/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/arrays","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/assert","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/map","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],se=function(j){for(var t=[],D=0,k=j.length;D<k;D++)t[D]=ie[j[D]];return t};const Ce=this,xe=typeof global=="object"?global:{};var fe;(function(j){j.global=Ce;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof j.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}j.Environment=t})(fe||(fe={}));var fe;(function(j){class t{constructor(f,N,h){this.type=f,this.detail=N,this.timestamp=h}}j.LoaderEvent=t;class D{constructor(f){this._events=[new t(1,"",f)]}record(f,N){this._events.push(new t(f,N,j.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}j.LoaderEventRecorder=D;class k{record(f,N){}getEvents(){return[]}}k.INSTANCE=new k,j.NullLoaderEventRecorder=k})(fe||(fe={}));var fe;(function(j){class t{static fileUriToFilePath(k,r){if(r=decodeURI(r).replace(/%23/g,"#"),k){if(/^file:\/\/\//.test(r))return r.substr(8);if(/^file:\/\//.test(r))return r.substr(5)}else if(/^file:\/\//.test(r))return r.substr(7);return r}static startsWith(k,r){return k.length>=r.length&&k.substr(0,r.length)===r}static endsWith(k,r){return k.length>=r.length&&k.substr(k.length-r.length)===r}static containsQueryString(k){return/^[^\#]*\?/gi.test(k)}static isAbsolutePath(k){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(k)}static forEachProperty(k,r){if(k){let f;for(f in k)k.hasOwnProperty(f)&&r(f,k[f])}}static isEmpty(k){let r=!0;return t.forEachProperty(k,()=>{r=!1}),r}static recursiveClone(k){if(!k||typeof k!="object"||k instanceof RegExp||!Array.isArray(k)&&Object.getPrototypeOf(k)!==Object.prototype)return k;let r=Array.isArray(k)?[]:{};return t.forEachProperty(k,(f,N)=>{N&&typeof N=="object"?r[f]=t.recursiveClone(N):r[f]=N}),r}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(k){return t.startsWith(k,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=j.global.performance&&typeof j.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?j.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,j.Utilities=t})(fe||(fe={}));var fe;(function(j){function t(r){if(r instanceof Error)return r;const f=new Error(r.message||String(r)||"Unknown Error");return r.stack&&(f.stack=r.stack),f}j.ensureError=t;class D{static validateConfigurationOptions(f){function N(h){if(h.phase==="loading"){console.error('Loading "'+h.moduleId+'" failed'),console.error(h),console.error("Here are the modules that depend on it:"),console.error(h.neededBy);return}if(h.phase==="factory"){console.error('The factory function of "'+h.moduleId+'" has thrown an exception'),console.error(h),console.error("Here are the modules that depend on it:"),console.error(h.neededBy);return}}if(f=f||{},typeof f.baseUrl!="string"&&(f.baseUrl=""),typeof f.isBuild!="boolean"&&(f.isBuild=!1),typeof f.paths!="object"&&(f.paths={}),typeof f.config!="object"&&(f.config={}),typeof f.catchError>"u"&&(f.catchError=!1),typeof f.recordStats>"u"&&(f.recordStats=!1),typeof f.urlArgs!="string"&&(f.urlArgs=""),typeof f.onError!="function"&&(f.onError=N),Array.isArray(f.ignoreDuplicateModules)||(f.ignoreDuplicateModules=[]),f.baseUrl.length>0&&(j.Utilities.endsWith(f.baseUrl,"/")||(f.baseUrl+="/")),typeof f.cspNonce!="string"&&(f.cspNonce=""),typeof f.preferScriptTags>"u"&&(f.preferScriptTags=!1),f.nodeCachedData&&typeof f.nodeCachedData=="object"&&(typeof f.nodeCachedData.seed!="string"&&(f.nodeCachedData.seed="seed"),(typeof f.nodeCachedData.writeDelay!="number"||f.nodeCachedData.writeDelay<0)&&(f.nodeCachedData.writeDelay=1e3*7),!f.nodeCachedData.path||typeof f.nodeCachedData.path!="string")){const h=t(new Error("INVALID cached data configuration, 'path' MUST be set"));h.phase="configuration",f.onError(h),f.nodeCachedData=void 0}return f}static mergeConfigurationOptions(f=null,N=null){let h=j.Utilities.recursiveClone(N||{});return j.Utilities.forEachProperty(f,(l,s)=>{l==="ignoreDuplicateModules"&&typeof h.ignoreDuplicateModules<"u"?h.ignoreDuplicateModules=h.ignoreDuplicateModules.concat(s):l==="paths"&&typeof h.paths<"u"?j.Utilities.forEachProperty(s,(g,A)=>h.paths[g]=A):l==="config"&&typeof h.config<"u"?j.Utilities.forEachProperty(s,(g,A)=>h.config[g]=A):h[l]=j.Utilities.recursiveClone(s)}),D.validateConfigurationOptions(h)}}j.ConfigurationOptionsUtil=D;class k{constructor(f,N){if(this._env=f,this.options=D.mergeConfigurationOptions(N),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let h=this.options.nodeRequire.main.filename,l=Math.max(h.lastIndexOf("/"),h.lastIndexOf("\\"));this.options.baseUrl=h.substring(0,l+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let f=0;f<this.options.ignoreDuplicateModules.length;f++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[f]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],j.Utilities.forEachProperty(this.options.paths,(f,N)=>{Array.isArray(N)?this.sortedPathsRules.push({from:f,to:N}):this.sortedPathsRules.push({from:f,to:[N]})}),this.sortedPathsRules.sort((f,N)=>N.from.length-f.from.length)}cloneAndMerge(f){return new k(this._env,D.mergeConfigurationOptions(f,this.options))}getOptionsLiteral(){return this.options}_applyPaths(f){let N;for(let h=0,l=this.sortedPathsRules.length;h<l;h++)if(N=this.sortedPathsRules[h],j.Utilities.startsWith(f,N.from)){let s=[];for(let g=0,A=N.to.length;g<A;g++)s.push(N.to[g]+f.substr(N.from.length));return s}return[f]}_addUrlArgsToUrl(f){return j.Utilities.containsQueryString(f)?f+"&"+this.options.urlArgs:f+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(f){return this.options.urlArgs?this._addUrlArgsToUrl(f):f}_addUrlArgsIfNecessaryToUrls(f){if(this.options.urlArgs)for(let N=0,h=f.length;N<h;N++)f[N]=this._addUrlArgsToUrl(f[N]);return f}moduleIdToPaths(f){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(f))return this.isBuild()?["empty:"]:["node|"+f];let N=f,h;if(!j.Utilities.endsWith(N,".js")&&!j.Utilities.isAbsolutePath(N)){h=this._applyPaths(N);for(let l=0,s=h.length;l<s;l++)this.isBuild()&&h[l]==="empty:"||(j.Utilities.isAbsolutePath(h[l])||(h[l]=this.options.baseUrl+h[l]),!j.Utilities.endsWith(h[l],".js")&&!j.Utilities.containsQueryString(h[l])&&(h[l]=h[l]+".js"))}else!j.Utilities.endsWith(N,".js")&&!j.Utilities.containsQueryString(N)&&(N=N+".js"),h=[N];return this._addUrlArgsIfNecessaryToUrls(h)}requireToUrl(f){let N=f;return j.Utilities.isAbsolutePath(N)||(N=this._applyPaths(N)[0],j.Utilities.isAbsolutePath(N)||(N=this.options.baseUrl+N)),this._addUrlArgsIfNecessaryToUrl(N)}isBuild(){return this.options.isBuild}shouldInvokeFactory(f){return!!(!this.options.isBuild||j.Utilities.isAnonymousModule(f)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[f])}isDuplicateMessageIgnoredFor(f){return this.ignoreDuplicateModulesMap.hasOwnProperty(f)}getConfigForModule(f){if(this.options.config)return this.options.config[f]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(f){this.options.onError(f)}}j.Configuration=k})(fe||(fe={}));var fe;(function(j){class t{constructor(s){this._env=s,this._scriptLoader=null,this._callbackMap={}}load(s,g,A,b){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new r;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=s.getConfig().getOptionsLiteral();e?this._scriptLoader=new D:this._scriptLoader=new f(this._env)}else this._env.isNode?this._scriptLoader=new f(this._env):this._scriptLoader=new D;let m={callback:A,errorback:b};if(this._callbackMap.hasOwnProperty(g)){this._callbackMap[g].push(m);return}this._callbackMap[g]=[m],this._scriptLoader.load(s,g,()=>this.triggerCallback(g),e=>this.triggerErrorback(g,e))}triggerCallback(s){let g=this._callbackMap[s];delete this._callbackMap[s];for(let A=0;A<g.length;A++)g[A].callback()}triggerErrorback(s,g){let A=this._callbackMap[s];delete this._callbackMap[s];for(let b=0;b<A.length;b++)A[b].errorback(g)}}class D{attachListeners(s,g,A){let b=()=>{s.removeEventListener("load",m),s.removeEventListener("error",e)},m=E=>{b(),g()},e=E=>{b(),A(E)};s.addEventListener("load",m),s.addEventListener("error",e)}load(s,g,A,b){if(/^node\|/.test(g)){let m=s.getConfig().getOptionsLiteral(),e=N(s.getRecorder(),m.nodeRequire||j.global.nodeRequire),E=g.split("|"),R=null;try{R=e(E[1])}catch(v){b(v);return}s.enqueueDefineAnonymousModule([],()=>R),A()}else{let m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript"),this.attachListeners(m,A,b);const{trustedTypesPolicy:e}=s.getConfig().getOptionsLiteral();e&&(g=e.createScriptURL(g)),m.setAttribute("src",g);const{cspNonce:E}=s.getConfig().getOptionsLiteral();E&&m.setAttribute("nonce",E),document.getElementsByTagName("head")[0].appendChild(m)}}}function k(l){const{trustedTypesPolicy:s}=l.getConfig().getOptionsLiteral();try{return(s?self.eval(s.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class r{constructor(){this._cachedCanUseEval=null}_canUseEval(s){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=k(s)),this._cachedCanUseEval}load(s,g,A,b){if(/^node\|/.test(g)){const m=s.getConfig().getOptionsLiteral(),e=N(s.getRecorder(),m.nodeRequire||j.global.nodeRequire),E=g.split("|");let R=null;try{R=e(E[1])}catch(v){b(v);return}s.enqueueDefineAnonymousModule([],function(){return R}),A()}else{const{trustedTypesPolicy:m}=s.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(g)&&g.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(s)){fetch(g).then(E=>{if(E.status!==200)throw new Error(E.statusText);return E.text()}).then(E=>{E=`${E}
//# sourceURL=${g}`,(m?self.eval(m.createScript("",E)):new Function(E)).call(self),A()}).then(void 0,b);return}try{m&&(g=m.createScriptURL(g)),importScripts(g),A()}catch(E){b(E)}}}}class f{constructor(s){this._env=s,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(s){this._didInitialize||(this._didInitialize=!0,this._fs=s("fs"),this._vm=s("vm"),this._path=s("path"),this._crypto=s("crypto"))}_initNodeRequire(s,g){const{nodeCachedData:A}=g.getConfig().getOptionsLiteral();if(!A||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const b=this,m=s("module");function e(E){const R=E.constructor;let v=function(u){try{return E.require(u)}finally{}};return v.resolve=function(u,o){return R._resolveFilename(u,E,!1,o)},v.resolve.paths=function(u){return R._resolveLookupPaths(u,E)},v.main=process.mainModule,v.extensions=R._extensions,v.cache=R._cache,v}m.prototype._compile=function(E,R){const v=m.wrap(E.replace(/^#!.*/,"")),$=g.getRecorder(),u=b._getCachedDataPath(A,R),o={filename:R};let c;try{const p=b._fs.readFileSync(u);c=p.slice(0,16),o.cachedData=p.slice(16),$.record(60,u)}catch{$.record(61,u)}const i=new b._vm.Script(v,o),a=i.runInThisContext(o),L=b._path.dirname(R),d=e(this),w=[this.exports,d,this,R,L,process,xe,Buffer],M=a.apply(this.exports,w);return b._handleCachedData(i,v,u,!o.cachedData,g),b._verifyCachedData(i,v,u,c,g),M}}load(s,g,A,b){const m=s.getConfig().getOptionsLiteral(),e=N(s.getRecorder(),m.nodeRequire||j.global.nodeRequire),E=m.nodeInstrumenter||function(v){return v};this._init(e),this._initNodeRequire(e,s);let R=s.getRecorder();if(/^node\|/.test(g)){let v=g.split("|"),$=null;try{$=e(v[1])}catch(u){b(u);return}s.enqueueDefineAnonymousModule([],()=>$),A()}else{g=j.Utilities.fileUriToFilePath(this._env.isWindows,g);const v=this._path.normalize(g),$=this._getElectronRendererScriptPathOrUri(v),u=!!m.nodeCachedData,o=u?this._getCachedDataPath(m.nodeCachedData,g):void 0;this._readSourceAndCachedData(v,o,R,(c,i,a,L)=>{if(c){b(c);return}let d;i.charCodeAt(0)===f._BOM?d=f._PREFIX+i.substring(1)+f._SUFFIX:d=f._PREFIX+i+f._SUFFIX,d=E(d,v);const w={filename:$,cachedData:a},M=this._createAndEvalScript(s,d,w,A,b);this._handleCachedData(M,d,o,u&&!a,s),this._verifyCachedData(M,d,o,L,s)})}}_createAndEvalScript(s,g,A,b,m){const e=s.getRecorder();e.record(31,A.filename);const E=new this._vm.Script(g,A),R=E.runInThisContext(A),v=s.getGlobalAMDDefineFunc();let $=!1;const u=function(){return $=!0,v.apply(null,arguments)};return u.amd=v.amd,R.call(j.global,s.getGlobalAMDRequireFunc(),u,A.filename,this._path.dirname(A.filename)),e.record(32,A.filename),$?b():m(new Error(`Didn't receive define call in ${A.filename}!`)),E}_getElectronRendererScriptPathOrUri(s){if(!this._env.isElectronRenderer)return s;let g=s.match(/^([a-z])\:(.*)/i);return g?`file:///${(g[1].toUpperCase()+":"+g[2]).replace(/\\/g,"/")}`:`file://${s}`}_getCachedDataPath(s,g){const A=this._crypto.createHash("md5").update(g,"utf8").update(s.seed,"utf8").update(process.arch,"").digest("hex"),b=this._path.basename(g).replace(/\.js$/,"");return this._path.join(s.path,`${b}-${A}.code`)}_handleCachedData(s,g,A,b,m){s.cachedDataRejected?this._fs.unlink(A,e=>{m.getRecorder().record(62,A),this._createAndWriteCachedData(s,g,A,m),e&&m.getConfig().onError(e)}):b&&this._createAndWriteCachedData(s,g,A,m)}_createAndWriteCachedData(s,g,A,b){let m=Math.ceil(b.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,E=0,R;const v=()=>{setTimeout(()=>{R||(R=this._crypto.createHash("md5").update(g,"utf8").digest());const $=s.createCachedData();if(!($.length===0||$.length===e||E>=5)){if($.length<e){v();return}e=$.length,this._fs.writeFile(A,Buffer.concat([R,$]),u=>{u&&b.getConfig().onError(u),b.getRecorder().record(63,A),v()})}},m*Math.pow(4,E++))};v()}_readSourceAndCachedData(s,g,A,b){if(!g)this._fs.readFile(s,{encoding:"utf8"},b);else{let m,e,E,R=2;const v=$=>{$?b($):--R===0&&b(void 0,m,e,E)};this._fs.readFile(s,{encoding:"utf8"},($,u)=>{m=u,v($)}),this._fs.readFile(g,($,u)=>{!$&&u&&u.length>0?(E=u.slice(0,16),e=u.slice(16),A.record(60,g)):A.record(61,g),v()})}}_verifyCachedData(s,g,A,b,m){b&&(s.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(g,"utf8").digest();b.equals(e)||(m.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${A}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(A,E=>{E&&m.getConfig().onError(E)}))},Math.ceil(5e3*(1+Math.random()))))}}f._BOM=65279,f._PREFIX="(function (require, define, __filename, __dirname) { ",f._SUFFIX=`
});`;function N(l,s){if(s.__$__isRecorded)return s;const g=function(b){l.record(33,b);try{return s(b)}finally{l.record(34,b)}};return g.__$__isRecorded=!0,g}j.ensureRecordedNodeRequire=N;function h(l){return new t(l)}j.createScriptLoader=h})(fe||(fe={}));var fe;(function(j){class t{constructor(l){let s=l.lastIndexOf("/");s!==-1?this.fromModulePath=l.substr(0,s+1):this.fromModulePath=""}static _normalizeModuleId(l){let s=l,g;for(g=/\/\.\//;g.test(s);)s=s.replace(g,"/");for(s=s.replace(/^\.\//g,""),g=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;g.test(s);)s=s.replace(g,"/");return s=s.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),s}resolveModule(l){let s=l;return j.Utilities.isAbsolutePath(s)||(j.Utilities.startsWith(s,"./")||j.Utilities.startsWith(s,"../"))&&(s=t._normalizeModuleId(this.fromModulePath+s)),s}}t.ROOT=new t(""),j.ModuleIdResolver=t;class D{constructor(l,s,g,A,b,m){this.id=l,this.strId=s,this.dependencies=g,this._callback=A,this._errorback=b,this.moduleIdResolver=m,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(l,s){try{return{returnedValue:l.apply(j.global,s),producedError:null}}catch(g){return{returnedValue:null,producedError:g}}}static _invokeFactory(l,s,g,A){return l.shouldInvokeFactory(s)?l.shouldCatchError()?this._safeInvokeFunction(g,A):{returnedValue:g.apply(j.global,A),producedError:null}:{returnedValue:null,producedError:null}}complete(l,s,g,A){this._isComplete=!0;let b=null;if(this._callback)if(typeof this._callback=="function"){l.record(21,this.strId);let m=D._invokeFactory(s,this.strId,this._callback,g);b=m.producedError,l.record(22,this.strId),!b&&typeof m.returnedValue<"u"&&(!this.exportsPassedIn||j.Utilities.isEmpty(this.exports))&&(this.exports=m.returnedValue)}else this.exports=this._callback;if(b){let m=j.ensureError(b);m.phase="factory",m.moduleId=this.strId,m.neededBy=A(this.id),this.error=m,s.onError(m)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(l){return this._isComplete=!0,this.error=l,this._errorback?(this._errorback(l),!0):!1}isComplete(){return this._isComplete}}j.Module=D;class k{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(l){let s=this._strModuleIdToIntModuleId.get(l);return typeof s>"u"&&(s=this._nextId++,this._strModuleIdToIntModuleId.set(l,s),this._intModuleIdToStrModuleId[s]=l),s}getStrModuleId(l){return this._intModuleIdToStrModuleId[l]}}class r{constructor(l){this.id=l}}r.EXPORTS=new r(0),r.MODULE=new r(1),r.REQUIRE=new r(2),j.RegularDependency=r;class f{constructor(l,s,g){this.id=l,this.pluginId=s,this.pluginParam=g}}j.PluginDependency=f;class N{constructor(l,s,g,A,b=0){this._env=l,this._scriptLoader=s,this._loaderAvailableTimestamp=b,this._defineFunc=g,this._requireFunc=A,this._moduleIdProvider=new k,this._config=new j.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new N(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(l,s){let g=m=>m.replace(/\\/g,"/"),A=g(l),b=s.split(/\n/);for(let m=0;m<b.length;m++){let e=b[m].match(/(.*):(\d+):(\d+)\)?$/);if(e){let E=e[1],R=e[2],v=e[3],$=Math.max(E.lastIndexOf(" ")+1,E.lastIndexOf("(")+1);if(E=E.substr($),E=g(E),E===A){let u={line:parseInt(R,10),col:parseInt(v,10)};return u.line===1&&(u.col-=53),u}}}throw new Error("Could not correlate define call site for needle "+l)}getBuildInfo(){if(!this._config.isBuild())return null;let l=[],s=0;for(let g=0,A=this._modules2.length;g<A;g++){let b=this._modules2[g];if(!b)continue;let m=this._buildInfoPath[b.id]||null,e=this._buildInfoDefineStack[b.id]||null,E=this._buildInfoDependencies[b.id];l[s++]={id:b.strId,path:m,defineLocation:m&&e?N._findRelevantLocationInStack(m,e):null,dependencies:E,shim:null,exports:b.exports}}return l}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new j.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=j.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(l,s){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let g=null;this._config.isBuild()&&(g=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:g,dependencies:l,callback:s}}defineModule(l,s,g,A,b,m=new t(l)){let e=this._moduleIdProvider.getModuleId(l);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(l)||console.warn("Duplicate definition of module '"+l+"'");return}let E=new D(e,l,this._normalizeDependencies(s,m),g,A,m);this._modules2[e]=E,this._config.isBuild()&&(this._buildInfoDefineStack[e]=b,this._buildInfoDependencies[e]=(E.dependencies||[]).map(R=>this._moduleIdProvider.getStrModuleId(R.id))),this._resolve(E)}_normalizeDependency(l,s){if(l==="exports")return r.EXPORTS;if(l==="module")return r.MODULE;if(l==="require")return r.REQUIRE;let g=l.indexOf("!");if(g>=0){let A=s.resolveModule(l.substr(0,g)),b=s.resolveModule(l.substr(g+1)),m=this._moduleIdProvider.getModuleId(A+"!"+b),e=this._moduleIdProvider.getModuleId(A);return new f(m,e,b)}return new r(this._moduleIdProvider.getModuleId(s.resolveModule(l)))}_normalizeDependencies(l,s){let g=[],A=0;for(let b=0,m=l.length;b<m;b++)g[A++]=this._normalizeDependency(l[b],s);return g}_relativeRequire(l,s,g,A){if(typeof s=="string")return this.synchronousRequire(s,l);this.defineModule(j.Utilities.generateAnonymousModule(),s,g,A,null,l)}synchronousRequire(l,s=new t(l)){let g=this._normalizeDependency(l,s),A=this._modules2[g.id];if(!A)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This is the first mention of this module!");if(!A.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This module has not been resolved completely yet.");if(A.error)throw A.error;return A.exports}configure(l,s){let g=this._config.shouldRecordStats();s?this._config=new j.Configuration(this._env,l):this._config=this._config.cloneAndMerge(l),this._config.shouldRecordStats()&&!g&&(this._recorder=null)}getConfig(){return this._config}_onLoad(l){if(this._currentAnonymousDefineCall!==null){let s=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(l),s.dependencies,s.callback,null,s.stack)}}_createLoadError(l,s){let g=this._moduleIdProvider.getStrModuleId(l),A=(this._inverseDependencies2[l]||[]).map(m=>this._moduleIdProvider.getStrModuleId(m));const b=j.ensureError(s);return b.phase="loading",b.moduleId=g,b.neededBy=A,b}_onLoadError(l,s){const g=this._createLoadError(l,s);this._modules2[l]||(this._modules2[l]=new D(l,this._moduleIdProvider.getStrModuleId(l),[],()=>{},null,null));let A=[];for(let e=0,E=this._moduleIdProvider.getMaxModuleId();e<E;e++)A[e]=!1;let b=!1,m=[];for(m.push(l),A[l]=!0;m.length>0;){let e=m.shift(),E=this._modules2[e];E&&(b=E.onDependencyError(g)||b);let R=this._inverseDependencies2[e];if(R)for(let v=0,$=R.length;v<$;v++){let u=R[v];A[u]||(m.push(u),A[u]=!0)}}b||this._config.onError(g)}_hasDependencyPath(l,s){let g=this._modules2[l];if(!g)return!1;let A=[];for(let m=0,e=this._moduleIdProvider.getMaxModuleId();m<e;m++)A[m]=!1;let b=[];for(b.push(g),A[l]=!0;b.length>0;){let e=b.shift().dependencies;if(e)for(let E=0,R=e.length;E<R;E++){let v=e[E];if(v.id===s)return!0;let $=this._modules2[v.id];$&&!A[v.id]&&(A[v.id]=!0,b.push($))}}return!1}_findCyclePath(l,s,g){if(l===s||g===50)return[l];let A=this._modules2[l];if(!A)return null;let b=A.dependencies;if(b)for(let m=0,e=b.length;m<e;m++){let E=this._findCyclePath(b[m].id,s,g+1);if(E!==null)return E.push(l),E}return null}_createRequire(l){let s=(g,A,b)=>this._relativeRequire(l,g,A,b);return s.toUrl=g=>this._config.requireToUrl(l.resolveModule(g)),s.getStats=()=>this.getLoaderEvents(),s.hasDependencyCycle=()=>this._hasDependencyCycle,s.config=(g,A=!1)=>{this.configure(g,A)},s.__$__nodeRequire=j.global.nodeRequire,s}_loadModule(l){if(this._modules2[l]||this._knownModules2[l])return;this._knownModules2[l]=!0;let s=this._moduleIdProvider.getStrModuleId(l),g=this._config.moduleIdToPaths(s),A=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(s.indexOf("/")===-1||A.test(s))&&g.push("node|"+s);let b=-1,m=e=>{if(b++,b>=g.length)this._onLoadError(l,e);else{let E=g[b],R=this.getRecorder();if(this._config.isBuild()&&E==="empty:"){this._buildInfoPath[l]=E,this.defineModule(this._moduleIdProvider.getStrModuleId(l),[],null,null,null),this._onLoad(l);return}R.record(10,E),this._scriptLoader.load(this,E,()=>{this._config.isBuild()&&(this._buildInfoPath[l]=E),R.record(11,E),this._onLoad(l)},v=>{R.record(12,E),m(v)})}};m(null)}_loadPluginDependency(l,s){if(this._modules2[s.id]||this._knownModules2[s.id])return;this._knownModules2[s.id]=!0;let g=A=>{this.defineModule(this._moduleIdProvider.getStrModuleId(s.id),[],A,null,null)};g.error=A=>{this._config.onError(this._createLoadError(s.id,A))},l.load(s.pluginParam,this._createRequire(t.ROOT),g,this._config.getOptionsLiteral())}_resolve(l){let s=l.dependencies;if(s)for(let g=0,A=s.length;g<A;g++){let b=s[g];if(b===r.EXPORTS){l.exportsPassedIn=!0,l.unresolvedDependenciesCount--;continue}if(b===r.MODULE){l.unresolvedDependenciesCount--;continue}if(b===r.REQUIRE){l.unresolvedDependenciesCount--;continue}let m=this._modules2[b.id];if(m&&m.isComplete()){if(m.error){l.onDependencyError(m.error);return}l.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(b.id,l.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(b.id)+"' and '"+this._moduleIdProvider.getStrModuleId(l.id)+"'. The cyclic path follows:");let e=this._findCyclePath(b.id,l.id,0)||[];e.reverse(),e.push(b.id),console.warn(e.map(E=>this._moduleIdProvider.getStrModuleId(E)).join(` => 
`)),l.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[b.id]=this._inverseDependencies2[b.id]||[],this._inverseDependencies2[b.id].push(l.id),b instanceof f){let e=this._modules2[b.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,b);continue}let E=this._inversePluginDependencies2.get(b.pluginId);E||(E=[],this._inversePluginDependencies2.set(b.pluginId,E)),E.push(b),this._loadModule(b.pluginId);continue}this._loadModule(b.id)}l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)}_onModuleComplete(l){let s=this.getRecorder();if(l.isComplete())return;let g=l.dependencies,A=[];if(g)for(let E=0,R=g.length;E<R;E++){let v=g[E];if(v===r.EXPORTS){A[E]=l.exports;continue}if(v===r.MODULE){A[E]={id:l.strId,config:()=>this._config.getConfigForModule(l.strId)};continue}if(v===r.REQUIRE){A[E]=this._createRequire(l.moduleIdResolver);continue}let $=this._modules2[v.id];if($){A[E]=$.exports;continue}A[E]=null}const b=E=>(this._inverseDependencies2[E]||[]).map(R=>this._moduleIdProvider.getStrModuleId(R));l.complete(s,this._config,A,b);let m=this._inverseDependencies2[l.id];if(this._inverseDependencies2[l.id]=null,m)for(let E=0,R=m.length;E<R;E++){let v=m[E],$=this._modules2[v];$.unresolvedDependenciesCount--,$.unresolvedDependenciesCount===0&&this._onModuleComplete($)}let e=this._inversePluginDependencies2.get(l.id);if(e){this._inversePluginDependencies2.delete(l.id);for(let E=0,R=e.length;E<R;E++)this._loadPluginDependency(l.exports,e[E])}}}j.ModuleManager=N})(fe||(fe={}));var ne,fe;(function(j){const t=new j.Environment;let D=null;const k=function(h,l,s){typeof h!="string"&&(s=l,l=h,h=null),(typeof l!="object"||!Array.isArray(l))&&(s=l,l=null),l||(l=["require","exports","module"]),h?D.defineModule(h,l,s,null,null):D.enqueueDefineAnonymousModule(l,s)};k.amd={jQuery:!0};const r=function(h,l=!1){D.configure(h,l)},f=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){r(arguments[0]);return}if(typeof arguments[0]=="string")return D.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){D.defineModule(j.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};f.config=r,f.getConfig=function(){return D.getConfig().getOptionsLiteral()},f.reset=function(){D=D.reset()},f.getBuildInfo=function(){return D.getBuildInfo()},f.getStats=function(){return D.getLoaderEvents()},f.define=k;function N(){if(typeof j.global.require<"u"||typeof require<"u"){const h=j.global.require||require;if(typeof h=="function"&&typeof h.resolve=="function"){const l=j.ensureRecordedNodeRequire(D.getRecorder(),h);j.global.nodeRequire=l,f.nodeRequire=l,f.__$__nodeRequire=l}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=f:(t.isElectronRenderer||(j.global.define=k),j.global.require=f)}j.init=N,(typeof j.global.define!="function"||!j.global.define.amd)&&(D=new j.ModuleManager(t,j.createScriptLoader(t),k,f,j.Utilities.getHighPerformanceTimestamp()),typeof j.global.require<"u"&&typeof j.global.require!="function"&&f.config(j.global.require),ne=function(){return k.apply(null,arguments)},ne.amd=k.amd,typeof doNotInitLoader>"u"&&N())})(fe||(fe={})),ne(ie[69],se([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function D(h,l,s,g){if(g=g||{},(g["vs/css"]||{}).disabled){s({});return}const b=l.toUrl(h+".css");k(h,b,()=>{s({})},m=>{typeof s.error=="function"&&s.error("Could not find "+b+".")})}t.load=D;function k(h,l,s,g){if(r(h,l)){s();return}f(h,l,s,g)}function r(h,l){const s=window.document.getElementsByTagName("link");for(let g=0,A=s.length;g<A;g++){const b=s[g].getAttribute("data-name"),m=s[g].getAttribute("href");if(b===h||m===l)return!0}return!1}function f(h,l,s,g){const A=document.createElement("link");A.setAttribute("rel","stylesheet"),A.setAttribute("type","text/css"),A.setAttribute("data-name",h),N(h,A,s,g),A.setAttribute("href",l),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild(A)}function N(h,l,s,g){const A=()=>{l.removeEventListener("load",b),l.removeEventListener("error",m)},b=e=>{A(),s()},m=e=>{A(),g(e)};l.addEventListener("load",b),l.addEventListener("error",m)}}),ne("vs/nls",["require","exports"],function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize2=t.localize=void 0;let D=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const k="i-default";function r(R,v){let $;return v.length===0?$=R:$=R.replace(/\{(\d+)\}/g,(u,o)=>{const c=o[0],i=v[c];let a=u;return typeof i=="string"?a=i:(typeof i=="number"||typeof i=="boolean"||i===void 0||i===null)&&(a=String(i)),a}),D&&($="\uFF3B"+$.replace(/[aouei]/g,"$&$&")+"\uFF3D"),$}function f(R,v){let $=R[v];return $||($=R["*"],$)?$:null}function N(R){return R.charAt(R.length-1)==="/"?R:R+"/"}async function h(R,v,$){const u=N(R)+N(v)+"vscode/"+N($),o=await fetch(u);if(o.ok)return await o.json();throw new Error(`${o.status} - ${o.statusText}`)}function l(R){return function(v,$){const u=Array.prototype.slice.call(arguments,2);return r(R[v],u)}}function s(R){return(v,$,...u)=>({value:r(R[v],u),original:r($,u)})}function g(R,v,...$){return r(v,$)}t.localize=g;function A(R,v,...$){const u=r(v,$);return{value:u,original:u}}t.localize2=A;function b(R){}t.getConfiguredDefaultLocale=b;function m(R){D=R}t.setPseudoTranslation=m;function e(R,v){return{localize:l(v[R]),localize2:s(v[R]),getConfiguredDefaultLocale:v.getConfiguredDefaultLocale??($=>{})}}t.create=e;function E(R,v,$,u){const o=u["vs/nls"]??{};if(!R||R.length===0)return $({localize:g,localize2:A,getConfiguredDefaultLocale:()=>o.availableLanguages?.["*"]});const c=o.availableLanguages?f(o.availableLanguages,R):null,i=c===null||c===k;let a=".nls";i||(a=a+"."+c);const L=d=>{Array.isArray(d)?(d.localize=l(d),d.localize2=s(d)):(d.localize=l(d[R]),d.localize2=s(d[R])),d.getConfiguredDefaultLocale=()=>o.availableLanguages?.["*"],$(d)};typeof o.loadBundle=="function"?o.loadBundle(R,c,(d,w)=>{d?v([R+".nls"],L):L(w)}):o.translationServiceUrl&&!i?(async()=>{try{const d=await h(o.translationServiceUrl,c,R);return L(d)}catch(d){if(!c.includes("-"))return console.error(d),v([R+".nls"],L);try{const w=c.split("-")[0],M=await h(o.translationServiceUrl,w,R);return o.availableLanguages??={},o.availableLanguages["*"]=w,L(M)}catch(w){return console.error(w),v([R+".nls"],L)}}})():v([R+a],L,d=>{if(a===".nls"){console.error("Failed trying to load default language strings",d);return}console.error(`Failed to load message bundle for language ${c}. Falling back to the default language:`,d),v([R+".nls"],L)})}t.load=E}),function(){const j=globalThis.MonacoEnvironment,t=j&&j.baseUrl?j.baseUrl:"../../../";function D(g,A){if(j?.createTrustedTypesPolicy)try{return j.createTrustedTypesPolicy(g,A)}catch(b){console.warn(b);return}try{return self.trustedTypes?.createPolicy(g,A)}catch(b){console.warn(b);return}}const k=D("amdLoader",{createScriptURL:g=>g,createScript:(g,...A)=>{const b=A.slice(0,-1).join(","),m=A.pop().toString();return`(function anonymous(${b}) { ${m}
})`}});function r(){try{return(k?globalThis.eval(k.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function f(){return new Promise((g,A)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return g();const b=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(b)&&b.substring(0,globalThis.origin.length)!==globalThis.origin)&&r()){fetch(b).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${b}`,(k?globalThis.eval(k.createScript("",e)):new Function(e)).call(globalThis),g()}).then(void 0,A);return}k?importScripts(k.createScriptURL(b)):importScripts(b),g()})}function N(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:k,amdModulesPattern:/^vs\//})}function h(g){f().then(()=>{N(),require([g],function(A){setTimeout(function(){const b=A.create((m,e)=>{globalThis.postMessage(m,e)},null);for(globalThis.onmessage=m=>b.onmessage(m.data,m.ports);s.length>0;){const m=s.shift();b.onmessage(m.data,m.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&N();let l=!0;const s=[];globalThis.onmessage=g=>{if(!l){s.push(g);return}l=!1,h(g.data)}}(),ne(ie[9],se([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=void 0;function D(E,R,v){const $=k(E,R);if($!==-1)return E[$]}t.$fb=D;function k(E,R,v=E.length-1){for(let $=v;$>=0;$--){const u=E[$];if(R(u))return $}return-1}t.$gb=k;function r(E,R){const v=f(E,R);return v===-1?void 0:E[v]}t.$hb=r;function f(E,R,v=0,$=E.length){let u=v,o=$;for(;u<o;){const c=Math.floor((u+o)/2);R(E[c])?u=c+1:o=c}return u-1}t.$ib=f;function N(E,R){const v=h(E,R);return v===E.length?void 0:E[v]}t.$jb=N;function h(E,R,v=0,$=E.length){let u=v,o=$;for(;u<o;){const c=Math.floor((u+o)/2);R(E[c])?o=c:u=c+1}return u}t.$kb=h;function l(E,R,v=0,$=E.length){const u=h(E,R,v,$);return u===E.length?-1:u}t.$lb=l;class s{static{this.assertInvariants=!1}constructor(R){this.e=R,this.c=0}findLastMonotonous(R){if(s.assertInvariants){if(this.d){for(const $ of this.e)if(this.d($)&&!R($))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=R}const v=f(this.e,R,this.c);return this.c=v+1,v===-1?void 0:this.e[v]}}t.$mb=s;function g(E,R){if(E.length===0)return;let v=E[0];for(let $=1;$<E.length;$++){const u=E[$];R(u,v)>0&&(v=u)}return v}t.$nb=g;function A(E,R){if(E.length===0)return;let v=E[0];for(let $=1;$<E.length;$++){const u=E[$];R(u,v)>=0&&(v=u)}return v}t.$ob=A;function b(E,R){return g(E,(v,$)=>-R(v,$))}t.$pb=b;function m(E,R){if(E.length===0)return-1;let v=0;for(let $=1;$<E.length;$++){const u=E[$];R(u,E[v])>0&&(v=$)}return v}t.$qb=m;function e(E,R){for(const v of E){const $=R(v);if($!==void 0)return $}}t.$rb=e}),ne(ie[34],se([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$N=t.$M=t.$L=t.$K=void 0;function D(N,h){const l=Object.create(null);for(const s of N){const g=h(s);let A=l[g];A||(A=l[g]=[]),A.push(s)}return l}t.$K=D;function k(N,h){const l=[],s=[];for(const g of N)h.has(g)||l.push(g);for(const g of h)N.has(g)||s.push(g);return{removed:l,added:s}}t.$L=k;function r(N,h){const l=[],s=[];for(const[g,A]of N)h.has(g)||l.push(A);for(const[g,A]of h)N.has(g)||s.push(A);return{removed:l,added:s}}t.$M=r;function f(N,h){const l=new Set;for(const s of h)N.has(s)&&l.add(s);return l}t.$N=f}),ne(ie[35],se([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$at=t.$_s=t.$$s=t.$0s=void 0;function D(h,l){const s=Math.pow(10,l);return Math.round(h*s)/s}class k{constructor(l,s,g,A=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,s))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=D(Math.max(Math.min(1,A),0),3)}static equals(l,s){return l.r===s.r&&l.g===s.g&&l.b===s.b&&l.a===s.a}}t.$0s=k;class r{constructor(l,s,g,A){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=D(Math.max(Math.min(1,s),0),3),this.l=D(Math.max(Math.min(1,g),0),3),this.a=D(Math.max(Math.min(1,A),0),3)}static equals(l,s){return l.h===s.h&&l.s===s.s&&l.l===s.l&&l.a===s.a}static fromRGBA(l){const s=l.r/255,g=l.g/255,A=l.b/255,b=l.a,m=Math.max(s,g,A),e=Math.min(s,g,A);let E=0,R=0;const v=(e+m)/2,$=m-e;if($>0){switch(R=Math.min(v<=.5?$/(2*v):$/(2-2*v),1),m){case s:E=(g-A)/$+(g<A?6:0);break;case g:E=(A-s)/$+2;break;case A:E=(s-g)/$+4;break}E*=60,E=Math.round(E)}return new r(E,R,v,b)}static i(l,s,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?l+(s-l)*6*g:g<1/2?s:g<2/3?l+(s-l)*(2/3-g)*6:l}static toRGBA(l){const s=l.h/360,{s:g,l:A,a:b}=l;let m,e,E;if(g===0)m=e=E=A;else{const R=A<.5?A*(1+g):A+g-A*g,v=2*A-R;m=r.i(v,R,s+1/3),e=r.i(v,R,s),E=r.i(v,R,s-1/3)}return new k(Math.round(m*255),Math.round(e*255),Math.round(E*255),b)}}t.$$s=r;class f{constructor(l,s,g,A){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=D(Math.max(Math.min(1,s),0),3),this.v=D(Math.max(Math.min(1,g),0),3),this.a=D(Math.max(Math.min(1,A),0),3)}static equals(l,s){return l.h===s.h&&l.s===s.s&&l.v===s.v&&l.a===s.a}static fromRGBA(l){const s=l.r/255,g=l.g/255,A=l.b/255,b=Math.max(s,g,A),m=Math.min(s,g,A),e=b-m,E=b===0?0:e/b;let R;return e===0?R=0:b===s?R=((g-A)/e%6+6)%6:b===g?R=(A-s)/e+2:R=(s-g)/e+4,new f(Math.round(R*60),E,b,l.a)}static toRGBA(l){const{h:s,s:g,v:A,a:b}=l,m=A*g,e=m*(1-Math.abs(s/60%2-1)),E=A-m;let[R,v,$]=[0,0,0];return s<60?(R=m,v=e):s<120?(R=e,v=m):s<180?(v=m,$=e):s<240?(v=e,$=m):s<300?(R=e,$=m):s<=360&&(R=m,$=e),R=Math.round((R+E)*255),v=Math.round((v+E)*255),$=Math.round(($+E)*255),new k(R,v,$,b)}}t.$_s=f;class N{static fromHex(l){return N.Format.CSS.parseHex(l)||N.red}static equals(l,s){return!l&&!s?!0:!l||!s?!1:l.equals(s)}get hsla(){return this.i?this.i:r.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:f.fromRGBA(this.rgba)}constructor(l){if(l)if(l instanceof k)this.rgba=l;else if(l instanceof r)this.i=l,this.rgba=r.toRGBA(l);else if(l instanceof f)this.j=l,this.rgba=f.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(l){return!!l&&k.equals(this.rgba,l.rgba)&&r.equals(this.hsla,l.hsla)&&f.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=N.k(this.rgba.r),s=N.k(this.rgba.g),g=N.k(this.rgba.b),A=.2126*l+.7152*s+.0722*g;return D(A,4)}static k(l){const s=l/255;return s<=.03928?s/12.92:Math.pow((s+.055)/1.055,2.4)}getContrastRatio(l){const s=this.getRelativeLuminance(),g=l.getRelativeLuminance();return s>g?(s+.05)/(g+.05):(g+.05)/(s+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const s=this.getRelativeLuminance(),g=l.getRelativeLuminance();return s>g}isDarkerThan(l){const s=this.getRelativeLuminance(),g=l.getRelativeLuminance();return s<g}lighten(l){return new N(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new N(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:s,g,b:A,a:b}=this.rgba;return new N(new k(s,g,A,b*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new N(new k(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const s=l.rgba,g=this.rgba.a,A=s.a,b=g+A*(1-g);if(b<1e-6)return N.transparent;const m=this.rgba.r*g/b+s.r*A*(1-g)/b,e=this.rgba.g*g/b+s.g*A*(1-g)/b,E=this.rgba.b*g/b+s.b*A*(1-g)/b;return new N(new k(m,e,E,b))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:s,g,b:A,a:b}=this.rgba;return new N(new k(l.rgba.r-b*(l.rgba.r-s),l.rgba.g-b*(l.rgba.g-g),l.rgba.b-b*(l.rgba.b-A),1))}flatten(...l){const s=l.reduceRight((g,A)=>N.o(A,g));return N.o(this,s)}static o(l,s){const g=1-l.rgba.a;return new N(new k(g*s.rgba.r+l.rgba.a*l.rgba.r,g*s.rgba.g+l.rgba.a*l.rgba.g,g*s.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this.u||(this.u=N.Format.CSS.format(this)),this.u}static getLighterColor(l,s,g){if(l.isLighterThan(s))return l;g=g||.5;const A=l.getRelativeLuminance(),b=s.getRelativeLuminance();return g=g*(b-A)/b,l.lighten(g)}static getDarkerColor(l,s,g){if(l.isDarkerThan(s))return l;g=g||.5;const A=l.getRelativeLuminance(),b=s.getRelativeLuminance();return g=g*(A-b)/A,l.darken(g)}static{this.white=new N(new k(255,255,255,1))}static{this.black=new N(new k(0,0,0,1))}static{this.red=new N(new k(255,0,0,1))}static{this.blue=new N(new k(0,0,255,1))}static{this.green=new N(new k(0,255,0,1))}static{this.cyan=new N(new k(0,255,255,1))}static{this.lightgrey=new N(new k(211,211,211,1))}static{this.transparent=new N(new k(0,0,0,0))}}t.$at=N,function(h){let l;(function(s){let g;(function(A){function b(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:h.Format.CSS.formatRGBA(i)}A.formatRGB=b;function m(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}A.formatRGBA=m;function e(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:h.Format.CSS.formatHSLA(i)}A.formatHSL=e;function E(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}A.formatHSLA=E;function R(i){const a=i.toString(16);return a.length!==2?"0"+a:a}function v(i){return`#${R(i.rgba.r)}${R(i.rgba.g)}${R(i.rgba.b)}`}A.formatHex=v;function $(i,a=!1){return a&&i.rgba.a===1?h.Format.CSS.formatHex(i):`#${R(i.rgba.r)}${R(i.rgba.g)}${R(i.rgba.b)}${R(Math.round(i.rgba.a*255))}`}A.formatHexA=$;function u(i){return i.isOpaque()?h.Format.CSS.formatHex(i):h.Format.CSS.formatRGBA(i)}A.format=u;function o(i){const a=i.length;if(a===0||i.charCodeAt(0)!==35)return null;if(a===7){const L=16*c(i.charCodeAt(1))+c(i.charCodeAt(2)),d=16*c(i.charCodeAt(3))+c(i.charCodeAt(4)),w=16*c(i.charCodeAt(5))+c(i.charCodeAt(6));return new h(new k(L,d,w,1))}if(a===9){const L=16*c(i.charCodeAt(1))+c(i.charCodeAt(2)),d=16*c(i.charCodeAt(3))+c(i.charCodeAt(4)),w=16*c(i.charCodeAt(5))+c(i.charCodeAt(6)),M=16*c(i.charCodeAt(7))+c(i.charCodeAt(8));return new h(new k(L,d,w,M/255))}if(a===4){const L=c(i.charCodeAt(1)),d=c(i.charCodeAt(2)),w=c(i.charCodeAt(3));return new h(new k(16*L+L,16*d+d,16*w+w))}if(a===5){const L=c(i.charCodeAt(1)),d=c(i.charCodeAt(2)),w=c(i.charCodeAt(3)),M=c(i.charCodeAt(4));return new h(new k(16*L+L,16*d+d,16*w+w,(16*M+M)/255))}return null}A.parseHex=o;function c(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=s.CSS||(s.CSS={}))})(l=h.Format||(h.Format={}))}(N||(t.$at=N={}))}),ne(ie[36],se([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ls=void 0;class D{constructor(r,f,N,h){this.originalStart=r,this.originalLength=f,this.modifiedStart=N,this.modifiedLength=h}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$Ls=D}),ne(ie[3],se([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.setUnexpectedErrorHandler=t.$X=t.$W=void 0;class D{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?u.isErrorNoTelemetry(i)?new u(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(a=>{a(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}t.$W=D,t.$X=new D;function k(c){t.$X.setUnexpectedErrorHandler(c)}t.setUnexpectedErrorHandler=k;function r(c){if(!c||typeof c!="object")return!1;const i=c;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}t.$Z=r;function f(c){s(c)||t.$X.onUnexpectedError(c)}t.$1=f;function N(c){s(c)||t.$X.onUnexpectedExternalError(c)}t.$2=N;function h(c){if(c instanceof Error){const{name:i,message:a}=c,L=c.stacktrace||c.stack;return{$isError:!0,name:i,message:a,stack:L,noTelemetry:u.isErrorNoTelemetry(c)}}return c}t.$3=h;const l="Canceled";function s(c){return c instanceof g?!0:c instanceof Error&&c.name===l&&c.message===l}t.$4=s;class g extends Error{constructor(){super(l),this.name=this.message}}t.$5=g;function A(){const c=new Error(l);return c.name=c.message,c}t.$6=A;function b(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}t.$7=b;function m(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}t.$8=m;class e extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function E(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}t.$0=E;class R extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}t.$$=R;class v extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}t.$_=v;class $ extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=$;class u extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof u)return i;const a=new u;return a.message=i.message,a.stack=i.stack,a}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}t.$bb=u;class o extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}t.$cb=o}),ne(ie[6],se([0,1,3,9]),function(j,t,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.CompareResult=t.$6b=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.top=t.$Eb=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=void 0;function r(U,C=0){return U[U.length-(1+C)]}t.$sb=r;function f(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}t.$tb=f;function N(U,C,W=(X,K)=>X===K){if(U===C)return!0;if(!U||!C||U.length!==C.length)return!1;for(let X=0,K=U.length;X<K;X++)if(!W(U[X],C[X]))return!1;return!0}t.$ub=N;function h(U,C){const W=U.length-1;C<W&&(U[C]=U[W]),U.pop()}t.$vb=h;function l(U,C,W){return s(U.length,X=>W(U[X],C))}t.$wb=l;function s(U,C){let W=0,X=U-1;for(;W<=X;){const K=(W+X)/2|0,G=C(K);if(G<0)W=K+1;else if(G>0)X=K-1;else return K}return-(W+1)}t.$xb=s;function g(U,C,W){if(U=U|0,U>=C.length)throw new TypeError("invalid index");const X=C[Math.floor(C.length*Math.random())],K=[],G=[],Z=[];for(const ee of C){const J=W(ee,X);J<0?K.push(ee):J>0?G.push(ee):Z.push(ee)}return U<K.length?g(U,K,W):U<K.length+Z.length?Z[0]:g(U-(K.length+Z.length),G,W)}t.$yb=g;function A(U,C){const W=[];let X;for(const K of U.slice(0).sort(C))!X||C(X[0],K)!==0?(X=[K],W.push(X)):X.push(K);return W}t.$zb=A;function*b(U,C){let W,X;for(const K of U)X!==void 0&&C(X,K)?W.push(K):(W&&(yield W),W=[K]),X=K;W&&(yield W)}t.$Ab=b;function m(U,C){for(let W=0;W<=U.length;W++)C(W===0?void 0:U[W-1],W===U.length?void 0:U[W])}t.$Bb=m;function e(U,C){for(let W=0;W<U.length;W++)C(W===0?void 0:U[W-1],U[W],W+1===U.length?void 0:U[W+1])}t.$Cb=e;function E(U,C,W){const X=[];function K(ee,J,re){if(J===0&&re.length===0)return;const le=X[X.length-1];le&&le.start+le.deleteCount===ee?(le.deleteCount+=J,le.toInsert.push(...re)):X.push({start:ee,deleteCount:J,toInsert:re})}let G=0,Z=0;for(;;){if(G===U.length){K(G,0,C.slice(Z));break}if(Z===C.length){K(G,U.length-G,[]);break}const ee=U[G],J=C[Z],re=W(ee,J);re===0?(G+=1,Z+=1):re<0?(K(G,1,[]),G+=1):re>0&&(K(G,0,[J]),Z+=1)}return X}t.$Db=E;function R(U,C,W){const X=E(U,C,W),K=[],G=[];for(const Z of X)K.push(...U.slice(Z.start,Z.start+Z.deleteCount)),G.push(...Z.toInsert);return{removed:K,added:G}}t.$Eb=R;function v(U,C,W){if(W===0)return[];const X=U.slice(0,W).sort(C);return u(U,C,X,W,U.length),X}t.top=v;function $(U,C,W,X,K){return W===0?Promise.resolve([]):new Promise((G,Z)=>{(async()=>{const ee=U.length,J=U.slice(0,W).sort(C);for(let re=W,le=Math.min(W+X,ee);re<ee;re=le,le=Math.min(le+X,ee)){if(re>W&&await new Promise(oe=>setTimeout(oe)),K&&K.isCancellationRequested)throw new D.$5;u(U,C,J,re,le)}return J})().then(G,Z)})}t.$Gb=$;function u(U,C,W,X,K){for(const G=W.length;X<K;X++){const Z=U[X];if(C(Z,W[G-1])<0){W.pop();const ee=(0,k.$kb)(W,J=>C(Z,J)<0);W.splice(ee,0,Z)}}}function o(U){return U.filter(C=>!!C)}t.$Hb=o;function c(U){let C=0;for(let W=0;W<U.length;W++)U[W]&&(U[C]=U[W],C+=1);U.length=C}t.$Ib=c;function i(U,C,W){U.splice(W,0,U.splice(C,1)[0])}t.$Jb=i;function a(U){return!Array.isArray(U)||U.length===0}t.$Kb=a;function L(U){return Array.isArray(U)&&U.length>0}t.$Lb=L;function d(U,C=W=>W){const W=new Set;return U.filter(X=>{const K=C(X);return W.has(K)?!1:(W.add(K),!0)})}t.$Mb=d;function w(U){const C=new Set;return W=>{const X=U(W);return C.has(X)?!1:(C.add(X),!0)}}t.$Nb=w;function M(U,C){return U.length>0?U[0]:C}t.$Ob=M;function p(U,C){return U.length>0?U[U.length-1]:C}t.$Pb=p;function F(U,C,W=(X,K)=>X===K){let X=0;for(let K=0,G=Math.min(U.length,C.length);K<G&&W(U[K],C[K]);K++)X++;return X}t.$Qb=F;function _(U){return[].concat(...U)}t.$Rb=_;function P(U,C){let W=typeof C=="number"?U:0;typeof C=="number"?W=U:(W=0,C=U);const X=[];if(W<=C)for(let K=W;K<C;K++)X.push(K);else for(let K=W;K>C;K--)X.push(K);return X}t.$Sb=P;function S(U,C,W){return U.reduce((X,K)=>(X[C(K)]=W?W(K):K,X),Object.create(null))}t.$Tb=S;function T(U,C){return U.push(C),()=>q(U,C)}t.$Ub=T;function q(U,C){const W=U.indexOf(C);if(W>-1)return U.splice(W,1),C}t.$Vb=q;function O(U,C,W){const X=U.slice(0,C),K=U.slice(C);return X.concat(W,K)}t.$Wb=O;function y(U,C){let W;if(typeof C=="number"){let X=C;W=()=>{const K=Math.sin(X++)*179426549;return K-Math.floor(K)}}else W=Math.random;for(let X=U.length-1;X>0;X-=1){const K=Math.floor(W()*(X+1)),G=U[X];U[X]=U[K],U[K]=G}}t.$Xb=y;function V(U,C){const W=U.indexOf(C);W>-1&&(U.splice(W,1),U.unshift(C))}t.$Yb=V;function H(U,C){const W=U.indexOf(C);W>-1&&(U.splice(W,1),U.push(C))}t.$Zb=H;function x(U,C){for(const W of C)U.push(W)}t.$1b=x;function Y(U,C){return Array.isArray(U)?U.map(C):C(U)}t.$2b=Y;function te(U){return Array.isArray(U)?U:[U]}t.$3b=te;function n(U){return U[Math.floor(Math.random()*U.length)]}t.$4b=n;function ae(U,C,W){const X=$e(U,C),K=U.length,G=W.length;U.length=K+G;for(let Z=K-1;Z>=X;Z--)U[Z+G]=U[Z];for(let Z=0;Z<G;Z++)U[Z+X]=W[Z]}t.$5b=ae;function he(U,C,W,X){const K=$e(U,C);let G=U.splice(K,W);return G===void 0&&(G=[]),ae(U,K,X),G}t.$6b=he;function $e(U,C){return C<0?Math.max(C+U.length,0):Math.min(C,U.length)}var ve;(function(U){function C(G){return G<0}U.isLessThan=C;function W(G){return G<=0}U.isLessThanOrEqual=W;function X(G){return G>0}U.isGreaterThan=X;function K(G){return G===0}U.isNeitherLessOrGreaterThan=K,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(ve||(t.CompareResult=ve={}));function Fe(U,C){return(W,X)=>C(U(W),U(X))}t.$7b=Fe;function we(...U){return(C,W)=>{for(const X of U){const K=X(C,W);if(!ve.isNeitherLessOrGreaterThan(K))return K}return ve.neitherLessOrGreaterThan}}t.$8b=we;const Re=(U,C)=>U-C;t.$9b=Re;const Se=(U,C)=>(0,t.$9b)(U?1:0,C?1:0);t.$0b=Se;function Ie(U){return(C,W)=>-U(C,W)}t.$$b=Ie;class qe{constructor(C){this.g=C,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(C){let W=this.c;for(;W<this.g.length&&C(this.g[W]);)W++;const X=W===this.c?null:this.g.slice(this.c,W);return this.c=W,X}takeFromEndWhile(C){let W=this.d;for(;W>=0&&C(this.g[W]);)W--;const X=W===this.d?null:this.g.slice(W+1,this.d+1);return this.d=W,X}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const C=this.g[this.c];return this.c++,C}removeLast(){const C=this.g[this.d];return this.d--,C}takeCount(C){const W=this.g.slice(this.c,this.c+C);return this.c+=C,W}}t.$_b=qe;class Me{static{this.empty=new Me(C=>{})}constructor(C){this.iterate=C}forEach(C){this.iterate(W=>(C(W),!0))}toArray(){const C=[];return this.iterate(W=>(C.push(W),!0)),C}filter(C){return new Me(W=>this.iterate(X=>C(X)?W(X):!0))}map(C){return new Me(W=>this.iterate(X=>W(C(X))))}some(C){let W=!1;return this.iterate(X=>(W=C(X),!W)),W}findFirst(C){let W;return this.iterate(X=>C(X)?(W=X,!1):!0),W}findLast(C){let W;return this.iterate(X=>(C(X)&&(W=X),!0)),W}findLastMaxBy(C){let W,X=!0;return this.iterate(K=>((X||ve.isGreaterThan(C(K,W)))&&(X=!1,W=K),!0)),W}}t.$ac=Me}),ne(ie[13],se([0,1,3]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8c=t.$7c=t.$6c=t.$5c=t.ok=void 0;function k(l,s){if(!l)throw new Error(s?`Assertion failed (${s})`:"Assertion Failed")}t.ok=k;function r(l,s="Unreachable"){throw new Error(s)}t.$5c=r;function f(l){if(!l)throw new D.$cb("Assertion Failed")}t.$6c=f;function N(l){if(!l()){debugger;l(),(0,D.$1)(new D.$cb("Assertion Failed"))}}t.$7c=N;function h(l,s){let g=0;for(;g<l.length-1;){const A=l[g],b=l[g+1];if(!s(A,b))return!1;g++}return!0}t.$8c=h}),ne(ie[19],se([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=void 0;function D(k,r){const f=this;let N=!1,h;return function(){if(N)return h;if(N=!0,r)try{h=k.apply(f,arguments)}finally{r()}else h=k.apply(f,arguments);return h}}t.$db=D}),ne(ie[20],se([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var D;(function(k){function r(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}k.is=r;const f=Object.freeze([]);function N(){return f}k.empty=N;function*h(i){yield i}k.single=h;function l(i){return r(i)?i:h(i)}k.wrap=l;function s(i){return i||f}k.from=s;function*g(i){for(let a=i.length-1;a>=0;a--)yield i[a]}k.reverse=g;function A(i){return!i||i[Symbol.iterator]().next().done===!0}k.isEmpty=A;function b(i){return i[Symbol.iterator]().next().value}k.first=b;function m(i,a){for(const L of i)if(a(L))return!0;return!1}k.some=m;function e(i,a){for(const L of i)if(a(L))return L}k.find=e;function*E(i,a){for(const L of i)a(L)&&(yield L)}k.filter=E;function*R(i,a){let L=0;for(const d of i)yield a(d,L++)}k.map=R;function*v(...i){for(const a of i)yield*a}k.concat=v;function $(i,a,L){let d=L;for(const w of i)d=a(d,w);return d}k.reduce=$;function*u(i,a,L=i.length){for(a<0&&(a+=i.length),L<0?L+=i.length:L>i.length&&(L=i.length);a<L;a++)yield i[a]}k.slice=u;function o(i,a=Number.POSITIVE_INFINITY){const L=[];if(a===0)return[L,i];const d=i[Symbol.iterator]();for(let w=0;w<a;w++){const M=d.next();if(M.done)return[L,k.empty()];L.push(M.value)}return[L,{[Symbol.iterator](){return d}}]}k.consume=o;async function c(i){const a=[];for await(const L of i)a.push(L);return Promise.resolve(a)}k.asyncToArray=c})(D||(t.Iterable=D={}))}),ne(ie[37],se([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uq=t.KeyMod=t.KeyCodeUtils=t.$Tq=t.$Sq=t.$Rq=t.$Qq=t.$Pq=t.ScanCode=t.KeyCode=void 0;var D;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(D||(t.KeyCode=D={}));var k;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(k||(t.ScanCode=k={}));class r{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(E,R){this._keyCodeToStr[E]=R,this._strToKeyCode[R.toLowerCase()]=E}keyCodeToStr(E){return this._keyCodeToStr[E]}strToKeyCode(E){return this._strToKeyCode[E.toLowerCase()]||0}}const f=new r,N=new r,h=new r;t.$Pq=new Array(230),t.$Qq={};const l=[],s=Object.create(null),g=Object.create(null);t.$Rq={lowerCaseToEnum:e=>g[e]||0,toEnum:e=>s[e]||0,toString:e=>l[e]||"None"},t.$Sq=[],t.$Tq=[];for(let e=0;e<=193;e++)t.$Sq[e]=-1;for(let e=0;e<=132;e++)t.$Tq[e]=-1;(function(){const e="",E=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],R=[],v=[];for(const $ of E){const[u,o,c,i,a,L,d,w,M]=$;if(v[o]||(v[o]=!0,l[o]=c,s[c]=o,g[c.toLowerCase()]=o,u&&(t.$Sq[o]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(t.$Tq[i]=o))),!R[i]){if(R[i]=!0,!a)throw new Error(`String representation missing for key code ${i} around scan code ${c}`);f.define(i,a),N.define(i,w||a),h.define(i,M||w||a)}L&&(t.$Pq[L]=i),d&&(t.$Qq[d]=i)}t.$Tq[3]=46})();var A;(function(e){function E(c){return f.keyCodeToStr(c)}e.toString=E;function R(c){return f.strToKeyCode(c)}e.fromString=R;function v(c){return N.keyCodeToStr(c)}e.toUserSettingsUS=v;function $(c){return h.keyCodeToStr(c)}e.toUserSettingsGeneral=$;function u(c){return N.strToKeyCode(c)||h.strToKeyCode(c)}e.fromUserSettings=u;function o(c){if(c>=98&&c<=113)return null;switch(c){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return f.keyCodeToStr(c)}e.toElectronAccelerator=o})(A||(t.KeyCodeUtils=A={}));var b;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(b||(t.KeyMod=b={}));function m(e,E){const R=(E&65535)<<16>>>0;return(e|R)>>>0}t.$Uq=m}),ne(ie[38],se([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class D{constructor(r){this.d=r,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(r){this.c=r}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=D}),ne(ie[21],se([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(f){this.element=f,this.next=D.Undefined,this.prev=D.Undefined}}class k{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let f=this.a;for(;f!==D.Undefined;){const N=f.next;f.prev=D.Undefined,f.next=D.Undefined,f=N}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(f){return this.d(f,!1)}push(f){return this.d(f,!0)}d(f,N){const h=new D(f);if(this.a===D.Undefined)this.a=h,this.b=h;else if(N){const s=this.b;this.b=h,h.prev=s,s.next=h}else{const s=this.a;this.a=h,h.next=s,s.prev=h}this.c+=1;let l=!1;return()=>{l||(l=!0,this.e(h))}}shift(){if(this.a!==D.Undefined){const f=this.a.element;return this.e(this.a),f}}pop(){if(this.b!==D.Undefined){const f=this.b.element;return this.e(this.b),f}}e(f){if(f.prev!==D.Undefined&&f.next!==D.Undefined){const N=f.prev;N.next=f.next,f.next.prev=N}else f.prev===D.Undefined&&f.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):f.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):f.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let f=this.a;for(;f!==D.Undefined;)yield f.element,f=f.next}}t.$3c=k}),ne(ie[22],se([0,1]),function(j,t){"use strict";var D,k,r;Object.defineProperty(t,"__esModule",{value:!0}),t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.Touch=t.$Bc=t.$Ac=t.$zc=t.$yc=t.$xc=void 0;function f($,u,o){let c=$.get(u);return c===void 0&&(c=o,$.set(u,c)),c}t.$xc=f;function N($){const u=[];return $.forEach((o,c)=>{u.push(`${c} => ${o}`)}),`Map(${$.size}) {${u.join(", ")}}`}t.$yc=N;function h($){const u=[];return $.forEach(o=>{u.push(o)}),`Set(${$.size}) {${u.join(", ")}}`}t.$zc=h;class l{constructor(u,o){this.uri=u,this.value=o}}function s($){return Array.isArray($)}class g{static{this.a=u=>u.toString()}constructor(u,o){if(this[D]="ResourceMap",u instanceof g)this.b=new Map(u.b),this.c=o??g.a;else if(s(u)){this.b=new Map,this.c=o??g.a;for(const[c,i]of u)this.set(c,i)}else this.b=new Map,this.c=u??g.a}set(u,o){return this.b.set(this.c(u),new l(u,o)),this}get(u){return this.b.get(this.c(u))?.value}has(u){return this.b.has(this.c(u))}get size(){return this.b.size}clear(){this.b.clear()}delete(u){return this.b.delete(this.c(u))}forEach(u,o){typeof o<"u"&&(u=u.bind(o));for(const[c,i]of this.b)u(i.value,i.uri,this)}*values(){for(const u of this.b.values())yield u.value}*keys(){for(const u of this.b.values())yield u.uri}*entries(){for(const u of this.b.values())yield[u.uri,u.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.b)yield[u.uri,u.value]}}t.$Ac=g;class A{constructor(u,o){this[k]="ResourceSet",!u||typeof u=="function"?this.a=new g(u):(this.a=new g(o),u.forEach(this.add,this))}get size(){return this.a.size}add(u){return this.a.set(u,u),this}clear(){this.a.clear()}delete(u){return this.a.delete(u)}forEach(u,o){this.a.forEach((c,i)=>u.call(o,i,i,this))}has(u){return this.a.has(u)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Bc=A;var b;(function($){$[$.None=0]="None",$[$.AsOld=1]="AsOld",$[$.AsNew=2]="AsNew"})(b||(t.Touch=b={}));class m{constructor(){this[r]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(u){return this.a.has(u)}get(u,o=0){const c=this.a.get(u);if(c)return o!==0&&this.j(c,o),c.value}set(u,o,c=0){let i=this.a.get(u);if(i)i.value=o,c!==0&&this.j(i,c);else{switch(i={key:u,value:o,next:void 0,previous:void 0},c){case 0:this.h(i);break;case 1:this.g(i);break;case 2:this.h(i);break;default:this.h(i);break}this.a.set(u,i),this.d++}return this}delete(u){return!!this.remove(u)}remove(u){const o=this.a.get(u);if(o)return this.a.delete(u),this.i(o),this.d--,o.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const u=this.b;return this.a.delete(u.key),this.i(u),this.d--,u.value}forEach(u,o){const c=this.e;let i=this.b;for(;i;){if(o?u.bind(o)(i.value,i.key,this):u(i.value,i.key,this),this.e!==c)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const u=this,o=this.e;let c=this.b;const i={[Symbol.iterator](){return i},next(){if(u.e!==o)throw new Error("LinkedMap got modified during iteration.");if(c){const a={value:c.key,done:!1};return c=c.next,a}else return{value:void 0,done:!0}}};return i}values(){const u=this,o=this.e;let c=this.b;const i={[Symbol.iterator](){return i},next(){if(u.e!==o)throw new Error("LinkedMap got modified during iteration.");if(c){const a={value:c.value,done:!1};return c=c.next,a}else return{value:void 0,done:!0}}};return i}entries(){const u=this,o=this.e;let c=this.b;const i={[Symbol.iterator](){return i},next(){if(u.e!==o)throw new Error("LinkedMap got modified during iteration.");if(c){const a={value:[c.key,c.value],done:!1};return c=c.next,a}else return{value:void 0,done:!0}}};return i}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(u){if(u>=this.size)return;if(u===0){this.clear();return}let o=this.b,c=this.size;for(;o&&c>u;)this.a.delete(o.key),o=o.next,c--;this.b=o,this.d=c,o&&(o.previous=void 0),this.e++}g(u){if(!this.b&&!this.c)this.c=u;else if(this.b)u.next=this.b,this.b.previous=u;else throw new Error("Invalid list");this.b=u,this.e++}h(u){if(!this.b&&!this.c)this.b=u;else if(this.c)u.previous=this.c,this.c.next=u;else throw new Error("Invalid list");this.c=u,this.e++}i(u){if(u===this.b&&u===this.c)this.b=void 0,this.c=void 0;else if(u===this.b){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.b=u.next}else if(u===this.c){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.c=u.previous}else{const o=u.next,c=u.previous;if(!o||!c)throw new Error("Invalid list");o.previous=c,c.next=o}u.next=void 0,u.previous=void 0,this.e++}j(u,o){if(!this.b||!this.c)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(u===this.b)return;const c=u.next,i=u.previous;u===this.c?(i.next=void 0,this.c=i):(c.previous=i,i.next=c),u.previous=void 0,u.next=this.b,this.b.previous=u,this.b=u,this.e++}else if(o===2){if(u===this.c)return;const c=u.next,i=u.previous;u===this.b?(c.previous=void 0,this.b=c):(c.previous=i,i.next=c),u.next=void 0,u.previous=this.c,this.c.next=u,this.c=u,this.e++}}}toJSON(){const u=[];return this.forEach((o,c)=>{u.push([c,o])}),u}fromJSON(u){this.clear();for(const[o,c]of u)this.set(o,c)}}t.$Cc=m;class e extends m{constructor(u,o=1){super(),this.k=u,this.l=Math.min(Math.max(0,o),1)}get limit(){return this.k}set limit(u){this.k=u,this.m()}get ratio(){return this.l}set ratio(u){this.l=Math.min(Math.max(0,u),1),this.m()}get(u,o=2){return super.get(u,o)}peek(u){return super.get(u,0)}set(u,o){return super.set(u,o,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.$Dc=e;class E{constructor(){this.a=new Map}add(u){return this.a.set(u,(this.a.get(u)||0)+1),this}delete(u){let o=this.a.get(u)||0;return o===0?!1:(o--,o===0?this.a.delete(u):this.a.set(u,o),!0)}has(u){return this.a.has(u)}}t.$Ec=E;class R{constructor(u){if(this.a=new Map,this.b=new Map,u)for(const[o,c]of u)this.set(o,c)}clear(){this.a.clear(),this.b.clear()}set(u,o){this.a.set(u,o),this.b.set(o,u)}get(u){return this.a.get(u)}getKey(u){return this.b.get(u)}delete(u){const o=this.a.get(u);return o===void 0?!1:(this.a.delete(u),this.b.delete(o),!0)}forEach(u,o){this.a.forEach((c,i)=>{u.call(o,c,i,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}t.$Fc=R;class v{constructor(){this.a=new Map}add(u,o){let c=this.a.get(u);c||(c=new Set,this.a.set(u,c)),c.add(o)}delete(u,o){const c=this.a.get(u);c&&(c.delete(o),c.size===0&&this.a.delete(u))}forEach(u,o){const c=this.a.get(u);c&&c.forEach(o)}get(u){const o=this.a.get(u);return o||new Set}}t.$Gc=v}),ne(ie[10],se([0,1,6,34,22,19,20]),function(j,t,D,k,r,f,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=t.$Hc=void 0;const h=!1;let l=null;class s{constructor(){this.b=new Map}static{this.a=0}c(T){let q=this.b.get(T);return q||(q={parent:null,source:null,isSingleton:!1,value:T,idx:s.a++},this.b.set(T,q)),q}trackDisposable(T){const q=this.c(T);q.source||(q.source=new Error().stack)}setParent(T,q){const O=this.c(T);O.parent=q}markAsDisposed(T){this.b.delete(T)}markAsSingleton(T){this.c(T).isSingleton=!0}f(T,q){const O=q.get(T);if(O)return O;const y=T.parent?this.f(this.c(T.parent),q):T;return q.set(T,y),y}getTrackedDisposables(){const T=new Map;return[...this.b.entries()].filter(([,O])=>O.source!==null&&!this.f(O,T).isSingleton).flatMap(([O])=>O)}computeLeakingDisposables(T=10,q){let O;if(q)O=q;else{const Y=new Map,te=[...this.b.values()].filter(ae=>ae.source!==null&&!this.f(ae,Y).isSingleton);if(te.length===0)return;const n=new Set(te.map(ae=>ae.value));if(O=te.filter(ae=>!(ae.parent&&n.has(ae.parent))),O.length===0)throw new Error("There are cyclic diposable chains!")}if(!O)return;function y(Y){function te(ae,he){for(;ae.length>0&&he.some($e=>typeof $e=="string"?$e===ae[0]:ae[0].match($e));)ae.shift()}const n=Y.source.split(`
`).map(ae=>ae.trim().replace("at ","")).filter(ae=>ae!=="");return te(n,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),n.reverse()}const V=new r.$Gc;for(const Y of O){const te=y(Y);for(let n=0;n<=te.length;n++)V.add(te.slice(0,n).join(`
`),Y)}O.sort((0,D.$7b)(Y=>Y.idx,D.$9b));let H="",x=0;for(const Y of O.slice(0,T)){x++;const te=y(Y),n=[];for(let ae=0;ae<te.length;ae++){let he=te[ae];he=`(shared with ${V.get(te.slice(0,ae+1).join(`
`)).size}/${O.length} leaks) at ${he}`;const ve=V.get(te.slice(0,ae).join(`
`)),Fe=(0,k.$K)([...ve].map(we=>y(we)[ae]),we=>we);delete Fe[te[ae]];for(const[we,Re]of Object.entries(Fe))n.unshift(`    - stacktraces of ${Re.length} other leaks continue with ${we}`);n.unshift(he)}H+=`


==================== Leaking disposable ${x}/${O.length}: ${Y.value.constructor.name} ====================
${n.join(`
`)}
============================================================

`}return O.length>T&&(H+=`


... and ${O.length-T} more leaking disposables

`),{leaks:O,details:H}}}t.$Hc=s;function g(S){l=S}if(t.$Ic=g,h){const S="__is_disposable_tracked__";g(new class{trackDisposable(T){const q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{T[S]||console.log(q)},3e3)}setParent(T,q){if(T&&T!==i.None)try{T[S]=!0}catch{}}markAsDisposed(T){if(T&&T!==i.None)try{T[S]=!0}catch{}}markAsSingleton(T){}})}function A(S){return l?.trackDisposable(S),S}t.$Jc=A;function b(S){l?.markAsDisposed(S)}t.$Kc=b;function m(S,T){l?.setParent(S,T)}function e(S,T){if(l)for(const q of S)l.setParent(q,T)}function E(S){return l?.markAsSingleton(S),S}t.$Lc=E;function R(S){return typeof S.dispose=="function"&&S.dispose.length===0}t.$Mc=R;function v(S){if(N.Iterable.is(S)){const T=[];for(const q of S)if(q)try{q.dispose()}catch(O){T.push(O)}if(T.length===1)throw T[0];if(T.length>1)throw new AggregateError(T,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}t.$Nc=v;function $(S){for(const T of S)R(T)&&T.dispose();return[]}t.$Oc=$;function u(...S){const T=o(()=>v(S));return e(S,T),T}t.$Pc=u;function o(S){const T=A({dispose:(0,f.$db)(()=>{b(T),S()})});return T}t.$Qc=o;class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,A(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{v(this.f)}finally{this.f.clear()}}add(T){if(!T)return T;if(T===this)throw new Error("Cannot register a disposable on itself!");return m(T,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(T),T}delete(T){if(T){if(T===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(T),T.dispose()}}deleteAndLeak(T){T&&this.f.has(T)&&(this.f.delete(T),m(T,null))}}t.$Rc=c;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,A(this),m(this.q,this)}dispose(){b(this),this.q.dispose()}B(T){if(T===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(T)}}t.$Sc=i;class a{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(T){this.b||T===this.a||(this.a?.dispose(),T&&m(T,this),this.a=T)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const T=this.a;return this.a=void 0,T&&m(T,null),T}}t.$Tc=a;class L{constructor(T){this.a=new a,this.b=!1,this.a.value=T}get value(){return this.a.value}set value(T){this.b||T===this.a.value||(this.a.value=T)}dispose(){this.b=!0,this.a.dispose()}}t.$Uc=L;class d{constructor(T){this.b=T,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Vc=d;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(T){let q=T;return this.unset=()=>q=void 0,this.isset=()=>q!==void 0,this.dispose=()=>{q&&(q(),q=void 0,b(this))},this}}t.$Wc=w;class M{constructor(){this.a=new Map}acquire(T,...q){let O=this.a.get(T);O||(O={counter:0,object:this.b(T,...q)},this.a.set(T,O));const{object:y}=O,V=(0,f.$db)(()=>{--O.counter===0&&(this.c(T,O.object),this.a.delete(T))});return O.counter++,{object:y,dispose:V}}}t.$Xc=M;class p{constructor(T){this.a=T}async acquire(T,...q){const O=this.a.acquire(T,...q);try{return{object:await O.object,dispose:()=>O.dispose()}}catch(y){throw O.dispose(),y}}}t.$Yc=p;class F{constructor(T){this.object=T}dispose(){}}t.$Zc=F;function _(S){const T=new c;try{S(T)}finally{T.dispose()}}t.$1c=_;class P{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{v(this.a.values())}finally{this.a.clear()}}has(T){return this.a.has(T)}get size(){return this.a.size}get(T){return this.a.get(T)}set(T,q,O=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),O||this.a.get(T)?.dispose(),this.a.set(T,q)}deleteAndDispose(T){this.a.get(T)?.dispose(),this.a.delete(T)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$2c=P}),ne(ie[23],se([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Od=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class k{static create(f){return new k(f)}constructor(f){this.c=D&&f===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Od=k}),ne(ie[11],se([0,1,3,19,10,21,23]),function(j,t,D,k,r,f,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2d=t.$1d=t.$Zd=t.$Yd=t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.Event=void 0;const h=!1,l=!1;var s;(function(_){_.None=()=>r.$Sc.None;function P(G){if(l){const{onDidAddListener:Z}=G,ee=e.create();let J=0;G.onDidAddListener=()=>{++J===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ee.print()),Z?.()}}}function S(G,Z){return n(G,()=>{},0,void 0,!0,void 0,Z)}_.defer=S;function T(G){return(Z,ee=null,J)=>{let re=!1,le;return le=G(oe=>{if(!re)return le?le.dispose():re=!0,Z.call(ee,oe)},null,J),re&&le.dispose(),le}}_.once=T;function q(G,Z,ee){return Y((J,re=null,le)=>G(oe=>J.call(re,Z(oe)),null,le),ee)}_.map=q;function O(G,Z,ee){return Y((J,re=null,le)=>G(oe=>{Z(oe),J.call(re,oe)},null,le),ee)}_.forEach=O;function y(G,Z,ee){return Y((J,re=null,le)=>G(oe=>Z(oe)&&J.call(re,oe),null,le),ee)}_.filter=y;function V(G){return G}_.signal=V;function H(...G){return(Z,ee=null,J)=>{const re=(0,r.$Pc)(...G.map(le=>le(oe=>Z.call(ee,oe))));return te(re,J)}}_.any=H;function x(G,Z,ee,J){let re=ee;return q(G,le=>(re=Z(re,le),re),J)}_.reduce=x;function Y(G,Z){let ee;const J={onWillAddFirstListener(){ee=G(re.fire,re)},onDidRemoveLastListener(){ee?.dispose()}};Z||P(J);const re=new u(J);return Z?.add(re),re.event}function te(G,Z){return Z instanceof Array?Z.push(G):Z&&Z.add(G),G}function n(G,Z,ee=100,J=!1,re=!1,le,oe){let de,ge,ye,De=0,ke;const Le={leakWarningThreshold:le,onWillAddFirstListener(){de=G(Oe=>{De++,ge=Z(ge,Oe),J&&!ye&&(_e.fire(ge),ge=void 0),ke=()=>{const je=ge;ge=void 0,ye=void 0,(!J||De>1)&&_e.fire(je),De=0},typeof ee=="number"?(clearTimeout(ye),ye=setTimeout(ke,ee)):ye===void 0&&(ye=0,queueMicrotask(ke))})},onWillRemoveListener(){re&&De>0&&ke?.()},onDidRemoveLastListener(){ke=void 0,de.dispose()}};oe||P(Le);const _e=new u(Le);return oe?.add(_e),_e.event}_.debounce=n;function ae(G,Z=0,ee){return _.debounce(G,(J,re)=>J?(J.push(re),J):[re],Z,void 0,!0,void 0,ee)}_.accumulate=ae;function he(G,Z=(J,re)=>J===re,ee){let J=!0,re;return y(G,le=>{const oe=J||!Z(le,re);return J=!1,re=le,oe},ee)}_.latch=he;function $e(G,Z,ee){return[_.filter(G,Z,ee),_.filter(G,J=>!Z(J),ee)]}_.split=$e;function ve(G,Z=!1,ee=[],J){let re=ee.slice(),le=G(ge=>{re?re.push(ge):de.fire(ge)});J&&J.add(le);const oe=()=>{re?.forEach(ge=>de.fire(ge)),re=null},de=new u({onWillAddFirstListener(){le||(le=G(ge=>de.fire(ge)),J&&J.add(le))},onDidAddFirstListener(){re&&(Z?setTimeout(oe):oe())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return J&&J.add(de),de.event}_.buffer=ve;function Fe(G,Z){return(J,re,le)=>{const oe=Z(new Re);return G(function(de){const ge=oe.evaluate(de);ge!==we&&J.call(re,ge)},void 0,le)}}_.chain=Fe;const we=Symbol("HaltChainable");class Re{constructor(){this.f=[]}map(Z){return this.f.push(Z),this}forEach(Z){return this.f.push(ee=>(Z(ee),ee)),this}filter(Z){return this.f.push(ee=>Z(ee)?ee:we),this}reduce(Z,ee){let J=ee;return this.f.push(re=>(J=Z(J,re),J)),this}latch(Z=(ee,J)=>ee===J){let ee=!0,J;return this.f.push(re=>{const le=ee||!Z(re,J);return ee=!1,J=re,le?re:we}),this}evaluate(Z){for(const ee of this.f)if(Z=ee(Z),Z===we)break;return Z}}function Se(G,Z,ee=J=>J){const J=(...de)=>oe.fire(ee(...de)),re=()=>G.on(Z,J),le=()=>G.removeListener(Z,J),oe=new u({onWillAddFirstListener:re,onDidRemoveLastListener:le});return oe.event}_.fromNodeEventEmitter=Se;function Ie(G,Z,ee=J=>J){const J=(...de)=>oe.fire(ee(...de)),re=()=>G.addEventListener(Z,J),le=()=>G.removeEventListener(Z,J),oe=new u({onWillAddFirstListener:re,onDidRemoveLastListener:le});return oe.event}_.fromDOMEventEmitter=Ie;function qe(G){return new Promise(Z=>T(G)(Z))}_.toPromise=qe;function Me(G){const Z=new u;return G.then(ee=>{Z.fire(ee)},()=>{Z.fire(void 0)}).finally(()=>{Z.dispose()}),Z.event}_.fromPromise=Me;function U(G,Z,ee){return Z(ee),G(J=>Z(J))}_.runAndSubscribe=U;function C(G,Z){let ee=null;function J(le){ee?.dispose(),ee=new r.$Rc,Z(le,ee)}J(void 0);const re=G(le=>J(le));return(0,r.$Qc)(()=>{re.dispose(),ee?.dispose()})}_.runAndSubscribeWithStore=C;class W{constructor(Z,ee){this._observable=Z,this.f=0,this.g=!1;const J={onWillAddFirstListener:()=>{Z.addObserver(this)},onDidRemoveLastListener:()=>{Z.removeObserver(this)}};ee||P(J),this.emitter=new u(J),ee&&ee.add(this.emitter)}beginUpdate(Z){this.f++}handlePossibleChange(Z){}handleChange(Z,ee){this.g=!0}endUpdate(Z){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function X(G,Z){return new W(G,Z).emitter.event}_.fromObservable=X;function K(G){return(Z,ee,J)=>{let re=0,le=!1;const oe={beginUpdate(){re++},endUpdate(){re--,re===0&&(G.reportChanges(),le&&(le=!1,Z.call(ee)))},handlePossibleChange(){},handleChange(){le=!0}};G.addObserver(oe),G.reportChanges();const de={dispose(){G.removeObserver(oe)}};return J instanceof r.$Rc?J.add(de):Array.isArray(J)&&J.push(de),de}}_.fromObservableLight=K})(s||(t.Event=s={}));class g{static{this.all=new Set}static{this.f=0}constructor(P){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${P}_${g.f++}`,g.all.add(this)}start(P){this.g=new N.$Od,this.listenerCount=P}stop(){if(this.g){const P=this.g.elapsed();this.durations.push(P),this.elapsedOverall+=P,this.invocationCount+=1,this.g=void 0}}}t.$Qd=g;let A=-1;function b(_){const P=A;return A=_,{dispose(){A=P}}}t.$Rd=b;class m{constructor(P,S=Math.random().toString(18).slice(2,5)){this.threshold=P,this.name=S,this.g=0}dispose(){this.f?.clear()}check(P,S){const T=this.threshold;if(T<=0||S<T)return;this.f||(this.f=new Map);const q=this.f.get(P.value)||0;if(this.f.set(P.value,q+1),this.g-=1,this.g<=0){this.g=T*.5;let O,y=0;for(const[V,H]of this.f)(!O||y<H)&&(O=V,y=H);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${y}):`),console.warn(O)}return()=>{const O=this.f.get(P.value)||0;this.f.set(P.value,O-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(P){this.value=P}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let E=0;class R{constructor(P){this.value=P,this.id=E++}}const v=2,$=(_,P)=>{if(_ instanceof R)P(_);else for(let S=0;S<_.length;S++){const T=_[S];T&&P(T)}};class u{constructor(P){this.w=0,this.f=P,this.g=A>0||this.f?.leakWarningThreshold?new m(this.f?.leakWarningThreshold??A):void 0,this.j=this.f?._profName?new g(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(h){const P=this.t;queueMicrotask(()=>{$(P,S=>S.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(P,S,T)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.$Sc.None;if(this.m)return r.$Sc.None;S&&(P=P.bind(S));const q=new R(P);let O,y;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(q.stack=e.create(),O=this.g.check(q.stack,this.w+1)),h&&(q.stack=y??e.create()),this.t?this.t instanceof R?(this.u??=new c,this.t=[this.t,q]):this.t.push(q):(this.f?.onWillAddFirstListener?.(this),this.t=q,this.f?.onDidAddFirstListener?.(this)),this.w++;const V=(0,r.$Qc)(()=>{O?.(),this.x(q)});return T instanceof r.$Rc?T.add(V):Array.isArray(T)&&T.push(V),V},this.q}x(P){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const S=this.t,T=S.indexOf(P);if(T===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,S[T]=void 0;const q=this.u.current===this;if(this.w*v<=S.length){let O=0;for(let y=0;y<S.length;y++)S[y]?S[O++]=S[y]:q&&(this.u.end--,O<this.u.i&&this.u.i--);S.length=O}}y(P,S){if(!P)return;const T=this.f?.onListenerError||D.$1;if(!T){P.value(S);return}try{P.value(S)}catch(q){T(q)}}z(P){const S=P.current.t;for(;P.i<P.end;)this.y(S[P.i++],P.value);P.reset()}fire(P){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof R)this.y(this.t,P);else{const S=this.u;S.enqueue(this,P,this.t.length),this.z(S)}this.j?.stop()}hasListeners(){return this.w>0}}t.$Sd=u;const o=()=>new c;t.$Td=o;class c{constructor(){this.i=-1,this.end=0}enqueue(P,S,T){this.i=0,this.end=T,this.current=P,this.value=S}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends u{async fireAsync(P,S,T){if(this.t)for(this.h||(this.h=new f.$3c),$(this.t,q=>this.h.push([q.value,P]));this.h.size>0&&!S.isCancellationRequested;){const[q,O]=this.h.shift(),y=[],V={...O,token:S,waitUntil:H=>{if(Object.isFrozen(y))throw new Error("waitUntil can NOT be called asynchronous");T&&(H=T(H,q)),y.push(H)}};try{q(V)}catch(H){(0,D.$1)(H);continue}Object.freeze(y),await Promise.allSettled(y).then(H=>{for(const x of H)x.status==="rejected"&&(0,D.$1)(x.reason)})}}}t.$Ud=i;class a extends u{get isPaused(){return this.h!==0}constructor(P){super(P),this.h=0,this.s=new f.$3c,this.A=P?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const P=Array.from(this.s);this.s.clear(),super.fire(this.A(P))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(P){this.w&&(this.h!==0?this.s.push(P):super.fire(P))}}t.$Vd=a;class L extends a{constructor(P){super(P),this.k=P.delay??100}fire(P){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(P)}}t.$Wd=L;class d extends u{constructor(P){super(P),this.h=[],this.k=P?.merge}fire(P){this.hasListeners()&&(this.h.push(P),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(S=>super.fire(S)),this.h=[]}))}}t.$Xd=d;class w{constructor(){this.g=!1,this.h=[],this.f=new u({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(P){const S={event:P,listener:null};this.h.push(S),this.g&&this.m(S);const T=()=>{this.g&&this.o(S);const q=this.h.indexOf(S);this.h.splice(q,1)};return(0,r.$Qc)((0,k.$db)(T))}j(){this.g=!0,this.h.forEach(P=>this.m(P))}k(){this.g=!1,this.h.forEach(P=>this.o(P))}m(P){P.listener=P.event(S=>this.f.fire(S))}o(P){P.listener&&P.listener.dispose(),P.listener=null}dispose(){this.f.dispose()}}t.$Yd=w;class M{constructor(P,S,T,q){this.f=new r.$Rc;const O=this.f.add(new w),y=this.f.add(new r.$2c);function V(H){y.set(H,O.add(q(H)))}for(const H of P)V(H);this.f.add(S(H=>{V(H)})),this.f.add(T(H=>{y.deleteAndDispose(H)})),this.event=O.event}dispose(){this.f.dispose()}}t.$Zd=M;class p{constructor(){this.f=[]}wrapEvent(P){return(S,T,q)=>P(O=>{const y=this.f[this.f.length-1];y?y.push(()=>S.call(T,O)):S.call(T,O)},void 0,q)}bufferEvents(P){const S=[];this.f.push(S);const T=P();return this.f.pop(),S.forEach(q=>q()),T}}t.$1d=p;class F{constructor(){this.f=!1,this.g=s.None,this.h=r.$Sc.None,this.j=new u({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(P){this.g=P,this.f&&(this.h.dispose(),this.h=P(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$2d=F}),ne(ie[24],se([0,1,11]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3d=t.CancellationToken=void 0;const k=Object.freeze(function(h,l){const s=setTimeout(h.bind(l),0);return{dispose(){clearTimeout(s)}}});var r;(function(h){function l(s){return s===h.None||s===h.Cancelled||s instanceof f?!0:!s||typeof s!="object"?!1:typeof s.isCancellationRequested=="boolean"&&typeof s.onCancellationRequested=="function"}h.isCancellationToken=l,h.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),h.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(r||(t.CancellationToken=r={}));class f{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?k:(this.b||(this.b=new D.$Sd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class N{constructor(l){this.f=void 0,this.g=void 0,this.g=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new f),this.f}cancel(){this.f?this.f instanceof f&&this.f.cancel():this.f=r.Cancelled}dispose(l=!1){l&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof f&&this.f.dispose():this.f=r.None}}t.$3d=N}),ne(ie[39],se([0,1,24]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$De=t.$Ce=t.$Be=void 0;class k{constructor(h){this.b=h,this.a=null}get(){if(this.a)return this.a;const h=new D.$3d,l=this.b(h.token);return this.a={promise:l,dispose:()=>{this.a=null,h.cancel(),h.dispose()}},this.a}}t.$Be=k;class r{constructor(h){this.c=h,this.a=void 0,this.b=void 0}get(h){const l=JSON.stringify(h);return this.b!==l&&(this.b=l,this.a=this.c(h)),this.a}}t.$Ce=r;class f{get cachedValues(){return this.a}constructor(h){this.b=h,this.a=new Map}get(h){if(this.a.has(h))return this.a.get(h);const l=this.b(h);return this.a.set(h,l),l}}t.$De=f}),ne(ie[7],se([0,1,39,38]),function(j,t,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ef=t.$Df=t.$Cf=t.$Bf=t.GraphemeBreakType=t.$Af=t.$zf=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=t.$Ge=void 0;function r(I){return!I||typeof I!="string"?!0:I.trim().length===0}t.$Ge=r;const f=/{(\d+)}/g;function N(I,...B){return B.length===0?I:I.replace(f,function(z,Q){const ue=parseInt(Q,10);return isNaN(ue)||ue<0||ue>=B.length?z:B[ue]})}t.$He=N;const h=/{([^}]+)}/g;function l(I,B){return Object.keys(B).length===0?I:I.replace(h,(z,Q)=>B[Q]??z)}t.$Ie=l;function s(I){return I.replace(/[<>"'&]/g,B=>{switch(B){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return B})}t.$Je=s;function g(I){return I.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}t.$Ke=g;function A(I){return I.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Le=A;function b(I,B){let z=0;const Q=B.charCodeAt(0);for(let ue=I.length-1;ue>=0;ue--)I.charCodeAt(ue)===Q&&z++;return z}t.$Me=b;function m(I,B,z="\u2026"){return I.length<=B?I:`${I.substr(0,B)}${z}`}t.$Ne=m;function e(I,B,z="\u2026"){if(I.length<=B)return I;const Q=Math.ceil(B/2)-z.length/2,ue=Math.floor(B/2)-z.length/2;return`${I.substr(0,Q)}${z}${I.substr(I.length-ue)}`}t.$Oe=e;function E(I,B=" "){const z=R(I,B);return v(z,B)}t.$Pe=E;function R(I,B){if(!I||!B)return I;const z=B.length;if(z===0||I.length===0)return I;let Q=0;for(;I.indexOf(B,Q)===Q;)Q=Q+z;return I.substring(Q)}t.$Qe=R;function v(I,B){if(!I||!B)return I;const z=B.length,Q=I.length;if(z===0||Q===0)return I;let ue=Q,ce=-1;for(;ce=I.lastIndexOf(B,ue-1),!(ce===-1||ce+z!==ue);){if(ce===0)return"";ue=ce}return I.substring(0,ue)}t.$Re=v;function $(I){return I.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$Se=$;function u(I){return I.replace(/\*/g,"")}t.$Te=u;function o(I,B,z={}){if(!I)throw new Error("Cannot create regex from empty string");B||(I=A(I)),z.wholeWord&&(/\B/.test(I.charAt(0))||(I="\\b"+I),/\B/.test(I.charAt(I.length-1))||(I=I+"\\b"));let Q="";return z.global&&(Q+="g"),z.matchCase||(Q+="i"),z.multiline&&(Q+="m"),z.unicode&&(Q+="u"),new RegExp(I,Q)}t.$Ue=o;function c(I){return I.source==="^"||I.source==="^$"||I.source==="$"||I.source==="^\\s*$"?!1:!!(I.exec("")&&I.lastIndex===0)}t.$Ve=c;function i(I){return I.split(/\r\n|\r|\n/)}t.$We=i;function a(I){for(let B=0,z=I.length;B<z;B++){const Q=I.charCodeAt(B);if(Q!==32&&Q!==9)return B}return-1}t.$Xe=a;function L(I,B=0,z=I.length){for(let Q=B;Q<z;Q++){const ue=I.charCodeAt(Q);if(ue!==32&&ue!==9)return I.substring(B,Q)}return I.substring(B,z)}t.$Ye=L;function d(I,B=I.length-1){for(let z=B;z>=0;z--){const Q=I.charCodeAt(z);if(Q!==32&&Q!==9)return z}return-1}t.$Ze=d;function w(I,B,z){const Q=[];let ue=0;for(const ce of I.matchAll(B)){if(Q.push(I.slice(ue,ce.index)),ce.index===void 0)throw new Error("match.index should be defined");ue=ce.index+ce[0].length,Q.push(z(ce[0],...ce.slice(1),ce.index,I,ce.groups))}return Q.push(I.slice(ue)),Promise.all(Q).then(ce=>ce.join(""))}t.$1e=w;function M(I,B){return I<B?-1:I>B?1:0}t.$2e=M;function p(I,B,z=0,Q=I.length,ue=0,ce=B.length){for(;z<Q&&ue<ce;z++,ue++){const Ne=I.charCodeAt(z),Ee=B.charCodeAt(ue);if(Ne<Ee)return-1;if(Ne>Ee)return 1}const me=Q-z,pe=ce-ue;return me<pe?-1:me>pe?1:0}t.$3e=p;function F(I,B){return _(I,B,0,I.length,0,B.length)}t.$4e=F;function _(I,B,z=0,Q=I.length,ue=0,ce=B.length){for(;z<Q&&ue<ce;z++,ue++){let Ne=I.charCodeAt(z),Ee=B.charCodeAt(ue);if(Ne===Ee)continue;if(Ne>=128||Ee>=128)return p(I.toLowerCase(),B.toLowerCase(),z,Q,ue,ce);S(Ne)&&(Ne-=32),S(Ee)&&(Ee-=32);const be=Ne-Ee;if(be!==0)return be}const me=Q-z,pe=ce-ue;return me<pe?-1:me>pe?1:0}t.$5e=_;function P(I){return I>=48&&I<=57}t.$6e=P;function S(I){return I>=97&&I<=122}t.$7e=S;function T(I){return I>=65&&I<=90}t.$8e=T;function q(I,B){return I.length===B.length&&_(I,B)===0}t.$9e=q;function O(I,B){const z=B.length;return B.length>I.length?!1:_(I,B,0,z)===0}t.$0e=O;function y(I,B){const z=Math.min(I.length,B.length);let Q;for(Q=0;Q<z;Q++)if(I.charCodeAt(Q)!==B.charCodeAt(Q))return Q;return z}t.$$e=y;function V(I,B){const z=Math.min(I.length,B.length);let Q;const ue=I.length-1,ce=B.length-1;for(Q=0;Q<z;Q++)if(I.charCodeAt(ue-Q)!==B.charCodeAt(ce-Q))return Q;return z}t.$_e=V;function H(I){return 55296<=I&&I<=56319}t.$af=H;function x(I){return 56320<=I&&I<=57343}t.$bf=x;function Y(I,B){return(I-55296<<10)+(B-56320)+65536}t.$cf=Y;function te(I,B,z){const Q=I.charCodeAt(z);if(H(Q)&&z+1<B){const ue=I.charCodeAt(z+1);if(x(ue))return Y(Q,ue)}return Q}t.$df=te;function n(I,B){const z=I.charCodeAt(B-1);if(x(z)&&B>1){const Q=I.charCodeAt(B-2);if(H(Q))return Y(Q,z)}return z}class ae{get offset(){return this.e}constructor(B,z=0){this.c=B,this.d=B.length,this.e=z}setOffset(B){this.e=B}prevCodePoint(){const B=n(this.c,this.e);return this.e-=B>=65536?2:1,B}nextCodePoint(){const B=te(this.c,this.d,this.e);return this.e+=B>=65536?2:1,B}eol(){return this.e>=this.d}}t.$ef=ae;class he{get offset(){return this.c.offset}constructor(B,z=0){this.c=new ae(B,z)}nextGraphemeLength(){const B=Le.getInstance(),z=this.c,Q=z.offset;let ue=B.getGraphemeBreakType(z.nextCodePoint());for(;!z.eol();){const ce=z.offset,me=B.getGraphemeBreakType(z.nextCodePoint());if(De(ue,me)){z.setOffset(ce);break}ue=me}return z.offset-Q}prevGraphemeLength(){const B=Le.getInstance(),z=this.c,Q=z.offset;let ue=B.getGraphemeBreakType(z.prevCodePoint());for(;z.offset>0;){const ce=z.offset,me=B.getGraphemeBreakType(z.prevCodePoint());if(De(me,ue)){z.setOffset(ce);break}ue=me}return Q-z.offset}eol(){return this.c.eol()}}t.$ff=he;function $e(I,B){return new he(I,B).nextGraphemeLength()}t.$gf=$e;function ve(I,B){return new he(I,B).prevGraphemeLength()}t.$hf=ve;function Fe(I,B){B>0&&x(I.charCodeAt(B))&&B--;const z=B+$e(I,B);return[z-ve(I,z),z]}t.$if=Fe;function we(I){const B=new he(I);let z=0;for(;!B.eol();)z++,B.nextGraphemeLength();return z}t.$jf=we;let Re;function Se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ie(I){return Re||(Re=Se()),Re.test(I)}t.$kf=Ie;const qe=/^[\t\n\r\x20-\x7E]*$/;function Me(I){return qe.test(I)}t.$lf=Me,t.$mf=/[\u2028\u2029]/;function U(I){return t.$mf.test(I)}t.$nf=U;function C(I){return I>=11904&&I<=55215||I>=63744&&I<=64255||I>=65281&&I<=65374}t.$of=C;function W(I){return I>=127462&&I<=127487||I===8986||I===8987||I===9200||I===9203||I>=9728&&I<=10175||I===11088||I===11093||I>=127744&&I<=128591||I>=128640&&I<=128764||I>=128992&&I<=129008||I>=129280&&I<=129535||I>=129648&&I<=129782}t.$pf=W;function X(I,B,z=""){const Q=I.trimStart();if(Q.length<B)return Q;const ue=/\b/g;let ce=0;for(;ue.test(Q)&&!(Q.length-ue.lastIndex<B);)ce=ue.lastIndex,ue.lastIndex+=1;return ce===0?Q:z+Q.substring(ce).trimStart()}t.$qf=X;const K=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,G=/\x1b\].*?\x07/g;function Z(I){return I&&(I=I.replace(K,"").replace(G,"")),I}t.$rf=Z,t.$sf=String.fromCharCode(65279);function ee(I){return!!(I&&I.length>0&&I.charCodeAt(0)===65279)}t.$tf=ee;function J(I){return ee(I)?I.substr(1):I}t.$uf=J;function re(I,B){if(!I||!B||I.length<B.length)return!1;const z=B.length,Q=I.toLowerCase();let ue=0,ce=-1;for(;ue<z;){const me=Q.indexOf(B[ue],ce+1);if(me<0)return!1;ce=me,ue++}return!0}t.$vf=re;function le(I,B=!1){return I?(B&&(I=I.replace(/\\./g,"")),I.toLowerCase()!==I):!1}t.$wf=le;function oe(I){return I.charAt(0).toUpperCase()+I.slice(1)}t.$xf=oe;function de(I,B=1){if(B===0)return"";let z=-1;do z=I.indexOf(`
`,z+1),B--;while(B>0&&z>=0);return z===-1?I:(I[z-1]==="\r"&&z--,I.substr(0,z))}t.$yf=de;function ge(I){return I=I%(2*26),I<26?String.fromCharCode(97+I):String.fromCharCode(65+I-26)}t.$zf=ge;function ye(I){return Le.getInstance().getGraphemeBreakType(I)}t.$Af=ye;function De(I,B){return I===0?B!==5&&B!==7:I===2&&B===3?!1:I===4||I===2||I===3||B===4||B===2||B===3?!0:!(I===8&&(B===8||B===9||B===11||B===12)||(I===11||I===9)&&(B===9||B===10)||(I===12||I===10)&&B===10||B===5||B===13||B===7||I===1||I===13&&B===14||I===6&&B===6)}var ke;(function(I){I[I.Other=0]="Other",I[I.Prepend=1]="Prepend",I[I.CR=2]="CR",I[I.LF=3]="LF",I[I.Control=4]="Control",I[I.Extend=5]="Extend",I[I.Regional_Indicator=6]="Regional_Indicator",I[I.SpacingMark=7]="SpacingMark",I[I.L=8]="L",I[I.V=9]="V",I[I.T=10]="T",I[I.LV=11]="LV",I[I.LVT=12]="LVT",I[I.ZWJ=13]="ZWJ",I[I.Extended_Pictographic=14]="Extended_Pictographic"})(ke||(t.GraphemeBreakType=ke={}));class Le{static{this.c=null}static getInstance(){return Le.c||(Le.c=new Le),Le.c}constructor(){this.d=_e()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const z=this.d,Q=z.length/3;let ue=1;for(;ue<=Q;)if(B<z[3*ue])ue=2*ue;else if(B>z[3*ue+1])ue=2*ue+1;else return z[3*ue+2];return 0}}function _e(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Oe(I,B){if(I===0)return 0;const z=je(I,B);if(z!==void 0)return z;const Q=new ae(B,I);return Q.prevCodePoint(),Q.offset}t.$Bf=Oe;function je(I,B){const z=new ae(B,I);let Q=z.prevCodePoint();for(;ze(Q)||Q===65039||Q===8419;){if(z.offset===0)return;Q=z.prevCodePoint()}if(!W(Q))return;let ue=z.offset;return ue>0&&z.prevCodePoint()===8205&&(ue=z.offset),ue}function ze(I){return 127995<=I&&I<=127999}var We;(function(I){I[I.zwj=8205]="zwj",I[I.emojiVariantSelector=65039]="emojiVariantSelector",I[I.enclosingKeyCap=8419]="enclosingKeyCap"})(We||(We={})),t.$Cf="\xA0";class Te{static{this.c=new k.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$Ce(B=>{function z(be){const Pe=new Map;for(let Ae=0;Ae<be.length;Ae+=2)Pe.set(be[Ae],be[Ae+1]);return Pe}function Q(be,Pe){const Ae=new Map(be);for(const[Be,Ve]of Pe)Ae.set(Be,Ve);return Ae}function ue(be,Pe){if(!be)return Pe;const Ae=new Map;for(const[Be,Ve]of be)Pe.has(Be)&&Ae.set(Be,Ve);return Ae}const ce=this.c.value;let me=B.filter(be=>!be.startsWith("_")&&be in ce);me.length===0&&(me=["_default"]);let pe;for(const be of me){const Pe=z(ce[be]);pe=ue(pe,Pe)}const Ne=z(ce._common),Ee=Q(Ne,pe);return new Te(Ee)})}static getInstance(B){return Te.d.get(Array.from(B))}static{this.e=new k.$V(()=>Object.keys(Te.c.value).filter(B=>!B.startsWith("_")))}static getLocales(){return Te.e.value}constructor(B){this.f=B}isAmbiguous(B){return this.f.has(B)}getPrimaryConfusable(B){return this.f.get(B)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Df=Te;class Ue{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ue.c())),this.d}static isInvisibleCharacter(B){return Ue.e().has(B)}static get codePoints(){return Ue.e()}}t.$Ef=Ue}),ne(ie[40],se([0,1,7]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wi=t.$Vi=t.$Ui=t.$Ti=t.$Si=t.$Ri=t.$Qi=void 0;function k(v){return r(v,0)}t.$Qi=k;function r(v,$){switch(typeof v){case"object":return v===null?f(349,$):Array.isArray(v)?l(v,$):s(v,$);case"string":return h(v,$);case"boolean":return N(v,$);case"number":return f(v,$);case"undefined":return f(937,$);default:return f(617,$)}}t.$Ri=r;function f(v,$){return($<<5)-$+v|0}t.$Si=f;function N(v,$){return f(v?433:863,$)}function h(v,$){$=f(149417,$);for(let u=0,o=v.length;u<o;u++)$=f(v.charCodeAt(u),$);return $}t.$Ti=h;function l(v,$){return $=f(104579,$),v.reduce((u,o)=>r(o,u),$)}function s(v,$){return $=f(181387,$),Object.keys(v).sort().reduce((u,o)=>(u=h(o,u),r(v[o],u)),$)}class g{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=r($,this.g),this.g}}t.$Ui=g;var A;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function b(v,$,u=32){const o=u-$,c=~((1<<o)-1);return(v<<$|(c&v)>>>o)>>>0}function m(v,$=0,u=v.byteLength,o=0){for(let c=0;c<u;c++)v[$+c]=o}function e(v,$,u="0"){for(;v.length<$;)v=u+v;return v}function E(v,$=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(u=>u.toString(16).padStart(2,"0")).join(""):e((v>>>0).toString(16),$/4)}t.$Vi=E;class R{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const u=$.length;if(u===0)return;const o=this.p;let c=this.r,i=this.u,a,L;for(i!==0?(a=i,L=-1,i=0):(a=$.charCodeAt(0),L=0);;){let d=a;if(D.$af(a))if(L+1<u){const w=$.charCodeAt(L+1);D.$bf(w)?(L++,d=D.$cf(a,w)):d=65533}else{i=a;break}else D.$bf(a)&&(d=65533);if(c=this.w(o,c,d),L++,L<u)a=$.charCodeAt(L);else break}this.r=c,this.u=i}w($,u,o){return o<128?$[u++]=o:o<2048?($[u++]=192|(o&1984)>>>6,$[u++]=128|(o&63)>>>0):o<65536?($[u++]=224|(o&61440)>>>12,$[u++]=128|(o&4032)>>>6,$[u++]=128|(o&63)>>>0):($[u++]=240|(o&1835008)>>>18,$[u++]=128|(o&258048)>>>12,$[u++]=128|(o&4032)>>>6,$[u++]=128|(o&63)>>>0),u>=64&&(this.y(),u-=64,this.t+=64,$[0]=$[64+0],$[1]=$[64+1],$[2]=$[64+2]),u}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),E(this.h)+E(this.l)+E(this.m)+E(this.n)+E(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=R.g,u=this.q;for(let p=0;p<64;p+=4)$.setUint32(p,u.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)$.setUint32(p,b($.getUint32(p-12,!1)^$.getUint32(p-32,!1)^$.getUint32(p-56,!1)^$.getUint32(p-64,!1),1),!1);let o=this.h,c=this.l,i=this.m,a=this.n,L=this.o,d,w,M;for(let p=0;p<80;p++)p<20?(d=c&i|~c&a,w=1518500249):p<40?(d=c^i^a,w=1859775393):p<60?(d=c&i|c&a|i&a,w=2400959708):(d=c^i^a,w=3395469782),M=b(o,5)+d+L+w+$.getUint32(p*4,!1)&4294967295,L=a,a=i,i=b(c,30),c=o,o=M;this.h=this.h+o&4294967295,this.l=this.l+c&4294967295,this.m=this.m+i&4294967295,this.n=this.n+a&4294967295,this.o=this.o+L&4294967295}}t.$Wi=R}),ne(ie[25],se([0,1,36,40]),function(j,t,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Os=t.$Ns=t.$Ms=void 0;class r{constructor(b){this.a=b}getElements(){const b=this.a,m=new Int32Array(b.length);for(let e=0,E=b.length;e<E;e++)m[e]=b.charCodeAt(e);return m}}t.$Ms=r;function f(A,b,m){return new g(new r(A),new r(b)).ComputeDiff(m).changes}t.$Ns=f;class N{static Assert(b,m){if(!b)throw new Error(m)}}class h{static Copy(b,m,e,E,R){for(let v=0;v<R;v++)e[E+v]=b[m+v]}static Copy2(b,m,e,E,R){for(let v=0;v<R;v++)e[E+v]=b[m+v]}}var l;(function(A){A[A.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(l||(l={}));class s{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new D.$Ls(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(b,m){this.b=Math.min(this.b,b),this.c=Math.min(this.c,m),this.d++}AddModifiedElement(b,m){this.b=Math.min(this.b,b),this.c=Math.min(this.c,m),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class g{constructor(b,m,e=null){this.a=e,this.b=b,this.c=m;const[E,R,v]=g.o(b),[$,u,o]=g.o(m);this.d=v&&o,this.e=E,this.f=R,this.g=$,this.h=u,this.k=[],this.m=[]}static n(b){return b.length>0&&typeof b[0]=="string"}static o(b){const m=b.getElements();if(g.n(m)){const e=new Int32Array(m.length);for(let E=0,R=m.length;E<R;E++)e[E]=(0,k.$Ti)(m[E],0);return[m,e,!0]}return m instanceof Int32Array?[[],m,!1]:[[],new Int32Array(m),!1]}p(b,m){return this.f[b]!==this.h[m]?!1:this.d?this.e[b]===this.g[m]:!0}q(b,m){if(!this.p(b,m))return!1;const e=g.r(this.b,b),E=g.r(this.c,m);return e===E}static r(b,m){return typeof b.getStrictElement=="function"?b.getStrictElement(m):null}s(b,m){return this.f[b]!==this.f[m]?!1:this.d?this.e[b]===this.e[m]:!0}u(b,m){return this.h[b]!==this.h[m]?!1:this.d?this.g[b]===this.g[m]:!0}ComputeDiff(b){return this.v(0,this.f.length-1,0,this.h.length-1,b)}v(b,m,e,E,R){const v=[!1];let $=this.w(b,m,e,E,v);return R&&($=this.z($)),{quitEarly:v[0],changes:$}}w(b,m,e,E,R){for(R[0]=!1;b<=m&&e<=E&&this.p(b,e);)b++,e++;for(;m>=b&&E>=e&&this.p(m,E);)m--,E--;if(b>m||e>E){let i;return e<=E?(N.Assert(b===m+1,"originalStart should only be one more than originalEnd"),i=[new D.$Ls(b,0,e,E-e+1)]):b<=m?(N.Assert(e===E+1,"modifiedStart should only be one more than modifiedEnd"),i=[new D.$Ls(b,m-b+1,e,0)]):(N.Assert(b===m+1,"originalStart should only be one more than originalEnd"),N.Assert(e===E+1,"modifiedStart should only be one more than modifiedEnd"),i=[]),i}const v=[0],$=[0],u=this.y(b,m,e,E,v,$,R),o=v[0],c=$[0];if(u!==null)return u;if(!R[0]){const i=this.w(b,o,e,c,R);let a=[];return R[0]?a=[new D.$Ls(o+1,m-(o+1)+1,c+1,E-(c+1)+1)]:a=this.w(o+1,m,c+1,E,R),this.H(i,a)}return[new D.$Ls(b,m-b+1,e,E-e+1)]}x(b,m,e,E,R,v,$,u,o,c,i,a,L,d,w,M,p,F){let _=null,P=null,S=new s,T=m,q=e,O=L[0]-M[0]-E,y=-1073741824,V=this.k.length-1;do{const H=O+b;H===T||H<q&&o[H-1]<o[H+1]?(i=o[H+1],d=i-O-E,i<y&&S.MarkNextChange(),y=i,S.AddModifiedElement(i+1,d),O=H+1-b):(i=o[H-1]+1,d=i-O-E,i<y&&S.MarkNextChange(),y=i-1,S.AddOriginalElement(i,d+1),O=H-1-b),V>=0&&(o=this.k[V],b=o[0],T=1,q=o.length-1)}while(--V>=-1);if(_=S.getReverseChanges(),F[0]){let H=L[0]+1,x=M[0]+1;if(_!==null&&_.length>0){const Y=_[_.length-1];H=Math.max(H,Y.getOriginalEnd()),x=Math.max(x,Y.getModifiedEnd())}P=[new D.$Ls(H,a-H+1,x,w-x+1)]}else{S=new s,T=v,q=$,O=L[0]-M[0]-u,y=1073741824,V=p?this.m.length-1:this.m.length-2;do{const H=O+R;H===T||H<q&&c[H-1]>=c[H+1]?(i=c[H+1]-1,d=i-O-u,i>y&&S.MarkNextChange(),y=i+1,S.AddOriginalElement(i+1,d+1),O=H+1-R):(i=c[H-1],d=i-O-u,i>y&&S.MarkNextChange(),y=i,S.AddModifiedElement(i+1,d+1),O=H-1-R),V>=0&&(c=this.m[V],R=c[0],T=1,q=c.length-1)}while(--V>=-1);P=S.getChanges()}return this.H(_,P)}y(b,m,e,E,R,v,$){let u=0,o=0,c=0,i=0,a=0,L=0;b--,e--,R[0]=0,v[0]=0,this.k=[],this.m=[];const d=m-b+(E-e),w=d+1,M=new Int32Array(w),p=new Int32Array(w),F=E-e,_=m-b,P=b-e,S=m-E,q=(_-F)%2===0;M[F]=b,p[_]=m,$[0]=!1;for(let O=1;O<=d/2+1;O++){let y=0,V=0;c=this.J(F-O,O,F,w),i=this.J(F+O,O,F,w);for(let x=c;x<=i;x+=2){x===c||x<i&&M[x-1]<M[x+1]?u=M[x+1]:u=M[x-1]+1,o=u-(x-F)-P;const Y=u;for(;u<m&&o<E&&this.p(u+1,o+1);)u++,o++;if(M[x]=u,u+o>y+V&&(y=u,V=o),!q&&Math.abs(x-_)<=O-1&&u>=p[x])return R[0]=u,v[0]=o,Y<=p[x]&&1447>0&&O<=1447+1?this.x(F,c,i,P,_,a,L,S,M,p,u,m,R,o,E,v,q,$):null}const H=(y-b+(V-e)-O)/2;if(this.a!==null&&!this.a(y,H))return $[0]=!0,R[0]=y,v[0]=V,H>0&&1447>0&&O<=1447+1?this.x(F,c,i,P,_,a,L,S,M,p,u,m,R,o,E,v,q,$):(b++,e++,[new D.$Ls(b,m-b+1,e,E-e+1)]);a=this.J(_-O,O,_,w),L=this.J(_+O,O,_,w);for(let x=a;x<=L;x+=2){x===a||x<L&&p[x-1]>=p[x+1]?u=p[x+1]-1:u=p[x-1],o=u-(x-_)-S;const Y=u;for(;u>b&&o>e&&this.p(u,o);)u--,o--;if(p[x]=u,q&&Math.abs(x-F)<=O&&u<=M[x])return R[0]=u,v[0]=o,Y>=M[x]&&1447>0&&O<=1447+1?this.x(F,c,i,P,_,a,L,S,M,p,u,m,R,o,E,v,q,$):null}if(O<=1447){let x=new Int32Array(i-c+2);x[0]=F-c+1,h.Copy2(M,c,x,1,i-c+1),this.k.push(x),x=new Int32Array(L-a+2),x[0]=_-a+1,h.Copy2(p,a,x,1,L-a+1),this.m.push(x)}}return this.x(F,c,i,P,_,a,L,S,M,p,u,m,R,o,E,v,q,$)}z(b){for(let m=0;m<b.length;m++){const e=b[m],E=m<b.length-1?b[m+1].originalStart:this.f.length,R=m<b.length-1?b[m+1].modifiedStart:this.h.length,v=e.originalLength>0,$=e.modifiedLength>0;for(;e.originalStart+e.originalLength<E&&e.modifiedStart+e.modifiedLength<R&&(!v||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!$||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const o=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!o)break;e.originalStart++,e.modifiedStart++}const u=[null];if(m<b.length-1&&this.I(b[m],b[m+1],u)){b[m]=u[0],b.splice(m+1,1),m--;continue}}for(let m=b.length-1;m>=0;m--){const e=b[m];let E=0,R=0;if(m>0){const i=b[m-1];E=i.originalStart+i.originalLength,R=i.modifiedStart+i.modifiedLength}const v=e.originalLength>0,$=e.modifiedLength>0;let u=0,o=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let i=1;;i++){const a=e.originalStart-i,L=e.modifiedStart-i;if(a<E||L<R||v&&!this.s(a,a+e.originalLength)||$&&!this.u(L,L+e.modifiedLength))break;const w=(a===E&&L===R?5:0)+this.G(a,e.originalLength,L,e.modifiedLength);w>o&&(o=w,u=i)}e.originalStart-=u,e.modifiedStart-=u;const c=[null];if(m>0&&this.I(b[m-1],b[m],c)){b[m-1]=c[0],b.splice(m,1),m++;continue}}if(this.d)for(let m=1,e=b.length;m<e;m++){const E=b[m-1],R=b[m],v=R.originalStart-E.originalStart-E.originalLength,$=E.originalStart,u=R.originalStart+R.originalLength,o=u-$,c=E.modifiedStart,i=R.modifiedStart+R.modifiedLength,a=i-c;if(v<5&&o<20&&a<20){const L=this.A($,o,c,a,v);if(L){const[d,w]=L;(d!==E.originalStart+E.originalLength||w!==E.modifiedStart+E.modifiedLength)&&(E.originalLength=d-E.originalStart,E.modifiedLength=w-E.modifiedStart,R.originalStart=d+v,R.modifiedStart=w+v,R.originalLength=u-R.originalStart,R.modifiedLength=i-R.modifiedStart)}}}return b}A(b,m,e,E,R){if(m<R||E<R)return null;const v=b+m-R+1,$=e+E-R+1;let u=0,o=0,c=0;for(let i=b;i<v;i++)for(let a=e;a<$;a++){const L=this.B(i,a,R);L>0&&L>u&&(u=L,o=i,c=a)}return u>0?[o,c]:null}B(b,m,e){let E=0;for(let R=0;R<e;R++){if(!this.p(b+R,m+R))return 0;E+=this.e[b+R].length}return E}C(b){return b<=0||b>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[b])}D(b,m){if(this.C(b)||this.C(b-1))return!0;if(m>0){const e=b+m;if(this.C(e-1)||this.C(e))return!0}return!1}E(b){return b<=0||b>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[b])}F(b,m){if(this.E(b)||this.E(b-1))return!0;if(m>0){const e=b+m;if(this.E(e-1)||this.E(e))return!0}return!1}G(b,m,e,E){const R=this.D(b,m)?1:0,v=this.F(e,E)?1:0;return R+v}H(b,m){const e=[];if(b.length===0||m.length===0)return m.length>0?m:b;if(this.I(b[b.length-1],m[0],e)){const E=new Array(b.length+m.length-1);return h.Copy(b,0,E,0,b.length-1),E[b.length-1]=e[0],h.Copy(m,1,E,b.length,m.length-1),E}else{const E=new Array(b.length+m.length);return h.Copy(b,0,E,0,b.length),h.Copy(m,0,E,b.length,m.length),E}}I(b,m,e){if(N.Assert(b.originalStart<=m.originalStart,"Left change is not less than or equal to right change"),N.Assert(b.modifiedStart<=m.modifiedStart,"Left change is not less than or equal to right change"),b.originalStart+b.originalLength>=m.originalStart||b.modifiedStart+b.modifiedLength>=m.modifiedStart){const E=b.originalStart;let R=b.originalLength;const v=b.modifiedStart;let $=b.modifiedLength;return b.originalStart+b.originalLength>=m.originalStart&&(R=m.originalStart+m.originalLength-b.originalStart),b.modifiedStart+b.modifiedLength>=m.modifiedStart&&($=m.modifiedStart+m.modifiedLength-b.modifiedStart),e[0]=new D.$Ls(E,R,v,$),!0}else return e[0]=null,!1}J(b,m,e,E){if(b>=0&&b<E)return b;const R=e,v=E-e-1,$=m%2===0;if(b<0){const u=R%2===0;return $===u?0:1}else{const u=v%2===0;return $===u?E-1:E-2}}}t.$Os=g}),ne(ie[26],se([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wf=t.$Vf=t.$Uf=t.$Tf=t.$Sf=t.$Rf=t.$Qf=t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=void 0;function D(c){return typeof c=="string"}t.$Ff=D;function k(c){return Array.isArray(c)&&c.every(i=>D(i))}t.$Gf=k;function r(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}t.$Hf=r;function f(c){const i=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof i}t.$If=f;function N(c){return typeof c=="number"&&!isNaN(c)}t.$Jf=N;function h(c){return!!c&&typeof c[Symbol.iterator]=="function"}t.$Kf=h;function l(c){return c===!0||c===!1}t.$Lf=l;function s(c){return typeof c>"u"}t.$Mf=s;function g(c){return!A(c)}t.$Nf=g;function A(c){return s(c)||c===null}t.$Of=A;function b(c,i){if(!c)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}t.$Pf=b;function m(c){if(A(c))throw new Error("Assertion Failed: argument is undefined or null");return c}t.$Qf=m;function e(...c){const i=[];for(let a=0;a<c.length;a++){const L=c[a];if(A(L))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);i.push(L)}return i}t.$Rf=e;const E=Object.prototype.hasOwnProperty;function R(c){if(!r(c))return!1;for(const i in c)if(E.call(c,i))return!1;return!0}t.$Sf=R;function v(c){return typeof c=="function"}t.$Tf=v;function $(...c){return c.length>0&&c.every(v)}t.$Uf=$;function u(c,i){const a=Math.min(c.length,i.length);for(let L=0;L<a;L++)o(c[L],i[L])}t.$Vf=u;function o(c,i){if(D(i)){if(typeof c!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(v(i)){try{if(c instanceof i)return}catch{}if(!A(c)&&c.constructor===i||i.length===1&&i.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Wf=o}),ne(ie[41],se([0,1,26]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9j=t.$8j=t.$7j=void 0;const k=Object.create(null);function r(h,l){if((0,D.$Ff)(l)){const s=k[l];if(s===void 0)throw new Error(`${h} references an unknown codicon: ${l}`);l=s}return k[h]=l,{id:h}}function f(){return k}t.$7j=f;function N(){return Object.values(t.$9j)}t.$8j=N,t.$9j={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),thumbsDownFilled:r("thumbsdown-filled",60435),thumbsUpFilled:r("thumbsup-filled",60436),coffee:r("coffee",60437),snake:r("snake",60438),game:r("game",60439),vr:r("vr",60440),chip:r("chip",60441),piano:r("piano",60442),music:r("music",60443),micFilled:r("mic-filled",60444),gitFetch:r("git-fetch",60445),copilot:r("copilot",60446),lightbulbSparkle:r("lightbulb-sparkle",60447),lightbulbSparkleAutofix:r("lightbulb-sparkle-autofix",60447),robot:r("robot",60448),sparkleFilled:r("sparkle-filled",60449),diffSingle:r("diff-single",60450),diffMultiple:r("diff-multiple",60451),surroundWith:r("surround-with",60452),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),ne(ie[14],se([0,1,26]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$un=t.$tn=t.$sn=t.$rn=t.$qn=t.$pn=t.$on=t.$nn=t.$mn=t.$ln=t.$kn=t.$jn=void 0;function k(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const $=Array.isArray(v)?[]:{};return Object.entries(v).forEach(([u,o])=>{$[u]=o&&typeof o=="object"?k(o):o}),$}t.$jn=k;function r(v){if(!v||typeof v!="object")return v;const $=[v];for(;$.length>0;){const u=$.shift();Object.freeze(u);for(const o in u)if(f.call(u,o)){const c=u[o];typeof c=="object"&&!Object.isFrozen(c)&&!(0,D.$If)(c)&&$.push(c)}}return v}t.$kn=r;const f=Object.prototype.hasOwnProperty;function N(v,$){return h(v,$,new Set)}t.$ln=N;function h(v,$,u){if((0,D.$Of)(v))return v;const o=$(v);if(typeof o<"u")return o;if(Array.isArray(v)){const c=[];for(const i of v)c.push(h(i,$,u));return c}if((0,D.$Hf)(v)){if(u.has(v))throw new Error("Cannot clone recursive data-structure");u.add(v);const c={};for(const i in v)f.call(v,i)&&(c[i]=h(v[i],$,u));return u.delete(v),c}return v}function l(v,$,u=!0){return(0,D.$Hf)(v)?((0,D.$Hf)($)&&Object.keys($).forEach(o=>{o in v?u&&((0,D.$Hf)(v[o])&&(0,D.$Hf)($[o])?l(v[o],$[o],u):v[o]=$[o]):v[o]=$[o]}),v):$}t.$mn=l;function s(v,$){if(v===$)return!0;if(v==null||$===null||$===void 0||typeof v!=typeof $||typeof v!="object"||Array.isArray(v)!==Array.isArray($))return!1;let u,o;if(Array.isArray(v)){if(v.length!==$.length)return!1;for(u=0;u<v.length;u++)if(!s(v[u],$[u]))return!1}else{const c=[];for(o in v)c.push(o);c.sort();const i=[];for(o in $)i.push(o);if(i.sort(),!s(c,i))return!1;for(u=0;u<c.length;u++)if(!s(v[c[u]],$[c[u]]))return!1}return!0}t.$nn=s;function g(v){const $=new Set;return JSON.stringify(v,(u,o)=>{if((0,D.$Hf)(o)||Array.isArray(o)){if($.has(o))return"[Circular]";$.add(o)}return o})}t.$on=g;function A(v,$){const u=Object.create(null);return!v||!$||Object.keys($).forEach(c=>{const i=v[c],a=$[c];s(i,a)||(u[c]=a)}),u}t.$pn=A;function b(v,$){const u=$.toLowerCase(),o=Object.keys(v).find(c=>c.toLowerCase()===u);return o?v[o]:v[$]}t.$qn=b;function m(v,$){const u=Object.create(null);for(const[o,c]of Object.entries(v))$(o,c)&&(u[o]=c);return u}t.$rn=m;function e(v){let $=[];for(;Object.prototype!==v;)$=$.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return $}t.$sn=e;function E(v){const $=[];for(const u of e(v))typeof v[u]=="function"&&$.push(u);return $}t.$tn=E;function R(v,$){const u=c=>function(){const i=Array.prototype.slice.call(arguments,0);return $(c,i)},o={};for(const c of v)o[c]=u(c);return o}t.$un=R}),ne(ie[27],se([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fe=t.$Ee=t.Constants=void 0;var D;(function(f){f[f.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",f[f.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",f[f.MAX_UINT_8=255]="MAX_UINT_8",f[f.MAX_UINT_16=65535]="MAX_UINT_16",f[f.MAX_UINT_32=4294967295]="MAX_UINT_32",f[f.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(t.Constants=D={}));function k(f){return f<0?0:f>255?255:f|0}t.$Ee=k;function r(f){return f<0?0:f>4294967295?4294967295:f|0}t.$Fe=r}),ne(ie[28],se([0,1,27]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7s=t.$6s=void 0;class k{constructor(h){const l=(0,D.$Ee)(h);this.c=l,this.a=k.d(l),this.b=new Map}static d(h){const l=new Uint8Array(256);return l.fill(h),l}set(h,l){const s=(0,D.$Ee)(l);h>=0&&h<256?this.a[h]=s:this.b.set(h,s)}get(h){return h>=0&&h<256?this.a[h]:this.b.get(h)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$6s=k;var r;(function(N){N[N.False=0]="False",N[N.True=1]="True"})(r||(r={}));class f{constructor(){this.a=new k(0)}add(h){this.a.set(h,1)}has(h){return this.a.get(h)===1}clear(){return this.a.clear()}}t.$7s=f}),ne(ie[4],se([0,1,3]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qs=t.$Ps=void 0;class k{static addRange(N,h){let l=0;for(;l<h.length&&h[l].endExclusive<N.start;)l++;let s=l;for(;s<h.length&&h[s].start<=N.endExclusive;)s++;if(l===s)h.splice(l,0,N);else{const g=Math.min(N.start,h[l].start),A=Math.max(N.endExclusive,h[s-1].endExclusive);h.splice(l,s-l,new k(g,A))}}static tryCreate(N,h){if(!(N>h))return new k(N,h)}static ofLength(N){return new k(0,N)}static ofStartAndLength(N,h){return new k(N,N+h)}constructor(N,h){if(this.start=N,this.endExclusive=h,N>h)throw new D.$cb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(N){return new k(this.start+N,this.endExclusive+N)}deltaStart(N){return new k(this.start+N,this.endExclusive)}deltaEnd(N){return new k(this.start,this.endExclusive+N)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(N){return this.start===N.start&&this.endExclusive===N.endExclusive}containsRange(N){return this.start<=N.start&&N.endExclusive<=this.endExclusive}contains(N){return this.start<=N&&N<this.endExclusive}join(N){return new k(Math.min(this.start,N.start),Math.max(this.endExclusive,N.endExclusive))}intersect(N){const h=Math.max(this.start,N.start),l=Math.min(this.endExclusive,N.endExclusive);if(h<=l)return new k(h,l)}intersects(N){const h=Math.max(this.start,N.start),l=Math.min(this.endExclusive,N.endExclusive);return h<l}intersectsOrTouches(N){const h=Math.max(this.start,N.start),l=Math.min(this.endExclusive,N.endExclusive);return h<=l}isBefore(N){return this.endExclusive<=N.start}isAfter(N){return this.start>=N.endExclusive}slice(N){return N.slice(this.start,this.endExclusive)}clip(N){if(this.isEmpty)throw new D.$cb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,N))}clipCyclic(N){if(this.isEmpty)throw new D.$cb(`Invalid clipping range: ${this.toString()}`);return N<this.start?this.endExclusive-(this.start-N)%this.length:N>=this.endExclusive?this.start+(N-this.start)%this.length:N}map(N){const h=[];for(let l=this.start;l<this.endExclusive;l++)h.push(N(l));return h}forEach(N){for(let h=this.start;h<this.endExclusive;h++)N(h)}}t.$Ps=k;class r{constructor(){this.a=[]}addRange(N){let h=0;for(;h<this.a.length&&this.a[h].endExclusive<N.start;)h++;let l=h;for(;l<this.a.length&&this.a[l].start<=N.endExclusive;)l++;if(h===l)this.a.splice(h,0,N);else{const s=Math.min(N.start,this.a[h].start),g=Math.max(N.endExclusive,this.a[l-1].endExclusive);this.a.splice(h,l-h,new k(s,g))}}toString(){return this.a.map(N=>N.toString()).join(", ")}intersectsStrict(N){let h=0;for(;h<this.a.length&&this.a[h].endExclusive<=N.start;)h++;return h<this.a.length&&this.a[h].start<N.endExclusive}intersectWithRange(N){const h=new r;for(const l of this.a){const s=l.intersect(N);s&&h.addRange(s)}return h}intersectWithRangeLength(N){return this.intersectWithRange(N).length}get length(){return this.a.reduce((N,h)=>N+h.length,0)}}t.$Qs=r}),ne(ie[5],se([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hs=void 0;class D{constructor(r,f){this.lineNumber=r,this.column=f}with(r=this.lineNumber,f=this.column){return r===this.lineNumber&&f===this.column?this:new D(r,f)}delta(r=0,f=0){return this.with(this.lineNumber+r,this.column+f)}equals(r){return D.equals(this,r)}static equals(r,f){return!r&&!f?!0:!!r&&!!f&&r.lineNumber===f.lineNumber&&r.column===f.column}isBefore(r){return D.isBefore(this,r)}static isBefore(r,f){return r.lineNumber<f.lineNumber?!0:f.lineNumber<r.lineNumber?!1:r.column<f.column}isBeforeOrEqual(r){return D.isBeforeOrEqual(this,r)}static isBeforeOrEqual(r,f){return r.lineNumber<f.lineNumber?!0:f.lineNumber<r.lineNumber?!1:r.column<=f.column}static compare(r,f){const N=r.lineNumber|0,h=f.lineNumber|0;if(N===h){const l=r.column|0,s=f.column|0;return l-s}return N-h}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(r){return new D(r.lineNumber,r.column)}static isIPosition(r){return r&&typeof r.lineNumber=="number"&&typeof r.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}t.$Hs=D}),ne(ie[2],se([0,1,5]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Is=void 0;class k{constructor(f,N,h,l){f>h||f===h&&N>l?(this.startLineNumber=h,this.startColumn=l,this.endLineNumber=f,this.endColumn=N):(this.startLineNumber=f,this.startColumn=N,this.endLineNumber=h,this.endColumn=l)}isEmpty(){return k.isEmpty(this)}static isEmpty(f){return f.startLineNumber===f.endLineNumber&&f.startColumn===f.endColumn}containsPosition(f){return k.containsPosition(this,f)}static containsPosition(f,N){return!(N.lineNumber<f.startLineNumber||N.lineNumber>f.endLineNumber||N.lineNumber===f.startLineNumber&&N.column<f.startColumn||N.lineNumber===f.endLineNumber&&N.column>f.endColumn)}static strictContainsPosition(f,N){return!(N.lineNumber<f.startLineNumber||N.lineNumber>f.endLineNumber||N.lineNumber===f.startLineNumber&&N.column<=f.startColumn||N.lineNumber===f.endLineNumber&&N.column>=f.endColumn)}containsRange(f){return k.containsRange(this,f)}static containsRange(f,N){return!(N.startLineNumber<f.startLineNumber||N.endLineNumber<f.startLineNumber||N.startLineNumber>f.endLineNumber||N.endLineNumber>f.endLineNumber||N.startLineNumber===f.startLineNumber&&N.startColumn<f.startColumn||N.endLineNumber===f.endLineNumber&&N.endColumn>f.endColumn)}strictContainsRange(f){return k.strictContainsRange(this,f)}static strictContainsRange(f,N){return!(N.startLineNumber<f.startLineNumber||N.endLineNumber<f.startLineNumber||N.startLineNumber>f.endLineNumber||N.endLineNumber>f.endLineNumber||N.startLineNumber===f.startLineNumber&&N.startColumn<=f.startColumn||N.endLineNumber===f.endLineNumber&&N.endColumn>=f.endColumn)}plusRange(f){return k.plusRange(this,f)}static plusRange(f,N){let h,l,s,g;return N.startLineNumber<f.startLineNumber?(h=N.startLineNumber,l=N.startColumn):N.startLineNumber===f.startLineNumber?(h=N.startLineNumber,l=Math.min(N.startColumn,f.startColumn)):(h=f.startLineNumber,l=f.startColumn),N.endLineNumber>f.endLineNumber?(s=N.endLineNumber,g=N.endColumn):N.endLineNumber===f.endLineNumber?(s=N.endLineNumber,g=Math.max(N.endColumn,f.endColumn)):(s=f.endLineNumber,g=f.endColumn),new k(h,l,s,g)}intersectRanges(f){return k.intersectRanges(this,f)}static intersectRanges(f,N){let h=f.startLineNumber,l=f.startColumn,s=f.endLineNumber,g=f.endColumn;const A=N.startLineNumber,b=N.startColumn,m=N.endLineNumber,e=N.endColumn;return h<A?(h=A,l=b):h===A&&(l=Math.max(l,b)),s>m?(s=m,g=e):s===m&&(g=Math.min(g,e)),h>s||h===s&&l>g?null:new k(h,l,s,g)}equalsRange(f){return k.equalsRange(this,f)}static equalsRange(f,N){return!f&&!N?!0:!!f&&!!N&&f.startLineNumber===N.startLineNumber&&f.startColumn===N.startColumn&&f.endLineNumber===N.endLineNumber&&f.endColumn===N.endColumn}getEndPosition(){return k.getEndPosition(this)}static getEndPosition(f){return new D.$Hs(f.endLineNumber,f.endColumn)}getStartPosition(){return k.getStartPosition(this)}static getStartPosition(f){return new D.$Hs(f.startLineNumber,f.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(f,N){return new k(this.startLineNumber,this.startColumn,f,N)}setStartPosition(f,N){return new k(f,N,this.endLineNumber,this.endColumn)}collapseToStart(){return k.collapseToStart(this)}static collapseToStart(f){return new k(f.startLineNumber,f.startColumn,f.startLineNumber,f.startColumn)}collapseToEnd(){return k.collapseToEnd(this)}static collapseToEnd(f){return new k(f.endLineNumber,f.endColumn,f.endLineNumber,f.endColumn)}delta(f){return new k(this.startLineNumber+f,this.startColumn,this.endLineNumber+f,this.endColumn)}static fromPositions(f,N=f){return new k(f.lineNumber,f.column,N.lineNumber,N.column)}static lift(f){return f?new k(f.startLineNumber,f.startColumn,f.endLineNumber,f.endColumn):null}static isIRange(f){return f&&typeof f.startLineNumber=="number"&&typeof f.startColumn=="number"&&typeof f.endLineNumber=="number"&&typeof f.endColumn=="number"}static areIntersectingOrTouching(f,N){return!(f.endLineNumber<N.startLineNumber||f.endLineNumber===N.startLineNumber&&f.endColumn<N.startColumn||N.endLineNumber<f.startLineNumber||N.endLineNumber===f.startLineNumber&&N.endColumn<f.startColumn)}static areIntersecting(f,N){return!(f.endLineNumber<N.startLineNumber||f.endLineNumber===N.startLineNumber&&f.endColumn<=N.startColumn||N.endLineNumber<f.startLineNumber||N.endLineNumber===f.startLineNumber&&N.endColumn<=f.startColumn)}static compareRangesUsingStarts(f,N){if(f&&N){const s=f.startLineNumber|0,g=N.startLineNumber|0;if(s===g){const A=f.startColumn|0,b=N.startColumn|0;if(A===b){const m=f.endLineNumber|0,e=N.endLineNumber|0;if(m===e){const E=f.endColumn|0,R=N.endColumn|0;return E-R}return m-e}return A-b}return s-g}return(f?1:0)-(N?1:0)}static compareRangesUsingEnds(f,N){return f.endLineNumber===N.endLineNumber?f.endColumn===N.endColumn?f.startLineNumber===N.startLineNumber?f.startColumn-N.startColumn:f.startLineNumber-N.startLineNumber:f.endColumn-N.endColumn:f.endLineNumber-N.endLineNumber}static spansMultipleLines(f){return f.endLineNumber>f.startLineNumber}toJSON(){return this}}t.$Is=k}),ne(ie[42],se([0,1,2]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Js=void 0;class k{static insert(f,N){return{range:new D.$Is(f.lineNumber,f.column,f.lineNumber,f.column),text:N,forceMoveMarkers:!0}}static delete(f){return{range:f,text:null}}static replace(f,N){return{range:f,text:N}}static replaceMove(f,N){return{range:f,text:N,forceMoveMarkers:!0}}}t.$Js=k}),ne(ie[12],se([0,1,3,4,2,9]),function(j,t,D,k,r,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ss=t.$Rs=void 0;class N{static fromRange(s){return new N(s.startLineNumber,s.endLineNumber)}static fromRangeInclusive(s){return new N(s.startLineNumber,s.endLineNumber+1)}static subtract(s,g){return g?s.startLineNumber<g.startLineNumber&&g.endLineNumberExclusive<s.endLineNumberExclusive?[new N(s.startLineNumber,g.startLineNumber),new N(g.endLineNumberExclusive,s.endLineNumberExclusive)]:g.startLineNumber<=s.startLineNumber&&s.endLineNumberExclusive<=g.endLineNumberExclusive?[]:g.endLineNumberExclusive<s.endLineNumberExclusive?[new N(Math.max(g.endLineNumberExclusive,s.startLineNumber),s.endLineNumberExclusive)]:[new N(s.startLineNumber,Math.min(g.startLineNumber,s.endLineNumberExclusive))]:[s]}static joinMany(s){if(s.length===0)return[];let g=new h(s[0].slice());for(let A=1;A<s.length;A++)g=g.getUnion(new h(s[A].slice()));return g.ranges}static ofLength(s,g){return new N(s,s+g)}static deserialize(s){return new N(s[0],s[1])}constructor(s,g){if(s>g)throw new D.$cb(`startLineNumber ${s} cannot be after endLineNumberExclusive ${g}`);this.startLineNumber=s,this.endLineNumberExclusive=g}contains(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(s){return new N(this.startLineNumber+s,this.endLineNumberExclusive+s)}deltaLength(s){return new N(this.startLineNumber,this.endLineNumberExclusive+s)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(s){return new N(Math.min(this.startLineNumber,s.startLineNumber),Math.max(this.endLineNumberExclusive,s.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(s){const g=Math.max(this.startLineNumber,s.startLineNumber),A=Math.min(this.endLineNumberExclusive,s.endLineNumberExclusive);if(g<=A)return new N(g,A)}intersectsStrict(s){return this.startLineNumber<s.endLineNumberExclusive&&s.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(s){return this.startLineNumber<=s.endLineNumberExclusive&&s.startLineNumber<=this.endLineNumberExclusive}equals(s){return this.startLineNumber===s.startLineNumber&&this.endLineNumberExclusive===s.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new r.$Is(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new r.$Is(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(s){const g=[];for(let A=this.startLineNumber;A<this.endLineNumberExclusive;A++)g.push(s(A));return g}forEach(s){for(let g=this.startLineNumber;g<this.endLineNumberExclusive;g++)s(g)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}toOffsetRange(){return new k.$Ps(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$Rs=N;class h{constructor(s=[]){this.c=s}get ranges(){return this.c}addRange(s){if(s.length===0)return;const g=(0,f.$kb)(this.c,b=>b.endLineNumberExclusive>=s.startLineNumber),A=(0,f.$ib)(this.c,b=>b.startLineNumber<=s.endLineNumberExclusive)+1;if(g===A)this.c.splice(g,0,s);else if(g===A-1){const b=this.c[g];this.c[g]=b.join(s)}else{const b=this.c[g].join(this.c[A-1]).join(s);this.c.splice(g,A-g,b)}}contains(s){const g=(0,f.$hb)(this.c,A=>A.startLineNumber<=s);return!!g&&g.endLineNumberExclusive>s}intersects(s){const g=(0,f.$hb)(this.c,A=>A.startLineNumber<s.endLineNumberExclusive);return!!g&&g.endLineNumberExclusive>s.startLineNumber}getUnion(s){if(this.c.length===0)return s;if(s.c.length===0)return this;const g=[];let A=0,b=0,m=null;for(;A<this.c.length||b<s.c.length;){let e=null;if(A<this.c.length&&b<s.c.length){const E=this.c[A],R=s.c[b];E.startLineNumber<R.startLineNumber?(e=E,A++):(e=R,b++)}else A<this.c.length?(e=this.c[A],A++):(e=s.c[b],b++);m===null?m=e:m.endLineNumberExclusive>=e.startLineNumber?m=new N(m.startLineNumber,Math.max(m.endLineNumberExclusive,e.endLineNumberExclusive)):(g.push(m),m=e)}return m!==null&&g.push(m),new h(g)}subtractFrom(s){const g=(0,f.$kb)(this.c,e=>e.endLineNumberExclusive>=s.startLineNumber),A=(0,f.$ib)(this.c,e=>e.startLineNumber<=s.endLineNumberExclusive)+1;if(g===A)return new h([s]);const b=[];let m=s.startLineNumber;for(let e=g;e<A;e++){const E=this.c[e];E.startLineNumber>m&&b.push(new N(m,E.startLineNumber)),m=E.endLineNumberExclusive}return m<s.endLineNumberExclusive&&b.push(new N(m,s.endLineNumberExclusive)),new h(b)}toString(){return this.c.map(s=>s.toString()).join(", ")}getIntersection(s){const g=[];let A=0,b=0;for(;A<this.c.length&&b<s.c.length;){const m=this.c[A],e=s.c[b],E=m.intersect(e);E&&!E.isEmpty&&g.push(E),m.endLineNumberExclusive<e.endLineNumberExclusive?A++:b++}return new h(g)}getWithDelta(s){return new h(this.c.map(g=>g.delta(s)))}}t.$Ss=h}),ne(ie[43],se([0,1,5,2]),function(j,t,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ks=t.SelectionDirection=void 0;var r;(function(N){N[N.LTR=0]="LTR",N[N.RTL=1]="RTL"})(r||(t.SelectionDirection=r={}));class f extends k.$Is{constructor(h,l,s,g){super(h,l,s,g),this.selectionStartLineNumber=h,this.selectionStartColumn=l,this.positionLineNumber=s,this.positionColumn=g}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(h){return f.selectionsEqual(this,h)}static selectionsEqual(h,l){return h.selectionStartLineNumber===l.selectionStartLineNumber&&h.selectionStartColumn===l.selectionStartColumn&&h.positionLineNumber===l.positionLineNumber&&h.positionColumn===l.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(h,l){return this.getDirection()===0?new f(this.startLineNumber,this.startColumn,h,l):new f(h,l,this.startLineNumber,this.startColumn)}getPosition(){return new D.$Hs(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.$Hs(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(h,l){return this.getDirection()===0?new f(h,l,this.endLineNumber,this.endColumn):new f(this.endLineNumber,this.endColumn,h,l)}static fromPositions(h,l=h){return new f(h.lineNumber,h.column,l.lineNumber,l.column)}static fromRange(h,l){return l===0?new f(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):new f(h.endLineNumber,h.endColumn,h.startLineNumber,h.startColumn)}static liftSelection(h){return new f(h.selectionStartLineNumber,h.selectionStartColumn,h.positionLineNumber,h.positionColumn)}static selectionsArrEqual(h,l){if(h&&!l||!h&&l)return!1;if(!h&&!l)return!0;if(h.length!==l.length)return!1;for(let s=0,g=h.length;s<g;s++)if(!this.selectionsEqual(h[s],l[s]))return!1;return!0}static isISelection(h){return h&&typeof h.selectionStartLineNumber=="number"&&typeof h.selectionStartColumn=="number"&&typeof h.positionLineNumber=="number"&&typeof h.positionColumn=="number"}static createWithDirection(h,l,s,g,A){return A===0?new f(h,l,s,g):new f(s,g,h,l)}}t.$Ks=f}),ne(ie[44],se([0,1,28]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9s=t.$8s=t.WordCharacterClass=void 0;var k;(function(N){N[N.Regular=0]="Regular",N[N.Whitespace=1]="Whitespace",N[N.WordSeparator=2]="WordSeparator"})(k||(t.WordCharacterClass=k={}));class r extends D.$6s{constructor(h){super(0);for(let l=0,s=h.length;l<s;l++)this.set(h.charCodeAt(l),2);this.set(32,1),this.set(9,1)}}t.$8s=r;function f(N){const h={};return l=>(h.hasOwnProperty(l)||(h[l]=N(l)),h[l])}t.$9s=f(N=>new r(N))}),ne(ie[29],se([0,1,20,10,21]),function(j,t,D,k,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ks=t.$js=t.$is=t.$hs=t.$gs=void 0,t.$gs="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function f(A=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const m of t.$gs)A.indexOf(m)>=0||(b+="\\"+m);return b+="\\s]+)",new RegExp(b,"g")}t.$hs=f();function N(A){let b=t.$hs;if(A&&A instanceof RegExp)if(A.global)b=A;else{let m="g";A.ignoreCase&&(m+="i"),A.multiline&&(m+="m"),A.unicode&&(m+="u"),b=new RegExp(A.source,m)}return b.lastIndex=0,b}t.$is=N;const h=new r.$3c;h.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function l(A){const b=h.unshift(A);return(0,k.$Qc)(b)}t.$js=l;function s(A,b,m,e,E){if(b=N(b),E||(E=D.Iterable.first(h)),m.length>E.maxLen){let o=A-E.maxLen/2;return o<0?o=0:e+=o,m=m.substring(o,A+E.maxLen/2),s(A,b,m,e,E)}const R=Date.now(),v=A-1-e;let $=-1,u=null;for(let o=1;!(Date.now()-R>=E.timeBudget);o++){const c=v-E.windowSize*o;b.lastIndex=Math.max(0,c);const i=g(b,m,v,$);if(!i&&u||(u=i,c<=0))break;$=c}if(u){const o={word:u[0],startColumn:e+1+u.index,endColumn:e+1+u.index+u[0].length};return b.lastIndex=0,o}return null}t.$ks=s;function g(A,b,m,e){let E;for(;E=A.exec(b);){const R=E.index||0;if(R<=m&&A.lastIndex>=m)return E;if(e>0&&R>e)return null}return null}}),ne(ie[8],se([0,1,6,3,4]),function(j,t,D,k,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yZ=t.$xZ=t.$wZ=t.$vZ=t.$uZ=void 0;class f{static trivial(A,b){return new f([new N(r.$Ps.ofLength(A.length),r.$Ps.ofLength(b.length))],!1)}static trivialTimedOut(A,b){return new f([new N(r.$Ps.ofLength(A.length),r.$Ps.ofLength(b.length))],!0)}constructor(A,b){this.diffs=A,this.hitTimeout=b}}t.$uZ=f;class N{static invert(A,b){const m=[];return(0,D.$Bb)(A,(e,E)=>{m.push(N.fromOffsetPairs(e?e.getEndExclusives():h.zero,E?E.getStarts():new h(b,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+b)))}),m}static fromOffsetPairs(A,b){return new N(new r.$Ps(A.offset1,b.offset1),new r.$Ps(A.offset2,b.offset2))}constructor(A,b){this.seq1Range=A,this.seq2Range=b}swap(){return new N(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(A){return new N(this.seq1Range.join(A.seq1Range),this.seq2Range.join(A.seq2Range))}delta(A){return A===0?this:new N(this.seq1Range.delta(A),this.seq2Range.delta(A))}deltaStart(A){return A===0?this:new N(this.seq1Range.deltaStart(A),this.seq2Range.deltaStart(A))}deltaEnd(A){return A===0?this:new N(this.seq1Range.deltaEnd(A),this.seq2Range.deltaEnd(A))}intersectsOrTouches(A){return this.seq1Range.intersectsOrTouches(A.seq1Range)||this.seq2Range.intersectsOrTouches(A.seq2Range)}intersect(A){const b=this.seq1Range.intersect(A.seq1Range),m=this.seq2Range.intersect(A.seq2Range);if(!(!b||!m))return new N(b,m)}getStarts(){return new h(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new h(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.$vZ=N;class h{static{this.zero=new h(0,0)}static{this.max=new h(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(A,b){this.offset1=A,this.offset2=b}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(A){return A===0?this:new h(this.offset1+A,this.offset2+A)}}t.$wZ=h;class l{static{this.instance=new l}isValid(){return!0}}t.$xZ=l;class s{constructor(A){if(this.e=A,this.c=Date.now(),this.d=!0,A<=0)throw new k.$cb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}t.$yZ=s}),ne(ie[30],se([0,1,4,8]),function(j,t,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DZ=void 0;class r{compute(s,g,A=k.$xZ.instance){if(s.length===0||g.length===0)return k.$uZ.trivial(s,g);const b=s,m=g;function e(a,L){for(;a<b.length&&L<m.length&&b.getElement(a)===m.getElement(L);)a++,L++;return a}let E=0;const R=new N;R.set(0,e(0,0));const v=new h;v.set(0,R.get(0)===0?null:new f(null,0,0,R.get(0)));let $=0;e:for(;;){if(E++,!A.isValid())return k.$uZ.trivialTimedOut(b,m);const a=-Math.min(E,m.length+E%2),L=Math.min(E,b.length+E%2);for($=a;$<=L;$+=2){let d=0;const w=$===L?-1:R.get($+1),M=$===a?-1:R.get($-1)+1;d++;const p=Math.min(Math.max(w,M),b.length),F=p-$;if(d++,p>b.length||F>m.length)continue;const _=e(p,F);R.set($,_);const P=p===w?v.get($+1):v.get($-1);if(v.set($,_!==p?new f(P,p,F,_-p):P),R.get($)===b.length&&R.get($)-$===m.length)break e}}let u=v.get($);const o=[];let c=b.length,i=m.length;for(;;){const a=u?u.x+u.length:0,L=u?u.y+u.length:0;if((a!==c||L!==i)&&o.push(new k.$vZ(new D.$Ps(a,c),new D.$Ps(L,i))),!u)break;c=u.x,i=u.y,u=u.prev}return o.reverse(),new k.$uZ(o,!1)}}t.$DZ=r;class f{constructor(s,g,A,b){this.prev=s,this.x=g,this.y=A,this.length=b}}class N{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,g){if(s<0){if(s=-s-1,s>=this.b.length){const A=this.b;this.b=new Int32Array(A.length*2),this.b.set(A)}this.b[s]=g}else{if(s>=this.a.length){const A=this.a;this.a=new Int32Array(A.length*2),this.a.set(A)}this.a[s]=g}}}class h{constructor(){this.a=[],this.b=[]}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,g){s<0?(s=-s-1,this.b[s]=g):this.a[s]=g}}}),ne(ie[45],se([0,1,6,4,8]),function(j,t,D,k,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LZ=t.$KZ=t.$JZ=t.$IZ=t.$HZ=void 0;function f(e,E,R){let v=R;return v=N(e,E,v),v=N(e,E,v),v=h(e,E,v),v}t.$HZ=f;function N(e,E,R){if(R.length===0)return R;const v=[];v.push(R[0]);for(let u=1;u<R.length;u++){const o=v[v.length-1];let c=R[u];if(c.seq1Range.isEmpty||c.seq2Range.isEmpty){const i=c.seq1Range.start-o.seq1Range.endExclusive;let a;for(a=1;a<=i&&!(e.getElement(c.seq1Range.start-a)!==e.getElement(c.seq1Range.endExclusive-a)||E.getElement(c.seq2Range.start-a)!==E.getElement(c.seq2Range.endExclusive-a));a++);if(a--,a===i){v[v.length-1]=new r.$vZ(new k.$Ps(o.seq1Range.start,c.seq1Range.endExclusive-i),new k.$Ps(o.seq2Range.start,c.seq2Range.endExclusive-i));continue}c=c.delta(-a)}v.push(c)}const $=[];for(let u=0;u<v.length-1;u++){const o=v[u+1];let c=v[u];if(c.seq1Range.isEmpty||c.seq2Range.isEmpty){const i=o.seq1Range.start-c.seq1Range.endExclusive;let a;for(a=0;a<i&&!(!e.isStronglyEqual(c.seq1Range.start+a,c.seq1Range.endExclusive+a)||!E.isStronglyEqual(c.seq2Range.start+a,c.seq2Range.endExclusive+a));a++);if(a===i){v[u+1]=new r.$vZ(new k.$Ps(c.seq1Range.start+i,o.seq1Range.endExclusive),new k.$Ps(c.seq2Range.start+i,o.seq2Range.endExclusive));continue}a>0&&(c=c.delta(a))}$.push(c)}return v.length>0&&$.push(v[v.length-1]),$}function h(e,E,R){if(!e.getBoundaryScore||!E.getBoundaryScore)return R;for(let v=0;v<R.length;v++){const $=v>0?R[v-1]:void 0,u=R[v],o=v+1<R.length?R[v+1]:void 0,c=new k.$Ps($?$.seq1Range.endExclusive+1:0,o?o.seq1Range.start-1:e.length),i=new k.$Ps($?$.seq2Range.endExclusive+1:0,o?o.seq2Range.start-1:E.length);u.seq1Range.isEmpty?R[v]=l(u,e,E,c,i):u.seq2Range.isEmpty&&(R[v]=l(u.swap(),E,e,i,c).swap())}return R}function l(e,E,R,v,$){let o=1;for(;e.seq1Range.start-o>=v.start&&e.seq2Range.start-o>=$.start&&R.isStronglyEqual(e.seq2Range.start-o,e.seq2Range.endExclusive-o)&&o<100;)o++;o--;let c=0;for(;e.seq1Range.start+c<v.endExclusive&&e.seq2Range.endExclusive+c<$.endExclusive&&R.isStronglyEqual(e.seq2Range.start+c,e.seq2Range.endExclusive+c)&&c<100;)c++;if(o===0&&c===0)return e;let i=0,a=-1;for(let L=-o;L<=c;L++){const d=e.seq2Range.start+L,w=e.seq2Range.endExclusive+L,M=e.seq1Range.start+L,p=E.getBoundaryScore(M)+R.getBoundaryScore(d)+R.getBoundaryScore(w);p>a&&(a=p,i=L)}return e.delta(i)}function s(e,E,R){const v=[];for(const $ of R){const u=v[v.length-1];if(!u){v.push($);continue}$.seq1Range.start-u.seq1Range.endExclusive<=2||$.seq2Range.start-u.seq2Range.endExclusive<=2?v[v.length-1]=new r.$vZ(u.seq1Range.join($.seq1Range),u.seq2Range.join($.seq2Range)):v.push($)}return v}t.$IZ=s;function g(e,E,R){const v=r.$vZ.invert(R,e.length),$=[];let u=new r.$wZ(0,0);function o(i,a){if(i.offset1<u.offset1||i.offset2<u.offset2)return;const L=e.findWordContaining(i.offset1),d=E.findWordContaining(i.offset2);if(!L||!d)return;let w=new r.$vZ(L,d);const M=w.intersect(a);let p=M.seq1Range.length,F=M.seq2Range.length;for(;v.length>0;){const _=v[0];if(!(_.seq1Range.intersects(L)||_.seq2Range.intersects(d)))break;const S=e.findWordContaining(_.seq1Range.start),T=E.findWordContaining(_.seq2Range.start),q=new r.$vZ(S,T),O=q.intersect(_);if(p+=O.seq1Range.length,F+=O.seq2Range.length,w=w.join(q),w.seq1Range.endExclusive>=_.seq1Range.endExclusive)v.shift();else break}p+F<(w.seq1Range.length+w.seq2Range.length)*2/3&&$.push(new r.$vZ(L,d)),u=w.getEndExclusives()}for(;v.length>0;){const i=v.shift();i.seq1Range.isEmpty||(o(i.getStarts(),i),o(i.getEndExclusives().delta(-1),i))}return A(R,$)}t.$JZ=g;function A(e,E){const R=[];for(;e.length>0||E.length>0;){const v=e[0],$=E[0];let u;v&&(!$||v.seq1Range.start<$.seq1Range.start)?u=e.shift():u=E.shift(),R.length>0&&R[R.length-1].seq1Range.endExclusive>=u.seq1Range.start?R[R.length-1]=R[R.length-1].join(u):R.push(u)}return R}function b(e,E,R){let v=R;if(v.length===0)return v;let $=0,u;do{u=!1;const o=[v[0]];for(let c=1;c<v.length;c++){let L=function(w,M){const p=new k.$Ps(a.seq1Range.endExclusive,i.seq1Range.start);return e.getText(p).replace(/\s/g,"").length<=4&&(w.seq1Range.length+w.seq2Range.length>5||M.seq1Range.length+M.seq2Range.length>5)};const i=v[c],a=o[o.length-1];L(a,i)?(u=!0,o[o.length-1]=o[o.length-1].join(i)):o.push(i)}v=o}while($++<10&&u);return v}t.$KZ=b;function m(e,E,R){let v=R;if(v.length===0)return v;let $=0,u;do{u=!1;const c=[v[0]];for(let i=1;i<v.length;i++){let d=function(M,p){const F=new k.$Ps(L.seq1Range.endExclusive,a.seq1Range.start);if(e.countLinesIn(F)>5||F.length>500)return!1;const P=e.getText(F).trim();if(P.length>20||P.split(/\r\n|\r|\n/).length>1)return!1;const S=e.countLinesIn(M.seq1Range),T=M.seq1Range.length,q=E.countLinesIn(M.seq2Range),O=M.seq2Range.length,y=e.countLinesIn(p.seq1Range),V=p.seq1Range.length,H=E.countLinesIn(p.seq2Range),x=p.seq2Range.length,Y=2*40+50;function te(n){return Math.min(n,Y)}return Math.pow(Math.pow(te(S*40+T),1.5)+Math.pow(te(q*40+O),1.5),1.5)+Math.pow(Math.pow(te(y*40+V),1.5)+Math.pow(te(H*40+x),1.5),1.5)>(Y**1.5)**1.5*1.3};const a=v[i],L=c[c.length-1];d(L,a)?(u=!0,c[c.length-1]=c[c.length-1].join(a)):c.push(a)}v=c}while($++<10&&u);const o=[];return(0,D.$Cb)(v,(c,i,a)=>{let L=i;function d(P){return P.length>0&&P.trim().length<=3&&i.seq1Range.length+i.seq2Range.length>100}const w=e.extendToFullLines(i.seq1Range),M=e.getText(new k.$Ps(w.start,i.seq1Range.start));d(M)&&(L=L.deltaStart(-M.length));const p=e.getText(new k.$Ps(i.seq1Range.endExclusive,w.endExclusive));d(p)&&(L=L.deltaEnd(p.length));const F=r.$vZ.fromOffsetPairs(c?c.getEndExclusives():r.$wZ.zero,a?a.getStarts():r.$wZ.max),_=L.intersect(F);o.push(_)}),o}t.$LZ=m}),ne(ie[46],se([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GZ=void 0;class D{constructor(f,N){this.a=f,this.b=N}getElement(f){return this.a[f]}get length(){return this.a.length}getBoundaryScore(f){const N=f===0?0:k(this.b[f-1]),h=f===this.b.length?0:k(this.b[f]);return 1e3-(N+h)}getText(f){return this.b.slice(f.start,f.endExclusive).join(`
`)}isStronglyEqual(f,N){return this.b[f]===this.b[N]}}t.$GZ=D;function k(r){let f=0;for(;f<r.length&&(r.charCodeAt(f)===32||r.charCodeAt(f)===9);)f++;return f}}),ne(ie[15],se([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BZ=t.$AZ=t.$zZ=void 0;class D{constructor(N,h){this.width=N,this.height=h,this.a=[],this.a=new Array(N*h)}get(N,h){return this.a[N+h*this.width]}set(N,h,l){this.a[N+h*this.width]=l}}t.$zZ=D;function k(f){return f===32||f===9}t.$AZ=k;class r{static{this.a=new Map}static b(N){let h=this.a.get(N);return h===void 0&&(h=this.a.size,this.a.set(N,h)),h}constructor(N,h,l){this.range=N,this.lines=h,this.source=l,this.d=[];let s=0;for(let g=N.startLineNumber-1;g<N.endLineNumberExclusive-1;g++){const A=h[g];for(let m=0;m<A.length;m++){s++;const e=A[m],E=r.b(e);this.d[E]=(this.d[E]||0)+1}s++;const b=r.b(`
`);this.d[b]=(this.d[b]||0)+1}this.c=s}computeSimilarity(N){let h=0;const l=Math.max(this.d.length,N.d.length);for(let s=0;s<l;s++)h+=Math.abs((this.d[s]??0)-(N.d[s]??0));return 1-h/(this.c+N.c)}}t.$BZ=r}),ne(ie[47],se([0,1,4,8,15]),function(j,t,D,k,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CZ=void 0;class f{compute(h,l,s=k.$xZ.instance,g){if(h.length===0||l.length===0)return k.$uZ.trivial(h,l);const A=new r.$zZ(h.length,l.length),b=new r.$zZ(h.length,l.length),m=new r.$zZ(h.length,l.length);for(let o=0;o<h.length;o++)for(let c=0;c<l.length;c++){if(!s.isValid())return k.$uZ.trivialTimedOut(h,l);const i=o===0?0:A.get(o-1,c),a=c===0?0:A.get(o,c-1);let L;h.getElement(o)===l.getElement(c)?(o===0||c===0?L=0:L=A.get(o-1,c-1),o>0&&c>0&&b.get(o-1,c-1)===3&&(L+=m.get(o-1,c-1)),L+=g?g(o,c):1):L=-1;const d=Math.max(i,a,L);if(d===L){const w=o>0&&c>0?m.get(o-1,c-1):0;m.set(o,c,w+1),b.set(o,c,3)}else d===i?(m.set(o,c,0),b.set(o,c,1)):d===a&&(m.set(o,c,0),b.set(o,c,2));A.set(o,c,d)}const e=[];let E=h.length,R=l.length;function v(o,c){(o+1!==E||c+1!==R)&&e.push(new k.$vZ(new D.$Ps(o+1,E),new D.$Ps(c+1,R))),E=o,R=c}let $=h.length-1,u=l.length-1;for(;$>=0&&u>=0;)b.get($,u)===3?(v($,u),$--,u--):b.get($,u)===1?$--:u--;return v(-1,-1),e.reverse(),new k.$uZ(e,!1)}}t.$CZ=f}),ne(ie[31],se([0,1,9,4,5,2,15]),function(j,t,D,k,r,f,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$EZ=void 0;class h{constructor(e,E,R){this.lines=e,this.considerWhitespaceChanges=R,this.b=[],this.c=[],this.d=[];let v=!1;E.start>0&&E.endExclusive>=e.length&&(E=new k.$Ps(E.start-1,E.endExclusive),v=!0),this.lineRange=E,this.c[0]=0;for(let $=this.lineRange.start;$<this.lineRange.endExclusive;$++){let u=e[$],o=0;if(v)o=u.length,u="",v=!1;else if(!R){const c=u.trimStart();o=u.length-c.length,u=c.trimEnd()}this.d.push(o);for(let c=0;c<u.length;c++)this.b.push(u.charCodeAt(c));$<e.length-1&&(this.b.push(`
`.charCodeAt(0)),this.c[$-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new k.$Ps(0,this.length))}getText(e){return this.b.slice(e.start,e.endExclusive).map(E=>String.fromCharCode(E)).join("")}getElement(e){return this.b[e]}get length(){return this.b.length}getBoundaryScore(e){const E=b(e>0?this.b[e-1]:-1),R=b(e<this.b.length?this.b[e]:-1);if(E===7&&R===8)return 0;if(E===8)return 150;let v=0;return E!==R&&(v+=10,E===0&&R===1&&(v+=1)),v+=A(E),v+=A(R),v}translateOffset(e){if(this.lineRange.isEmpty)return new r.$Hs(this.lineRange.start+1,1);const E=(0,D.$ib)(this.c,R=>R<=e);return new r.$Hs(this.lineRange.start+E+1,e-this.c[E]+this.d[E]+1)}translateRange(e){return f.$Is.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.b.length||!l(this.b[e]))return;let E=e;for(;E>0&&l(this.b[E-1]);)E--;let R=e;for(;R<this.b.length&&l(this.b[R]);)R++;return new k.$Ps(E,R)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,E){return this.b[e]===this.b[E]}extendToFullLines(e){const E=(0,D.$hb)(this.c,v=>v<=e.start)??0,R=(0,D.$jb)(this.c,v=>e.endExclusive<=v)??this.b.length;return new k.$Ps(E,R)}}t.$EZ=h;function l(m){return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57}var s;(function(m){m[m.WordLower=0]="WordLower",m[m.WordUpper=1]="WordUpper",m[m.WordNumber=2]="WordNumber",m[m.End=3]="End",m[m.Other=4]="Other",m[m.Separator=5]="Separator",m[m.Space=6]="Space",m[m.LineBreakCR=7]="LineBreakCR",m[m.LineBreakLF=8]="LineBreakLF"})(s||(s={}));const g={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:30,[6]:3,[7]:10,[8]:10};function A(m){return g[m]}function b(m){return m===10?8:m===13?7:(0,N.$AZ)(m)?6:m>=97&&m<=122?0:m>=65&&m<=90?1:m>=48&&m<=57?2:m===-1?3:m===44||m===59?5:4}}),ne(ie[32],se([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xs=t.$Ws=void 0;class D{constructor(f,N,h){this.changes=f,this.moves=N,this.hitTimeout=h}}t.$Ws=D;class k{constructor(f,N){this.lineRangeMapping=f,this.changes=N}flip(){return new k(this.lineRangeMapping.flip(),this.changes.map(f=>f.flip()))}}t.$Xs=k}),ne(ie[16],se([0,1,12]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vs=t.$Us=t.$Ts=void 0;class k{static inverse(h,l,s){const g=[];let A=1,b=1;for(const e of h){const E=new r(new D.$Rs(A,e.original.startLineNumber),new D.$Rs(b,e.modified.startLineNumber),void 0);E.modified.isEmpty||g.push(E),A=e.original.endLineNumberExclusive,b=e.modified.endLineNumberExclusive}const m=new r(new D.$Rs(A,l+1),new D.$Rs(b,s+1),void 0);return m.modified.isEmpty||g.push(m),g}constructor(h,l){this.original=h,this.modified=l}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new k(this.modified,this.original)}join(h){return new k(this.original.join(h.original),this.modified.join(h.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}t.$Ts=k;class r extends k{constructor(h,l,s){super(h,l),this.innerChanges=s}flip(){return new r(this.modified,this.original,this.innerChanges?.map(h=>h.flip()))}}t.$Us=r;class f{constructor(h,l){this.originalRange=h,this.modifiedRange=l}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new f(this.modifiedRange,this.originalRange)}}t.$Vs=f}),ne(ie[48],se([0,1,8,16,6,9,22,12,4,31,15,30]),function(j,t,D,k,r,f,N,h,l,s,g,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FZ=void 0;function b(u,o,c,i,a,L){let{moves:d,excludedChanges:w}=e(u,o,c,L);if(!L.isValid())return[];const M=u.filter(F=>!w.has(F)),p=E(M,i,a,o,c,L);return(0,r.$1b)(d,p),d=v(d),d=d.filter(F=>{const _=F.original.toOffsetRange().slice(o).map(S=>S.trim());return _.join(`
`).length>=15&&m(_,S=>S.length>=2)>=2}),d=$(u,d),d}t.$FZ=b;function m(u,o){let c=0;for(const i of u)o(i)&&c++;return c}function e(u,o,c,i){const a=[],L=u.filter(M=>M.modified.isEmpty&&M.original.length>=3).map(M=>new g.$BZ(M.original,o,M)),d=new Set(u.filter(M=>M.original.isEmpty&&M.modified.length>=3).map(M=>new g.$BZ(M.modified,c,M))),w=new Set;for(const M of L){let p=-1,F;for(const _ of d){const P=M.computeSimilarity(_);P>p&&(p=P,F=_)}if(p>.9&&F&&(d.delete(F),a.push(new k.$Ts(M.range,F.range)),w.add(M.source),w.add(F.source)),!i.isValid())return{moves:a,excludedChanges:w}}return{moves:a,excludedChanges:w}}function E(u,o,c,i,a,L){const d=[],w=new N.$Gc;for(const P of u)for(let S=P.original.startLineNumber;S<P.original.endLineNumberExclusive-2;S++){const T=`${o[S-1]}:${o[S+1-1]}:${o[S+2-1]}`;w.add(T,{range:new h.$Rs(S,S+3)})}const M=[];u.sort((0,r.$7b)(P=>P.modified.startLineNumber,r.$9b));for(const P of u){let S=[];for(let T=P.modified.startLineNumber;T<P.modified.endLineNumberExclusive-2;T++){const q=`${c[T-1]}:${c[T+1-1]}:${c[T+2-1]}`,O=new h.$Rs(T,T+3),y=[];w.forEach(q,({range:V})=>{for(const x of S)if(x.originalLineRange.endLineNumberExclusive+1===V.endLineNumberExclusive&&x.modifiedLineRange.endLineNumberExclusive+1===O.endLineNumberExclusive){x.originalLineRange=new h.$Rs(x.originalLineRange.startLineNumber,V.endLineNumberExclusive),x.modifiedLineRange=new h.$Rs(x.modifiedLineRange.startLineNumber,O.endLineNumberExclusive),y.push(x);return}const H={modifiedLineRange:O,originalLineRange:V};M.push(H),y.push(H)}),S=y}if(!L.isValid())return[]}M.sort((0,r.$$b)((0,r.$7b)(P=>P.modifiedLineRange.length,r.$9b)));const p=new h.$Ss,F=new h.$Ss;for(const P of M){const S=P.modifiedLineRange.startLineNumber-P.originalLineRange.startLineNumber,T=p.subtractFrom(P.modifiedLineRange),q=F.subtractFrom(P.originalLineRange).getWithDelta(S),O=T.getIntersection(q);for(const y of O.ranges){if(y.length<3)continue;const V=y,H=y.delta(-S);d.push(new k.$Ts(H,V)),p.addRange(V),F.addRange(H)}}d.sort((0,r.$7b)(P=>P.original.startLineNumber,r.$9b));const _=new f.$mb(u);for(let P=0;P<d.length;P++){const S=d[P],T=_.findLastMonotonous(te=>te.original.startLineNumber<=S.original.startLineNumber),q=(0,f.$hb)(u,te=>te.modified.startLineNumber<=S.modified.startLineNumber),O=Math.max(S.original.startLineNumber-T.original.startLineNumber,S.modified.startLineNumber-q.modified.startLineNumber),y=_.findLastMonotonous(te=>te.original.startLineNumber<S.original.endLineNumberExclusive),V=(0,f.$hb)(u,te=>te.modified.startLineNumber<S.modified.endLineNumberExclusive),H=Math.max(y.original.endLineNumberExclusive-S.original.endLineNumberExclusive,V.modified.endLineNumberExclusive-S.modified.endLineNumberExclusive);let x;for(x=0;x<O;x++){const te=S.original.startLineNumber-x-1,n=S.modified.startLineNumber-x-1;if(te>i.length||n>a.length||p.contains(n)||F.contains(te)||!R(i[te-1],a[n-1],L))break}x>0&&(F.addRange(new h.$Rs(S.original.startLineNumber-x,S.original.startLineNumber)),p.addRange(new h.$Rs(S.modified.startLineNumber-x,S.modified.startLineNumber)));let Y;for(Y=0;Y<H;Y++){const te=S.original.endLineNumberExclusive+Y,n=S.modified.endLineNumberExclusive+Y;if(te>i.length||n>a.length||p.contains(n)||F.contains(te)||!R(i[te-1],a[n-1],L))break}Y>0&&(F.addRange(new h.$Rs(S.original.endLineNumberExclusive,S.original.endLineNumberExclusive+Y)),p.addRange(new h.$Rs(S.modified.endLineNumberExclusive,S.modified.endLineNumberExclusive+Y))),(x>0||Y>0)&&(d[P]=new k.$Ts(new h.$Rs(S.original.startLineNumber-x,S.original.endLineNumberExclusive+Y),new h.$Rs(S.modified.startLineNumber-x,S.modified.endLineNumberExclusive+Y)))}return d}function R(u,o,c){if(u.trim()===o.trim())return!0;if(u.length>300&&o.length>300)return!1;const a=new A.$DZ().compute(new s.$EZ([u],new l.$Ps(0,1),!1),new s.$EZ([o],new l.$Ps(0,1),!1),c);let L=0;const d=D.$vZ.invert(a.diffs,u.length);for(const F of d)F.seq1Range.forEach(_=>{(0,g.$AZ)(u.charCodeAt(_))||L++});function w(F){let _=0;for(let P=0;P<u.length;P++)(0,g.$AZ)(F.charCodeAt(P))||_++;return _}const M=w(u.length>o.length?u:o);return L/M>.6&&M>10}function v(u){if(u.length===0)return u;u.sort((0,r.$7b)(c=>c.original.startLineNumber,r.$9b));const o=[u[0]];for(let c=1;c<u.length;c++){const i=o[o.length-1],a=u[c],L=a.original.startLineNumber-i.original.endLineNumberExclusive,d=a.modified.startLineNumber-i.modified.endLineNumberExclusive;if(L>=0&&d>=0&&L+d<=2){o[o.length-1]=i.join(a);continue}o.push(a)}return o}function $(u,o){const c=new f.$mb(u);return o=o.filter(i=>{const a=c.findLastMonotonous(w=>w.original.startLineNumber<i.original.endLineNumberExclusive)||new k.$Ts(new h.$Rs(1,1),new h.$Rs(1,1)),L=(0,f.$hb)(u,w=>w.modified.startLineNumber<i.modified.endLineNumberExclusive);return a!==L}),o}}),ne(ie[49],se([0,1,6,13,12,4,2,8,47,30,48,45,32,16,31,46]),function(j,t,D,k,r,f,N,h,l,s,g,A,b,m,e,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OZ=t.$NZ=t.$MZ=void 0;class R{constructor(){this.e=new l.$CZ,this.f=new s.$DZ}computeDiff(o,c,i){if(o.length<=1&&(0,D.$ub)(o,c,(Y,te)=>Y===te))return new b.$Ws([],[],!1);if(o.length===1&&o[0].length===0||c.length===1&&c[0].length===0)return new b.$Ws([new m.$Us(new r.$Rs(1,o.length+1),new r.$Rs(1,c.length+1),[new m.$Vs(new N.$Is(1,1,o.length,o[0].length+1),new N.$Is(1,1,c.length,c[0].length+1))])],[],!1);const a=i.maxComputationTimeMs===0?h.$xZ.instance:new h.$yZ(i.maxComputationTimeMs),L=!i.ignoreTrimWhitespace,d=new Map;function w(Y){let te=d.get(Y);return te===void 0&&(te=d.size,d.set(Y,te)),te}const M=o.map(Y=>w(Y.trim())),p=c.map(Y=>w(Y.trim())),F=new E.$GZ(M,o),_=new E.$GZ(p,c),P=(()=>F.length+_.length<1700?this.e.compute(F,_,a,(Y,te)=>o[Y]===c[te]?c[te].length===0?.1:1+Math.log(1+c[te].length):.99):this.f.compute(F,_))();let S=P.diffs,T=P.hitTimeout;S=(0,A.$HZ)(F,_,S),S=(0,A.$KZ)(F,_,S);const q=[],O=Y=>{if(L)for(let te=0;te<Y;te++){const n=y+te,ae=V+te;if(o[n]!==c[ae]){const he=this.j(o,c,new h.$vZ(new f.$Ps(n,n+1),new f.$Ps(ae,ae+1)),a,L);for(const $e of he.mappings)q.push($e);he.hitTimeout&&(T=!0)}}};let y=0,V=0;for(const Y of S){(0,k.$7c)(()=>Y.seq1Range.start-y===Y.seq2Range.start-V);const te=Y.seq1Range.start-y;O(te),y=Y.seq1Range.endExclusive,V=Y.seq2Range.endExclusive;const n=this.j(o,c,Y,a,L);n.hitTimeout&&(T=!0);for(const ae of n.mappings)q.push(ae)}O(o.length-y);const H=v(q,o,c);let x=[];return i.computeMoves&&(x=this.h(H,o,c,M,p,a,L)),(0,k.$7c)(()=>{function Y(n,ae){if(n.lineNumber<1||n.lineNumber>ae.length)return!1;const he=ae[n.lineNumber-1];return!(n.column<1||n.column>he.length+1)}function te(n,ae){return!(n.startLineNumber<1||n.startLineNumber>ae.length+1||n.endLineNumberExclusive<1||n.endLineNumberExclusive>ae.length+1)}for(const n of H){if(!n.innerChanges)return!1;for(const ae of n.innerChanges)if(!(Y(ae.modifiedRange.getStartPosition(),c)&&Y(ae.modifiedRange.getEndPosition(),c)&&Y(ae.originalRange.getStartPosition(),o)&&Y(ae.originalRange.getEndPosition(),o)))return!1;if(!te(n.modified,c)||!te(n.original,o))return!1}return!0}),new b.$Ws(H,x,T)}h(o,c,i,a,L,d,w){return(0,g.$FZ)(o,c,i,a,L,d).map(F=>{const _=this.j(c,i,new h.$vZ(F.original.toOffsetRange(),F.modified.toOffsetRange()),d,w),P=v(_.mappings,c,i,!0);return new b.$Xs(F,P)})}j(o,c,i,a,L){const d=new e.$EZ(o,i.seq1Range,L),w=new e.$EZ(c,i.seq2Range,L),M=d.length+w.length<500?this.e.compute(d,w,a):this.f.compute(d,w,a);let p=M.diffs;return p=(0,A.$HZ)(d,w,p),p=(0,A.$JZ)(d,w,p),p=(0,A.$IZ)(d,w,p),p=(0,A.$LZ)(d,w,p),{mappings:p.map(_=>new m.$Vs(d.translateRange(_.seq1Range),w.translateRange(_.seq2Range))),hitTimeout:M.hitTimeout}}}t.$MZ=R;function v(u,o,c,i=!1){const a=[];for(const L of(0,D.$Ab)(u.map(d=>$(d,o,c)),(d,w)=>d.original.overlapOrTouch(w.original)||d.modified.overlapOrTouch(w.modified))){const d=L[0],w=L[L.length-1];a.push(new m.$Us(d.original.join(w.original),d.modified.join(w.modified),L.map(M=>M.innerChanges[0])))}return(0,k.$7c)(()=>!i&&a.length>0&&a[0].original.startLineNumber!==a[0].modified.startLineNumber?!1:(0,k.$8c)(a,(L,d)=>d.original.startLineNumber-L.original.endLineNumberExclusive===d.modified.startLineNumber-L.modified.endLineNumberExclusive&&L.original.endLineNumberExclusive<d.original.startLineNumber&&L.modified.endLineNumberExclusive<d.modified.startLineNumber)),a}t.$NZ=v;function $(u,o,c){let i=0,a=0;u.modifiedRange.endColumn===1&&u.originalRange.endColumn===1&&u.originalRange.startLineNumber+i<=u.originalRange.endLineNumber&&u.modifiedRange.startLineNumber+i<=u.modifiedRange.endLineNumber&&(a=-1),u.modifiedRange.startColumn-1>=c[u.modifiedRange.startLineNumber-1].length&&u.originalRange.startColumn-1>=o[u.originalRange.startLineNumber-1].length&&u.originalRange.startLineNumber<=u.originalRange.endLineNumber+a&&u.modifiedRange.startLineNumber<=u.modifiedRange.endLineNumber+a&&(i=1);const L=new r.$Rs(u.originalRange.startLineNumber+i,u.originalRange.endLineNumber+1+a),d=new r.$Rs(u.modifiedRange.startLineNumber+i,u.modifiedRange.endLineNumber+1+a);return new m.$Us(L,d,[u])}t.$OZ=$}),ne(ie[33],se([0,1,25,32,16,7,2,13,12]),function(j,t,D,k,r,f,N,h,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zs=t.$Ys=void 0;const s=3;class g{computeDiff(i,a,L){const w=new v(i,a,{maxComputationTime:L.maxComputationTimeMs,shouldIgnoreTrimWhitespace:L.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),M=[];let p=null;for(const F of w.changes){let _;F.originalEndLineNumber===0?_=new l.$Rs(F.originalStartLineNumber+1,F.originalStartLineNumber+1):_=new l.$Rs(F.originalStartLineNumber,F.originalEndLineNumber+1);let P;F.modifiedEndLineNumber===0?P=new l.$Rs(F.modifiedStartLineNumber+1,F.modifiedStartLineNumber+1):P=new l.$Rs(F.modifiedStartLineNumber,F.modifiedEndLineNumber+1);let S=new r.$Us(_,P,F.charChanges?.map(T=>new r.$Vs(new N.$Is(T.originalStartLineNumber,T.originalStartColumn,T.originalEndLineNumber,T.originalEndColumn),new N.$Is(T.modifiedStartLineNumber,T.modifiedStartColumn,T.modifiedEndLineNumber,T.modifiedEndColumn))));p&&(p.modified.endLineNumberExclusive===S.modified.startLineNumber||p.original.endLineNumberExclusive===S.original.startLineNumber)&&(S=new r.$Us(p.original.join(S.original),p.modified.join(S.modified),p.innerChanges&&S.innerChanges?p.innerChanges.concat(S.innerChanges):void 0),M.pop()),M.push(S),p=S}return(0,h.$7c)(()=>(0,h.$8c)(M,(F,_)=>_.original.startLineNumber-F.original.endLineNumberExclusive===_.modified.startLineNumber-F.modified.endLineNumberExclusive&&F.original.endLineNumberExclusive<_.original.startLineNumber&&F.modified.endLineNumberExclusive<_.modified.startLineNumber)),new k.$Ws(M,[],w.quitEarly)}}t.$Ys=g;function A(c,i,a,L){return new D.$Os(c,i,a).ComputeDiff(L)}class b{constructor(i){const a=[],L=[];for(let d=0,w=i.length;d<w;d++)a[d]=$(i[d],1),L[d]=u(i[d],1);this.lines=i,this.a=a,this.b=L}getElements(){const i=[];for(let a=0,L=this.lines.length;a<L;a++)i[a]=this.lines[a].substring(this.a[a]-1,this.b[a]-1);return i}getStrictElement(i){return this.lines[i]}getStartLineNumber(i){return i+1}getEndLineNumber(i){return i+1}createCharSequence(i,a,L){const d=[],w=[],M=[];let p=0;for(let F=a;F<=L;F++){const _=this.lines[F],P=i?this.a[F]:1,S=i?this.b[F]:_.length+1;for(let T=P;T<S;T++)d[p]=_.charCodeAt(T-1),w[p]=F+1,M[p]=T,p++;!i&&F<L&&(d[p]=10,w[p]=F+1,M[p]=_.length+1,p++)}return new m(d,w,M)}}class m{constructor(i,a,L){this.a=i,this.b=a,this.d=L}toString(){return"["+this.a.map((i,a)=>(i===10?"\\n":String.fromCharCode(i))+`-(${this.b[a]},${this.d[a]})`).join(", ")+"]"}e(i,a){if(i<0||i>=a.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(i){return i>0&&i===this.b.length?this.getEndLineNumber(i-1):(this.e(i,this.b),this.b[i])}getEndLineNumber(i){return i===-1?this.getStartLineNumber(i+1):(this.e(i,this.b),this.a[i]===10?this.b[i]+1:this.b[i])}getStartColumn(i){return i>0&&i===this.d.length?this.getEndColumn(i-1):(this.e(i,this.d),this.d[i])}getEndColumn(i){return i===-1?this.getStartColumn(i+1):(this.e(i,this.d),this.a[i]===10?1:this.d[i]+1)}}class e{constructor(i,a,L,d,w,M,p,F){this.originalStartLineNumber=i,this.originalStartColumn=a,this.originalEndLineNumber=L,this.originalEndColumn=d,this.modifiedStartLineNumber=w,this.modifiedStartColumn=M,this.modifiedEndLineNumber=p,this.modifiedEndColumn=F}static createFromDiffChange(i,a,L){const d=a.getStartLineNumber(i.originalStart),w=a.getStartColumn(i.originalStart),M=a.getEndLineNumber(i.originalStart+i.originalLength-1),p=a.getEndColumn(i.originalStart+i.originalLength-1),F=L.getStartLineNumber(i.modifiedStart),_=L.getStartColumn(i.modifiedStart),P=L.getEndLineNumber(i.modifiedStart+i.modifiedLength-1),S=L.getEndColumn(i.modifiedStart+i.modifiedLength-1);return new e(d,w,M,p,F,_,P,S)}}function E(c){if(c.length<=1)return c;const i=[c[0]];let a=i[0];for(let L=1,d=c.length;L<d;L++){const w=c[L],M=w.originalStart-(a.originalStart+a.originalLength),p=w.modifiedStart-(a.modifiedStart+a.modifiedLength);Math.min(M,p)<s?(a.originalLength=w.originalStart+w.originalLength-a.originalStart,a.modifiedLength=w.modifiedStart+w.modifiedLength-a.modifiedStart):(i.push(w),a=w)}return i}class R{constructor(i,a,L,d,w){this.originalStartLineNumber=i,this.originalEndLineNumber=a,this.modifiedStartLineNumber=L,this.modifiedEndLineNumber=d,this.charChanges=w}static createFromDiffResult(i,a,L,d,w,M,p){let F,_,P,S,T;if(a.originalLength===0?(F=L.getStartLineNumber(a.originalStart)-1,_=0):(F=L.getStartLineNumber(a.originalStart),_=L.getEndLineNumber(a.originalStart+a.originalLength-1)),a.modifiedLength===0?(P=d.getStartLineNumber(a.modifiedStart)-1,S=0):(P=d.getStartLineNumber(a.modifiedStart),S=d.getEndLineNumber(a.modifiedStart+a.modifiedLength-1)),M&&a.originalLength>0&&a.originalLength<20&&a.modifiedLength>0&&a.modifiedLength<20&&w()){const q=L.createCharSequence(i,a.originalStart,a.originalStart+a.originalLength-1),O=d.createCharSequence(i,a.modifiedStart,a.modifiedStart+a.modifiedLength-1);if(q.getElements().length>0&&O.getElements().length>0){let y=A(q,O,w,!0).changes;p&&(y=E(y)),T=[];for(let V=0,H=y.length;V<H;V++)T.push(e.createFromDiffChange(y[V],q,O))}}return new R(F,_,P,S,T)}}class v{constructor(i,a,L){this.a=L.shouldComputeCharChanges,this.b=L.shouldPostProcessCharChanges,this.d=L.shouldIgnoreTrimWhitespace,this.e=L.shouldMakePrettyDiff,this.f=i,this.g=a,this.h=new b(i),this.j=new b(a),this.k=o(L.maxComputationTime),this.l=o(L.maxComputationTime===0?0:Math.min(L.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const i=A(this.h,this.j,this.k,this.e),a=i.changes,L=i.quitEarly;if(this.d){const p=[];for(let F=0,_=a.length;F<_;F++)p.push(R.createFromDiffResult(this.d,a[F],this.h,this.j,this.l,this.a,this.b));return{quitEarly:L,changes:p}}const d=[];let w=0,M=0;for(let p=-1,F=a.length;p<F;p++){const _=p+1<F?a[p+1]:null,P=_?_.originalStart:this.f.length,S=_?_.modifiedStart:this.g.length;for(;w<P&&M<S;){const T=this.f[w],q=this.g[M];if(T!==q){{let O=$(T,1),y=$(q,1);for(;O>1&&y>1;){const V=T.charCodeAt(O-2),H=q.charCodeAt(y-2);if(V!==H)break;O--,y--}(O>1||y>1)&&this.m(d,w+1,1,O,M+1,1,y)}{let O=u(T,1),y=u(q,1);const V=T.length+1,H=q.length+1;for(;O<V&&y<H;){const x=T.charCodeAt(O-1),Y=T.charCodeAt(y-1);if(x!==Y)break;O++,y++}(O<V||y<H)&&this.m(d,w+1,O,V,M+1,y,H)}}w++,M++}_&&(d.push(R.createFromDiffResult(this.d,_,this.h,this.j,this.l,this.a,this.b)),w+=_.originalLength,M+=_.modifiedLength)}return{quitEarly:L,changes:d}}m(i,a,L,d,w,M,p){if(this.n(i,a,L,d,w,M,p))return;let F;this.a&&(F=[new e(a,L,a,d,w,M,w,p)]),i.push(new R(a,a,w,w,F))}n(i,a,L,d,w,M,p){const F=i.length;if(F===0)return!1;const _=i[F-1];return _.originalEndLineNumber===0||_.modifiedEndLineNumber===0?!1:_.originalEndLineNumber===a&&_.modifiedEndLineNumber===w?(this.a&&_.charChanges&&_.charChanges.push(new e(a,L,a,d,w,M,w,p)),!0):_.originalEndLineNumber+1===a&&_.modifiedEndLineNumber+1===w?(_.originalEndLineNumber=a,_.modifiedEndLineNumber=w,this.a&&_.charChanges&&_.charChanges.push(new e(a,L,a,d,w,M,w,p)),!0):!1}}t.$Zs=v;function $(c,i){const a=f.$Xe(c);return a===-1?i:a+1}function u(c,i){const a=f.$Ze(c);return a===-1?i:a+2}function o(c){if(c===0)return()=>!0;const i=Date.now();return()=>Date.now()-i<c}}),ne(ie[50],se([0,1,33,49]),function(j,t,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PZ=void 0,t.$PZ={getLegacy:()=>new D.$Ys,getDefault:()=>new k.$MZ}}),ne(ie[51],se([0,1,35]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QZ=void 0;function k(b){const m=[];for(const e of b){const E=Number(e);(E||E===0&&e.replace(/\s/g,"")!=="")&&m.push(E)}return m}function r(b,m,e,E){return{red:b/255,blue:e/255,green:m/255,alpha:E}}function f(b,m){const e=m.index,E=m[0].length;if(!e)return;const R=b.positionAt(e);return{startLineNumber:R.lineNumber,startColumn:R.column,endLineNumber:R.lineNumber,endColumn:R.column+E}}function N(b,m){if(!b)return;const e=D.$at.Format.CSS.parseHex(m);if(e)return{range:b,color:r(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function h(b,m,e){if(!b||m.length!==1)return;const R=m[0].values(),v=k(R);return{range:b,color:r(v[0],v[1],v[2],e?v[3]:1)}}function l(b,m,e){if(!b||m.length!==1)return;const R=m[0].values(),v=k(R),$=new D.$at(new D.$$s(v[0],v[1]/100,v[2]/100,e?v[3]:1));return{range:b,color:r($.rgba.r,$.rgba.g,$.rgba.b,$.rgba.a)}}function s(b,m){return typeof b=="string"?[...b.matchAll(m)]:b.findMatches(m)}function g(b){const m=[],E=s(b,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(E.length>0)for(const R of E){const v=R.filter(c=>c!==void 0),$=v[1],u=v[2];if(!u)continue;let o;if($==="rgb"){const c=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;o=h(f(b,R),s(u,c),!1)}else if($==="rgba"){const c=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;o=h(f(b,R),s(u,c),!0)}else if($==="hsl"){const c=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;o=l(f(b,R),s(u,c),!1)}else if($==="hsla"){const c=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;o=l(f(b,R),s(u,c),!0)}else $==="#"&&(o=N(f(b,R),$+u));o&&m.push(o)}return m}function A(b){return!b||typeof b.getValue!="function"||typeof b.positionAt!="function"?[]:g(b)}t.$QZ=A}),ne(ie[52],se([0,1,28]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qZ=t.$pZ=t.$oZ=t.State=void 0;var k;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(k||(t.State=k={}));class r{constructor(e,E,R){const v=new Uint8Array(e*E);for(let $=0,u=e*E;$<u;$++)v[$]=R;this.a=v,this.rows=e,this.cols=E}get(e,E){return this.a[e*this.cols+E]}set(e,E,R){this.a[e*this.cols+E]=R}}class f{constructor(e){let E=0,R=0;for(let $=0,u=e.length;$<u;$++){const[o,c,i]=e[$];c>E&&(E=c),o>R&&(R=o),i>R&&(R=i)}E++,R++;const v=new r(R,E,0);for(let $=0,u=e.length;$<u;$++){const[o,c,i]=e[$];v.set(o,c,i)}this.a=v,this.b=E}nextState(e,E){return E<0||E>=this.b?0:this.a.get(e,E)}}t.$oZ=f;let N=null;function h(){return N===null&&(N=new f([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),N}var l;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let s=null;function g(){if(s===null){s=new D.$6s(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let E=0;E<m.length;E++)s.set(m.charCodeAt(E),1);const e=".,;:";for(let E=0;E<e.length;E++)s.set(e.charCodeAt(E),2)}return s}class A{static a(e,E,R,v,$){let u=$-1;do{const o=E.charCodeAt(u);if(e.get(o)!==2)break;u--}while(u>v);if(v>0){const o=E.charCodeAt(v-1),c=E.charCodeAt(u);(o===40&&c===41||o===91&&c===93||o===123&&c===125)&&u--}return{range:{startLineNumber:R,startColumn:v+1,endLineNumber:R,endColumn:u+2},url:E.substring(v,u+1)}}static computeLinks(e,E=h()){const R=g(),v=[];for(let $=1,u=e.getLineCount();$<=u;$++){const o=e.getLineContent($),c=o.length;let i=0,a=0,L=0,d=1,w=!1,M=!1,p=!1,F=!1;for(;i<c;){let _=!1;const P=o.charCodeAt(i);if(d===13){let S;switch(P){case 40:w=!0,S=0;break;case 41:S=w?0:1;break;case 91:p=!0,M=!0,S=0;break;case 93:p=!1,S=M?0:1;break;case 123:F=!0,S=0;break;case 125:S=F?0:1;break;case 39:case 34:case 96:L===P?S=1:L===39||L===34||L===96?S=0:S=1;break;case 42:S=L===42?1:0;break;case 124:S=L===124?1:0;break;case 32:S=p?0:1;break;default:S=R.get(P)}S===1&&(v.push(A.a(R,o,$,a,i)),_=!0)}else if(d===12){let S;P===91?(M=!0,S=0):S=R.get(P),S===1?_=!0:d=13}else d=E.nextState(d,P),d===0&&(_=!0);_&&(d=1,w=!1,M=!1,F=!1,a=i+1,L=P),i++}d===13&&v.push(A.a(R,o,$,a,c))}return v}}t.$pZ=A;function b(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:A.computeLinks(m)}t.$qZ=b}),ne(ie[53],se([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rZ=void 0;class D{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new D}navigateValueSet(r,f,N,h,l){if(r&&f){const s=this.a(f,l);if(s)return{range:r,value:s}}if(N&&h){const s=this.a(h,l);if(s)return{range:N,value:s}}return null}a(r,f){const N=this.b(r,f);return N!==null?N:this.d(r,f)}b(r,f){const N=Math.pow(10,r.length-(r.lastIndexOf(".")+1));let h=Number(r);const l=parseFloat(r);return!isNaN(h)&&!isNaN(l)&&h===l?h===0&&!f?null:(h=Math.floor(h*N),h+=f?N:-N,String(h/N)):null}d(r,f){return this.e(this.c,r,f)}e(r,f,N){let h=null;for(let l=0,s=r.length;h===null&&l<s;l++)h=this.f(r[l],f,N);return h}f(r,f,N){let h=r.indexOf(f);return h>=0?(h+=N?1:-1,h<0?h=r.length-1:h%=r.length,r[h]):null}}t.$rZ=D}),ne(ie[54],se([0,1,14]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6u=t.$5u=t.$4u=t.$3u=t.ModelConstants=t.PositionAffinity=t.$2u=t.TrackedRangeStickiness=t.$1u=t.$Zu=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var k;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(k||(t.OverviewRulerLane=k={}));var r;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(r||(t.GlyphMarginLane=r={}));var f;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(f||(t.MinimapPosition=f={}));var N;(function(o){o[o.Both=0]="Both",o[o.Right=1]="Right",o[o.Left=2]="Left",o[o.None=3]="None"})(N||(t.InjectedTextCursorStops=N={}));var h;(function(o){o[o.TextDefined=0]="TextDefined",o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(h||(t.EndOfLinePreference=h={}));var l;(function(o){o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(l||(t.DefaultEndOfLine=l={}));var s;(function(o){o[o.LF=0]="LF",o[o.CRLF=1]="CRLF"})(s||(t.EndOfLineSequence=s={}));class g{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(c){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,c.tabSize|0),c.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,c.indentSize|0),this.a=!1),this.insertSpaces=!!c.insertSpaces,this.defaultEOL=c.defaultEOL|0,this.trimAutoWhitespace=!!c.trimAutoWhitespace,this.bracketPairColorizationOptions=c.bracketPairColorizationOptions}equals(c){return this.tabSize===c.tabSize&&this.a===c.a&&this.indentSize===c.indentSize&&this.insertSpaces===c.insertSpaces&&this.defaultEOL===c.defaultEOL&&this.trimAutoWhitespace===c.trimAutoWhitespace&&(0,D.$nn)(this.bracketPairColorizationOptions,c.bracketPairColorizationOptions)}createChangeEvent(c){return{tabSize:this.tabSize!==c.tabSize,indentSize:this.indentSize!==c.indentSize,insertSpaces:this.insertSpaces!==c.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==c.trimAutoWhitespace}}}t.$Zu=g;class A{constructor(c,i){this._findMatchBrand=void 0,this.range=c,this.matches=i}}t.$1u=A;var b;(function(o){o[o.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",o[o.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",o[o.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",o[o.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(b||(t.TrackedRangeStickiness=b={}));function m(o){return o&&typeof o.read=="function"}t.$2u=m;var e;(function(o){o[o.Left=0]="Left",o[o.Right=1]="Right",o[o.None=2]="None",o[o.LeftOfInjectedText=3]="LeftOfInjectedText",o[o.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var E;(function(o){o[o.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E||(t.ModelConstants=E={}));class R{constructor(c,i,a,L,d,w){this.identifier=c,this.range=i,this.text=a,this.forceMoveMarkers=L,this.isAutoWhitespaceEdit=d,this._isTracked=w}}t.$3u=R;class v{constructor(c,i,a){this.regex=c,this.wordSeparators=i,this.simpleSearch=a}}t.$4u=v;class ${constructor(c,i,a){this.reverseEdits=c,this.changes=i,this.trimAutoWhitespaceLineNumbers=a}}t.$5u=$;function u(o){return!o.isTooLargeForSyncing()&&!o.isForSimpleWidget}t.$6u=u}),ne(ie[55],se([0,1,6,27]),function(j,t,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$u=t.$0u=t.$9u=void 0;class r{constructor(l){this.a=l,this.b=new Uint32Array(l.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(l,s){l=(0,k.$Fe)(l);const g=this.a,A=this.b,b=s.length;return b===0?!1:(this.a=new Uint32Array(g.length+b),this.a.set(g.subarray(0,l),0),this.a.set(g.subarray(l),l+b),this.a.set(s,l),l-1<this.c[0]&&(this.c[0]=l-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(A.subarray(0,this.c[0]+1)),!0)}setValue(l,s){return l=(0,k.$Fe)(l),s=(0,k.$Fe)(s),this.a[l]===s?!1:(this.a[l]=s,l-1<this.c[0]&&(this.c[0]=l-1),!0)}removeValues(l,s){l=(0,k.$Fe)(l),s=(0,k.$Fe)(s);const g=this.a,A=this.b;if(l>=g.length)return!1;const b=g.length-l;return s>=b&&(s=b),s===0?!1:(this.a=new Uint32Array(g.length-s),this.a.set(g.subarray(0,l),0),this.a.set(g.subarray(l+s),l),this.b=new Uint32Array(this.a.length),l-1<this.c[0]&&(this.c[0]=l-1),this.c[0]>=0&&this.b.set(A.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(l){return l<0?0:(l=(0,k.$Fe)(l),this.d(l))}d(l){if(l<=this.c[0])return this.b[l];let s=this.c[0]+1;s===0&&(this.b[0]=this.a[0],s++),l>=this.a.length&&(l=this.a.length-1);for(let g=s;g<=l;g++)this.b[g]=this.b[g-1]+this.a[g];return this.c[0]=Math.max(this.c[0],l),this.b[l]}getIndexOf(l){l=Math.floor(l),this.getTotalSum();let s=0,g=this.a.length-1,A=0,b=0,m=0;for(;s<=g;)if(A=s+(g-s)/2|0,b=this.b[A],m=b-this.a[A],l<m)g=A-1;else if(l>=b)s=A+1;else break;return new N(A,l-m)}}t.$9u=r;class f{constructor(l){this.a=l,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(l){return this.g(),l===0?0:this.d[l-1]}getIndexOf(l){this.g();const s=this.e[l],g=s>0?this.d[s-1]:0;return new N(s,l-g)}removeValues(l,s){this.a.splice(l,s),this.f(l)}insertValues(l,s){this.a=(0,D.$Wb)(this.a,l,s),this.f(l)}f(l){this.b=!1,this.c=Math.min(this.c,l-1)}g(){if(!this.b){for(let l=this.c+1,s=this.a.length;l<s;l++){const g=this.a[l],A=l>0?this.d[l-1]:0;this.d[l]=A+g;for(let b=0;b<g;b++)this.e[A+b]=l}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(l,s){this.a[l]!==s&&(this.a[l]=s,this.f(l))}}t.$0u=f;class N{constructor(l,s){this.index=l,this.remainder=s,this._prefixSumIndexOfResultBrand=void 0,this.index=l,this.remainder=s}}t.$$u=N}),ne(ie[56],se([0,1,7,5,55]),function(j,t,D,k,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_u=void 0;class f{constructor(h,l,s,g){this.d=h,this.f=l,this.g=s,this.h=g,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(h){h.eol&&h.eol!==this.g&&(this.g=h.eol,this.j=null);const l=h.changes;for(const s of l)this.o(s.range),this.p(new k.$Hs(s.range.startLineNumber,s.range.startColumn),s.text);this.h=h.versionId,this.k=null}l(){if(!this.j){const h=this.g.length,l=this.f.length,s=new Uint32Array(l);for(let g=0;g<l;g++)s[g]=this.f[g].length+h;this.j=new r.$9u(s)}}n(h,l){this.f[h]=l,this.j&&this.j.setValue(h,this.f[h].length+this.g.length)}o(h){if(h.startLineNumber===h.endLineNumber){if(h.startColumn===h.endColumn)return;this.n(h.startLineNumber-1,this.f[h.startLineNumber-1].substring(0,h.startColumn-1)+this.f[h.startLineNumber-1].substring(h.endColumn-1));return}this.n(h.startLineNumber-1,this.f[h.startLineNumber-1].substring(0,h.startColumn-1)+this.f[h.endLineNumber-1].substring(h.endColumn-1)),this.f.splice(h.startLineNumber,h.endLineNumber-h.startLineNumber),this.j&&this.j.removeValues(h.startLineNumber,h.endLineNumber-h.startLineNumber)}p(h,l){if(l.length===0)return;const s=(0,D.$We)(l);if(s.length===1){this.n(h.lineNumber-1,this.f[h.lineNumber-1].substring(0,h.column-1)+s[0]+this.f[h.lineNumber-1].substring(h.column-1));return}s[s.length-1]+=this.f[h.lineNumber-1].substring(h.column-1),this.n(h.lineNumber-1,this.f[h.lineNumber-1].substring(0,h.column-1)+s[0]);const g=new Uint32Array(s.length-1);for(let A=1;A<s.length;A++)this.f.splice(h.lineNumber+A-1,0,s[A]),g[A-1]=s[A].length+this.g.length;this.j&&this.j.insertValues(h.lineNumber,g)}}t.$_u=f}),ne(ie[57],se([0,1,7,44,5,2,54]),function(j,t,D,k,r,f,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TB=t.$SB=t.$RB=t.$QB=t.$PB=t.$OB=void 0;const h=999;class l{constructor($,u,o,c){this.searchString=$,this.isRegex=u,this.matchCase=o,this.wordSeparators=c}parseSearchRequest(){if(this.searchString==="")return null;let $;this.isRegex?$=s(this.searchString):$=this.searchString.indexOf(`
`)>=0;let u=null;try{u=D.$Ue(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:$,global:!0,unicode:!0})}catch{return null}if(!u)return null;let o=!this.isRegex&&!$;return o&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(o=this.matchCase),new N.$4u(u,this.wordSeparators?(0,k.$9s)(this.wordSeparators):null,o?this.searchString:null)}}t.$OB=l;function s(v){if(!v||v.length===0)return!1;for(let $=0,u=v.length;$<u;$++){const o=v.charCodeAt($);if(o===10)return!0;if(o===92){if($++,$>=u)break;const c=v.charCodeAt($);if(c===110||c===114||c===87)return!0}}return!1}t.$PB=s;function g(v,$,u){if(!u)return new N.$1u(v,null);const o=[];for(let c=0,i=$.length;c<i;c++)o[c]=$[c];return new N.$1u(v,o)}t.$QB=g;class A{constructor($){const u=[];let o=0;for(let c=0,i=$.length;c<i;c++)$.charCodeAt(c)===10&&(u[o++]=c);this.a=u}findLineFeedCountBeforeOffset($){const u=this.a;let o=0,c=u.length-1;if(c===-1||$<=u[0])return 0;for(;o<c;){const i=o+((c-o)/2>>0);u[i]>=$?c=i-1:u[i+1]>=$?(o=i,c=i):o=i+1}return o+1}}class b{static findMatches($,u,o,c,i){const a=u.parseSearchRequest();return a?a.regex.multiline?this.b($,o,new R(a.wordSeparators,a.regex),c,i):this.c($,o,a,c,i):[]}static a($,u,o,c,i,a){let L,d=0;c?(d=c.findLineFeedCountBeforeOffset(i),L=u+i+d):L=u+i;let w;if(c){const _=c.findLineFeedCountBeforeOffset(i+a.length)-d;w=L+a.length+_}else w=L+a.length;const M=$.getPositionAt(L),p=$.getPositionAt(w);return new f.$Is(M.lineNumber,M.column,p.lineNumber,p.column)}static b($,u,o,c,i){const a=$.getOffsetAt(u.getStartPosition()),L=$.getValueInRange(u,1),d=$.getEOL()===`\r
`?new A(L):null,w=[];let M=0,p;for(o.reset(0);p=o.next(L);)if(w[M++]=g(this.a($,a,L,d,p.index,p[0]),p,c),M>=i)return w;return w}static c($,u,o,c,i){const a=[];let L=0;if(u.startLineNumber===u.endLineNumber){const w=$.getLineContent(u.startLineNumber).substring(u.startColumn-1,u.endColumn-1);return L=this.d(o,w,u.startLineNumber,u.startColumn-1,L,a,c,i),a}const d=$.getLineContent(u.startLineNumber).substring(u.startColumn-1);L=this.d(o,d,u.startLineNumber,u.startColumn-1,L,a,c,i);for(let w=u.startLineNumber+1;w<u.endLineNumber&&L<i;w++)L=this.d(o,$.getLineContent(w),w,0,L,a,c,i);if(L<i){const w=$.getLineContent(u.endLineNumber).substring(0,u.endColumn-1);L=this.d(o,w,u.endLineNumber,0,L,a,c,i)}return a}static d($,u,o,c,i,a,L,d){const w=$.wordSeparators;if(!L&&$.simpleSearch){const F=$.simpleSearch,_=F.length,P=u.length;let S=-_;for(;(S=u.indexOf(F,S+_))!==-1;)if((!w||E(w,u,P,S,_))&&(a[i++]=new N.$1u(new f.$Is(o,S+1+c,o,S+1+_+c),null),i>=d))return i;return i}const M=new R($.wordSeparators,$.regex);let p;M.reset(0);do if(p=M.next(u),p&&(a[i++]=g(new f.$Is(o,p.index+1+c,o,p.index+1+p[0].length+c),p,L),i>=d))return i;while(p);return i}static findNextMatch($,u,o,c){const i=u.parseSearchRequest();if(!i)return null;const a=new R(i.wordSeparators,i.regex);return i.regex.multiline?this.e($,o,a,c):this.f($,o,a,c)}static e($,u,o,c){const i=new r.$Hs(u.lineNumber,1),a=$.getOffsetAt(i),L=$.getLineCount(),d=$.getValueInRange(new f.$Is(i.lineNumber,i.column,L,$.getLineMaxColumn(L)),1),w=$.getEOL()===`\r
`?new A(d):null;o.reset(u.column-1);const M=o.next(d);return M?g(this.a($,a,d,w,M.index,M[0]),M,c):u.lineNumber!==1||u.column!==1?this.e($,new r.$Hs(1,1),o,c):null}static f($,u,o,c){const i=$.getLineCount(),a=u.lineNumber,L=$.getLineContent(a),d=this.g(o,L,a,u.column,c);if(d)return d;for(let w=1;w<=i;w++){const M=(a+w-1)%i,p=$.getLineContent(M+1),F=this.g(o,p,M+1,1,c);if(F)return F}return null}static g($,u,o,c,i){$.reset(c-1);const a=$.next(u);return a?g(new f.$Is(o,a.index+1,o,a.index+1+a[0].length),a,i):null}static findPreviousMatch($,u,o,c){const i=u.parseSearchRequest();if(!i)return null;const a=new R(i.wordSeparators,i.regex);return i.regex.multiline?this.h($,o,a,c):this.j($,o,a,c)}static h($,u,o,c){const i=this.b($,new f.$Is(1,1,u.lineNumber,u.column),o,c,10*h);if(i.length>0)return i[i.length-1];const a=$.getLineCount();return u.lineNumber!==a||u.column!==$.getLineMaxColumn(a)?this.h($,new r.$Hs(a,$.getLineMaxColumn(a)),o,c):null}static j($,u,o,c){const i=$.getLineCount(),a=u.lineNumber,L=$.getLineContent(a).substring(0,u.column-1),d=this.k(o,L,a,c);if(d)return d;for(let w=1;w<=i;w++){const M=(i+a-w-1)%i,p=$.getLineContent(M+1),F=this.k(o,p,M+1,c);if(F)return F}return null}static k($,u,o,c){let i=null,a;for($.reset(0);a=$.next(u);)i=g(new f.$Is(o,a.index+1,o,a.index+1+a[0].length),a,c);return i}}t.$RB=b;function m(v,$,u,o,c){if(o===0)return!0;const i=$.charCodeAt(o-1);if(v.get(i)!==0||i===13||i===10)return!0;if(c>0){const a=$.charCodeAt(o);if(v.get(a)!==0)return!0}return!1}function e(v,$,u,o,c){if(o+c===u)return!0;const i=$.charCodeAt(o+c);if(v.get(i)!==0||i===13||i===10)return!0;if(c>0){const a=$.charCodeAt(o+c-1);if(v.get(a)!==0)return!0}return!1}function E(v,$,u,o,c){return m(v,$,u,o,c)&&e(v,$,u,o,c)}t.$SB=E;class R{constructor($,u){this._wordSeparators=$,this.a=u,this.b=-1,this.c=0}reset($){this.a.lastIndex=$,this.b=-1,this.c=0}next($){const u=$.length;let o;do{if(this.b+this.c===u||(o=this.a.exec($),!o))return null;const c=o.index,i=o[0].length;if(c===this.b&&i===this.c){if(i===0){D.$df($,u,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=c,this.c=i,!this._wordSeparators||E(this._wordSeparators,$,u,c,i))return o}while(o);return null}}t.$TB=R}),ne(ie[58],se([0,1,2,57,7,13,29]),function(j,t,D,k,r,f,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$nZ=void 0;class h{static computeUnicodeHighlights(e,E,R){const v=R?R.startLineNumber:1,$=R?R.endLineNumber:e.getLineCount(),u=new g(E),o=u.getCandidateCodePoints();let c;o==="allNonBasicAscii"?c=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):c=new RegExp(`${l(Array.from(o))}`,"g");const i=new k.$TB(null,c),a=[];let L=!1,d,w=0,M=0,p=0;e:for(let F=v,_=$;F<=_;F++){const P=e.getLineContent(F),S=P.length;i.reset(0);do if(d=i.next(P),d){let T=d.index,q=d.index+d[0].length;if(T>0){const H=P.charCodeAt(T-1);r.$af(H)&&T--}if(q+1<S){const H=P.charCodeAt(q-1);r.$af(H)&&q++}const O=P.substring(T,q);let y=(0,N.$ks)(T+1,N.$hs,P,0);y&&y.endColumn<=T+1&&(y=null);const V=u.shouldHighlightNonBasicASCII(O,y?y.word:null);if(V!==0){V===3?w++:V===2?M++:V===1?p++:(0,f.$5c)(V);const H=1e3;if(a.length>=H){L=!0;break e}a.push(new D.$Is(F,T+1,F,q+1))}}while(d)}return{ranges:a,hasMore:L,ambiguousCharacterCount:w,invisibleCharacterCount:M,nonBasicAsciiCharacterCount:p}}static computeUnicodeHighlightReason(e,E){const R=new g(E);switch(R.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const $=e.codePointAt(0),u=R.ambiguousCharacters.getPrimaryConfusable($),o=r.$Df.getLocales().filter(c=>!r.$Df.getInstance(new Set([...E.allowedLocales,c])).isAmbiguous($));return{kind:0,confusableWith:String.fromCodePoint(u),notAmbiguousInLocales:o}}case 1:return{kind:2}}}}t.$nZ=h;function l(m,e){return`[${r.$Le(m.map(R=>String.fromCodePoint(R)).join(""))}]`}var s;(function(m){m[m.Ambiguous=0]="Ambiguous",m[m.Invisible=1]="Invisible",m[m.NonBasicAscii=2]="NonBasicAscii"})(s||(t.UnicodeHighlighterReasonKind=s={}));class g{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=r.$Df.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const E of r.$Ef.codePoints)A(String.fromCodePoint(E))||e.add(E);if(this.b.ambiguousCharacters)for(const E of this.ambiguousCharacters.getConfusableCodePoints())e.add(E);for(const E of this.a)e.delete(E);return e}shouldHighlightNonBasicASCII(e,E){const R=e.codePointAt(0);if(this.a.has(R))return 0;if(this.b.nonBasicASCII)return 1;let v=!1,$=!1;if(E)for(const u of E){const o=u.codePointAt(0),c=r.$lf(u);v=v||c,!c&&!this.ambiguousCharacters.isAmbiguous(o)&&!r.$Ef.isInvisibleCharacter(o)&&($=!0)}return!v&&$?0:this.b.invisibleCharacters&&!A(e)&&r.$Ef.isInvisibleCharacter(R)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(R)?3:0}}function A(m){return m===" "||m===`
`||m==="	"}var b;(function(m){m[m.None=0]="None",m[m.NonBasicASCII=1]="NonBasicASCII",m[m.Invisible=2]="Invisible",m[m.Ambiguous=3]="Ambiguous"})(b||(b={}))}),ne(ie[59],se([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.ShowLightbulbIconMode=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var D;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(D||(t.AccessibilitySupport=D={}));var k;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(k||(t.CodeActionTriggerType=k={}));var r;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(r||(t.CompletionItemInsertTextRule=r={}));var f;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(f||(t.CompletionItemKind=f={}));var N;(function(n){n[n.Deprecated=1]="Deprecated"})(N||(t.CompletionItemTag=N={}));var h;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h||(t.CompletionTriggerKind=h={}));var l;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(l||(t.ContentWidgetPositionPreference=l={}));var s;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(s||(t.CursorChangeReason=s={}));var g;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(g||(t.DefaultEndOfLine=g={}));var A;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(A||(t.DocumentHighlightKind=A={}));var b;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(b||(t.EditorAutoIndentStrategy=b={}));var m;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.ariaRequired=5]="ariaRequired",n[n.autoClosingBrackets=6]="autoClosingBrackets",n[n.autoClosingComments=7]="autoClosingComments",n[n.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=9]="autoClosingDelete",n[n.autoClosingOvertype=10]="autoClosingOvertype",n[n.autoClosingQuotes=11]="autoClosingQuotes",n[n.autoIndent=12]="autoIndent",n[n.automaticLayout=13]="automaticLayout",n[n.autoSurround=14]="autoSurround",n[n.bracketPairColorization=15]="bracketPairColorization",n[n.guides=16]="guides",n[n.codeLens=17]="codeLens",n[n.codeLensFontFamily=18]="codeLensFontFamily",n[n.codeLensFontSize=19]="codeLensFontSize",n[n.colorDecorators=20]="colorDecorators",n[n.colorDecoratorsLimit=21]="colorDecoratorsLimit",n[n.columnSelection=22]="columnSelection",n[n.comments=23]="comments",n[n.contextmenu=24]="contextmenu",n[n.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",n[n.cursorBlinking=26]="cursorBlinking",n[n.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",n[n.cursorStyle=28]="cursorStyle",n[n.cursorSurroundingLines=29]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",n[n.cursorWidth=31]="cursorWidth",n[n.disableLayerHinting=32]="disableLayerHinting",n[n.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",n[n.domReadOnly=34]="domReadOnly",n[n.dragAndDrop=35]="dragAndDrop",n[n.dropIntoEditor=36]="dropIntoEditor",n[n.emptySelectionClipboard=37]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",n[n.extraEditorClassName=39]="extraEditorClassName",n[n.fastScrollSensitivity=40]="fastScrollSensitivity",n[n.find=41]="find",n[n.fixedOverflowWidgets=42]="fixedOverflowWidgets",n[n.folding=43]="folding",n[n.foldingStrategy=44]="foldingStrategy",n[n.foldingHighlight=45]="foldingHighlight",n[n.foldingImportsByDefault=46]="foldingImportsByDefault",n[n.foldingMaximumRegions=47]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=49]="fontFamily",n[n.fontInfo=50]="fontInfo",n[n.fontLigatures=51]="fontLigatures",n[n.fontSize=52]="fontSize",n[n.fontWeight=53]="fontWeight",n[n.fontVariations=54]="fontVariations",n[n.formatOnPaste=55]="formatOnPaste",n[n.formatOnType=56]="formatOnType",n[n.glyphMargin=57]="glyphMargin",n[n.gotoLocation=58]="gotoLocation",n[n.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",n[n.hover=60]="hover",n[n.inDiffEditor=61]="inDiffEditor",n[n.inlineSuggest=62]="inlineSuggest",n[n.letterSpacing=63]="letterSpacing",n[n.lightbulb=64]="lightbulb",n[n.lineDecorationsWidth=65]="lineDecorationsWidth",n[n.lineHeight=66]="lineHeight",n[n.lineNumbers=67]="lineNumbers",n[n.lineNumbersMinChars=68]="lineNumbersMinChars",n[n.linkedEditing=69]="linkedEditing",n[n.links=70]="links",n[n.matchBrackets=71]="matchBrackets",n[n.minimap=72]="minimap",n[n.mouseStyle=73]="mouseStyle",n[n.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=75]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",n[n.multiCursorModifier=77]="multiCursorModifier",n[n.multiCursorPaste=78]="multiCursorPaste",n[n.multiCursorLimit=79]="multiCursorLimit",n[n.occurrencesHighlight=80]="occurrencesHighlight",n[n.overviewRulerBorder=81]="overviewRulerBorder",n[n.overviewRulerLanes=82]="overviewRulerLanes",n[n.padding=83]="padding",n[n.pasteAs=84]="pasteAs",n[n.parameterHints=85]="parameterHints",n[n.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",n[n.quickSuggestions=88]="quickSuggestions",n[n.quickSuggestionsDelay=89]="quickSuggestionsDelay",n[n.readOnly=90]="readOnly",n[n.readOnlyMessage=91]="readOnlyMessage",n[n.renameOnType=92]="renameOnType",n[n.renderControlCharacters=93]="renderControlCharacters",n[n.renderFinalNewline=94]="renderFinalNewline",n[n.renderLineHighlight=95]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=97]="renderValidationDecorations",n[n.renderWhitespace=98]="renderWhitespace",n[n.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",n[n.roundedSelection=100]="roundedSelection",n[n.rulers=101]="rulers",n[n.scrollbar=102]="scrollbar",n[n.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=104]="scrollBeyondLastLine",n[n.scrollPredominantAxis=105]="scrollPredominantAxis",n[n.selectionClipboard=106]="selectionClipboard",n[n.selectionHighlight=107]="selectionHighlight",n[n.selectOnLineNumbers=108]="selectOnLineNumbers",n[n.showFoldingControls=109]="showFoldingControls",n[n.showUnused=110]="showUnused",n[n.snippetSuggestions=111]="snippetSuggestions",n[n.smartSelect=112]="smartSelect",n[n.smoothScrolling=113]="smoothScrolling",n[n.stickyScroll=114]="stickyScroll",n[n.stickyTabStops=115]="stickyTabStops",n[n.stopRenderingLineAfter=116]="stopRenderingLineAfter",n[n.suggest=117]="suggest",n[n.suggestFontSize=118]="suggestFontSize",n[n.suggestLineHeight=119]="suggestLineHeight",n[n.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",n[n.suggestSelection=121]="suggestSelection",n[n.tabCompletion=122]="tabCompletion",n[n.tabIndex=123]="tabIndex",n[n.unicodeHighlighting=124]="unicodeHighlighting",n[n.unusualLineTerminators=125]="unusualLineTerminators",n[n.useShadowDOM=126]="useShadowDOM",n[n.useTabStops=127]="useTabStops",n[n.wordBreak=128]="wordBreak",n[n.wordSeparators=129]="wordSeparators",n[n.wordWrap=130]="wordWrap",n[n.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=133]="wordWrapColumn",n[n.wordWrapOverride1=134]="wordWrapOverride1",n[n.wordWrapOverride2=135]="wordWrapOverride2",n[n.wrappingIndent=136]="wrappingIndent",n[n.wrappingStrategy=137]="wrappingStrategy",n[n.showDeprecated=138]="showDeprecated",n[n.inlayHints=139]="inlayHints",n[n.editorClassName=140]="editorClassName",n[n.pixelRatio=141]="pixelRatio",n[n.tabFocusMode=142]="tabFocusMode",n[n.layoutInfo=143]="layoutInfo",n[n.wrappingInfo=144]="wrappingInfo",n[n.defaultColorDecorators=145]="defaultColorDecorators",n[n.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",n[n.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(m||(t.EditorOption=m={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var E;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(E||(t.EndOfLineSequence=E={}));var R;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(R||(t.GlyphMarginLane=R={}));var v;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(v||(t.IndentAction=v={}));var $;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})($||(t.InjectedTextCursorStops=$={}));var u;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(u||(t.InlayHintKind=u={}));var o;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(o||(t.InlineCompletionTriggerKind=o={}));var c;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(c||(t.KeyCode=c={}));var i;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(i||(t.MarkerSeverity=i={}));var a;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(a||(t.MarkerTag=a={}));var L;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(L||(t.MinimapPosition=L={}));var d;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(d||(t.MouseTargetType=d={}));var w;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(w||(t.OverlayWidgetPositionPreference=w={}));var M;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(M||(t.OverviewRulerLane=M={}));var p;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(p||(t.PositionAffinity=p={}));var F;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(F||(t.RenderLineNumbersType=F={}));var _;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(_||(t.RenderMinimap=_={}));var P;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(P||(t.ScrollType=P={}));var S;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(S||(t.ScrollbarVisibility=S={}));var T;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(T||(t.SelectionDirection=T={}));var q;(function(n){n.Off="off",n.OnCode="onCode",n.On="on"})(q||(t.ShowLightbulbIconMode=q={}));var O;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(O||(t.SignatureHelpTriggerKind=O={}));var y;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(y||(t.SymbolKind=y={}));var V;(function(n){n[n.Deprecated=1]="Deprecated"})(V||(t.SymbolTag=V={}));var H;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(H||(t.TextEditorCursorBlinkingStyle=H={}));var x;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(x||(t.TextEditorCursorStyle=x={}));var Y;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(Y||(t.TrackedRangeStickiness=Y={}));var te;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(te||(t.WrappingIndent=te={}))}),ne(ie[60],se([0,1,11,10]),function(j,t,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ht=void 0;class r{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$Sd,this.onDidChange=this.c.event,this.d=null}handleChange(h){this.c.fire({changedLanguages:h,changedColorMap:!1})}register(h,l){return this.a.set(h,l),this.handleChange([h]),(0,k.$Qc)(()=>{this.a.get(h)===l&&(this.a.delete(h),this.handleChange([h]))})}get(h){return this.a.get(h)||null}registerFactory(h,l){this.b.get(h)?.dispose();const s=new f(this,h,l);return this.b.set(h,s),(0,k.$Qc)(()=>{const g=this.b.get(h);!g||g!==s||(this.b.delete(h),g.dispose())})}async getOrCreate(h){const l=this.get(h);if(l)return l;const s=this.b.get(h);return!s||s.isResolved?null:(await s.resolve(),this.get(h))}isResolved(h){if(this.get(h))return!0;const s=this.b.get(h);return!!(!s||s.isResolved)}setColorMap(h){this.d=h,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$ht=r;class f extends k.$Sc{get isResolved(){return this.c}constructor(h,l,s){super(),this.f=h,this.g=l,this.h=s,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const h=await this.h.tokenizationSupport;this.c=!0,h&&!this.a&&this.B(this.f.register(this.g,h))}}}),ne(ie[61],se([62,63]),function(j,t){return j.create("vs/base/common/platform",t)}),ne(ie[17],se([0,1,61]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$J=t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=void 0,t.$g="en";let k=!1,r=!1,f=!1,N=!1,h=!1,l=!1,s=!1,g=!1,A=!1,b=!1,m,e=t.$g,E=t.$g,R,v;const $=globalThis;let u;typeof $.vscode<"u"&&typeof $.vscode.process<"u"?u=$.vscode.process:typeof process<"u"&&(u=process);const o=typeof u?.versions?.electron=="string",c=o&&u?.type==="renderer";if(typeof u=="object"){k=u.platform==="win32",r=u.platform==="darwin",f=u.platform==="linux",N=f&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,s=o,A=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=t.$g,e=t.$g;const P=u.env.VSCODE_NLS_CONFIG;if(P)try{const S=JSON.parse(P),T=S.availableLanguages["*"];m=S.locale,E=S.osLocale,e=T||t.$g,R=S._translationsConfigFile}catch{}h=!0}else typeof navigator=="object"&&!c?(v=navigator.userAgent,k=v.indexOf("Windows")>=0,r=v.indexOf("Macintosh")>=0,g=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,f=v.indexOf("Linux")>=0,b=v?.indexOf("Mobi")>=0,l=!0,m=D.getConfiguredDefaultLocale(D.localize(0,null))||t.$g,e=m,E=navigator.language):console.error("Unable to resolve platform.");var i;(function(P){P[P.Web=0]="Web",P[P.Mac=1]="Mac",P[P.Linux=2]="Linux",P[P.Windows=3]="Windows"})(i||(t.Platform=i={}));function a(P){switch(P){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=a;let L=0;r?L=1:k?L=3:f&&(L=2),t.$i=k,t.$j=r,t.$k=f,t.$l=N,t.$m=h,t.$n=s,t.$o=l,t.$p=l&&typeof $.importScripts=="function",t.$q=t.$p?$.origin:void 0,t.$r=g,t.$s=b,t.$t=A,t.$u=L,t.$v=v,t.$w=e;var d;(function(P){function S(){return t.$w}P.value=S;function T(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}P.isDefaultVariant=T;function q(){return t.$w==="en"}P.isDefault=q})(d||(t.Language=d={})),t.$x=m,t.$y=E,t.$z=R,t.$A=typeof $.postMessage=="function"&&!$.importScripts,t.$B=(()=>{if(t.$A){const P=[];$.addEventListener("message",T=>{if(T.data&&T.data.vscodeScheduleAsyncWork)for(let q=0,O=P.length;q<O;q++){const y=P[q];if(y.id===T.data.vscodeScheduleAsyncWork){P.splice(q,1),y.callback();return}}});let S=0;return T=>{const q=++S;P.push({id:q,callback:T}),$.postMessage({vscodeScheduleAsyncWork:q},"*")}}return P=>setTimeout(P)})();var w;(function(P){P[P.Windows=1]="Windows",P[P.Macintosh=2]="Macintosh",P[P.Linux=3]="Linux"})(w||(t.OperatingSystem=w={})),t.OS=r||g?2:k?1:3;let M=!0,p=!1;function F(){if(!p){p=!0;const P=new Uint8Array(2);P[0]=1,P[1]=2,M=new Uint16Array(P.buffer)[0]===(2<<8)+1}return M}t.$D=F,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function _(P){return parseFloat(P)>=20}t.$J=_}),ne(ie[64],se([0,1,17]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.env=t.cwd=void 0;let k;const r=globalThis.vscode;if(typeof r<"u"&&typeof r.process<"u"){const f=r.process;k={get platform(){return f.platform},get arch(){return f.arch},get env(){return f.env},cwd(){return f.cwd()}}}else typeof process<"u"?k={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:k={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=k.cwd,t.env=k.env,t.$dc=k.platform,t.$ec=k.arch}),ne(ie[65],se([0,1,64]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=t.sep=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=void 0;const k=65,r=97,f=90,N=122,h=46,l=47,s=92,g=58,A=63;class b extends Error{constructor(a,L,d){let w;typeof L=="string"&&L.indexOf("not ")===0?(w="must not be",L=L.replace(/^not /,"")):w="must be";const M=a.indexOf(".")!==-1?"property":"argument";let p=`The "${a}" ${M} ${w} of type ${L}`;p+=`. Received type ${typeof d}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function m(i,a){if(i===null||typeof i!="object")throw new b(a,"Object",i)}function e(i,a){if(typeof i!="string")throw new b(a,"string",i)}const E=D.$dc==="win32";function R(i){return i===l||i===s}function v(i){return i===l}function $(i){return i>=k&&i<=f||i>=r&&i<=N}function u(i,a,L,d){let w="",M=0,p=-1,F=0,_=0;for(let P=0;P<=i.length;++P){if(P<i.length)_=i.charCodeAt(P);else{if(d(_))break;_=l}if(d(_)){if(!(p===P-1||F===1))if(F===2){if(w.length<2||M!==2||w.charCodeAt(w.length-1)!==h||w.charCodeAt(w.length-2)!==h){if(w.length>2){const S=w.lastIndexOf(L);S===-1?(w="",M=0):(w=w.slice(0,S),M=w.length-1-w.lastIndexOf(L)),p=P,F=0;continue}else if(w.length!==0){w="",M=0,p=P,F=0;continue}}a&&(w+=w.length>0?`${L}..`:"..",M=2)}else w.length>0?w+=`${L}${i.slice(p+1,P)}`:w=i.slice(p+1,P),M=P-p-1;p=P,F=0}else _===h&&F!==-1?++F:F=-1}return w}function o(i,a){m(a,"pathObject");const L=a.dir||a.root,d=a.base||`${a.name||""}${a.ext||""}`;return L?L===a.root?`${L}${d}`:`${L}${i}${d}`:d}t.$fc={resolve(...i){let a="",L="",d=!1;for(let w=i.length-1;w>=-1;w--){let M;if(w>=0){if(M=i[w],e(M,"path"),M.length===0)continue}else a.length===0?M=D.cwd():(M=D.env[`=${a}`]||D.cwd(),(M===void 0||M.slice(0,2).toLowerCase()!==a.toLowerCase()&&M.charCodeAt(2)===s)&&(M=`${a}\\`));const p=M.length;let F=0,_="",P=!1;const S=M.charCodeAt(0);if(p===1)R(S)&&(F=1,P=!0);else if(R(S))if(P=!0,R(M.charCodeAt(1))){let T=2,q=T;for(;T<p&&!R(M.charCodeAt(T));)T++;if(T<p&&T!==q){const O=M.slice(q,T);for(q=T;T<p&&R(M.charCodeAt(T));)T++;if(T<p&&T!==q){for(q=T;T<p&&!R(M.charCodeAt(T));)T++;(T===p||T!==q)&&(_=`\\\\${O}\\${M.slice(q,T)}`,F=T)}}}else F=1;else $(S)&&M.charCodeAt(1)===g&&(_=M.slice(0,2),F=2,p>2&&R(M.charCodeAt(2))&&(P=!0,F=3));if(_.length>0)if(a.length>0){if(_.toLowerCase()!==a.toLowerCase())continue}else a=_;if(d){if(a.length>0)break}else if(L=`${M.slice(F)}\\${L}`,d=P,P&&a.length>0)break}return L=u(L,!d,"\\",R),d?`${a}\\${L}`:`${a}${L}`||"."},normalize(i){e(i,"path");const a=i.length;if(a===0)return".";let L=0,d,w=!1;const M=i.charCodeAt(0);if(a===1)return v(M)?"\\":i;if(R(M))if(w=!0,R(i.charCodeAt(1))){let F=2,_=F;for(;F<a&&!R(i.charCodeAt(F));)F++;if(F<a&&F!==_){const P=i.slice(_,F);for(_=F;F<a&&R(i.charCodeAt(F));)F++;if(F<a&&F!==_){for(_=F;F<a&&!R(i.charCodeAt(F));)F++;if(F===a)return`\\\\${P}\\${i.slice(_)}\\`;F!==_&&(d=`\\\\${P}\\${i.slice(_,F)}`,L=F)}}}else L=1;else $(M)&&i.charCodeAt(1)===g&&(d=i.slice(0,2),L=2,a>2&&R(i.charCodeAt(2))&&(w=!0,L=3));let p=L<a?u(i.slice(L),!w,"\\",R):"";return p.length===0&&!w&&(p="."),p.length>0&&R(i.charCodeAt(a-1))&&(p+="\\"),d===void 0?w?`\\${p}`:p:w?`${d}\\${p}`:`${d}${p}`},isAbsolute(i){e(i,"path");const a=i.length;if(a===0)return!1;const L=i.charCodeAt(0);return R(L)||a>2&&$(L)&&i.charCodeAt(1)===g&&R(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let a,L;for(let M=0;M<i.length;++M){const p=i[M];e(p,"path"),p.length>0&&(a===void 0?a=L=p:a+=`\\${p}`)}if(a===void 0)return".";let d=!0,w=0;if(typeof L=="string"&&R(L.charCodeAt(0))){++w;const M=L.length;M>1&&R(L.charCodeAt(1))&&(++w,M>2&&(R(L.charCodeAt(2))?++w:d=!1))}if(d){for(;w<a.length&&R(a.charCodeAt(w));)w++;w>=2&&(a=`\\${a.slice(w)}`)}return t.$fc.normalize(a)},relative(i,a){if(e(i,"from"),e(a,"to"),i===a)return"";const L=t.$fc.resolve(i),d=t.$fc.resolve(a);if(L===d||(i=L.toLowerCase(),a=d.toLowerCase(),i===a))return"";let w=0;for(;w<i.length&&i.charCodeAt(w)===s;)w++;let M=i.length;for(;M-1>w&&i.charCodeAt(M-1)===s;)M--;const p=M-w;let F=0;for(;F<a.length&&a.charCodeAt(F)===s;)F++;let _=a.length;for(;_-1>F&&a.charCodeAt(_-1)===s;)_--;const P=_-F,S=p<P?p:P;let T=-1,q=0;for(;q<S;q++){const y=i.charCodeAt(w+q);if(y!==a.charCodeAt(F+q))break;y===s&&(T=q)}if(q!==S){if(T===-1)return d}else{if(P>S){if(a.charCodeAt(F+q)===s)return d.slice(F+q+1);if(q===2)return d.slice(F+q)}p>S&&(i.charCodeAt(w+q)===s?T=q:q===2&&(T=3)),T===-1&&(T=0)}let O="";for(q=w+T+1;q<=M;++q)(q===M||i.charCodeAt(q)===s)&&(O+=O.length===0?"..":"\\..");return F+=T,O.length>0?`${O}${d.slice(F,_)}`:(d.charCodeAt(F)===s&&++F,d.slice(F,_))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const a=t.$fc.resolve(i);if(a.length<=2)return i;if(a.charCodeAt(0)===s){if(a.charCodeAt(1)===s){const L=a.charCodeAt(2);if(L!==A&&L!==h)return`\\\\?\\UNC\\${a.slice(2)}`}}else if($(a.charCodeAt(0))&&a.charCodeAt(1)===g&&a.charCodeAt(2)===s)return`\\\\?\\${a}`;return i},dirname(i){e(i,"path");const a=i.length;if(a===0)return".";let L=-1,d=0;const w=i.charCodeAt(0);if(a===1)return R(w)?i:".";if(R(w)){if(L=d=1,R(i.charCodeAt(1))){let F=2,_=F;for(;F<a&&!R(i.charCodeAt(F));)F++;if(F<a&&F!==_){for(_=F;F<a&&R(i.charCodeAt(F));)F++;if(F<a&&F!==_){for(_=F;F<a&&!R(i.charCodeAt(F));)F++;if(F===a)return i;F!==_&&(L=d=F+1)}}}}else $(w)&&i.charCodeAt(1)===g&&(L=a>2&&R(i.charCodeAt(2))?3:2,d=L);let M=-1,p=!0;for(let F=a-1;F>=d;--F)if(R(i.charCodeAt(F))){if(!p){M=F;break}}else p=!1;if(M===-1){if(L===-1)return".";M=L}return i.slice(0,M)},basename(i,a){a!==void 0&&e(a,"ext"),e(i,"path");let L=0,d=-1,w=!0,M;if(i.length>=2&&$(i.charCodeAt(0))&&i.charCodeAt(1)===g&&(L=2),a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let p=a.length-1,F=-1;for(M=i.length-1;M>=L;--M){const _=i.charCodeAt(M);if(R(_)){if(!w){L=M+1;break}}else F===-1&&(w=!1,F=M+1),p>=0&&(_===a.charCodeAt(p)?--p===-1&&(d=M):(p=-1,d=F))}return L===d?d=F:d===-1&&(d=i.length),i.slice(L,d)}for(M=i.length-1;M>=L;--M)if(R(i.charCodeAt(M))){if(!w){L=M+1;break}}else d===-1&&(w=!1,d=M+1);return d===-1?"":i.slice(L,d)},extname(i){e(i,"path");let a=0,L=-1,d=0,w=-1,M=!0,p=0;i.length>=2&&i.charCodeAt(1)===g&&$(i.charCodeAt(0))&&(a=d=2);for(let F=i.length-1;F>=a;--F){const _=i.charCodeAt(F);if(R(_)){if(!M){d=F+1;break}continue}w===-1&&(M=!1,w=F+1),_===h?L===-1?L=F:p!==1&&(p=1):L!==-1&&(p=-1)}return L===-1||w===-1||p===0||p===1&&L===w-1&&L===d+1?"":i.slice(L,w)},format:o.bind(null,"\\"),parse(i){e(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const L=i.length;let d=0,w=i.charCodeAt(0);if(L===1)return R(w)?(a.root=a.dir=i,a):(a.base=a.name=i,a);if(R(w)){if(d=1,R(i.charCodeAt(1))){let T=2,q=T;for(;T<L&&!R(i.charCodeAt(T));)T++;if(T<L&&T!==q){for(q=T;T<L&&R(i.charCodeAt(T));)T++;if(T<L&&T!==q){for(q=T;T<L&&!R(i.charCodeAt(T));)T++;T===L?d=T:T!==q&&(d=T+1)}}}}else if($(w)&&i.charCodeAt(1)===g){if(L<=2)return a.root=a.dir=i,a;if(d=2,R(i.charCodeAt(2))){if(L===3)return a.root=a.dir=i,a;d=3}}d>0&&(a.root=i.slice(0,d));let M=-1,p=d,F=-1,_=!0,P=i.length-1,S=0;for(;P>=d;--P){if(w=i.charCodeAt(P),R(w)){if(!_){p=P+1;break}continue}F===-1&&(_=!1,F=P+1),w===h?M===-1?M=P:S!==1&&(S=1):M!==-1&&(S=-1)}return F!==-1&&(M===-1||S===0||S===1&&M===F-1&&M===p+1?a.base=a.name=i.slice(p,F):(a.name=i.slice(p,M),a.base=i.slice(p,F),a.ext=i.slice(M,F))),p>0&&p!==d?a.dir=i.slice(0,p-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(E){const i=/\\/g;return()=>{const a=D.cwd().replace(i,"/");return a.slice(a.indexOf("/"))}}return()=>D.cwd()})();t.$gc={resolve(...i){let a="",L=!1;for(let d=i.length-1;d>=-1&&!L;d--){const w=d>=0?i[d]:c();e(w,"path"),w.length!==0&&(a=`${w}/${a}`,L=w.charCodeAt(0)===l)}return a=u(a,!L,"/",v),L?`/${a}`:a.length>0?a:"."},normalize(i){if(e(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===l,L=i.charCodeAt(i.length-1)===l;return i=u(i,!a,"/",v),i.length===0?a?"/":L?"./":".":(L&&(i+="/"),a?`/${i}`:i)},isAbsolute(i){return e(i,"path"),i.length>0&&i.charCodeAt(0)===l},join(...i){if(i.length===0)return".";let a;for(let L=0;L<i.length;++L){const d=i[L];e(d,"path"),d.length>0&&(a===void 0?a=d:a+=`/${d}`)}return a===void 0?".":t.$gc.normalize(a)},relative(i,a){if(e(i,"from"),e(a,"to"),i===a||(i=t.$gc.resolve(i),a=t.$gc.resolve(a),i===a))return"";const L=1,d=i.length,w=d-L,M=1,p=a.length-M,F=w<p?w:p;let _=-1,P=0;for(;P<F;P++){const T=i.charCodeAt(L+P);if(T!==a.charCodeAt(M+P))break;T===l&&(_=P)}if(P===F)if(p>F){if(a.charCodeAt(M+P)===l)return a.slice(M+P+1);if(P===0)return a.slice(M+P)}else w>F&&(i.charCodeAt(L+P)===l?_=P:P===0&&(_=0));let S="";for(P=L+_+1;P<=d;++P)(P===d||i.charCodeAt(P)===l)&&(S+=S.length===0?"..":"/..");return`${S}${a.slice(M+_)}`},toNamespacedPath(i){return i},dirname(i){if(e(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===l;let L=-1,d=!0;for(let w=i.length-1;w>=1;--w)if(i.charCodeAt(w)===l){if(!d){L=w;break}}else d=!1;return L===-1?a?"/":".":a&&L===1?"//":i.slice(0,L)},basename(i,a){a!==void 0&&e(a,"ext"),e(i,"path");let L=0,d=-1,w=!0,M;if(a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let p=a.length-1,F=-1;for(M=i.length-1;M>=0;--M){const _=i.charCodeAt(M);if(_===l){if(!w){L=M+1;break}}else F===-1&&(w=!1,F=M+1),p>=0&&(_===a.charCodeAt(p)?--p===-1&&(d=M):(p=-1,d=F))}return L===d?d=F:d===-1&&(d=i.length),i.slice(L,d)}for(M=i.length-1;M>=0;--M)if(i.charCodeAt(M)===l){if(!w){L=M+1;break}}else d===-1&&(w=!1,d=M+1);return d===-1?"":i.slice(L,d)},extname(i){e(i,"path");let a=-1,L=0,d=-1,w=!0,M=0;for(let p=i.length-1;p>=0;--p){const F=i.charCodeAt(p);if(F===l){if(!w){L=p+1;break}continue}d===-1&&(w=!1,d=p+1),F===h?a===-1?a=p:M!==1&&(M=1):a!==-1&&(M=-1)}return a===-1||d===-1||M===0||M===1&&a===d-1&&a===L+1?"":i.slice(a,d)},format:o.bind(null,"/"),parse(i){e(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const L=i.charCodeAt(0)===l;let d;L?(a.root="/",d=1):d=0;let w=-1,M=0,p=-1,F=!0,_=i.length-1,P=0;for(;_>=d;--_){const S=i.charCodeAt(_);if(S===l){if(!F){M=_+1;break}continue}p===-1&&(F=!1,p=_+1),S===h?w===-1?w=_:P!==1&&(P=1):w!==-1&&(P=-1)}if(p!==-1){const S=M===0&&L?1:M;w===-1||P===0||P===1&&w===p-1&&w===M+1?a.base=a.name=i.slice(S,p):(a.name=i.slice(S,w),a.base=i.slice(S,p),a.ext=i.slice(w,p))}return M>0?a.dir=i.slice(0,M-1):L&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},t.$gc.win32=t.$fc.win32=t.$fc,t.$gc.posix=t.$fc.posix=t.$gc,t.$hc=E?t.$fc.normalize:t.$gc.normalize,t.$ic=E?t.$fc.isAbsolute:t.$gc.isAbsolute,t.$jc=E?t.$fc.join:t.$gc.join,t.$kc=E?t.$fc.resolve:t.$gc.resolve,t.$lc=E?t.$fc.relative:t.$gc.relative,t.$mc=E?t.$fc.dirname:t.$gc.dirname,t.$nc=E?t.$fc.basename:t.$gc.basename,t.$oc=E?t.$fc.extname:t.$gc.extname,t.$pc=E?t.$fc.format:t.$gc.format,t.$qc=E?t.$fc.parse:t.$gc.parse,t.$rc=E?t.$fc.toNamespacedPath:t.$gc.toNamespacedPath,t.sep=E?t.$fc.sep:t.$gc.sep,t.$tc=E?t.$fc.delimiter:t.$gc.delimiter}),ne(ie[18],se([0,1,65,17]),function(j,t,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wc=t.$vc=t.URI=void 0;const r=/^\w[\w\d+.-]*$/,f=/^\//,N=/^\/\//;function h(d,w){if(!d.scheme&&w)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!r.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!f.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(N.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(d,w){return!d&&!w?"file":d}function s(d,w){switch(d){case"https":case"http":case"file":w?w[0]!==A&&(w=A+w):w=A;break}return w}const g="",A="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(w){return w instanceof m?!0:w?typeof w.authority=="string"&&typeof w.fragment=="string"&&typeof w.path=="string"&&typeof w.query=="string"&&typeof w.scheme=="string"&&typeof w.fsPath=="string"&&typeof w.with=="function"&&typeof w.toString=="function":!1}constructor(w,M,p,F,_,P=!1){typeof w=="object"?(this.scheme=w.scheme||g,this.authority=w.authority||g,this.path=w.path||g,this.query=w.query||g,this.fragment=w.fragment||g):(this.scheme=l(w,P),this.authority=M||g,this.path=s(this.scheme,p||g),this.query=F||g,this.fragment=_||g,h(this,P))}get fsPath(){return o(this,!1)}with(w){if(!w)return this;let{scheme:M,authority:p,path:F,query:_,fragment:P}=w;return M===void 0?M=this.scheme:M===null&&(M=g),p===void 0?p=this.authority:p===null&&(p=g),F===void 0?F=this.path:F===null&&(F=g),_===void 0?_=this.query:_===null&&(_=g),P===void 0?P=this.fragment:P===null&&(P=g),M===this.scheme&&p===this.authority&&F===this.path&&_===this.query&&P===this.fragment?this:new R(M,p,F,_,P)}static parse(w,M=!1){const p=b.exec(w);return p?new R(p[2]||g,L(p[4]||g),L(p[5]||g),L(p[7]||g),L(p[9]||g),M):new R(g,g,g,g,g)}static file(w){let M=g;if(k.$i&&(w=w.replace(/\\/g,A)),w[0]===A&&w[1]===A){const p=w.indexOf(A,2);p===-1?(M=w.substring(2),w=A):(M=w.substring(2,p),w=w.substring(p)||A)}return new R("file",M,w,g,g)}static from(w,M){return new R(w.scheme,w.authority,w.path,w.query,w.fragment,M)}static joinPath(w,...M){if(!w.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return k.$i&&w.scheme==="file"?p=m.file(D.$fc.join(o(w,!0),...M)).path:p=D.$gc.join(w.path,...M),w.with({path:p})}toString(w=!1){return c(this,w)}toJSON(){return this}static revive(w){if(w){if(w instanceof m)return w;{const M=new R(w);return M._formatted=w.external??null,M._fsPath=w._sep===E?w.fsPath??null:null,M}}else return w}}t.URI=m;function e(d){return!d||typeof d!="object"?!1:typeof d.scheme=="string"&&(typeof d.authority=="string"||typeof d.authority>"u")&&(typeof d.path=="string"||typeof d.path>"u")&&(typeof d.query=="string"||typeof d.query>"u")&&(typeof d.fragment=="string"||typeof d.fragment>"u")}t.$vc=e;const E=k.$i?1:void 0;class R extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(w=!1){return w?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const w={$mid:1};return this._fsPath&&(w.fsPath=this._fsPath,w._sep=E),this._formatted&&(w.external=this._formatted),this.path&&(w.path=this.path),this.scheme&&(w.scheme=this.scheme),this.authority&&(w.authority=this.authority),this.query&&(w.query=this.query),this.fragment&&(w.fragment=this.fragment),w}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function $(d,w,M){let p,F=-1;for(let _=0;_<d.length;_++){const P=d.charCodeAt(_);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||w&&P===47||M&&P===91||M&&P===93||M&&P===58)F!==-1&&(p+=encodeURIComponent(d.substring(F,_)),F=-1),p!==void 0&&(p+=d.charAt(_));else{p===void 0&&(p=d.substr(0,_));const S=v[P];S!==void 0?(F!==-1&&(p+=encodeURIComponent(d.substring(F,_)),F=-1),p+=S):F===-1&&(F=_)}}return F!==-1&&(p+=encodeURIComponent(d.substring(F))),p!==void 0?p:d}function u(d){let w;for(let M=0;M<d.length;M++){const p=d.charCodeAt(M);p===35||p===63?(w===void 0&&(w=d.substr(0,M)),w+=v[p]):w!==void 0&&(w+=d[M])}return w!==void 0?w:d}function o(d,w){let M;return d.authority&&d.path.length>1&&d.scheme==="file"?M=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?w?M=d.path.substr(1):M=d.path[1].toLowerCase()+d.path.substr(2):M=d.path,k.$i&&(M=M.replace(/\//g,"\\")),M}t.$wc=o;function c(d,w){const M=w?u:$;let p="",{scheme:F,authority:_,path:P,query:S,fragment:T}=d;if(F&&(p+=F,p+=":"),(_||F==="file")&&(p+=A,p+=A),_){let q=_.indexOf("@");if(q!==-1){const O=_.substr(0,q);_=_.substr(q+1),q=O.lastIndexOf(":"),q===-1?p+=M(O,!1,!1):(p+=M(O.substr(0,q),!1,!1),p+=":",p+=M(O.substr(q+1),!1,!0)),p+="@"}_=_.toLowerCase(),q=_.lastIndexOf(":"),q===-1?p+=M(_,!1,!0):(p+=M(_.substr(0,q),!1,!0),p+=_.substr(q))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const q=P.charCodeAt(1);q>=65&&q<=90&&(P=`/${String.fromCharCode(q+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const q=P.charCodeAt(0);q>=65&&q<=90&&(P=`${String.fromCharCode(q+32)}:${P.substr(2)}`)}p+=M(P,!0,!1)}return S&&(p+="?",p+=M(S,!1,!1)),T&&(p+="#",p+=w?T:$(T,!1,!1)),p}function i(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+i(d.substr(3)):d}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function L(d){return d.match(a)?d.replace(a,w=>i(w)):d}}),ne(ie[70],se([0,1,3,11,10,14,17,7]),function(j,t,D,k,r,f,N,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const l="$initialize";let s=!1;function g(L){N.$o&&(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(L.message))}t.logOnceWebWorkerWarning=g;var A;(function(L){L[L.Request=0]="Request",L[L.Reply=1]="Reply",L[L.SubscribeEvent=2]="SubscribeEvent",L[L.Event=3]="Event",L[L.UnsubscribeEvent=4]="UnsubscribeEvent"})(A||(A={}));class b{constructor(d,w,M,p){this.vsWorker=d,this.req=w,this.method=M,this.args=p,this.type=0}}class m{constructor(d,w,M,p){this.vsWorker=d,this.seq=w,this.res=M,this.err=p,this.type=1}}class e{constructor(d,w,M,p){this.vsWorker=d,this.req=w,this.eventName=M,this.arg=p,this.type=2}}class E{constructor(d,w,M){this.vsWorker=d,this.req=w,this.event=M,this.type=3}}class R{constructor(d,w){this.vsWorker=d,this.req=w,this.type=4}}class v{constructor(d){this.a=-1,this.g=d,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(d){this.a=d}sendMessage(d,w){const M=String(++this.b);return new Promise((p,F)=>{this.c[M]={resolve:p,reject:F},this.o(new b(this.a,M,d,w))})}listen(d,w){let M=null;const p=new k.$Sd({onWillAddFirstListener:()=>{M=String(++this.b),this.d.set(M,p),this.o(new e(this.a,M,d,w))},onDidRemoveLastListener:()=>{this.d.delete(M),this.o(new R(this.a,M)),M=null}});return p.event}handleMessage(d){!d||!d.vsWorker||this.a!==-1&&d.vsWorker!==this.a||this.h(d)}h(d){switch(d.type){case 1:return this.j(d);case 0:return this.k(d);case 2:return this.l(d);case 3:return this.m(d);case 4:return this.n(d)}}j(d){if(!this.c[d.seq]){console.warn("Got reply to unknown seq");return}const w=this.c[d.seq];if(delete this.c[d.seq],d.err){let M=d.err;d.err.$isError&&(M=new Error,M.name=d.err.name,M.message=d.err.message,M.stack=d.err.stack),w.reject(M);return}w.resolve(d.res)}k(d){const w=d.req;this.g.handleMessage(d.method,d.args).then(p=>{this.o(new m(this.a,w,p,void 0))},p=>{p.detail instanceof Error&&(p.detail=(0,D.$3)(p.detail)),this.o(new m(this.a,w,void 0,(0,D.$3)(p)))})}l(d){const w=d.req,M=this.g.handleEvent(d.eventName,d.arg)(p=>{this.o(new E(this.a,w,p))});this.f.set(w,M)}m(d){if(!this.d.has(d.req)){console.warn("Got event for unknown req");return}this.d.get(d.req).fire(d.event)}n(d){if(!this.f.has(d.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(d.req).dispose(),this.f.delete(d.req)}o(d){const w=[];if(d.type===0)for(let M=0;M<d.args.length;M++)d.args[M]instanceof ArrayBuffer&&w.push(d.args[M]);else d.type===1&&d.res instanceof ArrayBuffer&&w.push(d.res);this.g.sendMessage(d,w)}}class $ extends r.$Sc{constructor(d,w,M){super();let p=null;this.a=this.B(d.create("vs/base/common/worker/simpleWorker",q=>{this.c.handleMessage(q)},q=>{p?.(q)})),this.c=new v({sendMessage:(q,O)=>{this.a.postMessage(q,O)},handleMessage:(q,O)=>{if(typeof M[q]!="function")return Promise.reject(new Error("Missing method "+q+" on main thread host."));try{return Promise.resolve(M[q].apply(M,O))}catch(y){return Promise.reject(y)}},handleEvent:(q,O)=>{if(o(q)){const y=M[q].call(M,O);if(typeof y!="function")throw new Error(`Missing dynamic event ${q} on main thread host.`);return y}if(u(q)){const y=M[q];if(typeof y!="function")throw new Error(`Missing event ${q} on main thread host.`);return y}throw new Error(`Malformed event name ${q}`)}}),this.c.setWorkerId(this.a.getId());let F=null;const _=globalThis.require;typeof _<"u"&&typeof _.getConfig=="function"?F=_.getConfig():typeof globalThis.requirejs<"u"&&(F=globalThis.requirejs.s.contexts._.config);const P=(0,f.$tn)(M);this.b=this.c.sendMessage(l,[this.a.getId(),JSON.parse(JSON.stringify(F)),w,P]);const S=(q,O)=>this.g(q,O),T=(q,O)=>this.c.listen(q,O);this.f=new Promise((q,O)=>{p=O,this.b.then(y=>{q(c(y,S,T))},y=>{O(y),this.h("Worker failed to load "+w,y)})})}getProxyObject(){return this.f}g(d,w){return new Promise((M,p)=>{this.b.then(()=>{this.c.sendMessage(d,w).then(M,p)},p)})}h(d,w){console.error(d),console.info(w)}}t.SimpleWorkerClient=$;function u(L){return L[0]==="o"&&L[1]==="n"&&h.$8e(L.charCodeAt(2))}function o(L){return/^onDynamic/.test(L)&&h.$8e(L.charCodeAt(9))}function c(L,d,w){const M=_=>function(){const P=Array.prototype.slice.call(arguments,0);return d(_,P)},p=_=>function(P){return w(_,P)},F={};for(const _ of L){if(o(_)){F[_]=p(_);continue}if(u(_)){F[_]=w(_,void 0);continue}F[_]=M(_)}return F}class i{constructor(d,w){this.a=w,this.b=null,this.c=new v({sendMessage:(M,p)=>{d(M,p)},handleMessage:(M,p)=>this.d(M,p),handleEvent:(M,p)=>this.f(M,p)})}onmessage(d){this.c.handleMessage(d)}d(d,w){if(d===l)return this.g(w[0],w[1],w[2],w[3]);if(!this.b||typeof this.b[d]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+d));try{return Promise.resolve(this.b[d].apply(this.b,w))}catch(M){return Promise.reject(M)}}f(d,w){if(!this.b)throw new Error("Missing requestHandler");if(o(d)){const M=this.b[d].call(this.b,w);if(typeof M!="function")throw new Error(`Missing dynamic event ${d} on request handler.`);return M}if(u(d)){const M=this.b[d];if(typeof M!="function")throw new Error(`Missing event ${d} on request handler.`);return M}throw new Error(`Malformed event name ${d}`)}g(d,w,M,p){this.c.setWorkerId(d);const P=c(p,(S,T)=>this.c.sendMessage(S,T),(S,T)=>this.c.listen(S,T));return this.a?(this.b=this.a(P),Promise.resolve((0,f.$tn)(this.b))):(w&&(typeof w.baseUrl<"u"&&delete w.baseUrl,typeof w.paths<"u"&&typeof w.paths.vs<"u"&&delete w.paths.vs,typeof w.trustedTypesPolicy!==void 0&&delete w.trustedTypesPolicy,w.catchError=!0,globalThis.require.config(w)),new Promise((S,T)=>{(globalThis.require||j)([M],O=>{if(this.b=O.create(P),!this.b){T(new Error("No RequestHandler!"));return}S((0,f.$tn)(this.b))},T)}))}}t.SimpleWorkerServer=i;function a(L){return new i(L,null)}t.create=a}),ne(ie[66],se([62,63]),function(j,t){return j.create("vs/editor/common/languages",t)}),ne(ie[67],se([0,1,41,18,42,2,60,66]),function(j,t,D,k,r,f,N,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.$At=t.$zt=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.$yt=t.$xt=t.SymbolKinds=t.SymbolTag=t.$wt=t.$vt=t.SymbolKind=t.$ut=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.$tt=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.$st=t.$rt=t.$qt=void 0;class l{constructor(V,H,x){this.offset=V,this.type=H,this.language=x,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$qt=l;class s{constructor(V,H){this.tokens=V,this.endState=H,this._tokenizationResultBrand=void 0}}t.$rt=s;class g{constructor(V,H){this.tokens=V,this.endState=H,this._encodedTokenizationResultBrand=void 0}}t.$st=g;var A;(function(y){y[y.Method=0]="Method",y[y.Function=1]="Function",y[y.Constructor=2]="Constructor",y[y.Field=3]="Field",y[y.Variable=4]="Variable",y[y.Class=5]="Class",y[y.Struct=6]="Struct",y[y.Interface=7]="Interface",y[y.Module=8]="Module",y[y.Property=9]="Property",y[y.Event=10]="Event",y[y.Operator=11]="Operator",y[y.Unit=12]="Unit",y[y.Value=13]="Value",y[y.Constant=14]="Constant",y[y.Enum=15]="Enum",y[y.EnumMember=16]="EnumMember",y[y.Keyword=17]="Keyword",y[y.Text=18]="Text",y[y.Color=19]="Color",y[y.File=20]="File",y[y.Reference=21]="Reference",y[y.Customcolor=22]="Customcolor",y[y.Folder=23]="Folder",y[y.TypeParameter=24]="TypeParameter",y[y.User=25]="User",y[y.Issue=26]="Issue",y[y.Snippet=27]="Snippet"})(A||(t.CompletionItemKind=A={}));var b;(function(y){const V=new Map;V.set(0,D.$9j.symbolMethod),V.set(1,D.$9j.symbolFunction),V.set(2,D.$9j.symbolConstructor),V.set(3,D.$9j.symbolField),V.set(4,D.$9j.symbolVariable),V.set(5,D.$9j.symbolClass),V.set(6,D.$9j.symbolStruct),V.set(7,D.$9j.symbolInterface),V.set(8,D.$9j.symbolModule),V.set(9,D.$9j.symbolProperty),V.set(10,D.$9j.symbolEvent),V.set(11,D.$9j.symbolOperator),V.set(12,D.$9j.symbolUnit),V.set(13,D.$9j.symbolValue),V.set(15,D.$9j.symbolEnum),V.set(14,D.$9j.symbolConstant),V.set(15,D.$9j.symbolEnum),V.set(16,D.$9j.symbolEnumMember),V.set(17,D.$9j.symbolKeyword),V.set(27,D.$9j.symbolSnippet),V.set(18,D.$9j.symbolText),V.set(19,D.$9j.symbolColor),V.set(20,D.$9j.symbolFile),V.set(21,D.$9j.symbolReference),V.set(22,D.$9j.symbolCustomColor),V.set(23,D.$9j.symbolFolder),V.set(24,D.$9j.symbolTypeParameter),V.set(25,D.$9j.account),V.set(26,D.$9j.issues);function H(te){let n=V.get(te);return n||(console.info("No codicon found for CompletionItemKind "+te),n=D.$9j.symbolProperty),n}y.toIcon=H;const x=new Map;x.set("method",0),x.set("function",1),x.set("constructor",2),x.set("field",3),x.set("variable",4),x.set("class",5),x.set("struct",6),x.set("interface",7),x.set("module",8),x.set("property",9),x.set("event",10),x.set("operator",11),x.set("unit",12),x.set("value",13),x.set("constant",14),x.set("enum",15),x.set("enum-member",16),x.set("enumMember",16),x.set("keyword",17),x.set("snippet",27),x.set("text",18),x.set("color",19),x.set("file",20),x.set("reference",21),x.set("customcolor",22),x.set("folder",23),x.set("type-parameter",24),x.set("typeParameter",24),x.set("account",25),x.set("issue",26);function Y(te,n){let ae=x.get(te);return typeof ae>"u"&&!n&&(ae=9),ae}y.fromString=Y})(b||(t.CompletionItemKinds=b={}));var m;(function(y){y[y.Deprecated=1]="Deprecated"})(m||(t.CompletionItemTag=m={}));var e;(function(y){y[y.None=0]="None",y[y.KeepWhitespace=1]="KeepWhitespace",y[y.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var E;(function(y){y[y.Invoke=0]="Invoke",y[y.TriggerCharacter=1]="TriggerCharacter",y[y.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(E||(t.CompletionTriggerKind=E={}));var R;(function(y){y[y.Automatic=0]="Automatic",y[y.Explicit=1]="Explicit"})(R||(t.InlineCompletionTriggerKind=R={}));class v{constructor(V,H,x,Y){this.range=V,this.text=H,this.completionKind=x,this.isSnippetText=Y}equals(V){return f.$Is.lift(this.range).equalsRange(V.range)&&this.text===V.text&&this.completionKind===V.completionKind&&this.isSnippetText===V.isSnippetText}}t.$tt=v;var $;(function(y){y[y.Invoke=1]="Invoke",y[y.Auto=2]="Auto"})($||(t.CodeActionTriggerType=$={}));var u;(function(y){y[y.Invoke=1]="Invoke",y[y.TriggerCharacter=2]="TriggerCharacter",y[y.ContentChange=3]="ContentChange"})(u||(t.SignatureHelpTriggerKind=u={}));var o;(function(y){y[y.Text=0]="Text",y[y.Read=1]="Read",y[y.Write=2]="Write"})(o||(t.DocumentHighlightKind=o={}));function c(y){return y&&k.URI.isUri(y.uri)&&f.$Is.isIRange(y.range)&&(f.$Is.isIRange(y.originSelectionRange)||f.$Is.isIRange(y.targetSelectionRange))}t.$ut=c;var i;(function(y){y[y.File=0]="File",y[y.Module=1]="Module",y[y.Namespace=2]="Namespace",y[y.Package=3]="Package",y[y.Class=4]="Class",y[y.Method=5]="Method",y[y.Property=6]="Property",y[y.Field=7]="Field",y[y.Constructor=8]="Constructor",y[y.Enum=9]="Enum",y[y.Interface=10]="Interface",y[y.Function=11]="Function",y[y.Variable=12]="Variable",y[y.Constant=13]="Constant",y[y.String=14]="String",y[y.Number=15]="Number",y[y.Boolean=16]="Boolean",y[y.Array=17]="Array",y[y.Object=18]="Object",y[y.Key=19]="Key",y[y.Null=20]="Null",y[y.EnumMember=21]="EnumMember",y[y.Struct=22]="Struct",y[y.Event=23]="Event",y[y.Operator=24]="Operator",y[y.TypeParameter=25]="TypeParameter"})(i||(t.SymbolKind=i={})),t.$vt={[17]:(0,h.localize)(0,null),[16]:(0,h.localize)(1,null),[4]:(0,h.localize)(2,null),[13]:(0,h.localize)(3,null),[8]:(0,h.localize)(4,null),[9]:(0,h.localize)(5,null),[21]:(0,h.localize)(6,null),[23]:(0,h.localize)(7,null),[7]:(0,h.localize)(8,null),[0]:(0,h.localize)(9,null),[11]:(0,h.localize)(10,null),[10]:(0,h.localize)(11,null),[19]:(0,h.localize)(12,null),[5]:(0,h.localize)(13,null),[1]:(0,h.localize)(14,null),[2]:(0,h.localize)(15,null),[20]:(0,h.localize)(16,null),[15]:(0,h.localize)(17,null),[18]:(0,h.localize)(18,null),[24]:(0,h.localize)(19,null),[3]:(0,h.localize)(20,null),[6]:(0,h.localize)(21,null),[14]:(0,h.localize)(22,null),[22]:(0,h.localize)(23,null),[25]:(0,h.localize)(24,null),[12]:(0,h.localize)(25,null)};function a(y,V){return(0,h.localize)(26,null,y,t.$vt[V])}t.$wt=a;var L;(function(y){y[y.Deprecated=1]="Deprecated"})(L||(t.SymbolTag=L={}));var d;(function(y){const V=new Map;V.set(0,D.$9j.symbolFile),V.set(1,D.$9j.symbolModule),V.set(2,D.$9j.symbolNamespace),V.set(3,D.$9j.symbolPackage),V.set(4,D.$9j.symbolClass),V.set(5,D.$9j.symbolMethod),V.set(6,D.$9j.symbolProperty),V.set(7,D.$9j.symbolField),V.set(8,D.$9j.symbolConstructor),V.set(9,D.$9j.symbolEnum),V.set(10,D.$9j.symbolInterface),V.set(11,D.$9j.symbolFunction),V.set(12,D.$9j.symbolVariable),V.set(13,D.$9j.symbolConstant),V.set(14,D.$9j.symbolString),V.set(15,D.$9j.symbolNumber),V.set(16,D.$9j.symbolBoolean),V.set(17,D.$9j.symbolArray),V.set(18,D.$9j.symbolObject),V.set(19,D.$9j.symbolKey),V.set(20,D.$9j.symbolNull),V.set(21,D.$9j.symbolEnumMember),V.set(22,D.$9j.symbolStruct),V.set(23,D.$9j.symbolEvent),V.set(24,D.$9j.symbolOperator),V.set(25,D.$9j.symbolTypeParameter);function H(x){let Y=V.get(x);return Y||(console.info("No codicon found for SymbolKind "+x),Y=D.$9j.symbolProperty),Y}y.toIcon=H})(d||(t.SymbolKinds=d={}));class w{static asEditOperation(V){return r.$Js.replace(f.$Is.lift(V.range),V.text)}}t.$xt=w;class M{static{this.Comment=new M("comment")}static{this.Imports=new M("imports")}static{this.Region=new M("region")}static fromValue(V){switch(V){case"comment":return M.Comment;case"imports":return M.Imports;case"region":return M.Region}return new M(V)}constructor(V){this.value=V}}t.$yt=M;var p;(function(y){function V(H){return!H||typeof H!="object"?!1:typeof H.id=="string"&&typeof H.title=="string"}y.is=V})(p||(t.Command=p={}));var F;(function(y){y[y.Collapsed=0]="Collapsed",y[y.Expanded=1]="Expanded"})(F||(t.CommentThreadCollapsibleState=F={}));var _;(function(y){y[y.Unresolved=0]="Unresolved",y[y.Resolved=1]="Resolved"})(_||(t.CommentThreadState=_={}));var P;(function(y){y[y.Editing=0]="Editing",y[y.Preview=1]="Preview"})(P||(t.CommentMode=P={}));var S;(function(y){y[y.Published=0]="Published",y[y.Draft=1]="Draft"})(S||(t.CommentState=S={}));var T;(function(y){y[y.Type=1]="Type",y[y.Parameter=2]="Parameter"})(T||(t.InlayHintKind=T={}));class q{constructor(V){this.b=V,this.a=null}dispose(){this.a&&this.a.then(V=>{V&&V.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$zt=q,t.$At=new N.$ht;var O;(function(y){y[y.None=0]="None",y[y.Option=1]="Option",y[y.Default=2]="Default",y[y.Preferred=3]="Preferred"})(O||(t.ExternalUriOpenerPriority=O={}))}),ne(ie[68],se([0,1,24,11,37,18,5,2,43,67,59]),function(j,t,D,k,r,f,N,h,l,s,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tZ=t.$sZ=void 0;class A{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,E){return(0,r.$Uq)(e,E)}}t.$sZ=A;function b(){return{editor:void 0,languages:void 0,CancellationTokenSource:D.$3d,Emitter:k.$Sd,KeyCode:g.KeyCode,KeyMod:A,Position:N.$Hs,Range:h.$Is,Selection:l.$Ks,SelectionDirection:g.SelectionDirection,MarkerSeverity:g.MarkerSeverity,MarkerTag:g.MarkerTag,Uri:f.URI,Token:s.$qt}}t.$tZ=b}),ne(ie[71],se([0,1,25,18,5,2,56,29,52,53,68,23,58,33,50,14,3,51]),function(j,t,D,k,r,f,N,h,l,s,g,A,b,m,e,E,R,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class $ extends N.$_u{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(i){const a=[];for(let L=0;L<this.f.length;L++){const d=this.f[L],w=this.offsetAt(new r.$Hs(L+1,1)),M=d.matchAll(i);for(const p of M)(p.index||p.index===0)&&(p.index=p.index+w),a.push(p)}return a}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(i){return this.f[i-1]}getWordAtPosition(i,a){const L=(0,h.$ks)(i.column,(0,h.$is)(a),this.f[i.lineNumber-1],0);return L?new f.$Is(i.lineNumber,L.startColumn,i.lineNumber,L.endColumn):null}getWordUntilPosition(i,a){const L=this.getWordAtPosition(i,a);return L?{word:this.f[i.lineNumber-1].substring(L.startColumn-1,i.column-1),startColumn:L.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const a=this.f,L=this.q.bind(this);let d=0,w="",M=0,p=[];return{*[Symbol.iterator](){for(;;)if(M<p.length){const F=w.substring(p[M].start,p[M].end);M+=1,yield F}else if(d<a.length)w=a[d],p=L(w,i),M=0,d+=1;else break}}}getLineWords(i,a){const L=this.f[i-1],d=this.q(L,a),w=[];for(const M of d)w.push({word:L.substring(M.start,M.end),startColumn:M.start+1,endColumn:M.end+1});return w}q(i,a){const L=[];let d;for(a.lastIndex=0;(d=a.exec(i))&&d[0].length!==0;)L.push({start:d.index,end:d.index+d[0].length});return L}getValueInRange(i){if(i=this.r(i),i.startLineNumber===i.endLineNumber)return this.f[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);const a=this.g,L=i.startLineNumber-1,d=i.endLineNumber-1,w=[];w.push(this.f[L].substring(i.startColumn-1));for(let M=L+1;M<d;M++)w.push(this.f[M]);return w.push(this.f[d].substring(0,i.endColumn-1)),w.join(a)}offsetAt(i){return i=this.s(i),this.l(),this.j.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this.l();const a=this.j.getIndexOf(i),L=this.f[a.index].length;return{lineNumber:1+a.index,column:1+Math.min(a.remainder,L)}}r(i){const a=this.s({lineNumber:i.startLineNumber,column:i.startColumn}),L=this.s({lineNumber:i.endLineNumber,column:i.endColumn});return a.lineNumber!==i.startLineNumber||a.column!==i.startColumn||L.lineNumber!==i.endLineNumber||L.column!==i.endColumn?{startLineNumber:a.lineNumber,startColumn:a.column,endLineNumber:L.lineNumber,endColumn:L.column}:i}s(i){if(!r.$Hs.isIPosition(i))throw new Error("bad position");let{lineNumber:a,column:L}=i,d=!1;if(a<1)a=1,L=1,d=!0;else if(a>this.f.length)a=this.f.length,L=this.f[a-1].length+1,d=!0;else{const w=this.f[a-1].length+1;L<1?(L=1,d=!0):L>w&&(L=w,d=!0)}return d?{lineNumber:a,column:L}:i}}class u{constructor(i,a){this.d=i,this.f=Object.create(null),this.g=a,this.h=null}dispose(){this.f=Object.create(null)}j(i){return this.f[i]}k(){const i=[];return Object.keys(this.f).forEach(a=>i.push(this.f[a])),i}acceptNewModel(i){this.f[i.url]=new $(k.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,a){if(!this.f[i])return;this.f[i].onEvents(a)}acceptRemovedModel(i){this.f[i]&&delete this.f[i]}async computeUnicodeHighlights(i,a,L){const d=this.j(i);return d?b.$nZ.computeUnicodeHighlights(d,a,L):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(i,a,L,d){const w=this.j(i),M=this.j(a);return!w||!M?null:u.l(w,M,L,d)}static l(i,a,L,d){const w=d==="advanced"?e.$PZ.getDefault():e.$PZ.getLegacy(),M=i.getLinesContent(),p=a.getLinesContent(),F=w.computeDiff(M,p,L),_=F.changes.length>0?!1:this.n(i,a);function P(S){return S.map(T=>[T.original.startLineNumber,T.original.endLineNumberExclusive,T.modified.startLineNumber,T.modified.endLineNumberExclusive,T.innerChanges?.map(q=>[q.originalRange.startLineNumber,q.originalRange.startColumn,q.originalRange.endLineNumber,q.originalRange.endColumn,q.modifiedRange.startLineNumber,q.modifiedRange.startColumn,q.modifiedRange.endLineNumber,q.modifiedRange.endColumn])])}return{identical:_,quitEarly:F.hitTimeout,changes:P(F.changes),moves:F.moves.map(S=>[S.lineRangeMapping.original.startLineNumber,S.lineRangeMapping.original.endLineNumberExclusive,S.lineRangeMapping.modified.startLineNumber,S.lineRangeMapping.modified.endLineNumberExclusive,P(S.changes)])}}static n(i,a){const L=i.getLineCount(),d=a.getLineCount();if(L!==d)return!1;for(let w=1;w<=L;w++){const M=i.getLineContent(w),p=a.getLineContent(w);if(M!==p)return!1}return!0}async computeDirtyDiff(i,a,L){const d=this.j(i),w=this.j(a);if(!d||!w)return null;const M=d.getLinesContent(),p=w.getLinesContent();return new m.$Zs(M,p,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:L,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(i,a,L){const d=this.j(i);if(!d)return a;const w=[];let M;a=a.slice(0).sort((F,_)=>{if(F.range&&_.range)return f.$Is.compareRangesUsingStarts(F.range,_.range);const P=F.range?0:1,S=_.range?0:1;return P-S});let p=0;for(let F=1;F<a.length;F++)f.$Is.getEndPosition(a[p].range).equals(f.$Is.getStartPosition(a[F].range))?(a[p].range=f.$Is.fromPositions(f.$Is.getStartPosition(a[p].range),f.$Is.getEndPosition(a[F].range)),a[p].text+=a[F].text):(p++,a[p]=a[F]);a.length=p+1;for(let{range:F,text:_,eol:P}of a){if(typeof P=="number"&&(M=P),f.$Is.isEmpty(F)&&!_)continue;const S=d.getValueInRange(F);if(_=_.replace(/\r\n|\n|\r/g,d.eol),S===_)continue;if(Math.max(_.length,S.length)>u.o){w.push({range:F,text:_});continue}const T=(0,D.$Ns)(S,_,L),q=d.offsetAt(f.$Is.lift(F).getStartPosition());for(const O of T){const y=d.positionAt(q+O.originalStart),V=d.positionAt(q+O.originalStart+O.originalLength),H={text:_.substr(O.modifiedStart,O.modifiedLength),range:{startLineNumber:y.lineNumber,startColumn:y.column,endLineNumber:V.lineNumber,endColumn:V.column}};d.getValueInRange(H.range)!==H.text&&w.push(H)}}return typeof M=="number"&&w.push({eol:M,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}computeHumanReadableDiff(i,a,L){const d=this.j(i);if(!d)return a;const w=[];let M;a=a.slice(0).sort((p,F)=>{if(p.range&&F.range)return f.$Is.compareRangesUsingStarts(p.range,F.range);const _=p.range?0:1,P=F.range?0:1;return _-P});for(let{range:p,text:F,eol:_}of a){let y=function(H,x){return new r.$Hs(H.lineNumber+x.lineNumber-1,x.lineNumber===1?H.column+x.column-1:x.column)},V=function(H,x){const Y=[];for(let te=x.startLineNumber;te<=x.endLineNumber;te++){const n=H[te-1];te===x.startLineNumber&&te===x.endLineNumber?Y.push(n.substring(x.startColumn-1,x.endColumn-1)):te===x.startLineNumber?Y.push(n.substring(x.startColumn-1)):te===x.endLineNumber?Y.push(n.substring(0,x.endColumn-1)):Y.push(n)}return Y};if(typeof _=="number"&&(M=_),f.$Is.isEmpty(p)&&!F)continue;const P=d.getValueInRange(p);if(F=F.replace(/\r\n|\n|\r/g,d.eol),P===F)continue;if(Math.max(F.length,P.length)>u.o){w.push({range:p,text:F});continue}const S=P.split(/\r\n|\n|\r/),T=F.split(/\r\n|\n|\r/),q=e.$PZ.getDefault().computeDiff(S,T,L),O=f.$Is.lift(p).getStartPosition();for(const H of q.changes)if(H.innerChanges)for(const x of H.innerChanges)w.push({range:f.$Is.fromPositions(y(O,x.originalRange.getStartPosition()),y(O,x.originalRange.getEndPosition())),text:V(T,x.modifiedRange).join(d.eol)});else throw new R.$cb("The experimental diff algorithm always produces inner changes")}return typeof M=="number"&&w.push({eol:M,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}async computeLinks(i){const a=this.j(i);return a?(0,l.$qZ)(a):null}async computeDefaultDocumentColors(i){const a=this.j(i);return a?(0,v.$QZ)(a):null}static{this.p=1e4}async textualSuggest(i,a,L,d){const w=new A.$Od,M=new RegExp(L,d),p=new Set;e:for(const F of i){const _=this.j(F);if(_){for(const P of _.words(M))if(!(P===a||!isNaN(Number(P)))&&(p.add(P),p.size>u.p))break e}}return{words:Array.from(p),duration:w.elapsed()}}async computeWordRanges(i,a,L,d){const w=this.j(i);if(!w)return Object.create(null);const M=new RegExp(L,d),p=Object.create(null);for(let F=a.startLineNumber;F<a.endLineNumber;F++){const _=w.getLineWords(F,M);for(const P of _){if(!isNaN(Number(P.word)))continue;let S=p[P.word];S||(S=[],p[P.word]=S),S.push({startLineNumber:F,startColumn:P.startColumn,endLineNumber:F,endColumn:P.endColumn})}}return p}async navigateValueSet(i,a,L,d,w){const M=this.j(i);if(!M)return null;const p=new RegExp(d,w);a.startColumn===a.endColumn&&(a={startLineNumber:a.startLineNumber,startColumn:a.startColumn,endLineNumber:a.endLineNumber,endColumn:a.endColumn+1});const F=M.getValueInRange(a),_=M.getWordAtPosition({lineNumber:a.startLineNumber,column:a.startColumn},p);if(!_)return null;const P=M.getValueInRange(_);return s.$rZ.INSTANCE.navigateValueSet(a,F,_,P,L)}loadForeignModule(i,a,L){const d=(p,F)=>this.d.fhr(p,F),M={host:(0,E.$un)(L,d),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(M,a),Promise.resolve((0,E.$tn)(this.h))):new Promise((p,F)=>{j([i],_=>{this.h=_.create(M,a),p((0,E.$tn)(this.h))},F)})}fmr(i,a){if(!this.h||typeof this.h[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this.h[i].apply(this.h,a))}catch(L){return Promise.reject(L)}}}t.EditorSimpleWorker=u;function o(c){return new u(c,null)}t.create=o,typeof importScripts=="function"&&(globalThis.monaco=(0,g.$tZ)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a017b12b9caa3475675cfe6fda014fcf5af388c9/core/vs/base/worker/workerMain.js.map
