/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/cancellation","vs/base/common/arrays","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/base/common/objects","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","vs/base/common/hash","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/window/common/window","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/backup/electron-main/backup","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],oe=function(J){for(var e=[],P=0,R=J.length;P<R;P++)e[P]=re[J[P]];return e};define(re[134],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function P(w,$,g){const u=R(w,$);if(u!==-1)return w[u]}e.$fb=P;function R(w,$,g=w.length-1){for(let u=g;u>=0;u--){const c=w[u];if($(c))return u}return-1}e.$gb=R;function s(w,$){const g=j(w,$);return g===-1?void 0:w[g]}e.$hb=s;function j(w,$,g=0,u=w.length){let c=g,S=u;for(;c<S;){const d=Math.floor((c+S)/2);$(w[d])?c=d+1:S=d}return c-1}e.$ib=j;function A(w,$){const g=E(w,$);return g===w.length?void 0:w[g]}e.$jb=A;function E(w,$,g=0,u=w.length){let c=g,S=u;for(;c<S;){const d=Math.floor((c+S)/2);$(w[d])?S=d:c=d+1}return c}e.$kb=E;function f(w,$,g=0,u=w.length){const c=E(w,$,g,u);return c===w.length?-1:c}e.$lb=f;class h{static{this.assertInvariants=!1}constructor($){this.e=$,this.c=0}findLastMonotonous($){if(h.assertInvariants){if(this.d){for(const u of this.e)if(this.d(u)&&!$(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=$}const g=j(this.e,$,this.c);return this.c=g+1,g===-1?void 0:this.e[g]}}e.$mb=h;function y(w,$){if(w.length===0)return;let g=w[0];for(let u=1;u<w.length;u++){const c=w[u];$(c,g)>0&&(g=c)}return g}e.$nb=y;function v(w,$){if(w.length===0)return;let g=w[0];for(let u=1;u<w.length;u++){const c=w[u];$(c,g)>=0&&(g=c)}return g}e.$ob=v;function b(w,$){return y(w,(g,u)=>-$(g,u))}e.$pb=b;function l(w,$){if(w.length===0)return-1;let g=0;for(let u=1;u<w.length;u++){const c=w[u];$(c,w[g])>0&&(g=u)}return g}e.$qb=l;function p(w,$){for(const g of w){const u=$(g);if(u!==void 0)return u}}e.$rb=p}),define(re[135],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function P(A,E){const f=Object.create(null);for(const h of A){const y=E(h);let v=f[y];v||(v=f[y]=[]),v.push(h)}return f}e.$K=P;function R(A,E){const f=[],h=[];for(const y of A)E.has(y)||f.push(y);for(const y of E)A.has(y)||h.push(y);return{removed:f,added:h}}e.$L=R;function s(A,E){const f=[],h=[];for(const[y,v]of A)E.has(y)||f.push(v);for(const[y,v]of E)A.has(y)||h.push(v);return{removed:f,added:h}}e.$M=s;function j(A,E){const f=new Set;for(const h of E)A.has(h)&&f.add(h);return f}e.$N=j}),define(re[136],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$at=e.$_s=e.$$s=e.$0s=void 0;function P(E,f){const h=Math.pow(10,f);return Math.round(E*h)/h}class R{constructor(f,h,y,v=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,h))|0,this.b=Math.min(255,Math.max(0,y))|0,this.a=P(Math.max(Math.min(1,v),0),3)}static equals(f,h){return f.r===h.r&&f.g===h.g&&f.b===h.b&&f.a===h.a}}e.$0s=R;class s{constructor(f,h,y,v){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=P(Math.max(Math.min(1,h),0),3),this.l=P(Math.max(Math.min(1,y),0),3),this.a=P(Math.max(Math.min(1,v),0),3)}static equals(f,h){return f.h===h.h&&f.s===h.s&&f.l===h.l&&f.a===h.a}static fromRGBA(f){const h=f.r/255,y=f.g/255,v=f.b/255,b=f.a,l=Math.max(h,y,v),p=Math.min(h,y,v);let w=0,$=0;const g=(p+l)/2,u=l-p;if(u>0){switch($=Math.min(g<=.5?u/(2*g):u/(2-2*g),1),l){case h:w=(y-v)/u+(y<v?6:0);break;case y:w=(v-h)/u+2;break;case v:w=(h-y)/u+4;break}w*=60,w=Math.round(w)}return new s(w,$,g,b)}static i(f,h,y){return y<0&&(y+=1),y>1&&(y-=1),y<1/6?f+(h-f)*6*y:y<1/2?h:y<2/3?f+(h-f)*(2/3-y)*6:f}static toRGBA(f){const h=f.h/360,{s:y,l:v,a:b}=f;let l,p,w;if(y===0)l=p=w=v;else{const $=v<.5?v*(1+y):v+y-v*y,g=2*v-$;l=s.i(g,$,h+1/3),p=s.i(g,$,h),w=s.i(g,$,h-1/3)}return new R(Math.round(l*255),Math.round(p*255),Math.round(w*255),b)}}e.$$s=s;class j{constructor(f,h,y,v){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=P(Math.max(Math.min(1,h),0),3),this.v=P(Math.max(Math.min(1,y),0),3),this.a=P(Math.max(Math.min(1,v),0),3)}static equals(f,h){return f.h===h.h&&f.s===h.s&&f.v===h.v&&f.a===h.a}static fromRGBA(f){const h=f.r/255,y=f.g/255,v=f.b/255,b=Math.max(h,y,v),l=Math.min(h,y,v),p=b-l,w=b===0?0:p/b;let $;return p===0?$=0:b===h?$=((y-v)/p%6+6)%6:b===y?$=(v-h)/p+2:$=(h-y)/p+4,new j(Math.round($*60),w,b,f.a)}static toRGBA(f){const{h,s:y,v,a:b}=f,l=v*y,p=l*(1-Math.abs(h/60%2-1)),w=v-l;let[$,g,u]=[0,0,0];return h<60?($=l,g=p):h<120?($=p,g=l):h<180?(g=l,u=p):h<240?(g=p,u=l):h<300?($=p,u=l):h<=360&&($=l,u=p),$=Math.round(($+w)*255),g=Math.round((g+w)*255),u=Math.round((u+w)*255),new R($,g,u,b)}}e.$_s=j;class A{static fromHex(f){return A.Format.CSS.parseHex(f)||A.red}static equals(f,h){return!f&&!h?!0:!f||!h?!1:f.equals(h)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:j.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof R)this.rgba=f;else if(f instanceof s)this.i=f,this.rgba=s.toRGBA(f);else if(f instanceof j)this.j=f,this.rgba=j.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&R.equals(this.rgba,f.rgba)&&s.equals(this.hsla,f.hsla)&&j.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=A.k(this.rgba.r),h=A.k(this.rgba.g),y=A.k(this.rgba.b),v=.2126*f+.7152*h+.0722*y;return P(v,4)}static k(f){const h=f/255;return h<=.03928?h/12.92:Math.pow((h+.055)/1.055,2.4)}getContrastRatio(f){const h=this.getRelativeLuminance(),y=f.getRelativeLuminance();return h>y?(h+.05)/(y+.05):(y+.05)/(h+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const h=this.getRelativeLuminance(),y=f.getRelativeLuminance();return h>y}isDarkerThan(f){const h=this.getRelativeLuminance(),y=f.getRelativeLuminance();return h<y}lighten(f){return new A(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new A(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:h,g:y,b:v,a:b}=this.rgba;return new A(new R(h,y,v,b*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new A(new R(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const h=f.rgba,y=this.rgba.a,v=h.a,b=y+v*(1-y);if(b<1e-6)return A.transparent;const l=this.rgba.r*y/b+h.r*v*(1-y)/b,p=this.rgba.g*y/b+h.g*v*(1-y)/b,w=this.rgba.b*y/b+h.b*v*(1-y)/b;return new A(new R(l,p,w,b))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:h,g:y,b:v,a:b}=this.rgba;return new A(new R(f.rgba.r-b*(f.rgba.r-h),f.rgba.g-b*(f.rgba.g-y),f.rgba.b-b*(f.rgba.b-v),1))}flatten(...f){const h=f.reduceRight((y,v)=>A.o(v,y));return A.o(this,h)}static o(f,h){const y=1-f.rgba.a;return new A(new R(y*h.rgba.r+f.rgba.a*f.rgba.r,y*h.rgba.g+f.rgba.a*f.rgba.g,y*h.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=A.Format.CSS.format(this)),this.u}static getLighterColor(f,h,y){if(f.isLighterThan(h))return f;y=y||.5;const v=f.getRelativeLuminance(),b=h.getRelativeLuminance();return y=y*(b-v)/b,f.lighten(y)}static getDarkerColor(f,h,y){if(f.isDarkerThan(h))return f;y=y||.5;const v=f.getRelativeLuminance(),b=h.getRelativeLuminance();return y=y*(v-b)/v,f.darken(y)}static{this.white=new A(new R(255,255,255,1))}static{this.black=new A(new R(0,0,0,1))}static{this.red=new A(new R(255,0,0,1))}static{this.blue=new A(new R(0,0,255,1))}static{this.green=new A(new R(0,255,0,1))}static{this.cyan=new A(new R(0,255,255,1))}static{this.lightgrey=new A(new R(211,211,211,1))}static{this.transparent=new A(new R(0,0,0,0))}}e.$at=A,function(E){let f;(function(h){let y;(function(v){function b(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:E.Format.CSS.formatRGBA(t)}v.formatRGB=b;function l(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}v.formatRGBA=l;function p(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:E.Format.CSS.formatHSLA(t)}v.formatHSL=p;function w(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}v.formatHSLA=w;function $(t){const o=t.toString(16);return o.length!==2?"0"+o:o}function g(t){return`#${$(t.rgba.r)}${$(t.rgba.g)}${$(t.rgba.b)}`}v.formatHex=g;function u(t,o=!1){return o&&t.rgba.a===1?E.Format.CSS.formatHex(t):`#${$(t.rgba.r)}${$(t.rgba.g)}${$(t.rgba.b)}${$(Math.round(t.rgba.a*255))}`}v.formatHexA=u;function c(t){return t.isOpaque()?E.Format.CSS.formatHex(t):E.Format.CSS.formatRGBA(t)}v.format=c;function S(t){const o=t.length;if(o===0||t.charCodeAt(0)!==35)return null;if(o===7){const r=16*d(t.charCodeAt(1))+d(t.charCodeAt(2)),i=16*d(t.charCodeAt(3))+d(t.charCodeAt(4)),n=16*d(t.charCodeAt(5))+d(t.charCodeAt(6));return new E(new R(r,i,n,1))}if(o===9){const r=16*d(t.charCodeAt(1))+d(t.charCodeAt(2)),i=16*d(t.charCodeAt(3))+d(t.charCodeAt(4)),n=16*d(t.charCodeAt(5))+d(t.charCodeAt(6)),a=16*d(t.charCodeAt(7))+d(t.charCodeAt(8));return new E(new R(r,i,n,a/255))}if(o===4){const r=d(t.charCodeAt(1)),i=d(t.charCodeAt(2)),n=d(t.charCodeAt(3));return new E(new R(16*r+r,16*i+i,16*n+n))}if(o===5){const r=d(t.charCodeAt(1)),i=d(t.charCodeAt(2)),n=d(t.charCodeAt(3)),a=d(t.charCodeAt(4));return new E(new R(16*r+r,16*i+i,16*n+n,(16*a+a)/255))}return null}v.parseHex=S;function d(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(y=h.CSS||(h.CSS={}))})(f=E.Format||(E.Format={}))}(A||(e.$at=A={}))}),define(re[50],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.$vh=e.$uh=void 0;function P(A){return(E,f,h)=>{let y=null,v=null;if(typeof h.value=="function"?(y="value",v=h.value):typeof h.get=="function"&&(y="get",v=h.get),!v)throw new Error("not supported");h[y]=A(v,f)}}function R(A,E,f){let h=null,y=null;if(typeof f.value=="function"?(h="value",y=f.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(h="get",y=f.get),!y)throw new Error("not supported");const v=`$memoize$${E}`;f[h]=function(...b){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,b)}),this[v]}}e.$uh=R;function s(A,E,f){return P((h,y)=>{const v=`$debounce$${y}`,b=`$debounce$result$${y}`;return function(...l){this[b]||(this[b]=f?f():void 0),clearTimeout(this[v]),E&&(this[b]=E(this[b],...l),l=[this[b]]),this[v]=setTimeout(()=>{h.apply(this,l),this[b]=f?f():void 0},A)}})}e.$vh=s;function j(A,E,f){return P((h,y)=>{const v=`$throttle$timer$${y}`,b=`$throttle$result$${y}`,l=`$throttle$lastRun$${y}`,p=`$throttle$pending$${y}`;return function(...w){if(this[b]||(this[b]=f?f():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),E&&(this[b]=E(this[b],...w)),this[p])return;const $=this[l]+A;$<=Date.now()?(this[l]=Date.now(),h.apply(this,[this[b]]),this[b]=f?f():void 0):(this[p]=!0,this[v]=setTimeout(()=>{this[p]=!1,this[l]=Date.now(),h.apply(this,[this[b]]),this[b]=f?f():void 0},$-Date.now()))}})}e.$wh=j}),define(re[14],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class P{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?c.isErrorNoTelemetry(t)?new c(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=P,e.$X=new P;function R(d){e.$X.setUnexpectedErrorHandler(d)}e.setUnexpectedErrorHandler=R;function s(d){if(!d||typeof d!="object")return!1;const t=d;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=s;function j(d){h(d)||e.$X.onUnexpectedError(d)}e.$1=j;function A(d){h(d)||e.$X.onUnexpectedExternalError(d)}e.$2=A;function E(d){if(d instanceof Error){const{name:t,message:o}=d,r=d.stacktrace||d.stack;return{$isError:!0,name:t,message:o,stack:r,noTelemetry:c.isErrorNoTelemetry(d)}}return d}e.$3=E;const f="Canceled";function h(d){return d instanceof y?!0:d instanceof Error&&d.name===f&&d.message===f}e.$4=h;class y extends Error{constructor(){super(f),this.name=this.message}}e.$5=y;function v(){const d=new Error(f);return d.name=d.message,d}e.$6=v;function b(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}e.$7=b;function l(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}e.$8=l;class p extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=p;function w(d){return d?d.message?d.message:d.stack?d.stack.split(`
`)[0]:String(d):"Error"}e.$0=w;class $ extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=$;class g extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=g;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=u;class c extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof c)return t;const o=new c;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=c;class S extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,S.prototype)}}e.$cb=S}),define(re[23],oe([0,1,14,134]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function s(z,Y=0){return z[z.length-(1+Y)]}e.$sb=s;function j(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.$tb=j;function A(z,Y,W=(B,_)=>B===_){if(z===Y)return!0;if(!z||!Y||z.length!==Y.length)return!1;for(let B=0,_=z.length;B<_;B++)if(!W(z[B],Y[B]))return!1;return!0}e.$ub=A;function E(z,Y){const W=z.length-1;Y<W&&(z[Y]=z[W]),z.pop()}e.$vb=E;function f(z,Y,W){return h(z.length,B=>W(z[B],Y))}e.$wb=f;function h(z,Y){let W=0,B=z-1;for(;W<=B;){const _=(W+B)/2|0,ae=Y(_);if(ae<0)W=_+1;else if(ae>0)B=_-1;else return _}return-(W+1)}e.$xb=h;function y(z,Y,W){if(z=z|0,z>=Y.length)throw new TypeError("invalid index");const B=Y[Math.floor(Y.length*Math.random())],_=[],ae=[],se=[];for(const $e of Y){const me=W($e,B);me<0?_.push($e):me>0?ae.push($e):se.push($e)}return z<_.length?y(z,_,W):z<_.length+se.length?se[0]:y(z-(_.length+se.length),ae,W)}e.$yb=y;function v(z,Y){const W=[];let B;for(const _ of z.slice(0).sort(Y))!B||Y(B[0],_)!==0?(B=[_],W.push(B)):B.push(_);return W}e.$zb=v;function*b(z,Y){let W,B;for(const _ of z)B!==void 0&&Y(B,_)?W.push(_):(W&&(yield W),W=[_]),B=_;W&&(yield W)}e.$Ab=b;function l(z,Y){for(let W=0;W<=z.length;W++)Y(W===0?void 0:z[W-1],W===z.length?void 0:z[W])}e.$Bb=l;function p(z,Y){for(let W=0;W<z.length;W++)Y(W===0?void 0:z[W-1],z[W],W+1===z.length?void 0:z[W+1])}e.$Cb=p;function w(z,Y,W){const B=[];function _($e,me,ye){if(me===0&&ye.length===0)return;const Pe=B[B.length-1];Pe&&Pe.start+Pe.deleteCount===$e?(Pe.deleteCount+=me,Pe.toInsert.push(...ye)):B.push({start:$e,deleteCount:me,toInsert:ye})}let ae=0,se=0;for(;;){if(ae===z.length){_(ae,0,Y.slice(se));break}if(se===Y.length){_(ae,z.length-ae,[]);break}const $e=z[ae],me=Y[se],ye=W($e,me);ye===0?(ae+=1,se+=1):ye<0?(_(ae,1,[]),ae+=1):ye>0&&(_(ae,0,[me]),se+=1)}return B}e.$Db=w;function $(z,Y,W){const B=w(z,Y,W),_=[],ae=[];for(const se of B)_.push(...z.slice(se.start,se.start+se.deleteCount)),ae.push(...se.toInsert);return{removed:_,added:ae}}e.$Eb=$;function g(z,Y,W){if(W===0)return[];const B=z.slice(0,W).sort(Y);return c(z,Y,B,W,z.length),B}e.top=g;function u(z,Y,W,B,_){return W===0?Promise.resolve([]):new Promise((ae,se)=>{(async()=>{const $e=z.length,me=z.slice(0,W).sort(Y);for(let ye=W,Pe=Math.min(W+B,$e);ye<$e;ye=Pe,Pe=Math.min(Pe+B,$e)){if(ye>W&&await new Promise(Le=>setTimeout(Le)),_&&_.isCancellationRequested)throw new P.$5;c(z,Y,me,ye,Pe)}return me})().then(ae,se)})}e.$Gb=u;function c(z,Y,W,B,_){for(const ae=W.length;B<_;B++){const se=z[B];if(Y(se,W[ae-1])<0){W.pop();const $e=(0,R.$kb)(W,me=>Y(se,me)<0);W.splice($e,0,se)}}}function S(z){return z.filter(Y=>!!Y)}e.$Hb=S;function d(z){let Y=0;for(let W=0;W<z.length;W++)z[W]&&(z[Y]=z[W],Y+=1);z.length=Y}e.$Ib=d;function t(z,Y,W){z.splice(W,0,z.splice(Y,1)[0])}e.$Jb=t;function o(z){return!Array.isArray(z)||z.length===0}e.$Kb=o;function r(z){return Array.isArray(z)&&z.length>0}e.$Lb=r;function i(z,Y=W=>W){const W=new Set;return z.filter(B=>{const _=Y(B);return W.has(_)?!1:(W.add(_),!0)})}e.$Mb=i;function n(z){const Y=new Set;return W=>{const B=z(W);return Y.has(B)?!1:(Y.add(B),!0)}}e.$Nb=n;function a(z,Y){return z.length>0?z[0]:Y}e.$Ob=a;function m(z,Y){return z.length>0?z[z.length-1]:Y}e.$Pb=m;function D(z,Y,W=(B,_)=>B===_){let B=0;for(let _=0,ae=Math.min(z.length,Y.length);_<ae&&W(z[_],Y[_]);_++)B++;return B}e.$Qb=D;function I(z){return[].concat(...z)}e.$Rb=I;function k(z,Y){let W=typeof Y=="number"?z:0;typeof Y=="number"?W=z:(W=0,Y=z);const B=[];if(W<=Y)for(let _=W;_<Y;_++)B.push(_);else for(let _=W;_>Y;_--)B.push(_);return B}e.$Sb=k;function C(z,Y,W){return z.reduce((B,_)=>(B[Y(_)]=W?W(_):_,B),Object.create(null))}e.$Tb=C;function M(z,Y){return z.push(Y),()=>F(z,Y)}e.$Ub=M;function F(z,Y){const W=z.indexOf(Y);if(W>-1)return z.splice(W,1),Y}e.$Vb=F;function N(z,Y,W){const B=z.slice(0,Y),_=z.slice(Y);return B.concat(W,_)}e.$Wb=N;function Z(z,Y){let W;if(typeof Y=="number"){let B=Y;W=()=>{const _=Math.sin(B++)*179426549;return _-Math.floor(_)}}else W=Math.random;for(let B=z.length-1;B>0;B-=1){const _=Math.floor(W()*(B+1)),ae=z[B];z[B]=z[_],z[_]=ae}}e.$Xb=Z;function Q(z,Y){const W=z.indexOf(Y);W>-1&&(z.splice(W,1),z.unshift(Y))}e.$Yb=Q;function le(z,Y){const W=z.indexOf(Y);W>-1&&(z.splice(W,1),z.push(Y))}e.$Zb=le;function ce(z,Y){for(const W of Y)z.push(W)}e.$1b=ce;function ue(z,Y){return Array.isArray(z)?z.map(Y):Y(z)}e.$2b=ue;function X(z){return Array.isArray(z)?z:[z]}e.$3b=X;function K(z){return z[Math.floor(Math.random()*z.length)]}e.$4b=K;function H(z,Y,W){const B=T(z,Y),_=z.length,ae=W.length;z.length=_+ae;for(let se=_-1;se>=B;se--)z[se+ae]=z[se];for(let se=0;se<ae;se++)z[se+B]=W[se]}e.$5b=H;function L(z,Y,W,B){const _=T(z,Y);let ae=z.splice(_,W);return ae===void 0&&(ae=[]),H(z,_,B),ae}e.$6b=L;function T(z,Y){return Y<0?Math.max(Y+z.length,0):Math.min(Y,z.length)}var V;(function(z){function Y(ae){return ae<0}z.isLessThan=Y;function W(ae){return ae<=0}z.isLessThanOrEqual=W;function B(ae){return ae>0}z.isGreaterThan=B;function _(ae){return ae===0}z.isNeitherLessOrGreaterThan=_,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(V||(e.CompareResult=V={}));function q(z,Y){return(W,B)=>Y(z(W),z(B))}e.$7b=q;function te(...z){return(Y,W)=>{for(const B of z){const _=B(Y,W);if(!V.isNeitherLessOrGreaterThan(_))return _}return V.neitherLessOrGreaterThan}}e.$8b=te;const he=(z,Y)=>z-Y;e.$9b=he;const G=(z,Y)=>(0,e.$9b)(z?1:0,Y?1:0);e.$0b=G;function O(z){return(Y,W)=>-z(Y,W)}e.$$b=O;class U{constructor(Y){this.g=Y,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Y){let W=this.c;for(;W<this.g.length&&Y(this.g[W]);)W++;const B=W===this.c?null:this.g.slice(this.c,W);return this.c=W,B}takeFromEndWhile(Y){let W=this.d;for(;W>=0&&Y(this.g[W]);)W--;const B=W===this.d?null:this.g.slice(W+1,this.d+1);return this.d=W,B}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Y=this.g[this.c];return this.c++,Y}removeLast(){const Y=this.g[this.d];return this.d--,Y}takeCount(Y){const W=this.g.slice(this.c,this.c+Y);return this.c+=Y,W}}e.$_b=U;class x{static{this.empty=new x(Y=>{})}constructor(Y){this.iterate=Y}forEach(Y){this.iterate(W=>(Y(W),!0))}toArray(){const Y=[];return this.iterate(W=>(Y.push(W),!0)),Y}filter(Y){return new x(W=>this.iterate(B=>Y(B)?W(B):!0))}map(Y){return new x(W=>this.iterate(B=>W(Y(B))))}some(Y){let W=!1;return this.iterate(B=>(W=Y(B),!W)),W}findFirst(Y){let W;return this.iterate(B=>Y(B)?(W=B,!1):!0),W}findLast(Y){let W;return this.iterate(B=>(Y(B)&&(W=B),!0)),W}findLastMaxBy(Y){let W,B=!0;return this.iterate(_=>((B||V.isGreaterThan(Y(_,W)))&&(B=!1,W=_),!0)),W}}e.$ac=x}),define(re[137],oe([0,1,14]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=e.$7c=e.$6c=e.$5c=e.ok=void 0;function R(f,h){if(!f)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}e.ok=R;function s(f,h="Unreachable"){throw new Error(h)}e.$5c=s;function j(f){if(!f)throw new P.$cb("Assertion Failed")}e.$6c=j;function A(f){if(!f()){debugger;f(),(0,P.$1)(new P.$cb("Assertion Failed"))}}e.$7c=A;function E(f,h){let y=0;for(;y<f.length-1;){const v=f[y],b=f[y+1];if(!h(v,b))return!1;y++}return!0}e.$8c=E}),define(re[84],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function P(R,s){const j=this;let A=!1,E;return function(){if(A)return E;if(A=!0,s)try{E=R.apply(j,arguments)}finally{s()}else E=R.apply(j,arguments);return E}}e.$db=P}),define(re[72],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var P;(function(R){function s(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}R.is=s;const j=Object.freeze([]);function A(){return j}R.empty=A;function*E(t){yield t}R.single=E;function f(t){return s(t)?t:E(t)}R.wrap=f;function h(t){return t||j}R.from=h;function*y(t){for(let o=t.length-1;o>=0;o--)yield t[o]}R.reverse=y;function v(t){return!t||t[Symbol.iterator]().next().done===!0}R.isEmpty=v;function b(t){return t[Symbol.iterator]().next().value}R.first=b;function l(t,o){for(const r of t)if(o(r))return!0;return!1}R.some=l;function p(t,o){for(const r of t)if(o(r))return r}R.find=p;function*w(t,o){for(const r of t)o(r)&&(yield r)}R.filter=w;function*$(t,o){let r=0;for(const i of t)yield o(i,r++)}R.map=$;function*g(...t){for(const o of t)yield*o}R.concat=g;function u(t,o,r){let i=r;for(const n of t)i=o(i,n);return i}R.reduce=u;function*c(t,o,r=t.length){for(o<0&&(o+=t.length),r<0?r+=t.length:r>t.length&&(r=t.length);o<r;o++)yield t[o]}R.slice=c;function S(t,o=Number.POSITIVE_INFINITY){const r=[];if(o===0)return[r,t];const i=t[Symbol.iterator]();for(let n=0;n<o;n++){const a=i.next();if(a.done)return[r,R.empty()];r.push(a.value)}return[r,{[Symbol.iterator](){return i}}]}R.consume=S;async function d(t){const o=[];for await(const r of t)o.push(r);return Promise.resolve(o)}R.asyncToArray=d})(P||(e.Iterable=P={}))}),define(re[44],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var P;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var s;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var j;(function(t){t.DEFAULT={allowTrailingComma:!0}})(j||(e.ParseOptions=j={}));function A(t,o=!1){let r=0;const i=t.length;let n="",a=0,m=16,D=0;function I(Q){let le=0,ce=0;for(;le<Q;){const ue=t.charCodeAt(r);if(ue>=48&&ue<=57)ce=ce*16+ue-48;else if(ue>=65&&ue<=70)ce=ce*16+ue-65+10;else if(ue>=97&&ue<=102)ce=ce*16+ue-97+10;else break;r++,le++}return le<Q&&(ce=-1),ce}function k(Q){r=Q,n="",a=0,m=16,D=0}function C(){const Q=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&h(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&h(t.charCodeAt(r)))for(r++;r<t.length&&h(t.charCodeAt(r));)r++;else return D=3,t.substring(Q,r);let le=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&h(t.charCodeAt(r))){for(r++;r<t.length&&h(t.charCodeAt(r));)r++;le=r}else D=3;return t.substring(Q,le)}function M(){let Q="",le=r;for(;;){if(r>=i){Q+=t.substring(le,r),D=2;break}const ce=t.charCodeAt(r);if(ce===34){Q+=t.substring(le,r),r++;break}if(ce===92){if(Q+=t.substring(le,r),r++,r>=i){D=2;break}switch(t.charCodeAt(r++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:{const X=I(4);X>=0?Q+=String.fromCharCode(X):D=4;break}default:D=5}le=r;continue}if(ce>=0&&ce<=31)if(f(ce)){Q+=t.substring(le,r),D=2;break}else D=6;r++}return Q}function F(){if(n="",D=0,a=r,r>=i)return a=i,m=17;let Q=t.charCodeAt(r);if(E(Q)){do r++,n+=String.fromCharCode(Q),Q=t.charCodeAt(r);while(E(Q));return m=15}if(f(Q))return r++,n+=String.fromCharCode(Q),Q===13&&t.charCodeAt(r)===10&&(r++,n+=`
`),m=14;switch(Q){case 123:return r++,m=1;case 125:return r++,m=2;case 91:return r++,m=3;case 93:return r++,m=4;case 58:return r++,m=6;case 44:return r++,m=5;case 34:return r++,n=M(),m=10;case 47:{const le=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!f(t.charCodeAt(r));)r++;return n=t.substring(le,r),m=12}if(t.charCodeAt(r+1)===42){r+=2;const ce=i-1;let ue=!1;for(;r<ce;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,ue=!0;break}r++}return ue||(r++,D=1),n=t.substring(le,r),m=13}return n+=String.fromCharCode(Q),r++,m=16}case 45:if(n+=String.fromCharCode(Q),r++,r===i||!h(t.charCodeAt(r)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=C(),m=11;default:for(;r<i&&N(Q);)r++,Q=t.charCodeAt(r);if(a!==r){switch(n=t.substring(a,r),n){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return n+=String.fromCharCode(Q),r++,m=16}}function N(Q){if(E(Q)||f(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Z(){let Q;do Q=F();while(Q>=12&&Q<=15);return Q}return{setPosition:k,getPosition:()=>r,scan:o?Z:F,getToken:()=>m,getTokenValue:()=>n,getTokenOffset:()=>a,getTokenLength:()=>r-a,getTokenError:()=>D}}e.$0m=A;function E(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function h(t){return t>=48&&t<=57}var y;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(y||(y={}));function v(t,o){const r=[],i=new Object;let n;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function D(I,k,C,M){a.value=I,a.offset=k,a.length=C,a.type=M,a.colonOffset=void 0,n=a}try{c(t,{onObjectBegin:(I,k)=>{if(o<=I)throw i;n=void 0,m=o>I,r.push("")},onObjectProperty:(I,k,C)=>{if(o<k||(D(I,k,C,"property"),r[r.length-1]=I,o<=k+C))throw i},onObjectEnd:(I,k)=>{if(o<=I)throw i;n=void 0,r.pop()},onArrayBegin:(I,k)=>{if(o<=I)throw i;n=void 0,r.push(0)},onArrayEnd:(I,k)=>{if(o<=I)throw i;n=void 0,r.pop()},onLiteralValue:(I,k,C)=>{if(o<k||(D(I,k,C,d(I)),o<=k+C))throw i},onSeparator:(I,k,C)=>{if(o<=k)throw i;if(I===":"&&n&&n.type==="property")n.colonOffset=k,m=!1,n=void 0;else if(I===","){const M=r[r.length-1];typeof M=="number"?r[r.length-1]=M+1:(m=!0,r[r.length-1]=""),n=void 0}}})}catch(I){if(I!==i)throw I}return{path:r,previousNode:n,isAtPropertyKey:m,matches:I=>{let k=0;for(let C=0;k<I.length&&C<r.length;C++)if(I[k]===r[C]||I[k]==="*")k++;else if(I[k]!=="**")return!1;return k===I.length}}}e.$$m=v;function b(t,o=[],r=j.DEFAULT){let i=null,n=[];const a=[];function m(I){Array.isArray(n)?n.push(I):i!==null&&(n[i]=I)}return c(t,{onObjectBegin:()=>{const I={};m(I),a.push(n),n=I,i=null},onObjectProperty:I=>{i=I},onObjectEnd:()=>{n=a.pop()},onArrayBegin:()=>{const I=[];m(I),a.push(n),n=I,i=null},onArrayEnd:()=>{n=a.pop()},onLiteralValue:m,onError:(I,k,C)=>{o.push({error:I,offset:k,length:C})}},r),n[0]}e.$_m=b;function l(t,o=[],r=j.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(I){i.type==="property"&&(i.length=I-i.offset,i=i.parent)}function a(I){return i.children.push(I),I}c(t,{onObjectBegin:I=>{i=a({type:"object",offset:I,length:-1,parent:i,children:[]})},onObjectProperty:(I,k,C)=>{i=a({type:"property",offset:k,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:I,offset:k,length:C,parent:i})},onObjectEnd:(I,k)=>{i.length=I+k-i.offset,i=i.parent,n(I+k)},onArrayBegin:(I,k)=>{i=a({type:"array",offset:I,length:-1,parent:i,children:[]})},onArrayEnd:(I,k)=>{i.length=I+k-i.offset,i=i.parent,n(I+k)},onLiteralValue:(I,k,C)=>{a({type:d(I),offset:k,length:C,parent:i,value:I}),n(k+C)},onSeparator:(I,k,C)=>{i.type==="property"&&(I===":"?i.colonOffset=k:I===","&&n(k))},onError:(I,k,C)=>{o.push({error:I,offset:k,length:C})}},r);const D=i.children[0];return D&&delete D.parent,D}e.$an=l;function p(t,o){if(!t)return;let r=t;for(const i of o)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const a of r.children)if(Array.isArray(a.children)&&a.children[0].value===i){r=a.children[1],n=!0;break}if(!n)return}else{const n=i;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.$bn=p;function w(t){if(!t.parent||!t.parent.children)return[];const o=w(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;o.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&o.push(r)}return o}e.$cn=w;function $(t){switch(t.type){case"array":return t.children.map($);case"object":{const o=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(o[r.children[0].value]=$(i))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$dn=$;function g(t,o,r=!1){return o>=t.offset&&o<t.offset+t.length||r&&o===t.offset+t.length}e.$en=g;function u(t,o,r=!1){if(g(t,o,r)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=o;n++){const a=u(i[n],o,r);if(a)return a}return t}}e.$fn=u;function c(t,o,r=j.DEFAULT){const i=A(t,!1);function n(q){return q?()=>q(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(q){return q?te=>q(te,i.getTokenOffset(),i.getTokenLength()):()=>!0}const m=n(o.onObjectBegin),D=a(o.onObjectProperty),I=n(o.onObjectEnd),k=n(o.onArrayBegin),C=n(o.onArrayEnd),M=a(o.onLiteralValue),F=a(o.onSeparator),N=n(o.onComment),Z=a(o.onError),Q=r&&r.disallowComments,le=r&&r.allowTrailingComma;function ce(){for(;;){const q=i.scan();switch(i.getTokenError()){case 4:ue(14);break;case 5:ue(15);break;case 3:ue(13);break;case 1:Q||ue(11);break;case 2:ue(12);break;case 6:ue(16);break}switch(q){case 12:case 13:Q?ue(10):N();break;case 16:ue(1);break;case 15:case 14:break;default:return q}}}function ue(q,te=[],he=[]){if(Z(q),te.length+he.length>0){let G=i.getToken();for(;G!==17;){if(te.indexOf(G)!==-1){ce();break}else if(he.indexOf(G)!==-1)break;G=ce()}}}function X(q){const te=i.getTokenValue();return q?M(te):D(te),ce(),!0}function K(){switch(i.getToken()){case 11:{let q=0;try{q=JSON.parse(i.getTokenValue()),typeof q!="number"&&(ue(2),q=0)}catch{ue(2)}M(q);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return ce(),!0}function H(){return i.getToken()!==10?(ue(3,[],[2,5]),!1):(X(!1),i.getToken()===6?(F(":"),ce(),V()||ue(4,[],[2,5])):ue(5,[],[2,5]),!0)}function L(){m(),ce();let q=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(q||ue(4,[],[]),F(","),ce(),i.getToken()===2&&le)break}else q&&ue(6,[],[]);H()||ue(4,[],[2,5]),q=!0}return I(),i.getToken()!==2?ue(7,[2],[]):ce(),!0}function T(){k(),ce();let q=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(q||ue(4,[],[]),F(","),ce(),i.getToken()===4&&le)break}else q&&ue(6,[],[]);V()||ue(4,[],[4,5]),q=!0}return C(),i.getToken()!==4?ue(8,[4],[]):ce(),!0}function V(){switch(i.getToken()){case 3:return T();case 1:return L();case 10:return X(!0);default:return K()}}return ce(),i.getToken()===17?r.allowEmptyContent?!0:(ue(4,[],[]),!1):V()?(i.getToken()!==17&&ue(9,[],[]),!0):(ue(4,[],[]),!1)}e.$gn=c;function S(t,o){const r=A(t),i=[];let n,a=0,m;do switch(m=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:a!==m&&i.push(t.substring(a,m)),o!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,o)),a=r.getPosition();break}while(n!==17);return i.join("")}e.$hn=S;function d(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$in=d}),define(re[138],oe([0,1,44]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WT=e.$VT=e.$UT=e.$TT=void 0;function R(h,y,v){let b,l,p,w,$;if(y){for(w=y.offset,$=w+y.length,p=w;p>0&&!f(h,p-1);)p--;let m=$;for(;m<h.length&&!f(h,m);)m++;l=h.substring(p,m),b=A(l,v)}else l=h,b=0,p=0,w=0,$=h.length;const g=E(v,h);let u=!1,c=0,S;v.insertSpaces?S=j(" ",v.tabSize||4):S="	";const d=(0,P.$0m)(l,!1);let t=!1;function o(){return g+j(S,b+c)}function r(){let m=d.scan();for(u=!1;m===15||m===14;)u=u||m===14,m=d.scan();return t=m===16||d.getTokenError()!==0,m}const i=[];function n(m,D,I){!t&&D<$&&I>w&&h.substring(D,I)!==m&&i.push({offset:D,length:I-D,content:m})}let a=r();if(a!==17){const m=d.getTokenOffset()+p,D=j(S,b);n(D,p,m)}for(;a!==17;){let m=d.getTokenOffset()+d.getTokenLength()+p,D=r(),I="";for(;!u&&(D===12||D===13);){const C=d.getTokenOffset()+p;n(" ",m,C),m=d.getTokenOffset()+d.getTokenLength()+p,I=D===12?o():"",D=r()}if(D===2)a!==1&&(c--,I=o());else if(D===4)a!==3&&(c--,I=o());else{switch(a){case 3:case 1:c++,I=o();break;case 5:case 12:I=o();break;case 13:u?I=o():I=" ";break;case 6:I=" ";break;case 10:if(D===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:D===12||D===13?I=" ":D!==5&&D!==17&&(t=!0);break;case 16:t=!0;break}u&&(D===12||D===13)&&(I=o())}const k=d.getTokenOffset()+p;n(I,m,k),a=D}return i}e.$TT=R;function s(h,y){const v=JSON.stringify(h,void 0,y.insertSpaces?y.tabSize||4:"	");return y.eol!==void 0?v.replace(/\r\n|\r|\n/g,y.eol):v}e.$UT=s;function j(h,y){let v="";for(let b=0;b<y;b++)v+=h;return v}function A(h,y){let v=0,b=0;const l=y.tabSize||4;for(;v<h.length;){const p=h.charAt(v);if(p===" ")b++;else if(p==="	")b+=l;else break;v++}return Math.floor(b/l)}function E(h,y){for(let v=0;v<y.length;v++){const b=y.charAt(v);if(b==="\r")return v+1<y.length&&y.charAt(v+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return h&&h.eol||`
`}e.$VT=E;function f(h,y){return`\r
`.indexOf(h.charAt(y))!==-1}e.$WT=f}),define(re[139],oe([0,1,44,138]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2T=e.$1T=e.$ZT=e.$YT=e.$XT=void 0;function s(h,y,v){return j(h,y,void 0,v)}e.$XT=s;function j(h,y,v,b,l){const p=y.slice(),w=[],$=(0,P.$an)(h,w);let g,u;for(;p.length>0&&(u=p.pop(),g=(0,P.$bn)($,p),g===void 0&&v!==void 0);)typeof u=="string"?v={[u]:v}:v=[v];if(g)if(g.type==="object"&&typeof u=="string"&&Array.isArray(g.children)){const c=(0,P.$bn)(g,[u]);if(c!==void 0)if(v===void 0){if(!c.parent)throw new Error("Malformed AST");const S=g.children.indexOf(c.parent);let d,t=c.parent.offset+c.parent.length;if(S>0){const o=g.children[S-1];d=o.offset+o.length}else d=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return A(h,{offset:d,length:t-d,content:""},b)}else return A(h,{offset:c.offset,length:c.length,content:JSON.stringify(v)},b);else{if(v===void 0)return[];const S=`${JSON.stringify(u)}: ${JSON.stringify(v)}`,d=l?l(g.children.map(o=>o.children[0].value)):g.children.length;let t;if(d>0){const o=g.children[d-1];t={offset:o.offset+o.length,length:0,content:","+S}}else g.children.length===0?t={offset:g.offset+1,length:0,content:S}:t={offset:g.offset+1,length:0,content:S+","};return A(h,t,b)}}else if(g.type==="array"&&typeof u=="number"&&Array.isArray(g.children))if(v!==void 0){const c=`${JSON.stringify(v)}`;let S;if(g.children.length===0||u===0)S={offset:g.offset+1,length:0,content:g.children.length===0?c:c+","};else{const d=u===-1||u>g.children.length?g.children.length:u,t=g.children[d-1];S={offset:t.offset+t.length,length:0,content:","+c}}return A(h,S,b)}else{const c=u,S=g.children[c];let d;if(g.children.length===1)d={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===c){const t=g.children[c-1],o=t.offset+t.length,r=g.offset+g.length;d={offset:o,length:r-2-o,content:""}}else d={offset:S.offset,length:g.children[c+1].offset-S.offset,content:""};return A(h,d,b)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${g.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return A(h,{offset:$?$.offset:0,length:$?$.length:0,content:JSON.stringify(v)},b)}}e.$YT=j;function A(h,y,v){let b=E(h,y),l=y.offset,p=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;l>0&&!(0,R.$WT)(b,l-1);)l--;for(;p<b.length&&!(0,R.$WT)(b,p);)p++}const w=(0,R.$TT)(b,{offset:l,length:p-l},v);for(let g=w.length-1;g>=0;g--){const u=w[g];b=E(b,u),l=Math.min(l,u.offset),p=Math.max(p,u.offset+u.length),p+=u.content.length-u.length}const $=h.length-(b.length-p)-l;return[{offset:l,length:$,content:b.substring(l,p)}]}e.$ZT=A;function E(h,y){return h.substring(0,y.offset)+y.content+h.substring(y.offset+y.length)}e.$1T=E;function f(h,y){const v=y.slice(0).sort((l,p)=>{const w=l.offset-p.offset;return w===0?l.length-p.length:w});let b=h.length;for(let l=v.length-1;l>=0;l--){const p=v[l];if(p.offset+p.length<=b)h=E(h,p);else throw new Error("Overlapping edit");b=p.offset}return h}e.$2T=f}),define(re[62],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class P{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=P}),define(re[101],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=void 0;class P{static{this.Undefined=new P(void 0)}constructor(j){this.element=j,this.next=P.Undefined,this.prev=P.Undefined}}class R{constructor(){this.a=P.Undefined,this.b=P.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===P.Undefined}clear(){let j=this.a;for(;j!==P.Undefined;){const A=j.next;j.prev=P.Undefined,j.next=P.Undefined,j=A}this.a=P.Undefined,this.b=P.Undefined,this.c=0}unshift(j){return this.d(j,!1)}push(j){return this.d(j,!0)}d(j,A){const E=new P(j);if(this.a===P.Undefined)this.a=E,this.b=E;else if(A){const h=this.b;this.b=E,E.prev=h,h.next=E}else{const h=this.a;this.a=E,E.next=h,h.prev=E}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(E))}}shift(){if(this.a!==P.Undefined){const j=this.a.element;return this.e(this.a),j}}pop(){if(this.b!==P.Undefined){const j=this.b.element;return this.e(this.b),j}}e(j){if(j.prev!==P.Undefined&&j.next!==P.Undefined){const A=j.prev;A.next=j.next,j.next.prev=A}else j.prev===P.Undefined&&j.next===P.Undefined?(this.a=P.Undefined,this.b=P.Undefined):j.next===P.Undefined?(this.b=this.b.prev,this.b.next=P.Undefined):j.prev===P.Undefined&&(this.a=this.a.next,this.a.prev=P.Undefined);this.c-=1}*[Symbol.iterator](){let j=this.a;for(;j!==P.Undefined;)yield j.element,j=j.next}}e.$3c=R}),define(re[31],oe([0,1]),function(J,e){"use strict";var P,R,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function j(u,c,S){let d=u.get(c);return d===void 0&&(d=S,u.set(c,d)),d}e.$xc=j;function A(u){const c=[];return u.forEach((S,d)=>{c.push(`${d} => ${S}`)}),`Map(${u.size}) {${c.join(", ")}}`}e.$yc=A;function E(u){const c=[];return u.forEach(S=>{c.push(S)}),`Set(${u.size}) {${c.join(", ")}}`}e.$zc=E;class f{constructor(c,S){this.uri=c,this.value=S}}function h(u){return Array.isArray(u)}class y{static{this.a=c=>c.toString()}constructor(c,S){if(this[P]="ResourceMap",c instanceof y)this.b=new Map(c.b),this.c=S??y.a;else if(h(c)){this.b=new Map,this.c=S??y.a;for(const[d,t]of c)this.set(d,t)}else this.b=new Map,this.c=c??y.a}set(c,S){return this.b.set(this.c(c),new f(c,S)),this}get(c){return this.b.get(this.c(c))?.value}has(c){return this.b.has(this.c(c))}get size(){return this.b.size}clear(){this.b.clear()}delete(c){return this.b.delete(this.c(c))}forEach(c,S){typeof S<"u"&&(c=c.bind(S));for(const[d,t]of this.b)c(t.value,t.uri,this)}*values(){for(const c of this.b.values())yield c.value}*keys(){for(const c of this.b.values())yield c.uri}*entries(){for(const c of this.b.values())yield[c.uri,c.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.b)yield[c.uri,c.value]}}e.$Ac=y;class v{constructor(c,S){this[R]="ResourceSet",!c||typeof c=="function"?this.a=new y(c):(this.a=new y(S),c.forEach(this.add,this))}get size(){return this.a.size}add(c){return this.a.set(c,c),this}clear(){this.a.clear()}delete(c){return this.a.delete(c)}forEach(c,S){this.a.forEach((d,t)=>c.call(S,t,t,this))}has(c){return this.a.has(c)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=v;var b;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(b||(e.Touch=b={}));class l{constructor(){this[s]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(c){return this.a.has(c)}get(c,S=0){const d=this.a.get(c);if(d)return S!==0&&this.j(d,S),d.value}set(c,S,d=0){let t=this.a.get(c);if(t)t.value=S,d!==0&&this.j(t,d);else{switch(t={key:c,value:S,next:void 0,previous:void 0},d){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(c,t),this.d++}return this}delete(c){return!!this.remove(c)}remove(c){const S=this.a.get(c);if(S)return this.a.delete(c),this.i(S),this.d--,S.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const c=this.b;return this.a.delete(c.key),this.i(c),this.d--,c.value}forEach(c,S){const d=this.e;let t=this.b;for(;t;){if(S?c.bind(S)(t.value,t.key,this):c(t.value,t.key,this),this.e!==d)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const c=this,S=this.e;let d=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==S)throw new Error("LinkedMap got modified during iteration.");if(d){const o={value:d.key,done:!1};return d=d.next,o}else return{value:void 0,done:!0}}};return t}values(){const c=this,S=this.e;let d=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==S)throw new Error("LinkedMap got modified during iteration.");if(d){const o={value:d.value,done:!1};return d=d.next,o}else return{value:void 0,done:!0}}};return t}entries(){const c=this,S=this.e;let d=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==S)throw new Error("LinkedMap got modified during iteration.");if(d){const o={value:[d.key,d.value],done:!1};return d=d.next,o}else return{value:void 0,done:!0}}};return t}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(c){if(c>=this.size)return;if(c===0){this.clear();return}let S=this.b,d=this.size;for(;S&&d>c;)this.a.delete(S.key),S=S.next,d--;this.b=S,this.d=d,S&&(S.previous=void 0),this.e++}g(c){if(!this.b&&!this.c)this.c=c;else if(this.b)c.next=this.b,this.b.previous=c;else throw new Error("Invalid list");this.b=c,this.e++}h(c){if(!this.b&&!this.c)this.b=c;else if(this.c)c.previous=this.c,this.c.next=c;else throw new Error("Invalid list");this.c=c,this.e++}i(c){if(c===this.b&&c===this.c)this.b=void 0,this.c=void 0;else if(c===this.b){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.b=c.next}else if(c===this.c){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.c=c.previous}else{const S=c.next,d=c.previous;if(!S||!d)throw new Error("Invalid list");S.previous=d,d.next=S}c.next=void 0,c.previous=void 0,this.e++}j(c,S){if(!this.b||!this.c)throw new Error("Invalid list");if(!(S!==1&&S!==2)){if(S===1){if(c===this.b)return;const d=c.next,t=c.previous;c===this.c?(t.next=void 0,this.c=t):(d.previous=t,t.next=d),c.previous=void 0,c.next=this.b,this.b.previous=c,this.b=c,this.e++}else if(S===2){if(c===this.c)return;const d=c.next,t=c.previous;c===this.b?(d.previous=void 0,this.b=d):(d.previous=t,t.next=d),c.next=void 0,c.previous=this.c,this.c.next=c,this.c=c,this.e++}}}toJSON(){const c=[];return this.forEach((S,d)=>{c.push([d,S])}),c}fromJSON(c){this.clear();for(const[S,d]of c)this.set(S,d)}}e.$Cc=l;class p extends l{constructor(c,S=1){super(),this.k=c,this.l=Math.min(Math.max(0,S),1)}get limit(){return this.k}set limit(c){this.k=c,this.m()}get ratio(){return this.l}set ratio(c){this.l=Math.min(Math.max(0,c),1),this.m()}get(c,S=2){return super.get(c,S)}peek(c){return super.get(c,0)}set(c,S){return super.set(c,S,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=p;class w{constructor(){this.a=new Map}add(c){return this.a.set(c,(this.a.get(c)||0)+1),this}delete(c){let S=this.a.get(c)||0;return S===0?!1:(S--,S===0?this.a.delete(c):this.a.set(c,S),!0)}has(c){return this.a.has(c)}}e.$Ec=w;class ${constructor(c){if(this.a=new Map,this.b=new Map,c)for(const[S,d]of c)this.set(S,d)}clear(){this.a.clear(),this.b.clear()}set(c,S){this.a.set(c,S),this.b.set(S,c)}get(c){return this.a.get(c)}getKey(c){return this.b.get(c)}delete(c){const S=this.a.get(c);return S===void 0?!1:(this.a.delete(c),this.b.delete(S),!0)}forEach(c,S){this.a.forEach((d,t)=>{c.call(S,d,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=$;class g{constructor(){this.a=new Map}add(c,S){let d=this.a.get(c);d||(d=new Set,this.a.set(c,d)),d.add(S)}delete(c,S){const d=this.a.get(c);d&&(d.delete(S),d.size===0&&this.a.delete(c))}forEach(c,S){const d=this.a.get(c);d&&d.forEach(S)}get(c){const S=this.a.get(c);return S||new Set}}e.$Gc=g}),define(re[2],oe([0,1,23,135,31,84,72]),function(J,e,P,R,s,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const E=!1;let f=null;class h{constructor(){this.b=new Map}static{this.a=0}c(M){let F=this.b.get(M);return F||(F={parent:null,source:null,isSingleton:!1,value:M,idx:h.a++},this.b.set(M,F)),F}trackDisposable(M){const F=this.c(M);F.source||(F.source=new Error().stack)}setParent(M,F){const N=this.c(M);N.parent=F}markAsDisposed(M){this.b.delete(M)}markAsSingleton(M){this.c(M).isSingleton=!0}f(M,F){const N=F.get(M);if(N)return N;const Z=M.parent?this.f(this.c(M.parent),F):M;return F.set(M,Z),Z}getTrackedDisposables(){const M=new Map;return[...this.b.entries()].filter(([,N])=>N.source!==null&&!this.f(N,M).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(M=10,F){let N;if(F)N=F;else{const ue=new Map,X=[...this.b.values()].filter(H=>H.source!==null&&!this.f(H,ue).isSingleton);if(X.length===0)return;const K=new Set(X.map(H=>H.value));if(N=X.filter(H=>!(H.parent&&K.has(H.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function Z(ue){function X(H,L){for(;H.length>0&&L.some(T=>typeof T=="string"?T===H[0]:H[0].match(T));)H.shift()}const K=ue.source.split(`
`).map(H=>H.trim().replace("at ","")).filter(H=>H!=="");return X(K,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),K.reverse()}const Q=new s.$Gc;for(const ue of N){const X=Z(ue);for(let K=0;K<=X.length;K++)Q.add(X.slice(0,K).join(`
`),ue)}N.sort((0,P.$7b)(ue=>ue.idx,P.$9b));let le="",ce=0;for(const ue of N.slice(0,M)){ce++;const X=Z(ue),K=[];for(let H=0;H<X.length;H++){let L=X[H];L=`(shared with ${Q.get(X.slice(0,H+1).join(`
`)).size}/${N.length} leaks) at ${L}`;const V=Q.get(X.slice(0,H).join(`
`)),q=(0,R.$K)([...V].map(te=>Z(te)[H]),te=>te);delete q[X[H]];for(const[te,he]of Object.entries(q))K.unshift(`    - stacktraces of ${he.length} other leaks continue with ${te}`);K.unshift(L)}le+=`


==================== Leaking disposable ${ce}/${N.length}: ${ue.value.constructor.name} ====================
${K.join(`
`)}
============================================================

`}return N.length>M&&(le+=`


... and ${N.length-M} more leaking disposables

`),{leaks:N,details:le}}}e.$Hc=h;function y(C){f=C}if(e.$Ic=y,E){const C="__is_disposable_tracked__";y(new class{trackDisposable(M){const F=new Error("Potentially leaked disposable").stack;setTimeout(()=>{M[C]||console.log(F)},3e3)}setParent(M,F){if(M&&M!==t.None)try{M[C]=!0}catch{}}markAsDisposed(M){if(M&&M!==t.None)try{M[C]=!0}catch{}}markAsSingleton(M){}})}function v(C){return f?.trackDisposable(C),C}e.$Jc=v;function b(C){f?.markAsDisposed(C)}e.$Kc=b;function l(C,M){f?.setParent(C,M)}function p(C,M){if(f)for(const F of C)f.setParent(F,M)}function w(C){return f?.markAsSingleton(C),C}e.$Lc=w;function $(C){return typeof C.dispose=="function"&&C.dispose.length===0}e.$Mc=$;function g(C){if(A.Iterable.is(C)){const M=[];for(const F of C)if(F)try{F.dispose()}catch(N){M.push(N)}if(M.length===1)throw M[0];if(M.length>1)throw new AggregateError(M,"Encountered errors while disposing of store");return Array.isArray(C)?[]:C}else if(C)return C.dispose(),C}e.$Nc=g;function u(C){for(const M of C)$(M)&&M.dispose();return[]}e.$Oc=u;function c(...C){const M=S(()=>g(C));return p(C,M),M}e.$Pc=c;function S(C){const M=v({dispose:(0,j.$db)(()=>{b(M),C()})});return M}e.$Qc=S;class d{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,v(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{g(this.f)}finally{this.f.clear()}}add(M){if(!M)return M;if(M===this)throw new Error("Cannot register a disposable on itself!");return l(M,this),this.g?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(M),M}delete(M){if(M){if(M===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(M),M.dispose()}}deleteAndLeak(M){M&&this.f.has(M)&&(this.f.delete(M),l(M,null))}}e.$Rc=d;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new d,v(this),l(this.q,this)}dispose(){b(this),this.q.dispose()}B(M){if(M===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(M)}}e.$Sc=t;class o{constructor(){this.b=!1,v(this)}get value(){return this.b?void 0:this.a}set value(M){this.b||M===this.a||(this.a?.dispose(),M&&l(M,this),this.a=M)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const M=this.a;return this.a=void 0,M&&l(M,null),M}}e.$Tc=o;class r{constructor(M){this.a=new o,this.b=!1,this.a.value=M}get value(){return this.a.value}set value(M){this.b||M===this.a.value||(this.a.value=M)}dispose(){this.b=!0,this.a.dispose()}}e.$Uc=r;class i{constructor(M){this.b=M,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Vc=i;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,v(this)}set(M){let F=M;return this.unset=()=>F=void 0,this.isset=()=>F!==void 0,this.dispose=()=>{F&&(F(),F=void 0,b(this))},this}}e.$Wc=n;class a{constructor(){this.a=new Map}acquire(M,...F){let N=this.a.get(M);N||(N={counter:0,object:this.b(M,...F)},this.a.set(M,N));const{object:Z}=N,Q=(0,j.$db)(()=>{--N.counter===0&&(this.c(M,N.object),this.a.delete(M))});return N.counter++,{object:Z,dispose:Q}}}e.$Xc=a;class m{constructor(M){this.a=M}async acquire(M,...F){const N=this.a.acquire(M,...F);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(Z){throw N.dispose(),Z}}}e.$Yc=m;class D{constructor(M){this.object=M}dispose(){}}e.$Zc=D;function I(C){const M=new d;try{C(M)}finally{M.dispose()}}e.$1c=I;class k{constructor(){this.a=new Map,this.b=!1,v(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(M){return this.a.has(M)}get size(){return this.a.size}get(M){return this.a.get(M)}set(M,F,N=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this.a.get(M)?.dispose(),this.a.set(M,F)}deleteAndDispose(M){this.a.get(M)?.dispose(),this.a.delete(M)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$2c=k}),define(re[85],oe([0,1,31]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fl=e.$El=e.$Dl=void 0;const R=new P.$Dc(1e4);function s(h){return f(h,"NFC",R)}e.$Dl=s;const j=new P.$Dc(1e4);function A(h){return f(h,"NFD",j)}e.$El=A;const E=/[^\u0000-\u0080]/;function f(h,y,v){if(!h)return h;const b=v.get(h);if(b)return b;let l;return E.test(h)?l=h.normalize(y):l=h,v.set(h,l),l}e.$Fl=function(){const h=/[\u0300-\u036f]/g;return function(y){return A(y).replace(h,"")}}()}),define(re[140],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8l=e.$7l=e.$6l=e.rot=e.$4l=void 0;function P(E,f,h){return Math.min(Math.max(E,f),h)}e.$4l=P;function R(E,f){return(f+E%f)%f}e.rot=R;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$6l=s;class j{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$7l=j;class A{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const h=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=h,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$8l=A}),function(){function J(s){const j=[];typeof s=="number"&&j.push("code/timeOrigin",s);function A(f){j.push(f,Date.now())}function E(){const f=[];for(let h=0;h<j.length;h+=2)f.push({name:j[h],startTime:j[h+1]});return f}return{mark:A,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const j=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const A of performance.getEntriesByType("mark"))j.push({name:A.name,startTime:Math.round(s+A.startTime)});return j}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function P(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=P(R))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var R in P)(typeof exports=="object"?exports:J)[R]=P[R]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function P(R){if(e[R])return e[R].exports;var s=e[R]={i:R,l:!1,exports:{}};return J[R].call(s.exports,s,s.exports,P),s.l=!0,s.exports}return P.m=J,P.c=e,P.d=function(R,s,j){P.o(R,s)||Object.defineProperty(R,s,{enumerable:!0,get:j})},P.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},P.t=function(R,s){if(1&s&&(R=P(R)),8&s||4&s&&typeof R=="object"&&R&&R.__esModule)return R;var j=Object.create(null);if(P.r(j),Object.defineProperty(j,"default",{enumerable:!0,value:R}),2&s&&typeof R!="string")for(var A in R)P.d(j,A,function(E){return R[E]}.bind(null,A));return j},P.n=function(R){var s=R&&R.__esModule?function(){return R.default}:function(){return R};return P.d(s,"a",s),s},P.o=function(R,s){return Object.prototype.hasOwnProperty.call(R,s)},P.p="",P(P.s=0)}([function(J,e,P){(function(R){var s;e=J.exports=he,s=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var j=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],f=e.src=[],h=0,y=h++;f[y]="0|[1-9]\\d*";var v=h++;f[v]="[0-9]+";var b=h++;f[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var l=h++;f[l]="("+f[y]+")\\.("+f[y]+")\\.("+f[y]+")";var p=h++;f[p]="("+f[v]+")\\.("+f[v]+")\\.("+f[v]+")";var w=h++;f[w]="(?:"+f[y]+"|"+f[b]+")";var $=h++;f[$]="(?:"+f[v]+"|"+f[b]+")";var g=h++;f[g]="(?:-("+f[w]+"(?:\\."+f[w]+")*))";var u=h++;f[u]="(?:-?("+f[$]+"(?:\\."+f[$]+")*))";var c=h++;f[c]="[0-9A-Za-z-]+";var S=h++;f[S]="(?:\\+("+f[c]+"(?:\\."+f[c]+")*))";var d=h++,t="v?"+f[l]+f[g]+"?"+f[S]+"?";f[d]="^"+t+"$";var o="[v=\\s]*"+f[p]+f[u]+"?"+f[S]+"?",r=h++;f[r]="^"+o+"$";var i=h++;f[i]="((?:<|>)?=?)";var n=h++;f[n]=f[v]+"|x|X|\\*";var a=h++;f[a]=f[y]+"|x|X|\\*";var m=h++;f[m]="[v=\\s]*("+f[a]+")(?:\\.("+f[a]+")(?:\\.("+f[a]+")(?:"+f[g]+")?"+f[S]+"?)?)?";var D=h++;f[D]="[v=\\s]*("+f[n]+")(?:\\.("+f[n]+")(?:\\.("+f[n]+")(?:"+f[u]+")?"+f[S]+"?)?)?";var I=h++;f[I]="^"+f[i]+"\\s*"+f[m]+"$";var k=h++;f[k]="^"+f[i]+"\\s*"+f[D]+"$";var C=h++;f[C]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=h++;f[M]="(?:~>?)";var F=h++;f[F]="(\\s*)"+f[M]+"\\s+",E[F]=new RegExp(f[F],"g");var N=h++;f[N]="^"+f[M]+f[m]+"$";var Z=h++;f[Z]="^"+f[M]+f[D]+"$";var Q=h++;f[Q]="(?:\\^)";var le=h++;f[le]="(\\s*)"+f[Q]+"\\s+",E[le]=new RegExp(f[le],"g");var ce=h++;f[ce]="^"+f[Q]+f[m]+"$";var ue=h++;f[ue]="^"+f[Q]+f[D]+"$";var X=h++;f[X]="^"+f[i]+"\\s*("+o+")$|^$";var K=h++;f[K]="^"+f[i]+"\\s*("+t+")$|^$";var H=h++;f[H]="(\\s*)"+f[i]+"\\s*("+o+"|"+f[m]+")",E[H]=new RegExp(f[H],"g");var L=h++;f[L]="^\\s*("+f[m]+")\\s+-\\s+("+f[m]+")\\s*$";var T=h++;f[T]="^\\s*("+f[D]+")\\s+-\\s+("+f[D]+")\\s*$";var V=h++;f[V]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)s(q,f[q]),E[q]||(E[q]=new RegExp(f[q]));function te(ee,fe){if(ee instanceof he)return ee;if(typeof ee!="string"||ee.length>j||!(fe?E[r]:E[d]).test(ee))return null;try{return new he(ee,fe)}catch{return null}}function he(ee,fe){if(ee instanceof he){if(ee.loose===fe)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>j)throw new TypeError("version is longer than "+j+" characters");if(!(this instanceof he))return new he(ee,fe);s("SemVer",ee,fe),this.loose=fe;var ge=ee.trim().match(fe?E[r]:E[d]);if(!ge)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var je=+Ie;if(je>=0&&je<A)return je}return Ie}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=te,e.valid=function(ee,fe){var ge=te(ee,fe);return ge?ge.version:null},e.clean=function(ee,fe){var ge=te(ee.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(ee){return s("SemVer.compare",this.version,this.loose,ee),ee instanceof he||(ee=new he(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},he.prototype.compareMain=function(ee){return ee instanceof he||(ee=new he(ee,this.loose)),O(this.major,ee.major)||O(this.minor,ee.minor)||O(this.patch,ee.patch)},he.prototype.comparePre=function(ee){if(ee instanceof he||(ee=new he(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],Ie=ee.prerelease[fe];if(s("prerelease compare",fe,ge,Ie),ge===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ie)return O(ge,Ie)}while(++fe)},he.prototype.inc=function(ee,fe){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,fe,ge,Ie){typeof ge=="string"&&(Ie=ge,ge=void 0);try{return new he(ee,ge).inc(fe,Ie).version}catch{return null}},e.diff=function(ee,fe){if(Y(ee,fe))return null;var ge=te(ee),Ie=te(fe);if(ge.prerelease.length||Ie.prerelease.length){for(var je in ge)if((je==="major"||je==="minor"||je==="patch")&&ge[je]!==Ie[je])return"pre"+je;return"prerelease"}for(var je in ge)if((je==="major"||je==="minor"||je==="patch")&&ge[je]!==Ie[je])return je},e.compareIdentifiers=O;var G=/^[0-9]+$/;function O(ee,fe){var ge=G.test(ee),Ie=G.test(fe);return ge&&Ie&&(ee=+ee,fe=+fe),ge&&!Ie?-1:Ie&&!ge?1:ee<fe?-1:ee>fe?1:0}function U(ee,fe,ge){return new he(ee,ge).compare(new he(fe,ge))}function x(ee,fe,ge){return U(ee,fe,ge)>0}function z(ee,fe,ge){return U(ee,fe,ge)<0}function Y(ee,fe,ge){return U(ee,fe,ge)===0}function W(ee,fe,ge){return U(ee,fe,ge)!==0}function B(ee,fe,ge){return U(ee,fe,ge)>=0}function _(ee,fe,ge){return U(ee,fe,ge)<=0}function ae(ee,fe,ge,Ie){var je;switch(fe){case"===":typeof ee=="object"&&(ee=ee.version),typeof ge=="object"&&(ge=ge.version),je=ee===ge;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof ge=="object"&&(ge=ge.version),je=ee!==ge;break;case"":case"=":case"==":je=Y(ee,ge,Ie);break;case"!=":je=W(ee,ge,Ie);break;case">":je=x(ee,ge,Ie);break;case">=":je=B(ee,ge,Ie);break;case"<":je=z(ee,ge,Ie);break;case"<=":je=_(ee,ge,Ie);break;default:throw new TypeError("Invalid operator: "+fe)}return je}function se(ee,fe){if(ee instanceof se){if(ee.loose===fe)return ee;ee=ee.value}if(!(this instanceof se))return new se(ee,fe);s("comparator",ee,fe),this.loose=fe,this.parse(ee),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(ee,fe){return O(fe,ee)},e.major=function(ee,fe){return new he(ee,fe).major},e.minor=function(ee,fe){return new he(ee,fe).minor},e.patch=function(ee,fe){return new he(ee,fe).patch},e.compare=U,e.compareLoose=function(ee,fe){return U(ee,fe,!0)},e.rcompare=function(ee,fe,ge){return U(fe,ee,ge)},e.sort=function(ee,fe){return ee.sort(function(ge,Ie){return e.compare(ge,Ie,fe)})},e.rsort=function(ee,fe){return ee.sort(function(ge,Ie){return e.rcompare(ge,Ie,fe)})},e.gt=x,e.lt=z,e.eq=Y,e.neq=W,e.gte=B,e.lte=_,e.cmp=ae,e.Comparator=se;var $e={};function me(ee,fe){if(ee instanceof me)return ee.loose===fe?ee:new me(ee.raw,fe);if(ee instanceof se)return new me(ee.value,fe);if(!(this instanceof me))return new me(ee,fe);if(this.loose=fe,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function ye(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Pe(ee,fe,ge,Ie,je,We,Me,Je,Be,He,Ve,ie,de){return((fe=ye(ge)?"":ye(Ie)?">="+ge+".0.0":ye(je)?">="+ge+"."+Ie+".0":">="+fe)+" "+(Je=ye(Be)?"":ye(He)?"<"+(+Be+1)+".0.0":ye(Ve)?"<"+Be+"."+(+He+1)+".0":ie?"<="+Be+"."+He+"."+Ve+"-"+ie:"<="+Je)).trim()}function Le(ee,fe){for(var ge=0;ge<ee.length;ge++)if(!ee[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<ee.length;ge++)if(s(ee[ge].semver),ee[ge].semver!==$e&&ee[ge].semver.prerelease.length>0){var Ie=ee[ge].semver;if(Ie.major===fe.major&&Ie.minor===fe.minor&&Ie.patch===fe.patch)return!0}return!1}return!0}function ke(ee,fe,ge){try{fe=new me(fe,ge)}catch{return!1}return fe.test(ee)}function pe(ee,fe,ge,Ie){var je,We,Me,Je,Be;switch(ee=new he(ee,Ie),fe=new me(fe,Ie),ge){case">":je=x,We=_,Me=z,Je=">",Be=">=";break;case"<":je=z,We=B,Me=x,Je="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(ee,fe,Ie))return!1;for(var He=0;He<fe.set.length;++He){var Ve=fe.set[He],ie=null,de=null;if(Ve.forEach(function(be){be.semver===$e&&(be=new se(">=0.0.0")),ie=ie||be,de=de||be,je(be.semver,ie.semver,Ie)?ie=be:Me(be.semver,de.semver,Ie)&&(de=be)}),ie.operator===Je||ie.operator===Be||(!de.operator||de.operator===Je)&&We(ee,de.semver)||de.operator===Be&&Me(ee,de.semver))return!1}return!0}se.prototype.parse=function(ee){var fe=this.loose?E[X]:E[K],ge=ee.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+ee);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new he(ge[2],this.loose):this.semver=$e},se.prototype.toString=function(){return this.value},se.prototype.test=function(ee){return s("Comparator.test",ee,this.loose),this.semver===$e||(typeof ee=="string"&&(ee=new he(ee,this.loose)),ae(ee,this.operator,this.semver,this.loose))},se.prototype.intersects=function(ee,fe){if(!(ee instanceof se))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new me(ee.value,fe),ke(this.value,ge,fe);if(ee.operator==="")return ge=new me(this.value,fe),ke(ee.semver,ge,fe);var Ie=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),We=this.semver.version===ee.semver.version,Me=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Je=ae(this.semver,"<",ee.semver,fe)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),Be=ae(this.semver,">",ee.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return Ie||je||We&&Me||Je||Be},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(ee){var fe=this.loose;ee=ee.trim(),s("range",ee,fe);var ge=fe?E[T]:E[L];ee=ee.replace(ge,Pe),s("hyphen replace",ee),ee=ee.replace(E[H],"$1$2$3"),s("comparator trim",ee,E[H]),ee=(ee=(ee=ee.replace(E[F],"$1~")).replace(E[le],"$1^")).split(/\s+/).join(" ");var Ie=fe?E[X]:E[K],je=ee.split(" ").map(function(We){return function(Me,Je){return s("comp",Me),Me=function(Be,He){return Be.trim().split(/\s+/).map(function(Ve){return function(ie,de){s("caret",ie,de);var be=de?E[ue]:E[ce];return ie.replace(be,function(Se,ve,De,Ne,qe){var Qe;return s("caret",ie,Se,ve,De,Ne,qe),ye(ve)?Qe="":ye(De)?Qe=">="+ve+".0.0 <"+(+ve+1)+".0.0":ye(Ne)?Qe=ve==="0"?">="+ve+"."+De+".0 <"+ve+"."+(+De+1)+".0":">="+ve+"."+De+".0 <"+(+ve+1)+".0.0":qe?(s("replaceCaret pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Qe=ve==="0"?De==="0"?">="+ve+"."+De+"."+Ne+qe+" <"+ve+"."+De+"."+(+Ne+1):">="+ve+"."+De+"."+Ne+qe+" <"+ve+"."+(+De+1)+".0":">="+ve+"."+De+"."+Ne+qe+" <"+(+ve+1)+".0.0"):(s("no pr"),Qe=ve==="0"?De==="0"?">="+ve+"."+De+"."+Ne+" <"+ve+"."+De+"."+(+Ne+1):">="+ve+"."+De+"."+Ne+" <"+ve+"."+(+De+1)+".0":">="+ve+"."+De+"."+Ne+" <"+(+ve+1)+".0.0"),s("caret return",Qe),Qe})}(Ve,He)}).join(" ")}(Me,Je),s("caret",Me),Me=function(Be,He){return Be.trim().split(/\s+/).map(function(Ve){return function(ie,de){var be=de?E[Z]:E[N];return ie.replace(be,function(Se,ve,De,Ne,qe){var Qe;return s("tilde",ie,Se,ve,De,Ne,qe),ye(ve)?Qe="":ye(De)?Qe=">="+ve+".0.0 <"+(+ve+1)+".0.0":ye(Ne)?Qe=">="+ve+"."+De+".0 <"+ve+"."+(+De+1)+".0":qe?(s("replaceTilde pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Qe=">="+ve+"."+De+"."+Ne+qe+" <"+ve+"."+(+De+1)+".0"):Qe=">="+ve+"."+De+"."+Ne+" <"+ve+"."+(+De+1)+".0",s("tilde return",Qe),Qe})}(Ve,He)}).join(" ")}(Me,Je),s("tildes",Me),Me=function(Be,He){return s("replaceXRanges",Be,He),Be.split(/\s+/).map(function(Ve){return function(ie,de){ie=ie.trim();var be=de?E[k]:E[I];return ie.replace(be,function(Se,ve,De,Ne,qe,Qe){s("xRange",ie,Se,ve,De,Ne,qe,Qe);var xe=ye(De),Ze=xe||ye(Ne),Ye=Ze||ye(qe);return ve==="="&&Ye&&(ve=""),xe?Se=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Ye?(Ze&&(Ne=0),Ye&&(qe=0),ve===">"?(ve=">=",Ze?(De=+De+1,Ne=0,qe=0):Ye&&(Ne=+Ne+1,qe=0)):ve==="<="&&(ve="<",Ze?De=+De+1:Ne=+Ne+1),Se=ve+De+"."+Ne+"."+qe):Ze?Se=">="+De+".0.0 <"+(+De+1)+".0.0":Ye&&(Se=">="+De+"."+Ne+".0 <"+De+"."+(+Ne+1)+".0"),s("xRange return",Se),Se})}(Ve,He)}).join(" ")}(Me,Je),s("xrange",Me),Me=function(Be,He){return s("replaceStars",Be,He),Be.trim().replace(E[V],"")}(Me,Je),s("stars",Me),Me}(We,fe)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(We){return!!We.match(Ie)})),je=je.map(function(We){return new se(We,fe)})},me.prototype.intersects=function(ee,fe){if(!(ee instanceof me))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ie){return ee.set.some(function(je){return je.every(function(We){return Ie.intersects(We,fe)})})})})},e.toComparators=function(ee,fe){return new me(ee,fe).set.map(function(ge){return ge.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},me.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new he(ee,this.loose));for(var fe=0;fe<this.set.length;fe++)if(Le(this.set[fe],ee))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(ee,fe,ge){var Ie=null,je=null;try{var We=new me(fe,ge)}catch{return null}return ee.forEach(function(Me){We.test(Me)&&(Ie&&je.compare(Me)!==-1||(je=new he(Ie=Me,ge)))}),Ie},e.minSatisfying=function(ee,fe,ge){var Ie=null,je=null;try{var We=new me(fe,ge)}catch{return null}return ee.forEach(function(Me){We.test(Me)&&(Ie&&je.compare(Me)!==1||(je=new he(Ie=Me,ge)))}),Ie},e.validRange=function(ee,fe){try{return new me(ee,fe).range||"*"}catch{return null}},e.ltr=function(ee,fe,ge){return pe(ee,fe,"<",ge)},e.gtr=function(ee,fe,ge){return pe(ee,fe,">",ge)},e.outside=pe,e.prerelease=function(ee,fe){var ge=te(ee,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ee,fe,ge){return ee=new me(ee,ge),fe=new me(fe,ge),ee.intersects(fe)},e.coerce=function(ee){if(ee instanceof he)return ee;if(typeof ee!="string")return null;var fe=ee.match(E[C]);return fe==null?null:te((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,P(1))},function(J,e){var P,R,s=J.exports={};function j(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function E($){if(P===setTimeout)return setTimeout($,0);if((P===j||!P)&&setTimeout)return P=setTimeout,setTimeout($,0);try{return P($,0)}catch{try{return P.call(null,$,0)}catch{return P.call(this,$,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:j}catch{P=j}try{R=typeof clearTimeout=="function"?clearTimeout:A}catch{R=A}})();var f,h=[],y=!1,v=-1;function b(){y&&f&&(y=!1,f.length?h=f.concat(h):v=-1,h.length&&l())}function l(){if(!y){var $=E(b);y=!0;for(var g=h.length;g;){for(f=h,h=[];++v<g;)f&&f[v].run();v=-1,g=h.length}f=null,y=!1,function(u){if(R===clearTimeout)return clearTimeout(u);if((R===A||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(u);try{R(u)}catch{try{return R.call(null,u)}catch{return R.call(this,u)}}}($)}}function p($,g){this.fun=$,this.array=g}function w(){}s.nextTick=function($){var g=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)g[u-1]=arguments[u];h.push(new p($,g)),h.length!==1||y||E(l)},p.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=w,s.addListener=w,s.once=w,s.off=w,s.removeListener=w,s.removeAllListeners=w,s.emit=w,s.prependListener=w,s.prependOnceListener=w,s.listeners=function($){return[]},s.binding=function($){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function($){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(re[141],oe([0,1]),function(J,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nr=void 0;class R{constructor(E,f,h){this.level=E,this.key=f,this.value=h,this.forward=[]}}const s=void 0;class j{constructor(E,f=2**16){this.comparator=E,this[P]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(f)|0),this.e=new R(this.c,s,s)}get size(){return this.f}clear(){this.e=new R(this.c,s,s),this.f=0}has(E){return!!j.g(this,E,this.comparator)}get(E){return j.g(this,E,this.comparator)?.value}set(E,f){return j.h(this,E,f,this.comparator)&&(this.f+=1),this}delete(E){const f=j.k(this,E,this.comparator);return f&&(this.f-=1),f}forEach(E,f){let h=this.e.forward[0];for(;h;)E.call(f,h.value,h.key,this),h=h.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this.e.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this.e.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this.e.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",f=this.e.forward[0];for(;f;)E+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return E}static g(E,f,h){let y=E.e;for(let v=E.d-1;v>=0;v--)for(;y.forward[v]&&h(y.forward[v].key,f)<0;)y=y.forward[v];if(y=y.forward[0],y&&h(y.key,f)===0)return y}static h(E,f,h,y){const v=[];let b=E.e;for(let l=E.d-1;l>=0;l--){for(;b.forward[l]&&y(b.forward[l].key,f)<0;)b=b.forward[l];v[l]=b}if(b=b.forward[0],b&&y(b.key,f)===0)return b.value=h,!1;{const l=j.j(E);if(l>E.d){for(let p=E.d;p<l;p++)v[p]=E.e;E.d=l}b=new R(l,f,h);for(let p=0;p<l;p++)b.forward[p]=v[p].forward[p],v[p].forward[p]=b;return!0}}static j(E,f=.5){let h=1;for(;Math.random()<f&&h<E.c;)h+=1;return h}static k(E,f,h){const y=[];let v=E.e;for(let b=E.d-1;b>=0;b--){for(;v.forward[b]&&h(v.forward[b].key,f)<0;)v=v.forward[b];y[b]=v}if(v=v.forward[0],!v||h(v.key,f)!==0)return!1;for(let b=0;b<E.d&&y[b].forward[b]===v;b++)y[b].forward[b]=v.forward[b];for(;E.d>0&&E.e.forward[E.d-1]===s;)E.d-=1;return!0}}e.$Nr=j}),define(re[73],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0;const P=globalThis.performance&&typeof globalThis.performance.now=="function";class R{static create(j){return new R(j)}constructor(j){this.c=P&&j===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Od=R}),define(re[3],oe([0,1,14,84,2,101,73]),function(J,e,P,R,s,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.Event=void 0;const E=!1,f=!1;var h;(function(I){I.None=()=>s.$Sc.None;function k(ae){if(f){const{onDidAddListener:se}=ae,$e=p.create();let me=0;ae.onDidAddListener=()=>{++me===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),se?.()}}}function C(ae,se){return K(ae,()=>{},0,void 0,!0,void 0,se)}I.defer=C;function M(ae){return(se,$e=null,me)=>{let ye=!1,Pe;return Pe=ae(Le=>{if(!ye)return Pe?Pe.dispose():ye=!0,se.call($e,Le)},null,me),ye&&Pe.dispose(),Pe}}I.once=M;function F(ae,se,$e){return ue((me,ye=null,Pe)=>ae(Le=>me.call(ye,se(Le)),null,Pe),$e)}I.map=F;function N(ae,se,$e){return ue((me,ye=null,Pe)=>ae(Le=>{se(Le),me.call(ye,Le)},null,Pe),$e)}I.forEach=N;function Z(ae,se,$e){return ue((me,ye=null,Pe)=>ae(Le=>se(Le)&&me.call(ye,Le),null,Pe),$e)}I.filter=Z;function Q(ae){return ae}I.signal=Q;function le(...ae){return(se,$e=null,me)=>{const ye=(0,s.$Pc)(...ae.map(Pe=>Pe(Le=>se.call($e,Le))));return X(ye,me)}}I.any=le;function ce(ae,se,$e,me){let ye=$e;return F(ae,Pe=>(ye=se(ye,Pe),ye),me)}I.reduce=ce;function ue(ae,se){let $e;const me={onWillAddFirstListener(){$e=ae(ye.fire,ye)},onDidRemoveLastListener(){$e?.dispose()}};se||k(me);const ye=new c(me);return se?.add(ye),ye.event}function X(ae,se){return se instanceof Array?se.push(ae):se&&se.add(ae),ae}function K(ae,se,$e=100,me=!1,ye=!1,Pe,Le){let ke,pe,ee,fe=0,ge;const Ie={leakWarningThreshold:Pe,onWillAddFirstListener(){ke=ae(We=>{fe++,pe=se(pe,We),me&&!ee&&(je.fire(pe),pe=void 0),ge=()=>{const Me=pe;pe=void 0,ee=void 0,(!me||fe>1)&&je.fire(Me),fe=0},typeof $e=="number"?(clearTimeout(ee),ee=setTimeout(ge,$e)):ee===void 0&&(ee=0,queueMicrotask(ge))})},onWillRemoveListener(){ye&&fe>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,ke.dispose()}};Le||k(Ie);const je=new c(Ie);return Le?.add(je),je.event}I.debounce=K;function H(ae,se=0,$e){return I.debounce(ae,(me,ye)=>me?(me.push(ye),me):[ye],se,void 0,!0,void 0,$e)}I.accumulate=H;function L(ae,se=(me,ye)=>me===ye,$e){let me=!0,ye;return Z(ae,Pe=>{const Le=me||!se(Pe,ye);return me=!1,ye=Pe,Le},$e)}I.latch=L;function T(ae,se,$e){return[I.filter(ae,se,$e),I.filter(ae,me=>!se(me),$e)]}I.split=T;function V(ae,se=!1,$e=[],me){let ye=$e.slice(),Pe=ae(pe=>{ye?ye.push(pe):ke.fire(pe)});me&&me.add(Pe);const Le=()=>{ye?.forEach(pe=>ke.fire(pe)),ye=null},ke=new c({onWillAddFirstListener(){Pe||(Pe=ae(pe=>ke.fire(pe)),me&&me.add(Pe))},onDidAddFirstListener(){ye&&(se?setTimeout(Le):Le())},onDidRemoveLastListener(){Pe&&Pe.dispose(),Pe=null}});return me&&me.add(ke),ke.event}I.buffer=V;function q(ae,se){return(me,ye,Pe)=>{const Le=se(new he);return ae(function(ke){const pe=Le.evaluate(ke);pe!==te&&me.call(ye,pe)},void 0,Pe)}}I.chain=q;const te=Symbol("HaltChainable");class he{constructor(){this.f=[]}map(se){return this.f.push(se),this}forEach(se){return this.f.push($e=>(se($e),$e)),this}filter(se){return this.f.push($e=>se($e)?$e:te),this}reduce(se,$e){let me=$e;return this.f.push(ye=>(me=se(me,ye),me)),this}latch(se=($e,me)=>$e===me){let $e=!0,me;return this.f.push(ye=>{const Pe=$e||!se(ye,me);return $e=!1,me=ye,Pe?ye:te}),this}evaluate(se){for(const $e of this.f)if(se=$e(se),se===te)break;return se}}function G(ae,se,$e=me=>me){const me=(...ke)=>Le.fire($e(...ke)),ye=()=>ae.on(se,me),Pe=()=>ae.removeListener(se,me),Le=new c({onWillAddFirstListener:ye,onDidRemoveLastListener:Pe});return Le.event}I.fromNodeEventEmitter=G;function O(ae,se,$e=me=>me){const me=(...ke)=>Le.fire($e(...ke)),ye=()=>ae.addEventListener(se,me),Pe=()=>ae.removeEventListener(se,me),Le=new c({onWillAddFirstListener:ye,onDidRemoveLastListener:Pe});return Le.event}I.fromDOMEventEmitter=O;function U(ae){return new Promise(se=>M(ae)(se))}I.toPromise=U;function x(ae){const se=new c;return ae.then($e=>{se.fire($e)},()=>{se.fire(void 0)}).finally(()=>{se.dispose()}),se.event}I.fromPromise=x;function z(ae,se,$e){return se($e),ae(me=>se(me))}I.runAndSubscribe=z;function Y(ae,se){let $e=null;function me(Pe){$e?.dispose(),$e=new s.$Rc,se(Pe,$e)}me(void 0);const ye=ae(Pe=>me(Pe));return(0,s.$Qc)(()=>{ye.dispose(),$e?.dispose()})}I.runAndSubscribeWithStore=Y;class W{constructor(se,$e){this._observable=se,this.f=0,this.g=!1;const me={onWillAddFirstListener:()=>{se.addObserver(this)},onDidRemoveLastListener:()=>{se.removeObserver(this)}};$e||k(me),this.emitter=new c(me),$e&&$e.add(this.emitter)}beginUpdate(se){this.f++}handlePossibleChange(se){}handleChange(se,$e){this.g=!0}endUpdate(se){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function B(ae,se){return new W(ae,se).emitter.event}I.fromObservable=B;function _(ae){return(se,$e,me)=>{let ye=0,Pe=!1;const Le={beginUpdate(){ye++},endUpdate(){ye--,ye===0&&(ae.reportChanges(),Pe&&(Pe=!1,se.call($e)))},handlePossibleChange(){},handleChange(){Pe=!0}};ae.addObserver(Le),ae.reportChanges();const ke={dispose(){ae.removeObserver(Le)}};return me instanceof s.$Rc?me.add(ke):Array.isArray(me)&&me.push(ke),ke}}I.fromObservableLight=_})(h||(e.Event=h={}));class y{static{this.all=new Set}static{this.f=0}constructor(k){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${k}_${y.f++}`,y.all.add(this)}start(k){this.g=new A.$Od,this.listenerCount=k}stop(){if(this.g){const k=this.g.elapsed();this.durations.push(k),this.elapsedOverall+=k,this.invocationCount+=1,this.g=void 0}}}e.$Qd=y;let v=-1;function b(I){const k=v;return v=I,{dispose(){v=k}}}e.$Rd=b;class l{constructor(k,C=Math.random().toString(18).slice(2,5)){this.threshold=k,this.name=C,this.g=0}dispose(){this.f?.clear()}check(k,C){const M=this.threshold;if(M<=0||C<M)return;this.f||(this.f=new Map);const F=this.f.get(k.value)||0;if(this.f.set(k.value,F+1),this.g-=1,this.g<=0){this.g=M*.5;let N,Z=0;for(const[Q,le]of this.f)(!N||Z<le)&&(N=Q,Z=le);console.warn(`[${this.name}] potential listener LEAK detected, having ${C} listeners already. MOST frequent listener (${Z}):`),console.warn(N)}return()=>{const N=this.f.get(k.value)||0;this.f.set(k.value,N-1)}}}class p{static create(){return new p(new Error().stack??"")}constructor(k){this.value=k}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class ${constructor(k){this.value=k,this.id=w++}}const g=2,u=(I,k)=>{if(I instanceof $)k(I);else for(let C=0;C<I.length;C++){const M=I[C];M&&k(M)}};class c{constructor(k){this.w=0,this.f=k,this.g=v>0||this.f?.leakWarningThreshold?new l(this.f?.leakWarningThreshold??v):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(E){const k=this.t;queueMicrotask(()=>{u(k,C=>C.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(k,C,M)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$Sc.None;if(this.m)return s.$Sc.None;C&&(k=k.bind(C));const F=new $(k);let N,Z;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(F.stack=p.create(),N=this.g.check(F.stack,this.w+1)),E&&(F.stack=Z??p.create()),this.t?this.t instanceof $?(this.u??=new d,this.t=[this.t,F]):this.t.push(F):(this.f?.onWillAddFirstListener?.(this),this.t=F,this.f?.onDidAddFirstListener?.(this)),this.w++;const Q=(0,s.$Qc)(()=>{N?.(),this.x(F)});return M instanceof s.$Rc?M.add(Q):Array.isArray(M)&&M.push(Q),Q},this.q}x(k){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const C=this.t,M=C.indexOf(k);if(M===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,C[M]=void 0;const F=this.u.current===this;if(this.w*g<=C.length){let N=0;for(let Z=0;Z<C.length;Z++)C[Z]?C[N++]=C[Z]:F&&(this.u.end--,N<this.u.i&&this.u.i--);C.length=N}}y(k,C){if(!k)return;const M=this.f?.onListenerError||P.$1;if(!M){k.value(C);return}try{k.value(C)}catch(F){M(F)}}z(k){const C=k.current.t;for(;k.i<k.end;)this.y(C[k.i++],k.value);k.reset()}fire(k){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof $)this.y(this.t,k);else{const C=this.u;C.enqueue(this,k,this.t.length),this.z(C)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Sd=c;const S=()=>new d;e.$Td=S;class d{constructor(){this.i=-1,this.end=0}enqueue(k,C,M){this.i=0,this.end=M,this.current=k,this.value=C}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends c{async fireAsync(k,C,M){if(this.t)for(this.h||(this.h=new j.$3c),u(this.t,F=>this.h.push([F.value,k]));this.h.size>0&&!C.isCancellationRequested;){const[F,N]=this.h.shift(),Z=[],Q={...N,token:C,waitUntil:le=>{if(Object.isFrozen(Z))throw new Error("waitUntil can NOT be called asynchronous");M&&(le=M(le,F)),Z.push(le)}};try{F(Q)}catch(le){(0,P.$1)(le);continue}Object.freeze(Z),await Promise.allSettled(Z).then(le=>{for(const ce of le)ce.status==="rejected"&&(0,P.$1)(ce.reason)})}}}e.$Ud=t;class o extends c{get isPaused(){return this.h!==0}constructor(k){super(k),this.h=0,this.s=new j.$3c,this.A=k?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const k=Array.from(this.s);this.s.clear(),super.fire(this.A(k))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(k){this.w&&(this.h!==0?this.s.push(k):super.fire(k))}}e.$Vd=o;class r extends o{constructor(k){super(k),this.k=k.delay??100}fire(k){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(k)}}e.$Wd=r;class i extends c{constructor(k){super(k),this.h=[],this.k=k?.merge}fire(k){this.hasListeners()&&(this.h.push(k),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(C=>super.fire(C)),this.h=[]}))}}e.$Xd=i;class n{constructor(){this.g=!1,this.h=[],this.f=new c({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(k){const C={event:k,listener:null};this.h.push(C),this.g&&this.m(C);const M=()=>{this.g&&this.o(C);const F=this.h.indexOf(C);this.h.splice(F,1)};return(0,s.$Qc)((0,R.$db)(M))}j(){this.g=!0,this.h.forEach(k=>this.m(k))}k(){this.g=!1,this.h.forEach(k=>this.o(k))}m(k){k.listener=k.event(C=>this.f.fire(C))}o(k){k.listener&&k.listener.dispose(),k.listener=null}dispose(){this.f.dispose()}}e.$Yd=n;class a{constructor(k,C,M,F){this.f=new s.$Rc;const N=this.f.add(new n),Z=this.f.add(new s.$2c);function Q(le){Z.set(le,N.add(F(le)))}for(const le of k)Q(le);this.f.add(C(le=>{Q(le)})),this.f.add(M(le=>{Z.deleteAndDispose(le)})),this.event=N.event}dispose(){this.f.dispose()}}e.$Zd=a;class m{constructor(){this.f=[]}wrapEvent(k){return(C,M,F)=>k(N=>{const Z=this.f[this.f.length-1];Z?Z.push(()=>C.call(M,N)):C.call(M,N)},void 0,F)}bufferEvents(k){const C=[];this.f.push(C);const M=k();return this.f.pop(),C.forEach(F=>F()),M}}e.$1d=m;class D{constructor(){this.f=!1,this.g=h.None,this.h=s.$Sc.None,this.j=new c({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(k){this.g=k,this.f&&(this.h.dispose(),this.h=k(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$2d=D}),define(re[22],oe([0,1,3]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=e.CancellationToken=void 0;const R=Object.freeze(function(E,f){const h=setTimeout(E.bind(f),0);return{dispose(){clearTimeout(h)}}});var s;(function(E){function f(h){return h===E.None||h===E.Cancelled||h instanceof j?!0:!h||typeof h!="object"?!1:typeof h.isCancellationRequested=="boolean"&&typeof h.onCancellationRequested=="function"}E.isCancellationToken=f,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(s||(e.CancellationToken=s={}));class j{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new P.$Sd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(f){this.f=void 0,this.g=void 0,this.g=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new j),this.f}cancel(){this.f?this.f instanceof j&&this.f.cancel():this.f=s.Cancelled}dispose(f=!1){f&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof j&&this.f.dispose():this.f=s.None}}e.$3d=A}),define(re[142],oe([0,1,22]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=e.$Ce=e.$Be=void 0;class R{constructor(E){this.b=E,this.a=null}get(){if(this.a)return this.a;const E=new P.$3d,f=this.b(E.token);return this.a={promise:f,dispose:()=>{this.a=null,E.cancel(),E.dispose()}},this.a}}e.$Be=R;class s{constructor(E){this.c=E,this.a=void 0,this.b=void 0}get(E){const f=JSON.stringify(E);return this.b!==f&&(this.b=f,this.a=this.c(E)),this.a}}e.$Ce=s;class j{get cachedValues(){return this.a}constructor(E){this.b=E,this.a=new Map}get(E){if(this.a.has(E))return this.a.get(E);const f=this.b(E);return this.a.set(E,f),f}}e.$De=j}),define(re[63],oe([0,1,14,2]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;function s(S){const d=S;return d?typeof d.read=="function":!1}e.$4d=s;function j(S){const d=S;return d?[d.on,d.pause,d.resume,d.destroy].every(t=>typeof t=="function"):!1}e.$5d=j;function A(S){const d=S;return d?j(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.$6d=A;function E(S,d){return new f(S,d)}e.$7d=E;class f{constructor(d,t){this.e=d,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(d){if(!this.a.destroyed){if(this.a.flowing)this.g(d);else if(this.b.data.push(d),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(d){this.a.destroyed||(this.a.flowing?this.h(d):this.b.error.push(d))}end(d){this.a.destroyed||(typeof d<"u"&&this.write(d),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(d){this.c.data.slice(0).forEach(t=>t(d))}h(d){this.c.error.length===0?(0,P.$1)(d):this.c.error.slice(0).forEach(t=>t(d))}i(){this.c.end.slice(0).forEach(d=>d())}on(d,t){if(!this.a.destroyed)switch(d){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(d,t){if(this.a.destroyed)return;let o;switch(d){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const r=o.indexOf(t);r>=0&&o.splice(r,1)}}j(){if(this.b.data.length>0){const d=this.e(this.b.data);this.g(d),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const d of this.b.error)this.h(d);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function h(S,d){const t=[];let o;for(;(o=S.read())!==null;)t.push(o);return d(t)}e.$8d=h;function y(S,d,t){const o=[];let r;for(;(r=S.read())!==null&&o.length<t;)o.push(r);return r===null&&o.length>0?d(o):{read:()=>{if(o.length>0)return o.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return S.read()}}}e.$9d=y;function v(S,d){return new Promise((t,o)=>{const r=[];b(S,{onData:i=>{d&&r.push(i)},onError:i=>{d?o(i):t(void 0)},onEnd:()=>{t(d?d(r):void 0)}})})}e.$0d=v;function b(S,d,t){S.on("error",o=>{t?.isCancellationRequested||d.onError(o)}),S.on("end",()=>{t?.isCancellationRequested||d.onEnd()}),S.on("data",o=>{t?.isCancellationRequested||d.onData(o)})}e.$$d=b;function l(S,d){return new Promise((t,o)=>{const r=new R.$Rc,i=[],n=D=>{if(i.push(D),i.length>d)return r.dispose(),S.pause(),t({stream:S,buffer:i,ended:!1})},a=D=>(r.dispose(),o(D)),m=()=>(r.dispose(),t({stream:S,buffer:i,ended:!0}));r.add((0,R.$Qc)(()=>S.removeListener("error",a))),S.on("error",a),r.add((0,R.$Qc)(()=>S.removeListener("end",m))),S.on("end",m),r.add((0,R.$Qc)(()=>S.removeListener("data",n))),S.on("data",n)})}e.$_d=l;function p(S,d){const t=E(d);return t.end(S),t}e.$ae=p;function w(){const S=E(()=>{throw new Error("not supported")});return S.end(),S}e.$be=w;function $(S){let d=!1;return{read:()=>d?null:(d=!0,S)}}e.$ce=$;function g(S,d,t){const o=E(t);return b(S,{onData:r=>o.write(d.data(r)),onError:r=>o.error(d.error?d.error(r):r),onEnd:()=>o.end()}),o}e.$de=g;function u(S,d,t){let o=!1;return{read:()=>{const r=d.read();return o?r:(o=!0,r!==null?t([S,r]):S)}}}e.$ee=u;function c(S,d,t){let o=!1;const r=E(t);return b(d,{onData:i=>o?r.write(i):(o=!0,r.write(t([S,i]))),onError:i=>r.error(i),onEnd:()=>{o||(o=!0,r.write(S)),r.end()}}),r}e.$fe=c}),define(re[18],oe([0,1,62,63]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=void 0;const s=typeof Buffer<"u",j=new P.$V(()=>new Uint8Array(256));let A,E;class f{static alloc(C){return s?new f(Buffer.allocUnsafe(C)):new f(new Uint8Array(C))}static wrap(C){return s&&!Buffer.isBuffer(C)&&(C=Buffer.from(C.buffer,C.byteOffset,C.byteLength)),new f(C)}static fromString(C,M){return!(M?.dontUseNodeBuffer||!1)&&s?new f(Buffer.from(C)):(A||(A=new TextEncoder),new f(A.encode(C)))}static fromByteArray(C){const M=f.alloc(C.length);for(let F=0,N=C.length;F<N;F++)M.buffer[F]=C[F];return M}static concat(C,M){if(typeof M>"u"){M=0;for(let Z=0,Q=C.length;Z<Q;Z++)M+=C[Z].byteLength}const F=f.alloc(M);let N=0;for(let Z=0,Q=C.length;Z<Q;Z++){const le=C[Z];F.set(le,N),N+=le.byteLength}return F}constructor(C){this.buffer=C,this.byteLength=this.buffer.byteLength}clone(){const C=f.alloc(this.byteLength);return C.set(this),C}toString(){return s?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(C,M){return new f(this.buffer.subarray(C,M))}set(C,M){if(C instanceof f)this.buffer.set(C.buffer,M);else if(C instanceof Uint8Array)this.buffer.set(C,M);else if(C instanceof ArrayBuffer)this.buffer.set(new Uint8Array(C),M);else if(ArrayBuffer.isView(C))this.buffer.set(new Uint8Array(C.buffer,C.byteOffset,C.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(C){return b(this.buffer,C)}writeUInt32BE(C,M){l(this.buffer,C,M)}readUInt32LE(C){return p(this.buffer,C)}writeUInt32LE(C,M){w(this.buffer,C,M)}readUInt8(C){return $(this.buffer,C)}writeUInt8(C,M){g(this.buffer,C,M)}indexOf(C,M=0){return h(this.buffer,C instanceof f?C.buffer:C,M)}}e.$ge=f;function h(k,C,M=0){const F=C.byteLength,N=k.byteLength;if(F===0)return 0;if(F===1)return k.indexOf(C[0]);if(F>N-M)return-1;const Z=j.value;Z.fill(C.length);for(let ue=0;ue<C.length;ue++)Z[C[ue]]=C.length-ue-1;let Q=M+C.length-1,le=Q,ce=-1;for(;Q<N;)if(k[Q]===C[le]){if(le===0){ce=Q;break}Q--,le--}else Q+=Math.max(C.length-le,Z[k[Q]]),le=C.length-1;return ce}e.$he=h;function y(k,C){return k[C+0]<<0>>>0|k[C+1]<<8>>>0}e.$ie=y;function v(k,C,M){k[M+0]=C&255,C=C>>>8,k[M+1]=C&255}e.$je=v;function b(k,C){return k[C]*2**24+k[C+1]*2**16+k[C+2]*2**8+k[C+3]}e.$ke=b;function l(k,C,M){k[M+3]=C,C=C>>>8,k[M+2]=C,C=C>>>8,k[M+1]=C,C=C>>>8,k[M]=C}e.$le=l;function p(k,C){return k[C+0]<<0>>>0|k[C+1]<<8>>>0|k[C+2]<<16>>>0|k[C+3]<<24>>>0}e.$me=p;function w(k,C,M){k[M+0]=C&255,C=C>>>8,k[M+1]=C&255,C=C>>>8,k[M+2]=C&255,C=C>>>8,k[M+3]=C&255}e.$ne=w;function $(k,C){return k[C]}e.$oe=$;function g(k,C,M){k[M]=C}e.$pe=g;function u(k){return R.$8d(k,C=>f.concat(C))}e.$qe=u;function c(k){return R.$ce(k)}e.$re=c;function S(k){return R.$0d(k,C=>f.concat(C))}e.$se=S;async function d(k){return k.ended?f.concat(k.buffer):f.concat([...k.buffer,await S(k.stream)])}e.$te=d;function t(k){return R.$ae(k,C=>f.concat(C))}e.$ue=t;function o(k){return R.$de(k,{data:C=>typeof C=="string"?f.fromString(C):f.wrap(C)},C=>f.concat(C))}e.$ve=o;function r(k){return R.$7d(C=>f.concat(C),k)}e.$we=r;function i(k,C){return R.$ee(k,C,M=>f.concat(M))}e.$xe=i;function n(k,C){return R.$fe(k,C,M=>f.concat(M))}e.$ye=n;function a(k){let C=0,M=0,F=0;const N=new Uint8Array(Math.floor(k.length/4*3)),Z=le=>{switch(M){case 3:N[F++]=C|le,M=0;break;case 2:N[F++]=C|le>>>2,C=le<<6,M=3;break;case 1:N[F++]=C|le>>>4,C=le<<4,M=2;break;default:C=le<<2,M=1}};for(let le=0;le<k.length;le++){const ce=k.charCodeAt(le);if(ce>=65&&ce<=90)Z(ce-65);else if(ce>=97&&ce<=122)Z(ce-97+26);else if(ce>=48&&ce<=57)Z(ce-48+52);else if(ce===43||ce===45)Z(62);else if(ce===47||ce===95)Z(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${k[le]}`)}}const Q=F;for(;M>0;)Z(0);return f.wrap(N).slice(0,Q)}e.$ze=a;const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:k},C=!0,M=!1){const F=M?D:m;let N="";const Z=k.byteLength%3;let Q=0;for(;Q<k.byteLength-Z;Q+=3){const le=k[Q+0],ce=k[Q+1],ue=k[Q+2];N+=F[le>>>2],N+=F[(le<<4|ce>>>4)&63],N+=F[(ce<<2|ue>>>6)&63],N+=F[ue&63]}if(Z===1){const le=k[Q+0];N+=F[le>>>2],N+=F[le<<4&63],C&&(N+="==")}else if(Z===2){const le=k[Q+0],ce=k[Q+1];N+=F[le>>>2],N+=F[(le<<4|ce>>>4)&63],N+=F[ce<<2&63],C&&(N+="=")}return N}e.$Ae=I}),define(re[25],oe([0,1,142,62]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ef=e.$Df=e.$Cf=e.$Bf=e.GraphemeBreakType=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=void 0;function s(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.$Ge=s;const j=/{(\d+)}/g;function A(ie,...de){return de.length===0?ie:ie.replace(j,function(be,Se){const ve=parseInt(Se,10);return isNaN(ve)||ve<0||ve>=de.length?be:de[ve]})}e.$He=A;const E=/{([^}]+)}/g;function f(ie,de){return Object.keys(de).length===0?ie:ie.replace(E,(be,Se)=>de[Se]??be)}e.$Ie=f;function h(ie){return ie.replace(/[<>"'&]/g,de=>{switch(de){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return de})}e.$Je=h;function y(ie){return ie.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}e.$Ke=y;function v(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Le=v;function b(ie,de){let be=0;const Se=de.charCodeAt(0);for(let ve=ie.length-1;ve>=0;ve--)ie.charCodeAt(ve)===Se&&be++;return be}e.$Me=b;function l(ie,de,be="\u2026"){return ie.length<=de?ie:`${ie.substr(0,de)}${be}`}e.$Ne=l;function p(ie,de,be="\u2026"){if(ie.length<=de)return ie;const Se=Math.ceil(de/2)-be.length/2,ve=Math.floor(de/2)-be.length/2;return`${ie.substr(0,Se)}${be}${ie.substr(ie.length-ve)}`}e.$Oe=p;function w(ie,de=" "){const be=$(ie,de);return g(be,de)}e.$Pe=w;function $(ie,de){if(!ie||!de)return ie;const be=de.length;if(be===0||ie.length===0)return ie;let Se=0;for(;ie.indexOf(de,Se)===Se;)Se=Se+be;return ie.substring(Se)}e.$Qe=$;function g(ie,de){if(!ie||!de)return ie;const be=de.length,Se=ie.length;if(be===0||Se===0)return ie;let ve=Se,De=-1;for(;De=ie.lastIndexOf(de,ve-1),!(De===-1||De+be!==ve);){if(De===0)return"";ve=De}return ie.substring(0,ve)}e.$Re=g;function u(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Se=u;function c(ie){return ie.replace(/\*/g,"")}e.$Te=c;function S(ie,de,be={}){if(!ie)throw new Error("Cannot create regex from empty string");de||(ie=v(ie)),be.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let Se="";return be.global&&(Se+="g"),be.matchCase||(Se+="i"),be.multiline&&(Se+="m"),be.unicode&&(Se+="u"),new RegExp(ie,Se)}e.$Ue=S;function d(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.$Ve=d;function t(ie){return ie.split(/\r\n|\r|\n/)}e.$We=t;function o(ie){for(let de=0,be=ie.length;de<be;de++){const Se=ie.charCodeAt(de);if(Se!==32&&Se!==9)return de}return-1}e.$Xe=o;function r(ie,de=0,be=ie.length){for(let Se=de;Se<be;Se++){const ve=ie.charCodeAt(Se);if(ve!==32&&ve!==9)return ie.substring(de,Se)}return ie.substring(de,be)}e.$Ye=r;function i(ie,de=ie.length-1){for(let be=de;be>=0;be--){const Se=ie.charCodeAt(be);if(Se!==32&&Se!==9)return be}return-1}e.$Ze=i;function n(ie,de,be){const Se=[];let ve=0;for(const De of ie.matchAll(de)){if(Se.push(ie.slice(ve,De.index)),De.index===void 0)throw new Error("match.index should be defined");ve=De.index+De[0].length,Se.push(be(De[0],...De.slice(1),De.index,ie,De.groups))}return Se.push(ie.slice(ve)),Promise.all(Se).then(De=>De.join(""))}e.$1e=n;function a(ie,de){return ie<de?-1:ie>de?1:0}e.$2e=a;function m(ie,de,be=0,Se=ie.length,ve=0,De=de.length){for(;be<Se&&ve<De;be++,ve++){const Qe=ie.charCodeAt(be),xe=de.charCodeAt(ve);if(Qe<xe)return-1;if(Qe>xe)return 1}const Ne=Se-be,qe=De-ve;return Ne<qe?-1:Ne>qe?1:0}e.$3e=m;function D(ie,de){return I(ie,de,0,ie.length,0,de.length)}e.$4e=D;function I(ie,de,be=0,Se=ie.length,ve=0,De=de.length){for(;be<Se&&ve<De;be++,ve++){let Qe=ie.charCodeAt(be),xe=de.charCodeAt(ve);if(Qe===xe)continue;if(Qe>=128||xe>=128)return m(ie.toLowerCase(),de.toLowerCase(),be,Se,ve,De);C(Qe)&&(Qe-=32),C(xe)&&(xe-=32);const Ze=Qe-xe;if(Ze!==0)return Ze}const Ne=Se-be,qe=De-ve;return Ne<qe?-1:Ne>qe?1:0}e.$5e=I;function k(ie){return ie>=48&&ie<=57}e.$6e=k;function C(ie){return ie>=97&&ie<=122}e.$7e=C;function M(ie){return ie>=65&&ie<=90}e.$8e=M;function F(ie,de){return ie.length===de.length&&I(ie,de)===0}e.$9e=F;function N(ie,de){const be=de.length;return de.length>ie.length?!1:I(ie,de,0,be)===0}e.$0e=N;function Z(ie,de){const be=Math.min(ie.length,de.length);let Se;for(Se=0;Se<be;Se++)if(ie.charCodeAt(Se)!==de.charCodeAt(Se))return Se;return be}e.$$e=Z;function Q(ie,de){const be=Math.min(ie.length,de.length);let Se;const ve=ie.length-1,De=de.length-1;for(Se=0;Se<be;Se++)if(ie.charCodeAt(ve-Se)!==de.charCodeAt(De-Se))return Se;return be}e.$_e=Q;function le(ie){return 55296<=ie&&ie<=56319}e.$af=le;function ce(ie){return 56320<=ie&&ie<=57343}e.$bf=ce;function ue(ie,de){return(ie-55296<<10)+(de-56320)+65536}e.$cf=ue;function X(ie,de,be){const Se=ie.charCodeAt(be);if(le(Se)&&be+1<de){const ve=ie.charCodeAt(be+1);if(ce(ve))return ue(Se,ve)}return Se}e.$df=X;function K(ie,de){const be=ie.charCodeAt(de-1);if(ce(be)&&de>1){const Se=ie.charCodeAt(de-2);if(le(Se))return ue(Se,be)}return be}class H{get offset(){return this.e}constructor(de,be=0){this.c=de,this.d=de.length,this.e=be}setOffset(de){this.e=de}prevCodePoint(){const de=K(this.c,this.e);return this.e-=de>=65536?2:1,de}nextCodePoint(){const de=X(this.c,this.d,this.e);return this.e+=de>=65536?2:1,de}eol(){return this.e>=this.d}}e.$ef=H;class L{get offset(){return this.c.offset}constructor(de,be=0){this.c=new H(de,be)}nextGraphemeLength(){const de=Ie.getInstance(),be=this.c,Se=be.offset;let ve=de.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const De=be.offset,Ne=de.getGraphemeBreakType(be.nextCodePoint());if(fe(ve,Ne)){be.setOffset(De);break}ve=Ne}return be.offset-Se}prevGraphemeLength(){const de=Ie.getInstance(),be=this.c,Se=be.offset;let ve=de.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const De=be.offset,Ne=de.getGraphemeBreakType(be.prevCodePoint());if(fe(Ne,ve)){be.setOffset(De);break}ve=Ne}return Se-be.offset}eol(){return this.c.eol()}}e.$ff=L;function T(ie,de){return new L(ie,de).nextGraphemeLength()}e.$gf=T;function V(ie,de){return new L(ie,de).prevGraphemeLength()}e.$hf=V;function q(ie,de){de>0&&ce(ie.charCodeAt(de))&&de--;const be=de+T(ie,de);return[be-V(ie,be),be]}e.$if=q;function te(ie){const de=new L(ie);let be=0;for(;!de.eol();)be++,de.nextGraphemeLength();return be}e.$jf=te;let he;function G(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function O(ie){return he||(he=G()),he.test(ie)}e.$kf=O;const U=/^[\t\n\r\x20-\x7E]*$/;function x(ie){return U.test(ie)}e.$lf=x,e.$mf=/[\u2028\u2029]/;function z(ie){return e.$mf.test(ie)}e.$nf=z;function Y(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.$of=Y;function W(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.$pf=W;function B(ie,de,be=""){const Se=ie.trimStart();if(Se.length<de)return Se;const ve=/\b/g;let De=0;for(;ve.test(Se)&&!(Se.length-ve.lastIndex<de);)De=ve.lastIndex,ve.lastIndex+=1;return De===0?Se:be+Se.substring(De).trimStart()}e.$qf=B;const _=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ae=/\x1b\].*?\x07/g;function se(ie){return ie&&(ie=ie.replace(_,"").replace(ae,"")),ie}e.$rf=se,e.$sf=String.fromCharCode(65279);function $e(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.$tf=$e;function me(ie){return $e(ie)?ie.substr(1):ie}e.$uf=me;function ye(ie,de){if(!ie||!de||ie.length<de.length)return!1;const be=de.length,Se=ie.toLowerCase();let ve=0,De=-1;for(;ve<be;){const Ne=Se.indexOf(de[ve],De+1);if(Ne<0)return!1;De=Ne,ve++}return!0}e.$vf=ye;function Pe(ie,de=!1){return ie?(de&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.$wf=Pe;function Le(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.$xf=Le;function ke(ie,de=1){if(de===0)return"";let be=-1;do be=ie.indexOf(`
`,be+1),de--;while(de>0&&be>=0);return be===-1?ie:(ie[be-1]==="\r"&&be--,ie.substr(0,be))}e.$yf=ke;function pe(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}e.$zf=pe;function ee(ie){return Ie.getInstance().getGraphemeBreakType(ie)}e.$Af=ee;function fe(ie,de){return ie===0?de!==5&&de!==7:ie===2&&de===3?!1:ie===4||ie===2||ie===3||de===4||de===2||de===3?!0:!(ie===8&&(de===8||de===9||de===11||de===12)||(ie===11||ie===9)&&(de===9||de===10)||(ie===12||ie===10)&&de===10||de===5||de===13||de===7||ie===1||ie===13&&de===14||ie===6&&de===6)}var ge;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(ge||(e.GraphemeBreakType=ge={}));class Ie{static{this.c=null}static getInstance(){return Ie.c||(Ie.c=new Ie),Ie.c}constructor(){this.d=je()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const be=this.d,Se=be.length/3;let ve=1;for(;ve<=Se;)if(de<be[3*ve])ve=2*ve;else if(de>be[3*ve+1])ve=2*ve+1;else return be[3*ve+2];return 0}}function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(ie,de){if(ie===0)return 0;const be=Me(ie,de);if(be!==void 0)return be;const Se=new H(de,ie);return Se.prevCodePoint(),Se.offset}e.$Bf=We;function Me(ie,de){const be=new H(de,ie);let Se=be.prevCodePoint();for(;Je(Se)||Se===65039||Se===8419;){if(be.offset===0)return;Se=be.prevCodePoint()}if(!W(Se))return;let ve=be.offset;return ve>0&&be.prevCodePoint()===8205&&(ve=be.offset),ve}function Je(ie){return 127995<=ie&&ie<=127999}var Be;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),e.$Cf="\xA0";class He{static{this.c=new R.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new P.$Ce(de=>{function be(Ze){const Ye=new Map;for(let nt=0;nt<Ze.length;nt+=2)Ye.set(Ze[nt],Ze[nt+1]);return Ye}function Se(Ze,Ye){const nt=new Map(Ze);for(const[st,ot]of Ye)nt.set(st,ot);return nt}function ve(Ze,Ye){if(!Ze)return Ye;const nt=new Map;for(const[st,ot]of Ze)Ye.has(st)&&nt.set(st,ot);return nt}const De=this.c.value;let Ne=de.filter(Ze=>!Ze.startsWith("_")&&Ze in De);Ne.length===0&&(Ne=["_default"]);let qe;for(const Ze of Ne){const Ye=be(De[Ze]);qe=ve(qe,Ye)}const Qe=be(De._common),xe=Se(Qe,qe);return new He(xe)})}static getInstance(de){return He.d.get(Array.from(de))}static{this.e=new R.$V(()=>Object.keys(He.c.value).filter(de=>!de.startsWith("_")))}static getLocales(){return He.e.value}constructor(de){this.f=de}isAmbiguous(de){return this.f.has(de)}getPrimaryConfusable(de){return this.f.get(de)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Df=He;class Ve{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ve.c())),this.d}static isInvisibleCharacter(de){return Ve.e().has(de)}static get codePoints(){return Ve.e()}}e.$Ef=Ve}),define(re[45],oe([0,1,25]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=void 0;function R(g){return s(g,0)}e.$Qi=R;function s(g,u){switch(typeof g){case"object":return g===null?j(349,u):Array.isArray(g)?f(g,u):h(g,u);case"string":return E(g,u);case"boolean":return A(g,u);case"number":return j(g,u);case"undefined":return j(937,u);default:return j(617,u)}}e.$Ri=s;function j(g,u){return(u<<5)-u+g|0}e.$Si=j;function A(g,u){return j(g?433:863,u)}function E(g,u){u=j(149417,u);for(let c=0,S=g.length;c<S;c++)u=j(g.charCodeAt(c),u);return u}e.$Ti=E;function f(g,u){return u=j(104579,u),g.reduce((c,S)=>s(S,c),u)}function h(g,u){return u=j(181387,u),Object.keys(g).sort().reduce((c,S)=>(c=E(S,c),s(g[S],c)),u)}class y{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=s(u,this.g),this.g}}e.$Ui=y;var v;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function b(g,u,c=32){const S=c-u,d=~((1<<S)-1);return(g<<u|(d&g)>>>S)>>>0}function l(g,u=0,c=g.byteLength,S=0){for(let d=0;d<c;d++)g[u+d]=S}function p(g,u,c="0"){for(;g.length<u;)g=c+g;return g}function w(g,u=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(c=>c.toString(16).padStart(2,"0")).join(""):p((g>>>0).toString(16),u/4)}e.$Vi=w;class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const c=u.length;if(c===0)return;const S=this.p;let d=this.r,t=this.u,o,r;for(t!==0?(o=t,r=-1,t=0):(o=u.charCodeAt(0),r=0);;){let i=o;if(P.$af(o))if(r+1<c){const n=u.charCodeAt(r+1);P.$bf(n)?(r++,i=P.$cf(o,n)):i=65533}else{t=o;break}else P.$bf(o)&&(i=65533);if(d=this.w(S,d,i),r++,r<c)o=u.charCodeAt(r);else break}this.r=d,this.u=t}w(u,c,S){return S<128?u[c++]=S:S<2048?(u[c++]=192|(S&1984)>>>6,u[c++]=128|(S&63)>>>0):S<65536?(u[c++]=224|(S&61440)>>>12,u[c++]=128|(S&4032)>>>6,u[c++]=128|(S&63)>>>0):(u[c++]=240|(S&1835008)>>>18,u[c++]=128|(S&258048)>>>12,u[c++]=128|(S&4032)>>>6,u[c++]=128|(S&63)>>>0),c>=64&&(this.y(),c-=64,this.t+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),c}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,l(this.p,this.r),this.r>56&&(this.y(),l(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=$.g,c=this.q;for(let m=0;m<64;m+=4)u.setUint32(m,c.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)u.setUint32(m,b(u.getUint32(m-12,!1)^u.getUint32(m-32,!1)^u.getUint32(m-56,!1)^u.getUint32(m-64,!1),1),!1);let S=this.h,d=this.l,t=this.m,o=this.n,r=this.o,i,n,a;for(let m=0;m<80;m++)m<20?(i=d&t|~d&o,n=1518500249):m<40?(i=d^t^o,n=1859775393):m<60?(i=d&t|d&o|t&o,n=2400959708):(i=d^t^o,n=3395469782),a=b(S,5)+i+r+n+u.getUint32(m*4,!1)&4294967295,r=o,o=t,t=b(d,30),d=S,S=a;this.h=this.h+S&4294967295,this.l=this.l+d&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+r&4294967295}}e.$Wi=$}),define(re[74],oe([0,1,25]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(R||(R={})),function(s){const j="error",A="warning",E="warn",f="info",h="ignore";function y(b){return b?P.$9e(j,b)?s.Error:P.$9e(A,b)||P.$9e(E,b)?s.Warning:P.$9e(f,b)?s.Info:s.Ignore:s.Ignore}s.fromValue=y;function v(b){switch(b){case s.Error:return j;case s.Warning:return A;case s.Info:return f;default:return h}}s.toString=v}(R||(R={})),e.default=R}),define(re[143],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pd=void 0,e.$Pd=Symbol("MicrotaskDelay")}),define(re[57],oe([0,1,23,25]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=void 0;class s{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const p=l.charCodeAt(0),w=this.b.charCodeAt(this.c);return p-w}value(){return this.b[this.c]}}e.$5h=s;class j{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,R.$3e)(l,this.b,0,l.length,this.c,this.d):(0,R.$5e)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$6h=j;class A{constructor(l=!0,p=!0){this.f=l,this.g=p}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let p=l.length-1;p>=0;p--,this.c--){const w=this.b.charCodeAt(p);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,R.$3e)(l,this.b,0,l.length,this.d,this.e):(0,R.$5e)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$7h=A;var E;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(E||(E={}));class f{constructor(l,p){this.f=l,this.g=p,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(3)),this.g(l)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===1)return(0,R.$4e)(l,this.c.scheme);if(this.d[this.e]===2)return(0,R.$4e)(l,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(l);if(this.d[this.e]===4)return(0,R.$2e)(l,this.c.query);if(this.d[this.e]===5)return(0,R.$2e)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$8h=f;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(y||(y={}));class v{static forUris(l=()=>!1,p=()=>!1){return new v(new f(l,p))}static forPaths(l=!1){return new v(new A(void 0,!l))}static forStrings(){return new v(new s)}static forConfigKeys(){return new v(new j)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,p){if(p){const w=p.slice(0);(0,P.$Xb)(w);for(const $ of w)this.set($,l)}else{const w=l.slice(0);(0,P.$Xb)(w);for(const $ of w)this.set($[0],$[1])}}set(l,p){const w=this.b.reset(l);let $;this.c||(this.c=new h,this.c.segment=w.value());const g=[];for($=this.c;;){const c=w.cmp($.segment);if(c>0)$.left||($.left=new h,$.left.segment=w.value()),g.push([-1,$]),$=$.left;else if(c<0)$.right||($.right=new h,$.right.segment=w.value()),g.push([1,$]),$=$.right;else if(w.hasNext())w.next(),$.mid||($.mid=new h,$.mid.segment=w.value()),g.push([0,$]),$=$.mid;else break}const u=$.value;$.value=p,$.key=l;for(let c=g.length-1;c>=0;c--){const S=g[c][1];S.updateHeight();const d=S.balanceFactor();if(d<-1||d>1){const t=g[c][0],o=g[c+1][0];if(t===1&&o===1)g[c][1]=S.rotateLeft();else if(t===-1&&o===-1)g[c][1]=S.rotateRight();else if(t===1&&o===-1)S.right=g[c+1][1]=g[c+1][1].rotateRight(),g[c][1]=S.rotateLeft();else if(t===-1&&o===1)S.left=g[c+1][1]=g[c+1][1].rotateLeft(),g[c][1]=S.rotateRight();else throw new Error;if(c>0)switch(g[c-1][0]){case-1:g[c-1][1].left=g[c][1];break;case 1:g[c-1][1].right=g[c][1];break;case 0:g[c-1][1].mid=g[c][1];break}else this.c=g[0][1]}}return u}get(l){return this.d(l)?.value}d(l){const p=this.b.reset(l);let w=this.c;for(;w;){const $=p.cmp(w.segment);if($>0)w=w.left;else if($<0)w=w.right;else if(p.hasNext())p.next(),w=w.mid;else break}return w}has(l){const p=this.d(l);return!(p?.value===void 0&&p?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,p){const w=this.b.reset(l),$=[];let g=this.c;for(;g;){const u=w.cmp(g.segment);if(u>0)$.push([-1,g]),g=g.left;else if(u<0)$.push([1,g]),g=g.right;else if(w.hasNext())w.next(),$.push([0,g]),g=g.mid;else break}if(g){if(p?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const u=this.f(g.right);if(u.key){const{key:c,value:S,segment:d}=u;this.e(u.key,!1),g.key=c,g.value=S,g.segment=d}}else{const u=g.left??g.right;if($.length>0){const[c,S]=$[$.length-1];switch(c){case-1:S.left=u;break;case 0:S.mid=u;break;case 1:S.right=u;break}}else this.c=u}for(let u=$.length-1;u>=0;u--){const c=$[u][1];c.updateHeight();const S=c.balanceFactor();if(S>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),$[u][1]=c.rotateLeft()):S<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),$[u][1]=c.rotateRight()),u>0)switch($[u-1][0]){case-1:$[u-1][1].left=$[u][1];break;case 1:$[u-1][1].right=$[u][1];break;case 0:$[u-1][1].mid=$[u][1];break}else this.c=$[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const p=this.b.reset(l);let w=this.c,$;for(;w;){const g=p.cmp(w.segment);if(g>0)w=w.left;else if(g<0)w=w.right;else if(p.hasNext())p.next(),$=w.value||$,w=w.mid;else break}return w&&w.value||$}findSuperstr(l){return this.g(l,!1)}g(l,p){const w=this.b.reset(l);let $=this.c;for(;$;){const g=w.cmp($.segment);if(g>0)$=$.left;else if(g<0)$=$.right;else if(w.hasNext())w.next(),$=$.mid;else return $.mid?this.h($.mid):p?$.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[p,w]of this)l(w,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const p=[];return this.j(l,p),p[Symbol.iterator]()}j(l,p){l&&(l.left&&this.j(l.left,p),l.value&&p.push([l.key,l.value]),l.mid&&this.j(l.mid,p),l.right&&this.j(l.right,p))}_isBalanced(){const l=p=>{if(!p)return!0;const w=p.balanceFactor();return w<-1||w>1?!1:l(p.left)&&l(p.right)};return l(this.c)}}e.$9h=v}),define(re[12],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=void 0;function P(d){return typeof d=="string"}e.$Ff=P;function R(d){return Array.isArray(d)&&d.every(t=>P(t))}e.$Gf=R;function s(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.$Hf=s;function j(d){const t=Object.getPrototypeOf(Uint8Array);return typeof d=="object"&&d instanceof t}e.$If=j;function A(d){return typeof d=="number"&&!isNaN(d)}e.$Jf=A;function E(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.$Kf=E;function f(d){return d===!0||d===!1}e.$Lf=f;function h(d){return typeof d>"u"}e.$Mf=h;function y(d){return!v(d)}e.$Nf=y;function v(d){return h(d)||d===null}e.$Of=v;function b(d,t){if(!d)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Pf=b;function l(d){if(v(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.$Qf=l;function p(...d){const t=[];for(let o=0;o<d.length;o++){const r=d[o];if(v(r))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(r)}return t}e.$Rf=p;const w=Object.prototype.hasOwnProperty;function $(d){if(!s(d))return!1;for(const t in d)if(w.call(d,t))return!1;return!0}e.$Sf=$;function g(d){return typeof d=="function"}e.$Tf=g;function u(...d){return d.length>0&&d.every(g)}e.$Uf=u;function c(d,t){const o=Math.min(d.length,t.length);for(let r=0;r<o;r++)S(d[r],t[r])}e.$Vf=c;function S(d,t){if(P(t)){if(typeof d!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(g(t)){try{if(d instanceof t)return}catch{}if(!v(d)&&d.constructor===t||t.length===1&&t.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Wf=S}),define(re[75],oe([0,1,12]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=e.$8j=e.$7j=void 0;const R=Object.create(null);function s(E,f){if((0,P.$Ff)(f)){const h=R[f];if(h===void 0)throw new Error(`${E} references an unknown codicon: ${f}`);f=h}return R[E]=f,{id:E}}function j(){return R}e.$7j=j;function A(){return Object.values(e.$9j)}e.$8j=A,e.$9j={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),thumbsDownFilled:s("thumbsdown-filled",60435),thumbsUpFilled:s("thumbsup-filled",60436),coffee:s("coffee",60437),snake:s("snake",60438),game:s("game",60439),vr:s("vr",60440),chip:s("chip",60441),piano:s("piano",60442),music:s("music",60443),micFilled:s("mic-filled",60444),gitFetch:s("git-fetch",60445),copilot:s("copilot",60446),lightbulbSparkle:s("lightbulb-sparkle",60447),lightbulbSparkleAutofix:s("lightbulb-sparkle-autofix",60447),robot:s("robot",60448),sparkleFilled:s("sparkle-filled",60449),diffSingle:s("diff-single",60450),diffMultiple:s("diff-multiple",60451),surroundWith:s("surround-with",60452),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(re[38],oe([0,1,12]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=void 0;function R(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const u=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([c,S])=>{u[c]=S&&typeof S=="object"?R(S):S}),u}e.$jn=R;function s(g){if(!g||typeof g!="object")return g;const u=[g];for(;u.length>0;){const c=u.shift();Object.freeze(c);for(const S in c)if(j.call(c,S)){const d=c[S];typeof d=="object"&&!Object.isFrozen(d)&&!(0,P.$If)(d)&&u.push(d)}}return g}e.$kn=s;const j=Object.prototype.hasOwnProperty;function A(g,u){return E(g,u,new Set)}e.$ln=A;function E(g,u,c){if((0,P.$Of)(g))return g;const S=u(g);if(typeof S<"u")return S;if(Array.isArray(g)){const d=[];for(const t of g)d.push(E(t,u,c));return d}if((0,P.$Hf)(g)){if(c.has(g))throw new Error("Cannot clone recursive data-structure");c.add(g);const d={};for(const t in g)j.call(g,t)&&(d[t]=E(g[t],u,c));return c.delete(g),d}return g}function f(g,u,c=!0){return(0,P.$Hf)(g)?((0,P.$Hf)(u)&&Object.keys(u).forEach(S=>{S in g?c&&((0,P.$Hf)(g[S])&&(0,P.$Hf)(u[S])?f(g[S],u[S],c):g[S]=u[S]):g[S]=u[S]}),g):u}e.$mn=f;function h(g,u){if(g===u)return!0;if(g==null||u===null||u===void 0||typeof g!=typeof u||typeof g!="object"||Array.isArray(g)!==Array.isArray(u))return!1;let c,S;if(Array.isArray(g)){if(g.length!==u.length)return!1;for(c=0;c<g.length;c++)if(!h(g[c],u[c]))return!1}else{const d=[];for(S in g)d.push(S);d.sort();const t=[];for(S in u)t.push(S);if(t.sort(),!h(d,t))return!1;for(c=0;c<d.length;c++)if(!h(g[d[c]],u[d[c]]))return!1}return!0}e.$nn=h;function y(g){const u=new Set;return JSON.stringify(g,(c,S)=>{if((0,P.$Hf)(S)||Array.isArray(S)){if(u.has(S))return"[Circular]";u.add(S)}return S})}e.$on=y;function v(g,u){const c=Object.create(null);return!g||!u||Object.keys(u).forEach(d=>{const t=g[d],o=u[d];h(t,o)||(c[d]=o)}),c}e.$pn=v;function b(g,u){const c=u.toLowerCase(),S=Object.keys(g).find(d=>d.toLowerCase()===c);return S?g[S]:g[u]}e.$qn=b;function l(g,u){const c=Object.create(null);for(const[S,d]of Object.entries(g))u(S,d)&&(c[S]=d);return c}e.$rn=l;function p(g){let u=[];for(;Object.prototype!==g;)u=u.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return u}e.$sn=p;function w(g){const u=[];for(const c of p(g))typeof g[c]=="function"&&u.push(c);return u}e.$tn=w;function $(g,u){const c=d=>function(){const t=Array.prototype.slice.call(arguments,0);return u(d,t)},S={};for(const d of g)S[d]=c(d);return S}e.$un=$}),define(re[102],oe([0,1,75]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$0j=e.ThemeColor=void 0;var R;(function(A){function E(f){return f&&typeof f=="object"&&typeof f.id=="string"}A.isThemeColor=E})(R||(e.ThemeColor=R={}));function s(A){return{id:A}}e.$0j=s;var j;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const E=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function f(u){const c=E.exec(u.id);if(!c)return f(P.$9j.error);const[,S,d]=c,t=["codicon","codicon-"+S];return d&&t.push("codicon-modifier-"+d.substring(1)),t}A.asClassNameArray=f;function h(u){return f(u).join(" ")}A.asClassName=h;function y(u){return"."+f(u).join(".")}A.asCSSSelector=y;function v(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||R.isThemeColor(u.color))}A.isThemeIcon=v;const b=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function l(u){const c=b.exec(u);if(!c)return;const[,S]=c;return{id:S}}A.fromString=l;function p(u){return{id:u}}A.fromId=p;function w(u,c){let S=u.id;const d=S.lastIndexOf("~");return d!==-1&&(S=S.substring(0,d)),c&&(S=`${S}~${c}`),{id:S}}A.modify=w;function $(u){const c=u.id.lastIndexOf("~");if(c!==-1)return u.id.substring(c+1)}A.getModifier=$;function g(u,c){return u.id===c.id&&u.color?.id===c.color?.id}A.isEqual=g})(j||(e.ThemeIcon=j={}))}),define(re[32],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ng=e.$mg=void 0;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(s){return P.test(s)}e.$mg=R,e.$ng=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(E){for(let f=0;f<E.length;f++)E[f]=Math.floor(Math.random()*256);return E};const j=new Uint8Array(16),A=[];for(let E=0;E<256;E++)A.push(E.toString(16).padStart(2,"0"));return function(){s(j),j[6]=j[6]&15|64,j[8]=j[8]&63|128;let f=0,h="";return h+=A[j[f++]],h+=A[j[f++]],h+=A[j[f++]],h+=A[j[f++]],h+="-",h+=A[j[f++]],h+=A[j[f++]],h+="-",h+=A[j[f++]],h+=A[j[f++]],h+="-",h+=A[j[f++]],h+=A[j[f++]],h+="-",h+=A[j[f++]],h+=A[j[f++]],h+=A[j[f++]],h+=A[j[f++]],h+=A[j[f++]],h+=A[j[f++]],h}}()}),define(re[144],oe([0,1,86,46,84]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eU=void 0;async function j(A,E){if(await new Promise((y,v)=>{const b=R.createReadStream(A),l=P.createHash("sha1");b.pipe(l);const p=(0,s.$db)((w,$)=>{b.removeAllListeners(),l.removeAllListeners(),w?v(w):y($)});b.once("error",p),b.once("end",p),l.once("error",p),l.once("data",w=>p(void 0,w.toString("hex")))})!==E)throw new Error("Hash mismatch")}e.$eU=j}),define(re[145],oe([0,1,26]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(A){const E=A.replace(/\-/g,":").toLowerCase();return!R.has(E)}function j(){const A=(0,P.networkInterfaces)();for(const E in A){const f=A[E];if(f){for(const{mac:h}of f)if(s(h))return h}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$6m=j}),define(re[103],oe([0,1,87]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rg=e.$qg=e.$pg=void 0;function R(E,f,h,y=1){let v=!1;return new Promise(b=>{const l=setTimeout(()=>{if(!v)return v=!0,b(0)},h);s(E,f,y,p=>{if(!v)return v=!0,clearTimeout(l),b(p)})})}e.$pg=R;function s(E,f,h,y){if(f===0)return y(0);const v=new P.Socket;v.once("connect",()=>(A(v),s(E+h,f-1,h,y))),v.once("data",()=>{}),v.once("error",b=>(A(v),b.code!=="ECONNREFUSED"?s(E+h,f-1,h,y):y(E))),v.connect(E,"127.0.0.1")}e.$qg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function j(E,f,h,y="127.0.0.1"){let v=!1,b,l=1;const p=P.createServer({pauseOnConnect:!0});function w($,g){v||(v=!0,p.removeAllListeners(),p.close(),b&&clearTimeout(b),g($))}return new Promise($=>{b=setTimeout(()=>{w(0,$)},h),p.on("listening",()=>{w(E,$)}),p.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&l<f?(E++,l++,p.listen(E,y)):w(0,$)}),p.on("close",()=>{w(0,$)}),p.listen(E,y)})}e.$rg=j;function A(E){try{E.removeAllListeners("connect"),E.removeAllListeners("error"),E.end(),E.destroy(),E.unref()}catch(f){console.error(f)}}}),function(){function J(){function e(){return process.uncHostAllowlist}function P(f){const h=new Set;if(Array.isArray(f))for(const y of f)typeof y=="string"&&h.add(y);return Array.from(h)}function R(){const f=e();return f?Array.from(f):[]}function s(f){if(process.platform!=="win32")return;const h=e();if(h)if(typeof f=="string")h.add(f.toLowerCase());else for(const y of P(f))s(y)}function j(f){if(typeof f!="string")return;const h=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let y;for(const v of h){if(f.indexOf(v)!==0)continue;const l=f.indexOf("\\",v.length);if(l===-1)continue;const p=f.substring(v.length,l);if(p){y=p;break}}return y}function A(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function E(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:R,addUNCHostToAllowlist:s,getUNCHost:j,disableUNCAccessRestrictions:A,isUNCAccessRestrictionsDisabled:E}}typeof define=="function"?define("vs/base/node/unc",[],function(){return J()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=J():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(re[146],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iU=e.$hU=void 0,e.$hU="vscode:contextmenu",e.$iU="vscode:onCloseContextMenu"}),define(re[147],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pU=void 0;class P{constructor(s,j){this.a=s,this.onMessage=j}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$pU=P}),define(re[148],oe([11,10]),function(J,e){return J.create("vs/base/common/date",e)}),define(re[149],oe([0,1,148]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=e.$sm=void 0;const R=60,s=R*60,j=s*24,A=j*7,E=j*30,f=j*365;function h(v,b,l,p){typeof v!="number"&&(v=v.getTime());const w=Math.round((new Date().getTime()-v)/1e3);if(w<-30)return(0,P.localize)(0,null,h(new Date().getTime()+w*1e3,!1));if(!p&&w<30)return(0,P.localize)(1,null);let $;return w<R?($=w,b?$===1?l?(0,P.localize)(2,null,$):(0,P.localize)(3,null,$):l?(0,P.localize)(4,null,$):(0,P.localize)(5,null,$):$===1?l?(0,P.localize)(6,null,$):(0,P.localize)(7,null,$):l?(0,P.localize)(8,null,$):(0,P.localize)(9,null,$)):w<s?($=Math.floor(w/R),b?$===1?l?(0,P.localize)(10,null,$):(0,P.localize)(11,null,$):l?(0,P.localize)(12,null,$):(0,P.localize)(13,null,$):$===1?l?(0,P.localize)(14,null,$):(0,P.localize)(15,null,$):l?(0,P.localize)(16,null,$):(0,P.localize)(17,null,$)):w<j?($=Math.floor(w/s),b?$===1?l?(0,P.localize)(18,null,$):(0,P.localize)(19,null,$):l?(0,P.localize)(20,null,$):(0,P.localize)(21,null,$):$===1?l?(0,P.localize)(22,null,$):(0,P.localize)(23,null,$):l?(0,P.localize)(24,null,$):(0,P.localize)(25,null,$)):w<A?($=Math.floor(w/j),b?$===1?(0,P.localize)(26,null,$):(0,P.localize)(27,null,$):$===1?(0,P.localize)(28,null,$):(0,P.localize)(29,null,$)):w<E?($=Math.floor(w/A),b?$===1?l?(0,P.localize)(30,null,$):(0,P.localize)(31,null,$):l?(0,P.localize)(32,null,$):(0,P.localize)(33,null,$):$===1?l?(0,P.localize)(34,null,$):(0,P.localize)(35,null,$):l?(0,P.localize)(36,null,$):(0,P.localize)(37,null,$)):w<f?($=Math.floor(w/E),b?$===1?l?(0,P.localize)(38,null,$):(0,P.localize)(39,null,$):l?(0,P.localize)(40,null,$):(0,P.localize)(41,null,$):$===1?l?(0,P.localize)(42,null,$):(0,P.localize)(43,null,$):l?(0,P.localize)(44,null,$):(0,P.localize)(45,null,$)):($=Math.floor(w/f),b?$===1?l?(0,P.localize)(46,null,$):(0,P.localize)(47,null,$):l?(0,P.localize)(48,null,$):(0,P.localize)(49,null,$):$===1?l?(0,P.localize)(50,null,$):(0,P.localize)(51,null,$):l?(0,P.localize)(52,null,$):(0,P.localize)(53,null,$))}e.$sm=h;function y(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$tm=y}),define(re[150],oe([11,10]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(re[51],oe([0,1,23,12,150]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.$Oi=e.$Ni=void 0;function j(v,b){return b&&(v.stack||v.stacktrace)?s.localize(0,null,E(v),A(v.stack)||A(v.stacktrace)):E(v)}function A(v){return Array.isArray(v)?v.join(`
`):v}function E(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?s.localize(1,null,v.message):v.message||s.localize(2,null)}function f(v=null,b=!1){if(!v)return s.localize(3,null);if(Array.isArray(v)){const l=P.$Hb(v),p=f(l[0],b);return l.length>1?s.localize(4,null,p,l.length):p}if(R.$Ff(v))return v;if(v.detail){const l=v.detail;if(l.error)return j(l.error,b);if(l.exception)return j(l.exception,b)}return v.stack?j(v,b):v.message?v.message:s.localize(5,null)}e.$Ni=f;function h(v){const b=v;return b instanceof Error&&Array.isArray(b.actions)}e.$Oi=h;function y(v,b){let l;return typeof v=="string"?l=new Error(v):l=v,l.actions=b,l}e.$Pi=y}),define(re[151],oe([11,10]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(re[152],oe([0,1,151]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=void 0;function R(s){switch(s){case 1:return(0,P.localize)(0,null);case 2:return(0,P.localize)(1,null);case 3:return(0,P.localize)(2,null);case 4:return(0,P.localize)(3,null);case 5:return(0,P.localize)(4,null);case 6:return(0,P.localize)(5,null);case 7:return(0,P.localize)(6,null);case 8:return(0,P.localize)(7,null);case 9:return(0,P.localize)(8,null);default:return""}}e.$Lp=R}),define(re[153],oe([11,10]),function(J,e){return J.create("vs/base/common/platform",e)}),define(re[4],oe([0,1,153]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let R=!1,s=!1,j=!1,A=!1,E=!1,f=!1,h=!1,y=!1,v=!1,b=!1,l,p=e.$g,w=e.$g,$,g;const u=globalThis;let c;typeof u.vscode<"u"&&typeof u.vscode.process<"u"?c=u.vscode.process:typeof process<"u"&&(c=process);const S=typeof c?.versions?.electron=="string",d=S&&c?.type==="renderer";if(typeof c=="object"){R=c.platform==="win32",s=c.platform==="darwin",j=c.platform==="linux",A=j&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,h=S,v=!!c.env.CI||!!c.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=e.$g,p=e.$g;const k=c.env.VSCODE_NLS_CONFIG;if(k)try{const C=JSON.parse(k),M=C.availableLanguages["*"];l=C.locale,w=C.osLocale,p=M||e.$g,$=C._translationsConfigFile}catch{}E=!0}else typeof navigator=="object"&&!d?(g=navigator.userAgent,R=g.indexOf("Windows")>=0,s=g.indexOf("Macintosh")>=0,y=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,j=g.indexOf("Linux")>=0,b=g?.indexOf("Mobi")>=0,f=!0,l=P.getConfiguredDefaultLocale(P.localize(0,null))||e.$g,p=l,w=navigator.language):console.error("Unable to resolve platform.");var t;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(k){switch(k){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=o;let r=0;s?r=1:R?r=3:j&&(r=2),e.$i=R,e.$j=s,e.$k=j,e.$l=A,e.$m=E,e.$n=h,e.$o=f,e.$p=f&&typeof u.importScripts=="function",e.$q=e.$p?u.origin:void 0,e.$r=y,e.$s=b,e.$t=v,e.$u=r,e.$v=g,e.$w=p;var i;(function(k){function C(){return e.$w}k.value=C;function M(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}k.isDefaultVariant=M;function F(){return e.$w==="en"}k.isDefault=F})(i||(e.Language=i={})),e.$x=l,e.$y=w,e.$z=$,e.$A=typeof u.postMessage=="function"&&!u.importScripts,e.$B=(()=>{if(e.$A){const k=[];u.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let F=0,N=k.length;F<N;F++){const Z=k[F];if(Z.id===M.data.vscodeScheduleAsyncWork){k.splice(F,1),Z.callback();return}}});let C=0;return M=>{const F=++C;k.push({id:F,callback:M}),u.postMessage({vscodeScheduleAsyncWork:F},"*")}}return k=>setTimeout(k)})();var n;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=s||y?2:R?1:3;let a=!0,m=!1;function D(){if(!m){m=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,a=new Uint16Array(k.buffer)[0]===(2<<8)+1}return a}e.$D=D,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function I(k){return parseFloat(k)>=20}e.$J=I}),define(re[35],oe([0,1,4]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let R;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.process<"u"){const j=s.process;R={get platform(){return j.platform},get arch(){return j.arch},get env(){return j.env},cwd(){return j.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return P.$i?"win32":P.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.$dc=R.platform,e.$ec=R.arch}),define(re[9],oe([0,1,35]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const R=65,s=97,j=90,A=122,E=46,f=47,h=92,y=58,v=63;class b extends Error{constructor(o,r,i){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const a=o.indexOf(".")!==-1?"property":"argument";let m=`The "${o}" ${a} ${n} of type ${r}`;m+=`. Received type ${typeof i}`,super(m),this.code="ERR_INVALID_ARG_TYPE"}}function l(t,o){if(t===null||typeof t!="object")throw new b(o,"Object",t)}function p(t,o){if(typeof t!="string")throw new b(o,"string",t)}const w=P.$dc==="win32";function $(t){return t===f||t===h}function g(t){return t===f}function u(t){return t>=R&&t<=j||t>=s&&t<=A}function c(t,o,r,i){let n="",a=0,m=-1,D=0,I=0;for(let k=0;k<=t.length;++k){if(k<t.length)I=t.charCodeAt(k);else{if(i(I))break;I=f}if(i(I)){if(!(m===k-1||D===1))if(D===2){if(n.length<2||a!==2||n.charCodeAt(n.length-1)!==E||n.charCodeAt(n.length-2)!==E){if(n.length>2){const C=n.lastIndexOf(r);C===-1?(n="",a=0):(n=n.slice(0,C),a=n.length-1-n.lastIndexOf(r)),m=k,D=0;continue}else if(n.length!==0){n="",a=0,m=k,D=0;continue}}o&&(n+=n.length>0?`${r}..`:"..",a=2)}else n.length>0?n+=`${r}${t.slice(m+1,k)}`:n=t.slice(m+1,k),a=k-m-1;m=k,D=0}else I===E&&D!==-1?++D:D=-1}return n}function S(t,o){l(o,"pathObject");const r=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return r?r===o.root?`${r}${i}`:`${r}${t}${i}`:i}e.$fc={resolve(...t){let o="",r="",i=!1;for(let n=t.length-1;n>=-1;n--){let a;if(n>=0){if(a=t[n],p(a,"path"),a.length===0)continue}else o.length===0?a=P.cwd():(a=P.env[`=${o}`]||P.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==o.toLowerCase()&&a.charCodeAt(2)===h)&&(a=`${o}\\`));const m=a.length;let D=0,I="",k=!1;const C=a.charCodeAt(0);if(m===1)$(C)&&(D=1,k=!0);else if($(C))if(k=!0,$(a.charCodeAt(1))){let M=2,F=M;for(;M<m&&!$(a.charCodeAt(M));)M++;if(M<m&&M!==F){const N=a.slice(F,M);for(F=M;M<m&&$(a.charCodeAt(M));)M++;if(M<m&&M!==F){for(F=M;M<m&&!$(a.charCodeAt(M));)M++;(M===m||M!==F)&&(I=`\\\\${N}\\${a.slice(F,M)}`,D=M)}}}else D=1;else u(C)&&a.charCodeAt(1)===y&&(I=a.slice(0,2),D=2,m>2&&$(a.charCodeAt(2))&&(k=!0,D=3));if(I.length>0)if(o.length>0){if(I.toLowerCase()!==o.toLowerCase())continue}else o=I;if(i){if(o.length>0)break}else if(r=`${a.slice(D)}\\${r}`,i=k,k&&o.length>0)break}return r=c(r,!i,"\\",$),i?`${o}\\${r}`:`${o}${r}`||"."},normalize(t){p(t,"path");const o=t.length;if(o===0)return".";let r=0,i,n=!1;const a=t.charCodeAt(0);if(o===1)return g(a)?"\\":t;if($(a))if(n=!0,$(t.charCodeAt(1))){let D=2,I=D;for(;D<o&&!$(t.charCodeAt(D));)D++;if(D<o&&D!==I){const k=t.slice(I,D);for(I=D;D<o&&$(t.charCodeAt(D));)D++;if(D<o&&D!==I){for(I=D;D<o&&!$(t.charCodeAt(D));)D++;if(D===o)return`\\\\${k}\\${t.slice(I)}\\`;D!==I&&(i=`\\\\${k}\\${t.slice(I,D)}`,r=D)}}}else r=1;else u(a)&&t.charCodeAt(1)===y&&(i=t.slice(0,2),r=2,o>2&&$(t.charCodeAt(2))&&(n=!0,r=3));let m=r<o?c(t.slice(r),!n,"\\",$):"";return m.length===0&&!n&&(m="."),m.length>0&&$(t.charCodeAt(o-1))&&(m+="\\"),i===void 0?n?`\\${m}`:m:n?`${i}\\${m}`:`${i}${m}`},isAbsolute(t){p(t,"path");const o=t.length;if(o===0)return!1;const r=t.charCodeAt(0);return $(r)||o>2&&u(r)&&t.charCodeAt(1)===y&&$(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,r;for(let a=0;a<t.length;++a){const m=t[a];p(m,"path"),m.length>0&&(o===void 0?o=r=m:o+=`\\${m}`)}if(o===void 0)return".";let i=!0,n=0;if(typeof r=="string"&&$(r.charCodeAt(0))){++n;const a=r.length;a>1&&$(r.charCodeAt(1))&&(++n,a>2&&($(r.charCodeAt(2))?++n:i=!1))}if(i){for(;n<o.length&&$(o.charCodeAt(n));)n++;n>=2&&(o=`\\${o.slice(n)}`)}return e.$fc.normalize(o)},relative(t,o){if(p(t,"from"),p(o,"to"),t===o)return"";const r=e.$fc.resolve(t),i=e.$fc.resolve(o);if(r===i||(t=r.toLowerCase(),o=i.toLowerCase(),t===o))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===h;)n++;let a=t.length;for(;a-1>n&&t.charCodeAt(a-1)===h;)a--;const m=a-n;let D=0;for(;D<o.length&&o.charCodeAt(D)===h;)D++;let I=o.length;for(;I-1>D&&o.charCodeAt(I-1)===h;)I--;const k=I-D,C=m<k?m:k;let M=-1,F=0;for(;F<C;F++){const Z=t.charCodeAt(n+F);if(Z!==o.charCodeAt(D+F))break;Z===h&&(M=F)}if(F!==C){if(M===-1)return i}else{if(k>C){if(o.charCodeAt(D+F)===h)return i.slice(D+F+1);if(F===2)return i.slice(D+F)}m>C&&(t.charCodeAt(n+F)===h?M=F:F===2&&(M=3)),M===-1&&(M=0)}let N="";for(F=n+M+1;F<=a;++F)(F===a||t.charCodeAt(F)===h)&&(N+=N.length===0?"..":"\\..");return D+=M,N.length>0?`${N}${i.slice(D,I)}`:(i.charCodeAt(D)===h&&++D,i.slice(D,I))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$fc.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===h){if(o.charCodeAt(1)===h){const r=o.charCodeAt(2);if(r!==v&&r!==E)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(u(o.charCodeAt(0))&&o.charCodeAt(1)===y&&o.charCodeAt(2)===h)return`\\\\?\\${o}`;return t},dirname(t){p(t,"path");const o=t.length;if(o===0)return".";let r=-1,i=0;const n=t.charCodeAt(0);if(o===1)return $(n)?t:".";if($(n)){if(r=i=1,$(t.charCodeAt(1))){let D=2,I=D;for(;D<o&&!$(t.charCodeAt(D));)D++;if(D<o&&D!==I){for(I=D;D<o&&$(t.charCodeAt(D));)D++;if(D<o&&D!==I){for(I=D;D<o&&!$(t.charCodeAt(D));)D++;if(D===o)return t;D!==I&&(r=i=D+1)}}}}else u(n)&&t.charCodeAt(1)===y&&(r=o>2&&$(t.charCodeAt(2))?3:2,i=r);let a=-1,m=!0;for(let D=o-1;D>=i;--D)if($(t.charCodeAt(D))){if(!m){a=D;break}}else m=!1;if(a===-1){if(r===-1)return".";a=r}return t.slice(0,a)},basename(t,o){o!==void 0&&p(o,"ext"),p(t,"path");let r=0,i=-1,n=!0,a;if(t.length>=2&&u(t.charCodeAt(0))&&t.charCodeAt(1)===y&&(r=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let m=o.length-1,D=-1;for(a=t.length-1;a>=r;--a){const I=t.charCodeAt(a);if($(I)){if(!n){r=a+1;break}}else D===-1&&(n=!1,D=a+1),m>=0&&(I===o.charCodeAt(m)?--m===-1&&(i=a):(m=-1,i=D))}return r===i?i=D:i===-1&&(i=t.length),t.slice(r,i)}for(a=t.length-1;a>=r;--a)if($(t.charCodeAt(a))){if(!n){r=a+1;break}}else i===-1&&(n=!1,i=a+1);return i===-1?"":t.slice(r,i)},extname(t){p(t,"path");let o=0,r=-1,i=0,n=-1,a=!0,m=0;t.length>=2&&t.charCodeAt(1)===y&&u(t.charCodeAt(0))&&(o=i=2);for(let D=t.length-1;D>=o;--D){const I=t.charCodeAt(D);if($(I)){if(!a){i=D+1;break}continue}n===-1&&(a=!1,n=D+1),I===E?r===-1?r=D:m!==1&&(m=1):r!==-1&&(m=-1)}return r===-1||n===-1||m===0||m===1&&r===n-1&&r===i+1?"":t.slice(r,n)},format:S.bind(null,"\\"),parse(t){p(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.length;let i=0,n=t.charCodeAt(0);if(r===1)return $(n)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if($(n)){if(i=1,$(t.charCodeAt(1))){let M=2,F=M;for(;M<r&&!$(t.charCodeAt(M));)M++;if(M<r&&M!==F){for(F=M;M<r&&$(t.charCodeAt(M));)M++;if(M<r&&M!==F){for(F=M;M<r&&!$(t.charCodeAt(M));)M++;M===r?i=M:M!==F&&(i=M+1)}}}}else if(u(n)&&t.charCodeAt(1)===y){if(r<=2)return o.root=o.dir=t,o;if(i=2,$(t.charCodeAt(2))){if(r===3)return o.root=o.dir=t,o;i=3}}i>0&&(o.root=t.slice(0,i));let a=-1,m=i,D=-1,I=!0,k=t.length-1,C=0;for(;k>=i;--k){if(n=t.charCodeAt(k),$(n)){if(!I){m=k+1;break}continue}D===-1&&(I=!1,D=k+1),n===E?a===-1?a=k:C!==1&&(C=1):a!==-1&&(C=-1)}return D!==-1&&(a===-1||C===0||C===1&&a===D-1&&a===m+1?o.base=o.name=t.slice(m,D):(o.name=t.slice(m,a),o.base=t.slice(m,D),o.ext=t.slice(a,D))),m>0&&m!==i?o.dir=t.slice(0,m-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const d=(()=>{if(w){const t=/\\/g;return()=>{const o=P.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>P.cwd()})();e.$gc={resolve(...t){let o="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const n=i>=0?t[i]:d();p(n,"path"),n.length!==0&&(o=`${n}/${o}`,r=n.charCodeAt(0)===f)}return o=c(o,!r,"/",g),r?`/${o}`:o.length>0?o:"."},normalize(t){if(p(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===f,r=t.charCodeAt(t.length-1)===f;return t=c(t,!o,"/",g),t.length===0?o?"/":r?"./":".":(r&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return p(t,"path"),t.length>0&&t.charCodeAt(0)===f},join(...t){if(t.length===0)return".";let o;for(let r=0;r<t.length;++r){const i=t[r];p(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.$gc.normalize(o)},relative(t,o){if(p(t,"from"),p(o,"to"),t===o||(t=e.$gc.resolve(t),o=e.$gc.resolve(o),t===o))return"";const r=1,i=t.length,n=i-r,a=1,m=o.length-a,D=n<m?n:m;let I=-1,k=0;for(;k<D;k++){const M=t.charCodeAt(r+k);if(M!==o.charCodeAt(a+k))break;M===f&&(I=k)}if(k===D)if(m>D){if(o.charCodeAt(a+k)===f)return o.slice(a+k+1);if(k===0)return o.slice(a+k)}else n>D&&(t.charCodeAt(r+k)===f?I=k:k===0&&(I=0));let C="";for(k=r+I+1;k<=i;++k)(k===i||t.charCodeAt(k)===f)&&(C+=C.length===0?"..":"/..");return`${C}${o.slice(a+I)}`},toNamespacedPath(t){return t},dirname(t){if(p(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===f;let r=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===f){if(!i){r=n;break}}else i=!1;return r===-1?o?"/":".":o&&r===1?"//":t.slice(0,r)},basename(t,o){o!==void 0&&p(o,"ext"),p(t,"path");let r=0,i=-1,n=!0,a;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let m=o.length-1,D=-1;for(a=t.length-1;a>=0;--a){const I=t.charCodeAt(a);if(I===f){if(!n){r=a+1;break}}else D===-1&&(n=!1,D=a+1),m>=0&&(I===o.charCodeAt(m)?--m===-1&&(i=a):(m=-1,i=D))}return r===i?i=D:i===-1&&(i=t.length),t.slice(r,i)}for(a=t.length-1;a>=0;--a)if(t.charCodeAt(a)===f){if(!n){r=a+1;break}}else i===-1&&(n=!1,i=a+1);return i===-1?"":t.slice(r,i)},extname(t){p(t,"path");let o=-1,r=0,i=-1,n=!0,a=0;for(let m=t.length-1;m>=0;--m){const D=t.charCodeAt(m);if(D===f){if(!n){r=m+1;break}continue}i===-1&&(n=!1,i=m+1),D===E?o===-1?o=m:a!==1&&(a=1):o!==-1&&(a=-1)}return o===-1||i===-1||a===0||a===1&&o===i-1&&o===r+1?"":t.slice(o,i)},format:S.bind(null,"/"),parse(t){p(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.charCodeAt(0)===f;let i;r?(o.root="/",i=1):i=0;let n=-1,a=0,m=-1,D=!0,I=t.length-1,k=0;for(;I>=i;--I){const C=t.charCodeAt(I);if(C===f){if(!D){a=I+1;break}continue}m===-1&&(D=!1,m=I+1),C===E?n===-1?n=I:k!==1&&(k=1):n!==-1&&(k=-1)}if(m!==-1){const C=a===0&&r?1:a;n===-1||k===0||k===1&&n===m-1&&n===a+1?o.base=o.name=t.slice(C,m):(o.name=t.slice(C,n),o.base=t.slice(C,m),o.ext=t.slice(n,m))}return a>0?o.dir=t.slice(0,a-1):r&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=w?e.$fc.normalize:e.$gc.normalize,e.$ic=w?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=w?e.$fc.join:e.$gc.join,e.$kc=w?e.$fc.resolve:e.$gc.resolve,e.$lc=w?e.$fc.relative:e.$gc.relative,e.$mc=w?e.$fc.dirname:e.$gc.dirname,e.$nc=w?e.$fc.basename:e.$gc.basename,e.$oc=w?e.$fc.extname:e.$gc.extname,e.$pc=w?e.$fc.format:e.$gc.format,e.$qc=w?e.$fc.parse:e.$gc.parse,e.$rc=w?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=w?e.$fc.sep:e.$gc.sep,e.$tc=w?e.$fc.delimiter:e.$gc.delimiter}),define(re[33],oe([0,1,9,4,25,12]),function(J,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=void 0;function A(a){return a===47||a===92}e.$Xf=A;function E(a){return a.replace(/[\\/]/g,P.$gc.sep)}e.$Yf=E;function f(a){return a.indexOf("/")===-1&&(a=E(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.$Zf=f;function h(a,m=P.$gc.sep){if(!a)return"";const D=a.length,I=a.charCodeAt(0);if(A(I)){if(A(a.charCodeAt(1))&&!A(a.charCodeAt(2))){let C=3;const M=C;for(;C<D&&!A(a.charCodeAt(C));C++);if(M!==C&&!A(a.charCodeAt(C+1))){for(C+=1;C<D;C++)if(A(a.charCodeAt(C)))return a.slice(0,C+1).replace(/[\\/]/g,m)}}return m}else if(g(I)&&a.charCodeAt(1)===58)return A(a.charCodeAt(2))?a.slice(0,2)+m:a.slice(0,2);let k=a.indexOf("://");if(k!==-1){for(k+=3;k<D;k++)if(A(a.charCodeAt(k)))return a.slice(0,k+1)}return""}e.$1f=h;function y(a){if(!R.$i||!a||a.length<5)return!1;let m=a.charCodeAt(0);if(m!==92||(m=a.charCodeAt(1),m!==92))return!1;let D=2;const I=D;for(;D<a.length&&(m=a.charCodeAt(D),m!==92);D++);return!(I===D||(m=a.charCodeAt(D+1),isNaN(m)||m===92))}e.$2f=y;const v=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(a,m=R.$i){const D=m?v:b;return!(!a||a.length===0||/^\s+$/.test(a)||(D.lastIndex=0,D.test(a))||m&&l.test(a)||a==="."||a===".."||m&&a[a.length-1]==="."||m&&a.length!==a.trim().length||a.length>255)}e.$3f=p;function w(a,m,D){const I=a===m;return!D||I?I:!a||!m?!1:(0,s.$9e)(a,m)}e.$4f=w;function $(a,m,D,I=P.sep){if(a===m)return!0;if(!a||!m||m.length>a.length)return!1;if(D){if(!(0,s.$0e)(a,m))return!1;if(m.length===a.length)return!0;let C=m.length;return m.charAt(m.length-1)===I&&C--,a.charAt(C)===I}return m.charAt(m.length-1)!==I&&(m+=I),a.indexOf(m)===0}e.$5f=$;function g(a){return a>=65&&a<=90||a>=97&&a<=122}e.$6f=g;function u(a,m){return R.$i&&a.endsWith(":")&&(a+=P.sep),(0,P.$ic)(a)||(a=(0,P.$jc)(m,a)),a=(0,P.$hc)(a),R.$i?(a=(0,s.$Re)(a,P.sep),a.endsWith(":")&&(a+=P.sep)):(a=(0,s.$Re)(a,P.sep),a||(a=P.sep)),a}e.$7f=u;function c(a){const m=(0,P.$hc)(a);return R.$i?a.length>3?!1:S(m)&&(a.length===2||m.charCodeAt(2)===92):m===P.$gc.sep}e.$8f=c;function S(a,m=R.$i){return m?g(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.$9f=S;function d(a,m=R.$i){return S(a,m)?a[0]:void 0}e.$0f=d;function t(a,m,D){return m.length>a.length?-1:a===m?0:(D&&(a=a.toLowerCase(),m=m.toLowerCase()),a.indexOf(m))}e.$$f=t;function o(a){const m=a.split(":");let D,I,k;for(const C of m){const M=Number(C);(0,j.$Jf)(M)?I===void 0?I=M:k===void 0&&(k=M):D=D?[D,C].join(":"):C}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:I!==void 0?I:void 0,column:k!==void 0?k:I!==void 0?1:void 0}}e.$_f=o;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(a,m,D=8){let I="";for(let C=0;C<D;C++){let M;C===0&&R.$i&&!m&&(D===3||D===4)?M=i:M=r,I+=M.charAt(Math.floor(Math.random()*M.length))}let k;return m?k=`${m}-${I}`:k=I,a?(0,P.$jc)(a,k):k}e.$ag=n}),define(re[76],oe([0,1,4]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.TerminateResponseCode=e.Source=void 0;var R;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(R||(e.Source=R={}));var s;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function j(E,...f){const h=f.reduce((b,l)=>(b[l]=!0,b),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(b=>!h[b]).forEach(b=>{for(let l=0;l<y.length;l++)if(b.search(y[l])!==-1){delete E[b];break}})}e.$Ol=j;function A(E){E&&(delete E.DEBUG,P.$j&&delete E.DYLD_LIBRARY_PATH,P.$k&&delete E.LD_PRELOAD)}e.$Pl=A}),define(re[7],oe([0,1,9,4]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,j=/^\//,A=/^\/\//;function E(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!s.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!j.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(i,n){return!i&&!n?"file":i}function h(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==v&&(n=v+n):n=v;break}return n}const y="",v="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(n){return n instanceof l?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,a,m,D,I,k=!1){typeof n=="object"?(this.scheme=n.scheme||y,this.authority=n.authority||y,this.path=n.path||y,this.query=n.query||y,this.fragment=n.fragment||y):(this.scheme=f(n,k),this.authority=a||y,this.path=h(this.scheme,m||y),this.query=D||y,this.fragment=I||y,E(this,k))}get fsPath(){return S(this,!1)}with(n){if(!n)return this;let{scheme:a,authority:m,path:D,query:I,fragment:k}=n;return a===void 0?a=this.scheme:a===null&&(a=y),m===void 0?m=this.authority:m===null&&(m=y),D===void 0?D=this.path:D===null&&(D=y),I===void 0?I=this.query:I===null&&(I=y),k===void 0?k=this.fragment:k===null&&(k=y),a===this.scheme&&m===this.authority&&D===this.path&&I===this.query&&k===this.fragment?this:new $(a,m,D,I,k)}static parse(n,a=!1){const m=b.exec(n);return m?new $(m[2]||y,r(m[4]||y),r(m[5]||y),r(m[7]||y),r(m[9]||y),a):new $(y,y,y,y,y)}static file(n){let a=y;if(R.$i&&(n=n.replace(/\\/g,v)),n[0]===v&&n[1]===v){const m=n.indexOf(v,2);m===-1?(a=n.substring(2),n=v):(a=n.substring(2,m),n=n.substring(m)||v)}return new $("file",a,n,y,y)}static from(n,a){return new $(n.scheme,n.authority,n.path,n.query,n.fragment,a)}static joinPath(n,...a){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return R.$i&&n.scheme==="file"?m=l.file(P.$fc.join(S(n,!0),...a)).path:m=P.$gc.join(n.path,...a),n.with({path:m})}toString(n=!1){return d(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof l)return n;{const a=new $(n);return a._formatted=n.external??null,a._fsPath=n._sep===w?n.fsPath??null:null,a}}else return n}}e.URI=l;function p(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$vc=p;const w=R.$i?1:void 0;class $ extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=S(this,!1)),this._fsPath}toString(n=!1){return n?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=w),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(i,n,a){let m,D=-1;for(let I=0;I<i.length;I++){const k=i.charCodeAt(I);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||n&&k===47||a&&k===91||a&&k===93||a&&k===58)D!==-1&&(m+=encodeURIComponent(i.substring(D,I)),D=-1),m!==void 0&&(m+=i.charAt(I));else{m===void 0&&(m=i.substr(0,I));const C=g[k];C!==void 0?(D!==-1&&(m+=encodeURIComponent(i.substring(D,I)),D=-1),m+=C):D===-1&&(D=I)}}return D!==-1&&(m+=encodeURIComponent(i.substring(D))),m!==void 0?m:i}function c(i){let n;for(let a=0;a<i.length;a++){const m=i.charCodeAt(a);m===35||m===63?(n===void 0&&(n=i.substr(0,a)),n+=g[m]):n!==void 0&&(n+=i[a])}return n!==void 0?n:i}function S(i,n){let a;return i.authority&&i.path.length>1&&i.scheme==="file"?a=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?a=i.path.substr(1):a=i.path[1].toLowerCase()+i.path.substr(2):a=i.path,R.$i&&(a=a.replace(/\//g,"\\")),a}e.$wc=S;function d(i,n){const a=n?c:u;let m="",{scheme:D,authority:I,path:k,query:C,fragment:M}=i;if(D&&(m+=D,m+=":"),(I||D==="file")&&(m+=v,m+=v),I){let F=I.indexOf("@");if(F!==-1){const N=I.substr(0,F);I=I.substr(F+1),F=N.lastIndexOf(":"),F===-1?m+=a(N,!1,!1):(m+=a(N.substr(0,F),!1,!1),m+=":",m+=a(N.substr(F+1),!1,!0)),m+="@"}I=I.toLowerCase(),F=I.lastIndexOf(":"),F===-1?m+=a(I,!1,!0):(m+=a(I.substr(0,F),!1,!0),m+=I.substr(F))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const F=k.charCodeAt(1);F>=65&&F<=90&&(k=`/${String.fromCharCode(F+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const F=k.charCodeAt(0);F>=65&&F<=90&&(k=`${String.fromCharCode(F+32)}:${k.substr(2)}`)}m+=a(k,!0,!1)}return C&&(m+="?",m+=a(C,!1,!1)),M&&(m+="#",m+=n?M:u(M,!1,!1)),m}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(o)?i.replace(o,n=>t(n)):i}}),define(re[154],oe([0,1,7]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$cq=e.$bq=e.$aq=void 0;function R(h){const y=h;return y&&typeof y.type=="string"&&typeof y.severity=="string"}e.$aq=R;function s(h){const y=[];let v;try{const b=JSON.parse(h.arguments),l=b[b.length-1];l&&l.__$stack&&(b.pop(),v=l.__$stack),y.push(...b)}catch{y.push("Unable to log remote console arguments",h.arguments)}return{args:y,stack:v}}e.$bq=s;function j(h){if(typeof h!="string")return j(s(h).stack);const y=h;if(y){const v=A(y),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(b&&b.length===4)return{uri:P.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.$cq=j;function A(h){if(!h)return h;const y=h.indexOf(`
`);return y===-1?h:h.substring(0,y)}function E(h,y){const{args:v,stack:b}=s(h),l=typeof v[0]=="string"&&v.length===1;let p=A(b);p&&(p=`(${p.trim()})`);let w=[];if(typeof v[0]=="string"?p&&l?w=[`%c[${y}] %c${v[0]} %c${p}`,f("blue"),f(""),f("grey")]:w=[`%c[${y}] %c${v[0]}`,f("blue"),f(""),...v.slice(1)]:w=[`%c[${y}]%`,f("blue"),...v],p&&!l&&w.push(p),typeof console[h.severity]!="function")throw new Error("Unknown console method");console[h.severity].apply(console,w)}e.log=E;function f(h){return`color: ${h}`}}),define(re[77],oe([0,1,18,7]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.$yh=e.$xh=void 0;function s(f){return JSON.stringify(f,A)}e.$xh=s;function j(f){let h=JSON.parse(f);return h=E(h),h}e.$yh=j;function A(f,h){return h instanceof RegExp?{$mid:2,source:h.source,flags:h.flags}:h}function E(f,h=0){if(!f||h>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return R.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof P.$ge||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let y=0;y<f.length;++y)f[y]=E(f[y],h+1);else for(const y in f)Object.hasOwnProperty.call(f,y)&&(f[y]=E(f[y],h+1))}return f}e.$zh=E}),define(re[13],oe([0,1,14,4,25,7]),function(J,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.Schemas=void 0;var A;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeManagedRemoteResource="vscode-managed-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.vscodeChatSesssion="vscode-chat-editor",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={}));function E(b,l){return j.URI.isUri(b)?(0,s.$9e)(b.scheme,l):(0,s.$0e)(b,l+":")}e.$bg=E;function f(b,...l){return l.some(p=>E(b,p))}e.$cg=f,e.$dg="vscode-tkn",e.$eg="tkn";class h{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(l){this.d=l}setDelegate(l){this.e=l}setServerRootPath(l){this.f=`${l}/${A.vscodeRemoteResource}`}set(l,p,w){this.a[l]=p,this.b[l]=w}setConnectionToken(l,p){this.c[l]=p}getPreferredWebSchema(){return this.d}rewrite(l){if(this.e)try{return this.e(l)}catch(c){return P.$1(c),l}const p=l.authority;let w=this.a[p];w&&w.indexOf(":")!==-1&&w.indexOf("[")===-1&&(w=`[${w}]`);const $=this.b[p],g=this.c[p];let u=`path=${encodeURIComponent(l.path)}`;return typeof g=="string"&&(u+=`&${e.$eg}=${encodeURIComponent(g)}`),j.URI.from({scheme:R.$o?this.d:A.vscodeRemoteResource,authority:`${w}:${$}`,path:this.f,query:u})}}e.$fg=new h,e.$gg="vs/../../extensions",e.$hg="vs/../../node_modules",e.$ig="vs/../../node_modules.asar",e.$jg="vs/../../node_modules.asar.unpacked",e.$kg="vscode-app";class y{static{this.a=e.$kg}asBrowserUri(l){const p=this.b(l,J);return this.uriToBrowserUri(p)}uriToBrowserUri(l){return l.scheme===A.vscodeRemote?e.$fg.rewrite(l):l.scheme===A.file&&(R.$m||R.$q===`${A.vscodeFileResource}://${y.a}`)?l.with({scheme:A.vscodeFileResource,authority:l.authority||y.a,query:null,fragment:null}):l}asFileUri(l){const p=this.b(l,J);return this.uriToFileUri(p)}uriToFileUri(l){return l.scheme===A.vscodeFileResource?l.with({scheme:A.file,authority:l.authority!==y.a?l.authority:null,query:null,fragment:null}):l}b(l,p){return j.URI.isUri(l)?l:j.URI.parse(p.toUrl(l))}}e.$lg=new y;var v;(function(b){const l=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);b.CoopAndCoep=Object.freeze(l.get("3"));const p="vscode-coi";function w(g){let u;typeof g=="string"?u=new URL(g).searchParams:g instanceof URL?u=g.searchParams:j.URI.isUri(g)&&(u=new URL(g.toString(!0)).searchParams);const c=u?.get(p);if(c)return l.get(c)}b.getHeadersFromQuery=w;function $(g,u,c){if(!globalThis.crossOriginIsolated)return;const S=u&&c?"3":c?"2":"1";g instanceof URLSearchParams?g.set(p,S):g[p]=S}b.addSearchParam=$})(v||(e.COI=v={}))}),define(re[19],oe([0,1,33,13,9,4,25,7]),function(J,e,P,R,s,j,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Og=e.DataUri=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=void 0;function f(l){return(0,E.$wc)(l,!0)}e.$sg=f;class h{constructor(p){this.a=p}compare(p,w,$=!1){return p===w?0:(0,A.$2e)(this.getComparisonKey(p,$),this.getComparisonKey(w,$))}isEqual(p,w,$=!1){return p===w?!0:!p||!w?!1:this.getComparisonKey(p,$)===this.getComparisonKey(w,$)}getComparisonKey(p,w=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,w,$=!1){if(p.scheme===w.scheme){if(p.scheme===R.Schemas.file)return P.$5f(f(p),f(w),this.a(p))&&p.query===w.query&&($||p.fragment===w.fragment);if((0,e.$Jg)(p.authority,w.authority))return P.$5f(p.path,w.path,this.a(p),"/")&&p.query===w.query&&($||p.fragment===w.fragment)}return!1}joinPath(p,...w){return E.URI.joinPath(p,...w)}basenameOrAuthority(p){return(0,e.$Bg)(p)||p.authority}basename(p){return s.$gc.basename(p.path)}extname(p){return s.$gc.extname(p.path)}dirname(p){if(p.path.length===0)return p;let w;return p.scheme===R.Schemas.file?w=E.URI.file(s.$mc(f(p))).path:(w=s.$gc.dirname(p.path),p.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),w="/")),p.with({path:w})}normalizePath(p){if(!p.path.length)return p;let w;return p.scheme===R.Schemas.file?w=E.URI.file(s.$hc(f(p))).path:w=s.$gc.normalize(p.path),p.with({path:w})}relativePath(p,w){if(p.scheme!==w.scheme||!(0,e.$Jg)(p.authority,w.authority))return;if(p.scheme===R.Schemas.file){const u=s.$lc(f(p),f(w));return j.$i?P.$Yf(u):u}let $=p.path||"/";const g=w.path||"/";if(this.a(p)){let u=0;for(const c=Math.min($.length,g.length);u<c&&!($.charCodeAt(u)!==g.charCodeAt(u)&&$.charAt(u).toLowerCase()!==g.charAt(u).toLowerCase());u++);$=g.substr(0,u)+$.substr(u)}return s.$gc.relative($,g)}resolvePath(p,w){if(p.scheme===R.Schemas.file){const $=E.URI.file(s.$kc(f(p),w));return p.with({authority:$.authority,path:$.path})}return w=P.$Zf(w),p.with({path:s.$gc.resolve(p.path,w)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,w){return p===w||p!==void 0&&w!==void 0&&(0,A.$9e)(p,w)}hasTrailingPathSeparator(p,w=s.sep){if(p.scheme===R.Schemas.file){const $=f(p);return $.length>P.$1f($).length&&$[$.length-1]===w}else{const $=p.path;return $.length>1&&$.charCodeAt($.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,w=s.sep){return(0,e.$Kg)(p,w)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,w=s.sep){let $=!1;if(p.scheme===R.Schemas.file){const g=f(p);$=g!==void 0&&g.length===P.$1f(g).length&&g[g.length-1]===w}else{w="/";const g=p.path;$=g.length===1&&g.charCodeAt(g.length-1)===47}return!$&&!(0,e.$Kg)(p,w)?p.with({path:p.path+"/"}):p}}e.$tg=h,e.$ug=new h(()=>!1),e.$vg=new h(l=>l.scheme===R.Schemas.file?!j.$k:!0),e.$wg=new h(l=>!0),e.$xg=e.$ug.isEqual.bind(e.$ug),e.$yg=e.$ug.isEqualOrParent.bind(e.$ug),e.$zg=e.$ug.getComparisonKey.bind(e.$ug),e.$Ag=e.$ug.basenameOrAuthority.bind(e.$ug),e.$Bg=e.$ug.basename.bind(e.$ug),e.$Cg=e.$ug.extname.bind(e.$ug),e.$Dg=e.$ug.dirname.bind(e.$ug),e.$Eg=e.$ug.joinPath.bind(e.$ug),e.$Fg=e.$ug.normalizePath.bind(e.$ug),e.$Gg=e.$ug.relativePath.bind(e.$ug),e.$Hg=e.$ug.resolvePath.bind(e.$ug),e.$Ig=e.$ug.isAbsolutePath.bind(e.$ug),e.$Jg=e.$ug.isEqualAuthority.bind(e.$ug),e.$Kg=e.$ug.hasTrailingPathSeparator.bind(e.$ug),e.$Lg=e.$ug.removeTrailingPathSeparator.bind(e.$ug),e.$Mg=e.$ug.addTrailingPathSeparator.bind(e.$ug);function y(l,p){const w=[];for(let $=0;$<l.length;$++){const g=p(l[$]);l.some((u,c)=>c===$?!1:(0,e.$yg)(g,p(u)))||w.push(l[$])}return w}e.$Ng=y;var v;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function p(w){const $=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(c=>{const[S,d]=c.split(":");S&&d&&$.set(S,d)});const u=w.path.substring(0,w.path.indexOf(";"));return u&&$.set(l.META_DATA_MIME,u),$}l.parseMetaData=p})(v||(e.DataUri=v={}));function b(l,p,w){if(p){let $=l.path;return $&&$[0]!==s.$gc.sep&&($=s.$gc.sep+$),l.with({scheme:w,authority:p,path:$})}return l.with({scheme:w})}e.$Og=b}),define(re[8],oe([0,1,22,14,3,2,19,4,143,62]),function(J,e,P,R,s,j,A,E,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.Promises=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=void 0;function y(W){return!!W&&typeof W.then=="function"}e.$Pg=y;function v(W){const B=new P.$3d,_=W(B.token),ae=new Promise((se,$e)=>{const me=B.token.onCancellationRequested(()=>{me.dispose(),B.dispose(),$e(new R.$5)});Promise.resolve(_).then(ye=>{me.dispose(),B.dispose(),se(ye)},ye=>{me.dispose(),B.dispose(),$e(ye)})});return new class{cancel(){B.cancel()}then(se,$e){return ae.then(se,$e)}catch(se){return this.then(void 0,se)}finally(se){return ae.finally(se)}}}e.$Qg=v;function b(W,B,_){return new Promise((ae,se)=>{const $e=B.onCancellationRequested(()=>{$e.dispose(),ae(_)});W.then(ae,se).finally(()=>$e.dispose())})}e.$Rg=b;function l(W,B){return new Promise((_,ae)=>{const se=B.onCancellationRequested(()=>{se.dispose(),ae(new R.$5)});W.then(_,ae).finally(()=>se.dispose())})}e.$Sg=l;async function p(W){let B=-1;const _=W.map((ae,se)=>ae.then($e=>(B=se,$e)));try{return await Promise.race(_)}finally{W.forEach((ae,se)=>{se!==B&&ae.cancel()})}}e.$Tg=p;function w(W,B,_){let ae;const se=setTimeout(()=>{ae?.(void 0),_?.()},B);return Promise.race([W.finally(()=>clearTimeout(se)),new Promise($e=>ae=$e)])}e.$Ug=w;function $(W){return new Promise((B,_)=>{const ae=W();y(ae)?ae.then(B,_):B(ae)})}e.$Vg=$;class g{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(B){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=B,!this.b){const _=()=>{if(this.b=null,this.f)return;const ae=this.queue(this.d);return this.d=null,ae};this.b=new Promise(ae=>{this.a.then(_,_).then(ae)})}return new Promise((_,ae)=>{this.b.then(_,ae)})}return this.a=B(),new Promise((_,ae)=>{this.a.then(se=>{this.a=null,_(se)},se=>{this.a=null,ae(se)})})}dispose(){this.f=!0}}e.$Wg=g;class u{constructor(){this.a=Promise.resolve(null)}queue(B){return this.a=this.a.then(()=>B(),()=>B())}}e.$Xg=u;class c{constructor(){this.a=new Map}queue(B,_){const se=(this.a.get(B)??Promise.resolve()).catch(()=>{}).then(_).finally(()=>{this.a.get(B)===se&&this.a.delete(B)});return this.a.set(B,se),se}}e.$Yg=c;const S=(W,B)=>{let _=!0;const ae=setTimeout(()=>{_=!1,B()},W);return{isTriggered:()=>_,dispose:()=>{clearTimeout(ae),_=!1}}},d=W=>{let B=!0;return queueMicrotask(()=>{B&&(B=!1,W())}),{isTriggered:()=>B,dispose:()=>{B=!1}}};class t{constructor(B){this.defaultDelay=B,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(B,_=this.defaultDelay){this.g=B,this.h(),this.b||(this.b=new Promise((se,$e)=>{this.d=se,this.f=$e}).then(()=>{if(this.b=null,this.d=null,this.g){const se=this.g;return this.g=null,se()}}));const ae=()=>{this.a=null,this.d?.(null)};return this.a=_===f.$Pd?d(ae):S(_,ae),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Zg=t;class o{constructor(B){this.a=new t(B),this.b=new g}trigger(B,_){return this.a.trigger(()=>this.b.queue(B),_)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$1g=o;class r{constructor(){this.a=!1,this.b=new Promise((B,_)=>{this.d=B})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$2g=r;class i extends r{constructor(B){super(),this.f=setTimeout(()=>this.open(),B)}open(){clearTimeout(this.f),super.open()}}e.$3g=i;function n(W,B){return B?new Promise((_,ae)=>{const se=setTimeout(()=>{$e.dispose(),_()},W),$e=B.onCancellationRequested(()=>{clearTimeout(se),$e.dispose(),ae(new R.$5)})}):v(_=>n(W,_))}e.$4g=n;function a(W,B=0,_){const ae=setTimeout(()=>{W(),_&&se.dispose()},B),se=(0,j.$Qc)(()=>{clearTimeout(ae),_?.deleteAndLeak(se)});return _?.add(se),se}e.$5g=a;function m(W){const B=[];let _=0;const ae=W.length;function se(){return _<ae?W[_++]():null}function $e(me){me!=null&&B.push(me);const ye=se();return ye?ye.then($e):Promise.resolve(B)}return Promise.resolve(null).then($e)}e.$6g=m;function D(W,B=ae=>!!ae,_=null){let ae=0;const se=W.length,$e=()=>{if(ae>=se)return Promise.resolve(_);const me=W[ae++];return Promise.resolve(me()).then(Pe=>B(Pe)?Promise.resolve(Pe):$e())};return $e()}e.$7g=D;function I(W,B=ae=>!!ae,_=null){if(W.length===0)return Promise.resolve(_);let ae=W.length;const se=()=>{ae=-1;for(const $e of W)$e.cancel?.()};return new Promise(($e,me)=>{for(const ye of W)ye.then(Pe=>{--ae>=0&&B(Pe)?(se(),$e(Pe)):ae===0&&$e(_)}).catch(Pe=>{--ae>=0&&(se(),me(Pe))})})}e.$8g=I;class k{constructor(B){this.a=0,this.d=B,this.f=[],this.b=0,this.g=new s.$Sd}get onDrained(){return this.g.event}get size(){return this.a}queue(B){return this.a++,new Promise((_,ae)=>{this.f.push({factory:B,c:_,e:ae}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const B=this.f.shift();this.b++;const _=B.factory();_.then(B.c,B.e),_.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$9g=k;class C extends k{constructor(){super(1)}}e.$0g=C;class M{constructor(){this.a=new L,this.b=0}queue(B){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,B())):this.a.run(this.b++,B())}}e.$$g=M;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const B=new q;return this.b.add(B),B.p}g(){for(const[,B]of this.a)if(B.size>0)return!1;return!0}queueFor(B,_=A.$ug){const ae=_.getComparisonKey(B);let se=this.a.get(ae);if(!se){se=new C;const $e=this.f++,me=s.Event.once(se.onDrained)(()=>{se?.dispose(),this.a.delete(ae),this.h(),this.d?.deleteAndDispose($e),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new j.$2c),this.d.set($e,me),this.a.set(ae,se)}return se}h(){this.g()&&this.j()}j(){for(const B of this.b)B.complete();this.b.clear()}dispose(){for(const[,B]of this.a)B.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$_g=F;class N{constructor(B,_){this.a=-1,typeof B=="function"&&typeof _=="number"&&this.setIfNotSet(B,_)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(B,_){this.cancel(),this.a=setTimeout(()=>{this.a=-1,B()},_)}setIfNotSet(B,_){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,B()},_))}}e.$ah=N;class Z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(B,_,ae=globalThis){this.cancel();const se=ae.setInterval(()=>{B()},_);this.d=(0,j.$Qc)(()=>{ae.clearInterval(se),this.d=void 0})}dispose(){this.cancel()}}e.$bh=Z;class Q{constructor(B,_){this.b=-1,this.a=B,this.d=_,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(B=this.d){this.cancel(),this.b=setTimeout(this.f,B)}get delay(){return this.d}set delay(B){this.d=B}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$ch=Q;class le{constructor(B,_){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.a=B,this.b=_,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(B=this.b){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(B/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$dh=le;class ce extends Q{constructor(B,_){super(B,_),this.j=[]}work(B){this.j.push(B),this.isScheduled()||this.schedule()}h(){const B=this.j;this.j=[],this.a?.(B)}dispose(){this.j=[],super.dispose()}}e.$eh=ce;class ue extends j.$Sc{constructor(B,_){super(),this.g=B,this.h=_,this.a=[],this.b=this.B(new j.$Tc),this.f=!1}get pending(){return this.a.length}work(B){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+B.length>this.g.maxBufferedWork)return!1}else if(this.pending+B.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const _ of B)this.a.push(_);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$fh=ue,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$hh=(W,B)=>{(0,E.$B)(()=>{if(_)return;const ae=Date.now()+15;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ae-Date.now())}}))});let _=!1;return{dispose(){_||(_=!0)}}}:e.$hh=(W,B,_)=>{const ae=W.requestIdleCallback(B,typeof _=="number"?{timeout:_}:void 0);let se=!1;return{dispose(){se||(se=!0,W.cancelIdleCallback(ae))}}},e.$gh=W=>(0,e.$hh)(globalThis,W)}();class X{constructor(B,_){this.g=!1,this.d=()=>{try{this.j=_()}catch(ae){this.l=ae}finally{this.g=!0}},this.f=(0,e.$hh)(B,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$ih=X;class K extends X{constructor(B){super(globalThis,B)}}e.$jh=K;async function H(W,B,_){let ae;for(let se=0;se<_;se++)try{return await W()}catch($e){ae=$e,await n(B)}throw ae}e.$kh=H;class L{isRunning(B){return typeof B=="number"?this.a?.taskId===B:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(B,_,ae){return this.a={taskId:B,cancel:()=>ae?.(),promise:_},_.then(()=>this.d(B),()=>this.d(B)),_}d(B){this.a&&B===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const B=this.b;this.b=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}queue(B){if(this.b)this.b.run=B;else{let _,ae;const se=new Promise(($e,me)=>{_=$e,ae=me});this.b={run:B,promise:se,promiseResolve:_,promiseReject:ae}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$lh=L;class T{constructor(B,_=()=>Date.now()){this.d=B,this.f=_,this.a=0,this.b=0}increment(){const B=this.f();return B-this.a>this.d&&(this.a=B,this.b=0),this.b++,this.b}}e.$mh=T;var V;(function(W){W[W.Resolved=0]="Resolved",W[W.Rejected=1]="Rejected"})(V||(V={}));class q{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((B,_)=>{this.a=B,this.b=_})}complete(B){return new Promise(_=>{this.a(B),this.d={outcome:0,value:B},_()})}error(B){return new Promise(_=>{this.b(B),this.d={outcome:1,value:B},_()})}cancel(){return this.error(new R.$5)}}e.$nh=q;var te;(function(W){async function B(ae){let se;const $e=await Promise.all(ae.map(me=>me.then(ye=>ye,ye=>{se||(se=ye)})));if(typeof se<"u")throw se;return $e}W.settled=B;function _(ae){return new Promise(async(se,$e)=>{try{await ae(se,$e)}catch(me){$e(me)}})}W.withAsyncBody=_})(te||(e.Promises=te={}));class he{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(B){this.a=void 0,this.b=void 0,this.d=!1,this.promise=B.then(_=>(this.a=_,this.d=!0,_),_=>{throw this.b=_,this.d=!0,_})}requireValue(){if(!this.d)throw new R.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$oh=he;class G{constructor(B){this.b=B,this.a=new h.$V(()=>new he(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$ph=G;var O;(function(W){W[W.Initial=0]="Initial",W[W.DoneOK=1]="DoneOK",W[W.DoneError=2]="DoneError"})(O||(O={}));class U{static fromArray(B){return new U(_=>{_.emitMany(B)})}static fromPromise(B){return new U(async _=>{_.emitMany(await B)})}static fromPromises(B){return new U(async _=>{await Promise.all(B.map(async ae=>_.emitOne(await ae)))})}static merge(B){return new U(async _=>{await Promise.all(B.map(async ae=>{for await(const se of ae)_.emitOne(se)}))})}static{this.EMPTY=U.fromArray([])}constructor(B){this.a=0,this.b=[],this.d=null,this.f=new s.$Sd,queueMicrotask(async()=>{const _={emitOne:ae=>this.g(ae),emitMany:ae=>this.h(ae),reject:ae=>this.k(ae)};try{await Promise.resolve(B(_)),this.j()}catch(ae){this.k(ae)}finally{_.emitOne=void 0,_.emitMany=void 0,_.reject=void 0}})}[Symbol.asyncIterator](){let B=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(B<this.b.length)return{done:!1,value:this.b[B++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(B,_){return new U(async ae=>{for await(const se of B)ae.emitOne(_(se))})}map(B){return U.map(this,B)}static filter(B,_){return new U(async ae=>{for await(const se of B)_(se)&&ae.emitOne(se)})}filter(B){return U.filter(this,B)}static coalesce(B){return U.filter(B,_=>!!_)}coalesce(){return U.coalesce(this)}static async toPromise(B){const _=[];for await(const ae of B)_.push(ae);return _}toPromise(){return U.toPromise(this)}g(B){this.a===0&&(this.b.push(B),this.f.fire())}h(B){this.a===0&&(this.b=this.b.concat(B),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(B){this.a===0&&(this.a=2,this.d=B,this.f.fire())}}e.$qh=U;class x extends U{constructor(B,_){super(_),this.l=B}cancel(){this.l.cancel()}}e.$rh=x;function z(W){const B=new P.$3d,_=W(B.token);return new x(B,async ae=>{const se=B.token.onCancellationRequested(()=>{se.dispose(),B.dispose(),ae.reject(new R.$5)});try{for await(const $e of _){if(B.token.isCancellationRequested)return;ae.emitOne($e)}se.dispose(),B.dispose()}catch($e){se.dispose(),B.dispose(),ae.reject($e)}})}e.$sh=z;class Y{constructor(){this.a=new q,this.b=new U(ae=>{if(B){ae.reject(B);return}return _&&ae.emitMany(_),this.d=se=>ae.reject(se),this.f=se=>ae.emitOne(se),this.a.p});let B,_;this.f=ae=>{_||(_=[]),_.push(ae)},this.d=ae=>{B||(B=ae)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(B){this.d(B),this.a.complete()}emitOne(B){this.f(B)}}e.$th=Y}),define(re[104],oe([0,1,23,8,33,31,9,4,25]),function(J,e,P,R,s,j,A,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=void 0;function h(){return Object.create(null)}e.$Ej=h,e.$Fj="**",e.$Gj="/";const y="[/\\\\]",v="[^/\\\\]",b=/\//g;function l(K,H){switch(K){case 0:return"";case 1:return`${v}*?`;default:return`(?:${y}|${v}+${y}${H?`|${y}${v}+`:""})*?`}}function p(K,H){if(!K)return[];const L=[];let T=!1,V=!1,q="";for(const te of K){switch(te){case H:if(!T&&!V){L.push(q),q="";continue}break;case"{":T=!0;break;case"}":T=!1;break;case"[":V=!0;break;case"]":V=!1;break}q+=te}return q&&L.push(q),L}e.$Hj=p;function w(K){if(!K)return"";let H="";const L=p(K,e.$Gj);if(L.every(T=>T===e.$Fj))H=".*";else{let T=!1;L.forEach((V,q)=>{if(V===e.$Fj){if(T)return;H+=l(2,q===L.length-1)}else{let te=!1,he="",G=!1,O="";for(const U of V){if(U!=="}"&&te){he+=U;continue}if(G&&(U!=="]"||!O)){let x;U==="-"?x=U:(U==="^"||U==="!")&&!O?x="^":U===e.$Gj?x="":x=(0,f.$Le)(U),O+=x;continue}switch(U){case"{":te=!0;continue;case"[":G=!0;continue;case"}":{const z=`(?:${p(he,",").map(Y=>w(Y)).join("|")})`;H+=z,te=!1,he="";break}case"]":{H+="["+O+"]",G=!1,O="";break}case"?":H+=v;continue;case"*":H+=l(1);continue;default:H+=(0,f.$Le)(U)}}q<L.length-1&&(L[q+1]!==e.$Fj||q+2<L.length)&&(H+=y)}T=V===e.$Fj})}return H}const $=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,d=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new j.$Dc(1e4),o=function(){return!1},r=function(){return null};function i(K,H){if(!K)return r;let L;typeof K!="string"?L=K.pattern:L=K,L=L.trim();const T=`${L}_${!!H.trimForExclusions}`;let V=t.get(T);if(V)return n(V,K);let q;return $.test(L)?V=m(L.substr(4),L):(q=g.exec(a(L,H)))?V=D(q[1],L):(H.trimForExclusions?c:u).test(L)?V=I(L,H):(q=S.exec(a(L,H)))?V=k(q[1].substr(1),L,!0):(q=d.exec(a(L,H)))?V=k(q[1],L,!1):V=C(L),t.set(T,V),n(V,K)}function n(K,H){if(typeof H=="string")return K;const L=function(T,V){return(0,s.$5f)(T,H.base,!E.$k)?K((0,f.$Qe)(T.substr(H.base.length),A.sep),V):null};return L.allBasenames=K.allBasenames,L.allPaths=K.allPaths,L.basenames=K.basenames,L.patterns=K.patterns,L}function a(K,H){return H.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function m(K,H){return function(L,T){return typeof L=="string"&&L.endsWith(K)?H:null}}function D(K,H){const L=`/${K}`,T=`\\${K}`,V=function(te,he){return typeof te!="string"?null:he?he===K?H:null:te===K||te.endsWith(L)||te.endsWith(T)?H:null},q=[K];return V.basenames=q,V.patterns=[H],V.allBasenames=q,V}function I(K,H){const L=ue(K.slice(1,-1).split(",").map(he=>i(he,H)).filter(he=>he!==r),K),T=L.length;if(!T)return r;if(T===1)return L[0];const V=function(he,G){for(let O=0,U=L.length;O<U;O++)if(L[O](he,G))return K;return null},q=L.find(he=>!!he.allBasenames);q&&(V.allBasenames=q.allBasenames);const te=L.reduce((he,G)=>G.allPaths?he.concat(G.allPaths):he,[]);return te.length&&(V.allPaths=te),V}function k(K,H,L){const T=A.sep===A.$gc.sep,V=T?K:K.replace(b,A.sep),q=A.sep+V,te=A.$gc.sep+K;let he;return L?he=function(G,O){return typeof G=="string"&&(G===V||G.endsWith(q)||!T&&(G===K||G.endsWith(te)))?H:null}:he=function(G,O){return typeof G=="string"&&(G===V||!T&&G===K)?H:null},he.allPaths=[(L?"*/":"./")+K],he}function C(K){try{const H=new RegExp(`^${w(K)}$`);return function(L){return H.lastIndex=0,typeof L=="string"&&H.test(L)?K:null}}catch{return r}}function M(K,H,L){return!K||typeof H!="string"?!1:F(K)(H,void 0,L)}e.$Ij=M;function F(K,H={}){if(!K)return o;if(typeof K=="string"||N(K)){const L=i(K,H);if(L===r)return o;const T=function(V,q){return!!L(V,q)};return L.allBasenames&&(T.allBasenames=L.allBasenames),L.allPaths&&(T.allPaths=L.allPaths),T}return le(K,H)}e.$Jj=F;function N(K){const H=K;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.$Kj=N;function Z(K){return K.allBasenames||[]}e.$Lj=Z;function Q(K){return K.allPaths||[]}e.$Mj=Q;function le(K,H){const L=ue(Object.getOwnPropertyNames(K).map(he=>ce(he,K[he],H)).filter(he=>he!==r)),T=L.length;if(!T)return r;if(!L.some(he=>!!he.requiresSiblings)){if(T===1)return L[0];const he=function(U,x){let z;for(let Y=0,W=L.length;Y<W;Y++){const B=L[Y](U,x);if(typeof B=="string")return B;(0,R.$Pg)(B)&&(z||(z=[]),z.push(B))}return z?(async()=>{for(const Y of z){const W=await Y;if(typeof W=="string")return W}return null})():null},G=L.find(U=>!!U.allBasenames);G&&(he.allBasenames=G.allBasenames);const O=L.reduce((U,x)=>x.allPaths?U.concat(x.allPaths):U,[]);return O.length&&(he.allPaths=O),he}const V=function(he,G,O){let U,x;for(let z=0,Y=L.length;z<Y;z++){const W=L[z];W.requiresSiblings&&O&&(G||(G=(0,A.$nc)(he)),U||(U=G.substr(0,G.length-(0,A.$oc)(he).length)));const B=W(he,G,U,O);if(typeof B=="string")return B;(0,R.$Pg)(B)&&(x||(x=[]),x.push(B))}return x?(async()=>{for(const z of x){const Y=await z;if(typeof Y=="string")return Y}return null})():null},q=L.find(he=>!!he.allBasenames);q&&(V.allBasenames=q.allBasenames);const te=L.reduce((he,G)=>G.allPaths?he.concat(G.allPaths):he,[]);return te.length&&(V.allPaths=te),V}function ce(K,H,L){if(H===!1)return r;const T=i(K,L);if(T===r)return r;if(typeof H=="boolean")return T;if(H){const V=H.when;if(typeof V=="string"){const q=(te,he,G,O)=>{if(!O||!T(te,he))return null;const U=V.replace("$(basename)",()=>G),x=O(U);return(0,R.$Pg)(x)?x.then(z=>z?K:null):x?K:null};return q.requiresSiblings=!0,q}}return T}function ue(K,H){const L=K.filter(he=>!!he.basenames);if(L.length<2)return K;const T=L.reduce((he,G)=>{const O=G.basenames;return O?he.concat(O):he},[]);let V;if(H){V=[];for(let he=0,G=T.length;he<G;he++)V.push(H)}else V=L.reduce((he,G)=>{const O=G.patterns;return O?he.concat(O):he},[]);const q=function(he,G){if(typeof he!="string")return null;if(!G){let U;for(U=he.length;U>0;U--){const x=he.charCodeAt(U-1);if(x===47||x===92)break}G=he.substr(U)}const O=T.indexOf(G);return O!==-1?V[O]:null};q.basenames=T,q.patterns=V,q.allBasenames=T;const te=K.filter(he=>!he.basenames);return te.push(q),te}function X(K,H){return(0,P.$ub)(K,H,(L,T)=>typeof L=="string"&&typeof T=="string"?L===T:typeof L!="string"&&typeof T!="string"?L.base===T.base&&L.pattern===T.pattern:!1)}e.$Nj=X}),define(re[47],oe([0,1,23,33,9,4,19,25]),function(J,e,P,R,s,j,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rv=e.$Qv=e.$Pv=e.$Ov=e.$Nv=e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=void 0;function f(i,n){const{os:a,tildify:m,relative:D}=n;if(D){const C=h(i,D,a);if(typeof C=="string")return C}let I=i.fsPath;if(a===1&&!j.$i?I=I.replace(/\//g,"\\"):a!==1&&j.$i&&(I=I.replace(/\\/g,"/")),a!==1&&m?.userHome){const C=m.userHome.fsPath;let M;i.scheme!==m.userHome.scheme&&i.path[0]===s.$gc.sep&&i.path[1]!==s.$gc.sep?M=m.userHome.with({path:i.path}).fsPath:M=I,I=b(M,C,a)}return(a===1?s.$fc:s.$gc).normalize(y(I,a===1))}e.$Iv=f;function h(i,n,a){const m=a===1?s.$fc:s.$gc,D=a===3?A.$ug:A.$wg,I=n.getWorkspace(),k=(0,P.$Ob)(I.folders);if(!k)return;i.scheme!==k.uri.scheme&&i.path[0]===s.$gc.sep&&i.path[1]!==s.$gc.sep&&(i=k.uri.with({path:i.path}));const C=n.getWorkspaceFolder(i);if(!C)return;let M;if(D.isEqual(C.uri,i)?M="":M=D.relativePath(C.uri,i)??"",M&&(M=m.normalize(M)),I.folders.length>1&&!n.noPrefix){const F=C.name?C.name:D.basenameOrAuthority(C.uri);M=M?`${F} \u2022 ${M}`:F}return M}function y(i,n=j.$i){return(0,R.$9f)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$Jv=y;let v=Object.create(null);function b(i,n,a=j.OS){if(a===1||!i||!n)return i;let m=v.original===n?v.normalized:void 0;m||(m=n,j.$i&&(m=(0,R.$Yf)(m)),m=`${(0,E.$Re)(m,s.$gc.sep)}${s.$gc.sep}`,v={original:n,normalized:m});let D=i;return j.$i&&(D=(0,R.$Yf)(D)),(a===3?D.startsWith(m):(0,E.$0e)(D,m))?`~/${D.substr(m.length)}`:i}e.$Kv=b;function l(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.$Lv=l;const p="\u2026",w="\\\\",$="~";function g(i,n=s.sep){const a=new Array(i.length);let m=!1;for(let D=0;D<i.length;D++){const I=i[D];if(I===""){a[D]=`.${n}`;continue}if(!I){a[D]=I;continue}m=!0;let k="",C=I;C.indexOf(w)===0?(k=C.substr(0,C.indexOf(w)+w.length),C=C.substr(C.indexOf(w)+w.length)):C.indexOf(n)===0?(k=C.substr(0,C.indexOf(n)+n.length),C=C.substr(C.indexOf(n)+n.length)):C.indexOf($)===0&&(k=C.substr(0,C.indexOf($)+$.length),C=C.substr(C.indexOf($)+$.length));const M=C.split(n);for(let F=1;m&&F<=M.length;F++)for(let N=M.length-F;m&&N>=0;N--){m=!1;let Z=M.slice(N,N+F).join(n);for(let Q=0;!m&&Q<i.length;Q++)if(Q!==D&&i[Q]&&i[Q].indexOf(Z)>-1){const le=N+F===M.length,ce=N>0&&i[Q].indexOf(n)>-1?n+Z:Z,ue=i[Q].endsWith(ce);m=!le||ue}if(!m){let Q="";(M[0].endsWith(":")||k!=="")&&(N===1&&(N=0,F++,Z=M[0]+n+Z),N>0&&(Q=M[0]+n),Q=k+Q),N>0&&(Q=Q+p+n),Q=Q+Z,N+F<M.length&&(Q=Q+n+p),a[D]=Q}}m&&(a[D]=I)}return a}e.$Mv=g;var u;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function c(i,n=Object.create(null)){const a=[];let m=!1,D="";for(const I of i)if(I==="$"||m&&I==="{")D&&a.push({value:D,type:u.TEXT}),D="",m=!0;else if(I==="}"&&m){const k=n[D];if(typeof k=="string")k.length&&a.push({value:k,type:u.VARIABLE});else if(k){const C=a[a.length-1];(!C||C.type!==u.SEPARATOR)&&a.push({value:k.label,type:u.SEPARATOR})}D="",m=!1}else D+=I;return D&&!m&&a.push({value:D,type:u.TEXT}),a.filter((I,k)=>{if(I.type===u.SEPARATOR){const C=a[k-1],M=a[k+1];return[C,M].every(F=>F&&(F.type===u.VARIABLE||F.type===u.TEXT)&&F.value.length>0)}return!0}).map(I=>I.value).join("")}e.$Nv=c;function S(i,n){return j.$j||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,j.$j?"&":"&&"):i.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.$Ov=S;function d(i,n){return j.$j||n?i.replace(/\(&&\w\)|&&/g,""):j.$i?i.replace(/&&|&/g,a=>a==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$Pv=d;function t(i){return i.replace(/&/g,"&&")}e.$Qv=t;function o(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const a=r(i.substring(0,n)),m=i.substring(n);return{name:a.name+m,parentPath:a.parentPath}}}return r(i)}e.$Rv=o;function r(i){const n=i.indexOf("/")!==-1?s.$gc:s.$fc,a=n.basename(i),m=n.dirname(i);return a.length?{name:a,parentPath:m}:{name:m,parentPath:""}}}),define(re[155],oe([0,1,18,7]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=void 0;function s(v){return v.toJSON()}class j{constructor(b){this.a=b}transformIncoming(b){const l=this.a.transformIncoming(b);return l===b?b:s(R.URI.from(l))}transformOutgoing(b){const l=this.a.transformOutgoing(b);return l===b?b:s(R.URI.from(l))}transformOutgoingURI(b){const l=this.a.transformOutgoing(b);return l===b?b:R.URI.from(l)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.$1m=j,e.$2m=new class{transformIncoming(v){return v}transformOutgoing(v){return v}transformOutgoingURI(v){return v}transformOutgoingScheme(v){return v}};function A(v,b,l){if(!v||l>200)return null;if(typeof v=="object"){if(v instanceof R.URI)return b.transformOutgoing(v);for(const p in v)if(Object.hasOwnProperty.call(v,p)){const w=A(v[p],b,l+1);w!==null&&(v[p]=w)}}return null}function E(v,b){const l=A(v,b,0);return l===null?v:l}e.$3m=E;function f(v,b,l,p){if(!v||p>200)return null;if(typeof v=="object"){if(v.$mid===1)return l?R.URI.revive(b.transformIncoming(v)):b.transformIncoming(v);if(v instanceof P.$ge)return null;for(const w in v)if(Object.hasOwnProperty.call(v,w)){const $=f(v[w],b,l,p+1);$!==null&&(v[w]=$)}}return null}function h(v,b){const l=f(v,b,!1,0);return l===null?v:l}e.$4m=h;function y(v,b){const l=f(v,b,!0,0);return l===null?v:l}e.$5m=y}),define(re[88],oe([0,1,26,57,32,145,4]),function(J,e,P,R,s,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=e.$8m=e.$7m=void 0,e.$7m=new class{c(b){return this.a||(this.a=R.$9h.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,l=0;const p=(0,P.networkInterfaces)();for(const w in p){const $=p[w];if($)for(const{mac:g,internal:u}of $)u||(l+=1,this.c(g.toUpperCase())&&(b+=1))}this.b=l>0?b/l:0}return this.b}};let E;async function f(b){return E||(E=(async()=>await h(b)||s.$ng())()),E}e.$8m=f;async function h(b){try{const l=await new Promise((w,$)=>{J(["crypto"],w,$)}),p=(0,j.$6m)();return l.createHash("sha256").update(p,"utf8").digest("hex")}catch(l){b(l);return}}const y="Software\\Microsoft\\SQMClient";async function v(b){if(A.$i){const l=await new Promise((p,w)=>{J(["@vscode/windows-registry"],p,w)});try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",y,"MachineId")||""}catch(p){return b(p),""}}return""}e.$9m=v}),define(re[21],oe([0,1,46,26,156,8,33,85,9,4,19,7]),function(J,e,P,R,s,j,A,E,f,h,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(ce){ce[ce.UNLINK=0]="UNLINK",ce[ce.MOVE=1]="MOVE"})(b||(e.RimRafMode=b={}));async function l(ce,ue=b.UNLINK,X){if((0,A.$8f)(ce))throw new Error("rimraf - will refuse to recursively delete root");return ue===b.UNLINK?w(ce):p(ce,X)}async function p(ce,ue=(0,A.$ag)((0,R.tmpdir)())){try{try{await P.promises.rename(ce,ue)}catch(X){return X.code==="ENOENT"?void 0:w(ce)}w(ue).catch(X=>{})}catch(X){if(X.code!=="ENOENT")throw X}}async function w(ce){return(0,s.promisify)(P.rm)(ce,{recursive:!0,force:!0,maxRetries:3})}function $(ce){if((0,A.$8f)(ce))throw new Error("rimraf - will refuse to recursively delete root");P.rmSync(ce,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=$;async function g(ce,ue){return S(await(ue?u(ce):(0,s.promisify)(P.readdir)(ce)))}async function u(ce){try{return await(0,s.promisify)(P.readdir)(ce,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const ue=[],X=await g(ce);for(const K of X){let H=!1,L=!1,T=!1;try{const V=await e.Promises.lstat((0,f.$jc)(ce,K));H=V.isFile(),L=V.isDirectory(),T=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}ue.push({name:K,isFile:()=>H,isDirectory:()=>L,isSymbolicLink:()=>T})}return ue}function c(ce){return S(P.readdirSync(ce))}e.readdirSync=c;function S(ce){return ce.map(ue=>typeof ue=="string"?h.$j?(0,E.$Dl)(ue):ue:(ue.name=h.$j?(0,E.$Dl)(ue.name):ue.name,ue))}async function d(ce){const ue=await g(ce),X=[];for(const K of ue)await o.existsDirectory((0,f.$jc)(ce,K))&&X.push(K);return X}function t(ce,ue=1e3){return new Promise(X=>{let K=!1;const H=setInterval(()=>{K||(K=!0,P.access(ce,L=>{K=!1,L&&(clearInterval(H),X(void 0))}))},ue)})}e.whenDeleted=t;var o;(function(ce){async function ue(H){let L;try{if(L=await e.Promises.lstat(H),!L.isSymbolicLink())return{stat:L}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:L?.isSymbolicLink()?{dangling:!1}:void 0}}catch(T){if(T.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};if(h.$i&&T.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};throw V}throw T}}ce.stat=ue;async function X(H){try{const{stat:L,symbolicLink:T}=await ce.stat(H);return L.isFile()&&T?.dangling!==!0}catch{}return!1}ce.existsFile=X;async function K(H){try{const{stat:L,symbolicLink:T}=await ce.stat(H);return L.isDirectory()&&T?.dangling!==!0}catch{}return!1}ce.existsDirectory=K})(o||(e.SymlinkSupport=o={}));const r=new j.$_g;function i(ce,ue,X){return r.queueFor(v.URI.file(ce),y.$vg).queue(()=>{const K=I(X);return new Promise((H,L)=>m(ce,ue,K,T=>T?L(T):H()))})}let n=!0;function a(ce){n=ce}e.configureFlushOnWrite=a;function m(ce,ue,X,K){if(!n)return P.writeFile(ce,ue,{mode:X.mode,flag:X.flag},K);P.open(ce,X.flag,X.mode,(H,L)=>{if(H)return K(H);P.writeFile(L,ue,T=>{if(T)return P.close(L,()=>K(T));P.fdatasync(L,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),a(!1)),P.close(L,q=>K(q))))})})}function D(ce,ue,X){const K=I(X);if(!n)return P.writeFileSync(ce,ue,{mode:K.mode,flag:K.flag});const H=P.openSync(ce,K.flag,K.mode);try{P.writeFileSync(H,ue);try{P.fdatasyncSync(H)}catch(L){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",L),a(!1)}}finally{P.closeSync(H)}}e.writeFileSync=D;function I(ce){return ce?{mode:typeof ce.mode=="number"?ce.mode:438,flag:typeof ce.flag=="string"?ce.flag:"w"}:{mode:438,flag:"w"}}async function k(ce,ue,X=6e4){if(ce!==ue)try{h.$i&&typeof X=="number"?await C(ce,ue,Date.now(),X):await(0,s.promisify)(P.rename)(ce,ue)}catch(K){if(ce.toLowerCase()!==ue.toLowerCase()&&K.code==="EXDEV"||ce.endsWith("."))await M(ce,ue,{preserveSymlinks:!1}),await l(ce,b.MOVE);else throw K}}async function C(ce,ue,X,K,H=0){try{return await(0,s.promisify)(P.rename)(ce,ue)}catch(L){if(L.code!=="EACCES"&&L.code!=="EPERM"&&L.code!=="EBUSY")throw L;if(Date.now()-X>=K)throw console.error(`[node.js fs] rename failed after ${H} retries with error: ${L}`),L;if(H===0){let T=!1;try{const{stat:V}=await o.stat(ue);V.isFile()||(T=!0)}catch{}if(T)throw L}return await(0,j.$4g)(Math.min(100,H*10)),C(ce,ue,X,K,H+1)}}async function M(ce,ue,X){return N(ce,ue,{root:{source:ce,target:ue},options:X,handledSourcePaths:new Set})}const F=511;async function N(ce,ue,X){if(X.handledSourcePaths.has(ce))return;X.handledSourcePaths.add(ce);const{stat:K,symbolicLink:H}=await o.stat(ce);if(H){if(X.options.preserveSymlinks)try{return await le(ce,ue,X)}catch{}if(H.dangling)return}return K.isDirectory()?Z(ce,ue,K.mode&F,X):Q(ce,ue,K.mode&F)}async function Z(ce,ue,X,K){await e.Promises.mkdir(ue,{recursive:!0,mode:X});const H=await g(ce);for(const L of H)await N((0,f.$jc)(ce,L),(0,f.$jc)(ue,L),K)}async function Q(ce,ue,X){await e.Promises.copyFile(ce,ue),await e.Promises.chmod(ue,X)}async function le(ce,ue,X){let K=await e.Promises.readlink(ce);(0,A.$5f)(K,X.root.source,!h.$k)&&(K=(0,f.$jc)(X.root.target,K.substr(X.root.source.length+1))),await e.Promises.symlink(K,ue)}e.Promises=new class{get access(){return(0,s.promisify)(P.access)}get stat(){return(0,s.promisify)(P.stat)}get lstat(){return(0,s.promisify)(P.lstat)}get utimes(){return(0,s.promisify)(P.utimes)}get read(){return(ce,ue,X,K,H)=>new Promise((L,T)=>{P.read(ce,ue,X,K,H,(V,q,te)=>V?T(V):L({bytesRead:q,buffer:te}))})}get readFile(){return(0,s.promisify)(P.readFile)}get write(){return(ce,ue,X,K,H)=>new Promise((L,T)=>{P.write(ce,ue,X,K,H,(V,q,te)=>V?T(V):L({bytesWritten:q,buffer:te}))})}get appendFile(){return(0,s.promisify)(P.appendFile)}get fdatasync(){return(0,s.promisify)(P.fdatasync)}get truncate(){return(0,s.promisify)(P.truncate)}get copyFile(){return(0,s.promisify)(P.copyFile)}get open(){return(0,s.promisify)(P.open)}get close(){return(0,s.promisify)(P.close)}get symlink(){return(0,s.promisify)(P.symlink)}get readlink(){return(0,s.promisify)(P.readlink)}get chmod(){return(0,s.promisify)(P.chmod)}get mkdir(){return(0,s.promisify)(P.mkdir)}get unlink(){return(0,s.promisify)(P.unlink)}get rmdir(){return(0,s.promisify)(P.rmdir)}get realpath(){return(0,s.promisify)(P.realpath)}async exists(ce){try{return await e.Promises.access(ce),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return d}get writeFile(){return i}get rm(){return l}get rename(){return k}get copy(){return M}}}),define(re[105],oe([0,1,46,9,4,25,21]),function(J,e,P,R,s,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=e.$iq=e.$hq=void 0;function E(b){if(s.$k)return b;const l=(0,R.$mc)(b);if(b===l)return b;const p=((0,R.$nc)(b)||b).toLowerCase();try{const $=(0,A.readdirSync)(l).filter(g=>g.toLowerCase()===p);if($.length===1){const g=E(l);if(g)return(0,R.$jc)(g,$[0])}else if($.length>1){const g=$.indexOf(p);if(g>=0){const u=E(l);if(u)return(0,R.$jc)(u,$[g])}}}catch{}return null}e.$hq=E;async function f(b){if(s.$k)return b;const l=(0,R.$mc)(b);if(b===l)return b;const p=((0,R.$nc)(b)||b).toLowerCase();try{const $=(await A.Promises.readdir(l)).filter(g=>g.toLowerCase()===p);if($.length===1){const g=await f(l);if(g)return(0,R.$jc)(g,$[0])}else if($.length>1){const g=$.indexOf(p);if(g>=0){const u=await f(l);if(u)return(0,R.$jc)(u,$[g])}}}catch{}return null}e.$iq=f;async function h(b){try{return await A.Promises.realpath(b)}catch{const p=v(b);return await A.Promises.access(p,P.constants.R_OK),p}}e.$jq=h;function y(b){try{return P.realpathSync(b)}catch{const p=v(b);return P.accessSync(p,P.constants.R_OK),p}}e.$kq=y;function v(b){return(0,j.$Re)((0,R.$hc)(b),R.sep)}}),define(re[106],oe([0,1,26,9,21]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=void 0;const j=/^\d+$/,A=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var f;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(f||(f={}));let h;switch(process.arch){case"ia32":h=1;break;case"arm":case"arm64":h=2;break;default:h=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class v{constructor(d,t,o){this.exePath=d,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function b({useAlternateBitness:S=!1}={}){return S?h===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function l({useAlternateBitness:S=!1,findPreview:d=!1}={}){const t=b({useAlternateBitness:S});if(!t)return null;const o=R.$jc(t,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(o))return null;let r=-1,i=null;for(const m of await s.Promises.readdir(o)){let D=-1;if(d){const k=m.indexOf("-");if(k<0)continue;const C=m.substring(0,k);if(!j.test(C)||m.substring(k+1)!=="preview")continue;D=parseInt(C,10)}else{if(!j.test(m))continue;D=parseInt(m,10)}if(D<=r)continue;const I=R.$jc(o,m,"pwsh.exe");await s.SymlinkSupport.existsFile(I)&&(i=I,r=D)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",a=d?" Preview":"";return new v(i,`PowerShell${a}${n}`,!0)}async function p({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const d=R.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(d))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=S?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const r of await s.Promises.readdir(d))if(t.test(r)){const i=R.$jc(d,r,"pwsh.exe");return new v(i,o)}return null}function w(){const S=R.$jc(P.homedir(),".dotnet","tools","pwsh.exe");return new v(S,".NET Core PowerShell Global Tool")}function $(){const S=R.$jc(process.env.windir,h===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(S,"Windows PowerShell",!0)}async function*g(){let S=await l();S&&(yield S),S=await l({useAlternateBitness:!0}),S&&(yield S),S=await p(),S&&(yield S),S=w(),S&&(yield S),S=await l({findPreview:!0}),S&&(yield S),S=await p({findPreview:!0}),S&&(yield S),S=await l({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=$(),S&&(yield S)}async function*u(){for await(const S of g())await S.exists()&&(yield S)}e.$Ml=u;async function c(){for await(const S of u())return S;return null}e.$Nl=c}),define(re[89],oe([0,1,9,4,35,76,12,21]),function(J,e,P,R,s,j,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Rl=e.$Ql=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return j.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return j.TerminateResponseCode}});function f(v=s.env){return v.comspec||"cmd.exe"}e.$Ql=f;function h(v){let b=[],l=!1;const p=function(w){if(l){b.push(w);return}(!v.send(w,g=>{if(g&&console.error(g),l=!1,b.length>0){const u=b.slice(0);b=[],u.forEach(c=>p(c))}})||R.$i)&&(l=!0)};return{send:p}}e.$Rl=h;var y;(function(v){async function b(l,p,w){if(P.$ic(l))return l;if(p===void 0&&(p=s.cwd()),P.$mc(l)!=="."||(w===void 0&&A.$Ff(s.env.PATH)&&(w=s.env.PATH.split(P.$tc)),w===void 0||w.length===0))return P.$jc(p,l);async function g(u){if(await E.Promises.exists(u)){let c;try{c=await E.Promises.stat(u)}catch(S){S.message.startsWith("EACCES")&&(c=await E.Promises.lstat(u))}return c?!c.isDirectory():!1}return!1}for(const u of w){let c;if(P.$ic(u)?c=P.$jc(u,l):c=P.$jc(p,u,l),await g(c))return c;let S=c+".com";if(await g(S)||(S=c+".exe",await g(S)))return S}return P.$jc(p,l)}v.findExecutable=b})(y||(e.win32=y={}))}),define(re[107],oe([0,1,48,13]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=void 0;function s(A){return new Promise((E,f)=>{let h;const y=new Map;function v(l,p,w,$,g){const u=y.get(p);if(l===A||u){const c={name:b(w),cmd:w,pid:l,ppid:p,load:$,mem:g};y.set(l,c),l===A&&(h=c),u&&(u.children||(u.children=[]),u.children.push(c),u.children.length>1&&(u.children=u.children.sort((S,d)=>S.pid-d.pid)))}}function b(l){const p=/--utility-sub-type=network/i,w=/--ms-enable-electron-run-as-node/i,$=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,c=/--type=([a-zA-Z-]+)/;if($.exec(l))return"electron-crash-reporter";if(g.exec(l))return"winpty-agent";if(u.exec(l))return"conpty-agent";let S=c.exec(l);if(S&&S.length===2)return S[1]==="renderer"?"window":S[1]==="utility"?p.exec(l)?"utility-network-service":"utility-process":S[1]==="extensionHost"?"extension-host":S[1];const d=/[a-zA-Z-]+\.js/g;let t="";do S=d.exec(l),S&&(t+=S+" ");while(S);return t&&l.indexOf("node ")<0&&l.indexOf("node.exe")<0?`electron-nodejs (${t})`:w.exec(l)?`electron-nodejs (${l})`:l}if(process.platform==="win32"){const l=p=>p.indexOf("\\\\?\\")===0||p.indexOf("\\??\\")===0?p.substring(4):p.indexOf('"\\\\?\\')===0||p.indexOf('"\\??\\')===0?'"'+p.substring(5):p;new Promise((p,w)=>{J(["@vscode/windows-process-tree"],p,w)}).then(p=>{p.getProcessList(A,w=>{if(!w){f(new Error(`Root process ${A} not found`));return}p.getProcessCpuUsage(w,$=>{const g=new Map;$.forEach(u=>{const c=l(u.commandLine||"");g.set(u.pid,{name:b(c),cmd:c,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),h=g.get(A),h?(g.forEach(u=>{const c=g.get(u.ppid);c&&(c.children||(c.children=[]),c.children.push(u))}),g.forEach(u=>{u.children&&(u.children=u.children.sort((c,S)=>c.pid-S.pid))}),E(h)):f(new Error(`Root process ${A} not found`))})},p.ProcessDataFlag.CommandLine|p.ProcessDataFlag.Memory)})}else{let l=function(){let p=[h];const w=[];for(;p.length;){const g=p.shift();g&&(w.push(g.pid),g.children&&(p=p.concat(g.children)))}let $=JSON.stringify(R.$lg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);$+=" "+w.join(" "),(0,P.exec)($,{},(g,u,c)=>{if(g||c)f(g||new Error(c.toString()));else{const S=u.toString().split(`
`);for(let d=0;d<w.length;d++){const t=y.get(w[d]);t.load=parseFloat(S[d])}if(!h){f(new Error(`Root process ${A} not found`));return}E(h)}})};(0,P.exec)("which ps",{},(p,w,$)=>{if(p||$)if(process.platform!=="linux")f(p||new Error($.toString()));else{const g=JSON.stringify(R.$lg.asFileUri("vs/base/node/ps.sh").fsPath);(0,P.exec)(g,{},(u,c,S)=>{u||S?f(u||new Error(S.toString())):(j(c,v),l())})}else{const g=w.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,P.exec)(`${g} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,S,d)=>{c||d&&!d.includes("screen size is bogus")?f(c||new Error(d.toString())):(j(S,v),process.platform==="linux"?l():h?E(h):f(new Error(`Root process ${A} not found`)))})}})}})}e.$Rr=s;function j(A,E){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,h=A.toString().split(`
`);for(const y of h){const v=f.exec(y.trim());v&&v.length===6&&E(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}}),define(re[108],oe([0,1,26,4,106,89]),function(J,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=void 0;async function A(v,b){return v===1?R.$i?y():j.$Ql(b):f(v,b)}e.$Sl=A;let E=null;function f(v,b){if(R.$k&&v===2||R.$j&&v===3)return"/bin/bash";if(!E){let l;if(R.$i)l="/bin/bash";else{if(l=b.SHELL,!l)try{l=(0,P.userInfo)().shell}catch{}l||(l="sh"),l==="/bin/false"&&(l="/bin/bash")}E=l}return E}let h=null;async function y(){return h||(h=(await(0,s.$Nl)()).exePath),h}});var Ee=this&&this.__decorate||function(J,e,P,R){var s=arguments.length,j=s<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,P):R,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(J,e,P,R);else for(var E=J.length-1;E>=0;E--)(A=J[E])&&(j=(s<3?A(j):s>3?A(e,P,j):A(e,P))||j);return s>3&&j&&Object.defineProperty(e,P,j),j};define(re[42],oe([0,1,23,8,18,22,50,14,3,2,77,25,12]),function(J,e,P,R,s,j,A,E,f,h,y,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.ProxyChannel=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.RequestInitiator=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=void 0;var l;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(l||(l={}));function p(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(w||(w={}));function $(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(g||(g={}));function u(H){let L=0;for(let T=0;;T+=7){const V=H.read(1);if(L|=(V.buffer[0]&127)<<T,!(V.buffer[0]&128))return L}}const c=r(0);function S(H,L){if(L===0){H.write(c);return}let T=0;for(let q=L;q!==0;q=q>>>7)T++;const V=s.$ge.alloc(T);for(let q=0;L!==0;q++)V.buffer[q]=L&127,L=L>>>7,L>0&&(V.buffer[q]|=128);H.write(V)}class d{constructor(L){this.b=L,this.a=0}read(L){const T=this.b.slice(this.a,this.a+L);return this.a+=T.byteLength,T}}e.$Ah=d;class t{constructor(){this.a=[]}get buffer(){return s.$ge.concat(this.a)}write(L){this.a.push(L)}}e.$Bh=t;var o;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(o||(o={}));function r(H){const L=s.$ge.alloc(1);return L.writeUInt8(H,0),L}const i={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object),Uint:r(o.Int)},n=typeof Buffer<"u";function a(H,L){if(typeof L>"u")H.write(i.Undefined);else if(typeof L=="string"){const T=s.$ge.fromString(L);H.write(i.String),S(H,T.byteLength),H.write(T)}else if(n&&Buffer.isBuffer(L)){const T=s.$ge.wrap(L);H.write(i.Buffer),S(H,T.byteLength),H.write(T)}else if(L instanceof s.$ge)H.write(i.VSBuffer),S(H,L.byteLength),H.write(L);else if(Array.isArray(L)){H.write(i.Array),S(H,L.length);for(const T of L)a(H,T)}else if(typeof L=="number"&&(L|0)===L)H.write(i.Uint),S(H,L);else{const T=s.$ge.fromString(JSON.stringify(L));H.write(i.Object),S(H,T.byteLength),H.write(T)}}e.$Ch=a;function m(H){switch(H.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return H.read(u(H)).toString();case o.Buffer:return H.read(u(H)).buffer;case o.VSBuffer:return H.read(u(H));case o.Array:{const T=u(H),V=[];for(let q=0;q<T;q++)V.push(m(H));return V}case o.Object:return JSON.parse(H.read(u(H)).toString());case o.Int:return u(H)}}e.$Dh=m;class D{constructor(L,T,V=null,q=1e3){this.h=L,this.j=T,this.k=V,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:200})}registerChannel(L,T){this.b.set(L,T),setTimeout(()=>this.w(L),0)}m(L){switch(L.type){case 200:{const T=this.o([L.type]);this.k?.logOutgoing(T,0,1,$(L.type));return}case 201:case 202:case 204:case 203:{const T=this.o([L.type,L.id],L.data);this.k?.logOutgoing(T,L.id,1,$(L.type),L.data);return}}}o(L,T=void 0){const V=new t;return a(V,L),a(V,T),this.p(V.buffer)}p(L){try{return this.h.send(L),L.byteLength}catch{return 0}}q(L){const T=new d(L),V=m(T),q=m(T),te=V[0];switch(te){case 100:return this.k?.logIncoming(L.byteLength,V[1],1,`${p(te)}: ${V[2]}.${V[3]}`,q),this.s({type:te,id:V[1],channelName:V[2],name:V[3],arg:q});case 102:return this.k?.logIncoming(L.byteLength,V[1],1,`${p(te)}: ${V[2]}.${V[3]}`,q),this.t({type:te,id:V[1],channelName:V[2],name:V[3],arg:q});case 101:return this.k?.logIncoming(L.byteLength,V[1],1,`${p(te)}`),this.u({type:te,id:V[1]});case 103:return this.k?.logIncoming(L.byteLength,V[1],1,`${p(te)}`),this.u({type:te,id:V[1]})}}s(L){const T=this.b.get(L.channelName);if(!T){this.v(L);return}const V=new j.$3d;let q;try{q=T.call(this.j,L.name,L.arg,V.token)}catch(G){q=Promise.reject(G)}const te=L.id;q.then(G=>{this.m({id:te,data:G,type:201})},G=>{G instanceof Error?this.m({id:te,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.m({id:te,data:G,type:203})}).finally(()=>{he.dispose(),this.d.delete(L.id)});const he=(0,h.$Qc)(()=>V.cancel());this.d.set(L.id,he)}t(L){const T=this.b.get(L.channelName);if(!T){this.v(L);return}const V=L.id,te=T.listen(this.j,L.name,L.arg)(he=>this.m({id:V,data:he,type:204}));this.d.set(L.id,te)}u(L){const T=this.d.get(L.id);T&&(T.dispose(),this.d.delete(L.id))}v(L){let T=this.g.get(L.channelName);T||(T=[],this.g.set(L.channelName,T));const V=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.m({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);T.push({request:L,timeoutTimer:V})}w(L){const T=this.g.get(L);if(T){for(const V of T)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.s(V.request);break;case 102:this.t(V.request);break}this.g.delete(L)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,h.$Nc)(this.d.values()),this.d.clear()}}e.$Eh=D;var I;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class k{constructor(L,T=null){this.l=L,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.$Sd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(V=>this.s(V)),this.j=T}getChannel(L){const T=this;return{call(V,q,te){return T.a?Promise.reject(new E.$5):T.m(L,V,q,te)},listen(V,q){return T.a?f.Event.None:T.o(L,V,q)}}}m(L,T,V,q=j.CancellationToken.None){const te=this.g++,G={id:te,type:100,channelName:L,name:T,arg:V};if(q.isCancellationRequested)return Promise.reject(new E.$5);let O;return new Promise((x,z)=>{if(q.isCancellationRequested)return z(new E.$5);const Y=()=>{const ae=se=>{switch(se.type){case 201:this.f.delete(te),x(se.data);break;case 202:{this.f.delete(te);const $e=new Error(se.data.message);$e.stack=Array.isArray(se.data.stack)?se.data.stack.join(`
`):se.data.stack,$e.name=se.data.name,z($e);break}case 203:this.f.delete(te),z(se.data);break}};this.f.set(te,ae),this.p(G)};let W=null;this.b===g.Idle?Y():(W=(0,R.$Qg)(ae=>this.u()),W.then(()=>{W=null,Y()}));const B=()=>{W?(W.cancel(),W=null):this.p({id:te,type:101}),z(new E.$5)},_=q.onCancellationRequested(B);O=(0,h.$Pc)((0,h.$Qc)(B),_),this.d.add(O)}).finally(()=>{O.dispose(),this.d.delete(O)})}o(L,T,V){const q=this.g++,he={id:q,type:102,channelName:L,name:T,arg:V};let G=null;const O=new f.$Sd({onWillAddFirstListener:()=>{G=(0,R.$Qg)(x=>this.u()),G.then(()=>{G=null,this.d.add(O),this.p(he)})},onDidRemoveLastListener:()=>{G?(G.cancel(),G=null):(this.d.delete(O),this.p({id:q,type:103}))}}),U=x=>O.fire(x.data);return this.f.set(q,U),O.event}p(L){switch(L.type){case 100:case 102:{const T=this.q([L.type,L.id,L.channelName,L.name],L.arg);this.j?.logOutgoing(T,L.id,0,`${p(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const T=this.q([L.type,L.id]);this.j?.logOutgoing(T,L.id,0,p(L.type));return}}}q(L,T=void 0){const V=new t;return a(V,L),a(V,T),this.r(V.buffer)}r(L){try{return this.l.send(L),L.byteLength}catch{return 0}}s(L){const T=new d(L),V=m(T),q=m(T),te=V[0];switch(te){case 200:return this.j?.logIncoming(L.byteLength,0,0,$(te)),this.t({type:V[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(L.byteLength,V[1],0,$(te),q),this.t({type:V[0],id:V[1],data:q})}}t(L){if(L.type===200){this.b=g.Idle,this.k.fire();return}this.f.get(L.id)?.(L)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,h.$Nc)(this.d.values()),this.d.clear()}}e.$Fh=k,Ee([A.$uh],k.prototype,"onDidInitializePromise",null);class C{get connections(){const L=[];return this.f.forEach(T=>L.push(T)),L}constructor(L){this.a=new Map,this.f=new Set,this.g=new f.$Sd,this.onDidAddConnection=this.g.event,this.h=new f.$Sd,this.onDidRemoveConnection=this.h.event,this.j=new h.$Rc,this.j.add(L(({protocol:T,onDidClientDisconnect:V})=>{const q=f.Event.once(T.onMessage);this.j.add(q(te=>{const he=new d(te),G=m(he),O=new D(T,G),U=new k(T);this.a.forEach((z,Y)=>O.registerChannel(Y,z));const x={channelServer:O,channelClient:U,ctx:G};this.f.add(x),this.g.fire(x),this.j.add(V(()=>{O.dispose(),U.dispose(),this.f.delete(x),this.h.fire(x)}))}))}))}getChannel(L,T){const V=this;return{call(q,te,he){let G;if((0,b.$Tf)(T)){const U=(0,P.$4b)(V.connections.filter(T));G=U?Promise.resolve(U):f.Event.toPromise(f.Event.filter(V.onDidAddConnection,T))}else G=T.routeCall(V,q,te);const O=G.then(U=>U.channelClient.getChannel(L));return F(O).call(q,te,he)},listen(q,te){if((0,b.$Tf)(T))return V.k(L,T,q,te);const he=T.routeEvent(V,q,te).then(G=>G.channelClient.getChannel(L));return F(he).listen(q,te)}}}k(L,T,V,q){const te=this;let he;const G=new f.$Sd({onWillAddFirstListener:()=>{he=new h.$Rc;const O=new f.$Yd,U=new Map,x=Y=>{const B=Y.channelClient.getChannel(L).listen(V,q),_=O.add(B);U.set(Y,_)},z=Y=>{const W=U.get(Y);W&&(W.dispose(),U.delete(Y))};te.connections.filter(T).forEach(x),f.Event.filter(te.onDidAddConnection,T)(x,void 0,he),te.onDidRemoveConnection(z,void 0,he),O.event(G.fire,G,he),he.add(O)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return G.event}registerChannel(L,T){this.a.set(L,T);for(const V of this.f)V.channelServer.registerChannel(L,T)}dispose(){this.j.dispose();for(const L of this.f)L.channelClient.dispose(),L.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Gh=C;class M{constructor(L,T,V=null){const q=new t;a(q,T),L.send(q.buffer),this.a=new k(L,V),this.d=new D(L,T,V)}getChannel(L){return this.a.getChannel(L)}registerChannel(L,T){this.d.registerChannel(L,T)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Hh=M;function F(H){return{call(L,T,V){return H.then(q=>q.call(L,T,V))},listen(L,T){const V=new f.$2d;return H.then(q=>V.input=q.listen(L,T)),V.event}}}e.$Ih=F;function N(H){let L=!1;return{call(T,V,q){return L?H.call(T,V,q):(0,R.$4g)(0).then(()=>L=!0).then(()=>H.call(T,V,q))},listen(T,V){if(L)return H.listen(T,V);const q=new f.$2d;return(0,R.$4g)(0).then(()=>L=!0).then(()=>q.input=H.listen(T,V)),q.event}}}e.$Jh=N;class Z{constructor(L){this.a=L}routeCall(L){return this.b(L)}routeEvent(L){return this.b(L)}async b(L){for(const T of L.connections)if(await Promise.resolve(this.a(T.ctx)))return Promise.resolve(T);return await f.Event.toPromise(L.onDidAddConnection),await this.b(L)}}e.$Kh=Z;var Q;(function(H){function L(te,he,G){const O=te,U=G&&G.disableMarshalling,x=new Map;for(const z in O)V(z)&&x.set(z,f.Event.buffer(O[z],!0,void 0,he));return new class{listen(z,Y,W){const B=x.get(Y);if(B)return B;if(q(Y)){const _=O[Y];if(typeof _=="function")return _.call(O,W)}throw new E.$bb(`Event not found: ${Y}`)}call(z,Y,W){const B=O[Y];if(typeof B=="function"){if(!U&&Array.isArray(W))for(let ae=0;ae<W.length;ae++)W[ae]=(0,y.$zh)(W[ae]);let _=B.apply(O,W);return _ instanceof Promise||(_=Promise.resolve(_)),_}throw new E.$bb(`Method not found: ${Y}`)}}}H.fromService=L;function T(te,he){const G=he&&he.disableMarshalling;return new Proxy({},{get(O,U){if(typeof U=="string")return he?.properties?.has(U)?he.properties.get(U):q(U)?function(x){return te.listen(U,x)}:V(U)?te.listen(U):async function(...x){let z;he&&!(0,b.$Of)(he.context)?z=[he.context,...x]:z=x;const Y=await te.call(U,z);return G?Y:(0,y.$zh)(Y)};throw new E.$bb(`Property not found: ${String(U)}`)}})}H.toService=T;function V(te){return te[0]==="o"&&te[1]==="n"&&v.$8e(te.charCodeAt(2))}function q(te){return/^onDynamic/.test(te)&&v.$8e(te.charCodeAt(9))}})(Q||(e.ProxyChannel=Q={}));const le=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const L=H.toString();if(L!=="[object Object]")return L}return H}function ue(H){return Array.isArray(H)?H.map(ce):ce(H)}function X(H,L,T,V,q,te,he){he=ue(he);const G=le[q],O=G[V%G.length];let U=[`%c[${H}]%c[${String(L).padStart(7," ")}]%c[len: ${String(T).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(te)?(U=U.concat(he),U.push(")")):U.push(he),console.log.apply(console,U)}class K{constructor(L,T){this.d=L,this.f=T,this.a=0,this.b=0}logOutgoing(L,T,V,q,te){this.b+=L,X(this.d,this.b,L,T,V,q,te)}logIncoming(L,T,V,q,te){this.a+=L,X(this.f,this.a,L,T,V,q,te)}}e.$Lh=K}),define(re[157],oe([0,1,18,3,42]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nU=e.$mU=void 0;class j{constructor(f){this.a=f,this.onMessage=R.Event.fromDOMEventEmitter(this.a,"message",h=>P.$ge.wrap(h.data)),f.start()}send(f){this.a.postMessage(f.buffer)}disconnect(){this.a.close()}}e.$mU=j;class A extends s.$Hh{constructor(f,h){const y=new j(f);super(y,h),this.b=y}dispose(){this.b.disconnect(),super.dispose()}}e.$nU=A}),define(re[109],oe([0,1,18,3,2,42]),function(J,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.ProtocolConstants=e.$Mh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var E;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let a=0;function m(I,k){if(!n.has(I)){const C=String(++a);n.set(I,C)}return n.get(I)}function D(I,k,C,M){if(!i.enableDiagnostics)return;const F=m(I,k);if(M instanceof P.$ge||M instanceof Uint8Array||M instanceof ArrayBuffer||ArrayBuffer.isView(M)){const N=P.$ge.alloc(M.byteLength);N.set(M),i.records.push({timestamp:Date.now(),id:F,label:k,type:C,buff:N})}else i.records.push({timestamp:Date.now(),id:F,label:k,type:C,data:M})}i.traceSocketEvent=D})(E||(e.SocketDiagnostics=E={}));var f;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f||(e.SocketCloseEventType=f={}));let h=null;function y(){return h||(h=P.$ge.alloc(0)),h}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,a){if(n===0)return y();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const k=this.a[0];return a&&(this.a.shift(),this.b-=n),k}if(this.a[0].byteLength>n){const k=this.a[0].slice(0,n);return a&&(this.a[0]=this.a[0].slice(n),this.b-=n),k}const m=P.$ge.alloc(n);let D=0,I=0;for(;n>0;){const k=this.a[I];if(k.byteLength>n){const C=k.slice(0,n);m.set(C,D),D+=n,a&&(this.a[I]=k.slice(n),this.b-=n),n-=n}else m.set(k,D),D+=k.byteLength,a?(this.a.shift(),this.b-=k.byteLength):I++,n-=k.byteLength}return m}}e.$Mh=v;var b;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(b||(b={}));function l(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var p;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(p||(e.ProtocolConstants=p={}));class w{constructor(n,a,m,D){this.type=n,this.id=a,this.ack=m,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class $ extends s.$Sc{constructor(n){super(),this.f=this.B(new R.$Sd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new v,this.B(this.a.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const a=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=a.readUInt32BE(9),this.g.messageType=a.readUInt8(0),this.g.id=a.readUInt32BE(1),this.g.ack=a.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:l(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const m=this.g.messageType,D=this.g.id,I=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",a),this.f.fire(new w(m,D,I,a)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=P.$ge.alloc(13);a.writeUInt8(n.type,0),a.writeUInt32BE(n.id,1),a.writeUInt32BE(n.ack,5),a.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:l(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(a,n.data)}g(n,a){const m=this.f===0;return this.d.push(n,a),this.f+=n.byteLength+a.byteLength,m}h(){const n=P.$ge.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,a){this.g(n,a)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class u extends s.$Sc{constructor(n){super(),this.f=new R.$Sd,this.onMessage=this.f.event,this.g=new R.$Sd,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new g(this.a)),this.c=this.B(new $(this.a)),this.B(this.c.onMessage(a=>{a.type===1&&this.f.fire(a.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new w(1,0,0,n))}}e.$Nh=u;class c extends j.$Hh{static fromSocket(n,a){return new c(new u(n),a)}get onDidDispose(){return this.b.onDidDispose}constructor(n,a,m=null){super(n,a,m),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$Oh=c;class S{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new R.$Sd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$Ph=S;class d{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,a=this.a;for(;a;)a=a.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let a=0,m=this.a;for(;m;)n[a++]=m.data,m=m.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const a=new d(n);if(!this.a){this.a=a,this.b=a;return}this.b.next=a,this.b=a}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const n=Date.now();for(let a=0;a<o.a;a++)this.c[a]=n-1e3*a;setInterval(()=>{for(let a=o.a;a>=1;a--)this.c[a]=this.c[a-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),a=(1+o.a)*1e3;let m=0;for(let D=0;D<o.a;D++)n-this.c[D]<=a&&m++;return 1-m/o.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new S,this.onControlMessage=this.u.event,this.v=new S,this.onMessage=this.v.event,this.w=new S,this.onDidDispose=this.w.event,this.x=new S,this.onSocketClose=this.x.event,this.y=new S,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??o.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$Rc,this.o=n.socket,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new $(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new w(5,0,0,y());this.p.write(n),this.p.flush()}sendPause(){const n=new w(7,0,0,y());this.p.write(n)}sendResume(){const n=new w(8,0,0,y());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,a){this.a=!0,this.r.dispose(),this.r=new s.$Rc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new $(this.o)),this.r.add(this.q.onMessage(m=>this.z(m))),this.r.add(this.o.onClose(m=>this.x.fire(m))),this.q.acceptChunk(a)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new w(3,0,this.h,y());this.p.write(n);const a=this.b.toArray();for(let m=0,D=a.length;m<D;m++)this.p.write(a[m]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const a=this.b.peek();if(a&&a.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const a=Date.now();a-this.m>1e4&&(this.m=a,this.p.write(new w(6,0,0,y())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const a=this.b.toArray();for(let m=0,D=a.length;m<D;m++)this.p.write(a[m]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const a=++this.c;this.h=this.g;const m=new w(1,a,this.h,n);this.b.push(m),this.a||(this.p.write(m),this.B())}sendControl(n){const a=new w(2,0,0,n);this.p.write(a)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),a=Date.now()-n.writtenTime,m=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(a>=2e4&&m>=2e4&&D>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:m});return}const I=Math.max(2e4-a,2e4-m,2e4-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},I)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new w(3,0,this.h,y());this.p.write(n)}D(){this.h=this.g;const n=new w(9,0,this.h,y());this.p.write(n)}}e.$Qh=r}),define(re[36],oe([0,1,15,14,13]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jU=void 0;class j{constructor(){this.a=new WeakMap}on(E,f){const h=(y,...v)=>{this.b(E,y)&&f(y,...v)};return this.a.set(f,h),P.ipcMain.on(E,h),this}once(E,f){return P.ipcMain.once(E,(h,...y)=>{this.b(E,h)&&f(h,...y)}),this}handle(E,f){return P.ipcMain.handle(E,(h,...y)=>this.b(E,h)?f(h,...y):Promise.reject(`Invalid channel '${E}' or sender for ipcMain.handle() usage.`)),this}removeHandler(E){return P.ipcMain.removeHandler(E),this}removeListener(E,f){const h=this.a.get(f);return h&&(P.ipcMain.removeListener(E,h),this.a.delete(f)),this}b(E,f){if(!E||!E.startsWith("vscode:"))return(0,R.$1)(`Refused to handle ipcMain event for channel '${E}' because the channel is unknown.`),!1;const h=f.senderFrame,y=h.url;if(!y||y==="about:blank")return!0;let v="unknown";try{v=new URL(y).host}catch{return(0,R.$1)(`Refused to handle ipcMain event for channel '${E}' because of a malformed URL '${y}'.`),!1}return v!==s.$kg?((0,R.$1)(`Refused to handle ipcMain event for channel '${E}' because of a bad origin of '${v}'.`),!1):h.parent!==null?((0,R.$1)(`Refused to handle ipcMain event for channel '${E}' because sender of origin '${v}' is not a main frame.`),!1):!0}}e.$jU=new j}),define(re[158],oe([0,1,15,36,146]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kU=void 0;function j(){R.$jU.on(s.$hU,(E,f,h,y,v)=>{const b=A(E,y,h);b.popup({x:v?v.x:void 0,y:v?v.y:void 0,positioningItem:v?v.positioningItem:void 0,callback:()=>{b&&E.sender.send(s.$iU,f)}})})}e.$kU=j;function A(E,f,h){const y=new P.Menu;return h.forEach(v=>{let b;v.type==="separator"?b=new P.MenuItem({type:v.type}):Array.isArray(v.submenu)?b=new P.MenuItem({submenu:A(E,f,v.submenu),label:v.label}):b=new P.MenuItem({label:v.label,type:v.type,accelerator:v.accelerator,checked:v.checked,enabled:v.enabled,visible:v.visible,click:(l,p,w)=>E.sender.send(f,v.id,w)}),y.append(b)}),y}}),define(re[159],oe([0,1,36,18,3,2,42,147]),function(J,e,P,R,s,j,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qU=void 0;function f(y,v){const b=s.Event.fromNodeEventEmitter(P.$jU,v,(p,w)=>({event:p,message:w})),l=s.Event.filter(b,({event:p})=>p.sender.id===y);return s.Event.map(l,({message:p})=>p&&R.$ge.wrap(p))}class h extends A.$Gh{static{this.b=new Map}static d(){const v=s.Event.fromNodeEventEmitter(P.$jU,"vscode:hello",({sender:b})=>b);return s.Event.map(v,b=>{const l=b.id;h.b.get(l)?.dispose();const w=new s.$Sd;h.b.set(l,(0,j.$Qc)(()=>w.fire()));const $=f(l,"vscode:message"),g=s.Event.any(s.Event.signal(f(l,"vscode:disconnect")),w.event);return{protocol:new E.$pU(b,$),onDidClientDisconnect:g}})}constructor(){super(h.d())}}e.$qU=h}),define(re[110],oe([0,1,36,3,32,157]),function(J,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sU=e.$rU=void 0;class A extends j.$nU{constructor(h,y){super({addEventListener:(v,b)=>h.addListener(v,b),removeEventListener:(v,b)=>h.removeListener(v,b),postMessage:v=>h.postMessage(v),start:()=>h.start(),close:()=>h.close()},y)}}e.$rU=A;async function E(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const h=(0,s.$ng)();f.webContents.send("vscode:createMessageChannel",h);const y=R.Event.fromNodeEventEmitter(P.$jU,"vscode:createMessageChannelResult",(b,l)=>({nonce:l,port:b.ports[0]})),{port:v}=await R.Event.toPromise(R.Event.once(R.Event.filter(y,b=>b.nonce===h)));return v}e.$sU=E}),define(re[160],oe([0,1,48,8,18,22,154,14,3,2,38,89,76,42]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=void 0;class p extends l.$Eh{constructor(g){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",u=>s.$ge.wrap(Buffer.from(u,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.$eq=p;class w{constructor(g,u){this.i=g,this.j=u,this.c=new Set,this.g=new Map,this.h=new f.$Sd,this.onDidProcessExit=this.h.event;const c=u&&u.timeout?u.timeout:6e4;this.b=new R.$Zg(c),this.d=null,this.f=null}getChannel(g){const u=this;return{call(c,S,d){return u.k(g,c,S,d)},listen(c,S){return u.l(g,c,S)}}}k(g,u,c,S=j.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(S.isCancellationRequested)return Promise.reject(E.$6());this.b.cancel();const d=this.n(g),t=(0,R.$Qg)(i=>d.call(u,c,i)),o=S.onCancellationRequested(()=>t.cancel()),r=(0,h.$Qc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{o.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(g,u,c){if(!this.b)return f.Event.None;this.b.cancel();let S;const d=new f.$Sd({onWillAddFirstListener:()=>{S=this.n(g).listen(u,c)(d.fire,d),this.c.add(S)},onDidRemoveLastListener:()=>{this.c.delete(S),S.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return d.event}get m(){if(!this.f){const g=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,y.$jn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,b.$Pl)(u.env),this.d=(0,P.fork)(this.i,g,u);const c=new f.$Sd;f.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,A.$aq)(n)){(0,A.log)(n,`IPC Library: ${this.j.serverName}`);return}c.fire(s.$ge.wrap(Buffer.from(n,"base64")))});const d=this.j.useQueue?(0,v.$Rl)(this.d):this.d,t=n=>this.d&&this.d.connected&&d.send(n.buffer.toString("base64")),o=c.event,r={send:t,onMessage:o};this.f=new l.$Fh(r);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,a)=>{process.removeListener("exit",i),this.c.forEach(m=>(0,h.$Nc)(m)),this.c.clear(),n!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:a})})}return this.f}n(g){let u=this.g.get(g);return u||(u=this.m.getChannel(g),this.g.set(g,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$fq=w}),define(re[111],oe([0,1,8,3,2,77,12]),function(J,e,P,R,s,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.StorageState=e.$dp=e.StorageHint=void 0;var E;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(E||(e.StorageHint=E={}));function f(b){const l=b;return l?.changed instanceof Map||l?.deleted instanceof Set}e.$dp=f;var h;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(h||(e.StorageState=h={}));class y extends s.$Sc{static{this.a=100}constructor(l,p=Object.create(null)){super(),this.r=l,this.s=p,this.b=this.B(new R.$Vd),this.onDidChangeStorage=this.b.event,this.c=h.None,this.f=new Map,this.g=this.B(new P.$1g(y.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(l=>this.u(l)))}u(l){this.b.pause();try{l.changed?.forEach((p,w)=>this.w(w,p)),l.deleted?.forEach(p=>this.w(p,void 0))}finally{this.b.resume()}}w(l,p){if(this.c===h.Closed)return;let w=!1;(0,A.$Of)(p)?w=this.f.delete(l):this.f.get(l)!==p&&(this.f.set(l,p),w=!0),w&&this.b.fire({key:l,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===h.None&&(this.c=h.Initialized,this.s.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(l,p){const w=this.f.get(l);return(0,A.$Of)(w)?p:w}getBoolean(l,p){const w=this.get(l);return(0,A.$Of)(w)?p:w==="true"}getNumber(l,p){const w=this.get(l);return(0,A.$Of)(w)?p:parseInt(w,10)}getObject(l,p){const w=this.get(l);return(0,A.$Of)(w)?p:(0,j.$yh)(w)}async set(l,p,w=!1){if(this.c===h.Closed)return;if((0,A.$Of)(p))return this.delete(l,w);const $=(0,A.$Hf)(p)||Array.isArray(p)?(0,j.$xh)(p):String(p);if(this.f.get(l)!==$)return this.f.set(l,$),this.j.set(l,$),this.h.delete(l),this.b.fire({key:l,external:w}),this.D()}async delete(l,p=!1){if(!(this.c===h.Closed||!this.f.delete(l)))return this.h.has(l)||this.h.add(l),this.j.delete(l),this.b.fire({key:l,external:p}),this.D()}async optimize(){if(this.c!==h.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=h.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const l={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(l).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(l){if(this.z)return this.D(l)}async D(l){return this.s.hint===E.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),l)}async whenFlushed(){if(this.z)return new Promise(l=>this.n.push(l))}isInMemory(){return this.s.hint===E.STORAGE_IN_MEMORY}}e.$ep=y;class v{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(l){l.insert?.forEach((p,w)=>this.a.set(w,p)),l.delete?.forEach(p=>this.a.delete(p))}async optimize(){}async close(){}}e.$fp=v}),define(re[161],oe([0,1,8,3,31,9,21]),function(J,e,P,R,s,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OU=void 0;class E{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return R.Event.None}static{this.a=2e3}static{this.b=256}constructor(y,v=Object.create(null)){this.g=y,this.h=v,this.c=(0,j.$nc)(this.g),this.d=new f(this.h.logging),this.f=this.n(this.g)}async getItems(){const y=await this.f,v=new Map;return(await this.s(y,"SELECT * FROM ItemTable")).forEach(l=>v.set(l.key,l.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${v.size} rows`),v}async updateItems(y){const v=await this.f;return this.j(v,y)}j(y,v){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${v.insert?(0,s.$yc)(v.insert):"0"}), delete(${v.delete?(0,s.$zc)(v.delete):"0"})`),this.t(y,()=>{const b=v.insert,l=v.delete;if(b&&b.size>0){const p=[];p.push([]);let w=0;b.forEach(($,g)=>{let u=p[w];u.length>E.b&&(w++,u=[],p.push(u)),u.push(g,$)}),p.forEach($=>{this.u(y,`INSERT INTO ItemTable VALUES ${new Array($.length/2).fill("(?,?)").join(",")}`,g=>g.run($),()=>{const g=[];let u=0;return b.forEach((c,S)=>{g.push(S),u+=c.length}),`Keys: ${g.join(", ")} Length: ${u}`})})}if(l&&l.size){const p=[];p.push([]);let w=0;l.forEach($=>{let g=p[w];g.length>E.b&&(w++,g=[],p.push(g)),g.push($)}),p.forEach($=>{this.u(y,`DELETE FROM ItemTable WHERE key IN (${new Array($.length).fill("?").join(",")})`,g=>g.run($),()=>{const g=[];return l.forEach(u=>{g.push(u)}),`Keys: ${g.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const y=await this.f;return this.q(y,"VACUUM")}async close(y){this.d.trace(`[storage ${this.c}] close()`);const v=await this.f;return this.k(v,y)}k(y,v){return new Promise((b,l)=>{y.db.close(p=>(p&&this.o(y,`[storage ${this.c}] close(): ${p}`),this.g===E.IN_MEMORY_PATH?b():!y.isErroneous&&!y.isInMemory?this.l().then(b,w=>(this.d.error(`[storage ${this.c}] backup(): ${w}`),b())):typeof v=="function"?A.Promises.unlink(this.g).then(()=>this.p(this.g).then(w=>{const $=()=>this.k(w,void 0);return this.j(w,{insert:v()}).then(()=>$(),g=>($(),Promise.reject(g)))})).then(b,l):l(p||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const y=this.m(this.g);return A.Promises.copy(this.g,y,{preserveSymlinks:!1})}m(y){return`${y}.backup`}async checkIntegrity(y){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${y})`);const v=await this.f,b=await this.r(v,y?"PRAGMA integrity_check":"PRAGMA quick_check"),l=y?b.integrity_check:b.quick_check;return v.isErroneous?`${l} (last error: ${v.lastError})`:v.isInMemory?`${l} (in-memory!)`:l}async n(y,v=!0){this.d.trace(`[storage ${this.c}] open(${y}, retryOnBusy: ${v})`);try{return await this.p(y)}catch(b){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${b}`),b.code==="SQLITE_BUSY"&&v)return await(0,P.$4g)(E.a),this.n(y,!1);try{await A.Promises.unlink(y);try{await A.Promises.rename(this.m(y),y,!1)}catch{}return await this.p(y)}catch(l){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${l}`),this.p(E.IN_MEMORY_PATH)}}}o(y,v){y.isErroneous=!0,y.lastError=v,this.d.error(v)}p(y){return new Promise((v,b)=>{new Promise((l,p)=>{J(["@vscode/sqlite3"],l,p)}).then(l=>{const p={db:new(this.d.isTracing?l.verbose().Database:l.Database)(y,w=>w?p.db&&w.code!=="SQLITE_CANTOPEN"?p.db.close(()=>b(w)):b(w):this.q(p,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>v(p),$=>p.db.close(()=>b($)))),isInMemory:y===E.IN_MEMORY_PATH};p.db.on("error",w=>this.o(p,`[storage ${this.c}] Error (event): ${w}`)),this.d.isTracing&&p.db.on("trace",w=>this.d.trace(`[storage ${this.c}] Trace (event): ${w}`))},b)})}q(y,v){return new Promise((b,l)=>{y.db.exec(v,p=>p?(this.o(y,`[storage ${this.c}] exec(): ${p}`),l(p)):b())})}r(y,v){return new Promise((b,l)=>{y.db.get(v,(p,w)=>p?(this.o(y,`[storage ${this.c}] get(): ${p}`),l(p)):b(w))})}s(y,v){return new Promise((b,l)=>{y.db.all(v,(p,w)=>p?(this.o(y,`[storage ${this.c}] all(): ${p}`),l(p)):b(w))})}t(y,v){return new Promise((b,l)=>{y.db.serialize(()=>{y.db.run("BEGIN TRANSACTION"),v(),y.db.run("END TRANSACTION",p=>p?(this.o(y,`[storage ${this.c}] transaction(): ${p}`),l(p)):b())})})}u(y,v,b,l){const p=y.db.prepare(v),w=$=>{this.o(y,`[storage ${this.c}] prepare(): ${$} (${v}). Details: ${l()}`)};p.on("error",w),b(p),p.finalize($=>{$&&w($),p.removeListener("error",w)})}}e.$OU=E;class f{static{this.a="VSCODE_TRACE_STORAGE"}constructor(y){y&&typeof y.logTrace=="function"&&process.env[f.a]&&(this.b=y.logTrace),y&&typeof y.logError=="function"&&(this.c=y.logError)}get isTracing(){return!!this.b}trace(y){this.b?.(y)}error(y){this.c?.(y)}}}),define(re[162],oe([11,10]),function(J,e){return J.create("vs/code/electron-main/app",e)}),define(re[163],oe([11,10]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[164],oe([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(re[165],oe([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(re[166],oe([11,10]),function(J,e){return J.create("vs/platform/dialogs/common/dialogs",e)}),define(re[167],oe([11,10]),function(J,e){return J.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(re[168],oe([11,10]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(re[169],oe([11,10]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(re[170],oe([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[171],oe([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(re[172],oe([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[173],oe([11,10]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[174],oe([11,10]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(re[175],oe([11,10]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(re[176],oe([11,10]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(re[177],oe([11,10]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(re[178],oe([11,10]),function(J,e){return J.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(re[179],oe([11,10]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[180],oe([11,10]),function(J,e){return J.create("vs/platform/issue/electron-main/issueMainService",e)}),define(re[181],oe([11,10]),function(J,e){return J.create("vs/platform/menubar/electron-main/menubar",e)}),define(re[182],oe([11,10]),function(J,e){return J.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(re[183],oe([11,10]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(re[184],oe([11,10]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(re[185],oe([11,10]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[186],oe([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(re[187],oe([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalProfiles",e)}),define(re[188],oe([11,10]),function(J,e){return J.create("vs/platform/update/common/update.config.contribution",e)}),define(re[189],oe([11,10]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[190],oe([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowImpl",e)}),define(re[191],oe([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(re[192],oe([11,10]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(re[193],oe([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(re[194],oe([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(re[195],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcb=e.$ecb=void 0;function P(s){return s&&s.hasOwnProperty("folderUri")}e.$ecb=P;function R(s){return s&&s.hasOwnProperty("workspace")}e.$fcb=R}),define(re[196],oe([0,1,7]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w9b=e.$v9b=e.$u9b=void 0;function R(A){return typeof A?.backupFolder=="string"}e.$u9b=R;function s(A){let E=[];try{Array.isArray(A.workspaces)&&(E=A.workspaces.map(f=>({workspace:{id:f.id,configPath:P.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}return E}e.$v9b=s;function j(A){let E=[];try{Array.isArray(A.folders)&&(E=A.folders.map(f=>({folderUri:P.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})))}catch{}return E}e.$w9b=j}),define(re[197],oe([0,1,14,165]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xi=e.TokenType=void 0;var s;(function(h){h[h.LParen=0]="LParen",h[h.RParen=1]="RParen",h[h.Neg=2]="Neg",h[h.Eq=3]="Eq",h[h.NotEq=4]="NotEq",h[h.Lt=5]="Lt",h[h.LtEq=6]="LtEq",h[h.Gt=7]="Gt",h[h.GtEq=8]="GtEq",h[h.RegexOp=9]="RegexOp",h[h.RegexStr=10]="RegexStr",h[h.True=11]="True",h[h.False=12]="False",h[h.In=13]="In",h[h.Not=14]="Not",h[h.And=15]="And",h[h.Or=16]="Or",h[h.Str=17]="Str",h[h.QuotedStr=18]="QuotedStr",h[h.Error=19]="Error",h[h.EOF=20]="EOF"})(s||(e.TokenType=s={}));function j(...h){switch(h.length){case 1:return(0,R.localize)(0,null,h[0]);case 2:return(0,R.localize)(1,null,h[0],h[1]);case 3:return(0,R.localize)(2,null,h[0],h[1],h[2]);default:return}}const A=(0,R.localize)(3,null),E=(0,R.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return y.isTripleEq?"===":"==";case 4:return y.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return y.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return y.lexeme;case 18:return y.lexeme;case 19:return y.lexeme;case 20:return"EOF";default:throw(0,P.$8)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const v=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:v})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const v=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:v})}else this.h(126)?this.k(9):this.l(j("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(j("&&"));break;case 124:this.h(124)?this.k(16):this.l(j("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const v=this.d,b=this.c.substring(this.d,this.e),l={type:19,offset:this.d,lexeme:b};this.g.push({offset:v,lexeme:b,additionalInfo:y}),this.f.push(l)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const v=this.c.substring(this.d,this.e),b=f.b.get(v);b?this.k(b):this.f.push({type:17,lexeme:v,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,v=!1,b=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(E);return}const p=this.c.charCodeAt(y);if(v)v=!1;else if(p===47&&!b){y++;break}else p===91?b=!0:p===92?v=!0:p===93&&(b=!1);y++}for(;y<this.c.length&&f.a.has(this.c.charCodeAt(y));)y++;this.e=y;const l=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$Xi=f}),define(re[198],oe([0,1,3,2]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=e.$2n=void 0;class s{constructor(){this.a=new P.$Sd,this.b=new P.$Sd,this.c=new P.$Sd,this.d=new P.$Sd}static{this.ChannelName="extensionhostdebugservice"}call(E,f,h){switch(f){case"close":return Promise.resolve(this.a.fire({sessionId:h[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:h[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:h[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:h[0],port:h[1],subId:h[2]}))}throw new Error("Method not implemented.")}listen(E,f,h){switch(f){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$2n=s;class j extends R.$Sc{constructor(E){super(),this.b=E}reload(E){this.b.call("reload",[E])}get onReload(){return this.b.listen("reload")}close(E){this.b.call("close",[E])}get onClose(){return this.b.listen("close")}attachSession(E,f,h){this.b.call("attach",[E,f,h])}get onAttachSession(){return this.b.listen("attach")}terminateSession(E,f){this.b.call("terminate",[E,f])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(E,f){return this.b.call("openExtensionDevelopmentHostWindow",[E,f])}}e.$3n=j}),define(re[199],oe([0,1,149,50,13,9,35,19,7]),function(J,e,P,R,s,j,A,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xm=e.$wm=e.$vm=e.$um=void 0,e.$um=/^([^.]+\..+)[:=](.+)$/;class h{get appRoot(){return(0,j.$mc)(s.$lg.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return f.URI.file((0,j.$jc)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.b.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,E.$Eg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.$Eg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const l=(0,P.$tm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,j.$jc)(this.userDataPath,"logs",l)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.$Eg)(f.URI.file((0,j.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.$Eg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.$Eg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.$Eg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=A.env.VSCODE_PORTABLE;return l?f.URI.file((0,j.$jc)(l,"argv.json")):(0,E.$Eg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,j.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,j.$kc)(l):(0,j.$hc)((0,j.$jc)(s.$lg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const l=this.args["extensions-download-dir"];return l?f.URI.file((0,j.$kc)(l)):f.URI.file((0,j.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,j.$kc)(l);const p=A.env.VSCODE_EXTENSIONS;if(p)return p;const w=A.env.VSCODE_PORTABLE;return w?(0,j.$jc)(w,"extensions"):(0,E.$Eg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(p=>/^[^:/?#]+?:\/\//.test(p)?f.URI.parse(p):f.URI.file((0,j.$hc)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?f.URI.parse(l):f.URI.file((0,j.$hc)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(l=>!e.$um.test(l))}get extensionLogLevel(){const l=[];for(const p of this.args.log||[]){const w=e.$um.exec(p);w&&w[1]&&w[2]&&l.push([w[1],w[2]])}return l.length?l:void 0}get serviceMachineIdResource(){return(0,E.$Eg)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const l=A.env.VSCODE_PORTABLE;return l?f.URI.file((0,j.$jc)(l,"policy.json")):(0,E.$Eg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(l){this.args.continueOn=l}get args(){return this.a}constructor(l,p,w){this.a=l,this.b=p,this.c=w,this.editSessionId=this.args.editSessionId}}e.$vm=h,Ee([R.$uh],h.prototype,"appRoot",null),Ee([R.$uh],h.prototype,"userHome",null),Ee([R.$uh],h.prototype,"userDataPath",null),Ee([R.$uh],h.prototype,"appSettingsHome",null),Ee([R.$uh],h.prototype,"tmpDir",null),Ee([R.$uh],h.prototype,"cacheHome",null),Ee([R.$uh],h.prototype,"stateResource",null),Ee([R.$uh],h.prototype,"userRoamingDataHome",null),Ee([R.$uh],h.prototype,"userDataSyncHome",null),Ee([R.$uh],h.prototype,"sync",null),Ee([R.$uh],h.prototype,"machineSettingsResource",null),Ee([R.$uh],h.prototype,"workspaceStorageHome",null),Ee([R.$uh],h.prototype,"localHistoryHome",null),Ee([R.$uh],h.prototype,"keyboardLayoutResource",null),Ee([R.$uh],h.prototype,"argvResource",null),Ee([R.$uh],h.prototype,"isExtensionDevelopment",null),Ee([R.$uh],h.prototype,"untitledWorkspacesHome",null),Ee([R.$uh],h.prototype,"builtinExtensionsPath",null),Ee([R.$uh],h.prototype,"extensionsPath",null),Ee([R.$uh],h.prototype,"extensionDevelopmentLocationURI",null),Ee([R.$uh],h.prototype,"extensionDevelopmentKind",null),Ee([R.$uh],h.prototype,"extensionTestsLocationURI",null),Ee([R.$uh],h.prototype,"debugExtensionHost",null),Ee([R.$uh],h.prototype,"logLevel",null),Ee([R.$uh],h.prototype,"extensionLogLevel",null),Ee([R.$uh],h.prototype,"serviceMachineIdResource",null),Ee([R.$uh],h.prototype,"disableTelemetry",null),Ee([R.$uh],h.prototype,"disableWorkspaceTrust",null),Ee([R.$uh],h.prototype,"useInMemorySecretStorage",null),Ee([R.$uh],h.prototype,"policyFile",null);function y(b,l){return v(b["inspect-extensions"],b["inspect-brk-extensions"],5870,l,b.debugId,b.extensionEnvironment)}e.$wm=y;function v(b,l,p,w,$,g){const c=Number(l||b)||(w?null:p),S=c?!!l:!1;let d;if(g)try{d=JSON.parse(g)}catch{}return{port:c,break:S,debugId:$,env:d}}e.$xm=v}),define(re[112],oe([0,1,309,4,168]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=void 0;const j={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$Tl=["tunnel","serve-web"],e.$Ul={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},sandbox:{type:"boolean"},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function E(w,$,g=A){const u=w.find(a=>a.length>0&&a[0]!=="-"),c={},S=["_"],d=[],t={};let o;for(const a in $){const m=$[a];m.type==="subcommand"?a===u&&(o=m):(m.alias&&(c[a]=m.alias),m.type==="string"||m.type==="string[]"?(S.push(a),m.deprecates&&S.push(...m.deprecates)):m.type==="boolean"&&(d.push(a),m.deprecates&&d.push(...m.deprecates)),m.global&&(t[a]=m))}if(o&&u){const a=t;for(const k in o.options)a[k]=o.options[k];const m=w.filter(k=>k!==u),D=g.getSubcommandReporter?g.getSubcommandReporter(u):void 0,I=E(m,a,D);return{[u]:I,_:[]}}const r=P(w,{string:S,boolean:d,alias:c}),i={},n=r;i._=r._.map(a=>String(a)).filter(a=>a.length>0),delete n._;for(const a in $){const m=$[a];if(m.type==="subcommand")continue;m.alias&&delete n[m.alias];let D=n[a];if(m.deprecates)for(const I of m.deprecates)n.hasOwnProperty(I)&&(D||(D=n[I],D&&g.onDeprecatedOption(I,m.deprecationMessage||(0,s.localize)(37,null,a))),delete n[I]);if(typeof D<"u"){if(m.type==="string[]"){if(Array.isArray(D)||(D=[D]),!m.allowEmptyValue){const I=D.filter(k=>k.length>0);I.length!==D.length&&(g.onEmptyValue(a),D=I.length>0?I:void 0)}}else m.type==="string"&&(Array.isArray(D)?(D=D.pop(),g.onMultipleValues(a,D)):!D&&!m.allowEmptyValue&&(g.onEmptyValue(a),D=void 0));i[a]=D,m.deprecationMessage&&g.onDeprecatedOption(a,m.deprecationMessage)}delete n[a]}for(const a in n)g.onUnknownOption(a);return i}e.$Vl=E;function f(w,$){let g="";return $.args&&(Array.isArray($.args)?g=` <${$.args.join("> <")}>`:g=` <${$.args}>`),$.alias?`-${$.alias} --${w}${g}`:`--${w}${g}`}function h(w,$){const g=[];for(const u in w){const c=w[u],S=f(u,c);g.push([S,c.description])}return y(g,$)}e.$Wl=h;function y(w,$){const u=w.reduce((d,t)=>Math.max(d,t[0].length),12)+2+1;if($-u<25)return w.reduce((d,t)=>d.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const c=$-u-1,S=[];for(const d of w){const t=d[0],o=b(d[1],c),r=v(u-t.length-2);S.push("  "+t+r+o[0]);for(let i=1;i<o.length;i++)S.push(v(u)+o[i])}return S}function v(w){return" ".repeat(w)}function b(w,$){const g=[];for(;w.length;){const u=w.length<$?w.length:w.lastIndexOf(" ",$),c=w.slice(0,u).trim();w=w.slice(u),g.push(c)}return g}function l(w,$,g,u,c){const S=process.stdout.isTTY&&process.stdout.columns||80,d=c?.noInputFiles!==!0?`[${(0,s.localize)(38,null)}...]`:"",t=[`${w} ${g}`];t.push(""),t.push(`${(0,s.localize)(39,null)}: ${$} [${(0,s.localize)(40,null)}]${d}`),t.push(""),c?.noPipe!==!0&&(R.$i?t.push((0,s.localize)(41,null,$)):t.push((0,s.localize)(42,null,$)),t.push(""));const o={},r=[];for(const i in u){const n=u[i];if(n.type==="subcommand")n.description&&r.push({command:i,description:n.description});else if(n.description&&n.cat){let a=o[n.cat];a||(o[n.cat]=a={}),a[i]=n}}for(const i in o){const n=i,a=o[n];a&&(t.push(j[n]),t.push(...h(a,S)),t.push(""))}return r.length&&(t.push((0,s.localize)(43,null)),t.push(...y(r.map(i=>[i.command,i.description]),S)),t.push("")),t.join(`
`)}e.$Xl=l;function p(w,$){return`${w||(0,s.localize)(44,null)}
${$||(0,s.localize)(45,null)}
${process.arch}`}e.$Yl=p}),define(re[200],oe([0,1,87,198,112]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X9b=void 0;class j extends R.$2n{constructor(E){super(),this.f=E}call(E,f,h){return f==="openExtensionDevelopmentHostWindow"?this.g(h[0],h[1]):super.call(E,f,h)}async g(E,f){const h=(0,s.$Vl)(E,s.$Ul);h.debugRenderer=f;const y=h.extensionDevelopmentPath;if(!y)return{success:!1};const[v]=await this.f.openExtensionDevelopmentHostWindow(y,{context:5,cli:h,forceProfile:h.profile,forceTempProfile:h["profile-temp"]});if(!f)return{success:!0};const b=v.win;if(!b)return{success:!0};const l=b.webContents.debugger;let p=l.isAttached()?1/0:0;const w=(0,P.createServer)($=>{p++===0&&l.attach();let g=!1;const u=d=>{g||$.write(JSON.stringify(d)+"\0")},c=(d,t,o,r)=>u({method:t,params:o,sessionId:r});b.on("close",()=>{l.removeListener("message",c),$.end(),g=!0}),l.addListener("message",c);let S=Buffer.alloc(0);$.on("data",d=>{S=Buffer.concat([S,d]);for(let t=S.indexOf(0);t!==-1;t=S.indexOf(0)){let o;try{const r=S.slice(0,t).toString("utf8");S=S.slice(t+1),o=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}l.sendCommand(o.method,o.params,o.sessionId).then(r=>u({id:o.id,sessionId:o.sessionId,result:r})).catch(r=>u({id:o.id,sessionId:o.sessionId,error:{code:0,message:r.message}}))}}),$.on("error",d=>{console.error("error on cdp pipe:",d)}),$.on("close",()=>{g=!0,--p===0&&l.detach()})});return await new Promise($=>w.listen(0,$)),b.on("close",()=>w.close()),{rendererDebugPort:w.address().port,success:!0}}}e.$X9b=j}),define(re[64],oe([0,1,310,169,112]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=e.$1l=e.$Zl=void 0;function j(v,b){const l=(c,S)=>{console.warn((0,R.localize)(0,null,c,S))},p=c=>{console.warn((0,R.localize)(1,null,c))},w=(c,S)=>{console.warn((0,R.localize)(2,null,c,S))},$=c=>({onUnknownOption:S=>{s.$Tl.includes(c)||console.warn((0,R.localize)(3,null,S,c))},onMultipleValues:l,onEmptyValue:p,onDeprecatedOption:w,getSubcommandReporter:s.$Tl.includes(c)?$:void 0}),g={onUnknownOption:c=>{console.warn((0,R.localize)(4,null,c))},onMultipleValues:l,onEmptyValue:p,onDeprecatedOption:w,getSubcommandReporter:$},u=(0,s.$Vl)(v,s.$Ul,b?g:void 0);return u.goto&&u._.forEach(c=>P(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(c),(0,R.localize)(5,null))),u}function A(v){const b=v.findIndex(l=>!/^-/.test(l));if(b>-1)return[...v.slice(0,b),...v.slice(b+1)]}function E(v){let[,...b]=v;process.env.VSCODE_DEV&&(b=A(b)||[]);const l=!y(process.env);return j(b,l)}e.$Zl=E;function f(v){let[,,...b]=v;return process.env.VSCODE_DEV&&(b=A(b)||[]),j(b,!0)}e.$1l=f;function h(v,...b){const l=v.indexOf("--");return l===-1?v.push(...b):v.splice(l,0,...b),v}e.$2l=h;function y(v){return v.VSCODE_CLI==="1"}e.$3l=y}),function(){"use strict";function J(e,P,R){function s(A,E){const f=j(A,E),h=[f];return e.isAbsolute(f)||h.unshift(R),e.resolve(...h)}function j(A,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let h=process.env.VSCODE_APPDATA;if(h)return e.join(h,E);const y=A["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(h=process.env.APPDATA,!h){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");h=e.join(v,"AppData","Roaming")}break;case"darwin":h=e.join(P.homedir(),"Library","Application Support");break;case"linux":h=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(h,E)}return{getUserDataPath:s}}if(typeof define=="function")define(re[201],oe([113,26,35]),function(e,P,R){return J(e,P,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=J(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[90],oe([0,1,26,199,201]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=e.$zm=e.$ym=void 0;class j extends R.$vm{constructor(h,y){super(h,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,s.getUserDataPath)(h,y.nameShort)},y)}}e.$ym=j;function A(f,h){return(0,R.$xm)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,h,f.extensionEnvironment)}e.$zm=A;function E(f,h){return(0,R.$xm)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,h,f.extensionEnvironment)}e.$Am=E}),define(re[202],oe([0,1,46,26,33]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d$b=void 0;function j(A){const E=(0,s.$ag)((0,R.tmpdir)());try{return(0,P.writeFileSync)(E,""),A&&console.log(`Marker file for --wait created: ${E}`),E}catch(f){A&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.$d$b=j}),define(re[203],oe([0,1,12,171]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;function s(A,E,f,h){try{j(A,E,f,h)}catch(y){A.error(y?.message??y)}return E}e.$Mp=s;function j(A,E,f,h){const y=(v,b,l)=>{const p=v[b];if((0,P.$Ff)(p)){const w=p,$=w.length;if($>1&&w[0]==="%"&&w[$-1]==="%"){const g=w.substr(1,$-2);let u=f[g];u===void 0&&h&&(u=h[g]);const c=typeof u=="string"?u:u?.message,S=h?.[g],d=typeof S=="string"?S:S?.message;if(!c){d||A.warn(`[${E.name}]: ${(0,R.localize)(0,null,g)}`);return}if(l&&(b==="title"||b==="category")&&d&&d!==c){const t={value:c,original:d};v[b]=t}else v[b]=c}}else if((0,P.$Hf)(p))for(const w in p)p.hasOwnProperty(w)&&(w==="commands"?y(p,w,!0):y(p,w,l));else if(Array.isArray(p))for(let w=0;w<p.length;w++)y(p,w,l)};for(const v in E)E.hasOwnProperty(v)&&y(E,v)}}),define(re[204],oe([0,1,19,74,173,205]),function(J,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function f(g){return g=g.trim(),g==="*"||A.test(g)}e.$1o=f;function h(g){if(!f(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=g.match(A);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.$2o=h;function y(g){if(!g)return null;const u=g.majorBase,c=g.majorMustEqual,S=g.minorBase;let d=g.minorMustEqual;const t=g.patchBase;let o=g.patchMustEqual;g.hasCaret&&(u===0||(d=!1),o=!1);let r=0;if(g.preRelease){const i=E.exec(g.preRelease);if(i){const[,n,a,m]=i;r=Date.UTC(Number(n),Number(a)-1,Number(m))}}return{majorBase:u,majorMustEqual:c,minorBase:S,minorMustEqual:d,patchBase:t,patchMustEqual:o,isMinimum:g.hasGreaterEquals,notBefore:r}}e.$3o=y;function v(g,u,c){let S;typeof g=="string"?S=y(h(g)):S=g;let d;u instanceof Date?d=u.getTime():typeof u=="string"&&(d=new Date(u).getTime());let t;if(typeof c=="string"?t=y(h(c)):t=c,!S||!t)return!1;const o=S.majorBase,r=S.minorBase,i=S.patchBase;let n=t.majorBase,a=t.minorBase,m=t.patchBase;const D=t.notBefore;let I=t.majorMustEqual,k=t.minorMustEqual,C=t.patchMustEqual;return t.isMinimum?o>n?!0:o<n?!1:r>a?!0:r<a||d&&d<D?!1:i>=m:(o===1&&n===0&&(!I||!k||!C)&&(n=1,a=0,m=0,I=!0,k=!1,C=!1),o<n?!1:o>n?!I:r<a?!1:r>a?!k:i<m?!1:i>m?!C:!(d&&d<D))}e.$4o=v;function b(g,u,c,S,d){const t=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return t.push([R.default.Error,s.localize(0,null)]),t;if(typeof S.name!="string")return t.push([R.default.Error,s.localize(1,null,"name")]),t;if(typeof S.version!="string")return t.push([R.default.Error,s.localize(2,null,"version")]),t;if(!S.engines)return t.push([R.default.Error,s.localize(3,null,"engines")]),t;if(typeof S.engines.vscode!="string")return t.push([R.default.Error,s.localize(4,null,"engines.vscode")]),t;if(typeof S.extensionDependencies<"u"&&!$(S.extensionDependencies))return t.push([R.default.Error,s.localize(5,null,"extensionDependencies")]),t;if(typeof S.activationEvents<"u"){if(!$(S.activationEvents))return t.push([R.default.Error,s.localize(6,null,"activationEvents")]),t;if(typeof S.main>"u"&&typeof S.browser>"u")return t.push([R.default.Error,s.localize(7,null,"activationEvents","main","browser")]),t}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&t.push([R.default.Warning,s.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return t.push([R.default.Error,s.localize(9,null,"main")]),t;{const i=(0,P.$Eg)(c,S.main);(0,P.$yg)(i,c)||t.push([R.default.Warning,s.localize(10,null,i.path,c.path)])}}if(typeof S.browser<"u"){if(typeof S.browser!="string")return t.push([R.default.Error,s.localize(11,null,"browser")]),t;{const i=(0,P.$Eg)(c,S.browser);(0,P.$yg)(i,c)||t.push([R.default.Warning,s.localize(12,null,i.path,c.path)])}}if(!j.valid(S.version))return t.push([R.default.Error,s.localize(13,null)]),t;const o=[];if(!l(g,u,S,d,o))for(const i of o)t.push([R.default.Error,i]);return t}e.$5o=b;function l(g,u,c,S,d){return S||typeof c.main>"u"&&typeof c.browser>"u"?!0:w(g,u,c.engines.vscode,d)}e.$6o=l;function p(g,u,c){return g==="*"||w(u,c,g)}e.$7o=p;function w(g,u,c,S=[]){const d=y(h(c));if(!d)return S.push(s.localize(14,null,c)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return S.push(s.localize(15,null,c)),!1}else if(!d.majorMustEqual)return S.push(s.localize(16,null,c)),!1;return v(g,u,d)?!0:(S.push(s.localize(17,null,g,c)),!1)}function $(g){if(!Array.isArray(g))return!1;for(let u=0,c=g.length;u<c;u++)if(typeof g[u]!="string")return!1;return!0}}),define(re[206],oe([0,1,18,32]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=void 0;async function s(j,A,E){let f=E&&E.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const y=(await A.readFile(j.serviceMachineIdResource)).value.toString();f=(0,R.$mg)(y)?y:null}catch{f=null}if(!f){f=(0,R.$ng)();try{await A.writeFile(j.serviceMachineIdResource,P.$ge.fromString(f))}catch{}}return E?.store("storage.serviceMachineId",f,-1,1),f}e.$op=s}),define(re[78],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=void 0;class P{constructor(s,j=[],A=!1){this.ctor=s,this.staticArguments=j,this.supportsDelayedInstantiation=A}}e.$Zh=P}),define(re[207],oe([0,1,78]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mr=e.$Lr=e.InstantiationType=void 0;const R=[];var s;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function j(E,f,h){f instanceof P.$Zh||(f=new P.$Zh(f,[],!!h)),R.push([E,f])}e.$Lr=j;function A(){return R}e.$Mr=A}),define(re[208],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=void 0;class P{constructor(j,A){this.key=j,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$qq=P;class R{constructor(j){this.b=j,this.a=new Map}roots(){const j=[];for(const A of this.a.values())A.outgoing.size===0&&j.push(A);return j}insertEdge(j,A){const E=this.lookupOrInsertNode(j),f=this.lookupOrInsertNode(A);E.outgoing.set(f.key,f),f.incoming.set(E.key,E)}removeNode(j){const A=this.b(j);this.a.delete(A);for(const E of this.a.values())E.outgoing.delete(A),E.incoming.delete(A)}lookupOrInsertNode(j){const A=this.b(j);let E=this.a.get(A);return E||(E=new P(A,j),this.a.set(A,E)),E}lookup(j){return this.a.get(this.b(j))}isEmpty(){return this.a.size===0}toString(){const j=[];for(const[A,E]of this.a)j.push(`${A}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return j.join(`
`)}findCycleSlow(){for(const[j,A]of this.a){const E=new Set([j]),f=this.c(A,E);if(f)return f}}c(j,A){for(const[E,f]of j.outgoing){if(A.has(E))return[...A,E].join(" -> ");A.add(E);const h=this.c(f,A);if(h)return h;A.delete(E)}}}e.$rq=R}),define(re[6],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=e.$2h=e._util=void 0;var P;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function E(f){return f[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=E})(P||(e._util=P={})),e.$2h=s("instantiationService");function R(A,E,f){E[P.DI_TARGET]===E?E[P.DI_DEPENDENCIES].push({id:A,index:f}):(E[P.DI_DEPENDENCIES]=[{id:A,index:f}],E[P.DI_TARGET]=E)}function s(A){if(P.serviceIds.has(A))return P.serviceIds.get(A);const E=function(f,h,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(E,f,y)};return E.toString=()=>A,P.serviceIds.set(A,E),E}e.$3h=s;function j(A){return A}e.$4h=j}),define(re[65],oe([0,1,13,6]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q9b=e.$P9b=void 0,e.$P9b=(0,R.$3h)("auxiliaryWindowsMainService");function s(j){return j?.opener?.url.startsWith(`${P.Schemas.vscodeFileResource}://${P.$kg}/`)}e.$Q9b=s}),define(re[66],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x9b=void 0,e.$x9b=(0,P.$3h)("backupMainService")}),define(re[17],oe([0,1,12,7,6]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.ConfigurationTarget=e.$yi=e.$xi=e.$wi=void 0,e.$wi=(0,s.$3h)("configurationService");function j(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof R.URI)}e.$xi=j;function A(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof R.URI)}e.$yi=A;var E;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(E||(e.ConfigurationTarget=E={}));function f(g){switch(g){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$zi=f;function h(g){return g.applicationValue!==void 0||g.userValue!==void 0||g.userLocalValue!==void 0||g.userRemoteValue!==void 0||g.workspaceValue!==void 0||g.workspaceFolderValue!==void 0}e.$Ai=h;function y(g,u){const c=Object.create(null);for(const S in g)v(c,S,g[S],u);return c}e.$Bi=y;function v(g,u,c,S){const d=u.split("."),t=d.pop();let o=g;for(let r=0;r<d.length;r++){const i=d[r];let n=o[i];switch(typeof n){case"undefined":n=o[i]=Object.create(null);break;case"object":break;default:S(`Ignoring ${u} as ${d.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[t]=c}catch{S(`Ignoring ${u} as ${d.join(".")} is ${JSON.stringify(o)}`)}else S(`Ignoring ${u} as ${d.join(".")} is ${JSON.stringify(o)}`)}e.$Ci=v;function b(g,u){const c=u.split(".");l(g,c)}e.$Di=b;function l(g,u){const c=u.shift();if(u.length===0){delete g[c];return}if(Object.keys(g).indexOf(c)!==-1){const S=g[c];typeof S=="object"&&!Array.isArray(S)&&(l(S,u),Object.keys(S).length===0&&delete g[c])}}function p(g,u,c){function S(o,r){let i=o;for(const n of r){if(typeof i!="object"||i===null)return;i=i[n]}return i}const d=u.split("."),t=S(g,d);return typeof t>"u"?c:t}e.$Ei=p;function w(g,u,c){Object.keys(u).forEach(S=>{S!=="__proto__"&&(S in g?P.$Hf(g[S])&&P.$Hf(u[S])?w(g[S],u[S],c):c&&(g[S]=u[S]):g[S]=u[S])})}e.$Fi=w;function $(g){return g.replace(/[\[\]]/g,"")}e.$Gi=$}),define(re[114],oe([0,1,4,25,197,6,164,14]),function(J,e,P,R,s,j,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.ContextKeyExprType=e.$Yi=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",P.$j),f.set("isLinux",P.$k),f.set("isWindows",P.$i),f.set("isWeb",P.$o),f.set("isMacNative",P.$j&&!P.$o),f.set("isEdge",P.$H),f.set("isFirefox",P.$F),f.set("isChrome",P.$E),f.set("isSafari",P.$G);function h(G,O){if(f.get(G)!==void 0)throw(0,E.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(G,O)}e.$Yi=h;const y=Object.prototype.hasOwnProperty;var v;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(v||(e.ContextKeyExprType=v={}));const b={regexParsingWithErrorRecovery:!0},l=(0,A.localize)(0,null),p=(0,A.localize)(1,null),w=(0,A.localize)(2,null),$=(0,A.localize)(3,null),g=(0,A.localize)(4,null),u=(0,A.localize)(5,null),c=(0,A.localize)(6,null),S=(0,A.localize)(7,null);class d{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=b){this.k=O,this.d=new s.$Xi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const U=this.l();if(!this.E()){const x=this.D(),z=x.type===17?u:void 0;throw this.h.push({message:g,offset:x.offset,lexeme:s.$Xi.getLexeme(x),additionalInfo:z}),d.c}return U}catch(U){if(U!==d.c)throw U;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const U=this.o();O.push(U)}return O.length===1?O[0]:t.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const U=this.s();O.push(U)}return O.length===1?O[0]:t.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),a.INSTANCE;case 0:{this.z();const U=this.l();return this.A(1,$),U?.negate()}case 17:return this.z(),M.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const U=this.l();return this.A(1,$),U}case 17:{const U=O.lexeme;if(this.z(),this.y(9)){const z=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),z.type!==10)throw this.B("REGEX",z);const Y=z.lexeme,W=Y.lastIndexOf("/"),B=W===Y.length-1?void 0:this.w(Y.substring(W+1));let _;try{_=new RegExp(Y.substring(1,W),B)}catch{throw this.B("REGEX",z)}return ce.create(U,_)}switch(z.type){case 10:case 19:{const Y=[z.lexeme];this.z();let W=this.D(),B=0;for(let me=0;me<z.lexeme.length;me++)z.lexeme.charCodeAt(me)===40?B++:z.lexeme.charCodeAt(me)===41&&B--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:B++;break;case 1:B--;break;case 10:case 18:for(let me=0;me<W.lexeme.length;me++)W.lexeme.charCodeAt(me)===40?B++:z.lexeme.charCodeAt(me)===41&&B--}if(B<0)break;Y.push(s.$Xi.getLexeme(W)),this.z(),W=this.D()}const _=Y.join(""),ae=_.lastIndexOf("/"),se=ae===_.length-1?void 0:this.w(_.substring(ae+1));let $e;try{$e=new RegExp(_.substring(1,ae),se)}catch{throw this.B("REGEX",z)}return t.regex(U,$e)}case 18:{const Y=z.lexeme;this.z();let W=null;if(!(0,R.$Ge)(Y)){const B=Y.indexOf("/"),_=Y.lastIndexOf("/");if(B!==_&&B>=0){const ae=Y.slice(B+1,_),se=Y[_+1]==="i"?"i":"";try{W=new RegExp(ae,se)}catch{throw this.B("REGEX",z)}}}if(W===null)throw this.B("REGEX",z);return ce.create(U,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const z=this.u();return t.notIn(U,z)}switch(this.D().type){case 3:{this.z();const z=this.u();if(this.x().type===18)return t.equals(U,z);switch(z){case"true":return t.has(U);case"false":return t.not(U);default:return t.equals(U,z)}}case 4:{this.z();const z=this.u();if(this.x().type===18)return t.notEquals(U,z);switch(z){case"true":return t.not(U);case"false":return t.has(U);default:return t.notEquals(U,z)}}case 5:return this.z(),Q.create(U,this.u());case 6:return this.z(),le.create(U,this.u());case 7:return this.z(),N.create(U,this.u());case 8:return this.z(),Z.create(U,this.u());case 13:return this.z(),t.in(U,this.u());default:return t.has(U)}}case 20:throw this.h.push({message:c,offset:O.offset,lexeme:"",additionalInfo:S}),d.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,U){if(this.C(O))return this.z();throw this.B(U,this.D())}B(O,U,x){const z=(0,A.localize)(8,null,O,s.$Xi.getLexeme(U)),Y=U.offset,W=s.$Xi.getLexeme(U);return this.h.push({message:z,offset:Y,lexeme:W,additionalInfo:x}),d.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Zi=d;class t{static false(){return n.INSTANCE}static true(){return a.INSTANCE}static has(O){return m.create(O)}static equals(O,U){return D.create(O,U)}static notEquals(O,U){return C.create(O,U)}static regex(O,U){return ce.create(O,U)}static in(O,U){return I.create(O,U)}static notIn(O,U){return k.create(O,U)}static not(O){return M.create(O)}static and(...O){return K.create(O,null,!0)}static or(...O){return H.create(O,null,!0)}static greater(O,U){return N.create(O,U)}static greaterEquals(O,U){return Z.create(O,U)}static smaller(O,U){return Q.create(O,U)}static smallerEquals(O,U){return le.create(O,U)}static{this.c=new d({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$1i=t;function o(G){const O=new d({regexParsingWithErrorRecovery:!1});return G.map(U=>(O.parse(U),O.lexingErrors.length>0?O.lexingErrors.map(x=>({errorMessage:x.additionalInfo?(0,A.localize)(9,null,x.additionalInfo):(0,A.localize)(10,null),offset:x.offset,length:x.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(x=>({errorMessage:x.additionalInfo?`${x.message}. ${x.additionalInfo}`:x.message,offset:x.offset,length:x.lexeme.length})):[]))}e.$2i=o;function r(G,O){const U=G?G.substituteConstants():void 0,x=O?O.substituteConstants():void 0;return!U&&!x?!0:!U||!x?!1:U.equals(x)}e.$3i=r;function i(G,O){return G.cmp(O)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return a.INSTANCE}}e.$4i=n;class a{static{this.INSTANCE=new a}constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return n.INSTANCE}}e.$5i=a;class m{static create(O,U=null){const x=f.get(O);return typeof x=="boolean"?x?a.INSTANCE:n.INSTANCE:new m(O,U)}constructor(O,U){this.key=O,this.c=U,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:T(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=f.get(this.key);return typeof O=="boolean"?O?a.INSTANCE:n.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$6i=m;class D{static create(O,U,x=null){if(typeof U=="boolean")return U?m.create(O,x):M.create(O,x);const z=f.get(O);return typeof z=="boolean"?U===(z?"true":"false")?a.INSTANCE:n.INSTANCE:new D(O,U,x)}constructor(O,U,x){this.c=O,this.d=U,this.f=x,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:V(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=f.get(this.c);if(typeof O=="boolean"){const U=O?"true":"false";return this.d===U?a.INSTANCE:n.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$7i=D;class I{static create(O,U){return new I(O,U)}constructor(O,U){this.d=O,this.f=U,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:V(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const U=O.getValue(this.f),x=O.getValue(this.d);return Array.isArray(U)?U.includes(x):typeof x=="string"&&typeof U=="object"&&U!==null?y.call(U,x):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$8i=I;class k{static create(O,U){return new k(O,U)}constructor(O,U){this.d=O,this.f=U,this.type=11,this.c=I.create(O,U)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$9i=k;class C{static create(O,U,x=null){if(typeof U=="boolean")return U?M.create(O,x):m.create(O,x);const z=f.get(O);return typeof z=="boolean"?U===(z?"true":"false")?n.INSTANCE:a.INSTANCE:new C(O,U,x)}constructor(O,U,x){this.c=O,this.d=U,this.f=x,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:V(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=f.get(this.c);if(typeof O=="boolean"){const U=O?"true":"false";return this.d===U?n.INSTANCE:a.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$0i=C;class M{static create(O,U=null){const x=f.get(O);return typeof x=="boolean"?x?n.INSTANCE:a.INSTANCE:new M(O,U)}constructor(O,U){this.c=O,this.d=U,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:T(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=f.get(this.c);return typeof O=="boolean"?O?n.INSTANCE:a.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=m.create(this.c,this)),this.d}}e.$$i=M;function F(G,O){if(typeof G=="string"){const U=parseFloat(G);isNaN(U)||(G=U)}return typeof G=="string"||typeof G=="number"?O(G):n.INSTANCE}class N{static create(O,U,x=null){return F(U,z=>new N(O,z,x))}constructor(O,U,x){this.c=O,this.d=U,this.f=x,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:V(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.$_i=N;class Z{static create(O,U,x=null){return F(U,z=>new Z(O,z,x))}constructor(O,U,x){this.c=O,this.d=U,this.f=x,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:V(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=Q.create(this.c,this.d,this)),this.f}}e.$aj=Z;class Q{static create(O,U,x=null){return F(U,z=>new Q(O,z,x))}constructor(O,U,x){this.c=O,this.d=U,this.f=x,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:V(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$bj=Q;class le{static create(O,U,x=null){return F(U,z=>new le(O,z,x))}constructor(O,U,x){this.c=O,this.d=U,this.f=x,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:V(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$cj=le;class ce{static create(O,U){return new ce(O,U)}constructor(O,U){this.d=O,this.f=U,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const U=this.f?this.f.source:"",x=O.f?O.f.source:"";return U<x?-1:U>x?1:0}equals(O){if(O.type===this.type){const U=this.f?this.f.source:"",x=O.f?O.f.source:"";return this.d===O.d&&U===x}return!1}substituteConstants(){return this}evaluate(O){const U=O.getValue(this.d);return this.f?this.f.test(U):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ue.create(this)),this.c}}e.$dj=ce;class ue{static create(O){return new ue(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new ue(this.c.map(O))}negate(){return this.c}}e.$ej=ue;function X(G){let O=null;for(let U=0,x=G.length;U<x;U++){const z=G[U].substituteConstants();if(G[U]!==z&&O===null){O=[];for(let Y=0;Y<U;Y++)O[Y]=G[Y]}O!==null&&(O[U]=z)}return O===null?G:O}class K{static create(O,U,x){return K.d(O,U,x)}constructor(O,U){this.expr=O,this.c=U,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let U=0,x=this.expr.length;U<x;U++){const z=i(this.expr[U],O.expr[U]);if(z!==0)return z}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let U=0,x=this.expr.length;U<x;U++)if(!this.expr[U].equals(O.expr[U]))return!1;return!0}return!1}substituteConstants(){const O=X(this.expr);return O===this.expr?this:K.create(O,this.c,!1)}evaluate(O){for(let U=0,x=this.expr.length;U<x;U++)if(!this.expr[U].evaluate(O))return!1;return!0}static d(O,U,x){const z=[];let Y=!1;for(const W of O)if(W){if(W.type===1){Y=!0;continue}if(W.type===0)return n.INSTANCE;if(W.type===6){z.push(...W.expr);continue}z.push(W)}if(z.length===0&&Y)return a.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(i);for(let W=1;W<z.length;W++)z[W-1].equals(z[W])&&(z.splice(W,1),W--);if(z.length===1)return z[0];for(;z.length>1;){const W=z[z.length-1];if(W.type!==9)break;z.pop();const B=z.pop(),_=z.length===0,ae=H.create(W.expr.map(se=>K.create([se,B],null,x)),null,_);ae&&(z.push(ae),z.sort(i))}if(z.length===1)return z[0];if(x){for(let W=0;W<z.length;W++)for(let B=W+1;B<z.length;B++)if(z[W].negate().equals(z[B]))return n.INSTANCE;if(z.length===1)return z[0]}return new K(z,U)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const U of this.expr)O.push(...U.keys());return O}map(O){return new K(this.expr.map(U=>U.map(O)),null)}negate(){if(!this.c){const O=[];for(const U of this.expr)O.push(U.negate());this.c=H.create(O,this,!0)}return this.c}}e.$fj=K;class H{static create(O,U,x){return H.d(O,U,x)}constructor(O,U){this.expr=O,this.c=U,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let U=0,x=this.expr.length;U<x;U++){const z=i(this.expr[U],O.expr[U]);if(z!==0)return z}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let U=0,x=this.expr.length;U<x;U++)if(!this.expr[U].equals(O.expr[U]))return!1;return!0}return!1}substituteConstants(){const O=X(this.expr);return O===this.expr?this:H.create(O,this.c,!1)}evaluate(O){for(let U=0,x=this.expr.length;U<x;U++)if(this.expr[U].evaluate(O))return!0;return!1}static d(O,U,x){let z=[],Y=!1;if(O){for(let W=0,B=O.length;W<B;W++){const _=O[W];if(_){if(_.type===0){Y=!0;continue}if(_.type===1)return a.INSTANCE;if(_.type===9){z=z.concat(_.expr);continue}z.push(_)}}if(z.length===0&&Y)return n.INSTANCE;z.sort(i)}if(z.length!==0){if(z.length===1)return z[0];for(let W=1;W<z.length;W++)z[W-1].equals(z[W])&&(z.splice(W,1),W--);if(z.length===1)return z[0];if(x){for(let W=0;W<z.length;W++)for(let B=W+1;B<z.length;B++)if(z[W].negate().equals(z[B]))return a.INSTANCE;if(z.length===1)return z[0]}return new H(z,U)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const U of this.expr)O.push(...U.keys());return O}map(O){return new H(this.expr.map(U=>U.map(O)),null)}negate(){if(!this.c){const O=[];for(const U of this.expr)O.push(U.negate());for(;O.length>1;){const U=O.shift(),x=O.shift(),z=[];for(const Y of he(U))for(const W of he(x))z.push(K.create([Y,W],null,!1));O.unshift(H.create(z,null,!1))}this.c=H.create(O,this,!0)}return this.c}}e.$gj=H;class L extends m{static{this.d=[]}static all(){return L.d.values()}constructor(O,U,x){super(O,null),this.f=U,typeof x=="object"?L.d.push({...x,key:O}):x!==!0&&L.d.push({key:O,description:x,type:U!=null?typeof U:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return D.create(this.key,O)}notEqualsTo(O){return C.create(this.key,O)}}e.$hj=L,e.$ij=(0,j.$3h)("contextKeyService");function T(G,O){return G<O?-1:G>O?1:0}function V(G,O,U,x){return G<U?-1:G>U?1:O<x?-1:O>x?1:0}function q(G,O){if(G.type===0||O.type===1)return!0;if(G.type===9)return O.type===9?te(G.expr,O.expr):!1;if(O.type===9){for(const U of O.expr)if(q(G,U))return!0;return!1}if(G.type===6){if(O.type===6)return te(O.expr,G.expr);for(const U of G.expr)if(q(U,O))return!0;return!1}return G.equals(O)}e.$jj=q;function te(G,O){let U=0,x=0;for(;U<G.length&&x<O.length;){const z=G[U].cmp(O[x]);if(z<0)return!1;z===0&&U++,x++}return U===G.length}function he(G){return G.type===9?G.expr:[G]}}),define(re[91],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=e.ID=void 0,e.ID="diagnosticsService",e.$Fm=(0,P.$3h)(e.ID);function R(j){return!!j.hostName&&!!j.errorMessage}e.$Gm=R;class s{async getPerformanceInfo(A,E){return{}}async getSystemInfo(A,E){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,E){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.$Hm=s}),define(re[115],oe([0,1,19,74,166,6,47,4,38]),function(J,e,P,R,s,j,A,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wv=e.$Vv=e.ConfirmResult=e.$Uv=e.$Tv=e.$Sv=void 0,e.$Sv=(0,j.$3h)("dialogService");var h;(function(w){w[w.Confirmation=1]="Confirmation",w[w.Prompt=2]="Prompt",w[w.Input=3]="Input"})(h||(h={}));class y{a($){return this.d($,h.Confirmation)}b($){return this.d($,h.Prompt)}c($){return this.d($,h.Input)}d($,g){const u=[];switch(g){case h.Confirmation:{const c=$;c.primaryButton?u.push(c.primaryButton):u.push((0,s.localize)(0,null)),c.cancelButton?u.push(c.cancelButton):u.push((0,s.localize)(1,null));break}case h.Prompt:{const c=$;Array.isArray(c.buttons)&&c.buttons.length>0&&u.push(...c.buttons.map(S=>S.label)),c.cancelButton&&(c.cancelButton===!0?u.push((0,s.localize)(2,null)):typeof c.cancelButton=="string"?u.push(c.cancelButton):c.cancelButton.label?u.push(c.cancelButton.label):u.push((0,s.localize)(3,null))),u.length===0&&u.push((0,s.localize)(4,null));break}case h.Input:{const c=$;c.primaryButton?u.push(c.primaryButton):u.push((0,s.localize)(5,null)),c.cancelButton?u.push(c.cancelButton):u.push((0,s.localize)(6,null));break}}return u}e($){if(typeof $=="string")return $;if(typeof $=="number")return $===R.default.Info?"info":$===R.default.Error?"error":$===R.default.Warning?"warning":"none"}f($,g,u){const c=[...$.buttons??[]];$.cancelButton&&typeof $.cancelButton!="string"&&typeof $.cancelButton!="boolean"&&c.push($.cancelButton);let S=c[g]?.run({checkboxChecked:u});return S instanceof Promise||(S=Promise.resolve(S)),{result:S,checkboxChecked:u}}}e.$Tv=y,e.$Uv=(0,j.$3h)("fileDialogService");var v;(function(w){w[w.SAVE=0]="SAVE",w[w.DONT_SAVE=1]="DONT_SAVE",w[w.CANCEL=2]="CANCEL"})(v||(e.ConfirmResult=v={}));const b=10;function l(w){const $=[];return $.push(...w.slice(0,b).map(g=>typeof g=="string"?g:(0,P.$Bg)(g))),w.length>b&&(w.length-b===1?$.push((0,s.localize)(7,null)):$.push((0,s.localize)(8,null,w.length-b))),$.push(""),$.join(`
`)}e.$Vv=l;function p(w,$){const g=(0,f.$jn)(w);let u=(g.buttons??[]).map(t=>(0,A.$Pv)(t)),c=(w.buttons||[]).map((t,o)=>o),S=0,d=g.cancelId??u.length-1;if(u.length>1){const t=typeof d=="number"?u[d]:void 0;if(E.$k||E.$j){if(typeof t=="string"&&u.length>1&&d!==1){u.splice(d,1),u.splice(1,0,t);const o=c[d];c.splice(d,1),c.splice(1,0,o),d=1}E.$k&&u.length>1&&(u=u.reverse(),c=c.reverse(),S=u.length-1,typeof t=="string"&&(d=S-1))}else if(E.$i&&typeof t=="string"&&u.length>1&&d!==u.length-1){u.splice(d,1),u.push(t);const o=c[d];c.splice(d,1),c.push(o),d=u.length-1}}return g.buttons=u,g.defaultId=S,g.cancelId=d,g.noLink=!0,g.title=g.title||$.nameLong,{options:g,buttonIndeces:c}}e.$Wv=p}),define(re[116],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7U=e.$6U=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$5U=e.$4U=void 0,e.$4U=(0,P.$3h)("encryptionService"),e.$5U=(0,P.$3h)("encryptionMainService");var R;(function(E){E.kwallet="kwallet",E.kwallet5="kwallet5",E.gnome="gnome",E.gnomeKeyring="gnome-keyring",E.gnomeLibsecret="gnome-libsecret",E.basic="basic"})(R||(e.PasswordStoreCLIOption=R={}));var s;(function(E){E.unknown="unknown",E.basicText="basic_text",E.gnomeAny="gnome_any",E.gnomeLibsecret="gnome_libsecret",E.gnomeKeyring="gnome_keyring",E.kwallet="kwallet",E.kwallet5="kwallet5",E.kwallet6="kwallet6",E.dplib="dpapi",E.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function j(E){return E==="kwallet"||E==="kwallet5"||E==="kwallet6"}e.$6U=j;function A(E){return E==="gnome_any"||E==="gnome_libsecret"||E==="gnome_keyring"}e.$7U=A}),define(re[37],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=e.$0h=void 0,e.$0h=(0,P.$3h)("environmentService"),e.$$h=(0,P.$4h)(e.$0h)}),define(re[117],oe([0,1,170,6]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$mo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=void 0,e.$ao="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$bo=new RegExp(e.$ao),e.$co="__web_extension",e.$do="skipWalkthrough",e.$eo="extensionsSync",e.$fo="dependecyOrPackExtensionInstall";function s(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$go=s;function j(g){switch(g){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$ho=j;function A(g,u){switch(g){case 3:return u==="x64"?"win32-x64":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$io=A;function E(g,u){return u==="web"&&!g.includes("web")}e.$jo=E;function f(g,u,c){return E(u,c)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===c}e.$ko=f;function h(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.$lo=h;var y;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(y||(e.SortBy=y={}));var v;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var b;(function(g){g.Install="install",g.Uninstall="uninstall"})(b||(e.StatisticType=b={}));var l;(function(g){g[g.None=1]="None",g[g.Install=2]="Install",g[g.Update=3]="Update",g[g.Migrate=4]="Migrate"})(l||(e.InstallOperation=l={})),e.$mo=(0,R.$3h)("extensionGalleryService");var p;(function(g){g.Unsupported="Unsupported",g.Deprecated="Deprecated",g.Malicious="Malicious",g.Incompatible="Incompatible",g.IncompatibleTargetPlatform="IncompatibleTargetPlatform",g.ReleaseVersionNotFound="ReleaseVersionNotFound",g.Invalid="Invalid",g.Download="Download",g.Extract="Extract",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Signature="Signature",g.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var w;(function(g){g.UnknownError="UnknownError",g.PackageIsInvalidZip="PackageIsInvalidZip",g.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(w||(e.ExtensionSignaturetErrorCode=w={}));class $ extends Error{constructor(u,c){super(u),this.code=c,this.name=c}}e.$no=$,e.$oo=(0,R.$3h)("extensionManagementService"),e.$po="extensionsIdentifiers/disabled",e.$qo="extensionsIdentifiers/enabled",e.$ro=(0,R.$3h)("IGlobalExtensionEnablementService"),e.$so=(0,R.$3h)("IExtensionTipsService"),e.$to=(0,P.localize)(0,null),e.$uo={value:e.$to,original:"Extensions"},e.$vo={value:(0,P.localize)(1,null),original:"Preferences"}}),define(re[209],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$69b=e.$59b=void 0,e.$59b=(0,P.$3h)("extensionHostStarter"),e.$69b="extensionHostStarter"}),define(re[210],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b2b=e.$a2b=void 0,e.$a2b=(0,P.$3h)("externalTerminal"),e.$b2b="Terminal.app"}),define(re[211],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$89b=void 0,e.$89b=(0,P.$3h)("externalTerminal")}),define(re[212],oe([0,1,48,50,13,9,4,76,21,89,174,210]),function(J,e,P,R,s,j,A,E,f,h,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$9b=e.$09b=e.$99b=void 0;const b=y.localize(0,null);class l{async getDefaultTerminalForPlatforms(){return{windows:p.getDefaultTerminalWindows(),linux:await $.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class p extends l{static{this.b="cmd.exe"}openTerminal(d,t){return this.spawnTerminal(P,d,h.$Ql(),t)}spawnTerminal(d,t,o,r){const i=t.windowsExec||p.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const n=j.$nc(i,".exe").toLowerCase();if(n==="cmder")return d.spawn(i,r?[r]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return i.indexOf(" ")>=0&&a.push('""'),a.push(i),n==="wt"&&a.push("-d ."),new Promise((m,D)=>{const I=g(process),k=d.spawn(o,a,{cwd:r,env:I,detached:!0});k.on("error",D),k.on("exit",()=>m())})}async runInTerminal(d,t,o,r,i){const n="windowsExec"in i&&i.windowsExec?i.windowsExec:p.getDefaultTerminalWindows(),a=await p.f();return new Promise((m,D)=>{const I=`"${t} - ${b}"`,k=`""${o.join('" "')}" & pause"`,C=Object.assign({},g(process),r);Object.keys(C).filter(Q=>C[Q]===null).forEach(Q=>delete C[Q]);const M={cwd:t,env:C,windowsVerbatimArguments:!0};let F,N;j.$nc(n,".exe")==="wt"?(F=n,N=["-d",".",p.b,"/c",k]):a?(F=a,N=["-d",t,n,"/c",k]):(F=p.b,N=["/c","start",I,"/wait",n,"/c",k]),P.spawn(F,N,M).on("error",Q=>{D(u(Q))}),m(void 0)})}static getDefaultTerminalWindows(){if(!p.d){const d=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${d?"Sysnative":"System32"}\\cmd.exe`}return p.d}static async f(){try{const d=await h.win32.findExecutable("wt");return await f.Promises.exists(d)?d:void 0}catch{return}}}e.$99b=p,Ee([R.$uh],p,"f",null);class w extends l{static{this.b="/usr/bin/osascript"}openTerminal(d,t){return this.spawnTerminal(P,d,t)}runInTerminal(d,t,o,r,i){const n=i.osxExec||v.$b2b;return new Promise((a,m)=>{if(n===v.$b2b||n==="iTerm.app"){const D=n===v.$b2b?"TerminalHelper":"iTermHelper",k=[s.$lg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",d||b,"-w",t];for(const F of o)k.push("-a"),k.push(F);if(r){const F=Object.assign({},g(process),r);for(const N in F){const Z=F[N];Z===null?(k.push("-u"),k.push(N)):(k.push("-e"),k.push(`${N}=${Z}`))}}let C="";const M=P.spawn(w.b,k);M.on("error",F=>{m(u(F))}),M.stderr.on("data",F=>{C+=F.toString()}),M.on("exit",F=>{if(F===0)a(void 0);else if(C){const N=C.split(`
`,1);m(new Error(N[0]))}else m(new Error(y.localize(1,null,D,F)))})}else m(new Error(y.localize(2,null,n)))})}spawnTerminal(d,t,o){const r=t.osxExec||v.$b2b;return new Promise((i,n)=>{const a=["-a",r];o&&a.push(o);const m=g(process),D=d.spawn("/usr/bin/open",a,{cwd:o,env:m});D.on("error",n),D.on("exit",()=>i())})}}e.$09b=w;class $ extends l{static{this.b=y.localize(3,null)}openTerminal(d,t){return this.spawnTerminal(P,d,t)}runInTerminal(d,t,o,r,i){const n=i.linuxExec?Promise.resolve(i.linuxExec):$.getDefaultTerminalLinuxReady();return new Promise((a,m)=>{const D=[];n.then(I=>{I.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const k=`${c(o)}; echo; read -p "${$.b}" -n1;`;D.push(`''${k}''`);const C=Object.assign({},g(process),r);Object.keys(C).filter(Z=>C[Z]===null).forEach(Z=>delete C[Z]);const M={cwd:t,env:C};let F="";const N=P.spawn(I,D,M);N.on("error",Z=>{m(u(Z))}),N.stderr.on("data",Z=>{F+=Z.toString()}),N.on("exit",Z=>{if(Z===0)a(void 0);else if(F){const Q=F.split(`
`,1);m(new Error(Q[0]))}else m(new Error(y.localize(4,null,I,Z)))})})})}static async getDefaultTerminalLinuxReady(){if(!$.d)if(!A.$k)$.d=Promise.resolve("xterm");else{const d=await f.Promises.exists("/etc/debian_version");$.d=new Promise(t=>{d?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return $.d}spawnTerminal(d,t,o){const r=t.linuxExec?Promise.resolve(t.linuxExec):$.getDefaultTerminalLinuxReady();return new Promise((i,n)=>{r.then(a=>{const m=g(process),D=d.spawn(a,[],{cwd:o,env:m});D.on("error",n),D.on("exit",()=>i())})})}}e.$$9b=$;function g(S){const d={...S.env};return(0,E.$Ol)(d),d}function u(S){return"errno"in S&&S.errno==="ENOENT"&&"path"in S&&typeof S.path=="string"?new Error(y.localize(5,null,S.path)):S}function c(S){let d="";for(const t of S)t.indexOf(" ")>=0?d+='"'+t+'"':d+=t,d+=" ";return d}}),define(re[16],oe([0,1,57,9,25,12,7,176,6,4,13,62]),function(J,e,P,R,s,j,A,E,f,h,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.FileKind=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.FileOperationResult=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.FileChangeType=e.$Fk=e.FileOperation=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.FileSystemProviderErrorCode=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.FileSystemProviderCapabilities=e.$pk=e.FilePermission=e.FileType=e.$ok=e.$nk=void 0,e.$nk=(0,f.$3h)("fileService");function b(q){return q.create===!0}e.$ok=b;var l;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(l||(e.FileType=l={}));var p;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(p||(e.FilePermission=p={}));function w(q){const te=q;return!!te&&typeof te.onDidChange=="function"}e.$pk=w;var $;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function g(q){return!!(q.capabilities&2)}e.$qk=g;function u(q){return!!(q.capabilities&8)}e.$rk=u;function c(q){return!!(q.capabilities&131072)}e.$sk=c;function S(q){return!!(q.capabilities&4)}e.$tk=S;function d(q){return!!(q.capabilities&16)}e.$uk=d;function t(q){return g(q)?!!(q.capabilities&16384):!1}e.$vk=t;function o(q){return g(q)?!!(q.capabilities&32768):!1}e.$wk=o;function r(q){return!!(q.capabilities&65536)}e.$xk=r;function i(q){return!!(q.capabilities&2048)}e.$yk=i;var n;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class a extends Error{static create(te,he){const G=new a(te.toString(),he);return I(G,he),G}constructor(te,he){super(te),this.code=he}}e.$zk=a;function m(q,te){return a.create(q,te)}e.$Ak=m;function D(q){return q||m((0,E.localize)(0,null),n.Unknown)}e.$Bk=D;function I(q,te){return q.name=te?`${te} (FileSystemError)`:"FileSystemError",q}e.$Ck=I;function k(q){if(!q)return n.Unknown;if(q instanceof a)return q.code;const te=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!te)return n.Unknown;switch(te[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$Dk=k;function C(q){if(q instanceof le)return q.fileOperationResult;switch(k(q)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$Ek=C;var M;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class F{constructor(te,he,G){this.resource=te,this.operation=he,this.target=G}isOperation(te){return this.operation===te}}e.$Fk=F;var N;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(N||(e.FileChangeType=N={}));class Z{static{this.a=null}constructor(te,he){this.c=he,this.b=void 0,this.d=new v.$V(()=>{const G=P.$9h.forUris(()=>this.c);return G.fill(this.rawAdded.map(O=>[O,!0])),G}),this.f=new v.$V(()=>{const G=P.$9h.forUris(()=>this.c);return G.fill(this.rawUpdated.map(O=>[O,!0])),G}),this.g=new v.$V(()=>{const G=P.$9h.forUris(()=>this.c);return G.fill(this.rawDeleted.map(O=>[O,!0])),G}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const G of te){switch(G.type){case 1:this.rawAdded.push(G.resource);break;case 0:this.rawUpdated.push(G.resource);break;case 2:this.rawDeleted.push(G.resource);break}this.b!==Z.a&&(typeof G.cId=="number"?this.b===void 0?this.b=G.cId:this.b!==G.cId&&(this.b=Z.a):this.b!==void 0&&(this.b=Z.a))}}contains(te,...he){return this.h(te,{includeChildren:!1},...he)}affects(te,...he){return this.h(te,{includeChildren:!0},...he)}h(te,he,...G){if(!te)return!1;const O=G.length>0;return!!((!O||G.includes(1))&&(this.d.value.get(te)||he.includeChildren&&this.d.value.findSuperstr(te))||(!O||G.includes(0))&&(this.f.value.get(te)||he.includeChildren&&this.f.value.findSuperstr(te))||(!O||G.includes(2))&&(this.g.value.findSubstr(te)||he.includeChildren&&this.g.value.findSuperstr(te)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(te){return this.b===te}hasCorrelation(){return typeof this.b=="number"}}e.$Gk=Z;function Q(q,te,he){return!q||!te||q===te||te.length>q.length?!1:(te.charAt(te.length-1)!==R.sep&&(te+=R.sep),he?(0,s.$0e)(q,te):q.indexOf(te)===0)}e.$Hk=Q;class le extends Error{constructor(te,he,G){super(te),this.fileOperationResult=he,this.options=G}}e.$Ik=le;class ce extends le{constructor(te,he,G,O){super(te,he,O),this.fileOperationResult=he,this.size=G}}e.$Jk=ce;class ue extends le{constructor(te,he,G){super(te,2,G),this.stat=he}}e.$Kk=ue;var X;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(X||(e.FileOperationResult=X={})),e.$Lk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Mk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Nk="files.associations",e.$Ok="files.exclude",e.$Pk="files.readonlyInclude",e.$Qk="files.readonlyExclude",e.$Rk="files.readonlyFromPermissions";var K;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(K||(e.FileKind=K={})),e.$Sk="";function H(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.$Tk=H;async function L(q,te){if(!te.hasProvider(A.URI.from({scheme:q.scheme})))return new Promise(he=>{const G=te.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===q.scheme&&O.added&&(G.dispose(),he())})})}e.$Uk=L;class T{static{this.KB=1024}static{this.MB=T.KB*T.KB}static{this.GB=T.MB*T.KB}static{this.TB=T.GB*T.KB}static formatSize(te){return(0,j.$Jf)(te)||(te=0),te<T.KB?(0,E.localize)(1,null,te.toFixed(0)):te<T.MB?(0,E.localize)(2,null,(te/T.KB).toFixed(2)):te<T.GB?(0,E.localize)(3,null,(te/T.MB).toFixed(2)):te<T.TB?(0,E.localize)(4,null,(te/T.GB).toFixed(2)):(0,E.localize)(5,null,(te/T.TB).toFixed(2))}}e.$Vk=T;function V(q){const te=typeof q=="string"||q?.scheme===y.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===y.Schemas.file?1024*T.MB:te?10*T.MB:h.$o?50*T.MB:1024*T.MB}e.$Wk=V}),define(re[118],oe([0,1,18,14,177,16]),function(J,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=void 0;async function A(y,v,b,l,p,w){let $;try{await E(y,v,b,l,p,w)}catch(g){$=g}finally{$&&p.errorTransformer&&($=p.errorTransformer($)),typeof $<"u"&&b.error($),b.end()}}e.$2p=A;async function E(y,v,b,l,p,w){f(w);const $=await y.open(v,{create:!1});try{f(w);let g=0,u=0,c=p&&typeof p.length=="number"?p.length:void 0,S=P.$ge.alloc(Math.min(p.bufferSize,typeof c=="number"?c:p.bufferSize)),d=p&&typeof p.position=="number"?p.position:0,t=0;do u=await y.read($,d,S.buffer,t,S.byteLength-t),d+=u,t+=u,g+=u,typeof c=="number"&&(c-=u),t===S.byteLength&&(await b.write(l(S)),S=P.$ge.alloc(Math.min(p.bufferSize,typeof c=="number"?c:p.bufferSize)),t=0);while(u>0&&(typeof c!="number"||c>0)&&f(w)&&h(g,p));if(t>0){let o=t;typeof c=="number"&&(o=Math.min(t,c)),b.write(l(S.slice(0,o)))}}catch(g){throw(0,j.$Bk)(g)}finally{await y.close($)}}function f(y){if(y.isCancellationRequested)throw(0,R.$6)();return!0}function h(y,v){if(typeof v?.limits?.size=="number"&&y>v.limits.size)throw(0,j.$Ak)((0,s.localize)(0,null),j.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(re[67],oe([0,1,104,2,9,4,7,16]),function(J,e,P,R,s,j,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=e.$9p=e.$8p=e.$7p=e.$6p=e.$5p=e.$4p=void 0;function f(g){return g.recursive===!0}e.$4p=f;class h extends R.$Sc{static{this.a=5}constructor(u,c,S,d){super(),this.h=u,this.j=c,this.m=S,this.n=d,this.c=this.B(new R.$Tc),this.f=void 0,this.g=0}s(){const u=new R.$Rc;this.c.value=u,this.b=this.r(u),this.b.setVerboseLogging(this.m),u.add(this.b.onDidChangeFile(c=>this.h(c))),u.add(this.b.onDidLogMessage(c=>this.j(c))),u.add(this.b.onDidError(c=>this.t(c)))}t(u){this.n.restartOnError?this.g<h.a&&this.f?(this.w(`restarting watcher after error: ${u}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${u}`):this.w(u)}u(u){this.g++,this.s(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.m=u,await this.b?.setVerboseLogging(u)}w(u){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${u}`})}y(u){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.$5p=h;class y extends h{constructor(u,c,S){super(u,c,S,{type:"node.js",restartOnError:!1})}}e.$6p=y;class v extends h{constructor(u,c,S){super(u,c,S,{type:"universal",restartOnError:!0})}}e.$7p=v;function b(g){return g.map(u=>({type:u.type,resource:A.URI.revive(u.resource),cId:u.cId}))}e.$8p=b;function l(g){const u=new $;for(const c of g)u.processEvent(c);return u.coalesce()}e.$9p=l;function p(g,u){return typeof u=="string"&&!u.startsWith(P.$Fj)&&!(0,s.$ic)(u)?{base:g,pattern:u}:u}e.$0p=p;function w(g,u){const c=[];for(const S of u)c.push((0,P.$Jj)(p(g,S)));return c}e.$$p=w;class ${constructor(){this.a=new Set,this.b=new Map}c(u){return j.$k?u.resource.fsPath:u.resource.fsPath.toLowerCase()}processEvent(u){const c=this.b.get(this.c(u));let S=!1;if(c){const d=c.type,t=u.type;c.resource.fsPath!==u.resource.fsPath&&(u.type===2||u.type===1)?S=!0:d===1&&t===2?(this.b.delete(this.c(u)),this.a.delete(c)):d===2&&t===1?c.type=0:d===1&&t===0||(c.type=t)}else S=!0;S&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],c=[];return Array.from(this.a).filter(S=>S.type!==2?(u.push(S),!1):!0).sort((S,d)=>S.resource.fsPath.length-d.resource.fsPath.length).filter(S=>c.some(d=>(0,E.$Hk)(S.resource.fsPath,d,!j.$k))?!1:(c.push(S.resource.fsPath),!0)).concat(u)}}}),define(re[213],oe([0,1,18,51,14,3,2,63,32,16,67]),function(J,e,P,R,s,j,A,E,f,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1N=e.$ZN=void 0,e.$ZN="localFilesystem";class v extends A.$Sc{constructor(l,p){super(),this.a=l,this.b=p,this.onDidChangeCapabilities=j.Event.None,this.f=this.B(new j.$Sd),this.onDidChangeFile=this.f.event,this.g=this.B(new j.$Sd),this.onDidWatchError=this.g.event,this.h=(0,f.$ng)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(l){return this.a.call("stat",[l])}readdir(l){return this.a.call("readdir",[l])}async readFile(l,p){const{buffer:w}=await this.a.call("readFile",[l,p]);return w}readFileStream(l,p,w){const $=(0,E.$7d)(u=>P.$ge.concat(u.map(c=>P.$ge.wrap(c))).buffer),g=new A.$Rc;return g.add(this.a.listen("readFileStream",[l,p])(u=>{if(u instanceof P.$ge)$.write(u.buffer);else{if(u==="end")$.end();else{let c;if(u instanceof Error)c=u;else{const S=u;c=(0,h.$Ak)(S.message??(0,R.$Ni)(S),S.code??h.FileSystemProviderErrorCode.Unknown)}$.error(c),$.end()}g.dispose()}})),g.add(w.onCancellationRequested(()=>{$.error((0,s.$6)()),$.end(),g.dispose()})),$}writeFile(l,p,w){return this.a.call("writeFile",[l,P.$ge.wrap(p),w])}open(l,p){return this.a.call("open",[l,p])}close(l){return this.a.call("close",[l])}async read(l,p,w,$,g){const[u,c]=await this.a.call("read",[l,p,g]);return w.set(u.buffer.slice(0,c),$),c}write(l,p,w,$,g){return this.a.call("write",[l,p,P.$ge.wrap(w),$,g])}mkdir(l){return this.a.call("mkdir",[l])}delete(l,p){return this.a.call("delete",[l,p])}rename(l,p,w){return this.a.call("rename",[l,p,w])}copy(l,p,w){return this.a.call("copy",[l,p,w])}cloneFile(l,p){return this.a.call("cloneFile",[l,p])}j(){this.B(this.a.listen("fileChange",[this.h])(l=>{if(Array.isArray(l)){const p=l;this.f.fire((0,y.$8p)(p))}else{const p=l;this.g.fire(p)}}))}watch(l,p){const w=(0,f.$ng)();return this.a.call("watch",[this.h,w,l,p]),(0,A.$Qc)(()=>this.a.call("unwatch",[this.h,w]))}}e.$1N=v}),define(re[214],oe([0,1,46,8,22,33,2,85,9,4,19,7,105,21,67]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$lq=void 0;class w extends A.$Sc{static{this.a=100}static{this.b=75}constructor(u,c,S,d){super(),this.m=u,this.n=c,this.r=S,this.s=d,this.c=this.B(new R.$fh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new R.$eh(t=>this.z(t),w.b)),this.g=(0,p.$$p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,p.$$p)(this.m.path,this.m.includes):void 0,this.j=new s.$3d,this.ready=this.t()}async t(){try{const u=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const c=await l.Promises.stat(u);this.B(await this.w(u,c.isDirectory()))}catch(u){u.code!=="ENOENT"?this.D(u):this.G(u)}}async u(u){let c=u.path;try{c=await l.Promises.realpath(u.path),u.path===c&&(c=await(0,b.$iq)(u.path)??u.path),u.path!==c&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${u.path}, real: ${c})`)}catch{}return c}async w(u,c){if(h.$j&&(0,j.$5f)(u,"/Volumes/",!0))return this.D(`Refusing to watch ${u} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$Sc.None;const S=new s.$3d(this.j.token),d=new A.$Rc;try{const t=v.URI.file(this.m.path),o=(0,f.$nc)(u),r=(0,P.watch)(u);d.add((0,A.$Qc)(()=>{r.removeAllListeners(),r.close()})),this.G(`Started watching: '${u}'`);const i=new Set;if(c)try{for(const a of await l.Promises.readdir(u))i.add(a)}catch(a){this.D(a)}const n=new Map;d.add((0,A.$Qc)(()=>{for(const[,a]of n)a.dispose();n.clear()})),r.on("error",(a,m)=>{this.D(`Failed to watch ${u} for changes using fs.watch() (${a}, ${m})`),this.dispose()}),r.on("change",(a,m)=>{if(S.token.isCancellationRequested)return;this.G(`[raw] ["${a}"] ${m}`);let D="";if(m&&(D=m.toString(),h.$j&&(D=(0,E.$Dl)(D))),!(!D||a!=="change"&&a!=="rename"))if(c)if(a==="rename"){n.get(D)?.dispose();const I=setTimeout(async()=>{if(n.delete(D),D===o&&!await l.Promises.exists(u)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const k=await this.C((0,f.$jc)(u,D));if(S.token.isCancellationRequested)return;let C;k?i.has(D)?C=0:(C=1,i.add(D)):(i.delete(D),C=2),this.y({resource:(0,y.$Eg)(t,D),type:C,cId:this.m.correlationId})},w.a);n.set(D,(0,A.$Qc)(()=>clearTimeout(I)))}else{let I;i.has(D)?I=0:(I=1,i.add(D)),this.y({resource:(0,y.$Eg)(t,D),type:I,cId:this.m.correlationId})}else if(a==="rename"||D!==o){const I=setTimeout(async()=>{const k=await l.Promises.exists(u);S.token.isCancellationRequested||(k?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),d.add(await this.w(u,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},w.a);d.clear(),d.add((0,A.$Qc)(()=>clearTimeout(I)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await l.Promises.exists(u)&&!S.token.isCancellationRequested&&this.D(`Failed to watch ${u} for changes using fs.watch() (${t.toString()})`)}return(0,A.$Qc)(()=>{S.dispose(!0),d.dispose()})}y(u,c=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`),!c&&this.g.some(S=>S(u.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${u.resource.fsPath}`):!c&&this.h&&this.h.length>0&&!this.h.some(S=>S(u.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${u.resource.fsPath}`):this.f.work(u))}z(u){const c=(0,p.$9p)(u);if(c.length>0){if(this.s)for(const d of c)this.G(` >> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`);this.c.work(c)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(u){if(h.$k)return l.Promises.exists(u);try{const c=(0,f.$nc)(u);return(await l.Promises.readdir((0,f.$mc)(u))).some(d=>d===c)}catch(c){return this.G(c),!1}}setVerboseLogging(u){this.s=u}D(u){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${u}`})}F(u){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${u}`})}G(u){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${u}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$lq=w;async function $(g,u,c,S,d=512){const t=await l.Promises.open(g,"r"),o=Buffer.allocUnsafe(d),r=new s.$3d(S);let i,n=!1;const a={path:g,excludes:[],recursive:!1},m=new w(a,D=>{(async()=>{for(const{type:I}of D)if(I===0){if(n)return;n=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:k}=await l.Promises.read(t,o,0,d,null);if(!k||r.token.isCancellationRequested)break;u(o.slice(0,k))}}catch(k){i=new Error(k),r.dispose(!0)}finally{n=!1}}})()});return await m.ready,c(),new Promise((D,I)=>{r.token.onCancellationRequested(async()=>{m.dispose();try{await l.Promises.close(t)}catch(k){i=new Error(k)}i?I(i):D()})})}e.$mq=$}),define(re[215],oe([0,1,3,104,2,4,214]),function(J,e,P,R,s,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;class E extends s.$Sc{constructor(){super(...arguments),this.a=this.B(new P.$Sd),this.onDidChangeFile=this.a.event,this.b=this.B(new P.$Sd),this.onDidLogMessage=this.b.event,this.onDidError=P.Event.None,this.c=new Map,this.f=!1}async watch(h){const y=this.j(h),v=y.filter(l=>{const p=this.c.get(l.path);return p?!(0,R.$Nj)(p.request.excludes,l.excludes)||!(0,R.$Nj)(p.request.includes,l.includes):!0}),b=Array.from(this.c.values()).filter(({request:l})=>!y.find(p=>p.path===l.path&&(0,R.$Nj)(p.excludes,l.excludes)&&(0,R.$Nj)(p.includes,l.includes))).map(({request:l})=>l.path);v.length&&this.m(`Request to start watching: ${v.map(l=>`${l.path} (excludes: ${l.excludes.length>0?l.excludes:"<none>"}, includes: ${l.includes&&l.includes.length>0?JSON.stringify(l.includes):"<all>"}, correlationId: ${typeof l.correlationId=="number"?l.correlationId:"<none>"})`).join(",")}`),b.length&&this.m(`Request to stop watching: ${b.join(",")}`);for(const l of b)this.h(l);for(const l of v)this.g(l)}g(h){const y=new A.$lq(h,b=>this.a.fire(b),b=>this.b.fire(b),this.f),v={request:h,instance:y};this.c.set(h.path,v)}async stop(){for(const[h]of this.c)this.h(h);this.c.clear()}h(h){const y=this.c.get(h);y&&(this.c.delete(h),y.instance.dispose())}j(h){const y=new Map;for(const v of h){const b=j.$k?v.path:v.path.toLowerCase();let l=y.get(v.correlationId);l||(l=new Map,y.set(v.correlationId,l)),l.set(b,v)}return Array.from(y.values()).map(v=>Array.from(v.values())).flat()}async setVerboseLogging(h){this.f=h;for(const[,y]of this.c)y.instance.setVerboseLogging(h)}m(h){this.f&&this.b.fire({type:"trace",message:this.n(h)})}n(h,y){return y?`[File Watcher (node.js)] ${h} (path: ${y.request.path})`:`[File Watcher (node.js)] ${h}`}}e.$nq=E}),define(re[216],oe([0,1,67,215]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=void 0;class s extends P.$6p{constructor(A,E,f){super(A,E,f),this.s()}r(A){return A.add(new R.$nq)}}e.$oq=s}),define(re[217],oe([0,1,13,42,160,67]),function(J,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=void 0;class A extends j.$7p{constructor(f,h,y){super(f,h,y),this.s()}r(f){const h=f.add(new s.$fq(P.$lg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(h.onDidProcessExit(({code:y,signal:v})=>this.t(`terminated by itself with code ${y}, signal: ${v}`))),R.ProxyChannel.toService((0,R.$Jh)(h.getChannel("watcher")))}}e.$gq=A}),define(re[92],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=void 0;class P{constructor(...s){this.a=new Map;for(const[j,A]of s)this.set(j,A)}set(s,j){const A=this.a.get(s);return this.a.set(s,j),A}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$1h=P}),define(re[218],oe([0,1,8,14,2,78,208,6,92,101]),function(J,e,P,R,s,j,A,E,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=void 0;const y=!1;class v extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class b{constructor($=new f.$1h,g=!1,u,c=y){this.f=$,this.g=g,this.h=u,this.i=c,this.o=new Set,this.f.set(E.$2h,this),this._globalGraph=c?u?._globalGraph??new A.$rq(S=>S):void 0}createChild($){return new b($,this.g,this,this.i)}invokeFunction($,...g){const u=p.traceInvocation(this.i,$);let c=!1;try{return $({get:d=>{if(c)throw(0,R.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(d,u);if(!t)throw new Error(`[invokeFunction] unknown service '${d}'`);return t}},...g)}finally{c=!0,u.stop()}}createInstance($,...g){let u,c;return $ instanceof j.$Zh?(u=p.traceCreation(this.i,$.ctor),c=this.j($.ctor,$.staticArguments.concat(g),u)):(u=p.traceCreation(this.i,$),c=this.j($,g,u)),u.stop(),c}j($,g=[],u){const c=E._util.getServiceDependencies($).sort((t,o)=>t.index-o.index),S=[];for(const t of c){const o=this.m(t.id,u);o||this.u(`[createInstance] ${$.name} depends on UNKNOWN service ${t.id}.`,!1),S.push(o)}const d=c.length>0?c[0].index:g.length;if(g.length!==d){console.trace(`[createInstance] First service dependency of ${$.name} at position ${d+1} conflicts with ${g.length} static arguments`);const t=d-g.length;t>0?g=g.concat(new Array(t)):g=g.slice(0,d)}return Reflect.construct($,g.concat(S))}k($,g){if(this.f.get($)instanceof j.$Zh)this.f.set($,g);else if(this.h)this.h.k($,g);else throw new Error("illegalState - setting UNKNOWN service instance")}l($){const g=this.f.get($);return!g&&this.h?this.h.l($):g}m($,g){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const u=this.l($);return u instanceof j.$Zh?this.q($,u,g.branch($,!0)):(g.branch($,!1),u)}q($,g,u){if(this.o.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.o.add($);try{return this.r($,g,u)}finally{this.o.delete($)}}r($,g,u){const c=new A.$rq(t=>t.id.toString());let S=0;const d=[{id:$,desc:g,_trace:u}];for(;d.length;){const t=d.pop();if(c.lookupOrInsertNode(t),S++>1e3)throw new v(c);for(const o of E._util.getServiceDependencies(t.desc.ctor)){const r=this.l(o.id);if(r||this.u(`[createInstance] ${$} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),r instanceof j.$Zh){const i={id:o.id,desc:r,_trace:t._trace.branch(o.id,!0)};c.insertEdge(t,i),d.push(i)}}}for(;;){const t=c.roots();if(t.length===0){if(!c.isEmpty())throw new v(c);break}for(const{data:o}of t){if(this.l(o.id)instanceof j.$Zh){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}c.removeNode(o)}}return this.l($)}s($,g,u=[],c,S){if(this.f.get($)instanceof j.$Zh)return this.t($,g,u,c,S);if(this.h)return this.h.s($,g,u,c,S);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}t($,g,u=[],c,S){if(c){const d=new b(void 0,this.g,this,this.i);d.c=String($);const t=new Map,o=new P.$jh(()=>{const r=d.j(g,u,S);for(const[i,n]of t){const a=r[i];if(typeof a=="function")for(const m of n)a.apply(r,m)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let m=t.get(i);return m||(m=new h.$3c,t.set(i,m)),(I,k,C)=>{const M=m.push([I,k,C]);return(0,s.$Qc)(M)}}if(i in r)return r[i];const n=o.value;let a=n[i];return typeof a!="function"||(a=a.bind(n),r[i]=a),a},set(r,i,n){return o.value[i]=n,!0},getPrototypeOf(r){return g.prototype}})}else return this.j(g,u,S)}u($,g){if(g&&console.warn($),this.g)throw new Error($)}}e.$sq=b;var l;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(l||(l={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation($,g){return $?new p(2,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation($,g){return $?new p(1,g.name):p.c}static{this.f=0}constructor($,g){this.type=$,this.name=g,this.g=Date.now(),this.h=[]}branch($,g){const u=new p(3,$.toString());return this.h.push([$,g,u]),u}stop(){const $=Date.now()-this.g;p.f+=$;let g=!1;function u(S,d){const t=[],o=new Array(S+1).join("	");for(const[r,i,n]of d.h)if(i&&n){g=!0,t.push(`${o}CREATES -> ${r}`);const a=u(S+1,n);a&&t.push(a)}else t.push(`${o}uses -> ${r}`);return t.join(`
`)}const c=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];($>2||g)&&p.all.add(c.join(`
`))}}e.$tq=p}),define(re[219],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ezb=e.IssueType=void 0;var R;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(R||(e.IssueType=R={})),e.$ezb=(0,P.$3h)("issueService")}),define(re[5],oe([0,1,51,3,45,2,31,4,19,12,7,114,6]),function(J,e,P,R,s,j,A,E,f,h,y,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.log=e.$nj=e.LogLevel=e.$mj=e.$lj=e.$kj=void 0,e.$kj=(0,b.$3h)("logService"),e.$lj=(0,b.$3h)("loggerService");function l(){return new Date().toISOString()}function p(I){return(0,h.$Jf)(I)}e.$mj=p;var w;(function(I){I[I.Off=0]="Off",I[I.Trace=1]="Trace",I[I.Debug=2]="Debug",I[I.Info=3]="Info",I[I.Warning=4]="Warning",I[I.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$nj=w.Info;function $(I,k,C){switch(k){case w.Trace:I.trace(C);break;case w.Debug:I.debug(C);break;case w.Info:I.info(C);break;case w.Warning:I.warn(C);break;case w.Error:I.error(C);break;case w.Off:break;default:throw new Error(`Invalid log level ${k}`)}}e.log=$;function g(I,k=!1){let C="";for(let M=0;M<I.length;M++){let F=I[M];if(F instanceof Error&&(F=(0,P.$Ni)(F,k)),typeof F=="object")try{F=JSON.stringify(F)}catch{}C+=(M>0?" ":"")+F}return C}class u extends j.$Sc{constructor(){super(...arguments),this.b=e.$nj,this.c=this.B(new R.$Sd),this.onDidChangeLogLevel=this.c.event}setLevel(k){this.b!==k&&(this.b=k,this.c.fire(this.b))}getLevel(){return this.b}f(k){return this.b!==w.Off&&this.b<=k}}e.$pj=u;class c extends u{constructor(k){super(),this.h=k}f(k){return this.h||super.f(k)}trace(k,...C){this.f(w.Trace)&&this.g(w.Trace,g([k,...C],!0))}debug(k,...C){this.f(w.Debug)&&this.g(w.Debug,g([k,...C]))}info(k,...C){this.f(w.Info)&&this.g(w.Info,g([k,...C]))}warn(k,...C){this.f(w.Warning)&&this.g(w.Warning,g([k,...C]))}error(k,...C){if(this.f(w.Error))if(k instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=k.stack,this.g(w.Error,g(M))}else this.g(w.Error,g([k,...C]))}flush(){}}e.$qj=c;class S extends u{constructor(k=e.$nj){super(),this.setLevel(k),this.g=!E.$i}trace(k,...C){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,k,...C):console.log(`[main ${l()}]`,k,...C))}debug(k,...C){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,k,...C):console.log(`[main ${l()}]`,k,...C))}info(k,...C){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,k,...C):console.log(`[main ${l()}]`,k,...C))}warn(k,...C){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,k,...C):console.warn(`[main ${l()}]`,k,...C))}error(k,...C){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,k,...C):console.error(`[main ${l()}]`,k,...C))}flush(){}}e.$rj=S;class d extends u{constructor(k=e.$nj,C=!0){super(),this.g=C,this.setLevel(k)}trace(k,...C){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",k,...C):console.log(k,...C))}debug(k,...C){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",k,...C):console.log(k,...C))}info(k,...C){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",k,...C):console.log(k,...C))}warn(k,...C){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",k,...C):console.log(k,...C))}error(k,...C){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",k,...C):console.error(k,...C))}flush(){}}e.$sj=d;class t extends u{constructor(k,C=e.$nj){super(),this.g=k,this.setLevel(C)}trace(k,...C){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(k),...C])}debug(k,...C){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(k),...C])}info(k,...C){this.f(w.Info)&&this.g.log(w.Info,[this.h(k),...C])}warn(k,...C){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(k),...C])}error(k,...C){this.f(w.Error)&&this.g.log(w.Error,[this.h(k),...C])}h(k){return typeof k=="string"?k:(0,P.$Ni)(k,this.f(w.Trace))}flush(){}}e.$tj=t;class o extends u{constructor(k){super(),this.g=k,k.length&&this.setLevel(k[0].getLevel())}setLevel(k){for(const C of this.g)C.setLevel(k);super.setLevel(k)}trace(k,...C){for(const M of this.g)M.trace(k,...C)}debug(k,...C){for(const M of this.g)M.debug(k,...C)}info(k,...C){for(const M of this.g)M.info(k,...C)}warn(k,...C){for(const M of this.g)M.warn(k,...C)}error(k,...C){for(const M of this.g)M.error(k,...C)}flush(){for(const k of this.g)k.flush()}dispose(){for(const k of this.g)k.dispose();super.dispose()}}e.$uj=o;class r extends j.$Sc{constructor(k,C,M){if(super(),this.h=k,this.j=C,this.b=new A.$Ac,this.c=this.B(new R.$Sd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$Sd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$Sd),this.onDidChangeVisibility=this.g.event,M)for(const F of M)this.b.set(F.resource,{logger:void 0,info:F})}m(k){return(0,h.$Ff)(k)?[...this.b.values()].find(C=>C.info.id===k):this.b.get(k)}getLogger(k){return this.m(k)?.logger}createLogger(k,C){const M=this.n(k),F=(0,h.$Ff)(k)?k:C?.id??(0,s.$Qi)(M.toString()).toString(16);let N=this.b.get(M)?.logger;const Z=C?.logLevel==="always"?w.Trace:C?.logLevel;N||(N=this.s(M,Z??this.getLogLevel(M)??this.h,{...C,id:F}));const Q={logger:N,info:{resource:M,id:F,logLevel:Z,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId,when:C?.when}};return this.registerLogger(Q.info),this.b.set(M,Q),N}n(k){return(0,h.$Ff)(k)?(0,f.$Eg)(this.j,`${k}.log`):k}setLogLevel(k,C){if(y.URI.isUri(k)){const M=k,F=C,N=this.b.get(M);N&&F!==N.info.logLevel&&(N.info.logLevel=F===this.h?void 0:F,N.logger?.setLevel(F),this.b.set(N.info.resource,N),this.f.fire([M,F]))}else{this.h=k;for(const[M,F]of this.b.entries())this.b.get(M)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(k,C){const M=this.m(k);M&&C!==!M.info.hidden&&(M.info.hidden=!C,this.b.set(M.info.resource,M),this.g.fire([M.info.resource,C]))}getLogLevel(k){let C;return k&&(C=this.b.get(k)?.info.logLevel),C??this.h}registerLogger(k){const C=this.b.get(k.resource);C?C.info.hidden!==k.hidden&&this.setVisibility(k.resource,!k.hidden):(this.b.set(k.resource,{info:k,logger:void 0}),this.c.fire({added:[k],removed:[]}))}deregisterLogger(k){const C=this.b.get(k);C&&(C.logger&&C.logger.dispose(),this.b.delete(k),this.c.fire({added:[],removed:[C.info]}))}*getRegisteredLoggers(){for(const k of this.b.values())yield k.info}getRegisteredLogger(k){return this.b.get(k)?.info}dispose(){this.b.forEach(k=>k.logger?.dispose()),this.b.clear(),super.dispose()}}e.$vj=r;class i{constructor(){this.onDidChangeLogLevel=new R.$Sd().event}setLevel(k){}getLevel(){return w.Info}trace(k,...C){}debug(k,...C){}info(k,...C){}warn(k,...C){}error(k,...C){}critical(k,...C){}dispose(){}flush(){}}e.$wj=i;class n extends i{}e.$xj=n;function a(I){if(I.verbose)return w.Trace;if(typeof I.logLevel=="string"){const k=D(I.logLevel.toLowerCase());if(k!==void 0)return k}return e.$nj}e.$yj=a;function m(I){switch(I){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.$zj=m;function D(I){switch(I){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$Aj=D,e.$Bj=new v.$hj("logLevel",m(w.Info))});var ne=this&&this.__param||function(J,e){return function(P,R){e(P,R,J)}};define(re[220],oe([0,1,15,4,5]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$49b=void 0;const j=P.safeStorage;let A=class{constructor(f){this.a=f,P.app.commandLine.getSwitchValue("password-store")==="basic"&&j.setUsePlainTextEncryption?.(!0)}async encrypt(f){this.a.trace("[EncryptionMainService] Encrypting value.");try{const h=JSON.stringify(j.encryptString(f));return this.a.trace("[EncryptionMainService] Encrypted value."),h}catch(h){throw this.a.error(h),h}}async decrypt(f){let h;try{if(h=JSON.parse(f),!h.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${f}`);const y=Buffer.from(h.data);this.a.trace("[EncryptionMainService] Decrypting value.");const v=j.decryptString(y);return this.a.trace("[EncryptionMainService] Decrypted value."),v}catch(y){throw this.a.error(y),y}}isEncryptionAvailable(){return Promise.resolve(j.isEncryptionAvailable())}getKeyStorageProvider(){if(R.$i)return Promise.resolve("dpapi");if(R.$j)return Promise.resolve("keychain_access");if(j.getSelectedStorageBackend)try{const f=j.getSelectedStorageBackend();return Promise.resolve(f)}catch(f){this.a.error(f)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(R.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(R.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!j.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");j.setUsePlainTextEncryption(!0)}};e.$49b=A,e.$49b=A=Ee([ne(0,s.$kj)],A)}),define(re[221],oe([0,1,23,8,14,3,2,9,67,5]),function(J,e,P,R,s,j,A,E,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=void 0;class y extends A.$Sc{constructor(b,l){super(),this.a=b,this.b=l,this.c=this.B(new j.$Sd),this.onDidChangeFile=this.c.event,this.g=this.B(new j.$Sd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new R.$1g(0)),this.w=[],this.y=this.B(new R.$1g(0))}watch(b,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n(b,l):this.z(b,l)}n(b,l){const p={path:this.H(b),excludes:l.excludes,includes:l.includes,recursive:l.recursive,correlationId:l.correlationId},w=(0,P.$Ub)(this.j,p);return this.r(),(0,A.$Qc)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(b=>(0,s.$1)(b))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,f.$8p)(l)),l=>this.G(l),this.a.getLevel()===h.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===h.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const l of this.j)(0,f.$4p)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const l of this.j)(0,f.$4p)(l)&&b.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(b,l){const p={path:this.H(b),excludes:l.excludes,includes:l.includes,recursive:!1,correlationId:l.correlationId},w=(0,P.$Ub)(this.w,p);return this.C(),(0,A.$Qc)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(b=>(0,s.$1)(b))}D(){return this.u||(this.u=this.B(this.F(b=>this.c.fire((0,f.$8p)(b)),b=>this.G(b),this.a.getLevel()===h.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===h.LogLevel.Trace)}))),this.u.watch(this.w)}G(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}H(b){return(0,E.$hc)(b.fsPath)}}e.$_p=y}),define(re[222],oe([0,1,23,8,18,22,3,45,72,2,57,13,68,19,63,175,16,118,5,14]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p,w,$,g,u,c){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0;let d=class extends h.$Sc{static{S=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new A.$Sd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$Sd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$Sd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$Sd),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$Sd),this.Y=this.B(new A.$Sd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$Sd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new R.$_g)}registerProvider(o,r){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${o}`);const i=new h.$Rc;return this.h.set(o,r),this.c.fire({added:!0,scheme:o,provider:r}),i.add(r.onDidChangeFile(n=>{const a=new $.$Gk(n,!this.S(r));this.X.fire(a),a.hasCorrelation()||this.Y.fire(a)})),typeof r.onDidWatchError=="function"&&i.add(r.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:o}))),(0,h.$Qc)(()=>{this.c.fire({added:!1,scheme:o,provider:r}),this.h.delete(o),(0,h.$Nc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const r=[];this.f.fire({scheme:o,join(i){r.push(i)}}),!this.h.has(o)&&await R.Promises.settled(r)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,r){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&r)}listCapabilities(){return f.Iterable.map(this.h,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async j(o){if(!(0,l.$Ig)(o))throw new $.$Ik((0,w.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const r=this.h.get(o.scheme);if(!r){const i=new c.$bb;throw i.message=(0,w.localize)(1,null,o.toString()),i}return r}async m(o){const r=await this.j(o);if((0,$.$tk)(r)||(0,$.$qk)(r)||(0,$.$uk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const r=await this.j(o);if((0,$.$tk)(r)||(0,$.$qk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.s(o,r)}catch(i){throw(0,$.$Dk)(i)===$.FileSystemProviderErrorCode.FileNotFound?new $.$Ik((0,w.localize)(2,null,this.sb(o)),1):(0,$.$Bk)(i)}}async s(o,r){const i=await this.j(o),n=this.S(i),a=r?.resolveTo,m=r?.resolveSingleChildDescendants,D=r?.resolveMetadata,I=await i.stat(o);let k;return this.t(i,o,I,void 0,!!D,(C,M)=>(k||(k=y.$9h.forUris(()=>!n),k.set(o,!0),a&&k.fill(!0,a)),k.get(C.resource)||k.findSuperstr(C.resource.with({query:null,fragment:null}))?!0:C.isDirectory&&m?M===1:!1))}async t(o,r,i,n,a,m){const{providerExtUri:D}=this.R(o),I={resource:r,name:D.basename(r),isFile:(i.type&$.FileType.File)!==0,isDirectory:(i.type&$.FileType.Directory)!==0,isSymbolicLink:(i.type&$.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&$.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&$.FilePermission.Locked),etag:(0,$.$Tk)({mtime:i.mtime,size:i.size}),children:void 0};if(I.isDirectory&&m(I,n)){try{const k=await o.readdir(r),C=await R.Promises.settled(k.map(async([M,F])=>{try{const N=D.joinPath(r,M),Z=a?await o.stat(N):{type:F};return await this.t(o,N,Z,k.length,a,m)}catch(N){return this.b.trace(N),null}}));I.children=(0,P.$Hb)(C)}catch(k){this.b.trace(k),I.children=[]}return I}return I}async resolveAll(o){return R.Promises.settled(o.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const r=await this.j(o),i=await r.stat(o);return this.t(r,o,i,void 0,!0,()=>!1)}async exists(o){const r=await this.j(o);try{return!!await r.stat(o)}catch{return!1}}async canCreateFile(o,r){try{await this.u(o,r)}catch(i){return i}return!0}async u(o,r){if(!r?.overwrite&&await this.exists(o))throw new $.$Ik((0,w.localize)(3,null,this.sb(o)),3,r)}async createFile(o,r=s.$ge.fromString(""),i){await this.u(o,i);const n=await this.writeFile(o,r);return this.r.fire(new $.$Fk(o,0,n)),n}async writeFile(o,r,i){const n=this.qb(await this.n(o),o),{providerExtUri:a}=this.R(n);let m=i;if((0,$.$wk)(n)&&!m?.atomic){const D=n.enforceAtomicWriteFile?.(o);D&&(m={...i,atomic:D})}try{await this.w(n,o,m)||await this.U(n,a.dirname(o));let I;if((0,$.$qk)(n)&&!(r instanceof s.$ge))if((0,p.$5d)(r)){const k=await(0,p.$_d)(r,3);k.ended?I=s.$ge.concat(k.buffer):I=k}else I=(0,p.$9d)(r,k=>s.$ge.concat(k),3);else I=r;!(0,$.$tk)(n)||(0,$.$qk)(n)&&I instanceof s.$ge||(0,$.$qk)(n)&&(0,$.$wk)(n)&&m?.atomic?await this.hb(n,o,m,I):await this.db(n,o,m,I instanceof s.$ge?(0,s.$re)(I):I),this.r.fire(new $.$Fk(o,4))}catch(D){throw new $.$Ik((0,w.localize)(4,null,this.sb(o),(0,$.$Bk)(D).toString()),(0,$.$Ek)(D),m)}return this.resolve(o,{resolveMetadata:!0})}async w(o,r,i){const n=!!i?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,w.localize)(5,null,this.sb(r)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,w.localize)(6,null,this.sb(r)));if(!(o.capabilities&2))throw new Error((0,w.localize)(7,null,this.sb(r)));if(n)throw new Error((0,w.localize)(8,null,this.sb(r)))}let m;try{m=await o.stat(r)}catch{return}if(m.type&$.FileType.Directory)throw new $.$Ik((0,w.localize)(9,null,this.sb(r)),0,i);if(this.rb(r,m),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==$.$Sk&&typeof m.mtime=="number"&&typeof m.size=="number"&&i.mtime<m.mtime&&i.etag!==(0,$.$Tk)({mtime:i.mtime,size:m.size}))throw new $.$Ik((0,w.localize)(10,null),3,i);return m}async readFile(o,r,i){const n=await this.m(o);return r?.atomic?this.z(n,o,r,i):this.C(n,o,r,i)}async z(o,r,i,n){return new Promise((a,m)=>{this.cb.queueFor(r,this.R(o).providerExtUri).queue(async()=>{try{const D=await this.C(o,r,i,n);a(D)}catch(D){m(D)}})})}async C(o,r,i,n){const a=await this.D(o,r,{...i,preferUnbuffered:!0},n);return{...a,value:await(0,s.$se)(a.value)}}async readFileStream(o,r,i){const n=await this.m(o);return this.D(n,o,r,i)}async D(o,r,i,n){const a=new j.$3d(n);let m=i;(0,$.$vk)(o)&&o.enforceAtomicReadFile?.(r)&&(m={...i,atomic:!0});const D=this.J(r,m).then(k=>k,k=>{throw a.dispose(!0),k});let I;try{return typeof m?.etag=="string"&&m.etag!==$.$Sk&&await D,m?.atomic&&(0,$.$vk)(o)||!((0,$.$tk)(o)||(0,$.$uk)(o))||(0,$.$qk)(o)&&m?.preferUnbuffered?I=this.I(o,r,m):(0,$.$uk)(o)?I=this.G(o,r,a.token,m):I=this.H(o,r,a.token,m),I.on("end",()=>a.dispose()),I.on("error",()=>a.dispose()),{...await D,value:I}}catch(k){throw I&&await(0,p.$0d)(I),this.F(k,r,m)}}F(o,r,i){const n=(0,w.localize)(11,null,this.sb(r),(0,$.$Bk)(o).toString());return o instanceof $.$Kk?new $.$Kk(n,o.stat,i):o instanceof $.$Jk?new $.$Jk(n,o.fileOperationResult,o.size,o.options):new $.$Ik(n,(0,$.$Ek)(o),i)}G(o,r,i,n=Object.create(null)){const a=o.readFileStream(r,n,i);return(0,p.$de)(a,{data:m=>m instanceof s.$ge?m:s.$ge.wrap(m),error:m=>this.F(m,r,n)},m=>s.$ge.concat(m))}H(o,r,i,n=Object.create(null)){const a=(0,s.$we)();return(0,g.$2p)(o,r,a,m=>m,{...n,bufferSize:this.a,errorTransformer:m=>this.F(m,r,n)},i),a}I(o,r,i){const n=(0,p.$7d)(a=>s.$ge.concat(a));return(async()=>{try{let a;i?.atomic&&(0,$.$vk)(o)?a=await o.readFile(r,{atomic:!0}):a=await o.readFile(r),typeof i?.position=="number"&&(a=a.slice(i.position)),typeof i?.length=="number"&&(a=a.slice(0,i.length)),this.L(r,a.byteLength,i),n.end(s.$ge.wrap(a))}catch(a){n.error(a),n.end()}})(),n}async J(o,r){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new $.$Ik((0,w.localize)(12,null,this.sb(o)),0,r);if(typeof r?.etag=="string"&&r.etag!==$.$Sk&&r.etag===i.etag)throw new $.$Kk((0,w.localize)(13,null),i,r);return this.L(o,i.size,r),i}L(o,r,i){if(typeof i?.limits?.size=="number"&&r>i.limits.size)throw new $.$Jk((0,w.localize)(14,null,this.sb(o)),7,r,i)}async canMove(o,r,i){return this.M(o,r,"move",i)}async canCopy(o,r,i){return this.M(o,r,"copy",i)}async M(o,r,i,n){if(o.toString()!==r.toString())try{const a=i==="move"?this.qb(await this.n(o),o):await this.m(o),m=this.qb(await this.n(r),r);await this.Q(a,o,m,r,i,n)}catch(a){return a}return!0}async move(o,r,i){const n=this.qb(await this.n(o),o),a=this.qb(await this.n(r),r),m=await this.N(n,o,a,r,"move",!!i),D=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new $.$Fk(o,m==="move"?2:3,D)),D}async copy(o,r,i){const n=await this.m(o),a=this.qb(await this.n(r),r),m=await this.N(n,o,a,r,"copy",!!i),D=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new $.$Fk(o,m==="copy"?3:2,D)),D}async N(o,r,i,n,a,m){if(r.toString()===n.toString())return a;const{exists:D,isSameResourceWithDifferentPathCase:I}=await this.Q(o,r,i,n,a,m);if(D&&!I&&m&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),a==="copy"){if(o===i&&(0,$.$rk)(o))await o.copy(r,n,{overwrite:m});else{const k=await this.resolve(r);k.isDirectory?await this.P(o,k,i,n):await this.O(o,r,i,n)}return a}else return o===i?(await o.rename(r,n,{overwrite:m}),a):(await this.N(o,r,i,n,"copy",m),await this.del(r,{recursive:!0}),"copy")}async O(o,r,i,n){if((0,$.$tk)(o)&&(0,$.$tk)(i))return this.jb(o,r,i,n);if((0,$.$tk)(o)&&(0,$.$qk)(i))return this.pb(o,r,i,n);if((0,$.$qk)(o)&&(0,$.$tk)(i))return this.nb(o,r,i,n);if((0,$.$qk)(o)&&(0,$.$qk)(i))return this.lb(o,r,i,n)}async P(o,r,i,n){await i.mkdir(n),Array.isArray(r.children)&&await R.Promises.settled(r.children.map(async a=>{const m=this.R(i).providerExtUri.joinPath(n,a.name);return a.isDirectory?this.P(o,await this.resolve(a.resource),i,m):this.O(o,a.resource,i,m)}))}async Q(o,r,i,n,a,m){let D=!1;if(o===i){const{providerExtUri:k,isPathCaseSensitive:C}=this.R(o);if(C||(D=k.isEqual(r,n)),D&&a==="copy")throw new Error((0,w.localize)(15,null,this.sb(r),this.sb(n)));if(!D&&k.isEqualOrParent(n,r))throw new Error((0,w.localize)(16,null,this.sb(r),this.sb(n)))}const I=await this.exists(n);if(I&&!D){if(!m)throw new $.$Ik((0,w.localize)(17,null,this.sb(r),this.sb(n)),4);if(o===i){const{providerExtUri:k}=this.R(o);if(k.isEqualOrParent(r,n))throw new Error((0,w.localize)(18,null,this.sb(r),this.sb(n)))}}return{exists:I,isSameResourceWithDifferentPathCase:D}}R(o){const r=this.S(o);return{providerExtUri:r?l.$ug:l.$wg,isPathCaseSensitive:r}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const r=this.qb(await this.j(o),o);await this.U(r,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new $.$Fk(o,0,i)),i}async U(o,r){const i=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(r,n.dirname(r));)try{if(!((await o.stat(r)).type&$.FileType.Directory))throw new Error((0,w.localize)(19,null,this.sb(r)));break}catch(a){if((0,$.$Dk)(a)!==$.FileSystemProviderErrorCode.FileNotFound)throw a;i.push(n.basename(r)),r=n.dirname(r)}for(let a=i.length-1;a>=0;a--){r=n.joinPath(r,i[a]);try{await o.mkdir(r)}catch(m){if((0,$.$Dk)(m)!==$.FileSystemProviderErrorCode.FileExists)throw m}}}async canDelete(o,r){try{await this.W(o,r)}catch(i){return i}return!0}async W(o,r){const i=this.qb(await this.j(o),o),n=!!r?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,w.localize)(20,null,this.sb(o)));const a=r?.atomic;if(a&&!(i.capabilities&65536))throw new Error((0,w.localize)(21,null,this.sb(o)));if(n&&a)throw new Error((0,w.localize)(22,null,this.sb(o)));let m;try{m=await i.stat(o)}catch{}if(m)this.rb(o,m);else throw new $.$Ik((0,w.localize)(23,null,this.sb(o)),1);if(!!!r?.recursive){const I=await this.resolve(o);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,w.localize)(24,null,this.sb(o)))}return i}async del(o,r){const i=await this.W(o,r);let n=r;if((0,$.$xk)(i)&&!n?.atomic){const I=i.enforceAtomicDelete?.(o);I&&(n={...r,atomic:I})}const a=!!n?.useTrash,m=!!n?.recursive,D=n?.atomic??!1;await i.delete(o,{recursive:m,useTrash:a,atomic:D}),this.r.fire(new $.$Fk(o,1))}async cloneFile(o,r){const i=await this.j(o),n=this.qb(await this.n(r),r);if(i===n&&this.R(i).providerExtUri.isEqual(o,r))return;if(i===n&&(0,$.$sk)(i))return i.cloneFile(o,r);await this.U(n,this.R(n).providerExtUri.dirname(r));const a=this.cb.queueFor(o,this.R(i).providerExtUri);return i===n&&(0,$.$rk)(i)?a.queue(()=>i.copy(o,r,{overwrite:!0})):a.queue(()=>this.O(i,o,n,r))}static{this.ab=0}createWatcher(o,r){return this.watch(o,{...r,correlationId:S.ab++})}watch(o,r={recursive:!1,excludes:[]}){const i=new h.$Rc;let n=!1,a=()=>{n=!0};i.add((0,h.$Qc)(()=>a())),(async()=>{try{const D=await this.bb(o,r);n?(0,h.$Nc)(D):a=()=>(0,h.$Nc)(D)}catch(D){this.b.error(D)}})();const m=r.correlationId;if(typeof m=="number"){const D=i.add(new A.$Sd);return i.add(this.X.event(k=>{k.correlates(m)&&D.fire(k)})),{onDidChange:D.event,dispose:()=>i.dispose()}}return i}async bb(o,r){const i=await this.j(o),n=(0,E.$Qi)([this.R(i).providerExtUri.getComparisonKey(o),r]);let a=this.$.get(n);return a||(a={count:0,disposable:i.watch(o,r)},this.$.set(n,a)),a.count+=1,(0,h.$Qc)(()=>{a&&(a.count--,a.count===0&&((0,h.$Nc)(a.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,h.$Nc)(o.disposable);this.$.clear()}async db(o,r,i,n){return this.cb.queueFor(r,this.R(o).providerExtUri).queue(async()=>{const a=await o.open(r,{create:!0,unlock:i?.unlock??!1});try{(0,p.$5d)(n)||(0,p.$6d)(n)?await this.eb(o,a,n):await this.fb(o,a,n)}catch(m){throw(0,$.$Bk)(m)}finally{await o.close(a)}})}async eb(o,r,i){let n=0,a;if((0,p.$6d)(i)){if(i.buffer.length>0){const m=s.$ge.concat(i.buffer);await this.gb(o,r,m,m.byteLength,n,0),n+=m.byteLength}if(i.ended)return;a=i.stream}else a=i;return new Promise((m,D)=>{(0,p.$$d)(a,{onData:async I=>{a.pause();try{await this.gb(o,r,I,I.byteLength,n,0)}catch(k){return D(k)}n+=I.byteLength,setTimeout(()=>a.resume())},onError:I=>D(I),onEnd:()=>m()})})}async fb(o,r,i){let n=0,a;for(;(a=i.read())!==null;)await this.gb(o,r,a,a.byteLength,n,0),n+=a.byteLength}async gb(o,r,i,n,a,m){let D=0;for(;D<n;){const I=await o.write(r,a+D,i.buffer,m+D,n-D);D+=I}}async hb(o,r,i,n){return this.cb.queueFor(r,this.R(o).providerExtUri).queue(()=>this.ib(o,r,i,n))}async ib(o,r,i,n){let a;n instanceof s.$ge?a=n:(0,p.$5d)(n)?a=await(0,s.$se)(n):(0,p.$6d)(n)?a=await(0,s.$te)(n):a=(0,s.$qe)(n),await o.writeFile(r,a.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,r,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.kb(o,r,i,n))}async kb(o,r,i,n){let a,m;try{a=await o.open(r,{create:!1}),m=await i.open(n,{create:!0,unlock:!1});const D=s.$ge.alloc(this.a);let I=0,k=0,C=0;do C=await o.read(a,I,D.buffer,k,D.byteLength-k),await this.gb(i,m,D,C,I,k),I+=C,k+=C,k===D.byteLength&&(k=0);while(C>0)}catch(D){throw(0,$.$Bk)(D)}finally{await R.Promises.settled([typeof a=="number"?o.close(a):Promise.resolve(),typeof m=="number"?i.close(m):Promise.resolve()])}}async lb(o,r,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.mb(o,r,i,n))}async mb(o,r,i,n){return i.writeFile(n,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,r,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.ob(o,r,i,n))}async ob(o,r,i,n){const a=await i.open(n,{create:!0,unlock:!1});try{const m=await o.readFile(r);await this.gb(i,a,s.$ge.wrap(m),m.byteLength,0,0)}catch(m){throw(0,$.$Bk)(m)}finally{await i.close(a)}}async pb(o,r,i,n){const a=await(0,s.$se)(this.H(o,r,j.CancellationToken.None));await this.hb(i,n,void 0,a)}qb(o,r){if(o.capabilities&2048)throw new $.$Ik((0,w.localize)(25,null,this.sb(r)),6);return o}rb(o,r){if((r.permissions??0)&$.FilePermission.Readonly)throw new $.$Ik((0,w.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===v.Schemas.file?o.fsPath:o.toString(!0)}};e.$3p=d,e.$3p=d=S=Ee([ne(0,u.$kj)],d)}),define(re[93],oe([0,1,46,311,8,31,18,3,33,2,9,4,19,63,21,179,16,118,221,51,217,216]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p,w,$,g,u,c,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=void 0,(()=>{try{(0,R.gracefulify)(P)}catch(o){console.error(`Error enabling graceful-fs: ${(0,c.$Ni)(o)}`)}})();class t extends u.$_p{static{this.I=!1}constructor(r,i){super(r,i),this.onDidChangeCapabilities=E.Event.None,this.N=new j.$Ac(n=>b.$vg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,v.$k&&(this.J|=1024)),this.J}async stat(r){try{const{stat:i,symbolicLink:n}=await p.SymlinkSupport.stat(this.H(r));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:$.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await p.Promises.readdir(this.H(r),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async a=>{try{let m;a.isSymbolicLink()?m=(await this.stat((0,b.$Eg)(r,a.name))).type:m=this.M(a),n.push([a.name,m])}catch(m){this.a.trace(m)}})),n}catch(i){throw this.fb(i)}}M(r,i){let n;return i?.dangling?n=$.FileType.Unknown:r.isFile()?n=$.FileType.File:r.isDirectory()?n=$.FileType.Directory:n=$.FileType.Unknown,i&&(n|=$.FileType.SymbolicLink),n}async O(r){const i=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const a=new s.$2g;return this.N.set(r,a),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,h.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(r)===a&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),a.open()})}async readFile(r,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),n=await this.O(r));const a=this.H(r);return await p.Promises.readFile(a)}catch(a){throw this.fb(a)}finally{n?.dispose()}}P(r){t.I&&this.a.trace(r)}readFileStream(r,i,n){const a=(0,l.$7d)(m=>A.$ge.concat(m.map(D=>A.$ge.wrap(D))).buffer);return(0,g.$2p)(this,r,a,m=>m.buffer,{...i,bufferSize:256*1024},n),a}async writeFile(r,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(r)?this.R(r,(0,b.$Eg)((0,b.$Dg)(r),`${(0,b.$Bg)(r)}${n.atomic.postfix}`),i,n):this.S(r,i,n)}async Q(r){try{const i=this.H(r),{symbolicLink:n}=await p.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async R(r,i,n,a){const m=new h.$Rc;try{m.add(await this.O(r)),m.add(await this.O(i)),await this.S(i,n,a,!0);try{await this.rename(i,r,{overwrite:!0})}catch(D){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{m.dispose()}}async S(r,i,n,a){let m;try{const D=this.H(r);if(!n.create||!n.overwrite){if(await p.Promises.exists(D)){if(!n.overwrite)throw(0,$.$Ak)((0,w.localize)(0,null),$.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,$.$Ak)((0,w.localize)(1,null),$.FileSystemProviderErrorCode.FileNotFound)}m=await this.open(r,{create:!0,unlock:n.unlock},a),await this.write(m,0,i,0,i.byteLength)}catch(D){throw await this.gb(r,D)}finally{typeof m=="number"&&await this.close(m)}}static{this.Y=!0}static configureFlushOnWrite(r){t.Y=r}async open(r,i,n){const a=this.H(r);let m;(0,$.$ok)(i)&&!n&&(m=await this.O(r));let D;try{if((0,$.$ok)(i)&&i.unlock)try{const{stat:k}=await p.SymlinkSupport.stat(a);k.mode&128||await p.Promises.chmod(a,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}let I;if((0,$.$ok)(i)){if(v.$i)try{await p.Promises.truncate(a,0),I="r+"}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}I||(I="w")}else I="r";D=await p.Promises.open(a,I)}catch(I){throw m?.dispose(),(0,$.$ok)(i)?await this.gb(r,I):this.fb(I)}if(this.U.set(D,0),(0,$.$ok)(i)&&this.X.set(D,r),m){const I=this.W.get(D);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${a})`),this.W.set(D,m),I&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${a})`),I.dispose())}return D}async close(r){const i=this.W.get(r);try{if(this.U.delete(r),this.X.delete(r)&&t.Y)try{await p.Promises.fdatasync(r)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await p.Promises.close(r)}catch(n){throw this.fb(n)}finally{i&&(this.W.get(r)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.W.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,n,a,m){const D=this.Z(r,i);let I=null;try{I=(await p.Promises.read(r,n,a,m,D)).bytesRead}catch(k){throw this.fb(k)}finally{this.$(r,D,I)}return I}Z(r,i){return i===this.U.get(r)?null:i}$(r,i,n){const a=this.U.get(r);typeof a=="number"&&(typeof i=="number"||(typeof n=="number"?this.U.set(r,a+n):this.U.delete(r)))}async write(r,i,n,a,m){return(0,s.$kh)(()=>this.ab(r,i,n,a,m),100,3)}async ab(r,i,n,a,m){const D=this.Z(r,i);let I=null;try{I=(await p.Promises.write(r,n,a,m,D)).bytesWritten}catch(k){throw await this.gb(this.X.get(r),k)}finally{this.$(r,D,I)}return I}async mkdir(r){try{await p.Promises.mkdir(this.H(r))}catch(i){throw this.fb(i)}}async delete(r,i){try{const n=this.H(r);if(i.recursive){let a;i?.atomic!==!1&&i.atomic.postfix&&(a=(0,y.$jc)((0,y.$mc)(n),`${(0,y.$nc)(n)}${i.atomic.postfix}`)),await p.Promises.rm(n,p.RimRafMode.MOVE,a)}else try{await p.Promises.unlink(n)}catch(a){if(a.code==="EPERM"||a.code==="EISDIR"){let m=!1;try{const{stat:D,symbolicLink:I}=await p.SymlinkSupport.stat(n);m=D.isDirectory()&&!I}catch{}if(m)await p.Promises.rmdir(n);else throw a}else throw a}}catch(n){throw this.fb(n)}}async rename(r,i,n){const a=this.H(r),m=this.H(i);if(a!==m)try{await this.bb(r,i,"move",n.overwrite),await p.Promises.rename(a,m)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,w.localize)(2,null,(0,y.$nc)(a),(0,y.$nc)((0,y.$mc)(m)),D.toString()))),this.fb(D)}}async copy(r,i,n){const a=this.H(r),m=this.H(i);if(a!==m)try{await this.bb(r,i,"copy",n.overwrite),await p.Promises.copy(a,m,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,w.localize)(3,null,(0,y.$nc)(a),(0,y.$nc)((0,y.$mc)(m)),D.toString()))),this.fb(D)}}async bb(r,i,n,a){const m=this.H(r),D=this.H(i);let I=!1;if(!!(this.capabilities&1024)||(I=(0,f.$4f)(m,D,!0)),I){if(n==="copy")throw(0,$.$Ak)((0,w.localize)(4,null),$.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const C=await this.L(r);if(!C)throw(0,$.$Ak)((0,w.localize)(5,null),$.FileSystemProviderErrorCode.FileNotFound);const M=await this.L(i);if(M){if(!a)throw(0,$.$Ak)((0,w.localize)(6,null),$.FileSystemProviderErrorCode.FileExists);C.type&$.FileType.File&&M.type&$.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.cb(r,i,!1)}async cb(r,i,n){const a=this.H(r),m=this.H(i),D=!!(this.capabilities&1024);if((0,f.$4f)(a,m,!D))return;const I=new h.$Rc;try{I.add(await this.O(r)),I.add(await this.O(i)),n&&await p.Promises.mkdir((0,y.$mc)(m),{recursive:!0}),await p.Promises.copyFile(a,m)}catch(k){if(k.code==="ENOENT"&&!n)return this.cb(r,i,!0);throw this.fb(k)}finally{I.dispose()}}t(r,i,n){return new S.$gq(a=>r(a),a=>i(a),n)}F(r,i,n){return new d.$oq(a=>r(a),a=>i(a),n)}fb(r){if(r instanceof $.$zk)return r;let i=r,n;switch(r.code){case"ENOENT":n=$.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=$.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=$.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=$.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=$.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=$.FileSystemProviderErrorCode.Unknown;break;default:n=$.FileSystemProviderErrorCode.Unknown}return(0,$.$Ak)(i,n)}async gb(r,i){let n=this.fb(i);if(r&&n.code===$.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await p.SymlinkSupport.stat(this.H(r));a.mode&128||(n=(0,$.$Ak)(i,$.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return n}}e.$pq=t}),define(re[223],oe([0,1,3,93,2,18,63,22]),function(J,e,P,R,s,j,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=e.$Xr=void 0;class f extends s.$Sc{constructor(v,b){super(),this.a=v,this.b=b,this.F=new Map,this.G=new Map}call(v,b,l){const p=this.c(v);switch(b){case"stat":return this.g(p,l[0]);case"readdir":return this.h(p,l[0]);case"open":return this.r(p,l[0],l[1]);case"close":return this.s(l[0]);case"read":return this.t(l[0],l[1],l[2]);case"readFile":return this.j(p,l[0],l[1]);case"write":return this.u(l[0],l[1],l[2],l[3],l[4]);case"writeFile":return this.n(p,l[0],l[1],l[2]);case"rename":return this.z(p,l[0],l[1],l[2]);case"copy":return this.C(p,l[0],l[1],l[2]);case"cloneFile":return this.D(p,l[0],l[1]);case"mkdir":return this.w(p,l[0]);case"delete":return this.y(p,l[0],l[1]);case"watch":return this.I(p,l[0],l[1],l[2],l[3]);case"unwatch":return this.J(l[0],l[1])}throw new Error(`IPC Command ${b} not found`)}listen(v,b,l){const p=this.c(v);switch(b){case"fileChange":return this.H(p,l[0]);case"readFileStream":return this.m(p,l[0],l[1])}throw new Error(`Unknown event ${b}`)}g(v,b){const l=this.f(v,b,!0);return this.a.stat(l)}h(v,b){const l=this.f(v,b);return this.a.readdir(l)}async j(v,b,l){const p=this.f(v,b,!0),w=await this.a.readFile(p,l);return j.$ge.wrap(w)}m(v,b,l){const p=this.f(v,b,!0),w=new E.$3d,$=new P.$Sd({onDidRemoveLastListener:()=>{w.cancel()}}),g=this.a.readFileStream(p,l,w.token);return(0,A.$$d)(g,{onData:u=>$.fire(j.$ge.wrap(u)),onError:u=>$.fire(u),onEnd:()=>{$.fire("end"),$.dispose(),w.dispose()}}),$.event}n(v,b,l,p){const w=this.f(v,b);return this.a.writeFile(w,l.buffer,p)}r(v,b,l){const p=this.f(v,b,!0);return this.a.open(p,l)}s(v){return this.a.close(v)}async t(v,b,l){const p=j.$ge.alloc(l),w=0,$=await this.a.read(v,b,p.buffer,w,l);return[p,$]}u(v,b,l,p,w){return this.a.write(v,b,l.buffer,p,w)}w(v,b){const l=this.f(v,b);return this.a.mkdir(l)}y(v,b,l){const p=this.f(v,b);return this.a.delete(p,l)}z(v,b,l,p){const w=this.f(v,b),$=this.f(v,l);return this.a.rename(w,$,p)}C(v,b,l,p){const w=this.f(v,b),$=this.f(v,l);return this.a.copy(w,$,p)}D(v,b,l){const p=this.f(v,b),w=this.f(v,l);return this.a.cloneFile(p,w)}H(v,b){const l=new P.$Sd({onWillAddFirstListener:()=>{this.F.set(b,this.L(v,l))},onDidRemoveLastListener:()=>{(0,s.$Nc)(this.F.get(b)),this.F.delete(b)}});return l.event}async I(v,b,l,p,w){const $=this.F.get(b);if($){const g=this.f(v,p),u=$.watch(l,g,w);this.G.set(b+l,u)}}async J(v,b){const l=v+b,p=this.G.get(l);p&&((0,s.$Nc)(p),this.G.delete(l))}dispose(){super.dispose();for(const[,v]of this.G)v.dispose();this.G.clear();for(const[,v]of this.F)v.dispose();this.F.clear()}}e.$Xr=f;class h extends s.$Sc{constructor(v,b,l,p){super(),this.c=v,this.f=l,this.g=p,this.a=new Map,this.b=this.B(new R.$pq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(b)}h(v){const b=this.B(new P.$Sd);this.B(b.event(l=>{v.fire(l.map(p=>({resource:this.c.transformOutgoingURI(p.resource),type:p.type,cId:p.cId})))})),this.B(this.b.onDidChangeFile(l=>b.fire(l))),this.B(this.b.onDidWatchError(l=>v.fire(l)))}j(v){}m(v){}watch(v,b,l){const p=this.m(this.g);return Array.isArray(p)&&(l.excludes=[...l.excludes,...p]),this.a.set(v,this.b.watch(b,l)),(0,s.$Qc)(()=>{(0,s.$Nc)(this.a.get(v)),this.a.delete(v)})}dispose(){for(const[,v]of this.a)v.dispose();this.a.clear(),super.dispose()}}e.$Yr=h}),define(re[224],oe([0,1,15,178,4,7,16,9,223,155]),function(J,e,P,R,s,j,A,E,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_9b=void 0;class y extends f.$Xr{constructor(l,p,w){super(l,p),this.M=w}c(l){return h.$2m}f(l,p){return j.URI.revive(p)}async y(l,p,w){if(!w.useTrash)return super.y(l,p,w);const $=this.f(l,p),g=(0,E.$hc)($.fsPath);try{await P.shell.trashItem(g)}catch{throw(0,A.$Ak)(s.$i?(0,R.localize)(0,null,(0,E.$nc)(g)):(0,R.localize)(1,null,(0,E.$nc)(g)),A.FileSystemProviderErrorCode.Unknown)}}L(l,p){return new v(l,p,this.b,this.M)}}e.$_9b=y;class v extends f.$Yr{watch(l,p,w){if(w.recursive)throw(0,A.$Ak)("Recursive file watching is not supported from main process for performance reasons.",A.FileSystemProviderErrorCode.Unavailable);return super.watch(l,p,w)}}}),define(re[225],oe([0,1,5]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z6b=void 0;class R extends P.$qj{constructor(j=P.$nj){super(),this.m=[],this.n=void 0,this.setLevel(j),this.B(this.onDidChangeLogLevel(A=>{this.n?.setLevel(A)}))}set logger(j){this.n=j;for(const{level:A,message:E}of this.m)(0,P.log)(j,A,E);this.m=[]}g(j,A){this.n?(0,P.log)(this.n,j,A):this.getLevel()<=j&&this.m.push({level:j,message:A})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$Z6b=R}),define(re[226],oe([0,1,7,3,5,2]),function(J,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=e.$or=e.$nr=void 0;class A extends s.$vj{constructor(v,b,l,p,w){super(b,l,p),this.r=v,this.t=w,this.B(w.listen("onDidChangeLogLevel",v)($=>{(0,s.$mj)($)?super.setLogLevel($):super.setLogLevel(P.URI.revive($[0]),$[1])})),this.B(w.listen("onDidChangeVisibility",v)(([$,g])=>super.setVisibility(P.URI.revive($),g))),this.B(w.listen("onDidChangeLoggers",v)(({added:$,removed:g})=>{for(const u of $)super.registerLogger({...u,resource:P.URI.revive(u.resource)});for(const u of g)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new s.$tj({log:(v,b)=>{this.t.call("consoleLog",[v,b])}})}registerLogger(v){super.registerLogger(v),this.t.call("registerLogger",[v,this.r])}deregisterLogger(v){super.deregisterLogger(v),this.t.call("deregisterLogger",[v,this.r])}setLogLevel(v,b){super.setLogLevel(v,b),this.t.call("setLogLevel",[v,b])}setVisibility(v,b){super.setVisibility(v,b),this.t.call("setVisibility",[this.n(v),b])}s(v,b,l){return new E(this.t,v,b,l,this.r)}static setLogLevel(v,b,l){return v.call("setLogLevel",[b,l])}}e.$nr=A;class E extends s.$qj{constructor(v,b,l,p,w){super(p?.logLevel==="always"),this.r=v,this.s=b,this.m=!1,this.n=[],this.setLevel(l),this.r.call("createLogger",[b,p,w]).then(()=>{this.u(this.n),this.m=!0})}g(v,b){const l=[[v,b]];this.m?this.u(l):this.n.push(...l)}u(v){this.r.call("log",[this.s,v])}}class f{constructor(v,b){this.a=v,this.b=b}listen(v,b){const l=this.b(v);switch(b){case"onDidChangeLoggers":return R.Event.map(this.a.onDidChangeLoggers,p=>({added:[...p.added].map(w=>this.c(w,l)),removed:[...p.removed].map(w=>this.c(w,l))}));case"onDidChangeVisibility":return R.Event.map(this.a.onDidChangeVisibility,p=>[l.transformOutgoingURI(p[0]),p[1]]);case"onDidChangeLogLevel":return R.Event.map(this.a.onDidChangeLogLevel,p=>(0,s.$mj)(p)?p:[l.transformOutgoingURI(p[0]),p[1]])}throw new Error(`Event not found: ${b}`)}async call(v,b,l){const p=this.b(v);switch(b){case"setLogLevel":return(0,s.$mj)(l[0])?this.a.setLogLevel(l[0]):this.a.setLogLevel(P.URI.revive(p.transformIncoming(l[0][0])),l[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(w=>this.c(w,p)))}throw new Error(`Call not found: ${b}`)}c(v,b){return{...v,resource:b.transformOutgoingURI(v.resource)}}}e.$or=f;class h extends j.$Sc{constructor(v,b){super(),b.call("setLogLevel",[v.getLogLevel()]),this.B(v.onDidChangeLogLevel(l=>b.call("setLogLevel",[l]))),b.call("getRegisteredLoggers").then(l=>{for(const p of l)v.registerLogger({...p,resource:P.URI.revive(p.resource)})}),this.B(b.listen("onDidChangeVisibility")(([l,p])=>v.setVisibility(P.URI.revive(l),p))),this.B(b.listen("onDidChangeLoggers")(({added:l,removed:p})=>{for(const w of l)v.registerLogger({...w,resource:P.URI.revive(w.resource)});for(const w of p)v.deregisterLogger(w.resource)}))}}e.$pr=h}),define(re[227],oe([0,1,2,5]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fO=void 0;class s extends P.$Sc{constructor(A,E=[]){super(),this.a=new R.$uj([A,...E]),this.B(A.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...E){this.a.trace(A,...E)}debug(A,...E){this.a.debug(A,...E)}info(A,...E){this.a.info(A,...E)}warn(A,...E){this.a.warn(A,...E)}error(A,...E){this.a.error(A,...E)}flush(){this.a.flush()}}e.$fO=s}),define(re[228],oe([0,1,31,7,5]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$60b=void 0;class j{constructor(E){this.b=E,this.a=new P.$Ac}listen(E,f,h){switch(f){case"onDidChangeLoggers":return h?this.b.getOnDidChangeLoggersEvent(h):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return h?this.b.getOnDidChangeLogLevelEvent(h):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return h?this.b.getOnDidChangeVisibilityEvent(h):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${f}`)}async call(E,f,h){switch(f){case"createLogger":this.c(R.URI.revive(h[0]),h[1],h[2]);return;case"log":return this.e(R.URI.revive(h[0]),h[1]);case"consoleLog":return this.d(h[0],h[1]);case"setLogLevel":return(0,s.$mj)(h[0])?this.b.setLogLevel(h[0]):this.b.setLogLevel(R.URI.revive(h[0]),h[1]);case"setVisibility":return this.b.setVisibility(R.URI.revive(h[0]),h[1]);case"registerLogger":return this.b.registerLogger({...h[0],resource:R.URI.revive(h[0].resource)},h[1]);case"deregisterLogger":return this.b.deregisterLogger(R.URI.revive(h[0]))}throw new Error(`Call not found: ${f}`)}c(E,f,h){this.a.set(E,this.b.createLogger(E,f,h))}d(E,f){let h=console.log;switch(E){case s.LogLevel.Error:h=console.error;break;case s.LogLevel.Warning:h=console.warn;break;case s.LogLevel.Info:h=console.info;break}h.call(console,...f)}e(E,f){const h=this.a.get(E);if(!h)throw new Error("Create the logger before logging");for(const[y,v]of f)(0,s.log)(h,y,v)}}e.$60b=j}),define(re[229],oe([0,1,16,5]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7N=void 0;var s;(function(h){h[h.Trace=0]="Trace",h[h.Debug=1]="Debug",h[h.Info=2]="Info",h[h.Warning=3]="Warning",h[h.Error=4]="Error",h[h.Critical=5]="Critical",h[h.Off=6]="Off"})(s||(s={}));async function j(h,y,v,b,l){try{const p=await new Promise(($,g)=>{J(["@vscode/spdlog"],$,g)});p.setFlushOn(s.Trace);const w=await p.createAsyncRotatingLogger(h,y,v,b);return l?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(p){console.error(p)}return null}function A(h,y,v){switch(y){case R.LogLevel.Trace:h.trace(v);break;case R.LogLevel.Debug:h.debug(v);break;case R.LogLevel.Info:h.info(v);break;case R.LogLevel.Warning:h.warn(v);break;case R.LogLevel.Error:h.error(v);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function E(h,y){switch(y){case R.LogLevel.Trace:h.setLevel(s.Trace);break;case R.LogLevel.Debug:h.setLevel(s.Debug);break;case R.LogLevel.Info:h.setLevel(s.Info);break;case R.LogLevel.Warning:h.setLevel(s.Warning);break;case R.LogLevel.Error:h.setLevel(s.Error);break;case R.LogLevel.Off:h.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${y}`)}}class f extends R.$qj{constructor(y,v,b,l,p){super(),this.m=[],this.setLevel(p),this.n=this.s(y,v,b,l),this.B(this.onDidChangeLogLevel(w=>{this.r&&E(this.r,w)}))}async s(y,v,b,l){const p=b?6:1,w=30/p*P.$Vk.MB,$=await j(y,v,w,p,l);if($){this.r=$,E(this.r,this.getLevel());for(const{level:g,message:u}of this.m)A(this.r,g,u);this.m=[]}}g(y,v){this.r?A(this.r,y,v):this.getLevel()<=y&&this.m.push({level:y,message:v})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$7N=f}),define(re[230],oe([0,1,32,5,229]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8N=void 0;class j extends R.$vj{s(E,f,h){return new s.$7N((0,P.$ng)(),E.fsPath,!h?.donotRotate,!!h?.donotUseFormatters,f)}}e.$8N=j}),define(re[69],oe([0,1,31,3,6,5,230]),function(J,e,P,R,s,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L9b=e.$K9b=void 0,e.$K9b=(0,s.$4h)(j.$lj);class E extends A.$8N{constructor(){super(...arguments),this.u=new P.$Ac}createLogger(h,y,v){v!==void 0&&this.u.set(this.n(h),v);try{return super.createLogger(h,y)}catch(b){throw this.u.delete(this.n(h)),b}}registerLogger(h,y){y!==void 0&&this.u.set(h.resource,y),super.registerLogger(h)}deregisterLogger(h){this.u.delete(h),super.deregisterLogger(h)}getRegisteredLoggers(h){const y=[];for(const v of super.getRegisteredLoggers())h===this.u.get(v.resource)&&y.push(v);return y}getOnDidChangeLogLevelEvent(h){return R.Event.filter(this.onDidChangeLogLevel,y=>(0,j.$mj)(y)||this.w(y[0],h))}getOnDidChangeVisibilityEvent(h){return R.Event.filter(this.onDidChangeVisibility,([y])=>this.w(y,h))}getOnDidChangeLoggersEvent(h){return R.Event.filter(R.Event.map(this.onDidChangeLoggers,y=>({added:[...y.added].filter(b=>this.w(b.resource,h)),removed:[...y.removed].filter(b=>this.w(b.resource,h))})),y=>y.added.length>0||y.removed.length>0)}deregisterLoggers(h){for(const[y,v]of this.u)v===h&&this.deregisterLogger(y)}w(h,y){const v=this.u.get(h);return v===void 0||v===y}dispose(){super.dispose(),this.u.clear()}}e.$L9b=E}),define(re[231],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o0b=e.$n0b=e.$m0b=e.$l0b=void 0;function P(A){return A.submenu!==void 0}e.$l0b=P;function R(A){return A.id==="vscode.menubar.separator"}e.$m0b=R;function s(A){return A.uri!==void 0}e.$n0b=s;function j(A){return!P(A)&&!R(A)&&!s(A)}e.$o0b=j}),define(re[39],oe([0,1,3,72,2,6]),function(J,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$yn=e.$xn=void 0,e.$xn=(0,j.$3h)("policy");class A extends s.$Sc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new P.$Sd),this.onDidChange=this.h.event}async updatePolicyDefinitions(h){const y=Object.keys(this.f).length;return this.f={...h,...this.f},y!==Object.keys(this.f).length&&await this.j(h),R.Iterable.reduce(this.g.entries(),(v,[b,l])=>({...v,[b]:l}),{})}getPolicyValue(h){return this.g.get(h)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(h,[y,v])=>({...h,[y]:{definition:v,value:this.g.get(y)}}),{})}}e.$yn=A;class E{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$zn=E}),define(re[232],oe([0,1,8,3,72,12,16,5,39]),function(J,e,P,R,s,j,A,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m$b=void 0;function h(v,b){const l=[];for(const p of new Set(s.Iterable.concat(v.keys(),b.keys())))v.get(p)!==b.get(p)&&l.push(p);return l}let y=class extends f.$yn{constructor(b,l,p){super(),this.m=b,this.n=l,this.s=p,this.c=this.B(new P.$1g(500));const w=R.Event.filter(l.onDidFilesChange,$=>$.affects(b));this.B(l.watch(b)),this.B(w(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const b=new Map;try{const l=await this.n.readFile(this.m),p=JSON.parse(l.value.toString());if(!(0,j.$Hf)(p))throw new Error("Policy file isn't a JSON object");for(const w of Object.keys(p))this.f[w]&&b.set(w,p[w])}catch(l){l.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",l)}return b}async w(){const b=await this.u(),l=h(this.g,b);this.g=b,l.length>0&&this.h.fire(l)}};e.$m$b=y,e.$m$b=y=Ee([ne(1,A.$nk),ne(2,E.$kj)],y)}),define(re[233],oe([0,1,3,2,39]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X0b=e.$W0b=void 0;class j{constructor(f){this.b=f,this.a=new R.$Rc}listen(f,h){switch(h){case"onDidChange":return P.Event.map(this.b.onDidChange,y=>y.reduce((v,b)=>({...v,[b]:this.b.getPolicyValue(b)??null}),{}),this.a)}throw new Error(`Event not found: ${h}`)}call(f,h,y){switch(h){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(y)}throw new Error(`Call not found: ${h}`)}dispose(){this.a.dispose()}}e.$W0b=j;class A extends s.$yn{constructor(f,h){super(),this.a=h;for(const y in f){const{definition:v,value:b}=f[y];this.f[y]=v,b!==void 0&&this.g.set(y,b)}this.a.listen("onDidChange")(y=>{for(const v in y){const b=y[v];b===null?this.g.delete(v):this.g.set(v,b)}this.h.fire(Object.keys(y))})}async j(f){const h=await this.a.call("updatePolicyDefinitions",f);for(const y in h)this.g.set(y,h[y])}}e.$X0b=A}),define(re[234],oe([0,1,39,8,2,5]),function(J,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l$b=void 0;let A=class extends P.$yn{constructor(f,h){super(),this.m=f,this.n=h,this.a=new R.$Wg,this.b=this.B(new s.$Tc)}async j(f){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(f).length} policy definitions`);const{createWatcher:h}=await new Promise((y,v)=>{J(["@vscode/policy-watcher"],y,v)});await this.a.queue(()=>new Promise((y,v)=>{try{this.b.value=h(this.n,f,b=>{this.t(b),y()})}catch(b){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",b),v(b)}}))}t(f){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(f)}`);for(const h in f){const y=f[h];y===void 0?this.g.delete(h):this.g.set(h,y)}this.h.fire(Object.keys(f))}};e.$l$b=A,e.$l$b=A=Ee([ne(0,j.$kj)],A)}),define(re[79],oe([0,1,35]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let R;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.context<"u"){const j=s.context.configuration();if(j)R=j.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(R=globalThis._VSCODE_PRODUCT_JSON,P.env.VSCODE_DEV&&Object.assign(R,{nameShort:`${R.nameShort} Dev`,nameLong:`${R.nameLong} Dev`,dataFolderName:`${R.dataFolderName}-dev`,serverDataFolderName:R.serverDataFolderName?`${R.serverDataFolderName}-dev`:void 0}),!R.version){const j=globalThis._VSCODE_PACKAGE_JSON;Object.assign(R,{version:j.version})}}else R={},Object.keys(R).length===0&&Object.assign(R,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=R}),define(re[27],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dj=e.$Cj=void 0,e.$Cj=(0,P.$3h)("productService"),e.$Dj="vscode://schemas/vscode-product"}),define(re[235],oe([0,1,8,5]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c0b=void 0;let s=class{constructor(A,E,f){this.a=A,this.b=E,this.c=f}async inspect(A){await this.d();const E=this.a.webContents.debugger;await E.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,P.$4g)(A);const f=await E.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),f.profile}async d(){const A=this.a.webContents.debugger;A.attach(),await A.sendCommand("Profiler.enable")}async e(){const A=this.a.webContents.debugger;await A.sendCommand("Profiler.disable"),A.detach()}};e.$c0b=s,e.$c0b=s=Ee([ne(2,R.$kj)],s)}),define(re[80],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A9b=void 0,e.$A9b=(0,P.$3h)("protocolMainService")}),define(re[43],oe([0,1,137,12]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=void 0;class s{constructor(){this.a=new Map}add(A,E){P.ok(R.$Ff(A)),P.ok(R.$Hf(E)),P.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,E)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$vn=new s}),define(re[236],oe([0,1,3,43]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=void 0,e.$wn={JSONContribution:"base.contributions.json"};function s(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class j{constructor(){this.b=new P.$Sd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,h){this.a[s(f)]=h,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const A=new j;R.$vn.add(e.$wn.JSONContribution,A)}),define(re[58],oe([0,1,23,3,12,163,17,236,43]),function(J,e,P,R,s,j,A,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.ConfigurationScope=e.$An=e.EditPresentationTypes=void 0;var h;(function(d){d.Multiline="multilineText",d.Singleline="singlelineText"})(h||(e.EditPresentationTypes=h={})),e.$An={Configuration:"base.contributions.configuration"};var y;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.MACHINE=2]="MACHINE",d[d.WINDOW=3]="WINDOW",d[d.RESOURCE=4]="RESOURCE",d[d.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",d[d.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y||(e.ConfigurationScope=y={})),e.$Bn={properties:{},patternProperties:{}},e.$Cn={properties:{},patternProperties:{}},e.$Dn={properties:{},patternProperties:{}},e.$En={properties:{},patternProperties:{}},e.$Fn={properties:{},patternProperties:{}},e.$Gn={properties:{},patternProperties:{}},e.$Hn="vscode://schemas/settings/resourceLanguage",e.$In="vscode://schemas/settings/configurationDefaults";const v=f.$vn.as(E.$wn.JSONContribution);class b{constructor(){this.h=new Set,this.i=new R.$Sd,this.onDidSchemaChange=this.i.event,this.j=new R.$Sd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:j.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.$Hn,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const r=new Set;this.n(t,o,r),v.registerSchema(e.$Hn,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const o=new Set;this.o(t,o),v.registerSchema(e.$Hn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const r=new Set;this.o(o,r),this.n(t,!1,r),v.registerSchema(e.$Hn,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const r=[];for(const{overrides:i,source:n}of t)for(const a in i)if(o.add(a),e.$Kn.test(a)){const m=this.a.get(a),D=m?.valuesSources??new Map;if(n)for(const M of Object.keys(i[a]))D.set(M,n);const I={...m?.value||{},...i[a]};this.a.set(a,{source:n,value:I,valuesSources:D});const k=(0,A.$Gi)(a),C={type:"object",default:I,description:j.localize(1,null,k),$ref:e.$Hn,defaultDefaultValue:I,source:s.$Ff(n)?void 0:n,defaultValueSource:n};r.push(...w(a)),this.d[a]=C,this.b.properties[a]=C}else{this.a.set(a,{value:i[a],source:n});const m=this.d[a];m&&(this.w(a,m),this.r(a,m))}this.m(r)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:r,source:i}of t)for(const n in r){const a=this.a.get(n),m=s.$Ff(i)?i:i?.id,D=s.$Ff(a?.source)?a?.source:a?.source?.id;if(m===D)if(o.add(n),this.a.delete(n),e.$Kn.test(n))delete this.d[n],delete this.b.properties[n];else{const I=this.d[n];I&&(this.w(n,I),this.r(n,I))}}this.u()}deltaConfiguration(t){let o=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,r){t.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,o){const r=i=>{if(i.properties)for(const n in i.properties){o.add(n);const a=this.d[n];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>r(n))};for(const i of t){r(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(t,o=!0,r,i,n=3,a){n=s.$Of(t.scope)?n:t.scope;const m=t.properties;if(m)for(const I in m){const k=m[I];if(o&&c(I,k)){delete m[I];continue}if(k.source=r,k.defaultDefaultValue=m[I].default,this.w(I,k),e.$Kn.test(I)?k.scope=void 0:(k.scope=s.$Of(k.scope)?n:k.scope,k.restricted=s.$Of(k.restricted)?!!i?.includes(I):k.restricted),m[I].hasOwnProperty("included")&&!m[I].included){this.f[I]=m[I],delete m[I];continue}else this.d[I]=m[I],m[I].policy?.name&&this.e.set(m[I].policy.name,I);!m[I].deprecationMessage&&m[I].markdownDeprecationMessage&&(m[I].deprecationMessage=m[I].markdownDeprecationMessage),a.add(I)}const D=t.allOf;if(D)for(const I of D)this.p(I,o,r,i,n,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=r=>{const i=r.properties;if(i)for(const a in i)this.r(a,i[a]);r.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$Bn.properties[t]=o,o.scope){case 1:e.$Cn.properties[t]=o;break;case 2:e.$Dn.properties[t]=o;break;case 6:e.$En.properties[t]=o;break;case 3:e.$Fn.properties[t]=o;break;case 4:e.$Gn.properties[t]=o;break;case 5:e.$Gn.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$Bn.properties[t],o.scope){case 1:delete e.$Cn.properties[t];break;case 2:delete e.$Dn.properties[t];break;case 6:delete e.$En.properties[t];break;case 3:delete e.$Fn.properties[t];break;case 4:case 5:delete e.$Gn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,r={type:"object",description:j.localize(2,null),errorMessage:j.localize(3,null),$ref:e.$Hn};this.w(o,r),e.$Bn.properties[o]=r,e.$Cn.properties[o]=r,e.$Dn.properties[o]=r,e.$En.properties[o]=r,e.$Fn.properties[o]=r,e.$Gn.properties[o]=r}}v(){const t={type:"object",description:j.localize(4,null),errorMessage:j.localize(5,null),$ref:e.$Hn};e.$Bn.patternProperties[e.$Jn]=t,e.$Cn.patternProperties[e.$Jn]=t,e.$Dn.patternProperties[e.$Jn]=t,e.$En.patternProperties[e.$Jn]=t,e.$Fn.patternProperties[e.$Jn]=t,e.$Gn.patternProperties[e.$Jn]=t,this.i.fire()}w(t,o){const r=this.a.get(t);let i=r?.value,n=r?.source;s.$Mf(i)&&(i=o.defaultDefaultValue,n=void 0),s.$Mf(i)&&(i=g(o.type)),o.default=i,o.defaultValueSource=n}}const l="\\[([^\\]]+)\\]",p=new RegExp(l,"g");e.$Jn=`^(${l})+$`,e.$Kn=new RegExp(e.$Jn);function w(d){const t=[];if(e.$Kn.test(d)){let o=p.exec(d);for(;o?.length;){const r=o[1].trim();r&&t.push(r),o=p.exec(d)}}return(0,P.$Mb)(t)}e.$Ln=w;function $(d){return d.reduce((t,o)=>`${t}[${o}]`,"")}e.$Mn=$;function g(d){switch(Array.isArray(d)?d[0]:d){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Nn=g;const u=new b;f.$vn.add(e.$An.Configuration,u);function c(d,t){return d.trim()?e.$Kn.test(d)?j.localize(7,null,d):u.getConfigurationProperties()[d]!==void 0?j.localize(8,null,d):t.policy?.name&&u.getPolicyConfigurations().get(t.policy?.name)!==void 0?j.localize(9,null,d,t.policy?.name,u.getPolicyConfigurations().get(t.policy?.name)):null:j.localize(6,null)}e.$On=c;function S(){const d=[],t=u.getConfigurationProperties();for(const o of Object.keys(t))d.push([o,t[o].scope]);return d.push(["launch",4]),d.push(["task",4]),d}e.$Pn=S}),define(re[119],oe([0,1,23,3,44,2,31,38,12,7,17,58,43]),function(J,e,P,R,s,j,A,E,f,h,y,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=void 0;function l(o){return Object.isFrozen(o)?o:E.$kn(o)}class p{constructor(r={},i=[],n=[],a){this.b=r,this.c=i,this.d=n,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof p)return i;const n=new w("");return n.parseRaw(i),n.configurationModel});this.f=r.reduce((i,n)=>n===i?n:i.merge(n),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,y.$Ei)(this.contents,r):this.contents}inspect(r,i){const n=this.rawConfiguration.getValue(r),a=i?this.rawConfiguration.getOverrideValue(r,i):void 0,m=i?this.rawConfiguration.override(i).getValue(r):n;return{value:n,override:a,merged:m}}getOverrideValue(r,i){const n=this.i(i);return n?r?(0,y.$Ei)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const n of this.overrides)n.identifiers.includes(r)&&i.push(...n.keys);return P.$Mb(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return P.$Mb(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=E.$jn(this.contents),n=E.$jn(this.overrides),a=[...this.keys],m=this.raw?.length?[...this.raw]:[this];for(const D of r)if(m.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h(i,D.contents);for(const I of D.overrides){const[k]=n.filter(C=>P.$ub(C.identifiers,I.identifiers));k?(this.h(k.contents,I.contents),k.keys.push(...I.keys),k.keys=P.$Mb(k.keys)):n.push(E.$jn(I))}for(const I of D.keys)a.indexOf(I)===-1&&a.push(I)}return new p(i,a,n,m.every(D=>D instanceof p)?void 0:m)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const a of P.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let m=this.contents[a];const D=i[a];D&&(typeof m=="object"&&typeof D=="object"?(m=E.$jn(m),this.h(m,D)):m=D),n[a]=m}return new p(n,this.keys,this.overrides)}h(r,i){for(const n of Object.keys(i)){if(n in r&&f.$Hf(r[n])&&f.$Hf(i[n])){this.h(r[n],i[n]);continue}r[n]=E.$jn(i[n])}}i(r){let i=null,n=null;const a=m=>{m&&(n?this.h(n,m):n=E.$jn(m))};for(const m of this.overrides)m.identifiers.length===1&&m.identifiers[0]===r?i=m.contents:m.identifiers.includes(r)&&a(m.contents);return a(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,y.$Di)(this.contents,r),v.$Kn.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>P.$ub(n.identifiers,(0,v.$Ln)(r))),1))}j(r,i,n){(0,y.$Ci)(this.contents,r,i,a=>console.error(a)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),v.$Kn.test(r)&&this.overrides.push({identifiers:(0,v.$Ln)(r),keys:Object.keys(this.contents[r]),contents:(0,y.$Bi)(this.contents[r],a=>console.error(a))})}}e.$Qn=p;class w{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!f.$Of(r)){const n=this.g(r);this.parseRaw(n,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:n,keys:a,overrides:m,restricted:D,hasExcludedProperties:I}=this.h(r,i);this.b=new p(n,a,m,I?[r]:void 0),this.c=D||[]}g(r){let i={},n=null,a=[];const m=[],D=[];function I(C){Array.isArray(a)?a.push(C):n!==null&&(a[n]=C)}const k={onObjectBegin:()=>{const C={};I(C),m.push(a),a=C,n=null},onObjectProperty:C=>{n=C},onObjectEnd:()=>{a=m.pop()},onArrayBegin:()=>{const C=[];I(C),m.push(a),a=C,n=null},onArrayEnd:()=>{a=m.pop()},onLiteralValue:I,onError:(C,M,F)=>{D.push({error:C,offset:M,length:F})}};if(r)try{s.$gn(r,k),i=a[0]||{}}catch(C){console.error(`Error while parsing settings file ${this.f}: ${C}`),this.d=[C]}return i}h(r,i){const n=b.$vn.as(v.$An.Configuration).getConfigurationProperties(),a=this.i(r,n,!0,i);r=a.raw;const m=(0,y.$Bi)(r,k=>console.error(`Conflict in settings file ${this.f}: ${k}`)),D=Object.keys(r),I=this.j(r,k=>console.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:m,keys:D,overrides:I,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(r,i,n,a){let m=!1;if(!a?.scopes&&!a?.skipRestricted&&!a?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:m};const D={},I=[];for(const k in r)if(v.$Kn.test(k)&&n){const C=this.i(r[k],i,!1,a);D[k]=C.raw,m=m||C.hasExcludedProperties,I.push(...C.restricted)}else{const C=i[k],M=C?typeof C.scope<"u"?C.scope:3:void 0;C?.restricted&&I.push(k),!a.exclude?.includes(k)&&(a.include?.includes(k)||(M===void 0||a.scopes===void 0||a.scopes.includes(M))&&!(a.skipRestricted&&C?.restricted))?D[k]=r[k]:m=!0}return{raw:D,restricted:I,hasExcludedProperties:m}}j(r,i){const n=[];for(const a of Object.keys(r))if(v.$Kn.test(a)){const m={};for(const D in r[a])m[D]=r[a][D];n.push({identifiers:(0,v.$Ln)(a),keys:Object.keys(m),contents:(0,y.$Bi)(m,i)})}return n}}e.$Rn=w;class $ extends j.$Sc{constructor(r,i,n,a){super(),this.c=r,this.f=i,this.g=a,this.b=this.B(new R.$Sd),this.onDidChange=this.b.event,this.a=new w(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,m=>m.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,m=>(m.isOperation(0)||m.isOperation(3)||m.isOperation(1)||m.isOperation(4))&&n.isEqual(m.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new p}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Sn=$;class g{constructor(r,i,n,a,m,D,I,k,C,M,F,N,Z){this.a=r,this.b=i,this.c=n,this.overrideIdentifiers=a,this.d=m,this.f=D,this.g=I,this.h=k,this.i=C,this.j=M,this.k=F,this.l=N,this.m=Z}get value(){return l(this.c)}n(r,i,n){const a=r.inspect(i,n);return{get value(){return l(a.value)},get override(){return l(a.override)},get merged(){return l(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class u{constructor(r,i,n,a,m=new p,D=new p,I=new A.$Ac,k=new p,C=new A.$Ac){this.c=r,this.d=i,this.f=n,this.g=a,this.h=m,this.i=D,this.j=I,this.l=k,this.m=C,this.a=null,this.b=new A.$Ac,this.n=null}getValue(r,i,n){return this.p(r,i,n).getValue(r)}updateValue(r,i,n={}){let a;n.resource?(a=this.m.get(n.resource),a||(a=new p,this.m.set(n.resource,a))):a=this.l,i===void 0?a.removeValue(r):a.setValue(r,i),n.resource||(this.a=null)}inspect(r,i,n){const a=this.p(r,i,n),m=this.t(i.resource,n),D=i.resource?this.m.get(i.resource)||this.l:this.l,I=new Set;for(const k of a.overrides)for(const C of k.identifiers)a.getOverrideValue(r,C)!==void 0&&I.add(C);return new g(r,i,a.getValue(r),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,m||void 0,D)}keys(r){const i=this.t(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const n=[];if(!i){const{added:a,updated:m,removed:D}=d(this.c,r);i=[...a,...m,...D]}for(const a of i)for(const m of(0,v.$Ln)(a)){const D=this.c.getKeysForOverrideIdentifier(m),I=r.getKeysForOverrideIdentifier(m),k=[...I.filter(C=>D.indexOf(C)===-1),...D.filter(C=>I.indexOf(C)===-1),...D.filter(C=>!E.$nn(this.c.override(m).getValue(C),r.override(m).getValue(C)))];n.push([m,k])}return this.updateDefaultConfiguration(r),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:n,removed:a}=d(this.d,r),m=[...i,...n,...a];return m.length&&this.updatePolicyConfiguration(r),{keys:m,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:n,removed:a,overrides:m}=d(this.applicationConfiguration,r),D=[...i,...n,...a];return D.length&&this.updateApplicationConfiguration(r),{keys:D,overrides:m}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:n,removed:a,overrides:m}=d(this.localUserConfiguration,r),D=[...i,...n,...a];return D.length&&this.updateLocalUserConfiguration(r),{keys:D,overrides:m}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:n,removed:a,overrides:m}=d(this.remoteUserConfiguration,r),D=[...i,...n,...a];return D.length&&this.updateRemoteUserConfiguration(r),{keys:D,overrides:m}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:n,removed:a,overrides:m}=d(this.workspaceConfiguration,r),D=[...i,...n,...a];return D.length&&this.updateWorkspaceConfiguration(r),{keys:D,overrides:m}}compareAndUpdateFolderConfiguration(r,i){const n=this.folderConfigurations.get(r),{added:a,updated:m,removed:D,overrides:I}=d(n,i),k=[...a,...m,...D];return(k.length||!n)&&this.updateFolderConfiguration(r,i),{keys:k,overrides:I}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:a,removed:m,overrides:D}=d(i,void 0);return{keys:[...n,...a,...m],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(r,i,n){let a=this.q(i,n);return i.overrideIdentifier&&(a=a.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(a=a.merge(this.d)),a}q({resource:r},i){let n=this.r();if(i&&r){const a=i.getFolder(r);a&&(n=this.s(a.uri)||n);const m=this.m.get(r);m&&(n=n.merge(m))}return n}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(r){let i=this.b.get(r);if(!i){const n=this.r(),a=this.j.get(r);a?(i=n.merge(a),this.b.set(r,i)):i=n}return i}t(r,i){if(i&&r){const n=i.getFolder(r);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:n,overrides:a,keys:m}=this.j.get(i);return r.push([i,{contents:n,overrides:a,keys:m}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(n=>r.add(n))),[...r.values()]}u(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}v(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a))),[...i.values()]}static parse(r){const i=this.w(r.defaults),n=this.w(r.policy),a=this.w(r.application),m=this.w(r.user),D=this.w(r.workspace),I=r.folders.reduce((k,C)=>(k.set(h.URI.revive(C[0]),this.w(C[1])),k),new A.$Ac);return new u(i,n,a,m,new p,D,I,new p,new A.$Ac)}static w(r){return new p(r.contents,r.keys,r.overrides)}}e.$Tn=u;function c(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const r=new Set,i=new Map;for(const a of o)a.keys.forEach(m=>r.add(m)),a.overrides.forEach(([m,D])=>{const I=(0,A.$xc)(i,m,new Set);D.forEach(k=>I.add(k))});const n=[];return i.forEach((a,m)=>n.push([m,[...a.values()]])),{keys:[...r.values()],overrides:n}}e.$Un=c;class S{constructor(r,i,n,a){this.change=r,this.f=i,this.g=n,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const m of r.keys)this.affectedKeys.add(m);for(const[,m]of r.overrides)for(const D of m)this.affectedKeys.add(D);this.d=this.a;for(const m of this.affectedKeys)this.d+=m+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=u.parse(this.f.data)),this.i}affectsConfiguration(r,i){const n=this.a+r,a=this.d.indexOf(n);if(a<0)return!1;const m=a+n.length;if(m>=this.d.length)return!1;const D=this.d.charCodeAt(m);if(D!==this.b&&D!==this.c)return!1;if(i){const I=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,k=this.g.getValue(r,i,this.h);return!E.$nn(I,k)}return!0}}e.$Vn=S;function d(o,r){const{added:i,removed:n,updated:a}=t(r?.rawConfiguration,o?.rawConfiguration),m=[],D=o?.getAllOverrideIdentifiers()||[],I=r?.getAllOverrideIdentifiers()||[];if(r){const k=I.filter(C=>!D.includes(C));for(const C of k)m.push([C,r.getKeysForOverrideIdentifier(C)])}if(o){const k=D.filter(C=>!I.includes(C));for(const C of k)m.push([C,o.getKeysForOverrideIdentifier(C)])}if(r&&o){for(const k of D)if(I.includes(k)){const C=t({contents:o.getOverrideValue(void 0,k)||{},keys:o.getKeysForOverrideIdentifier(k)},{contents:r.getOverrideValue(void 0,k)||{},keys:r.getKeysForOverrideIdentifier(k)});m.push([k,[...C.added,...C.removed,...C.updated]])}}return{added:i,removed:n,updated:a,overrides:m}}function t(o,r){const i=o?r?o.keys.filter(m=>r.keys.indexOf(m)===-1):[...o.keys]:[],n=r?o?r.keys.filter(m=>o.keys.indexOf(m)===-1):[...r.keys]:[],a=[];if(o&&r){for(const m of r.keys)if(o.keys.indexOf(m)!==-1){const D=(0,y.$Ei)(r.contents,m),I=(0,y.$Ei)(o.contents,m);E.$nn(D,I)||a.push(m)}}return{added:i,removed:n,updated:a}}}),define(re[237],oe([0,1,23,3,2,38,12,119,58,5,39,43]),function(J,e,P,R,s,j,A,E,f,h,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=e.$Xn=e.$Wn=void 0;class b extends s.$Sc{constructor(){super(...arguments),this.a=this.B(new R.$Sd),this.onDidChangeConfiguration=this.a.event,this.b=new E.$Qn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(v.$vn.as(f.$An.Configuration).onDidUpdateConfiguration(({properties:$,defaultsOverrides:g})=>this.c(Array.from($),g))),this.configurationModel}reload(){return this.g(),this.configurationModel}c($,g){this.h($,v.$vn.as(f.$An.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:$})}f(){return{}}g(){this.b=new E.$Qn;const $=v.$vn.as(f.$An.Configuration).getConfigurationProperties();this.h(Object.keys($),$)}h($,g){const u=this.f();for(const c of $){const S=u[c],d=g[c];S!==void 0?this.b.addValue(c,S):d?this.b.addValue(c,d.default):this.b.removeValue(c)}}}e.$Wn=b;class l{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new E.$Qn}async initialize(){return this.configurationModel}}e.$Xn=l;let p=class extends s.$Sc{get configurationModel(){return this.b}constructor($,g,u){super(),this.c=$,this.f=g,this.g=u,this.a=this.B(new R.$Sd),this.onDidChangeConfiguration=this.a.event,this.b=new E.$Qn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange($=>this.j($))),this.B(this.c.onDidChangeConfiguration(async({properties:$})=>this.m(await this.h($),!0))),this.b}async h($){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",$);const g={},u=[],c=v.$vn.as(f.$An.Configuration).getConfigurationProperties();for(const S of $){const d=c[S];if(!d){u.push(S);continue}if(d.policy){if(d.type!=="string"&&d.type!=="number"){this.g.warn(`Policy ${d.policy.name} has unsupported type ${d.type}`);continue}u.push(S),g[d.policy.name]={type:d.type}}}return(0,A.$Sf)(g)||await this.f.updatePolicyDefinitions(g),u}j($){this.g.trace("PolicyConfiguration#onDidChangePolicies",$);const g=v.$vn.as(f.$An.Configuration).getPolicyConfigurations(),u=(0,P.$Hb)($.map(c=>g.get(c)));this.m(u,!0)}m($,g){this.g.trace("PolicyConfiguration#update",$);const u=v.$vn.as(f.$An.Configuration).getConfigurationProperties(),c=[],S=this.b.isEmpty();for(const d of $){const t=u[d]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);(S?o!==void 0:!(0,j.$nn)(this.b.getValue(d),o))&&c.push([d,o])}else this.b.getValue(d)!==void 0&&c.push([d,void 0])}if(c.length){this.g.trace("PolicyConfiguration#changed",c);const d=this.b;this.b=new E.$Qn;for(const t of d.keys)this.b.setValue(t,d.getValue(t));for(const[t,o]of c)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);g&&this.a.fire(this.b)}}};e.$Yn=p,e.$Yn=p=Ee([ne(1,y.$xn),ne(2,h.$kj)],p)}),define(re[238],oe([0,1,8,3,2,19,17,119,237,39]),function(J,e,P,R,s,j,A,E,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=void 0;class y extends s.$Sc{constructor(b,l,p,w){super(),this.j=b,this.h=this.B(new R.$Sd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new f.$Wn),this.c=p instanceof h.$zn?new f.$Xn:this.B(new f.$Yn(this.b,p,w)),this.f=this.B(new E.$Sn(this.j,{},j.$vg,l)),this.a=new E.$Tn(this.b.configurationModel,this.c.configurationModel,new E.$Qn,new E.$Qn),this.g=this.B(new P.$ch(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:$,properties:g})=>this.n($,g))),this.B(this.c.onDidChangeConfiguration($=>this.r($))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[b,l,p]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new E.$Tn(b,l,new E.$Qn,p)}getConfigurationData(){return this.a.toData()}getValue(b,l){const p=typeof b=="string"?b:void 0,w=(0,A.$xi)(b)?b:(0,A.$xi)(l)?l:{};return this.a.getValue(p,w,void 0)}updateValue(b,l,p,w){return Promise.reject(new Error("not supported"))}inspect(b){return this.a.inspect(b,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const b=await this.f.loadConfiguration();this.m(b)}m(b){const l=this.a.toData(),p=this.a.compareAndUpdateLocalUserConfiguration(b);this.s(p,l,2)}n(b,l){const p=this.a.toData(),w=this.a.compareAndUpdateDefaultConfiguration(b,l);this.s(w,p,7)}r(b){const l=this.a.toData(),p=this.a.compareAndUpdatePolicyConfiguration(b);this.s(p,l,7)}s(b,l,p){const w=new E.$Vn(b,{data:l},this.a);w.source=p,w.sourceConfig=this.t(p),this.h.fire(w)}t(b){switch(b){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Zn=y}),define(re[239],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a$b=e.$_0b=e.$$0b=void 0,e.$$0b="request",e.$_0b="remoteResourceHandler";class P{async routeCall(s,j,A){if(j!==e.$$0b)throw new Error(`Call not found: ${j}`);const E=A[0];if(E?.authority){const f=s.connections.find(h=>h.ctx===E.authority);if(f)return f}throw new Error("Caller not found")}routeEvent(s,j){throw new Error(`Event not found: ${j}`)}}e.$a$b=P}),define(re[240],oe([0,1,14,6]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.RemoteAuthorityResolverErrorCode=e.$7k=e.$6k=e.RemoteConnectionType=e.$5k=void 0,e.$5k=(0,R.$3h)("remoteAuthorityResolverService");var s;(function(y){y[y.WebSocket=0]="WebSocket",y[y.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class j{constructor(v){this.id=v,this.type=1}toString(){return`Managed(${this.id})`}}e.$6k=j;class A{constructor(v,b){this.host=v,this.port=b,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$7k=A;var E;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound",y.InvalidAuthority="InvalidAuthority"})(E||(e.RemoteAuthorityResolverErrorCode=E={}));class f extends P.$bb{static isNotAvailable(v){return v instanceof f&&v._code===E.NotAvailable}static isTemporarilyNotAvailable(v){return v instanceof f&&v._code===E.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof f&&v._code===E.NoResolverFound}static isInvalidAuthority(v){return v instanceof f&&v._code===E.InvalidAuthority}static isHandled(v){return v instanceof f&&v.isHandled}constructor(v,b=E.Unknown,l){super(v),this._message=v,this._code=b,this._detail=l,this.isHandled=b===E.NotAvailable&&l===!0,Object.setPrototypeOf(this,f.prototype)}}e.$8k=f;function h(y){const v=y.indexOf("+");return v===-1?y:y.substring(0,v)}e.$9k=h}),define(re[59],oe([0,1,13]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=e.$_k=e.$$k=e.$0k=void 0;function R(h){return h.scheme===P.Schemas.vscodeRemote?h.authority:void 0}e.$0k=R;function s(h){if(!h)return;const y=h.indexOf("+");return y<0?h:h.substr(0,y)}e.$$k=s;function j(h){return`/${h.quality??"oss"}-${h.commit??"dev"}`}e.$_k=j;function A(h){const{host:y,port:v}=f(h);if(typeof v>"u")throw new Error(`Invalid remote authority: ${h}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:y,port:v}}e.$al=A;function E(h,y){let{host:v,port:b}=f(h);return typeof b>"u"&&(b=y),{host:v,port:b}}e.$bl=E;function f(h){const y=h.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(y)return{host:y[1],port:parseInt(y[2],10)};const v=h.match(/^(\[[0-9a-z:]+\])$/);if(v)return{host:v[1],port:void 0};const b=h.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:h,port:void 0}}}),define(re[120],oe([0,1,25,6,59]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.TargetPlatform=e.ExtensionType=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=void 0,e.$cm="extensions.user.cache",e.$dm="extensions.builtin.cache",e.$em="undefined_publisher",e.$fm=["ui","workspace","web"];function j(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$gm=j,e.$hm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(A||(e.ExtensionType=A={}));var E;(function(w){w.WIN32_X64="win32-x64",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(E||(e.TargetPlatform=E={}));class f{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,g){if(typeof $>"u"||$===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof $=="string"||typeof g=="string"){const u=typeof $=="string"?$:$.value,c=typeof g=="string"?g:g.value;return P.$9e(u,c)}return $._lower===g._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$im=f;class h{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const g of $)this.add(g)}add($){this.c.add(f.toKey($))}delete($){return this.c.delete(f.toKey($))}has($){return this.c.has(f.toKey($))}}e.$jm=h;class y{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(f.toKey($))}get($){return this.c.get(f.toKey($))}has($){return this.c.has(f.toKey($))}set($,g){this.c.set(f.toKey($),g)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$km=y;function v(w){return b(w)}e.$lm=v;function b(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.$mm=b;function l(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.$nm=l;function p(w,$){if($){const g=`onResolveRemoteAuthority:${(0,s.$$k)($)}`;return!!w.activationEvents?.includes(g)}return!1}e.$om=p,e.$pm=(0,R.$3h)("IBuiltinExtensionsScannerService")}),define(re[241],oe([0,1,8,18,22,14,3,2,68,73,32,109,240,59]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.PersistentConnectionEventType=e.$il=e.$hl=e.$gl=e.ConnectionType=void 0;const p=30*1e3;var w;(function(G){G[G.Management=1]="Management",G[G.ExtensionHost=2]="ExtensionHost",G[G.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function $(G){switch(G){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(G){const O=new s.$3d;return setTimeout(()=>O.cancel(),G),O.token}function u(G,O){if(G.isCancellationRequested||O.isCancellationRequested)return s.CancellationToken.Cancelled;const U=new s.$3d;return G.onCancellationRequested(()=>U.cancel()),O.onCancellationRequested(()=>U.cancel()),U.token}class c{get didTimeout(){return this.c==="timedout"}constructor(O){this.c="pending",this.d=new E.$Rc,this.promise=new Promise((U,x)=>{this.f=U,this.g=x}),O.isCancellationRequested?this.h():this.d.add(O.onCancellationRequested(()=>this.h()))}registerDisposable(O){this.c==="pending"?this.d.add(O):O.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(O))}reject(O){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(O))}}function S(G,O){const U=new c(O);return U.registerDisposable(G.onControlMessage(x=>{const z=JSON.parse(x.toString()),Y=L(z);Y?U.reject(Y):U.resolve(z)})),U.promise}function d(G,O,U,x,z,Y,W,B){const _=new c(B),ae=h.$Od.create(!1);return G.info(`Creating a socket (${W})...`),f.mark(`code/willCreateSocket/${Y}`),O.connect(U,x,z,W).then(se=>{_.didTimeout?(f.mark(`code/didCreateSocketError/${Y}`),G.info(`Creating a socket (${W}) finished after ${ae.elapsed()} ms, but this is too late and has timed out already.`),se?.dispose()):(f.mark(`code/didCreateSocketOK/${Y}`),G.info(`Creating a socket (${W}) was successful after ${ae.elapsed()} ms.`),_.resolve(se))},se=>{f.mark(`code/didCreateSocketError/${Y}`),G.info(`Creating a socket (${W}) returned an error after ${ae.elapsed()} ms.`),G.error(se),_.reject(se)}),_.promise}function t(G,O){const U=new c(O);return G.then(x=>{U.didTimeout||U.resolve(x)},x=>{U.didTimeout||U.reject(x)}),U.promise}async function o(G,O,U,x){const z=te(G,O);G.logService.trace(`${z} 1/6. invoking socketFactory.connect().`);let Y;try{Y=await d(G.logService,G.remoteSocketFactoryService,G.connectTo,(0,l.$_k)(G),`reconnectionToken=${G.reconnectionToken}&reconnection=${G.reconnectionProtocol?"true":"false"}`,$(O),`renderer-${$(O)}-${G.reconnectionToken}`,x)}catch(se){throw G.logService.error(`${z} socketFactory.connect() failed or timed out. Error:`),G.logService.error(se),se}G.logService.trace(`${z} 2/6. socketFactory.connect() was successful.`);let W,B;G.reconnectionProtocol?(G.reconnectionProtocol.beginAcceptReconnection(Y,null),W=G.reconnectionProtocol,B=!1):(W=new v.$Qh({socket:Y}),B=!0),G.logService.trace(`${z} 3/6. sending AuthRequest control message.`);const _=await t(G.signService.createNewMessage((0,y.$ng)()),x),ae={type:"auth",auth:G.connectionToken||"00000000000000000000",data:_.data};W.sendControl(R.$ge.fromString(JSON.stringify(ae)));try{const se=await S(W,u(x,g(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const Pe=new Error("Unexpected handshake message");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}if(G.logService.trace(`${z} 4/6. received SignRequest control message.`),!await t(G.signService.validate(_,se.signedData),x)){const Pe=new Error("Refused to connect to unsupported server");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}const me=await t(G.signService.sign(se.data),x),ye={type:"connectionType",commit:G.commit,signedData:me,desiredConnectionType:O};return U&&(ye.args=U),G.logService.trace(`${z} 5/6. sending ConnectionTypeRequest control message.`),W.sendControl(R.$ge.fromString(JSON.stringify(ye))),{protocol:W,ownsProtocol:B}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(G.logService.error(`${z} the handshake timed out. Error:`),G.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(G.logService.error(`${z} received error control message when negotiating connection. Error:`),G.logService.error(se)),B&&H(W),se}}async function r(G,O,U,x){const z=Date.now(),Y=te(G,O),{protocol:W,ownsProtocol:B}=await o(G,O,U,x),_=new c(x);return _.registerDisposable(W.onControlMessage(ae=>{const se=JSON.parse(ae.toString()),$e=L(se);$e?(G.logService.error(`${Y} received error control message when negotiating connection. Error:`),G.logService.error($e),B&&H(W),_.reject($e)):(G.reconnectionProtocol?.endAcceptReconnection(),G.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${he(z)}!`),_.resolve({protocol:W,firstMessage:se}))})),_.promise}async function i(G,O){const{protocol:U}=await r(G,1,void 0,O);return{protocol:U}}async function n(G,O,U){const{protocol:x,firstMessage:z}=await r(G,2,O,U),Y=z&&z.debugPort;return{protocol:x,debugPort:Y}}async function a(G,O,U){const x=Date.now(),z=te(G,3),{protocol:Y}=await o(G,3,O,U);return G.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${he(x)}!`),Y}async function m(G,O,U){const{connectTo:x,connectionToken:z}=await G.addressProvider.getAddress();return{commit:G.commit,quality:G.quality,connectTo:x,connectionToken:z,reconnectionToken:O,reconnectionProtocol:U,remoteSocketFactoryService:G.remoteSocketFactoryService,signService:G.signService,logService:G.logService}}async function D(G,O,U){return k(G,async x=>{const{protocol:z}=await i(x,s.CancellationToken.None);return new X(G,O,U,x.reconnectionToken,z)})}e.$gl=D;async function I(G,O){return k(G,async U=>{const{protocol:x,debugPort:z}=await n(U,O,s.CancellationToken.None);return new K(G,O,U.reconnectionToken,x,z)})}e.$hl=I;async function k(G,O){for(let x=1;;x++)try{const z=(0,y.$ng)(),Y=await m(G,z,null);return await O(Y)}catch(z){if(x<5)G.logService.error(`[remote-connection][attempt ${x}] An error occurred in initial connection! Will retry... Error:`),G.logService.error(z);else throw G.logService.error(`[remote-connection][attempt ${x}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),G.logService.error(z),ue.triggerPermanentFailure(0,0,b.$8k.isHandled(z)),z}}async function C(G,O,U){const x=await m(G,(0,y.$ng)(),null);return await a(x,{host:O,port:U},s.CancellationToken.None)}e.$il=C;function M(G){return(0,P.$Qg)(O=>new Promise((U,x)=>{const z=setTimeout(U,G*1e3);O.onCancellationRequested(()=>{clearTimeout(z),U()})}))}var F;(function(G){G[G.ConnectionLost=0]="ConnectionLost",G[G.ReconnectionWait=1]="ReconnectionWait",G[G.ReconnectionRunning=2]="ReconnectionRunning",G[G.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",G[G.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class N{constructor(O,U){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.type=0}}e.$jl=N;class Z{constructor(O,U,x,z){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.durationSeconds=x,this.c=z,this.type=1}skipWait(){this.c.cancel()}}e.$kl=Z;class Q{constructor(O,U,x){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.attempt=x,this.type=2}}e.$ll=Q;class le{constructor(O,U,x){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.attempt=x,this.type=4}}e.$ml=le;class ce{constructor(O,U,x,z){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.attempt=x,this.handled=z,this.type=3}}e.$nl=ce;class ue extends E.$Sc{static triggerPermanentFailure(O,U,x){this._permanentFailure=!0,this.f=O,this.g=U,this.h=x,this.j.forEach(z=>z.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(O=>O.y())}static debugPauseSocketWriting(){this.j.forEach(O=>O.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ue._permanentFailure}constructor(O,U,x,z,Y){super(),this.t=O,this.u=U,this.reconnectionToken=x,this.protocol=z,this.w=Y,this.m=this.B(new A.$Sd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new le(this.reconnectionToken,0,0)),this.B(z.onSocketClose(W=>{const B=q(this.t,this.reconnectionToken,!0);W?W.type===0?(this.u.logService.info(`${B} received socket close event (hadError: ${W.hadError}).`),W.error&&this.u.logService.error(W.error)):(this.u.logService.info(`${B} received socket close event (wasClean: ${W.wasClean}, code: ${W.code}, reason: ${W.reason}).`),W.event&&this.u.logService.error(W.event)):this.u.logService.info(`${B} received socket close event.`),this.y()})),this.B(z.onSocketTimeout(W=>{const B=q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${B} received socket timeout event (unacknowledgedMsgCount: ${W.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${W.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${W.timeSinceLastReceivedSomeData}).`),this.y()})),ue.j.push(this),this.B((0,E.$Qc)(()=>{const W=ue.j.indexOf(this);W>=0&&ue.j.splice(W,1)})),this.n&&this.D(ue.f,ue.g,ue.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const O=q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let x=-1;do{x++;const z=x<U.length?U[x]:U[U.length-1];try{if(z>0){const W=M(z);this.m.fire(new Z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z,W)),this.u.logService.info(`${O} waiting for ${z} seconds before reconnecting...`);try{await W}catch{}}if(this.n){this.u.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x+1)),this.u.logService.info(`${O} resolving connection...`);const Y=await m(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${O} connecting to ${Y.connectTo}...`),await this.G(Y,g(p)),this.u.logService.info(`${O} reconnected!`),this.m.fire(new le(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x+1));break}catch(Y){if(Y.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}if(x>360){this.u.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}if(b.$8k.isTemporarilyNotAvailable(Y)){this.u.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if((Y.code==="ETIMEDOUT"||Y.code==="ENETUNREACH"||Y.code==="ECONNREFUSED"||Y.code==="ECONNRESET")&&Y.syscall==="connect"){this.u.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if((0,j.$4)(Y)){this.u.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if(Y instanceof b.$8k){this.u.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,b.$8k.isHandled(Y));break}this.u.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}}while(!this.n&&!this.s)}C(O,U,x){this.w?ue.triggerPermanentFailure(O,U,x):this.D(O,U,x)}D(O,U,x){this.m.fire(new ce(this.reconnectionToken,O,U,x)),H(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$ol=ue;class X extends ue{constructor(O,U,x,z,Y){super(1,O,z,Y,!0),this.client=this.B(new v.$Oh(Y,{remoteAuthority:U,clientId:x},O.ipcLogger))}async G(O,U){await i(O,U)}}e.$pl=X;class K extends ue{constructor(O,U,x,z,Y){super(2,O,x,z,!1),this.H=U,this.debugPort=Y}async G(O,U){await n(O,this.H,U)}}e.$ql=K;function H(G){try{G.acceptDisconnect();const O=G.getSocket();G.dispose(),O.dispose()}catch(O){(0,j.$1)(O)}}function L(G){if(G&&G.type==="error"){const O=new Error(`Connection error: ${G.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function T(G,O){for(;G.length<O;)G+=" ";return G}function V(G,O){return`[remote-connection][${T($(G),13)}][${O.substr(0,5)}\u2026]`}function q(G,O,U){return`${V(G,O)}[${U?"reconnect":"initial"}]`}function te(G,O){return`${q(O,G.reconnectionToken,!!G.reconnectionProtocol)}[${G.connectTo}]`}function he(G){return`${Date.now()-G} ms`}}),define(re[242],oe([0,1,2,6]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dl=e.$cl=void 0,e.$cl=(0,R.$3h)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(A,E){return this.a[A]??=[],this.a[A].push(E),(0,P.$Qc)(()=>{const f=this.a[A]?.indexOf(E);typeof f=="number"&&f>=0&&this.a[A]?.splice(f,1)})}b(A){return(this.a[A.type]||[]).find(f=>f.supports(A))}connect(A,E,f,h){const y=this.b(A);if(!y)throw new Error(`No socket factory found for ${A}`);return y.connect(A,E,f,h)}}e.$dl=s}),define(re[243],oe([0,1,26,48,21,113]),function(J,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b0b=void 0;let A;async function E(l=!1){return(A===void 0||l)&&(A=f()),A}e.$b0b=E;async function f(){const l=h();if(l===void 0)return!1;if(l>=22e3){const p=v();if(p)return new Promise(w=>{R.execFile(p,["--status"],$=>w(!$))})}else{const p=b();if(p)try{if((await s.Promises.stat(p)).isFile())return!0}catch{}}return!1}function h(){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());if(l)return parseInt(l[3])}function y(l){const p=process.env.SystemRoot;if(p){const w=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return j.join(p,w?"Sysnative":"System32",l)}}function v(){return y("wsl.exe")}function b(){return y("lxss\\LxssManager.dll")}}),define(re[52],oe([0,1,18,14,2,183,58,6,5,43]),function(J,e,P,R,s,j,A,E,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=void 0,e.$8o=(0,E.$3h)("requestService");class y{constructor(d){this.b=d}toJSON(){if(!this.a){const d=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?d[t]="*****":d[t]=this.b[t];this.a=d}return this.a}}class v extends s.$Sc{constructor(d){super(),this.b=0,this.a=d.createLogger("network",{name:(0,j.localize)(0,null),when:f.$Bj.isEqualTo((0,f.$zj)(f.LogLevel.Trace)).serialize()})}async c(d,t,o){const r=`${d} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new y(t.headers??{}));try{const i=await o();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,R.$0)(i)),i}}}e.$9o=v;function b(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}e.$0o=b;function l(S){return S.res.statusCode===204}e.$$o=l;async function p(S){return l(S)?null:(await(0,P.$se)(S.stream)).toString()}e.$_o=p;async function w(S){if(!b(S))throw new Error("Server returned "+S.res.statusCode);return p(S)}e.$ap=w;async function $(S){if(!b(S))throw new Error("Server returned "+S.res.statusCode);if(l(S))return null;const t=(await(0,P.$se)(S.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}e.$bp=$;function g(S){c(S)}e.$cp=g;let u;function c(S){const d=h.$vn.as(A.$An.Configuration),t=u;u={id:"http",order:15,title:(0,j.localize)(1,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,j.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,j.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,j.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,j.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,j.localize)(6,null),(0,j.localize)(7,null),(0,j.localize)(8,null),(0,j.localize)(9,null)],default:"override",description:(0,j.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,j.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,j.localize)(12,null),restricted:!0}}},d.updateConfigurations({add:[u],remove:t?[t]:[]})}c(1)}),define(re[244],oe([0,1,18,22]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=e.$$q=void 0;class s{constructor(E){this.a=E}listen(E,f){throw new Error("Invalid listen")}call(E,f,h,y=R.CancellationToken.None){switch(f){case"request":return this.a.request(h[0],y).then(async({res:v,stream:b})=>{const l=await(0,P.$se)(b);return[{statusCode:v.statusCode,headers:v.headers},l]});case"resolveProxy":return this.a.resolveProxy(h[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$$q=s;class j{constructor(E){this.a=E}async request(E,f){const[h,y]=await this.a.call("request",[E],f);return{res:h,stream:(0,P.$ue)(y)}}async resolveProxy(E){return this.a.call("resolveProxy",[E])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$_q=j}),define(re[245],oe([0,1,246,12]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=void 0;function s(A,E){return A.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:A.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function j(A,E,f={}){const h=(0,P.parse)(A),y=f.proxyUrl||s(h,E);if(!y)return null;const v=(0,P.parse)(y);if(!/^https?:$/.test(v.protocol||""))return null;const b={host:v.hostname||"",port:(v.port?+v.port:0)||(v.protocol==="https"?443:80),auth:v.auth,rejectUnauthorized:(0,R.$Lf)(f.strictSSL)?f.strictSSL:!0};return h.protocol==="http:"?new(await new Promise((l,p)=>{J(["http-proxy-agent"],l,p)})).HttpProxyAgent(y,b):new(await new Promise((l,p)=>{J(["https-proxy-agent"],l,p)})).HttpsProxyAgent(y,b)}e.$ar=j}),define(re[247],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w0b=e.$v0b=e.$u0b=void 0,e.$u0b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$v0b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$w0b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(re[94],oe([0,1,48,9,184,22,51,14,4,32,108,64,8,140]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=void 0;let p;async function w(g,u,c,S){return c["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.$i?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.$3l)(S)&&!c["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.$3l)(S)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=b.Promises.withAsyncBody(async(d,t)=>{const o=new j.$3d;let r=1e4;const i=g.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,l.$4l)(i,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),t(new Error((0,s.localize)(0,null)))},r);try{d(await $(u,o.token))}catch(a){!(0,E.$4)(a)&&!o.token.isCancellationRequested?t(new Error((0,s.localize)(1,null,(0,A.$Ni)(a)))):d({})}finally{clearTimeout(n),o.dispose()}})),p)}e.$9l=w;async function $(g,u){const c=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",c);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",S);const d=(0,h.$ng)().replace(/-/g,"").substr(0,12),t=new RegExp(d+"({.*})"+d),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",o);const r=await(0,y.$Sl)(f.OS,o);return g.trace("getUnixShellEnvironment#shell",r),new Promise((i,n)=>{if(u.isCancellationRequested)return n(new E.$5);const a=(0,R.$nc)(r);let m,D;const I=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(m=`& '${process.execPath}' ${I} -p '''${d}'' + JSON.stringify(process.env) + ''${d}'''`,D=["-Login","-Command"]):a==="nu"?(m=`^'${process.execPath}' ${I} -p '"${d}" + JSON.stringify(process.env) + "${d}"'`,D=["-i","-l","-c"]):a==="xonsh"?(m=`import os, json; print("${d}", json.dumps(dict(os.environ)), "${d}")`,D=["-i","-l","-c"]):(m=`'${process.execPath}' ${I} -p '"${d}" + JSON.stringify(process.env) + "${d}"'`,a==="tcsh"||a==="csh"?D=["-ic"]:D=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(D),m);const k=(0,P.spawn)(r,[...D,m],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});u.onCancellationRequested(()=>(k.kill(),n(new E.$5))),k.on("error",F=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,A.$Ni)(F)),n(F)});const C=[];k.stdout.on("data",F=>C.push(F));const M=[];k.stderr.on("data",F=>M.push(F)),k.on("close",(F,N)=>{const Z=Buffer.concat(C).toString("utf8");g.trace("getUnixShellEnvironment#raw",Z);const Q=Buffer.concat(M).toString("utf8");if(Q.trim()&&g.trace("getUnixShellEnvironment#stderr",Q),F||N)return n(new Error((0,s.localize)(2,null,F,N)));const le=t.exec(Z),ce=le?le[1]:"{}";try{const ue=JSON.parse(ce);c?ue.ELECTRON_RUN_AS_NODE=c:delete ue.ELECTRON_RUN_AS_NODE,S?ue.ELECTRON_NO_ATTACH_CONSOLE=S:delete ue.ELECTRON_NO_ATTACH_CONSOLE,delete ue.VSCODE_RESOLVING_ENVIRONMENT,delete ue.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",ue),i(ue)}catch(ue){g.error("getUnixShellEnvironment#errorCaught",(0,A.$Ni)(ue)),n(ue)}})})}}),define(re[248],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p6b=void 0;class P{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const j=await this.c();if(j){const A=String(P.a++);return this.b.set(A,j),{id:A,data:j.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,j){if(!s.id)return!0;const A=this.b.get(s.id);if(!A)return!1;this.b.delete(s.id);try{return A.validate(j)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$p6b=P}),define(re[95],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fl=e.$el=void 0,e.$el="signService",e.$fl=(0,P.$3h)(e.$el)}),define(re[249],oe([0,1,248]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k$b=void 0;class R extends P.$p6b{c(){return this.h().then(j=>new j.validator)}d(j){return this.h().then(A=>new A.signer().sign(j))}h(){return new Promise((j,A)=>J(["vsda"],j,A))}}e.$k$b=R}),define(re[34],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0N=e.$9N=void 0,e.$9N=(0,P.$3h)("stateReadService"),e.$0N=(0,P.$3h)("stateService")}),define(re[121],oe([0,1,8,18,2,12,37,16,5]),function(J,e,P,R,s,j,A,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aO=e.$_N=e.$$N=e.SaveStrategy=void 0;var h;(function(l){l[l.IMMEDIATE=0]="IMMEDIATE",l[l.DELAYED=1]="DELAYED"})(h||(e.SaveStrategy=h={}));class y extends s.$Sc{constructor(p,w,$,g){super(),this.h=p,this.j=w,this.m=$,this.n=g,this.a=Object.create(null),this.b="",this.c=this.B(new P.$1g(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(p){p.fileOperationResult!==1&&this.m.error(p)}}getItem(p,w){const $=this.a[p];return(0,j.$Of)($)?w:$}setItem(p,w){this.setItems([{key:p,data:w}])}setItems(p){let w=!1;for(const{key:$,data:g}of p)this.a[$]!==g&&((0,j.$Of)(g)?(0,j.$Mf)(this.a[$])||(this.a[$]=void 0,w=!0):(this.a[$]=g,w=!0));w&&this.s()}removeItem(p){(0,j.$Mf)(this.a[p])||(this.a[p]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const p=JSON.stringify(this.a,null,4);if(p!==this.b)try{await this.n.writeFile(this.h,R.$ge.fromString(p),{atomic:{postfix:".vsctmp"}}),this.b=p}catch(w){this.m.error(w)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$$N=y;let v=class extends s.$Sc{constructor(p,w,$,g){super(),this.a=this.B(new y(w.stateResource,p,$,g))}async init(){await this.a.init()}getItem(p,w){return this.a.getItem(p,w)}};e.$_N=v,e.$_N=v=Ee([ne(1,A.$0h),ne(2,f.$kj),ne(3,E.$nk)],v);class b extends v{setItem(p,w){this.a.setItem(p,w)}setItems(p){this.a.setItems(p)}removeItem(p){this.a.removeItem(p)}close(){return this.a.close()}}e.$aO=b}),define(re[122],oe([0,1,4,35,32]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xo=e.$wo=void 0;function j(f){if(P.$u===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function A(f,h,y,v,b,l,p,w,$){const g=Object.create(null);g["common.machineId"]=l,g["common.sqmId"]=p,g.sessionID=(0,s.$ng)()+Date.now(),g.commitHash=v,g.version=b,g["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,P.$h)(P.$u),g["common.nodePlatform"]=R.$dc,g["common.nodeArch"]=y,g["common.product"]=$||"desktop",w&&(g["common.msftInternal"]=w);let u=0;const c=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),P.$l&&(g["common.snap"]="true");const S=j(h);return S&&(g["common.platformDetail"]=S),g}e.$wo=A;function E(f){const h=R.env.USERDNSDOMAIN;if(!h)return!1;const y=h.toLowerCase();return f.some(v=>y===v)}e.$xo=E}),define(re[28],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=void 0,e.$rl=(0,P.$3h)("telemetryService"),e.$sl=(0,P.$3h)("customEndpointTelemetryService"),e.$tl="telemetry.currentSessionDate",e.$ul="telemetry.firstSessionDate",e.$vl="telemetry.lastSessionDate",e.$wl="telemetry.machineId",e.$xl="telemetry.sqmId",e.$yl="telemetry",e.$zl="telemetry.telemetryLevel",e.$Al="telemetry.enableCrashReporter",e.$Bl="telemetry.enableTelemetry";var R;(function(j){j[j.NONE=0]="NONE",j[j.CRASH=1]="CRASH",j[j.ERROR=2]="ERROR",j[j.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var s;(function(j){j.OFF="off",j.CRASH="crash",j.ERROR="error",j.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(re[250],oe([0,1,26,8,44,13,9,4,7,88,21,107,91,16,27,28]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vr=e.$Ur=e.$Tr=e.$Sr=void 0;const $=new Map;async function g(t,o){const r=`${t}::${o.join(":")}`,i=$.get(r);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,m=new Map,D=2e4;function I(C,M,F,N){const Z=M.substring(C.length+1);return R.Promises.withAsyncBody(async Q=>{let le;try{le=await y.Promises.readdir(M,{withFileTypes:!0})}catch{Q();return}if(N.count>=D){N.count+=le.length,N.maxReached=!0,Q();return}let ce=le.length;if(ce===0){Q();return}let ue=le;N.count+le.length>D&&(N.maxReached=!0,ce=D-N.count,ue=le.slice(0,ce)),N.count+=le.length;for(const X of ue)if(X.isDirectory()){if(F.includes(X.name)||await I(C,(0,A.$jc)(M,X.name),F,N),--ce===0){Q();return}}else{const K=X.name.lastIndexOf(".");if(K>=0){const H=X.name.substring(K+1);H&&a.set(H,(a.get(H)??0)+1)}for(const H of n)H.relativePathPattern?.test(Z)!==!1&&H.filePattern.test(X.name)&&m.set(H.tag,(m.get(H.tag)??0)+1);if(--ce===0){Q();return}}})}const k=R.Promises.withAsyncBody(async C=>{const M={count:0,maxReached:!1};await I(t,t,o,M);const F=await S(t);C({configFiles:u(m),fileTypes:u(a),fileCount:M.count,maxFilesReached:M.maxReached,launchConfigFiles:F})});return $.set(r,k),k}e.$Sr=g;function u(t){return Array.from(t.entries(),([o,r])=>({name:o,count:r})).sort((o,r)=>r.count-o.count)}function c(){const t={os:`${P.type()} ${P.arch()} ${P.release()}`,memory:`${(P.totalmem()/l.$Vk.GB).toFixed(2)}GB (${(P.freemem()/l.$Vk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(h.$7m.value()*100)}%`},o=P.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}e.$Tr=c;async function S(t){try{const o=new Map,r=(0,A.$jc)(t,".vscode","launch.json"),i=await y.Promises.readFile(r),n=[],a=(0,s.$_m)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${r}`),[];if((0,s.$in)(a)==="object"&&a.configurations)for(const m of a.configurations){const D=m.type;D&&(o.has(D)?o.set(D,o.get(D)+1):o.set(D,1))}return u(o)}catch{return[]}}e.$Ur=S;let d=class{constructor(o,r){this.c=o,this.d=r}f(o){const r=[];return r.push(`OS Version:       ${o.os}`),r.push(`CPUs:             ${o.cpus}`),r.push(`Memory (System):  ${o.memory}`),r.push(`VM:               ${o.vmHint}`),r.join(`
`)}g(o){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${P.type()} ${P.arch()} ${P.release()}`);const i=P.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(P.totalmem()/l.$Vk.GB).toFixed(2)}GB (${(P.freemem()/l.$Vk.GB).toFixed(2)}GB free)`),E.$i||r.push(`Load (avg):       ${P.loadavg().map(n=>Math.round(n)).join(", ")}`),r.push(`VM:               ${Math.round(h.$7m.value()*100)}%`),r.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${o.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(o,r){return Promise.all([(0,v.$Rr)(o.mainPID),this.k(o)]).then(async i=>{let[n,a]=i,m=this.m(o,n);return r.forEach(D=>{if((0,b.$Gm)(D))m+=`
${D.errorMessage}`,a+=`
${D.errorMessage}`;else if(m+=`

Remote: ${D.hostName}`,D.processes&&(m+=`
${this.m(o,D.processes)}`),D.workspaceMetadata){a+=`
|  Remote: ${D.hostName}`;for(const I of Object.keys(D.workspaceMetadata)){const k=D.workspaceMetadata[I];let C=`${k.fileCount} files`;k.maxFilesReached&&(C=`more than ${C}`),a+=`|    Folder (${I}): ${C}`,a+=this.h(k)}}}),{processInfo:m,workspaceInfo:a}})}async getSystemInfo(o,r){const{memory:i,vmHint:n,os:a,cpus:m}=c(),D={os:a,memory:i,cpus:m,vmHint:n,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:r};return E.$i||(D.load=`${P.loadavg().map(I=>Math.round(I)).join(", ")}`),E.$k&&(D.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(D)}async getDiagnostics(o,r){const i=[];return(0,v.$Rr)(o.mainPID).then(async n=>(i.push(""),i.push(this.g(o)),i.push(""),i.push(this.m(o,n)),o.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(o))),r.forEach(a=>{if((0,b.$Gm)(a))i.push(`
${a.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${a.hostName}`),i.push(this.f(a.machineInfo)),a.processes&&i.push(this.m(o,a.processes)),a.workspaceMetadata)for(const m of Object.keys(a.workspaceMetadata)){const D=a.workspaceMetadata[m];let I=`${D.fileCount} files`;D.maxFilesReached&&(I=`more than ${I}`),i.push(`Folder (${m}): ${I}`),i.push(this.h(D))}}),i.push(""),i.push(""),i.join(`
`)))}h(o){const r=[];let n=0;const a=(k,C)=>{const M=` ${k}(${C})`;n+M.length>60?(r.push(m),m="|                 ",n=m.length):n+=M.length,m+=M};let m="|      File types:";const D=10,I=o.fileTypes.length>D?D:o.fileTypes.length;for(let k=0;k<I;k++){const C=o.fileTypes[k];a(C.name,C.count)}if(r.push(m),o.configFiles.length>=0&&(m="|      Conf files:",n=0,o.configFiles.forEach(k=>{a(k.name,k.count)}),r.push(m)),o.launchConfigFiles.length>0){let k="|      Launch Configs:";o.launchConfigFiles.forEach(C=>{const M=C.count>1?` ${C.name}(${C.count})`:` ${C.name}`;k+=M}),r.push(k)}return r.join(`
`)}j(o){const r=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${o[i]}`).join(`
                  `)}k(o){const r=[],i=[];return o.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(r.push(`|  Window (${n.title})`),n.folderURIs.forEach(a=>{const m=f.URI.revive(a);if(m.scheme===j.Schemas.file){const D=m.fsPath;i.push(g(D,["node_modules",".git"]).then(I=>{let k=`${I.fileCount} files`;I.maxFilesReached&&(k=`more than ${k}`),r.push(`|    Folder (${(0,A.$nc)(D)}): ${k}`),r.push(this.h(I))}).catch(I=>{r.push(`|      Error: Unable to collect workspace stats for folder ${D} (${I.toString()})`)}))}else r.push(`|    Folder (${m.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>r.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(o,r){const i=new Map;o.windows.forEach(a=>i.set(a.pid,`window [${a.id}] (${a.title})`)),o.pidToNames.forEach(({pid:a,name:m})=>i.set(a,m));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),r&&this.n(o.mainPID,i,n,r,0),n.join(`
`)}n(o,r,i,n,a){const m=a===0;let D;m?D=n.pid===o?`${this.d.applicationName} main`:"remote agent":r.has(n.pid)?D=r.get(n.pid):D=`${"  ".repeat(a)} ${n.name}`;const I=process.platform==="win32"?n.mem:P.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(I/l.$Vk.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${D}`),Array.isArray(n.children)&&n.children.forEach(k=>this.n(o,r,i,k,a+1))}async getWorkspaceFileExtensions(o){const r=new Set;for(const{uri:i}of o.folders){const n=f.URI.revive(i);if(n.scheme!==j.Schemas.file)continue;const a=n.fsPath;try{(await g(a,["node_modules",".git"])).fileTypes.forEach(D=>r.add(D.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(o){for(const{uri:r}of o.folders){const i=f.URI.revive(r);if(i.scheme!==j.Schemas.file)continue;const n=i.fsPath;try{const a=await g(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),a.fileTypes.forEach(m=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:m.name,count:m.count})}),a.launchConfigFiles.forEach(m=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:m.name,count:m.count})}),a.configFiles.forEach(m=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:m.name,count:m.count})})}catch{}}}};e.$Vr=d,e.$Vr=d=Ee([ne(0,w.$rl),ne(1,p.$Cj)],d)}),define(re[251],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A0b=e.$z0b=void 0;class P{constructor(j){this.b=j}listen(j,A){throw new Error(`Event not found: ${A}`)}call(j,A,{eventName:E,data:f}){return this.b.forEach(h=>h.log(E,f)),Promise.resolve(null)}}e.$z0b=P;class R{constructor(j){this.b=j}log(j,A){return this.b.call("log",{eventName:j,data:A}).then(void 0,E=>`Failed to log telemetry: ${console.warn(E)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$A0b=R}),define(re[53],oe([0,1,38,12,3,17,59,122,28]),function(J,e,P,R,s,j,A,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=void 0;class h{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$yo=h;class y{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$zo=y,e.$Ao=new y;class v{async publicLog(n,a,m){}async publicLogError(n,a,m){}}e.$Bo=v,e.$Co="telemetry",e.$Do="extensionTelemetryLog",e.$Eo={log:()=>null,flush:()=>Promise.resolve(null)};function b(i,n){return s.Event.debounce(n.onDidChangeConfiguration,(m,D)=>{const I=m?new Set([...m.affectedKeys,...D.affectedKeys]):D.affectedKeys;return{...D,affectedKeys:I}},1e3,!0)(m=>{m.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,j.$zi)(m.source),configurationKeys:Array.from(m.affectedKeys)})})}e.$Fo=b;function l(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry)}e.$Go=l;function p(i,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$Ho=p;function w(i){const n=i.getValue(f.$zl),a=i.getValue(f.$Al);if(i.getValue(f.$Bl)===!1||a===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Io=w;function $(i){const n={},a={},m={};c(i,m);for(let D in m){D=D.length>150?D.substr(D.length-149):D;const I=m[D];typeof I=="number"?a[D]=I:typeof I=="boolean"?a[D]=I?1:0:typeof I=="string"?(I.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${I.length}`),n[D]=I.substring(0,8191)):typeof I<"u"&&I!==null&&(n[D]=I)}return{properties:n,measurements:a}}e.$Jo=$;const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(i){if(!i)return"none";const n=(0,A.$$k)(i);return g.has(n)?n:"other"}e.$Ko=u;function c(i,n,a=0,m){if(i)for(const D of Object.getOwnPropertyNames(i)){const I=i[D],k=m?m+D:D;Array.isArray(I)?n[k]=(0,P.$on)(I):I instanceof Date?n[k]=I.toISOString():(0,R.$Hf)(I)?a<2?c(I,n,a+1,k+"."):n[k]=(0,P.$on)(I):n[k]=I}}function S(i,n){const a=i.msftInternalDomains||[],m=n.getValue("telemetry.internalTesting");return(0,E.$xo)(a)||m}e.$Lo=S;function d(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$Mo=d;function t(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let a=i;const m=[];for(const C of n)for(;;){const M=C.exec(i);if(!M)break;m.push([M.index,C.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,I=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(a="";;){const C=I.exec(i);if(!C)break;const M=m.some(([F,N])=>C.index<N&&F<I.lastIndex);!D.test(C[0])&&!M&&(a+=i.substring(k,C.index)+"<REDACTED: user-file-path>",k=I.lastIndex)}return k<i.length&&(a+=i.substr(k)),a}function o(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of n)if(a.regex.test(i))return`<REDACTED: ${a.label}>`;return i}function r(i,n){return(0,P.$ln)(i,a=>{if(a instanceof h||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let m=a.replaceAll("%20"," ");m=t(m,n);for(const D of n)m=m.replace(D,"");return m=o(m),m}})}e.$No=r}),define(re[123],oe([0,1,25,117,120,4,7,14,35,53]),function(J,e,P,R,s,j,A,E,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=void 0;function y(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,P.$4e)(r.id,i.id)===0}e.$Oo=y;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(i){const n=i.manifest?i.manifest.version:i.version,a=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new b(i.identifier,n,a)}static parse(i){const n=v.exec(i);return n&&n[1]&&n[2]?new b({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,a="undefined"){this.version=n,this.targetPlatform=a,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof b?y(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Po=b;const l=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(r){const i=l.exec(r);return i&&i[1]?[$(i[1]),i[2]]:[$(r),void 0]}e.$Qo=p;function w(r,i){return`${r}.${i}`}e.$Ro=w;function $(r){return r.toLowerCase()}e.$So=$;function g(r,i){return $(w(r??s.$em,i))}e.$To=g;function u(r,i){const n=[],a=m=>{for(const D of n)if(D.some(I=>y(i(I),i(m))))return D;return null};for(const m of r){const D=a(m);D?D.push(m):n.push([m])}return n}e.$Uo=u;function c(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$Vo=c;function S(r){return{id:new h.$yo(r.identifier.id),name:new h.$yo(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Wo=S,e.$Xo=new s.$im("pprice.better-merge");function d(r,i){const n=[],a=i.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const m=a.shift();if(m&&n.every(D=>!y(D.identifier,{id:m}))){const D=r.filter(I=>y(I.identifier,{id:m}));D.length===1&&(n.push(D[0]),a.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$Yo=d;async function t(r,i){if(!j.$k)return!1;let n;try{n=(await r.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(m){i.debug("Error while getting the os-release file.",(0,E.$0)(m))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(r,i){const n=await t(r,i),a=(0,R.$io)(n?"alpine":j.$u,f.$ec);return i.debug("ComputeTargetPlatform:",a),a}e.$Zo=o}),define(re[252],oe([0,1,206,53]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=void 0;async function s(j,A,E,f,h,y,v){const b={"X-Market-Client-Id":`VSCode ${j}`,"User-Agent":`VSCode ${j} (${A.nameShort})`};if((0,R.$Go)(A,E)&&(0,R.$Io)(f)===3){const l=await(0,P.$op)(E,h,y);b["X-Market-User-Id"]=l,b["VSCode-SessionId"]=v.machineId||l}return b}e.$pp=s}),define(re[253],oe([0,1,2,38,4,25,185,17,58,79,27,43,28,53]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0;let p=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(g,u,c){this.k=u,this.l=c,this.d={},this.i=new P.$Rc,this.j=[],this.b=g.appenders,this.c=g.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=g.piiPaths||[],this.g=3,this.h=!!g.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const S of this.f)this.j.push(new RegExp((0,j.$Le)(S),"gi")),S.indexOf("\\")>=0&&this.j.push(new RegExp((0,j.$Le)(S.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(S=>{(S.affectsConfiguration(b.$zl)||S.affectsConfiguration(b.$Bl)||S.affectsConfiguration(b.$Al))&&this.m()}))}setExperimentProperty(g,u){this.d[g]=u}m(){let g=(0,l.$Io)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const c=u.usage?3:u.error?2:0;g=Math.min(g,c)}this.g=g}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(g,u,c){this.g<u||(c=(0,R.$mn)(c,this.d),c=(0,l.$No)(c,this.j),c=(0,R.$mn)(c,this.c),this.b.forEach(S=>S.log(g,c)))}publicLog(g,u){this.n(g,3,u)}publicLog2(g,u){this.publicLog(g,u)}publicLogError(g,u){this.h&&this.n(g,2,u)}publicLogError2(g,u){this.publicLogError(g,u)}};e.$dr=p,e.$dr=p=Ee([ne(1,E.$wi),ne(2,y.$Cj)],p);function w(){const $=(0,A.localize)(0,null,h.default.nameLong),g=h.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",h.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=s.$o?"":(0,A.localize)(3,null),c=(0,A.localize)(4,null),S=(0,A.localize)(5,null),d=(0,A.localize)(6,null),t=(0,A.localize)(7,null),o=`
|       | ${c} | ${S} | ${d} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,A.localize)(8,null);return`
${$} ${g} ${u}

&nbsp;

${t}
${o}

&nbsp;

${r}
`}v.$vn.as(f.$An.Configuration).registerConfiguration({id:b.$yl,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[b.$zl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.$vn.as(f.$An.Configuration).registerConfiguration({id:b.$yl,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[b.$Bl]:{type:"boolean",markdownDescription:h.default.privacyStatementUrl?(0,A.localize)(16,null,h.default.nameLong,h.default.privacyStatementUrl):(0,A.localize)(15,null,h.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${b.$zl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[254],oe([0,1,4,88,28]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$30b=e.$20b=void 0;async function j(E,f){let h=E.getItem(s.$wl);return(typeof h!="string"||P.$j&&h==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(h=await(0,R.$8m)(f.error.bind(f))),h}e.$20b=j;async function A(E,f){let h=E.getItem(s.$xl);return typeof h!="string"&&(h=await(0,R.$9m)(f.error.bind(f))),h}e.$30b=A}),define(re[255],oe([0,1,28,254]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$50b=e.$40b=void 0;async function s(A,E){const f=await(0,R.$20b)(A,E);return A.setItem(P.$wl,f),f}e.$40b=s;async function j(A,E){const f=await(0,R.$30b)(A,E);return A.setItem(P.$xl,f),f}e.$50b=j}),define(re[124],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var P;(function(R){R[R.Replace=1]="Replace",R[R.Append=2]="Append",R[R.Prepend=3]="Prepend"})(P||(e.EnvironmentVariableMutatorType=P={}))}),define(re[256],oe([0,1,4,124]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=void 0;const s=new Map([[R.EnvironmentVariableMutatorType.Append,"APPEND"],[R.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[R.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class j{constructor(y){this.collections=y,this.a=new Map,this.b=new Map,y.forEach((v,b)=>{this.d(v,b);const l=v.map.entries();let p=l.next();for(;!p.done;){const w=p.value[1],$=p.value[0];let g=this.a.get($);if(g||(g=[],this.a.set($,g)),g.length>0&&g[0].type===R.EnvironmentVariableMutatorType.Replace){p=l.next();continue}const u={extensionIdentifier:b,value:w.value,type:w.type,scope:w.scope,variable:w.variable,options:w.options};u.scope||delete u.scope,g.unshift(u),p=l.next()}})}async applyToProcessEnvironment(y,v,b){let l;P.$i&&(l={},Object.keys(y).forEach(p=>l[p.toLowerCase()]=p));for(const[p,w]of this.getVariableMap(v)){const $=P.$i&&l[p.toLowerCase()]||p;for(const g of w){const u=b?await b(g.value):g.value;if(g.options?.applyAtProcessCreation??!0)switch(g.type){case R.EnvironmentVariableMutatorType.Append:y[$]=(y[$]||"")+u;break;case R.EnvironmentVariableMutatorType.Prepend:y[$]=u+(y[$]||"");break;case R.EnvironmentVariableMutatorType.Replace:y[$]=u;break}if(g.options?.applyAtShellIntegration??!1){const c=`VSCODE_ENV_${s.get(g.type)}`;y[c]=(y[c]?y[c]+":":"")+p+"="+this.c(u)}}}}c(y){return y.replaceAll(":","\\x3a")}diff(y,v){const b=new Map,l=new Map,p=new Map;if(y.getVariableMap(v).forEach((w,$)=>{const g=this.getVariableMap(v).get($),u=E(w,g);u&&b.set($,u)}),this.getVariableMap(v).forEach((w,$)=>{const g=y.getVariableMap(v).get($),u=E(w,g);u&&p.set($,u)}),this.getVariableMap(v).forEach((w,$)=>{const g=y.getVariableMap(v).get($),u=f(w,g);u&&l.set($,u)}),!(b.size===0&&l.size===0&&p.size===0))return{added:b,changed:l,removed:p}}getVariableMap(y){const v=new Map;for(const b of this.a.values()){const l=b.filter(p=>A(p,y));l.length>0&&v.set(l[0].variable,l)}return v}getDescriptionMap(y){const v=new Map;for(const b of this.b.values()){const l=b.filter(p=>A(p,y,!0));for(const p of l)v.set(p.extensionIdentifier,p.description)}return v}d(y,v){if(!y.descriptionMap)return;const b=y.descriptionMap.entries();let l=b.next();for(;!l.done;){const p=l.value[1],w=l.value[0];let $=this.b.get(w);$||($=[],this.b.set(w,$));const g={extensionIdentifier:v,scope:p.scope,description:p.description};g.scope||delete g.scope,$.push(g),l=b.next()}}}e.$Fr=j;function A(h,y,v=!1){return h.scope?!!(h.scope.workspaceFolder&&y?.workspaceFolder&&h.scope.workspaceFolder.index===y.workspaceFolder.index):v?y===h.scope:!0}function E(h,y){if(!y)return h;const v=new Set;y.forEach(l=>v.add(l.extensionIdentifier));const b=[];return h.forEach(l=>{v.has(l.extensionIdentifier)||b.push(l)}),b.length===0?void 0:b}function f(h,y){if(!y)return;const v=new Map;y.forEach(l=>v.set(l.extensionIdentifier,l));const b=[];return h.forEach(l=>{const p=v.get(l.extensionIdentifier);p&&(l.type!==p.type||l.value!==p.value||l.scope?.workspaceFolder?.index!==p.scope?.workspaceFolder?.index)&&b.push(p)}),b.length===0?void 0:b}}),define(re[257],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=e.$Dr=e.$Cr=e.$Br=e.$Ar=e.$zr=void 0;function P(f){return[...f.entries()]}e.$zr=P;function R(f){return f?[...f.entries()]:[]}e.$Ar=R;function s(f){return new Map(f)}e.$Br=s;function j(f){return new Map(f??[])}e.$Cr=j;function A(f){return Array.from(f.entries()).map(h=>[h[0],P(h[1].map),R(h[1].descriptionMap)])}e.$Dr=A;function E(f){return new Map(f.map(h=>[h[0],{map:s(h[1]),descriptionMap:j(h[2])}]))}e.$Er=E}),define(re[258],oe([0,1,8,22,3,2,5]),function(J,e,P,R,s,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;let E=class extends j.$Sc{constructor(h,y){super(),this.h=y,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$Sd),this.onCreateRequest=this.g.event,this.b=h===void 0?15e3:h,this.B((0,j.$Qc)(()=>{for(const v of this.f.values())(0,j.$Nc)(v)}))}createRequest(h){return new Promise((y,v)=>{const b=++this.a;this.c.set(b,y),this.g.fire({requestId:b,...h});const l=new R.$3d;(0,P.$4g)(this.b,l.token).then(()=>v(`Request ${b} timed out (${this.b}ms)`)),this.f.set(b,[(0,j.$Qc)(()=>l.cancel())])})}acceptReply(h,y){const v=this.c.get(h);v?(this.c.delete(h),(0,j.$Nc)(this.f.get(h)||[]),this.f.delete(h),v(y)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${h}`)}};e.$qr=E,e.$qr=E=Ee([ne(1,A.$kj)],E)}),define(re[125],oe([0,1,6,114,43]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=e.$lr=e.$kr=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$jr=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ir=void 0,e.$ir=new R.$hj("terminalTabFocusMode",!1,!0);var j;(function(d){d.AutomationProfile="terminal.integrated.automationProfile.",d.DefaultProfile="terminal.integrated.defaultProfile.",d.Profiles="terminal.integrated.profiles."})(j||(e.TerminalSettingPrefix=j={}));var A;(function(d){d.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",d.AutomationProfileLinux="terminal.integrated.automationProfile.linux",d.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",d.AutomationProfileWindows="terminal.integrated.automationProfile.windows",d.ProfilesWindows="terminal.integrated.profiles.windows",d.ProfilesMacOs="terminal.integrated.profiles.osx",d.ProfilesLinux="terminal.integrated.profiles.linux",d.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",d.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",d.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",d.UseWslProfiles="terminal.integrated.useWslProfiles",d.TabsDefaultColor="terminal.integrated.tabs.defaultColor",d.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",d.TabsEnabled="terminal.integrated.tabs.enabled",d.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",d.TabsHideCondition="terminal.integrated.tabs.hideCondition",d.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",d.TabsShowActions="terminal.integrated.tabs.showActions",d.TabsLocation="terminal.integrated.tabs.location",d.TabsFocusMode="terminal.integrated.tabs.focusMode",d.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",d.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",d.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",d.CopyOnSelection="terminal.integrated.copyOnSelection",d.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",d.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",d.FontFamily="terminal.integrated.fontFamily",d.FontSize="terminal.integrated.fontSize",d.LetterSpacing="terminal.integrated.letterSpacing",d.LineHeight="terminal.integrated.lineHeight",d.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",d.TabStopWidth="terminal.integrated.tabStopWidth",d.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",d.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",d.BellDuration="terminal.integrated.bellDuration",d.FontWeight="terminal.integrated.fontWeight",d.FontWeightBold="terminal.integrated.fontWeightBold",d.CursorBlinking="terminal.integrated.cursorBlinking",d.CursorStyle="terminal.integrated.cursorStyle",d.CursorStyleInactive="terminal.integrated.cursorStyleInactive",d.CursorWidth="terminal.integrated.cursorWidth",d.Scrollback="terminal.integrated.scrollback",d.DetectLocale="terminal.integrated.detectLocale",d.DefaultLocation="terminal.integrated.defaultLocation",d.GpuAcceleration="terminal.integrated.gpuAcceleration",d.TerminalTitleSeparator="terminal.integrated.tabs.separator",d.TerminalTitle="terminal.integrated.tabs.title",d.TerminalDescription="terminal.integrated.tabs.description",d.RightClickBehavior="terminal.integrated.rightClickBehavior",d.Cwd="terminal.integrated.cwd",d.ConfirmOnExit="terminal.integrated.confirmOnExit",d.ConfirmOnKill="terminal.integrated.confirmOnKill",d.EnableBell="terminal.integrated.enableBell",d.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",d.AllowChords="terminal.integrated.allowChords",d.AllowMnemonics="terminal.integrated.allowMnemonics",d.TabFocusMode="terminal.integrated.tabFocusMode",d.EnvMacOs="terminal.integrated.env.osx",d.EnvLinux="terminal.integrated.env.linux",d.EnvWindows="terminal.integrated.env.windows",d.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",d.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",d.ShowExitAlert="terminal.integrated.showExitAlert",d.SplitCwd="terminal.integrated.splitCwd",d.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",d.WordSeparators="terminal.integrated.wordSeparators",d.EnableFileLinks="terminal.integrated.enableFileLinks",d.UnicodeVersion="terminal.integrated.unicodeVersion",d.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",d.LocalEchoEnabled="terminal.integrated.localEchoEnabled",d.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",d.LocalEchoStyle="terminal.integrated.localEchoStyle",d.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",d.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",d.HideOnStartup="terminal.integrated.hideOnStartup",d.CustomGlyphs="terminal.integrated.customGlyphs",d.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",d.InheritEnv="terminal.integrated.inheritEnv",d.ShowLinkHover="terminal.integrated.showLinkHover",d.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",d.AutoReplies="terminal.integrated.autoReplies",d.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",d.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",d.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",d.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",d.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",d.EnableImages="terminal.integrated.enableImages",d.SmoothScrolling="terminal.integrated.smoothScrolling",d.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",d.FocusAfterRun="terminal.integrated.focusAfterRun",d.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",d.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",d.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",d.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",d.MouseWheelZoom="terminal.integrated.mouseWheelZoom",d.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",d.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",d.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var E;(function(d){d.PowerShell="pwsh",d.Bash="bash",d.Fish="fish",d.Sh="sh",d.Csh="csh",d.Ksh="ksh",d.Zsh="zsh"})(E||(e.PosixShellType=E={}));var f;(function(d){d.CommandPrompt="cmd",d.PowerShell="pwsh",d.Wsl="wsl",d.GitBash="gitbash"})(f||(e.WindowsShellType=f={}));var h;(function(d){d[d.Api=0]="Api",d[d.Process=1]="Process",d[d.Sequence=2]="Sequence",d[d.Config=3]="Config"})(h||(e.TitleEventSource=h={}));var y;(function(d){d.LocalPty="localPty",d.PtyHost="ptyHost",d.PtyHostWindow="ptyHostWindow",d.Logger="logger",d.Heartbeat="heartbeat"})(y||(e.TerminalIpcChannels=y={}));var v;(function(d){d.Cwd="cwd",d.InitialCwd="initialCwd",d.FixedDimensions="fixedDimensions",d.Title="title",d.ShellType="shellType",d.HasChildProcesses="hasChildProcesses",d.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",d.OverrideDimensions="overrideDimensions",d.FailedShellIntegrationActivation="failedShellIntegrationActivation",d.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(v||(e.ProcessPropertyType=v={})),e.$jr=(0,P.$3h)("ptyService");var b;(function(d){d[d.BeatInterval=5e3]="BeatInterval",d[d.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",d[d.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",d[d.SecondWaitMultiplier=1]="SecondWaitMultiplier",d[d.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b||(e.HeartbeatConstants=b={}));var l;(function(d){d[d.Panel=1]="Panel",d[d.Editor=2]="Editor"})(l||(e.TerminalLocation=l={}));var p;(function(d){d.TerminalView="view",d.Editor="editor"})(p||(e.TerminalLocationString=p={}));var w;(function(d){d[d.GraceTime=6e4]="GraceTime",d[d.ShortGraceTime=6e3]="ShortGraceTime"})(w||(e.LocalReconnectConstants=w={}));var $;(function(d){d[d.HighWatermarkChars=1e5]="HighWatermarkChars",d[d.LowWatermarkChars=5e3]="LowWatermarkChars",d[d.CharCountAckSize=5e3]="CharCountAckSize"})($||(e.FlowControlConstants=$={}));var g;(function(d){d.GitBash="Git Bash",d.Pwsh="PowerShell"})(g||(e.ProfileSource=g={}));var u;(function(d){d[d.Off=0]="Off",d[d.FinalTerm=1]="FinalTerm",d[d.VSCode=2]="VSCode"})(u||(e.ShellIntegrationStatus=u={}));var c;(function(d){d[d.Unknown=0]="Unknown",d[d.Shutdown=1]="Shutdown",d[d.Process=2]="Process",d[d.User=3]="User",d[d.Extension=4]="Extension"})(c||(e.TerminalExitReason=c={})),e.$kr={Backend:"workbench.contributions.terminal.processBackend"};class S{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const o=this.b(t.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}s.$vn.add(e.$kr.Backend,new S),e.$lr=(0,P.$3h)("localPtyService"),e.$mr=(0,P.$3h)("terminalLogService")}),define(re[259],oe([0,1,75,7,187,102]),function(J,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=e.$sr=e.$rr=void 0;function A(b,l){const p=[{name:null,description:(0,s.localize)(0,null)}];return p.push(...b.map(w=>({name:w.profileName,description:E(w)}))),l&&p.push(...l.map(w=>({name:w.title,description:f(w)}))),{values:p.map(w=>w.name),markdownDescriptions:p.map(w=>w.description)}}e.$rr=A;function E(b){let l=`$(${j.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:P.$9j.terminal.id}) ${b.profileName}
- path: ${b.path}`;return b.args&&(typeof b.args=="string"?l+=`
- args: "${b.args}"`:l+=`
- args: [${b.args.length===0?"":`'${b.args.join("','")}'`}]`),b.overrideName!==void 0&&(l+=`
- overrideName: ${b.overrideName}`),b.color&&(l+=`
- color: ${b.color}`),b.env&&(l+=`
- env: ${JSON.stringify(b.env)}`),l}function f(b){return`$(${j.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:P.$9j.terminal.id}) ${b.title}
- extensionIdentifier: ${b.extensionIdentifier}`}function h(b,l){if(!b&&!l)return!0;if(typeof b=="string"&&typeof l=="string")return b===l;if(Array.isArray(b)&&Array.isArray(l)){if(b.length!==l.length)return!1;for(let p=0;p<b.length;p++)if(b[p]!==l[p])return!1;return!0}return!1}e.$sr=h;function y(b,l){if(!b&&!l)return!0;if(!b||!l)return!1;if(j.ThemeIcon.isThemeIcon(b)&&j.ThemeIcon.isThemeIcon(l))return b.id===l.id&&b.color===l.color;if(typeof b=="object"&&"light"in b&&"dark"in b&&typeof l=="object"&&"light"in l&&"dark"in l){const p=b,w=l;if((R.URI.isUri(p.light)||v(p.light))&&(R.URI.isUri(p.dark)||v(p.dark))&&(R.URI.isUri(w.light)||v(w.light))&&(R.URI.isUri(w.dark)||v(w.dark)))return p.light.path===w.light.path&&p.dark.path===w.dark.path}if(R.URI.isUri(b)&&R.URI.isUri(l)||v(b)||v(l)){const p=b,w=l;return p.path===w.path&&p.scheme===w.scheme}return!1}e.$tr=y;function v(b){return b?typeof b.path=="string"&&typeof b.scheme=="string":!1}e.$ur=v}),define(re[260],oe([0,1,75,4,186,58,43,259]),function(J,e,P,R,s,j,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=e.$xr=e.$wr=e.$vr=void 0,e.$vr={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$wr={type:"string",enum:Array.from((0,P.$8j)(),$=>$.id),markdownEnumDescriptions:Array.from((0,P.$8j)(),$=>`$(${$.id})`)};const f={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$wr},color:{description:(0,s.localize)(3,null),...e.$vr},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},h={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...f}},y={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...f}};function v($){const g=$===2?"linux":$===1?"osx":"windows";return(0,s.localize)(7,null,(0,R.$h)($),'```json\n"terminal.integrated.profile.'+g+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const b={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:v(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...f}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...f}},{type:"null"},h]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:v(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...f}},{type:"null"},h]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:v(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...f}},{type:"null"},h]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function l(){A.$vn.as(j.$An.Configuration).registerConfiguration(b),w()}e.$xr=l;let p;function w($,g){const u=A.$vn.as(j.$An.Configuration);let c;$&&(c=(0,E.$rr)($?.profiles,g));const S=p;p={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:$?.os===3?c?.values:void 0,markdownEnumDescriptions:$?.os===3?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:$?.os===2?c?.values:void 0,markdownEnumDescriptions:$?.os===2?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:$?.os===1?c?.values:void 0,markdownEnumDescriptions:$?.os===1?c?.markdownDescriptions:void 0}}},u.updateConfigurations({add:[p],remove:S?[S]:[]})}e.$yr=w}),define(re[261],oe([0,1,26,13,38,9,4,35,25,12,21,124,257,256]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ir=e.$Hr=e.$Gr=void 0;function p(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());let n=0;return i&&i.length===4&&(n=parseInt(i[3])),n}e.$Gr=p;async function w(i,n,a,m=E.env,D=y.Promises.exists){if(j.$ic(i))return await D(i)?i:void 0;if(n===void 0&&(n=E.cwd()),j.$mc(i)!=="."){const M=j.$jc(n,i);return await D(M)?M:void 0}const k=(0,s.$qn)(m,"PATH");if(a===void 0&&(0,h.$Ff)(k)&&(a=k.split(j.$tc)),a===void 0||a.length===0){const M=j.$jc(n,i);return await D(M)?M:void 0}for(const M of a){let F;if(j.$ic(M)?F=j.$jc(M,i):F=j.$jc(n,M,i),await D(F))return F;if(A.$i){let N=F+".com";if(await D(N)||(N=F+".exe",await D(N)))return N}}const C=j.$jc(n,i);return await D(C)?C:void 0}e.$Hr=w;function $(i,n,a,m,D){const I=A.$i&&(!n.windowsEnableConpty||p()<18309);if(!n.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||I)return;const k=i.args,C=E.$dc==="win32"?j.$nc(i.executable).toLowerCase():j.$nc(i.executable),M=j.$mc(R.$lg.asFileUri("").fsPath);let F;const N={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(N.VSCODE_NONCE=n.shellIntegration.nonce),A.$i){if(C==="pwsh.exe"||C==="powershell.exe")return!k||o(k)?F=c.get(u.WindowsPwsh):t(k)&&(F=c.get(u.WindowsPwshLogin)),F?(F=[...F],F[F.length-1]=(0,f.$He)(F[F.length-1],M,""),n.shellIntegration.suggestEnabled&&(N.VSCODE_SUGGEST="1"),{newArgs:F,envMixin:N}):void 0;m.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(C){case"bash":return!k||k.length===0?F=c.get(u.Bash):r(k)&&(N.VSCODE_SHELL_LOGIN="1",g(n,N),F=c.get(u.Bash)),F?(F=[...F],F[F.length-1]=(0,f.$He)(F[F.length-1],M),{newArgs:F,envMixin:N}):void 0;case"fish":{const Z=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",Q=j.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return N.XDG_DATA_DIRS=`${Z}:${Q}`,g(n,N),{newArgs:void 0,envMixin:N}}case"pwsh":return!k||o(k)?F=c.get(u.Pwsh):t(k)&&(F=c.get(u.PwshLogin)),F?(n.shellIntegration.suggestEnabled&&(N.VSCODE_SUGGEST="1"),F=[...F],F[F.length-1]=(0,f.$He)(F[F.length-1],M,""),{newArgs:F,envMixin:N}):void 0;case"zsh":{if(!k||k.length===0?F=c.get(u.Zsh):r(k)?(F=c.get(u.ZshLogin),g(n,N)):(k===c.get(u.Zsh)||k===c.get(u.ZshLogin))&&(F=k),!F)return;F=[...F],F[F.length-1]=(0,f.$He)(F[F.length-1],M);let Z;try{Z=P.userInfo().username}catch{Z="unknown"}const Q=j.$jc(P.tmpdir(),`${Z}-${D.applicationName}-zsh`);N.ZDOTDIR=Q;const le=a?.ZDOTDIR??P.homedir()??"~";N.USER_ZDOTDIR=le;const ce=[];return ce.push({source:j.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:j.$jc(Q,".zshrc")}),ce.push({source:j.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:j.$jc(Q,".zprofile")}),ce.push({source:j.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:j.$jc(Q,".zshenv")}),ce.push({source:j.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:j.$jc(Q,".zlogin")}),{newArgs:F,envMixin:N,filesToCopy:ce}}}m.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.$Ir=$;function g(i,n){if(A.$j&&i.environmentVariableCollections){const a=(0,b.$Er)(i.environmentVariableCollections),D=new l.$Fr(a).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),I=[];if(D)for(const k of D)k.type===v.EnvironmentVariableMutatorType.Prepend&&I.push(k.value);I.length>0&&(n.VSCODE_PATH_PREFIX=I.join(""))}}var u;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(u||(u={}));const c=new Map;c.set(u.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),c.set(u.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),c.set(u.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),c.set(u.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),c.set(u.Zsh,["-i"]),c.set(u.ZshLogin,["-il"]),c.set(u.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],d=["-nol","-nologo"];function t(i){return typeof i=="string"?S.includes(i.toLowerCase()):i.length===1&&S.includes(i[0].toLowerCase())||i.length===2&&(S.includes(i[0].toLowerCase())||S.includes(i[1].toLowerCase()))&&(d.includes(i[0].toLowerCase())||d.includes(i[1].toLowerCase()))}function o(i){return typeof i=="string"?d.includes(i.toLowerCase()):i.length===0||i?.length===1&&d.includes(i[0].toLowerCase())}function r(i){return i==="string"&&S.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&S.includes(i[0].toLowerCase())}}),define(re[262],oe([0,1,48,75,9,4,12,21,106,261,113]),function(J,e,P,R,s,j,A,E,f,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jr=void 0;var v;(function(a){a.UnixShellsPath="/etc/shells"})(v||(v={}));let b,l=!0;function p(a,m,D,I,k=process.env,C,M,F,N){return C=C||{existsFile:E.SymlinkSupport.existsFile,readFile:E.Promises.readFile},j.$i?w(D,C,k,M,I.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:I.getValue("terminal.integrated.profiles.windows"),typeof m=="string"?m:I.getValue("terminal.integrated.defaultProfile.windows"),N,F):r(C,M,D,a&&typeof a=="object"?{...a}:I.getValue(j.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof m=="string"?m:I.getValue(j.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),N,F,k)}e.$Jr=p;async function w(a,m,D,I,k,C,M,F,N){const Z=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),Q=`${process.env.windir}\\${Z?"Sysnative":"System32"}`;let le=!1;(0,h.$Gr)()>=16299&&(le=!0),await c(F);const ce=new Map;if(a){ce.set("PowerShell",{source:"PowerShell",icon:R.$9j.terminalPowershell,isAutoDetected:!0}),ce.set("Windows PowerShell",{path:`${Q}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:R.$9j.terminalPowershell,isAutoDetected:!0}),ce.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ce.set("Command Prompt",{path:`${Q}\\cmd.exe`,icon:R.$9j.terminalCmd,isAutoDetected:!0}),ce.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ce.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:R.$9j.terminalBash,isAutoDetected:!0});const X=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ce.set("Cmder",{path:`${Q}\\cmd.exe`,args:["/K",X],requiresPath:process.env.CMDER_ROOT?X:{path:X,isUnsafe:!0},isAutoDetected:!0})}i(C,ce);const ue=await $(ce.entries(),M,m,D,I,N);if(a&&k)try{const X=await t(`${Q}\\${le?"wsl":"bash"}.exe`,M);for(const K of X)(!C||!(K.profileName in C))&&ue.push(K)}catch{l&&(I?.info("WSL is not installed, so could not detect WSL profiles"),l=!1)}return ue}async function $(a,m,D,I=process.env,k,C){const M=[];for(const[F,N]of a)M.push(g(F,N,m,D,I,k,C));return(await Promise.all(M)).filter(F=>!!F)}async function g(a,m,D,I,k=process.env,C,M){if(m===null)return;let F,N,Z;if("source"in m&&!("path"in m)){const ue=b?.get(m.source);if(!ue)return;F=ue.paths,N=m.args||ue.args,m.icon?Z=u(m.icon):ue.icon&&(Z=ue.icon)}else F=Array.isArray(m.path)?m.path:[m.path],N=j.$i||Array.isArray(m.args)?m.args:void 0,Z=u(m.icon);let Q;if(M){const ue=F.map(K=>typeof K=="string"?K:K.path),X=await M(ue);Q=new Array(F.length);for(let K=0;K<F.length;K++)typeof F[K]=="string"?Q[K]=X[K]:Q[K]={path:X[K],isUnsafe:!0}}else Q=F.slice();let le;if(m.requiresPath){let ue;if((0,A.$Ff)(m.requiresPath)?ue=m.requiresPath:(ue=m.requiresPath.path,m.requiresPath.isUnsafe&&(le=ue)),!await I.existsFile(ue))return}const ce=await n(a,D,Q,I,k,N,m.env,m.overrideName,m.isAutoDetected,le);if(!ce){C?.debug("Terminal profile not validated",a,F);return}return ce.isAutoDetected=m.isAutoDetected,ce.icon=Z,ce.color=m.color,ce}function u(a){return typeof a=="string"?{id:a}:a}async function c(a){if(b&&!a)return;const[m,D]=await Promise.all([S(),a||d()]);b=new Map,b.set("Git Bash",{profileName:"Git Bash",paths:m,args:["--login","-i"]}),b.set("PowerShell",{profileName:"PowerShell",paths:D,icon:R.$9j.terminalPowershell})}async function S(){const a=new Set,m=await(0,h.$Hr)("git.exe");if(m){const k=(0,y.dirname)(m);a.add((0,y.resolve)(k,"../.."))}function D(k,C){C&&k.add(C)}D(a,process.env.ProgramW6432),D(a,process.env.ProgramFiles),D(a,process.env["ProgramFiles(X86)"]),D(a,`${process.env.LocalAppData}\\Program`);const I=[];for(const k of a)I.push(`${k}\\Git\\bin\\bash.exe`,`${k}\\Git\\usr\\bin\\bash.exe`,`${k}\\usr\\bin\\bash.exe`);return I.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),I.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),I}async function d(){const a=[];for await(const m of(0,f.$Ml)())a.push(m.exePath);return a}async function t(a,m){const D=[],I=await new Promise((M,F)=>{P.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(N,Z)=>{if(N)return F("Problem occurred when getting wsl distros");M(Z)})});if(!I)return[];const k=new RegExp(/[\r?\n]/),C=I.split(k).filter(M=>M.trim().length>0&&M!=="");for(const M of C){if(M===""||M.startsWith("docker-desktop"))continue;const F=`${M} (WSL)`,N={profileName:F,path:a,args:["-d",`${M}`],isDefault:F===m,icon:o(M),isAutoDetected:!1};D.push(N)}return D}function o(a){return a.includes("Ubuntu")?R.$9j.terminalUbuntu:a.includes("Debian")?R.$9j.terminalDebian:R.$9j.terminalLinux}async function r(a,m,D,I,k,C,M,F){const N=new Map;if(D&&await a.existsFile("/etc/shells")){const Z=(await a.readFile("/etc/shells")).toString(),Q=(C||Z.split(`
`)).map(ce=>{const ue=ce.indexOf("#");return ue===-1?ce:ce.substring(0,ue)}).filter(ce=>ce.trim().length>0),le=new Map;for(const ce of Q){let ue=(0,s.$nc)(ce),X=le.get(ue)||0;X++,X>1&&(ue=`${ue} (${X})`),le.set(ue,X),N.set(ue,{path:ce,isAutoDetected:!0})}}return i(I,N),await $(N.entries(),k,a,F,m,M)}function i(a,m){if(a)for(const[D,I]of Object.entries(a))I===null||typeof I!="object"||!("path"in I)&&!("source"in I)?m.delete(D):(I.icon=I.icon||m.get(D)?.icon,m.set(D,I))}async function n(a,m,D,I,k,C,M,F,N,Z){if(D.length===0)return Promise.resolve(void 0);const Q=D.shift();if(Q==="")return n(a,m,D,I,k,C,M,F,N);const le=typeof Q!="string"&&Q.isUnsafe,ce=typeof Q=="string"?Q:Q.path,ue={profileName:a,path:ce,args:C,env:M,overrideName:F,isAutoDetected:N,isDefault:a===m,isUnsafePath:le,requiresUnsafePath:Z};if((0,s.$nc)(ce)===ce){const K=k.PATH?k.PATH.split(s.$tc):void 0,H=await(0,h.$Hr)(ce,void 0,K,void 0,I.existsFile);return H?(ue.path=H,ue.isFromPath=!0,ue):n(a,m,D,I,k,C)}return await I.existsFile((0,s.$hc)(ce))?ue:n(a,m,D,I,k,C,M,F,N)}}),define(re[263],oe([0,1,3,2,4,42,17,5,226,94,258,125,260,262,108,73]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=void 0;var $;(function(u){u[u.MaxRestarts=5]="MaxRestarts"})($||($={}));let g=class extends R.$Sc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(c,S,d,t){super(),this.M=c,this.N=S,this.O=d,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new P.$Sd),this.onPtyHostExit=this.u.event,this.w=this.B(new P.$Sd),this.onPtyHostStart=this.w.event,this.y=this.B(new P.$Sd),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new P.$Sd),this.onPtyHostResponsive=this.z.event,this.C=this.B(new P.$Sd),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new P.$Sd),this.onProcessData=this.D.event,this.F=this.B(new P.$Sd),this.onProcessReady=this.F.event,this.G=this.B(new P.$Sd),this.onProcessReplay=this.G.event,this.H=this.B(new P.$Sd),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new P.$Sd),this.onDidRequestDetach=this.I.event,this.J=this.B(new P.$Sd),this.onDidChangeProperty=this.J.event,this.L=this.B(new P.$Sd),this.onProcessExit=this.L.event,(0,b.$xr)(),this.B(this.M),this.B((0,R.$Qc)(()=>this.W())),this.j=this.B(new y.$qr(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&P.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$i)return process.env;try{return await(0,h.$9l)(this.N,this.O,{_:[]},process.env)}catch(c){return this.O.error("ptyHost was unable to resolve shell environment",c),{}}}U(){const c=this.M.start(),S=c.client;this.O.getLevel()===E.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),j.ProxyChannel.toService(S.getChannel(v.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(c.onDidProcessExit(o=>{this.u.fire(o.code),!this.m&&!this.q.isDisposed&&(this.n<=$.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const t=j.ProxyChannel.toService(S.getChannel(v.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(o=>this.D.fire(o))),this.B(t.onProcessReady(o=>this.F.fire(o))),this.B(t.onProcessExit(o=>this.L.fire(o))),this.B(t.onDidChangeProperty(o=>this.J.fire(o))),this.B(t.onProcessReplay(o=>this.G.fire(o))),this.B(t.onProcessOrphanQuestion(o=>this.H.fire(o))),this.B(t.onDidRequestDetach(o=>this.I.fire(o))),this.B(new f.$pr(this.P,S.getChannel(v.TerminalIpcChannels.Logger))),this.a=c,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[c,t]}async createProcess(c,S,d,t,o,r,i,n,a,m,D){const I=setTimeout(()=>this.$(),v.HeartbeatConstants.CreateProcessTimeout),k=await this.f.createProcess(c,S,d,t,o,r,i,n,a,m,D);return clearTimeout(I),k}updateTitle(c,S,d){return this.f.updateTitle(c,S,d)}updateIcon(c,S,d,t){return this.f.updateIcon(c,S,d,t)}attachToProcess(c){return this.f.attachToProcess(c)}detachFromProcess(c,S){return this.f.detachFromProcess(c,S)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(c){return this.f.start(c)}shutdown(c,S){return this.f.shutdown(c,S)}input(c,S){return this.f.input(c,S)}processBinary(c,S){return this.f.processBinary(c,S)}resize(c,S,d){return this.f.resize(c,S,d)}clearBuffer(c){return this.f.clearBuffer(c)}acknowledgeDataEvent(c,S){return this.f.acknowledgeDataEvent(c,S)}setUnicodeVersion(c,S){return this.f.setUnicodeVersion(c,S)}getInitialCwd(c){return this.f.getInitialCwd(c)}getCwd(c){return this.f.getCwd(c)}async getLatency(){const c=new w.$Od,S=await this.f.getLatency();return c.stop(),[{label:"ptyhostservice<->ptyhost",latency:c.elapsed()},...S]}orphanQuestionReply(c){return this.f.orphanQuestionReply(c)}installAutoReply(c,S){return this.f.installAutoReply(c,S)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(c){return this.f.uninstallAutoReply(c)}getDefaultSystemShell(c){return this.g?.getDefaultSystemShell(c)??(0,p.$Sl)(c??s.OS,process.env)}async getProfiles(c,S,d,t=!1){const o=await this.S();return(0,l.$Jr)(S,d,t,this.N,o,void 0,this.O,this.bb.bind(this,c))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(c,S){return this.f.getWslPath(c,S)}getRevivedPtyNewId(c,S){return this.f.getRevivedPtyNewId(c,S)}setTerminalLayoutInfo(c){return this.f.setTerminalLayoutInfo(c)}async getTerminalLayoutInfo(c){return this.g?.getTerminalLayoutInfo(c)}async requestDetachInstance(c,S){return this.f.requestDetachInstance(c,S)}async acceptDetachInstanceReply(c,S){return this.f.acceptDetachInstanceReply(c,S)}async freePortKillProcess(c){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(c)}async serializeTerminalState(c){return this.f.serializeTerminalState(c)}async reviveTerminalProcesses(c,S,d){return this.f.reviveTerminalProcesses(c,S,d)}async refreshProperty(c,S){return this.f.refreshProperty(c,S)}async updateProperty(c,S,d){return this.f.updateProperty(c,S,d)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(c){this.ab(),this.s=setTimeout(()=>this.Y(),c?v.HeartbeatConstants.ConnectingBeatInterval:v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier+v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${v.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(c,S){return this.j.createRequest({workspaceId:c,originalText:S})}async acceptPtyHostResolvedVariables(c,S){this.j.acceptReply(c,S)}};e.$Kr=g,e.$Kr=g=Ee([ne(1,A.$wi),ne(2,E.$kj),ne(3,E.$lj)],g)}),define(re[70],oe([0,1,15,3,2,4,17,6,34]),function(J,e,P,R,s,j,A,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t9b=e.$s9b=void 0;const h="#FFFFFF",y="#1E1E1E",v="#000000",b="#FFFFFF",l="theme",p="themeBackground",w="windowSplash";e.$s9b=(0,E.$3h)("themeMainService");let $=class extends s.$Sc{constructor(u,c){super(),this.b=u,this.c=c,this.a=this.B(new R.$Sd),this.onDidChangeColorScheme=this.a.event,this.B(this.c.onDidChangeConfiguration(S=>{S.affectsConfiguration("window.systemColorTheme")&&this.f()})),this.f(),this.B(R.Event.fromNodeEventEmitter(P.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){switch(this.c.getValue("window.systemColorTheme")){case"dark":P.nativeTheme.themeSource="dark";break;case"light":P.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":P.nativeTheme.themeSource="light";break;case"vs-dark":P.nativeTheme.themeSource="dark";break;default:P.nativeTheme.themeSource="system"}break;default:P.nativeTheme.themeSource="system";break}}getColorScheme(){if(j.$i){if(P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(j.$j){if(P.nativeTheme.shouldUseInvertedColorScheme||P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(j.$k&&P.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const u=this.getColorScheme();if(u.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return u.dark?v:b;let c=this.b.getItem(p,null);if(!c)switch(this.g()){case"vs":c=h;break;case"hc-black":c=v;break;case"hc-light":c=b;break;default:c=y}return j.$j&&c.toUpperCase()===y&&(c="#171717"),c}g(){switch(this.b.getItem(l,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(u,c){this.b.setItems([{key:l,data:c.baseTheme},{key:p,data:c.colorInfo.background},{key:w,data:c}]),typeof u=="number"&&this.h(u,c),this.f()}h(u,c){for(const S of P.BrowserWindow.getAllWindows())if(S.id===u){S.setBackgroundColor(c.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(w)}};e.$t9b=$,e.$t9b=$=Ee([ne(0,f.$0N),ne(1,A.$wi)],$)}),define(re[126],oe([0,1,3,17,6,5]),function(J,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xv=e.$wv=e.$vv=e.$uv=e.$tv=e.$sv=e.$rv=e.$qv=e.ProvidedOnAutoForward=e.$pv=e.TunnelPrivacyId=e.TunnelProtocol=e.$ov=e.$nv=void 0,e.$nv=(0,s.$3h)("tunnelService"),e.$ov=(0,s.$3h)("sharedTunnelsService");var A;(function($){$.Http="http",$.Https="https"})(A||(e.TunnelProtocol=A={}));var E;(function($){$.ConstantPrivate="constantPrivate",$.Private="private",$.Public="public"})(E||(e.TunnelPrivacyId=E={}));function f($){return!!$.forwardPort}e.$pv=f;var h;(function($){$[$.Notify=1]="Notify",$[$.OpenBrowser=2]="OpenBrowser",$[$.OpenPreview=3]="OpenPreview",$[$.Silent=4]="Silent",$[$.Ignore=5]="Ignore",$[$.OpenBrowserOnce=6]="OpenBrowserOnce"})(h||(e.ProvidedOnAutoForward=h={}));function y($){if($.scheme!=="http"&&$.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec($.authority);if(g)return{address:g[1],port:+g[2]}}e.$qv=y,e.$rv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function v($){return e.$rv.indexOf($)>=0}e.$sv=v,e.$tv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b($){return e.$tv.indexOf($)>=0}e.$uv=b;function l($,g,u,c){if(u===1)return!1;if(u===2&&b(g)){const S=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(S?.length===4&&parseInt(S[1])>=18)return!1}return $<1024}e.$vv=l;class p{constructor(g,u,c){this.remoteAddress=g,this.localAddress=u,this.b=c,this.a=new P.$Sd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$wv=p;let w=class{constructor(g,u){this.j=g,this.k=u,this.a=new P.$Sd,this.onTunnelOpened=this.a.event,this.b=new P.$Sd,this.onTunnelClosed=this.b.event,this.c=new P.$Sd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const g=this.k.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(g){return this.f=g,g?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this.g=g.elevation,this.h=g.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const g=[],u=Array.from(this.e.values());for(const c of u){const S=Array.from(c.values());for(const d of S){const t=await d.value;t&&typeof t!="string"&&g.push(t)}}return g}async dispose(){for(const g of this.e.values()){for(const{value:u}of g.values())await u.then(c=>typeof c!="string"?c?.dispose():void 0);g.clear()}this.e.clear()}setEnvironmentTunnel(g,u,c,S,d){this.p(g,u,Promise.resolve({tunnelRemoteHost:g,tunnelRemotePort:u,localAddress:c,privacy:S,protocol:d,dispose:()=>Promise.resolve()}))}async getExistingTunnel(g,u){(b(g)||v(g))&&(g=e.$rv[0]);const c=this.r(g,u);if(c)return++c.refcount,c.value}openTunnel(g,u,c,S,d,t=!1,o,r){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${c} on local port ${d}.`);const i=this.f??g;if(!i)return;if(u||(u="localhost"),S||(S=this.l),this.f&&this.i.has(c)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.s(i,u,c,S,d,t,o,r);return n?n.then(a=>{if(a){if(typeof a=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(u,c),a}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(u,c);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const m=this.n(a);return(a.tunnelRemoteHost!==u||a.tunnelRemotePort!==c)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&a.privacy!==o&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(m),m}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}n(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const u=this.e.get(g.tunnelRemoteHost);if(u){const c=u.get(g.tunnelRemotePort);c&&(c.refcount--,await this.o(g.tunnelRemoteHost,g.tunnelRemotePort,c))}}}}async o(g,u,c){if(c.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${u}.`);const S=c.value.then(async d=>{d&&typeof d!="string"&&(await d.dispose(!0),this.b.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this.e.has(g)&&this.e.get(g).delete(u),S}}async closeTunnel(g,u){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${u} `);const c=this.e.get(g);if(c&&c.has(u)){const S=c.get(u);S.refcount=0,await this.o(g,u,S)}}p(g,u,c){this.e.has(g)||this.e.set(g,new Map),this.e.get(g).set(u,{refcount:1,value:c})}async q(g,u){const c=this.e.get(g);if(c){const S=c.get(u),d=S?await S.value:void 0;(!d||typeof d=="string")&&c.delete(u),c.size===0&&this.e.delete(g)}}r(g,u){const c=[g];v(g)?(c.push(...e.$rv),c.push(...e.$tv)):b(g)&&c.push(...e.$tv);const S=c.map(d=>this.e.get(d));for(const d of S){const t=d?.get(u);if(t)return t}}canTunnel(g){return!!y(g)}t(g,u,c,S,d,t,o){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${c} on local port ${S}.`);const r=c;this.i.add(r);const i=S===void 0?c:S,n={elevationRequired:d?this.isPortPrivileged(i):!1},a={remoteAddress:{host:u,port:c},localAddressPort:S,privacy:t,public:t?t!==E.Private:void 0,protocol:o},m=g.forwardPort(a,n);return m?(this.p(u,c,m),m.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(r)})):this.i.delete(r),m}};e.$xv=w,e.$xv=w=Ee([ne(0,j.$kj),ne(1,R.$wi)],w)}),define(re[49],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iV=e.$hV=e.DisablementReason=e.UpdateType=e.StateType=void 0;var R;(function(A){A.Uninitialized="uninitialized",A.Idle="idle",A.Disabled="disabled",A.CheckingForUpdates="checking for updates",A.AvailableForDownload="available for download",A.Downloading="downloading",A.Downloaded="downloaded",A.Updating="updating",A.Ready="ready"})(R||(e.StateType=R={}));var s;(function(A){A[A.Setup=0]="Setup",A[A.Archive=1]="Archive",A[A.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var j;(function(A){A[A.NotBuilt=0]="NotBuilt",A[A.DisabledByEnvironment=1]="DisabledByEnvironment",A[A.ManuallyDisabled=2]="ManuallyDisabled",A[A.MissingConfiguration=3]="MissingConfiguration",A[A.InvalidConfiguration=4]="InvalidConfiguration",A[A.RunningAsAdmin=5]="RunningAsAdmin"})(j||(e.DisablementReason=j={})),e.$hV={Uninitialized:{type:"uninitialized"},Disabled:A=>({type:"disabled",reason:A}),Idle:(A,E)=>({type:"idle",updateType:A,error:E}),CheckingForUpdates:A=>({type:"checking for updates",explicit:A}),AvailableForDownload:A=>({type:"available for download",update:A}),Downloading:A=>({type:"downloading",update:A}),Downloaded:A=>({type:"downloaded",update:A}),Updating:A=>({type:"updating",update:A}),Ready:A=>({type:"ready",update:A})},e.$iV=(0,P.$3h)("updateService")}),define(re[264],oe([0,1,4,188,58,43]),function(J,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),j.$vn.as(s.$An.Configuration).registerConfiguration({id:"update",order:15,title:(0,R.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,R.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,R.localize)(2,null),(0,R.localize)(3,null),(0,R.localize)(4,null),(0,R.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,R.localize)(6,null),deprecationMessage:(0,R.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,R.localize)(8,null),description:(0,R.localize)(9,null),included:P.$i&&!P.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,R.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(re[265],oe([0,1,3,49]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C0b=e.$B0b=void 0;class s{constructor(E){this.a=E}listen(E,f){switch(f){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${f}`)}call(E,f,h){switch(f){case"checkForUpdates":return this.a.checkForUpdates(h);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(h)}throw new Error(`Call not found: ${f}`)}}e.$B0b=s;class j{get state(){return this.b}set state(E){this.b=E,this.a.fire(E)}constructor(E){this.c=E,this.a=new P.$Sd,this.onStateChange=this.a.event,this.b=R.$hV.Uninitialized,this.c.listen("onStateChange")(f=>this.state=f),this.c.call("_getInitialState").then(f=>this.state=f)}checkForUpdates(E){return this.c.call("checkForUpdates",E)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(E){return this.c.call("_applySpecificUpdate",E)}}e.$C0b=j}),define(re[40],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=void 0,e.$Xk=(0,P.$3h)("IUriIdentityService")}),define(re[266],oe([0,1,40,207,16,19,141,3,2]),function(J,e,P,R,s,j,A,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=void 0;class h{static{this._clock=0}constructor(b){this.uri=b,this.time=h._clock++}touch(){return this.time=h._clock++,this}}let y=class{constructor(b){this.g=b,this.c=new f.$Rc,this.f=2**16;const l=new Map,p=w=>{let $=l.get(w.scheme);return $===void 0&&($=b.hasProvider(w)&&!this.g.hasCapability(w,1024),l.set(w.scheme,$)),$};this.c.add(E.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(w=>{l.delete(w.scheme)})),this.extUri=new j.$tg(p),this.d=new A.$Nr((w,$)=>this.extUri.compare(w,$,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(b){this.g.hasProvider(b)&&(b=(0,j.$Fg)(b));const l=this.d.get(b);return l?l.touch().uri.with({fragment:b.fragment}):(this.d.set(b,new h(b)),this.h(),b)}h(){if(this.d.size<this.f)return;const b=[...this.d.entries()].sort((p,w)=>p[1].time<w[1].time?1:p[1].time>w[1].time?-1:0);h._clock=0,this.d.clear();const l=this.f*.5;for(let p=0;p<l;p++)this.d.set(b[p][0],b[p][1].touch())}};e.$Or=y,e.$Or=y=Ee([ne(0,s.$nk)],y),(0,R.$Lr)(P.$Xk,y,1)}),define(re[127],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$U=void 0,e.$$U=(0,P.$3h)("urlService")}),define(re[267],oe([0,1,7]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L0b=e.$K0b=e.$J0b=void 0;class R{constructor(E){this.a=E}listen(E,f){throw new Error(`Event not found: ${f}`)}call(E,f,h){switch(f){case"handleURL":return this.a.handleURL(P.URI.revive(h[0]),h[1])}throw new Error(`Call not found: ${f}`)}}e.$J0b=R;class s{constructor(E){this.a=E}handleURL(E,f){return this.a.call("handleURL",[E.toJSON(),f])}}e.$K0b=s;class j{constructor(E,f){this.a=E,this.b=f}async routeCall(E,f,h,y){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(Array.isArray(h)&&h.length>0){const v=P.URI.revive(h[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",v.toString(!0)),v.query){const b=/\bwindowId=(\d+)/.exec(v.query);if(b){const l=b[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${l}"`,v.toString(!0));const p=new RegExp(`window:${l}`),w=E.connections.find($=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",$.ctx),p.test($.ctx)));if(w)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",v.toString(!0)),w;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",v.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",v.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(E,f,h,y)}routeEvent(E,f){throw new Error(`Event not found: ${f}`)}}e.$L0b=j}),define(re[268],oe([0,1,8,2,7,27]),function(J,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aV=e.$_U=void 0;class A extends R.$Sc{constructor(){super(...arguments),this.a=new Set}open(h,y){const v=[...this.a.values()];return(0,P.$7g)(v.map(b=>()=>b.handleURL(h,y)),void 0,!1).then(b=>b||!1)}registerHandler(h){return this.a.add(h),(0,R.$Qc)(()=>this.a.delete(h))}}e.$_U=A;let E=class extends A{constructor(h){super(),this.b=h}create(h){let{authority:y,path:v,query:b,fragment:l}=h||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return y&&v&&v.indexOf("/")!==0&&(v=`/${v}`),s.URI.from({scheme:this.b.urlProtocol,authority:y,path:v,query:b,fragment:l})}};e.$aV=E,e.$aV=E=Ee([ne(0,j.$Cj)],E)}),define(re[269],oe([0,1,15,8,3,2,4,7]),function(J,e,P,R,s,j,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M0b=void 0;class f extends j.$Sc{constructor(y,v,b,l,p,w){if(super(),this.c=v,this.f=w,this.a=[],this.b=0,y&&(w.trace("ElectronURLListener initialUrisToHandle:",y.map(u=>u.originalUrl)),this.a=y),A.$i){const u=l.isBuilt?[]:[`"${l.appRoot}"`];u.push("--open-url","--"),P.app.setAsDefaultProtocolClient(p.urlProtocol,process.execPath,u)}const $=s.Event.map(s.Event.fromNodeEventEmitter(P.app,"open-url",(u,c)=>({event:u,url:c})),({event:u,url:c})=>(u.preventDefault(),c));this.B($(u=>{const c=this.g(u);c&&this.c.open(c,{originalUrl:u})})),b.getWindows().filter(u=>u.isReady).length>0?(w.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(w.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(s.Event.once(b.onDidSignalReadyWindow)(()=>this.h())))}g(y){try{return E.URI.parse(y)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const y=[];for(const v of this.a)await this.c.open(v.uri,{originalUrl:v.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",v.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",v.originalUrl),y.push(v));y.length!==0&&(this.a=y,(0,R.$5g)(()=>this.h(),500,this.q))}}e.$M0b=f}),define(re[270],oe([0,1,3,2,16,57,31]),function(J,e,P,R,s,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n$b=void 0;class E extends R.$Sc{constructor(h,y,v,b,l,p){super(),this.f=h,this.g=y,this.h=v,this.j=b,this.m=l,this.n=p,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new P.$Sd),this.onDidChangeFile=this.a.event,this.b=j.$9h.forUris(()=>!(this.capabilities&1024)),this.c=new A.$Bc(w=>this.m.extUri.getComparisonKey(this.t(w))),this.r(),this.B(b.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(w=>this.s(w)))}r(){this.c.clear();for(const h of this.j.profiles)this.c.add(h.settingsResource),this.c.add(h.keybindingsResource),this.c.add(h.tasksResource),this.c.add(h.extensionsResource)}open(h,y){return this.g.open(this.t(h),y)}close(h){return this.g.close(h)}read(h,y,v,b,l){return this.g.read(h,y,v,b,l)}write(h,y,v,b,l){return this.g.write(h,y,v,b,l)}watch(h,y){this.b.set(h,h);const v=this.g.watch(this.t(h),y);return(0,R.$Qc)(()=>{this.b.delete(h),v.dispose()})}stat(h){return this.g.stat(this.t(h))}mkdir(h){return this.g.mkdir(this.t(h))}rename(h,y,v){return this.g.rename(this.t(h),this.t(y),v)}readFile(h,y){return this.g.readFile(this.t(h),y)}readFileStream(h,y,v){return this.g.readFileStream(this.t(h),y,v)}readdir(h){return this.g.readdir(this.t(h))}enforceAtomicReadFile(h){return this.c.has(h)}writeFile(h,y,v){return this.g.writeFile(this.t(h),y,v)}enforceAtomicWriteFile(h){return this.c.has(h)?{postfix:".vsctmp"}:!1}delete(h,y){return this.g.delete(this.t(h),y)}copy(h,y,v){if((0,s.$rk)(this.g))return this.g.copy(this.t(h),this.t(y),v);throw new Error("copy not supported")}cloneFile(h,y){if((0,s.$sk)(this.g))return this.g.cloneFile(this.t(h),this.t(y));throw new Error("clone not supported")}s(h){const y=[];for(const v of h){if(v.resource.scheme!==this.f)continue;const b=this.u(v.resource);this.b.findSubstr(b)&&y.push({resource:b,type:v.type,cId:v.cId})}y.length&&(this.n.debug("User data changed"),this.a.fire(y))}t(h){return h.with({scheme:this.f})}u(h){return h.with({scheme:this.h})}}e.$n$b=E}),define(re[271],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$70b=void 0,e.$70b="utilityProcessWorker"}),define(re[272],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N0b=void 0,e.$N0b=(0,P.$3h)("webviewManagerService")}),define(re[273],oe([0,1,15,2,13,7]),function(J,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O0b=void 0;class A extends R.$Sc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const f=this.b.bind(this);P.protocol.registerFileProtocol(s.Schemas.vscodeWebview,f)}b(f,h){try{const y=j.URI.parse(f.url),v=A.a.get(y.path);if(typeof v=="string"){const b=`vs/workbench/contrib/webview/browser/pre/${v}`,l=s.$lg.asFileUri(b);return h({path:l.fsPath,headers:{...s.COI.getHeadersFromQuery(f.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return h({error:-10})}catch{}return h({error:-2})}}e.$O0b=A}),define(re[60],oe([0,1,4]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IC=e.$HC=e.$GC=e.$FC=e.$EC=e.$DC=e.$CC=e.$BC=e.$AC=e.$zC=void 0,e.$zC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R(b){return typeof b.parentId=="number"}e.$AC=R;function s(b){return!!b.workspaceUri}e.$BC=s;function j(b){return!!b.folderUri}e.$CC=j;function A(b){return!!b.fileUri}e.$DC=A;function E(b){const l=f(b),p=b.getValue("window.menuBarVisibility");return p==="default"||l==="native"&&p==="compact"||P.$j&&P.$m?"classic":p}e.$EC=E;function f(b){if(P.$o)return"custom";const l=b.getValue("window");if(l){if(P.$j&&l.nativeTabs===!0||P.$j&&l.nativeFullScreen===!1)return"native";const $=l.titleBarStyle;if($==="native"||$==="custom")return $}return P.$k?"native":"custom"}e.$FC=f;function h(b){return!(!P.$i||P.$o||f(b)==="native")}e.$GC=h;function y(b){const l=b.getValue("window");return!l||typeof l.nativeFullScreen!="boolean"||l.nativeTabs?!0:l.nativeFullScreen!==!1}e.$HC=y;function v(b=0){return Math.pow(1.2,b)}e.$IC=v}),define(re[128],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$d9b=e.UnloadReason=e.LoadReason=void 0;var P;(function(E){E[E.INITIAL=1]="INITIAL",E[E.LOAD=2]="LOAD",E[E.RELOAD=3]="RELOAD"})(P||(e.LoadReason=P={}));var R;(function(E){E[E.CLOSE=1]="CLOSE",E[E.QUIT=2]="QUIT",E[E.RELOAD=3]="RELOAD",E[E.LOAD=4]="LOAD"})(R||(e.UnloadReason=R={}));const s=function(E=1){return{width:1024,height:768,mode:E}};e.$d9b=s;var j;(function(E){E[E.Maximized=0]="Maximized",E[E.Normal=1]="Normal",E[E.Minimized=2]="Minimized",E[E.Fullscreen=3]="Fullscreen"})(j||(e.WindowMode=j={}));var A;(function(E){E[E.UNRESPONSIVE=1]="UNRESPONSIVE",E[E.PROCESS_GONE=2]="PROCESS_GONE",E[E.LOAD=3]="LOAD"})(A||(e.WindowError=A={}))}),define(re[274],oe([0,1,8,3,2]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U0b=void 0;class j extends s.$Sc{constructor({onDidOpenMainWindow:E,onDidFocusMainWindow:f,getActiveWindowId:h}){super(),this.a=this.B(new s.$Rc),R.Event.latch(R.Event.any(E,f))(this.f,this,this.a),this.b=(0,P.$Qg)(()=>h()),(async()=>{try{const v=await this.b;this.c=typeof this.c=="number"?this.c:v}catch{}finally{this.b=void 0}})()}f(E){this.b&&(this.b.cancel(),this.b=void 0),this.c=E}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$U0b=j}),define(re[30],oe([0,1,192,9,57,19,7,6,13]),function(J,e,P,R,s,j,A,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.WorkbenchState=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=void 0,e.$_h=(0,E.$3h)("contextService");function h(i){const n=i;return typeof n?.id=="string"&&A.URI.isUri(n.uri)}e.$ai=h;function y(i){return typeof i?.id=="string"&&!h(i)&&!b(i)}e.$bi=y,e.$ci={id:"ext-dev"},e.$di={id:"empty-window"};function v(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,R.$nc)(i)}:n?e.$ci:e.$di;const a=i;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.$ei=v;function b(i){const n=i;return typeof n?.id=="string"&&A.URI.isUri(n.configPath)}e.$fi=b;function l(i){const n=i;if(n?.uri)return{id:n.id,uri:A.URI.revive(n.uri)};const a=i;if(a?.configPath)return{id:a.id,configPath:A.URI.revive(a.configPath)};if(i?.id)return{id:i.id}}e.$gi=l;var p;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function w(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$hi=w;function $(i){const n=i;return!!(n&&typeof n=="object"&&A.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$ii=$;class g{constructor(n,a,m,D,I){this.h=n,this.j=m,this.k=D,this.l=I,this.c=s.$9h.forUris(this.l,()=>!0),this.folders=a}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=s.$9h.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ji=g;class u{constructor(n,a){this.raw=a,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,j.$Eg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ki=u;function c(i){return new u({uri:i,index:0,name:(0,j.$Ag)(i)},{uri:i.toString()})}e.$li=c,e.$mi="code-workspace",e.$ni=`.${e.$mi}`,e.$oi=[{name:(0,P.localize)(0,null),extensions:[e.$mi]}],e.$pi="workspace.json";function S(i,n){return j.$vg.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$qi=S;function d(i){let n;return A.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===f.Schemas.tmp}e.$ri=d,e.$si="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$si}e.$ti=t;function o(i,n){return!S(i,n)&&!d(i)}e.$ui=o;function r(i){return(typeof i=="string"?(0,R.$oc)(i):(0,j.$Cg)(i))===e.$ni}e.$vi=r}),define(re[54],oe([0,1,15,8,45,47,2,85,4,21,167,115,6,5,27,30]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z9b=e.$y9b=void 0,e.$y9b=(0,b.$3h)("dialogMainService");let $=class{constructor(u,c){this.d=u,this.e=c,this.a=new Map,this.b=new Map,this.c=new R.$0g}pickFileFolder(u,c){return this.f({...u,pickFolders:!0,pickFiles:!0,title:(0,y.localize)(0,null)},c)}pickFolder(u,c){return this.f({...u,pickFolders:!0,title:(0,y.localize)(1,null)},c)}pickFile(u,c){return this.f({...u,pickFiles:!0,title:(0,y.localize)(2,null)},c)}pickWorkspace(u,c){const S=(0,y.localize)(3,null),d=(0,j.$Pv)((0,y.localize)(4,null)),t=w.$oi;return this.f({...u,pickFiles:!0,title:S,filters:t,buttonLabel:d},c)}async f(u,c){const S={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters,defaultPath:u.defaultPath};(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(S.properties=void 0,u.pickFiles&&u.pickFolders&&(S.properties=["multiSelections","openDirectory","openFile","createDirectory"])),S.properties||(S.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),f.$j&&S.properties.push("treatPackageAsDirectory");const d=await this.showOpenDialog(S,(c||P.BrowserWindow.getFocusedWindow())??void 0);if(d&&d.filePaths&&d.filePaths.length>0)return d.filePaths}g(u){if(u){let c=this.b.get(u.id);return c||(c=new R.$0g,this.b.set(u.id,c)),c}else return this.c}showMessageBox(u,c){return this.g(c).queue(async()=>{const{options:S,buttonIndeces:d}=(0,v.$Wv)(u,this.e);let t;return c?t=await P.dialog.showMessageBox(c,S):t=await P.dialog.showMessageBox(S),{response:d[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(u,c){const S=this.j(u,c);if(!S)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(c).queue(async()=>{let d;return c?d=await P.dialog.showSaveDialog(c,u):d=await P.dialog.showSaveDialog(u),d.filePath=this.h(d.filePath),d})}finally{(0,A.$Nc)(S)}}h(u){return u&&f.$j&&(u=(0,E.$Dl)(u)),u}i(u){return u.map(c=>this.h(c))}async showOpenDialog(u,c){u.defaultPath&&(await h.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const S=this.j(u,c);if(!S)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(c).queue(async()=>{let d;return c?d=await P.dialog.showOpenDialog(c,u):d=await P.dialog.showOpenDialog(u),d.filePaths=this.i(d.filePaths),d})}finally{(0,A.$Nc)(S)}}j(u,c){if(!c)return A.$Sc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",u);let S=this.a.get(c.id);S||(S=new Set,this.a.set(c.id,S));const d=(0,s.$Qi)(u);if(!S.has(d))return this.d.trace("[DialogMainService]: new file dialog lock created",u),S.add(d),(0,A.$Qc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",u),S?.delete(d),S?.size===0&&this.a.delete(c.id)})}};e.$z9b=$,e.$z9b=$=Ee([ne(0,l.$kj),ne(1,p.$Cj)],$)}),define(re[275],oe([0,1,3,2,77,30]),function(J,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y0b=void 0;class A extends R.$Sc{static{this.a=100}constructor(f,h){super(),this.f=f,this.g=h,this.b=this.B(new P.$Sd),this.c=new Map,this.h(h.applicationStorage,this.b)}h(f,h){this.B(P.Event.debounce(f.onDidChangeStorage,(y,v)=>(y?y.push(v):y=[v],y),A.a)(y=>{y.length&&h.fire(this.j(y,f))}))}j(f,h){const y=new Map,v=new Set;return f.forEach(b=>{const l=h.get(b.key);typeof l=="string"?y.set(b.key,l):v.add(b.key)}),{changed:Array.from(y.entries()),deleted:Array.from(v.values())}}listen(f,h,y){switch(h){case"onDidChangeStorage":{const v=y.profile?(0,s.$zh)(y.profile):void 0;if(!v)return this.b.event;let b=this.c.get(v.id);return b||(b=this.B(new P.$Sd),this.h(this.g.profileStorage(v),b),this.c.set(v.id,b)),b.event}}throw new Error(`Event not found: ${h}`)}async call(f,h,y){const v=y.profile?(0,s.$zh)(y.profile):void 0,b=(0,j.$gi)(y.workspace),l=await this.m(v,b);switch(h){case"getItems":return Array.from(l.items.entries());case"updateItems":{const p=y;if(p.insert)for(const[w,$]of p.insert)l.set(w,$);p.delete?.forEach(w=>l.delete(w));break}case"optimize":return l.optimize();case"isUsed":{const p=y.payload;if(typeof p=="string")return this.g.isUsed(p)}default:throw new Error(`Call not found: ${h}`)}}async m(f,h){let y;h?y=this.g.workspaceStorage(h):f?y=this.g.profileStorage(f):y=this.g.applicationStorage;try{await y.init()}catch(v){this.f.error(`StorageIPC#init: Unable to init ${h?"workspace":f?"profile":"application"} storage due to ${v}`)}return y}}e.$y0b=A}),define(re[41],oe([0,1,45,3,2,19,7,189,37,16,6,5,30,31,40,8,32,25,12]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p,w,$,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.ProfileResourceType=void 0;var c;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(c||(e.ProfileResourceType=c={}));function S(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&A.URI.isUri(n.location)&&A.URI.isUri(n.globalStorageHome)&&A.URI.isUri(n.settingsResource)&&A.URI.isUri(n.keybindingsResource)&&A.URI.isUri(n.tasksResource)&&A.URI.isUri(n.snippetsHome)&&A.URI.isUri(n.extensionsResource))}e.$Yk=S,e.$Zk=(0,y.$3h)("IUserDataProfilesService");function d(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:A.URI.revive(i.location).with({scheme:n}),globalStorageHome:A.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:A.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:A.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:A.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:A.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:A.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:A.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$1k=d;function t(i,n,a,m,D,I){return{id:i,name:n,location:a,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:I&&D?.useDefaultFlags?.globalState?I.globalStorageHome:(0,j.$Eg)(a,"globalStorage"),settingsResource:I&&D?.useDefaultFlags?.settings?I.settingsResource:(0,j.$Eg)(a,"settings.json"),keybindingsResource:I&&D?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,j.$Eg)(a,"keybindings.json"),tasksResource:I&&D?.useDefaultFlags?.tasks?I.tasksResource:(0,j.$Eg)(a,"tasks.json"),snippetsHome:I&&D?.useDefaultFlags?.snippets?I.snippetsHome:(0,j.$Eg)(a,"snippets"),extensionsResource:I&&D?.useDefaultFlags?.extensions?I.extensionsResource:(0,j.$Eg)(a,"extensions.json"),cacheHome:(0,j.$Eg)(m,i),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}e.$2k=t;let o=class extends s.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,a,m,D){super(),this.t=n,this.u=a,this.w=m,this.y=D,this.f=!0,this.h=this.B(new R.$Sd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$Sd),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$Sd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$Sd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new l.$Ac,emptyWindows:new Map},this.profilesHome=(0,j.$Eg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,j.$Eg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),a=[n];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,u.$Ff)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}a.push(t((0,j.$Bg)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},n))}}catch(I){this.y.error(I)}const m=new l.$Ac,D=new Map;if(a.length)try{const I=this.Q();if(I.workspaces)for(const[k,C]of Object.entries(I.workspaces)){const M=A.URI.parse(k),F=a.find(N=>N.id===C);F&&m.set(M,F)}if(I.emptyWindows)for(const[k,C]of Object.entries(I.emptyWindows)){const M=a.find(F=>F.id===C);M&&D.set(k,M)}}catch(I){this.y.error(I)}this.z={profiles:a,workspaces:m,emptyWindows:D}}return this.z}D(){const n=t("__default__profile__",(0,E.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const a="Temp",m=new RegExp(`${(0,g.$Le)(a)}\\s(\\d+)`);let D=0;for(const k of this.profiles){const C=m.exec(k.name),M=C?parseInt(C[1]):0;D=M>D?M:D}const I=`${a} ${D+1}`;return this.createProfile((0,P.$Qi)((0,$.$ng)()).toString(16),I,{transient:!0},n)}async createNamedProfile(n,a,m){return this.createProfile((0,P.$Qi)((0,$.$ng)()).toString(16),n,a,m)}async createProfile(n,a,m,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(n,a,m);return D&&await this.setProfileForWorkspace(D,I),I}async F(n,a,m){if(!(0,u.$Ff)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(a);return D||(D=(async()=>{try{const I=this.profiles.find(M=>M.name===a||M.id===n);if(I)return I;const k=t(n,a,(0,j.$Eg)(this.profilesHome,n),this.g,m,this.defaultProfile);await this.u.createFolder(k.location);const C=[];return this.j.fire({profile:k,join(M){C.push(M)}}),await w.Promises.settled(C),this.I([k],[],[]),k}finally{this.r.delete(a)}})(),this.r.set(a,D)),D}async updateProfile(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let m=this.profiles.find(D=>D.id===n.id);if(!m)throw new Error(`Profile '${n.name}' does not exist`);return m=t(m.id,a.name??m.name,m.location,this.g,{shortName:a.shortName??m.shortName,icon:a.icon===null?void 0:a.icon??m.icon,transient:a.transient??m.isTransient,useDefaultFlags:a.useDefaultFlags??m.useDefaultFlags},this.defaultProfile),this.I([],[],[m]),m}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(D=>D.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);const m=[];this.m.fire({profile:a,join(D){m.push(D)}});try{await Promise.allSettled(m)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])a.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])a.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[a],[]);try{await this.u.del(a.cacheHome,{recursive:!0})}catch(D){(0,h.$Ek)(D)!==1&&this.y.error(D)}}async setProfileForWorkspace(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=this.profiles.find(D=>D.id===a.id);if(!m)throw new Error(`Profile '${a.name}' does not exist`);this.L(n,m)}unsetWorkspace(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,a)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(a=>a.isDirectory&&this.profiles.every(m=>!this.w.extUri.isEqual(m.location,a.resource))).map(a=>this.u.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(a=>!this.H(a));await Promise.allSettled(n.map(a=>this.removeProfile(a)))}getProfileForWorkspace(n){const a=this.G(n);return A.URI.isUri(a)?this.s.workspaces.get(a)??this.C.workspaces.get(a):this.s.emptyWindows.get(a)??this.C.emptyWindows.get(a)}G(n){return(0,b.$ai)(n)?n.uri:(0,b.$fi)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.s.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.C.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.C.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,n.location)))}I(n,a,m){const D=[...this.profiles,...n],I=[];this.s.profiles=[];for(let k of D)k.isDefault||a.some(C=>k.id===C.id)||(k=m.find(C=>k.id===C.id)??k,k.isTransient?this.s.profiles.push(k):I.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P(I),this.z=void 0,this.J(n,a,m)}J(n,a,m){this.h.fire({added:n,removed:a,updated:m,all:this.profiles})}L(n,a,m){m=a?.isTransient?!0:m,m||this.L(n,void 0,!0);const D=this.G(n),I=m?this.s:this.C;A.URI.isUri(D)?(I.workspaces.delete(D),a&&I.workspaces.set(D,a)):(I.emptyWindows.delete(D),a&&I.emptyWindows.set(D,a)),m||this.M()}M(){const n={};for(const[m,D]of this.C.workspaces.entries())n[m.toString()]=D.id;const a={};for(const[m,D]of this.C.emptyWindows.entries())a[m.toString()]=D.id;this.R({workspaces:n,emptyWindows:a}),this.z=void 0}N(n){const a={},m=this.D();if(n.workspaces)for(const[I,k]of Object.entries(n.workspaces)){const C=A.URI.parse(k);a[I]=this.w.extUri.isEqual(C,m.location)?m.id:this.w.extUri.basename(C)}const D={};if(n.emptyWindows)for(const[I,k]of Object.entries(n.emptyWindows)){const C=A.URI.parse(k);D[I]=this.w.extUri.isEqual(C,m.location)?m.id:this.w.extUri.basename(C)}return{workspaces:a,emptyWindows:D}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$3k=o,e.$3k=o=Ee([ne(0,f.$0h),ne(1,h.$nk),ne(2,p.$Xk),ne(3,v.$kj)],o);class r extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$4k=r}),define(re[81],oe([0,1,8,18,2,3,31,7,117,123,16,6,5,41,40,12,14,28]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p,w,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=e.$Jp=e.$Ip=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class c extends Error{constructor(r,i){super(r),this.code=i}}e.$Ip=c,e.$Jp=(0,v.$3h)("IExtensionsProfileScannerService");let S=class extends s.$Sc{constructor(r,i,n,a,m,D){super(),this.j=r,this.m=i,this.n=n,this.r=a,this.s=m,this.t=D,this.b=this.B(new j.$Sd),this.onAddExtensions=this.b.event,this.c=this.B(new j.$Sd),this.onDidAddExtensions=this.c.event,this.f=this.B(new j.$Sd),this.onRemoveExtensions=this.f.event,this.g=this.B(new j.$Sd),this.onDidRemoveExtensions=this.g.event,this.h=new A.$Ac}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i){const n=[],a=[];try{return await this.u(i,m=>{const D=[];for(const I of m)r.some(([k])=>(0,h.$Oo)(k.identifier,I.identifier)&&k.manifest.version!==I.version)?n.push(I):D.push(I);for(const[I,k]of r){const C=D.findIndex(F=>(0,h.$Oo)(F.identifier,I.identifier)&&F.version===I.manifest.version),M={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:k};C===-1?(a.push(M),D.push(M)):D.splice(C,1,M)}return a.length&&this.b.fire({extensions:a,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),D}),a.length&&this.c.fire({extensions:a,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),a}catch(m){throw a.length&&this.c.fire({extensions:a,error:m,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:m,profileLocation:i}),m}}async updateMetadata(r,i){const n=[];return await this.u(i,a=>{const m=[];for(const D of a){const I=r.find(([k])=>(0,h.$Oo)(k.identifier,D.identifier)&&k.manifest.version===D.version);I&&(D.metadata={...D.metadata,...I[1]},n.push(D)),m.push(D)}return m}),n}async removeExtensionFromProfile(r,i){const n=[];try{await this.u(i,a=>{const m=[];for(const D of a)(0,h.$Oo)(D.identifier,r.identifier)?n.push(D):m.push(D);return n.length&&this.f.fire({extensions:n,profileLocation:i}),m}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(a){throw n.length&&this.g.fire({extensions:n,error:a,profileLocation:i}),a}}async u(r,i,n){return this.F(r).queue(async()=>{let a=[],m;try{const D=await this.m.readFile(r);m=JSON.parse(D.value.toString().trim()||"[]")}catch(D){if((0,y.$Ek)(D)!==1)throw D;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(m=await this.D()),!m&&n?.bailOutWhenFileNotFound)throw new c((0,$.$0)(D),"ERROR_PROFILE_NOT_FOUND")}if(m){Array.isArray(m)||this.w(r);let D=!1;for(const I of m){d(I)||this.w(r);let k;if((0,w.$Ff)(I.relativeLocation)&&I.relativeLocation)k=this.z(I.relativeLocation);else if((0,w.$Ff)(I.location))k=this.z(I.location),D=!0,I.relativeLocation=I.location,I.location=k.toJSON();else{k=E.URI.revive(I.location);const C=this.y(k);C&&(D=!0,I.relativeLocation=C)}a.push({identifier:I.identifier,location:k,version:I.version,metadata:I.metadata})}D&&await this.m.writeFile(r,R.$ge.fromString(JSON.stringify(m)))}if(i){a=i(a);const D=a.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.y(I.location),metadata:I.metadata}));await this.m.writeFile(r,R.$ge.fromString(JSON.stringify(D)))}return a})}w(r){const i=new c(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch(m){if((0,y.$Ek)(m)===1)return;throw m}this.t.info("Migrating extensions from old default profile location",r.toString());let a;try{const m=JSON.parse(n);Array.isArray(m)&&m.every(D=>d(D))?a=m:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",m)}catch(m){this.t.error(m)}if(a)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,R.$ge.fromString(JSON.stringify(a)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(m){if((0,y.$Ek)(m)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw m}try{await this.m.del(r)}catch(m){(0,y.$Ek)(m)!==1&&this.t.error(m)}try{await this.m.del(i)}catch(m){(0,y.$Ek)(m)!==1&&this.t.error(m)}return a})()),this.C}F(r){let i=this.h.get(r);return i||(i=new P.$0g,this.h.set(r,i)),i}};e.$Kp=S,e.$Kp=S=Ee([ne(1,y.$nk),ne(2,l.$Zk),ne(3,p.$Xk),ne(4,g.$rl),ne(5,b.$kj)],S);function d(o){return(0,w.$Hf)(o)&&(0,f.$lo)(o.identifier)&&(t(o.location)||(0,w.$Ff)(o.location)&&o.location)&&((0,w.$Mf)(o.relativeLocation)||(0,w.$Ff)(o.relativeLocation))&&o.version&&(0,w.$Ff)(o.version)}function t(o){return o?(0,w.$Ff)(o.path)&&(0,w.$Ff)(o.scheme):!1}}),define(re[129],oe([0,1,23,8,38,18,14,44,152,2,13,9,4,19,205,74,12,7,172,37,123,120,204,16,6,5,27,3,77,81,41,40,203]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p,w,$,g,u,c,S,d,t,o,r,i,n,a,m,D,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=e.$Pp=e.$Op=e.$Np=e.Translations=void 0;var M;(function(ue){function X(K,H){if(K===H)return!0;const L=Object.keys(K),T=new Set;for(const V of Object.keys(H))T.add(V);if(L.length!==T.size)return!1;for(const V of L){if(K[V]!==H[V])return!1;T.delete(V)}return T.size===0}ue.equals=X})(M||(e.Translations=M={})),e.$Np=(0,r.$3h)("IExtensionsScannerService");let F=class extends h.$Sc{constructor(X,K,H,L,T,V,q,te,he,G,O,U){super(),this.systemExtensionsLocation=X,this.userExtensionsLocation=K,this.r=H,this.s=L,this.t=T,this.u=V,this.w=q,this.y=te,this.z=he,this.C=G,this.D=O,this.F=U,this.g=this.B(new a.$Sd),this.onDidChangeCache=this.g.event,this.h=(0,l.$Eg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(Q,this.s,this.h)),this.m=this.B(this.F.createInstance(Q,this.s,this.h)),this.n=this.B(this.F.createInstance(Z,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,S.$Zo)(this.w,this.y)),this.G}async scanAllExtensions(X,K,H){const[L,T]=await Promise.all([this.scanSystemExtensions(X),this.scanUserExtensions(K)]),V=H?await this.scanExtensionsUnderDevelopment(X,[...L,...T]):[];return this.L(L,T,V,await this.getTargetPlatform(),!0)}async scanSystemExtensions(X){const K=[];K.push(this.M(!!X.useCache,X.language)),K.push(this.N(X.language,!!X.checkControlFile));const[H,L]=await Promise.all(K);return this.J([...H,...L],0,X,!1)}async scanUserExtensions(X){const K=X.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",K);const H=this.D.extUri.isEqual(X.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,L=await this.P(K,!!X.profileLocation,1,!X.includeUninstalled,X.language,!0,H),T=X.useCache&&!L.devMode&&L.excludeObsolete?this.m:this.n;let V;try{V=await T.scanExtensions(L)}catch(q){if(q instanceof D.$Ip&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),V=await T.scanExtensions(L);else throw q}return V=await this.J(V,1,X,!0),this.y.trace("Scanned user extensions:",V.length),V}async scanExtensionsUnderDevelopment(X,K){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const H=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(L=>L.scheme===y.Schemas.file).map(async L=>{const T=await this.P(L,!1,1,!0,X.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(T)).map(q=>(q.type=K.find(te=>(0,S.$Oo)(te.identifier,q.identifier))?.type??q.type,this.n.validate(q,T)))}))).flat();return this.J(H,"development",X,!0)}return[]}async scanExistingExtension(X,K,H){const L=await this.P(X,!1,K,!0,H.language,!0,void 0),T=await this.n.scanExtension(L);return!T||!H.includeInvalid&&!T.isValid?null:T}async scanOneOrMultipleExtensions(X,K,H){const L=await this.P(X,!1,K,!0,H.language,!0,void 0),T=await this.n.scanOneOrMultipleExtensions(L);return this.J(T,K,H,!0)}async scanMetadata(X){const K=(0,l.$Eg)(X,"package.json"),H=(await this.w.readFile(K)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(X,K){const H=(0,l.$Eg)(X,"package.json"),L=(await this.w.readFile(H)).value.toString(),T=JSON.parse(L);K.isMachineScoped===!1&&delete K.isMachineScoped,K.isBuiltin===!1&&delete K.isBuiltin,T.__metadata={...T.__metadata,...K},await this.w.writeFile((0,l.$Eg)(X,"package.json"),j.$ge.fromString(JSON.stringify(T,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(X){if(X instanceof D.$Ip&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw X}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const X=await this.scanUserExtensions({includeInvalid:!0});if(X.length)await this.u.addExtensionsToProfile(X.map(K=>[K,K.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,j.$ge.fromString(JSON.stringify([])))}catch(K){(0,o.$Ek)(K)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$0)(K))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(X){this.y.error(X)}finally{this.H=void 0}})()),this.H}async J(X,K,H,L){return H.includeAllVersions||(X=this.L(K===0?X:void 0,K===1?X:void 0,K==="development"?X:void 0,await this.getTargetPlatform(),L)),H.includeInvalid||(X=X.filter(T=>T.isValid)),X.sort((T,V)=>{const q=v.$nc(T.location.fsPath),te=v.$nc(V.location.fsPath);return q<te?-1:q>te?1:0})}L(X,K,H,L,T){const V=(te,he,G)=>{if(te.isValid&&!he.isValid)return!1;if(te.isValid===he.isValid){if(T&&p.gt(te.manifest.version,he.manifest.version))return this.y.debug(`Skipping extension ${he.location.path} with lower version ${he.manifest.version} in favour of ${te.location.path} with version ${te.manifest.version}`),!1;if(p.eq(te.manifest.version,he.manifest.version)){if(te.type===0)return this.y.debug(`Skipping extension ${he.location.path} in favour of system extension ${te.location.path} with same version`),!1;if(te.targetPlatform===L)return this.y.debug(`Skipping extension ${he.location.path} from different target platform ${he.targetPlatform}`),!1}}return G?this.y.warn(`Overwriting user extension ${te.location.path} with ${he.location.path}.`):this.y.debug(`Overwriting user extension ${te.location.path} with ${he.location.path}.`),!0},q=new d.$km;return X?.forEach(te=>{const he=q.get(te.identifier.id);(!he||V(he,te,!1))&&q.set(te.identifier.id,te)}),K?.forEach(te=>{const he=q.get(te.identifier.id);if(!he&&X&&te.type===0){this.y.debug(`Skipping obsolete system extension ${te.location.path}.`);return}(!he||V(he,te,!1))&&q.set(te.identifier.id,te)}),H?.forEach(te=>{const he=q.get(te.identifier.id);(!he||V(he,te,!0))&&q.set(te.identifier.id,te),q.set(te.identifier.id,te)}),[...q.values()]}async M(X,K){this.y.trace("Started scanning system extensions");const H=await this.P(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0),T=await(X&&!H.devMode?this.j:this.n).scanExtensions(H);return this.y.trace("Scanned system extensions:",T.length),T}async N(X,K){const H=this.z.isBuilt?[]:this.C.builtInExtensions;if(!H?.length)return[];this.y.trace("Started scanning dev system extensions");const L=K?await this.O():{},T=[],V=g.URI.file(v.$hc(v.$jc(y.$lg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const te of H){const he=L[te.name]||"marketplace";switch(he){case"disabled":break;case"marketplace":T.push((0,l.$Eg)(V,te.name));break;default:T.push(g.URI.file(he));break}}const q=await Promise.all(T.map(async te=>this.n.scanExtension(await this.P(te,!1,0,!0,X,!0,void 0))));return this.y.trace("Scanned dev system extensions:",q.length),(0,P.$Hb)(q)}async O(){try{const X=await this.w.readFile(this.r);return JSON.parse(X.value.toString())}catch{return{}}}async P(X,K,H,L,T,V,q){const te=await this.f(T??b.$w),he=await this.Q(X),G=K&&!this.D.extUri.isEqual(X,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,O=G?await this.Q(G):void 0;return new N(X,he,G,O,K,q,H,L,V,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,T,te)}async Q(X){try{const K=await this.w.stat(X);if(typeof K.mtime=="number")return K.mtime}catch{}}};e.$Op=F,e.$Op=F=Ee([ne(4,I.$Zk),ne(5,D.$Jp),ne(6,o.$nk),ne(7,i.$kj),ne(8,c.$0h),ne(9,n.$Cj),ne(10,k.$Xk),ne(11,r.$2h)],F);class N{constructor(X,K,H,L,T,V,q,te,he,G,O,U,x,z,Y){this.location=X,this.mtime=K,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=L,this.profile=T,this.profileScanOptions=V,this.type=q,this.excludeObsolete=te,this.validate=he,this.productVersion=G,this.productDate=O,this.productCommit=U,this.devMode=x,this.language=z,this.translations=Y}static createNlsConfiguration(X){return{language:X.language,pseudo:X.language==="pseudo",devMode:X.devMode,translations:X.translations}}static equals(X,K){return(0,l.$xg)(X.location,K.location)&&X.mtime===K.mtime&&(0,l.$xg)(X.applicationExtensionslocation,K.applicationExtensionslocation)&&X.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&X.profile===K.profile&&s.$nn(X.profileScanOptions,K.profileScanOptions)&&X.type===K.type&&X.excludeObsolete===K.excludeObsolete&&X.validate===K.validate&&X.productVersion===K.productVersion&&X.productDate===K.productDate&&X.productCommit===K.productCommit&&X.devMode===K.devMode&&X.language===K.language&&M.equals(X.translations,K.translations)}}e.$Pp=N;let Z=class extends h.$Sc{constructor(X,K,H,L,T){super(),this.f=X,this.g=K,this.h=H,this.j=L,this.m=T}async scanExtensions(X){const K=X.profile?await this.r(X):await this.n(X);let H={};if(X.excludeObsolete&&X.type===1)try{const L=(await this.j.readFile(this.f)).value.toString();H=JSON.parse(L)}catch{}return(0,$.$Sf)(H)?K:K.filter(L=>!H[S.$Po.create(L).toString()])}async n(X){const K=await this.j.resolve(X.location);if(!K.children?.length)return[];const H=await Promise.all(K.children.map(async L=>{if(!L.isDirectory||X.type===1&&(0,l.$Bg)(L.resource).indexOf(".")===0)return null;const T=new N(L.resource,X.mtime,X.applicationExtensionslocation,X.applicationExtensionslocationMtime,X.profile,X.profileScanOptions,X.type,X.excludeObsolete,X.validate,X.productVersion,X.productDate,X.productCommit,X.devMode,X.language,X.translations);return this.scanExtension(T)}));return(0,P.$Hb)(H).sort((L,T)=>L.location.path<T.location.path?-1:1)}async r(X){let K=await this.s(X.location,()=>!0,X);if(X.applicationExtensionslocation&&!this.h.extUri.isEqual(X.location,X.applicationExtensionslocation)){K=K.filter(L=>!L.metadata?.isApplicationScoped);const H=await this.s(X.applicationExtensionslocation,L=>!!L.metadata?.isBuiltin||!!L.metadata?.isApplicationScoped,X);K.push(...H)}return K}async s(X,K,H){const L=await this.g.scanProfileExtensions(X,H.profileScanOptions);if(!L.length)return[];const T=await Promise.all(L.map(async V=>{if(K(V)){const q=new N(V.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(q,V.metadata)}return null}));return(0,P.$Hb)(T)}async scanOneOrMultipleExtensions(X){try{if(await this.j.exists((0,l.$Eg)(X.location,"package.json"))){const K=await this.scanExtension(X);return K?[K]:[]}else return await this.scanExtensions(X)}catch(K){return this.m.error(`Error scanning extensions at ${X.location.path}:`,(0,A.$0)(K)),[]}}async scanExtension(X,K){try{let H=await this.scanExtensionManifest(X.location);if(H){H.publisher||(H.publisher=d.$em),K=K??H.__metadata,delete H.__metadata;const L=(0,S.$To)(H.publisher,H.name),T=K?.id?{id:L,uuid:K.id}:{id:L},V=K?.isSystem?0:X.type,q=V===0||!!K?.isBuiltin;H=await this.t(X.location,H,N.createNlsConfiguration(X));const te={type:V,identifier:T,manifest:H,location:X.location,isBuiltin:q,targetPlatform:K?.targetPlatform??"undefined",metadata:K,isValid:!0,validations:[]};return X.validate?this.validate(te,X):te}}catch(H){X.type!==0&&this.m.error(H)}return null}validate(X,K){let H=!0;const L=(0,t.$5o)(K.productVersion,K.productDate,K.location,X.manifest,X.isBuiltin);for(const[T,V]of L)T===w.default.Error&&(H=!1,this.m.error(this.z(K.location,V)));return X.isValid=H,X.validations=L,X}async scanExtensionManifest(X){const K=(0,l.$Eg)(X,"package.json");let H;try{H=(await this.j.readFile(K)).value.toString()}catch(T){return(0,o.$Ek)(T)!==1&&this.m.error(this.z(X,(0,u.localize)(0,null,K.path,T.message))),null}let L;try{L=JSON.parse(H)}catch{const V=[];(0,E.$_m)(H,V);for(const q of V)this.m.error(this.z(X,(0,u.localize)(1,null,K.path,q.offset,q.length,(0,f.$Lp)(q.error))));return null}return(0,E.$in)(L)!=="object"?(this.m.error(this.z(X,(0,u.localize)(2,null,K.path))),null):L}async t(X,K,H){const L=await this.u(X,K,H);if(L)try{const T=[],V=await this.w(L.default,T);if(T.length>0)return T.forEach(te=>{this.m.error(this.z(X,(0,u.localize)(3,null,L.default?.path,(0,f.$Lp)(te.error))))}),K;if((0,E.$in)(L)!=="object")return this.m.error(this.z(X,(0,u.localize)(4,null,L.default?.path))),K;const q=L.values||Object.create(null);return(0,C.$Mp)(this.m,K,q,V)}catch{}return K}async u(X,K,H){const L=(0,l.$Eg)(X,"package.nls.json"),T=(he,G)=>{G.forEach(O=>{this.m.error(this.z(X,(0,u.localize)(5,null,he?.path,(0,f.$Lp)(O.error))))})},V=he=>{this.m.error(this.z(X,(0,u.localize)(6,null,he?.path)))},q=`${K.publisher}.${K.name}`,te=H.translations[q];if(te)try{const he=g.URI.file(te),G=(await this.j.readFile(he)).value.toString(),O=[],U=(0,E.$_m)(G,O);return O.length>0?(T(he,O),{values:void 0,default:L}):(0,E.$in)(U)!=="object"?(V(he),{values:void 0,default:L}):{values:U.contents?U.contents.package:void 0,default:L}}catch{return{values:void 0,default:L}}else{if(!await this.j.exists(L))return;let G;try{G=await this.y(X,H)}catch{return}if(!G.localized)return{values:void 0,default:G.original};try{const O=(await this.j.readFile(G.localized)).value.toString(),U=[],x=(0,E.$_m)(O,U);return U.length>0?(T(G.localized,U),{values:void 0,default:G.original}):(0,E.$in)(x)!=="object"?(V(G.localized),{values:void 0,default:G.original}):{values:x,default:G.original}}catch{return{values:void 0,default:G.original}}}}async w(X,K){if(X)try{const H=(await this.j.readFile(X)).value.toString();return(0,E.$_m)(H,K)}catch{}}y(X,K){return new Promise((H,L)=>{const T=V=>{const q=(0,l.$Eg)(X,`package.nls.${V}.json`);this.j.exists(q).then(te=>{te&&H({localized:q,original:(0,l.$Eg)(X,"package.nls.json")});const he=V.lastIndexOf("-");he===-1?H({localized:(0,l.$Eg)(X,"package.nls.json"),original:null}):(V=V.substring(0,he),T(V))})};if(K.devMode||K.pseudo||!K.language)return H({localized:(0,l.$Eg)(X,"package.nls.json"),original:null});T(K.language)})}z(X,K){return`[${X.path}]: ${K}`}};Z=Ee([ne(1,D.$Jp),ne(2,k.$Xk),ne(3,o.$nk),ne(4,i.$kj)],Z);let Q=class extends Z{constructor(X,K,H,L,T,V,q){super(K,L,T,V,q),this.G=X,this.H=H,this.D=this.B(new R.$1g(3e3)),this.F=this.B(new a.$Sd),this.onDidChangeCache=this.F.event}async scanExtensions(X){const K=this.M(X),H=await this.I(K);if(this.C=X,H&&H.input&&N.equals(H.input,this.C))return this.m.debug("Using cached extensions scan result",X.location.toString()),this.D.trigger(()=>this.L()),H.result.map(T=>(T.location=g.URI.revive(T.location),T));const L=await super.scanExtensions(X);return await this.J(K,{input:X,result:L}),L}async I(X){try{const K=await this.j.readFile(X),H=JSON.parse(K.value.toString());return{result:H.result,input:(0,m.$zh)(H.input)}}catch(K){this.m.debug("Error while reading the extension cache file:",X.path,(0,A.$0)(K))}return null}async J(X,K){try{await this.j.writeFile(X,j.$ge.fromString(JSON.stringify(K)))}catch(H){this.m.debug("Error while writing the extension cache file:",X.path,(0,A.$0)(H))}}async L(){if(!this.C)return;const X=this.M(this.C),K=await this.I(X);if(!K)return;const H=K.result,L=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$nn(L,H))try{this.m.info("Invalidating Cache",H,L),await this.j.del(X),this.F.fire()}catch(T){this.m.error(T)}}M(X){const K=this.N(X);return this.h.extUri.joinPath(K.cacheHome,X.type===0?d.$dm:d.$cm)}N(X){return X.type===0?this.H.defaultProfile:X.profile?this.h.extUri.isEqual(X.location,this.G.extensionsResource)?this.G:this.H.profiles.find(K=>this.h.extUri.isEqual(X.location,K.extensionsResource))??this.G:this.H.defaultProfile}};Q=Ee([ne(2,I.$Zk),ne(3,D.$Jp),ne(4,k.$Xk),ne(5,o.$nk),ne(6,i.$kj)],Q);function le(ue,X){const K=(0,S.$Ro)(ue.manifest.publisher,ue.manifest.name);return{id:K,identifier:new d.$im(K),isBuiltin:ue.type===0,isUserBuiltin:ue.type===1&&ue.isBuiltin,isUnderDevelopment:X,extensionLocation:ue.location,uuid:ue.identifier.uuid,targetPlatform:ue.targetPlatform,...ue.manifest}}e.$Qp=le;class ce extends F{constructor(X,K,H,L,T,V,q,te,he,G,O,U){super(X,K,(0,l.$Eg)(H,".vscode-oss-dev","extensions","control.json"),L,T,V,q,te,he,G,O,U),this.R=(async()=>{if(b.$z)try{const x=await this.w.readFile(g.URI.file(b.$z));return JSON.parse(x.value.toString())}catch{}return Object.create(null)})()}f(X){return this.R}}e.$Rp=ce}),define(re[276],oe([0,1,5,41,40,28,81,16,37,7]),function(J,e,P,R,s,j,A,E,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eO=void 0;let y=class extends A.$Kp{constructor(b,l,p,w,$,g){super(h.URI.file(b.extensionsPath),l,p,w,$,g)}};e.$eO=y,e.$eO=y=Ee([ne(0,f.$$h),ne(1,E.$nk),ne(2,R.$Zk),ne(3,s.$Xk),ne(4,j.$rl),ne(5,P.$kj)],y)}),define(re[277],oe([0,1,7,37,81,129,16,6,5,27,40,41]),function(J,e,P,R,s,j,A,E,f,h,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y0b=void 0;let b=class extends j.$Rp{constructor(p,w,$,g,u,c,S,d){super(P.URI.file(u.builtinExtensionsPath),P.URI.file(u.extensionsPath),u.userHome,p.defaultProfile,p,w,$,g,u,c,S,d)}};e.$Y0b=b,e.$Y0b=b=Ee([ne(0,v.$Zk),ne(1,s.$Jp),ne(2,A.$nk),ne(3,f.$kj),ne(4,R.$$h),ne(5,h.$Cj),ne(6,y.$Xk),ne(7,E.$2h)],b)}),define(re[278],oe([0,1,15,2,13,9,4,57,7,32,36,37,5,41]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e$b=void 0;let p=class extends R.$Sc{constructor($,g,u){super(),this.c=$,this.f=u,this.a=E.$9h.forPaths(!A.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot($.appRoot),this.addValidFileRoot($.extensionsPath),this.addValidFileRoot(g.defaultProfile.globalStorageHome.with({scheme:s.Schemas.file}).fsPath),this.addValidFileRoot($.workspaceStorageHome.with({scheme:s.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:$}=P.session;$.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,(g,u)=>this.j(g,u)),$.protocol.interceptFileProtocol(s.Schemas.file,(g,u)=>this.h(g,u)),this.B((0,R.$Qc)(()=>{$.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),$.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot($){const g=(0,j.$hc)($);return this.a.get(g)?R.$Sc.None:(this.a.set(g,!0),(0,R.$Qc)(()=>this.a.delete(g)))}h($,g){const u=f.URI.parse($.url);return this.f.error(`Refused to load resource ${u.fsPath} from ${s.Schemas.file}: protocol (original URL: ${$.url})`),g({error:-3})}j($,g){const u=this.m($);let c;return this.c.crossOriginIsolated&&((0,j.$nc)(u)==="workbench.html"||(0,j.$nc)(u)==="workbench-dev.html"?c=s.COI.CoopAndCoep:c=s.COI.getHeadersFromQuery($.url)),this.a.findSubstr(u)?g({path:u,headers:c}):this.b.has((0,j.$oc)(u).toLowerCase())?g({path:u}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${u} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${$.url})`),g({error:-3}))}m($){const g=f.URI.parse($.url),u=s.$lg.uriToFileUri(g);return(0,j.$hc)(u.fsPath)}createIPCObjectUrl(){let $;const g=f.URI.from({scheme:"vscode",path:(0,h.$ng)()}),u=g.toString(),c=async()=>$;return y.$jU.handle(u,c),this.f.trace(`IPC Object URL: Registered new channel ${u}.`),{resource:g,update:S=>$=S,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${u}.`),y.$jU.removeHandler(u)}}}};e.$e$b=p,e.$e$b=p=Ee([ne(0,v.$$h),ne(1,l.$Zk),ne(2,b.$kj)],p)}),define(re[96],oe([0,1,8,3,2,68,12,111,6,41]),function(J,e,P,R,s,j,A,E,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$ip=e.$hp=e.$gp=void 0,e.$gp="__$__isNewStorageMarker",e.$hp="__$__targetStorageMarker",e.$ip=(0,f.$3h)("storageService");var y;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(y||(e.WillSaveStateReason=y={}));var v;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var b;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(b||(e.StorageTarget=b={}));function l(u){const c=u.get(e.$hp);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}e.$jp=l;class p extends s.$Sc{static{this.a=60*1e3}constructor(c={flushInterval:p.a}){super(),this.m=c,this.b=this.B(new R.$Vd),this.c=this.B(new R.$Vd),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$Sd),this.onWillSaveState=this.f.event,this.h=this.B(new P.$ch(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(c,S,d){return R.Event.filter(this.b.event,t=>t.scope===c&&(S===void 0||t.key===S),d)}n(){this.j.value=(0,P.$gh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,j.mark)("code/willInitStorage");try{await this.O()}finally{(0,j.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(c,S){const{key:d,external:t}=S;if(d===e.$hp){switch(c){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:c})}else this.b.fire({scope:c,key:d,target:this.J(c)[d],external:t})}w(c){this.f.fire({reason:c})}get(c,S,d){return this.P(S)?.get(c,d)}getBoolean(c,S,d){return this.P(S)?.getBoolean(c,d)}getNumber(c,S,d){return this.P(S)?.getNumber(c,d)}getObject(c,S,d){return this.P(S)?.getObject(c,d)}storeAll(c,S){this.y(()=>{for(const d of c)this.store(d.key,d.value,d.scope,d.target,S)})}store(c,S,d,t,o=!1){if((0,A.$Of)(S)){this.remove(c,d,o);return}this.y(()=>{this.z(c,d,t),this.P(d)?.set(c,S,o)})}remove(c,S,d=!1){this.y(()=>{this.z(c,S,void 0),this.P(S)?.delete(c,d)})}y(c){this.b.pause(),this.c.pause();try{c()}finally{this.b.resume(),this.c.resume()}}keys(c,S){const d=[],t=this.J(c);for(const o of Object.keys(t))t[o]===S&&d.push(o);return d}z(c,S,d,t=!1){const o=this.J(S);typeof d=="number"?o[c]!==d&&(o[c]=d,this.P(S)?.set(e.$hp,JSON.stringify(o),t)):typeof o[c]=="number"&&(delete o[c],this.P(S)?.set(e.$hp,JSON.stringify(o),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(c){switch(c){case-1:return this.I;case 0:return this.G;default:return this.D}}L(c){const S=this.P(c);return S?l(S):Object.create(null)}isNew(c){return this.getBoolean(e.$gp,c)===!0}async flush(c=y.NONE){this.f.fire({reason:c});const S=this.P(-1),d=this.P(0),t=this.P(1);switch(c){case y.NONE:await P.Promises.settled([S?.whenFlushed()??Promise.resolve(),d?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await P.Promises.settled([S?.flush(0)??Promise.resolve(),d?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const c=this.P(-1)?.items??new Map,S=this.P(0)?.items??new Map,d=this.P(1)?.items??new Map;return g(c,S,d,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(c){return await this.flush(),this.P(c)?.optimize()}async switch(c,S){return this.w(y.NONE),(0,h.$Yk)(c)?this.R(c,S):this.S(c,S)}M(c,S){return!(c.id===S.id||w(S)&&w(c))}N(c,S,d){this.y(()=>{const t=new Set;for(const[o,r]of c)t.add(o),S.get(o)!==r&&this.u(d,{key:o,external:!0});for(const[o]of S.items)t.has(o)||this.u(d,{key:o,external:!0})})}}e.$kp=p;function w(u){return u.isDefault||!!u.useDefaultFlags?.globalState}e.$lp=w;class $ extends p{constructor(){super(),this.U=this.B(new E.$ep(new E.$fp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new E.$ep(new E.$fp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new E.$ep(new E.$fp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(c=>this.u(1,c))),this.B(this.W.onDidChangeStorage(c=>this.u(0,c))),this.B(this.U.onDidChangeStorage(c=>this.u(-1,c)))}P(c){switch(c){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(c){switch(c){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(c){return!1}}e.$mp=$;async function g(u,c,S,d,t,o){const r=M=>{try{return JSON.parse(M)}catch{return M}},i=new Map,n=new Map;u.forEach((M,F)=>{i.set(F,M),n.set(F,r(M))});const a=new Map,m=new Map;c.forEach((M,F)=>{a.set(F,M),m.set(F,r(M))});const D=new Map,I=new Map;S.forEach((M,F)=>{D.set(F,M),I.set(F,r(M))}),console.group(d!==t?`Storage: Application (path: ${d})`:`Storage: Application & Profile (path: ${d}, default profile)`);const k=[];if(i.forEach((M,F)=>{k.push({key:F,value:M})}),console.table(k),console.groupEnd(),console.log(n),d!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const M=[];a.forEach((F,N)=>{M.push({key:N,value:F})}),console.table(M),console.groupEnd(),console.log(m)}console.group(`Storage: Workspace (path: ${o})`);const C=[];D.forEach((M,F)=>{C.push({key:F,value:M})}),console.table(C),console.groupEnd(),console.log(I)}e.$np=g}),define(re[279],oe([0,1,23,8,3,2,9,73,7,21,111,161,5,96,28,30,13]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l9b=e.$k9b=e.$j9b=e.$i9b=void 0;class g extends j.$Sc{static{this.a=2e3}get storage(){return this.f}constructor(r,i){super(),this.m=r,this.n=i,this.b=this.B(new s.$Sd),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$Sd),this.onDidCloseStorage=this.c.event,this.f=this.B(new y.$ep(new y.$fp,{hint:y.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new R.$nh,this.whenInit=this.h.p,this.j=y.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===y.StorageState.None)try{const r=this.B(await this.t());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(n=>this.b.fire(n))),await this.s(r);const i=r.getBoolean(l.$gp);i===void 0?r.set(l.$gp,!0):i&&r.set(l.$gp,!1)}catch(r){this.m.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.j=y.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===b.LogLevel.Trace?r=>this.m.trace(r):void 0,logError:r=>this.m.error(r)}}s(r){return r.init()}get items(){return this.f.items}get(r,i){return this.f.get(r,i)}set(r,i){return this.f.set(r,i)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new E.$Od(!1);await this.w(),r.stop(),r.elapsed()>g.a&&await this.u(r),this.c.fire()}async u(r){if(this.path)try{const i=(0,P.top)(Array.from(this.f.items.entries()).map(([a,m])=>({key:a,length:m.length})),(a,m)=>m.length-a.length,5).map(a=>`${a.key}:${a.length}`).join(", "),n=(await this.n.stat(f.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async w(){this.g&&await this.g,this.j=y.StorageState.Closed,await this.f.close()}}class u extends g{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,A.$jc)(this.z.globalStorageHome.with({scheme:$.Schemas.file}).fsPath,u.y)}constructor(r,i,n,a){super(n,a),this.z=r,this.C=i}async t(){return new y.$ep(new v.$OU(this.path??v.$OU.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:y.StorageHint.STORAGE_IN_MEMORY})}}class c extends u{constructor(r,i,n,a){super(r,i,n,a)}}e.$i9b=c;class S extends u{constructor(r,i,n,a){super(i.defaultProfile,r,n,a)}async s(r){await super.s(r),this.G(r)}G(r){r.get(p.$ul,void 0)===void 0&&r.set(p.$ul,new Date().toUTCString());const n=r.get(p.$tl,void 0),a=new Date().toUTCString();r.set(p.$vl,typeof n>"u"?null:n),r.set(p.$tl,a)}}e.$j9b=S;class d extends g{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,A.$jc)(this.F.workspaceStorageHome.with({scheme:$.Schemas.file}).fsPath,this.C.id,d.y)}constructor(r,i,n,a,m){super(n,m),this.C=r,this.D=i,this.F=a}async t(){const{storageFilePath:r,wasCreated:i}=await this.H();return new y.$ep(new v.$OU(r,{logging:this.r()}),{hint:this.D.useInMemoryStorage?y.StorageHint.STORAGE_IN_MEMORY:i?y.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:v.$OU.IN_MEMORY_PATH,wasCreated:!0};const r=(0,A.$jc)(this.F.workspaceStorageHome.with({scheme:$.Schemas.file}).fsPath,this.C.id),i=(0,A.$jc)(r,d.y);return await h.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await h.Promises.mkdir(r,{recursive:!0}),this.I(r),{storageFilePath:i,wasCreated:!0})}async I(r){let i;if((0,w.$ai)(this.C)?i={folder:this.C.uri.toString()}:(0,w.$fi)(this.C)&&(i={workspace:this.C.configPath.toString()}),i)try{const n=(0,A.$jc)(r,d.z);await h.Promises.exists(n)||await h.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$k9b=d;class t extends g{get path(){}async t(){return new y.$ep(new y.$fp,{hint:y.StorageHint.STORAGE_IN_MEMORY})}}e.$l9b=t}),define(re[280],oe([0,1,3,2,96]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$10b=void 0;class j extends R.$Sc{constructor(E,f,h){super(),this.b=E,this.c=f,this.f=h;const y=this.B(new R.$Tc);this.a=this.B(new P.$Sd({onWillAddFirstListener:()=>y.value=this.g(),onDidRemoveLastListener:()=>y.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const E=new R.$Rc;return E.add(P.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(f,h)=>(f?f.push(h.key):f=[h.key],f),100)(f=>this.h(f))),E.add(P.Event.debounce(this.b.onDidChangeProfileStorage,(f,h)=>{f||(f=new Map);let y=f.get(h.profile.id);return y||f.set(h.profile.id,y={profile:h.profile,keys:[],storage:h.storage}),y.keys.push(h.key),f},100)(f=>this.j(f))),E}h(E){const f=E.includes(s.$hp)?[this.c.defaultProfile]:[],h=[];if(E=E.filter(y=>y!==s.$hp),E.length){const y=(0,s.$jp)(this.b.applicationStorage.storage);h.push({profile:this.c.defaultProfile,changes:E.map(v=>({key:v,scope:0,target:y[v]}))})}this.m(f,h)}j(E){const f=[],h=new Map;for(const[y,v]of E.entries()){v.keys.includes(s.$hp)&&f.push(v.profile);const b=v.keys.filter(l=>l!==s.$hp);if(b.length){const l=(0,s.$jp)(v.storage.storage);h.set(y,{profile:v.profile,changes:b.map(p=>({key:p,scope:0,target:l[p]}))})}}this.m(f,[...h.values()])}m(E,f){(E.length||f.length)&&this.a.fire({valueChanges:f,targetChanges:E})}listen(E,f,h){switch(f){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${f}`)}async call(E,f){throw new Error(`Call not found: ${f}`)}}e.$10b=j}),define(re[281],oe([0,1,7,37,16,5,34,40,41,12,121]),function(J,e,P,R,s,j,A,E,f,h,y){"use strict";var v,b;Object.defineProperty(e,"__esModule",{value:!0}),e.$dO=e.$cO=e.$bO=void 0;let l=class extends f.$3k{static{v=this}static{this.a="profileAssociationsMigration"}constructor(g,u,c,S,d){super(c,S,u,d),this.U=g,this.W=c}O(){return this.U.getItem(v.b,[]).map(u=>({...u,location:(0,h.$Ff)(u.location)?this.w.extUri.joinPath(this.profilesHome,u.location):P.URI.revive(u.location)}))}Q(){const g=this.U.getItem(v.c,{});return this.U.getItem(v.a,!1)?g:this.N(g)}S(){return this.w.extUri.joinPath(P.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$bO=l,e.$bO=l=v=Ee([ne(0,A.$9N),ne(1,E.$Xk),ne(2,R.$$h),ne(3,s.$nk),ne(4,j.$kj)],l);let p=b=class extends l{constructor(g,u,c,S,d){super(g,u,c,S,d),this.$=g}P(g){g.length?this.$.setItem(b.b,g.map(u=>({...u,location:this.w.extUri.basename(u.location)}))):this.$.removeItem(b.b)}O(){const g=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(g),this.$.setItem("userDataProfilesMigration",!0)),g}R(g){g.emptyWindows||g.workspaces?this.$.setItem(b.c,g):this.$.removeItem(b.c)}Q(){const g="workspaceAndProfileInfo",u=this.$.getItem(g,void 0);if(u){this.$.removeItem(g);const S=u.reduce((d,{workspace:t,profile:o})=>(d[P.URI.revive(t).toString()]=P.URI.revive(o).toString(),d),{});this.$.setItem(b.c,{workspaces:S})}const c=super.Q();return this.$.getItem(b.a,!1)||(this.R(c),this.$.setItem(b.a,!0)),c}};e.$cO=p,e.$cO=p=b=Ee([ne(0,A.$0N),ne(1,E.$Xk),ne(2,R.$$h),ne(3,s.$nk),ne(4,j.$kj)],p);let w=class extends p{constructor(g,u,c,S){super(new y.$aO(0,u,S,c),g,u,c,S)}async init(){return await this.$.init(),super.init()}};e.$dO=w,e.$dO=w=Ee([ne(0,E.$Xk),ne(1,R.$$h),ne(2,s.$nk),ne(3,j.$kj)],w)}),define(re[55],oe([0,1,37,16,6,5,40,41,281,34]),function(J,e,P,R,s,j,A,E,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n9b=e.$m9b=void 0,e.$m9b=(0,s.$4h)(E.$Zk);let y=class extends f.$cO{constructor(b,l,p,w,$){super(b,l,p,w,$)}getAssociatedEmptyWindows(){const b=[];for(const l of this.C.emptyWindows.keys())b.push({id:l});return b}};e.$n9b=y,e.$n9b=y=Ee([ne(0,h.$0N),ne(1,A.$Xk),ne(2,P.$$h),ne(3,R.$nk),ne(4,j.$kj)],y)}),define(re[130],oe([0,1,19,7,30]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D9b=e.$C9b=e.$B9b=void 0;async function j(f,h,y){for(const b of f){const l=b.openedWorkspace;if((0,s.$fi)(l)){const p=await y(l);if(p){if(p.folders.some(w=>P.$vg.isEqualOrParent(h,w.uri)))return b}else if(P.$vg.isEqualOrParent(h,l.configPath))return b}}const v=f.filter(b=>(0,s.$ai)(b.openedWorkspace)&&P.$vg.isEqualOrParent(h,b.openedWorkspace.uri));if(v.length)return v.sort((b,l)=>-(b.openedWorkspace.uri.path.length-l.openedWorkspace.uri.path.length))[0]}e.$B9b=j;function A(f,h){for(const y of f)if((0,s.$fi)(y.openedWorkspace)&&P.$vg.isEqual(y.openedWorkspace.configPath,h)||(0,s.$ai)(y.openedWorkspace)&&P.$vg.isEqual(y.openedWorkspace.uri,h))return y}e.$C9b=A;function E(f,h){const y=v=>h.some(b=>P.$vg.isEqual(R.URI.file(b),R.URI.file(v)));for(const v of f)if(v.config?.extensionDevelopmentPath?.some(b=>y(b)))return v}e.$D9b=E}),define(re[97],oe([0,1,33,44,139,47,13,9,4,19,7,6,59,30]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcb=e.$ocb=e.$ncb=e.$mcb=e.$lcb=e.$kcb=e.$jcb=e.$icb=e.$hcb=e.$gcb=void 0,e.$gcb=(0,v.$3h)("workspacesService");function p(I){return I.hasOwnProperty("workspace")}e.$hcb=p;function w(I){return I.hasOwnProperty("folderUri")}e.$icb=w;function $(I){return I.hasOwnProperty("fileUri")}e.$jcb=$;function g(I){return u(I)||c(I)}e.$kcb=g;function u(I){const k=I;return typeof k?.path=="string"&&(!k.name||typeof k.name=="string")}function c(I){const k=I;return typeof k?.uri=="string"&&(!k.name||typeof k.name=="string")}function S(I,k,C,M,F){if(I.scheme!==M.scheme)return{name:C,uri:I.toString(!0)};let N=k?void 0:F.relativePath(M,I);if(N!==void 0)N.length===0?N=".":f.$i&&(N=d(N));else if(I.scheme===A.Schemas.file)N=I.fsPath,f.$i&&(N=d(N));else if(F.isEqualAuthority(I.authority,M.authority))N=I.path;else return{name:C,uri:I.toString(!0)};return{name:C,path:N}}e.$lcb=S;function d(I){return I=(0,j.$Jv)(I),(0,P.$2f)(I)||(I=(0,P.$Yf)(I)),I}function t(I,k,C){const M=[],F=new Set,N=C.dirname(k);for(const Z of I){let Q;if(u(Z))Z.path&&(Q=C.resolvePath(N,Z.path));else if(c(Z))try{Q=y.URI.parse(Z.uri),Q.path[0]!==E.$gc.sep&&(Q=Q.with({path:E.$gc.sep+Q.path}))}catch(le){console.warn(le)}if(Q){const le=C.getComparisonKey(Q);if(!F.has(le)){F.add(le);const ce=Z.name||C.basenameOrAuthority(Q);M.push(new l.$ki({uri:Q,name:ce,index:M.length},Z))}}}return M}e.$mcb=t;function o(I,k,C,M,F){const N=r(k,I),Z=F.dirname(k),Q=F.dirname(M),le=[];for(const K of N.folders){const H=u(K)?F.resolvePath(Z,K.path):y.URI.parse(K.uri);let L;C?L=!1:L=!u(K)||(0,E.$ic)(K.path),le.push(S(H,L,K.name,Q,F))}const ce={insertSpaces:!1,tabSize:4,eol:f.$k||f.$j?`
`:`\r
`},ue=s.$YT(I,["folders"],le,ce);let X=s.$2T(I,ue);return(0,h.$Jg)(N.remoteAuthority,(0,b.$0k)(M))&&(X=s.$2T(X,s.$XT(X,["remoteAuthority"],ce))),X}e.$ncb=o;function r(I,k){const C=R.$_m(k);if(C&&Array.isArray(C.folders))C.folders=C.folders.filter(M=>g(M));else throw new Error(`${I} looks like an invalid workspace file.`);return C}function i(I){return I.workspace&&typeof I.workspace=="object"&&typeof I.workspace.id=="string"&&typeof I.workspace.configPath=="string"}function n(I){return typeof I.folderUri=="string"}function a(I){return typeof I.fileUri=="string"}function m(I,k){const C={workspaces:[],files:[]};if(I){const M=function(N,Z){for(let Q=0;Q<N.length;Q++)try{Z(N[Q],Q)}catch(le){k.warn(`Error restoring recent entry ${JSON.stringify(N[Q])}: ${le.toString()}. Skip entry.`)}},F=I;Array.isArray(F.entries)&&M(F.entries,N=>{const Z=N.label,Q=N.remoteAuthority;i(N)?C.workspaces.push({label:Z,remoteAuthority:Q,workspace:{id:N.workspace.id,configPath:y.URI.parse(N.workspace.configPath)}}):n(N)?C.workspaces.push({label:Z,remoteAuthority:Q,folderUri:y.URI.parse(N.folderUri)}):a(N)&&C.files.push({label:Z,remoteAuthority:Q,fileUri:y.URI.parse(N.fileUri)})})}return C}e.$ocb=m;function D(I){const k={entries:[]};for(const C of I.workspaces)w(C)?k.entries.push({folderUri:C.folderUri.toString(),label:C.label,remoteAuthority:C.remoteAuthority}):k.entries.push({workspace:{id:C.workspace.id,configPath:C.workspace.configPath.toString()},label:C.label,remoteAuthority:C.remoteAuthority});for(const C of I.files)k.entries.push({fileUri:C.fileUri.toString(),label:C.label,remoteAuthority:C.remoteAuthority});return k}e.$pcb=D}),define(re[98],oe([0,1,86,13,4,19]),function(J,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H9b=e.$G9b=e.$F9b=e.$E9b=void 0,e.$E9b=128/4;function A(h){function y(){let v=h.scheme===R.Schemas.file?(0,j.$sg)(h):h.toString();return s.$k||(v=v.toLowerCase()),(0,P.createHash)("md5").update(v).digest("hex")}return{id:y(),configPath:h}}e.$F9b=A;function E(h,y){function v(){if(h.scheme!==R.Schemas.file)return(0,P.createHash)("md5").update(h.toString()).digest("hex");if(!y)return;let l;return s.$k?l=y.ino:s.$j?l=y.birthtime.getTime():s.$i&&(typeof y.birthtimeMs=="number"?l=Math.floor(y.birthtimeMs):l=y.birthtime.getTime()),(0,P.createHash)("md5").update(h.fsPath).update(l?String(l):"").digest("hex")}const b=v();if(typeof b=="string")return{id:b,uri:h}}e.$G9b=E;function f(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$H9b=f}),define(re[99],oe([0,1,86,87,26,282,18,14,3,2,9,4,32,42,109]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=void 0;class w{traceSocketEvent(k,C){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,k,C)}constructor(k,C=""){this.f=!0,this.debugLabel=C,this.socket=k,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,E.$1)(M)}},this.socket.on("error",this.a),this.b=M=>{this.traceSocketEvent("close",{hadError:M}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(k){const C=M=>{this.traceSocketEvent("read",M),k(A.$ge.wrap(M))};return this.socket.on("data",C),{dispose:()=>this.socket.off("data",C)}}onClose(k){const C=M=>{k({type:0,hadError:M,error:void 0})};return this.socket.on("close",C),{dispose:()=>this.socket.off("close",C)}}onEnd(k){const C=()=>{k()};return this.socket.on("end",C),{dispose:()=>this.socket.off("end",C)}}write(k){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",k),this.socket.write(k.buffer,C=>{if(C){if(C.code==="EPIPE")return;(0,E.$1)(C)}})}catch(C){if(C.code==="EPIPE")return;(0,E.$1)(C)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((k,C)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),k();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),k()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$Rh=w;var $;(function(I){I[I.MinHeaderByteSize=2]="MinHeaderByteSize",I[I.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})($||($={}));var g;(function(I){I[I.PeekHeader=1]="PeekHeader",I[I.ReadHeader=2]="ReadHeader",I[I.ReadBody=3]="ReadBody",I[I.Fin=4]="Fin"})(g||(g={}));class u extends h.$Sc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(k,C){this.socket.traceSocketEvent(k,C)}constructor(k,C,M,F){super(),this.f=this.B(new f.$Sd),this.g=this.B(new f.$Sd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=k,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:C,inflateBytesLength:M?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new c(this,C,M,F,this.f,(N,Z)=>this.m(N,Z))),this.B(this.a.onError(N=>{console.error(N),(0,E.$1)(N),this.g.fire({type:0,hadError:!0,error:N})})),this.b=new p.$Mh,this.B(this.socket.onData(N=>this.n(N))),this.B(this.socket.onClose(async N=>{this.a.isProcessingReadQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(N)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this.f.event(k)}onClose(k){return this.g.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){let C=0;for(;C<k.byteLength;)this.a.writeMessage(k.slice(C,Math.min(C+262144,k.byteLength)),{compressed:!0,opcode:2}),C+=262144}m(k,{compressed:C,opcode:M}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",k);let F=2;k.byteLength<126?F+=0:k.byteLength<2**16?F+=2:F+=8;const N=A.$ge.alloc(F),Z=C?64:0,Q=M&15;if(N.writeUInt8(128|Z|Q,0),k.byteLength<126)N.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){N.writeUInt8(126,1);let le=1;N.writeUInt8(k.byteLength>>>8&255,++le),N.writeUInt8(k.byteLength>>>0&255,++le)}else{N.writeUInt8(127,1);let le=1;N.writeUInt8(0,++le),N.writeUInt8(0,++le),N.writeUInt8(0,++le),N.writeUInt8(0,++le),N.writeUInt8(k.byteLength>>>24&255,++le),N.writeUInt8(k.byteLength>>>16&255,++le),N.writeUInt8(k.byteLength>>>8&255,++le),N.writeUInt8(k.byteLength>>>0&255,++le)}this.socket.write(A.$ge.concat([N,k]))}end(){this.h=!0,this.socket.end()}n(k){if(k.byteLength!==0){for(this.b.acceptChunk(k);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const C=this.b.peek(this.j.readLen),M=C.readUInt8(0),F=(M&128)>>>7,N=(M&64)>>>6,Z=M&15,Q=C.readUInt8(1),le=(Q&128)>>>7,ce=Q&127;this.j.state=2,this.j.readLen=2+(le?4:0)+(ce===126?2:0)+(ce===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!N),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.j.opcode=Z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const C=this.b.read(this.j.readLen),M=C.readUInt8(1),F=(M&128)>>>7;let N=M&127,Z=1;N===126?N=C.readUInt8(++Z)*2**8+C.readUInt8(++Z):N===127&&(N=C.readUInt8(++Z)*0+C.readUInt8(++Z)*0+C.readUInt8(++Z)*0+C.readUInt8(++Z)*0+C.readUInt8(++Z)*2**24+C.readUInt8(++Z)*2**16+C.readUInt8(++Z)*2**8+C.readUInt8(++Z));let Q=0;F&&(Q=C.readUInt8(++Z)*2**24+C.readUInt8(++Z)*2**16+C.readUInt8(++Z)*2**8+C.readUInt8(++Z)),this.j.state=3,this.j.readLen=N,this.j.mask=Q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const C=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",C),t(C,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",C),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(C,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(C,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Sh=u;class c extends h.$Sc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$ge.alloc(0)}constructor(k,C,M,F,N,Z){super(),this.n=k,this.r=N,this.s=Z,this.a=this.B(new f.$Sd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new f.$Sd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new f.$Sd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,C?(this.b=this.B(new S(this.n,F,M,{windowBits:15})),this.f=this.B(new d(this.n,{windowBits:15})),this.B(this.b.onError(Q=>this.a.fire(Q))),this.B(this.f.onError(Q=>this.a.fire(Q)))):(this.b=null,this.f=null)}writeMessage(k,C){this.g.push({data:k,options:C}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:k,options:C}=this.g.shift();if(this.f&&C.compressed){const M=await this.w(this.f,k);this.s(M,C)}else this.s(k,{...C,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(k,C){return new Promise((M,F)=>{k.write(C),k.flush(N=>M(N))})}acceptFrame(k,C,M){this.h.push({data:k,isCompressed:C,isLastFrameOfMessage:M}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const k=this.h.shift();if(this.b&&k.isCompressed){const C=await this.C(this.b,k.data,k.isLastFrameOfMessage);this.r.fire(C)}else this.r.fire(k.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(k,C,M){return new Promise((F,N)=>{k.write(C),M&&k.write(A.$ge.fromByteArray([0,0,255,255])),k.flush(Z=>F(Z))})}}class S extends h.$Sc{get recordedInflateBytes(){return this.j?A.$ge.concat(this.f):A.$ge.alloc(0)}constructor(k,C,M,F){super(),this.h=k,this.j=C,this.a=this.B(new f.$Sd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,j.createInflateRaw)(F),this.b.on("error",N=>{this.h.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.h.traceSocketEvent("zlibInflateData",N),this.g.push(A.$ge.wrap(N))}),M&&(this.h.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(k){this.j&&this.f.push(k.clone()),this.h.traceSocketEvent("zlibInflateWrite",k),this.b.write(k.buffer)}flush(k){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const C=A.$ge.concat(this.g);this.g.length=0,k(C)})}}class d extends h.$Sc{constructor(k,C){super(),this.g=k,this.a=this.B(new f.$Sd),this.onError=this.a.event,this.f=[],this.b=(0,j.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent("zlibDeflateData",M),this.f.push(A.$ge.wrap(M))})}write(k){this.g.traceSocketEvent("zlibDeflateWrite",k.buffer),this.b.write(k.buffer)}flush(k){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let C=A.$ge.concat(this.f);this.f.length=0,C=C.slice(0,C.byteLength-4),k(C)})}}function t(I,k){if(k===0)return;const C=I.byteLength>>>2;for(let le=0;le<C;le++){const ce=I.readUInt32BE(le*4);I.writeUInt32BE(ce^k,le*4)}const M=C*4,F=I.byteLength-M,N=k>>>24&255,Z=k>>>16&255,Q=k>>>8&255;F>=1&&I.writeUInt8(I.readUInt8(M)^N,M),F>=2&&I.writeUInt8(I.readUInt8(M+1)^Z,M+1),F>=3&&I.writeUInt8(I.readUInt8(M+2)^Q,M+2)}e.$Th=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function r(){const I=(0,b.$ng)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${I}-sock`;const k=process.platform!=="darwin"&&e.$Th?e.$Th:(0,s.tmpdir)(),C=(0,y.$jc)(k,`vscode-ipc-${I}.sock`);return n(C),C}e.$Uh=r;function i(I,k,C){const M=(0,P.createHash)("md5").update(I).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${M}-${C}-${k}-sock`;const F=C.substr(0,4),N=k.substr(0,6),Z=M.substr(0,8);let Q;return process.platform!=="darwin"&&e.$Th&&!process.env.VSCODE_PORTABLE?Q=(0,y.$jc)(e.$Th,`vscode-${Z}-${F}-${N}.sock`):Q=(0,y.$jc)(I,`${F}-${N}.sock`),n(Q),Q}e.$Vh=i;function n(I){const k=o[v.$u];typeof k=="number"&&I.length>=k&&console.warn(`WARNING: IPC handle "${I}" is longer than ${k} chars, try a shorter --user-data-dir`)}class a extends l.$Gh{static b(k){const C=f.Event.fromNodeEventEmitter(k,"connection");return f.Event.map(C,M=>({protocol:new p.$Nh(new w(M,"ipc-server-connection")),onDidClientDisconnect:f.Event.once(f.Event.fromNodeEventEmitter(M,"close"))}))}constructor(k){super(a.b(k)),this.d=k}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Wh=a;function m(I){return new Promise((k,C)=>{const M=(0,R.createServer)();M.on("error",C),M.listen(I,()=>{M.removeListener("error",C),k(new a(M))})})}e.$Xh=m;function D(I,k){return new Promise((C,M)=>{const F=(0,R.createConnection)(I,()=>{F.removeListener("error",M),C(p.$Oh.fromSocket(new w(F,`ipc-client${k}`),k))});F.once("error",M)})}e.$Yh=D}),define(re[24],oe([0,1,50,9,4,99,37,90,6]),function(J,e,P,R,s,j,A,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f9b=e.$e9b=void 0,e.$e9b=(0,f.$4h)(A.$0h);class h extends E.$ym{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,R.$jc)(this.userDataPath,"clp")}get backupHome(){return(0,R.$jc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,j.$Vh)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,R.$jc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$k){for(const v in process.env)if(v.endsWith("_VSCODE_SNAP_ORIG")){const b=v.slice(0,-17);if(this.d[b])continue;process.env[b]&&(this.d[b]=process.env[b]),process.env[v]?process.env[b]=process.env[v]:delete process.env[b]}}}restoreSnapExportedVariables(){if(s.$k)for(const v in this.d)process.env[v]=this.d[v],delete this.d[v]}}e.$f9b=h,Ee([P.$uh],h.prototype,"cachedLanguagesPath",null),Ee([P.$uh],h.prototype,"backupHome",null),Ee([P.$uh],h.prototype,"mainIPCHandle",null),Ee([P.$uh],h.prototype,"mainLockfile",null),Ee([P.$uh],h.prototype,"disableUpdates",null),Ee([P.$uh],h.prototype,"crossOriginIsolated",null),Ee([P.$uh],h.prototype,"codeCachePath",null),Ee([P.$uh],h.prototype,"useCodeCache",null)}),define(re[283],oe([0,1,86,33,13,9,4,19,21,196,17,24,34,16,5,195,30,98]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p,w,$,g){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$W9b=void 0;let c=class{static{u=this}static{this.a="backupWorkspaces"}constructor(d,t,o,r){this.j=d,this.k=t,this.l=o,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=E.$vg,this.i={isEqual:(i,n)=>(0,R.$4f)(i,n,!A.$k)}}async initialize(){const d=this.m.getItem(u.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(d.emptyWindows),this.d=await this.u((0,h.$v9b)(d)),this.e=await this.v((0,h.$w9b)(d)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==l.$Mk.OFF}q(){return this.s()===l.$Mk.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||l.$Mk.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(d,t){this.d.some(r=>d.workspace.id===r.workspace.id)||(this.d.push(d),this.C());const o=(0,j.$jc)(this.c,d.workspace.id);return t?this.t(o,t).then(()=>o):o}async t(d,t){if(await f.Promises.exists(d)&&await this.z(d),await f.Promises.exists(t))try{await f.Promises.rename(t,d,!1)}catch(o){this.l.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}registerFolderBackup(d){return this.e.some(t=>this.h.isEqual(d.folderUri,t.folderUri))||(this.e.push(d),this.C()),(0,j.$jc)(this.c,this.D(d))}registerEmptyWindowBackup(d){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,d.backupFolder))||(this.g.push(d),this.C()),(0,j.$jc)(this.c,d.backupFolder)}async u(d){if(!Array.isArray(d))return[];const t=new Set,o=[];for(const r of d){const i=r.workspace;if(!(0,$.$fi)(i))return[];if(!t.has(i.id)){t.add(i.id);const n=(0,j.$jc)(this.c,i.id);await this.B(n)?i.configPath.scheme!==s.Schemas.file||await f.Promises.exists(i.configPath.fsPath)?o.push(r):await this.z(n):await this.x(n)}}return o}async v(d){if(!Array.isArray(d))return[];const t=[],o=new Set;for(const r of d){const i=r.folderUri,n=this.h.getComparisonKey(i);if(!o.has(n)){o.add(n);const a=(0,j.$jc)(this.c,this.D(r));await this.B(a)?i.scheme!==s.Schemas.file||await f.Promises.exists(i.fsPath)?t.push(r):await this.z(a):await this.x(a)}}return t}async w(d){if(!Array.isArray(d))return[];const t=[],o=new Set;for(const r of d){const i=r.backupFolder;if(typeof i!="string")return[];if(!o.has(i)){o.add(i);const n=(0,j.$jc)(this.c,i);await this.B(n)?t.push(r):await this.x(n)}}return t}async x(d){try{await f.Promises.rm(d,f.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let d=(0,g.$H9b)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,d.id));)d=(0,g.$H9b)();return{backupFolder:d.id}}async z(d){const t=this.y(),o=(0,j.$jc)(this.c,t.backupFolder);try{await f.Promises.rename(d,o,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const d=[];for(const t of this.d)await this.A(t)&&d.push(t);for(const t of this.e)await this.A(t)&&d.push(t);return d}A(d){let t;return(0,h.$u9b)(d)?t=(0,j.$jc)(this.c,d.backupFolder):(0,w.$ecb)(d)?t=(0,j.$jc)(this.c,this.D(d)):t=(0,j.$jc)(this.c,d.workspace.id),this.B(t)}async B(d){try{const t=await f.Promises.readdir(d);for(const o of t)try{if((await f.Promises.readdir((0,j.$jc)(d,o))).length>0)return!0}catch{}}catch{}return!1}C(){const d={workspaces:this.d.map(({workspace:t,remoteAuthority:o})=>{const r={id:t.id,configURIPath:t.configPath.toString()};return o&&(r.remoteAuthority=o),r}),folders:this.e.map(({folderUri:t,remoteAuthority:o})=>{const r={folderUri:t.toString()};return o&&(r.remoteAuthority=o),r}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:o})=>{const r={backupFolder:t};return o&&(r.remoteAuthority=o),r})};this.m.setItem(u.a,d)}D(d){const t=d.folderUri;let o;return t.scheme===s.Schemas.file?o=A.$k?t.fsPath:t.fsPath.toLowerCase():o=t.toString().toLowerCase(),(0,P.createHash)("md5").update(o).digest("hex")}};e.$W9b=c,e.$W9b=c=u=Ee([ne(0,v.$e9b),ne(1,y.$wi),ne(2,p.$kj),ne(3,b.$0N)],c)}),define(re[20],oe([0,1,15,36,8,3,2,4,35,12,6,5,34,24]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$h9b=e.LifecycleMainPhase=e.ShutdownReason=e.$g9b=void 0,e.$g9b=(0,y.$3h)("lifecycleMainService");var w;(function(u){u[u.QUIT=1]="QUIT",u[u.KILL=2]="KILL"})(w||(e.ShutdownReason=w={}));var $;(function(u){u[u.Starting=1]="Starting",u[u.Ready=2]="Ready",u[u.AfterWindowOpen=3]="AfterWindowOpen",u[u.Eventually=4]="Eventually"})($||(e.LifecycleMainPhase=$={}));let g=class extends A.$Sc{static{p=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(c,S,d){super(),this.F=c,this.G=S,this.H=d,this.c=this.B(new j.$Sd),this.onBeforeShutdown=this.c.event,this.f=this.B(new j.$Sd),this.onWillShutdown=this.f.event,this.g=this.B(new j.$Sd),this.onWillLoadWindow=this.g.event,this.h=this.B(new j.$Sd),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(p.b),this.m&&this.G.removeItem(p.b)}J(){const c=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),E.$j&&this.t===0&&this.L(1))};P.app.addListener("before-quit",c);const S=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!E.$j)&&P.app.quit()};P.app.addListener("window-all-closed",S),P.app.once("will-quit",d=>{this.S("Lifecycle#app.on(will-quit) - begin"),d.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),P.app.removeListener("before-quit",c),P.app.removeListener("window-all-closed",S),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),P.app.quit()})})}L(c){if(this.y)return this.y;const S=this.F;this.S("Lifecycle#onWillShutdown.fire()");const d=[];return this.f.fire({reason:c,join(t,o){S.trace(`Lifecycle#onWillShutdown - begin '${t}'`),d.push(o.finally(()=>{S.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await s.Promises.settled(d)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(c){if(c<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===c)return;this.S(`lifecycle (main): phase changed (value: ${c})`),this.n=c;const S=this.C.get(this.n);S&&(S.open(),this.C.delete(this.n))}async when(c){if(c<=this.n)return;let S=this.C.get(c);S||(S=new s.$2g,this.C.set(c,S)),await S.wait()}registerWindow(c){const S=new A.$Rc;this.t++,S.add(c.onWillLoad(t=>this.g.fire({window:c,workspace:t.workspace,reason:t.reason})));const d=(0,h.$Qf)(c.win);d.on("close",t=>{const o=c.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${c.id}`),t.preventDefault(),this.unload(c,1).then(r=>{if(r){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(c),c.close()})}),d.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${c.id}`),this.t--,S.dispose(),this.t===0&&(!E.$j||this.j)&&this.L(1)})}async reload(c,S){await this.unload(c,3)||c.reload(S)}unload(c,S){const d=this.z.get(c.id);if(d)return d;const t=this.M(c,S).finally(()=>{this.z.delete(c.id)});return this.z.set(c.id,t),t}async M(c,S){if(!c.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${c.id}`);const d=this.j?2:S,t=await this.P(c,d);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${c.id})`),this.N(t)):(await this.Q(c,d),!1)}N(c){return c?(this.O(!0),this.j=!1,!0):!1}O(c){this.w&&(this.w(c),this.w=void 0,this.u=void 0)}P(c,S){return new Promise(d=>{const t=this.s++,o=`vscode:ok${t}`,r=`vscode:cancel${t}`;R.$jU.once(o,()=>{d(!1)}),R.$jU.once(r,()=>{d(!0)}),c.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:r,reason:S})})}Q(c,S){return new Promise(d=>{const o=`vscode:reply${this.s++}`;R.$jU.once(o,()=>d()),c.send("vscode:onWillUnload",{replyChannel:o,reason:S})})}quit(c){return this.R(c).then(S=>{if(!S&&c)try{if(E.$i){const d=(0,f.cwd)();d!==process.cwd()&&process.chdir(d)}}catch(d){this.F.error(d)}return S})}R(c){return this.S(`Lifecycle#quit() - begin (willRestart: ${c})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(c&&this.G.setItem(p.b,!0),this.u=new Promise(S=>{this.w=S,this.S("Lifecycle#quit() - calling app.quit()"),P.app.quit()}),this.u)}S(c){this.H.args["enable-smoke-test-driver"]?this.F.info(c):this.F.trace(c)}setRelaunchHandler(c){this.D=c}async relaunch(c){this.S("Lifecycle#relaunch()");const S=process.argv.slice(1);if(c?.addArgs&&S.push(...c.addArgs),c?.removeArgs)for(const o of c.removeArgs){const r=S.indexOf(o);r>=0&&S.splice(r,1)}const d=()=>{this.D?.handleRelaunch(c)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),P.app.relaunch({args:S}))};P.app.once("quit",d),await this.quit(!0)&&P.app.removeListener("quit",d)}async kill(c){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,s.$4g)(1e3),(async()=>{for(const S of P.BrowserWindow.getAllWindows())if(S&&!S.isDestroyed()){let d;S.webContents&&!S.webContents.isDestroyed()?d=new Promise(t=>S.once("closed",t)):d=Promise.resolve(),S.destroy(),await d}})()]),P.app.exit(c)}};e.$h9b=g,e.$h9b=g=p=Ee([ne(0,v.$kj),ne(1,b.$0N),ne(2,l.$e9b)],g)}),define(re[284],oe([0,1,4,3,2,6,20]),function(J,e,P,R,s,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h0b=e.$g0b=void 0,e.$g0b=(0,j.$3h)("keyboardLayoutMainService");let E=class extends s.$Sc{constructor(y){super(),this.a=this.B(new R.$Sd),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,y.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const y=await new Promise((v,b)=>{J(["native-keymap"],v,b)});this.c=f(y),P.$t||y.onDidChangeKeyboardLayout(()=>{this.c=f(y),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$h0b=E,e.$h0b=E=Ee([ne(0,A.$g9b)],E);function f(h){const y=h.getKeyMap(),v=h.getCurrentKeyboardLayout();return{keyboardMapping:y,keyboardLayoutInfo:v}}}),define(re[285],oe([0,1,246,8,18,14,12,17,37,94,5,52,245,282]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=e.$br=void 0;let p=class extends v.$9o{constructor(u,c,S,d){super(d),this.m=u,this.n=c,this.r=S,this.s(),this.B(u.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const u=this.m.getValue("http");this.f=u?.proxy,this.g=!!u?.proxyStrictSSL,this.h=u?.proxyAuthorization}async request(u,c){const{f:S,g:d}=this;let t;try{t=await(0,h.$9l)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,j.$0)(i)))}const o={...process.env,...t},r=u.agent?u.agent:await(0,b.$ar)(u.url||"",o,{proxyUrl:S,strictSSL:d});return u.agent=r,u.strictSSL=d,this.h&&(u.headers={...u.headers||{},"Proxy-Authorization":this.h}),this.c(u.isChromiumNetwork?"electron":"node",u,()=>$(u,c))}async resolveProxy(u){}async loadCertificates(){return(await new Promise((c,S)=>{J(["@vscode/proxy-agent"],c,S)})).loadSystemCertificates({log:this.r})}};e.$br=p,e.$br=p=Ee([ne(0,E.$wi),ne(1,f.$$h),ne(2,y.$kj),ne(3,y.$lj)],p);async function w(g){return((0,P.parse)(g.url).protocol==="https:"?await new Promise((S,d)=>{J(["https"],S,d)}):await new Promise((S,d)=>{J(["http"],S,d)})).request}async function $(g,u){return R.Promises.withAsyncBody(async(c,S)=>{const d=(0,P.parse)(g.url),t=g.getRawRequest?g.getRawRequest(g):await w(g),o={hostname:d.hostname,port:d.port?parseInt(d.port):d.protocol==="https:"?443:80,protocol:d.protocol,path:d.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,A.$Lf)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(o.auth=g.user+":"+g.password);const r=t(o,i=>{const n=(0,A.$Jf)(g.followRedirects)?g.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)$({...g,url:i.headers.location,followRedirects:n-1},u).then(c,S);else{let a=i;!g.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(a=i.pipe((0,l.createGunzip)())),c({res:i,stream:(0,s.$ve)(a)})}});r.on("error",S),g.timeout&&r.setTimeout(g.timeout),g.isChromiumNetwork&&r.removeHeader("Content-Length"),g.data&&typeof g.data=="string"&&r.write(g.data),r.end(),u.onCancellationRequested(()=>{r.abort(),S(new j.$5)})})}e.$cr=$}),define(re[286],oe([0,1,15,285]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j$b=void 0;function s(A){return P.net.request}class j extends R.$br{request(E,f){return super.request({...E||{},getRawRequest:s,isChromiumNetwork:!0},f)}}e.$j$b=j}),define(re[82],oe([0,1,7,3,2,37,16,6,20,5,96,279,41,55,40,13]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r9b=e.$q9b=e.$p9b=e.$o9b=void 0,e.$o9b=(0,E.$3h)("storageMainService");let $=class extends s.$Sc{constructor(c,S,d,t,o,r){super(),this.c=c,this.f=S,this.g=d,this.h=t,this.j=o,this.m=r,this.a=void 0,this.b=this.B(new R.$Sd),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(c=>{c.window.profile&&this.profileStorage(c.window.profile).init(),c.workspace&&this.workspaceStorage(c.workspace).init()})),this.B(this.h.onWillShutdown(c=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=c.reason,c.join("applicationStorage",this.applicationStorage.close());for(const[,S]of this.t)c.join("profileStorage",S.close());for(const[,S]of this.w)c.join("workspaceStorage",S.close())})),this.B(this.g.onWillCreateProfile(c=>{c.join((async()=>{await this.j.exists(c.profile.globalStorageHome)||await this.j.createFolder(c.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(c=>{const S=this.t.get(c.profile.id);S&&c.join(S.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const c=new v.$j9b(this.n(),this.g,this.c,this.j);return this.B(R.Event.once(c.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),c}profileStorage(c){if((0,y.$lp)(c))return this.applicationStorage;let S=this.t.get(c.id);if(!S){this.c.trace(`StorageMainService: creating profile storage (${c.name})`),S=this.B(this.u(c)),this.t.set(c.id,S);const d=this.B(S.onDidChangeStorage(t=>this.b.fire({...t,storage:S,profile:c})));this.B(R.Event.once(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${c.name})`),this.t.delete(c.id),d.dispose()}))}return S}u(c){return this.a===2?new v.$l9b(this.c,this.j):new v.$i9b(c,this.n(),this.c,this.j)}workspaceStorage(c){let S=this.w.get(c.id);return S||(this.c.trace(`StorageMainService: creating workspace storage (${c.id})`),S=this.B(this.y(c)),this.w.set(c.id,S),this.B(R.Event.once(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${c.id})`),this.w.delete(c.id)}))),S}y(c){return this.a===2?new v.$l9b(this.c,this.j):new v.$k9b(c,this.n(),this.c,this.f,this.j)}isUsed(c){const S=P.URI.file(c);for(const d of[this.applicationStorage,...this.t.values(),...this.w.values()])if(d.path&&this.m.extUri.isEqualOrParent(P.URI.file(d.path),S))return!0;return!1}};e.$p9b=$,e.$p9b=$=Ee([ne(0,h.$kj),ne(1,j.$0h),ne(2,l.$m9b),ne(3,f.$g9b),ne(4,A.$nk),ne(5,p.$Xk)],$),e.$q9b=(0,E.$3h)("applicationStorageMainService");let g=class extends y.$kp{constructor(c,S){super(),this.s=c,this.U=S,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(c){if(c===-1)return this.U.applicationStorage.storage}Q(c){if(c===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:w.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$r9b=g,e.$r9b=g=Ee([ne(0,b.$Zk),ne(1,e.$o9b)],g)}),define(re[287],oe([0,1,87,26,103,99,8,2,4,17,5,27,241,242,95,126,18]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i$b=e.$h$b=e.$g$b=e.$f$b=void 0;async function g(t,o,r,i,n){let a;for(let m=3;m&&(a?.dispose(),a=await new u(t,o,r,i,n).waitForReady(),!(n&&s.$qg[n]||!s.$qg[a.tunnelLocalPort]));m--);return a}class u extends E.$Sc{constructor(o,r,i,n,a){super(),this.m=r,this.n=a,this.privacy=w.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=P.createServer(),this.c=new A.$2g,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=m=>this.r(m),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,r=(0,w.$uv)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,s.$rg)(o,2,1e3,r),n=null;return this.b.listen(i,this.m),await this.c.wait(),n=this.b.address(),n||(i=0,this.b.listen(i,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(o){o.pause();const r=(0,w.$sv)(this.tunnelRemoteHost)||(0,w.$uv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,b.$il)(this.a,r,this.tunnelRemotePort),n=i.getSocket(),a=i.readEntireBuffer();i.dispose(),a.byteLength>0&&o.write(a.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),n.end()}),o.on("close",()=>n.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),n instanceof j.$Rh?n.socket.destroy():n.end()}),n instanceof j.$Rh?this.t(o,n):this.s(o,n),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),n.end()})}s(o,r){r.onClose(()=>o.destroy()),r.onEnd(()=>o.end()),r.onData(i=>o.write(i.buffer)),o.on("data",i=>r.write($.$ge.wrap(i))),o.resume()}t(o,r){const i=r.socket;i.on("end",()=>o.end()),i.on("close",()=>o.end()),i.on("error",()=>{o.destroy()}),i.pipe(o),o.pipe(i)}}e.$f$b=u;let c=class extends w.$xv{constructor(o,r,i,n,a){super(r,a),this.u=o,this.v=i,this.w=n}isPortPrivileged(o){return(0,w.$vv)(o,this.l,f.OS,R.release())}s(o,r,i,n,a,m,D,I){const k=this.r(r,i);if(k)return++k.refcount,k.value;if((0,w.$pv)(o))return this.t(o,r,i,a,m,D,I);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${a}.`);const C={commit:this.w.commit,quality:this.w.quality,addressProvider:o,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},M=g(C,n,r,i,a);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(r,i,M),M}}};e.$g$b=c,e.$g$b=c=Ee([ne(0,l.$cl),ne(1,y.$kj),ne(2,p.$fl),ne(3,v.$Cj),ne(4,h.$wi)],c);let S=class extends c{constructor(o,r,i,n,a){super(o,r,i,n,a)}};e.$h$b=S,e.$h$b=S=Ee([ne(0,l.$cl),ne(1,y.$kj),ne(2,p.$fl),ne(3,v.$Cj),ne(4,h.$wi)],S);let d=class extends E.$Sc{constructor(o,r,i,n,a){super(),this.b=o,this.c=r,this.f=i,this.g=n,this.h=a,this.a=new Map}async openTunnel(o,r,i,n,a,m,D,I,k){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${m}.`),!this.a.has(o)){const C=new S(this.b,this.c,this.g,this.f,this.h);this.B(C),this.a.set(o,C),C.onTunnelClosed(async()=>{(await C.tunnels).length===0&&(C.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(r,i,n,a,m,D,I,k)}};e.$i$b=d,e.$i$b=d=Ee([ne(0,l.$cl),ne(1,y.$kj),ne(2,v.$Cj),ne(3,p.$fl),ne(4,h.$wi)],d)}),define(re[100],oe([0,1,8,22,3,17,24,20,5,27,52,49]),function(J,e,P,R,s,j,A,E,f,h,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E0b=e.$D0b=void 0;function b(p,w,$){return`${$.updateUrl}/api/update/${p}/${w}/${$.commit}`}e.$D0b=b;let l=class{get state(){return this.b}d(w){this.j.info("update#setState",w.type),this.b=w,this.c.fire(w)}constructor(w,$,g,u,c,S){this.f=w,this.g=$,this.h=g,this.i=u,this.j=c,this.k=S,this.b=v.$hV.Uninitialized,this.c=new s.$Sd,this.onStateChange=this.c.event,w.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(v.$hV.Disabled(0));return}if(this.h.disableUpdates){this.d(v.$hV.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(v.$hV.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const w=this.g.getValue("update.mode"),$=this.m(w);if(!$){this.d(v.$hV.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s($),!this.a){this.d(v.$hV.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const g=new URL(this.a);g.searchParams.set("prss","true"),this.a=g.toString()}if(this.d(v.$hV.Idle(this.q())),w==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,g=>this.j.error(g))}m(w){return w==="none"?void 0:this.k.quality}n(w=60*60*1e3){return(0,P.$4g)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(w){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(w)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(w){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},R.CancellationToken.None)).res.statusCode===204}catch($){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error($);return}}async _applySpecificUpdate(w){}q(){return 1}r(){}};e.$E0b=l,e.$E0b=l=Ee([ne(0,E.$g9b),ne(1,j.$wi),ne(2,A.$e9b),ne(3,y.$8o),ne(4,f.$kj),ne(5,h.$Cj)],l)}),define(re[288],oe([0,1,15,50,3,45,2,17,24,20,5,27,52,28,49,100]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F0b=void 0;let $=class extends w.$E0b{get v(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"error",(u,c)=>c)}get w(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-available",(u,c,S)=>({url:c,version:S,productVersion:S}))}get y(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-downloaded",(u,c,S,d)=>({releaseNotes:c,version:S,productVersion:S,date:d}))}constructor(u,c,S,d,t,o,r){super(u,c,d,t,o,r),this.z=S,this.u=new A.$Rc,u.setRelaunchHandler(this)}handleRelaunch(u){return u?.addArgs||u?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(u){this.z.publicLog2("update:error",{messageHash:String((0,j.$Qi)(String(u)))}),this.j.error("UpdateService error:",u);const c=this.state.type==="checking for updates"&&this.state.explicit?u:void 0;this.d(p.$hV.Idle(1,c))}s(u){let c;this.k.darwinUniversalAssetId?c=this.k.darwinUniversalAssetId:c=process.arch==="x64"?"darwin":"darwin-arm64";const S=(0,w.$D0b)(c,u,this.k);try{P.autoUpdater.setFeedURL({url:S})}catch(d){this.j.error("Failed to set update feed URL",d);return}return S}t(u){this.d(p.$hV.CheckingForUpdates(u)),P.autoUpdater.checkForUpdates()}E(u){this.state.type==="checking for updates"&&this.d(p.$hV.Downloading(u))}F(u){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:u.version}),this.d(p.$hV.Ready(u)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(p.$hV.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),P.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$F0b=$,Ee([R.$uh],$.prototype,"v",null),Ee([R.$uh],$.prototype,"w",null),Ee([R.$uh],$.prototype,"x",null),Ee([R.$uh],$.prototype,"y",null),e.$F0b=$=Ee([ne(0,h.$g9b),ne(1,E.$wi),ne(2,l.$rl),ne(3,f.$e9b),ne(4,b.$8o),ne(5,y.$kj),ne(6,v.$Cj)],$)}),define(re[289],oe([0,1,48,46,8,3,9,24,20,5,28,49]),function(J,e,P,R,s,j,A,E,f,h,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H0b=void 0;let b=class{get state(){return this.a}d(w){this.g.info("update#setState",w.type),this.a=w,this.b.fire(w)}constructor(w,$,g){if(this.f=w,this.g=g,this.a=v.$hV.Uninitialized,this.b=new j.$Sd,this.onStateChange=this.b.event,$.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(v.$hV.Idle(this.k())),this.h(30*1e3).then(void 0,u=>this.g.error(u))}h(w=60*60*1e3){return(0,s.$4g)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(w){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(w)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(w){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(w){}};b=Ee([ne(0,f.$g9b),ne(1,E.$e9b),ne(2,h.$kj)],b);let l=class extends b{constructor(w,$,g,u,c,S){super(g,u,c),this.o=w,this.p=$,this.q=S;const d=(0,R.watch)(A.$mc(this.o)),t=j.Event.fromNodeEventEmitter(d,"change",(n,a)=>a),o=j.Event.filter(t,n=>n==="current"),i=j.Event.debounce(o,(n,a)=>a,2e3)(()=>this.checkForUpdates(!1));g.onWillShutdown(()=>{i.dispose(),d.close()})}m(){this.d(v.$hV.CheckingForUpdates(!1)),this.u().then(w=>{w?this.d(v.$hV.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.$hV.Idle(2)))},w=>{this.g.error(w),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.$hV.Idle(2,w.message||w))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,P.spawn)("sleep 3 && "+A.$nc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const w=await new Promise((g,u)=>(0,R.realpath)(`${A.$mc(this.o)}/current`,(c,S)=>c?u(c):g(S))),$=A.$nc(w);return this.p!==$}isLatestVersion(){return this.u().then(void 0,w=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$H0b=l,e.$H0b=l=Ee([ne(2,f.$g9b),ne(3,E.$e9b),ne(4,h.$kj),ne(5,y.$rl)],l)}),define(re[29],oe([0,1,4,6,60,70,27,17,24,9,65,136]),function(J,e,P,R,s,j,A,E,f,h,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U9b=e.$T9b=e.$S9b=e.OpenContext=e.$R9b=void 0,e.$R9b=(0,R.$3h)("windowsMainService");var b;(function($){$[$.CLI=0]="CLI",$[$.DOCK=1]="DOCK",$[$.MENU=2]="MENU",$[$.DIALOG=3]="DIALOG",$[$.DESKTOP=4]="DESKTOP",$[$.API=5]="API"})(b||(e.OpenContext=b={}));function l($,g,u){const c=$.get(j.$s9b),S=$.get(A.$Cj),d=$.get(E.$wi),t=$.get(f.$e9b),o=d.getValue("window"),r={backgroundColor:c.getBackgroundColor(),minWidth:s.$zC.WIDTH,minHeight:s.$zC.HEIGHT,title:S.nameLong,...u,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,s.$IC)(o?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...u?.webPreferences,sandbox:!0},experimentalDarkMode:!0};if(g&&(r.x=g.x,r.y=g.y,r.width=g.width,r.height=g.height),P.$k?r.icon=(0,h.$jc)(t.appRoot,"resources/linux/code.png"):P.$i&&!t.isBuilt&&(r.icon=(0,h.$jc)(t.appRoot,"resources/win32/code_150x150.png")),P.$j&&(r.acceptFirstMouse=!0,o?.clickThroughInactive===!1&&(r.acceptFirstMouse=!1)),P.$j&&!(0,s.$HC)(d)&&(r.fullscreenable=!1),P.$j&&o?.nativeTabs===!0&&(r.tabbingIdentifier=S.nameShort),(0,s.$FC)(d)==="custom"&&(r.titleBarStyle="hidden",P.$j||(r.frame=!1),(0,s.$GC)(d))){const a=c.getWindowSplash()?.colorInfo.titleBarBackground??c.getBackgroundColor(),m=v.$at.fromHex(a).isDarker()?"#FFFFFF":"#000000";r.titleBarOverlay={height:29,color:a,symbolColor:m}}return r}e.$S9b=l;function p($){const g=$.get(e.$R9b),u=$.get(y.$P9b),c=g.getFocusedWindow()??u.getFocusedWindow();if(c)return c;const S=g.getLastActiveWindow(),d=u.getLastActiveWindow();return S&&d?S.lastFocusTime<d.lastFocusTime?d:S:S??d}e.$T9b=p;function w($){let g,u=Number.MIN_VALUE;for(const c of $)c.lastFocusTime>u&&(u=c.lastFocusTime,g=c);return g}e.$U9b=w}),define(re[290],oe([0,1,15,22,3,45,2,32,116,5,82,29]),function(J,e,P,R,s,j,A,E,f,h,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V9b=void 0;var b;(function(p){p[p.Initial=1]="Initial",p[p.StoredCredentialsUsed=2]="StoredCredentialsUsed",p[p.LoginDialogShown=3]="LoginDialogShown"})(b||(b={}));let l=class extends A.$Sc{constructor(w,$,g,u){super(),this.g=w,this.h=$,this.j=g,this.m=u,this.a="proxy-credentials://",this.b=void 0,this.c=b.Initial,this.f=void 0,this.n()}n(){const w=s.Event.fromNodeEventEmitter(P.app,"login",($,g,u,c,S)=>({event:$,webContents:g,req:u,authInfo:c,callback:S}));this.B(w(this.r,this))}async r({event:w,authInfo:$,req:g,callback:u}){if(!$.isProxy)return;if(!this.b&&this.c===b.LoginDialogShown&&g.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}w.preventDefault();let c;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),c=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s($);try{c=await this.b}finally{this.b=void 0}}u(c?.username,c?.password)}async s(w){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const $=await this.t(w);if($)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),$;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(w){this.g.trace("auth#doResolveProxyCredentials - enter",w);const $=String((0,j.$Qi)({scheme:w.scheme,host:w.host,port:w.port}));let g,u;try{const t=this.m.get(this.a+$,-1);if(t){const o=JSON.parse(await this.j.decrypt(t));g=o.username,u=o.password}}catch(t){this.g.error(t)}if(this.c!==b.StoredCredentialsUsed&&typeof g=="string"&&typeof u=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=b.StoredCredentialsUsed,{username:g,password:u};const c=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!c){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${c.id} to handle proxy login`);const S={authInfo:w,username:this.f?.username??g,password:this.f?.password??u,replyChannel:`vscode:proxyAuthResponse:${(0,E.$ng)()}`};c.sendWhenReady("vscode:openProxyAuthenticationDialog",R.CancellationToken.None,S),this.c=b.LoginDialogShown;const d=await new Promise(t=>{const o=async(r,i,n)=>{if(i===S.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${c.id}`),c.win?.webContents.off("ipc-message",o),n){const a={username:n.username,password:n.password};try{if(n.remember){const m=await this.j.encrypt(JSON.stringify(a));this.m.store(this.a+$,m,-1,1)}else this.m.remove(this.a+$,-1)}catch(m){this.g.error(m)}t({username:a.username,password:a.password})}else t(void 0)};c.win?.webContents.on("ipc-message",o)});return this.f=d,d}};e.$V9b=l,e.$V9b=l=Ee([ne(0,h.$kj),ne(1,v.$R9b),ne(2,f.$5U),ne(3,y.$q9b)],l)}),define(re[291],oe([0,1,15,23,4,7,21,17,64,6,5,127,29]),function(J,e,P,R,s,j,A,E,f,h,y,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k0b=e.$j0b=e.ID=void 0,e.ID="launchMainService",e.$j0b=(0,h.$3h)(e.ID);let l=class{constructor(w,$,g,u){this.a=w,this.b=$,this.c=g,this.d=u}async start(w,$){this.a.trace("Received data from other instance: ",w,$),s.$j&&P.app.focus({steal:!0});const g=this.e(w);if(g.length){let u=Promise.resolve();if(this.b.getWindowCount()===0){const c=(0,R.$Ob)(await this.b.openEmptyWindow({context:4}));c&&(u=c.ready())}u.then(()=>{for(const{uri:c,originalUrl:S}of g)this.c.open(c,{originalUrl:S})})}else return this.f(w,$)}e(w){return w["open-url"]&&w._urls&&w._urls.length>0?(0,R.$Hb)(w._urls.map($=>{try{return{uri:j.URI.parse($),originalUrl:$}}catch{return null}})):[]}async f(w,$){const g=(0,f.$3l)($)?0:4;let u=[];const c=w.wait&&w.waitMarkerFilePath?j.URI.file(w.waitMarkerFilePath):void 0,S=w.remote||void 0,d={context:g,cli:w,userEnv:$,waitMarkerFileURI:c,remoteAuthority:S,forceProfile:w.profile,forceTempProfile:w["profile-temp"]};if(w.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(w.extensionDevelopmentPath,d);else if(!w._.length&&!w["folder-uri"]&&!w["file-uri"]){let t=!1;if(w["new-window"]||w["unity-launch"]||d.forceProfile||d.forceTempProfile)t=!0;else if(w["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!s.$j}if(t)u=await this.b.open({...d,forceNewWindow:!0,forceEmpty:!0});else{const o=this.b.getLastActiveWindow();o?(this.b.openExistingWindow(o,d),u=[o]):u=await this.b.open({...d,forceEmpty:!0})}}else u=await this.b.open({...d,forceNewWindow:w["new-window"],preferNewWindow:!w["reuse-window"]&&!w.wait,forceReuseWindow:w["reuse-window"],diffMode:w.diff,mergeMode:w.merge,addMode:w.add,noRecentEntry:!!w["skip-add-to-recently-opened"],gotoLineMode:w.goto});if(c&&u.length===1&&u[0])return Promise.race([u[0].whenClosedOrLoaded,(0,A.whenDeleted)(c.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$k0b=l,e.$k0b=l=Ee([ne(0,y.$kj),ne(1,b.$R9b),ne(2,v.$$U),ne(3,E.$wi)],l)}),define(re[292],oe([0,1,2,20,55,30,8,29]),function(J,e,P,R,s,j,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z0b=void 0;let f=class extends P.$Sc{constructor(y,v,b){super(),this.a=v,this.b=b,this.B(y.onWillLoadWindow(l=>{l.reason===2&&this.c(l.window)})),this.B(y.onBeforeCloseWindow(l=>this.c(l))),this.B(new A.$ch(()=>this.g(),30*1e3)).schedule()}async c(y){const v=this.f(y),b=this.a.getProfileForWorkspace(v);b?.isTransient&&(this.a.unsetWorkspace(v,b.isTransient),b.isTransient&&await this.a.cleanUpTransientProfiles())}f(y){return y.openedWorkspace??(0,j.$ei)(y.backupPath,y.isExtensionDevelopmentHost)}g(){const y=this.a.getAssociatedEmptyWindows();if(y.length===0)return;const v=this.b.getWindows().map(b=>this.f(b));for(const b of y)v.some(l=>l.id===b.id)||this.a.unsetWorkspace(b,!1)}};e.$Z0b=f,e.$Z0b=f=Ee([ne(0,R.$g9b),ne(1,s.$m9b),ne(2,E.$R9b)],f)}),define(re[61],oe([0,1,15,2,3,5,312,8,13,29,74,28,20,76,38,4,131]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p,w,$){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Z9b=e.$Y9b=void 0;function u(d){return typeof d.responseWindowId=="number"}let c=class extends R.$Sc{static{g=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(g.b.values())}constructor(t,o,r){super(),this.u=t,this.w=o,this.y=r,this.c=String(++g.a),this.f=this.B(new s.$Sd),this.onStdout=this.f.event,this.g=this.B(new s.$Sd),this.onStderr=this.g.event,this.h=this.B(new s.$Sd),this.onMessage=this.h.event,this.j=this.B(new s.$Sd),this.onSpawn=this.j.event,this.m=this.B(new s.$Sd),this.onExit=this.m.event,this.n=this.B(new s.$Sd),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0}z(t,o){let r;switch(this.t?.correlationId?r=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:r=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,o){case y.default.Error:this.u.error(r);break;case y.default.Warning:this.u.warn(r);break;case y.default.Info:this.u.trace(r);break}}C(){return this.r?(this.z("Cannot start utility process because it is already running...",y.default.Error),!1):!0}start(t){const o=this.D(t);return o&&t.payload&&this.postMessage(t.payload),o}D(t){if(!this.C())return!1;this.t=t;const o=`${this.t.type}-${this.c}`,r=f.$lg.asFileUri("bootstrap-fork.js").fsPath,i=this.t.args??[],n=this.t.execArgv??[],a=this.t.allowLoadingUnsignedLibraries,m=this.t.forceAllocationsToV8Sandbox,D="pipe",I=this.F(t);return this.z("creating new...",y.default.Info),this.r=P.utilityProcess.fork(r,i,{serviceName:o,env:I,execArgv:n,allowLoadingUnsignedLibraries:a,forceAllocationsToV8Sandbox:m,stdio:D}),this.G(this.r,this.t,o),!0}F(t){const o=t.env?{...t.env}:{...(0,p.$jn)(process.env)};o.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,w.$i&&((0,$.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,$.getUNCHostAllowlist)().join("\\")),(0,l.$Pl)(o);for(const r of Object.keys(o))o[r]=String(o[r]);return o}G(t,o,r){if(t.stdout){const i=new A.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:i.write(n))))}if(t.stderr){const i=new A.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:i.write(n))))}this.B(s.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(s.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&g.b.set(t.pid,{pid:t.pid,name:u(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.z("successfully created",y.default.Info),this.j.fire(t.pid)})),this.B(s.Event.fromNodeEventEmitter(t,"exit")(i=>{this.z(`received exit event with code ${i}`,y.default.Info),this.m.fire({pid:this.s,code:i,signal:"unknown"}),this.H()})),this.B(s.Event.fromNodeEventEmitter(P.app,"child-process-gone",(i,n)=>({event:i,details:n}))(({details:i})=>{i.type==="Utility"&&i.name===r&&(this.z(`crashed with code ${i.exitCode} and reason '${i.reason}'`,y.default.Error),this.w.publicLog2("utilityprocesscrash",{type:o.type,reason:i.reason,code:i.exitCode}),this.n.fire({pid:this.s,code:i.exitCode,reason:i.reason}),this.H())}))}once(t,o){const r=this.B(this.h.event(i=>{i===t&&(r.dispose(),o())}))}postMessage(t,o){this.r&&this.r.postMessage(t,o)}connect(t){const{port1:o,port2:r}=new P.MessageChannelMain;return this.postMessage(t,[r]),o}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.z("enabling inspect port",y.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.z("attempting to kill the process...",y.default.Info),this.r.kill()?(this.z("successfully killed the process",y.default.Info),this.H()):this.z("unable to kill the process",y.default.Warning)}H(){typeof this.s=="number"&&g.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.z("waiting to exit...",y.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,E.$4g)(t)]),this.r&&(this.z(`did not exit within ${t}ms, will kill it now...`,y.default.Info),this.kill()))}};e.$Y9b=c,e.$Y9b=c=g=Ee([ne(0,j.$kj),ne(1,v.$rl),ne(2,b.$g9b)],c);let S=class extends c{constructor(t,o,r,i){super(t,r,i),this.I=o}start(t){const o=this.I.getWindowById(t.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.z("Refusing to start utility process because requesting window cannot be found or is destroyed...",y.default.Error),!0;if(!super.D(t))return!1;this.J(o.win,t);const i=this.connect(t.payload);return o.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}J(t,o){o.windowLifecycleBound&&(this.B(s.Event.filter(this.y.onWillLoadWindow,r=>r.window.win===t)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$Z9b=S,e.$Z9b=S=Ee([ne(0,j.$kj),ne(1,h.$R9b),ne(2,v.$rl),ne(3,b.$g9b)],S)}),define(re[293],oe([0,1,14,3,5,20,8,61,29,28]),function(J,e,P,R,s,j,A,E,f,h){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$79b=void 0;let v=class{static{y=this}static{this.a=0}constructor(l,p,w,$){this.d=l,this.f=p,this.g=w,this.h=$,this.b=new Map,this.c=!1,this.f.onWillShutdown(g=>{this.c=!0,g.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(l){const p=this.b.get(l);if(!p)throw new Error("Unknown extension host!");return p}onDynamicStdout(l){return this.i(l).onStdout}onDynamicStderr(l){return this.i(l).onStderr}onDynamicMessage(l){return this.i(l).onMessage}onDynamicExit(l){return this.i(l).onExit}async createExtensionHost(){if(this.c)throw(0,P.$6)();const l=String(++y.a),p=new E.$Z9b(this.d,this.g,this.h,this.f);return this.b.set(l,p),p.onExit(({pid:w,code:$,signal:g})=>{this.d.info(`Extension host with pid ${w} exited with code: ${$}, signal: ${g}.`),setTimeout(()=>{p.dispose(),this.b.delete(l)}),setTimeout(()=>{try{process.kill(w,0),this.d.error(`Extension host with pid ${w} still exists, forcefully killing it...`),process.kill(w)}catch{}},1e3)}),{id:l}}async start(l,p){if(this.c)throw(0,P.$6)();const w=this.i(l);return w.start({...p,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:p.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:l}),{pid:await R.Event.toPromise(w.onSpawn)}}async enableInspectPort(l){if(this.c)throw(0,P.$6)();const p=this.b.get(l);return p?p.enableInspectPort():!1}async kill(l){if(this.c)throw(0,P.$6)();const p=this.b.get(l);p&&p.kill()}async _killAllNow(){for(const[,l]of this.b)l.kill()}async _waitForAllExit(l){const p=[];for(const[,w]of this.b)p.push(w.waitForExit(l));return A.Promises.settled(p).then(()=>{})}};e.$79b=v,e.$79b=v=y=Ee([ne(0,s.$kj),ne(1,j.$g9b),ne(2,f.$R9b),ne(3,h.$rl)],v)}),define(re[294],oe([0,1,36,8,2,24,20,5,41,39,69,61,53,90,12,247]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x0b=void 0;let $=class extends s.$Sc{constructor(u,c,S,d,t,o,r,i){super(),this.c=u,this.f=c,this.g=S,this.h=d,this.j=t,this.m=o,this.n=r,this.r=i,this.a=new R.$2g,this.b=void 0,this.w=void 0,this.y=void 0,this.s()}s(){P.$jU.on(w.$v0b.request,(u,c)=>this.t(u,c,w.$v0b.response)),P.$jU.on(w.$w0b.request,(u,c)=>this.t(u,c,w.$w0b.response)),this.B(this.j.onWillShutdown(()=>this.u()))}async t(u,c,S){this.m.trace(`[SharedProcess] onWindowConnection for: ${S}`),this.a.isOpen()||this.a.open(),await this.whenReady();const d=await this.connect(S);if(u.sender.isDestroyed())return d.close();u.sender.postMessage(S,c,[d])}u(){this.m.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(w.$u0b.exit),this.b=void 0}whenReady(){return this.w||(this.w=(async()=>{await this.z;const u=new R.$nh;this.b?this.b.once(w.$u0b.initDone,()=>u.complete()):P.$jU.once(w.$u0b.initDone,()=>u.complete()),await u.p,this.m.trace("[SharedProcess] Overall ready")})()),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C();const u=new R.$nh;this.b?this.b.once(w.$u0b.ipcReady,()=>u.complete()):P.$jU.once(w.$u0b.ipcReady,()=>u.complete()),await u.p,this.m.trace("[SharedProcess] IPC ready")})()),this.y}C(){this.b=this.B(new v.$Y9b(this.m,b.$Ao,this.j));const u=(0,l.$Am)(this.g.args,this.g.isBuilt);let c;u.port&&(c=["--nolazy"],u.break?c.push(`--inspect-brk=${u.port}`):c.push(`--inspect=${u.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.D(),execArgv:c})}D(){return{machineId:this.c,sqmId:this.f,codeCachePath:this.g.codeCachePath,profiles:{home:this.h.profilesHome,all:this.h.profiles},args:this.g.args,logLevel:this.n.getLogLevel(),loggers:this.n.getRegisteredLoggers(),policiesData:this.r.serialize()}}async connect(u){return await this.z,(0,p.$Qf)(this.b).connect(u)}};e.$x0b=$,e.$x0b=$=Ee([ne(2,j.$e9b),ne(3,f.$Zk),ne(4,A.$g9b),ne(5,E.$kj),ne(6,y.$K9b),ne(7,h.$xn)],$)}),define(re[295],oe([0,1,24,90,20,5,53,61,110,36,2,3,38,17,13]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$00b=void 0;let w=class extends y.$Sc{constructor(g,u,c,S,d){super(),this.f=g,this.g=u,this.h=c,this.j=S,this.m=d,this.a=void 0,this.b=new v.$Sd,this.onRequestConnection=this.b.event,this.c=new v.$Sd,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),h.$jU.on("vscode:createPtyHostMessageChannel",(t,o)=>this.r(t,o)),this.B((0,y.$Qc)(()=>{h.$jU.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new E.$Y9b(this.m,A.$Ao,this.j);const g=(0,R.$zm)(this.h.args,this.h.isBuilt),u=g.port?["--nolazy",`--inspect${g.break?"-brk":""}=${g.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:u,args:["--logsPath",this.h.logsHome.with({scheme:p.Schemas.file}).fsPath],env:this.n()});const c=this.a.connect(),S=new f.$rU(c,"ptyHost"),d=new y.$Rc;return d.add(S),d.add((0,y.$Qc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:S,store:d,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const g={...(0,b.$jn)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},u=this.g.getValue("terminal.integrated.developer.ptyHost.latency");u&&typeof u=="number"&&(g.VSCODE_LATENCY=String(u));const c=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return c&&typeof c=="number"&&(g.VSCODE_STARTUP_DELAY=String(c)),this.h.restoreSnapExportedVariables(),g}r(g,u){this.b.fire();const c=this.a.connect();if(g.sender.isDestroyed()){c.close();return}g.sender.postMessage("vscode:createPtyHostMessageChannelResult",u,[c])}};e.$00b=w,e.$00b=w=Ee([ne(1,l.$wi),ne(2,P.$e9b),ne(3,s.$g9b),ne(4,j.$kj)],w)}),define(re[296],oe([0,1,2,6,5,29,61,28,45,3,8,20]),function(J,e,P,R,s,j,A,E,f,h,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$90b=e.$80b=void 0,e.$80b=(0,R.$3h)("utilityProcessWorker");let b=class extends P.$Sc{constructor(w,$,g,u){super(),this.b=w,this.c=$,this.f=g,this.g=u,this.a=new Map}async createWorker(w){const $=`window: ${w.reply.windowId}, moduleId: ${w.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${$})`);const g=this.h(w);this.a.has(g)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${$})`),this.disposeWorker(w));const u=new l(this.b,this.c,this.f,this.g,w);if(!u.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(g,u);const c=new y.$nh;return h.Event.once(u.onDidTerminate)(S=>{S.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${S.code}, signal: ${S.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${S.code}, signal: ${S.signal}`),this.a.delete(g),c.complete({reason:S})}),c.p}h(w){return(0,f.$Qi)({moduleId:w.process.moduleId,windowId:w.reply.windowId})}async disposeWorker(w){const $=this.h(w),g=this.a.get($);g&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${w.reply.windowId}, moduleId: ${w.process.moduleId})`),g.kill(),this.a.delete($))}};e.$90b=b,e.$90b=b=Ee([ne(0,s.$kj),ne(1,j.$R9b),ne(2,E.$rl),ne(3,v.$g9b)],b);let l=class extends P.$Sc{constructor(w,$,g,u,c){super(),this.c=w,this.f=$,this.g=g,this.h=u,this.j=c,this.a=this.B(new h.$Sd),this.onDidTerminate=this.a.event,this.b=new A.$Z9b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(w=>this.a.fire({code:w.code,signal:w.signal}))),this.B(this.b.onCrash(w=>this.a.fire({code:w.code,signal:"ECRASH"})))}spawn(){const $=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:$,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};l=Ee([ne(0,s.$kj),ne(1,j.$R9b),ne(2,E.$rl),ne(3,v.$g9b)],l)}),define(re[297],oe([0,1,15,3,2,273,29]),function(J,e,P,R,s,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P0b=void 0;let E=class extends s.$Sc{constructor(h){super(),this.b=h,this.a=this.B(new R.$Sd),this.onFoundInFrame=this.a.event,this.B(new j.$O0b)}async setIgnoreMenuShortcuts(h,y){let v;if(typeof h.windowId=="number"){const{windowId:b}=h,l=this.b.getWindowById(b);if(!l?.win)throw new Error(`Invalid windowId: ${b}`);v=l.win.webContents}else{const{webContentsId:b}=h;if(v=P.webContents.fromId(b),!v)throw new Error(`Invalid webContentsId: ${b}`)}v.isDestroyed()||v.setIgnoreMenuShortcuts(y)}async findInFrame(h,y,v,b){const p=this.c(h,y);if(typeof p.findInFrame=="function"){p.findInFrame(v,{findNext:b.findNext,forward:b.forward});const w=($,g)=>{g.finalUpdate&&(this.a.fire(g),p.removeListener("found-in-frame",w))};p.on("found-in-frame",w)}}async stopFindInFrame(h,y,v){const l=this.c(h,y);typeof l.stopFindInFrame=="function"&&l.stopFindInFrame(v.keepSelection?"keepSelection":"clearSelection")}c(h,y){const v=this.b.getWindowById(h.windowId);if(!v?.win)throw new Error(`Invalid windowId: ${h}`);const b=v.win.webContents.mainFrame.framesInSubtree.find(l=>l.name===y);if(!b)throw new Error(`Unknown frame: ${y}`);return b}};e.$P0b=E,e.$P0b=E=Ee([ne(0,A.$R9b)],E)}),define(re[298],oe([0,1,15,2,4,19,7,17,20,5,34,29,128,30]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$S0b=e.$R0b=e.$Q0b=void 0;let w=class extends R.$Sc{static{p=this}static{this.a="windowsState"}get state(){return this.b}constructor(d,t,o,r,i){super(),this.g=d,this.h=t,this.j=o,this.m=r,this.n=i,this.b=$(this.h.getItem(p.a)),this.c=void 0,this.f=!1,this.r()}r(){P.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(d=>this.u(d)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(d=>{d.newCount-d.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(d=>this.u(d))}s(){this.f=!0,this.t()}t(){const d=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.w(i),t.lastActiveWindow.uiState.mode===3&&d.add(t.lastActiveWindow.uiState.display))}const o=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);o&&(t.lastPluginDevelopmentHostWindow=this.w(o),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(d.has(t.lastPluginDevelopmentHostWindow.uiState.display)?s.$j&&!o.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):d.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.w(i);return n.uiState.mode===3&&(d.has(n.uiState.display)?s.$j&&n.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):d.add(n.uiState.display)),n}));const r=u(t);this.h.setItem(p.a,r),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",r)}u(d){if(this.j.quitRequested)return;const t=this.w(d);d.isExtensionDevelopmentHost&&!d.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!d.isExtensionDevelopmentHost&&d.openedWorkspace&&this.b.openedWindows.forEach(o=>{const r=(0,l.$fi)(d.openedWorkspace)&&o.workspace?.id===d.openedWorkspace.id,i=(0,l.$ai)(d.openedWorkspace)&&o.folderUri&&j.$vg.isEqual(o.folderUri,d.openedWorkspace.uri);(r||i)&&(o.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(d){return{windowId:d.id,workspace:(0,l.$fi)(d.openedWorkspace)?d.openedWorkspace:void 0,folderUri:(0,l.$ai)(d.openedWorkspace)?d.openedWorkspace.uri:void 0,backupPath:d.backupPath,remoteAuthority:d.remoteAuthority,uiState:d.serializeWindowState()}}getNewWindowState(d){const t=this.z(d),o=this.n.getValue("window");if(t.mode===3){let r;t.hasDefaultState?r=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):r=!!(this.j.wasRestarted||o?.restoreFullscreen),r||(t.mode=1)}return t}z(d){const t=this.g.getLastActiveWindow();if(!d.extensionTestsPath){if(d.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const m=d.workspace;if((0,l.$fi)(m)){const I=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===m.id).map(k=>k.uiState);if(I.length)return I[0]}if((0,l.$ai)(m)){const I=this.state.openedWindows.filter(k=>k.folderUri&&j.$vg.isEqual(k.folderUri,m.uri)).map(k=>k.uiState);if(I.length)return I[0]}else if(d.backupPath){const I=this.state.openedWindows.filter(k=>k.backupPath===d.backupPath).map(k=>k.uiState);if(I.length)return I[0]}const D=this.c||this.state.lastActiveWindow;if(!t&&D)return D.uiState}let o;const r=P.screen.getAllDisplays();if(r.length===1)o=r[0];else{if(s.$j){const m=P.screen.getCursorScreenPoint();o=P.screen.getDisplayNearestPoint(m)}!o&&t&&(o=P.screen.getDisplayMatching(t.getBounds())),o||(o=P.screen.getPrimaryDisplay()||r[0])}let i=(0,b.$d9b)();i.x=Math.round(o.bounds.x+o.bounds.width/2-i.width/2),i.y=Math.round(o.bounds.y+o.bounds.height/2-i.height/2);const n=this.n.getValue("window");let a=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,a=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,a=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&t){const m=t.serializeWindowState();m.mode===3?i.mode=3:i=m,a=i.mode!==3&&n.newWindowDimensions==="offset"}}return a&&(i=this.C(i)),i.hasDefaultState=!0,i}C(d){if(this.g.getWindows().length===0)return d;d.x=typeof d.x=="number"?d.x:0,d.y=typeof d.y=="number"?d.y:0;const t=this.g.getWindows().map(o=>o.getBounds());for(;t.some(o=>o.x===d.x||o.y===d.y);)d.x+=30,d.y+=30;return d}};e.$Q0b=w,e.$Q0b=w=p=Ee([ne(0,v.$R9b),ne(1,y.$0N),ne(2,f.$g9b),ne(3,h.$kj),ne(4,E.$wi)],w);function $(S){const d={openedWindows:[]},t=S||{openedWindows:[]};return t.lastActiveWindow&&(d.lastActiveWindow=g(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(d.lastPluginDevelopmentHostWindow=g(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(d.openedWindows=t.openedWindows.map(o=>g(o))),d}e.$R0b=$;function g(S){const d={uiState:S.uiState};return S.backupPath&&(d.backupPath=S.backupPath),S.remoteAuthority&&(d.remoteAuthority=S.remoteAuthority),S.folder&&(d.folderUri=A.URI.parse(S.folder)),S.workspaceIdentifier&&(d.workspace={id:S.workspaceIdentifier.id,configPath:A.URI.parse(S.workspaceIdentifier.configURIPath)}),d}function u(S){return{lastActiveWindow:S.lastActiveWindow&&c(S.lastActiveWindow),lastPluginDevelopmentHostWindow:S.lastPluginDevelopmentHostWindow&&c(S.lastPluginDevelopmentHostWindow),openedWindows:S.openedWindows.map(d=>c(d))}}e.$S0b=u;function c(S){return{workspaceIdentifier:S.workspace&&{id:S.workspace.id,configURIPath:S.workspace.configPath.toString()},folder:S.folderUri&&S.folderUri.toString(),backupPath:S.backupPath,remoteAuthority:S.remoteAuthority,uiState:S.uiState}}}),define(re[56],oe([0,1,15,3,44,2,13,9,19,21,194,66,54,24,6,5,55,130,30,97,98]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p,w,$,g,u,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J9b=e.$I9b=void 0,e.$I9b=(0,p.$3h)("workspacesManagementMainService");let d=class extends j.$Sc{constructor(o,r,i,n,a){super(),this.g=o,this.h=r,this.j=i,this.m=n,this.n=a,this.a=this.B(new R.$Sd),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new R.$Sd),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await h.Promises.readdir(this.c.with({scheme:A.Schemas.file}).fsPath)).map(r=>(0,f.$Eg)(this.c,r,u.$pi));for(const r of o){const i=(0,S.$F9b)(r),n=await this.resolveLocalWorkspace(r);n?this.f.push({workspace:i,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,r=>h.Promises.readFile(r,"utf8"))}r(o,r){if(this.s(o)&&o.scheme===A.Schemas.file)try{const i=r(o.fsPath);return i instanceof Promise?i.then(n=>this.t(o,n),n=>{}):this.t(o,i)}catch{return}}s(o){return(0,u.$qi)(o,this.g)||(0,u.$vi)(o)}t(o,r){try{const i=this.u(o,r),n=(0,S.$F9b)(o);return{id:n.id,configPath:n.configPath,folders:(0,c.$mcb)(i.folders,n.configPath,f.$vg),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}u(o,r){const i=(0,s.$_m)(r);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(n=>(0,c.$kcb)(n));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(o,r){const{workspace:i,storedWorkspace:n}=this.w(o,r),a=i.configPath.fsPath;return await h.Promises.mkdir((0,E.$mc)(a),{recursive:!0}),await h.Promises.writeFile(a,JSON.stringify(n,null,"	")),this.f.push({workspace:i,remoteAuthority:r}),i}w(o=[],r){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,f.$Eg)(this.c,i),a=(0,f.$Eg)(n,u.$pi),m=[];for(const D of o)m.push((0,c.$lcb)(D.uri,!0,D.name,n,f.$vg));return{workspace:(0,S.$F9b)(a),storedWorkspace:{folders:m,remoteAuthority:r}}}async getWorkspaceIdentifier(o){return(0,S.$F9b)(o)}isUntitledWorkspace(o){return(0,u.$qi)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const r=(0,f.$sg)(o.configPath);try{await h.Promises.rm((0,E.$mc)(r));const i=(0,E.$jc)(this.g.workspaceStorageHome.with({scheme:A.Schemas.file}).fsPath,o.id);await h.Promises.exists(i)&&await h.Promises.writeFile((0,E.$jc)(i,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==o.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${r} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,r,i){if(!o||!o.win||!o.isReady||!await this.z(o,r,i))return;const a=await this.C(o,(0,S.$F9b)(i));if(a)return this.b.fire({window:o,workspace:a.workspace}),a}async z(o,r,i){return i?(0,u.$fi)(o.openedWorkspace)&&f.$vg.isEqual(o.openedWorkspace.configPath,i)?!1:(0,g.$C9b)(r,i)?(await this.n.showMessageBox({type:"info",buttons:[(0,y.localize)(0,null)],message:(0,y.localize)(1,null,(0,f.$Bg)(i)),detail:(0,y.localize)(2,null)},P.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,r){if(!o.config)return;o.focus();let i;return o.config.extensionDevelopmentPath||(o.config.backupPath?i=await this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority},o.config.backupPath):i=this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority})),(0,u.$fi)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=r,o.config.backupPath=i,{workspace:r,backupPath:i}}};e.$J9b=d,e.$J9b=d=Ee([ne(0,l.$e9b),ne(1,w.$kj),ne(2,$.$m9b),ne(3,v.$x9b),ne(4,b.$y9b)],d)}),define(re[132],oe([0,1,15,36,22,6,29,30,56,12,5,61]),function(J,e,P,R,s,j,A,E,f,h,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$39b=e.$29b=e.ID=void 0,e.ID="diagnosticsMainService",e.$29b=(0,j.$3h)(e.ID);let b=class{constructor(p,w,$){this.a=p,this.b=w,this.c=$}async getRemoteDiagnostics(p){const w=this.a.getWindows();return(await Promise.all(w.map(async g=>{const u=g.remoteAuthority;if(!u)return;const c=`vscode:getDiagnosticInfoResponse${g.id}`,S={includeProcesses:p.includeProcesses,folders:p.includeWorkspaceMetadata?await this.f(g):void 0};return new Promise(d=>{g.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:c,args:S}),R.$jU.once(c,(t,o)=>{o||d({hostName:u,errorMessage:`Unable to resolve connection to '${u}'.`}),d(o)}),setTimeout(()=>{d({hostName:u,errorMessage:`Connection to '${u}' could not be established`})},5e3)})}))).filter(g=>!!g)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const p=[];for(const $ of P.BrowserWindow.getAllWindows()){const g=this.a.getWindowById($.id);g?p.push(await this.d(g)):p.push(this.e($))}const w=[];for(const{pid:$,name:g}of v.$Y9b.getAll())w.push({pid:$,name:g});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:p,pidToNames:w,screenReader:!!P.app.accessibilitySupportEnabled,gpuFeatureStatus:P.app.getGPUFeatureStatus()}}async d(p){const w=await this.f(p),$=(0,h.$Qf)(p.win);return this.e($,w,p.remoteAuthority)}e(p,w=[],$){return{id:p.id,pid:p.webContents.getOSProcessId(),title:p.getTitle(),folderURIs:w,remoteAuthority:$}}async f(p){const w=[],$=p.openedWorkspace;if((0,E.$ai)($))w.push($.uri);else if((0,E.$fi)($)){const g=await this.b.resolveLocalWorkspace($.configPath);g&&g.folders.forEach(c=>{w.push(c.uri)})}return w}};e.$39b=b,e.$39b=b=Ee([ne(0,A.$R9b),ne(1,f.$I9b),ne(2,y.$kj)],b)}),define(re[71],oe([0,1,48,15,26,156,50,3,2,13,9,4,7,105,88,21,103,182,54,24,6,20,5,27,70,29,30,56,18,243,235,65]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p,w,$,g,u,c,S,d,t,o,r,i,n,a,m,D,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e0b=e.$d0b=void 0,e.$d0b=(0,S.$3h)("nativeHostMainService");let C=class extends f.$Sc{constructor(F,N,Z,Q,le,ce,ue,X,K,H){super(),this.a=F,this.b=N,this.c=Z,this.f=Q,this.g=le,this.h=ce,this.j=ue,this.m=X,this.n=K,this.r=H,this.onDidOpenMainWindow=E.Event.map(this.a.onDidOpenWindow,L=>L.id),this.onDidTriggerWindowSystemContextMenu=E.Event.any(E.Event.filter(E.Event.map(this.a.onDidTriggerSystemContextMenu,({window:L,x:T,y:V})=>({windowId:L.id,x:T,y:V})),({windowId:L})=>!!this.a.getWindowById(L)),E.Event.filter(E.Event.map(this.b.onDidTriggerSystemContextMenu,({window:L,x:T,y:V})=>({windowId:L.id,x:T,y:V})),({windowId:L})=>!!this.b.getWindowById(L))),this.onDidMaximizeWindow=E.Event.any(E.Event.filter(E.Event.map(this.a.onDidMaximizeWindow,L=>L.id),L=>!!this.a.getWindowById(L)),E.Event.filter(E.Event.map(this.b.onDidMaximizeWindow,L=>L.id),L=>!!this.b.getWindowById(L))),this.onDidUnmaximizeWindow=E.Event.any(E.Event.filter(E.Event.map(this.a.onDidUnmaximizeWindow,L=>L.id),L=>!!this.a.getWindowById(L)),E.Event.filter(E.Event.map(this.b.onDidUnmaximizeWindow,L=>L.id),L=>!!this.b.getWindowById(L))),this.onDidBlurMainWindow=E.Event.filter(E.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(L,T)=>T.id),L=>!!this.a.getWindowById(L)),this.onDidFocusMainWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),L=>!!L),L=>L.id),E.Event.filter(E.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(L,T)=>T.id),L=>!!this.a.getWindowById(L))),this.onDidBlurMainOrAuxiliaryWindow=E.Event.any(this.onDidBlurMainWindow,E.Event.map(E.Event.filter(E.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(L,T)=>T),L=>(0,k.$Q9b)(L.webContents)),L=>L.id)),this.onDidFocusMainOrAuxiliaryWindow=E.Event.any(this.onDidFocusMainWindow,E.Event.map(E.Event.filter(E.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(L,T)=>T),L=>(0,k.$Q9b)(L.webContents)),L=>L.id)),this.onDidResumeOS=E.Event.fromNodeEventEmitter(R.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.s=this.B(new E.$Sd),this.onDidChangePassword=this.s.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(R.screen,"display-metrics-changed",(L,T,V)=>V),L=>!(Array.isArray(L)&&L.length===1&&L[0]==="workArea")),E.Event.fromNodeEventEmitter(R.screen,"display-added"),E.Event.fromNodeEventEmitter(R.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(F,N){const Z=this.a.getWindows().map(le=>({id:le.id,workspace:le.openedWorkspace??(0,n.$ei)(le.backupPath,le.isExtensionDevelopmentHost),title:le.win?.getTitle()??"",filename:le.getRepresentedFilename(),dirty:le.isDocumentEdited()})),Q=[];return N.includeAuxiliaryWindows&&Q.push(...this.b.getWindows().map(le=>({id:le.id,parentId:le.parentId,title:le.win?.getTitle()??"",filename:le.getRepresentedFilename()}))),[...Z,...Q]}async getWindowCount(F){return this.a.getWindowCount()}async getActiveWindowId(F){const N=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(N)return N.id}openWindow(F,N,Z){return Array.isArray(N)?this.t(F,N,Z):this.u(F,N)}async t(F,N,Z=Object.create(null)){N.length>0&&await this.a.open({context:5,contextWindowId:F,urisToOpen:N,cli:this.g.args,forceNewWindow:Z.forceNewWindow,forceReuseWindow:Z.forceReuseWindow,preferNewWindow:Z.preferNewWindow,diffMode:Z.diffMode,mergeMode:Z.mergeMode,addMode:Z.addMode,gotoLineMode:Z.gotoLineMode,noRecentEntry:Z.noRecentEntry,waitMarkerFileURI:Z.waitMarkerFileURI,remoteAuthority:Z.remoteAuthority||void 0,forceProfile:Z.forceProfile,forceTempProfile:Z.forceTempProfile})}async u(F,N){await this.a.openEmptyWindow({context:5,contextWindowId:F},N)}async toggleFullScreen(F,N){this.D(N?.targetWindowId,F)?.toggleFullScreen()}async handleTitleDoubleClick(F,N){this.D(N?.targetWindowId,F)?.handleTitleDoubleClick()}async getCursorScreenPoint(F){const N=R.screen.getCursorScreenPoint(),Z=R.screen.getDisplayNearestPoint(N);return{point:N,display:Z.bounds}}async isMaximized(F,N){return this.D(N?.targetWindowId,F)?.win?.isMaximized()??!1}async maximizeWindow(F,N){this.D(N?.targetWindowId,F)?.win?.maximize()}async unmaximizeWindow(F,N){this.D(N?.targetWindowId,F)?.win?.unmaximize()}async minimizeWindow(F,N){this.D(N?.targetWindowId,F)?.win?.minimize()}async moveWindowTop(F,N){this.D(N?.targetWindowId,F)?.win?.moveTop()}async positionWindow(F,N,Z){const Q=this.D(Z?.targetWindowId,F);if(Q?.win){if(Q.win.isFullScreen()){const le=E.Event.toPromise(E.Event.once(E.Event.fromNodeEventEmitter(Q.win,"leave-full-screen")));Q.win.setFullScreen(!1),await le}Q.win.setBounds(N)}}async updateWindowControls(F,N){this.D(N?.targetWindowId,F)?.updateWindowControls(N)}async focusWindow(F,N){this.D(N?.targetWindowId,F)?.focus({force:N?.force??!1})}async setMinimumSize(F,N,Z){const Q=this.F(F);if(Q?.win){const[le,ce]=Q.win.getSize(),[ue,X]=Q.win.getMinimumSize(),[K,H]=[N??ue,Z??X],[L,T]=[Math.max(le,K),Math.max(ce,H)];(ue!==K||X!==H)&&Q.win.setMinimumSize(K,H),(le!==L||ce!==T)&&Q.win.setSize(L,T)}}async saveWindowSplash(F,N){this.m.saveWindowSplash(F,N)}async installShellCommand(F){const{source:N,target:Z}=await this.w();try{const{symbolicLink:Q}=await w.SymlinkSupport.stat(N);if(Q&&!Q.dangling){const le=await(0,l.$jq)(N);if(Z===le)return}await w.Promises.unlink(N)}catch(Q){if(Q.code!=="ENOENT")throw Q}try{await w.Promises.symlink(Z,N)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="ENOENT")throw Q;const{response:le}=await this.showMessageBox(F,{type:"info",message:(0,g.localize)(0,null,this.j.nameShort),buttons:[(0,g.localize)(1,null),(0,g.localize)(2,null)]});if(le===0)try{const ce=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${Z}' '${N}'\\" with administrator privileges"`;await(0,j.promisify)(P.exec)(ce)}catch{throw new Error((0,g.localize)(3,null,N))}}}async uninstallShellCommand(F){const{source:N}=await this.w();try{await w.Promises.unlink(N)}catch(Z){switch(Z.code){case"EACCES":{const{response:Q}=await this.showMessageBox(F,{type:"info",message:(0,g.localize)(4,null,this.j.nameShort),buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null)]});if(Q===0)try{const le=`osascript -e "do shell script \\"rm '${N}'\\" with administrator privileges"`;await(0,j.promisify)(P.exec)(le)}catch{throw new Error((0,g.localize)(7,null,N))}break}case"ENOENT":break;default:throw Z}}}async w(){const F=(0,y.$kc)(this.g.appRoot,"bin","code"),N=`/usr/local/bin/${this.j.applicationName}`;if(!await w.Promises.exists(F))throw new Error((0,g.localize)(8,null,F));return{source:N,target:F}}async showMessageBox(F,N){const Z=this.H(F);return this.c.showMessageBox(N,Z?.win??void 0)}async showSaveDialog(F,N){const Z=this.H(F);return this.c.showSaveDialog(N,Z?.win??void 0)}async showOpenDialog(F,N){const Z=this.H(F);return this.c.showOpenDialog(N,Z?.win??void 0)}async pickFileFolderAndOpen(F,N){const Z=await this.c.pickFileFolder(N);Z&&await this.z(await Promise.all(Z.map(async Q=>await w.SymlinkSupport.existsDirectory(Q)?{folderUri:b.URI.file(Q)}:{fileUri:b.URI.file(Q)})),N,F)}async pickFolderAndOpen(F,N){const Z=await this.c.pickFolder(N);Z&&await this.z(Z.map(Q=>({folderUri:b.URI.file(Q)})),N,F)}async pickFileAndOpen(F,N){const Z=await this.c.pickFile(N);Z&&await this.z(Z.map(Q=>({fileUri:b.URI.file(Q)})),N,F)}async pickWorkspaceAndOpen(F,N){const Z=await this.c.pickWorkspace(N);Z&&await this.z(Z.map(Q=>({workspaceUri:b.URI.file(Q)})),N,F)}async z(F,N,Z){await this.a.open({context:3,contextWindowId:Z,cli:this.g.args,urisToOpen:F,forceNewWindow:N.forceNewWindow})}async showItemInFolder(F,N){R.shell.showItemInFolder(N)}async setRepresentedFilename(F,N,Z){this.D(Z?.targetWindowId,F)?.setRepresentedFilename(N)}async setDocumentEdited(F,N,Z){this.D(Z?.targetWindowId,F)?.setDocumentEdited(N)}async openExternal(F,N){return this.g.unsetSnapExportedVariables(),R.shell.openExternal(N),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(F,N){return R.shell.trashItem(N)}async isAdmin(){let F;return v.$i?F=(await new Promise((N,Z)=>{J(["native-is-elevated"],N,Z)}))():F=process.getuid?.()===0,F}async writeElevated(F,N,Z,Q){const le=await new Promise((ce,ue)=>{J(["@vscode/sudo-prompt"],ce,ue)});return new Promise((ce,ue)=>{const X=[`"${this.C}"`];Q?.unlock&&X.push("--file-chmod"),X.push("--file-write",`"${N.fsPath}"`,`"${Z.fsPath}"`);const K={name:this.j.nameLong.replace("-",""),icns:v.$j&&this.g.isBuilt?(0,y.$jc)((0,y.$mc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};le.exec(X.join(" "),K,(H,L,T)=>{L&&this.h.trace(`[sudo-prompt] received stdout: ${L}`),T&&this.h.trace(`[sudo-prompt] received stderr: ${T}`),H?ue(H):ce(void 0)})})}async isRunningUnderARM64Translation(){return v.$k||v.$i?!1:R.app.runningUnderARM64Translation}get C(){return v.$i?this.g.isBuilt?(0,y.$jc)((0,y.$mc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,y.$jc)(this.g.appRoot,"scripts","code-cli.bat"):v.$k?this.g.isBuilt?(0,y.$jc)((0,y.$mc)(process.execPath),"bin",`${this.j.applicationName}`):(0,y.$jc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,y.$jc)(this.g.appRoot,"bin","code"):(0,y.$jc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return p.$7m.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return v.$i&&(0,D.$b0b)()}async killProcess(F,N,Z){process.kill(N,Z)}async readClipboardText(F,N){return R.clipboard.readText(N)}async writeClipboardText(F,N,Z){return R.clipboard.writeText(N,Z)}async readClipboardFindText(F){return R.clipboard.readFindText()}async writeClipboardFindText(F,N){return R.clipboard.writeFindText(N)}async writeClipboardBuffer(F,N,Z,Q){return R.clipboard.writeBuffer(N,Buffer.from(Z.buffer),Q)}async readClipboardBuffer(F,N){return m.$ge.wrap(R.clipboard.readBuffer(N))}async hasClipboard(F,N,Z){return R.clipboard.has(N,Z)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){R.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){R.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){R.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){R.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){R.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(F,N){this.F(F)?.updateTouchBar(N)}async notifyReady(F){this.F(F)?.setReady()}async relaunch(F,N){return this.f.relaunch(N)}async reload(F,N){const Z=this.F(F);if(Z){if((0,n.$fi)(Z.openedWorkspace)){const Q=Z.openedWorkspace.configPath;if(Q.scheme===h.Schemas.file&&(await this.n.resolveLocalWorkspace(Q))?.transient)return this.openWindow(Z.id,{forceReuseWindow:!0})}return this.f.reload(Z,N?.disableExtensions!==void 0?{_:[],"disable-extensions":N.disableExtensions}:void 0)}}async closeWindow(F,N){return this.D(N?.targetWindowId,F)?.win?.close()}async quit(F){const N=this.a.getLastActiveWindow();N?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&N.win?N.win.close():this.f.quit()}async exit(F,N){await this.f.kill(N)}async resolveProxy(F,N){return this.F(F)?.win?.webContents?.session?.resolveProxy(N)}async loadCertificates(F){return(await new Promise((Z,Q)=>{J(["@vscode/proxy-agent"],Z,Q)})).loadSystemCertificates({log:this.h})}findFreePort(F,N,Z,Q,le=1){return(0,$.$pg)(N,Z,Q,le)}async openDevTools(F,N){this.H(F)?.win?.webContents.openDevTools(N)}async toggleDevTools(F){this.H(F)?.win?.webContents.toggleDevTools()}async profileRenderer(F,N,Z){const Q=this.F(F);if(!Q||!Q.win)throw new Error;return await new I.$c0b(Q.win,N,this.h).inspect(Z)}async windowsGetStringRegKey(F,N,Z,Q){if(!v.$i)return;const le=await new Promise((ce,ue)=>{J(["@vscode/windows-registry"],ce,ue)});try{return le.GetStringRegKey(N,Z,Q)}catch{return}}D(F,N){return this.F(F)??this.G(F)??this.F(N)}F(F){if(typeof F=="number")return this.a.getWindowById(F)}G(F){if(typeof F=="number")return this.b.getWindowById(F)}H(F){let N=this.r.invokeFunction(i.$T9b);return N||(N=this.D(F)),N}};e.$e0b=C,Ee([A.$uh],C.prototype,"C",null),e.$e0b=C=Ee([ne(0,i.$R9b),ne(1,k.$P9b),ne(2,u.$y9b),ne(3,d.$g9b),ne(4,c.$e9b),ne(5,t.$kj),ne(6,o.$Cj),ne(7,r.$s9b),ne(8,a.$I9b),ne(9,S.$2h)],C)}),define(re[299],oe([0,1,15,26,8,22,33,2,13,4,7,107,36,180,91,132,54,24,5,71,79,27,80,34,61,60,29]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p,w,$,g,u,c,S,d,t,o,r,i,n){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$f0b=void 0;const m="issue.processExplorerWindowState";let D=class{static{a=this}static{this.a="#1E1E1E"}constructor(C,M,F,N,Z,Q,le,ce,ue,X,K){this.g=C,this.h=M,this.i=F,this.j=N,this.k=Z,this.l=Q,this.m=le,this.n=ce,this.o=ue,this.p=X,this.q=K,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){b.$jU.on("vscode:listProcesses",async C=>{const M=[];try{M.push({name:(0,l.localize)(0,null),rootProcess:await(0,v.$Rr)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(N=>{(0,p.$Gm)(N)?M.push({name:N.hostName,rootProcess:N}):N.processes&&M.push({name:N.hostName,rootProcess:N.processes})})}catch(F){this.i.error(`Listing processes failed: ${F}`)}this.t(C,"vscode:listProcessesResponse",M)}),b.$jU.on("vscode:workbenchCommand",(C,M)=>{const{id:F,from:N,args:Z}=M;let Q;switch(N){case"processExplorer":Q=this.f;break;default:throw new Error(`Unexpected command source: ${N}`)}Q?.webContents.send("vscode:runAction",{id:F,from:N,args:Z})}),b.$jU.on("vscode:closeProcessExplorer",C=>{this.d?.close()}),b.$jU.on("vscode:pidToNameRequest",async C=>{const M=await this.k.getMainDiagnostics(),F=[];for(const N of M.windows)F.push([N.pid,`window [${N.id}] (${N.title})`]);for(const{pid:N,name:Z}of r.$Y9b.getAll())F.push([N,Z]);this.t(C,"vscode:pidToNameResponse",F)})}async openReporter(C){if(!this.b&&(this.c=P.BrowserWindow.getFocusedWindow(),this.c)){const M=new E.$Rc,F=M.add(this.n.createIPCObjectUrl()),N=this.v(this.c,700,800);this.b=this.u(N,F,{backgroundColor:C.styles.backgroundColor,title:(0,l.localize)(1,null),zoomLevel:C.zoomLevel,alwaysOnTop:!1},"issue-reporter"),F.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:C,disableExtensions:!!this.h.disableExtensions,os:{type:(0,R.type)(),arch:(0,R.arch)(),release:(0,R.release)()},product:S.default}),this.b.loadURL(f.$lg.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,M.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,M.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(C){if(!this.d&&(this.f=P.BrowserWindow.getFocusedWindow(),this.f)){const M=new E.$Rc,F=M.add(this.n.createIPCObjectUrl()),N=this.p.getItem(m,void 0),Z=I(N)?N:this.v(this.f,800,500);this.d=this.u(Z,F,{backgroundColor:C.styles.backgroundColor,title:(0,l.localize)(2,null),zoomLevel:C.zoomLevel,alwaysOnTop:!0},"process-explorer"),F.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:C,product:S.default}),this.d.loadURL(f.$lg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,M.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,M.dispose())});const Q=()=>{if(!this.d)return;const le=this.d.getSize(),ce=this.d.getPosition();if(!le||!ce)return;const ue={width:le[0],height:le[1],x:ce[0],y:ce[1]};this.p.setItem(m,ue)};this.d.on("moved",Q),this.d.on("resized",Q)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const C=await P.contentTracing.stopRecording(`${(0,A.$ag)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,l.localize)(3,null),detail:(0,l.localize)(4,null,C),buttons:[(0,l.localize)(5,null)]},P.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,C)}async getSystemStatus(){const[C,M]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(C,M)}async $getSystemInfo(){const[C,M]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(C,M)}async $getPerformanceInfo(){try{const[C,M]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(C,M)}catch(C){throw this.i.warn("issueService#getPerformanceInfo ",C.message),C}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(C){this.i.error(C)}}async $showConfirmCloseDialog(){if(this.b){const{response:C}=await this.l.showMessageBox({type:"warning",message:(0,l.localize)(6,null),buttons:[(0,l.localize)(7,null),(0,l.localize)(8,null)]},this.b);C===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:C}=await this.l.showMessageBox({type:"warning",message:(0,l.localize)(9,null),buttons:[(0,l.localize)(10,null),(0,l.localize)(11,null)]},this.b);return C===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const C=this.q.getWindowById(this.c.id);if(!C)throw new Error("Window not found");return C}async $getIssueReporterUri(C){const M=this.issueReporterWindowCheck(),F=`vscode:triggerIssueUriRequestHandlerResponse${M.id}`;return s.Promises.withAsyncBody(async(N,Z)=>{const Q=new j.$3d;M.sendWhenReady("vscode:triggerIssueUriRequestHandler",Q.token,{replyChannel:F,extensionId:C}),b.$jU.once(F,(le,ce)=>{N(y.URI.parse(ce))});try{await(0,s.$4g)(5e3),Q.cancel(),Z(new Error("Timed out waiting for issue reporter URI"))}finally{b.$jU.removeHandler(F)}})}async $getIssueReporterData(C){const M=this.issueReporterWindowCheck(),F=`vscode:triggerIssueDataProviderResponse${M.id}`;return s.Promises.withAsyncBody(async N=>{const Z=new j.$3d;M.sendWhenReady("vscode:triggerIssueDataProvider",Z.token,{replyChannel:F,extensionId:C}),b.$jU.once(F,(Q,le)=>{N(le)});try{await(0,s.$4g)(5e3),Z.cancel(),N("Error: Extension timed out waiting for issue reporter data")}finally{b.$jU.removeHandler(F)}})}async $getIssueReporterTemplate(C){const M=this.issueReporterWindowCheck(),F=`vscode:triggerIssueDataTemplateResponse${M.id}`;return s.Promises.withAsyncBody(async N=>{const Z=new j.$3d;M.sendWhenReady("vscode:triggerIssueDataTemplate",Z.token,{replyChannel:F,extensionId:C}),b.$jU.once(F,(Q,le)=>{N(le)});try{await(0,s.$4g)(5e3),Z.cancel(),N("Error: Extension timed out waiting for issue reporter template")}finally{b.$jU.removeHandler(F)}})}async $getReporterStatus(C,M){const F=[!1,!1],N=this.issueReporterWindowCheck(),Z="vscode:triggerReporterStatus",Q=new j.$3d;return N.sendWhenReady(Z,Q.token,{replyChannel:Z,extensionId:C,extensionName:M}),await(0,s.$Ug)(new Promise(ce=>b.$jU.once("vscode:triggerReporterStatusResponse",(ue,X)=>ce(X))),2e3,()=>{this.i.error("Error: Extension timed out waiting for reporter status"),Q.cancel()})??F}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(C){C.isMinimized()&&C.restore(),C.focus()}t(C,M,...F){C.sender.isDestroyed()||C.sender.send(M,...F)}u(C,M,F,N){const Z=new P.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:C.width,height:C.height,minWidth:300,minHeight:200,x:C.x,y:C.y,title:F.title,backgroundColor:F.backgroundColor||a.a,webPreferences:{preload:f.$lg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${M.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,i.$IC)(F.zoomLevel),sandbox:!0},alwaysOnTop:F.alwaysOnTop,experimentalDarkMode:!0});return Z.setMenuBarVisibility(!1),Z}v(C,M,F){let N;const Z=P.screen.getAllDisplays();if(Z.length===1)N=Z[0];else{if(h.$j){const ce=P.screen.getCursorScreenPoint();N=P.screen.getDisplayNearestPoint(ce)}!N&&C&&(N=P.screen.getDisplayMatching(C.getBounds())),N||(N=P.screen.getPrimaryDisplay()||Z[0])}const Q=N.bounds,le={width:M,height:F,x:Q.x+Q.width/2-M/2,y:Q.y+Q.height/2-F/2};return Q.width>0&&Q.height>0&&(le.x<Q.x&&(le.x=Q.x),le.y<Q.y&&(le.y=Q.y),le.x>Q.x+Q.width&&(le.x=Q.x),le.y>Q.y+Q.height&&(le.y=Q.y),le.width>Q.width&&(le.width=Q.width),le.height>Q.height&&(le.height=Q.height)),le}};e.$f0b=D,e.$f0b=D=a=Ee([ne(1,g.$e9b),ne(2,u.$kj),ne(3,p.$Fm),ne(4,w.$29b),ne(5,$.$y9b),ne(6,c.$d0b),ne(7,t.$A9b),ne(8,d.$Cj),ne(9,o.$0N),ne(10,n.$R9b)],D);function I(k){return typeof k!="object"||k===null?!1:"x"in k&&"y"in k&&"width"in k&&"height"in k}}),define(re[300],oe([0,1,22,17,24,20,5,71,27,52,28,49,100]),function(J,e,P,R,s,j,A,E,f,h,y,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G0b=void 0;let l=class extends b.$E0b{constructor(w,$,g,u,c,S,d,t){super(w,$,u,c,S,t),this.e=g,this.u=d}s(w){return(0,b.$D0b)(`linux-${process.arch}`,w,this.k)}t(w){this.a&&(this.d(v.$hV.CheckingForUpdates(w)),this.i.request({url:this.a},P.CancellationToken.None).then(h.$bp).then($=>{!$||!$.url||!$.version||!$.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!w}),this.d(v.$hV.Idle(1))):this.d(v.$hV.AvailableForDownload($))}).then(void 0,$=>{this.j.error($);const g=w?$.message||$:void 0;this.d(v.$hV.Idle(1,g))}))}async o(w){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):w.update.url&&this.u.openExternal(void 0,w.update.url),this.d(v.$hV.Idle(1))}};e.$G0b=l,e.$G0b=l=Ee([ne(0,j.$g9b),ne(1,R.$wi),ne(2,y.$rl),ne(3,s.$e9b),ne(4,h.$8o),ne(5,A.$kj),ne(6,E.$d0b),ne(7,f.$Cj)],l)}),define(re[301],oe([0,1,48,46,26,8,22,50,45,9,7,144,21,17,24,16,20,5,71,27,52,28,49,100]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p,w,$,g,u,c,S,d,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I0b=void 0;async function r(m,D=1e3){for(;!m();)await(0,j.$4g)(D)}let i;function n(){return typeof i>"u"&&(i=R.existsSync(h.$jc(h.$mc(process.execPath),"unins000.exe"))?0:1),i}let a=class extends o.$E0b{get cachePath(){const D=h.$jc((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return b.Promises.mkdir(D,{recursive:!0}).then(()=>D)}constructor(D,I,k,C,M,F,N,Z,Q){super(D,I,C,M,F,Q),this.u=k,this.v=N,this.w=Z,D.setRelaunchHandler(this)}handleRelaunch(D){return D?.addArgs||D?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(t.$hV.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(D){let I=`win32-${process.arch}`;return n()===1?I+="-archive":this.k.target==="user"&&(I+="-user"),(0,o.$D0b)(I,D,this.k)}t(D){this.a&&(this.d(t.$hV.CheckingForUpdates(D)),this.i.request({url:this.a},A.CancellationToken.None).then(S.$bp).then(I=>{const k=n();return!I||!I.url||!I.version||!I.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!D}),this.d(t.$hV.Idle(k)),Promise.resolve(null)):k===1?(this.d(t.$hV.AvailableForDownload(I)),Promise.resolve(null)):(this.d(t.$hV.Downloading(I)),this.C(I.version).then(()=>this.B(I.version).then(C=>b.Promises.exists(C).then(M=>{if(M)return Promise.resolve(C);const F=I.url,N=I.hash,Z=`${C}.tmp`;return this.i.request({url:F},A.CancellationToken.None).then(Q=>this.v.writeFile(y.URI.file(Z),Q.stream)).then(N?()=>(0,v.$eU)(Z,I.hash):()=>{}).then(()=>b.Promises.rename(Z,C,!1)).then(()=>C)})).then(C=>{const M=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:C},M?this.k.target==="user"?this.p():this.d(t.$hV.Downloaded(I)):this.d(t.$hV.Ready(I))})))}).then(void 0,I=>{this.u.publicLog2("update:error",{messageHash:String((0,f.$Qi)(String(I)))}),this.j.error(I);const k=D?I.message||I:void 0;this.d(t.$hV.Idle(n(),k))}))}async o(D){D.update.url&&this.w.openExternal(void 0,D.update.url),this.d(t.$hV.Idle(n()))}async B(D){const I=await this.cachePath;return h.$jc(I,`CodeSetup-${this.k.quality}-${D}.exe`)}async C(D=null){const I=D?F=>!new RegExp(`${this.k.quality}-${D}\\.exe$`).test(F):()=>!0,k=await this.cachePath,M=(await b.Promises.readdir(k)).filter(I).map(async F=>{try{await b.Promises.unlink(h.$jc(k,F))}catch{}});await Promise.all(M)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const D=this.state.update;this.d(t.$hV.Updating(D));const I=await this.cachePath;this.e.updateFilePath=h.$jc(I,`CodeSetup-${this.k.quality}-${D.version}.flag`),await b.Promises.writeFile(this.e.updateFilePath,"flag"),(0,P.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(t.$hV.Idle(n()))});const C=`${this.k.win32MutexName}-ready`,M=await new Promise((F,N)=>{J(["@vscode/windows-mutex"],F,N)});r(()=>M.isActive(C)).then(()=>this.d(t.$hV.Ready(D)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?R.unlinkSync(this.e.updateFilePath):(0,P.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return n()}async _applySpecificUpdate(D){if(this.state.type!=="idle")return;const I=this.g.getValue("update.enableWindowsBackgroundUpdates"),k={version:"unknown",productVersion:"unknown"};this.d(t.$hV.Downloading(k)),this.e={packagePath:D},I?this.k.target==="user"?this.p():this.d(t.$hV.Downloaded(k)):this.d(t.$hV.Ready(k))}};e.$I0b=a,Ee([E.$uh],a.prototype,"cachePath",null),e.$I0b=a=Ee([ne(0,$.$g9b),ne(1,l.$wi),ne(2,d.$rl),ne(3,p.$e9b),ne(4,S.$8o),ne(5,g.$kj),ne(6,w.$nk),ne(7,u.$d0b),ne(8,c.$Cj)],a)}),define(re[133],oe([0,1,15,8,22,51,3,2,13,68,4,7,190,26,66,17,54,24,64,16,20,5,27,80,252,82,28,102,70,60,29,30,56,128,39,34,55,69,23,6]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p,w,$,g,u,c,S,d,t,o,r,i,n,a,m,D,I,k,C,M,F,N,Z,Q,le,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N9b=e.$M9b=void 0;var ue;(function(H){H[H.NONE=0]="NONE",H[H.NAVIGATING=1]="NAVIGATING",H[H.READY=2]="READY"})(ue||(ue={}));class X extends E.$Sc{get lastFocusTime(){return this.g}get win(){return this.h}j(L){this.h=L,this.B(A.Event.fromNodeEventEmitter(L,"maximize")(()=>this.b.fire())),this.B(A.Event.fromNodeEventEmitter(L,"unmaximize")(()=>this.c.fire())),this.B(A.Event.fromNodeEventEmitter(L,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(A.Event.fromNodeEventEmitter(L,"focus")(()=>{this.g=Date.now()}));const T=(0,D.$FC)(this.m)==="custom";if(y.$j&&T&&L.setSheetOffset((0,y.$J)((0,l.release)())?28:22),T&&(y.$i&&(0,D.$GC)(this.m)||y.$j)){const V=this.n.getItem(X.u);V&&this.updateWindowControls({height:V})}y.$i&&T&&L.hookWindowMessage(278,()=>{const[q,te]=L.getPosition(),he=P.screen.getCursorScreenPoint(),G=he.x-q,O=he.y-te;return(()=>!(G>30&&O>=0&&O<=Math.max(L.getBounds().height*.15,35)))()||(L.setEnabled(!1),L.setEnabled(!0),this.f.fire({x:G,y:O})),0}),this.r.args["open-devtools"]===!0&&L.webContents.openDevTools()}constructor(L,T,V){super(),this.m=L,this.n=T,this.r=V,this.a=this.B(new A.$Sd),this.onDidClose=this.a.event,this.b=this.B(new A.$Sd),this.onDidMaximize=this.b.event,this.c=this.B(new A.$Sd),this.onDidUnmaximize=this.c.event,this.f=this.B(new A.$Sd),this.onDidTriggerSystemContextMenu=this.f.event,this.g=Date.now(),this.h=null,this.w=(0,D.$GC)(this.m),this.z=void 0,this.C=void 0}setRepresentedFilename(L){y.$j?this.win?.setRepresentedFilename(L):this.s=L}getRepresentedFilename(){return y.$j?this.win?.getRepresentedFilename():this.s}setDocumentEdited(L){y.$j&&this.win?.setDocumentEdited(L),this.t=L}isDocumentEdited(){return y.$j?!!this.win?.isDocumentEdited():!!this.t}focus(L){y.$j&&L?.force&&P.app.focus({steal:!0});const T=this.win;T&&(T.isMinimized()&&T.restore(),T.focus())}handleTitleDoubleClick(){const L=this.win;if(L)if(y.$j)switch(P.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":L.minimize();break;case"None":break;case"Maximize":default:L.isMaximized()?L.unmaximize():L.maximize()}else L.isMaximized()?L.unmaximize():L.maximize()}static{this.u="windowControlHeight"}updateWindowControls(L){const T=this.win;if(T){if(L.height&&this.n.setItem(K.u,L.height),y.$i&&this.w)T.setTitleBarOverlay({color:L.backgroundColor?.trim()===""?void 0:L.backgroundColor,symbolColor:L.foregroundColor?.trim()===""?void 0:L.foregroundColor,height:L.height?L.height-1:void 0});else if(y.$j&&L.height!==void 0){const V=(L.height-15)/2;V?T.setWindowButtonPosition({x:V,y:V}):T.setWindowButtonPosition(null)}}}toggleFullScreen(){this.D(!this.isFullScreen)}D(L){(0,D.$HC)(this.m)?this.F(L):this.H(L)}get isFullScreen(){if(y.$j&&typeof this.z=="boolean")return this.z;const L=this.win,T=L?.isFullScreen(),V=L?.isSimpleFullScreen();return!!(T||V)}F(L){const T=this.win;T?.isSimpleFullScreen()&&T?.setSimpleFullScreen(!1),this.G(L)}G(L){y.$j&&(this.z=L,this.C=new R.$nh,Promise.race([this.C.p,(0,R.$4g)(1e4)]).finally(()=>{this.z=void 0})),this.win?.setFullScreen(L)}H(L){const T=this.win;T?.isFullScreen()&&this.G(!1),T?.setSimpleFullScreen(L),T?.webContents.focus()}dispose(){super.dispose(),this.h=null}}e.$M9b=X;let K=class extends X{get id(){return this.M}get backupPath(){return this.O?.backupPath}get openedWorkspace(){return this.O?.workspace}get profile(){if(!this.config)return;const L=this.db.profiles.find(T=>T.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&L?L:this.db.getProfileForWorkspace(this.config.workspace??(0,k.$ei)(this.backupPath,this.isExtensionDevelopmentHost))??this.db.defaultProfile}get remoteAuthority(){return this.O?.remoteAuthority}get config(){return this.O}get isExtensionDevelopmentHost(){return!!this.O?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.O?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.O?.debugId}constructor(L,T,V,q,te,he,G,O,U,x,z,Y,W,B,_,ae,se,$e,me,ye,Pe){super(x,ye,q),this.$=T,this.ab=V,this.bb=te,this.db=he,this.eb=G,this.fb=O,this.gb=U,this.hb=z,this.ib=Y,this.jb=W,this.kb=B,this.lb=_,this.mb=ae,this.nb=se,this.ob=$e,this.pb=me,this.I=this.B(new A.$Sd),this.onWillLoad=this.I.event,this.J=this.B(new A.$Sd),this.onDidSignalReady=this.J.event,this.L=this.B(new A.$Sd),this.onDidDestroy=this.L.event,this.R=[],this.S=[],this.U=void 0,this.W=void 0,this.X=this.B(this.ob.createIPCObjectUrl()),this.Z=!1,this.qb=0;{const[Le,ke]=this.Ab(L.state);this.P=Le,this.$.trace("window#ctor: using window state",Le);const pe=this.P.mode===0||this.P.mode===3,ee=Pe.invokeFunction(I.$S9b,this.P,{show:!pe,webPreferences:{preload:f.$lg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.X.resource.toString()}`],v8CacheOptions:this.r.useCodeCache?"bypassHeatCheck":"none"}});(0,h.mark)("code/willCreateCodeBrowserWindow"),this.h=new P.BrowserWindow(ee),(0,h.mark)("code/didCreateCodeBrowserWindow"),this.M=this.h.id,this.j(this.h);const fe=this.m.getValue("window"),ge=y.$j&&fe?.nativeTabs===!0;(y.$j||y.$i)&&ke&&(!ge||P.BrowserWindow.getAllWindows().length===1)&&[this.P.width,this.P.height,this.P.x,this.P.y].every(Ie=>typeof Ie=="number")&&this.h.setBounds({width:this.P.width,height:this.P.height,x:this.P.x,y:this.P.y}),pe&&((0,h.mark)("code/willMaximizeCodeWindow"),this.h.maximize(),this.P.mode===3&&this.D(!0),this.h.show(),(0,h.mark)("code/didMaximizeCodeWindow")),this.g=Date.now()}this.xb(),this.Hb(),this.rb()}setReady(){for(this.$.trace(`window#load: window reported ready (id: ${this.M})`),this.qb=2;this.R.length;)this.R.pop()(this);this.J.fire()}ready(){return new Promise(L=>{if(this.isReady)return L(this);this.R.push(L)})}get isReady(){return this.qb===2}get whenClosedOrLoaded(){return new Promise(L=>{function T(){V.dispose(),q.dispose(),L()}const V=this.onDidClose(()=>T()),q=this.onWillLoad(()=>T())})}rb(){this.h.on("unresponsive",()=>this.ub(1)),this.h.webContents.on("render-process-gone",(T,V)=>this.ub(2,{...V})),this.h.webContents.on("did-fail-load",(T,V,q)=>this.ub(3,{reason:q,exitCode:V})),this.h.webContents.on("will-prevent-unload",T=>{T.preventDefault()}),this.h.webContents.on("did-finish-load",()=>{this.Y&&(this.O=this.Y,this.Y=void 0)}),this.B(this.onDidMaximize(()=>{this.O&&(this.O.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.O&&(this.O.maximized=!1)})),this.B(A.Event.fromNodeEventEmitter(this.h,"enter-full-screen")(()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.C?.complete(),this.C=void 0})),this.B(A.Event.fromNodeEventEmitter(this.h,"leave-full-screen")(()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.C?.complete(),this.C=void 0})),this.B(this.m.onDidChangeConfiguration(T=>this.xb(T))),this.B(this.ib.onDidDeleteUntitledWorkspace(T=>this.wb(T)));const L=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.h.webContents.session.webRequest.onBeforeSendHeaders({urls:L},async(T,V)=>{const q=await this.tb();V({cancel:!1,requestHeaders:Object.assign(T.requestHeaders,q)})})}tb(){return this.sb||(this.sb=(0,r.$pp)(this.nb.version,this.nb,this.r,this.m,this.eb,this.fb,this.kb)),this.sb}async ub(L,T){switch(L){case 2:this.$.error(`CodeWindow: renderer process gone (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break;case 1:this.$.error("CodeWindow: detected unresponsive");break;case 3:this.$.error(`CodeWindow: failed to load (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break}switch(this.kb.publicLog2("windowerror",{type:L,reason:T?.reason,code:T?.exitCode}),L){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.mb.kill(1);return}if(this.r.args["enable-smoke-test-driver"]){await this.vb(!1,!1),this.mb.quit();return}if(L===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.h&&this.h.webContents&&this.h.webContents.isDevToolsOpened())return;const{response:V,checkboxChecked:q}=await this.lb.showMessageBox({type:"warning",buttons:[(0,b.localize)(0,null),(0,b.localize)(1,null),(0,b.localize)(2,null)],message:(0,b.localize)(3,null),detail:(0,b.localize)(4,null),checkboxLabel:this.O?.workspace?(0,b.localize)(5,null):void 0},this.h);if(V!==2){const te=V===0;await this.vb(te,q)}}else if(L===2){let V;T?V=(0,b.localize)(7,null,T.reason,T.exitCode??"<unknown>"):V=(0,b.localize)(6,null);const{response:q,checkboxChecked:te}=await this.lb.showMessageBox({type:"warning",buttons:[this.O?.workspace?(0,b.localize)(8,null):(0,b.localize)(9,null),(0,b.localize)(10,null)],message:V,detail:this.O?.workspace?(0,b.localize)(11,null):(0,b.localize)(12,null),checkboxLabel:this.O?.workspace?(0,b.localize)(13,null):void 0},this.h),he=q===0;await this.vb(he,te)}break}}async vb(L,T){const V=this.O?.workspace;if(T&&V)try{const q=this.gb.workspaceStorage(V);await q.init(),q.delete("memento/workbench.parts.editor"),await q.close()}catch(q){this.$.error(q)}this.L.fire();try{if(L&&this.O){let q,te;(0,k.$ai)(V)?q={folderUri:V.uri}:(0,k.$fi)(V)?q={workspaceUri:V.configPath}:te=!0,(0,le.$Ob)(await this.pb.open({context:5,userEnv:this.O.userEnv,cli:{...this.r.args,_:[]},urisToOpen:q?[q]:void 0,forceEmpty:te,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.h?.destroy()}}wb(L){this.O?.workspace?.id===L.id&&(this.O.workspace=void 0)}xb(L){if(!L||L.affectsConfiguration("window.menuBarVisibility")){const T=this.Eb();T!==this.Q&&(this.Q=T,this.Fb(T))}if(!L||L.affectsConfiguration("http.proxy")){let T=(this.m.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;T?.endsWith("/")&&(T=T.substr(0,T.length-1));const V=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((T||"").indexOf("@")===-1&&(T!==this.U||V!==this.W)){this.U=T,this.W=V;const q=T||"",te=V?`${V},<local>`:"<local>";this.$.trace(`Setting proxy to '${q}', bypassing '${te}'`),this.h.webContents.session.setProxy({proxyRules:q,proxyBypassRules:te,pacScript:""})}}}addTabbedWindow(L){y.$j&&L.win&&this.h.addTabbedWindow(L.win)}load(L,T=Object.create(null)){this.$.trace(`window#load: attempt to load window (id: ${this.M})`),this.isDocumentEdited()&&(!T.isReload||!this.jb.isHotExitEnabled())&&this.setDocumentEdited(!1),T.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.h.setTitle(this.nb.nameLong)),this.yb(L,T),this.qb===0?this.O=L:this.Y=L,this.qb=1,this.h.loadURL(f.$lg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.r.isBuilt?"":"-dev"}.html`).toString(!0));const V=this.Z;this.Z=!0,!this.r.isBuilt&&!this.r.extensionTestsLocationURI&&this.B(new R.$ch(()=>{this.h&&!this.h.isVisible()&&!this.h.isMinimized()&&(this.h.show(),this.focus({force:!0}),this.h.webContents.openDevTools())},1e4)).schedule(),this.I.fire({workspace:L.workspace,reason:T.isReload?3:V?2:1})}yb(L,T){const V=(this.O??this.Y)?.userEnv;if(V){const q=(0,u.$3l)(V)&&!(0,u.$3l)(L.userEnv),te=this.isExtensionDevelopmentHost;(q||te)&&(L.userEnv={...V,...L.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(L.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),T.disableExtensions!==void 0&&(L["disable-extensions"]=T.disableExtensions),L.fullscreen=this.isFullScreen,L.maximized=this.h.isMaximized(),L.partsSplash=this.hb.getWindowSplash(),(0,h.mark)("code/willOpenNewWindow"),L.perfMarks=(0,h.getMarks)(),this.X.update(L)}async reload(L){const T=Object.assign({},this.O);T.workspace=await this.zb(T),delete T.filesToOpenOrCreate,delete T.filesToDiff,delete T.filesToMerge,delete T.filesToWait,this.isExtensionDevelopmentHost&&L&&(T.verbose=L.verbose,T.debugId=L.debugId,T.extensionEnvironment=L.extensionEnvironment,T["inspect-extensions"]=L["inspect-extensions"],T["inspect-brk-extensions"]=L["inspect-brk-extensions"],T["extensions-dir"]=L["extensions-dir"]),T.accessibilitySupport=P.app.isAccessibilitySupportEnabled(),T.isInitialStartup=!1,T.policiesData=this.bb.serialize(),T.continueOn=this.r.continueOn,T.profiles={all:this.db.profiles,profile:this.profile||this.db.defaultProfile,home:this.db.profilesHome},T.logLevel=this.ab.getLogLevel(),T.loggers={window:this.ab.getRegisteredLoggers(this.id),global:this.ab.getRegisteredLoggers()},this.load(T,{isReload:!0,disableExtensions:L?.["disable-extensions"]})}async zb(L){if((0,k.$fi)(L.workspace)){const T=L.workspace.configPath;if(T.scheme===f.Schemas.file&&!await this.eb.exists(T))return}else if((0,k.$ai)(L.workspace)){const T=L.workspace.uri;if(T.scheme===f.Schemas.file&&!await this.eb.exists(T))return}return L.workspace}serializeWindowState(){if(!this.h)return(0,M.$d9b)();if(this.isFullScreen){let V;try{V=P.screen.getDisplayMatching(this.getBounds())}catch{}const q=(0,M.$d9b)();return{mode:3,display:V?V.id:void 0,width:this.P.width||q.width,height:this.P.height||q.height,x:this.P.x||0,y:this.P.y||0}}const L=Object.create(null);let T;if(!y.$j&&this.h.isMaximized()?T=0:T=1,T===0?L.mode=0:L.mode=1,T===1||T===0){let V;T===1?V=this.getBounds():V=this.h.getNormalBounds(),L.x=V.x,L.y=V.y,L.width=V.width,L.height=V.height}return L}Ab(L){(0,h.mark)("code/willRestoreCodeWindowState");let T=!1;if(L)try{const V=P.screen.getAllDisplays();T=V.length>1,L=this.Bb(L,V)}catch(V){this.$.warn(`Unexpected error validating window state: ${V}
${V.stack}`)}return(0,h.mark)("code/didRestoreCodeWindowState"),[L||(0,M.$d9b)(),T]}Bb(L,T){if(this.$.trace(`window#validateWindowState: validating window state on ${T.length} display(s)`,L),typeof L.x!="number"||typeof L.y!="number"||typeof L.width!="number"||typeof L.height!="number"){this.$.trace("window#validateWindowState: unexpected type of state values");return}if(L.width<=0||L.height<=0){this.$.trace("window#validateWindowState: unexpected negative values");return}if(T.length===1){const te=this.Cb(T[0]);if(te){let he=function(){!L||typeof L.x!="number"||typeof L.y!="number"||!te||(L.x<te.x&&(L.x=te.x),L.y<te.y&&(L.y=te.y))};this.$.trace("window#validateWindowState: 1 monitor working area",te),he(),L.width>te.width&&(L.width=te.width),L.height>te.height&&(L.height=te.height),L.x>te.x+te.width-128&&(L.x=te.x+te.width-L.width),L.y>te.y+te.height-128&&(L.y=te.y+te.height-L.height),he()}return L}if(L.display&&L.mode===3){const te=T.find(he=>he.id===L.display);if(te&&typeof te.bounds?.x=="number"&&typeof te.bounds?.y=="number"){this.$.trace("window#validateWindowState: restoring fullscreen to previous display");const he=(0,M.$d9b)(3);return he.x=te.bounds.x,he.y=te.bounds.y,he}}let V,q;try{V=P.screen.getDisplayMatching({x:L.x,y:L.y,width:L.width,height:L.height}),q=this.Cb(V)}catch{}if(V&&q&&L.x+L.width>q.x&&L.y+L.height>q.y&&L.x<q.x+q.width&&L.y<q.y+q.height)return this.$.trace("window#validateWindowState: multi-monitor working area",q),L}Cb(L){if(L.workArea.width>0&&L.workArea.height>0)return L.workArea;if(L.bounds.width>0&&L.bounds.height>0)return L.bounds}getBounds(){const[L,T]=this.h.getPosition(),[V,q]=this.h.getSize();return{x:L,y:T,width:V,height:q}}D(L){super.D(L),this.sendWhenReady(L?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.Q&&this.Fb(this.Q,!1)}Eb(){let L=(0,D.$EC)(this.m);return["visible","toggle","hidden"].indexOf(L)<0&&(L="classic"),L}Fb(L,T=!0){y.$j||(L==="toggle"&&T&&this.send("vscode:showInfoMessage",(0,b.localize)(14,null)),L==="hidden"?setTimeout(()=>{this.Gb(L)}):this.Gb(L))}Gb(L){const T=this.isFullScreen;switch(L){case"classic":this.h.setMenuBarVisibility(!T),this.h.autoHideMenuBar=T;break;case"visible":this.h.setMenuBarVisibility(!0),this.h.autoHideMenuBar=!1;break;case"toggle":this.h.setMenuBarVisibility(!1),this.h.autoHideMenuBar=!0;break;case"hidden":this.h.setMenuBarVisibility(!1),this.h.autoHideMenuBar=!1;break}}close(){this.h?.close()}sendWhenReady(L,T,...V){this.isReady?this.send(L,...V):this.ready().then(()=>{T.isCancellationRequested||this.send(L,...V)})}send(L,...T){if(this.h){if(this.h.isDestroyed()||this.h.webContents.isDestroyed()){this.$.warn(`Sending IPC message to channel '${L}' for window that is destroyed`);return}try{this.h.webContents.send(L,...T)}catch(V){this.$.warn(`Error sending IPC message to channel '${L}' of window ${this.M}: ${(0,j.$Ni)(V)}`)}}}updateTouchBar(L){y.$j&&this.S.forEach((T,V)=>{const q=L[V];T.segments=this.Jb(q)})}Hb(){if(y.$j){for(let L=0;L<10;L++){const T=this.Ib();this.S.push(T)}this.h.setTouchBar(new P.TouchBar({items:this.S}))}}Ib(L=[]){const T=this.Jb(L),V=new P.TouchBar.TouchBarSegmentedControl({segments:T,mode:"buttons",segmentStyle:"automatic",change:q=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:V.segments[q].id,from:"touchbar"})}});return V}Jb(L=[]){return L.map(V=>{let q;V.icon&&!a.ThemeIcon.isThemeIcon(V.icon)&&V.icon?.dark?.scheme===f.Schemas.file&&(q=P.nativeImage.createFromPath(v.URI.revive(V.icon.dark).fsPath),q.isEmpty()&&(q=void 0));let te;return typeof V.title=="string"?te=V.title:te=V.title.value,{id:V.id,label:q?void 0:te,icon:q}})}dispose(){super.dispose(),this.ab.deregisterLoggers(this.id)}};e.$N9b=K,e.$N9b=K=Ee([ne(1,d.$kj),ne(2,Q.$K9b),ne(3,g.$e9b),ne(4,F.$xn),ne(5,Z.$m9b),ne(6,c.$nk),ne(7,i.$q9b),ne(8,i.$o9b),ne(9,w.$wi),ne(10,m.$s9b),ne(11,C.$I9b),ne(12,p.$x9b),ne(13,n.$rl),ne(14,$.$y9b),ne(15,S.$g9b),ne(16,t.$Cj),ne(17,o.$A9b),ne(18,I.$R9b),ne(19,N.$0N),ne(20,ce.$2h)],K)}),define(re[302],oe([0,1,15,17,24,5,34,133]),function(J,e,P,R,s,j,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O9b=void 0;let f=class extends E.$M9b{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(y,v,b,l,p){super(l,p,v),this.I=y,this.J=b,this.id=this.I.id,this.parentId=-1,y.removeAllListeners("devtools-reload-page"),this.tryClaimWindow()}tryClaimWindow(){if(this.h||this.q.isDisposed||this.I.isDestroyed())return;const y=P.BrowserWindow.fromWebContents(this.I);y&&(this.J.trace("[aux window] Claimed browser window instance"),this.j(y),y.setMenu(null))}};e.$O9b=f,e.$O9b=f=Ee([ne(1,s.$e9b),ne(2,j.$kj),ne(3,R.$wi),ne(4,A.$0N)],f)}),define(re[303],oe([0,1,15,3,2,13,36,302,6,5,29]),function(J,e,P,R,s,j,A,E,f,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b$b=void 0;let v=class extends s.$Sc{constructor(l,p){super(),this.g=l,this.h=p,this.a=this.B(new R.$Sd),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new R.$Sd),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new R.$Sd),this.onDidTriggerSystemContextMenu=this.c.event,this.f=new Map,this.j()}j(){P.app.on("browser-window-created",(l,p)=>{const w=this.getWindowById(p.id);w&&(this.h.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),w.tryClaimWindow())}),A.$jU.handle("vscode:registerAuxiliaryWindow",async(l,p)=>{const w=this.getWindowById(l.sender.id);return w&&(this.h.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),w.parentId=p),l.sender.id})}createWindow(){return this.g.invokeFunction(y.$S9b,void 0,{webPreferences:{preload:j.$lg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath}})}registerWindow(l){const p=new s.$Rc,w=this.g.createInstance(E.$O9b,l);this.f.set(w.id,w),p.add((0,s.$Qc)(()=>this.f.delete(w.id))),p.add(w.onDidMaximize(()=>this.a.fire(w))),p.add(w.onDidUnmaximize(()=>this.b.fire(w))),p.add(w.onDidTriggerSystemContextMenu(({x:$,y:g})=>this.c.fire({window:w,x:$,y:g}))),R.Event.once(w.onDidClose)(()=>p.dispose())}getWindowById(l){return this.f.get(l)}getFocusedWindow(){const l=P.BrowserWindow.getFocusedWindow();if(l)return this.getWindowById(l.id)}getLastActiveWindow(){return(0,y.$U9b)(Array.from(this.f.values()))}getWindows(){return Array.from(this.f.values())}};e.$b$b=v,e.$b$b=v=Ee([ne(0,f.$2h),ne(1,h.$kj)],v)}),define(re[83],oe([0,1,15,23,8,3,47,2,13,4,19,7,21,193,6,20,5,82,97,30,56,31,54]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p,w,$,g,u,c,S,d,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$q0b=e.$p0b=void 0,e.$p0b=(0,p.$3h)("workspacesHistoryMainService");let r=class extends E.$Sc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(n,a,m,D,I){super(),this.f=n,this.g=a,this.h=m,this.j=D,this.m=I,this.c=this.B(new j.$Sd),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new s.$1g(800)),this.n()}n(){this.h.when(4).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let a=[],m=[];for(const I of n)if((0,u.$hcb)(I))!this.g.isUntitledWorkspace(I.workspace)&&!this.w(a,I.workspace)&&a.push(I);else if((0,u.$icb)(I))this.y(a,I.folderUri)||a.push(I);else{const k=this.z(m,I.fileUri),C=I.fileUri.scheme===f.Schemas.file&&o.G.indexOf((0,y.$Bg)(I.fileUri))>=0;!k&&!C&&(m.push(I),h.$i&&I.fileUri.scheme===f.Schemas.file&&P.app.addRecentDocument(I.fileUri.fsPath))}const D=await this.r({workspaces:a,files:m});a=D.workspaces,m=D.files,a.length>o.a&&(a.length=o.a),m.length>o.a&&(m.length=o.a),await this.t({workspaces:a,files:m}),this.c.fire(),h.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(n){const a=k=>{const C=this.u(k);for(const M of n)if(y.$vg.isEqual(M,C))return!1;return!0},m=await this.getRecentlyOpened(),D=m.workspaces.filter(a),I=m.files.filter(a);(D.length!==m.workspaces.length||I.length!==m.files.length)&&(await this.t({files:I,workspaces:D}),this.c.fire(),h.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(n){if(n?.confirm){const{response:a}=await this.m.showMessageBox({type:"warning",buttons:[(0,l.localize)(0,null),(0,l.localize)(1,null)],message:(0,l.localize)(2,null),detail:(0,l.localize)(3,null),cancelId:1});if(a!==0)return}await this.t({workspaces:[],files:[]}),P.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(n){const a=new d.$Ac(I=>y.$vg.getComparisonKey(I));if(n?.workspaces)for(const I of n.workspaces)a.set(this.u(I),I);const m=new d.$Ac(I=>y.$vg.getComparisonKey(I));if(n?.files)for(const I of n.files)m.set(this.u(I),I);const D=await this.s();for(const I of D.workspaces){const k=a.get(this.u(I));k?k.label=k.label??I.label:a.set(this.u(I),I)}for(const I of D.files){const k=m.get(this.u(I));k?k.label=k.label??I.label:m.set(this.u(I),I)}return{workspaces:[...a.values()],files:[...m.values()]}}async s(){await this.j.whenReady;let n;const a=this.j.get(o.b,-1);if(typeof a=="string")try{n=JSON.parse(a)}catch(m){this.f.error("Unexpected error parsing opened paths list",m)}return(0,u.$ocb)(n,this.f)}async t(n){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,u.$pcb)(n)),-1,1)}u(n){return(0,u.$icb)(n)?n.folderUri:(0,u.$jcb)(n)?n.fileUri:n.workspace.configPath}w(n,a){return!!n.find(m=>(0,u.$hcb)(m)&&m.workspace.id===a.id)}y(n,a){return!!n.find(m=>(0,u.$icb)(m)&&y.$vg.isEqual(m.folderUri,a))}z(n,a){return!!n.find(m=>y.$vg.isEqual(m.fileUri,a))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG"]}async I(){h.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!h.$i)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,l.localize)(4,null),description:(0,l.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const a=[];for(const I of P.app.getJumpListSettings().removedItems){const k=I.args;if(k){const C=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(k);C&&a.push(v.URI.parse(C[2]))}}await this.removeRecentlyOpened(a);let m=!1;const D=(0,R.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(I=>{const k=(0,u.$hcb)(I)?I.workspace:I.folderUri,{title:C,description:M}=this.L(k,I.label);let F;return v.URI.isUri(k)?F=`--folder-uri "${k.toString()}"`:(m=!0,F=`--file-uri "${k.configPath.toString()}"`),{type:"task",title:C.substr(0,255),description:M.substr(0,255),program:process.execPath,args:F,iconPath:"explorer.exe",iconIndex:0}}));D.length>0&&n.push({type:"custom",name:m?(0,l.localize)(6,null):(0,l.localize)(7,null),items:D})}n.push({type:"recent"});try{const a=P.app.setJumpList(n);a&&a!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${a}`)}catch(a){this.f.warn("updateWindowsJumpList#setJumpList",a)}}L(n,a){if(a)return{title:(0,A.$Rv)(a).name,description:a};if(v.URI.isUri(n))return{title:(0,y.$Bg)(n),description:this.M(n)};if(this.g.isUntitledWorkspace(n))return{title:(0,l.localize)(8,null),description:""};let m=(0,y.$Bg)(n.configPath);return m.endsWith(c.$mi)&&(m=m.substr(0,m.length-c.$mi.length-1)),{title:(0,l.localize)(9,null,m),description:this.M(n.configPath)}}M(n){return n.scheme==="file"?(0,A.$Jv)(n.fsPath):n.toString()}async N(){if(!h.$j)return;P.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),a=[];let m=0;for(let I=0;I<n.workspaces.length&&m<o.C;I++){const k=this.u(n.workspaces[I]);if(k.scheme===f.Schemas.file){const C=(0,y.$sg)(k);await b.Promises.exists(C)&&(a.push(C),m++)}}const D=[];for(let I=0;I<n.files.length&&m<o.D;I++){const k=this.u(n.files[I]);if(k.scheme===f.Schemas.file){const C=(0,y.$sg)(k);if(o.G.includes((0,y.$Bg)(k))||a.includes(C))continue;await b.Promises.exists(C)&&(D.push(C),m++)}}D.reverse().forEach(I=>P.app.addRecentDocument(I)),a.reverse().forEach(I=>P.app.addRecentDocument(I))}};e.$q0b=r,e.$q0b=r=o=Ee([ne(0,$.$kj),ne(1,S.$I9b),ne(2,w.$g9b),ne(3,g.$q9b),ne(4,t.$y9b)],r)}),define(re[304],oe([0,1,15,8,22,47,4,7,181,65,17,24,20,5,231,71,27,34,28,49,60,29,83]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p,w,$,g,u,c,S,d,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$r0b=void 0;const r="menu";let i=class{static{o=this}static{this.a="lastKnownMenubarData"}constructor(m,D,I,k,C,M,F,N,Z,Q,le,ce){this.n=m,this.o=D,this.p=I,this.q=k,this.r=C,this.s=M,this.t=F,this.u=N,this.v=Z,this.w=Q,this.x=le,this.y=ce,this.m=Object.create(null),this.g=new R.$ch(()=>this.F(),0),this.h=new R.$ch(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(A.$j||(0,S.$FC)(this.o)==="native")&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const m=this.t.getItem(o.a);m&&(m.menus&&(this.k=m.menus),m.keybindings&&(this.l=m.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(M,F,N)=>{this.Y({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.p.openEmptyWindow({context:2,contextWindowId:F?.id})},this.m["workbench.action.newWindow"]=(M,F,N)=>this.p.openEmptyWindow({context:2,contextWindowId:F?.id}),this.m["workbench.action.files.openFileFolder"]=(M,F,N)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(N),telemetryExtraData:{from:r}}),this.m["workbench.action.files.openFolder"]=(M,F,N)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(N),telemetryExtraData:{from:r}}),this.m["workbench.action.openWorkspace"]=(M,F,N)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(N),telemetryExtraData:{from:r}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened({confirm:!0});const m=this.x.youTubeUrl;m&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab(m,"openYouTubeUrl"));const D=this.x.requestFeatureUrl;D&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(D,"openUserVoiceUrl"));const I=this.x.reportIssueUrl;I&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(I,"openReportIssues"));const k=this.x.licenseUrl;k&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(A.$w){const M=k.indexOf("?")>0?"&":"?";this.ab(`${k}${M}lang=${A.$w}`,"openLicenseUrl")}else this.ab(k,"openLicenseUrl")});const C=this.x.privacyStatementUrl;C&&k&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(C,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(m=>this.G(m)),this.w.onDidBlurMainWindow(()=>this.H()),this.w.onDidFocusMainWindow(()=>this.H())}get C(){const m=this.o.getValue("window.enableMenuBarMnemonics");return typeof m!="boolean"?!0:m}get D(){if(!A.$j)return!1;const m=this.o.getValue("window.nativeTabs");return typeof m!="boolean"?!1:m}updateMenu(m,D){this.k=m.menus,this.l=m.keybindings,this.t.setItem(o.a,m),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(m){A.$j&&(m.oldCount===0&&m.newCount>0||m.oldCount>0&&m.newCount===0)&&(this.d=m.newCount===0,this.E())}H(){if(!A.$j)return;const m=P.BrowserWindow.getFocusedWindow();this.f=!m||!!this.y.getWindowById(m.id),this.E()}I(){const m=P.Menu.getApplicationMenu();if(m&&this.j.push(m),Object.keys(this.k).length===0){this.J(A.$j?new P.Menu:null);return}const D=new P.Menu;let I;if(A.$j){const C=new P.Menu;I=new P.MenuItem({label:this.x.nameShort,submenu:C}),this.K(C),D.append(I)}if(A.$j&&!this.c){this.c=!0;const C=new P.Menu;C.append(new P.MenuItem({label:this.cb(f.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),P.app.dock.setMenu(C)}if(this.M("File")){const C=new P.Menu,M=new P.MenuItem({label:this.cb(f.localize(1,null)),submenu:C});this.O(C,"File"),D.append(M)}if(this.M("Edit")){const C=new P.Menu,M=new P.MenuItem({label:this.cb(f.localize(2,null)),submenu:C});this.O(C,"Edit"),D.append(M)}if(this.M("Selection")){const C=new P.Menu,M=new P.MenuItem({label:this.cb(f.localize(3,null)),submenu:C});this.O(C,"Selection"),D.append(M)}if(this.M("View")){const C=new P.Menu,M=new P.MenuItem({label:this.cb(f.localize(4,null)),submenu:C});this.O(C,"View"),D.append(M)}if(this.M("Go")){const C=new P.Menu,M=new P.MenuItem({label:this.cb(f.localize(5,null)),submenu:C});this.O(C,"Go"),D.append(M)}if(this.M("Run")){const C=new P.Menu,M=new P.MenuItem({label:this.cb(f.localize(6,null)),submenu:C});this.O(C,"Run"),D.append(M)}if(this.M("Terminal")){const C=new P.Menu,M=new P.MenuItem({label:this.cb(f.localize(7,null)),submenu:C});this.O(C,"Terminal"),D.append(M)}let k;if(this.M("Window")){const C=new P.Menu;k=new P.MenuItem({label:this.cb(f.localize(8,null)),submenu:C,role:"window"}),this.U(C)}if(k&&D.append(k),this.M("Help")){const C=new P.Menu,M=new P.MenuItem({label:this.cb(f.localize(9,null)),submenu:C,role:"help"});this.O(C,"Help"),D.append(M)}D.items&&D.items.length>0?this.J(D):this.J(null),this.h.schedule()}J(m){if(P.Menu.setApplicationMenu(m),m)for(const D of this.y.getWindows())D.win?.setMenu(null)}K(m){const D=this.W(f.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),I=this.V();let k;if(this.M("Preferences")){const ce=new P.Menu;this.O(ce,"Preferences"),k=new P.MenuItem({label:this.cb(f.localize(11,null)),submenu:ce})}const C=new P.Menu,M=new P.MenuItem({label:f.localize(12,null),role:"services",submenu:C}),F=new P.MenuItem({label:f.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),N=new P.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Z=new P.MenuItem({label:f.localize(15,null),role:"unhide"}),Q=new P.MenuItem(this.$("workbench.action.quit",{label:f.localize(16,null,this.x.nameLong),click:async(ce,ue,X)=>{const K=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||P.BrowserWindow.getFocusedWindow()||K?.win?.isMinimized())&&await this.L(X)&&this.w.quit(void 0)}})),le=[D];le.push(...I),k&&le.push(n(),k),le.push(n(),M,n(),F,N,Z,n(),Q),le.forEach(ce=>m.append(ce))}async L(m){if(this.p.getWindowCount()===0)return!0;const D=this.o.getValue("window.confirmBeforeClose");if(D==="always"||D==="keyboardOnly"&&this.S(m)){const{response:I}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[f.localize(17,null),f.localize(18,null)],message:f.localize(19,null)});return I===0}return!0}M(m){if(!A.$j&&(0,S.$FC)(this.o)==="custom")return!1;switch(m){case"File":case"Help":if(A.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[m];case"Window":if(A.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[m]}}N(m,D){D.forEach(I=>{if((0,p.$m0b)(I))m.append(n());else if((0,p.$l0b)(I)){const k=new P.Menu,C=new P.MenuItem({label:this.cb(I.label),submenu:k});this.N(k,I.submenu.items),m.append(C)}else(0,p.$n0b)(I)?m.append(this.Q(I)):(0,p.$o0b)(I)&&(I.id==="workbench.action.showAboutDialog"&&this.P(m),A.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[I.id]?m.append(new P.MenuItem(this.$(I.id,{label:this.cb(I.label),click:this.m[I.id]}))):m.append(this.W(I.label,I.id,!1,I.checked)):m.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)):m.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)))})}O(m,D){this.k&&this.k[D]&&this.N(m,this.k[D].items)}P(m){const D=this.V();D.length&&(D.forEach(I=>m.append(I)),m.append(n()))}Q(m){const D=E.URI.revive(m.uri),I=m.id,k=I==="openRecentFile"?{fileUri:D}:I==="openRecentWorkspace"?{workspaceUri:D}:{folderUri:D};return new P.MenuItem(this.$(I,{label:m.label,click:async(C,M,F)=>{const N=this.R(F);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[k],forceNewWindow:N,gotoLineMode:!1,remoteAuthority:m.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([D])}},!1))}R(m){return!!(m&&(!A.$j&&(m.ctrlKey||m.shiftKey)||A.$j&&(m.metaKey||m.altKey)))}S(m){return!!(m.triggeredByAccelerator||m.altKey||m.ctrlKey||m.metaKey||m.shiftKey)}T(m,D,I){const k={label:this.cb(m),role:I,enabled:!0};return new P.MenuItem(this.Z(D,k))}U(m){const D=new P.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),I=new P.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),k=new P.MenuItem({label:f.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),C=this.W(f.localize(23,null),"workbench.action.switchWindow"),M=[];this.D&&(M.push(n()),M.push(this.W(f.localize(24,null),"workbench.action.newWindowTab")),M.push(this.T(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),M.push(this.T(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),M.push(this.T(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),M.push(this.T(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[D,I,n(),C,...M,n(),k].forEach(F=>m.append(F))}V(){switch(this.n.state.type){case"idle":return[new P.MenuItem({label:this.cb(f.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new P.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new P.MenuItem({label:this.cb(f.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new P.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new P.MenuItem({label:this.cb(f.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new P.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new P.MenuItem({label:this.cb(f.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W(m,D,I,k){const C=this.cb(m),M=typeof D=="function"?D:(le,ce,ue)=>{const X=le?le.userSettingsLabel:null;let K=D;Array.isArray(D)&&(K=this.R(ue)?D[1]:D[0]),X&&ue.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:X}):this.Y({type:"commandId",commandId:K})},F=typeof I=="boolean"?I:this.p.getWindowCount()>0,N=typeof k=="boolean"?k:!1,Z={label:C,click:M,enabled:F};N&&(Z.type="checkbox",Z.checked=N);let Q;return typeof D=="string"?Q=D:Array.isArray(D)&&(Q=D[0]),A.$j&&(Q==="editor.action.clipboardCutAction"?Z.role="cut":Q==="editor.action.clipboardCopyAction"?Z.role="copy":Q==="editor.action.clipboardPasteAction"&&(Z.role="paste"),Q==="undo"?Z.click=this.X(M,{inDevTools:le=>le.undo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("undo:")}):Q==="redo"?Z.click=this.X(M,{inDevTools:le=>le.redo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("redo:")}):Q==="editor.action.selectAll"&&(Z.click=this.X(M,{inDevTools:le=>le.selectAll(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("selectAll:")}))),new P.MenuItem(this.Z(Q,Z))}X(m,D){return(I,k,C)=>{const M=P.BrowserWindow.getFocusedWindow();if(!M)return D.inNoWindow();if(M.webContents.isDevToolsFocused()&&M.webContents.devToolsWebContents)return D.inDevTools(M.webContents.devToolsWebContents);m(I,k||M,C)}}Y(m){let D=P.BrowserWindow.getFocusedWindow();if(D){const k=this.y.getWindowById(D.id);k&&(D=this.p.getWindowById(k.parentId)?.win??null)}if(!D){const k=this.p.getLastActiveWindow();k?.win?.isMinimized()&&(D=k.win)}const I=D?this.p.getWindowById(D.id):void 0;if(I){if(this.v.trace("menubar#runActionInRenderer",m),A.$j&&!this.q.isBuilt&&!I.isReady&&(m.type==="commandId"&&m.commandId==="workbench.action.toggleDevTools"||m.type!=="commandId"&&m.userSettingsLabel==="alt+cmd+i"))return!1;if(m.type==="commandId"){const k={id:m.commandId,from:"menu"};I.sendWhenReady("vscode:runAction",s.CancellationToken.None,k)}else{const k={userSettingsLabel:m.userSettingsLabel};I.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,k)}return!0}else return this.v.trace("menubar#runActionInRenderer: no active window found",m),!1}Z(m,D){const I=typeof m=="string"?this.l[m]:void 0;if(I?.label){if(I.isNative!==!1)D.accelerator=I.label,D.userSettingsLabel=I.userSettingsLabel;else if(typeof D.label=="string"){const k=D.label.indexOf("[");k>=0?D.label=`${D.label.substr(0,k)} [${I.label}]`:D.label=`${D.label} [${I.label}]`}}else D.accelerator=void 0;return D}$(m,D,I=!D.accelerator){I&&(D=this.Z(m,D));const k=D.click;return D.click=(C,M,F)=>{this.bb(m),k?.(C,M,F)},D}ab(m,D){this.w.openExternal(void 0,m),this.bb(D)}bb(m){this.r.publicLog2("workbenchActionExecuted",{id:m,from:r})}cb(m){return(0,j.$Ov)(m,!this.C)}};e.$r0b=i,e.$r0b=i=o=Ee([ne(0,c.$iV),ne(1,y.$wi),ne(2,d.$R9b),ne(3,v.$e9b),ne(4,u.$rl),ne(5,t.$p0b),ne(6,g.$0N),ne(7,b.$g9b),ne(8,l.$kj),ne(9,w.$d0b),ne(10,$.$Cj),ne(11,h.$P9b)],i);function n(){return new P.MenuItem({type:"separator"})}}),define(re[305],oe([0,1,6,20,5,304]),function(J,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t0b=e.$s0b=void 0,e.$s0b=(0,P.$3h)("menubarMainService");let A=class{constructor(f,h,y){this.b=f,this.c=h,this.d=y,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(j.$r0b)}async updateMenubar(f,h){this.d.trace("menubarService#updateMenubar",f),(await this.a).updateMenu(h,f)}};e.$t0b=A,e.$t0b=A=Ee([ne(0,P.$2h),ne(1,R.$g9b),ne(2,s.$kj)],A)}),define(re[306],oe([0,1,15,21,131,26,23,22,3,33,47,2,13,9,68,4,35,19,12,7,191,66,17,54,24,16,6,20,5,79,80,59,34,60,133,29,130,298,30,98,83,56,70,39,55,69,65]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p,w,$,g,u,c,S,d,t,o,r,i,n,a,m,D,I,k,C,M,F,N,Z,Q,le,ce,ue,X,K,H,L,T,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T0b=void 0;function q(G){return(0,le.$fi)(G?.workspace)}function te(G){return(0,le.$ai)(G?.workspace)}let he=class extends v.$Sc{constructor(O,U,x,z,Y,W,B,_,ae,se,$e,me,ye,Pe,Le,ke,pe,ee,fe,ge){super(),this.r=O,this.s=U,this.t=x,this.u=z,this.w=Y,this.z=W,this.C=B,this.D=_,this.F=ae,this.G=se,this.H=$e,this.I=me,this.J=ye,this.L=Pe,this.M=Le,this.N=ke,this.O=pe,this.P=ee,this.Q=fe,this.R=ge,this.a=this.B(new f.$Sd),this.onDidOpenWindow=this.a.event,this.b=this.B(new f.$Sd),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new f.$Sd),this.onDidDestroyWindow=this.c.event,this.f=this.B(new f.$Sd),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new f.$Sd),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new f.$Sd),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new f.$Sd),this.onDidTriggerSystemContextMenu=this.j.event,this.m=new Map,this.n=this.B(new Q.$Q0b(this,this.z,this.G,this.u,this.I)),this.S()}S(){this.B(this.L.onDidEnterWorkspace(O=>this.b.fire(O.window))),this.B(this.onDidSignalReadyWindow(O=>{if(O.config?.extensionDevelopmentPath||O.config?.extensionTestsPath){const U=new v.$Rc;if(U.add(f.Event.any(O.onDidClose,O.onDidDestroy)(()=>U.dispose())),O.config.extensionDevelopmentPath)for(const x of O.config.extensionDevelopmentPath)U.add(this.P.addValidFileRoot(x));O.config.extensionTestsPath&&U.add(this.P.addValidFileRoot(O.config.extensionTestsPath))}}))}openEmptyWindow(O,U){const x=this.D.args,z=U?.remoteAuthority||void 0,Y=!0,W=U?.forceReuseWindow,B=!W;return this.open({...O,cli:x,forceEmpty:Y,forceNewWindow:B,forceReuseWindow:W,remoteAuthority:z})}openExistingWindow(O,U){O.focus(),this.U(U,[O])}async open(O){this.u.trace("windowsManager#open"),O.addMode&&(O.initialStartup||!this.getLastActiveWindow())&&(O.addMode=!1);const U=[],x=[],z=[],Y=[],W=[];let B,_=0;const ae=await this.bb(O);this.u.trace("windowsManager#open pathsToOpen",ae);for(const Pe of ae)te(Pe)?O.addMode?U.push(Pe):x.push(Pe):q(Pe)?z.push(Pe):Pe.fileUri?(B||(B={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Pe.remoteAuthority}),B.filesToOpenOrCreate.push(Pe)):Pe.backupPath?W.push({backupFolder:(0,l.$nc)(Pe.backupPath),remoteAuthority:Pe.remoteAuthority}):_++;O.diffMode&&B&&B.filesToOpenOrCreate.length>=2&&(B.filesToDiff=B.filesToOpenOrCreate.slice(0,2),B.filesToOpenOrCreate=[]),O.mergeMode&&B&&B.filesToOpenOrCreate.length===4&&(B.filesToMerge=B.filesToOpenOrCreate.slice(0,4),B.filesToOpenOrCreate=[],B.filesToDiff=[]),B&&O.waitMarkerFileURI&&(B.filesToWait={paths:(0,A.$Hb)([...B.filesToDiff,B.filesToMerge[3],...B.filesToOpenOrCreate]),waitMarkerFileUri:O.waitMarkerFileURI}),O.initialStartup?(Y.push(...this.L.getUntitledWorkspaces()),z.push(...Y),W.push(...this.H.getEmptyWindowBackups())):W.length=0;const{windows:se,filesOpenedInWindow:$e}=await this.W(O,z,x,W,_,B,U);if(this.u.trace(`windowsManager#open used window count ${se.length} (workspacesToOpen: ${z.length}, foldersToOpen: ${x.length}, emptyToRestore: ${W.length}, emptyToOpen: ${_})`),se.length>1)if($e)$e.focus();else{const Pe=this.n.state.lastActiveWindow&&!O.forceEmpty&&!O.cli._.length&&!O.cli["file-uri"]&&!O.cli["folder-uri"]&&!(O.urisToOpen&&O.urisToOpen.length);let Le=!0,ke=!0;if(Pe){const pe=se.filter(ee=>this.n.state.lastActiveWindow&&ee.backupPath===this.n.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),Le=!1,ke=!1)}if(Le)for(let pe=se.length-1;pe>=0;pe--){const ee=se[pe];if(!(ee.openedWorkspace&&Y.some(fe=>ee.openedWorkspace&&fe.workspace.id===ee.openedWorkspace.id)||ee.backupPath&&W.some(fe=>ee.backupPath&&fe.backupFolder===(0,l.$nc)(ee.backupPath)))){ee.focus(),ke=!1;break}}ke&&se[se.length-1].focus()}const me=B&&B.filesToDiff.length>0,ye=B&&B.filesToMerge.length>0;if(!se.some(Pe=>Pe.isExtensionDevelopmentHost)&&!me&&!ye&&!O.noRecentEntry){const Pe=[];for(const Le of ae)q(Le)&&!Le.transient?Pe.push({label:Le.label,workspace:Le.workspace,remoteAuthority:Le.remoteAuthority}):te(Le)?Pe.push({label:Le.label,folderUri:Le.workspace.uri,remoteAuthority:Le.remoteAuthority}):Le.fileUri&&Pe.push({label:Le.label,fileUri:Le.fileUri,remoteAuthority:Le.remoteAuthority});this.J.addRecentlyOpened(Pe)}return this.U(O,se),se}U(O,U){const x=O.waitMarkerFileURI;O.context===0&&x&&U.length===1&&U[0]&&(async()=>{await U[0].whenClosedOrLoaded;try{await this.O.del(x)}catch{}})()}async W(O,U,x,z,Y,W,B){const _=[];let ae;function se(pe,ee){_.push(pe),ee&&(ae=pe,W=void 0)}let{openFolderInNewWindow:$e,openFilesInNewWindow:me}=this.nb(O);if(!O.initialStartup&&B.length>0){const pe=B[0].remoteAuthority,ee=this.tb(pe);ee&&se(this.Z(ee,B.map(fe=>fe.workspace.uri)))}const ye=x.length+U.length+z.length;if(W&&ye===0){const pe=W.filesToOpenOrCreate[0]||W.filesToDiff[0]||W.filesToMerge[3],ee=this.getWindows().filter(ge=>W&&(0,g.$Jg)(ge.remoteAuthority,W.remoteAuthority));let fe;pe?.fileUri&&!me&&((O.context===4||O.context===0||O.context===1)&&(fe=await(0,Z.$B9b)(ee,pe.fileUri,async ge=>ge.configPath.scheme===b.Schemas.file?this.L.resolveLocalWorkspace(ge.configPath):void 0)),fe||(fe=this.ub(ee))),fe?(0,le.$fi)(fe.openedWorkspace)?U.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):(0,le.$ai)(fe.openedWorkspace)?x.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):se(this.X(O,fe,W),!0):se(await this.ob({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,filesToOpen:W,forceNewWindow:!0,remoteAuthority:W.remoteAuthority,forceNewTabbedWindow:O.forceNewTabbedWindow,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile}),!0)}const Pe=(0,A.$Mb)(U,pe=>pe.workspace.id);if(Pe.length>0){const pe=(0,A.$Hb)(Pe.map(ee=>(0,Z.$C9b)(this.getWindows(),ee.workspace.configPath)));if(pe.length>0){const ee=pe[0],fe=(0,g.$Jg)(W?.remoteAuthority,ee.remoteAuthority)?W:void 0;se(this.X(O,ee,fe),!!fe),$e=!0}for(const ee of Pe){if(pe.some(Ie=>Ie.openedWorkspace&&Ie.openedWorkspace.id===ee.workspace.id))continue;const fe=ee.remoteAuthority,ge=(0,g.$Jg)(W?.remoteAuthority,fe)?W:void 0;se(await this.ab(O,ee,$e,ge),!!ge),$e=!0}}const Le=(0,A.$Mb)(x,pe=>g.$vg.getComparisonKey(pe.workspace.uri));if(Le.length>0){const pe=(0,A.$Hb)(Le.map(ee=>(0,Z.$C9b)(this.getWindows(),ee.workspace.uri)));if(pe.length>0){const ee=pe[0],fe=(0,g.$Jg)(W?.remoteAuthority,ee.remoteAuthority)?W:void 0;se(this.X(O,ee,fe),!!fe),$e=!0}for(const ee of Le){if(pe.some(Ie=>(0,le.$ai)(Ie.openedWorkspace)&&g.$vg.isEqual(Ie.openedWorkspace.uri,ee.workspace.uri)))continue;const fe=ee.remoteAuthority,ge=(0,g.$Jg)(W?.remoteAuthority,fe)?W:void 0;se(await this.ab(O,ee,$e,ge),!!ge),$e=!0}}const ke=(0,A.$Mb)(z,pe=>pe.backupFolder);if(ke.length>0)for(const pe of ke){const ee=pe.remoteAuthority,fe=(0,g.$Jg)(W?.remoteAuthority,ee)?W:void 0;se(await this.$(O,!0,ee,fe,pe),!!fe),$e=!0}if(_.length===0||W){W&&!Y&&Y++;const pe=W?W.remoteAuthority:O.remoteAuthority;for(let ee=0;ee<Y;ee++)se(await this.$(O,$e,pe,W),!!W),$e=!0}return{windows:(0,A.$Mb)(_),filesOpenedInWindow:ae}}X(O,U,x){this.u.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:x}),this.Y(U);const z={filesToOpenOrCreate:x?.filesToOpenOrCreate,filesToDiff:x?.filesToDiff,filesToMerge:x?.filesToMerge,filesToWait:x?.filesToWait,termProgram:O?.userEnv?.TERM_PROGRAM};return U.sendWhenReady("vscode:openFiles",E.CancellationToken.None,z),U}Y(O){let U=O;const x=P.BrowserWindow.getFocusedWindow();if(x&&x.id!==O.id){const z=this.R.getWindowById(x.id);z&&z.parentId===O.id&&(U=z)}U.focus()}Z(O,U){this.u.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:U}),O.focus();const x={foldersToAdd:U};return O.sendWhenReady("vscode:addFolders",E.CancellationToken.None,x),O}$(O,U,x,z,Y){this.u.trace("windowsManager#doOpenEmpty",{restore:!!Y,remoteAuthority:x,filesToOpen:z,forceNewWindow:U});let W;return!U&&typeof O.contextWindowId=="number"&&(W=this.getWindowById(O.contextWindowId)),this.ob({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:x,forceNewWindow:U,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:z,windowToUse:W,emptyWindowBackupInfo:Y,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}ab(O,U,x,z,Y){return this.u.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:U,filesToOpen:z}),!x&&!Y&&typeof O.contextWindowId=="number"&&(Y=this.getWindowById(O.contextWindowId)),this.ob({workspace:U.workspace,userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:U.remoteAuthority,forceNewWindow:x,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:z,windowToUse:Y,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}async bb(O){let U,x=!1,z=!1;if(O.urisToOpen&&O.urisToOpen.length>0?(U=await this.cb(O),x=!0):O.forceEmpty?U=[Object.create(null)]:O.cli._.length||O.cli["folder-uri"]||O.cli["file-uri"]?(U=await this.db(O.cli),U.length===0&&U.push(Object.create(null)),x=!0):(U=await this.fb(),U.length===0&&U.push(Object.create(null)),z=!0),!O.addMode&&x){const Y=U.filter(W=>te(W));if(Y.length>1){const W=Y[0].remoteAuthority;if(Y.every(B=>(0,g.$Jg)(B.remoteAuthority,W))){const B=await this.L.createUntitledWorkspace(Y.map(_=>({uri:_.workspace.uri})));U.push({workspace:B,remoteAuthority:W}),U=U.filter(_=>!te(_))}}}if(O.initialStartup&&!z&&this.I.getValue("window")?.restoreWindows==="preserve"){const Y=await this.fb();U.unshift(...Y.filter(W=>q(W)||te(W)||W.backupPath))}return U}async cb(O){const U={gotoLineMode:O.gotoLineMode,remoteAuthority:O.remoteAuthority},x=await Promise.all((0,A.$Hb)(O.urisToOpen||[]).map(async z=>{const Y=await this.hb(z,U);if(Y)return Y.label=z.label,Y;const W=this.jb(z);this.N.showMessageBox({type:"info",buttons:[(0,S.localize)(0,null)],message:W.scheme===b.Schemas.file?(0,S.localize)(1,null):(0,S.localize)(2,null),detail:W.scheme===b.Schemas.file?(0,S.localize)(3,null,(0,y.$Iv)(W,{os:w.OS,tildify:this.D})):(0,S.localize)(4,null,W.toString(!0))},P.BrowserWindow.getFocusedWindow()??void 0)}));return(0,A.$Hb)(x)}async db(O){const U=[],x={ignoreFileNotFound:!0,gotoLineMode:O.goto,remoteAuthority:O.remote||void 0,forceOpenWorkspaceAsFile:O.diff&&O._.length===2||O.merge&&O._.length===4},z=O["folder-uri"];if(z){const B=await Promise.all(z.map(_=>{const ae=this.eb(_);if(ae)return this.hb({folderUri:ae},x)}));U.push(...(0,A.$Hb)(B))}const Y=O["file-uri"];if(Y){const B=await Promise.all(Y.map(_=>{const ae=this.eb(_);if(ae)return this.hb((0,le.$vi)(_)?{workspaceUri:ae}:{fileUri:ae},x)}));U.push(...(0,A.$Hb)(B))}const W=await Promise.all(O._.map(B=>x.remoteAuthority?this.mb(B,x):this.kb(B,x)));return U.push(...(0,A.$Hb)(W)),U}eb(O){try{const U=c.URI.parse(O);if(!U.scheme){this.u.error(`Invalid URI input string, scheme missing: ${O}`);return}return U.path?U:U.with({path:"/"})}catch(U){this.u.error(`Invalid URI input string: ${O}, ${U.message}`)}}async fb(){const O=this.gb();switch(O){case"none":return[];case"one":case"all":case"preserve":case"folders":{const U=[];O!=="one"&&U.push(...this.n.state.openedWindows),this.n.state.lastActiveWindow&&U.push(this.n.state.lastActiveWindow);const x=await Promise.all(U.map(async z=>{if(z.workspace){const Y=await this.hb({workspaceUri:z.workspace.configPath},{remoteAuthority:z.remoteAuthority,rejectTransientWorkspaces:!0});if(q(Y))return Y}else if(z.folderUri){const Y=await this.hb({folderUri:z.folderUri},{remoteAuthority:z.remoteAuthority});if(te(Y))return Y}else if(O!=="folders"&&z.backupPath)return{backupPath:z.backupPath,remoteAuthority:z.remoteAuthority}}));return(0,A.$Hb)(x)}}}gb(){let O;return this.G.wasRestarted?O="all":(O=this.I.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(O)||(O="all")),O}async hb(O,U=Object.create(null)){const x=this.jb(O);return x.scheme===b.Schemas.file?((0,M.$DC)(O)&&(U={...U,forceOpenWorkspaceAsFile:!0}),this.kb(x.fsPath,U)):this.ib(O,U)}ib(O,U){let x=this.jb(O);const z=(0,k.$0k)(x)||U.remoteAuthority;if(x=(0,g.$Lg)((0,g.$Fg)(x)),(0,M.$DC)(O)){if(U.gotoLineMode){const{path:Y,line:W,column:B}=(0,h.$_f)(x.path);return{fileUri:x.with({path:Y}),options:{selection:W?{startLineNumber:W,startColumn:B||1}:void 0},remoteAuthority:z}}return{fileUri:x,remoteAuthority:z}}else if((0,M.$BC)(O))return{workspace:(0,ce.$F9b)(x),remoteAuthority:z};return{workspace:(0,ce.$G9b)(x),remoteAuthority:z}}jb(O){return(0,M.$BC)(O)?O.workspaceUri:(0,M.$CC)(O)?O.folderUri:O.fileUri}async kb(O,U,x){let z,Y;U.gotoLineMode&&({path:O,line:z,column:Y}=(0,h.$_f)(O)),O=(0,h.$7f)((0,l.$hc)(O),(0,$.cwd)());try{const W=await R.Promises.stat(O);if(W.isFile()){if(!U.forceOpenWorkspaceAsFile){const B=await this.L.resolveLocalWorkspace(c.URI.file(O));if(B)return B.transient&&U.rejectTransientWorkspaces?void 0:{workspace:{id:B.id,configPath:B.configPath},type:i.FileType.File,exists:!0,remoteAuthority:B.remoteAuthority,transient:B.transient}}return{fileUri:c.URI.file(O),type:i.FileType.File,exists:!0,options:{selection:z?{startLineNumber:z,startColumn:Y||1}:void 0}}}else{if(W.isDirectory())return{workspace:(0,ce.$G9b)(c.URI.file(O),W),type:i.FileType.Directory,exists:!0};if(!w.$i&&O==="/dev/null")return{fileUri:c.URI.file(O),type:i.FileType.File,exists:!0}}}catch(W){if(W.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!x)return this.lb(O,U);const B=c.URI.file(O);if(this.J.removeRecentlyOpened([B]),U.ignoreFileNotFound)return{fileUri:B,type:i.FileType.File,exists:!1}}}async lb(O,U){const x=c.URI.file(O),{response:z,checkboxChecked:Y}=await this.N.showMessageBox({type:"warning",buttons:[(0,S.localize)(5,null),(0,S.localize)(6,null),(0,S.localize)(7,null)],message:(0,S.localize)(8,null,x.authority),detail:(0,S.localize)(9,null,(0,y.$Iv)(x,{os:w.OS,tildify:this.D})),checkboxLabel:(0,S.localize)(10,null,x.authority),cancelId:1});if(z===0){if((0,s.addUNCHostToAllowlist)(x.authority),Y){const W={channel:"vscode:configureAllowedUNCHost",args:x.authority};this.sendToFocused(W.channel,W.args),this.sendToOpeningWindow(W.channel,W.args)}return this.kb(O,U,!0)}if(z===2)return P.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.lb(O,U)}mb(O,U){const x=O.charCodeAt(0),z=U.remoteAuthority;let Y,W;U.gotoLineMode&&({path:O,line:Y,column:W}=(0,h.$_f)(O)),x!==47&&((0,h.$6f)(x)&&O.charCodeAt(O.charCodeAt(1))===58&&(O=(0,h.$Yf)(O)),O=`/${O}`);const B=c.URI.from({scheme:b.Schemas.vscodeRemote,authority:z,path:O});if(O.charCodeAt(O.length-1)!==47){if((0,le.$vi)(O))return U.forceOpenWorkspaceAsFile?{fileUri:B,options:{selection:Y?{startLineNumber:Y,startColumn:W||1}:void 0},remoteAuthority:U.remoteAuthority}:{workspace:(0,ce.$F9b)(B),remoteAuthority:z};if(U.gotoLineMode||l.$gc.basename(O).indexOf(".")!==-1)return{fileUri:B,options:{selection:Y?{startLineNumber:Y,startColumn:W||1}:void 0},remoteAuthority:z}}return{workspace:(0,ce.$G9b)(B),remoteAuthority:z}}nb(O){const U=this.I.getValue("window"),x=U?.openFoldersInNewWindow||"default",z=U?.openFilesInNewWindow||"off";let Y=(O.preferNewWindow||O.forceNewWindow)&&!O.forceReuseWindow;!O.forceNewWindow&&!O.forceReuseWindow&&(x==="on"||x==="off")&&(Y=x==="on");let W=!1;return O.forceNewWindow||O.forceReuseWindow?W=!!O.forceNewWindow&&!O.forceReuseWindow:(w.$j?O.context===1&&(W=!0):O.context!==3&&O.context!==2&&!(O.userEnv&&O.userEnv.TERM_PROGRAM==="vscode")&&(W=!0),!O.cli.extensionDevelopmentPath&&(z==="on"||z==="off")&&(W=z==="on")),{openFolderInNewWindow:!!Y,openFilesInNewWindow:W}}async openExtensionDevelopmentHostWindow(O,U){const x=(0,Z.$D9b)(this.getWindows(),O);if(x)return this.G.reload(x,U.cli),x.focus(),[x];let z=U.cli["folder-uri"]||[],Y=U.cli["file-uri"]||[],W=U.cli._;if(!W.length&&!z.length&&!Y.length&&!U.cli.extensionTestsPath){const ae=this.n.state.lastPluginDevelopmentHostWindow,se=ae?.workspace??ae?.folderUri;se&&(c.URI.isUri(se)?se.scheme===b.Schemas.file?W=[se.fsPath]:z=[se.toString()]:se.configPath.scheme===b.Schemas.file?W=[(0,g.$sg)(se.configPath)]:Y=[se.configPath.toString()])}let B=U.remoteAuthority;for(const ae of O)if(ae.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const se=c.URI.parse(ae),$e=(0,k.$0k)(se);$e&&(B?(0,g.$Jg)($e,B)||this.u.error("more than one extension development path authority"):B=$e)}W=W.filter(ae=>{const se=c.URI.file(ae);return(0,Z.$C9b)(this.getWindows(),se)?!1:(0,g.$Jg)((0,k.$0k)(se),B)}),z=z.filter(ae=>{const se=this.eb(ae);return se&&(0,Z.$C9b)(this.getWindows(),se)?!1:se?(0,g.$Jg)((0,k.$0k)(se),B):!1}),Y=Y.filter(ae=>{const se=this.eb(ae);return se&&(0,Z.$C9b)(this.getWindows(),se)?!1:se?(0,g.$Jg)((0,k.$0k)(se),B):!1}),U.cli._=W,U.cli["folder-uri"]=z,U.cli["file-uri"]=Y;const _={context:U.context,cli:U.cli,forceNewWindow:!0,forceEmpty:!W.length&&!z.length&&!Y.length,userEnv:U.userEnv,noRecentEntry:!0,waitMarkerFileURI:U.waitMarkerFileURI,remoteAuthority:B,forceProfile:U.forceProfile,forceTempProfile:U.forceTempProfile};return this.open(_)}async ob(O){const U=this.I.getValue("window"),x=this.getLastActiveWindow(),z=x?.profile??this.F.defaultProfile;let Y;!O.forceNewWindow&&!O.forceNewTabbedWindow&&(Y=O.windowToUse||x,Y&&Y.focus());const W={...this.D.args,...O.cli,machineId:this.r,sqmId:this.s,windowId:-1,mainPid:process.pid,appRoot:this.D.appRoot,execPath:process.execPath,codeCachePath:this.D.codeCachePath,backupPath:O.emptyWindowBackupInfo?(0,l.$jc)(this.D.backupHome,O.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.F.profilesHome,all:this.F.profiles,profile:z},homeDir:this.D.userHome.with({scheme:b.Schemas.file}).fsPath,tmpDir:this.D.tmpDir.with({scheme:b.Schemas.file}).fsPath,userDataDir:this.D.userDataPath,remoteAuthority:O.remoteAuthority,workspace:O.workspace,userEnv:{...this.t,...O.userEnv},filesToOpenOrCreate:O.filesToOpen?.filesToOpenOrCreate,filesToDiff:O.filesToOpen?.filesToDiff,filesToMerge:O.filesToOpen?.filesToMerge,filesToWait:O.filesToOpen?.filesToWait,logLevel:this.w.getLogLevel(),loggers:{window:[],global:this.w.getRegisteredLoggers()},logsPath:this.D.logsHome.with({scheme:b.Schemas.file}).fsPath,product:D.default,isInitialStartup:O.initialStartup,perfMarks:(0,p.getMarks)(),os:{release:(0,j.release)(),hostname:(0,j.hostname)(),arch:(0,j.arch)()},zoomLevel:typeof U?.zoomLevel=="number"?U.zoomLevel:void 0,autoDetectHighContrast:U?.autoDetectHighContrast??!0,autoDetectColorScheme:U?.autoDetectColorScheme??!1,accessibilitySupport:P.app.accessibilitySupportEnabled,colorScheme:this.Q.getColorScheme(),policiesData:this.C.serialize(),continueOn:this.D.continueOn};if(Y){const B=Y.config;!W.extensionDevelopmentPath&&B?.extensionDevelopmentPath&&(W.extensionDevelopmentPath=B.extensionDevelopmentPath,W.extensionDevelopmentKind=B.extensionDevelopmentKind,W["enable-proposed-api"]=B["enable-proposed-api"],W.verbose=B.verbose,W["inspect-extensions"]=B["inspect-extensions"],W["inspect-brk-extensions"]=B["inspect-brk-extensions"],W.debugId=B.debugId,W.extensionEnvironment=B.extensionEnvironment,W["extensions-dir"]=B["extensions-dir"],W["disable-extensions"]=B["disable-extensions"]),W.loggers={global:W.loggers.global,window:B?.loggers.window??W.loggers.window}}else{const B=this.n.getNewWindowState(W);(0,p.mark)("code/willCreateCodeWindow");const _=Y=this.M.createInstance(F.$N9b,{state:B,extensionDevelopmentPath:W.extensionDevelopmentPath,isExtensionTestHost:!!W.extensionTestsPath});(0,p.mark)("code/didCreateCodeWindow"),O.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(_),this.m.set(_.id,_),this.a.fire(_),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const ae=new v.$Rc;ae.add(_.onDidSignalReady(()=>this.b.fire(_))),ae.add(f.Event.once(_.onDidClose)(()=>this.rb(_,ae))),ae.add(f.Event.once(_.onDidDestroy)(()=>this.sb(_))),ae.add(_.onDidMaximize(()=>this.g.fire(_))),ae.add(_.onDidUnmaximize(()=>this.h.fire(_))),ae.add(_.onDidTriggerSystemContextMenu(({x:$e,y:me})=>this.j.fire({window:_,x:$e,y:me})));const se=(0,u.$Qf)(_.win?.webContents);se.removeAllListeners("devtools-reload-page"),se.on("devtools-reload-page",()=>this.G.reload(_)),this.G.registerWindow(_)}return W.windowId=Y.id,Y.isReady?this.G.unload(Y,4).then(async B=>{B||await this.pb(Y,W,O,z)}):await this.pb(Y,W,O,z),Y}async pb(O,U,x,z){if(U.extensionDevelopmentPath||((0,le.$fi)(U.workspace)?U.backupPath=this.H.registerWorkspaceBackup({workspace:U.workspace,remoteAuthority:U.remoteAuthority}):(0,le.$ai)(U.workspace)?U.backupPath=this.H.registerFolderBackup({folderUri:U.workspace.uri,remoteAuthority:U.remoteAuthority}):U.backupPath=this.H.registerEmptyWindowBackup({backupFolder:x.emptyWindowBackupInfo?.backupFolder??(0,ce.$H9b)().id,remoteAuthority:U.remoteAuthority})),this.F.isEnabled()){const Y=U.workspace??(0,le.$ei)(U.backupPath,!1),W=this.qb(x,Y,z),B=W instanceof Promise?await W:W;U.profiles.profile=B,U.extensionDevelopmentPath||await this.F.setProfileForWorkspace(Y,B)}O.load(U)}qb(O,U,x){return O.forceProfile?this.F.profiles.find(z=>z.name===O.forceProfile)??this.F.createNamedProfile(O.forceProfile):O.forceTempProfile?this.F.createTransientProfile():this.F.getProfileForWorkspace(U)??x}rb(O,U){this.m.delete(O.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),U.dispose()}sb(O){this.m.delete(O.id),this.c.fire(O)}getFocusedWindow(){const O=P.BrowserWindow.getFocusedWindow();if(O)return this.getWindowById(O.id)}getLastActiveWindow(){return this.ub(this.getWindows())}tb(O){return this.ub(this.getWindows().filter(U=>(0,g.$Jg)(U.remoteAuthority,O)))}ub(O){return(0,N.$U9b)(O)}sendToFocused(O,...U){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(O,E.CancellationToken.None,...U)}sendToOpeningWindow(O,...U){this.B(f.Event.once(this.onDidSignalReadyWindow)(x=>{x.sendWhenReady(O,E.CancellationToken.None,...U)}))}sendToAll(O,U,x){for(const z of this.getWindows())x&&x.indexOf(z.id)>=0||z.sendWhenReady(O,E.CancellationToken.None,U)}getWindows(){return Array.from(this.m.values())}getWindowCount(){return this.m.size}getWindowById(O){return this.m.get(O)}getWindowByWebContents(O){const U=P.BrowserWindow.fromWebContents(O);if(U)return this.getWindowById(U.id)}};e.$T0b=he,e.$T0b=he=Ee([ne(3,m.$kj),ne(4,T.$K9b),ne(5,C.$0N),ne(6,H.$xn),ne(7,r.$e9b),ne(8,L.$m9b),ne(9,a.$g9b),ne(10,d.$x9b),ne(11,t.$wi),ne(12,ue.$p0b),ne(13,X.$I9b),ne(14,n.$2h),ne(15,o.$y9b),ne(16,i.$nk),ne(17,I.$A9b),ne(18,K.$s9b),ne(19,V.$P9b)],he)}),define(re[307],oe([0,1,66,29,83,56]),function(J,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V0b=void 0;let A=class{constructor(f,h,y,v){this.a=f,this.b=h,this.c=y,this.d=v,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(f,h){const y=this.b.getWindowById(f);if(y)return this.a.enterWorkspace(y,this.b.getWindows(),h)}createUntitledWorkspace(f,h,y){return this.a.createUntitledWorkspace(h,y)}deleteUntitledWorkspace(f,h){return this.a.deleteUntitledWorkspace(h)}getWorkspaceIdentifier(f,h){return this.a.getWorkspaceIdentifier(h)}getRecentlyOpened(f){return this.c.getRecentlyOpened()}addRecentlyOpened(f,h){return this.c.addRecentlyOpened(h)}removeRecentlyOpened(f,h){return this.c.removeRecentlyOpened(h)}clearRecentlyOpened(f){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$V0b=A,e.$V0b=A=Ee([ne(0,j.$I9b),ne(1,R.$R9b),ne(2,s.$p0b),ne(3,P.$x9b)],A)}),define(re[308],oe([0,1,15,131,36,26,18,51,14,33,3,44,47,2,13,9,4,12,7,32,158,42,159,110,290,162,66,283,17,200,91,132,54,116,220,24,64,94,209,293,211,212,213,16,224,93,78,6,92,219,299,284,291,20,5,305,71,27,59,294,95,34,275,82,122,28,251,253,53,49,265,288,300,289,301,127,267,268,269,272,297,60,29,306,274,30,97,83,307,56,39,233,55,244,52,81,129,277,292,280,8,255,276,228,69,296,271,23,125,295,263,239,62,65,303]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p,w,$,g,u,c,S,d,t,o,r,i,n,a,m,D,I,k,C,M,F,N,Z,Q,le,ce,ue,X,K,H,L,T,V,q,te,he,G,O,U,x,z,Y,W,B,_,ae,se,$e,me,ye,Pe,Le,ke,pe,ee,fe,ge,Ie,je,We,Me,Je,Be,He,Ve,ie,de,be,Se,ve,De,Ne,qe,Qe,xe,Ze,Ye,nt,st,ot,pt,yt,vt,kt,Et,St,at,gt,Pt,It,Ct,ct,At,$t,lt,Dt,Rt,ut,Ot,ht,jt){"use strict";var ft;Object.defineProperty(e,"__esModule",{value:!0}),e.$c$b=void 0;let dt=class extends l.$Sc{static{ft=this}static{this.a={[p.Schemas.file]:"security.promptForLocalFileProtocolHandling",[p.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Ce,Ae,Oe,we,Re,Te,ze,Ke,Fe,Ue,Ge,Xe){super(),this.g=Ce,this.h=Ae,this.j=Oe,this.m=we,this.n=Re,this.s=Te,this.t=ze,this.u=Ke,this.w=Fe,this.y=Ue,this.z=Ge,this.C=Xe,this.D(),this.F()}D(){const Ce=Fe=>Fe?.startsWith(`${p.Schemas.vscodeWebview}://`),Ae=new Set(["clipboard-read","clipboard-sanitized-write"]);P.session.defaultSession.setPermissionRequestHandler((Fe,Ue,Ge,Xe)=>Ce(Xe.requestingUrl)?Ge(Ae.has(Ue)):Ge(!1)),P.session.defaultSession.setPermissionCheckHandler((Fe,Ue,Ge,Xe)=>Ce(Xe.requestingUrl)?Ae.has(Ue):!1);const Oe=new Set([p.Schemas.file,p.Schemas.vscodeFileResource,p.Schemas.vscodeRemoteResource,p.Schemas.vscodeManagedRemoteResource,"devtools"]),we=Fe=>{for(let Ue=Fe;Ue;Ue=Ue.parent)if(Ue.url.startsWith(`${p.Schemas.vscodeWebview}://`))return!0;return!1},Re=Fe=>Fe.resourceType==="xhr"||we(Fe.frame),Te=Fe=>{const Ue=Fe.frame;if(!Ue||!this.b)return!1;const Ge=P.BrowserWindow.getAllWindows();for(const Xe of Ge)if(Ue.processId===Xe.webContents.mainFrame.processId)return!0;return!1},ze=(Fe,Ue)=>{if(Fe.path!=="/index.html")return!0;const Ge=Ue.frame;if(!Ge||!this.b)return!1;for(const Xe of this.b.getWindows())if(Xe.win&&Ge.processId===Xe.win.webContents.mainFrame.processId)return!0;return!1};P.session.defaultSession.webRequest.onBeforeRequest((Fe,Ue)=>{const Ge=u.URI.parse(Fe.url);return Ge.scheme===p.Schemas.vscodeWebview&&!ze(Ge,Fe)?(this.m.error("Blocked vscode-webview request",Fe.url),Ue({cancel:!0})):Ge.scheme===p.Schemas.vscodeFileResource&&!Te(Fe)?(this.m.error("Blocked vscode-file request",Fe.url),Ue({cancel:!0})):Ge.path.endsWith(".svg")&&!Oe.has(Ge.scheme)?Ue({cancel:!Re(Fe)}):Ue({cancel:!1})}),P.session.defaultSession.webRequest.onHeadersReceived((Fe,Ue)=>{const Ge=Fe.responseHeaders,Xe=Ge["content-type"]||Ge["Content-Type"];if(Xe&&Array.isArray(Xe)){const _e=u.URI.parse(Fe.url);if(_e.path.endsWith(".svg")&&Oe.has(_e.scheme))return Ge["Content-Type"]=["image/svg+xml"],Ue({cancel:!1,responseHeaders:Ge});if(!_e.path.endsWith(p.Schemas.vscodeRemoteResource)&&Xe.some(tt=>tt.toLowerCase().includes("image/svg")))return Ue({cancel:!Re(Fe)})}return Ue({cancel:!1})}),P.session.defaultSession.webRequest.onHeadersReceived((Fe,Ue)=>{if(Fe.url.startsWith("https://vscode.download.prss.microsoft.com/")){const Ge=Fe.responseHeaders??Object.create(null);if(Ge["Access-Control-Allow-Origin"]===void 0)return Ge["Access-Control-Allow-Origin"]=["*"],Ue({cancel:!1,responseHeaders:Ge})}return Ue({cancel:!1})});const Ke=P.session.defaultSession;typeof Ke.setCodeCachePath=="function"&&this.s.codeCachePath&&Ke.setCodeCachePath((0,w.$jc)(this.s.codeCachePath,"chrome")),$.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,R.disableUNCAccessRestrictions)():(0,R.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,f.setUnexpectedErrorHandler)(Oe=>this.H(Oe)),process.on("uncaughtException",Oe=>{(0,f.$Z)(Oe)||(0,f.$1)(Oe)}),process.on("unhandledRejection",Oe=>(0,f.$1)(Oe)),this.t.onWillShutdown(()=>this.dispose()),(0,S.$kU)(),P.app.on("accessibility-support-changed",(Oe,we)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",we)}),P.app.on("activate",async(Oe,we)=>{this.m.trace("app#activate"),we||await this.b?.openEmptyWindow({context:1})}),P.app.on("web-contents-created",(Oe,we)=>{(0,ht.$Q9b)(we)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(we)),we.on("will-navigate",Re=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Re.preventDefault()}),we.setWindowOpenHandler(Re=>Re.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow()}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Re.url}}`),this.f?.openExternal(void 0,Re.url),{action:"deny"}))});let Ce=[],Ae;P.app.on("open-file",(Oe,we)=>{this.m.trace("app#open-file: ",we),Oe.preventDefault(),Ce.push((0,Ne.$vi)(we)?{workspaceUri:u.URI.file(we)}:{fileUri:u.URI.file(we)}),Ae!==void 0&&(clearTimeout(Ae),Ae=void 0),Ae=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:Ce,gotoLineMode:!1,preferNewWindow:!0}),Ce=[],Ae=void 0},100)}),P.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),s.$jU.handle("vscode:fetchShellEnv",Oe=>{const we=this.b?.getWindowByWebContents(Oe.sender);let Re,Te;return we?.config?(Re=we.config,Te={...process.env,...we.config.userEnv}):(Re=this.s.args,Te=process.env),this.X(Re,Te,!1)}),s.$jU.handle("vscode:writeNlsFile",(Oe,we,Re)=>{const Te=this.G([we]);if(!Te||typeof Re!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(Te,A.$ge.fromString(Re))}),s.$jU.handle("vscode:readNlsFile",async(Oe,...we)=>{const Re=this.G(we);if(!Re)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Re)).value.toString()}),s.$jU.on("vscode:toggleDevTools",Oe=>Oe.sender.toggleDevTools()),s.$jU.on("vscode:openDevTools",Oe=>Oe.sender.openDevTools()),s.$jU.on("vscode:reloadWindow",Oe=>Oe.sender.reload())}G(Ce){let Ae;for(const Oe of Ce)typeof Oe=="string"&&(typeof Ae!="string"?Ae=Oe:Ae=(0,w.$jc)(Ae,Oe));if(!(typeof Ae!="string"||!(0,w.$ic)(Ae)||!(0,h.$5f)(Ae,this.s.cachedLanguagesPath,!$.$k)))return u.URI.file(Ae)}H(Ce){if(Ce){const Ae={message:`[uncaught exception in main]: ${Ce.message}`,stack:Ce.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Ae))}this.m.error(`[uncaught exception in main]: ${Ce}`),Ce.stack&&this.m.error(Ce.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Ce=this.z.win32AppUserModelId;$.$i&&Ce&&P.app.setAppUserModelId(Ce);try{$.$j&&this.u.getValue("window.nativeTabs")===!0&&!P.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&P.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ue){this.m.error(Ue)}const Ae=new t.$qU;this.t.onWillShutdown(Ue=>{Ue.reason===2&&Ae.dispose()}),this.m.trace("Resolving machine identifier...");const[Oe,we]=await Promise.all([(0,gt.$40b)(this.w,this.m),(0,gt.$50b)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Oe}`);const{sharedProcessReady:Re,sharedProcessClient:Te}=this.P(Oe,we),ze=await this.Q(Oe,we,Re);this.B(ze.createInstance(r.$V9b)),this.B(ze.createInstance(Et.$Z0b)),ze.invokeFunction(Ue=>this.R(Ue,Ae,Te));const Ke=await ze.invokeFunction(Ue=>this.I(Ue,Ae));this.J(Ae),this.t.phase=2,await ze.invokeFunction(Ue=>this.S(Ue,Ke)),this.t.phase=3,this.U(),this.B(new at.$ch(()=>{this.B((0,at.$gh)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(Ce,Ae){const Oe=this.b=Ce.get(Se.$R9b),we=Ce.get(Je.$$U),Re=this.f=Ce.get(W.$d0b),Te=Ce.get(C.$y9b),ze=this;we.registerHandler({async handleURL(_e,tt){return ze.O(Oe,Te,we,_e,tt)}});const Ke=this.B(new De.$U0b({onDidOpenMainWindow:Re.onDidOpenMainWindow,onDidFocusMainWindow:Re.onDidFocusMainWindow,getActiveWindowId:()=>Re.getActiveWindowId(-1)})),Fe=new d.$Kh(_e=>Ke.getActiveClientId().then(tt=>_e===tt)),Ue=new Be.$L0b(Fe,this.m),Ge=Ae.getChannel("urlHandler",Ue);we.registerHandler(new Be.$K0b(Ge));const Xe=await this.L(Oe,Te);return this.B(new Ve.$M0b(Xe?.urls,we,Oe,this.s,this.z,this.m)),Xe}J(Ce){const Ae=()=>({statusCode:404,data:"Not found"}),Oe=new Ot.$V(()=>Ce.getChannel(ut.$_0b,new ut.$a$b));P.protocol.registerBufferProtocol(p.Schemas.vscodeManagedRemoteResource,(we,Re)=>{const Te=u.URI.parse(we.url);if(!Te.authority.startsWith("window:"))return Re(Ae());Oe.value.call(ut.$$0b,[Te]).then(ze=>Re({...ze,data:Buffer.from(ze.body,"base64")}),ze=>{this.m.warn("error dispatching remote resource call",ze),Re({statusCode:500,data:String(ze)})})})}async L(Ce,Ae){const Oe=this.s.args["open-url"]?this.s.args._urls||[]:[];Oe.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Oe);const we=global.getOpenUrls()||[];if(we.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",we),Oe.length+we.length===0)return;const Re=[...Oe,...we].map(Ke=>{try{return{uri:u.URI.parse(Ke),originalUrl:Ke}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ke);return}}),Te=[],ze=[];for(const Ke of Re){if(!Ke)continue;const Fe=this.N(Ke.uri);if(Fe)if(await this.M(Fe,Ce,Ae)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ke.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ke.uri.toString(!0),Fe),Te.push(Fe);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ke.uri.toString(!0)),ze.push(Ke)}return{urls:ze,openables:Te}}async M(Ce,Ae,Oe){let we,Re;if((0,be.$BC)(Ce)?(we=Ce.workspaceUri,Re=(0,i.localize)(0,null,we.scheme===p.Schemas.file?(0,b.$Iv)(we,{os:$.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)):(0,be.$CC)(Ce)?(we=Ce.folderUri,Re=(0,i.localize)(1,null,we.scheme===p.Schemas.file?(0,b.$Iv)(we,{os:$.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)):(we=Ce.fileUri,Re=(0,i.localize)(2,null,we.scheme===p.Schemas.file?(0,b.$Iv)(we,{os:$.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)),we.scheme!==p.Schemas.file&&we.scheme!==p.Schemas.vscodeRemote||this.u.getValue(ft.a[we.scheme])===!1)return!1;const{response:ze,checkboxChecked:Ke}=await Oe.showMessageBox({type:"warning",buttons:[(0,i.localize)(3,null),(0,i.localize)(4,null)],message:Re,detail:(0,i.localize)(5,null),checkboxLabel:we.scheme===p.Schemas.file?(0,i.localize)(6,null):(0,i.localize)(7,null),cancelId:1});if(ze!==0)return!0;if(Ke){const Fe={channel:"vscode:disablePromptForProtocolHandling",args:we.scheme===p.Schemas.file?"local":"remote"};Ae.sendToFocused(Fe.channel,Fe.args),Ae.sendToOpeningWindow(Fe.channel,Fe.args)}return!1}N(Ce){if(Ce.path){if(Ce.authority===p.Schemas.file){const Ae=u.URI.file(Ce.fsPath);return(0,Ne.$vi)(Ae)?{workspaceUri:Ae}:{fileUri:Ae}}else if(Ce.authority===p.Schemas.vscodeRemote){const Ae=Ce.path.indexOf(w.$gc.sep,1);if(Ae!==-1){const Oe=Ce.path.substring(1,Ae),we=Ce.path.substring(Ae);let Re=Ce.query;const Te=new URLSearchParams(Ce.query);Te.get("windowId")==="_blank"&&(Te.delete("windowId"),Re=Te.toString());const ze=u.URI.from({scheme:p.Schemas.vscodeRemote,authority:Oe,path:we,query:Re,fragment:Ce.fragment});return(0,Ne.$vi)(we)?{workspaceUri:ze}:/:[\d]+$/.test(we)?{fileUri:ze}:{folderUri:ze}}}}}async O(Ce,Ae,Oe,we,Re){this.m.trace("app#handleProtocolUrl():",we.toString(!0),Re),we.scheme===this.z.urlProtocol&&we.path==="workspace"&&(we=we.with({authority:"file",path:u.URI.parse(we.query).path,query:""}));let Te=!1;const ze=new URLSearchParams(we.query);ze.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",we.toString(!0)),ze.delete("windowId"),we=we.with({query:ze.toString()}),Te=!0):$.$j&&Ce.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",we.toString(!0)),Te=!0);const Ke=ze.get("continueOn");Ke!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",we.toString(!0)),ze.delete("continueOn"),we=we.with({query:ze.toString()}),this.s.continueOn=Ke??void 0);const Fe=this.N(we);return Fe?await this.M(Fe,Ce,Ae)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",we.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Fe,we.toString(!0)),(0,$t.$Ob)(await Ce.open({context:5,cli:{...this.s.args},urisToOpen:[Fe],forceNewWindow:Te,gotoLineMode:!0}))?.focus(),!0):Te?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",we.toString(!0)),await(0,$t.$Ob)(await Ce.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,_.$0k)(we)}))?.ready(),Oe.open(we,Re)):(this.m.trace("app#handleProtocolUrl(): not handled",we.toString(!0),Re),!1)}P(Ce,Ae){const Oe=this.B(this.j.createInstance(ae.$x0b,Ce,Ae)),we=(async()=>{this.m.trace("Main->SharedProcess#connect");const Te=await Oe.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new o.$rU(Te,"main")})();return{sharedProcessReady:(async()=>(await Oe.whenReady(),we))(),sharedProcessClient:we}}async Q(Ce,Ae,Oe){const we=new te.$1h;switch(process.platform){case"win32":we.set(fe.$iV,new V.$Zh(Me.$I0b));break;case"linux":$.$l?we.set(fe.$iV,new V.$Zh(We.$H0b,[process.env.SNAP,process.env.SNAP_REVISION])):we.set(fe.$iV,new V.$Zh(je.$G0b));break;case"darwin":we.set(fe.$iV,new V.$Zh(Ie.$F0b));break}we.set(Se.$R9b,new V.$Zh(ve.$T0b,[Ce,Ae,this.h],!1)),we.set(ht.$P9b,new V.$Zh(jt.$b$b,void 0,!1));const Re=new C.$z9b(this.m,this.z);we.set(C.$y9b,Re),we.set(U.$j0b,new V.$Zh(U.$k0b,void 0,!1)),we.set(k.$29b,new V.$Zh(k.$39b,void 0,!1)),we.set(I.$Fm,d.ProxyChannel.toService((0,d.$Ih)(Oe.then(Ue=>Ue.getChannel("diagnostics"))))),we.set(he.$ezb,new V.$Zh(G.$f0b,[this.h])),we.set(M.$5U,new V.$Zh(F.$49b)),we.set(O.$g0b,new V.$Zh(O.$h0b)),we.set(W.$d0b,new V.$Zh(W.$e0b,void 0,!1)),we.set(ie.$N0b,new V.$Zh(de.$P0b)),we.set(Y.$s0b,new V.$Zh(Y.$t0b)),we.set(le.$59b,new V.$Zh(ce.$79b)),we.set(ye.$o9b,new V.$Zh(ye.$p9b)),we.set(ye.$q9b,new V.$Zh(ye.$r9b));const Te=new Dt.$00b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),ze=new Rt.$Kr(Te,this.u,this.m,this.n);we.set(lt.$lr,ze),$.$i?we.set(ue.$89b,new V.$Zh(X.$99b)):$.$j?we.set(ue.$89b,new V.$Zh(X.$09b)):$.$k&&we.set(ue.$89b,new V.$Zh(X.$$9b));const Ke=new a.$W9b(this.s,this.u,this.m,this.w);we.set(n.$x9b,Ke);const Fe=new Ze.$J9b(this.s,this.m,this.C,Ke,Re);if(we.set(Ze.$I9b,Fe),we.set(qe.$gcb,new V.$Zh(xe.$V0b,void 0,!1)),we.set(Qe.$p0b,new V.$Zh(Qe.$q0b,void 0,!1)),we.set(Je.$$U,new V.$Zh(He.$aV,void 0,!1)),(0,ee.$Go)(this.z,this.s)){const Ue=(0,ee.$Lo)(this.z,this.u),Ge=(0,d.$Ih)(Oe.then(rt=>rt.getChannel("telemetryAppender"))),Xe=new ke.$A0b(Ge),_e=(0,Pe.$wo)((0,j.release)(),(0,j.hostname)(),process.arch,this.z.commit,this.z.version,Ce,Ae,Ue),tt=(0,ee.$Mo)(this.s),it={appenders:[Xe],commonProperties:_e,piiPaths:tt,sendErrorTelemetry:!0};we.set(Le.$rl,new V.$Zh(pe.$dr,[it],!1))}else we.set(Le.$rl,ee.$Ao);return we.set(yt.$Jp,new V.$Zh(Pt.$eO,void 0,!0)),we.set(vt.$Np,new V.$Zh(kt.$Y0b,void 0,!0)),we.set(ct.$80b,new V.$Zh(ct.$90b,void 0,!0)),await at.Promises.settled([Ke.initialize(),Fe.initialize()]),this.j.createChild(we)}R(Ce,Ae,Oe){const we=this.B(new l.$Rc),Re=d.ProxyChannel.fromService(Ce.get(U.$j0b),we,{disableMarshalling:!0});this.g.registerChannel("launch",Re);const Te=d.ProxyChannel.fromService(Ce.get(k.$29b),we,{disableMarshalling:!0});this.g.registerChannel("diagnostics",Te);const ze=new nt.$W0b(Ce.get(Ye.$xn));Ae.registerChannel("policy",ze),Oe.then(et=>et.registerChannel("policy",ze));const Ke=this.y.getProvider(p.Schemas.file);(0,g.$Pf)(Ke instanceof T.$pq);const Fe=new L.$_9b(Ke,this.m,this.s);Ae.registerChannel(K.$ZN,Fe),Oe.then(et=>et.registerChannel(K.$ZN,Fe));const Ue=d.ProxyChannel.fromService(Ce.get(st.$m9b),we);Ae.registerChannel("userDataProfiles",Ue),Oe.then(et=>et.registerChannel("userDataProfiles",Ue));const Ge=new ot.$$q(Ce.get(pt.$8o));Oe.then(et=>et.registerChannel("request",Ge));const Xe=new ge.$B0b(Ce.get(fe.$iV));Ae.registerChannel("update",Xe);const _e=d.ProxyChannel.fromService(Ce.get(he.$ezb),we);Ae.registerChannel("issue",_e);const tt=d.ProxyChannel.fromService(Ce.get(M.$5U),we);Ae.registerChannel("encryption",tt);const it=d.ProxyChannel.fromService(Ce.get(se.$fl),we);Ae.registerChannel("sign",it);const rt=d.ProxyChannel.fromService(Ce.get(O.$g0b),we);Ae.registerChannel("keyboardLayout",rt),this.f=Ce.get(W.$d0b);const mt=d.ProxyChannel.fromService(this.f,we);Ae.registerChannel("nativeHost",mt),Oe.then(et=>et.registerChannel("nativeHost",mt));const Mt=d.ProxyChannel.fromService(Ce.get(qe.$gcb),we);Ae.registerChannel("workspaces",Mt);const Lt=d.ProxyChannel.fromService(Ce.get(Y.$s0b),we);Ae.registerChannel("menubar",Lt);const Ft=d.ProxyChannel.fromService(Ce.get(Je.$$U),we);Ae.registerChannel("url",Ft);const Ut=d.ProxyChannel.fromService(Ce.get(ie.$N0b),we);Ae.registerChannel("webview",Ut);const wt=this.B(new me.$y0b(this.m,Ce.get(ye.$o9b)));Ae.registerChannel("storage",wt),Oe.then(et=>et.registerChannel("storage",wt));const Nt=this.B(new St.$10b(Ce.get(ye.$o9b),Ce.get(st.$m9b),this.m));Oe.then(et=>et.registerChannel("profileStorageListener",Nt));const Wt=d.ProxyChannel.fromService(Ce.get(lt.$lr),we);Ae.registerChannel(lt.TerminalIpcChannels.LocalPty,Wt);const Tt=d.ProxyChannel.fromService(Ce.get(ue.$89b),we);Ae.registerChannel("externalTerminal",Tt);const bt=new It.$60b(Ce.get(Ct.$K9b));Ae.registerChannel("logger",bt),Oe.then(et=>et.registerChannel("logger",bt));const zt=new D.$X9b(Ce.get(Se.$R9b));Ae.registerChannel("extensionhostdebugservice",zt);const Bt=d.ProxyChannel.fromService(Ce.get(le.$59b),we);Ae.registerChannel(le.$69b,Bt);const qt=d.ProxyChannel.fromService(Ce.get(ct.$80b),we);Ae.registerChannel(At.$70b,qt)}async S(Ce,Ae){const Oe=this.b=Ce.get(Se.$R9b);this.c=Ce.get(ht.$P9b);const we=(0,Z.$3l)(process.env)?0:4,Re=this.s.args;if(Ae){if(Ae.openables.length>0)return Oe.open({context:we,cli:Re,urisToOpen:Ae.openables,gotoLineMode:!0,initialStartup:!0});if(Ae.urls.length>0)for(const it of Ae.urls){const rt=new URLSearchParams(it.uri.query);if(rt.get("windowId")==="_blank")return rt.delete("windowId"),it.originalUrl=it.uri.toString(!0),it.uri=it.uri.with({query:rt.toString()}),Oe.open({context:we,cli:Re,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Te=global.macOpenFiles,ze=Re._.length,Ke=!!Re["folder-uri"],Fe=!!Re["file-uri"],Ue=Re["skip-add-to-recently-opened"]===!0,Ge=Re.wait&&Re.waitMarkerFilePath?u.URI.file(Re.waitMarkerFilePath):void 0,Xe=Re.remote||void 0,_e=Re.profile,tt=Re["profile-temp"];if(!ze&&!Ke&&!Fe){if(Re["new-window"]||_e||tt)return Oe.open({context:we,cli:Re,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ue,waitMarkerFileURI:Ge,initialStartup:!0,remoteAuthority:Xe,forceProfile:_e,forceTempProfile:tt});if(Te.length)return Oe.open({context:1,cli:Re,urisToOpen:Te.map(it=>(0,Ne.$vi)(it)?{workspaceUri:u.URI.file(it)}:{fileUri:u.URI.file(it)}),noRecentEntry:Ue,waitMarkerFileURI:Ge,initialStartup:!0})}return Oe.open({context:we,cli:Re,forceNewWindow:Re["new-window"]||!ze&&Re["unity-launch"],diffMode:Re.diff,mergeMode:Re.merge,noRecentEntry:Ue,waitMarkerFileURI:Ge,gotoLineMode:Re.goto,initialStartup:!0,remoteAuthority:Xe,forceProfile:_e,forceTempProfile:tt})}U(){this.W(),P.protocol.registerHttpProtocol(p.Schemas.vscodeRemoteResource,(Ce,Ae)=>{Ae({url:Ce.url.replace(/^vscode-remote-resource:/,"http:"),method:Ce.method})}),this.X(this.s.args,process.env,!0),this.Y(),$.$j&&P.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Ce=this.z.win32MutexName;if($.$i&&Ce)try{const Ae=await new Promise((we,Re)=>{J(["@vscode/windows-mutex"],we,Re)}),Oe=new Ae.Mutex(Ce);y.Event.once(this.t.onWillShutdown)(()=>Oe.release())}catch(Ae){this.m.error(Ae)}}async X(Ce,Ae,Oe){try{return await(0,Q.$9l)(this.u,this.m,Ce,Ae)}catch(we){const Re=(0,E.$Ni)(we);Oe?this.b?.sendToFocused("vscode:showResolveShellEnvError",Re):this.m.error(Re)}return{}}async Y(){try{const Ae=(await this.y.readFile(this.s.argvResource)).value.toString(),Oe=JSON.parse((0,v.$hn)(Ae)),Re=(0,ee.$Io)(this.u)>=1;if(Oe["enable-crash-reporter"]===void 0){const Te=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Re},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,c.$ng)()}"`,"}"],ze=Ae.substring(0,Ae.length-2).concat(`,
`,Te.join(`
`));await this.y.writeFile(this.s.argvResource,A.$ge.fromString(ze))}else{const Te=Ae.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Re},`);Te!==Ae&&await this.y.writeFile(this.s.argvResource,A.$ge.fromString(Te))}}catch(Ce){this.m.error(Ce)}}};e.$c$b=dt,e.$c$b=dt=ft=Ee([ne(2,q.$2h),ne(3,z.$kj),ne(4,z.$lj),ne(5,N.$e9b),ne(6,x.$g9b),ne(7,m.$wi),ne(8,$e.$0N),ne(9,H.$nk),ne(10,B.$Cj),ne(11,st.$m9b)],dt)}),define(re[313],oe([0,1,15,46,7,23,8,51,14,33,3,47,13,9,68,4,35,25,21,42,99,308,10,17,238,250,24,64,202,16,222,93,78,218,92,20,225,5,79,27,80,278,126,287,52,286,95,249,34,53,70,55,39,234,232,2,40,266,69,227,115,121,270,264]),function(J,e,P,R,s,j,A,E,f,h,y,v,b,l,p,w,$,g,u,c,S,d,t,o,r,i,n,a,m,D,I,k,C,M,F,N,Z,Q,le,ce,ue,X,K,H,L,T,V,q,te,he,G,O,U,x,z,Y,W,B,_,ae,se,$e,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ye{main(){try{this.a()}catch(ke){console.error(ke.message),P.app.exit(1)}}async a(){(0,f.setUnexpectedErrorHandler)(Me=>console.error(Me));const[ke,pe,ee,fe,ge,Ie,je,We]=this.b();try{try{await this.d(ee,We,fe,ge,je)}catch(Me){throw this.f(ee,je,Me),Me}await ke.invokeFunction(async Me=>{const Je=Me.get(Q.$kj),Be=Me.get(N.$g9b),He=Me.get(D.$nk),Ve=Me.get(Q.$lj),ie=await this.e(Je,ee,Be,ke,je,!0);return u.Promises.writeFile(ee.mainLockfile,String(process.pid)).catch(de=>{Je.warn(`app#startup(): Error writing main lockfile: ${de.stack}`)}),Ie.logger=Ve.createLogger("main",{name:(0,t.localize)(0,null)}),y.Event.once(Be.onWillShutdown)(de=>{He.dispose(),fe.dispose(),de.join("instanceLockfile",u.Promises.unlink(ee.mainLockfile).catch(()=>{}))}),ke.createInstance(d.$c$b,ie,pe).startup()})}catch(Me){ke.invokeFunction(this.i,Me)}}b(){const ke=new F.$1h,pe=new Y.$Rc;process.once("exit",()=>pe.dispose());const ee={_serviceBrand:void 0,...le.default};ke.set(ce.$Cj,ee);const fe=new n.$f9b(this.j(),ee),ge=this.c(fe);ke.set(n.$e9b,fe);const Ie=new _.$L9b((0,Q.$yj)(fe),fe.logsHome);ke.set(_.$K9b,Ie);const je=new Z.$Z6b(Ie.getLogLevel()),We=pe.add(new ae.$fO(je,[new Q.$rj(Ie.getLogLevel())]));ke.set(Q.$kj,We);const Me=new I.$3p(We);ke.set(D.$nk,Me);const Je=new k.$pq(We);Me.registerProvider(b.Schemas.file,Je);const Be=new B.$Or(Me);ke.set(W.$Xk,Be);const He=new $e.$aO(1,fe,We,Me);ke.set(te.$9N,He),ke.set(te.$0N,He);const Ve=new O.$n9b(He,Be,fe,Me,We);ke.set(O.$m9b,Ve),Me.registerProvider(b.Schemas.vscodeUserData,new me.$n$b(b.Schemas.file,Je,b.Schemas.vscodeUserData,Ve,Be,We));const ie=w.$i&&ee.win32RegValueName?pe.add(new x.$l$b(We,ee.win32RegValueName)):fe.policyFile?pe.add(new z.$m$b(fe.policyFile,Me,We)):new U.$zn;ke.set(U.$xn,ie);const de=new r.$Zn(Ve.defaultProfile.settingsResource,Me,ie,We);return ke.set(o.$wi,de),ke.set(N.$g9b,new C.$Zh(N.$h9b,void 0,!1)),ke.set(L.$8o,new C.$Zh(T.$j$b,void 0,!0)),ke.set(G.$s9b,new C.$Zh(G.$t9b)),ke.set(V.$fl,new C.$Zh(q.$k$b,void 0,!1)),ke.set(K.$nv,new C.$Zh(H.$h$b)),ke.set(ue.$A9b,new X.$e$b(fe,Ve,We)),[new M.$sq(ke,!0),ge,fe,de,He,je,ee,Ve]}c(ke){const pe={VSCODE_IPC_HOOK:ke.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ee=>{const fe=process.env[ee];typeof fe=="string"&&(pe[ee]=fe)}),Object.assign(process.env,pe),pe}async d(ke,pe,ee,fe,ge){await A.Promises.settled([Promise.all([ke.extensionsPath,ke.codeCachePath,ke.logsHome.with({scheme:b.Schemas.file}).fsPath,pe.defaultProfile.globalStorageHome.with({scheme:b.Schemas.file}).fsPath,ke.workspaceStorageHome.with({scheme:b.Schemas.file}).fsPath,ke.localHistoryHome.with({scheme:b.Schemas.file}).fsPath,ke.backupHome].map(Ie=>Ie?u.Promises.mkdir(Ie,{recursive:!0}):void 0)),fe.init(),ee.initialize()]),pe.init()}async e(ke,pe,ee,fe,ge,Ie){let je;try{(0,p.mark)("code/willStartMainServer"),je=await(0,S.$Xh)(pe.mainIPCHandle),(0,p.mark)("code/didStartMainServer"),y.Event.once(ee.onWillShutdown)(()=>je.dispose())}catch(We){if(We.code!=="EADDRINUSE")throw this.f(pe,ge,We),We;let Me;try{Me=await(0,S.$Yh)(pe.mainIPCHandle,"main")}catch(Ve){if(!Ie||w.$i||Ve.code!=="ECONNREFUSED")throw Ve.code==="EPERM"&&this.g((0,t.localize)(1,null,ge.nameShort),(0,t.localize)(2,null),ge),Ve;try{(0,R.unlinkSync)(pe.mainIPCHandle)}catch(ie){throw ke.warn("Could not delete obsolete instance handle",ie),ie}return this.e(ke,pe,ee,fe,ge,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const Ve=`Running extension tests from the command line is currently only supported if no other instance of ${ge.nameShort} is running.`;throw ke.error(Ve),Me.dispose(),new Error(Ve)}let Je;!pe.args.wait&&!pe.args.status&&(Je=setTimeout(()=>{this.g((0,t.localize)(3,null,ge.nameShort),(0,t.localize)(4,null),ge)},1e4));const Be=c.ProxyChannel.toService(Me.getChannel("launch"),{disableMarshalling:!0}),He=c.ProxyChannel.toService(Me.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return fe.invokeFunction(async()=>{const Ve=new i.$Vr(he.$Ao,ge),ie=await He.getMainDiagnostics(),de=await He.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),be=await Ve.getDiagnostics(ie,de);throw console.log(be),new f.$ab});throw w.$i&&await this.h(Be,ke),ke.trace("Sending env to running instance..."),await Be.start(pe.args,process.env),Me.dispose(),Je&&clearTimeout(Je),new f.$ab("Sent env to running instance. Terminating...")}if(pe.args.status)throw console.log((0,t.localize)(5,null,ge.nameShort)),new f.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),je}f(ke,pe,ee){if(ee.code==="EACCES"||ee.code==="EPERM"){const fe=(0,j.$Hb)([ke.userDataPath,ke.extensionsPath,S.$Th]).map(ge=>(0,v.$Iv)(s.URI.file(ge),{os:w.OS,tildify:ke}));this.g((0,t.localize)(6,null),(0,t.localize)(7,null,(0,E.$Ni)(ee),fe.join(`
`)),pe)}}g(ke,pe,ee){P.dialog.showMessageBoxSync((0,se.$Wv)({type:"warning",buttons:[(0,t.localize)(8,null)],message:ke,detail:pe},ee).options)}async h(ke,pe){if(w.$i){const ee=await ke.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",ee);try{(await new Promise((fe,ge)=>{J(["windows-foreground-love"],fe,ge)})).allowSetForegroundWindow(ee)}catch(fe){pe.error(fe)}}}i(ke,pe){const ee=ke.get(Q.$kj),fe=ke.get(N.$g9b);let ge=0;pe&&(pe.isExpected?pe.message&&ee.trace(pe.message):(ge=1,pe.stack?ee.error(pe.stack):ee.error(`Startup error: ${pe.toString()}`))),fe.kill(ge)}j(){const ke=this.k((0,a.$Zl)(process.argv));if(ke.wait&&!ke.waitMarkerFilePath){const pe=(0,m.$d$b)(ke.verbose);pe&&((0,a.$2l)(process.argv,"--waitMarkerFilePath",pe),ke.waitMarkerFilePath=pe)}return ke}k(ke){if(ke["open-url"]&&(ke._urls=ke._,ke._=[]),!ke.remote){const pe=this.l(ke._,ke.goto);ke._=pe}return ke}l(ke,pe){const ee=(0,$.cwd)(),fe=ke.map(je=>{let We=String(je),Me;pe&&(Me=(0,h.$_f)(We),We=Me.path),We&&(We=this.m(ee,We));const Je=(0,h.$7f)(We,ee),Be=(0,l.$nc)(Je);return Be&&!(0,h.$3f)(Be)?null:pe&&Me?(Me.path=Je,this.n(Me)):Je}),ge=w.$i||w.$j,Ie=(0,j.$Mb)(fe,je=>je&&ge?je.toLowerCase():je||"");return(0,j.$Hb)(Ie)}m(ke,pe){return w.$i&&(pe=(0,g.$Re)(pe,'"')),pe=(0,g.$Pe)((0,g.$Pe)(pe," "),"	"),w.$i&&(pe=(0,l.$kc)(ke,pe),pe=(0,g.$Re)(pe,".")),pe}n(ke){const pe=[ke.path];return typeof ke.line=="number"&&pe.push(String(ke.line)),typeof ke.column=="number"&&pe.push(String(ke.column)),pe.join(":")}}new ye().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a017b12b9caa3475675cfe6fda014fcf5af388c9/core/vs/code/electron-main/main.js.map
