/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/common/lifecycle","vs/base/browser/dom","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/strings","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/nls","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/browser/event","vs/base/common/lazy","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/common/map","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],$e=function(ie){for(var t=[],A=0,C=ie.length;A<C;A++)t[A]=be[ie[A]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:zt,setPrototypeOf:jt,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:ot,seal:ft,create:ri}=Object,{apply:Nt,construct:Ct}=typeof Reflect<"u"&&Reflect;Nt||(Nt=function(t,A,C){return t.apply(A,C)}),ot||(ot=function(t){return t}),ft||(ft=function(t){return t}),Ct||(Ct=function(t,A){return new t(...A)});const oi=ct(Array.prototype.forEach),Ht=ct(Array.prototype.pop),$t=ct(Array.prototype.push),yt=ct(String.prototype.toLowerCase),Rt=ct(String.prototype.toString),li=ct(String.prototype.match),dt=ct(String.prototype.replace),ai=ct(String.prototype.indexOf),hi=ct(String.prototype.trim),ht=ct(RegExp.prototype.test),pt=ui(TypeError);function ct(ie){return function(t){for(var A=arguments.length,C=new Array(A>1?A-1:0),n=1;n<A;n++)C[n-1]=arguments[n];return Nt(ie,t,C)}}function ui(ie){return function(){for(var t=arguments.length,A=new Array(t),C=0;C<t;C++)A[C]=arguments[C];return Ct(ie,A)}}function Ue(ie,t,A){var C;A=(C=A)!==null&&C!==void 0?C:yt,jt&&jt(ie,null);let n=t.length;for(;n--;){let j=t[n];if(typeof j=="string"){const E=A(j);E!==j&&(ii(t)||(t[n]=E),j=E)}ie[j]=!0}return ie}function mt(ie){const t=ri(null);for(const[A,C]of zt(ie))t[A]=C;return t}function Et(ie,t){for(;ie!==null;){const C=si(ie,t);if(C){if(C.get)return ct(C.get);if(typeof C.value=="function")return ct(C.value)}ie=ni(ie)}function A(C){return console.warn("fallback value for",C),null}return A}const Ut=ot(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Tt=ot(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Lt=ot(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=ot(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),It=ot(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=ot(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Wt=ot(["#text"]),Qt=ot(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Ot=ot(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),qt=ot(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),At=ot(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=ft(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=ft(/<%[\w\W]*|[\w\W]*%>/gm),mi=ft(/\${[\w\W]*}/gm),bi=ft(/^data-[\-\w.\u00B7-\uFFFF]/),$i=ft(/^aria-[\-\w]+$/),_t=ft(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=ft(/^(?:\w+script|data):/i),wi=ft(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Vt=ft(/^html$/i);var Kt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:bi,ARIA_ATTR:$i,IS_ALLOWED_URI:_t,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:wi,DOCTYPE_NAME:Vt});const vi=()=>typeof window>"u"?null:window,Di=function(t,A){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let C=null;const n="data-tt-policy-suffix";A&&A.hasAttribute(n)&&(C=A.getAttribute(n));const j="dompurify"+(C?"#"+C:"");try{return t.createPolicy(j,{createHTML(E){return E},createScriptURL(E){return E}})}catch{return console.warn("TrustedTypes policy "+j+" could not be created."),null}};function xt(){let ie=arguments.length>0&&arguments[0]!==void 0?arguments[0]:vi();const t=ze=>xt(ze);if(t.version="3.0.5",t.removed=[],!ie||!ie.document||ie.document.nodeType!==9)return t.isSupported=!1,t;const A=ie.document,C=A.currentScript;let{document:n}=ie;const{DocumentFragment:j,HTMLTemplateElement:E,Node:k,Element:m,NodeFilter:w,NamedNodeMap:y=ie.NamedNodeMap||ie.MozNamedAttrMap,HTMLFormElement:L,DOMParser:l,trustedTypes:h}=ie,e=m.prototype,s=Et(e,"cloneNode"),g=Et(e,"nextSibling"),$=Et(e,"childNodes"),o=Et(e,"parentNode");if(typeof E=="function"){const ze=n.createElement("template");ze.content&&ze.content.ownerDocument&&(n=ze.content.ownerDocument)}let a,D="";const{implementation:b,createNodeIterator:f,createDocumentFragment:N,getElementsByTagName:O}=n,{importNode:T}=A;let p={};t.isSupported=typeof zt=="function"&&typeof o=="function"&&b&&b.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:S,ERB_EXPR:M,TMPLIT_EXPR:U,DATA_ATTR:_,ARIA_ATTR:P,IS_SCRIPT_OR_DATA:I,ATTR_WHITESPACE:B}=Kt;let{IS_ALLOWED_URI:X}=Kt,Y=null;const ue=Ue({},[...Ut,...Tt,...Lt,...It,...Wt]);let ne=null;const te=Ue({},[...Qt,...Ot,...qt,...At]);let we=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Te=null,Pe=null,Oe=!0,re=!0,Z=!1,ae=!0,K=!1,H=!1,J=!1,me=!1,ve=!1,Fe=!1,Ae=!1,ge=!0,v=!1;const i="user-content-";let r=!0,c=!1,u={},d=null;const F=Ue({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let R=null;const W=Ue({},["audio","video","img","source","image","track"]);let z=null;const q=Ue({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),G="http://www.w3.org/1998/Math/MathML",oe="http://www.w3.org/2000/svg",se="http://www.w3.org/1999/xhtml";let de=se,De=!1,pe=null;const Re=Ue({},[G,oe,se],Rt);let Se;const Me=["application/xhtml+xml","text/html"],Be="text/html";let Ie,Ze=null;const Ke=n.createElement("form"),xe=function(he){return he instanceof RegExp||he instanceof Function},x=function(he){if(!(Ze&&Ze===he)){if((!he||typeof he!="object")&&(he={}),he=mt(he),Se=Me.indexOf(he.PARSER_MEDIA_TYPE)===-1?Se=Be:Se=he.PARSER_MEDIA_TYPE,Ie=Se==="application/xhtml+xml"?Rt:yt,Y="ALLOWED_TAGS"in he?Ue({},he.ALLOWED_TAGS,Ie):ue,ne="ALLOWED_ATTR"in he?Ue({},he.ALLOWED_ATTR,Ie):te,pe="ALLOWED_NAMESPACES"in he?Ue({},he.ALLOWED_NAMESPACES,Rt):Re,z="ADD_URI_SAFE_ATTR"in he?Ue(mt(q),he.ADD_URI_SAFE_ATTR,Ie):q,R="ADD_DATA_URI_TAGS"in he?Ue(mt(W),he.ADD_DATA_URI_TAGS,Ie):W,d="FORBID_CONTENTS"in he?Ue({},he.FORBID_CONTENTS,Ie):F,Te="FORBID_TAGS"in he?Ue({},he.FORBID_TAGS,Ie):{},Pe="FORBID_ATTR"in he?Ue({},he.FORBID_ATTR,Ie):{},u="USE_PROFILES"in he?he.USE_PROFILES:!1,Oe=he.ALLOW_ARIA_ATTR!==!1,re=he.ALLOW_DATA_ATTR!==!1,Z=he.ALLOW_UNKNOWN_PROTOCOLS||!1,ae=he.ALLOW_SELF_CLOSE_IN_ATTR!==!1,K=he.SAFE_FOR_TEMPLATES||!1,H=he.WHOLE_DOCUMENT||!1,ve=he.RETURN_DOM||!1,Fe=he.RETURN_DOM_FRAGMENT||!1,Ae=he.RETURN_TRUSTED_TYPE||!1,me=he.FORCE_BODY||!1,ge=he.SANITIZE_DOM!==!1,v=he.SANITIZE_NAMED_PROPS||!1,r=he.KEEP_CONTENT!==!1,c=he.IN_PLACE||!1,X=he.ALLOWED_URI_REGEXP||_t,de=he.NAMESPACE||se,we=he.CUSTOM_ELEMENT_HANDLING||{},he.CUSTOM_ELEMENT_HANDLING&&xe(he.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(we.tagNameCheck=he.CUSTOM_ELEMENT_HANDLING.tagNameCheck),he.CUSTOM_ELEMENT_HANDLING&&xe(he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(we.attributeNameCheck=he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),he.CUSTOM_ELEMENT_HANDLING&&typeof he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(we.allowCustomizedBuiltInElements=he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),K&&(re=!1),Fe&&(ve=!0),u&&(Y=Ue({},[...Wt]),ne=[],u.html===!0&&(Ue(Y,Ut),Ue(ne,Qt)),u.svg===!0&&(Ue(Y,Tt),Ue(ne,Ot),Ue(ne,At)),u.svgFilters===!0&&(Ue(Y,Lt),Ue(ne,Ot),Ue(ne,At)),u.mathMl===!0&&(Ue(Y,It),Ue(ne,qt),Ue(ne,At))),he.ADD_TAGS&&(Y===ue&&(Y=mt(Y)),Ue(Y,he.ADD_TAGS,Ie)),he.ADD_ATTR&&(ne===te&&(ne=mt(ne)),Ue(ne,he.ADD_ATTR,Ie)),he.ADD_URI_SAFE_ATTR&&Ue(z,he.ADD_URI_SAFE_ATTR,Ie),he.FORBID_CONTENTS&&(d===F&&(d=mt(d)),Ue(d,he.FORBID_CONTENTS,Ie)),r&&(Y["#text"]=!0),H&&Ue(Y,["html","head","body"]),Y.table&&(Ue(Y,["tbody"]),delete Te.tbody),he.TRUSTED_TYPES_POLICY){if(typeof he.TRUSTED_TYPES_POLICY.createHTML!="function")throw pt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof he.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw pt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');a=he.TRUSTED_TYPES_POLICY,D=a.createHTML("")}else a===void 0&&(a=Di(h,C)),a!==null&&typeof D=="string"&&(D=a.createHTML(""));ot&&ot(he),Ze=he}},le=Ue({},["mi","mo","mn","ms","mtext"]),fe=Ue({},["foreignobject","desc","title","annotation-xml"]),Ee=Ue({},["title","style","font","a","script"]),Ne=Ue({},Tt);Ue(Ne,Lt),Ue(Ne,ci);const je=Ue({},It);Ue(je,fi);const Qe=function(he){let ke=o(he);(!ke||!ke.tagName)&&(ke={namespaceURI:de,tagName:"template"});const Ce=yt(he.tagName),We=yt(ke.tagName);return pe[he.namespaceURI]?he.namespaceURI===oe?ke.namespaceURI===se?Ce==="svg":ke.namespaceURI===G?Ce==="svg"&&(We==="annotation-xml"||le[We]):!!Ne[Ce]:he.namespaceURI===G?ke.namespaceURI===se?Ce==="math":ke.namespaceURI===oe?Ce==="math"&&fe[We]:!!je[Ce]:he.namespaceURI===se?ke.namespaceURI===oe&&!fe[We]||ke.namespaceURI===G&&!le[We]?!1:!je[Ce]&&(Ee[Ce]||!Ne[Ce]):!!(Se==="application/xhtml+xml"&&pe[he.namespaceURI]):!1},_e=function(he){$t(t.removed,{element:he});try{he.parentNode.removeChild(he)}catch{he.remove()}},et=function(he,ke){try{$t(t.removed,{attribute:ke.getAttributeNode(he),from:ke})}catch{$t(t.removed,{attribute:null,from:ke})}if(ke.removeAttribute(he),he==="is"&&!ne[he])if(ve||Fe)try{_e(ke)}catch{}else try{ke.setAttribute(he,"")}catch{}},tt=function(he){let ke,Ce;if(me)he="<remove></remove>"+he;else{const at=li(he,/^[\r\n\t ]+/);Ce=at&&at[0]}Se==="application/xhtml+xml"&&de===se&&(he='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+he+"</body></html>");const We=a?a.createHTML(he):he;if(de===se)try{ke=new l().parseFromString(We,Se)}catch{}if(!ke||!ke.documentElement){ke=b.createDocument(de,"template",null);try{ke.documentElement.innerHTML=De?D:We}catch{}}const it=ke.body||ke.documentElement;return he&&Ce&&it.insertBefore(n.createTextNode(Ce),it.childNodes[0]||null),de===se?O.call(ke,H?"html":"body")[0]:H?ke.documentElement:it},Je=function(he){return f.call(he.ownerDocument||he,he,w.SHOW_ELEMENT|w.SHOW_COMMENT|w.SHOW_TEXT,null,!1)},nt=function(he){return he instanceof L&&(typeof he.nodeName!="string"||typeof he.textContent!="string"||typeof he.removeChild!="function"||!(he.attributes instanceof y)||typeof he.removeAttribute!="function"||typeof he.setAttribute!="function"||typeof he.namespaceURI!="string"||typeof he.insertBefore!="function"||typeof he.hasChildNodes!="function")},st=function(he){return typeof k=="object"?he instanceof k:he&&typeof he=="object"&&typeof he.nodeType=="number"&&typeof he.nodeName=="string"},rt=function(he,ke,Ce){p[he]&&oi(p[he],We=>{We.call(t,ke,Ce,Ze)})},gt=function(he){let ke;if(rt("beforeSanitizeElements",he,null),nt(he))return _e(he),!0;const Ce=Ie(he.nodeName);if(rt("uponSanitizeElement",he,{tagName:Ce,allowedTags:Y}),he.hasChildNodes()&&!st(he.firstElementChild)&&(!st(he.content)||!st(he.content.firstElementChild))&&ht(/<[/\w]/g,he.innerHTML)&&ht(/<[/\w]/g,he.textContent))return _e(he),!0;if(!Y[Ce]||Te[Ce]){if(!Te[Ce]&&St(Ce)&&(we.tagNameCheck instanceof RegExp&&ht(we.tagNameCheck,Ce)||we.tagNameCheck instanceof Function&&we.tagNameCheck(Ce)))return!1;if(r&&!d[Ce]){const We=o(he)||he.parentNode,it=$(he)||he.childNodes;if(it&&We){const at=it.length;for(let Ve=at-1;Ve>=0;--Ve)We.insertBefore(s(it[Ve],!0),g(he))}}return _e(he),!0}return he instanceof m&&!Qe(he)||(Ce==="noscript"||Ce==="noembed"||Ce==="noframes")&&ht(/<\/no(script|embed|frames)/i,he.innerHTML)?(_e(he),!0):(K&&he.nodeType===3&&(ke=he.textContent,ke=dt(ke,S," "),ke=dt(ke,M," "),ke=dt(ke,U," "),he.textContent!==ke&&($t(t.removed,{element:he.cloneNode()}),he.textContent=ke)),rt("afterSanitizeElements",he,null),!1)},kt=function(he,ke,Ce){if(ge&&(ke==="id"||ke==="name")&&(Ce in n||Ce in Ke))return!1;if(!(re&&!Pe[ke]&&ht(_,ke))){if(!(Oe&&ht(P,ke))){if(!ne[ke]||Pe[ke]){if(!(St(he)&&(we.tagNameCheck instanceof RegExp&&ht(we.tagNameCheck,he)||we.tagNameCheck instanceof Function&&we.tagNameCheck(he))&&(we.attributeNameCheck instanceof RegExp&&ht(we.attributeNameCheck,ke)||we.attributeNameCheck instanceof Function&&we.attributeNameCheck(ke))||ke==="is"&&we.allowCustomizedBuiltInElements&&(we.tagNameCheck instanceof RegExp&&ht(we.tagNameCheck,Ce)||we.tagNameCheck instanceof Function&&we.tagNameCheck(Ce))))return!1}else if(!z[ke]){if(!ht(X,dt(Ce,B,""))){if(!((ke==="src"||ke==="xlink:href"||ke==="href")&&he!=="script"&&ai(Ce,"data:")===0&&R[he])){if(!(Z&&!ht(I,dt(Ce,B,"")))){if(Ce)return!1}}}}}}return!0},St=function(he){return he.indexOf("-")>0},wt=function(he){let ke,Ce,We,it;rt("beforeSanitizeAttributes",he,null);const{attributes:at}=he;if(!at)return;const Ve={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:ne};for(it=at.length;it--;){ke=at[it];const{name:ut,namespaceURI:vt}=ke;if(Ce=ut==="value"?ke.value:hi(ke.value),We=Ie(ut),Ve.attrName=We,Ve.attrValue=Ce,Ve.keepAttr=!0,Ve.forceKeepAttr=void 0,rt("uponSanitizeAttribute",he,Ve),Ce=Ve.attrValue,Ve.forceKeepAttr||(et(ut,he),!Ve.keepAttr))continue;if(!ae&&ht(/\/>/i,Ce)){et(ut,he);continue}K&&(Ce=dt(Ce,S," "),Ce=dt(Ce,M," "),Ce=dt(Ce,U," "));const Ft=Ie(he.nodeName);if(kt(Ft,We,Ce)){if(v&&(We==="id"||We==="name")&&(et(ut,he),Ce=i+Ce),a&&typeof h=="object"&&typeof h.getAttributeType=="function"&&!vt)switch(h.getAttributeType(Ft,We)){case"TrustedHTML":{Ce=a.createHTML(Ce);break}case"TrustedScriptURL":{Ce=a.createScriptURL(Ce);break}}try{vt?he.setAttributeNS(vt,ut,Ce):he.setAttribute(ut,Ce),Ht(t.removed)}catch{}}}rt("afterSanitizeAttributes",he,null)},Mt=function ze(he){let ke;const Ce=Je(he);for(rt("beforeSanitizeShadowDOM",he,null);ke=Ce.nextNode();)rt("uponSanitizeShadowNode",ke,null),!gt(ke)&&(ke.content instanceof j&&ze(ke.content),wt(ke));rt("afterSanitizeShadowDOM",he,null)};return t.sanitize=function(ze){let he=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},ke,Ce,We,it;if(De=!ze,De&&(ze="<!-->"),typeof ze!="string"&&!st(ze))if(typeof ze.toString=="function"){if(ze=ze.toString(),typeof ze!="string")throw pt("dirty is not a string, aborting")}else throw pt("toString is not a function");if(!t.isSupported)return ze;if(J||x(he),t.removed=[],typeof ze=="string"&&(c=!1),c){if(ze.nodeName){const ut=Ie(ze.nodeName);if(!Y[ut]||Te[ut])throw pt("root node is forbidden and cannot be sanitized in-place")}}else if(ze instanceof k)ke=tt("<!---->"),Ce=ke.ownerDocument.importNode(ze,!0),Ce.nodeType===1&&Ce.nodeName==="BODY"||Ce.nodeName==="HTML"?ke=Ce:ke.appendChild(Ce);else{if(!ve&&!K&&!H&&ze.indexOf("<")===-1)return a&&Ae?a.createHTML(ze):ze;if(ke=tt(ze),!ke)return ve?null:Ae?D:""}ke&&me&&_e(ke.firstChild);const at=Je(c?ze:ke);for(;We=at.nextNode();)gt(We)||(We.content instanceof j&&Mt(We.content),wt(We));if(c)return ze;if(ve){if(Fe)for(it=N.call(ke.ownerDocument);ke.firstChild;)it.appendChild(ke.firstChild);else it=ke;return(ne.shadowroot||ne.shadowrootmode)&&(it=T.call(A,it,!0)),it}let Ve=H?ke.outerHTML:ke.innerHTML;return H&&Y["!doctype"]&&ke.ownerDocument&&ke.ownerDocument.doctype&&ke.ownerDocument.doctype.name&&ht(Vt,ke.ownerDocument.doctype.name)&&(Ve="<!DOCTYPE "+ke.ownerDocument.doctype.name+`>
`+Ve),K&&(Ve=dt(Ve,S," "),Ve=dt(Ve,M," "),Ve=dt(Ve,U," ")),a&&Ae?a.createHTML(Ve):Ve},t.setConfig=function(ze){x(ze),J=!0},t.clearConfig=function(){Ze=null,J=!1},t.isValidAttribute=function(ze,he,ke){Ze||x({});const Ce=Ie(ze),We=Ie(he);return kt(Ce,We,ke)},t.addHook=function(ze,he){typeof he=="function"&&(p[ze]=p[ze]||[],$t(p[ze],he))},t.removeHook=function(ze){if(p[ze])return Ht(p[ze])},t.removeHooks=function(ze){p[ze]&&(p[ze]=[])},t.removeAllHooks=function(){p={}},t}var yi=xt();define("vs/base/browser/dompurify/dompurify",function(){return yi}),define(be[41],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WQ=t.$VQ=void 0;class A{constructor(E){this.domNode=E,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(E){const k=C(E);this.a!==k&&(this.a=k,this.domNode.style.maxWidth=this.a)}setWidth(E){const k=C(E);this.b!==k&&(this.b=k,this.domNode.style.width=this.b)}setHeight(E){const k=C(E);this.c!==k&&(this.c=k,this.domNode.style.height=this.c)}setTop(E){const k=C(E);this.d!==k&&(this.d=k,this.domNode.style.top=this.d)}setLeft(E){const k=C(E);this.e!==k&&(this.e=k,this.domNode.style.left=this.e)}setBottom(E){const k=C(E);this.f!==k&&(this.f=k,this.domNode.style.bottom=this.f)}setRight(E){const k=C(E);this.g!==k&&(this.g=k,this.domNode.style.right=this.g)}setPaddingTop(E){const k=C(E);this.h!==k&&(this.h=k,this.domNode.style.paddingTop=this.h)}setPaddingLeft(E){const k=C(E);this.i!==k&&(this.i=k,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(E){const k=C(E);this.j!==k&&(this.j=k,this.domNode.style.paddingBottom=this.j)}setPaddingRight(E){const k=C(E);this.k!==k&&(this.k=k,this.domNode.style.paddingRight=this.k)}setFontFamily(E){this.l!==E&&(this.l=E,this.domNode.style.fontFamily=this.l)}setFontWeight(E){this.m!==E&&(this.m=E,this.domNode.style.fontWeight=this.m)}setFontSize(E){const k=C(E);this.n!==k&&(this.n=k,this.domNode.style.fontSize=this.n)}setFontStyle(E){this.o!==E&&(this.o=E,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(E){this.p!==E&&(this.p=E,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(E){this.q!==E&&(this.q=E,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(E){this.r!==E&&(this.r=E,this.domNode.style.textDecoration=this.r)}setLineHeight(E){const k=C(E);this.s!==k&&(this.s=k,this.domNode.style.lineHeight=this.s)}setLetterSpacing(E){const k=C(E);this.t!==k&&(this.t=k,this.domNode.style.letterSpacing=this.t)}setClassName(E){this.u!==E&&(this.u=E,this.domNode.className=this.u)}toggleClassName(E,k){this.domNode.classList.toggle(E,k),this.u=this.domNode.className}setDisplay(E){this.v!==E&&(this.v=E,this.domNode.style.display=this.v)}setPosition(E){this.w!==E&&(this.w=E,this.domNode.style.position=this.w)}setVisibility(E){this.x!==E&&(this.x=E,this.domNode.style.visibility=this.x)}setColor(E){this.y!==E&&(this.y=E,this.domNode.style.color=this.y)}setBackgroundColor(E){this.z!==E&&(this.z=E,this.domNode.style.backgroundColor=this.z)}setLayerHinting(E){this.A!==E&&(this.A=E,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(E){this.C!==E&&(this.C=E,this.domNode.style.boxShadow=E)}setContain(E){this.B!==E&&(this.B=E,this.domNode.style.contain=this.B)}setAttribute(E,k){this.domNode.setAttribute(E,k)}removeAttribute(E){this.domNode.removeAttribute(E)}appendChild(E){this.domNode.appendChild(E.domNode)}removeChild(E){this.domNode.removeChild(E.domNode)}}t.$VQ=A;function C(j){return typeof j=="number"?`${j}px`:j}function n(j){return new A(j)}t.$WQ=n}),define(be[69],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cP=t.$bP=void 0;const A=new WeakMap;function C(k){if(!k.parent||k.parent===k)return null;try{const m=k.location,w=k.parent.location;if(m.origin!=="null"&&w.origin!=="null"&&m.origin!==w.origin)return null}catch{return null}return k.parent}class n{static a(m){let w=A.get(m);if(!w){w=[],A.set(m,w);let y=m,L;do L=C(y),L?w.push({window:new WeakRef(y),iframeElement:y.frameElement||null}):w.push({window:new WeakRef(y),iframeElement:null}),y=L;while(y)}return w.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(m,w){if(!w||m===w)return{top:0,left:0};let y=0,L=0;const l=this.a(m);for(const h of l){const e=h.window.deref();if(y+=e?.scrollY??0,L+=e?.scrollX??0,e===w||!h.iframeElement)break;const s=h.iframeElement.getBoundingClientRect();y+=s.top,L+=s.left}return{top:y,left:L}}}t.$bP=n;async function j(k,m){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const w=JSON.stringify({parentOrigin:k,salt:m}),L=new TextEncoder().encode(w),l=await crypto.subtle.digest("sha-256",L);return E(l)}t.$cP=j;function E(k){const w=Array.from(new Uint8Array(k)).map(y=>y.toString(16).padStart(2,"0")).join("");return BigInt(`0x${w}`).toString(32).padStart(52,"0")}}),define(be[70],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tR=t.$sR=t.$rR=t.ListDragOverEffect=void 0;var A;(function(j){j[j.Copy=0]="Copy",j[j.Move=1]="Move"})(A||(t.ListDragOverEffect=A={})),t.$rR={reject(){return{accept:!1}},accept(){return{accept:!0}}};class C extends Error{constructor(E,k){super(`ListError [${E}] ${k}`)}}t.$sR=C;class n{constructor(){this.c=new WeakMap}getHeight(E){return this.c.get(E)??this.d(E)}setDynamicHeight(E,k){k>0&&this.c.set(E,k)}}t.$tR=n}),define(be[71],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qR=void 0;class A{constructor(n){this.a=n}splice(n,j,E){this.a.forEach(k=>k.splice(n,j,E))}}t.$qR=A}),define(be[42],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2Q=void 0;const A=20;class C{constructor(j,E,k,m,w,y){this.a=Math.round(E),this.b=Math.round(k),this.c=Math.round(j),this.d=m,this.e=w,this.f=y,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new C(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(j){const E=Math.round(j);return this.d!==E?(this.d=E,this.m(),!0):!1}setScrollSize(j){const E=Math.round(j);return this.e!==E?(this.e=E,this.m(),!0):!1}setScrollPosition(j){const E=Math.round(j);return this.f!==E?(this.f=E,this.m(),!0):!1}setScrollbarSize(j){this.a=Math.round(j)}setOppositeScrollbarSize(j){this.b=Math.round(j)}static l(j,E,k,m,w){const y=Math.max(0,k-j),L=Math.max(0,y-2*E),l=m>0&&m>k;if(!l)return{computedAvailableSize:Math.round(y),computedIsNeeded:l,computedSliderSize:Math.round(L),computedSliderRatio:0,computedSliderPosition:0};const h=Math.round(Math.max(A,Math.floor(k*L/m))),e=(L-h)/(m-k),s=w*e;return{computedAvailableSize:Math.round(y),computedIsNeeded:l,computedSliderSize:Math.round(h),computedSliderRatio:e,computedSliderPosition:Math.round(s)}}m(){const j=C.l(this.b,this.c,this.d,this.e,this.f);this.g=j.computedAvailableSize,this.h=j.computedIsNeeded,this.i=j.computedSliderSize,this.j=j.computedSliderRatio,this.k=j.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(j){if(!this.h)return 0;const E=j-this.c-this.i/2;return Math.round(E/this.j)}getDesiredScrollPositionFromOffsetPaged(j){if(!this.h)return 0;const E=j-this.c;let k=this.f;return E<this.k?k-=this.d:k+=this.d,k}getDesiredScrollPositionFromDelta(j){if(!this.h)return 0;const E=this.k+j;return Math.round(E/this.j)}}t.$2Q=C}),define(be[26],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sT=t.$rT=t.$qT=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var A;(function(m){m[m.Hidden=0]="Hidden",m[m.Visible=1]="Visible",m[m.Recurse=2]="Recurse"})(A||(t.TreeVisibility=A={}));var C;(function(m){m[m.Expanded=0]="Expanded",m[m.Collapsed=1]="Collapsed",m[m.PreserveOrExpanded=2]="PreserveOrExpanded",m[m.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(C||(t.ObjectTreeElementCollapseState=C={}));var n;(function(m){m[m.Unknown=0]="Unknown",m[m.Twistie=1]="Twistie",m[m.Element=2]="Element",m[m.Filter=3]="Filter"})(n||(t.TreeMouseEventTarget=n={}));var j;(function(m){m[m.Down=0]="Down",m[m.Up=1]="Up"})(j||(t.TreeDragOverBubble=j={})),t.$qT={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(m=!1){return{accept:!0,bubble:0,autoExpand:m}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(m=!1){return{accept:!0,bubble:0,effect:0,autoExpand:m}}};class E extends Error{constructor(w,y){super(`TreeError [${w}] ${y}`)}}t.$rT=E;class k{constructor(w){this.a=w,this.b=new WeakMap}map(w){let y=this.b.get(w);return y||(y=this.a(w),this.b.set(w,y)),y}}t.$sT=k}),define(be[21],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SO=t.$window=t.$QO=t.$PO=void 0;function A(n,j){const E=n;typeof E.vscodeWindowId!="number"&&Object.defineProperty(E,"vscodeWindowId",{get:()=>j})}t.$PO=A,t.$QO=window,t.$window=t.$QO;function C(n){return n===t.$QO?!1:typeof n?.vscodeWindowId=="number"}t.$SO=C}),define(be[72],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=void 0;function A(s,g,$){const o=C(s,g);if(o!==-1)return s[o]}t.$fb=A;function C(s,g,$=s.length-1){for(let o=$;o>=0;o--){const a=s[o];if(g(a))return o}return-1}t.$gb=C;function n(s,g){const $=j(s,g);return $===-1?void 0:s[$]}t.$hb=n;function j(s,g,$=0,o=s.length){let a=$,D=o;for(;a<D;){const b=Math.floor((a+D)/2);g(s[b])?a=b+1:D=b}return a-1}t.$ib=j;function E(s,g){const $=k(s,g);return $===s.length?void 0:s[$]}t.$jb=E;function k(s,g,$=0,o=s.length){let a=$,D=o;for(;a<D;){const b=Math.floor((a+D)/2);g(s[b])?D=b:a=b+1}return a}t.$kb=k;function m(s,g,$=0,o=s.length){const a=k(s,g,$,o);return a===s.length?-1:a}t.$lb=m;class w{static{this.assertInvariants=!1}constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(w.assertInvariants){if(this.d){for(const o of this.e)if(this.d(o)&&!g(o))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const $=j(this.e,g,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}t.$mb=w;function y(s,g){if(s.length===0)return;let $=s[0];for(let o=1;o<s.length;o++){const a=s[o];g(a,$)>0&&($=a)}return $}t.$nb=y;function L(s,g){if(s.length===0)return;let $=s[0];for(let o=1;o<s.length;o++){const a=s[o];g(a,$)>=0&&($=a)}return $}t.$ob=L;function l(s,g){return y(s,($,o)=>-g($,o))}t.$pb=l;function h(s,g){if(s.length===0)return-1;let $=0;for(let o=1;o<s.length;o++){const a=s[o];g(a,s[$])>0&&($=o)}return $}t.$qb=h;function e(s,g){for(const $ of s){const o=g($);if(o!==void 0)return o}}t.$rb=e}),define(be[73],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$N=t.$M=t.$L=t.$K=void 0;function A(E,k){const m=Object.create(null);for(const w of E){const y=k(w);let L=m[y];L||(L=m[y]=[]),L.push(w)}return m}t.$K=A;function C(E,k){const m=[],w=[];for(const y of E)k.has(y)||m.push(y);for(const y of k)E.has(y)||w.push(y);return{removed:m,added:w}}t.$L=C;function n(E,k){const m=[],w=[];for(const[y,L]of E)k.has(y)||m.push(L);for(const[y,L]of k)E.has(y)||w.push(L);return{removed:m,added:w}}t.$M=n;function j(E,k){const m=new Set;for(const w of k)E.has(w)&&m.add(w);return m}t.$N=j}),define(be[74],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$at=t.$_s=t.$$s=t.$0s=void 0;function A(k,m){const w=Math.pow(10,m);return Math.round(k*w)/w}class C{constructor(m,w,y,L=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,m))|0,this.g=Math.min(255,Math.max(0,w))|0,this.b=Math.min(255,Math.max(0,y))|0,this.a=A(Math.max(Math.min(1,L),0),3)}static equals(m,w){return m.r===w.r&&m.g===w.g&&m.b===w.b&&m.a===w.a}}t.$0s=C;class n{constructor(m,w,y,L){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=A(Math.max(Math.min(1,w),0),3),this.l=A(Math.max(Math.min(1,y),0),3),this.a=A(Math.max(Math.min(1,L),0),3)}static equals(m,w){return m.h===w.h&&m.s===w.s&&m.l===w.l&&m.a===w.a}static fromRGBA(m){const w=m.r/255,y=m.g/255,L=m.b/255,l=m.a,h=Math.max(w,y,L),e=Math.min(w,y,L);let s=0,g=0;const $=(e+h)/2,o=h-e;if(o>0){switch(g=Math.min($<=.5?o/(2*$):o/(2-2*$),1),h){case w:s=(y-L)/o+(y<L?6:0);break;case y:s=(L-w)/o+2;break;case L:s=(w-y)/o+4;break}s*=60,s=Math.round(s)}return new n(s,g,$,l)}static i(m,w,y){return y<0&&(y+=1),y>1&&(y-=1),y<1/6?m+(w-m)*6*y:y<1/2?w:y<2/3?m+(w-m)*(2/3-y)*6:m}static toRGBA(m){const w=m.h/360,{s:y,l:L,a:l}=m;let h,e,s;if(y===0)h=e=s=L;else{const g=L<.5?L*(1+y):L+y-L*y,$=2*L-g;h=n.i($,g,w+1/3),e=n.i($,g,w),s=n.i($,g,w-1/3)}return new C(Math.round(h*255),Math.round(e*255),Math.round(s*255),l)}}t.$$s=n;class j{constructor(m,w,y,L){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=A(Math.max(Math.min(1,w),0),3),this.v=A(Math.max(Math.min(1,y),0),3),this.a=A(Math.max(Math.min(1,L),0),3)}static equals(m,w){return m.h===w.h&&m.s===w.s&&m.v===w.v&&m.a===w.a}static fromRGBA(m){const w=m.r/255,y=m.g/255,L=m.b/255,l=Math.max(w,y,L),h=Math.min(w,y,L),e=l-h,s=l===0?0:e/l;let g;return e===0?g=0:l===w?g=((y-L)/e%6+6)%6:l===y?g=(L-w)/e+2:g=(w-y)/e+4,new j(Math.round(g*60),s,l,m.a)}static toRGBA(m){const{h:w,s:y,v:L,a:l}=m,h=L*y,e=h*(1-Math.abs(w/60%2-1)),s=L-h;let[g,$,o]=[0,0,0];return w<60?(g=h,$=e):w<120?(g=e,$=h):w<180?($=h,o=e):w<240?($=e,o=h):w<300?(g=e,o=h):w<=360&&(g=h,o=e),g=Math.round((g+s)*255),$=Math.round(($+s)*255),o=Math.round((o+s)*255),new C(g,$,o,l)}}t.$_s=j;class E{static fromHex(m){return E.Format.CSS.parseHex(m)||E.red}static equals(m,w){return!m&&!w?!0:!m||!w?!1:m.equals(w)}get hsla(){return this.i?this.i:n.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:j.fromRGBA(this.rgba)}constructor(m){if(m)if(m instanceof C)this.rgba=m;else if(m instanceof n)this.i=m,this.rgba=n.toRGBA(m);else if(m instanceof j)this.j=m,this.rgba=j.toRGBA(m);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(m){return!!m&&C.equals(this.rgba,m.rgba)&&n.equals(this.hsla,m.hsla)&&j.equals(this.hsva,m.hsva)}getRelativeLuminance(){const m=E.k(this.rgba.r),w=E.k(this.rgba.g),y=E.k(this.rgba.b),L=.2126*m+.7152*w+.0722*y;return A(L,4)}static k(m){const w=m/255;return w<=.03928?w/12.92:Math.pow((w+.055)/1.055,2.4)}getContrastRatio(m){const w=this.getRelativeLuminance(),y=m.getRelativeLuminance();return w>y?(w+.05)/(y+.05):(y+.05)/(w+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(m){const w=this.getRelativeLuminance(),y=m.getRelativeLuminance();return w>y}isDarkerThan(m){const w=this.getRelativeLuminance(),y=m.getRelativeLuminance();return w<y}lighten(m){return new E(new n(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*m,this.hsla.a))}darken(m){return new E(new n(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*m,this.hsla.a))}transparent(m){const{r:w,g:y,b:L,a:l}=this.rgba;return new E(new C(w,y,L,l*m))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new E(new C(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(m){const w=m.rgba,y=this.rgba.a,L=w.a,l=y+L*(1-y);if(l<1e-6)return E.transparent;const h=this.rgba.r*y/l+w.r*L*(1-y)/l,e=this.rgba.g*y/l+w.g*L*(1-y)/l,s=this.rgba.b*y/l+w.b*L*(1-y)/l;return new E(new C(h,e,s,l))}makeOpaque(m){if(this.isOpaque()||m.rgba.a!==1)return this;const{r:w,g:y,b:L,a:l}=this.rgba;return new E(new C(m.rgba.r-l*(m.rgba.r-w),m.rgba.g-l*(m.rgba.g-y),m.rgba.b-l*(m.rgba.b-L),1))}flatten(...m){const w=m.reduceRight((y,L)=>E.o(L,y));return E.o(this,w)}static o(m,w){const y=1-m.rgba.a;return new E(new C(y*w.rgba.r+m.rgba.a*m.rgba.r,y*w.rgba.g+m.rgba.a*m.rgba.g,y*w.rgba.b+m.rgba.a*m.rgba.b))}toString(){return this.u||(this.u=E.Format.CSS.format(this)),this.u}static getLighterColor(m,w,y){if(m.isLighterThan(w))return m;y=y||.5;const L=m.getRelativeLuminance(),l=w.getRelativeLuminance();return y=y*(l-L)/l,m.lighten(y)}static getDarkerColor(m,w,y){if(m.isDarkerThan(w))return m;y=y||.5;const L=m.getRelativeLuminance(),l=w.getRelativeLuminance();return y=y*(L-l)/L,m.darken(y)}static{this.white=new E(new C(255,255,255,1))}static{this.black=new E(new C(0,0,0,1))}static{this.red=new E(new C(255,0,0,1))}static{this.blue=new E(new C(0,0,255,1))}static{this.green=new E(new C(0,255,0,1))}static{this.cyan=new E(new C(0,255,255,1))}static{this.lightgrey=new E(new C(211,211,211,1))}static{this.transparent=new E(new C(0,0,0,0))}}t.$at=E,function(k){let m;(function(w){let y;(function(L){function l(f){return f.rgba.a===1?`rgb(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b})`:k.Format.CSS.formatRGBA(f)}L.formatRGB=l;function h(f){return`rgba(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b}, ${+f.rgba.a.toFixed(2)})`}L.formatRGBA=h;function e(f){return f.hsla.a===1?`hsl(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%)`:k.Format.CSS.formatHSLA(f)}L.formatHSL=e;function s(f){return`hsla(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%, ${f.hsla.a.toFixed(2)})`}L.formatHSLA=s;function g(f){const N=f.toString(16);return N.length!==2?"0"+N:N}function $(f){return`#${g(f.rgba.r)}${g(f.rgba.g)}${g(f.rgba.b)}`}L.formatHex=$;function o(f,N=!1){return N&&f.rgba.a===1?k.Format.CSS.formatHex(f):`#${g(f.rgba.r)}${g(f.rgba.g)}${g(f.rgba.b)}${g(Math.round(f.rgba.a*255))}`}L.formatHexA=o;function a(f){return f.isOpaque()?k.Format.CSS.formatHex(f):k.Format.CSS.formatRGBA(f)}L.format=a;function D(f){const N=f.length;if(N===0||f.charCodeAt(0)!==35)return null;if(N===7){const O=16*b(f.charCodeAt(1))+b(f.charCodeAt(2)),T=16*b(f.charCodeAt(3))+b(f.charCodeAt(4)),p=16*b(f.charCodeAt(5))+b(f.charCodeAt(6));return new k(new C(O,T,p,1))}if(N===9){const O=16*b(f.charCodeAt(1))+b(f.charCodeAt(2)),T=16*b(f.charCodeAt(3))+b(f.charCodeAt(4)),p=16*b(f.charCodeAt(5))+b(f.charCodeAt(6)),S=16*b(f.charCodeAt(7))+b(f.charCodeAt(8));return new k(new C(O,T,p,S/255))}if(N===4){const O=b(f.charCodeAt(1)),T=b(f.charCodeAt(2)),p=b(f.charCodeAt(3));return new k(new C(16*O+O,16*T+T,16*p+p))}if(N===5){const O=b(f.charCodeAt(1)),T=b(f.charCodeAt(2)),p=b(f.charCodeAt(3)),S=b(f.charCodeAt(4));return new k(new C(16*O+O,16*T+T,16*p+p,(16*S+S)/255))}return null}L.parseHex=D;function b(f){switch(f){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(y=w.CSS||(w.CSS={}))})(m=k.Format||(k.Format={}))}(E||(t.$at=E={}))}),define(be[27],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wh=t.$vh=t.$uh=void 0;function A(E){return(k,m,w)=>{let y=null,L=null;if(typeof w.value=="function"?(y="value",L=w.value):typeof w.get=="function"&&(y="get",L=w.get),!L)throw new Error("not supported");w[y]=E(L,m)}}function C(E,k,m){let w=null,y=null;if(typeof m.value=="function"?(w="value",y=m.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(w="get",y=m.get),!y)throw new Error("not supported");const L=`$memoize$${k}`;m[w]=function(...l){return this.hasOwnProperty(L)||Object.defineProperty(this,L,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,l)}),this[L]}}t.$uh=C;function n(E,k,m){return A((w,y)=>{const L=`$debounce$${y}`,l=`$debounce$result$${y}`;return function(...h){this[l]||(this[l]=m?m():void 0),clearTimeout(this[L]),k&&(this[l]=k(this[l],...h),h=[this[l]]),this[L]=setTimeout(()=>{w.apply(this,h),this[l]=m?m():void 0},E)}})}t.$vh=n;function j(E,k,m){return A((w,y)=>{const L=`$throttle$timer$${y}`,l=`$throttle$result$${y}`,h=`$throttle$lastRun$${y}`,e=`$throttle$pending$${y}`;return function(...s){if(this[l]||(this[l]=m?m():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),k&&(this[l]=k(this[l],...s)),this[e])return;const g=this[h]+E;g<=Date.now()?(this[h]=Date.now(),w.apply(this,[this[l]]),this[l]=m?m():void 0):(this[e]=!0,this[L]=setTimeout(()=>{this[e]=!1,this[h]=Date.now(),w.apply(this,[this[l]]),this[l]=m?m():void 0},g-Date.now()))}})}t.$wh=j}),define(be[75],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ls=void 0;class A{constructor(n,j,E,k){this.originalStart=n,this.originalLength=j,this.modifiedStart=E,this.modifiedLength=k}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$Ls=A}),define(be[6],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.setUnexpectedErrorHandler=t.$X=t.$W=void 0;class A{constructor(){this.b=[],this.a=function(f){setTimeout(()=>{throw f.stack?a.isErrorNoTelemetry(f)?new a(f.message+`

`+f.stack):new Error(f.message+`

`+f.stack):f},0)}}addListener(f){return this.b.push(f),()=>{this.d(f)}}c(f){this.b.forEach(N=>{N(f)})}d(f){this.b.splice(this.b.indexOf(f),1)}setUnexpectedErrorHandler(f){this.a=f}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(f){this.a(f),this.c(f)}onUnexpectedExternalError(f){this.a(f)}}t.$W=A,t.$X=new A;function C(b){t.$X.setUnexpectedErrorHandler(b)}t.setUnexpectedErrorHandler=C;function n(b){if(!b||typeof b!="object")return!1;const f=b;return f.code==="EPIPE"&&f.syscall?.toUpperCase()==="WRITE"}t.$Z=n;function j(b){w(b)||t.$X.onUnexpectedError(b)}t.$1=j;function E(b){w(b)||t.$X.onUnexpectedExternalError(b)}t.$2=E;function k(b){if(b instanceof Error){const{name:f,message:N}=b,O=b.stacktrace||b.stack;return{$isError:!0,name:f,message:N,stack:O,noTelemetry:a.isErrorNoTelemetry(b)}}return b}t.$3=k;const m="Canceled";function w(b){return b instanceof y?!0:b instanceof Error&&b.name===m&&b.message===m}t.$4=w;class y extends Error{constructor(){super(m),this.name=this.message}}t.$5=y;function L(){const b=new Error(m);return b.name=b.message,b}t.$6=L;function l(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}t.$7=l;function h(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}t.$8=h;class e extends TypeError{constructor(f){super(f?`${f} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function s(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}t.$0=s;class g extends Error{constructor(f){super("NotImplemented"),f&&(this.message=f)}}t.$$=g;class $ extends Error{constructor(f){super("NotSupported"),f&&(this.message=f)}}t.$_=$;class o extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=o;class a extends Error{constructor(f){super(f),this.name="CodeExpectedError"}static fromError(f){if(f instanceof a)return f;const N=new a;return N.message=f.message,N.stack=f.stack,N}static isErrorNoTelemetry(f){return f.name==="CodeExpectedError"}}t.$bb=a;class D extends Error{constructor(f){super(f||"An unexpected bug occurred."),Object.setPrototypeOf(this,D.prototype)}}t.$cb=D}),define(be[12],$e([1,0,6,72]),function(ie,t,A,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.CompareResult=t.$6b=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.top=t.$Eb=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=void 0;function n(v,i=0){return v[v.length-(1+i)]}t.$sb=n;function j(v){if(v.length===0)throw new Error("Invalid tail call");return[v.slice(0,v.length-1),v[v.length-1]]}t.$tb=j;function E(v,i,r=(c,u)=>c===u){if(v===i)return!0;if(!v||!i||v.length!==i.length)return!1;for(let c=0,u=v.length;c<u;c++)if(!r(v[c],i[c]))return!1;return!0}t.$ub=E;function k(v,i){const r=v.length-1;i<r&&(v[i]=v[r]),v.pop()}t.$vb=k;function m(v,i,r){return w(v.length,c=>r(v[c],i))}t.$wb=m;function w(v,i){let r=0,c=v-1;for(;r<=c;){const u=(r+c)/2|0,d=i(u);if(d<0)r=u+1;else if(d>0)c=u-1;else return u}return-(r+1)}t.$xb=w;function y(v,i,r){if(v=v|0,v>=i.length)throw new TypeError("invalid index");const c=i[Math.floor(i.length*Math.random())],u=[],d=[],F=[];for(const R of i){const W=r(R,c);W<0?u.push(R):W>0?d.push(R):F.push(R)}return v<u.length?y(v,u,r):v<u.length+F.length?F[0]:y(v-(u.length+F.length),d,r)}t.$yb=y;function L(v,i){const r=[];let c;for(const u of v.slice(0).sort(i))!c||i(c[0],u)!==0?(c=[u],r.push(c)):c.push(u);return r}t.$zb=L;function*l(v,i){let r,c;for(const u of v)c!==void 0&&i(c,u)?r.push(u):(r&&(yield r),r=[u]),c=u;r&&(yield r)}t.$Ab=l;function h(v,i){for(let r=0;r<=v.length;r++)i(r===0?void 0:v[r-1],r===v.length?void 0:v[r])}t.$Bb=h;function e(v,i){for(let r=0;r<v.length;r++)i(r===0?void 0:v[r-1],v[r],r+1===v.length?void 0:v[r+1])}t.$Cb=e;function s(v,i,r){const c=[];function u(R,W,z){if(W===0&&z.length===0)return;const q=c[c.length-1];q&&q.start+q.deleteCount===R?(q.deleteCount+=W,q.toInsert.push(...z)):c.push({start:R,deleteCount:W,toInsert:z})}let d=0,F=0;for(;;){if(d===v.length){u(d,0,i.slice(F));break}if(F===i.length){u(d,v.length-d,[]);break}const R=v[d],W=i[F],z=r(R,W);z===0?(d+=1,F+=1):z<0?(u(d,1,[]),d+=1):z>0&&(u(d,0,[W]),F+=1)}return c}t.$Db=s;function g(v,i,r){const c=s(v,i,r),u=[],d=[];for(const F of c)u.push(...v.slice(F.start,F.start+F.deleteCount)),d.push(...F.toInsert);return{removed:u,added:d}}t.$Eb=g;function $(v,i,r){if(r===0)return[];const c=v.slice(0,r).sort(i);return a(v,i,c,r,v.length),c}t.top=$;function o(v,i,r,c,u){return r===0?Promise.resolve([]):new Promise((d,F)=>{(async()=>{const R=v.length,W=v.slice(0,r).sort(i);for(let z=r,q=Math.min(r+c,R);z<R;z=q,q=Math.min(q+c,R)){if(z>r&&await new Promise(G=>setTimeout(G)),u&&u.isCancellationRequested)throw new A.$5;a(v,i,W,z,q)}return W})().then(d,F)})}t.$Gb=o;function a(v,i,r,c,u){for(const d=r.length;c<u;c++){const F=v[c];if(i(F,r[d-1])<0){r.pop();const R=(0,C.$kb)(r,W=>i(F,W)<0);r.splice(R,0,F)}}}function D(v){return v.filter(i=>!!i)}t.$Hb=D;function b(v){let i=0;for(let r=0;r<v.length;r++)v[r]&&(v[i]=v[r],i+=1);v.length=i}t.$Ib=b;function f(v,i,r){v.splice(r,0,v.splice(i,1)[0])}t.$Jb=f;function N(v){return!Array.isArray(v)||v.length===0}t.$Kb=N;function O(v){return Array.isArray(v)&&v.length>0}t.$Lb=O;function T(v,i=r=>r){const r=new Set;return v.filter(c=>{const u=i(c);return r.has(u)?!1:(r.add(u),!0)})}t.$Mb=T;function p(v){const i=new Set;return r=>{const c=v(r);return i.has(c)?!1:(i.add(c),!0)}}t.$Nb=p;function S(v,i){return v.length>0?v[0]:i}t.$Ob=S;function M(v,i){return v.length>0?v[v.length-1]:i}t.$Pb=M;function U(v,i,r=(c,u)=>c===u){let c=0;for(let u=0,d=Math.min(v.length,i.length);u<d&&r(v[u],i[u]);u++)c++;return c}t.$Qb=U;function _(v){return[].concat(...v)}t.$Rb=_;function P(v,i){let r=typeof i=="number"?v:0;typeof i=="number"?r=v:(r=0,i=v);const c=[];if(r<=i)for(let u=r;u<i;u++)c.push(u);else for(let u=r;u>i;u--)c.push(u);return c}t.$Sb=P;function I(v,i,r){return v.reduce((c,u)=>(c[i(u)]=r?r(u):u,c),Object.create(null))}t.$Tb=I;function B(v,i){return v.push(i),()=>X(v,i)}t.$Ub=B;function X(v,i){const r=v.indexOf(i);if(r>-1)return v.splice(r,1),i}t.$Vb=X;function Y(v,i,r){const c=v.slice(0,i),u=v.slice(i);return c.concat(r,u)}t.$Wb=Y;function ue(v,i){let r;if(typeof i=="number"){let c=i;r=()=>{const u=Math.sin(c++)*179426549;return u-Math.floor(u)}}else r=Math.random;for(let c=v.length-1;c>0;c-=1){const u=Math.floor(r()*(c+1)),d=v[c];v[c]=v[u],v[u]=d}}t.$Xb=ue;function ne(v,i){const r=v.indexOf(i);r>-1&&(v.splice(r,1),v.unshift(i))}t.$Yb=ne;function te(v,i){const r=v.indexOf(i);r>-1&&(v.splice(r,1),v.push(i))}t.$Zb=te;function we(v,i){for(const r of i)v.push(r)}t.$1b=we;function Te(v,i){return Array.isArray(v)?v.map(i):i(v)}t.$2b=Te;function Pe(v){return Array.isArray(v)?v:[v]}t.$3b=Pe;function Oe(v){return v[Math.floor(Math.random()*v.length)]}t.$4b=Oe;function re(v,i,r){const c=ae(v,i),u=v.length,d=r.length;v.length=u+d;for(let F=u-1;F>=c;F--)v[F+d]=v[F];for(let F=0;F<d;F++)v[F+c]=r[F]}t.$5b=re;function Z(v,i,r,c){const u=ae(v,i);let d=v.splice(u,r);return d===void 0&&(d=[]),re(v,u,c),d}t.$6b=Z;function ae(v,i){return i<0?Math.max(i+v.length,0):Math.min(i,v.length)}var K;(function(v){function i(d){return d<0}v.isLessThan=i;function r(d){return d<=0}v.isLessThanOrEqual=r;function c(d){return d>0}v.isGreaterThan=c;function u(d){return d===0}v.isNeitherLessOrGreaterThan=u,v.greaterThan=1,v.lessThan=-1,v.neitherLessOrGreaterThan=0})(K||(t.CompareResult=K={}));function H(v,i){return(r,c)=>i(v(r),v(c))}t.$7b=H;function J(...v){return(i,r)=>{for(const c of v){const u=c(i,r);if(!K.isNeitherLessOrGreaterThan(u))return u}return K.neitherLessOrGreaterThan}}t.$8b=J;const me=(v,i)=>v-i;t.$9b=me;const ve=(v,i)=>(0,t.$9b)(v?1:0,i?1:0);t.$0b=ve;function Fe(v){return(i,r)=>-v(i,r)}t.$$b=Fe;class Ae{constructor(i){this.g=i,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(i){let r=this.c;for(;r<this.g.length&&i(this.g[r]);)r++;const c=r===this.c?null:this.g.slice(this.c,r);return this.c=r,c}takeFromEndWhile(i){let r=this.d;for(;r>=0&&i(this.g[r]);)r--;const c=r===this.d?null:this.g.slice(r+1,this.d+1);return this.d=r,c}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const i=this.g[this.c];return this.c++,i}removeLast(){const i=this.g[this.d];return this.d--,i}takeCount(i){const r=this.g.slice(this.c,this.c+i);return this.c+=i,r}}t.$_b=Ae;class ge{static{this.empty=new ge(i=>{})}constructor(i){this.iterate=i}forEach(i){this.iterate(r=>(i(r),!0))}toArray(){const i=[];return this.iterate(r=>(i.push(r),!0)),i}filter(i){return new ge(r=>this.iterate(c=>i(c)?r(c):!0))}map(i){return new ge(r=>this.iterate(c=>r(i(c))))}some(i){let r=!1;return this.iterate(c=>(r=i(c),!r)),r}findFirst(i){let r;return this.iterate(c=>i(c)?(r=c,!1):!0),r}findLast(i){let r;return this.iterate(c=>(i(c)&&(r=c),!0)),r}findLastMaxBy(i){let r,c=!0;return this.iterate(u=>((c||K.isGreaterThan(i(u,r)))&&(c=!1,r=u),!0)),r}}t.$ac=ge}),define(be[76],$e([1,0,6]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8c=t.$7c=t.$6c=t.$5c=t.ok=void 0;function C(m,w){if(!m)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}t.ok=C;function n(m,w="Unreachable"){throw new Error(w)}t.$5c=n;function j(m){if(!m)throw new A.$cb("Assertion Failed")}t.$6c=j;function E(m){if(!m()){debugger;m(),(0,A.$1)(new A.$cb("Assertion Failed"))}}t.$7c=E;function k(m,w){let y=0;for(;y<m.length-1;){const L=m[y],l=m[y+1];if(!w(L,l))return!1;y++}return!0}t.$8c=k}),define(be[43],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=void 0;function A(C,n){const j=this;let E=!1,k;return function(){if(E)return k;if(E=!0,n)try{k=C.apply(j,arguments)}finally{n()}else k=C.apply(j,arguments);return k}}t.$db=A}),define(be[77],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1M=t.$ZM=void 0;class A{constructor(n){this.a=n,this.b=0}nextId(){return this.a+ ++this.b}}t.$ZM=A,t.$1M=new A("id#")}),define(be[28],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var A;(function(C){function n(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}C.is=n;const j=Object.freeze([]);function E(){return j}C.empty=E;function*k(f){yield f}C.single=k;function m(f){return n(f)?f:k(f)}C.wrap=m;function w(f){return f||j}C.from=w;function*y(f){for(let N=f.length-1;N>=0;N--)yield f[N]}C.reverse=y;function L(f){return!f||f[Symbol.iterator]().next().done===!0}C.isEmpty=L;function l(f){return f[Symbol.iterator]().next().value}C.first=l;function h(f,N){for(const O of f)if(N(O))return!0;return!1}C.some=h;function e(f,N){for(const O of f)if(N(O))return O}C.find=e;function*s(f,N){for(const O of f)N(O)&&(yield O)}C.filter=s;function*g(f,N){let O=0;for(const T of f)yield N(T,O++)}C.map=g;function*$(...f){for(const N of f)yield*N}C.concat=$;function o(f,N,O){let T=O;for(const p of f)T=N(T,p);return T}C.reduce=o;function*a(f,N,O=f.length){for(N<0&&(N+=f.length),O<0?O+=f.length:O>f.length&&(O=f.length);N<O;N++)yield f[N]}C.slice=a;function D(f,N=Number.POSITIVE_INFINITY){const O=[];if(N===0)return[O,f];const T=f[Symbol.iterator]();for(let p=0;p<N;p++){const S=T.next();if(S.done)return[O,C.empty()];O.push(S.value)}return[O,{[Symbol.iterator](){return T}}]}C.consume=D;async function b(f){const N=[];for await(const O of f)N.push(O);return Promise.resolve(N)}C.asyncToArray=b})(A||(t.Iterable=A={}))}),define(be[44],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uq=t.KeyMod=t.KeyCodeUtils=t.$Tq=t.$Sq=t.$Rq=t.$Qq=t.$Pq=t.ScanCode=t.KeyCode=void 0;var A;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(A||(t.KeyCode=A={}));var C;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(C||(t.ScanCode=C={}));class n{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,g){this._keyCodeToStr[s]=g,this._strToKeyCode[g.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||0}}const j=new n,E=new n,k=new n;t.$Pq=new Array(230),t.$Qq={};const m=[],w=Object.create(null),y=Object.create(null);t.$Rq={lowerCaseToEnum:e=>y[e]||0,toEnum:e=>w[e]||0,toString:e=>m[e]||"None"},t.$Sq=[],t.$Tq=[];for(let e=0;e<=193;e++)t.$Sq[e]=-1;for(let e=0;e<=132;e++)t.$Tq[e]=-1;(function(){const e="",s=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],g=[],$=[];for(const o of s){const[a,D,b,f,N,O,T,p,S]=o;if($[D]||($[D]=!0,m[D]=b,w[b]=D,y[b.toLowerCase()]=D,a&&(t.$Sq[D]=f,f!==0&&f!==3&&f!==5&&f!==4&&f!==6&&f!==57&&(t.$Tq[f]=D))),!g[f]){if(g[f]=!0,!N)throw new Error(`String representation missing for key code ${f} around scan code ${b}`);j.define(f,N),E.define(f,p||N),k.define(f,S||p||N)}O&&(t.$Pq[O]=f),T&&(t.$Qq[T]=f)}t.$Tq[3]=46})();var L;(function(e){function s(b){return j.keyCodeToStr(b)}e.toString=s;function g(b){return j.strToKeyCode(b)}e.fromString=g;function $(b){return E.keyCodeToStr(b)}e.toUserSettingsUS=$;function o(b){return k.keyCodeToStr(b)}e.toUserSettingsGeneral=o;function a(b){return E.strToKeyCode(b)||k.strToKeyCode(b)}e.fromUserSettings=a;function D(b){if(b>=98&&b<=113)return null;switch(b){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return j.keyCodeToStr(b)}e.toElectronAccelerator=D})(L||(t.KeyCodeUtils=L={}));var l;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(l||(t.KeyMod=l={}));function h(e,s){const g=(s&65535)<<16>>>0;return(e|g)>>>0}t.$Uq=h}),define(be[78],$e([1,0,6]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2q=t.$1q=t.$Zq=t.$Yq=t.$Xq=t.$Wq=t.$Vq=void 0;var C;(function(L){L[L.CtrlCmd=2048]="CtrlCmd",L[L.Shift=1024]="Shift",L[L.Alt=512]="Alt",L[L.WinCtrl=256]="WinCtrl",L[L.KeyCode=255]="KeyCode"})(C||(C={}));function n(L,l){if(typeof L=="number"){if(L===0)return null;const h=(L&65535)>>>0,e=(L&4294901760)>>>16;return e!==0?new m([j(h,l),j(e,l)]):new m([j(h,l)])}else{const h=[];for(let e=0;e<L.length;e++)h.push(j(L[e],l));return new m(h)}}t.$Vq=n;function j(L,l){const h=!!(L&2048),e=!!(L&256),s=l===2?e:h,g=!!(L&1024),$=!!(L&512),o=l===2?h:e,a=L&255;return new E(s,g,$,o,a)}t.$Wq=j;class E{constructor(l,h,e,s,g){this.ctrlKey=l,this.shiftKey=h,this.altKey=e,this.metaKey=s,this.keyCode=g}equals(l){return l instanceof E&&this.ctrlKey===l.ctrlKey&&this.shiftKey===l.shiftKey&&this.altKey===l.altKey&&this.metaKey===l.metaKey&&this.keyCode===l.keyCode}getHashCode(){const l=this.ctrlKey?"1":"0",h=this.shiftKey?"1":"0",e=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`K${l}${h}${e}${s}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new m([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$Xq=E;class k{constructor(l,h,e,s,g){this.ctrlKey=l,this.shiftKey=h,this.altKey=e,this.metaKey=s,this.scanCode=g}equals(l){return l instanceof k&&this.ctrlKey===l.ctrlKey&&this.shiftKey===l.shiftKey&&this.altKey===l.altKey&&this.metaKey===l.metaKey&&this.scanCode===l.scanCode}getHashCode(){const l=this.ctrlKey?"1":"0",h=this.shiftKey?"1":"0",e=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`S${l}${h}${e}${s}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$Yq=k;class m{constructor(l){if(l.length===0)throw(0,A.$7)("chords");this.chords=l}getHashCode(){let l="";for(let h=0,e=this.chords.length;h<e;h++)h!==0&&(l+=";"),l+=this.chords[h].getHashCode();return l}equals(l){if(l===null||this.chords.length!==l.chords.length)return!1;for(let h=0;h<this.chords.length;h++)if(!this.chords[h].equals(l.chords[h]))return!1;return!0}}t.$Zq=m;class w{constructor(l,h,e,s,g,$){this.ctrlKey=l,this.shiftKey=h,this.altKey=e,this.metaKey=s,this.keyLabel=g,this.keyAriaLabel=$}}t.$1q=w;class y{}t.$2q=y}),define(be[23],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class A{constructor(n){this.d=n,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(n){this.c=n}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=A}),define(be[45],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3c=void 0;class A{static{this.Undefined=new A(void 0)}constructor(j){this.element=j,this.next=A.Undefined,this.prev=A.Undefined}}class C{constructor(){this.a=A.Undefined,this.b=A.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===A.Undefined}clear(){let j=this.a;for(;j!==A.Undefined;){const E=j.next;j.prev=A.Undefined,j.next=A.Undefined,j=E}this.a=A.Undefined,this.b=A.Undefined,this.c=0}unshift(j){return this.d(j,!1)}push(j){return this.d(j,!0)}d(j,E){const k=new A(j);if(this.a===A.Undefined)this.a=k,this.b=k;else if(E){const w=this.b;this.b=k,k.prev=w,w.next=k}else{const w=this.a;this.a=k,k.next=w,w.prev=k}this.c+=1;let m=!1;return()=>{m||(m=!0,this.e(k))}}shift(){if(this.a!==A.Undefined){const j=this.a.element;return this.e(this.a),j}}pop(){if(this.b!==A.Undefined){const j=this.b.element;return this.e(this.b),j}}e(j){if(j.prev!==A.Undefined&&j.next!==A.Undefined){const E=j.prev;E.next=j.next,j.next.prev=E}else j.prev===A.Undefined&&j.next===A.Undefined?(this.a=A.Undefined,this.b=A.Undefined):j.next===A.Undefined?(this.b=this.b.prev,this.b.next=A.Undefined):j.prev===A.Undefined&&(this.a=this.a.next,this.a.prev=A.Undefined);this.c-=1}*[Symbol.iterator](){let j=this.a;for(;j!==A.Undefined;)yield j.element,j=j.next}}t.$3c=C}),define(be[32],$e([1,0]),function(ie,t){"use strict";var A,C,n;Object.defineProperty(t,"__esModule",{value:!0}),t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.Touch=t.$Bc=t.$Ac=t.$zc=t.$yc=t.$xc=void 0;function j(o,a,D){let b=o.get(a);return b===void 0&&(b=D,o.set(a,b)),b}t.$xc=j;function E(o){const a=[];return o.forEach((D,b)=>{a.push(`${b} => ${D}`)}),`Map(${o.size}) {${a.join(", ")}}`}t.$yc=E;function k(o){const a=[];return o.forEach(D=>{a.push(D)}),`Set(${o.size}) {${a.join(", ")}}`}t.$zc=k;class m{constructor(a,D){this.uri=a,this.value=D}}function w(o){return Array.isArray(o)}class y{static{this.a=a=>a.toString()}constructor(a,D){if(this[A]="ResourceMap",a instanceof y)this.b=new Map(a.b),this.c=D??y.a;else if(w(a)){this.b=new Map,this.c=D??y.a;for(const[b,f]of a)this.set(b,f)}else this.b=new Map,this.c=a??y.a}set(a,D){return this.b.set(this.c(a),new m(a,D)),this}get(a){return this.b.get(this.c(a))?.value}has(a){return this.b.has(this.c(a))}get size(){return this.b.size}clear(){this.b.clear()}delete(a){return this.b.delete(this.c(a))}forEach(a,D){typeof D<"u"&&(a=a.bind(D));for(const[b,f]of this.b)a(f.value,f.uri,this)}*values(){for(const a of this.b.values())yield a.value}*keys(){for(const a of this.b.values())yield a.uri}*entries(){for(const a of this.b.values())yield[a.uri,a.value]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.b)yield[a.uri,a.value]}}t.$Ac=y;class L{constructor(a,D){this[C]="ResourceSet",!a||typeof a=="function"?this.a=new y(a):(this.a=new y(D),a.forEach(this.add,this))}get size(){return this.a.size}add(a){return this.a.set(a,a),this}clear(){this.a.clear()}delete(a){return this.a.delete(a)}forEach(a,D){this.a.forEach((b,f)=>a.call(D,f,f,this))}has(a){return this.a.has(a)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Bc=L;var l;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(l||(t.Touch=l={}));class h{constructor(){this[n]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(a){return this.a.has(a)}get(a,D=0){const b=this.a.get(a);if(b)return D!==0&&this.j(b,D),b.value}set(a,D,b=0){let f=this.a.get(a);if(f)f.value=D,b!==0&&this.j(f,b);else{switch(f={key:a,value:D,next:void 0,previous:void 0},b){case 0:this.h(f);break;case 1:this.g(f);break;case 2:this.h(f);break;default:this.h(f);break}this.a.set(a,f),this.d++}return this}delete(a){return!!this.remove(a)}remove(a){const D=this.a.get(a);if(D)return this.a.delete(a),this.i(D),this.d--,D.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const a=this.b;return this.a.delete(a.key),this.i(a),this.d--,a.value}forEach(a,D){const b=this.e;let f=this.b;for(;f;){if(D?a.bind(D)(f.value,f.key,this):a(f.value,f.key,this),this.e!==b)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const a=this,D=this.e;let b=this.b;const f={[Symbol.iterator](){return f},next(){if(a.e!==D)throw new Error("LinkedMap got modified during iteration.");if(b){const N={value:b.key,done:!1};return b=b.next,N}else return{value:void 0,done:!0}}};return f}values(){const a=this,D=this.e;let b=this.b;const f={[Symbol.iterator](){return f},next(){if(a.e!==D)throw new Error("LinkedMap got modified during iteration.");if(b){const N={value:b.value,done:!1};return b=b.next,N}else return{value:void 0,done:!0}}};return f}entries(){const a=this,D=this.e;let b=this.b;const f={[Symbol.iterator](){return f},next(){if(a.e!==D)throw new Error("LinkedMap got modified during iteration.");if(b){const N={value:[b.key,b.value],done:!1};return b=b.next,N}else return{value:void 0,done:!0}}};return f}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(a){if(a>=this.size)return;if(a===0){this.clear();return}let D=this.b,b=this.size;for(;D&&b>a;)this.a.delete(D.key),D=D.next,b--;this.b=D,this.d=b,D&&(D.previous=void 0),this.e++}g(a){if(!this.b&&!this.c)this.c=a;else if(this.b)a.next=this.b,this.b.previous=a;else throw new Error("Invalid list");this.b=a,this.e++}h(a){if(!this.b&&!this.c)this.b=a;else if(this.c)a.previous=this.c,this.c.next=a;else throw new Error("Invalid list");this.c=a,this.e++}i(a){if(a===this.b&&a===this.c)this.b=void 0,this.c=void 0;else if(a===this.b){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this.b=a.next}else if(a===this.c){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this.c=a.previous}else{const D=a.next,b=a.previous;if(!D||!b)throw new Error("Invalid list");D.previous=b,b.next=D}a.next=void 0,a.previous=void 0,this.e++}j(a,D){if(!this.b||!this.c)throw new Error("Invalid list");if(!(D!==1&&D!==2)){if(D===1){if(a===this.b)return;const b=a.next,f=a.previous;a===this.c?(f.next=void 0,this.c=f):(b.previous=f,f.next=b),a.previous=void 0,a.next=this.b,this.b.previous=a,this.b=a,this.e++}else if(D===2){if(a===this.c)return;const b=a.next,f=a.previous;a===this.b?(b.previous=void 0,this.b=b):(b.previous=f,f.next=b),a.next=void 0,a.previous=this.c,this.c.next=a,this.c=a,this.e++}}}toJSON(){const a=[];return this.forEach((D,b)=>{a.push([b,D])}),a}fromJSON(a){this.clear();for(const[D,b]of a)this.set(D,b)}}t.$Cc=h;class e extends h{constructor(a,D=1){super(),this.k=a,this.l=Math.min(Math.max(0,D),1)}get limit(){return this.k}set limit(a){this.k=a,this.m()}get ratio(){return this.l}set ratio(a){this.l=Math.min(Math.max(0,a),1),this.m()}get(a,D=2){return super.get(a,D)}peek(a){return super.get(a,0)}set(a,D){return super.set(a,D,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.$Dc=e;class s{constructor(){this.a=new Map}add(a){return this.a.set(a,(this.a.get(a)||0)+1),this}delete(a){let D=this.a.get(a)||0;return D===0?!1:(D--,D===0?this.a.delete(a):this.a.set(a,D),!0)}has(a){return this.a.has(a)}}t.$Ec=s;class g{constructor(a){if(this.a=new Map,this.b=new Map,a)for(const[D,b]of a)this.set(D,b)}clear(){this.a.clear(),this.b.clear()}set(a,D){this.a.set(a,D),this.b.set(D,a)}get(a){return this.a.get(a)}getKey(a){return this.b.get(a)}delete(a){const D=this.a.get(a);return D===void 0?!1:(this.a.delete(a),this.b.delete(D),!0)}forEach(a,D){this.a.forEach((b,f)=>{a.call(D,b,f,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}t.$Fc=g;class ${constructor(){this.a=new Map}add(a,D){let b=this.a.get(a);b||(b=new Set,this.a.set(a,b)),b.add(D)}delete(a,D){const b=this.a.get(a);b&&(b.delete(D),b.size===0&&this.a.delete(a))}forEach(a,D){const b=this.a.get(a);b&&b.forEach(D)}get(a){const D=this.a.get(a);return D||new Set}}t.$Gc=$}),define(be[2],$e([1,0,12,73,32,43,28]),function(ie,t,A,C,n,j,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=t.$Hc=void 0;const k=!1;let m=null;class w{constructor(){this.b=new Map}static{this.a=0}c(B){let X=this.b.get(B);return X||(X={parent:null,source:null,isSingleton:!1,value:B,idx:w.a++},this.b.set(B,X)),X}trackDisposable(B){const X=this.c(B);X.source||(X.source=new Error().stack)}setParent(B,X){const Y=this.c(B);Y.parent=X}markAsDisposed(B){this.b.delete(B)}markAsSingleton(B){this.c(B).isSingleton=!0}f(B,X){const Y=X.get(B);if(Y)return Y;const ue=B.parent?this.f(this.c(B.parent),X):B;return X.set(B,ue),ue}getTrackedDisposables(){const B=new Map;return[...this.b.entries()].filter(([,Y])=>Y.source!==null&&!this.f(Y,B).isSingleton).flatMap(([Y])=>Y)}computeLeakingDisposables(B=10,X){let Y;if(X)Y=X;else{const Te=new Map,Pe=[...this.b.values()].filter(re=>re.source!==null&&!this.f(re,Te).isSingleton);if(Pe.length===0)return;const Oe=new Set(Pe.map(re=>re.value));if(Y=Pe.filter(re=>!(re.parent&&Oe.has(re.parent))),Y.length===0)throw new Error("There are cyclic diposable chains!")}if(!Y)return;function ue(Te){function Pe(re,Z){for(;re.length>0&&Z.some(ae=>typeof ae=="string"?ae===re[0]:re[0].match(ae));)re.shift()}const Oe=Te.source.split(`
`).map(re=>re.trim().replace("at ","")).filter(re=>re!=="");return Pe(Oe,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Oe.reverse()}const ne=new n.$Gc;for(const Te of Y){const Pe=ue(Te);for(let Oe=0;Oe<=Pe.length;Oe++)ne.add(Pe.slice(0,Oe).join(`
`),Te)}Y.sort((0,A.$7b)(Te=>Te.idx,A.$9b));let te="",we=0;for(const Te of Y.slice(0,B)){we++;const Pe=ue(Te),Oe=[];for(let re=0;re<Pe.length;re++){let Z=Pe[re];Z=`(shared with ${ne.get(Pe.slice(0,re+1).join(`
`)).size}/${Y.length} leaks) at ${Z}`;const K=ne.get(Pe.slice(0,re).join(`
`)),H=(0,C.$K)([...K].map(J=>ue(J)[re]),J=>J);delete H[Pe[re]];for(const[J,me]of Object.entries(H))Oe.unshift(`    - stacktraces of ${me.length} other leaks continue with ${J}`);Oe.unshift(Z)}te+=`


==================== Leaking disposable ${we}/${Y.length}: ${Te.value.constructor.name} ====================
${Oe.join(`
`)}
============================================================

`}return Y.length>B&&(te+=`


... and ${Y.length-B} more leaking disposables

`),{leaks:Y,details:te}}}t.$Hc=w;function y(I){m=I}if(t.$Ic=y,k){const I="__is_disposable_tracked__";y(new class{trackDisposable(B){const X=new Error("Potentially leaked disposable").stack;setTimeout(()=>{B[I]||console.log(X)},3e3)}setParent(B,X){if(B&&B!==f.None)try{B[I]=!0}catch{}}markAsDisposed(B){if(B&&B!==f.None)try{B[I]=!0}catch{}}markAsSingleton(B){}})}function L(I){return m?.trackDisposable(I),I}t.$Jc=L;function l(I){m?.markAsDisposed(I)}t.$Kc=l;function h(I,B){m?.setParent(I,B)}function e(I,B){if(m)for(const X of I)m.setParent(X,B)}function s(I){return m?.markAsSingleton(I),I}t.$Lc=s;function g(I){return typeof I.dispose=="function"&&I.dispose.length===0}t.$Mc=g;function $(I){if(E.Iterable.is(I)){const B=[];for(const X of I)if(X)try{X.dispose()}catch(Y){B.push(Y)}if(B.length===1)throw B[0];if(B.length>1)throw new AggregateError(B,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}t.$Nc=$;function o(I){for(const B of I)g(B)&&B.dispose();return[]}t.$Oc=o;function a(...I){const B=D(()=>$(I));return e(I,B),B}t.$Pc=a;function D(I){const B=L({dispose:(0,j.$db)(()=>{l(B),I()})});return B}t.$Qc=D;class b{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,L(this)}dispose(){this.g||(l(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(B){if(!B)return B;if(B===this)throw new Error("Cannot register a disposable on itself!");return h(B,this),this.g?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(B),B}delete(B){if(B){if(B===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(B),B.dispose()}}deleteAndLeak(B){B&&this.f.has(B)&&(this.f.delete(B),h(B,null))}}t.$Rc=b;class f{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new b,L(this),h(this.q,this)}dispose(){l(this),this.q.dispose()}B(B){if(B===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(B)}}t.$Sc=f;class N{constructor(){this.b=!1,L(this)}get value(){return this.b?void 0:this.a}set value(B){this.b||B===this.a||(this.a?.dispose(),B&&h(B,this),this.a=B)}clear(){this.value=void 0}dispose(){this.b=!0,l(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const B=this.a;return this.a=void 0,B&&h(B,null),B}}t.$Tc=N;class O{constructor(B){this.a=new N,this.b=!1,this.a.value=B}get value(){return this.a.value}set value(B){this.b||B===this.a.value||(this.a.value=B)}dispose(){this.b=!0,this.a.dispose()}}t.$Uc=O;class T{constructor(B){this.b=B,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Vc=T;class p{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,L(this)}set(B){let X=B;return this.unset=()=>X=void 0,this.isset=()=>X!==void 0,this.dispose=()=>{X&&(X(),X=void 0,l(this))},this}}t.$Wc=p;class S{constructor(){this.a=new Map}acquire(B,...X){let Y=this.a.get(B);Y||(Y={counter:0,object:this.b(B,...X)},this.a.set(B,Y));const{object:ue}=Y,ne=(0,j.$db)(()=>{--Y.counter===0&&(this.c(B,Y.object),this.a.delete(B))});return Y.counter++,{object:ue,dispose:ne}}}t.$Xc=S;class M{constructor(B){this.a=B}async acquire(B,...X){const Y=this.a.acquire(B,...X);try{return{object:await Y.object,dispose:()=>Y.dispose()}}catch(ue){throw Y.dispose(),ue}}}t.$Yc=M;class U{constructor(B){this.object=B}dispose(){}}t.$Zc=U;function _(I){const B=new b;try{I(B)}finally{B.dispose()}}t.$1c=_;class P{constructor(){this.a=new Map,this.b=!1,L(this)}dispose(){l(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(B){return this.a.has(B)}get size(){return this.a.size}get(B){return this.a.get(B)}set(B,X,Y=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Y||this.a.get(B)?.dispose(),this.a.set(B,X)}deleteAndDispose(B){this.a.get(B)?.dispose(),this.a.delete(B)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$2c=P}),function(ie,t){typeof define=="function"&&define.amd?define(be[79],$e([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(ie=typeof globalThis<"u"?globalThis:ie||self,t(ie.marked={}))}(this,function(ie){"use strict";function t(i,r){for(var c=0;c<r.length;c++){var u=r[c];u.enumerable=u.enumerable||!1,u.configurable=!0,"value"in u&&(u.writable=!0),Object.defineProperty(i,u.key,u)}}function A(i,r,c){return r&&t(i.prototype,r),c&&t(i,c),Object.defineProperty(i,"prototype",{writable:!1}),i}function C(i,r){if(i){if(typeof i=="string")return n(i,r);var c=Object.prototype.toString.call(i).slice(8,-1);if(c==="Object"&&i.constructor&&(c=i.constructor.name),c==="Map"||c==="Set")return Array.from(i);if(c==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(c))return n(i,r)}}function n(i,r){(r==null||r>i.length)&&(r=i.length);for(var c=0,u=new Array(r);c<r;c++)u[c]=i[c];return u}function j(i,r){var c=typeof Symbol<"u"&&i[Symbol.iterator]||i["@@iterator"];if(c)return(c=c.call(i)).next.bind(c);if(Array.isArray(i)||(c=C(i))||r&&i&&typeof i.length=="number"){c&&(i=c);var u=0;return function(){return u>=i.length?{done:!0}:{done:!1,value:i[u++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function E(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=E();function k(i){ie.defaults=i}var m=/[&<>"']/,w=/[&<>"']/g,y=/[<>"']|&(?!#?\w+;)/,L=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(r){return l[r]};function e(i,r){if(r){if(m.test(i))return i.replace(w,h)}else if(y.test(i))return i.replace(L,h);return i}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(i){return i.replace(s,function(r,c){return c=c.toLowerCase(),c==="colon"?":":c.charAt(0)==="#"?c.charAt(1)==="x"?String.fromCharCode(parseInt(c.substring(2),16)):String.fromCharCode(+c.substring(1)):""})}var $=/(^|[^\[])\^/g;function o(i,r){i=typeof i=="string"?i:i.source,r=r||"";var c={replace:function(d,F){return F=F.source||F,F=F.replace($,"$1"),i=i.replace(d,F),c},getRegex:function(){return new RegExp(i,r)}};return c}var a=/[^\w:]/g,D=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(i,r,c){if(i){var u;try{u=decodeURIComponent(g(c)).replace(a,"").toLowerCase()}catch{return null}if(u.indexOf("javascript:")===0||u.indexOf("vbscript:")===0||u.indexOf("data:")===0)return null}r&&!D.test(c)&&(c=p(r,c));try{c=encodeURI(c).replace(/%25/g,"%")}catch{return null}return c}var f={},N=/^[^:]+:\/*[^/]*$/,O=/^([^:]+:)[\s\S]*$/,T=/^([^:]+:\/*[^/]*)[\s\S]*$/;function p(i,r){f[" "+i]||(N.test(i)?f[" "+i]=i+"/":f[" "+i]=_(i,"/",!0)),i=f[" "+i];var c=i.indexOf(":")===-1;return r.substring(0,2)==="//"?c?r:i.replace(O,"$1")+r:r.charAt(0)==="/"?c?r:i.replace(T,"$1")+r:i+r}var S={exec:function(){}};function M(i){for(var r=1,c,u;r<arguments.length;r++){c=arguments[r];for(u in c)Object.prototype.hasOwnProperty.call(c,u)&&(i[u]=c[u])}return i}function U(i,r){var c=i.replace(/\|/g,function(F,R,W){for(var z=!1,q=R;--q>=0&&W[q]==="\\";)z=!z;return z?"|":" |"}),u=c.split(/ \|/),d=0;if(u[0].trim()||u.shift(),u.length>0&&!u[u.length-1].trim()&&u.pop(),u.length>r)u.splice(r);else for(;u.length<r;)u.push("");for(;d<u.length;d++)u[d]=u[d].trim().replace(/\\\|/g,"|");return u}function _(i,r,c){var u=i.length;if(u===0)return"";for(var d=0;d<u;){var F=i.charAt(u-d-1);if(F===r&&!c)d++;else if(F!==r&&c)d++;else break}return i.slice(0,u-d)}function P(i,r){if(i.indexOf(r[1])===-1)return-1;for(var c=i.length,u=0,d=0;d<c;d++)if(i[d]==="\\")d++;else if(i[d]===r[0])u++;else if(i[d]===r[1]&&(u--,u<0))return d;return-1}function I(i){i&&i.sanitize&&!i.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function B(i,r){if(r<1)return"";for(var c="";r>1;)r&1&&(c+=i),r>>=1,i+=i;return c+i}function X(i,r,c,u){var d=r.href,F=r.title?e(r.title):null,R=i[1].replace(/\\([\[\]])/g,"$1");if(i[0].charAt(0)!=="!"){u.state.inLink=!0;var W={type:"link",raw:c,href:d,title:F,text:R,tokens:u.inlineTokens(R)};return u.state.inLink=!1,W}return{type:"image",raw:c,href:d,title:F,text:e(R)}}function Y(i,r){var c=i.match(/^(\s+)(?:```)/);if(c===null)return r;var u=c[1];return r.split(`
`).map(function(d){var F=d.match(/^\s+/);if(F===null)return d;var R=F[0];return R.length>=u.length?d.slice(u.length):d}).join(`
`)}var ue=function(){function i(c){this.options=c||ie.defaults}var r=i.prototype;return r.space=function(u){var d=this.rules.block.newline.exec(u);if(d&&d[0].length>0)return{type:"space",raw:d[0]}},r.code=function(u){var d=this.rules.block.code.exec(u);if(d){var F=d[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:d[0],codeBlockStyle:"indented",text:this.options.pedantic?F:_(F,`
`)}}},r.fences=function(u){var d=this.rules.block.fences.exec(u);if(d){var F=d[0],R=Y(F,d[3]||"");return{type:"code",raw:F,lang:d[2]?d[2].trim():d[2],text:R}}},r.heading=function(u){var d=this.rules.block.heading.exec(u);if(d){var F=d[2].trim();if(/#$/.test(F)){var R=_(F,"#");(this.options.pedantic||!R||/ $/.test(R))&&(F=R.trim())}return{type:"heading",raw:d[0],depth:d[1].length,text:F,tokens:this.lexer.inline(F)}}},r.hr=function(u){var d=this.rules.block.hr.exec(u);if(d)return{type:"hr",raw:d[0]}},r.blockquote=function(u){var d=this.rules.block.blockquote.exec(u);if(d){var F=d[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:d[0],tokens:this.lexer.blockTokens(F,[]),text:F}}},r.list=function(u){var d=this.rules.block.list.exec(u);if(d){var F,R,W,z,q,G,oe,se,de,De,pe,Re,Se=d[1].trim(),Me=Se.length>1,Be={type:"list",raw:"",ordered:Me,start:Me?+Se.slice(0,-1):"",loose:!1,items:[]};Se=Me?"\\d{1,9}\\"+Se.slice(-1):"\\"+Se,this.options.pedantic&&(Se=Me?Se:"[*+-]");for(var Ie=new RegExp("^( {0,3}"+Se+")((?:[	 ][^\\n]*)?(?:\\n|$))");u&&(Re=!1,!(!(d=Ie.exec(u))||this.rules.block.hr.test(u)));){if(F=d[0],u=u.substring(F.length),se=d[2].split(`
`,1)[0],de=u.split(`
`,1)[0],this.options.pedantic?(z=2,pe=se.trimLeft()):(z=d[2].search(/[^ ]/),z=z>4?1:z,pe=se.slice(z),z+=d[1].length),G=!1,!se&&/^ *$/.test(de)&&(F+=de+`
`,u=u.substring(de.length+1),Re=!0),!Re)for(var Ze=new RegExp("^ {0,"+Math.min(3,z-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ke=new RegExp("^ {0,"+Math.min(3,z-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),xe=new RegExp("^ {0,"+Math.min(3,z-1)+"}(?:```|~~~)"),x=new RegExp("^ {0,"+Math.min(3,z-1)+"}#");u&&(De=u.split(`
`,1)[0],se=De,this.options.pedantic&&(se=se.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(xe.test(se)||x.test(se)||Ze.test(se)||Ke.test(u)));){if(se.search(/[^ ]/)>=z||!se.trim())pe+=`
`+se.slice(z);else if(!G)pe+=`
`+se;else break;!G&&!se.trim()&&(G=!0),F+=De+`
`,u=u.substring(De.length+1)}Be.loose||(oe?Be.loose=!0:/\n *\n *$/.test(F)&&(oe=!0)),this.options.gfm&&(R=/^\[[ xX]\] /.exec(pe),R&&(W=R[0]!=="[ ] ",pe=pe.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:F,task:!!R,checked:W,loose:!1,text:pe}),Be.raw+=F}Be.items[Be.items.length-1].raw=F.trimRight(),Be.items[Be.items.length-1].text=pe.trimRight(),Be.raw=Be.raw.trimRight();var le=Be.items.length;for(q=0;q<le;q++){this.lexer.state.top=!1,Be.items[q].tokens=this.lexer.blockTokens(Be.items[q].text,[]);var fe=Be.items[q].tokens.filter(function(Ne){return Ne.type==="space"}),Ee=fe.every(function(Ne){for(var je=Ne.raw.split(""),Qe=0,_e=j(je),et;!(et=_e()).done;){var tt=et.value;if(tt===`
`&&(Qe+=1),Qe>1)return!0}return!1});!Be.loose&&fe.length&&Ee&&(Be.loose=!0,Be.items[q].loose=!0)}return Be}},r.html=function(u){var d=this.rules.block.html.exec(u);if(d){var F={type:"html",raw:d[0],pre:!this.options.sanitizer&&(d[1]==="pre"||d[1]==="script"||d[1]==="style"),text:d[0]};if(this.options.sanitize){var R=this.options.sanitizer?this.options.sanitizer(d[0]):e(d[0]);F.type="paragraph",F.text=R,F.tokens=this.lexer.inline(R)}return F}},r.def=function(u){var d=this.rules.block.def.exec(u);if(d){d[3]&&(d[3]=d[3].substring(1,d[3].length-1));var F=d[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:F,raw:d[0],href:d[2],title:d[3]}}},r.table=function(u){var d=this.rules.block.table.exec(u);if(d){var F={type:"table",header:U(d[1]).map(function(oe){return{text:oe}}),align:d[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:d[3]&&d[3].trim()?d[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(F.header.length===F.align.length){F.raw=d[0];var R=F.align.length,W,z,q,G;for(W=0;W<R;W++)/^ *-+: *$/.test(F.align[W])?F.align[W]="right":/^ *:-+: *$/.test(F.align[W])?F.align[W]="center":/^ *:-+ *$/.test(F.align[W])?F.align[W]="left":F.align[W]=null;for(R=F.rows.length,W=0;W<R;W++)F.rows[W]=U(F.rows[W],F.header.length).map(function(oe){return{text:oe}});for(R=F.header.length,z=0;z<R;z++)F.header[z].tokens=this.lexer.inline(F.header[z].text);for(R=F.rows.length,z=0;z<R;z++)for(G=F.rows[z],q=0;q<G.length;q++)G[q].tokens=this.lexer.inline(G[q].text);return F}}},r.lheading=function(u){var d=this.rules.block.lheading.exec(u);if(d)return{type:"heading",raw:d[0],depth:d[2].charAt(0)==="="?1:2,text:d[1],tokens:this.lexer.inline(d[1])}},r.paragraph=function(u){var d=this.rules.block.paragraph.exec(u);if(d){var F=d[1].charAt(d[1].length-1)===`
`?d[1].slice(0,-1):d[1];return{type:"paragraph",raw:d[0],text:F,tokens:this.lexer.inline(F)}}},r.text=function(u){var d=this.rules.block.text.exec(u);if(d)return{type:"text",raw:d[0],text:d[0],tokens:this.lexer.inline(d[0])}},r.escape=function(u){var d=this.rules.inline.escape.exec(u);if(d)return{type:"escape",raw:d[0],text:e(d[1])}},r.tag=function(u){var d=this.rules.inline.tag.exec(u);if(d)return!this.lexer.state.inLink&&/^<a /i.test(d[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(d[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(d[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(d[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:d[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(d[0]):e(d[0]):d[0]}},r.link=function(u){var d=this.rules.inline.link.exec(u);if(d){var F=d[2].trim();if(!this.options.pedantic&&/^</.test(F)){if(!/>$/.test(F))return;var R=_(F.slice(0,-1),"\\");if((F.length-R.length)%2===0)return}else{var W=P(d[2],"()");if(W>-1){var z=d[0].indexOf("!")===0?5:4,q=z+d[1].length+W;d[2]=d[2].substring(0,W),d[0]=d[0].substring(0,q).trim(),d[3]=""}}var G=d[2],oe="";if(this.options.pedantic){var se=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(G);se&&(G=se[1],oe=se[3])}else oe=d[3]?d[3].slice(1,-1):"";return G=G.trim(),/^</.test(G)&&(this.options.pedantic&&!/>$/.test(F)?G=G.slice(1):G=G.slice(1,-1)),X(d,{href:G&&G.replace(this.rules.inline._escapes,"$1"),title:oe&&oe.replace(this.rules.inline._escapes,"$1")},d[0],this.lexer)}},r.reflink=function(u,d){var F;if((F=this.rules.inline.reflink.exec(u))||(F=this.rules.inline.nolink.exec(u))){var R=(F[2]||F[1]).replace(/\s+/g," ");if(R=d[R.toLowerCase()],!R||!R.href){var W=F[0].charAt(0);return{type:"text",raw:W,text:W}}return X(F,R,F[0],this.lexer)}},r.emStrong=function(u,d,F){F===void 0&&(F="");var R=this.rules.inline.emStrong.lDelim.exec(u);if(R&&!(R[3]&&F.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var W=R[1]||R[2]||"";if(!W||W&&(F===""||this.rules.inline.punctuation.exec(F))){var z=R[0].length-1,q,G,oe=z,se=0,de=R[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(de.lastIndex=0,d=d.slice(-1*u.length+z);(R=de.exec(d))!=null;)if(q=R[1]||R[2]||R[3]||R[4]||R[5]||R[6],!!q){if(G=q.length,R[3]||R[4]){oe+=G;continue}else if((R[5]||R[6])&&z%3&&!((z+G)%3)){se+=G;continue}if(oe-=G,!(oe>0)){if(G=Math.min(G,G+oe+se),Math.min(z,G)%2){var De=u.slice(1,z+R.index+G);return{type:"em",raw:u.slice(0,z+R.index+G+1),text:De,tokens:this.lexer.inlineTokens(De)}}var pe=u.slice(2,z+R.index+G-1);return{type:"strong",raw:u.slice(0,z+R.index+G+1),text:pe,tokens:this.lexer.inlineTokens(pe)}}}}}},r.codespan=function(u){var d=this.rules.inline.code.exec(u);if(d){var F=d[2].replace(/\n/g," "),R=/[^ ]/.test(F),W=/^ /.test(F)&&/ $/.test(F);return R&&W&&(F=F.substring(1,F.length-1)),F=e(F,!0),{type:"codespan",raw:d[0],text:F}}},r.br=function(u){var d=this.rules.inline.br.exec(u);if(d)return{type:"br",raw:d[0]}},r.del=function(u){var d=this.rules.inline.del.exec(u);if(d)return{type:"del",raw:d[0],text:d[2],tokens:this.lexer.inlineTokens(d[2])}},r.autolink=function(u,d){var F=this.rules.inline.autolink.exec(u);if(F){var R,W;return F[2]==="@"?(R=e(this.options.mangle?d(F[1]):F[1]),W="mailto:"+R):(R=e(F[1]),W=R),{type:"link",raw:F[0],text:R,href:W,tokens:[{type:"text",raw:R,text:R}]}}},r.url=function(u,d){var F;if(F=this.rules.inline.url.exec(u)){var R,W;if(F[2]==="@")R=e(this.options.mangle?d(F[0]):F[0]),W="mailto:"+R;else{var z;do z=F[0],F[0]=this.rules.inline._backpedal.exec(F[0])[0];while(z!==F[0]);R=e(F[0]),F[1]==="www."?W="http://"+R:W=R}return{type:"link",raw:F[0],text:R,href:W,tokens:[{type:"text",raw:R,text:R}]}}},r.inlineText=function(u,d){var F=this.rules.inline.text.exec(u);if(F){var R;return this.lexer.state.inRawBlock?R=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(F[0]):e(F[0]):F[0]:R=e(this.options.smartypants?d(F[0]):F[0]),{type:"text",raw:F[0],text:R}}},i}(),ne={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:S,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ne._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ne._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ne.def=o(ne.def).replace("label",ne._label).replace("title",ne._title).getRegex(),ne.bullet=/(?:[*+-]|\d{1,9}[.)])/,ne.listItemStart=o(/^( *)(bull) */).replace("bull",ne.bullet).getRegex(),ne.list=o(ne.list).replace(/bull/g,ne.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ne.def.source+")").getRegex(),ne._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ne._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ne.html=o(ne.html,"i").replace("comment",ne._comment).replace("tag",ne._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ne.paragraph=o(ne._paragraph).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.blockquote=o(ne.blockquote).replace("paragraph",ne.paragraph).getRegex(),ne.normal=M({},ne),ne.gfm=M({},ne.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ne.gfm.table=o(ne.gfm.table).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.gfm.paragraph=o(ne._paragraph).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ne.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.pedantic=M({},ne.normal,{html:o(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ne._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:S,paragraph:o(ne.normal._paragraph).replace("hr",ne.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ne.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var te={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:S,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:S,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};te._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",te.punctuation=o(te.punctuation).replace(/punctuation/g,te._punctuation).getRegex(),te.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,te.escapedEmSt=/\\\*|\\_/g,te._comment=o(ne._comment).replace("(?:-->|$)","-->").getRegex(),te.emStrong.lDelim=o(te.emStrong.lDelim).replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimAst=o(te.emStrong.rDelimAst,"g").replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimUnd=o(te.emStrong.rDelimUnd,"g").replace(/punct/g,te._punctuation).getRegex(),te._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,te._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,te._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,te.autolink=o(te.autolink).replace("scheme",te._scheme).replace("email",te._email).getRegex(),te._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,te.tag=o(te.tag).replace("comment",te._comment).replace("attribute",te._attribute).getRegex(),te._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,te._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,te._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,te.link=o(te.link).replace("label",te._label).replace("href",te._href).replace("title",te._title).getRegex(),te.reflink=o(te.reflink).replace("label",te._label).replace("ref",ne._label).getRegex(),te.nolink=o(te.nolink).replace("ref",ne._label).getRegex(),te.reflinkSearch=o(te.reflinkSearch,"g").replace("reflink",te.reflink).replace("nolink",te.nolink).getRegex(),te.normal=M({},te),te.pedantic=M({},te.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:o(/^!?\[(label)\]\((.*?)\)/).replace("label",te._label).getRegex(),reflink:o(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",te._label).getRegex()}),te.gfm=M({},te.normal,{escape:o(te.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),te.gfm.url=o(te.gfm.url,"i").replace("email",te.gfm._extended_email).getRegex(),te.breaks=M({},te.gfm,{br:o(te.br).replace("{2,}","*").getRegex(),text:o(te.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function we(i){return i.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Te(i){var r="",c,u,d=i.length;for(c=0;c<d;c++)u=i.charCodeAt(c),Math.random()>.5&&(u="x"+u.toString(16)),r+="&#"+u+";";return r}var Pe=function(){function i(c){this.tokens=[],this.tokens.links=Object.create(null),this.options=c||ie.defaults,this.options.tokenizer=this.options.tokenizer||new ue,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var u={block:ne.normal,inline:te.normal};this.options.pedantic?(u.block=ne.pedantic,u.inline=te.pedantic):this.options.gfm&&(u.block=ne.gfm,this.options.breaks?u.inline=te.breaks:u.inline=te.gfm),this.tokenizer.rules=u}i.lex=function(u,d){var F=new i(d);return F.lex(u)},i.lexInline=function(u,d){var F=new i(d);return F.inlineTokens(u)};var r=i.prototype;return r.lex=function(u){u=u.replace(/\r\n|\r/g,`
`),this.blockTokens(u,this.tokens);for(var d;d=this.inlineQueue.shift();)this.inlineTokens(d.src,d.tokens);return this.tokens},r.blockTokens=function(u,d){var F=this;d===void 0&&(d=[]),this.options.pedantic?u=u.replace(/\t/g,"    ").replace(/^ +$/gm,""):u=u.replace(/^( *)(\t+)/gm,function(oe,se,de){return se+"    ".repeat(de.length)});for(var R,W,z,q;u;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(oe){return(R=oe.call({lexer:F},u,d))?(u=u.substring(R.raw.length),d.push(R),!0):!1}))){if(R=this.tokenizer.space(u)){u=u.substring(R.raw.length),R.raw.length===1&&d.length>0?d[d.length-1].raw+=`
`:d.push(R);continue}if(R=this.tokenizer.code(u)){u=u.substring(R.raw.length),W=d[d.length-1],W&&(W.type==="paragraph"||W.type==="text")?(W.raw+=`
`+R.raw,W.text+=`
`+R.text,this.inlineQueue[this.inlineQueue.length-1].src=W.text):d.push(R);continue}if(R=this.tokenizer.fences(u)){u=u.substring(R.raw.length),d.push(R);continue}if(R=this.tokenizer.heading(u)){u=u.substring(R.raw.length),d.push(R);continue}if(R=this.tokenizer.hr(u)){u=u.substring(R.raw.length),d.push(R);continue}if(R=this.tokenizer.blockquote(u)){u=u.substring(R.raw.length),d.push(R);continue}if(R=this.tokenizer.list(u)){u=u.substring(R.raw.length),d.push(R);continue}if(R=this.tokenizer.html(u)){u=u.substring(R.raw.length),d.push(R);continue}if(R=this.tokenizer.def(u)){u=u.substring(R.raw.length),W=d[d.length-1],W&&(W.type==="paragraph"||W.type==="text")?(W.raw+=`
`+R.raw,W.text+=`
`+R.raw,this.inlineQueue[this.inlineQueue.length-1].src=W.text):this.tokens.links[R.tag]||(this.tokens.links[R.tag]={href:R.href,title:R.title});continue}if(R=this.tokenizer.table(u)){u=u.substring(R.raw.length),d.push(R);continue}if(R=this.tokenizer.lheading(u)){u=u.substring(R.raw.length),d.push(R);continue}if(z=u,this.options.extensions&&this.options.extensions.startBlock&&function(){var oe=1/0,se=u.slice(1),de=void 0;F.options.extensions.startBlock.forEach(function(De){de=De.call({lexer:this},se),typeof de=="number"&&de>=0&&(oe=Math.min(oe,de))}),oe<1/0&&oe>=0&&(z=u.substring(0,oe+1))}(),this.state.top&&(R=this.tokenizer.paragraph(z))){W=d[d.length-1],q&&W.type==="paragraph"?(W.raw+=`
`+R.raw,W.text+=`
`+R.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=W.text):d.push(R),q=z.length!==u.length,u=u.substring(R.raw.length);continue}if(R=this.tokenizer.text(u)){u=u.substring(R.raw.length),W=d[d.length-1],W&&W.type==="text"?(W.raw+=`
`+R.raw,W.text+=`
`+R.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=W.text):d.push(R);continue}if(u){var G="Infinite loop on byte: "+u.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return this.state.top=!0,d},r.inline=function(u,d){return d===void 0&&(d=[]),this.inlineQueue.push({src:u,tokens:d}),d},r.inlineTokens=function(u,d){var F=this;d===void 0&&(d=[]);var R,W,z,q=u,G,oe,se;if(this.tokens.links){var de=Object.keys(this.tokens.links);if(de.length>0)for(;(G=this.tokenizer.rules.inline.reflinkSearch.exec(q))!=null;)de.includes(G[0].slice(G[0].lastIndexOf("[")+1,-1))&&(q=q.slice(0,G.index)+"["+B("a",G[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(G=this.tokenizer.rules.inline.blockSkip.exec(q))!=null;)q=q.slice(0,G.index)+"["+B("a",G[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(G=this.tokenizer.rules.inline.escapedEmSt.exec(q))!=null;)q=q.slice(0,G.index)+"++"+q.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;u;)if(oe||(se=""),oe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(pe){return(R=pe.call({lexer:F},u,d))?(u=u.substring(R.raw.length),d.push(R),!0):!1}))){if(R=this.tokenizer.escape(u)){u=u.substring(R.raw.length),d.push(R);continue}if(R=this.tokenizer.tag(u)){u=u.substring(R.raw.length),W=d[d.length-1],W&&R.type==="text"&&W.type==="text"?(W.raw+=R.raw,W.text+=R.text):d.push(R);continue}if(R=this.tokenizer.link(u)){u=u.substring(R.raw.length),d.push(R);continue}if(R=this.tokenizer.reflink(u,this.tokens.links)){u=u.substring(R.raw.length),W=d[d.length-1],W&&R.type==="text"&&W.type==="text"?(W.raw+=R.raw,W.text+=R.text):d.push(R);continue}if(R=this.tokenizer.emStrong(u,q,se)){u=u.substring(R.raw.length),d.push(R);continue}if(R=this.tokenizer.codespan(u)){u=u.substring(R.raw.length),d.push(R);continue}if(R=this.tokenizer.br(u)){u=u.substring(R.raw.length),d.push(R);continue}if(R=this.tokenizer.del(u)){u=u.substring(R.raw.length),d.push(R);continue}if(R=this.tokenizer.autolink(u,Te)){u=u.substring(R.raw.length),d.push(R);continue}if(!this.state.inLink&&(R=this.tokenizer.url(u,Te))){u=u.substring(R.raw.length),d.push(R);continue}if(z=u,this.options.extensions&&this.options.extensions.startInline&&function(){var pe=1/0,Re=u.slice(1),Se=void 0;F.options.extensions.startInline.forEach(function(Me){Se=Me.call({lexer:this},Re),typeof Se=="number"&&Se>=0&&(pe=Math.min(pe,Se))}),pe<1/0&&pe>=0&&(z=u.substring(0,pe+1))}(),R=this.tokenizer.inlineText(z,we)){u=u.substring(R.raw.length),R.raw.slice(-1)!=="_"&&(se=R.raw.slice(-1)),oe=!0,W=d[d.length-1],W&&W.type==="text"?(W.raw+=R.raw,W.text+=R.text):d.push(R);continue}if(u){var De="Infinite loop on byte: "+u.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return d},A(i,null,[{key:"rules",get:function(){return{block:ne,inline:te}}}]),i}(),Oe=function(){function i(c){this.options=c||ie.defaults}var r=i.prototype;return r.code=function(u,d,F){var R=(d||"").match(/\S*/)[0];if(this.options.highlight){var W=this.options.highlight(u,R);W!=null&&W!==u&&(F=!0,u=W)}return u=u.replace(/\n$/,"")+`
`,R?'<pre><code class="'+this.options.langPrefix+e(R,!0)+'">'+(F?u:e(u,!0))+`</code></pre>
`:"<pre><code>"+(F?u:e(u,!0))+`</code></pre>
`},r.blockquote=function(u){return`<blockquote>
`+u+`</blockquote>
`},r.html=function(u){return u},r.heading=function(u,d,F,R){if(this.options.headerIds){var W=this.options.headerPrefix+R.slug(F);return"<h"+d+' id="'+W+'">'+u+"</h"+d+`>
`}return"<h"+d+">"+u+"</h"+d+`>
`},r.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},r.list=function(u,d,F){var R=d?"ol":"ul",W=d&&F!==1?' start="'+F+'"':"";return"<"+R+W+`>
`+u+"</"+R+`>
`},r.listitem=function(u){return"<li>"+u+`</li>
`},r.checkbox=function(u){return"<input "+(u?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},r.paragraph=function(u){return"<p>"+u+`</p>
`},r.table=function(u,d){return d&&(d="<tbody>"+d+"</tbody>"),`<table>
<thead>
`+u+`</thead>
`+d+`</table>
`},r.tablerow=function(u){return`<tr>
`+u+`</tr>
`},r.tablecell=function(u,d){var F=d.header?"th":"td",R=d.align?"<"+F+' align="'+d.align+'">':"<"+F+">";return R+u+("</"+F+`>
`)},r.strong=function(u){return"<strong>"+u+"</strong>"},r.em=function(u){return"<em>"+u+"</em>"},r.codespan=function(u){return"<code>"+u+"</code>"},r.br=function(){return this.options.xhtml?"<br/>":"<br>"},r.del=function(u){return"<del>"+u+"</del>"},r.link=function(u,d,F){if(u=b(this.options.sanitize,this.options.baseUrl,u),u===null)return F;var R='<a href="'+e(u)+'"';return d&&(R+=' title="'+d+'"'),R+=">"+F+"</a>",R},r.image=function(u,d,F){if(u=b(this.options.sanitize,this.options.baseUrl,u),u===null)return F;var R='<img src="'+u+'" alt="'+F+'"';return d&&(R+=' title="'+d+'"'),R+=this.options.xhtml?"/>":">",R},r.text=function(u){return u},i}(),re=function(){function i(){}var r=i.prototype;return r.strong=function(u){return u},r.em=function(u){return u},r.codespan=function(u){return u},r.del=function(u){return u},r.html=function(u){return u},r.text=function(u){return u},r.link=function(u,d,F){return""+F},r.image=function(u,d,F){return""+F},r.br=function(){return""},i}(),Z=function(){function i(){this.seen={}}var r=i.prototype;return r.serialize=function(u){return u.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},r.getNextSafeSlug=function(u,d){var F=u,R=0;if(this.seen.hasOwnProperty(F)){R=this.seen[u];do R++,F=u+"-"+R;while(this.seen.hasOwnProperty(F))}return d||(this.seen[u]=R,this.seen[F]=0),F},r.slug=function(u,d){d===void 0&&(d={});var F=this.serialize(u);return this.getNextSafeSlug(F,d.dryrun)},i}(),ae=function(){function i(c){this.options=c||ie.defaults,this.options.renderer=this.options.renderer||new Oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new re,this.slugger=new Z}i.parse=function(u,d){var F=new i(d);return F.parse(u)},i.parseInline=function(u,d){var F=new i(d);return F.parseInline(u)};var r=i.prototype;return r.parse=function(u,d){d===void 0&&(d=!0);var F="",R,W,z,q,G,oe,se,de,De,pe,Re,Se,Me,Be,Ie,Ze,Ke,xe,x,le=u.length;for(R=0;R<le;R++){if(pe=u[R],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[pe.type]&&(x=this.options.extensions.renderers[pe.type].call({parser:this},pe),x!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(pe.type))){F+=x||"";continue}switch(pe.type){case"space":continue;case"hr":{F+=this.renderer.hr();continue}case"heading":{F+=this.renderer.heading(this.parseInline(pe.tokens),pe.depth,g(this.parseInline(pe.tokens,this.textRenderer)),this.slugger);continue}case"code":{F+=this.renderer.code(pe.text,pe.lang,pe.escaped);continue}case"table":{for(de="",se="",q=pe.header.length,W=0;W<q;W++)se+=this.renderer.tablecell(this.parseInline(pe.header[W].tokens),{header:!0,align:pe.align[W]});for(de+=this.renderer.tablerow(se),De="",q=pe.rows.length,W=0;W<q;W++){for(oe=pe.rows[W],se="",G=oe.length,z=0;z<G;z++)se+=this.renderer.tablecell(this.parseInline(oe[z].tokens),{header:!1,align:pe.align[z]});De+=this.renderer.tablerow(se)}F+=this.renderer.table(de,De);continue}case"blockquote":{De=this.parse(pe.tokens),F+=this.renderer.blockquote(De);continue}case"list":{for(Re=pe.ordered,Se=pe.start,Me=pe.loose,q=pe.items.length,De="",W=0;W<q;W++)Ie=pe.items[W],Ze=Ie.checked,Ke=Ie.task,Be="",Ie.task&&(xe=this.renderer.checkbox(Ze),Me?Ie.tokens.length>0&&Ie.tokens[0].type==="paragraph"?(Ie.tokens[0].text=xe+" "+Ie.tokens[0].text,Ie.tokens[0].tokens&&Ie.tokens[0].tokens.length>0&&Ie.tokens[0].tokens[0].type==="text"&&(Ie.tokens[0].tokens[0].text=xe+" "+Ie.tokens[0].tokens[0].text)):Ie.tokens.unshift({type:"text",text:xe}):Be+=xe),Be+=this.parse(Ie.tokens,Me),De+=this.renderer.listitem(Be,Ke,Ze);F+=this.renderer.list(De,Re,Se);continue}case"html":{F+=this.renderer.html(pe.text);continue}case"paragraph":{F+=this.renderer.paragraph(this.parseInline(pe.tokens));continue}case"text":{for(De=pe.tokens?this.parseInline(pe.tokens):pe.text;R+1<le&&u[R+1].type==="text";)pe=u[++R],De+=`
`+(pe.tokens?this.parseInline(pe.tokens):pe.text);F+=d?this.renderer.paragraph(De):De;continue}default:{var fe='Token with "'+pe.type+'" type was not found.';if(this.options.silent){console.error(fe);return}else throw new Error(fe)}}}return F},r.parseInline=function(u,d){d=d||this.renderer;var F="",R,W,z,q=u.length;for(R=0;R<q;R++){if(W=u[R],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[W.type]&&(z=this.options.extensions.renderers[W.type].call({parser:this},W),z!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(W.type))){F+=z||"";continue}switch(W.type){case"escape":{F+=d.text(W.text);break}case"html":{F+=d.html(W.text);break}case"link":{F+=d.link(W.href,W.title,this.parseInline(W.tokens,d));break}case"image":{F+=d.image(W.href,W.title,W.text);break}case"strong":{F+=d.strong(this.parseInline(W.tokens,d));break}case"em":{F+=d.em(this.parseInline(W.tokens,d));break}case"codespan":{F+=d.codespan(W.text);break}case"br":{F+=d.br();break}case"del":{F+=d.del(this.parseInline(W.tokens,d));break}case"text":{F+=d.text(W.text);break}default:{var G='Token with "'+W.type+'" type was not found.';if(this.options.silent){console.error(G);return}else throw new Error(G)}}}return F},i}();function K(i,r,c){if(typeof i>"u"||i===null)throw new Error("marked(): input parameter is undefined or null");if(typeof i!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(i)+", string expected");if(typeof r=="function"&&(c=r,r=null),r=M({},K.defaults,r||{}),I(r),c){var u=r.highlight,d;try{d=Pe.lex(i,r)}catch(q){return c(q)}var F=function(G){var oe;if(!G)try{r.walkTokens&&K.walkTokens(d,r.walkTokens),oe=ae.parse(d,r)}catch(se){G=se}return r.highlight=u,G?c(G):c(null,oe)};if(!u||u.length<3||(delete r.highlight,!d.length))return F();var R=0;K.walkTokens(d,function(q){q.type==="code"&&(R++,setTimeout(function(){u(q.text,q.lang,function(G,oe){if(G)return F(G);oe!=null&&oe!==q.text&&(q.text=oe,q.escaped=!0),R--,R===0&&F()})},0))}),R===0&&F();return}function W(q){if(q.message+=`
Please report this to https://github.com/markedjs/marked.`,r.silent)return"<p>An error occurred:</p><pre>"+e(q.message+"",!0)+"</pre>";throw q}try{var z=Pe.lex(i,r);if(r.walkTokens){if(r.async)return Promise.all(K.walkTokens(z,r.walkTokens)).then(function(){return ae.parse(z,r)}).catch(W);K.walkTokens(z,r.walkTokens)}return ae.parse(z,r)}catch(q){W(q)}}K.options=K.setOptions=function(i){return M(K.defaults,i),k(K.defaults),K},K.getDefaults=E,K.defaults=ie.defaults,K.use=function(){for(var i=arguments.length,r=new Array(i),c=0;c<i;c++)r[c]=arguments[c];var u=M.apply(void 0,[{}].concat(r)),d=K.defaults.extensions||{renderers:{},childTokens:{}},F;r.forEach(function(R){if(R.extensions&&(F=!0,R.extensions.forEach(function(z){if(!z.name)throw new Error("extension name required");if(z.renderer){var q=d.renderers?d.renderers[z.name]:null;q?d.renderers[z.name]=function(){for(var G=arguments.length,oe=new Array(G),se=0;se<G;se++)oe[se]=arguments[se];var de=z.renderer.apply(this,oe);return de===!1&&(de=q.apply(this,oe)),de}:d.renderers[z.name]=z.renderer}if(z.tokenizer){if(!z.level||z.level!=="block"&&z.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");d[z.level]?d[z.level].unshift(z.tokenizer):d[z.level]=[z.tokenizer],z.start&&(z.level==="block"?d.startBlock?d.startBlock.push(z.start):d.startBlock=[z.start]:z.level==="inline"&&(d.startInline?d.startInline.push(z.start):d.startInline=[z.start]))}z.childTokens&&(d.childTokens[z.name]=z.childTokens)})),R.renderer&&function(){var z=K.defaults.renderer||new Oe,q=function(se){var de=z[se];z[se]=function(){for(var De=arguments.length,pe=new Array(De),Re=0;Re<De;Re++)pe[Re]=arguments[Re];var Se=R.renderer[se].apply(z,pe);return Se===!1&&(Se=de.apply(z,pe)),Se}};for(var G in R.renderer)q(G);u.renderer=z}(),R.tokenizer&&function(){var z=K.defaults.tokenizer||new ue,q=function(se){var de=z[se];z[se]=function(){for(var De=arguments.length,pe=new Array(De),Re=0;Re<De;Re++)pe[Re]=arguments[Re];var Se=R.tokenizer[se].apply(z,pe);return Se===!1&&(Se=de.apply(z,pe)),Se}};for(var G in R.tokenizer)q(G);u.tokenizer=z}(),R.walkTokens){var W=K.defaults.walkTokens;u.walkTokens=function(z){var q=[];return q.push(R.walkTokens.call(this,z)),W&&(q=q.concat(W.call(this,z))),q}}F&&(u.extensions=d),K.setOptions(u)})},K.walkTokens=function(i,r){for(var c=[],u=function(){var W=F.value;switch(c=c.concat(r.call(K,W)),W.type){case"table":{for(var z=j(W.header),q;!(q=z()).done;){var G=q.value;c=c.concat(K.walkTokens(G.tokens,r))}for(var oe=j(W.rows),se;!(se=oe()).done;)for(var de=se.value,De=j(de),pe;!(pe=De()).done;){var Re=pe.value;c=c.concat(K.walkTokens(Re.tokens,r))}break}case"list":{c=c.concat(K.walkTokens(W.items,r));break}default:K.defaults.extensions&&K.defaults.extensions.childTokens&&K.defaults.extensions.childTokens[W.type]?K.defaults.extensions.childTokens[W.type].forEach(function(Se){c=c.concat(K.walkTokens(W[Se],r))}):W.tokens&&(c=c.concat(K.walkTokens(W.tokens,r)))}},d=j(i),F;!(F=d()).done;)u();return c},K.parseInline=function(i,r){if(typeof i>"u"||i===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof i!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(i)+", string expected");r=M({},K.defaults,r||{}),I(r);try{var c=Pe.lexInline(i,r);return r.walkTokens&&K.walkTokens(c,r.walkTokens),ae.parseInline(c,r)}catch(u){if(u.message+=`
Please report this to https://github.com/markedjs/marked.`,r.silent)return"<p>An error occurred:</p><pre>"+e(u.message+"",!0)+"</pre>";throw u}},K.Parser=ae,K.parser=ae.parse,K.Renderer=Oe,K.TextRenderer=re,K.Lexer=Pe,K.lexer=Pe.lex,K.Tokenizer=ue,K.Slugger=Z,K.parse=K;var H=K.options,J=K.setOptions,me=K.use,ve=K.walkTokens,Fe=K.parseInline,Ae=K,ge=ae.parse,v=Pe.lex;ie.Lexer=Pe,ie.Parser=ae,ie.Renderer=Oe,ie.Slugger=Z,ie.TextRenderer=re,ie.Tokenizer=ue,ie.getDefaults=E,ie.lexer=v,ie.marked=K,ie.options=H,ie.parse=Ae,ie.parseInline=Fe,ie.parser=ge,ie.setOptions=J,ie.use=me,ie.walkTokens=ve,Object.defineProperty(ie,"__esModule",{value:!0})}),define(be[80],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Oj=void 0;function A(s){const g=j(s);if(g&&g.length>0)return new Uint32Array(g)}t.$Oj=A;let C=0;const n=new Uint32Array(10);function j(s){if(C=0,E(s,L,4352),C>0||(E(s,l,4449),C>0)||(E(s,h,4520),C>0)||(E(s,e,12593),C))return n.subarray(0,C);if(s>=44032&&s<=55203){const g=s-44032,$=g%588,o=Math.floor(g/588),a=Math.floor($/28),D=$%28-1;if(o<L.length?E(o,L,0):4352+o-12593<e.length&&E(4352+o,e,12593),a<l.length?E(a,l,0):4449+a-12593<e.length&&E(4449+a-12593,e,12593),D>=0&&(D<h.length?E(D,h,0):4520+D-12593<e.length&&E(4520+D-12593,e,12593)),C>0)return n.subarray(0,C)}}function E(s,g,$){s>=$&&s<$+g.length&&k(g[s-$])}function k(s){s!==0&&(n[C++]=s&255,s>>8&&(n[C++]=s>>8&255),s>>16&&(n[C++]=s>>16&255))}var m;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var w;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(w||(w={}));var y;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(y||(y={}));const L=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),h=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),e=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(be[81],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JS=void 0;class A{constructor(n,j=0,E=n.length,k=j-1){this.a=n,this.b=j,this.c=E,this.d=k}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$JS=A}),define(be[82],$e([1,0,81]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LS=t.$KS=void 0;class C{constructor(E=[],k=10){this.h(E),this.b=k,this.d()}getHistory(){return this.j}add(E){this.a.delete(E),this.a.add(E),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(E){return this.a.has(E)}clear(){this.h([]),this.d()}d(){this.f();const E=this.j;this.c=new A.$JS(E,0,E.length,E.length)}f(){const E=this.j;E.length>this.b&&this.h(E.slice(E.length-this.b))}g(){const E=this.c.current();return E?this.j.indexOf(E):-1}h(E){this.a=new Set;for(const k of E)this.a.add(k)}get j(){const E=[];return this.a.forEach(k=>E.push(k)),E}}t.$KS=C;class n{get size(){return this.f}constructor(E,k=10){if(this.g=k,E.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:E[0],previous:void 0,next:void 0},this.a=new Set([E[0]]);for(let m=1;m<E.length;m++)this.add(E[m])}add(E){const k={value:E,previous:this.c,next:void 0};for(this.c.next=k,this.c=k,this.d=this.c,this.f++,this.a.has(E)?this.h(E):this.a.add(E);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(E){if(this.c.value===E)return E;const k=this.c.value;return this.a.delete(k),this.c.value=E,this.a.has(E)?this.h(E):this.a.add(E),k}prepend(E){if(this.f===this.g||this.a.has(E))return;const k={value:E,previous:void 0,next:this.b};this.b.previous=k,this.b=k,this.f++,this.a.add(E)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(E){return this.a.has(E)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let E=this.b;for(;E;)yield E.value,E=E.next}h(E){let k=this.b;for(;k!==this.c;)k.value===E&&(k===this.b?(this.b=this.b.next,this.b.previous=void 0):(k.previous.next=k.next,k.next.previous=k.previous),this.f--),k=k.next}}t.$LS=n}),define(be[46],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8l=t.$7l=t.$6l=t.rot=t.$4l=void 0;function A(k,m,w){return Math.min(Math.max(k,m),w)}t.$4l=A;function C(k,m){return(m+k%m)%m}t.rot=C;class n{constructor(){this.a=0}getNext(){return this.a++}}t.$6l=n;class j{constructor(){this.a=1,this.b=0}update(m){return this.b=this.b+(m-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$7l=j;class E{constructor(m){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(m),this.c.fill(0,0,m)}update(m){const w=this.c[this.d];return this.c[this.d]=m,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=m,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$8l=E}),define(be[47],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var A;(function(C){function n(m,w){if(m.start>=w.end||w.start>=m.end)return{start:0,end:0};const y=Math.max(m.start,w.start),L=Math.min(m.end,w.end);return L-y<=0?{start:0,end:0}:{start:y,end:L}}C.intersect=n;function j(m){return m.end-m.start<=0}C.isEmpty=j;function E(m,w){return!j(n(m,w))}C.intersects=E;function k(m,w){const y=[],L={start:m.start,end:Math.min(w.start,m.end)},l={start:Math.max(w.end,m.start),end:m.end};return j(L)||y.push(L),j(l)||y.push(l),y}C.relativeComplement=k})(A||(t.Range=A={}))}),define(be[83],$e([1,0,47]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xR=t.$wR=t.$vR=t.$uR=void 0;function C(m,w){const y=[];for(const L of w){if(m.start>=L.range.end)continue;if(m.end<L.range.start)break;const l=A.Range.intersect(m,L.range);A.Range.isEmpty(l)||y.push({range:l,size:L.size})}return y}t.$uR=C;function n({start:m,end:w},y){return{start:m+y,end:w+y}}t.$vR=n;function j(m){const w=[];let y=null;for(const L of m){const l=L.range.start,h=L.range.end,e=L.size;if(y&&e===y.size){y.range.end=h;continue}y={range:{start:l,end:h},size:e},w.push(y)}return w}t.$wR=j;function E(...m){return j(m.reduce((w,y)=>w.concat(y),[]))}class k{get paddingTop(){return this.c}set paddingTop(w){this.b=this.b+w-this.c,this.c=w}constructor(w){this.a=[],this.b=0,this.c=0,this.c=w??0,this.b=this.c}splice(w,y,L=[]){const l=L.length-y,h=C({start:0,end:w},this.a),e=C({start:w+y,end:Number.POSITIVE_INFINITY},this.a).map(g=>({range:n(g.range,l),size:g.size})),s=L.map((g,$)=>({range:{start:w+$,end:w+$+1},size:g.size}));this.a=E(h,s,e),this.b=this.c+this.a.reduce((g,$)=>g+$.size*($.range.end-$.range.start),0)}get count(){const w=this.a.length;return w?this.a[w-1].range.end:0}get size(){return this.b}indexAt(w){if(w<0)return-1;if(w<this.c)return 0;let y=0,L=this.c;for(const l of this.a){const h=l.range.end-l.range.start,e=L+h*l.size;if(w<e)return y+Math.floor((w-L)/l.size);y+=h,L=e}return y}indexAfter(w){return Math.min(this.indexAt(w)+1,this.count)}positionAt(w){if(w<0)return-1;let y=0,L=0;for(const l of this.a){const h=l.range.end-l.range.start,e=L+h;if(w<e)return this.c+y+(w-L)*l.size;y+=h*l.size,L=e}return-1}}t.$xR=k}),define(be[84],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Od=void 0;const A=globalThis.performance&&typeof globalThis.performance.now=="function";class C{static create(j){return new C(j)}constructor(j){this.c=A&&j===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Od=C}),define(be[4],$e([1,0,6,43,2,45,84]),function(ie,t,A,C,n,j,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2d=t.$1d=t.$Zd=t.$Yd=t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.Event=void 0;const k=!1,m=!1;var w;(function(_){_.None=()=>n.$Sc.None;function P(d){if(m){const{onDidAddListener:F}=d,R=e.create();let W=0;d.onDidAddListener=()=>{++W===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),R.print()),F?.()}}}function I(d,F){return Oe(d,()=>{},0,void 0,!0,void 0,F)}_.defer=I;function B(d){return(F,R=null,W)=>{let z=!1,q;return q=d(G=>{if(!z)return q?q.dispose():z=!0,F.call(R,G)},null,W),z&&q.dispose(),q}}_.once=B;function X(d,F,R){return Te((W,z=null,q)=>d(G=>W.call(z,F(G)),null,q),R)}_.map=X;function Y(d,F,R){return Te((W,z=null,q)=>d(G=>{F(G),W.call(z,G)},null,q),R)}_.forEach=Y;function ue(d,F,R){return Te((W,z=null,q)=>d(G=>F(G)&&W.call(z,G),null,q),R)}_.filter=ue;function ne(d){return d}_.signal=ne;function te(...d){return(F,R=null,W)=>{const z=(0,n.$Pc)(...d.map(q=>q(G=>F.call(R,G))));return Pe(z,W)}}_.any=te;function we(d,F,R,W){let z=R;return X(d,q=>(z=F(z,q),z),W)}_.reduce=we;function Te(d,F){let R;const W={onWillAddFirstListener(){R=d(z.fire,z)},onDidRemoveLastListener(){R?.dispose()}};F||P(W);const z=new a(W);return F?.add(z),z.event}function Pe(d,F){return F instanceof Array?F.push(d):F&&F.add(d),d}function Oe(d,F,R=100,W=!1,z=!1,q,G){let oe,se,de,De=0,pe;const Re={leakWarningThreshold:q,onWillAddFirstListener(){oe=d(Me=>{De++,se=F(se,Me),W&&!de&&(Se.fire(se),se=void 0),pe=()=>{const Be=se;se=void 0,de=void 0,(!W||De>1)&&Se.fire(Be),De=0},typeof R=="number"?(clearTimeout(de),de=setTimeout(pe,R)):de===void 0&&(de=0,queueMicrotask(pe))})},onWillRemoveListener(){z&&De>0&&pe?.()},onDidRemoveLastListener(){pe=void 0,oe.dispose()}};G||P(Re);const Se=new a(Re);return G?.add(Se),Se.event}_.debounce=Oe;function re(d,F=0,R){return _.debounce(d,(W,z)=>W?(W.push(z),W):[z],F,void 0,!0,void 0,R)}_.accumulate=re;function Z(d,F=(W,z)=>W===z,R){let W=!0,z;return ue(d,q=>{const G=W||!F(q,z);return W=!1,z=q,G},R)}_.latch=Z;function ae(d,F,R){return[_.filter(d,F,R),_.filter(d,W=>!F(W),R)]}_.split=ae;function K(d,F=!1,R=[],W){let z=R.slice(),q=d(se=>{z?z.push(se):oe.fire(se)});W&&W.add(q);const G=()=>{z?.forEach(se=>oe.fire(se)),z=null},oe=new a({onWillAddFirstListener(){q||(q=d(se=>oe.fire(se)),W&&W.add(q))},onDidAddFirstListener(){z&&(F?setTimeout(G):G())},onDidRemoveLastListener(){q&&q.dispose(),q=null}});return W&&W.add(oe),oe.event}_.buffer=K;function H(d,F){return(W,z,q)=>{const G=F(new me);return d(function(oe){const se=G.evaluate(oe);se!==J&&W.call(z,se)},void 0,q)}}_.chain=H;const J=Symbol("HaltChainable");class me{constructor(){this.f=[]}map(F){return this.f.push(F),this}forEach(F){return this.f.push(R=>(F(R),R)),this}filter(F){return this.f.push(R=>F(R)?R:J),this}reduce(F,R){let W=R;return this.f.push(z=>(W=F(W,z),W)),this}latch(F=(R,W)=>R===W){let R=!0,W;return this.f.push(z=>{const q=R||!F(z,W);return R=!1,W=z,q?z:J}),this}evaluate(F){for(const R of this.f)if(F=R(F),F===J)break;return F}}function ve(d,F,R=W=>W){const W=(...oe)=>G.fire(R(...oe)),z=()=>d.on(F,W),q=()=>d.removeListener(F,W),G=new a({onWillAddFirstListener:z,onDidRemoveLastListener:q});return G.event}_.fromNodeEventEmitter=ve;function Fe(d,F,R=W=>W){const W=(...oe)=>G.fire(R(...oe)),z=()=>d.addEventListener(F,W),q=()=>d.removeEventListener(F,W),G=new a({onWillAddFirstListener:z,onDidRemoveLastListener:q});return G.event}_.fromDOMEventEmitter=Fe;function Ae(d){return new Promise(F=>B(d)(F))}_.toPromise=Ae;function ge(d){const F=new a;return d.then(R=>{F.fire(R)},()=>{F.fire(void 0)}).finally(()=>{F.dispose()}),F.event}_.fromPromise=ge;function v(d,F,R){return F(R),d(W=>F(W))}_.runAndSubscribe=v;function i(d,F){let R=null;function W(q){R?.dispose(),R=new n.$Rc,F(q,R)}W(void 0);const z=d(q=>W(q));return(0,n.$Qc)(()=>{z.dispose(),R?.dispose()})}_.runAndSubscribeWithStore=i;class r{constructor(F,R){this._observable=F,this.f=0,this.g=!1;const W={onWillAddFirstListener:()=>{F.addObserver(this)},onDidRemoveLastListener:()=>{F.removeObserver(this)}};R||P(W),this.emitter=new a(W),R&&R.add(this.emitter)}beginUpdate(F){this.f++}handlePossibleChange(F){}handleChange(F,R){this.g=!0}endUpdate(F){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function c(d,F){return new r(d,F).emitter.event}_.fromObservable=c;function u(d){return(F,R,W)=>{let z=0,q=!1;const G={beginUpdate(){z++},endUpdate(){z--,z===0&&(d.reportChanges(),q&&(q=!1,F.call(R)))},handlePossibleChange(){},handleChange(){q=!0}};d.addObserver(G),d.reportChanges();const oe={dispose(){d.removeObserver(G)}};return W instanceof n.$Rc?W.add(oe):Array.isArray(W)&&W.push(oe),oe}}_.fromObservableLight=u})(w||(t.Event=w={}));class y{static{this.all=new Set}static{this.f=0}constructor(P){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${P}_${y.f++}`,y.all.add(this)}start(P){this.g=new E.$Od,this.listenerCount=P}stop(){if(this.g){const P=this.g.elapsed();this.durations.push(P),this.elapsedOverall+=P,this.invocationCount+=1,this.g=void 0}}}t.$Qd=y;let L=-1;function l(_){const P=L;return L=_,{dispose(){L=P}}}t.$Rd=l;class h{constructor(P,I=Math.random().toString(18).slice(2,5)){this.threshold=P,this.name=I,this.g=0}dispose(){this.f?.clear()}check(P,I){const B=this.threshold;if(B<=0||I<B)return;this.f||(this.f=new Map);const X=this.f.get(P.value)||0;if(this.f.set(P.value,X+1),this.g-=1,this.g<=0){this.g=B*.5;let Y,ue=0;for(const[ne,te]of this.f)(!Y||ue<te)&&(Y=ne,ue=te);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${ue}):`),console.warn(Y)}return()=>{const Y=this.f.get(P.value)||0;this.f.set(P.value,Y-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(P){this.value=P}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let s=0;class g{constructor(P){this.value=P,this.id=s++}}const $=2,o=(_,P)=>{if(_ instanceof g)P(_);else for(let I=0;I<_.length;I++){const B=_[I];B&&P(B)}};class a{constructor(P){this.w=0,this.f=P,this.g=L>0||this.f?.leakWarningThreshold?new h(this.f?.leakWarningThreshold??L):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(k){const P=this.t;queueMicrotask(()=>{o(P,I=>I.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(P,I,B)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),n.$Sc.None;if(this.m)return n.$Sc.None;I&&(P=P.bind(I));const X=new g(P);let Y,ue;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(X.stack=e.create(),Y=this.g.check(X.stack,this.w+1)),k&&(X.stack=ue??e.create()),this.t?this.t instanceof g?(this.u??=new b,this.t=[this.t,X]):this.t.push(X):(this.f?.onWillAddFirstListener?.(this),this.t=X,this.f?.onDidAddFirstListener?.(this)),this.w++;const ne=(0,n.$Qc)(()=>{Y?.(),this.x(X)});return B instanceof n.$Rc?B.add(ne):Array.isArray(B)&&B.push(ne),ne},this.q}x(P){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const I=this.t,B=I.indexOf(P);if(B===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,I[B]=void 0;const X=this.u.current===this;if(this.w*$<=I.length){let Y=0;for(let ue=0;ue<I.length;ue++)I[ue]?I[Y++]=I[ue]:X&&(this.u.end--,Y<this.u.i&&this.u.i--);I.length=Y}}y(P,I){if(!P)return;const B=this.f?.onListenerError||A.$1;if(!B){P.value(I);return}try{P.value(I)}catch(X){B(X)}}z(P){const I=P.current.t;for(;P.i<P.end;)this.y(I[P.i++],P.value);P.reset()}fire(P){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof g)this.y(this.t,P);else{const I=this.u;I.enqueue(this,P,this.t.length),this.z(I)}this.j?.stop()}hasListeners(){return this.w>0}}t.$Sd=a;const D=()=>new b;t.$Td=D;class b{constructor(){this.i=-1,this.end=0}enqueue(P,I,B){this.i=0,this.end=B,this.current=P,this.value=I}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class f extends a{async fireAsync(P,I,B){if(this.t)for(this.h||(this.h=new j.$3c),o(this.t,X=>this.h.push([X.value,P]));this.h.size>0&&!I.isCancellationRequested;){const[X,Y]=this.h.shift(),ue=[],ne={...Y,token:I,waitUntil:te=>{if(Object.isFrozen(ue))throw new Error("waitUntil can NOT be called asynchronous");B&&(te=B(te,X)),ue.push(te)}};try{X(ne)}catch(te){(0,A.$1)(te);continue}Object.freeze(ue),await Promise.allSettled(ue).then(te=>{for(const we of te)we.status==="rejected"&&(0,A.$1)(we.reason)})}}}t.$Ud=f;class N extends a{get isPaused(){return this.h!==0}constructor(P){super(P),this.h=0,this.s=new j.$3c,this.A=P?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const P=Array.from(this.s);this.s.clear(),super.fire(this.A(P))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(P){this.w&&(this.h!==0?this.s.push(P):super.fire(P))}}t.$Vd=N;class O extends N{constructor(P){super(P),this.k=P.delay??100}fire(P){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(P)}}t.$Wd=O;class T extends a{constructor(P){super(P),this.h=[],this.k=P?.merge}fire(P){this.hasListeners()&&(this.h.push(P),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(I=>super.fire(I)),this.h=[]}))}}t.$Xd=T;class p{constructor(){this.g=!1,this.h=[],this.f=new a({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(P){const I={event:P,listener:null};this.h.push(I),this.g&&this.m(I);const B=()=>{this.g&&this.o(I);const X=this.h.indexOf(I);this.h.splice(X,1)};return(0,n.$Qc)((0,C.$db)(B))}j(){this.g=!0,this.h.forEach(P=>this.m(P))}k(){this.g=!1,this.h.forEach(P=>this.o(P))}m(P){P.listener=P.event(I=>this.f.fire(I))}o(P){P.listener&&P.listener.dispose(),P.listener=null}dispose(){this.f.dispose()}}t.$Yd=p;class S{constructor(P,I,B,X){this.f=new n.$Rc;const Y=this.f.add(new p),ue=this.f.add(new n.$2c);function ne(te){ue.set(te,Y.add(X(te)))}for(const te of P)ne(te);this.f.add(I(te=>{ne(te)})),this.f.add(B(te=>{ue.deleteAndDispose(te)})),this.event=Y.event}dispose(){this.f.dispose()}}t.$Zd=S;class M{constructor(){this.f=[]}wrapEvent(P){return(I,B,X)=>P(Y=>{const ue=this.f[this.f.length-1];ue?ue.push(()=>I.call(B,Y)):I.call(B,Y)},void 0,X)}bufferEvents(P){const I=[];this.f.push(I);const B=P();return this.f.pop(),I.forEach(X=>X()),B}}t.$1d=M;class U{constructor(){this.f=!1,this.g=w.None,this.h=n.$Sc.None,this.j=new a({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(P){this.g=P,this.f&&(this.h.dispose(),this.h=P(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$2d=U}),define(be[16],$e([1,0,21,4,2]),function(ie,t,A,C,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_O=t.$$O=t.$0O=t.$9O=t.$8O=t.$7O=t.$6O=t.$5O=t.$4O=t.$3O=t.$2O=t.$1O=t.$ZO=t.$YO=t.$XO=t.$WO=t.$VO=t.$UO=void 0;class j{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new C.$Sd,this.onDidChangeFullscreen=this.d.event}static{this.INSTANCE=new j}getZoomLevel(){return this.a}setZoomLevel(b){this.a!==b&&(this.a=b)}getZoomFactor(){return this.b}setZoomFactor(b){this.b=b}setFullscreen(b){this.c!==b&&(this.c=b,this.d.fire())}isFullscreen(){return this.c}}class E extends n.$Sc{constructor(){super(),this.a=this.B(new C.$Sd),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(b){this.c?.removeEventListener("change",this.b),this.c=A.$window.matchMedia(`(resolution: ${A.$window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),b&&this.a.fire()}}class k extends n.$Sc{get value(){return this.b}constructor(){super(),this.a=this.B(new C.$Sd),this.onDidChange=this.a.event,this.b=this.c();const b=this.B(new E);this.B(b.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const b=document.createElement("canvas").getContext("2d"),f=A.$window.devicePixelRatio||1,N=b.webkitBackingStorePixelRatio||b.mozBackingStorePixelRatio||b.msBackingStorePixelRatio||b.oBackingStorePixelRatio||b.backingStorePixelRatio||1;return f/N}}class m{constructor(){this.a=null}b(){return this.a||(this.a=(0,n.$Lc)(new k)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function w(D,b){typeof D=="string"&&(D=A.$window.matchMedia(D)),D.addEventListener("change",b)}t.$UO=w,t.$VO=new m;function y(D){j.INSTANCE.setZoomLevel(D)}t.$WO=y;function L(){return j.INSTANCE.getZoomLevel()}t.$XO=L;function l(){return j.INSTANCE.getZoomFactor()}t.$YO=l;function h(D){j.INSTANCE.setZoomFactor(D)}t.$ZO=h;function e(D){j.INSTANCE.setFullscreen(D)}t.$1O=e;function s(){return j.INSTANCE.isFullscreen()}t.$2O=s,t.$3O=j.INSTANCE.onDidChangeFullscreen;const g=navigator.userAgent;t.$4O=g.indexOf("Firefox")>=0,t.$5O=g.indexOf("AppleWebKit")>=0,t.$6O=g.indexOf("Chrome")>=0,t.$7O=!t.$6O&&g.indexOf("Safari")>=0,t.$8O=!t.$6O&&!t.$7O&&t.$5O,t.$9O=g.indexOf("Electron/")>=0,t.$0O=g.indexOf("Android")>=0;let $=!1;if(A.$window.matchMedia){const D=A.$window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),b=A.$window.matchMedia("(display-mode: fullscreen)");$=D.matches,w(D,({matches:f})=>{$&&b.matches||($=f)})}function o(){return $}t.$$O=o;function a(){return navigator?.windowControlsOverlay?.visible}t.$_O=a}),define(be[22],$e([1,0,4]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mR=void 0;class C{get event(){return this.a.event}constructor(j,E,k){const m=w=>this.a.fire(w);this.a=new A.$Sd({onWillAddFirstListener:()=>j.addEventListener(E,m,k),onDidRemoveLastListener:()=>j.removeEventListener(E,m,k)})}dispose(){this.a.dispose()}}t.$mR=C}),define(be[29],$e([1,0,4]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3d=t.CancellationToken=void 0;const C=Object.freeze(function(k,m){const w=setTimeout(k.bind(m),0);return{dispose(){clearTimeout(w)}}});var n;(function(k){function m(w){return w===k.None||w===k.Cancelled||w instanceof j?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}k.isCancellationToken=m,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:A.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:C})})(n||(t.CancellationToken=n={}));class j{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?C:(this.b||(this.b=new A.$Sd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class E{constructor(m){this.f=void 0,this.g=void 0,this.g=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new j),this.f}cancel(){this.f?this.f instanceof j&&this.f.cancel():this.f=n.Cancelled}dispose(m=!1){m&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof j&&this.f.dispose():this.f=n.None}}t.$3d=E}),define(be[85],$e([1,0,29]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$De=t.$Ce=t.$Be=void 0;class C{constructor(k){this.b=k,this.a=null}get(){if(this.a)return this.a;const k=new A.$3d,m=this.b(k.token);return this.a={promise:m,dispose:()=>{this.a=null,k.cancel(),k.dispose()}},this.a}}t.$Be=C;class n{constructor(k){this.c=k,this.a=void 0,this.b=void 0}get(k){const m=JSON.stringify(k);return this.b!==m&&(this.b=m,this.a=this.c(k)),this.a}}t.$Ce=n;class j{get cachedValues(){return this.a}constructor(k){this.b=k,this.a=new Map}get(k){if(this.a.has(k))return this.a.get(k);const m=this.b(k);return this.a.set(k,m),m}}t.$De=j}),define(be[48],$e([1,0,4,2]),function(ie,t,A,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$as=t.$_r=t.$$r=t.$0r=t.ScrollbarVisibility=void 0;var n;(function(h){h[h.Auto=1]="Auto",h[h.Hidden=2]="Hidden",h[h.Visible=3]="Visible"})(n||(t.ScrollbarVisibility=n={}));class j{constructor(e,s,g,$,o,a,D){this.c=e,this._scrollStateBrand=void 0,this.c&&(s=s|0,g=g|0,$=$|0,o=o|0,a=a|0,D=D|0),this.rawScrollLeft=$,this.rawScrollTop=D,s<0&&(s=0),$+s>g&&($=g-s),$<0&&($=0),o<0&&(o=0),D+o>a&&(D=a-o),D<0&&(D=0),this.width=s,this.scrollWidth=g,this.scrollLeft=$,this.height=o,this.scrollHeight=a,this.scrollTop=D}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,s){return new j(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new j(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,s){const g=this.width!==e.width,$=this.scrollWidth!==e.scrollWidth,o=this.scrollLeft!==e.scrollLeft,a=this.height!==e.height,D=this.scrollHeight!==e.scrollHeight,b=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:s,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:g,scrollWidthChanged:$,scrollLeftChanged:o,heightChanged:a,scrollHeightChanged:D,scrollTopChanged:b}}}t.$0r=j;class E extends C.$Sc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new A.$Sd),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new j(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,s){const g=this.g.withScrollDimensions(e,s);this.n(g,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const s=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(s,!1)}setScrollPositionSmooth(e,s){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const g=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===g.scrollLeft&&this.h.to.scrollTop===g.scrollTop)return;let $;s?$=new y(this.h.from,g,this.h.startTime,this.h.duration):$=this.h.combine(this.g,g,this.c),this.h.dispose(),this.h=$}else{const g=this.g.withScrollPosition(e);this.h=y.start(this.g,g,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),s=this.g.withScrollPosition(e);if(this.n(s,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,s){const g=this.g;g.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(g,s)))}}t.$$r=E;class k{constructor(e,s,g){this.scrollLeft=e,this.scrollTop=s,this.isDone=g}}t.$_r=k;function m(h,e){const s=e-h;return function(g){return h+s*l(g)}}function w(h,e,s){return function(g){return g<s?h(g/s):e((g-s)/(1-s))}}class y{constructor(e,s,g,$){this.from=e,this.to=s,this.duration=$,this.startTime=g,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,s,g){if(Math.abs(e-s)>2.5*g){let o,a;return e<s?(o=e+.75*g,a=s-.75*g):(o=e-.75*g,a=s+.75*g),w(m(e,o),m(a,s),.33)}return m(e,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const s=(e-this.startTime)/this.duration;if(s<1){const g=this.c(s),$=this.d(s);return new k(g,$,!1)}return new k(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,s,g){return y.start(e,s,g)}static start(e,s,g){g=g+10;const $=Date.now()-10;return new y(e,s,$,g)}}t.$as=y;function L(h){return Math.pow(h,3)}function l(h){return 1-L(1-h)}}),define(be[86],$e([1,0,6,2]),function(ie,t,A,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fe=t.$ee=t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=void 0;function n(D){const b=D;return b?typeof b.read=="function":!1}t.$4d=n;function j(D){const b=D;return b?[b.on,b.pause,b.resume,b.destroy].every(f=>typeof f=="function"):!1}t.$5d=j;function E(D){const b=D;return b?j(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}t.$6d=E;function k(D,b){return new m(D,b)}t.$7d=k;class m{constructor(b,f){this.e=b,this.f=f,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(f=>this.d.push(f))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(f=>f(b))}h(b){this.c.error.length===0?(0,A.$1)(b):this.c.error.slice(0).forEach(f=>f(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,f){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(f),this.resume();break;case"end":this.c.end.push(f),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(f),this.a.flowing&&this.k();break}}removeListener(b,f){if(this.a.destroyed)return;let N;switch(b){case"data":N=this.c.data;break;case"end":N=this.c.end;break;case"error":N=this.c.error;break}if(N){const O=N.indexOf(f);O>=0&&N.splice(O,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const f=[...this.d];this.d.length=0,f.forEach(N=>N())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(D,b){const f=[];let N;for(;(N=D.read())!==null;)f.push(N);return b(f)}t.$8d=w;function y(D,b,f){const N=[];let O;for(;(O=D.read())!==null&&N.length<f;)N.push(O);return O===null&&N.length>0?b(N):{read:()=>{if(N.length>0)return N.shift();if(typeof O<"u"){const T=O;return O=void 0,T}return D.read()}}}t.$9d=y;function L(D,b){return new Promise((f,N)=>{const O=[];l(D,{onData:T=>{b&&O.push(T)},onError:T=>{b?N(T):f(void 0)},onEnd:()=>{f(b?b(O):void 0)}})})}t.$0d=L;function l(D,b,f){D.on("error",N=>{f?.isCancellationRequested||b.onError(N)}),D.on("end",()=>{f?.isCancellationRequested||b.onEnd()}),D.on("data",N=>{f?.isCancellationRequested||b.onData(N)})}t.$$d=l;function h(D,b){return new Promise((f,N)=>{const O=new C.$Rc,T=[],p=U=>{if(T.push(U),T.length>b)return O.dispose(),D.pause(),f({stream:D,buffer:T,ended:!1})},S=U=>(O.dispose(),N(U)),M=()=>(O.dispose(),f({stream:D,buffer:T,ended:!0}));O.add((0,C.$Qc)(()=>D.removeListener("error",S))),D.on("error",S),O.add((0,C.$Qc)(()=>D.removeListener("end",M))),D.on("end",M),O.add((0,C.$Qc)(()=>D.removeListener("data",p))),D.on("data",p)})}t.$_d=h;function e(D,b){const f=k(b);return f.end(D),f}t.$ae=e;function s(){const D=k(()=>{throw new Error("not supported")});return D.end(),D}t.$be=s;function g(D){let b=!1;return{read:()=>b?null:(b=!0,D)}}t.$ce=g;function $(D,b,f){const N=k(f);return l(D,{onData:O=>N.write(b.data(O)),onError:O=>N.error(b.error?b.error(O):O),onEnd:()=>N.end()}),N}t.$de=$;function o(D,b,f){let N=!1;return{read:()=>{const O=b.read();return N?O:(N=!0,O!==null?f([D,O]):D)}}}t.$ee=o;function a(D,b,f){let N=!1;const O=k(f);return l(b,{onData:T=>N?O.write(T):(N=!0,O.write(f([D,T]))),onError:T=>O.error(T),onEnd:()=>{N||(N=!0,O.write(D)),O.end()}}),O}t.$fe=a}),define(be[33],$e([1,0,23,86]),function(ie,t,A,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ae=t.$ze=t.$ye=t.$xe=t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=void 0;const n=typeof Buffer<"u",j=new A.$V(()=>new Uint8Array(256));let E,k;class m{static alloc(I){return n?new m(Buffer.allocUnsafe(I)):new m(new Uint8Array(I))}static wrap(I){return n&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new m(I)}static fromString(I,B){return!(B?.dontUseNodeBuffer||!1)&&n?new m(Buffer.from(I)):(E||(E=new TextEncoder),new m(E.encode(I)))}static fromByteArray(I){const B=m.alloc(I.length);for(let X=0,Y=I.length;X<Y;X++)B.buffer[X]=I[X];return B}static concat(I,B){if(typeof B>"u"){B=0;for(let ue=0,ne=I.length;ue<ne;ue++)B+=I[ue].byteLength}const X=m.alloc(B);let Y=0;for(let ue=0,ne=I.length;ue<ne;ue++){const te=I[ue];X.set(te,Y),Y+=te.byteLength}return X}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=m.alloc(this.byteLength);return I.set(this),I}toString(){return n?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(I,B){return new m(this.buffer.subarray(I,B))}set(I,B){if(I instanceof m)this.buffer.set(I.buffer,B);else if(I instanceof Uint8Array)this.buffer.set(I,B);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),B);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),B);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return l(this.buffer,I)}writeUInt32BE(I,B){h(this.buffer,I,B)}readUInt32LE(I){return e(this.buffer,I)}writeUInt32LE(I,B){s(this.buffer,I,B)}readUInt8(I){return g(this.buffer,I)}writeUInt8(I,B){$(this.buffer,I,B)}indexOf(I,B=0){return w(this.buffer,I instanceof m?I.buffer:I,B)}}t.$ge=m;function w(P,I,B=0){const X=I.byteLength,Y=P.byteLength;if(X===0)return 0;if(X===1)return P.indexOf(I[0]);if(X>Y-B)return-1;const ue=j.value;ue.fill(I.length);for(let Te=0;Te<I.length;Te++)ue[I[Te]]=I.length-Te-1;let ne=B+I.length-1,te=ne,we=-1;for(;ne<Y;)if(P[ne]===I[te]){if(te===0){we=ne;break}ne--,te--}else ne+=Math.max(I.length-te,ue[P[ne]]),te=I.length-1;return we}t.$he=w;function y(P,I){return P[I+0]<<0>>>0|P[I+1]<<8>>>0}t.$ie=y;function L(P,I,B){P[B+0]=I&255,I=I>>>8,P[B+1]=I&255}t.$je=L;function l(P,I){return P[I]*2**24+P[I+1]*2**16+P[I+2]*2**8+P[I+3]}t.$ke=l;function h(P,I,B){P[B+3]=I,I=I>>>8,P[B+2]=I,I=I>>>8,P[B+1]=I,I=I>>>8,P[B]=I}t.$le=h;function e(P,I){return P[I+0]<<0>>>0|P[I+1]<<8>>>0|P[I+2]<<16>>>0|P[I+3]<<24>>>0}t.$me=e;function s(P,I,B){P[B+0]=I&255,I=I>>>8,P[B+1]=I&255,I=I>>>8,P[B+2]=I&255,I=I>>>8,P[B+3]=I&255}t.$ne=s;function g(P,I){return P[I]}t.$oe=g;function $(P,I,B){P[B]=I}t.$pe=$;function o(P){return C.$8d(P,I=>m.concat(I))}t.$qe=o;function a(P){return C.$ce(P)}t.$re=a;function D(P){return C.$0d(P,I=>m.concat(I))}t.$se=D;async function b(P){return P.ended?m.concat(P.buffer):m.concat([...P.buffer,await D(P.stream)])}t.$te=b;function f(P){return C.$ae(P,I=>m.concat(I))}t.$ue=f;function N(P){return C.$de(P,{data:I=>typeof I=="string"?m.fromString(I):m.wrap(I)},I=>m.concat(I))}t.$ve=N;function O(P){return C.$7d(I=>m.concat(I),P)}t.$we=O;function T(P,I){return C.$ee(P,I,B=>m.concat(B))}t.$xe=T;function p(P,I){return C.$fe(P,I,B=>m.concat(B))}t.$ye=p;function S(P){let I=0,B=0,X=0;const Y=new Uint8Array(Math.floor(P.length/4*3)),ue=te=>{switch(B){case 3:Y[X++]=I|te,B=0;break;case 2:Y[X++]=I|te>>>2,I=te<<6,B=3;break;case 1:Y[X++]=I|te>>>4,I=te<<4,B=2;break;default:I=te<<2,B=1}};for(let te=0;te<P.length;te++){const we=P.charCodeAt(te);if(we>=65&&we<=90)ue(we-65);else if(we>=97&&we<=122)ue(we-97+26);else if(we>=48&&we<=57)ue(we-48+52);else if(we===43||we===45)ue(62);else if(we===47||we===95)ue(63);else{if(we===61)break;throw new SyntaxError(`Unexpected base64 character ${P[te]}`)}}const ne=X;for(;B>0;)ue(0);return m.wrap(Y).slice(0,ne)}t.$ze=S;const M="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",U="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function _({buffer:P},I=!0,B=!1){const X=B?U:M;let Y="";const ue=P.byteLength%3;let ne=0;for(;ne<P.byteLength-ue;ne+=3){const te=P[ne+0],we=P[ne+1],Te=P[ne+2];Y+=X[te>>>2],Y+=X[(te<<4|we>>>4)&63],Y+=X[(we<<2|Te>>>6)&63],Y+=X[Te&63]}if(ue===1){const te=P[ne+0];Y+=X[te>>>2],Y+=X[te<<4&63],I&&(Y+="==")}else if(ue===2){const te=P[ne+0],we=P[ne+1];Y+=X[te>>>2],Y+=X[(te<<4|we>>>4)&63],Y+=X[we<<2&63],I&&(Y+="=")}return Y}t.$Ae=_}),define(be[10],$e([1,0,85,23]),function(ie,t,A,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ef=t.$Df=t.$Cf=t.$Bf=t.GraphemeBreakType=t.$Af=t.$zf=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=t.$Ge=void 0;function n(x){return!x||typeof x!="string"?!0:x.trim().length===0}t.$Ge=n;const j=/{(\d+)}/g;function E(x,...le){return le.length===0?x:x.replace(j,function(fe,Ee){const Ne=parseInt(Ee,10);return isNaN(Ne)||Ne<0||Ne>=le.length?fe:le[Ne]})}t.$He=E;const k=/{([^}]+)}/g;function m(x,le){return Object.keys(le).length===0?x:x.replace(k,(fe,Ee)=>le[Ee]??fe)}t.$Ie=m;function w(x){return x.replace(/[<>"'&]/g,le=>{switch(le){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return le})}t.$Je=w;function y(x){return x.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}t.$Ke=y;function L(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Le=L;function l(x,le){let fe=0;const Ee=le.charCodeAt(0);for(let Ne=x.length-1;Ne>=0;Ne--)x.charCodeAt(Ne)===Ee&&fe++;return fe}t.$Me=l;function h(x,le,fe="\u2026"){return x.length<=le?x:`${x.substr(0,le)}${fe}`}t.$Ne=h;function e(x,le,fe="\u2026"){if(x.length<=le)return x;const Ee=Math.ceil(le/2)-fe.length/2,Ne=Math.floor(le/2)-fe.length/2;return`${x.substr(0,Ee)}${fe}${x.substr(x.length-Ne)}`}t.$Oe=e;function s(x,le=" "){const fe=g(x,le);return $(fe,le)}t.$Pe=s;function g(x,le){if(!x||!le)return x;const fe=le.length;if(fe===0||x.length===0)return x;let Ee=0;for(;x.indexOf(le,Ee)===Ee;)Ee=Ee+fe;return x.substring(Ee)}t.$Qe=g;function $(x,le){if(!x||!le)return x;const fe=le.length,Ee=x.length;if(fe===0||Ee===0)return x;let Ne=Ee,je=-1;for(;je=x.lastIndexOf(le,Ne-1),!(je===-1||je+fe!==Ne);){if(je===0)return"";Ne=je}return x.substring(0,Ne)}t.$Re=$;function o(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$Se=o;function a(x){return x.replace(/\*/g,"")}t.$Te=a;function D(x,le,fe={}){if(!x)throw new Error("Cannot create regex from empty string");le||(x=L(x)),fe.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let Ee="";return fe.global&&(Ee+="g"),fe.matchCase||(Ee+="i"),fe.multiline&&(Ee+="m"),fe.unicode&&(Ee+="u"),new RegExp(x,Ee)}t.$Ue=D;function b(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}t.$Ve=b;function f(x){return x.split(/\r\n|\r|\n/)}t.$We=f;function N(x){for(let le=0,fe=x.length;le<fe;le++){const Ee=x.charCodeAt(le);if(Ee!==32&&Ee!==9)return le}return-1}t.$Xe=N;function O(x,le=0,fe=x.length){for(let Ee=le;Ee<fe;Ee++){const Ne=x.charCodeAt(Ee);if(Ne!==32&&Ne!==9)return x.substring(le,Ee)}return x.substring(le,fe)}t.$Ye=O;function T(x,le=x.length-1){for(let fe=le;fe>=0;fe--){const Ee=x.charCodeAt(fe);if(Ee!==32&&Ee!==9)return fe}return-1}t.$Ze=T;function p(x,le,fe){const Ee=[];let Ne=0;for(const je of x.matchAll(le)){if(Ee.push(x.slice(Ne,je.index)),je.index===void 0)throw new Error("match.index should be defined");Ne=je.index+je[0].length,Ee.push(fe(je[0],...je.slice(1),je.index,x,je.groups))}return Ee.push(x.slice(Ne)),Promise.all(Ee).then(je=>je.join(""))}t.$1e=p;function S(x,le){return x<le?-1:x>le?1:0}t.$2e=S;function M(x,le,fe=0,Ee=x.length,Ne=0,je=le.length){for(;fe<Ee&&Ne<je;fe++,Ne++){const et=x.charCodeAt(fe),tt=le.charCodeAt(Ne);if(et<tt)return-1;if(et>tt)return 1}const Qe=Ee-fe,_e=je-Ne;return Qe<_e?-1:Qe>_e?1:0}t.$3e=M;function U(x,le){return _(x,le,0,x.length,0,le.length)}t.$4e=U;function _(x,le,fe=0,Ee=x.length,Ne=0,je=le.length){for(;fe<Ee&&Ne<je;fe++,Ne++){let et=x.charCodeAt(fe),tt=le.charCodeAt(Ne);if(et===tt)continue;if(et>=128||tt>=128)return M(x.toLowerCase(),le.toLowerCase(),fe,Ee,Ne,je);I(et)&&(et-=32),I(tt)&&(tt-=32);const Je=et-tt;if(Je!==0)return Je}const Qe=Ee-fe,_e=je-Ne;return Qe<_e?-1:Qe>_e?1:0}t.$5e=_;function P(x){return x>=48&&x<=57}t.$6e=P;function I(x){return x>=97&&x<=122}t.$7e=I;function B(x){return x>=65&&x<=90}t.$8e=B;function X(x,le){return x.length===le.length&&_(x,le)===0}t.$9e=X;function Y(x,le){const fe=le.length;return le.length>x.length?!1:_(x,le,0,fe)===0}t.$0e=Y;function ue(x,le){const fe=Math.min(x.length,le.length);let Ee;for(Ee=0;Ee<fe;Ee++)if(x.charCodeAt(Ee)!==le.charCodeAt(Ee))return Ee;return fe}t.$$e=ue;function ne(x,le){const fe=Math.min(x.length,le.length);let Ee;const Ne=x.length-1,je=le.length-1;for(Ee=0;Ee<fe;Ee++)if(x.charCodeAt(Ne-Ee)!==le.charCodeAt(je-Ee))return Ee;return fe}t.$_e=ne;function te(x){return 55296<=x&&x<=56319}t.$af=te;function we(x){return 56320<=x&&x<=57343}t.$bf=we;function Te(x,le){return(x-55296<<10)+(le-56320)+65536}t.$cf=Te;function Pe(x,le,fe){const Ee=x.charCodeAt(fe);if(te(Ee)&&fe+1<le){const Ne=x.charCodeAt(fe+1);if(we(Ne))return Te(Ee,Ne)}return Ee}t.$df=Pe;function Oe(x,le){const fe=x.charCodeAt(le-1);if(we(fe)&&le>1){const Ee=x.charCodeAt(le-2);if(te(Ee))return Te(Ee,fe)}return fe}class re{get offset(){return this.e}constructor(le,fe=0){this.c=le,this.d=le.length,this.e=fe}setOffset(le){this.e=le}prevCodePoint(){const le=Oe(this.c,this.e);return this.e-=le>=65536?2:1,le}nextCodePoint(){const le=Pe(this.c,this.d,this.e);return this.e+=le>=65536?2:1,le}eol(){return this.e>=this.d}}t.$ef=re;class Z{get offset(){return this.c.offset}constructor(le,fe=0){this.c=new re(le,fe)}nextGraphemeLength(){const le=Re.getInstance(),fe=this.c,Ee=fe.offset;let Ne=le.getGraphemeBreakType(fe.nextCodePoint());for(;!fe.eol();){const je=fe.offset,Qe=le.getGraphemeBreakType(fe.nextCodePoint());if(De(Ne,Qe)){fe.setOffset(je);break}Ne=Qe}return fe.offset-Ee}prevGraphemeLength(){const le=Re.getInstance(),fe=this.c,Ee=fe.offset;let Ne=le.getGraphemeBreakType(fe.prevCodePoint());for(;fe.offset>0;){const je=fe.offset,Qe=le.getGraphemeBreakType(fe.prevCodePoint());if(De(Qe,Ne)){fe.setOffset(je);break}Ne=Qe}return Ee-fe.offset}eol(){return this.c.eol()}}t.$ff=Z;function ae(x,le){return new Z(x,le).nextGraphemeLength()}t.$gf=ae;function K(x,le){return new Z(x,le).prevGraphemeLength()}t.$hf=K;function H(x,le){le>0&&we(x.charCodeAt(le))&&le--;const fe=le+ae(x,le);return[fe-K(x,fe),fe]}t.$if=H;function J(x){const le=new Z(x);let fe=0;for(;!le.eol();)fe++,le.nextGraphemeLength();return fe}t.$jf=J;let me;function ve(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Fe(x){return me||(me=ve()),me.test(x)}t.$kf=Fe;const Ae=/^[\t\n\r\x20-\x7E]*$/;function ge(x){return Ae.test(x)}t.$lf=ge,t.$mf=/[\u2028\u2029]/;function v(x){return t.$mf.test(x)}t.$nf=v;function i(x){return x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}t.$of=i;function r(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129008||x>=129280&&x<=129535||x>=129648&&x<=129782}t.$pf=r;function c(x,le,fe=""){const Ee=x.trimStart();if(Ee.length<le)return Ee;const Ne=/\b/g;let je=0;for(;Ne.test(Ee)&&!(Ee.length-Ne.lastIndex<le);)je=Ne.lastIndex,Ne.lastIndex+=1;return je===0?Ee:fe+Ee.substring(je).trimStart()}t.$qf=c;const u=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,d=/\x1b\].*?\x07/g;function F(x){return x&&(x=x.replace(u,"").replace(d,"")),x}t.$rf=F,t.$sf=String.fromCharCode(65279);function R(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}t.$tf=R;function W(x){return R(x)?x.substr(1):x}t.$uf=W;function z(x,le){if(!x||!le||x.length<le.length)return!1;const fe=le.length,Ee=x.toLowerCase();let Ne=0,je=-1;for(;Ne<fe;){const Qe=Ee.indexOf(le[Ne],je+1);if(Qe<0)return!1;je=Qe,Ne++}return!0}t.$vf=z;function q(x,le=!1){return x?(le&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}t.$wf=q;function G(x){return x.charAt(0).toUpperCase()+x.slice(1)}t.$xf=G;function oe(x,le=1){if(le===0)return"";let fe=-1;do fe=x.indexOf(`
`,fe+1),le--;while(le>0&&fe>=0);return fe===-1?x:(x[fe-1]==="\r"&&fe--,x.substr(0,fe))}t.$yf=oe;function se(x){return x=x%(2*26),x<26?String.fromCharCode(97+x):String.fromCharCode(65+x-26)}t.$zf=se;function de(x){return Re.getInstance().getGraphemeBreakType(x)}t.$Af=de;function De(x,le){return x===0?le!==5&&le!==7:x===2&&le===3?!1:x===4||x===2||x===3||le===4||le===2||le===3?!0:!(x===8&&(le===8||le===9||le===11||le===12)||(x===11||x===9)&&(le===9||le===10)||(x===12||x===10)&&le===10||le===5||le===13||le===7||x===1||x===13&&le===14||x===6&&le===6)}var pe;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(pe||(t.GraphemeBreakType=pe={}));class Re{static{this.c=null}static getInstance(){return Re.c||(Re.c=new Re),Re.c}constructor(){this.d=Se()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const fe=this.d,Ee=fe.length/3;let Ne=1;for(;Ne<=Ee;)if(le<fe[3*Ne])Ne=2*Ne;else if(le>fe[3*Ne+1])Ne=2*Ne+1;else return fe[3*Ne+2];return 0}}function Se(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Me(x,le){if(x===0)return 0;const fe=Be(x,le);if(fe!==void 0)return fe;const Ee=new re(le,x);return Ee.prevCodePoint(),Ee.offset}t.$Bf=Me;function Be(x,le){const fe=new re(le,x);let Ee=fe.prevCodePoint();for(;Ie(Ee)||Ee===65039||Ee===8419;){if(fe.offset===0)return;Ee=fe.prevCodePoint()}if(!r(Ee))return;let Ne=fe.offset;return Ne>0&&fe.prevCodePoint()===8205&&(Ne=fe.offset),Ne}function Ie(x){return 127995<=x&&x<=127999}var Ze;(function(x){x[x.zwj=8205]="zwj",x[x.emojiVariantSelector=65039]="emojiVariantSelector",x[x.enclosingKeyCap=8419]="enclosingKeyCap"})(Ze||(Ze={})),t.$Cf="\xA0";class Ke{static{this.c=new C.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new A.$Ce(le=>{function fe(Je){const nt=new Map;for(let st=0;st<Je.length;st+=2)nt.set(Je[st],Je[st+1]);return nt}function Ee(Je,nt){const st=new Map(Je);for(const[rt,gt]of nt)st.set(rt,gt);return st}function Ne(Je,nt){if(!Je)return nt;const st=new Map;for(const[rt,gt]of Je)nt.has(rt)&&st.set(rt,gt);return st}const je=this.c.value;let Qe=le.filter(Je=>!Je.startsWith("_")&&Je in je);Qe.length===0&&(Qe=["_default"]);let _e;for(const Je of Qe){const nt=fe(je[Je]);_e=Ne(_e,nt)}const et=fe(je._common),tt=Ee(et,_e);return new Ke(tt)})}static getInstance(le){return Ke.d.get(Array.from(le))}static{this.e=new C.$V(()=>Object.keys(Ke.c.value).filter(le=>!le.startsWith("_")))}static getLocales(){return Ke.e.value}constructor(le){this.f=le}isAmbiguous(le){return this.f.has(le)}getPrimaryConfusable(le){return this.f.get(le)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Df=Ke;class xe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(xe.c())),this.d}static isInvisibleCharacter(le){return xe.e().has(le)}static get codePoints(){return xe.e()}}t.$Ef=xe}),define(be[34],$e([1,0,32,80,10]),function(ie,t,A,C,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6j=t.$5j=t.$4j=t.$3j=t.FuzzyScore=t.$2j=t.$1j=t.$Zj=t.$Yj=t.$Xj=t.$Wj=t.$Vj=t.$Uj=t.$Tj=t.$Sj=t.$Rj=t.$Qj=t.or=void 0;function j(...z){return function(q,G){for(let oe=0,se=z.length;oe<se;oe++){const de=z[oe](q,G);if(de)return de}return null}}t.or=j,t.$Qj=E.bind(void 0,!1),t.$Rj=E.bind(void 0,!0);function E(z,q,G){if(!G||G.length<q.length)return null;let oe;return z?oe=n.$0e(G,q):oe=G.indexOf(q)===0,oe?q.length>0?[{start:0,end:q.length}]:[]:null}function k(z,q){const G=q.toLowerCase().indexOf(z.toLowerCase());return G===-1?null:[{start:G,end:G+z.length}]}t.$Sj=k;function m(z,q){return w(z.toLowerCase(),q.toLowerCase(),0,0)}t.$Tj=m;function w(z,q,G,oe){if(G===z.length)return[];if(oe===q.length)return null;if(z[G]===q[oe]){let se=null;return(se=w(z,q,G+1,oe+1))?D({start:oe,end:oe+1},se):null}return w(z,q,G,oe+1)}function y(z){return 97<=z&&z<=122}function L(z){return 65<=z&&z<=90}t.$Uj=L;function l(z){return 48<=z&&z<=57}function h(z){return z===32||z===9||z===10||z===13}const e=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(z=>e.add(z.charCodeAt(0)));function s(z){return h(z)||e.has(z)}function g(z,q){return z===q||s(z)&&s(q)}const $=new Map;function o(z){if($.has(z))return $.get(z);let q;const G=(0,C.$Oj)(z);return G&&(q=G),$.set(z,q),q}function a(z){return y(z)||L(z)||l(z)}function D(z,q){return q.length===0?q=[z]:z.end===q[0].start?q[0].start=z.start:q.unshift(z),q}function b(z,q){for(let G=q;G<z.length;G++){const oe=z.charCodeAt(G);if(L(oe)||l(oe)||G>0&&!a(z.charCodeAt(G-1)))return G}return z.length}function f(z,q,G,oe){if(G===z.length)return[];if(oe===q.length)return null;if(z[G]!==q[oe].toLowerCase())return null;{let se=null,de=oe+1;for(se=f(z,q,G+1,oe+1);!se&&(de=b(q,de))<q.length;)se=f(z,q,G+1,de),de++;return se===null?null:D({start:oe,end:oe+1},se)}}function N(z){let q=0,G=0,oe=0,se=0,de=0;for(let Me=0;Me<z.length;Me++)de=z.charCodeAt(Me),L(de)&&q++,y(de)&&G++,a(de)&&oe++,l(de)&&se++;const De=q/z.length,pe=G/z.length,Re=oe/z.length,Se=se/z.length;return{upperPercent:De,lowerPercent:pe,alphaPercent:Re,numericPercent:Se}}function O(z){const{upperPercent:q,lowerPercent:G}=z;return G===0&&q>.6}function T(z){const{upperPercent:q,lowerPercent:G,alphaPercent:oe,numericPercent:se}=z;return G>.2&&q<.8&&oe>.6&&se<.2}function p(z){let q=0,G=0,oe=0,se=0;for(let de=0;de<z.length;de++)oe=z.charCodeAt(de),L(oe)&&q++,y(oe)&&G++,h(oe)&&se++;return(q===0||G===0)&&se===0?z.length<=30:q<=5}function S(z,q){if(!q||(q=q.trim(),q.length===0)||!p(z)||q.length>60)return null;const G=N(q);if(!T(G)){if(!O(G))return null;q=q.toLowerCase()}let oe=null,se=0;for(z=z.toLowerCase();se<q.length&&(oe=f(z,q,0,se))===null;)se=b(q,se+1);return oe}t.$Vj=S;function M(z,q,G=!1){if(!q||q.length===0)return null;let oe=null,se=0;for(z=z.toLowerCase(),q=q.toLowerCase();se<q.length&&(oe=U(z,q,0,se,G),oe===null);)se=_(q,se+1);return oe}t.$Wj=M;function U(z,q,G,oe,se){let de=0;if(G===z.length)return[];if(oe===q.length)return null;if(!g(z.charCodeAt(G),q.charCodeAt(oe))){const Re=o(z.charCodeAt(G));if(!Re)return null;for(let Se=0;Se<Re.length;Se++)if(!g(Re[Se],q.charCodeAt(oe+Se)))return null;de+=Re.length-1}let De=null,pe=oe+de+1;if(De=U(z,q,G+1,pe,se),!se)for(;!De&&(pe=_(q,pe))<q.length;)De=U(z,q,G+1,pe,se),pe++;if(!De)return null;if(z.charCodeAt(G)!==q.charCodeAt(oe)){const Re=o(z.charCodeAt(G));if(!Re)return De;for(let Se=0;Se<Re.length;Se++)if(Re[Se]!==q.charCodeAt(oe+Se))return De}return D({start:oe,end:oe+de+1},De)}function _(z,q){for(let G=q;G<z.length;G++)if(s(z.charCodeAt(G))||G>0&&s(z.charCodeAt(G-1)))return G;return z.length}const P=j(t.$Rj,S,k),I=j(t.$Rj,S,m),B=new A.$Dc(1e4);function X(z,q,G=!1){if(typeof z!="string"||typeof q!="string")return null;let oe=B.get(z);oe||(oe=new RegExp(n.$Se(z),"i"),B.set(z,oe));const se=oe.exec(q);return se?[{start:se.index,end:se.index+se[0].length}]:G?I(z,q):P(z,q)}t.$Xj=X;function Y(z,q){const G=r(z,z.toLowerCase(),0,q,q.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return G?ne(G):null}t.$Yj=Y;function ue(z,q,G,oe,se,de){const De=Math.min(13,z.length);for(;G<De;G++){const pe=r(z,q,G,oe,se,de,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(pe)return pe}return[0,de]}t.$Zj=ue;function ne(z){if(typeof z>"u")return[];const q=[],G=z[1];for(let oe=z.length-1;oe>1;oe--){const se=z[oe]+G,de=q[q.length-1];de&&de.end===se?de.end=se+1:q.push({start:se,end:se+1})}return q}t.$1j=ne;const te=128;function we(){const z=[],q=[];for(let G=0;G<=te;G++)q[G]=0;for(let G=0;G<=te;G++)z.push(q.slice(0));return z}function Te(z){const q=[];for(let G=0;G<=z;G++)q[G]=0;return q}const Pe=Te(2*te),Oe=Te(2*te),re=we(),Z=we(),ae=we(),K=!1;function H(z,q,G,oe,se){function de(pe,Re,Se=" "){for(;pe.length<Re;)pe=Se+pe;return pe}let De=` |   |${oe.split("").map(pe=>de(pe,3)).join("|")}
`;for(let pe=0;pe<=G;pe++)pe===0?De+=" |":De+=`${q[pe-1]}|`,De+=z[pe].slice(0,se+1).map(Re=>de(Re.toString(),3)).join("|")+`
`;return De}function J(z,q,G,oe){z=z.substr(q),G=G.substr(oe),console.log(H(Z,z,z.length,G,G.length)),console.log(H(ae,z,z.length,G,G.length)),console.log(H(re,z,z.length,G,G.length))}function me(z,q){if(q<0||q>=z.length)return!1;const G=z.codePointAt(q);switch(G){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!n.$pf(G)}}function ve(z,q){if(q<0||q>=z.length)return!1;switch(z.charCodeAt(q)){case 32:case 9:return!0;default:return!1}}function Fe(z,q,G){return q[z]!==G[z]}function Ae(z,q,G,oe,se,de,De=!1){for(;q<G&&se<de;)z[q]===oe[se]&&(De&&(Pe[q]=se),q+=1),se+=1;return q===G}t.$2j=Ae;var ge;(function(z){z[z.Diag=1]="Diag",z[z.Left=2]="Left",z[z.LeftLeft=3]="LeftLeft"})(ge||(ge={}));var v;(function(z){z.Default=[-100,0];function q(G){return!G||G.length===2&&G[0]===-100&&G[1]===0}z.isDefault=q})(v||(t.FuzzyScore=v={}));class i{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(q,G){this.firstMatchCanBeWeak=q,this.boostFullMatch=G}}t.$3j=i;function r(z,q,G,oe,se,de,De=i.default){const pe=z.length>te?te:z.length,Re=oe.length>te?te:oe.length;if(G>=pe||de>=Re||pe-G>Re-de||!Ae(q,G,pe,se,de,Re,!0))return;c(pe,Re,G,de,q,se);let Se=1,Me=1,Be=G,Ie=de;const Ze=[!1];for(Se=1,Be=G;Be<pe;Se++,Be++){const fe=Pe[Be],Ee=Oe[Be],Ne=Be+1<pe?Oe[Be+1]:Re;for(Me=fe-de+1,Ie=fe;Ie<Ne;Me++,Ie++){let je=Number.MIN_SAFE_INTEGER,Qe=!1;Ie<=Ee&&(je=u(z,q,Be,G,oe,se,Ie,Re,de,re[Se-1][Me-1]===0,Ze));let _e=0;je!==Number.MAX_SAFE_INTEGER&&(Qe=!0,_e=je+Z[Se-1][Me-1]);const et=Ie>fe,tt=et?Z[Se][Me-1]+(re[Se][Me-1]>0?-5:0):0,Je=Ie>fe+1&&re[Se][Me-1]>0,nt=Je?Z[Se][Me-2]+(re[Se][Me-2]>0?-5:0):0;if(Je&&(!et||nt>=tt)&&(!Qe||nt>=_e))Z[Se][Me]=nt,ae[Se][Me]=3,re[Se][Me]=0;else if(et&&(!Qe||tt>=_e))Z[Se][Me]=tt,ae[Se][Me]=2,re[Se][Me]=0;else if(Qe)Z[Se][Me]=_e,ae[Se][Me]=1,re[Se][Me]=re[Se-1][Me-1]+1;else throw new Error("not possible")}}if(K&&J(z,G,oe,de),!Ze[0]&&!De.firstMatchCanBeWeak)return;Se--,Me--;const Ke=[Z[Se][Me],de];let xe=0,x=0;for(;Se>=1;){let fe=Me;do{const Ee=ae[Se][fe];if(Ee===3)fe=fe-2;else if(Ee===2)fe=fe-1;else break}while(fe>=1);xe>1&&q[G+Se-1]===se[de+Me-1]&&!Fe(fe+de-1,oe,se)&&xe+1>re[Se][fe]&&(fe=Me),fe===Me?xe++:xe=1,x||(x=fe),Se--,Me=fe-1,Ke.push(Me)}Re===pe&&De.boostFullMatch&&(Ke[0]+=2);const le=x-pe;return Ke[0]-=le,Ke}t.$4j=r;function c(z,q,G,oe,se,de){let De=z-1,pe=q-1;for(;De>=G&&pe>=oe;)se[De]===de[pe]&&(Oe[De]=pe,De--),pe--}function u(z,q,G,oe,se,de,De,pe,Re,Se,Me){if(q[G]!==de[De])return Number.MIN_SAFE_INTEGER;let Be=1,Ie=!1;return De===G-oe?Be=z[G]===se[De]?7:5:Fe(De,se,de)&&(De===0||!Fe(De-1,se,de))?(Be=z[G]===se[De]?7:5,Ie=!0):me(de,De)&&(De===0||!me(de,De-1))?Be=5:(me(de,De-1)||ve(de,De-1))&&(Be=5,Ie=!0),Be>1&&G===oe&&(Me[0]=!0),Ie||(Ie=Fe(De,se,de)||me(de,De-1)||ve(de,De-1)),G===oe?De>Re&&(Be-=Ie?3:5):Se?Be+=Ie?2:0:Be+=Ie?0:1,De+1===pe&&(Be-=Ie?3:5),Be}function d(z,q,G,oe,se,de,De){return R(z,q,G,oe,se,de,!0,De)}t.$5j=d;function F(z,q,G,oe,se,de,De){return R(z,q,G,oe,se,de,!1,De)}t.$6j=F;function R(z,q,G,oe,se,de,De,pe){let Re=r(z,q,G,oe,se,de,pe);if(Re&&!De)return Re;if(z.length>=3){const Se=Math.min(7,z.length-1);for(let Me=G+1;Me<Se;Me++){const Be=W(z,Me);if(Be){const Ie=r(Be,Be.toLowerCase(),G,oe,se,de,pe);Ie&&(Ie[0]-=3,(!Re||Ie[0]>Re[0])&&(Re=Ie))}}}return Re}function W(z,q){if(q+1>=z.length)return;const G=z[q],oe=z[q+1];if(G!==oe)return z.slice(0,q)+oe+G+z.slice(q+2)}}),define(be[49],$e([1,0,10]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wi=t.$Vi=t.$Ui=t.$Ti=t.$Si=t.$Ri=t.$Qi=void 0;function C($){return n($,0)}t.$Qi=C;function n($,o){switch(typeof $){case"object":return $===null?j(349,o):Array.isArray($)?m($,o):w($,o);case"string":return k($,o);case"boolean":return E($,o);case"number":return j($,o);case"undefined":return j(937,o);default:return j(617,o)}}t.$Ri=n;function j($,o){return(o<<5)-o+$|0}t.$Si=j;function E($,o){return j($?433:863,o)}function k($,o){o=j(149417,o);for(let a=0,D=$.length;a<D;a++)o=j($.charCodeAt(a),o);return o}t.$Ti=k;function m($,o){return o=j(104579,o),$.reduce((a,D)=>n(D,a),o)}function w($,o){return o=j(181387,o),Object.keys($).sort().reduce((a,D)=>(a=k(D,a),n($[D],a)),o)}class y{constructor(){this.g=0}get value(){return this.g}hash(o){return this.g=n(o,this.g),this.g}}t.$Ui=y;var L;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(L||(L={}));function l($,o,a=32){const D=a-o,b=~((1<<D)-1);return($<<o|(b&$)>>>D)>>>0}function h($,o=0,a=$.byteLength,D=0){for(let b=0;b<a;b++)$[o+b]=D}function e($,o,a="0"){for(;$.length<o;)$=a+$;return $}function s($,o=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(a=>a.toString(16).padStart(2,"0")).join(""):e(($>>>0).toString(16),o/4)}t.$Vi=s;class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(o){const a=o.length;if(a===0)return;const D=this.p;let b=this.r,f=this.u,N,O;for(f!==0?(N=f,O=-1,f=0):(N=o.charCodeAt(0),O=0);;){let T=N;if(A.$af(N))if(O+1<a){const p=o.charCodeAt(O+1);A.$bf(p)?(O++,T=A.$cf(N,p)):T=65533}else{f=N;break}else A.$bf(N)&&(T=65533);if(b=this.w(D,b,T),O++,O<a)N=o.charCodeAt(O);else break}this.r=b,this.u=f}w(o,a,D){return D<128?o[a++]=D:D<2048?(o[a++]=192|(D&1984)>>>6,o[a++]=128|(D&63)>>>0):D<65536?(o[a++]=224|(D&61440)>>>12,o[a++]=128|(D&4032)>>>6,o[a++]=128|(D&63)>>>0):(o[a++]=240|(D&1835008)>>>18,o[a++]=128|(D&258048)>>>12,o[a++]=128|(D&4032)>>>6,o[a++]=128|(D&63)>>>0),a>=64&&(this.y(),a-=64,this.t+=64,o[0]=o[64+0],o[1]=o[64+1],o[2]=o[64+2]),a}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),s(this.h)+s(this.l)+s(this.m)+s(this.n)+s(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const o=8*this.t;this.q.setUint32(56,Math.floor(o/4294967296),!1),this.q.setUint32(60,o%4294967296,!1),this.y()}y(){const o=g.g,a=this.q;for(let M=0;M<64;M+=4)o.setUint32(M,a.getUint32(M,!1),!1);for(let M=64;M<320;M+=4)o.setUint32(M,l(o.getUint32(M-12,!1)^o.getUint32(M-32,!1)^o.getUint32(M-56,!1)^o.getUint32(M-64,!1),1),!1);let D=this.h,b=this.l,f=this.m,N=this.n,O=this.o,T,p,S;for(let M=0;M<80;M++)M<20?(T=b&f|~b&N,p=1518500249):M<40?(T=b^f^N,p=1859775393):M<60?(T=b&f|b&N|f&N,p=2400959708):(T=b^f^N,p=3395469782),S=l(D,5)+T+O+p+o.getUint32(M*4,!1)&4294967295,O=N,N=f,f=l(b,30),b=D,D=S;this.h=this.h+D&4294967295,this.l=this.l+b&4294967295,this.m=this.m+f&4294967295,this.n=this.n+N&4294967295,this.o=this.o+O&4294967295}}t.$Wi=g}),define(be[87],$e([1,0,75,49]),function(ie,t,A,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Os=t.$Ns=t.$Ms=void 0;class n{constructor(l){this.a=l}getElements(){const l=this.a,h=new Int32Array(l.length);for(let e=0,s=l.length;e<s;e++)h[e]=l.charCodeAt(e);return h}}t.$Ms=n;function j(L,l,h){return new y(new n(L),new n(l)).ComputeDiff(h).changes}t.$Ns=j;class E{static Assert(l,h){if(!l)throw new Error(h)}}class k{static Copy(l,h,e,s,g){for(let $=0;$<g;$++)e[s+$]=l[h+$]}static Copy2(l,h,e,s,g){for(let $=0;$<g;$++)e[s+$]=l[h+$]}}var m;(function(L){L[L.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(m||(m={}));class w{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new A.$Ls(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(l,h){this.b=Math.min(this.b,l),this.c=Math.min(this.c,h),this.d++}AddModifiedElement(l,h){this.b=Math.min(this.b,l),this.c=Math.min(this.c,h),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class y{constructor(l,h,e=null){this.a=e,this.b=l,this.c=h;const[s,g,$]=y.o(l),[o,a,D]=y.o(h);this.d=$&&D,this.e=s,this.f=g,this.g=o,this.h=a,this.k=[],this.m=[]}static n(l){return l.length>0&&typeof l[0]=="string"}static o(l){const h=l.getElements();if(y.n(h)){const e=new Int32Array(h.length);for(let s=0,g=h.length;s<g;s++)e[s]=(0,C.$Ti)(h[s],0);return[h,e,!0]}return h instanceof Int32Array?[[],h,!1]:[[],new Int32Array(h),!1]}p(l,h){return this.f[l]!==this.h[h]?!1:this.d?this.e[l]===this.g[h]:!0}q(l,h){if(!this.p(l,h))return!1;const e=y.r(this.b,l),s=y.r(this.c,h);return e===s}static r(l,h){return typeof l.getStrictElement=="function"?l.getStrictElement(h):null}s(l,h){return this.f[l]!==this.f[h]?!1:this.d?this.e[l]===this.e[h]:!0}u(l,h){return this.h[l]!==this.h[h]?!1:this.d?this.g[l]===this.g[h]:!0}ComputeDiff(l){return this.v(0,this.f.length-1,0,this.h.length-1,l)}v(l,h,e,s,g){const $=[!1];let o=this.w(l,h,e,s,$);return g&&(o=this.z(o)),{quitEarly:$[0],changes:o}}w(l,h,e,s,g){for(g[0]=!1;l<=h&&e<=s&&this.p(l,e);)l++,e++;for(;h>=l&&s>=e&&this.p(h,s);)h--,s--;if(l>h||e>s){let f;return e<=s?(E.Assert(l===h+1,"originalStart should only be one more than originalEnd"),f=[new A.$Ls(l,0,e,s-e+1)]):l<=h?(E.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),f=[new A.$Ls(l,h-l+1,e,0)]):(E.Assert(l===h+1,"originalStart should only be one more than originalEnd"),E.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),f=[]),f}const $=[0],o=[0],a=this.y(l,h,e,s,$,o,g),D=$[0],b=o[0];if(a!==null)return a;if(!g[0]){const f=this.w(l,D,e,b,g);let N=[];return g[0]?N=[new A.$Ls(D+1,h-(D+1)+1,b+1,s-(b+1)+1)]:N=this.w(D+1,h,b+1,s,g),this.H(f,N)}return[new A.$Ls(l,h-l+1,e,s-e+1)]}x(l,h,e,s,g,$,o,a,D,b,f,N,O,T,p,S,M,U){let _=null,P=null,I=new w,B=h,X=e,Y=O[0]-S[0]-s,ue=-1073741824,ne=this.k.length-1;do{const te=Y+l;te===B||te<X&&D[te-1]<D[te+1]?(f=D[te+1],T=f-Y-s,f<ue&&I.MarkNextChange(),ue=f,I.AddModifiedElement(f+1,T),Y=te+1-l):(f=D[te-1]+1,T=f-Y-s,f<ue&&I.MarkNextChange(),ue=f-1,I.AddOriginalElement(f,T+1),Y=te-1-l),ne>=0&&(D=this.k[ne],l=D[0],B=1,X=D.length-1)}while(--ne>=-1);if(_=I.getReverseChanges(),U[0]){let te=O[0]+1,we=S[0]+1;if(_!==null&&_.length>0){const Te=_[_.length-1];te=Math.max(te,Te.getOriginalEnd()),we=Math.max(we,Te.getModifiedEnd())}P=[new A.$Ls(te,N-te+1,we,p-we+1)]}else{I=new w,B=$,X=o,Y=O[0]-S[0]-a,ue=1073741824,ne=M?this.m.length-1:this.m.length-2;do{const te=Y+g;te===B||te<X&&b[te-1]>=b[te+1]?(f=b[te+1]-1,T=f-Y-a,f>ue&&I.MarkNextChange(),ue=f+1,I.AddOriginalElement(f+1,T+1),Y=te+1-g):(f=b[te-1],T=f-Y-a,f>ue&&I.MarkNextChange(),ue=f,I.AddModifiedElement(f+1,T+1),Y=te-1-g),ne>=0&&(b=this.m[ne],g=b[0],B=1,X=b.length-1)}while(--ne>=-1);P=I.getChanges()}return this.H(_,P)}y(l,h,e,s,g,$,o){let a=0,D=0,b=0,f=0,N=0,O=0;l--,e--,g[0]=0,$[0]=0,this.k=[],this.m=[];const T=h-l+(s-e),p=T+1,S=new Int32Array(p),M=new Int32Array(p),U=s-e,_=h-l,P=l-e,I=h-s,X=(_-U)%2===0;S[U]=l,M[_]=h,o[0]=!1;for(let Y=1;Y<=T/2+1;Y++){let ue=0,ne=0;b=this.J(U-Y,Y,U,p),f=this.J(U+Y,Y,U,p);for(let we=b;we<=f;we+=2){we===b||we<f&&S[we-1]<S[we+1]?a=S[we+1]:a=S[we-1]+1,D=a-(we-U)-P;const Te=a;for(;a<h&&D<s&&this.p(a+1,D+1);)a++,D++;if(S[we]=a,a+D>ue+ne&&(ue=a,ne=D),!X&&Math.abs(we-_)<=Y-1&&a>=M[we])return g[0]=a,$[0]=D,Te<=M[we]&&1447>0&&Y<=1447+1?this.x(U,b,f,P,_,N,O,I,S,M,a,h,g,D,s,$,X,o):null}const te=(ue-l+(ne-e)-Y)/2;if(this.a!==null&&!this.a(ue,te))return o[0]=!0,g[0]=ue,$[0]=ne,te>0&&1447>0&&Y<=1447+1?this.x(U,b,f,P,_,N,O,I,S,M,a,h,g,D,s,$,X,o):(l++,e++,[new A.$Ls(l,h-l+1,e,s-e+1)]);N=this.J(_-Y,Y,_,p),O=this.J(_+Y,Y,_,p);for(let we=N;we<=O;we+=2){we===N||we<O&&M[we-1]>=M[we+1]?a=M[we+1]-1:a=M[we-1],D=a-(we-_)-I;const Te=a;for(;a>l&&D>e&&this.p(a,D);)a--,D--;if(M[we]=a,X&&Math.abs(we-U)<=Y&&a<=S[we])return g[0]=a,$[0]=D,Te>=S[we]&&1447>0&&Y<=1447+1?this.x(U,b,f,P,_,N,O,I,S,M,a,h,g,D,s,$,X,o):null}if(Y<=1447){let we=new Int32Array(f-b+2);we[0]=U-b+1,k.Copy2(S,b,we,1,f-b+1),this.k.push(we),we=new Int32Array(O-N+2),we[0]=_-N+1,k.Copy2(M,N,we,1,O-N+1),this.m.push(we)}}return this.x(U,b,f,P,_,N,O,I,S,M,a,h,g,D,s,$,X,o)}z(l){for(let h=0;h<l.length;h++){const e=l[h],s=h<l.length-1?l[h+1].originalStart:this.f.length,g=h<l.length-1?l[h+1].modifiedStart:this.h.length,$=e.originalLength>0,o=e.modifiedLength>0;for(;e.originalStart+e.originalLength<s&&e.modifiedStart+e.modifiedLength<g&&(!$||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!o||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const D=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!D)break;e.originalStart++,e.modifiedStart++}const a=[null];if(h<l.length-1&&this.I(l[h],l[h+1],a)){l[h]=a[0],l.splice(h+1,1),h--;continue}}for(let h=l.length-1;h>=0;h--){const e=l[h];let s=0,g=0;if(h>0){const f=l[h-1];s=f.originalStart+f.originalLength,g=f.modifiedStart+f.modifiedLength}const $=e.originalLength>0,o=e.modifiedLength>0;let a=0,D=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let f=1;;f++){const N=e.originalStart-f,O=e.modifiedStart-f;if(N<s||O<g||$&&!this.s(N,N+e.originalLength)||o&&!this.u(O,O+e.modifiedLength))break;const p=(N===s&&O===g?5:0)+this.G(N,e.originalLength,O,e.modifiedLength);p>D&&(D=p,a=f)}e.originalStart-=a,e.modifiedStart-=a;const b=[null];if(h>0&&this.I(l[h-1],l[h],b)){l[h-1]=b[0],l.splice(h,1),h++;continue}}if(this.d)for(let h=1,e=l.length;h<e;h++){const s=l[h-1],g=l[h],$=g.originalStart-s.originalStart-s.originalLength,o=s.originalStart,a=g.originalStart+g.originalLength,D=a-o,b=s.modifiedStart,f=g.modifiedStart+g.modifiedLength,N=f-b;if($<5&&D<20&&N<20){const O=this.A(o,D,b,N,$);if(O){const[T,p]=O;(T!==s.originalStart+s.originalLength||p!==s.modifiedStart+s.modifiedLength)&&(s.originalLength=T-s.originalStart,s.modifiedLength=p-s.modifiedStart,g.originalStart=T+$,g.modifiedStart=p+$,g.originalLength=a-g.originalStart,g.modifiedLength=f-g.modifiedStart)}}}return l}A(l,h,e,s,g){if(h<g||s<g)return null;const $=l+h-g+1,o=e+s-g+1;let a=0,D=0,b=0;for(let f=l;f<$;f++)for(let N=e;N<o;N++){const O=this.B(f,N,g);O>0&&O>a&&(a=O,D=f,b=N)}return a>0?[D,b]:null}B(l,h,e){let s=0;for(let g=0;g<e;g++){if(!this.p(l+g,h+g))return 0;s+=this.e[l+g].length}return s}C(l){return l<=0||l>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[l])}D(l,h){if(this.C(l)||this.C(l-1))return!0;if(h>0){const e=l+h;if(this.C(e-1)||this.C(e))return!0}return!1}E(l){return l<=0||l>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[l])}F(l,h){if(this.E(l)||this.E(l-1))return!0;if(h>0){const e=l+h;if(this.E(e-1)||this.E(e))return!0}return!1}G(l,h,e,s){const g=this.D(l,h)?1:0,$=this.F(e,s)?1:0;return g+$}H(l,h){const e=[];if(l.length===0||h.length===0)return h.length>0?h:l;if(this.I(l[l.length-1],h[0],e)){const s=new Array(l.length+h.length-1);return k.Copy(l,0,s,0,l.length-1),s[l.length-1]=e[0],k.Copy(h,1,s,l.length,h.length-1),s}else{const s=new Array(l.length+h.length);return k.Copy(l,0,s,0,l.length),k.Copy(h,0,s,l.length,h.length),s}}I(l,h,e){if(E.Assert(l.originalStart<=h.originalStart,"Left change is not less than or equal to right change"),E.Assert(l.modifiedStart<=h.modifiedStart,"Left change is not less than or equal to right change"),l.originalStart+l.originalLength>=h.originalStart||l.modifiedStart+l.modifiedLength>=h.modifiedStart){const s=l.originalStart;let g=l.originalLength;const $=l.modifiedStart;let o=l.modifiedLength;return l.originalStart+l.originalLength>=h.originalStart&&(g=h.originalStart+h.originalLength-l.originalStart),l.modifiedStart+l.modifiedLength>=h.modifiedStart&&(o=h.modifiedStart+h.modifiedLength-l.modifiedStart),e[0]=new A.$Ls(s,g,$,o),!0}else return e[0]=null,!1}J(l,h,e,s){if(l>=0&&l<s)return l;const g=e,$=s-e-1,o=h%2===0;if(l<0){const a=g%2===0;return o===a?0:1}else{const a=$%2===0;return o===a?s-1:s-2}}}t.$Os=y}),define(be[50],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pd=void 0,t.$Pd=Symbol("MicrotaskDelay")}),define(be[88],$e([1,0,12,10]),function(ie,t,A,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9h=t.$8h=t.$7h=t.$6h=t.$5h=void 0;class n{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const e=h.charCodeAt(0),s=this.b.charCodeAt(this.c);return e-s}value(){return this.b[this.c]}}t.$5h=n;class j{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,C.$3e)(h,this.b,0,h.length,this.c,this.d):(0,C.$5e)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$6h=j;class E{constructor(h=!0,e=!0){this.f=h,this.g=e}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let e=h.length-1;e>=0;e--,this.c--){const s=this.b.charCodeAt(e);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,C.$3e)(h,this.b,0,h.length,this.d,this.e):(0,C.$5e)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$7h=E;var k;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(k||(k={}));class m{constructor(h,e){this.f=h,this.g=e,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new E(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,C.$4e)(h,this.c.scheme);if(this.d[this.e]===2)return(0,C.$4e)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,C.$2e)(h,this.c.query);if(this.d[this.e]===5)return(0,C.$2e)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$8h=m;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(y||(y={}));class L{static forUris(h=()=>!1,e=()=>!1){return new L(new m(h,e))}static forPaths(h=!1){return new L(new E(void 0,!h))}static forStrings(){return new L(new n)}static forConfigKeys(){return new L(new j)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,e){if(e){const s=e.slice(0);(0,A.$Xb)(s);for(const g of s)this.set(g,h)}else{const s=h.slice(0);(0,A.$Xb)(s);for(const g of s)this.set(g[0],g[1])}}set(h,e){const s=this.b.reset(h);let g;this.c||(this.c=new w,this.c.segment=s.value());const $=[];for(g=this.c;;){const a=s.cmp(g.segment);if(a>0)g.left||(g.left=new w,g.left.segment=s.value()),$.push([-1,g]),g=g.left;else if(a<0)g.right||(g.right=new w,g.right.segment=s.value()),$.push([1,g]),g=g.right;else if(s.hasNext())s.next(),g.mid||(g.mid=new w,g.mid.segment=s.value()),$.push([0,g]),g=g.mid;else break}const o=g.value;g.value=e,g.key=h;for(let a=$.length-1;a>=0;a--){const D=$[a][1];D.updateHeight();const b=D.balanceFactor();if(b<-1||b>1){const f=$[a][0],N=$[a+1][0];if(f===1&&N===1)$[a][1]=D.rotateLeft();else if(f===-1&&N===-1)$[a][1]=D.rotateRight();else if(f===1&&N===-1)D.right=$[a+1][1]=$[a+1][1].rotateRight(),$[a][1]=D.rotateLeft();else if(f===-1&&N===1)D.left=$[a+1][1]=$[a+1][1].rotateLeft(),$[a][1]=D.rotateRight();else throw new Error;if(a>0)switch($[a-1][0]){case-1:$[a-1][1].left=$[a][1];break;case 1:$[a-1][1].right=$[a][1];break;case 0:$[a-1][1].mid=$[a][1];break}else this.c=$[0][1]}}return o}get(h){return this.d(h)?.value}d(h){const e=this.b.reset(h);let s=this.c;for(;s;){const g=e.cmp(s.segment);if(g>0)s=s.left;else if(g<0)s=s.right;else if(e.hasNext())e.next(),s=s.mid;else break}return s}has(h){const e=this.d(h);return!(e?.value===void 0&&e?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,e){const s=this.b.reset(h),g=[];let $=this.c;for(;$;){const o=s.cmp($.segment);if(o>0)g.push([-1,$]),$=$.left;else if(o<0)g.push([1,$]),$=$.right;else if(s.hasNext())s.next(),g.push([0,$]),$=$.mid;else break}if($){if(e?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const o=this.f($.right);if(o.key){const{key:a,value:D,segment:b}=o;this.e(o.key,!1),$.key=a,$.value=D,$.segment=b}}else{const o=$.left??$.right;if(g.length>0){const[a,D]=g[g.length-1];switch(a){case-1:D.left=o;break;case 0:D.mid=o;break;case 1:D.right=o;break}}else this.c=o}for(let o=g.length-1;o>=0;o--){const a=g[o][1];a.updateHeight();const D=a.balanceFactor();if(D>1?(a.right.balanceFactor()>=0||(a.right=a.right.rotateRight()),g[o][1]=a.rotateLeft()):D<-1&&(a.left.balanceFactor()<=0||(a.left=a.left.rotateLeft()),g[o][1]=a.rotateRight()),o>0)switch(g[o-1][0]){case-1:g[o-1][1].left=g[o][1];break;case 1:g[o-1][1].right=g[o][1];break;case 0:g[o-1][1].mid=g[o][1];break}else this.c=g[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const e=this.b.reset(h);let s=this.c,g;for(;s;){const $=e.cmp(s.segment);if($>0)s=s.left;else if($<0)s=s.right;else if(e.hasNext())e.next(),g=s.value||g,s=s.mid;else break}return s&&s.value||g}findSuperstr(h){return this.g(h,!1)}g(h,e){const s=this.b.reset(h);let g=this.c;for(;g;){const $=s.cmp(g.segment);if($>0)g=g.left;else if($<0)g=g.right;else if(s.hasNext())s.next(),g=g.mid;else return g.mid?this.h(g.mid):e?g.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[e,s]of this)h(s,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const e=[];return this.j(h,e),e[Symbol.iterator]()}j(h,e){h&&(h.left&&this.j(h.left,e),h.value&&e.push([h.key,h.value]),h.mid&&this.j(h.mid,e),h.right&&this.j(h.right,e))}_isBalanced(){const h=e=>{if(!e)return!0;const s=e.balanceFactor();return s<-1||s>1?!1:h(e.left)&&h(e.right)};return h(this.c)}}t.$9h=L}),define(be[7],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wf=t.$Vf=t.$Uf=t.$Tf=t.$Sf=t.$Rf=t.$Qf=t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=void 0;function A(b){return typeof b=="string"}t.$Ff=A;function C(b){return Array.isArray(b)&&b.every(f=>A(f))}t.$Gf=C;function n(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}t.$Hf=n;function j(b){const f=Object.getPrototypeOf(Uint8Array);return typeof b=="object"&&b instanceof f}t.$If=j;function E(b){return typeof b=="number"&&!isNaN(b)}t.$Jf=E;function k(b){return!!b&&typeof b[Symbol.iterator]=="function"}t.$Kf=k;function m(b){return b===!0||b===!1}t.$Lf=m;function w(b){return typeof b>"u"}t.$Mf=w;function y(b){return!L(b)}t.$Nf=y;function L(b){return w(b)||b===null}t.$Of=L;function l(b,f){if(!b)throw new Error(f?`Unexpected type, expected '${f}'`:"Unexpected type")}t.$Pf=l;function h(b){if(L(b))throw new Error("Assertion Failed: argument is undefined or null");return b}t.$Qf=h;function e(...b){const f=[];for(let N=0;N<b.length;N++){const O=b[N];if(L(O))throw new Error(`Assertion Failed: argument at index ${N} is undefined or null`);f.push(O)}return f}t.$Rf=e;const s=Object.prototype.hasOwnProperty;function g(b){if(!n(b))return!1;for(const f in b)if(s.call(b,f))return!1;return!0}t.$Sf=g;function $(b){return typeof b=="function"}t.$Tf=$;function o(...b){return b.length>0&&b.every($)}t.$Uf=o;function a(b,f){const N=Math.min(b.length,f.length);for(let O=0;O<N;O++)D(b[O],f[O])}t.$Vf=a;function D(b,f){if(A(f)){if(typeof b!==f)throw new Error(`argument does not match constraint: typeof ${f}`)}else if($(f)){try{if(b instanceof f)return}catch{}if(!L(b)&&b.constructor===f||f.length===1&&f.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Wf=D}),define(be[17],$e([1,0,7]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9j=t.$8j=t.$7j=void 0;const C=Object.create(null);function n(k,m){if((0,A.$Ff)(m)){const w=C[m];if(w===void 0)throw new Error(`${k} references an unknown codicon: ${m}`);m=w}return C[k]=m,{id:k}}function j(){return C}t.$7j=j;function E(){return Object.values(t.$9j)}t.$8j=E,t.$9j={add:n("add",6e4),plus:n("plus",6e4),gistNew:n("gist-new",6e4),repoCreate:n("repo-create",6e4),lightbulb:n("lightbulb",60001),lightBulb:n("light-bulb",60001),repo:n("repo",60002),repoDelete:n("repo-delete",60002),gistFork:n("gist-fork",60003),repoForked:n("repo-forked",60003),gitPullRequest:n("git-pull-request",60004),gitPullRequestAbandoned:n("git-pull-request-abandoned",60004),recordKeys:n("record-keys",60005),keyboard:n("keyboard",60005),tag:n("tag",60006),tagAdd:n("tag-add",60006),tagRemove:n("tag-remove",60006),gitPullRequestLabel:n("git-pull-request-label",60006),person:n("person",60007),personFollow:n("person-follow",60007),personOutline:n("person-outline",60007),personFilled:n("person-filled",60007),gitBranch:n("git-branch",60008),gitBranchCreate:n("git-branch-create",60008),gitBranchDelete:n("git-branch-delete",60008),sourceControl:n("source-control",60008),mirror:n("mirror",60009),mirrorPublic:n("mirror-public",60009),star:n("star",60010),starAdd:n("star-add",60010),starDelete:n("star-delete",60010),starEmpty:n("star-empty",60010),comment:n("comment",60011),commentAdd:n("comment-add",60011),alert:n("alert",60012),warning:n("warning",60012),search:n("search",60013),searchSave:n("search-save",60013),logOut:n("log-out",60014),signOut:n("sign-out",60014),logIn:n("log-in",60015),signIn:n("sign-in",60015),eye:n("eye",60016),eyeUnwatch:n("eye-unwatch",60016),eyeWatch:n("eye-watch",60016),circleFilled:n("circle-filled",60017),primitiveDot:n("primitive-dot",60017),closeDirty:n("close-dirty",60017),debugBreakpoint:n("debug-breakpoint",60017),debugBreakpointDisabled:n("debug-breakpoint-disabled",60017),debugHint:n("debug-hint",60017),primitiveSquare:n("primitive-square",60018),edit:n("edit",60019),pencil:n("pencil",60019),info:n("info",60020),issueOpened:n("issue-opened",60020),gistPrivate:n("gist-private",60021),gitForkPrivate:n("git-fork-private",60021),lock:n("lock",60021),mirrorPrivate:n("mirror-private",60021),close:n("close",60022),removeClose:n("remove-close",60022),x:n("x",60022),repoSync:n("repo-sync",60023),sync:n("sync",60023),clone:n("clone",60024),desktopDownload:n("desktop-download",60024),beaker:n("beaker",60025),microscope:n("microscope",60025),vm:n("vm",60026),deviceDesktop:n("device-desktop",60026),file:n("file",60027),fileText:n("file-text",60027),more:n("more",60028),ellipsis:n("ellipsis",60028),kebabHorizontal:n("kebab-horizontal",60028),mailReply:n("mail-reply",60029),reply:n("reply",60029),organization:n("organization",60030),organizationFilled:n("organization-filled",60030),organizationOutline:n("organization-outline",60030),newFile:n("new-file",60031),fileAdd:n("file-add",60031),newFolder:n("new-folder",60032),fileDirectoryCreate:n("file-directory-create",60032),trash:n("trash",60033),trashcan:n("trashcan",60033),history:n("history",60034),clock:n("clock",60034),folder:n("folder",60035),fileDirectory:n("file-directory",60035),symbolFolder:n("symbol-folder",60035),logoGithub:n("logo-github",60036),markGithub:n("mark-github",60036),github:n("github",60036),terminal:n("terminal",60037),console:n("console",60037),repl:n("repl",60037),zap:n("zap",60038),symbolEvent:n("symbol-event",60038),error:n("error",60039),stop:n("stop",60039),variable:n("variable",60040),symbolVariable:n("symbol-variable",60040),array:n("array",60042),symbolArray:n("symbol-array",60042),symbolModule:n("symbol-module",60043),symbolPackage:n("symbol-package",60043),symbolNamespace:n("symbol-namespace",60043),symbolObject:n("symbol-object",60043),symbolMethod:n("symbol-method",60044),symbolFunction:n("symbol-function",60044),symbolConstructor:n("symbol-constructor",60044),symbolBoolean:n("symbol-boolean",60047),symbolNull:n("symbol-null",60047),symbolNumeric:n("symbol-numeric",60048),symbolNumber:n("symbol-number",60048),symbolStructure:n("symbol-structure",60049),symbolStruct:n("symbol-struct",60049),symbolParameter:n("symbol-parameter",60050),symbolTypeParameter:n("symbol-type-parameter",60050),symbolKey:n("symbol-key",60051),symbolText:n("symbol-text",60051),symbolReference:n("symbol-reference",60052),goToFile:n("go-to-file",60052),symbolEnum:n("symbol-enum",60053),symbolValue:n("symbol-value",60053),symbolRuler:n("symbol-ruler",60054),symbolUnit:n("symbol-unit",60054),activateBreakpoints:n("activate-breakpoints",60055),archive:n("archive",60056),arrowBoth:n("arrow-both",60057),arrowDown:n("arrow-down",60058),arrowLeft:n("arrow-left",60059),arrowRight:n("arrow-right",60060),arrowSmallDown:n("arrow-small-down",60061),arrowSmallLeft:n("arrow-small-left",60062),arrowSmallRight:n("arrow-small-right",60063),arrowSmallUp:n("arrow-small-up",60064),arrowUp:n("arrow-up",60065),bell:n("bell",60066),bold:n("bold",60067),book:n("book",60068),bookmark:n("bookmark",60069),debugBreakpointConditionalUnverified:n("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:n("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:n("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:n("debug-breakpoint-data-unverified",60072),debugBreakpointData:n("debug-breakpoint-data",60073),debugBreakpointDataDisabled:n("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:n("debug-breakpoint-log-unverified",60074),debugBreakpointLog:n("debug-breakpoint-log",60075),debugBreakpointLogDisabled:n("debug-breakpoint-log-disabled",60075),briefcase:n("briefcase",60076),broadcast:n("broadcast",60077),browser:n("browser",60078),bug:n("bug",60079),calendar:n("calendar",60080),caseSensitive:n("case-sensitive",60081),check:n("check",60082),checklist:n("checklist",60083),chevronDown:n("chevron-down",60084),dropDownButton:n("drop-down-button",60084),chevronLeft:n("chevron-left",60085),chevronRight:n("chevron-right",60086),chevronUp:n("chevron-up",60087),chromeClose:n("chrome-close",60088),chromeMaximize:n("chrome-maximize",60089),chromeMinimize:n("chrome-minimize",60090),chromeRestore:n("chrome-restore",60091),circle:n("circle",60092),circleOutline:n("circle-outline",60092),debugBreakpointUnverified:n("debug-breakpoint-unverified",60092),circleSlash:n("circle-slash",60093),circuitBoard:n("circuit-board",60094),clearAll:n("clear-all",60095),clippy:n("clippy",60096),closeAll:n("close-all",60097),cloudDownload:n("cloud-download",60098),cloudUpload:n("cloud-upload",60099),code:n("code",60100),collapseAll:n("collapse-all",60101),colorMode:n("color-mode",60102),commentDiscussion:n("comment-discussion",60103),compareChanges:n("compare-changes",60157),creditCard:n("credit-card",60105),dash:n("dash",60108),dashboard:n("dashboard",60109),database:n("database",60110),debugContinue:n("debug-continue",60111),debugDisconnect:n("debug-disconnect",60112),debugPause:n("debug-pause",60113),debugRestart:n("debug-restart",60114),debugStart:n("debug-start",60115),debugStepInto:n("debug-step-into",60116),debugStepOut:n("debug-step-out",60117),debugStepOver:n("debug-step-over",60118),debugStop:n("debug-stop",60119),debug:n("debug",60120),deviceCameraVideo:n("device-camera-video",60121),deviceCamera:n("device-camera",60122),deviceMobile:n("device-mobile",60123),diffAdded:n("diff-added",60124),diffIgnored:n("diff-ignored",60125),diffModified:n("diff-modified",60126),diffRemoved:n("diff-removed",60127),diffRenamed:n("diff-renamed",60128),diff:n("diff",60129),discard:n("discard",60130),editorLayout:n("editor-layout",60131),emptyWindow:n("empty-window",60132),exclude:n("exclude",60133),extensions:n("extensions",60134),eyeClosed:n("eye-closed",60135),fileBinary:n("file-binary",60136),fileCode:n("file-code",60137),fileMedia:n("file-media",60138),filePdf:n("file-pdf",60139),fileSubmodule:n("file-submodule",60140),fileSymlinkDirectory:n("file-symlink-directory",60141),fileSymlinkFile:n("file-symlink-file",60142),fileZip:n("file-zip",60143),files:n("files",60144),filter:n("filter",60145),flame:n("flame",60146),foldDown:n("fold-down",60147),foldUp:n("fold-up",60148),fold:n("fold",60149),folderActive:n("folder-active",60150),folderOpened:n("folder-opened",60151),gear:n("gear",60152),gift:n("gift",60153),gistSecret:n("gist-secret",60154),gist:n("gist",60155),gitCommit:n("git-commit",60156),gitCompare:n("git-compare",60157),gitMerge:n("git-merge",60158),githubAction:n("github-action",60159),githubAlt:n("github-alt",60160),globe:n("globe",60161),grabber:n("grabber",60162),graph:n("graph",60163),gripper:n("gripper",60164),heart:n("heart",60165),home:n("home",60166),horizontalRule:n("horizontal-rule",60167),hubot:n("hubot",60168),inbox:n("inbox",60169),issueClosed:n("issue-closed",60324),issueReopened:n("issue-reopened",60171),issues:n("issues",60172),italic:n("italic",60173),jersey:n("jersey",60174),json:n("json",60175),bracket:n("bracket",60175),kebabVertical:n("kebab-vertical",60176),key:n("key",60177),law:n("law",60178),lightbulbAutofix:n("lightbulb-autofix",60179),linkExternal:n("link-external",60180),link:n("link",60181),listOrdered:n("list-ordered",60182),listUnordered:n("list-unordered",60183),liveShare:n("live-share",60184),loading:n("loading",60185),location:n("location",60186),mailRead:n("mail-read",60187),mail:n("mail",60188),markdown:n("markdown",60189),megaphone:n("megaphone",60190),mention:n("mention",60191),milestone:n("milestone",60192),gitPullRequestMilestone:n("git-pull-request-milestone",60192),mortarBoard:n("mortar-board",60193),move:n("move",60194),multipleWindows:n("multiple-windows",60195),mute:n("mute",60196),noNewline:n("no-newline",60197),note:n("note",60198),octoface:n("octoface",60199),openPreview:n("open-preview",60200),package:n("package",60201),paintcan:n("paintcan",60202),pin:n("pin",60203),play:n("play",60204),run:n("run",60204),plug:n("plug",60205),preserveCase:n("preserve-case",60206),preview:n("preview",60207),project:n("project",60208),pulse:n("pulse",60209),question:n("question",60210),quote:n("quote",60211),radioTower:n("radio-tower",60212),reactions:n("reactions",60213),references:n("references",60214),refresh:n("refresh",60215),regex:n("regex",60216),remoteExplorer:n("remote-explorer",60217),remote:n("remote",60218),remove:n("remove",60219),replaceAll:n("replace-all",60220),replace:n("replace",60221),repoClone:n("repo-clone",60222),repoForcePush:n("repo-force-push",60223),repoPull:n("repo-pull",60224),repoPush:n("repo-push",60225),report:n("report",60226),requestChanges:n("request-changes",60227),rocket:n("rocket",60228),rootFolderOpened:n("root-folder-opened",60229),rootFolder:n("root-folder",60230),rss:n("rss",60231),ruby:n("ruby",60232),saveAll:n("save-all",60233),saveAs:n("save-as",60234),save:n("save",60235),screenFull:n("screen-full",60236),screenNormal:n("screen-normal",60237),searchStop:n("search-stop",60238),server:n("server",60240),settingsGear:n("settings-gear",60241),settings:n("settings",60242),shield:n("shield",60243),smiley:n("smiley",60244),sortPrecedence:n("sort-precedence",60245),splitHorizontal:n("split-horizontal",60246),splitVertical:n("split-vertical",60247),squirrel:n("squirrel",60248),starFull:n("star-full",60249),starHalf:n("star-half",60250),symbolClass:n("symbol-class",60251),symbolColor:n("symbol-color",60252),symbolCustomColor:n("symbol-customcolor",60252),symbolConstant:n("symbol-constant",60253),symbolEnumMember:n("symbol-enum-member",60254),symbolField:n("symbol-field",60255),symbolFile:n("symbol-file",60256),symbolInterface:n("symbol-interface",60257),symbolKeyword:n("symbol-keyword",60258),symbolMisc:n("symbol-misc",60259),symbolOperator:n("symbol-operator",60260),symbolProperty:n("symbol-property",60261),wrench:n("wrench",60261),wrenchSubaction:n("wrench-subaction",60261),symbolSnippet:n("symbol-snippet",60262),tasklist:n("tasklist",60263),telescope:n("telescope",60264),textSize:n("text-size",60265),threeBars:n("three-bars",60266),thumbsdown:n("thumbsdown",60267),thumbsup:n("thumbsup",60268),tools:n("tools",60269),triangleDown:n("triangle-down",60270),triangleLeft:n("triangle-left",60271),triangleRight:n("triangle-right",60272),triangleUp:n("triangle-up",60273),twitter:n("twitter",60274),unfold:n("unfold",60275),unlock:n("unlock",60276),unmute:n("unmute",60277),unverified:n("unverified",60278),verified:n("verified",60279),versions:n("versions",60280),vmActive:n("vm-active",60281),vmOutline:n("vm-outline",60282),vmRunning:n("vm-running",60283),watch:n("watch",60284),whitespace:n("whitespace",60285),wholeWord:n("whole-word",60286),window:n("window",60287),wordWrap:n("word-wrap",60288),zoomIn:n("zoom-in",60289),zoomOut:n("zoom-out",60290),listFilter:n("list-filter",60291),listFlat:n("list-flat",60292),listSelection:n("list-selection",60293),selection:n("selection",60293),listTree:n("list-tree",60294),debugBreakpointFunctionUnverified:n("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:n("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:n("debug-breakpoint-function-disabled",60296),debugStackframeActive:n("debug-stackframe-active",60297),circleSmallFilled:n("circle-small-filled",60298),debugStackframeDot:n("debug-stackframe-dot",60298),debugStackframe:n("debug-stackframe",60299),debugStackframeFocused:n("debug-stackframe-focused",60299),debugBreakpointUnsupported:n("debug-breakpoint-unsupported",60300),symbolString:n("symbol-string",60301),debugReverseContinue:n("debug-reverse-continue",60302),debugStepBack:n("debug-step-back",60303),debugRestartFrame:n("debug-restart-frame",60304),callIncoming:n("call-incoming",60306),callOutgoing:n("call-outgoing",60307),menu:n("menu",60308),expandAll:n("expand-all",60309),feedback:n("feedback",60310),gitPullRequestReviewer:n("git-pull-request-reviewer",60310),groupByRefType:n("group-by-ref-type",60311),ungroupByRefType:n("ungroup-by-ref-type",60312),account:n("account",60313),gitPullRequestAssignee:n("git-pull-request-assignee",60313),bellDot:n("bell-dot",60314),debugConsole:n("debug-console",60315),library:n("library",60316),output:n("output",60317),runAll:n("run-all",60318),syncIgnored:n("sync-ignored",60319),pinned:n("pinned",60320),githubInverted:n("github-inverted",60321),debugAlt:n("debug-alt",60305),serverProcess:n("server-process",60322),serverEnvironment:n("server-environment",60323),pass:n("pass",60324),stopCircle:n("stop-circle",60325),playCircle:n("play-circle",60326),record:n("record",60327),debugAltSmall:n("debug-alt-small",60328),vmConnect:n("vm-connect",60329),cloud:n("cloud",60330),merge:n("merge",60331),exportIcon:n("export",60332),graphLeft:n("graph-left",60333),magnet:n("magnet",60334),notebook:n("notebook",60335),redo:n("redo",60336),checkAll:n("check-all",60337),pinnedDirty:n("pinned-dirty",60338),passFilled:n("pass-filled",60339),circleLargeFilled:n("circle-large-filled",60340),circleLarge:n("circle-large",60341),circleLargeOutline:n("circle-large-outline",60341),combine:n("combine",60342),gather:n("gather",60342),table:n("table",60343),variableGroup:n("variable-group",60344),typeHierarchy:n("type-hierarchy",60345),typeHierarchySub:n("type-hierarchy-sub",60346),typeHierarchySuper:n("type-hierarchy-super",60347),gitPullRequestCreate:n("git-pull-request-create",60348),runAbove:n("run-above",60349),runBelow:n("run-below",60350),notebookTemplate:n("notebook-template",60351),debugRerun:n("debug-rerun",60352),workspaceTrusted:n("workspace-trusted",60353),workspaceUntrusted:n("workspace-untrusted",60354),workspaceUnspecified:n("workspace-unspecified",60355),terminalCmd:n("terminal-cmd",60356),terminalDebian:n("terminal-debian",60357),terminalLinux:n("terminal-linux",60358),terminalPowershell:n("terminal-powershell",60359),terminalTmux:n("terminal-tmux",60360),terminalUbuntu:n("terminal-ubuntu",60361),terminalBash:n("terminal-bash",60362),arrowSwap:n("arrow-swap",60363),copy:n("copy",60364),personAdd:n("person-add",60365),filterFilled:n("filter-filled",60366),wand:n("wand",60367),debugLineByLine:n("debug-line-by-line",60368),inspect:n("inspect",60369),layers:n("layers",60370),layersDot:n("layers-dot",60371),layersActive:n("layers-active",60372),compass:n("compass",60373),compassDot:n("compass-dot",60374),compassActive:n("compass-active",60375),azure:n("azure",60376),issueDraft:n("issue-draft",60377),gitPullRequestClosed:n("git-pull-request-closed",60378),gitPullRequestDraft:n("git-pull-request-draft",60379),debugAll:n("debug-all",60380),debugCoverage:n("debug-coverage",60381),runErrors:n("run-errors",60382),folderLibrary:n("folder-library",60383),debugContinueSmall:n("debug-continue-small",60384),beakerStop:n("beaker-stop",60385),graphLine:n("graph-line",60386),graphScatter:n("graph-scatter",60387),pieChart:n("pie-chart",60388),bracketDot:n("bracket-dot",60389),bracketError:n("bracket-error",60390),lockSmall:n("lock-small",60391),azureDevops:n("azure-devops",60392),verifiedFilled:n("verified-filled",60393),newLine:n("newline",60394),layout:n("layout",60395),layoutActivitybarLeft:n("layout-activitybar-left",60396),layoutActivitybarRight:n("layout-activitybar-right",60397),layoutPanelLeft:n("layout-panel-left",60398),layoutPanelCenter:n("layout-panel-center",60399),layoutPanelJustify:n("layout-panel-justify",60400),layoutPanelRight:n("layout-panel-right",60401),layoutPanel:n("layout-panel",60402),layoutSidebarLeft:n("layout-sidebar-left",60403),layoutSidebarRight:n("layout-sidebar-right",60404),layoutStatusbar:n("layout-statusbar",60405),layoutMenubar:n("layout-menubar",60406),layoutCentered:n("layout-centered",60407),layoutSidebarRightOff:n("layout-sidebar-right-off",60416),layoutPanelOff:n("layout-panel-off",60417),layoutSidebarLeftOff:n("layout-sidebar-left-off",60418),target:n("target",60408),indent:n("indent",60409),recordSmall:n("record-small",60410),errorSmall:n("error-small",60411),arrowCircleDown:n("arrow-circle-down",60412),arrowCircleLeft:n("arrow-circle-left",60413),arrowCircleRight:n("arrow-circle-right",60414),arrowCircleUp:n("arrow-circle-up",60415),heartFilled:n("heart-filled",60420),map:n("map",60421),mapFilled:n("map-filled",60422),circleSmall:n("circle-small",60423),bellSlash:n("bell-slash",60424),bellSlashDot:n("bell-slash-dot",60425),commentUnresolved:n("comment-unresolved",60426),gitPullRequestGoToChanges:n("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:n("git-pull-request-new-changes",60428),searchFuzzy:n("search-fuzzy",60429),commentDraft:n("comment-draft",60430),send:n("send",60431),sparkle:n("sparkle",60432),insert:n("insert",60433),mic:n("mic",60434),thumbsDownFilled:n("thumbsdown-filled",60435),thumbsUpFilled:n("thumbsup-filled",60436),coffee:n("coffee",60437),snake:n("snake",60438),game:n("game",60439),vr:n("vr",60440),chip:n("chip",60441),piano:n("piano",60442),music:n("music",60443),micFilled:n("mic-filled",60444),gitFetch:n("git-fetch",60445),copilot:n("copilot",60446),lightbulbSparkle:n("lightbulb-sparkle",60447),lightbulbSparkleAutofix:n("lightbulb-sparkle-autofix",60447),robot:n("robot",60448),sparkleFilled:n("sparkle-filled",60449),diffSingle:n("diff-single",60450),diffMultiple:n("diff-multiple",60451),surroundWith:n("surround-with",60452),dialogError:n("dialog-error","error"),dialogWarning:n("dialog-warning","warning"),dialogInfo:n("dialog-info","info"),dialogClose:n("dialog-close","close"),treeItemExpanded:n("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:n("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:n("tree-filter-on-type-off","list-selection"),treeFilterClear:n("tree-filter-clear","close"),treeItemLoading:n("tree-item-loading","loading"),menuSelection:n("menu-selection","check"),menuSubmenu:n("menu-submenu","chevron-right"),menuBarMore:n("menubar-more","more"),scrollbarButtonLeft:n("scrollbar-button-left","triangle-left"),scrollbarButtonRight:n("scrollbar-button-right","triangle-right"),scrollbarButtonUp:n("scrollbar-button-up","triangle-up"),scrollbarButtonDown:n("scrollbar-button-down","triangle-down"),toolBarMore:n("toolbar-more","more"),quickInputBack:n("quick-input-back","arrow-left")}}),define(be[51],$e([1,0,7]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$un=t.$tn=t.$sn=t.$rn=t.$qn=t.$pn=t.$on=t.$nn=t.$mn=t.$ln=t.$kn=t.$jn=void 0;function C($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const o=Array.isArray($)?[]:{};return Object.entries($).forEach(([a,D])=>{o[a]=D&&typeof D=="object"?C(D):D}),o}t.$jn=C;function n($){if(!$||typeof $!="object")return $;const o=[$];for(;o.length>0;){const a=o.shift();Object.freeze(a);for(const D in a)if(j.call(a,D)){const b=a[D];typeof b=="object"&&!Object.isFrozen(b)&&!(0,A.$If)(b)&&o.push(b)}}return $}t.$kn=n;const j=Object.prototype.hasOwnProperty;function E($,o){return k($,o,new Set)}t.$ln=E;function k($,o,a){if((0,A.$Of)($))return $;const D=o($);if(typeof D<"u")return D;if(Array.isArray($)){const b=[];for(const f of $)b.push(k(f,o,a));return b}if((0,A.$Hf)($)){if(a.has($))throw new Error("Cannot clone recursive data-structure");a.add($);const b={};for(const f in $)j.call($,f)&&(b[f]=k($[f],o,a));return a.delete($),b}return $}function m($,o,a=!0){return(0,A.$Hf)($)?((0,A.$Hf)(o)&&Object.keys(o).forEach(D=>{D in $?a&&((0,A.$Hf)($[D])&&(0,A.$Hf)(o[D])?m($[D],o[D],a):$[D]=o[D]):$[D]=o[D]}),$):o}t.$mn=m;function w($,o){if($===o)return!0;if($==null||o===null||o===void 0||typeof $!=typeof o||typeof $!="object"||Array.isArray($)!==Array.isArray(o))return!1;let a,D;if(Array.isArray($)){if($.length!==o.length)return!1;for(a=0;a<$.length;a++)if(!w($[a],o[a]))return!1}else{const b=[];for(D in $)b.push(D);b.sort();const f=[];for(D in o)f.push(D);if(f.sort(),!w(b,f))return!1;for(a=0;a<b.length;a++)if(!w($[b[a]],o[b[a]]))return!1}return!0}t.$nn=w;function y($){const o=new Set;return JSON.stringify($,(a,D)=>{if((0,A.$Hf)(D)||Array.isArray(D)){if(o.has(D))return"[Circular]";o.add(D)}return D})}t.$on=y;function L($,o){const a=Object.create(null);return!$||!o||Object.keys(o).forEach(b=>{const f=$[b],N=o[b];w(f,N)||(a[b]=N)}),a}t.$pn=L;function l($,o){const a=o.toLowerCase(),D=Object.keys($).find(b=>b.toLowerCase()===a);return D?$[D]:$[o]}t.$qn=l;function h($,o){const a=Object.create(null);for(const[D,b]of Object.entries($))o(D,b)&&(a[D]=b);return a}t.$rn=h;function e($){let o=[];for(;Object.prototype!==$;)o=o.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return o}t.$sn=e;function s($){const o=[];for(const a of e($))typeof $[a]=="function"&&o.push(a);return o}t.$tn=s;function g($,o){const a=b=>function(){const f=Array.prototype.slice.call(arguments,0);return o(b,f)},D={};for(const b of $)D[b]=a(b);return D}t.$un=g}),define(be[18],$e([1,0,17]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.$0j=t.ThemeColor=void 0;var C;(function(E){function k(m){return m&&typeof m=="object"&&typeof m.id=="string"}E.isThemeColor=k})(C||(t.ThemeColor=C={}));function n(E){return{id:E}}t.$0j=n;var j;(function(E){E.iconNameSegment="[A-Za-z0-9]+",E.iconNameExpression="[A-Za-z0-9-]+",E.iconModifierExpression="~[A-Za-z]+",E.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${E.iconNameExpression})(${E.iconModifierExpression})?$`);function m(o){const a=k.exec(o.id);if(!a)return m(A.$9j.error);const[,D,b]=a,f=["codicon","codicon-"+D];return b&&f.push("codicon-modifier-"+b.substring(1)),f}E.asClassNameArray=m;function w(o){return m(o).join(" ")}E.asClassName=w;function y(o){return"."+m(o).join(".")}E.asCSSSelector=y;function L(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color>"u"||C.isThemeColor(o.color))}E.isThemeIcon=L;const l=new RegExp(`^\\$\\((${E.iconNameExpression}(?:${E.iconModifierExpression})?)\\)$`);function h(o){const a=l.exec(o);if(!a)return;const[,D]=a;return{id:D}}E.fromString=h;function e(o){return{id:o}}E.fromId=e;function s(o,a){let D=o.id;const b=D.lastIndexOf("~");return b!==-1&&(D=D.substring(0,b)),a&&(D=`${D}~${a}`),{id:D}}E.modify=s;function g(o){const a=o.id.lastIndexOf("~");if(a!==-1)return o.id.substring(a+1)}E.getModifier=g;function $(o,a){return o.id===a.id&&o.color?.id===a.color?.id}E.isEqual=$})(j||(t.ThemeIcon=j={}))}),define(be[35],$e([1,0,34,10,18]),function(ie,t,A,C,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dk=t.$ck=t.$bk=t.$ak=t.$_j=t.$$j=void 0;const j="$(",E=new RegExp(`\\$\\(${n.ThemeIcon.iconNameExpression}(?:${n.ThemeIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(`(\\\\)?${E.source}`,"g");function m($){return $.replace(k,(o,a)=>a?o:`\\${o}`)}t.$$j=m;const w=new RegExp(`\\\\${E.source}`,"g");function y($){return $.replace(w,o=>`\\${o}`)}t.$_j=y;const L=new RegExp(`(\\s)?(\\\\)?${E.source}(\\s)?`,"g");function l($){return $.indexOf(j)===-1?$:$.replace(L,(o,a,D,b)=>D?o:a||b||"")}t.$ak=l;function h($){return $?$.replace(/\$\((.*?)\)/g,(o,a)=>` ${a} `).trim():""}t.$bk=h;const e=new RegExp(`\\$\\(${n.ThemeIcon.iconNameCharacter}+\\)`,"g");function s($){e.lastIndex=0;let o="";const a=[];let D=0;for(;;){const b=e.lastIndex,f=e.exec($),N=$.substring(b,f?.index);if(N.length>0){o+=N;for(let O=0;O<N.length;O++)a.push(D)}if(!f)break;D+=f[0].length}return{text:o,iconOffsets:a}}t.$ck=s;function g($,o,a=!1){const{text:D,iconOffsets:b}=o;if(!b||b.length===0)return(0,A.$Xj)($,D,a);const f=(0,C.$Qe)(D," "),N=D.length-f.length,O=(0,A.$Xj)($,f,a);if(O)for(const T of O){const p=b[T.start+N]+N;T.start+=p,T.end+=p}return O}t.$dk=g}),define(be[89],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iU=t.$hU=void 0,t.$hU="vscode:contextmenu",t.$iU="vscode:onCloseContextMenu"}),define(be[90],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pU=void 0;class A{constructor(n,j){this.a=n,this.onMessage=j}send(n){try{this.a.send("vscode:message",n.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$pU=A}),define(be[30],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S=t.$R=t.$Q=t.$P=t.$O=void 0;const A=globalThis.vscode;t.$O=A.ipcRenderer,t.$P=A.ipcMessagePort,t.$Q=A.webFrame,t.$R=A.process,t.$S=A.context}),define(be[91],$e([1,0,89,30]),function(ie,t,A,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lU=void 0;let n=0;function j(k,m,w){const y=[],L=n++,l=`vscode:onContextMenu${L}`,h=(e,s,g)=>{y[s].click?.(g)};C.$O.once(l,h),C.$O.once(A.$iU,(e,s)=>{s===L&&(C.$O.removeListener(l,h),w?.())}),C.$O.send(A.$hU,L,k.map(e=>E(e,y)),l,m)}t.$lU=j;function E(k,m){const w={id:m.length,label:k.label,type:k.type,accelerator:k.accelerator,checked:k.checked,enabled:typeof k.enabled=="boolean"?k.enabled:!0,visible:typeof k.visible=="boolean"?k.visible:!0};return m.push(k),Array.isArray(k.submenu)&&(w.submenu=k.submenu.map(y=>E(y,m))),w}}),define(be[52],$e([8]),{}),define(be[92],$e([8]),{}),define(be[93],$e([8]),{}),define(be[94],$e([8]),{}),define(be[95],$e([1,0,93,94]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(be[96],$e([8]),{}),define(be[97],$e([8]),{}),define(be[98],$e([8]),{}),define(be[99],$e([8]),{}),define(be[100],$e([8]),{}),define(be[101],$e([8]),{}),define(be[102],$e([8]),{}),define(be[103],$e([8]),{}),define(be[104],$e([8]),{}),define(be[105],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(be[106],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/findinput/findInput",t)}),define(be[107],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(be[108],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(be[109],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(be[110],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(be[111],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/tree/abstractTree",t)}),define(be[112],$e([13,11]),function(ie,t){return ie.create("vs/base/common/actions",t)}),define(be[36],$e([1,0,4,2,112]),function(ie,t,A,C,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mi=t.$Li=t.$Ki=t.$Ji=t.$Ii=t.$Hi=void 0;class j extends C.$Sc{constructor(l,h="",e="",s=!0,g){super(),this.h=this.B(new A.$Sd),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=h,this.u=e,this.w=s,this.C=g}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,h){this.C&&await this.C(l)}}t.$Hi=j;class E extends C.$Sc{constructor(){super(...arguments),this.f=this.B(new A.$Sd),this.onWillRun=this.f.event,this.m=this.B(new A.$Sd),this.onDidRun=this.m.event}async run(l,h){if(!l.enabled)return;this.f.fire({action:l});let e;try{await this.u(l,h)}catch(s){e=s}this.m.fire({action:l,error:e})}async u(l,h){await l.run(h)}}t.$Ii=E;class k{constructor(){this.id=k.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let h=[];for(const e of l)e.length&&(h.length?h=[...h,new k,...e]:h=e);return h}static{this.ID="vs.actions.separator"}async run(){}}t.$Ji=k;class m{get actions(){return this.a}constructor(l,h,e,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=h,this.class=s,this.a=e}async run(){}}t.$Ki=m;class w extends j{static{this.ID="vs.actions.empty"}constructor(){super(w.ID,n.localize(0,null),void 0,!1)}}t.$Li=w;function y(L){return{id:L.id,label:L.label,class:L.class,enabled:L.enabled??!0,checked:L.checked??!1,run:async(...l)=>L.run(...l),tooltip:L.label}}t.$Mi=y}),define(be[113],$e([13,11]),function(ie,t){return ie.create("vs/base/common/platform",t)}),define(be[5],$e([1,0,113]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$J=t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=void 0,t.$g="en";let C=!1,n=!1,j=!1,E=!1,k=!1,m=!1,w=!1,y=!1,L=!1,l=!1,h,e=t.$g,s=t.$g,g,$;const o=globalThis;let a;typeof o.vscode<"u"&&typeof o.vscode.process<"u"?a=o.vscode.process:typeof process<"u"&&(a=process);const D=typeof a?.versions?.electron=="string",b=D&&a?.type==="renderer";if(typeof a=="object"){C=a.platform==="win32",n=a.platform==="darwin",j=a.platform==="linux",E=j&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,w=D,L=!!a.env.CI||!!a.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=t.$g,e=t.$g;const P=a.env.VSCODE_NLS_CONFIG;if(P)try{const I=JSON.parse(P),B=I.availableLanguages["*"];h=I.locale,s=I.osLocale,e=B||t.$g,g=I._translationsConfigFile}catch{}k=!0}else typeof navigator=="object"&&!b?($=navigator.userAgent,C=$.indexOf("Windows")>=0,n=$.indexOf("Macintosh")>=0,y=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,j=$.indexOf("Linux")>=0,l=$?.indexOf("Mobi")>=0,m=!0,h=A.getConfiguredDefaultLocale(A.localize(0,null))||t.$g,e=h,s=navigator.language):console.error("Unable to resolve platform.");var f;(function(P){P[P.Web=0]="Web",P[P.Mac=1]="Mac",P[P.Linux=2]="Linux",P[P.Windows=3]="Windows"})(f||(t.Platform=f={}));function N(P){switch(P){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=N;let O=0;n?O=1:C?O=3:j&&(O=2),t.$i=C,t.$j=n,t.$k=j,t.$l=E,t.$m=k,t.$n=w,t.$o=m,t.$p=m&&typeof o.importScripts=="function",t.$q=t.$p?o.origin:void 0,t.$r=y,t.$s=l,t.$t=L,t.$u=O,t.$v=$,t.$w=e;var T;(function(P){function I(){return t.$w}P.value=I;function B(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}P.isDefaultVariant=B;function X(){return t.$w==="en"}P.isDefault=X})(T||(t.Language=T={})),t.$x=h,t.$y=s,t.$z=g,t.$A=typeof o.postMessage=="function"&&!o.importScripts,t.$B=(()=>{if(t.$A){const P=[];o.addEventListener("message",B=>{if(B.data&&B.data.vscodeScheduleAsyncWork)for(let X=0,Y=P.length;X<Y;X++){const ue=P[X];if(ue.id===B.data.vscodeScheduleAsyncWork){P.splice(X,1),ue.callback();return}}});let I=0;return B=>{const X=++I;P.push({id:X,callback:B}),o.postMessage({vscodeScheduleAsyncWork:X},"*")}}return P=>setTimeout(P)})();var p;(function(P){P[P.Windows=1]="Windows",P[P.Macintosh=2]="Macintosh",P[P.Linux=3]="Linux"})(p||(t.OperatingSystem=p={})),t.OS=n||y?2:C?1:3;let S=!0,M=!1;function U(){if(!M){M=!0;const P=new Uint8Array(2);P[0]=1,P[1]=2,S=new Uint16Array(P.buffer)[0]===(2<<8)+1}return S}t.$D=U,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function _(P){return parseFloat(P)>=20}t.$J=_}),define(be[114],$e([1,0,16,21,5]),function(ie,t,A,C,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aP=t.KeyboardSupport=void 0;var j;(function(E){E[E.Always=0]="Always",E[E.FullScreen=1]="FullScreen",E[E.None=2]="None"})(j||(t.KeyboardSupport=j={})),t.$aP={clipboard:{writeText:n.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:n.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>n.$m||A.$$O()?0:navigator.keyboard||A.$7O?1:2)(),touch:"ontouchstart"in C.$QO||navigator.maxTouchPoints>0,pointerEvents:C.$QO.PointerEvent&&("ontouchstart"in C.$QO||navigator.maxTouchPoints>0)}}),define(be[14],$e([1,0,16,44,78,5]),function(ie,t,A,C,n,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iP=t.$hP=t.$gP=void 0;function E(e){if(e.charCode){const g=String.fromCharCode(e.charCode).toUpperCase();return C.KeyCodeUtils.fromString(g)}const s=e.keyCode;if(s===3)return 7;if(A.$4O)switch(s){case 59:return 85;case 60:if(j.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(j.$j)return 57;break}else if(A.$5O){if(j.$j&&s===93)return 57;if(!j.$j&&s===92)return 57}return C.$Pq[s]||0}const k=j.$j?256:2048,m=512,w=1024,y=j.$j?2048:256;function L(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.$gP=L;function l(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${C.KeyCodeUtils.toString(e.keyCode)}')`}t.$hP=l;class h{constructor(s){this._standardKeyboardEventBrand=!0;const g=s;this.browserEvent=g,this.target=g.target,this.ctrlKey=g.ctrlKey,this.shiftKey=g.shiftKey,this.altKey=g.altKey,this.metaKey=g.metaKey,this.altGraphKey=g.getModifierState("AltGraph"),this.keyCode=E(g),this.code=g.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(s){return this.a===s}c(){let s=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode);let g=0;return this.ctrlKey&&(g|=k),this.altKey&&(g|=m),this.shiftKey&&(g|=w),this.metaKey&&(g|=y),g|=s,g}d(){let s=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode),new n.$Xq(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}t.$iP=h}),define(be[19],$e([1,0,16,69,5]),function(ie,t,A,C,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fP=t.$eP=t.$dP=void 0;class j{constructor(w,y){this.timestamp=Date.now(),this.browserEvent=y,this.leftButton=y.button===0,this.middleButton=y.button===1,this.rightButton=y.button===2,this.buttons=y.buttons,this.target=y.target,this.detail=y.detail||1,y.type==="dblclick"&&(this.detail=2),this.ctrlKey=y.ctrlKey,this.shiftKey=y.shiftKey,this.altKey=y.altKey,this.metaKey=y.metaKey,typeof y.pageX=="number"?(this.posx=y.pageX,this.posy=y.pageY):(this.posx=y.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=y.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const L=C.$bP.getPositionOfChildWindowRelativeToAncestorWindow(w,y.view);this.posx-=L.left,this.posy-=L.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$dP=j;class E extends j{constructor(w,y){super(w,y),this.dataTransfer=y.dataTransfer}}t.$eP=E;class k{constructor(w,y=0,L=0){if(this.browserEvent=w||null,this.target=w?w.target||w.targetNode||w.srcElement:null,this.deltaY=L,this.deltaX=y,w){const l=w,h=w;if(typeof l.wheelDeltaY<"u")this.deltaY=l.wheelDeltaY/120;else if(typeof h.VERTICAL_AXIS<"u"&&h.axis===h.VERTICAL_AXIS)this.deltaY=-h.detail/3;else if(w.type==="wheel"){const e=w;e.deltaMode===e.DOM_DELTA_LINE?A.$4O&&!n.$j?this.deltaY=-w.deltaY/3:this.deltaY=-w.deltaY:this.deltaY=-w.deltaY/40}if(typeof l.wheelDeltaX<"u")A.$7O&&n.$i?this.deltaX=-(l.wheelDeltaX/120):this.deltaX=l.wheelDeltaX/120;else if(typeof h.HORIZONTAL_AXIS<"u"&&h.axis===h.HORIZONTAL_AXIS)this.deltaX=-w.detail/3;else if(w.type==="wheel"){const e=w;e.deltaMode===e.DOM_DELTA_LINE?A.$4O&&!n.$j?this.deltaX=-w.deltaX/3:this.deltaX=-w.deltaX:this.deltaX=-w.deltaX/40}this.deltaY===0&&this.deltaX===0&&w.wheelDelta&&(this.deltaY=w.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$fP=k}),define(be[115],$e([1,0,5]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.env=t.cwd=void 0;let C;const n=globalThis.vscode;if(typeof n<"u"&&typeof n.process<"u"){const j=n.process;C={get platform(){return j.platform},get arch(){return j.arch},get env(){return j.env},cwd(){return j.cwd()}}}else typeof process<"u"?C={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:C={get platform(){return A.$i?"win32":A.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=C.cwd,t.env=C.env,t.$dc=C.platform,t.$ec=C.arch}),define(be[24],$e([1,0,115]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=t.sep=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=void 0;const C=65,n=97,j=90,E=122,k=46,m=47,w=92,y=58,L=63;class l extends Error{constructor(N,O,T){let p;typeof O=="string"&&O.indexOf("not ")===0?(p="must not be",O=O.replace(/^not /,"")):p="must be";const S=N.indexOf(".")!==-1?"property":"argument";let M=`The "${N}" ${S} ${p} of type ${O}`;M+=`. Received type ${typeof T}`,super(M),this.code="ERR_INVALID_ARG_TYPE"}}function h(f,N){if(f===null||typeof f!="object")throw new l(N,"Object",f)}function e(f,N){if(typeof f!="string")throw new l(N,"string",f)}const s=A.$dc==="win32";function g(f){return f===m||f===w}function $(f){return f===m}function o(f){return f>=C&&f<=j||f>=n&&f<=E}function a(f,N,O,T){let p="",S=0,M=-1,U=0,_=0;for(let P=0;P<=f.length;++P){if(P<f.length)_=f.charCodeAt(P);else{if(T(_))break;_=m}if(T(_)){if(!(M===P-1||U===1))if(U===2){if(p.length<2||S!==2||p.charCodeAt(p.length-1)!==k||p.charCodeAt(p.length-2)!==k){if(p.length>2){const I=p.lastIndexOf(O);I===-1?(p="",S=0):(p=p.slice(0,I),S=p.length-1-p.lastIndexOf(O)),M=P,U=0;continue}else if(p.length!==0){p="",S=0,M=P,U=0;continue}}N&&(p+=p.length>0?`${O}..`:"..",S=2)}else p.length>0?p+=`${O}${f.slice(M+1,P)}`:p=f.slice(M+1,P),S=P-M-1;M=P,U=0}else _===k&&U!==-1?++U:U=-1}return p}function D(f,N){h(N,"pathObject");const O=N.dir||N.root,T=N.base||`${N.name||""}${N.ext||""}`;return O?O===N.root?`${O}${T}`:`${O}${f}${T}`:T}t.$fc={resolve(...f){let N="",O="",T=!1;for(let p=f.length-1;p>=-1;p--){let S;if(p>=0){if(S=f[p],e(S,"path"),S.length===0)continue}else N.length===0?S=A.cwd():(S=A.env[`=${N}`]||A.cwd(),(S===void 0||S.slice(0,2).toLowerCase()!==N.toLowerCase()&&S.charCodeAt(2)===w)&&(S=`${N}\\`));const M=S.length;let U=0,_="",P=!1;const I=S.charCodeAt(0);if(M===1)g(I)&&(U=1,P=!0);else if(g(I))if(P=!0,g(S.charCodeAt(1))){let B=2,X=B;for(;B<M&&!g(S.charCodeAt(B));)B++;if(B<M&&B!==X){const Y=S.slice(X,B);for(X=B;B<M&&g(S.charCodeAt(B));)B++;if(B<M&&B!==X){for(X=B;B<M&&!g(S.charCodeAt(B));)B++;(B===M||B!==X)&&(_=`\\\\${Y}\\${S.slice(X,B)}`,U=B)}}}else U=1;else o(I)&&S.charCodeAt(1)===y&&(_=S.slice(0,2),U=2,M>2&&g(S.charCodeAt(2))&&(P=!0,U=3));if(_.length>0)if(N.length>0){if(_.toLowerCase()!==N.toLowerCase())continue}else N=_;if(T){if(N.length>0)break}else if(O=`${S.slice(U)}\\${O}`,T=P,P&&N.length>0)break}return O=a(O,!T,"\\",g),T?`${N}\\${O}`:`${N}${O}`||"."},normalize(f){e(f,"path");const N=f.length;if(N===0)return".";let O=0,T,p=!1;const S=f.charCodeAt(0);if(N===1)return $(S)?"\\":f;if(g(S))if(p=!0,g(f.charCodeAt(1))){let U=2,_=U;for(;U<N&&!g(f.charCodeAt(U));)U++;if(U<N&&U!==_){const P=f.slice(_,U);for(_=U;U<N&&g(f.charCodeAt(U));)U++;if(U<N&&U!==_){for(_=U;U<N&&!g(f.charCodeAt(U));)U++;if(U===N)return`\\\\${P}\\${f.slice(_)}\\`;U!==_&&(T=`\\\\${P}\\${f.slice(_,U)}`,O=U)}}}else O=1;else o(S)&&f.charCodeAt(1)===y&&(T=f.slice(0,2),O=2,N>2&&g(f.charCodeAt(2))&&(p=!0,O=3));let M=O<N?a(f.slice(O),!p,"\\",g):"";return M.length===0&&!p&&(M="."),M.length>0&&g(f.charCodeAt(N-1))&&(M+="\\"),T===void 0?p?`\\${M}`:M:p?`${T}\\${M}`:`${T}${M}`},isAbsolute(f){e(f,"path");const N=f.length;if(N===0)return!1;const O=f.charCodeAt(0);return g(O)||N>2&&o(O)&&f.charCodeAt(1)===y&&g(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let N,O;for(let S=0;S<f.length;++S){const M=f[S];e(M,"path"),M.length>0&&(N===void 0?N=O=M:N+=`\\${M}`)}if(N===void 0)return".";let T=!0,p=0;if(typeof O=="string"&&g(O.charCodeAt(0))){++p;const S=O.length;S>1&&g(O.charCodeAt(1))&&(++p,S>2&&(g(O.charCodeAt(2))?++p:T=!1))}if(T){for(;p<N.length&&g(N.charCodeAt(p));)p++;p>=2&&(N=`\\${N.slice(p)}`)}return t.$fc.normalize(N)},relative(f,N){if(e(f,"from"),e(N,"to"),f===N)return"";const O=t.$fc.resolve(f),T=t.$fc.resolve(N);if(O===T||(f=O.toLowerCase(),N=T.toLowerCase(),f===N))return"";let p=0;for(;p<f.length&&f.charCodeAt(p)===w;)p++;let S=f.length;for(;S-1>p&&f.charCodeAt(S-1)===w;)S--;const M=S-p;let U=0;for(;U<N.length&&N.charCodeAt(U)===w;)U++;let _=N.length;for(;_-1>U&&N.charCodeAt(_-1)===w;)_--;const P=_-U,I=M<P?M:P;let B=-1,X=0;for(;X<I;X++){const ue=f.charCodeAt(p+X);if(ue!==N.charCodeAt(U+X))break;ue===w&&(B=X)}if(X!==I){if(B===-1)return T}else{if(P>I){if(N.charCodeAt(U+X)===w)return T.slice(U+X+1);if(X===2)return T.slice(U+X)}M>I&&(f.charCodeAt(p+X)===w?B=X:X===2&&(B=3)),B===-1&&(B=0)}let Y="";for(X=p+B+1;X<=S;++X)(X===S||f.charCodeAt(X)===w)&&(Y+=Y.length===0?"..":"\\..");return U+=B,Y.length>0?`${Y}${T.slice(U,_)}`:(T.charCodeAt(U)===w&&++U,T.slice(U,_))},toNamespacedPath(f){if(typeof f!="string"||f.length===0)return f;const N=t.$fc.resolve(f);if(N.length<=2)return f;if(N.charCodeAt(0)===w){if(N.charCodeAt(1)===w){const O=N.charCodeAt(2);if(O!==L&&O!==k)return`\\\\?\\UNC\\${N.slice(2)}`}}else if(o(N.charCodeAt(0))&&N.charCodeAt(1)===y&&N.charCodeAt(2)===w)return`\\\\?\\${N}`;return f},dirname(f){e(f,"path");const N=f.length;if(N===0)return".";let O=-1,T=0;const p=f.charCodeAt(0);if(N===1)return g(p)?f:".";if(g(p)){if(O=T=1,g(f.charCodeAt(1))){let U=2,_=U;for(;U<N&&!g(f.charCodeAt(U));)U++;if(U<N&&U!==_){for(_=U;U<N&&g(f.charCodeAt(U));)U++;if(U<N&&U!==_){for(_=U;U<N&&!g(f.charCodeAt(U));)U++;if(U===N)return f;U!==_&&(O=T=U+1)}}}}else o(p)&&f.charCodeAt(1)===y&&(O=N>2&&g(f.charCodeAt(2))?3:2,T=O);let S=-1,M=!0;for(let U=N-1;U>=T;--U)if(g(f.charCodeAt(U))){if(!M){S=U;break}}else M=!1;if(S===-1){if(O===-1)return".";S=O}return f.slice(0,S)},basename(f,N){N!==void 0&&e(N,"ext"),e(f,"path");let O=0,T=-1,p=!0,S;if(f.length>=2&&o(f.charCodeAt(0))&&f.charCodeAt(1)===y&&(O=2),N!==void 0&&N.length>0&&N.length<=f.length){if(N===f)return"";let M=N.length-1,U=-1;for(S=f.length-1;S>=O;--S){const _=f.charCodeAt(S);if(g(_)){if(!p){O=S+1;break}}else U===-1&&(p=!1,U=S+1),M>=0&&(_===N.charCodeAt(M)?--M===-1&&(T=S):(M=-1,T=U))}return O===T?T=U:T===-1&&(T=f.length),f.slice(O,T)}for(S=f.length-1;S>=O;--S)if(g(f.charCodeAt(S))){if(!p){O=S+1;break}}else T===-1&&(p=!1,T=S+1);return T===-1?"":f.slice(O,T)},extname(f){e(f,"path");let N=0,O=-1,T=0,p=-1,S=!0,M=0;f.length>=2&&f.charCodeAt(1)===y&&o(f.charCodeAt(0))&&(N=T=2);for(let U=f.length-1;U>=N;--U){const _=f.charCodeAt(U);if(g(_)){if(!S){T=U+1;break}continue}p===-1&&(S=!1,p=U+1),_===k?O===-1?O=U:M!==1&&(M=1):O!==-1&&(M=-1)}return O===-1||p===-1||M===0||M===1&&O===p-1&&O===T+1?"":f.slice(O,p)},format:D.bind(null,"\\"),parse(f){e(f,"path");const N={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return N;const O=f.length;let T=0,p=f.charCodeAt(0);if(O===1)return g(p)?(N.root=N.dir=f,N):(N.base=N.name=f,N);if(g(p)){if(T=1,g(f.charCodeAt(1))){let B=2,X=B;for(;B<O&&!g(f.charCodeAt(B));)B++;if(B<O&&B!==X){for(X=B;B<O&&g(f.charCodeAt(B));)B++;if(B<O&&B!==X){for(X=B;B<O&&!g(f.charCodeAt(B));)B++;B===O?T=B:B!==X&&(T=B+1)}}}}else if(o(p)&&f.charCodeAt(1)===y){if(O<=2)return N.root=N.dir=f,N;if(T=2,g(f.charCodeAt(2))){if(O===3)return N.root=N.dir=f,N;T=3}}T>0&&(N.root=f.slice(0,T));let S=-1,M=T,U=-1,_=!0,P=f.length-1,I=0;for(;P>=T;--P){if(p=f.charCodeAt(P),g(p)){if(!_){M=P+1;break}continue}U===-1&&(_=!1,U=P+1),p===k?S===-1?S=P:I!==1&&(I=1):S!==-1&&(I=-1)}return U!==-1&&(S===-1||I===0||I===1&&S===U-1&&S===M+1?N.base=N.name=f.slice(M,U):(N.name=f.slice(M,S),N.base=f.slice(M,U),N.ext=f.slice(S,U))),M>0&&M!==T?N.dir=f.slice(0,M-1):N.dir=N.root,N},sep:"\\",delimiter:";",win32:null,posix:null};const b=(()=>{if(s){const f=/\\/g;return()=>{const N=A.cwd().replace(f,"/");return N.slice(N.indexOf("/"))}}return()=>A.cwd()})();t.$gc={resolve(...f){let N="",O=!1;for(let T=f.length-1;T>=-1&&!O;T--){const p=T>=0?f[T]:b();e(p,"path"),p.length!==0&&(N=`${p}/${N}`,O=p.charCodeAt(0)===m)}return N=a(N,!O,"/",$),O?`/${N}`:N.length>0?N:"."},normalize(f){if(e(f,"path"),f.length===0)return".";const N=f.charCodeAt(0)===m,O=f.charCodeAt(f.length-1)===m;return f=a(f,!N,"/",$),f.length===0?N?"/":O?"./":".":(O&&(f+="/"),N?`/${f}`:f)},isAbsolute(f){return e(f,"path"),f.length>0&&f.charCodeAt(0)===m},join(...f){if(f.length===0)return".";let N;for(let O=0;O<f.length;++O){const T=f[O];e(T,"path"),T.length>0&&(N===void 0?N=T:N+=`/${T}`)}return N===void 0?".":t.$gc.normalize(N)},relative(f,N){if(e(f,"from"),e(N,"to"),f===N||(f=t.$gc.resolve(f),N=t.$gc.resolve(N),f===N))return"";const O=1,T=f.length,p=T-O,S=1,M=N.length-S,U=p<M?p:M;let _=-1,P=0;for(;P<U;P++){const B=f.charCodeAt(O+P);if(B!==N.charCodeAt(S+P))break;B===m&&(_=P)}if(P===U)if(M>U){if(N.charCodeAt(S+P)===m)return N.slice(S+P+1);if(P===0)return N.slice(S+P)}else p>U&&(f.charCodeAt(O+P)===m?_=P:P===0&&(_=0));let I="";for(P=O+_+1;P<=T;++P)(P===T||f.charCodeAt(P)===m)&&(I+=I.length===0?"..":"/..");return`${I}${N.slice(S+_)}`},toNamespacedPath(f){return f},dirname(f){if(e(f,"path"),f.length===0)return".";const N=f.charCodeAt(0)===m;let O=-1,T=!0;for(let p=f.length-1;p>=1;--p)if(f.charCodeAt(p)===m){if(!T){O=p;break}}else T=!1;return O===-1?N?"/":".":N&&O===1?"//":f.slice(0,O)},basename(f,N){N!==void 0&&e(N,"ext"),e(f,"path");let O=0,T=-1,p=!0,S;if(N!==void 0&&N.length>0&&N.length<=f.length){if(N===f)return"";let M=N.length-1,U=-1;for(S=f.length-1;S>=0;--S){const _=f.charCodeAt(S);if(_===m){if(!p){O=S+1;break}}else U===-1&&(p=!1,U=S+1),M>=0&&(_===N.charCodeAt(M)?--M===-1&&(T=S):(M=-1,T=U))}return O===T?T=U:T===-1&&(T=f.length),f.slice(O,T)}for(S=f.length-1;S>=0;--S)if(f.charCodeAt(S)===m){if(!p){O=S+1;break}}else T===-1&&(p=!1,T=S+1);return T===-1?"":f.slice(O,T)},extname(f){e(f,"path");let N=-1,O=0,T=-1,p=!0,S=0;for(let M=f.length-1;M>=0;--M){const U=f.charCodeAt(M);if(U===m){if(!p){O=M+1;break}continue}T===-1&&(p=!1,T=M+1),U===k?N===-1?N=M:S!==1&&(S=1):N!==-1&&(S=-1)}return N===-1||T===-1||S===0||S===1&&N===T-1&&N===O+1?"":f.slice(N,T)},format:D.bind(null,"/"),parse(f){e(f,"path");const N={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return N;const O=f.charCodeAt(0)===m;let T;O?(N.root="/",T=1):T=0;let p=-1,S=0,M=-1,U=!0,_=f.length-1,P=0;for(;_>=T;--_){const I=f.charCodeAt(_);if(I===m){if(!U){S=_+1;break}continue}M===-1&&(U=!1,M=_+1),I===k?p===-1?p=_:P!==1&&(P=1):p!==-1&&(P=-1)}if(M!==-1){const I=S===0&&O?1:S;p===-1||P===0||P===1&&p===M-1&&p===S+1?N.base=N.name=f.slice(I,M):(N.name=f.slice(I,p),N.base=f.slice(I,M),N.ext=f.slice(p,M))}return S>0?N.dir=f.slice(0,S-1):O&&(N.dir="/"),N},sep:"/",delimiter:":",win32:null,posix:null},t.$gc.win32=t.$fc.win32=t.$fc,t.$gc.posix=t.$fc.posix=t.$gc,t.$hc=s?t.$fc.normalize:t.$gc.normalize,t.$ic=s?t.$fc.isAbsolute:t.$gc.isAbsolute,t.$jc=s?t.$fc.join:t.$gc.join,t.$kc=s?t.$fc.resolve:t.$gc.resolve,t.$lc=s?t.$fc.relative:t.$gc.relative,t.$mc=s?t.$fc.dirname:t.$gc.dirname,t.$nc=s?t.$fc.basename:t.$gc.basename,t.$oc=s?t.$fc.extname:t.$gc.extname,t.$pc=s?t.$fc.format:t.$gc.format,t.$qc=s?t.$fc.parse:t.$gc.parse,t.$rc=s?t.$fc.toNamespacedPath:t.$gc.toNamespacedPath,t.sep=s?t.$fc.sep:t.$gc.sep,t.$tc=s?t.$fc.delimiter:t.$gc.delimiter}),define(be[116],$e([1,0,24,5,10,7]),function(ie,t,A,C,n,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ag=t.$_f=t.$$f=t.$0f=t.$9f=t.$8f=t.$7f=t.$6f=t.$5f=t.$4f=t.$3f=t.$2f=t.$1f=t.$Zf=t.$Yf=t.$Xf=void 0;function E(S){return S===47||S===92}t.$Xf=E;function k(S){return S.replace(/[\\/]/g,A.$gc.sep)}t.$Yf=k;function m(S){return S.indexOf("/")===-1&&(S=k(S)),/^[a-zA-Z]:(\/|$)/.test(S)&&(S="/"+S),S}t.$Zf=m;function w(S,M=A.$gc.sep){if(!S)return"";const U=S.length,_=S.charCodeAt(0);if(E(_)){if(E(S.charCodeAt(1))&&!E(S.charCodeAt(2))){let I=3;const B=I;for(;I<U&&!E(S.charCodeAt(I));I++);if(B!==I&&!E(S.charCodeAt(I+1))){for(I+=1;I<U;I++)if(E(S.charCodeAt(I)))return S.slice(0,I+1).replace(/[\\/]/g,M)}}return M}else if($(_)&&S.charCodeAt(1)===58)return E(S.charCodeAt(2))?S.slice(0,2)+M:S.slice(0,2);let P=S.indexOf("://");if(P!==-1){for(P+=3;P<U;P++)if(E(S.charCodeAt(P)))return S.slice(0,P+1)}return""}t.$1f=w;function y(S){if(!C.$i||!S||S.length<5)return!1;let M=S.charCodeAt(0);if(M!==92||(M=S.charCodeAt(1),M!==92))return!1;let U=2;const _=U;for(;U<S.length&&(M=S.charCodeAt(U),M!==92);U++);return!(_===U||(M=S.charCodeAt(U+1),isNaN(M)||M===92))}t.$2f=y;const L=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(S,M=C.$i){const U=M?L:l;return!(!S||S.length===0||/^\s+$/.test(S)||(U.lastIndex=0,U.test(S))||M&&h.test(S)||S==="."||S===".."||M&&S[S.length-1]==="."||M&&S.length!==S.trim().length||S.length>255)}t.$3f=e;function s(S,M,U){const _=S===M;return!U||_?_:!S||!M?!1:(0,n.$9e)(S,M)}t.$4f=s;function g(S,M,U,_=A.sep){if(S===M)return!0;if(!S||!M||M.length>S.length)return!1;if(U){if(!(0,n.$0e)(S,M))return!1;if(M.length===S.length)return!0;let I=M.length;return M.charAt(M.length-1)===_&&I--,S.charAt(I)===_}return M.charAt(M.length-1)!==_&&(M+=_),S.indexOf(M)===0}t.$5f=g;function $(S){return S>=65&&S<=90||S>=97&&S<=122}t.$6f=$;function o(S,M){return C.$i&&S.endsWith(":")&&(S+=A.sep),(0,A.$ic)(S)||(S=(0,A.$jc)(M,S)),S=(0,A.$hc)(S),C.$i?(S=(0,n.$Re)(S,A.sep),S.endsWith(":")&&(S+=A.sep)):(S=(0,n.$Re)(S,A.sep),S||(S=A.sep)),S}t.$7f=o;function a(S){const M=(0,A.$hc)(S);return C.$i?S.length>3?!1:D(M)&&(S.length===2||M.charCodeAt(2)===92):M===A.$gc.sep}t.$8f=a;function D(S,M=C.$i){return M?$(S.charCodeAt(0))&&S.charCodeAt(1)===58:!1}t.$9f=D;function b(S,M=C.$i){return D(S,M)?S[0]:void 0}t.$0f=b;function f(S,M,U){return M.length>S.length?-1:S===M?0:(U&&(S=S.toLowerCase(),M=M.toLowerCase()),S.indexOf(M))}t.$$f=f;function N(S){const M=S.split(":");let U,_,P;for(const I of M){const B=Number(I);(0,j.$Jf)(B)?_===void 0?_=B:P===void 0&&(P=B):U=U?[U,I].join(":"):I}if(!U)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:U,line:_!==void 0?_:void 0,column:P!==void 0?P:_!==void 0?1:void 0}}t.$_f=N;const O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",T="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function p(S,M,U=8){let _="";for(let I=0;I<U;I++){let B;I===0&&C.$i&&!M&&(U===3||U===4)?B=T:B=O,_+=B.charAt(Math.floor(Math.random()*B.length))}let P;return M?P=`${M}-${_}`:P=_,S?(0,A.$jc)(S,P):P}t.$ag=p}),define(be[117],$e([1,0,24]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9r=t.$8r=t.$7r=t.$6r=t.$5r=void 0,t.$5r=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},n={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function j(y){const L=(0,A.$oc)(y),l=C[L.toLowerCase()];return l!==void 0?l:E(y)}t.$6r=j;function E(y){const L=(0,A.$oc)(y);return n[L.toLowerCase()]}t.$7r=E;function k(y){for(const L in n)if(n[L]===y)return L}t.$8r=k;const m=/^(.+)\/(.+?)(;.+)?$/;function w(y,L){const l=m.exec(y);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:L?void 0:y}t.$9r=w}),define(be[15],$e([1,0,24,5]),function(ie,t,A,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wc=t.$vc=t.URI=void 0;const n=/^\w[\w\d+.-]*$/,j=/^\//,E=/^\/\//;function k(T,p){if(!T.scheme&&p)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${T.authority}", path: "${T.path}", query: "${T.query}", fragment: "${T.fragment}"}`);if(T.scheme&&!n.test(T.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(T.path){if(T.authority){if(!j.test(T.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(T.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(T,p){return!T&&!p?"file":T}function w(T,p){switch(T){case"https":case"http":case"file":p?p[0]!==L&&(p=L+p):p=L;break}return p}const y="",L="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(p){return p instanceof h?!0:p?typeof p.authority=="string"&&typeof p.fragment=="string"&&typeof p.path=="string"&&typeof p.query=="string"&&typeof p.scheme=="string"&&typeof p.fsPath=="string"&&typeof p.with=="function"&&typeof p.toString=="function":!1}constructor(p,S,M,U,_,P=!1){typeof p=="object"?(this.scheme=p.scheme||y,this.authority=p.authority||y,this.path=p.path||y,this.query=p.query||y,this.fragment=p.fragment||y):(this.scheme=m(p,P),this.authority=S||y,this.path=w(this.scheme,M||y),this.query=U||y,this.fragment=_||y,k(this,P))}get fsPath(){return D(this,!1)}with(p){if(!p)return this;let{scheme:S,authority:M,path:U,query:_,fragment:P}=p;return S===void 0?S=this.scheme:S===null&&(S=y),M===void 0?M=this.authority:M===null&&(M=y),U===void 0?U=this.path:U===null&&(U=y),_===void 0?_=this.query:_===null&&(_=y),P===void 0?P=this.fragment:P===null&&(P=y),S===this.scheme&&M===this.authority&&U===this.path&&_===this.query&&P===this.fragment?this:new g(S,M,U,_,P)}static parse(p,S=!1){const M=l.exec(p);return M?new g(M[2]||y,O(M[4]||y),O(M[5]||y),O(M[7]||y),O(M[9]||y),S):new g(y,y,y,y,y)}static file(p){let S=y;if(C.$i&&(p=p.replace(/\\/g,L)),p[0]===L&&p[1]===L){const M=p.indexOf(L,2);M===-1?(S=p.substring(2),p=L):(S=p.substring(2,M),p=p.substring(M)||L)}return new g("file",S,p,y,y)}static from(p,S){return new g(p.scheme,p.authority,p.path,p.query,p.fragment,S)}static joinPath(p,...S){if(!p.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let M;return C.$i&&p.scheme==="file"?M=h.file(A.$fc.join(D(p,!0),...S)).path:M=A.$gc.join(p.path,...S),p.with({path:M})}toString(p=!1){return b(this,p)}toJSON(){return this}static revive(p){if(p){if(p instanceof h)return p;{const S=new g(p);return S._formatted=p.external??null,S._fsPath=p._sep===s?p.fsPath??null:null,S}}else return p}}t.URI=h;function e(T){return!T||typeof T!="object"?!1:typeof T.scheme=="string"&&(typeof T.authority=="string"||typeof T.authority>"u")&&(typeof T.path=="string"||typeof T.path>"u")&&(typeof T.query=="string"||typeof T.query>"u")&&(typeof T.fragment=="string"||typeof T.fragment>"u")}t.$vc=e;const s=C.$i?1:void 0;class g extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=D(this,!1)),this._fsPath}toString(p=!1){return p?b(this,!0):(this._formatted||(this._formatted=b(this,!1)),this._formatted)}toJSON(){const p={$mid:1};return this._fsPath&&(p.fsPath=this._fsPath,p._sep=s),this._formatted&&(p.external=this._formatted),this.path&&(p.path=this.path),this.scheme&&(p.scheme=this.scheme),this.authority&&(p.authority=this.authority),this.query&&(p.query=this.query),this.fragment&&(p.fragment=this.fragment),p}}const $={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function o(T,p,S){let M,U=-1;for(let _=0;_<T.length;_++){const P=T.charCodeAt(_);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||p&&P===47||S&&P===91||S&&P===93||S&&P===58)U!==-1&&(M+=encodeURIComponent(T.substring(U,_)),U=-1),M!==void 0&&(M+=T.charAt(_));else{M===void 0&&(M=T.substr(0,_));const I=$[P];I!==void 0?(U!==-1&&(M+=encodeURIComponent(T.substring(U,_)),U=-1),M+=I):U===-1&&(U=_)}}return U!==-1&&(M+=encodeURIComponent(T.substring(U))),M!==void 0?M:T}function a(T){let p;for(let S=0;S<T.length;S++){const M=T.charCodeAt(S);M===35||M===63?(p===void 0&&(p=T.substr(0,S)),p+=$[M]):p!==void 0&&(p+=T[S])}return p!==void 0?p:T}function D(T,p){let S;return T.authority&&T.path.length>1&&T.scheme==="file"?S=`//${T.authority}${T.path}`:T.path.charCodeAt(0)===47&&(T.path.charCodeAt(1)>=65&&T.path.charCodeAt(1)<=90||T.path.charCodeAt(1)>=97&&T.path.charCodeAt(1)<=122)&&T.path.charCodeAt(2)===58?p?S=T.path.substr(1):S=T.path[1].toLowerCase()+T.path.substr(2):S=T.path,C.$i&&(S=S.replace(/\//g,"\\")),S}t.$wc=D;function b(T,p){const S=p?a:o;let M="",{scheme:U,authority:_,path:P,query:I,fragment:B}=T;if(U&&(M+=U,M+=":"),(_||U==="file")&&(M+=L,M+=L),_){let X=_.indexOf("@");if(X!==-1){const Y=_.substr(0,X);_=_.substr(X+1),X=Y.lastIndexOf(":"),X===-1?M+=S(Y,!1,!1):(M+=S(Y.substr(0,X),!1,!1),M+=":",M+=S(Y.substr(X+1),!1,!0)),M+="@"}_=_.toLowerCase(),X=_.lastIndexOf(":"),X===-1?M+=S(_,!1,!0):(M+=S(_.substr(0,X),!1,!0),M+=_.substr(X))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const X=P.charCodeAt(1);X>=65&&X<=90&&(P=`/${String.fromCharCode(X+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const X=P.charCodeAt(0);X>=65&&X<=90&&(P=`${String.fromCharCode(X+32)}:${P.substr(2)}`)}M+=S(P,!0,!1)}return I&&(M+="?",M+=S(I,!1,!1)),B&&(M+="#",M+=p?B:o(B,!1,!1)),M}function f(T){try{return decodeURIComponent(T)}catch{return T.length>3?T.substr(0,3)+f(T.substr(3)):T}}const N=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function O(T){return T.match(N)?T.replace(N,p=>f(p)):T}}),define(be[53],$e([1,0,33,15]),function(ie,t,A,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zh=t.$yh=t.$xh=void 0;function n(m){return JSON.stringify(m,E)}t.$xh=n;function j(m){let w=JSON.parse(m);return w=k(w),w}t.$yh=j;function E(m,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:w.flags}:w}function k(m,w=0){if(!m||w>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return C.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 17:return new Date(m.source)}if(m instanceof A.$ge||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let y=0;y<m.length;++y)m[y]=k(m[y],w+1);else for(const y in m)Object.hasOwnProperty.call(m,y)&&(m[y]=k(m[y],w+1))}return m}t.$zh=k}),define(be[31],$e([1,0,6,5,10,15]),function(ie,t,A,C,n,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$lg=t.$kg=t.$jg=t.$ig=t.$hg=t.$gg=t.$fg=t.$eg=t.$dg=t.$cg=t.$bg=t.Schemas=void 0;var E;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(E||(t.Schemas=E={}));function k(l,h){return j.URI.isUri(l)?(0,n.$9e)(l.scheme,h):(0,n.$0e)(l,h+":")}t.$bg=k;function m(l,...h){return h.some(e=>k(l,e))}t.$cg=m,t.$dg="vscode-tkn",t.$eg="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${E.vscodeRemoteResource}`}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h){this.f=`${h}/${E.vscodeRemoteResource}`}set(h,e,s){this.a[h]=e,this.b[h]=s}setConnectionToken(h,e){this.c[h]=e}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(a){return A.$1(a),h}const e=h.authority;let s=this.a[e];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const g=this.b[e],$=this.c[e];let o=`path=${encodeURIComponent(h.path)}`;return typeof $=="string"&&(o+=`&${t.$eg}=${encodeURIComponent($)}`),j.URI.from({scheme:C.$o?this.d:E.vscodeRemoteResource,authority:`${s}:${g}`,path:this.f,query:o})}}t.$fg=new w,t.$gg="vs/../../extensions",t.$hg="vs/../../node_modules",t.$ig="vs/../../node_modules.asar",t.$jg="vs/../../node_modules.asar.unpacked",t.$kg="vscode-app";class y{static{this.a=t.$kg}asBrowserUri(h){const e=this.b(h,ie);return this.uriToBrowserUri(e)}uriToBrowserUri(h){return h.scheme===E.vscodeRemote?t.$fg.rewrite(h):h.scheme===E.file&&(C.$m||C.$q===`${E.vscodeFileResource}://${y.a}`)?h.with({scheme:E.vscodeFileResource,authority:h.authority||y.a,query:null,fragment:null}):h}asFileUri(h){const e=this.b(h,ie);return this.uriToFileUri(e)}uriToFileUri(h){return h.scheme===E.vscodeFileResource?h.with({scheme:E.file,authority:h.authority!==y.a?h.authority:null,query:null,fragment:null}):h}b(h,e){return j.URI.isUri(h)?h:j.URI.parse(e.toUrl(h))}}t.$lg=new y;var L;(function(l){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(h.get("3"));const e="vscode-coi";function s($){let o;typeof $=="string"?o=new URL($).searchParams:$ instanceof URL?o=$.searchParams:j.URI.isUri($)&&(o=new URL($.toString(!0)).searchParams);const a=o?.get(e);if(a)return h.get(a)}l.getHeadersFromQuery=s;function g($,o,a){if(!globalThis.crossOriginIsolated)return;const D=o&&a?"3":a?"2":"1";$ instanceof URLSearchParams?$.set(e,D):$[e]=D}l.addSearchParam=g})(L||(t.COI=L={}))}),define(be[37],$e([1,0,116,31,24,5,10,15]),function(ie,t,A,C,n,j,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Og=t.DataUri=t.$Ng=t.$Mg=t.$Lg=t.$Kg=t.$Jg=t.$Ig=t.$Hg=t.$Gg=t.$Fg=t.$Eg=t.$Dg=t.$Cg=t.$Bg=t.$Ag=t.$zg=t.$yg=t.$xg=t.$wg=t.$vg=t.$ug=t.$tg=t.$sg=void 0;function m(h){return(0,k.$wc)(h,!0)}t.$sg=m;class w{constructor(e){this.a=e}compare(e,s,g=!1){return e===s?0:(0,E.$2e)(this.getComparisonKey(e,g),this.getComparisonKey(s,g))}isEqual(e,s,g=!1){return e===s?!0:!e||!s?!1:this.getComparisonKey(e,g)===this.getComparisonKey(s,g)}getComparisonKey(e,s=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,s,g=!1){if(e.scheme===s.scheme){if(e.scheme===C.Schemas.file)return A.$5f(m(e),m(s),this.a(e))&&e.query===s.query&&(g||e.fragment===s.fragment);if((0,t.$Jg)(e.authority,s.authority))return A.$5f(e.path,s.path,this.a(e),"/")&&e.query===s.query&&(g||e.fragment===s.fragment)}return!1}joinPath(e,...s){return k.URI.joinPath(e,...s)}basenameOrAuthority(e){return(0,t.$Bg)(e)||e.authority}basename(e){return n.$gc.basename(e.path)}extname(e){return n.$gc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let s;return e.scheme===C.Schemas.file?s=k.URI.file(n.$mc(m(e))).path:(s=n.$gc.dirname(e.path),e.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),s="/")),e.with({path:s})}normalizePath(e){if(!e.path.length)return e;let s;return e.scheme===C.Schemas.file?s=k.URI.file(n.$hc(m(e))).path:s=n.$gc.normalize(e.path),e.with({path:s})}relativePath(e,s){if(e.scheme!==s.scheme||!(0,t.$Jg)(e.authority,s.authority))return;if(e.scheme===C.Schemas.file){const o=n.$lc(m(e),m(s));return j.$i?A.$Yf(o):o}let g=e.path||"/";const $=s.path||"/";if(this.a(e)){let o=0;for(const a=Math.min(g.length,$.length);o<a&&!(g.charCodeAt(o)!==$.charCodeAt(o)&&g.charAt(o).toLowerCase()!==$.charAt(o).toLowerCase());o++);g=$.substr(0,o)+g.substr(o)}return n.$gc.relative(g,$)}resolvePath(e,s){if(e.scheme===C.Schemas.file){const g=k.URI.file(n.$kc(m(e),s));return e.with({authority:g.authority,path:g.path})}return s=A.$Zf(s),e.with({path:n.$gc.resolve(e.path,s)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,s){return e===s||e!==void 0&&s!==void 0&&(0,E.$9e)(e,s)}hasTrailingPathSeparator(e,s=n.sep){if(e.scheme===C.Schemas.file){const g=m(e);return g.length>A.$1f(g).length&&g[g.length-1]===s}else{const g=e.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,s=n.sep){return(0,t.$Kg)(e,s)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,s=n.sep){let g=!1;if(e.scheme===C.Schemas.file){const $=m(e);g=$!==void 0&&$.length===A.$1f($).length&&$[$.length-1]===s}else{s="/";const $=e.path;g=$.length===1&&$.charCodeAt($.length-1)===47}return!g&&!(0,t.$Kg)(e,s)?e.with({path:e.path+"/"}):e}}t.$tg=w,t.$ug=new w(()=>!1),t.$vg=new w(h=>h.scheme===C.Schemas.file?!j.$k:!0),t.$wg=new w(h=>!0),t.$xg=t.$ug.isEqual.bind(t.$ug),t.$yg=t.$ug.isEqualOrParent.bind(t.$ug),t.$zg=t.$ug.getComparisonKey.bind(t.$ug),t.$Ag=t.$ug.basenameOrAuthority.bind(t.$ug),t.$Bg=t.$ug.basename.bind(t.$ug),t.$Cg=t.$ug.extname.bind(t.$ug),t.$Dg=t.$ug.dirname.bind(t.$ug),t.$Eg=t.$ug.joinPath.bind(t.$ug),t.$Fg=t.$ug.normalizePath.bind(t.$ug),t.$Gg=t.$ug.relativePath.bind(t.$ug),t.$Hg=t.$ug.resolvePath.bind(t.$ug),t.$Ig=t.$ug.isAbsolutePath.bind(t.$ug),t.$Jg=t.$ug.isEqualAuthority.bind(t.$ug),t.$Kg=t.$ug.hasTrailingPathSeparator.bind(t.$ug),t.$Lg=t.$ug.removeTrailingPathSeparator.bind(t.$ug),t.$Mg=t.$ug.addTrailingPathSeparator.bind(t.$ug);function y(h,e){const s=[];for(let g=0;g<h.length;g++){const $=e(h[g]);h.some((o,a)=>a===g?!1:(0,t.$yg)($,e(o)))||s.push(h[g])}return s}t.$Ng=y;var L;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function e(s){const g=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(a=>{const[D,b]=a.split(":");D&&b&&g.set(D,b)});const o=s.path.substring(0,s.path.indexOf(";"));return o&&g.set(h.META_DATA_MIME,o),g}h.parseMetaData=e})(L||(t.DataUri=L={}));function l(h,e,s){if(e){let g=h.path;return g&&g[0]!==n.$gc.sep&&(g=n.$gc.sep+g),h.with({scheme:s,authority:e,path:g})}return h.with({scheme:s})}t.$Og=l}),define(be[9],$e([1,0,29,6,4,2,37,5,50,23]),function(ie,t,A,C,n,j,E,k,m,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$th=t.$sh=t.$rh=t.$qh=t.$ph=t.$oh=t.Promises=t.$nh=t.$mh=t.$lh=t.$kh=t.$jh=t.$ih=t.$hh=t.$gh=t.$fh=t.$eh=t.$dh=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Qg=t.$Pg=void 0;function y(r){return!!r&&typeof r.then=="function"}t.$Pg=y;function L(r){const c=new A.$3d,u=r(c.token),d=new Promise((F,R)=>{const W=c.token.onCancellationRequested(()=>{W.dispose(),c.dispose(),R(new C.$5)});Promise.resolve(u).then(z=>{W.dispose(),c.dispose(),F(z)},z=>{W.dispose(),c.dispose(),R(z)})});return new class{cancel(){c.cancel()}then(F,R){return d.then(F,R)}catch(F){return this.then(void 0,F)}finally(F){return d.finally(F)}}}t.$Qg=L;function l(r,c,u){return new Promise((d,F)=>{const R=c.onCancellationRequested(()=>{R.dispose(),d(u)});r.then(d,F).finally(()=>R.dispose())})}t.$Rg=l;function h(r,c){return new Promise((u,d)=>{const F=c.onCancellationRequested(()=>{F.dispose(),d(new C.$5)});r.then(u,d).finally(()=>F.dispose())})}t.$Sg=h;async function e(r){let c=-1;const u=r.map((d,F)=>d.then(R=>(c=F,R)));try{return await Promise.race(u)}finally{r.forEach((d,F)=>{F!==c&&d.cancel()})}}t.$Tg=e;function s(r,c,u){let d;const F=setTimeout(()=>{d?.(void 0),u?.()},c);return Promise.race([r.finally(()=>clearTimeout(F)),new Promise(R=>d=R)])}t.$Ug=s;function g(r){return new Promise((c,u)=>{const d=r();y(d)?d.then(c,u):c(d)})}t.$Vg=g;class ${constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(c){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=c,!this.b){const u=()=>{if(this.b=null,this.f)return;const d=this.queue(this.d);return this.d=null,d};this.b=new Promise(d=>{this.a.then(u,u).then(d)})}return new Promise((u,d)=>{this.b.then(u,d)})}return this.a=c(),new Promise((u,d)=>{this.a.then(F=>{this.a=null,u(F)},F=>{this.a=null,d(F)})})}dispose(){this.f=!0}}t.$Wg=$;class o{constructor(){this.a=Promise.resolve(null)}queue(c){return this.a=this.a.then(()=>c(),()=>c())}}t.$Xg=o;class a{constructor(){this.a=new Map}queue(c,u){const F=(this.a.get(c)??Promise.resolve()).catch(()=>{}).then(u).finally(()=>{this.a.get(c)===F&&this.a.delete(c)});return this.a.set(c,F),F}}t.$Yg=a;const D=(r,c)=>{let u=!0;const d=setTimeout(()=>{u=!1,c()},r);return{isTriggered:()=>u,dispose:()=>{clearTimeout(d),u=!1}}},b=r=>{let c=!0;return queueMicrotask(()=>{c&&(c=!1,r())}),{isTriggered:()=>c,dispose:()=>{c=!1}}};class f{constructor(c){this.defaultDelay=c,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(c,u=this.defaultDelay){this.g=c,this.h(),this.b||(this.b=new Promise((F,R)=>{this.d=F,this.f=R}).then(()=>{if(this.b=null,this.d=null,this.g){const F=this.g;return this.g=null,F()}}));const d=()=>{this.a=null,this.d?.(null)};return this.a=u===m.$Pd?b(d):D(u,d),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$Zg=f;class N{constructor(c){this.a=new f(c),this.b=new $}trigger(c,u){return this.a.trigger(()=>this.b.queue(c),u)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$1g=N;class O{constructor(){this.a=!1,this.b=new Promise((c,u)=>{this.d=c})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$2g=O;class T extends O{constructor(c){super(),this.f=setTimeout(()=>this.open(),c)}open(){clearTimeout(this.f),super.open()}}t.$3g=T;function p(r,c){return c?new Promise((u,d)=>{const F=setTimeout(()=>{R.dispose(),u()},r),R=c.onCancellationRequested(()=>{clearTimeout(F),R.dispose(),d(new C.$5)})}):L(u=>p(r,u))}t.$4g=p;function S(r,c=0,u){const d=setTimeout(()=>{r(),u&&F.dispose()},c),F=(0,j.$Qc)(()=>{clearTimeout(d),u?.deleteAndLeak(F)});return u?.add(F),F}t.$5g=S;function M(r){const c=[];let u=0;const d=r.length;function F(){return u<d?r[u++]():null}function R(W){W!=null&&c.push(W);const z=F();return z?z.then(R):Promise.resolve(c)}return Promise.resolve(null).then(R)}t.$6g=M;function U(r,c=d=>!!d,u=null){let d=0;const F=r.length,R=()=>{if(d>=F)return Promise.resolve(u);const W=r[d++];return Promise.resolve(W()).then(q=>c(q)?Promise.resolve(q):R())};return R()}t.$7g=U;function _(r,c=d=>!!d,u=null){if(r.length===0)return Promise.resolve(u);let d=r.length;const F=()=>{d=-1;for(const R of r)R.cancel?.()};return new Promise((R,W)=>{for(const z of r)z.then(q=>{--d>=0&&c(q)?(F(),R(q)):d===0&&R(u)}).catch(q=>{--d>=0&&(F(),W(q))})})}t.$8g=_;class P{constructor(c){this.a=0,this.d=c,this.f=[],this.b=0,this.g=new n.$Sd}get onDrained(){return this.g.event}get size(){return this.a}queue(c){return this.a++,new Promise((u,d)=>{this.f.push({factory:c,c:u,e:d}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const c=this.f.shift();this.b++;const u=c.factory();u.then(c.c,c.e),u.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.$9g=P;class I extends P{constructor(){super(1)}}t.$0g=I;class B{constructor(){this.a=new Z,this.b=0}queue(c){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,c())):this.a.run(this.b++,c())}}t.$$g=B;class X{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const c=new H;return this.b.add(c),c.p}g(){for(const[,c]of this.a)if(c.size>0)return!1;return!0}queueFor(c,u=E.$ug){const d=u.getComparisonKey(c);let F=this.a.get(d);if(!F){F=new I;const R=this.f++,W=n.Event.once(F.onDrained)(()=>{F?.dispose(),this.a.delete(d),this.h(),this.d?.deleteAndDispose(R),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new j.$2c),this.d.set(R,W),this.a.set(d,F)}return F}h(){this.g()&&this.j()}j(){for(const c of this.b)c.complete();this.b.clear()}dispose(){for(const[,c]of this.a)c.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$_g=X;class Y{constructor(c,u){this.a=-1,typeof c=="function"&&typeof u=="number"&&this.setIfNotSet(c,u)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(c,u){this.cancel(),this.a=setTimeout(()=>{this.a=-1,c()},u)}setIfNotSet(c,u){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,c()},u))}}t.$ah=Y;class ue{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(c,u,d=globalThis){this.cancel();const F=d.setInterval(()=>{c()},u);this.d=(0,j.$Qc)(()=>{d.clearInterval(F),this.d=void 0})}dispose(){this.cancel()}}t.$bh=ue;class ne{constructor(c,u){this.b=-1,this.a=c,this.d=u,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(c=this.d){this.cancel(),this.b=setTimeout(this.f,c)}get delay(){return this.d}set delay(c){this.d=c}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$ch=ne;class te{constructor(c,u){u%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${u}ms is not a multiple of 1000ms.`),this.a=c,this.b=u,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(c=this.b){c%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${c}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(c/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$dh=te;class we extends ne{constructor(c,u){super(c,u),this.j=[]}work(c){this.j.push(c),this.isScheduled()||this.schedule()}h(){const c=this.j;this.j=[],this.a?.(c)}dispose(){this.j=[],super.dispose()}}t.$eh=we;class Te extends j.$Sc{constructor(c,u){super(),this.g=c,this.h=u,this.a=[],this.b=this.B(new j.$Tc),this.f=!1}get pending(){return this.a.length}work(c){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+c.length>this.g.maxBufferedWork)return!1}else if(this.pending+c.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const u of c)this.a.push(u);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ne(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$fh=Te,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$hh=(r,c)=>{(0,k.$B)(()=>{if(u)return;const d=Date.now()+15;c(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,d-Date.now())}}))});let u=!1;return{dispose(){u||(u=!0)}}}:t.$hh=(r,c,u)=>{const d=r.requestIdleCallback(c,typeof u=="number"?{timeout:u}:void 0);let F=!1;return{dispose(){F||(F=!0,r.cancelIdleCallback(d))}}},t.$gh=r=>(0,t.$hh)(globalThis,r)}();class Pe{constructor(c,u){this.g=!1,this.d=()=>{try{this.j=u()}catch(d){this.l=d}finally{this.g=!0}},this.f=(0,t.$hh)(c,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$ih=Pe;class Oe extends Pe{constructor(c){super(globalThis,c)}}t.$jh=Oe;async function re(r,c,u){let d;for(let F=0;F<u;F++)try{return await r()}catch(R){d=R,await p(c)}throw d}t.$kh=re;class Z{isRunning(c){return typeof c=="number"?this.a?.taskId===c:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(c,u,d){return this.a={taskId:c,cancel:()=>d?.(),promise:u},u.then(()=>this.d(c),()=>this.d(c)),u}d(c){this.a&&c===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const c=this.b;this.b=void 0,c.run().then(c.promiseResolve,c.promiseReject)}}queue(c){if(this.b)this.b.run=c;else{let u,d;const F=new Promise((R,W)=>{u=R,d=W});this.b={run:c,promise:F,promiseResolve:u,promiseReject:d}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$lh=Z;class ae{constructor(c,u=()=>Date.now()){this.d=c,this.f=u,this.a=0,this.b=0}increment(){const c=this.f();return c-this.a>this.d&&(this.a=c,this.b=0),this.b++,this.b}}t.$mh=ae;var K;(function(r){r[r.Resolved=0]="Resolved",r[r.Rejected=1]="Rejected"})(K||(K={}));class H{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((c,u)=>{this.a=c,this.b=u})}complete(c){return new Promise(u=>{this.a(c),this.d={outcome:0,value:c},u()})}error(c){return new Promise(u=>{this.b(c),this.d={outcome:1,value:c},u()})}cancel(){return this.error(new C.$5)}}t.$nh=H;var J;(function(r){async function c(d){let F;const R=await Promise.all(d.map(W=>W.then(z=>z,z=>{F||(F=z)})));if(typeof F<"u")throw F;return R}r.settled=c;function u(d){return new Promise(async(F,R)=>{try{await d(F,R)}catch(W){R(W)}})}r.withAsyncBody=u})(J||(t.Promises=J={}));class me{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(c){this.a=void 0,this.b=void 0,this.d=!1,this.promise=c.then(u=>(this.a=u,this.d=!0,u),u=>{throw this.b=u,this.d=!0,u})}requireValue(){if(!this.d)throw new C.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$oh=me;class ve{constructor(c){this.b=c,this.a=new w.$V(()=>new me(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}t.$ph=ve;var Fe;(function(r){r[r.Initial=0]="Initial",r[r.DoneOK=1]="DoneOK",r[r.DoneError=2]="DoneError"})(Fe||(Fe={}));class Ae{static fromArray(c){return new Ae(u=>{u.emitMany(c)})}static fromPromise(c){return new Ae(async u=>{u.emitMany(await c)})}static fromPromises(c){return new Ae(async u=>{await Promise.all(c.map(async d=>u.emitOne(await d)))})}static merge(c){return new Ae(async u=>{await Promise.all(c.map(async d=>{for await(const F of d)u.emitOne(F)}))})}static{this.EMPTY=Ae.fromArray([])}constructor(c){this.a=0,this.b=[],this.d=null,this.f=new n.$Sd,queueMicrotask(async()=>{const u={emitOne:d=>this.g(d),emitMany:d=>this.h(d),reject:d=>this.k(d)};try{await Promise.resolve(c(u)),this.j()}catch(d){this.k(d)}finally{u.emitOne=void 0,u.emitMany=void 0,u.reject=void 0}})}[Symbol.asyncIterator](){let c=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(c<this.b.length)return{done:!1,value:this.b[c++]};if(this.a===1)return{done:!0,value:void 0};await n.Event.toPromise(this.f.event)}while(!0)}}}static map(c,u){return new Ae(async d=>{for await(const F of c)d.emitOne(u(F))})}map(c){return Ae.map(this,c)}static filter(c,u){return new Ae(async d=>{for await(const F of c)u(F)&&d.emitOne(F)})}filter(c){return Ae.filter(this,c)}static coalesce(c){return Ae.filter(c,u=>!!u)}coalesce(){return Ae.coalesce(this)}static async toPromise(c){const u=[];for await(const d of c)u.push(d);return u}toPromise(){return Ae.toPromise(this)}g(c){this.a===0&&(this.b.push(c),this.f.fire())}h(c){this.a===0&&(this.b=this.b.concat(c),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(c){this.a===0&&(this.a=2,this.d=c,this.f.fire())}}t.$qh=Ae;class ge extends Ae{constructor(c,u){super(u),this.l=c}cancel(){this.l.cancel()}}t.$rh=ge;function v(r){const c=new A.$3d,u=r(c.token);return new ge(c,async d=>{const F=c.token.onCancellationRequested(()=>{F.dispose(),c.dispose(),d.reject(new C.$5)});try{for await(const R of u){if(c.token.isCancellationRequested)return;d.emitOne(R)}F.dispose(),c.dispose()}catch(R){F.dispose(),c.dispose(),d.reject(R)}})}t.$sh=v;class i{constructor(){this.a=new H,this.b=new Ae(d=>{if(c){d.reject(c);return}return u&&d.emitMany(u),this.d=F=>d.reject(F),this.f=F=>d.emitOne(F),this.a.p});let c,u;this.f=d=>{u||(u=[]),u.push(d)},this.d=d=>{c||(c=d)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(c){this.d(c),this.a.complete()}emitOne(c){this.f(c)}}t.$th=i}),define(be[3],$e([1,0,16,114,14,19,9,6,4,118,2,31,5,15,49,21]),function(ie,t,A,C,n,j,E,k,m,w,y,L,l,h,e,s){"use strict";var g;Object.defineProperty(t,"__esModule",{value:!0}),t.$QQ=t.$PQ=t.h=t.$NQ=t.$MQ=t.$LQ=t.$KQ=t.$JQ=t.$IQ=t.$HQ=t.$GQ=t.DetectedFullscreenMode=t.$FQ=t.$EQ=t.$DQ=t.$CQ=t.$BQ=t.$AQ=t.$zQ=t.$yQ=t.$xQ=t.$wQ=t.$vQ=t.$uQ=t.$tQ=t.$sQ=t.$rQ=t.$qQ=t.$pQ=t.$=t.Namespace=t.$nQ=t.$mQ=t.$lQ=t.$kQ=t.$jQ=t.$iQ=t.$hQ=t.$gQ=t.$fQ=t.$eQ=t.$dQ=t.$cQ=t.$bQ=t.$aQ=t.$_P=t.$$P=t.$0P=t.$9P=t.$8P=t.$7P=t.$6P=t.$5P=t.$4P=t.$3P=t.$2P=t.$1P=t.$ZP=t.$YP=t.$XP=t.$WP=t.$VP=t.$UP=t.$TP=t.$SP=t.$RP=t.$QP=t.$PP=t.$OP=t.$NP=t.$MP=t.$LP=t.$KP=t.$JP=t.$IP=t.$HP=t.$GP=t.$FP=t.$EP=t.$DP=t.$CP=t.$BP=t.$AP=t.$zP=t.$yP=t.$xP=t.$wP=t.$vP=t.$uP=t.$tP=t.$sP=t.$rP=t.$qP=t.$pP=t.$oP=t.$nP=t.$mP=t.$lP=t.$kP=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,g=function(){const Q=new Map;(0,s.$PO)(s.$QO,1),Q.set(s.$QO.vscodeWindowId,{window:s.$QO,disposables:new y.$Rc});const V=new m.$Sd,ee=new m.$Sd,ce=new m.$Sd;return{onDidRegisterWindow:V.event,onWillUnregisterWindow:ce.event,onDidUnregisterWindow:ee.event,registerWindow(ye){if(Q.has(ye.vscodeWindowId))return y.$Sc.None;const Le=new y.$Rc,He={window:ye,disposables:Le.add(new y.$Rc)};return Q.set(ye.vscodeWindowId,He),Le.add((0,y.$Qc)(()=>{Q.delete(ye.vscodeWindowId),ee.fire(ye)})),Le.add(a(ye,t.$eQ.BEFORE_UNLOAD,()=>{ce.fire(ye)})),V.fire(He),Le},getWindows(){return Q.values()},getWindowsCount(){return Q.size},getWindowId(ye){return ye.vscodeWindowId},hasWindow(ye){return Q.has(ye)},getWindowById(ye){return Q.get(ye)},getWindow(ye){const Le=ye;if(Le?.ownerDocument?.defaultView)return Le.ownerDocument.defaultView.window;const He=ye;return He?.view?He.view.window:s.$QO},getDocument(ye){const Le=ye;return(0,t.getWindow)(Le).document}}}(),t.registerWindow=g.registerWindow,t.getWindow=g.getWindow,t.getDocument=g.getDocument,t.getWindows=g.getWindows,t.getWindowsCount=g.getWindowsCount,t.getWindowId=g.getWindowId,t.getWindowById=g.getWindowById,t.hasWindow=g.hasWindow,t.onDidRegisterWindow=g.onDidRegisterWindow,t.onWillUnregisterWindow=g.onWillUnregisterWindow,t.onDidUnregisterWindow=g.onDidUnregisterWindow;function $(Q){for(;Q.firstChild;)Q.firstChild.remove()}t.$kP=$;class o{constructor(V,ee,ce,ye){this.f=V,this.g=ee,this.d=ce,this.j=ye||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function a(Q,V,ee,ce){return new o(Q,V,ee,ce)}t.$lP=a;function D(Q,V){return function(ee){return V(new j.$dP(Q,ee))}}function b(Q){return function(V){return Q(new n.$iP(V))}}const f=function(V,ee,ce,ye){let Le=ce;return ee==="click"||ee==="mousedown"?Le=D((0,t.getWindow)(V),ce):(ee==="keydown"||ee==="keypress"||ee==="keyup")&&(Le=b(ce)),a(V,ee,Le,ye)};t.$mP=f;const N=function(V,ee,ce){const ye=D((0,t.getWindow)(V),ee);return T(V,ye,ce)};t.$nP=N;const O=function(V,ee,ce){const ye=D((0,t.getWindow)(V),ee);return S(V,ye,ce)};t.$oP=O;function T(Q,V,ee){return a(Q,l.$r&&C.$aP.pointerEvents?t.$eQ.POINTER_DOWN:t.$eQ.MOUSE_DOWN,V,ee)}t.$pP=T;function p(Q,V,ee){return a(Q,l.$r&&C.$aP.pointerEvents?t.$eQ.POINTER_MOVE:t.$eQ.MOUSE_MOVE,V,ee)}t.$qP=p;function S(Q,V,ee){return a(Q,l.$r&&C.$aP.pointerEvents?t.$eQ.POINTER_UP:t.$eQ.MOUSE_UP,V,ee)}t.$rP=S;function M(Q,V,ee){return(0,E.$hh)(Q,V,ee)}t.$sP=M;class U extends E.$ih{constructor(V,ee){super(V,ee)}}t.$tP=U;function _(Q,V,ee,ce){let ye=0;const Le=Q.setInterval(()=>{ye++,(typeof ce=="number"&&ye>=ce||V()===!0)&&He.dispose()},ee),He=(0,y.$Qc)(()=>{Q.clearInterval(Le)});return He}t.$wP=_;class P extends E.$bh{cancelAndSet(V,ee,ce){return super.cancelAndSet(V,ee,ce)}}t.$xP=P;class I{constructor(V,ee=0){this.d=V,this.priority=ee,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(V){(0,k.$1)(V)}}static sort(V,ee){return ee.priority-V.priority}}(function(){const Q=new Map,V=new Map,ee=new Map,ce=new Map,ye=Le=>{ee.set(Le,!1);const He=Q.get(Le)??[];for(V.set(Le,He),Q.set(Le,[]),ce.set(Le,!0);He.length>0;)He.sort(I.sort),He.shift().execute();ce.set(Le,!1)};t.$vP=(Le,He,Ge=0)=>{const Xe=(0,t.getWindowId)(Le),qe=new I(He,Ge);let lt=Q.get(Xe);return lt||(lt=[],Q.set(Xe,lt)),lt.push(qe),ee.get(Xe)||(ee.set(Xe,!0),Le.requestAnimationFrame(()=>ye(Xe))),qe},t.$uP=(Le,He,Ge)=>{const Xe=(0,t.getWindowId)(Le);if(ce.get(Xe)){const qe=new I(He,Ge);let lt=V.get(Xe);return lt||(lt=[],V.set(Xe,lt)),lt.push(qe),qe}else return(0,t.$vP)(Le,He,Ge)}})();function B(Q,V){return(0,t.$vP)(Q,V,1e4)}t.$yP=B;function X(Q,V){return(0,t.$vP)(Q,V,-1e4)}t.$zP=X;const Y=8,ue=function(Q,V){return V};class ne extends y.$Sc{constructor(V,ee,ce,ye=ue,Le=Y){super();let He=null,Ge=0;const Xe=this.B(new E.$ah),qe=()=>{Ge=new Date().getTime(),ce(He),He=null};this.B(a(V,ee,lt=>{He=ye(He,lt);const Pt=new Date().getTime()-Ge;Pt>=Le?(Xe.cancel(),qe()):Xe.setIfNotSet(qe,Le-Pt)}))}}function te(Q,V,ee,ce,ye){return new ne(Q,V,ee,ce,ye)}t.$AP=te;function we(Q){return(0,t.getWindow)(Q).getComputedStyle(Q,null)}t.$BP=we;function Te(Q,V){const ee=(0,t.getWindow)(Q),ce=ee.document;if(Q!==ce.body)return new Oe(Q.clientWidth,Q.clientHeight);if(l.$r&&ee?.visualViewport)return new Oe(ee.visualViewport.width,ee.visualViewport.height);if(ee?.innerWidth&&ee.innerHeight)return new Oe(ee.innerWidth,ee.innerHeight);if(ce.body&&ce.body.clientWidth&&ce.body.clientHeight)return new Oe(ce.body.clientWidth,ce.body.clientHeight);if(ce.documentElement&&ce.documentElement.clientWidth&&ce.documentElement.clientHeight)return new Oe(ce.documentElement.clientWidth,ce.documentElement.clientHeight);if(V)return Te(V);throw new Error("Unable to figure out browser width and height")}t.$CP=Te;class Pe{static d(V,ee){return parseFloat(ee)||0}static f(V,ee,ce){const ye=we(V),Le=ye?ye.getPropertyValue(ee):"0";return Pe.d(V,Le)}static getBorderLeftWidth(V){return Pe.f(V,"border-left-width","borderLeftWidth")}static getBorderRightWidth(V){return Pe.f(V,"border-right-width","borderRightWidth")}static getBorderTopWidth(V){return Pe.f(V,"border-top-width","borderTopWidth")}static getBorderBottomWidth(V){return Pe.f(V,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(V){return Pe.f(V,"padding-left","paddingLeft")}static getPaddingRight(V){return Pe.f(V,"padding-right","paddingRight")}static getPaddingTop(V){return Pe.f(V,"padding-top","paddingTop")}static getPaddingBottom(V){return Pe.f(V,"padding-bottom","paddingBottom")}static getMarginLeft(V){return Pe.f(V,"margin-left","marginLeft")}static getMarginTop(V){return Pe.f(V,"margin-top","marginTop")}static getMarginRight(V){return Pe.f(V,"margin-right","marginRight")}static getMarginBottom(V){return Pe.f(V,"margin-bottom","marginBottom")}}class Oe{static{this.None=new Oe(0,0)}constructor(V,ee){this.width=V,this.height=ee}with(V=this.width,ee=this.height){return V!==this.width||ee!==this.height?new Oe(V,ee):this}static is(V){return typeof V=="object"&&typeof V.height=="number"&&typeof V.width=="number"}static lift(V){return V instanceof Oe?V:new Oe(V.width,V.height)}static equals(V,ee){return V===ee?!0:!V||!ee?!1:V.width===ee.width&&V.height===ee.height}}t.$DP=Oe;function re(Q){let V=Q.offsetParent,ee=Q.offsetTop,ce=Q.offsetLeft;for(;(Q=Q.parentNode)!==null&&Q!==Q.ownerDocument.body&&Q!==Q.ownerDocument.documentElement;){ee-=Q.scrollTop;const ye=W(Q)?null:we(Q);ye&&(ce-=ye.direction!=="rtl"?Q.scrollLeft:-Q.scrollLeft),Q===V&&(ce+=Pe.getBorderLeftWidth(Q),ee+=Pe.getBorderTopWidth(Q),ee+=Q.offsetTop,ce+=Q.offsetLeft,V=Q.offsetParent)}return{left:ce,top:ee}}t.$EP=re;function Z(Q,V,ee){typeof V=="number"&&(Q.style.width=`${V}px`),typeof ee=="number"&&(Q.style.height=`${ee}px`)}t.$FP=Z;function ae(Q,V,ee,ce,ye,Le="absolute"){typeof V=="number"&&(Q.style.top=`${V}px`),typeof ee=="number"&&(Q.style.right=`${ee}px`),typeof ce=="number"&&(Q.style.bottom=`${ce}px`),typeof ye=="number"&&(Q.style.left=`${ye}px`),Q.style.position=Le}t.$GP=ae;function K(Q){const V=Q.getBoundingClientRect(),ee=(0,t.getWindow)(Q);return{left:V.left+ee.scrollX,top:V.top+ee.scrollY,width:V.width,height:V.height}}t.$HP=K;function H(Q){let V=Q,ee=1;do{const ce=we(V).zoom;ce!=null&&ce!=="1"&&(ee*=ce),V=V.parentElement}while(V!==null&&V!==V.ownerDocument.documentElement);return ee}t.$IP=H;function J(Q){const V=Pe.getMarginLeft(Q)+Pe.getMarginRight(Q);return Q.offsetWidth+V}t.$JP=J;function me(Q){const V=Pe.getBorderLeftWidth(Q)+Pe.getBorderRightWidth(Q),ee=Pe.getPaddingLeft(Q)+Pe.getPaddingRight(Q);return Q.offsetWidth-V-ee}t.$KP=me;function ve(Q){const V=Pe.getMarginLeft(Q)+Pe.getMarginRight(Q);return Q.scrollWidth+V}t.$LP=ve;function Fe(Q){const V=Pe.getBorderTopWidth(Q)+Pe.getBorderBottomWidth(Q),ee=Pe.getPaddingTop(Q)+Pe.getPaddingBottom(Q);return Q.offsetHeight-V-ee}t.$MP=Fe;function Ae(Q){const V=Pe.getMarginTop(Q)+Pe.getMarginBottom(Q);return Q.offsetHeight+V}t.$NP=Ae;function ge(Q,V){if(Q===null)return 0;const ee=re(Q),ce=re(V);return ee.left-ce.left}function v(Q,V){const ee=V.map(ye=>Math.max(ve(ye),J(ye))+ge(ye,Q)||0);return Math.max(...ee)}t.$OP=v;function i(Q,V){return!!V?.contains(Q)}t.$PP=i;const r="parentFlowToElementId";function c(Q,V){Q.dataset[r]=V.id}t.$QP=c;function u(Q){const V=Q.dataset[r];return typeof V=="string"?Q.ownerDocument.getElementById(V):null}function d(Q,V){let ee=Q;for(;ee;){if(ee===V)return!0;if(ee instanceof HTMLElement){const ce=u(ee);if(ce){ee=ce;continue}}ee=ee.parentNode}return!1}t.$RP=d;function F(Q,V,ee){for(;Q&&Q.nodeType===Q.ELEMENT_NODE;){if(Q.classList.contains(V))return Q;if(ee){if(typeof ee=="string"){if(Q.classList.contains(ee))return null}else if(Q===ee)return null}Q=Q.parentNode}return null}t.$SP=F;function R(Q,V,ee){return!!F(Q,V,ee)}t.$TP=R;function W(Q){return Q&&!!Q.host&&!!Q.mode}t.$UP=W;function z(Q){return!!q(Q)}t.$VP=z;function q(Q){for(;Q.parentNode;){if(Q===Q.ownerDocument?.body)return null;Q=Q.parentNode}return W(Q)?Q:null}t.$WP=q;function G(){let Q=De().activeElement;for(;Q?.shadowRoot;)Q=Q.shadowRoot.activeElement;return Q}t.$XP=G;function oe(Q){return G()===Q}t.$YP=oe;function se(Q){return i(G(),Q)}t.$ZP=se;function de(Q){return Q.ownerDocument===De()}t.$1P=de;function De(){return(0,t.getWindowsCount)()<=1?s.$QO.document:Array.from((0,t.getWindows)()).map(({window:V})=>V.document).find(V=>V.hasFocus())??s.$QO.document}t.$2P=De;function pe(){return De().defaultView?.window??s.$QO}t.$3P=pe;function Re(Q){const V=(0,t.getWindow)(Q);V.document.hasFocus()||V.focus()}t.$4P=Re;const Se=new Map;function Me(Q){return Se.has(Q)}t.$5P=Me;function Be(Q=s.$QO.document.head,V,ee){const ce=document.createElement("style");if(ce.type="text/css",ce.media="screen",V?.(ce),Q.appendChild(ce),ee&&ee.add((0,y.$Qc)(()=>Q.removeChild(ce))),Q===s.$QO.document.head){const ye=new Set;Se.set(ce,ye);for(const{window:Le,disposables:He}of(0,t.getWindows)()){if(Le===s.$QO)continue;const Ge=He.add(Ze(ce,ye,Le));ee?.add(Ge)}}return ce}t.$6P=Be;function Ie(Q){const V=new y.$Rc;for(const[ee,ce]of Se)V.add(Ze(ee,ce,Q));return V}t.$7P=Ie;function Ze(Q,V,ee){const ce=new y.$Rc,ye=Q.cloneNode(!0);ee.document.head.appendChild(ye),ce.add((0,y.$Qc)(()=>ee.document.head.removeChild(ye)));for(const Le of Ee(Q))ye.sheet?.insertRule(Le.cssText,ye.sheet?.cssRules.length);return ce.add(t.$8P.observe(Q,ce,{childList:!0})(()=>{ye.textContent=Q.textContent})),V.add(ye),ce.add((0,y.$Qc)(()=>V.delete(ye))),ce}t.$8P=new class{constructor(){this.mutationObservers=new Map}observe(Q,V,ee){let ce=this.mutationObservers.get(Q);ce||(ce=new Map,this.mutationObservers.set(Q,ce));const ye=(0,e.$Qi)(ee);let Le=ce.get(ye);if(Le)Le.users+=1;else{const He=new m.$Sd,Ge=new MutationObserver(qe=>He.fire(qe));Ge.observe(Q,ee);const Xe=Le={users:1,observer:Ge,onDidMutate:He.event};V.add((0,y.$Qc)(()=>{Xe.users-=1,Xe.users===0&&(He.dispose(),Ge.disconnect(),ce?.delete(ye),ce?.size===0&&this.mutationObservers.delete(Q))})),ce.set(ye,Le)}return Le.onDidMutate}};function Ke(Q=s.$QO.document.head){return x("meta",Q)}t.$9P=Ke;function xe(Q=s.$QO.document.head){return x("link",Q)}t.$0P=xe;function x(Q,V=s.$QO.document.head){const ee=document.createElement(Q);return V.appendChild(ee),ee}let le=null;function fe(){return le||(le=Be()),le}function Ee(Q){return Q?.sheet?.rules?Q.sheet.rules:Q?.sheet?.cssRules?Q.sheet.cssRules:[]}function Ne(Q,V,ee=fe()){if(!(!ee||!V)){ee.sheet?.insertRule(`${Q} {${V}}`,0);for(const ce of Se.get(ee)??[])Ne(Q,V,ce)}}t.$$P=Ne;function je(Q,V=fe()){if(!V)return;const ee=Ee(V),ce=[];for(let ye=0;ye<ee.length;ye++){const Le=ee[ye];Qe(Le)&&Le.selectorText.indexOf(Q)!==-1&&ce.push(ye)}for(let ye=ce.length-1;ye>=0;ye--)V.sheet?.deleteRule(ce[ye]);for(const ye of Se.get(V)??[])je(Q,ye)}t.$_P=je;function Qe(Q){return typeof Q.selectorText=="string"}function _e(Q){return Q instanceof MouseEvent||Q instanceof(0,t.getWindow)(Q).MouseEvent}t.$aQ=_e;function et(Q){return Q instanceof KeyboardEvent||Q instanceof(0,t.getWindow)(Q).KeyboardEvent}t.$bQ=et;function tt(Q){return Q instanceof PointerEvent||Q instanceof(0,t.getWindow)(Q).PointerEvent}t.$cQ=tt;function Je(Q){return Q instanceof DragEvent||Q instanceof(0,t.getWindow)(Q).DragEvent}t.$dQ=Je,t.$eQ={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:A.$5O?"webkitAnimationStart":"animationstart",ANIMATION_END:A.$5O?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:A.$5O?"webkitAnimationIteration":"animationiteration"};function nt(Q){const V=Q;return!!(V&&typeof V.preventDefault=="function"&&typeof V.stopPropagation=="function")}t.$fQ=nt,t.$gQ={stop:(Q,V)=>(Q.preventDefault(),V&&Q.stopPropagation(),Q)};function st(Q){const V=[];for(let ee=0;Q&&Q.nodeType===Q.ELEMENT_NODE;ee++)V[ee]=Q.scrollTop,Q=Q.parentNode;return V}t.$hQ=st;function rt(Q,V){for(let ee=0;Q&&Q.nodeType===Q.ELEMENT_NODE;ee++)Q.scrollTop!==V[ee]&&(Q.scrollTop=V[ee]),Q=Q.parentNode}t.$iQ=rt;class gt extends y.$Sc{static m(V){if(V instanceof HTMLElement){const ee=q(V),ce=ee?ee.activeElement:V.ownerDocument.activeElement;return i(ce,V)}else{const ee=V;return i(ee.document.activeElement,ee.document)}}constructor(V){super(),this.f=this.B(new m.$Sd),this.onDidFocus=this.f.event,this.g=this.B(new m.$Sd),this.onDidBlur=this.g.event;let ee=gt.m(V),ce=!1;const ye=()=>{ce=!1,ee||(ee=!0,this.f.fire())},Le=()=>{ee&&(ce=!0,(V instanceof HTMLElement?(0,t.getWindow)(V):V).setTimeout(()=>{ce&&(ce=!1,ee=!1,this.g.fire())},0))};this.j=()=>{gt.m(V)!==ee&&(ee?Le():ye())},this.B(a(V,t.$eQ.FOCUS,ye,!0)),this.B(a(V,t.$eQ.BLUR,Le,!0)),V instanceof HTMLElement&&(this.B(a(V,t.$eQ.FOCUS_IN,()=>this.j())),this.B(a(V,t.$eQ.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function kt(Q){return new gt(Q)}t.$jQ=kt;function St(Q,V){return Q.after(V),V}t.$kQ=St;function wt(Q,...V){if(Q.append(...V),V.length===1&&typeof V[0]!="string")return V[0]}t.$lQ=wt;function Mt(Q,V){return Q.insertBefore(V,Q.firstChild),V}t.$mQ=Mt;function ze(Q,...V){Q.innerText="",wt(Q,...V)}t.$nQ=ze;const he=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var ke;(function(Q){Q.HTML="http://www.w3.org/1999/xhtml",Q.SVG="http://www.w3.org/2000/svg"})(ke||(t.Namespace=ke={}));function Ce(Q,V,ee,...ce){const ye=he.exec(V);if(!ye)throw new Error("Bad use of emmet");const Le=ye[1]||"div";let He;return Q!==ke.HTML?He=document.createElementNS(Q,Le):He=document.createElement(Le),ye[3]&&(He.id=ye[3]),ye[4]&&(He.className=ye[4].replace(/\./g," ").trim()),ee&&Object.entries(ee).forEach(([Ge,Xe])=>{typeof Xe>"u"||(/^on\w+$/.test(Ge)?He[Ge]=Xe:Ge==="selected"?Xe&&He.setAttribute(Ge,"true"):He.setAttribute(Ge,Xe))}),He.append(...ce),He}function We(Q,V,...ee){return Ce(ke.HTML,Q,V,...ee)}t.$=We,We.SVG=function(Q,V,...ee){return Ce(ke.SVG,Q,V,...ee)};function it(Q,V){const ee=[];return Q.forEach((ce,ye)=>{ye>0&&(V instanceof Node?ee.push(V.cloneNode()):ee.push(document.createTextNode(V))),ee.push(ce)}),ee}t.$pQ=it;function at(Q,...V){Q?Ve(...V):ut(...V)}t.$qQ=at;function Ve(...Q){for(const V of Q)V.style.display="",V.removeAttribute("aria-hidden")}t.$rQ=Ve;function ut(...Q){for(const V of Q)V.style.display="none",V.setAttribute("aria-hidden","true")}t.$sQ=ut;function vt(Q,V){for(;Q&&Q.nodeType===Q.ELEMENT_NODE;){if(Q instanceof HTMLElement&&Q.hasAttribute(V))return Q;Q=Q.parentNode}return null}function Ft(Q){!Q||!Q.hasAttribute("tabIndex")||(Q.ownerDocument.activeElement===Q&&vt(Q.parentElement,"tabIndex")?.focus(),Q.removeAttribute("tabindex"))}t.$tQ=Ft;function Gt(Q){return V=>{V.preventDefault(),V.stopPropagation(),Q(V)}}t.$uQ=Gt;function Ai(Q){return new Promise(V=>{if(Q.document.readyState==="complete"||Q.document&&Q.document.body!==null)V(void 0);else{const ce=()=>{Q.window.removeEventListener("DOMContentLoaded",ce,!1),V()};Q.window.addEventListener("DOMContentLoaded",ce,!1)}})}t.$vQ=Ai;function ki(Q,V){const ee=Q.devicePixelRatio*V;return Math.max(1,Math.floor(ee))/Q.devicePixelRatio}t.$wQ=ki;function Si(Q){s.$QO.open(Q,"_blank","noopener")}t.$xQ=Si;const Xt=780,Yt=640;function Fi(Q){const V=Math.floor(s.$QO.screenLeft+s.$QO.innerWidth/2-Xt/2),ee=Math.floor(s.$QO.screenTop+s.$QO.innerHeight/2-Yt/2);s.$QO.open(Q,"_blank",`width=${Xt},height=${Yt},top=${ee},left=${V}`)}t.$yQ=Fi;function Pi(Q,V=!0){const ee=s.$QO.open();return ee?(V&&(ee.opener=null),ee.location.href=Q,!0):!1}t.$zQ=Pi;function Ni(Q,V){const ee=()=>{V(),ce=(0,t.$vP)(Q,ee)};let ce=(0,t.$vP)(Q,ee);return(0,y.$Qc)(()=>ce.dispose())}t.$AQ=Ni,L.$fg.setPreferredWebSchema(/^https:/.test(s.$QO.location.href)?"https":"http");function Ci(Q){return Q?`url('${L.$lg.uriToBrowserUri(Q).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.$BQ=Ci;function Ri(Q){return`'${Q.replace(/'/g,"%27")}'`}t.$CQ=Ri;function Zt(Q,V){if(Q!==void 0){const ee=Q.match(/^\s*var\((.+)\)$/);if(ee){const ce=ee[1].split(",",2);return ce.length===2&&(V=Zt(ce[1].trim(),V)),`var(${ce[0]}, ${V})`}return Q}return V}t.$DQ=Zt;function Ti(Q,V){let ee;if(h.URI.isUri(Q))ee=Q.toString(!0);else{const Le=new Blob([Q]);ee=URL.createObjectURL(Le),setTimeout(()=>URL.revokeObjectURL(ee))}const ce=pe(),ye=document.createElement("a");ce.document.body.appendChild(ye),ye.download=V,ye.href=ee,ye.click(),setTimeout(()=>ce.document.body.removeChild(ye))}t.$EQ=Ti;function Li(){return new Promise(Q=>{const V=pe(),ee=document.createElement("input");V.document.body.appendChild(ee),ee.type="file",ee.multiple=!0,m.Event.once(m.Event.fromDOMEventEmitter(ee,"input"))(()=>{Q(ee.files??void 0)}),ee.click(),setTimeout(()=>V.document.body.removeChild(ee))})}t.$FQ=Li;var Dt;(function(Q){Q[Q.DOCUMENT=1]="DOCUMENT",Q[Q.BROWSER=2]="BROWSER"})(Dt||(t.DetectedFullscreenMode=Dt={}));function Ii(Q){return Q.document.fullscreenElement||Q.document.webkitFullscreenElement||Q.document.webkitIsFullScreen?{mode:Dt.DOCUMENT,guess:!1}:Q.innerHeight===Q.screen.height?{mode:Dt.BROWSER,guess:!1}:(l.$j||l.$k)&&Q.outerHeight===Q.screen.height&&Q.outerWidth===Q.screen.width?{mode:Dt.BROWSER,guess:!0}:null}t.$GQ=Ii;function Jt(Q,V=!1){const ee=document.createElement("a");return w.addHook("afterSanitizeAttributes",ce=>{for(const ye of["href","src"])if(ce.hasAttribute(ye)){const Le=ce.getAttribute(ye);if(ye==="href"&&Le.startsWith("#"))continue;if(ee.href=Le,!Q.includes(ee.protocol.replace(/:$/,""))){if(V&&ye==="src"&&ee.href.startsWith("data:"))continue;ce.removeAttribute(ye)}}}),(0,y.$Qc)(()=>{w.removeHook("afterSanitizeAttributes")})}t.$HQ=Jt;const Oi=[L.Schemas.http,L.Schemas.https,L.Schemas.command];t.$IQ=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Mi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Bi(Q,V){const ee=Jt(Oi);try{const ce=w.sanitize(V,Mi);Q.innerHTML=ce}finally{ee.dispose()}}t.$JQ=Bi;function zi(Q){const V=new Uint16Array(Q.length);for(let ye=0;ye<V.length;ye++)V[ye]=Q.charCodeAt(ye);let ee="";const ce=new Uint8Array(V.buffer);for(let ye=0;ye<ce.length;ye++)ee+=String.fromCharCode(ce[ye]);return ee}function ji(Q){return btoa(zi(Q))}t.$KQ=ji;class bt extends m.$Sd{constructor(){super(),this.o=new y.$Rc,this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(m.Event.runAndSubscribe(t.onDidRegisterWindow,({window:V,disposables:ee})=>this.B(V,ee),{window:s.$QO,disposables:this.o}))}B(V,ee){ee.add(a(V,"keydown",ce=>{if(ce.defaultPrevented)return;const ye=new n.$iP(ce);if(!(ye.keyCode===6&&ce.repeat)){if(ce.altKey&&!this.s.altKey)this.s.lastKeyPressed="alt";else if(ce.ctrlKey&&!this.s.ctrlKey)this.s.lastKeyPressed="ctrl";else if(ce.metaKey&&!this.s.metaKey)this.s.lastKeyPressed="meta";else if(ce.shiftKey&&!this.s.shiftKey)this.s.lastKeyPressed="shift";else if(ye.keyCode!==6)this.s.lastKeyPressed=void 0;else return;this.s.altKey=ce.altKey,this.s.ctrlKey=ce.ctrlKey,this.s.metaKey=ce.metaKey,this.s.shiftKey=ce.shiftKey,this.s.lastKeyPressed&&(this.s.event=ce,this.fire(this.s))}},!0)),ee.add(a(V,"keyup",ce=>{ce.defaultPrevented||(!ce.altKey&&this.s.altKey?this.s.lastKeyReleased="alt":!ce.ctrlKey&&this.s.ctrlKey?this.s.lastKeyReleased="ctrl":!ce.metaKey&&this.s.metaKey?this.s.lastKeyReleased="meta":!ce.shiftKey&&this.s.shiftKey?this.s.lastKeyReleased="shift":this.s.lastKeyReleased=void 0,this.s.lastKeyPressed!==this.s.lastKeyReleased&&(this.s.lastKeyPressed=void 0),this.s.altKey=ce.altKey,this.s.ctrlKey=ce.ctrlKey,this.s.metaKey=ce.metaKey,this.s.shiftKey=ce.shiftKey,this.s.lastKeyReleased&&(this.s.event=ce,this.fire(this.s)))},!0)),ee.add(a(V.document.body,"mousedown",()=>{this.s.lastKeyPressed=void 0},!0)),ee.add(a(V.document.body,"mouseup",()=>{this.s.lastKeyPressed=void 0},!0)),ee.add(a(V.document.body,"mousemove",ce=>{ce.buttons&&(this.s.lastKeyPressed=void 0)},!0)),ee.add(a(V,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.s}get isModifierPressed(){return this.s.altKey||this.s.ctrlKey||this.s.metaKey||this.s.shiftKey}resetKeyStatus(){this.C(),this.fire(this.s)}C(){this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return bt.A||(bt.A=new bt),bt.A}dispose(){super.dispose(),this.o.dispose()}}t.$LQ=bt;function Hi(Q){const V=document.cookie.match("(^|[^;]+)\\s*"+Q+"\\s*=\\s*([^;]+)");return V?V.pop():void 0}t.$MQ=Hi;class Ui extends y.$Sc{constructor(V,ee){super(),this.j=V,this.m=ee,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(a(this.j,t.$eQ.DRAG_START,V=>{this.m.onDragStart?.(V)})),this.m.onDrag&&this.B(a(this.j,t.$eQ.DRAG,V=>{this.m.onDrag?.(V)})),this.B(a(this.j,t.$eQ.DRAG_ENTER,V=>{this.f++,this.g=V.timeStamp,this.m.onDragEnter?.(V)})),this.B(a(this.j,t.$eQ.DRAG_OVER,V=>{V.preventDefault(),this.m.onDragOver?.(V,V.timeStamp-this.g)})),this.B(a(this.j,t.$eQ.DRAG_LEAVE,V=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(V))})),this.B(a(this.j,t.$eQ.DRAG_END,V=>{this.f=0,this.g=0,this.m.onDragEnd?.(V)})),this.B(a(this.j,t.$eQ.DROP,V=>{this.f=0,this.g=0,this.m.onDrop?.(V)}))}}t.$NQ=Ui;const Wi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function Qi(Q,...V){let ee,ce;Array.isArray(V[0])?(ee={},ce=V[0]):(ee=V[0]||{},ce=V[1]);const ye=Wi.exec(Q);if(!ye||!ye.groups)throw new Error("Bad use of h");const Le=ye.groups.tag||"div",He=document.createElement(Le);ye.groups.id&&(He.id=ye.groups.id);const Ge=[];if(ye.groups.class)for(const qe of ye.groups.class.split("."))qe!==""&&Ge.push(qe);if(ee.className!==void 0)for(const qe of ee.className.split("."))qe!==""&&Ge.push(qe);Ge.length>0&&(He.className=Ge.join(" "));const Xe={};if(ye.groups.name&&(Xe[ye.groups.name]=He),ce)for(const qe of ce)qe instanceof HTMLElement?He.appendChild(qe):typeof qe=="string"?He.append(qe):"root"in qe&&(Object.assign(Xe,qe),He.appendChild(qe.root));for(const[qe,lt]of Object.entries(ee))if(qe!=="className")if(qe==="style")for(const[Pt,Bt]of Object.entries(lt))He.style.setProperty(ei(Pt),typeof Bt=="number"?Bt+"px":""+Bt);else qe==="tabIndex"?He.tabIndex=lt:He.setAttribute(ei(qe),lt.toString());return Xe.root=He,Xe}t.h=Qi;function ei(Q){return Q.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(Q,V){for(const{name:ee,value:ce}of Q.attributes)V.setAttribute(ee,ce)}t.$PQ=ti;function qi(Q,V,ee){const ce=Q.getAttribute(ee);ce?V.setAttribute(ee,ce):V.removeAttribute(ee)}function _i(Q,V,ee){ti(Q,V);const ce=new y.$Rc;return ce.add(t.$8P.observe(Q,ce,{attributes:!0,attributeFilter:ee})(ye=>{for(const Le of ye)Le.type==="attributes"&&Le.attributeName&&qi(Q,V,Le.attributeName)})),ce}t.$QQ=_i}),define(be[54],$e([1,0,3,2,117]),function(ie,t,A,C,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TQ=t.$SQ=t.$RQ=void 0;class j extends C.$Sc{constructor(m,w){super(),this.B((0,A.$lP)(m,"dragover",y=>{y.preventDefault(),this.a||(this.a=setTimeout(()=>{w(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(y=>{this.B((0,A.$lP)(m,y,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$RQ=j,t.$SQ={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:n.$5r.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function E(k,m,w,y,L){const l=document.createElement("div");if(l.className=w,l.textContent=m,L&&(l.style.color=L),y&&(l.style.background=y),k.dataTransfer){const h=(0,A.getWindow)(k).document;h.body.appendChild(l),k.dataTransfer.setDragImage(l,-10,-10),setTimeout(()=>h.body.removeChild(l),0)}}t.$TQ=E}),define(be[55],$e([1,0,3]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lR=t.$kR=t.$jR=void 0;function C(l,h={}){const e=j(h);return e.textContent=l,e}t.$jR=C;function n(l,h={}){const e=j(h);return m(e,w(l,!!h.renderCodeSegments),h.actionHandler,h.renderCodeSegments),e}t.$kR=n;function j(l){const h=l.inline?"span":"div",e=document.createElement(h);return l.className&&(e.className=l.className),e}t.$lR=j;class E{constructor(h){this.b=h,this.c=0}eos(){return this.c>=this.b.length}next(){const h=this.peek();return this.advance(),h}peek(){return this.b[this.c]}advance(){this.c++}}var k;(function(l){l[l.Invalid=0]="Invalid",l[l.Root=1]="Root",l[l.Text=2]="Text",l[l.Bold=3]="Bold",l[l.Italics=4]="Italics",l[l.Action=5]="Action",l[l.ActionClose=6]="ActionClose",l[l.Code=7]="Code",l[l.NewLine=8]="NewLine"})(k||(k={}));function m(l,h,e,s){let g;if(h.type===2)g=document.createTextNode(h.content||"");else if(h.type===3)g=document.createElement("b");else if(h.type===4)g=document.createElement("i");else if(h.type===7&&s)g=document.createElement("code");else if(h.type===5&&e){const $=document.createElement("a");e.disposables.add(A.$mP($,"click",o=>{e.callback(String(h.index),o)})),g=$}else h.type===8?g=document.createElement("br"):h.type===1&&(g=l);g&&l!==g&&l.appendChild(g),g&&Array.isArray(h.children)&&h.children.forEach($=>{m(g,$,e,s)})}function w(l,h){const e={type:1,children:[]};let s=0,g=e;const $=[],o=new E(l);for(;!o.eos();){let a=o.next();const D=a==="\\"&&L(o.peek(),h)!==0;if(D&&(a=o.next()),!D&&y(a,h)&&a===o.peek()){o.advance(),g.type===2&&(g=$.pop());const b=L(a,h);if(g.type===b||g.type===5&&b===6)g=$.pop();else{const f={type:b,children:[]};b===5&&(f.index=s,s++),g.children.push(f),$.push(g),g=f}}else if(a===`
`)g.type===2&&(g=$.pop()),g.children.push({type:8});else if(g.type!==2){const b={type:2,content:a};g.children.push(b),$.push(g),g=b}else g.content+=a}return g.type===2&&(g=$.pop()),$.length,e}function y(l,h){return L(l,h)!==0}function L(l,h){switch(l){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return h?7:0;default:return 0}}}),define(be[56],$e([1,0,3,2]),function(ie,t,A,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XQ=void 0;class n{constructor(){this.a=new C.$Rc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(E,k){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const m=this.c;this.c=null,E&&m&&m(k)}isMonitoring(){return!!this.b}startMonitoring(E,k,m,w,y){this.isMonitoring()&&this.stopMonitoring(!1),this.b=w,this.c=y;let L=E;try{E.setPointerCapture(k),this.a.add((0,C.$Qc)(()=>{try{E.releasePointerCapture(k)}catch{}}))}catch{L=A.getWindow(E)}this.a.add(A.$lP(L,A.$eQ.POINTER_MOVE,l=>{if(l.buttons!==m){this.stopMonitoring(!0);return}l.preventDefault(),this.b(l)})),this.a.add(A.$lP(L,A.$eQ.POINTER_UP,l=>this.stopMonitoring(!0)))}}t.$XQ=n});var Ye=this&&this.__decorate||function(ie,t,A,C){var n=arguments.length,j=n<3?t:C===null?C=Object.getOwnPropertyDescriptor(t,A):C,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(ie,t,A,C);else for(var k=ie.length-1;k>=0;k--)(E=ie[k])&&(j=(n<3?E(j):n>3?E(t,A,j):E(t,A))||j);return n>3&&j&&Object.defineProperty(t,A,j),j};define(be[25],$e([1,0,3,21,12,27,4,2,45]),function(ie,t,A,C,n,j,E,k,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UQ=t.EventType=void 0;var w;(function(L){L.Tap="-monaco-gesturetap",L.Change="-monaco-gesturechange",L.Start="-monaco-gesturestart",L.End="-monaco-gesturesend",L.Contextmenu="-monaco-gesturecontextmenu"})(w||(t.EventType=w={}));class y extends k.$Sc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new m.$3c,this.h=new m.$3c,this.m={},this.j=null,this.n=0,this.B(E.Event.runAndSubscribe(A.onDidRegisterWindow,({window:l,disposables:h})=>{h.add(A.$lP(l.document,"touchstart",e=>this.s(e),{passive:!1})),h.add(A.$lP(l.document,"touchend",e=>this.u(l,e))),h.add(A.$lP(l.document,"touchmove",e=>this.D(e),{passive:!1}))},{window:C.$QO,disposables:this.q}))}static addTarget(l){if(!y.isTouchDevice())return k.$Sc.None;y.b||(y.b=(0,k.$Lc)(new y));const h=y.b.g.push(l);return(0,k.$Qc)(h)}static ignoreTarget(l){if(!y.isTouchDevice())return k.$Sc.None;y.b||(y.b=(0,k.$Lc)(new y));const h=y.b.h.push(l);return(0,k.$Qc)(h)}static isTouchDevice(){return"ontouchstart"in C.$QO||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(l){const h=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let e=0,s=l.targetTouches.length;e<s;e++){const g=l.targetTouches.item(e);this.m[g.identifier]={id:g.identifier,initialTarget:g.target,initialTimeStamp:h,initialPageX:g.pageX,initialPageY:g.pageY,rollingTimestamps:[h],rollingPageX:[g.pageX],rollingPageY:[g.pageY]};const $=this.w(w.Start,g.target);$.pageX=g.pageX,$.pageY=g.pageY,this.z($)}this.f&&(l.preventDefault(),l.stopPropagation(),this.f=!1)}u(l,h){const e=Date.now(),s=Object.keys(this.m).length;for(let g=0,$=h.changedTouches.length;g<$;g++){const o=h.changedTouches.item(g);if(!this.m.hasOwnProperty(String(o.identifier))){console.warn("move of an UNKNOWN touch",o);continue}const a=this.m[o.identifier],D=Date.now()-a.initialTimeStamp;if(D<y.c&&Math.abs(a.initialPageX-n.$sb(a.rollingPageX))<30&&Math.abs(a.initialPageY-n.$sb(a.rollingPageY))<30){const b=this.w(w.Tap,a.initialTarget);b.pageX=n.$sb(a.rollingPageX),b.pageY=n.$sb(a.rollingPageY),this.z(b)}else if(D>=y.c&&Math.abs(a.initialPageX-n.$sb(a.rollingPageX))<30&&Math.abs(a.initialPageY-n.$sb(a.rollingPageY))<30){const b=this.w(w.Contextmenu,a.initialTarget);b.pageX=n.$sb(a.rollingPageX),b.pageY=n.$sb(a.rollingPageY),this.z(b)}else if(s===1){const b=n.$sb(a.rollingPageX),f=n.$sb(a.rollingPageY),N=n.$sb(a.rollingTimestamps)-a.rollingTimestamps[0],O=b-a.rollingPageX[0],T=f-a.rollingPageY[0],p=[...this.g].filter(S=>a.initialTarget instanceof Node&&S.contains(a.initialTarget));this.C(l,p,e,Math.abs(O)/N,O>0?1:-1,b,Math.abs(T)/N,T>0?1:-1,f)}this.z(this.w(w.End,a.initialTarget)),delete this.m[o.identifier]}this.f&&(h.preventDefault(),h.stopPropagation(),this.f=!1)}w(l,h){const e=document.createEvent("CustomEvent");return e.initEvent(l,!1,!0),e.initialTarget=h,e.tapCount=0,e}z(l){if(l.type===w.Tap){const h=new Date().getTime();let e=0;h-this.n>y.r?e=1:e=2,this.n=h,l.tapCount=e}else(l.type===w.Change||l.type===w.Contextmenu)&&(this.n=0);if(l.initialTarget instanceof Node){for(const h of this.h)if(h.contains(l.initialTarget))return;for(const h of this.g)h.contains(l.initialTarget)&&(h.dispatchEvent(l),this.f=!0)}}C(l,h,e,s,g,$,o,a,D){this.j=A.$vP(l,()=>{const b=Date.now(),f=b-e;let N=0,O=0,T=!0;s+=y.a*f,o+=y.a*f,s>0&&(T=!1,N=g*s*f),o>0&&(T=!1,O=a*o*f);const p=this.w(w.Change);p.translationX=N,p.translationY=O,h.forEach(S=>S.dispatchEvent(p)),T||this.C(l,h,b,s,g,$+N,o,a,D+O)})}D(l){const h=Date.now();for(let e=0,s=l.changedTouches.length;e<s;e++){const g=l.changedTouches.item(e);if(!this.m.hasOwnProperty(String(g.identifier))){console.warn("end of an UNKNOWN touch",g);continue}const $=this.m[g.identifier],o=this.w(w.Change,$.initialTarget);o.translationX=g.pageX-n.$sb($.rollingPageX),o.translationY=g.pageY-n.$sb($.rollingPageY),o.pageX=g.pageX,o.pageY=g.pageY,this.z(o),$.rollingPageX.length>3&&($.rollingPageX.shift(),$.rollingPageY.shift(),$.rollingTimestamps.shift()),$.rollingPageX.push(g.pageX),$.rollingPageY.push(g.pageY),$.rollingTimestamps.push(h)}this.f&&(l.preventDefault(),l.stopPropagation(),this.f=!1)}}t.$UQ=y,Ye([j.$uh],y,"isTouchDevice",null)}),define(be[57],$e([1,0,3,92]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pR=t.$oR=t.$nR=void 0;const C=2e4;let n,j,E,k,m;function w(h){n=document.createElement("div"),n.className="monaco-aria-container";const e=()=>{const g=document.createElement("div");return g.className="monaco-alert",g.setAttribute("role","alert"),g.setAttribute("aria-atomic","true"),n.appendChild(g),g};j=e(),E=e();const s=()=>{const g=document.createElement("div");return g.className="monaco-status",g.setAttribute("aria-live","polite"),g.setAttribute("aria-atomic","true"),n.appendChild(g),g};k=s(),m=s(),h.appendChild(n)}t.$nR=w;function y(h){n&&(j.textContent!==h?(A.$kP(E),l(j,h)):(A.$kP(j),l(E,h)))}t.$oR=y;function L(h){n&&(k.textContent!==h?(A.$kP(m),l(k,h)):(A.$kP(k),l(m,h)))}t.$pR=L;function l(h,e){A.$kP(h),e.length>C&&(e=e.substr(0,C)),h.textContent=e,h.style.visibility="hidden",h.style.visibility="visible"}}),define(be[119],$e([1,0,3,18]),function(ie,t,A,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SR=t.$RR=void 0;const n=new RegExp(`(\\\\)?\\$\\((${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?)\\)`,"g");function j(k){const m=new Array;let w,y=0,L=0;for(;(w=n.exec(k))!==null;){L=w.index||0,y<L&&m.push(k.substring(y,L)),y=(w.index||0)+w[0].length;const[,l,h]=w;m.push(l?`$(${h})`:E({id:h}))}return y<k.length&&m.push(k.substring(y)),m}t.$RR=j;function E(k){const m=A.$("span");return m.classList.add(...C.ThemeIcon.asClassNameArray(k)),m}t.$SR=E}),define(be[120],$e([1,0,3]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yR=void 0;function C(j){try{j.parentElement?.removeChild(j)}catch{}}class n{constructor(E){this.d=E,this.a=new Map,this.b=new Set,this.c=!1}alloc(E){let k=this.h(E).pop(),m=!1;if(k)m=this.b.has(k.domNode),m&&this.b.delete(k.domNode);else{const w=(0,A.$)(".monaco-list-row"),L=this.i(E).renderTemplate(w);k={domNode:w,templateId:E,templateData:L}}return{row:k,isReusingConnectedDomNode:m}}release(E){E&&this.f(E)}transact(E){if(this.c)throw new Error("Already in transaction");this.c=!0;try{E()}finally{for(const k of this.b)this.g(k);this.b.clear(),this.c=!1}}f(E){const{domNode:k,templateId:m}=E;k&&(this.c?this.b.add(k):this.g(k)),this.h(m).push(E)}g(E){E.classList.remove("scrolling"),C(E)}h(E){let k=this.a.get(E);return k||(k=[],this.a.set(E,k)),k}dispose(){this.a.forEach((E,k)=>{for(const m of E)this.i(k).disposeTemplate(m.templateData),m.templateData=null}),this.a.clear(),this.b.clear()}i(E){const k=this.d.get(E);if(!k)throw new Error(`No renderer found for ${E}`);return k}}t.$yR=n}),define(be[121],$e([1,0,9,2]),function(ie,t,A,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3Q=void 0;class n extends C.$Sc{constructor(E,k,m){super(),this.a=E,this.b=k,this.c=m,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new A.$ah)}setVisibility(E){this.a!==E&&(this.a=E,this.s())}setShouldBeVisible(E){this.g=E,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const E=this.r();this.h!==E&&(this.h=E,this.ensureVisibility())}setIsNeeded(E){this.j!==E&&(this.j=E,this.ensureVisibility())}setDomNode(E){this.f=E,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(E){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(E?" fade":"")))}}t.$3Q=n}),define(be[122],$e([1,0,3,25,12,4,2,5]),function(ie,t,A,C,n,j,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZR=void 0;class m extends E.$Sc{constructor(y,L,l,h){super(),this.f=0,this.b=h||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new j.$Sd),this.h=l,this.j(),this.setOptions(y,L)}j(){this.B(C.$UQ.addTarget(this.a)),[C.EventType.Tap].forEach(y=>{this.B(A.$lP(this.a,y,L=>{this.a.focus()}))}),this.B(A.$mP(this.a,"click",y=>{A.$gQ.stop(y,!0)})),this.B(A.$mP(this.a,"change",y=>{this.a.title=y.target.value,this.g.fire({index:y.target.selectedIndex,selected:y.target.value})})),this.B(A.$mP(this.a,"keydown",y=>{let L=!1;k.$j?(y.keyCode===18||y.keyCode===16||y.keyCode===10)&&(L=!0):(y.keyCode===18&&y.altKey||y.keyCode===10||y.keyCode===3)&&(L=!0),L&&y.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(y,L){(!this.c||!n.$ub(this.c,y))&&(this.c=y,this.a.options.length=0,this.c.forEach((l,h)=>{this.a.add(this.m(l.text,h,l.isDisabled))})),L!==void 0&&this.select(L)}select(y){this.c.length===0?this.f=0:y>=0&&y<this.c.length?this.f=y:y>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(y){this.b.ariaLabel=y,this.a.setAttribute("aria-label",y)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(y){this.a.tabIndex=y?0:-1}render(y){y.classList.add("select-container"),y.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(y){this.h=y,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(y,L,l){const h=document.createElement("option");return h.value=y,h.text=y,h.disabled=!!l,h}}t.$ZR=m}),define(be[58],$e([1,0,26,12,9,50,87,4,28]),function(ie,t,A,C,n,j,E,k,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vT=t.$uT=t.$tT=void 0;function w(h){return typeof h=="object"&&"visibility"in h&&"data"in h}t.$tT=w;function y(h){switch(h){case!0:return 1;case!1:return 0;default:return h}}t.$uT=y;function L(h){return typeof h.collapsible=="boolean"}class l{constructor(e,s,g,$={}){this.o=e,this.p=s,this.rootRef=[],this.d=new k.$1d,this.f=new k.$Sd,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new k.$Sd,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new k.$Sd,this.onDidSplice=this.l.event,this.m=new n.$Zg(j.$Pd),this.h=typeof $.collapseByDefault>"u"?!1:$.collapseByDefault,this.j=$.filter,this.k=typeof $.autoExpandSingleChildren>"u"?!1:$.autoExpandSingleChildren,this.c={parent:void 0,element:g,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,s,g=m.Iterable.empty(),$={}){if(e.length===0)throw new A.$rT(this.o,"Invalid tree location");$.diffIdentityProvider?this.q($.diffIdentityProvider,e,s,g,$):this.s(e,s,g,$)}q(e,s,g,$=m.Iterable.empty(),o,a=o.diffDepth??0){const{parentNode:D}=this.G(s);if(!D.lastDiffIds)return this.s(s,g,$,o);const b=[...$],f=s[s.length-1],N=new E.$Os({getElements:()=>D.lastDiffIds},{getElements:()=>[...D.children.slice(0,f),...b,...D.children.slice(f+g)].map(M=>e.getId(M.element).toString())}).ComputeDiff(!1);if(N.quitEarly)return D.lastDiffIds=void 0,this.s(s,g,b,o);const O=s.slice(0,-1),T=(M,U,_)=>{if(a>0)for(let P=0;P<_;P++)M--,U--,this.q(e,[...O,M,0],Number.MAX_SAFE_INTEGER,b[U].children,o,a-1)};let p=Math.min(D.children.length,f+g),S=b.length;for(const M of N.changes.sort((U,_)=>_.originalStart-U.originalStart))T(p,S,p-(M.originalStart+M.originalLength)),p=M.originalStart,S=M.modifiedStart-f,this.s([...O,p],M.originalLength,m.Iterable.slice(b,S,S+M.modifiedLength),o);T(p,S,p)}s(e,s,g=m.Iterable.empty(),{onDidCreateNode:$,onDidDeleteNode:o,diffIdentityProvider:a}){const{parentNode:D,listIndex:b,revealed:f,visible:N}=this.G(e),O=[],T=m.Iterable.map(g,ue=>this.w(ue,D,D.visible?1:0,f,O,$)),p=e[e.length-1],S=D.children.length>0;let M=0;for(let ue=p;ue>=0&&ue<D.children.length;ue--){const ne=D.children[ue];if(ne.visible){M=ne.visibleChildIndex;break}}const U=[];let _=0,P=0;for(const ue of T)U.push(ue),P+=ue.renderNodeCount,ue.visible&&(ue.visibleChildIndex=M+_++);const I=(0,C.$6b)(D.children,p,s,U);a?D.lastDiffIds?(0,C.$6b)(D.lastDiffIds,p,s,U.map(ue=>a.getId(ue.element).toString())):D.lastDiffIds=D.children.map(ue=>a.getId(ue.element).toString()):D.lastDiffIds=void 0;let B=0;for(const ue of I)ue.visible&&B++;if(B!==0)for(let ue=p+U.length;ue<D.children.length;ue++){const ne=D.children[ue];ne.visible&&(ne.visibleChildIndex-=B)}if(D.visibleChildrenCount+=_-B,f&&N){const ue=I.reduce((ne,te)=>ne+(te.visible?te.renderNodeCount:0),0);this.B(D,P-ue),this.p.splice(b,ue,O)}if(I.length>0&&o){const ue=ne=>{o(ne),ne.children.forEach(ue)};I.forEach(ue)}this.l.fire({insertedNodes:U,deletedNodes:I});const X=D.children.length>0;S!==X&&this.setCollapsible(e.slice(0,-1),X);let Y=D;for(;Y;){if(Y.visibility===2){this.m.trigger(()=>this.refilter());break}Y=Y.parent}}rerender(e){if(e.length===0)throw new A.$rT(this.o,"Invalid tree location");const{node:s,listIndex:g,revealed:$}=this.F(e);s.visible&&$&&this.p.splice(g,1,[s])}updateElementHeight(e,s){if(e.length===0)throw new A.$rT(this.o,"Invalid tree location");const{listIndex:g}=this.F(e);this.p.updateElementHeight(g,s)}has(e){return this.D(e)}getListIndex(e){const{listIndex:s,visible:g,revealed:$}=this.F(e);return g&&$?s:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,s){const g=this.E(e);typeof s>"u"&&(s=!g.collapsible);const $={collapsible:s};return this.d.bufferEvents(()=>this.t(e,$))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,s,g){const $=this.E(e);typeof s>"u"&&(s=!$.collapsed);const o={collapsed:s,recursive:g||!1};return this.d.bufferEvents(()=>this.t(e,o))}t(e,s){const{node:g,listIndex:$,revealed:o}=this.F(e),a=this.u(g,$,o,s);if(g!==this.c&&this.k&&a&&!L(s)&&g.collapsible&&!g.collapsed&&!s.recursive){let D=-1;for(let b=0;b<g.children.length;b++)if(g.children[b].visible)if(D>-1){D=-1;break}else D=b;D>-1&&this.t([...e,D],s)}return a}u(e,s,g,$){const o=this.v(e,$,!1);if(!g||!e.visible||!o)return o;const a=e.renderNodeCount,D=this.x(e),b=a-(s===-1?0:1);return this.p.splice(s+1,b,D.slice(1)),o}v(e,s,g){let $;if(e===this.c?$=!1:(L(s)?($=e.collapsible!==s.collapsible,e.collapsible=s.collapsible):e.collapsible?($=e.collapsed!==s.collapsed,e.collapsed=s.collapsed):$=!1,$&&this.f.fire({node:e,deep:g})),!L(s)&&s.recursive)for(const o of e.children)$=this.v(o,s,!0)||$;return $}expandTo(e){this.d.bufferEvents(()=>{let s=this.E(e);for(;s.parent;)s=s.parent,e=e.slice(0,e.length-1),s.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,s=this.z(this.c);this.p.splice(0,e,s),this.m.cancel()}w(e,s,g,$,o,a){const D={parent:s,element:e.element,children:[],depth:s.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},b=this.C(D,g);D.visibility=b,$&&o.push(D);const f=e.children||m.Iterable.empty(),N=$&&b!==0&&!D.collapsed;let O=0,T=1;for(const p of f){const S=this.w(p,D,b,N,o,a);D.children.push(S),T+=S.renderNodeCount,S.visible&&(S.visibleChildIndex=O++)}return D.collapsible=D.collapsible||D.children.length>0,D.visibleChildrenCount=O,D.visible=b===2?O>0:b===1,D.visible?D.collapsed||(D.renderNodeCount=T):(D.renderNodeCount=0,$&&o.pop()),a?.(D),D}x(e){const s=e.renderNodeCount,g=[];return this.y(e,g),this.B(e.parent,g.length-s),g}y(e,s){if(e.visible===!1)return 0;if(s.push(e),e.renderNodeCount=1,!e.collapsed)for(const g of e.children)e.renderNodeCount+=this.y(g,s);return this.g.fire(e),e.renderNodeCount}z(e){const s=e.renderNodeCount,g=[];return this.A(e,e.visible?1:0,g),this.B(e.parent,g.length-s),g}A(e,s,g,$=!0){let o;if(e!==this.c){if(o=this.C(e,s),o===0)return e.visible=!1,e.renderNodeCount=0,!1;$&&g.push(e)}const a=g.length;e.renderNodeCount=e===this.c?0:1;let D=!1;if(!e.collapsed||o!==0){let b=0;for(const f of e.children)D=this.A(f,o,g,$&&!e.collapsed)||D,f.visible&&(f.visibleChildIndex=b++);e.visibleChildrenCount=b}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=o===2?D:o===1,e.visibility=o),e.visible?e.collapsed||(e.renderNodeCount+=g.length-a):(e.renderNodeCount=0,$&&g.pop()),this.g.fire(e),e.visible}B(e,s){if(s!==0)for(;e;)e.renderNodeCount+=s,this.g.fire(e),e=e.parent}C(e,s){const g=this.j?this.j.filter(e.element,s):1;return typeof g=="boolean"?(e.filterData=void 0,g?1:0):w(g)?(e.filterData=g.data,y(g.visibility)):(e.filterData=void 0,y(g))}D(e,s=this.c){if(!e||e.length===0)return!0;const[g,...$]=e;return g<0||g>s.children.length?!1:this.D($,s.children[g])}E(e,s=this.c){if(!e||e.length===0)return s;const[g,...$]=e;if(g<0||g>s.children.length)throw new A.$rT(this.o,"Invalid tree location");return this.E($,s.children[g])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:s,listIndex:g,revealed:$,visible:o}=this.G(e),a=e[e.length-1];if(a<0||a>s.children.length)throw new A.$rT(this.o,"Invalid tree location");const D=s.children[a];return{node:D,listIndex:g,revealed:$,visible:o&&D.visible}}G(e,s=this.c,g=0,$=!0,o=!0){const[a,...D]=e;if(a<0||a>s.children.length)throw new A.$rT(this.o,"Invalid tree location");for(let b=0;b<a;b++)g+=s.children[b].renderNodeCount;return $=$&&!s.collapsed,o=o&&s.visible,D.length===0?{parentNode:s,listIndex:g,revealed:$,visible:o}:this.G(D,s.children[a],g+1,$,o)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const s=[];let g=e;for(;g.parent;)s.push(g.parent.children.indexOf(g)),g=g.parent;return s.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,C.$tb)(e)[0]}getFirstElementChild(e){const s=this.E(e);if(s.children.length!==0)return s.children[0].element}getLastElementAncestor(e=[]){const s=this.E(e);if(s.children.length!==0)return this.H(s)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.$vT=l}),define(be[123],$e([1,0,58,26,28]),function(ie,t,A,C,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CT=void 0;class j{get size(){return this.d.size}constructor(k,m,w={}){this.k=k,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new A.$vT(k,m,null,w),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,w.sorter&&(this.j={compare(y,L){return w.sorter.compare(y.element,L.element)}}),this.h=w.identityProvider}setChildren(k,m=n.Iterable.empty(),w={}){const y=this.o(k);this.l(y,this.m(m),w)}l(k,m=n.Iterable.empty(),w){const y=new Set,L=new Set,l=e=>{if(e.element===null)return;const s=e;if(y.add(s.element),this.d.set(s.element,s),this.h){const g=this.h.getId(s.element).toString();L.add(g),this.f.set(g,s)}w.onDidCreateNode?.(s)},h=e=>{if(e.element===null)return;const s=e;if(y.has(s.element)||this.d.delete(s.element),this.h){const g=this.h.getId(s.element).toString();L.has(g)||this.f.delete(g)}w.onDidDeleteNode?.(s)};this.c.splice([...k,0],Number.MAX_VALUE,m,{...w,onDidCreateNode:l,onDidDeleteNode:h})}m(k=n.Iterable.empty()){return this.j&&(k=[...k].sort(this.j.compare.bind(this.j))),n.Iterable.map(k,m=>{let w=this.d.get(m.element);if(!w&&this.h){const l=this.h.getId(m.element).toString();w=this.f.get(l)}if(!w){let l;return typeof m.collapsed>"u"?l=void 0:m.collapsed===C.ObjectTreeElementCollapseState.Collapsed||m.collapsed===C.ObjectTreeElementCollapseState.PreserveOrCollapsed?l=!0:m.collapsed===C.ObjectTreeElementCollapseState.Expanded||m.collapsed===C.ObjectTreeElementCollapseState.PreserveOrExpanded?l=!1:l=!!m.collapsed,{...m,children:this.m(m.children),collapsed:l}}const y=typeof m.collapsible=="boolean"?m.collapsible:w.collapsible;let L;return typeof m.collapsed>"u"||m.collapsed===C.ObjectTreeElementCollapseState.PreserveOrCollapsed||m.collapsed===C.ObjectTreeElementCollapseState.PreserveOrExpanded?L=w.collapsed:m.collapsed===C.ObjectTreeElementCollapseState.Collapsed?L=!0:m.collapsed===C.ObjectTreeElementCollapseState.Expanded?L=!1:L=!!m.collapsed,{...m,collapsible:y,collapsed:L,children:this.m(m.children)}})}rerender(k){const m=this.o(k);this.c.rerender(m)}updateElementHeight(k,m){const w=this.o(k);this.c.updateElementHeight(w,m)}resort(k=null,m=!0){if(!this.j)return;const w=this.o(k),y=this.c.getNode(w);this.l(w,this.n(y,m),{})}n(k,m,w=!0){let y=[...k.children];return(m||w)&&(y=y.sort(this.j.compare.bind(this.j))),n.Iterable.map(y,L=>({element:L.element,collapsible:L.collapsible,collapsed:L.collapsed,children:this.n(L,m,!1)}))}getFirstElementChild(k=null){const m=this.o(k);return this.c.getFirstElementChild(m)}getLastElementAncestor(k=null){const m=this.o(k);return this.c.getLastElementAncestor(m)}has(k){return this.d.has(k)}getListIndex(k){const m=this.o(k);return this.c.getListIndex(m)}getListRenderCount(k){const m=this.o(k);return this.c.getListRenderCount(m)}isCollapsible(k){const m=this.o(k);return this.c.isCollapsible(m)}setCollapsible(k,m){const w=this.o(k);return this.c.setCollapsible(w,m)}isCollapsed(k){const m=this.o(k);return this.c.isCollapsed(m)}setCollapsed(k,m,w){const y=this.o(k);return this.c.setCollapsed(y,m,w)}expandTo(k){const m=this.o(k);this.c.expandTo(m)}refilter(){this.c.refilter()}getNode(k=null){if(k===null)return this.c.getNode(this.c.rootRef);const m=this.d.get(k);if(!m)throw new C.$rT(this.k,`Tree element not found: ${k}`);return m}getNodeLocation(k){return k.element}getParentNodeLocation(k){if(k===null)throw new C.$rT(this.k,"Invalid getParentNodeLocation call");const m=this.d.get(k);if(!m)throw new C.$rT(this.k,`Tree element not found: ${k}`);const w=this.c.getNodeLocation(m),y=this.c.getParentNodeLocation(w);return this.c.getNode(y).element}o(k){if(k===null)return[];const m=this.d.get(k);if(!m)throw new C.$rT(this.k,`Tree element not found: ${k}`);return this.c.getNodeLocation(m)}}t.$CT=j}),define(be[20],$e([1,0,3,14,19,25,2]),function(ie,t,A,C,n,j,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YQ=void 0;class k extends E.$Sc{f(w,y){this.B(A.$lP(w,A.$eQ.CLICK,L=>y(new n.$dP(A.getWindow(w),L))))}j(w,y){this.B(A.$lP(w,A.$eQ.MOUSE_DOWN,L=>y(new n.$dP(A.getWindow(w),L))))}m(w,y){this.B(A.$lP(w,A.$eQ.MOUSE_OVER,L=>y(new n.$dP(A.getWindow(w),L))))}u(w,y){this.B(A.$lP(w,A.$eQ.MOUSE_LEAVE,L=>y(new n.$dP(A.getWindow(w),L))))}z(w,y){this.B(A.$lP(w,A.$eQ.KEY_DOWN,L=>y(new C.$iP(L))))}C(w,y){this.B(A.$lP(w,A.$eQ.KEY_UP,L=>y(new C.$iP(L))))}D(w,y){this.B(A.$lP(w,A.$eQ.INPUT,y))}F(w,y){this.B(A.$lP(w,A.$eQ.BLUR,y))}G(w,y){this.B(A.$lP(w,A.$eQ.FOCUS,y))}H(w,y){this.B(A.$lP(w,A.$eQ.CHANGE,y))}I(w){return j.$UQ.ignoreTarget(w)}}t.$YQ=k}),define(be[38],$e([1,0,56,20,9,18,3]),function(ie,t,A,C,n,j,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1Q=t.$ZQ=void 0,t.$ZQ=11;class k extends C.$YQ{constructor(w){super(),this.a=w.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=w.bgWidth+"px",this.bgDomNode.style.height=w.bgHeight+"px",typeof w.top<"u"&&(this.bgDomNode.style.top="0px"),typeof w.left<"u"&&(this.bgDomNode.style.left="0px"),typeof w.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof w.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=w.className,this.domNode.classList.add(...j.ThemeIcon.asClassNameArray(w.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$ZQ+"px",this.domNode.style.height=t.$ZQ+"px",typeof w.top<"u"&&(this.domNode.style.top=w.top+"px"),typeof w.left<"u"&&(this.domNode.style.left=w.left+"px"),typeof w.bottom<"u"&&(this.domNode.style.bottom=w.bottom+"px"),typeof w.right<"u"&&(this.domNode.style.right=w.right+"px"),this.g=this.B(new A.$XQ),this.B(E.$mP(this.bgDomNode,E.$eQ.POINTER_DOWN,y=>this.h(y))),this.B(E.$mP(this.domNode,E.$eQ.POINTER_DOWN,y=>this.h(y))),this.b=this.B(new E.$xP),this.c=this.B(new n.$ah)}h(w){if(!w.target||!(w.target instanceof Element))return;const y=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,E.getWindow(w))};this.a(),this.b.cancel(),this.c.cancelAndSet(y,200),this.g.startMonitoring(w.target,w.pointerId,w.buttons,L=>{},()=>{this.b.cancel(),this.c.cancel()}),w.preventDefault()}}t.$1Q=k}),define(be[59],$e([1,0,3,41,56,38,121,20,5]),function(ie,t,A,C,n,j,E,k,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4Q=void 0;const w=140;class y extends k.$YQ{constructor(l){super(),this.g=l.lazyRender,this.a=l.host,this.b=l.scrollable,this.c=l.scrollByPage,this.h=l.scrollbarState,this.n=this.B(new E.$3Q(l.visibility,"visible scrollbar "+l.extraScrollbarClassName,"invisible scrollbar "+l.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new n.$XQ),this.s=!0,this.domNode=(0,C.$WQ)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(A.$lP(this.domNode.domNode,A.$eQ.POINTER_DOWN,h=>this.M(h)))}t(l){const h=this.B(new j.$1Q(l));this.domNode.domNode.appendChild(h.bgDomNode),this.domNode.domNode.appendChild(h.domNode)}w(l,h,e,s){this.slider=(0,C.$WQ)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(l),this.slider.setLeft(h),typeof e=="number"&&this.slider.setWidth(e),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(A.$lP(this.slider.domNode,A.$eQ.POINTER_DOWN,g=>{g.button===0&&(g.preventDefault(),this.O(g))})),this.f(this.slider.domNode,g=>{g.leftButton&&g.stopPropagation()})}y(l){return this.h.setVisibleSize(l)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(l){return this.h.setScrollSize(l)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(l){return this.h.setScrollPosition(l)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(l){l.target===this.domNode.domNode&&this.N(l)}delegatePointerDown(l){const h=this.domNode.domNode.getClientRects()[0].top,e=h+this.h.getSliderPosition(),s=h+this.h.getSliderPosition()+this.h.getSliderSize(),g=this.U(l);e<=g&&g<=s?l.button===0&&(l.preventDefault(),this.O(l)):this.N(l)}N(l){let h,e;if(l.target===this.domNode.domNode&&typeof l.offsetX=="number"&&typeof l.offsetY=="number")h=l.offsetX,e=l.offsetY;else{const g=A.$HP(this.domNode.domNode);h=l.pageX-g.left,e=l.pageY-g.top}const s=this.S(h,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(s):this.h.getDesiredScrollPositionFromOffset(s)),l.button===0&&(l.preventDefault(),this.O(l))}O(l){if(!l.target||!(l.target instanceof Element))return;const h=this.U(l),e=this.W(l),s=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(l.target,l.pointerId,l.buttons,g=>{const $=this.W(g),o=Math.abs($-e);if(m.$i&&o>w){this.P(s.getScrollPosition());return}const D=this.U(g)-h;this.P(s.getDesiredScrollPositionFromDelta(D))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(l){const h={};this.writeScrollPosition(h,l),this.b.setScrollPositionNow(h)}updateScrollbarSize(l){this.X(l),this.h.setScrollbarSize(l),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$4Q=y}),define(be[124],$e([1,0,19,59,38,42,17]),function(ie,t,A,C,n,j,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5Q=void 0;class k extends C.$4Q{constructor(w,y,L){const l=w.getScrollDimensions(),h=w.getCurrentScrollPosition();if(super({lazyRender:y.lazyRender,host:L,scrollbarState:new j.$2Q(y.horizontalHasArrows?y.arrowSize:0,y.horizontal===2?0:y.horizontalScrollbarSize,y.vertical===2?0:y.verticalScrollbarSize,l.width,l.scrollWidth,h.scrollLeft),visibility:y.horizontal,extraScrollbarClassName:"horizontal",scrollable:w,scrollByPage:y.scrollByPage}),y.horizontalHasArrows){const e=(y.arrowSize-n.$ZQ)/2,s=(y.horizontalScrollbarSize-n.$ZQ)/2;this.t({className:"scra",icon:E.$9j.scrollbarButtonLeft,top:s,left:e,bottom:void 0,right:void 0,bgWidth:y.arrowSize,bgHeight:y.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new A.$fP(null,1,0))}),this.t({className:"scra",icon:E.$9j.scrollbarButtonRight,top:s,left:void 0,bottom:void 0,right:e,bgWidth:y.arrowSize,bgHeight:y.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new A.$fP(null,-1,0))})}this.w(Math.floor((y.horizontalScrollbarSize-y.horizontalSliderSize)/2),0,void 0,y.horizontalSliderSize)}R(w,y){this.slider.setWidth(w),this.slider.setLeft(y)}Q(w,y){this.domNode.setWidth(w),this.domNode.setHeight(y),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(w){return this.s=this.J(w.scrollWidth)||this.s,this.s=this.L(w.scrollLeft)||this.s,this.s=this.y(w.width)||this.s,this.s}S(w,y){return w}U(w){return w.pageX}W(w){return w.pageY}X(w){this.slider.setHeight(w)}writeScrollPosition(w,y){w.scrollLeft=y}updateOptions(w){this.updateScrollbarSize(w.horizontal===2?0:w.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(w.vertical===2?0:w.verticalScrollbarSize),this.n.setVisibility(w.horizontal),this.c=w.scrollByPage}}t.$5Q=k}),define(be[125],$e([1,0,19,59,38,42,17]),function(ie,t,A,C,n,j,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6Q=void 0;class k extends C.$4Q{constructor(w,y,L){const l=w.getScrollDimensions(),h=w.getCurrentScrollPosition();if(super({lazyRender:y.lazyRender,host:L,scrollbarState:new j.$2Q(y.verticalHasArrows?y.arrowSize:0,y.vertical===2?0:y.verticalScrollbarSize,0,l.height,l.scrollHeight,h.scrollTop),visibility:y.vertical,extraScrollbarClassName:"vertical",scrollable:w,scrollByPage:y.scrollByPage}),y.verticalHasArrows){const e=(y.arrowSize-n.$ZQ)/2,s=(y.verticalScrollbarSize-n.$ZQ)/2;this.t({className:"scra",icon:E.$9j.scrollbarButtonUp,top:e,left:s,bottom:void 0,right:void 0,bgWidth:y.verticalScrollbarSize,bgHeight:y.arrowSize,onActivate:()=>this.a.onMouseWheel(new A.$fP(null,0,1))}),this.t({className:"scra",icon:E.$9j.scrollbarButtonDown,top:void 0,left:s,bottom:e,right:void 0,bgWidth:y.verticalScrollbarSize,bgHeight:y.arrowSize,onActivate:()=>this.a.onMouseWheel(new A.$fP(null,0,-1))})}this.w(0,Math.floor((y.verticalScrollbarSize-y.verticalSliderSize)/2),y.verticalSliderSize,void 0)}R(w,y){this.slider.setHeight(w),this.slider.setTop(y)}Q(w,y){this.domNode.setWidth(y),this.domNode.setHeight(w),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(w){return this.s=this.J(w.scrollHeight)||this.s,this.s=this.L(w.scrollTop)||this.s,this.s=this.y(w.height)||this.s,this.s}S(w,y){return y}U(w){return w.pageY}W(w){return w.pageX}X(w){this.slider.setWidth(w)}writeScrollPosition(w,y){w.scrollTop=y}updateOptions(w){this.updateScrollbarSize(w.vertical===2?0:w.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(w.vertical),this.c=w.scrollByPage}}t.$6Q=k}),define(be[60],$e([1,0,16,3,41,19,124,125,20,9,4,2,5,48,99]),function(ie,t,A,C,n,j,E,k,m,w,y,L,l,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$Q=t.$0Q=t.$9Q=t.$8Q=t.$7Q=void 0;const e=500,s=50,g=!0;class ${constructor(T,p,S){this.timestamp=T,this.deltaX=p,this.deltaY=S,this.score=0}}class o{static{this.INSTANCE=new o}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let T=1,p=0,S=1,M=this.d;do{const U=M===this.c?T:Math.pow(2,-S);if(T-=U,p+=this.b[M].score*U,M===this.c)break;M=(this.a+M-1)%this.a,S++}while(!0);return p<=.5}acceptStandardWheelEvent(T){const p=C.getWindow(T.browserEvent).devicePixelRatio/(0,A.$YO)();l.$i||l.$k?this.accept(Date.now(),T.deltaX/p,T.deltaY/p):this.accept(Date.now(),T.deltaX,T.deltaY)}accept(T,p,S){const M=new $(T,p,S);M.score=this.f(M),this.c===-1&&this.d===-1?(this.b[0]=M,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=M)}f(T){if(Math.abs(T.deltaX)>0&&Math.abs(T.deltaY)>0)return 1;let p=.5;const S=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(T.deltaX)||!this.g(T.deltaY))&&(p+=.25),Math.min(Math.max(p,0),1)}g(T){return Math.abs(Math.round(T)-T)<.01}}t.$7Q=o;class a extends m.$YQ{get options(){return this.a}constructor(T,p,S){super(),this.O=this.B(new y.$Sd),this.onScroll=this.O.event,this.P=this.B(new y.$Sd),this.onWillScroll=this.P.event,T.style.overflow="hidden",this.a=N(p),this.b=S,this.B(this.b.onScroll(U=>{this.P.fire(U),this.S(U),this.O.fire(U)}));const M={onMouseWheel:U=>this.R(U),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new k.$6Q(this.b,this.a,M)),this.g=this.B(new E.$5Q(this.b,this.a,M)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(T),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,n.$WQ)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,n.$WQ)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,n.$WQ)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,U=>this.Z(U)),this.u(this.t,U=>this.Y(U)),this.L=this.B(new w.$ah),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,L.$Nc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(T){this.c.delegatePointerDown(T)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(T){this.b.setScrollDimensions(T,!1)}updateClassName(T){this.a.className=T,l.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(T){typeof T.handleMouseWheel<"u"&&(this.a.handleMouseWheel=T.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof T.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=T.mouseWheelScrollSensitivity),typeof T.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=T.fastScrollSensitivity),typeof T.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=T.scrollPredominantAxis),typeof T.horizontal<"u"&&(this.a.horizontal=T.horizontal),typeof T.vertical<"u"&&(this.a.vertical=T.vertical),typeof T.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=T.horizontalScrollbarSize),typeof T.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=T.verticalScrollbarSize),typeof T.scrollByPage<"u"&&(this.a.scrollByPage=T.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(T){this.N=T}delegateScrollFromMouseWheelEvent(T){this.R(new j.$fP(T))}Q(T){if(this.w.length>0!==T&&(this.w=(0,L.$Nc)(this.w),T)){const S=M=>{this.R(new j.$fP(M))};this.w.push(C.$lP(this.t,C.$eQ.MOUSE_WHEEL,S,{passive:!1}))}}R(T){if(T.browserEvent?.defaultPrevented)return;const p=o.INSTANCE;g&&p.acceptStandardWheelEvent(T);let S=!1;if(T.deltaY||T.deltaX){let U=T.deltaY*this.a.mouseWheelScrollSensitivity,_=T.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&_+U===0?_=U=0:Math.abs(U)>=Math.abs(_)?_=0:U=0),this.a.flipAxes&&([U,_]=[_,U]);const P=!l.$j&&T.browserEvent&&T.browserEvent.shiftKey;(this.a.scrollYToX||P)&&!_&&(_=U,U=0),T.browserEvent&&T.browserEvent.altKey&&(_=_*this.a.fastScrollSensitivity,U=U*this.a.fastScrollSensitivity);const I=this.b.getFutureScrollPosition();let B={};if(U){const X=s*U,Y=I.scrollTop-(X<0?Math.floor(X):Math.ceil(X));this.c.writeScrollPosition(B,Y)}if(_){const X=s*_,Y=I.scrollLeft-(X<0?Math.floor(X):Math.ceil(X));this.g.writeScrollPosition(B,Y)}B=this.b.validateScrollPosition(B),(I.scrollLeft!==B.scrollLeft||I.scrollTop!==B.scrollTop)&&(g&&this.a.mouseWheelSmoothScroll&&p.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(B):this.b.setScrollPositionNow(B),S=!0)}let M=S;!M&&this.a.alwaysConsumeMouseWheel&&(M=!0),!M&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(M=!0),M&&(T.preventDefault(),T.stopPropagation())}S(T){this.M=this.g.onDidScroll(T)||this.M,this.M=this.c.onDidScroll(T)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const T=this.b.getCurrentScrollPosition(),p=T.scrollTop>0,S=T.scrollLeft>0,M=S?" left":"",U=p?" top":"",_=S||p?" top-left-corner":"";this.n.setClassName(`shadow${M}`),this.r.setClassName(`shadow${U}`),this.s.setClassName(`shadow${_}${U}${M}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(T){this.J=!1,this.ab()}Z(T){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$8Q=a;class D extends a{constructor(T,p){p=p||{},p.mouseWheelSmoothScroll=!1;const S=new h.$$r({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:M=>C.$vP(C.getWindow(T),M)});super(T,p,S),this.B(S)}setScrollPosition(T){this.b.setScrollPositionNow(T)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$9Q=D;class b extends a{constructor(T,p,S){super(T,p,S)}setScrollPosition(T){T.reuseAnimation?this.b.setScrollPositionSmooth(T,T.reuseAnimation):this.b.setScrollPositionNow(T)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$0Q=b;class f extends a{constructor(T,p){p=p||{},p.mouseWheelSmoothScroll=!1;const S=new h.$$r({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:M=>C.$vP(C.getWindow(T),M)});super(T,p,S),this.B(S),this.cb=T,this.B(this.onScroll(M=>{M.scrollTopChanged&&(this.cb.scrollTop=M.scrollTop),M.scrollLeftChanged&&(this.cb.scrollLeft=M.scrollLeft)})),this.scanDomNode()}setScrollPosition(T){this.b.setScrollPositionNow(T)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$$Q=f;function N(O){const T={lazyRender:typeof O.lazyRender<"u"?O.lazyRender:!1,className:typeof O.className<"u"?O.className:"",useShadows:typeof O.useShadows<"u"?O.useShadows:!0,handleMouseWheel:typeof O.handleMouseWheel<"u"?O.handleMouseWheel:!0,flipAxes:typeof O.flipAxes<"u"?O.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof O.consumeMouseWheelIfScrollbarIsNeeded<"u"?O.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof O.alwaysConsumeMouseWheel<"u"?O.alwaysConsumeMouseWheel:!1,scrollYToX:typeof O.scrollYToX<"u"?O.scrollYToX:!1,mouseWheelScrollSensitivity:typeof O.mouseWheelScrollSensitivity<"u"?O.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof O.fastScrollSensitivity<"u"?O.fastScrollSensitivity:5,scrollPredominantAxis:typeof O.scrollPredominantAxis<"u"?O.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof O.mouseWheelSmoothScroll<"u"?O.mouseWheelSmoothScroll:!0,arrowSize:typeof O.arrowSize<"u"?O.arrowSize:11,listenOnDomNode:typeof O.listenOnDomNode<"u"?O.listenOnDomNode:null,horizontal:typeof O.horizontal<"u"?O.horizontal:1,horizontalScrollbarSize:typeof O.horizontalScrollbarSize<"u"?O.horizontalScrollbarSize:10,horizontalSliderSize:typeof O.horizontalSliderSize<"u"?O.horizontalSliderSize:0,horizontalHasArrows:typeof O.horizontalHasArrows<"u"?O.horizontalHasArrows:!1,vertical:typeof O.vertical<"u"?O.vertical:1,verticalScrollbarSize:typeof O.verticalScrollbarSize<"u"?O.verticalScrollbarSize:10,verticalHasArrows:typeof O.verticalHasArrows<"u"?O.verticalHasArrows:!1,verticalSliderSize:typeof O.verticalSliderSize<"u"?O.verticalSliderSize:0,scrollByPage:typeof O.scrollByPage<"u"?O.scrollByPage:!1};return T.horizontalSliderSize=typeof O.horizontalSliderSize<"u"?O.horizontalSliderSize:T.horizontalScrollbarSize,T.verticalSliderSize=typeof O.verticalSliderSize<"u"?O.verticalSliderSize:T.verticalScrollbarSize,l.$j&&(T.className+=" mac"),T}}),define(be[61],$e([1,0,54,3,22,25,60,12,9,27,4,2,47,48,83,120,6]),function(ie,t,A,C,n,j,E,k,m,w,y,L,l,h,e,s,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CR=t.$BR=t.$AR=t.$zR=void 0;const $={CurrentDragAndDropData:void 0},o={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(T){return[T]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class a{get context(){return this.d}set context(p){this.d=p}constructor(p){this.elements=p}update(){}getData(){return this.elements}}t.$zR=a;class D{constructor(p){this.elements=p}update(){}getData(){return this.elements}}t.$AR=D;class b{constructor(){this.types=[],this.files=[]}update(p){if(p.types&&this.types.splice(0,this.types.length,...p.types),p.files){this.files.splice(0,this.files.length);for(let S=0;S<p.files.length;S++){const M=p.files.item(S);M&&(M.size||M.type)&&this.files.push(M)}}}getData(){return{types:this.types,files:this.files}}}t.$BR=b;function f(T,p){return Array.isArray(T)&&Array.isArray(p)?(0,k.$ub)(T,p):T===p}class N{constructor(p){p?.getSetSize?this.getSetSize=p.getSetSize.bind(p):this.getSetSize=(S,M,U)=>U,p?.getPosInSet?this.getPosInSet=p.getPosInSet.bind(p):this.getPosInSet=(S,M)=>M+1,p?.getRole?this.getRole=p.getRole.bind(p):this.getRole=S=>"listitem",p?.isChecked?this.isChecked=p.isChecked.bind(p):this.isChecked=S=>{}}}class O{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get P(){return this.O}set P(p){if(p!==this.O){if(p&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.O=p,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.O){for(const S of this.d)this.Y(S);this.V(),this.q.setScrollDimensions({width:(0,C.$KP)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(p,S,M,U=o){if(this.Q=S,this.domId=`list_id_${++O.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new m.$Zg(50),this.v=!1,this.x=L.$Sc.None,this.y=0,this.G=!1,this.J=L.$Sc.None,this.K=L.$Sc.None,this.L=new L.$Rc,this.M=new y.$Sd,this.N=new y.$Sd,this.onDidChangeContentHeight=y.Event.latch(this.M.event,void 0,this.L),this.onDidChangeContentWidth=y.Event.latch(this.N.event,void 0,this.L),this.O=!1,U.horizontalScrolling&&U.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.$xR(U.paddingTop??0);for(const P of M)this.j.set(P.templateId,P);this.h=this.L.add(new s.$yR(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof U.mouseSupport=="boolean"?U.mouseSupport:!0),this.O=U.horizontalScrolling??o.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.C=typeof U.paddingBottom>"u"?0:U.paddingBottom,this.D=new N(U.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(U.transformOptimization??o.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(j.$UQ.addTarget(this.o)),this.p=this.L.add(new h.$$r({forceIntegerValues:!0,smoothScrollDuration:U.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:P=>(0,C.$vP)((0,C.getWindow)(this.domNode),P)})),this.q=this.L.add(new E.$0Q(this.o,{alwaysConsumeMouseWheel:U.alwaysConsumeMouseWheel??o.alwaysConsumeMouseWheel,horizontal:1,vertical:U.verticalScrollMode??o.verticalScrollMode,useShadows:U.useShadows??o.useShadows,mouseWheelScrollSensitivity:U.mouseWheelScrollSensitivity,fastScrollSensitivity:U.fastScrollSensitivity,scrollByPage:U.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),p.appendChild(this.domNode),this.q.onScroll(this.gb,this,this.L),this.L.add((0,C.$lP)(this.o,j.EventType.Change,P=>this.hb(P))),this.L.add((0,C.$lP)(this.q.getDomNode(),"scroll",P=>P.target.scrollTop=0)),this.L.add((0,C.$lP)(this.domNode,"dragover",P=>this.jb(this.fb(P)))),this.L.add((0,C.$lP)(this.domNode,"drop",P=>this.lb(this.fb(P)))),this.L.add((0,C.$lP)(this.domNode,"dragleave",P=>this.kb(this.fb(P)))),this.L.add((0,C.$lP)(this.domNode,"dragend",P=>this.mb(P))),this.z=U.setRowLineHeight??o.setRowLineHeight,this.A=U.setRowHeight??o.setRowHeight,this.B=U.supportDynamicHeights??o.supportDynamicHeights,this.F=U.dnd??this.L.add(o.dnd),this.layout(U.initialSize?.height,U.initialSize?.width)}updateOptions(p){p.paddingBottom!==void 0&&(this.C=p.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),p.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(p.smoothScrolling?125:0),p.horizontalScrolling!==void 0&&(this.P=p.horizontalScrolling);let S;if(p.scrollByPage!==void 0&&(S={...S??{},scrollByPage:p.scrollByPage}),p.mouseWheelScrollSensitivity!==void 0&&(S={...S??{},mouseWheelScrollSensitivity:p.mouseWheelScrollSensitivity}),p.fastScrollSensitivity!==void 0&&(S={...S??{},fastScrollSensitivity:p.fastScrollSensitivity}),S&&this.q.updateOptions(S),p.paddingTop!==void 0&&p.paddingTop!==this.g.paddingTop){const M=this.sb(this.k,this.m),U=p.paddingTop-this.g.paddingTop;this.g.paddingTop=p.paddingTop,this.W(M,Math.max(0,this.k+U),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(p){this.q.delegateScrollFromMouseWheelEvent(p)}delegateVerticalScrollbarPointerDown(p){this.q.delegateVerticalScrollbarPointerDown(p)}updateElementHeight(p,S,M){if(p<0||p>=this.d.length)return;const U=this.d[p].size;if(typeof S>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[p].lastDynamicHeightWidth=void 0,S=U+this.ub(p)}if(U===S)return;const _=this.sb(this.k,this.m);let P=0;p<_.start||M!==null&&M>p&&M<_.end?P=S-U:P=0,this.g.splice(p,1,[{size:S}]),this.d[p].size=S,this.W(_,Math.max(0,this.k+P),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}splice(p,S,M=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.R(p,S,M)}finally{this.v=!1,this.M.fire(this.contentHeight)}}R(p,S,M=[]){const U=this.sb(this.k,this.m),_={start:p,end:p+S},P=l.Range.intersect(U,_),I=new Map;for(let H=P.end-1;H>=P.start;H--){const J=this.d[H];if(J.dragStartDisposable.dispose(),J.checkedDisposable.dispose(),J.row){let me=I.get(J.templateId);me||(me=[],I.set(J.templateId,me));const ve=this.j.get(J.templateId);ve&&ve.disposeElement&&ve.disposeElement(J.element,H,J.row.templateData,J.size),me.push(J.row)}J.row=null}const B={start:p+S,end:this.d.length},X=l.Range.intersect(B,U),Y=l.Range.relativeComplement(B,U),ue=M.map(H=>({id:String(this.f++),element:H,templateId:this.Q.getTemplateId(H),size:this.Q.getHeight(H),width:void 0,hasDynamicHeight:!!this.Q.hasDynamicHeight&&this.Q.hasDynamicHeight(H),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:L.$Sc.None,checkedDisposable:L.$Sc.None}));let ne;p===0&&S>=this.d.length?(this.g=new e.$xR(this.g.paddingTop),this.g.splice(0,0,ue),ne=this.d,this.d=ue):(this.g.splice(p,S,ue),ne=this.d.splice(p,S,...ue));const te=M.length-S,we=this.sb(this.k,this.m),Te=(0,e.$vR)(X,te),Pe=l.Range.intersect(we,Te);for(let H=Pe.start;H<Pe.end;H++)this.Z(this.d[H],H);const Oe=l.Range.relativeComplement(Te,we);for(const H of Oe)for(let J=H.start;J<H.end;J++)this.ab(J);const re=Y.map(H=>(0,e.$vR)(H,te)),ae=[{start:p,end:p+M.length},...re].map(H=>l.Range.intersect(we,H)),K=this.vb(ae);for(const H of ae)for(let J=H.start;J<H.end;J++){const me=this.d[J],Fe=I.get(me.templateId)?.pop();this.X(J,K,Fe)}for(const H of I.values())for(const J of H)this.h.release(J);return this.S(),this.B&&this.tb(this.scrollTop,this.renderHeight),ne.map(H=>H.element)}S(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,C.$vP)((0,C.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.V(),this.t=null}))}U(){if(!this.P){this.u.cancel();return}this.u.trigger(()=>this.V())}V(){if(!this.P)return;let p=0;for(const S of this.d)typeof S.width<"u"&&(p=Math.max(p,S.width));this.E=p,this.q.setScrollDimensions({scrollWidth:p===0?0:p+10}),this.N.fire(this.E)}updateWidth(p){if(!this.P||typeof this.E>"u")return;const S=this.d[p];this.Y(S),typeof S.width<"u"&&S.width>this.E&&(this.E=S.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.N.fire(this.E))}rerender(){if(this.B){for(const p of this.d)p.lastDynamicHeightWidth=void 0;this.tb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.sb(this.k,this.m).start}get firstMostlyVisibleIndex(){const p=this.firstVisibleIndex,S=this.g.positionAt(p),M=this.g.positionAt(p+1);return M!==-1&&(M-S)/2+S<this.scrollTop?p+1:p}get lastVisibleIndex(){return this.sb(this.k,this.m).end-1}element(p){return this.d[p].element}indexOf(p){return this.d.findIndex(S=>S.element===p)}domElement(p){const S=this.d[p].row;return S&&S.domNode}elementHeight(p){return this.d[p].size}elementTop(p){return this.g.positionAt(p)}indexAt(p){return this.g.indexAt(p)}indexAfter(p){return this.g.indexAfter(p)}layout(p,S){const M={height:typeof p=="number"?p:(0,C.$MP)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,M.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(M),typeof S<"u"&&(this.n=S,this.B&&this.tb(this.scrollTop,this.renderHeight)),this.P&&this.q.setScrollDimensions({width:typeof S=="number"?S:(0,C.$KP)(this.domNode)})}W(p,S,M,U,_,P=!1){const I=this.sb(S,M),B=l.Range.relativeComplement(I,p),X=l.Range.relativeComplement(p,I),Y=this.vb(B);if(P){const ue=l.Range.intersect(p,I);for(let ne=ue.start;ne<ue.end;ne++)this.Z(this.d[ne],ne)}this.h.transact(()=>{for(const ue of X)for(let ne=ue.start;ne<ue.end;ne++)this.ab(ne);for(const ue of B)for(let ne=ue.start;ne<ue.end;ne++)this.X(ne,Y)}),U!==void 0&&(this.o.style.left=`-${U}px`),this.o.style.top=`-${S}px`,this.P&&_!==void 0&&(this.o.style.width=`${Math.max(_,this.n)}px`),this.k=S,this.m=M}X(p,S,M){const U=this.d[p];let _=!1;if(!U.row)if(M)U.row=M;else{const Y=this.h.alloc(U.templateId);U.row=Y.row,_=Y.isReusingConnectedDomNode}const P=this.D.getRole(U.element)||"listitem";U.row.domNode.setAttribute("role",P);const I=this.D.isChecked(U.element);if(typeof I=="boolean")U.row.domNode.setAttribute("aria-checked",String(!!I));else if(I){const Y=ue=>U.row.domNode.setAttribute("aria-checked",String(!!ue));Y(I.value),U.checkedDisposable=I.onDidChange(Y)}(_||!U.row.domNode.parentElement)&&(S?this.o.insertBefore(U.row.domNode,S):this.o.appendChild(U.row.domNode)),this.Z(U,p);const B=this.j.get(U.templateId);if(!B)throw new Error(`No renderer found for template id ${U.templateId}`);B?.renderElement(U.element,p,U.row.templateData,U.size);const X=this.F.getDragURI(U.element);U.dragStartDisposable.dispose(),U.row.domNode.draggable=!!X,X&&(U.dragStartDisposable=(0,C.$lP)(U.row.domNode,"dragstart",Y=>this.ib(U.element,X,Y))),this.P&&(this.Y(U),this.U())}Y(p){if(!p.row||!p.row.domNode)return;p.row.domNode.style.width="fit-content",p.width=(0,C.$KP)(p.row.domNode);const S=(0,C.getWindow)(p.row.domNode).getComputedStyle(p.row.domNode);S.paddingLeft&&(p.width+=parseFloat(S.paddingLeft)),S.paddingRight&&(p.width+=parseFloat(S.paddingRight)),p.row.domNode.style.width=""}Z(p,S){p.row.domNode.style.top=`${this.elementTop(S)}px`,this.A&&(p.row.domNode.style.height=`${p.size}px`),this.z&&(p.row.domNode.style.lineHeight=`${p.size}px`),p.row.domNode.setAttribute("data-index",`${S}`),p.row.domNode.setAttribute("data-last-element",S===this.length-1?"true":"false"),p.row.domNode.setAttribute("data-parity",S%2===0?"even":"odd"),p.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(p.element,S,this.length))),p.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(p.element,S))),p.row.domNode.setAttribute("id",this.getElementDomId(S)),p.row.domNode.classList.toggle("drop-target",p.dropTarget)}ab(p){const S=this.d[p];if(S.dragStartDisposable.dispose(),S.checkedDisposable.dispose(),S.row){const M=this.j.get(S.templateId);M&&M.disposeElement&&M.disposeElement(S.element,p,S.row.templateData,S.size),this.h.release(S.row),S.row=null}this.P&&this.U()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(p,S){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:p,reuseAnimation:S})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(p){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:p})}get scrollTop(){return this.getScrollTop()}set scrollTop(p){this.setScrollTop(p)}get scrollHeight(){return this.s+(this.P?10:0)+this.C}get onMouseClick(){return y.Event.map(this.L.add(new n.$mR(this.domNode,"click")).event,p=>this.bb(p),this.L)}get onMouseDblClick(){return y.Event.map(this.L.add(new n.$mR(this.domNode,"dblclick")).event,p=>this.bb(p),this.L)}get onMouseMiddleClick(){return y.Event.filter(y.Event.map(this.L.add(new n.$mR(this.domNode,"auxclick")).event,p=>this.bb(p),this.L),p=>p.browserEvent.button===1,this.L)}get onMouseUp(){return y.Event.map(this.L.add(new n.$mR(this.domNode,"mouseup")).event,p=>this.bb(p),this.L)}get onMouseDown(){return y.Event.map(this.L.add(new n.$mR(this.domNode,"mousedown")).event,p=>this.bb(p),this.L)}get onMouseOver(){return y.Event.map(this.L.add(new n.$mR(this.domNode,"mouseover")).event,p=>this.bb(p),this.L)}get onMouseMove(){return y.Event.map(this.L.add(new n.$mR(this.domNode,"mousemove")).event,p=>this.bb(p),this.L)}get onMouseOut(){return y.Event.map(this.L.add(new n.$mR(this.domNode,"mouseout")).event,p=>this.bb(p),this.L)}get onContextMenu(){return y.Event.any(y.Event.map(this.L.add(new n.$mR(this.domNode,"contextmenu")).event,p=>this.bb(p),this.L),y.Event.map(this.L.add(new n.$mR(this.domNode,j.EventType.Contextmenu)).event,p=>this.eb(p),this.L))}get onTouchStart(){return y.Event.map(this.L.add(new n.$mR(this.domNode,"touchstart")).event,p=>this.db(p),this.L)}get onTap(){return y.Event.map(this.L.add(new n.$mR(this.o,j.EventType.Tap)).event,p=>this.eb(p),this.L)}bb(p){const S=this.rb(p.target||null),M=typeof S>"u"?void 0:this.d[S],U=M&&M.element;return{browserEvent:p,index:S,element:U}}db(p){const S=this.rb(p.target||null),M=typeof S>"u"?void 0:this.d[S],U=M&&M.element;return{browserEvent:p,index:S,element:U}}eb(p){const S=this.rb(p.initialTarget||null),M=typeof S>"u"?void 0:this.d[S],U=M&&M.element;return{browserEvent:p,index:S,element:U}}fb(p){const S=this.rb(p.target||null),M=typeof S>"u"?void 0:this.d[S],U=M&&M.element;return{browserEvent:p,index:S,element:U}}gb(p){try{const S=this.sb(this.k,this.m);this.W(S,p.scrollTop,p.height,p.scrollLeft,p.scrollWidth),this.B&&this.tb(p.scrollTop,p.height,p.inSmoothScrolling)}catch(S){throw console.error("Got bad scroll event:",p),S}}hb(p){p.preventDefault(),p.stopPropagation(),this.scrollTop-=p.translationY}ib(p,S,M){if(!M.dataTransfer)return;const U=this.F.getDragElements(p);if(M.dataTransfer.effectAllowed="copyMove",M.dataTransfer.setData(A.$SQ.TEXT,S),M.dataTransfer.setDragImage){let _;this.F.getDragLabel&&(_=this.F.getDragLabel(U,M)),typeof _>"u"&&(_=String(U.length));const P=(0,C.$)(".monaco-drag-image");P.textContent=_;const B=(X=>{for(;X&&!X.classList.contains("monaco-workbench");)X=X.parentElement;return X||this.domNode.ownerDocument})(this.domNode);B.appendChild(P),M.dataTransfer.setDragImage(P,-10,-10),setTimeout(()=>B.removeChild(P),0)}this.domNode.classList.add("dragging"),this.H=new a(U),$.CurrentDragAndDropData=new D(U),this.F.onDragStart?.(this.H,M)}jb(p){if(p.browserEvent.preventDefault(),this.K.dispose(),$.CurrentDragAndDropData&&$.CurrentDragAndDropData.getData()==="vscode-ui"||(this.ob(p.browserEvent),!p.browserEvent.dataTransfer))return!1;if(!this.H)if($.CurrentDragAndDropData)this.H=$.CurrentDragAndDropData;else{if(!p.browserEvent.dataTransfer.types)return!1;this.H=new b}const S=this.F.onDragOver(this.H,p.element,p.index,p.browserEvent);if(this.G=typeof S=="boolean"?S:S.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;p.browserEvent.dataTransfer.dropEffect=typeof S!="boolean"&&S.effect===0?"copy":"move";let M;if(typeof S!="boolean"&&S.feedback?M=S.feedback:typeof p.index>"u"?M=[-1]:M=[p.index],M=(0,k.$Mb)(M).filter(U=>U>=-1&&U<this.length).sort((U,_)=>U-_),M=M[0]===-1?[-1]:M,f(this.I,M))return!0;if(this.I=M,this.J.dispose(),M[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,L.$Qc)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const U of M){const _=this.d[U];_.dropTarget=!0,_.row?.domNode.classList.add("drop-target")}this.J=(0,L.$Qc)(()=>{for(const U of M){const _=this.d[U];_.dropTarget=!1,_.row?.domNode.classList.remove("drop-target")}})}return!0}kb(p){this.K.dispose(),this.K=(0,m.$5g)(()=>this.nb(),100,this.L),this.H&&this.F.onDragLeave?.(this.H,p.element,p.index,p.browserEvent)}lb(p){if(!this.G)return;const S=this.H;this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,$.CurrentDragAndDropData=void 0,!(!S||!p.browserEvent.dataTransfer)&&(p.browserEvent.preventDefault(),S.update(p.browserEvent.dataTransfer),this.F.drop(S,p.element,p.index,p.browserEvent))}mb(p){this.G=!1,this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,$.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(p)}nb(){this.I=void 0,this.J.dispose(),this.J=L.$Sc.None}ob(p){if(!this.w){const S=(0,C.$EP)(this.domNode).top;this.w=(0,C.$AQ)((0,C.getWindow)(this.domNode),this.pb.bind(this,S))}this.x.dispose(),this.x=(0,m.$5g)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.L),this.y=p.pageY}pb(p){if(this.y===void 0)return;const S=this.y-p,M=this.renderHeight-35;S<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(S-35))):S>M&&(this.scrollTop+=Math.min(14,Math.floor(.3*(S-M))))}qb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}rb(p){const S=this.q.getDomNode();let M=p;for(;M instanceof HTMLElement&&M!==this.o&&S.contains(M);){const U=M.getAttribute("data-index");if(U){const _=Number(U);if(!isNaN(_))return _}M=M.parentElement}}sb(p,S){return{start:this.g.indexAt(p),end:this.g.indexAfter(p+S-1)}}tb(p,S,M){const U=this.sb(p,S);let _,P;p===this.elementTop(U.start)?(_=U.start,P=0):U.end-U.start>1&&(_=U.start+1,P=this.elementTop(_)-p);let I=0;for(;;){const B=this.sb(p,S);let X=!1;for(let Y=B.start;Y<B.end;Y++){const ue=this.ub(Y);ue!==0&&this.g.splice(Y,1,[this.d[Y]]),I+=ue,X=X||ue!==0}if(!X){I!==0&&this.S();const Y=l.Range.relativeComplement(U,B);for(const ne of Y)for(let te=ne.start;te<ne.end;te++)this.d[te].row&&this.ab(te);const ue=l.Range.relativeComplement(B,U);for(const ne of ue)for(let te=ne.start;te<ne.end;te++){const we=te+1,Te=we<this.d.length?this.d[we].row:null,Pe=Te?Te.domNode:null;this.X(te,Pe)}for(let ne=B.start;ne<B.end;ne++)this.d[ne].row&&this.Z(this.d[ne],ne);if(typeof _=="number"){const ne=this.p.getFutureScrollPosition().scrollTop-p,te=this.elementTop(_)-P+ne;this.setScrollTop(te,M)}this.M.fire(this.contentHeight);return}}}ub(p){const S=this.d[p];if(this.Q.getDynamicHeight){const P=this.Q.getDynamicHeight(S.element);if(P!==null){const I=S.size;return S.size=P,S.lastDynamicHeightWidth=this.n,P-I}}if(!S.hasDynamicHeight||S.lastDynamicHeightWidth===this.n||this.Q.hasDynamicHeight&&!this.Q.hasDynamicHeight(S.element))return 0;const M=S.size;if(S.row)return S.row.domNode.style.height="",S.size=S.row.domNode.offsetHeight,S.lastDynamicHeightWidth=this.n,S.size-M;const{row:U}=this.h.alloc(S.templateId);U.domNode.style.height="",this.o.appendChild(U.domNode);const _=this.j.get(S.templateId);if(!_)throw new g.$cb("Missing renderer for templateId: "+S.templateId);return _.renderElement(S.element,p,U.templateData,void 0),S.size=U.domNode.offsetHeight,_.disposeElement?.(S.element,p,U.templateData,void 0),this.Q.setDynamicHeight?.(S.element,S.size),S.lastDynamicHeightWidth=this.n,this.o.removeChild(U.domNode),this.h.release(U),S.size-M}vb(p){const S=p[p.length-1];if(!S)return null;const M=this.d[S.end];return!M||!M.row?null:M.row.domNode}getElementDomId(p){return`${this.domId}_${p}`}dispose(){for(const p of this.d)if(p.dragStartDisposable.dispose(),p.checkedDisposable.dispose(),p.row){const S=this.j.get(p.row.templateId);S&&(S.disposeElement?.(p.element,-1,p.row.templateData,void 0),S.disposeTemplate(p.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.L.dispose()}}t.$CR=O,Ye([w.$uh],O.prototype,"onMouseClick",null),Ye([w.$uh],O.prototype,"onMouseDblClick",null),Ye([w.$uh],O.prototype,"onMouseMiddleClick",null),Ye([w.$uh],O.prototype,"onMouseUp",null),Ye([w.$uh],O.prototype,"onMouseDown",null),Ye([w.$uh],O.prototype,"onMouseOver",null),Ye([w.$uh],O.prototype,"onMouseMove",null),Ye([w.$uh],O.prototype,"onMouseOut",null),Ye([w.$uh],O.prototype,"onContextMenu",null),Ye([w.$uh],O.prototype,"onTouchStart",null),Ye([w.$uh],O.prototype,"onTap",null)}),define(be[39],$e([1,0,3,22,14,25,57,71,12,9,74,27,4,34,2,46,5,7,70,61,19,98]),function(ie,t,A,C,n,j,E,k,m,w,y,L,l,h,e,s,g,$,o,a,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QR=t.$PR=t.$OR=t.$NR=t.$MR=t.$LR=t.$KR=t.TypeNavigationMode=t.$JR=t.$IR=t.$HR=t.$GR=t.$FR=t.$ER=t.$DR=void 0;class b{constructor(v){this.d=v,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(v){return v}renderElement(v,i,r){const c=this.c.findIndex(u=>u.templateData===r);if(c>=0){const u=this.c[c];this.d.unrender(r),u.index=i}else{const u={index:i,templateData:r};this.c.push(u)}this.d.renderIndex(i,r)}splice(v,i,r){const c=[];for(const u of this.c)u.index<v?c.push(u):u.index>=v+i&&c.push({index:u.index+r-i,templateData:u.templateData});this.c=c}renderIndexes(v){for(const{index:i,templateData:r}of this.c)v.indexOf(i)>-1&&this.d.renderIndex(i,r)}disposeTemplate(v){const i=this.c.findIndex(r=>r.templateData===v);i<0||this.c.splice(i,1)}}class f{get name(){return this.h}get renderer(){return new b(this)}constructor(v){this.h=v,this.c=0,this.d=[],this.f=[],this.g=new l.$Sd,this.onChange=this.g.event}splice(v,i,r){i=Math.max(0,Math.min(i,this.c-v));const c=r.length-i,u=v+i,d=[];let F=0;for(;F<this.f.length&&this.f[F]<v;)d.push(this.f[F++]);for(let W=0;W<r.length;W++)r[W]&&d.push(W+v);for(;F<this.f.length&&this.f[F]>=u;)d.push(this.f[F++]+c);const R=this.c+c;if(this.f.length>0&&d.length===0&&R>0){const W=this.f.find(z=>z>=v)??R-1;d.push(Math.min(W,R-1))}this.renderer.splice(v,i,r.length),this.k(d,d),this.c=R}renderIndex(v,i){i.classList.toggle(this.h,this.contains(v))}unrender(v){v.classList.remove(this.h)}set(v,i){return this.k(v,[...v].sort(J),i)}k(v,i,r){const c=this.d,u=this.f;this.d=v,this.f=i;const d=K(u,v);return this.renderer.renderIndexes(d),this.g.fire({indexes:v,browserEvent:r}),c}get(){return this.d}contains(v){return(0,m.$wb)(this.f,v,J)>=0}dispose(){(0,e.$Nc)(this.g)}}Ye([L.$uh],f.prototype,"renderer",null);class N extends f{constructor(v){super("selected"),this.l=v}renderIndex(v,i){super.renderIndex(v,i),this.l&&(this.contains(v)?i.setAttribute("aria-selected","true"):i.setAttribute("aria-selected","false"))}}class O{constructor(v,i,r){this.c=v,this.d=i,this.f=r}splice(v,i,r){if(!this.f)return this.c.splice(v,i,new Array(r.length).fill(!1));const c=this.c.get().map(F=>this.f.getId(this.d.element(F)).toString());if(c.length===0)return this.c.splice(v,i,new Array(r.length).fill(!1));const u=new Set(c),d=r.map(F=>u.has(this.f.getId(F).toString()));this.c.splice(v,i,d)}}function T(ge){return ge.tagName==="INPUT"||ge.tagName==="TEXTAREA"}t.$DR=T;function p(ge,v){return ge.classList.contains(v)?!0:ge.classList.contains("monaco-list")||!ge.parentElement?!1:p(ge.parentElement,v)}function S(ge){return p(ge,"monaco-editor")}t.$ER=S;function M(ge){return p(ge,"monaco-custom-toggle")}t.$FR=M;function U(ge){return p(ge,"action-item")}t.$GR=U;function _(ge){return p(ge,"monaco-tl-twistie")}t.$HR=_;function P(ge){return p(ge,"monaco-tree-sticky-row")}t.$IR=P;function I(ge){return ge.tagName==="A"&&ge.classList.contains("monaco-button")||ge.tagName==="DIV"&&ge.classList.contains("monaco-button-dropdown")?!0:ge.classList.contains("monaco-list")||!ge.parentElement?!1:I(ge.parentElement)}t.$JR=I;class B{get g(){return l.Event.chain(this.c.add(new C.$mR(this.k.domNode,"keydown")).event,v=>v.filter(i=>!T(i.target)).map(i=>new n.$iP(i)))}constructor(v,i,r){this.h=v,this.k=i,this.c=new e.$Rc,this.d=new e.$Rc,this.f=r.multipleSelectionSupport,this.c.add(this.g(c=>{switch(c.keyCode){case 3:return this.l(c);case 16:return this.o(c);case 18:return this.p(c);case 11:return this.q(c);case 12:return this.s(c);case 9:return this.u(c);case 31:this.f&&(g.$j?c.metaKey:c.ctrlKey)&&this.t(c)}}))}updateOptions(v){v.multipleSelectionSupport!==void 0&&(this.f=v.multipleSelectionSupport)}l(v){v.preventDefault(),v.stopPropagation(),this.h.setSelection(this.h.getFocus(),v.browserEvent)}o(v){v.preventDefault(),v.stopPropagation(),this.h.focusPrevious(1,!1,v.browserEvent);const i=this.h.getFocus()[0];this.h.setAnchor(i),this.h.reveal(i),this.k.domNode.focus()}p(v){v.preventDefault(),v.stopPropagation(),this.h.focusNext(1,!1,v.browserEvent);const i=this.h.getFocus()[0];this.h.setAnchor(i),this.h.reveal(i),this.k.domNode.focus()}q(v){v.preventDefault(),v.stopPropagation(),this.h.focusPreviousPage(v.browserEvent);const i=this.h.getFocus()[0];this.h.setAnchor(i),this.h.reveal(i),this.k.domNode.focus()}s(v){v.preventDefault(),v.stopPropagation(),this.h.focusNextPage(v.browserEvent);const i=this.h.getFocus()[0];this.h.setAnchor(i),this.h.reveal(i),this.k.domNode.focus()}t(v){v.preventDefault(),v.stopPropagation(),this.h.setSelection((0,m.$Sb)(this.h.length),v.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(v){this.h.getSelection().length&&(v.preventDefault(),v.stopPropagation(),this.h.setSelection([],v.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Ye([L.$uh],B.prototype,"g",null);var X;(function(ge){ge[ge.Automatic=0]="Automatic",ge[ge.Trigger=1]="Trigger"})(X||(t.TypeNavigationMode=X={}));var Y;(function(ge){ge[ge.Idle=0]="Idle",ge[ge.Typing=1]="Typing"})(Y||(Y={})),t.$KR=new class{mightProducePrintableCharacter(ge){return ge.ctrlKey||ge.metaKey||ge.altKey?!1:ge.keyCode>=31&&ge.keyCode<=56||ge.keyCode>=21&&ge.keyCode<=30||ge.keyCode>=98&&ge.keyCode<=107||ge.keyCode>=85&&ge.keyCode<=95}};class ue{constructor(v,i,r,c,u){this.o=v,this.p=i,this.q=r,this.s=c,this.t=u,this.c=!1,this.d=Y.Idle,this.f=X.Automatic,this.g=!1,this.h=-1,this.k=new e.$Rc,this.l=new e.$Rc,this.updateOptions(v.options)}updateOptions(v){v.typeNavigationEnabled??!0?this.u():this.v(),this.f=v.typeNavigationMode??X.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let v=!1;const i=l.Event.chain(this.k.add(new C.$mR(this.p.domNode,"keydown")).event,u=>u.filter(d=>!T(d.target)).filter(()=>this.f===X.Automatic||this.g).map(d=>new n.$iP(d)).filter(d=>v||this.s(d)).filter(d=>this.t.mightProducePrintableCharacter(d)).forEach(d=>A.$gQ.stop(d,!0)).map(d=>d.browserEvent.key)),r=l.Event.debounce(i,()=>null,800,void 0,void 0,void 0,this.k);l.Event.reduce(l.Event.any(i,r),(u,d)=>d===null?null:(u||"")+d,void 0,this.k)(this.x,this,this.k),r(this.w,this,this.k),i(()=>v=!0,void 0,this.k),r(()=>v=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const v=this.o.getFocus();if(v.length>0&&v[0]===this.h){const i=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(v[0]));i&&(0,E.$oR)(i)}this.h=-1}x(v){if(!v){this.d=Y.Idle,this.g=!1;return}const i=this.o.getFocus(),r=i.length>0?i[0]:0,c=this.d===Y.Idle?1:0;this.d=Y.Typing;for(let u=0;u<this.o.length;u++){const d=(r+u+c)%this.o.length,F=this.q.getKeyboardNavigationLabel(this.p.element(d)),R=F&&F.toString();if(this.o.options.typeNavigationEnabled){if(typeof R<"u"){if((0,h.$Rj)(v,R)){this.h=r,this.o.setFocus([d]),this.o.reveal(d);return}const W=(0,h.$Yj)(v,R);if(W&&W[0].end-W[0].start>1&&W.length===1){this.h=r,this.o.setFocus([d]),this.o.reveal(d);return}}}else if(typeof R>"u"||(0,h.$Rj)(v,R)){this.h=r,this.o.setFocus([d]),this.o.reveal(d);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class ne{constructor(v,i){this.d=v,this.f=i,this.c=new e.$Rc;const r=l.Event.chain(this.c.add(new C.$mR(i.domNode,"keydown")).event,u=>u.filter(d=>!T(d.target)).map(d=>new n.$iP(d)));l.Event.chain(r,u=>u.filter(d=>d.keyCode===2&&!d.ctrlKey&&!d.metaKey&&!d.shiftKey&&!d.altKey))(this.g,this,this.c)}g(v){if(v.target!==this.f.domNode)return;const i=this.d.getFocus();if(i.length===0)return;const r=this.f.domElement(i[0]);if(!r)return;const c=r.querySelector("[tabIndex]");if(!c||!(c instanceof HTMLElement)||c.tabIndex===-1)return;const u=(0,A.getWindow)(c).getComputedStyle(c);u.visibility==="hidden"||u.display==="none"||(v.preventDefault(),v.stopPropagation(),c.focus())}dispose(){this.c.dispose()}}function te(ge){return g.$j?ge.browserEvent.metaKey:ge.browserEvent.ctrlKey}t.$LR=te;function we(ge){return ge.browserEvent.shiftKey}t.$MR=we;function Te(ge){return(0,A.$aQ)(ge)&&ge.button===2}const Pe={isSelectionSingleChangeEvent:te,isSelectionRangeChangeEvent:we};class Oe{constructor(v){this.k=v,this.f=new e.$Rc,this.g=new l.$Sd,this.onPointer=this.g.event,v.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||Pe),this.d=typeof v.options.mouseSupport>"u"||!!v.options.mouseSupport,this.d&&(v.onMouseDown(this.s,this,this.f),v.onContextMenu(this.t,this,this.f),v.onMouseDblClick(this.v,this,this.f),v.onTouchStart(this.s,this,this.f),this.f.add(j.$UQ.addTarget(v.getHTMLElement()))),l.Event.any(v.onMouseClick,v.onMouseMiddleClick,v.onTap)(this.u,this,this.f)}updateOptions(v){v.multipleSelectionSupport!==void 0&&(this.c=void 0,v.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||Pe))}o(v){return this.c?this.c.isSelectionSingleChangeEvent(v):!1}p(v){return this.c?this.c.isSelectionRangeChangeEvent(v):!1}q(v){return this.o(v)||this.p(v)}s(v){S(v.browserEvent.target)||(0,A.$XP)()!==v.browserEvent.target&&this.k.domFocus()}t(v){if(T(v.browserEvent.target)||S(v.browserEvent.target))return;const i=typeof v.index>"u"?[]:[v.index];this.k.setFocus(i,v.browserEvent)}u(v){if(!this.d||T(v.browserEvent.target)||S(v.browserEvent.target)||v.browserEvent.isHandledByList)return;v.browserEvent.isHandledByList=!0;const i=v.index;if(typeof i>"u"){this.k.setFocus([],v.browserEvent),this.k.setSelection([],v.browserEvent),this.k.setAnchor(void 0);return}if(this.q(v))return this.w(v);this.k.setFocus([i],v.browserEvent),this.k.setAnchor(i),Te(v.browserEvent)||this.k.setSelection([i],v.browserEvent),this.g.fire(v)}v(v){if(T(v.browserEvent.target)||S(v.browserEvent.target)||this.q(v)||v.browserEvent.isHandledByList)return;v.browserEvent.isHandledByList=!0;const i=this.k.getFocus();this.k.setSelection(i,v.browserEvent)}w(v){const i=v.index;let r=this.k.getAnchor();if(this.p(v)){typeof r>"u"&&(r=this.k.getFocus()[0]??i,this.k.setAnchor(r));const c=Math.min(r,i),u=Math.max(r,i),d=(0,m.$Sb)(c,u+1),F=this.k.getSelection(),R=ae(K(F,[r]),r);if(R.length===0)return;const W=K(d,H(F,R));this.k.setSelection(W,v.browserEvent),this.k.setFocus([i],v.browserEvent)}else if(this.o(v)){const c=this.k.getSelection(),u=c.filter(d=>d!==i);this.k.setFocus([i]),this.k.setAnchor(i),c.length===u.length?this.k.setSelection([...u,i],v.browserEvent):this.k.setSelection(u,v.browserEvent)}}dispose(){this.f.dispose()}}t.$NR=Oe;class re{constructor(v,i){this.c=v,this.d=i}style(v){const i=this.d&&`.${this.d}`,r=[];v.listBackground&&r.push(`.monaco-list${i} .monaco-list-rows { background: ${v.listBackground}; }`),v.listFocusBackground&&(r.push(`.monaco-list${i}:focus .monaco-list-row.focused { background-color: ${v.listFocusBackground}; }`),r.push(`.monaco-list${i}:focus .monaco-list-row.focused:hover { background-color: ${v.listFocusBackground}; }`)),v.listFocusForeground&&r.push(`.monaco-list${i}:focus .monaco-list-row.focused { color: ${v.listFocusForeground}; }`),v.listActiveSelectionBackground&&(r.push(`.monaco-list${i}:focus .monaco-list-row.selected { background-color: ${v.listActiveSelectionBackground}; }`),r.push(`.monaco-list${i}:focus .monaco-list-row.selected:hover { background-color: ${v.listActiveSelectionBackground}; }`)),v.listActiveSelectionForeground&&r.push(`.monaco-list${i}:focus .monaco-list-row.selected { color: ${v.listActiveSelectionForeground}; }`),v.listActiveSelectionIconForeground&&r.push(`.monaco-list${i}:focus .monaco-list-row.selected .codicon { color: ${v.listActiveSelectionIconForeground}; }`),v.listFocusAndSelectionBackground&&r.push(`
				.monaco-drag-image,
				.monaco-list${i}:focus .monaco-list-row.selected.focused { background-color: ${v.listFocusAndSelectionBackground}; }
			`),v.listFocusAndSelectionForeground&&r.push(`
				.monaco-drag-image,
				.monaco-list${i}:focus .monaco-list-row.selected.focused { color: ${v.listFocusAndSelectionForeground}; }
			`),v.listInactiveFocusForeground&&(r.push(`.monaco-list${i} .monaco-list-row.focused { color:  ${v.listInactiveFocusForeground}; }`),r.push(`.monaco-list${i} .monaco-list-row.focused:hover { color:  ${v.listInactiveFocusForeground}; }`)),v.listInactiveSelectionIconForeground&&r.push(`.monaco-list${i} .monaco-list-row.focused .codicon { color:  ${v.listInactiveSelectionIconForeground}; }`),v.listInactiveFocusBackground&&(r.push(`.monaco-list${i} .monaco-list-row.focused { background-color:  ${v.listInactiveFocusBackground}; }`),r.push(`.monaco-list${i} .monaco-list-row.focused:hover { background-color:  ${v.listInactiveFocusBackground}; }`)),v.listInactiveSelectionBackground&&(r.push(`.monaco-list${i} .monaco-list-row.selected { background-color:  ${v.listInactiveSelectionBackground}; }`),r.push(`.monaco-list${i} .monaco-list-row.selected:hover { background-color:  ${v.listInactiveSelectionBackground}; }`)),v.listInactiveSelectionForeground&&r.push(`.monaco-list${i} .monaco-list-row.selected { color: ${v.listInactiveSelectionForeground}; }`),v.listHoverBackground&&r.push(`.monaco-list${i}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${v.listHoverBackground}; }`),v.listHoverForeground&&r.push(`.monaco-list${i}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${v.listHoverForeground}; }`);const c=(0,A.$DQ)(v.listFocusAndSelectionOutline,(0,A.$DQ)(v.listSelectionOutline,v.listFocusOutline??""));c&&r.push(`.monaco-list${i}:focus .monaco-list-row.focused.selected { outline: 1px solid ${c}; outline-offset: -1px;}`),v.listFocusOutline&&r.push(`
				.monaco-drag-image,
				.monaco-list${i}:focus .monaco-list-row.focused { outline: 1px solid ${v.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${i}.last-focused .monaco-list-row.focused { outline: 1px solid ${v.listFocusOutline}; outline-offset: -1px; }
			`);const u=(0,A.$DQ)(v.listSelectionOutline,v.listInactiveFocusOutline??"");u&&r.push(`.monaco-list${i} .monaco-list-row.focused.selected { outline: 1px dotted ${u}; outline-offset: -1px; }`),v.listSelectionOutline&&r.push(`.monaco-list${i} .monaco-list-row.selected { outline: 1px dotted ${v.listSelectionOutline}; outline-offset: -1px; }`),v.listInactiveFocusOutline&&r.push(`.monaco-list${i} .monaco-list-row.focused { outline: 1px dotted ${v.listInactiveFocusOutline}; outline-offset: -1px; }`),v.listHoverOutline&&r.push(`.monaco-list${i} .monaco-list-row:hover { outline: 1px dashed ${v.listHoverOutline}; outline-offset: -1px; }`),v.listDropBackground&&r.push(`
				.monaco-list${i}.drop-target,
				.monaco-list${i} .monaco-list-rows.drop-target,
				.monaco-list${i} .monaco-list-row.drop-target { background-color: ${v.listDropBackground} !important; color: inherit !important; }
			`),v.tableColumnsBorder&&r.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${v.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),v.tableOddRowsBackgroundColor&&r.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${v.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=r.join(`
`)}}t.$OR=re,t.$PR={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropBackground:"#383B3D",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:y.$at.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:y.$at.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:y.$at.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const Z={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function ae(ge,v){const i=ge.indexOf(v);if(i===-1)return[];const r=[];let c=i-1;for(;c>=0&&ge[c]===v-(i-c);)r.push(ge[c--]);for(r.reverse(),c=i;c<ge.length&&ge[c]===v+(c-i);)r.push(ge[c++]);return r}function K(ge,v){const i=[];let r=0,c=0;for(;r<ge.length||c<v.length;)if(r>=ge.length)i.push(v[c++]);else if(c>=v.length)i.push(ge[r++]);else if(ge[r]===v[c]){i.push(ge[r]),r++,c++;continue}else ge[r]<v[c]?i.push(ge[r++]):i.push(v[c++]);return i}function H(ge,v){const i=[];let r=0,c=0;for(;r<ge.length||c<v.length;)if(r>=ge.length)i.push(v[c++]);else if(c>=v.length)i.push(ge[r++]);else if(ge[r]===v[c]){r++,c++;continue}else ge[r]<v[c]?i.push(ge[r++]):c++;return i}const J=(ge,v)=>ge-v;class me{constructor(v,i){this.c=v,this.d=i}get templateId(){return this.c}renderTemplate(v){return this.d.map(i=>i.renderTemplate(v))}renderElement(v,i,r,c){let u=0;for(const d of this.d)d.renderElement(v,i,r[u++],c)}disposeElement(v,i,r,c){let u=0;for(const d of this.d)d.disposeElement?.(v,i,r[u],c),u+=1}disposeTemplate(v){let i=0;for(const r of this.d)r.disposeTemplate(v[i++])}}class ve{constructor(v){this.c=v,this.templateId="a18n"}renderTemplate(v){return v}renderElement(v,i,r){const c=this.c.getAriaLabel(v);c?r.setAttribute("aria-label",c):r.removeAttribute("aria-label");const u=this.c.getAriaLevel&&this.c.getAriaLevel(v);typeof u=="number"?r.setAttribute("aria-level",`${u}`):r.removeAttribute("aria-level")}disposeTemplate(v){}}class Fe{constructor(v,i){this.c=v,this.d=i}getDragElements(v){const i=this.c.getSelectedElements();return i.indexOf(v)>-1?i:[v]}getDragURI(v){return this.d.getDragURI(v)}getDragLabel(v,i){if(this.d.getDragLabel)return this.d.getDragLabel(v,i)}onDragStart(v,i){this.d.onDragStart?.(v,i)}onDragOver(v,i,r,c){return this.d.onDragOver(v,i,r,c)}onDragLeave(v,i,r,c){this.d.onDragLeave?.(v,i,r,c)}onDragEnd(v){this.d.onDragEnd?.(v)}drop(v,i,r,c){this.d.drop(v,i,r,c)}dispose(){this.d.dispose()}}class Ae{get onDidChangeFocus(){return l.Event.map(this.g.wrapEvent(this.c.onChange),v=>this.G(v),this.y)}get onDidChangeSelection(){return l.Event.map(this.g.wrapEvent(this.d.onChange),v=>this.G(v),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let v=!1;const i=l.Event.chain(this.y.add(new C.$mR(this.k.domNode,"keydown")).event,u=>u.map(d=>new n.$iP(d)).filter(d=>v=d.keyCode===58||d.shiftKey&&d.keyCode===68).map(d=>A.$gQ.stop(d,!0)).filter(()=>!1)),r=l.Event.chain(this.y.add(new C.$mR(this.k.domNode,"keyup")).event,u=>u.forEach(()=>v=!1).map(d=>new n.$iP(d)).filter(d=>d.keyCode===58||d.shiftKey&&d.keyCode===68).map(d=>A.$gQ.stop(d,!0)).map(({browserEvent:d})=>{const F=this.getFocus(),R=F.length?F[0]:void 0,W=typeof R<"u"?this.k.element(R):void 0,z=typeof R<"u"?this.k.domElement(R):this.k.domNode;return{index:R,element:W,anchor:z,browserEvent:d}})),c=l.Event.chain(this.k.onContextMenu,u=>u.filter(d=>!v).map(({element:d,index:F,browserEvent:R})=>({element:d,index:F,anchor:new D.$dP((0,A.getWindow)(this.k.domNode),R),browserEvent:R})));return l.Event.any(i,r,c)}get onKeyDown(){return this.y.add(new C.$mR(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new C.$mR(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new C.$mR(this.k.domNode,"keypress")).event}get onDidFocus(){return l.Event.signal(this.y.add(new C.$mR(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return l.Event.signal(this.y.add(new C.$mR(this.k.domNode,"blur",!0)).event)}constructor(v,i,r,c,u=Z){this.A=v,this.B=u,this.c=new f("focused"),this.f=new f("anchor"),this.g=new l.$1d,this.x="",this.y=new e.$Rc,this.z=new l.$Sd,this.onDidDispose=this.z.event;const d=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new N(d!=="listbox");const F=[this.c.renderer,this.d.renderer];this.u=u.accessibilityProvider,this.u&&(F.push(new ve(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),c=c.map(W=>new me(W.templateId,[...F,W]));const R={...u,dnd:u.dnd&&new Fe(this,u.dnd)};if(this.k=this.C(i,r,c,R),this.k.domNode.setAttribute("role",d),u.styleController)this.q=u.styleController(this.k.domId);else{const W=(0,A.$6P)(this.k.domNode);this.q=new re(W,this.k.domId)}if(this.o=new k.$qR([new O(this.c,this.k,u.identityProvider),new O(this.d,this.k,u.identityProvider),new O(this.f,this.k,u.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new ne(this,this.k)),(typeof u.keyboardSupport!="boolean"||u.keyboardSupport)&&(this.v=new B(this,this.k,u),this.y.add(this.v)),u.keyboardNavigationLabelProvider){const W=u.keyboardNavigationDelegate||t.$KR;this.t=new ue(this,this.k,u.keyboardNavigationLabelProvider,u.keyboardNavigationEventFilter??(()=>!0),W),this.y.add(this.t)}this.w=this.D(u),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(v,i,r,c){return new a.$CR(v,i,r,c)}D(v){return new Oe(this)}updateOptions(v={}){this.B={...this.B,...v},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(v),this.v?.updateOptions(v),this.k.updateOptions(v)}get options(){return this.B}splice(v,i,r=[]){if(v<0||v>this.k.length)throw new o.$sR(this.A,`Invalid start index: ${v}`);if(i<0)throw new o.$sR(this.A,`Invalid delete count: ${i}`);i===0&&r.length===0||this.g.bufferEvents(()=>this.o.splice(v,i,r))}updateWidth(v){this.k.updateWidth(v)}updateElementHeight(v,i){this.k.updateElementHeight(v,i,null)}rerender(){this.k.rerender()}element(v){return this.k.element(v)}indexOf(v){return this.k.indexOf(v)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(v){this.k.setScrollTop(v)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(v){this.k.setScrollLeft(v)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(v){this.x=v,this.k.domNode.setAttribute("aria-label",v)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(v,i){this.k.layout(v,i)}triggerTypeNavigation(){this.t?.trigger()}setSelection(v,i){for(const r of v)if(r<0||r>=this.length)throw new o.$sR(this.A,`Invalid index ${r}`);this.d.set(v,i)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(v=>this.k.element(v))}setAnchor(v){if(typeof v>"u"){this.f.set([]);return}if(v<0||v>=this.length)throw new o.$sR(this.A,`Invalid index ${v}`);this.f.set([v])}getAnchor(){return(0,m.$Ob)(this.f.get(),void 0)}getAnchorElement(){const v=this.getAnchor();return typeof v>"u"?void 0:this.element(v)}setFocus(v,i){for(const r of v)if(r<0||r>=this.length)throw new o.$sR(this.A,`Invalid index ${r}`);this.c.set(v,i)}focusNext(v=1,i=!1,r,c){if(this.length===0)return;const u=this.c.get(),d=this.E(u.length>0?u[0]+v:0,i,c);d>-1&&this.setFocus([d],r)}focusPrevious(v=1,i=!1,r,c){if(this.length===0)return;const u=this.c.get(),d=this.F(u.length>0?u[0]-v:0,i,c);d>-1&&this.setFocus([d],r)}async focusNextPage(v,i){let r=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);r=r===0?0:r-1;const c=this.getFocus()[0];if(c!==r&&(c===void 0||r>c)){const u=this.F(r,!1,i);u>-1&&c!==u?this.setFocus([u],v):this.setFocus([r],v)}else{const u=this.k.getScrollTop();let d=u+this.k.renderHeight;r>c&&(d-=this.k.elementHeight(r)),this.k.setScrollTop(d),this.k.getScrollTop()!==u&&(this.setFocus([]),await(0,w.$4g)(0),await this.focusNextPage(v,i))}}async focusPreviousPage(v,i){let r;const c=this.k.getScrollTop();c===0?r=this.k.indexAt(c):r=this.k.indexAfter(c-1);const u=this.getFocus()[0];if(u!==r&&(u===void 0||u>=r)){const d=this.E(r,!1,i);d>-1&&u!==d?this.setFocus([d],v):this.setFocus([r],v)}else{const d=c;this.k.setScrollTop(c-this.k.renderHeight),this.k.getScrollTop()!==d&&(this.setFocus([]),await(0,w.$4g)(0),await this.focusPreviousPage(v,i))}}focusLast(v,i){if(this.length===0)return;const r=this.F(this.length-1,!1,i);r>-1&&this.setFocus([r],v)}focusFirst(v,i){this.focusNth(0,v,i)}focusNth(v,i,r){if(this.length===0)return;const c=this.E(v,!1,r);c>-1&&this.setFocus([c],i)}E(v,i=!1,r){for(let c=0;c<this.length;c++){if(v>=this.length&&!i)return-1;if(v=v%this.length,!r||r(this.element(v)))return v;v++}return-1}F(v,i=!1,r){for(let c=0;c<this.length;c++){if(v<0&&!i)return-1;if(v=(this.length+v%this.length)%this.length,!r||r(this.element(v)))return v;v--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(v=>this.k.element(v))}reveal(v,i,r=0){if(v<0||v>=this.length)throw new o.$sR(this.A,`Invalid index ${v}`);const c=this.k.getScrollTop(),u=this.k.elementTop(v),d=this.k.elementHeight(v);if((0,$.$Jf)(i)){const F=d-this.k.renderHeight+r;this.k.setScrollTop(F*(0,s.$4l)(i,0,1)+u-r)}else{const F=u+d,R=c+this.k.renderHeight;u<c+r&&F>=R||(u<c+r||F>=R&&d>=this.k.renderHeight?this.k.setScrollTop(u-r):F>=R&&this.k.setScrollTop(F-this.k.renderHeight))}}getRelativeTop(v,i=0){if(v<0||v>=this.length)throw new o.$sR(this.A,`Invalid index ${v}`);const r=this.k.getScrollTop(),c=this.k.elementTop(v),u=this.k.elementHeight(v);if(c<r+i||c+u>r+this.k.renderHeight)return null;const d=u-this.k.renderHeight+i;return Math.abs((r+i-c)/d)}isDOMFocused(){return(0,A.$YP)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(v){return this.k.getElementDomId(v)}getElementTop(v){return this.k.elementTop(v)}style(v){this.q.style(v)}G({indexes:v,browserEvent:i}){return{indexes:v,elements:v.map(r=>this.k.element(r)),browserEvent:i}}H(){const v=this.c.get();this.k.domNode.classList.toggle("element-focused",v.length>0),this.I()}I(){const v=this.c.get();if(v.length>0){let i;this.u?.getActiveDescendantId&&(i=this.u.getActiveDescendantId(this.k.element(v[0]))),this.k.domNode.setAttribute("aria-activedescendant",i||this.k.getElementDomId(v[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const v=this.d.get();this.k.domNode.classList.toggle("selection-none",v.length===0),this.k.domNode.classList.toggle("selection-single",v.length===1),this.k.domNode.classList.toggle("selection-multiple",v.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$QR=Ae,Ye([L.$uh],Ae.prototype,"onDidChangeFocus",null),Ye([L.$uh],Ae.prototype,"onDidChangeSelection",null),Ye([L.$uh],Ae.prototype,"onContextMenu",null),Ye([L.$uh],Ae.prototype,"onKeyDown",null),Ye([L.$uh],Ae.prototype,"onKeyUp",null),Ye([L.$uh],Ae.prototype,"onKeyPress",null),Ye([L.$uh],Ae.prototype,"onDidFocus",null),Ye([L.$uh],Ae.prototype,"onDidBlur",null)}),define(be[62],$e([1,0,6,35,37,10,15]),function(ie,t,A,C,n,j,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mk=t.$lk=t.$kk=t.$jk=t.$ik=t.$hk=t.$gk=t.$fk=t.$ek=t.MarkdownStringTextNewlineStyle=void 0;var k;(function($){$[$.Paragraph=0]="Paragraph",$[$.Break=1]="Break"})(k||(t.MarkdownStringTextNewlineStyle=k={}));class m{constructor(o="",a=!1){if(this.value=o,typeof this.value!="string")throw(0,A.$7)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1,this.supportHtml=a.supportHtml??!1)}appendText(o,a=0){return this.value+=l(this.supportThemeIcons?(0,C.$$j)(o):o).replace(/([ \t]+)/g,(D,b)=>"&nbsp;".repeat(b.length)).replace(/\>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(o){return this.value+=o,this}appendCodeblock(o,a){return this.value+=`
${h(a,o)}
`,this}appendLink(o,a,D){return this.value+="[",this.value+=this.c(a,"]"),this.value+="](",this.value+=this.c(String(o),")"),D&&(this.value+=` "${this.c(this.c(D,'"'),")")}"`),this.value+=")",this}c(o,a){const D=new RegExp((0,j.$Le)(a),"g");return o.replace(D,(b,f)=>o.charAt(f-1)!=="\\"?`\\${b}`:b)}}t.$ek=m;function w($){return y($)?!$.value:Array.isArray($)?$.every(w):!0}t.$fk=w;function y($){return $ instanceof m?!0:$&&typeof $=="object"?typeof $.value=="string"&&(typeof $.isTrusted=="boolean"||typeof $.isTrusted=="object"||$.isTrusted===void 0)&&(typeof $.supportThemeIcons=="boolean"||$.supportThemeIcons===void 0):!1}t.$gk=y;function L($,o){return $===o?!0:!$||!o?!1:$.value===o.value&&$.isTrusted===o.isTrusted&&$.supportThemeIcons===o.supportThemeIcons&&$.supportHtml===o.supportHtml&&($.baseUri===o.baseUri||!!$.baseUri&&!!o.baseUri&&(0,n.$xg)(E.URI.from($.baseUri),E.URI.from(o.baseUri)))}t.$hk=L;function l($){return $.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.$ik=l;function h($,o){const a=$.match(/^`+/gm)?.reduce((b,f)=>b.length>f.length?b:f).length??0,D=a>=3?a+1:3;return[`${"`".repeat(D)}${o}`,$,`${"`".repeat(D)}`].join(`
`)}t.$jk=h;function e($){return $.replace(/"/g,"&quot;")}t.$kk=e;function s($){return $&&$.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.$lk=s;function g($){const o=[],a=$.split("|").map(b=>b.trim());$=a[0];const D=a[1];if(D){const b=/height=(\d+)/.exec(D),f=/width=(\d+)/.exec(D),N=b?b[1]:"",O=f?f[1]:"",T=isFinite(parseInt(O)),p=isFinite(parseInt(N));T&&o.push(`width="${O}"`),p&&o.push(`height="${N}"`)}return{href:$,dimensions:o}}t.$mk=g}),define(be[126],$e([1,0,3,118,22,55,14,19,119,6,4,62,35,77,23,2,79,53,31,51,37,10,15]),function(ie,t,A,C,n,j,E,k,m,w,y,L,l,h,e,s,g,$,o,a,D,b,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XR=t.$WR=t.$VR=t.$UR=t.$TR=void 0;const N=Object.freeze({image:(K,H,J)=>{let me=[],ve=[];return K&&({href:K,dimensions:me}=(0,L.$mk)(K),ve.push(`src="${(0,L.$kk)(K)}"`)),J&&ve.push(`alt="${(0,L.$kk)(J)}"`),H&&ve.push(`title="${(0,L.$kk)(H)}"`),me.length&&(ve=ve.concat(me)),"<img "+ve.join(" ")+">"},paragraph:K=>`<p>${K}</p>`,link:(K,H,J)=>typeof K!="string"?"":(K===J&&(J=(0,L.$lk)(J)),H=typeof H=="string"?(0,L.$kk)((0,L.$lk)(H)):"",K=(0,L.$lk)(K),K=K.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${K}" title="${H||K}" draggable="false">${J}</a>`)});function O(K,H={},J={}){const me=new s.$Rc;let ve=!1;const Fe=(0,j.$lR)(H),Ae=function(R){let W;try{W=(0,$.$yh)(decodeURIComponent(R))}catch{}return W?(W=(0,a.$ln)(W,z=>{if(K.uris&&K.uris[z])return f.URI.revive(K.uris[z])}),encodeURIComponent(JSON.stringify(W))):R},ge=function(R,W){const z=K.uris&&K.uris[R];let q=f.URI.revive(z);return W?R.startsWith(o.Schemas.data+":")?R:(q||(q=f.URI.parse(R)),o.$lg.uriToBrowserUri(q).toString(!0)):!q||f.URI.parse(R).toString()===q.toString()?R:(q.query&&(q=q.with({query:Ae(q.query)})),q.toString())},v=new g.marked.Renderer;v.image=N.image,v.link=N.link,v.paragraph=N.paragraph;const i=[],r=[];if(H.codeBlockRendererSync?v.code=(R,W)=>{const z=h.$1M.nextId(),q=H.codeBlockRendererSync(T(W),R);return r.push([z,q]),`<div class="code" data-code="${z}">${(0,b.$Ke)(R)}</div>`}:H.codeBlockRenderer&&(v.code=(R,W)=>{const z=h.$1M.nextId(),q=H.codeBlockRenderer(T(W),R);return i.push(q.then(G=>[z,G])),`<div class="code" data-code="${z}">${(0,b.$Ke)(R)}</div>`}),H.actionHandler){const R=function(q){let G=q.target;if(!(G.tagName!=="A"&&(G=G.parentElement,!G||G.tagName!=="A")))try{let oe=G.dataset.href;oe&&(K.baseUri&&(oe=p(f.URI.from(K.baseUri),oe)),H.actionHandler.callback(oe,q))}catch(oe){(0,w.$1)(oe)}finally{q.preventDefault()}},W=H.actionHandler.disposables.add(new n.$mR(Fe,"click")),z=H.actionHandler.disposables.add(new n.$mR(Fe,"auxclick"));H.actionHandler.disposables.add(y.Event.any(W.event,z.event)(q=>{const G=new k.$dP(A.getWindow(Fe),q);!G.leftButton&&!G.middleButton||R(G)})),H.actionHandler.disposables.add(A.$lP(Fe,"keydown",q=>{const G=new E.$iP(q);!G.equals(10)&&!G.equals(3)||R(G)}))}K.supportHtml||(J.sanitizer=R=>(K.isTrusted?R.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?R:"",J.sanitize=!0,J.silent=!0),J.renderer=v;let c=K.value??"";c.length>1e5&&(c=`${c.substr(0,1e5)}\u2026`),K.supportThemeIcons&&(c=(0,l.$_j)(c));let u;if(H.fillInIncompleteTokens){const R={...g.marked.defaults,...J},W=g.marked.lexer(c,R),z=Y(W);u=g.marked.parser(z,R)}else u=g.marked.parse(c,J);K.supportThemeIcons&&(u=(0,m.$RR)(u).map(W=>typeof W=="string"?W:W.outerHTML).join(""));const F=new DOMParser().parseFromString(S(K,u),"text/html");if(F.body.querySelectorAll("img").forEach(R=>{const W=R.getAttribute("src");if(W){let z=W;try{K.baseUri&&(z=p(f.URI.from(K.baseUri),z))}catch{}R.src=ge(z,!0)}}),F.body.querySelectorAll("a").forEach(R=>{const W=R.getAttribute("href");if(R.setAttribute("href",""),!W||/^data:|javascript:/i.test(W)||/^command:/i.test(W)&&!K.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(W))R.replaceWith(...R.childNodes);else{let z=ge(W,!1);K.baseUri&&(z=p(f.URI.from(K.baseUri),W)),R.dataset.href=z}}),Fe.innerHTML=S(K,F.body.innerHTML),i.length>0)Promise.all(i).then(R=>{if(ve)return;const W=new Map(R),z=Fe.querySelectorAll("div[data-code]");for(const q of z){const G=W.get(q.dataset.code??"");G&&A.$nQ(q,G)}H.asyncRenderCallback?.()});else if(r.length>0){const R=new Map(r),W=Fe.querySelectorAll("div[data-code]");for(const z of W){const q=R.get(z.dataset.code??"");q&&A.$nQ(z,q)}}if(H.asyncRenderCallback)for(const R of Fe.getElementsByTagName("img")){const W=me.add(A.$lP(R,"load",()=>{W.dispose(),H.asyncRenderCallback()}))}return{element:Fe,dispose:()=>{ve=!0,me.dispose()}}}t.$TR=O;function T(K){if(!K)return"";const H=K.split(/[\s+|:|,|\{|\?]/,1);return H.length?H[0]:K}function p(K,H){return/^\w[\w\d+.-]*:/.test(H)?H:K.path.endsWith("/")?(0,D.$Hg)(K,H).toString():(0,D.$Hg)((0,D.$Dg)(K),H).toString()}function S(K,H){const{config:J,allowedSchemes:me}=M(K);C.addHook("uponSanitizeAttribute",(Fe,Ae)=>{if(Ae.attrName==="style"||Ae.attrName==="class"){if(Fe.tagName==="SPAN"){if(Ae.attrName==="style"){Ae.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(Ae.attrValue);return}else if(Ae.attrName==="class"){Ae.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(Ae.attrValue);return}}Ae.keepAttr=!1;return}});const ve=A.$HQ(me);try{return C.sanitize(H,{...J,RETURN_TRUSTED_TYPE:!0})}finally{C.removeHook("uponSanitizeAttribute"),ve.dispose()}}t.$UR=["align","autoplay","alt","class","controls","data-code","data-href","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","width","start"];function M(K){const H=[o.Schemas.http,o.Schemas.https,o.Schemas.mailto,o.Schemas.data,o.Schemas.file,o.Schemas.vscodeFileResource,o.Schemas.vscodeRemote,o.Schemas.vscodeRemoteResource];return K.isTrusted&&H.push(o.Schemas.command),{config:{ALLOWED_TAGS:[...A.$IQ],ALLOWED_ATTR:t.$UR,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:H}}function U(K){return typeof K=="string"?K:_(K)}t.$VR=U;function _(K){let H=K.value??"";H.length>1e5&&(H=`${H.substr(0,1e5)}\u2026`);const J=g.marked.parse(H,{renderer:I.value}).replace(/&(#\d+|[a-zA-Z]+);/g,me=>P.get(me)??me);return S({isTrusted:!1},J).toString()}t.$WR=_;const P=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),I=new e.$V(()=>{const K=new g.marked.Renderer;return K.code=H=>H,K.blockquote=H=>H,K.html=H=>"",K.heading=(H,J,me)=>H+`
`,K.hr=()=>"",K.list=(H,J)=>H,K.listitem=H=>H+`
`,K.paragraph=H=>H+`
`,K.table=(H,J)=>H+J+`
`,K.tablerow=H=>H,K.tablecell=(H,J)=>H+" ",K.strong=H=>H,K.em=H=>H,K.codespan=H=>H,K.br=()=>`
`,K.del=H=>H,K.image=(H,J,me)=>"",K.text=H=>H,K.link=(H,J,me)=>me,K});function B(K){let H="";return K.forEach(J=>{H+=J.raw}),H}function X(K){for(const H of K.tokens)if(H.type==="text"){const J=H.raw.split(`
`),me=J[J.length-1];if(me.includes("`"))return ne(K);if(me.includes("**"))return Oe(K);if(me.match(/\*\w/))return te(K);if(me.match(/(^|\s)__\w/))return re(K);if(me.match(/(^|\s)_\w/))return we(K);if(me.match(/(^|\s)\[.*\]\(\w*/))return Te(K);if(me.match(/(^|\s)\[\w/))return Pe(K)}}function Y(K){let H,J;for(H=0;H<K.length;H++){const me=K[H];if(me.type==="paragraph"&&me.raw.match(/(\n|^)```/)){J=ue(K.slice(H));break}if(me.type==="paragraph"&&me.raw.match(/(\n|^)\|/)){J=ae(K.slice(H));break}if(H===K.length-1&&me.type==="paragraph"){const ve=X(me);if(ve){J=[ve];break}}}if(J){const me=[...K.slice(0,H),...J];return me.links=K.links,me}return K}t.$XR=Y;function ue(K){const H=B(K);return g.marked.lexer(H+"\n```")}function ne(K){return Z(K,"`")}function te(K){return Z(K,"*")}function we(K){return Z(K,"_")}function Te(K){return Z(K,")")}function Pe(K){return Z(K,"](about:blank)")}function Oe(K){return Z(K,"**")}function re(K){return Z(K,"__")}function Z(K,H){const J=B(Array.isArray(K)?K:[K]);return g.marked.lexer(J+H)[0]}function ae(K){const H=B(K),J=H.split(`
`);let me,ve=!1;for(let Fe=0;Fe<J.length;Fe++){const Ae=J[Fe].trim();if(typeof me>"u"&&Ae.match(/^\s*\|/)){const ge=Ae.match(/(\|[^\|]+)(?=\||$)/g);ge&&(me=ge.length)}else if(typeof me=="number")if(Ae.match(/^\s*\|/)){if(Fe!==J.length-1)return;ve=!0}else return}if(typeof me=="number"&&me>0){const Fe=ve?J.slice(0,-1).join(`
`):H,Ae=!!Fe.match(/\|\s*$/),ge=Fe+(Ae?"":"|")+`
|${" --- |".repeat(me)}`;return g.marked.lexer(ge)}}}),define(be[127],$e([1,0,3,9,29,62,35,2,7,108]),function(ie,t,A,C,n,j,E,k,m,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dR=t.$cR=void 0;function y(h,e){(0,m.$Ff)(e)?h.title=(0,E.$ak)(e):e?.markdownNotSupportedFallback?h.title=e.markdownNotSupportedFallback:h.removeAttribute("title")}t.$cR=y;class L{constructor(e,s,g){this.c=e,this.d=s,this.f=g}async update(e,s,g){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let $;if(e===void 0||(0,m.$Ff)(e)||e instanceof HTMLElement)$=e;else if(!(0,m.$Tf)(e.markdown))$=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,w.localize)(0,null),s),this.b=new n.$3d;const o=this.b.token;if($=await e.markdown(o),$===void 0&&($=e.markdownNotSupportedFallback),this.isDisposed||o.isCancellationRequested)return}this.g($,s,g)}g(e,s,g){const $=this.a;if(this.h(e)){const o={content:e,target:this.d,appearance:{showPointer:this.c.placement==="element",skipFadeInAnimation:!this.f||!!$},position:{hoverPosition:2},...g};this.a=this.c.showHover(o,s)}$?.dispose()}h(e){return e?(0,j.$gk)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function l(h,e,s,g){let $,o;const a=(_,P)=>{const I=o!==void 0;_&&(o?.dispose(),o=void 0),P&&($?.dispose(),$=void 0),I&&h.onDidHideHover?.()},D=(_,P,I)=>new C.$ah(async()=>{(!o||o.isDisposed)&&(o=new L(h,I||e,_>0),await o.update(s,P,g))},_);let b=!1;const f=A.$lP(e,A.$eQ.MOUSE_DOWN,()=>{b=!0,a(!0,!0)},!0),N=A.$lP(e,A.$eQ.MOUSE_UP,()=>{b=!1},!0),O=A.$lP(e,A.$eQ.MOUSE_LEAVE,_=>{b=!1,a(!1,_.fromElement===e)},!0),T=()=>{if($)return;const _=new k.$Rc,P={targetElements:[e],dispose:()=>{}};if(h.placement===void 0||h.placement==="mouse"){const I=B=>{P.x=B.x+10,B.target instanceof HTMLElement&&B.target.classList.contains("action-label")&&a(!0,!0)};_.add(A.$lP(e,A.$eQ.MOUSE_MOVE,I,!0))}_.add(D(h.delay,!1,P)),$=_},p=A.$lP(e,A.$eQ.MOUSE_OVER,T,!0),S=()=>{if(b||$)return;const _={targetElements:[e],dispose:()=>{}},P=new k.$Rc,I=()=>a(!0,!0);P.add(A.$lP(e,A.$eQ.BLUR,I,!0)),P.add(D(h.delay,!1,_)),$=P},M=A.$lP(e,A.$eQ.FOCUS,S,!0);return{show:_=>{a(!1,!0),D(0,_)},hide:()=>{a(!0,!0)},update:async(_,P)=>{s=_,await o?.update(s,void 0,P)},dispose:()=>{p.dispose(),O.dispose(),f.dispose(),N.dispose(),M.dispose(),a(!0,!0)}}}t.$dR=l}),define(be[128],$e([1,0,3,22,14,126,39,12,4,44,2,5,110,101]),function(ie,t,A,C,n,j,E,k,m,w,y,L,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YR=void 0;const h=A.$,e="selectOption.entry.template";class s{get templateId(){return e}renderTemplate(o){const a=Object.create(null);return a.root=o,a.text=A.$lQ(o,h(".option-text")),a.detail=A.$lQ(o,h(".option-detail")),a.decoratorRight=A.$lQ(o,h(".option-decorator-right")),a}renderElement(o,a,D){const b=D,f=o.text,N=o.detail,O=o.decoratorRight,T=o.isDisabled;b.text.textContent=f,b.detail.textContent=N||"",b.decoratorRight.innerText=O||"",T?b.root.classList.add("option-disabled"):b.root.classList.remove("option-disabled")}disposeTemplate(o){}}class g extends y.$Sc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(o,a,D,b,f){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.M=!1,this.f=!1,this.s=b,this.g=f||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=g.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new m.$Sd,this.B(this.r),this.O(),this.N(D),this.n=a||0,o&&this.setOptions(o,a),this.Q()}getHeight(){return 22}getTemplateId(){return e}N(o){this.u=o,this.w=A.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=A.$lQ(this.w,h(".select-box-details-pane"));const a=A.$lQ(this.w,h(".select-box-dropdown-container-width-control")),D=A.$lQ(a,h(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",A.$lQ(D,this.D),this.G=0,this.y=A.$6P(this.w),this.w.setAttribute("draggable","true"),this.B(A.$lP(this.w,A.$eQ.DRAG_START,b=>{A.$gQ.stop(b,!0)}))}O(){this.B(A.$mP(this.h,"change",a=>{this.n=a.target.selectedIndex,this.r.fire({index:a.target.selectedIndex,selected:a.target.value}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)})),this.B(A.$lP(this.h,A.$eQ.CLICK,a=>{A.$gQ.stop(a),this.f?this.X(!0):this.W()})),this.B(A.$lP(this.h,A.$eQ.MOUSE_DOWN,a=>{A.$gQ.stop(a)}));let o;this.B(A.$lP(this.h,"touchstart",a=>{o=this.f})),this.B(A.$lP(this.h,"touchend",a=>{A.$gQ.stop(a),o?this.X(!0):this.W()})),this.B(A.$lP(this.h,A.$eQ.KEY_DOWN,a=>{const D=new n.$iP(a);let b=!1;L.$j?(D.keyCode===18||D.keyCode===16||D.keyCode===10||D.keyCode===3)&&(b=!0):(D.keyCode===18&&D.altKey||D.keyCode===16&&D.altKey||D.keyCode===10||D.keyCode===3)&&(b=!0),b&&(this.W(),A.$gQ.stop(a,!0))}))}get onDidSelect(){return this.r.event}setOptions(o,a){k.$ub(this.m,o)||(this.m=o,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((D,b)=>{this.h.add(this.U(D.text,b,D.isDisabled)),typeof D.description=="string"&&(this.H=!0)})),a!==void 0&&(this.select(a),this.F=this.n)}P(){this.z?.splice(0,this.z.length,this.m)}select(o){o>=0&&o<this.m.length?this.n=o:o>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)}setAriaLabel(o){this.g.ariaLabel=o,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(o){this.h.tabIndex=o?0:-1}render(o){this.j=o,o.classList.add("select-container"),o.appendChild(this.h),this.R()}Q(){const o=[];this.s.listFocusBackground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(o.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),o.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),o.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=o.join(`
`)}R(){const o=this.s.selectBackground??"",a=this.s.selectForeground??"",D=this.s.selectBorder??"";this.h.style.backgroundColor=o,this.h.style.color=a,this.h.style.borderColor=D}S(){const o=this.s.selectBackground??"",a=A.$DQ(this.s.selectListBackground,o);this.C.style.backgroundColor=a,this.I.style.backgroundColor=a;const D=this.s.focusBorder??"";this.w.style.outlineColor=D,this.w.style.outlineOffset="-1px",this.z.style(this.s)}U(o,a,D){const b=document.createElement("option");return b.value=o,b.text=o,b.disabled=!!D,b}W(){this.I.innerText="",!(!this.u||this.f)&&(this.cb(this.w),this.P(),this.u.showContextView({getAnchor:()=>this.h,render:o=>this.Y(o,!0),layout:()=>{this.ab()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.X(!1),this.u.showContextView({getAnchor:()=>this.h,render:o=>this.Y(o),layout:()=>this.ab(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}X(o){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),o&&this.h.focus(),this.u.hideContextView())}Y(o,a){return o.appendChild(this.w),this.ab(a),{dispose:()=>{try{o.removeChild(this.w)}catch{}}}}Z(){let o=0;return this.m.forEach((a,D)=>{this.hb(D),this.I.offsetHeight>o&&(o=this.I.offsetHeight)}),o}ab(o){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const a=A.getWindow(this.h),D=A.$HP(this.h),b=A.getWindow(this.h).getComputedStyle(this.h),f=parseFloat(b.getPropertyValue("--dropdown-padding-top"))+parseFloat(b.getPropertyValue("--dropdown-padding-bottom")),N=a.innerHeight-D.top-D.height-(this.g.minBottomMargin||0),O=D.top-g.b,T=this.h.offsetWidth,p=this.bb(this.D),S=Math.max(p,Math.round(T)).toString()+"px";this.w.style.width=S,this.z.getHTMLElement().style.height="",this.z.layout();let M=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.Z());const U=this.H?this.L:0,_=M+f+U,P=Math.floor((N-f-U)/this.getHeight()),I=Math.floor((O-f-U)/this.getHeight());if(o)return D.top+D.height>a.innerHeight-22||D.top<g.b||P<1&&I<1?!1:(P<g.c&&I>P&&this.m.length>P?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(D.top+D.height>a.innerHeight-22||D.top<g.b||this.G===0&&P<1||this.G===1&&I<1)return this.X(!0),!1;if(this.G===0){if(this.f&&P+I<1)return this.X(!0),!1;_>N&&(M=P*this.getHeight())}else _>O&&(M=I*this.getHeight());return this.z.layout(M),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=M+f+"px",this.w.style.height=""):this.w.style.height=M+f+"px",this.hb(this.n),this.w.style.width=S,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}bb(o){let a=0;if(o){let D=0,b=0;this.m.forEach((f,N)=>{const O=f.detail?f.detail.length:0,T=f.decoratorRight?f.decoratorRight.length:0,p=f.text.length+O+T;p>b&&(D=N,b=p)}),o.textContent=this.m[D].text+(this.m[D].decoratorRight?this.m[D].decoratorRight+" ":""),a=A.$JP(o)}return a}cb(o){if(this.z)return;this.C=A.$lQ(o,h(".select-box-dropdown-list-container")),this.t=new s,this.z=new E.$QR("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:b=>{let f=b.text;return b.detail&&(f+=`. ${b.detail}`),b.decoratorRight&&(f+=`. ${b.decoratorRight}`),b.description&&(f+=`. ${b.description}`),f},getWidgetAriaLabel:()=>(0,l.localize)(0,null),getRole:()=>L.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const a=this.B(new C.$mR(this.C,"keydown")),D=m.Event.chain(a.event,b=>b.filter(()=>this.z.length>0).map(f=>new n.$iP(f)));this.B(m.Event.chain(D,b=>b.filter(f=>f.keyCode===3))(this.jb,this)),this.B(m.Event.chain(D,b=>b.filter(f=>f.keyCode===2))(this.jb,this)),this.B(m.Event.chain(D,b=>b.filter(f=>f.keyCode===9))(this.ib,this)),this.B(m.Event.chain(D,b=>b.filter(f=>f.keyCode===16))(this.lb,this)),this.B(m.Event.chain(D,b=>b.filter(f=>f.keyCode===18))(this.kb,this)),this.B(m.Event.chain(D,b=>b.filter(f=>f.keyCode===12))(this.nb,this)),this.B(m.Event.chain(D,b=>b.filter(f=>f.keyCode===11))(this.mb,this)),this.B(m.Event.chain(D,b=>b.filter(f=>f.keyCode===14))(this.ob,this)),this.B(m.Event.chain(D,b=>b.filter(f=>f.keyCode===13))(this.pb,this)),this.B(m.Event.chain(D,b=>b.filter(f=>f.keyCode>=21&&f.keyCode<=56||f.keyCode>=85&&f.keyCode<=113))(this.qb,this)),this.B(A.$lP(this.z.getHTMLElement(),A.$eQ.POINTER_UP,b=>this.db(b))),this.B(this.z.onMouseOver(b=>typeof b.index<"u"&&this.z.setFocus([b.index]))),this.B(this.z.onDidChangeFocus(b=>this.gb(b))),this.B(A.$lP(this.w,A.$eQ.FOCUS_OUT,b=>{!this.f||A.$PP(b.relatedTarget,this.w)||this.eb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.S()}db(o){if(!this.z.length)return;A.$gQ.stop(o);const a=o.target;if(!a||a.classList.contains("slider"))return;const D=a.closest(".monaco-list-row");if(!D)return;const b=Number(D.getAttribute("data-index")),f=D.classList.contains("option-disabled");b>=0&&b<this.m.length&&!f&&(this.n=b,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0))}eb(){this.M||(this.n!==this.F&&this.select(this.F),this.X(!1))}fb(o,a){const D=f=>{for(let N=0;N<f.childNodes.length;N++){const O=f.childNodes.item(N);(O.tagName&&O.tagName.toLowerCase())==="img"?f.removeChild(O):D(O)}},b=(0,j.$TR)({value:o,supportThemeIcons:!0},{actionHandler:a});return b.element.classList.add("select-box-description-markdown"),D(b.element),b.element}gb(o){!this.f||!this.H||this.hb(o.indexes[0])}hb(o){this.I.innerText="";const a=this.m[o],D=a?.description??"",b=a?.descriptionIsMarkdown??!1;if(D){if(b){const f=a.descriptionMarkdownActionHandler;this.I.appendChild(this.fb(D,f))}else this.I.innerText=D;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}ib(o){A.$gQ.stop(o),this.select(this.F),this.X(!0)}jb(o){A.$gQ.stop(o),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0)}kb(o){if(this.n<this.m.length-1){A.$gQ.stop(o,!0);const a=this.m[this.n+1].isDisabled;if(a&&this.m.length>this.n+2)this.n+=2;else{if(a)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}lb(o){this.n>0&&(A.$gQ.stop(o,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}mb(o){A.$gQ.stop(o),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}nb(o){A.$gQ.stop(o),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}ob(o){A.$gQ.stop(o),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}pb(o){A.$gQ.stop(o),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}qb(o){const a=w.KeyCodeUtils.toString(o.keyCode);let D=-1;for(let b=0;b<this.m.length-1;b++)if(D=(b+this.n+1)%this.m.length,this.m[D].text.charAt(0).toUpperCase()===a&&!this.m[D].isDisabled){this.select(D),this.z.setFocus([D]),this.z.reveal(this.z.getFocus()[0]),A.$gQ.stop(o);break}}dispose(){this.X(!1),super.dispose()}}t.$YR=g}),define(be[129],$e([1,0,39,128,122,20,5,100]),function(ie,t,A,C,n,j,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2R=t.$1R=void 0,t.$1R={...A.$PR,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class k extends j.$YQ{constructor(w,y,L,l,h){super(),E.$j&&!h?.useCustomDrawn?this.a=new n.$ZR(w,y,l,h):this.a=new C.$YR(w,y,L,l,h),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(w,y){this.a.setOptions(w,y)}select(w){this.a.select(w)}setAriaLabel(w){this.a.setAriaLabel(w)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(w){this.a.setFocusable(w)}render(w){this.a.render(w)}}t.$2R=k}),define(be[63],$e([1,0,16,54,3,25,127,129,36,2,5,7,105,52]),function(ie,t,A,C,n,j,E,k,m,w,y,L,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0R=t.$9R=t.$8R=void 0;class h extends w.$Sc{get action(){return this._action}constructor($,o,a={}){super(),this.m=a,this._context=$||this,this._action=o,o instanceof m.$Hi&&this.B(o.onDidChange(D=>{this.element&&this.t(D)}))}t($){$.enabled!==void 0&&this.u(),$.checked!==void 0&&this.H(),$.class!==void 0&&this.G(),$.label!==void 0&&(this.w(),this.D()),$.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new m.$Ii)),this.j}set actionRunner($){this.j=$}isEnabled(){return this._action.enabled}setActionContext($){this._context=$}render($){const o=this.element=$;this.B(j.$UQ.addTarget($));const a=this.m&&this.m.draggable;a&&($.draggable=!0,A.$4O&&this.B((0,n.$lP)($,n.$eQ.DRAG_START,D=>D.dataTransfer?.setData(C.$SQ.TEXT,this._action.label)))),this.B((0,n.$lP)(o,j.EventType.Tap,D=>this.onClick(D,!0))),this.B((0,n.$lP)(o,n.$eQ.MOUSE_DOWN,D=>{a||n.$gQ.stop(D,!0),this._action.enabled&&D.button===0&&o.classList.add("active")})),y.$j&&this.B((0,n.$lP)(o,n.$eQ.CONTEXT_MENU,D=>{D.button===0&&D.ctrlKey===!0&&this.onClick(D)})),this.B((0,n.$lP)(o,n.$eQ.CLICK,D=>{n.$gQ.stop(D,!0),this.m&&this.m.isMenu||this.onClick(D)})),this.B((0,n.$lP)(o,n.$eQ.DBLCLICK,D=>{n.$gQ.stop(D,!0)})),[n.$eQ.MOUSE_UP,n.$eQ.MOUSE_OUT].forEach(D=>{this.B((0,n.$lP)(o,D,b=>{n.$gQ.stop(b),o.classList.remove("active")}))})}onClick($,o=!1){n.$gQ.stop($,!0);const a=L.$Of(this._context)?this.m?.useEventAsContext?$:{preserveFocus:o}:this._context;this.actionRunner.run(this._action,a)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable($){this.element&&(this.element.tabIndex=$?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const $=this.C()??"";this.F(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update($):(this.f=(0,E.$dR)(this.m.hoverDelegate,this.element,$),this.q.add(this.f))):this.element.title=$}F(){if(this.element){const $=this.C()??"";this.element.setAttribute("aria-label",$)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$8R=h;class e extends h{constructor($,o,a){super($,o,a),this.m=a,this.m.icon=a.icon!==void 0?a.icon:!1,this.m.label=a.label!==void 0?a.label:!0,this.L=""}render($){super.render($),L.$Pf(this.element);const o=document.createElement("a");if(o.classList.add("action-label"),o.setAttribute("role",this.M()),this.I=o,this.element.appendChild(o),this.m.label&&this.m.keybinding){const a=document.createElement("span");a.classList.add("keybinding"),a.textContent=this.m.keybinding,this.element.appendChild(a)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===m.$Ji.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable($){this.I&&(this.I.tabIndex=$?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let $=null;return this.action.tooltip?$=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&($=this.action.label,this.m.keybinding&&($=l.localize(0,null,$,this.m.keybinding))),$??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const $=this.C()??"";this.I.setAttribute("aria-label",$)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox")):(this.I.classList.remove("checked"),this.I.removeAttribute("aria-checked"),this.I.setAttribute("role",this.M())))}}t.$9R=e;class s extends h{constructor($,o,a,D,b,f,N){super($,o),this.b=new k.$2R(a,D,b,f,N),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions($,o){this.b.setOptions($,o)}select($){this.b.select($)}g(){this.B(this.b.onDidSelect($=>this.n($.selected,$.index)))}n($,o){this.actionRunner.run(this._action,this.r($,o))}r($,o){return $}setFocusable($){this.b.setFocusable($)}focus(){this.b?.focus()}blur(){this.b?.blur()}render($){this.b.render($)}}t.$0R=s}),define(be[64],$e([1,0,3,14,63,36,4,2,7,52]),function(ie,t,A,C,n,j,E,k,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fR=t.$eR=t.ActionsOrientation=void 0;var w;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(w||(t.ActionsOrientation=w={}));class y extends k.$Sc{constructor(h,e={}){super(),this.g=this.B(new k.$Rc),this.r=this.B(new k.$2c),this.w=!1,this.y=!0,this.C=this.B(new E.$Sd),this.onDidBlur=this.C.event,this.D=this.B(new E.$Sd({onWillAddFirstListener:()=>this.F=!0})),this.onDidCancel=this.D.event,this.F=!1,this.G=this.B(new E.$Sd),this.onDidRun=this.G.event,this.H=this.B(new E.$Sd),this.onWillRun=this.H.event,this.b=e,this.j=e.context??null,this.m=this.b.orientation??0,this.n={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new j.$Ii,this.g.add(this.f)),this.g.add(this.f.onDidRun($=>this.G.fire($))),this.g.add(this.f.onWillRun($=>this.H.fire($))),this.viewItems=[],this.t=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let s,g;switch(this.m){case 0:s=[15],g=[17];break;case 1:s=[16],g=[18],this.domNode.className+=" vertical";break}this.B(A.$lP(this.domNode,A.$eQ.KEY_DOWN,$=>{const o=new C.$iP($);let a=!0;const D=typeof this.t=="number"?this.viewItems[this.t]:void 0;s&&(o.equals(s[0])||o.equals(s[1]))?a=this.P():g&&(o.equals(g[0])||o.equals(g[1]))?a=this.O():o.equals(9)&&this.F?this.D.fire():o.equals(14)?a=this.M():o.equals(13)?a=this.N():o.equals(2)&&D instanceof n.$8R&&D.trapsArrowNavigation?a=this.O():this.J(o)?this.n.keyDown?this.R(o):this.w=!0:a=!1,a&&(o.preventDefault(),o.stopPropagation())})),this.B(A.$lP(this.domNode,A.$eQ.KEY_UP,$=>{const o=new C.$iP($);this.J(o)?(!this.n.keyDown&&this.w&&(this.w=!1,this.R(o)),o.preventDefault(),o.stopPropagation()):(o.equals(2)||o.equals(1026)||o.equals(16)||o.equals(18)||o.equals(15)||o.equals(17))&&this.L()})),this.u=this.B(A.$jQ(this.domNode)),this.B(this.u.onDidBlur(()=>{(A.$XP()===this.domNode||!A.$PP(A.$XP(),this.domNode))&&(this.C.fire(),this.s=this.t,this.t=void 0,this.w=!1)})),this.B(this.u.onDidFocus(()=>this.L())),this.z=document.createElement("ul"),this.z.className="actions-container",this.b.highlightToggledItems&&this.z.classList.add("highlight-toggled"),this.z.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.z.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.z),h.appendChild(this.domNode)}I(){this.length()>=1?this.z.setAttribute("role",this.b.ariaRole||"toolbar"):this.z.setAttribute("role","presentation")}setAriaLabel(h){h?this.z.setAttribute("aria-label",h):this.z.removeAttribute("aria-label")}setFocusable(h){if(this.y=h,this.y){const e=this.viewItems.find(s=>s instanceof n.$8R&&s.isEnabled());e instanceof n.$8R&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof n.$8R&&e.setFocusable(!1)})}J(h){let e=!1;return this.n.keys.forEach(s=>{e=e||h.equals(s)}),e}L(){for(let h=0;h<this.z.children.length;h++){const e=this.z.children[h];if(A.$PP(A.$XP(),e)){this.t=h,this.viewItems[this.t]?.showHover?.();break}}}get context(){return this.j}set context(h){this.j=h,this.viewItems.forEach(e=>e.setActionContext(h))}get actionRunner(){return this.f}set actionRunner(h){this.f=h,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.G.fire(e))),this.g.add(this.f.onWillRun(e=>this.H.fire(e))),this.viewItems.forEach(e=>e.actionRunner=h)}getContainer(){return this.domNode}hasAction(h){return this.viewItems.findIndex(e=>e.action.id===h.id)!==-1}getAction(h){if(typeof h=="number")return this.viewItems[h]?.action;if(h instanceof HTMLElement){for(;h.parentElement!==this.z;){if(!h.parentElement)return;h=h.parentElement}for(let e=0;e<this.z.childNodes.length;e++)if(this.z.childNodes[e]===h)return this.viewItems[e].action}}push(h,e={}){const s=Array.isArray(h)?h:[h];let g=m.$Jf(e.index)?e.index:null;s.forEach($=>{const o=document.createElement("li");o.className="action-item",o.setAttribute("role","presentation");let a;const D={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&(a=this.b.actionViewItemProvider($,D)),a||(a=new n.$9R(this.context,$,D)),this.b.allowContextMenu||this.r.set(a,A.$lP(o,A.$eQ.CONTEXT_MENU,b=>{A.$gQ.stop(b,!0)})),a.actionRunner=this.f,a.setActionContext(this.context),a.render(o),this.y&&a instanceof n.$8R&&this.viewItems.length===0&&a.setFocusable(!0),g===null||g<0||g>=this.z.children.length?(this.z.appendChild(o),this.viewItems.push(a)):(this.z.insertBefore(o,this.z.children[g]),this.viewItems.splice(g,0,a),g++)}),typeof this.t=="number"&&this.focus(this.t),this.I()}getWidth(h){if(h>=0&&h<this.z.children.length){const e=this.z.children.item(h);if(e)return e.clientWidth}return 0}getHeight(h){if(h>=0&&h<this.z.children.length){const e=this.z.children.item(h);if(e)return e.clientHeight}return 0}pull(h){h>=0&&h<this.viewItems.length&&(this.z.removeChild(this.z.childNodes[h]),this.r.deleteAndDispose(this.viewItems[h]),(0,k.$Nc)(this.viewItems.splice(h,1)),this.I())}clear(){this.isEmpty()||(this.viewItems=(0,k.$Nc)(this.viewItems),this.r.clearAndDisposeAll(),A.$kP(this.z),this.I())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(h){let e=!1,s;if(h===void 0?e=!0:typeof h=="number"?s=h:typeof h=="boolean"&&(e=h),e&&typeof this.t>"u"){const g=this.viewItems.findIndex($=>$.isEnabled());this.t=g===-1?void 0:g,this.Q(void 0,void 0,!0)}else s!==void 0&&(this.t=s),this.Q(void 0,void 0,!0)}M(){return this.t=this.length()-1,this.O(!0)}N(){return this.t=0,this.P(!0)}O(h){if(typeof this.t>"u")this.t=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.t;let s;do{if(!h&&this.b.preventLoopNavigation&&this.t+1>=this.viewItems.length)return this.t=e,!1;this.t=(this.t+1)%this.viewItems.length,s=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!s.isEnabled()||s.action.id===j.$Ji.ID));return this.Q(),!0}P(h){if(typeof this.t>"u")this.t=0;else if(this.viewItems.length<=1)return!1;const e=this.t;let s;do{if(this.t=this.t-1,this.t<0){if(!h&&this.b.preventLoopNavigation)return this.t=e,!1;this.t=this.viewItems.length-1}s=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!s.isEnabled()||s.action.id===j.$Ji.ID));return this.Q(!0),!0}Q(h,e,s=!1){typeof this.t>"u"&&this.z.focus({preventScroll:e}),this.s!==void 0&&this.s!==this.t&&this.viewItems[this.s]?.blur();const g=this.t!==void 0?this.viewItems[this.t]:void 0;if(g){let $=!0;m.$Tf(g.focus)||($=!1),this.b.focusOnlyEnabledItems&&m.$Tf(g.isEnabled)&&!g.isEnabled()&&($=!1),g.action.id===j.$Ji.ID&&($=!1),$?(s||this.s!==this.t)&&(g.focus(h),this.s=this.t):(this.z.focus({preventScroll:e}),this.s=void 0),$&&g.showHover?.()}}R(h){if(typeof this.t>"u")return;const e=this.viewItems[this.t];if(e instanceof n.$8R){const s=e._context===null||e._context===void 0?h:e._context;this.run(e._action,s)}}async run(h,e){await this.f.run(h,e)}dispose(){this.j=void 0,this.viewItems=(0,k.$Nc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$eR=y;function L(l){if(!l.length)return l;let h=-1;for(let s=0;s<l.length;s++)if(l[s].id!==j.$Ji.ID){h=s;break}if(h===-1)return[];l=l.slice(h);for(let s=l.length-1;s>=0&&l[s].id===j.$Ji.ID;s--)l.splice(s,1);let e=!1;for(let s=l.length-1;s>=0;s--){const g=l[s].id===j.$Ji.ID;g&&!e?l.splice(s,1):g?g&&(e=!1):e=!0}return l}t.$fR=L}),define(be[65],$e([1,0,3,22,55,64,57,60,20,4,82,51,109,97]),function(ie,t,A,C,n,j,E,k,m,w,y,L,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OS=t.$NS=t.$MS=t.MessageType=void 0;const h=A.$;var e;(function($){$[$.INFO=1]="INFO",$[$.WARNING=2]="WARNING",$[$.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.$MS={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class s extends m.$YQ{constructor(o,a,D){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.O=this.B(new w.$Sd),this.onDidChange=this.O.event,this.P=this.B(new w.$Sd),this.onDidHeightChange=this.P.event,this.a=a,this.g=D,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=A.$lQ(o,h(".monaco-inputbox.idle"));const b=this.g.flexibleHeight?"textarea":"input",f=A.$lQ(this.element,h(".ibwrapper"));if(this.b=A.$lQ(f,h(b+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=A.$lQ(f,h("div.mirror")),this.y.innerText="\xA0",this.N=new k.$9Q(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),A.$lQ(o,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(T=>this.b.scrollTop=T.scrollTop));const N=this.B(new C.$mR(o.ownerDocument,"selectionchange")),O=w.Event.filter(N.event,()=>o.ownerDocument.getSelection()?.anchorNode===f);this.B(O(this.S,this)),this.B(this.onDidHeightChange(this.S,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Y()),this.F(this.b,()=>this.Q()),this.G(this.b,()=>this.R()),this.B(this.I(this.b)),setTimeout(()=>this.Z(),0),this.g.actions&&(this.c=this.B(new j.$eR(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.ab()}Q(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}R(){this.W(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(o){this.n=o,this.b.setAttribute("placeholder",o)}setTooltip(o){this.r=o,this.b.title=o}setAriaLabel(o){this.s=o,o?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(o){this.b.value!==o&&(this.b.value=o,this.Y())}get step(){return this.b.step}set step(o){this.b.step=o}get height(){return typeof this.J=="number"?this.J:A.$NP(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return A.$YP(this.b)}select(o=null){this.b.select(),o&&(this.b.setSelectionRange(o.start,o.end),o.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.X()}setEnabled(o){o?this.enable():this.disable()}get width(){return A.$JP(this.b)}set width(o){if(this.g.flexibleHeight&&this.g.flexibleWidth){let a=0;if(this.y){const D=parseFloat(this.y.style.paddingLeft||"")||0,b=parseFloat(this.y.style.paddingRight||"")||0;a=D+b}this.b.style.width=o-a+"px"}else this.b.style.width=o+"px";this.y&&(this.y.style.width=o+"px")}set paddingRight(o){this.b.style.width=`calc(100% - ${o}px)`,this.y&&(this.y.style.paddingRight=o+"px")}S(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const o=this.L,a=this.J,D=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:o,height:a}),this.N.setScrollPosition({scrollTop:D})}showMessage(o,a){if(this.w==="open"&&(0,L.$nn)(this.h,o))return;this.h=o,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.U(o.type));const D=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${A.$DQ(D.border,"transparent")}`,this.h.content&&(this.hasFocus()||a)&&this.W()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.X(),this.ab()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let o=null;return this.t&&(o=this.t(this.value),o?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(o)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),o?.type}stylesForType(o){const a=this.g.inputBoxStyles;switch(o){case 1:return{border:a.inputValidationInfoBorder,background:a.inputValidationInfoBackground,foreground:a.inputValidationInfoForeground};case 2:return{border:a.inputValidationWarningBorder,background:a.inputValidationWarningBackground,foreground:a.inputValidationWarningForeground};default:return{border:a.inputValidationErrorBorder,background:a.inputValidationErrorBackground,foreground:a.inputValidationErrorForeground}}}U(o){switch(o){case 1:return"info";case 2:return"warning";default:return"error"}}W(){if(!this.a||!this.h)return;let o;const a=()=>o.style.width=A.$JP(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:b=>{if(!this.h)return null;o=A.$lQ(b,h(".monaco-inputbox-container")),a();const f={inline:!0,className:"monaco-inputbox-message"},N=this.h.formatContent?(0,n.$kR)(this.h.content,f):(0,n.$jR)(this.h.content,f);N.classList.add(this.U(this.h.type));const O=this.stylesForType(this.h.type);return N.style.backgroundColor=O.background??"",N.style.color=O.foreground??"",N.style.border=O.border?`1px solid ${O.border}`:"",A.$lQ(o,N),null},onHide:()=>{this.w="closed"},layout:a});let D;this.h.type===3?D=l.localize(0,null,this.h.content):this.h.type===2?D=l.localize(1,null,this.h.content):D=l.localize(2,null,this.h.content),E.$oR(D),this.w="open"}X(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Y(){this.O.fire(this.value),this.validate(),this.Z(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}Z(){if(!this.y)return;const o=this.value,D=o.charCodeAt(o.length-1)===10?" ":"";(o+D).replace(/\u000c/g,"")?this.y.textContent=o+D:this.y.innerText="\xA0",this.layout()}ab(){const o=this.g.inputBoxStyles,a=o.inputBackground??"",D=o.inputForeground??"",b=o.inputBorder??"";this.element.style.backgroundColor=a,this.element.style.color=D,this.b.style.backgroundColor="inherit",this.b.style.color=D,this.element.style.border=`1px solid ${A.$DQ(b,"transparent")}`}layout(){if(!this.y)return;const o=this.L;this.L=A.$NP(this.y),o!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.P.fire(this.L))}insertAtCursor(o){const a=this.inputElement,D=a.selectionStart,b=a.selectionEnd,f=a.value;D!==null&&b!==null&&(this.value=f.substr(0,D)+o+f.substr(b),a.setSelectionRange(D+1,D+1),this.layout())}dispose(){this.X(),this.h=null,this.c?.dispose(),super.dispose()}}t.$NS=s;class g extends s{constructor(o,a,D){const b=l.localize(3,null,"\u21C5"),f=l.localize(4,null,"\u21C5");super(o,a,D),this.db=this.B(new w.$Sd),this.onDidFocus=this.db.event,this.eb=this.B(new w.$Sd),this.onDidBlur=this.eb.event,this.bb=new y.$KS(D.history,100);const N=()=>{if(D.showHistoryHint&&D.showHistoryHint()&&!this.n.endsWith(b)&&!this.n.endsWith(f)&&this.bb.getHistory().length){const O=this.n.endsWith(")")?b:f,T=this.n+O;D.showPlaceholderOnFocus&&!A.$YP(this.b)?this.n=T:this.setPlaceHolder(T)}};this.cb=new MutationObserver((O,T)=>{O.forEach(p=>{p.target.textContent||N()})}),this.cb.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>N()),this.F(this.b,()=>{const O=T=>{if(this.n.endsWith(T)){const p=this.n.slice(0,this.n.length-T.length);return D.showPlaceholderOnFocus?this.n=p:this.setPlaceHolder(p),!0}else return!1};O(f)||O(b)})}dispose(){super.dispose(),this.cb&&(this.cb.disconnect(),this.cb=void 0)}addToHistory(o){this.value&&(o||this.value!==this.hb())&&this.bb.add(this.value)}prependHistory(o){const a=this.getHistory();this.clearHistory(),o.forEach(D=>{this.bb.add(D)}),a.forEach(D=>{this.bb.add(D)})}getHistory(){return this.bb.getHistory()}isAtFirstInHistory(){return this.bb.isFirst()}isAtLastInHistory(){return this.bb.isLast()}isNowhereInHistory(){return this.bb.isNowhere()}showNextValue(){this.bb.has(this.value)||this.addToHistory();let o=this.jb();o&&(o=o===this.value?this.jb():o),this.value=o??"",E.$pR(this.value?this.value:l.localize(5,null))}showPreviousValue(){this.bb.has(this.value)||this.addToHistory();let o=this.ib();o&&(o=o===this.value?this.ib():o),o&&(this.value=o,E.$pR(this.value))}clearHistory(){this.bb.clear()}setPlaceHolder(o){super.setPlaceHolder(o),this.setTooltip(o)}Q(){super.Q(),this.eb.fire()}R(){super.R(),this.db.fire()}hb(){let o=this.bb.current();return o||(o=this.bb.last(),this.bb.next()),o}ib(){return this.bb.previous()||this.bb.first()}jb(){return this.bb.next()}}t.$OS=g}),define(be[66],$e([1,0,63,20,17,18,4,3,102]),function(ie,t,A,C,n,j,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7R=t.$6R=t.$5R=t.$4R=t.$3R=void 0,t.$3R={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class m extends A.$8R{constructor(h,e,s){super(h,e,s),this.a=this.B(new w({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:s.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:s.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:s.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(h){this.element=h,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(h){this.a.domNode.tabIndex=h?0:-1}}t.$4R=m;class w extends C.$YQ{constructor(h){super(),this.a=this.B(new E.$Sd),this.onChange=this.a.event,this.b=this.B(new E.$Sd),this.onKeyDown=this.b.event,this.c=h,this.s=this.c.isChecked;const e=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,e.push(...j.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&e.push(...this.c.actionClassName.split(" ")),this.s&&e.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...e),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,s=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),s.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,s=>{if(s.keyCode===10||s.keyCode===3){this.checked=!this.s,this.a.fire(!0),s.preventDefault(),s.stopPropagation();return}this.b.fire(s)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(h){this.s=h,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(h){this.g&&this.domNode.classList.remove(...j.ThemeIcon.asClassNameArray(this.g)),this.g=h,this.g&&this.domNode.classList.add(...j.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(h){this.domNode.title=h,this.domNode.setAttribute("aria-label",h)}}t.$5R=w;class y extends C.$YQ{constructor(h,e,s){super(),this.g=h,this.h=e,this.a=this.B(new E.$Sd),this.onChange=this.a.event,this.b=new w({title:this.g,isChecked:this.h,icon:n.$9j.check,actionClassName:"monaco-checkbox",...t.$3R}),this.domNode=this.b.domNode,this.c=s,this.n(),this.B(this.b.onChange(g=>{this.n(),this.a.fire(g)}))}get checked(){return this.b.checked}set checked(h){this.b.checked=h,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,k.$YP)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}t.$6R=y;class L extends A.$8R{constructor(h,e,s){super(h,e,s),this.a=this.B(new y(this._action.label,!!this._action.checked,s.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(h){if(this.element=h,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const e=this.element.appendChild((0,k.$)("span.checkbox-label",void 0,this._action.label));this.B((0,k.$lP)(e,k.$eQ.CLICK,s=>{this.a.checked=!this.a.checked,s.stopPropagation(),s.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(h){this.a.domNode.tabIndex=h?0:-1}}t.$7R=L}),define(be[130],$e([1,0,66,17,107]),function(ie,t,A,C,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2S=t.$1S=t.$ZS=void 0;const j=n.localize(0,null),E=n.localize(1,null),k=n.localize(2,null);class m extends A.$5R{constructor(l){super({icon:C.$9j.caseSensitive,title:j+l.appendTitle,isChecked:l.isChecked,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}t.$ZS=m;class w extends A.$5R{constructor(l){super({icon:C.$9j.wholeWord,title:E+l.appendTitle,isChecked:l.isChecked,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}t.$1S=w;class y extends A.$5R{constructor(l){super({icon:C.$9j.regex,title:k+l.appendTitle,isChecked:l.isChecked,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}t.$2S=y}),define(be[131],$e([1,0,3,130,65,20,4,106,2,96]),function(ie,t,A,C,n,j,E,k,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3S=void 0;const w=k.localize(0,null);class y extends j.$YQ{static{this.OPTION_CHANGE="optionChange"}constructor(l,h,e){super(),this.n=!0,this.s=!1,this.w=this.B(new m.$Tc),this.N=[],this.O=this.B(new E.$Sd),this.onDidOptionChange=this.O.event,this.P=this.B(new E.$Sd),this.onKeyDown=this.P.event,this.Q=this.B(new E.$Sd),this.onMouseDown=this.Q.event,this.R=this.B(new E.$Sd),this.onInput=this.R.event,this.S=this.B(new E.$Sd),this.onKeyUp=this.S.event,this.U=this.B(new E.$Sd),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new E.$Sd),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||w,this.h=!!e.showCommonFindToggles;const s=e.appendCaseSensitiveLabel||"",g=e.appendWholeWordsLabel||"",$=e.appendRegexLabel||"",o=e.history||[],a=!!e.flexibleHeight,D=!!e.flexibleWidth,b=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new n.$OS(this.domNode,h,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:o,showHistoryHint:e.showHistoryHint,flexibleHeight:a,flexibleWidth:D,flexibleMaxHeight:b,inputBoxStyles:e.inputBoxStyles})),this.h){this.J=this.B(new C.$2S({appendTitle:$,isChecked:!1,...e.toggleStyles})),this.B(this.J.onChange(N=>{this.O.fire(N),!N&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(N=>{this.W.fire(N)})),this.L=this.B(new C.$1S({appendTitle:g,isChecked:!1,...e.toggleStyles})),this.B(this.L.onChange(N=>{this.O.fire(N),!N&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new C.$ZS({appendTitle:s,isChecked:!1,...e.toggleStyles})),this.B(this.M.onChange(N=>{this.O.fire(N),!N&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(N=>{this.U.fire(N)}));const f=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,N=>{if(N.equals(15)||N.equals(17)||N.equals(9)){const O=f.indexOf(this.domNode.ownerDocument.activeElement);if(O>=0){let T=-1;N.equals(17)?T=(O+1)%f.length:N.equals(15)&&(O===0?T=f.length-1:T=O-1),N.equals(9)?(f[O].blur(),this.inputBox.focus()):T>=0&&f[T].focus(),A.$gQ.stop(N,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(e?.additionalToggles),this.y&&this.domNode.appendChild(this.y),l?.appendChild(this.domNode),this.B(A.$lP(this.inputBox.inputElement,"compositionstart",f=>{this.s=!0})),this.B(A.$lP(this.inputBox.inputElement,"compositionend",f=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,f=>this.P.fire(f)),this.C(this.inputBox.inputElement,f=>this.S.fire(f)),this.D(this.inputBox.inputElement,f=>this.R.fire()),this.j(this.inputBox.inputElement,f=>this.Q.fire(f))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(l){this.inputBox.layout(),this.X(l.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const l of this.N)l.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const l of this.N)l.disable()}setFocusInputOnOptionClick(l){this.n=l}setEnabled(l){l?this.enable():this.disable()}setAdditionalToggles(l){for(const h of this.N)h.domNode.remove();this.N=[],this.w.value=new m.$Rc;for(const h of l??[])this.w.value.add(h),this.y.appendChild(h.domNode),this.w.value.add(h.onChange(e=>{this.O.fire(e),!e&&this.n&&this.inputBox.focus()})),this.N.push(h);this.N.length>0&&(this.y.style.display=""),this.X()}X(l=!1){l?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((h,e)=>h+e.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(l){this.inputBox.value!==l&&(this.inputBox.value=l)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(l){this.M&&(this.M.checked=l)}getWholeWords(){return this.L?.checked??!1}setWholeWords(l){this.L&&(this.L.checked=l)}getRegex(){return this.J?.checked??!1}setRegex(l){this.J&&(this.J.checked=l,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(l){this.inputBox.showMessage(l)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$3S=y}),define(be[132],$e([1,0,3,22,14,64,131,65,61,39,66,58,26,36,12,9,17,18,32,4,34,2,46,7,111,103]),function(ie,t,A,C,n,j,E,k,m,w,y,L,l,h,e,s,g,$,o,a,D,b,f,N,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BT=t.TreeFindMatchType=t.TreeFindMode=t.$AT=t.$zT=t.$yT=t.RenderIndentGuides=t.$xT=t.$wT=void 0;class T extends m.$zR{set context(i){this.c.context=i}get context(){return this.c.context}constructor(i){super(i.elements.map(r=>r.element)),this.c=i}}function p(v){return v instanceof m.$zR?new T(v):v}class S{constructor(i,r){this.d=i,this.f=r,this.b=b.$Sc.None,this.c=new b.$Rc}getDragURI(i){return this.f.getDragURI(i.element)}getDragLabel(i,r){if(this.f.getDragLabel)return this.f.getDragLabel(i.map(c=>c.element),r)}onDragStart(i,r){this.f.onDragStart?.(p(i),r)}onDragOver(i,r,c,u,d=!0){const F=this.f.onDragOver(p(i),r&&r.element,c,u),R=this.a!==r;if(R&&(this.b.dispose(),this.a=r),typeof r>"u")return F;if(R&&typeof F!="boolean"&&F.autoExpand&&(this.b=(0,s.$5g)(()=>{const oe=this.d(),se=oe.getNodeLocation(r);oe.isCollapsed(se)&&oe.setCollapsed(se,!1),this.a=void 0},500,this.c)),typeof F=="boolean"||!F.accept||typeof F.bubble>"u"||F.feedback){if(!d){const oe=typeof F=="boolean"?F:F.accept,se=typeof F=="boolean"?void 0:F.effect;return{accept:oe,effect:se,feedback:[c]}}return F}if(F.bubble===1){const oe=this.d(),se=oe.getNodeLocation(r),de=oe.getParentNodeLocation(se),De=oe.getNode(de),pe=de&&oe.getListIndex(de);return this.onDragOver(i,De,pe,u,!1)}const W=this.d(),z=W.getNodeLocation(r),q=W.getListIndex(z),G=W.getListRenderCount(z);return{...F,feedback:(0,e.$Sb)(q,q+G)}}drop(i,r,c,u){this.b.dispose(),this.a=void 0,this.f.drop(p(i),r&&r.element,c,u)}onDragEnd(i){this.f.onDragEnd?.(i)}dispose(){this.c.dispose(),this.f.dispose()}}function M(v,i){return i&&{...i,identityProvider:i.identityProvider&&{getId(r){return i.identityProvider.getId(r.element)}},dnd:i.dnd&&new S(v,i.dnd),multipleSelectionController:i.multipleSelectionController&&{isSelectionSingleChangeEvent(r){return i.multipleSelectionController.isSelectionSingleChangeEvent({...r,element:r.element})},isSelectionRangeChangeEvent(r){return i.multipleSelectionController.isSelectionRangeChangeEvent({...r,element:r.element})}},accessibilityProvider:i.accessibilityProvider&&{...i.accessibilityProvider,getSetSize(r){const c=v(),u=c.getNodeLocation(r),d=c.getParentNodeLocation(u);return c.getNode(d).visibleChildrenCount},getPosInSet(r){return r.visibleChildIndex+1},isChecked:i.accessibilityProvider&&i.accessibilityProvider.isChecked?r=>i.accessibilityProvider.isChecked(r.element):void 0,getRole:i.accessibilityProvider&&i.accessibilityProvider.getRole?r=>i.accessibilityProvider.getRole(r.element):()=>"treeitem",getAriaLabel(r){return i.accessibilityProvider.getAriaLabel(r.element)},getWidgetAriaLabel(){return i.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:i.accessibilityProvider&&i.accessibilityProvider.getWidgetRole?()=>i.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:i.accessibilityProvider&&i.accessibilityProvider.getAriaLevel?r=>i.accessibilityProvider.getAriaLevel(r.element):r=>r.depth,getActiveDescendantId:i.accessibilityProvider.getActiveDescendantId&&(r=>i.accessibilityProvider.getActiveDescendantId(r.element))},keyboardNavigationLabelProvider:i.keyboardNavigationLabelProvider&&{...i.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(r){return i.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(r.element)}}}}class U{constructor(i){this.a=i}getHeight(i){return this.a.getHeight(i.element)}getTemplateId(i){return this.a.getTemplateId(i.element)}hasDynamicHeight(i){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(i.element)}setDynamicHeight(i,r){this.a.setDynamicHeight?.(i.element,r)}}t.$wT=U;class _{static lift(i){return i instanceof _?i:new _(i)}static empty(i=0){return new _({focus:[],selection:[],expanded:Object.create(null),scrollTop:i})}constructor(i){if(this.focus=new Set(i.focus),this.selection=new Set(i.selection),i.expanded instanceof Array){this.expanded=Object.create(null);for(const r of i.expanded)this.expanded[r]=1}else this.expanded=i.expanded;this.expanded=i.expanded,this.scrollTop=i.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$xT=_;var P;(function(v){v.None="none",v.OnHover="onHover",v.Always="always"})(P||(t.RenderIndentGuides=P={}));class I{get elements(){return this.b}constructor(i,r=[]){this.b=r,this.a=new b.$Rc,this.onDidChange=a.Event.forEach(i,c=>this.b=c,this.a)}dispose(){this.a.dispose()}}class B{static{this.a=8}constructor(i,r,c,u,d,F={}){this.o=i,this.p=r,this.q=u,this.s=d,this.b=new Map,this.c=new Map,this.d=B.a,this.f=!1,this.g=!1,this.j=new Set,this.k=b.$Sc.None,this.m=new b.$Rc,this.templateId=i.templateId,this.updateOptions(F),a.Event.map(c,R=>R.node)(this.u,this,this.m),i.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(i={}){if(typeof i.indent<"u"){const r=(0,f.$4l)(i.indent,0,40);if(r!==this.d){this.d=r;for(const[c,u]of this.c)this.v(c,u)}}if(typeof i.renderIndentGuides<"u"){const r=i.renderIndentGuides!==P.None;if(r!==this.g){this.g=r;for(const[c,u]of this.c)this.w(c,u);if(this.k.dispose(),r){const c=new b.$Rc;this.q.onDidChange(this.x,this,c),this.k=c,this.x(this.q.elements)}}}typeof i.hideTwistiesOfChildlessElements<"u"&&(this.f=i.hideTwistiesOfChildlessElements)}renderTemplate(i){const r=(0,A.$lQ)(i,(0,A.$)(".monaco-tl-row")),c=(0,A.$lQ)(r,(0,A.$)(".monaco-tl-indent")),u=(0,A.$lQ)(r,(0,A.$)(".monaco-tl-twistie")),d=(0,A.$lQ)(r,(0,A.$)(".monaco-tl-contents")),F=this.o.renderTemplate(d);return{container:i,indent:c,twistie:u,indentGuidesDisposable:b.$Sc.None,templateData:F}}renderElement(i,r,c,u){this.c.set(i,c),this.b.set(i.element,i),this.v(i,c),this.o.renderElement(i,r,c.templateData,u)}disposeElement(i,r,c,u){c.indentGuidesDisposable.dispose(),this.o.disposeElement?.(i,r,c.templateData,u),typeof u=="number"&&(this.c.delete(i),this.b.delete(i.element))}disposeTemplate(i){this.o.disposeTemplate(i.templateData)}t(i){const r=this.b.get(i);r&&this.u(r)}u(i){const r=this.c.get(i);r&&(this.x(this.q.elements),this.v(i,r))}v(i,r){const c=B.a+(i.depth-1)*this.d;r.twistie.style.paddingLeft=`${c}px`,r.indent.style.width=`${c+this.d-16}px`,i.collapsible?r.container.setAttribute("aria-expanded",String(!i.collapsed)):r.container.removeAttribute("aria-expanded"),r.twistie.classList.remove(...$.ThemeIcon.asClassNameArray(g.$9j.treeItemExpanded));let u=!1;this.o.renderTwistie&&(u=this.o.renderTwistie(i.element,r.twistie)),i.collapsible&&(!this.f||i.visibleChildrenCount>0)?(u||r.twistie.classList.add(...$.ThemeIcon.asClassNameArray(g.$9j.treeItemExpanded)),r.twistie.classList.add("collapsible"),r.twistie.classList.toggle("collapsed",i.collapsed)):r.twistie.classList.remove("collapsible","collapsed"),this.w(i,r)}w(i,r){if((0,A.$kP)(r.indent),r.indentGuidesDisposable.dispose(),!this.g)return;const c=new b.$Rc,u=this.p();for(;;){const d=u.getNodeLocation(i),F=u.getParentNodeLocation(d);if(!F)break;const R=u.getNode(F),W=(0,A.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(R)&&W.classList.add("active"),r.indent.childElementCount===0?r.indent.appendChild(W):r.indent.insertBefore(W,r.indent.firstElementChild),this.s.add(R,W),c.add((0,b.$Qc)(()=>this.s.delete(R,W))),i=R}r.indentGuidesDisposable=c}x(i){if(!this.g)return;const r=new Set,c=this.p();i.forEach(u=>{const d=c.getNodeLocation(u);try{const F=c.getParentNodeLocation(d);u.collapsible&&u.children.length>0&&!u.collapsed?r.add(u):F&&r.add(c.getNode(F))}catch{}}),this.j.forEach(u=>{r.has(u)||this.s.forEach(u,d=>d.classList.remove("active"))}),r.forEach(u=>{this.j.has(u)||this.s.forEach(u,d=>d.classList.add("active"))}),this.j=r}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,b.$Nc)(this.m)}}t.$yT=B;class X{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(i){this.c=i,this.d=i.toLowerCase()}constructor(i,r,c){this.g=i,this.j=r,this.k=c,this.a=0,this.b=0,this.c="",this.d="",this.f=new b.$Rc,i.onWillRefilter(this.m,this,this.f)}filter(i,r){let c=1;if(this.k){const F=this.k.filter(i,r);if(typeof F=="boolean"?c=F?1:0:(0,L.$tT)(F)?c=(0,L.$uT)(F.visibility):c=F,c===0)return!1}if(this.a++,!this.c)return this.b++,{data:D.FuzzyScore.Default,visibility:c};const u=this.j.getKeyboardNavigationLabel(i),d=Array.isArray(u)?u:[u];for(const F of d){const R=F&&F.toString();if(typeof R>"u")return{data:D.FuzzyScore.Default,visibility:c};let W;if(this.g.findMatchType===we.Contiguous){const z=R.toLowerCase().indexOf(this.d);if(z>-1){W=[Number.MAX_SAFE_INTEGER,0];for(let q=this.d.length;q>0;q--)W.push(z+q-1)}}else W=(0,D.$4j)(this.c,this.d,0,R,R.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(W)return this.b++,d.length===1?{data:W,visibility:c}:{data:{label:R,score:W},visibility:c}}return this.g.findMode===te.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(i):2:{data:D.FuzzyScore.Default,visibility:c}}m(){this.a=0,this.b=0}dispose(){(0,b.$Nc)(this.f)}}class Y extends y.$5R{constructor(i){super({icon:g.$9j.listFilter,title:(0,O.localize)(0,null),isChecked:i.isChecked??!1,inputActiveOptionBorder:i.inputActiveOptionBorder,inputActiveOptionForeground:i.inputActiveOptionForeground,inputActiveOptionBackground:i.inputActiveOptionBackground})}}t.$zT=Y;class ue extends y.$5R{constructor(i){super({icon:g.$9j.searchFuzzy,title:(0,O.localize)(1,null),isChecked:i.isChecked??!1,inputActiveOptionBorder:i.inputActiveOptionBorder,inputActiveOptionForeground:i.inputActiveOptionForeground,inputActiveOptionBackground:i.inputActiveOptionBackground})}}t.$AT=ue;const ne={inputBoxStyles:k.$MS,toggleStyles:y.$3R,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var te;(function(v){v[v.Highlight=0]="Highlight",v[v.Filter=1]="Filter"})(te||(t.TreeFindMode=te={}));var we;(function(v){v[v.Fuzzy=0]="Fuzzy",v[v.Contiguous=1]="Contiguous"})(we||(t.TreeFindMatchType=we={}));class Te extends b.$Sc{set mode(i){this.b.checked=i===te.Filter,this.f.inputBox.setPlaceHolder(i===te.Filter?(0,O.localize)(2,null):(0,O.localize)(3,null))}set matchType(i){this.c.checked=i===we.Fuzzy}get value(){return this.f.inputBox.value}set value(i){this.f.inputBox.value=i}constructor(i,r,c,u,d,F){super(),this.t=r,this.a=(0,A.h)(".monaco-tree-type-filter",[(0,A.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,A.h)(".monaco-tree-type-filter-input@findInput"),(0,A.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new a.$Sd,this.onDidDisable=this._onDidDisable.event,i.appendChild(this.a.root),this.B((0,b.$Qc)(()=>i.removeChild(this.a.root)));const R=F?.styles??ne;R.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=R.listFilterWidgetBackground),R.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${R.listFilterWidgetShadow}`),this.b=this.B(new Y({...R.toggleStyles,isChecked:u===te.Filter})),this.c=this.B(new ue({...R.toggleStyles,isChecked:d===we.Fuzzy})),this.onDidChangeMode=a.Event.map(this.b.onChange,()=>this.b.checked?te.Filter:te.Highlight,this.q),this.onDidChangeMatchType=a.Event.map(this.c.onChange,()=>this.c.checked?we.Fuzzy:we.Contiguous,this.q),this.f=this.B(new E.$3S(this.a.findInput,c,{label:(0,O.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:R.inputBoxStyles,toggleStyles:R.toggleStyles,history:F?.history})),this.g=this.B(new j.$eR(this.a.actionbar)),this.mode=u;const W=this.B(new C.$mR(this.f.inputBox.inputElement,"keydown")),z=a.Event.chain(W.event,se=>se.map(de=>new n.$iP(de)));this.B(z(se=>{if(se.equals(3)){se.preventDefault(),se.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(se.equals(18)){se.preventDefault(),se.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(se.equals(16)){se.preventDefault(),se.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const q=this.B(new h.$Hi("close",(0,O.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(q,{icon:!0,label:!1});const G=this.B(new C.$mR(this.a.grab,"mousedown"));this.B(G.event(se=>{const de=new b.$Rc,De=de.add(new C.$mR((0,A.getWindow)(se),"mousemove")),pe=de.add(new C.$mR((0,A.getWindow)(se),"mouseup")),Re=this.m,Se=se.pageX,Me=this.s,Be=se.pageY;this.a.grab.classList.add("grabbing");const Ie=this.a.root.style.transition;this.a.root.style.transition="unset";const Ze=Ke=>{const xe=Ke.pageX-Se;this.m=Re-xe;const x=Ke.pageY-Be;this.s=Me+x,this.layout()};de.add(De.event(Ze)),de.add(pe.event(Ke=>{Ze(Ke),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Ie,de.dispose()}))}));const oe=a.Event.chain(this.B(new C.$mR(this.a.grab,"keydown")).event,se=>se.map(de=>new n.$iP(de)));this.B(oe(se=>{let de,De;if(se.keyCode===15?de=Number.POSITIVE_INFINITY:se.keyCode===17?de=0:se.keyCode===10&&(de=this.m===0?Number.POSITIVE_INFINITY:0),se.keyCode===16?De=0:se.keyCode===18&&(De=Number.POSITIVE_INFINITY),de!==void 0&&(se.preventDefault(),se.stopPropagation(),this.m=de,this.layout()),De!==void 0){se.preventDefault(),se.stopPropagation(),this.s=De;const pe=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=pe},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(i=this.j){this.j=i,this.m=(0,f.$4l)(this.m,0,Math.max(0,i-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,f.$4l)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(i){this.f.showMessage(i)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,s.$4g)(300),super.dispose()}}class Pe{get pattern(){return this.b}get mode(){return this.d}set mode(i){i!==this.d&&(this.d=i,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(i))}get matchType(){return this.f}set matchType(i){i!==this.f&&(this.f=i,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(i))}constructor(i,r,c,u,d,F={}){this.t=i,this.u=c,this.v=u,this.w=d,this.x=F,this.b="",this.c="",this.j=0,this.k=new a.$Sd,this.onDidChangeMode=this.k.event,this.m=new a.$Sd,this.onDidChangeMatchType=this.m.event,this.o=new a.$Sd,this.onDidChangePattern=this.o.event,this.p=new a.$Sd,this.onDidChangeOpenState=this.p.event,this.q=new b.$Rc,this.s=new b.$Rc,this.d=i.options.defaultFindMode??te.Highlight,this.f=i.options.defaultFindMatchType??we.Fuzzy,r.onDidSplice(this.z,this,this.s)}updateOptions(i={}){i.defaultFindMode!==void 0&&(this.mode=i.defaultFindMode),i.defaultFindMatchType!==void 0&&(this.matchType=i.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Te(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(i=>this.mode=i,void 0,this.q),this.g.onDidChangeMatchType(i=>this.matchType=i,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(i){this.b=i,this.o.fire(i),this.v.pattern=i,this.t.refilter(),i&&this.t.focusNext(0,!0,void 0,c=>!D.FuzzyScore.isDefault(c.filterData));const r=this.t.getFocus();if(r.length>0){const c=r[0];this.t.getRelativeTop(c)===null&&this.t.reveal(c,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const i=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&i?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,O.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(i){return!this.g||!this.pattern||this.d===te.Filter||this.v.totalCount>0&&this.v.matchCount<=1?!0:!D.FuzzyScore.isDefault(i.filterData)}layout(i){this.j=i,this.g?.layout(i)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Oe(v,i){return v.position===i.position&&v.node.element===i.node.element&&v.startIndex===i.startIndex&&v.height===i.height&&v.endIndex===i.endIndex}class re extends b.$Sc{constructor(i=[]){super(),this.stickyNodes=i}get count(){return this.stickyNodes.length}equal(i){return(0,e.$ub)(this.stickyNodes,i.stickyNodes,Oe)}addDisposable(i){this.B(i)}}class Z extends b.$Sc{get f(){const i=this.m.firstVisibleIndex;if(!(i<0||i>=this.m.length))return this.m.element(i)}constructor(i,r,c,u,d,F={}){super(),this.g=i,this.j=r,this.m=c,this.s=d,this.b=.4;const R=this.validateStickySettings(F);this.a=R.stickyScrollMaxItemCount,this.c=this.B(new ae(c.getScrollableElement(),c,r,u,d)),this.B(c.onDidScroll(()=>this.t())),this.B(c.onDidChangeContentHeight(()=>this.t())),this.B(i.onDidChangeCollapseState(()=>this.t())),this.t()}get height(){return this.c.height}get count(){return this.c.count}getNode(i){return this.c.getNode(i)}t(){const i=this.f;if(!i||this.g.scrollTop===0){this.c.setState(void 0);return}const r=this.u(i);this.c.setState(r)}u(i){const r=[],c=this.m.renderHeight*this.b;let u=i,d=0,F=this.y(u,void 0,d);for(;F&&d+F.height<c&&(r.push(F),d+=F.height,!(r.length>=this.a||(u=this.w(u),!u)));)F=this.y(u,F.node,d);return r.length?new re(r):void 0}w(i){const r=this.I(i);return r===-1||r===this.m.length-1?void 0:this.m.element(r+1)}y(i,r,c){const u=this.D(i,r);if(u&&!(u===i&&(!this.H(i)||this.z(i,c))))return this.C(u,c)}z(i,r){const c=this.I(i),u=this.m.getElementTop(c),d=r;return this.m.scrollTop===u-d}C(i,r){const c=this.s.getHeight(i),{startIndex:u,endIndex:d}=this.J(i),F=this.F(d,r);return{node:i,position:F,height:c,startIndex:u,endIndex:d}}D(i,r=void 0){let c=i,u=this.G(c);for(;u;){if(u===r)return c;c=u,u=this.G(c)}if(r===void 0)return c}F(i,r){let c=this.m.getRelativeTop(i);if(c===null&&this.m.firstVisibleIndex===i&&i+1<this.m.length){const W=this.s.getHeight(this.m.element(i)),z=this.m.getRelativeTop(i+1);c=z?z-W/this.m.renderHeight:null}if(c===null)return r;const u=this.m.element(i),d=this.s.getHeight(u),F=c*this.m.renderHeight,R=F+d;return r>F&&r<=R?F:r}G(i){const r=this.j.getNodeLocation(i),c=this.j.getParentNodeLocation(r);return c?this.j.getNode(c):void 0}H(i){const r=this.j.getNodeLocation(i);return this.j.getListRenderCount(r)>1}I(i,r){return r===void 0&&(r=this.j.getNodeLocation(i)),this.j.getListIndex(r)}J(i){const r=this.j.getNodeLocation(i),c=this.j.getListIndex(r);if(c<0)throw new Error("Node not found in tree");const u=this.j.getListRenderCount(r),d=c+u-1;return{startIndex:c,endIndex:d}}nodePositionTopBelowWidget(i){const r=[];let c=this.G(i);for(;c;)r.push(c),c=this.G(c);let u=0;for(let d=0;d<r.length&&d<this.a;d++)u+=this.s.getHeight(r[d]);return u}updateOptions(i={}){const r=this.validateStickySettings(i);this.a!==r.stickyScrollMaxItemCount&&(this.a=r.stickyScrollMaxItemCount,this.t())}validateStickySettings(i){let r=5;return typeof i.stickyScrollMaxItemCount=="number"&&(r=Math.max(i.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:r}}}class ae{constructor(i,r,c,u,d){this.c=r,this.d=c,this.f=u,this.g=d,this.a=document.createElement("div"),this.a.classList.add("monaco-tree-sticky-container"),i.appendChild(this.a)}get height(){if(!this.b)return 0;const i=this.b.stickyNodes[this.b.count-1];return i.position+i.height}get count(){return this.b?.count??0}getNode(i){return this.b?.stickyNodes.find(r=>r.node===i)}setState(i){const r=!!this.b&&this.b.count>0,c=!!i&&i.count>0;if(!r&&!c||r&&c&&this.b.equal(i)||(r!==c&&this.k(c),this.b?.dispose(),this.b=i,!c))return;for(let F=i.count-1;F>=0;F--){const R=i.stickyNodes[F],W=F?i.stickyNodes[F-1]:void 0,z=W?W.position+W.height:0,{element:q,disposable:G}=this.j(R,z);this.a.appendChild(q),i.addDisposable(G)}const u=(0,A.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(u),i.addDisposable((0,b.$Qc)(()=>u.remove()));const d=i.stickyNodes[i.count-1];this.a.style.height=`${d.position+d.height}px`}j(i,r){const c=this.d.getNodeLocation(i.node),u=this.d.getListIndex(c),d=document.createElement("div");d.style.top=`${i.position}px`,d.style.height=`${i.height}px`,d.style.lineHeight=`${i.height}px`,d.classList.add("monaco-tree-sticky-row"),d.classList.add("monaco-list-row"),d.setAttribute("data-index",`${u}`),d.setAttribute("data-parity",u%2===0?"even":"odd"),d.setAttribute("id",this.c.getElementID(u));const F=this.g.getTemplateId(i.node),R=this.f.find(G=>G.templateId===F);if(!R)throw new Error(`No renderer found for template id ${F}`);const W=new Proxy(i.node,{}),z=R.renderTemplate(d);R.renderElement(W,i.startIndex,z,i.height);const q=(0,b.$Qc)(()=>{R.disposeElement(W,i.startIndex,z,i.height),R.disposeTemplate(z),d.remove()});return{element:d,disposable:q}}k(i){this.a.style.display=i?"block":"none"}dispose(){this.b?.dispose(),this.a.remove()}}function K(v){let i=l.TreeMouseEventTarget.Unknown;return(0,A.$TP)(v.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?i=l.TreeMouseEventTarget.Twistie:(0,A.$TP)(v.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?i=l.TreeMouseEventTarget.Element:(0,A.$TP)(v.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(i=l.TreeMouseEventTarget.Filter),{browserEvent:v.browserEvent,element:v.element?v.element.element:null,target:i}}function H(v){return{element:v.element?v.element.element:null,browserEvent:v.browserEvent,anchor:v.anchor}}function J(v,i){i(v),v.children.forEach(r=>J(r,i))}class me{get f(){return this.d||(this.d=this.m()),this.d}constructor(i,r){this.g=i,this.j=r,this.a=[],this.c=new a.$Sd,this.onDidChange=this.c.event}set(i,r){!r?.__forceEvent&&(0,e.$ub)(this.a,i)||this.k(i,!1,r)}k(i,r,c){if(this.a=[...i],this.b=void 0,this.d=void 0,!r){const u=this;this.c.fire({get elements(){return u.get()},browserEvent:c})}}get(){return this.b||(this.b=this.a.map(i=>i.element)),[...this.b]}getNodes(){return this.a}has(i){return this.f.has(i)}onDidModelSplice({insertedNodes:i,deletedNodes:r}){if(!this.j){const W=this.m(),z=q=>W.delete(q);r.forEach(q=>J(q,z)),this.set([...W.values()]);return}const c=new Set,u=W=>c.add(this.j.getId(W.element).toString());r.forEach(W=>J(W,u));const d=new Map,F=W=>d.set(this.j.getId(W.element).toString(),W);i.forEach(W=>J(W,F));const R=[];for(const W of this.a){const z=this.j.getId(W.element).toString();if(!c.has(z))R.push(W);else{const G=d.get(z);G&&G.visible&&R.push(G)}}if(this.a.length>0&&R.length===0){const W=this.g();W&&R.push(W)}this.k(R,!0)}m(){const i=new Set;for(const r of this.a)i.add(r);return i}}class ve extends w.$NR{constructor(i,r,c){super(i),this.x=r,this.y=c}u(i){if((0,w.$JR)(i.browserEvent.target)||(0,w.$DR)(i.browserEvent.target)||(0,w.$ER)(i.browserEvent.target)||i.browserEvent.isHandledByList)return;const r=i.element;if(!r)return super.u(i);if(this.p(i)||this.o(i))return super.u(i);const c=i.browserEvent.target,u=c.classList.contains("monaco-tl-twistie")||c.classList.contains("monaco-icon-label")&&c.classList.contains("folder-icon")&&i.browserEvent.offsetX<16,d=(0,w.$IR)(i.browserEvent.target);let F=!1;if(d?F=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?F=this.x.expandOnlyOnTwistieClick(r.element):F=!!this.x.expandOnlyOnTwistieClick,d)this.A(i,r);else{if(F&&!u&&i.browserEvent.detail!==2)return super.u(i);if(!this.x.expandOnDoubleClick&&i.browserEvent.detail===2)return super.u(i)}if(r.collapsible&&(!d||u)){const R=this.x.getNodeLocation(r),W=i.browserEvent.altKey;if(this.x.setFocus([R]),this.x.toggleCollapsed(R,W),F&&u){i.browserEvent.isHandledByList=!0;return}}d||super.u(i)}A(i,r){if((0,w.$FR)(i.browserEvent.target)||(0,w.$GR)(i.browserEvent.target))return;const c=this.y();if(!c)throw new Error("Sticky scroll controller not found");const u=this.k.indexOf(r),d=this.k.getElementTop(u),F=c.nodePositionTopBelowWidget(r);this.x.scrollTop=d-F,this.k.setFocus([u]),this.k.setSelection([u])}v(i){i.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||i.browserEvent.isHandledByList||super.v(i)}}class Fe extends w.$QR{constructor(i,r,c,u,d,F,R,W){super(i,r,c,u,W),this.p=d,this.s=F,this.K=R}D(i){return new ve(this,i.tree,i.stickyScrollProvider)}splice(i,r,c=[]){if(super.splice(i,r,c),c.length===0)return;const u=[],d=[];let F;c.forEach((R,W)=>{this.p.has(R)&&u.push(i+W),this.s.has(R)&&d.push(i+W),this.K.has(R)&&(F=i+W)}),u.length>0&&super.setFocus((0,e.$Mb)([...super.getFocus(),...u])),d.length>0&&super.setSelection((0,e.$Mb)([...super.getSelection(),...d])),typeof F=="number"&&super.setAnchor(F)}setFocus(i,r,c=!1){super.setFocus(i,r),c||this.p.set(i.map(u=>this.element(u)),r)}setSelection(i,r,c=!1){super.setSelection(i,r),c||this.s.set(i.map(u=>this.element(u)),r)}setAnchor(i,r=!1){super.setAnchor(i),r||(typeof i>"u"?this.K.set([]):this.K.set([this.element(i)]))}}class Ae{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return a.Event.map(this.j.onMouseClick,K)}get onMouseDblClick(){return a.Event.filter(a.Event.map(this.j.onMouseDblClick,K),i=>i.target!==l.TreeMouseEventTarget.Filter)}get onContextMenu(){return a.Event.map(this.j.onContextMenu,H)}get onTap(){return a.Event.map(this.j.onTap,K)}get onPointer(){return a.Event.map(this.j.onPointer,K)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return a.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??te.Highlight}set findMode(i){this.z&&(this.z.mode=i)}get findMatchType(){return this.z?.matchType??we.Fuzzy}set findMatchType(i){this.z&&(this.z.matchType=i)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:a.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(i,r,c,u,d={}){this.G=i,this.H=d,this.y=new a.$1d,this.onDidChangeFindOpenState=a.Event.None,this.D=new b.$Rc,this.E=new a.$Sd,this.onWillRefilter=this.E.event,this.F=new a.$Sd,this.onDidUpdateOptions=this.F.event,this.p=new U(c);const F=new a.$2d,R=new a.$2d,W=this.D.add(new I(R.event)),z=new o.$Gc;this.k=u.map(de=>new B(de,()=>this.o,F.event,W,z,d));for(const de of this.k)this.D.add(de);let q;d.keyboardNavigationLabelProvider&&(q=new X(this,d.keyboardNavigationLabelProvider,d.filter),d={...d,filter:q},this.D.add(q)),this.q=new me(()=>this.j.getFocusedElements()[0],d.identityProvider),this.w=new me(()=>this.j.getSelectedElements()[0],d.identityProvider),this.x=new me(()=>this.j.getAnchorElement(),d.identityProvider),this.j=new Fe(i,r,this.p,this.k,this.q,this.w,this.x,{...M(()=>this.o,d),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(i,this.j,d),F.input=this.o.onDidChangeCollapseState;const G=a.Event.forEach(this.o.onDidSplice,de=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(de),this.w.onDidModelSplice(de)})},this.D);G(()=>null,null,this.D);const oe=this.D.add(new a.$Sd),se=this.D.add(new s.$Zg(0));if(this.D.add(a.Event.any(G,this.q.onDidChange,this.w.onDidChange)(()=>{se.trigger(()=>{const de=new Set;for(const De of this.q.getNodes())de.add(De);for(const De of this.w.getNodes())de.add(De);oe.fire([...de.values()])})})),R.input=oe.event,d.keyboardSupport!==!1){const de=a.Event.chain(this.j.onKeyDown,De=>De.filter(pe=>!(0,w.$DR)(pe.target)).map(pe=>new n.$iP(pe)));a.Event.chain(de,De=>De.filter(pe=>pe.keyCode===15))(this.J,this,this.D),a.Event.chain(de,De=>De.filter(pe=>pe.keyCode===17))(this.K,this,this.D),a.Event.chain(de,De=>De.filter(pe=>pe.keyCode===10))(this.L,this,this.D)}if((d.findWidgetEnabled??!0)&&d.keyboardNavigationLabelProvider&&d.contextViewProvider){const de=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new Pe(this,this.o,this.j,q,d.contextViewProvider,de),this.A=De=>this.z.shouldAllowFocus(De),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=a.Event.None,this.onDidChangeFindMatchType=a.Event.None;d.enableStickyScroll&&(this.B=new Z(this,this.o,this.j,this.k,this.p,d)),this.C=(0,A.$6P)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===P.Always)}updateOptions(i={}){this.H={...this.H,...i};for(const r of this.k)r.updateOptions(i);this.j.updateOptions(this.H),this.z?.updateOptions(i),this.I(i),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===P.Always)}get options(){return this.H}I(i){!this.B&&this.H.enableStickyScroll?this.B=new Z(this,this.o,this.j,this.k,this.p,this.H):this.B&&!this.H.enableStickyScroll&&(this.B.dispose(),this.B=void 0),this.B?.updateOptions(i)}updateWidth(i){const r=this.o.getListIndex(i);r!==-1&&this.j.updateWidth(r)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(i){this.j.scrollTop=i}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(i){this.j.scrollLeft=i}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let i=this.j.firstVisibleIndex;return this.B&&(i+=this.B.count),i<0||i>=this.j.length?void 0:this.j.element(i).element}get lastVisibleElement(){const i=this.j.lastVisibleIndex;return this.j.element(i).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(i){this.j.ariaLabel=i}get selectionSize(){return this.w.getNodes().length}domFocus(){this.j.domFocus()}isDOMFocused(){return(0,A.$YP)(this.getHTMLElement())}layout(i,r){this.j.layout(i,r),(0,N.$Jf)(r)&&this.z?.layout(r)}style(i){const r=`.${this.j.domId}`,c=[];i.treeIndentGuidesStroke&&(c.push(`.monaco-list${r}:hover .monaco-tl-indent > .indent-guide, .monaco-list${r}.always .monaco-tl-indent > .indent-guide  { border-color: ${i.treeInactiveIndentGuidesStroke}; }`),c.push(`.monaco-list${r} .monaco-tl-indent > .indent-guide.active { border-color: ${i.treeIndentGuidesStroke}; }`)),i.listBackground&&(c.push(`.monaco-list${r} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${i.listBackground}; }`),c.push(`.monaco-list${r} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${i.listBackground}; }`)),this.C.textContent=c.join(`
`),this.j.style(i)}getParentElement(i){const r=this.o.getParentNodeLocation(i);return this.o.getNode(r).element}getFirstElementChild(i){return this.o.getFirstElementChild(i)}getNode(i){return this.o.getNode(i)}getNodeLocation(i){return this.o.getNodeLocation(i)}collapse(i,r=!1){return this.o.setCollapsed(i,!0,r)}expand(i,r=!1){return this.o.setCollapsed(i,!1,r)}toggleCollapsed(i,r=!1){return this.o.setCollapsed(i,void 0,r)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(i){return this.o.isCollapsible(i)}setCollapsible(i,r){return this.o.setCollapsible(i,r)}isCollapsed(i){return this.o.isCollapsed(i)}expandTo(i){this.o.expandTo(i)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(i){if(typeof i>"u")return this.j.setAnchor(void 0);const r=this.o.getNode(i);this.x.set([r]);const c=this.o.getListIndex(i);c>-1&&this.j.setAnchor(c,!0)}getAnchor(){return(0,e.$Ob)(this.x.get(),void 0)}setSelection(i,r){const c=i.map(d=>this.o.getNode(d));this.w.set(c,r);const u=i.map(d=>this.o.getListIndex(d)).filter(d=>d>-1);this.j.setSelection(u,r,!0)}getSelection(){return this.w.get()}setFocus(i,r){const c=i.map(d=>this.o.getNode(d));this.q.set(c,r);const u=i.map(d=>this.o.getListIndex(d)).filter(d=>d>-1);this.j.setFocus(u,r,!0)}focusNext(i=1,r=!1,c,u=this.A){this.j.focusNext(i,r,c,u)}focusPrevious(i=1,r=!1,c,u=this.A){this.j.focusPrevious(i,r,c,u)}focusNextPage(i,r=this.A){return this.j.focusNextPage(i,r)}focusPreviousPage(i,r=this.A){return this.j.focusPreviousPage(i,r)}focusLast(i,r=this.A){this.j.focusLast(i,r)}focusFirst(i,r=this.A){this.j.focusFirst(i,r)}getFocus(){return this.q.get()}reveal(i,r){this.o.expandTo(i);const c=this.o.getListIndex(i);if(c!==-1)if(!this.B)this.j.reveal(c,r);else{const u=this.B.nodePositionTopBelowWidget(this.getNode(i));this.j.reveal(c,r,u)}}getRelativeTop(i){const r=this.o.getListIndex(i);if(r===-1)return null;const c=this.B?.getNode(this.getNode(i));return this.j.getRelativeTop(r,c?.position??this.B?.height)}getViewState(i=this.options.identityProvider){if(!i)throw new l.$rT(this.G,"Can't get tree view state without an identity provider");const r=F=>i.getId(F).toString(),c=_.empty(this.scrollTop);for(const F of this.getFocus())c.focus.add(r(F));for(const F of this.getSelection())c.selection.add(r(F));const u=this.o.getNode(),d=[u];for(;d.length>0;){const F=d.shift();F!==u&&F.collapsible&&(c.expanded[r(F.element)]=F.collapsed?0:1),d.push(...F.children)}return c}J(i){i.preventDefault(),i.stopPropagation();const r=this.j.getFocusedElements();if(r.length===0)return;const c=r[0],u=this.o.getNodeLocation(c);if(!this.o.setCollapsed(u,!0)){const F=this.o.getParentNodeLocation(u);if(!F)return;const R=this.o.getListIndex(F);this.j.reveal(R),this.j.setFocus([R])}}K(i){i.preventDefault(),i.stopPropagation();const r=this.j.getFocusedElements();if(r.length===0)return;const c=r[0],u=this.o.getNodeLocation(c);if(!this.o.setCollapsed(u,!1)){if(!c.children.some(W=>W.visible))return;const[F]=this.j.getFocus(),R=F+1;this.j.reveal(R),this.j.setFocus([R])}}L(i){i.preventDefault(),i.stopPropagation();const r=this.j.getFocusedElements();if(r.length===0)return;const c=r[0],u=this.o.getNodeLocation(c),d=i.browserEvent.altKey;this.o.setCollapsed(u,void 0,d)}navigate(i){return new ge(this.j,this.o,i)}dispose(){(0,b.$Nc)(this.D),this.B?.dispose(),this.j.dispose()}}t.$BT=Ae;class ge{constructor(i,r,c){this.b=i,this.c=r,c?this.a=this.c.getListIndex(c):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(be[133],$e([1,0,132,123,26,28]),function(ie,t,A,C,n,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MT=void 0;class E extends A.$BT{constructor(m,w,y,L,l,h={}){super(m,w,y,L,h),this.f=m,this.g=l,this.d=new Map,this.c=h.identityProvider}getInput(){return this.b}setInput(m,w){if(w&&!this.c)throw new n.$rT(this.f,"Can't restore tree view state without an identity provider");if(this.b=m,!m){this.d.clear(),this.o.setChildren(null,j.Iterable.empty());return}if(!w){this.m(m);return}const y=[],L=[],l=e=>{const s=this.c.getId(e).toString();return!w.expanded[s]},h=e=>{const s=this.c.getId(e.element).toString();w.focus.has(s)&&y.push(e.element),w.selection.has(s)&&L.push(e.element)};this.m(m,l,h),this.setFocus(y),this.setSelection(L),w&&typeof w.scrollTop=="number"&&(this.scrollTop=w.scrollTop)}updateChildren(m=this.b){if(typeof this.b>"u")throw new n.$rT(this.f,"Tree input not set");let w;this.c&&(w=y=>{const L=this.c.getId(y).toString(),l=this.d.get(L);if(l)return l.collapsed}),this.m(m,w)}resort(m=this.b,w=!0){this.o.resort(m===this.b?null:m,w)}refresh(m){if(m===void 0){this.j.rerender();return}this.o.rerender(m)}m(m,w,y){let L;if(this.c){const l=new Set,h=y;y=e=>{const s=this.c.getId(e.element).toString();l.add(s),this.d.set(s,e),h?.(e)},L=e=>{const s=this.c.getId(e.element).toString();l.has(s)||this.d.delete(s)}}this.o.setChildren(m===this.b?null:m,this.s(m,w).elements,{onDidCreateNode:y,onDidDeleteNode:L})}s(m,w){const y=[...this.g.getChildren(m)];return{elements:j.Iterable.map(y,l=>{const{elements:h,size:e}=this.s(l,w),s=this.g.hasChildren?this.g.hasChildren(l):void 0,g=e===0?void 0:w&&w(l);return{element:l,children:h,collapsible:s,collapsed:g}}),size:y.length}}M(m,w,y){return new C.$CT(m,w,y)}}t.$MT=E}),define(be[67],$e([1,0,12,9,33,29,27,6,4,2,53,10,7]),function(ie,t,A,C,n,j,E,k,m,w,y,L,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lh=t.ProxyChannel=t.$Kh=t.$Jh=t.$Ih=t.$Hh=t.$Gh=t.$Fh=t.RequestInitiator=t.$Eh=t.$Dh=t.$Ch=t.$Bh=t.$Ah=void 0;var h;(function(re){re[re.Promise=100]="Promise",re[re.PromiseCancel=101]="PromiseCancel",re[re.EventListen=102]="EventListen",re[re.EventDispose=103]="EventDispose"})(h||(h={}));function e(re){switch(re){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var s;(function(re){re[re.Initialize=200]="Initialize",re[re.PromiseSuccess=201]="PromiseSuccess",re[re.PromiseError=202]="PromiseError",re[re.PromiseErrorObj=203]="PromiseErrorObj",re[re.EventFire=204]="EventFire"})(s||(s={}));function g(re){switch(re){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var $;(function(re){re[re.Uninitialized=0]="Uninitialized",re[re.Idle=1]="Idle"})($||($={}));function o(re){let Z=0;for(let ae=0;;ae+=7){const K=re.read(1);if(Z|=(K.buffer[0]&127)<<ae,!(K.buffer[0]&128))return Z}}const a=O(0);function D(re,Z){if(Z===0){re.write(a);return}let ae=0;for(let H=Z;H!==0;H=H>>>7)ae++;const K=n.$ge.alloc(ae);for(let H=0;Z!==0;H++)K.buffer[H]=Z&127,Z=Z>>>7,Z>0&&(K.buffer[H]|=128);re.write(K)}class b{constructor(Z){this.b=Z,this.a=0}read(Z){const ae=this.b.slice(this.a,this.a+Z);return this.a+=ae.byteLength,ae}}t.$Ah=b;class f{constructor(){this.a=[]}get buffer(){return n.$ge.concat(this.a)}write(Z){this.a.push(Z)}}t.$Bh=f;var N;(function(re){re[re.Undefined=0]="Undefined",re[re.String=1]="String",re[re.Buffer=2]="Buffer",re[re.VSBuffer=3]="VSBuffer",re[re.Array=4]="Array",re[re.Object=5]="Object",re[re.Int=6]="Int"})(N||(N={}));function O(re){const Z=n.$ge.alloc(1);return Z.writeUInt8(re,0),Z}const T={Undefined:O(N.Undefined),String:O(N.String),Buffer:O(N.Buffer),VSBuffer:O(N.VSBuffer),Array:O(N.Array),Object:O(N.Object),Uint:O(N.Int)},p=typeof Buffer<"u";function S(re,Z){if(typeof Z>"u")re.write(T.Undefined);else if(typeof Z=="string"){const ae=n.$ge.fromString(Z);re.write(T.String),D(re,ae.byteLength),re.write(ae)}else if(p&&Buffer.isBuffer(Z)){const ae=n.$ge.wrap(Z);re.write(T.Buffer),D(re,ae.byteLength),re.write(ae)}else if(Z instanceof n.$ge)re.write(T.VSBuffer),D(re,Z.byteLength),re.write(Z);else if(Array.isArray(Z)){re.write(T.Array),D(re,Z.length);for(const ae of Z)S(re,ae)}else if(typeof Z=="number"&&(Z|0)===Z)re.write(T.Uint),D(re,Z);else{const ae=n.$ge.fromString(JSON.stringify(Z));re.write(T.Object),D(re,ae.byteLength),re.write(ae)}}t.$Ch=S;function M(re){switch(re.read(1).readUInt8(0)){case N.Undefined:return;case N.String:return re.read(o(re)).toString();case N.Buffer:return re.read(o(re)).buffer;case N.VSBuffer:return re.read(o(re));case N.Array:{const ae=o(re),K=[];for(let H=0;H<ae;H++)K.push(M(re));return K}case N.Object:return JSON.parse(re.read(o(re)).toString());case N.Int:return o(re)}}t.$Dh=M;class U{constructor(Z,ae,K=null,H=1e3){this.h=Z,this.j=ae,this.k=K,this.l=H,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(J=>this.q(J)),this.m({type:200})}registerChannel(Z,ae){this.b.set(Z,ae),setTimeout(()=>this.w(Z),0)}m(Z){switch(Z.type){case 200:{const ae=this.o([Z.type]);this.k?.logOutgoing(ae,0,1,g(Z.type));return}case 201:case 202:case 204:case 203:{const ae=this.o([Z.type,Z.id],Z.data);this.k?.logOutgoing(ae,Z.id,1,g(Z.type),Z.data);return}}}o(Z,ae=void 0){const K=new f;return S(K,Z),S(K,ae),this.p(K.buffer)}p(Z){try{return this.h.send(Z),Z.byteLength}catch{return 0}}q(Z){const ae=new b(Z),K=M(ae),H=M(ae),J=K[0];switch(J){case 100:return this.k?.logIncoming(Z.byteLength,K[1],1,`${e(J)}: ${K[2]}.${K[3]}`,H),this.s({type:J,id:K[1],channelName:K[2],name:K[3],arg:H});case 102:return this.k?.logIncoming(Z.byteLength,K[1],1,`${e(J)}: ${K[2]}.${K[3]}`,H),this.t({type:J,id:K[1],channelName:K[2],name:K[3],arg:H});case 101:return this.k?.logIncoming(Z.byteLength,K[1],1,`${e(J)}`),this.u({type:J,id:K[1]});case 103:return this.k?.logIncoming(Z.byteLength,K[1],1,`${e(J)}`),this.u({type:J,id:K[1]})}}s(Z){const ae=this.b.get(Z.channelName);if(!ae){this.v(Z);return}const K=new j.$3d;let H;try{H=ae.call(this.j,Z.name,Z.arg,K.token)}catch(ve){H=Promise.reject(ve)}const J=Z.id;H.then(ve=>{this.m({id:J,data:ve,type:201})},ve=>{ve instanceof Error?this.m({id:J,data:{message:ve.message,name:ve.name,stack:ve.stack?ve.stack.split?ve.stack.split(`
`):ve.stack:void 0},type:202}):this.m({id:J,data:ve,type:203})}).finally(()=>{me.dispose(),this.d.delete(Z.id)});const me=(0,w.$Qc)(()=>K.cancel());this.d.set(Z.id,me)}t(Z){const ae=this.b.get(Z.channelName);if(!ae){this.v(Z);return}const K=Z.id,J=ae.listen(this.j,Z.name,Z.arg)(me=>this.m({id:K,data:me,type:204}));this.d.set(Z.id,J)}u(Z){const ae=this.d.get(Z.id);ae&&(ae.dispose(),this.d.delete(Z.id))}v(Z){let ae=this.g.get(Z.channelName);ae||(ae=[],this.g.set(Z.channelName,ae));const K=setTimeout(()=>{console.error(`Unknown channel: ${Z.channelName}`),Z.type===100&&this.m({id:Z.id,data:{name:"Unknown channel",message:`Channel name '${Z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ae.push({request:Z,timeoutTimer:K})}w(Z){const ae=this.g.get(Z);if(ae){for(const K of ae)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.s(K.request);break;case 102:this.t(K.request);break}this.g.delete(Z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,w.$Nc)(this.d.values()),this.d.clear()}}t.$Eh=U;var _;(function(re){re[re.LocalSide=0]="LocalSide",re[re.OtherSide=1]="OtherSide"})(_||(t.RequestInitiator=_={}));class P{constructor(Z,ae=null){this.l=Z,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new m.$Sd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(K=>this.s(K)),this.j=ae}getChannel(Z){const ae=this;return{call(K,H,J){return ae.a?Promise.reject(new k.$5):ae.m(Z,K,H,J)},listen(K,H){return ae.a?m.Event.None:ae.o(Z,K,H)}}}m(Z,ae,K,H=j.CancellationToken.None){const J=this.g++,ve={id:J,type:100,channelName:Z,name:ae,arg:K};if(H.isCancellationRequested)return Promise.reject(new k.$5);let Fe;return new Promise((ge,v)=>{if(H.isCancellationRequested)return v(new k.$5);const i=()=>{const d=F=>{switch(F.type){case 201:this.f.delete(J),ge(F.data);break;case 202:{this.f.delete(J);const R=new Error(F.data.message);R.stack=Array.isArray(F.data.stack)?F.data.stack.join(`
`):F.data.stack,R.name=F.data.name,v(R);break}case 203:this.f.delete(J),v(F.data);break}};this.f.set(J,d),this.p(ve)};let r=null;this.b===$.Idle?i():(r=(0,C.$Qg)(d=>this.u()),r.then(()=>{r=null,i()}));const c=()=>{r?(r.cancel(),r=null):this.p({id:J,type:101}),v(new k.$5)},u=H.onCancellationRequested(c);Fe=(0,w.$Pc)((0,w.$Qc)(c),u),this.d.add(Fe)}).finally(()=>{Fe.dispose(),this.d.delete(Fe)})}o(Z,ae,K){const H=this.g++,me={id:H,type:102,channelName:Z,name:ae,arg:K};let ve=null;const Fe=new m.$Sd({onWillAddFirstListener:()=>{ve=(0,C.$Qg)(ge=>this.u()),ve.then(()=>{ve=null,this.d.add(Fe),this.p(me)})},onDidRemoveLastListener:()=>{ve?(ve.cancel(),ve=null):(this.d.delete(Fe),this.p({id:H,type:103}))}}),Ae=ge=>Fe.fire(ge.data);return this.f.set(H,Ae),Fe.event}p(Z){switch(Z.type){case 100:case 102:{const ae=this.q([Z.type,Z.id,Z.channelName,Z.name],Z.arg);this.j?.logOutgoing(ae,Z.id,0,`${e(Z.type)}: ${Z.channelName}.${Z.name}`,Z.arg);return}case 101:case 103:{const ae=this.q([Z.type,Z.id]);this.j?.logOutgoing(ae,Z.id,0,e(Z.type));return}}}q(Z,ae=void 0){const K=new f;return S(K,Z),S(K,ae),this.r(K.buffer)}r(Z){try{return this.l.send(Z),Z.byteLength}catch{return 0}}s(Z){const ae=new b(Z),K=M(ae),H=M(ae),J=K[0];switch(J){case 200:return this.j?.logIncoming(Z.byteLength,0,0,g(J)),this.t({type:K[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Z.byteLength,K[1],0,g(J),H),this.t({type:K[0],id:K[1],data:H})}}t(Z){if(Z.type===200){this.b=$.Idle,this.k.fire();return}this.f.get(Z.id)?.(Z)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,w.$Nc)(this.d.values()),this.d.clear()}}t.$Fh=P,Ye([E.$uh],P.prototype,"onDidInitializePromise",null);class I{get connections(){const Z=[];return this.f.forEach(ae=>Z.push(ae)),Z}constructor(Z){this.a=new Map,this.f=new Set,this.g=new m.$Sd,this.onDidAddConnection=this.g.event,this.h=new m.$Sd,this.onDidRemoveConnection=this.h.event,this.j=new w.$Rc,this.j.add(Z(({protocol:ae,onDidClientDisconnect:K})=>{const H=m.Event.once(ae.onMessage);this.j.add(H(J=>{const me=new b(J),ve=M(me),Fe=new U(ae,ve),Ae=new P(ae);this.a.forEach((v,i)=>Fe.registerChannel(i,v));const ge={channelServer:Fe,channelClient:Ae,ctx:ve};this.f.add(ge),this.g.fire(ge),this.j.add(K(()=>{Fe.dispose(),Ae.dispose(),this.f.delete(ge),this.h.fire(ge)}))}))}))}getChannel(Z,ae){const K=this;return{call(H,J,me){let ve;if((0,l.$Tf)(ae)){const Ae=(0,A.$4b)(K.connections.filter(ae));ve=Ae?Promise.resolve(Ae):m.Event.toPromise(m.Event.filter(K.onDidAddConnection,ae))}else ve=ae.routeCall(K,H,J);const Fe=ve.then(Ae=>Ae.channelClient.getChannel(Z));return X(Fe).call(H,J,me)},listen(H,J){if((0,l.$Tf)(ae))return K.k(Z,ae,H,J);const me=ae.routeEvent(K,H,J).then(ve=>ve.channelClient.getChannel(Z));return X(me).listen(H,J)}}}k(Z,ae,K,H){const J=this;let me;const ve=new m.$Sd({onWillAddFirstListener:()=>{me=new w.$Rc;const Fe=new m.$Yd,Ae=new Map,ge=i=>{const c=i.channelClient.getChannel(Z).listen(K,H),u=Fe.add(c);Ae.set(i,u)},v=i=>{const r=Ae.get(i);r&&(r.dispose(),Ae.delete(i))};J.connections.filter(ae).forEach(ge),m.Event.filter(J.onDidAddConnection,ae)(ge,void 0,me),J.onDidRemoveConnection(v,void 0,me),Fe.event(ve.fire,ve,me),me.add(Fe)},onDidRemoveLastListener:()=>{me?.dispose(),me=void 0}});return ve.event}registerChannel(Z,ae){this.a.set(Z,ae);for(const K of this.f)K.channelServer.registerChannel(Z,ae)}dispose(){this.j.dispose();for(const Z of this.f)Z.channelClient.dispose(),Z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$Gh=I;class B{constructor(Z,ae,K=null){const H=new f;S(H,ae),Z.send(H.buffer),this.a=new P(Z,K),this.d=new U(Z,ae,K)}getChannel(Z){return this.a.getChannel(Z)}registerChannel(Z,ae){this.d.registerChannel(Z,ae)}dispose(){this.a.dispose(),this.d.dispose()}}t.$Hh=B;function X(re){return{call(Z,ae,K){return re.then(H=>H.call(Z,ae,K))},listen(Z,ae){const K=new m.$2d;return re.then(H=>K.input=H.listen(Z,ae)),K.event}}}t.$Ih=X;function Y(re){let Z=!1;return{call(ae,K,H){return Z?re.call(ae,K,H):(0,C.$4g)(0).then(()=>Z=!0).then(()=>re.call(ae,K,H))},listen(ae,K){if(Z)return re.listen(ae,K);const H=new m.$2d;return(0,C.$4g)(0).then(()=>Z=!0).then(()=>H.input=re.listen(ae,K)),H.event}}}t.$Jh=Y;class ue{constructor(Z){this.a=Z}routeCall(Z){return this.b(Z)}routeEvent(Z){return this.b(Z)}async b(Z){for(const ae of Z.connections)if(await Promise.resolve(this.a(ae.ctx)))return Promise.resolve(ae);return await m.Event.toPromise(Z.onDidAddConnection),await this.b(Z)}}t.$Kh=ue;var ne;(function(re){function Z(J,me,ve){const Fe=J,Ae=ve&&ve.disableMarshalling,ge=new Map;for(const v in Fe)K(v)&&ge.set(v,m.Event.buffer(Fe[v],!0,void 0,me));return new class{listen(v,i,r){const c=ge.get(i);if(c)return c;if(H(i)){const u=Fe[i];if(typeof u=="function")return u.call(Fe,r)}throw new k.$bb(`Event not found: ${i}`)}call(v,i,r){const c=Fe[i];if(typeof c=="function"){if(!Ae&&Array.isArray(r))for(let d=0;d<r.length;d++)r[d]=(0,y.$zh)(r[d]);let u=c.apply(Fe,r);return u instanceof Promise||(u=Promise.resolve(u)),u}throw new k.$bb(`Method not found: ${i}`)}}}re.fromService=Z;function ae(J,me){const ve=me&&me.disableMarshalling;return new Proxy({},{get(Fe,Ae){if(typeof Ae=="string")return me?.properties?.has(Ae)?me.properties.get(Ae):H(Ae)?function(ge){return J.listen(Ae,ge)}:K(Ae)?J.listen(Ae):async function(...ge){let v;me&&!(0,l.$Of)(me.context)?v=[me.context,...ge]:v=ge;const i=await J.call(Ae,v);return ve?i:(0,y.$zh)(i)};throw new k.$bb(`Property not found: ${String(Ae)}`)}})}re.toService=ae;function K(J){return J[0]==="o"&&J[1]==="n"&&L.$8e(J.charCodeAt(2))}function H(J){return/^onDynamic/.test(J)&&L.$8e(J.charCodeAt(9))}})(ne||(t.ProxyChannel=ne={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function we(re){if(Array.isArray(re))return re;if(re&&typeof re=="object"&&typeof re.toString=="function"){const Z=re.toString();if(Z!=="[object Object]")return Z}return re}function Te(re){return Array.isArray(re)?re.map(we):we(re)}function Pe(re,Z,ae,K,H,J,me){me=Te(me);const ve=te[H],Fe=ve[K%ve.length];let Ae=[`%c[${re}]%c[${String(Z).padStart(7," ")}]%c[len: ${String(ae).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${J}`,"color: darkgreen","color: grey","color: grey",`color: ${Fe}`];/\($/.test(J)?(Ae=Ae.concat(me),Ae.push(")")):Ae.push(me),console.log.apply(console,Ae)}class Oe{constructor(Z,ae){this.d=Z,this.f=ae,this.a=0,this.b=0}logOutgoing(Z,ae,K,H,J){this.b+=Z,Pe(this.d,this.b,Z,ae,K,H,J)}logIncoming(Z,ae,K,H,J){this.a+=Z,Pe(this.f,this.a,Z,ae,K,H,J)}}t.$Lh=Oe}),define(be[134],$e([1,0,33,4,67,90,30]),function(ie,t,A,C,n,j,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tU=void 0;class k extends n.$Hh{static f(){const w=C.Event.fromNodeEventEmitter(E.$O,"vscode:message",(y,L)=>A.$ge.wrap(L));return E.$O.send("vscode:hello"),new j.$pU(E.$O,w)}constructor(w){const y=k.f();super(y,w),this.b=y}dispose(){this.b.disconnect(),super.dispose()}}t.$tU=k}),define(be[135],$e([13,11]),function(ie,t){return ie.create("vs/platform/files/common/files",t)}),define(be[136],$e([13,11]),function(ie,t){return ie.create("vs/platform/theme/common/iconRegistry",t)}),define(be[40],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4h=t.$3h=t.$2h=t._util=void 0;var A;(function(E){E.serviceIds=new Map,E.DI_TARGET="$di$target",E.DI_DEPENDENCIES="$di$dependencies";function k(m){return m[E.DI_DEPENDENCIES]||[]}E.getServiceDependencies=k})(A||(t._util=A={})),t.$2h=n("instantiationService");function C(E,k,m){k[A.DI_TARGET]===k?k[A.DI_DEPENDENCIES].push({id:E,index:m}):(k[A.DI_DEPENDENCIES]=[{id:E,index:m}],k[A.DI_TARGET]=k)}function n(E){if(A.serviceIds.has(E))return A.serviceIds.get(E);const k=function(m,w,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(k,m,y)};return k.toString=()=>E,A.serviceIds.set(E,k),k}t.$3h=n;function j(E){return E}t.$4h=j}),define(be[137],$e([1,0,40]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hm=t.$Gm=t.$Fm=t.ID=void 0,t.ID="diagnosticsService",t.$Fm=(0,A.$3h)(t.ID);function C(j){return!!j.hostName&&!!j.errorMessage}t.$Gm=C;class n{async getPerformanceInfo(E,k){return{}}async getSystemInfo(E,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(E,k){return""}async getWorkspaceFileExtensions(E){return{extensions:[]}}async reportWorkspaceStats(E){}}t.$Hm=n}),define(be[138],$e([1,0,88,24,10,7,15,135,40,5,31,23]),function(ie,t,A,C,n,j,E,k,m,w,y,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wk=t.$Vk=t.$Uk=t.$Tk=t.$Sk=t.FileKind=t.$Rk=t.$Qk=t.$Pk=t.$Ok=t.$Nk=t.$Mk=t.$Lk=t.FileOperationResult=t.$Kk=t.$Jk=t.$Ik=t.$Hk=t.$Gk=t.FileChangeType=t.$Fk=t.FileOperation=t.$Ek=t.$Dk=t.$Ck=t.$Bk=t.$Ak=t.$zk=t.FileSystemProviderErrorCode=t.$yk=t.$xk=t.$wk=t.$vk=t.$uk=t.$tk=t.$sk=t.$rk=t.$qk=t.FileSystemProviderCapabilities=t.$pk=t.FilePermission=t.FileType=t.$ok=t.$nk=void 0,t.$nk=(0,m.$3h)("fileService");function l(H){return H.create===!0}t.$ok=l;var h;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(h||(t.FileType=h={}));var e;(function(H){H[H.Readonly=1]="Readonly",H[H.Locked=2]="Locked"})(e||(t.FilePermission=e={}));function s(H){const J=H;return!!J&&typeof J.onDidChange=="function"}t.$pk=s;var g;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileAtomicWrite=32768]="FileAtomicWrite",H[H.FileAtomicDelete=65536]="FileAtomicDelete",H[H.FileClone=131072]="FileClone"})(g||(t.FileSystemProviderCapabilities=g={}));function $(H){return!!(H.capabilities&2)}t.$qk=$;function o(H){return!!(H.capabilities&8)}t.$rk=o;function a(H){return!!(H.capabilities&131072)}t.$sk=a;function D(H){return!!(H.capabilities&4)}t.$tk=D;function b(H){return!!(H.capabilities&16)}t.$uk=b;function f(H){return $(H)?!!(H.capabilities&16384):!1}t.$vk=f;function N(H){return $(H)?!!(H.capabilities&32768):!1}t.$wk=N;function O(H){return!!(H.capabilities&65536)}t.$xk=O;function T(H){return!!(H.capabilities&2048)}t.$yk=T;var p;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsStorageQuota="EntryExceedsStorageQuota",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(p||(t.FileSystemProviderErrorCode=p={}));class S extends Error{static create(J,me){const ve=new S(J.toString(),me);return _(ve,me),ve}constructor(J,me){super(J),this.code=me}}t.$zk=S;function M(H,J){return S.create(H,J)}t.$Ak=M;function U(H){return H||M((0,k.localize)(0,null),p.Unknown)}t.$Bk=U;function _(H,J){return H.name=J?`${J} (FileSystemError)`:"FileSystemError",H}t.$Ck=_;function P(H){if(!H)return p.Unknown;if(H instanceof S)return H.code;const J=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!J)return p.Unknown;switch(J[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}t.$Dk=P;function I(H){if(H instanceof te)return H.fileOperationResult;switch(P(H)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 9;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileTooLarge:return 7;default:return 10}}t.$Ek=I;var B;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(B||(t.FileOperation=B={}));class X{constructor(J,me,ve){this.resource=J,this.operation=me,this.target=ve}isOperation(J){return this.operation===J}}t.$Fk=X;var Y;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(Y||(t.FileChangeType=Y={}));class ue{static{this.a=null}constructor(J,me){this.c=me,this.b=void 0,this.d=new L.$V(()=>{const ve=A.$9h.forUris(()=>this.c);return ve.fill(this.rawAdded.map(Fe=>[Fe,!0])),ve}),this.f=new L.$V(()=>{const ve=A.$9h.forUris(()=>this.c);return ve.fill(this.rawUpdated.map(Fe=>[Fe,!0])),ve}),this.g=new L.$V(()=>{const ve=A.$9h.forUris(()=>this.c);return ve.fill(this.rawDeleted.map(Fe=>[Fe,!0])),ve}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ve of J){switch(ve.type){case 1:this.rawAdded.push(ve.resource);break;case 0:this.rawUpdated.push(ve.resource);break;case 2:this.rawDeleted.push(ve.resource);break}this.b!==ue.a&&(typeof ve.cId=="number"?this.b===void 0?this.b=ve.cId:this.b!==ve.cId&&(this.b=ue.a):this.b!==void 0&&(this.b=ue.a))}}contains(J,...me){return this.h(J,{includeChildren:!1},...me)}affects(J,...me){return this.h(J,{includeChildren:!0},...me)}h(J,me,...ve){if(!J)return!1;const Fe=ve.length>0;return!!((!Fe||ve.includes(1))&&(this.d.value.get(J)||me.includeChildren&&this.d.value.findSuperstr(J))||(!Fe||ve.includes(0))&&(this.f.value.get(J)||me.includeChildren&&this.f.value.findSuperstr(J))||(!Fe||ve.includes(2))&&(this.g.value.findSubstr(J)||me.includeChildren&&this.g.value.findSuperstr(J)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(J){return this.b===J}hasCorrelation(){return typeof this.b=="number"}}t.$Gk=ue;function ne(H,J,me){return!H||!J||H===J||J.length>H.length?!1:(J.charAt(J.length-1)!==C.sep&&(J+=C.sep),me?(0,n.$0e)(H,J):H.indexOf(J)===0)}t.$Hk=ne;class te extends Error{constructor(J,me,ve){super(J),this.fileOperationResult=me,this.options=ve}}t.$Ik=te;class we extends te{constructor(J,me,ve,Fe){super(J,me,Fe),this.fileOperationResult=me,this.size=ve}}t.$Jk=we;class Te extends te{constructor(J,me,ve){super(J,2,ve),this.stat=me}}t.$Kk=Te;var Pe;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Pe||(t.FileOperationResult=Pe={})),t.$Lk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$Mk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$Nk="files.associations",t.$Ok="files.exclude",t.$Pk="files.readonlyInclude",t.$Qk="files.readonlyExclude",t.$Rk="files.readonlyFromPermissions";var Oe;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(Oe||(t.FileKind=Oe={})),t.$Sk="";function re(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}t.$Tk=re;async function Z(H,J){if(!J.hasProvider(E.URI.from({scheme:H.scheme})))return new Promise(me=>{const ve=J.onDidChangeFileSystemProviderRegistrations(Fe=>{Fe.scheme===H.scheme&&Fe.added&&(ve.dispose(),me())})})}t.$Uk=Z;class ae{static{this.KB=1024}static{this.MB=ae.KB*ae.KB}static{this.GB=ae.MB*ae.KB}static{this.TB=ae.GB*ae.KB}static formatSize(J){return(0,j.$Jf)(J)||(J=0),J<ae.KB?(0,k.localize)(1,null,J.toFixed(0)):J<ae.MB?(0,k.localize)(2,null,(J/ae.KB).toFixed(2)):J<ae.GB?(0,k.localize)(3,null,(J/ae.MB).toFixed(2)):J<ae.TB?(0,k.localize)(4,null,(J/ae.GB).toFixed(2)):(0,k.localize)(5,null,(J/ae.TB).toFixed(2))}}t.$Vk=ae;function K(H){const J=typeof H=="string"||H?.scheme===y.Schemas.vscodeRemote;return typeof H!="string"&&H?.scheme===y.Schemas.file?1024*ae.MB:J?10*ae.MB:w.$o?50*ae.MB:1024*ae.MB}t.$Wk=K}),define(be[139],$e([1,0,40]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$p$b=t.$o$b=void 0,t.$o$b=(0,A.$3h)("mainProcessService");class C{constructor(j,E){this.a=j,this.b=E}getChannel(j){return this.a.getChannel(j,this.b)}registerChannel(j,E){this.a.registerChannel(j,E)}}t.$p$b=C}),define(be[140],$e([1,0,2,134]),function(ie,t,A,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$q$b=void 0;class n extends A.$Sc{constructor(E){super(),this.a=this.B(new C.$tU(`window:${E}`))}getChannel(E){return this.a.getChannel(E)}registerChannel(E,k){this.a.registerChannel(E,k)}}t.$q$b=n});var Ei=this&&this.__param||function(ie,t){return function(A,C){t(A,C,ie)}};define(be[141],$e([1,0,67,139]),function(ie,t,A,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$u$b=void 0;let n=class{constructor(E,k){return this.windowId=E,A.ProxyChannel.toService(k.getChannel("nativeHost"),{context:E,properties:(()=>{const m=new Map;return m.set("windowId",E),m})()})}};t.$u$b=n,t.$u$b=n=Ye([Ei(1,C.$o$b)],n)}),define(be[68],$e([1,0,76,7]),function(ie,t,A,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vn=void 0;class n{constructor(){this.a=new Map}add(E,k){A.ok(C.$Ff(E)),A.ok(C.$Hf(k)),A.ok(!this.a.has(E),"There is already an extension with this id"),this.a.set(E,k)}knows(E){return this.a.has(E)}as(E){return this.a.get(E)||null}}t.$vn=new n}),define(be[142],$e([1,0,4,68]),function(ie,t,A,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wn=void 0,t.$wn={JSONContribution:"base.contributions.json"};function n(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class j{constructor(){this.b=new A.$Sd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,w){this.a[n(m)]=w,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const E=new j;C.$vn.add(t.$wn.JSONContribution,E)}),define(be[143],$e([1,0,9,17,18,4,7,15,136,142,68]),function(ie,t,A,C,n,j,E,k,m,w,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rw=t.$qw=t.$pw=t.$ow=t.$nw=t.$mw=t.$lw=t.$kw=t.IconFontDefinition=t.IconContribution=t.$jw=void 0,t.$jw={IconContribution:"base.contributions.icons"};var L;(function(D){function b(f,N){let O=f.defaults;for(;n.ThemeIcon.isThemeIcon(O);){const T=e.getIcon(O.id);if(!T)return;O=T.defaults}return O}D.getDefinition=b})(L||(t.IconContribution=L={}));var l;(function(D){function b(N){return{weight:N.weight,style:N.style,src:N.src.map(O=>({format:O.format,location:O.location.toString()}))}}D.toJSONObject=b;function f(N){const O=T=>(0,E.$Ff)(T)?T:void 0;if(N&&Array.isArray(N.src)&&N.src.every(T=>(0,E.$Ff)(T.format)&&(0,E.$Ff)(T.location)))return{weight:O(N.weight),style:O(N.style),src:N.src.map(T=>({format:T.format,location:k.URI.parse(T.location)}))}}D.fromJSONObject=f})(l||(t.IconFontDefinition=l={}));class h{constructor(){this.a=new j.$Sd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,m.localize)(0,null)},fontCharacter:{type:"string",description:(0,m.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${n.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(b,f,N,O){const T=this.b[b];if(T){if(N&&!T.description){T.description=N,this.d.properties[b].markdownDescription=`${N} $(${b})`;const M=this.e.enum.indexOf(b);M!==-1&&(this.e.enumDescriptions[M]=N),this.a.fire()}return T}const p={id:b,description:N,defaults:f,deprecationMessage:O};this.b[b]=p;const S={$ref:"#/definitions/icons"};return O&&(S.deprecationMessage=O),N&&(S.markdownDescription=`${N}: $(${b})`),this.d.properties[b]=S,this.e.enum.push(b),this.e.enumDescriptions.push(N||""),this.a.fire(),{id:b}}deregisterIcon(b){delete this.b[b],delete this.d.properties[b];const f=this.e.enum.indexOf(b);f!==-1&&(this.e.enum.splice(f,1),this.e.enumDescriptions.splice(f,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(b=>this.b[b])}getIcon(b){return this.b[b]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(b,f){const N=this.f[b];return N||(this.f[b]=f,this.a.fire(),f)}deregisterIconFont(b){delete this.f[b]}getIconFont(b){return this.f[b]}toString(){const b=(T,p)=>T.id.localeCompare(p.id),f=T=>{for(;n.ThemeIcon.isThemeIcon(T.defaults);)T=this.b[T.defaults.id];return`codicon codicon-${T?T.id:""}`},N=[];N.push("| preview     | identifier                        | default codicon ID                | description"),N.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const O=Object.keys(this.b).map(T=>this.b[T]);for(const T of O.filter(p=>!!p.description).sort(b))N.push(`|<i class="${f(T)}"></i>|${T.id}|${n.ThemeIcon.isThemeIcon(T.defaults)?T.defaults.id:T.id}|${T.description||""}|`);N.push("| preview     | identifier                        "),N.push("| ----------- | --------------------------------- |");for(const T of O.filter(p=>!n.ThemeIcon.isThemeIcon(p.defaults)).sort(b))N.push(`|<i class="${f(T)}"></i>|${T.id}|`);return N.join(`
`)}}const e=new h;y.$vn.add(t.$jw.IconContribution,e);function s(D,b,f,N){return e.registerIcon(D,b,f,N)}t.$kw=s;function g(){return e}t.$lw=g;function $(){const D=(0,C.$7j)();for(const b in D){const f="\\"+D[b].toString(16);e.registerIcon(b,{fontCharacter:f})}}$(),t.$mw="vscode://schemas/icons";const o=y.$vn.as(w.$wn.JSONContribution);o.registerSchema(t.$mw,e.getIconSchema());const a=new A.$ch(()=>o.notifySchemaChanged(t.$mw),200);e.onDidChange(()=>{a.isScheduled()||a.schedule()}),t.$nw=s("widget-close",C.$9j.close,(0,m.localize)(2,null)),t.$ow=s("goto-previous-location",C.$9j.arrowUp,(0,m.localize)(3,null)),t.$pw=s("goto-next-location",C.$9j.arrowDown,(0,m.localize)(4,null)),t.$qw=n.ThemeIcon.modify(C.$9j.sync,"spin"),t.$rw=n.ThemeIcon.modify(C.$9j.loading,"spin")}),define(be[144],$e([1,0,3,4,2,18,143]),function(ie,t,A,C,n,j,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GEb=t.$FEb=void 0;function k(w){const y=new n.$Rc,L=y.add(new C.$Sd),l=(0,E.$lw)();return y.add(l.onDidChange(()=>L.fire())),w&&y.add(w.onDidProductIconThemeChange(()=>L.fire())),{dispose:()=>y.dispose(),onDidChange:L.event,getCSS(){const h=w?w.getProductIconTheme():new m,e={},s=$=>{const o=h.getIcon($);if(!o)return;const a=o.font;return a?(e[a.id]=a.definition,`.codicon-${$.id}:before { content: '${o.fontCharacter}'; font-family: ${(0,A.$CQ)(a.id)}; }`):`.codicon-${$.id}:before { content: '${o.fontCharacter}'; }`},g=[];for(const $ of l.getIcons()){const o=s($);o&&g.push(o)}for(const $ in e){const o=e[$],a=o.weight?`font-weight: ${o.weight};`:"",D=o.style?`font-style: ${o.style};`:"",b=o.src.map(f=>`${(0,A.$BQ)(f.location)} format('${f.format}')`).join(", ");g.push(`@font-face { src: ${b}; font-family: ${(0,A.$CQ)($)};${a}${D} font-display: block; }`)}return g.join(`
`)}}}t.$FEb=k;class m{getIcon(y){const L=(0,E.$lw)();let l=y.defaults;for(;j.ThemeIcon.isThemeIcon(l);){const h=L.getIcon(l.id);if(!h)return;l=h.defaults}return l}}t.$GEb=m}),define(be[145],$e([1,0,5]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IC=t.$HC=t.$GC=t.$FC=t.$EC=t.$DC=t.$CC=t.$BC=t.$AC=t.$zC=void 0,t.$zC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function C(l){return typeof l.parentId=="number"}t.$AC=C;function n(l){return!!l.workspaceUri}t.$BC=n;function j(l){return!!l.folderUri}t.$CC=j;function E(l){return!!l.fileUri}t.$DC=E;function k(l){const h=m(l),e=l.getValue("window.menuBarVisibility");return e==="default"||h==="native"&&e==="compact"||A.$j&&A.$m?"classic":e}t.$EC=k;function m(l){if(A.$o)return"custom";const h=l.getValue("window");if(h){if(A.$j&&h.nativeTabs===!0||A.$j&&h.nativeFullScreen===!1)return"native";const g=h.titleBarStyle;if(g==="native"||g==="custom")return g}return A.$k?"native":"custom"}t.$FC=m;function w(l){return!(!A.$i||A.$o||m(l)==="native")}t.$GC=w;function y(l){const h=l.getValue("window");return!h||typeof h.nativeFullScreen!="boolean"||h.nativeTabs?!0:h.nativeFullScreen!==!1}t.$HC=y;function L(l=0){return Math.pow(1.2,l)}t.$IC=L}),define(be[146],$e([1,0,16,3,21,30,145]),function(ie,t,A,C,n,j,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$y$b=t.$x$b=t.$w$b=void 0;function k(L){for(const{window:l}of(0,C.getWindows)())m(l)?.webFrame?.setZoomLevel(L);(0,A.$ZO)((0,E.$IC)(L)),(0,A.$WO)(L)}t.$w$b=k;function m(L){if(L===n.$QO)return{ipcRenderer:j.$O,webFrame:j.$Q};{const l=L;if(l?.vscode?.ipcRenderer&&l?.vscode?.webFrame)return l.vscode}}function w(){k((0,A.$XO)()+1)}t.$x$b=w;function y(){k((0,A.$XO)()-1)}t.$y$b=y}),define(be[147],$e([1,0,11,3,133,9,91,30,137,138,140,141,144,146,14,21,104,95]),function(ie,t,A,C,n,j,E,k,m,w,y,L,l,h,e,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const g=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,$=/\s--inspect-port=(?<port>\d+)/;class o{getHeight(P){return 22}getTemplateId(P){return p(P)?"process":O(P)?"machine":(0,m.$Gm)(P)?"error":T(P)?"header":""}}class a{hasChildren(P){return(0,m.$Gm)(P)?!1:p(P)?!!P.children?.length:!0}getChildren(P){return p(P)?P.children?P.children:[]:(0,m.$Gm)(P)?[]:T(P)?P.processRoots.length>1?P.processRoots:[P.processRoots[0].rootProcess]:O(P)?[P.rootProcess]:[P.processes]}}class D{constructor(){this.templateId="header"}renderTemplate(P){const I=(0,C.$lQ)(P,(0,C.$)(".row")),B=(0,C.$lQ)(I,(0,C.$)(".nameLabel")),X=(0,C.$lQ)(I,(0,C.$)(".cpu")),Y=(0,C.$lQ)(I,(0,C.$)(".memory")),ue=(0,C.$lQ)(I,(0,C.$)(".pid"));return{name:B,CPU:X,memory:Y,PID:ue}}renderElement(P,I,B,X){B.name.textContent=(0,A.localize)(0,null),B.CPU.textContent=(0,A.localize)(1,null),B.PID.textContent=(0,A.localize)(2,null),B.memory.textContent=(0,A.localize)(3,null)}disposeTemplate(P){}}class b{constructor(){this.templateId="machine"}renderTemplate(P){const I=Object.create(null),B=(0,C.$lQ)(P,(0,C.$)(".row"));return I.name=(0,C.$lQ)(B,(0,C.$)(".nameLabel")),I}renderElement(P,I,B,X){B.name.textContent=P.element.name}disposeTemplate(P){}}class f{constructor(){this.templateId="error"}renderTemplate(P){const I=Object.create(null),B=(0,C.$lQ)(P,(0,C.$)(".row"));return I.name=(0,C.$lQ)(B,(0,C.$)(".nameLabel")),I}renderElement(P,I,B,X){B.name.textContent=P.element.errorMessage}disposeTemplate(P){}}class N{constructor(P,I,B){this.a=P,this.b=I,this.c=B,this.templateId="process"}renderTemplate(P){const I=(0,C.$lQ)(P,(0,C.$)(".row")),B=(0,C.$lQ)(I,(0,C.$)(".nameLabel")),X=(0,C.$lQ)(I,(0,C.$)(".cpu")),Y=(0,C.$lQ)(I,(0,C.$)(".memory")),ue=(0,C.$lQ)(I,(0,C.$)(".pid"));return{name:B,CPU:X,PID:ue,memory:Y}}renderElement(P,I,B,X){const{element:Y}=P,ue=Y.pid.toFixed(0);let ne=Y.name;this.c.has(Y.pid)&&(ne=this.c.get(Y.pid)),B.name.textContent=ne,B.name.title=Y.cmd,B.CPU.textContent=Y.load.toFixed(0),B.PID.textContent=ue,B.PID.parentElement.id=`pid-${ue}`;const te=this.a==="win32"?Y.mem:this.b*(Y.mem/100);B.memory.textContent=(te/w.$Vk.MB).toFixed(0)}disposeTemplate(P){}}function O(_){return!!_.name&&!!_.rootProcess}function T(_){return!!_.processRoots}function p(_){return!!_.pid}class S{constructor(P,I){this.f=I,this.b=new Map;const B=new y.$q$b(P);this.c=new L.$u$b(P,B),this.k(I.styles),this.g(I),k.$O.on("vscode:pidToNameResponse",(X,Y)=>{this.b.clear();for(const[ue,ne]of Y)this.b.set(ue,ne)}),k.$O.on("vscode:listProcessesResponse",async(X,Y)=>{Y.forEach((ue,ne)=>{p(ue.rootProcess)&&(ue.rootProcess.name=ne===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:Y}}),this.d.layout(s.$QO.innerHeight,s.$QO.innerWidth)):await this.h(Y),this.m(0)}),this.a=Date.now(),k.$O.send("vscode:pidToNameRequest"),k.$O.send("vscode:listProcesses")}g(P){s.$QO.document.onkeydown=I=>{const B=P.platform==="darwin"?I.metaKey:I.ctrlKey;B&&I.keyCode===87&&(I.stopPropagation(),I.preventDefault(),k.$O.send("vscode:closeProcessExplorer")),B&&I.keyCode===187&&(0,h.$x$b)(),B&&I.keyCode===189&&(0,h.$y$b)()}}async h(P){const I=s.$QO.document.getElementById("process-list");if(!I)return;const{totalmem:B}=await this.c.getOSStatistics(),X=[new N(this.f.platform,B,this.b),new D,new b,new f];this.d=new n.$MT("processExplorer",I,new o,X,new a,{identityProvider:{getId:Y=>p(Y)?Y.pid.toString():(0,m.$Gm)(Y)?Y.hostName:T(Y)?"processes":O(Y)?Y.name:"header"}}),this.d.setInput({processes:{processRoots:P}}),this.d.layout(s.$QO.innerHeight,s.$QO.innerWidth),this.d.onKeyDown(Y=>{const ue=new e.$iP(Y);if(ue.keyCode===35&&ue.altKey){const ne=this.n();Promise.all(ne.map(te=>this.c.killProcess(te,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(Y=>{p(Y.element)&&this.l(Y.element,!0)}),I.style.height=`${s.$QO.innerHeight}px`,s.$QO.addEventListener("resize",()=>{I.style.height=`${s.$QO.innerHeight}px`,this.d?.layout(s.$QO.innerHeight,s.$QO.innerWidth)})}i(P){const I=g.exec(P);return I&&I.groups.port!=="0"||P.indexOf("node ")>=0||P.indexOf("node.exe")>=0}j(P){const I={type:"node",request:"attach",name:`process ${P.pid}`};let B=g.exec(P.cmd);B?I.port=Number(B.groups.port):I.processId=String(P.pid),B=$.exec(P.cmd),B&&(I.port=Number(B.groups.port)),k.$O.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[I]})}k(P){const I=(0,C.$6P)(),B=[];P.listFocusBackground&&(B.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${P.listFocusBackground}; }`),B.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${P.listFocusBackground}; }`)),P.listFocusForeground&&B.push(`.monaco-list:focus .monaco-list-row.focused { color: ${P.listFocusForeground}; }`),P.listActiveSelectionBackground&&(B.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${P.listActiveSelectionBackground}; }`),B.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${P.listActiveSelectionBackground}; }`)),P.listActiveSelectionForeground&&B.push(`.monaco-list:focus .monaco-list-row.selected { color: ${P.listActiveSelectionForeground}; }`),P.listHoverBackground&&B.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${P.listHoverBackground}; }`),P.listHoverForeground&&B.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${P.listHoverForeground}; }`),P.listFocusOutline&&B.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${P.listFocusOutline}; outline-offset: -1px; }`),P.listHoverOutline&&B.push(`.monaco-list-row:hover { outline: 1px dashed ${P.listHoverOutline}; outline-offset: -1px; }`),P.scrollbarShadowColor&&B.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${P.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${P.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${P.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),P.scrollbarSliderBackgroundColor&&B.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${P.scrollbarSliderBackgroundColor};
				}
			`),P.scrollbarSliderHoverBackgroundColor&&B.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${P.scrollbarSliderHoverBackgroundColor};
				}
			`),P.scrollbarSliderActiveBackgroundColor&&B.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${P.scrollbarSliderActiveBackgroundColor};
				}
			`),I.textContent=B.join(`
`),P.color&&(s.$QO.document.body.style.color=P.color)}l(P,I){const B=[],X=Number(P.pid);I&&(B.push({accelerator:"Alt+E",label:(0,A.localize)(4,null),click:()=>{this.c.killProcess(X,"SIGTERM")}}),B.push({label:(0,A.localize)(5,null),click:()=>{this.c.killProcess(X,"SIGKILL")}}),B.push({type:"separator"})),B.push({label:(0,A.localize)(6,null),click:()=>{const Y=this.n();Y?.includes(X)||(Y.length=0,Y.push(X));const ue=Y?.map(ne=>s.$QO.document.getElementById(`pid-${ne}`)).filter(ne=>!!ne);if(ue){const ne=ue.map(te=>te.innerText).filter(te=>!!te);this.c.writeClipboardText(ne.join(`
`))}}}),B.push({label:(0,A.localize)(7,null),click:()=>{const Y=s.$QO.document.getElementById("process-list");Y&&this.c.writeClipboardText(Y.innerText)}}),P&&I&&this.i(P.cmd)&&(B.push({type:"separator"}),B.push({label:(0,A.localize)(8,null),click:()=>{this.j(P)}})),(0,E.$lU)(B)}m(P){setTimeout(()=>{const I=Date.now(),B=P+I-this.a;this.a=I,B>1e3?(k.$O.send("vscode:pidToNameRequest"),k.$O.send("vscode:listProcesses")):this.m(B)},200)}n(){return this.d?.getSelection()?.map(P=>{if(!(!P||!("pid"in P)))return P.pid}).filter(P=>!!P)}}function M(){const _=(0,C.$6P)();_.id="codiconStyles";const P=(0,l.$FEb)(void 0);function I(){_.textContent=P.getCSS()}const B=new j.$ch(I,0);P.onDidChange(()=>B.schedule()),B.schedule()}function U(_){const P=_.data.platform==="win32"?"windows":_.data.platform==="linux"?"linux":"mac";s.$QO.document.body.classList.add(P),M(),(0,h.$w$b)(_.data.zoomLevel),new S(_.windowId,_.data)}t.startup=U})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a017b12b9caa3475675cfe6fda014fcf5af388c9/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
