/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","fs","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain"],ne=function(G){for(var e=[],L=0,D=G.length;L<D;L++)e[L]=te[G[L]];return e};define(te[70],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class L{static get(){const R=new Map,N=new Map,A=new Map,E=new Map;function h(f,S){f.has(S.detail)||f.set(S.detail,-S.timestamp)}function c(f,S){const v=f.get(S.detail);v&&(v>=0||f.set(S.detail,v+S.timestamp))}let P=[];typeof G=="function"&&typeof G.getStats=="function"&&(P=G.getStats().slice(0).sort((f,S)=>f.timestamp-S.timestamp));for(const f of P)switch(f.type){case 10:h(R,f);break;case 11:case 12:c(R,f);break;case 21:h(N,f);break;case 22:c(N,f);break;case 33:h(A,f);break;case 34:c(A,f);break;case 31:h(E,f);break;case 32:c(E,f);break}let I=0;A.forEach(f=>I+=f);function d(f){const S=[];return f.forEach((v,p)=>S.push([p,v])),S}return{amdLoad:d(R),amdInvoke:d(N),nodeRequire:d(A),nodeEval:d(E),nodeRequireTotal:I}}static toMarkdownTable(R,N){let A="";const E=[];return R.forEach((h,c)=>{E[c]=h.length}),N.forEach(h=>{h.forEach((c,P)=>{typeof c>"u"&&(c=h[P]="-");const I=c.toString().length;E[P]=Math.max(I,E[P])})}),R.forEach((h,c)=>{A+=`| ${h+" ".repeat(E[c]-h.toString().length)} `}),A+=`|
`,R.forEach((h,c)=>{A+=`| ${"-".repeat(E[c])} `}),A+=`|
`,N.forEach(h=>{h.forEach((c,P)=>{typeof c<"u"&&(A+=`| ${c+" ".repeat(E[P]-c.toString().length)} `)}),A+=`|
`}),A}}e.$U=L}),define(te[52],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.$vh=e.$uh=void 0;function L(A){return(E,h,c)=>{let P=null,I=null;if(typeof c.value=="function"?(P="value",I=c.value):typeof c.get=="function"&&(P="get",I=c.get),!I)throw new Error("not supported");c[P]=A(I,h)}}function D(A,E,h){let c=null,P=null;if(typeof h.value=="function"?(c="value",P=h.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(c="get",P=h.get),!P)throw new Error("not supported");const I=`$memoize$${E}`;h[c]=function(...d){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,d)}),this[I]}}e.$uh=D;function R(A,E,h){return L((c,P)=>{const I=`$debounce$${P}`,d=`$debounce$result$${P}`;return function(...f){this[d]||(this[d]=h?h():void 0),clearTimeout(this[I]),E&&(this[d]=E(this[d],...f),f=[this[d]]),this[I]=setTimeout(()=>{c.apply(this,f),this[d]=h?h():void 0},A)}})}e.$vh=R;function N(A,E,h){return L((c,P)=>{const I=`$throttle$timer$${P}`,d=`$throttle$result$${P}`,f=`$throttle$lastRun$${P}`,S=`$throttle$pending$${P}`;return function(...v){if(this[d]||(this[d]=h?h():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),E&&(this[d]=E(this[d],...v)),this[S])return;const p=this[f]+A;p<=Date.now()?(this[f]=Date.now(),c.apply(this,[this[d]]),this[d]=h?h():void 0):(this[S]=!0,this[I]=setTimeout(()=>{this[S]=!1,this[f]=Date.now(),c.apply(this,[this[d]]),this[d]=h?h():void 0},p-Date.now()))}})}e.$wh=N}),define(te[71],ne([0,1,9]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=e.$7c=e.$6c=e.$5c=e.ok=void 0;function D(h,c){if(!h)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=D;function R(h,c="Unreachable"){throw new Error(c)}e.$5c=R;function N(h){if(!h)throw new L.$cb("Assertion Failed")}e.$6c=N;function A(h){if(!h()){debugger;h(),(0,L.$1)(new L.$cb("Assertion Failed"))}}e.$7c=A;function E(h,c){let P=0;for(;P<h.length-1;){const I=h[P],d=h[P+1];if(!c(I,d))return!1;P++}return!0}e.$8c=E}),define(te[53],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var D;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var R;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var N;(function(s){s.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function A(s,o=!1){let t=0;const i=s.length;let n="",r=0,l=16,k=0;function b(se){let ue=0,ce=0;for(;ue<se;){const oe=s.charCodeAt(t);if(oe>=48&&oe<=57)ce=ce*16+oe-48;else if(oe>=65&&oe<=70)ce=ce*16+oe-65+10;else if(oe>=97&&oe<=102)ce=ce*16+oe-97+10;else break;t++,ue++}return ue<se&&(ce=-1),ce}function w(se){t=se,n="",r=0,l=16,k=0}function j(){const se=t;if(s.charCodeAt(t)===48)t++;else for(t++;t<s.length&&c(s.charCodeAt(t));)t++;if(t<s.length&&s.charCodeAt(t)===46)if(t++,t<s.length&&c(s.charCodeAt(t)))for(t++;t<s.length&&c(s.charCodeAt(t));)t++;else return k=3,s.substring(se,t);let ue=t;if(t<s.length&&(s.charCodeAt(t)===69||s.charCodeAt(t)===101))if(t++,(t<s.length&&s.charCodeAt(t)===43||s.charCodeAt(t)===45)&&t++,t<s.length&&c(s.charCodeAt(t))){for(t++;t<s.length&&c(s.charCodeAt(t));)t++;ue=t}else k=3;return s.substring(se,ue)}function H(){let se="",ue=t;for(;;){if(t>=i){se+=s.substring(ue,t),k=2;break}const ce=s.charCodeAt(t);if(ce===34){se+=s.substring(ue,t),t++;break}if(ce===92){if(se+=s.substring(ue,t),t++,t>=i){k=2;break}switch(s.charCodeAt(t++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:{const q=b(4);q>=0?se+=String.fromCharCode(q):k=4;break}default:k=5}ue=t;continue}if(ce>=0&&ce<=31)if(h(ce)){se+=s.substring(ue,t),k=2;break}else k=6;t++}return se}function ee(){if(n="",k=0,r=t,t>=i)return r=i,l=17;let se=s.charCodeAt(t);if(E(se)){do t++,n+=String.fromCharCode(se),se=s.charCodeAt(t);while(E(se));return l=15}if(h(se))return t++,n+=String.fromCharCode(se),se===13&&s.charCodeAt(t)===10&&(t++,n+=`
`),l=14;switch(se){case 123:return t++,l=1;case 125:return t++,l=2;case 91:return t++,l=3;case 93:return t++,l=4;case 58:return t++,l=6;case 44:return t++,l=5;case 34:return t++,n=H(),l=10;case 47:{const ue=t-1;if(s.charCodeAt(t+1)===47){for(t+=2;t<i&&!h(s.charCodeAt(t));)t++;return n=s.substring(ue,t),l=12}if(s.charCodeAt(t+1)===42){t+=2;const ce=i-1;let oe=!1;for(;t<ce;){if(s.charCodeAt(t)===42&&s.charCodeAt(t+1)===47){t+=2,oe=!0;break}t++}return oe||(t++,k=1),n=s.substring(ue,t),l=13}return n+=String.fromCharCode(se),t++,l=16}case 45:if(n+=String.fromCharCode(se),t++,t===i||!c(s.charCodeAt(t)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=j(),l=11;default:for(;t<i&&_(se);)t++,se=s.charCodeAt(t);if(r!==t){switch(n=s.substring(r,t),n){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return n+=String.fromCharCode(se),t++,l=16}}function _(se){if(E(se)||h(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let se;do se=ee();while(se>=12&&se<=15);return se}return{setPosition:w,getPosition:()=>t,scan:o?re:ee,getToken:()=>l,getTokenValue:()=>n,getTokenOffset:()=>r,getTokenLength:()=>t-r,getTokenError:()=>k}}e.$0m=A;function E(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function h(s){return s===10||s===13||s===8232||s===8233}function c(s){return s>=48&&s<=57}var P;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(P||(P={}));function I(s,o){const t=[],i=new Object;let n;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function k(b,w,j,H){r.value=b,r.offset=w,r.length=j,r.type=H,r.colonOffset=void 0,n=r}try{O(s,{onObjectBegin:(b,w)=>{if(o<=b)throw i;n=void 0,l=o>b,t.push("")},onObjectProperty:(b,w,j)=>{if(o<w||(k(b,w,j,"property"),t[t.length-1]=b,o<=w+j))throw i},onObjectEnd:(b,w)=>{if(o<=b)throw i;n=void 0,t.pop()},onArrayBegin:(b,w)=>{if(o<=b)throw i;n=void 0,t.push(0)},onArrayEnd:(b,w)=>{if(o<=b)throw i;n=void 0,t.pop()},onLiteralValue:(b,w,j)=>{if(o<w||(k(b,w,j,y(b)),o<=w+j))throw i},onSeparator:(b,w,j)=>{if(o<=w)throw i;if(b===":"&&n&&n.type==="property")n.colonOffset=w,l=!1,n=void 0;else if(b===","){const H=t[t.length-1];typeof H=="number"?t[t.length-1]=H+1:(l=!0,t[t.length-1]=""),n=void 0}}})}catch(b){if(b!==i)throw b}return{path:t,previousNode:n,isAtPropertyKey:l,matches:b=>{let w=0;for(let j=0;w<b.length&&j<t.length;j++)if(b[w]===t[j]||b[w]==="*")w++;else if(b[w]!=="**")return!1;return w===b.length}}}e.$$m=I;function d(s,o=[],t=N.DEFAULT){let i=null,n=[];const r=[];function l(b){Array.isArray(n)?n.push(b):i!==null&&(n[i]=b)}return O(s,{onObjectBegin:()=>{const b={};l(b),r.push(n),n=b,i=null},onObjectProperty:b=>{i=b},onObjectEnd:()=>{n=r.pop()},onArrayBegin:()=>{const b=[];l(b),r.push(n),n=b,i=null},onArrayEnd:()=>{n=r.pop()},onLiteralValue:l,onError:(b,w,j)=>{o.push({error:b,offset:w,length:j})}},t),n[0]}e.$_m=d;function f(s,o=[],t=N.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(b){i.type==="property"&&(i.length=b-i.offset,i=i.parent)}function r(b){return i.children.push(b),b}O(s,{onObjectBegin:b=>{i=r({type:"object",offset:b,length:-1,parent:i,children:[]})},onObjectProperty:(b,w,j)=>{i=r({type:"property",offset:w,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:b,offset:w,length:j,parent:i})},onObjectEnd:(b,w)=>{i.length=b+w-i.offset,i=i.parent,n(b+w)},onArrayBegin:(b,w)=>{i=r({type:"array",offset:b,length:-1,parent:i,children:[]})},onArrayEnd:(b,w)=>{i.length=b+w-i.offset,i=i.parent,n(b+w)},onLiteralValue:(b,w,j)=>{r({type:y(b),offset:w,length:j,parent:i,value:b}),n(w+j)},onSeparator:(b,w,j)=>{i.type==="property"&&(b===":"?i.colonOffset=w:b===","&&n(w))},onError:(b,w,j)=>{o.push({error:b,offset:w,length:j})}},t);const k=i.children[0];return k&&delete k.parent,k}e.$an=f;function S(s,o){if(!s)return;let t=s;for(const i of o)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let n=!1;for(const r of t.children)if(Array.isArray(r.children)&&r.children[0].value===i){t=r.children[1],n=!0;break}if(!n)return}else{const n=i;if(t.type!=="array"||n<0||!Array.isArray(t.children)||n>=t.children.length)return;t=t.children[n]}return t}e.$bn=S;function v(s){if(!s.parent||!s.parent.children)return[];const o=v(s.parent);if(s.parent.type==="property"){const t=s.parent.children[0].value;o.push(t)}else if(s.parent.type==="array"){const t=s.parent.children.indexOf(s);t!==-1&&o.push(t)}return o}e.$cn=v;function p(s){switch(s.type){case"array":return s.children.map(p);case"object":{const o=Object.create(null);for(const t of s.children){const i=t.children[1];i&&(o[t.children[0].value]=p(i))}return o}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$dn=p;function u(s,o,t=!1){return o>=s.offset&&o<s.offset+s.length||t&&o===s.offset+s.length}e.$en=u;function $(s,o,t=!1){if(u(s,o,t)){const i=s.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=o;n++){const r=$(i[n],o,t);if(r)return r}return s}}e.$fn=$;function O(s,o,t=N.DEFAULT){const i=A(s,!1);function n(Q){return Q?()=>Q(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(Q){return Q?K=>Q(K,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=n(o.onObjectBegin),k=r(o.onObjectProperty),b=n(o.onObjectEnd),w=n(o.onArrayBegin),j=n(o.onArrayEnd),H=r(o.onLiteralValue),ee=r(o.onSeparator),_=n(o.onComment),re=r(o.onError),se=t&&t.disallowComments,ue=t&&t.allowTrailingComma;function ce(){for(;;){const Q=i.scan();switch(i.getTokenError()){case 4:oe(14);break;case 5:oe(15);break;case 3:oe(13);break;case 1:se||oe(11);break;case 2:oe(12);break;case 6:oe(16);break}switch(Q){case 12:case 13:se?oe(10):_();break;case 16:oe(1);break;case 15:case 14:break;default:return Q}}}function oe(Q,K=[],C=[]){if(re(Q),K.length+C.length>0){let F=i.getToken();for(;F!==17;){if(K.indexOf(F)!==-1){ce();break}else if(C.indexOf(F)!==-1)break;F=ce()}}}function q(Q){const K=i.getTokenValue();return Q?H(K):k(K),ce(),!0}function X(){switch(i.getToken()){case 11:{let Q=0;try{Q=JSON.parse(i.getTokenValue()),typeof Q!="number"&&(oe(2),Q=0)}catch{oe(2)}H(Q);break}case 7:H(null);break;case 8:H(!0);break;case 9:H(!1);break;default:return!1}return ce(),!0}function T(){return i.getToken()!==10?(oe(3,[],[2,5]),!1):(q(!1),i.getToken()===6?(ee(":"),ce(),J()||oe(4,[],[2,5])):oe(5,[],[2,5]),!0)}function M(){l(),ce();let Q=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Q||oe(4,[],[]),ee(","),ce(),i.getToken()===2&&ue)break}else Q&&oe(6,[],[]);T()||oe(4,[],[2,5]),Q=!0}return b(),i.getToken()!==2?oe(7,[2],[]):ce(),!0}function V(){w(),ce();let Q=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Q||oe(4,[],[]),ee(","),ce(),i.getToken()===4&&ue)break}else Q&&oe(6,[],[]);J()||oe(4,[],[4,5]),Q=!0}return j(),i.getToken()!==4?oe(8,[4],[]):ce(),!0}function J(){switch(i.getToken()){case 3:return V();case 1:return M();case 10:return q(!0);default:return X()}}return ce(),i.getToken()===17?t.allowEmptyContent?!0:(oe(4,[],[]),!1):J()?(i.getToken()!==17&&oe(9,[],[]),!0):(oe(4,[],[]),!1)}e.$gn=O;function g(s,o){const t=A(s),i=[];let n,r=0,l;do switch(l=t.getPosition(),n=t.scan(),n){case 12:case 13:case 17:r!==l&&i.push(s.substring(r,l)),o!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,o)),r=t.getPosition();break}while(n!==17);return i.join("")}e.$hn=g;function y(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$in=y}),define(te[72],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8l=e.$7l=e.$6l=e.rot=e.$4l=void 0;function L(E,h,c){return Math.min(Math.max(E,h),c)}e.$4l=L;function D(E,h){return(h+E%h)%h}e.rot=D;class R{constructor(){this.a=0}getNext(){return this.a++}}e.$6l=R;class N{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$7l=N;class A{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const c=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$8l=A}),function(){function G(R){const N=[];typeof R=="number"&&N.push("code/timeOrigin",R);function A(h){N.push(h,Date.now())}function E(){const h=[];for(let c=0;c<N.length;c+=2)h.push({name:N[c],startTime:N[c+1]});return h}return{mark:A,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const A of performance.getEntriesByType("mark"))N.push({name:A.name,startTime:Math.round(R+A.startTime)});return N}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function L(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=L(D))}(),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var D in L)(typeof exports=="object"?exports:G)[D]=L[D]}}(typeof self<"u"?self:this,function(){return function(G){var e={};function L(D){if(e[D])return e[D].exports;var R=e[D]={i:D,l:!1,exports:{}};return G[D].call(R.exports,R,R.exports,L),R.l=!0,R.exports}return L.m=G,L.c=e,L.d=function(D,R,N){L.o(D,R)||Object.defineProperty(D,R,{enumerable:!0,get:N})},L.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},L.t=function(D,R){if(1&R&&(D=L(D)),8&R||4&R&&typeof D=="object"&&D&&D.__esModule)return D;var N=Object.create(null);if(L.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:D}),2&R&&typeof D!="string")for(var A in D)L.d(N,A,function(E){return D[E]}.bind(null,A));return N},L.n=function(D){var R=D&&D.__esModule?function(){return D.default}:function(){return D};return L.d(R,"a",R),R},L.o=function(D,R){return Object.prototype.hasOwnProperty.call(D,R)},L.p="",L(L.s=0)}([function(G,e,L){(function(D){var R;e=G.exports=C,R=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],h=e.src=[],c=0,P=c++;h[P]="0|[1-9]\\d*";var I=c++;h[I]="[0-9]+";var d=c++;h[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=c++;h[f]="("+h[P]+")\\.("+h[P]+")\\.("+h[P]+")";var S=c++;h[S]="("+h[I]+")\\.("+h[I]+")\\.("+h[I]+")";var v=c++;h[v]="(?:"+h[P]+"|"+h[d]+")";var p=c++;h[p]="(?:"+h[I]+"|"+h[d]+")";var u=c++;h[u]="(?:-("+h[v]+"(?:\\."+h[v]+")*))";var $=c++;h[$]="(?:-?("+h[p]+"(?:\\."+h[p]+")*))";var O=c++;h[O]="[0-9A-Za-z-]+";var g=c++;h[g]="(?:\\+("+h[O]+"(?:\\."+h[O]+")*))";var y=c++,s="v?"+h[f]+h[u]+"?"+h[g]+"?";h[y]="^"+s+"$";var o="[v=\\s]*"+h[S]+h[$]+"?"+h[g]+"?",t=c++;h[t]="^"+o+"$";var i=c++;h[i]="((?:<|>)?=?)";var n=c++;h[n]=h[I]+"|x|X|\\*";var r=c++;h[r]=h[P]+"|x|X|\\*";var l=c++;h[l]="[v=\\s]*("+h[r]+")(?:\\.("+h[r]+")(?:\\.("+h[r]+")(?:"+h[u]+")?"+h[g]+"?)?)?";var k=c++;h[k]="[v=\\s]*("+h[n]+")(?:\\.("+h[n]+")(?:\\.("+h[n]+")(?:"+h[$]+")?"+h[g]+"?)?)?";var b=c++;h[b]="^"+h[i]+"\\s*"+h[l]+"$";var w=c++;h[w]="^"+h[i]+"\\s*"+h[k]+"$";var j=c++;h[j]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var H=c++;h[H]="(?:~>?)";var ee=c++;h[ee]="(\\s*)"+h[H]+"\\s+",E[ee]=new RegExp(h[ee],"g");var _=c++;h[_]="^"+h[H]+h[l]+"$";var re=c++;h[re]="^"+h[H]+h[k]+"$";var se=c++;h[se]="(?:\\^)";var ue=c++;h[ue]="(\\s*)"+h[se]+"\\s+",E[ue]=new RegExp(h[ue],"g");var ce=c++;h[ce]="^"+h[se]+h[l]+"$";var oe=c++;h[oe]="^"+h[se]+h[k]+"$";var q=c++;h[q]="^"+h[i]+"\\s*("+o+")$|^$";var X=c++;h[X]="^"+h[i]+"\\s*("+s+")$|^$";var T=c++;h[T]="(\\s*)"+h[i]+"\\s*("+o+"|"+h[l]+")",E[T]=new RegExp(h[T],"g");var M=c++;h[M]="^\\s*("+h[l]+")\\s+-\\s+("+h[l]+")\\s*$";var V=c++;h[V]="^\\s*("+h[k]+")\\s+-\\s+("+h[k]+")\\s*$";var J=c++;h[J]="(<|>)?=?\\s*\\*";for(var Q=0;Q<35;Q++)R(Q,h[Q]),E[Q]||(E[Q]=new RegExp(h[Q]));function K(B,Y){if(B instanceof C)return B;if(typeof B!="string"||B.length>N||!(Y?E[t]:E[y]).test(B))return null;try{return new C(B,Y)}catch{return null}}function C(B,Y){if(B instanceof C){if(B.loose===Y)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof C))return new C(B,Y);R("SemVer",B,Y),this.loose=Y;var x=B.trim().match(Y?E[t]:E[y]);if(!x)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+x[1],this.minor=+x[2],this.patch=+x[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");x[4]?this.prerelease=x[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var ye=+$e;if(ye>=0&&ye<A)return ye}return $e}):this.prerelease=[],this.build=x[5]?x[5].split("."):[],this.format()}e.parse=K,e.valid=function(B,Y){var x=K(B,Y);return x?x.version:null},e.clean=function(B,Y){var x=K(B.trim().replace(/^[=v]+/,""),Y);return x?x.version:null},e.SemVer=C,C.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},C.prototype.toString=function(){return this.version},C.prototype.compare=function(B){return R("SemVer.compare",this.version,this.loose,B),B instanceof C||(B=new C(B,this.loose)),this.compareMain(B)||this.comparePre(B)},C.prototype.compareMain=function(B){return B instanceof C||(B=new C(B,this.loose)),a(this.major,B.major)||a(this.minor,B.minor)||a(this.patch,B.patch)},C.prototype.comparePre=function(B){if(B instanceof C||(B=new C(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var Y=0;do{var x=this.prerelease[Y],$e=B.prerelease[Y];if(R("prerelease compare",Y,x,$e),x===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(x===void 0)return-1;if(x!==$e)return a(x,$e)}while(++Y)},C.prototype.inc=function(B,Y){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Y),this.inc("pre",Y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Y),this.inc("pre",Y);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var x=this.prerelease.length;--x>=0;)typeof this.prerelease[x]=="number"&&(this.prerelease[x]++,x=-2);x===-1&&this.prerelease.push(0)}Y&&(this.prerelease[0]===Y?isNaN(this.prerelease[1])&&(this.prerelease=[Y,0]):this.prerelease=[Y,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,Y,x,$e){typeof x=="string"&&($e=x,x=void 0);try{return new C(B,x).inc(Y,$e).version}catch{return null}},e.diff=function(B,Y){if(Z(B,Y))return null;var x=K(B),$e=K(Y);if(x.prerelease.length||$e.prerelease.length){for(var ye in x)if((ye==="major"||ye==="minor"||ye==="patch")&&x[ye]!==$e[ye])return"pre"+ye;return"prerelease"}for(var ye in x)if((ye==="major"||ye==="minor"||ye==="patch")&&x[ye]!==$e[ye])return ye},e.compareIdentifiers=a;var F=/^[0-9]+$/;function a(B,Y){var x=F.test(B),$e=F.test(Y);return x&&$e&&(B=+B,Y=+Y),x&&!$e?-1:$e&&!x?1:B<Y?-1:B>Y?1:0}function m(B,Y,x){return new C(B,x).compare(new C(Y,x))}function z(B,Y,x){return m(B,Y,x)>0}function U(B,Y,x){return m(B,Y,x)<0}function Z(B,Y,x){return m(B,Y,x)===0}function W(B,Y,x){return m(B,Y,x)!==0}function le(B,Y,x){return m(B,Y,x)>=0}function ae(B,Y,x){return m(B,Y,x)<=0}function me(B,Y,x,$e){var ye;switch(Y){case"===":typeof B=="object"&&(B=B.version),typeof x=="object"&&(x=x.version),ye=B===x;break;case"!==":typeof B=="object"&&(B=B.version),typeof x=="object"&&(x=x.version),ye=B!==x;break;case"":case"=":case"==":ye=Z(B,x,$e);break;case"!=":ye=W(B,x,$e);break;case">":ye=z(B,x,$e);break;case">=":ye=le(B,x,$e);break;case"<":ye=U(B,x,$e);break;case"<=":ye=ae(B,x,$e);break;default:throw new TypeError("Invalid operator: "+Y)}return ye}function de(B,Y){if(B instanceof de){if(B.loose===Y)return B;B=B.value}if(!(this instanceof de))return new de(B,Y);R("comparator",B,Y),this.loose=Y,this.parse(B),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(B,Y){return a(Y,B)},e.major=function(B,Y){return new C(B,Y).major},e.minor=function(B,Y){return new C(B,Y).minor},e.patch=function(B,Y){return new C(B,Y).patch},e.compare=m,e.compareLoose=function(B,Y){return m(B,Y,!0)},e.rcompare=function(B,Y,x){return m(Y,B,x)},e.sort=function(B,Y){return B.sort(function(x,$e){return e.compare(x,$e,Y)})},e.rsort=function(B,Y){return B.sort(function(x,$e){return e.rcompare(x,$e,Y)})},e.gt=z,e.lt=U,e.eq=Z,e.neq=W,e.gte=le,e.lte=ae,e.cmp=me,e.Comparator=de;var ge={};function fe(B,Y){if(B instanceof fe)return B.loose===Y?B:new fe(B.raw,Y);if(B instanceof de)return new fe(B.value,Y);if(!(this instanceof fe))return new fe(B,Y);if(this.loose=Y,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(x){return this.parseRange(x.trim())},this).filter(function(x){return x.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function he(B){return!B||B.toLowerCase()==="x"||B==="*"}function we(B,Y,x,$e,ye,Re,Se,Le,Ie,Ae,Me,Oe,De){return((Y=he(x)?"":he($e)?">="+x+".0.0":he(ye)?">="+x+"."+$e+".0":">="+Y)+" "+(Le=he(Ie)?"":he(Ae)?"<"+(+Ie+1)+".0.0":he(Me)?"<"+Ie+"."+(+Ae+1)+".0":Oe?"<="+Ie+"."+Ae+"."+Me+"-"+Oe:"<="+Le)).trim()}function be(B,Y){for(var x=0;x<B.length;x++)if(!B[x].test(Y))return!1;if(Y.prerelease.length){for(x=0;x<B.length;x++)if(R(B[x].semver),B[x].semver!==ge&&B[x].semver.prerelease.length>0){var $e=B[x].semver;if($e.major===Y.major&&$e.minor===Y.minor&&$e.patch===Y.patch)return!0}return!1}return!0}function ke(B,Y,x){try{Y=new fe(Y,x)}catch{return!1}return Y.test(B)}function Ce(B,Y,x,$e){var ye,Re,Se,Le,Ie;switch(B=new C(B,$e),Y=new fe(Y,$e),x){case">":ye=z,Re=ae,Se=U,Le=">",Ie=">=";break;case"<":ye=U,Re=le,Se=z,Le="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(B,Y,$e))return!1;for(var Ae=0;Ae<Y.set.length;++Ae){var Me=Y.set[Ae],Oe=null,De=null;if(Me.forEach(function(ze){ze.semver===ge&&(ze=new de(">=0.0.0")),Oe=Oe||ze,De=De||ze,ye(ze.semver,Oe.semver,$e)?Oe=ze:Se(ze.semver,De.semver,$e)&&(De=ze)}),Oe.operator===Le||Oe.operator===Ie||(!De.operator||De.operator===Le)&&Re(B,De.semver)||De.operator===Ie&&Se(B,De.semver))return!1}return!0}de.prototype.parse=function(B){var Y=this.loose?E[q]:E[X],x=B.match(Y);if(!x)throw new TypeError("Invalid comparator: "+B);this.operator=x[1],this.operator==="="&&(this.operator=""),x[2]?this.semver=new C(x[2],this.loose):this.semver=ge},de.prototype.toString=function(){return this.value},de.prototype.test=function(B){return R("Comparator.test",B,this.loose),this.semver===ge||(typeof B=="string"&&(B=new C(B,this.loose)),me(B,this.operator,this.semver,this.loose))},de.prototype.intersects=function(B,Y){if(!(B instanceof de))throw new TypeError("a Comparator is required");var x;if(this.operator==="")return x=new fe(B.value,Y),ke(this.value,x,Y);if(B.operator==="")return x=new fe(this.value,Y),ke(B.semver,x,Y);var $e=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),Re=this.semver.version===B.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),Le=me(this.semver,"<",B.semver,Y)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),Ie=me(this.semver,">",B.semver,Y)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return $e||ye||Re&&Se||Le||Ie},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(B){var Y=this.loose;B=B.trim(),R("range",B,Y);var x=Y?E[V]:E[M];B=B.replace(x,we),R("hyphen replace",B),B=B.replace(E[T],"$1$2$3"),R("comparator trim",B,E[T]),B=(B=(B=B.replace(E[ee],"$1~")).replace(E[ue],"$1^")).split(/\s+/).join(" ");var $e=Y?E[q]:E[X],ye=B.split(" ").map(function(Re){return function(Se,Le){return R("comp",Se),Se=function(Ie,Ae){return Ie.trim().split(/\s+/).map(function(Me){return function(Oe,De){R("caret",Oe,De);var ze=De?E[oe]:E[ce];return Oe.replace(ze,function(Ne,ve,Ee,Pe,je){var Fe;return R("caret",Oe,Ne,ve,Ee,Pe,je),he(ve)?Fe="":he(Ee)?Fe=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Pe)?Fe=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":je?(R("replaceCaret pr",je),je.charAt(0)!=="-"&&(je="-"+je),Fe=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+je+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+je+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+je+" <"+(+ve+1)+".0.0"):(R("no pr"),Fe=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+" <"+(+ve+1)+".0.0"),R("caret return",Fe),Fe})}(Me,Ae)}).join(" ")}(Se,Le),R("caret",Se),Se=function(Ie,Ae){return Ie.trim().split(/\s+/).map(function(Me){return function(Oe,De){var ze=De?E[re]:E[_];return Oe.replace(ze,function(Ne,ve,Ee,Pe,je){var Fe;return R("tilde",Oe,Ne,ve,Ee,Pe,je),he(ve)?Fe="":he(Ee)?Fe=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Pe)?Fe=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":je?(R("replaceTilde pr",je),je.charAt(0)!=="-"&&(je="-"+je),Fe=">="+ve+"."+Ee+"."+Pe+je+" <"+ve+"."+(+Ee+1)+".0"):Fe=">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0",R("tilde return",Fe),Fe})}(Me,Ae)}).join(" ")}(Se,Le),R("tildes",Se),Se=function(Ie,Ae){return R("replaceXRanges",Ie,Ae),Ie.split(/\s+/).map(function(Me){return function(Oe,De){Oe=Oe.trim();var ze=De?E[w]:E[b];return Oe.replace(ze,function(Ne,ve,Ee,Pe,je,Fe){R("xRange",Oe,Ne,ve,Ee,Pe,je,Fe);var qe=he(Ee),Ue=qe||he(Pe),Te=Ue||he(je);return ve==="="&&Te&&(ve=""),qe?Ne=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Te?(Ue&&(Pe=0),Te&&(je=0),ve===">"?(ve=">=",Ue?(Ee=+Ee+1,Pe=0,je=0):Te&&(Pe=+Pe+1,je=0)):ve==="<="&&(ve="<",Ue?Ee=+Ee+1:Pe=+Pe+1),Ne=ve+Ee+"."+Pe+"."+je):Ue?Ne=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Te&&(Ne=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),R("xRange return",Ne),Ne})}(Me,Ae)}).join(" ")}(Se,Le),R("xrange",Se),Se=function(Ie,Ae){return R("replaceStars",Ie,Ae),Ie.trim().replace(E[J],"")}(Se,Le),R("stars",Se),Se}(Re,Y)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(Re){return!!Re.match($e)})),ye=ye.map(function(Re){return new de(Re,Y)})},fe.prototype.intersects=function(B,Y){if(!(B instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(x){return x.every(function($e){return B.set.some(function(ye){return ye.every(function(Re){return $e.intersects(Re,Y)})})})})},e.toComparators=function(B,Y){return new fe(B,Y).set.map(function(x){return x.map(function($e){return $e.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new C(B,this.loose));for(var Y=0;Y<this.set.length;Y++)if(be(this.set[Y],B))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(B,Y,x){var $e=null,ye=null;try{var Re=new fe(Y,x)}catch{return null}return B.forEach(function(Se){Re.test(Se)&&($e&&ye.compare(Se)!==-1||(ye=new C($e=Se,x)))}),$e},e.minSatisfying=function(B,Y,x){var $e=null,ye=null;try{var Re=new fe(Y,x)}catch{return null}return B.forEach(function(Se){Re.test(Se)&&($e&&ye.compare(Se)!==1||(ye=new C($e=Se,x)))}),$e},e.validRange=function(B,Y){try{return new fe(B,Y).range||"*"}catch{return null}},e.ltr=function(B,Y,x){return Ce(B,Y,"<",x)},e.gtr=function(B,Y,x){return Ce(B,Y,">",x)},e.outside=Ce,e.prerelease=function(B,Y){var x=K(B,Y);return x&&x.prerelease.length?x.prerelease:null},e.intersects=function(B,Y,x){return B=new fe(B,x),Y=new fe(Y,x),B.intersects(Y)},e.coerce=function(B){if(B instanceof C)return B;if(typeof B!="string")return null;var Y=B.match(E[j]);return Y==null?null:K((Y[1]||"0")+"."+(Y[2]||"0")+"."+(Y[3]||"0"))}}).call(this,L(1))},function(G,e){var L,D,R=G.exports={};function N(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function E(p){if(L===setTimeout)return setTimeout(p,0);if((L===N||!L)&&setTimeout)return L=setTimeout,setTimeout(p,0);try{return L(p,0)}catch{try{return L.call(null,p,0)}catch{return L.call(this,p,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:N}catch{L=N}try{D=typeof clearTimeout=="function"?clearTimeout:A}catch{D=A}})();var h,c=[],P=!1,I=-1;function d(){P&&h&&(P=!1,h.length?c=h.concat(c):I=-1,c.length&&f())}function f(){if(!P){var p=E(d);P=!0;for(var u=c.length;u;){for(h=c,c=[];++I<u;)h&&h[I].run();I=-1,u=c.length}h=null,P=!1,function($){if(D===clearTimeout)return clearTimeout($);if((D===A||!D)&&clearTimeout)return D=clearTimeout,clearTimeout($);try{D($)}catch{try{return D.call(null,$)}catch{return D.call(this,$)}}}(p)}}function S(p,u){this.fun=p,this.array=u}function v(){}R.nextTick=function(p){var u=new Array(arguments.length-1);if(arguments.length>1)for(var $=1;$<arguments.length;$++)u[$-1]=arguments[$];c.push(new S(p,u)),c.length!==1||P||E(f)},S.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=v,R.addListener=v,R.once=v,R.off=v,R.removeListener=v,R.removeAllListeners=v,R.emit=v,R.prependListener=v,R.prependOnceListener=v,R.listeners=function(p){return[]},R.binding=function(p){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(p){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(te[73],ne([0,1]),function(G,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nr=void 0;class D{constructor(E,h,c){this.level=E,this.key=h,this.value=c,this.forward=[]}}const R=void 0;class N{constructor(E,h=2**16){this.comparator=E,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new D(this.c,R,R)}get size(){return this.f}clear(){this.e=new D(this.c,R,R),this.f=0}has(E){return!!N.g(this,E,this.comparator)}get(E){return N.g(this,E,this.comparator)?.value}set(E,h){return N.h(this,E,h,this.comparator)&&(this.f+=1),this}delete(E){const h=N.k(this,E,this.comparator);return h&&(this.f-=1),h}forEach(E,h){let c=this.e.forward[0];for(;c;)E.call(h,c.value,c.key,this),c=c.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this.e.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this.e.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this.e.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",h=this.e.forward[0];for(;h;)E+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return E}static g(E,h,c){let P=E.e;for(let I=E.d-1;I>=0;I--)for(;P.forward[I]&&c(P.forward[I].key,h)<0;)P=P.forward[I];if(P=P.forward[0],P&&c(P.key,h)===0)return P}static h(E,h,c,P){const I=[];let d=E.e;for(let f=E.d-1;f>=0;f--){for(;d.forward[f]&&P(d.forward[f].key,h)<0;)d=d.forward[f];I[f]=d}if(d=d.forward[0],d&&P(d.key,h)===0)return d.value=c,!1;{const f=N.j(E);if(f>E.d){for(let S=E.d;S<f;S++)I[S]=E.e;E.d=f}d=new D(f,h,c);for(let S=0;S<f;S++)d.forward[S]=I[S].forward[S],I[S].forward[S]=d;return!0}}static j(E,h=.5){let c=1;for(;Math.random()<h&&c<E.c;)c+=1;return c}static k(E,h,c){const P=[];let I=E.e;for(let d=E.d-1;d>=0;d--){for(;I.forward[d]&&c(I.forward[d].key,h)<0;)I=I.forward[d];P[d]=I}if(I=I.forward[0],!I||c(I.key,h)!==0)return!1;for(let d=0;d<E.d&&P[d].forward[d]===I;d++)P[d].forward[d]=I.forward[d];for(;E.d>0&&E.e.forward[E.d-1]===R;)E.d-=1;return!0}}e.$Nr=N}),define(te[45],ne([0,1,9,2]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;function R(g){const y=g;return y?typeof y.read=="function":!1}e.$4d=R;function N(g){const y=g;return y?[y.on,y.pause,y.resume,y.destroy].every(s=>typeof s=="function"):!1}e.$5d=N;function A(g){const y=g;return y?N(y.stream)&&Array.isArray(y.buffer)&&typeof y.ended=="boolean":!1}e.$6d=A;function E(g,y){return new h(g,y)}e.$7d=E;class h{constructor(y,s){this.e=y,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(y){if(!this.a.destroyed){if(this.a.flowing)this.g(y);else if(this.b.data.push(y),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(y){this.a.destroyed||(this.a.flowing?this.h(y):this.b.error.push(y))}end(y){this.a.destroyed||(typeof y<"u"&&this.write(y),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(y){this.c.data.slice(0).forEach(s=>s(y))}h(y){this.c.error.length===0?(0,L.$1)(y):this.c.error.slice(0).forEach(s=>s(y))}i(){this.c.end.slice(0).forEach(y=>y())}on(y,s){if(!this.a.destroyed)switch(y){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(y,s){if(this.a.destroyed)return;let o;switch(y){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const t=o.indexOf(s);t>=0&&o.splice(t,1)}}j(){if(this.b.data.length>0){const y=this.e(this.b.data);this.g(y),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const y of this.b.error)this.h(y);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(g,y){const s=[];let o;for(;(o=g.read())!==null;)s.push(o);return y(s)}e.$8d=c;function P(g,y,s){const o=[];let t;for(;(t=g.read())!==null&&o.length<s;)o.push(t);return t===null&&o.length>0?y(o):{read:()=>{if(o.length>0)return o.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return g.read()}}}e.$9d=P;function I(g,y){return new Promise((s,o)=>{const t=[];d(g,{onData:i=>{y&&t.push(i)},onError:i=>{y?o(i):s(void 0)},onEnd:()=>{s(y?y(t):void 0)}})})}e.$0d=I;function d(g,y,s){g.on("error",o=>{s?.isCancellationRequested||y.onError(o)}),g.on("end",()=>{s?.isCancellationRequested||y.onEnd()}),g.on("data",o=>{s?.isCancellationRequested||y.onData(o)})}e.$$d=d;function f(g,y){return new Promise((s,o)=>{const t=new D.$Rc,i=[],n=k=>{if(i.push(k),i.length>y)return t.dispose(),g.pause(),s({stream:g,buffer:i,ended:!1})},r=k=>(t.dispose(),o(k)),l=()=>(t.dispose(),s({stream:g,buffer:i,ended:!0}));t.add((0,D.$Qc)(()=>g.removeListener("error",r))),g.on("error",r),t.add((0,D.$Qc)(()=>g.removeListener("end",l))),g.on("end",l),t.add((0,D.$Qc)(()=>g.removeListener("data",n))),g.on("data",n)})}e.$_d=f;function S(g,y){const s=E(y);return s.end(g),s}e.$ae=S;function v(){const g=E(()=>{throw new Error("not supported")});return g.end(),g}e.$be=v;function p(g){let y=!1;return{read:()=>y?null:(y=!0,g)}}e.$ce=p;function u(g,y,s){const o=E(s);return d(g,{onData:t=>o.write(y.data(t)),onError:t=>o.error(y.error?y.error(t):t),onEnd:()=>o.end()}),o}e.$de=u;function $(g,y,s){let o=!1;return{read:()=>{const t=y.read();return o?t:(o=!0,t!==null?s([g,t]):g)}}}e.$ee=$;function O(g,y,s){let o=!1;const t=E(s);return d(y,{onData:i=>o?t.write(i):(o=!0,t.write(s([g,i]))),onError:i=>t.error(i),onEnd:()=>{o||(o=!0,t.write(g)),t.end()}}),t}e.$fe=O}),define(te[14],ne([0,1,164,45]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=void 0;const R=typeof Buffer<"u",N=new L.$V(()=>new Uint8Array(256));let A,E;class h{static alloc(j){return R?new h(Buffer.allocUnsafe(j)):new h(new Uint8Array(j))}static wrap(j){return R&&!Buffer.isBuffer(j)&&(j=Buffer.from(j.buffer,j.byteOffset,j.byteLength)),new h(j)}static fromString(j,H){return!(H?.dontUseNodeBuffer||!1)&&R?new h(Buffer.from(j)):(A||(A=new TextEncoder),new h(A.encode(j)))}static fromByteArray(j){const H=h.alloc(j.length);for(let ee=0,_=j.length;ee<_;ee++)H.buffer[ee]=j[ee];return H}static concat(j,H){if(typeof H>"u"){H=0;for(let re=0,se=j.length;re<se;re++)H+=j[re].byteLength}const ee=h.alloc(H);let _=0;for(let re=0,se=j.length;re<se;re++){const ue=j[re];ee.set(ue,_),_+=ue.byteLength}return ee}constructor(j){this.buffer=j,this.byteLength=this.buffer.byteLength}clone(){const j=h.alloc(this.byteLength);return j.set(this),j}toString(){return R?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(j,H){return new h(this.buffer.subarray(j,H))}set(j,H){if(j instanceof h)this.buffer.set(j.buffer,H);else if(j instanceof Uint8Array)this.buffer.set(j,H);else if(j instanceof ArrayBuffer)this.buffer.set(new Uint8Array(j),H);else if(ArrayBuffer.isView(j))this.buffer.set(new Uint8Array(j.buffer,j.byteOffset,j.byteLength),H);else throw new Error("Unknown argument 'array'")}readUInt32BE(j){return d(this.buffer,j)}writeUInt32BE(j,H){f(this.buffer,j,H)}readUInt32LE(j){return S(this.buffer,j)}writeUInt32LE(j,H){v(this.buffer,j,H)}readUInt8(j){return p(this.buffer,j)}writeUInt8(j,H){u(this.buffer,j,H)}indexOf(j,H=0){return c(this.buffer,j instanceof h?j.buffer:j,H)}}e.$ge=h;function c(w,j,H=0){const ee=j.byteLength,_=w.byteLength;if(ee===0)return 0;if(ee===1)return w.indexOf(j[0]);if(ee>_-H)return-1;const re=N.value;re.fill(j.length);for(let oe=0;oe<j.length;oe++)re[j[oe]]=j.length-oe-1;let se=H+j.length-1,ue=se,ce=-1;for(;se<_;)if(w[se]===j[ue]){if(ue===0){ce=se;break}se--,ue--}else se+=Math.max(j.length-ue,re[w[se]]),ue=j.length-1;return ce}e.$he=c;function P(w,j){return w[j+0]<<0>>>0|w[j+1]<<8>>>0}e.$ie=P;function I(w,j,H){w[H+0]=j&255,j=j>>>8,w[H+1]=j&255}e.$je=I;function d(w,j){return w[j]*2**24+w[j+1]*2**16+w[j+2]*2**8+w[j+3]}e.$ke=d;function f(w,j,H){w[H+3]=j,j=j>>>8,w[H+2]=j,j=j>>>8,w[H+1]=j,j=j>>>8,w[H]=j}e.$le=f;function S(w,j){return w[j+0]<<0>>>0|w[j+1]<<8>>>0|w[j+2]<<16>>>0|w[j+3]<<24>>>0}e.$me=S;function v(w,j,H){w[H+0]=j&255,j=j>>>8,w[H+1]=j&255,j=j>>>8,w[H+2]=j&255,j=j>>>8,w[H+3]=j&255}e.$ne=v;function p(w,j){return w[j]}e.$oe=p;function u(w,j,H){w[H]=j}e.$pe=u;function $(w){return D.$8d(w,j=>h.concat(j))}e.$qe=$;function O(w){return D.$ce(w)}e.$re=O;function g(w){return D.$0d(w,j=>h.concat(j))}e.$se=g;async function y(w){return w.ended?h.concat(w.buffer):h.concat([...w.buffer,await g(w.stream)])}e.$te=y;function s(w){return D.$ae(w,j=>h.concat(j))}e.$ue=s;function o(w){return D.$de(w,{data:j=>typeof j=="string"?h.fromString(j):h.wrap(j)},j=>h.concat(j))}e.$ve=o;function t(w){return D.$7d(j=>h.concat(j),w)}e.$we=t;function i(w,j){return D.$ee(w,j,H=>h.concat(H))}e.$xe=i;function n(w,j){return D.$fe(w,j,H=>h.concat(H))}e.$ye=n;function r(w){let j=0,H=0,ee=0;const _=new Uint8Array(Math.floor(w.length/4*3)),re=ue=>{switch(H){case 3:_[ee++]=j|ue,H=0;break;case 2:_[ee++]=j|ue>>>2,j=ue<<6,H=3;break;case 1:_[ee++]=j|ue>>>4,j=ue<<4,H=2;break;default:j=ue<<2,H=1}};for(let ue=0;ue<w.length;ue++){const ce=w.charCodeAt(ue);if(ce>=65&&ce<=90)re(ce-65);else if(ce>=97&&ce<=122)re(ce-97+26);else if(ce>=48&&ce<=57)re(ce-48+52);else if(ce===43||ce===45)re(62);else if(ce===47||ce===95)re(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${w[ue]}`)}}const se=ee;for(;H>0;)re(0);return h.wrap(_).slice(0,se)}e.$ze=r;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:w},j=!0,H=!1){const ee=H?k:l;let _="";const re=w.byteLength%3;let se=0;for(;se<w.byteLength-re;se+=3){const ue=w[se+0],ce=w[se+1],oe=w[se+2];_+=ee[ue>>>2],_+=ee[(ue<<4|ce>>>4)&63],_+=ee[(ce<<2|oe>>>6)&63],_+=ee[oe&63]}if(re===1){const ue=w[se+0];_+=ee[ue>>>2],_+=ee[ue<<4&63],j&&(_+="==")}else if(re===2){const ue=w[se+0],ce=w[se+1];_+=ee[ue>>>2],_+=ee[(ue<<4|ce>>>4)&63],_+=ee[ce<<2&63],j&&(_+="=")}return _}e.$Ae=b}),define(te[41],ne([0,1,29]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=void 0;function D(u){return R(u,0)}e.$Qi=D;function R(u,$){switch(typeof u){case"object":return u===null?N(349,$):Array.isArray(u)?h(u,$):c(u,$);case"string":return E(u,$);case"boolean":return A(u,$);case"number":return N(u,$);case"undefined":return N(937,$);default:return N(617,$)}}e.$Ri=R;function N(u,$){return($<<5)-$+u|0}e.$Si=N;function A(u,$){return N(u?433:863,$)}function E(u,$){$=N(149417,$);for(let O=0,g=u.length;O<g;O++)$=N(u.charCodeAt(O),$);return $}e.$Ti=E;function h(u,$){return $=N(104579,$),u.reduce((O,g)=>R(g,O),$)}function c(u,$){return $=N(181387,$),Object.keys(u).sort().reduce((O,g)=>(O=E(g,O),R(u[g],O)),$)}class P{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=R($,this.g),this.g}}e.$Ui=P;var I;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function d(u,$,O=32){const g=O-$,y=~((1<<g)-1);return(u<<$|(y&u)>>>g)>>>0}function f(u,$=0,O=u.byteLength,g=0){for(let y=0;y<O;y++)u[$+y]=g}function S(u,$,O="0"){for(;u.length<$;)u=O+u;return u}function v(u,$=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(O=>O.toString(16).padStart(2,"0")).join(""):S((u>>>0).toString(16),$/4)}e.$Vi=v;class p{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const O=$.length;if(O===0)return;const g=this.p;let y=this.r,s=this.u,o,t;for(s!==0?(o=s,t=-1,s=0):(o=$.charCodeAt(0),t=0);;){let i=o;if(L.$af(o))if(t+1<O){const n=$.charCodeAt(t+1);L.$bf(n)?(t++,i=L.$cf(o,n)):i=65533}else{s=o;break}else L.$bf(o)&&(i=65533);if(y=this.w(g,y,i),t++,t<O)o=$.charCodeAt(t);else break}this.r=y,this.u=s}w($,O,g){return g<128?$[O++]=g:g<2048?($[O++]=192|(g&1984)>>>6,$[O++]=128|(g&63)>>>0):g<65536?($[O++]=224|(g&61440)>>>12,$[O++]=128|(g&4032)>>>6,$[O++]=128|(g&63)>>>0):($[O++]=240|(g&1835008)>>>18,$[O++]=128|(g&258048)>>>12,$[O++]=128|(g&4032)>>>6,$[O++]=128|(g&63)>>>0),O>=64&&(this.y(),O-=64,this.t+=64,$[0]=$[64+0],$[1]=$[64+1],$[2]=$[64+2]),O}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=p.g,O=this.q;for(let l=0;l<64;l+=4)$.setUint32(l,O.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)$.setUint32(l,d($.getUint32(l-12,!1)^$.getUint32(l-32,!1)^$.getUint32(l-56,!1)^$.getUint32(l-64,!1),1),!1);let g=this.h,y=this.l,s=this.m,o=this.n,t=this.o,i,n,r;for(let l=0;l<80;l++)l<20?(i=y&s|~y&o,n=1518500249):l<40?(i=y^s^o,n=1859775393):l<60?(i=y&s|y&o|s&o,n=2400959708):(i=y^s^o,n=3395469782),r=d(g,5)+i+t+n+$.getUint32(l*4,!1)&4294967295,t=o,o=s,s=d(y,30),y=g,g=r;this.h=this.h+g&4294967295,this.l=this.l+y&4294967295,this.m=this.m+s&4294967295,this.n=this.n+o&4294967295,this.o=this.o+t&4294967295}}e.$Wi=p}),define(te[54],ne([0,1,29]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(D||(D={})),function(R){const N="error",A="warning",E="warn",h="info",c="ignore";function P(d){return d?L.$9e(N,d)?R.Error:L.$9e(A,d)||L.$9e(E,d)?R.Warning:L.$9e(h,d)?R.Info:R.Ignore:R.Ignore}R.fromValue=P;function I(d){switch(d){case R.Error:return N;case R.Warning:return A;case R.Info:return h;default:return c}}R.toString=I}(D||(D={})),e.default=D}),define(te[30],ne([0,1,3]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=void 0;function D(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const $=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([O,g])=>{$[O]=g&&typeof g=="object"?D(g):g}),$}e.$jn=D;function R(u){if(!u||typeof u!="object")return u;const $=[u];for(;$.length>0;){const O=$.shift();Object.freeze(O);for(const g in O)if(N.call(O,g)){const y=O[g];typeof y=="object"&&!Object.isFrozen(y)&&!(0,L.$If)(y)&&$.push(y)}}return u}e.$kn=R;const N=Object.prototype.hasOwnProperty;function A(u,$){return E(u,$,new Set)}e.$ln=A;function E(u,$,O){if((0,L.$Of)(u))return u;const g=$(u);if(typeof g<"u")return g;if(Array.isArray(u)){const y=[];for(const s of u)y.push(E(s,$,O));return y}if((0,L.$Hf)(u)){if(O.has(u))throw new Error("Cannot clone recursive data-structure");O.add(u);const y={};for(const s in u)N.call(u,s)&&(y[s]=E(u[s],$,O));return O.delete(u),y}return u}function h(u,$,O=!0){return(0,L.$Hf)(u)?((0,L.$Hf)($)&&Object.keys($).forEach(g=>{g in u?O&&((0,L.$Hf)(u[g])&&(0,L.$Hf)($[g])?h(u[g],$[g],O):u[g]=$[g]):u[g]=$[g]}),u):$}e.$mn=h;function c(u,$){if(u===$)return!0;if(u==null||$===null||$===void 0||typeof u!=typeof $||typeof u!="object"||Array.isArray(u)!==Array.isArray($))return!1;let O,g;if(Array.isArray(u)){if(u.length!==$.length)return!1;for(O=0;O<u.length;O++)if(!c(u[O],$[O]))return!1}else{const y=[];for(g in u)y.push(g);y.sort();const s=[];for(g in $)s.push(g);if(s.sort(),!c(y,s))return!1;for(O=0;O<y.length;O++)if(!c(u[y[O]],$[y[O]]))return!1}return!0}e.$nn=c;function P(u){const $=new Set;return JSON.stringify(u,(O,g)=>{if((0,L.$Hf)(g)||Array.isArray(g)){if($.has(g))return"[Circular]";$.add(g)}return g})}e.$on=P;function I(u,$){const O=Object.create(null);return!u||!$||Object.keys($).forEach(y=>{const s=u[y],o=$[y];c(s,o)||(O[y]=o)}),O}e.$pn=I;function d(u,$){const O=$.toLowerCase(),g=Object.keys(u).find(y=>y.toLowerCase()===O);return g?u[g]:u[$]}e.$qn=d;function f(u,$){const O=Object.create(null);for(const[g,y]of Object.entries(u))$(g,y)&&(O[g]=y);return O}e.$rn=f;function S(u){let $=[];for(;Object.prototype!==u;)$=$.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return $}e.$sn=S;function v(u){const $=[];for(const O of S(u))typeof u[O]=="function"&&$.push(O);return $}e.$tn=v;function p(u,$){const O=y=>function(){const s=Array.prototype.slice.call(arguments,0);return $(y,s)},g={};for(const y of u)g[y]=O(y);return g}e.$un=p}),define(te[28],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ng=e.$mg=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(R){return L.test(R)}e.$mg=D,e.$ng=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(E){for(let h=0;h<E.length;h++)E[h]=Math.floor(Math.random()*256);return E};const N=new Uint8Array(16),A=[];for(let E=0;E<256;E++)A.push(E.toString(16).padStart(2,"0"));return function(){R(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let h=0,c="";return c+=A[N[h++]],c+=A[N[h++]],c+=A[N[h++]],c+=A[N[h++]],c+="-",c+=A[N[h++]],c+=A[N[h++]],c+="-",c+=A[N[h++]],c+=A[N[h++]],c+="-",c+=A[N[h++]],c+=A[N[h++]],c+="-",c+=A[N[h++]],c+=A[N[h++]],c+=A[N[h++]],c+=A[N[h++]],c+=A[N[h++]],c+=A[N[h++]],c}}()}),define(te[74],ne([0,1,33]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(A){const E=A.replace(/\-/g,":").toLowerCase();return!D.has(E)}function N(){const A=(0,L.networkInterfaces)();for(const E in A){const h=A[E];if(h){for(const{mac:c}of h)if(R(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$6m=N}),define(te[75],ne([7,5]),function(G,e){return G.create("vs/base/common/date",e)}),define(te[76],ne([0,1,75]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=e.$sm=void 0;const D=60,R=D*60,N=R*24,A=N*7,E=N*30,h=N*365;function c(I,d,f,S){typeof I!="number"&&(I=I.getTime());const v=Math.round((new Date().getTime()-I)/1e3);if(v<-30)return(0,L.localize)(0,null,c(new Date().getTime()+v*1e3,!1));if(!S&&v<30)return(0,L.localize)(1,null);let p;return v<D?(p=v,d?p===1?f?(0,L.localize)(2,null,p):(0,L.localize)(3,null,p):f?(0,L.localize)(4,null,p):(0,L.localize)(5,null,p):p===1?f?(0,L.localize)(6,null,p):(0,L.localize)(7,null,p):f?(0,L.localize)(8,null,p):(0,L.localize)(9,null,p)):v<R?(p=Math.floor(v/D),d?p===1?f?(0,L.localize)(10,null,p):(0,L.localize)(11,null,p):f?(0,L.localize)(12,null,p):(0,L.localize)(13,null,p):p===1?f?(0,L.localize)(14,null,p):(0,L.localize)(15,null,p):f?(0,L.localize)(16,null,p):(0,L.localize)(17,null,p)):v<N?(p=Math.floor(v/R),d?p===1?f?(0,L.localize)(18,null,p):(0,L.localize)(19,null,p):f?(0,L.localize)(20,null,p):(0,L.localize)(21,null,p):p===1?f?(0,L.localize)(22,null,p):(0,L.localize)(23,null,p):f?(0,L.localize)(24,null,p):(0,L.localize)(25,null,p)):v<A?(p=Math.floor(v/N),d?p===1?(0,L.localize)(26,null,p):(0,L.localize)(27,null,p):p===1?(0,L.localize)(28,null,p):(0,L.localize)(29,null,p)):v<E?(p=Math.floor(v/A),d?p===1?f?(0,L.localize)(30,null,p):(0,L.localize)(31,null,p):f?(0,L.localize)(32,null,p):(0,L.localize)(33,null,p):p===1?f?(0,L.localize)(34,null,p):(0,L.localize)(35,null,p):f?(0,L.localize)(36,null,p):(0,L.localize)(37,null,p)):v<h?(p=Math.floor(v/E),d?p===1?f?(0,L.localize)(38,null,p):(0,L.localize)(39,null,p):f?(0,L.localize)(40,null,p):(0,L.localize)(41,null,p):p===1?f?(0,L.localize)(42,null,p):(0,L.localize)(43,null,p):f?(0,L.localize)(44,null,p):(0,L.localize)(45,null,p)):(p=Math.floor(v/h),d?p===1?f?(0,L.localize)(46,null,p):(0,L.localize)(47,null,p):f?(0,L.localize)(48,null,p):(0,L.localize)(49,null,p):p===1?f?(0,L.localize)(50,null,p):(0,L.localize)(51,null,p):f?(0,L.localize)(52,null,p):(0,L.localize)(53,null,p))}e.$sm=c;function P(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$tm=P}),define(te[77],ne([7,5]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(te[34],ne([0,1,19,3,77]),function(G,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.$Oi=e.$Ni=void 0;function N(I,d){return d&&(I.stack||I.stacktrace)?R.localize(0,null,E(I),A(I.stack)||A(I.stacktrace)):E(I)}function A(I){return Array.isArray(I)?I.join(`
`):I}function E(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?R.localize(1,null,I.message):I.message||R.localize(2,null)}function h(I=null,d=!1){if(!I)return R.localize(3,null);if(Array.isArray(I)){const f=L.$Hb(I),S=h(f[0],d);return f.length>1?R.localize(4,null,S,f.length):S}if(D.$Ff(I))return I;if(I.detail){const f=I.detail;if(f.error)return N(f.error,d);if(f.exception)return N(f.exception,d)}return I.stack?N(I,d):I.message?I.message:R.localize(5,null)}e.$Ni=h;function c(I){const d=I;return d instanceof Error&&Array.isArray(d.actions)}e.$Oi=c;function P(I,d){let f;return typeof I=="string"?f=new Error(I):f=I,f.actions=d,f}e.$Pi=P}),define(te[78],ne([7,5]),function(G,e){return G.create("vs/base/common/jsonErrorMessages",e)}),define(te[79],ne([0,1,78]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=void 0;function D(R){switch(R){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.$Lp=D}),define(te[55],ne([0,1,13]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.TerminateResponseCode=e.Source=void 0;var D;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(D||(e.Source=D={}));var R;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(R||(e.TerminateResponseCode=R={}));function N(E,...h){const c=h.reduce((d,f)=>(d[f]=!0,d),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(d=>!c[d]).forEach(d=>{for(let f=0;f<P.length;f++)if(d.search(P[f])!==-1){delete E[d];break}})}e.$Ol=N;function A(E){E&&(delete E.DEBUG,L.$j&&delete E.DYLD_LIBRARY_PATH,L.$k&&delete E.LD_PRELOAD)}e.$Pl=A}),define(te[80],ne([0,1,11]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$cq=e.$bq=e.$aq=void 0;function D(c){const P=c;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.$aq=D;function R(c){const P=[];let I;try{const d=JSON.parse(c.arguments),f=d[d.length-1];f&&f.__$stack&&(d.pop(),I=f.__$stack),P.push(...d)}catch{P.push("Unable to log remote console arguments",c.arguments)}return{args:P,stack:I}}e.$bq=R;function N(c){if(typeof c!="string")return N(R(c).stack);const P=c;if(P){const I=A(P),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(d&&d.length===4)return{uri:L.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.$cq=N;function A(c){if(!c)return c;const P=c.indexOf(`
`);return P===-1?c:c.substring(0,P)}function E(c,P){const{args:I,stack:d}=R(c),f=typeof I[0]=="string"&&I.length===1;let S=A(d);S&&(S=`(${S.trim()})`);let v=[];if(typeof I[0]=="string"?S&&f?v=[`%c[${P}] %c${I[0]} %c${S}`,h("blue"),h(""),h("grey")]:v=[`%c[${P}] %c${I[0]}`,h("blue"),h(""),...I.slice(1)]:v=[`%c[${P}]%`,h("blue"),...I],S&&!f&&v.push(S),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,v)}e.log=E;function h(c){return`color: ${c}`}}),define(te[46],ne([0,1,14,11]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.$yh=e.$xh=void 0;function R(h){return JSON.stringify(h,A)}e.$xh=R;function N(h){let c=JSON.parse(h);return c=E(c),c}e.$yh=N;function A(h,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function E(h,c=0){if(!h||c>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return D.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof L.$ge||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let P=0;P<h.length;++P)h[P]=E(h[P],c+1);else for(const P in h)Object.hasOwnProperty.call(h,P)&&(h[P]=E(h[P],c+1))}return h}e.$zh=E}),define(te[81],ne([0,1,70,15,13,11]),function(G,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4C=void 0;class A{constructor(d,f,S){this.id=d,this.dependencies=f,this.callback=S}}class E{static{this.INSTANCE=new E}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(d,f,S)=>{typeof d!="string"&&(S=f,f=d,d=null),(typeof f!="object"||!Array.isArray(f))&&(S=f,f=null),this.c.push(new A(d,f,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this.g();const f=await(this.a?this.i(d):this.b?this.h(d):this.j(d));if(!f)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray(f.dependencies)&&f.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${f.dependencies.join(", ")}`);return typeof f.callback=="function"?f.callback([]):f.callback}h(d){return new Promise((f,S)=>{const v=document.createElement("script");v.setAttribute("async","async"),v.setAttribute("type","text/javascript");const p=()=>{v.removeEventListener("load",u),v.removeEventListener("error",$)},u=O=>{p(),f(this.c.pop())},$=O=>{p(),S(O)};v.addEventListener("load",u),v.addEventListener("error",$),this.f&&(d=this.f.createScriptURL(d)),v.setAttribute("src",d),window.document.getElementsByTagName("head")[0].appendChild(v)})}i(d){return new Promise((f,S)=>{try{this.f&&(d=this.f.createScriptURL(d)),importScripts(d),f(this.c.pop())}catch(v){S(v)}})}async j(d){try{const f=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,v=globalThis._VSCODE_NODE_MODULES.module,p=N.URI.parse(d).fsPath,u=f.readFileSync(p).toString(),$=v.wrap(u.replace(/^#!.*/,""));return new S.Script($).runInThisContext().apply(),this.c.pop()}catch(f){throw f}}}const h=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function P(I,d,f){if(L.$T){f===void 0&&(f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[I]&&(I=c[I]);const S=`${I}/${d}`;if(h.has(S))return h.get(S);let v;if(/^\w[\w\d+.-]*:\/\//.test(S))v=S;else{const O=`${f&&!R.$o?D.$ig:D.$hg}/${S}`;v=D.$lg.asBrowserUri(O).toString(!0)}const p=E.INSTANCE.load(v);return h.set(S,p),p}else return await new Promise((S,v)=>{G([I],S,v)})}e.$4C=P}),define(te[82],ne([0,1,33,47,28,74,13]),function(G,e,L,D,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=e.$8m=e.$7m=void 0,e.$7m=new class{c(d){return this.a||(this.a=D.$9h.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(d)}value(){if(this.b===void 0){let d=0,f=0;const S=(0,L.networkInterfaces)();for(const v in S){const p=S[v];if(p)for(const{mac:u,internal:$}of p)$||(f+=1,this.c(u.toUpperCase())&&(d+=1))}this.b=f>0?d/f:0}return this.b}};let E;async function h(d){return E||(E=(async()=>await c(d)||R.$ng())()),E}e.$8m=h;async function c(d){try{const f=await new Promise((v,p)=>{G(["crypto"],v,p)}),S=(0,N.$6m)();return f.createHash("sha256").update(S,"utf8").digest("hex")}catch(f){d(f);return}}const P="Software\\Microsoft\\SQMClient";async function I(d){if(A.$i){const f=await new Promise((S,v)=>{G(["@vscode/windows-registry"],S,v)});try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",P,"MachineId")||""}catch(S){return d(S),""}}return""}e.$9m=I}),define(te[83],ne([0,1,33,16,24]),function(G,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=void 0;const N=/^\d+$/,A=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var h;(function(g){g[g.x64=0]="x64",g[g.x86=1]="x86",g[g.ARM=2]="ARM"})(h||(h={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class I{constructor(y,s,o){this.exePath=y,this.displayName=s,this.a=o}async exists(){return this.a===void 0&&(this.a=await R.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:g=!1}={}){return g?c===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:g=!1,findPreview:y=!1}={}){const s=d({useAlternateBitness:g});if(!s)return null;const o=D.$jc(s,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(o))return null;let t=-1,i=null;for(const l of await R.Promises.readdir(o)){let k=-1;if(y){const w=l.indexOf("-");if(w<0)continue;const j=l.substring(0,w);if(!N.test(j)||l.substring(w+1)!=="preview")continue;k=parseInt(j,10)}else{if(!N.test(l))continue;k=parseInt(l,10)}if(k<=t)continue;const b=D.$jc(o,l,"pwsh.exe");await R.SymlinkSupport.existsFile(b)&&(i=b,t=k)}if(!i)return null;const n=s.includes("x86")?" (x86)":"",r=y?" Preview":"";return new I(i,`PowerShell${r}${n}`,!0)}async function S({findPreview:g}={}){if(!process.env.LOCALAPPDATA)return null;const y=D.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(y))return null;const{pwshMsixDirRegex:s,pwshMsixName:o}=g?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const t of await R.Promises.readdir(y))if(s.test(t)){const i=D.$jc(y,t,"pwsh.exe");return new I(i,o)}return null}function v(){const g=D.$jc(L.homedir(),".dotnet","tools","pwsh.exe");return new I(g,".NET Core PowerShell Global Tool")}function p(){const g=D.$jc(process.env.windir,c===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(g,"Windows PowerShell",!0)}async function*u(){let g=await f();g&&(yield g),g=await f({useAlternateBitness:!0}),g&&(yield g),g=await S(),g&&(yield g),g=v(),g&&(yield g),g=await f({findPreview:!0}),g&&(yield g),g=await S({findPreview:!0}),g&&(yield g),g=await f({useAlternateBitness:!0,findPreview:!0}),g&&(yield g),g=p(),g&&(yield g)}async function*$(){for await(const g of u())await g.exists()&&(yield g)}e.$Ml=$;async function O(){for await(const g of $())return g;return null}e.$Nl=O}),define(te[56],ne([0,1,16,13,35,55,3,24]),function(G,e,L,D,R,N,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Rl=e.$Ql=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return N.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return N.TerminateResponseCode}});function h(I=R.env){return I.comspec||"cmd.exe"}e.$Ql=h;function c(I){let d=[],f=!1;const S=function(v){if(f){d.push(v);return}(!I.send(v,u=>{if(u&&console.error(u),f=!1,d.length>0){const $=d.slice(0);d=[],$.forEach(O=>S(O))}})||D.$i)&&(f=!0)};return{send:S}}e.$Rl=c;var P;(function(I){async function d(f,S,v){if(L.$ic(f))return f;if(S===void 0&&(S=R.cwd()),L.$mc(f)!=="."||(v===void 0&&A.$Ff(R.env.PATH)&&(v=R.env.PATH.split(L.$tc)),v===void 0||v.length===0))return L.$jc(S,f);async function u($){if(await E.Promises.exists($)){let O;try{O=await E.Promises.stat($)}catch(g){g.message.startsWith("EACCES")&&(O=await E.Promises.lstat($))}return O?!O.isDirectory():!1}return!1}for(const $ of v){let O;if(L.$ic($)?O=L.$jc($,f):O=L.$jc(S,$,f),await u(O))return O;let g=O+".com";if(await u(g)||(g=O+".exe",await u(g)))return g}return L.$jc(S,f)}I.findExecutable=d})(P||(e.win32=P={}))}),define(te[84],ne([0,1,33,13,83,56]),function(G,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=void 0;async function A(I,d){return I===1?D.$i?P():N.$Ql(d):h(I,d)}e.$Sl=A;let E=null;function h(I,d){if(D.$k&&I===2||D.$j&&I===3)return"/bin/bash";if(!E){let f;if(D.$i)f="/bin/bash";else{if(f=d.SHELL,!f)try{f=(0,L.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}E=f}return E}let c=null;async function P(){return c||(c=(await(0,R.$Nl)()).exePath),c}});var pe=this&&this.__decorate||function(G,e,L,D){var R=arguments.length,N=R<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,L):D,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(G,e,L,D);else for(var E=G.length-1;E>=0;E--)(A=G[E])&&(N=(R<3?A(N):R>3?A(e,L,N):A(e,L))||N);return R>3&&N&&Object.defineProperty(e,L,N),N};define(te[57],ne([0,1,19,8,14,20,52,9,4,2,46,29,3]),function(G,e,L,D,R,N,A,E,h,c,P,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.ProxyChannel=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.RequestInitiator=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=void 0;var f;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(f||(f={}));function S(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(v||(v={}));function p(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(u||(u={}));function $(T){let M=0;for(let V=0;;V+=7){const J=T.read(1);if(M|=(J.buffer[0]&127)<<V,!(J.buffer[0]&128))return M}}const O=t(0);function g(T,M){if(M===0){T.write(O);return}let V=0;for(let Q=M;Q!==0;Q=Q>>>7)V++;const J=R.$ge.alloc(V);for(let Q=0;M!==0;Q++)J.buffer[Q]=M&127,M=M>>>7,M>0&&(J.buffer[Q]|=128);T.write(J)}class y{constructor(M){this.b=M,this.a=0}read(M){const V=this.b.slice(this.a,this.a+M);return this.a+=V.byteLength,V}}e.$Ah=y;class s{constructor(){this.a=[]}get buffer(){return R.$ge.concat(this.a)}write(M){this.a.push(M)}}e.$Bh=s;var o;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object",T[T.Int=6]="Int"})(o||(o={}));function t(T){const M=R.$ge.alloc(1);return M.writeUInt8(T,0),M}const i={Undefined:t(o.Undefined),String:t(o.String),Buffer:t(o.Buffer),VSBuffer:t(o.VSBuffer),Array:t(o.Array),Object:t(o.Object),Uint:t(o.Int)},n=typeof Buffer<"u";function r(T,M){if(typeof M>"u")T.write(i.Undefined);else if(typeof M=="string"){const V=R.$ge.fromString(M);T.write(i.String),g(T,V.byteLength),T.write(V)}else if(n&&Buffer.isBuffer(M)){const V=R.$ge.wrap(M);T.write(i.Buffer),g(T,V.byteLength),T.write(V)}else if(M instanceof R.$ge)T.write(i.VSBuffer),g(T,M.byteLength),T.write(M);else if(Array.isArray(M)){T.write(i.Array),g(T,M.length);for(const V of M)r(T,V)}else if(typeof M=="number"&&(M|0)===M)T.write(i.Uint),g(T,M);else{const V=R.$ge.fromString(JSON.stringify(M));T.write(i.Object),g(T,V.byteLength),T.write(V)}}e.$Ch=r;function l(T){switch(T.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return T.read($(T)).toString();case o.Buffer:return T.read($(T)).buffer;case o.VSBuffer:return T.read($(T));case o.Array:{const V=$(T),J=[];for(let Q=0;Q<V;Q++)J.push(l(T));return J}case o.Object:return JSON.parse(T.read($(T)).toString());case o.Int:return $(T)}}e.$Dh=l;class k{constructor(M,V,J=null,Q=1e3){this.h=M,this.j=V,this.k=J,this.l=Q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(K=>this.q(K)),this.m({type:200})}registerChannel(M,V){this.b.set(M,V),setTimeout(()=>this.w(M),0)}m(M){switch(M.type){case 200:{const V=this.o([M.type]);this.k?.logOutgoing(V,0,1,p(M.type));return}case 201:case 202:case 204:case 203:{const V=this.o([M.type,M.id],M.data);this.k?.logOutgoing(V,M.id,1,p(M.type),M.data);return}}}o(M,V=void 0){const J=new s;return r(J,M),r(J,V),this.p(J.buffer)}p(M){try{return this.h.send(M),M.byteLength}catch{return 0}}q(M){const V=new y(M),J=l(V),Q=l(V),K=J[0];switch(K){case 100:return this.k?.logIncoming(M.byteLength,J[1],1,`${S(K)}: ${J[2]}.${J[3]}`,Q),this.s({type:K,id:J[1],channelName:J[2],name:J[3],arg:Q});case 102:return this.k?.logIncoming(M.byteLength,J[1],1,`${S(K)}: ${J[2]}.${J[3]}`,Q),this.t({type:K,id:J[1],channelName:J[2],name:J[3],arg:Q});case 101:return this.k?.logIncoming(M.byteLength,J[1],1,`${S(K)}`),this.u({type:K,id:J[1]});case 103:return this.k?.logIncoming(M.byteLength,J[1],1,`${S(K)}`),this.u({type:K,id:J[1]})}}s(M){const V=this.b.get(M.channelName);if(!V){this.v(M);return}const J=new N.$3d;let Q;try{Q=V.call(this.j,M.name,M.arg,J.token)}catch(F){Q=Promise.reject(F)}const K=M.id;Q.then(F=>{this.m({id:K,data:F,type:201})},F=>{F instanceof Error?this.m({id:K,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.m({id:K,data:F,type:203})}).finally(()=>{C.dispose(),this.d.delete(M.id)});const C=(0,c.$Qc)(()=>J.cancel());this.d.set(M.id,C)}t(M){const V=this.b.get(M.channelName);if(!V){this.v(M);return}const J=M.id,K=V.listen(this.j,M.name,M.arg)(C=>this.m({id:J,data:C,type:204}));this.d.set(M.id,K)}u(M){const V=this.d.get(M.id);V&&(V.dispose(),this.d.delete(M.id))}v(M){let V=this.g.get(M.channelName);V||(V=[],this.g.set(M.channelName,V));const J=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.m({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);V.push({request:M,timeoutTimer:J})}w(M){const V=this.g.get(M);if(V){for(const J of V)switch(clearTimeout(J.timeoutTimer),J.request.type){case 100:this.s(J.request);break;case 102:this.t(J.request);break}this.g.delete(M)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Nc)(this.d.values()),this.d.clear()}}e.$Eh=k;var b;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(b||(e.RequestInitiator=b={}));class w{constructor(M,V=null){this.l=M,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$Sd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(J=>this.s(J)),this.j=V}getChannel(M){const V=this;return{call(J,Q,K){return V.a?Promise.reject(new E.$5):V.m(M,J,Q,K)},listen(J,Q){return V.a?h.Event.None:V.o(M,J,Q)}}}m(M,V,J,Q=N.CancellationToken.None){const K=this.g++,F={id:K,type:100,channelName:M,name:V,arg:J};if(Q.isCancellationRequested)return Promise.reject(new E.$5);let a;return new Promise((z,U)=>{if(Q.isCancellationRequested)return U(new E.$5);const Z=()=>{const me=de=>{switch(de.type){case 201:this.f.delete(K),z(de.data);break;case 202:{this.f.delete(K);const ge=new Error(de.data.message);ge.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,ge.name=de.data.name,U(ge);break}case 203:this.f.delete(K),U(de.data);break}};this.f.set(K,me),this.p(F)};let W=null;this.b===u.Idle?Z():(W=(0,D.$Qg)(me=>this.u()),W.then(()=>{W=null,Z()}));const le=()=>{W?(W.cancel(),W=null):this.p({id:K,type:101}),U(new E.$5)},ae=Q.onCancellationRequested(le);a=(0,c.$Pc)((0,c.$Qc)(le),ae),this.d.add(a)}).finally(()=>{a.dispose(),this.d.delete(a)})}o(M,V,J){const Q=this.g++,C={id:Q,type:102,channelName:M,name:V,arg:J};let F=null;const a=new h.$Sd({onWillAddFirstListener:()=>{F=(0,D.$Qg)(z=>this.u()),F.then(()=>{F=null,this.d.add(a),this.p(C)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.d.delete(a),this.p({id:Q,type:103}))}}),m=z=>a.fire(z.data);return this.f.set(Q,m),a.event}p(M){switch(M.type){case 100:case 102:{const V=this.q([M.type,M.id,M.channelName,M.name],M.arg);this.j?.logOutgoing(V,M.id,0,`${S(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const V=this.q([M.type,M.id]);this.j?.logOutgoing(V,M.id,0,S(M.type));return}}}q(M,V=void 0){const J=new s;return r(J,M),r(J,V),this.r(J.buffer)}r(M){try{return this.l.send(M),M.byteLength}catch{return 0}}s(M){const V=new y(M),J=l(V),Q=l(V),K=J[0];switch(K){case 200:return this.j?.logIncoming(M.byteLength,0,0,p(K)),this.t({type:J[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(M.byteLength,J[1],0,p(K),Q),this.t({type:J[0],id:J[1],data:Q})}}t(M){if(M.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(M.id)?.(M)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Nc)(this.d.values()),this.d.clear()}}e.$Fh=w,pe([A.$uh],w.prototype,"onDidInitializePromise",null);class j{get connections(){const M=[];return this.f.forEach(V=>M.push(V)),M}constructor(M){this.a=new Map,this.f=new Set,this.g=new h.$Sd,this.onDidAddConnection=this.g.event,this.h=new h.$Sd,this.onDidRemoveConnection=this.h.event,this.j=new c.$Rc,this.j.add(M(({protocol:V,onDidClientDisconnect:J})=>{const Q=h.Event.once(V.onMessage);this.j.add(Q(K=>{const C=new y(K),F=l(C),a=new k(V,F),m=new w(V);this.a.forEach((U,Z)=>a.registerChannel(Z,U));const z={channelServer:a,channelClient:m,ctx:F};this.f.add(z),this.g.fire(z),this.j.add(J(()=>{a.dispose(),m.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(M,V){const J=this;return{call(Q,K,C){let F;if((0,d.$Tf)(V)){const m=(0,L.$4b)(J.connections.filter(V));F=m?Promise.resolve(m):h.Event.toPromise(h.Event.filter(J.onDidAddConnection,V))}else F=V.routeCall(J,Q,K);const a=F.then(m=>m.channelClient.getChannel(M));return ee(a).call(Q,K,C)},listen(Q,K){if((0,d.$Tf)(V))return J.k(M,V,Q,K);const C=V.routeEvent(J,Q,K).then(F=>F.channelClient.getChannel(M));return ee(C).listen(Q,K)}}}k(M,V,J,Q){const K=this;let C;const F=new h.$Sd({onWillAddFirstListener:()=>{C=new c.$Rc;const a=new h.$Yd,m=new Map,z=Z=>{const le=Z.channelClient.getChannel(M).listen(J,Q),ae=a.add(le);m.set(Z,ae)},U=Z=>{const W=m.get(Z);W&&(W.dispose(),m.delete(Z))};K.connections.filter(V).forEach(z),h.Event.filter(K.onDidAddConnection,V)(z,void 0,C),K.onDidRemoveConnection(U,void 0,C),a.event(F.fire,F,C),C.add(a)},onDidRemoveLastListener:()=>{C?.dispose(),C=void 0}});return F.event}registerChannel(M,V){this.a.set(M,V);for(const J of this.f)J.channelServer.registerChannel(M,V)}dispose(){this.j.dispose();for(const M of this.f)M.channelClient.dispose(),M.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Gh=j;class H{constructor(M,V,J=null){const Q=new s;r(Q,V),M.send(Q.buffer),this.a=new w(M,J),this.d=new k(M,V,J)}getChannel(M){return this.a.getChannel(M)}registerChannel(M,V){this.d.registerChannel(M,V)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Hh=H;function ee(T){return{call(M,V,J){return T.then(Q=>Q.call(M,V,J))},listen(M,V){const J=new h.$2d;return T.then(Q=>J.input=Q.listen(M,V)),J.event}}}e.$Ih=ee;function _(T){let M=!1;return{call(V,J,Q){return M?T.call(V,J,Q):(0,D.$4g)(0).then(()=>M=!0).then(()=>T.call(V,J,Q))},listen(V,J){if(M)return T.listen(V,J);const Q=new h.$2d;return(0,D.$4g)(0).then(()=>M=!0).then(()=>Q.input=T.listen(V,J)),Q.event}}}e.$Jh=_;class re{constructor(M){this.a=M}routeCall(M){return this.b(M)}routeEvent(M){return this.b(M)}async b(M){for(const V of M.connections)if(await Promise.resolve(this.a(V.ctx)))return Promise.resolve(V);return await h.Event.toPromise(M.onDidAddConnection),await this.b(M)}}e.$Kh=re;var se;(function(T){function M(K,C,F){const a=K,m=F&&F.disableMarshalling,z=new Map;for(const U in a)J(U)&&z.set(U,h.Event.buffer(a[U],!0,void 0,C));return new class{listen(U,Z,W){const le=z.get(Z);if(le)return le;if(Q(Z)){const ae=a[Z];if(typeof ae=="function")return ae.call(a,W)}throw new E.$bb(`Event not found: ${Z}`)}call(U,Z,W){const le=a[Z];if(typeof le=="function"){if(!m&&Array.isArray(W))for(let me=0;me<W.length;me++)W[me]=(0,P.$zh)(W[me]);let ae=le.apply(a,W);return ae instanceof Promise||(ae=Promise.resolve(ae)),ae}throw new E.$bb(`Method not found: ${Z}`)}}}T.fromService=M;function V(K,C){const F=C&&C.disableMarshalling;return new Proxy({},{get(a,m){if(typeof m=="string")return C?.properties?.has(m)?C.properties.get(m):Q(m)?function(z){return K.listen(m,z)}:J(m)?K.listen(m):async function(...z){let U;C&&!(0,d.$Of)(C.context)?U=[C.context,...z]:U=z;const Z=await K.call(m,U);return F?Z:(0,P.$zh)(Z)};throw new E.$bb(`Property not found: ${String(m)}`)}})}T.toService=V;function J(K){return K[0]==="o"&&K[1]==="n"&&I.$8e(K.charCodeAt(2))}function Q(K){return/^onDynamic/.test(K)&&I.$8e(K.charCodeAt(9))}})(se||(e.ProxyChannel=se={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){const M=T.toString();if(M!=="[object Object]")return M}return T}function oe(T){return Array.isArray(T)?T.map(ce):ce(T)}function q(T,M,V,J,Q,K,C){C=oe(C);const F=ue[Q],a=F[J%F.length];let m=[`%c[${T}]%c[${String(M).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${a}`];/\($/.test(K)?(m=m.concat(C),m.push(")")):m.push(C),console.log.apply(console,m)}class X{constructor(M,V){this.d=M,this.f=V,this.a=0,this.b=0}logOutgoing(M,V,J,Q,K){this.b+=M,q(this.d,this.b,M,V,J,Q,K)}logIncoming(M,V,J,Q,K){this.a+=M,q(this.f,this.a,M,V,J,Q,K)}}e.$Lh=X}),define(te[85],ne([0,1,58,8,14,20,80,9,4,2,30,56,55,57]),function(G,e,L,D,R,N,A,E,h,c,P,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=void 0;class S extends f.$Eh{constructor(u){super({send:$=>{try{process.send?.($.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",$=>R.$ge.wrap(Buffer.from($,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.$eq=S;class v{constructor(u,$){this.i=u,this.j=$,this.c=new Set,this.g=new Map,this.h=new h.$Sd,this.onDidProcessExit=this.h.event;const O=$&&$.timeout?$.timeout:6e4;this.b=new D.$Zg(O),this.d=null,this.f=null}getChannel(u){const $=this;return{call(O,g,y){return $.k(u,O,g,y)},listen(O,g){return $.l(u,O,g)}}}k(u,$,O,g=N.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(E.$6());this.b.cancel();const y=this.n(u),s=(0,D.$Qg)(i=>y.call($,O,i)),o=g.onCancellationRequested(()=>s.cancel()),t=(0,c.$Qc)(()=>s.cancel());return this.c.add(t),s.finally(()=>{o.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(u,$,O){if(!this.b)return h.Event.None;this.b.cancel();let g;const y=new h.$Sd({onWillAddFirstListener:()=>{g=this.n(u).listen($,O)(y.fire,y),this.c.add(g)},onDidRemoveLastListener:()=>{this.c.delete(g),g.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return y.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],$=Object.create(null);$.env={...(0,P.$jn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&($.env={...$.env,...this.j.env}),this.j&&this.j.freshExecArgv&&($.execArgv=[]),this.j&&typeof this.j.debug=="number"&&($.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&($.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),$.execArgv===void 0&&($.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,d.$Pl)($.env),this.d=(0,L.fork)(this.i,u,$);const O=new h.$Sd;h.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,A.$aq)(n)){(0,A.log)(n,`IPC Library: ${this.j.serverName}`);return}O.fire(R.$ge.wrap(Buffer.from(n,"base64")))});const y=this.j.useQueue?(0,I.$Rl)(this.d):this.d,s=n=>this.d&&this.d.connected&&y.send(n.buffer.toString("base64")),o=O.event,t={send:s,onMessage:o};this.f=new f.$Fh(t);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,r)=>{process.removeListener("exit",i),this.c.forEach(l=>(0,c.$Nc)(l)),this.c.clear(),n!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:r})})}return this.f}n(u){let $=this.g.get(u);return $||($=this.m.getChannel(u),this.g.set(u,$)),$}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$fq=v}),define(te[86],ne([0,1,8,4,2,46,3]),function(G,e,L,D,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.StorageState=e.$dp=e.StorageHint=void 0;var E;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(E||(e.StorageHint=E={}));function h(d){const f=d;return f?.changed instanceof Map||f?.deleted instanceof Set}e.$dp=h;var c;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(c||(e.StorageState=c={}));class P extends R.$Sc{static{this.a=100}constructor(f,S=Object.create(null)){super(),this.r=f,this.s=S,this.b=this.B(new D.$Vd),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new L.$1g(P.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((S,v)=>this.w(v,S)),f.deleted?.forEach(S=>this.w(S,void 0))}finally{this.b.resume()}}w(f,S){if(this.c===c.Closed)return;let v=!1;(0,A.$Of)(S)?v=this.f.delete(f):this.f.get(f)!==S&&(this.f.set(f,S),v=!0),v&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,S){const v=this.f.get(f);return(0,A.$Of)(v)?S:v}getBoolean(f,S){const v=this.get(f);return(0,A.$Of)(v)?S:v==="true"}getNumber(f,S){const v=this.get(f);return(0,A.$Of)(v)?S:parseInt(v,10)}getObject(f,S){const v=this.get(f);return(0,A.$Of)(v)?S:(0,N.$yh)(v)}async set(f,S,v=!1){if(this.c===c.Closed)return;if((0,A.$Of)(S))return this.delete(f,v);const p=(0,A.$Hf)(S)||Array.isArray(S)?(0,N.$xh)(S):String(S);if(this.f.get(f)!==p)return this.f.set(f,p),this.j.set(f,p),this.h.delete(f),this.b.fire({key:f,external:v}),this.D()}async delete(f,S=!1){if(!(this.c===c.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:S}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===E.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===E.STORAGE_IN_MEMORY}}e.$ep=P;class I{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((S,v)=>this.a.set(v,S)),f.delete?.forEach(S=>this.a.delete(S))}async optimize(){}async close(){}}e.$fp=I}),define(te[87],ne([7,5]),function(G,e){return G.create("vs/base/node/zip",e)}),define(te[48],ne([0,1,88,8,16,3,24,87]),function(G,e,L,D,R,N,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$Cp=e.zip=e.$Ap=e.$zp=void 0,e.$zp="end of central directory record signature not found";const h=new RegExp(e.$zp);class c extends Error{constructor(y,s){let o=s.message;switch(y){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=y,this.cause=s}}e.$Ap=c;function P(g){const y=g.externalFileAttributes>>16||33188;return[448,56,7].map(s=>y&s).reduce((s,o)=>s+o,y&61440)}function I(g){if(g instanceof c)return g;let y;return h.test(g.message)&&(y="CorruptZip"),new c(y,g)}function d(g,y,s,o,t,i){const n=R.$mc(y),r=R.$jc(o,n);if(!r.startsWith(o))return Promise.reject(new Error(E.localize(0,null,y)));const l=R.$jc(o,y);let k;return i.onCancellationRequested(()=>{k?.destroy()}),Promise.resolve(A.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((b,w)=>{if(!i.isCancellationRequested)try{k=(0,L.createWriteStream)(l,{mode:s}),k.once("close",()=>b()),k.once("error",w),g.once("error",w),g.pipe(k)}catch(j){w(j)}}))}function f(g,y,s,o){let t=(0,D.$Qg)(()=>Promise.resolve()),i=0;const n=o.onCancellationRequested(()=>{t.cancel(),g.close()});return new Promise((r,l)=>{const k=new D.$Xg,b=w=>{w.isCancellationRequested||(i++,g.readEntry())};g.once("error",l),g.once("close",()=>t.then(()=>{o.isCancellationRequested||g.entryCount===i?r():l(new c("Incomplete",new Error(E.localize(1,null,i,g.entryCount))))},l)),g.readEntry(),g.on("entry",w=>{if(o.isCancellationRequested)return;if(!s.sourcePathRegex.test(w.fileName)){b(o);return}const j=w.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(j)){const _=R.$jc(y,j);t=(0,D.$Qg)(re=>A.Promises.mkdir(_,{recursive:!0}).then(()=>b(re)).then(void 0,l));return}const H=v(g,w),ee=P(w);t=(0,D.$Qg)(_=>k.queue(()=>H.then(re=>d(re,j,ee,y,s,_).then(()=>b(_)))).then(null,l))})}).finally(()=>n.dispose())}async function S(g,y=!1){const{open:s}=await new Promise((o,t)=>{G(["yauzl"],o,t)});return new Promise((o,t)=>{s(g,y?{lazyEntries:!0}:void 0,(i,n)=>{i?t(I(i)):o((0,N.$Qf)(n))})})}function v(g,y){return new Promise((s,o)=>{g.openReadStream(y,(t,i)=>{t?o(I(t)):s((0,N.$Qf)(i))})})}async function p(g,y){const{ZipFile:s}=await new Promise((o,t)=>{G(["yazl"],o,t)});return new Promise((o,t)=>{const i=new s;y.forEach(r=>{r.contents?i.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&i.addFile(r.localPath,r.path)}),i.end();const n=(0,L.createWriteStream)(g);i.outputStream.pipe(n),i.outputStream.once("error",t),n.once("error",t),n.once("finish",()=>o(g))})}e.zip=p;function u(g,y,s={},o){const t=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let i=S(g,!0);return s.overwrite&&(i=i.then(n=>A.Promises.rm(y).then(()=>n))),i.then(n=>f(n,y,{sourcePathRegex:t},o))}e.$Cp=u;function $(g,y){return S(g).then(s=>new Promise((o,t)=>{s.on("entry",i=>{i.fileName===y&&v(s,i).then(n=>o(n),n=>t(n))}),s.once("close",()=>t(new Error(E.localize(2,null,y))))}))}function O(g,y){return $(g,y).then(s=>new Promise((o,t)=>{const i=[];s.once("error",t),s.on("data",n=>i.push(n)),s.on("end",()=>o(Buffer.concat(i)))}))}e.$Dp=O}),define(te[89],ne([7,5]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[90],ne([7,5]),function(G,e){return G.create("vs/platform/contextkey/common/contextkey",e)}),define(te[91],ne([7,5]),function(G,e){return G.create("vs/platform/contextkey/common/scanner",e)}),define(te[92],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[93],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[94],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(te[95],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[96],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[97],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[98],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[99],ne([7,5]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[100],ne([7,5]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(te[101],ne([7,5]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(te[102],ne([7,5]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[103],ne([7,5]),function(G,e){return G.create("vs/platform/languagePacks/common/languagePacks",e)}),define(te[104],ne([7,5]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(te[105],ne([7,5]),function(G,e){return G.create("vs/platform/shell/node/shellEnv",e)}),define(te[106],ne([7,5]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[107],ne([7,5]),function(G,e){return G.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[108],ne([7,5]),function(G,e){return G.create("vs/platform/workspace/common/workspace",e)}),define(te[109],ne([0,1,9,91]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xi=e.TokenType=void 0;var R;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(R||(e.TokenType=R={}));function N(...c){switch(c.length){case 1:return(0,D.localize)(0,null,c[0]);case 2:return(0,D.localize)(1,null,c[0],c[1]);case 3:return(0,D.localize)(2,null,c[0],c[1],c[2]);default:return}}const A=(0,D.localize)(3,null),E=(0,D.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,L.$8)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(N("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(N("&&"));break;case 124:this.h(124)?this.k(16):this.l(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const I=this.d,d=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:d};this.g.push({offset:I,lexeme:d,additionalInfo:P}),this.f.push(f)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const I=this.c.substring(this.d,this.e),d=h.b.get(I);d?this.k(d):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,I=!1,d=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(E);return}const S=this.c.charCodeAt(P);if(I)I=!1;else if(S===47&&!d){P++;break}else S===91?d=!0:S===92?I=!0:S===93&&(d=!1);P++}for(;P<this.c.length&&h.a.has(this.c.charCodeAt(P));)P++;this.e=P;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Xi=h}),define(te[110],ne([0,1,76,52,15,16,35,17,11]),function(G,e,L,D,R,N,A,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xm=e.$wm=e.$vm=e.$um=void 0,e.$um=/^([^.]+\..+)[:=](.+)$/;class c{get appRoot(){return(0,N.$mc)(R.$lg.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,N.$jc)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,E.$Eg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:R.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.$Eg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,L.$tm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,N.$jc)(this.userDataPath,"logs",f)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.$Eg)(h.URI.file((0,N.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.$Eg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.$Eg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.$Eg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=A.env.VSCODE_PORTABLE;return f?h.URI.file((0,N.$jc)(f,"argv.json")):(0,E.$Eg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,N.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,N.$kc)(f):(0,N.$hc)((0,N.$jc)(R.$lg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?h.URI.file((0,N.$kc)(f)):h.URI.file((0,N.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,N.$kc)(f);const S=A.env.VSCODE_EXTENSIONS;if(S)return S;const v=A.env.VSCODE_PORTABLE;return v?(0,N.$jc)(v,"extensions"):(0,E.$Eg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(S=>/^[^:/?#]+?:\/\//.test(S)?h.URI.parse(S):h.URI.file((0,N.$hc)(S)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?h.URI.parse(f):h.URI.file((0,N.$hc)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$um.test(f))}get extensionLogLevel(){const f=[];for(const S of this.args.log||[]){const v=e.$um.exec(S);v&&v[1]&&v[2]&&f.push([v[1],v[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,E.$Eg)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=A.env.VSCODE_PORTABLE;return f?h.URI.file((0,N.$jc)(f,"policy.json")):(0,E.$Eg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,S,v){this.a=f,this.b=S,this.c=v,this.editSessionId=this.args.editSessionId}}e.$vm=c,pe([D.$uh],c.prototype,"appRoot",null),pe([D.$uh],c.prototype,"userHome",null),pe([D.$uh],c.prototype,"userDataPath",null),pe([D.$uh],c.prototype,"appSettingsHome",null),pe([D.$uh],c.prototype,"tmpDir",null),pe([D.$uh],c.prototype,"cacheHome",null),pe([D.$uh],c.prototype,"stateResource",null),pe([D.$uh],c.prototype,"userRoamingDataHome",null),pe([D.$uh],c.prototype,"userDataSyncHome",null),pe([D.$uh],c.prototype,"sync",null),pe([D.$uh],c.prototype,"machineSettingsResource",null),pe([D.$uh],c.prototype,"workspaceStorageHome",null),pe([D.$uh],c.prototype,"localHistoryHome",null),pe([D.$uh],c.prototype,"keyboardLayoutResource",null),pe([D.$uh],c.prototype,"argvResource",null),pe([D.$uh],c.prototype,"isExtensionDevelopment",null),pe([D.$uh],c.prototype,"untitledWorkspacesHome",null),pe([D.$uh],c.prototype,"builtinExtensionsPath",null),pe([D.$uh],c.prototype,"extensionsPath",null),pe([D.$uh],c.prototype,"extensionDevelopmentLocationURI",null),pe([D.$uh],c.prototype,"extensionDevelopmentKind",null),pe([D.$uh],c.prototype,"extensionTestsLocationURI",null),pe([D.$uh],c.prototype,"debugExtensionHost",null),pe([D.$uh],c.prototype,"logLevel",null),pe([D.$uh],c.prototype,"extensionLogLevel",null),pe([D.$uh],c.prototype,"serviceMachineIdResource",null),pe([D.$uh],c.prototype,"disableTelemetry",null),pe([D.$uh],c.prototype,"disableWorkspaceTrust",null),pe([D.$uh],c.prototype,"useInMemorySecretStorage",null),pe([D.$uh],c.prototype,"policyFile",null);function P(d,f){return I(d["inspect-extensions"],d["inspect-brk-extensions"],5870,f,d.debugId,d.extensionEnvironment)}e.$wm=P;function I(d,f,S,v,p,u){const O=Number(f||d)||(v?null:S),g=O?!!f:!1;let y;if(u)try{y=JSON.parse(u)}catch{}return{port:O,break:g,debugId:p,env:y}}e.$xm=I}),function(){"use strict";function G(e,L,D){function R(A,E){const h=N(A,E),c=[h];return e.isAbsolute(h)||c.unshift(D),e.resolve(...c)}function N(A,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,E);const P=A["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(I,"AppData","Roaming")}break;case"darwin":c=e.join(L.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,E)}return{getUserDataPath:R}}if(typeof define=="function")define(te[111],ne([165,33,35]),function(e,L,D){return G(e,L,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=G(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[112],ne([0,1,33,110,111]),function(G,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=e.$zm=e.$ym=void 0;class N extends D.$vm{constructor(c,P){super(c,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,R.getUserDataPath)(c,P.nameShort)},P)}}e.$ym=N;function A(h,c){return(0,D.$xm)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,c,h.extensionEnvironment)}e.$zm=A;function E(h,c){return(0,D.$xm)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,c,h.extensionEnvironment)}e.$Am=E}),define(te[113],ne([0,1,3,95]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;function R(A,E,h,c){try{N(A,E,h,c)}catch(P){A.error(P?.message??P)}return E}e.$Mp=R;function N(A,E,h,c){const P=(I,d,f)=>{const S=I[d];if((0,L.$Ff)(S)){const v=S,p=v.length;if(p>1&&v[0]==="%"&&v[p-1]==="%"){const u=v.substr(1,p-2);let $=h[u];$===void 0&&c&&($=c[u]);const O=typeof $=="string"?$:$?.message,g=c?.[u],y=typeof g=="string"?g:g?.message;if(!O){y||A.warn(`[${E.name}]: ${(0,D.localize)(0,null,u)}`);return}if(f&&(d==="title"||d==="category")&&y&&y!==O){const s={value:O,original:y};I[d]=s}else I[d]=O}}else if((0,L.$Hf)(S))for(const v in S)S.hasOwnProperty(v)&&(v==="commands"?P(S,v,!0):P(S,v,f));else if(Array.isArray(S))for(let v=0;v<S.length;v++)P(S,v,f)};for(const I in E)E.hasOwnProperty(I)&&P(E,I)}}),define(te[114],ne([0,1,48,98]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=void 0;function R(N){return(0,L.$Dp)(N,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}e.$Up=R}),define(te[49],ne([0,1,17,54,99,42]),function(G,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function h(u){return u=u.trim(),u==="*"||A.test(u)}e.$1o=h;function c(u){if(!h(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const $=u.match(A);return $?{hasCaret:$[1]==="^",hasGreaterEquals:$[1]===">=",majorBase:$[2]==="x"?0:parseInt($[2],10),majorMustEqual:$[2]!=="x",minorBase:$[4]==="x"?0:parseInt($[4],10),minorMustEqual:$[4]!=="x",patchBase:$[6]==="x"?0:parseInt($[6],10),patchMustEqual:$[6]!=="x",preRelease:$[8]||null}:null}e.$2o=c;function P(u){if(!u)return null;const $=u.majorBase,O=u.majorMustEqual,g=u.minorBase;let y=u.minorMustEqual;const s=u.patchBase;let o=u.patchMustEqual;u.hasCaret&&($===0||(y=!1),o=!1);let t=0;if(u.preRelease){const i=E.exec(u.preRelease);if(i){const[,n,r,l]=i;t=Date.UTC(Number(n),Number(r)-1,Number(l))}}return{majorBase:$,majorMustEqual:O,minorBase:g,minorMustEqual:y,patchBase:s,patchMustEqual:o,isMinimum:u.hasGreaterEquals,notBefore:t}}e.$3o=P;function I(u,$,O){let g;typeof u=="string"?g=P(c(u)):g=u;let y;$ instanceof Date?y=$.getTime():typeof $=="string"&&(y=new Date($).getTime());let s;if(typeof O=="string"?s=P(c(O)):s=O,!g||!s)return!1;const o=g.majorBase,t=g.minorBase,i=g.patchBase;let n=s.majorBase,r=s.minorBase,l=s.patchBase;const k=s.notBefore;let b=s.majorMustEqual,w=s.minorMustEqual,j=s.patchMustEqual;return s.isMinimum?o>n?!0:o<n?!1:t>r?!0:t<r||y&&y<k?!1:i>=l:(o===1&&n===0&&(!b||!w||!j)&&(n=1,r=0,l=0,b=!0,w=!1,j=!1),o<n?!1:o>n?!b:t<r?!1:t>r?!w:i<l?!1:i>l?!j:!(y&&y<k))}e.$4o=I;function d(u,$,O,g,y){const s=[];if(typeof g.publisher<"u"&&typeof g.publisher!="string")return s.push([D.default.Error,R.localize(0,null)]),s;if(typeof g.name!="string")return s.push([D.default.Error,R.localize(1,null,"name")]),s;if(typeof g.version!="string")return s.push([D.default.Error,R.localize(2,null,"version")]),s;if(!g.engines)return s.push([D.default.Error,R.localize(3,null,"engines")]),s;if(typeof g.engines.vscode!="string")return s.push([D.default.Error,R.localize(4,null,"engines.vscode")]),s;if(typeof g.extensionDependencies<"u"&&!p(g.extensionDependencies))return s.push([D.default.Error,R.localize(5,null,"extensionDependencies")]),s;if(typeof g.activationEvents<"u"){if(!p(g.activationEvents))return s.push([D.default.Error,R.localize(6,null,"activationEvents")]),s;if(typeof g.main>"u"&&typeof g.browser>"u")return s.push([D.default.Error,R.localize(7,null,"activationEvents","main","browser")]),s}if(typeof g.extensionKind<"u"&&typeof g.main>"u"&&s.push([D.default.Warning,R.localize(8,null,"extensionKind")]),typeof g.main<"u"){if(typeof g.main!="string")return s.push([D.default.Error,R.localize(9,null,"main")]),s;{const i=(0,L.$Eg)(O,g.main);(0,L.$yg)(i,O)||s.push([D.default.Warning,R.localize(10,null,i.path,O.path)])}}if(typeof g.browser<"u"){if(typeof g.browser!="string")return s.push([D.default.Error,R.localize(11,null,"browser")]),s;{const i=(0,L.$Eg)(O,g.browser);(0,L.$yg)(i,O)||s.push([D.default.Warning,R.localize(12,null,i.path,O.path)])}}if(!N.valid(g.version))return s.push([D.default.Error,R.localize(13,null)]),s;const o=[];if(!f(u,$,g,y,o))for(const i of o)s.push([D.default.Error,i]);return s}e.$5o=d;function f(u,$,O,g,y){return g||typeof O.main>"u"&&typeof O.browser>"u"?!0:v(u,$,O.engines.vscode,y)}e.$6o=f;function S(u,$,O){return u==="*"||v($,O,u)}e.$7o=S;function v(u,$,O,g=[]){const y=P(c(O));if(!y)return g.push(R.localize(14,null,O)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return g.push(R.localize(15,null,O)),!1}else if(!y.majorMustEqual)return g.push(R.localize(16,null,O)),!1;return I(u,$,y)?!0:(g.push(R.localize(17,null,u,O)),!1)}function p(u){if(!Array.isArray(u))return!1;for(let $=0,O=u.length;$<O;$++)if(typeof u[$]!="string")return!1;return!0}}),define(te[115],ne([0,1,14,28]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=void 0;async function R(N,A,E){let h=E&&E.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const P=(await A.readFile(N.serviceMachineIdResource)).value.toString();h=(0,D.$mg)(P)?P:null}catch{h=null}if(!h){h=(0,D.$ng)();try{await A.writeFile(N.serviceMachineIdResource,L.$ge.fromString(h))}catch{}}return E?.store("storage.serviceMachineId",h,-1,1),h}e.$op=R}),define(te[50],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=void 0;class L{constructor(R,N=[],A=!1){this.ctor=R,this.staticArguments=N,this.supportsDelayedInstantiation=A}}e.$Zh=L}),define(te[116],ne([0,1,50]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mr=e.$Lr=e.InstantiationType=void 0;const D=[];var R;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function N(E,h,c){h instanceof L.$Zh||(h=new L.$Zh(h,[],!!c)),D.push([E,h])}e.$Lr=N;function A(){return D}e.$Mr=A}),define(te[117],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=void 0;class L{constructor(N,A){this.key=N,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$qq=L;class D{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const A of this.a.values())A.outgoing.size===0&&N.push(A);return N}insertEdge(N,A){const E=this.lookupOrInsertNode(N),h=this.lookupOrInsertNode(A);E.outgoing.set(h.key,h),h.incoming.set(E.key,E)}removeNode(N){const A=this.b(N);this.a.delete(A);for(const E of this.a.values())E.outgoing.delete(A),E.incoming.delete(A)}lookupOrInsertNode(N){const A=this.b(N);let E=this.a.get(A);return E||(E=new L(A,N),this.a.set(A,E)),E}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[A,E]of this.a)N.push(`${A}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,A]of this.a){const E=new Set([N]),h=this.c(A,E);if(h)return h}}c(N,A){for(const[E,h]of N.outgoing){if(A.has(E))return[...A,E].join(" -> ");A.add(E);const c=this.c(h,A);if(c)return c;A.delete(E)}}}e.$rq=D}),define(te[25],ne([0,1,3,11,10]),function(G,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.ConfigurationTarget=e.$yi=e.$xi=e.$wi=void 0,e.$wi=(0,R.$3h)("configurationService");function N(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof D.URI)}e.$xi=N;function A(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof D.URI)}e.$yi=A;var E;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(E||(e.ConfigurationTarget=E={}));function h(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$zi=h;function c(u){return u.applicationValue!==void 0||u.userValue!==void 0||u.userLocalValue!==void 0||u.userRemoteValue!==void 0||u.workspaceValue!==void 0||u.workspaceFolderValue!==void 0}e.$Ai=c;function P(u,$){const O=Object.create(null);for(const g in u)I(O,g,u[g],$);return O}e.$Bi=P;function I(u,$,O,g){const y=$.split("."),s=y.pop();let o=u;for(let t=0;t<y.length;t++){const i=y[t];let n=o[i];switch(typeof n){case"undefined":n=o[i]=Object.create(null);break;case"object":break;default:g(`Ignoring ${$} as ${y.slice(0,t+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[s]=O}catch{g(`Ignoring ${$} as ${y.join(".")} is ${JSON.stringify(o)}`)}else g(`Ignoring ${$} as ${y.join(".")} is ${JSON.stringify(o)}`)}e.$Ci=I;function d(u,$){const O=$.split(".");f(u,O)}e.$Di=d;function f(u,$){const O=$.shift();if($.length===0){delete u[O];return}if(Object.keys(u).indexOf(O)!==-1){const g=u[O];typeof g=="object"&&!Array.isArray(g)&&(f(g,$),Object.keys(g).length===0&&delete u[O])}}function S(u,$,O){function g(o,t){let i=o;for(const n of t){if(typeof i!="object"||i===null)return;i=i[n]}return i}const y=$.split("."),s=g(u,y);return typeof s>"u"?O:s}e.$Ei=S;function v(u,$,O){Object.keys($).forEach(g=>{g!=="__proto__"&&(g in u?L.$Hf(u[g])&&L.$Hf($[g])?v(u[g],$[g],O):O&&(u[g]=$[g]):u[g]=$[g])})}e.$Fi=v;function p(u){return u.replace(/[\[\]]/g,"")}e.$Gi=p}),define(te[118],ne([0,1,13,29,109,10,90,9]),function(G,e,L,D,R,N,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.ContextKeyExprType=e.$Yi=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",L.$j),h.set("isLinux",L.$k),h.set("isWindows",L.$i),h.set("isWeb",L.$o),h.set("isMacNative",L.$j&&!L.$o),h.set("isEdge",L.$H),h.set("isFirefox",L.$F),h.set("isChrome",L.$E),h.set("isSafari",L.$G);function c(F,a){if(h.get(F)!==void 0)throw(0,E.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(F,a)}e.$Yi=c;const P=Object.prototype.hasOwnProperty;var I;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const d={regexParsingWithErrorRecovery:!0},f=(0,A.localize)(0,null),S=(0,A.localize)(1,null),v=(0,A.localize)(2,null),p=(0,A.localize)(3,null),u=(0,A.localize)(4,null),$=(0,A.localize)(5,null),O=(0,A.localize)(6,null),g=(0,A.localize)(7,null);class y{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(a=d){this.k=a,this.d=new R.$Xi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(a){if(a===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(a).scan(),this.g=0,this.h=[];try{const m=this.l();if(!this.E()){const z=this.D(),U=z.type===17?$:void 0;throw this.h.push({message:u,offset:z.offset,lexeme:R.$Xi.getLexeme(z),additionalInfo:U}),y.c}return m}catch(m){if(m!==y.c)throw m;return}}l(){return this.m()}m(){const a=[this.o()];for(;this.y(16);){const m=this.o();a.push(m)}return a.length===1?a[0]:s.or(...a)}o(){const a=[this.s()];for(;this.y(15);){const m=this.s();a.push(m)}return a.length===1?a[0]:s.and(...a)}s(){if(this.y(2)){const a=this.D();switch(a.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const m=this.l();return this.A(1,p),m?.negate()}case 17:return this.z(),H.create(a.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",a)}}return this.t()}t(){const a=this.D();switch(a.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const m=this.l();return this.A(1,p),m}case 17:{const m=a.lexeme;if(this.z(),this.y(9)){const U=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),U.type!==10)throw this.B("REGEX",U);const Z=U.lexeme,W=Z.lastIndexOf("/"),le=W===Z.length-1?void 0:this.w(Z.substring(W+1));let ae;try{ae=new RegExp(Z.substring(1,W),le)}catch{throw this.B("REGEX",U)}return ce.create(m,ae)}switch(U.type){case 10:case 19:{const Z=[U.lexeme];this.z();let W=this.D(),le=0;for(let fe=0;fe<U.lexeme.length;fe++)U.lexeme.charCodeAt(fe)===40?le++:U.lexeme.charCodeAt(fe)===41&&le--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:le++;break;case 1:le--;break;case 10:case 18:for(let fe=0;fe<W.lexeme.length;fe++)W.lexeme.charCodeAt(fe)===40?le++:U.lexeme.charCodeAt(fe)===41&&le--}if(le<0)break;Z.push(R.$Xi.getLexeme(W)),this.z(),W=this.D()}const ae=Z.join(""),me=ae.lastIndexOf("/"),de=me===ae.length-1?void 0:this.w(ae.substring(me+1));let ge;try{ge=new RegExp(ae.substring(1,me),de)}catch{throw this.B("REGEX",U)}return s.regex(m,ge)}case 18:{const Z=U.lexeme;this.z();let W=null;if(!(0,D.$Ge)(Z)){const le=Z.indexOf("/"),ae=Z.lastIndexOf("/");if(le!==ae&&le>=0){const me=Z.slice(le+1,ae),de=Z[ae+1]==="i"?"i":"";try{W=new RegExp(me,de)}catch{throw this.B("REGEX",U)}}}if(W===null)throw this.B("REGEX",U);return ce.create(m,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const U=this.u();return s.notIn(m,U)}switch(this.D().type){case 3:{this.z();const U=this.u();if(this.x().type===18)return s.equals(m,U);switch(U){case"true":return s.has(m);case"false":return s.not(m);default:return s.equals(m,U)}}case 4:{this.z();const U=this.u();if(this.x().type===18)return s.notEquals(m,U);switch(U){case"true":return s.not(m);case"false":return s.has(m);default:return s.notEquals(m,U)}}case 5:return this.z(),se.create(m,this.u());case 6:return this.z(),ue.create(m,this.u());case 7:return this.z(),_.create(m,this.u());case 8:return this.z(),re.create(m,this.u());case 13:return this.z(),s.in(m,this.u());default:return s.has(m)}}case 20:throw this.h.push({message:O,offset:a.offset,lexeme:"",additionalInfo:g}),y.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const a=this.D();switch(a.type){case 17:case 18:return this.z(),a.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(a){return a.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(a){return this.C(a)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(a,m){if(this.C(a))return this.z();throw this.B(m,this.D())}B(a,m,z){const U=(0,A.localize)(8,null,a,R.$Xi.getLexeme(m)),Z=m.offset,W=R.$Xi.getLexeme(m);return this.h.push({message:U,offset:Z,lexeme:W,additionalInfo:z}),y.c}C(a){return this.D().type===a}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Zi=y;class s{static false(){return n.INSTANCE}static true(){return r.INSTANCE}static has(a){return l.create(a)}static equals(a,m){return k.create(a,m)}static notEquals(a,m){return j.create(a,m)}static regex(a,m){return ce.create(a,m)}static in(a,m){return b.create(a,m)}static notIn(a,m){return w.create(a,m)}static not(a){return H.create(a)}static and(...a){return X.create(a,null,!0)}static or(...a){return T.create(a,null,!0)}static greater(a,m){return _.create(a,m)}static greaterEquals(a,m){return re.create(a,m)}static smaller(a,m){return se.create(a,m)}static smallerEquals(a,m){return ue.create(a,m)}static{this.c=new y({regexParsingWithErrorRecovery:!1})}static deserialize(a){return a==null?void 0:this.c.parse(a)}}e.$1i=s;function o(F){const a=new y({regexParsingWithErrorRecovery:!1});return F.map(m=>(a.parse(m),a.lexingErrors.length>0?a.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,A.localize)(9,null,z.additionalInfo):(0,A.localize)(10,null),offset:z.offset,length:z.lexeme.length})):a.parsingErrors.length>0?a.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.$2i=o;function t(F,a){const m=F?F.substituteConstants():void 0,z=a?a.substituteConstants():void 0;return!m&&!z?!0:!m||!z?!1:m.equals(z)}e.$3i=t;function i(F,a){return F.cmp(a)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return r.INSTANCE}}e.$4i=n;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return n.INSTANCE}}e.$5i=r;class l{static create(a,m=null){const z=h.get(a);return typeof z=="boolean"?z?r.INSTANCE:n.INSTANCE:new l(a,m)}constructor(a,m){this.key=a,this.c=m,this.type=2}cmp(a){return a.type!==this.type?this.type-a.type:V(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}substituteConstants(){const a=h.get(this.key);return typeof a=="boolean"?a?r.INSTANCE:n.INSTANCE:this}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return this.c||(this.c=H.create(this.key,this)),this.c}}e.$6i=l;class k{static create(a,m,z=null){if(typeof m=="boolean")return m?l.create(a,z):H.create(a,z);const U=h.get(a);return typeof U=="boolean"?m===(U?"true":"false")?r.INSTANCE:n.INSTANCE:new k(a,m,z)}constructor(a,m,z){this.c=a,this.d=m,this.f=z,this.type=4}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=h.get(this.c);if(typeof a=="boolean"){const m=a?"true":"false";return this.d===m?r.INSTANCE:n.INSTANCE}return this}evaluate(a){return a.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(a){return a.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$7i=k;class b{static create(a,m){return new b(a,m)}constructor(a,m){this.d=a,this.f=m,this.type=10,this.c=null}cmp(a){return a.type!==this.type?this.type-a.type:J(this.d,this.f,a.d,a.f)}equals(a){return a.type===this.type?this.d===a.d&&this.f===a.f:!1}substituteConstants(){return this}evaluate(a){const m=a.getValue(this.f),z=a.getValue(this.d);return Array.isArray(m)?m.includes(z):typeof z=="string"&&typeof m=="object"&&m!==null?P.call(m,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(a){return a.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$8i=b;class w{static create(a,m){return new w(a,m)}constructor(a,m){this.d=a,this.f=m,this.type=11,this.c=b.create(a,m)}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(a){return a.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$9i=w;class j{static create(a,m,z=null){if(typeof m=="boolean")return m?H.create(a,z):l.create(a,z);const U=h.get(a);return typeof U=="boolean"?m===(U?"true":"false")?n.INSTANCE:r.INSTANCE:new j(a,m,z)}constructor(a,m,z){this.c=a,this.d=m,this.f=z,this.type=5}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=h.get(this.c);if(typeof a=="boolean"){const m=a?"true":"false";return this.d===m?n.INSTANCE:r.INSTANCE}return this}evaluate(a){return a.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(a){return a.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$0i=j;class H{static create(a,m=null){const z=h.get(a);return typeof z=="boolean"?z?n.INSTANCE:r.INSTANCE:new H(a,m)}constructor(a,m){this.c=a,this.d=m,this.type=3}cmp(a){return a.type!==this.type?this.type-a.type:V(this.c,a.c)}equals(a){return a.type===this.type?this.c===a.c:!1}substituteConstants(){const a=h.get(this.c);return typeof a=="boolean"?a?n.INSTANCE:r.INSTANCE:this}evaluate(a){return!a.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(a){return a.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$$i=H;function ee(F,a){if(typeof F=="string"){const m=parseFloat(F);isNaN(m)||(F=m)}return typeof F=="string"||typeof F=="number"?a(F):n.INSTANCE}class _{static create(a,m,z=null){return ee(m,U=>new _(a,U,z))}constructor(a,m,z){this.c=a,this.d=m,this.f=z,this.type=12}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$_i=_;class re{static create(a,m,z=null){return ee(m,U=>new re(a,U,z))}constructor(a,m,z){this.c=a,this.d=m,this.f=z,this.type=13}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}e.$aj=re;class se{static create(a,m,z=null){return ee(m,U=>new se(a,U,z))}constructor(a,m,z){this.c=a,this.d=m,this.f=z,this.type=14}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$bj=se;class ue{static create(a,m,z=null){return ee(m,U=>new ue(a,U,z))}constructor(a,m,z){this.c=a,this.d=m,this.f=z,this.type=15}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$cj=ue;class ce{static create(a,m){return new ce(a,m)}constructor(a,m){this.d=a,this.f=m,this.type=7,this.c=null}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.d<a.d)return-1;if(this.d>a.d)return 1;const m=this.f?this.f.source:"",z=a.f?a.f.source:"";return m<z?-1:m>z?1:0}equals(a){if(a.type===this.type){const m=this.f?this.f.source:"",z=a.f?a.f.source:"";return this.d===a.d&&m===z}return!1}substituteConstants(){return this}evaluate(a){const m=a.getValue(this.d);return this.f?this.f.test(m):!1}serialize(){const a=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${a}`}keys(){return[this.d]}map(a){return a.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=oe.create(this)),this.c}}e.$dj=ce;class oe{static create(a){return new oe(a)}constructor(a){this.c=a,this.type=8}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(a){return new oe(this.c.map(a))}negate(){return this.c}}e.$ej=oe;function q(F){let a=null;for(let m=0,z=F.length;m<z;m++){const U=F[m].substituteConstants();if(F[m]!==U&&a===null){a=[];for(let Z=0;Z<m;Z++)a[Z]=F[Z]}a!==null&&(a[m]=U)}return a===null?F:a}class X{static create(a,m,z){return X.d(a,m,z)}constructor(a,m){this.expr=a,this.c=m,this.type=6}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let m=0,z=this.expr.length;m<z;m++){const U=i(this.expr[m],a.expr[m]);if(U!==0)return U}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let m=0,z=this.expr.length;m<z;m++)if(!this.expr[m].equals(a.expr[m]))return!1;return!0}return!1}substituteConstants(){const a=q(this.expr);return a===this.expr?this:X.create(a,this.c,!1)}evaluate(a){for(let m=0,z=this.expr.length;m<z;m++)if(!this.expr[m].evaluate(a))return!1;return!0}static d(a,m,z){const U=[];let Z=!1;for(const W of a)if(W){if(W.type===1){Z=!0;continue}if(W.type===0)return n.INSTANCE;if(W.type===6){U.push(...W.expr);continue}U.push(W)}if(U.length===0&&Z)return r.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(i);for(let W=1;W<U.length;W++)U[W-1].equals(U[W])&&(U.splice(W,1),W--);if(U.length===1)return U[0];for(;U.length>1;){const W=U[U.length-1];if(W.type!==9)break;U.pop();const le=U.pop(),ae=U.length===0,me=T.create(W.expr.map(de=>X.create([de,le],null,z)),null,ae);me&&(U.push(me),U.sort(i))}if(U.length===1)return U[0];if(z){for(let W=0;W<U.length;W++)for(let le=W+1;le<U.length;le++)if(U[W].negate().equals(U[le]))return n.INSTANCE;if(U.length===1)return U[0]}return new X(U,m)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(const m of this.expr)a.push(...m.keys());return a}map(a){return new X(this.expr.map(m=>m.map(a)),null)}negate(){if(!this.c){const a=[];for(const m of this.expr)a.push(m.negate());this.c=T.create(a,this,!0)}return this.c}}e.$fj=X;class T{static create(a,m,z){return T.d(a,m,z)}constructor(a,m){this.expr=a,this.c=m,this.type=9}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let m=0,z=this.expr.length;m<z;m++){const U=i(this.expr[m],a.expr[m]);if(U!==0)return U}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let m=0,z=this.expr.length;m<z;m++)if(!this.expr[m].equals(a.expr[m]))return!1;return!0}return!1}substituteConstants(){const a=q(this.expr);return a===this.expr?this:T.create(a,this.c,!1)}evaluate(a){for(let m=0,z=this.expr.length;m<z;m++)if(this.expr[m].evaluate(a))return!0;return!1}static d(a,m,z){let U=[],Z=!1;if(a){for(let W=0,le=a.length;W<le;W++){const ae=a[W];if(ae){if(ae.type===0){Z=!0;continue}if(ae.type===1)return r.INSTANCE;if(ae.type===9){U=U.concat(ae.expr);continue}U.push(ae)}}if(U.length===0&&Z)return n.INSTANCE;U.sort(i)}if(U.length!==0){if(U.length===1)return U[0];for(let W=1;W<U.length;W++)U[W-1].equals(U[W])&&(U.splice(W,1),W--);if(U.length===1)return U[0];if(z){for(let W=0;W<U.length;W++)for(let le=W+1;le<U.length;le++)if(U[W].negate().equals(U[le]))return r.INSTANCE;if(U.length===1)return U[0]}return new T(U,m)}}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(const m of this.expr)a.push(...m.keys());return a}map(a){return new T(this.expr.map(m=>m.map(a)),null)}negate(){if(!this.c){const a=[];for(const m of this.expr)a.push(m.negate());for(;a.length>1;){const m=a.shift(),z=a.shift(),U=[];for(const Z of C(m))for(const W of C(z))U.push(X.create([Z,W],null,!1));a.unshift(T.create(U,null,!1))}this.c=T.create(a,this,!0)}return this.c}}e.$gj=T;class M extends l{static{this.d=[]}static all(){return M.d.values()}constructor(a,m,z){super(a,null),this.f=m,typeof z=="object"?M.d.push({...z,key:a}):z!==!0&&M.d.push({key:a,description:z,type:m!=null?typeof m:void 0})}bindTo(a){return a.createKey(this.key,this.f)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(a){return k.create(this.key,a)}notEqualsTo(a){return j.create(this.key,a)}}e.$hj=M,e.$ij=(0,N.$3h)("contextKeyService");function V(F,a){return F<a?-1:F>a?1:0}function J(F,a,m,z){return F<m?-1:F>m?1:a<z?-1:a>z?1:0}function Q(F,a){if(F.type===0||a.type===1)return!0;if(F.type===9)return a.type===9?K(F.expr,a.expr):!1;if(a.type===9){for(const m of a.expr)if(Q(F,m))return!0;return!1}if(F.type===6){if(a.type===6)return K(a.expr,F.expr);for(const m of F.expr)if(Q(m,a))return!0;return!1}return F.equals(a)}e.$jj=Q;function K(F,a){let m=0,z=0;for(;m<F.length&&z<a.length;){const U=F[m].cmp(a[z]);if(U<0)return!1;U===0&&m++,z++}return m===F.length}function C(F){return F.type===9?F.expr:[F]}}),define(te[59],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4n=void 0,e.$4n=(0,L.$3h)("downloadService")}),define(te[18],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=e.$0h=void 0,e.$0h=(0,L.$3h)("environmentService"),e.$$h=(0,L.$4h)(e.$0h)}),define(te[21],ne([0,1,93,10]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$mo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=void 0,e.$ao="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$bo=new RegExp(e.$ao),e.$co="__web_extension",e.$do="skipWalkthrough",e.$eo="extensionsSync",e.$fo="dependecyOrPackExtensionInstall";function R(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$go=R;function N(u){switch(u){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$ho=N;function A(u,$){switch(u){case 3:return $==="x64"?"win32-x64":$==="arm64"?"win32-arm64":"unknown";case 2:return $==="x64"?"linux-x64":$==="arm64"?"linux-arm64":$==="arm"?"linux-armhf":"unknown";case"alpine":return $==="x64"?"alpine-x64":$==="arm64"?"alpine-arm64":"unknown";case 1:return $==="x64"?"darwin-x64":$==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$io=A;function E(u,$){return $==="web"&&!u.includes("web")}e.$jo=E;function h(u,$,O){return E($,O)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===O}e.$ko=h;function c(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.$lo=c;var P;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var I;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(I||(e.SortOrder=I={}));var d;(function(u){u.Install="install",u.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var f;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$mo=(0,D.$3h)("extensionGalleryService");var S;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var v;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(v||(e.ExtensionSignaturetErrorCode=v={}));class p extends Error{constructor($,O){super($),this.code=O,this.name=O}}e.$no=p,e.$oo=(0,D.$3h)("extensionManagementService"),e.$po="extensionsIdentifiers/disabled",e.$qo="extensionsIdentifiers/enabled",e.$ro=(0,D.$3h)("IGlobalExtensionEnablementService"),e.$so=(0,D.$3h)("IExtensionTipsService"),e.$to=(0,L.localize)(0,null),e.$uo={value:e.$to,original:"Extensions"},e.$vo={value:(0,L.localize)(1,null),original:"Preferences"}}),define(te[60],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=e.$tp=void 0,e.$tp=(0,L.$3h)("IExtensionSignatureVerificationService");class D{b(){return this.a||(this.a=new Promise((N,A)=>G(["node-vsce-sign"],async E=>N(E),A))),this.a}async verify(N,A,E){let h;try{h=await this.b()}catch{return!1}return h.verify(N,A,E)}}e.$up=D}),define(te[61],ne([0,1,14,9,101,12]),function(G,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=void 0;async function A(P,I,d,f,S,v){let p;try{await E(P,I,d,f,S,v)}catch(u){p=u}finally{p&&S.errorTransformer&&(p=S.errorTransformer(p)),typeof p<"u"&&d.error(p),d.end()}}e.$2p=A;async function E(P,I,d,f,S,v){h(v);const p=await P.open(I,{create:!1});try{h(v);let u=0,$=0,O=S&&typeof S.length=="number"?S.length:void 0,g=L.$ge.alloc(Math.min(S.bufferSize,typeof O=="number"?O:S.bufferSize)),y=S&&typeof S.position=="number"?S.position:0,s=0;do $=await P.read(p,y,g.buffer,s,g.byteLength-s),y+=$,s+=$,u+=$,typeof O=="number"&&(O-=$),s===g.byteLength&&(await d.write(f(g)),g=L.$ge.alloc(Math.min(S.bufferSize,typeof O=="number"?O:S.bufferSize)),s=0);while($>0&&(typeof O!="number"||O>0)&&h(v)&&c(u,S));if(s>0){let o=s;typeof O=="number"&&(o=Math.min(s,O)),d.write(f(g.slice(0,o)))}}catch(u){throw(0,N.$Bk)(u)}finally{await P.close(p)}}function h(P){if(P.isCancellationRequested)throw(0,D.$6)();return!0}function c(P,I){if(typeof I?.limits?.size=="number"&&P>I.limits.size)throw(0,N.$Ak)((0,R.localize)(0,null),N.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(te[119],ne([0,1,4,166,2,13,167]),function(G,e,L,D,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;class E extends R.$Sc{constructor(){super(...arguments),this.a=this.B(new L.$Sd),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$Sd),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(c){const P=this.j(c),I=P.filter(f=>{const S=this.c.get(f.path);return S?!(0,D.$Nj)(S.request.excludes,f.excludes)||!(0,D.$Nj)(S.request.includes,f.includes):!0}),d=Array.from(this.c.values()).filter(({request:f})=>!P.find(S=>S.path===f.path&&(0,D.$Nj)(S.excludes,f.excludes)&&(0,D.$Nj)(S.includes,f.includes))).map(({request:f})=>f.path);I.length&&this.m(`Request to start watching: ${I.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`).join(",")}`),d.length&&this.m(`Request to stop watching: ${d.join(",")}`);for(const f of d)this.h(f);for(const f of I)this.g(f)}g(c){const P=new A.$lq(c,d=>this.a.fire(d),d=>this.b.fire(d),this.f),I={request:c,instance:P};this.c.set(c.path,I)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const P=this.c.get(c);P&&(this.c.delete(c),P.instance.dispose())}j(c){const P=new Map;for(const I of c){const d=N.$k?I.path:I.path.toLowerCase();let f=P.get(I.correlationId);f||(f=new Map,P.set(I.correlationId,f)),f.set(d,I)}return Array.from(P.values()).map(I=>Array.from(I.values())).flat()}async setVerboseLogging(c){this.f=c;for(const[,P]of this.c)P.instance.setVerboseLogging(c)}m(c){this.f&&this.b.fire({type:"trace",message:this.n(c)})}n(c,P){return P?`[File Watcher (node.js)] ${c} (path: ${P.request.path})`:`[File Watcher (node.js)] ${c}`}}e.$nq=E}),define(te[120],ne([0,1,62,119]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=void 0;class R extends L.$6p{constructor(A,E,h){super(A,E,h),this.s()}r(A){return A.add(new D.$nq)}}e.$oq=R}),define(te[121],ne([0,1,15,57,85,62]),function(G,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=void 0;class A extends N.$7p{constructor(h,c,P){super(h,c,P),this.s()}r(h){const c=h.add(new R.$fq(L.$lg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(c.onDidProcessExit(({code:P,signal:I})=>this.t(`terminated by itself with code ${P}, signal: ${I}`))),D.ProxyChannel.toService((0,D.$Jh)(c.getChannel("watcher")))}}e.$gq=A}),define(te[63],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=void 0;class L{constructor(...R){this.a=new Map;for(const[N,A]of R)this.set(N,A)}set(R,N){const A=this.a.get(R);return this.a.set(R,N),A}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$1h=L}),define(te[122],ne([0,1,8,9,2,50,117,10,63,168]),function(G,e,L,D,R,N,A,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=void 0;const P=!1;class I extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class d{constructor(p=new h.$1h,u=!1,$,O=P){this.f=p,this.g=u,this.h=$,this.i=O,this.o=new Set,this.f.set(E.$2h,this),this._globalGraph=O?$?._globalGraph??new A.$rq(g=>g):void 0}createChild(p){return new d(p,this.g,this,this.i)}invokeFunction(p,...u){const $=S.traceInvocation(this.i,p);let O=!1;try{return p({get:y=>{if(O)throw(0,D.$8)("service accessor is only valid during the invocation of its target method");const s=this.m(y,$);if(!s)throw new Error(`[invokeFunction] unknown service '${y}'`);return s}},...u)}finally{O=!0,$.stop()}}createInstance(p,...u){let $,O;return p instanceof N.$Zh?($=S.traceCreation(this.i,p.ctor),O=this.j(p.ctor,p.staticArguments.concat(u),$)):($=S.traceCreation(this.i,p),O=this.j(p,u,$)),$.stop(),O}j(p,u=[],$){const O=E._util.getServiceDependencies(p).sort((s,o)=>s.index-o.index),g=[];for(const s of O){const o=this.m(s.id,$);o||this.u(`[createInstance] ${p.name} depends on UNKNOWN service ${s.id}.`,!1),g.push(o)}const y=O.length>0?O[0].index:u.length;if(u.length!==y){console.trace(`[createInstance] First service dependency of ${p.name} at position ${y+1} conflicts with ${u.length} static arguments`);const s=y-u.length;s>0?u=u.concat(new Array(s)):u=u.slice(0,y)}return Reflect.construct(p,u.concat(g))}k(p,u){if(this.f.get(p)instanceof N.$Zh)this.f.set(p,u);else if(this.h)this.h.k(p,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(p){const u=this.f.get(p);return!u&&this.h?this.h.l(p):u}m(p,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(p));const $=this.l(p);return $ instanceof N.$Zh?this.q(p,$,u.branch(p,!0)):(u.branch(p,!1),$)}q(p,u,$){if(this.o.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this.o.add(p);try{return this.r(p,u,$)}finally{this.o.delete(p)}}r(p,u,$){const O=new A.$rq(s=>s.id.toString());let g=0;const y=[{id:p,desc:u,_trace:$}];for(;y.length;){const s=y.pop();if(O.lookupOrInsertNode(s),g++>1e3)throw new I(O);for(const o of E._util.getServiceDependencies(s.desc.ctor)){const t=this.l(o.id);if(t||this.u(`[createInstance] ${p} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(o.id)),t instanceof N.$Zh){const i={id:o.id,desc:t,_trace:s._trace.branch(o.id,!0)};O.insertEdge(s,i),y.push(i)}}}for(;;){const s=O.roots();if(s.length===0){if(!O.isEmpty())throw new I(O);break}for(const{data:o}of s){if(this.l(o.id)instanceof N.$Zh){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}O.removeNode(o)}}return this.l(p)}s(p,u,$=[],O,g){if(this.f.get(p)instanceof N.$Zh)return this.t(p,u,$,O,g);if(this.h)return this.h.s(p,u,$,O,g);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(p,u,$=[],O,g){if(O){const y=new d(void 0,this.g,this,this.i);y.c=String(p);const s=new Map,o=new L.$jh(()=>{const t=y.j(u,$,g);for(const[i,n]of s){const r=t[i];if(typeof r=="function")for(const l of n)r.apply(t,l)}return s.clear(),t});return new Proxy(Object.create(null),{get(t,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let l=s.get(i);return l||(l=new c.$3c,s.set(i,l)),(b,w,j)=>{const H=l.push([b,w,j]);return(0,R.$Qc)(H)}}if(i in t)return t[i];const n=o.value;let r=n[i];return typeof r!="function"||(r=r.bind(n),t[i]=r),r},set(t,i,n){return o.value[i]=n,!0},getPrototypeOf(t){return u.prototype}})}else return this.j(u,$,g)}u(p,u){if(u&&console.warn(p),this.g)throw new Error(p)}}e.$sq=d;var f;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(f||(f={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(p,u){return p?new S(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation(p,u){return p?new S(1,u.name):S.c}static{this.f=0}constructor(p,u){this.type=p,this.name=u,this.g=Date.now(),this.h=[]}branch(p,u){const $=new S(3,p.toString());return this.h.push([p,u,$]),$}stop(){const p=Date.now()-this.g;S.f+=p;let u=!1;function $(g,y){const s=[],o=new Array(g+1).join("	");for(const[t,i,n]of y.h)if(i&&n){u=!0,s.push(`${o}CREATES -> ${t}`);const r=$(g+1,n);r&&s.push(r)}else s.push(`${o}uses -> ${t}`);return s.join(`
`)}const O=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${$(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];(p>2||u)&&S.all.add(O.join(`
`))}}e.$tq=S});var ie=this&&this.__param||function(G,e){return function(L,D){e(L,D,G)}};define(te[64],ne([0,1,20,2,13,103,21,10]),function(G,e,L,D,R,N,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=e.$7q=void 0;function h(P){return P.tags.find(I=>I.startsWith("lp-"))?.split("lp-")[1]}e.$7q=h,e.$8q=(0,E.$3h)("languagePackService");let c=class extends D.$Sc{constructor(I){super(),this.c=I}async getAvailableLanguages(){const I=new L.$3d;setTimeout(()=>I.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},I.token)}catch{return[]}const S=d.firstPage.filter(v=>v.properties.localizedLanguages?.length&&v.tags.some(p=>p.startsWith("lp-"))).map(v=>{const p=v.properties.localizedLanguages?.[0],u=h(v);return{...this.f(u,p,v),extensionId:v.identifier.id,galleryExtension:v}});return S.push(this.f("en","English")),S}f(I,d,f){const S=d??I;let v;if(S!==I&&(v=`(${I})`),I.toLowerCase()===R.$w.toLowerCase()&&(v??="",v+=(0,N.localize)(0,null)),f?.installCount){v??="";const p=f.installCount;let u;p>1e6?u=`${Math.floor(p/1e5)/10}M`:p>1e3?u=`${Math.floor(p/1e3)}K`:u=String(p),v+=` $(cloud-download) ${u}`}return{id:I,label:S,description:v}}};e.$9q=c,e.$9q=c=pe([ie(0,A.$mo)],c)}),define(te[6],ne([0,1,34,4,41,2,31,13,17,3,11,118,10]),function(G,e,L,D,R,N,A,E,h,c,P,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.log=e.$nj=e.LogLevel=e.$mj=e.$lj=e.$kj=void 0,e.$kj=(0,d.$3h)("logService"),e.$lj=(0,d.$3h)("loggerService");function f(){return new Date().toISOString()}function S(b){return(0,c.$Jf)(b)}e.$mj=S;var v;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$nj=v.Info;function p(b,w,j){switch(w){case v.Trace:b.trace(j);break;case v.Debug:b.debug(j);break;case v.Info:b.info(j);break;case v.Warning:b.warn(j);break;case v.Error:b.error(j);break;case v.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=p;function u(b,w=!1){let j="";for(let H=0;H<b.length;H++){let ee=b[H];if(ee instanceof Error&&(ee=(0,L.$Ni)(ee,w)),typeof ee=="object")try{ee=JSON.stringify(ee)}catch{}j+=(H>0?" ":"")+ee}return j}class $ extends N.$Sc{constructor(){super(...arguments),this.b=e.$nj,this.c=this.B(new D.$Sd),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==v.Off&&this.b<=w}}e.$pj=$;class O extends ${constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...j){this.f(v.Trace)&&this.g(v.Trace,u([w,...j],!0))}debug(w,...j){this.f(v.Debug)&&this.g(v.Debug,u([w,...j]))}info(w,...j){this.f(v.Info)&&this.g(v.Info,u([w,...j]))}warn(w,...j){this.f(v.Warning)&&this.g(v.Warning,u([w,...j]))}error(w,...j){if(this.f(v.Error))if(w instanceof Error){const H=Array.prototype.slice.call(arguments);H[0]=w.stack,this.g(v.Error,u(H))}else this.g(v.Error,u([w,...j]))}flush(){}}e.$qj=O;class g extends ${constructor(w=e.$nj){super(),this.setLevel(w),this.g=!E.$i}trace(w,...j){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...j):console.log(`[main ${f()}]`,w,...j))}debug(w,...j){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...j):console.log(`[main ${f()}]`,w,...j))}info(w,...j){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...j):console.log(`[main ${f()}]`,w,...j))}warn(w,...j){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,w,...j):console.warn(`[main ${f()}]`,w,...j))}error(w,...j){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,w,...j):console.error(`[main ${f()}]`,w,...j))}flush(){}}e.$rj=g;class y extends ${constructor(w=e.$nj,j=!0){super(),this.g=j,this.setLevel(w)}trace(w,...j){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...j):console.log(w,...j))}debug(w,...j){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...j):console.log(w,...j))}info(w,...j){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...j):console.log(w,...j))}warn(w,...j){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...j):console.log(w,...j))}error(w,...j){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...j):console.error(w,...j))}flush(){}}e.$sj=y;class s extends ${constructor(w,j=e.$nj){super(),this.g=w,this.setLevel(j)}trace(w,...j){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(w),...j])}debug(w,...j){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(w),...j])}info(w,...j){this.f(v.Info)&&this.g.log(v.Info,[this.h(w),...j])}warn(w,...j){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(w),...j])}error(w,...j){this.f(v.Error)&&this.g.log(v.Error,[this.h(w),...j])}h(w){return typeof w=="string"?w:(0,L.$Ni)(w,this.f(v.Trace))}flush(){}}e.$tj=s;class o extends ${constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const j of this.g)j.setLevel(w);super.setLevel(w)}trace(w,...j){for(const H of this.g)H.trace(w,...j)}debug(w,...j){for(const H of this.g)H.debug(w,...j)}info(w,...j){for(const H of this.g)H.info(w,...j)}warn(w,...j){for(const H of this.g)H.warn(w,...j)}error(w,...j){for(const H of this.g)H.error(w,...j)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose();super.dispose()}}e.$uj=o;class t extends N.$Sc{constructor(w,j,H){if(super(),this.h=w,this.j=j,this.b=new A.$Ac,this.c=this.B(new D.$Sd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new D.$Sd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new D.$Sd),this.onDidChangeVisibility=this.g.event,H)for(const ee of H)this.b.set(ee.resource,{logger:void 0,info:ee})}m(w){return(0,c.$Ff)(w)?[...this.b.values()].find(j=>j.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,j){const H=this.n(w),ee=(0,c.$Ff)(w)?w:j?.id??(0,R.$Qi)(H.toString()).toString(16);let _=this.b.get(H)?.logger;const re=j?.logLevel==="always"?v.Trace:j?.logLevel;_||(_=this.s(H,re??this.getLogLevel(H)??this.h,{...j,id:ee}));const se={logger:_,info:{resource:H,id:ee,logLevel:re,name:j?.name,hidden:j?.hidden,extensionId:j?.extensionId,when:j?.when}};return this.registerLogger(se.info),this.b.set(H,se),_}n(w){return(0,c.$Ff)(w)?(0,h.$Eg)(this.j,`${w}.log`):w}setLogLevel(w,j){if(P.URI.isUri(w)){const H=w,ee=j,_=this.b.get(H);_&&ee!==_.info.logLevel&&(_.info.logLevel=ee===this.h?void 0:ee,_.logger?.setLevel(ee),this.b.set(_.info.resource,_),this.f.fire([H,ee]))}else{this.h=w;for(const[H,ee]of this.b.entries())this.b.get(H)?.info.logLevel===void 0&&ee.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,j){const H=this.m(w);H&&j!==!H.info.hidden&&(H.info.hidden=!j,this.b.set(H.info.resource,H),this.g.fire([H.info.resource,j]))}getLogLevel(w){let j;return w&&(j=this.b.get(w)?.info.logLevel),j??this.h}registerLogger(w){const j=this.b.get(w.resource);j?j.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const j=this.b.get(w);j&&(j.logger&&j.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[j.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$vj=t;class i{constructor(){this.onDidChangeLogLevel=new D.$Sd().event}setLevel(w){}getLevel(){return v.Info}trace(w,...j){}debug(w,...j){}info(w,...j){}warn(w,...j){}error(w,...j){}critical(w,...j){}dispose(){}flush(){}}e.$wj=i;class n extends i{}e.$xj=n;function r(b){if(b.verbose)return v.Trace;if(typeof b.logLevel=="string"){const w=k(b.logLevel.toLowerCase());if(w!==void 0)return w}return e.$nj}e.$yj=r;function l(b){switch(b){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.$zj=l;function k(b){switch(b){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$Aj=k,e.$Bj=new I.$hj("logLevel",l(v.Info))}),define(te[123],ne([0,1,19,8,9,4,2,16,62,6]),function(G,e,L,D,R,N,A,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=void 0;class P extends A.$Sc{constructor(d,f){super(),this.a=d,this.b=f,this.c=this.B(new N.$Sd),this.onDidChangeFile=this.c.event,this.g=this.B(new N.$Sd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$1g(0)),this.w=[],this.y=this.B(new D.$1g(0))}watch(d,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(d,f):this.z(d,f)}n(d,f){const S={path:this.H(d),excludes:f.excludes,includes:f.includes,recursive:f.recursive,correlationId:f.correlationId},v=(0,L.$Ub)(this.j,S);return this.r(),(0,A.$Qc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(d=>(0,R.$1)(d))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,h.$8p)(f)),f=>this.G(f),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const f of this.j)(0,h.$4p)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const f of this.j)(0,h.$4p)(f)&&d.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(d,f){const S={path:this.H(d),excludes:f.excludes,includes:f.includes,recursive:!1,correlationId:f.correlationId},v=(0,L.$Ub)(this.w,S);return this.C(),(0,A.$Qc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(d=>(0,R.$1)(d))}D(){return this.u||(this.u=this.B(this.F(d=>this.c.fire((0,h.$8p)(d)),d=>this.G(d),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(d){d.type==="error"&&this.g.fire(d.message),this.a[d.type](d.message)}H(d){return(0,E.$hc)(d.fsPath)}}e.$_p=P}),define(te[124],ne([0,1,19,8,14,20,4,41,65,2,47,15,125,17,45,100,12,61,6,9]),function(G,e,L,D,R,N,A,E,h,c,P,I,d,f,S,v,p,u,$,O){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0;let y=class extends c.$Sc{static{g=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new A.$Sd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$Sd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$Sd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$Sd),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$Sd),this.Y=this.B(new A.$Sd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$Sd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new D.$_g)}registerProvider(o,t){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${o}`);const i=new c.$Rc;return this.h.set(o,t),this.c.fire({added:!0,scheme:o,provider:t}),i.add(t.onDidChangeFile(n=>{const r=new p.$Gk(n,!this.S(t));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof t.onDidWatchError=="function"&&i.add(t.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:o}))),(0,c.$Qc)(()=>{this.c.fire({added:!1,scheme:o,provider:t}),this.h.delete(o),(0,c.$Nc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const t=[];this.f.fire({scheme:o,join(i){t.push(i)}}),!this.h.has(o)&&await D.Promises.settled(t)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,t){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&t)}listCapabilities(){return h.Iterable.map(this.h,([o,t])=>({scheme:o,capabilities:t.capabilities}))}async j(o){if(!(0,f.$Ig)(o))throw new p.$Ik((0,v.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const t=this.h.get(o.scheme);if(!t){const i=new O.$bb;throw i.message=(0,v.localize)(1,null,o.toString()),i}return t}async m(o){const t=await this.j(o);if((0,p.$tk)(t)||(0,p.$qk)(t)||(0,p.$uk)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const t=await this.j(o);if((0,p.$tk)(t)||(0,p.$qk)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,t){try{return await this.s(o,t)}catch(i){throw(0,p.$Dk)(i)===p.FileSystemProviderErrorCode.FileNotFound?new p.$Ik((0,v.localize)(2,null,this.sb(o)),1):(0,p.$Bk)(i)}}async s(o,t){const i=await this.j(o),n=this.S(i),r=t?.resolveTo,l=t?.resolveSingleChildDescendants,k=t?.resolveMetadata,b=await i.stat(o);let w;return this.t(i,o,b,void 0,!!k,(j,H)=>(w||(w=P.$9h.forUris(()=>!n),w.set(o,!0),r&&w.fill(!0,r)),w.get(j.resource)||w.findSuperstr(j.resource.with({query:null,fragment:null}))?!0:j.isDirectory&&l?H===1:!1))}async t(o,t,i,n,r,l){const{providerExtUri:k}=this.R(o),b={resource:t,name:k.basename(t),isFile:(i.type&p.FileType.File)!==0,isDirectory:(i.type&p.FileType.Directory)!==0,isSymbolicLink:(i.type&p.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&p.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&p.FilePermission.Locked),etag:(0,p.$Tk)({mtime:i.mtime,size:i.size}),children:void 0};if(b.isDirectory&&l(b,n)){try{const w=await o.readdir(t),j=await D.Promises.settled(w.map(async([H,ee])=>{try{const _=k.joinPath(t,H),re=r?await o.stat(_):{type:ee};return await this.t(o,_,re,w.length,r,l)}catch(_){return this.b.trace(_),null}}));b.children=(0,L.$Hb)(j)}catch(w){this.b.trace(w),b.children=[]}return b}return b}async resolveAll(o){return D.Promises.settled(o.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const t=await this.j(o),i=await t.stat(o);return this.t(t,o,i,void 0,!0,()=>!1)}async exists(o){const t=await this.j(o);try{return!!await t.stat(o)}catch{return!1}}async canCreateFile(o,t){try{await this.u(o,t)}catch(i){return i}return!0}async u(o,t){if(!t?.overwrite&&await this.exists(o))throw new p.$Ik((0,v.localize)(3,null,this.sb(o)),3,t)}async createFile(o,t=R.$ge.fromString(""),i){await this.u(o,i);const n=await this.writeFile(o,t);return this.r.fire(new p.$Fk(o,0,n)),n}async writeFile(o,t,i){const n=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(n);let l=i;if((0,p.$wk)(n)&&!l?.atomic){const k=n.enforceAtomicWriteFile?.(o);k&&(l={...i,atomic:k})}try{await this.w(n,o,l)||await this.U(n,r.dirname(o));let b;if((0,p.$qk)(n)&&!(t instanceof R.$ge))if((0,S.$5d)(t)){const w=await(0,S.$_d)(t,3);w.ended?b=R.$ge.concat(w.buffer):b=w}else b=(0,S.$9d)(t,w=>R.$ge.concat(w),3);else b=t;!(0,p.$tk)(n)||(0,p.$qk)(n)&&b instanceof R.$ge||(0,p.$qk)(n)&&(0,p.$wk)(n)&&l?.atomic?await this.hb(n,o,l,b):await this.db(n,o,l,b instanceof R.$ge?(0,R.$re)(b):b),this.r.fire(new p.$Fk(o,4))}catch(k){throw new p.$Ik((0,v.localize)(4,null,this.sb(o),(0,p.$Bk)(k).toString()),(0,p.$Ek)(k),l)}return this.resolve(o,{resolveMetadata:!0})}async w(o,t,i){const n=!!i?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,v.localize)(5,null,this.sb(t)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,v.localize)(6,null,this.sb(t)));if(!(o.capabilities&2))throw new Error((0,v.localize)(7,null,this.sb(t)));if(n)throw new Error((0,v.localize)(8,null,this.sb(t)))}let l;try{l=await o.stat(t)}catch{return}if(l.type&p.FileType.Directory)throw new p.$Ik((0,v.localize)(9,null,this.sb(t)),0,i);if(this.rb(t,l),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==p.$Sk&&typeof l.mtime=="number"&&typeof l.size=="number"&&i.mtime<l.mtime&&i.etag!==(0,p.$Tk)({mtime:i.mtime,size:l.size}))throw new p.$Ik((0,v.localize)(10,null),3,i);return l}async readFile(o,t,i){const n=await this.m(o);return t?.atomic?this.z(n,o,t,i):this.C(n,o,t,i)}async z(o,t,i,n){return new Promise((r,l)=>{this.cb.queueFor(t,this.R(o).providerExtUri).queue(async()=>{try{const k=await this.C(o,t,i,n);r(k)}catch(k){l(k)}})})}async C(o,t,i,n){const r=await this.D(o,t,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,R.$se)(r.value)}}async readFileStream(o,t,i){const n=await this.m(o);return this.D(n,o,t,i)}async D(o,t,i,n){const r=new N.$3d(n);let l=i;(0,p.$vk)(o)&&o.enforceAtomicReadFile?.(t)&&(l={...i,atomic:!0});const k=this.J(t,l).then(w=>w,w=>{throw r.dispose(!0),w});let b;try{return typeof l?.etag=="string"&&l.etag!==p.$Sk&&await k,l?.atomic&&(0,p.$vk)(o)||!((0,p.$tk)(o)||(0,p.$uk)(o))||(0,p.$qk)(o)&&l?.preferUnbuffered?b=this.I(o,t,l):(0,p.$uk)(o)?b=this.G(o,t,r.token,l):b=this.H(o,t,r.token,l),b.on("end",()=>r.dispose()),b.on("error",()=>r.dispose()),{...await k,value:b}}catch(w){throw b&&await(0,S.$0d)(b),this.F(w,t,l)}}F(o,t,i){const n=(0,v.localize)(11,null,this.sb(t),(0,p.$Bk)(o).toString());return o instanceof p.$Kk?new p.$Kk(n,o.stat,i):o instanceof p.$Jk?new p.$Jk(n,o.fileOperationResult,o.size,o.options):new p.$Ik(n,(0,p.$Ek)(o),i)}G(o,t,i,n=Object.create(null)){const r=o.readFileStream(t,n,i);return(0,S.$de)(r,{data:l=>l instanceof R.$ge?l:R.$ge.wrap(l),error:l=>this.F(l,t,n)},l=>R.$ge.concat(l))}H(o,t,i,n=Object.create(null)){const r=(0,R.$we)();return(0,u.$2p)(o,t,r,l=>l,{...n,bufferSize:this.a,errorTransformer:l=>this.F(l,t,n)},i),r}I(o,t,i){const n=(0,S.$7d)(r=>R.$ge.concat(r));return(async()=>{try{let r;i?.atomic&&(0,p.$vk)(o)?r=await o.readFile(t,{atomic:!0}):r=await o.readFile(t),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.L(t,r.byteLength,i),n.end(R.$ge.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async J(o,t){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new p.$Ik((0,v.localize)(12,null,this.sb(o)),0,t);if(typeof t?.etag=="string"&&t.etag!==p.$Sk&&t.etag===i.etag)throw new p.$Kk((0,v.localize)(13,null),i,t);return this.L(o,i.size,t),i}L(o,t,i){if(typeof i?.limits?.size=="number"&&t>i.limits.size)throw new p.$Jk((0,v.localize)(14,null,this.sb(o)),7,t,i)}async canMove(o,t,i){return this.M(o,t,"move",i)}async canCopy(o,t,i){return this.M(o,t,"copy",i)}async M(o,t,i,n){if(o.toString()!==t.toString())try{const r=i==="move"?this.qb(await this.n(o),o):await this.m(o),l=this.qb(await this.n(t),t);await this.Q(r,o,l,t,i,n)}catch(r){return r}return!0}async move(o,t,i){const n=this.qb(await this.n(o),o),r=this.qb(await this.n(t),t),l=await this.N(n,o,r,t,"move",!!i),k=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new p.$Fk(o,l==="move"?2:3,k)),k}async copy(o,t,i){const n=await this.m(o),r=this.qb(await this.n(t),t),l=await this.N(n,o,r,t,"copy",!!i),k=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new p.$Fk(o,l==="copy"?3:2,k)),k}async N(o,t,i,n,r,l){if(t.toString()===n.toString())return r;const{exists:k,isSameResourceWithDifferentPathCase:b}=await this.Q(o,t,i,n,r,l);if(k&&!b&&l&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),r==="copy"){if(o===i&&(0,p.$rk)(o))await o.copy(t,n,{overwrite:l});else{const w=await this.resolve(t);w.isDirectory?await this.P(o,w,i,n):await this.O(o,t,i,n)}return r}else return o===i?(await o.rename(t,n,{overwrite:l}),r):(await this.N(o,t,i,n,"copy",l),await this.del(t,{recursive:!0}),"copy")}async O(o,t,i,n){if((0,p.$tk)(o)&&(0,p.$tk)(i))return this.jb(o,t,i,n);if((0,p.$tk)(o)&&(0,p.$qk)(i))return this.pb(o,t,i,n);if((0,p.$qk)(o)&&(0,p.$tk)(i))return this.nb(o,t,i,n);if((0,p.$qk)(o)&&(0,p.$qk)(i))return this.lb(o,t,i,n)}async P(o,t,i,n){await i.mkdir(n),Array.isArray(t.children)&&await D.Promises.settled(t.children.map(async r=>{const l=this.R(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),i,l):this.O(o,r.resource,i,l)}))}async Q(o,t,i,n,r,l){let k=!1;if(o===i){const{providerExtUri:w,isPathCaseSensitive:j}=this.R(o);if(j||(k=w.isEqual(t,n)),k&&r==="copy")throw new Error((0,v.localize)(15,null,this.sb(t),this.sb(n)));if(!k&&w.isEqualOrParent(n,t))throw new Error((0,v.localize)(16,null,this.sb(t),this.sb(n)))}const b=await this.exists(n);if(b&&!k){if(!l)throw new p.$Ik((0,v.localize)(17,null,this.sb(t),this.sb(n)),4);if(o===i){const{providerExtUri:w}=this.R(o);if(w.isEqualOrParent(t,n))throw new Error((0,v.localize)(18,null,this.sb(t),this.sb(n)))}}return{exists:b,isSameResourceWithDifferentPathCase:k}}R(o){const t=this.S(o);return{providerExtUri:t?f.$ug:f.$wg,isPathCaseSensitive:t}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const t=this.qb(await this.j(o),o);await this.U(t,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new p.$Fk(o,0,i)),i}async U(o,t){const i=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(t,n.dirname(t));)try{if(!((await o.stat(t)).type&p.FileType.Directory))throw new Error((0,v.localize)(19,null,this.sb(t)));break}catch(r){if((0,p.$Dk)(r)!==p.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(t)),t=n.dirname(t)}for(let r=i.length-1;r>=0;r--){t=n.joinPath(t,i[r]);try{await o.mkdir(t)}catch(l){if((0,p.$Dk)(l)!==p.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(o,t){try{await this.W(o,t)}catch(i){return i}return!0}async W(o,t){const i=this.qb(await this.j(o),o),n=!!t?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,v.localize)(20,null,this.sb(o)));const r=t?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,v.localize)(21,null,this.sb(o)));if(n&&r)throw new Error((0,v.localize)(22,null,this.sb(o)));let l;try{l=await i.stat(o)}catch{}if(l)this.rb(o,l);else throw new p.$Ik((0,v.localize)(23,null,this.sb(o)),1);if(!!!t?.recursive){const b=await this.resolve(o);if(b.isDirectory&&Array.isArray(b.children)&&b.children.length>0)throw new Error((0,v.localize)(24,null,this.sb(o)))}return i}async del(o,t){const i=await this.W(o,t);let n=t;if((0,p.$xk)(i)&&!n?.atomic){const b=i.enforceAtomicDelete?.(o);b&&(n={...t,atomic:b})}const r=!!n?.useTrash,l=!!n?.recursive,k=n?.atomic??!1;await i.delete(o,{recursive:l,useTrash:r,atomic:k}),this.r.fire(new p.$Fk(o,1))}async cloneFile(o,t){const i=await this.j(o),n=this.qb(await this.n(t),t);if(i===n&&this.R(i).providerExtUri.isEqual(o,t))return;if(i===n&&(0,p.$sk)(i))return i.cloneFile(o,t);await this.U(n,this.R(n).providerExtUri.dirname(t));const r=this.cb.queueFor(o,this.R(i).providerExtUri);return i===n&&(0,p.$rk)(i)?r.queue(()=>i.copy(o,t,{overwrite:!0})):r.queue(()=>this.O(i,o,n,t))}static{this.ab=0}createWatcher(o,t){return this.watch(o,{...t,correlationId:g.ab++})}watch(o,t={recursive:!1,excludes:[]}){const i=new c.$Rc;let n=!1,r=()=>{n=!0};i.add((0,c.$Qc)(()=>r())),(async()=>{try{const k=await this.bb(o,t);n?(0,c.$Nc)(k):r=()=>(0,c.$Nc)(k)}catch(k){this.b.error(k)}})();const l=t.correlationId;if(typeof l=="number"){const k=i.add(new A.$Sd);return i.add(this.X.event(w=>{w.correlates(l)&&k.fire(w)})),{onDidChange:k.event,dispose:()=>i.dispose()}}return i}async bb(o,t){const i=await this.j(o),n=(0,E.$Qi)([this.R(i).providerExtUri.getComparisonKey(o),t]);let r=this.$.get(n);return r||(r={count:0,disposable:i.watch(o,t)},this.$.set(n,r)),r.count+=1,(0,c.$Qc)(()=>{r&&(r.count--,r.count===0&&((0,c.$Nc)(r.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,c.$Nc)(o.disposable);this.$.clear()}async db(o,t,i,n){return this.cb.queueFor(t,this.R(o).providerExtUri).queue(async()=>{const r=await o.open(t,{create:!0,unlock:i?.unlock??!1});try{(0,S.$5d)(n)||(0,S.$6d)(n)?await this.eb(o,r,n):await this.fb(o,r,n)}catch(l){throw(0,p.$Bk)(l)}finally{await o.close(r)}})}async eb(o,t,i){let n=0,r;if((0,S.$6d)(i)){if(i.buffer.length>0){const l=R.$ge.concat(i.buffer);await this.gb(o,t,l,l.byteLength,n,0),n+=l.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((l,k)=>{(0,S.$$d)(r,{onData:async b=>{r.pause();try{await this.gb(o,t,b,b.byteLength,n,0)}catch(w){return k(w)}n+=b.byteLength,setTimeout(()=>r.resume())},onError:b=>k(b),onEnd:()=>l()})})}async fb(o,t,i){let n=0,r;for(;(r=i.read())!==null;)await this.gb(o,t,r,r.byteLength,n,0),n+=r.byteLength}async gb(o,t,i,n,r,l){let k=0;for(;k<n;){const b=await o.write(t,r+k,i.buffer,l+k,n-k);k+=b}}async hb(o,t,i,n){return this.cb.queueFor(t,this.R(o).providerExtUri).queue(()=>this.ib(o,t,i,n))}async ib(o,t,i,n){let r;n instanceof R.$ge?r=n:(0,S.$5d)(n)?r=await(0,R.$se)(n):(0,S.$6d)(n)?r=await(0,R.$te)(n):r=(0,R.$qe)(n),await o.writeFile(t,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.kb(o,t,i,n))}async kb(o,t,i,n){let r,l;try{r=await o.open(t,{create:!1}),l=await i.open(n,{create:!0,unlock:!1});const k=R.$ge.alloc(this.a);let b=0,w=0,j=0;do j=await o.read(r,b,k.buffer,w,k.byteLength-w),await this.gb(i,l,k,j,b,w),b+=j,w+=j,w===k.byteLength&&(w=0);while(j>0)}catch(k){throw(0,p.$Bk)(k)}finally{await D.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof l=="number"?i.close(l):Promise.resolve()])}}async lb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.mb(o,t,i,n))}async mb(o,t,i,n){return i.writeFile(n,await o.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.ob(o,t,i,n))}async ob(o,t,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const l=await o.readFile(t);await this.gb(i,r,R.$ge.wrap(l),l.byteLength,0,0)}catch(l){throw(0,p.$Bk)(l)}finally{await i.close(r)}}async pb(o,t,i,n){const r=await(0,R.$se)(this.H(o,t,N.CancellationToken.None));await this.hb(i,n,void 0,r)}qb(o,t){if(o.capabilities&2048)throw new p.$Ik((0,v.localize)(25,null,this.sb(t)),6);return o}rb(o,t){if((t.permissions??0)&p.FilePermission.Readonly)throw new p.$Ik((0,v.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===I.Schemas.file?o.fsPath:o.toString(!0)}};e.$3p=y,e.$3p=y=g=pe([ie(0,$.$kj)],y)}),define(te[126],ne([0,1,88,169,8,31,14,4,170,2,16,13,17,45,24,102,12,61,123,34,121,120]),function(G,e,L,D,R,N,A,E,h,c,P,I,d,f,S,v,p,u,$,O,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=void 0,(()=>{try{(0,D.gracefulify)(L)}catch(o){console.error(`Error enabling graceful-fs: ${(0,O.$Ni)(o)}`)}})();class s extends $.$_p{static{this.I=!1}constructor(t,i){super(t,i),this.onDidChangeCapabilities=E.Event.None,this.N=new N.$Ac(n=>d.$vg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,I.$k&&(this.J|=1024)),this.J}async stat(t){try{const{stat:i,symbolicLink:n}=await S.SymlinkSupport.stat(this.H(t));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:p.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await S.Promises.readdir(this.H(t),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async r=>{try{let l;r.isSymbolicLink()?l=(await this.stat((0,d.$Eg)(t,r.name))).type:l=this.M(r),n.push([r.name,l])}catch(l){this.a.trace(l)}})),n}catch(i){throw this.fb(i)}}M(t,i){let n;return i?.dangling?n=p.FileType.Unknown:t.isFile()?n=p.FileType.File:t.isDirectory()?n=p.FileType.Directory:n=p.FileType.Unknown,i&&(n|=p.FileType.SymbolicLink),n}async O(t){const i=this.H(t);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(t);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const r=new R.$2g;return this.N.set(t,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(t)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(t)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(t,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(t)})`),n=await this.O(t));const r=this.H(t);return await S.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{n?.dispose()}}P(t){s.I&&this.a.trace(t)}readFileStream(t,i,n){const r=(0,f.$7d)(l=>A.$ge.concat(l.map(k=>A.$ge.wrap(k))).buffer);return(0,u.$2p)(this,t,r,l=>l.buffer,{...i,bufferSize:256*1024},n),r}async writeFile(t,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(t)?this.R(t,(0,d.$Eg)((0,d.$Dg)(t),`${(0,d.$Bg)(t)}${n.atomic.postfix}`),i,n):this.S(t,i,n)}async Q(t){try{const i=this.H(t),{symbolicLink:n}=await S.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async R(t,i,n,r){const l=new c.$Rc;try{l.add(await this.O(t)),l.add(await this.O(i)),await this.S(i,n,r,!0);try{await this.rename(i,t,{overwrite:!0})}catch(k){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw k}}finally{l.dispose()}}async S(t,i,n,r){let l;try{const k=this.H(t);if(!n.create||!n.overwrite){if(await S.Promises.exists(k)){if(!n.overwrite)throw(0,p.$Ak)((0,v.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,p.$Ak)((0,v.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:n.unlock},r),await this.write(l,0,i,0,i.byteLength)}catch(k){throw await this.gb(t,k)}finally{typeof l=="number"&&await this.close(l)}}static{this.Y=!0}static configureFlushOnWrite(t){s.Y=t}async open(t,i,n){const r=this.H(t);let l;(0,p.$ok)(i)&&!n&&(l=await this.O(t));let k;try{if((0,p.$ok)(i)&&i.unlock)try{const{stat:w}=await S.SymlinkSupport.stat(r);w.mode&128||await S.Promises.chmod(r,w.mode|128)}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}let b;if((0,p.$ok)(i)){if(I.$i)try{await S.Promises.truncate(r,0),b="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}b||(b="w")}else b="r";k=await S.Promises.open(r,b)}catch(b){throw l?.dispose(),(0,p.$ok)(i)?await this.gb(t,b):this.fb(b)}if(this.U.set(k,0),(0,p.$ok)(i)&&this.X.set(k,t),l){const b=this.W.get(k);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${k} (${r})`),this.W.set(k,l),b&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${k} (${r})`),b.dispose())}return k}async close(t){const i=this.W.get(t);try{if(this.U.delete(t),this.X.delete(t)&&s.Y)try{await S.Promises.fdatasync(t)}catch(n){s.configureFlushOnWrite(!1),this.a.error(n)}return await S.Promises.close(t)}catch(n){throw this.fb(n)}finally{i&&(this.W.get(t)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.W.delete(t)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,n,r,l){const k=this.Z(t,i);let b=null;try{b=(await S.Promises.read(t,n,r,l,k)).bytesRead}catch(w){throw this.fb(w)}finally{this.$(t,k,b)}return b}Z(t,i){return i===this.U.get(t)?null:i}$(t,i,n){const r=this.U.get(t);typeof r=="number"&&(typeof i=="number"||(typeof n=="number"?this.U.set(t,r+n):this.U.delete(t)))}async write(t,i,n,r,l){return(0,R.$kh)(()=>this.ab(t,i,n,r,l),100,3)}async ab(t,i,n,r,l){const k=this.Z(t,i);let b=null;try{b=(await S.Promises.write(t,n,r,l,k)).bytesWritten}catch(w){throw await this.gb(this.X.get(t),w)}finally{this.$(t,k,b)}return b}async mkdir(t){try{await S.Promises.mkdir(this.H(t))}catch(i){throw this.fb(i)}}async delete(t,i){try{const n=this.H(t);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,P.$jc)((0,P.$mc)(n),`${(0,P.$nc)(n)}${i.atomic.postfix}`)),await S.Promises.rm(n,S.RimRafMode.MOVE,r)}else try{await S.Promises.unlink(n)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let l=!1;try{const{stat:k,symbolicLink:b}=await S.SymlinkSupport.stat(n);l=k.isDirectory()&&!b}catch{}if(l)await S.Promises.rmdir(n);else throw r}else throw r}}catch(n){throw this.fb(n)}}async rename(t,i,n){const r=this.H(t),l=this.H(i);if(r!==l)try{await this.bb(t,i,"move",n.overwrite),await S.Promises.rename(r,l)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,v.localize)(2,null,(0,P.$nc)(r),(0,P.$nc)((0,P.$mc)(l)),k.toString()))),this.fb(k)}}async copy(t,i,n){const r=this.H(t),l=this.H(i);if(r!==l)try{await this.bb(t,i,"copy",n.overwrite),await S.Promises.copy(r,l,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,v.localize)(3,null,(0,P.$nc)(r),(0,P.$nc)((0,P.$mc)(l)),k.toString()))),this.fb(k)}}async bb(t,i,n,r){const l=this.H(t),k=this.H(i);let b=!1;if(!!(this.capabilities&1024)||(b=(0,h.$4f)(l,k,!0)),b){if(n==="copy")throw(0,p.$Ak)((0,v.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const j=await this.L(t);if(!j)throw(0,p.$Ak)((0,v.localize)(5,null),p.FileSystemProviderErrorCode.FileNotFound);const H=await this.L(i);if(H){if(!r)throw(0,p.$Ak)((0,v.localize)(6,null),p.FileSystemProviderErrorCode.FileExists);j.type&p.FileType.File&&H.type&p.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.cb(t,i,!1)}async cb(t,i,n){const r=this.H(t),l=this.H(i),k=!!(this.capabilities&1024);if((0,h.$4f)(r,l,!k))return;const b=new c.$Rc;try{b.add(await this.O(t)),b.add(await this.O(i)),n&&await S.Promises.mkdir((0,P.$mc)(l),{recursive:!0}),await S.Promises.copyFile(r,l)}catch(w){if(w.code==="ENOENT"&&!n)return this.cb(t,i,!0);throw this.fb(w)}finally{b.dispose()}}t(t,i,n){return new g.$gq(r=>t(r),r=>i(r),n)}F(t,i,n){return new y.$oq(r=>t(r),r=>i(r),n)}fb(t){if(t instanceof p.$zk)return t;let i=t,n;switch(t.code){case"ENOENT":n=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=p.FileSystemProviderErrorCode.Unknown;break;default:n=p.FileSystemProviderErrorCode.Unknown}return(0,p.$Ak)(i,n)}async gb(t,i){let n=this.fb(i);if(t&&n.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await S.SymlinkSupport.stat(this.H(t));r.mode&128||(n=(0,p.$Ak)(i,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return n}}e.$pq=s}),define(te[127],ne([0,1,2,6]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fO=void 0;class R extends L.$Sc{constructor(A,E=[]){super(),this.a=new D.$uj([A,...E]),this.B(A.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...E){this.a.trace(A,...E)}debug(A,...E){this.a.debug(A,...E)}info(A,...E){this.a.info(A,...E)}warn(A,...E){this.a.warn(A,...E)}error(A,...E){this.a.error(A,...E)}flush(){this.a.flush()}}e.$fO=R}),define(te[128],ne([0,1,12,6]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7N=void 0;var R;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(R||(R={}));async function N(c,P,I,d,f){try{const S=await new Promise((p,u)=>{G(["@vscode/spdlog"],p,u)});S.setFlushOn(R.Trace);const v=await S.createAsyncRotatingLogger(c,P,I,d);return f?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(S){console.error(S)}return null}function A(c,P,I){switch(P){case D.LogLevel.Trace:c.trace(I);break;case D.LogLevel.Debug:c.debug(I);break;case D.LogLevel.Info:c.info(I);break;case D.LogLevel.Warning:c.warn(I);break;case D.LogLevel.Error:c.error(I);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function E(c,P){switch(P){case D.LogLevel.Trace:c.setLevel(R.Trace);break;case D.LogLevel.Debug:c.setLevel(R.Debug);break;case D.LogLevel.Info:c.setLevel(R.Info);break;case D.LogLevel.Warning:c.setLevel(R.Warning);break;case D.LogLevel.Error:c.setLevel(R.Error);break;case D.LogLevel.Off:c.setLevel(R.Off);break;default:throw new Error(`Invalid log level ${P}`)}}class h extends D.$qj{constructor(P,I,d,f,S){super(),this.m=[],this.setLevel(S),this.n=this.s(P,I,d,f),this.B(this.onDidChangeLogLevel(v=>{this.r&&E(this.r,v)}))}async s(P,I,d,f){const S=d?6:1,v=30/S*L.$Vk.MB,p=await N(P,I,v,S,f);if(p){this.r=p,E(this.r,this.getLevel());for(const{level:u,message:$}of this.m)A(this.r,u,$);this.m=[]}}g(P,I){this.r?A(this.r,P,I):this.getLevel()<=P&&this.m.push({level:P,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$7N=h}),define(te[129],ne([0,1,28,6,128]),function(G,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8N=void 0;class N extends D.$vj{s(E,h,c){return new R.$7N((0,L.$ng)(),E.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,h)}}e.$8N=N}),define(te[38],ne([0,1,4,65,2,10]),function(G,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$yn=e.$xn=void 0,e.$xn=(0,N.$3h)("policy");class A extends R.$Sc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.$Sd),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const P=Object.keys(this.f).length;return this.f={...c,...this.f},P!==Object.keys(this.f).length&&await this.j(c),D.Iterable.reduce(this.g.entries(),(I,[d,f])=>({...I,[d]:f}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(c,[P,I])=>({...c,[P]:{definition:I,value:this.g.get(P)}}),{})}}e.$yn=A;class E{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$zn=E}),define(te[130],ne([0,1,8,4,65,3,12,6,38]),function(G,e,L,D,R,N,A,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m$b=void 0;function c(I,d){const f=[];for(const S of new Set(R.Iterable.concat(I.keys(),d.keys())))I.get(S)!==d.get(S)&&f.push(S);return f}let P=class extends h.$yn{constructor(d,f,S){super(),this.m=d,this.n=f,this.s=S,this.c=this.B(new L.$1g(500));const v=D.Event.filter(f.onDidFilesChange,p=>p.affects(d));this.B(f.watch(d)),this.B(v(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const d=new Map;try{const f=await this.n.readFile(this.m),S=JSON.parse(f.value.toString());if(!(0,N.$Hf)(S))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(S))this.f[v]&&d.set(v,S[v])}catch(f){f.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",f)}return d}async w(){const d=await this.u(),f=c(this.g,d);this.g=d,f.length>0&&this.h.fire(f)}};e.$m$b=P,e.$m$b=P=pe([ie(1,A.$nk),ie(2,E.$kj)],P)}),define(te[131],ne([0,1,38,8,2,6]),function(G,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l$b=void 0;let A=class extends L.$yn{constructor(h,c){super(),this.m=h,this.n=c,this.a=new D.$Wg,this.b=this.B(new R.$Tc)}async j(h){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(h).length} policy definitions`);const{createWatcher:c}=await new Promise((P,I)=>{G(["@vscode/policy-watcher"],P,I)});await this.a.queue(()=>new Promise((P,I)=>{try{this.b.value=c(this.n,h,d=>{this.t(d),P()})}catch(d){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),I(d)}}))}t(h){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(h)}`);for(const c in h){const P=h[c];P===void 0?this.g.delete(c):this.g.set(c,P)}this.h.fire(Object.keys(h))}};e.$l$b=A,e.$l$b=A=pe([ie(0,N.$kj)],A)}),define(te[32],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dj=e.$Cj=void 0,e.$Cj=(0,L.$3h)("productService"),e.$Dj="vscode://schemas/vscode-product"}),define(te[36],ne([0,1,71,3]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=void 0;class R{constructor(){this.a=new Map}add(A,E){L.ok(D.$Ff(A)),L.ok(D.$Hf(E)),L.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,E)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$vn=new R}),define(te[132],ne([0,1,4,36]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=void 0,e.$wn={JSONContribution:"base.contributions.json"};function R(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class N{constructor(){this.b=new L.$Sd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,c){this.a[R(h)]=c,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const A=new N;D.$vn.add(e.$wn.JSONContribution,A)}),define(te[43],ne([0,1,19,4,3,89,25,132,36]),function(G,e,L,D,R,N,A,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.ConfigurationScope=e.$An=e.EditPresentationTypes=void 0;var c;(function(y){y.Multiline="multilineText",y.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$An={Configuration:"base.contributions.configuration"};var P;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$Bn={properties:{},patternProperties:{}},e.$Cn={properties:{},patternProperties:{}},e.$Dn={properties:{},patternProperties:{}},e.$En={properties:{},patternProperties:{}},e.$Fn={properties:{},patternProperties:{}},e.$Gn={properties:{},patternProperties:{}},e.$Hn="vscode://schemas/settings/resourceLanguage",e.$In="vscode://schemas/settings/configurationDefaults";const I=h.$vn.as(E.$wn.JSONContribution);class d{constructor(){this.h=new Set,this.i=new D.$Sd,this.onDidSchemaChange=this.i.event,this.j=new D.$Sd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$Hn,this.g),this.v()}registerConfiguration(s,o=!0){this.registerConfigurations([s],o)}registerConfigurations(s,o=!0){const t=new Set;this.n(s,o,t),I.registerSchema(e.$Hn,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(s){const o=new Set;this.o(s,o),I.registerSchema(e.$Hn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:s,remove:o}){const t=new Set;this.o(o,t),this.n(s,!1,t),I.registerSchema(e.$Hn,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(s){const o=new Set;this.k(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(s,o){const t=[];for(const{overrides:i,source:n}of s)for(const r in i)if(o.add(r),e.$Kn.test(r)){const l=this.a.get(r),k=l?.valuesSources??new Map;if(n)for(const H of Object.keys(i[r]))k.set(H,n);const b={...l?.value||{},...i[r]};this.a.set(r,{source:n,value:b,valuesSources:k});const w=(0,A.$Gi)(r),j={type:"object",default:b,description:N.localize(1,null,w),$ref:e.$Hn,defaultDefaultValue:b,source:R.$Ff(n)?void 0:n,defaultValueSource:n};t.push(...v(r)),this.d[r]=j,this.b.properties[r]=j}else{this.a.set(r,{value:i[r],source:n});const l=this.d[r];l&&(this.w(r,l),this.r(r,l))}this.m(t)}deregisterDefaultConfigurations(s){const o=new Set;this.l(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(s,o){for(const{overrides:t,source:i}of s)for(const n in t){const r=this.a.get(n),l=R.$Ff(i)?i:i?.id,k=R.$Ff(r?.source)?r?.source:r?.source?.id;if(l===k)if(o.add(n),this.a.delete(n),e.$Kn.test(n))delete this.d[n],delete this.b.properties[n];else{const b=this.d[n];b&&(this.w(n,b),this.r(n,b))}}this.u()}deltaConfiguration(s){let o=!1;const t=new Set;s.removedDefaults&&(this.l(s.removedDefaults,t),o=!0),s.addedDefaults&&(this.k(s.addedDefaults,t),o=!0),s.removedConfigurations&&this.o(s.removedConfigurations,t),s.addedConfigurations&&this.n(s.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const o of s)this.h.add(o);this.u()}n(s,o,t){s.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,t),this.c.push(i),this.q(i)})}o(s,o){const t=i=>{if(i.properties)for(const n in i.properties){o.add(n);const r=this.d[n];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>t(n))};for(const i of s){t(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(s,o=!0,t,i,n=3,r){n=R.$Of(s.scope)?n:s.scope;const l=s.properties;if(l)for(const b in l){const w=l[b];if(o&&O(b,w)){delete l[b];continue}if(w.source=t,w.defaultDefaultValue=l[b].default,this.w(b,w),e.$Kn.test(b)?w.scope=void 0:(w.scope=R.$Of(w.scope)?n:w.scope,w.restricted=R.$Of(w.restricted)?!!i?.includes(b):w.restricted),l[b].hasOwnProperty("included")&&!l[b].included){this.f[b]=l[b],delete l[b];continue}else this.d[b]=l[b],l[b].policy?.name&&this.e.set(l[b].policy.name,b);!l[b].deprecationMessage&&l[b].markdownDeprecationMessage&&(l[b].deprecationMessage=l[b].markdownDeprecationMessage),r.add(b)}const k=s.allOf;if(k)for(const b of k)this.p(b,o,t,i,n,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const o=t=>{const i=t.properties;if(i)for(const r in i)this.r(r,i[r]);t.allOf?.forEach(o)};o(s)}r(s,o){switch(e.$Bn.properties[s]=o,o.scope){case 1:e.$Cn.properties[s]=o;break;case 2:e.$Dn.properties[s]=o;break;case 6:e.$En.properties[s]=o;break;case 3:e.$Fn.properties[s]=o;break;case 4:e.$Gn.properties[s]=o;break;case 5:e.$Gn.properties[s]=o,this.g.properties[s]=o;break}}s(s,o){switch(delete e.$Bn.properties[s],o.scope){case 1:delete e.$Cn.properties[s];break;case 2:delete e.$Dn.properties[s];break;case 6:delete e.$En.properties[s];break;case 3:delete e.$Fn.properties[s];break;case 4:case 5:delete e.$Gn.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const o=`[${s}]`,t={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.$Hn};this.w(o,t),e.$Bn.properties[o]=t,e.$Cn.properties[o]=t,e.$Dn.properties[o]=t,e.$En.properties[o]=t,e.$Fn.properties[o]=t,e.$Gn.properties[o]=t}}v(){const s={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.$Hn};e.$Bn.patternProperties[e.$Jn]=s,e.$Cn.patternProperties[e.$Jn]=s,e.$Dn.patternProperties[e.$Jn]=s,e.$En.patternProperties[e.$Jn]=s,e.$Fn.patternProperties[e.$Jn]=s,e.$Gn.patternProperties[e.$Jn]=s,this.i.fire()}w(s,o){const t=this.a.get(s);let i=t?.value,n=t?.source;R.$Mf(i)&&(i=o.defaultDefaultValue,n=void 0),R.$Mf(i)&&(i=u(o.type)),o.default=i,o.defaultValueSource=n}}const f="\\[([^\\]]+)\\]",S=new RegExp(f,"g");e.$Jn=`^(${f})+$`,e.$Kn=new RegExp(e.$Jn);function v(y){const s=[];if(e.$Kn.test(y)){let o=S.exec(y);for(;o?.length;){const t=o[1].trim();t&&s.push(t),o=S.exec(y)}}return(0,L.$Mb)(s)}e.$Ln=v;function p(y){return y.reduce((s,o)=>`${s}[${o}]`,"")}e.$Mn=p;function u(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Nn=u;const $=new d;h.$vn.add(e.$An.Configuration,$);function O(y,s){return y.trim()?e.$Kn.test(y)?N.localize(7,null,y):$.getConfigurationProperties()[y]!==void 0?N.localize(8,null,y):s.policy?.name&&$.getPolicyConfigurations().get(s.policy?.name)!==void 0?N.localize(9,null,y,s.policy?.name,$.getPolicyConfigurations().get(s.policy?.name)):null:N.localize(6,null)}e.$On=O;function g(){const y=[],s=$.getConfigurationProperties();for(const o of Object.keys(s))y.push([o,s[o].scope]);return y.push(["launch",4]),y.push(["task",4]),y}e.$Pn=g}),define(te[66],ne([0,1,19,4,53,2,31,30,3,11,25,43,36]),function(G,e,L,D,R,N,A,E,h,c,P,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=void 0;function f(o){return Object.isFrozen(o)?o:E.$kn(o)}class S{constructor(t={},i=[],n=[],r){this.b=t,this.c=i,this.d=n,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof S)return i;const n=new v("");return n.parseRaw(i),n.configurationModel});this.f=t.reduce((i,n)=>n===i?n:i.merge(n),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,P.$Ei)(this.contents,t):this.contents}inspect(t,i){const n=this.rawConfiguration.getValue(t),r=i?this.rawConfiguration.getOverrideValue(t,i):void 0,l=i?this.rawConfiguration.override(i).getValue(t):n;return{value:n,override:r,merged:l}}getOverrideValue(t,i){const n=this.i(i);return n?t?(0,P.$Ei)(n,t):n:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const n of this.overrides)n.identifiers.includes(t)&&i.push(...n.keys);return L.$Mb(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return L.$Mb(t)}override(t){let i=this.a.get(t);return i||(i=this.g(t),this.a.set(t,i)),i}merge(...t){const i=E.$jn(this.contents),n=E.$jn(this.overrides),r=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const k of t)if(l.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.h(i,k.contents);for(const b of k.overrides){const[w]=n.filter(j=>L.$ub(j.identifiers,b.identifiers));w?(this.h(w.contents,b.contents),w.keys.push(...b.keys),w.keys=L.$Mb(w.keys)):n.push(E.$jn(b))}for(const b of k.keys)r.indexOf(b)===-1&&r.push(b)}return new S(i,r,n,l.every(k=>k instanceof S)?void 0:l)}g(t){const i=this.i(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const r of L.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[r];const k=i[r];k&&(typeof l=="object"&&typeof k=="object"?(l=E.$jn(l),this.h(l,k)):l=k),n[r]=l}return new S(n,this.keys,this.overrides)}h(t,i){for(const n of Object.keys(i)){if(n in t&&h.$Hf(t[n])&&h.$Hf(i[n])){this.h(t[n],i[n]);continue}t[n]=E.$jn(i[n])}}i(t){let i=null,n=null;const r=l=>{l&&(n?this.h(n,l):n=E.$jn(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===t?i=l.contents:l.identifiers.includes(t)&&r(l.contents);return r(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.j(t,i,!0)}setValue(t,i){this.j(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,P.$Di)(this.contents,t),I.$Kn.test(t)&&this.overrides.splice(this.overrides.findIndex(n=>L.$ub(n.identifiers,(0,I.$Ln)(t))),1))}j(t,i,n){(0,P.$Ci)(this.contents,t,i,r=>console.error(r)),n=n||this.keys.indexOf(t)===-1,n&&this.keys.push(t),I.$Kn.test(t)&&this.overrides.push({identifiers:(0,I.$Ln)(t),keys:Object.keys(this.contents[t]),contents:(0,P.$Bi)(this.contents[t],r=>console.error(r))})}}e.$Qn=S;class v{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,i){if(!h.$Of(t)){const n=this.g(t);this.parseRaw(n,i)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,i){this.a=t;const{contents:n,keys:r,overrides:l,restricted:k,hasExcludedProperties:b}=this.h(t,i);this.b=new S(n,r,l,b?[t]:void 0),this.c=k||[]}g(t){let i={},n=null,r=[];const l=[],k=[];function b(j){Array.isArray(r)?r.push(j):n!==null&&(r[n]=j)}const w={onObjectBegin:()=>{const j={};b(j),l.push(r),r=j,n=null},onObjectProperty:j=>{n=j},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const j=[];b(j),l.push(r),r=j,n=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:b,onError:(j,H,ee)=>{k.push({error:j,offset:H,length:ee})}};if(t)try{R.$gn(t,w),i=r[0]||{}}catch(j){console.error(`Error while parsing settings file ${this.f}: ${j}`),this.d=[j]}return i}h(t,i){const n=d.$vn.as(I.$An.Configuration).getConfigurationProperties(),r=this.i(t,n,!0,i);t=r.raw;const l=(0,P.$Bi)(t,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),k=Object.keys(t),b=this.j(t,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:l,keys:k,overrides:b,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(t,i,n,r){let l=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:l};const k={},b=[];for(const w in t)if(I.$Kn.test(w)&&n){const j=this.i(t[w],i,!1,r);k[w]=j.raw,l=l||j.hasExcludedProperties,b.push(...j.restricted)}else{const j=i[w],H=j?typeof j.scope<"u"?j.scope:3:void 0;j?.restricted&&b.push(w),!r.exclude?.includes(w)&&(r.include?.includes(w)||(H===void 0||r.scopes===void 0||r.scopes.includes(H))&&!(r.skipRestricted&&j?.restricted))?k[w]=t[w]:l=!0}return{raw:k,restricted:b,hasExcludedProperties:l}}j(t,i){const n=[];for(const r of Object.keys(t))if(I.$Kn.test(r)){const l={};for(const k in t[r])l[k]=t[r][k];n.push({identifiers:(0,I.$Ln)(r),keys:Object.keys(l),contents:(0,P.$Bi)(l,i)})}return n}}e.$Rn=v;class p extends N.$Sc{constructor(t,i,n,r){super(),this.c=t,this.f=i,this.g=r,this.b=this.B(new D.$Sd),this.onDidChange=this.b.event,this.a=new v(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&n.isEqual(l.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Sn=p;class u{constructor(t,i,n,r,l,k,b,w,j,H,ee,_,re){this.a=t,this.b=i,this.c=n,this.overrideIdentifiers=r,this.d=l,this.f=k,this.g=b,this.h=w,this.i=j,this.j=H,this.k=ee,this.l=_,this.m=re}get value(){return f(this.c)}n(t,i,n){const r=t.inspect(i,n);return{get value(){return f(r.value)},get override(){return f(r.override)},get merged(){return f(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class ${constructor(t,i,n,r,l=new S,k=new S,b=new A.$Ac,w=new S,j=new A.$Ac){this.c=t,this.d=i,this.f=n,this.g=r,this.h=l,this.i=k,this.j=b,this.l=w,this.m=j,this.a=null,this.b=new A.$Ac,this.n=null}getValue(t,i,n){return this.p(t,i,n).getValue(t)}updateValue(t,i,n={}){let r;n.resource?(r=this.m.get(n.resource),r||(r=new S,this.m.set(n.resource,r))):r=this.l,i===void 0?r.removeValue(t):r.setValue(t,i),n.resource||(this.a=null)}inspect(t,i,n){const r=this.p(t,i,n),l=this.t(i.resource,n),k=i.resource?this.m.get(i.resource)||this.l:this.l,b=new Set;for(const w of r.overrides)for(const j of w.identifiers)r.getOverrideValue(t,j)!==void 0&&b.add(j);return new u(t,i,r.getValue(t),b.size?[...b]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,l||void 0,k)}keys(t){const i=this.t(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,i){this.j.set(t,i),this.b.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const n=[];if(!i){const{added:r,updated:l,removed:k}=y(this.c,t);i=[...r,...l,...k]}for(const r of i)for(const l of(0,I.$Ln)(r)){const k=this.c.getKeysForOverrideIdentifier(l),b=t.getKeysForOverrideIdentifier(l),w=[...b.filter(j=>k.indexOf(j)===-1),...k.filter(j=>b.indexOf(j)===-1),...k.filter(j=>!E.$nn(this.c.override(l).getValue(j),t.override(l).getValue(j)))];n.push([l,w])}return this.updateDefaultConfiguration(t),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:n,removed:r}=y(this.d,t),l=[...i,...n,...r];return l.length&&this.updatePolicyConfiguration(t),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=y(this.applicationConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateApplicationConfiguration(t),{keys:k,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=y(this.localUserConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateLocalUserConfiguration(t),{keys:k,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=y(this.remoteUserConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateRemoteUserConfiguration(t),{keys:k,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=y(this.workspaceConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateWorkspaceConfiguration(t),{keys:k,overrides:l}}compareAndUpdateFolderConfiguration(t,i){const n=this.folderConfigurations.get(t),{added:r,updated:l,removed:k,overrides:b}=y(n,i),w=[...r,...l,...k];return(w.length||!n)&&this.updateFolderConfiguration(t,i),{keys:w,overrides:b}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:r,removed:l,overrides:k}=y(i,void 0);return{keys:[...n,...r,...l],overrides:k}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(t,i,n){let r=this.q(i,n);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(r=r.merge(this.d)),r}q({resource:t},i){let n=this.r();if(i&&t){const r=i.getFolder(t);r&&(n=this.s(r.uri)||n);const l=this.m.get(t);l&&(n=n.merge(l))}return n}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(t){let i=this.b.get(t);if(!i){const n=this.r(),r=this.j.get(t);r?(i=n.merge(r),this.b.set(t,i)):i=n}return i}t(t,i){if(i&&t){const n=i.getFolder(t);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,i)=>{const{contents:n,overrides:r,keys:l}=this.j.get(i);return t.push([i,{contents:n,overrides:r,keys:l}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this.i.keys.forEach(i=>t.add(i)),this.j.forEach(i=>i.keys.forEach(n=>t.add(n))),[...t.values()]}u(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>t.add(n))),[...t.values()]}v(t){const i=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r))),[...i.values()]}static parse(t){const i=this.w(t.defaults),n=this.w(t.policy),r=this.w(t.application),l=this.w(t.user),k=this.w(t.workspace),b=t.folders.reduce((w,j)=>(w.set(c.URI.revive(j[0]),this.w(j[1])),w),new A.$Ac);return new $(i,n,r,l,new S,k,b,new S,new A.$Ac)}static w(t){return new S(t.contents,t.keys,t.overrides)}}e.$Tn=$;function O(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,i=new Map;for(const r of o)r.keys.forEach(l=>t.add(l)),r.overrides.forEach(([l,k])=>{const b=(0,A.$xc)(i,l,new Set);k.forEach(w=>b.add(w))});const n=[];return i.forEach((r,l)=>n.push([l,[...r.values()]])),{keys:[...t.values()],overrides:n}}e.$Un=O;class g{constructor(t,i,n,r){this.change=t,this.f=i,this.g=n,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of t.keys)this.affectedKeys.add(l);for(const[,l]of t.overrides)for(const k of l)this.affectedKeys.add(k);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=$.parse(this.f.data)),this.i}affectsConfiguration(t,i){const n=this.a+t,r=this.d.indexOf(n);if(r<0)return!1;const l=r+n.length;if(l>=this.d.length)return!1;const k=this.d.charCodeAt(l);if(k!==this.b&&k!==this.c)return!1;if(i){const b=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.f?.workspace):void 0,w=this.g.getValue(t,i,this.h);return!E.$nn(b,w)}return!0}}e.$Vn=g;function y(o,t){const{added:i,removed:n,updated:r}=s(t?.rawConfiguration,o?.rawConfiguration),l=[],k=o?.getAllOverrideIdentifiers()||[],b=t?.getAllOverrideIdentifiers()||[];if(t){const w=b.filter(j=>!k.includes(j));for(const j of w)l.push([j,t.getKeysForOverrideIdentifier(j)])}if(o){const w=k.filter(j=>!b.includes(j));for(const j of w)l.push([j,o.getKeysForOverrideIdentifier(j)])}if(t&&o){for(const w of k)if(b.includes(w)){const j=s({contents:o.getOverrideValue(void 0,w)||{},keys:o.getKeysForOverrideIdentifier(w)},{contents:t.getOverrideValue(void 0,w)||{},keys:t.getKeysForOverrideIdentifier(w)});l.push([w,[...j.added,...j.removed,...j.updated]])}}return{added:i,removed:n,updated:r,overrides:l}}function s(o,t){const i=o?t?o.keys.filter(l=>t.keys.indexOf(l)===-1):[...o.keys]:[],n=t?o?t.keys.filter(l=>o.keys.indexOf(l)===-1):[...t.keys]:[],r=[];if(o&&t){for(const l of t.keys)if(o.keys.indexOf(l)!==-1){const k=(0,P.$Ei)(t.contents,l),b=(0,P.$Ei)(o.contents,l);E.$nn(k,b)||r.push(l)}}return{added:i,removed:n,updated:r}}}),define(te[133],ne([0,1,19,4,2,30,3,66,43,6,38,36]),function(G,e,L,D,R,N,A,E,h,c,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=e.$Xn=e.$Wn=void 0;class d extends R.$Sc{constructor(){super(...arguments),this.a=this.B(new D.$Sd),this.onDidChangeConfiguration=this.a.event,this.b=new E.$Qn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(I.$vn.as(h.$An.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:u})=>this.c(Array.from(p),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(p,u){this.h(p,I.$vn.as(h.$An.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:p})}f(){return{}}g(){this.b=new E.$Qn;const p=I.$vn.as(h.$An.Configuration).getConfigurationProperties();this.h(Object.keys(p),p)}h(p,u){const $=this.f();for(const O of p){const g=$[O],y=u[O];g!==void 0?this.b.addValue(O,g):y?this.b.addValue(O,y.default):this.b.removeValue(O)}}}e.$Wn=d;class f{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new E.$Qn}async initialize(){return this.configurationModel}}e.$Xn=f;let S=class extends R.$Sc{get configurationModel(){return this.b}constructor(p,u,$){super(),this.c=p,this.f=u,this.g=$,this.a=this.B(new D.$Sd),this.onDidChangeConfiguration=this.a.event,this.b=new E.$Qn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(p=>this.j(p))),this.B(this.c.onDidChangeConfiguration(async({properties:p})=>this.m(await this.h(p),!0))),this.b}async h(p){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",p);const u={},$=[],O=I.$vn.as(h.$An.Configuration).getConfigurationProperties();for(const g of p){const y=O[g];if(!y){$.push(g);continue}if(y.policy){if(y.type!=="string"&&y.type!=="number"){this.g.warn(`Policy ${y.policy.name} has unsupported type ${y.type}`);continue}$.push(g),u[y.policy.name]={type:y.type}}}return(0,A.$Sf)(u)||await this.f.updatePolicyDefinitions(u),$}j(p){this.g.trace("PolicyConfiguration#onDidChangePolicies",p);const u=I.$vn.as(h.$An.Configuration).getPolicyConfigurations(),$=(0,L.$Hb)(p.map(O=>u.get(O)));this.m($,!0)}m(p,u){this.g.trace("PolicyConfiguration#update",p);const $=I.$vn.as(h.$An.Configuration).getConfigurationProperties(),O=[],g=this.b.isEmpty();for(const y of p){const s=$[y]?.policy?.name;if(s){const o=this.f.getPolicyValue(s);(g?o!==void 0:!(0,N.$nn)(this.b.getValue(y),o))&&O.push([y,o])}else this.b.getValue(y)!==void 0&&O.push([y,void 0])}if(O.length){this.g.trace("PolicyConfiguration#changed",O);const y=this.b;this.b=new E.$Qn;for(const s of y.keys)this.b.setValue(s,y.getValue(s));for(const[s,o]of O)o===void 0?this.b.removeValue(s):this.b.setValue(s,o);u&&this.a.fire(this.b)}}};e.$Yn=S,e.$Yn=S=pe([ie(1,P.$xn),ie(2,c.$kj)],S)}),define(te[134],ne([0,1,8,4,2,17,25,66,133,38]),function(G,e,L,D,R,N,A,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=void 0;class P extends R.$Sc{constructor(d,f,S,v){super(),this.j=d,this.h=this.B(new D.$Sd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new h.$Wn),this.c=S instanceof c.$zn?new h.$Xn:this.B(new h.$Yn(this.b,S,v)),this.f=this.B(new E.$Sn(this.j,{},N.$vg,f)),this.a=new E.$Tn(this.b.configurationModel,this.c.configurationModel,new E.$Qn,new E.$Qn),this.g=this.B(new L.$ch(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:p,properties:u})=>this.n(p,u))),this.B(this.c.onDidChangeConfiguration(p=>this.r(p))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[d,f,S]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new E.$Tn(d,f,new E.$Qn,S)}getConfigurationData(){return this.a.toData()}getValue(d,f){const S=typeof d=="string"?d:void 0,v=(0,A.$xi)(d)?d:(0,A.$xi)(f)?f:{};return this.a.getValue(S,v,void 0)}updateValue(d,f,S,v){return Promise.reject(new Error("not supported"))}inspect(d){return this.a.inspect(d,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const d=await this.f.loadConfiguration();this.m(d)}m(d){const f=this.a.toData(),S=this.a.compareAndUpdateLocalUserConfiguration(d);this.s(S,f,2)}n(d,f){const S=this.a.toData(),v=this.a.compareAndUpdateDefaultConfiguration(d,f);this.s(v,S,7)}r(d){const f=this.a.toData(),S=this.a.compareAndUpdatePolicyConfiguration(d);this.s(S,f,7)}s(d,f,S){const v=new E.$Vn(d,{data:f},this.a);v.source=S,v.sourceConfig=this.t(S),this.h.fire(v)}t(d){switch(d){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Zn=P}),define(te[67],ne([0,1,15]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=e.$_k=e.$$k=e.$0k=void 0;function D(c){return c.scheme===L.Schemas.vscodeRemote?c.authority:void 0}e.$0k=D;function R(c){if(!c)return;const P=c.indexOf("+");return P<0?c:c.substr(0,P)}e.$$k=R;function N(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.$_k=N;function A(c){const{host:P,port:I}=h(c);if(typeof I>"u")throw new Error(`Invalid remote authority: ${c}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:P,port:I}}e.$al=A;function E(c,P){let{host:I,port:d}=h(c);return typeof d>"u"&&(d=P),{host:I,port:d}}e.$bl=E;function h(c){const P=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const I=c.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const d=c.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:c,port:void 0}}}),define(te[37],ne([0,1,29,10,67]),function(G,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.TargetPlatform=e.ExtensionType=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=void 0,e.$cm="extensions.user.cache",e.$dm="extensions.builtin.cache",e.$em="undefined_publisher",e.$fm=["ui","workspace","web"];function N(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.$gm=N,e.$hm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(A||(e.ExtensionType=A={}));var E;(function(v){v.WIN32_X64="win32-x64",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(E||(e.TargetPlatform=E={}));class h{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,u){if(typeof p>"u"||p===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof p=="string"||typeof u=="string"){const $=typeof p=="string"?p:p.value,O=typeof u=="string"?u:u.value;return L.$9e($,O)}return p._lower===u._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.$im=h;class c{get size(){return this.c.size}constructor(p){if(this.c=new Set,p)for(const u of p)this.add(u)}add(p){this.c.add(h.toKey(p))}delete(p){return this.c.delete(h.toKey(p))}has(p){return this.c.has(h.toKey(p))}}e.$jm=c;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(p){this.c.delete(h.toKey(p))}get(p){return this.c.get(h.toKey(p))}has(p){return this.c.has(h.toKey(p))}set(p,u){this.c.set(h.toKey(p),u)}values(){return this.c.values()}forEach(p){this.c.forEach(p)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$km=P;function I(v){return d(v)}e.$lm=I;function d(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.$mm=d;function f(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.$nm=f;function S(v,p){if(p){const u=`onResolveRemoteAuthority:${(0,R.$$k)(p)}`;return!!v.activationEvents?.includes(u)}return!1}e.$om=S,e.$pm=(0,D.$3h)("IBuiltinExtensionsScannerService")}),define(te[135],ne([0,1,2,37,12]),function(G,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=void 0;class N extends L.$Sc{constructor(E,h,c,P,I){super(),this.a=E,this.b=h,this.c=c,this.f=I,this.B(P.onDidInstallExtensions(d=>this.g(d))),this.B(P.onDidUninstallExtension(d=>this.h(d)))}g(E){for(const h of E)h.local&&this.invalidate(h.profileLocation)}h(E){E.error||this.invalidate(E.profileLocation)}async invalidate(E){if(E)for(const h of this.a.profiles)this.c.extUri.isEqual(h.extensionsResource,E)&&await this.j(h);else await this.j(this.a.defaultProfile)}async j(E){try{await this.b.del(this.c.extUri.joinPath(E.cacheHome,D.$cm))}catch(h){(0,R.$Ek)(h)!==1&&this.f.error(h)}}}e.$Vp=N}),define(te[44],ne([0,1,14,9,2,104,43,10,6,36]),function(G,e,L,D,R,N,A,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=void 0,e.$8o=(0,E.$3h)("requestService");class P{constructor(y){this.b=y}toJSON(){if(!this.a){const y=Object.create(null);for(const s in this.b)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?y[s]="*****":y[s]=this.b[s];this.a=y}return this.a}}class I extends R.$Sc{constructor(y){super(),this.b=0,this.a=y.createLogger("network",{name:(0,N.localize)(0,null),when:h.$Bj.isEqualTo((0,h.$zj)(h.LogLevel.Trace)).serialize()})}async c(y,s,o){const t=`${y} #${++this.b}: ${s.url}`;this.a.trace(`${t} - begin`,s.type,new P(s.headers??{}));try{const i=await o();return this.a.trace(`${t} - end`,s.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${t} - error`,s.type,(0,D.$0)(i)),i}}}e.$9o=I;function d(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}e.$0o=d;function f(g){return g.res.statusCode===204}e.$$o=f;async function S(g){return f(g)?null:(await(0,L.$se)(g.stream)).toString()}e.$_o=S;async function v(g){if(!d(g))throw new Error("Server returned "+g.res.statusCode);return S(g)}e.$ap=v;async function p(g){if(!d(g))throw new Error("Server returned "+g.res.statusCode);if(f(g))return null;const s=(await(0,L.$se)(g.stream)).toString();try{return JSON.parse(s)}catch(o){throw o.message+=`:
`+s,o}}e.$bp=p;function u(g){O(g)}e.$cp=u;let $;function O(g){const y=c.$vn.as(A.$An.Configuration),s=$;$={id:"http",order:15,title:(0,N.localize)(1,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,N.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,N.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,N.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,N.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,N.localize)(6,null),(0,N.localize)(7,null),(0,N.localize)(8,null),(0,N.localize)(9,null)],default:"override",description:(0,N.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,N.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,N.localize)(12,null),restricted:!0}}},y.updateConfigurations({add:[$],remove:s?[s]:[]})}O(1)}),define(te[136],ne([0,1,20,15,12,44]),function(G,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uO=void 0;let A=class{constructor(h,c){this.a=h,this.b=c}async download(h,c,P=L.CancellationToken.None){if(h.scheme===D.Schemas.file||h.scheme===D.Schemas.vscodeRemote){await this.b.copy(h,c);return}const I={type:"GET",url:h.toString(!0)},d=await this.a.request(I,P);if(d.res.statusCode===200)await this.b.writeFile(c,d.stream);else{const f=await(0,N.$ap)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${f}`)}}};e.$uO=A,e.$uO=A=pe([ie(0,N.$8o),ie(1,R.$nk)],A)}),define(te[137],ne([0,1,138,3]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=void 0;function R(A,E){return A.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:A.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function N(A,E,h={}){const c=(0,L.parse)(A),P=h.proxyUrl||R(c,E);if(!P)return null;const I=(0,L.parse)(P);if(!/^https?:$/.test(I.protocol||""))return null;const d={host:I.hostname||"",port:(I.port?+I.port:0)||(I.protocol==="https"?443:80),auth:I.auth,rejectUnauthorized:(0,D.$Lf)(h.strictSSL)?h.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((f,S)=>{G(["http-proxy-agent"],f,S)})).HttpProxyAgent(P,d):new(await new Promise((f,S)=>{G(["https-proxy-agent"],f,S)})).HttpsProxyAgent(P,d)}e.$ar=N}),define(te[139],ne([0,1,58,16,105,20,34,9,13,28,84,171,8,72]),function(G,e,L,D,R,N,A,E,h,c,P,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=void 0;let S;async function v(u,$,O,g){return O["force-disable-user-env"]?($.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.$i?($.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.$3l)(g)&&!O["force-user-env"]?($.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.$3l)(g)?$.trace("resolveShellEnv(): running (--force-user-env)"):$.trace("resolveShellEnv(): running (macOS/Linux)"),S||(S=d.Promises.withAsyncBody(async(y,s)=>{const o=new N.$3d;let t=1e4;const i=u.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(t=(0,f.$4l)(i,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),s(new Error((0,R.localize)(0,null)))},t);try{y(await p($,o.token))}catch(r){!(0,E.$4)(r)&&!o.token.isCancellationRequested?s(new Error((0,R.localize)(1,null,(0,A.$Ni)(r)))):y({})}finally{clearTimeout(n),o.dispose()}})),S)}e.$9l=v;async function p(u,$){const O=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",O);const g=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",g);const y=(0,c.$ng)().replace(/-/g,"").substr(0,12),s=new RegExp(y+"({.*})"+y),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",o);const t=await(0,P.$Sl)(h.OS,o);return u.trace("getUnixShellEnvironment#shell",t),new Promise((i,n)=>{if($.isCancellationRequested)return n(new E.$5);const r=(0,D.$nc)(t);let l,k;const b=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(l=`& '${process.execPath}' ${b} -p '''${y}'' + JSON.stringify(process.env) + ''${y}'''`,k=["-Login","-Command"]):r==="nu"?(l=`^'${process.execPath}' ${b} -p '"${y}" + JSON.stringify(process.env) + "${y}"'`,k=["-i","-l","-c"]):r==="xonsh"?(l=`import os, json; print("${y}", json.dumps(dict(os.environ)), "${y}")`,k=["-i","-l","-c"]):(l=`'${process.execPath}' ${b} -p '"${y}" + JSON.stringify(process.env) + "${y}"'`,r==="tcsh"||r==="csh"?k=["-ic"]:k=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(k),l);const w=(0,L.spawn)(t,[...k,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});$.onCancellationRequested(()=>(w.kill(),n(new E.$5))),w.on("error",ee=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,A.$Ni)(ee)),n(ee)});const j=[];w.stdout.on("data",ee=>j.push(ee));const H=[];w.stderr.on("data",ee=>H.push(ee)),w.on("close",(ee,_)=>{const re=Buffer.concat(j).toString("utf8");u.trace("getUnixShellEnvironment#raw",re);const se=Buffer.concat(H).toString("utf8");if(se.trim()&&u.trace("getUnixShellEnvironment#stderr",se),ee||_)return n(new Error((0,R.localize)(2,null,ee,_)));const ue=s.exec(re),ce=ue?ue[1]:"{}";try{const oe=JSON.parse(ce);O?oe.ELECTRON_RUN_AS_NODE=O:delete oe.ELECTRON_RUN_AS_NODE,g?oe.ELECTRON_NO_ATTACH_CONSOLE=g:delete oe.ELECTRON_NO_ATTACH_CONSOLE,delete oe.VSCODE_RESOLVING_ENVIRONMENT,delete oe.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",oe),i(oe)}catch(oe){u.error("getUnixShellEnvironment#errorCaught",(0,A.$Ni)(oe)),n(oe)}})})}}),define(te[140],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0N=e.$9N=void 0,e.$9N=(0,L.$3h)("stateReadService"),e.$0N=(0,L.$3h)("stateService")}),define(te[68],ne([0,1,8,14,2,3,18,12,6]),function(G,e,L,D,R,N,A,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aO=e.$_N=e.$$N=e.SaveStrategy=void 0;var c;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class P extends R.$Sc{constructor(S,v,p,u){super(),this.h=S,this.j=v,this.m=p,this.n=u,this.a=Object.create(null),this.b="",this.c=this.B(new L.$1g(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(S){S.fileOperationResult!==1&&this.m.error(S)}}getItem(S,v){const p=this.a[S];return(0,N.$Of)(p)?v:p}setItem(S,v){this.setItems([{key:S,data:v}])}setItems(S){let v=!1;for(const{key:p,data:u}of S)this.a[p]!==u&&((0,N.$Of)(u)?(0,N.$Mf)(this.a[p])||(this.a[p]=void 0,v=!0):(this.a[p]=u,v=!0));v&&this.s()}removeItem(S){(0,N.$Mf)(this.a[S])||(this.a[S]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const S=JSON.stringify(this.a,null,4);if(S!==this.b)try{await this.n.writeFile(this.h,D.$ge.fromString(S),{atomic:{postfix:".vsctmp"}}),this.b=S}catch(v){this.m.error(v)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$$N=P;let I=class extends R.$Sc{constructor(S,v,p,u){super(),this.a=this.B(new P(v.stateResource,S,p,u))}async init(){await this.a.init()}getItem(S,v){return this.a.getItem(S,v)}};e.$_N=I,e.$_N=I=pe([ie(1,A.$0h),ie(2,h.$kj),ie(3,E.$nk)],I);class d extends I{setItem(S,v){this.a.setItem(S,v)}setItems(S){this.a.setItems(S)}removeItem(S){this.a.removeItem(S)}close(){return this.a.close()}}e.$aO=d}),define(te[69],ne([0,1,13,35,28]),function(G,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xo=e.$wo=void 0;function N(h){if(L.$u===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function A(h,c,P,I,d,f,S,v,p){const u=Object.create(null);u["common.machineId"]=f,u["common.sqmId"]=S,u.sessionID=(0,R.$ng)()+Date.now(),u.commitHash=I,u.version=d,u["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,L.$h)(L.$u),u["common.nodePlatform"]=D.$dc,u["common.nodeArch"]=P,u["common.product"]=p||"desktop",v&&(u["common.msftInternal"]=v);let $=0;const O=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-O,enumerable:!0},"common.sequence":{get:()=>$++,enumerable:!0}}),L.$l&&(u["common.snap"]="true");const g=N(c);return g&&(u["common.platformDetail"]=g),u}e.$wo=A;function E(h){const c=D.env.USERDNSDOMAIN;if(!c)return!1;const P=c.toLowerCase();return h.some(I=>P===I)}e.$xo=E}),define(te[26],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=void 0,e.$rl=(0,L.$3h)("telemetryService"),e.$sl=(0,L.$3h)("customEndpointTelemetryService"),e.$tl="telemetry.currentSessionDate",e.$ul="telemetry.firstSessionDate",e.$vl="telemetry.lastSessionDate",e.$wl="telemetry.machineId",e.$xl="telemetry.sqmId",e.$yl="telemetry",e.$zl="telemetry.telemetryLevel",e.$Al="telemetry.enableCrashReporter",e.$Bl="telemetry.enableTelemetry";var D;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var R;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(te[39],ne([0,1,30,3,4,25,67,69,26]),function(G,e,L,D,R,N,A,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=void 0;class c{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$yo=c;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$zo=P,e.$Ao=new P;class I{async publicLog(n,r,l){}async publicLogError(n,r,l){}}e.$Bo=I,e.$Co="telemetry",e.$Do="extensionTelemetryLog",e.$Eo={log:()=>null,flush:()=>Promise.resolve(null)};function d(i,n){return R.Event.debounce(n.onDidChangeConfiguration,(l,k)=>{const b=l?new Set([...l.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:b}},1e3,!0)(l=>{l.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,N.$zi)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.$Fo=d;function f(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry)}e.$Go=f;function S(i,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$Ho=S;function v(i){const n=i.getValue(h.$zl),r=i.getValue(h.$Al);if(i.getValue(h.$Bl)===!1||r===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Io=v;function p(i){const n={},r={},l={};O(i,l);for(let k in l){k=k.length>150?k.substr(k.length-149):k;const b=l[k];typeof b=="number"?r[k]=b:typeof b=="boolean"?r[k]=b?1:0:typeof b=="string"?(b.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${b.length}`),n[k]=b.substring(0,8191)):typeof b<"u"&&b!==null&&(n[k]=b)}return{properties:n,measurements:r}}e.$Jo=p;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function $(i){if(!i)return"none";const n=(0,A.$$k)(i);return u.has(n)?n:"other"}e.$Ko=$;function O(i,n,r=0,l){if(i)for(const k of Object.getOwnPropertyNames(i)){const b=i[k],w=l?l+k:k;Array.isArray(b)?n[w]=(0,L.$on)(b):b instanceof Date?n[w]=b.toISOString():(0,D.$Hf)(b)?r<2?O(b,n,r+1,w+"."):n[w]=(0,L.$on)(b):n[w]=b}}function g(i,n){const r=i.msftInternalDomains||[],l=n.getValue("telemetry.internalTesting");return(0,E.$xo)(r)||l}e.$Lo=g;function y(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$Mo=y;function s(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const l=[];for(const j of n)for(;;){const H=j.exec(i);if(!H)break;l.push([H.index,j.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,b=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(r="";;){const j=b.exec(i);if(!j)break;const H=l.some(([ee,_])=>j.index<_&&ee<b.lastIndex);!k.test(j[0])&&!H&&(r+=i.substring(w,j.index)+"<REDACTED: user-file-path>",w=b.lastIndex)}return w<i.length&&(r+=i.substr(w)),r}function o(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function t(i,n){return(0,L.$ln)(i,r=>{if(r instanceof c||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let l=r.replaceAll("%20"," ");l=s(l,n);for(const k of n)l=l.replace(k,"");return l=o(l),l}})}e.$No=t}),define(te[27],ne([0,1,29,21,37,13,11,9,35,39]),function(G,e,L,D,R,N,A,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=void 0;function P(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,L.$4e)(t.id,i.id)===0}e.$Oo=P;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(i){const n=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new d(i.identifier,n,r)}static parse(i){const n=I.exec(i);return n&&n[1]&&n[2]?new d({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,r="undefined"){this.version=n,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof d?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Po=d;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(t){const i=f.exec(t);return i&&i[1]?[p(i[1]),i[2]]:[p(t),void 0]}e.$Qo=S;function v(t,i){return`${t}.${i}`}e.$Ro=v;function p(t){return t.toLowerCase()}e.$So=p;function u(t,i){return p(v(t??R.$em,i))}e.$To=u;function $(t,i){const n=[],r=l=>{for(const k of n)if(k.some(b=>P(i(b),i(l))))return k;return null};for(const l of t){const k=r(l);k?k.push(l):n.push([l])}return n}e.$Uo=$;function O(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.$Vo=O;function g(t){return{id:new c.$yo(t.identifier.id),name:new c.$yo(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$Wo=g,e.$Xo=new R.$im("pprice.better-merge");function y(t,i){const n=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const l=r.shift();if(l&&n.every(k=>!P(k.identifier,{id:l}))){const k=t.filter(b=>P(b.identifier,{id:l}));k.length===1&&(n.push(k[0]),r.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$Yo=y;async function s(t,i){if(!N.$k)return!1;let n;try{n=(await t.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await t.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){i.debug("Error while getting the os-release file.",(0,E.$0)(l))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(t,i){const n=await s(t,i),r=(0,D.$io)(n?"alpine":N.$u,h.$ec);return i.debug("ComputeTargetPlatform:",r),r}e.$Zo=o}),define(te[141],ne([0,1,20,9,15,17,42,11,94,21,27,37]),function(G,e,L,D,R,N,A,E,h,c,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=void 0;const d=p=>(0,h.localize)(0,null,p),f=(0,h.localize)(1,null,"ms-dotnettools.csharp");function S(p,u){return u?`${p.publisher}.${p.name}@${p.version}`:`${p.publisher}.${p.name}`}let v=class{constructor(u,$,O){this.a=u,this.b=$,this.d=O}get f(){}async listExtensions(u,$,O){let g=await this.b.getInstalled(1,O);const y=I.$hm.map(o=>o.toLowerCase());if($&&$!==""){if(y.indexOf($.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}g=g.filter(o=>o.manifest.categories?o.manifest.categories.map(i=>i.toLowerCase()).indexOf($.toLowerCase())>-1:!1)}else if($===""){this.a.info("Possible Categories: "),y.forEach(o=>{this.a.info(o)});return}this.f&&this.a.info((0,h.localize)(2,null,this.f)),g=g.sort((o,t)=>o.identifier.id.localeCompare(t.identifier.id));let s;for(const o of g)s!==o.identifier.id&&(s=o.identifier.id,this.a.info(S(o.manifest,u)))}async installExtensions(u,$,O,g){const y=[];try{const s=[];u.length&&this.a.info(this.f?(0,h.localize)(3,null,this.f):(0,h.localize)(4,null));const o=[];let t=[];const i=(r,l,k)=>{t.push({id:r,version:l!=="prerelease"?l:void 0,installOptions:{...O,isBuiltin:k,installPreReleaseVersion:l==="prerelease"||O.installPreReleaseVersion}})};for(const r of u)if(r instanceof E.URI)o.push({vsix:r,installOptions:O});else{const[l,k]=(0,P.$Qo)(r);i(l,k,!1)}for(const r of $)if(r instanceof E.URI)o.push({vsix:r,installOptions:{...O,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[l,k]=(0,P.$Qo)(r);i(l,k,!0)}const n=await this.b.getInstalled(1,O.profileLocation);if(o.length&&await Promise.all(o.map(async({vsix:r,installOptions:l})=>{try{const k=await this.g(r,l,g,n);k&&s.push(k)}catch(k){this.a.error(k),y.push(r.toString())}})),t.length&&(t=t.filter(({id:r,version:l})=>{const k=n.find(b=>(0,P.$Oo)(b.identifier,{id:r}));if(k){if(!g&&(!l||l==="prerelease"&&k.preRelease))return this.a.info((0,h.localize)(5,null,r,k.manifest.version,r)),!1;if(l&&k.manifest.version===l)return this.a.info((0,h.localize)(6,null,`${r}@${l}`)),!1}return!0}),t.length)){const r=await this.h(t);await Promise.all(t.map(async l=>{const k=r.get(l.id.toLowerCase());if(k)try{const b=await this.j(l,k,n);b&&s.push(b)}catch(b){this.a.error(b.message||b.stack||b),y.push(l.id)}else this.a.error(`${d(l.version?`${l.id}@${l.version}`:l.id)}
${f}`),y.push(l.id)}))}}catch(s){throw this.a.error((0,h.localize)(7,null,(0,D.$0)(s))),s}if(y.length)throw new Error((0,h.localize)(8,null,y.join(", ")))}async g(u,$,O,g){const y=await this.b.getManifest(u);if(!y)throw new Error("Invalid vsix");if(await this.l(y,O,$.profileLocation,g))try{return await this.b.install(u,$),this.a.info((0,h.localize)(9,null,(0,N.$Bg)(u))),y}catch(o){if((0,D.$4)(o))return this.a.info((0,h.localize)(10,null,(0,N.$Bg)(u))),null;throw o}return null}async h(u){const $=new Map,O=u.some(s=>s.installOptions.installPreReleaseVersion),g=await this.b.getTargetPlatform(),y=[];for(const s of u)c.$bo.test(s.id)&&y.push({...s,preRelease:O});if(y.length){const s=await this.d.getExtensions(y,{targetPlatform:g},L.CancellationToken.None);for(const o of s)$.set(o.identifier.id.toLowerCase(),o)}return $}async j({id:u,version:$,installOptions:O},g,y){const s=await this.d.getManifest(g,L.CancellationToken.None);if(s&&!this.k(s))return null;const o=y.find(t=>(0,P.$Oo)(t.identifier,g.identifier));if(o){if(g.version===o.manifest.version)return this.a.info((0,h.localize)(11,null,$?`${u}@${$}`:u)),null;this.a.info((0,h.localize)(12,null,u,g.version))}try{O.isBuiltin?this.a.info($?(0,h.localize)(13,null,u,$):(0,h.localize)(14,null,u)):this.a.info($?(0,h.localize)(15,null,u,$):(0,h.localize)(16,null,u));const t=await this.b.installFromGallery(g,{...O,installGivenVersion:!!$});return this.a.info((0,h.localize)(17,null,u,t.manifest.version)),s}catch(t){if((0,D.$4)(t))return this.a.info((0,h.localize)(18,null,u)),null;throw t}}k(u){return!0}async l(u,$,O,g){if(!$){const y={id:(0,P.$To)(u.publisher,u.name)},s=g.find(o=>(0,P.$Oo)(y,o.identifier)&&(0,A.gt)(o.manifest.version,u.version));if(s)return this.a.info((0,h.localize)(19,null,s.identifier.id,s.manifest.version,u.version)),!1}return this.k(u)}async uninstallExtensions(u,$,O){const g=async s=>{if(s instanceof E.URI){const o=await this.b.getManifest(s);return S(o)}return s},y=[];for(const s of u){const o=await g(s),i=(await this.b.getInstalled(void 0,O)).filter(n=>(0,P.$Oo)(n.identifier,{id:o}));if(!i.length)throw new Error(`${this.m(o)}
${f}`);if(i.some(n=>n.type===0)){this.a.info((0,h.localize)(20,null,o));return}if(!$&&i.some(n=>n.isBuiltin)){this.a.info((0,h.localize)(21,null,o));return}this.a.info((0,h.localize)(22,null,o));for(const n of i)await this.b.uninstall(n,{profileLocation:O}),y.push(n);this.f?this.a.info((0,h.localize)(23,null,o,this.f)):this.a.info((0,h.localize)(24,null,o))}}async locateExtension(u){const $=await this.b.getInstalled();u.forEach(O=>{$.forEach(g=>{if(g.identifier.id===O&&g.location.scheme===R.Schemas.file){this.a.info(g.location.fsPath);return}})})}m(u){return this.f?(0,h.localize)(25,null,u,this.f):(0,h.localize)(26,null,u)}};e.$vp=v,e.$vp=v=pe([ie(1,c.$oo),ie(2,c.$mo)],v)}),define(te[142],ne([0,1,8,9,2,15,17,42,3,28,24,48,25,18,21,27,60,12,6]),function(G,e,L,D,R,N,A,E,h,c,P,I,d,f,S,v,p,u,$){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;let g=class extends R.$Sc{static{O=this}static{this.c=".sigzip"}constructor(s,o,t,i,n,r){super(),this.h=o,this.j=t,this.m=i,this.n=n,this.r=r,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(s,o,t){await this.g;const i=(0,A.$Eg)(this.extensionsDownloadDir,this.z(s));try{await this.w(s,i,r=>this.j.download(s,r,o))}catch(r){throw new S.$no(r.message,S.ExtensionManagementErrorCode.Download)}let n=!1;if(t&&this.t(s)){const r=await this.u(s);try{n=await this.n.verify(i.fsPath,r.fsPath,this.r.getLevel()===$.LogLevel.Trace)}catch(l){const k=l;if(n=k.code,k.output&&this.r.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${k.output}`),n===S.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===S.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(i)}catch(b){this.r.error(b)}throw new S.$no(I.$zp,S.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(r)}catch(l){this.r.error(l)}}}return n===!0?this.r.info(`Extension signature is verified: ${s.identifier.id}`):n===!1?this.r.info(`Extension signature verification is not done: ${s.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${n}': ${s.identifier.id}`),{location:i,verificationStatus:n}}t(s){if(!s.isSigned)return!1;const o=this.m.getValue("extensions.verifySignature");return(0,h.$Lf)(o)?o:!0}async u(s){await this.g;const o=(0,A.$Eg)(this.extensionsDownloadDir,`${this.z(s)}${O.c}`);return await this.w(s,o,t=>this.j.downloadSignatureArchive(s,t)),o}async w(s,o,t){if(await this.h.exists(o))return;if(o.scheme!==N.Schemas.file){await t(o);return}const i=(0,A.$Eg)(this.extensionsDownloadDir,`.${(0,c.$ng)()}`);await this.h.exists(i)||await t(i);try{await P.Promises.rename(i.fsPath,o.fsPath,2*60*1e3)}catch(n){try{await this.h.del(i)}catch{}if(n.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,D.$0)(n)}. Deleted the file from downloaded location`,i.path),n}}async delete(s){await this.g,await this.h.del(s)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const o=[],t=[],i=[];for(const l of s.children)if(l.name.endsWith(O.c))i.push(l.resource);else{const k=v.$Po.parse(l.name);k&&t.push([k,l])}const n=(0,v.$Uo)(t,([l])=>l),r=[];for(const l of n)l.sort((k,b)=>E.rcompare(k[0].version,b[0].version)),o.push(...l.slice(1).map(k=>k[1].resource)),r.push(l[0][1]);r.sort((l,k)=>l.mtime-k.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(l=>l.resource)),o.push(...i),await L.Promises.settled(o.map(l=>(this.r.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(s){this.r.error(s)}}z(s){return this.f?v.$Po.create(s).toString().toLowerCase():(0,c.$ng)()}};e.$Sp=g,e.$Sp=g=O=pe([ie(0,f.$$h),ie(1,u.$nk),ie(2,S.$mo),ie(3,d.$wi),ie(4,p.$tp),ie(5,$.$kj)],g)}),define(te[143],ne([0,1,4,2,31,27,37]),function(G,e,L,D,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=void 0;class E extends D.$Sc{constructor(c,P,I,d,f,S,v){super(),this.f=c,this.g=P,this.h=I,this.j=d,this.m=f,this.n=S,this.r=v,this.a=this.B(new L.$Sd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new D.$2c),this.s().then(null,p=>v.error(p))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(c=>this.u(c.added))),this.B(this.j.onAddExtensions(c=>this.w(c))),this.B(this.j.onDidAddExtensions(c=>this.y(c))),this.B(this.j.onRemoveExtensions(c=>this.z(c))),this.B(this.j.onDidRemoveExtensions(c=>this.C(c))),this.B(this.n.onDidFilesChange(c=>this.D(c)))}async u(c){try{c.length&&await Promise.all(c.map(P=>(this.c.set(P.id,(0,D.$Pc)(this.n.watch(this.m.extUri.dirname(P.extensionsResource)),this.n.watch(P.extensionsResource))),this.G(P.extensionsResource))))}catch(P){throw this.r.error(P),P}}async w(c){for(const P of c.extensions)this.I(this.L(P.identifier,P.version),c.profileLocation)}async y(c){for(const P of c.extensions){const I=this.L(P.identifier,P.version);c.error?this.J(I,c.profileLocation):this.I(I,c.profileLocation)}}async z(c){for(const P of c.extensions)this.J(this.L(P.identifier,P.version),c.profileLocation)}async C(c){const P=[],I=[];for(const d of c.extensions){const f=this.L(d.identifier,d.version);c.error?this.I(f,c.profileLocation):(this.J(f,c.profileLocation),this.b.has(f)||(this.r.debug("Extension is removed from all profiles",d.identifier.id,d.version),I.push(this.f.scanInstalledExtensionAtLocation(d.location).then(S=>{S?P.push(S):this.r.info("Extension not found at the location",d.location.toString())},S=>this.r.error(S)))))}try{await Promise.all(I),P.length&&await this.H(P)}catch(d){this.r.error(d)}}D(c){for(const P of this.h.profiles)c.contains(P.extensionsResource,0,1)&&this.F(P.extensionsResource)}async F(c){const P=[],I=[],d=await this.j.scanProfileExtensions(c),f=new Set,S=new Set;for(const[v,p]of this.b)p.has(c)&&S.add(v);for(const v of d){const p=this.L(v.identifier,v.version);f.add(p),S.has(p)||(P.push(v.identifier),this.I(p,c))}for(const v of S)if(!f.has(v)){const p=this.M(v);p&&(I.push(p.identifier),this.J(v,c))}(P.length||I.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:c}:void 0,removed:I.length?{extensions:I,profileLocation:c}:void 0})}async G(c){const P=await this.j.scanProfileExtensions(c);for(const I of P)this.I(this.L(I.identifier,I.version),c)}async H(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(I=>!this.b.has(this.L(I.identifier,I.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}I(c,P){let I=this.b.get(c);I||this.b.set(c,I=new R.$Bc(d=>this.m.extUri.getComparisonKey(d))),I.add(P)}J(c,P){const I=this.b.get(c);I&&I.delete(P),I?.size||this.b.delete(c)}L(c,P){return`${A.$im.toKey(c.id)}@${P}`}M(c){const[P,I]=(0,N.$Qo)(c);return I?{identifier:{id:P},version:I}:void 0}}e.$Wp=E}),define(te[144],ne([0,1,115,39]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=void 0;async function R(N,A,E,h,c,P,I){const d={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N} (${A.nameShort})`};if((0,D.$Go)(A,E)&&(0,D.$Io)(h)===3){const f=await(0,L.$op)(E,c,P);d["X-Market-User-Id"]=f,d["VSCode-SessionId"]=I.machineId||f}return d}e.$pp=R}),define(te[145],ne([0,1,172,19,8,2,15,16,24,18,21,27,6,64,11]),function(G,e,L,D,R,N,A,E,h,c,P,I,d,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=void 0;let v=class extends f.$9q{constructor(O,g,y,s){super(y),this.h=O,this.j=s,this.g=this.B(new p(g,s)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(O,g){const s=(await this.g.getLanguagePacks())[g];if(!s){this.j.warn(`No language pack found for ${g}`);return}const o=s.translations[O];return o?S.URI.file(o):void 0}async getInstalledLanguages(){const O=await this.g.getLanguagePacks(),g=Object.keys(O).map(y=>{const s=O[y];return{...this.f(y,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return g.push(this.f("en","English")),g.sort((y,s)=>y.label.localeCompare(s.label)),g}async m(O){O&&O.manifest&&O.manifest.contributes&&O.manifest.contributes.localizations&&O.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",O.identifier.id),await this.update())}async n(O){const g=await this.g.getLanguagePacks();Object.keys(g).some(y=>g[y]&&g[y].extensions.some(s=>(0,I.$Oo)(s.extensionIdentifier,O.identifier)))&&(this.j.info("Removing language packs from the extension",O.identifier.id),await this.update())}async update(){const[O,g]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),y=await this.g.update(g);return!(0,D.$ub)(Object.keys(O),Object.keys(y))}};e.$0q=v,e.$0q=v=pe([ie(0,P.$oo),ie(1,c.$$h),ie(2,P.$mo),ie(3,d.$kj)],v);let p=class extends N.$Sc{constructor(O,g){super(),this.j=g,this.c={},this.f=(0,E.$jc)(O.userDataPath,"languagepacks.json"),this.g=new R.$0g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(O){return this.s(g=>{Object.keys(g).forEach(y=>delete g[y]),this.m(g,...O)}).then(()=>this.c)}m(O,...g){for(const y of g)y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&this.n(O,y);Object.keys(O).forEach(y=>this.r(O[y]))}n(O,g){const y=g.identifier,s=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const o of s)if(g.location.scheme===A.Schemas.file&&u(o)){let t=O[o.languageId];t||(t={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},O[o.languageId]=t);const i=t.extensions.filter(n=>(0,I.$Oo)(n.extensionIdentifier,y))[0];i?i.version=g.manifest.version:t.extensions.push({extensionIdentifier:y,version:g.manifest.version});for(const n of o.translations)t.translations[n.id]=(0,E.$jc)(g.location.fsPath,n.path)}}r(O){if(O){const g=(0,L.createHash)("md5");for(const y of O.extensions)g.update(y.extensionIdentifier.uuid||y.extensionIdentifier.id).update(y.version);O.hash=g.digest("hex")}}s(O=()=>null){return this.g.queue(()=>{let g=null;return h.Promises.readFile(this.f,"utf8").then(void 0,y=>y.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(y)).then(y=>{try{return JSON.parse(y)}catch{return{}}}).then(y=>(g=O(y),y)).then(y=>{for(const o of Object.keys(y))y[o]||delete y[o];this.c=y,this.h=!0;const s=JSON.stringify(this.c);return this.j.debug("Writing language packs",s),h.Promises.writeFile(this.f,s)}).then(()=>g,y=>this.j.error(y))})}};p=pe([ie(0,c.$$h),ie(1,d.$kj)],p);function u($){if(typeof $.languageId!="string"||!Array.isArray($.translations)||$.translations.length===0)return!1;for(const O of $.translations)if(typeof O.id!="string"||typeof O.path!="string")return!1;return!($.languageName&&typeof $.languageName!="string"||$.localizedLanguageName&&typeof $.localizedLanguageName!="string")}}),define(te[146],ne([0,1,81,9,30,39]),function(G,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5N=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",E="https://mobile.events.data.microsoft.com/ping";async function h(P,I,d){const f=await(0,L.$4C)("@microsoft/1ds-core-js","dist/ms.core.js"),S=await(0,L.$4C)("@microsoft/1ds-post-js","dist/ms.post.js"),v=new f.AppInsightsCore,p=new S.PostChannel,u={instrumentationKey:P,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(d){u.extensionConfig={};const $={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:d};u.extensionConfig[p.identifier]=$}return v.initialize(u,[]),v.addTelemetryInitializer($=>{$.ext=$.ext??{},$.ext.web=$.ext.web??{},$.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',I&&($.ext.utc=$.ext.utc??{},$.ext.utc.flags=8462029)}),v}class c{constructor(I,d,f,S,v){this.e=I,this.f=d,this.g=f,this.h=v,this.c=A,this.d=E,this.g||(this.g={}),typeof S=="function"?this.a=S():this.a=S,this.b=null}i(I){if(this.a){if(typeof this.a!="string"){I(this.a);return}this.b||(this.b=h(this.a,this.e,this.h)),this.b.then(d=>{I(d)},d=>{(0,D.$1)(d),console.error(d)})}}log(I,d){if(!this.a)return;d=(0,R.$mn)(d,this.g),d=(0,N.$Jo)(d);const f=this.f+"/"+I;try{this.i(S=>{S.pluginVersionString=d?.properties.version??"Unknown",S.track({name:f,baseData:{name:f,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this.a?new Promise(I=>{this.i(d=>{d.unload(!0,()=>{this.a=void 0,I(void 0)})})}):Promise.resolve(void 0)}}e.$5N=c}),define(te[147],ne([0,1,2,30,13,29,106,25,43,148,32,36,26,39]),function(G,e,L,D,R,N,A,E,h,c,P,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0;let S=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(u,$,O){this.k=$,this.l=O,this.d={},this.i=new L.$Rc,this.j=[],this.b=u.appenders,this.c=u.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const g of this.f)this.j.push(new RegExp((0,N.$Le)(g),"gi")),g.indexOf("\\")>=0&&this.j.push(new RegExp((0,N.$Le)(g.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(g=>{(g.affectsConfiguration(d.$zl)||g.affectsConfiguration(d.$Bl)||g.affectsConfiguration(d.$Al))&&this.m()}))}setExperimentProperty(u,$){this.d[u]=$}m(){let u=(0,f.$Io)(this.k);const $=this.l.enabledTelemetryLevels;if($){this.h=this.sendErrorTelemetry?$.error:!1;const O=$.usage?3:$.error?2:0;u=Math.min(u,O)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(u,$,O){this.g<$||(O=(0,D.$mn)(O,this.d),O=(0,f.$No)(O,this.j),O=(0,D.$mn)(O,this.c),this.b.forEach(g=>g.log(u,O)))}publicLog(u,$){this.n(u,3,$)}publicLog2(u,$){this.publicLog(u,$)}publicLogError(u,$){this.h&&this.n(u,2,$)}publicLogError2(u,$){this.publicLogError(u,$)}};e.$dr=S,e.$dr=S=pe([ie(1,E.$wi),ie(2,P.$Cj)],S);function v(){const p=(0,A.localize)(0,null,c.default.nameLong),u=c.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),$=R.$o?"":(0,A.localize)(3,null),O=(0,A.localize)(4,null),g=(0,A.localize)(5,null),y=(0,A.localize)(6,null),s=(0,A.localize)(7,null),o=`
|       | ${O} | ${g} | ${y} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,A.localize)(8,null);return`
${p} ${u} ${$}

&nbsp;

${s}
${o}

&nbsp;

${t}
`}I.$vn.as(h.$An.Configuration).registerConfiguration({id:d.$yl,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[d.$zl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.$vn.as(h.$An.Configuration).registerConfiguration({id:d.$yl,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[d.$Bl]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,A.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,A.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${d.$zl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[149],ne([0,1,14,20,173,146]),function(G,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6N=void 0;async function A(P,I){const d=await I.request(P,D.CancellationToken.None),f=(await(0,L.$se)(d.stream)).toString(),S=d.res.statusCode??200;return{headers:d.res.headers,statusCode:S,responseData:f}}async function E(P){const I={method:P.type,headers:P.headers};return new Promise((f,S)=>{const v=R.request(P.url??"",I,p=>{p.on("data",function(u){f({headers:p.headers,statusCode:p.statusCode??200,responseData:u.toString()})}),p.on("error",function(u){S(u)})});v.write(P.data,p=>{p&&S(p)}),v.end()})}async function h(P,I,d){const f=typeof I.data=="string"?I.data:new TextDecoder().decode(I.data),S={type:"POST",headers:{...I.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(I.data).toString()},url:I.urlString,data:f};try{const v=P?await A(S,P):await E(S);d(v.statusCode,v.headers,v.responseData)}catch{d(0,{})}}class c extends N.$5N{constructor(I,d,f,S,v){const p={sendPOST:(u,$)=>{h(I,u,$)}};super(d,f,S,v,p)}}e.$6N=c}),define(te[150],ne([0,1,16,24]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J$b=void 0;async function R(N,A){const E=Object.create(null),h=(P,I)=>{const d=JSON.parse(P);E[I]=d};if(A){const P=[],I=await D.Promises.readdir(A);for(const f of I)try{(await D.Promises.stat((0,L.$jc)(A,f))).isDirectory()&&P.push(f)}catch{}const d=[];for(const f of P)(await D.Promises.readdir((0,L.$jc)(A,f))).filter(v=>v==="telemetry.json").length===1&&d.push(f);for(const f of d){const S=(await D.Promises.readFile((0,L.$jc)(A,f,"telemetry.json"))).toString();h(S,f)}}let c=(await D.Promises.readFile((0,L.$jc)(N,"telemetry-core.json"))).toString();return h(c,"vscode-core"),c=(await D.Promises.readFile((0,L.$jc)(N,"telemetry-extensions.json"))).toString(),h(c,"vscode-extensions"),JSON.stringify(E,null,4)}e.$J$b=R}),define(te[151],ne([0,1,13,82,26]),function(G,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$30b=e.$20b=void 0;async function N(E,h){let c=E.getItem(R.$wl);return(typeof c!="string"||L.$j&&c==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(c=await(0,D.$8m)(h.error.bind(h))),c}e.$20b=N;async function A(E,h){let c=E.getItem(R.$xl);return typeof c!="string"&&(c=await(0,D.$9m)(h.error.bind(h))),c}e.$30b=A}),define(te[22],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=void 0,e.$Xk=(0,L.$3h)("IUriIdentityService")}),define(te[152],ne([0,1,22,116,12,17,73,4,2]),function(G,e,L,D,R,N,A,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=void 0;class c{static{this._clock=0}constructor(d){this.uri=d,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let P=class{constructor(d){this.g=d,this.c=new h.$Rc,this.f=2**16;const f=new Map,S=v=>{let p=f.get(v.scheme);return p===void 0&&(p=d.hasProvider(v)&&!this.g.hasCapability(v,1024),f.set(v.scheme,p)),p};this.c.add(E.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(v=>{f.delete(v.scheme)})),this.extUri=new N.$tg(S),this.d=new A.$Nr((v,p)=>this.extUri.compare(v,p,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,N.$Fg)(d));const f=this.d.get(d);return f?f.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new c(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((S,v)=>S[1].time<v[1].time?1:S[1].time>v[1].time?-1:0);c._clock=0,this.d.clear();const f=this.f*.5;for(let S=0;S<f;S++)this.d.set(d[S][0],d[S][1].touch())}};e.$Or=P,e.$Or=P=pe([ie(0,R.$nk)],P),(0,D.$Lr)(L.$Xk,P,1)}),define(te[153],ne([0,1,4,2,12,47,31]),function(G,e,L,D,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n$b=void 0;class E extends D.$Sc{constructor(c,P,I,d,f,S){super(),this.f=c,this.g=P,this.h=I,this.j=d,this.m=f,this.n=S,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new L.$Sd),this.onDidChangeFile=this.a.event,this.b=N.$9h.forUris(()=>!(this.capabilities&1024)),this.c=new A.$Bc(v=>this.m.extUri.getComparisonKey(this.t(v))),this.r(),this.B(d.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(v=>this.s(v)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,P){return this.g.open(this.t(c),P)}close(c){return this.g.close(c)}read(c,P,I,d,f){return this.g.read(c,P,I,d,f)}write(c,P,I,d,f){return this.g.write(c,P,I,d,f)}watch(c,P){this.b.set(c,c);const I=this.g.watch(this.t(c),P);return(0,D.$Qc)(()=>{this.b.delete(c),I.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,P,I){return this.g.rename(this.t(c),this.t(P),I)}readFile(c,P){return this.g.readFile(this.t(c),P)}readFileStream(c,P,I){return this.g.readFileStream(this.t(c),P,I)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,P,I){return this.g.writeFile(this.t(c),P,I)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,P){return this.g.delete(this.t(c),P)}copy(c,P,I){if((0,R.$rk)(this.g))return this.g.copy(this.t(c),this.t(P),I);throw new Error("copy not supported")}cloneFile(c,P){if((0,R.$sk)(this.g))return this.g.cloneFile(this.t(c),this.t(P));throw new Error("clone not supported")}s(c){const P=[];for(const I of c){if(I.resource.scheme!==this.f)continue;const d=this.u(I.resource);this.b.findSubstr(d)&&P.push({resource:d,type:I.type,cId:I.cId})}P.length&&(this.n.debug("User data changed"),this.a.fire(P))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$n$b=E}),define(te[154],ne([0,1,108,16,47,17,11,10,15]),function(G,e,L,D,R,N,A,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.WorkbenchState=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=void 0,e.$_h=(0,E.$3h)("contextService");function c(i){const n=i;return typeof n?.id=="string"&&A.URI.isUri(n.uri)}e.$ai=c;function P(i){return typeof i?.id=="string"&&!c(i)&&!d(i)}e.$bi=P,e.$ci={id:"ext-dev"},e.$di={id:"empty-window"};function I(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,D.$nc)(i)}:n?e.$ci:e.$di;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$ei=I;function d(i){const n=i;return typeof n?.id=="string"&&A.URI.isUri(n.configPath)}e.$fi=d;function f(i){const n=i;if(n?.uri)return{id:n.id,uri:A.URI.revive(n.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:A.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.$gi=f;var S;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function v(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$hi=v;function p(i){const n=i;return!!(n&&typeof n=="object"&&A.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$ii=p;class u{constructor(n,r,l,k,b){this.h=n,this.j=l,this.k=k,this.l=b,this.c=R.$9h.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=R.$9h.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ji=u;class ${constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,N.$Eg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ki=$;function O(i){return new $({uri:i,index:0,name:(0,N.$Ag)(i)},{uri:i.toString()})}e.$li=O,e.$mi="code-workspace",e.$ni=`.${e.$mi}`,e.$oi=[{name:(0,L.localize)(0,null),extensions:[e.$mi]}],e.$pi="workspace.json";function g(i,n){return N.$vg.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$qi=g;function y(i){let n;return A.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===h.Schemas.tmp}e.$ri=y,e.$si="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(i){return i.id===e.$si}e.$ti=s;function o(i,n){return!g(i,n)&&!y(i)}e.$ui=o;function t(i){return(typeof i=="string"?(0,D.$oc)(i):(0,N.$Cg)(i))===e.$ni}e.$vi=t}),define(te[23],ne([0,1,41,4,2,17,11,107,18,12,10,6,154,31,22,8,28,29,3]),function(G,e,L,D,R,N,A,E,h,c,P,I,d,f,S,v,p,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.ProfileResourceType=void 0;var O;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(O||(e.ProfileResourceType=O={}));function g(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&A.URI.isUri(n.location)&&A.URI.isUri(n.globalStorageHome)&&A.URI.isUri(n.settingsResource)&&A.URI.isUri(n.keybindingsResource)&&A.URI.isUri(n.tasksResource)&&A.URI.isUri(n.snippetsHome)&&A.URI.isUri(n.extensionsResource))}e.$Yk=g,e.$Zk=(0,P.$3h)("IUserDataProfilesService");function y(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:A.URI.revive(i.location).with({scheme:n}),globalStorageHome:A.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:A.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:A.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:A.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:A.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:A.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:A.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$1k=y;function s(i,n,r,l,k,b){return{id:i,name:n,location:r,isDefault:!1,shortName:k?.shortName,icon:k?.icon,globalStorageHome:b&&k?.useDefaultFlags?.globalState?b.globalStorageHome:(0,N.$Eg)(r,"globalStorage"),settingsResource:b&&k?.useDefaultFlags?.settings?b.settingsResource:(0,N.$Eg)(r,"settings.json"),keybindingsResource:b&&k?.useDefaultFlags?.keybindings?b.keybindingsResource:(0,N.$Eg)(r,"keybindings.json"),tasksResource:b&&k?.useDefaultFlags?.tasks?b.tasksResource:(0,N.$Eg)(r,"tasks.json"),snippetsHome:b&&k?.useDefaultFlags?.snippets?b.snippetsHome:(0,N.$Eg)(r,"snippets"),extensionsResource:b&&k?.useDefaultFlags?.extensions?b.extensionsResource:(0,N.$Eg)(r,"extensions.json"),cacheHome:(0,N.$Eg)(l,i),useDefaultFlags:k?.useDefaultFlags,isTransient:k?.transient}}e.$2k=s;let o=class extends R.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,r,l,k){super(),this.t=n,this.u=r,this.w=l,this.y=k,this.f=!0,this.h=this.B(new D.$Sd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$Sd),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$Sd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$Sd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$Ac,emptyWindows:new Map},this.profilesHome=(0,N.$Eg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,N.$Eg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),r=[n];if(this.f)try{for(const b of this.O()){if(!b.name||!(0,$.$Ff)(b.name)||!b.location){this.y.warn("Skipping the invalid stored profile",b.location||b.name);continue}r.push(s((0,N.$Bg)(b.location),b.name,b.location,this.g,{shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags},n))}}catch(b){this.y.error(b)}const l=new f.$Ac,k=new Map;if(r.length)try{const b=this.Q();if(b.workspaces)for(const[w,j]of Object.entries(b.workspaces)){const H=A.URI.parse(w),ee=r.find(_=>_.id===j);ee&&l.set(H,ee)}if(b.emptyWindows)for(const[w,j]of Object.entries(b.emptyWindows)){const H=r.find(ee=>ee.id===j);H&&k.set(w,H)}}catch(b){this.y.error(b)}this.z={profiles:r,workspaces:l,emptyWindows:k}}return this.z}D(){const n=s("__default__profile__",(0,E.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const r="Temp",l=new RegExp(`${(0,u.$Le)(r)}\\s(\\d+)`);let k=0;for(const w of this.profiles){const j=l.exec(w.name),H=j?parseInt(j[1]):0;k=H>k?H:k}const b=`${r} ${k+1}`;return this.createProfile((0,L.$Qi)((0,p.$ng)()).toString(16),b,{transient:!0},n)}async createNamedProfile(n,r,l){return this.createProfile((0,L.$Qi)((0,p.$ng)()).toString(16),n,r,l)}async createProfile(n,r,l,k){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=await this.F(n,r,l);return k&&await this.setProfileForWorkspace(k,b),b}async F(n,r,l){if(!(0,$.$Ff)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let k=this.r.get(r);return k||(k=(async()=>{try{const b=this.profiles.find(H=>H.name===r||H.id===n);if(b)return b;const w=s(n,r,(0,N.$Eg)(this.profilesHome,n),this.g,l,this.defaultProfile);await this.u.createFolder(w.location);const j=[];return this.j.fire({profile:w,join(H){j.push(H)}}),await v.Promises.settled(j),this.I([w],[],[]),w}finally{this.r.delete(r)}})(),this.r.set(r,k)),k}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(k=>k.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);return l=s(l.id,r.name??l.name,l.location,this.g,{shortName:r.shortName??l.shortName,icon:r.icon===null?void 0:r.icon??l.icon,transient:r.transient??l.isTransient,useDefaultFlags:r.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(k=>k.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const l=[];this.m.fire({profile:r,join(k){l.push(k)}});try{await Promise.allSettled(l)}catch(k){this.y.error(k)}for(const k of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(k)?.id&&this.C.emptyWindows.delete(k);for(const k of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(k)?.id&&this.C.workspaces.delete(k);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(k){(0,c.$Ek)(k)!==1&&this.y.error(k)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(k=>k.id===r.id);if(!l)throw new Error(`Profile '${r.name}' does not exist`);this.L(n,l)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.G(n);return A.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(n){return(0,d.$ai)(n)?n.uri:(0,d.$fi)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location)))}I(n,r,l){const k=[...this.profiles,...n],b=[];this.s.profiles=[];for(let w of k)w.isDefault||r.some(j=>w.id===j.id)||(w=l.find(j=>w.id===j.id)??w,w.isTransient?this.s.profiles.push(w):b.push({location:w.location,name:w.name,shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags}));this.P(b),this.z=void 0,this.J(n,r,l)}J(n,r,l){this.h.fire({added:n,removed:r,updated:l,all:this.profiles})}L(n,r,l){l=r?.isTransient?!0:l,l||this.L(n,void 0,!0);const k=this.G(n),b=l?this.s:this.C;A.URI.isUri(k)?(b.workspaces.delete(k),r&&b.workspaces.set(k,r)):(b.emptyWindows.delete(k),r&&b.emptyWindows.set(k,r)),l||this.M()}M(){const n={};for(const[l,k]of this.C.workspaces.entries())n[l.toString()]=k.id;const r={};for(const[l,k]of this.C.emptyWindows.entries())r[l.toString()]=k.id;this.R({workspaces:n,emptyWindows:r}),this.z=void 0}N(n){const r={},l=this.D();if(n.workspaces)for(const[b,w]of Object.entries(n.workspaces)){const j=A.URI.parse(w);r[b]=this.w.extUri.isEqual(j,l.location)?l.id:this.w.extUri.basename(j)}const k={};if(n.emptyWindows)for(const[b,w]of Object.entries(n.emptyWindows)){const j=A.URI.parse(w);k[b]=this.w.extUri.isEqual(j,l.location)?l.id:this.w.extUri.basename(j)}return{workspaces:r,emptyWindows:k}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$3k=o,e.$3k=o=pe([ie(0,h.$0h),ie(1,c.$nk),ie(2,S.$Xk),ie(3,I.$kj)],o);class t extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$4k=t}),define(te[155],ne([0,1,19,8,20,9,4,2,13,3,11,92,21,27,37,6,32,26,22,23]),function(G,e,L,D,R,N,A,E,h,c,P,I,d,f,S,v,p,u,$,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$Gp=e.$Fp=e.$Ep=void 0;let g=class extends E.$Sc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(n,r,l,k,b,w){super(),this.z=n,this.C=r,this.D=l,this.F=k,this.G=b,this.H=w,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new A.$Sd),this.s=this.B(new A.$Sd),this.t=this.B(new A.$Sd),this.u=this.B(new A.$Sd),this.w=this.B(new A.$Sd),this.y=[],this.B((0,E.$Qc)(()=>{this.j.forEach(({task:j})=>j.cancel()),this.m.forEach(j=>j.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(l=>(0,d.$ko)(l,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{const k=(await this.installGalleryExtensions([{extension:n,options:r}])).find(({identifier:b})=>(0,f.$Oo)(b,n.identifier));if(k?.local)return k?.local;throw k?.error?k.error:s(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch(l){throw s(l)}}async installGalleryExtensions(n){if(!this.z.isEnabled())throw new d.$no(I.localize(0,null),d.ExtensionManagementErrorCode.Internal);const r=[],l=[];await Promise.allSettled(n.map(async({extension:k,options:b})=>{try{const w=await this.O(k,!!b?.installGivenVersion,!!b?.installPreReleaseVersion);l.push({...w,options:b})}catch(w){r.push({identifier:k.identifier,operation:2,source:k,error:w})}})),l.length&&r.push(...await this.I(l));for(const k of r)k.error&&(this.F.error("Failed to install extension.",k.identifier.id),this.F.error(k.error),k.source&&!P.URI.isUri(k.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,f.$Wo)(k.source),error:k.error}));return r}async uninstall(n,r={}){return this.F.trace("ExtensionManagementService#uninstall",n.identifier.id),this.Q(n,r)}async toggleAppliationScope(n,r){if((0,S.$lm)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let l=await this.updateMetadata(n,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(l=await this.ab(n,this.H.defaultProfile.extensionsResource,r));for(const k of this.H.profiles){const b=(await this.getInstalled(1,k.extensionsResource)).find(w=>(0,f.$Oo)(w.identifier,n.identifier));b?this.w.fire(b):this.u.fire({identifier:n.identifier,profileLocation:k.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(n,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.X(),this.h=n),this.g}registerParticipant(n){this.y.push(n)}async I(n){const r=[];return await Promise.allSettled(n.map(async l=>{try{const k=await this.J(l,(b,w)=>n.some(j=>(0,f.$So)(w.identifier.id)===(0,f.$To)(j.manifest.publisher,j.manifest.name))?!1:this.L(b,w));r.push(...k)}catch(k){r.push({identifier:{id:(0,f.$To)(l.manifest.publisher,l.manifest.name)},operation:2,source:l.extension,error:k})}})),this.s.fire(r),r}async J({manifest:n,extension:r,options:l},k){const b=l.isApplicationScoped||l.isBuiltin||(0,S.$lm)(n),w={...l,installOnlyNewlyAddedFromExtensionPack:P.URI.isUri(r)?l.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:b,profileLocation:b?this.H.defaultProfile.extensionsResource:l.profileLocation??this.Y()},j=ue=>`${f.$Po.create(ue).toString()}${w.profileLocation?`-${w.profileLocation.toString()}`:""}`;if(!P.URI.isUri(r)){const ue=this.j.get(j(r));if(ue)return this.F.info("Extensions is already requested to install",r.identifier.id),await ue.task.waitUntilTaskIsFinished(),[]}const H=[],ee=[],_=[],re=this.Z(n,r,w);P.URI.isUri(r)||this.j.set(j(r),{task:re,waitingTasks:[]}),this.n.fire({identifier:re.identifier,source:r,profileLocation:w.profileLocation}),this.F.info("Installing extension:",re.identifier.id),H.push({task:re,manifest:n});let se=!1;try{if(w.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",re.identifier.id);else try{const ce=await this.N(re.identifier,n,!!w.installOnlyNewlyAddedFromExtensionPack,!!w.installPreReleaseVersion,w.profileLocation),oe=await this.getInstalled(void 0,w.profileLocation),q={...w,donotIncludePackAndDependencies:!0,context:{...w.context,[d.$fo]:!0}};for(const{gallery:X,manifest:T}of(0,L.$Mb)(ce,({gallery:M})=>M.identifier.id)){se=se||!!T.extensionDependencies?.some(J=>(0,f.$Oo)({id:J},re.identifier));const M=j(X),V=this.j.get(M);if(V){if(k(re,V.task)){const J=V.task.identifier;this.F.info("Waiting for already requested installing extension",J.id,re.identifier.id),V.waitingTasks.push(re),ee.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,Q=>Q.some(K=>(0,f.$Oo)(K.identifier,J)))).then(Q=>{if(this.F.info("Finished waiting for already requested installing extension",J.id,re.identifier.id),!Q.find(C=>(0,f.$Oo)(C.identifier,J))?.local)throw new Error(`Extension ${J.id} is not installed`)}))}}else if(!oe.some(({identifier:J})=>(0,f.$Oo)(J,X.identifier))){const J=this.Z(T,X,q);this.j.set(M,{task:J,waitingTasks:[re]}),this.n.fire({identifier:J.identifier,source:X,profileLocation:w.profileLocation}),this.F.info("Installing extension:",J.identifier.id,re.identifier.id),H.push({task:J,manifest:T})}}}catch(ce){if(P.URI.isUri(re.source))(0,L.$Lb)(n.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",re.identifier.id,ce.message),(0,L.$Lb)(n.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",re.identifier.id,ce.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",re.identifier.id),ce}const ue=H.reduce((ce,{task:oe,manifest:q})=>(ce.set(oe.identifier.id.toLowerCase(),{task:oe,manifest:q}),ce),new Map);for(;ue.size;){let ce;const oe=[...ue.values()].filter(({manifest:q})=>!q.extensionDependencies?.some(X=>ue.has(X.toLowerCase())));oe.length?ce=ue.size===1?oe:oe.filter(({task:q})=>!(q===re&&!se)):(this.F.info("Found extensions with circular dependencies",oe.map(({task:q})=>q.identifier.id)),ce=[...ue.values()]),await this.M(ce.map(async({task:q})=>{const X=new Date().getTime();try{const T=await q.run();if(await this.M(this.y.map(M=>M.postInstall(T,q.source,w,R.CancellationToken.None))),!P.URI.isUri(q.source)){const M=q.operation===3,V=M?void 0:(new Date().getTime()-q.source.lastUpdated)/1e3;if(o(this.C,M?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$Wo)(q.source),verificationStatus:q.verificationStatus,duration:new Date().getTime()-X,durationSinceUpdate:V}),h.$o&&q.operation!==3)try{await this.z.reportStatistic(T.manifest.publisher,T.manifest.name,T.manifest.version,"install")}catch{}}_.push({local:T,identifier:q.identifier,operation:q.operation,source:q.source,context:q.options.context,profileLocation:q.profileLocation,applicationScoped:T.isApplicationScoped})}catch(T){throw P.URI.isUri(q.source)||o(this.C,q.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$Wo)(q.source),verificationStatus:q.verificationStatus,duration:new Date().getTime()-X,error:T}),this.F.error("Error while installing the extension:",q.identifier.id),T}finally{ue.delete(q.identifier.id.toLowerCase())}}))}return ee.length&&await this.M(ee),_.forEach(({identifier:ce})=>this.F.info("Extension installed successfully:",ce.id)),_}catch(ue){if(H.forEach(({task:ce})=>ce.cancel()),_.length)try{const ce=await Promise.allSettled(_.map(({local:oe})=>this.$(oe,{versionOnly:!0,profileLocation:w.profileLocation}).run()));for(let oe=0;oe<ce.length;oe++){const q=ce[oe],{identifier:X}=_[oe];q.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",X.id):this.F.warn("Rollback: Error while uninstalling extension",X.id,(0,N.$0)(q.reason))}}catch(ce){this.F.warn("Error while rolling back extensions",(0,N.$0)(ce),_.map(({identifier:oe})=>oe.id))}return H.map(({task:ce})=>({identifier:ce.identifier,operation:2,source:ce.source,context:w.context,profileLocation:w.profileLocation,error:ue}))}finally{for(const{task:ue}of H)ue.source&&!P.URI.isUri(ue.source)&&this.j.delete(j(ue.source))}}L(n,r){for(const[,{task:l,waitingTasks:k}]of this.j.entries())if(l===n&&(k.includes(r)||k.some(b=>this.L(b,r)))||l===r&&k[0]&&!this.L(n,k[0]))return!1;return!0}async M(n){const r=[],l=[],k=await Promise.allSettled(n);for(const b of k)b.status==="fulfilled"?r.push(b.value):l.push(b.reason);if(l.length)throw y(l);return r}async N(n,r,l,k,b){if(!this.z.isEnabled())return[];const w=await this.getInstalled(void 0,b),j=[],H=[],ee=async(_,re)=>{j.push(_);const se=re.extensionDependencies||[],ue=[...se];if(re.extensionPack){const ce=l?w.find(oe=>(0,f.$Oo)(oe.identifier,_)):void 0;for(const oe of re.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(q=>(0,f.$Oo)({id:q},{id:oe}))||ue.every(q=>!(0,f.$Oo)({id:q},{id:oe}))&&ue.push(oe)}if(ue.length){const ce=ue.filter(oe=>j.every(q=>!(0,f.$Oo)(q,{id:oe})));if(ce.length){const oe=await this.z.getExtensions(ce.map(q=>({id:q,preRelease:k})),R.CancellationToken.None);for(const q of oe){if(j.find(M=>(0,f.$Oo)(M,q.identifier)))continue;const X=se.some(M=>(0,f.$Oo)({id:M},q.identifier));let T;try{T=await this.O(q,!1,k)}catch(M){if(X)throw M;this.F.info("Skipping the packed extension as it cannot be installed",q.identifier.id,(0,N.$0)(M));continue}H.push({gallery:T.extension,manifest:T.manifest}),await ee(T.extension.identifier,T.manifest)}}}};return await ee(n,r),H}async O(n,r,l){let k;const b=await this.getExtensionsControlManifest();if(b.malicious.some(H=>(0,f.$Oo)(n.identifier,H)))throw new d.$no(I.localize(1,null,n.identifier.id),d.ExtensionManagementErrorCode.Malicious);const w=b.deprecated[n.identifier.id.toLowerCase()];if(w?.extension?.autoMigrate){if(this.F.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${w.extension.id}' extension instead.`),k=(await this.z.getExtensions([{id:w.extension.id,preRelease:w.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0],!k)throw new d.$no(I.localize(2,null,n.identifier.id,w.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const H=await this.getTargetPlatform();throw new d.$no(I.localize(3,null,n.identifier.id,this.G.nameLong,(0,d.$go)(H)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(k=await this.P(n,r,l),!k)throw!l&&n.properties.isPreReleaseVersion&&(await this.z.getExtensions([n.identifier],R.CancellationToken.None))[0]?new d.$no(I.localize(4,null,n.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.$no(I.localize(5,null,n.identifier.id,this.G.nameLong,this.G.version),d.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",k.identifier.id);const j=await this.z.getManifest(k,R.CancellationToken.None);if(j===null)throw new d.$no(`Missing manifest for extension ${k.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(j.version!==k.version)throw new d.$no(`Cannot install '${k.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:k,manifest:j}}async P(n,r,l){const k=await this.getTargetPlatform();let b=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==l&&(b=(await this.z.getExtensions([{...n.identifier,preRelease:l}],{targetPlatform:k,compatible:!0},R.CancellationToken.None))[0]||null),!b&&await this.z.isExtensionCompatible(n,l,k)&&(b=n),b||(r?b=(await this.z.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:k,compatible:!0},R.CancellationToken.None))[0]||null:b=await this.z.getCompatibleExtension(n,l,k)),b}async Q(n,r){const l={...r,profileLocation:n.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},k=_=>`${_.id.toLowerCase()}${l.versionOnly?`-${n.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,b=this.m.get(k(n.identifier));if(b)return this.F.info("Extensions is already requested to uninstall",n.identifier.id),b.waitUntilTaskIsFinished();const w=_=>{const re=this.$(_,l);return this.m.set(k(re.extension.identifier),re),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${_.identifier.id}@${_.manifest.version}`),this.t.fire({identifier:_.identifier,profileLocation:l.profileLocation,applicationScoped:_.isApplicationScoped}),re},j=(_,re)=>{re?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,l.profileLocation.toString(),re.message):this.F.error("Failed to uninstall extension:",`${_.identifier.id}@${_.manifest.version}`,re.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${_.identifier.id}@${_.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${_.identifier.id}@${_.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,f.$Vo)(_),error:re}),this.u.fire({identifier:_.identifier,error:re?.code,profileLocation:l.profileLocation,applicationScoped:_.isApplicationScoped})},H=[],ee=[];try{H.push(w(n));const _=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const re=this.U(n,_);for(const se of re)this.m.has(k(se.identifier))?this.F.info("Extensions is already requested to uninstall",se.identifier.id):H.push(w(se))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.R(H.map(re=>re.extension),_,n),await this.M(H.map(async re=>{try{if(await re.run(),await this.M(this.y.map(se=>se.postUninstall(re.extension,l,R.CancellationToken.None))),re.extension.identifier.uuid)try{await this.z.reportStatistic(re.extension.manifest.publisher,re.extension.manifest.name,re.extension.manifest.version,"uninstall")}catch{}j(re.extension)}catch(se){const ue=se instanceof d.$no?se:new d.$no((0,N.$0)(se),d.ExtensionManagementErrorCode.Internal);throw j(re.extension,ue),ue}finally{ee.push(re)}}))}catch(_){const re=_ instanceof d.$no?_:new d.$no((0,N.$0)(_),d.ExtensionManagementErrorCode.Internal);for(const se of H){try{se.cancel()}catch{}ee.includes(se)||j(se.extension,re)}throw re}finally{for(const _ of H)this.m.delete(k(_.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",_.extension.identifier.id)}}R(n,r,l){for(const k of n){const b=this.W(k,r);if(b.length){const w=b.filter(j=>!n.some(H=>(0,f.$Oo)(H.identifier,j.identifier)));if(w.length)throw new Error(this.S(k,w,l))}}}S(n,r,l){return l===n?r.length===1?I.localize(6,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(7,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(8,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?I.localize(9,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(10,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(11,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(n,r,l=[]){if(l.indexOf(n)!==-1)return[];l.push(n);const k=n.manifest.extensionPack?n.manifest.extensionPack:[];if(k.length){const b=r.filter(j=>!j.isBuiltin&&k.some(H=>(0,f.$Oo)({id:H},j.identifier))),w=[];for(const j of b)w.push(...this.U(j,r,l));return[...b,...w]}return[]}W(n,r){return r.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(k=>(0,f.$Oo)({id:k},n.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const n=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$Ep=g,e.$Ep=g=pe([ie(0,d.$mo),ie(1,u.$rl),ie(2,$.$Xk),ie(3,v.$kj),ie(4,p.$Cj),ie(5,O.$Zk)],g);function y(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,l)=>new Error(`${r.message}${r.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.$Fp=y;function s(i){if(i instanceof d.$no)return i;const n=new d.$no(i.message,d.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}e.$Gp=s;function o(i,n,{extensionData:r,verificationStatus:l,duration:k,error:b,durationSinceUpdate:w}){let j,H;(0,c.$Nf)(l)&&(l===!0?l="Verified":(l===!1||(j=d.ExtensionManagementErrorCode.Signature,H=l),l="Unverified")),b&&(b instanceof d.$no?(j=b.code,b.code===d.ExtensionManagementErrorCode.Signature&&(H=b.message)):j=d.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...r,verificationStatus:l,success:!b,duration:k,errorcode:j,errorcodeDetail:H,durationSinceUpdate:w})}class t{constructor(){this.d=new D.$2g}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,D.$Qg)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,D.$Qg)(n=>new Promise((r,l)=>{const k=n.onCancellationRequested(()=>{k.dispose(),l(new N.$5)})})),this.d.open()),this.g.cancel()}}e.$Hp=t}),define(te[40],ne([0,1,8,14,2,4,31,11,21,27,12,10,6,23,22,3,9,26]),function(G,e,L,D,R,N,A,E,h,c,P,I,d,f,S,v,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=e.$Jp=e.$Ip=e.ExtensionsProfileScanningErrorCode=void 0;var $;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})($||(e.ExtensionsProfileScanningErrorCode=$={}));class O extends Error{constructor(t,i){super(t),this.code=i}}e.$Ip=O,e.$Jp=(0,I.$3h)("IExtensionsProfileScannerService");let g=class extends R.$Sc{constructor(t,i,n,r,l,k){super(),this.j=t,this.m=i,this.n=n,this.r=r,this.s=l,this.t=k,this.b=this.B(new N.$Sd),this.onAddExtensions=this.b.event,this.c=this.B(new N.$Sd),this.onDidAddExtensions=this.c.event,this.f=this.B(new N.$Sd),this.onRemoveExtensions=this.f.event,this.g=this.B(new N.$Sd),this.onDidRemoveExtensions=this.g.event,this.h=new A.$Ac}scanProfileExtensions(t,i){return this.u(t,void 0,i)}async addExtensionsToProfile(t,i){const n=[],r=[];try{return await this.u(i,l=>{const k=[];for(const b of l)t.some(([w])=>(0,c.$Oo)(w.identifier,b.identifier)&&w.manifest.version!==b.version)?n.push(b):k.push(b);for(const[b,w]of t){const j=k.findIndex(ee=>(0,c.$Oo)(ee.identifier,b.identifier)&&ee.version===b.manifest.version),H={identifier:b.identifier,version:b.manifest.version,location:b.location,metadata:w};j===-1?(r.push(H),k.push(H)):k.splice(j,1,H)}return r.length&&this.b.fire({extensions:r,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),k}),r.length&&this.c.fire({extensions:r,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),r}catch(l){throw r.length&&this.c.fire({extensions:r,error:l,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:l,profileLocation:i}),l}}async updateMetadata(t,i){const n=[];return await this.u(i,r=>{const l=[];for(const k of r){const b=t.find(([w])=>(0,c.$Oo)(w.identifier,k.identifier)&&w.manifest.version===k.version);b&&(k.metadata={...k.metadata,...b[1]},n.push(k)),l.push(k)}return l}),n}async removeExtensionFromProfile(t,i){const n=[];try{await this.u(i,r=>{const l=[];for(const k of r)(0,c.$Oo)(k.identifier,t.identifier)?n.push(k):l.push(k);return n.length&&this.f.fire({extensions:n,profileLocation:i}),l}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(r){throw n.length&&this.g.fire({extensions:n,error:r,profileLocation:i}),r}}async u(t,i,n){return this.F(t).queue(async()=>{let r=[],l;try{const k=await this.m.readFile(t);l=JSON.parse(k.value.toString().trim()||"[]")}catch(k){if((0,P.$Ek)(k)!==1)throw k;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&n?.bailOutWhenFileNotFound)throw new O((0,p.$0)(k),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.w(t);let k=!1;for(const b of l){y(b)||this.w(t);let w;if((0,v.$Ff)(b.relativeLocation)&&b.relativeLocation)w=this.z(b.relativeLocation);else if((0,v.$Ff)(b.location))w=this.z(b.location),k=!0,b.relativeLocation=b.location,b.location=w.toJSON();else{w=E.URI.revive(b.location);const j=this.y(w);j&&(k=!0,b.relativeLocation=j)}r.push({identifier:b.identifier,location:w,version:b.version,metadata:b.metadata})}k&&await this.m.writeFile(t,D.$ge.fromString(JSON.stringify(l)))}if(i){r=i(r);const k=r.map(b=>({identifier:b.identifier,version:b.version,location:b.location.toJSON(),relativeLocation:this.y(b.location),metadata:b.metadata}));await this.m.writeFile(t,D.$ge.fromString(JSON.stringify(k)))}return r})}w(t){const i=new O(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(t)).value.toString()}catch(l){if((0,P.$Ek)(l)===1)return;throw l}this.t.info("Migrating extensions from old default profile location",t.toString());let r;try{const l=JSON.parse(n);Array.isArray(l)&&l.every(k=>y(k))?r=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$ge.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,P.$Ek)(l)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(t)}catch(l){(0,P.$Ek)(l)!==1&&this.t.error(l)}try{await this.m.del(i)}catch(l){(0,P.$Ek)(l)!==1&&this.t.error(l)}return r})()),this.C}F(t){let i=this.h.get(t);return i||(i=new L.$0g,this.h.set(t,i)),i}};e.$Kp=g,e.$Kp=g=pe([ie(1,P.$nk),ie(2,f.$Zk),ie(3,S.$Xk),ie(4,u.$rl),ie(5,d.$kj)],g);function y(o){return(0,v.$Hf)(o)&&(0,h.$lo)(o.identifier)&&(s(o.location)||(0,v.$Ff)(o.location)&&o.location)&&((0,v.$Mf)(o.relativeLocation)||(0,v.$Ff)(o.relativeLocation))&&o.version&&(0,v.$Ff)(o.version)}function s(o){return o?(0,v.$Ff)(o.path)&&(0,v.$Ff)(o.scheme):!1}}),define(te[51],ne([0,1,19,8,30,14,9,53,79,2,15,16,13,17,42,54,3,11,96,18,27,37,49,12,10,6,32,4,46,40,23,22,113]),function(G,e,L,D,R,N,A,E,h,c,P,I,d,f,S,v,p,u,$,O,g,y,s,o,t,i,n,r,l,k,b,w,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=e.$Pp=e.$Op=e.$Np=e.Translations=void 0;var H;(function(oe){function q(X,T){if(X===T)return!0;const M=Object.keys(X),V=new Set;for(const J of Object.keys(T))V.add(J);if(M.length!==V.size)return!1;for(const J of M){if(X[J]!==T[J])return!1;V.delete(J)}return V.size===0}oe.equals=q})(H||(e.Translations=H={})),e.$Np=(0,t.$3h)("IExtensionsScannerService");let ee=class extends c.$Sc{constructor(q,X,T,M,V,J,Q,K,C,F,a,m){super(),this.systemExtensionsLocation=q,this.userExtensionsLocation=X,this.r=T,this.s=M,this.t=V,this.u=J,this.w=Q,this.y=K,this.z=C,this.C=F,this.D=a,this.F=m,this.g=this.B(new r.$Sd),this.onDidChangeCache=this.g.event,this.h=(0,f.$Eg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(se,this.s,this.h)),this.m=this.B(this.F.createInstance(se,this.s,this.h)),this.n=this.B(this.F.createInstance(re,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,g.$Zo)(this.w,this.y)),this.G}async scanAllExtensions(q,X,T){const[M,V]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(X)]),J=T?await this.scanExtensionsUnderDevelopment(q,[...M,...V]):[];return this.L(M,V,J,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const X=[];X.push(this.M(!!q.useCache,q.language)),X.push(this.N(q.language,!!q.checkControlFile));const[T,M]=await Promise.all(X);return this.J([...T,...M],0,q,!1)}async scanUserExtensions(q){const X=q.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",X);const T=this.D.extUri.isEqual(q.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,M=await this.P(X,!!q.profileLocation,1,!q.includeUninstalled,q.language,!0,T),V=q.useCache&&!M.devMode&&M.excludeObsolete?this.m:this.n;let J;try{J=await V.scanExtensions(M)}catch(Q){if(Q instanceof k.$Ip&&Q.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),J=await V.scanExtensions(M);else throw Q}return J=await this.J(J,1,q,!0),this.y.trace("Scanned user extensions:",J.length),J}async scanExtensionsUnderDevelopment(q,X){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const T=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(M=>M.scheme===P.Schemas.file).map(async M=>{const V=await this.P(M,!1,1,!0,q.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(V)).map(Q=>(Q.type=X.find(K=>(0,g.$Oo)(K.identifier,Q.identifier))?.type??Q.type,this.n.validate(Q,V)))}))).flat();return this.J(T,"development",q,!0)}return[]}async scanExistingExtension(q,X,T){const M=await this.P(q,!1,X,!0,T.language,!0,void 0),V=await this.n.scanExtension(M);return!V||!T.includeInvalid&&!V.isValid?null:V}async scanOneOrMultipleExtensions(q,X,T){const M=await this.P(q,!1,X,!0,T.language,!0,void 0),V=await this.n.scanOneOrMultipleExtensions(M);return this.J(V,X,T,!0)}async scanMetadata(q){const X=(0,f.$Eg)(q,"package.json"),T=(await this.w.readFile(X)).value.toString();return JSON.parse(T).__metadata}async updateMetadata(q,X){const T=(0,f.$Eg)(q,"package.json"),M=(await this.w.readFile(T)).value.toString(),V=JSON.parse(M);X.isMachineScoped===!1&&delete X.isMachineScoped,X.isBuiltin===!1&&delete X.isBuiltin,V.__metadata={...V.__metadata,...X},await this.w.writeFile((0,f.$Eg)(q,"package.json"),N.$ge.fromString(JSON.stringify(V,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(q){if(q instanceof k.$Ip&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw q}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const q=await this.scanUserExtensions({includeInvalid:!0});if(q.length)await this.u.addExtensionsToProfile(q.map(X=>[X,X.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,N.$ge.fromString(JSON.stringify([])))}catch(X){(0,o.$Ek)(X)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$0)(X))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(q){this.y.error(q)}finally{this.H=void 0}})()),this.H}async J(q,X,T,M){return T.includeAllVersions||(q=this.L(X===0?q:void 0,X===1?q:void 0,X==="development"?q:void 0,await this.getTargetPlatform(),M)),T.includeInvalid||(q=q.filter(V=>V.isValid)),q.sort((V,J)=>{const Q=I.$nc(V.location.fsPath),K=I.$nc(J.location.fsPath);return Q<K?-1:Q>K?1:0})}L(q,X,T,M,V){const J=(K,C,F)=>{if(K.isValid&&!C.isValid)return!1;if(K.isValid===C.isValid){if(V&&S.gt(K.manifest.version,C.manifest.version))return this.y.debug(`Skipping extension ${C.location.path} with lower version ${C.manifest.version} in favour of ${K.location.path} with version ${K.manifest.version}`),!1;if(S.eq(K.manifest.version,C.manifest.version)){if(K.type===0)return this.y.debug(`Skipping extension ${C.location.path} in favour of system extension ${K.location.path} with same version`),!1;if(K.targetPlatform===M)return this.y.debug(`Skipping extension ${C.location.path} from different target platform ${C.targetPlatform}`),!1}}return F?this.y.warn(`Overwriting user extension ${K.location.path} with ${C.location.path}.`):this.y.debug(`Overwriting user extension ${K.location.path} with ${C.location.path}.`),!0},Q=new y.$km;return q?.forEach(K=>{const C=Q.get(K.identifier.id);(!C||J(C,K,!1))&&Q.set(K.identifier.id,K)}),X?.forEach(K=>{const C=Q.get(K.identifier.id);if(!C&&q&&K.type===0){this.y.debug(`Skipping obsolete system extension ${K.location.path}.`);return}(!C||J(C,K,!1))&&Q.set(K.identifier.id,K)}),T?.forEach(K=>{const C=Q.get(K.identifier.id);(!C||J(C,K,!0))&&Q.set(K.identifier.id,K),Q.set(K.identifier.id,K)}),[...Q.values()]}async M(q,X){this.y.trace("Started scanning system extensions");const T=await this.P(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0),V=await(q&&!T.devMode?this.j:this.n).scanExtensions(T);return this.y.trace("Scanned system extensions:",V.length),V}async N(q,X){const T=this.z.isBuilt?[]:this.C.builtInExtensions;if(!T?.length)return[];this.y.trace("Started scanning dev system extensions");const M=X?await this.O():{},V=[],J=u.URI.file(I.$hc(I.$jc(P.$lg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const K of T){const C=M[K.name]||"marketplace";switch(C){case"disabled":break;case"marketplace":V.push((0,f.$Eg)(J,K.name));break;default:V.push(u.URI.file(C));break}}const Q=await Promise.all(V.map(async K=>this.n.scanExtension(await this.P(K,!1,0,!0,q,!0,void 0))));return this.y.trace("Scanned dev system extensions:",Q.length),(0,L.$Hb)(Q)}async O(){try{const q=await this.w.readFile(this.r);return JSON.parse(q.value.toString())}catch{return{}}}async P(q,X,T,M,V,J,Q){const K=await this.f(V??d.$w),C=await this.Q(q),F=X&&!this.D.extUri.isEqual(q,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,a=F?await this.Q(F):void 0;return new _(q,C,F,a,X,Q,T,M,J,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,V,K)}async Q(q){try{const X=await this.w.stat(q);if(typeof X.mtime=="number")return X.mtime}catch{}}};e.$Op=ee,e.$Op=ee=pe([ie(4,b.$Zk),ie(5,k.$Jp),ie(6,o.$nk),ie(7,i.$kj),ie(8,O.$0h),ie(9,n.$Cj),ie(10,w.$Xk),ie(11,t.$2h)],ee);class _{constructor(q,X,T,M,V,J,Q,K,C,F,a,m,z,U,Z){this.location=q,this.mtime=X,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=M,this.profile=V,this.profileScanOptions=J,this.type=Q,this.excludeObsolete=K,this.validate=C,this.productVersion=F,this.productDate=a,this.productCommit=m,this.devMode=z,this.language=U,this.translations=Z}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,X){return(0,f.$xg)(q.location,X.location)&&q.mtime===X.mtime&&(0,f.$xg)(q.applicationExtensionslocation,X.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&q.profile===X.profile&&R.$nn(q.profileScanOptions,X.profileScanOptions)&&q.type===X.type&&q.excludeObsolete===X.excludeObsolete&&q.validate===X.validate&&q.productVersion===X.productVersion&&q.productDate===X.productDate&&q.productCommit===X.productCommit&&q.devMode===X.devMode&&q.language===X.language&&H.equals(q.translations,X.translations)}}e.$Pp=_;let re=class extends c.$Sc{constructor(q,X,T,M,V){super(),this.f=q,this.g=X,this.h=T,this.j=M,this.m=V}async scanExtensions(q){const X=q.profile?await this.r(q):await this.n(q);let T={};if(q.excludeObsolete&&q.type===1)try{const M=(await this.j.readFile(this.f)).value.toString();T=JSON.parse(M)}catch{}return(0,p.$Sf)(T)?X:X.filter(M=>!T[g.$Po.create(M).toString()])}async n(q){const X=await this.j.resolve(q.location);if(!X.children?.length)return[];const T=await Promise.all(X.children.map(async M=>{if(!M.isDirectory||q.type===1&&(0,f.$Bg)(M.resource).indexOf(".")===0)return null;const V=new _(M.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(V)}));return(0,L.$Hb)(T).sort((M,V)=>M.location.path<V.location.path?-1:1)}async r(q){let X=await this.s(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.h.extUri.isEqual(q.location,q.applicationExtensionslocation)){X=X.filter(M=>!M.metadata?.isApplicationScoped);const T=await this.s(q.applicationExtensionslocation,M=>!!M.metadata?.isBuiltin||!!M.metadata?.isApplicationScoped,q);X.push(...T)}return X}async s(q,X,T){const M=await this.g.scanProfileExtensions(q,T.profileScanOptions);if(!M.length)return[];const V=await Promise.all(M.map(async J=>{if(X(J)){const Q=new _(J.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.profileScanOptions,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(Q,J.metadata)}return null}));return(0,L.$Hb)(V)}async scanOneOrMultipleExtensions(q){try{if(await this.j.exists((0,f.$Eg)(q.location,"package.json"))){const X=await this.scanExtension(q);return X?[X]:[]}else return await this.scanExtensions(q)}catch(X){return this.m.error(`Error scanning extensions at ${q.location.path}:`,(0,A.$0)(X)),[]}}async scanExtension(q,X){try{let T=await this.scanExtensionManifest(q.location);if(T){T.publisher||(T.publisher=y.$em),X=X??T.__metadata,delete T.__metadata;const M=(0,g.$To)(T.publisher,T.name),V=X?.id?{id:M,uuid:X.id}:{id:M},J=X?.isSystem?0:q.type,Q=J===0||!!X?.isBuiltin;T=await this.t(q.location,T,_.createNlsConfiguration(q));const K={type:J,identifier:V,manifest:T,location:q.location,isBuiltin:Q,targetPlatform:X?.targetPlatform??"undefined",metadata:X,isValid:!0,validations:[]};return q.validate?this.validate(K,q):K}}catch(T){q.type!==0&&this.m.error(T)}return null}validate(q,X){let T=!0;const M=(0,s.$5o)(X.productVersion,X.productDate,X.location,q.manifest,q.isBuiltin);for(const[V,J]of M)V===v.default.Error&&(T=!1,this.m.error(this.z(X.location,J)));return q.isValid=T,q.validations=M,q}async scanExtensionManifest(q){const X=(0,f.$Eg)(q,"package.json");let T;try{T=(await this.j.readFile(X)).value.toString()}catch(V){return(0,o.$Ek)(V)!==1&&this.m.error(this.z(q,(0,$.localize)(0,null,X.path,V.message))),null}let M;try{M=JSON.parse(T)}catch{const J=[];(0,E.$_m)(T,J);for(const Q of J)this.m.error(this.z(q,(0,$.localize)(1,null,X.path,Q.offset,Q.length,(0,h.$Lp)(Q.error))));return null}return(0,E.$in)(M)!=="object"?(this.m.error(this.z(q,(0,$.localize)(2,null,X.path))),null):M}async t(q,X,T){const M=await this.u(q,X,T);if(M)try{const V=[],J=await this.w(M.default,V);if(V.length>0)return V.forEach(K=>{this.m.error(this.z(q,(0,$.localize)(3,null,M.default?.path,(0,h.$Lp)(K.error))))}),X;if((0,E.$in)(M)!=="object")return this.m.error(this.z(q,(0,$.localize)(4,null,M.default?.path))),X;const Q=M.values||Object.create(null);return(0,j.$Mp)(this.m,X,Q,J)}catch{}return X}async u(q,X,T){const M=(0,f.$Eg)(q,"package.nls.json"),V=(C,F)=>{F.forEach(a=>{this.m.error(this.z(q,(0,$.localize)(5,null,C?.path,(0,h.$Lp)(a.error))))})},J=C=>{this.m.error(this.z(q,(0,$.localize)(6,null,C?.path)))},Q=`${X.publisher}.${X.name}`,K=T.translations[Q];if(K)try{const C=u.URI.file(K),F=(await this.j.readFile(C)).value.toString(),a=[],m=(0,E.$_m)(F,a);return a.length>0?(V(C,a),{values:void 0,default:M}):(0,E.$in)(m)!=="object"?(J(C),{values:void 0,default:M}):{values:m.contents?m.contents.package:void 0,default:M}}catch{return{values:void 0,default:M}}else{if(!await this.j.exists(M))return;let F;try{F=await this.y(q,T)}catch{return}if(!F.localized)return{values:void 0,default:F.original};try{const a=(await this.j.readFile(F.localized)).value.toString(),m=[],z=(0,E.$_m)(a,m);return m.length>0?(V(F.localized,m),{values:void 0,default:F.original}):(0,E.$in)(z)!=="object"?(J(F.localized),{values:void 0,default:F.original}):{values:z,default:F.original}}catch{return{values:void 0,default:F.original}}}}async w(q,X){if(q)try{const T=(await this.j.readFile(q)).value.toString();return(0,E.$_m)(T,X)}catch{}}y(q,X){return new Promise((T,M)=>{const V=J=>{const Q=(0,f.$Eg)(q,`package.nls.${J}.json`);this.j.exists(Q).then(K=>{K&&T({localized:Q,original:(0,f.$Eg)(q,"package.nls.json")});const C=J.lastIndexOf("-");C===-1?T({localized:(0,f.$Eg)(q,"package.nls.json"),original:null}):(J=J.substring(0,C),V(J))})};if(X.devMode||X.pseudo||!X.language)return T({localized:(0,f.$Eg)(q,"package.nls.json"),original:null});V(X.language)})}z(q,X){return`[${q.path}]: ${X}`}};re=pe([ie(1,k.$Jp),ie(2,w.$Xk),ie(3,o.$nk),ie(4,i.$kj)],re);let se=class extends re{constructor(q,X,T,M,V,J,Q){super(X,M,V,J,Q),this.G=q,this.H=T,this.D=this.B(new D.$1g(3e3)),this.F=this.B(new r.$Sd),this.onDidChangeCache=this.F.event}async scanExtensions(q){const X=this.M(q),T=await this.I(X);if(this.C=q,T&&T.input&&_.equals(T.input,this.C))return this.m.debug("Using cached extensions scan result",q.location.toString()),this.D.trigger(()=>this.L()),T.result.map(V=>(V.location=u.URI.revive(V.location),V));const M=await super.scanExtensions(q);return await this.J(X,{input:q,result:M}),M}async I(q){try{const X=await this.j.readFile(q),T=JSON.parse(X.value.toString());return{result:T.result,input:(0,l.$zh)(T.input)}}catch(X){this.m.debug("Error while reading the extension cache file:",q.path,(0,A.$0)(X))}return null}async J(q,X){try{await this.j.writeFile(q,N.$ge.fromString(JSON.stringify(X)))}catch(T){this.m.debug("Error while writing the extension cache file:",q.path,(0,A.$0)(T))}}async L(){if(!this.C)return;const q=this.M(this.C),X=await this.I(q);if(!X)return;const T=X.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!R.$nn(M,T))try{this.m.info("Invalidating Cache",T,M),await this.j.del(q),this.F.fire()}catch(V){this.m.error(V)}}M(q){const X=this.N(q);return this.h.extUri.joinPath(X.cacheHome,q.type===0?y.$dm:y.$cm)}N(q){return q.type===0?this.H.defaultProfile:q.profile?this.h.extUri.isEqual(q.location,this.G.extensionsResource)?this.G:this.H.profiles.find(X=>this.h.extUri.isEqual(q.location,X.extensionsResource))??this.G:this.H.defaultProfile}};se=pe([ie(2,b.$Zk),ie(3,k.$Jp),ie(4,w.$Xk),ie(5,o.$nk),ie(6,i.$kj)],se);function ue(oe,q){const X=(0,g.$Ro)(oe.manifest.publisher,oe.manifest.name);return{id:X,identifier:new y.$im(X),isBuiltin:oe.type===0,isUserBuiltin:oe.type===1&&oe.isBuiltin,isUnderDevelopment:q,extensionLocation:oe.location,uuid:oe.identifier.uuid,targetPlatform:oe.targetPlatform,...oe.manifest}}e.$Qp=ue;class ce extends ee{constructor(q,X,T,M,V,J,Q,K,C,F,a,m){super(q,X,(0,f.$Eg)(T,".vscode-oss-dev","extensions","control.json"),M,V,J,Q,K,C,F,a,m),this.R=(async()=>{if(d.$z)try{const z=await this.w.readFile(u.URI.file(d.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(q){return this.R}}e.$Rp=ce}),define(te[156],ne([0,1,58,8,34,4,2,15,16,24,6,23]),function(G,e,L,D,R,N,A,E,h,c,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0;let d=class extends A.$Sc{constructor(S,v){super(),this.b=S,this.f=v,this.a=new D.$9g(5)}async postUninstall(S){const v=this.g(S,"uninstall");v&&(this.f.info(S.identifier.id,S.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(v.script,"uninstall",v.args,!0,S),this.f.info("Finished running post uninstall script",S.identifier.id,S.manifest.version)}catch(p){this.f.error("Failed to run post uninstall script",S.identifier.id,S.manifest.version),this.f.error(p)}}));try{await c.Promises.rm(this.m(S))}catch(p){this.f.error("Error while removing extension storage path",S.identifier.id),this.f.error(p)}}g(S,v){const p=`vscode:${v}`;if(S.location.scheme===E.Schemas.file&&S.manifest&&S.manifest.scripts&&typeof S.manifest.scripts[p]=="string"){const u=S.manifest.scripts[p].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(S.identifier.id,S.manifest.version,`${p} should be a node script`),null):{script:(0,h.$jc)(S.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(S,v,p,u,$){return new Promise((O,g)=>{const y=this.j(S,v,p,$);let s;const o=t=>{s&&(clearTimeout(s),s=null),t?g(t):O(void 0)};y.on("error",t=>{o((0,R.$Ni)(t)||"Unknown")}),y.on("exit",(t,i)=>{o(t?`post-${v} process exited with code ${t}`:void 0)}),u&&(s=setTimeout(()=>{s=null,y.kill(),g("timed out")},5e3))})}j(S,v,p,u){const $={silent:!0,execArgv:void 0},O=(0,L.fork)(S,[`--type=extension-post-${v}`,...p],$);O.stdout.setEncoding("utf8"),O.stderr.setEncoding("utf8");const g=N.Event.fromNodeEventEmitter(O.stdout,"data"),y=N.Event.fromNodeEventEmitter(O.stderr,"data");g(t=>this.f.info(u.identifier.id,u.manifest.version,`post-${v}`,t)),y(t=>this.f.error(u.identifier.id,u.manifest.version,`post-${v}`,t));const s=N.Event.any(N.Event.map(g,t=>({data:`%c${t}`,format:[""]})),N.Event.map(y,t=>({data:`%c${t}`,format:["color: red"]})));return N.Event.debounce(s,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(u.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),O}m(S){return(0,h.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,S.identifier.id.toLowerCase())}};e.$Tp=d,e.$Tp=d=pe([ie(0,I.$Zk),ie(1,P.$kj)],d)}),define(te[157],ne([0,1,8,14,20,34,9,4,41,2,31,15,16,17,42,3,11,28,24,48,97,59,18,155,21,27,40,51,142,156,114,135,143,49,12,10,6,32,26,22,23]),function(G,e,L,D,R,N,A,E,h,c,P,I,d,f,S,v,p,u,$,O,g,y,s,o,t,i,n,r,l,k,b,w,j,H,ee,_,re,se,ue,ce,oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=e.$Zp=e.$Yp=e.$Xp=void 0,e.$Xp=(0,_.$4h)(t.$oo);const q=".vsctmp";let X=class extends o.$Ep{constructor(C,F,a,m,z,U,Z,W,le,ae,me,de){super(C,F,me,a,ae,de),this.fb=z,this.gb=U,this.hb=Z,this.ib=le,this.eb=new Map,this.rb=new P.$Bc;const ge=this.B(W.createInstance(k.$Tp));this.bb=this.B(W.createInstance(T,he=>ge.postUninstall(he))),this.cb=this.B(new w.$Vp(de,le,me,this,this.F)),this.db=this.B(W.createInstance(l.$Sp));const fe=this.B(new j.$Wp(this,this.fb,de,U,me,le,a));this.B(fe.onDidChangeExtensionsByAnotherSource(he=>this.qb(he))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Zo)(this.ib,this.F)),this.jb}async zip(C){this.F.trace("ExtensionManagementService#zip",C.identifier.id);const F=await this.pb(C),a=await(0,O.zip)((0,f.$Eg)(this.db.extensionsDownloadDir,(0,u.$ng)()).fsPath,F);return p.URI.file(a)}async unzip(C){return this.F.trace("ExtensionManagementService#unzip",C.toString()),(await this.install(C)).identifier}async getManifest(C){const{location:F,cleanup:a}=await this.lb(C),m=d.$kc(F.fsPath);try{return await(0,b.$Up)(m)}finally{await a()}}getInstalled(C,F=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(C??null,F)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(C){return this.bb.scanUserExtensionAtLocation(C)}async install(C,F={}){this.F.trace("ExtensionManagementService#install",C.toString());const{location:a,cleanup:m}=await this.lb(C);try{const z=await(0,b.$Up)(d.$kc(a.fsPath)),U=(0,i.$To)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,H.$7o)(z.engines.vscode,this.G.version,this.G.date))throw new Error(g.localize(0,null,U,this.G.version));const W=(await this.I([{manifest:z,extension:a,options:F}])).find(({identifier:le})=>(0,i.$Oo)(le,{id:U}));if(W?.local)return W.local;throw W?.error?W.error:(0,o.$Gp)(new Error(`Unknown error while installing extension ${U}`))}finally{await m()}}async installFromLocation(C,F){this.F.trace("ExtensionManagementService#installFromLocation",C.toString());const a=await this.bb.scanUserExtensionAtLocation(C);if(!a)throw new Error(`Cannot find a valid extension from the location ${C.toString()}`);return await this.ub([[a,void 0]],F),this.F.info("Successfully installed extension",a.identifier.id,F.toString()),a}async installExtensionsFromProfile(C,F,a){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",C,F.toString(),a.toString());const m=(await this.bb.scanExtensions(1,F)).filter(z=>C.some(U=>(0,i.$Oo)(U,z.identifier)));if(m.length){const z=await Promise.all(m.map(U=>this.bb.scanMetadata(U,F)));await this.ub(m.map((U,Z)=>[U,z[Z]]),a),this.F.info("Successfully installed extensions",m.map(U=>U.identifier.id),a.toString())}return m}async updateMetadata(C,F,a=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",C.identifier.id),F.isPreReleaseVersion&&(F.preRelease=!0),F.isMachineScoped===!1&&(F.isMachineScoped=void 0),F.isBuiltin===!1&&(F.isBuiltin=void 0),F.pinned===!1&&(F.pinned=void 0),C=await this.bb.updateMetadata(C,F,a),this.cb.invalidate(a),this.w.fire(C),C}async reinstallFromGallery(C){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",C.identifier.id),!this.z.isEnabled())throw new Error(g.localize(1,null));const F=await this.getTargetPlatform(),[a]=await this.z.getExtensions([{...C.identifier,preRelease:C.preRelease}],{targetPlatform:F,compatible:!0},R.CancellationToken.None);if(!a)throw new Error(g.localize(2,null));await this.bb.setUninstalled(C);try{await this.bb.removeUninstalledExtension(C)}catch(m){throw new Error(g.localize(3,null,(0,N.$Ni)(m)))}return this.installFromGallery(a)}ab(C,F,a,m){return this.bb.copyExtension(C,F,a,m)}copyExtensions(C,F){return this.bb.copyExtensions(C,F)}markAsUninstalled(...C){return this.bb.setUninstalled(...C)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(C){this.F.error(C)}}async download(C,F,a){const{location:m}=await this.db.download(C,F,!a);return m}async lb(C){if(C.scheme===I.Schemas.file)return{location:C,async cleanup(){}};this.F.trace("Downloading extension from",C.toString());const F=(0,f.$Eg)(this.db.extensionsDownloadDir,(0,u.$ng)());return await this.hb.download(C,F),this.F.info("Downloaded extension to",F.toString()),{location:F,cleanup:async()=>{try{await this.ib.del(F)}catch(m){this.F.error(m)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(C,F,a){if(p.URI.isUri(F))return new J(C,F,a,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const m=i.$Po.create(F).toString();let z=this.eb.get(m);return z||(this.eb.set(m,z=new V(C,F,a,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),z.waitUntilTaskIsFinished().finally(()=>this.eb.delete(m))),z}$(C,F){return new Q(C,F.profileLocation,this.gb)}async pb(C){const F=async m=>{let z=await $.Promises.readdir(m);z=z.map(W=>d.$jc(m,W));const U=await Promise.all(z.map(W=>$.Promises.stat(W)));let Z=Promise.resolve([]);return U.forEach((W,le)=>{const ae=z[le];W.isFile()&&(Z=Z.then(me=>[...me,ae])),W.isDirectory()&&(Z=Z.then(me=>F(ae).then(de=>[...me,...de])))}),Z};return(await F(C.location.fsPath)).map(m=>({path:`extension/${d.$lc(C.location.fsPath,m)}`,localPath:m}))}async qb({added:C,removed:F}){if(F){const a=C&&this.D.extUri.isEqual(F.profileLocation,C.profileLocation)?F.extensions.filter(m=>C.extensions.every(z=>!(0,i.$Oo)(z,m))):F.extensions;for(const m of a)this.F.info("Extensions removed from another source",m.id,F.profileLocation.toString()),this.u.fire({identifier:m,profileLocation:F.profileLocation})}if(C){const m=(await this.bb.scanExtensions(1,C.profileLocation)).filter(z=>C.extensions.some(U=>(0,i.$Oo)(U,z.identifier)));this.s.fire(m.map(z=>(this.F.info("Extensions added from another source",z.identifier.id,C.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:C.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(F=>this.rb.add(F)));const C=await this.ib.resolve(this.fb.userExtensionsLocation);for(const F of C.children??[])F.isDirectory&&this.rb.add(F.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(F=>this.tb(F)))}async tb(C){if(!C.affects(this.fb.userExtensionsLocation,1))return;const F=[];for(const a of C.rawAdded){if(this.rb.has(a)||!this.D.extUri.isEqual(this.D.extUri.dirname(a),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(a,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(a).startsWith(".")||!(await this.ib.stat(a)).isDirectory)continue;const m=await this.bb.scanUserExtensionAtLocation(a);m&&m.installedTimestamp===void 0&&(this.rb.add(a),F.push(m))}F.length&&(await this.ub(F.map(a=>[a,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",F.map(a=>a.identifier.id)))}async ub(C,F){const a=C.map(m=>m[0]);await this.vb(a),await this.gb.addExtensionsToProfile(C,F),this.s.fire(a.map(m=>({local:m,identifier:m.identifier,operation:1,profileLocation:F})))}async vb(C){const F=await this.bb.getUninstalledExtensions();for(const a of C){const m=i.$Po.create(a);F[m.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",m.id),await this.bb.setInstalled(m),this.F.info("Removed the extension from uninstalled list:",m.id))}}};e.$Yp=X,e.$Yp=X=pe([ie(0,t.$mo),ie(1,ue.$rl),ie(2,re.$kj),ie(3,s.$$h),ie(4,r.$Np),ie(5,n.$Jp),ie(6,y.$4n),ie(7,_.$2h),ie(8,ee.$nk),ie(9,se.$Cj),ie(10,ce.$Xk),ie(11,oe.$Zk)],X);let T=class extends c.$Sc{constructor(C,F,a,m,z,U){super(),this.j=C,this.m=F,this.n=a,this.s=m,this.t=z,this.u=U,this.h=this.B(new E.$Sd),this.onExtract=this.h.event,this.c=(0,f.$Eg)(this.n.userExtensionsLocation,".obsolete"),this.g=new L.$0g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(C,F){const a={includeInvalid:!0,profileLocation:F};let m=[];return C===null||C===0?m.push(...await this.n.scanAllExtensions({includeInvalid:!0},a,!1)):C===1&&m.push(...await this.n.scanUserExtensions(a)),m=C!==null?m.filter(z=>z.type===C):m,Promise.all(m.map(z=>this.F(z)))}async scanAllUserExtensions(C){const F=await this.n.scanUserExtensions({includeAllVersions:!C,includeInvalid:!0});return Promise.all(F.map(a=>this.F(a)))}async scanUserExtensionAtLocation(C){try{const F=await this.n.scanExistingExtension(C,1,{includeInvalid:!0});if(F)return await this.F(F)}catch(F){this.u.error(F)}return null}async extractUserExtension(C,F,a,m,z){const U=C.toString(),Z=p.URI.file(d.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,u.$ng)()}`)),W=p.URI.file(d.$jc(this.n.userExtensionsLocation.fsPath,U));let le=await this.m.exists(W);if(le&&m){try{await this.y(C.id,W,"removeExisting")}catch{throw new t.$no(g.localize(4,null,W.fsPath,C.id),t.ExtensionManagementErrorCode.Delete)}le=!1}if(!le)try{try{this.u.trace(`Started extracting the extension from ${F} to ${W.fsPath}`),await(0,O.$Cp)(F,Z.fsPath,{sourcePath:"extension",overwrite:!0},z),this.u.info(`Extracted extension to ${W}:`,C.id)}catch(ae){let me=t.ExtensionManagementErrorCode.Extract;throw ae instanceof O.$Ap&&(ae.type==="CorruptZip"?me=t.ExtensionManagementErrorCode.CorruptZip:ae.type==="Incomplete"&&(me=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$no(ae.message,me)}await this.n.updateMetadata(Z,a);try{this.u.trace(`Started renaming the extension from ${Z.fsPath} to ${W.fsPath}`),await this.C(Z.fsPath,W.fsPath),this.u.info("Renamed to",W.fsPath)}catch(ae){if(ae.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",C.id);else throw this.u.info(`Rename failed because of ${(0,A.$0)(ae)}. Deleted from extracted location`,Z),ae}this.h.fire(W)}catch(ae){try{await this.m.del(Z,{recursive:!0})}catch{}throw ae}return this.D(W,1)}async scanMetadata(C,F){return F?(await this.w(C,F))?.metadata:this.n.scanMetadata(C.location)}async w(C,F){return(await this.s.scanProfileExtensions(F)).find(m=>(0,i.$Oo)(m.identifier,C.identifier))}async updateMetadata(C,F,a){return a?await this.s.updateMetadata([[C,F]],a):await this.n.updateMetadata(C.location,F),this.D(C.location,C.type,a)}getUninstalledExtensions(){return this.z()}async setUninstalled(...C){const F=C.map(a=>i.$Po.create(a));await this.z(a=>F.forEach(m=>{a[m.toString()]=!0,this.u.info("Marked extension as uninstalled",m.toString())}))}async setInstalled(C){await this.z(F=>delete F[C.toString()])}async removeExtension(C,F){if(this.t.extUri.isEqualOrParent(C.location,this.n.userExtensionsLocation))return this.y(C.identifier.id,C.location,F)}async removeUninstalledExtension(C){await this.removeExtension(C,"uninstalled"),await this.z(F=>delete F[i.$Po.create(C).toString()])}async copyExtension(C,F,a,m){const z=await this.w(C,F),U=await this.w(C,a);return m={...z?.metadata,...m},U?await this.s.updateMetadata([[C,{...U.metadata,...m}]],a):await this.s.addExtensionsToProfile([[C,m]],a),this.D(C.location,C.type,a)}async copyExtensions(C,F){const a=await this.scanExtensions(1,C),m=await Promise.all(a.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,C)]));await this.s.addExtensionsToProfile(m,F)}async y(C,F,a){this.u.trace(`Deleting ${a} extension from disk`,C,F.fsPath);const m=this.t.extUri.joinPath(this.t.extUri.dirname(F),`${this.t.extUri.basename(F)}.${(0,h.$Qi)((0,u.$ng)()).toString(16)}${q}`);await this.C(F.fsPath,m.fsPath),await this.m.del(m,{recursive:!0}),this.u.info(`Deleted ${a} extension from disk`,C,F.fsPath)}async z(C){return this.g.queue(async()=>{let F;try{F=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(m){if((0,ee.$Ek)(m)!==1)throw m}let a={};if(F)try{a=JSON.parse(F)}catch{}return C&&(C(a),Object.keys(a).length?await this.m.writeFile(this.c,D.$ge.fromString(JSON.stringify(a))):await this.m.del(this.c)),a})}async C(C,F){try{await $.Promises.rename(C,F,2*60*1e3)}catch(a){throw new t.$no(a.message||g.localize(5,null,C,F),a.code||t.ExtensionManagementErrorCode.Rename)}}async D(C,F,a){if(a){const z=(await this.n.scanUserExtensions({profileLocation:a})).find(U=>this.t.extUri.isEqual(U.location,C));if(z)return this.F(z)}else{const m=await this.n.scanExistingExtension(C,F,{includeInvalid:!0});if(m)return this.F(m)}throw new Error(g.localize(6,null,C.path))}async F(C){const F=await this.m.resolve(C.location);let a,m;return F.children&&(a=F.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,m=F.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:C.identifier,type:C.type,isBuiltin:C.isBuiltin||!!C.metadata?.isBuiltin,location:C.location,manifest:C.manifest,targetPlatform:C.targetPlatform,validations:C.validations,isValid:C.isValid,readmeUrl:a,changelogUrl:m,publisherDisplayName:C.metadata?.publisherDisplayName||null,publisherId:C.metadata?.publisherId||null,isApplicationScoped:!!C.metadata?.isApplicationScoped,isMachineScoped:!!C.metadata?.isMachineScoped,isPreReleaseVersion:!!C.metadata?.isPreReleaseVersion,preRelease:!!C.metadata?.preRelease,installedTimestamp:C.metadata?.installedTimestamp,updated:!!C.metadata?.updated,pinned:!!C.metadata?.pinned}}async G(){const C=await this.getUninstalledExtensions();if(Object.keys(C).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(C));const F=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),a=new Set;for(const z of F)C[i.$Po.create(z).toString()]||a.add(z.identifier.id.toLowerCase());try{const z=(0,i.$Uo)(F,U=>U.identifier);await L.Promises.settled(z.map(async U=>{const Z=U.sort((W,le)=>S.rcompare(W.manifest.version,le.manifest.version))[0];a.has(Z.identifier.id.toLowerCase())||await this.j(await this.F(Z))}))}catch(z){this.u.error(z)}const m=F.filter(z=>z.metadata&&C[i.$Po.create(z).toString()]);await Promise.allSettled(m.map(z=>this.removeUninstalledExtension(z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let C;try{C=await this.m.resolve(this.n.userExtensionsLocation)}catch(F){(0,ee.$Ek)(F)!==1&&this.u.error(F);return}if(C?.children)try{await Promise.allSettled(C.children.map(async F=>{if(!(!F.isDirectory||!F.name.endsWith(q))){this.u.trace("Deleting the temporarily deleted folder",F.resource.toString());try{await this.m.del(F.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",F.resource.toString())}catch(a){(0,ee.$Ek)(a)!==1&&this.u.error(a)}}}))}catch{}}};e.$Zp=T,e.$Zp=T=pe([ie(1,ee.$nk),ie(2,r.$Np),ie(3,n.$Jp),ie(4,ce.$Xk),ie(5,re.$kj)],T);class M extends o.$Hp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,v.$Mf)(this.options.operation)?this.l:this.options.operation}constructor(C,F,a,m,z,U,Z,W,le){super(),this.identifier=C,this.source=F,this.options=a,this.m=m,this.n=z,this.o=U,this.p=Z,this.q=W,this.s=le,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(C){const[F,a]=await this.x(C);return this.j=F.isBuiltin||F.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[F,a]],this.j),F}async u({zipPath:C,key:F,metadata:a},m,z){let U=await this.v(F);return U||(this.s.trace("Extracting extension...",F.id),U=await this.m.extractUserExtension(F,C,a,m,z),this.s.info("Extracting extension completed.",F.id)),U}async v(C){return await this.w(C)?(this.s.trace("Removing the extension from uninstalled list:",C.id),await this.m.setInstalled(C),this.s.info("Removed the extension from uninstalled list:",C.id),(await this.m.scanAllUserExtensions(!0)).find(m=>i.$Po.create(m).equals(C))):void 0}async w(C){return!!(await this.m.getUninstalledExtensions())[C.toString()]}}class V extends M{constructor(C,F,a,m,z,U,Z,W,le,ae){super(F.identifier,F,a,z,U,Z,W,le,ae),this.y=F,this.z=m}async x(C){const a=(await this.m.scanExtensions(null,this.options.profileLocation)).find(Z=>(0,i.$Oo)(Z.identifier,this.y.identifier));a&&(this.l=3);const m={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||a?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||a?.isMachineScoped,isBuiltin:this.options.isBuiltin||a?.isBuiltin,isSystem:a?.type===0?!0:void 0,updated:!!a,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??a?.pinned,preRelease:this.y.properties.isPreReleaseVersion||((0,v.$Lf)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:a?.preRelease)};if(a?.manifest.version===this.y.version)return[await this.m.updateMetadata(a,m),m];const{location:z,verificationStatus:U}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=U,this.B(z.fsPath),[await this.u({zipPath:z.fsPath,key:i.$Po.create(this.y),metadata:m},!1,C),m]}catch(Z){try{await this.z.delete(z)}catch(W){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,A.$0)(W))}throw Z}}async B(C){try{await(0,b.$Up)(C)}catch(F){throw new t.$no((0,o.$Fp)(F).message,t.ExtensionManagementErrorCode.Invalid)}}}e.$1p=V;class J extends M{constructor(C,F,a,m,z,U,Z,W,le,ae){super({id:(0,i.$To)(C.publisher,C.name)},F,a,z,U,Z,W,le,ae),this.y=C,this.z=F,this.A=m}async h(C){const F=await super.h(C);return this.D(F,C),F}async x(C){const F=new i.$Po(this.identifier,this.y.version),m=(await this.m.scanExtensions(1,this.options.profileLocation)).find(Z=>(0,i.$Oo)(this.identifier,Z.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||m?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||m?.isMachineScoped,isBuiltin:this.options.isBuiltin||m?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??m?.pinned};if(m)if(this.l=3,F.equals(new i.$Po(m.identifier,m.manifest.version)))try{await this.m.removeExtension(m,"existing")}catch{throw new Error(g.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&S.gt(m.manifest.version,this.y.version)&&await this.m.setUninstalled(m);else{const Z=await this.v(F);if(Z)try{await this.m.removeExtension(Z,"existing")}catch{throw new Error(g.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:d.$kc(this.z.fsPath),key:F,metadata:z},!0,C),z]}async D(C,F){try{let[a]=await this.A.getExtensions([{id:C.identifier.id,version:C.manifest.version}],F);if(a||([a]=await this.A.getExtensions([{id:C.identifier.id}],F)),a){const m={id:a.identifier.uuid,publisherDisplayName:a.publisherDisplayName,publisherId:a.publisherId,isPreReleaseVersion:a.properties.isPreReleaseVersion,preRelease:a.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(C,m,this.options.profileLocation)}}catch{}}}class Q extends o.$Hp{constructor(C,F,a){super(),this.extension=C,this.j=F,this.k=a}async h(C){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(te[158],ne([0,1,6,23,22,26,40,12,18,11]),function(G,e,L,D,R,N,A,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eO=void 0;let P=class extends A.$Kp{constructor(d,f,S,v,p,u){super(c.URI.file(d.extensionsPath),f,S,v,p,u)}};e.$eO=P,e.$eO=P=pe([ie(0,h.$$h),ie(1,E.$nk),ie(2,D.$Zk),ie(3,R.$Xk),ie(4,N.$rl),ie(5,L.$kj)],P)}),define(te[159],ne([0,1,11,18,40,51,12,10,6,32,22,23]),function(G,e,L,D,R,N,A,E,h,c,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y0b=void 0;let d=class extends N.$Rp{constructor(S,v,p,u,$,O,g,y){super(L.URI.file($.builtinExtensionsPath),L.URI.file($.extensionsPath),$.userHome,S.defaultProfile,S,v,p,u,$,O,g,y)}};e.$Y0b=d,e.$Y0b=d=pe([ie(0,I.$Zk),ie(1,R.$Jp),ie(2,A.$nk),ie(3,h.$kj),ie(4,D.$$h),ie(5,c.$Cj),ie(6,P.$Xk),ie(7,E.$2h)],d)}),define(te[160],ne([0,1,8,4,2,125,3,86,10,23]),function(G,e,L,D,R,N,A,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$ip=e.$hp=e.$gp=void 0,e.$gp="__$__isNewStorageMarker",e.$hp="__$__targetStorageMarker",e.$ip=(0,h.$3h)("storageService");var P;(function($){$[$.NONE=0]="NONE",$[$.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var I;(function($){$[$.APPLICATION=-1]="APPLICATION",$[$.PROFILE=0]="PROFILE",$[$.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var d;(function($){$[$.USER=0]="USER",$[$.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function f($){const O=$.get(e.$hp);if(O)try{return JSON.parse(O)}catch{}return Object.create(null)}e.$jp=f;class S extends R.$Sc{static{this.a=60*1e3}constructor(O={flushInterval:S.a}){super(),this.m=O,this.b=this.B(new D.$Vd),this.c=this.B(new D.$Vd),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$Sd),this.onWillSaveState=this.f.event,this.h=this.B(new L.$ch(()=>this.n(),this.m.flushInterval)),this.j=this.B(new R.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(O,g,y){return D.Event.filter(this.b.event,s=>s.scope===O&&(g===void 0||s.key===g),y)}n(){this.j.value=(0,L.$gh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,R.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,N.mark)("code/willInitStorage");try{await this.O()}finally{(0,N.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(O,g){const{key:y,external:s}=g;if(y===e.$hp){switch(O){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:O})}else this.b.fire({scope:O,key:y,target:this.J(O)[y],external:s})}w(O){this.f.fire({reason:O})}get(O,g,y){return this.P(g)?.get(O,y)}getBoolean(O,g,y){return this.P(g)?.getBoolean(O,y)}getNumber(O,g,y){return this.P(g)?.getNumber(O,y)}getObject(O,g,y){return this.P(g)?.getObject(O,y)}storeAll(O,g){this.y(()=>{for(const y of O)this.store(y.key,y.value,y.scope,y.target,g)})}store(O,g,y,s,o=!1){if((0,A.$Of)(g)){this.remove(O,y,o);return}this.y(()=>{this.z(O,y,s),this.P(y)?.set(O,g,o)})}remove(O,g,y=!1){this.y(()=>{this.z(O,g,void 0),this.P(g)?.delete(O,y)})}y(O){this.b.pause(),this.c.pause();try{O()}finally{this.b.resume(),this.c.resume()}}keys(O,g){const y=[],s=this.J(O);for(const o of Object.keys(s))s[o]===g&&y.push(o);return y}z(O,g,y,s=!1){const o=this.J(g);typeof y=="number"?o[O]!==y&&(o[O]=y,this.P(g)?.set(e.$hp,JSON.stringify(o),s)):typeof o[O]=="number"&&(delete o[O],this.P(g)?.set(e.$hp,JSON.stringify(o),s))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(O){switch(O){case-1:return this.I;case 0:return this.G;default:return this.D}}L(O){const g=this.P(O);return g?f(g):Object.create(null)}isNew(O){return this.getBoolean(e.$gp,O)===!0}async flush(O=P.NONE){this.f.fire({reason:O});const g=this.P(-1),y=this.P(0),s=this.P(1);switch(O){case P.NONE:await L.Promises.settled([g?.whenFlushed()??Promise.resolve(),y?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await L.Promises.settled([g?.flush(0)??Promise.resolve(),y?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const O=this.P(-1)?.items??new Map,g=this.P(0)?.items??new Map,y=this.P(1)?.items??new Map;return u(O,g,y,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(O){return await this.flush(),this.P(O)?.optimize()}async switch(O,g){return this.w(P.NONE),(0,c.$Yk)(O)?this.R(O,g):this.S(O,g)}M(O,g){return!(O.id===g.id||v(g)&&v(O))}N(O,g,y){this.y(()=>{const s=new Set;for(const[o,t]of O)s.add(o),g.get(o)!==t&&this.u(y,{key:o,external:!0});for(const[o]of g.items)s.has(o)||this.u(y,{key:o,external:!0})})}}e.$kp=S;function v($){return $.isDefault||!!$.useDefaultFlags?.globalState}e.$lp=v;class p extends S{constructor(){super(),this.U=this.B(new E.$ep(new E.$fp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new E.$ep(new E.$fp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new E.$ep(new E.$fp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(O=>this.u(1,O))),this.B(this.W.onDidChangeStorage(O=>this.u(0,O))),this.B(this.U.onDidChangeStorage(O=>this.u(-1,O)))}P(O){switch(O){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(O){switch(O){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(O){return!1}}e.$mp=p;async function u($,O,g,y,s,o){const t=H=>{try{return JSON.parse(H)}catch{return H}},i=new Map,n=new Map;$.forEach((H,ee)=>{i.set(ee,H),n.set(ee,t(H))});const r=new Map,l=new Map;O.forEach((H,ee)=>{r.set(ee,H),l.set(ee,t(H))});const k=new Map,b=new Map;g.forEach((H,ee)=>{k.set(ee,H),b.set(ee,t(H))}),console.group(y!==s?`Storage: Application (path: ${y})`:`Storage: Application & Profile (path: ${y}, default profile)`);const w=[];if(i.forEach((H,ee)=>{w.push({key:ee,value:H})}),console.table(w),console.groupEnd(),console.log(n),y!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const H=[];r.forEach((ee,_)=>{H.push({key:_,value:ee})}),console.table(H),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${o})`);const j=[];k.forEach((H,ee)=>{j.push({key:ee,value:H})}),console.table(j),console.groupEnd(),console.log(b)}e.$np=u}),define(te[161],ne([0,1,19,20,9,13,35,3,11,25,18,21,27,49,12,6,32,44,144,160,26,174]),function(G,e,L,D,R,N,A,E,h,c,P,I,d,f,S,v,p,u,$,O,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=void 0;const s=N.$o?"web":(0,I.$io)(N.$u,A.$ec),o="X-Market-Search-Activity-Id";var t;(function(a){a[a.None=0]="None",a[a.IncludeVersions=1]="IncludeVersions",a[a.IncludeFiles=2]="IncludeFiles",a[a.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",a[a.IncludeSharedAccounts=8]="IncludeSharedAccounts",a[a.IncludeVersionProperties=16]="IncludeVersionProperties",a[a.ExcludeNonValidated=32]="ExcludeNonValidated",a[a.IncludeInstallationTargets=64]="IncludeInstallationTargets",a[a.IncludeAssetUri=128]="IncludeAssetUri",a[a.IncludeStatistics=256]="IncludeStatistics",a[a.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",a[a.Unpublished=4096]="Unpublished",a[a.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function i(...a){return String(a.reduce((m,z)=>m|z,0))}var n;(function(a){a[a.Tag=1]="Tag",a[a.ExtensionId=4]="ExtensionId",a[a.Category=5]="Category",a[a.ExtensionName=7]="ExtensionName",a[a.Target=8]="Target",a[a.Featured=9]="Featured",a[a.SearchText=10]="SearchText",a[a.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},b={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class w{constructor(m=b){this.d=m}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(m,z=this.d.pageSize){return new w({...this.d,pageNumber:m,pageSize:z})}withFilter(m,...z){const U=[...this.d.criteria,...z.length?z.map(Z=>({filterType:m,value:Z})):[{filterType:m}]];return new w({...this.d,criteria:U})}withSortBy(m){return new w({...this.d,sortBy:m})}withSortOrder(m){return new w({...this.d,sortOrder:m})}withFlags(...m){return new w({...this.d,flags:m.reduce((z,U)=>z|U,0)})}withAssetTypes(...m){return new w({...this.d,assetTypes:m})}withSource(m){return new w({...this.d,source:m})}get raw(){const{criteria:m,pageNumber:z,pageSize:U,sortBy:Z,sortOrder:W,flags:le,assetTypes:ae}=this.d;return{filters:[{criteria:m,pageNumber:z,pageSize:U,sortBy:Z,sortOrder:W}],assetTypes:ae,flags:le}}get searchText(){const m=this.d.criteria.filter(z=>z.filterType===n.SearchText)[0];return m&&m.value?m.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(m=>String(m.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function j(a,m){const z=(a||[]).filter(U=>U.statisticName===m)[0];return z?z.value:0}function H(a){const m="Microsoft.VisualStudio.Code.Translation.";return a.files.filter(U=>U.assetType.indexOf(m)===0).reduce((U,Z)=>{const W=re(a,Z.assetType);return W&&U.push([Z.assetType.substring(m.length),W]),U},[])}function ee(a){if(a.properties){const m=a.properties.filter(Z=>Z.key===r.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),U=m.filter(Z=>z.test(Z.value))[0];return U?{uri:U.value,fallbackUri:U.value}:null}return re(a,r.Repository)}function _(a){return{uri:`${a.fallbackAssetUri}/${r.VSIX}?redirect=true${a.targetPlatform?`&targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${r.VSIX}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}}function re(a,m){return a.files.filter(U=>U.assetType===m)[0]?{uri:`${a.assetUri}/${m}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${m}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}:null}function se(a,m){const z=a.properties?a.properties.filter(Z=>Z.key===m):[],U=z.length>0&&z[0].value;return U?U.split(",").map(Z=>(0,d.$So)(Z)):[]}function ue(a){const m=a.properties?a.properties.filter(z=>z.key===l.Engine):[];return m.length>0&&m[0].value||""}function ce(a){const m=a.properties?a.properties.filter(z=>z.key===l.PreRelease):[];return m.length>0&&m[0].value==="true"}function oe(a){const m=a.properties?a.properties.filter(U=>U.key===l.LocalizedLanguages):[],z=m.length>0&&m[0].value||"";return z?z.split(","):[]}function q(a){return a.properties?.find(m=>m.key===l.SponsorLink)?.value}function X(a){return a.indexOf("preview")!==-1}function T(a){return a.targetPlatform?(0,I.$ho)(a.targetPlatform):"undefined"}function M(a){const m=(0,L.$Mb)(a.versions.map(T)),z=!!a.tags?.includes(I.$co),U=m.indexOf("web");return z?U===-1&&m.push("web"):U!==-1&&m.splice(U,1),m}function V(a,m){for(let z=0;z<a.length;z++){const U=a[z];if(U.version===a[z-1]?.version){let Z=z;if(T(U)===m)for(;Z>0&&a[Z-1].version===U.version;)Z--;Z!==z&&(a.splice(z,1),a.splice(Z,0,U))}}return a}e.$qp=V;function J(a,m,z){a.telemetryData={index:m,querySource:z,queryActivityId:a.queryContext?.[o]}}function Q(a,m,z,U){const Z=a.versions[0],W={manifest:re(m,r.Manifest),readme:re(m,r.Details),changelog:re(m,r.Changelog),license:re(m,r.License),repository:ee(m),download:_(m),icon:re(m,r.Icon),signature:re(m,r.Signature),coreTranslations:H(m)};return{identifier:{id:(0,d.$To)(a.publisher.publisherName,a.extensionName),uuid:a.extensionId},name:a.extensionName,version:m.version,displayName:a.displayName,publisherId:a.publisher.publisherId,publisher:a.publisher.publisherName,publisherDisplayName:a.publisher.displayName,publisherDomain:a.publisher.domain?{link:a.publisher.domain,verified:!!a.publisher.isDomainVerified}:void 0,publisherSponsorLink:q(Z),description:a.shortDescription||"",installCount:j(a.statistics,"install"),rating:j(a.statistics,"averagerating"),ratingCount:j(a.statistics,"ratingcount"),categories:a.categories||[],tags:a.tags||[],releaseDate:Date.parse(a.releaseDate),lastUpdated:Date.parse(a.lastUpdated),allTargetPlatforms:z,assets:W,properties:{dependencies:se(m,l.Dependency),extensionPack:se(m,l.ExtensionPack),engine:ue(m),localizedLanguages:oe(m),targetPlatform:T(m),isPreReleaseVersion:ce(m)},hasPreReleaseVersion:ce(Z),hasReleaseVersion:!0,preview:X(a.flags),isSigned:!!W.signature,queryContext:U}}let K=class{constructor(m,z,U,Z,W,le,ae,me){this.k=z,this.l=U,this.n=Z,this.o=W,this.q=le,this.u=ae,this.w=me;const de=ae.extensionsGallery,ge=de?.servicePPEUrl&&me.getValue("_extensionsGallery.enablePPE");this.d=ge?de.servicePPEUrl:de?.serviceUrl,this.g=ge?void 0:de?.searchUrl,this.h=de?.controlUrl,this.j=(0,$.$pp)(ae.version,ae,this.n,this.w,this.q,m,this.o)}x(m=""){return`${this.d}${m}`}isEnabled(){return!!this.d}async getExtensions(m,z,U){const Z=D.CancellationToken.isCancellationToken(z)?{}:z,W=D.CancellationToken.isCancellationToken(z)?z:U,le=[],ae=[],me=[],de=[];let ge=!0;for(const we of m){we.uuid?ae.push(we.uuid):le.push(we.id);const be=!!(we.version||we.preRelease);me.push({id:we.id,uuid:we.uuid,includePreRelease:be}),we.version&&de.push({id:we.id,uuid:we.uuid,version:we.version}),ge=ge&&!!we.hasPreRelease&&!be}if(!ae.length&&!le.length)return[];let fe=new w().withPage(1,m.length);ae.length&&(fe=fe.withFilter(n.ExtensionId,...ae)),le.length&&(fe=fe.withFilter(n.ExtensionName,...le)),(Z.queryAllVersions||ge)&&(fe=fe.withFlags(fe.flags,t.IncludeVersions)),Z.source&&(fe=fe.withSource(Z.source));const{extensions:he}=await this.z(fe,{targetPlatform:Z.targetPlatform??s,includePreRelease:me,versions:de,compatible:!!Z.compatible},W);return Z.source&&he.forEach((we,be)=>J(we,be,Z.source)),he}async getCompatibleExtension(m,z,U){if((0,I.$jo)(m.allTargetPlatforms,U))return null;if(await this.isExtensionCompatible(m,z,U))return m;const Z=new w().withFlags(t.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,m.identifier.uuid),{extensions:W}=await this.z(Z,{targetPlatform:U,compatible:!0,includePreRelease:z},D.CancellationToken.None);return W[0]||null}async isExtensionCompatible(m,z,U){if(!(0,I.$ko)(m.properties.targetPlatform,m.allTargetPlatforms,U)||!z&&m.properties.isPreReleaseVersion)return!1;let Z=m.properties.engine;if(!Z){const W=await this.getManifest(m,D.CancellationToken.None);if(!W)throw new Error("Manifest was not found");Z=W.engines.vscode}return(0,f.$7o)(Z,this.u.version,this.u.date)}async y(m,z,U,Z,W){if(!(0,I.$ko)(T(m),Z,W)||z!=="any"&&ce(m)!==(z==="prerelease"))return!1;if(U)try{const le=await this.E(m);if(!(0,f.$7o)(le,this.u.version,this.u.date))return!1}catch(le){return this.l.error(`Error while getting the engine for the version ${m.version}.`,(0,R.$0)(le)),!1}return!0}async query(m,z){let U=m.text||"";const Z=m.pageSize??50;let W=new w().withPage(1,Z);U?(U=U.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Category,he||fe),"")),U=U.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Tag,he||fe),"")),U=U.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(n.Featured),"")),U=U.trim(),U&&(U=U.length<200?U:U.substring(0,200),W=W.withFilter(n.SearchText,U)),W=W.withSortBy(0)):m.ids?W=W.withFilter(n.ExtensionId,...m.ids):m.names?W=W.withFilter(n.ExtensionName,...m.names):W=W.withSortBy(4),typeof m.sortBy=="number"&&(W=W.withSortBy(m.sortBy)),typeof m.sortOrder=="number"&&(W=W.withSortOrder(m.sortOrder)),m.source&&(W=W.withSource(m.source));const le=async(ge,fe)=>{const{extensions:he,total:we}=await this.z(ge,{targetPlatform:s,compatible:!1,includePreRelease:!!m.includePreRelease},fe);return he.forEach((be,ke)=>J(be,(ge.pageNumber-1)*ge.pageSize+ke,m.source)),{extensions:he,total:we}},{extensions:ae,total:me}=await le(W,z),de=async(ge,fe)=>{if(fe.isCancellationRequested)throw new R.$5;const{extensions:he}=await le(W.withPage(ge+1),fe);return he};return{firstPage:ae,total:me,pageSize:W.pageSize,getPage:de}}async z(m,z,U){const Z=m.flags;m.flags&t.IncludeLatestVersionOnly&&m.flags&t.IncludeVersions&&(m=m.withFlags(m.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(m.flags&t.IncludeLatestVersionOnly)&&!(m.flags&t.IncludeVersions)&&(m=m.withFlags(m.flags,t.IncludeLatestVersionOnly)),z.versions?.length&&(m=m.withFlags(m.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),m=m.withFlags(m.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:W,total:le,context:ae}=await this.B(m,U);if(!(m.flags&t.IncludeLatestVersionOnly)){const fe=[];for(const he of W){const we=await this.A(he,z,ae);we&&fe.push(we)}return{extensions:fe,total:le}}const de=[],ge=new Map;for(let fe=0;fe<W.length;fe++){const he=W[fe],we={id:(0,d.$To)(he.publisher.publisherName,he.extensionName),uuid:he.extensionId},be=(0,E.$Lf)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(Ce=>(0,d.$Oo)(Ce,we))?.includePreRelease;if(z.compatible&&(0,I.$jo)(M(he),z.targetPlatform))continue;const ke=await this.A(he,z,ae);!ke||ke.properties.isPreReleaseVersion&&(!be||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==z.targetPlatform&&ke.hasPreReleaseVersion?ge.set(he.extensionId,fe):de.push([fe,ke])}if(ge.size){const fe=new y.$Od,he=new w().withFlags(Z&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ge.size).withFilter(n.ExtensionId,...ge.keys()),{extensions:we}=await this.z(he,z,U);this.o.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:ge.size});for(const be of we){const ke=ge.get(be.identifier.uuid);de.push([ke,be])}}return{extensions:de.sort((fe,he)=>fe[0]-he[0]).map(([,fe])=>fe),total:le}}async A(m,z,U){const Z={id:(0,d.$To)(m.publisher.publisherName,m.extensionName),uuid:m.extensionId},W=z.versions?.find(de=>(0,d.$Oo)(de,Z))?.version,le=(0,E.$Lf)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(de=>(0,d.$Oo)(de,Z))?.includePreRelease,ae=M(m),me=V(m.versions,z.targetPlatform);if(z.compatible&&(0,I.$jo)(ae,z.targetPlatform))return null;for(let de=0;de<me.length;de++){const ge=me[de];if(!(W&&ge.version!==W)){if(await this.y(ge,le?"any":"release",z.compatible,ae,z.targetPlatform))return Q(m,ge,ae,U);if(W&&ge.version===W)return null}}return W||z.compatible?null:Q(m,m.versions[0],ae)}async B(m,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");m=m.withFlags(m.flags,t.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(t.Unpublished));const U=await this.j,Z=JSON.stringify(m.raw),W={...U,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},le=new y.$Od;let ae,me,de=0;try{if(ae=await this.k.request({type:"POST",url:this.g&&m.criteria.some(fe=>fe.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:Z,headers:W},z),ae.res.statusCode&&ae.res.statusCode>=400&&ae.res.statusCode<500)return{galleryExtensions:[],total:de};const ge=await(0,u.$bp)(ae);if(ge){const fe=ge.results[0],he=fe.extensions,we=fe.resultMetadata&&fe.resultMetadata.filter(be=>be.metadataType==="ResultCount")[0];return de=we&&we.metadataItems.filter(be=>be.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:de,context:{[o]:ae.res.headers.activityid}}}return{galleryExtensions:[],total:de}}catch(ge){throw me=ge,ge}finally{this.o.publicLog2("galleryService:query",{...m.telemetryData,requestBodySize:String(Z.length),duration:le.elapsed(),success:!!ae&&(0,u.$0o)(ae),responseBodySize:ae?.res.headers["Content-Length"],statusCode:ae?String(ae.res.statusCode):void 0,errorCode:me?(0,R.$4)(me)?"canceled":(0,R.$0)(me).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(m,z,U,Z){if(!this.isEnabled())return;const W=N.$o?this.x(`/itemName/${m}.${z}/version/${U}/statType/${Z==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${m}/extensions/${z}/${U}/stats?statType=${Z}`),le=N.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.j,Accept:le};try{await this.k.request({type:"POST",url:W,headers:me},D.CancellationToken.None)}catch{}}async download(m,z,U){this.l.trace("ExtensionGalleryService#download",m.identifier.id);const Z=(0,d.$Wo)(m),W=new Date().getTime(),le=fe=>this.o.publicLog("galleryService:downloadVSIX",{...Z,duration:fe}),ae=U===2?"install":U===3?"update":"",me=ae?{uri:`${m.assets.download.uri}${h.URI.parse(m.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${m.assets.download.fallbackUri}${h.URI.parse(m.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:m.assets.download,de=m.queryContext?.[o]?{[o]:m.queryContext[o]}:void 0,ge=await this.D(me,de?{headers:de}:void 0);await this.q.writeFile(z,ge.stream),le(new Date().getTime()-W)}async downloadSignatureArchive(m,z){if(!m.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",m.identifier.id);const U=await this.D(m.assets.signature);await this.q.writeFile(z,U.stream)}async getReadme(m,z){if(m.assets.readme){const U=await this.D(m.assets.readme,{},z);return await(0,u.$ap)(U)||""}return""}async getManifest(m,z){if(m.assets.manifest){const U=await this.D(m.assets.manifest,{},z),Z=await(0,u.$ap)(U);return Z?JSON.parse(Z):null}return null}async C(m,z){const U=re(m,r.Manifest);if(!U)throw new Error("Manifest was not found");const Z={"Accept-Encoding":"gzip"},W=await this.D(U,{headers:Z});return await(0,u.$bp)(W)}async getCoreTranslation(m,z){const U=m.assets.coreTranslations.filter(Z=>Z[0]===z.toUpperCase())[0];if(U){const Z=await this.D(U[1]),W=await(0,u.$ap)(Z);return W?JSON.parse(W):null}return null}async getChangelog(m,z){if(m.assets.changelog){const U=await this.D(m.assets.changelog,{},z);return await(0,u.$ap)(U)||""}return""}async getAllCompatibleVersions(m,z,U){let Z=new w().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);m.identifier.uuid?Z=Z.withFilter(n.ExtensionId,m.identifier.uuid):Z=Z.withFilter(n.ExtensionName,m.identifier.id);const{galleryExtensions:W}=await this.B(Z,D.CancellationToken.None);if(!W.length)return[];const le=M(W[0]);if((0,I.$jo)(le,U))return[];const ae=[];await Promise.all(W[0].versions.map(async ge=>{try{await this.y(ge,z?"any":"release",!0,le,U)&&ae.push(ge)}catch{}}));const me=[],de=new Set;for(const ge of V(ae,U))de.has(ge.version)||(de.add(ge.version),me.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:ce(ge)}));return me}async D(m,z={},U=D.CancellationToken.None){const Z=await this.j,W={type:"GET"},le={...Z,...z.headers||{}};z={...z,...W,headers:le};const ae=m.uri,me=m.fallbackUri,de={...z,url:ae};try{const ge=await this.k.request(de,U);if(ge.res.statusCode===200)return ge;const fe=await(0,u.$ap)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${fe}`)}catch(ge){if((0,R.$4)(ge))throw ge;const fe=(0,R.$0)(ge);this.o.publicLog2("galleryService:cdnFallback",{url:ae,message:fe});const he={...z,url:me};return this.k.request(he,U)}}async E(m){let z=ue(m);if(!z){const U=await this.C(m,D.CancellationToken.None);if(!U)throw new Error("Manifest was not found");z=U.engines.vscode}return z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const m=await this.k.request({type:"GET",url:this.h},D.CancellationToken.None);if(m.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,u.$bp)(m),U=[],Z={},W=[];if(z){for(const le of z.malicious)U.push({id:le});if(z.migrateToPreRelease)for(const[le,ae]of Object.entries(z.migrateToPreRelease))(!ae.engine||(0,f.$7o)(ae.engine,this.u.version,this.u.date))&&(Z[le.toLowerCase()]={disallowInstall:!0,extension:{id:ae.id,displayName:ae.displayName,autoMigrate:{storage:!!ae.migrateStorage},preRelease:!0}});if(z.deprecated)for(const[le,ae]of Object.entries(z.deprecated))ae&&(Z[le.toLowerCase()]=(0,E.$Lf)(ae)?{}:ae);if(z.search)for(const le of z.search)W.push(le)}return{malicious:U,deprecated:Z,search:W}}};K=pe([ie(1,u.$8o),ie(2,v.$kj),ie(3,P.$0h),ie(4,g.$rl),ie(5,S.$nk),ie(6,p.$Cj),ie(7,c.$wi)],K);let C=class extends K{constructor(m,z,U,Z,W,le,ae,me){super(m,z,U,Z,W,le,ae,me)}};e.$rp=C,e.$rp=C=pe([ie(0,O.$ip),ie(1,u.$8o),ie(2,v.$kj),ie(3,P.$0h),ie(4,g.$rl),ie(5,S.$nk),ie(6,p.$Cj),ie(7,c.$wi)],C);let F=class extends K{constructor(m,z,U,Z,W,le,ae){super(void 0,m,z,U,Z,W,le,ae)}};e.$sp=F,e.$sp=F=pe([ie(0,u.$8o),ie(1,v.$kj),ie(2,P.$0h),ie(3,g.$rl),ie(4,S.$nk),ie(5,p.$Cj),ie(6,c.$wi)],F)}),define(te[162],ne([0,1,11,18,12,6,140,22,23,3,68]),function(G,e,L,D,R,N,A,E,h,c,P){"use strict";var I,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$dO=e.$cO=e.$bO=void 0;let f=class extends h.$3k{static{I=this}static{this.a="profileAssociationsMigration"}constructor(u,$,O,g,y){super(O,g,$,y),this.U=u,this.W=O}O(){return this.U.getItem(I.b,[]).map($=>({...$,location:(0,c.$Ff)($.location)?this.w.extUri.joinPath(this.profilesHome,$.location):L.URI.revive($.location)}))}Q(){const u=this.U.getItem(I.c,{});return this.U.getItem(I.a,!1)?u:this.N(u)}S(){return this.w.extUri.joinPath(L.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$bO=f,e.$bO=f=I=pe([ie(0,A.$9N),ie(1,E.$Xk),ie(2,D.$$h),ie(3,R.$nk),ie(4,N.$kj)],f);let S=d=class extends f{constructor(u,$,O,g,y){super(u,$,O,g,y),this.$=u}P(u){u.length?this.$.setItem(d.b,u.map($=>({...$,location:this.w.extUri.basename($.location)}))):this.$.removeItem(d.b)}O(){const u=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(u),this.$.setItem("userDataProfilesMigration",!0)),u}R(u){u.emptyWindows||u.workspaces?this.$.setItem(d.c,u):this.$.removeItem(d.c)}Q(){const u="workspaceAndProfileInfo",$=this.$.getItem(u,void 0);if($){this.$.removeItem(u);const g=$.reduce((y,{workspace:s,profile:o})=>(y[L.URI.revive(s).toString()]=L.URI.revive(o).toString(),y),{});this.$.setItem(d.c,{workspaces:g})}const O=super.Q();return this.$.getItem(d.a,!1)||(this.R(O),this.$.setItem(d.a,!0)),O}};e.$cO=S,e.$cO=S=d=pe([ie(0,A.$0N),ie(1,E.$Xk),ie(2,D.$$h),ie(3,R.$nk),ie(4,N.$kj)],S);let v=class extends S{constructor(u,$,O,g){super(new P.$aO(0,$,g,O),u,$,O,g)}async init(){return await this.$.init(),super.init()}};e.$dO=v,e.$dO=v=pe([ie(0,E.$Xk),ie(1,D.$$h),ie(2,R.$nk),ie(3,N.$kj)],v)}),define(te[163],ne([0,1,138,8,14,9,3,25,18,139,6,44,137,175]),function(G,e,L,D,R,N,A,E,h,c,P,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=e.$br=void 0;let S=class extends I.$9o{constructor($,O,g,y){super(y),this.m=$,this.n=O,this.r=g,this.s(),this.B($.onDidChangeConfiguration(s=>{s.affectsConfiguration("http")&&this.s()}))}s(){const $=this.m.getValue("http");this.f=$?.proxy,this.g=!!$?.proxyStrictSSL,this.h=$?.proxyAuthorization}async request($,O){const{f:g,g:y}=this;let s;try{s=await(0,c.$9l)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,N.$0)(i)))}const o={...process.env,...s},t=$.agent?$.agent:await(0,d.$ar)($.url||"",o,{proxyUrl:g,strictSSL:y});return $.agent=t,$.strictSSL=y,this.h&&($.headers={...$.headers||{},"Proxy-Authorization":this.h}),this.c($.isChromiumNetwork?"electron":"node",$,()=>p($,O))}async resolveProxy($){}async loadCertificates(){return(await new Promise((O,g)=>{G(["@vscode/proxy-agent"],O,g)})).loadSystemCertificates({log:this.r})}};e.$br=S,e.$br=S=pe([ie(0,E.$wi),ie(1,h.$$h),ie(2,P.$kj),ie(3,P.$lj)],S);async function v(u){return((0,L.parse)(u.url).protocol==="https:"?await new Promise((g,y)=>{G(["https"],g,y)}):await new Promise((g,y)=>{G(["http"],g,y)})).request}async function p(u,$){return D.Promises.withAsyncBody(async(O,g)=>{const y=(0,L.parse)(u.url),s=u.getRawRequest?u.getRawRequest(u):await v(u),o={hostname:y.hostname,port:y.port?parseInt(y.port):y.protocol==="https:"?443:80,protocol:y.protocol,path:y.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,A.$Lf)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(o.auth=u.user+":"+u.password);const t=s(o,i=>{const n=(0,A.$Jf)(u.followRedirects)?u.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)p({...u,url:i.headers.location,followRedirects:n-1},$).then(O,g);else{let r=i;!u.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,f.createGunzip)())),O({res:i,stream:(0,R.$ve)(r)})}});t.on("error",g),u.timeout&&t.setTimeout(u.timeout),u.isChromiumNetwork&&t.removeHeader("Content-Length"),u.data&&typeof u.data=="string"&&t.write(u.data),t.end(),$.onCancellationRequested(()=>{t.abort(),g(new N.$5)})})}e.$cr=p}),define(te[176],ne([0,1,33,8,34,9,2,15,16,13,35,11,24,25,134,59,136,18,112,161,21,60,141,40,51,157,159,12,124,126,50,122,63,64,145,6,130,38,131,148,32,44,163,68,69,26,147,39,149,150,22,152,23,162,151,158,127,129,5,153]),function(G,e,L,D,R,N,A,E,h,c,P,I,d,f,S,v,p,u,$,O,g,y,s,o,t,i,n,r,l,k,b,w,j,H,ee,_,re,se,ue,ce,oe,q,X,T,M,V,J,Q,K,C,F,a,m,z,U,Z,W,le,ae,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class de extends A.$Sc{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,we]=await this.f();return he.invokeFunction(async be=>{const ke=be.get(_.$kj),Ce=be.get(r.$nk),B=be.get(u.$$h),Y=be.get(m.$Zk);ke.info("CLI main",this.b),this.g(ke),await this.h(B,Ce,Y,he),await Promise.all(we.map(x=>{(0,D.$Ug)(x.flush(),1e3)}))})}async f(){const he=new j.$1h,we={_serviceBrand:void 0,...ce.default};he.set(oe.$Cj,we);const be=new $.$ym(this.b,we);he.set(u.$$h,be),await Promise.all([be.appSettingsHome.with({scheme:E.Schemas.file}).fsPath,be.extensionsPath].map(Ne=>Ne?d.Promises.mkdir(Ne,{recursive:!0}):void 0));const ke=new le.$8N((0,_.$yj)(be),be.logsHome);he.set(_.$lj,ke);const Ce=this.B(ke.createLogger("cli",{name:(0,ae.localize)(0,null)})),B=[];ke.getLogLevel()===_.LogLevel.Trace&&B.push(new _.$sj(ke.getLogLevel()));const Y=this.B(new W.$fO(Ce,B));he.set(_.$kj,Y);const x=this.B(new l.$3p(Y));he.set(r.$nk,x);const $e=this.B(new k.$pq(Y));x.registerProvider(E.Schemas.file,$e);const ye=new a.$Or(x);he.set(F.$Xk,ye);const Re=new T.$_N(1,be,Y,x),Se=new z.$bO(Re,ye,be,x,Y);he.set(m.$Zk,Se),x.registerProvider(E.Schemas.vscodeUserData,new me.$n$b(E.Schemas.file,$e,E.Schemas.vscodeUserData,Se,ye,Y));const Le=c.$i&&we.win32RegValueName?this.B(new ue.$l$b(Y,we.win32RegValueName)):be.policyFile?this.B(new re.$m$b(be.policyFile,x,Y)):new se.$zn;he.set(se.$xn,Le);const Ie=this.B(new S.$Zn(Se.defaultProfile.settingsResource,x,Le,Y));he.set(f.$wi,Ie),await Promise.all([Re.init(),Ie.initialize()]);let Ae;try{Ae=await(0,U.$20b)(Re,Y)}catch(Ne){Ne.code!=="ENOENT"&&Y.error(Ne)}const Me=await(0,U.$30b)(Re,Y);Se.init(),he.set(F.$Xk,new a.$Or(x));const Oe=new X.$br(Ie,be,Y,ke);he.set(q.$8o,Oe),he.set(v.$4n,new b.$Zh(p.$uO,void 0,!0)),he.set(o.$Jp,new b.$Zh(Z.$eO,void 0,!0)),he.set(t.$Np,new b.$Zh(n.$Y0b,void 0,!0)),he.set(y.$tp,new b.$Zh(y.$up,void 0,!0)),he.set(i.$Xp,new b.$Zh(i.$Yp,void 0,!0)),he.set(g.$mo,new b.$Zh(O.$sp,void 0,!0)),he.set(H.$8q,new b.$Zh(ee.$0q,void 0,!1));const De=[],ze=(0,Q.$Lo)(we,Ie);if((0,Q.$Go)(we,be)){we.aiConfig&&we.aiConfig.ariaKey&&De.push(new K.$6N(Oe,ze,"monacoworkbench",null,we.aiConfig.ariaKey));const Ne={appenders:De,sendErrorTelemetry:!1,commonProperties:(0,M.$wo)((0,L.release)(),(0,L.hostname)(),process.arch,we.commit,we.version,Ae,Me,ze),piiPaths:(0,Q.$Mo)(be)};he.set(V.$rl,new b.$Zh(J.$dr,[Ne],!1))}else he.set(V.$rl,Q.$Ao);return[new w.$sq(he),De]}g(he){(0,N.setUnexpectedErrorHandler)(we=>{const be=(0,R.$Ni)(we,!0);be&&he.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",we=>{(0,N.$Z)(we)||(0,N.$1)(we)}),process.on("unhandledRejection",we=>(0,N.$1)(we))}async h(he,we,be,ke){let Ce;if(he.args.profile&&(Ce=be.profiles.find(Y=>Y.name===he.args.profile),!Ce))throw new Error(`Profile '${he.args.profile}' not found.`);const B=(Ce??be.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ke.createInstance(s.$vp,new _.$sj(_.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,B);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Y={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:B};return ke.createInstance(s.$vp,new _.$sj(_.LogLevel.Info,!1)).installExtensions(this.j(this.b["install-extension"]||[]),this.j(this.b["install-builtin-extension"]||[]),Y,!!this.b.force)}else{if(this.b["uninstall-extension"])return ke.createInstance(s.$vp,new _.$sj(_.LogLevel.Info,!1)).uninstallExtensions(this.j(this.b["uninstall-extension"]),!!this.b.force,B);if(this.b["locate-extension"])return ke.createInstance(s.$vp,new _.$sj(_.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,C.$J$b)(he.appRoot,he.extensionsPath))}}j(he){return he.map(we=>/\.vsix$/i.test(we)?I.URI.file((0,h.$ic)(we)?we:(0,h.$jc)((0,P.cwd)(),we)):we)}}async function ge(fe){const he=new de(fe);try{await he.run()}finally{he.dispose()}}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a017b12b9caa3475675cfe6fda014fcf5af388c9/core/vs/code/node/cliProcessMain.js.map
