/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/async","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/extpath","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","child_process","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/themables","net","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],ke=function(me){for(var e=[],D=0,N=me.length;D<N;D++)e[D]=Se[me[D]];return e};define(Se[157],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class D{static get(){const g=new Map,I=new Map,R=new Map,b=new Map;function $(v,k){v.has(k.detail)||v.set(k.detail,-k.timestamp)}function y(v,k){const l=v.get(k.detail);l&&(l>=0||v.set(k.detail,l+k.timestamp))}let A=[];typeof me=="function"&&typeof me.getStats=="function"&&(A=me.getStats().slice(0).sort((v,k)=>v.timestamp-k.timestamp));for(const v of A)switch(v.type){case 10:$(g,v);break;case 11:case 12:y(g,v);break;case 21:$(I,v);break;case 22:y(I,v);break;case 33:$(R,v);break;case 34:y(R,v);break;case 31:$(b,v);break;case 32:y(b,v);break}let C=0;R.forEach(v=>C+=v);function m(v){const k=[];return v.forEach((l,f)=>k.push([f,l])),k}return{amdLoad:m(g),amdInvoke:m(I),nodeRequire:m(R),nodeEval:m(b),nodeRequireTotal:C}}static toMarkdownTable(g,I){let R="";const b=[];return g.forEach(($,y)=>{b[y]=$.length}),I.forEach($=>{$.forEach((y,A)=>{typeof y>"u"&&(y=$[A]="-");const C=y.toString().length;b[A]=Math.max(C,b[A])})}),g.forEach(($,y)=>{R+=`| ${$+" ".repeat(b[y]-$.toString().length)} `}),R+=`|
`,g.forEach(($,y)=>{R+=`| ${"-".repeat(b[y])} `}),R+=`|
`,I.forEach($=>{$.forEach((y,A)=>{typeof y<"u"&&(R+=`| ${y+" ".repeat(b[A]-y.toString().length)} `)}),R+=`|
`}),R}}e.$U=D}),define(Se[158],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function D(l,f,s){const i=N(l,f);if(i!==-1)return l[i]}e.$fb=D;function N(l,f,s=l.length-1){for(let i=s;i>=0;i--){const n=l[i];if(f(n))return i}return-1}e.$gb=N;function g(l,f){const s=I(l,f);return s===-1?void 0:l[s]}e.$hb=g;function I(l,f,s=0,i=l.length){let n=s,o=i;for(;n<o;){const c=Math.floor((n+o)/2);f(l[c])?n=c+1:o=c}return n-1}e.$ib=I;function R(l,f){const s=b(l,f);return s===l.length?void 0:l[s]}e.$jb=R;function b(l,f,s=0,i=l.length){let n=s,o=i;for(;n<o;){const c=Math.floor((n+o)/2);f(l[c])?o=c:n=c+1}return n}e.$kb=b;function $(l,f,s=0,i=l.length){const n=b(l,f,s,i);return n===l.length?-1:n}e.$lb=$;class y{static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(y.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!f(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const s=I(this.e,f,this.c);return this.c=s+1,s===-1?void 0:this.e[s]}}e.$mb=y;function A(l,f){if(l.length===0)return;let s=l[0];for(let i=1;i<l.length;i++){const n=l[i];f(n,s)>0&&(s=n)}return s}e.$nb=A;function C(l,f){if(l.length===0)return;let s=l[0];for(let i=1;i<l.length;i++){const n=l[i];f(n,s)>=0&&(s=n)}return s}e.$ob=C;function m(l,f){return A(l,(s,i)=>-f(s,i))}e.$pb=m;function v(l,f){if(l.length===0)return-1;let s=0;for(let i=1;i<l.length;i++){const n=l[i];f(n,l[s])>0&&(s=i)}return s}e.$qb=v;function k(l,f){for(const s of l){const i=f(s);if(i!==void 0)return i}}e.$rb=k}),define(Se[73],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function D(R,b){const $=Object.create(null);for(const y of R){const A=b(y);let C=$[A];C||(C=$[A]=[]),C.push(y)}return $}e.$K=D;function N(R,b){const $=[],y=[];for(const A of R)b.has(A)||$.push(A);for(const A of b)R.has(A)||y.push(A);return{removed:$,added:y}}e.$L=N;function g(R,b){const $=[],y=[];for(const[A,C]of R)b.has(A)||$.push(C);for(const[A,C]of b)R.has(A)||y.push(C);return{removed:$,added:y}}e.$M=g;function I(R,b){const $=new Set;for(const y of b)R.has(y)&&$.add(y);return $}e.$N=I}),define(Se[52],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.$vh=e.$uh=void 0;function D(R){return(b,$,y)=>{let A=null,C=null;if(typeof y.value=="function"?(A="value",C=y.value):typeof y.get=="function"&&(A="get",C=y.get),!C)throw new Error("not supported");y[A]=R(C,$)}}function N(R,b,$){let y=null,A=null;if(typeof $.value=="function"?(y="value",A=$.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(y="get",A=$.get),!A)throw new Error("not supported");const C=`$memoize$${b}`;$[y]=function(...m){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,m)}),this[C]}}e.$uh=N;function g(R,b,$){return D((y,A)=>{const C=`$debounce$${A}`,m=`$debounce$result$${A}`;return function(...v){this[m]||(this[m]=$?$():void 0),clearTimeout(this[C]),b&&(this[m]=b(this[m],...v),v=[this[m]]),this[C]=setTimeout(()=>{y.apply(this,v),this[m]=$?$():void 0},R)}})}e.$vh=g;function I(R,b,$){return D((y,A)=>{const C=`$throttle$timer$${A}`,m=`$throttle$result$${A}`,v=`$throttle$lastRun$${A}`,k=`$throttle$pending$${A}`;return function(...l){if(this[m]||(this[m]=$?$():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),b&&(this[m]=b(this[m],...l)),this[k])return;const f=this[v]+R;f<=Date.now()?(this[v]=Date.now(),y.apply(this,[this[m]]),this[m]=$?$():void 0):(this[k]=!0,this[C]=setTimeout(()=>{this[k]=!1,this[v]=Date.now(),y.apply(this,[this[m]]),this[m]=$?$():void 0},f-Date.now()))}})}e.$wh=I}),define(Se[14],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class D{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(r=>{r(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=D,e.$X=new D;function N(c){e.$X.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=N;function g(c){if(!c||typeof c!="object")return!1;const t=c;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=g;function I(c){y(c)||e.$X.onUnexpectedError(c)}e.$1=I;function R(c){y(c)||e.$X.onUnexpectedExternalError(c)}e.$2=R;function b(c){if(c instanceof Error){const{name:t,message:r}=c,d=c.stacktrace||c.stack;return{$isError:!0,name:t,message:r,stack:d,noTelemetry:n.isErrorNoTelemetry(c)}}return c}e.$3=b;const $="Canceled";function y(c){return c instanceof A?!0:c instanceof Error&&c.name===$&&c.message===$}e.$4=y;class A extends Error{constructor(){super($),this.name=this.message}}e.$5=A;function C(){const c=new Error($);return c.name=c.message,c}e.$6=C;function m(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.$7=m;function v(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.$8=v;class k extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=k;function l(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.$0=l;class f extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=f;class s extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=s;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=i;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const r=new n;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=n;class o extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}e.$cb=o}),define(Se[19],ke([1,0,14,158]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function g(de,ge=0){return de[de.length-(1+ge)]}e.$sb=g;function I(de){if(de.length===0)throw new Error("Invalid tail call");return[de.slice(0,de.length-1),de[de.length-1]]}e.$tb=I;function R(de,ge,_=(ie,G)=>ie===G){if(de===ge)return!0;if(!de||!ge||de.length!==ge.length)return!1;for(let ie=0,G=de.length;ie<G;ie++)if(!_(de[ie],ge[ie]))return!1;return!0}e.$ub=R;function b(de,ge){const _=de.length-1;ge<_&&(de[ge]=de[_]),de.pop()}e.$vb=b;function $(de,ge,_){return y(de.length,ie=>_(de[ie],ge))}e.$wb=$;function y(de,ge){let _=0,ie=de-1;for(;_<=ie;){const G=(_+ie)/2|0,te=ge(G);if(te<0)_=G+1;else if(te>0)ie=G-1;else return G}return-(_+1)}e.$xb=y;function A(de,ge,_){if(de=de|0,de>=ge.length)throw new TypeError("invalid index");const ie=ge[Math.floor(ge.length*Math.random())],G=[],te=[],fe=[];for(const ve of ge){const Pe=_(ve,ie);Pe<0?G.push(ve):Pe>0?te.push(ve):fe.push(ve)}return de<G.length?A(de,G,_):de<G.length+fe.length?fe[0]:A(de-(G.length+fe.length),te,_)}e.$yb=A;function C(de,ge){const _=[];let ie;for(const G of de.slice(0).sort(ge))!ie||ge(ie[0],G)!==0?(ie=[G],_.push(ie)):ie.push(G);return _}e.$zb=C;function*m(de,ge){let _,ie;for(const G of de)ie!==void 0&&ge(ie,G)?_.push(G):(_&&(yield _),_=[G]),ie=G;_&&(yield _)}e.$Ab=m;function v(de,ge){for(let _=0;_<=de.length;_++)ge(_===0?void 0:de[_-1],_===de.length?void 0:de[_])}e.$Bb=v;function k(de,ge){for(let _=0;_<de.length;_++)ge(_===0?void 0:de[_-1],de[_],_+1===de.length?void 0:de[_+1])}e.$Cb=k;function l(de,ge,_){const ie=[];function G(ve,Pe,be){if(Pe===0&&be.length===0)return;const De=ie[ie.length-1];De&&De.start+De.deleteCount===ve?(De.deleteCount+=Pe,De.toInsert.push(...be)):ie.push({start:ve,deleteCount:Pe,toInsert:be})}let te=0,fe=0;for(;;){if(te===de.length){G(te,0,ge.slice(fe));break}if(fe===ge.length){G(te,de.length-te,[]);break}const ve=de[te],Pe=ge[fe],be=_(ve,Pe);be===0?(te+=1,fe+=1):be<0?(G(te,1,[]),te+=1):be>0&&(G(te,0,[Pe]),fe+=1)}return ie}e.$Db=l;function f(de,ge,_){const ie=l(de,ge,_),G=[],te=[];for(const fe of ie)G.push(...de.slice(fe.start,fe.start+fe.deleteCount)),te.push(...fe.toInsert);return{removed:G,added:te}}e.$Eb=f;function s(de,ge,_){if(_===0)return[];const ie=de.slice(0,_).sort(ge);return n(de,ge,ie,_,de.length),ie}e.top=s;function i(de,ge,_,ie,G){return _===0?Promise.resolve([]):new Promise((te,fe)=>{(async()=>{const ve=de.length,Pe=de.slice(0,_).sort(ge);for(let be=_,De=Math.min(_+ie,ve);be<ve;be=De,De=Math.min(De+ie,ve)){if(be>_&&await new Promise(z=>setTimeout(z)),G&&G.isCancellationRequested)throw new D.$5;n(de,ge,Pe,be,De)}return Pe})().then(te,fe)})}e.$Gb=i;function n(de,ge,_,ie,G){for(const te=_.length;ie<G;ie++){const fe=de[ie];if(ge(fe,_[te-1])<0){_.pop();const ve=(0,N.$kb)(_,Pe=>ge(fe,Pe)<0);_.splice(ve,0,fe)}}}function o(de){return de.filter(ge=>!!ge)}e.$Hb=o;function c(de){let ge=0;for(let _=0;_<de.length;_++)de[_]&&(de[ge]=de[_],ge+=1);de.length=ge}e.$Ib=c;function t(de,ge,_){de.splice(_,0,de.splice(ge,1)[0])}e.$Jb=t;function r(de){return!Array.isArray(de)||de.length===0}e.$Kb=r;function d(de){return Array.isArray(de)&&de.length>0}e.$Lb=d;function u(de,ge=_=>_){const _=new Set;return de.filter(ie=>{const G=ge(ie);return _.has(G)?!1:(_.add(G),!0)})}e.$Mb=u;function a(de){const ge=new Set;return _=>{const ie=de(_);return ge.has(ie)?!1:(ge.add(ie),!0)}}e.$Nb=a;function h(de,ge){return de.length>0?de[0]:ge}e.$Ob=h;function S(de,ge){return de.length>0?de[de.length-1]:ge}e.$Pb=S;function P(de,ge,_=(ie,G)=>ie===G){let ie=0;for(let G=0,te=Math.min(de.length,ge.length);G<te&&_(de[G],ge[G]);G++)ie++;return ie}e.$Qb=P;function w(de){return[].concat(...de)}e.$Rb=w;function p(de,ge){let _=typeof ge=="number"?de:0;typeof ge=="number"?_=de:(_=0,ge=de);const ie=[];if(_<=ge)for(let G=_;G<ge;G++)ie.push(G);else for(let G=_;G>ge;G--)ie.push(G);return ie}e.$Sb=p;function E(de,ge,_){return de.reduce((ie,G)=>(ie[ge(G)]=_?_(G):G,ie),Object.create(null))}e.$Tb=E;function L(de,ge){return de.push(ge),()=>T(de,ge)}e.$Ub=L;function T(de,ge){const _=de.indexOf(ge);if(_>-1)return de.splice(_,1),ge}e.$Vb=T;function U(de,ge,_){const ie=de.slice(0,ge),G=de.slice(ge);return ie.concat(_,G)}e.$Wb=U;function F(de,ge){let _;if(typeof ge=="number"){let ie=ge;_=()=>{const G=Math.sin(ie++)*179426549;return G-Math.floor(G)}}else _=Math.random;for(let ie=de.length-1;ie>0;ie-=1){const G=Math.floor(_()*(ie+1)),te=de[ie];de[ie]=de[G],de[G]=te}}e.$Xb=F;function j(de,ge){const _=de.indexOf(ge);_>-1&&(de.splice(_,1),de.unshift(ge))}e.$Yb=j;function O(de,ge){const _=de.indexOf(ge);_>-1&&(de.splice(_,1),de.push(ge))}e.$Zb=O;function M(de,ge){for(const _ of ge)de.push(_)}e.$1b=M;function W(de,ge){return Array.isArray(de)?de.map(ge):ge(de)}e.$2b=W;function Y(de){return Array.isArray(de)?de:[de]}e.$3b=Y;function ue(de){return de[Math.floor(Math.random()*de.length)]}e.$4b=ue;function X(de,ge,_){const ie=x(de,ge),G=de.length,te=_.length;de.length=G+te;for(let fe=G-1;fe>=ie;fe--)de[fe+te]=de[fe];for(let fe=0;fe<te;fe++)de[fe+ie]=_[fe]}e.$5b=X;function J(de,ge,_,ie){const G=x(de,ge);let te=de.splice(G,_);return te===void 0&&(te=[]),X(de,G,ie),te}e.$6b=J;function x(de,ge){return ge<0?Math.max(ge+de.length,0):Math.min(ge,de.length)}var he;(function(de){function ge(te){return te<0}de.isLessThan=ge;function _(te){return te<=0}de.isLessThanOrEqual=_;function ie(te){return te>0}de.isGreaterThan=ie;function G(te){return te===0}de.isNeitherLessOrGreaterThan=G,de.greaterThan=1,de.lessThan=-1,de.neitherLessOrGreaterThan=0})(he||(e.CompareResult=he={}));function Z(de,ge){return(_,ie)=>ge(de(_),de(ie))}e.$7b=Z;function we(...de){return(ge,_)=>{for(const ie of de){const G=ie(ge,_);if(!he.isNeitherLessOrGreaterThan(G))return G}return he.neitherLessOrGreaterThan}}e.$8b=we;const ce=(de,ge)=>de-ge;e.$9b=ce;const K=(de,ge)=>(0,e.$9b)(de?1:0,ge?1:0);e.$0b=K;function B(de){return(ge,_)=>-de(ge,_)}e.$$b=B;class re{constructor(ge){this.g=ge,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ge){let _=this.c;for(;_<this.g.length&&ge(this.g[_]);)_++;const ie=_===this.c?null:this.g.slice(this.c,_);return this.c=_,ie}takeFromEndWhile(ge){let _=this.d;for(;_>=0&&ge(this.g[_]);)_--;const ie=_===this.d?null:this.g.slice(_+1,this.d+1);return this.d=_,ie}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ge=this.g[this.c];return this.c++,ge}removeLast(){const ge=this.g[this.d];return this.d--,ge}takeCount(ge){const _=this.g.slice(this.c,this.c+ge);return this.c+=ge,_}}e.$_b=re;class ye{static{this.empty=new ye(ge=>{})}constructor(ge){this.iterate=ge}forEach(ge){this.iterate(_=>(ge(_),!0))}toArray(){const ge=[];return this.iterate(_=>(ge.push(_),!0)),ge}filter(ge){return new ye(_=>this.iterate(ie=>ge(ie)?_(ie):!0))}map(ge){return new ye(_=>this.iterate(ie=>_(ge(ie))))}some(ge){let _=!1;return this.iterate(ie=>(_=ge(ie),!_)),_}findFirst(ge){let _;return this.iterate(ie=>ge(ie)?(_=ie,!1):!0),_}findLast(ge){let _;return this.iterate(ie=>(ge(ie)&&(_=ie),!0)),_}findLastMaxBy(ge){let _,ie=!0;return this.iterate(G=>((ie||he.isGreaterThan(ge(G,_)))&&(ie=!1,_=G),!0)),_}}e.$ac=ye}),define(Se[60],ke([1,0,14]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=e.$7c=e.$6c=e.$5c=e.ok=void 0;function N($,y){if(!$)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=N;function g($,y="Unreachable"){throw new Error(y)}e.$5c=g;function I($){if(!$)throw new D.$cb("Assertion Failed")}e.$6c=I;function R($){if(!$()){debugger;$(),(0,D.$1)(new D.$cb("Assertion Failed"))}}e.$7c=R;function b($,y){let A=0;for(;A<$.length-1;){const C=$[A],m=$[A+1];if(!y(C,m))return!1;A++}return!0}e.$8c=b}),define(Se[74],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function D(N,g){const I=this;let R=!1,b;return function(){if(R)return b;if(R=!0,g)try{b=N.apply(I,arguments)}finally{g()}else b=N.apply(I,arguments);return b}}e.$db=D}),define(Se[121],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1M=e.$ZM=void 0;class D{constructor(g){this.a=g,this.b=0}nextId(){return this.a+ ++this.b}}e.$ZM=D,e.$1M=new D("id#")}),define(Se[53],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(N){function g(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}N.is=g;const I=Object.freeze([]);function R(){return I}N.empty=R;function*b(t){yield t}N.single=b;function $(t){return g(t)?t:b(t)}N.wrap=$;function y(t){return t||I}N.from=y;function*A(t){for(let r=t.length-1;r>=0;r--)yield t[r]}N.reverse=A;function C(t){return!t||t[Symbol.iterator]().next().done===!0}N.isEmpty=C;function m(t){return t[Symbol.iterator]().next().value}N.first=m;function v(t,r){for(const d of t)if(r(d))return!0;return!1}N.some=v;function k(t,r){for(const d of t)if(r(d))return d}N.find=k;function*l(t,r){for(const d of t)r(d)&&(yield d)}N.filter=l;function*f(t,r){let d=0;for(const u of t)yield r(u,d++)}N.map=f;function*s(...t){for(const r of t)yield*r}N.concat=s;function i(t,r,d){let u=d;for(const a of t)u=r(u,a);return u}N.reduce=i;function*n(t,r,d=t.length){for(r<0&&(r+=t.length),d<0?d+=t.length:d>t.length&&(d=t.length);r<d;r++)yield t[r]}N.slice=n;function o(t,r=Number.POSITIVE_INFINITY){const d=[];if(r===0)return[d,t];const u=t[Symbol.iterator]();for(let a=0;a<r;a++){const h=u.next();if(h.done)return[d,N.empty()];d.push(h.value)}return[d,{[Symbol.iterator](){return u}}]}N.consume=o;async function c(t){const r=[];for await(const d of t)r.push(d);return Promise.resolve(r)}N.asyncToArray=c})(D||(e.Iterable=D={}))}),define(Se[159],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var g;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(g||(e.ParseErrorCode=g={}));var I;(function(t){t.DEFAULT={allowTrailingComma:!0}})(I||(e.ParseOptions=I={}));function R(t,r=!1){let d=0;const u=t.length;let a="",h=0,S=16,P=0;function w(j){let O=0,M=0;for(;O<j;){const W=t.charCodeAt(d);if(W>=48&&W<=57)M=M*16+W-48;else if(W>=65&&W<=70)M=M*16+W-65+10;else if(W>=97&&W<=102)M=M*16+W-97+10;else break;d++,O++}return O<j&&(M=-1),M}function p(j){d=j,a="",h=0,S=16,P=0}function E(){const j=d;if(t.charCodeAt(d)===48)d++;else for(d++;d<t.length&&y(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===46)if(d++,d<t.length&&y(t.charCodeAt(d)))for(d++;d<t.length&&y(t.charCodeAt(d));)d++;else return P=3,t.substring(j,d);let O=d;if(d<t.length&&(t.charCodeAt(d)===69||t.charCodeAt(d)===101))if(d++,(d<t.length&&t.charCodeAt(d)===43||t.charCodeAt(d)===45)&&d++,d<t.length&&y(t.charCodeAt(d))){for(d++;d<t.length&&y(t.charCodeAt(d));)d++;O=d}else P=3;return t.substring(j,O)}function L(){let j="",O=d;for(;;){if(d>=u){j+=t.substring(O,d),P=2;break}const M=t.charCodeAt(d);if(M===34){j+=t.substring(O,d),d++;break}if(M===92){if(j+=t.substring(O,d),d++,d>=u){P=2;break}switch(t.charCodeAt(d++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const Y=w(4);Y>=0?j+=String.fromCharCode(Y):P=4;break}default:P=5}O=d;continue}if(M>=0&&M<=31)if($(M)){j+=t.substring(O,d),P=2;break}else P=6;d++}return j}function T(){if(a="",P=0,h=d,d>=u)return h=u,S=17;let j=t.charCodeAt(d);if(b(j)){do d++,a+=String.fromCharCode(j),j=t.charCodeAt(d);while(b(j));return S=15}if($(j))return d++,a+=String.fromCharCode(j),j===13&&t.charCodeAt(d)===10&&(d++,a+=`
`),S=14;switch(j){case 123:return d++,S=1;case 125:return d++,S=2;case 91:return d++,S=3;case 93:return d++,S=4;case 58:return d++,S=6;case 44:return d++,S=5;case 34:return d++,a=L(),S=10;case 47:{const O=d-1;if(t.charCodeAt(d+1)===47){for(d+=2;d<u&&!$(t.charCodeAt(d));)d++;return a=t.substring(O,d),S=12}if(t.charCodeAt(d+1)===42){d+=2;const M=u-1;let W=!1;for(;d<M;){if(t.charCodeAt(d)===42&&t.charCodeAt(d+1)===47){d+=2,W=!0;break}d++}return W||(d++,P=1),a=t.substring(O,d),S=13}return a+=String.fromCharCode(j),d++,S=16}case 45:if(a+=String.fromCharCode(j),d++,d===u||!y(t.charCodeAt(d)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=E(),S=11;default:for(;d<u&&U(j);)d++,j=t.charCodeAt(d);if(h!==d){switch(a=t.substring(h,d),a){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return a+=String.fromCharCode(j),d++,S=16}}function U(j){if(b(j)||$(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let j;do j=T();while(j>=12&&j<=15);return j}return{setPosition:p,getPosition:()=>d,scan:r?F:T,getToken:()=>S,getTokenValue:()=>a,getTokenOffset:()=>h,getTokenLength:()=>d-h,getTokenError:()=>P}}e.$0m=R;function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function C(t,r){const d=[],u=new Object;let a;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function P(w,p,E,L){h.value=w,h.offset=p,h.length=E,h.type=L,h.colonOffset=void 0,a=h}try{n(t,{onObjectBegin:(w,p)=>{if(r<=w)throw u;a=void 0,S=r>w,d.push("")},onObjectProperty:(w,p,E)=>{if(r<p||(P(w,p,E,"property"),d[d.length-1]=w,r<=p+E))throw u},onObjectEnd:(w,p)=>{if(r<=w)throw u;a=void 0,d.pop()},onArrayBegin:(w,p)=>{if(r<=w)throw u;a=void 0,d.push(0)},onArrayEnd:(w,p)=>{if(r<=w)throw u;a=void 0,d.pop()},onLiteralValue:(w,p,E)=>{if(r<p||(P(w,p,E,c(w)),r<=p+E))throw u},onSeparator:(w,p,E)=>{if(r<=p)throw u;if(w===":"&&a&&a.type==="property")a.colonOffset=p,S=!1,a=void 0;else if(w===","){const L=d[d.length-1];typeof L=="number"?d[d.length-1]=L+1:(S=!0,d[d.length-1]=""),a=void 0}}})}catch(w){if(w!==u)throw w}return{path:d,previousNode:a,isAtPropertyKey:S,matches:w=>{let p=0;for(let E=0;p<w.length&&E<d.length;E++)if(w[p]===d[E]||w[p]==="*")p++;else if(w[p]!=="**")return!1;return p===w.length}}}e.$$m=C;function m(t,r=[],d=I.DEFAULT){let u=null,a=[];const h=[];function S(w){Array.isArray(a)?a.push(w):u!==null&&(a[u]=w)}return n(t,{onObjectBegin:()=>{const w={};S(w),h.push(a),a=w,u=null},onObjectProperty:w=>{u=w},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{const w=[];S(w),h.push(a),a=w,u=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:S,onError:(w,p,E)=>{r.push({error:w,offset:p,length:E})}},d),a[0]}e.$_m=m;function v(t,r=[],d=I.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(w){u.type==="property"&&(u.length=w-u.offset,u=u.parent)}function h(w){return u.children.push(w),w}n(t,{onObjectBegin:w=>{u=h({type:"object",offset:w,length:-1,parent:u,children:[]})},onObjectProperty:(w,p,E)=>{u=h({type:"property",offset:p,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:w,offset:p,length:E,parent:u})},onObjectEnd:(w,p)=>{u.length=w+p-u.offset,u=u.parent,a(w+p)},onArrayBegin:(w,p)=>{u=h({type:"array",offset:w,length:-1,parent:u,children:[]})},onArrayEnd:(w,p)=>{u.length=w+p-u.offset,u=u.parent,a(w+p)},onLiteralValue:(w,p,E)=>{h({type:c(w),offset:p,length:E,parent:u,value:w}),a(p+E)},onSeparator:(w,p,E)=>{u.type==="property"&&(w===":"?u.colonOffset=p:w===","&&a(p))},onError:(w,p,E)=>{r.push({error:w,offset:p,length:E})}},d);const P=u.children[0];return P&&delete P.parent,P}e.$an=v;function k(t,r){if(!t)return;let d=t;for(const u of r)if(typeof u=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let a=!1;for(const h of d.children)if(Array.isArray(h.children)&&h.children[0].value===u){d=h.children[1],a=!0;break}if(!a)return}else{const a=u;if(d.type!=="array"||a<0||!Array.isArray(d.children)||a>=d.children.length)return;d=d.children[a]}return d}e.$bn=k;function l(t){if(!t.parent||!t.parent.children)return[];const r=l(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;r.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&r.push(d)}return r}e.$cn=l;function f(t){switch(t.type){case"array":return t.children.map(f);case"object":{const r=Object.create(null);for(const d of t.children){const u=d.children[1];u&&(r[d.children[0].value]=f(u))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$dn=f;function s(t,r,d=!1){return r>=t.offset&&r<t.offset+t.length||d&&r===t.offset+t.length}e.$en=s;function i(t,r,d=!1){if(s(t,r,d)){const u=t.children;if(Array.isArray(u))for(let a=0;a<u.length&&u[a].offset<=r;a++){const h=i(u[a],r,d);if(h)return h}return t}}e.$fn=i;function n(t,r,d=I.DEFAULT){const u=R(t,!1);function a(Z){return Z?()=>Z(u.getTokenOffset(),u.getTokenLength()):()=>!0}function h(Z){return Z?we=>Z(we,u.getTokenOffset(),u.getTokenLength()):()=>!0}const S=a(r.onObjectBegin),P=h(r.onObjectProperty),w=a(r.onObjectEnd),p=a(r.onArrayBegin),E=a(r.onArrayEnd),L=h(r.onLiteralValue),T=h(r.onSeparator),U=a(r.onComment),F=h(r.onError),j=d&&d.disallowComments,O=d&&d.allowTrailingComma;function M(){for(;;){const Z=u.scan();switch(u.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:j||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(Z){case 12:case 13:j?W(10):U();break;case 16:W(1);break;case 15:case 14:break;default:return Z}}}function W(Z,we=[],ce=[]){if(F(Z),we.length+ce.length>0){let K=u.getToken();for(;K!==17;){if(we.indexOf(K)!==-1){M();break}else if(ce.indexOf(K)!==-1)break;K=M()}}}function Y(Z){const we=u.getTokenValue();return Z?L(we):P(we),M(),!0}function ue(){switch(u.getToken()){case 11:{let Z=0;try{Z=JSON.parse(u.getTokenValue()),typeof Z!="number"&&(W(2),Z=0)}catch{W(2)}L(Z);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return M(),!0}function X(){return u.getToken()!==10?(W(3,[],[2,5]),!1):(Y(!1),u.getToken()===6?(T(":"),M(),he()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function J(){S(),M();let Z=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(Z||W(4,[],[]),T(","),M(),u.getToken()===2&&O)break}else Z&&W(6,[],[]);X()||W(4,[],[2,5]),Z=!0}return w(),u.getToken()!==2?W(7,[2],[]):M(),!0}function x(){p(),M();let Z=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(Z||W(4,[],[]),T(","),M(),u.getToken()===4&&O)break}else Z&&W(6,[],[]);he()||W(4,[],[4,5]),Z=!0}return E(),u.getToken()!==4?W(8,[4],[]):M(),!0}function he(){switch(u.getToken()){case 3:return x();case 1:return J();case 10:return Y(!0);default:return ue()}}return M(),u.getToken()===17?d.allowEmptyContent?!0:(W(4,[],[]),!1):he()?(u.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.$gn=n;function o(t,r){const d=R(t),u=[];let a,h=0,S;do switch(S=d.getPosition(),a=d.scan(),a){case 12:case 13:case 17:h!==S&&u.push(t.substring(h,S)),r!==void 0&&u.push(d.getTokenValue().replace(/[^\r\n]/g,r)),h=d.getPosition();break}while(a!==17);return u.join("")}e.$hn=o;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$in=c}),define(Se[43],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class D{constructor(g){this.d=g,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(g){this.c=g}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=D}),define(Se[75],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(I){this.element=I,this.next=D.Undefined,this.prev=D.Undefined}}class N{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let I=this.a;for(;I!==D.Undefined;){const R=I.next;I.prev=D.Undefined,I.next=D.Undefined,I=R}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(I){return this.d(I,!1)}push(I){return this.d(I,!0)}d(I,R){const b=new D(I);if(this.a===D.Undefined)this.a=b,this.b=b;else if(R){const y=this.b;this.b=b,b.prev=y,y.next=b}else{const y=this.a;this.a=b,b.next=y,y.prev=b}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(b))}}shift(){if(this.a!==D.Undefined){const I=this.a.element;return this.e(this.a),I}}pop(){if(this.b!==D.Undefined){const I=this.b.element;return this.e(this.b),I}}e(I){if(I.prev!==D.Undefined&&I.next!==D.Undefined){const R=I.prev;R.next=I.next,I.next.prev=R}else I.prev===D.Undefined&&I.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):I.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):I.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let I=this.a;for(;I!==D.Undefined;)yield I.element,I=I.next}}e.$3c=N}),define(Se[28],ke([1,0]),function(me,e){"use strict";var D,N,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function I(i,n,o){let c=i.get(n);return c===void 0&&(c=o,i.set(n,c)),c}e.$xc=I;function R(i){const n=[];return i.forEach((o,c)=>{n.push(`${c} => ${o}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.$yc=R;function b(i){const n=[];return i.forEach(o=>{n.push(o)}),`Set(${i.size}) {${n.join(", ")}}`}e.$zc=b;class ${constructor(n,o){this.uri=n,this.value=o}}function y(i){return Array.isArray(i)}class A{static{this.a=n=>n.toString()}constructor(n,o){if(this[D]="ResourceMap",n instanceof A)this.b=new Map(n.b),this.c=o??A.a;else if(y(n)){this.b=new Map,this.c=o??A.a;for(const[c,t]of n)this.set(c,t)}else this.b=new Map,this.c=n??A.a}set(n,o){return this.b.set(this.c(n),new $(n,o)),this}get(n){return this.b.get(this.c(n))?.value}has(n){return this.b.has(this.c(n))}get size(){return this.b.size}clear(){this.b.clear()}delete(n){return this.b.delete(this.c(n))}forEach(n,o){typeof o<"u"&&(n=n.bind(o));for(const[c,t]of this.b)n(t.value,t.uri,this)}*values(){for(const n of this.b.values())yield n.value}*keys(){for(const n of this.b.values())yield n.uri}*entries(){for(const n of this.b.values())yield[n.uri,n.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.b)yield[n.uri,n.value]}}e.$Ac=A;class C{constructor(n,o){this[N]="ResourceSet",!n||typeof n=="function"?this.a=new A(n):(this.a=new A(o),n.forEach(this.add,this))}get size(){return this.a.size}add(n){return this.a.set(n,n),this}clear(){this.a.clear()}delete(n){return this.a.delete(n)}forEach(n,o){this.a.forEach((c,t)=>n.call(o,t,t,this))}has(n){return this.a.has(n)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=C;var m;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class v{constructor(){this[g]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(n){return this.a.has(n)}get(n,o=0){const c=this.a.get(n);if(c)return o!==0&&this.j(c,o),c.value}set(n,o,c=0){let t=this.a.get(n);if(t)t.value=o,c!==0&&this.j(t,c);else{switch(t={key:n,value:o,next:void 0,previous:void 0},c){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(n,t),this.d++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this.a.get(n);if(o)return this.a.delete(n),this.i(o),this.d--,o.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const n=this.b;return this.a.delete(n.key),this.i(n),this.d--,n.value}forEach(n,o){const c=this.e;let t=this.b;for(;t;){if(o?n.bind(o)(t.value,t.key,this):n(t.value,t.key,this),this.e!==c)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const n=this,o=this.e;let c=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(c){const r={value:c.key,done:!1};return c=c.next,r}else return{value:void 0,done:!0}}};return t}values(){const n=this,o=this.e;let c=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(c){const r={value:c.value,done:!1};return c=c.next,r}else return{value:void 0,done:!0}}};return t}entries(){const n=this,o=this.e;let c=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(c){const r={value:[c.key,c.value],done:!1};return c=c.next,r}else return{value:void 0,done:!0}}};return t}[(g=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this.b,c=this.size;for(;o&&c>n;)this.a.delete(o.key),o=o.next,c--;this.b=o,this.d=c,o&&(o.previous=void 0),this.e++}g(n){if(!this.b&&!this.c)this.c=n;else if(this.b)n.next=this.b,this.b.previous=n;else throw new Error("Invalid list");this.b=n,this.e++}h(n){if(!this.b&&!this.c)this.b=n;else if(this.c)n.previous=this.c,this.c.next=n;else throw new Error("Invalid list");this.c=n,this.e++}i(n){if(n===this.b&&n===this.c)this.b=void 0,this.c=void 0;else if(n===this.b){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.b=n.next}else if(n===this.c){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.c=n.previous}else{const o=n.next,c=n.previous;if(!o||!c)throw new Error("Invalid list");o.previous=c,c.next=o}n.next=void 0,n.previous=void 0,this.e++}j(n,o){if(!this.b||!this.c)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this.b)return;const c=n.next,t=n.previous;n===this.c?(t.next=void 0,this.c=t):(c.previous=t,t.next=c),n.previous=void 0,n.next=this.b,this.b.previous=n,this.b=n,this.e++}else if(o===2){if(n===this.c)return;const c=n.next,t=n.previous;n===this.b?(c.previous=void 0,this.b=c):(c.previous=t,t.next=c),n.next=void 0,n.previous=this.c,this.c.next=n,this.c=n,this.e++}}}toJSON(){const n=[];return this.forEach((o,c)=>{n.push([c,o])}),n}fromJSON(n){this.clear();for(const[o,c]of n)this.set(o,c)}}e.$Cc=v;class k extends v{constructor(n,o=1){super(),this.k=n,this.l=Math.min(Math.max(0,o),1)}get limit(){return this.k}set limit(n){this.k=n,this.m()}get ratio(){return this.l}set ratio(n){this.l=Math.min(Math.max(0,n),1),this.m()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=k;class l{constructor(){this.a=new Map}add(n){return this.a.set(n,(this.a.get(n)||0)+1),this}delete(n){let o=this.a.get(n)||0;return o===0?!1:(o--,o===0?this.a.delete(n):this.a.set(n,o),!0)}has(n){return this.a.has(n)}}e.$Ec=l;class f{constructor(n){if(this.a=new Map,this.b=new Map,n)for(const[o,c]of n)this.set(o,c)}clear(){this.a.clear(),this.b.clear()}set(n,o){this.a.set(n,o),this.b.set(o,n)}get(n){return this.a.get(n)}getKey(n){return this.b.get(n)}delete(n){const o=this.a.get(n);return o===void 0?!1:(this.a.delete(n),this.b.delete(o),!0)}forEach(n,o){this.a.forEach((c,t)=>{n.call(o,c,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=f;class s{constructor(){this.a=new Map}add(n,o){let c=this.a.get(n);c||(c=new Set,this.a.set(n,c)),c.add(o)}delete(n,o){const c=this.a.get(n);c&&(c.delete(o),c.size===0&&this.a.delete(n))}forEach(n,o){const c=this.a.get(n);c&&c.forEach(o)}get(n){const o=this.a.get(n);return o||new Set}}e.$Gc=s}),define(Se[3],ke([1,0,19,73,28,74,53]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const b=!1;let $=null;class y{constructor(){this.b=new Map}static{this.a=0}c(L){let T=this.b.get(L);return T||(T={parent:null,source:null,isSingleton:!1,value:L,idx:y.a++},this.b.set(L,T)),T}trackDisposable(L){const T=this.c(L);T.source||(T.source=new Error().stack)}setParent(L,T){const U=this.c(L);U.parent=T}markAsDisposed(L){this.b.delete(L)}markAsSingleton(L){this.c(L).isSingleton=!0}f(L,T){const U=T.get(L);if(U)return U;const F=L.parent?this.f(this.c(L.parent),T):L;return T.set(L,F),F}getTrackedDisposables(){const L=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,L).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(L=10,T){let U;if(T)U=T;else{const W=new Map,Y=[...this.b.values()].filter(X=>X.source!==null&&!this.f(X,W).isSingleton);if(Y.length===0)return;const ue=new Set(Y.map(X=>X.value));if(U=Y.filter(X=>!(X.parent&&ue.has(X.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function F(W){function Y(X,J){for(;X.length>0&&J.some(x=>typeof x=="string"?x===X[0]:X[0].match(x));)X.shift()}const ue=W.source.split(`
`).map(X=>X.trim().replace("at ","")).filter(X=>X!=="");return Y(ue,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ue.reverse()}const j=new g.$Gc;for(const W of U){const Y=F(W);for(let ue=0;ue<=Y.length;ue++)j.add(Y.slice(0,ue).join(`
`),W)}U.sort((0,D.$7b)(W=>W.idx,D.$9b));let O="",M=0;for(const W of U.slice(0,L)){M++;const Y=F(W),ue=[];for(let X=0;X<Y.length;X++){let J=Y[X];J=`(shared with ${j.get(Y.slice(0,X+1).join(`
`)).size}/${U.length} leaks) at ${J}`;const he=j.get(Y.slice(0,X).join(`
`)),Z=(0,N.$K)([...he].map(we=>F(we)[X]),we=>we);delete Z[Y[X]];for(const[we,ce]of Object.entries(Z))ue.unshift(`    - stacktraces of ${ce.length} other leaks continue with ${we}`);ue.unshift(J)}O+=`


==================== Leaking disposable ${M}/${U.length}: ${W.value.constructor.name} ====================
${ue.join(`
`)}
============================================================

`}return U.length>L&&(O+=`


... and ${U.length-L} more leaking disposables

`),{leaks:U,details:O}}}e.$Hc=y;function A(E){$=E}if(e.$Ic=A,b){const E="__is_disposable_tracked__";A(new class{trackDisposable(L){const T=new Error("Potentially leaked disposable").stack;setTimeout(()=>{L[E]||console.log(T)},3e3)}setParent(L,T){if(L&&L!==t.None)try{L[E]=!0}catch{}}markAsDisposed(L){if(L&&L!==t.None)try{L[E]=!0}catch{}}markAsSingleton(L){}})}function C(E){return $?.trackDisposable(E),E}e.$Jc=C;function m(E){$?.markAsDisposed(E)}e.$Kc=m;function v(E,L){$?.setParent(E,L)}function k(E,L){if($)for(const T of E)$.setParent(T,L)}function l(E){return $?.markAsSingleton(E),E}e.$Lc=l;function f(E){return typeof E.dispose=="function"&&E.dispose.length===0}e.$Mc=f;function s(E){if(R.Iterable.is(E)){const L=[];for(const T of E)if(T)try{T.dispose()}catch(U){L.push(U)}if(L.length===1)throw L[0];if(L.length>1)throw new AggregateError(L,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}e.$Nc=s;function i(E){for(const L of E)f(L)&&L.dispose();return[]}e.$Oc=i;function n(...E){const L=o(()=>s(E));return k(E,L),L}e.$Pc=n;function o(E){const L=C({dispose:(0,I.$db)(()=>{m(L),E()})});return L}e.$Qc=o;class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{s(this.f)}finally{this.f.clear()}}add(L){if(!L)return L;if(L===this)throw new Error("Cannot register a disposable on itself!");return v(L,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(L),L}delete(L){if(L){if(L===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(L),L.dispose()}}deleteAndLeak(L){L&&this.f.has(L)&&(this.f.delete(L),v(L,null))}}e.$Rc=c;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,C(this),v(this.q,this)}dispose(){m(this),this.q.dispose()}B(L){if(L===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(L)}}e.$Sc=t;class r{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(L){this.b||L===this.a||(this.a?.dispose(),L&&v(L,this),this.a=L)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const L=this.a;return this.a=void 0,L&&v(L,null),L}}e.$Tc=r;class d{constructor(L){this.a=new r,this.b=!1,this.a.value=L}get value(){return this.a.value}set value(L){this.b||L===this.a.value||(this.a.value=L)}dispose(){this.b=!0,this.a.dispose()}}e.$Uc=d;class u{constructor(L){this.b=L,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Vc=u;class a{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(L){let T=L;return this.unset=()=>T=void 0,this.isset=()=>T!==void 0,this.dispose=()=>{T&&(T(),T=void 0,m(this))},this}}e.$Wc=a;class h{constructor(){this.a=new Map}acquire(L,...T){let U=this.a.get(L);U||(U={counter:0,object:this.b(L,...T)},this.a.set(L,U));const{object:F}=U,j=(0,I.$db)(()=>{--U.counter===0&&(this.c(L,U.object),this.a.delete(L))});return U.counter++,{object:F,dispose:j}}}e.$Xc=h;class S{constructor(L){this.a=L}async acquire(L,...T){const U=this.a.acquire(L,...T);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(F){throw U.dispose(),F}}}e.$Yc=S;class P{constructor(L){this.object=L}dispose(){}}e.$Zc=P;function w(E){const L=new c;try{E(L)}finally{L.dispose()}}e.$1c=w;class p{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{s(this.a.values())}finally{this.a.clear()}}has(L){return this.a.has(L)}get size(){return this.a.size}get(L){return this.a.get(L)}set(L,T,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(L)?.dispose(),this.a.set(L,T)}deleteAndDispose(L){this.a.get(L)?.dispose(),this.a.delete(L)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$2c=p}),function(me,e){typeof define=="function"&&define.amd?define(Se[160],ke([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(ge,_){for(var ie=0;ie<_.length;ie++){var G=_[ie];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(ge,G.key,G)}}function D(ge,_,ie){return _&&e(ge.prototype,_),ie&&e(ge,ie),Object.defineProperty(ge,"prototype",{writable:!1}),ge}function N(ge,_){if(ge){if(typeof ge=="string")return g(ge,_);var ie=Object.prototype.toString.call(ge).slice(8,-1);if(ie==="Object"&&ge.constructor&&(ie=ge.constructor.name),ie==="Map"||ie==="Set")return Array.from(ge);if(ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ie))return g(ge,_)}}function g(ge,_){(_==null||_>ge.length)&&(_=ge.length);for(var ie=0,G=new Array(_);ie<_;ie++)G[ie]=ge[ie];return G}function I(ge,_){var ie=typeof Symbol<"u"&&ge[Symbol.iterator]||ge["@@iterator"];if(ie)return(ie=ie.call(ge)).next.bind(ie);if(Array.isArray(ge)||(ie=N(ge))||_&&ge&&typeof ge.length=="number"){ie&&(ge=ie);var G=0;return function(){return G>=ge.length?{done:!0}:{done:!1,value:ge[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=R();function b(ge){me.defaults=ge}var $=/[&<>"']/,y=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(_){return m[_]};function k(ge,_){if(_){if($.test(ge))return ge.replace(y,v)}else if(A.test(ge))return ge.replace(C,v);return ge}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(ge){return ge.replace(l,function(_,ie){return ie=ie.toLowerCase(),ie==="colon"?":":ie.charAt(0)==="#"?ie.charAt(1)==="x"?String.fromCharCode(parseInt(ie.substring(2),16)):String.fromCharCode(+ie.substring(1)):""})}var s=/(^|[^\[])\^/g;function i(ge,_){ge=typeof ge=="string"?ge:ge.source,_=_||"";var ie={replace:function(te,fe){return fe=fe.source||fe,fe=fe.replace(s,"$1"),ge=ge.replace(te,fe),ie},getRegex:function(){return new RegExp(ge,_)}};return ie}var n=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(ge,_,ie){if(ge){var G;try{G=decodeURIComponent(f(ie)).replace(n,"").toLowerCase()}catch{return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}_&&!o.test(ie)&&(ie=a(_,ie));try{ie=encodeURI(ie).replace(/%25/g,"%")}catch{return null}return ie}var t={},r=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(ge,_){t[" "+ge]||(r.test(ge)?t[" "+ge]=ge+"/":t[" "+ge]=w(ge,"/",!0)),ge=t[" "+ge];var ie=ge.indexOf(":")===-1;return _.substring(0,2)==="//"?ie?_:ge.replace(d,"$1")+_:_.charAt(0)==="/"?ie?_:ge.replace(u,"$1")+_:ge+_}var h={exec:function(){}};function S(ge){for(var _=1,ie,G;_<arguments.length;_++){ie=arguments[_];for(G in ie)Object.prototype.hasOwnProperty.call(ie,G)&&(ge[G]=ie[G])}return ge}function P(ge,_){var ie=ge.replace(/\|/g,function(fe,ve,Pe){for(var be=!1,De=ve;--De>=0&&Pe[De]==="\\";)be=!be;return be?"|":" |"}),G=ie.split(/ \|/),te=0;if(G[0].trim()||G.shift(),G.length>0&&!G[G.length-1].trim()&&G.pop(),G.length>_)G.splice(_);else for(;G.length<_;)G.push("");for(;te<G.length;te++)G[te]=G[te].trim().replace(/\\\|/g,"|");return G}function w(ge,_,ie){var G=ge.length;if(G===0)return"";for(var te=0;te<G;){var fe=ge.charAt(G-te-1);if(fe===_&&!ie)te++;else if(fe!==_&&ie)te++;else break}return ge.slice(0,G-te)}function p(ge,_){if(ge.indexOf(_[1])===-1)return-1;for(var ie=ge.length,G=0,te=0;te<ie;te++)if(ge[te]==="\\")te++;else if(ge[te]===_[0])G++;else if(ge[te]===_[1]&&(G--,G<0))return te;return-1}function E(ge){ge&&ge.sanitize&&!ge.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(ge,_){if(_<1)return"";for(var ie="";_>1;)_&1&&(ie+=ge),_>>=1,ge+=ge;return ie+ge}function T(ge,_,ie,G){var te=_.href,fe=_.title?k(_.title):null,ve=ge[1].replace(/\\([\[\]])/g,"$1");if(ge[0].charAt(0)!=="!"){G.state.inLink=!0;var Pe={type:"link",raw:ie,href:te,title:fe,text:ve,tokens:G.inlineTokens(ve)};return G.state.inLink=!1,Pe}return{type:"image",raw:ie,href:te,title:fe,text:k(ve)}}function U(ge,_){var ie=ge.match(/^(\s+)(?:```)/);if(ie===null)return _;var G=ie[1];return _.split(`
`).map(function(te){var fe=te.match(/^\s+/);if(fe===null)return te;var ve=fe[0];return ve.length>=G.length?te.slice(G.length):te}).join(`
`)}var F=function(){function ge(ie){this.options=ie||me.defaults}var _=ge.prototype;return _.space=function(G){var te=this.rules.block.newline.exec(G);if(te&&te[0].length>0)return{type:"space",raw:te[0]}},_.code=function(G){var te=this.rules.block.code.exec(G);if(te){var fe=te[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:te[0],codeBlockStyle:"indented",text:this.options.pedantic?fe:w(fe,`
`)}}},_.fences=function(G){var te=this.rules.block.fences.exec(G);if(te){var fe=te[0],ve=U(fe,te[3]||"");return{type:"code",raw:fe,lang:te[2]?te[2].trim():te[2],text:ve}}},_.heading=function(G){var te=this.rules.block.heading.exec(G);if(te){var fe=te[2].trim();if(/#$/.test(fe)){var ve=w(fe,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&(fe=ve.trim())}return{type:"heading",raw:te[0],depth:te[1].length,text:fe,tokens:this.lexer.inline(fe)}}},_.hr=function(G){var te=this.rules.block.hr.exec(G);if(te)return{type:"hr",raw:te[0]}},_.blockquote=function(G){var te=this.rules.block.blockquote.exec(G);if(te){var fe=te[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:te[0],tokens:this.lexer.blockTokens(fe,[]),text:fe}}},_.list=function(G){var te=this.rules.block.list.exec(G);if(te){var fe,ve,Pe,be,De,z,Q,ee,V,oe,le,Re,je=te[1].trim(),He=je.length>1,Je={type:"list",raw:"",ordered:He,start:He?+je.slice(0,-1):"",loose:!1,items:[]};je=He?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=He?je:"[*+-]");for(var _e=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");G&&(Re=!1,!(!(te=_e.exec(G))||this.rules.block.hr.test(G)));){if(fe=te[0],G=G.substring(fe.length),ee=te[2].split(`
`,1)[0],V=G.split(`
`,1)[0],this.options.pedantic?(be=2,le=ee.trimLeft()):(be=te[2].search(/[^ ]/),be=be>4?1:be,le=ee.slice(be),be+=te[1].length),z=!1,!ee&&/^ *$/.test(V)&&(fe+=V+`
`,G=G.substring(V.length+1),Re=!0),!Re)for(var ct=new RegExp("^ {0,"+Math.min(3,be-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ot=new RegExp("^ {0,"+Math.min(3,be-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,be-1)+"}(?:```|~~~)"),Ae=new RegExp("^ {0,"+Math.min(3,be-1)+"}#");G&&(oe=G.split(`
`,1)[0],ee=oe,this.options.pedantic&&(ee=ee.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(ee)||Ae.test(ee)||ct.test(ee)||ot.test(G)));){if(ee.search(/[^ ]/)>=be||!ee.trim())le+=`
`+ee.slice(be);else if(!z)le+=`
`+ee;else break;!z&&!ee.trim()&&(z=!0),fe+=oe+`
`,G=G.substring(oe.length+1)}Je.loose||(Q?Je.loose=!0:/\n *\n *$/.test(fe)&&(Q=!0)),this.options.gfm&&(ve=/^\[[ xX]\] /.exec(le),ve&&(Pe=ve[0]!=="[ ] ",le=le.replace(/^\[[ xX]\] +/,""))),Je.items.push({type:"list_item",raw:fe,task:!!ve,checked:Pe,loose:!1,text:le}),Je.raw+=fe}Je.items[Je.items.length-1].raw=fe.trimRight(),Je.items[Je.items.length-1].text=le.trimRight(),Je.raw=Je.raw.trimRight();var Ue=Je.items.length;for(De=0;De<Ue;De++){this.lexer.state.top=!1,Je.items[De].tokens=this.lexer.blockTokens(Je.items[De].text,[]);var Le=Je.items[De].tokens.filter(function(ne){return ne.type==="space"}),Xe=Le.every(function(ne){for(var ae=ne.raw.split(""),Ie=0,Ve=I(ae),Ze;!(Ze=Ve()).done;){var nt=Ze.value;if(nt===`
`&&(Ie+=1),Ie>1)return!0}return!1});!Je.loose&&Le.length&&Xe&&(Je.loose=!0,Je.items[De].loose=!0)}return Je}},_.html=function(G){var te=this.rules.block.html.exec(G);if(te){var fe={type:"html",raw:te[0],pre:!this.options.sanitizer&&(te[1]==="pre"||te[1]==="script"||te[1]==="style"),text:te[0]};if(this.options.sanitize){var ve=this.options.sanitizer?this.options.sanitizer(te[0]):k(te[0]);fe.type="paragraph",fe.text=ve,fe.tokens=this.lexer.inline(ve)}return fe}},_.def=function(G){var te=this.rules.block.def.exec(G);if(te){te[3]&&(te[3]=te[3].substring(1,te[3].length-1));var fe=te[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:fe,raw:te[0],href:te[2],title:te[3]}}},_.table=function(G){var te=this.rules.block.table.exec(G);if(te){var fe={type:"table",header:P(te[1]).map(function(Q){return{text:Q}}),align:te[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:te[3]&&te[3].trim()?te[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(fe.header.length===fe.align.length){fe.raw=te[0];var ve=fe.align.length,Pe,be,De,z;for(Pe=0;Pe<ve;Pe++)/^ *-+: *$/.test(fe.align[Pe])?fe.align[Pe]="right":/^ *:-+: *$/.test(fe.align[Pe])?fe.align[Pe]="center":/^ *:-+ *$/.test(fe.align[Pe])?fe.align[Pe]="left":fe.align[Pe]=null;for(ve=fe.rows.length,Pe=0;Pe<ve;Pe++)fe.rows[Pe]=P(fe.rows[Pe],fe.header.length).map(function(Q){return{text:Q}});for(ve=fe.header.length,be=0;be<ve;be++)fe.header[be].tokens=this.lexer.inline(fe.header[be].text);for(ve=fe.rows.length,be=0;be<ve;be++)for(z=fe.rows[be],De=0;De<z.length;De++)z[De].tokens=this.lexer.inline(z[De].text);return fe}}},_.lheading=function(G){var te=this.rules.block.lheading.exec(G);if(te)return{type:"heading",raw:te[0],depth:te[2].charAt(0)==="="?1:2,text:te[1],tokens:this.lexer.inline(te[1])}},_.paragraph=function(G){var te=this.rules.block.paragraph.exec(G);if(te){var fe=te[1].charAt(te[1].length-1)===`
`?te[1].slice(0,-1):te[1];return{type:"paragraph",raw:te[0],text:fe,tokens:this.lexer.inline(fe)}}},_.text=function(G){var te=this.rules.block.text.exec(G);if(te)return{type:"text",raw:te[0],text:te[0],tokens:this.lexer.inline(te[0])}},_.escape=function(G){var te=this.rules.inline.escape.exec(G);if(te)return{type:"escape",raw:te[0],text:k(te[1])}},_.tag=function(G){var te=this.rules.inline.tag.exec(G);if(te)return!this.lexer.state.inLink&&/^<a /i.test(te[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(te[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(te[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(te[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:te[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):k(te[0]):te[0]}},_.link=function(G){var te=this.rules.inline.link.exec(G);if(te){var fe=te[2].trim();if(!this.options.pedantic&&/^</.test(fe)){if(!/>$/.test(fe))return;var ve=w(fe.slice(0,-1),"\\");if((fe.length-ve.length)%2===0)return}else{var Pe=p(te[2],"()");if(Pe>-1){var be=te[0].indexOf("!")===0?5:4,De=be+te[1].length+Pe;te[2]=te[2].substring(0,Pe),te[0]=te[0].substring(0,De).trim(),te[3]=""}}var z=te[2],Q="";if(this.options.pedantic){var ee=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(z);ee&&(z=ee[1],Q=ee[3])}else Q=te[3]?te[3].slice(1,-1):"";return z=z.trim(),/^</.test(z)&&(this.options.pedantic&&!/>$/.test(fe)?z=z.slice(1):z=z.slice(1,-1)),T(te,{href:z&&z.replace(this.rules.inline._escapes,"$1"),title:Q&&Q.replace(this.rules.inline._escapes,"$1")},te[0],this.lexer)}},_.reflink=function(G,te){var fe;if((fe=this.rules.inline.reflink.exec(G))||(fe=this.rules.inline.nolink.exec(G))){var ve=(fe[2]||fe[1]).replace(/\s+/g," ");if(ve=te[ve.toLowerCase()],!ve||!ve.href){var Pe=fe[0].charAt(0);return{type:"text",raw:Pe,text:Pe}}return T(fe,ve,fe[0],this.lexer)}},_.emStrong=function(G,te,fe){fe===void 0&&(fe="");var ve=this.rules.inline.emStrong.lDelim.exec(G);if(ve&&!(ve[3]&&fe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Pe=ve[1]||ve[2]||"";if(!Pe||Pe&&(fe===""||this.rules.inline.punctuation.exec(fe))){var be=ve[0].length-1,De,z,Q=be,ee=0,V=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(V.lastIndex=0,te=te.slice(-1*G.length+be);(ve=V.exec(te))!=null;)if(De=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!De){if(z=De.length,ve[3]||ve[4]){Q+=z;continue}else if((ve[5]||ve[6])&&be%3&&!((be+z)%3)){ee+=z;continue}if(Q-=z,!(Q>0)){if(z=Math.min(z,z+Q+ee),Math.min(be,z)%2){var oe=G.slice(1,be+ve.index+z);return{type:"em",raw:G.slice(0,be+ve.index+z+1),text:oe,tokens:this.lexer.inlineTokens(oe)}}var le=G.slice(2,be+ve.index+z-1);return{type:"strong",raw:G.slice(0,be+ve.index+z+1),text:le,tokens:this.lexer.inlineTokens(le)}}}}}},_.codespan=function(G){var te=this.rules.inline.code.exec(G);if(te){var fe=te[2].replace(/\n/g," "),ve=/[^ ]/.test(fe),Pe=/^ /.test(fe)&&/ $/.test(fe);return ve&&Pe&&(fe=fe.substring(1,fe.length-1)),fe=k(fe,!0),{type:"codespan",raw:te[0],text:fe}}},_.br=function(G){var te=this.rules.inline.br.exec(G);if(te)return{type:"br",raw:te[0]}},_.del=function(G){var te=this.rules.inline.del.exec(G);if(te)return{type:"del",raw:te[0],text:te[2],tokens:this.lexer.inlineTokens(te[2])}},_.autolink=function(G,te){var fe=this.rules.inline.autolink.exec(G);if(fe){var ve,Pe;return fe[2]==="@"?(ve=k(this.options.mangle?te(fe[1]):fe[1]),Pe="mailto:"+ve):(ve=k(fe[1]),Pe=ve),{type:"link",raw:fe[0],text:ve,href:Pe,tokens:[{type:"text",raw:ve,text:ve}]}}},_.url=function(G,te){var fe;if(fe=this.rules.inline.url.exec(G)){var ve,Pe;if(fe[2]==="@")ve=k(this.options.mangle?te(fe[0]):fe[0]),Pe="mailto:"+ve;else{var be;do be=fe[0],fe[0]=this.rules.inline._backpedal.exec(fe[0])[0];while(be!==fe[0]);ve=k(fe[0]),fe[1]==="www."?Pe="http://"+ve:Pe=ve}return{type:"link",raw:fe[0],text:ve,href:Pe,tokens:[{type:"text",raw:ve,text:ve}]}}},_.inlineText=function(G,te){var fe=this.rules.inline.text.exec(G);if(fe){var ve;return this.lexer.state.inRawBlock?ve=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):k(fe[0]):fe[0]:ve=k(this.options.smartypants?te(fe[0]):fe[0]),{type:"text",raw:fe[0],text:ve}}},ge}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=i(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=i(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=i(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=i(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=i(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=i(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=S({},j),j.gfm=S({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=i(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=i(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=S({},j.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:i(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=i(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=i(j._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=i(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=i(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=i(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=i(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=i(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=i(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=i(O.reflink).replace("label",O._label).replace("ref",j._label).getRegex(),O.nolink=i(O.nolink).replace("ref",j._label).getRegex(),O.reflinkSearch=i(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=S({},O),O.pedantic=S({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=S({},O.normal,{escape:i(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=i(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=S({},O.gfm,{br:i(O.br).replace("{2,}","*").getRegex(),text:i(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function M(ge){return ge.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(ge){var _="",ie,G,te=ge.length;for(ie=0;ie<te;ie++)G=ge.charCodeAt(ie),Math.random()>.5&&(G="x"+G.toString(16)),_+="&#"+G+";";return _}var Y=function(){function ge(ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=ie||me.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var G={block:j.normal,inline:O.normal};this.options.pedantic?(G.block=j.pedantic,G.inline=O.pedantic):this.options.gfm&&(G.block=j.gfm,this.options.breaks?G.inline=O.breaks:G.inline=O.gfm),this.tokenizer.rules=G}ge.lex=function(G,te){var fe=new ge(te);return fe.lex(G)},ge.lexInline=function(G,te){var fe=new ge(te);return fe.inlineTokens(G)};var _=ge.prototype;return _.lex=function(G){G=G.replace(/\r\n|\r/g,`
`),this.blockTokens(G,this.tokens);for(var te;te=this.inlineQueue.shift();)this.inlineTokens(te.src,te.tokens);return this.tokens},_.blockTokens=function(G,te){var fe=this;te===void 0&&(te=[]),this.options.pedantic?G=G.replace(/\t/g,"    ").replace(/^ +$/gm,""):G=G.replace(/^( *)(\t+)/gm,function(Q,ee,V){return ee+"    ".repeat(V.length)});for(var ve,Pe,be,De;G;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Q){return(ve=Q.call({lexer:fe},G,te))?(G=G.substring(ve.raw.length),te.push(ve),!0):!1}))){if(ve=this.tokenizer.space(G)){G=G.substring(ve.raw.length),ve.raw.length===1&&te.length>0?te[te.length-1].raw+=`
`:te.push(ve);continue}if(ve=this.tokenizer.code(G)){G=G.substring(ve.raw.length),Pe=te[te.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+ve.raw,Pe.text+=`
`+ve.text,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):te.push(ve);continue}if(ve=this.tokenizer.fences(G)){G=G.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.heading(G)){G=G.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.hr(G)){G=G.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.blockquote(G)){G=G.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.list(G)){G=G.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.html(G)){G=G.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.def(G)){G=G.substring(ve.raw.length),Pe=te[te.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+ve.raw,Pe.text+=`
`+ve.raw,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(G)){G=G.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.lheading(G)){G=G.substring(ve.raw.length),te.push(ve);continue}if(be=G,this.options.extensions&&this.options.extensions.startBlock&&function(){var Q=1/0,ee=G.slice(1),V=void 0;fe.options.extensions.startBlock.forEach(function(oe){V=oe.call({lexer:this},ee),typeof V=="number"&&V>=0&&(Q=Math.min(Q,V))}),Q<1/0&&Q>=0&&(be=G.substring(0,Q+1))}(),this.state.top&&(ve=this.tokenizer.paragraph(be))){Pe=te[te.length-1],De&&Pe.type==="paragraph"?(Pe.raw+=`
`+ve.raw,Pe.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):te.push(ve),De=be.length!==G.length,G=G.substring(ve.raw.length);continue}if(ve=this.tokenizer.text(G)){G=G.substring(ve.raw.length),Pe=te[te.length-1],Pe&&Pe.type==="text"?(Pe.raw+=`
`+ve.raw,Pe.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):te.push(ve);continue}if(G){var z="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(z);break}else throw new Error(z)}}return this.state.top=!0,te},_.inline=function(G,te){return te===void 0&&(te=[]),this.inlineQueue.push({src:G,tokens:te}),te},_.inlineTokens=function(G,te){var fe=this;te===void 0&&(te=[]);var ve,Pe,be,De=G,z,Q,ee;if(this.tokens.links){var V=Object.keys(this.tokens.links);if(V.length>0)for(;(z=this.tokenizer.rules.inline.reflinkSearch.exec(De))!=null;)V.includes(z[0].slice(z[0].lastIndexOf("[")+1,-1))&&(De=De.slice(0,z.index)+"["+L("a",z[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(z=this.tokenizer.rules.inline.blockSkip.exec(De))!=null;)De=De.slice(0,z.index)+"["+L("a",z[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(z=this.tokenizer.rules.inline.escapedEmSt.exec(De))!=null;)De=De.slice(0,z.index)+"++"+De.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;)if(Q||(ee=""),Q=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(le){return(ve=le.call({lexer:fe},G,te))?(G=G.substring(ve.raw.length),te.push(ve),!0):!1}))){if(ve=this.tokenizer.escape(G)){G=G.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.tag(G)){G=G.substring(ve.raw.length),Pe=te[te.length-1],Pe&&ve.type==="text"&&Pe.type==="text"?(Pe.raw+=ve.raw,Pe.text+=ve.text):te.push(ve);continue}if(ve=this.tokenizer.link(G)){G=G.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(ve.raw.length),Pe=te[te.length-1],Pe&&ve.type==="text"&&Pe.type==="text"?(Pe.raw+=ve.raw,Pe.text+=ve.text):te.push(ve);continue}if(ve=this.tokenizer.emStrong(G,De,ee)){G=G.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.codespan(G)){G=G.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.br(G)){G=G.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.del(G)){G=G.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.autolink(G,W)){G=G.substring(ve.raw.length),te.push(ve);continue}if(!this.state.inLink&&(ve=this.tokenizer.url(G,W))){G=G.substring(ve.raw.length),te.push(ve);continue}if(be=G,this.options.extensions&&this.options.extensions.startInline&&function(){var le=1/0,Re=G.slice(1),je=void 0;fe.options.extensions.startInline.forEach(function(He){je=He.call({lexer:this},Re),typeof je=="number"&&je>=0&&(le=Math.min(le,je))}),le<1/0&&le>=0&&(be=G.substring(0,le+1))}(),ve=this.tokenizer.inlineText(be,M)){G=G.substring(ve.raw.length),ve.raw.slice(-1)!=="_"&&(ee=ve.raw.slice(-1)),Q=!0,Pe=te[te.length-1],Pe&&Pe.type==="text"?(Pe.raw+=ve.raw,Pe.text+=ve.text):te.push(ve);continue}if(G){var oe="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(oe);break}else throw new Error(oe)}}return te},D(ge,null,[{key:"rules",get:function(){return{block:j,inline:O}}}]),ge}(),ue=function(){function ge(ie){this.options=ie||me.defaults}var _=ge.prototype;return _.code=function(G,te,fe){var ve=(te||"").match(/\S*/)[0];if(this.options.highlight){var Pe=this.options.highlight(G,ve);Pe!=null&&Pe!==G&&(fe=!0,G=Pe)}return G=G.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+k(ve,!0)+'">'+(fe?G:k(G,!0))+`</code></pre>
`:"<pre><code>"+(fe?G:k(G,!0))+`</code></pre>
`},_.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},_.html=function(G){return G},_.heading=function(G,te,fe,ve){if(this.options.headerIds){var Pe=this.options.headerPrefix+ve.slug(fe);return"<h"+te+' id="'+Pe+'">'+G+"</h"+te+`>
`}return"<h"+te+">"+G+"</h"+te+`>
`},_.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},_.list=function(G,te,fe){var ve=te?"ol":"ul",Pe=te&&fe!==1?' start="'+fe+'"':"";return"<"+ve+Pe+`>
`+G+"</"+ve+`>
`},_.listitem=function(G){return"<li>"+G+`</li>
`},_.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},_.paragraph=function(G){return"<p>"+G+`</p>
`},_.table=function(G,te){return te&&(te="<tbody>"+te+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+te+`</table>
`},_.tablerow=function(G){return`<tr>
`+G+`</tr>
`},_.tablecell=function(G,te){var fe=te.header?"th":"td",ve=te.align?"<"+fe+' align="'+te.align+'">':"<"+fe+">";return ve+G+("</"+fe+`>
`)},_.strong=function(G){return"<strong>"+G+"</strong>"},_.em=function(G){return"<em>"+G+"</em>"},_.codespan=function(G){return"<code>"+G+"</code>"},_.br=function(){return this.options.xhtml?"<br/>":"<br>"},_.del=function(G){return"<del>"+G+"</del>"},_.link=function(G,te,fe){if(G=c(this.options.sanitize,this.options.baseUrl,G),G===null)return fe;var ve='<a href="'+k(G)+'"';return te&&(ve+=' title="'+te+'"'),ve+=">"+fe+"</a>",ve},_.image=function(G,te,fe){if(G=c(this.options.sanitize,this.options.baseUrl,G),G===null)return fe;var ve='<img src="'+G+'" alt="'+fe+'"';return te&&(ve+=' title="'+te+'"'),ve+=this.options.xhtml?"/>":">",ve},_.text=function(G){return G},ge}(),X=function(){function ge(){}var _=ge.prototype;return _.strong=function(G){return G},_.em=function(G){return G},_.codespan=function(G){return G},_.del=function(G){return G},_.html=function(G){return G},_.text=function(G){return G},_.link=function(G,te,fe){return""+fe},_.image=function(G,te,fe){return""+fe},_.br=function(){return""},ge}(),J=function(){function ge(){this.seen={}}var _=ge.prototype;return _.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},_.getNextSafeSlug=function(G,te){var fe=G,ve=0;if(this.seen.hasOwnProperty(fe)){ve=this.seen[G];do ve++,fe=G+"-"+ve;while(this.seen.hasOwnProperty(fe))}return te||(this.seen[G]=ve,this.seen[fe]=0),fe},_.slug=function(G,te){te===void 0&&(te={});var fe=this.serialize(G);return this.getNextSafeSlug(fe,te.dryrun)},ge}(),x=function(){function ge(ie){this.options=ie||me.defaults,this.options.renderer=this.options.renderer||new ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new X,this.slugger=new J}ge.parse=function(G,te){var fe=new ge(te);return fe.parse(G)},ge.parseInline=function(G,te){var fe=new ge(te);return fe.parseInline(G)};var _=ge.prototype;return _.parse=function(G,te){te===void 0&&(te=!0);var fe="",ve,Pe,be,De,z,Q,ee,V,oe,le,Re,je,He,Je,_e,ct,ot,rt,Ae,Ue=G.length;for(ve=0;ve<Ue;ve++){if(le=G[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[le.type]&&(Ae=this.options.extensions.renderers[le.type].call({parser:this},le),Ae!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(le.type))){fe+=Ae||"";continue}switch(le.type){case"space":continue;case"hr":{fe+=this.renderer.hr();continue}case"heading":{fe+=this.renderer.heading(this.parseInline(le.tokens),le.depth,f(this.parseInline(le.tokens,this.textRenderer)),this.slugger);continue}case"code":{fe+=this.renderer.code(le.text,le.lang,le.escaped);continue}case"table":{for(V="",ee="",De=le.header.length,Pe=0;Pe<De;Pe++)ee+=this.renderer.tablecell(this.parseInline(le.header[Pe].tokens),{header:!0,align:le.align[Pe]});for(V+=this.renderer.tablerow(ee),oe="",De=le.rows.length,Pe=0;Pe<De;Pe++){for(Q=le.rows[Pe],ee="",z=Q.length,be=0;be<z;be++)ee+=this.renderer.tablecell(this.parseInline(Q[be].tokens),{header:!1,align:le.align[be]});oe+=this.renderer.tablerow(ee)}fe+=this.renderer.table(V,oe);continue}case"blockquote":{oe=this.parse(le.tokens),fe+=this.renderer.blockquote(oe);continue}case"list":{for(Re=le.ordered,je=le.start,He=le.loose,De=le.items.length,oe="",Pe=0;Pe<De;Pe++)_e=le.items[Pe],ct=_e.checked,ot=_e.task,Je="",_e.task&&(rt=this.renderer.checkbox(ct),He?_e.tokens.length>0&&_e.tokens[0].type==="paragraph"?(_e.tokens[0].text=rt+" "+_e.tokens[0].text,_e.tokens[0].tokens&&_e.tokens[0].tokens.length>0&&_e.tokens[0].tokens[0].type==="text"&&(_e.tokens[0].tokens[0].text=rt+" "+_e.tokens[0].tokens[0].text)):_e.tokens.unshift({type:"text",text:rt}):Je+=rt),Je+=this.parse(_e.tokens,He),oe+=this.renderer.listitem(Je,ot,ct);fe+=this.renderer.list(oe,Re,je);continue}case"html":{fe+=this.renderer.html(le.text);continue}case"paragraph":{fe+=this.renderer.paragraph(this.parseInline(le.tokens));continue}case"text":{for(oe=le.tokens?this.parseInline(le.tokens):le.text;ve+1<Ue&&G[ve+1].type==="text";)le=G[++ve],oe+=`
`+(le.tokens?this.parseInline(le.tokens):le.text);fe+=te?this.renderer.paragraph(oe):oe;continue}default:{var Le='Token with "'+le.type+'" type was not found.';if(this.options.silent){console.error(Le);return}else throw new Error(Le)}}}return fe},_.parseInline=function(G,te){te=te||this.renderer;var fe="",ve,Pe,be,De=G.length;for(ve=0;ve<De;ve++){if(Pe=G[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Pe.type]&&(be=this.options.extensions.renderers[Pe.type].call({parser:this},Pe),be!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Pe.type))){fe+=be||"";continue}switch(Pe.type){case"escape":{fe+=te.text(Pe.text);break}case"html":{fe+=te.html(Pe.text);break}case"link":{fe+=te.link(Pe.href,Pe.title,this.parseInline(Pe.tokens,te));break}case"image":{fe+=te.image(Pe.href,Pe.title,Pe.text);break}case"strong":{fe+=te.strong(this.parseInline(Pe.tokens,te));break}case"em":{fe+=te.em(this.parseInline(Pe.tokens,te));break}case"codespan":{fe+=te.codespan(Pe.text);break}case"br":{fe+=te.br();break}case"del":{fe+=te.del(this.parseInline(Pe.tokens,te));break}case"text":{fe+=te.text(Pe.text);break}default:{var z='Token with "'+Pe.type+'" type was not found.';if(this.options.silent){console.error(z);return}else throw new Error(z)}}}return fe},ge}();function he(ge,_,ie){if(typeof ge>"u"||ge===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");if(typeof _=="function"&&(ie=_,_=null),_=S({},he.defaults,_||{}),E(_),ie){var G=_.highlight,te;try{te=Y.lex(ge,_)}catch(De){return ie(De)}var fe=function(z){var Q;if(!z)try{_.walkTokens&&he.walkTokens(te,_.walkTokens),Q=x.parse(te,_)}catch(ee){z=ee}return _.highlight=G,z?ie(z):ie(null,Q)};if(!G||G.length<3||(delete _.highlight,!te.length))return fe();var ve=0;he.walkTokens(te,function(De){De.type==="code"&&(ve++,setTimeout(function(){G(De.text,De.lang,function(z,Q){if(z)return fe(z);Q!=null&&Q!==De.text&&(De.text=Q,De.escaped=!0),ve--,ve===0&&fe()})},0))}),ve===0&&fe();return}function Pe(De){if(De.message+=`
Please report this to https://github.com/markedjs/marked.`,_.silent)return"<p>An error occurred:</p><pre>"+k(De.message+"",!0)+"</pre>";throw De}try{var be=Y.lex(ge,_);if(_.walkTokens){if(_.async)return Promise.all(he.walkTokens(be,_.walkTokens)).then(function(){return x.parse(be,_)}).catch(Pe);he.walkTokens(be,_.walkTokens)}return x.parse(be,_)}catch(De){Pe(De)}}he.options=he.setOptions=function(ge){return S(he.defaults,ge),b(he.defaults),he},he.getDefaults=R,he.defaults=me.defaults,he.use=function(){for(var ge=arguments.length,_=new Array(ge),ie=0;ie<ge;ie++)_[ie]=arguments[ie];var G=S.apply(void 0,[{}].concat(_)),te=he.defaults.extensions||{renderers:{},childTokens:{}},fe;_.forEach(function(ve){if(ve.extensions&&(fe=!0,ve.extensions.forEach(function(be){if(!be.name)throw new Error("extension name required");if(be.renderer){var De=te.renderers?te.renderers[be.name]:null;De?te.renderers[be.name]=function(){for(var z=arguments.length,Q=new Array(z),ee=0;ee<z;ee++)Q[ee]=arguments[ee];var V=be.renderer.apply(this,Q);return V===!1&&(V=De.apply(this,Q)),V}:te.renderers[be.name]=be.renderer}if(be.tokenizer){if(!be.level||be.level!=="block"&&be.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");te[be.level]?te[be.level].unshift(be.tokenizer):te[be.level]=[be.tokenizer],be.start&&(be.level==="block"?te.startBlock?te.startBlock.push(be.start):te.startBlock=[be.start]:be.level==="inline"&&(te.startInline?te.startInline.push(be.start):te.startInline=[be.start]))}be.childTokens&&(te.childTokens[be.name]=be.childTokens)})),ve.renderer&&function(){var be=he.defaults.renderer||new ue,De=function(ee){var V=be[ee];be[ee]=function(){for(var oe=arguments.length,le=new Array(oe),Re=0;Re<oe;Re++)le[Re]=arguments[Re];var je=ve.renderer[ee].apply(be,le);return je===!1&&(je=V.apply(be,le)),je}};for(var z in ve.renderer)De(z);G.renderer=be}(),ve.tokenizer&&function(){var be=he.defaults.tokenizer||new F,De=function(ee){var V=be[ee];be[ee]=function(){for(var oe=arguments.length,le=new Array(oe),Re=0;Re<oe;Re++)le[Re]=arguments[Re];var je=ve.tokenizer[ee].apply(be,le);return je===!1&&(je=V.apply(be,le)),je}};for(var z in ve.tokenizer)De(z);G.tokenizer=be}(),ve.walkTokens){var Pe=he.defaults.walkTokens;G.walkTokens=function(be){var De=[];return De.push(ve.walkTokens.call(this,be)),Pe&&(De=De.concat(Pe.call(this,be))),De}}fe&&(G.extensions=te),he.setOptions(G)})},he.walkTokens=function(ge,_){for(var ie=[],G=function(){var Pe=fe.value;switch(ie=ie.concat(_.call(he,Pe)),Pe.type){case"table":{for(var be=I(Pe.header),De;!(De=be()).done;){var z=De.value;ie=ie.concat(he.walkTokens(z.tokens,_))}for(var Q=I(Pe.rows),ee;!(ee=Q()).done;)for(var V=ee.value,oe=I(V),le;!(le=oe()).done;){var Re=le.value;ie=ie.concat(he.walkTokens(Re.tokens,_))}break}case"list":{ie=ie.concat(he.walkTokens(Pe.items,_));break}default:he.defaults.extensions&&he.defaults.extensions.childTokens&&he.defaults.extensions.childTokens[Pe.type]?he.defaults.extensions.childTokens[Pe.type].forEach(function(je){ie=ie.concat(he.walkTokens(Pe[je],_))}):Pe.tokens&&(ie=ie.concat(he.walkTokens(Pe.tokens,_)))}},te=I(ge),fe;!(fe=te()).done;)G();return ie},he.parseInline=function(ge,_){if(typeof ge>"u"||ge===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");_=S({},he.defaults,_||{}),E(_);try{var ie=Y.lexInline(ge,_);return _.walkTokens&&he.walkTokens(ie,_.walkTokens),x.parseInline(ie,_)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,_.silent)return"<p>An error occurred:</p><pre>"+k(G.message+"",!0)+"</pre>";throw G}},he.Parser=x,he.parser=x.parse,he.Renderer=ue,he.TextRenderer=X,he.Lexer=Y,he.lexer=Y.lex,he.Tokenizer=F,he.Slugger=J,he.parse=he;var Z=he.options,we=he.setOptions,ce=he.use,K=he.walkTokens,B=he.parseInline,re=he,ye=x.parse,de=Y.lex;me.Lexer=Y,me.Parser=x,me.Renderer=ue,me.Slugger=J,me.TextRenderer=X,me.Tokenizer=F,me.getDefaults=R,me.lexer=de,me.marked=he,me.options=Z,me.parse=re,me.parseInline=B,me.parser=ye,me.setOptions=we,me.use=ce,me.walkTokens=K,Object.defineProperty(me,"__esModule",{value:!0})}),define(Se[161],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oj=void 0;function D(l){const f=I(l);if(f&&f.length>0)return new Uint32Array(f)}e.$Oj=D;let N=0;const g=new Uint32Array(10);function I(l){if(N=0,R(l,C,4352),N>0||(R(l,m,4449),N>0)||(R(l,v,4520),N>0)||(R(l,k,12593),N))return g.subarray(0,N);if(l>=44032&&l<=55203){const f=l-44032,s=f%588,i=Math.floor(f/588),n=Math.floor(s/28),o=s%28-1;if(i<C.length?R(i,C,0):4352+i-12593<k.length&&R(4352+i,k,12593),n<m.length?R(n,m,0):4449+n-12593<k.length&&R(4449+n-12593,k,12593),o>=0&&(o<v.length?R(o,v,0):4520+o-12593<k.length&&R(4520+o-12593,k,12593)),N>0)return g.subarray(0,N)}}function R(l,f,s){l>=s&&l<s+f.length&&b(f[l-s])}function b(l){l!==0&&(g[N++]=l&255,l>>8&&(g[N++]=l>>8&255),l>>16&&(g[N++]=l>>16&255))}var $;(function(l){l[l.InitialConsonant=4352]="InitialConsonant",l[l.Vowel=4449]="Vowel",l[l.FinalConsonant=4520]="FinalConsonant",l[l.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var y;(function(l){l[l.NUL=0]="NUL",l[l.A=65]="A",l[l.B=66]="B",l[l.C=67]="C",l[l.D=68]="D",l[l.E=69]="E",l[l.F=70]="F",l[l.G=71]="G",l[l.H=72]="H",l[l.I=73]="I",l[l.J=74]="J",l[l.K=75]="K",l[l.L=76]="L",l[l.M=77]="M",l[l.N=78]="N",l[l.O=79]="O",l[l.P=80]="P",l[l.Q=81]="Q",l[l.R=82]="R",l[l.S=83]="S",l[l.T=84]="T",l[l.U=85]="U",l[l.V=86]="V",l[l.W=87]="W",l[l.X=88]="X",l[l.Y=89]="Y",l[l.Z=90]="Z",l[l.a=97]="a",l[l.b=98]="b",l[l.c=99]="c",l[l.d=100]="d",l[l.e=101]="e",l[l.f=102]="f",l[l.g=103]="g",l[l.h=104]="h",l[l.i=105]="i",l[l.j=106]="j",l[l.k=107]="k",l[l.l=108]="l",l[l.m=109]="m",l[l.n=110]="n",l[l.o=111]="o",l[l.p=112]="p",l[l.q=113]="q",l[l.r=114]="r",l[l.s=115]="s",l[l.t=116]="t",l[l.u=117]="u",l[l.v=118]="v",l[l.w=119]="w",l[l.x=120]="x",l[l.y=121]="y",l[l.z=122]="z"})(y||(y={}));var A;(function(l){l[l.fa=24934]="fa",l[l.fg=26470]="fg",l[l.fq=29030]="fq",l[l.fr=29286]="fr",l[l.ft=29798]="ft",l[l.fv=30310]="fv",l[l.fx=30822]="fx",l[l.hk=27496]="hk",l[l.hl=27752]="hl",l[l.ho=28520]="ho",l[l.ml=27757]="ml",l[l.nj=27246]="nj",l[l.nl=27758]="nl",l[l.np=28782]="np",l[l.qt=29809]="qt",l[l.rt=29810]="rt",l[l.sg=26483]="sg",l[l.sw=30579]="sw"})(A||(A={}));const C=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),m=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),v=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),k=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Se[76],ke([1,0,28]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fl=e.$El=e.$Dl=void 0;const N=new D.$Dc(1e4);function g(y){return $(y,"NFC",N)}e.$Dl=g;const I=new D.$Dc(1e4);function R(y){return $(y,"NFD",I)}e.$El=R;const b=/[^\u0000-\u0080]/;function $(y,A,C){if(!y)return y;const m=C.get(y);if(m)return m;let v;return b.test(y)?v=y.normalize(A):v=y,C.set(y,v),v}e.$Fl=function(){const y=/[\u0300-\u036f]/g;return function(A){return R(A).replace(y,"")}}()}),define(Se[122],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8l=e.$7l=e.$6l=e.rot=e.$4l=void 0;function D(b,$,y){return Math.min(Math.max(b,$),y)}e.$4l=D;function N(b,$){return($+b%$)%$}e.rot=N;class g{constructor(){this.a=0}getNext(){return this.a++}}e.$6l=g;class I{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$7l=I;class R{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const y=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=y,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$8l=R}),function(){function me(g){const I=[];typeof g=="number"&&I.push("code/timeOrigin",g);function R($){I.push($,Date.now())}function b(){const $=[];for(let y=0;y<I.length;y+=2)$.push({name:I[y],startTime:I[y+1]});return $}return{mark:R,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(g){performance.mark(g)},getMarks(){let g=performance.timeOrigin;typeof g!="number"&&(g=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(g)}];for(const R of performance.getEntriesByType("mark"))I.push({name:R.name,startTime:Math.round(g+R.startTime)});return I}};if(typeof process=="object"){const g=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(g)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function D(g){return g.MonacoPerformanceMarks||(g.MonacoPerformanceMarks=e()),g.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=D(N))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var N in D)(typeof exports=="object"?exports:me)[N]=D[N]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function D(N){if(e[N])return e[N].exports;var g=e[N]={i:N,l:!1,exports:{}};return me[N].call(g.exports,g,g.exports,D),g.l=!0,g.exports}return D.m=me,D.c=e,D.d=function(N,g,I){D.o(N,g)||Object.defineProperty(N,g,{enumerable:!0,get:I})},D.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},D.t=function(N,g){if(1&g&&(N=D(N)),8&g||4&g&&typeof N=="object"&&N&&N.__esModule)return N;var I=Object.create(null);if(D.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:N}),2&g&&typeof N!="string")for(var R in N)D.d(I,R,function(b){return N[b]}.bind(null,R));return I},D.n=function(N){var g=N&&N.__esModule?function(){return N.default}:function(){return N};return D.d(g,"a",g),g},D.o=function(N,g){return Object.prototype.hasOwnProperty.call(N,g)},D.p="",D(D.s=0)}([function(me,e,D){(function(N){var g;e=me.exports=ce,g=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var I=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],$=e.src=[],y=0,A=y++;$[A]="0|[1-9]\\d*";var C=y++;$[C]="[0-9]+";var m=y++;$[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=y++;$[v]="("+$[A]+")\\.("+$[A]+")\\.("+$[A]+")";var k=y++;$[k]="("+$[C]+")\\.("+$[C]+")\\.("+$[C]+")";var l=y++;$[l]="(?:"+$[A]+"|"+$[m]+")";var f=y++;$[f]="(?:"+$[C]+"|"+$[m]+")";var s=y++;$[s]="(?:-("+$[l]+"(?:\\."+$[l]+")*))";var i=y++;$[i]="(?:-?("+$[f]+"(?:\\."+$[f]+")*))";var n=y++;$[n]="[0-9A-Za-z-]+";var o=y++;$[o]="(?:\\+("+$[n]+"(?:\\."+$[n]+")*))";var c=y++,t="v?"+$[v]+$[s]+"?"+$[o]+"?";$[c]="^"+t+"$";var r="[v=\\s]*"+$[k]+$[i]+"?"+$[o]+"?",d=y++;$[d]="^"+r+"$";var u=y++;$[u]="((?:<|>)?=?)";var a=y++;$[a]=$[C]+"|x|X|\\*";var h=y++;$[h]=$[A]+"|x|X|\\*";var S=y++;$[S]="[v=\\s]*("+$[h]+")(?:\\.("+$[h]+")(?:\\.("+$[h]+")(?:"+$[s]+")?"+$[o]+"?)?)?";var P=y++;$[P]="[v=\\s]*("+$[a]+")(?:\\.("+$[a]+")(?:\\.("+$[a]+")(?:"+$[i]+")?"+$[o]+"?)?)?";var w=y++;$[w]="^"+$[u]+"\\s*"+$[S]+"$";var p=y++;$[p]="^"+$[u]+"\\s*"+$[P]+"$";var E=y++;$[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=y++;$[L]="(?:~>?)";var T=y++;$[T]="(\\s*)"+$[L]+"\\s+",b[T]=new RegExp($[T],"g");var U=y++;$[U]="^"+$[L]+$[S]+"$";var F=y++;$[F]="^"+$[L]+$[P]+"$";var j=y++;$[j]="(?:\\^)";var O=y++;$[O]="(\\s*)"+$[j]+"\\s+",b[O]=new RegExp($[O],"g");var M=y++;$[M]="^"+$[j]+$[S]+"$";var W=y++;$[W]="^"+$[j]+$[P]+"$";var Y=y++;$[Y]="^"+$[u]+"\\s*("+r+")$|^$";var ue=y++;$[ue]="^"+$[u]+"\\s*("+t+")$|^$";var X=y++;$[X]="(\\s*)"+$[u]+"\\s*("+r+"|"+$[S]+")",b[X]=new RegExp($[X],"g");var J=y++;$[J]="^\\s*("+$[S]+")\\s+-\\s+("+$[S]+")\\s*$";var x=y++;$[x]="^\\s*("+$[P]+")\\s+-\\s+("+$[P]+")\\s*$";var he=y++;$[he]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)g(Z,$[Z]),b[Z]||(b[Z]=new RegExp($[Z]));function we(V,oe){if(V instanceof ce)return V;if(typeof V!="string"||V.length>I||!(oe?b[d]:b[c]).test(V))return null;try{return new ce(V,oe)}catch{return null}}function ce(V,oe){if(V instanceof ce){if(V.loose===oe)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof ce))return new ce(V,oe);g("SemVer",V,oe),this.loose=oe;var le=V.trim().match(oe?b[d]:b[c]);if(!le)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+le[1],this.minor=+le[2],this.patch=+le[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");le[4]?this.prerelease=le[4].split(".").map(function(Re){if(/^[0-9]+$/.test(Re)){var je=+Re;if(je>=0&&je<R)return je}return Re}):this.prerelease=[],this.build=le[5]?le[5].split("."):[],this.format()}e.parse=we,e.valid=function(V,oe){var le=we(V,oe);return le?le.version:null},e.clean=function(V,oe){var le=we(V.trim().replace(/^[=v]+/,""),oe);return le?le.version:null},e.SemVer=ce,ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ce.prototype.toString=function(){return this.version},ce.prototype.compare=function(V){return g("SemVer.compare",this.version,this.loose,V),V instanceof ce||(V=new ce(V,this.loose)),this.compareMain(V)||this.comparePre(V)},ce.prototype.compareMain=function(V){return V instanceof ce||(V=new ce(V,this.loose)),B(this.major,V.major)||B(this.minor,V.minor)||B(this.patch,V.patch)},ce.prototype.comparePre=function(V){if(V instanceof ce||(V=new ce(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var oe=0;do{var le=this.prerelease[oe],Re=V.prerelease[oe];if(g("prerelease compare",oe,le,Re),le===void 0&&Re===void 0)return 0;if(Re===void 0)return 1;if(le===void 0)return-1;if(le!==Re)return B(le,Re)}while(++oe)},ce.prototype.inc=function(V,oe){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",oe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",oe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",oe),this.inc("pre",oe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",oe),this.inc("pre",oe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var le=this.prerelease.length;--le>=0;)typeof this.prerelease[le]=="number"&&(this.prerelease[le]++,le=-2);le===-1&&this.prerelease.push(0)}oe&&(this.prerelease[0]===oe?isNaN(this.prerelease[1])&&(this.prerelease=[oe,0]):this.prerelease=[oe,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,oe,le,Re){typeof le=="string"&&(Re=le,le=void 0);try{return new ce(V,le).inc(oe,Re).version}catch{return null}},e.diff=function(V,oe){if(ge(V,oe))return null;var le=we(V),Re=we(oe);if(le.prerelease.length||Re.prerelease.length){for(var je in le)if((je==="major"||je==="minor"||je==="patch")&&le[je]!==Re[je])return"pre"+je;return"prerelease"}for(var je in le)if((je==="major"||je==="minor"||je==="patch")&&le[je]!==Re[je])return je},e.compareIdentifiers=B;var K=/^[0-9]+$/;function B(V,oe){var le=K.test(V),Re=K.test(oe);return le&&Re&&(V=+V,oe=+oe),le&&!Re?-1:Re&&!le?1:V<oe?-1:V>oe?1:0}function re(V,oe,le){return new ce(V,le).compare(new ce(oe,le))}function ye(V,oe,le){return re(V,oe,le)>0}function de(V,oe,le){return re(V,oe,le)<0}function ge(V,oe,le){return re(V,oe,le)===0}function _(V,oe,le){return re(V,oe,le)!==0}function ie(V,oe,le){return re(V,oe,le)>=0}function G(V,oe,le){return re(V,oe,le)<=0}function te(V,oe,le,Re){var je;switch(oe){case"===":typeof V=="object"&&(V=V.version),typeof le=="object"&&(le=le.version),je=V===le;break;case"!==":typeof V=="object"&&(V=V.version),typeof le=="object"&&(le=le.version),je=V!==le;break;case"":case"=":case"==":je=ge(V,le,Re);break;case"!=":je=_(V,le,Re);break;case">":je=ye(V,le,Re);break;case">=":je=ie(V,le,Re);break;case"<":je=de(V,le,Re);break;case"<=":je=G(V,le,Re);break;default:throw new TypeError("Invalid operator: "+oe)}return je}function fe(V,oe){if(V instanceof fe){if(V.loose===oe)return V;V=V.value}if(!(this instanceof fe))return new fe(V,oe);g("comparator",V,oe),this.loose=oe,this.parse(V),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,g("comp",this)}e.rcompareIdentifiers=function(V,oe){return B(oe,V)},e.major=function(V,oe){return new ce(V,oe).major},e.minor=function(V,oe){return new ce(V,oe).minor},e.patch=function(V,oe){return new ce(V,oe).patch},e.compare=re,e.compareLoose=function(V,oe){return re(V,oe,!0)},e.rcompare=function(V,oe,le){return re(oe,V,le)},e.sort=function(V,oe){return V.sort(function(le,Re){return e.compare(le,Re,oe)})},e.rsort=function(V,oe){return V.sort(function(le,Re){return e.rcompare(le,Re,oe)})},e.gt=ye,e.lt=de,e.eq=ge,e.neq=_,e.gte=ie,e.lte=G,e.cmp=te,e.Comparator=fe;var ve={};function Pe(V,oe){if(V instanceof Pe)return V.loose===oe?V:new Pe(V.raw,oe);if(V instanceof fe)return new Pe(V.value,oe);if(!(this instanceof Pe))return new Pe(V,oe);if(this.loose=oe,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(le){return this.parseRange(le.trim())},this).filter(function(le){return le.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function be(V){return!V||V.toLowerCase()==="x"||V==="*"}function De(V,oe,le,Re,je,He,Je,_e,ct,ot,rt,Ae,Ue){return((oe=be(le)?"":be(Re)?">="+le+".0.0":be(je)?">="+le+"."+Re+".0":">="+oe)+" "+(_e=be(ct)?"":be(ot)?"<"+(+ct+1)+".0.0":be(rt)?"<"+ct+"."+(+ot+1)+".0":Ae?"<="+ct+"."+ot+"."+rt+"-"+Ae:"<="+_e)).trim()}function z(V,oe){for(var le=0;le<V.length;le++)if(!V[le].test(oe))return!1;if(oe.prerelease.length){for(le=0;le<V.length;le++)if(g(V[le].semver),V[le].semver!==ve&&V[le].semver.prerelease.length>0){var Re=V[le].semver;if(Re.major===oe.major&&Re.minor===oe.minor&&Re.patch===oe.patch)return!0}return!1}return!0}function Q(V,oe,le){try{oe=new Pe(oe,le)}catch{return!1}return oe.test(V)}function ee(V,oe,le,Re){var je,He,Je,_e,ct;switch(V=new ce(V,Re),oe=new Pe(oe,Re),le){case">":je=ye,He=G,Je=de,_e=">",ct=">=";break;case"<":je=de,He=ie,Je=ye,_e="<",ct="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Q(V,oe,Re))return!1;for(var ot=0;ot<oe.set.length;++ot){var rt=oe.set[ot],Ae=null,Ue=null;if(rt.forEach(function(Le){Le.semver===ve&&(Le=new fe(">=0.0.0")),Ae=Ae||Le,Ue=Ue||Le,je(Le.semver,Ae.semver,Re)?Ae=Le:Je(Le.semver,Ue.semver,Re)&&(Ue=Le)}),Ae.operator===_e||Ae.operator===ct||(!Ue.operator||Ue.operator===_e)&&He(V,Ue.semver)||Ue.operator===ct&&Je(V,Ue.semver))return!1}return!0}fe.prototype.parse=function(V){var oe=this.loose?b[Y]:b[ue],le=V.match(oe);if(!le)throw new TypeError("Invalid comparator: "+V);this.operator=le[1],this.operator==="="&&(this.operator=""),le[2]?this.semver=new ce(le[2],this.loose):this.semver=ve},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(V){return g("Comparator.test",V,this.loose),this.semver===ve||(typeof V=="string"&&(V=new ce(V,this.loose)),te(V,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(V,oe){if(!(V instanceof fe))throw new TypeError("a Comparator is required");var le;if(this.operator==="")return le=new Pe(V.value,oe),Q(this.value,le,oe);if(V.operator==="")return le=new Pe(this.value,oe),Q(V.semver,le,oe);var Re=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),He=this.semver.version===V.semver.version,Je=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),_e=te(this.semver,"<",V.semver,oe)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),ct=te(this.semver,">",V.semver,oe)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return Re||je||He&&Je||_e||ct},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(V){var oe=this.loose;V=V.trim(),g("range",V,oe);var le=oe?b[x]:b[J];V=V.replace(le,De),g("hyphen replace",V),V=V.replace(b[X],"$1$2$3"),g("comparator trim",V,b[X]),V=(V=(V=V.replace(b[T],"$1~")).replace(b[O],"$1^")).split(/\s+/).join(" ");var Re=oe?b[Y]:b[ue],je=V.split(" ").map(function(He){return function(Je,_e){return g("comp",Je),Je=function(ct,ot){return ct.trim().split(/\s+/).map(function(rt){return function(Ae,Ue){g("caret",Ae,Ue);var Le=Ue?b[W]:b[M];return Ae.replace(Le,function(Xe,ne,ae,Ie,Ve){var Ze;return g("caret",Ae,Xe,ne,ae,Ie,Ve),be(ne)?Ze="":be(ae)?Ze=">="+ne+".0.0 <"+(+ne+1)+".0.0":be(Ie)?Ze=ne==="0"?">="+ne+"."+ae+".0 <"+ne+"."+(+ae+1)+".0":">="+ne+"."+ae+".0 <"+(+ne+1)+".0.0":Ve?(g("replaceCaret pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ze=ne==="0"?ae==="0"?">="+ne+"."+ae+"."+Ie+Ve+" <"+ne+"."+ae+"."+(+Ie+1):">="+ne+"."+ae+"."+Ie+Ve+" <"+ne+"."+(+ae+1)+".0":">="+ne+"."+ae+"."+Ie+Ve+" <"+(+ne+1)+".0.0"):(g("no pr"),Ze=ne==="0"?ae==="0"?">="+ne+"."+ae+"."+Ie+" <"+ne+"."+ae+"."+(+Ie+1):">="+ne+"."+ae+"."+Ie+" <"+ne+"."+(+ae+1)+".0":">="+ne+"."+ae+"."+Ie+" <"+(+ne+1)+".0.0"),g("caret return",Ze),Ze})}(rt,ot)}).join(" ")}(Je,_e),g("caret",Je),Je=function(ct,ot){return ct.trim().split(/\s+/).map(function(rt){return function(Ae,Ue){var Le=Ue?b[F]:b[U];return Ae.replace(Le,function(Xe,ne,ae,Ie,Ve){var Ze;return g("tilde",Ae,Xe,ne,ae,Ie,Ve),be(ne)?Ze="":be(ae)?Ze=">="+ne+".0.0 <"+(+ne+1)+".0.0":be(Ie)?Ze=">="+ne+"."+ae+".0 <"+ne+"."+(+ae+1)+".0":Ve?(g("replaceTilde pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ze=">="+ne+"."+ae+"."+Ie+Ve+" <"+ne+"."+(+ae+1)+".0"):Ze=">="+ne+"."+ae+"."+Ie+" <"+ne+"."+(+ae+1)+".0",g("tilde return",Ze),Ze})}(rt,ot)}).join(" ")}(Je,_e),g("tildes",Je),Je=function(ct,ot){return g("replaceXRanges",ct,ot),ct.split(/\s+/).map(function(rt){return function(Ae,Ue){Ae=Ae.trim();var Le=Ue?b[p]:b[w];return Ae.replace(Le,function(Xe,ne,ae,Ie,Ve,Ze){g("xRange",Ae,Xe,ne,ae,Ie,Ve,Ze);var nt=be(ae),it=nt||be(Ie),Oe=it||be(Ve);return ne==="="&&Oe&&(ne=""),nt?Xe=ne===">"||ne==="<"?"<0.0.0":"*":ne&&Oe?(it&&(Ie=0),Oe&&(Ve=0),ne===">"?(ne=">=",it?(ae=+ae+1,Ie=0,Ve=0):Oe&&(Ie=+Ie+1,Ve=0)):ne==="<="&&(ne="<",it?ae=+ae+1:Ie=+Ie+1),Xe=ne+ae+"."+Ie+"."+Ve):it?Xe=">="+ae+".0.0 <"+(+ae+1)+".0.0":Oe&&(Xe=">="+ae+"."+Ie+".0 <"+ae+"."+(+Ie+1)+".0"),g("xRange return",Xe),Xe})}(rt,ot)}).join(" ")}(Je,_e),g("xrange",Je),Je=function(ct,ot){return g("replaceStars",ct,ot),ct.trim().replace(b[he],"")}(Je,_e),g("stars",Je),Je}(He,oe)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(He){return!!He.match(Re)})),je=je.map(function(He){return new fe(He,oe)})},Pe.prototype.intersects=function(V,oe){if(!(V instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(le){return le.every(function(Re){return V.set.some(function(je){return je.every(function(He){return Re.intersects(He,oe)})})})})},e.toComparators=function(V,oe){return new Pe(V,oe).set.map(function(le){return le.map(function(Re){return Re.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new ce(V,this.loose));for(var oe=0;oe<this.set.length;oe++)if(z(this.set[oe],V))return!0;return!1},e.satisfies=Q,e.maxSatisfying=function(V,oe,le){var Re=null,je=null;try{var He=new Pe(oe,le)}catch{return null}return V.forEach(function(Je){He.test(Je)&&(Re&&je.compare(Je)!==-1||(je=new ce(Re=Je,le)))}),Re},e.minSatisfying=function(V,oe,le){var Re=null,je=null;try{var He=new Pe(oe,le)}catch{return null}return V.forEach(function(Je){He.test(Je)&&(Re&&je.compare(Je)!==1||(je=new ce(Re=Je,le)))}),Re},e.validRange=function(V,oe){try{return new Pe(V,oe).range||"*"}catch{return null}},e.ltr=function(V,oe,le){return ee(V,oe,"<",le)},e.gtr=function(V,oe,le){return ee(V,oe,">",le)},e.outside=ee,e.prerelease=function(V,oe){var le=we(V,oe);return le&&le.prerelease.length?le.prerelease:null},e.intersects=function(V,oe,le){return V=new Pe(V,le),oe=new Pe(oe,le),V.intersects(oe)},e.coerce=function(V){if(V instanceof ce)return V;if(typeof V!="string")return null;var oe=V.match(b[E]);return oe==null?null:we((oe[1]||"0")+"."+(oe[2]||"0")+"."+(oe[3]||"0"))}}).call(this,D(1))},function(me,e){var D,N,g=me.exports={};function I(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function b(f){if(D===setTimeout)return setTimeout(f,0);if((D===I||!D)&&setTimeout)return D=setTimeout,setTimeout(f,0);try{return D(f,0)}catch{try{return D.call(null,f,0)}catch{return D.call(this,f,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:I}catch{D=I}try{N=typeof clearTimeout=="function"?clearTimeout:R}catch{N=R}})();var $,y=[],A=!1,C=-1;function m(){A&&$&&(A=!1,$.length?y=$.concat(y):C=-1,y.length&&v())}function v(){if(!A){var f=b(m);A=!0;for(var s=y.length;s;){for($=y,y=[];++C<s;)$&&$[C].run();C=-1,s=y.length}$=null,A=!1,function(i){if(N===clearTimeout)return clearTimeout(i);if((N===R||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(i);try{N(i)}catch{try{return N.call(null,i)}catch{return N.call(this,i)}}}(f)}}function k(f,s){this.fun=f,this.array=s}function l(){}g.nextTick=function(f){var s=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)s[i-1]=arguments[i];y.push(new k(f,s)),y.length!==1||A||b(v)},k.prototype.run=function(){this.fun.apply(null,this.array)},g.title="browser",g.browser=!0,g.env={},g.argv=[],g.version="",g.versions={},g.on=l,g.addListener=l,g.once=l,g.off=l,g.removeListener=l,g.removeAllListeners=l,g.emit=l,g.prependListener=l,g.prependOnceListener=l,g.listeners=function(f){return[]},g.binding=function(f){throw new Error("process.binding is not supported")},g.cwd=function(){return"/"},g.chdir=function(f){throw new Error("process.chdir is not supported")},g.umask=function(){return 0}}])}),define(Se[38],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(I){return new N(I)}constructor(I){this.c=D&&I===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Od=N}),define(Se[4],ke([1,0,14,74,3,75,38]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.Event=void 0;const b=!1,$=!1;var y;(function(w){w.None=()=>g.$Sc.None;function p(te){if($){const{onDidAddListener:fe}=te,ve=k.create();let Pe=0;te.onDidAddListener=()=>{++Pe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ve.print()),fe?.()}}}function E(te,fe){return ue(te,()=>{},0,void 0,!0,void 0,fe)}w.defer=E;function L(te){return(fe,ve=null,Pe)=>{let be=!1,De;return De=te(z=>{if(!be)return De?De.dispose():be=!0,fe.call(ve,z)},null,Pe),be&&De.dispose(),De}}w.once=L;function T(te,fe,ve){return W((Pe,be=null,De)=>te(z=>Pe.call(be,fe(z)),null,De),ve)}w.map=T;function U(te,fe,ve){return W((Pe,be=null,De)=>te(z=>{fe(z),Pe.call(be,z)},null,De),ve)}w.forEach=U;function F(te,fe,ve){return W((Pe,be=null,De)=>te(z=>fe(z)&&Pe.call(be,z),null,De),ve)}w.filter=F;function j(te){return te}w.signal=j;function O(...te){return(fe,ve=null,Pe)=>{const be=(0,g.$Pc)(...te.map(De=>De(z=>fe.call(ve,z))));return Y(be,Pe)}}w.any=O;function M(te,fe,ve,Pe){let be=ve;return T(te,De=>(be=fe(be,De),be),Pe)}w.reduce=M;function W(te,fe){let ve;const Pe={onWillAddFirstListener(){ve=te(be.fire,be)},onDidRemoveLastListener(){ve?.dispose()}};fe||p(Pe);const be=new n(Pe);return fe?.add(be),be.event}function Y(te,fe){return fe instanceof Array?fe.push(te):fe&&fe.add(te),te}function ue(te,fe,ve=100,Pe=!1,be=!1,De,z){let Q,ee,V,oe=0,le;const Re={leakWarningThreshold:De,onWillAddFirstListener(){Q=te(He=>{oe++,ee=fe(ee,He),Pe&&!V&&(je.fire(ee),ee=void 0),le=()=>{const Je=ee;ee=void 0,V=void 0,(!Pe||oe>1)&&je.fire(Je),oe=0},typeof ve=="number"?(clearTimeout(V),V=setTimeout(le,ve)):V===void 0&&(V=0,queueMicrotask(le))})},onWillRemoveListener(){be&&oe>0&&le?.()},onDidRemoveLastListener(){le=void 0,Q.dispose()}};z||p(Re);const je=new n(Re);return z?.add(je),je.event}w.debounce=ue;function X(te,fe=0,ve){return w.debounce(te,(Pe,be)=>Pe?(Pe.push(be),Pe):[be],fe,void 0,!0,void 0,ve)}w.accumulate=X;function J(te,fe=(Pe,be)=>Pe===be,ve){let Pe=!0,be;return F(te,De=>{const z=Pe||!fe(De,be);return Pe=!1,be=De,z},ve)}w.latch=J;function x(te,fe,ve){return[w.filter(te,fe,ve),w.filter(te,Pe=>!fe(Pe),ve)]}w.split=x;function he(te,fe=!1,ve=[],Pe){let be=ve.slice(),De=te(ee=>{be?be.push(ee):Q.fire(ee)});Pe&&Pe.add(De);const z=()=>{be?.forEach(ee=>Q.fire(ee)),be=null},Q=new n({onWillAddFirstListener(){De||(De=te(ee=>Q.fire(ee)),Pe&&Pe.add(De))},onDidAddFirstListener(){be&&(fe?setTimeout(z):z())},onDidRemoveLastListener(){De&&De.dispose(),De=null}});return Pe&&Pe.add(Q),Q.event}w.buffer=he;function Z(te,fe){return(Pe,be,De)=>{const z=fe(new ce);return te(function(Q){const ee=z.evaluate(Q);ee!==we&&Pe.call(be,ee)},void 0,De)}}w.chain=Z;const we=Symbol("HaltChainable");class ce{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(ve=>(fe(ve),ve)),this}filter(fe){return this.f.push(ve=>fe(ve)?ve:we),this}reduce(fe,ve){let Pe=ve;return this.f.push(be=>(Pe=fe(Pe,be),Pe)),this}latch(fe=(ve,Pe)=>ve===Pe){let ve=!0,Pe;return this.f.push(be=>{const De=ve||!fe(be,Pe);return ve=!1,Pe=be,De?be:we}),this}evaluate(fe){for(const ve of this.f)if(fe=ve(fe),fe===we)break;return fe}}function K(te,fe,ve=Pe=>Pe){const Pe=(...Q)=>z.fire(ve(...Q)),be=()=>te.on(fe,Pe),De=()=>te.removeListener(fe,Pe),z=new n({onWillAddFirstListener:be,onDidRemoveLastListener:De});return z.event}w.fromNodeEventEmitter=K;function B(te,fe,ve=Pe=>Pe){const Pe=(...Q)=>z.fire(ve(...Q)),be=()=>te.addEventListener(fe,Pe),De=()=>te.removeEventListener(fe,Pe),z=new n({onWillAddFirstListener:be,onDidRemoveLastListener:De});return z.event}w.fromDOMEventEmitter=B;function re(te){return new Promise(fe=>L(te)(fe))}w.toPromise=re;function ye(te){const fe=new n;return te.then(ve=>{fe.fire(ve)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}w.fromPromise=ye;function de(te,fe,ve){return fe(ve),te(Pe=>fe(Pe))}w.runAndSubscribe=de;function ge(te,fe){let ve=null;function Pe(De){ve?.dispose(),ve=new g.$Rc,fe(De,ve)}Pe(void 0);const be=te(De=>Pe(De));return(0,g.$Qc)(()=>{be.dispose(),ve?.dispose()})}w.runAndSubscribeWithStore=ge;class _{constructor(fe,ve){this._observable=fe,this.f=0,this.g=!1;const Pe={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};ve||p(Pe),this.emitter=new n(Pe),ve&&ve.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,ve){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ie(te,fe){return new _(te,fe).emitter.event}w.fromObservable=ie;function G(te){return(fe,ve,Pe)=>{let be=0,De=!1;const z={beginUpdate(){be++},endUpdate(){be--,be===0&&(te.reportChanges(),De&&(De=!1,fe.call(ve)))},handlePossibleChange(){},handleChange(){De=!0}};te.addObserver(z),te.reportChanges();const Q={dispose(){te.removeObserver(z)}};return Pe instanceof g.$Rc?Pe.add(Q):Array.isArray(Pe)&&Pe.push(Q),Q}}w.fromObservableLight=G})(y||(e.Event=y={}));class A{static{this.all=new Set}static{this.f=0}constructor(p){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${p}_${A.f++}`,A.all.add(this)}start(p){this.g=new R.$Od,this.listenerCount=p}stop(){if(this.g){const p=this.g.elapsed();this.durations.push(p),this.elapsedOverall+=p,this.invocationCount+=1,this.g=void 0}}}e.$Qd=A;let C=-1;function m(w){const p=C;return C=w,{dispose(){C=p}}}e.$Rd=m;class v{constructor(p,E=Math.random().toString(18).slice(2,5)){this.threshold=p,this.name=E,this.g=0}dispose(){this.f?.clear()}check(p,E){const L=this.threshold;if(L<=0||E<L)return;this.f||(this.f=new Map);const T=this.f.get(p.value)||0;if(this.f.set(p.value,T+1),this.g-=1,this.g<=0){this.g=L*.5;let U,F=0;for(const[j,O]of this.f)(!U||F<O)&&(U=j,F=O);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${F}):`),console.warn(U)}return()=>{const U=this.f.get(p.value)||0;this.f.set(p.value,U-1)}}}class k{static create(){return new k(new Error().stack??"")}constructor(p){this.value=p}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let l=0;class f{constructor(p){this.value=p,this.id=l++}}const s=2,i=(w,p)=>{if(w instanceof f)p(w);else for(let E=0;E<w.length;E++){const L=w[E];L&&p(L)}};class n{constructor(p){this.w=0,this.f=p,this.g=C>0||this.f?.leakWarningThreshold?new v(this.f?.leakWarningThreshold??C):void 0,this.j=this.f?._profName?new A(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(b){const p=this.t;queueMicrotask(()=>{i(p,E=>E.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(p,E,L)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),g.$Sc.None;if(this.m)return g.$Sc.None;E&&(p=p.bind(E));const T=new f(p);let U,F;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(T.stack=k.create(),U=this.g.check(T.stack,this.w+1)),b&&(T.stack=F??k.create()),this.t?this.t instanceof f?(this.u??=new c,this.t=[this.t,T]):this.t.push(T):(this.f?.onWillAddFirstListener?.(this),this.t=T,this.f?.onDidAddFirstListener?.(this)),this.w++;const j=(0,g.$Qc)(()=>{U?.(),this.x(T)});return L instanceof g.$Rc?L.add(j):Array.isArray(L)&&L.push(j),j},this.q}x(p){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const E=this.t,L=E.indexOf(p);if(L===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,E[L]=void 0;const T=this.u.current===this;if(this.w*s<=E.length){let U=0;for(let F=0;F<E.length;F++)E[F]?E[U++]=E[F]:T&&(this.u.end--,U<this.u.i&&this.u.i--);E.length=U}}y(p,E){if(!p)return;const L=this.f?.onListenerError||D.$1;if(!L){p.value(E);return}try{p.value(E)}catch(T){L(T)}}z(p){const E=p.current.t;for(;p.i<p.end;)this.y(E[p.i++],p.value);p.reset()}fire(p){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof f)this.y(this.t,p);else{const E=this.u;E.enqueue(this,p,this.t.length),this.z(E)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Sd=n;const o=()=>new c;e.$Td=o;class c{constructor(){this.i=-1,this.end=0}enqueue(p,E,L){this.i=0,this.end=L,this.current=p,this.value=E}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends n{async fireAsync(p,E,L){if(this.t)for(this.h||(this.h=new I.$3c),i(this.t,T=>this.h.push([T.value,p]));this.h.size>0&&!E.isCancellationRequested;){const[T,U]=this.h.shift(),F=[],j={...U,token:E,waitUntil:O=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");L&&(O=L(O,T)),F.push(O)}};try{T(j)}catch(O){(0,D.$1)(O);continue}Object.freeze(F),await Promise.allSettled(F).then(O=>{for(const M of O)M.status==="rejected"&&(0,D.$1)(M.reason)})}}}e.$Ud=t;class r extends n{get isPaused(){return this.h!==0}constructor(p){super(p),this.h=0,this.s=new I.$3c,this.A=p?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const p=Array.from(this.s);this.s.clear(),super.fire(this.A(p))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(p){this.w&&(this.h!==0?this.s.push(p):super.fire(p))}}e.$Vd=r;class d extends r{constructor(p){super(p),this.k=p.delay??100}fire(p){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(p)}}e.$Wd=d;class u extends n{constructor(p){super(p),this.h=[],this.k=p?.merge}fire(p){this.hasListeners()&&(this.h.push(p),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(E=>super.fire(E)),this.h=[]}))}}e.$Xd=u;class a{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(p){const E={event:p,listener:null};this.h.push(E),this.g&&this.m(E);const L=()=>{this.g&&this.o(E);const T=this.h.indexOf(E);this.h.splice(T,1)};return(0,g.$Qc)((0,N.$db)(L))}j(){this.g=!0,this.h.forEach(p=>this.m(p))}k(){this.g=!1,this.h.forEach(p=>this.o(p))}m(p){p.listener=p.event(E=>this.f.fire(E))}o(p){p.listener&&p.listener.dispose(),p.listener=null}dispose(){this.f.dispose()}}e.$Yd=a;class h{constructor(p,E,L,T){this.f=new g.$Rc;const U=this.f.add(new a),F=this.f.add(new g.$2c);function j(O){F.set(O,U.add(T(O)))}for(const O of p)j(O);this.f.add(E(O=>{j(O)})),this.f.add(L(O=>{F.deleteAndDispose(O)})),this.event=U.event}dispose(){this.f.dispose()}}e.$Zd=h;class S{constructor(){this.f=[]}wrapEvent(p){return(E,L,T)=>p(U=>{const F=this.f[this.f.length-1];F?F.push(()=>E.call(L,U)):E.call(L,U)},void 0,T)}bufferEvents(p){const E=[];this.f.push(E);const L=p();return this.f.pop(),E.forEach(T=>T()),L}}e.$1d=S;class P{constructor(){this.f=!1,this.g=y.None,this.h=g.$Sc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(p){this.g=p,this.f&&(this.h.dispose(),this.h=p(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$2d=P}),define(Se[21],ke([1,0,4]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=e.CancellationToken=void 0;const N=Object.freeze(function(b,$){const y=setTimeout(b.bind($),0);return{dispose(){clearTimeout(y)}}});var g;(function(b){function $(y){return y===b.None||y===b.Cancelled||y instanceof I?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}b.isCancellationToken=$,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(g||(e.CancellationToken=g={}));class I{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new D.$Sd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new I),this.f}cancel(){this.f?this.f instanceof I&&this.f.cancel():this.f=g.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof I&&this.f.dispose():this.f=g.None}}e.$3d=R}),define(Se[162],ke([1,0,21]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=e.$Ce=e.$Be=void 0;class N{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new D.$3d,$=this.b(b.token);return this.a={promise:$,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$Be=N;class g{constructor(b){this.c=b,this.a=void 0,this.b=void 0}get(b){const $=JSON.stringify(b);return this.b!==$&&(this.b=$,this.a=this.c(b)),this.a}}e.$Ce=g;class I{get cachedValues(){return this.a}constructor(b){this.b=b,this.a=new Map}get(b){if(this.a.has(b))return this.a.get(b);const $=this.b(b);return this.a.set(b,$),$}}e.$De=I}),define(Se[98],ke([1,0,14,3]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;function g(o){const c=o;return c?typeof c.read=="function":!1}e.$4d=g;function I(o){const c=o;return c?[c.on,c.pause,c.resume,c.destroy].every(t=>typeof t=="function"):!1}e.$5d=I;function R(o){const c=o;return c?I(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.$6d=R;function b(o,c){return new $(o,c)}e.$7d=b;class ${constructor(c,t){this.e=c,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(c){if(!this.a.destroyed){if(this.a.flowing)this.g(c);else if(this.b.data.push(c),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(c){this.a.destroyed||(this.a.flowing?this.h(c):this.b.error.push(c))}end(c){this.a.destroyed||(typeof c<"u"&&this.write(c),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(c){this.c.data.slice(0).forEach(t=>t(c))}h(c){this.c.error.length===0?(0,D.$1)(c):this.c.error.slice(0).forEach(t=>t(c))}i(){this.c.end.slice(0).forEach(c=>c())}on(c,t){if(!this.a.destroyed)switch(c){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(c,t){if(this.a.destroyed)return;let r;switch(c){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const d=r.indexOf(t);d>=0&&r.splice(d,1)}}j(){if(this.b.data.length>0){const c=this.e(this.b.data);this.g(c),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const c of this.b.error)this.h(c);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(o,c){const t=[];let r;for(;(r=o.read())!==null;)t.push(r);return c(t)}e.$8d=y;function A(o,c,t){const r=[];let d;for(;(d=o.read())!==null&&r.length<t;)r.push(d);return d===null&&r.length>0?c(r):{read:()=>{if(r.length>0)return r.shift();if(typeof d<"u"){const u=d;return d=void 0,u}return o.read()}}}e.$9d=A;function C(o,c){return new Promise((t,r)=>{const d=[];m(o,{onData:u=>{c&&d.push(u)},onError:u=>{c?r(u):t(void 0)},onEnd:()=>{t(c?c(d):void 0)}})})}e.$0d=C;function m(o,c,t){o.on("error",r=>{t?.isCancellationRequested||c.onError(r)}),o.on("end",()=>{t?.isCancellationRequested||c.onEnd()}),o.on("data",r=>{t?.isCancellationRequested||c.onData(r)})}e.$$d=m;function v(o,c){return new Promise((t,r)=>{const d=new N.$Rc,u=[],a=P=>{if(u.push(P),u.length>c)return d.dispose(),o.pause(),t({stream:o,buffer:u,ended:!1})},h=P=>(d.dispose(),r(P)),S=()=>(d.dispose(),t({stream:o,buffer:u,ended:!0}));d.add((0,N.$Qc)(()=>o.removeListener("error",h))),o.on("error",h),d.add((0,N.$Qc)(()=>o.removeListener("end",S))),o.on("end",S),d.add((0,N.$Qc)(()=>o.removeListener("data",a))),o.on("data",a)})}e.$_d=v;function k(o,c){const t=b(c);return t.end(o),t}e.$ae=k;function l(){const o=b(()=>{throw new Error("not supported")});return o.end(),o}e.$be=l;function f(o){let c=!1;return{read:()=>c?null:(c=!0,o)}}e.$ce=f;function s(o,c,t){const r=b(t);return m(o,{onData:d=>r.write(c.data(d)),onError:d=>r.error(c.error?c.error(d):d),onEnd:()=>r.end()}),r}e.$de=s;function i(o,c,t){let r=!1;return{read:()=>{const d=c.read();return r?d:(r=!0,d!==null?t([o,d]):o)}}}e.$ee=i;function n(o,c,t){let r=!1;const d=b(t);return m(c,{onData:u=>r?d.write(u):(r=!0,d.write(t([o,u]))),onError:u=>d.error(u),onEnd:()=>{r||(r=!0,d.write(o)),d.end()}}),d}e.$fe=n}),define(Se[22],ke([1,0,43,98]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=void 0;const g=typeof Buffer<"u",I=new D.$V(()=>new Uint8Array(256));let R,b;class ${static alloc(E){return g?new $(Buffer.allocUnsafe(E)):new $(new Uint8Array(E))}static wrap(E){return g&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new $(E)}static fromString(E,L){return!(L?.dontUseNodeBuffer||!1)&&g?new $(Buffer.from(E)):(R||(R=new TextEncoder),new $(R.encode(E)))}static fromByteArray(E){const L=$.alloc(E.length);for(let T=0,U=E.length;T<U;T++)L.buffer[T]=E[T];return L}static concat(E,L){if(typeof L>"u"){L=0;for(let F=0,j=E.length;F<j;F++)L+=E[F].byteLength}const T=$.alloc(L);let U=0;for(let F=0,j=E.length;F<j;F++){const O=E[F];T.set(O,U),U+=O.byteLength}return T}constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}clone(){const E=$.alloc(this.byteLength);return E.set(this),E}toString(){return g?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(E,L){return new $(this.buffer.subarray(E,L))}set(E,L){if(E instanceof $)this.buffer.set(E.buffer,L);else if(E instanceof Uint8Array)this.buffer.set(E,L);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),L);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return m(this.buffer,E)}writeUInt32BE(E,L){v(this.buffer,E,L)}readUInt32LE(E){return k(this.buffer,E)}writeUInt32LE(E,L){l(this.buffer,E,L)}readUInt8(E){return f(this.buffer,E)}writeUInt8(E,L){s(this.buffer,E,L)}indexOf(E,L=0){return y(this.buffer,E instanceof $?E.buffer:E,L)}}e.$ge=$;function y(p,E,L=0){const T=E.byteLength,U=p.byteLength;if(T===0)return 0;if(T===1)return p.indexOf(E[0]);if(T>U-L)return-1;const F=I.value;F.fill(E.length);for(let W=0;W<E.length;W++)F[E[W]]=E.length-W-1;let j=L+E.length-1,O=j,M=-1;for(;j<U;)if(p[j]===E[O]){if(O===0){M=j;break}j--,O--}else j+=Math.max(E.length-O,F[p[j]]),O=E.length-1;return M}e.$he=y;function A(p,E){return p[E+0]<<0>>>0|p[E+1]<<8>>>0}e.$ie=A;function C(p,E,L){p[L+0]=E&255,E=E>>>8,p[L+1]=E&255}e.$je=C;function m(p,E){return p[E]*2**24+p[E+1]*2**16+p[E+2]*2**8+p[E+3]}e.$ke=m;function v(p,E,L){p[L+3]=E,E=E>>>8,p[L+2]=E,E=E>>>8,p[L+1]=E,E=E>>>8,p[L]=E}e.$le=v;function k(p,E){return p[E+0]<<0>>>0|p[E+1]<<8>>>0|p[E+2]<<16>>>0|p[E+3]<<24>>>0}e.$me=k;function l(p,E,L){p[L+0]=E&255,E=E>>>8,p[L+1]=E&255,E=E>>>8,p[L+2]=E&255,E=E>>>8,p[L+3]=E&255}e.$ne=l;function f(p,E){return p[E]}e.$oe=f;function s(p,E,L){p[L]=E}e.$pe=s;function i(p){return N.$8d(p,E=>$.concat(E))}e.$qe=i;function n(p){return N.$ce(p)}e.$re=n;function o(p){return N.$0d(p,E=>$.concat(E))}e.$se=o;async function c(p){return p.ended?$.concat(p.buffer):$.concat([...p.buffer,await o(p.stream)])}e.$te=c;function t(p){return N.$ae(p,E=>$.concat(E))}e.$ue=t;function r(p){return N.$de(p,{data:E=>typeof E=="string"?$.fromString(E):$.wrap(E)},E=>$.concat(E))}e.$ve=r;function d(p){return N.$7d(E=>$.concat(E),p)}e.$we=d;function u(p,E){return N.$ee(p,E,L=>$.concat(L))}e.$xe=u;function a(p,E){return N.$fe(p,E,L=>$.concat(L))}e.$ye=a;function h(p){let E=0,L=0,T=0;const U=new Uint8Array(Math.floor(p.length/4*3)),F=O=>{switch(L){case 3:U[T++]=E|O,L=0;break;case 2:U[T++]=E|O>>>2,E=O<<6,L=3;break;case 1:U[T++]=E|O>>>4,E=O<<4,L=2;break;default:E=O<<2,L=1}};for(let O=0;O<p.length;O++){const M=p.charCodeAt(O);if(M>=65&&M<=90)F(M-65);else if(M>=97&&M<=122)F(M-97+26);else if(M>=48&&M<=57)F(M-48+52);else if(M===43||M===45)F(62);else if(M===47||M===95)F(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${p[O]}`)}}const j=T;for(;L>0;)F(0);return $.wrap(U).slice(0,j)}e.$ze=h;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:p},E=!0,L=!1){const T=L?P:S;let U="";const F=p.byteLength%3;let j=0;for(;j<p.byteLength-F;j+=3){const O=p[j+0],M=p[j+1],W=p[j+2];U+=T[O>>>2],U+=T[(O<<4|M>>>4)&63],U+=T[(M<<2|W>>>6)&63],U+=T[W&63]}if(F===1){const O=p[j+0];U+=T[O>>>2],U+=T[O<<4&63],E&&(U+="==")}else if(F===2){const O=p[j+0],M=p[j+1];U+=T[O>>>2],U+=T[(O<<4|M>>>4)&63],U+=T[M<<2&63],E&&(U+="=")}return U}e.$Ae=w}),define(Se[12],ke([1,0,162,43]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ef=e.$Df=e.$Cf=e.$Bf=e.GraphemeBreakType=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=void 0;function g(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$Ge=g;const I=/{(\d+)}/g;function R(Ae,...Ue){return Ue.length===0?Ae:Ae.replace(I,function(Le,Xe){const ne=parseInt(Xe,10);return isNaN(ne)||ne<0||ne>=Ue.length?Le:Ue[ne]})}e.$He=R;const b=/{([^}]+)}/g;function $(Ae,Ue){return Object.keys(Ue).length===0?Ae:Ae.replace(b,(Le,Xe)=>Ue[Xe]??Le)}e.$Ie=$;function y(Ae){return Ae.replace(/[<>"'&]/g,Ue=>{switch(Ue){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Ue})}e.$Je=y;function A(Ae){return Ae.replace(/[<>&]/g,function(Ue){switch(Ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ue}})}e.$Ke=A;function C(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Le=C;function m(Ae,Ue){let Le=0;const Xe=Ue.charCodeAt(0);for(let ne=Ae.length-1;ne>=0;ne--)Ae.charCodeAt(ne)===Xe&&Le++;return Le}e.$Me=m;function v(Ae,Ue,Le="\u2026"){return Ae.length<=Ue?Ae:`${Ae.substr(0,Ue)}${Le}`}e.$Ne=v;function k(Ae,Ue,Le="\u2026"){if(Ae.length<=Ue)return Ae;const Xe=Math.ceil(Ue/2)-Le.length/2,ne=Math.floor(Ue/2)-Le.length/2;return`${Ae.substr(0,Xe)}${Le}${Ae.substr(Ae.length-ne)}`}e.$Oe=k;function l(Ae,Ue=" "){const Le=f(Ae,Ue);return s(Le,Ue)}e.$Pe=l;function f(Ae,Ue){if(!Ae||!Ue)return Ae;const Le=Ue.length;if(Le===0||Ae.length===0)return Ae;let Xe=0;for(;Ae.indexOf(Ue,Xe)===Xe;)Xe=Xe+Le;return Ae.substring(Xe)}e.$Qe=f;function s(Ae,Ue){if(!Ae||!Ue)return Ae;const Le=Ue.length,Xe=Ae.length;if(Le===0||Xe===0)return Ae;let ne=Xe,ae=-1;for(;ae=Ae.lastIndexOf(Ue,ne-1),!(ae===-1||ae+Le!==ne);){if(ae===0)return"";ne=ae}return Ae.substring(0,ne)}e.$Re=s;function i(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Se=i;function n(Ae){return Ae.replace(/\*/g,"")}e.$Te=n;function o(Ae,Ue,Le={}){if(!Ae)throw new Error("Cannot create regex from empty string");Ue||(Ae=C(Ae)),Le.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Xe="";return Le.global&&(Xe+="g"),Le.matchCase||(Xe+="i"),Le.multiline&&(Xe+="m"),Le.unicode&&(Xe+="u"),new RegExp(Ae,Xe)}e.$Ue=o;function c(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$Ve=c;function t(Ae){return Ae.split(/\r\n|\r|\n/)}e.$We=t;function r(Ae){for(let Ue=0,Le=Ae.length;Ue<Le;Ue++){const Xe=Ae.charCodeAt(Ue);if(Xe!==32&&Xe!==9)return Ue}return-1}e.$Xe=r;function d(Ae,Ue=0,Le=Ae.length){for(let Xe=Ue;Xe<Le;Xe++){const ne=Ae.charCodeAt(Xe);if(ne!==32&&ne!==9)return Ae.substring(Ue,Xe)}return Ae.substring(Ue,Le)}e.$Ye=d;function u(Ae,Ue=Ae.length-1){for(let Le=Ue;Le>=0;Le--){const Xe=Ae.charCodeAt(Le);if(Xe!==32&&Xe!==9)return Le}return-1}e.$Ze=u;function a(Ae,Ue,Le){const Xe=[];let ne=0;for(const ae of Ae.matchAll(Ue)){if(Xe.push(Ae.slice(ne,ae.index)),ae.index===void 0)throw new Error("match.index should be defined");ne=ae.index+ae[0].length,Xe.push(Le(ae[0],...ae.slice(1),ae.index,Ae,ae.groups))}return Xe.push(Ae.slice(ne)),Promise.all(Xe).then(ae=>ae.join(""))}e.$1e=a;function h(Ae,Ue){return Ae<Ue?-1:Ae>Ue?1:0}e.$2e=h;function S(Ae,Ue,Le=0,Xe=Ae.length,ne=0,ae=Ue.length){for(;Le<Xe&&ne<ae;Le++,ne++){const Ze=Ae.charCodeAt(Le),nt=Ue.charCodeAt(ne);if(Ze<nt)return-1;if(Ze>nt)return 1}const Ie=Xe-Le,Ve=ae-ne;return Ie<Ve?-1:Ie>Ve?1:0}e.$3e=S;function P(Ae,Ue){return w(Ae,Ue,0,Ae.length,0,Ue.length)}e.$4e=P;function w(Ae,Ue,Le=0,Xe=Ae.length,ne=0,ae=Ue.length){for(;Le<Xe&&ne<ae;Le++,ne++){let Ze=Ae.charCodeAt(Le),nt=Ue.charCodeAt(ne);if(Ze===nt)continue;if(Ze>=128||nt>=128)return S(Ae.toLowerCase(),Ue.toLowerCase(),Le,Xe,ne,ae);E(Ze)&&(Ze-=32),E(nt)&&(nt-=32);const it=Ze-nt;if(it!==0)return it}const Ie=Xe-Le,Ve=ae-ne;return Ie<Ve?-1:Ie>Ve?1:0}e.$5e=w;function p(Ae){return Ae>=48&&Ae<=57}e.$6e=p;function E(Ae){return Ae>=97&&Ae<=122}e.$7e=E;function L(Ae){return Ae>=65&&Ae<=90}e.$8e=L;function T(Ae,Ue){return Ae.length===Ue.length&&w(Ae,Ue)===0}e.$9e=T;function U(Ae,Ue){const Le=Ue.length;return Ue.length>Ae.length?!1:w(Ae,Ue,0,Le)===0}e.$0e=U;function F(Ae,Ue){const Le=Math.min(Ae.length,Ue.length);let Xe;for(Xe=0;Xe<Le;Xe++)if(Ae.charCodeAt(Xe)!==Ue.charCodeAt(Xe))return Xe;return Le}e.$$e=F;function j(Ae,Ue){const Le=Math.min(Ae.length,Ue.length);let Xe;const ne=Ae.length-1,ae=Ue.length-1;for(Xe=0;Xe<Le;Xe++)if(Ae.charCodeAt(ne-Xe)!==Ue.charCodeAt(ae-Xe))return Xe;return Le}e.$_e=j;function O(Ae){return 55296<=Ae&&Ae<=56319}e.$af=O;function M(Ae){return 56320<=Ae&&Ae<=57343}e.$bf=M;function W(Ae,Ue){return(Ae-55296<<10)+(Ue-56320)+65536}e.$cf=W;function Y(Ae,Ue,Le){const Xe=Ae.charCodeAt(Le);if(O(Xe)&&Le+1<Ue){const ne=Ae.charCodeAt(Le+1);if(M(ne))return W(Xe,ne)}return Xe}e.$df=Y;function ue(Ae,Ue){const Le=Ae.charCodeAt(Ue-1);if(M(Le)&&Ue>1){const Xe=Ae.charCodeAt(Ue-2);if(O(Xe))return W(Xe,Le)}return Le}class X{get offset(){return this.e}constructor(Ue,Le=0){this.c=Ue,this.d=Ue.length,this.e=Le}setOffset(Ue){this.e=Ue}prevCodePoint(){const Ue=ue(this.c,this.e);return this.e-=Ue>=65536?2:1,Ue}nextCodePoint(){const Ue=Y(this.c,this.d,this.e);return this.e+=Ue>=65536?2:1,Ue}eol(){return this.e>=this.d}}e.$ef=X;class J{get offset(){return this.c.offset}constructor(Ue,Le=0){this.c=new X(Ue,Le)}nextGraphemeLength(){const Ue=Re.getInstance(),Le=this.c,Xe=Le.offset;let ne=Ue.getGraphemeBreakType(Le.nextCodePoint());for(;!Le.eol();){const ae=Le.offset,Ie=Ue.getGraphemeBreakType(Le.nextCodePoint());if(oe(ne,Ie)){Le.setOffset(ae);break}ne=Ie}return Le.offset-Xe}prevGraphemeLength(){const Ue=Re.getInstance(),Le=this.c,Xe=Le.offset;let ne=Ue.getGraphemeBreakType(Le.prevCodePoint());for(;Le.offset>0;){const ae=Le.offset,Ie=Ue.getGraphemeBreakType(Le.prevCodePoint());if(oe(Ie,ne)){Le.setOffset(ae);break}ne=Ie}return Xe-Le.offset}eol(){return this.c.eol()}}e.$ff=J;function x(Ae,Ue){return new J(Ae,Ue).nextGraphemeLength()}e.$gf=x;function he(Ae,Ue){return new J(Ae,Ue).prevGraphemeLength()}e.$hf=he;function Z(Ae,Ue){Ue>0&&M(Ae.charCodeAt(Ue))&&Ue--;const Le=Ue+x(Ae,Ue);return[Le-he(Ae,Le),Le]}e.$if=Z;function we(Ae){const Ue=new J(Ae);let Le=0;for(;!Ue.eol();)Le++,Ue.nextGraphemeLength();return Le}e.$jf=we;let ce;function K(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function B(Ae){return ce||(ce=K()),ce.test(Ae)}e.$kf=B;const re=/^[\t\n\r\x20-\x7E]*$/;function ye(Ae){return re.test(Ae)}e.$lf=ye,e.$mf=/[\u2028\u2029]/;function de(Ae){return e.$mf.test(Ae)}e.$nf=de;function ge(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$of=ge;function _(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$pf=_;function ie(Ae,Ue,Le=""){const Xe=Ae.trimStart();if(Xe.length<Ue)return Xe;const ne=/\b/g;let ae=0;for(;ne.test(Xe)&&!(Xe.length-ne.lastIndex<Ue);)ae=ne.lastIndex,ne.lastIndex+=1;return ae===0?Xe:Le+Xe.substring(ae).trimStart()}e.$qf=ie;const G=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,te=/\x1b\].*?\x07/g;function fe(Ae){return Ae&&(Ae=Ae.replace(G,"").replace(te,"")),Ae}e.$rf=fe,e.$sf=String.fromCharCode(65279);function ve(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$tf=ve;function Pe(Ae){return ve(Ae)?Ae.substr(1):Ae}e.$uf=Pe;function be(Ae,Ue){if(!Ae||!Ue||Ae.length<Ue.length)return!1;const Le=Ue.length,Xe=Ae.toLowerCase();let ne=0,ae=-1;for(;ne<Le;){const Ie=Xe.indexOf(Ue[ne],ae+1);if(Ie<0)return!1;ae=Ie,ne++}return!0}e.$vf=be;function De(Ae,Ue=!1){return Ae?(Ue&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$wf=De;function z(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$xf=z;function Q(Ae,Ue=1){if(Ue===0)return"";let Le=-1;do Le=Ae.indexOf(`
`,Le+1),Ue--;while(Ue>0&&Le>=0);return Le===-1?Ae:(Ae[Le-1]==="\r"&&Le--,Ae.substr(0,Le))}e.$yf=Q;function ee(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$zf=ee;function V(Ae){return Re.getInstance().getGraphemeBreakType(Ae)}e.$Af=V;function oe(Ae,Ue){return Ae===0?Ue!==5&&Ue!==7:Ae===2&&Ue===3?!1:Ae===4||Ae===2||Ae===3||Ue===4||Ue===2||Ue===3?!0:!(Ae===8&&(Ue===8||Ue===9||Ue===11||Ue===12)||(Ae===11||Ae===9)&&(Ue===9||Ue===10)||(Ae===12||Ae===10)&&Ue===10||Ue===5||Ue===13||Ue===7||Ae===1||Ae===13&&Ue===14||Ae===6&&Ue===6)}var le;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(le||(e.GraphemeBreakType=le={}));class Re{static{this.c=null}static getInstance(){return Re.c||(Re.c=new Re),Re.c}constructor(){this.d=je()}getGraphemeBreakType(Ue){if(Ue<32)return Ue===10?3:Ue===13?2:4;if(Ue<127)return 0;const Le=this.d,Xe=Le.length/3;let ne=1;for(;ne<=Xe;)if(Ue<Le[3*ne])ne=2*ne;else if(Ue>Le[3*ne+1])ne=2*ne+1;else return Le[3*ne+2];return 0}}function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(Ae,Ue){if(Ae===0)return 0;const Le=Je(Ae,Ue);if(Le!==void 0)return Le;const Xe=new X(Ue,Ae);return Xe.prevCodePoint(),Xe.offset}e.$Bf=He;function Je(Ae,Ue){const Le=new X(Ue,Ae);let Xe=Le.prevCodePoint();for(;_e(Xe)||Xe===65039||Xe===8419;){if(Le.offset===0)return;Xe=Le.prevCodePoint()}if(!_(Xe))return;let ne=Le.offset;return ne>0&&Le.prevCodePoint()===8205&&(ne=Le.offset),ne}function _e(Ae){return 127995<=Ae&&Ae<=127999}var ct;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(ct||(ct={})),e.$Cf="\xA0";class ot{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$Ce(Ue=>{function Le(it){const Oe=new Map;for(let wt=0;wt<it.length;wt+=2)Oe.set(it[wt],it[wt+1]);return Oe}function Xe(it,Oe){const wt=new Map(it);for(const[kt,Tt]of Oe)wt.set(kt,Tt);return wt}function ne(it,Oe){if(!it)return Oe;const wt=new Map;for(const[kt,Tt]of it)Oe.has(kt)&&wt.set(kt,Tt);return wt}const ae=this.c.value;let Ie=Ue.filter(it=>!it.startsWith("_")&&it in ae);Ie.length===0&&(Ie=["_default"]);let Ve;for(const it of Ie){const Oe=Le(ae[it]);Ve=ne(Ve,Oe)}const Ze=Le(ae._common),nt=Xe(Ze,Ve);return new ot(nt)})}static getInstance(Ue){return ot.d.get(Array.from(Ue))}static{this.e=new N.$V(()=>Object.keys(ot.c.value).filter(Ue=>!Ue.startsWith("_")))}static getLocales(){return ot.e.value}constructor(Ue){this.f=Ue}isAmbiguous(Ue){return this.f.has(Ue)}getPrimaryConfusable(Ue){return this.f.get(Ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Df=ot;class rt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(rt.c())),this.d}static isInvisibleCharacter(Ue){return rt.e().has(Ue)}static get codePoints(){return rt.e()}}e.$Ef=rt}),define(Se[123],ke([1,0,28,161,12]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$5j=e.$4j=e.$3j=e.FuzzyScore=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.or=void 0;function I(...be){return function(De,z){for(let Q=0,ee=be.length;Q<ee;Q++){const V=be[Q](De,z);if(V)return V}return null}}e.or=I,e.$Qj=R.bind(void 0,!1),e.$Rj=R.bind(void 0,!0);function R(be,De,z){if(!z||z.length<De.length)return null;let Q;return be?Q=g.$0e(z,De):Q=z.indexOf(De)===0,Q?De.length>0?[{start:0,end:De.length}]:[]:null}function b(be,De){const z=De.toLowerCase().indexOf(be.toLowerCase());return z===-1?null:[{start:z,end:z+be.length}]}e.$Sj=b;function $(be,De){return y(be.toLowerCase(),De.toLowerCase(),0,0)}e.$Tj=$;function y(be,De,z,Q){if(z===be.length)return[];if(Q===De.length)return null;if(be[z]===De[Q]){let ee=null;return(ee=y(be,De,z+1,Q+1))?o({start:Q,end:Q+1},ee):null}return y(be,De,z,Q+1)}function A(be){return 97<=be&&be<=122}function C(be){return 65<=be&&be<=90}e.$Uj=C;function m(be){return 48<=be&&be<=57}function v(be){return be===32||be===9||be===10||be===13}const k=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(be=>k.add(be.charCodeAt(0)));function l(be){return v(be)||k.has(be)}function f(be,De){return be===De||l(be)&&l(De)}const s=new Map;function i(be){if(s.has(be))return s.get(be);let De;const z=(0,N.$Oj)(be);return z&&(De=z),s.set(be,De),De}function n(be){return A(be)||C(be)||m(be)}function o(be,De){return De.length===0?De=[be]:be.end===De[0].start?De[0].start=be.start:De.unshift(be),De}function c(be,De){for(let z=De;z<be.length;z++){const Q=be.charCodeAt(z);if(C(Q)||m(Q)||z>0&&!n(be.charCodeAt(z-1)))return z}return be.length}function t(be,De,z,Q){if(z===be.length)return[];if(Q===De.length)return null;if(be[z]!==De[Q].toLowerCase())return null;{let ee=null,V=Q+1;for(ee=t(be,De,z+1,Q+1);!ee&&(V=c(De,V))<De.length;)ee=t(be,De,z+1,V),V++;return ee===null?null:o({start:Q,end:Q+1},ee)}}function r(be){let De=0,z=0,Q=0,ee=0,V=0;for(let He=0;He<be.length;He++)V=be.charCodeAt(He),C(V)&&De++,A(V)&&z++,n(V)&&Q++,m(V)&&ee++;const oe=De/be.length,le=z/be.length,Re=Q/be.length,je=ee/be.length;return{upperPercent:oe,lowerPercent:le,alphaPercent:Re,numericPercent:je}}function d(be){const{upperPercent:De,lowerPercent:z}=be;return z===0&&De>.6}function u(be){const{upperPercent:De,lowerPercent:z,alphaPercent:Q,numericPercent:ee}=be;return z>.2&&De<.8&&Q>.6&&ee<.2}function a(be){let De=0,z=0,Q=0,ee=0;for(let V=0;V<be.length;V++)Q=be.charCodeAt(V),C(Q)&&De++,A(Q)&&z++,v(Q)&&ee++;return(De===0||z===0)&&ee===0?be.length<=30:De<=5}function h(be,De){if(!De||(De=De.trim(),De.length===0)||!a(be)||De.length>60)return null;const z=r(De);if(!u(z)){if(!d(z))return null;De=De.toLowerCase()}let Q=null,ee=0;for(be=be.toLowerCase();ee<De.length&&(Q=t(be,De,0,ee))===null;)ee=c(De,ee+1);return Q}e.$Vj=h;function S(be,De,z=!1){if(!De||De.length===0)return null;let Q=null,ee=0;for(be=be.toLowerCase(),De=De.toLowerCase();ee<De.length&&(Q=P(be,De,0,ee,z),Q===null);)ee=w(De,ee+1);return Q}e.$Wj=S;function P(be,De,z,Q,ee){let V=0;if(z===be.length)return[];if(Q===De.length)return null;if(!f(be.charCodeAt(z),De.charCodeAt(Q))){const Re=i(be.charCodeAt(z));if(!Re)return null;for(let je=0;je<Re.length;je++)if(!f(Re[je],De.charCodeAt(Q+je)))return null;V+=Re.length-1}let oe=null,le=Q+V+1;if(oe=P(be,De,z+1,le,ee),!ee)for(;!oe&&(le=w(De,le))<De.length;)oe=P(be,De,z+1,le,ee),le++;if(!oe)return null;if(be.charCodeAt(z)!==De.charCodeAt(Q)){const Re=i(be.charCodeAt(z));if(!Re)return oe;for(let je=0;je<Re.length;je++)if(Re[je]!==De.charCodeAt(Q+je))return oe}return o({start:Q,end:Q+V+1},oe)}function w(be,De){for(let z=De;z<be.length;z++)if(l(be.charCodeAt(z))||z>0&&l(be.charCodeAt(z-1)))return z;return be.length}const p=I(e.$Rj,h,b),E=I(e.$Rj,h,$),L=new D.$Dc(1e4);function T(be,De,z=!1){if(typeof be!="string"||typeof De!="string")return null;let Q=L.get(be);Q||(Q=new RegExp(g.$Se(be),"i"),L.set(be,Q));const ee=Q.exec(De);return ee?[{start:ee.index,end:ee.index+ee[0].length}]:z?E(be,De):p(be,De)}e.$Xj=T;function U(be,De){const z=_(be,be.toLowerCase(),0,De,De.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return z?j(z):null}e.$Yj=U;function F(be,De,z,Q,ee,V){const oe=Math.min(13,be.length);for(;z<oe;z++){const le=_(be,De,z,Q,ee,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(le)return le}return[0,V]}e.$Zj=F;function j(be){if(typeof be>"u")return[];const De=[],z=be[1];for(let Q=be.length-1;Q>1;Q--){const ee=be[Q]+z,V=De[De.length-1];V&&V.end===ee?V.end=ee+1:De.push({start:ee,end:ee+1})}return De}e.$1j=j;const O=128;function M(){const be=[],De=[];for(let z=0;z<=O;z++)De[z]=0;for(let z=0;z<=O;z++)be.push(De.slice(0));return be}function W(be){const De=[];for(let z=0;z<=be;z++)De[z]=0;return De}const Y=W(2*O),ue=W(2*O),X=M(),J=M(),x=M(),he=!1;function Z(be,De,z,Q,ee){function V(le,Re,je=" "){for(;le.length<Re;)le=je+le;return le}let oe=` |   |${Q.split("").map(le=>V(le,3)).join("|")}
`;for(let le=0;le<=z;le++)le===0?oe+=" |":oe+=`${De[le-1]}|`,oe+=be[le].slice(0,ee+1).map(Re=>V(Re.toString(),3)).join("|")+`
`;return oe}function we(be,De,z,Q){be=be.substr(De),z=z.substr(Q),console.log(Z(J,be,be.length,z,z.length)),console.log(Z(x,be,be.length,z,z.length)),console.log(Z(X,be,be.length,z,z.length))}function ce(be,De){if(De<0||De>=be.length)return!1;const z=be.codePointAt(De);switch(z){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!g.$pf(z)}}function K(be,De){if(De<0||De>=be.length)return!1;switch(be.charCodeAt(De)){case 32:case 9:return!0;default:return!1}}function B(be,De,z){return De[be]!==z[be]}function re(be,De,z,Q,ee,V,oe=!1){for(;De<z&&ee<V;)be[De]===Q[ee]&&(oe&&(Y[De]=ee),De+=1),ee+=1;return De===z}e.$2j=re;var ye;(function(be){be[be.Diag=1]="Diag",be[be.Left=2]="Left",be[be.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var de;(function(be){be.Default=[-100,0];function De(z){return!z||z.length===2&&z[0]===-100&&z[1]===0}be.isDefault=De})(de||(e.FuzzyScore=de={}));class ge{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(De,z){this.firstMatchCanBeWeak=De,this.boostFullMatch=z}}e.$3j=ge;function _(be,De,z,Q,ee,V,oe=ge.default){const le=be.length>O?O:be.length,Re=Q.length>O?O:Q.length;if(z>=le||V>=Re||le-z>Re-V||!re(De,z,le,ee,V,Re,!0))return;ie(le,Re,z,V,De,ee);let je=1,He=1,Je=z,_e=V;const ct=[!1];for(je=1,Je=z;Je<le;je++,Je++){const Le=Y[Je],Xe=ue[Je],ne=Je+1<le?ue[Je+1]:Re;for(He=Le-V+1,_e=Le;_e<ne;He++,_e++){let ae=Number.MIN_SAFE_INTEGER,Ie=!1;_e<=Xe&&(ae=G(be,De,Je,z,Q,ee,_e,Re,V,X[je-1][He-1]===0,ct));let Ve=0;ae!==Number.MAX_SAFE_INTEGER&&(Ie=!0,Ve=ae+J[je-1][He-1]);const Ze=_e>Le,nt=Ze?J[je][He-1]+(X[je][He-1]>0?-5:0):0,it=_e>Le+1&&X[je][He-1]>0,Oe=it?J[je][He-2]+(X[je][He-2]>0?-5:0):0;if(it&&(!Ze||Oe>=nt)&&(!Ie||Oe>=Ve))J[je][He]=Oe,x[je][He]=3,X[je][He]=0;else if(Ze&&(!Ie||nt>=Ve))J[je][He]=nt,x[je][He]=2,X[je][He]=0;else if(Ie)J[je][He]=Ve,x[je][He]=1,X[je][He]=X[je-1][He-1]+1;else throw new Error("not possible")}}if(he&&we(be,z,Q,V),!ct[0]&&!oe.firstMatchCanBeWeak)return;je--,He--;const ot=[J[je][He],V];let rt=0,Ae=0;for(;je>=1;){let Le=He;do{const Xe=x[je][Le];if(Xe===3)Le=Le-2;else if(Xe===2)Le=Le-1;else break}while(Le>=1);rt>1&&De[z+je-1]===ee[V+He-1]&&!B(Le+V-1,Q,ee)&&rt+1>X[je][Le]&&(Le=He),Le===He?rt++:rt=1,Ae||(Ae=Le),je--,He=Le-1,ot.push(He)}Re===le&&oe.boostFullMatch&&(ot[0]+=2);const Ue=Ae-le;return ot[0]-=Ue,ot}e.$4j=_;function ie(be,De,z,Q,ee,V){let oe=be-1,le=De-1;for(;oe>=z&&le>=Q;)ee[oe]===V[le]&&(ue[oe]=le,oe--),le--}function G(be,De,z,Q,ee,V,oe,le,Re,je,He){if(De[z]!==V[oe])return Number.MIN_SAFE_INTEGER;let Je=1,_e=!1;return oe===z-Q?Je=be[z]===ee[oe]?7:5:B(oe,ee,V)&&(oe===0||!B(oe-1,ee,V))?(Je=be[z]===ee[oe]?7:5,_e=!0):ce(V,oe)&&(oe===0||!ce(V,oe-1))?Je=5:(ce(V,oe-1)||K(V,oe-1))&&(Je=5,_e=!0),Je>1&&z===Q&&(He[0]=!0),_e||(_e=B(oe,ee,V)||ce(V,oe-1)||K(V,oe-1)),z===Q?oe>Re&&(Je-=_e?3:5):je?Je+=_e?2:0:Je+=_e?0:1,oe+1===le&&(Je-=_e?3:5),Je}function te(be,De,z,Q,ee,V,oe){return ve(be,De,z,Q,ee,V,!0,oe)}e.$5j=te;function fe(be,De,z,Q,ee,V,oe){return ve(be,De,z,Q,ee,V,!1,oe)}e.$6j=fe;function ve(be,De,z,Q,ee,V,oe,le){let Re=_(be,De,z,Q,ee,V,le);if(Re&&!oe)return Re;if(be.length>=3){const je=Math.min(7,be.length-1);for(let He=z+1;He<je;He++){const Je=Pe(be,He);if(Je){const _e=_(Je,Je.toLowerCase(),z,Q,ee,V,le);_e&&(_e[0]-=3,(!Re||_e[0]>Re[0])&&(Re=_e))}}}return Re}function Pe(be,De){if(De+1>=be.length)return;const z=be[De],Q=be[De+1];if(z!==Q)return be.slice(0,De)+Q+z+be.slice(De+2)}}),define(Se[54],ke([1,0,12]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=void 0;function N(s){return g(s,0)}e.$Qi=N;function g(s,i){switch(typeof s){case"object":return s===null?I(349,i):Array.isArray(s)?$(s,i):y(s,i);case"string":return b(s,i);case"boolean":return R(s,i);case"number":return I(s,i);case"undefined":return I(937,i);default:return I(617,i)}}e.$Ri=g;function I(s,i){return(i<<5)-i+s|0}e.$Si=I;function R(s,i){return I(s?433:863,i)}function b(s,i){i=I(149417,i);for(let n=0,o=s.length;n<o;n++)i=I(s.charCodeAt(n),i);return i}e.$Ti=b;function $(s,i){return i=I(104579,i),s.reduce((n,o)=>g(o,n),i)}function y(s,i){return i=I(181387,i),Object.keys(s).sort().reduce((n,o)=>(n=b(o,n),g(s[o],n)),i)}class A{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=g(i,this.g),this.g}}e.$Ui=A;var C;(function(s){s[s.BLOCK_SIZE=64]="BLOCK_SIZE",s[s.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function m(s,i,n=32){const o=n-i,c=~((1<<o)-1);return(s<<i|(c&s)>>>o)>>>0}function v(s,i=0,n=s.byteLength,o=0){for(let c=0;c<n;c++)s[i+c]=o}function k(s,i,n="0"){for(;s.length<i;)s=n+s;return s}function l(s,i=32){return s instanceof ArrayBuffer?Array.from(new Uint8Array(s)).map(n=>n.toString(16).padStart(2,"0")).join(""):k((s>>>0).toString(16),i/4)}e.$Vi=l;class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const n=i.length;if(n===0)return;const o=this.p;let c=this.r,t=this.u,r,d;for(t!==0?(r=t,d=-1,t=0):(r=i.charCodeAt(0),d=0);;){let u=r;if(D.$af(r))if(d+1<n){const a=i.charCodeAt(d+1);D.$bf(a)?(d++,u=D.$cf(r,a)):u=65533}else{t=r;break}else D.$bf(r)&&(u=65533);if(c=this.w(o,c,u),d++,d<n)r=i.charCodeAt(d);else break}this.r=c,this.u=t}w(i,n,o){return o<128?i[n++]=o:o<2048?(i[n++]=192|(o&1984)>>>6,i[n++]=128|(o&63)>>>0):o<65536?(i[n++]=224|(o&61440)>>>12,i[n++]=128|(o&4032)>>>6,i[n++]=128|(o&63)>>>0):(i[n++]=240|(o&1835008)>>>18,i[n++]=128|(o&258048)>>>12,i[n++]=128|(o&4032)>>>6,i[n++]=128|(o&63)>>>0),n>=64&&(this.y(),n-=64,this.t+=64,i[0]=i[64+0],i[1]=i[64+1],i[2]=i[64+2]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),l(this.h)+l(this.l)+l(this.m)+l(this.n)+l(this.o)}x(){this.p[this.r++]=128,v(this.p,this.r),this.r>56&&(this.y(),v(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=f.g,n=this.q;for(let S=0;S<64;S+=4)i.setUint32(S,n.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)i.setUint32(S,m(i.getUint32(S-12,!1)^i.getUint32(S-32,!1)^i.getUint32(S-56,!1)^i.getUint32(S-64,!1),1),!1);let o=this.h,c=this.l,t=this.m,r=this.n,d=this.o,u,a,h;for(let S=0;S<80;S++)S<20?(u=c&t|~c&r,a=1518500249):S<40?(u=c^t^r,a=1859775393):S<60?(u=c&t|c&r|t&r,a=2400959708):(u=c^t^r,a=3395469782),h=m(o,5)+u+d+a+i.getUint32(S*4,!1)&4294967295,d=r,r=t,t=m(c,30),c=o,o=h;this.h=this.h+o&4294967295,this.l=this.l+c&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+d&4294967295}}e.$Wi=f}),define(Se[39],ke([1,0,12]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(g){g[g.Ignore=0]="Ignore",g[g.Info=1]="Info",g[g.Warning=2]="Warning",g[g.Error=3]="Error"})(N||(N={})),function(g){const I="error",R="warning",b="warn",$="info",y="ignore";function A(m){return m?D.$9e(I,m)?g.Error:D.$9e(R,m)||D.$9e(b,m)?g.Warning:D.$9e($,m)?g.Info:g.Ignore:g.Ignore}g.fromValue=A;function C(m){switch(m){case g.Error:return I;case g.Warning:return R;case g.Info:return $;default:return y}}g.toString=C}(N||(N={})),e.default=N}),define(Se[163],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pd=void 0,e.$Pd=Symbol("MicrotaskDelay")}),define(Se[77],ke([1,0,19,12]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=void 0;class g{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const k=v.charCodeAt(0),l=this.b.charCodeAt(this.c);return k-l}value(){return this.b[this.c]}}e.$5h=g;class I{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,N.$3e)(v,this.b,0,v.length,this.c,this.d):(0,N.$5e)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$6h=I;class R{constructor(v=!0,k=!0){this.f=v,this.g=k}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let k=v.length-1;k>=0;k--,this.c--){const l=this.b.charCodeAt(k);if(!(l===47||this.f&&l===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const k=this.b.charCodeAt(this.e);if(k===47||this.f&&k===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,N.$3e)(v,this.b,0,v.length,this.d,this.e):(0,N.$5e)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$7h=R;var b;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(b||(b={}));class ${constructor(v,k){this.f=v,this.g=k,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,N.$4e)(v,this.c.scheme);if(this.d[this.e]===2)return(0,N.$4e)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,N.$2e)(v,this.c.query);if(this.d[this.e]===5)return(0,N.$2e)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$8h=$;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(A||(A={}));class C{static forUris(v=()=>!1,k=()=>!1){return new C(new $(v,k))}static forPaths(v=!1){return new C(new R(void 0,!v))}static forStrings(){return new C(new g)}static forConfigKeys(){return new C(new I)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,k){if(k){const l=k.slice(0);(0,D.$Xb)(l);for(const f of l)this.set(f,v)}else{const l=v.slice(0);(0,D.$Xb)(l);for(const f of l)this.set(f[0],f[1])}}set(v,k){const l=this.b.reset(v);let f;this.c||(this.c=new y,this.c.segment=l.value());const s=[];for(f=this.c;;){const n=l.cmp(f.segment);if(n>0)f.left||(f.left=new y,f.left.segment=l.value()),s.push([-1,f]),f=f.left;else if(n<0)f.right||(f.right=new y,f.right.segment=l.value()),s.push([1,f]),f=f.right;else if(l.hasNext())l.next(),f.mid||(f.mid=new y,f.mid.segment=l.value()),s.push([0,f]),f=f.mid;else break}const i=f.value;f.value=k,f.key=v;for(let n=s.length-1;n>=0;n--){const o=s[n][1];o.updateHeight();const c=o.balanceFactor();if(c<-1||c>1){const t=s[n][0],r=s[n+1][0];if(t===1&&r===1)s[n][1]=o.rotateLeft();else if(t===-1&&r===-1)s[n][1]=o.rotateRight();else if(t===1&&r===-1)o.right=s[n+1][1]=s[n+1][1].rotateRight(),s[n][1]=o.rotateLeft();else if(t===-1&&r===1)o.left=s[n+1][1]=s[n+1][1].rotateLeft(),s[n][1]=o.rotateRight();else throw new Error;if(n>0)switch(s[n-1][0]){case-1:s[n-1][1].left=s[n][1];break;case 1:s[n-1][1].right=s[n][1];break;case 0:s[n-1][1].mid=s[n][1];break}else this.c=s[0][1]}}return i}get(v){return this.d(v)?.value}d(v){const k=this.b.reset(v);let l=this.c;for(;l;){const f=k.cmp(l.segment);if(f>0)l=l.left;else if(f<0)l=l.right;else if(k.hasNext())k.next(),l=l.mid;else break}return l}has(v){const k=this.d(v);return!(k?.value===void 0&&k?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,k){const l=this.b.reset(v),f=[];let s=this.c;for(;s;){const i=l.cmp(s.segment);if(i>0)f.push([-1,s]),s=s.left;else if(i<0)f.push([1,s]),s=s.right;else if(l.hasNext())l.next(),f.push([0,s]),s=s.mid;else break}if(s){if(k?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const i=this.f(s.right);if(i.key){const{key:n,value:o,segment:c}=i;this.e(i.key,!1),s.key=n,s.value=o,s.segment=c}}else{const i=s.left??s.right;if(f.length>0){const[n,o]=f[f.length-1];switch(n){case-1:o.left=i;break;case 0:o.mid=i;break;case 1:o.right=i;break}}else this.c=i}for(let i=f.length-1;i>=0;i--){const n=f[i][1];n.updateHeight();const o=n.balanceFactor();if(o>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),f[i][1]=n.rotateLeft()):o<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),f[i][1]=n.rotateRight()),i>0)switch(f[i-1][0]){case-1:f[i-1][1].left=f[i][1];break;case 1:f[i-1][1].right=f[i][1];break;case 0:f[i-1][1].mid=f[i][1];break}else this.c=f[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const k=this.b.reset(v);let l=this.c,f;for(;l;){const s=k.cmp(l.segment);if(s>0)l=l.left;else if(s<0)l=l.right;else if(k.hasNext())k.next(),f=l.value||f,l=l.mid;else break}return l&&l.value||f}findSuperstr(v){return this.g(v,!1)}g(v,k){const l=this.b.reset(v);let f=this.c;for(;f;){const s=l.cmp(f.segment);if(s>0)f=f.left;else if(s<0)f=f.right;else if(l.hasNext())l.next(),f=f.mid;else return f.mid?this.h(f.mid):k?f.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[k,l]of this)v(l,k)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const k=[];return this.j(v,k),k[Symbol.iterator]()}j(v,k){v&&(v.left&&this.j(v.left,k),v.value&&k.push([v.key,v.value]),v.mid&&this.j(v.mid,k),v.right&&this.j(v.right,k))}_isBalanced(){const v=k=>{if(!k)return!0;const l=k.balanceFactor();return l<-1||l>1?!1:v(k.left)&&v(k.right)};return v(this.c)}}e.$9h=C}),define(Se[18],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=void 0;function D(c){return typeof c=="string"}e.$Ff=D;function N(c){return Array.isArray(c)&&c.every(t=>D(t))}e.$Gf=N;function g(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.$Hf=g;function I(c){const t=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof t}e.$If=I;function R(c){return typeof c=="number"&&!isNaN(c)}e.$Jf=R;function b(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.$Kf=b;function $(c){return c===!0||c===!1}e.$Lf=$;function y(c){return typeof c>"u"}e.$Mf=y;function A(c){return!C(c)}e.$Nf=A;function C(c){return y(c)||c===null}e.$Of=C;function m(c,t){if(!c)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Pf=m;function v(c){if(C(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.$Qf=v;function k(...c){const t=[];for(let r=0;r<c.length;r++){const d=c[r];if(C(d))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(d)}return t}e.$Rf=k;const l=Object.prototype.hasOwnProperty;function f(c){if(!g(c))return!1;for(const t in c)if(l.call(c,t))return!1;return!0}e.$Sf=f;function s(c){return typeof c=="function"}e.$Tf=s;function i(...c){return c.length>0&&c.every(s)}e.$Uf=i;function n(c,t){const r=Math.min(c.length,t.length);for(let d=0;d<r;d++)o(c[d],t[d])}e.$Vf=n;function o(c,t){if(D(t)){if(typeof c!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(s(t)){try{if(c instanceof t)return}catch{}if(!C(c)&&c.constructor===t||t.length===1&&t.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Wf=o}),define(Se[78],ke([1,0,18]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=e.$8j=e.$7j=void 0;const N=Object.create(null);function g(b,$){if((0,D.$Ff)($)){const y=N[$];if(y===void 0)throw new Error(`${b} references an unknown codicon: ${$}`);$=y}return N[b]=$,{id:b}}function I(){return N}e.$7j=I;function R(){return Object.values(e.$9j)}e.$8j=R,e.$9j={add:g("add",6e4),plus:g("plus",6e4),gistNew:g("gist-new",6e4),repoCreate:g("repo-create",6e4),lightbulb:g("lightbulb",60001),lightBulb:g("light-bulb",60001),repo:g("repo",60002),repoDelete:g("repo-delete",60002),gistFork:g("gist-fork",60003),repoForked:g("repo-forked",60003),gitPullRequest:g("git-pull-request",60004),gitPullRequestAbandoned:g("git-pull-request-abandoned",60004),recordKeys:g("record-keys",60005),keyboard:g("keyboard",60005),tag:g("tag",60006),tagAdd:g("tag-add",60006),tagRemove:g("tag-remove",60006),gitPullRequestLabel:g("git-pull-request-label",60006),person:g("person",60007),personFollow:g("person-follow",60007),personOutline:g("person-outline",60007),personFilled:g("person-filled",60007),gitBranch:g("git-branch",60008),gitBranchCreate:g("git-branch-create",60008),gitBranchDelete:g("git-branch-delete",60008),sourceControl:g("source-control",60008),mirror:g("mirror",60009),mirrorPublic:g("mirror-public",60009),star:g("star",60010),starAdd:g("star-add",60010),starDelete:g("star-delete",60010),starEmpty:g("star-empty",60010),comment:g("comment",60011),commentAdd:g("comment-add",60011),alert:g("alert",60012),warning:g("warning",60012),search:g("search",60013),searchSave:g("search-save",60013),logOut:g("log-out",60014),signOut:g("sign-out",60014),logIn:g("log-in",60015),signIn:g("sign-in",60015),eye:g("eye",60016),eyeUnwatch:g("eye-unwatch",60016),eyeWatch:g("eye-watch",60016),circleFilled:g("circle-filled",60017),primitiveDot:g("primitive-dot",60017),closeDirty:g("close-dirty",60017),debugBreakpoint:g("debug-breakpoint",60017),debugBreakpointDisabled:g("debug-breakpoint-disabled",60017),debugHint:g("debug-hint",60017),primitiveSquare:g("primitive-square",60018),edit:g("edit",60019),pencil:g("pencil",60019),info:g("info",60020),issueOpened:g("issue-opened",60020),gistPrivate:g("gist-private",60021),gitForkPrivate:g("git-fork-private",60021),lock:g("lock",60021),mirrorPrivate:g("mirror-private",60021),close:g("close",60022),removeClose:g("remove-close",60022),x:g("x",60022),repoSync:g("repo-sync",60023),sync:g("sync",60023),clone:g("clone",60024),desktopDownload:g("desktop-download",60024),beaker:g("beaker",60025),microscope:g("microscope",60025),vm:g("vm",60026),deviceDesktop:g("device-desktop",60026),file:g("file",60027),fileText:g("file-text",60027),more:g("more",60028),ellipsis:g("ellipsis",60028),kebabHorizontal:g("kebab-horizontal",60028),mailReply:g("mail-reply",60029),reply:g("reply",60029),organization:g("organization",60030),organizationFilled:g("organization-filled",60030),organizationOutline:g("organization-outline",60030),newFile:g("new-file",60031),fileAdd:g("file-add",60031),newFolder:g("new-folder",60032),fileDirectoryCreate:g("file-directory-create",60032),trash:g("trash",60033),trashcan:g("trashcan",60033),history:g("history",60034),clock:g("clock",60034),folder:g("folder",60035),fileDirectory:g("file-directory",60035),symbolFolder:g("symbol-folder",60035),logoGithub:g("logo-github",60036),markGithub:g("mark-github",60036),github:g("github",60036),terminal:g("terminal",60037),console:g("console",60037),repl:g("repl",60037),zap:g("zap",60038),symbolEvent:g("symbol-event",60038),error:g("error",60039),stop:g("stop",60039),variable:g("variable",60040),symbolVariable:g("symbol-variable",60040),array:g("array",60042),symbolArray:g("symbol-array",60042),symbolModule:g("symbol-module",60043),symbolPackage:g("symbol-package",60043),symbolNamespace:g("symbol-namespace",60043),symbolObject:g("symbol-object",60043),symbolMethod:g("symbol-method",60044),symbolFunction:g("symbol-function",60044),symbolConstructor:g("symbol-constructor",60044),symbolBoolean:g("symbol-boolean",60047),symbolNull:g("symbol-null",60047),symbolNumeric:g("symbol-numeric",60048),symbolNumber:g("symbol-number",60048),symbolStructure:g("symbol-structure",60049),symbolStruct:g("symbol-struct",60049),symbolParameter:g("symbol-parameter",60050),symbolTypeParameter:g("symbol-type-parameter",60050),symbolKey:g("symbol-key",60051),symbolText:g("symbol-text",60051),symbolReference:g("symbol-reference",60052),goToFile:g("go-to-file",60052),symbolEnum:g("symbol-enum",60053),symbolValue:g("symbol-value",60053),symbolRuler:g("symbol-ruler",60054),symbolUnit:g("symbol-unit",60054),activateBreakpoints:g("activate-breakpoints",60055),archive:g("archive",60056),arrowBoth:g("arrow-both",60057),arrowDown:g("arrow-down",60058),arrowLeft:g("arrow-left",60059),arrowRight:g("arrow-right",60060),arrowSmallDown:g("arrow-small-down",60061),arrowSmallLeft:g("arrow-small-left",60062),arrowSmallRight:g("arrow-small-right",60063),arrowSmallUp:g("arrow-small-up",60064),arrowUp:g("arrow-up",60065),bell:g("bell",60066),bold:g("bold",60067),book:g("book",60068),bookmark:g("bookmark",60069),debugBreakpointConditionalUnverified:g("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:g("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:g("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:g("debug-breakpoint-data-unverified",60072),debugBreakpointData:g("debug-breakpoint-data",60073),debugBreakpointDataDisabled:g("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:g("debug-breakpoint-log-unverified",60074),debugBreakpointLog:g("debug-breakpoint-log",60075),debugBreakpointLogDisabled:g("debug-breakpoint-log-disabled",60075),briefcase:g("briefcase",60076),broadcast:g("broadcast",60077),browser:g("browser",60078),bug:g("bug",60079),calendar:g("calendar",60080),caseSensitive:g("case-sensitive",60081),check:g("check",60082),checklist:g("checklist",60083),chevronDown:g("chevron-down",60084),dropDownButton:g("drop-down-button",60084),chevronLeft:g("chevron-left",60085),chevronRight:g("chevron-right",60086),chevronUp:g("chevron-up",60087),chromeClose:g("chrome-close",60088),chromeMaximize:g("chrome-maximize",60089),chromeMinimize:g("chrome-minimize",60090),chromeRestore:g("chrome-restore",60091),circle:g("circle",60092),circleOutline:g("circle-outline",60092),debugBreakpointUnverified:g("debug-breakpoint-unverified",60092),circleSlash:g("circle-slash",60093),circuitBoard:g("circuit-board",60094),clearAll:g("clear-all",60095),clippy:g("clippy",60096),closeAll:g("close-all",60097),cloudDownload:g("cloud-download",60098),cloudUpload:g("cloud-upload",60099),code:g("code",60100),collapseAll:g("collapse-all",60101),colorMode:g("color-mode",60102),commentDiscussion:g("comment-discussion",60103),compareChanges:g("compare-changes",60157),creditCard:g("credit-card",60105),dash:g("dash",60108),dashboard:g("dashboard",60109),database:g("database",60110),debugContinue:g("debug-continue",60111),debugDisconnect:g("debug-disconnect",60112),debugPause:g("debug-pause",60113),debugRestart:g("debug-restart",60114),debugStart:g("debug-start",60115),debugStepInto:g("debug-step-into",60116),debugStepOut:g("debug-step-out",60117),debugStepOver:g("debug-step-over",60118),debugStop:g("debug-stop",60119),debug:g("debug",60120),deviceCameraVideo:g("device-camera-video",60121),deviceCamera:g("device-camera",60122),deviceMobile:g("device-mobile",60123),diffAdded:g("diff-added",60124),diffIgnored:g("diff-ignored",60125),diffModified:g("diff-modified",60126),diffRemoved:g("diff-removed",60127),diffRenamed:g("diff-renamed",60128),diff:g("diff",60129),discard:g("discard",60130),editorLayout:g("editor-layout",60131),emptyWindow:g("empty-window",60132),exclude:g("exclude",60133),extensions:g("extensions",60134),eyeClosed:g("eye-closed",60135),fileBinary:g("file-binary",60136),fileCode:g("file-code",60137),fileMedia:g("file-media",60138),filePdf:g("file-pdf",60139),fileSubmodule:g("file-submodule",60140),fileSymlinkDirectory:g("file-symlink-directory",60141),fileSymlinkFile:g("file-symlink-file",60142),fileZip:g("file-zip",60143),files:g("files",60144),filter:g("filter",60145),flame:g("flame",60146),foldDown:g("fold-down",60147),foldUp:g("fold-up",60148),fold:g("fold",60149),folderActive:g("folder-active",60150),folderOpened:g("folder-opened",60151),gear:g("gear",60152),gift:g("gift",60153),gistSecret:g("gist-secret",60154),gist:g("gist",60155),gitCommit:g("git-commit",60156),gitCompare:g("git-compare",60157),gitMerge:g("git-merge",60158),githubAction:g("github-action",60159),githubAlt:g("github-alt",60160),globe:g("globe",60161),grabber:g("grabber",60162),graph:g("graph",60163),gripper:g("gripper",60164),heart:g("heart",60165),home:g("home",60166),horizontalRule:g("horizontal-rule",60167),hubot:g("hubot",60168),inbox:g("inbox",60169),issueClosed:g("issue-closed",60324),issueReopened:g("issue-reopened",60171),issues:g("issues",60172),italic:g("italic",60173),jersey:g("jersey",60174),json:g("json",60175),bracket:g("bracket",60175),kebabVertical:g("kebab-vertical",60176),key:g("key",60177),law:g("law",60178),lightbulbAutofix:g("lightbulb-autofix",60179),linkExternal:g("link-external",60180),link:g("link",60181),listOrdered:g("list-ordered",60182),listUnordered:g("list-unordered",60183),liveShare:g("live-share",60184),loading:g("loading",60185),location:g("location",60186),mailRead:g("mail-read",60187),mail:g("mail",60188),markdown:g("markdown",60189),megaphone:g("megaphone",60190),mention:g("mention",60191),milestone:g("milestone",60192),gitPullRequestMilestone:g("git-pull-request-milestone",60192),mortarBoard:g("mortar-board",60193),move:g("move",60194),multipleWindows:g("multiple-windows",60195),mute:g("mute",60196),noNewline:g("no-newline",60197),note:g("note",60198),octoface:g("octoface",60199),openPreview:g("open-preview",60200),package:g("package",60201),paintcan:g("paintcan",60202),pin:g("pin",60203),play:g("play",60204),run:g("run",60204),plug:g("plug",60205),preserveCase:g("preserve-case",60206),preview:g("preview",60207),project:g("project",60208),pulse:g("pulse",60209),question:g("question",60210),quote:g("quote",60211),radioTower:g("radio-tower",60212),reactions:g("reactions",60213),references:g("references",60214),refresh:g("refresh",60215),regex:g("regex",60216),remoteExplorer:g("remote-explorer",60217),remote:g("remote",60218),remove:g("remove",60219),replaceAll:g("replace-all",60220),replace:g("replace",60221),repoClone:g("repo-clone",60222),repoForcePush:g("repo-force-push",60223),repoPull:g("repo-pull",60224),repoPush:g("repo-push",60225),report:g("report",60226),requestChanges:g("request-changes",60227),rocket:g("rocket",60228),rootFolderOpened:g("root-folder-opened",60229),rootFolder:g("root-folder",60230),rss:g("rss",60231),ruby:g("ruby",60232),saveAll:g("save-all",60233),saveAs:g("save-as",60234),save:g("save",60235),screenFull:g("screen-full",60236),screenNormal:g("screen-normal",60237),searchStop:g("search-stop",60238),server:g("server",60240),settingsGear:g("settings-gear",60241),settings:g("settings",60242),shield:g("shield",60243),smiley:g("smiley",60244),sortPrecedence:g("sort-precedence",60245),splitHorizontal:g("split-horizontal",60246),splitVertical:g("split-vertical",60247),squirrel:g("squirrel",60248),starFull:g("star-full",60249),starHalf:g("star-half",60250),symbolClass:g("symbol-class",60251),symbolColor:g("symbol-color",60252),symbolCustomColor:g("symbol-customcolor",60252),symbolConstant:g("symbol-constant",60253),symbolEnumMember:g("symbol-enum-member",60254),symbolField:g("symbol-field",60255),symbolFile:g("symbol-file",60256),symbolInterface:g("symbol-interface",60257),symbolKeyword:g("symbol-keyword",60258),symbolMisc:g("symbol-misc",60259),symbolOperator:g("symbol-operator",60260),symbolProperty:g("symbol-property",60261),wrench:g("wrench",60261),wrenchSubaction:g("wrench-subaction",60261),symbolSnippet:g("symbol-snippet",60262),tasklist:g("tasklist",60263),telescope:g("telescope",60264),textSize:g("text-size",60265),threeBars:g("three-bars",60266),thumbsdown:g("thumbsdown",60267),thumbsup:g("thumbsup",60268),tools:g("tools",60269),triangleDown:g("triangle-down",60270),triangleLeft:g("triangle-left",60271),triangleRight:g("triangle-right",60272),triangleUp:g("triangle-up",60273),twitter:g("twitter",60274),unfold:g("unfold",60275),unlock:g("unlock",60276),unmute:g("unmute",60277),unverified:g("unverified",60278),verified:g("verified",60279),versions:g("versions",60280),vmActive:g("vm-active",60281),vmOutline:g("vm-outline",60282),vmRunning:g("vm-running",60283),watch:g("watch",60284),whitespace:g("whitespace",60285),wholeWord:g("whole-word",60286),window:g("window",60287),wordWrap:g("word-wrap",60288),zoomIn:g("zoom-in",60289),zoomOut:g("zoom-out",60290),listFilter:g("list-filter",60291),listFlat:g("list-flat",60292),listSelection:g("list-selection",60293),selection:g("selection",60293),listTree:g("list-tree",60294),debugBreakpointFunctionUnverified:g("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:g("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:g("debug-breakpoint-function-disabled",60296),debugStackframeActive:g("debug-stackframe-active",60297),circleSmallFilled:g("circle-small-filled",60298),debugStackframeDot:g("debug-stackframe-dot",60298),debugStackframe:g("debug-stackframe",60299),debugStackframeFocused:g("debug-stackframe-focused",60299),debugBreakpointUnsupported:g("debug-breakpoint-unsupported",60300),symbolString:g("symbol-string",60301),debugReverseContinue:g("debug-reverse-continue",60302),debugStepBack:g("debug-step-back",60303),debugRestartFrame:g("debug-restart-frame",60304),callIncoming:g("call-incoming",60306),callOutgoing:g("call-outgoing",60307),menu:g("menu",60308),expandAll:g("expand-all",60309),feedback:g("feedback",60310),gitPullRequestReviewer:g("git-pull-request-reviewer",60310),groupByRefType:g("group-by-ref-type",60311),ungroupByRefType:g("ungroup-by-ref-type",60312),account:g("account",60313),gitPullRequestAssignee:g("git-pull-request-assignee",60313),bellDot:g("bell-dot",60314),debugConsole:g("debug-console",60315),library:g("library",60316),output:g("output",60317),runAll:g("run-all",60318),syncIgnored:g("sync-ignored",60319),pinned:g("pinned",60320),githubInverted:g("github-inverted",60321),debugAlt:g("debug-alt",60305),serverProcess:g("server-process",60322),serverEnvironment:g("server-environment",60323),pass:g("pass",60324),stopCircle:g("stop-circle",60325),playCircle:g("play-circle",60326),record:g("record",60327),debugAltSmall:g("debug-alt-small",60328),vmConnect:g("vm-connect",60329),cloud:g("cloud",60330),merge:g("merge",60331),exportIcon:g("export",60332),graphLeft:g("graph-left",60333),magnet:g("magnet",60334),notebook:g("notebook",60335),redo:g("redo",60336),checkAll:g("check-all",60337),pinnedDirty:g("pinned-dirty",60338),passFilled:g("pass-filled",60339),circleLargeFilled:g("circle-large-filled",60340),circleLarge:g("circle-large",60341),circleLargeOutline:g("circle-large-outline",60341),combine:g("combine",60342),gather:g("gather",60342),table:g("table",60343),variableGroup:g("variable-group",60344),typeHierarchy:g("type-hierarchy",60345),typeHierarchySub:g("type-hierarchy-sub",60346),typeHierarchySuper:g("type-hierarchy-super",60347),gitPullRequestCreate:g("git-pull-request-create",60348),runAbove:g("run-above",60349),runBelow:g("run-below",60350),notebookTemplate:g("notebook-template",60351),debugRerun:g("debug-rerun",60352),workspaceTrusted:g("workspace-trusted",60353),workspaceUntrusted:g("workspace-untrusted",60354),workspaceUnspecified:g("workspace-unspecified",60355),terminalCmd:g("terminal-cmd",60356),terminalDebian:g("terminal-debian",60357),terminalLinux:g("terminal-linux",60358),terminalPowershell:g("terminal-powershell",60359),terminalTmux:g("terminal-tmux",60360),terminalUbuntu:g("terminal-ubuntu",60361),terminalBash:g("terminal-bash",60362),arrowSwap:g("arrow-swap",60363),copy:g("copy",60364),personAdd:g("person-add",60365),filterFilled:g("filter-filled",60366),wand:g("wand",60367),debugLineByLine:g("debug-line-by-line",60368),inspect:g("inspect",60369),layers:g("layers",60370),layersDot:g("layers-dot",60371),layersActive:g("layers-active",60372),compass:g("compass",60373),compassDot:g("compass-dot",60374),compassActive:g("compass-active",60375),azure:g("azure",60376),issueDraft:g("issue-draft",60377),gitPullRequestClosed:g("git-pull-request-closed",60378),gitPullRequestDraft:g("git-pull-request-draft",60379),debugAll:g("debug-all",60380),debugCoverage:g("debug-coverage",60381),runErrors:g("run-errors",60382),folderLibrary:g("folder-library",60383),debugContinueSmall:g("debug-continue-small",60384),beakerStop:g("beaker-stop",60385),graphLine:g("graph-line",60386),graphScatter:g("graph-scatter",60387),pieChart:g("pie-chart",60388),bracketDot:g("bracket-dot",60389),bracketError:g("bracket-error",60390),lockSmall:g("lock-small",60391),azureDevops:g("azure-devops",60392),verifiedFilled:g("verified-filled",60393),newLine:g("newline",60394),layout:g("layout",60395),layoutActivitybarLeft:g("layout-activitybar-left",60396),layoutActivitybarRight:g("layout-activitybar-right",60397),layoutPanelLeft:g("layout-panel-left",60398),layoutPanelCenter:g("layout-panel-center",60399),layoutPanelJustify:g("layout-panel-justify",60400),layoutPanelRight:g("layout-panel-right",60401),layoutPanel:g("layout-panel",60402),layoutSidebarLeft:g("layout-sidebar-left",60403),layoutSidebarRight:g("layout-sidebar-right",60404),layoutStatusbar:g("layout-statusbar",60405),layoutMenubar:g("layout-menubar",60406),layoutCentered:g("layout-centered",60407),layoutSidebarRightOff:g("layout-sidebar-right-off",60416),layoutPanelOff:g("layout-panel-off",60417),layoutSidebarLeftOff:g("layout-sidebar-left-off",60418),target:g("target",60408),indent:g("indent",60409),recordSmall:g("record-small",60410),errorSmall:g("error-small",60411),arrowCircleDown:g("arrow-circle-down",60412),arrowCircleLeft:g("arrow-circle-left",60413),arrowCircleRight:g("arrow-circle-right",60414),arrowCircleUp:g("arrow-circle-up",60415),heartFilled:g("heart-filled",60420),map:g("map",60421),mapFilled:g("map-filled",60422),circleSmall:g("circle-small",60423),bellSlash:g("bell-slash",60424),bellSlashDot:g("bell-slash-dot",60425),commentUnresolved:g("comment-unresolved",60426),gitPullRequestGoToChanges:g("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:g("git-pull-request-new-changes",60428),searchFuzzy:g("search-fuzzy",60429),commentDraft:g("comment-draft",60430),send:g("send",60431),sparkle:g("sparkle",60432),insert:g("insert",60433),mic:g("mic",60434),thumbsDownFilled:g("thumbsdown-filled",60435),thumbsUpFilled:g("thumbsup-filled",60436),coffee:g("coffee",60437),snake:g("snake",60438),game:g("game",60439),vr:g("vr",60440),chip:g("chip",60441),piano:g("piano",60442),music:g("music",60443),micFilled:g("mic-filled",60444),gitFetch:g("git-fetch",60445),copilot:g("copilot",60446),lightbulbSparkle:g("lightbulb-sparkle",60447),lightbulbSparkleAutofix:g("lightbulb-sparkle-autofix",60447),robot:g("robot",60448),sparkleFilled:g("sparkle-filled",60449),diffSingle:g("diff-single",60450),diffMultiple:g("diff-multiple",60451),surroundWith:g("surround-with",60452),dialogError:g("dialog-error","error"),dialogWarning:g("dialog-warning","warning"),dialogInfo:g("dialog-info","info"),dialogClose:g("dialog-close","close"),treeItemExpanded:g("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:g("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:g("tree-filter-on-type-off","list-selection"),treeFilterClear:g("tree-filter-clear","close"),treeItemLoading:g("tree-item-loading","loading"),menuSelection:g("menu-selection","check"),menuSubmenu:g("menu-submenu","chevron-right"),menuBarMore:g("menubar-more","more"),scrollbarButtonLeft:g("scrollbar-button-left","triangle-left"),scrollbarButtonRight:g("scrollbar-button-right","triangle-right"),scrollbarButtonUp:g("scrollbar-button-up","triangle-up"),scrollbarButtonDown:g("scrollbar-button-down","triangle-down"),toolBarMore:g("toolbar-more","more"),quickInputBack:g("quick-input-back","arrow-left")}}),define(Se[24],ke([1,0,18]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=void 0;function N(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const i=Array.isArray(s)?[]:{};return Object.entries(s).forEach(([n,o])=>{i[n]=o&&typeof o=="object"?N(o):o}),i}e.$jn=N;function g(s){if(!s||typeof s!="object")return s;const i=[s];for(;i.length>0;){const n=i.shift();Object.freeze(n);for(const o in n)if(I.call(n,o)){const c=n[o];typeof c=="object"&&!Object.isFrozen(c)&&!(0,D.$If)(c)&&i.push(c)}}return s}e.$kn=g;const I=Object.prototype.hasOwnProperty;function R(s,i){return b(s,i,new Set)}e.$ln=R;function b(s,i,n){if((0,D.$Of)(s))return s;const o=i(s);if(typeof o<"u")return o;if(Array.isArray(s)){const c=[];for(const t of s)c.push(b(t,i,n));return c}if((0,D.$Hf)(s)){if(n.has(s))throw new Error("Cannot clone recursive data-structure");n.add(s);const c={};for(const t in s)I.call(s,t)&&(c[t]=b(s[t],i,n));return n.delete(s),c}return s}function $(s,i,n=!0){return(0,D.$Hf)(s)?((0,D.$Hf)(i)&&Object.keys(i).forEach(o=>{o in s?n&&((0,D.$Hf)(s[o])&&(0,D.$Hf)(i[o])?$(s[o],i[o],n):s[o]=i[o]):s[o]=i[o]}),s):i}e.$mn=$;function y(s,i){if(s===i)return!0;if(s==null||i===null||i===void 0||typeof s!=typeof i||typeof s!="object"||Array.isArray(s)!==Array.isArray(i))return!1;let n,o;if(Array.isArray(s)){if(s.length!==i.length)return!1;for(n=0;n<s.length;n++)if(!y(s[n],i[n]))return!1}else{const c=[];for(o in s)c.push(o);c.sort();const t=[];for(o in i)t.push(o);if(t.sort(),!y(c,t))return!1;for(n=0;n<c.length;n++)if(!y(s[c[n]],i[c[n]]))return!1}return!0}e.$nn=y;function A(s){const i=new Set;return JSON.stringify(s,(n,o)=>{if((0,D.$Hf)(o)||Array.isArray(o)){if(i.has(o))return"[Circular]";i.add(o)}return o})}e.$on=A;function C(s,i){const n=Object.create(null);return!s||!i||Object.keys(i).forEach(c=>{const t=s[c],r=i[c];y(t,r)||(n[c]=r)}),n}e.$pn=C;function m(s,i){const n=i.toLowerCase(),o=Object.keys(s).find(c=>c.toLowerCase()===n);return o?s[o]:s[i]}e.$qn=m;function v(s,i){const n=Object.create(null);for(const[o,c]of Object.entries(s))i(o,c)&&(n[o]=c);return n}e.$rn=v;function k(s){let i=[];for(;Object.prototype!==s;)i=i.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return i}e.$sn=k;function l(s){const i=[];for(const n of k(s))typeof s[n]=="function"&&i.push(n);return i}e.$tn=l;function f(s,i){const n=c=>function(){const t=Array.prototype.slice.call(arguments,0);return i(c,t)},o={};for(const c of s)o[c]=n(c);return o}e.$un=f}),define(Se[61],ke([1,0,78]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$0j=e.ThemeColor=void 0;var N;(function(R){function b($){return $&&typeof $=="object"&&typeof $.id=="string"}R.isThemeColor=b})(N||(e.ThemeColor=N={}));function g(R){return{id:R}}e.$0j=g;var I;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function $(i){const n=b.exec(i.id);if(!n)return $(D.$9j.error);const[,o,c]=n,t=["codicon","codicon-"+o];return c&&t.push("codicon-modifier-"+c.substring(1)),t}R.asClassNameArray=$;function y(i){return $(i).join(" ")}R.asClassName=y;function A(i){return"."+$(i).join(".")}R.asCSSSelector=A;function C(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||N.isThemeColor(i.color))}R.isThemeIcon=C;const m=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function v(i){const n=m.exec(i);if(!n)return;const[,o]=n;return{id:o}}R.fromString=v;function k(i){return{id:i}}R.fromId=k;function l(i,n){let o=i.id;const c=o.lastIndexOf("~");return c!==-1&&(o=o.substring(0,c)),n&&(o=`${o}~${n}`),{id:o}}R.modify=l;function f(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}R.getModifier=f;function s(i,n){return i.id===n.id&&i.color?.id===n.color?.id}R.isEqual=s})(I||(e.ThemeIcon=I={}))}),define(Se[164],ke([1,0,123,12,61]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=void 0;const I="$(",R=new RegExp(`\\$\\(${g.ThemeIcon.iconNameExpression}(?:${g.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${R.source}`,"g");function $(s){return s.replace(b,(i,n)=>n?i:`\\${i}`)}e.$$j=$;const y=new RegExp(`\\\\${R.source}`,"g");function A(s){return s.replace(y,i=>`\\${i}`)}e.$_j=A;const C=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function m(s){return s.indexOf(I)===-1?s:s.replace(C,(i,n,o,c)=>o?i:n||c||"")}e.$ak=m;function v(s){return s?s.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}e.$bk=v;const k=new RegExp(`\\$\\(${g.ThemeIcon.iconNameCharacter}+\\)`,"g");function l(s){k.lastIndex=0;let i="";const n=[];let o=0;for(;;){const c=k.lastIndex,t=k.exec(s),r=s.substring(c,t?.index);if(r.length>0){i+=r;for(let d=0;d<r.length;d++)n.push(o)}if(!t)break;o+=t[0].length}return{text:i,iconOffsets:n}}e.$ck=l;function f(s,i,n=!1){const{text:o,iconOffsets:c}=i;if(!c||c.length===0)return(0,D.$Xj)(s,o,n);const t=(0,N.$Qe)(o," "),r=o.length-t.length,d=(0,D.$Xj)(s,t,n);if(d)for(const u of d){const a=c[u.start+r]+r;u.start+=a,u.end+=a}return d}e.$dk=f}),define(Se[124],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fe=e.$Ee=e.Constants=void 0;var D;(function(I){I[I.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",I[I.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",I[I.MAX_UINT_8=255]="MAX_UINT_8",I[I.MAX_UINT_16=65535]="MAX_UINT_16",I[I.MAX_UINT_32=4294967295]="MAX_UINT_32",I[I.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(e.Constants=D={}));function N(I){return I<0?0:I>255?255:I|0}e.$Ee=N;function g(I){return I<0?0:I>4294967295?4294967295:I|0}e.$Fe=g}),define(Se[30],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ng=e.$mg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(g){return D.test(g)}e.$mg=N,e.$ng=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let g;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?g=crypto.getRandomValues.bind(crypto):g=function(b){for(let $=0;$<b.length;$++)b[$]=Math.floor(Math.random()*256);return b};const I=new Uint8Array(16),R=[];for(let b=0;b<256;b++)R.push(b.toString(16).padStart(2,"0"));return function(){g(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let $=0,y="";return y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y+="-",y+=R[I[$++]],y+=R[I[$++]],y+="-",y+=R[I[$++]],y+=R[I[$++]],y+="-",y+=R[I[$++]],y+=R[I[$++]],y+="-",y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y}}()}),define(Se[165],ke([1,0,19,53,30]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.$et=e.$dt=e.$ct=e.$bt=void 0;function I(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}e.$bt=I;function R(C,m,v){const k={id:(0,g.$ng)(),name:C,uri:m,data:v};return{asString:async()=>"",asFile:()=>k,value:void 0}}e.$ct=R;class b{constructor(){this.a=new Map}get size(){let m=0;for(const v of this.a)m++;return m}has(m){return this.a.has(this.b(m))}matches(m){const v=[...this.a.keys()];return N.Iterable.some(this,([k,l])=>l.asFile())&&v.push("files"),A($(m),v)}get(m){return this.a.get(this.b(m))?.[0]}append(m,v){const k=this.a.get(m);k?k.push(v):this.a.set(this.b(m),[v])}replace(m,v){this.a.set(this.b(m),[v])}delete(m){this.a.delete(this.b(m))}*[Symbol.iterator](){for(const[m,v]of this.a)for(const k of v)yield[m,k]}b(m){return $(m)}}e.$dt=b;function $(C){return C.toLowerCase()}function y(C,m){return A($(C),m.map($))}e.$et=y;function A(C,m){if(C==="*/*")return m.length>0;if(m.includes(C))return!0;const v=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[k,l,f]=v;return f==="*"?m.some(s=>s.startsWith(l+"/")):!1}e.$ft=Object.freeze({create:C=>(0,D.$Mb)(C.map(m=>m.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.$ft.split(C).filter(m=>!m.startsWith("#"))})}),define(Se[166],ke([1,0,62]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rg=e.$qg=e.$pg=void 0;function N(b,$,y,A=1){let C=!1;return new Promise(m=>{const v=setTimeout(()=>{if(!C)return C=!0,m(0)},y);g(b,$,A,k=>{if(!C)return C=!0,clearTimeout(v),m(k)})})}e.$pg=N;function g(b,$,y,A){if($===0)return A(0);const C=new D.Socket;C.once("connect",()=>(R(C),g(b+y,$-1,y,A))),C.once("data",()=>{}),C.once("error",m=>(R(C),m.code!=="ECONNREFUSED"?g(b+y,$-1,y,A):A(b))),C.connect(b,"127.0.0.1")}e.$qg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function I(b,$,y,A="127.0.0.1"){let C=!1,m,v=1;const k=D.createServer({pauseOnConnect:!0});function l(f,s){C||(C=!0,k.removeAllListeners(),k.close(),m&&clearTimeout(m),s(f))}return new Promise(f=>{m=setTimeout(()=>{l(0,f)},y),k.on("listening",()=>{l(b,f)}),k.on("error",s=>{s&&(s.code==="EADDRINUSE"||s.code==="EACCES")&&v<$?(b++,v++,k.listen(b,A)):l(0,f)}),k.on("close",()=>{l(0,f)}),k.listen(b,A)})}e.$rg=I;function R(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch($){console.error($)}}}),define(Se[125],ke([1,0,124]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7s=e.$6s=void 0;class N{constructor(b){const $=(0,D.$Ee)(b);this.c=$,this.a=N.d($),this.b=new Map}static d(b){const $=new Uint8Array(256);return $.fill(b),$}set(b,$){const y=(0,D.$Ee)($);b>=0&&b<256?this.a[b]=y:this.b.set(b,y)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$6s=N;var g;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(g||(g={}));class I{constructor(){this.a=new N(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$7s=I}),define(Se[167],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$it=e.StringEOL=void 0;var D;(function(g){g[g.Unknown=0]="Unknown",g[g.Invalid=3]="Invalid",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(D||(e.StringEOL=D={}));function N(g){let I=0,R=0,b=0,$=0;for(let y=0,A=g.length;y<A;y++){const C=g.charCodeAt(y);C===13?(I===0&&(R=y),I++,y+1<A&&g.charCodeAt(y+1)===10?($|=2,y++):$|=3,b=y+1):C===10&&($|=1,I===0&&(R=y),I++,b=y+1)}return I===0&&(R=g.length),[I,R,g.length-b,$]}e.$it=N}),define(Se[49],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=void 0;class D{constructor(g,I){this.lineNumber=g,this.column=I}with(g=this.lineNumber,I=this.column){return g===this.lineNumber&&I===this.column?this:new D(g,I)}delta(g=0,I=0){return this.with(this.lineNumber+g,this.column+I)}equals(g){return D.equals(this,g)}static equals(g,I){return!g&&!I?!0:!!g&&!!I&&g.lineNumber===I.lineNumber&&g.column===I.column}isBefore(g){return D.isBefore(this,g)}static isBefore(g,I){return g.lineNumber<I.lineNumber?!0:I.lineNumber<g.lineNumber?!1:g.column<I.column}isBeforeOrEqual(g){return D.isBeforeOrEqual(this,g)}static isBeforeOrEqual(g,I){return g.lineNumber<I.lineNumber?!0:I.lineNumber<g.lineNumber?!1:g.column<=I.column}static compare(g,I){const R=g.lineNumber|0,b=I.lineNumber|0;if(R===b){const $=g.column|0,y=I.column|0;return $-y}return R-b}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(g){return new D(g.lineNumber,g.column)}static isIPosition(g){return g&&typeof g.lineNumber=="number"&&typeof g.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Hs=D}),define(Se[29],ke([1,0,49]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=void 0;class N{constructor(I,R,b,$){I>b||I===b&&R>$?(this.startLineNumber=b,this.startColumn=$,this.endLineNumber=I,this.endColumn=R):(this.startLineNumber=I,this.startColumn=R,this.endLineNumber=b,this.endColumn=$)}isEmpty(){return N.isEmpty(this)}static isEmpty(I){return I.startLineNumber===I.endLineNumber&&I.startColumn===I.endColumn}containsPosition(I){return N.containsPosition(this,I)}static containsPosition(I,R){return!(R.lineNumber<I.startLineNumber||R.lineNumber>I.endLineNumber||R.lineNumber===I.startLineNumber&&R.column<I.startColumn||R.lineNumber===I.endLineNumber&&R.column>I.endColumn)}static strictContainsPosition(I,R){return!(R.lineNumber<I.startLineNumber||R.lineNumber>I.endLineNumber||R.lineNumber===I.startLineNumber&&R.column<=I.startColumn||R.lineNumber===I.endLineNumber&&R.column>=I.endColumn)}containsRange(I){return N.containsRange(this,I)}static containsRange(I,R){return!(R.startLineNumber<I.startLineNumber||R.endLineNumber<I.startLineNumber||R.startLineNumber>I.endLineNumber||R.endLineNumber>I.endLineNumber||R.startLineNumber===I.startLineNumber&&R.startColumn<I.startColumn||R.endLineNumber===I.endLineNumber&&R.endColumn>I.endColumn)}strictContainsRange(I){return N.strictContainsRange(this,I)}static strictContainsRange(I,R){return!(R.startLineNumber<I.startLineNumber||R.endLineNumber<I.startLineNumber||R.startLineNumber>I.endLineNumber||R.endLineNumber>I.endLineNumber||R.startLineNumber===I.startLineNumber&&R.startColumn<=I.startColumn||R.endLineNumber===I.endLineNumber&&R.endColumn>=I.endColumn)}plusRange(I){return N.plusRange(this,I)}static plusRange(I,R){let b,$,y,A;return R.startLineNumber<I.startLineNumber?(b=R.startLineNumber,$=R.startColumn):R.startLineNumber===I.startLineNumber?(b=R.startLineNumber,$=Math.min(R.startColumn,I.startColumn)):(b=I.startLineNumber,$=I.startColumn),R.endLineNumber>I.endLineNumber?(y=R.endLineNumber,A=R.endColumn):R.endLineNumber===I.endLineNumber?(y=R.endLineNumber,A=Math.max(R.endColumn,I.endColumn)):(y=I.endLineNumber,A=I.endColumn),new N(b,$,y,A)}intersectRanges(I){return N.intersectRanges(this,I)}static intersectRanges(I,R){let b=I.startLineNumber,$=I.startColumn,y=I.endLineNumber,A=I.endColumn;const C=R.startLineNumber,m=R.startColumn,v=R.endLineNumber,k=R.endColumn;return b<C?(b=C,$=m):b===C&&($=Math.max($,m)),y>v?(y=v,A=k):y===v&&(A=Math.min(A,k)),b>y||b===y&&$>A?null:new N(b,$,y,A)}equalsRange(I){return N.equalsRange(this,I)}static equalsRange(I,R){return!I&&!R?!0:!!I&&!!R&&I.startLineNumber===R.startLineNumber&&I.startColumn===R.startColumn&&I.endLineNumber===R.endLineNumber&&I.endColumn===R.endColumn}getEndPosition(){return N.getEndPosition(this)}static getEndPosition(I){return new D.$Hs(I.endLineNumber,I.endColumn)}getStartPosition(){return N.getStartPosition(this)}static getStartPosition(I){return new D.$Hs(I.startLineNumber,I.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(I,R){return new N(this.startLineNumber,this.startColumn,I,R)}setStartPosition(I,R){return new N(I,R,this.endLineNumber,this.endColumn)}collapseToStart(){return N.collapseToStart(this)}static collapseToStart(I){return new N(I.startLineNumber,I.startColumn,I.startLineNumber,I.startColumn)}collapseToEnd(){return N.collapseToEnd(this)}static collapseToEnd(I){return new N(I.endLineNumber,I.endColumn,I.endLineNumber,I.endColumn)}delta(I){return new N(this.startLineNumber+I,this.startColumn,this.endLineNumber+I,this.endColumn)}static fromPositions(I,R=I){return new N(I.lineNumber,I.column,R.lineNumber,R.column)}static lift(I){return I?new N(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):null}static isIRange(I){return I&&typeof I.startLineNumber=="number"&&typeof I.startColumn=="number"&&typeof I.endLineNumber=="number"&&typeof I.endColumn=="number"}static areIntersectingOrTouching(I,R){return!(I.endLineNumber<R.startLineNumber||I.endLineNumber===R.startLineNumber&&I.endColumn<R.startColumn||R.endLineNumber<I.startLineNumber||R.endLineNumber===I.startLineNumber&&R.endColumn<I.startColumn)}static areIntersecting(I,R){return!(I.endLineNumber<R.startLineNumber||I.endLineNumber===R.startLineNumber&&I.endColumn<=R.startColumn||R.endLineNumber<I.startLineNumber||R.endLineNumber===I.startLineNumber&&R.endColumn<=I.startColumn)}static compareRangesUsingStarts(I,R){if(I&&R){const y=I.startLineNumber|0,A=R.startLineNumber|0;if(y===A){const C=I.startColumn|0,m=R.startColumn|0;if(C===m){const v=I.endLineNumber|0,k=R.endLineNumber|0;if(v===k){const l=I.endColumn|0,f=R.endColumn|0;return l-f}return v-k}return C-m}return y-A}return(I?1:0)-(R?1:0)}static compareRangesUsingEnds(I,R){return I.endLineNumber===R.endLineNumber?I.endColumn===R.endColumn?I.startLineNumber===R.startLineNumber?I.startColumn-R.startColumn:I.startLineNumber-R.startLineNumber:I.endColumn-R.endColumn:I.endLineNumber-R.endLineNumber}static spansMultipleLines(I){return I.endLineNumber>I.startLineNumber}toJSON(){return this}}e.$Is=N}),define(Se[168],ke([1,0,29]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Js=void 0;class N{static insert(I,R){return{range:new D.$Is(I.lineNumber,I.column,I.lineNumber,I.column),text:R,forceMoveMarkers:!0}}static delete(I){return{range:I,text:null}}static replace(I,R){return{range:I,text:R}}static replaceMove(I,R){return{range:I,text:R,forceMoveMarkers:!0}}}e.$Js=N}),define(Se[169],ke([1,0,49,29]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=e.SelectionDirection=void 0;var g;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(g||(e.SelectionDirection=g={}));class I extends N.$Is{constructor(b,$,y,A){super(b,$,y,A),this.selectionStartLineNumber=b,this.selectionStartColumn=$,this.positionLineNumber=y,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return I.selectionsEqual(this,b)}static selectionsEqual(b,$){return b.selectionStartLineNumber===$.selectionStartLineNumber&&b.selectionStartColumn===$.selectionStartColumn&&b.positionLineNumber===$.positionLineNumber&&b.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,$){return this.getDirection()===0?new I(this.startLineNumber,this.startColumn,b,$):new I(b,$,this.startLineNumber,this.startColumn)}getPosition(){return new D.$Hs(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.$Hs(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,$){return this.getDirection()===0?new I(b,$,this.endLineNumber,this.endColumn):new I(this.endLineNumber,this.endColumn,b,$)}static fromPositions(b,$=b){return new I(b.lineNumber,b.column,$.lineNumber,$.column)}static fromRange(b,$){return $===0?new I(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new I(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new I(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,$){if(b&&!$||!b&&$)return!1;if(!b&&!$)return!0;if(b.length!==$.length)return!1;for(let y=0,A=b.length;y<A;y++)if(!this.selectionsEqual(b[y],$[y]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,$,y,A,C){return C===0?new I(b,$,y,A):new I(y,A,b,$)}}e.$Ks=I}),define(Se[170],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=void 0,e.$fs={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[171],ke([1,0,125]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=e.$8s=e.WordCharacterClass=void 0;var N;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(N||(e.WordCharacterClass=N={}));class g extends D.$6s{constructor(b){super(0);for(let $=0,y=b.length;$<y;$++)this.set(b.charCodeAt($),2);this.set(32,1),this.set(9,1)}}e.$8s=g;function I(R){const b={};return $=>(b.hasOwnProperty($)||(b[$]=R($)),b[$])}e.$9s=I(R=>new g(R))}),define(Se[126],ke([1,0,53,3,75]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=e.$js=e.$is=e.$hs=e.$gs=void 0,e.$gs="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function I(C=""){let m="(-?\\d*\\.\\d\\w*)|([^";for(const v of e.$gs)C.indexOf(v)>=0||(m+="\\"+v);return m+="\\s]+)",new RegExp(m,"g")}e.$hs=I();function R(C){let m=e.$hs;if(C&&C instanceof RegExp)if(C.global)m=C;else{let v="g";C.ignoreCase&&(v+="i"),C.multiline&&(v+="m"),C.unicode&&(v+="u"),m=new RegExp(C.source,v)}return m.lastIndex=0,m}e.$is=R;const b=new g.$3c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(C){const m=b.unshift(C);return(0,N.$Qc)(m)}e.$js=$;function y(C,m,v,k,l){if(m=R(m),l||(l=D.Iterable.first(b)),v.length>l.maxLen){let o=C-l.maxLen/2;return o<0?o=0:k+=o,v=v.substring(o,C+l.maxLen/2),y(C,m,v,k,l)}const f=Date.now(),s=C-1-k;let i=-1,n=null;for(let o=1;!(Date.now()-f>=l.timeBudget);o++){const c=s-l.windowSize*o;m.lastIndex=Math.max(0,c);const t=A(m,v,s,i);if(!t&&n||(n=t,c<=0))break;i=c}if(n){const o={word:n[0],startColumn:k+1+n.index,endColumn:k+1+n.index+n[0].length};return m.lastIndex=0,o}return null}e.$ks=y;function A(C,m,v,k){let l;for(;l=C.exec(m);){const f=l.index||0;if(f<=v&&C.lastIndex>=v)return l;if(k>0&&f>k)return null}return null}}),define(Se[172],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gt=e.$Ft=e.IndentAction=void 0;var D;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class N{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let $=0,y=b.notIn.length;$<y;$++)switch(b.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,$){if(b.getTokenCount()===0)return!0;const y=b.findTokenIndexAtOffset($-2),A=b.getStandardTokenType(y);return this.isOK(A)}g(b,$){for(let y=b;y<=$;y++){const A=String.fromCharCode(y);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Ft=N;class g{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of b)I(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),I(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),I(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),I(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&I(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$Gt=g;function I(R,b,$){R.has(b)?R.get(b).push($):R.set(b,[$])}}),define(Se[173],ke([1,0,125]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qZ=e.$pZ=e.$oZ=e.State=void 0;var N;(function(v){v[v.Invalid=0]="Invalid",v[v.Start=1]="Start",v[v.H=2]="H",v[v.HT=3]="HT",v[v.HTT=4]="HTT",v[v.HTTP=5]="HTTP",v[v.F=6]="F",v[v.FI=7]="FI",v[v.FIL=8]="FIL",v[v.BeforeColon=9]="BeforeColon",v[v.AfterColon=10]="AfterColon",v[v.AlmostThere=11]="AlmostThere",v[v.End=12]="End",v[v.Accept=13]="Accept",v[v.LastKnownState=14]="LastKnownState"})(N||(e.State=N={}));class g{constructor(k,l,f){const s=new Uint8Array(k*l);for(let i=0,n=k*l;i<n;i++)s[i]=f;this.a=s,this.rows=k,this.cols=l}get(k,l){return this.a[k*this.cols+l]}set(k,l,f){this.a[k*this.cols+l]=f}}class I{constructor(k){let l=0,f=0;for(let i=0,n=k.length;i<n;i++){const[o,c,t]=k[i];c>l&&(l=c),o>f&&(f=o),t>f&&(f=t)}l++,f++;const s=new g(f,l,0);for(let i=0,n=k.length;i<n;i++){const[o,c,t]=k[i];s.set(o,c,t)}this.a=s,this.b=l}nextState(k,l){return l<0||l>=this.b?0:this.a.get(k,l)}}e.$oZ=I;let R=null;function b(){return R===null&&(R=new I([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var $;(function(v){v[v.None=0]="None",v[v.ForceTermination=1]="ForceTermination",v[v.CannotEndIn=2]="CannotEndIn"})($||($={}));let y=null;function A(){if(y===null){y=new D.$6s(0);const v=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let l=0;l<v.length;l++)y.set(v.charCodeAt(l),1);const k=".,;:";for(let l=0;l<k.length;l++)y.set(k.charCodeAt(l),2)}return y}class C{static a(k,l,f,s,i){let n=i-1;do{const o=l.charCodeAt(n);if(k.get(o)!==2)break;n--}while(n>s);if(s>0){const o=l.charCodeAt(s-1),c=l.charCodeAt(n);(o===40&&c===41||o===91&&c===93||o===123&&c===125)&&n--}return{range:{startLineNumber:f,startColumn:s+1,endLineNumber:f,endColumn:n+2},url:l.substring(s,n+1)}}static computeLinks(k,l=b()){const f=A(),s=[];for(let i=1,n=k.getLineCount();i<=n;i++){const o=k.getLineContent(i),c=o.length;let t=0,r=0,d=0,u=1,a=!1,h=!1,S=!1,P=!1;for(;t<c;){let w=!1;const p=o.charCodeAt(t);if(u===13){let E;switch(p){case 40:a=!0,E=0;break;case 41:E=a?0:1;break;case 91:S=!0,h=!0,E=0;break;case 93:S=!1,E=h?0:1;break;case 123:P=!0,E=0;break;case 125:E=P?0:1;break;case 39:case 34:case 96:d===p?E=1:d===39||d===34||d===96?E=0:E=1;break;case 42:E=d===42?1:0;break;case 124:E=d===124?1:0;break;case 32:E=S?0:1;break;default:E=f.get(p)}E===1&&(s.push(C.a(f,o,i,r,t)),w=!0)}else if(u===12){let E;p===91?(h=!0,E=0):E=f.get(p),E===1?w=!0:u=13}else u=l.nextState(u,p),u===0&&(w=!0);w&&(u=1,a=!1,h=!1,P=!1,r=t+1,d=p),t++}u===13&&s.push(C.a(f,o,i,r,c))}return s}}e.$pZ=C;function m(v){return!v||typeof v.getLineCount!="function"||typeof v.getLineContent!="function"?[]:C.computeLinks(v)}e.$qZ=m}),define(Se[79],ke([1,0,24]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6u=e.$5u=e.$4u=e.$3u=e.ModelConstants=e.PositionAffinity=e.$2u=e.TrackedRangeStickiness=e.$1u=e.$Zu=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var N;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(N||(e.OverviewRulerLane=N={}));var g;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(g||(e.GlyphMarginLane=g={}));var I;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(I||(e.MinimapPosition=I={}));var R;(function(o){o[o.Both=0]="Both",o[o.Right=1]="Right",o[o.Left=2]="Left",o[o.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var b;(function(o){o[o.TextDefined=0]="TextDefined",o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(b||(e.EndOfLinePreference=b={}));var $;(function(o){o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})($||(e.DefaultEndOfLine=$={}));var y;(function(o){o[o.LF=0]="LF",o[o.CRLF=1]="CRLF"})(y||(e.EndOfLineSequence=y={}));class A{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(c){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,c.tabSize|0),c.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,c.indentSize|0),this.a=!1),this.insertSpaces=!!c.insertSpaces,this.defaultEOL=c.defaultEOL|0,this.trimAutoWhitespace=!!c.trimAutoWhitespace,this.bracketPairColorizationOptions=c.bracketPairColorizationOptions}equals(c){return this.tabSize===c.tabSize&&this.a===c.a&&this.indentSize===c.indentSize&&this.insertSpaces===c.insertSpaces&&this.defaultEOL===c.defaultEOL&&this.trimAutoWhitespace===c.trimAutoWhitespace&&(0,D.$nn)(this.bracketPairColorizationOptions,c.bracketPairColorizationOptions)}createChangeEvent(c){return{tabSize:this.tabSize!==c.tabSize,indentSize:this.indentSize!==c.indentSize,insertSpaces:this.insertSpaces!==c.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==c.trimAutoWhitespace}}}e.$Zu=A;class C{constructor(c,t){this._findMatchBrand=void 0,this.range=c,this.matches=t}}e.$1u=C;var m;(function(o){o[o.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",o[o.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",o[o.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",o[o.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(m||(e.TrackedRangeStickiness=m={}));function v(o){return o&&typeof o.read=="function"}e.$2u=v;var k;(function(o){o[o.Left=0]="Left",o[o.Right=1]="Right",o[o.None=2]="None",o[o.LeftOfInjectedText=3]="LeftOfInjectedText",o[o.RightOfInjectedText=4]="RightOfInjectedText"})(k||(e.PositionAffinity=k={}));var l;(function(o){o[o.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(l||(e.ModelConstants=l={}));class f{constructor(c,t,r,d,u,a){this.identifier=c,this.range=t,this.text=r,this.forceMoveMarkers=d,this.isAutoWhitespaceEdit=u,this._isTracked=a}}e.$3u=f;class s{constructor(c,t,r){this.regex=c,this.wordSeparators=t,this.simpleSearch=r}}e.$4u=s;class i{constructor(c,t,r){this.reverseEdits=c,this.changes=t,this.trimAutoWhitespaceLineNumbers=r}}e.$5u=i;function n(o){return!o.isTooLargeForSyncing()&&!o.isForSimpleWidget}e.$6u=n}),define(Se[174],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NB=e.$MB=e.$LB=e.$KB=e.$JB=e.$IB=e.$HB=e.$GB=e.$FB=e.NodeColor=e.$EB=void 0;class D{constructor(f,s){this.piece=f,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$FB)return g(this.right);let f=this;for(;f.parent!==e.$FB&&f.parent.left!==f;)f=f.parent;return f.parent===e.$FB?e.$FB:f.parent}prev(){if(this.left!==e.$FB)return I(this.left);let f=this;for(;f.parent!==e.$FB&&f.parent.right!==f;)f=f.parent;return f.parent===e.$FB?e.$FB:f.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$EB=D;var N;(function(l){l[l.Black=0]="Black",l[l.Red=1]="Red"})(N||(e.NodeColor=N={})),e.$FB=new D(null,0),e.$FB.parent=e.$FB,e.$FB.left=e.$FB,e.$FB.right=e.$FB,e.$FB.color=0;function g(l){for(;l.left!==e.$FB;)l=l.left;return l}e.$GB=g;function I(l){for(;l.right!==e.$FB;)l=l.right;return l}e.$HB=I;function R(l){return l===e.$FB?0:l.size_left+l.piece.length+R(l.right)}function b(l){return l===e.$FB?0:l.lf_left+l.piece.lineFeedCnt+b(l.right)}function $(){e.$FB.parent=e.$FB}function y(l,f){const s=f.right;s.size_left+=f.size_left+(f.piece?f.piece.length:0),s.lf_left+=f.lf_left+(f.piece?f.piece.lineFeedCnt:0),f.right=s.left,s.left!==e.$FB&&(s.left.parent=f),s.parent=f.parent,f.parent===e.$FB?l.root=s:f.parent.left===f?f.parent.left=s:f.parent.right=s,s.left=f,f.parent=s}e.$IB=y;function A(l,f){const s=f.left;f.left=s.right,s.right!==e.$FB&&(s.right.parent=f),s.parent=f.parent,f.size_left-=s.size_left+(s.piece?s.piece.length:0),f.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),f.parent===e.$FB?l.root=s:f===f.parent.right?f.parent.right=s:f.parent.left=s,s.right=f,f.parent=s}e.$JB=A;function C(l,f){let s,i;if(f.left===e.$FB?(i=f,s=i.right):f.right===e.$FB?(i=f,s=i.left):(i=g(f.right),s=i.right),i===l.root){l.root=s,s.color=0,f.detach(),$(),l.root.parent=e.$FB;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=s:i.parent.right=s,i===f?(s.parent=i.parent,k(l,s)):(i.parent===f?s.parent=i:s.parent=i.parent,k(l,s),i.left=f.left,i.right=f.right,i.parent=f.parent,i.color=f.color,f===l.root?l.root=i:f===f.parent.left?f.parent.left=i:f.parent.right=i,i.left!==e.$FB&&(i.left.parent=i),i.right!==e.$FB&&(i.right.parent=i),i.size_left=f.size_left,i.lf_left=f.lf_left,k(l,i)),f.detach(),s.parent.left===s){const c=R(s),t=b(s);if(c!==s.parent.size_left||t!==s.parent.lf_left){const r=c-s.parent.size_left,d=t-s.parent.lf_left;s.parent.size_left=c,s.parent.lf_left=t,v(l,s.parent,r,d)}}if(k(l,s.parent),n){$();return}let o;for(;s!==l.root&&s.color===0;)s===s.parent.left?(o=s.parent.right,o.color===1&&(o.color=0,s.parent.color=1,y(l,s.parent),o=s.parent.right),o.left.color===0&&o.right.color===0?(o.color=1,s=s.parent):(o.right.color===0&&(o.left.color=0,o.color=1,A(l,o),o=s.parent.right),o.color=s.parent.color,s.parent.color=0,o.right.color=0,y(l,s.parent),s=l.root)):(o=s.parent.left,o.color===1&&(o.color=0,s.parent.color=1,A(l,s.parent),o=s.parent.left),o.left.color===0&&o.right.color===0?(o.color=1,s=s.parent):(o.left.color===0&&(o.right.color=0,o.color=1,y(l,o),o=s.parent.left),o.color=s.parent.color,s.parent.color=0,o.left.color=0,A(l,s.parent),s=l.root));s.color=0,$()}e.$KB=C;function m(l,f){for(k(l,f);f!==l.root&&f.parent.color===1;)if(f.parent===f.parent.parent.left){const s=f.parent.parent.right;s.color===1?(f.parent.color=0,s.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.right&&(f=f.parent,y(l,f)),f.parent.color=0,f.parent.parent.color=1,A(l,f.parent.parent))}else{const s=f.parent.parent.left;s.color===1?(f.parent.color=0,s.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.left&&(f=f.parent,A(l,f)),f.parent.color=0,f.parent.parent.color=1,y(l,f.parent.parent))}l.root.color=0}e.$LB=m;function v(l,f,s,i){for(;f!==l.root&&f!==e.$FB;)f.parent.left===f&&(f.parent.size_left+=s,f.parent.lf_left+=i),f=f.parent}e.$MB=v;function k(l,f){let s=0,i=0;if(f!==l.root){for(;f!==l.root&&f===f.parent.right;)f=f.parent;if(f!==l.root)for(f=f.parent,s=R(f.left)-f.size_left,i=b(f.left)-f.lf_left,f.size_left+=s,f.lf_left+=i;f!==l.root&&(s!==0||i!==0);)f.parent.left===f&&(f.parent.size_left+=s,f.parent.lf_left+=i),f=f.parent}}e.$NB=k}),define(Se[175],ke([1,0,19,124]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$u=e.$0u=e.$9u=void 0;class g{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,y){$=(0,N.$Fe)($);const A=this.a,C=this.b,m=y.length;return m===0?!1:(this.a=new Uint32Array(A.length+m),this.a.set(A.subarray(0,$),0),this.a.set(A.subarray($),$+m),this.a.set(y,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}setValue($,y){return $=(0,N.$Fe)($),y=(0,N.$Fe)(y),this.a[$]===y?!1:(this.a[$]=y,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,y){$=(0,N.$Fe)($),y=(0,N.$Fe)(y);const A=this.a,C=this.b;if($>=A.length)return!1;const m=A.length-$;return y>=m&&(y=m),y===0?!1:(this.a=new Uint32Array(A.length-y),this.a.set(A.subarray(0,$),0),this.a.set(A.subarray($+y),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,N.$Fe)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let y=this.c[0]+1;y===0&&(this.b[0]=this.a[0],y++),$>=this.a.length&&($=this.a.length-1);for(let A=y;A<=$;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let y=0,A=this.a.length-1,C=0,m=0,v=0;for(;y<=A;)if(C=y+(A-y)/2|0,m=this.b[C],v=m-this.a[C],$<v)A=C-1;else if($>=m)y=C+1;else break;return new R(C,$-v)}}e.$9u=g;class I{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const y=this.e[$],A=y>0?this.d[y-1]:0;return new R(y,$-A)}removeValues($,y){this.a.splice($,y),this.f($)}insertValues($,y){this.a=(0,D.$Wb)(this.a,$,y),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,y=this.a.length;$<y;$++){const A=this.a[$],C=$>0?this.d[$-1]:0;this.d[$]=C+A;for(let m=0;m<A;m++)this.e[C+m]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,y){this.a[$]!==y&&(this.a[$]=y,this.f($))}}e.$0u=I;class R{constructor($,y){this.index=$,this.remainder=y,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=y}}e.$$u=R}),define(Se[176],ke([1,0,12,49,175]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_u=void 0;class I{constructor(b,$,y,A){this.d=b,this.f=$,this.g=y,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const $=b.changes;for(const y of $)this.o(y.range),this.p(new N.$Hs(y.range.startLineNumber,y.range.startColumn),y.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,$=this.f.length,y=new Uint32Array($);for(let A=0;A<$;A++)y[A]=this.f[A].length+b;this.j=new g.$9u(y)}}n(b,$){this.f[b]=$,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,$){if($.length===0)return;const y=(0,D.$We)($);if(y.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+y[0]+this.f[b.lineNumber-1].substring(b.column-1));return}y[y.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+y[0]);const A=new Uint32Array(y.length-1);for(let C=1;C<y.length;C++)this.f.splice(b.lineNumber+C-1,0,y[C]),A[C-1]=y[C].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,A)}}e.$_u=I}),define(Se[99],ke([1,0,12,171,49,29,79]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TB=e.$SB=e.$RB=e.$QB=e.$PB=e.$OB=void 0;const b=999;class ${constructor(i,n,o,c){this.searchString=i,this.isRegex=n,this.matchCase=o,this.wordSeparators=c}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=y(this.searchString):i=this.searchString.indexOf(`
`)>=0;let n=null;try{n=D.$Ue(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!n)return null;let o=!this.isRegex&&!i;return o&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(o=this.matchCase),new R.$4u(n,this.wordSeparators?(0,N.$9s)(this.wordSeparators):null,o?this.searchString:null)}}e.$OB=$;function y(s){if(!s||s.length===0)return!1;for(let i=0,n=s.length;i<n;i++){const o=s.charCodeAt(i);if(o===10)return!0;if(o===92){if(i++,i>=n)break;const c=s.charCodeAt(i);if(c===110||c===114||c===87)return!0}}return!1}e.$PB=y;function A(s,i,n){if(!n)return new R.$1u(s,null);const o=[];for(let c=0,t=i.length;c<t;c++)o[c]=i[c];return new R.$1u(s,o)}e.$QB=A;class C{constructor(i){const n=[];let o=0;for(let c=0,t=i.length;c<t;c++)i.charCodeAt(c)===10&&(n[o++]=c);this.a=n}findLineFeedCountBeforeOffset(i){const n=this.a;let o=0,c=n.length-1;if(c===-1||i<=n[0])return 0;for(;o<c;){const t=o+((c-o)/2>>0);n[t]>=i?c=t-1:n[t+1]>=i?(o=t,c=t):o=t+1}return o+1}}class m{static findMatches(i,n,o,c,t){const r=n.parseSearchRequest();return r?r.regex.multiline?this.b(i,o,new f(r.wordSeparators,r.regex),c,t):this.c(i,o,r,c,t):[]}static a(i,n,o,c,t,r){let d,u=0;c?(u=c.findLineFeedCountBeforeOffset(t),d=n+t+u):d=n+t;let a;if(c){const w=c.findLineFeedCountBeforeOffset(t+r.length)-u;a=d+r.length+w}else a=d+r.length;const h=i.getPositionAt(d),S=i.getPositionAt(a);return new I.$Is(h.lineNumber,h.column,S.lineNumber,S.column)}static b(i,n,o,c,t){const r=i.getOffsetAt(n.getStartPosition()),d=i.getValueInRange(n,1),u=i.getEOL()===`\r
`?new C(d):null,a=[];let h=0,S;for(o.reset(0);S=o.next(d);)if(a[h++]=A(this.a(i,r,d,u,S.index,S[0]),S,c),h>=t)return a;return a}static c(i,n,o,c,t){const r=[];let d=0;if(n.startLineNumber===n.endLineNumber){const a=i.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return d=this.d(o,a,n.startLineNumber,n.startColumn-1,d,r,c,t),r}const u=i.getLineContent(n.startLineNumber).substring(n.startColumn-1);d=this.d(o,u,n.startLineNumber,n.startColumn-1,d,r,c,t);for(let a=n.startLineNumber+1;a<n.endLineNumber&&d<t;a++)d=this.d(o,i.getLineContent(a),a,0,d,r,c,t);if(d<t){const a=i.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);d=this.d(o,a,n.endLineNumber,0,d,r,c,t)}return r}static d(i,n,o,c,t,r,d,u){const a=i.wordSeparators;if(!d&&i.simpleSearch){const P=i.simpleSearch,w=P.length,p=n.length;let E=-w;for(;(E=n.indexOf(P,E+w))!==-1;)if((!a||l(a,n,p,E,w))&&(r[t++]=new R.$1u(new I.$Is(o,E+1+c,o,E+1+w+c),null),t>=u))return t;return t}const h=new f(i.wordSeparators,i.regex);let S;h.reset(0);do if(S=h.next(n),S&&(r[t++]=A(new I.$Is(o,S.index+1+c,o,S.index+1+S[0].length+c),S,d),t>=u))return t;while(S);return t}static findNextMatch(i,n,o,c){const t=n.parseSearchRequest();if(!t)return null;const r=new f(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,o,r,c):this.f(i,o,r,c)}static e(i,n,o,c){const t=new g.$Hs(n.lineNumber,1),r=i.getOffsetAt(t),d=i.getLineCount(),u=i.getValueInRange(new I.$Is(t.lineNumber,t.column,d,i.getLineMaxColumn(d)),1),a=i.getEOL()===`\r
`?new C(u):null;o.reset(n.column-1);const h=o.next(u);return h?A(this.a(i,r,u,a,h.index,h[0]),h,c):n.lineNumber!==1||n.column!==1?this.e(i,new g.$Hs(1,1),o,c):null}static f(i,n,o,c){const t=i.getLineCount(),r=n.lineNumber,d=i.getLineContent(r),u=this.g(o,d,r,n.column,c);if(u)return u;for(let a=1;a<=t;a++){const h=(r+a-1)%t,S=i.getLineContent(h+1),P=this.g(o,S,h+1,1,c);if(P)return P}return null}static g(i,n,o,c,t){i.reset(c-1);const r=i.next(n);return r?A(new I.$Is(o,r.index+1,o,r.index+1+r[0].length),r,t):null}static findPreviousMatch(i,n,o,c){const t=n.parseSearchRequest();if(!t)return null;const r=new f(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,o,r,c):this.j(i,o,r,c)}static h(i,n,o,c){const t=this.b(i,new I.$Is(1,1,n.lineNumber,n.column),o,c,10*b);if(t.length>0)return t[t.length-1];const r=i.getLineCount();return n.lineNumber!==r||n.column!==i.getLineMaxColumn(r)?this.h(i,new g.$Hs(r,i.getLineMaxColumn(r)),o,c):null}static j(i,n,o,c){const t=i.getLineCount(),r=n.lineNumber,d=i.getLineContent(r).substring(0,n.column-1),u=this.k(o,d,r,c);if(u)return u;for(let a=1;a<=t;a++){const h=(t+r-a-1)%t,S=i.getLineContent(h+1),P=this.k(o,S,h+1,c);if(P)return P}return null}static k(i,n,o,c){let t=null,r;for(i.reset(0);r=i.next(n);)t=A(new I.$Is(o,r.index+1,o,r.index+1+r[0].length),r,c);return t}}e.$RB=m;function v(s,i,n,o,c){if(o===0)return!0;const t=i.charCodeAt(o-1);if(s.get(t)!==0||t===13||t===10)return!0;if(c>0){const r=i.charCodeAt(o);if(s.get(r)!==0)return!0}return!1}function k(s,i,n,o,c){if(o+c===n)return!0;const t=i.charCodeAt(o+c);if(s.get(t)!==0||t===13||t===10)return!0;if(c>0){const r=i.charCodeAt(o+c-1);if(s.get(r)!==0)return!0}return!1}function l(s,i,n,o,c){return v(s,i,n,o,c)&&k(s,i,n,o,c)}e.$SB=l;class f{constructor(i,n){this._wordSeparators=i,this.a=n,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const n=i.length;let o;do{if(this.b+this.c===n||(o=this.a.exec(i),!o))return null;const c=o.index,t=o[0].length;if(c===this.b&&t===this.c){if(t===0){D.$df(i,n,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=c,this.c=t,!this._wordSeparators||l(this._wordSeparators,i,n,c,t))return o}while(o);return null}}e.$TB=f}),define(Se[127],ke([1,0,49,29,79,174,99]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YB=e.$XB=e.$WB=e.$VB=e.$UB=void 0;const b=65535;function $(s){let i;return s[s.length-1]<65536?i=new Uint16Array(s.length):i=new Uint32Array(s.length),i.set(s,0),i}class y{constructor(i,n,o,c,t){this.lineStarts=i,this.cr=n,this.lf=o,this.crlf=c,this.isBasicASCII=t}}function A(s,i=!0){const n=[0];let o=1;for(let c=0,t=s.length;c<t;c++){const r=s.charCodeAt(c);r===13?c+1<t&&s.charCodeAt(c+1)===10?(n[o++]=c+2,c++):n[o++]=c+1:r===10&&(n[o++]=c+1)}return i?$(n):n}e.$UB=A;function C(s,i){s.length=0,s[0]=0;let n=1,o=0,c=0,t=0,r=!0;for(let u=0,a=i.length;u<a;u++){const h=i.charCodeAt(u);h===13?u+1<a&&i.charCodeAt(u+1)===10?(t++,s[n++]=u+2,u++):(o++,s[n++]=u+1):h===10?(c++,s[n++]=u+1):r&&h!==9&&(h<32||h>126)&&(r=!1)}const d=new y($(s),o,c,t,r);return s.length=0,d}e.$VB=C;class m{constructor(i,n,o,c,t){this.bufferIndex=i,this.start=n,this.end=o,this.lineFeedCnt=c,this.length=t}}e.$WB=m;class v{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$XB=v;class k{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==I.$FB&&i.iterate(i.root,o=>(o!==I.$FB&&this.a.push(o.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class l{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const o=this.b[n];if(o.nodeStartOffset<=i&&o.nodeStartOffset+o.node.piece.length>=i)return o}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const o=this.b[n];if(o.nodeStartLineNumber&&o.nodeStartLineNumber<i&&o.nodeStartLineNumber+o.node.piece.lineFeedCnt>=i)return o}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const o=this.b;for(let c=0;c<o.length;c++){const t=o[c];if(t.node.parent===null||t.nodeStartOffset>=i){o[c]=null,n=!0;continue}}if(n){const c=[];for(const t of o)t!==null&&c.push(t);this.b=c}}}class f{constructor(i,n,o){this.create(i,n,o)}create(i,n,o){this.a=[new v("",[0])],this.g={line:0,column:0},this.root=I.$FB,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=o;let c=null;for(let t=0,r=i.length;t<r;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=A(i[t].buffer));const d=new m(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),c=this.S(c,d)}this.h=new l(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=b,o=n-Math.floor(n/3),c=o*2;let t="",r=0;const d=[];if(this.iterate(this.root,u=>{const a=this.R(u),h=a.length;if(r<=o||r+h<c)return t+=a,r+=h,!0;const S=t.replace(/\r\n|\r|\n/g,i);return d.push(new v(S,A(S))),t=a,r=h,!0}),r>0){const u=t.replace(/\r\n|\r|\n/g,i);d.push(new v(u,A(u)))}this.create(d,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new k(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,c=>{if(c===I.$FB)return!0;const t=this.R(c),r=t.length,d=i.G(n),u=i.G(n+r),a=i.getValueInRange2(d,u);return n+=r,t===a})}getOffsetAt(i,n){let o=0,c=this.root;for(;c!==I.$FB;)if(c.left!==I.$FB&&c.lf_left+1>=i)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt+1>=i){o+=c.size_left;const t=this.B(c,i-c.lf_left-2);return o+=t+n-1}else i-=c.lf_left+c.piece.lineFeedCnt,o+=c.size_left+c.piece.length,c=c.right;return o}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,o=0;const c=i;for(;n!==I.$FB;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(o+=n.lf_left+t.index,t.index===0){const r=this.getOffsetAt(o+1,1),d=c-r;return new D.$Hs(o+1,d+1)}return new D.$Hs(o+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,o+=n.lf_left+n.piece.lineFeedCnt,n.right===I.$FB){const t=this.getOffsetAt(o+1,1),r=c-i-t;return new D.$Hs(o+1,r+1)}else n=n.right;return new D.$Hs(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const o=this.H(i.startLineNumber,i.startColumn),c=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(o,c);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const d=i.node,u=this.a[d.piece.bufferIndex].buffer,a=this.u(d.piece.bufferIndex,d.piece.start);return u.substring(a+i.remainder,a+n.remainder)}let o=i.node;const c=this.a[o.piece.bufferIndex].buffer,t=this.u(o.piece.bufferIndex,o.piece.start);let r=c.substring(t+i.remainder,t+o.piece.length);for(o=o.next();o!==I.$FB;){const d=this.a[o.piece.bufferIndex].buffer,u=this.u(o.piece.bufferIndex,o.piece.start);if(o===n.node){r+=d.substring(u,u+n.remainder);break}else r+=d.substr(u,o.piece.length);o=o.next()}return r}getLinesContent(){const i=[];let n=0,o="",c=!1;return this.iterate(this.root,t=>{if(t===I.$FB)return!0;const r=t.piece;let d=r.length;if(d===0)return!0;const u=this.a[r.bufferIndex].buffer,a=this.a[r.bufferIndex].lineStarts,h=r.start.line,S=r.end.line;let P=a[h]+r.start.column;if(c&&(u.charCodeAt(P)===10&&(P++,d--),i[n++]=o,o="",c=!1,d===0))return!0;if(h===S)return!this.f&&u.charCodeAt(P+d-1)===13?(c=!0,o+=u.substr(P,d-1)):o+=u.substr(P,d),!0;o+=this.f?u.substring(P,Math.max(P,a[h+1]-this.e)):u.substring(P,a[h+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=o;for(let w=h+1;w<S;w++)o=this.f?u.substring(a[w],a[w+1]-this.e):u.substring(a[w],a[w+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=o;return!this.f&&u.charCodeAt(a[S]+r.end.column-1)===13?(c=!0,r.end.column===0?n--:o=u.substr(a[S],r.end.column-1)):o=u.substr(a[S],r.end.column),!0}),c&&(i[n++]=o,o=""),i[n++]=o,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const o=this.a[n.piece.bufferIndex],c=this.u(n.piece.bufferIndex,n.piece.start);return o.buffer.charCodeAt(c)}else{const n=this.a[i.node.piece.bufferIndex],c=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(c)}}getLineCharCode(i,n){const o=this.H(i,n+1);return this.l(o)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,o,c,t,r,d,u,a,h,S){const P=this.a[i.piece.bufferIndex],w=this.u(i.piece.bufferIndex,i.piece.start),p=this.u(i.piece.bufferIndex,t),E=this.u(i.piece.bufferIndex,r);let L;const T={line:0,column:0};let U,F;n._wordSeparators?(U=P.buffer.substring(p,E),F=j=>j+p,n.reset(0)):(U=P.buffer,F=j=>j,n.reset(p));do if(L=n.next(U),L){if(F(L.index)>=E)return h;this.s(i,F(L.index)-w,T);const j=this.t(i.piece.bufferIndex,t,T),O=T.line===t.line?T.column-t.column+c:T.column+1,M=O+L[0].length;if(S[h++]=(0,R.$QB)(new N.$Is(o+j,O,o+j,M),L,u),F(L.index)+L[0].length>=E||h>=a)return h}while(L);return h}findMatchesLineByLine(i,n,o,c){const t=[];let r=0;const d=new R.$TB(n.wordSeparators,n.regex);let u=this.H(i.startLineNumber,i.startColumn);if(u===null)return[];const a=this.H(i.endLineNumber,i.endColumn);if(a===null)return[];let h=this.s(u.node,u.remainder);const S=this.s(a.node,a.remainder);if(u.node===a.node)return this.findMatchesInNode(u.node,d,i.startLineNumber,i.startColumn,h,S,n,o,c,r,t),t;let P=i.startLineNumber,w=u.node;for(;w!==a.node;){const E=this.t(w.piece.bufferIndex,h,w.piece.end);if(E>=1){const T=this.a[w.piece.bufferIndex].lineStarts,U=this.u(w.piece.bufferIndex,w.piece.start),F=T[h.line+E],j=P===i.startLineNumber?i.startColumn:1;if(r=this.findMatchesInNode(w,d,P,j,h,this.s(w,F-U),n,o,c,r,t),r>=c)return t;P+=E}const L=P===i.startLineNumber?i.startColumn-1:0;if(P===i.endLineNumber){const T=this.getLineContent(P).substring(L,i.endColumn-1);return r=this.n(n,d,T,i.endLineNumber,L,r,t,o,c),t}if(r=this.n(n,d,this.getLineContent(P).substr(L),P,L,r,t,o,c),r>=c)return t;P++,u=this.H(P,1),w=u.node,h=this.s(u.node,u.remainder)}if(P===i.endLineNumber){const E=P===i.startLineNumber?i.startColumn-1:0,L=this.getLineContent(P).substring(E,i.endColumn-1);return r=this.n(n,d,L,i.endLineNumber,E,r,t,o,c),t}const p=P===i.startLineNumber?i.startColumn:1;return r=this.findMatchesInNode(a.node,d,P,p,h,S,n,o,c,r,t),t}n(i,n,o,c,t,r,d,u,a){const h=i.wordSeparators;if(!u&&i.simpleSearch){const P=i.simpleSearch,w=P.length,p=o.length;let E=-w;for(;(E=o.indexOf(P,E+w))!==-1;)if((!h||(0,R.$SB)(h,o,p,E,w))&&(d[r++]=new g.$1u(new N.$Is(c,E+1+t,c,E+1+w+t),null),r>=a))return r;return r}let S;n.reset(0);do if(S=n.next(o),S&&(d[r++]=(0,R.$QB)(new N.$Is(c,S.index+1+t,c,S.index+1+S[0].length+t),S,u),r>=a))return r;while(S);return r}insert(i,n,o=!1){if(this.f=this.f&&o,this.j.lineNumber=0,this.j.value="",this.root!==I.$FB){const{node:c,remainder:t,nodeStartOffset:r}=this.G(i),d=c.piece,u=d.bufferIndex,a=this.s(c,t);if(c.piece.bufferIndex===0&&d.end.line===this.g.line&&d.end.column===this.g.column&&r+d.length===i&&n.length<b){this.F(c,n),this.y();return}if(r===i)this.o(n,c),this.h.validate(i);else if(r+c.piece.length>i){const h=[];let S=new m(d.bufferIndex,a,d.end,this.t(d.bufferIndex,a,d.end),this.u(u,d.end)-this.u(u,a));if(this.K()&&this.M(n)&&this.I(c,t)===10){const E={line:S.start.line+1,column:0};S=new m(S.bufferIndex,E,S.end,this.t(S.bufferIndex,E,S.end),S.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(c,t-1)===13){const E=this.s(c,t-1);this.C(c,E),n="\r"+n,c.piece.length===0&&h.push(c)}else this.C(c,a);else this.C(c,a);const P=this.w(n);S.length>0&&this.S(c,S);let w=c;for(let p=0;p<P.length;p++)w=this.S(w,P[p]);this.v(h)}else this.q(n,c)}else{const c=this.w(n);let t=this.T(null,c[0]);for(let r=1;r<c.length;r++)t=this.S(t,c[r])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===I.$FB)return;const o=this.G(i),c=this.G(i+n),t=o.node,r=c.node;if(t===r){const P=this.s(t,o.remainder),w=this.s(t,c.remainder);if(o.nodeStartOffset===i){if(n===t.piece.length){const p=t.next();(0,I.$KB)(this,t),this.N(p),this.y();return}this.D(t,w),this.h.validate(i),this.N(t),this.y();return}if(o.nodeStartOffset+t.piece.length===i+n){this.C(t,P),this.O(t),this.y();return}this.E(t,P,w),this.y();return}const d=[],u=this.s(t,o.remainder);this.C(t,u),this.h.validate(i),t.piece.length===0&&d.push(t);const a=this.s(r,c.remainder);this.D(r,a),r.piece.length===0&&d.push(r);const h=t.next();for(let P=h;P!==I.$FB&&P!==r;P=P.next())d.push(P);const S=t.piece.length===0?t.prev():t;this.v(d),this.O(S),this.y()}o(i,n){const o=[];if(this.K()&&this.M(i)&&this.L(n)){const r=n.piece,d={line:r.start.line+1,column:0},u=new m(r.bufferIndex,d,r.end,this.t(r.bufferIndex,d,r.end),r.length-1);n.piece=u,i+=`
`,(0,I.$MB)(this,n,-1,-1),n.piece.length===0&&o.push(n)}const c=this.w(i);let t=this.T(n,c[c.length-1]);for(let r=c.length-2;r>=0;r--)t=this.T(t,c[r]);this.N(t),this.v(o)}q(i,n){this.Q(i,n)&&(i+=`
`);const o=this.w(i),c=this.S(n,o[0]);let t=c;for(let r=1;r<o.length;r++)t=this.S(t,o[r]);this.N(c)}s(i,n,o){const c=i.piece,t=i.piece.bufferIndex,r=this.a[t].lineStarts,u=r[c.start.line]+c.start.column+n;let a=c.start.line,h=c.end.line,S=0,P=0,w=0;for(;a<=h&&(S=a+(h-a)/2|0,w=r[S],S!==h);)if(P=r[S+1],u<w)h=S-1;else if(u>=P)a=S+1;else break;return o?(o.line=S,o.column=u-w,null):{line:S,column:u-w}}t(i,n,o){if(o.column===0)return o.line-n.line;const c=this.a[i].lineStarts;if(o.line===c.length-1)return o.line-n.line;const t=c[o.line+1],r=c[o.line]+o.column;if(t>r+1)return o.line-n.line;const d=r-1;return this.a[i].buffer.charCodeAt(d)===13?o.line-n.line+1:o.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,I.$KB)(this,i[n])}w(i){if(i.length>b){const h=[];for(;i.length>b;){const P=i.charCodeAt(b-1);let w;P===13||P>=55296&&P<=56319?(w=i.substring(0,b-1),i=i.substring(b-1)):(w=i.substring(0,b),i=i.substring(b));const p=A(w);h.push(new m(this.a.length,{line:0,column:0},{line:p.length-1,column:w.length-p[p.length-1]},p.length-1,w.length)),this.a.push(new v(w,p))}const S=A(i);return h.push(new m(this.a.length,{line:0,column:0},{line:S.length-1,column:i.length-S[S.length-1]},S.length-1,i.length)),this.a.push(new v(i,S)),h}let n=this.a[0].buffer.length;const o=A(i,!1);let c=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},c=this.g;for(let h=0;h<o.length;h++)o[h]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let h=0;h<o.length;h++)o[h]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,r=this.a[0].lineStarts.length-1,d=t-this.a[0].lineStarts[r],u={line:r,column:d},a=new m(0,c,u,this.t(0,c,u),t-n);return this.g=u,[a]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let o=this.root,c="";const t=this.h.get2(i);if(t){o=t.node;const r=this.B(o,i-t.nodeStartLineNumber-1),d=this.a[o.piece.bufferIndex].buffer,u=this.u(o.piece.bufferIndex,o.piece.start);if(t.nodeStartLineNumber+o.piece.lineFeedCnt===i)c=d.substring(u+r,u+o.piece.length);else{const a=this.B(o,i-t.nodeStartLineNumber);return d.substring(u+r,u+a-n)}}else{let r=0;const d=i;for(;o!==I.$FB;)if(o.left!==I.$FB&&o.lf_left>=i-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>i-1){const u=this.B(o,i-o.lf_left-2),a=this.B(o,i-o.lf_left-1),h=this.a[o.piece.bufferIndex].buffer,S=this.u(o.piece.bufferIndex,o.piece.start);return r+=o.size_left,this.h.set({node:o,nodeStartOffset:r,nodeStartLineNumber:d-(i-1-o.lf_left)}),h.substring(S+u,S+a-n)}else if(o.lf_left+o.piece.lineFeedCnt===i-1){const u=this.B(o,i-o.lf_left-2),a=this.a[o.piece.bufferIndex].buffer,h=this.u(o.piece.bufferIndex,o.piece.start);c=a.substring(h+u,h+o.piece.length);break}else i-=o.lf_left+o.piece.lineFeedCnt,r+=o.size_left+o.piece.length,o=o.right}for(o=o.next();o!==I.$FB;){const r=this.a[o.piece.bufferIndex].buffer;if(o.piece.lineFeedCnt>0){const d=this.B(o,0),u=this.u(o.piece.bufferIndex,o.piece.start);return c+=r.substring(u,u+d-n),c}else{const d=this.u(o.piece.bufferIndex,o.piece.start);c+=r.substr(d,o.piece.length)}o=o.next()}return c}y(){let i=this.root,n=1,o=0;for(;i!==I.$FB;)n+=i.lf_left+i.piece.lineFeedCnt,o+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=o,this.h.validate(this.c)}A(i,n){const o=i.piece,c=this.s(i,n),t=c.line-o.start.line;if(this.u(o.bufferIndex,o.end)-this.u(o.bufferIndex,o.start)===n){const r=this.t(i.piece.bufferIndex,o.start,c);if(r!==t)return{index:r,remainder:0}}return{index:t,remainder:c.column}}B(i,n){if(n<0)return 0;const o=i.piece,c=this.a[o.bufferIndex].lineStarts,t=o.start.line+n+1;return t>o.end.line?c[o.end.line]+o.end.column-c[o.start.line]-o.start.column:c[t]-c[o.start.line]-o.start.column}C(i,n){const o=i.piece,c=o.lineFeedCnt,t=this.u(o.bufferIndex,o.end),r=n,d=this.u(o.bufferIndex,r),u=this.t(o.bufferIndex,o.start,r),a=u-c,h=d-t,S=o.length+h;i.piece=new m(o.bufferIndex,o.start,r,u,S),(0,I.$MB)(this,i,h,a)}D(i,n){const o=i.piece,c=o.lineFeedCnt,t=this.u(o.bufferIndex,o.start),r=n,d=this.t(o.bufferIndex,r,o.end),u=this.u(o.bufferIndex,r),a=d-c,h=t-u,S=o.length+h;i.piece=new m(o.bufferIndex,r,o.end,d,S),(0,I.$MB)(this,i,h,a)}E(i,n,o){const c=i.piece,t=c.start,r=c.end,d=c.length,u=c.lineFeedCnt,a=n,h=this.t(c.bufferIndex,c.start,a),S=this.u(c.bufferIndex,n)-this.u(c.bufferIndex,t);i.piece=new m(c.bufferIndex,c.start,a,h,S),(0,I.$MB)(this,i,S-d,h-u);const P=new m(c.bufferIndex,o,r,this.t(c.bufferIndex,o,r),this.u(c.bufferIndex,r)-this.u(c.bufferIndex,o)),w=this.S(i,P);this.N(w)}F(i,n){this.Q(n,i)&&(n+=`
`);const o=this.K()&&this.L(n)&&this.M(i),c=this.a[0].buffer.length;this.a[0].buffer+=n;const t=A(n,!1);for(let w=0;w<t.length;w++)t[w]+=c;if(o){const w=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:c-w}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const r=this.a[0].lineStarts.length-1,d=this.a[0].buffer.length-this.a[0].lineStarts[r],u={line:r,column:d},a=i.piece.length+n.length,h=i.piece.lineFeedCnt,S=this.t(0,i.piece.start,u),P=S-h;i.piece=new m(i.piece.bufferIndex,i.piece.start,u,S,a),this.g=u,(0,I.$MB)(this,i,n.length,P)}G(i){let n=this.root;const o=this.h.get(i);if(o)return{node:o.node,nodeStartOffset:o.nodeStartOffset,remainder:i-o.nodeStartOffset};let c=0;for(;n!==I.$FB;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){c+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:c};return this.h.set(t),t}else i-=n.size_left+n.piece.length,c+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let o=this.root,c=0;for(;o!==I.$FB;)if(o.left!==I.$FB&&o.lf_left>=i-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>i-1){const t=this.B(o,i-o.lf_left-2),r=this.B(o,i-o.lf_left-1);return c+=o.size_left,{node:o,remainder:Math.min(t+n-1,r),nodeStartOffset:c}}else if(o.lf_left+o.piece.lineFeedCnt===i-1){const t=this.B(o,i-o.lf_left-2);if(t+n-1<=o.piece.length)return{node:o,remainder:t+n-1,nodeStartOffset:c};n-=o.piece.length-t;break}else i-=o.lf_left+o.piece.lineFeedCnt,c+=o.size_left+o.piece.length,o=o.right;for(o=o.next();o!==I.$FB;){if(o.piece.lineFeedCnt>0){const t=this.B(o,0),r=this.J(o);return{node:o,remainder:Math.min(n-1,t),nodeStartOffset:r}}else if(o.piece.length>=n-1){const t=this.J(o);return{node:o,remainder:n-1,nodeStartOffset:t}}else n-=o.piece.length;o=o.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const o=this.a[i.piece.bufferIndex],c=this.u(i.piece.bufferIndex,i.piece.start)+n;return o.buffer.charCodeAt(c)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===I.$FB||i.piece.lineFeedCnt===0)return!1;const n=i.piece,o=this.a[n.bufferIndex].lineStarts,c=n.start.line,t=o[c]+n.start.column;return c===o.length-1||o[c+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===I.$FB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const o=[],c=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:c[i.piece.end.line]-c[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const r=i.piece.length-1,d=i.piece.lineFeedCnt-1;i.piece=new m(i.piece.bufferIndex,i.piece.start,t,d,r),(0,I.$MB)(this,i,-1,-1),i.piece.length===0&&o.push(i);const u={line:n.piece.start.line+1,column:0},a=n.piece.length-1,h=this.t(n.piece.bufferIndex,u,n.piece.end);n.piece=new m(n.piece.bufferIndex,u,n.piece.end,h,a),(0,I.$MB)(this,n,-1,-1),n.piece.length===0&&o.push(n);const S=this.w(`\r
`);this.S(i,S[0]);for(let P=0;P<o.length;P++)(0,I.$KB)(this,o[P])}Q(i,n){if(this.K()&&this.M(i)){const o=n.next();if(this.L(o)){if(i+=`
`,o.piece.length===1)(0,I.$KB)(this,o);else{const c=o.piece,t={line:c.start.line+1,column:0},r=c.length-1,d=this.t(c.bufferIndex,t,c.end);o.piece=new m(c.bufferIndex,t,c.end,d,r),(0,I.$MB)(this,o,-1,-1)}return!0}}return!1}iterate(i,n){if(i===I.$FB)return n(I.$FB);const o=this.iterate(i.left,n);return o&&n(i)&&this.iterate(i.right,n)}R(i){if(i===I.$FB)return"";const n=this.a[i.piece.bufferIndex],o=i.piece,c=this.u(o.bufferIndex,o.start),t=this.u(o.bufferIndex,o.end);return n.buffer.substring(c,t)}getPieceContent(i){const n=this.a[i.bufferIndex],o=this.u(i.bufferIndex,i.start),c=this.u(i.bufferIndex,i.end);return n.buffer.substring(o,c)}S(i,n){const o=new I.$EB(n,1);if(o.left=I.$FB,o.right=I.$FB,o.parent=I.$FB,o.size_left=0,o.lf_left=0,this.root===I.$FB)this.root=o,o.color=0;else if(i.right===I.$FB)i.right=o,o.parent=i;else{const t=(0,I.$GB)(i.right);t.left=o,o.parent=t}return(0,I.$LB)(this,o),o}T(i,n){const o=new I.$EB(n,1);if(o.left=I.$FB,o.right=I.$FB,o.parent=I.$FB,o.size_left=0,o.lf_left=0,this.root===I.$FB)this.root=o,o.color=0;else if(i.left===I.$FB)i.left=o,o.parent=i;else{const c=(0,I.$HB)(i.left);c.right=o,o.parent=c}return(0,I.$LB)(this,o),o}U(i){let n="";return this.iterate(i,o=>(n+=this.R(o),!0)),n}}e.$YB=f}),define(Se[177],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b8=e.$a8=void 0;class D{constructor(){this.a=new Map}removeDragOperationTransfer(I){if(I&&this.a.has(I)){const R=this.a.get(I);return this.a.delete(I),R}}addDragOperationTransfer(I,R){this.a.set(I,R)}}e.$a8=D;class N{constructor(I){this.identifier=I}}e.$b8=N}),define(Se[178],ke([1,0,4,3]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ht=void 0;class g{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$Sd,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,$){return this.a.set(b,$),this.handleChange([b]),(0,N.$Qc)(()=>{this.a.get(b)===$&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,$){this.b.get(b)?.dispose();const y=new I(this,b,$);return this.b.set(b,y),(0,N.$Qc)(()=>{const A=this.b.get(b);!A||A!==y||(this.b.delete(b),A.dispose())})}async getOrCreate(b){const $=this.get(b);if($)return $;const y=this.b.get(b);return!y||y.isResolved?null:(await y.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const y=this.b.get(b);return!!(!y||y.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$ht=g;class I extends N.$Sc{get isResolved(){return this.c}constructor(b,$,y){super(),this.f=b,this.g=$,this.h=y,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(Se[179],ke([8,9]),function(me,e){return me.create("vs/base/common/actions",e)}),define(Se[180],ke([1,0,4,3,179]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=void 0;class I extends N.$Sc{constructor(m,v="",k="",l=!0,f){super(),this.h=this.B(new D.$Sd),this.onDidChange=this.h.event,this.w=!0,this.j=m,this.m=v,this.u=k,this.w=l,this.C=f}get id(){return this.j}get label(){return this.m}set label(m){this.D(m)}D(m){this.m!==m&&(this.m=m,this.h.fire({label:m}))}get tooltip(){return this.n||""}set tooltip(m){this.F(m)}F(m){this.n!==m&&(this.n=m,this.h.fire({tooltip:m}))}get class(){return this.u}set class(m){this.G(m)}G(m){this.u!==m&&(this.u=m,this.h.fire({class:m}))}get enabled(){return this.w}set enabled(m){this.H(m)}H(m){this.w!==m&&(this.w=m,this.h.fire({enabled:m}))}get checked(){return this.z}set checked(m){this.I(m)}I(m){this.z!==m&&(this.z=m,this.h.fire({checked:m}))}async run(m,v){this.C&&await this.C(m)}}e.$Hi=I;class R extends N.$Sc{constructor(){super(...arguments),this.f=this.B(new D.$Sd),this.onWillRun=this.f.event,this.m=this.B(new D.$Sd),this.onDidRun=this.m.event}async run(m,v){if(!m.enabled)return;this.f.fire({action:m});let k;try{await this.u(m,v)}catch(l){k=l}this.m.fire({action:m,error:k})}async u(m,v){await m.run(v)}}e.$Ii=R;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...m){let v=[];for(const k of m)k.length&&(v.length?v=[...v,new b,...k]:v=k);return v}static{this.ID="vs.actions.separator"}async run(){}}e.$Ji=b;class ${get actions(){return this.a}constructor(m,v,k,l){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=m,this.label=v,this.class=l,this.a=k}async run(){}}e.$Ki=$;class y extends I{static{this.ID="vs.actions.empty"}constructor(){super(y.ID,g.localize(0,null),void 0,!1)}}e.$Li=y;function A(C){return{id:C.id,label:C.label,class:C.class,enabled:C.enabled??!0,checked:C.checked??!1,run:async(...m)=>C.run(...m),tooltip:C.label}}e.$Mi=A}),define(Se[181],ke([8,9]),function(me,e){return me.create("vs/base/common/date",e)}),define(Se[182],ke([1,0,181]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=e.$sm=void 0;const N=60,g=N*60,I=g*24,R=I*7,b=I*30,$=I*365;function y(C,m,v,k){typeof C!="number"&&(C=C.getTime());const l=Math.round((new Date().getTime()-C)/1e3);if(l<-30)return(0,D.localize)(0,null,y(new Date().getTime()+l*1e3,!1));if(!k&&l<30)return(0,D.localize)(1,null);let f;return l<N?(f=l,m?f===1?v?(0,D.localize)(2,null,f):(0,D.localize)(3,null,f):v?(0,D.localize)(4,null,f):(0,D.localize)(5,null,f):f===1?v?(0,D.localize)(6,null,f):(0,D.localize)(7,null,f):v?(0,D.localize)(8,null,f):(0,D.localize)(9,null,f)):l<g?(f=Math.floor(l/N),m?f===1?v?(0,D.localize)(10,null,f):(0,D.localize)(11,null,f):v?(0,D.localize)(12,null,f):(0,D.localize)(13,null,f):f===1?v?(0,D.localize)(14,null,f):(0,D.localize)(15,null,f):v?(0,D.localize)(16,null,f):(0,D.localize)(17,null,f)):l<I?(f=Math.floor(l/g),m?f===1?v?(0,D.localize)(18,null,f):(0,D.localize)(19,null,f):v?(0,D.localize)(20,null,f):(0,D.localize)(21,null,f):f===1?v?(0,D.localize)(22,null,f):(0,D.localize)(23,null,f):v?(0,D.localize)(24,null,f):(0,D.localize)(25,null,f)):l<R?(f=Math.floor(l/I),m?f===1?(0,D.localize)(26,null,f):(0,D.localize)(27,null,f):f===1?(0,D.localize)(28,null,f):(0,D.localize)(29,null,f)):l<b?(f=Math.floor(l/R),m?f===1?v?(0,D.localize)(30,null,f):(0,D.localize)(31,null,f):v?(0,D.localize)(32,null,f):(0,D.localize)(33,null,f):f===1?v?(0,D.localize)(34,null,f):(0,D.localize)(35,null,f):v?(0,D.localize)(36,null,f):(0,D.localize)(37,null,f)):l<$?(f=Math.floor(l/b),m?f===1?v?(0,D.localize)(38,null,f):(0,D.localize)(39,null,f):v?(0,D.localize)(40,null,f):(0,D.localize)(41,null,f):f===1?v?(0,D.localize)(42,null,f):(0,D.localize)(43,null,f):v?(0,D.localize)(44,null,f):(0,D.localize)(45,null,f)):(f=Math.floor(l/$),m?f===1?v?(0,D.localize)(46,null,f):(0,D.localize)(47,null,f):v?(0,D.localize)(48,null,f):(0,D.localize)(49,null,f):f===1?v?(0,D.localize)(50,null,f):(0,D.localize)(51,null,f):v?(0,D.localize)(52,null,f):(0,D.localize)(53,null,f))}e.$sm=y;function A(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$tm=A}),define(Se[183],ke([8,9]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(Se[44],ke([1,0,19,18,183]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.$Oi=e.$Ni=void 0;function I(C,m){return m&&(C.stack||C.stacktrace)?g.localize(0,null,b(C),R(C.stack)||R(C.stacktrace)):b(C)}function R(C){return Array.isArray(C)?C.join(`
`):C}function b(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?g.localize(1,null,C.message):C.message||g.localize(2,null)}function $(C=null,m=!1){if(!C)return g.localize(3,null);if(Array.isArray(C)){const v=D.$Hb(C),k=$(v[0],m);return v.length>1?g.localize(4,null,k,v.length):k}if(N.$Ff(C))return C;if(C.detail){const v=C.detail;if(v.error)return I(v.error,m);if(v.exception)return I(v.exception,m)}return C.stack?I(C,m):C.message?C.message:g.localize(5,null)}e.$Ni=$;function y(C){const m=C;return m instanceof Error&&Array.isArray(m.actions)}e.$Oi=y;function A(C,m){let v;return typeof C=="string"?v=new Error(C):v=C,v.actions=m,v}e.$Pi=A}),define(Se[184],ke([8,9]),function(me,e){return me.create("vs/base/common/platform",e)}),define(Se[10],ke([1,0,184]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let N=!1,g=!1,I=!1,R=!1,b=!1,$=!1,y=!1,A=!1,C=!1,m=!1,v,k=e.$g,l=e.$g,f,s;const i=globalThis;let n;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?n=i.vscode.process:typeof process<"u"&&(n=process);const o=typeof n?.versions?.electron=="string",c=o&&n?.type==="renderer";if(typeof n=="object"){N=n.platform==="win32",g=n.platform==="darwin",I=n.platform==="linux",R=I&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,y=o,C=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=e.$g,k=e.$g;const p=n.env.VSCODE_NLS_CONFIG;if(p)try{const E=JSON.parse(p),L=E.availableLanguages["*"];v=E.locale,l=E.osLocale,k=L||e.$g,f=E._translationsConfigFile}catch{}b=!0}else typeof navigator=="object"&&!c?(s=navigator.userAgent,N=s.indexOf("Windows")>=0,g=s.indexOf("Macintosh")>=0,A=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,I=s.indexOf("Linux")>=0,m=s?.indexOf("Mobi")>=0,$=!0,v=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,k=v,l=navigator.language):console.error("Unable to resolve platform.");var t;(function(p){p[p.Web=0]="Web",p[p.Mac=1]="Mac",p[p.Linux=2]="Linux",p[p.Windows=3]="Windows"})(t||(e.Platform=t={}));function r(p){switch(p){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=r;let d=0;g?d=1:N?d=3:I&&(d=2),e.$i=N,e.$j=g,e.$k=I,e.$l=R,e.$m=b,e.$n=y,e.$o=$,e.$p=$&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=A,e.$s=m,e.$t=C,e.$u=d,e.$v=s,e.$w=k;var u;(function(p){function E(){return e.$w}p.value=E;function L(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}p.isDefaultVariant=L;function T(){return e.$w==="en"}p.isDefault=T})(u||(e.Language=u={})),e.$x=v,e.$y=l,e.$z=f,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const p=[];i.addEventListener("message",L=>{if(L.data&&L.data.vscodeScheduleAsyncWork)for(let T=0,U=p.length;T<U;T++){const F=p[T];if(F.id===L.data.vscodeScheduleAsyncWork){p.splice(T,1),F.callback();return}}});let E=0;return L=>{const T=++E;p.push({id:T,callback:L}),i.postMessage({vscodeScheduleAsyncWork:T},"*")}}return p=>setTimeout(p)})();var a;(function(p){p[p.Windows=1]="Windows",p[p.Macintosh=2]="Macintosh",p[p.Linux=3]="Linux"})(a||(e.OperatingSystem=a={})),e.OS=g||A?2:N?1:3;let h=!0,S=!1;function P(){if(!S){S=!0;const p=new Uint8Array(2);p[0]=1,p[1]=2,h=new Uint16Array(p.buffer)[0]===(2<<8)+1}return h}e.$D=P,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function w(p){return parseFloat(p)>=20}e.$J=w}),define(Se[50],ke([1,0,10]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let N;const g=globalThis.vscode;if(typeof g<"u"&&typeof g.process<"u"){const I=g.process;N={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$dc=N.platform,e.$ec=N.arch}),define(Se[16],ke([1,0,50]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const N=65,g=97,I=90,R=122,b=46,$=47,y=92,A=58,C=63;class m extends Error{constructor(r,d,u){let a;typeof d=="string"&&d.indexOf("not ")===0?(a="must not be",d=d.replace(/^not /,"")):a="must be";const h=r.indexOf(".")!==-1?"property":"argument";let S=`The "${r}" ${h} ${a} of type ${d}`;S+=`. Received type ${typeof u}`,super(S),this.code="ERR_INVALID_ARG_TYPE"}}function v(t,r){if(t===null||typeof t!="object")throw new m(r,"Object",t)}function k(t,r){if(typeof t!="string")throw new m(r,"string",t)}const l=D.$dc==="win32";function f(t){return t===$||t===y}function s(t){return t===$}function i(t){return t>=N&&t<=I||t>=g&&t<=R}function n(t,r,d,u){let a="",h=0,S=-1,P=0,w=0;for(let p=0;p<=t.length;++p){if(p<t.length)w=t.charCodeAt(p);else{if(u(w))break;w=$}if(u(w)){if(!(S===p-1||P===1))if(P===2){if(a.length<2||h!==2||a.charCodeAt(a.length-1)!==b||a.charCodeAt(a.length-2)!==b){if(a.length>2){const E=a.lastIndexOf(d);E===-1?(a="",h=0):(a=a.slice(0,E),h=a.length-1-a.lastIndexOf(d)),S=p,P=0;continue}else if(a.length!==0){a="",h=0,S=p,P=0;continue}}r&&(a+=a.length>0?`${d}..`:"..",h=2)}else a.length>0?a+=`${d}${t.slice(S+1,p)}`:a=t.slice(S+1,p),h=p-S-1;S=p,P=0}else w===b&&P!==-1?++P:P=-1}return a}function o(t,r){v(r,"pathObject");const d=r.dir||r.root,u=r.base||`${r.name||""}${r.ext||""}`;return d?d===r.root?`${d}${u}`:`${d}${t}${u}`:u}e.$fc={resolve(...t){let r="",d="",u=!1;for(let a=t.length-1;a>=-1;a--){let h;if(a>=0){if(h=t[a],k(h,"path"),h.length===0)continue}else r.length===0?h=D.cwd():(h=D.env[`=${r}`]||D.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==r.toLowerCase()&&h.charCodeAt(2)===y)&&(h=`${r}\\`));const S=h.length;let P=0,w="",p=!1;const E=h.charCodeAt(0);if(S===1)f(E)&&(P=1,p=!0);else if(f(E))if(p=!0,f(h.charCodeAt(1))){let L=2,T=L;for(;L<S&&!f(h.charCodeAt(L));)L++;if(L<S&&L!==T){const U=h.slice(T,L);for(T=L;L<S&&f(h.charCodeAt(L));)L++;if(L<S&&L!==T){for(T=L;L<S&&!f(h.charCodeAt(L));)L++;(L===S||L!==T)&&(w=`\\\\${U}\\${h.slice(T,L)}`,P=L)}}}else P=1;else i(E)&&h.charCodeAt(1)===A&&(w=h.slice(0,2),P=2,S>2&&f(h.charCodeAt(2))&&(p=!0,P=3));if(w.length>0)if(r.length>0){if(w.toLowerCase()!==r.toLowerCase())continue}else r=w;if(u){if(r.length>0)break}else if(d=`${h.slice(P)}\\${d}`,u=p,p&&r.length>0)break}return d=n(d,!u,"\\",f),u?`${r}\\${d}`:`${r}${d}`||"."},normalize(t){k(t,"path");const r=t.length;if(r===0)return".";let d=0,u,a=!1;const h=t.charCodeAt(0);if(r===1)return s(h)?"\\":t;if(f(h))if(a=!0,f(t.charCodeAt(1))){let P=2,w=P;for(;P<r&&!f(t.charCodeAt(P));)P++;if(P<r&&P!==w){const p=t.slice(w,P);for(w=P;P<r&&f(t.charCodeAt(P));)P++;if(P<r&&P!==w){for(w=P;P<r&&!f(t.charCodeAt(P));)P++;if(P===r)return`\\\\${p}\\${t.slice(w)}\\`;P!==w&&(u=`\\\\${p}\\${t.slice(w,P)}`,d=P)}}}else d=1;else i(h)&&t.charCodeAt(1)===A&&(u=t.slice(0,2),d=2,r>2&&f(t.charCodeAt(2))&&(a=!0,d=3));let S=d<r?n(t.slice(d),!a,"\\",f):"";return S.length===0&&!a&&(S="."),S.length>0&&f(t.charCodeAt(r-1))&&(S+="\\"),u===void 0?a?`\\${S}`:S:a?`${u}\\${S}`:`${u}${S}`},isAbsolute(t){k(t,"path");const r=t.length;if(r===0)return!1;const d=t.charCodeAt(0);return f(d)||r>2&&i(d)&&t.charCodeAt(1)===A&&f(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,d;for(let h=0;h<t.length;++h){const S=t[h];k(S,"path"),S.length>0&&(r===void 0?r=d=S:r+=`\\${S}`)}if(r===void 0)return".";let u=!0,a=0;if(typeof d=="string"&&f(d.charCodeAt(0))){++a;const h=d.length;h>1&&f(d.charCodeAt(1))&&(++a,h>2&&(f(d.charCodeAt(2))?++a:u=!1))}if(u){for(;a<r.length&&f(r.charCodeAt(a));)a++;a>=2&&(r=`\\${r.slice(a)}`)}return e.$fc.normalize(r)},relative(t,r){if(k(t,"from"),k(r,"to"),t===r)return"";const d=e.$fc.resolve(t),u=e.$fc.resolve(r);if(d===u||(t=d.toLowerCase(),r=u.toLowerCase(),t===r))return"";let a=0;for(;a<t.length&&t.charCodeAt(a)===y;)a++;let h=t.length;for(;h-1>a&&t.charCodeAt(h-1)===y;)h--;const S=h-a;let P=0;for(;P<r.length&&r.charCodeAt(P)===y;)P++;let w=r.length;for(;w-1>P&&r.charCodeAt(w-1)===y;)w--;const p=w-P,E=S<p?S:p;let L=-1,T=0;for(;T<E;T++){const F=t.charCodeAt(a+T);if(F!==r.charCodeAt(P+T))break;F===y&&(L=T)}if(T!==E){if(L===-1)return u}else{if(p>E){if(r.charCodeAt(P+T)===y)return u.slice(P+T+1);if(T===2)return u.slice(P+T)}S>E&&(t.charCodeAt(a+T)===y?L=T:T===2&&(L=3)),L===-1&&(L=0)}let U="";for(T=a+L+1;T<=h;++T)(T===h||t.charCodeAt(T)===y)&&(U+=U.length===0?"..":"\\..");return P+=L,U.length>0?`${U}${u.slice(P,w)}`:(u.charCodeAt(P)===y&&++P,u.slice(P,w))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.$fc.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===y){if(r.charCodeAt(1)===y){const d=r.charCodeAt(2);if(d!==C&&d!==b)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(i(r.charCodeAt(0))&&r.charCodeAt(1)===A&&r.charCodeAt(2)===y)return`\\\\?\\${r}`;return t},dirname(t){k(t,"path");const r=t.length;if(r===0)return".";let d=-1,u=0;const a=t.charCodeAt(0);if(r===1)return f(a)?t:".";if(f(a)){if(d=u=1,f(t.charCodeAt(1))){let P=2,w=P;for(;P<r&&!f(t.charCodeAt(P));)P++;if(P<r&&P!==w){for(w=P;P<r&&f(t.charCodeAt(P));)P++;if(P<r&&P!==w){for(w=P;P<r&&!f(t.charCodeAt(P));)P++;if(P===r)return t;P!==w&&(d=u=P+1)}}}}else i(a)&&t.charCodeAt(1)===A&&(d=r>2&&f(t.charCodeAt(2))?3:2,u=d);let h=-1,S=!0;for(let P=r-1;P>=u;--P)if(f(t.charCodeAt(P))){if(!S){h=P;break}}else S=!1;if(h===-1){if(d===-1)return".";h=d}return t.slice(0,h)},basename(t,r){r!==void 0&&k(r,"ext"),k(t,"path");let d=0,u=-1,a=!0,h;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(d=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let S=r.length-1,P=-1;for(h=t.length-1;h>=d;--h){const w=t.charCodeAt(h);if(f(w)){if(!a){d=h+1;break}}else P===-1&&(a=!1,P=h+1),S>=0&&(w===r.charCodeAt(S)?--S===-1&&(u=h):(S=-1,u=P))}return d===u?u=P:u===-1&&(u=t.length),t.slice(d,u)}for(h=t.length-1;h>=d;--h)if(f(t.charCodeAt(h))){if(!a){d=h+1;break}}else u===-1&&(a=!1,u=h+1);return u===-1?"":t.slice(d,u)},extname(t){k(t,"path");let r=0,d=-1,u=0,a=-1,h=!0,S=0;t.length>=2&&t.charCodeAt(1)===A&&i(t.charCodeAt(0))&&(r=u=2);for(let P=t.length-1;P>=r;--P){const w=t.charCodeAt(P);if(f(w)){if(!h){u=P+1;break}continue}a===-1&&(h=!1,a=P+1),w===b?d===-1?d=P:S!==1&&(S=1):d!==-1&&(S=-1)}return d===-1||a===-1||S===0||S===1&&d===a-1&&d===u+1?"":t.slice(d,a)},format:o.bind(null,"\\"),parse(t){k(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const d=t.length;let u=0,a=t.charCodeAt(0);if(d===1)return f(a)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(f(a)){if(u=1,f(t.charCodeAt(1))){let L=2,T=L;for(;L<d&&!f(t.charCodeAt(L));)L++;if(L<d&&L!==T){for(T=L;L<d&&f(t.charCodeAt(L));)L++;if(L<d&&L!==T){for(T=L;L<d&&!f(t.charCodeAt(L));)L++;L===d?u=L:L!==T&&(u=L+1)}}}}else if(i(a)&&t.charCodeAt(1)===A){if(d<=2)return r.root=r.dir=t,r;if(u=2,f(t.charCodeAt(2))){if(d===3)return r.root=r.dir=t,r;u=3}}u>0&&(r.root=t.slice(0,u));let h=-1,S=u,P=-1,w=!0,p=t.length-1,E=0;for(;p>=u;--p){if(a=t.charCodeAt(p),f(a)){if(!w){S=p+1;break}continue}P===-1&&(w=!1,P=p+1),a===b?h===-1?h=p:E!==1&&(E=1):h!==-1&&(E=-1)}return P!==-1&&(h===-1||E===0||E===1&&h===P-1&&h===S+1?r.base=r.name=t.slice(S,P):(r.name=t.slice(S,h),r.base=t.slice(S,P),r.ext=t.slice(h,P))),S>0&&S!==u?r.dir=t.slice(0,S-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(l){const t=/\\/g;return()=>{const r=D.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>D.cwd()})();e.$gc={resolve(...t){let r="",d=!1;for(let u=t.length-1;u>=-1&&!d;u--){const a=u>=0?t[u]:c();k(a,"path"),a.length!==0&&(r=`${a}/${r}`,d=a.charCodeAt(0)===$)}return r=n(r,!d,"/",s),d?`/${r}`:r.length>0?r:"."},normalize(t){if(k(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===$,d=t.charCodeAt(t.length-1)===$;return t=n(t,!r,"/",s),t.length===0?r?"/":d?"./":".":(d&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return k(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let r;for(let d=0;d<t.length;++d){const u=t[d];k(u,"path"),u.length>0&&(r===void 0?r=u:r+=`/${u}`)}return r===void 0?".":e.$gc.normalize(r)},relative(t,r){if(k(t,"from"),k(r,"to"),t===r||(t=e.$gc.resolve(t),r=e.$gc.resolve(r),t===r))return"";const d=1,u=t.length,a=u-d,h=1,S=r.length-h,P=a<S?a:S;let w=-1,p=0;for(;p<P;p++){const L=t.charCodeAt(d+p);if(L!==r.charCodeAt(h+p))break;L===$&&(w=p)}if(p===P)if(S>P){if(r.charCodeAt(h+p)===$)return r.slice(h+p+1);if(p===0)return r.slice(h+p)}else a>P&&(t.charCodeAt(d+p)===$?w=p:p===0&&(w=0));let E="";for(p=d+w+1;p<=u;++p)(p===u||t.charCodeAt(p)===$)&&(E+=E.length===0?"..":"/..");return`${E}${r.slice(h+w)}`},toNamespacedPath(t){return t},dirname(t){if(k(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===$;let d=-1,u=!0;for(let a=t.length-1;a>=1;--a)if(t.charCodeAt(a)===$){if(!u){d=a;break}}else u=!1;return d===-1?r?"/":".":r&&d===1?"//":t.slice(0,d)},basename(t,r){r!==void 0&&k(r,"ext"),k(t,"path");let d=0,u=-1,a=!0,h;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let S=r.length-1,P=-1;for(h=t.length-1;h>=0;--h){const w=t.charCodeAt(h);if(w===$){if(!a){d=h+1;break}}else P===-1&&(a=!1,P=h+1),S>=0&&(w===r.charCodeAt(S)?--S===-1&&(u=h):(S=-1,u=P))}return d===u?u=P:u===-1&&(u=t.length),t.slice(d,u)}for(h=t.length-1;h>=0;--h)if(t.charCodeAt(h)===$){if(!a){d=h+1;break}}else u===-1&&(a=!1,u=h+1);return u===-1?"":t.slice(d,u)},extname(t){k(t,"path");let r=-1,d=0,u=-1,a=!0,h=0;for(let S=t.length-1;S>=0;--S){const P=t.charCodeAt(S);if(P===$){if(!a){d=S+1;break}continue}u===-1&&(a=!1,u=S+1),P===b?r===-1?r=S:h!==1&&(h=1):r!==-1&&(h=-1)}return r===-1||u===-1||h===0||h===1&&r===u-1&&r===d+1?"":t.slice(r,u)},format:o.bind(null,"/"),parse(t){k(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const d=t.charCodeAt(0)===$;let u;d?(r.root="/",u=1):u=0;let a=-1,h=0,S=-1,P=!0,w=t.length-1,p=0;for(;w>=u;--w){const E=t.charCodeAt(w);if(E===$){if(!P){h=w+1;break}continue}S===-1&&(P=!1,S=w+1),E===b?a===-1?a=w:p!==1&&(p=1):a!==-1&&(p=-1)}if(S!==-1){const E=h===0&&d?1:h;a===-1||p===0||p===1&&a===S-1&&a===h+1?r.base=r.name=t.slice(E,S):(r.name=t.slice(E,a),r.base=t.slice(E,S),r.ext=t.slice(a,S))}return h>0?r.dir=t.slice(0,h-1):d&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=l?e.$fc.normalize:e.$gc.normalize,e.$ic=l?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=l?e.$fc.join:e.$gc.join,e.$kc=l?e.$fc.resolve:e.$gc.resolve,e.$lc=l?e.$fc.relative:e.$gc.relative,e.$mc=l?e.$fc.dirname:e.$gc.dirname,e.$nc=l?e.$fc.basename:e.$gc.basename,e.$oc=l?e.$fc.extname:e.$gc.extname,e.$pc=l?e.$fc.format:e.$gc.format,e.$qc=l?e.$fc.parse:e.$gc.parse,e.$rc=l?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=l?e.$fc.sep:e.$gc.sep,e.$tc=l?e.$fc.delimiter:e.$gc.delimiter}),define(Se[128],ke([1,0,43,16]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=e.$Hq=e.$Gq=e.$Fq=e.$Eq=e.$Dq=e.$Cq=e.$Bq=e.$Aq=e.$zq=e.$yq=e.$xq=e.$wq=void 0;const g=new D.$V(()=>{const P=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:P,collatorIsNumeric:P.resolvedOptions().numeric}}),I=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(P,w,p=!1){const E=P||"",L=w||"",T=g.value.collator.compare(E,L);return g.value.collatorIsNumeric&&T===0&&E!==L?E<L?-1:1:T}e.$wq=b;function $(P,w){const p=I.value.collator;return P=P||"",w=w||"",o(p,P,w)}e.$xq=$;function y(P,w){const p=I.value.collator;return P=P||"",w=w||"",d(P,w)||o(p,P,w)}e.$yq=y;function A(P,w){const p=I.value.collator;return P=P||"",w=w||"",r(P,w)||o(p,P,w)}e.$zq=A;function C(P,w){return P=P||"",w=w||"",P===w?0:P<w?-1:1}e.$Aq=C;function m(P,w){const[p,E]=i(P),[L,T]=i(w);let U=g.value.collator.compare(E,T);if(U===0){if(g.value.collatorIsNumeric&&E!==T)return E<T?-1:1;if(U=g.value.collator.compare(p,L),g.value.collatorIsNumeric&&U===0&&p!==L)return p<L?-1:1}return U}e.$Bq=m;function v(P,w){P=P||"",w=w||"";const p=n(P),E=n(w),L=I.value.collator,T=R.value.collator;return o(T,p,E)||o(L,P,w)}e.$Cq=v;function k(P,w){P=P||"",w=w||"";const p=n(P),E=n(w),L=I.value.collator,T=R.value.collator;return o(T,p,E)||d(P,w)||o(L,P,w)}e.$Dq=k;function l(P,w){P=P||"",w=w||"";const p=n(P),E=n(w),L=I.value.collator,T=R.value.collator;return o(T,p,E)||r(P,w)||o(L,P,w)}e.$Eq=l;function f(P,w){P=P||"",w=w||"";const p=n(P).toLowerCase(),E=n(w).toLowerCase();return p!==E?p<E?-1:1:P!==w?P<w?-1:1:0}e.$Fq=f;const s=/^(.*?)(\.([^.]*))?$/;function i(P,w=!1){const p=P?s.exec(P):[];let E=[p&&p[1]||"",p&&p[3]||""];return w&&(!E[0]&&E[1]||E[0]&&E[0].charAt(0)===".")&&(E=[E[0]+"."+E[1],""]),E}function n(P){const w=P?s.exec(P):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function o(P,w,p){const E=P.compare(w,p);return E!==0?E:w.length!==p.length?w.length<p.length?-1:1:0}function c(P){const w=P.charAt(0);return w.toLocaleUpperCase()!==w}function t(P){const w=P.charAt(0);return w.toLocaleLowerCase()!==w}function r(P,w){return c(P)&&t(w)?-1:t(P)&&c(w)?1:0}function d(P,w){return t(P)&&c(w)?-1:c(P)&&t(w)?1:0}function u(P,w,p=!1){return p||(P=P&&P.toLowerCase(),w=w&&w.toLowerCase()),P===w?0:P<w?-1:1}function a(P,w,p=!1){const E=P.split(N.sep),L=w.split(N.sep),T=E.length-1,U=L.length-1;let F,j;for(let O=0;;O++){if(F=T===O,j=U===O,F&&j)return b(E[O],L[O],p);if(F)return-1;if(j)return 1;const M=u(E[O],L[O],p);if(M!==0)return M}}e.$Gq=a;function h(P,w,p){const E=P.toLowerCase(),L=w.toLowerCase(),T=S(P,w,p);if(T)return T;const U=E.endsWith(p),F=L.endsWith(p);if(U!==F)return U?-1:1;const j=b(E,L);return j!==0?j:E.localeCompare(L)}e.$Hq=h;function S(P,w,p){const E=P.toLowerCase(),L=w.toLowerCase(),T=E.startsWith(p),U=L.startsWith(p);if(T!==U)return T?-1:1;if(T&&U){if(E.length<L.length)return-1;if(E.length>L.length)return 1}return 0}e.$Iq=S}),define(Se[33],ke([1,0,16,10,12,18]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=void 0;function R(h){return h===47||h===92}e.$Xf=R;function b(h){return h.replace(/[\\/]/g,D.$gc.sep)}e.$Yf=b;function $(h){return h.indexOf("/")===-1&&(h=b(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.$Zf=$;function y(h,S=D.$gc.sep){if(!h)return"";const P=h.length,w=h.charCodeAt(0);if(R(w)){if(R(h.charCodeAt(1))&&!R(h.charCodeAt(2))){let E=3;const L=E;for(;E<P&&!R(h.charCodeAt(E));E++);if(L!==E&&!R(h.charCodeAt(E+1))){for(E+=1;E<P;E++)if(R(h.charCodeAt(E)))return h.slice(0,E+1).replace(/[\\/]/g,S)}}return S}else if(s(w)&&h.charCodeAt(1)===58)return R(h.charCodeAt(2))?h.slice(0,2)+S:h.slice(0,2);let p=h.indexOf("://");if(p!==-1){for(p+=3;p<P;p++)if(R(h.charCodeAt(p)))return h.slice(0,p+1)}return""}e.$1f=y;function A(h){if(!N.$i||!h||h.length<5)return!1;let S=h.charCodeAt(0);if(S!==92||(S=h.charCodeAt(1),S!==92))return!1;let P=2;const w=P;for(;P<h.length&&(S=h.charCodeAt(P),S!==92);P++);return!(w===P||(S=h.charCodeAt(P+1),isNaN(S)||S===92))}e.$2f=A;const C=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function k(h,S=N.$i){const P=S?C:m;return!(!h||h.length===0||/^\s+$/.test(h)||(P.lastIndex=0,P.test(h))||S&&v.test(h)||h==="."||h===".."||S&&h[h.length-1]==="."||S&&h.length!==h.trim().length||h.length>255)}e.$3f=k;function l(h,S,P){const w=h===S;return!P||w?w:!h||!S?!1:(0,g.$9e)(h,S)}e.$4f=l;function f(h,S,P,w=D.sep){if(h===S)return!0;if(!h||!S||S.length>h.length)return!1;if(P){if(!(0,g.$0e)(h,S))return!1;if(S.length===h.length)return!0;let E=S.length;return S.charAt(S.length-1)===w&&E--,h.charAt(E)===w}return S.charAt(S.length-1)!==w&&(S+=w),h.indexOf(S)===0}e.$5f=f;function s(h){return h>=65&&h<=90||h>=97&&h<=122}e.$6f=s;function i(h,S){return N.$i&&h.endsWith(":")&&(h+=D.sep),(0,D.$ic)(h)||(h=(0,D.$jc)(S,h)),h=(0,D.$hc)(h),N.$i?(h=(0,g.$Re)(h,D.sep),h.endsWith(":")&&(h+=D.sep)):(h=(0,g.$Re)(h,D.sep),h||(h=D.sep)),h}e.$7f=i;function n(h){const S=(0,D.$hc)(h);return N.$i?h.length>3?!1:o(S)&&(h.length===2||S.charCodeAt(2)===92):S===D.$gc.sep}e.$8f=n;function o(h,S=N.$i){return S?s(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.$9f=o;function c(h,S=N.$i){return o(h,S)?h[0]:void 0}e.$0f=c;function t(h,S,P){return S.length>h.length?-1:h===S?0:(P&&(h=h.toLowerCase(),S=S.toLowerCase()),h.indexOf(S))}e.$$f=t;function r(h){const S=h.split(":");let P,w,p;for(const E of S){const L=Number(E);(0,I.$Jf)(L)?w===void 0?w=L:p===void 0&&(p=L):P=P?[P,E].join(":"):E}if(!P)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:P,line:w!==void 0?w:void 0,column:p!==void 0?p:w!==void 0?1:void 0}}e.$_f=r;const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",u="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(h,S,P=8){let w="";for(let E=0;E<P;E++){let L;E===0&&N.$i&&!S&&(P===3||P===4)?L=u:L=d,w+=L.charAt(Math.floor(Math.random()*L.length))}let p;return S?p=`${S}-${w}`:p=w,h?(0,D.$jc)(h,p):p}e.$ag=a}),define(Se[129],ke([1,0,128,123,54,16,10,12]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=e.$Nq=e.$Mq=e.$Lq=e.$Kq=e.$Jq=void 0;const $=0,y=[$,[]];function A(W,Y,ue,X){if(!W||!Y)return y;const J=W.length,x=Y.length;if(J<x)return y;const he=W.toLowerCase();return C(Y,ue,x,W,he,J,X)}e.$Jq=A;function C(W,Y,ue,X,J,x,he){const Z=[],we=[];for(let re=0;re<ue;re++){const ye=re*x,de=ye-x,ge=re>0,_=W[re],ie=Y[re];for(let G=0;G<x;G++){const te=G>0,fe=ye+G,ve=fe-1,Pe=de+G-1,be=te?Z[ve]:0,De=ge&&te?Z[Pe]:0,z=ge&&te?we[Pe]:0;let Q;!De&&ge?Q=0:Q=m(_,ie,X,J,G,z),Q&&De+Q>=be&&(he||ge||J.startsWith(Y,G))?(we[fe]=z+1,Z[fe]=De+Q):(we[fe]=$,Z[fe]=be)}}const ce=[];let K=ue-1,B=x-1;for(;K>=0&&B>=0;){const re=K*x+B;we[re]===$||(ce.push(B),K--),B--}return[Z[ue*x-1],ce.reverse()]}function m(W,Y,ue,X,J,x){let he=0;if(!v(Y,X[J]))return he;if(he+=1,x>0&&(he+=x*5),W===ue[J]&&(he+=1),J===0)he+=8;else{const Z=k(ue.charCodeAt(J-1));Z?he+=Z:(0,N.$Uj)(ue.charCodeAt(J))&&x===0&&(he+=2)}return he}function v(W,Y){return W===Y?!0:W==="/"||W==="\\"?Y==="/"||Y==="\\":!1}function k(W){switch(W){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const l=[void 0,[]];function f(W,Y,ue=0,X=0){const J=Y;return J.values&&J.values.length>1?s(W,J.values,ue,X):i(W,Y,ue,X)}e.$Kq=f;function s(W,Y,ue,X){let J=0;const x=[];for(const he of Y){const[Z,we]=i(W,he,ue,X);if(typeof Z!="number")return l;J+=Z,x.push(...we)}return[J,P(x)]}function i(W,Y,ue,X){const J=(0,N.$4j)(Y.original,Y.originalLowercase,ue,W,W.toLowerCase(),X,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return J?[J[0],(0,N.$1j)(J)]:l}const n=Object.freeze({score:0}),o=1<<18,c=1<<17,t=1<<16;function r(W,Y,ue,X){const J=X.values?X.values:[X];return(0,g.$Qi)({[X.normalized]:{values:J.map(he=>({value:he.normalized,expectContiguousMatch:he.expectContiguousMatch})),label:W,description:Y,allowNonContiguousMatches:ue}})}function d(W,Y,ue,X,J){if(!W||!Y.normalized)return n;const x=X.getItemLabel(W);if(!x)return n;const he=X.getItemDescription(W),Z=r(x,he,ue,Y),we=J[Z];if(we)return we;const ce=u(x,he,X.getItemPath(W),Y,ue);return J[Z]=ce,ce}e.$Lq=d;function u(W,Y,ue,X,J){const x=!ue||!X.containsPathSeparator;return ue&&(R.$k?X.pathNormalized===ue:(0,b.$9e)(X.pathNormalized,ue))?{score:o,labelMatch:[{start:0,end:W.length}],descriptionMatch:Y?[{start:0,end:Y.length}]:void 0}:X.values&&X.values.length>1?a(W,Y,ue,X.values,x,J):h(W,Y,ue,X,x,J)}function a(W,Y,ue,X,J,x){let he=0;const Z=[],we=[];for(const ce of X){const{score:K,labelMatch:B,descriptionMatch:re}=h(W,Y,ue,ce,J,x);if(K===$)return n;he+=K,B&&Z.push(...B),re&&we.push(...re)}return{score:he,labelMatch:P(Z),descriptionMatch:P(we)}}function h(W,Y,ue,X,J,x){if(J||!Y){const[he,Z]=A(W,X.normalized,X.normalizedLowercase,x&&!X.expectContiguousMatch);if(he){const we=(0,N.$Rj)(X.normalized,W);let ce;if(we){ce=c;const K=Math.round(X.normalized.length/W.length*100);ce+=K}else ce=t;return{score:ce+he,labelMatch:we||S(Z)}}}if(Y){let he=Y;ue&&(he=`${Y}${I.sep}`);const Z=he.length,we=`${he}${W}`,[ce,K]=A(we,X.normalized,X.normalizedLowercase,x&&!X.expectContiguousMatch);if(ce){const B=S(K),re=[],ye=[];return B.forEach(de=>{de.start<Z&&de.end>Z?(re.push({start:0,end:de.end-Z}),ye.push({start:de.start,end:Z})):de.start>=Z?re.push({start:de.start-Z,end:de.end-Z}):ye.push(de)}),{score:ce,labelMatch:re,descriptionMatch:ye}}}return n}function S(W){const Y=[];if(!W)return Y;let ue;for(const X of W)ue&&ue.end===X?ue.end+=1:(ue={start:X,end:X+1},Y.push(ue));return Y}function P(W){const Y=W.sort((J,x)=>J.start-x.start),ue=[];let X;for(const J of Y)!X||!w(X,J)?(X=J,ue.push(J)):(X.start=Math.min(X.start,J.start),X.end=Math.max(X.end,J.end));return ue}function w(W,Y){return!(W.end<Y.start||Y.end<W.start)}function p(W,Y,ue,X,J,x){const he=d(W,ue,X,J,x),Z=d(Y,ue,X,J,x),we=he.score,ce=Z.score;if((we===o||ce===o)&&we!==ce)return we===o?-1:1;if(we>t||ce>t){if(we!==ce)return we>ce?-1:1;if(we<c&&ce<c){const _=L(he.labelMatch,Z.labelMatch);if(_!==0)return _}const de=J.getItemLabel(W)||"",ge=J.getItemLabel(Y)||"";if(de.length!==ge.length)return de.length-ge.length}if(we!==ce)return we>ce?-1:1;const K=Array.isArray(he.labelMatch)&&he.labelMatch.length>0,B=Array.isArray(Z.labelMatch)&&Z.labelMatch.length>0;if(K&&!B)return-1;if(B&&!K)return 1;const re=E(W,he,J),ye=E(Y,Z,J);return re&&ye&&re!==ye?ye>re?-1:1:T(W,Y,ue,J)}e.$Mq=p;function E(W,Y,ue){let X=-1,J=-1;if(Y.descriptionMatch&&Y.descriptionMatch.length?X=Y.descriptionMatch[0].start:Y.labelMatch&&Y.labelMatch.length&&(X=Y.labelMatch[0].start),Y.labelMatch&&Y.labelMatch.length){if(J=Y.labelMatch[Y.labelMatch.length-1].end,Y.descriptionMatch&&Y.descriptionMatch.length){const x=ue.getItemDescription(W);x&&(J+=x.length)}}else Y.descriptionMatch&&Y.descriptionMatch.length&&(J=Y.descriptionMatch[Y.descriptionMatch.length-1].end);return J-X}function L(W,Y){if(!W&&!Y||(!W||!W.length)&&(!Y||!Y.length))return 0;if(!Y||!Y.length)return-1;if(!W||!W.length)return 1;const ue=W[0].start,J=W[W.length-1].end-ue,x=Y[0].start,Z=Y[Y.length-1].end-x;return J===Z?0:Z<J?1:-1}function T(W,Y,ue,X){const J=X.getItemLabel(W)||"",x=X.getItemLabel(Y)||"",he=X.getItemDescription(W),Z=X.getItemDescription(Y),we=J.length+(he?he.length:0),ce=x.length+(Z?Z.length:0);if(we!==ce)return we-ce;const K=X.getItemPath(W),B=X.getItemPath(Y);return K&&B&&K.length!==B.length?K.length-B.length:J!==x?(0,D.$Hq)(J,x,ue.normalized):he&&Z&&he!==Z?(0,D.$Hq)(he,Z,ue.normalized):K&&B&&K!==B?(0,D.$Hq)(K,B,ue.normalized):0}function U(W){return W.startsWith('"')&&W.endsWith('"')}const F=" ";function j(W){typeof W!="string"&&(W="");const Y=W.toLowerCase(),{pathNormalized:ue,normalized:X,normalizedLowercase:J}=O(W),x=ue.indexOf(I.sep)>=0,he=U(W);let Z;const we=W.split(F);if(we.length>1)for(const ce of we){const K=U(ce),{pathNormalized:B,normalized:re,normalizedLowercase:ye}=O(ce);re&&(Z||(Z=[]),Z.push({original:ce,originalLowercase:ce.toLowerCase(),pathNormalized:B,normalized:re,normalizedLowercase:ye,expectContiguousMatch:K}))}return{original:W,originalLowercase:Y,pathNormalized:ue,normalized:X,normalizedLowercase:J,values:Z,containsPathSeparator:x,expectContiguousMatch:he}}e.$Nq=j;function O(W){let Y;R.$i?Y=W.replace(/\//g,I.sep):Y=W.replace(/\\/g,I.sep);const ue=(0,b.$Te)(Y).replace(/\s|"/g,"");return{pathNormalized:Y,normalized:ue,normalizedLowercase:ue.toLowerCase()}}function M(W){return Array.isArray(W)?j(W.map(Y=>Y.original).join(F)):j(W.original)}e.$Oq=M}),define(Se[100],ke([1,0,16]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=e.$8r=e.$7r=e.$6r=e.$5r=void 0,e.$5r=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},g={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function I(A){const C=(0,D.$oc)(A),m=N[C.toLowerCase()];return m!==void 0?m:R(A)}e.$6r=I;function R(A){const C=(0,D.$oc)(A);return g[C.toLowerCase()]}e.$7r=R;function b(A){for(const C in g)if(g[C]===A)return C}e.$8r=b;const $=/^(.+)\/(.+?)(;.+)?$/;function y(A,C){const m=$.exec(A);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:C?void 0:A}e.$9r=y}),define(Se[101],ke([1,0,10]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.TerminateResponseCode=e.Source=void 0;var N;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(N||(e.Source=N={}));var g;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(g||(e.TerminateResponseCode=g={}));function I(b,...$){const y=$.reduce((m,v)=>(m[v]=!0,m),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(m=>!y[m]).forEach(m=>{for(let v=0;v<A.length;v++)if(m.search(A[v])!==-1){delete b[m];break}})}e.$Ol=I;function R(b){b&&(delete b.DEBUG,D.$j&&delete b.DYLD_LIBRARY_PATH,D.$k&&delete b.LD_PRELOAD)}e.$Pl=R}),define(Se[2],ke([1,0,16,10]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const g=/^\w[\w\d+.-]*$/,I=/^\//,R=/^\/\//;function b(u,a){if(!u.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${u.authority}", path: "${u.path}", query: "${u.query}", fragment: "${u.fragment}"}`);if(u.scheme&&!g.test(u.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(u.path){if(u.authority){if(!I.test(u.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(u.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(u,a){return!u&&!a?"file":u}function y(u,a){switch(u){case"https":case"http":case"file":a?a[0]!==C&&(a=C+a):a=C;break}return a}const A="",C="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{static isUri(a){return a instanceof v?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,h,S,P,w,p=!1){typeof a=="object"?(this.scheme=a.scheme||A,this.authority=a.authority||A,this.path=a.path||A,this.query=a.query||A,this.fragment=a.fragment||A):(this.scheme=$(a,p),this.authority=h||A,this.path=y(this.scheme,S||A),this.query=P||A,this.fragment=w||A,b(this,p))}get fsPath(){return o(this,!1)}with(a){if(!a)return this;let{scheme:h,authority:S,path:P,query:w,fragment:p}=a;return h===void 0?h=this.scheme:h===null&&(h=A),S===void 0?S=this.authority:S===null&&(S=A),P===void 0?P=this.path:P===null&&(P=A),w===void 0?w=this.query:w===null&&(w=A),p===void 0?p=this.fragment:p===null&&(p=A),h===this.scheme&&S===this.authority&&P===this.path&&w===this.query&&p===this.fragment?this:new f(h,S,P,w,p)}static parse(a,h=!1){const S=m.exec(a);return S?new f(S[2]||A,d(S[4]||A),d(S[5]||A),d(S[7]||A),d(S[9]||A),h):new f(A,A,A,A,A)}static file(a){let h=A;if(N.$i&&(a=a.replace(/\\/g,C)),a[0]===C&&a[1]===C){const S=a.indexOf(C,2);S===-1?(h=a.substring(2),a=C):(h=a.substring(2,S),a=a.substring(S)||C)}return new f("file",h,a,A,A)}static from(a,h){return new f(a.scheme,a.authority,a.path,a.query,a.fragment,h)}static joinPath(a,...h){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let S;return N.$i&&a.scheme==="file"?S=v.file(D.$fc.join(o(a,!0),...h)).path:S=D.$gc.join(a.path,...h),a.with({path:S})}toString(a=!1){return c(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof v)return a;{const h=new f(a);return h._formatted=a.external??null,h._fsPath=a._sep===l?a.fsPath??null:null,h}}else return a}}e.URI=v;function k(u){return!u||typeof u!="object"?!1:typeof u.scheme=="string"&&(typeof u.authority=="string"||typeof u.authority>"u")&&(typeof u.path=="string"||typeof u.path>"u")&&(typeof u.query=="string"||typeof u.query>"u")&&(typeof u.fragment=="string"||typeof u.fragment>"u")}e.$vc=k;const l=N.$i?1:void 0;class f extends v{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(a=!1){return a?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=l),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const s={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function i(u,a,h){let S,P=-1;for(let w=0;w<u.length;w++){const p=u.charCodeAt(w);if(p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57||p===45||p===46||p===95||p===126||a&&p===47||h&&p===91||h&&p===93||h&&p===58)P!==-1&&(S+=encodeURIComponent(u.substring(P,w)),P=-1),S!==void 0&&(S+=u.charAt(w));else{S===void 0&&(S=u.substr(0,w));const E=s[p];E!==void 0?(P!==-1&&(S+=encodeURIComponent(u.substring(P,w)),P=-1),S+=E):P===-1&&(P=w)}}return P!==-1&&(S+=encodeURIComponent(u.substring(P))),S!==void 0?S:u}function n(u){let a;for(let h=0;h<u.length;h++){const S=u.charCodeAt(h);S===35||S===63?(a===void 0&&(a=u.substr(0,h)),a+=s[S]):a!==void 0&&(a+=u[h])}return a!==void 0?a:u}function o(u,a){let h;return u.authority&&u.path.length>1&&u.scheme==="file"?h=`//${u.authority}${u.path}`:u.path.charCodeAt(0)===47&&(u.path.charCodeAt(1)>=65&&u.path.charCodeAt(1)<=90||u.path.charCodeAt(1)>=97&&u.path.charCodeAt(1)<=122)&&u.path.charCodeAt(2)===58?a?h=u.path.substr(1):h=u.path[1].toLowerCase()+u.path.substr(2):h=u.path,N.$i&&(h=h.replace(/\//g,"\\")),h}e.$wc=o;function c(u,a){const h=a?n:i;let S="",{scheme:P,authority:w,path:p,query:E,fragment:L}=u;if(P&&(S+=P,S+=":"),(w||P==="file")&&(S+=C,S+=C),w){let T=w.indexOf("@");if(T!==-1){const U=w.substr(0,T);w=w.substr(T+1),T=U.lastIndexOf(":"),T===-1?S+=h(U,!1,!1):(S+=h(U.substr(0,T),!1,!1),S+=":",S+=h(U.substr(T+1),!1,!0)),S+="@"}w=w.toLowerCase(),T=w.lastIndexOf(":"),T===-1?S+=h(w,!1,!0):(S+=h(w.substr(0,T),!1,!0),S+=w.substr(T))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const T=p.charCodeAt(1);T>=65&&T<=90&&(p=`/${String.fromCharCode(T+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const T=p.charCodeAt(0);T>=65&&T<=90&&(p=`${String.fromCharCode(T+32)}:${p.substr(2)}`)}S+=h(p,!0,!1)}return E&&(S+="?",S+=h(E,!1,!1)),L&&(S+="#",S+=a?L:i(L,!1,!1)),S}function t(u){try{return decodeURIComponent(u)}catch{return u.length>3?u.substr(0,3)+t(u.substr(3)):u}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(u){return u.match(r)?u.replace(r,a=>t(a)):u}}),define(Se[185],ke([1,0,2]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$cq=e.$bq=e.$aq=void 0;function N(y){const A=y;return A&&typeof A.type=="string"&&typeof A.severity=="string"}e.$aq=N;function g(y){const A=[];let C;try{const m=JSON.parse(y.arguments),v=m[m.length-1];v&&v.__$stack&&(m.pop(),C=v.__$stack),A.push(...m)}catch{A.push("Unable to log remote console arguments",y.arguments)}return{args:A,stack:C}}e.$bq=g;function I(y){if(typeof y!="string")return I(g(y).stack);const A=y;if(A){const C=R(A),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(m&&m.length===4)return{uri:D.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.$cq=I;function R(y){if(!y)return y;const A=y.indexOf(`
`);return A===-1?y:y.substring(0,A)}function b(y,A){const{args:C,stack:m}=g(y),v=typeof C[0]=="string"&&C.length===1;let k=R(m);k&&(k=`(${k.trim()})`);let l=[];if(typeof C[0]=="string"?k&&v?l=[`%c[${A}] %c${C[0]} %c${k}`,$("blue"),$(""),$("grey")]:l=[`%c[${A}] %c${C[0]}`,$("blue"),$(""),...C.slice(1)]:l=[`%c[${A}]%`,$("blue"),...C],k&&!v&&l.push(k),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,l)}e.log=b;function $(y){return`color: ${y}`}}),define(Se[55],ke([1,0,22,2]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.$yh=e.$xh=void 0;function g($){return JSON.stringify($,R)}e.$xh=g;function I($){let y=JSON.parse($);return y=b(y),y}e.$yh=I;function R($,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:y.flags}:y}function b($,y=0){if(!$||y>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return N.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof D.$ge||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let A=0;A<$.length;++A)$[A]=b($[A],y+1);else for(const A in $)Object.hasOwnProperty.call($,A)&&($[A]=b($[A],y+1))}return $}e.$zh=b}),define(Se[17],ke([1,0,14,10,12,2]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.Schemas=void 0;var R;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={}));function b(m,v){return I.URI.isUri(m)?(0,g.$9e)(m.scheme,v):(0,g.$0e)(m,v+":")}e.$bg=b;function $(m,...v){return v.some(k=>b(m,k))}e.$cg=$,e.$dg="vscode-tkn",e.$eg="tkn";class y{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(v){this.d=v}setDelegate(v){this.e=v}setServerRootPath(v){this.f=`${v}/${R.vscodeRemoteResource}`}set(v,k,l){this.a[v]=k,this.b[v]=l}setConnectionToken(v,k){this.c[v]=k}getPreferredWebSchema(){return this.d}rewrite(v){if(this.e)try{return this.e(v)}catch(n){return D.$1(n),v}const k=v.authority;let l=this.a[k];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const f=this.b[k],s=this.c[k];let i=`path=${encodeURIComponent(v.path)}`;return typeof s=="string"&&(i+=`&${e.$eg}=${encodeURIComponent(s)}`),I.URI.from({scheme:N.$o?this.d:R.vscodeRemoteResource,authority:`${l}:${f}`,path:this.f,query:i})}}e.$fg=new y,e.$gg="vs/../../extensions",e.$hg="vs/../../node_modules",e.$ig="vs/../../node_modules.asar",e.$jg="vs/../../node_modules.asar.unpacked",e.$kg="vscode-app";class A{static{this.a=e.$kg}asBrowserUri(v){const k=this.b(v,me);return this.uriToBrowserUri(k)}uriToBrowserUri(v){return v.scheme===R.vscodeRemote?e.$fg.rewrite(v):v.scheme===R.file&&(N.$m||N.$q===`${R.vscodeFileResource}://${A.a}`)?v.with({scheme:R.vscodeFileResource,authority:v.authority||A.a,query:null,fragment:null}):v}asFileUri(v){const k=this.b(v,me);return this.uriToFileUri(k)}uriToFileUri(v){return v.scheme===R.vscodeFileResource?v.with({scheme:R.file,authority:v.authority!==A.a?v.authority:null,query:null,fragment:null}):v}b(v,k){return I.URI.isUri(v)?v:I.URI.parse(k.toUrl(v))}}e.$lg=new A;var C;(function(m){const v=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(v.get("3"));const k="vscode-coi";function l(s){let i;typeof s=="string"?i=new URL(s).searchParams:s instanceof URL?i=s.searchParams:I.URI.isUri(s)&&(i=new URL(s.toString(!0)).searchParams);const n=i?.get(k);if(n)return v.get(n)}m.getHeadersFromQuery=l;function f(s,i,n){if(!globalThis.crossOriginIsolated)return;const o=i&&n?"3":n?"2":"1";s instanceof URLSearchParams?s.set(k,o):s[k]=o}m.addSearchParam=f})(C||(e.COI=C={}))}),define(Se[186],ke([1,0,157,17,10,2]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4C=void 0;class R{constructor(m,v,k){this.id=m,this.dependencies=v,this.callback=k}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,v,k)=>{typeof m!="string"&&(k=v,v=m,m=null),(typeof v!="object"||!Array.isArray(v))&&(k=v,v=null),this.c.push(new R(m,v,k))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const v=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!v)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(v.dependencies)&&v.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${v.dependencies.join(", ")}`);return typeof v.callback=="function"?v.callback([]):v.callback}h(m){return new Promise((v,k)=>{const l=document.createElement("script");l.setAttribute("async","async"),l.setAttribute("type","text/javascript");const f=()=>{l.removeEventListener("load",s),l.removeEventListener("error",i)},s=n=>{f(),v(this.c.pop())},i=n=>{f(),k(n)};l.addEventListener("load",s),l.addEventListener("error",i),this.f&&(m=this.f.createScriptURL(m)),l.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(l)})}i(m){return new Promise((v,k)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),v(this.c.pop())}catch(l){k(l)}})}async j(m){try{const v=globalThis._VSCODE_NODE_MODULES.fs,k=globalThis._VSCODE_NODE_MODULES.vm,l=globalThis._VSCODE_NODE_MODULES.module,f=I.URI.parse(m).fsPath,s=v.readFileSync(f).toString(),i=l.wrap(s.replace(/^#!.*/,""));return new k.Script(i).runInThisContext().apply(),this.c.pop()}catch(v){throw v}}}const $=new Map;let y={};typeof globalThis.require=="object"&&(y=globalThis.require.paths??{});async function A(C,m,v){if(D.$T){v===void 0&&(v=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),y[C]&&(C=y[C]);const k=`${C}/${m}`;if($.has(k))return $.get(k);let l;if(/^\w[\w\d+.-]*:\/\//.test(k))l=k;else{const n=`${v&&!g.$o?N.$ig:N.$hg}/${k}`;l=N.$lg.asBrowserUri(n).toString(!0)}const f=b.INSTANCE.load(l);return $.set(k,f),f}else return await new Promise((k,l)=>{me([C],k,l)})}e.$4C=A}),define(Se[23],ke([1,0,33,17,16,10,12,2]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Og=e.DataUri=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=void 0;function $(v){return(0,b.$wc)(v,!0)}e.$sg=$;class y{constructor(k){this.a=k}compare(k,l,f=!1){return k===l?0:(0,R.$2e)(this.getComparisonKey(k,f),this.getComparisonKey(l,f))}isEqual(k,l,f=!1){return k===l?!0:!k||!l?!1:this.getComparisonKey(k,f)===this.getComparisonKey(l,f)}getComparisonKey(k,l=!1){return k.with({path:this.a(k)?k.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(k){return this.a(k)}isEqualOrParent(k,l,f=!1){if(k.scheme===l.scheme){if(k.scheme===N.Schemas.file)return D.$5f($(k),$(l),this.a(k))&&k.query===l.query&&(f||k.fragment===l.fragment);if((0,e.$Jg)(k.authority,l.authority))return D.$5f(k.path,l.path,this.a(k),"/")&&k.query===l.query&&(f||k.fragment===l.fragment)}return!1}joinPath(k,...l){return b.URI.joinPath(k,...l)}basenameOrAuthority(k){return(0,e.$Bg)(k)||k.authority}basename(k){return g.$gc.basename(k.path)}extname(k){return g.$gc.extname(k.path)}dirname(k){if(k.path.length===0)return k;let l;return k.scheme===N.Schemas.file?l=b.URI.file(g.$mc($(k))).path:(l=g.$gc.dirname(k.path),k.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${k.toString})) resulted in a relative path`),l="/")),k.with({path:l})}normalizePath(k){if(!k.path.length)return k;let l;return k.scheme===N.Schemas.file?l=b.URI.file(g.$hc($(k))).path:l=g.$gc.normalize(k.path),k.with({path:l})}relativePath(k,l){if(k.scheme!==l.scheme||!(0,e.$Jg)(k.authority,l.authority))return;if(k.scheme===N.Schemas.file){const i=g.$lc($(k),$(l));return I.$i?D.$Yf(i):i}let f=k.path||"/";const s=l.path||"/";if(this.a(k)){let i=0;for(const n=Math.min(f.length,s.length);i<n&&!(f.charCodeAt(i)!==s.charCodeAt(i)&&f.charAt(i).toLowerCase()!==s.charAt(i).toLowerCase());i++);f=s.substr(0,i)+f.substr(i)}return g.$gc.relative(f,s)}resolvePath(k,l){if(k.scheme===N.Schemas.file){const f=b.URI.file(g.$kc($(k),l));return k.with({authority:f.authority,path:f.path})}return l=D.$Zf(l),k.with({path:g.$gc.resolve(k.path,l)})}isAbsolutePath(k){return!!k.path&&k.path[0]==="/"}isEqualAuthority(k,l){return k===l||k!==void 0&&l!==void 0&&(0,R.$9e)(k,l)}hasTrailingPathSeparator(k,l=g.sep){if(k.scheme===N.Schemas.file){const f=$(k);return f.length>D.$1f(f).length&&f[f.length-1]===l}else{const f=k.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(k.fsPath)}}removeTrailingPathSeparator(k,l=g.sep){return(0,e.$Kg)(k,l)?k.with({path:k.path.substr(0,k.path.length-1)}):k}addTrailingPathSeparator(k,l=g.sep){let f=!1;if(k.scheme===N.Schemas.file){const s=$(k);f=s!==void 0&&s.length===D.$1f(s).length&&s[s.length-1]===l}else{l="/";const s=k.path;f=s.length===1&&s.charCodeAt(s.length-1)===47}return!f&&!(0,e.$Kg)(k,l)?k.with({path:k.path+"/"}):k}}e.$tg=y,e.$ug=new y(()=>!1),e.$vg=new y(v=>v.scheme===N.Schemas.file?!I.$k:!0),e.$wg=new y(v=>!0),e.$xg=e.$ug.isEqual.bind(e.$ug),e.$yg=e.$ug.isEqualOrParent.bind(e.$ug),e.$zg=e.$ug.getComparisonKey.bind(e.$ug),e.$Ag=e.$ug.basenameOrAuthority.bind(e.$ug),e.$Bg=e.$ug.basename.bind(e.$ug),e.$Cg=e.$ug.extname.bind(e.$ug),e.$Dg=e.$ug.dirname.bind(e.$ug),e.$Eg=e.$ug.joinPath.bind(e.$ug),e.$Fg=e.$ug.normalizePath.bind(e.$ug),e.$Gg=e.$ug.relativePath.bind(e.$ug),e.$Hg=e.$ug.resolvePath.bind(e.$ug),e.$Ig=e.$ug.isAbsolutePath.bind(e.$ug),e.$Jg=e.$ug.isEqualAuthority.bind(e.$ug),e.$Kg=e.$ug.hasTrailingPathSeparator.bind(e.$ug),e.$Lg=e.$ug.removeTrailingPathSeparator.bind(e.$ug),e.$Mg=e.$ug.addTrailingPathSeparator.bind(e.$ug);function A(v,k){const l=[];for(let f=0;f<v.length;f++){const s=k(v[f]);v.some((i,n)=>n===f?!1:(0,e.$yg)(s,k(i)))||l.push(v[f])}return l}e.$Ng=A;var C;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function k(l){const f=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(n=>{const[o,c]=n.split(":");o&&c&&f.set(o,c)});const i=l.path.substring(0,l.path.indexOf(";"));return i&&f.set(v.META_DATA_MIME,i),f}v.parseMetaData=k})(C||(e.DataUri=C={}));function m(v,k,l){if(k){let f=v.path;return f&&f[0]!==g.$gc.sep&&(f=g.$gc.sep+f),v.with({scheme:l,authority:k,path:f})}return v.with({scheme:l})}e.$Og=m}),define(Se[11],ke([1,0,21,14,4,3,23,10,163,43]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.Promises=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=void 0;function A(_){return!!_&&typeof _.then=="function"}e.$Pg=A;function C(_){const ie=new D.$3d,G=_(ie.token),te=new Promise((fe,ve)=>{const Pe=ie.token.onCancellationRequested(()=>{Pe.dispose(),ie.dispose(),ve(new N.$5)});Promise.resolve(G).then(be=>{Pe.dispose(),ie.dispose(),fe(be)},be=>{Pe.dispose(),ie.dispose(),ve(be)})});return new class{cancel(){ie.cancel()}then(fe,ve){return te.then(fe,ve)}catch(fe){return this.then(void 0,fe)}finally(fe){return te.finally(fe)}}}e.$Qg=C;function m(_,ie,G){return new Promise((te,fe)=>{const ve=ie.onCancellationRequested(()=>{ve.dispose(),te(G)});_.then(te,fe).finally(()=>ve.dispose())})}e.$Rg=m;function v(_,ie){return new Promise((G,te)=>{const fe=ie.onCancellationRequested(()=>{fe.dispose(),te(new N.$5)});_.then(G,te).finally(()=>fe.dispose())})}e.$Sg=v;async function k(_){let ie=-1;const G=_.map((te,fe)=>te.then(ve=>(ie=fe,ve)));try{return await Promise.race(G)}finally{_.forEach((te,fe)=>{fe!==ie&&te.cancel()})}}e.$Tg=k;function l(_,ie,G){let te;const fe=setTimeout(()=>{te?.(void 0),G?.()},ie);return Promise.race([_.finally(()=>clearTimeout(fe)),new Promise(ve=>te=ve)])}e.$Ug=l;function f(_){return new Promise((ie,G)=>{const te=_();A(te)?te.then(ie,G):ie(te)})}e.$Vg=f;class s{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(ie){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=ie,!this.b){const G=()=>{if(this.b=null,this.f)return;const te=this.queue(this.d);return this.d=null,te};this.b=new Promise(te=>{this.a.then(G,G).then(te)})}return new Promise((G,te)=>{this.b.then(G,te)})}return this.a=ie(),new Promise((G,te)=>{this.a.then(fe=>{this.a=null,G(fe)},fe=>{this.a=null,te(fe)})})}dispose(){this.f=!0}}e.$Wg=s;class i{constructor(){this.a=Promise.resolve(null)}queue(ie){return this.a=this.a.then(()=>ie(),()=>ie())}}e.$Xg=i;class n{constructor(){this.a=new Map}queue(ie,G){const fe=(this.a.get(ie)??Promise.resolve()).catch(()=>{}).then(G).finally(()=>{this.a.get(ie)===fe&&this.a.delete(ie)});return this.a.set(ie,fe),fe}}e.$Yg=n;const o=(_,ie)=>{let G=!0;const te=setTimeout(()=>{G=!1,ie()},_);return{isTriggered:()=>G,dispose:()=>{clearTimeout(te),G=!1}}},c=_=>{let ie=!0;return queueMicrotask(()=>{ie&&(ie=!1,_())}),{isTriggered:()=>ie,dispose:()=>{ie=!1}}};class t{constructor(ie){this.defaultDelay=ie,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ie,G=this.defaultDelay){this.g=ie,this.h(),this.b||(this.b=new Promise((fe,ve)=>{this.d=fe,this.f=ve}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const te=()=>{this.a=null,this.d?.(null)};return this.a=G===$.$Pd?c(te):o(G,te),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Zg=t;class r{constructor(ie){this.a=new t(ie),this.b=new s}trigger(ie,G){return this.a.trigger(()=>this.b.queue(ie),G)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$1g=r;class d{constructor(){this.a=!1,this.b=new Promise((ie,G)=>{this.d=ie})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$2g=d;class u extends d{constructor(ie){super(),this.f=setTimeout(()=>this.open(),ie)}open(){clearTimeout(this.f),super.open()}}e.$3g=u;function a(_,ie){return ie?new Promise((G,te)=>{const fe=setTimeout(()=>{ve.dispose(),G()},_),ve=ie.onCancellationRequested(()=>{clearTimeout(fe),ve.dispose(),te(new N.$5)})}):C(G=>a(_,G))}e.$4g=a;function h(_,ie=0,G){const te=setTimeout(()=>{_(),G&&fe.dispose()},ie),fe=(0,I.$Qc)(()=>{clearTimeout(te),G?.deleteAndLeak(fe)});return G?.add(fe),fe}e.$5g=h;function S(_){const ie=[];let G=0;const te=_.length;function fe(){return G<te?_[G++]():null}function ve(Pe){Pe!=null&&ie.push(Pe);const be=fe();return be?be.then(ve):Promise.resolve(ie)}return Promise.resolve(null).then(ve)}e.$6g=S;function P(_,ie=te=>!!te,G=null){let te=0;const fe=_.length,ve=()=>{if(te>=fe)return Promise.resolve(G);const Pe=_[te++];return Promise.resolve(Pe()).then(De=>ie(De)?Promise.resolve(De):ve())};return ve()}e.$7g=P;function w(_,ie=te=>!!te,G=null){if(_.length===0)return Promise.resolve(G);let te=_.length;const fe=()=>{te=-1;for(const ve of _)ve.cancel?.()};return new Promise((ve,Pe)=>{for(const be of _)be.then(De=>{--te>=0&&ie(De)?(fe(),ve(De)):te===0&&ve(G)}).catch(De=>{--te>=0&&(fe(),Pe(De))})})}e.$8g=w;class p{constructor(ie){this.a=0,this.d=ie,this.f=[],this.b=0,this.g=new g.$Sd}get onDrained(){return this.g.event}get size(){return this.a}queue(ie){return this.a++,new Promise((G,te)=>{this.f.push({factory:ie,c:G,e:te}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const ie=this.f.shift();this.b++;const G=ie.factory();G.then(ie.c,ie.e),G.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$9g=p;class E extends p{constructor(){super(1)}}e.$0g=E;class L{constructor(){this.a=new J,this.b=0}queue(ie){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,ie())):this.a.run(this.b++,ie())}}e.$$g=L;class T{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const ie=new Z;return this.b.add(ie),ie.p}g(){for(const[,ie]of this.a)if(ie.size>0)return!1;return!0}queueFor(ie,G=R.$ug){const te=G.getComparisonKey(ie);let fe=this.a.get(te);if(!fe){fe=new E;const ve=this.f++,Pe=g.Event.once(fe.onDrained)(()=>{fe?.dispose(),this.a.delete(te),this.h(),this.d?.deleteAndDispose(ve),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new I.$2c),this.d.set(ve,Pe),this.a.set(te,fe)}return fe}h(){this.g()&&this.j()}j(){for(const ie of this.b)ie.complete();this.b.clear()}dispose(){for(const[,ie]of this.a)ie.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$_g=T;class U{constructor(ie,G){this.a=-1,typeof ie=="function"&&typeof G=="number"&&this.setIfNotSet(ie,G)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ie,G){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ie()},G)}setIfNotSet(ie,G){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ie()},G))}}e.$ah=U;class F{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(ie,G,te=globalThis){this.cancel();const fe=te.setInterval(()=>{ie()},G);this.d=(0,I.$Qc)(()=>{te.clearInterval(fe),this.d=void 0})}dispose(){this.cancel()}}e.$bh=F;class j{constructor(ie,G){this.b=-1,this.a=ie,this.d=G,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ie=this.d){this.cancel(),this.b=setTimeout(this.f,ie)}get delay(){return this.d}set delay(ie){this.d=ie}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$ch=j;class O{constructor(ie,G){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.a=ie,this.b=G,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ie=this.b){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ie/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$dh=O;class M extends j{constructor(ie,G){super(ie,G),this.j=[]}work(ie){this.j.push(ie),this.isScheduled()||this.schedule()}h(){const ie=this.j;this.j=[],this.a?.(ie)}dispose(){this.j=[],super.dispose()}}e.$eh=M;class W extends I.$Sc{constructor(ie,G){super(),this.g=ie,this.h=G,this.a=[],this.b=this.B(new I.$Tc),this.f=!1}get pending(){return this.a.length}work(ie){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ie.length>this.g.maxBufferedWork)return!1}else if(this.pending+ie.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const G of ie)this.a.push(G);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$fh=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$hh=(_,ie)=>{(0,b.$B)(()=>{if(G)return;const te=Date.now()+15;ie(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,te-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.$hh=(_,ie,G)=>{const te=_.requestIdleCallback(ie,typeof G=="number"?{timeout:G}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,_.cancelIdleCallback(te))}}},e.$gh=_=>(0,e.$hh)(globalThis,_)}();class Y{constructor(ie,G){this.g=!1,this.d=()=>{try{this.j=G()}catch(te){this.l=te}finally{this.g=!0}},this.f=(0,e.$hh)(ie,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$ih=Y;class ue extends Y{constructor(ie){super(globalThis,ie)}}e.$jh=ue;async function X(_,ie,G){let te;for(let fe=0;fe<G;fe++)try{return await _()}catch(ve){te=ve,await a(ie)}throw te}e.$kh=X;class J{isRunning(ie){return typeof ie=="number"?this.a?.taskId===ie:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(ie,G,te){return this.a={taskId:ie,cancel:()=>te?.(),promise:G},G.then(()=>this.d(ie),()=>this.d(ie)),G}d(ie){this.a&&ie===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ie=this.b;this.b=void 0,ie.run().then(ie.promiseResolve,ie.promiseReject)}}queue(ie){if(this.b)this.b.run=ie;else{let G,te;const fe=new Promise((ve,Pe)=>{G=ve,te=Pe});this.b={run:ie,promise:fe,promiseResolve:G,promiseReject:te}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$lh=J;class x{constructor(ie,G=()=>Date.now()){this.d=ie,this.f=G,this.a=0,this.b=0}increment(){const ie=this.f();return ie-this.a>this.d&&(this.a=ie,this.b=0),this.b++,this.b}}e.$mh=x;var he;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(he||(he={}));class Z{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((ie,G)=>{this.a=ie,this.b=G})}complete(ie){return new Promise(G=>{this.a(ie),this.d={outcome:0,value:ie},G()})}error(ie){return new Promise(G=>{this.b(ie),this.d={outcome:1,value:ie},G()})}cancel(){return this.error(new N.$5)}}e.$nh=Z;var we;(function(_){async function ie(te){let fe;const ve=await Promise.all(te.map(Pe=>Pe.then(be=>be,be=>{fe||(fe=be)})));if(typeof fe<"u")throw fe;return ve}_.settled=ie;function G(te){return new Promise(async(fe,ve)=>{try{await te(fe,ve)}catch(Pe){ve(Pe)}})}_.withAsyncBody=G})(we||(e.Promises=we={}));class ce{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(ie){this.a=void 0,this.b=void 0,this.d=!1,this.promise=ie.then(G=>(this.a=G,this.d=!0,G),G=>{throw this.b=G,this.d=!0,G})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$oh=ce;class K{constructor(ie){this.b=ie,this.a=new y.$V(()=>new ce(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$ph=K;var B;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(B||(B={}));class re{static fromArray(ie){return new re(G=>{G.emitMany(ie)})}static fromPromise(ie){return new re(async G=>{G.emitMany(await ie)})}static fromPromises(ie){return new re(async G=>{await Promise.all(ie.map(async te=>G.emitOne(await te)))})}static merge(ie){return new re(async G=>{await Promise.all(ie.map(async te=>{for await(const fe of te)G.emitOne(fe)}))})}static{this.EMPTY=re.fromArray([])}constructor(ie){this.a=0,this.b=[],this.d=null,this.f=new g.$Sd,queueMicrotask(async()=>{const G={emitOne:te=>this.g(te),emitMany:te=>this.h(te),reject:te=>this.k(te)};try{await Promise.resolve(ie(G)),this.j()}catch(te){this.k(te)}finally{G.emitOne=void 0,G.emitMany=void 0,G.reject=void 0}})}[Symbol.asyncIterator](){let ie=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ie<this.b.length)return{done:!1,value:this.b[ie++]};if(this.a===1)return{done:!0,value:void 0};await g.Event.toPromise(this.f.event)}while(!0)}}}static map(ie,G){return new re(async te=>{for await(const fe of ie)te.emitOne(G(fe))})}map(ie){return re.map(this,ie)}static filter(ie,G){return new re(async te=>{for await(const fe of ie)G(fe)&&te.emitOne(fe)})}filter(ie){return re.filter(this,ie)}static coalesce(ie){return re.filter(ie,G=>!!G)}coalesce(){return re.coalesce(this)}static async toPromise(ie){const G=[];for await(const te of ie)G.push(te);return G}toPromise(){return re.toPromise(this)}g(ie){this.a===0&&(this.b.push(ie),this.f.fire())}h(ie){this.a===0&&(this.b=this.b.concat(ie),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ie){this.a===0&&(this.a=2,this.d=ie,this.f.fire())}}e.$qh=re;class ye extends re{constructor(ie,G){super(G),this.l=ie}cancel(){this.l.cancel()}}e.$rh=ye;function de(_){const ie=new D.$3d,G=_(ie.token);return new ye(ie,async te=>{const fe=ie.token.onCancellationRequested(()=>{fe.dispose(),ie.dispose(),te.reject(new N.$5)});try{for await(const ve of G){if(ie.token.isCancellationRequested)return;te.emitOne(ve)}fe.dispose(),ie.dispose()}catch(ve){fe.dispose(),ie.dispose(),te.reject(ve)}})}e.$sh=de;class ge{constructor(){this.a=new Z,this.b=new re(te=>{if(ie){te.reject(ie);return}return G&&te.emitMany(G),this.d=fe=>te.reject(fe),this.f=fe=>te.emitOne(fe),this.a.p});let ie,G;this.f=te=>{G||(G=[]),G.push(te)},this.d=te=>{ie||(ie=te)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(ie){this.d(ie),this.a.complete()}emitOne(ie){this.f(ie)}}e.$th=ge}),define(Se[34],ke([1,0,19,11,33,28,16,10,12]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=void 0;function y(){return Object.create(null)}e.$Ej=y,e.$Fj="**",e.$Gj="/";const A="[/\\\\]",C="[^/\\\\]",m=/\//g;function v(ue,X){switch(ue){case 0:return"";case 1:return`${C}*?`;default:return`(?:${A}|${C}+${A}${X?`|${A}${C}+`:""})*?`}}function k(ue,X){if(!ue)return[];const J=[];let x=!1,he=!1,Z="";for(const we of ue){switch(we){case X:if(!x&&!he){J.push(Z),Z="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":he=!0;break;case"]":he=!1;break}Z+=we}return Z&&J.push(Z),J}e.$Hj=k;function l(ue){if(!ue)return"";let X="";const J=k(ue,e.$Gj);if(J.every(x=>x===e.$Fj))X=".*";else{let x=!1;J.forEach((he,Z)=>{if(he===e.$Fj){if(x)return;X+=v(2,Z===J.length-1)}else{let we=!1,ce="",K=!1,B="";for(const re of he){if(re!=="}"&&we){ce+=re;continue}if(K&&(re!=="]"||!B)){let ye;re==="-"?ye=re:(re==="^"||re==="!")&&!B?ye="^":re===e.$Gj?ye="":ye=(0,$.$Le)(re),B+=ye;continue}switch(re){case"{":we=!0;continue;case"[":K=!0;continue;case"}":{const de=`(?:${k(ce,",").map(ge=>l(ge)).join("|")})`;X+=de,we=!1,ce="";break}case"]":{X+="["+B+"]",K=!1,B="";break}case"?":X+=C;continue;case"*":X+=v(1);continue;default:X+=(0,$.$Le)(re)}}Z<J.length-1&&(J[Z+1]!==e.$Fj||Z+2<J.length)&&(X+=A)}x=he===e.$Fj})}return X}const f=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new I.$Dc(1e4),r=function(){return!1},d=function(){return null};function u(ue,X){if(!ue)return d;let J;typeof ue!="string"?J=ue.pattern:J=ue,J=J.trim();const x=`${J}_${!!X.trimForExclusions}`;let he=t.get(x);if(he)return a(he,ue);let Z;return f.test(J)?he=S(J.substr(4),J):(Z=s.exec(h(J,X)))?he=P(Z[1],J):(X.trimForExclusions?n:i).test(J)?he=w(J,X):(Z=o.exec(h(J,X)))?he=p(Z[1].substr(1),J,!0):(Z=c.exec(h(J,X)))?he=p(Z[1],J,!1):he=E(J),t.set(x,he),a(he,ue)}function a(ue,X){if(typeof X=="string")return ue;const J=function(x,he){return(0,g.$5f)(x,X.base,!b.$k)?ue((0,$.$Qe)(x.substr(X.base.length),R.sep),he):null};return J.allBasenames=ue.allBasenames,J.allPaths=ue.allPaths,J.basenames=ue.basenames,J.patterns=ue.patterns,J}function h(ue,X){return X.trimForExclusions&&ue.endsWith("/**")?ue.substr(0,ue.length-2):ue}function S(ue,X){return function(J,x){return typeof J=="string"&&J.endsWith(ue)?X:null}}function P(ue,X){const J=`/${ue}`,x=`\\${ue}`,he=function(we,ce){return typeof we!="string"?null:ce?ce===ue?X:null:we===ue||we.endsWith(J)||we.endsWith(x)?X:null},Z=[ue];return he.basenames=Z,he.patterns=[X],he.allBasenames=Z,he}function w(ue,X){const J=W(ue.slice(1,-1).split(",").map(ce=>u(ce,X)).filter(ce=>ce!==d),ue),x=J.length;if(!x)return d;if(x===1)return J[0];const he=function(ce,K){for(let B=0,re=J.length;B<re;B++)if(J[B](ce,K))return ue;return null},Z=J.find(ce=>!!ce.allBasenames);Z&&(he.allBasenames=Z.allBasenames);const we=J.reduce((ce,K)=>K.allPaths?ce.concat(K.allPaths):ce,[]);return we.length&&(he.allPaths=we),he}function p(ue,X,J){const x=R.sep===R.$gc.sep,he=x?ue:ue.replace(m,R.sep),Z=R.sep+he,we=R.$gc.sep+ue;let ce;return J?ce=function(K,B){return typeof K=="string"&&(K===he||K.endsWith(Z)||!x&&(K===ue||K.endsWith(we)))?X:null}:ce=function(K,B){return typeof K=="string"&&(K===he||!x&&K===ue)?X:null},ce.allPaths=[(J?"*/":"./")+ue],ce}function E(ue){try{const X=new RegExp(`^${l(ue)}$`);return function(J){return X.lastIndex=0,typeof J=="string"&&X.test(J)?ue:null}}catch{return d}}function L(ue,X,J){return!ue||typeof X!="string"?!1:T(ue)(X,void 0,J)}e.$Ij=L;function T(ue,X={}){if(!ue)return r;if(typeof ue=="string"||U(ue)){const J=u(ue,X);if(J===d)return r;const x=function(he,Z){return!!J(he,Z)};return J.allBasenames&&(x.allBasenames=J.allBasenames),J.allPaths&&(x.allPaths=J.allPaths),x}return O(ue,X)}e.$Jj=T;function U(ue){const X=ue;return X?typeof X.base=="string"&&typeof X.pattern=="string":!1}e.$Kj=U;function F(ue){return ue.allBasenames||[]}e.$Lj=F;function j(ue){return ue.allPaths||[]}e.$Mj=j;function O(ue,X){const J=W(Object.getOwnPropertyNames(ue).map(ce=>M(ce,ue[ce],X)).filter(ce=>ce!==d)),x=J.length;if(!x)return d;if(!J.some(ce=>!!ce.requiresSiblings)){if(x===1)return J[0];const ce=function(re,ye){let de;for(let ge=0,_=J.length;ge<_;ge++){const ie=J[ge](re,ye);if(typeof ie=="string")return ie;(0,N.$Pg)(ie)&&(de||(de=[]),de.push(ie))}return de?(async()=>{for(const ge of de){const _=await ge;if(typeof _=="string")return _}return null})():null},K=J.find(re=>!!re.allBasenames);K&&(ce.allBasenames=K.allBasenames);const B=J.reduce((re,ye)=>ye.allPaths?re.concat(ye.allPaths):re,[]);return B.length&&(ce.allPaths=B),ce}const he=function(ce,K,B){let re,ye;for(let de=0,ge=J.length;de<ge;de++){const _=J[de];_.requiresSiblings&&B&&(K||(K=(0,R.$nc)(ce)),re||(re=K.substr(0,K.length-(0,R.$oc)(ce).length)));const ie=_(ce,K,re,B);if(typeof ie=="string")return ie;(0,N.$Pg)(ie)&&(ye||(ye=[]),ye.push(ie))}return ye?(async()=>{for(const de of ye){const ge=await de;if(typeof ge=="string")return ge}return null})():null},Z=J.find(ce=>!!ce.allBasenames);Z&&(he.allBasenames=Z.allBasenames);const we=J.reduce((ce,K)=>K.allPaths?ce.concat(K.allPaths):ce,[]);return we.length&&(he.allPaths=we),he}function M(ue,X,J){if(X===!1)return d;const x=u(ue,J);if(x===d)return d;if(typeof X=="boolean")return x;if(X){const he=X.when;if(typeof he=="string"){const Z=(we,ce,K,B)=>{if(!B||!x(we,ce))return null;const re=he.replace("$(basename)",()=>K),ye=B(re);return(0,N.$Pg)(ye)?ye.then(de=>de?ue:null):ye?ue:null};return Z.requiresSiblings=!0,Z}}return x}function W(ue,X){const J=ue.filter(ce=>!!ce.basenames);if(J.length<2)return ue;const x=J.reduce((ce,K)=>{const B=K.basenames;return B?ce.concat(B):ce},[]);let he;if(X){he=[];for(let ce=0,K=x.length;ce<K;ce++)he.push(X)}else he=J.reduce((ce,K)=>{const B=K.patterns;return B?ce.concat(B):ce},[]);const Z=function(ce,K){if(typeof ce!="string")return null;if(!K){let re;for(re=ce.length;re>0;re--){const ye=ce.charCodeAt(re-1);if(ye===47||ye===92)break}K=ce.substr(re)}const B=x.indexOf(K);return B!==-1?he[B]:null};Z.basenames=x,Z.patterns=he,Z.allBasenames=x;const we=ue.filter(ce=>!ce.basenames);return we.push(Z),we}function Y(ue,X){return(0,D.$ub)(ue,X,(J,x)=>typeof J=="string"&&typeof x=="string"?J===x:typeof J!="string"&&typeof x!="string"?J.base===x.base&&J.pattern===x.pattern:!1)}e.$Nj=Y}),define(Se[80],ke([1,0,14,164,23,12,2]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.MarkdownStringTextNewlineStyle=void 0;var b;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class ${constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,D.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=m(this.supportThemeIcons?(0,N.$$j)(i):i).replace(/([ \t]+)/g,(o,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+=`
${v(n,i)}
`,this}appendLink(i,n,o){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(i),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(i,n){const o=new RegExp((0,I.$Le)(n),"g");return i.replace(o,(c,t)=>i.charAt(t-1)!=="\\"?`\\${c}`:c)}}e.$ek=$;function y(s){return A(s)?!s.value:Array.isArray(s)?s.every(y):!0}e.$fk=y;function A(s){return s instanceof $?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.$gk=A;function C(s,i){return s===i?!0:!s||!i?!1:s.value===i.value&&s.isTrusted===i.isTrusted&&s.supportThemeIcons===i.supportThemeIcons&&s.supportHtml===i.supportHtml&&(s.baseUri===i.baseUri||!!s.baseUri&&!!i.baseUri&&(0,g.$xg)(R.URI.from(s.baseUri),R.URI.from(i.baseUri)))}e.$hk=C;function m(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$ik=m;function v(s,i){const n=s.match(/^`+/gm)?.reduce((c,t)=>c.length>t.length?c:t).length??0,o=n>=3?n+1:3;return[`${"`".repeat(o)}${i}`,s,`${"`".repeat(o)}`].join(`
`)}e.$jk=v;function k(s){return s.replace(/"/g,"&quot;")}e.$kk=k;function l(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$lk=l;function f(s){const i=[],n=s.split("|").map(c=>c.trim());s=n[0];const o=n[1];if(o){const c=/height=(\d+)/.exec(o),t=/width=(\d+)/.exec(o),r=c?c[1]:"",d=t?t[1]:"",u=isFinite(parseInt(d)),a=isFinite(parseInt(r));u&&i.push(`width="${d}"`),a&&i.push(`height="${r}"`)}return{href:s,dimensions:i}}e.$mk=f}),define(Se[102],ke([1,0,19,33,16,10,23,12]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rv=e.$Qv=e.$Pv=e.$Ov=e.$Nv=e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=void 0;function $(u,a){const{os:h,tildify:S,relative:P}=a;if(P){const E=y(u,P,h);if(typeof E=="string")return E}let w=u.fsPath;if(h===1&&!I.$i?w=w.replace(/\//g,"\\"):h!==1&&I.$i&&(w=w.replace(/\\/g,"/")),h!==1&&S?.userHome){const E=S.userHome.fsPath;let L;u.scheme!==S.userHome.scheme&&u.path[0]===g.$gc.sep&&u.path[1]!==g.$gc.sep?L=S.userHome.with({path:u.path}).fsPath:L=w,w=m(L,E,h)}return(h===1?g.$fc:g.$gc).normalize(A(w,h===1))}e.$Iv=$;function y(u,a,h){const S=h===1?g.$fc:g.$gc,P=h===3?R.$ug:R.$wg,w=a.getWorkspace(),p=(0,D.$Ob)(w.folders);if(!p)return;u.scheme!==p.uri.scheme&&u.path[0]===g.$gc.sep&&u.path[1]!==g.$gc.sep&&(u=p.uri.with({path:u.path}));const E=a.getWorkspaceFolder(u);if(!E)return;let L;if(P.isEqual(E.uri,u)?L="":L=P.relativePath(E.uri,u)??"",L&&(L=S.normalize(L)),w.folders.length>1&&!a.noPrefix){const T=E.name?E.name:P.basenameOrAuthority(E.uri);L=L?`${T} \u2022 ${L}`:T}return L}function A(u,a=I.$i){return(0,N.$9f)(u,a)?u.charAt(0).toUpperCase()+u.slice(1):u}e.$Jv=A;let C=Object.create(null);function m(u,a,h=I.OS){if(h===1||!u||!a)return u;let S=C.original===a?C.normalized:void 0;S||(S=a,I.$i&&(S=(0,N.$Yf)(S)),S=`${(0,b.$Re)(S,g.$gc.sep)}${g.$gc.sep}`,C={original:a,normalized:S});let P=u;return I.$i&&(P=(0,N.$Yf)(P)),(h===3?P.startsWith(S):(0,b.$0e)(P,S))?`~/${P.substr(S.length)}`:u}e.$Kv=m;function v(u,a){return u.replace(/^~($|\/|\\)/,`${a}$1`)}e.$Lv=v;const k="\u2026",l="\\\\",f="~";function s(u,a=g.sep){const h=new Array(u.length);let S=!1;for(let P=0;P<u.length;P++){const w=u[P];if(w===""){h[P]=`.${a}`;continue}if(!w){h[P]=w;continue}S=!0;let p="",E=w;E.indexOf(l)===0?(p=E.substr(0,E.indexOf(l)+l.length),E=E.substr(E.indexOf(l)+l.length)):E.indexOf(a)===0?(p=E.substr(0,E.indexOf(a)+a.length),E=E.substr(E.indexOf(a)+a.length)):E.indexOf(f)===0&&(p=E.substr(0,E.indexOf(f)+f.length),E=E.substr(E.indexOf(f)+f.length));const L=E.split(a);for(let T=1;S&&T<=L.length;T++)for(let U=L.length-T;S&&U>=0;U--){S=!1;let F=L.slice(U,U+T).join(a);for(let j=0;!S&&j<u.length;j++)if(j!==P&&u[j]&&u[j].indexOf(F)>-1){const O=U+T===L.length,M=U>0&&u[j].indexOf(a)>-1?a+F:F,W=u[j].endsWith(M);S=!O||W}if(!S){let j="";(L[0].endsWith(":")||p!=="")&&(U===1&&(U=0,T++,F=L[0]+a+F),U>0&&(j=L[0]+a),j=p+j),U>0&&(j=j+k+a),j=j+F,U+T<L.length&&(j=j+a+k),h[P]=j}}S&&(h[P]=w)}return h}e.$Mv=s;var i;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(u,a=Object.create(null)){const h=[];let S=!1,P="";for(const w of u)if(w==="$"||S&&w==="{")P&&h.push({value:P,type:i.TEXT}),P="",S=!0;else if(w==="}"&&S){const p=a[P];if(typeof p=="string")p.length&&h.push({value:p,type:i.VARIABLE});else if(p){const E=h[h.length-1];(!E||E.type!==i.SEPARATOR)&&h.push({value:p.label,type:i.SEPARATOR})}P="",S=!1}else P+=w;return P&&!S&&h.push({value:P,type:i.TEXT}),h.filter((w,p)=>{if(w.type===i.SEPARATOR){const E=h[p-1],L=h[p+1];return[E,L].every(T=>T&&(T.type===i.VARIABLE||T.type===i.TEXT)&&T.value.length>0)}return!0}).map(w=>w.value).join("")}e.$Nv=n;function o(u,a){return I.$j||a?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.$j?"&":"&&"):u.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.$Ov=o;function c(u,a){return I.$j||a?u.replace(/\(&&\w\)|&&/g,""):I.$i?u.replace(/&&|&/g,h=>h==="&"?"&&":"&"):u.replace(/&&/g,"_")}e.$Pv=c;function t(u){return u.replace(/&/g,"&&")}e.$Qv=t;function r(u){if(u.endsWith("]")){const a=u.lastIndexOf(" [",u.length-2);if(a!==-1){const h=d(u.substring(0,a)),S=u.substring(a);return{name:h.name+S,parentPath:h.parentPath}}}return d(u)}e.$Rv=r;function d(u){const a=u.indexOf("/")!==-1?g.$gc:g.$fc,h=a.basename(u),S=a.dirname(u);return h.length?{name:h,parentPath:S}:{name:S,parentPath:""}}}),define(Se[130],ke([1,0,22,2]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=void 0;function g(C){return C.toJSON()}class I{constructor(m){this.a=m}transformIncoming(m){const v=this.a.transformIncoming(m);return v===m?m:g(N.URI.from(v))}transformOutgoing(m){const v=this.a.transformOutgoing(m);return v===m?m:g(N.URI.from(v))}transformOutgoingURI(m){const v=this.a.transformOutgoing(m);return v===m?m:N.URI.from(v)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.$1m=I,e.$2m=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function R(C,m,v){if(!C||v>200)return null;if(typeof C=="object"){if(C instanceof N.URI)return m.transformOutgoing(C);for(const k in C)if(Object.hasOwnProperty.call(C,k)){const l=R(C[k],m,v+1);l!==null&&(C[k]=l)}}return null}function b(C,m){const v=R(C,m,0);return v===null?C:v}e.$3m=b;function $(C,m,v,k){if(!C||k>200)return null;if(typeof C=="object"){if(C.$mid===1)return v?N.URI.revive(m.transformIncoming(C)):m.transformIncoming(C);if(C instanceof D.$ge)return null;for(const l in C)if(Object.hasOwnProperty.call(C,l)){const f=$(C[l],m,v,k+1);f!==null&&(C[l]=f)}}return null}function y(C,m){const v=$(C,m,!1,0);return v===null?C:v}e.$4m=y;function A(C,m){const v=$(C,m,!0,0);return v===null?C:v}e.$5m=A}),define(Se[31],ke([1,0,56,63,385,11,33,76,16,10,23,2]),function(me,e,D,N,g,I,R,b,$,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function v(M,W=m.UNLINK,Y){if((0,R.$8f)(M))throw new Error("rimraf - will refuse to recursively delete root");return W===m.UNLINK?l(M):k(M,Y)}async function k(M,W=(0,R.$ag)((0,N.tmpdir)())){try{try{await D.promises.rename(M,W)}catch(Y){return Y.code==="ENOENT"?void 0:l(M)}l(W).catch(Y=>{})}catch(Y){if(Y.code!=="ENOENT")throw Y}}async function l(M){return(0,g.promisify)(D.rm)(M,{recursive:!0,force:!0,maxRetries:3})}function f(M){if((0,R.$8f)(M))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=f;async function s(M,W){return o(await(W?i(M):(0,g.promisify)(D.readdir)(M)))}async function i(M){try{return await(0,g.promisify)(D.readdir)(M,{withFileTypes:!0})}catch(ue){console.warn("[node.js fs] readdir with filetypes failed with error: ",ue)}const W=[],Y=await s(M);for(const ue of Y){let X=!1,J=!1,x=!1;try{const he=await e.Promises.lstat((0,$.$jc)(M,ue));X=he.isFile(),J=he.isDirectory(),x=he.isSymbolicLink()}catch(he){console.warn("[node.js fs] unexpected error from lstat after readdir: ",he)}W.push({name:ue,isFile:()=>X,isDirectory:()=>J,isSymbolicLink:()=>x})}return W}function n(M){return o(D.readdirSync(M))}e.readdirSync=n;function o(M){return M.map(W=>typeof W=="string"?y.$j?(0,b.$Dl)(W):W:(W.name=y.$j?(0,b.$Dl)(W.name):W.name,W))}async function c(M){const W=await s(M),Y=[];for(const ue of W)await r.existsDirectory((0,$.$jc)(M,ue))&&Y.push(ue);return Y}function t(M,W=1e3){return new Promise(Y=>{let ue=!1;const X=setInterval(()=>{ue||(ue=!0,D.access(M,J=>{ue=!1,J&&(clearInterval(X),Y(void 0))}))},W)})}e.whenDeleted=t;var r;(function(M){async function W(X){let J;try{if(J=await e.Promises.lstat(X),!J.isSymbolicLink())return{stat:J}}catch{}try{return{stat:await e.Promises.stat(X),symbolicLink:J?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};if(y.$i&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(X)),symbolicLink:{dangling:!1}}}catch(he){if(he.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};throw he}throw x}}M.stat=W;async function Y(X){try{const{stat:J,symbolicLink:x}=await M.stat(X);return J.isFile()&&x?.dangling!==!0}catch{}return!1}M.existsFile=Y;async function ue(X){try{const{stat:J,symbolicLink:x}=await M.stat(X);return J.isDirectory()&&x?.dangling!==!0}catch{}return!1}M.existsDirectory=ue})(r||(e.SymlinkSupport=r={}));const d=new I.$_g;function u(M,W,Y){return d.queueFor(C.URI.file(M),A.$vg).queue(()=>{const ue=w(Y);return new Promise((X,J)=>S(M,W,ue,x=>x?J(x):X()))})}let a=!0;function h(M){a=M}e.configureFlushOnWrite=h;function S(M,W,Y,ue){if(!a)return D.writeFile(M,W,{mode:Y.mode,flag:Y.flag},ue);D.open(M,Y.flag,Y.mode,(X,J)=>{if(X)return ue(X);D.writeFile(J,W,x=>{if(x)return D.close(J,()=>ue(x));D.fdatasync(J,he=>(he&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",he),h(!1)),D.close(J,Z=>ue(Z))))})})}function P(M,W,Y){const ue=w(Y);if(!a)return D.writeFileSync(M,W,{mode:ue.mode,flag:ue.flag});const X=D.openSync(M,ue.flag,ue.mode);try{D.writeFileSync(X,W);try{D.fdatasyncSync(X)}catch(J){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",J),h(!1)}}finally{D.closeSync(X)}}e.writeFileSync=P;function w(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function p(M,W,Y=6e4){if(M!==W)try{y.$i&&typeof Y=="number"?await E(M,W,Date.now(),Y):await(0,g.promisify)(D.rename)(M,W)}catch(ue){if(M.toLowerCase()!==W.toLowerCase()&&ue.code==="EXDEV"||M.endsWith("."))await L(M,W,{preserveSymlinks:!1}),await v(M,m.MOVE);else throw ue}}async function E(M,W,Y,ue,X=0){try{return await(0,g.promisify)(D.rename)(M,W)}catch(J){if(J.code!=="EACCES"&&J.code!=="EPERM"&&J.code!=="EBUSY")throw J;if(Date.now()-Y>=ue)throw console.error(`[node.js fs] rename failed after ${X} retries with error: ${J}`),J;if(X===0){let x=!1;try{const{stat:he}=await r.stat(W);he.isFile()||(x=!0)}catch{}if(x)throw J}return await(0,I.$4g)(Math.min(100,X*10)),E(M,W,Y,ue,X+1)}}async function L(M,W,Y){return U(M,W,{root:{source:M,target:W},options:Y,handledSourcePaths:new Set})}const T=511;async function U(M,W,Y){if(Y.handledSourcePaths.has(M))return;Y.handledSourcePaths.add(M);const{stat:ue,symbolicLink:X}=await r.stat(M);if(X){if(Y.options.preserveSymlinks)try{return await O(M,W,Y)}catch{}if(X.dangling)return}return ue.isDirectory()?F(M,W,ue.mode&T,Y):j(M,W,ue.mode&T)}async function F(M,W,Y,ue){await e.Promises.mkdir(W,{recursive:!0,mode:Y});const X=await s(M);for(const J of X)await U((0,$.$jc)(M,J),(0,$.$jc)(W,J),ue)}async function j(M,W,Y){await e.Promises.copyFile(M,W),await e.Promises.chmod(W,Y)}async function O(M,W,Y){let ue=await e.Promises.readlink(M);(0,R.$5f)(ue,Y.root.source,!y.$k)&&(ue=(0,$.$jc)(Y.root.target,ue.substr(Y.root.source.length+1))),await e.Promises.symlink(ue,W)}e.Promises=new class{get access(){return(0,g.promisify)(D.access)}get stat(){return(0,g.promisify)(D.stat)}get lstat(){return(0,g.promisify)(D.lstat)}get utimes(){return(0,g.promisify)(D.utimes)}get read(){return(M,W,Y,ue,X)=>new Promise((J,x)=>{D.read(M,W,Y,ue,X,(he,Z,we)=>he?x(he):J({bytesRead:Z,buffer:we}))})}get readFile(){return(0,g.promisify)(D.readFile)}get write(){return(M,W,Y,ue,X)=>new Promise((J,x)=>{D.write(M,W,Y,ue,X,(he,Z,we)=>he?x(he):J({bytesWritten:Z,buffer:we}))})}get appendFile(){return(0,g.promisify)(D.appendFile)}get fdatasync(){return(0,g.promisify)(D.fdatasync)}get truncate(){return(0,g.promisify)(D.truncate)}get copyFile(){return(0,g.promisify)(D.copyFile)}get open(){return(0,g.promisify)(D.open)}get close(){return(0,g.promisify)(D.close)}get symlink(){return(0,g.promisify)(D.symlink)}get readlink(){return(0,g.promisify)(D.readlink)}get chmod(){return(0,g.promisify)(D.chmod)}get mkdir(){return(0,g.promisify)(D.mkdir)}get unlink(){return(0,g.promisify)(D.unlink)}get rmdir(){return(0,g.promisify)(D.rmdir)}get realpath(){return(0,g.promisify)(D.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return s}get readDirsInDir(){return c}get writeFile(){return u}get rm(){return v}get rename(){return p}get copy(){return L}}}),define(Se[103],ke([1,0,56,16,10,12,31]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=e.$iq=e.$hq=void 0;function b(m){if(g.$k)return m;const v=(0,N.$mc)(m);if(m===v)return m;const k=((0,N.$nc)(m)||m).toLowerCase();try{const f=(0,R.readdirSync)(v).filter(s=>s.toLowerCase()===k);if(f.length===1){const s=b(v);if(s)return(0,N.$jc)(s,f[0])}else if(f.length>1){const s=f.indexOf(k);if(s>=0){const i=b(v);if(i)return(0,N.$jc)(i,f[s])}}}catch{}return null}e.$hq=b;async function $(m){if(g.$k)return m;const v=(0,N.$mc)(m);if(m===v)return m;const k=((0,N.$nc)(m)||m).toLowerCase();try{const f=(await R.Promises.readdir(v)).filter(s=>s.toLowerCase()===k);if(f.length===1){const s=await $(v);if(s)return(0,N.$jc)(s,f[0])}else if(f.length>1){const s=f.indexOf(k);if(s>=0){const i=await $(v);if(i)return(0,N.$jc)(i,f[s])}}}catch{}return null}e.$iq=$;async function y(m){try{return await R.Promises.realpath(m)}catch{const k=C(m);return await R.Promises.access(k,D.constants.R_OK),k}}e.$jq=y;function A(m){try{return D.realpathSync(m)}catch{const k=C(m);return D.accessSync(k,D.constants.R_OK),k}}e.$kq=A;function C(m){return(0,I.$Re)((0,N.$hc)(m),N.sep)}}),define(Se[104],ke([1,0,16,10,50,101,18,31]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Rl=e.$Ql=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function $(C=g.env){return C.comspec||"cmd.exe"}e.$Ql=$;function y(C){let m=[],v=!1;const k=function(l){if(v){m.push(l);return}(!C.send(l,s=>{if(s&&console.error(s),v=!1,m.length>0){const i=m.slice(0);m=[],i.forEach(n=>k(n))}})||N.$i)&&(v=!0)};return{send:k}}e.$Rl=y;var A;(function(C){async function m(v,k,l){if(D.$ic(v))return v;if(k===void 0&&(k=g.cwd()),D.$mc(v)!=="."||(l===void 0&&R.$Ff(g.env.PATH)&&(l=g.env.PATH.split(D.$tc)),l===void 0||l.length===0))return D.$jc(k,v);async function s(i){if(await b.Promises.exists(i)){let n;try{n=await b.Promises.stat(i)}catch(o){o.message.startsWith("EACCES")&&(n=await b.Promises.lstat(i))}return n?!n.isDirectory():!1}return!1}for(const i of l){let n;if(D.$ic(i)?n=D.$jc(i,v):n=D.$jc(k,i,v),await s(n))return n;let o=n+".com";if(await s(o)||(o=n+".exe",await s(o)))return o}return D.$jc(k,v)}C.findExecutable=m})(A||(e.win32=A={}))});var Ge=this&&this.__decorate||function(me,e,D,N){var g=arguments.length,I=g<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,D):N,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(me,e,D,N);else for(var b=me.length-1;b>=0;b--)(R=me[b])&&(I=(g<3?R(I):g>3?R(e,D,I):R(e,D))||I);return g>3&&I&&Object.defineProperty(e,D,I),I};define(Se[81],ke([1,0,19,11,22,21,52,14,4,3,55,12,18]),function(me,e,D,N,g,I,R,b,$,y,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.ProxyChannel=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.RequestInitiator=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=void 0;var v;(function(X){X[X.Promise=100]="Promise",X[X.PromiseCancel=101]="PromiseCancel",X[X.EventListen=102]="EventListen",X[X.EventDispose=103]="EventDispose"})(v||(v={}));function k(X){switch(X){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var l;(function(X){X[X.Initialize=200]="Initialize",X[X.PromiseSuccess=201]="PromiseSuccess",X[X.PromiseError=202]="PromiseError",X[X.PromiseErrorObj=203]="PromiseErrorObj",X[X.EventFire=204]="EventFire"})(l||(l={}));function f(X){switch(X){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var s;(function(X){X[X.Uninitialized=0]="Uninitialized",X[X.Idle=1]="Idle"})(s||(s={}));function i(X){let J=0;for(let x=0;;x+=7){const he=X.read(1);if(J|=(he.buffer[0]&127)<<x,!(he.buffer[0]&128))return J}}const n=d(0);function o(X,J){if(J===0){X.write(n);return}let x=0;for(let Z=J;Z!==0;Z=Z>>>7)x++;const he=g.$ge.alloc(x);for(let Z=0;J!==0;Z++)he.buffer[Z]=J&127,J=J>>>7,J>0&&(he.buffer[Z]|=128);X.write(he)}class c{constructor(J){this.b=J,this.a=0}read(J){const x=this.b.slice(this.a,this.a+J);return this.a+=x.byteLength,x}}e.$Ah=c;class t{constructor(){this.a=[]}get buffer(){return g.$ge.concat(this.a)}write(J){this.a.push(J)}}e.$Bh=t;var r;(function(X){X[X.Undefined=0]="Undefined",X[X.String=1]="String",X[X.Buffer=2]="Buffer",X[X.VSBuffer=3]="VSBuffer",X[X.Array=4]="Array",X[X.Object=5]="Object",X[X.Int=6]="Int"})(r||(r={}));function d(X){const J=g.$ge.alloc(1);return J.writeUInt8(X,0),J}const u={Undefined:d(r.Undefined),String:d(r.String),Buffer:d(r.Buffer),VSBuffer:d(r.VSBuffer),Array:d(r.Array),Object:d(r.Object),Uint:d(r.Int)},a=typeof Buffer<"u";function h(X,J){if(typeof J>"u")X.write(u.Undefined);else if(typeof J=="string"){const x=g.$ge.fromString(J);X.write(u.String),o(X,x.byteLength),X.write(x)}else if(a&&Buffer.isBuffer(J)){const x=g.$ge.wrap(J);X.write(u.Buffer),o(X,x.byteLength),X.write(x)}else if(J instanceof g.$ge)X.write(u.VSBuffer),o(X,J.byteLength),X.write(J);else if(Array.isArray(J)){X.write(u.Array),o(X,J.length);for(const x of J)h(X,x)}else if(typeof J=="number"&&(J|0)===J)X.write(u.Uint),o(X,J);else{const x=g.$ge.fromString(JSON.stringify(J));X.write(u.Object),o(X,x.byteLength),X.write(x)}}e.$Ch=h;function S(X){switch(X.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return X.read(i(X)).toString();case r.Buffer:return X.read(i(X)).buffer;case r.VSBuffer:return X.read(i(X));case r.Array:{const x=i(X),he=[];for(let Z=0;Z<x;Z++)he.push(S(X));return he}case r.Object:return JSON.parse(X.read(i(X)).toString());case r.Int:return i(X)}}e.$Dh=S;class P{constructor(J,x,he=null,Z=1e3){this.h=J,this.j=x,this.k=he,this.l=Z,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(we=>this.q(we)),this.m({type:200})}registerChannel(J,x){this.b.set(J,x),setTimeout(()=>this.w(J),0)}m(J){switch(J.type){case 200:{const x=this.o([J.type]);this.k?.logOutgoing(x,0,1,f(J.type));return}case 201:case 202:case 204:case 203:{const x=this.o([J.type,J.id],J.data);this.k?.logOutgoing(x,J.id,1,f(J.type),J.data);return}}}o(J,x=void 0){const he=new t;return h(he,J),h(he,x),this.p(he.buffer)}p(J){try{return this.h.send(J),J.byteLength}catch{return 0}}q(J){const x=new c(J),he=S(x),Z=S(x),we=he[0];switch(we){case 100:return this.k?.logIncoming(J.byteLength,he[1],1,`${k(we)}: ${he[2]}.${he[3]}`,Z),this.s({type:we,id:he[1],channelName:he[2],name:he[3],arg:Z});case 102:return this.k?.logIncoming(J.byteLength,he[1],1,`${k(we)}: ${he[2]}.${he[3]}`,Z),this.t({type:we,id:he[1],channelName:he[2],name:he[3],arg:Z});case 101:return this.k?.logIncoming(J.byteLength,he[1],1,`${k(we)}`),this.u({type:we,id:he[1]});case 103:return this.k?.logIncoming(J.byteLength,he[1],1,`${k(we)}`),this.u({type:we,id:he[1]})}}s(J){const x=this.b.get(J.channelName);if(!x){this.v(J);return}const he=new I.$3d;let Z;try{Z=x.call(this.j,J.name,J.arg,he.token)}catch(K){Z=Promise.reject(K)}const we=J.id;Z.then(K=>{this.m({id:we,data:K,type:201})},K=>{K instanceof Error?this.m({id:we,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.m({id:we,data:K,type:203})}).finally(()=>{ce.dispose(),this.d.delete(J.id)});const ce=(0,y.$Qc)(()=>he.cancel());this.d.set(J.id,ce)}t(J){const x=this.b.get(J.channelName);if(!x){this.v(J);return}const he=J.id,we=x.listen(this.j,J.name,J.arg)(ce=>this.m({id:he,data:ce,type:204}));this.d.set(J.id,we)}u(J){const x=this.d.get(J.id);x&&(x.dispose(),this.d.delete(J.id))}v(J){let x=this.g.get(J.channelName);x||(x=[],this.g.set(J.channelName,x));const he=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.m({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);x.push({request:J,timeoutTimer:he})}w(J){const x=this.g.get(J);if(x){for(const he of x)switch(clearTimeout(he.timeoutTimer),he.request.type){case 100:this.s(he.request);break;case 102:this.t(he.request);break}this.g.delete(J)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,y.$Nc)(this.d.values()),this.d.clear()}}e.$Eh=P;var w;(function(X){X[X.LocalSide=0]="LocalSide",X[X.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class p{constructor(J,x=null){this.l=J,this.a=!1,this.b=s.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$Sd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(he=>this.s(he)),this.j=x}getChannel(J){const x=this;return{call(he,Z,we){return x.a?Promise.reject(new b.$5):x.m(J,he,Z,we)},listen(he,Z){return x.a?$.Event.None:x.o(J,he,Z)}}}m(J,x,he,Z=I.CancellationToken.None){const we=this.g++,K={id:we,type:100,channelName:J,name:x,arg:he};if(Z.isCancellationRequested)return Promise.reject(new b.$5);let B;return new Promise((ye,de)=>{if(Z.isCancellationRequested)return de(new b.$5);const ge=()=>{const te=fe=>{switch(fe.type){case 201:this.f.delete(we),ye(fe.data);break;case 202:{this.f.delete(we);const ve=new Error(fe.data.message);ve.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,ve.name=fe.data.name,de(ve);break}case 203:this.f.delete(we),de(fe.data);break}};this.f.set(we,te),this.p(K)};let _=null;this.b===s.Idle?ge():(_=(0,N.$Qg)(te=>this.u()),_.then(()=>{_=null,ge()}));const ie=()=>{_?(_.cancel(),_=null):this.p({id:we,type:101}),de(new b.$5)},G=Z.onCancellationRequested(ie);B=(0,y.$Pc)((0,y.$Qc)(ie),G),this.d.add(B)}).finally(()=>{B.dispose(),this.d.delete(B)})}o(J,x,he){const Z=this.g++,ce={id:Z,type:102,channelName:J,name:x,arg:he};let K=null;const B=new $.$Sd({onWillAddFirstListener:()=>{K=(0,N.$Qg)(ye=>this.u()),K.then(()=>{K=null,this.d.add(B),this.p(ce)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(B),this.p({id:Z,type:103}))}}),re=ye=>B.fire(ye.data);return this.f.set(Z,re),B.event}p(J){switch(J.type){case 100:case 102:{const x=this.q([J.type,J.id,J.channelName,J.name],J.arg);this.j?.logOutgoing(x,J.id,0,`${k(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const x=this.q([J.type,J.id]);this.j?.logOutgoing(x,J.id,0,k(J.type));return}}}q(J,x=void 0){const he=new t;return h(he,J),h(he,x),this.r(he.buffer)}r(J){try{return this.l.send(J),J.byteLength}catch{return 0}}s(J){const x=new c(J),he=S(x),Z=S(x),we=he[0];switch(we){case 200:return this.j?.logIncoming(J.byteLength,0,0,f(we)),this.t({type:he[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(J.byteLength,he[1],0,f(we),Z),this.t({type:he[0],id:he[1],data:Z})}}t(J){if(J.type===200){this.b=s.Idle,this.k.fire();return}this.f.get(J.id)?.(J)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===s.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,y.$Nc)(this.d.values()),this.d.clear()}}e.$Fh=p,Ge([R.$uh],p.prototype,"onDidInitializePromise",null);class E{get connections(){const J=[];return this.f.forEach(x=>J.push(x)),J}constructor(J){this.a=new Map,this.f=new Set,this.g=new $.$Sd,this.onDidAddConnection=this.g.event,this.h=new $.$Sd,this.onDidRemoveConnection=this.h.event,this.j=new y.$Rc,this.j.add(J(({protocol:x,onDidClientDisconnect:he})=>{const Z=$.Event.once(x.onMessage);this.j.add(Z(we=>{const ce=new c(we),K=S(ce),B=new P(x,K),re=new p(x);this.a.forEach((de,ge)=>B.registerChannel(ge,de));const ye={channelServer:B,channelClient:re,ctx:K};this.f.add(ye),this.g.fire(ye),this.j.add(he(()=>{B.dispose(),re.dispose(),this.f.delete(ye),this.h.fire(ye)}))}))}))}getChannel(J,x){const he=this;return{call(Z,we,ce){let K;if((0,m.$Tf)(x)){const re=(0,D.$4b)(he.connections.filter(x));K=re?Promise.resolve(re):$.Event.toPromise($.Event.filter(he.onDidAddConnection,x))}else K=x.routeCall(he,Z,we);const B=K.then(re=>re.channelClient.getChannel(J));return T(B).call(Z,we,ce)},listen(Z,we){if((0,m.$Tf)(x))return he.k(J,x,Z,we);const ce=x.routeEvent(he,Z,we).then(K=>K.channelClient.getChannel(J));return T(ce).listen(Z,we)}}}k(J,x,he,Z){const we=this;let ce;const K=new $.$Sd({onWillAddFirstListener:()=>{ce=new y.$Rc;const B=new $.$Yd,re=new Map,ye=ge=>{const ie=ge.channelClient.getChannel(J).listen(he,Z),G=B.add(ie);re.set(ge,G)},de=ge=>{const _=re.get(ge);_&&(_.dispose(),re.delete(ge))};we.connections.filter(x).forEach(ye),$.Event.filter(we.onDidAddConnection,x)(ye,void 0,ce),we.onDidRemoveConnection(de,void 0,ce),B.event(K.fire,K,ce),ce.add(B)},onDidRemoveLastListener:()=>{ce?.dispose(),ce=void 0}});return K.event}registerChannel(J,x){this.a.set(J,x);for(const he of this.f)he.channelServer.registerChannel(J,x)}dispose(){this.j.dispose();for(const J of this.f)J.channelClient.dispose(),J.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Gh=E;class L{constructor(J,x,he=null){const Z=new t;h(Z,x),J.send(Z.buffer),this.a=new p(J,he),this.d=new P(J,x,he)}getChannel(J){return this.a.getChannel(J)}registerChannel(J,x){this.d.registerChannel(J,x)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Hh=L;function T(X){return{call(J,x,he){return X.then(Z=>Z.call(J,x,he))},listen(J,x){const he=new $.$2d;return X.then(Z=>he.input=Z.listen(J,x)),he.event}}}e.$Ih=T;function U(X){let J=!1;return{call(x,he,Z){return J?X.call(x,he,Z):(0,N.$4g)(0).then(()=>J=!0).then(()=>X.call(x,he,Z))},listen(x,he){if(J)return X.listen(x,he);const Z=new $.$2d;return(0,N.$4g)(0).then(()=>J=!0).then(()=>Z.input=X.listen(x,he)),Z.event}}}e.$Jh=U;class F{constructor(J){this.a=J}routeCall(J){return this.b(J)}routeEvent(J){return this.b(J)}async b(J){for(const x of J.connections)if(await Promise.resolve(this.a(x.ctx)))return Promise.resolve(x);return await $.Event.toPromise(J.onDidAddConnection),await this.b(J)}}e.$Kh=F;var j;(function(X){function J(we,ce,K){const B=we,re=K&&K.disableMarshalling,ye=new Map;for(const de in B)he(de)&&ye.set(de,$.Event.buffer(B[de],!0,void 0,ce));return new class{listen(de,ge,_){const ie=ye.get(ge);if(ie)return ie;if(Z(ge)){const G=B[ge];if(typeof G=="function")return G.call(B,_)}throw new b.$bb(`Event not found: ${ge}`)}call(de,ge,_){const ie=B[ge];if(typeof ie=="function"){if(!re&&Array.isArray(_))for(let te=0;te<_.length;te++)_[te]=(0,A.$zh)(_[te]);let G=ie.apply(B,_);return G instanceof Promise||(G=Promise.resolve(G)),G}throw new b.$bb(`Method not found: ${ge}`)}}}X.fromService=J;function x(we,ce){const K=ce&&ce.disableMarshalling;return new Proxy({},{get(B,re){if(typeof re=="string")return ce?.properties?.has(re)?ce.properties.get(re):Z(re)?function(ye){return we.listen(re,ye)}:he(re)?we.listen(re):async function(...ye){let de;ce&&!(0,m.$Of)(ce.context)?de=[ce.context,...ye]:de=ye;const ge=await we.call(re,de);return K?ge:(0,A.$zh)(ge)};throw new b.$bb(`Property not found: ${String(re)}`)}})}X.toService=x;function he(we){return we[0]==="o"&&we[1]==="n"&&C.$8e(we.charCodeAt(2))}function Z(we){return/^onDynamic/.test(we)&&C.$8e(we.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(X){if(Array.isArray(X))return X;if(X&&typeof X=="object"&&typeof X.toString=="function"){const J=X.toString();if(J!=="[object Object]")return J}return X}function W(X){return Array.isArray(X)?X.map(M):M(X)}function Y(X,J,x,he,Z,we,ce){ce=W(ce);const K=O[Z],B=K[he%K.length];let re=[`%c[${X}]%c[${String(J).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(he).padStart(5," ")} - ${we}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(we)?(re=re.concat(ce),re.push(")")):re.push(ce),console.log.apply(console,re)}class ue{constructor(J,x){this.d=J,this.f=x,this.a=0,this.b=0}logOutgoing(J,x,he,Z,we){this.b+=J,Y(this.d,this.b,J,x,he,Z,we)}logIncoming(J,x,he,Z,we){this.a+=J,Y(this.f,this.a,J,x,he,Z,we)}}e.$Lh=ue}),define(Se[82],ke([1,0,22,4,3,81]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.ProtocolConstants=e.$Mh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(u){u.Created="created",u.Read="read",u.Write="write",u.Open="open",u.Error="error",u.Close="close",u.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",u.NodeEndReceived="nodeEndReceived",u.NodeEndSent="nodeEndSent",u.NodeDrainBegin="nodeDrainBegin",u.NodeDrainEnd="nodeDrainEnd",u.zlibInflateError="zlibInflateError",u.zlibInflateData="zlibInflateData",u.zlibInflateInitialWrite="zlibInflateInitialWrite",u.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",u.zlibInflateWrite="zlibInflateWrite",u.zlibInflateFlushFired="zlibInflateFlushFired",u.zlibDeflateError="zlibDeflateError",u.zlibDeflateData="zlibDeflateData",u.zlibDeflateWrite="zlibDeflateWrite",u.zlibDeflateFlushFired="zlibDeflateFlushFired",u.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",u.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",u.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",u.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",u.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",u.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",u.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",u.ProtocolHeaderRead="protocolHeaderRead",u.ProtocolMessageRead="protocolMessageRead",u.ProtocolHeaderWrite="protocolHeaderWrite",u.ProtocolMessageWrite="protocolMessageWrite",u.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var b;(function(u){u.enableDiagnostics=!1,u.records=[];const a=new WeakMap;let h=0;function S(w,p){if(!a.has(w)){const E=String(++h);a.set(w,E)}return a.get(w)}function P(w,p,E,L){if(!u.enableDiagnostics)return;const T=S(w,p);if(L instanceof D.$ge||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const U=D.$ge.alloc(L.byteLength);U.set(L),u.records.push({timestamp:Date.now(),id:T,label:p,type:E,buff:U})}else u.records.push({timestamp:Date.now(),id:T,label:p,type:E,data:L})}u.traceSocketEvent=P})(b||(e.SocketDiagnostics=b={}));var $;(function(u){u[u.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",u[u.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let y=null;function A(){return y||(y=D.$ge.alloc(0)),y}class C{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(a){this.a.push(a),this.b+=a.byteLength}read(a){return this.c(a,!0)}peek(a){return this.c(a,!1)}c(a,h){if(a===0)return A();if(a>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===a){const p=this.a[0];return h&&(this.a.shift(),this.b-=a),p}if(this.a[0].byteLength>a){const p=this.a[0].slice(0,a);return h&&(this.a[0]=this.a[0].slice(a),this.b-=a),p}const S=D.$ge.alloc(a);let P=0,w=0;for(;a>0;){const p=this.a[w];if(p.byteLength>a){const E=p.slice(0,a);S.set(E,P),P+=a,h&&(this.a[w]=p.slice(a),this.b-=a),a-=a}else S.set(p,P),P+=p.byteLength,h?(this.a.shift(),this.b-=p.byteLength):w++,a-=p.byteLength}return S}}e.$Mh=C;var m;(function(u){u[u.None=0]="None",u[u.Regular=1]="Regular",u[u.Control=2]="Control",u[u.Ack=3]="Ack",u[u.Disconnect=5]="Disconnect",u[u.ReplayRequest=6]="ReplayRequest",u[u.Pause=7]="Pause",u[u.Resume=8]="Resume",u[u.KeepAlive=9]="KeepAlive"})(m||(m={}));function v(u){switch(u){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var k;(function(u){u[u.HeaderLength=13]="HeaderLength",u[u.AcknowledgeTime=2e3]="AcknowledgeTime",u[u.TimeoutTime=2e4]="TimeoutTime",u[u.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",u[u.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",u[u.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(k||(e.ProtocolConstants=k={}));class l{constructor(a,h,S,P){this.type=a,this.id=h,this.ack=S,this.data=P,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends g.$Sc{constructor(a){super(),this.f=this.B(new N.$Sd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=a,this.b=!1,this.c=new C,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(a);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:v(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const S=this.g.messageType,P=this.g.id,w=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",h),this.f.fire(new l(S,P,w,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class s{constructor(a){this.k=null,this.a=!1,this.b=!1,this.c=a,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(a){if(this.a)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=D.$ge.alloc(13);h.writeUInt8(a.type,0),h.writeUInt32BE(a.id,1),h.writeUInt32BE(a.ack,5),h.writeUInt32BE(a.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:v(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",a.data),this.j(h,a.data)}g(a,h){const S=this.f===0;return this.d.push(a,h),this.f+=a.byteLength+h.byteLength,S}h(){const a=D.$ge.concat(this.d,this.f);return this.d.length=0,this.f=0,a}j(a,h){this.g(a,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const a=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this.c.write(a)}}class i extends g.$Sc{constructor(a){super(),this.f=new N.$Sd,this.onMessage=this.f.event,this.g=new N.$Sd,this.onDidDispose=this.g.event,this.a=a,this.b=this.B(new s(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(h=>{h.type===1&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(a){this.b.write(new l(1,0,0,a))}}e.$Nh=i;class n extends I.$Hh{static fromSocket(a,h){return new n(new i(a),h)}get onDidDispose(){return this.b.onDidDispose}constructor(a,h,S=null){super(a,h,S),this.b=a}dispose(){super.dispose();const a=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),a.end()}}e.$Oh=n;class o{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$Sd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(a){this.b?this.d.length>0?this.d.push(a):this.a.fire(a):this.d.push(a)}flushBuffer(){this.d=[]}}e.$Ph=o;class c{constructor(a){this.data=a,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let a=0,h=this.a;for(;h;)h=h.next,a++;return a}peek(){return this.a?this.a.data:null}toArray(){const a=[];let h=0,S=this.a;for(;S;)a[h++]=S.data,S=S.next;return a}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(a){const h=new c(a);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class r{static{this.a=10}static{this.b=null}static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const a=Date.now();for(let h=0;h<r.a;h++)this.c[h]=a-1e3*h;setInterval(()=>{for(let h=r.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const a=Date.now(),h=(1+r.a)*1e3;let S=0;for(let P=0;P<r.a;P++)a-this.c[P]<=h&&S++;return 1-S/r.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.c-this.d}constructor(a){this.u=new o,this.onControlMessage=this.u.event,this.v=new o,this.onMessage=this.v.event,this.w=new o,this.onDidDispose=this.w.event,this.x=new o,this.onSocketClose=this.x.event,this.y=new o,this.onSocketTimeout=this.y.event,this.s=a.loadEstimator??r.getInstance(),this.t=a.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new g.$Rc,this.o=a.socket,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(h=>this.z(h))),this.r.add(this.o.onClose(h=>this.x.fire(h))),a.initialChunk&&this.q.acceptChunk(a.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const a=new l(5,0,0,A());this.p.write(a),this.p.flush()}sendPause(){const a=new l(7,0,0,A());this.p.write(a)}sendResume(){const a=new l(8,0,0,A());this.p.write(a)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(a,h){this.a=!0,this.r.dispose(),this.r=new g.$Rc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=a,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(S=>this.z(S))),this.r.add(this.o.onClose(S=>this.x.fire(S))),this.q.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.h=this.g;const a=new l(3,0,this.h,A());this.p.write(a);const h=this.b.toArray();for(let S=0,P=h.length;S<P;S++)this.p.write(h[S]);this.B()}acceptDisconnect(){this.w.fire()}z(a){if(a.ack>this.d){this.d=a.ack;do{const h=this.b.peek();if(h&&h.id<=a.ack)this.b.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this.g)if(a.id!==this.g+1){const h=Date.now();h-this.m>1e4&&(this.m=h,this.p.write(new l(6,0,0,A())))}else this.g=a.id,this.j=Date.now(),this.A(),this.v.fire(a.data);break}case 2:{this.u.fire(a.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const h=this.b.toArray();for(let S=0,P=h.length;S<P;S++)this.p.write(h[S]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(a){const h=++this.c;this.h=this.g;const S=new l(1,h,this.h,a);this.b.push(S),this.a||(this.p.write(S),this.B())}sendControl(a){const h=new l(2,0,0,a);this.p.write(h)}A(){if(this.g<=this.h||this.k)return;const a=Date.now()-this.j;if(a>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-a+5)}B(){if(this.c<=this.d||this.f||this.a)return;const a=this.b.peek(),h=Date.now()-a.writtenTime,S=Date.now()-this.q.lastReadTime,P=Date.now()-this.n;if(h>=2e4&&S>=2e4&&P>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:S});return}const w=Math.max(2e4-h,2e4-S,2e4-P,500);this.f=setTimeout(()=>{this.f=null,this.B()},w)}C(){if(this.g<=this.h)return;this.h=this.g;const a=new l(3,0,this.h,A());this.p.write(a)}D(){this.h=this.g;const a=new l(9,0,this.h,A());this.p.write(a)}}e.$Qh=d}),define(Se[187],ke([1,0,51,11,22,21,185,14,4,3,24,104,101,81]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=void 0;class k extends v.$Eh{constructor(s){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",i=>g.$ge.wrap(Buffer.from(i,"base64")))},s),process.once("disconnect",()=>this.dispose())}}e.$eq=k;class l{constructor(s,i){this.i=s,this.j=i,this.c=new Set,this.g=new Map,this.h=new $.$Sd,this.onDidProcessExit=this.h.event;const n=i&&i.timeout?i.timeout:6e4;this.b=new N.$Zg(n),this.d=null,this.f=null}getChannel(s){const i=this;return{call(n,o,c){return i.k(s,n,o,c)},listen(n,o){return i.l(s,n,o)}}}k(s,i,n,o=I.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const c=this.n(s),t=(0,N.$Qg)(u=>c.call(i,n,u)),r=o.onCancellationRequested(()=>t.cancel()),d=(0,y.$Qc)(()=>t.cancel());return this.c.add(d),t.finally(()=>{r.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(s,i,n){if(!this.b)return $.Event.None;this.b.cancel();let o;const c=new $.$Sd({onWillAddFirstListener:()=>{o=this.n(s).listen(i,n)(c.fire,c),this.c.add(o)},onDidRemoveLastListener:()=>{this.c.delete(o),o.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return c.event}get m(){if(!this.f){const s=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,A.$jn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a)).filter(a=>!a.startsWith("--vscode-"))),(0,m.$Pl)(i.env),this.d=(0,D.fork)(this.i,s,i);const n=new $.$Sd;$.Event.fromNodeEventEmitter(this.d,"message",a=>a)(a=>{if((0,R.$aq)(a)){(0,R.log)(a,`IPC Library: ${this.j.serverName}`);return}n.fire(g.$ge.wrap(Buffer.from(a,"base64")))});const c=this.j.useQueue?(0,C.$Rl)(this.d):this.d,t=a=>this.d&&this.d.connected&&c.send(a.buffer.toString("base64")),r=n.event,d={send:t,onMessage:r};this.f=new v.$Fh(d);const u=()=>this.o();process.once("exit",u),this.d.on("error",a=>console.warn('IPC "'+this.j.serverName+'" errored with '+a)),this.d.on("exit",(a,h)=>{process.removeListener("exit",u),this.c.forEach(S=>(0,y.$Nc)(S)),this.c.clear(),a!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+a+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:a,signal:h})})}return this.f}n(s){let i=this.g.get(s);return i||(i=this.m.getChannel(s),this.g.set(s,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$fq=l}),define(Se[188],ke([1,0,11,4,3,55,18]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.StorageState=e.$dp=e.StorageHint=void 0;var b;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function $(m){const v=m;return v?.changed instanceof Map||v?.deleted instanceof Set}e.$dp=$;var y;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(y||(e.StorageState=y={}));class A extends g.$Sc{static{this.a=100}constructor(v,k=Object.create(null)){super(),this.r=v,this.s=k,this.b=this.B(new N.$Vd),this.onDidChangeStorage=this.b.event,this.c=y.None,this.f=new Map,this.g=this.B(new D.$1g(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(v=>this.u(v)))}u(v){this.b.pause();try{v.changed?.forEach((k,l)=>this.w(l,k)),v.deleted?.forEach(k=>this.w(k,void 0))}finally{this.b.resume()}}w(v,k){if(this.c===y.Closed)return;let l=!1;(0,R.$Of)(k)?l=this.f.delete(v):this.f.get(v)!==k&&(this.f.set(v,k),l=!0),l&&this.b.fire({key:v,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===y.None&&(this.c=y.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(v,k){const l=this.f.get(v);return(0,R.$Of)(l)?k:l}getBoolean(v,k){const l=this.get(v);return(0,R.$Of)(l)?k:l==="true"}getNumber(v,k){const l=this.get(v);return(0,R.$Of)(l)?k:parseInt(l,10)}getObject(v,k){const l=this.get(v);return(0,R.$Of)(l)?k:(0,I.$yh)(l)}async set(v,k,l=!1){if(this.c===y.Closed)return;if((0,R.$Of)(k))return this.delete(v,l);const f=(0,R.$Hf)(k)||Array.isArray(k)?(0,I.$xh)(k):String(k);if(this.f.get(v)!==f)return this.f.set(v,f),this.j.set(v,f),this.h.delete(v),this.b.fire({key:v,external:l}),this.D()}async delete(v,k=!1){if(!(this.c===y.Closed||!this.f.delete(v)))return this.h.has(v)||this.h.add(v),this.j.delete(v),this.b.fire({key:v,external:k}),this.D()}async optimize(){if(this.c!==y.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=y.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const v={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(v).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(v){if(this.z)return this.D(v)}async D(v){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),v)}async whenFlushed(){if(this.z)return new Promise(v=>this.n.push(v))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$ep=A;class C{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(v){v.insert?.forEach((k,l)=>this.a.set(l,k)),v.delete?.forEach(k=>this.a.delete(k))}async optimize(){}async close(){}}e.$fp=C}),define(Se[189],ke([1,0,12,10,22]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=e.$2s=e.$1s=void 0;let I;function R(){return I||(I=new TextDecoder("UTF-16LE")),I}let b;function $(){return b||(b=new TextDecoder("UTF-16BE")),b}let y;function A(){return y||(y=N.$D()?R():$()),y}e.$1s=A;function C(k,l,f){const s=new Uint16Array(k.buffer,l,f);return f>0&&(s[0]===65279||s[0]===65534)?m(k,l,f):R().decode(s)}e.$2s=C;function m(k,l,f){const s=[];let i=0;for(let n=0;n<f;n++){const o=g.$ie(k,l);l+=2,s[i++]=String.fromCharCode(o)}return s.join("")}class v{constructor(l){this.a=l|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const l=new Uint16Array(this.b.buffer,0,this.d);return A().decode(l)}f(){const l=this.e();this.d=0,this.c===null?this.c=[l]:this.c[this.c.length]=l}appendCharCode(l){const f=this.a-this.d;f<=1&&(f===0||D.$af(l))&&this.f(),this.b[this.d++]=l}appendASCIICharCode(l){this.d===this.a&&this.f(),this.b[this.d++]=l}appendString(l){const f=l.length;if(this.d+f>=this.a){this.f(),this.c[this.c.length]=l;return}for(let s=0;s<f;s++)this.b[this.d++]=l.charCodeAt(s)}}e.$3s=v}),define(Se[190],ke([1,0,22,189]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5s=e.$4s=void 0;function g($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class I{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(y,A,C,m){this.oldPosition=y,this.oldText=A,this.newPosition=C,this.newText=m}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${g(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${g(this.oldText)}")`:`(replace@${this.oldPosition} "${g(this.oldText)}" with "${g(this.newText)}")`}static a(y){return 4+2*y.length}static c(y,A,C){const m=A.length;D.$le(y,m,C),C+=4;for(let v=0;v<m;v++)D.$je(y,A.charCodeAt(v),C),C+=2;return C}static d(y,A){const C=D.$ke(y,A);return A+=4,(0,N.$2s)(y,A,C)}writeSize(){return 4+4+I.a(this.oldText)+I.a(this.newText)}write(y,A){return D.$le(y,this.oldPosition,A),A+=4,D.$le(y,this.newPosition,A),A+=4,A=I.c(y,this.oldText,A),A=I.c(y,this.newText,A),A}static read(y,A,C){const m=D.$ke(y,A);A+=4;const v=D.$ke(y,A);A+=4;const k=I.d(y,A);A+=I.a(k);const l=I.d(y,A);return A+=I.a(l),C.push(new I(m,k,v,l)),A}}e.$4s=I;function R($,y){return $===null||$.length===0?y:new b($,y).compress()}e.$5s=R;class b{constructor(y,A){this.a=y,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let y=0,A=0,C=this.n(y),m=this.l(A);for(;y<this.f||A<this.h;){if(C===null){this.k(m),m=this.l(++A);continue}if(m===null){this.m(C),C=this.n(++y);continue}if(m.oldEnd<=C.newPosition){this.k(m),m=this.l(++A);continue}if(C.newEnd<=m.oldPosition){this.m(C),C=this.n(++y);continue}if(m.oldPosition<C.newPosition){const[s,i]=b.r(m,C.newPosition-m.oldPosition);this.k(s),m=i;continue}if(C.newPosition<m.oldPosition){const[s,i]=b.q(C,m.oldPosition-C.newPosition);this.m(s),C=i;continue}let l,f;if(m.oldEnd===C.newEnd)l=C,f=m,C=this.n(++y),m=this.l(++A);else if(m.oldEnd<C.newEnd){const[s,i]=b.q(C,m.oldLength);l=s,f=m,C=i,m=this.l(++A)}else{const[s,i]=b.r(m,C.newLength);l=C,f=s,C=this.n(++y),m=i}this.d[this.e++]=new I(l.oldPosition,l.oldText,f.newPosition,f.newText),this.g+=l.newLength-l.oldLength,this.j+=f.newLength-f.oldLength}const v=b.s(this.d);return b.t(v)}k(y){this.d[this.e++]=b.o(this.g,y),this.j+=y.newLength-y.oldLength}l(y){return y<this.h?this.c[y]:null}m(y){this.d[this.e++]=b.p(this.j,y),this.g+=y.newLength-y.oldLength}n(y){return y<this.f?this.a[y]:null}static o(y,A){return new I(A.oldPosition-y,A.oldText,A.newPosition,A.newText)}static p(y,A){return new I(A.oldPosition,A.oldText,A.newPosition+y,A.newText)}static q(y,A){const C=y.newText.substr(0,A),m=y.newText.substr(A);return[new I(y.oldPosition,y.oldText,y.newPosition,C),new I(y.oldEnd,"",y.newPosition+A,m)]}static r(y,A){const C=y.oldText.substr(0,A),m=y.oldText.substr(A);return[new I(y.oldPosition,C,y.newPosition,y.newText),new I(y.oldPosition+A,m,y.newEnd,"")]}static s(y){if(y.length===0)return y;const A=[];let C=0,m=y[0];for(let v=1;v<y.length;v++){const k=y[v];m.oldEnd===k.oldPosition?m=new I(m.oldPosition,m.oldText+k.oldText,m.newPosition,m.newText+k.newText):(A[C++]=m,m=k)}return A[C++]=m,A}static t(y){if(y.length===0)return y;const A=[];let C=0;for(let m=0;m<y.length;m++){const v=y[m];v.oldText!==v.newText&&(A[C++]=v)}return A}}}),define(Se[191],ke([1,0,34,16]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pt=void 0;function g(I,R,b,$,y,A){if(Array.isArray(I)){let C=0;for(const m of I){const v=g(m,R,b,$,y,A);if(v===10)return v;v>C&&(C=v)}return C}else{if(typeof I=="string")return $?I==="*"?5:I===b?10:0:0;if(I){const{language:C,pattern:m,scheme:v,hasAccessToAllModels:k,notebookType:l}=I;if(!$&&!k)return 0;l&&y&&(R=y);let f=0;if(v)if(v===R.scheme)f=10;else if(v==="*")f=5;else return 0;if(C)if(C===b)f=10;else if(C==="*")f=Math.max(f,5);else return 0;if(l)if(l===A)f=10;else if(l==="*"&&A!==void 0)f=Math.max(f,5);else return 0;if(m){let s;if(typeof m=="string"?s=m:s={...m,base:(0,N.$hc)(m.base)},s===R.fsPath||(0,D.$Ij)(s,R.fsPath))f=10;else return 0}return f}else return 0}}e.$pt=g}),define(Se[192],ke([1,0,4,12,29,79,127,167,190,3]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZB=void 0;class A extends y.$Sc{constructor(m,v,k,l,f,s,i){super(),this.m=this.B(new D.$Sd),this.onDidChangeContent=this.m.event,this.f=v,this.j=!s,this.g=l,this.h=f,this.c=new R.$YB(m,k,i)}equals(m){return!(m instanceof A)||this.f!==m.f||this.getEOL()!==m.getEOL()?!1:this.c.equal(m.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(m){return this.c.createSnapshot(m?this.f:"")}getOffsetAt(m,v){return this.c.getOffsetAt(m,v)}getPositionAt(m){return this.c.getPositionAt(m)}getRangeAt(m,v){const k=m+v,l=this.getPositionAt(m),f=this.getPositionAt(k);return new g.$Is(l.lineNumber,l.column,f.lineNumber,f.column)}getValueInRange(m,v=0){if(m.isEmpty())return"";const k=this.n(v);return this.c.getValueInRange(m,k)}getValueLengthInRange(m,v=0){if(m.isEmpty())return 0;if(m.startLineNumber===m.endLineNumber)return m.endColumn-m.startColumn;const k=this.getOffsetAt(m.startLineNumber,m.startColumn),l=this.getOffsetAt(m.endLineNumber,m.endColumn);let f=0;const s=this.n(v),i=this.getEOL();if(s.length!==i.length){const n=s.length-i.length,o=m.endLineNumber-m.startLineNumber;f=n*o}return l-k+f}getCharacterCountInRange(m,v=0){if(this.j){let k=0;const l=m.startLineNumber,f=m.endLineNumber;for(let s=l;s<=f;s++){const i=this.getLineContent(s),n=s===l?m.startColumn-1:0,o=s===f?m.endColumn-1:i.length;for(let c=n;c<o;c++)N.$af(i.charCodeAt(c))?(k=k+1,c=c+1):k=k+1}return k+=this.n(v).length*(f-l),k}return this.getValueLengthInRange(m,v)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(m){return this.c.getLineContent(m)}getLineCharCode(m,v){return this.c.getLineCharCode(m,v)}getCharCode(m){return this.c.getCharCode(m)}getLineLength(m){return this.c.getLineLength(m)}getLineMinColumn(m){return 1}getLineMaxColumn(m){return this.getLineLength(m)+1}getLineFirstNonWhitespaceColumn(m){const v=N.$Xe(this.getLineContent(m));return v===-1?0:v+1}getLineLastNonWhitespaceColumn(m){const v=N.$Ze(this.getLineContent(m));return v===-1?0:v+2}n(m){switch(m){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(m){this.c.setEOL(m)}applyEdits(m,v,k){let l=this.g,f=this.h,s=this.j,i=!0,n=[];for(let a=0;a<m.length;a++){const h=m[a];i&&h._isTracked&&(i=!1);const S=h.range;if(h.text){let L=!0;s||(L=!N.$lf(h.text),s=L),!l&&L&&(l=N.$kf(h.text)),!f&&L&&(f=N.$nf(h.text))}let P="",w=0,p=0,E=0;if(h.text){let L;[w,p,E,L]=(0,b.$it)(h.text);const T=this.getEOL();L===0||L===(T===`\r
`?2:1)?P=h.text:P=h.text.replace(/\r\n|\r|\n/g,T)}n[a]={sortIndex:a,identifier:h.identifier||null,range:S,rangeOffset:this.getOffsetAt(S.startLineNumber,S.startColumn),rangeLength:this.getValueLengthInRange(S),text:P,eolCount:w,firstLineLength:p,lastLineLength:E,forceMoveMarkers:!!h.forceMoveMarkers,isAutoWhitespaceEdit:h.isAutoWhitespaceEdit||!1}}n.sort(A.u);let o=!1;for(let a=0,h=n.length-1;a<h;a++){const S=n[a].range.getEndPosition(),P=n[a+1].range.getStartPosition();if(P.isBeforeOrEqual(S)){if(P.isBefore(S))throw new Error("Overlapping ranges are not allowed!");o=!0}}i&&(n=this.s(n));const c=k||v?A._getInverseEditRanges(n):[],t=[];if(v)for(let a=0;a<n.length;a++){const h=n[a],S=c[a];if(h.isAutoWhitespaceEdit&&h.range.isEmpty())for(let P=S.startLineNumber;P<=S.endLineNumber;P++){let w="";P===S.startLineNumber&&(w=this.getLineContent(h.range.startLineNumber),N.$Xe(w)!==-1)||t.push({lineNumber:P,oldContent:w})}}let r=null;if(k){let a=0;r=[];for(let h=0;h<n.length;h++){const S=n[h],P=c[h],w=this.getValueInRange(S.range),p=S.rangeOffset+a;a+=S.text.length-w.length,r[h]={sortIndex:S.sortIndex,identifier:S.identifier,range:P,text:w,textChange:new $.$4s(S.rangeOffset,w,p,S.text)}}o||r.sort((h,S)=>h.sortIndex-S.sortIndex)}this.g=l,this.h=f,this.j=s;const d=this.t(n);let u=null;if(v&&t.length>0){t.sort((a,h)=>h.lineNumber-a.lineNumber),u=[];for(let a=0,h=t.length;a<h;a++){const S=t[a].lineNumber;if(a>0&&t[a-1].lineNumber===S)continue;const P=t[a].oldContent,w=this.getLineContent(S);w.length===0||w===P||N.$Xe(w)!==-1||u.push(S)}}return this.m.fire(),new I.$5u(r,d,u)}s(m){return m.length<1e3?m:[this._toSingleEditOperation(m)]}_toSingleEditOperation(m){let v=!1;const k=m[0].range,l=m[m.length-1].range,f=new g.$Is(k.startLineNumber,k.startColumn,l.endLineNumber,l.endColumn);let s=k.startLineNumber,i=k.startColumn;const n=[];for(let d=0,u=m.length;d<u;d++){const a=m[d],h=a.range;v=v||a.forceMoveMarkers,n.push(this.getValueInRange(new g.$Is(s,i,h.startLineNumber,h.startColumn))),a.text.length>0&&n.push(a.text),s=h.endLineNumber,i=h.endColumn}const o=n.join(""),[c,t,r]=(0,b.$it)(o);return{sortIndex:0,identifier:m[0].identifier,range:f,rangeOffset:this.getOffsetAt(f.startLineNumber,f.startColumn),rangeLength:this.getValueLengthInRange(f,0),text:o,eolCount:c,firstLineLength:t,lastLineLength:r,forceMoveMarkers:v,isAutoWhitespaceEdit:!1}}t(m){m.sort(A.w);const v=[];for(let k=0;k<m.length;k++){const l=m[k],f=l.range.startLineNumber,s=l.range.startColumn,i=l.range.endLineNumber,n=l.range.endColumn;if(f===i&&s===n&&l.text.length===0)continue;l.text?(this.c.delete(l.rangeOffset,l.rangeLength),this.c.insert(l.rangeOffset,l.text,!0)):this.c.delete(l.rangeOffset,l.rangeLength);const o=new g.$Is(f,s,i,n);v.push({range:o,rangeLength:l.rangeLength,text:l.text,rangeOffset:l.rangeOffset,forceMoveMarkers:l.forceMoveMarkers})}return v}findMatchesLineByLine(m,v,k,l){return this.c.findMatchesLineByLine(m,v,k,l)}getPieceTree(){return this.c}static _getInverseEditRange(m,v){const k=m.startLineNumber,l=m.startColumn,[f,s,i]=(0,b.$it)(v);let n;if(v.length>0){const o=f+1;o===1?n=new g.$Is(k,l,k,l+s):n=new g.$Is(k,l,k+o-1,i+1)}else n=new g.$Is(k,l,k,l);return n}static _getInverseEditRanges(m){const v=[];let k=0,l=0,f=null;for(let s=0,i=m.length;s<i;s++){const n=m[s];let o,c;f?f.range.endLineNumber===n.range.startLineNumber?(o=k,c=l+(n.range.startColumn-f.range.endColumn)):(o=k+(n.range.startLineNumber-f.range.endLineNumber),c=n.range.startColumn):(o=n.range.startLineNumber,c=n.range.startColumn);let t;if(n.text.length>0){const r=n.eolCount+1;r===1?t=new g.$Is(o,c,o,c+n.firstLineLength):t=new g.$Is(o,c,o+r-1,n.lastLineLength+1)}else t=new g.$Is(o,c,o,c);k=t.endLineNumber,l=t.endColumn,v.push(t),f=n}return v}static u(m,v){const k=g.$Is.compareRangesUsingEnds(m.range,v.range);return k===0?m.sortIndex-v.sortIndex:k}static w(m,v){const k=g.$Is.compareRangesUsingEnds(m.range,v.range);return k===0?v.sortIndex-m.sortIndex:-k}}e.$ZB=A}),define(Se[193],ke([1,0,12,127,192]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1B=void 0;class I{constructor($,y,A,C,m,v,k,l,f){this.a=$,this.b=y,this.c=A,this.d=C,this.e=m,this.f=v,this.g=k,this.h=l,this.j=f}k($){const y=this.c+this.d+this.e,A=this.c+this.e;return y===0?$===1?`
`:`\r
`:A>y/2?`\r
`:`
`}create($){const y=this.k($),A=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let m=0,v=A.length;m<v;m++){const k=A[m].buffer.replace(/\r\n|\r|\n/g,y),l=(0,N.$UB)(k);A[m]=new N.$XB(k,l)}const C=new g.$ZB(A,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&D.$tf($)&&(this.b=D.$sf,$=$.substr(1));const y=$.charCodeAt($.length-1);y===13||y>=55296&&y<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=y):(this.m($,!1),this.c=!1,this.d=y)}m($,y){!y&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const y=(0,N.$VB)(this.e,$);this.a.push(new N.$XB($,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=D.$kf($)),this.k||(this.k=D.$nf($)))}finish($=!0){return this.o(),new I(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const y=(0,N.$UB)($.buffer);$.lineStarts=y,this.d===13&&this.f++}}}e.$1B=R}),define(Se[131],ke([1,0,22,10]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k$=e.$j$=void 0;var g;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(g||(g={}));function I(C){for(let m=0,v=C.length;m<v;m+=4){const k=C[m+0],l=C[m+1],f=C[m+2],s=C[m+3];C[m+0]=s,C[m+1]=f,C[m+2]=l,C[m+3]=k}}function R(C){const m=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return N.$D()||I(m),D.$ge.wrap(m)}function b(C){const m=C.buffer;if(N.$D()||I(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const v=new Uint8Array(m.byteLength);return v.set(m),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function $(C){const m=new Uint32Array(y(C));let v=0;if(m[v++]=C.id,C.type==="full")m[v++]=1,m[v++]=C.data.length,m.set(C.data,v),v+=C.data.length;else{m[v++]=2,m[v++]=C.deltas.length;for(const k of C.deltas)m[v++]=k.start,m[v++]=k.deleteCount,k.data?(m[v++]=k.data.length,m.set(k.data,v),v+=k.data.length):m[v++]=0}return R(m)}e.$j$=$;function y(C){let m=0;if(m+=1+1,C.type==="full")m+=1+C.data.length;else{m+=1,m+=(1+1+1)*C.deltas.length;for(const v of C.deltas)v.data&&(m+=v.data.length)}return m}function A(C){const m=b(C);let v=0;const k=m[v++];if(m[v++]===1){const i=m[v++],n=m.subarray(v,v+i);return v+=i,{id:k,type:"full",data:n}}const f=m[v++],s=[];for(let i=0;i<f;i++){const n=m[v++],o=m[v++],c=m[v++];let t;c>0&&(t=m.subarray(v,v+c),v+=c),s[i]={start:n,deleteCount:o,data:t}}return{id:k,type:"delta",deltas:s}}e.$k$=A}),define(Se[194],ke([8,9]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(Se[132],ke([1,0,19,24,10,170,126,194]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var $;(function(ne){ne[ne.None=0]="None",ne[ne.Keep=1]="Keep",ne[ne.Brackets=2]="Brackets",ne[ne.Advanced=3]="Advanced",ne[ne.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(ae){this.c=ae}hasChanged(ae){return this.c[ae]}}e.ConfigurationChangedEvent=y;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class C{constructor(ae,Ie,Ve,Ze){this.id=ae,this.name=Ie,this.defaultValue=Ve,this.schema=Ze}applyUpdate(ae,Ie){return v(ae,Ie)}compute(ae,Ie,Ve){return Ve}}class m{constructor(ae,Ie){this.newValue=ae,this.didChange=Ie}}e.ApplyUpdateResult=m;function v(ne,ae){if(typeof ne!="object"||typeof ae!="object"||!ne||!ae)return new m(ae,ne!==ae);if(Array.isArray(ne)||Array.isArray(ae)){const Ve=Array.isArray(ne)&&Array.isArray(ae)&&D.$ub(ne,ae);return new m(ae,!Ve)}let Ie=!1;for(const Ve in ae)if(ae.hasOwnProperty(Ve)){const Ze=v(ne[Ve],ae[Ve]);Ze.didChange&&(ne[Ve]=Ze.newValue,Ie=!0)}return new m(ne,Ie)}class k{constructor(ae){this.schema=void 0,this.id=ae,this.name="_never_",this.defaultValue=void 0}applyUpdate(ae,Ie){return v(ae,Ie)}validate(ae){return this.defaultValue}}class l{constructor(ae,Ie,Ve,Ze){this.id=ae,this.name=Ie,this.defaultValue=Ve,this.schema=Ze}applyUpdate(ae,Ie){return v(ae,Ie)}validate(ae){return typeof ae>"u"?this.defaultValue:ae}compute(ae,Ie,Ve){return Ve}}function f(ne,ae){return typeof ne>"u"?ae:ne==="false"?!1:!!ne}e.boolean=f;class s extends l{constructor(ae,Ie,Ve,Ze=void 0){typeof Ze<"u"&&(Ze.type="boolean",Ze.default=Ve),super(ae,Ie,Ve,Ze)}validate(ae){return f(ae,this.defaultValue)}}function i(ne,ae,Ie,Ve){if(typeof ne>"u")return ae;let Ze=parseInt(ne,10);return isNaN(Ze)?ae:(Ze=Math.max(Ie,Ze),Ze=Math.min(Ve,Ze),Ze|0)}e.clampedInt=i;class n extends l{static clampedInt(ae,Ie,Ve,Ze){return i(ae,Ie,Ve,Ze)}constructor(ae,Ie,Ve,Ze,nt,it=void 0){typeof it<"u"&&(it.type="integer",it.default=Ve,it.minimum=Ze,it.maximum=nt),super(ae,Ie,Ve,it),this.minimum=Ze,this.maximum=nt}validate(ae){return n.clampedInt(ae,this.defaultValue,this.minimum,this.maximum)}}function o(ne,ae,Ie,Ve){if(typeof ne>"u")return ae;const Ze=c.float(ne,ae);return c.clamp(Ze,Ie,Ve)}e.clampedFloat=o;class c extends l{static clamp(ae,Ie,Ve){return ae<Ie?Ie:ae>Ve?Ve:ae}static float(ae,Ie){if(typeof ae=="number")return ae;if(typeof ae>"u")return Ie;const Ve=parseFloat(ae);return isNaN(Ve)?Ie:Ve}constructor(ae,Ie,Ve,Ze,nt){typeof nt<"u"&&(nt.type="number",nt.default=Ve),super(ae,Ie,Ve,nt),this.validationFn=Ze}validate(ae){return this.validationFn(c.float(ae,this.defaultValue))}}class t extends l{static string(ae,Ie){return typeof ae!="string"?Ie:ae}constructor(ae,Ie,Ve,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.default=Ve),super(ae,Ie,Ve,Ze)}validate(ae){return t.string(ae,this.defaultValue)}}function r(ne,ae,Ie,Ve){return typeof ne!="string"?ae:Ve&&ne in Ve?Ve[ne]:Ie.indexOf(ne)===-1?ae:ne}e.stringSet=r;class d extends l{constructor(ae,Ie,Ve,Ze,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=Ze,nt.default=Ve),super(ae,Ie,Ve,nt),this.c=Ze}validate(ae){return r(ae,this.defaultValue,this.c)}}class u extends C{constructor(ae,Ie,Ve,Ze,nt,it,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.enum=nt,Oe.default=Ze),super(ae,Ie,Ve,Oe),this.c=nt,this.d=it}validate(ae){return typeof ae!="string"?this.defaultValue:this.c.indexOf(ae)===-1?this.defaultValue:this.d(ae)}}function a(ne){switch(ne){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(ae){switch(ae){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ae,Ie,Ve){return Ve===0?ae.accessibilitySupport:Ve}}class S extends C{constructor(){const ae={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ae,{"editor.comments.insertSpace":{type:"boolean",default:ae.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ae.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{insertSpace:f(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:f(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var P;(function(ne){ne[ne.Hidden=0]="Hidden",ne[ne.Blink=1]="Blink",ne[ne.Smooth=2]="Smooth",ne[ne.Phase=3]="Phase",ne[ne.Expand=4]="Expand",ne[ne.Solid=5]="Solid"})(P||(e.TextEditorCursorBlinkingStyle=P={}));function w(ne){switch(ne){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(ne){ne[ne.Line=1]="Line",ne[ne.Block=2]="Block",ne[ne.Underline=3]="Underline",ne[ne.LineThin=4]="LineThin",ne[ne.BlockOutline=5]="BlockOutline",ne[ne.UnderlineThin=6]="UnderlineThin"})(p||(e.TextEditorCursorStyle=p={}));function E(ne){switch(ne){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function L(ne){switch(ne){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class T extends k{constructor(){super(140)}compute(ae,Ie,Ve){const Ze=["monaco-editor"];return Ie.get(39)&&Ze.push(Ie.get(39)),ae.extraEditorClassName&&Ze.push(ae.extraEditorClassName),Ie.get(73)==="default"?Ze.push("mouse-default"):Ie.get(73)==="copy"&&Ze.push("mouse-copy"),Ie.get(110)&&Ze.push("showUnused"),Ie.get(138)&&Ze.push("showDeprecated"),Ze.join(" ")}}class U extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ae,Ie,Ve){return Ve&&ae.emptySelectionClipboard}}class F extends C{constructor(){const ae={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ae,{"editor.find.cursorMoveOnType":{type:"boolean",default:ae.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ae.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ae.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ae.globalFindClipboard,description:b.localize(16,null),included:g.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ae.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:ae.loop,description:b.localize(18,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{cursorMoveOnType:f(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ae.seedSearchStringFromSelection=="boolean"?ae.seedSearchStringFromSelection?"always":"never":r(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ae.autoFindInSelection=="boolean"?ae.autoFindInSelection?"always":"never":r(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:f(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:f(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:f(Ie.loop,this.defaultValue.loop)}}}class j extends C{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",j.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(ae){return typeof ae>"u"?this.defaultValue:typeof ae=="string"?ae==="false"||ae.length===0?j.OFF:ae==="true"?j.ON:ae:ae?j.ON:j.OFF}}e.EditorFontLigatures=j;class O extends C{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",O.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(ae){return typeof ae>"u"?this.defaultValue:typeof ae=="string"?ae==="false"?O.OFF:ae==="true"?O.TRANSLATE:ae:ae?O.TRANSLATE:O.OFF}compute(ae,Ie,Ve){return ae.fontInfo.fontVariationSettings}}e.EditorFontVariations=O;class M extends k{constructor(){super(50)}compute(ae,Ie,Ve){return ae.fontInfo}}class W extends l{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(ae){const Ie=c.float(ae,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(Ie,6,100)}compute(ae,Ie,Ve){return ae.fontInfo.fontSize}}class Y extends C{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Y.d,maximum:Y.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Y.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(ae){return ae==="normal"||ae==="bold"?ae:String(n.clampedInt(ae,e.EDITOR_FONT_DEFAULTS.fontWeight,Y.d,Y.e))}}class ue extends C{constructor(){const ae={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:ae.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ae,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ae.alternativeDefinitionCommand,enum:Ve,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ae.alternativeTypeDefinitionCommand,enum:Ve,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ae.alternativeDeclarationCommand,enum:Ve,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ae.alternativeImplementationCommand,enum:Ve,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ae.alternativeReferenceCommand,enum:Ve,description:b.localize(41,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{multiple:r(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??r(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??r(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??r(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??r(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??r(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class X extends C{constructor(){const ae={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ae,{"editor.hover.enabled":{type:"boolean",default:ae.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:ae.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ae.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ae.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:ae.above,description:b.localize(46,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:f(Ie.enabled,this.defaultValue.enabled),delay:n.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:f(Ie.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:f(Ie.above,this.defaultValue.above)}}}var J;(function(ne){ne[ne.None=0]="None",ne[ne.Text=1]="Text",ne[ne.Blocks=2]="Blocks"})(J||(e.RenderMinimap=J={}));class x extends k{constructor(){super(143)}compute(ae,Ie,Ve){return x.computeLayout(Ie,{memory:ae.memory,outerWidth:ae.outerWidth,outerHeight:ae.outerHeight,isDominatedByLongLines:ae.isDominatedByLongLines,lineHeight:ae.fontInfo.lineHeight,viewLineCount:ae.viewLineCount,lineNumbersDigitCount:ae.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ae.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ae.fontInfo.maxDigitWidth,pixelRatio:ae.pixelRatio,glyphMarginDecorationLaneCount:ae.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ae){const Ie=ae.height/ae.lineHeight,Ve=Math.floor(ae.paddingTop/ae.lineHeight);let Ze=Math.floor(ae.paddingBottom/ae.lineHeight);ae.scrollBeyondLastLine&&(Ze=Math.max(Ze,Ie-1));const nt=(Ve+ae.viewLineCount+Ze)/(ae.pixelRatio*ae.height),it=Math.floor(ae.viewLineCount/nt);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:Ve,extraLinesBeyondLastLine:Ze,desiredRatio:nt,minimapLineCount:it}}static c(ae,Ie){const Ve=ae.outerWidth,Ze=ae.outerHeight,nt=ae.pixelRatio;if(!ae.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(nt*Ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ze};const it=Ie.stableMinimapLayoutInput,Oe=it&&ae.outerHeight===it.outerHeight&&ae.lineHeight===it.lineHeight&&ae.typicalHalfwidthCharacterWidth===it.typicalHalfwidthCharacterWidth&&ae.pixelRatio===it.pixelRatio&&ae.scrollBeyondLastLine===it.scrollBeyondLastLine&&ae.paddingTop===it.paddingTop&&ae.paddingBottom===it.paddingBottom&&ae.minimap.enabled===it.minimap.enabled&&ae.minimap.side===it.minimap.side&&ae.minimap.size===it.minimap.size&&ae.minimap.showSlider===it.minimap.showSlider&&ae.minimap.renderCharacters===it.minimap.renderCharacters&&ae.minimap.maxColumn===it.minimap.maxColumn&&ae.minimap.scale===it.minimap.scale&&ae.verticalScrollbarWidth===it.verticalScrollbarWidth&&ae.isViewportWrapping===it.isViewportWrapping,wt=ae.lineHeight,kt=ae.typicalHalfwidthCharacterWidth,Tt=ae.scrollBeyondLastLine,Wt=ae.minimap.renderCharacters;let Et=nt>=2?Math.round(ae.minimap.scale*2):ae.minimap.scale;const Kt=ae.minimap.maxColumn,Ot=ae.minimap.size,Zt=ae.minimap.side,Ut=ae.verticalScrollbarWidth,Lt=ae.viewLineCount,et=ae.remainingWidth,Gt=ae.isViewportWrapping,Jt=Wt?2:3;let ht=Math.floor(nt*Ze);const bt=ht/nt;let zt=!1,qt=!1,Dt=Jt*Et,ft=Et/nt,At=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:gt,extraLinesBeforeFirstLine:Nt,extraLinesBeyondLastLine:Fe,desiredRatio:Te,minimapLineCount:Ce}=x.computeContainedMinimapLineCount({viewLineCount:Lt,scrollBeyondLastLine:Tt,paddingTop:ae.paddingTop,paddingBottom:ae.paddingBottom,height:Ze,lineHeight:wt,pixelRatio:nt});if(Lt/Ce>1)zt=!0,qt=!0,Et=1,Dt=1,ft=Et/nt;else{let Ne=!1,qe=Et+1;if(Ot==="fit"){const xe=Math.ceil((Nt+Lt+Fe)*Dt);Gt&&Oe&&et<=Ie.stableFitRemainingWidth?(Ne=!0,qe=Ie.stableFitMaxMinimapScale):Ne=xe>ht}if(Ot==="fill"||Ne){zt=!0;const xe=Et;Dt=Math.min(wt*nt,Math.max(1,Math.floor(1/Te))),Gt&&Oe&&et<=Ie.stableFitRemainingWidth&&(qe=Ie.stableFitMaxMinimapScale),Et=Math.min(qe,Math.max(1,Math.floor(Dt/Jt))),Et>xe&&(At=Math.min(2,Et/xe)),ft=Et/nt/At,ht=Math.ceil(Math.max(gt,Nt+Lt+Fe)*Dt),Gt?(Ie.stableMinimapLayoutInput=ae,Ie.stableFitRemainingWidth=et,Ie.stableFitMaxMinimapScale=Et):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const xt=Math.floor(Kt*ft),Ct=Math.min(xt,Math.max(0,Math.floor((et-Ut-2)*ft/(kt+ft)))+e.MINIMAP_GUTTER_WIDTH);let Qe=Math.floor(nt*Ct);const Mt=Qe/nt;Qe=Math.floor(Qe*At);const Vt=Wt?1:2,Qt=Zt==="left"?0:Ve-Ct-Ut;return{renderMinimap:Vt,minimapLeft:Qt,minimapWidth:Ct,minimapHeightIsEditorHeight:zt,minimapIsSampling:qt,minimapScale:Et,minimapLineHeight:Dt,minimapCanvasInnerWidth:Qe,minimapCanvasInnerHeight:ht,minimapCanvasOuterWidth:Mt,minimapCanvasOuterHeight:bt}}static computeLayout(ae,Ie){const Ve=Ie.outerWidth|0,Ze=Ie.outerHeight|0,nt=Ie.lineHeight|0,it=Ie.lineNumbersDigitCount|0,Oe=Ie.typicalHalfwidthCharacterWidth,wt=Ie.maxDigitWidth,kt=Ie.pixelRatio,Tt=Ie.viewLineCount,Wt=ae.get(135),Et=Wt==="inherit"?ae.get(134):Wt,Kt=Et==="inherit"?ae.get(130):Et,Ot=ae.get(133),Zt=Ie.isDominatedByLongLines,Ut=ae.get(57),Lt=ae.get(67).renderType!==0,et=ae.get(68),Gt=ae.get(104),Jt=ae.get(83),ht=ae.get(72),bt=ae.get(102),zt=bt.verticalScrollbarSize,qt=bt.verticalHasArrows,Dt=bt.arrowSize,ft=bt.horizontalScrollbarSize,At=ae.get(43),xt=ae.get(109)!=="never";let Ct=ae.get(65);At&&xt&&(Ct+=16);let Qe=0;if(Lt){const st=Math.max(it,et);Qe=Math.round(st*wt)}let Mt=0;Ut&&(Mt=nt*Ie.glyphMarginDecorationLaneCount);let Vt=0,Qt=Vt+Mt,gt=Qt+Qe,Nt=gt+Ct;const Fe=Ve-Mt-Qe-Ct;let Te=!1,Ce=!1,se=-1;Et==="inherit"&&Zt?(Te=!0,Ce=!0):Kt==="on"||Kt==="bounded"?Ce=!0:Kt==="wordWrapColumn"&&(se=Ot);const Ne=x.c({outerWidth:Ve,outerHeight:Ze,lineHeight:nt,typicalHalfwidthCharacterWidth:Oe,pixelRatio:kt,scrollBeyondLastLine:Gt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:ht,verticalScrollbarWidth:zt,viewLineCount:Tt,remainingWidth:Fe,isViewportWrapping:Ce},Ie.memory||new A);Ne.renderMinimap!==0&&Ne.minimapLeft===0&&(Vt+=Ne.minimapWidth,Qt+=Ne.minimapWidth,gt+=Ne.minimapWidth,Nt+=Ne.minimapWidth);const qe=Fe-Ne.minimapWidth,xe=Math.max(1,Math.floor((qe-zt-2)/Oe)),Ke=qt?Dt:0;return Ce&&(se=Math.max(1,xe),Kt==="bounded"&&(se=Math.min(se,Ot))),{width:Ve,height:Ze,glyphMarginLeft:Vt,glyphMarginWidth:Mt,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Qt,lineNumbersWidth:Qe,decorationsLeft:gt,decorationsWidth:Ct,contentLeft:Nt,contentWidth:qe,minimap:Ne,viewportColumn:xe,isWordWrapMinified:Te,isViewportWrapping:Ce,wrappingColumn:se,verticalScrollbarWidth:zt,horizontalScrollbarHeight:ft,overviewRuler:{top:Ke,width:zt,height:Ze-2*Ke,right:0}}}}e.EditorLayoutInfoComputer=x;class he extends C{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(ae){return r(ae,"simple",["simple","advanced"])}compute(ae,Ie,Ve){return Ie.get(2)===2?"advanced":Ve}}var Z;(function(ne){ne.Off="off",ne.OnCode="onCode",ne.On="on"})(Z||(e.ShowLightbulbIconMode=Z={}));class we extends C{constructor(){const ae={enabled:Z.OnCode};super(64,"lightbulb",ae,{"editor.lightbulb.enabled":{type:"string",enum:[Z.Off,Z.OnCode,Z.On],default:ae.enabled,enumDescriptions:[b.localize(50,null),b.localize(51,null),b.localize(52,null)],description:b.localize(53,null)}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{enabled:r(ae.enabled,this.defaultValue.enabled,[Z.Off,Z.OnCode,Z.On])}}}class ce extends C{constructor(){const ae={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",ae,{"editor.stickyScroll.enabled":{type:"boolean",default:ae.enabled,description:b.localize(54,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ae.maxLineCount,minimum:1,maximum:10,description:b.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ae.defaultModel,description:b.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ae.scrollWithEditor,description:b.localize(57,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:f(Ie.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:f(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class K extends C{constructor(){const ae={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",ae,{"editor.inlayHints.enabled":{type:"string",default:ae.enabled,description:b.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(59,null),b.localize(60,null,g.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(61,null,g.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:ae.fontSize,markdownDescription:b.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ae.fontFamily,markdownDescription:b.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ae.padding,description:b.localize(65,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:r(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:f(Ie.padding,this.defaultValue.padding)}}}class B extends C{constructor(){super(65,"lineDecorationsWidth",10)}validate(ae){return typeof ae=="string"&&/^\d+(\.\d+)?ch$/.test(ae)?-parseFloat(ae.substring(0,ae.length-2)):n.clampedInt(ae,this.defaultValue,0,1e3)}compute(ae,Ie,Ve){return Ve<0?n.clampedInt(-Ve*ae.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ve}}class re extends c{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ae=>c.clamp(ae,0,150),{markdownDescription:b.localize(66,null)})}compute(ae,Ie,Ve){return ae.fontInfo.lineHeight}}class ye extends C{constructor(){const ae={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ae,{"editor.minimap.enabled":{type:"boolean",default:ae.enabled,description:b.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:ae.autohide,description:b.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(69,null),b.localize(70,null),b.localize(71,null)],default:ae.size,description:b.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ae.side,description:b.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ae.showSlider,description:b.localize(74,null)},"editor.minimap.scale":{type:"number",default:ae.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ae.renderCharacters,description:b.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:ae.maxColumn,description:b.localize(77,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:f(Ie.enabled,this.defaultValue.enabled),autohide:f(Ie.autohide,this.defaultValue.autohide),size:r(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(Ie.side,this.defaultValue.side,["right","left"]),showSlider:r(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:f(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(Ie.scale,1,1,3),maxColumn:n.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function de(ne){return ne==="ctrlCmd"?g.$j?"metaKey":"ctrlKey":"altKey"}class ge extends C{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(79,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{top:n.clampedInt(Ie.top,0,0,1e3),bottom:n.clampedInt(Ie.bottom,0,0,1e3)}}}class _ extends C{constructor(){const ae={enabled:!0,cycle:!0};super(85,"parameterHints",ae,{"editor.parameterHints.enabled":{type:"boolean",default:ae.enabled,description:b.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:ae.cycle,description:b.localize(81,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:f(Ie.enabled,this.defaultValue.enabled),cycle:f(Ie.cycle,this.defaultValue.cycle)}}}class ie extends k{constructor(){super(141)}compute(ae,Ie,Ve){return ae.pixelRatio}}class G extends C{constructor(){const ae={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(82,null),b.localize(83,null),b.localize(84,null)]}];super(88,"quickSuggestions",ae,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:ae.strings,description:b.localize(85,null)},comments:{anyOf:Ie,default:ae.comments,description:b.localize(86,null)},other:{anyOf:Ie,default:ae.other,description:b.localize(87,null)}},default:ae,markdownDescription:b.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ae}validate(ae){if(typeof ae=="boolean"){const kt=ae?"on":"off";return{comments:kt,strings:kt,other:kt}}if(!ae||typeof ae!="object")return this.defaultValue;const{other:Ie,comments:Ve,strings:Ze}=ae,nt=["on","inline","off"];let it,Oe,wt;return typeof Ie=="boolean"?it=Ie?"on":"off":it=r(Ie,this.defaultValue.other,nt),typeof Ve=="boolean"?Oe=Ve?"on":"off":Oe=r(Ve,this.defaultValue.comments,nt),typeof Ze=="boolean"?wt=Ze?"on":"off":wt=r(Ze,this.defaultValue.strings,nt),{other:it,comments:Oe,strings:wt}}}var te;(function(ne){ne[ne.Off=0]="Off",ne[ne.On=1]="On",ne[ne.Relative=2]="Relative",ne[ne.Interval=3]="Interval",ne[ne.Custom=4]="Custom"})(te||(e.RenderLineNumbersType=te={}));class fe extends C{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(89,null),b.localize(90,null),b.localize(91,null),b.localize(92,null)],default:"on",description:b.localize(93,null)})}validate(ae){let Ie=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof ae<"u"&&(typeof ae=="function"?(Ie=4,Ve=ae):ae==="interval"?Ie=3:ae==="relative"?Ie=2:ae==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:Ve}}}function ve(ne){const ae=ne.get(97);return ae==="editable"?ne.get(90):ae!=="on"}e.filterValidationDecorations=ve;class Pe extends C{constructor(){const ae=[],Ie={type:"number",description:b.localize(94,null)};super(101,"rulers",ae,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:b.localize(95,null),format:"color-hex"}}}]},default:ae,description:b.localize(96,null)})}validate(ae){if(Array.isArray(ae)){const Ie=[];for(const Ve of ae)if(typeof Ve=="number")Ie.push({column:n.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const Ze=Ve;Ie.push({column:n.clampedInt(Ze.column,0,0,1e4),color:Ze.color})}return Ie.sort((Ve,Ze)=>Ve.column-Ze.column),Ie}return this.defaultValue}}class be extends C{constructor(){super(91,"readOnlyMessage",void 0)}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:ae}}function De(ne,ae){if(typeof ne!="string")return ae;switch(ne){case"hidden":return 2;case"visible":return 3;default:return 1}}class z extends C{constructor(){const ae={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",ae,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(97,null),b.localize(98,null),b.localize(99,null)],default:"auto",description:b.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(101,null),b.localize(102,null),b.localize(103,null)],default:"auto",description:b.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ae.verticalScrollbarSize,description:b.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ae.horizontalScrollbarSize,description:b.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ae.scrollByPage,description:b.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ae.ignoreHorizontalScrollbarInContentHeight,description:b.localize(108,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae,Ve=n.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ze=n.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:De(Ie.vertical,this.defaultValue.vertical),horizontal:De(Ie.horizontal,this.defaultValue.horizontal),useShadows:f(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:f(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:f(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:f(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:f(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:n.clampedInt(Ie.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:Ze,verticalSliderSize:n.clampedInt(Ie.verticalSliderSize,Ze,0,1e3),scrollByPage:f(Ie.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:f(Ie.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends C{constructor(){const ae={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",ae,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.nonBasicASCII,description:b.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ae.invisibleCharacters,description:b.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ae.ambiguousCharacters,description:b.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeComments,description:b.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeStrings,description:b.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ae.allowedCharacters,description:b.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ae.allowedLocales,description:b.localize(115,null)}})}applyUpdate(ae,Ie){let Ve=!1;Ie.allowedCharacters&&ae&&(N.$nn(ae.allowedCharacters,Ie.allowedCharacters)||(ae={...ae,allowedCharacters:Ie.allowedCharacters},Ve=!0)),Ie.allowedLocales&&ae&&(N.$nn(ae.allowedLocales,Ie.allowedLocales)||(ae={...ae,allowedLocales:Ie.allowedLocales},Ve=!0));const Ze=super.applyUpdate(ae,Ie);return Ve?new m(Ze.newValue,!0):Ze}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{nonBasicASCII:le(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:f(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:f(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:le(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:le(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ae.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ae.allowedLocales,this.defaultValue.allowedLocales)}}c(ae,Ie){if(typeof ae!="object"||!ae)return Ie;const Ve={};for(const[Ze,nt]of Object.entries(ae))nt===!0&&(Ve[Ze]=!0);return Ve}}class ee extends C{constructor(){const ae={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ae,{"editor.inlineSuggest.enabled":{type:"boolean",default:ae.enabled,description:b.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ae.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(117,null),b.localize(118,null),b.localize(119,null)],description:b.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ae.suppressSuggestions,description:b.localize(121,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:f(Ie.enabled,this.defaultValue.enabled),mode:r(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:f(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:f(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class V extends C{constructor(){const ae={enabled:I.$fs.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:I.$fs.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ae,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ae.enabled,markdownDescription:b.localize(122,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ae.independentColorPoolPerBracketType,description:b.localize(123,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:f(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:f(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class oe extends C{constructor(){const ae={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ae,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(124,null),b.localize(125,null),b.localize(126,null)],default:ae.bracketPairs,description:b.localize(127,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(128,null),b.localize(129,null),b.localize(130,null)],default:ae.bracketPairsHorizontal,description:b.localize(131,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ae.highlightActiveBracketPair,description:b.localize(132,null)},"editor.guides.indentation":{type:"boolean",default:ae.indentation,description:b.localize(133,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(134,null),b.localize(135,null),b.localize(136,null)],default:ae.highlightActiveIndentation,description:b.localize(137,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{bracketPairs:le(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:le(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:f(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:f(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:le(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function le(ne,ae,Ie){const Ve=Ie.indexOf(ne);return Ve===-1?ae:Ie[Ve]}class Re extends C{constructor(){const ae={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",ae,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(138,null),b.localize(139,null)],default:ae.insertMode,description:b.localize(140,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ae.filterGraceful,description:b.localize(141,null)},"editor.suggest.localityBonus":{type:"boolean",default:ae.localityBonus,description:b.localize(142,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ae.shareSuggestSelections,markdownDescription:b.localize(143,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(144,null),b.localize(145,null),b.localize(146,null),b.localize(147,null)],default:ae.selectionMode,markdownDescription:b.localize(148,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ae.snippetsPreventQuickSuggestions,description:b.localize(149,null)},"editor.suggest.showIcons":{type:"boolean",default:ae.showIcons,description:b.localize(150,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ae.showStatusBar,description:b.localize(151,null)},"editor.suggest.preview":{type:"boolean",default:ae.preview,description:b.localize(152,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ae.showInlineDetails,description:b.localize(153,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(154,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(155,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(156,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(157,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(158,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(159,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(160,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(161,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(162,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(163,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(164,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(165,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(166,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(183,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(184,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(185,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{insertMode:r(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:f(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:f(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:f(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:f(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:f(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:f(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:f(Ie.preview,this.defaultValue.preview),previewMode:r(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:f(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:f(Ie.showMethods,this.defaultValue.showMethods),showFunctions:f(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:f(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:f(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:f(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:f(Ie.showFields,this.defaultValue.showFields),showVariables:f(Ie.showVariables,this.defaultValue.showVariables),showClasses:f(Ie.showClasses,this.defaultValue.showClasses),showStructs:f(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:f(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:f(Ie.showModules,this.defaultValue.showModules),showProperties:f(Ie.showProperties,this.defaultValue.showProperties),showEvents:f(Ie.showEvents,this.defaultValue.showEvents),showOperators:f(Ie.showOperators,this.defaultValue.showOperators),showUnits:f(Ie.showUnits,this.defaultValue.showUnits),showValues:f(Ie.showValues,this.defaultValue.showValues),showConstants:f(Ie.showConstants,this.defaultValue.showConstants),showEnums:f(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:f(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:f(Ie.showKeywords,this.defaultValue.showKeywords),showWords:f(Ie.showWords,this.defaultValue.showWords),showColors:f(Ie.showColors,this.defaultValue.showColors),showFiles:f(Ie.showFiles,this.defaultValue.showFiles),showReferences:f(Ie.showReferences,this.defaultValue.showReferences),showFolders:f(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:f(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:f(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:f(Ie.showUsers,this.defaultValue.showUsers),showIssues:f(Ie.showIssues,this.defaultValue.showIssues)}}}class je extends C{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(186,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(187,null),default:!0,type:"boolean"}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:f(ae.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:f(ae.selectSubwords,this.defaultValue.selectSubwords)}}}var He;(function(ne){ne[ne.None=0]="None",ne[ne.Same=1]="Same",ne[ne.Indent=2]="Indent",ne[ne.DeepIndent=3]="DeepIndent"})(He||(e.WrappingIndent=He={}));class Je extends C{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(188,null),b.localize(189,null),b.localize(190,null),b.localize(191,null)],description:b.localize(192,null),default:"same"}})}validate(ae){switch(ae){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ae,Ie,Ve){return Ie.get(2)===2?0:Ve}}class _e extends k{constructor(){super(144)}compute(ae,Ie,Ve){const Ze=Ie.get(143);return{isDominatedByLongLines:ae.isDominatedByLongLines,isWordWrapMinified:Ze.isWordWrapMinified,isViewportWrapping:Ze.isViewportWrapping,wrappingColumn:Ze.wrappingColumn}}}class ct extends C{constructor(){const ae={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ae,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ae.enabled,markdownDescription:b.localize(193,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(194,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(195,null),b.localize(196,null)],default:"afterDrop"}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:f(Ie.enabled,this.defaultValue.enabled),showDropSelector:r(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ot extends C{constructor(){const ae={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",ae,{"editor.pasteAs.enabled":{type:"boolean",default:ae.enabled,markdownDescription:b.localize(197,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(198,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(199,null),b.localize(200,null)],default:"afterPaste"}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:f(Ie.enabled,this.defaultValue.enabled),showPasteSelector:r(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",Ae="Menlo, Monaco, 'Courier New', monospace",Ue="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:g.$j?Ae:g.$k?Ue:rt,fontWeight:"normal",fontSize:g.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(ne){return e.editorOptionsRegistry[ne.id]=ne,ne}var Xe;(function(ne){ne[ne.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ne[ne.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ne[ne.accessibilitySupport=2]="accessibilitySupport",ne[ne.accessibilityPageSize=3]="accessibilityPageSize",ne[ne.ariaLabel=4]="ariaLabel",ne[ne.ariaRequired=5]="ariaRequired",ne[ne.autoClosingBrackets=6]="autoClosingBrackets",ne[ne.autoClosingComments=7]="autoClosingComments",ne[ne.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ne[ne.autoClosingDelete=9]="autoClosingDelete",ne[ne.autoClosingOvertype=10]="autoClosingOvertype",ne[ne.autoClosingQuotes=11]="autoClosingQuotes",ne[ne.autoIndent=12]="autoIndent",ne[ne.automaticLayout=13]="automaticLayout",ne[ne.autoSurround=14]="autoSurround",ne[ne.bracketPairColorization=15]="bracketPairColorization",ne[ne.guides=16]="guides",ne[ne.codeLens=17]="codeLens",ne[ne.codeLensFontFamily=18]="codeLensFontFamily",ne[ne.codeLensFontSize=19]="codeLensFontSize",ne[ne.colorDecorators=20]="colorDecorators",ne[ne.colorDecoratorsLimit=21]="colorDecoratorsLimit",ne[ne.columnSelection=22]="columnSelection",ne[ne.comments=23]="comments",ne[ne.contextmenu=24]="contextmenu",ne[ne.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ne[ne.cursorBlinking=26]="cursorBlinking",ne[ne.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ne[ne.cursorStyle=28]="cursorStyle",ne[ne.cursorSurroundingLines=29]="cursorSurroundingLines",ne[ne.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ne[ne.cursorWidth=31]="cursorWidth",ne[ne.disableLayerHinting=32]="disableLayerHinting",ne[ne.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ne[ne.domReadOnly=34]="domReadOnly",ne[ne.dragAndDrop=35]="dragAndDrop",ne[ne.dropIntoEditor=36]="dropIntoEditor",ne[ne.emptySelectionClipboard=37]="emptySelectionClipboard",ne[ne.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ne[ne.extraEditorClassName=39]="extraEditorClassName",ne[ne.fastScrollSensitivity=40]="fastScrollSensitivity",ne[ne.find=41]="find",ne[ne.fixedOverflowWidgets=42]="fixedOverflowWidgets",ne[ne.folding=43]="folding",ne[ne.foldingStrategy=44]="foldingStrategy",ne[ne.foldingHighlight=45]="foldingHighlight",ne[ne.foldingImportsByDefault=46]="foldingImportsByDefault",ne[ne.foldingMaximumRegions=47]="foldingMaximumRegions",ne[ne.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ne[ne.fontFamily=49]="fontFamily",ne[ne.fontInfo=50]="fontInfo",ne[ne.fontLigatures=51]="fontLigatures",ne[ne.fontSize=52]="fontSize",ne[ne.fontWeight=53]="fontWeight",ne[ne.fontVariations=54]="fontVariations",ne[ne.formatOnPaste=55]="formatOnPaste",ne[ne.formatOnType=56]="formatOnType",ne[ne.glyphMargin=57]="glyphMargin",ne[ne.gotoLocation=58]="gotoLocation",ne[ne.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ne[ne.hover=60]="hover",ne[ne.inDiffEditor=61]="inDiffEditor",ne[ne.inlineSuggest=62]="inlineSuggest",ne[ne.letterSpacing=63]="letterSpacing",ne[ne.lightbulb=64]="lightbulb",ne[ne.lineDecorationsWidth=65]="lineDecorationsWidth",ne[ne.lineHeight=66]="lineHeight",ne[ne.lineNumbers=67]="lineNumbers",ne[ne.lineNumbersMinChars=68]="lineNumbersMinChars",ne[ne.linkedEditing=69]="linkedEditing",ne[ne.links=70]="links",ne[ne.matchBrackets=71]="matchBrackets",ne[ne.minimap=72]="minimap",ne[ne.mouseStyle=73]="mouseStyle",ne[ne.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",ne[ne.mouseWheelZoom=75]="mouseWheelZoom",ne[ne.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",ne[ne.multiCursorModifier=77]="multiCursorModifier",ne[ne.multiCursorPaste=78]="multiCursorPaste",ne[ne.multiCursorLimit=79]="multiCursorLimit",ne[ne.occurrencesHighlight=80]="occurrencesHighlight",ne[ne.overviewRulerBorder=81]="overviewRulerBorder",ne[ne.overviewRulerLanes=82]="overviewRulerLanes",ne[ne.padding=83]="padding",ne[ne.pasteAs=84]="pasteAs",ne[ne.parameterHints=85]="parameterHints",ne[ne.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",ne[ne.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",ne[ne.quickSuggestions=88]="quickSuggestions",ne[ne.quickSuggestionsDelay=89]="quickSuggestionsDelay",ne[ne.readOnly=90]="readOnly",ne[ne.readOnlyMessage=91]="readOnlyMessage",ne[ne.renameOnType=92]="renameOnType",ne[ne.renderControlCharacters=93]="renderControlCharacters",ne[ne.renderFinalNewline=94]="renderFinalNewline",ne[ne.renderLineHighlight=95]="renderLineHighlight",ne[ne.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",ne[ne.renderValidationDecorations=97]="renderValidationDecorations",ne[ne.renderWhitespace=98]="renderWhitespace",ne[ne.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",ne[ne.roundedSelection=100]="roundedSelection",ne[ne.rulers=101]="rulers",ne[ne.scrollbar=102]="scrollbar",ne[ne.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",ne[ne.scrollBeyondLastLine=104]="scrollBeyondLastLine",ne[ne.scrollPredominantAxis=105]="scrollPredominantAxis",ne[ne.selectionClipboard=106]="selectionClipboard",ne[ne.selectionHighlight=107]="selectionHighlight",ne[ne.selectOnLineNumbers=108]="selectOnLineNumbers",ne[ne.showFoldingControls=109]="showFoldingControls",ne[ne.showUnused=110]="showUnused",ne[ne.snippetSuggestions=111]="snippetSuggestions",ne[ne.smartSelect=112]="smartSelect",ne[ne.smoothScrolling=113]="smoothScrolling",ne[ne.stickyScroll=114]="stickyScroll",ne[ne.stickyTabStops=115]="stickyTabStops",ne[ne.stopRenderingLineAfter=116]="stopRenderingLineAfter",ne[ne.suggest=117]="suggest",ne[ne.suggestFontSize=118]="suggestFontSize",ne[ne.suggestLineHeight=119]="suggestLineHeight",ne[ne.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",ne[ne.suggestSelection=121]="suggestSelection",ne[ne.tabCompletion=122]="tabCompletion",ne[ne.tabIndex=123]="tabIndex",ne[ne.unicodeHighlighting=124]="unicodeHighlighting",ne[ne.unusualLineTerminators=125]="unusualLineTerminators",ne[ne.useShadowDOM=126]="useShadowDOM",ne[ne.useTabStops=127]="useTabStops",ne[ne.wordBreak=128]="wordBreak",ne[ne.wordSeparators=129]="wordSeparators",ne[ne.wordWrap=130]="wordWrap",ne[ne.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",ne[ne.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",ne[ne.wordWrapColumn=133]="wordWrapColumn",ne[ne.wordWrapOverride1=134]="wordWrapOverride1",ne[ne.wordWrapOverride2=135]="wordWrapOverride2",ne[ne.wrappingIndent=136]="wrappingIndent",ne[ne.wrappingStrategy=137]="wrappingStrategy",ne[ne.showDeprecated=138]="showDeprecated",ne[ne.inlayHints=139]="inlayHints",ne[ne.editorClassName=140]="editorClassName",ne[ne.pixelRatio=141]="pixelRatio",ne[ne.tabFocusMode=142]="tabFocusMode",ne[ne.layoutInfo=143]="layoutInfo",ne[ne.wrappingInfo=144]="wrappingInfo",ne[ne.defaultColorDecorators=145]="defaultColorDecorators",ne[ne.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",ne[ne.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Xe||(e.EditorOption=Xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(201,null)})),acceptSuggestionOnEnter:Le(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(202,null),""],markdownDescription:b.localize(203,null)})),accessibilitySupport:Le(new h),accessibilityPageSize:Le(new n(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(204,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",b.localize(205,null))),ariaRequired:Le(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(206,null),tags:["accessibility"]})),autoClosingBrackets:Le(new d(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(207,null),b.localize(208,null),""],description:b.localize(209,null)})),autoClosingComments:Le(new d(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(210,null),b.localize(211,null),""],description:b.localize(212,null)})),autoClosingDelete:Le(new d(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(213,null),""],description:b.localize(214,null)})),autoClosingOvertype:Le(new d(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(215,null),""],description:b.localize(216,null)})),autoClosingQuotes:Le(new d(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(217,null),b.localize(218,null),""],description:b.localize(219,null)})),autoIndent:Le(new u(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[b.localize(220,null),b.localize(221,null),b.localize(222,null),b.localize(223,null),b.localize(224,null)],description:b.localize(225,null)})),automaticLayout:Le(new s(13,"automaticLayout",!1)),autoSurround:Le(new d(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(226,null),b.localize(227,null),b.localize(228,null),""],description:b.localize(229,null)})),bracketPairColorization:Le(new V),bracketPairGuides:Le(new oe),stickyTabStops:Le(new s(115,"stickyTabStops",!1,{description:b.localize(230,null)})),codeLens:Le(new s(17,"codeLens",!0,{description:b.localize(231,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:b.localize(232,null)})),codeLensFontSize:Le(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(233,null)})),colorDecorators:Le(new s(20,"colorDecorators",!0,{description:b.localize(234,null)})),colorDecoratorActivatedOn:Le(new d(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(235,null),b.localize(236,null),b.localize(237,null)],description:b.localize(238,null)})),colorDecoratorsLimit:Le(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(239,null)})),columnSelection:Le(new s(22,"columnSelection",!1,{description:b.localize(240,null)})),comments:Le(new S),contextmenu:Le(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new s(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(241,null)})),cursorBlinking:Le(new u(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],w,{description:b.localize(242,null)})),cursorSmoothCaretAnimation:Le(new d(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(243,null),b.localize(244,null),b.localize(245,null)],description:b.localize(246,null)})),cursorStyle:Le(new u(28,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:b.localize(247,null)})),cursorSurroundingLines:Le(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(248,null)})),cursorSurroundingLinesStyle:Le(new d(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(249,null),b.localize(250,null)],markdownDescription:b.localize(251,null)})),cursorWidth:Le(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(252,null)})),disableLayerHinting:Le(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new s(34,"domReadOnly",!1)),dragAndDrop:Le(new s(35,"dragAndDrop",!0,{description:b.localize(253,null)})),emptySelectionClipboard:Le(new U),dropIntoEditor:Le(new ct),stickyScroll:Le(new ce),experimentalWhitespaceRendering:Le(new d(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(254,null),b.localize(255,null),b.localize(256,null)],description:b.localize(257,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new c(40,"fastScrollSensitivity",5,ne=>ne<=0?5:ne,{markdownDescription:b.localize(258,null)})),find:Le(new F),fixedOverflowWidgets:Le(new s(42,"fixedOverflowWidgets",!1)),folding:Le(new s(43,"folding",!0,{description:b.localize(259,null)})),foldingStrategy:Le(new d(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(260,null),b.localize(261,null)],description:b.localize(262,null)})),foldingHighlight:Le(new s(45,"foldingHighlight",!0,{description:b.localize(263,null)})),foldingImportsByDefault:Le(new s(46,"foldingImportsByDefault",!1,{description:b.localize(264,null)})),foldingMaximumRegions:Le(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(265,null)})),unfoldOnClickAfterEndOfLine:Le(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(266,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(267,null)})),fontInfo:Le(new M),fontLigatures2:Le(new j),fontSize:Le(new W),fontWeight:Le(new Y),fontVariations:Le(new O),formatOnPaste:Le(new s(55,"formatOnPaste",!1,{description:b.localize(268,null)})),formatOnType:Le(new s(56,"formatOnType",!1,{description:b.localize(269,null)})),glyphMargin:Le(new s(57,"glyphMargin",!0,{description:b.localize(270,null)})),gotoLocation:Le(new ue),hideCursorInOverviewRuler:Le(new s(59,"hideCursorInOverviewRuler",!1,{description:b.localize(271,null)})),hover:Le(new X),inDiffEditor:Le(new s(61,"inDiffEditor",!1)),letterSpacing:Le(new c(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ne=>c.clamp(ne,-5,20),{description:b.localize(272,null)})),lightbulb:Le(new we),lineDecorationsWidth:Le(new B),lineHeight:Le(new re),lineNumbers:Le(new fe),lineNumbersMinChars:Le(new n(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new s(69,"linkedEditing",!1,{description:b.localize(273,null)})),links:Le(new s(70,"links",!0,{description:b.localize(274,null)})),matchBrackets:Le(new d(71,"matchBrackets","always",["always","near","never"],{description:b.localize(275,null)})),minimap:Le(new ye),mouseStyle:Le(new d(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new c(74,"mouseWheelScrollSensitivity",1,ne=>ne===0?1:ne,{markdownDescription:b.localize(276,null)})),mouseWheelZoom:Le(new s(75,"mouseWheelZoom",!1,{markdownDescription:g.$j?b.localize(277,null):b.localize(278,null)})),multiCursorMergeOverlapping:Le(new s(76,"multiCursorMergeOverlapping",!0,{description:b.localize(279,null)})),multiCursorModifier:Le(new u(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],de,{markdownEnumDescriptions:[b.localize(280,null),b.localize(281,null)],markdownDescription:b.localize(282,null)})),multiCursorPaste:Le(new d(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(283,null),b.localize(284,null)],markdownDescription:b.localize(285,null)})),multiCursorLimit:Le(new n(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(286,null)})),occurrencesHighlight:Le(new d(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(287,null),b.localize(288,null),b.localize(289,null)],markdownDescription:b.localize(290,null)})),overviewRulerBorder:Le(new s(81,"overviewRulerBorder",!0,{description:b.localize(291,null)})),overviewRulerLanes:Le(new n(82,"overviewRulerLanes",3,0,3)),padding:Le(new ge),pasteAs:Le(new ot),parameterHints:Le(new _),peekWidgetDefaultFocus:Le(new d(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(292,null),b.localize(293,null)],description:b.localize(294,null)})),definitionLinkOpensInPeek:Le(new s(87,"definitionLinkOpensInPeek",!1,{description:b.localize(295,null)})),quickSuggestions:Le(new G),quickSuggestionsDelay:Le(new n(89,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(296,null)})),readOnly:Le(new s(90,"readOnly",!1)),readOnlyMessage:Le(new be),renameOnType:Le(new s(92,"renameOnType",!1,{description:b.localize(297,null),markdownDeprecationMessage:b.localize(298,null)})),renderControlCharacters:Le(new s(93,"renderControlCharacters",!0,{description:b.localize(299,null),restricted:!0})),renderFinalNewline:Le(new d(94,"renderFinalNewline",g.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(300,null)})),renderLineHighlight:Le(new d(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(301,null)],description:b.localize(302,null)})),renderLineHighlightOnlyWhenFocus:Le(new s(96,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(303,null)})),renderValidationDecorations:Le(new d(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new d(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(304,null),b.localize(305,null),b.localize(306,null),""],description:b.localize(307,null)})),revealHorizontalRightPadding:Le(new n(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new s(100,"roundedSelection",!0,{description:b.localize(308,null)})),rulers:Le(new Pe),scrollbar:Le(new z),scrollBeyondLastColumn:Le(new n(103,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(309,null)})),scrollBeyondLastLine:Le(new s(104,"scrollBeyondLastLine",!0,{description:b.localize(310,null)})),scrollPredominantAxis:Le(new s(105,"scrollPredominantAxis",!0,{description:b.localize(311,null)})),selectionClipboard:Le(new s(106,"selectionClipboard",!0,{description:b.localize(312,null),included:g.$k})),selectionHighlight:Le(new s(107,"selectionHighlight",!0,{description:b.localize(313,null)})),selectOnLineNumbers:Le(new s(108,"selectOnLineNumbers",!0)),showFoldingControls:Le(new d(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(314,null),b.localize(315,null),b.localize(316,null)],description:b.localize(317,null)})),showUnused:Le(new s(110,"showUnused",!0,{description:b.localize(318,null)})),showDeprecated:Le(new s(138,"showDeprecated",!0,{description:b.localize(319,null)})),inlayHints:Le(new K),snippetSuggestions:Le(new d(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(320,null),b.localize(321,null),b.localize(322,null),b.localize(323,null)],description:b.localize(324,null)})),smartSelect:Le(new je),smoothScrolling:Le(new s(113,"smoothScrolling",!1,{description:b.localize(325,null)})),stopRenderingLineAfter:Le(new n(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new Re),inlineSuggest:Le(new ee),inlineCompletionsAccessibilityVerbose:Le(new s(147,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(326,null)})),suggestFontSize:Le(new n(118,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(327,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new n(119,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(328,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new s(120,"suggestOnTriggerCharacters",!0,{description:b.localize(329,null)})),suggestSelection:Le(new d(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(330,null),b.localize(331,null),b.localize(332,null)],description:b.localize(333,null)})),tabCompletion:Le(new d(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(334,null),b.localize(335,null),b.localize(336,null)],description:b.localize(337,null)})),tabIndex:Le(new n(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new Q),unusualLineTerminators:Le(new d(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(338,null),b.localize(339,null),b.localize(340,null)],description:b.localize(341,null)})),useShadowDOM:Le(new s(126,"useShadowDOM",!0)),useTabStops:Le(new s(127,"useTabStops",!0,{description:b.localize(342,null)})),wordBreak:Le(new d(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(343,null),b.localize(344,null)],description:b.localize(345,null)})),wordSeparators:Le(new t(129,"wordSeparators",R.$gs,{description:b.localize(346,null)})),wordWrap:Le(new d(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(347,null),b.localize(348,null),b.localize(349,null),b.localize(350,null)],description:b.localize(351,null)})),wordWrapBreakAfterCharacters:Le(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new n(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(352,null)})),wordWrapOverride1:Le(new d(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new d(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new T),defaultColorDecorators:Le(new s(145,"defaultColorDecorators",!1,{markdownDescription:b.localize(353,null)})),pixelRatio:Le(new ie),tabFocusMode:Le(new s(142,"tabFocusMode",!1,{markdownDescription:b.localize(354,null)})),layoutInfo:Le(new x),wrappingInfo:Le(new _e),wrappingIndent:Le(new Je),wrappingStrategy:Le(new he)}}),define(Se[195],ke([8,9]),function(me,e){return me.create("vs/editor/common/languages",e)}),define(Se[83],ke([1,0,78,2,168,29,178,195]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$At=e.$zt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$yt=e.$xt=e.SymbolKinds=e.SymbolTag=e.$wt=e.$vt=e.SymbolKind=e.$ut=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$tt=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$st=e.$rt=e.$qt=void 0;class ${constructor(j,O,M){this.offset=j,this.type=O,this.language=M,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$qt=$;class y{constructor(j,O){this.tokens=j,this.endState=O,this._tokenizationResultBrand=void 0}}e.$rt=y;class A{constructor(j,O){this.tokens=j,this.endState=O,this._encodedTokenizationResultBrand=void 0}}e.$st=A;var C;(function(F){F[F.Method=0]="Method",F[F.Function=1]="Function",F[F.Constructor=2]="Constructor",F[F.Field=3]="Field",F[F.Variable=4]="Variable",F[F.Class=5]="Class",F[F.Struct=6]="Struct",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Event=10]="Event",F[F.Operator=11]="Operator",F[F.Unit=12]="Unit",F[F.Value=13]="Value",F[F.Constant=14]="Constant",F[F.Enum=15]="Enum",F[F.EnumMember=16]="EnumMember",F[F.Keyword=17]="Keyword",F[F.Text=18]="Text",F[F.Color=19]="Color",F[F.File=20]="File",F[F.Reference=21]="Reference",F[F.Customcolor=22]="Customcolor",F[F.Folder=23]="Folder",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue",F[F.Snippet=27]="Snippet"})(C||(e.CompletionItemKind=C={}));var m;(function(F){const j=new Map;j.set(0,D.$9j.symbolMethod),j.set(1,D.$9j.symbolFunction),j.set(2,D.$9j.symbolConstructor),j.set(3,D.$9j.symbolField),j.set(4,D.$9j.symbolVariable),j.set(5,D.$9j.symbolClass),j.set(6,D.$9j.symbolStruct),j.set(7,D.$9j.symbolInterface),j.set(8,D.$9j.symbolModule),j.set(9,D.$9j.symbolProperty),j.set(10,D.$9j.symbolEvent),j.set(11,D.$9j.symbolOperator),j.set(12,D.$9j.symbolUnit),j.set(13,D.$9j.symbolValue),j.set(15,D.$9j.symbolEnum),j.set(14,D.$9j.symbolConstant),j.set(15,D.$9j.symbolEnum),j.set(16,D.$9j.symbolEnumMember),j.set(17,D.$9j.symbolKeyword),j.set(27,D.$9j.symbolSnippet),j.set(18,D.$9j.symbolText),j.set(19,D.$9j.symbolColor),j.set(20,D.$9j.symbolFile),j.set(21,D.$9j.symbolReference),j.set(22,D.$9j.symbolCustomColor),j.set(23,D.$9j.symbolFolder),j.set(24,D.$9j.symbolTypeParameter),j.set(25,D.$9j.account),j.set(26,D.$9j.issues);function O(Y){let ue=j.get(Y);return ue||(console.info("No codicon found for CompletionItemKind "+Y),ue=D.$9j.symbolProperty),ue}F.toIcon=O;const M=new Map;M.set("method",0),M.set("function",1),M.set("constructor",2),M.set("field",3),M.set("variable",4),M.set("class",5),M.set("struct",6),M.set("interface",7),M.set("module",8),M.set("property",9),M.set("event",10),M.set("operator",11),M.set("unit",12),M.set("value",13),M.set("constant",14),M.set("enum",15),M.set("enum-member",16),M.set("enumMember",16),M.set("keyword",17),M.set("snippet",27),M.set("text",18),M.set("color",19),M.set("file",20),M.set("reference",21),M.set("customcolor",22),M.set("folder",23),M.set("type-parameter",24),M.set("typeParameter",24),M.set("account",25),M.set("issue",26);function W(Y,ue){let X=M.get(Y);return typeof X>"u"&&!ue&&(X=9),X}F.fromString=W})(m||(e.CompletionItemKinds=m={}));var v;(function(F){F[F.Deprecated=1]="Deprecated"})(v||(e.CompletionItemTag=v={}));var k;(function(F){F[F.None=0]="None",F[F.KeepWhitespace=1]="KeepWhitespace",F[F.InsertAsSnippet=4]="InsertAsSnippet"})(k||(e.CompletionItemInsertTextRule=k={}));var l;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(l||(e.CompletionTriggerKind=l={}));var f;(function(F){F[F.Automatic=0]="Automatic",F[F.Explicit=1]="Explicit"})(f||(e.InlineCompletionTriggerKind=f={}));class s{constructor(j,O,M,W){this.range=j,this.text=O,this.completionKind=M,this.isSnippetText=W}equals(j){return I.$Is.lift(this.range).equalsRange(j.range)&&this.text===j.text&&this.completionKind===j.completionKind&&this.isSnippetText===j.isSnippetText}}e.$tt=s;var i;(function(F){F[F.Invoke=1]="Invoke",F[F.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var n;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(n||(e.SignatureHelpTriggerKind=n={}));var o;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(o||(e.DocumentHighlightKind=o={}));function c(F){return F&&N.URI.isUri(F.uri)&&I.$Is.isIRange(F.range)&&(I.$Is.isIRange(F.originSelectionRange)||I.$Is.isIRange(F.targetSelectionRange))}e.$ut=c;var t;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$vt={[17]:(0,b.localize)(0,null),[16]:(0,b.localize)(1,null),[4]:(0,b.localize)(2,null),[13]:(0,b.localize)(3,null),[8]:(0,b.localize)(4,null),[9]:(0,b.localize)(5,null),[21]:(0,b.localize)(6,null),[23]:(0,b.localize)(7,null),[7]:(0,b.localize)(8,null),[0]:(0,b.localize)(9,null),[11]:(0,b.localize)(10,null),[10]:(0,b.localize)(11,null),[19]:(0,b.localize)(12,null),[5]:(0,b.localize)(13,null),[1]:(0,b.localize)(14,null),[2]:(0,b.localize)(15,null),[20]:(0,b.localize)(16,null),[15]:(0,b.localize)(17,null),[18]:(0,b.localize)(18,null),[24]:(0,b.localize)(19,null),[3]:(0,b.localize)(20,null),[6]:(0,b.localize)(21,null),[14]:(0,b.localize)(22,null),[22]:(0,b.localize)(23,null),[25]:(0,b.localize)(24,null),[12]:(0,b.localize)(25,null)};function r(F,j){return(0,b.localize)(26,null,F,e.$vt[j])}e.$wt=r;var d;(function(F){F[F.Deprecated=1]="Deprecated"})(d||(e.SymbolTag=d={}));var u;(function(F){const j=new Map;j.set(0,D.$9j.symbolFile),j.set(1,D.$9j.symbolModule),j.set(2,D.$9j.symbolNamespace),j.set(3,D.$9j.symbolPackage),j.set(4,D.$9j.symbolClass),j.set(5,D.$9j.symbolMethod),j.set(6,D.$9j.symbolProperty),j.set(7,D.$9j.symbolField),j.set(8,D.$9j.symbolConstructor),j.set(9,D.$9j.symbolEnum),j.set(10,D.$9j.symbolInterface),j.set(11,D.$9j.symbolFunction),j.set(12,D.$9j.symbolVariable),j.set(13,D.$9j.symbolConstant),j.set(14,D.$9j.symbolString),j.set(15,D.$9j.symbolNumber),j.set(16,D.$9j.symbolBoolean),j.set(17,D.$9j.symbolArray),j.set(18,D.$9j.symbolObject),j.set(19,D.$9j.symbolKey),j.set(20,D.$9j.symbolNull),j.set(21,D.$9j.symbolEnumMember),j.set(22,D.$9j.symbolStruct),j.set(23,D.$9j.symbolEvent),j.set(24,D.$9j.symbolOperator),j.set(25,D.$9j.symbolTypeParameter);function O(M){let W=j.get(M);return W||(console.info("No codicon found for SymbolKind "+M),W=D.$9j.symbolProperty),W}F.toIcon=O})(u||(e.SymbolKinds=u={}));class a{static asEditOperation(j){return g.$Js.replace(I.$Is.lift(j.range),j.text)}}e.$xt=a;class h{static{this.Comment=new h("comment")}static{this.Imports=new h("imports")}static{this.Region=new h("region")}static fromValue(j){switch(j){case"comment":return h.Comment;case"imports":return h.Imports;case"region":return h.Region}return new h(j)}constructor(j){this.value=j}}e.$yt=h;var S;(function(F){function j(O){return!O||typeof O!="object"?!1:typeof O.id=="string"&&typeof O.title=="string"}F.is=j})(S||(e.Command=S={}));var P;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(P||(e.CommentThreadCollapsibleState=P={}));var w;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})(w||(e.CommentThreadState=w={}));var p;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(p||(e.CommentMode=p={}));var E;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(E||(e.CommentState=E={}));var L;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(L||(e.InlayHintKind=L={}));class T{constructor(j){this.b=j,this.a=null}dispose(){this.a&&this.a.then(j=>{j&&j.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$zt=T,e.$At=new R.$ht;var U;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(U||(e.ExternalUriOpenerPriority=U={}))}),define(Se[196],ke([8,9]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[197],ke([8,9]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[198],ke([8,9]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(Se[199],ke([8,9]),function(me,e){return me.create("vs/platform/dialogs/common/dialogs",e)}),define(Se[200],ke([8,9]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[201],ke([8,9]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[202],ke([8,9]),function(me,e){return me.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[203],ke([8,9]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(Se[204],ke([8,9]),function(me,e){return me.create("vs/platform/files/common/io",e)}),define(Se[205],ke([8,9]),function(me,e){return me.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Se[206],ke([8,9]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(Se[207],ke([8,9]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[208],ke([8,9]),function(me,e){return me.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Se[209],ke([8,9]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(Se[210],ke([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Se[211],ke([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[212],ke([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[213],ke([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Se[214],ke([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(Se[215],ke([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(Se[216],ke([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostProgress",e)}),define(Se[217],ke([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[218],ke([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[219],ke([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[220],ke([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[221],ke([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Se[222],ke([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[223],ke([8,9]),function(me,e){return me.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[224],ke([8,9]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(Se[225],ke([8,9]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(Se[226],ke([8,9]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(Se[227],ke([8,9]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[228],ke([8,9]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[229],ke([8,9]),function(me,e){return me.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[230],ke([8,9]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[231],ke([8,9]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[232],ke([8,9]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[233],ke([8,9]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Se[234],ke([8,9]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[235],ke([8,9]),function(me,e){return me.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Se[236],ke([8,9]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[237],ke([1,0,14,198]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xi=e.TokenType=void 0;var g;(function(y){y[y.LParen=0]="LParen",y[y.RParen=1]="RParen",y[y.Neg=2]="Neg",y[y.Eq=3]="Eq",y[y.NotEq=4]="NotEq",y[y.Lt=5]="Lt",y[y.LtEq=6]="LtEq",y[y.Gt=7]="Gt",y[y.GtEq=8]="GtEq",y[y.RegexOp=9]="RegexOp",y[y.RegexStr=10]="RegexStr",y[y.True=11]="True",y[y.False=12]="False",y[y.In=13]="In",y[y.Not=14]="Not",y[y.And=15]="And",y[y.Or=16]="Or",y[y.Str=17]="Str",y[y.QuotedStr=18]="QuotedStr",y[y.Error=19]="Error",y[y.EOF=20]="EOF"})(g||(e.TokenType=g={}));function I(...y){switch(y.length){case 1:return(0,N.localize)(0,null,y[0]);case 2:return(0,N.localize)(1,null,y[0],y[1]);case 3:return(0,N.localize)(2,null,y[0],y[1],y[2]);default:return}}const R=(0,N.localize)(3,null),b=(0,N.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const C=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:C})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const C=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:C})}else this.h(126)?this.k(9):this.l(I("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(I("&&"));break;case 124:this.h(124)?this.k(16):this.l(I("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const C=this.d,m=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:m};this.g.push({offset:C,lexeme:m,additionalInfo:A}),this.f.push(v)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const C=this.c.substring(this.d,this.e),m=$.b.get(C);m?this.k(m):this.f.push({type:17,lexeme:C,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,C=!1,m=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(b);return}const k=this.c.charCodeAt(A);if(C)C=!1;else if(k===47&&!m){A++;break}else k===91?m=!0:k===92?C=!0:k===93&&(m=!1);A++}for(;A<this.c.length&&$.a.has(this.c.charCodeAt(A));)A++;this.e=A;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$Xi=$}),define(Se[238],ke([1,0,23,39,201,386]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function $(s){return s=s.trim(),s==="*"||R.test(s)}e.$1o=$;function y(s){if(!$(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=s.match(R);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$2o=y;function A(s){if(!s)return null;const i=s.majorBase,n=s.majorMustEqual,o=s.minorBase;let c=s.minorMustEqual;const t=s.patchBase;let r=s.patchMustEqual;s.hasCaret&&(i===0||(c=!1),r=!1);let d=0;if(s.preRelease){const u=b.exec(s.preRelease);if(u){const[,a,h,S]=u;d=Date.UTC(Number(a),Number(h)-1,Number(S))}}return{majorBase:i,majorMustEqual:n,minorBase:o,minorMustEqual:c,patchBase:t,patchMustEqual:r,isMinimum:s.hasGreaterEquals,notBefore:d}}e.$3o=A;function C(s,i,n){let o;typeof s=="string"?o=A(y(s)):o=s;let c;i instanceof Date?c=i.getTime():typeof i=="string"&&(c=new Date(i).getTime());let t;if(typeof n=="string"?t=A(y(n)):t=n,!o||!t)return!1;const r=o.majorBase,d=o.minorBase,u=o.patchBase;let a=t.majorBase,h=t.minorBase,S=t.patchBase;const P=t.notBefore;let w=t.majorMustEqual,p=t.minorMustEqual,E=t.patchMustEqual;return t.isMinimum?r>a?!0:r<a?!1:d>h?!0:d<h||c&&c<P?!1:u>=S:(r===1&&a===0&&(!w||!p||!E)&&(a=1,h=0,S=0,w=!0,p=!1,E=!1),r<a?!1:r>a?!w:d<h?!1:d>h?!p:u<S?!1:u>S?!E:!(c&&c<P))}e.$4o=C;function m(s,i,n,o,c){const t=[];if(typeof o.publisher<"u"&&typeof o.publisher!="string")return t.push([N.default.Error,g.localize(0,null)]),t;if(typeof o.name!="string")return t.push([N.default.Error,g.localize(1,null,"name")]),t;if(typeof o.version!="string")return t.push([N.default.Error,g.localize(2,null,"version")]),t;if(!o.engines)return t.push([N.default.Error,g.localize(3,null,"engines")]),t;if(typeof o.engines.vscode!="string")return t.push([N.default.Error,g.localize(4,null,"engines.vscode")]),t;if(typeof o.extensionDependencies<"u"&&!f(o.extensionDependencies))return t.push([N.default.Error,g.localize(5,null,"extensionDependencies")]),t;if(typeof o.activationEvents<"u"){if(!f(o.activationEvents))return t.push([N.default.Error,g.localize(6,null,"activationEvents")]),t;if(typeof o.main>"u"&&typeof o.browser>"u")return t.push([N.default.Error,g.localize(7,null,"activationEvents","main","browser")]),t}if(typeof o.extensionKind<"u"&&typeof o.main>"u"&&t.push([N.default.Warning,g.localize(8,null,"extensionKind")]),typeof o.main<"u"){if(typeof o.main!="string")return t.push([N.default.Error,g.localize(9,null,"main")]),t;{const u=(0,D.$Eg)(n,o.main);(0,D.$yg)(u,n)||t.push([N.default.Warning,g.localize(10,null,u.path,n.path)])}}if(typeof o.browser<"u"){if(typeof o.browser!="string")return t.push([N.default.Error,g.localize(11,null,"browser")]),t;{const u=(0,D.$Eg)(n,o.browser);(0,D.$yg)(u,n)||t.push([N.default.Warning,g.localize(12,null,u.path,n.path)])}}if(!I.valid(o.version))return t.push([N.default.Error,g.localize(13,null)]),t;const r=[];if(!v(s,i,o,c,r))for(const u of r)t.push([N.default.Error,u]);return t}e.$5o=m;function v(s,i,n,o,c){return o||typeof n.main>"u"&&typeof n.browser>"u"?!0:l(s,i,n.engines.vscode,c)}e.$6o=v;function k(s,i,n){return s==="*"||l(i,n,s)}e.$7o=k;function l(s,i,n,o=[]){const c=A(y(n));if(!c)return o.push(g.localize(14,null,n)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return o.push(g.localize(15,null,n)),!1}else if(!c.majorMustEqual)return o.push(g.localize(16,null,n)),!1;return C(s,i,c)?!0:(o.push(g.localize(17,null,s,n)),!1)}function f(s){if(!Array.isArray(s))return!1;for(let i=0,n=s.length;i<n;i++)if(typeof s[i]!="string")return!1;return!0}}),define(Se[105],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=void 0;class D{constructor(g,I=[],R=!1){this.ctor=g,this.staticArguments=I,this.supportsDelayedInstantiation=R}}e.$Zh=D}),define(Se[106],ke([1,0,105]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mr=e.$Lr=e.InstantiationType=void 0;const N=[];var g;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(g||(e.InstantiationType=g={}));function I(b,$,y){$ instanceof D.$Zh||($=new D.$Zh($,[],!!y)),N.push([b,$])}e.$Lr=I;function R(){return N}e.$Mr=R}),define(Se[239],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=void 0;class D{constructor(I,R){this.key=I,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$qq=D;class N{constructor(I){this.b=I,this.a=new Map}roots(){const I=[];for(const R of this.a.values())R.outgoing.size===0&&I.push(R);return I}insertEdge(I,R){const b=this.lookupOrInsertNode(I),$=this.lookupOrInsertNode(R);b.outgoing.set($.key,$),$.incoming.set(b.key,b)}removeNode(I){const R=this.b(I);this.a.delete(R);for(const b of this.a.values())b.outgoing.delete(R),b.incoming.delete(R)}lookupOrInsertNode(I){const R=this.b(I);let b=this.a.get(R);return b||(b=new D(R,I),this.a.set(R,b)),b}lookup(I){return this.a.get(this.b(I))}isEmpty(){return this.a.size===0}toString(){const I=[];for(const[R,b]of this.a)I.push(`${R}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return I.join(`
`)}findCycleSlow(){for(const[I,R]of this.a){const b=new Set([I]),$=this.c(R,b);if($)return $}}c(I,R){for(const[b,$]of I.outgoing){if(R.has(b))return[...R,b].join(" -> ");R.add(b);const y=this.c($,R);if(y)return y;R.delete(b)}}}e.$rq=N}),define(Se[5],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=e.$2h=e._util=void 0;var D;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function b($){return $[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=b})(D||(e._util=D={})),e.$2h=g("instantiationService");function N(R,b,$){b[D.DI_TARGET]===b?b[D.DI_DEPENDENCIES].push({id:R,index:$}):(b[D.DI_DEPENDENCIES]=[{id:R,index:$}],b[D.DI_TARGET]=b)}function g(R){if(D.serviceIds.has(R))return D.serviceIds.get(R);const b=function($,y,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(b,$,A)};return b.toString=()=>R,D.serviceIds.set(R,b),b}e.$3h=g;function I(R){return R}e.$4h=I}),define(Se[45],ke([1,0,18,2,5]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.ConfigurationTarget=e.$yi=e.$xi=e.$wi=void 0,e.$wi=(0,g.$3h)("configurationService");function I(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof N.URI)}e.$xi=I;function R(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof N.URI)}e.$yi=R;var b;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function $(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$zi=$;function y(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}e.$Ai=y;function A(s,i){const n=Object.create(null);for(const o in s)C(n,o,s[o],i);return n}e.$Bi=A;function C(s,i,n,o){const c=i.split("."),t=c.pop();let r=s;for(let d=0;d<c.length;d++){const u=c[d];let a=r[u];switch(typeof a){case"undefined":a=r[u]=Object.create(null);break;case"object":break;default:o(`Ignoring ${i} as ${c.slice(0,d+1).join(".")} is ${JSON.stringify(a)}`);return}r=a}if(typeof r=="object"&&r!==null)try{r[t]=n}catch{o(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(r)}`)}else o(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(r)}`)}e.$Ci=C;function m(s,i){const n=i.split(".");v(s,n)}e.$Di=m;function v(s,i){const n=i.shift();if(i.length===0){delete s[n];return}if(Object.keys(s).indexOf(n)!==-1){const o=s[n];typeof o=="object"&&!Array.isArray(o)&&(v(o,i),Object.keys(o).length===0&&delete s[n])}}function k(s,i,n){function o(r,d){let u=r;for(const a of d){if(typeof u!="object"||u===null)return;u=u[a]}return u}const c=i.split("."),t=o(s,c);return typeof t>"u"?n:t}e.$Ei=k;function l(s,i,n){Object.keys(i).forEach(o=>{o!=="__proto__"&&(o in s?D.$Hf(s[o])&&D.$Hf(i[o])?l(s[o],i[o],n):n&&(s[o]=i[o]):s[o]=i[o])})}e.$Fi=l;function f(s){return s.replace(/[\[\]]/g,"")}e.$Gi=f}),define(Se[46],ke([1,0,10,12,237,5,197,14]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.ContextKeyExprType=e.$Yi=void 0;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",D.$j),$.set("isLinux",D.$k),$.set("isWindows",D.$i),$.set("isWeb",D.$o),$.set("isMacNative",D.$j&&!D.$o),$.set("isEdge",D.$H),$.set("isFirefox",D.$F),$.set("isChrome",D.$E),$.set("isSafari",D.$G);function y(K,B){if($.get(K)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(K,B)}e.$Yi=y;const A=Object.prototype.hasOwnProperty;var C;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const m={regexParsingWithErrorRecovery:!0},v=(0,R.localize)(0,null),k=(0,R.localize)(1,null),l=(0,R.localize)(2,null),f=(0,R.localize)(3,null),s=(0,R.localize)(4,null),i=(0,R.localize)(5,null),n=(0,R.localize)(6,null),o=(0,R.localize)(7,null);class c{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=m){this.k=B,this.d=new g.$Xi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:k});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const re=this.l();if(!this.E()){const ye=this.D(),de=ye.type===17?i:void 0;throw this.h.push({message:s,offset:ye.offset,lexeme:g.$Xi.getLexeme(ye),additionalInfo:de}),c.c}return re}catch(re){if(re!==c.c)throw re;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(16);){const re=this.o();B.push(re)}return B.length===1?B[0]:t.or(...B)}o(){const B=[this.s()];for(;this.y(15);){const re=this.s();B.push(re)}return B.length===1?B[0]:t.and(...B)}s(){if(this.y(2)){const B=this.D();switch(B.type){case 11:return this.z(),a.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const re=this.l();return this.A(1,f),re?.negate()}case 17:return this.z(),L.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const re=this.l();return this.A(1,f),re}case 17:{const re=B.lexeme;if(this.z(),this.y(9)){const de=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),de.type!==10)throw this.B("REGEX",de);const ge=de.lexeme,_=ge.lastIndexOf("/"),ie=_===ge.length-1?void 0:this.w(ge.substring(_+1));let G;try{G=new RegExp(ge.substring(1,_),ie)}catch{throw this.B("REGEX",de)}return M.create(re,G)}switch(de.type){case 10:case 19:{const ge=[de.lexeme];this.z();let _=this.D(),ie=0;for(let Pe=0;Pe<de.lexeme.length;Pe++)de.lexeme.charCodeAt(Pe)===40?ie++:de.lexeme.charCodeAt(Pe)===41&&ie--;for(;!this.E()&&_.type!==15&&_.type!==16;){switch(_.type){case 0:ie++;break;case 1:ie--;break;case 10:case 18:for(let Pe=0;Pe<_.lexeme.length;Pe++)_.lexeme.charCodeAt(Pe)===40?ie++:de.lexeme.charCodeAt(Pe)===41&&ie--}if(ie<0)break;ge.push(g.$Xi.getLexeme(_)),this.z(),_=this.D()}const G=ge.join(""),te=G.lastIndexOf("/"),fe=te===G.length-1?void 0:this.w(G.substring(te+1));let ve;try{ve=new RegExp(G.substring(1,te),fe)}catch{throw this.B("REGEX",de)}return t.regex(re,ve)}case 18:{const ge=de.lexeme;this.z();let _=null;if(!(0,N.$Ge)(ge)){const ie=ge.indexOf("/"),G=ge.lastIndexOf("/");if(ie!==G&&ie>=0){const te=ge.slice(ie+1,G),fe=ge[G+1]==="i"?"i":"";try{_=new RegExp(te,fe)}catch{throw this.B("REGEX",de)}}}if(_===null)throw this.B("REGEX",de);return M.create(re,_)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,l);const de=this.u();return t.notIn(re,de)}switch(this.D().type){case 3:{this.z();const de=this.u();if(this.x().type===18)return t.equals(re,de);switch(de){case"true":return t.has(re);case"false":return t.not(re);default:return t.equals(re,de)}}case 4:{this.z();const de=this.u();if(this.x().type===18)return t.notEquals(re,de);switch(de){case"true":return t.not(re);case"false":return t.has(re);default:return t.notEquals(re,de)}}case 5:return this.z(),j.create(re,this.u());case 6:return this.z(),O.create(re,this.u());case 7:return this.z(),U.create(re,this.u());case 8:return this.z(),F.create(re,this.u());case 13:return this.z(),t.in(re,this.u());default:return t.has(re)}}case 20:throw this.h.push({message:n,offset:B.offset,lexeme:"",additionalInfo:o}),c.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case 17:case 18:return this.z(),B.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,re){if(this.C(B))return this.z();throw this.B(re,this.D())}B(B,re,ye){const de=(0,R.localize)(8,null,B,g.$Xi.getLexeme(re)),ge=re.offset,_=g.$Xi.getLexeme(re);return this.h.push({message:de,offset:ge,lexeme:_,additionalInfo:ye}),c.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Zi=c;class t{static false(){return a.INSTANCE}static true(){return h.INSTANCE}static has(B){return S.create(B)}static equals(B,re){return P.create(B,re)}static notEquals(B,re){return E.create(B,re)}static regex(B,re){return M.create(B,re)}static in(B,re){return w.create(B,re)}static notIn(B,re){return p.create(B,re)}static not(B){return L.create(B)}static and(...B){return ue.create(B,null,!0)}static or(...B){return X.create(B,null,!0)}static greater(B,re){return U.create(B,re)}static greaterEquals(B,re){return F.create(B,re)}static smaller(B,re){return j.create(B,re)}static smallerEquals(B,re){return O.create(B,re)}static{this.c=new c({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$1i=t;function r(K){const B=new c({regexParsingWithErrorRecovery:!1});return K.map(re=>(B.parse(re),B.lexingErrors.length>0?B.lexingErrors.map(ye=>({errorMessage:ye.additionalInfo?(0,R.localize)(9,null,ye.additionalInfo):(0,R.localize)(10,null),offset:ye.offset,length:ye.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(ye=>({errorMessage:ye.additionalInfo?`${ye.message}. ${ye.additionalInfo}`:ye.message,offset:ye.offset,length:ye.lexeme.length})):[]))}e.$2i=r;function d(K,B){const re=K?K.substituteConstants():void 0,ye=B?B.substituteConstants():void 0;return!re&&!ye?!0:!re||!ye?!1:re.equals(ye)}e.$3i=d;function u(K,B){return K.cmp(B)}class a{static{this.INSTANCE=new a}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return h.INSTANCE}}e.$4i=a;class h{static{this.INSTANCE=new h}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return a.INSTANCE}}e.$5i=h;class S{static create(B,re=null){const ye=$.get(B);return typeof ye=="boolean"?ye?h.INSTANCE:a.INSTANCE:new S(B,re)}constructor(B,re){this.key=B,this.c=re,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:x(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=$.get(this.key);return typeof B=="boolean"?B?h.INSTANCE:a.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$6i=S;class P{static create(B,re,ye=null){if(typeof re=="boolean")return re?S.create(B,ye):L.create(B,ye);const de=$.get(B);return typeof de=="boolean"?re===(de?"true":"false")?h.INSTANCE:a.INSTANCE:new P(B,re,ye)}constructor(B,re,ye){this.c=B,this.d=re,this.f=ye,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:he(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=$.get(this.c);if(typeof B=="boolean"){const re=B?"true":"false";return this.d===re?h.INSTANCE:a.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$7i=P;class w{static create(B,re){return new w(B,re)}constructor(B,re){this.d=B,this.f=re,this.type=10,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:he(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const re=B.getValue(this.f),ye=B.getValue(this.d);return Array.isArray(re)?re.includes(ye):typeof ye=="string"&&typeof re=="object"&&re!==null?A.call(re,ye):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$8i=w;class p{static create(B,re){return new p(B,re)}constructor(B,re){this.d=B,this.f=re,this.type=11,this.c=w.create(B,re)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$9i=p;class E{static create(B,re,ye=null){if(typeof re=="boolean")return re?L.create(B,ye):S.create(B,ye);const de=$.get(B);return typeof de=="boolean"?re===(de?"true":"false")?a.INSTANCE:h.INSTANCE:new E(B,re,ye)}constructor(B,re,ye){this.c=B,this.d=re,this.f=ye,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:he(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=$.get(this.c);if(typeof B=="boolean"){const re=B?"true":"false";return this.d===re?a.INSTANCE:h.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$0i=E;class L{static create(B,re=null){const ye=$.get(B);return typeof ye=="boolean"?ye?a.INSTANCE:h.INSTANCE:new L(B,re)}constructor(B,re){this.c=B,this.d=re,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:x(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=$.get(this.c);return typeof B=="boolean"?B?a.INSTANCE:h.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=S.create(this.c,this)),this.d}}e.$$i=L;function T(K,B){if(typeof K=="string"){const re=parseFloat(K);isNaN(re)||(K=re)}return typeof K=="string"||typeof K=="number"?B(K):a.INSTANCE}class U{static create(B,re,ye=null){return T(re,de=>new U(B,de,ye))}constructor(B,re,ye){this.c=B,this.d=re,this.f=ye,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:he(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$_i=U;class F{static create(B,re,ye=null){return T(re,de=>new F(B,de,ye))}constructor(B,re,ye){this.c=B,this.d=re,this.f=ye,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:he(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$aj=F;class j{static create(B,re,ye=null){return T(re,de=>new j(B,de,ye))}constructor(B,re,ye){this.c=B,this.d=re,this.f=ye,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:he(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$bj=j;class O{static create(B,re,ye=null){return T(re,de=>new O(B,de,ye))}constructor(B,re,ye){this.c=B,this.d=re,this.f=ye,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:he(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$cj=O;class M{static create(B,re){return new M(B,re)}constructor(B,re){this.d=B,this.f=re,this.type=7,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const re=this.f?this.f.source:"",ye=B.f?B.f.source:"";return re<ye?-1:re>ye?1:0}equals(B){if(B.type===this.type){const re=this.f?this.f.source:"",ye=B.f?B.f.source:"";return this.d===B.d&&re===ye}return!1}substituteConstants(){return this}evaluate(B){const re=B.getValue(this.d);return this.f?this.f.test(re):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=W.create(this)),this.c}}e.$dj=M;class W{static create(B){return new W(B)}constructor(B){this.c=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new W(this.c.map(B))}negate(){return this.c}}e.$ej=W;function Y(K){let B=null;for(let re=0,ye=K.length;re<ye;re++){const de=K[re].substituteConstants();if(K[re]!==de&&B===null){B=[];for(let ge=0;ge<re;ge++)B[ge]=K[ge]}B!==null&&(B[re]=de)}return B===null?K:B}class ue{static create(B,re,ye){return ue.d(B,re,ye)}constructor(B,re){this.expr=B,this.c=re,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let re=0,ye=this.expr.length;re<ye;re++){const de=u(this.expr[re],B.expr[re]);if(de!==0)return de}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let re=0,ye=this.expr.length;re<ye;re++)if(!this.expr[re].equals(B.expr[re]))return!1;return!0}return!1}substituteConstants(){const B=Y(this.expr);return B===this.expr?this:ue.create(B,this.c,!1)}evaluate(B){for(let re=0,ye=this.expr.length;re<ye;re++)if(!this.expr[re].evaluate(B))return!1;return!0}static d(B,re,ye){const de=[];let ge=!1;for(const _ of B)if(_){if(_.type===1){ge=!0;continue}if(_.type===0)return a.INSTANCE;if(_.type===6){de.push(..._.expr);continue}de.push(_)}if(de.length===0&&ge)return h.INSTANCE;if(de.length!==0){if(de.length===1)return de[0];de.sort(u);for(let _=1;_<de.length;_++)de[_-1].equals(de[_])&&(de.splice(_,1),_--);if(de.length===1)return de[0];for(;de.length>1;){const _=de[de.length-1];if(_.type!==9)break;de.pop();const ie=de.pop(),G=de.length===0,te=X.create(_.expr.map(fe=>ue.create([fe,ie],null,ye)),null,G);te&&(de.push(te),de.sort(u))}if(de.length===1)return de[0];if(ye){for(let _=0;_<de.length;_++)for(let ie=_+1;ie<de.length;ie++)if(de[_].negate().equals(de[ie]))return a.INSTANCE;if(de.length===1)return de[0]}return new ue(de,re)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const re of this.expr)B.push(...re.keys());return B}map(B){return new ue(this.expr.map(re=>re.map(B)),null)}negate(){if(!this.c){const B=[];for(const re of this.expr)B.push(re.negate());this.c=X.create(B,this,!0)}return this.c}}e.$fj=ue;class X{static create(B,re,ye){return X.d(B,re,ye)}constructor(B,re){this.expr=B,this.c=re,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let re=0,ye=this.expr.length;re<ye;re++){const de=u(this.expr[re],B.expr[re]);if(de!==0)return de}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let re=0,ye=this.expr.length;re<ye;re++)if(!this.expr[re].equals(B.expr[re]))return!1;return!0}return!1}substituteConstants(){const B=Y(this.expr);return B===this.expr?this:X.create(B,this.c,!1)}evaluate(B){for(let re=0,ye=this.expr.length;re<ye;re++)if(this.expr[re].evaluate(B))return!0;return!1}static d(B,re,ye){let de=[],ge=!1;if(B){for(let _=0,ie=B.length;_<ie;_++){const G=B[_];if(G){if(G.type===0){ge=!0;continue}if(G.type===1)return h.INSTANCE;if(G.type===9){de=de.concat(G.expr);continue}de.push(G)}}if(de.length===0&&ge)return a.INSTANCE;de.sort(u)}if(de.length!==0){if(de.length===1)return de[0];for(let _=1;_<de.length;_++)de[_-1].equals(de[_])&&(de.splice(_,1),_--);if(de.length===1)return de[0];if(ye){for(let _=0;_<de.length;_++)for(let ie=_+1;ie<de.length;ie++)if(de[_].negate().equals(de[ie]))return h.INSTANCE;if(de.length===1)return de[0]}return new X(de,re)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const re of this.expr)B.push(...re.keys());return B}map(B){return new X(this.expr.map(re=>re.map(B)),null)}negate(){if(!this.c){const B=[];for(const re of this.expr)B.push(re.negate());for(;B.length>1;){const re=B.shift(),ye=B.shift(),de=[];for(const ge of ce(re))for(const _ of ce(ye))de.push(ue.create([ge,_],null,!1));B.unshift(X.create(de,null,!1))}this.c=X.create(B,this,!0)}return this.c}}e.$gj=X;class J extends S{static{this.d=[]}static all(){return J.d.values()}constructor(B,re,ye){super(B,null),this.f=re,typeof ye=="object"?J.d.push({...ye,key:B}):ye!==!0&&J.d.push({key:B,description:ye,type:re!=null?typeof re:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return P.create(this.key,B)}notEqualsTo(B){return E.create(this.key,B)}}e.$hj=J,e.$ij=(0,I.$3h)("contextKeyService");function x(K,B){return K<B?-1:K>B?1:0}function he(K,B,re,ye){return K<re?-1:K>re?1:B<ye?-1:B>ye?1:0}function Z(K,B){if(K.type===0||B.type===1)return!0;if(K.type===9)return B.type===9?we(K.expr,B.expr):!1;if(B.type===9){for(const re of B.expr)if(Z(K,re))return!0;return!1}if(K.type===6){if(B.type===6)return we(B.expr,K.expr);for(const re of K.expr)if(Z(re,B))return!0;return!1}return K.equals(B)}e.$jj=Z;function we(K,B){let re=0,ye=0;for(;re<K.length&&ye<B.length;){const de=K[re].cmp(B[ye]);if(de<0)return!1;de===0&&re++,ye++}return re===K.length}function ce(K){return K.type===9?K.expr:[K]}}),define(Se[240],ke([1,0,23,39,199,5,102,10,24]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wv=e.$Vv=e.ConfirmResult=e.$Uv=e.$Tv=e.$Sv=void 0,e.$Sv=(0,I.$3h)("dialogService");var y;(function(l){l[l.Confirmation=1]="Confirmation",l[l.Prompt=2]="Prompt",l[l.Input=3]="Input"})(y||(y={}));class A{a(f){return this.d(f,y.Confirmation)}b(f){return this.d(f,y.Prompt)}c(f){return this.d(f,y.Input)}d(f,s){const i=[];switch(s){case y.Confirmation:{const n=f;n.primaryButton?i.push(n.primaryButton):i.push((0,g.localize)(0,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,g.localize)(1,null));break}case y.Prompt:{const n=f;Array.isArray(n.buttons)&&n.buttons.length>0&&i.push(...n.buttons.map(o=>o.label)),n.cancelButton&&(n.cancelButton===!0?i.push((0,g.localize)(2,null)):typeof n.cancelButton=="string"?i.push(n.cancelButton):n.cancelButton.label?i.push(n.cancelButton.label):i.push((0,g.localize)(3,null))),i.length===0&&i.push((0,g.localize)(4,null));break}case y.Input:{const n=f;n.primaryButton?i.push(n.primaryButton):i.push((0,g.localize)(5,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,g.localize)(6,null));break}}return i}e(f){if(typeof f=="string")return f;if(typeof f=="number")return f===N.default.Info?"info":f===N.default.Error?"error":f===N.default.Warning?"warning":"none"}f(f,s,i){const n=[...f.buttons??[]];f.cancelButton&&typeof f.cancelButton!="string"&&typeof f.cancelButton!="boolean"&&n.push(f.cancelButton);let o=n[s]?.run({checkboxChecked:i});return o instanceof Promise||(o=Promise.resolve(o)),{result:o,checkboxChecked:i}}}e.$Tv=A,e.$Uv=(0,I.$3h)("fileDialogService");var C;(function(l){l[l.SAVE=0]="SAVE",l[l.DONT_SAVE=1]="DONT_SAVE",l[l.CANCEL=2]="CANCEL"})(C||(e.ConfirmResult=C={}));const m=10;function v(l){const f=[];return f.push(...l.slice(0,m).map(s=>typeof s=="string"?s:(0,D.$Bg)(s))),l.length>m&&(l.length-m===1?f.push((0,g.localize)(7,null)):f.push((0,g.localize)(8,null,l.length-m))),f.push(""),f.join(`
`)}e.$Vv=v;function k(l,f){const s=(0,$.$jn)(l);let i=(s.buttons??[]).map(t=>(0,R.$Pv)(t)),n=(l.buttons||[]).map((t,r)=>r),o=0,c=s.cancelId??i.length-1;if(i.length>1){const t=typeof c=="number"?i[c]:void 0;if(b.$k||b.$j){if(typeof t=="string"&&i.length>1&&c!==1){i.splice(c,1),i.splice(1,0,t);const r=n[c];n.splice(c,1),n.splice(1,0,r),c=1}b.$k&&i.length>1&&(i=i.reverse(),n=n.reverse(),o=i.length-1,typeof t=="string"&&(c=o-1))}else if(b.$i&&typeof t=="string"&&i.length>1&&c!==i.length-1){i.splice(c,1),i.push(t);const r=n[c];n.splice(c,1),n.push(r),c=i.length-1}}return s.buttons=i,s.defaultId=o,s.cancelId=c,s.noLink=!0,s.title=s.title||f.nameLong,{options:s,buttonIndeces:n}}e.$Wv=k}),define(Se[133],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=e.$0h=void 0,e.$0h=(0,D.$3h)("environmentService"),e.$$h=(0,D.$4h)(e.$0h)}),define(Se[134],ke([1,0,200,5]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$mo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=void 0,e.$ao="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$bo=new RegExp(e.$ao),e.$co="__web_extension",e.$do="skipWalkthrough",e.$eo="extensionsSync",e.$fo="dependecyOrPackExtensionInstall";function g(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$go=g;function I(s){switch(s){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$ho=I;function R(s,i){switch(s){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$io=R;function b(s,i){return i==="web"&&!s.includes("web")}e.$jo=b;function $(s,i,n){return b(i,n)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===n}e.$ko=$;function y(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.$lo=y;var A;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var C;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var m;(function(s){s.Install="install",s.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var v;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$mo=(0,N.$3h)("extensionGalleryService");var k;(function(s){s.Unsupported="Unsupported",s.Deprecated="Deprecated",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Signature="Signature",s.Internal="Internal"})(k||(e.ExtensionManagementErrorCode=k={}));var l;(function(s){s.UnknownError="UnknownError",s.PackageIsInvalidZip="PackageIsInvalidZip",s.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(l||(e.ExtensionSignaturetErrorCode=l={}));class f extends Error{constructor(i,n){super(i),this.code=n,this.name=n}}e.$no=f,e.$oo=(0,N.$3h)("extensionManagementService"),e.$po="extensionsIdentifiers/disabled",e.$qo="extensionsIdentifiers/enabled",e.$ro=(0,N.$3h)("IGlobalExtensionEnablementService"),e.$so=(0,N.$3h)("IExtensionTipsService"),e.$to=(0,D.localize)(0,null),e.$uo={value:e.$to,original:"Extensions"},e.$vo={value:(0,D.localize)(1,null),original:"Preferences"}}),define(Se[241],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b2b=e.$a2b=void 0,e.$a2b=(0,D.$3h)("externalTerminal"),e.$b2b="Terminal.app"}),define(Se[242],ke([1,0,51,52,17,16,10,101,31,104,202,241]),function(me,e,D,N,g,I,R,b,$,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$9b=e.$09b=e.$99b=void 0;const m=A.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:k.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class k extends v{static{this.b="cmd.exe"}openTerminal(c,t){return this.spawnTerminal(D,c,y.$Ql(),t)}spawnTerminal(c,t,r,d){const u=t.windowsExec||k.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const a=I.$nc(u,".exe").toLowerCase();if(a==="cmder")return c.spawn(u,d?[d]:void 0),Promise.resolve(void 0);const h=["/c","start","/wait"];return u.indexOf(" ")>=0&&h.push('""'),h.push(u),a==="wt"&&h.push("-d ."),new Promise((S,P)=>{const w=s(process),p=c.spawn(r,h,{cwd:d,env:w,detached:!0});p.on("error",P),p.on("exit",()=>S())})}async runInTerminal(c,t,r,d,u){const a="windowsExec"in u&&u.windowsExec?u.windowsExec:k.getDefaultTerminalWindows(),h=await k.f();return new Promise((S,P)=>{const w=`"${t} - ${m}"`,p=`""${r.join('" "')}" & pause"`,E=Object.assign({},s(process),d);Object.keys(E).filter(j=>E[j]===null).forEach(j=>delete E[j]);const L={cwd:t,env:E,windowsVerbatimArguments:!0};let T,U;I.$nc(a,".exe")==="wt"?(T=a,U=["-d",".",k.b,"/c",p]):h?(T=h,U=["-d",t,a,"/c",p]):(T=k.b,U=["/c","start",w,"/wait",a,"/c",p]),D.spawn(T,U,L).on("error",j=>{P(i(j))}),S(void 0)})}static getDefaultTerminalWindows(){if(!k.d){const c=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");k.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${c?"Sysnative":"System32"}\\cmd.exe`}return k.d}static async f(){try{const c=await y.win32.findExecutable("wt");return await $.Promises.exists(c)?c:void 0}catch{return}}}e.$99b=k,Ge([N.$uh],k,"f",null);class l extends v{static{this.b="/usr/bin/osascript"}openTerminal(c,t){return this.spawnTerminal(D,c,t)}runInTerminal(c,t,r,d,u){const a=u.osxExec||C.$b2b;return new Promise((h,S)=>{if(a===C.$b2b||a==="iTerm.app"){const P=a===C.$b2b?"TerminalHelper":"iTermHelper",p=[g.$lg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${P}.scpt`).fsPath,"-t",c||m,"-w",t];for(const T of r)p.push("-a"),p.push(T);if(d){const T=Object.assign({},s(process),d);for(const U in T){const F=T[U];F===null?(p.push("-u"),p.push(U)):(p.push("-e"),p.push(`${U}=${F}`))}}let E="";const L=D.spawn(l.b,p);L.on("error",T=>{S(i(T))}),L.stderr.on("data",T=>{E+=T.toString()}),L.on("exit",T=>{if(T===0)h(void 0);else if(E){const U=E.split(`
`,1);S(new Error(U[0]))}else S(new Error(A.localize(1,null,P,T)))})}else S(new Error(A.localize(2,null,a)))})}spawnTerminal(c,t,r){const d=t.osxExec||C.$b2b;return new Promise((u,a)=>{const h=["-a",d];r&&h.push(r);const S=s(process),P=c.spawn("/usr/bin/open",h,{cwd:r,env:S});P.on("error",a),P.on("exit",()=>u())})}}e.$09b=l;class f extends v{static{this.b=A.localize(3,null)}openTerminal(c,t){return this.spawnTerminal(D,c,t)}runInTerminal(c,t,r,d,u){const a=u.linuxExec?Promise.resolve(u.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((h,S)=>{const P=[];a.then(w=>{w.indexOf("gnome-terminal")>=0?P.push("-x"):P.push("-e"),P.push("bash"),P.push("-c");const p=`${n(r)}; echo; read -p "${f.b}" -n1;`;P.push(`''${p}''`);const E=Object.assign({},s(process),d);Object.keys(E).filter(F=>E[F]===null).forEach(F=>delete E[F]);const L={cwd:t,env:E};let T="";const U=D.spawn(w,P,L);U.on("error",F=>{S(i(F))}),U.stderr.on("data",F=>{T+=F.toString()}),U.on("exit",F=>{if(F===0)h(void 0);else if(T){const j=T.split(`
`,1);S(new Error(j[0]))}else S(new Error(A.localize(4,null,w,F)))})})})}static async getDefaultTerminalLinuxReady(){if(!f.d)if(!R.$k)f.d=Promise.resolve("xterm");else{const c=await $.Promises.exists("/etc/debian_version");f.d=new Promise(t=>{c?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return f.d}spawnTerminal(c,t,r){const d=t.linuxExec?Promise.resolve(t.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((u,a)=>{d.then(h=>{const S=s(process),P=c.spawn(h,[],{cwd:r,env:S});P.on("error",a),P.on("exit",()=>u())})})}}e.$$9b=f;function s(o){const c={...o.env};return(0,b.$Ol)(c),c}function i(o){return"errno"in o&&o.errno==="ENOENT"&&"path"in o&&typeof o.path=="string"?new Error(A.localize(5,null,o.path)):o}function n(o){let c="";for(const t of o)t.indexOf(" ")>=0?c+='"'+t+'"':c+=t,c+=" ";return c}}),define(Se[32],ke([1,0,77,16,12,18,2,203,5,10,17,43]),function(me,e,D,N,g,I,R,b,$,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.FileKind=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.FileOperationResult=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.FileChangeType=e.$Fk=e.FileOperation=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.FileSystemProviderErrorCode=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.FileSystemProviderCapabilities=e.$pk=e.FilePermission=e.FileType=e.$ok=e.$nk=void 0,e.$nk=(0,$.$3h)("fileService");function m(Z){return Z.create===!0}e.$ok=m;var v;(function(Z){Z[Z.Unknown=0]="Unknown",Z[Z.File=1]="File",Z[Z.Directory=2]="Directory",Z[Z.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var k;(function(Z){Z[Z.Readonly=1]="Readonly",Z[Z.Locked=2]="Locked"})(k||(e.FilePermission=k={}));function l(Z){const we=Z;return!!we&&typeof we.onDidChange=="function"}e.$pk=l;var f;(function(Z){Z[Z.None=0]="None",Z[Z.FileReadWrite=2]="FileReadWrite",Z[Z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Z[Z.FileReadStream=16]="FileReadStream",Z[Z.FileFolderCopy=8]="FileFolderCopy",Z[Z.PathCaseSensitive=1024]="PathCaseSensitive",Z[Z.Readonly=2048]="Readonly",Z[Z.Trash=4096]="Trash",Z[Z.FileWriteUnlock=8192]="FileWriteUnlock",Z[Z.FileAtomicRead=16384]="FileAtomicRead",Z[Z.FileAtomicWrite=32768]="FileAtomicWrite",Z[Z.FileAtomicDelete=65536]="FileAtomicDelete",Z[Z.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function s(Z){return!!(Z.capabilities&2)}e.$qk=s;function i(Z){return!!(Z.capabilities&8)}e.$rk=i;function n(Z){return!!(Z.capabilities&131072)}e.$sk=n;function o(Z){return!!(Z.capabilities&4)}e.$tk=o;function c(Z){return!!(Z.capabilities&16)}e.$uk=c;function t(Z){return s(Z)?!!(Z.capabilities&16384):!1}e.$vk=t;function r(Z){return s(Z)?!!(Z.capabilities&32768):!1}e.$wk=r;function d(Z){return!!(Z.capabilities&65536)}e.$xk=d;function u(Z){return!!(Z.capabilities&2048)}e.$yk=u;var a;(function(Z){Z.FileExists="EntryExists",Z.FileNotFound="EntryNotFound",Z.FileNotADirectory="EntryNotADirectory",Z.FileIsADirectory="EntryIsADirectory",Z.FileExceedsStorageQuota="EntryExceedsStorageQuota",Z.FileTooLarge="EntryTooLarge",Z.FileWriteLocked="EntryWriteLocked",Z.NoPermissions="NoPermissions",Z.Unavailable="Unavailable",Z.Unknown="Unknown"})(a||(e.FileSystemProviderErrorCode=a={}));class h extends Error{static create(we,ce){const K=new h(we.toString(),ce);return w(K,ce),K}constructor(we,ce){super(we),this.code=ce}}e.$zk=h;function S(Z,we){return h.create(Z,we)}e.$Ak=S;function P(Z){return Z||S((0,b.localize)(0,null),a.Unknown)}e.$Bk=P;function w(Z,we){return Z.name=we?`${we} (FileSystemError)`:"FileSystemError",Z}e.$Ck=w;function p(Z){if(!Z)return a.Unknown;if(Z instanceof h)return Z.code;const we=/^(.+) \(FileSystemError\)$/.exec(Z.name);if(!we)return a.Unknown;switch(we[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.$Dk=p;function E(Z){if(Z instanceof O)return Z.fileOperationResult;switch(p(Z)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 9;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileTooLarge:return 7;default:return 10}}e.$Ek=E;var L;(function(Z){Z[Z.CREATE=0]="CREATE",Z[Z.DELETE=1]="DELETE",Z[Z.MOVE=2]="MOVE",Z[Z.COPY=3]="COPY",Z[Z.WRITE=4]="WRITE"})(L||(e.FileOperation=L={}));class T{constructor(we,ce,K){this.resource=we,this.operation=ce,this.target=K}isOperation(we){return this.operation===we}}e.$Fk=T;var U;(function(Z){Z[Z.UPDATED=0]="UPDATED",Z[Z.ADDED=1]="ADDED",Z[Z.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class F{static{this.a=null}constructor(we,ce){this.c=ce,this.b=void 0,this.d=new C.$V(()=>{const K=D.$9h.forUris(()=>this.c);return K.fill(this.rawAdded.map(B=>[B,!0])),K}),this.f=new C.$V(()=>{const K=D.$9h.forUris(()=>this.c);return K.fill(this.rawUpdated.map(B=>[B,!0])),K}),this.g=new C.$V(()=>{const K=D.$9h.forUris(()=>this.c);return K.fill(this.rawDeleted.map(B=>[B,!0])),K}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const K of we){switch(K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}this.b!==F.a&&(typeof K.cId=="number"?this.b===void 0?this.b=K.cId:this.b!==K.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(we,...ce){return this.h(we,{includeChildren:!1},...ce)}affects(we,...ce){return this.h(we,{includeChildren:!0},...ce)}h(we,ce,...K){if(!we)return!1;const B=K.length>0;return!!((!B||K.includes(1))&&(this.d.value.get(we)||ce.includeChildren&&this.d.value.findSuperstr(we))||(!B||K.includes(0))&&(this.f.value.get(we)||ce.includeChildren&&this.f.value.findSuperstr(we))||(!B||K.includes(2))&&(this.g.value.findSubstr(we)||ce.includeChildren&&this.g.value.findSuperstr(we)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(we){return this.b===we}hasCorrelation(){return typeof this.b=="number"}}e.$Gk=F;function j(Z,we,ce){return!Z||!we||Z===we||we.length>Z.length?!1:(we.charAt(we.length-1)!==N.sep&&(we+=N.sep),ce?(0,g.$0e)(Z,we):Z.indexOf(we)===0)}e.$Hk=j;class O extends Error{constructor(we,ce,K){super(we),this.fileOperationResult=ce,this.options=K}}e.$Ik=O;class M extends O{constructor(we,ce,K,B){super(we,ce,B),this.fileOperationResult=ce,this.size=K}}e.$Jk=M;class W extends O{constructor(we,ce,K){super(we,2,K),this.stat=ce}}e.$Kk=W;var Y;(function(Z){Z[Z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Z[Z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Z[Z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Z[Z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Z[Z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Z[Z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Z[Z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Z[Z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Z[Z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Z[Z.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Z[Z.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Y||(e.FileOperationResult=Y={})),e.$Lk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Mk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Nk="files.associations",e.$Ok="files.exclude",e.$Pk="files.readonlyInclude",e.$Qk="files.readonlyExclude",e.$Rk="files.readonlyFromPermissions";var ue;(function(Z){Z[Z.FILE=0]="FILE",Z[Z.FOLDER=1]="FOLDER",Z[Z.ROOT_FOLDER=2]="ROOT_FOLDER"})(ue||(e.FileKind=ue={})),e.$Sk="";function X(Z){if(!(typeof Z.size!="number"||typeof Z.mtime!="number"))return Z.mtime.toString(29)+Z.size.toString(31)}e.$Tk=X;async function J(Z,we){if(!we.hasProvider(R.URI.from({scheme:Z.scheme})))return new Promise(ce=>{const K=we.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===Z.scheme&&B.added&&(K.dispose(),ce())})})}e.$Uk=J;class x{static{this.KB=1024}static{this.MB=x.KB*x.KB}static{this.GB=x.MB*x.KB}static{this.TB=x.GB*x.KB}static formatSize(we){return(0,I.$Jf)(we)||(we=0),we<x.KB?(0,b.localize)(1,null,we.toFixed(0)):we<x.MB?(0,b.localize)(2,null,(we/x.KB).toFixed(2)):we<x.GB?(0,b.localize)(3,null,(we/x.MB).toFixed(2)):we<x.TB?(0,b.localize)(4,null,(we/x.GB).toFixed(2)):(0,b.localize)(5,null,(we/x.TB).toFixed(2))}}e.$Vk=x;function he(Z){const we=typeof Z=="string"||Z?.scheme===A.Schemas.vscodeRemote;return typeof Z!="string"&&Z?.scheme===A.Schemas.file?1024*x.MB:we?10*x.MB:y.$o?50*x.MB:1024*x.MB}e.$Wk=he}),define(Se[243],ke([1,0,22,14,204,32]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=void 0;async function R(A,C,m,v,k,l){let f;try{await b(A,C,m,v,k,l)}catch(s){f=s}finally{f&&k.errorTransformer&&(f=k.errorTransformer(f)),typeof f<"u"&&m.error(f),m.end()}}e.$2p=R;async function b(A,C,m,v,k,l){$(l);const f=await A.open(C,{create:!1});try{$(l);let s=0,i=0,n=k&&typeof k.length=="number"?k.length:void 0,o=D.$ge.alloc(Math.min(k.bufferSize,typeof n=="number"?n:k.bufferSize)),c=k&&typeof k.position=="number"?k.position:0,t=0;do i=await A.read(f,c,o.buffer,t,o.byteLength-t),c+=i,t+=i,s+=i,typeof n=="number"&&(n-=i),t===o.byteLength&&(await m.write(v(o)),o=D.$ge.alloc(Math.min(k.bufferSize,typeof n=="number"?n:k.bufferSize)),t=0);while(i>0&&(typeof n!="number"||n>0)&&$(l)&&y(s,k));if(t>0){let r=t;typeof n=="number"&&(r=Math.min(t,n)),m.write(v(o.slice(0,r)))}}catch(s){throw(0,I.$Bk)(s)}finally{await A.close(f)}}function $(A){if(A.isCancellationRequested)throw(0,N.$6)();return!0}function y(A,C){if(typeof C?.limits?.size=="number"&&A>C.limits.size)throw(0,I.$Ak)((0,g.localize)(0,null),I.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Se[84],ke([1,0,34,3,16,10,2,32]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=e.$9p=e.$8p=e.$7p=e.$6p=e.$5p=e.$4p=void 0;function $(s){return s.recursive===!0}e.$4p=$;class y extends N.$Sc{static{this.a=5}constructor(i,n,o,c){super(),this.h=i,this.j=n,this.m=o,this.n=c,this.c=this.B(new N.$Tc),this.f=void 0,this.g=0}s(){const i=new N.$Rc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(n=>this.h(n))),i.add(this.b.onDidLogMessage(n=>this.j(n))),i.add(this.b.onDidError(n=>this.t(n)))}t(i){this.n.restartOnError?this.g<y.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$5p=y;class A extends y{constructor(i,n,o){super(i,n,o,{type:"node.js",restartOnError:!1})}}e.$6p=A;class C extends y{constructor(i,n,o){super(i,n,o,{type:"universal",restartOnError:!0})}}e.$7p=C;function m(s){return s.map(i=>({type:i.type,resource:R.URI.revive(i.resource),cId:i.cId}))}e.$8p=m;function v(s){const i=new f;for(const n of s)i.processEvent(n);return i.coalesce()}e.$9p=v;function k(s,i){return typeof i=="string"&&!i.startsWith(D.$Fj)&&!(0,g.$ic)(i)?{base:s,pattern:i}:i}e.$0p=k;function l(s,i){const n=[];for(const o of i)n.push((0,D.$Jj)(k(s,o)));return n}e.$$p=l;class f{constructor(){this.a=new Set,this.b=new Map}c(i){return I.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const n=this.b.get(this.c(i));let o=!1;if(n){const c=n.type,t=i.type;n.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?o=!0:c===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(n)):c===2&&t===1?n.type=0:c===1&&t===0||(n.type=t)}else o=!0;o&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],n=[];return Array.from(this.a).filter(o=>o.type!==2?(i.push(o),!1):!0).sort((o,c)=>o.resource.fsPath.length-c.resource.fsPath.length).filter(o=>n.some(c=>(0,b.$Hk)(o.resource.fsPath,c,!I.$k))?!1:(n.push(o.resource.fsPath),!0)).concat(i)}}}),define(Se[244],ke([1,0,56,11,21,33,3,76,16,10,23,2,103,31,84]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$lq=void 0;class l extends R.$Sc{static{this.a=100}static{this.b=75}constructor(i,n,o,c){super(),this.m=i,this.n=n,this.r=o,this.s=c,this.c=this.B(new N.$fh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new N.$eh(t=>this.z(t),l.b)),this.g=(0,k.$$p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,k.$$p)(this.m.path,this.m.includes):void 0,this.j=new g.$3d,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const n=await v.Promises.stat(i);this.B(await this.w(i,n.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let n=i.path;try{n=await v.Promises.realpath(i.path),i.path===n&&(n=await(0,m.$iq)(i.path)??i.path),i.path!==n&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${n})`)}catch{}return n}async w(i,n){if(y.$j&&(0,I.$5f)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.$Sc.None;const o=new g.$3d(this.j.token),c=new R.$Rc;try{const t=C.URI.file(this.m.path),r=(0,$.$nc)(i),d=(0,D.watch)(i);c.add((0,R.$Qc)(()=>{d.removeAllListeners(),d.close()})),this.G(`Started watching: '${i}'`);const u=new Set;if(n)try{for(const h of await v.Promises.readdir(i))u.add(h)}catch(h){this.D(h)}const a=new Map;c.add((0,R.$Qc)(()=>{for(const[,h]of a)h.dispose();a.clear()})),d.on("error",(h,S)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${h}, ${S})`),this.dispose()}),d.on("change",(h,S)=>{if(o.token.isCancellationRequested)return;this.G(`[raw] ["${h}"] ${S}`);let P="";if(S&&(P=S.toString(),y.$j&&(P=(0,b.$Dl)(P))),!(!P||h!=="change"&&h!=="rename"))if(n)if(h==="rename"){a.get(P)?.dispose();const w=setTimeout(async()=>{if(a.delete(P),P===r&&!await v.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const p=await this.C((0,$.$jc)(i,P));if(o.token.isCancellationRequested)return;let E;p?u.has(P)?E=0:(E=1,u.add(P)):(u.delete(P),E=2),this.y({resource:(0,A.$Eg)(t,P),type:E,cId:this.m.correlationId})},l.a);a.set(P,(0,R.$Qc)(()=>clearTimeout(w)))}else{let w;u.has(P)?w=0:(w=1,u.add(P)),this.y({resource:(0,A.$Eg)(t,P),type:w,cId:this.m.correlationId})}else if(h==="rename"||P!==r){const w=setTimeout(async()=>{const p=await v.Promises.exists(i);o.token.isCancellationRequested||(p?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),c.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},l.a);c.clear(),c.add((0,R.$Qc)(()=>clearTimeout(w)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await v.Promises.exists(i)&&!o.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,R.$Qc)(()=>{o.dispose(!0),c.dispose()})}y(i,n=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!n&&this.g.some(o=>o(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!n&&this.h&&this.h.length>0&&!this.h.some(o=>o(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const n=(0,k.$9p)(i);if(n.length>0){if(this.s)for(const c of n)this.G(` >> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`);this.c.work(n)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(y.$k)return v.Promises.exists(i);try{const n=(0,$.$nc)(i);return(await v.Promises.readdir((0,$.$mc)(i))).some(c=>c===n)}catch(n){return this.G(n),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$lq=l;async function f(s,i,n,o,c=512){const t=await v.Promises.open(s,"r"),r=Buffer.allocUnsafe(c),d=new g.$3d(o);let u,a=!1;const h={path:s,excludes:[],recursive:!1},S=new l(h,P=>{(async()=>{for(const{type:w}of P)if(w===0){if(a)return;a=!0;try{for(;!d.token.isCancellationRequested;){const{bytesRead:p}=await v.Promises.read(t,r,0,c,null);if(!p||d.token.isCancellationRequested)break;i(r.slice(0,p))}}catch(p){u=new Error(p),d.dispose(!0)}finally{a=!1}}})()});return await S.ready,n(),new Promise((P,w)=>{d.token.onCancellationRequested(async()=>{S.dispose();try{await v.Promises.close(t)}catch(p){u=new Error(p)}u?w(u):P()})})}e.$mq=f}),define(Se[245],ke([1,0,4,34,3,10,244]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;class b extends g.$Sc{constructor(){super(...arguments),this.a=this.B(new D.$Sd),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Sd),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(y){const A=this.j(y),C=A.filter(v=>{const k=this.c.get(v.path);return k?!(0,N.$Nj)(k.request.excludes,v.excludes)||!(0,N.$Nj)(k.request.includes,v.includes):!0}),m=Array.from(this.c.values()).filter(({request:v})=>!A.find(k=>k.path===v.path&&(0,N.$Nj)(k.excludes,v.excludes)&&(0,N.$Nj)(k.includes,v.includes))).map(({request:v})=>v.path);C.length&&this.m(`Request to start watching: ${C.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"}, correlationId: ${typeof v.correlationId=="number"?v.correlationId:"<none>"})`).join(",")}`),m.length&&this.m(`Request to stop watching: ${m.join(",")}`);for(const v of m)this.h(v);for(const v of C)this.g(v)}g(y){const A=new R.$lq(y,m=>this.a.fire(m),m=>this.b.fire(m),this.f),C={request:y,instance:A};this.c.set(y.path,C)}async stop(){for(const[y]of this.c)this.h(y);this.c.clear()}h(y){const A=this.c.get(y);A&&(this.c.delete(y),A.instance.dispose())}j(y){const A=new Map;for(const C of y){const m=I.$k?C.path:C.path.toLowerCase();let v=A.get(C.correlationId);v||(v=new Map,A.set(C.correlationId,v)),v.set(m,C)}return Array.from(A.values()).map(C=>Array.from(C.values())).flat()}async setVerboseLogging(y){this.f=y;for(const[,A]of this.c)A.instance.setVerboseLogging(y)}m(y){this.f&&this.b.fire({type:"trace",message:this.n(y)})}n(y,A){return A?`[File Watcher (node.js)] ${y} (path: ${A.request.path})`:`[File Watcher (node.js)] ${y}`}}e.$nq=b}),define(Se[246],ke([1,0,84,245]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=void 0;class g extends D.$6p{constructor(R,b,$){super(R,b,$),this.s()}r(R){return R.add(new N.$nq)}}e.$oq=g}),define(Se[247],ke([1,0,17,81,187,84]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=void 0;class R extends I.$7p{constructor($,y,A){super($,y,A),this.s()}r($){const y=$.add(new g.$fq(D.$lg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(y.onDidProcessExit(({code:A,signal:C})=>this.t(`terminated by itself with code ${A}, signal: ${C}`))),N.ProxyChannel.toService((0,N.$Jh)(y.getChannel("watcher")))}}e.$gq=R}),define(Se[107],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=void 0;class D{constructor(...g){this.a=new Map;for(const[I,R]of g)this.set(I,R)}set(g,I){const R=this.a.get(g);return this.a.set(g,I),R}has(g){return this.a.has(g)}get(g){return this.a.get(g)}}e.$1h=D}),define(Se[248],ke([1,0,11,14,3,105,239,5,107,75]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=void 0;const A=!1;class C extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class m{constructor(f=new $.$1h,s=!1,i,n=A){this.f=f,this.g=s,this.h=i,this.i=n,this.o=new Set,this.f.set(b.$2h,this),this._globalGraph=n?i?._globalGraph??new R.$rq(o=>o):void 0}createChild(f){return new m(f,this.g,this,this.i)}invokeFunction(f,...s){const i=k.traceInvocation(this.i,f);let n=!1;try{return f({get:c=>{if(n)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(c,i);if(!t)throw new Error(`[invokeFunction] unknown service '${c}'`);return t}},...s)}finally{n=!0,i.stop()}}createInstance(f,...s){let i,n;return f instanceof I.$Zh?(i=k.traceCreation(this.i,f.ctor),n=this.j(f.ctor,f.staticArguments.concat(s),i)):(i=k.traceCreation(this.i,f),n=this.j(f,s,i)),i.stop(),n}j(f,s=[],i){const n=b._util.getServiceDependencies(f).sort((t,r)=>t.index-r.index),o=[];for(const t of n){const r=this.m(t.id,i);r||this.u(`[createInstance] ${f.name} depends on UNKNOWN service ${t.id}.`,!1),o.push(r)}const c=n.length>0?n[0].index:s.length;if(s.length!==c){console.trace(`[createInstance] First service dependency of ${f.name} at position ${c+1} conflicts with ${s.length} static arguments`);const t=c-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,c)}return Reflect.construct(f,s.concat(o))}k(f,s){if(this.f.get(f)instanceof I.$Zh)this.f.set(f,s);else if(this.h)this.h.k(f,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(f){const s=this.f.get(f);return!s&&this.h?this.h.l(f):s}m(f,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(f));const i=this.l(f);return i instanceof I.$Zh?this.q(f,i,s.branch(f,!0)):(s.branch(f,!1),i)}q(f,s,i){if(this.o.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this.o.add(f);try{return this.r(f,s,i)}finally{this.o.delete(f)}}r(f,s,i){const n=new R.$rq(t=>t.id.toString());let o=0;const c=[{id:f,desc:s,_trace:i}];for(;c.length;){const t=c.pop();if(n.lookupOrInsertNode(t),o++>1e3)throw new C(n);for(const r of b._util.getServiceDependencies(t.desc.ctor)){const d=this.l(r.id);if(d||this.u(`[createInstance] ${f} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),d instanceof I.$Zh){const u={id:r.id,desc:d,_trace:t._trace.branch(r.id,!0)};n.insertEdge(t,u),c.push(u)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new C(n);break}for(const{data:r}of t){if(this.l(r.id)instanceof I.$Zh){const u=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,u)}n.removeNode(r)}}return this.l(f)}s(f,s,i=[],n,o){if(this.f.get(f)instanceof I.$Zh)return this.t(f,s,i,n,o);if(this.h)return this.h.s(f,s,i,n,o);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(f,s,i=[],n,o){if(n){const c=new m(void 0,this.g,this,this.i);c.c=String(f);const t=new Map,r=new D.$jh(()=>{const d=c.j(s,i,o);for(const[u,a]of t){const h=d[u];if(typeof h=="function")for(const S of a)h.apply(d,S)}return t.clear(),d});return new Proxy(Object.create(null),{get(d,u){if(!r.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let S=t.get(u);return S||(S=new y.$3c,t.set(u,S)),(w,p,E)=>{const L=S.push([w,p,E]);return(0,g.$Qc)(L)}}if(u in d)return d[u];const a=r.value;let h=a[u];return typeof h!="function"||(h=h.bind(a),d[u]=h),h},set(d,u,a){return r.value[u]=a,!0},getPrototypeOf(d){return s.prototype}})}else return this.j(s,i,o)}u(f,s){if(s&&console.warn(f),this.g)throw new Error(f)}}e.$sq=m;var v;(function(l){l[l.None=0]="None",l[l.Creation=1]="Creation",l[l.Invocation=2]="Invocation",l[l.Branch=3]="Branch"})(v||(v={}));class k{static{this.all=new Set}static{this.c=new class extends k{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(f,s){return f?new k(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):k.c}static traceCreation(f,s){return f?new k(1,s.name):k.c}static{this.f=0}constructor(f,s){this.type=f,this.name=s,this.g=Date.now(),this.h=[]}branch(f,s){const i=new k(3,f.toString());return this.h.push([f,s,i]),i}stop(){const f=Date.now()-this.g;k.f+=f;let s=!1;function i(o,c){const t=[],r=new Array(o+1).join("	");for(const[d,u,a]of c.h)if(u&&a){s=!0,t.push(`${r}CREATES -> ${d}`);const h=i(o+1,a);h&&t.push(h)}else t.push(`${r}uses -> ${d}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${k.f.toFixed(2)}ms)`];(f>2||s)&&k.all.add(n.join(`
`))}}e.$tq=k}),define(Se[13],ke([1,0,44,4,54,3,28,10,23,18,2,46,5]),function(me,e,D,N,g,I,R,b,$,y,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.log=e.$nj=e.LogLevel=e.$mj=e.$lj=e.$kj=void 0,e.$kj=(0,m.$3h)("logService"),e.$lj=(0,m.$3h)("loggerService");function v(){return new Date().toISOString()}function k(w){return(0,y.$Jf)(w)}e.$mj=k;var l;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(l||(e.LogLevel=l={})),e.$nj=l.Info;function f(w,p,E){switch(p){case l.Trace:w.trace(E);break;case l.Debug:w.debug(E);break;case l.Info:w.info(E);break;case l.Warning:w.warn(E);break;case l.Error:w.error(E);break;case l.Off:break;default:throw new Error(`Invalid log level ${p}`)}}e.log=f;function s(w,p=!1){let E="";for(let L=0;L<w.length;L++){let T=w[L];if(T instanceof Error&&(T=(0,D.$Ni)(T,p)),typeof T=="object")try{T=JSON.stringify(T)}catch{}E+=(L>0?" ":"")+T}return E}class i extends I.$Sc{constructor(){super(...arguments),this.b=e.$nj,this.c=this.B(new N.$Sd),this.onDidChangeLogLevel=this.c.event}setLevel(p){this.b!==p&&(this.b=p,this.c.fire(this.b))}getLevel(){return this.b}f(p){return this.b!==l.Off&&this.b<=p}}e.$pj=i;class n extends i{constructor(p){super(),this.h=p}f(p){return this.h||super.f(p)}trace(p,...E){this.f(l.Trace)&&this.g(l.Trace,s([p,...E],!0))}debug(p,...E){this.f(l.Debug)&&this.g(l.Debug,s([p,...E]))}info(p,...E){this.f(l.Info)&&this.g(l.Info,s([p,...E]))}warn(p,...E){this.f(l.Warning)&&this.g(l.Warning,s([p,...E]))}error(p,...E){if(this.f(l.Error))if(p instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=p.stack,this.g(l.Error,s(L))}else this.g(l.Error,s([p,...E]))}flush(){}}e.$qj=n;class o extends i{constructor(p=e.$nj){super(),this.setLevel(p),this.g=!b.$i}trace(p,...E){this.f(l.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,p,...E):console.log(`[main ${v()}]`,p,...E))}debug(p,...E){this.f(l.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,p,...E):console.log(`[main ${v()}]`,p,...E))}info(p,...E){this.f(l.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,p,...E):console.log(`[main ${v()}]`,p,...E))}warn(p,...E){this.f(l.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,p,...E):console.warn(`[main ${v()}]`,p,...E))}error(p,...E){this.f(l.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,p,...E):console.error(`[main ${v()}]`,p,...E))}flush(){}}e.$rj=o;class c extends i{constructor(p=e.$nj,E=!0){super(),this.g=E,this.setLevel(p)}trace(p,...E){this.f(l.Trace)&&(this.g?console.log("%cTRACE","color: #888",p,...E):console.log(p,...E))}debug(p,...E){this.f(l.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",p,...E):console.log(p,...E))}info(p,...E){this.f(l.Info)&&(this.g?console.log("%c INFO","color: #33f",p,...E):console.log(p,...E))}warn(p,...E){this.f(l.Warning)&&(this.g?console.log("%c WARN","color: #993",p,...E):console.log(p,...E))}error(p,...E){this.f(l.Error)&&(this.g?console.log("%c  ERR","color: #f33",p,...E):console.error(p,...E))}flush(){}}e.$sj=c;class t extends i{constructor(p,E=e.$nj){super(),this.g=p,this.setLevel(E)}trace(p,...E){this.f(l.Trace)&&this.g.log(l.Trace,[this.h(p),...E])}debug(p,...E){this.f(l.Debug)&&this.g.log(l.Debug,[this.h(p),...E])}info(p,...E){this.f(l.Info)&&this.g.log(l.Info,[this.h(p),...E])}warn(p,...E){this.f(l.Warning)&&this.g.log(l.Warning,[this.h(p),...E])}error(p,...E){this.f(l.Error)&&this.g.log(l.Error,[this.h(p),...E])}h(p){return typeof p=="string"?p:(0,D.$Ni)(p,this.f(l.Trace))}flush(){}}e.$tj=t;class r extends i{constructor(p){super(),this.g=p,p.length&&this.setLevel(p[0].getLevel())}setLevel(p){for(const E of this.g)E.setLevel(p);super.setLevel(p)}trace(p,...E){for(const L of this.g)L.trace(p,...E)}debug(p,...E){for(const L of this.g)L.debug(p,...E)}info(p,...E){for(const L of this.g)L.info(p,...E)}warn(p,...E){for(const L of this.g)L.warn(p,...E)}error(p,...E){for(const L of this.g)L.error(p,...E)}flush(){for(const p of this.g)p.flush()}dispose(){for(const p of this.g)p.dispose();super.dispose()}}e.$uj=r;class d extends I.$Sc{constructor(p,E,L){if(super(),this.h=p,this.j=E,this.b=new R.$Ac,this.c=this.B(new N.$Sd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$Sd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$Sd),this.onDidChangeVisibility=this.g.event,L)for(const T of L)this.b.set(T.resource,{logger:void 0,info:T})}m(p){return(0,y.$Ff)(p)?[...this.b.values()].find(E=>E.info.id===p):this.b.get(p)}getLogger(p){return this.m(p)?.logger}createLogger(p,E){const L=this.n(p),T=(0,y.$Ff)(p)?p:E?.id??(0,g.$Qi)(L.toString()).toString(16);let U=this.b.get(L)?.logger;const F=E?.logLevel==="always"?l.Trace:E?.logLevel;U||(U=this.s(L,F??this.getLogLevel(L)??this.h,{...E,id:T}));const j={logger:U,info:{resource:L,id:T,logLevel:F,name:E?.name,hidden:E?.hidden,extensionId:E?.extensionId,when:E?.when}};return this.registerLogger(j.info),this.b.set(L,j),U}n(p){return(0,y.$Ff)(p)?(0,$.$Eg)(this.j,`${p}.log`):p}setLogLevel(p,E){if(A.URI.isUri(p)){const L=p,T=E,U=this.b.get(L);U&&T!==U.info.logLevel&&(U.info.logLevel=T===this.h?void 0:T,U.logger?.setLevel(T),this.b.set(U.info.resource,U),this.f.fire([L,T]))}else{this.h=p;for(const[L,T]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(p,E){const L=this.m(p);L&&E!==!L.info.hidden&&(L.info.hidden=!E,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,E]))}getLogLevel(p){let E;return p&&(E=this.b.get(p)?.info.logLevel),E??this.h}registerLogger(p){const E=this.b.get(p.resource);E?E.info.hidden!==p.hidden&&this.setVisibility(p.resource,!p.hidden):(this.b.set(p.resource,{info:p,logger:void 0}),this.c.fire({added:[p],removed:[]}))}deregisterLogger(p){const E=this.b.get(p);E&&(E.logger&&E.logger.dispose(),this.b.delete(p),this.c.fire({added:[],removed:[E.info]}))}*getRegisteredLoggers(){for(const p of this.b.values())yield p.info}getRegisteredLogger(p){return this.b.get(p)?.info}dispose(){this.b.forEach(p=>p.logger?.dispose()),this.b.clear(),super.dispose()}}e.$vj=d;class u{constructor(){this.onDidChangeLogLevel=new N.$Sd().event}setLevel(p){}getLevel(){return l.Info}trace(p,...E){}debug(p,...E){}info(p,...E){}warn(p,...E){}error(p,...E){}critical(p,...E){}dispose(){}flush(){}}e.$wj=u;class a extends u{}e.$xj=a;function h(w){if(w.verbose)return l.Trace;if(typeof w.logLevel=="string"){const p=P(w.logLevel.toLowerCase());if(p!==void 0)return p}return e.$nj}e.$yj=h;function S(w){switch(w){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Off:return"off"}}e.$zj=S;function P(w){switch(w){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Error;case"off":return l.Off}}e.$Aj=P,e.$Bj=new C.$hj("logLevel",S(l.Info))}),define(Se[249],ke([1,0,19,11,14,4,3,16,84,13]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=void 0;class A extends R.$Sc{constructor(m,v){super(),this.a=m,this.b=v,this.c=this.B(new I.$Sd),this.onDidChangeFile=this.c.event,this.g=this.B(new I.$Sd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$1g(0)),this.w=[],this.y=this.B(new N.$1g(0))}watch(m,v){return v.recursive||this.b?.watcher?.forceUniversal?this.n(m,v):this.z(m,v)}n(m,v){const k={path:this.H(m),excludes:v.excludes,includes:v.includes,recursive:v.recursive,correlationId:v.correlationId},l=(0,D.$Ub)(this.j,k);return this.r(),(0,R.$Qc)(()=>{l(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,g.$1)(m))}s(){this.h||(this.h=this.B(this.t(v=>this.c.fire((0,$.$8p)(v)),v=>this.G(v),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const v of this.j)(0,$.$4p)(v)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const v of this.j)(0,$.$4p)(v)&&m.includes(v.path)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,v){const k={path:this.H(m),excludes:v.excludes,includes:v.includes,recursive:!1,correlationId:v.correlationId},l=(0,D.$Ub)(this.w,k);return this.C(),(0,R.$Qc)(()=>{l(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,g.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,$.$8p)(m)),m=>this.G(m),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}H(m){return(0,b.$hc)(m.fsPath)}}e.$_p=A}),define(Se[250],ke([1,0,56,387,11,28,22,4,33,3,16,10,23,98,31,205,32,243,249,44,247,246]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l,f,s,i,n,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=void 0,(()=>{try{(0,N.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,n.$Ni)(r)}`)}})();class t extends i.$_p{static{this.I=!1}constructor(d,u){super(d,u),this.onDidChangeCapabilities=b.Event.None,this.N=new I.$Ac(a=>m.$vg.getComparisonKey(a)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,C.$k&&(this.J|=1024)),this.J}async stat(d){try{const{stat:u,symbolicLink:a}=await k.SymlinkSupport.stat(this.H(d));return{type:this.M(u,a),ctime:u.birthtime.getTime(),mtime:u.mtime.getTime(),size:u.size,permissions:u.mode&128?void 0:f.FilePermission.Locked}}catch(u){throw this.fb(u)}}async L(d){try{return await this.stat(d)}catch{return}}async readdir(d){try{const u=await k.Promises.readdir(this.H(d),{withFileTypes:!0}),a=[];return await Promise.all(u.map(async h=>{try{let S;h.isSymbolicLink()?S=(await this.stat((0,m.$Eg)(d,h.name))).type:S=this.M(h),a.push([h.name,S])}catch(S){this.a.trace(S)}})),a}catch(u){throw this.fb(u)}}M(d,u){let a;return u?.dangling?a=f.FileType.Unknown:d.isFile()?a=f.FileType.File:d.isDirectory()?a=f.FileType.Directory:a=f.FileType.Unknown,u&&(a|=f.FileType.SymbolicLink),a}async O(d){const u=this.H(d);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${u})`);let a;for(;a=this.N.get(d);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${u})`),await a.wait();const h=new g.$2g;return this.N.set(d,h),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${u})`),(0,y.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${u})`),this.N.get(d)===h&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${u})`),this.N.delete(d)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${u})`),h.open()})}async readFile(d,u){let a;try{u?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(d)})`),a=await this.O(d));const h=this.H(d);return await k.Promises.readFile(h)}catch(h){throw this.fb(h)}finally{a?.dispose()}}P(d){t.I&&this.a.trace(d)}readFileStream(d,u,a){const h=(0,v.$7d)(S=>R.$ge.concat(S.map(P=>R.$ge.wrap(P))).buffer);return(0,s.$2p)(this,d,h,S=>S.buffer,{...u,bufferSize:256*1024},a),h}async writeFile(d,u,a){return a?.atomic!==!1&&a?.atomic?.postfix&&await this.Q(d)?this.R(d,(0,m.$Eg)((0,m.$Dg)(d),`${(0,m.$Bg)(d)}${a.atomic.postfix}`),u,a):this.S(d,u,a)}async Q(d){try{const u=this.H(d),{symbolicLink:a}=await k.SymlinkSupport.stat(u);if(a)return!1}catch{}return!0}async R(d,u,a,h){const S=new y.$Rc;try{S.add(await this.O(d)),S.add(await this.O(u)),await this.S(u,a,h,!0);try{await this.rename(u,d,{overwrite:!0})}catch(P){try{await this.delete(u,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw P}}finally{S.dispose()}}async S(d,u,a,h){let S;try{const P=this.H(d);if(!a.create||!a.overwrite){if(await k.Promises.exists(P)){if(!a.overwrite)throw(0,f.$Ak)((0,l.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,f.$Ak)((0,l.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}S=await this.open(d,{create:!0,unlock:a.unlock},h),await this.write(S,0,u,0,u.byteLength)}catch(P){throw await this.gb(d,P)}finally{typeof S=="number"&&await this.close(S)}}static{this.Y=!0}static configureFlushOnWrite(d){t.Y=d}async open(d,u,a){const h=this.H(d);let S;(0,f.$ok)(u)&&!a&&(S=await this.O(d));let P;try{if((0,f.$ok)(u)&&u.unlock)try{const{stat:p}=await k.SymlinkSupport.stat(h);p.mode&128||await k.Promises.chmod(h,p.mode|128)}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}let w;if((0,f.$ok)(u)){if(C.$i)try{await k.Promises.truncate(h,0),w="r+"}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}w||(w="w")}else w="r";P=await k.Promises.open(h,w)}catch(w){throw S?.dispose(),(0,f.$ok)(u)?await this.gb(d,w):this.fb(w)}if(this.U.set(P,0),(0,f.$ok)(u)&&this.X.set(P,d),S){const w=this.W.get(P);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${P} (${h})`),this.W.set(P,S),w&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${P} (${h})`),w.dispose())}return P}async close(d){const u=this.W.get(d);try{if(this.U.delete(d),this.X.delete(d)&&t.Y)try{await k.Promises.fdatasync(d)}catch(a){t.configureFlushOnWrite(!1),this.a.error(a)}return await k.Promises.close(d)}catch(a){throw this.fb(a)}finally{u&&(this.W.get(d)===u&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${d}`),this.W.delete(d)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${d}`),u.dispose())}}async read(d,u,a,h,S){const P=this.Z(d,u);let w=null;try{w=(await k.Promises.read(d,a,h,S,P)).bytesRead}catch(p){throw this.fb(p)}finally{this.$(d,P,w)}return w}Z(d,u){return u===this.U.get(d)?null:u}$(d,u,a){const h=this.U.get(d);typeof h=="number"&&(typeof u=="number"||(typeof a=="number"?this.U.set(d,h+a):this.U.delete(d)))}async write(d,u,a,h,S){return(0,g.$kh)(()=>this.ab(d,u,a,h,S),100,3)}async ab(d,u,a,h,S){const P=this.Z(d,u);let w=null;try{w=(await k.Promises.write(d,a,h,S,P)).bytesWritten}catch(p){throw await this.gb(this.X.get(d),p)}finally{this.$(d,P,w)}return w}async mkdir(d){try{await k.Promises.mkdir(this.H(d))}catch(u){throw this.fb(u)}}async delete(d,u){try{const a=this.H(d);if(u.recursive){let h;u?.atomic!==!1&&u.atomic.postfix&&(h=(0,A.$jc)((0,A.$mc)(a),`${(0,A.$nc)(a)}${u.atomic.postfix}`)),await k.Promises.rm(a,k.RimRafMode.MOVE,h)}else try{await k.Promises.unlink(a)}catch(h){if(h.code==="EPERM"||h.code==="EISDIR"){let S=!1;try{const{stat:P,symbolicLink:w}=await k.SymlinkSupport.stat(a);S=P.isDirectory()&&!w}catch{}if(S)await k.Promises.rmdir(a);else throw h}else throw h}}catch(a){throw this.fb(a)}}async rename(d,u,a){const h=this.H(d),S=this.H(u);if(h!==S)try{await this.bb(d,u,"move",a.overwrite),await k.Promises.rename(h,S)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,l.localize)(2,null,(0,A.$nc)(h),(0,A.$nc)((0,A.$mc)(S)),P.toString()))),this.fb(P)}}async copy(d,u,a){const h=this.H(d),S=this.H(u);if(h!==S)try{await this.bb(d,u,"copy",a.overwrite),await k.Promises.copy(h,S,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,l.localize)(3,null,(0,A.$nc)(h),(0,A.$nc)((0,A.$mc)(S)),P.toString()))),this.fb(P)}}async bb(d,u,a,h){const S=this.H(d),P=this.H(u);let w=!1;if(!!(this.capabilities&1024)||(w=(0,$.$4f)(S,P,!0)),w){if(a==="copy")throw(0,f.$Ak)((0,l.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(a==="move")return}const E=await this.L(d);if(!E)throw(0,f.$Ak)((0,l.localize)(5,null),f.FileSystemProviderErrorCode.FileNotFound);const L=await this.L(u);if(L){if(!h)throw(0,f.$Ak)((0,l.localize)(6,null),f.FileSystemProviderErrorCode.FileExists);E.type&f.FileType.File&&L.type&f.FileType.File||await this.delete(u,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(d,u){return this.cb(d,u,!1)}async cb(d,u,a){const h=this.H(d),S=this.H(u),P=!!(this.capabilities&1024);if((0,$.$4f)(h,S,!P))return;const w=new y.$Rc;try{w.add(await this.O(d)),w.add(await this.O(u)),a&&await k.Promises.mkdir((0,A.$mc)(S),{recursive:!0}),await k.Promises.copyFile(h,S)}catch(p){if(p.code==="ENOENT"&&!a)return this.cb(d,u,!0);throw this.fb(p)}finally{w.dispose()}}t(d,u,a){return new o.$gq(h=>d(h),h=>u(h),a)}F(d,u,a){return new c.$oq(h=>d(h),h=>u(h),a)}fb(d){if(d instanceof f.$zk)return d;let u=d,a;switch(d.code){case"ENOENT":a=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=f.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":u=`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,a=f.FileSystemProviderErrorCode.Unknown;break;default:a=f.FileSystemProviderErrorCode.Unknown}return(0,f.$Ak)(u,a)}async gb(d,u){let a=this.fb(u);if(d&&a.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await k.SymlinkSupport.stat(this.H(d));h.mode&128||(a=(0,f.$Ak)(u,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.a.trace(h)}return a}}e.$pq=t}),define(Se[251],ke([1,0,3,13]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fO=void 0;class g extends D.$Sc{constructor(R,b=[]){super(),this.a=new N.$uj([R,...b]),this.B(R.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...b){this.a.trace(R,...b)}debug(R,...b){this.a.debug(R,...b)}info(R,...b){this.a.info(R,...b)}warn(R,...b){this.a.warn(R,...b)}error(R,...b){this.a.error(R,...b)}flush(){this.a.flush()}}e.$fO=g}),define(Se[252],ke([1,0,32,13]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7N=void 0;var g;(function(y){y[y.Trace=0]="Trace",y[y.Debug=1]="Debug",y[y.Info=2]="Info",y[y.Warning=3]="Warning",y[y.Error=4]="Error",y[y.Critical=5]="Critical",y[y.Off=6]="Off"})(g||(g={}));async function I(y,A,C,m,v){try{const k=await new Promise((f,s)=>{me(["@vscode/spdlog"],f,s)});k.setFlushOn(g.Trace);const l=await k.createAsyncRotatingLogger(y,A,C,m);return v?l.clearFormatters():l.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),l}catch(k){console.error(k)}return null}function R(y,A,C){switch(A){case N.LogLevel.Trace:y.trace(C);break;case N.LogLevel.Debug:y.debug(C);break;case N.LogLevel.Info:y.info(C);break;case N.LogLevel.Warning:y.warn(C);break;case N.LogLevel.Error:y.error(C);break;case N.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function b(y,A){switch(A){case N.LogLevel.Trace:y.setLevel(g.Trace);break;case N.LogLevel.Debug:y.setLevel(g.Debug);break;case N.LogLevel.Info:y.setLevel(g.Info);break;case N.LogLevel.Warning:y.setLevel(g.Warning);break;case N.LogLevel.Error:y.setLevel(g.Error);break;case N.LogLevel.Off:y.setLevel(g.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class $ extends N.$qj{constructor(A,C,m,v,k){super(),this.m=[],this.setLevel(k),this.n=this.s(A,C,m,v),this.B(this.onDidChangeLogLevel(l=>{this.r&&b(this.r,l)}))}async s(A,C,m,v){const k=m?6:1,l=30/k*D.$Vk.MB,f=await I(A,C,l,k,v);if(f){this.r=f,b(this.r,this.getLevel());for(const{level:s,message:i}of this.m)R(this.r,s,i);this.m=[]}}g(A,C){this.r?R(this.r,A,C):this.getLevel()<=A&&this.m.push({level:A,message:C})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$7N=$}),define(Se[135],ke([1,0,39,206,5]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ot=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var I;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(I||(e.MarkerTag=I={}));var R;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function($){function y(k,l){return l-k}$.compare=y;const A=Object.create(null);A[$.Error]=(0,N.localize)(0,null),A[$.Warning]=(0,N.localize)(1,null),A[$.Info]=(0,N.localize)(2,null);function C(k){return A[k]||""}$.toString=C;function m(k){switch(k){case D.default.Error:return $.Error;case D.default.Warning:return $.Warning;case D.default.Info:return $.Info;case D.default.Ignore:return $.Hint}}$.fromSeverity=m;function v(k){switch(k){case $.Error:return D.default.Error;case $.Warning:return D.default.Warning;case $.Info:return D.default.Info;case $.Hint:return D.default.Ignore}}$.toSeverity=v}(R||(e.MarkerSeverity=R={}));var b;(function($){const y="";function A(m){return C(m,!0)}$.makeKey=A;function C(m,v){const k=[y];return m.source?k.push(m.source.replace("\xA6","\\\xA6")):k.push(y),m.code?typeof m.code=="string"?k.push(m.code.replace("\xA6","\\\xA6")):k.push(m.code.value.replace("\xA6","\\\xA6")):k.push(y),m.severity!==void 0&&m.severity!==null?k.push(R.toString(m.severity)):k.push(y),m.message&&v?k.push(m.message.replace("\xA6","\\\xA6")):k.push(y),m.startLineNumber!==void 0&&m.startLineNumber!==null?k.push(m.startLineNumber.toString()):k.push(y),m.startColumn!==void 0&&m.startColumn!==null?k.push(m.startColumn.toString()):k.push(y),m.endLineNumber!==void 0&&m.endLineNumber!==null?k.push(m.endLineNumber.toString()):k.push(y),m.endColumn!==void 0&&m.endColumn!==null?k.push(m.endColumn.toString()):k.push(y),k.push(y),k.join("\xA6")}$.makeKeyOptionalMessage=C})(b||(e.IMarkerData=b={})),e.$ot=(0,g.$3h)("markerService")}),define(Se[253],ke([1,0,4,39,5]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fv=e.$ev=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$dv=e.Severity=void 0,e.Severity=N.default,e.$dv=(0,g.$3h)("notificationService");var I;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(I||(e.NotificationPriority=I={}));var R;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var b;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(b||(e.NotificationsFilter=b={}));class ${constructor(){this.progress=new y,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(C){}updateMessage(C){}updateActions(C){}close(){}}e.$ev=$;class y{infinite(){}done(){}total(C){}worked(C){}}e.$fv=y}),define(Se[254],ke([1,0,50]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const g=globalThis.vscode;if(typeof g<"u"&&typeof g.context<"u"){const I=g.context.configuration();if(I)N=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const I=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:I.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(Se[136],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dj=e.$Cj=void 0,e.$Cj=(0,D.$3h)("productService"),e.$Dj="vscode://schemas/vscode-product"});var We=this&&this.__param||function(me,e){return function(D,N){e(D,N,me)}};define(Se[85],ke([1,0,11,21,3,5]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.ProgressLocation=e.$gv=void 0,e.$gv=(0,I.$3h)("progressService");var R;(function(C){C[C.Explorer=1]="Explorer",C[C.Scm=3]="Scm",C[C.Extensions=5]="Extensions",C[C.Window=10]="Window",C[C.Notification=15]="Notification",C[C.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$hv=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(m){this.b=m}report(m){this.a=m,this.b(this.a)}}e.$iv=b;class ${get value(){return this.a}constructor(m){this.e=m}report(m){this.b?this.b.push(m):this.b=[m],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const m=this.b.shift();this.a=m,await this.e(this.a)}}finally{this.c=!1;const m=this.d;this.d=void 0,m?.()}}drain(){return this.c?new Promise(m=>{const v=this.d;this.d=()=>{v?.(),m()}}):Promise.resolve()}}e.$jv=$;let y=class extends g.$Sc{constructor(m,v){super(),this.a=new D.$nh,v.withProgress(m,k=>(this.b=k,this.c&&k.report(this.c),this.a.p)),this.B((0,g.$Qc)(()=>this.a.complete()))}report(m){this.b?this.b.report(m):this.c=m}};e.$kv=y,e.$kv=y=Ge([We(1,e.$gv)],y);class A extends g.$Sc{constructor(m){super(),this.g=m,this.a=0,this.b=this.B(new g.$Rc)}start(m){this.stop();const v=++this.a,k=new N.$3d;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},m),this.b.add((0,g.$Qc)(()=>clearTimeout(this.f))),this.b.add((0,g.$Qc)(()=>k.cancel())),this.b.add((0,g.$Qc)(()=>this.c?this.c.done():void 0)),{id:v,token:k.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(m){this.a===m&&this.b.clear()}}e.$lv=A,e.$mv=(0,I.$3h)("editorProgressService")}),define(Se[37],ke([1,0,60,18]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=void 0;class g{constructor(){this.a=new Map}add(R,b){D.ok(N.$Ff(R)),D.ok(N.$Hf(b)),D.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,b)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$vn=new g}),define(Se[108],ke([1,0,4,37]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=void 0,e.$wn={JSONContribution:"base.contributions.json"};function g(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class I{constructor(){this.b=new D.$Sd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,y){this.a[g($)]=y,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const R=new I;N.$vn.add(e.$wn.JSONContribution,R)}),define(Se[86],ke([1,0,19,4,18,196,45,108,37]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.ConfigurationScope=e.$An=e.EditPresentationTypes=void 0;var y;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(y||(e.EditPresentationTypes=y={})),e.$An={Configuration:"base.contributions.configuration"};var A;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$Bn={properties:{},patternProperties:{}},e.$Cn={properties:{},patternProperties:{}},e.$Dn={properties:{},patternProperties:{}},e.$En={properties:{},patternProperties:{}},e.$Fn={properties:{},patternProperties:{}},e.$Gn={properties:{},patternProperties:{}},e.$Hn="vscode://schemas/settings/resourceLanguage",e.$In="vscode://schemas/settings/configurationDefaults";const C=$.$vn.as(b.$wn.JSONContribution);class m{constructor(){this.h=new Set,this.i=new N.$Sd,this.onDidSchemaChange=this.i.event,this.j=new N.$Sd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.$Hn,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const d=new Set;this.n(t,r,d),C.registerSchema(e.$Hn,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(t){const r=new Set;this.o(t,r),C.registerSchema(e.$Hn,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const d=new Set;this.o(r,d),this.n(t,!1,d),C.registerSchema(e.$Hn,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const d=[];for(const{overrides:u,source:a}of t)for(const h in u)if(r.add(h),e.$Kn.test(h)){const S=this.a.get(h),P=S?.valuesSources??new Map;if(a)for(const L of Object.keys(u[h]))P.set(L,a);const w={...S?.value||{},...u[h]};this.a.set(h,{source:a,value:w,valuesSources:P});const p=(0,R.$Gi)(h),E={type:"object",default:w,description:I.localize(1,null,p),$ref:e.$Hn,defaultDefaultValue:w,source:g.$Ff(a)?void 0:a,defaultValueSource:a};d.push(...l(h)),this.d[h]=E,this.b.properties[h]=E}else{this.a.set(h,{value:u[h],source:a});const S=this.d[h];S&&(this.w(h,S),this.r(h,S))}this.m(d)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:d,source:u}of t)for(const a in d){const h=this.a.get(a),S=g.$Ff(u)?u:u?.id,P=g.$Ff(h?.source)?h?.source:h?.source?.id;if(S===P)if(r.add(a),this.a.delete(a),e.$Kn.test(a))delete this.d[a],delete this.b.properties[a];else{const w=this.d[a];w&&(this.w(a,w),this.r(a,w))}}this.u()}deltaConfiguration(t){let r=!1;const d=new Set;t.removedDefaults&&(this.l(t.removedDefaults,d),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,d),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,d),t.addedConfigurations&&this.n(t.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,d){t.forEach(u=>{this.p(u,r,u.extensionInfo,u.restrictedProperties,void 0,d),this.c.push(u),this.q(u)})}o(t,r){const d=u=>{if(u.properties)for(const a in u.properties){r.add(a);const h=this.d[a];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[a],this.s(a,u.properties[a])}u.allOf?.forEach(a=>d(a))};for(const u of t){d(u);const a=this.c.indexOf(u);a!==-1&&this.c.splice(a,1)}}p(t,r=!0,d,u,a=3,h){a=g.$Of(t.scope)?a:t.scope;const S=t.properties;if(S)for(const w in S){const p=S[w];if(r&&n(w,p)){delete S[w];continue}if(p.source=d,p.defaultDefaultValue=S[w].default,this.w(w,p),e.$Kn.test(w)?p.scope=void 0:(p.scope=g.$Of(p.scope)?a:p.scope,p.restricted=g.$Of(p.restricted)?!!u?.includes(w):p.restricted),S[w].hasOwnProperty("included")&&!S[w].included){this.f[w]=S[w],delete S[w];continue}else this.d[w]=S[w],S[w].policy?.name&&this.e.set(S[w].policy.name,w);!S[w].deprecationMessage&&S[w].markdownDeprecationMessage&&(S[w].deprecationMessage=S[w].markdownDeprecationMessage),h.add(w)}const P=t.allOf;if(P)for(const w of P)this.p(w,r,d,u,a,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=d=>{const u=d.properties;if(u)for(const h in u)this.r(h,u[h]);d.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$Bn.properties[t]=r,r.scope){case 1:e.$Cn.properties[t]=r;break;case 2:e.$Dn.properties[t]=r;break;case 6:e.$En.properties[t]=r;break;case 3:e.$Fn.properties[t]=r;break;case 4:e.$Gn.properties[t]=r;break;case 5:e.$Gn.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$Bn.properties[t],r.scope){case 1:delete e.$Cn.properties[t];break;case 2:delete e.$Dn.properties[t];break;case 6:delete e.$En.properties[t];break;case 3:delete e.$Fn.properties[t];break;case 4:case 5:delete e.$Gn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,d={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:e.$Hn};this.w(r,d),e.$Bn.properties[r]=d,e.$Cn.properties[r]=d,e.$Dn.properties[r]=d,e.$En.properties[r]=d,e.$Fn.properties[r]=d,e.$Gn.properties[r]=d}}v(){const t={type:"object",description:I.localize(4,null),errorMessage:I.localize(5,null),$ref:e.$Hn};e.$Bn.patternProperties[e.$Jn]=t,e.$Cn.patternProperties[e.$Jn]=t,e.$Dn.patternProperties[e.$Jn]=t,e.$En.patternProperties[e.$Jn]=t,e.$Fn.patternProperties[e.$Jn]=t,e.$Gn.patternProperties[e.$Jn]=t,this.i.fire()}w(t,r){const d=this.a.get(t);let u=d?.value,a=d?.source;g.$Mf(u)&&(u=r.defaultDefaultValue,a=void 0),g.$Mf(u)&&(u=s(r.type)),r.default=u,r.defaultValueSource=a}}const v="\\[([^\\]]+)\\]",k=new RegExp(v,"g");e.$Jn=`^(${v})+$`,e.$Kn=new RegExp(e.$Jn);function l(c){const t=[];if(e.$Kn.test(c)){let r=k.exec(c);for(;r?.length;){const d=r[1].trim();d&&t.push(d),r=k.exec(c)}}return(0,D.$Mb)(t)}e.$Ln=l;function f(c){return c.reduce((t,r)=>`${t}[${r}]`,"")}e.$Mn=f;function s(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Nn=s;const i=new m;$.$vn.add(e.$An.Configuration,i);function n(c,t){return c.trim()?e.$Kn.test(c)?I.localize(7,null,c):i.getConfigurationProperties()[c]!==void 0?I.localize(8,null,c):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?I.localize(9,null,c,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:I.localize(6,null)}e.$On=n;function o(){const c=[],t=i.getConfigurationProperties();for(const r of Object.keys(t))c.push([r,t[r].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.$Pn=o}),define(Se[255],ke([1,0,19,4,159,3,28,24,18,2,45,86,37]),function(me,e,D,N,g,I,R,b,$,y,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=void 0;function v(r){return Object.isFrozen(r)?r:b.$kn(r)}class k{constructor(d={},u=[],a=[],h){this.b=d,this.c=u,this.d=a,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const d=this.raw.map(u=>{if(u instanceof k)return u;const a=new l("");return a.parseRaw(u),a.configurationModel});this.f=d.reduce((u,a)=>a===u?a:u.merge(a),d[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(d){return d?(0,A.$Ei)(this.contents,d):this.contents}inspect(d,u){const a=this.rawConfiguration.getValue(d),h=u?this.rawConfiguration.getOverrideValue(d,u):void 0,S=u?this.rawConfiguration.override(u).getValue(d):a;return{value:a,override:h,merged:S}}getOverrideValue(d,u){const a=this.i(u);return a?d?(0,A.$Ei)(a,d):a:void 0}getKeysForOverrideIdentifier(d){const u=[];for(const a of this.overrides)a.identifiers.includes(d)&&u.push(...a.keys);return D.$Mb(u)}getAllOverrideIdentifiers(){const d=[];for(const u of this.overrides)d.push(...u.identifiers);return D.$Mb(d)}override(d){let u=this.a.get(d);return u||(u=this.g(d),this.a.set(d,u)),u}merge(...d){const u=b.$jn(this.contents),a=b.$jn(this.overrides),h=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const P of d)if(S.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.h(u,P.contents);for(const w of P.overrides){const[p]=a.filter(E=>D.$ub(E.identifiers,w.identifiers));p?(this.h(p.contents,w.contents),p.keys.push(...w.keys),p.keys=D.$Mb(p.keys)):a.push(b.$jn(w))}for(const w of P.keys)h.indexOf(w)===-1&&h.push(w)}return new k(u,h,a,S.every(P=>P instanceof k)?void 0:S)}g(d){const u=this.i(d);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const a={};for(const h of D.$Mb([...Object.keys(this.contents),...Object.keys(u)])){let S=this.contents[h];const P=u[h];P&&(typeof S=="object"&&typeof P=="object"?(S=b.$jn(S),this.h(S,P)):S=P),a[h]=S}return new k(a,this.keys,this.overrides)}h(d,u){for(const a of Object.keys(u)){if(a in d&&$.$Hf(d[a])&&$.$Hf(u[a])){this.h(d[a],u[a]);continue}d[a]=b.$jn(u[a])}}i(d){let u=null,a=null;const h=S=>{S&&(a?this.h(a,S):a=b.$jn(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===d?u=S.contents:S.identifiers.includes(d)&&h(S.contents);return h(u),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(d,u){this.j(d,u,!0)}setValue(d,u){this.j(d,u,!1)}removeValue(d){const u=this.keys.indexOf(d);u!==-1&&(this.keys.splice(u,1),(0,A.$Di)(this.contents,d),C.$Kn.test(d)&&this.overrides.splice(this.overrides.findIndex(a=>D.$ub(a.identifiers,(0,C.$Ln)(d))),1))}j(d,u,a){(0,A.$Ci)(this.contents,d,u,h=>console.error(h)),a=a||this.keys.indexOf(d)===-1,a&&this.keys.push(d),C.$Kn.test(d)&&this.overrides.push({identifiers:(0,C.$Ln)(d),keys:Object.keys(this.contents[d]),contents:(0,A.$Bi)(this.contents[d],h=>console.error(h))})}}e.$Qn=k;class l{constructor(d){this.f=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new k}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(d,u){if(!$.$Of(d)){const a=this.g(d);this.parseRaw(a,u)}}reparse(d){this.a&&this.parseRaw(this.a,d)}parseRaw(d,u){this.a=d;const{contents:a,keys:h,overrides:S,restricted:P,hasExcludedProperties:w}=this.h(d,u);this.b=new k(a,h,S,w?[d]:void 0),this.c=P||[]}g(d){let u={},a=null,h=[];const S=[],P=[];function w(E){Array.isArray(h)?h.push(E):a!==null&&(h[a]=E)}const p={onObjectBegin:()=>{const E={};w(E),S.push(h),h=E,a=null},onObjectProperty:E=>{a=E},onObjectEnd:()=>{h=S.pop()},onArrayBegin:()=>{const E=[];w(E),S.push(h),h=E,a=null},onArrayEnd:()=>{h=S.pop()},onLiteralValue:w,onError:(E,L,T)=>{P.push({error:E,offset:L,length:T})}};if(d)try{g.$gn(d,p),u=h[0]||{}}catch(E){console.error(`Error while parsing settings file ${this.f}: ${E}`),this.d=[E]}return u}h(d,u){const a=m.$vn.as(C.$An.Configuration).getConfigurationProperties(),h=this.i(d,a,!0,u);d=h.raw;const S=(0,A.$Bi)(d,p=>console.error(`Conflict in settings file ${this.f}: ${p}`)),P=Object.keys(d),w=this.j(d,p=>console.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:S,keys:P,overrides:w,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(d,u,a,h){let S=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:d,restricted:[],hasExcludedProperties:S};const P={},w=[];for(const p in d)if(C.$Kn.test(p)&&a){const E=this.i(d[p],u,!1,h);P[p]=E.raw,S=S||E.hasExcludedProperties,w.push(...E.restricted)}else{const E=u[p],L=E?typeof E.scope<"u"?E.scope:3:void 0;E?.restricted&&w.push(p),!h.exclude?.includes(p)&&(h.include?.includes(p)||(L===void 0||h.scopes===void 0||h.scopes.includes(L))&&!(h.skipRestricted&&E?.restricted))?P[p]=d[p]:S=!0}return{raw:P,restricted:w,hasExcludedProperties:S}}j(d,u){const a=[];for(const h of Object.keys(d))if(C.$Kn.test(h)){const S={};for(const P in d[h])S[P]=d[h][P];a.push({identifiers:(0,C.$Ln)(h),keys:Object.keys(S),contents:(0,A.$Bi)(S,u)})}return a}}e.$Rn=l;class f extends I.$Sc{constructor(d,u,a,h){super(),this.c=d,this.f=u,this.g=h,this.b=this.B(new N.$Sd),this.onDidChange=this.b.event,this.a=new l(this.c.toString()),this.B(this.g.watch(a.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&a.isEqual(S.resource,d)))(()=>this.b.fire()))}async loadConfiguration(){try{const d=await this.g.readFile(this.c);return this.a.parse(d.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new k}}reparse(d){return d&&(this.f=d),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Sn=f;class s{constructor(d,u,a,h,S,P,w,p,E,L,T,U,F){this.a=d,this.b=u,this.c=a,this.overrideIdentifiers=h,this.d=S,this.f=P,this.g=w,this.h=p,this.i=E,this.j=L,this.k=T,this.l=U,this.m=F}get value(){return v(this.c)}n(d,u,a){const h=d.inspect(u,a);return{get value(){return v(h.value)},get override(){return v(h.override)},get merged(){return v(h.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class i{constructor(d,u,a,h,S=new k,P=new k,w=new R.$Ac,p=new k,E=new R.$Ac){this.c=d,this.d=u,this.f=a,this.g=h,this.h=S,this.i=P,this.j=w,this.l=p,this.m=E,this.a=null,this.b=new R.$Ac,this.n=null}getValue(d,u,a){return this.p(d,u,a).getValue(d)}updateValue(d,u,a={}){let h;a.resource?(h=this.m.get(a.resource),h||(h=new k,this.m.set(a.resource,h))):h=this.l,u===void 0?h.removeValue(d):h.setValue(d,u),a.resource||(this.a=null)}inspect(d,u,a){const h=this.p(d,u,a),S=this.t(u.resource,a),P=u.resource?this.m.get(u.resource)||this.l:this.l,w=new Set;for(const p of h.overrides)for(const E of p.identifiers)h.getOverrideValue(d,E)!==void 0&&w.add(E);return new s(d,u,h.getValue(d),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,a?this.i:void 0,S||void 0,P)}keys(d){const u=this.t(void 0,d);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:u?u.keys.slice(0):[]}}updateDefaultConfiguration(d){this.c=d,this.a=null,this.b.clear()}updatePolicyConfiguration(d){this.d=d}updateApplicationConfiguration(d){this.f=d,this.a=null,this.b.clear()}updateLocalUserConfiguration(d){this.g=d,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(d){this.h=d,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(d){this.i=d,this.a=null,this.b.clear()}updateFolderConfiguration(d,u){this.j.set(d,u),this.b.delete(d)}deleteFolderConfiguration(d){this.folderConfigurations.delete(d),this.b.delete(d)}compareAndUpdateDefaultConfiguration(d,u){const a=[];if(!u){const{added:h,updated:S,removed:P}=c(this.c,d);u=[...h,...S,...P]}for(const h of u)for(const S of(0,C.$Ln)(h)){const P=this.c.getKeysForOverrideIdentifier(S),w=d.getKeysForOverrideIdentifier(S),p=[...w.filter(E=>P.indexOf(E)===-1),...P.filter(E=>w.indexOf(E)===-1),...P.filter(E=>!b.$nn(this.c.override(S).getValue(E),d.override(S).getValue(E)))];a.push([S,p])}return this.updateDefaultConfiguration(d),{keys:u,overrides:a}}compareAndUpdatePolicyConfiguration(d){const{added:u,updated:a,removed:h}=c(this.d,d),S=[...u,...a,...h];return S.length&&this.updatePolicyConfiguration(d),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:u,updated:a,removed:h,overrides:S}=c(this.applicationConfiguration,d),P=[...u,...a,...h];return P.length&&this.updateApplicationConfiguration(d),{keys:P,overrides:S}}compareAndUpdateLocalUserConfiguration(d){const{added:u,updated:a,removed:h,overrides:S}=c(this.localUserConfiguration,d),P=[...u,...a,...h];return P.length&&this.updateLocalUserConfiguration(d),{keys:P,overrides:S}}compareAndUpdateRemoteUserConfiguration(d){const{added:u,updated:a,removed:h,overrides:S}=c(this.remoteUserConfiguration,d),P=[...u,...a,...h];return P.length&&this.updateRemoteUserConfiguration(d),{keys:P,overrides:S}}compareAndUpdateWorkspaceConfiguration(d){const{added:u,updated:a,removed:h,overrides:S}=c(this.workspaceConfiguration,d),P=[...u,...a,...h];return P.length&&this.updateWorkspaceConfiguration(d),{keys:P,overrides:S}}compareAndUpdateFolderConfiguration(d,u){const a=this.folderConfigurations.get(d),{added:h,updated:S,removed:P,overrides:w}=c(a,u),p=[...h,...S,...P];return(p.length||!a)&&this.updateFolderConfiguration(d,u),{keys:p,overrides:w}}compareAndDeleteFolderConfiguration(d){const u=this.folderConfigurations.get(d);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:a,updated:h,removed:S,overrides:P}=c(u,void 0);return{keys:[...a,...h,...S],overrides:P}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(d,u,a){let h=this.q(u,a);return u.overrideIdentifier&&(h=h.override(u.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(d)!==void 0&&(h=h.merge(this.d)),h}q({resource:d},u){let a=this.r();if(u&&d){const h=u.getFolder(d);h&&(a=this.s(h.uri)||a);const S=this.m.get(d);S&&(a=a.merge(S))}return a}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(d){let u=this.b.get(d);if(!u){const a=this.r(),h=this.j.get(d);h?(u=a.merge(h),this.b.set(d,u)):u=a}return u}t(d,u){if(u&&d){const a=u.getFolder(d);if(a)return this.j.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((d,u)=>{const{contents:a,overrides:h,keys:S}=this.j.get(u);return d.push([u,{contents:a,overrides:h,keys:S}]),d},[])}}allKeys(){const d=new Set;return this.c.keys.forEach(u=>d.add(u)),this.userConfiguration.keys.forEach(u=>d.add(u)),this.i.keys.forEach(u=>d.add(u)),this.j.forEach(u=>u.keys.forEach(a=>d.add(a))),[...d.values()]}u(){const d=new Set;return this.c.getAllOverrideIdentifiers().forEach(u=>d.add(u)),this.userConfiguration.getAllOverrideIdentifiers().forEach(u=>d.add(u)),this.i.getAllOverrideIdentifiers().forEach(u=>d.add(u)),this.j.forEach(u=>u.getAllOverrideIdentifiers().forEach(a=>d.add(a))),[...d.values()]}v(d){const u=new Set;return this.c.getKeysForOverrideIdentifier(d).forEach(a=>u.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(a=>u.add(a)),this.i.getKeysForOverrideIdentifier(d).forEach(a=>u.add(a)),this.j.forEach(a=>a.getKeysForOverrideIdentifier(d).forEach(h=>u.add(h))),[...u.values()]}static parse(d){const u=this.w(d.defaults),a=this.w(d.policy),h=this.w(d.application),S=this.w(d.user),P=this.w(d.workspace),w=d.folders.reduce((p,E)=>(p.set(y.URI.revive(E[0]),this.w(E[1])),p),new R.$Ac);return new i(u,a,h,S,new k,P,w,new k,new R.$Ac)}static w(d){return new k(d.contents,d.keys,d.overrides)}}e.$Tn=i;function n(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const d=new Set,u=new Map;for(const h of r)h.keys.forEach(S=>d.add(S)),h.overrides.forEach(([S,P])=>{const w=(0,R.$xc)(u,S,new Set);P.forEach(p=>w.add(p))});const a=[];return u.forEach((h,S)=>a.push([S,[...h.values()]])),{keys:[...d.values()],overrides:a}}e.$Un=n;class o{constructor(d,u,a,h){this.change=d,this.f=u,this.g=a,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const S of d.keys)this.affectedKeys.add(S);for(const[,S]of d.overrides)for(const P of S)this.affectedKeys.add(P);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(d,u){const a=this.a+d,h=this.d.indexOf(a);if(h<0)return!1;const S=h+a.length;if(S>=this.d.length)return!1;const P=this.d.charCodeAt(S);if(P!==this.b&&P!==this.c)return!1;if(u){const w=this.previousConfiguration?this.previousConfiguration.getValue(d,u,this.f?.workspace):void 0,p=this.g.getValue(d,u,this.h);return!b.$nn(w,p)}return!0}}e.$Vn=o;function c(r,d){const{added:u,removed:a,updated:h}=t(d?.rawConfiguration,r?.rawConfiguration),S=[],P=r?.getAllOverrideIdentifiers()||[],w=d?.getAllOverrideIdentifiers()||[];if(d){const p=w.filter(E=>!P.includes(E));for(const E of p)S.push([E,d.getKeysForOverrideIdentifier(E)])}if(r){const p=P.filter(E=>!w.includes(E));for(const E of p)S.push([E,r.getKeysForOverrideIdentifier(E)])}if(d&&r){for(const p of P)if(w.includes(p)){const E=t({contents:r.getOverrideValue(void 0,p)||{},keys:r.getKeysForOverrideIdentifier(p)},{contents:d.getOverrideValue(void 0,p)||{},keys:d.getKeysForOverrideIdentifier(p)});S.push([p,[...E.added,...E.removed,...E.updated]])}}return{added:u,removed:a,updated:h,overrides:S}}function t(r,d){const u=r?d?r.keys.filter(S=>d.keys.indexOf(S)===-1):[...r.keys]:[],a=d?r?d.keys.filter(S=>r.keys.indexOf(S)===-1):[...d.keys]:[],h=[];if(r&&d){for(const S of d.keys)if(r.keys.indexOf(S)!==-1){const P=(0,A.$Ei)(d.contents,S),w=(0,A.$Ei)(r.contents,S);b.$nn(P,w)||h.push(S)}}return{added:u,removed:a,updated:h}}}),define(Se[256],ke([1,0,22,4,3,82]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$irb=e.$hrb=e.$grb=e.$frb=void 0;const R=(y,A,C)=>{const m=new Uint8Array(16);for(let l=0;l<16;l++)m[l]=Math.round(Math.random()*256);const v=(0,D.$Ae)(D.$ge.wrap(m));return[`GET ws://localhost${y}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${v}`].join(`\r
`)+`\r
\r
`};e.$frb=R,e.$grb=D.$ge.fromString(`\r
\r
`);async function b(y,A,C,m,v){y.write(D.$ge.fromString((0,e.$frb)(A,C,m)));const k=new g.$Rc;try{return await new Promise((l,f)=>{let s;k.add(y.onData(i=>{s?s=D.$ge.concat([s,i],s.byteLength+i.byteLength):s=i;const n=s.indexOf(e.$grb);if(n===-1)return;l(y),y.pauseData();const o=s.slice(n+e.$grb.byteLength);o.byteLength&&v.onData.fire(o)})),k.add(y.onClose(i=>f(i??new Error("socket closed")))),k.add(y.onEnd(()=>f(new Error("socket ended"))))})}catch(l){throw y.dispose(),l}finally{k.dispose()}}e.$hrb=b;class $ extends g.$Sc{constructor(A,C){super(),this.g=A,this.a=this.B(new N.$Vd),this.onData=(...m)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...m)),this.b=this.B(new N.$Sd),this.onDidDispose=this.b.event,this.f=!1,this.B(C.onData),this.B(C.onData.event(m=>this.a.fire(m))),this.onClose=this.B(C.onClose).event,this.onEnd=this.B(C.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,C){I.SocketDiagnostics.traceSocketEvent(this,this.g,A,C)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$irb=$}),define(Se[64],ke([1,0,14,5]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.RemoteAuthorityResolverErrorCode=e.$7k=e.$6k=e.RemoteConnectionType=e.$5k=void 0,e.$5k=(0,N.$3h)("remoteAuthorityResolverService");var g;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(g||(e.RemoteConnectionType=g={}));class I{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.$6k=I;class R{constructor(C,m){this.host=C,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$7k=R;var b;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class $ extends D.$bb{static isNotAvailable(C){return C instanceof $&&C._code===b.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof $&&C._code===b.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof $&&C._code===b.NoResolverFound}static isInvalidAuthority(C){return C instanceof $&&C._code===b.InvalidAuthority}static isHandled(C){return C instanceof $&&C.isHandled}constructor(C,m=b.Unknown,v){super(C),this._message=C,this._code=m,this._detail=v,this.isHandled=m===b.NotAvailable&&v===!0,Object.setPrototypeOf(this,$.prototype)}}e.$8k=$;function y(A){const C=A.indexOf("+");return C===-1?A:A.substring(0,C)}e.$9k=y}),define(Se[65],ke([1,0,17]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=e.$_k=e.$$k=e.$0k=void 0;function N(y){return y.scheme===D.Schemas.vscodeRemote?y.authority:void 0}e.$0k=N;function g(y){if(!y)return;const A=y.indexOf("+");return A<0?y:y.substr(0,A)}e.$$k=g;function I(y){return`/${y.quality??"oss"}-${y.commit??"dev"}`}e.$_k=I;function R(y){const{host:A,port:C}=$(y);if(typeof C>"u")throw new Error(`Invalid remote authority: ${y}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:A,port:C}}e.$al=R;function b(y,A){let{host:C,port:m}=$(y);return typeof m>"u"&&(m=A),{host:C,port:m}}e.$bl=b;function $(y){const A=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const C=y.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const m=y.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:y,port:void 0}}}),define(Se[26],ke([1,0,12,5,65]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.TargetPlatform=e.ExtensionType=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=void 0,e.$cm="extensions.user.cache",e.$dm="extensions.builtin.cache",e.$em="undefined_publisher",e.$fm=["ui","workspace","web"];function I(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.$gm=I,e.$hm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(R||(e.ExtensionType=R={}));var b;(function(l){l.WIN32_X64="win32-x64",l.WIN32_ARM64="win32-arm64",l.LINUX_X64="linux-x64",l.LINUX_ARM64="linux-arm64",l.LINUX_ARMHF="linux-armhf",l.ALPINE_X64="alpine-x64",l.ALPINE_ARM64="alpine-arm64",l.DARWIN_X64="darwin-x64",l.DARWIN_ARM64="darwin-arm64",l.WEB="web",l.UNIVERSAL="universal",l.UNKNOWN="unknown",l.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class ${constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,s){if(typeof f>"u"||f===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof f=="string"||typeof s=="string"){const i=typeof f=="string"?f:f.value,n=typeof s=="string"?s:s.value;return D.$9e(i,n)}return f._lower===s._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.$im=$;class y{get size(){return this.c.size}constructor(f){if(this.c=new Set,f)for(const s of f)this.add(s)}add(f){this.c.add($.toKey(f))}delete(f){return this.c.delete($.toKey(f))}has(f){return this.c.has($.toKey(f))}}e.$jm=y;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(f){this.c.delete($.toKey(f))}get(f){return this.c.get($.toKey(f))}has(f){return this.c.has($.toKey(f))}set(f,s){this.c.set($.toKey(f),s)}values(){return this.c.values()}forEach(f){this.c.forEach(f)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$km=A;function C(l){return m(l)}e.$lm=C;function m(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}e.$mm=m;function v(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}e.$nm=v;function k(l,f){if(f){const s=`onResolveRemoteAuthority:${(0,g.$$k)(f)}`;return!!l.activationEvents?.includes(s)}return!1}e.$om=k,e.$pm=(0,N.$3h)("IBuiltinExtensionsScannerService")}),define(Se[137],ke([1,0,14,26]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7E=e.$6E=void 0;class g{constructor(){this.a=new Map,this.b=new WeakMap}register(R,b){this.a.set(R,b)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const b=Object.create(null);for(const $ of R){const y=this.readActivationEvents($);y.length>0&&(b[N.$im.toKey($.identifier)]=y)}return b}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const b=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let $=0;$<b.length;$++)b[$]==="onUri"&&(b[$]=`onUri:${N.$im.toKey(R.identifier)}`);if(!R.contributes)return b;for(const $ in R.contributes){const y=this.a.get($);if(!y)continue;const A=R.contributes[$],C=Array.isArray(A)?A:[A];try{y(C,b)}catch(m){(0,D.$1)(m)}}return b}}e.$6E=g,e.$7E=new g}),define(Se[257],ke([1,0,11,22,21,14,4,3,57,38,30,82,64,65]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.PersistentConnectionEventType=e.$il=e.$hl=e.$gl=e.ConnectionType=void 0;const k=30*1e3;var l;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(l||(e.ConnectionType=l={}));function f(K){switch(K){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function s(K){const B=new g.$3d;return setTimeout(()=>B.cancel(),K),B.token}function i(K,B){if(K.isCancellationRequested||B.isCancellationRequested)return g.CancellationToken.Cancelled;const re=new g.$3d;return K.onCancellationRequested(()=>re.cancel()),B.onCancellationRequested(()=>re.cancel()),re.token}class n{get didTimeout(){return this.c==="timedout"}constructor(B){this.c="pending",this.d=new b.$Rc,this.promise=new Promise((re,ye)=>{this.f=re,this.g=ye}),B.isCancellationRequested?this.h():this.d.add(B.onCancellationRequested(()=>this.h()))}registerDisposable(B){this.c==="pending"?this.d.add(B):B.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(B))}reject(B){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(B))}}function o(K,B){const re=new n(B);return re.registerDisposable(K.onControlMessage(ye=>{const de=JSON.parse(ye.toString()),ge=J(de);ge?re.reject(ge):re.resolve(de)})),re.promise}function c(K,B,re,ye,de,ge,_,ie){const G=new n(ie),te=y.$Od.create(!1);return K.info(`Creating a socket (${_})...`),$.mark(`code/willCreateSocket/${ge}`),B.connect(re,ye,de,_).then(fe=>{G.didTimeout?($.mark(`code/didCreateSocketError/${ge}`),K.info(`Creating a socket (${_}) finished after ${te.elapsed()} ms, but this is too late and has timed out already.`),fe?.dispose()):($.mark(`code/didCreateSocketOK/${ge}`),K.info(`Creating a socket (${_}) was successful after ${te.elapsed()} ms.`),G.resolve(fe))},fe=>{$.mark(`code/didCreateSocketError/${ge}`),K.info(`Creating a socket (${_}) returned an error after ${te.elapsed()} ms.`),K.error(fe),G.reject(fe)}),G.promise}function t(K,B){const re=new n(B);return K.then(ye=>{re.didTimeout||re.resolve(ye)},ye=>{re.didTimeout||re.reject(ye)}),re.promise}async function r(K,B,re,ye){const de=we(K,B);K.logService.trace(`${de} 1/6. invoking socketFactory.connect().`);let ge;try{ge=await c(K.logService,K.remoteSocketFactoryService,K.connectTo,(0,v.$_k)(K),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,f(B),`renderer-${f(B)}-${K.reconnectionToken}`,ye)}catch(fe){throw K.logService.error(`${de} socketFactory.connect() failed or timed out. Error:`),K.logService.error(fe),fe}K.logService.trace(`${de} 2/6. socketFactory.connect() was successful.`);let _,ie;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(ge,null),_=K.reconnectionProtocol,ie=!1):(_=new C.$Qh({socket:ge}),ie=!0),K.logService.trace(`${de} 3/6. sending AuthRequest control message.`);const G=await t(K.signService.createNewMessage((0,A.$ng)()),ye),te={type:"auth",auth:K.connectionToken||"00000000000000000000",data:G.data};_.sendControl(N.$ge.fromString(JSON.stringify(te)));try{const fe=await o(_,i(ye,s(1e4)));if(fe.type!=="sign"||typeof fe.data!="string"){const De=new Error("Unexpected handshake message");throw De.code="VSCODE_CONNECTION_ERROR",De}if(K.logService.trace(`${de} 4/6. received SignRequest control message.`),!await t(K.signService.validate(G,fe.signedData),ye)){const De=new Error("Refused to connect to unsupported server");throw De.code="VSCODE_CONNECTION_ERROR",De}const Pe=await t(K.signService.sign(fe.data),ye),be={type:"connectionType",commit:K.commit,signedData:Pe,desiredConnectionType:B};return re&&(be.args=re),K.logService.trace(`${de} 5/6. sending ConnectionTypeRequest control message.`),_.sendControl(N.$ge.fromString(JSON.stringify(be))),{protocol:_,ownsProtocol:ie}}catch(fe){throw fe&&fe.code==="ETIMEDOUT"&&(K.logService.error(`${de} the handshake timed out. Error:`),K.logService.error(fe)),fe&&fe.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${de} received error control message when negotiating connection. Error:`),K.logService.error(fe)),ie&&X(_),fe}}async function d(K,B,re,ye){const de=Date.now(),ge=we(K,B),{protocol:_,ownsProtocol:ie}=await r(K,B,re,ye),G=new n(ye);return G.registerDisposable(_.onControlMessage(te=>{const fe=JSON.parse(te.toString()),ve=J(fe);ve?(K.logService.error(`${ge} received error control message when negotiating connection. Error:`),K.logService.error(ve),ie&&X(_),G.reject(ve)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${ge} 6/6. handshake finished, connection is up and running after ${ce(de)}!`),G.resolve({protocol:_,firstMessage:fe}))})),G.promise}async function u(K,B){const{protocol:re}=await d(K,1,void 0,B);return{protocol:re}}async function a(K,B,re){const{protocol:ye,firstMessage:de}=await d(K,2,B,re),ge=de&&de.debugPort;return{protocol:ye,debugPort:ge}}async function h(K,B,re){const ye=Date.now(),de=we(K,3),{protocol:ge}=await r(K,3,B,re);return K.logService.trace(`${de} 6/6. handshake finished, connection is up and running after ${ce(ye)}!`),ge}async function S(K,B,re){const{connectTo:ye,connectionToken:de}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:ye,connectionToken:de,reconnectionToken:B,reconnectionProtocol:re,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function P(K,B,re){return p(K,async ye=>{const{protocol:de}=await u(ye,g.CancellationToken.None);return new Y(K,B,re,ye.reconnectionToken,de)})}e.$gl=P;async function w(K,B){return p(K,async re=>{const{protocol:ye,debugPort:de}=await a(re,B,g.CancellationToken.None);return new ue(K,B,re.reconnectionToken,ye,de)})}e.$hl=w;async function p(K,B){for(let ye=1;;ye++)try{const de=(0,A.$ng)(),ge=await S(K,de,null);return await B(ge)}catch(de){if(ye<5)K.logService.error(`[remote-connection][attempt ${ye}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(de);else throw K.logService.error(`[remote-connection][attempt ${ye}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(de),W.triggerPermanentFailure(0,0,m.$8k.isHandled(de)),de}}async function E(K,B,re){const ye=await S(K,(0,A.$ng)(),null);return await h(ye,{host:B,port:re},g.CancellationToken.None)}e.$il=E;function L(K){return(0,D.$Qg)(B=>new Promise((re,ye)=>{const de=setTimeout(re,K*1e3);B.onCancellationRequested(()=>{clearTimeout(de),re()})}))}var T;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class U{constructor(B,re){this.reconnectionToken=B,this.millisSinceLastIncomingData=re,this.type=0}}e.$jl=U;class F{constructor(B,re,ye,de){this.reconnectionToken=B,this.millisSinceLastIncomingData=re,this.durationSeconds=ye,this.c=de,this.type=1}skipWait(){this.c.cancel()}}e.$kl=F;class j{constructor(B,re,ye){this.reconnectionToken=B,this.millisSinceLastIncomingData=re,this.attempt=ye,this.type=2}}e.$ll=j;class O{constructor(B,re,ye){this.reconnectionToken=B,this.millisSinceLastIncomingData=re,this.attempt=ye,this.type=4}}e.$ml=O;class M{constructor(B,re,ye,de){this.reconnectionToken=B,this.millisSinceLastIncomingData=re,this.attempt=ye,this.handled=de,this.type=3}}e.$nl=M;class W extends b.$Sc{static triggerPermanentFailure(B,re,ye){this._permanentFailure=!0,this.f=B,this.g=re,this.h=ye,this.j.forEach(de=>de.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(B=>B.y())}static debugPauseSocketWriting(){this.j.forEach(B=>B.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||W._permanentFailure}constructor(B,re,ye,de,ge){super(),this.t=B,this.u=re,this.reconnectionToken=ye,this.protocol=de,this.w=ge,this.m=this.B(new R.$Sd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new O(this.reconnectionToken,0,0)),this.B(de.onSocketClose(_=>{const ie=Z(this.t,this.reconnectionToken,!0);_?_.type===0?(this.u.logService.info(`${ie} received socket close event (hadError: ${_.hadError}).`),_.error&&this.u.logService.error(_.error)):(this.u.logService.info(`${ie} received socket close event (wasClean: ${_.wasClean}, code: ${_.code}, reason: ${_.reason}).`),_.event&&this.u.logService.error(_.event)):this.u.logService.info(`${ie} received socket close event.`),this.y()})),this.B(de.onSocketTimeout(_=>{const ie=Z(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ie} received socket timeout event (unacknowledgedMsgCount: ${_.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${_.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${_.timeSinceLastReceivedSomeData}).`),this.y()})),W.j.push(this),this.B((0,b.$Qc)(()=>{const _=W.j.indexOf(this);_>=0&&W.j.splice(_,1)})),this.n&&this.D(W.f,W.g,W.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const B=Z(this.t,this.reconnectionToken,!0);this.u.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const re=[0,5,5,10,10,10,10,10,30];let ye=-1;do{ye++;const de=ye<re.length?re[ye]:re[re.length-1];try{if(de>0){const _=L(de);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),de,_)),this.u.logService.info(`${B} waiting for ${de} seconds before reconnecting...`);try{await _}catch{}}if(this.n){this.u.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1)),this.u.logService.info(`${B} resolving connection...`);const ge=await S(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${B} connecting to ${ge.connectTo}...`),await this.G(ge,s(k)),this.u.logService.info(`${B} reconnected!`),this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1));break}catch(ge){if(ge.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(ye>360){this.u.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(m.$8k.isTemporarilyNotAvailable(ge)){this.u.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ge);continue}if((ge.code==="ETIMEDOUT"||ge.code==="ENETUNREACH"||ge.code==="ECONNREFUSED"||ge.code==="ECONNRESET")&&ge.syscall==="connect"){this.u.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ge);continue}if((0,I.$4)(ge)){this.u.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ge);continue}if(ge instanceof m.$8k){this.u.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,m.$8k.isHandled(ge));break}this.u.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}}while(!this.n&&!this.s)}C(B,re,ye){this.w?W.triggerPermanentFailure(B,re,ye):this.D(B,re,ye)}D(B,re,ye){this.m.fire(new M(this.reconnectionToken,B,re,ye)),X(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$ol=W;class Y extends W{constructor(B,re,ye,de,ge){super(1,B,de,ge,!0),this.client=this.B(new C.$Oh(ge,{remoteAuthority:re,clientId:ye},B.ipcLogger))}async G(B,re){await u(B,re)}}e.$pl=Y;class ue extends W{constructor(B,re,ye,de,ge){super(2,B,ye,de,!1),this.H=re,this.debugPort=ge}async G(B,re){await a(B,this.H,re)}}e.$ql=ue;function X(K){try{K.acceptDisconnect();const B=K.getSocket();K.dispose(),B.dispose()}catch(B){(0,I.$1)(B)}}function J(K){if(K&&K.type==="error"){const B=new Error(`Connection error: ${K.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function x(K,B){for(;K.length<B;)K+=" ";return K}function he(K,B){return`[remote-connection][${x(f(K),13)}][${B.substr(0,5)}\u2026]`}function Z(K,B,re){return`${he(K,B)}[${re?"reconnect":"initial"}]`}function we(K,B){return`${Z(B,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function ce(K){return`${Date.now()-K} ms`}}),define(Se[258],ke([1,0,3,5]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dl=e.$cl=void 0,e.$cl=(0,N.$3h)("remoteSocketFactoryService");class g{constructor(){this.a={}}register(R,b){return this.a[R]??=[],this.a[R].push(b),(0,D.$Qc)(()=>{const $=this.a[R]?.indexOf(b);typeof $=="number"&&$>=0&&this.a[R]?.splice($,1)})}b(R){return(this.a[R.type]||[]).find($=>$.supports(R))}connect(R,b,$,y){const A=this.b(R);if(!A)throw new Error(`No socket factory found for ${R}`);return A.connect(R,b,$,y)}}e.$dl=g}),define(Se[259],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p6b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(g){try{const I=await this.c();if(I){const R=String(D.a++);return this.b.set(R,I),{id:R,data:I.createNewMessage(g)}}}catch{}return{id:"",data:g}}async validate(g,I){if(!g.id)return!0;const R=this.b.get(g.id);if(!R)return!1;this.b.delete(g.id);try{return R.validate(I)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(g){try{return await this.d(g)}catch{}return g}}e.$p6b=D}),define(Se[109],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fl=e.$el=void 0,e.$el="signService",e.$fl=(0,D.$3h)(e.$el)}),define(Se[138],ke([1,0,259]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k$b=void 0;class N extends D.$p6b{c(){return this.h().then(I=>new I.validator)}d(I){return this.h().then(R=>new R.signer().sign(I))}h(){return new Promise((I,R)=>me(["vsda"],I,R))}}e.$k$b=N}),define(Se[260],ke([1,0,10,50,30]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xo=e.$wo=void 0;function I($){if(D.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function R($,y,A,C,m,v,k,l,f){const s=Object.create(null);s["common.machineId"]=v,s["common.sqmId"]=k,s.sessionID=(0,g.$ng)()+Date.now(),s.commitHash=C,s.version=m,s["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,D.$h)(D.$u),s["common.nodePlatform"]=N.$dc,s["common.nodeArch"]=A,s["common.product"]=f||"desktop",l&&(s["common.msftInternal"]=l);let i=0;const n=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),D.$l&&(s["common.snap"]="true");const o=I(y);return o&&(s["common.platformDetail"]=o),s}e.$wo=R;function b($){const y=N.env.USERDNSDOMAIN;if(!y)return!1;const A=y.toLowerCase();return $.some(C=>A===C)}e.$xo=b}),define(Se[261],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=void 0,e.$rl=(0,D.$3h)("telemetryService"),e.$sl=(0,D.$3h)("customEndpointTelemetryService"),e.$tl="telemetry.currentSessionDate",e.$ul="telemetry.firstSessionDate",e.$vl="telemetry.lastSessionDate",e.$wl="telemetry.machineId",e.$xl="telemetry.sqmId",e.$yl="telemetry",e.$zl="telemetry.telemetryLevel",e.$Al="telemetry.enableCrashReporter",e.$Bl="telemetry.enableTelemetry";var N;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var g;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})(g||(e.TelemetryConfiguration=g={}))}),define(Se[87],ke([1,0,24,18,4,45,65,260,261]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=void 0;class y{constructor(a){this.value=a,this.isTrustedTelemetryValue=!0}}e.$yo=y;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$zo=A,e.$Ao=new A;class C{async publicLog(a,h,S){}async publicLogError(a,h,S){}}e.$Bo=C,e.$Co="telemetry",e.$Do="extensionTelemetryLog",e.$Eo={log:()=>null,flush:()=>Promise.resolve(null)};function m(u,a){return g.Event.debounce(a.onDidChangeConfiguration,(S,P)=>{const w=S?new Set([...S.affectedKeys,...P.affectedKeys]):P.affectedKeys;return{...P,affectedKeys:w}},1e3,!0)(S=>{S.source!==7&&u.publicLog2("updateConfiguration",{configurationSource:(0,I.$zi)(S.source),configurationKeys:Array.from(S.affectedKeys)})})}e.$Fo=m;function v(u,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!u.enableTelemetry)}e.$Go=v;function k(u,a){return a.extensionTestsLocationURI?!0:!(a.isBuilt||a.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}e.$Ho=k;function l(u){const a=u.getValue($.$zl),h=u.getValue($.$Al);if(u.getValue($.$Bl)===!1||h===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Io=l;function f(u){const a={},h={},S={};n(u,S);for(let P in S){P=P.length>150?P.substr(P.length-149):P;const w=S[P];typeof w=="number"?h[P]=w:typeof w=="boolean"?h[P]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${P} has been trimmed to 8192, the original length is ${w.length}`),a[P]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(a[P]=w)}return{properties:a,measurements:h}}e.$Jo=f;const s=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function i(u){if(!u)return"none";const a=(0,R.$$k)(u);return s.has(a)?a:"other"}e.$Ko=i;function n(u,a,h=0,S){if(u)for(const P of Object.getOwnPropertyNames(u)){const w=u[P],p=S?S+P:P;Array.isArray(w)?a[p]=(0,D.$on)(w):w instanceof Date?a[p]=w.toISOString():(0,N.$Hf)(w)?h<2?n(w,a,h+1,p+"."):a[p]=(0,D.$on)(w):a[p]=w}}function o(u,a){const h=u.msftInternalDomains||[],S=a.getValue("telemetry.internalTesting");return(0,b.$xo)(h)||S}e.$Lo=o;function c(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}e.$Mo=c;function t(u,a){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let h=u;const S=[];for(const E of a)for(;;){const L=E.exec(u);if(!L)break;S.push([L.index,E.lastIndex])}const P=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(h="";;){const E=w.exec(u);if(!E)break;const L=S.some(([T,U])=>E.index<U&&T<w.lastIndex);!P.test(E[0])&&!L&&(h+=u.substring(p,E.index)+"<REDACTED: user-file-path>",p=w.lastIndex)}return p<u.length&&(h+=u.substr(p)),h}function r(u){if(!u)return u;const a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of a)if(h.regex.test(u))return`<REDACTED: ${h.label}>`;return u}function d(u,a){return(0,D.$ln)(u,h=>{if(h instanceof y||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let S=h.replaceAll("%20"," ");S=t(S,a);for(const P of a)S=S.replace(P,"");return S=r(S),S}})}e.$No=d}),define(Se[262],ke([1,0,12,134,26,10,2,14,50,87]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=void 0;function A(d,u){return d.uuid&&u.uuid?d.uuid===u.uuid:d.id===u.id?!0:(0,D.$4e)(d.id,u.id)===0}e.$Oo=A;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(u){const a=u.manifest?u.manifest.version:u.version,h=u.manifest?u.targetPlatform:u.properties.targetPlatform;return new m(u.identifier,a,h)}static parse(u){const a=C.exec(u);return a&&a[1]&&a[2]?new m({id:a[1]},a[2],a[4]||void 0):null}constructor(u,a,h="undefined"){this.version=a,this.targetPlatform=h,this.id=u.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(u){return u instanceof m?A(this,u)&&this.version===u.version&&this.targetPlatform===u.targetPlatform:!1}}e.$Po=m;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function k(d){const u=v.exec(d);return u&&u[1]?[f(u[1]),u[2]]:[f(d),void 0]}e.$Qo=k;function l(d,u){return`${d}.${u}`}e.$Ro=l;function f(d){return d.toLowerCase()}e.$So=f;function s(d,u){return f(l(d??g.$em,u))}e.$To=s;function i(d,u){const a=[],h=S=>{for(const P of a)if(P.some(w=>A(u(w),u(S))))return P;return null};for(const S of d){const P=h(S);P?P.push(S):a.push([S])}return a}e.$Uo=i;function n(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.$Vo=n;function o(d){return{id:new y.$yo(d.identifier.id),name:new y.$yo(d.name),galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$Wo=o,e.$Xo=new g.$im("pprice.better-merge");function c(d,u){const a=[],h=u.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const S=h.shift();if(S&&a.every(P=>!A(P.identifier,{id:S}))){const P=d.filter(w=>A(w.identifier,{id:S}));P.length===1&&(a.push(P[0]),h.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.$Yo=c;async function t(d,u){if(!I.$k)return!1;let a;try{a=(await d.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await d.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){u.debug("Error while getting the os-release file.",(0,b.$0)(S))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(d,u){const a=await t(d,u),h=(0,N.$io)(a?"alpine":I.$u,$.$ec);return u.debug("ComputeTargetPlatform:",h),h}e.$Zo=r}),define(Se[263],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=e.$Dr=e.$Cr=e.$Br=e.$Ar=e.$zr=void 0;function D($){return[...$.entries()]}e.$zr=D;function N($){return $?[...$.entries()]:[]}e.$Ar=N;function g($){return new Map($)}e.$Br=g;function I($){return new Map($??[])}e.$Cr=I;function R($){return Array.from($.entries()).map(y=>[y[0],D(y[1].map),N(y[1].descriptionMap)])}e.$Dr=R;function b($){return new Map($.map(y=>[y[0],{map:g(y[1]),descriptionMap:I(y[2])}]))}e.$Er=b}),define(Se[264],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zrb=void 0;class D{constructor(g){this.b=g,this.a=new Map}dispose(){for(const g of this.a.values())g.dispose()}startBuffering(g,I,R=5){const b=I($=>{const y=typeof $=="string"?$:$.data;let A=this.a.get(g);if(A){A.data.push(y);return}const C=setTimeout(()=>this.flushBuffer(g),R);A={data:[y],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(g),b.dispose()}},this.a.set(g,A)});return b}stopBuffering(g){this.a.get(g)?.dispose()}flushBuffer(g){const I=this.a.get(g);I&&(this.a.delete(g),this.b(g,I.data.join("")))}}e.$zrb=D}),define(Se[265],ke([1,0,11,78,61,4,18,2,207,108,37]),function(me,e,D,N,g,I,R,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rw=e.$qw=e.$pw=e.$ow=e.$nw=e.$mw=e.$lw=e.$kw=e.IconFontDefinition=e.IconContribution=e.$jw=void 0,e.$jw={IconContribution:"base.contributions.icons"};var C;(function(o){function c(t,r){let d=t.defaults;for(;g.ThemeIcon.isThemeIcon(d);){const u=k.getIcon(d.id);if(!u)return;d=u.defaults}return d}o.getDefinition=c})(C||(e.IconContribution=C={}));var m;(function(o){function c(r){return{weight:r.weight,style:r.style,src:r.src.map(d=>({format:d.format,location:d.location.toString()}))}}o.toJSONObject=c;function t(r){const d=u=>(0,R.$Ff)(u)?u:void 0;if(r&&Array.isArray(r.src)&&r.src.every(u=>(0,R.$Ff)(u.format)&&(0,R.$Ff)(u.location)))return{weight:d(r.weight),style:d(r.style),src:r.src.map(u=>({format:u.format,location:b.URI.parse(u.location)}))}}o.fromJSONObject=t})(m||(e.IconFontDefinition=m={}));class v{constructor(){this.a=new I.$Sd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,$.localize)(0,null)},fontCharacter:{type:"string",description:(0,$.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${g.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(c,t,r,d){const u=this.b[c];if(u){if(r&&!u.description){u.description=r,this.d.properties[c].markdownDescription=`${r} $(${c})`;const S=this.e.enum.indexOf(c);S!==-1&&(this.e.enumDescriptions[S]=r),this.a.fire()}return u}const a={id:c,description:r,defaults:t,deprecationMessage:d};this.b[c]=a;const h={$ref:"#/definitions/icons"};return d&&(h.deprecationMessage=d),r&&(h.markdownDescription=`${r}: $(${c})`),this.d.properties[c]=h,this.e.enum.push(c),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:c}}deregisterIcon(c){delete this.b[c],delete this.d.properties[c];const t=this.e.enum.indexOf(c);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(c=>this.b[c])}getIcon(c){return this.b[c]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(c,t){const r=this.f[c];return r||(this.f[c]=t,this.a.fire(),t)}deregisterIconFont(c){delete this.f[c]}getIconFont(c){return this.f[c]}toString(){const c=(u,a)=>u.id.localeCompare(a.id),t=u=>{for(;g.ThemeIcon.isThemeIcon(u.defaults);)u=this.b[u.defaults.id];return`codicon codicon-${u?u.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const d=Object.keys(this.b).map(u=>this.b[u]);for(const u of d.filter(a=>!!a.description).sort(c))r.push(`|<i class="${t(u)}"></i>|${u.id}|${g.ThemeIcon.isThemeIcon(u.defaults)?u.defaults.id:u.id}|${u.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const u of d.filter(a=>!g.ThemeIcon.isThemeIcon(a.defaults)).sort(c))r.push(`|<i class="${t(u)}"></i>|${u.id}|`);return r.join(`
`)}}const k=new v;A.$vn.add(e.$jw.IconContribution,k);function l(o,c,t,r){return k.registerIcon(o,c,t,r)}e.$kw=l;function f(){return k}e.$lw=f;function s(){const o=(0,N.$7j)();for(const c in o){const t="\\"+o[c].toString(16);k.registerIcon(c,{fontCharacter:t})}}s(),e.$mw="vscode://schemas/icons";const i=A.$vn.as(y.$wn.JSONContribution);i.registerSchema(e.$mw,k.getIconSchema());const n=new D.$ch(()=>i.notifySchemaChanged(e.$mw),200);k.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$nw=l("widget-close",N.$9j.close,(0,$.localize)(2,null)),e.$ow=l("goto-previous-location",N.$9j.arrowUp,(0,$.localize)(3,null)),e.$pw=l("goto-next-location",N.$9j.arrowDown,(0,$.localize)(4,null)),e.$qw=g.ThemeIcon.modify(N.$9j.sync,"spin"),e.$rw=g.ThemeIcon.modify(N.$9j.loading,"spin")}),define(Se[88],ke([1,0,4,45,5,13]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xv=e.$wv=e.$vv=e.$uv=e.$tv=e.$sv=e.$rv=e.$qv=e.ProvidedOnAutoForward=e.$pv=e.TunnelPrivacyId=e.TunnelProtocol=e.$ov=e.$nv=void 0,e.$nv=(0,g.$3h)("tunnelService"),e.$ov=(0,g.$3h)("sharedTunnelsService");var R;(function(f){f.Http="http",f.Https="https"})(R||(e.TunnelProtocol=R={}));var b;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(b||(e.TunnelPrivacyId=b={}));function $(f){return!!f.forwardPort}e.$pv=$;var y;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(y||(e.ProvidedOnAutoForward=y={}));function A(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(s)return{address:s[1],port:+s[2]}}e.$qv=A,e.$rv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(f){return e.$rv.indexOf(f)>=0}e.$sv=C,e.$tv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(f){return e.$tv.indexOf(f)>=0}e.$uv=m;function v(f,s,i,n){if(i===1)return!1;if(i===2&&m(s)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(o?.length===4&&parseInt(o[1])>=18)return!1}return f<1024}e.$vv=v;class k{constructor(s,i,n){this.remoteAddress=s,this.localAddress=i,this.b=n,this.a=new D.$Sd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$wv=k;let l=class{constructor(s,i){this.j=s,this.k=i,this.a=new D.$Sd,this.onTunnelOpened=this.a.event,this.b=new D.$Sd,this.onTunnelClosed=this.b.event,this.c=new D.$Sd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const s=this.k.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.f=s,s?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.g=s.elevation,this.h=s.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const s=[],i=Array.from(this.e.values());for(const n of i){const o=Array.from(n.values());for(const c of o){const t=await c.value;t&&typeof t!="string"&&s.push(t)}}return s}async dispose(){for(const s of this.e.values()){for(const{value:i}of s.values())await i.then(n=>typeof n!="string"?n?.dispose():void 0);s.clear()}this.e.clear()}setEnvironmentTunnel(s,i,n,o,c){this.p(s,i,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:i,localAddress:n,privacy:o,protocol:c,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,i){(m(s)||C(s))&&(s=e.$rv[0]);const n=this.r(s,i);if(n)return++n.refcount,n.value}openTunnel(s,i,n,o,c,t=!1,r,d){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${n} on local port ${c}.`);const u=this.f??s;if(!u)return;if(i||(i="localhost"),o||(o=this.l),this.f&&this.i.has(n)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.s(u,i,n,o,c,t,r,d);return a?a.then(h=>{if(h){if(typeof h=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(i,n),h}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(i,n);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.n(h);return(h.tunnelRemoteHost!==i||h.tunnelRemotePort!==n)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&h.privacy!==r&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}n(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const i=this.e.get(s.tunnelRemoteHost);if(i){const n=i.get(s.tunnelRemotePort);n&&(n.refcount--,await this.o(s.tunnelRemoteHost,s.tunnelRemotePort,n))}}}}async o(s,i,n){if(n.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${i}.`);const o=n.value.then(async c=>{c&&typeof c!="string"&&(await c.dispose(!0),this.b.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this.e.has(s)&&this.e.get(s).delete(i),o}}async closeTunnel(s,i){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${i} `);const n=this.e.get(s);if(n&&n.has(i)){const o=n.get(i);o.refcount=0,await this.o(s,i,o)}}p(s,i,n){this.e.has(s)||this.e.set(s,new Map),this.e.get(s).set(i,{refcount:1,value:n})}async q(s,i){const n=this.e.get(s);if(n){const o=n.get(i),c=o?await o.value:void 0;(!c||typeof c=="string")&&n.delete(i),n.size===0&&this.e.delete(s)}}r(s,i){const n=[s];C(s)?(n.push(...e.$rv),n.push(...e.$tv)):m(s)&&n.push(...e.$tv);const o=n.map(c=>this.e.get(c));for(const c of o){const t=c?.get(i);if(t)return t}}canTunnel(s){return!!A(s)}t(s,i,n,o,c,t,r){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${n} on local port ${o}.`);const d=n;this.i.add(d);const u=o===void 0?n:o,a={elevationRequired:c?this.isPortPrivileged(u):!1},h={remoteAddress:{host:i,port:n},localAddressPort:o,privacy:t,public:t?t!==b.Private:void 0,protocol:r},S=s.forwardPort(h,a);return S?(this.p(i,n,S),S.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(d)})):this.i.delete(d),S}};e.$xv=l,e.$xv=l=Ge([We(0,I.$kj),We(1,N.$wi)],l)}),define(Se[266],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=void 0,e.$Xk=(0,D.$3h)("IUriIdentityService")}),define(Se[267],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$yv=void 0,e.$yv=(0,D.$3h)("editSessionIdentityService");var N;(function(g){g[g.Complete=100]="Complete",g[g.Partial=50]="Partial",g[g.None=0]="None"})(N||(e.EditSessionIdentityMatch=N={}))}),define(Se[268],ke([1,0,17]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=void 0;function N($){return $.scheme!==D.Schemas.file&&$.scheme!==D.Schemas.vscodeRemote}e.$nK=N;function g($){if($.folders.length)return $.folders.every(y=>N(y.uri))?$.folders[0].uri:void 0;if($.configuration&&N($.configuration))return $.configuration}e.$oK=g;function I($){return g($)?.scheme}e.$pK=I;function R($){return g($)?.authority}e.$qK=R;function b($){return g($)!==void 0}e.$rK=b}),define(Se[40],ke([1,0,209,16,77,23,2,5,17]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.WorkbenchState=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=void 0,e.$_h=(0,b.$3h)("contextService");function y(u){const a=u;return typeof a?.id=="string"&&R.URI.isUri(a.uri)}e.$ai=y;function A(u){return typeof u?.id=="string"&&!y(u)&&!m(u)}e.$bi=A,e.$ci={id:"ext-dev"},e.$di={id:"empty-window"};function C(u,a){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,N.$nc)(u)}:a?e.$ci:e.$di;const h=u;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}e.$ei=C;function m(u){const a=u;return typeof a?.id=="string"&&R.URI.isUri(a.configPath)}e.$fi=m;function v(u){const a=u;if(a?.uri)return{id:a.id,uri:R.URI.revive(a.uri)};const h=u;if(h?.configPath)return{id:h.id,configPath:R.URI.revive(h.configPath)};if(u?.id)return{id:u.id}}e.$gi=v;var k;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(k||(e.WorkbenchState=k={}));function l(u){const a=u;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.$hi=l;function f(u){const a=u;return!!(a&&typeof a=="object"&&R.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.$ii=f;class s{constructor(a,h,S,P,w){this.h=a,this.j=S,this.k=P,this.l=w,this.c=g.$9h.forUris(this.l,()=>!0),this.folders=h}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=g.$9h.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ji=s;class i{constructor(a,h){this.raw=h,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,I.$Eg)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ki=i;function n(u){return new i({uri:u,index:0,name:(0,I.$Ag)(u)},{uri:u.toString()})}e.$li=n,e.$mi="code-workspace",e.$ni=`.${e.$mi}`,e.$oi=[{name:(0,D.localize)(0,null),extensions:[e.$mi]}],e.$pi="workspace.json";function o(u,a){return I.$vg.isEqualOrParent(u,a.untitledWorkspacesHome)}e.$qi=o;function c(u){let a;return R.URI.isUri(u)?a=u:a=u.configuration,a?.scheme===$.Schemas.tmp}e.$ri=c,e.$si="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(u){return u.id===e.$si}e.$ti=t;function r(u,a){return!o(u,a)&&!c(u)}e.$ui=r;function d(u){return(typeof u=="string"?(0,N.$oc)(u):(0,I.$Cg)(u))===e.$ni}e.$vi=d}),define(Se[269],ke([1,0,54,4,3,23,2,208,133,32,5,13,40,28,266,11,30,12,18]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l,f,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.ProfileResourceType=void 0;var n;(function(u){u.Settings="settings",u.Keybindings="keybindings",u.Snippets="snippets",u.Tasks="tasks",u.Extensions="extensions",u.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function o(u){const a=u;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&R.URI.isUri(a.location)&&R.URI.isUri(a.globalStorageHome)&&R.URI.isUri(a.settingsResource)&&R.URI.isUri(a.keybindingsResource)&&R.URI.isUri(a.tasksResource)&&R.URI.isUri(a.snippetsHome)&&R.URI.isUri(a.extensionsResource))}e.$Yk=o,e.$Zk=(0,A.$3h)("IUserDataProfilesService");function c(u,a){return{id:u.id,isDefault:u.isDefault,name:u.name,shortName:u.shortName,icon:u.icon,location:R.URI.revive(u.location).with({scheme:a}),globalStorageHome:R.URI.revive(u.globalStorageHome).with({scheme:a}),settingsResource:R.URI.revive(u.settingsResource).with({scheme:a}),keybindingsResource:R.URI.revive(u.keybindingsResource).with({scheme:a}),tasksResource:R.URI.revive(u.tasksResource).with({scheme:a}),snippetsHome:R.URI.revive(u.snippetsHome).with({scheme:a}),extensionsResource:R.URI.revive(u.extensionsResource).with({scheme:a}),cacheHome:R.URI.revive(u.cacheHome).with({scheme:a}),useDefaultFlags:u.useDefaultFlags,isTransient:u.isTransient}}e.$1k=c;function t(u,a,h,S,P,w){return{id:u,name:a,location:h,isDefault:!1,shortName:P?.shortName,icon:P?.icon,globalStorageHome:w&&P?.useDefaultFlags?.globalState?w.globalStorageHome:(0,I.$Eg)(h,"globalStorage"),settingsResource:w&&P?.useDefaultFlags?.settings?w.settingsResource:(0,I.$Eg)(h,"settings.json"),keybindingsResource:w&&P?.useDefaultFlags?.keybindings?w.keybindingsResource:(0,I.$Eg)(h,"keybindings.json"),tasksResource:w&&P?.useDefaultFlags?.tasks?w.tasksResource:(0,I.$Eg)(h,"tasks.json"),snippetsHome:w&&P?.useDefaultFlags?.snippets?w.snippetsHome:(0,I.$Eg)(h,"snippets"),extensionsResource:w&&P?.useDefaultFlags?.extensions?w.extensionsResource:(0,I.$Eg)(h,"extensions.json"),cacheHome:(0,I.$Eg)(S,u),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}e.$2k=t;let r=class extends g.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(a,h,S,P){super(),this.t=a,this.u=h,this.w=S,this.y=P,this.f=!0,this.h=this.B(new N.$Sd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$Sd),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$Sd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$Sd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new v.$Ac,emptyWindows:new Map},this.profilesHome=(0,I.$Eg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,I.$Eg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(a){this.f!==a&&(this.z=void 0,this.f=a)}isEnabled(){return this.f}get C(){if(!this.z){const a=this.D(),h=[a];if(this.f)try{for(const w of this.O()){if(!w.name||!(0,i.$Ff)(w.name)||!w.location){this.y.warn("Skipping the invalid stored profile",w.location||w.name);continue}h.push(t((0,I.$Bg)(w.location),w.name,w.location,this.g,{shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags},a))}}catch(w){this.y.error(w)}const S=new v.$Ac,P=new Map;if(h.length)try{const w=this.Q();if(w.workspaces)for(const[p,E]of Object.entries(w.workspaces)){const L=R.URI.parse(p),T=h.find(U=>U.id===E);T&&S.set(L,T)}if(w.emptyWindows)for(const[p,E]of Object.entries(w.emptyWindows)){const L=h.find(T=>T.id===E);L&&P.set(p,L)}}catch(w){this.y.error(w)}this.z={profiles:h,workspaces:S,emptyWindows:P}}return this.z}D(){const a=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...a,extensionsResource:this.S()??a.extensionsResource,isDefault:!0}}async createTransientProfile(a){const h="Temp",S=new RegExp(`${(0,s.$Le)(h)}\\s(\\d+)`);let P=0;for(const p of this.profiles){const E=S.exec(p.name),L=E?parseInt(E[1]):0;P=L>P?L:P}const w=`${h} ${P+1}`;return this.createProfile((0,D.$Qi)((0,f.$ng)()).toString(16),w,{transient:!0},a)}async createNamedProfile(a,h,S){return this.createProfile((0,D.$Qi)((0,f.$ng)()).toString(16),a,h,S)}async createProfile(a,h,S,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=await this.F(a,h,S);return P&&await this.setProfileForWorkspace(P,w),w}async F(a,h,S){if(!(0,i.$Ff)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.r.get(h);return P||(P=(async()=>{try{const w=this.profiles.find(L=>L.name===h||L.id===a);if(w)return w;const p=t(a,h,(0,I.$Eg)(this.profilesHome,a),this.g,S,this.defaultProfile);await this.u.createFolder(p.location);const E=[];return this.j.fire({profile:p,join(L){E.push(L)}}),await l.Promises.settled(E),this.I([p],[],[]),p}finally{this.r.delete(h)}})(),this.r.set(h,P)),P}async updateProfile(a,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(P=>P.id===a.id);if(!S)throw new Error(`Profile '${a.name}' does not exist`);return S=t(S.id,h.name??S.name,S.location,this.g,{shortName:h.shortName??S.shortName,icon:h.icon===null?void 0:h.icon??S.icon,transient:h.transient??S.isTransient,useDefaultFlags:h.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.I([],[],[S]),S}async removeProfile(a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(a.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(P=>P.id===a.id);if(!h)throw new Error(`Profile '${a.name}' does not exist`);const S=[];this.m.fire({profile:h,join(P){S.push(P)}});try{await Promise.allSettled(S)}catch(P){this.y.error(P)}for(const P of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(P)?.id&&this.C.emptyWindows.delete(P);for(const P of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(P)?.id&&this.C.workspaces.delete(P);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(P){(0,y.$Ek)(P)!==1&&this.y.error(P)}}async setProfileForWorkspace(a,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(P=>P.id===h.id);if(!S)throw new Error(`Profile '${h.name}' does not exist`);this.L(a,S)}unsetWorkspace(a,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(a,void 0,h)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const a=await this.u.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(h=>h.isDirectory&&this.profiles.every(S=>!this.w.extUri.isEqual(S.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const a=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(a.map(h=>this.removeProfile(h)))}getProfileForWorkspace(a){const h=this.G(a);return R.URI.isUri(h)?this.s.workspaces.get(h)??this.C.workspaces.get(h):this.s.emptyWindows.get(h)??this.C.emptyWindows.get(h)}G(a){return(0,m.$ai)(a)?a.uri:(0,m.$fi)(a)?a.configPath:a.id}H(a){return!!([...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,a.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,a.location))||[...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,a.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,a.location)))}I(a,h,S){const P=[...this.profiles,...a],w=[];this.s.profiles=[];for(let p of P)p.isDefault||h.some(E=>p.id===E.id)||(p=S.find(E=>p.id===E.id)??p,p.isTransient?this.s.profiles.push(p):w.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags}));this.P(w),this.z=void 0,this.J(a,h,S)}J(a,h,S){this.h.fire({added:a,removed:h,updated:S,all:this.profiles})}L(a,h,S){S=h?.isTransient?!0:S,S||this.L(a,void 0,!0);const P=this.G(a),w=S?this.s:this.C;R.URI.isUri(P)?(w.workspaces.delete(P),h&&w.workspaces.set(P,h)):(w.emptyWindows.delete(P),h&&w.emptyWindows.set(P,h)),S||this.M()}M(){const a={};for(const[S,P]of this.C.workspaces.entries())a[S.toString()]=P.id;const h={};for(const[S,P]of this.C.emptyWindows.entries())h[S.toString()]=P.id;this.R({workspaces:a,emptyWindows:h}),this.z=void 0}N(a){const h={},S=this.D();if(a.workspaces)for(const[w,p]of Object.entries(a.workspaces)){const E=R.URI.parse(p);h[w]=this.w.extUri.isEqual(E,S.location)?S.id:this.w.extUri.basename(E)}const P={};if(a.emptyWindows)for(const[w,p]of Object.entries(a.emptyWindows)){const E=R.URI.parse(p);P[w]=this.w.extUri.isEqual(E,S.location)?S.id:this.w.extUri.basename(E)}return{workspaces:h,emptyWindows:P}}O(){return[]}P(a){throw new Error("not implemented")}Q(){return{}}R(a){throw new Error("not implemented")}S(){}};e.$3k=r,e.$3k=r=Ge([We(0,$.$0h),We(1,y.$nk),We(2,k.$Xk),We(3,C.$kj)],r);class d extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(a){this.a=a}Q(){return this.X}R(a){this.X=a}}e.$4k=d}),define(Se[270],ke([1,0,11,4,3,57,18,188,5,269]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$ip=e.$hp=e.$gp=void 0,e.$gp="__$__isNewStorageMarker",e.$hp="__$__targetStorageMarker",e.$ip=(0,$.$3h)("storageService");var A;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var C;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var m;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function v(i){const n=i.get(e.$hp);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}e.$jp=v;class k extends g.$Sc{static{this.a=60*1e3}constructor(n={flushInterval:k.a}){super(),this.m=n,this.b=this.B(new N.$Vd),this.c=this.B(new N.$Vd),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$Sd),this.onWillSaveState=this.f.event,this.h=this.B(new D.$ch(()=>this.n(),this.m.flushInterval)),this.j=this.B(new g.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,o,c){return N.Event.filter(this.b.event,t=>t.scope===n&&(o===void 0||t.key===o),c)}n(){this.j.value=(0,D.$gh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,g.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.O()}finally{(0,I.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,o){const{key:c,external:t}=o;if(c===e.$hp){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:c,target:this.J(n)[c],external:t})}w(n){this.f.fire({reason:n})}get(n,o,c){return this.P(o)?.get(n,c)}getBoolean(n,o,c){return this.P(o)?.getBoolean(n,c)}getNumber(n,o,c){return this.P(o)?.getNumber(n,c)}getObject(n,o,c){return this.P(o)?.getObject(n,c)}storeAll(n,o){this.y(()=>{for(const c of n)this.store(c.key,c.value,c.scope,c.target,o)})}store(n,o,c,t,r=!1){if((0,R.$Of)(o)){this.remove(n,c,r);return}this.y(()=>{this.z(n,c,t),this.P(c)?.set(n,o,r)})}remove(n,o,c=!1){this.y(()=>{this.z(n,o,void 0),this.P(o)?.delete(n,c)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,o){const c=[],t=this.J(n);for(const r of Object.keys(t))t[r]===o&&c.push(r);return c}z(n,o,c,t=!1){const r=this.J(o);typeof c=="number"?r[n]!==c&&(r[n]=c,this.P(o)?.set(e.$hp,JSON.stringify(r),t)):typeof r[n]=="number"&&(delete r[n],this.P(o)?.set(e.$hp,JSON.stringify(r),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const o=this.P(n);return o?v(o):Object.create(null)}isNew(n){return this.getBoolean(e.$gp,n)===!0}async flush(n=A.NONE){this.f.fire({reason:n});const o=this.P(-1),c=this.P(0),t=this.P(1);switch(n){case A.NONE:await D.Promises.settled([o?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await D.Promises.settled([o?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,o=this.P(0)?.items??new Map,c=this.P(1)?.items??new Map;return s(n,o,c,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,o){return this.w(A.NONE),(0,y.$Yk)(n)?this.R(n,o):this.S(n,o)}M(n,o){return!(n.id===o.id||l(o)&&l(n))}N(n,o,c){this.y(()=>{const t=new Set;for(const[r,d]of n)t.add(r),o.get(r)!==d&&this.u(c,{key:r,external:!0});for(const[r]of o.items)t.has(r)||this.u(c,{key:r,external:!0})})}}e.$kp=k;function l(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$lp=l;class f extends k{constructor(){super(),this.U=this.B(new b.$ep(new b.$fp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$ep(new b.$fp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$ep(new b.$fp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$mp=f;async function s(i,n,o,c,t,r){const d=L=>{try{return JSON.parse(L)}catch{return L}},u=new Map,a=new Map;i.forEach((L,T)=>{u.set(T,L),a.set(T,d(L))});const h=new Map,S=new Map;n.forEach((L,T)=>{h.set(T,L),S.set(T,d(L))});const P=new Map,w=new Map;o.forEach((L,T)=>{P.set(T,L),w.set(T,d(L))}),console.group(c!==t?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const p=[];if(u.forEach((L,T)=>{p.push({key:T,value:L})}),console.table(p),console.groupEnd(),console.log(a),c!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const L=[];h.forEach((T,U)=>{L.push({key:U,value:T})}),console.table(L),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${r})`);const E=[];P.forEach((L,T)=>{E.push({key:T,value:L})}),console.table(E),console.groupEnd(),console.log(w)}e.$np=s}),define(Se[110],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0;class D{static{this.a=!1}constructor(g){this.d=g,this.b=new Map,this.c=1}add(g){const I=this.c++;return this.b.set(I,g),this.e(),I}get(g,I){return this.b.has(g)?this.b.get(g)[I]:void 0}delete(g){this.b.delete(g),this.e()}e(){D.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$dfc=D}),define(Se[58],ke([1,0,17,23,5]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=e.$gfc=void 0;class I{constructor(){this.a=new Set(Object.keys(D.Schemas)),this.b=new Map,this.extUri=new N.$tg(b=>{const $=this.b.get(b.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(b,$){$===null?this.b.delete(b.scheme):this.b.set(b.scheme,$)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$gfc=I,e.$hfc=(0,g.$3h)("IExtHostFileSystemInfo")}),define(Se[27],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=void 0,e.$$M=(0,D.$3h)("IExtHostInitDataService")}),define(Se[271],ke([1,0,214,13,251,27]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=void 0;let R=class extends g.$fO{constructor($,y,A){const C=A.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",m=A.remote.isRemote?(0,D.localize)(0,null):$?(0,D.localize)(1,null):(0,D.localize)(2,null);super(y.createLogger(C,{name:m}))}};e.$nhc=R,e.$nhc=R=Ge([We(1,N.$lj),We(2,I.$$M)],R)}),define(Se[272],ke([1,0,11]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=e.$2fc=void 0;class N{constructor(R,b,$){this.h=new Map,this.a=R,this.b=b,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(y=>(this.f=y,this)),this.g=this.c.onDidChangeStorage(y=>{y.shared===this.b&&y.key===this.a&&(this.f=y.value)}),this.i=new D.$ch(()=>{const y=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of y.values())A.complete()}catch(A){for(const C of y.values())C.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,b){let $=this.f[R];return typeof $>"u"&&($=b),$}update(R,b){this.f[R]=b;const $=this.h.get(R);if($!==void 0)return $.p;const y=new D.$nh;return this.h.set(R,y),this.i.isScheduled()||this.i.schedule(),y.p}dispose(){this.g.dispose()}}e.$2fc=N;class g extends N{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,b){super(R.identifier.value,!0,b),this.j=R}}e.$3fc=g}),define(Se[273],ke([1,0,4,2]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pgc=void 0;class g{constructor(R){this.c=R,this.a=new D.$Sd,this.onDidSaveNotebookDocument=this.a.event,this.b=new D.$Sd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,b,$,y){const C=this.c.getNotebookDocument(N.URI.revive(R)).acceptModelChanged(b.value,$,y);this.b.fire(C)}$acceptDirtyStateChanged(R,b){this.c.getNotebookDocument(N.URI.revive(R)).acceptDirty(b)}$acceptModelSaved(R){const b=this.c.getNotebookDocument(N.URI.revive(R));this.a.fire(b.apiNotebook)}}e.$Pgc=g}),define(Se[20],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VM=e.$UM=void 0,e.$UM=(0,D.$3h)("IExtHostRpcService");class N{constructor(I){this.getProxy=I.getProxy.bind(I),this.set=I.set.bind(I),this.dispose=I.dispose.bind(I),this.assertRegistered=I.assertRegistered.bind(I),this.drain=I.drain.bind(I)}}e.$VM=N}),define(Se[274],ke([1,0,26,4]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=void 0;class g{#e;constructor(R,b){this.b=new N.$Sd,this.onDidChange=this.b.event,this.a=D.$im.toKey(R.identifier),this.#e=b,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(R){return this.#e.get(this.a,R)}store(R,b){return this.#e.store(this.a,R,b)}delete(R){return this.#e.delete(this.a,R)}}e.$0fc=g}),define(Se[66],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=e.$zfc=void 0,e.$zfc=(0,D.$3h)("IURITransformerService");class N{constructor(I){I?(this.transformIncoming=I.transformIncoming.bind(I),this.transformOutgoing=I.transformOutgoing.bind(I),this.transformOutgoingURI=I.transformOutgoingURI.bind(I),this.transformOutgoingScheme=I.transformOutgoingScheme.bind(I)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$Afc=N}),define(Se[275],ke([1,0,22]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5kb=e.$4kb=void 0;class N{constructor(){this.buffers=[]}add($){let y=this.buffers.indexOf($);return y<0&&(y=this.buffers.length,this.buffers.push($)),y}}function g(b,$){if($.serializeBuffersForPostMessage){const y=new N,C=JSON.stringify(b,(v,k)=>{if(k instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:y.add(k)};if(ArrayBuffer.isView(k)){const l=I(k);if(l)return{$$vscode_array_buffer_reference$$:!0,index:y.add(k.buffer),view:{type:l,byteLength:k.byteLength,byteOffset:k.byteOffset}}}return k}),m=y.buffers.map(v=>{const k=new Uint8Array(v);return D.$ge.wrap(k)});return{message:C,buffers:m}}else return{message:JSON.stringify(b),buffers:[]}}e.$4kb=g;function I(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(b,$){const y=$.map(m=>{const v=new ArrayBuffer(m.byteLength);return new Uint8Array(v).set(m.buffer),v}),A=$.length?(m,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const k=v,{index:l}=k,f=y[l];if(k.view)switch(k.view.type){case 1:return new Int8Array(f,k.view.byteOffset,k.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(f,k.view.byteOffset,k.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(f,k.view.byteOffset,k.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(f,k.view.byteOffset,k.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(f,k.view.byteOffset,k.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(f,k.view.byteOffset,k.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(f,k.view.byteOffset,k.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(f,k.view.byteOffset,k.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(f,k.view.byteOffset,k.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(f,k.view.byteOffset,k.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(f,k.view.byteOffset,k.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return f}return v}:void 0;return{message:JSON.parse(b,A),arrayBuffers:y}}e.$5kb=R}),define(Se[276],ke([1,0,277,388,389,62,2,13,390]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=void 0;const y=!1;function A(n,o,c,t,r,d){const u=d.environment.useHostProxy,a=typeof u=="boolean"?u:!d.remote.isRemote,h={resolveProxy:w=>n.resolveProxy(w),lookupProxyAuthorization:f.bind(void 0,t,r,o,{},d.remote.isRemote),getProxyURL:()=>o.getConfiguration("http").get("proxy"),getProxySupport:()=>o.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>m(o),addCertificatesV2:()=>v(o),log:t,getLogLevel:()=>{const w=t.getLevel();switch(w){case b.LogLevel.Trace:return $.LogLevel.Trace;case b.LogLevel.Debug:return $.LogLevel.Debug;case b.LogLevel.Info:return $.LogLevel.Info;case b.LogLevel.Warning:return $.LogLevel.Warning;case b.LogLevel.Error:return $.LogLevel.Error;case b.LogLevel.Off:return $.LogLevel.Off;default:return p(w)}function p(E){return t.error("Unknown log level",E),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:a,loadAdditionalCertificates:async()=>{const w=[];if(d.remote.isRemote&&w.push((0,$.loadSystemCertificates)({log:t})),a){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const p=n.loadCertificates();p.then(E=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",E.length)),w.push(p)}return(await Promise.all(w)).flat()},env:process.env},S=(0,$.createProxyResolver)(h),P=C(h,S);return l(c,P)}e.$Vhc=A;function C(n,o){return{http:Object.assign(D,(0,$.createHttpPatch)(n,D,o)),https:Object.assign(N,(0,$.createHttpPatch)(n,N,o)),net:Object.assign(I,(0,$.createNetPatch)(n,I)),tls:Object.assign(g,(0,$.createTlsPatch)(n,g))}}function m(n){const o=n.getConfiguration("http");return!o.get("experimental.systemCertificatesV2",y)&&!!o.get("systemCertificates")}function v(n){const o=n.getConfiguration("http");return!!o.get("experimental.systemCertificatesV2",y)&&!!o.get("systemCertificates")}const k=new Map;function l(n,o){return n.getExtensionPathIndex().then(c=>{const t=globalThis._VSCODE_NODE_MODULES.module,r=t._load;t._load=function(u,a,h){if(u==="net")return o.net;if(u==="tls")return o.tls;if(u!=="http"&&u!=="https")return r.apply(this,arguments);const S=c.findSubstr(R.URI.file(a.filename));let P=k.get(S);if(P||k.set(S,P={}),!P[u]){const w=o[u];P[u]={...w}}return P[u]}})}async function f(n,o,c,t,r,d,u,a){const h=t[d];u&&(t[d]=u),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${d}`,`proxyAuthenticate:${u}`,`proxyAuthenticateCache:${h}`);const S=u||h,P=Array.isArray(S)?S:typeof S=="string"?[S]:[];if(i(o,P,r),P.some(w=>/^(Negotiate|Kerberos)( |$)/i.test(w))&&!a.kerberosRequested)try{a.kerberosRequested=!0;const w=await new Promise((U,F)=>{me(["kerberos"],U,F)}),p=new URL(d),E=c.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${p.hostname}`:`HTTP@${p.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${d}`,`spn:${E}`),"Negotiate "+await(await w.initializeClient(E)).step("")}catch(w){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",w)}}let s=!1;function i(n,o,c){s||!o.length||(s=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:o.map(t=>t.split(" ")[0]).join(","),extensionHostType:c?"remote":"local"}))}}),define(Se[278],ke([1,0,130]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pr=void 0;function N(I){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:I,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function g(I){return new D.$1m(N(I))}e.$Pr=g}),define(Se[139],ke([1,0,225,18,2,3,5,37,32,17,44,180,39]),function(me,e,D,N,g,I,R,b,$,y,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QE=e.$PE=e.$OE=e.EditorsOrder=e.$NE=e.CloseDirection=e.$ME=e.$LE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$KE=e.$JE=e.$IE=e.$HE=e.$GE=e.$FE=e.$EE=e.$DE=e.EditorInputCapabilities=e.$CE=e.SaveReason=e.Verbosity=e.$BE=e.$AE=e.$zE=e.$yE=e.$xE=e.$wE=e.$vE=e.$uE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$tE=e.$sE=e.$rE=e.$qE=e.$pE=void 0,e.$pE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$qE={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.$rE="workbench.editor.sidebysideEditor",e.$sE="workbench.editors.textDiffEditor",e.$tE="workbench.editors.binaryResourceDiffEditor";var v;(function(ce){ce[ce.PROGRAMMATIC=1]="PROGRAMMATIC",ce[ce.USER=2]="USER",ce[ce.EDIT=3]="EDIT",ce[ce.NAVIGATION=4]="NAVIGATION",ce[ce.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var k;(function(ce){ce[ce.IDENTICAL=1]="IDENTICAL",ce[ce.SIMILAR=2]="SIMILAR",ce[ce.DIFFERENT=3]="DIFFERENT"})(k||(e.EditorPaneSelectionCompareResult=k={}));function l(ce){const K=ce;return!!K&&typeof K.getSelection=="function"&&!!K.onDidChangeSelection}e.$uE=l;function f(ce,K,B){for(const re of B.visibleEditorPanes)if(re.group.id===K&&ce.matches(re.input))return re.getViewState()}e.$vE=f;function s(ce){if(S(ce))return!1;const K=ce;return g.URI.isUri(K?.resource)}e.$wE=s;function i(ce){if(S(ce))return!1;const K=ce;return K?.original!==void 0&&K.modified!==void 0}e.$xE=i;function n(ce){if(S(ce))return!1;const K=ce;return Array.isArray(K?.resources)}e.$yE=n;function o(ce){if(S(ce)||i(ce))return!1;const K=ce;return K?.primary!==void 0&&K.secondary!==void 0}e.$zE=o;function c(ce){if(S(ce))return!1;const K=ce;return K?K.resource===void 0||K.resource.scheme===y.Schemas.untitled||K.forceUntitled===!0:!1}e.$AE=c;function t(ce){if(S(ce))return!1;const K=ce;return g.URI.isUri(K?.base?.resource)&&g.URI.isUri(K?.input1?.resource)&&g.URI.isUri(K?.input2?.resource)&&g.URI.isUri(K?.result?.resource)}e.$BE=t;var r;(function(ce){ce[ce.SHORT=0]="SHORT",ce[ce.MEDIUM=1]="MEDIUM",ce[ce.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var d;(function(ce){ce[ce.EXPLICIT=1]="EXPLICIT",ce[ce.AUTO=2]="AUTO",ce[ce.FOCUS_CHANGE=3]="FOCUS_CHANGE",ce[ce.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(d||(e.SaveReason=d={}));class u{constructor(){this.a=new Map}registerSource(K,B){let re=this.a.get(K);return re||(re={source:K,label:B},this.a.set(K,re)),re.source}getSourceLabel(K){return this.a.get(K)?.label??K}}e.$CE=new u;var a;(function(ce){ce[ce.None=0]="None",ce[ce.Readonly=2]="Readonly",ce[ce.Untitled=4]="Untitled",ce[ce.Singleton=8]="Singleton",ce[ce.RequiresTrust=16]="RequiresTrust",ce[ce.CanSplitInGroup=32]="CanSplitInGroup",ce[ce.ForceDescription=64]="ForceDescription",ce[ce.CanDropIntoEditor=128]="CanDropIntoEditor",ce[ce.MultipleEditors=256]="MultipleEditors",ce[ce.Scratchpad=512]="Scratchpad",ce[ce.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(a||(e.EditorInputCapabilities=a={}));class h extends I.$Sc{}e.$DE=h;function S(ce){return ce instanceof h}e.$EE=S;function P(ce){const K=ce;return g.URI.isUri(K?.preferredResource)}function w(ce){const K=ce;return S(K?.primary)&&S(K?.secondary)}e.$FE=w;function p(ce){const K=ce;return S(K?.modified)&&S(K?.original)}e.$GE=p;function E(ce,K,B,re,ye){return we(re,[(0,C.$Mi)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const de={...B,limits:{size:Number.MAX_VALUE}};ce.openEditor(K,de)}}),(0,C.$Mi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>ye.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:m.default.Warning})}e.$HE=E;function L(ce){return S(ce?.editor)}e.$IE=L;function T(ce){const K=ce;return L(ce)&&K?.group!==void 0}e.$JE=T;function U(ce){const K=ce;return typeof K?.groupId=="number"&&S(K.editor)}e.$KE=U;var F;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.REPLACE=1]="REPLACE",ce[ce.MOVE=2]="MOVE",ce[ce.UNPIN=3]="UNPIN"})(F||(e.EditorCloseContext=F={}));var j;(function(ce){ce[ce.GROUP_ACTIVE=0]="GROUP_ACTIVE",ce[ce.GROUP_INDEX=1]="GROUP_INDEX",ce[ce.GROUP_LABEL=2]="GROUP_LABEL",ce[ce.GROUP_LOCKED=3]="GROUP_LOCKED",ce[ce.EDITOR_OPEN=4]="EDITOR_OPEN",ce[ce.EDITOR_CLOSE=5]="EDITOR_CLOSE",ce[ce.EDITOR_MOVE=6]="EDITOR_MOVE",ce[ce.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ce[ce.EDITOR_LABEL=8]="EDITOR_LABEL",ce[ce.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ce[ce.EDITOR_PIN=10]="EDITOR_PIN",ce[ce.EDITOR_STICKY=11]="EDITOR_STICKY",ce[ce.EDITOR_DIRTY=12]="EDITOR_DIRTY",ce[ce.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(j||(e.GroupModelChangeKind=j={}));var O;(function(ce){ce[ce.PRIMARY=1]="PRIMARY",ce[ce.SECONDARY=2]="SECONDARY",ce[ce.BOTH=3]="BOTH",ce[ce.ANY=4]="ANY"})(O||(e.SideBySideEditor=O={}));class M{getOriginalUri(K,B){if(!K)return;if(t(K))return e.$ME.getOriginalUri(K.result,B);if(B?.supportSideBySide){const{primary:ye,secondary:de}=this.a(K);if(ye&&de){if(B?.supportSideBySide===O.BOTH)return{primary:this.getOriginalUri(ye,{filterByScheme:B.filterByScheme}),secondary:this.getOriginalUri(de,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===O.ANY)return this.getOriginalUri(ye,{filterByScheme:B.filterByScheme})??this.getOriginalUri(de,{filterByScheme:B.filterByScheme});K=B.supportSideBySide===O.PRIMARY?ye:de}}if(i(K)||n(K)||o(K)||t(K))return;const re=P(K)?K.preferredResource:K.resource;return!re||!B||!B.filterByScheme?re:this.b(re,B.filterByScheme)}a(K){return w(K)||o(K)?{primary:K.primary,secondary:K.secondary}:p(K)||i(K)?{primary:K.modified,secondary:K.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(K,B){if(!K)return;if(t(K))return e.$ME.getCanonicalUri(K.result,B);if(B?.supportSideBySide){const{primary:ye,secondary:de}=this.a(K);if(ye&&de){if(B?.supportSideBySide===O.BOTH)return{primary:this.getCanonicalUri(ye,{filterByScheme:B.filterByScheme}),secondary:this.getCanonicalUri(de,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===O.ANY)return this.getCanonicalUri(ye,{filterByScheme:B.filterByScheme})??this.getCanonicalUri(de,{filterByScheme:B.filterByScheme});K=B.supportSideBySide===O.PRIMARY?ye:de}}if(i(K)||n(K)||o(K)||t(K))return;const re=K.resource;return!re||!B||!B.filterByScheme?re:this.b(re,B.filterByScheme)}b(K,B){if(Array.isArray(B)){if(B.some(re=>K.scheme===re))return K}else if(B===K.scheme)return K}}var W;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.KEYBOARD=1]="KEYBOARD",ce[ce.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function Y(ce,K,B,re){if(!ce.isSticky(K))return!1;switch(re.preventPinnedEditorClose){case"keyboardAndMouse":return B===W.MOUSE||B===W.KEYBOARD;case"mouse":return B===W.MOUSE;case"keyboard":return B===W.KEYBOARD}return!1}e.$LE=Y,e.$ME=new M;var ue;(function(ce){ce[ce.LEFT=0]="LEFT",ce[ce.RIGHT=1]="RIGHT"})(ue||(e.CloseDirection=ue={}));class X{constructor(){this.c=new Map,this.d=new Map}start(K){const B=this.a=K.get(R.$2h);for(const[re,ye]of this.c)this.e(re,ye,B);this.c.clear()}e(K,B,re){const ye=re.createInstance(B);this.d.set(K,ye)}registerFileEditorFactory(K){if(this.b)throw new Error("Can only register one file editor factory.");this.b=K}getFileEditorFactory(){return(0,N.$Qf)(this.b)}registerEditorSerializer(K,B){if(this.c.has(K)||this.d.has(K))throw new Error(`A editor serializer with type ID '${K}' was already registered.`);return this.a?this.e(K,B,this.a):this.c.set(K,B),(0,I.$Qc)(()=>{this.c.delete(K),this.d.delete(K)})}getEditorSerializer(K){return this.d.get(typeof K=="string"?K:K.typeId)}}b.$vn.add(e.$pE.EditorFactory,new X);async function J(ce,K,B){return!ce||!ce.length?[]:await Promise.all(ce.map(async re=>{const ye=g.URI.revive(re.fileUri);if(!ye){B.info("Cannot resolve the path because it is not valid.",re);return}if(!await K.canHandleResource(ye)){B.info("Cannot resolve the path because it cannot be handled",re);return}let ge=re.exists,_=re.type;if(typeof ge!="boolean"||typeof _!="number")try{_=(await K.stat(ye)).isDirectory?$.FileType.Directory:$.FileType.Unknown,ge=!0}catch(G){B.error(G),ge=!1}if(!ge&&re.openOnlyIfExists){B.info("Cannot resolve the path because it does not exist",re);return}if(_===$.FileType.Directory){B.info("Cannot resolve the path because it is a directory",re);return}const ie={...re.options,pinned:!0};return ge?{resource:ye,options:ie}:{resource:ye,options:ie,forceUntitled:!0}}))}e.$NE=J;var x;(function(ce){ce[ce.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ce[ce.SEQUENTIAL=1]="SEQUENTIAL"})(x||(e.EditorsOrder=x={}));function he(ce){const K=ce;if(!K)return!1;const B=K;if(B.modified)return he(B.modified);const re=K;return!!(re.contributionsState&&re.viewState&&Array.isArray(re.cursorState))}e.$OE=he;function Z(ce){return(0,A.$Oi)(ce)}e.$PE=Z;function we(ce,K,B){const re=(0,A.$Pi)(ce,K);return re.forceMessage=B?.forceMessage,re.forceSeverity=B?.forceSeverity,re.allowDialog=B?.allowDialog,re}e.$QE=we}),define(Se[279],ke([1,0,4,226,5,3,28,37,19,24,78,265]),function(me,e,D,N,g,I,R,b,$,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZE=e.$YE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$XE=e.$WE=e.ViewContentGroups=e.$VE=e.$UE=e.ViewContainerLocation=e.Extensions=e.$TE=e.$SE=e.$RE=void 0,e.$RE="views",e.$SE=(0,N.localize)(0,null),e.$TE=(0,C.$kw)("default-view-icon",A.$9j.window,(0,N.localize)(1,null));var m;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(m||(e.Extensions=m={}));var v;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(v||(e.ViewContainerLocation=v={})),e.$UE=[0,1,2];function k(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$VE=k;class l extends I.$Sc{constructor(){super(...arguments),this.c=this.B(new D.$Sd),this.onDidRegister=this.c.event,this.f=this.B(new D.$Sd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,$.$Rb)([...this.g.values()])}registerViewContainer(d,u,a){const h=this.get(d.id);if(h)return h;const S=d;return S.openCommandActionDescriptor=a?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,R.$xc)(this.g,u,[]).push(S),a?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:u}),S}deregisterViewContainer(d){for(const u of this.g.keys()){const a=this.g.get(u),h=a?.indexOf(d);if(h!==-1){a?.splice(h,1),a.length===0&&this.g.delete(u),this.f.fire({viewContainer:d,viewContainerLocation:u});return}}}get(d){return this.all.filter(u=>u.id===d)[0]}getViewContainers(d){return[...this.g.get(d)||[]]}getViewContainerLocation(d){return[...this.g.keys()].filter(u=>this.getViewContainers(u).filter(a=>a?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.h.find(u=>this.getViewContainerLocation(u)===d)}}b.$vn.add(m.ViewContainersRegistry,new l);var f;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(f||(e.ViewContentGroups=f={}));function s(r,d){const u=r.group??f.More,a=d.group??f.More;return u!==a?u.localeCompare(a):(r.order??5)-(d.order??5)}class i extends I.$Sc{constructor(){super(...arguments),this.c=this.B(new D.$Sd),this.onViewsRegistered=this.c.event,this.f=this.B(new D.$Sd),this.onViewsDeregistered=this.f.event,this.g=this.B(new D.$Sd),this.onDidChangeContainer=this.g.event,this.h=this.B(new D.$Sd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Gc}registerViews(d,u){this.registerViews2([{views:d,viewContainer:u}])}registerViews2(d){d.forEach(({views:u,viewContainer:a})=>this.r(u,a)),this.c.fire(d)}deregisterViews(d,u){const a=this.s(d,u);a.length&&this.f.fire({views:a,viewContainer:u})}moveViews(d,u){for(const a of this.m.keys())if(a!==u){const h=this.s(d,a);h.length&&(this.r(h,u),this.g.fire({views:h,from:a,to:u}))}}getViews(d){return this.m.get(d)||[]}getView(d){for(const u of this.j){const a=(this.m.get(u)||[]).filter(h=>h.id===d)[0];if(a)return a}return null}getViewContainer(d){for(const u of this.j)if((this.m.get(u)||[]).filter(h=>h.id===d)[0])return u;return null}registerViewWelcomeContent(d,u){return this.n.add(d,u),this.h.fire(d),(0,I.$Qc)(()=>{this.n.delete(d,u),this.h.fire(d)})}registerViewWelcomeContent2(d,u){const a=new Map;for(const[h,S]of u)this.n.add(d,S),a.set(h,(0,I.$Qc)(()=>{this.n.delete(d,S),this.h.fire(d)}));return this.h.fire(d),a}getViewWelcomeContent(d){const u=[];return this.n.forEach(d,a=>u.push(a)),u.sort(s)}r(d,u){let a=this.m.get(u);a||(a=[],this.m.set(u,a),this.j.push(u));for(const h of d){if(this.getView(h.id)!==null)throw new Error((0,N.localize)(2,null,h.id));a.push(h)}}s(d,u){const a=this.m.get(u);if(!a)return[];const h=[],S=[];for(const P of a)d.includes(P)?h.push(P):S.push(P);return h.length&&(S.length?this.m.set(u,S):(this.m.delete(u),this.j.splice(this.j.indexOf(u),1))),h}}b.$vn.add(m.ViewsRegistry,new i),e.$WE=(0,g.$3h)("viewsService"),e.$XE=(0,g.$3h)("viewDescriptorService");var n;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var o;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(o||(e.TreeItemCollapsibleState=o={}));class c{constructor(d,u){this.c=!1,this.d=!1,(0,y.$mn)(this,d),this.d=!!u,this.resolve=async a=>{if(u&&!this.c){const h=await u(a);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}a.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$YE=c;class t extends Error{constructor(d){super((0,N.localize)(3,null,d)),this.name="NoTreeViewError"}static is(d){return d.name==="NoTreeViewError"}}e.$ZE=t}),define(Se[280],ke([1,0,2,29,5]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RF=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$QF=e.$PF=void 0;function I(y){return!!y&&typeof y=="object"&&"uri"in y&&y.uri instanceof D.URI&&"version"in y&&typeof y.version=="number"&&"ranges"in y&&Array.isArray(y.ranges)&&y.ranges.every(N.$Is.isIRange)}e.$PF=I;function R(y){return!!y&&typeof y=="object"&&"documents"in y&&Array.isArray(y.documents)&&y.documents.every(I)}e.$QF=R;var b;(function(y){y[y.Down=0]="Down",y[y.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var $;(function(y){y[y.Action=1]="Action",y[y.Toolbar=2]="Toolbar"})($||(e.ChatAgentCopyKind=$={})),e.$RF=(0,g.$3h)("IChatService")}),define(Se[140],ke([1,0,4,11,227]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xlb=void 0;class I{constructor(){this.f=new Map,this.k=[],this.m=new D.$Sd,this.n=new D.$Sd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(b){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=b}onEvent(b){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=b}onRequest(b){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.s("response",b)}sendRequest(b,$,y,A){const C={command:b};if($&&Object.keys($).length>0&&(C.arguments=$),this.s("request",C),typeof A=="number"){const m=setTimeout(()=>{clearTimeout(m);const v=this.f.get(C.seq);if(v){this.f.delete(C.seq);const k={type:"response",seq:0,request_seq:C.seq,success:!1,command:b,message:(0,g.localize)(0,null,A,b)};v(k)}},A)}return y&&this.f.set(C.seq,y),C.seq}acceptMessage(b){this.j?this.j(b):(this.k.push(b),this.k.length===1&&this.q())}o(b,$){return b.type!=="event"||$.type!=="event"}async q(){let b;for(;this.k.length;){if((!b||this.o(this.k[0],b))&&await(0,N.$4g)(0),b=this.k.shift(),!b)return;switch(b.type){case"event":this.i?.(b);break;case"request":this.g?.(b);break;case"response":{const $=b,y=this.f.get($.request_seq);y&&(this.f.delete($.request_seq),y($));break}}}}s(b,$){$.type=b,$.seq=this.d++,this.sendMessage($)}async u(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach(($,y)=>b.set(y,$)),await(0,N.$4g)(500),b.forEach(($,y)=>{$({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.f.delete(y)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$xlb=I}),define(Se[281],ke([1,0,228,46,5]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$AH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$zH=e.MemoryRangeType=e.$yH=e.State=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=void 0,e.$vG="workbench.view.debug",e.$wG="workbench.debug.variablesView",e.$xG="workbench.debug.watchExpressionsView",e.$yG="workbench.debug.callStackView",e.$zG="workbench.debug.loadedScriptsView",e.$AG="workbench.debug.breakPointsView",e.$BG="workbench.debug.disassemblyView",e.$CG="workbench.panel.repl",e.$DG="workbench.panel.repl.view",e.$EG=new N.$hj("debugType",void 0,{type:"string",description:D.localize(0,null)}),e.$FG=new N.$hj("debugConfigurationType",void 0,{type:"string",description:D.localize(1,null)}),e.$GG=new N.$hj("debugState","inactive",{type:"string",description:D.localize(2,null)}),e.$HG="debugUx",e.$IG=new N.$hj(e.$HG,"default",{type:"string",description:D.localize(3,null)}),e.$JG=new N.$hj("hasDebugged",!1,{type:"boolean",description:D.localize(4,null)}),e.$KG=new N.$hj("inDebugMode",!1,{type:"boolean",description:D.localize(5,null)}),e.$LG=new N.$hj("inDebugRepl",!1,{type:"boolean",description:D.localize(6,null)}),e.$MG=new N.$hj("breakpointWidgetVisible",!1,{type:"boolean",description:D.localize(7,null)}),e.$NG=new N.$hj("inBreakpointWidget",!1,{type:"boolean",description:D.localize(8,null)}),e.$OG=new N.$hj("breakpointsFocused",!0,{type:"boolean",description:D.localize(9,null)}),e.$PG=new N.$hj("watchExpressionsFocused",!0,{type:"boolean",description:D.localize(10,null)}),e.$QG=new N.$hj("watchExpressionsExist",!1,{type:"boolean",description:D.localize(11,null)}),e.$RG=new N.$hj("variablesFocused",!0,{type:"boolean",description:D.localize(12,null)}),e.$SG=new N.$hj("expressionSelected",!1,{type:"boolean",description:D.localize(13,null)}),e.$TG=new N.$hj("breakpointInputFocused",!1,{type:"boolean",description:D.localize(14,null)}),e.$UG=new N.$hj("callStackItemType",void 0,{type:"string",description:D.localize(15,null)}),e.$VG=new N.$hj("callStackSessionIsAttach",!1,{type:"boolean",description:D.localize(16,null)}),e.$WG=new N.$hj("callStackItemStopped",!1,{type:"boolean",description:D.localize(17,null)}),e.$XG=new N.$hj("callStackSessionHasOneThread",!1,{type:"boolean",description:D.localize(18,null)}),e.$YG=new N.$hj("watchItemType",void 0,{type:"string",description:D.localize(19,null)}),e.$ZG=new N.$hj("canViewMemory",void 0,{type:"boolean",description:D.localize(20,null)}),e.$1G=new N.$hj("breakpointItemType",void 0,{type:"string",description:D.localize(21,null)}),e.$2G=new N.$hj("breakpointSupportsCondition",!1,{type:"boolean",description:D.localize(22,null)}),e.$3G=new N.$hj("loadedScriptsSupported",!1,{type:"boolean",description:D.localize(23,null)}),e.$4G=new N.$hj("loadedScriptsItemType",void 0,{type:"string",description:D.localize(24,null)}),e.$5G=new N.$hj("focusedSessionIsAttach",!1,{type:"boolean",description:D.localize(25,null)}),e.$6G=new N.$hj("focusedSessionIsNoDebug",!1,{type:"boolean",description:D.localize(26,null)}),e.$7G=new N.$hj("stepBackSupported",!1,{type:"boolean",description:D.localize(27,null)}),e.$8G=new N.$hj("restartFrameSupported",!1,{type:"boolean",description:D.localize(28,null)}),e.$9G=new N.$hj("stackFrameSupportsRestart",!1,{type:"boolean",description:D.localize(29,null)}),e.$0G=new N.$hj("jumpToCursorSupported",!1,{type:"boolean",description:D.localize(30,null)}),e.$$G=new N.$hj("stepIntoTargetsSupported",!1,{type:"boolean",description:D.localize(31,null)}),e.$_G=new N.$hj("breakpointsExist",!1,{type:"boolean",description:D.localize(32,null)}),e.$aH=new N.$hj("debuggersAvailable",!1,{type:"boolean",description:D.localize(33,null)}),e.$bH=new N.$hj("debugExtensionAvailable",!0,{type:"boolean",description:D.localize(34,null)}),e.$cH=new N.$hj("debugProtocolVariableMenuContext",void 0,{type:"string",description:D.localize(35,null)}),e.$dH=new N.$hj("debugSetVariableSupported",!1,{type:"boolean",description:D.localize(36,null)}),e.$eH=new N.$hj("debugSetExpressionSupported",!1,{type:"boolean",description:D.localize(37,null)}),e.$fH=new N.$hj("breakWhenValueChangesSupported",!1,{type:"boolean",description:D.localize(38,null)}),e.$gH=new N.$hj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:D.localize(39,null)}),e.$hH=new N.$hj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:D.localize(40,null)}),e.$iH=new N.$hj("terminateDebuggeeSupported",!1,{type:"boolean",description:D.localize(41,null)}),e.$jH=new N.$hj("suspendDebuggeeSupported",!1,{type:"boolean",description:D.localize(42,null)}),e.$kH=new N.$hj("variableEvaluateNamePresent",!1,{type:"boolean",description:D.localize(43,null)}),e.$lH=new N.$hj("variableIsReadonly",!1,{type:"boolean",description:D.localize(44,null)}),e.$mH=new N.$hj("exceptionWidgetVisible",!1,{type:"boolean",description:D.localize(45,null)}),e.$nH=new N.$hj("multiSessionRepl",!1,{type:"boolean",description:D.localize(46,null)}),e.$oH=new N.$hj("multiSessionDebug",!1,{type:"boolean",description:D.localize(47,null)}),e.$pH=new N.$hj("disassembleRequestSupported",!1,{type:"boolean",description:D.localize(48,null)}),e.$qH=new N.$hj("disassemblyViewFocus",!1,{type:"boolean",description:D.localize(49,null)}),e.$rH=new N.$hj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:D.localize(50,null)}),e.$sH=new N.$hj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:D.localize(51,null)});const I=m=>D.localize(52,null,m);e.$tH=I,e.$uH="editor.contrib.debug",e.$vH="editor.contrib.breakpoint",e.$wH="debug",e.$xH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:D.localize(53,null)};var R;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(R||(e.State=R={}));function b(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$yH=b;var $;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})($||(e.MemoryRangeType=$={})),e.$zH="vscode-debug-memory";var y;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(y||(e.DebugConfigurationProviderTriggerKind=y={}));var A;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$AH=(0,g.$3h)("debugService");var C;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(C||(e.BreakpointWidgetContext=C={}))}),define(Se[282],ke([1,0,12,2,16,24,17,29,21,19]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=void 0;const A=/{([^}]+)}/g;function C(P,w,p){return P.replace(A,function(E,L){return w&&L.length>0&&L[0]!=="_"?E:p&&p.hasOwnProperty(L)?p[L]:E})}e.$WF=C;function m(P){const w={};for(const p of Object.keys(P))p.startsWith("!")||(w[p]=P[p]);return w}e.$XF=m;function v(P){return P.configuration.request==="attach"&&!k(P)&&(!P.parentSession||v(P.parentSession))}e.$YF=v;function k(P){let w=P.configuration.type;if(w)return w==="vslsShare"&&(w=P.configuration.adapterProxy.configuration.type),(0,D.$9e)(w,"extensionhost")||(0,D.$9e)(w,"pwa-extensionhost")?P:P.parentSession?k(P.parentSession):void 0}e.$ZF=k;function l(P){return P.type&&(P.label||P.program||P.runtime)}e.$1F=l;function f(P,w,p){let E,L=0;const T=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let U=null;for(;U=T.exec(P);){const F=U.index+1,j=F+U[0].length;if(F<=w&&j>=p){E=U[0],L=F;break}}if(E){const F=/\w+/g;let j=null;for(;(j=F.exec(E))&&!(j.index+1+L+j[0].length>=p););j&&(E=E.substring(0,F.lastIndex))}return E?{start:L,end:L+E.length-1}:{start:0,end:0}}e.$2F=f;async function s(P,w,p,E){if(P.evaluatableExpressionProvider.has(w)){const L=P.evaluatableExpressionProvider.ordered(w),T=(0,y.$Hb)(await Promise.all(L.map(async U=>{try{return await U.provideEvaluatableExpression(w,p,E??$.CancellationToken.None)}catch{return}})));if(T.length>0){let U=T[0].expression;const F=T[0].range;return U||(U=w.getLineContent(p.lineNumber).substring(F.startColumn-1,F.endColumn-1)),{range:F,matchingExpression:U}}}else{const L=w.getLineContent(p.lineNumber),{start:T,end:U}=f(L,p.column,p.column),F=L.substring(T-1,U);return{matchingExpression:F,range:new b.$Is(p.lineNumber,T,p.lineNumber,T+F.length)}}return null}e.$3F=s;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(P){return!!(P&&P.match(i))}e.$4F=n;function o(P){if(typeof P.path=="string"&&!(typeof P.sourceReference=="number"&&P.sourceReference>0)){if(n(P.path))return N.URI.parse(P.path);if((0,g.$ic)(P.path))return N.URI.file(P.path)}return P.path}function c(P){if(typeof P.path=="object"){const w=N.URI.revive(P.path);if(w)return w.scheme===R.Schemas.file?w.fsPath:w.toString()}return P.path}function t(P,w){const p=w?o:c,E=(0,I.$jn)(P);return d(E,(L,T)=>{L&&T&&(T.path=p(T))}),E}e.$5F=t;function r(P,w){const p=w?o:c,E=(0,I.$jn)(P);return d(E,(L,T)=>{!L&&T&&(T.path=p(T))}),E}e.$6F=r;function d(P,w){switch(P.type){case"event":{const p=P;switch(p.event){case"output":w(!1,p.body.source);break;case"loadedSource":w(!1,p.body.source);break;case"breakpoint":w(!1,p.body.breakpoint.source);break;default:break}break}case"request":{const p=P;switch(p.command){case"setBreakpoints":w(!0,p.arguments.source);break;case"breakpointLocations":w(!0,p.arguments.source);break;case"source":w(!0,p.arguments.source);break;case"gotoTargets":w(!0,p.arguments.source);break;case"launchVSCode":p.arguments.args.forEach(E=>w(!1,E));break;default:break}break}case"response":{const p=P;if(p.success&&p.body)switch(p.command){case"stackTrace":p.body.stackFrames.forEach(E=>w(!1,E.source));break;case"loadedSources":p.body.sources.forEach(E=>w(!1,E));break;case"scopes":p.body.scopes.forEach(E=>w(!1,E.source));break;case"setFunctionBreakpoints":p.body.breakpoints.forEach(E=>w(!1,E.source));break;case"setBreakpoints":p.body.breakpoints.forEach(E=>w(!1,E.source));break;case"disassemble":p.body?.instructions.forEach(L=>w(!1,L.location));break;default:break}break}}}function u(P){return P.filter(w=>!w.presentation?.hidden).sort((w,p)=>w.presentation?p.presentation?w.presentation.group?p.presentation.group?w.presentation.group!==p.presentation.group?w.presentation.group.localeCompare(p.presentation.group):a(w.presentation.order,p.presentation.order):-1:p.presentation.group?1:a(w.presentation.order,p.presentation.order):-1:p.presentation?1:0)}e.$7F=u;function a(P,w){return typeof P!="number"?typeof w!="number"?0:1:typeof w!="number"?-1:P-w}async function h(P,w){const p=P.getValue("debug.saveBeforeStart",{overrideIdentifier:w.activeTextEditorLanguageId});if(p!=="none"&&(await w.saveAll(),p==="allEditorsInActiveGroup")){const E=w.activeEditorPane;E&&E.input.resource?.scheme===R.Schemas.untitled&&await w.save({editor:E.input,groupId:E.group.id})}await P.reloadConfiguration()}e.$8F=h;const S=(P,w)=>!P||!w?P===w:P.name===w.name&&P.path===w.path&&P.sourceReference===w.sourceReference;e.$9F=S}),define(Se[283],ke([1,0,51,62,24,16,10,12,31,229,140]),function(me,e,D,N,g,I,R,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=e.$whc=e.$vhc=e.$uhc=e.$thc=void 0;class C extends A.$xlb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(s,i){this.p=i,this.r=Buffer.allocUnsafe(0),this.t=-1,s.on("data",n=>this.w(n))}sendMessage(s){if(this.p){const i=JSON.stringify(s);this.p.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${C.a}${i}`,"utf8")}}w(s){for(this.r=Buffer.concat([this.r,s]);;){if(this.t>=0){if(this.r.length>=this.t){const i=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(n){this.m.fire(new Error((n.message||n)+`
`+i))}continue}}else{const i=this.r.indexOf(C.a);if(i!==-1){const o=this.r.toString("utf8",0,i).split(C.b);for(const c of o){const t=c.split(C.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(i+C.a.length);continue}}break}}}e.$thc=C;class m extends C{startSession(){return new Promise((s,i)=>{let n=!1;this.x=this.y(()=>{this.v(this.x,this.x),s(),n=!0}),this.x.on("close",()=>{n?this.m.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",o=>{n?this.m.fire(o):i(o)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$uhc=m;class v extends m{constructor(s){super(),this.z=s}y(s){return N.createConnection(this.z.port,this.z.host||"127.0.0.1",s)}}e.$vhc=v;class k extends m{constructor(s){super(),this.z=s}y(s){return N.createConnection(this.z.path,s)}}e.$whc=k;class l extends C{constructor(s,i){super(),this.y=s,this.z=i}async startSession(){const s=this.y.command,i=this.y.args,n=this.y.options||{};try{if(s)if(I.$ic(s)){if(!await $.Promises.exists(s))throw new Error(y.localize(0,null,s))}else s.indexOf("/")<0&&s.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.z));let o=process.env;if(n.env&&Object.keys(n.env).length>0&&(o=g.$mn(g.$jn(process.env),n.env)),s==="node")if(Array.isArray(i)&&i.length>0){const c=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:o,execArgv:c?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const r=D.fork(i[0],i.slice(1),t);if(!r.pid)throw new Error(y.localize(2,null,i[0]));this.x=r}else throw new Error(y.localize(3,null));else{const c={env:o};n.cwd&&(c.cwd=n.cwd),this.x=D.spawn(s,i,c)}this.x.on("error",c=>{this.m.fire(c)}),this.x.on("exit",(c,t)=>{this.n.fire(c)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",c=>{this.m.fire(c)}),this.x.stdin.on("error",c=>{this.m.fire(c)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(o){this.m.fire(o)}}async stopSession(){return this.x?(await this.u(),R.$i?new Promise((s,i)=>{const n=D.exec(`taskkill /F /T /PID ${this.x.pid}`,function(o,c,t){if(o)return i(o)});n.on("exit",s),n.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(s,i){if(!s)return;const n=Object.create(null);s.runtime&&(s.runtime.indexOf("./")===0?n.runtime=I.$jc(i,s.runtime):n.runtime=s.runtime),s.runtimeArgs&&(n.runtimeArgs=s.runtimeArgs),s.program&&(I.$ic(s.program)?n.program=s.program:n.program=I.$jc(i,s.program)),s.args&&(n.args=s.args);const o=s;return o.win&&(n.win=l.A(o.win,i)),o.winx86&&(n.winx86=l.A(o.winx86,i)),o.windows&&(n.windows=l.A(o.windows,i)),o.osx&&(n.osx=l.A(o.osx,i)),o.linux&&(n.linux=l.A(o.linux,i)),n}static platformAdapterExecutable(s,i){let n=Object.create(null);i=i.toLowerCase();for(const u of s)if(u.contributes){const a=u.contributes.debuggers;a&&a.length>0&&a.filter(h=>typeof h.type=="string"&&b.$9e(h.type,i)).forEach(h=>{const S=l.A(h,u.extensionLocation.fsPath);n=g.$mn(n,S,u.isBuiltin)})}let o;R.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?o=n.winx86||n.win||n.windows:R.$i?o=n.win||n.windows:R.$j?o=n.osx:R.$k&&(o=n.linux),o=o||n;const c=o.program||n.program,t=o.args||n.args,r=o.runtime||n.runtime,d=o.runtimeArgs||n.runtimeArgs;if(r)return{type:"executable",command:r,args:(d||[]).concat(typeof c=="string"?[c]:[]).concat(t||[])};if(c)return{type:"executable",command:c,args:t||[]}}}e.$xhc=l}),define(Se[284],ke([1,0,51,33,10]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zhc=e.$yhc=void 0;function I(y,A){return new Promise((C,m)=>{let v="";const k=D.spawn(y,A);k.pid&&k.stdout.on("data",l=>{v+=l.toString()}),k.on("error",l=>{m(l)}),k.on("close",l=>{C(v)})})}async function R(y){if(y)if(g.$i){const A=await new Promise((C,m)=>{me(["@vscode/windows-process-tree"],C,m)});return new Promise(C=>{A.getProcessTree(y,m=>{C(!!m&&m.children.length>0)})})}else return I("/usr/bin/pgrep",["-lP",String(y)]).then(A=>{const C=A.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}e.$yhc=R;var b;(function(y){y[y.cmd=0]="cmd",y[y.powershell=1]="powershell",y[y.bash=2]="bash"})(b||(b={}));function $(y,A,C,m,v){y=y.trim().toLowerCase();let k;y.indexOf("powershell")>=0||y.indexOf("pwsh")>=0?k=1:y.indexOf("cmd.exe")>=0?k=0:y.indexOf("bash")>=0?k=2:g.$i?k=0:k=2;let l,f=" ";switch(k){case 1:if(l=s=>(s=s.replace(/\'/g,"''"),s.length>0&&s.charAt(s.length-1)==="\\"?`'${s}\\'`:`'${s}'`),m){const s=(0,N.$0f)(m);s&&(f+=`${s}:; `),f+=`cd ${l(m)}; `}if(v)for(const s in v){const i=v[s];i===null?f+=`Remove-Item env:${s}; `:f+=`\${env:${s}}='${i}'; `}if(A.length>0){const s=A.shift(),i=C?s:l(s);f+=i[0]==="'"?`& ${i} `:`${i} `;for(const n of A)f+=n==="<"||n===">"||C?n:l(n),f+=" "}break;case 0:if(l=s=>(s=s.replace(/\"/g,'""'),s=s.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>s.includes(i))||s.length===0?`"${s}"`:s),m){const s=(0,N.$0f)(m);s&&(f+=`${s}: && `),f+=`cd ${l(m)} && `}if(v){f+='cmd /C "';for(const s in v){let i=v[s];i===null?f+=`set "${s}=" && `:(i=i.replace(/[&^|<>]/g,n=>`^${n}`),f+=`set "${s}=${i}" && `)}}for(const s of A)f+=s==="<"||s===">"||C?s:l(s),f+=" ";v&&(f+='"');break;case 2:{l=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),i.length===0?'""':i);const s=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(m&&(f+=`cd ${l(m)} ; `),v){f+="/usr/bin/env";for(const i in v){const n=v[i];n===null?f+=` -u ${s(i)}`:f+=` ${s(`${i}=${n}`)}`}f+=" "}for(const i of A)f+=i==="<"||i===">"||C?i:l(i),f+=" ";break}}return f}e.$zhc=$}),define(Se[111],ke([1,0,22,34,53,100,17,16,10,46]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WI=e.$VI=e.$UI=e.$TI=e.CellStatusbarAlignment=e.$SI=e.$RI=e.$QI=e.NotebookEditorPriority=e.$PI=e.$OI=e.$NI=e.$MI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$LI=e.$KI=e.$JI=e.$II=e.CellKind=e.$HI=e.$GI=e.$FI=void 0,e.$FI="workbench.editor.notebook",e.$GI="workbench.editor.notebookTextDiffEditor",e.$HI="workbench.editor.interactive";var A;(function(M){M[M.Markup=1]="Markup",M[M.Code=2]="Code"})(A||(e.CellKind=A={})),e.$II=["application/json","application/javascript","text/html","image/svg+xml",I.$5r.latex,I.$5r.markdown,"image/png","image/jpeg",I.$5r.text],e.$JI=[I.$5r.latex,I.$5r.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",I.$5r.text],e.$KI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$LI="_notAvailable";var C;(function(M){M[M.Running=1]="Running",M[M.Idle=2]="Idle"})(C||(e.NotebookRunState=C={}));var m;(function(M){M[M.Unconfirmed=1]="Unconfirmed",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(m||(e.NotebookCellExecutionState=m={}));var v;(function(M){M[M.Unconfirmed=1]="Unconfirmed",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var k;(function(M){M[M.WithHardKernelDependency=0]="WithHardKernelDependency",M[M.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",M[M.Pure=2]="Pure",M[M.Never=3]="Never"})(k||(e.NotebookRendererMatch=k={}));var l;(function(M){M.Always="always",M.Never="never",M.Optional="optional"})(l||(e.RendererMessagingSpec=l={}));var f;(function(M){M[M.ModelChange=1]="ModelChange",M[M.Move=2]="Move",M[M.ChangeCellLanguage=5]="ChangeCellLanguage",M[M.Initialize=6]="Initialize",M[M.ChangeCellMetadata=7]="ChangeCellMetadata",M[M.Output=8]="Output",M[M.OutputItem=9]="OutputItem",M[M.ChangeCellContent=10]="ChangeCellContent",M[M.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",M[M.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",M[M.ChangeCellMime=13]="ChangeCellMime",M[M.Unknown=100]="Unknown"})(f||(e.NotebookCellsChangeType=f={}));var s;(function(M){M[M.Handle=0]="Handle",M[M.Index=1]="Index"})(s||(e.SelectionStateType=s={}));var i;(function(M){M[M.Replace=1]="Replace",M[M.Output=2]="Output",M[M.Metadata=3]="Metadata",M[M.CellLanguage=4]="CellLanguage",M[M.DocumentMetadata=5]="DocumentMetadata",M[M.Move=6]="Move",M[M.OutputItems=7]="OutputItems",M[M.PartialMetadata=8]="PartialMetadata",M[M.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var n;(function(M){M.scheme=R.Schemas.vscodeNotebookCell;const W=["W","X","Y","Z","a","b","c","d","e","f"],Y=new RegExp(`^[${W.join("")}]+`),ue=7;function X(ce,K){const B=K.toString(ue),ye=`${B.length<W.length?W[B.length-1]:"z"}${B}s${(0,D.$Ae)(D.$ge.fromString(ce.scheme),!0,!0)}`;return ce.with({scheme:M.scheme,fragment:ye})}M.generate=X;function J(ce){if(ce.scheme!==M.scheme)return;const K=ce.fragment.indexOf("s");if(K<0)return;const B=parseInt(ce.fragment.substring(0,K).replace(Y,""),ue),re=(0,D.$ze)(ce.fragment.substring(K+1)).toString();if(!isNaN(B))return{handle:B,notebook:ce.with({scheme:re,fragment:null})}}M.parse=J;function x(ce,K){return ce.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${K??""},${ce.scheme!==R.Schemas.file?ce.scheme:""}`})}M.generateCellOutputUri=x;function he(ce){if(ce.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const K=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ce.fragment);if(!K)return;const B=K[1]&&K[1]!==""?K[1]:void 0,re=K[2];return{outputId:B,notebook:ce.with({scheme:re||R.Schemas.file,fragment:null})}}M.parseCellOutputUri=he;function Z(ce,K,B){return M.generate(ce,K).with({scheme:B})}M.generateCellPropertyUri=Z;function we(ce,K){if(ce.scheme===K)return M.parse(ce.with({scheme:M.scheme}))}M.parseCellPropertyUri=we})(n||(e.CellUri=n={}));const o=M=>$.$i?M.replace(/\//g,"\\"):M;class c{constructor(W=[],Y=e.$II){this.e=Y,this.d=[...new Set(W)].map(ue=>({pattern:ue,matches:N.$Jj(o(ue))}))}sort(W){const Y=new Map(g.Iterable.map(W,X=>[X,o(X)]));let ue=[];for(const{matches:X}of this.d)for(const[J,x]of Y)if(X(x)){ue.push(J),Y.delete(J);break}return Y.size&&(ue=ue.concat([...Y.keys()].sort((X,J)=>this.e.indexOf(X)-this.e.indexOf(J)))),ue}prioritize(W,Y){const ue=this.f(W);if(ue===-1){this.d.unshift({pattern:W,matches:N.$Jj(o(W))});return}const X=new Set(Y.map(x=>this.f(x,ue)));X.delete(-1);const J=Array.from(X).sort();this.d.splice(ue+1,0,...J.map(x=>this.d[x]));for(let x=J.length-1;x>=0;x--)this.d.splice(J[x],1)}toArray(){return this.d.map(W=>W.pattern)}f(W,Y=this.d.length){const ue=o(W);for(let X=0;X<Y;X++)if(this.d[X].matches(ue))return X;return-1}}e.$MI=c;function t(M,W,Y,ue=(X,J)=>X===J){const X=[];function J(Z,we,ce){if(we===0&&ce.length===0)return;const K=X[X.length-1];K&&K.start+K.deleteCount===Z?(K.deleteCount+=we,K.toInsert.push(...ce)):X.push({start:Z,deleteCount:we,toInsert:ce})}let x=0,he=0;for(;;){if(x===M.length){J(x,0,W.slice(he));break}if(he===W.length){J(x,M.length-x,[]);break}const Z=M[x],we=W[he];if(ue(Z,we)){x+=1,he+=1;continue}Y(we)?(J(x,1,[]),x+=1):(J(x,0,[we]),he+=1)}return X}e.$NI=t,e.$OI=new y.$hj("notebookEditorCursorAtBoundary","none"),e.$PI=new y.$hj("notebookEditorCursorAtLineBoundary","none");var r;(function(M){M.default="default",M.option="option"})(r||(e.NotebookEditorPriority=r={}));function d(M){const W=M;return!!((typeof W.include=="string"||N.$Kj(W.include))&&(typeof W.exclude=="string"||N.$Kj(W.exclude)))}e.$QI=d;function u(M,W,Y){if(Array.isArray(M.viewType)&&M.viewType.indexOf(W)>=0||M.viewType===W)return!0;if(M.filenamePattern){const ue=d(M.filenamePattern)?M.filenamePattern.include:M.filenamePattern,X=d(M.filenamePattern)?M.filenamePattern.exclude:void 0;if(N.$Ij(ue,(0,b.$nc)(Y.fsPath).toLowerCase()))return!(X&&N.$Ij(X,(0,b.$nc)(Y.fsPath).toLowerCase()))}return!1}e.$RI=u,e.$SI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var a;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(a||(e.CellStatusbarAlignment=a={}));class h{static{this.d="notebook/"}static create(W){return`${h.d}${W}`}static parse(W){if(W.startsWith(h.d))return W.substring(h.d.length)}}e.$TI=h;function S(M){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(M)}e.$UI=S;const P=new TextDecoder;function w(M){const W=[];let Y=!1;for(const x of M)(W.length===0||Y)&&(W.push(x),Y=!0);let ue=L(W);const X=D.$ge.concat(W.map(x=>D.$ge.wrap(x))),J=O(X);return ue=ue||J.byteLength!==X.byteLength,{data:J,didCompression:ue}}e.$VI=w,e.$WI=`${String.fromCharCode(27)}[A`;const p=e.$WI.split("").map(M=>M.charCodeAt(0)),E=10;function L(M){let W=!1;return M.forEach((Y,ue)=>{if(ue===0||Y.length<e.$WI.length)return;const X=M[ue-1],J=Y.subarray(0,e.$WI.length);if(J[0]===p[0]&&J[1]===p[1]&&J[2]===p[2]){const x=X.lastIndexOf(E);if(x===-1)return;W=!0,M[ue-1]=X.subarray(0,x),M[ue]=Y.subarray(e.$WI.length)}}),W}function T(M){let W=M;do M=W,W=M.replace(/[^\n]\x08/gm,"");while(W.length<M.length);return M}function U(M){for(M=M.replace(/\r+\n/gm,`
`);M.search(/\r[^$]/g)>-1;){const W=M.match(/^(.*)\r+/m)[1];let Y=M.match(/\r+(.*)$/m)[1];Y=Y+W.slice(Y.length,W.length),M=M.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Y)}return M}const F="\b".charCodeAt(0),j="\r".charCodeAt(0);function O(M){return!M.buffer.includes(F)&&!M.buffer.includes(j)?M:D.$ge.fromString(U(T(P.decode(M.buffer))))}}),define(Se[7],ke([1,0,19,14,80,28,100,12,18,2,30,26,32,64,111]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k){"use strict";var l,f,s,i,n,o,c,t,r,d,u,a,h,S,P,w,p;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$JM=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$IM=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=e.$CM=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$wM=e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.TestRunProfileKind=e.TestResultState=e.$oM=e.$nM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$mM=e.NotebookVariablesRequestKind=e.$lM=e.$kM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$jM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.ColorThemeKind=e.$dM=e.$cM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$bM=e.DebugConsoleMode=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$8L=e.$7L=e.FileChangeType=e.$6L=e.$5L=e.$4L=e.$3L=e.InlineCompletionTriggerKind=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.ConfigurationTarget=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$FL=e.ViewBadge=e.ProgressLocation=e.$EL=e.$DL=e.TaskScope=e.ShellQuoting=e.$CL=e.$BL=e.$AL=e.TaskPanelKind=e.TaskRevealKind=e.$zL=e.TerminalLocation=e.$yL=e.$xL=e.$wL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$vL=e.$uL=e.$tL=e.$sL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$rL=e.StatusBarAlignment=e.ViewColumn=e.$qL=e.$pL=e.$oL=e.$nL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$mL=e.$lL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.LanguageStatusSeverity=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.CodeActionTriggerKind=e.$_K=e.$$K=e.SymbolTag=e.SymbolKind=e.$0K=e.$9K=e.DocumentHighlightKind=e.$8K=e.$7K=e.$6K=e.$5K=e.DiagnosticSeverity=e.DiagnosticTag=e.$4K=e.$3K=e.FileEditType=e.$2K=e.$1K=e.$ZK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function E(H){return Object.assign(H,{apply:function(...pe){if(pe.length===0)return Reflect.construct(H,[]);{const Me=pe.length===1?[]:pe[1];return Reflect.construct(H,Me,pe[0].constructor)}},call:function(...pe){if(pe.length===0)return Reflect.construct(H,[]);{const[Me,...Ye]=pe;return Reflect.construct(H,Ye,Me.constructor)}}})}var L;(function(H){H[H.Top=0]="Top",H[H.Bottom=1]="Bottom"})(L||(e.TerminalOutputAnchor=L={}));var T;(function(H){H[H.TerminalCommand=0]="TerminalCommand",H[H.Opener=1]="Opener",H[H.Command=3]="Command"})(T||(e.TerminalQuickFixType=T={}));let U=l=class{static from(...q){let pe=q;return new l(function(){if(pe){for(const Me of pe)Me&&typeof Me.dispose=="function"&&Me.dispose();pe=void 0}})}#e;constructor(q){this.#e=q}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$SK=U,e.$SK=U=l=Ge([E],U);let F=f=class{static Min(...q){if(q.length===0)throw new TypeError;let pe=q[0];for(let Me=1;Me<q.length;Me++){const Ye=q[Me];Ye.isBefore(pe)&&(pe=Ye)}return pe}static Max(...q){if(q.length===0)throw new TypeError;let pe=q[0];for(let Me=1;Me<q.length;Me++){const Ye=q[Me];Ye.isAfter(pe)&&(pe=Ye)}return pe}static isPosition(q){if(!q)return!1;if(q instanceof f)return!0;const{line:pe,character:Me}=q;return typeof pe=="number"&&typeof Me=="number"}static of(q){if(q instanceof f)return q;if(this.isPosition(q))return new f(q.line,q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(q,pe){if(q<0)throw(0,N.$7)("line must be non-negative");if(pe<0)throw(0,N.$7)("character must be non-negative");this.c=q,this.e=pe}isBefore(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<q.e}isBeforeOrEqual(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<=q.e}isAfter(q){return!this.isBeforeOrEqual(q)}isAfterOrEqual(q){return!this.isBefore(q)}isEqual(q){return this.c===q.c&&this.e===q.e}compareTo(q){return this.c<q.c?-1:this.c>q.line?1:this.e<q.e?-1:this.e>q.e?1:0}translate(q,pe=0){if(q===null||pe===null)throw(0,N.$7)();let Me;return typeof q>"u"?Me=0:typeof q=="number"?Me=q:(Me=typeof q.lineDelta=="number"?q.lineDelta:0,pe=typeof q.characterDelta=="number"?q.characterDelta:0),Me===0&&pe===0?this:new f(this.line+Me,this.character+pe)}with(q,pe=this.character){if(q===null||pe===null)throw(0,N.$7)();let Me;return typeof q>"u"?Me=this.line:typeof q=="number"?Me=q:(Me=typeof q.line=="number"?q.line:this.line,pe=typeof q.character=="number"?q.character:this.character),Me===this.line&&pe===this.character?this:new f(Me,pe)}toJSON(){return{line:this.line,character:this.character}}};e.$TK=F,e.$TK=F=f=Ge([E],F);let j=s=class{static isRange(q){return q instanceof s?!0:q?F.isPosition(q.start)&&F.isPosition(q.end):!1}static of(q){if(q instanceof s)return q;if(this.isRange(q))return new s(q.start,q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(q,pe,Me,Ye){let tt,lt;if(typeof q=="number"&&typeof pe=="number"&&typeof Me=="number"&&typeof Ye=="number"?(tt=new F(q,pe),lt=new F(Me,Ye)):F.isPosition(q)&&F.isPosition(pe)&&(tt=F.of(q),lt=F.of(pe)),!tt||!lt)throw new Error("Invalid arguments");tt.isBefore(lt)?(this.c=tt,this.e=lt):(this.c=lt,this.e=tt)}contains(q){return s.isRange(q)?this.contains(q.start)&&this.contains(q.end):F.isPosition(q)?!(F.of(q).isBefore(this.c)||this.e.isBefore(q)):!1}isEqual(q){return this.c.isEqual(q.c)&&this.e.isEqual(q.e)}intersection(q){const pe=F.Max(q.start,this.c),Me=F.Min(q.end,this.e);if(!pe.isAfter(Me))return new s(pe,Me)}union(q){if(this.contains(q))return this;if(q.contains(this))return q;const pe=F.Min(q.start,this.c),Me=F.Max(q.end,this.end);return new s(pe,Me)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(q,pe=this.end){if(q===null||pe===null)throw(0,N.$7)();let Me;return q?F.isPosition(q)?Me=q:(Me=q.start||this.start,pe=q.end||this.end):Me=this.start,Me.isEqual(this.c)&&pe.isEqual(this.end)?this:new s(Me,pe)}toJSON(){return[this.start,this.end]}};e.$UK=j,e.$UK=j=s=Ge([E],j);let O=i=class extends j{static isSelection(q){return q instanceof i?!0:q?j.isRange(q)&&F.isPosition(q.anchor)&&F.isPosition(q.active)&&typeof q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(q,pe,Me,Ye){let tt,lt;if(typeof q=="number"&&typeof pe=="number"&&typeof Me=="number"&&typeof Ye=="number"?(tt=new F(q,pe),lt=new F(Me,Ye)):F.isPosition(q)&&F.isPosition(pe)&&(tt=F.of(q),lt=F.of(pe)),!tt||!lt)throw new Error("Invalid arguments");super(tt,lt),this.f=tt,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$VK=O,e.$VK=O=i=Ge([E],O);const M=H=>{if(typeof H!="string"||H.length===0||!/^[0-9A-Za-z_\-]+$/.test(H))throw(0,N.$7)("connectionToken")};class W{static isResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.host=="string"&&typeof q.port=="number"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,pe,Me){if(typeof q!="string"||q.length===0)throw(0,N.$7)("host");if(typeof pe!="number"||pe===0||Math.round(pe)!==pe)throw(0,N.$7)("port");typeof Me<"u"&&M(Me),this.host=q,this.port=Math.round(pe),this.connectionToken=Me}}e.$WK=W;class Y{static isManagedResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.makeConnection=="function"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,pe){this.makeConnection=q,this.connectionToken=pe,typeof pe<"u"&&M(pe)}}e.$XK=Y;class ue extends Error{static NotAvailable(q,pe){return new ue(q,v.RemoteAuthorityResolverErrorCode.NotAvailable,pe)}static TemporarilyNotAvailable(q){return new ue(q,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(q,pe=v.RemoteAuthorityResolverErrorCode.Unknown,Me){super(q),this._message=q,this._code=pe,this._detail=Me,Object.setPrototypeOf(this,ue.prototype)}}e.$YK=ue;var X;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(X||(e.EndOfLine=X={}));var J;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(J||(e.EnvironmentVariableMutatorType=J={}));let x=n=class{static isTextEdit(q){return q instanceof n?!0:q?j.isRange(q)&&typeof q.newText=="string":!1}static replace(q,pe){return new n(q,pe)}static insert(q,pe){return n.replace(new j(q,q),pe)}static delete(q){return n.replace(q,"")}static setEndOfLine(q){const pe=new n(new j(new F(0,0),new F(0,0)),"");return pe.newEol=q,pe}get range(){return this.c}set range(q){if(q&&!j.isRange(q))throw(0,N.$7)("range");this.c=q}get newText(){return this.e||""}set newText(q){if(q&&typeof q!="string")throw(0,N.$7)("newText");this.e=q}get newEol(){return this.f}set newEol(q){if(q&&typeof q!="number")throw(0,N.$7)("newEol");this.f=q}constructor(q,pe){this.c=q,this.e=pe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$ZK=x,e.$ZK=x=n=Ge([E],x);let he=o=class{static isNotebookCellEdit(q){return q instanceof o?!0:q?ei.isNotebookRange(q)&&Array.isArray(q.newCells):!1}static replaceCells(q,pe){return new o(q,pe)}static insertCells(q,pe){return new o(new ei(q,q),pe)}static deleteCells(q){return new o(q,[])}static updateCellMetadata(q,pe){const Me=new o(new ei(q,q),[]);return Me.newCellMetadata=pe,Me}static updateNotebookMetadata(q){const pe=new o(new ei(0,0),[]);return pe.newNotebookMetadata=q,pe}constructor(q,pe){this.range=q,this.newCells=pe}};e.$1K=he,e.$1K=he=o=Ge([E],he);class Z{static isSnippetTextEdit(q){return q instanceof Z?!0:q?j.isRange(q.range)&&K.isSnippetString(q.snippet):!1}static replace(q,pe){return new Z(q,pe)}static insert(q,pe){return Z.replace(new j(q,q),pe)}constructor(q,pe){this.range=q,this.snippet=pe}}e.$2K=Z;var we;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace",H[H.Snippet=6]="Snippet"})(we||(e.FileEditType=we={}));let ce=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(q,pe,Me,Ye){this.c.push({_type:1,from:q,to:pe,options:Me,metadata:Ye})}createFile(q,pe,Me){this.c.push({_type:1,from:void 0,to:q,options:pe,metadata:Me})}deleteFile(q,pe,Me){this.c.push({_type:1,from:q,to:void 0,options:pe,metadata:Me})}e(q,pe,Me){this.c.push({_type:3,metadata:Me,uri:q,edit:{editType:5,metadata:pe},notebookMetadata:pe})}f(q,pe,Me,Ye){const tt=pe.start,lt=pe.end;(tt!==lt||Me.length>0)&&this.c.push({_type:5,uri:q,index:tt,count:lt-tt,cells:Me,metadata:Ye})}g(q,pe,Me,Ye){this.c.push({_type:3,metadata:Ye,uri:q,edit:{editType:3,index:pe,metadata:Me}})}replace(q,pe,Me,Ye){this.c.push({_type:2,uri:q,edit:new x(pe,Me),metadata:Ye})}insert(q,pe,Me,Ye){this.replace(q,new j(pe,pe),Me,Ye)}delete(q,pe,Me){this.replace(q,pe,"",Me)}has(q){return this.c.some(pe=>pe._type===2&&pe.uri.toString()===q.toString())}set(q,pe){if(pe)for(const Me of pe){if(!Me)continue;let Ye,tt;Array.isArray(Me)?(Ye=Me[0],tt=Me[1]):Ye=Me,he.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.g(q,Ye.range.start,Ye.newCellMetadata,tt):Ye.newNotebookMetadata?this.e(q,Ye.newNotebookMetadata,tt):this.f(q,Ye.range,Ye.newCells,tt):Z.isSnippetTextEdit(Ye)?this.c.push({_type:6,uri:q,range:Ye.range,edit:Ye.snippet,metadata:tt}):this.c.push({_type:2,uri:q,edit:Ye,metadata:tt})}else{for(let Me=0;Me<this.c.length;Me++){const Ye=this.c[Me];switch(Ye._type){case 2:case 6:case 3:case 5:Ye.uri.toString()===q.toString()&&(this.c[Me]=void 0);break}}(0,D.$Ib)(this.c)}}get(q){const pe=[];for(const Me of this.c)Me._type===2&&Me.uri.toString()===q.toString()&&pe.push(Me.edit);return pe}entries(){const q=new I.$Ac;for(const pe of this.c)if(pe._type===2){let Me=q.get(pe.uri);Me||(Me=[pe.uri,[]],q.set(pe.uri,Me)),Me[1].push(pe.edit)}return[...q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$3K=ce,e.$3K=ce=Ge([E],ce);let K=c=class{static isSnippetString(q){return q instanceof c?!0:q?typeof q.value=="string":!1}static c(q){return q.replace(/\$|}|\\/g,"\\$&")}constructor(q){this.e=1,this.value=q||""}appendText(q){return this.value+=c.c(q),this}appendTabstop(q=this.e++){return this.value+="$",this.value+=q,this}appendPlaceholder(q,pe=this.e++){if(typeof q=="function"){const Me=new c;Me.e=this.e,q(Me),this.e=Me.e,q=Me.value}else q=c.c(q);return this.value+="${",this.value+=pe,this.value+=":",this.value+=q,this.value+="}",this}appendChoice(q,pe=this.e++){const Me=q.map(Ye=>Ye.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=pe,this.value+="|",this.value+=Me,this.value+="|}",this}appendVariable(q,pe){if(typeof pe=="function"){const Me=new c;Me.e=this.e,pe(Me),this.e=Me.e,pe=Me.value}else typeof pe=="string"&&(pe=pe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=q,pe&&(this.value+=":",this.value+=pe),this.value+="}",this}};e.$4K=K,e.$4K=K=c=Ge([E],K);var B;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(B||(e.DiagnosticTag=B={}));var re;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(re||(e.DiagnosticSeverity=re={}));let ye=t=class{static isLocation(q){return q instanceof t?!0:q?j.isRange(q.range)&&y.URI.isUri(q.uri):!1}constructor(q,pe){if(this.uri=q,pe)if(j.isRange(pe))this.range=j.of(pe);else if(F.isPosition(pe))this.range=new j(pe,pe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$5K=ye,e.$5K=ye=t=Ge([E],ye);let de=class{static is(q){return q?typeof q.message=="string"&&q.location&&j.isRange(q.location.range)&&y.URI.isUri(q.location.uri):!1}constructor(q,pe){this.location=q,this.message=pe}static isEqual(q,pe){return q===pe?!0:!q||!pe?!1:q.message===pe.message&&q.location.range.isEqual(pe.location.range)&&q.location.uri.toString()===pe.location.uri.toString()}};e.$6K=de,e.$6K=de=Ge([E],de);let ge=class{constructor(q,pe,Me=re.Error){if(!j.isRange(q))throw new TypeError("range must be set");if(!pe)throw new TypeError("message must be set");this.range=q,this.message=pe,this.severity=Me}toJSON(){return{severity:re[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(q,pe){return q===pe?!0:!q||!pe?!1:q.message===pe.message&&q.severity===pe.severity&&q.code===pe.code&&q.severity===pe.severity&&q.source===pe.source&&q.range.isEqual(pe.range)&&(0,D.$ub)(q.tags,pe.tags)&&(0,D.$ub)(q.relatedInformation,pe.relatedInformation,de.isEqual)}};e.$7K=ge,e.$7K=ge=Ge([E],ge);let _=class{constructor(q,pe){if(!q)throw new Error("Illegal argument, contents must be defined");Array.isArray(q)?this.contents=q:this.contents=[q],this.range=pe}};e.$8K=_,e.$8K=_=Ge([E],_);var ie;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(ie||(e.DocumentHighlightKind=ie={}));let G=class{constructor(q,pe=ie.Text){this.range=q,this.kind=pe}toJSON(){return{range:this.range,kind:ie[this.kind]}}};e.$9K=G,e.$9K=G=Ge([E],G);let te=class{constructor(q,pe){this.uri=q,this.highlights=pe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(q=>q.toJSON())}}};e.$0K=te,e.$0K=te=Ge([E],te);var fe;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(fe||(e.SymbolKind=fe={}));var ve;(function(H){H[H.Deprecated=1]="Deprecated"})(ve||(e.SymbolTag=ve={}));let Pe=r=class{static validate(q){if(!q.name)throw new Error("name must not be falsy")}constructor(q,pe,Me,Ye,tt){this.name=q,this.kind=pe,this.containerName=tt,typeof Me=="string"&&(this.containerName=Me),Ye instanceof ye?this.location=Ye:Me instanceof j&&(this.location=new ye(Ye,Me)),r.validate(this)}toJSON(){return{name:this.name,kind:fe[this.kind],location:this.location,containerName:this.containerName}}};e.$$K=Pe,e.$$K=Pe=r=Ge([E],Pe);let be=d=class{static validate(q){if(!q.name)throw new Error("name must not be falsy");if(!q.range.contains(q.selectionRange))throw new Error("selectionRange must be contained in fullRange");q.children?.forEach(d.validate)}constructor(q,pe,Me,Ye,tt){this.name=q,this.detail=pe,this.kind=Me,this.range=Ye,this.selectionRange=tt,this.children=[],d.validate(this)}};e.$_K=be,e.$_K=be=d=Ge([E],be);var De;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(De||(e.CodeActionTriggerKind=De={}));let z=class{constructor(q,pe){this.title=q,this.kind=pe}};e.$aL=z,e.$aL=z=Ge([E],z);let Q=class{static{u=this}static{this.c="."}constructor(q){this.value=q}append(q){return new u(this.value?this.value+u.c+q:q)}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+u.c)}};e.$bL=Q,e.$bL=Q=u=Ge([E],Q),Q.Empty=new Q(""),Q.QuickFix=Q.Empty.append("quickfix"),Q.Refactor=Q.Empty.append("refactor"),Q.RefactorExtract=Q.Refactor.append("extract"),Q.RefactorInline=Q.Refactor.append("inline"),Q.RefactorMove=Q.Refactor.append("move"),Q.RefactorRewrite=Q.Refactor.append("rewrite"),Q.Source=Q.Empty.append("source"),Q.SourceOrganizeImports=Q.Source.append("organizeImports"),Q.SourceFixAll=Q.Source.append("fixAll"),Q.Notebook=Q.Empty.append("notebook");let ee=class{constructor(q,pe){if(this.range=q,this.parent=pe,pe&&!pe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$cL=ee,e.$cL=ee=Ge([E],ee);class V{constructor(q,pe,Me,Ye,tt,lt){this.kind=q,this.name=pe,this.detail=Me,this.uri=Ye,this.range=tt,this.selectionRange=lt}}e.$dL=V;class oe{constructor(q,pe){this.fromRanges=pe,this.from=q}}e.$eL=oe;class le{constructor(q,pe){this.fromRanges=pe,this.to=q}}e.$fL=le;var Re;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(Re||(e.LanguageStatusSeverity=Re={}));let je=class{constructor(q,pe){this.range=q,this.command=pe}get isResolved(){return!!this.command}};e.$gL=je,e.$gL=je=Ge([E],je);let He=a=class{#e;static isMarkdownString(q){return q instanceof a?!0:q&&q.appendCodeblock&&q.appendMarkdown&&q.appendText&&q.value!==void 0}constructor(q,pe=!1){this.#e=new g.$ek(q,{supportThemeIcons:pe})}get value(){return this.#e.value}set value(q){this.#e.value=q}get isTrusted(){return this.#e.isTrusted}set isTrusted(q){this.#e.isTrusted=q}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(q){this.#e.supportThemeIcons=q}get supportHtml(){return this.#e.supportHtml}set supportHtml(q){this.#e.supportHtml=q}get baseUri(){return this.#e.baseUri}set baseUri(q){this.#e.baseUri=q}appendText(q){return this.#e.appendText(q),this}appendMarkdown(q){return this.#e.appendMarkdown(q),this}appendCodeblock(q,pe){return this.#e.appendCodeblock(pe??"",q),this}};e.$hL=He,e.$hL=He=a=Ge([E],He);let Je=class{constructor(q,pe){this.label=q,this.documentation=pe}};e.$iL=Je,e.$iL=Je=Ge([E],Je);let _e=class{constructor(q,pe){this.label=q,this.documentation=pe,this.parameters=[]}};e.$jL=_e,e.$jL=_e=Ge([E],_e);let ct=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$kL=ct,e.$kL=ct=Ge([E],ct);var ot;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(ot||(e.SignatureHelpTriggerKind=ot={}));var rt;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let Ae=class{constructor(q){this.value=q}};e.$lL=Ae,e.$lL=Ae=Ge([E],Ae);let Ue=class{constructor(q,pe,Me){this.position=q,this.label=pe,this.kind=Me}};e.$mL=Ue,e.$mL=Ue=Ge([E],Ue);var Le;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Le||(e.CompletionTriggerKind=Le={}));var Xe;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(Xe||(e.CompletionItemKind=Xe={}));var ne;(function(H){H[H.Deprecated=1]="Deprecated"})(ne||(e.CompletionItemTag=ne={}));let ae=class{constructor(q,pe){this.label=q,this.kind=pe}toJSON(){return{label:this.label,kind:this.kind&&Xe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$nL=ae,e.$nL=ae=Ge([E],ae);let Ie=class{constructor(q=[],pe=!1){this.items=q,this.isIncomplete=pe}};e.$oL=Ie,e.$oL=Ie=Ge([E],Ie);let Ve=class{constructor(q,pe,Me){this.insertText=q,this.range=pe,this.command=Me}};e.$pL=Ve,e.$pL=Ve=Ge([E],Ve);let Ze=class{constructor(q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=q}};e.$qL=Ze,e.$qL=Ze=Ge([E],Ze);var nt;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var it;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(it||(e.StatusBarAlignment=it={}));function Oe(H,q){return`${C.$im.toKey(H)}.${q}`}e.$rL=Oe;var wt;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(wt||(e.TextEditorLineNumbersStyle=wt={}));var kt;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(kt||(e.TextDocumentSaveReason=kt={}));var Tt;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Tt||(e.TextEditorRevealType=Tt={}));var Wt;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(Wt||(e.TextEditorSelectionChangeKind=Wt={}));var Et;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(Et||(e.TextDocumentChangeReason=Et={}));var Kt;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(Kt||(e.DecorationRangeBehavior=Kt={})),function(H){function q(pe){switch(pe){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=q}(Wt||(e.TextEditorSelectionChangeKind=Wt={}));var Ot;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(Ot||(e.SyntaxTokenType=Ot={})),function(H){function q(pe){switch(pe){case H.Other:return"other";case H.Comment:return"comment";case H.String:return"string";case H.RegEx:return"regex"}return"other"}H.toString=q}(Ot||(e.SyntaxTokenType=Ot={}));let Zt=class{constructor(q,pe){if(pe&&!y.URI.isUri(pe))throw(0,N.$7)("target");if(!j.isRange(q)||q.isEmpty)throw(0,N.$7)("range");this.range=q,this.target=pe}};e.$sL=Zt,e.$sL=Zt=Ge([E],Zt);let Ut=class{constructor(q,pe,Me,Ye){this.red=q,this.green=pe,this.blue=Me,this.alpha=Ye}};e.$tL=Ut,e.$tL=Ut=Ge([E],Ut);let Lt=class{constructor(q,pe){if(pe&&!(pe instanceof Ut))throw(0,N.$7)("color");if(!j.isRange(q)||q.isEmpty)throw(0,N.$7)("range");this.range=q,this.color=pe}};e.$uL=Lt,e.$uL=Lt=Ge([E],Lt);let et=class{constructor(q){if(!q||typeof q!="string")throw(0,N.$7)("label");this.label=q}};e.$vL=et,e.$vL=et=Ge([E],et);var Gt;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(Gt||(e.ColorFormat=Gt={}));var Jt;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(Jt||(e.SourceControlInputBoxValidationType=Jt={}));var ht;(function(H){H[H.Unknown=0]="Unknown",H[H.Shutdown=1]="Shutdown",H[H.Process=2]="Process",H[H.User=3]="User",H[H.Extension=4]="Extension"})(ht||(e.TerminalExitReason=ht={}));class bt{constructor(q,pe,Me){if(this.startIndex=q,this.length=pe,this.tooltip=Me,typeof q!="number"||q<0)throw(0,N.$7)("startIndex");if(typeof pe!="number"||pe<1)throw(0,N.$7)("length");if(Me!==void 0&&typeof Me!="string")throw(0,N.$7)("tooltip")}}e.$wL=bt;class zt{constructor(q){this.uri=q}}e.$xL=zt;class qt{constructor(q){this.terminalCommand=q}}e.$yL=qt;var Dt;(function(H){H[H.Panel=1]="Panel",H[H.Editor=2]="Editor"})(Dt||(e.TerminalLocation=Dt={}));class ft{constructor(q){if(this.options=q,typeof q!="object")throw(0,N.$7)("options")}}e.$zL=ft;var At;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(At||(e.TaskRevealKind=At={}));var xt;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(xt||(e.TaskPanelKind=xt={}));let Ct=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(q){switch(q){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(q,pe){if(this.label=pe,typeof q!="string"||typeof pe!="string")throw(0,N.$7)("name");this.c=q}get id(){return this.c}};e.$AL=Ct,e.$AL=Ct=h=Ge([E],Ct);function Qe(H){let q="";for(let pe=0;pe<H.length;pe++)q+=H[pe].replace(/,/g,",,")+",";return q}let Mt=class{constructor(q,pe,Me){if(typeof q!="string")throw(0,N.$7)("process");this.e=[],this.c=q,pe!==void 0&&(Array.isArray(pe)?(this.e=pe,this.f=Me):this.f=pe)}get process(){return this.c}set process(q){if(typeof q!="string")throw(0,N.$7)("process");this.c=q}get args(){return this.e}set args(q){Array.isArray(q)||(q=[]),this.e=q}get options(){return this.f}set options(q){this.f=q}computeId(){const q=[];if(q.push("process"),this.c!==void 0&&q.push(this.c),this.e&&this.e.length>0)for(const pe of this.e)q.push(pe);return Qe(q)}};e.$BL=Mt,e.$BL=Mt=Ge([E],Mt);let Vt=class{constructor(q,pe,Me){if(this.f=[],Array.isArray(pe)){if(!q)throw(0,N.$7)("command can't be undefined or null");if(typeof q!="string"&&typeof q.value!="string")throw(0,N.$7)("command");this.e=q,this.f=pe,this.g=Me}else{if(typeof q!="string")throw(0,N.$7)("commandLine");this.c=q,this.g=pe}}get commandLine(){return this.c}set commandLine(q){if(typeof q!="string")throw(0,N.$7)("commandLine");this.c=q}get command(){return this.e?this.e:""}set command(q){if(typeof q!="string"&&typeof q.value!="string")throw(0,N.$7)("command");this.e=q}get args(){return this.f}set args(q){this.f=q||[]}get options(){return this.g}set options(q){this.g=q}computeId(){const q=[];if(q.push("shell"),this.c!==void 0&&q.push(this.c),this.e!==void 0&&q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const pe of this.f)q.push(typeof pe=="string"?pe:pe.value);return Qe(q)}};e.$CL=Vt,e.$CL=Vt=Ge([E],Vt);var Qt;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(Qt||(e.ShellQuoting=Qt={}));var gt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(gt||(e.TaskScope=gt={}));class Nt{constructor(q){this.c=q}computeId(){return"customExecution"+(0,A.$ng)()}set callback(q){this.c=q}get callback(){return this.c}}e.$DL=Nt;let Fe=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(q,pe,Me,Ye,tt,lt){this.k=!1,this.l=this.definition=q;let mt;typeof pe=="string"?(this.n=this.name=pe,this.u=this.source=Me,this.execution=Ye,mt=tt,this.k=!0):pe===gt.Global||pe===gt.Workspace?(this.target=pe,this.n=this.name=Me,this.u=this.source=Ye,this.execution=tt,mt=lt):(this.target=pe,this.n=this.name=Me,this.u=this.source=Ye,this.execution=tt,mt=lt),typeof mt=="string"?(this.q=[mt],this.r=!0):Array.isArray(mt)?(this.q=mt,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(q){this.j=q}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Mt?this.l={type:S.e,id:this.o.computeId()}:this.o instanceof Vt?this.l={type:S.f,id:this.o.computeId()}:this.o instanceof Nt?this.l={type:S.c,id:this.o.computeId()}:this.l={type:S.g,id:(0,A.$ng)()}}get definition(){return this.l}set definition(q){if(q==null)throw(0,N.$7)("Kind can't be undefined or null");this.A(),this.l=q}get scope(){return this.m}set target(q){this.A(),this.m=q}get name(){return this.n}set name(q){if(typeof q!="string")throw(0,N.$7)("name");this.A(),this.n=q}get execution(){return this.o}set execution(q){q===null&&(q=void 0),this.A(),this.o=q;const pe=this.l.type;(S.g===pe||S.e===pe||S.f===pe||S.c===pe)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(q){if(Array.isArray(q))this.A(),this.q=q,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(q){q!==!0&&q!==!1&&(q=!1),this.A(),this.t=q}get source(){return this.u}set source(q){if(typeof q!="string"||q.length===0)throw(0,N.$7)("source must be a string of length > 0");this.A(),this.u=q}get group(){return this.w}set group(q){q===null&&(q=void 0),this.A(),this.w=q}get detail(){return this.z}set detail(q){q===null&&(q=void 0),this.z=q}get presentationOptions(){return this.x}set presentationOptions(q){q==null&&(q=Object.create(null)),this.A(),this.x=q}get runOptions(){return this.y}set runOptions(q){q==null&&(q=Object.create(null)),this.A(),this.y=q}};e.$EL=Fe,e.$EL=Fe=S=Ge([E],Fe);var Te;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(Te||(e.ProgressLocation=Te={}));var Ce;(function(H){function q(pe){const Me=pe;return(0,$.$Jf)(Me.value)?Me.tooltip&&!(0,$.$Ff)(Me.tooltip)?(console.log("INVALID view badge, invalid tooltip",Me.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Me.value),!1)}H.isViewBadge=q})(Ce||(e.ViewBadge=Ce={}));let se=P=class{static isTreeItem(q,pe){const Me=q;if(Me.checkboxState!==void 0){const Ye=(0,$.$Jf)(Me.checkboxState)?Me.checkboxState:(0,$.$Hf)(Me.checkboxState)&&(0,$.$Jf)(Me.checkboxState.state)?Me.checkboxState.state:void 0,tt=!(0,$.$Jf)(Me.checkboxState)&&(0,$.$Hf)(Me.checkboxState)?Me.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==qe.Checked&&Ye!==qe.Unchecked||tt!==void 0&&!(0,$.$Ff)(tt))return console.log("INVALID tree item, invalid checkboxState",Me.checkboxState),!1}if(q instanceof P)return!0;if(Me.label!==void 0&&!(0,$.$Ff)(Me.label)&&!Me.label?.label)return console.log("INVALID tree item, invalid label",Me.label),!1;if(Me.id!==void 0&&!(0,$.$Ff)(Me.id))return console.log("INVALID tree item, invalid id",Me.id),!1;if(Me.iconPath!==void 0&&!(0,$.$Ff)(Me.iconPath)&&!y.URI.isUri(Me.iconPath)&&(!Me.iconPath||!(0,$.$Ff)(Me.iconPath.id))){const Ye=Me.iconPath;if(!Ye||!(0,$.$Ff)(Ye.light)&&!y.URI.isUri(Ye.light)&&!(0,$.$Ff)(Ye.dark)&&!y.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",Me.iconPath),!1}return Me.description!==void 0&&!(0,$.$Ff)(Me.description)&&typeof Me.description!="boolean"?(console.log("INVALID tree item, invalid description",Me.description),!1):Me.resourceUri!==void 0&&!y.URI.isUri(Me.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Me.resourceUri),!1):Me.tooltip!==void 0&&!(0,$.$Ff)(Me.tooltip)&&!(Me.tooltip instanceof He)?(console.log("INVALID tree item, invalid tooltip",Me.tooltip),!1):Me.command!==void 0&&!Me.command.command?(console.log("INVALID tree item, invalid command",Me.command),!1):Me.collapsibleState!==void 0&&Me.collapsibleState<Ne.None&&Me.collapsibleState>Ne.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Me.collapsibleState),!1):Me.contextValue!==void 0&&!(0,$.$Ff)(Me.contextValue)?(console.log("INVALID tree item, invalid contextValue",Me.contextValue),!1):Me.accessibilityInformation!==void 0&&!Me.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Me.accessibilityInformation),!1):!0}constructor(q,pe=Ne.None){this.collapsibleState=pe,y.URI.isUri(q)?this.resourceUri=q:this.label=q}};e.$FL=se,e.$FL=se=P=Ge([E],se);var Ne;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(Ne||(e.TreeItemCollapsibleState=Ne={}));var qe;(function(H){H[H.Unchecked=0]="Unchecked",H[H.Checked=1]="Checked"})(qe||(e.TreeItemCheckboxState=qe={}));let xe=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(q){this.value=q}};e.$GL=xe,e.$GL=xe=Ge([E],xe);class Ke extends xe{}e.$HL=Ke;class st extends Ke{#e;constructor(q){super(""),this.#e=q}asFile(){return this.#e}}e.$IL=st;class $t{constructor(q,pe,Me,Ye){this.name=q,this.uri=pe,this._itemId=Me,this.c=Ye}data(){return this.c()}}e.$JL=$t;let Bt=class{#e=new Map;constructor(q){for(const[pe,Me]of q??[]){const Ye=this.#e.get(this.#t(pe));Ye?Ye.push(Me):this.#e.set(this.#t(pe),[Me])}}get(q){return this.#e.get(this.#t(q))?.[0]}set(q,pe){this.#e.set(this.#t(q),[pe])}forEach(q,pe){for(const[Me,Ye]of this.#e)for(const tt of Ye)q.call(pe,tt,Me,this)}*[Symbol.iterator](){for(const[q,pe]of this.#e)for(const Me of pe)yield[q,Me]}#t(q){return q.toLowerCase()}};e.$KL=Bt,e.$KL=Bt=Ge([E],Bt);let St=class{constructor(q){this.insertText=q}};e.$LL=St,e.$LL=St=Ge([E],St);let It=class{constructor(q,pe){this.label=pe,this.insertText=q}};e.$ML=It,e.$ML=It=Ge([E],It);let yt=class{constructor(q,pe){this.id=q,this.color=pe}static isThemeIcon(q){return typeof q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",q.id),!1):!0}};e.$NL=yt,e.$NL=yt=Ge([E],yt),yt.File=new yt("file"),yt.Folder=new yt("folder");let gi=class{constructor(q){this.id=q}};e.$OL=gi,e.$OL=gi=Ge([E],gi);var Rt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(Rt||(e.ConfigurationTarget=Rt={}));let Di=class{get base(){return this.c}set base(q){this.c=q,this.e=y.URI.file(q)}get baseUri(){return this.e}set baseUri(q){this.e=q,this.c=q.fsPath}constructor(q,pe){if(typeof q!="string"&&(!q||!y.URI.isUri(q)&&!y.URI.isUri(q.uri)))throw(0,N.$7)("base");if(typeof pe!="string")throw(0,N.$7)("pattern");typeof q=="string"?this.baseUri=y.URI.file(q):y.URI.isUri(q)?this.baseUri=q:this.baseUri=q.uri,this.pattern=pe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$PL=Di,e.$PL=Di=Ge([E],Di);const Ki=new WeakMap;function Pt(H,q){Ki.set(H,q)}e.$QL=Pt;let ri=class{constructor(q,pe,Me,Ye){this.enabled=typeof q=="boolean"?q:!0,typeof pe=="string"&&(this.condition=pe),typeof Me=="string"&&(this.hitCondition=Me),typeof Ye=="string"&&(this.logMessage=Ye)}get id(){return this.c||(this.c=Ki.get(this)??(0,A.$ng)()),this.c}};e.$RL=ri,e.$RL=ri=Ge([E],ri);let mi=class extends ri{constructor(q,pe,Me,Ye,tt){if(super(pe,Me,Ye,tt),q===null)throw(0,N.$7)("location");this.location=q}};e.$SL=mi,e.$SL=mi=Ge([E],mi);let ci=class extends ri{constructor(q,pe,Me,Ye,tt){super(pe,Me,Ye,tt),this.functionName=q}};e.$TL=ci,e.$TL=ci=Ge([E],ci);let Ci=class extends ri{constructor(q,pe,Me,Ye,tt,lt,mt){if(super(Ye,tt,lt,mt),!pe)throw(0,N.$7)("dataId");this.label=q,this.dataId=pe,this.canPersist=Me}};e.$UL=Ci,e.$UL=Ci=Ge([E],Ci);let Ii=class{constructor(q,pe,Me){this.command=q,this.args=pe||[],this.options=Me}};e.$VL=Ii,e.$VL=Ii=Ge([E],Ii);let jt=class{constructor(q,pe){this.port=q,this.host=pe}};e.$WL=jt,e.$WL=jt=Ge([E],jt);let $i=class{constructor(q){this.path=q}};e.$XL=$i,e.$XL=$i=Ge([E],$i);let Pi=class{constructor(q){this.implementation=q}};e.$YL=Pi,e.$YL=Pi=Ge([E],Pi);let ui=class{constructor(q,pe,Me){this.session=q,this.threadId=pe,this.frameId=Me}};e.$ZL=ui,e.$ZL=ui=Ge([E],ui);let li=class{constructor(q,pe){this.session=q,this.threadId=pe}};e.$1L=li,e.$1L=li=Ge([E],li);let dt=class{constructor(q,pe){this.range=q,this.expression=pe}};e.$2L=dt,e.$2L=dt=Ge([E],dt);var Gi;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Gi||(e.InlineCompletionTriggerKind=Gi={}));let _t=class{constructor(q,pe){this.range=q,this.text=pe}};e.$3L=_t,e.$3L=_t=Ge([E],_t);let si=class{constructor(q,pe,Me=!0){this.range=q,this.variableName=pe,this.caseSensitiveLookup=Me}};e.$4L=si,e.$4L=si=Ge([E],si);let bi=class{constructor(q,pe){this.range=q,this.expression=pe}};e.$5L=bi,e.$5L=bi=Ge([E],bi);let Ai=class{constructor(q,pe){this.frameId=q,this.stoppedLocation=pe}};e.$6L=Ai,e.$6L=Ai=Ge([E],Ai);var Ji;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Ji||(e.FileChangeType=Ji={}));let Li=w=class extends Error{static FileExists(q){return new w(q,m.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound(q){return new w(q,m.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory(q){return new w(q,m.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory(q){return new w(q,m.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions(q){return new w(q,m.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable(q){return new w(q,m.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}constructor(q,pe=m.FileSystemProviderErrorCode.Unknown,Me){super(y.URI.isUri(q)?q.toString(!0):q),this.code=Me?.name??"Unknown",(0,m.$Ck)(this,pe),Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof Me=="function"&&Error.captureStackTrace(this,Me)}};e.$7L=Li,e.$7L=Li=w=Ge([E],Li);let pi=class{constructor(q,pe,Me){this.start=q,this.end=pe,this.kind=Me}};e.$8L=pi,e.$8L=pi=Ge([E],pi);var Qi;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(Qi||(e.FoldingRangeKind=Qi={}));var Ri;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(Ri||(e.CommentThreadCollapsibleState=Ri={}));var hi;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(hi||(e.CommentMode=hi={}));var Zi;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(Zi||(e.CommentState=Zi={}));var wi;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class Fi{constructor(q,pe=[]){this.tokenTypes=q,this.tokenModifiers=pe}}e.$9L=Fi;function cn(H){return typeof H>"u"||(0,$.$Gf)(H)}class Mi{constructor(q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,q){this.m=!0;for(let pe=0,Me=q.tokenTypes.length;pe<Me;pe++)this.k.set(q.tokenTypes[pe],pe);for(let pe=0,Me=q.tokenModifiers.length;pe<Me;pe++)this.l.set(q.tokenModifiers[pe],pe)}}push(q,pe,Me,Ye,tt){if(typeof q=="number"&&typeof pe=="number"&&typeof Me=="number"&&typeof Ye=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.o(q,pe,Me,Ye,tt);if(j.isRange(q)&&typeof pe=="string"&&cn(Me))return this.n(q,pe,Me);throw(0,N.$7)()}n(q,pe,Me){if(!this.m)throw new Error("Legend must be provided in constructor");if(q.start.line!==q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(pe))throw new Error("`tokenType` is not in the provided legend");const Ye=q.start.line,tt=q.start.character,lt=q.end.character-q.start.character,mt=this.k.get(pe);let Ht=0;if(Me)for(const Yt of Me){if(!this.l.has(Yt))throw new Error("`tokenModifier` is not in the provided legend");const ii=this.l.get(Yt);Ht|=1<<ii>>>0}this.o(Ye,tt,lt,mt,Ht)}o(q,pe,Me,Ye,tt){if(this.f&&(q<this.c||q===this.c&&pe<this.e)){this.f=!1;const Ht=this.g.length/5|0;let Yt=0,ii=0;for(let ni=0;ni<Ht;ni++){let ai=this.g[5*ni],Vi=this.g[5*ni+1];ai===0?(ai=Yt,Vi+=ii):ai+=Yt,this.g[5*ni]=ai,this.g[5*ni+1]=Vi,Yt=ai,ii=Vi}}let lt=q,mt=pe;this.f&&this.j>0&&(lt-=this.c,lt===0&&(mt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=mt,this.g[this.j++]=Me,this.g[this.j++]=Ye,this.g[this.j++]=tt,this.c=q,this.e=pe}static q(q){const pe=[],Me=q.length/5|0;for(let mt=0;mt<Me;mt++)pe[mt]=mt;pe.sort((mt,Ht)=>{const Yt=q[5*mt],ii=q[5*Ht];if(Yt===ii){const ni=q[5*mt+1],ai=q[5*Ht+1];return ni-ai}return Yt-ii});const Ye=new Uint32Array(q.length);let tt=0,lt=0;for(let mt=0;mt<Me;mt++){const Ht=5*pe[mt],Yt=q[Ht+0],ii=q[Ht+1],ni=q[Ht+2],ai=q[Ht+3],Vi=q[Ht+4],Cn=Yt-tt,On=Cn===0?ii-lt:ii,Hi=5*mt;Ye[Hi+0]=Cn,Ye[Hi+1]=On,Ye[Hi+2]=ni,Ye[Hi+3]=ai,Ye[Hi+4]=Vi,tt=Yt,lt=ii}return Ye}build(q){return this.f?new oi(new Uint32Array(this.g),q):new oi(Mi.q(this.g),q)}}e.$0L=Mi;class oi{constructor(q,pe){this.resultId=pe,this.data=q}}e.$$L=oi;class un{constructor(q,pe,Me){this.start=q,this.deleteCount=pe,this.data=Me}}e.$_L=un;class ln{constructor(q,pe){this.resultId=pe,this.edits=q}}e.$aM=ln;var Xi;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(Xi||(e.DebugConsoleMode=Xi={}));let di=class{static{this.Back={iconPath:new yt("arrow-left")}}constructor(){}};e.$bM=di,e.$bM=di=Ge([E],di);var Yi;(function(H){H[H.Separator=-1]="Separator",H[H.Default=0]="Default"})(Yi||(e.QuickPickItemKind=Yi={}));var xi;(function(H){H[H.Info=1]="Info",H[H.Warning=2]="Warning",H[H.Error=3]="Error"})(xi||(e.InputBoxValidationSeverity=xi={}));var vi;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(vi||(e.ExtensionKind=vi={}));class _i{static validate(q){if(typeof q.badge=="string"){let pe=(0,b.$gf)(q.badge,0);if(pe<q.badge.length&&(pe+=(0,b.$gf)(q.badge,pe)),q.badge.length>pe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(q.badge&&!yt.isThemeIcon(q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!q.color&&!q.badge&&!q.tooltip)throw new Error("The decoration is empty");return!0}constructor(q,pe,Me){this.badge=q,this.tooltip=pe,this.color=Me}}e.$cM=_i;let Ni=class{constructor(q){this.kind=q}};e.$dM=Ni,e.$dM=Ni=Ge([E],Ni);var Ti;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast",H[H.HighContrastLight=4]="HighContrastLight"})(Ti||(e.ColorThemeKind=Ti={}));class ei{static isNotebookRange(q){return q instanceof ei?!0:q?typeof q.start=="number"&&typeof q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(q,pe){if(q<0)throw(0,N.$7)("start must be positive");if(pe<0)throw(0,N.$7)("end must be positive");q<=pe?(this.c=q,this.e=pe):(this.c=pe,this.e=q)}with(q){let pe=this.c,Me=this.e;return q.start!==void 0&&(pe=q.start),q.end!==void 0&&(Me=q.end),pe===this.c&&Me===this.e?this:new ei(pe,Me)}}e.$eM=ei;class yi{static validate(q){if(typeof q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(q){return Array.isArray(q)&&q.every(pe=>yi.isNotebookCellData(pe))}static isNotebookCellData(q){return!0}constructor(q,pe,Me,Ye,tt,lt,mt){this.kind=q,this.value=pe,this.languageId=Me,this.mime=Ye,this.outputs=tt??[],this.metadata=lt,this.executionSummary=mt,yi.validate(this)}}e.$fM=yi;class hn{constructor(q){this.cells=q}}e.$gM=hn;class Xt{static isNotebookCellOutputItem(q){return q instanceof Xt?!0:q?typeof q.mime=="string"&&q.data instanceof Uint8Array:!1}static error(q){const pe={name:q.name,message:q.message,stack:q.stack};return Xt.json(pe,"application/vnd.code.notebook.error")}static stdout(q){return Xt.text(q,"application/vnd.code.notebook.stdout")}static stderr(q){return Xt.text(q,"application/vnd.code.notebook.stderr")}static bytes(q,pe="application/octet-stream"){return new Xt(q,pe)}static#e=new TextEncoder;static text(q,pe=R.$5r.text){const Me=Xt.#e.encode(String(q));return new Xt(Me,pe)}static json(q,pe="text/x-json"){const Me=JSON.stringify(q,void 0,"	");return Xt.text(Me,pe)}constructor(q,pe){this.data=q,this.mime=pe;const Me=(0,R.$9r)(pe,!0);if(!Me)throw new Error(`INVALID mime type: ${pe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Me}}e.$hM=Xt;class Ei{static isNotebookCellOutput(q){return q instanceof Ei?!0:!q||typeof q!="object"?!1:typeof q.id=="string"&&Array.isArray(q.items)}static ensureUniqueMimeTypes(q,pe=!1){const Me=new Set,Ye=new Set;for(let tt=0;tt<q.length;tt++){const lt=q[tt],mt=(0,R.$9r)(lt.mime);if(!Me.has(mt)||(0,k.$UI)(mt)){Me.add(mt);continue}Ye.add(tt),pe&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ye.size===0?q:q.filter((tt,lt)=>!Ye.has(lt))}constructor(q,pe,Me){this.items=Ei.ensureUniqueMimeTypes(q,!0),typeof pe=="string"?(this.id=pe,this.metadata=Me):(this.id=(0,A.$ng)(),this.metadata=pe??Me)}}e.$iM=Ei;var Si;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(Si||(e.NotebookCellKind=Si={}));var Oi;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(Oi||(e.NotebookCellExecutionState=Oi={}));var Be;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(Be||(e.NotebookCellStatusBarAlignment=Be={}));var ti;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(ti||(e.NotebookEditorRevealType=ti={}));class en{constructor(q,pe){this.text=q,this.alignment=pe}}e.$jM=en;var at;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(at||(e.NotebookControllerAffinity=at={}));var pt;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred",H[H.Hidden=-1]="Hidden"})(pt||(e.NotebookControllerAffinity2=pt={}));class dn{constructor(q,pe=[]){this.uri=q,this.provides=(0,D.$3b)(pe)}}e.$kM=dn;class fn{constructor(q){this.label=q}}e.$lM=fn;var ji;(function(H){H[H.Named=1]="Named",H[H.Indexed=2]="Indexed"})(ji||(e.NotebookVariablesRequestKind=ji={}));let Ui=class{constructor(q,pe){this.label=q,this.timestamp=pe}};e.$mM=Ui,e.$mM=Ui=Ge([E],Ui);var fi;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(fi||(e.ExtensionMode=fi={}));var tn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(tn||(e.ExtensionRuntime=tn={}));var nn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(nn||(e.StandardTokenType=nn={}));class gn{constructor(q,pe){this.ranges=q,this.wordPattern=pe}}e.$nM=gn;class rn{constructor(q){this.c=q}get autoForwardAction(){return this.c}}e.$oM=rn;var sn;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(sn||(e.TestResultState=sn={}));var on;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(on||(e.TestRunProfileKind=on={}));let zi=class{constructor(q=void 0,pe=void 0,Me=void 0,Ye=!1){this.include=q,this.exclude=pe,this.profile=Me,this.continuous=Ye}};e.$pM=zi,e.$pM=zi=Ge([E],zi);let Bi=p=class{static diff(q,pe,Me){const Ye=new p(q);return Ye.expectedOutput=pe,Ye.actualOutput=Me,Ye}constructor(q){this.message=q}};e.$qM=Bi,e.$qM=Bi=p=Ge([E],Bi);let Wi=class{constructor(q){this.id=q}};e.$rM=Wi,e.$rM=Wi=Ge([E],Wi);class ki{constructor(q,pe){this.covered=q,this.total=pe}}e.$sM=ki;class qi{static fromDetails(q,pe){const Me=new ki(0,0),Ye=new ki(0,0),tt=new ki(0,0);for(const mt of pe)if("branches"in mt){Me.total+=1,Me.covered+=mt.executionCount>0?1:0;for(const Ht of mt.branches)Ye.total+=1,Ye.covered+=Ht.executionCount>0?1:0}else tt.total+=1,tt.covered+=mt.executionCount>0?1:0;const lt=new qi(q,Me,Ye.total>0?Ye:void 0,tt.total>0?tt:void 0);return lt.detailedCoverage=pe,lt}constructor(q,pe,Me,Ye){this.uri=q,this.statementCoverage=pe,this.branchCoverage=Me,this.functionCoverage=Ye}}e.$tM=qi;class mn{constructor(q,pe,Me=[]){this.executionCount=q,this.location=pe,this.branches=Me}}e.$uM=mn;class $n{constructor(q,pe){this.executionCount=q,this.location=pe}}e.$vM=$n;class bn{constructor(q,pe,Me){this.name=q,this.executionCount=pe,this.location=Me}}e.$wM=bn;var $e;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})($e||(e.ExternalUriOpenerPriority=$e={}));var Ee;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(Ee||(e.WorkspaceTrustState=Ee={}));var ze;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(ze||(e.PortAutoForwardAction=ze={}));class ut{constructor(q,pe,Me,Ye,tt,lt){this.kind=q,this.name=pe,this.detail=Me,this.uri=Ye,this.range=tt,this.selectionRange=lt}}e.$xM=ut;class vt{constructor(q){this.uri=q}}e.$yM=vt;class Ft{constructor(q,pe){this.original=q,this.modified=pe}}e.$zM=Ft;class an{constructor(q,pe,Me,Ye){this.base=q,this.input1=pe,this.input2=Me,this.result=Ye}}e.$AM=an;class In{constructor(q,pe){this.uri=q,this.viewType=pe}}e.$BM=In;class Pn{constructor(q){this.viewType=q}}e.$CM=Pn;class An{constructor(q,pe){this.uri=q,this.notebookType=pe}}e.$DM=An;class Ln{constructor(q,pe,Me){this.original=q,this.modified=pe,this.notebookType=Me}}e.$EM=Ln;class Rn{constructor(){}}e.$FM=Rn;class Fn{constructor(q,pe){this.uri=q,this.inputBoxUri=pe}}e.$GM=Fn;class Mn{constructor(q){this.providerId=q}}e.$HM=Mn;var pn;(function(H){H[H.Down=0]="Down",H[H.Up=1]="Up"})(pn||(e.InteractiveSessionVoteDirection=pn={}));var wn;(function(H){H[H.Action=1]="Action",H[H.Toolbar=2]="Toolbar"})(wn||(e.ChatAgentCopyKind=wn={}));var vn;(function(H){H[H.Short=1]="Short",H[H.Medium=2]="Medium",H[H.Full=3]="Full"})(vn||(e.ChatVariableLevel=vn={}));class Nn{constructor(q,pe){this.label=q,this.values=pe}}e.$IM=Nn;var yn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful",H[H.Undone=2]="Undone",H[H.Accepted=3]="Accepted",H[H.Bug=4]="Bug"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(H){H[H.System=0]="System",H[H.User=1]="User",H[H.Assistant=2]="Assistant",H[H.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));class Tn{constructor(q,pe){this.role=q,this.content=pe}}e.$JM=Tn;var Sn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful"})(Sn||(e.ChatAgentResultFeedbackKind=Sn={}));var kn;(function(H){H[H.SymbolInformation=1]="SymbolInformation",H[H.CommandInformation=2]="CommandInformation",H[H.SearchInformation=3]="SearchInformation",H[H.SettingInformation=4]="SettingInformation"})(kn||(e.RelatedInformationType=kn={}));var Dn;(function(H){H[H.Started=1]="Started",H[H.Recognizing=2]="Recognizing",H[H.Recognized=3]="Recognized",H[H.Stopped=4]="Stopped"})(Dn||(e.SpeechToTextStatus=Dn={}))}),define(Se[141],ke([1,0,60,17,12,176,126,7,19]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YM=e.$XM=e.$WM=void 0;const y=new Map;function A(k,l){l?y.set(k,l):y.delete(k)}e.$WM=A;function C(k){return y.get(k)}class m extends I.$_u{constructor(l,f,s,i,n,o,c,t){super(f,s,i,n),this.c=l,this.m=o,this.q=c,this.notebook=t,this.b=!1}dispose(){(0,D.ok)(!this.b),this.b=!0,this.q=!1}equalLines(l){return(0,$.$ub)(this.f,l)}get document(){if(!this.a){const l=this;this.a={get uri(){return l.d},get fileName(){return l.d.fsPath},get isUntitled(){return l.d.scheme===N.Schemas.untitled},get languageId(){return l.m},get version(){return l.h},get isClosed(){return l.b},get isDirty(){return l.q},save(){return l.r()},getText(f){return f?l.s(f):l.getText()},get eol(){return l.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return l.f.length},lineAt(f){return l.t(f)},offsetAt(f){return l.u(f)},positionAt(f){return l.v(f)},validateRange(f){return l.w(f)},validatePosition(f){return l.x(f)},getWordRangeAtPosition(f,s){return l.y(f,s)}}}return Object.freeze(this.a)}_acceptLanguageId(l){(0,D.ok)(!this.b),this.m=l}_acceptIsDirty(l){(0,D.ok)(!this.b),this.q=l}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(l){const f=this.w(l);if(f.isEmpty)return"";if(f.isSingleLine)return this.f[f.start.line].substring(f.start.character,f.end.character);const s=this.g,i=f.start.line,n=f.end.line,o=[];o.push(this.f[i].substring(f.start.character));for(let c=i+1;c<n;c++)o.push(this.f[c]);return o.push(this.f[n].substring(0,f.end.character)),o.join(s)}t(l){let f;if(l instanceof b.$TK?f=l.line:typeof l=="number"&&(f=l),typeof f!="number"||f<0||f>=this.f.length||Math.floor(f)!==f)throw new Error("Illegal value for `line`");return new v(f,this.f[f],f===this.f.length-1)}u(l){return l=this.x(l),this.l(),this.j.getPrefixSum(l.line-1)+l.character}v(l){l=Math.floor(l),l=Math.max(0,l),this.l();const f=this.j.getIndexOf(l),s=this.f[f.index].length;return new b.$TK(f.index,Math.min(f.remainder,s))}w(l){if(!(l instanceof b.$UK))throw new Error("Invalid argument");const f=this.x(l.start),s=this.x(l.end);return f===l.start&&s===l.end?l:new b.$UK(f.line,f.character,s.line,s.character)}x(l){if(!(l instanceof b.$TK))throw new Error("Invalid argument");if(this.f.length===0)return l.with(0,0);let{line:f,character:s}=l,i=!1;if(f<0)f=0,s=0,i=!0;else if(f>=this.f.length)f=this.f.length-1,s=this.f[f].length,i=!0;else{const n=this.f[f].length;s<0?(s=0,i=!0):s>n&&(s=n,i=!0)}return i?new b.$TK(f,s):l}y(l,f){const s=this.x(l);if(!f)f=C(this.m);else if((0,g.$Ve)(f))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${f.source}' because it matches the empty string.`);const i=(0,R.$ks)(s.character+1,(0,R.$is)(f),this.f[s.line],0);if(i)return new b.$UK(s.line,i.startColumn-1,s.line,i.endColumn-1)}}e.$XM=m;class v{constructor(l,f,s){this.a=l,this.b=f,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$UK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$UK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$YM=v}),define(Se[285],ke([1,0,7,20,4]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=void 0;let I=class{constructor(b){this.a=new D.$dM(D.ColorThemeKind.Dark),this.b=new g.$Sd}get activeColorTheme(){return this.a}$onColorThemeChange(b){let $;switch(b){case"light":$=D.ColorThemeKind.Light;break;case"hcDark":$=D.ColorThemeKind.HighContrast;break;case"hcLight":$=D.ColorThemeKind.HighContrastLight;break;default:$=D.ColorThemeKind.Dark}this.a=new D.$dM($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$bhc=I,e.$bhc=I=Ge([We(0,N.$UM)],I)}),define(Se[286],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YI=e.CellExecutionUpdateType=void 0;var N;(function(g){g[g.Output=1]="Output",g[g.OutputItems=2]="OutputItems",g[g.ExecutionState=3]="ExecutionState"})(N||(e.CellExecutionUpdateType=N={})),e.$YI=(0,D.$3h)("INotebookExecutionService")}),define(Se[287],ke([1,0,3,29,193,99]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Pb=void 0;class R extends D.$Sc{constructor($,y,A){super(),this._source=$,this.b=y,this.c=A,this.a=void 0}f($){const y=$.getLineCount();return new N.$Is(1,1,y,this.g($,y))}g($,y){if(y<1||y>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(y)+1}get inputTextBuffer(){if(!this.b){const $=new g.$1B;$.acceptChunk(this._source);const y=$.finish(!0),{textBuffer:A,disposable:C}=y.create(1);this.b=A,this.B(C)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const y=new g.$1B;y.acceptChunk($);const A=y.finish(!0),{textBuffer:C,disposable:m}=A.create(1);return this.B(m),C})),this.a}findInInputs($){const A=new I.$OB($,!1,!1,null).parseSearchRequest();if(!A)return[];const C=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(C,A,!0,5e3)}findInOutputs($){const A=new I.$OB($,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(C=>{const m=C.findMatchesLineByLine(this.f(C),A,!0,5e3);if(m.length!==0)return{textBuffer:C,matches:m}}).filter(C=>!!C):[]}}e.$$Pb=R}),define(Se[67],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IJ=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(I){I.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var N;(function(I){I[I.IsSame=0]="IsSame",I[I.Disconnected=1]="Disconnected",I[I.IsChild=2]="IsChild",I[I.IsParent=3]="IsParent"})(N||(e.TestPosition=N={}));class g{static fromExtHostTestItem(R,b,$=R.parent){if(R._isRoot)return new g([b]);const y=[R.id];for(let A=$;A&&A.id!==b;A=A.parent)y.push(A.id);return y.push(b),new g(y.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const b=R.indexOf("\0");return b===-1?R:R.slice(0,b)}static fromString(R){return new g(R.split("\0"))}static join(R,b){return new g([...R.path,b])}static joinToString(R,b){return R.toString()+"\0"+b}static parentId(R){const b=R.lastIndexOf("\0");return b===-1?void 0:R.slice(0,b)}static localId(R){const b=R.lastIndexOf("\0");return b===-1?R:R.slice(b+1)}static isChild(R,b){return b.startsWith(R)&&b[R.length]==="\0"}static compare(R,b){return R===b?0:g.isChild(R,b)?2:g.isChild(b,R)?3:1}constructor(R,b=R.length){if(this.path=R,this.d=b,R.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new g(this.path,1)}get parentId(){return this.d>1?new g(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new g(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new g(this.path,R)}compare(R){if(typeof R=="string")return g.compare(this.toString(),R);for(let b=0;b<R.d&&b<this.d;b++)if(R.path[b]!==this.path[b])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$IJ=g}),define(Se[89],ke([1,0,2,49,29,67]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$PJ=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$OJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$NJ=e.$MJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$LJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$KJ=e.$JJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(O){O[O.Unset=0]="Unset",O[O.Queued=1]="Queued",O[O.Running=2]="Running",O[O.Passed=3]="Passed",O[O.Failed=4]="Failed",O[O.Skipped=5]="Skipped",O[O.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var b;(function(O){O[O.Run=1]="Run",O[O.Debug=2]="Debug",O[O.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var $;(function(O){O[O.Run=2]="Run",O[O.Debug=4]="Debug",O[O.Coverage=8]="Coverage",O[O.HasNonDefaultProfile=16]="HasNonDefaultProfile",O[O.HasConfigurable=32]="HasConfigurable",O[O.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$JJ=[2,4,8,16,32,64];const y=O=>"runId"in O;e.$KJ=y;var A;(function(O){O.serialize=M=>({range:M.range.toJSON(),uri:M.uri.toJSON()}),O.deserialize=(M,W)=>({range:g.$Is.lift(W.range),uri:M.asCanonicalUri(D.URI.revive(W.uri))})})(A||(e.IRichLocation=A={}));var C;(function(O){O[O.Error=0]="Error",O[O.Output=1]="Output"})(C||(e.TestMessageType=C={}));var m;(function(O){O.serialize=M=>({message:M.message,type:0,expected:M.expected,actual:M.actual,contextValue:M.contextValue,location:M.location&&A.serialize(M.location)}),O.deserialize=(M,W)=>({message:W.message,type:0,expected:W.expected,actual:W.actual,contextValue:W.contextValue,location:W.location&&A.deserialize(M,W.location)})})(m||(e.ITestErrorMessage=m={}));const v=(O,M)=>`${M?"s":"e"}${O}`;e.$LJ=v;var k;(function(O){O.serialize=M=>({message:M.message,type:1,offset:M.offset,length:M.length,location:M.location&&A.serialize(M.location)}),O.deserialize=(M,W)=>({message:W.message,type:1,offset:W.offset,length:W.length,location:W.location&&A.deserialize(M,W.location)})})(k||(e.ITestOutputMessage=k={}));var l;(function(O){O.serialize=M=>M.type===0?m.serialize(M):k.serialize(M),O.deserialize=(M,W)=>W.type===0?m.deserialize(M,W):k.deserialize(M,W)})(l||(e.ITestMessage=l={}));var f;(function(O){O.serializeWithoutMessages=M=>({state:M.state,duration:M.duration,messages:[]}),O.serialize=M=>({state:M.state,duration:M.duration,messages:M.messages.map(l.serialize)}),O.deserialize=(M,W)=>({state:W.state,duration:W.duration,messages:W.messages.map(Y=>l.deserialize(M,Y))})})(f||(e.ITestTaskState=f={}));const s="\0",i=(O,M)=>O+s+M;e.$MJ=i;const n=O=>{const M=O.indexOf(s);return{ctrlId:O.slice(0,M),tagId:O.slice(M+1)}};e.$NJ=n;var o;(function(O){O.serialize=M=>({extId:M.extId,label:M.label,tags:M.tags,busy:M.busy,children:void 0,uri:M.uri?.toJSON(),range:M.range?.toJSON()||null,description:M.description,error:M.error,sortText:M.sortText}),O.deserialize=(M,W)=>({extId:W.extId,label:W.label,tags:W.tags,busy:W.busy,children:void 0,uri:W.uri?M.asCanonicalUri(D.URI.revive(W.uri)):void 0,range:W.range?g.$Is.lift(W.range):null,description:W.description,error:W.error,sortText:W.sortText})})(o||(e.ITestItem=o={}));var c;(function(O){O[O.NotExpandable=0]="NotExpandable",O[O.Expandable=1]="Expandable",O[O.BusyExpanding=2]="BusyExpanding",O[O.Expanded=3]="Expanded"})(c||(e.TestItemExpandState=c={}));var t;(function(O){O.serialize=M=>({expand:M.expand,item:o.serialize(M.item)}),O.deserialize=(M,W)=>({controllerId:I.$IJ.root(W.item.extId),expand:W.expand,item:o.deserialize(M,W.item)})})(t||(e.InternalTestItem=t={}));var r;(function(O){O.serialize=M=>{let W;return M.item&&(W={},M.item.label!==void 0&&(W.label=M.item.label),M.item.tags!==void 0&&(W.tags=M.item.tags),M.item.busy!==void 0&&(W.busy=M.item.busy),M.item.uri!==void 0&&(W.uri=M.item.uri?.toJSON()),M.item.range!==void 0&&(W.range=M.item.range?.toJSON()),M.item.description!==void 0&&(W.description=M.item.description),M.item.error!==void 0&&(W.error=M.item.error),M.item.sortText!==void 0&&(W.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:W}},O.deserialize=M=>{let W;return M.item&&(W={},M.item.label!==void 0&&(W.label=M.item.label),M.item.tags!==void 0&&(W.tags=M.item.tags),M.item.busy!==void 0&&(W.busy=M.item.busy),M.item.range!==void 0&&(W.range=M.item.range?g.$Is.lift(M.item.range):null),M.item.description!==void 0&&(W.description=M.item.description),M.item.error!==void 0&&(W.error=M.item.error),M.item.sortText!==void 0&&(W.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:W}}})(r||(e.ITestItemUpdate=r={}));const d=(O,M)=>{M.expand!==void 0&&(O.expand=M.expand),M.item!==void 0&&(O.item=O.item?Object.assign(O.item,M.item):M.item)};e.$OJ=d;var u;(function(O){O.serializeWithoutMessages=M=>({...t.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(f.serializeWithoutMessages)}),O.serialize=M=>({...t.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(f.serialize)}),O.deserialize=(M,W)=>({...t.deserialize(M,W),ownComputedState:W.ownComputedState,computedState:W.computedState,tasks:W.tasks.map(Y=>f.deserialize(M,Y)),retired:!0})})(u||(e.TestResultItem=u={}));var a;(function(O){O.empty=()=>({covered:0,total:0}),O.sum=(M,W)=>{M.covered+=W.covered,M.total+=W.total}})(a||(e.ICoveredCount=a={}));var h;(function(O){O.serialize=M=>({statement:M.statement,branch:M.branch,function:M.function,details:M.details?.map(p.serialize),uri:M.uri.toJSON()}),O.deserialize=(M,W)=>({statement:W.statement,branch:W.branch,function:W.function,details:W.details?.map(p.deserialize),uri:M.asCanonicalUri(D.URI.revive(W.uri))})})(h||(e.IFileCoverage=h={}));function S(O){return{...O,location:O.location?.toJSON()}}function P(O){return O.location=O.location?N.$Hs.isIPosition(O.location)?N.$Hs.lift(O.location):g.$Is.lift(O.location):void 0,O}e.$PJ=3;var w;(function(O){O[O.Function=0]="Function",O[O.Statement=1]="Statement"})(w||(e.DetailType=w={}));var p;(function(O){O.serialize=M=>M.type===0?L.serialize(M):T.serialize(M),O.deserialize=M=>M.type===0?L.deserialize(M):T.deserialize(M)})(p||(e.CoverageDetails=p={}));var E;(function(O){O.serialize=S,O.deserialize=P})(E||(e.IBranchCoverage=E={}));var L;(function(O){O.serialize=S,O.deserialize=P})(L||(e.IFunctionCoverage=L={}));var T;(function(O){O.serialize=M=>({...S(M),branches:M.branches?.map(E.serialize)}),O.deserialize=M=>({...P(M),branches:M.branches?.map(E.deserialize)})})(T||(e.IStatementCoverage=T={}));var U;(function(O){O[O.Add=0]="Add",O[O.Update=1]="Update",O[O.DocumentSynced=2]="DocumentSynced",O[O.Remove=3]="Remove",O[O.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",O[O.Retire=5]="Retire",O[O.AddTag=6]="AddTag",O[O.RemoveTag=7]="RemoveTag"})(U||(e.TestDiffOpType=U={}));var F;(function(O){O.deserialize=(M,W)=>W.op===0?{op:W.op,item:t.deserialize(M,W.item)}:W.op===1?{op:W.op,item:r.deserialize(W.item)}:W.op===2?{op:W.op,uri:M.asCanonicalUri(D.URI.revive(W.uri)),docv:W.docv}:W,O.serialize=M=>M.op===0?{op:M.op,item:t.serialize(M.item)}:M.op===1?{op:M.op,item:r.serialize(M.item)}:M})(F||(e.TestsDiffOp=F={}));class j{constructor(M){this.k=M,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(M){const W=this.v();for(const Y of M)switch(Y.op){case 0:this.l(t.deserialize(this.k,Y.item),W);break;case 1:this.o(r.deserialize(Y.item),W);break;case 3:this.p(Y.itemId,W);break;case 5:this.q(Y.itemId);break;case 4:this.updatePendingRoots(Y.amount);break;case 6:this.c.set(Y.tag.id,Y.tag);break;case 7:this.c.delete(Y.id);break}W.complete?.()}l(M,W){const Y=I.$IJ.parentId(M.item.extId)?.toString();let ue;if(!Y)ue=this.w(M),this.g.add(ue),this.f.set(M.item.extId,ue);else if(this.f.has(Y)){const X=this.f.get(Y);X.children.add(M.item.extId),ue=this.w(M,X),this.f.set(M.item.extId,ue)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(M)}`);return}return W.add?.(ue),M.expand===2&&this.h++,ue}o(M,W){const Y=this.f.get(M.extId);if(Y)return M.expand!==void 0&&(Y.expand===2&&this.h--,M.expand===2&&this.h++),(0,e.$OJ)(Y,M),W.update?.(Y),Y}p(M,W){const Y=this.f.get(M);if(!Y)return;const ue=I.$IJ.parentId(Y.item.extId)?.toString();ue?this.f.get(ue).children.delete(Y.item.extId):this.g.delete(Y);const X=[[M]];for(;X.length;)for(const J of X.pop()){const x=this.f.get(J);x&&(X.push(x.children),this.f.delete(J),W.remove?.(x,x!==Y),x.expand===2&&this.h--)}}q(M){}updatePendingRoots(M){this.j+=M}v(){return{}}}e.$QJ=j}),define(Se[112],ke([1,0,11,4,3,60,89,67]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=e.$NM=e.$MM=e.$LM=e.$KM=e.TestItemEventOp=void 0;var $;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const y=(i,n)=>i===n,C=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:y,label:y,description:y,error:y,sortText:y,tags:(i,n)=>!(i.length!==n.length||i.some(o=>!n.includes(o)))}),m=(i,n)=>{let o;for(const[c,t]of C)t(i[c],n[c])||(o?o[c]=n[c]:o={[c]:n[c]});return o};class v extends g.$Sc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new D.$ch(()=>this.flushDiff(),200)),this.g=this.B(new N.$Sd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const o of this.tree.values())this.J(o)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const o of this.m)if(o.op===2&&o.uri===n.uri){o.docv=n.docv;return}break}case 1:{const o=this.m[this.m.length-1];if(o){if(o.op===1&&o.item.extId===n.item.extId){(0,R.$OJ)(o.item,n.item);return}if(o.op===0&&o.item.item.extId===n.item.extId){(0,R.$OJ)(o.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,o){const c=this.tree.get(n);if(c){if((c.expandLevels===void 0||o>c.expandLevels)&&(c.expandLevels=o),c.expand===1){const t=this.M(c);return t.isOpen()?this.L(c,o-1):t.wait().then(()=>this.L(c,o-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.L(c,o-1)):this.L(c,o-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,o){switch(o.op){case 3:this.O(b.$IJ.joinToString(n.fullId,o.id));break;case 0:this.z(o.item,n);break;case 5:for(const c of o.ops)this.w(n,c);break;case 1:this.C(o.new,o.old,n.fullId.toString());break;case 2:this.J(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:o.update}});break;case 6:this.y(n.actual.uri);break;default:(0,I.$5c)(o)}}y(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,o){const c=b.$IJ.fromExtHostTestItem(n,this.root.id,o?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==o?.actual&&this.s.getChildren(t.parent).delete(n.id);let r=this.tree.get(c.toString());if(!r){r={fullId:c,actual:n,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:0},n.tags.forEach(this.D,this),this.tree.set(r.fullId.toString(),r),this.G(n,o),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem(n)}}),this.I(n,r,o);return}if(r.actual===n){this.H(n,r,o);return}if(r.actual.uri?.toString()!==n.uri?.toString())return this.O(c.toString()),this.z(n,o);const d=this.s.getChildren(r.actual),u=r.actual,a=m(this.s.toITestItem(u),this.s.toITestItem(n));this.s.getApiFor(u).listener=void 0,r.actual=n,r.expand=0,a&&(a.hasOwnProperty("tags")&&(this.C(n.tags,u.tags,c.toString()),delete a.tags),this.w(r,{op:4,update:a})),this.I(n,r,o);for(const[h,S]of d)this.s.getChildren(n).get(S.id)||this.O(b.$IJ.joinToString(c,S.id));this.y(r.actual.uri)}C(n,o,c){const t=new Set(o.map(r=>r.id));for(const r of n)t.delete(r.id)||this.D(r);this.pushDiff({op:1,item:{extId:c,item:{tags:n.map(r=>(0,R.$MJ)(this.s.controllerId,r.id))}}}),t.forEach(this.F,this)}D(n){const o=this.j.get(n.id);o?o.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$MJ)(this.s.controllerId,n.id)}}))}F(n){const o=this.j.get(n);o&&!--o.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,R.$MJ)(this.s.controllerId,n)}))}G(n,o){this.s.getApiFor(n).parent=o&&o.actual!==this.root?o.actual:void 0}H(n,o,c){this.G(n,c);const t=this.s.getApiFor(n);t.parent=c?.actual,t.listener=r=>this.w(o,r),this.J(o)}I(n,o,c){this.H(n,o,c);for(const[t,r]of this.s.getChildren(n))this.z(r,o)}J(n){let o;this.h?n.resolveBarrier?o=n.resolveBarrier.isOpen()?3:2:o=n.actual.canResolveChildren?1:0:o=0,o!==n.expand&&(n.expand=o,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:o}}),o===1&&n.expandLevels!==void 0&&this.M(n))}L(n,o){if(o<0)return;const c=[];for(const[t,r]of this.s.getChildren(n.actual)){const d=this.expand(b.$IJ.joinToString(n.fullId,r.id),o);(0,D.$Pg)(d)&&c.push(d)}if(c.length)return Promise.all(c).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const r=new D.$2g;return r.open(),r}n.expand=2,this.N(n);const o=n.resolveBarrier=new D.$2g,c=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(r){c(r)}return(0,D.$Pg)(t)?t.catch(c).then(()=>{o.open(),this.J(n)}):(o.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const o=this.tree.get(n);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const c=[o];for(;c.length;){const t=c.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const r of t.actual.tags)this.F(r.id);this.tree.delete(t.fullId.toString());for(const[r,d]of this.s.getChildren(t.actual))c.push(this.tree.get(b.$IJ.joinToString(t.fullId,d.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$KM=v;class k extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$LM=k;class l extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$MM=l;class f extends Error{constructor(n,o,c){super(`TestItem with ID "${n}" is from controller "${o}" and cannot be added as a child of an item from controller "${c}".`)}}e.$NM=f;const s=(i,n,o)=>{let c=new Map;return{get size(){return c.size},forEach(t,r){for(const d of c.values())t.call(r,d,this)},[Symbol.iterator](){return c.entries()},replace(t){const r=new Map,d=new Set(c.keys()),u={op:5,ops:[]};for(const a of t){if(!(a instanceof o))throw new l(a.id);const h=n(a).controllerId;if(h!==i.controllerId)throw new f(a.id,h,i.controllerId);if(r.has(a.id))throw new k(a.id);r.set(a.id,a),d.delete(a.id),u.ops.push({op:0,item:a})}for(const a of d.keys())u.ops.push({op:3,id:a});i.listener?.(u),c=r},add(t){if(!(t instanceof o))throw new l(t.id);c.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){c.delete(t)&&i.listener?.({op:3,id:t})},get(t){return c.get(t)},toJSON(){return Array.from(c.values())}}};e.$OM=s}),define(Se[142],ke([1,0,112]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$PM=void 0;const N=new WeakMap,g=(R,b)=>{const $={controllerId:b};return N.set(R,$),$};e.$PM=g;const I=R=>{const b=N.get(R);if(!b)throw new D.$MM(R?.id||"<unknown>");return b};e.$QM=I}),define(Se[113],ke([1,0,17,2]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mvb=e.$lvb=e.$kvb=e.$jvb=e.$ivb=void 0,e.$ivb="vscode-cdn.net",e.$jvb=`vscode-resource.${e.$ivb}`,e.$kvb=`'self' https://*.${e.$ivb}`;function g(b,$){return b.scheme===D.Schemas.http||b.scheme===D.Schemas.https?b:($&&$.authority&&$.isRemote&&b.scheme===D.Schemas.file&&(b=N.URI.from({scheme:D.Schemas.vscodeRemote,authority:$.authority,path:b.path})),N.URI.from({scheme:D.Schemas.https,authority:`${b.scheme}+${I(b.authority)}.${e.$jvb}`,path:b.path,fragment:b.fragment,query:b.query}))}e.$lvb=g;function I(b){return b.replace(/./g,$=>{const y=$.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?$:"-"+y.toString(16).padStart(4,"0")})}function R(b){return b.replace(/-([0-9a-f]{4})/g,($,y)=>String.fromCharCode(parseInt(y,16)))}e.$mvb=R}),define(Se[288],ke([1,0,4,3,113]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=void 0;class I{constructor(b,$,y){this.d=b,this.e=$,this.f=y,this.a=0,this.b=new N.$Rc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const A=$.getVisibleTextEditors();for(const C of this.c.values())A.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,$,y,A,C){let m;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===b){m=n;break}if(!m)throw new Error("not a visible editor");const v=this,k=this.a++,l=new D.$Sd,f=new D.$Sd,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,g.$lvb)(n,v.f)}get cspSource(){return g.$kvb}set options(n){this.b=n,v.d.$setOptions(k,n)}get options(){return this.b}set html(n){this.a=n,v.d.$setHtml(k,n)}get html(){return this.a}get onDidReceiveMessage(){return l.event}postMessage(n){return v.d.$postMessage(k,n)}},i=new class{constructor(){this.editor=b,this.line=$,this.height=y,this.webview=s,this.onDidDispose=f.event}dispose(){v.c.has(k)&&(v.c.delete(k),v.d.$disposeEditorInset(k),f.fire(),f.dispose(),l.dispose())}};return this.d.$createEditorInset(k,m.id,m.value.document.uri,$+1,y,A||{},C.identifier,C.extensionLocation),this.c.set(k,{editor:b,inset:i,onDidReceiveMessage:l}),i}$onDidDispose(b){const $=this.c.get(b);$&&$.inset.dispose()}$onDidReceiveMessage(b,$){this.c.get(b)?.onDidReceiveMessage.fire($)}}e.$xfc=I}),define(Se[289],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HN=e.VariableKind=e.$GN=void 0,e.$GN=(0,D.$3h)("configurationResolverService");var N;(function(I){I.Unknown="unknown",I.Env="env",I.Config="config",I.Command="command",I.Input="input",I.ExtensionInstallFolder="extensionInstallFolder",I.WorkspaceFolder="workspaceFolder",I.Cwd="cwd",I.WorkspaceFolderBasename="workspaceFolderBasename",I.UserHome="userHome",I.LineNumber="lineNumber",I.SelectedText="selectedText",I.File="file",I.FileWorkspaceFolder="fileWorkspaceFolder",I.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",I.RelativeFile="relativeFile",I.RelativeFileDirname="relativeFileDirname",I.FileDirname="fileDirname",I.FileExtname="fileExtname",I.FileBasename="fileBasename",I.FileBasenameNoExtension="fileBasenameNoExtension",I.FileDirnameBasename="fileDirnameBasename",I.ExecPath="execPath",I.ExecInstallFolder="execInstallFolder",I.PathSeparator="pathSeparator",I.PathSeparatorAlias="/"})(N||(e.VariableKind=N={}));class g extends Error{constructor(R,b){super(b),this.variable=R}}e.$HN=g}),define(Se[290],ke([1,0,16,50,18,24,10,102,232,289,12]),function(me,e,D,N,g,I,R,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VN=void 0;class C{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,k,l,f){this.h=new Map,this.a=v,this.b=k,this.g=l,f&&(this.c=f.then(s=>this.i(s)))}i(v){if(R.$i){const k=Object.create(null);return Object.keys(v).forEach(l=>{k[l.toLowerCase()]=v[l]}),k}return v}resolveWithEnvironment(v,k,l){return this.l({env:this.i(v),userHome:void 0},k?k.uri:void 0,l)}async resolveAsync(v,k){const l={env:await this.c,userHome:await this.g};return this.l(l,v?v.uri:void 0,k)}async j(v,k,l,f){const s=I.$jn(k);R.$i&&s.windows?Object.keys(s.windows).forEach(n=>s[n]=s.windows[n]):R.$j&&s.osx?Object.keys(s.osx).forEach(n=>s[n]=s.osx[n]):R.$k&&s.linux&&Object.keys(s.linux).forEach(n=>s[n]=s.linux[n]),delete s.windows,delete s.osx,delete s.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,v?v.uri:void 0,s,l,f)}async resolveAnyAsync(v,k,l){return this.j(v,k,l)}async resolveAnyMap(v,k,l){const f=new Map;return{newConfig:await this.j(v,k,l,f),resolvedVariables:f}}resolveWithInteractionReplace(v,k,l,f){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,k,l,f){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,k){if(this.h.has(v))throw new Error("Variable "+v+" is contributed twice.");this.h.set(v,k)}async l(v,k,l,f,s){if(g.$Ff(l))return this.m(v,k,l,f,s);if(Array.isArray(l))return Promise.all(l.map(i=>this.l(v,k,i,f,s)));if(g.$Hf(l)){const i=Object.create(null),n=await Promise.all(Object.keys(l).map(async o=>[await this.m(v,k,o,f,s),await this.l(v,k,l[o],f,s)]));for(const[o,c]of n)i[o]=c;return i}return l}m(v,k,l,f,s){return(0,A.$1e)(l,C.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(C.VARIABLE_LHS))return i;let o=await this.o(v,i,n,k,f);return s?.set(n,o),o!==i&&g.$Ff(o)&&o.match(C.VARIABLE_REGEXP)&&(o=await this.m(v,k,o,f,s)),o})}n(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async o(v,k,l,f,s){let i;const n=l.split(":");n.length>1&&(l=n[0],i=n[1]);const o=r=>{const d=this.a.getFilePath();if(d)return(0,b.$Jv)(d);throw new y.$HN(r,(0,$.localize)(0,null,k))},c=r=>{const d=o(r);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return(0,b.$Jv)(u)}throw new y.$HN(r,(0,$.localize)(1,null,k,D.$nc(d)))},t=r=>{if(i){const d=this.a.getFolderUri(i);if(d)return d;throw new y.$HN(r,(0,$.localize)(2,null,k,i))}if(f)return f;throw this.a.getWorkspaceFolderCount()>1?new y.$HN(r,(0,$.localize)(3,null,k)):new y.$HN(r,(0,$.localize)(4,null,k))};switch(l){case"env":if(i){if(v.env){const r=v.env[R.$i?i.toLowerCase():i];if(g.$Ff(r))return r}return""}throw new y.$HN(y.VariableKind.Env,(0,$.localize)(5,null,k));case"config":if(i){const r=this.a.getConfigurationValue(f,i);if(g.$Of(r))throw new y.$HN(y.VariableKind.Config,(0,$.localize)(6,null,k,i));if(g.$Hf(r))throw new y.$HN(y.VariableKind.Config,(0,$.localize)(7,null,k,i));return r}throw new y.$HN(y.VariableKind.Config,(0,$.localize)(8,null,k));case"command":return this.p(y.VariableKind.Command,k,i,s,"command");case"input":return this.p(y.VariableKind.Input,k,i,s,"input");case"extensionInstallFolder":if(i){const r=await this.a.getExtension(i);if(!r)throw new y.$HN(y.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,k,i));return this.n(r.extensionLocation)}throw new y.$HN(y.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,k));default:switch(l){case"workspaceRoot":case"workspaceFolder":return(0,b.$Jv)(this.n(t(y.VariableKind.WorkspaceFolder)));case"cwd":return f||i?(0,b.$Jv)(this.n(t(y.VariableKind.Cwd))):N.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$Jv)(D.$nc(this.n(t(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new y.$HN(y.VariableKind.UserHome,(0,$.localize)(11,null,k))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new y.$HN(y.VariableKind.LineNumber,(0,$.localize)(12,null,k))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new y.$HN(y.VariableKind.SelectedText,(0,$.localize)(13,null,k))}case"file":return o(y.VariableKind.File);case"fileWorkspaceFolder":return c(y.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return D.$nc(c(y.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return f||i?D.$lc(this.n(t(y.VariableKind.RelativeFile)),o(y.VariableKind.RelativeFile)):o(y.VariableKind.RelativeFile);case"relativeFileDirname":{const r=D.$mc(o(y.VariableKind.RelativeFileDirname));if(f||i){const d=D.$lc(this.n(t(y.VariableKind.RelativeFileDirname)),r);return d.length===0?".":d}return r}case"fileDirname":return D.$mc(o(y.VariableKind.FileDirname));case"fileExtname":return D.$oc(o(y.VariableKind.FileExtname));case"fileBasename":return D.$nc(o(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=D.$nc(o(y.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-D.$oc(r).length)}case"fileDirnameBasename":return D.$nc(D.$mc(o(y.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||k}case"execInstallFolder":{const r=this.a.getAppRoot();return r||k}case"pathSeparator":case"/":return D.sep;default:try{const r=i?`${l}:${i}`:l;return this.p(y.VariableKind.Unknown,k,r,s,void 0)}catch{return k}}}}p(v,k,l,f,s){if(l&&f){const i=s===void 0?f[l]:f[s+":"+l];if(typeof i=="string")return i;throw new y.$HN(v,(0,$.localize)(14,null,k))}return k}}e.$VN=C}),define(Se[143],ke([1,0,5,139]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XC=e.$WC=e.OpenEditorContext=e.GroupsOrder=e.$VC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$UC=void 0,e.$UC=(0,D.$3h)("editorGroupsService");var g;(function(k){k[k.UP=0]="UP",k[k.DOWN=1]="DOWN",k[k.LEFT=2]="LEFT",k[k.RIGHT=3]="RIGHT"})(g||(e.GroupDirection=g={}));var I;(function(k){k[k.HORIZONTAL=0]="HORIZONTAL",k[k.VERTICAL=1]="VERTICAL"})(I||(e.GroupOrientation=I={}));var R;(function(k){k[k.FIRST=0]="FIRST",k[k.LAST=1]="LAST",k[k.NEXT=2]="NEXT",k[k.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var b;(function(k){k[k.MAXIMIZE=0]="MAXIMIZE",k[k.EXPAND=1]="EXPAND",k[k.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var $;(function(k){k[k.COPY_EDITORS=0]="COPY_EDITORS",k[k.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function y(k){const l=k;return(0,N.$EE)(l?.editor)&&(0,N.$EE)(l?.replacement)}e.$VC=y;var A;(function(k){k[k.CREATION_TIME=0]="CREATION_TIME",k[k.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",k[k.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var C;(function(k){k[k.NEW_EDITOR=1]="NEW_EDITOR",k[k.MOVE_EDITOR=2]="MOVE_EDITOR",k[k.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function m(k){const l=k;return!!l&&typeof l.id=="number"&&Array.isArray(l.editors)}e.$WC=m;function v(k){return k.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$XC=v}),define(Se[291],ke([1,0,5,143]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3C=e.$2C=e.$1C=e.$ZC=e.$YC=void 0,e.$YC=(0,D.$3h)("editorService"),e.$ZC=-1,e.$1C=-2,e.$2C=-3;function g(I){const R=I;return typeof I=="number"||(0,N.$WC)(R)}e.$3C=g}),define(Se[144],ke([1,0,5,133]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bK=void 0,e.$bK=(0,D.$4h)(N.$0h)}),define(Se[145],ke([1,0,26,4,16,3]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s7b=e.$r7b=e.$q7b=e.$p7b=e.$o7b=void 0;class R{constructor(s,i){this.versionId=s,this.removedDueToLooping=i}}e.$o7b=R;class b{static isHostExtension(s,i,n){if(i.getExtensionDescription(s))return!1;const o=n.getExtensionDescription(s);return o?!!((o.main||o.browser)&&o.api==="none"):!1}constructor(s,i){this.j=s,this.c=new N.$Sd,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(k),this.f=new D.$km,this.g=[],this.h=new Map;for(const s of this.e){if(this.f.has(s.identifier)){console.error("Extension `"+s.identifier.value+"` is already registered");continue}this.f.set(s.identifier,s),this.g.push(s);const i=this.j.readActivationEvents(s);for(const n of i)this.h.has(n)||this.h.set(n,[]),this.h.get(n).push(s)}}set(s){return this.e=s,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(s,i){this.e=l(this.e,i),this.e=this.e.concat(s);const n=b.l(this.e);return this.e=l(this.e,n.map(o=>o.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,n)}static l(s){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,d){this.addNode(r),this.addNode(d),this.c.has(r)?this.c.get(r).push(d):this.c.set(r,[d])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,d){const u=i.getArcs(r);for(let a=0;a<u.length;a++)if(!d.has(u[a]))return!1;return!0}getNodes(){return this.e}},n=new D.$km;for(const r of s)if(n.set(r.identifier,r),r.extensionDependencies)for(const d of r.extensionDependencies)i.addArc(D.$im.toKey(r.identifier),D.$im.toKey(d));const o=new Set;i.getNodes().filter(r=>i.getArcs(r).length===0).forEach(r=>o.add(r));const c=i.getNodes().filter(r=>!o.has(r));let t;do{t=!1;for(let r=0;r<c.length;r++){const d=c[r];i.hasOnlyGoodArcs(d,o)&&(c.splice(r,1),r--,o.add(d),t=!0)}}while(t);return c.map(r=>n.get(r))}containsActivationEvent(s){return this.h.has(s)}containsExtension(s){return this.f.has(s)}getExtensionDescriptionsForActivationEvent(s){const i=this.h.get(s);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new $(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(s){const i=this.f.get(s);return i||void 0}getExtensionDescriptionByUUID(s){for(const i of this.g)if(i.uuid===s)return i}getExtensionDescriptionByIdOrUUID(s,i){return this.getExtensionDescription(s)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$p7b=b;class ${constructor(s,i){this.versionId=s,this.extensions=i}}e.$q7b=$;class y{constructor(s){this.d=new m,this.c=new b(s,[])}async acquireLock(s){const i=await this.d.acquire(s);return new A(this,i)}deltaExtensions(s,i,n){if(!s.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,n)}containsActivationEvent(s){return this.c.containsActivationEvent(s)}containsExtension(s){return this.c.containsExtension(s)}getExtensionDescriptionsForActivationEvent(s){return this.c.getExtensionDescriptionsForActivationEvent(s)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(s){return this.c.getExtensionDescription(s)}getExtensionDescriptionByUUID(s){return this.c.getExtensionDescriptionByUUID(s)}getExtensionDescriptionByIdOrUUID(s,i){return this.c.getExtensionDescriptionByIdOrUUID(s,i)}}e.$r7b=y;class A extends I.$Sc{constructor(s,i){super(),this.f=s,this.c=!1,this.B(i)}isAcquiredFor(s){return!this.c&&this.f===s}}e.$s7b=A;class C{constructor(s){this.name=s,this.promise=new Promise((i,n)=>{this.c=i})}resolve(s){this.c(s)}}class m{constructor(){this.c=[],this.d=!1}async acquire(s){const i=new C(s);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const s=this.c.shift();this.d=!0;let i=!0;const n=setTimeout(()=>{i&&console.warn(`The customer named ${s.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),o=()=>{i&&(clearTimeout(n),i=!1,this.d=!1,this.e())};s.resolve((0,I.$Qc)(o))}}var v;(function(f){f[f.Builtin=0]="Builtin",f[f.User=1]="User",f[f.Dev=2]="Dev"})(v||(v={}));function k(f,s){const i=f.isBuiltin?0:f.isUnderDevelopment?2:1,n=s.isBuiltin?0:s.isUnderDevelopment?2:1;if(i!==n)return i-n;const o=g.$gc.basename(f.extensionLocation.path),c=g.$gc.basename(s.extensionLocation.path);return o<c?-1:o>c?1:0}function l(f,s){const i=new D.$jm(s);return f.filter(n=>!i.has(n.identifier))}}),define(Se[292],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.ExtHostConnectionType=void 0;var D;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(D||(e.ExtHostConnectionType=D={}));class N{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(C){this.pipeName=C,this.type=1}serialize(C){C[N.ENV_KEY]=this.pipeName}}e.$Mm=N;class g{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(C){C[g.ENV_KEY]="1"}}e.$Nm=g;class I{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(C){C[I.ENV_KEY]="1"}}e.$Om=I;function R(A){delete A[N.ENV_KEY],delete A[g.ENV_KEY],delete A[I.ENV_KEY]}function b(A,C){R(C),A.serialize(C)}e.$Pm=b;function $(A){if(A[N.ENV_KEY])return y(A,new N(A[N.ENV_KEY]));if(A[g.ENV_KEY])return y(A,new g);if(A[I.ENV_KEY])return y(A,new I);throw new Error("No connection information defined in environment!")}e.$Qm=$;function y(A,C){return R(A),C}}),define(Se[114],ke([1,0,22]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$rm=e.$qm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var N;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(N||(e.UIKind=N={}));var g;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(g||(e.ExtensionHostExitCode=g={}));var I;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(I||(e.MessageType=I={}));function R(y){const A=D.$ge.alloc(1);switch(y){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$qm=R;function b(y,A){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$rm=b;var $;(function(y){y.Start="START_NATIVE_LOG",y.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Se[90],ke([1,0,5,4,13,27,114,65,87,24,2,3,218]),function(me,e,D,N,g,I,R,b,$,y,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cN=e.$bN=e.$aN=e.$_M=void 0;let v=class extends C.$Sc{constructor(s,i){super(),this.s=s,this.t=i,this.a=this.B(new N.$Sd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new N.$Sd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:$.$Do,name:(0,m.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,g.$mj)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===g.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,i,n){const o=this.getTelemetryDetails(),c=new k(i,n,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,c]),c.apiTelemetryLogger}$initializeTelemetryLevel(s,i,n){this.f=s,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const i=Object.create(null);switch(i["common.extname"]=`${s.publisher}.${s.name}`,i["common.extversion"]=s.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=l(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,b.$$k)((0,$.$Ko)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const i=this.getTelemetryDetails();this.r.forEach((n,o)=>{const c=n.filter(t=>!t.isDisposed);c.length===0?this.r.delete(o):this.r.set(o,c)}),this.r.forEach(n=>{for(const o of n)o.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,i){const o=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!o)return this.r.delete(s.value),!1;let c=!1;for(const t of o)t.ignoreUnhandledExtHostErrors||(t.logError(i),c=!0);return c}};e.$_M=v,e.$_M=v=Ge([We(0,I.$$M),We(1,g.$lj)],v);class k{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,i,n,o,c,t,r){this.g=n,this.h=o,this.i=c,this.j=t,this.a=new N.$Sd,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(s,i){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let i="properties"in s?s.properties??{}:s;return i=(0,$.$No)(i,[]),this.c&&(i=(0,y.$mn)(i,this.c)),this.b||(i=(0,y.$mn)(i,this.j)),"properties"in s?s.properties=i:s=i,s}k(s,i){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(s,i),this.h.trace(s,i))}logUsage(s,i){this.d.isUsageEnabled&&this.k(s,i)}logError(s,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,i);else{const n={name:s.name,message:s.message,stack:s.stack,cause:s.cause},o=(0,$.$No)(n,[]),c=new Error(o.message,{cause:o.cause});c.stack=o.stack,c.name=o.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(c,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const s=this,i={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$aN=k;function l(f){const s=Date.now()-new Date(f).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$bN=l,e.$cN=(0,D.$3h)("IExtHostTelemetry")}),define(Se[25],ke([1,0,4,2,262,137,26,5]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uF=e.$tF=e.$sF=e.ActivationKind=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.ExtensionHostStartup=e.$mF=e.$lF=e.$kF=e.$jF=void 0,e.$jF=Object.freeze({identifier:new R.$im("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:N.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$kF="extensions.webWorker",e.$lF=(0,b.$3h)("extensionService");class ${constructor(c){this.dependency=c}}e.$mF=$;var y;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(y||(e.ExtensionHostStartup=y={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(c,t,r){this.c=c,this.d=t.slice(0),this.e=r.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:I.$7E.createActivationEventsMap(this.d)}}set(c,t,r){if(this.c>c)throw new Error(`ExtensionHostExtensions: invalid versionId ${c} (current: ${this.c})`);const d=[],u=[],a=[],h=[],S=C(this.d),P=C(t),w=(U,F)=>U.extensionLocation.toString()===F.extensionLocation.toString()||U.isBuiltin===F.isBuiltin||U.isUserBuiltin===F.isUserBuiltin||U.isUnderDevelopment===F.isUnderDevelopment;for(const U of this.d){const F=P.get(U.identifier);if(!F){d.push(U.identifier),S.delete(U.identifier);continue}if(!w(U,F)){d.push(U.identifier),S.delete(U.identifier);continue}}for(const U of t){const F=S.get(U.identifier);if(!F){u.push(U);continue}if(!w(F,U)){d.push(F.identifier),S.delete(F.identifier);continue}}const p=new R.$jm(this.e),E=new R.$jm(r);for(const U of this.e)E.has(U)||a.push(U);for(const U of r)p.has(U)||h.push(U);const L=I.$7E.createActivationEventsMap(u),T={versionId:c,toRemove:d,toAdd:u,addActivationEvents:L,myToRemove:a,myToAdd:h};return this.delta(T),T}delta(c){if(this.c>=c.versionId)return null;const{toRemove:t,toAdd:r,myToRemove:d,myToAdd:u}=c,a=new R.$jm(t),h=new R.$jm(d);for(let S=0;S<this.d.length;S++)a.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)h.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of r)this.d.push(S);for(const S of u)this.e.push(S);return this.f=null,c}containsExtension(c){for(const t of this.e)if(R.$im.equals(t,c))return!0;return!1}containsActivationEvent(c){return this.f||(this.f=this.g()),this.f.has(c)}g(){const c=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const r=I.$7E.readActivationEvents(t);for(const d of r)c.add(d)}return c}}e.$nF=A;function C(o){const c=new R.$km;for(const t of o)c.set(t.identifier,t);return c}function m(o,c){return o.enabledApiProposals?o.enabledApiProposals.includes(c):!1}e.$oF=m;function v(o,c){if(!m(o,c))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${c}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${c}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.$pF=v;class k{constructor(c,t,r,d){this.codeLoadingTime=c,this.activateCallTime=t,this.activateResolvedTime=r,this.activationReason=d}}e.$qF=k;class l{constructor(c,t){this.description=c,this.value=t}}e.$rF=l;var f;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(f||(e.ActivationKind=f={}));function s(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,g.$To)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.$sF=s;function i(o,c){return{identifier:new R.$im((0,g.$Ro)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!c,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform}}e.$tF=i;class n{constructor(){this.onDidRegisterExtensions=D.Event.None,this.onDidChangeExtensionsStatus=D.Event.None,this.onDidChangeExtensions=D.Event.None,this.onWillActivateByEvent=D.Event.None,this.onDidChangeResponsiveChange=D.Event.None,this.onWillStop=D.Event.None,this.extensions=[]}activateByEvent(c){return Promise.resolve(void 0)}activateById(c,t){return Promise.resolve(void 0)}activationEventIsDone(c){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(c){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(c,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(c){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$uF=n}),define(Se[293],ke([1,0,14,145,26,25,13,11]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yfc=e.$Xfc=e.$Wfc=e.$Vfc=e.$Ufc=e.$Tfc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(s,i,n,o){this.startup=s,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=o}}e.$Tfc=$;class y{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,i){return s===-1||i===-1?-1:i-s}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Ufc=y;class A{constructor(s,i,n,o,c,t){this.activationFailed=s,this.activationFailedError=i,this.activationTimes=n,this.module=o,this.exports=c,this.subscriptions=t}}e.$Vfc=A;class C extends A{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Wfc=C;class m extends A{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Xfc=m;class v extends A{constructor(s){super(!0,s,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let k=class{constructor(s,i,n,o){this.g=o,this.a=s,this.b=i,this.c=n,this.d=new g.$km,this.f=Object.create(null)}dispose(){for(const[s,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const s=[];for(const[i,n]of this.d)s.push(n.wait());await Promise.all(s)}isActivated(s){const i=this.d.get(s);return!!(i&&i.value)}getActivatedExtension(s){const i=this.d.get(s);if(!i||!i.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return i.value}async activateByEvent(s,i){if(this.f[s])return;const n=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(n.map(o=>({id:o.identifier,reason:{startup:i,extensionId:o.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,i){const n=this.a.getExtensionDescription(s);if(!n)throw new Error(`Extension '${s}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(s){const i=s.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const i=this.a.getExtensionDescription(s.id);if(!i){const c=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new v(c));return this.c.onExtensionActivationError(s.id,c,new I.$mF(s.id.value)),t}const n=[],o=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const c of o){if(this.m(c))continue;const t=this.d.get(c);if(t){n.push(t);continue}if(this.l(c)){n.push(this.j({id:this.b.getExtensionDescription(c).identifier,reason:s.reason}));continue}const r=this.a.getExtensionDescription(c);if(r){if(!r.main&&!r.browser)continue;n.push(this.j({id:r.identifier,reason:s.reason}));continue}const d=i.displayName||i.identifier.value,u=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${c}'`),a=this.k(s,i.displayName,[],new v(u));return this.c.onExtensionActivationError(i.identifier,u,new I.$mF(c)),a}return this.k(s,i.displayName,n,null)}k(s,i,n,o){const c=new l(s.id,i,s.reason,n,o,this.c,this.g);return this.d.set(s.id,c),c}l(s){return N.$p7b.isHostExtension(s,this.a,this.b)}m(s){const i=this.b.getExtensionDescription(s);return i?!i.main&&!i.browser:!1}};e.$Yfc=k,e.$Yfc=k=Ge([We(3,R.$kj)],k);let l=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,i,n,o,c,t,r){this.c=s,this.d=i,this.f=n,this.g=o,this.h=c,this.j=t,this.k=r,this.a=new b.$2g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const i=this.g[s];if(i.value&&!i.value.activationFailed){this.g.splice(s,1),s--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new v(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const i=new Error;if(s&&s.name&&(i.name=s.name),s&&s.message?i.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(i.stack=s.stack),this.h=new v(i),this.b&&D.$4(s))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};l=Ge([We(6,R.$kj)],l)}),define(Se[15],ke([1,0,19,22,165,74,80,28,160,55,100,24,18,2,29,83,135,142,139,111,67,89,291,7,25]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l,f,s,i,n,o,c,t,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$TM=e.$SM=e.MarkdownString=e.$RM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var u;(function(Fe){function Te(se){const{selectionStartLineNumber:Ne,selectionStartColumn:qe,positionLineNumber:xe,positionColumn:Ke}=se,st=new r.$TK(Ne-1,qe-1),$t=new r.$TK(xe-1,Ke-1);return new r.$VK(st,$t)}Fe.to=Te;function Ce(se){const{anchor:Ne,active:qe}=se;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:qe.line+1,positionColumn:qe.character+1}}Fe.from=Ce})(u||(e.Selection=u={}));var a;(function(Fe){function Te(se){if(!se)return;const{start:Ne,end:qe}=se;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:qe.line+1,endColumn:qe.character+1}}Fe.from=Te;function Ce(se){if(!se)return;const{startLineNumber:Ne,startColumn:qe,endLineNumber:xe,endColumn:Ke}=se;return new r.$UK(Ne-1,qe-1,xe-1,Ke-1)}Fe.to=Ce})(a||(e.Range=a={}));var h;(function(Fe){function Te(Ce){switch(Ce){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Fe.to=Te})(h||(e.TokenType=h={}));var S;(function(Fe){function Te(se){return new r.$TK(se.lineNumber-1,se.column-1)}Fe.to=Te;function Ce(se){return{lineNumber:se.line+1,column:se.character+1}}Fe.from=Ce})(S||(e.Position=S={}));var P;(function(Fe){function Te(Ne,qe,xe){return(0,D.$Hb)((0,D.$3b)(Ne).map(Ke=>Ce(Ke,qe,xe)))}Fe.from=Te;function Ce(Ne,qe,xe){if(typeof Ne=="string")return{$serialized:!0,language:Ne,isBuiltin:xe?.isBuiltin};if(Ne)return{$serialized:!0,language:Ne.language,scheme:se(Ne.scheme,qe),pattern:ne.from(Ne.pattern)??void 0,exclusive:Ne.exclusive,notebookType:Ne.notebookType,isBuiltin:xe?.isBuiltin}}function se(Ne,qe){return qe&&typeof Ne=="string"?qe.transformOutgoingScheme(Ne):Ne}})(P||(e.DocumentSelector=P={}));var w;(function(Fe){function Te(se){switch(se){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Fe.from=Te;function Ce(se){switch(se){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Fe.to=Ce})(w||(e.DiagnosticTag=w={}));var p;(function(Fe){function Te(se){let Ne;return se.code&&((0,m.$Ff)(se.code)||(0,m.$Jf)(se.code)?Ne=String(se.code):Ne={value:String(se.code.value),target:se.code.target}),{...a.from(se.range),message:se.message,source:se.source,code:Ne,severity:L.from(se.severity),relatedInformation:se.relatedInformation&&se.relatedInformation.map(E.from),tags:Array.isArray(se.tags)?(0,D.$Hb)(se.tags.map(w.from)):void 0}}Fe.from=Te;function Ce(se){const Ne=new r.$7K(a.to(se),se.message,L.to(se.severity));return Ne.source=se.source,Ne.code=(0,m.$Ff)(se.code)?se.code:se.code?.value,Ne.relatedInformation=se.relatedInformation&&se.relatedInformation.map(E.to),Ne.tags=se.tags&&(0,D.$Hb)(se.tags.map(w.to)),Ne}Fe.to=Ce})(p||(e.Diagnostic=p={}));var E;(function(Fe){function Te(se){return{...a.from(se.location.range),message:se.message,resource:se.location.uri}}Fe.from=Te;function Ce(se){return new r.$6K(new r.$5K(se.resource,a.to(se)),se.message)}Fe.to=Ce})(E||(e.DiagnosticRelatedInformation=E={}));var L;(function(Fe){function Te(se){switch(se){case r.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}Fe.from=Te;function Ce(se){switch(se){case f.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Fe.to=Ce})(L||(e.DiagnosticSeverity=L={}));var T;(function(Fe){function Te(se){return typeof se=="number"&&se>=r.ViewColumn.One?se-1:se===r.ViewColumn.Beside?t.$1C:t.$ZC}Fe.from=Te;function Ce(se){if(typeof se=="number"&&se>=0)return se+1;throw new Error("invalid 'EditorGroupColumn'")}Fe.to=Ce})(T||(e.ViewColumn=T={}));function U(Fe){return typeof Fe.range<"u"}function F(Fe){return Fe.length===0?!0:!!U(Fe[0])}e.$RM=F;var j;(function(Fe){function Te(Ke){return Ke.map(Fe.from)}Fe.fromMany=Te;function Ce(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function se(Ke){let st;if(Ce(Ke)){const{language:It,value:yt}=Ke;st={value:"```"+It+`
`+yt+"\n```\n"}}else r.$hL.isMarkdownString(Ke)?st={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?st={value:Ke}:st={value:""};const $t=Object.create(null);st.uris=$t;const Bt=It=>{try{let yt=v.URI.parse(It,!0);yt=yt.with({query:Ne(yt.query,$t)}),$t[It]=yt}catch{}return""},St=new $.marked.Renderer;return St.link=Bt,St.image=It=>typeof It=="string"?Bt(R.$mk(It).href):"",(0,$.marked)(st.value,{renderer:St}),st}Fe.from=se;function Ne(Ke,st){if(!Ke)return Ke;let $t;try{$t=(0,y.$yh)(Ke)}catch{}if(!$t)return Ke;let Bt=!1;return $t=(0,C.$ln)($t,St=>{if(v.URI.isUri(St)){const It=`__uri_${Math.random().toString(16).slice(2,8)}`;return st[It]=St,Bt=!0,It}else return}),Bt?JSON.stringify($t):Ke}function qe(Ke){const st=new r.$hL(Ke.value,Ke.supportThemeIcons);return st.isTrusted=Ke.isTrusted,st.supportHtml=Ke.supportHtml,st.baseUri=Ke.baseUri?v.URI.from(Ke.baseUri):void 0,st}Fe.to=qe;function xe(Ke){if(Ke)return typeof Ke=="string"?Ke:Fe.from(Ke)}Fe.fromStrict=xe})(j||(e.MarkdownString=j={}));function O(Fe){return F(Fe)?Fe.map(Te=>({range:a.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?j.fromMany(Te.hoverMessage):Te.hoverMessage?j.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Fe.map(Te=>({range:a.from(Te)}))}e.$SM=O;function M(Fe){return typeof Fe>"u"?Fe:typeof Fe=="string"?v.URI.file(Fe):Fe}e.$TM=M;var W;(function(Fe){function Te(Ce){return typeof Ce>"u"?Ce:{contentText:Ce.contentText,contentIconPath:Ce.contentIconPath?M(Ce.contentIconPath):void 0,border:Ce.border,borderColor:Ce.borderColor,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,color:Ce.color,backgroundColor:Ce.backgroundColor,margin:Ce.margin,width:Ce.width,height:Ce.height}}Fe.from=Te})(W||(e.ThemableDecorationAttachmentRenderOptions=W={}));var Y;(function(Fe){function Te(Ce){return typeof Ce>"u"?Ce:{backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?M(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?W.from(Ce.before):void 0,after:Ce.after?W.from(Ce.after):void 0}}Fe.from=Te})(Y||(e.ThemableDecorationRenderOptions=Y={}));var ue;(function(Fe){function Te(Ce){if(typeof Ce>"u")return Ce;switch(Ce){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Fe.from=Te})(ue||(e.DecorationRangeBehavior=ue={}));var X;(function(Fe){function Te(Ce){return{isWholeLine:Ce.isWholeLine,rangeBehavior:Ce.rangeBehavior?ue.from(Ce.rangeBehavior):void 0,overviewRulerLane:Ce.overviewRulerLane,light:Ce.light?Y.from(Ce.light):void 0,dark:Ce.dark?Y.from(Ce.dark):void 0,backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?M(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?W.from(Ce.before):void 0,after:Ce.after?W.from(Ce.after):void 0}}Fe.from=Te})(X||(e.DecorationRenderOptions=X={}));var J;(function(Fe){function Te(se){return{text:se.newText,eol:se.newEol&&rt.from(se.newEol),range:a.from(se.range)}}Fe.from=Te;function Ce(se){const Ne=new r.$ZK(a.to(se.range),se.text);return Ne.newEol=typeof se.eol>"u"?void 0:rt.to(se.eol),Ne}Fe.to=Ce})(J||(e.TextEdit=J={}));var x;(function(Fe){function Te(se,Ne){const qe={edits:[]};if(se instanceof r.$3K){const xe=new b.$Bc;for(const Ke of se._allEntries())Ke._type===1&&v.URI.isUri(Ke.to)&&Ke.from===void 0&&xe.add(Ke.to);for(const Ke of se._allEntries())if(Ke._type===1){let st;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?st={type:"base64",value:(0,N.$Ae)(N.$ge.wrap(Ke.options.contents))}:st={type:"dataTransferItem",id:Ke.options.contents._itemId}),qe.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:st},metadata:Ke.metadata})}else Ke._type===2?qe.edits.push({resource:Ke.uri,textEdit:J.from(Ke.edit),versionId:xe.has(Ke.uri)?void 0:Ne?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===6?qe.edits.push({resource:Ke.uri,textEdit:{range:a.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:xe.has(Ke.uri)?void 0:Ne?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===3?qe.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Ne?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&qe.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Ne?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(wt.from)}})}return qe}Fe.from=Te;function Ce(se){const Ne=new r.$3K,qe=new b.$Ac;for(const xe of se.edits)if(xe.textEdit){const Ke=xe,st=v.URI.revive(Ke.resource),$t=a.to(Ke.textEdit.range),Bt=Ke.textEdit.text,St=Ke.textEdit.insertAsSnippet;let It;St?It=r.$2K.replace($t,new r.$4K(Bt)):It=r.$ZK.replace($t,Bt);const yt=qe.get(st);yt?yt.push(It):qe.set(st,[It])}else Ne.renameFile(v.URI.revive(xe.oldResource),v.URI.revive(xe.newResource),xe.options);for(const[xe,Ke]of qe)Ne.set(xe,Ke);return Ne}Fe.to=Ce})(x||(e.WorkspaceEdit=x={}));var he;(function(Fe){const Te=Object.create(null);Te[r.SymbolKind.File]=0,Te[r.SymbolKind.Module]=1,Te[r.SymbolKind.Namespace]=2,Te[r.SymbolKind.Package]=3,Te[r.SymbolKind.Class]=4,Te[r.SymbolKind.Method]=5,Te[r.SymbolKind.Property]=6,Te[r.SymbolKind.Field]=7,Te[r.SymbolKind.Constructor]=8,Te[r.SymbolKind.Enum]=9,Te[r.SymbolKind.Interface]=10,Te[r.SymbolKind.Function]=11,Te[r.SymbolKind.Variable]=12,Te[r.SymbolKind.Constant]=13,Te[r.SymbolKind.String]=14,Te[r.SymbolKind.Number]=15,Te[r.SymbolKind.Boolean]=16,Te[r.SymbolKind.Array]=17,Te[r.SymbolKind.Object]=18,Te[r.SymbolKind.Key]=19,Te[r.SymbolKind.Null]=20,Te[r.SymbolKind.EnumMember]=21,Te[r.SymbolKind.Struct]=22,Te[r.SymbolKind.Event]=23,Te[r.SymbolKind.Operator]=24,Te[r.SymbolKind.TypeParameter]=25;function Ce(Ne){return typeof Te[Ne]=="number"?Te[Ne]:6}Fe.from=Ce;function se(Ne){for(const qe in Te)if(Te[qe]===Ne)return Number(qe);return r.SymbolKind.Property}Fe.to=se})(he||(e.SymbolKind=he={}));var Z;(function(Fe){function Te(se){switch(se){case r.SymbolTag.Deprecated:return 1}}Fe.from=Te;function Ce(se){switch(se){case 1:return r.SymbolTag.Deprecated}}Fe.to=Ce})(Z||(e.SymbolTag=Z={}));var we;(function(Fe){function Te(se){return{name:se.name,kind:he.from(se.kind),tags:se.tags&&se.tags.map(Z.from),containerName:se.containerName,location:ye.from(se.location)}}Fe.from=Te;function Ce(se){const Ne=new r.$$K(se.name,he.to(se.kind),se.containerName,ye.to(se.location));return Ne.tags=se.tags&&se.tags.map(Z.to),Ne}Fe.to=Ce})(we||(e.WorkspaceSymbol=we={}));var ce;(function(Fe){function Te(se){const Ne={name:se.name||"!!MISSING: name!!",detail:se.detail,range:a.from(se.range),selectionRange:a.from(se.selectionRange),kind:he.from(se.kind),tags:se.tags?.map(Z.from)??[]};return se.children&&(Ne.children=se.children.map(Te)),Ne}Fe.from=Te;function Ce(se){const Ne=new r.$_K(se.name,se.detail,he.to(se.kind),a.to(se.range),a.to(se.selectionRange));return(0,D.$Lb)(se.tags)&&(Ne.tags=se.tags.map(Z.to)),se.children&&(Ne.children=se.children.map(Ce)),Ne}Fe.to=Ce})(ce||(e.DocumentSymbol=ce={}));var K;(function(Fe){function Te(se){const Ne=new r.$dL(he.to(se.kind),se.name,se.detail||"",v.URI.revive(se.uri),a.to(se.range),a.to(se.selectionRange));return Ne._sessionId=se._sessionId,Ne._itemId=se._itemId,Ne}Fe.to=Te;function Ce(se,Ne,qe){if(Ne=Ne??se._sessionId,qe=qe??se._itemId,Ne===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:qe,name:se.name,detail:se.detail,kind:he.from(se.kind),uri:se.uri,range:a.from(se.range),selectionRange:a.from(se.selectionRange),tags:se.tags?.map(Z.from)}}Fe.from=Ce})(K||(e.CallHierarchyItem=K={}));var B;(function(Fe){function Te(Ce){return new r.$eL(K.to(Ce.from),Ce.fromRanges.map(se=>a.to(se)))}Fe.to=Te})(B||(e.CallHierarchyIncomingCall=B={}));var re;(function(Fe){function Te(Ce){return new r.$fL(K.to(Ce.to),Ce.fromRanges.map(se=>a.to(se)))}Fe.to=Te})(re||(e.CallHierarchyOutgoingCall=re={}));var ye;(function(Fe){function Te(se){return{range:se.range&&a.from(se.range),uri:se.uri}}Fe.from=Te;function Ce(se){return new r.$5K(v.URI.revive(se.uri),a.to(se.range))}Fe.to=Ce})(ye||(e.location=ye={}));var de;(function(Fe){function Te(se){const Ne=se,qe=se;return{originSelectionRange:Ne.originSelectionRange?a.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:qe.uri,range:a.from(Ne.targetRange?Ne.targetRange:qe.range),targetSelectionRange:Ne.targetSelectionRange?a.from(Ne.targetSelectionRange):void 0}}Fe.from=Te;function Ce(se){return{targetUri:v.URI.revive(se.uri),targetRange:a.to(se.range),targetSelectionRange:se.targetSelectionRange?a.to(se.targetSelectionRange):void 0,originSelectionRange:se.originSelectionRange?a.to(se.originSelectionRange):void 0}}Fe.to=Ce})(de||(e.DefinitionLink=de={}));var ge;(function(Fe){function Te(se){return{range:a.from(se.range),contents:j.fromMany(se.contents)}}Fe.from=Te;function Ce(se){return new r.$8K(se.contents.map(j.to),a.to(se.range))}Fe.to=Ce})(ge||(e.Hover=ge={}));var _;(function(Fe){function Te(se){return{range:a.from(se.range),expression:se.expression}}Fe.from=Te;function Ce(se){return new r.$2L(a.to(se.range),se.expression)}Fe.to=Ce})(_||(e.EvaluatableExpression=_={}));var ie;(function(Fe){function Te(se){if(se instanceof r.$3L)return{type:"text",range:a.from(se.range),text:se.text};if(se instanceof r.$4L)return{type:"variable",range:a.from(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};if(se instanceof r.$5L)return{type:"expression",range:a.from(se.range),expression:se.expression};throw new Error("Unknown 'InlineValue' type")}Fe.from=Te;function Ce(se){switch(se.type){case"text":return{range:a.to(se.range),text:se.text};case"variable":return{range:a.to(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};case"expression":return{range:a.to(se.range),expression:se.expression}}}Fe.to=Ce})(ie||(e.InlineValue=ie={}));var G;(function(Fe){function Te(se){return{frameId:se.frameId,stoppedLocation:a.from(se.stoppedLocation)}}Fe.from=Te;function Ce(se){return new r.$6L(se.frameId,a.to(se.stoppedLocation))}Fe.to=Ce})(G||(e.InlineValueContext=G={}));var te;(function(Fe){function Te(se){return{range:a.from(se.range),kind:se.kind}}Fe.from=Te;function Ce(se){return new r.$9K(a.to(se.range),se.kind)}Fe.to=Ce})(te||(e.DocumentHighlight=te={}));var fe;(function(Fe){function Te(se){return{uri:se.uri,highlights:se.highlights.map(te.from)}}Fe.from=Te;function Ce(se){return new r.$0K(v.URI.revive(se.uri),se.highlights.map(te.to))}Fe.to=Ce})(fe||(e.MultiDocumentHighlight=fe={}));var ve;(function(Fe){function Te(Ce){switch(Ce){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Fe.to=Te})(ve||(e.CompletionTriggerKind=ve={}));var Pe;(function(Fe){function Te(Ce){return{triggerKind:ve.to(Ce.triggerKind),triggerCharacter:Ce.triggerCharacter}}Fe.to=Te})(Pe||(e.CompletionContext=Pe={}));var be;(function(Fe){function Te(se){switch(se){case r.CompletionItemTag.Deprecated:return 1}}Fe.from=Te;function Ce(se){switch(se){case 1:return r.CompletionItemTag.Deprecated}}Fe.to=Ce})(be||(e.CompletionItemTag=be={}));var De;(function(Fe){const Te=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function Ce(qe){return Te.get(qe)??9}Fe.from=Ce;const se=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Ne(qe){return se.get(qe)??r.CompletionItemKind.Property}Fe.to=Ne})(De||(e.CompletionItemKind=De={}));var z;(function(Fe){function Te(Ce,se){const Ne=new r.$nL(Ce.label);return Ne.insertText=Ce.insertText,Ne.kind=De.to(Ce.kind),Ne.tags=Ce.tags?.map(be.to),Ne.detail=Ce.detail,Ne.documentation=R.$gk(Ce.documentation)?j.to(Ce.documentation):Ce.documentation,Ne.sortText=Ce.sortText,Ne.filterText=Ce.filterText,Ne.preselect=Ce.preselect,Ne.commitCharacters=Ce.commitCharacters,k.$Is.isIRange(Ce.range)?Ne.range=a.to(Ce.range):typeof Ce.range=="object"&&(Ne.range={inserting:a.to(Ce.range.insert),replacing:a.to(Ce.range.replace)}),Ne.keepWhitespace=typeof Ce.insertTextRules>"u"?!1:!!(Ce.insertTextRules&1),typeof Ce.insertTextRules<"u"&&Ce.insertTextRules&4?Ne.insertText=new r.$4K(Ce.insertText):(Ne.insertText=Ce.insertText,Ne.textEdit=Ne.range instanceof r.$UK?new r.$ZK(Ne.range,Ne.insertText):void 0),Ce.additionalTextEdits&&Ce.additionalTextEdits.length>0&&(Ne.additionalTextEdits=Ce.additionalTextEdits.map(qe=>J.to(qe))),Ne.command=se&&Ce.command?se.fromInternal(Ce.command):void 0,Ne}Fe.to=Te})(z||(e.CompletionItem=z={}));var Q;(function(Fe){function Te(se){if(typeof se.label!="string"&&!Array.isArray(se.label))throw new TypeError("Invalid label");return{label:se.label,documentation:j.fromStrict(se.documentation)}}Fe.from=Te;function Ce(se){return{label:se.label,documentation:R.$gk(se.documentation)?j.to(se.documentation):se.documentation}}Fe.to=Ce})(Q||(e.ParameterInformation=Q={}));var ee;(function(Fe){function Te(se){return{label:se.label,documentation:j.fromStrict(se.documentation),parameters:Array.isArray(se.parameters)?se.parameters.map(Q.from):[],activeParameter:se.activeParameter}}Fe.from=Te;function Ce(se){return{label:se.label,documentation:R.$gk(se.documentation)?j.to(se.documentation):se.documentation,parameters:Array.isArray(se.parameters)?se.parameters.map(Q.to):[],activeParameter:se.activeParameter}}Fe.to=Ce})(ee||(e.SignatureInformation=ee={}));var V;(function(Fe){function Te(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(ee.from):[]}}Fe.from=Te;function Ce(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(ee.to):[]}}Fe.to=Ce})(V||(e.SignatureHelp=V={}));var oe;(function(Fe){function Te(Ce,se){const Ne=new r.$mL(S.to(se.position),typeof se.label=="string"?se.label:se.label.map(le.to.bind(void 0,Ce)),se.kind&&Re.to(se.kind));return Ne.textEdits=se.textEdits&&se.textEdits.map(J.to),Ne.tooltip=R.$gk(se.tooltip)?j.to(se.tooltip):se.tooltip,Ne.paddingLeft=se.paddingLeft,Ne.paddingRight=se.paddingRight,Ne}Fe.to=Te})(oe||(e.InlayHint=oe={}));var le;(function(Fe){function Te(Ce,se){const Ne=new r.$lL(se.label);return Ne.tooltip=R.$gk(se.tooltip)?j.to(se.tooltip):se.tooltip,l.Command.is(se.command)&&(Ne.command=Ce.fromInternal(se.command)),se.location&&(Ne.location=ye.to(se.location)),Ne}Fe.to=Te})(le||(e.InlayHintLabelPart=le={}));var Re;(function(Fe){function Te(se){return se}Fe.from=Te;function Ce(se){return se}Fe.to=Ce})(Re||(e.InlayHintKind=Re={}));var je;(function(Fe){function Te(se){return{range:a.from(se.range),url:se.target,tooltip:se.tooltip}}Fe.from=Te;function Ce(se){let Ne;if(se.url)try{Ne=typeof se.url=="string"?v.URI.parse(se.url,!0):v.URI.revive(se.url)}catch{}return new r.$sL(a.to(se.range),Ne)}Fe.to=Ce})(je||(e.DocumentLink=je={}));var He;(function(Fe){function Te(se){const Ne=new r.$vL(se.label);return se.textEdit&&(Ne.textEdit=J.to(se.textEdit)),se.additionalTextEdits&&(Ne.additionalTextEdits=se.additionalTextEdits.map(qe=>J.to(qe))),Ne}Fe.to=Te;function Ce(se){return{label:se.label,textEdit:se.textEdit?J.from(se.textEdit):void 0,additionalTextEdits:se.additionalTextEdits?se.additionalTextEdits.map(Ne=>J.from(Ne)):void 0}}Fe.from=Ce})(He||(e.ColorPresentation=He={}));var Je;(function(Fe){function Te(se){return new r.$tL(se[0],se[1],se[2],se[3])}Fe.to=Te;function Ce(se){return[se.red,se.green,se.blue,se.alpha]}Fe.from=Ce})(Je||(e.Color=Je={}));var _e;(function(Fe){function Te(se){return{range:a.from(se.range)}}Fe.from=Te;function Ce(se){return new r.$cL(a.to(se.range))}Fe.to=Ce})(_e||(e.SelectionRange=_e={}));var ct;(function(Fe){function Te(Ce){switch(Ce){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Fe.to=Te})(ct||(e.TextDocumentSaveReason=ct={}));var ot;(function(Fe){function Te(se){switch(se){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Fe.from=Te;function Ce(se){switch(se){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Fe.to=Ce})(ot||(e.TextEditorLineNumbersStyle=ot={}));var rt;(function(Fe){function Te(se){if(se===r.EndOfLine.CRLF)return 1;if(se===r.EndOfLine.LF)return 0}Fe.from=Te;function Ce(se){if(se===1)return r.EndOfLine.CRLF;if(se===0)return r.EndOfLine.LF}Fe.to=Ce})(rt||(e.EndOfLine=rt={}));var Ae;(function(Fe){function Te(Ce){if(typeof Ce=="object")return Ce.viewId;switch(Ce){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Fe.from=Te})(Ae||(e.ProgressLocation=Ae={}));var Ue;(function(Fe){function Te(se){const Ne={start:se.start+1,end:se.end+1};return se.kind&&(Ne.kind=Le.from(se.kind)),Ne}Fe.from=Te;function Ce(se){const Ne={start:se.start-1,end:se.end-1};return se.kind&&(Ne.kind=Le.to(se.kind)),Ne}Fe.to=Ce})(Ue||(e.FoldingRange=Ue={}));var Le;(function(Fe){function Te(se){if(se)switch(se){case r.FoldingRangeKind.Comment:return l.$yt.Comment;case r.FoldingRangeKind.Imports:return l.$yt.Imports;case r.FoldingRangeKind.Region:return l.$yt.Region}}Fe.from=Te;function Ce(se){if(se)switch(se.value){case l.$yt.Comment.value:return r.FoldingRangeKind.Comment;case l.$yt.Imports.value:return r.FoldingRangeKind.Imports;case l.$yt.Region.value:return r.FoldingRangeKind.Region}}Fe.to=Ce})(Le||(e.FoldingRangeKind=Le={}));var Xe;(function(Fe){function Te(Ce){if(Ce)return{pinned:typeof Ce.preview=="boolean"?!Ce.preview:void 0,inactive:Ce.background,preserveFocus:Ce.preserveFocus,selection:typeof Ce.selection=="object"?a.from(Ce.selection):void 0,override:typeof Ce.override=="boolean"?i.$qE.id:void 0}}Fe.from=Te})(Xe||(e.TextEditorOpenOptions=Xe={}));var ne;(function(Fe){function Te(qe){return qe instanceof r.$PL?qe.toJSON():typeof qe=="string"?qe:Ce(qe)||se(qe)?new r.$PL(qe.baseUri??qe.base,qe.pattern).toJSON():qe}Fe.from=Te;function Ce(qe){const xe=qe;return xe?v.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function se(qe){const xe=qe;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Ne(qe){return typeof qe=="string"?qe:new r.$PL(v.URI.revive(qe.baseUri),qe.pattern)}Fe.to=Ne})(ne||(e.GlobPattern=ne={}));var ae;(function(Fe){function Te(Ce){if(Ce){if(Array.isArray(Ce))return Ce.map(Te);if(typeof Ce=="string")return Ce;{const se=Ce;return{language:se.language,scheme:se.scheme,pattern:ne.from(se.pattern),exclusive:se.exclusive,notebookType:se.notebookType}}}else return}Fe.from=Te})(ae||(e.LanguageSelector=ae={}));var Ie;(function(Fe){function Te(se){return!!se&&typeof se=="object"&&"documents"in se&&Array.isArray(se.documents)&&se.documents.every(Ne=>Array.isArray(Ne)&&Ne.every(qe=>qe&&typeof qe=="object"&&"uri"in qe&&v.URI.isUri(qe.uri)&&"version"in qe&&typeof qe.version=="number"&&"ranges"in qe&&Array.isArray(qe.ranges)&&qe.ranges.every(xe=>xe instanceof r.$UK)))}Fe.is=Te;function Ce(se){return{documents:se.documents.map(Ne=>Ne.map(qe=>({uri:v.URI.from(qe.uri),version:qe.version,ranges:qe.ranges.map(xe=>a.from(xe))})))}}Fe.from=Ce})(Ie||(e.MappedEditsContext=Ie={}));var Ve;(function(Fe){function Te(se){return{start:se.start,end:se.end}}Fe.from=Te;function Ce(se){return new r.$eM(se.start,se.end)}Fe.to=Ce})(Ve||(e.NotebookRange=Ve={}));var Ze;(function(Fe){function Te(se){return{timing:typeof se.runStartTime=="number"&&typeof se.runEndTime=="number"?{startTime:se.runStartTime,endTime:se.runEndTime}:void 0,executionOrder:se.executionOrder,success:se.lastRunSuccess}}Fe.to=Te;function Ce(se){return{lastRunSuccess:se.success,runStartTime:se.timing?.startTime,runEndTime:se.timing?.endTime,executionOrder:se.executionOrder}}Fe.from=Ce})(Ze||(e.NotebookCellExecutionSummary=Ze={}));var nt;(function(Fe){function Te(Ce){if(Ce===n.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(Ce===n.NotebookCellExecutionState.Pending)return;if(Ce===n.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ce}`)}Fe.to=Te})(nt||(e.NotebookCellExecutionState=nt={}));var it;(function(Fe){function Te(se){switch(se){case r.NotebookCellKind.Markup:return n.CellKind.Markup;case r.NotebookCellKind.Code:default:return n.CellKind.Code}}Fe.from=Te;function Ce(se){switch(se){case n.CellKind.Markup:return r.NotebookCellKind.Markup;case n.CellKind.Code:default:return r.NotebookCellKind.Code}}Fe.to=Ce})(it||(e.NotebookCellKind=it={}));var Oe;(function(Fe){function Te(se){const Ne={metadata:se.metadata??Object.create(null),cells:[]};for(const qe of se.cells)r.$fM.validate(qe),Ne.cells.push(wt.from(qe));return Ne}Fe.from=Te;function Ce(se){const Ne=new r.$gM(se.cells.map(wt.to));return(0,m.$Sf)(se.metadata)||(Ne.metadata=se.metadata),Ne}Fe.to=Ce})(Oe||(e.NotebookData=Oe={}));var wt;(function(Fe){function Te(se){return{cellKind:it.from(se.kind),language:se.languageId,mime:se.mime,source:se.value,metadata:se.metadata,internalMetadata:Ze.from(se.executionSummary??{}),outputs:se.outputs?se.outputs.map(Tt.from):[]}}Fe.from=Te;function Ce(se){return new r.$fM(it.to(se.cellKind),se.source,se.language,se.mime,se.outputs?se.outputs.map(Tt.to):void 0,se.metadata,se.internalMetadata?Ze.to(se.internalMetadata):void 0)}Fe.to=Ce})(wt||(e.NotebookCellData=wt={}));var kt;(function(Fe){function Te(se){return{mime:se.mime,valueBytes:N.$ge.wrap(se.data)}}Fe.from=Te;function Ce(se){return new r.$hM(se.valueBytes.buffer,se.mime)}Fe.to=Ce})(kt||(e.NotebookCellOutputItem=kt={}));var Tt;(function(Fe){function Te(se){return{outputId:se.id,items:se.items.map(kt.from),metadata:se.metadata}}Fe.from=Te;function Ce(se){const Ne=se.items.map(kt.to);return new r.$iM(Ne,se.outputId,se.metadata)}Fe.to=Ce})(Tt||(e.NotebookCellOutput=Tt={}));var Wt;(function(Fe){function Te(Ne){return se(Ne)?{include:ne.from(Ne.include)??void 0,exclude:ne.from(Ne.exclude)??void 0}:ne.from(Ne)??void 0}Fe.from=Te;function Ce(Ne){return se(Ne)?{include:ne.to(Ne.include),exclude:ne.to(Ne.exclude)}:ne.to(Ne)}Fe.to=Ce;function se(Ne){const qe=Ne;return qe?!(0,m.$Of)(qe.include)&&!(0,m.$Of)(qe.exclude):!1}})(Wt||(e.NotebookExclusiveDocumentPattern=Wt={}));var Et;(function(Fe){function Te(Ce,se,Ne){const qe=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{alignment:Ce.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:se.toInternal(qe,Ne),text:Ce.text,tooltip:Ce.tooltip,accessibilityInformation:Ce.accessibilityInformation,priority:Ce.priority}}Fe.from=Te})(Et||(e.NotebookStatusBarItem=Et={}));var Kt;(function(Fe){function Te(Ce,se,Ne){const qe=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{command:se.toInternal(qe,Ne),label:Ce.label,description:Ce.description,detail:Ce.detail,documentation:Ce.documentation}}Fe.from=Te})(Kt||(e.NotebookKernelSourceAction=Kt={}));var Ot;(function(Fe){function Te(Ce){return{transientOutputs:Ce?.transientOutputs??!1,transientCellMetadata:Ce?.transientCellMetadata??{},transientDocumentMetadata:Ce?.transientDocumentMetadata??{},cellContentMetadata:Ce?.cellContentMetadata??{}}}Fe.from=Te})(Ot||(e.NotebookDocumentContentOptions=Ot={}));var Zt;(function(Fe){function Te(se){return{uri:se.uri,provides:se.provides}}Fe.from=Te;function Ce(se){return new r.$kM(v.URI.revive(se.uri),se.provides)}Fe.to=Ce})(Zt||(e.NotebookRendererScript=Zt={}));var Ut;(function(Fe){function Te(se){return{message:j.fromStrict(se.message)||"",type:0,expected:se.expectedOutput,actual:se.actualOutput,contextValue:se.contextValue,location:se.location&&{range:a.from(se.location.range),uri:se.location.uri}}}Fe.from=Te;function Ce(se){const Ne=new r.$qM(typeof se.message=="string"?se.message:j.to(se.message));return Ne.actualOutput=se.actual,Ne.expectedOutput=se.expected,Ne.contextValue=se.contextValue,Ne.location=se.location?ye.to(se.location):void 0,Ne}Fe.to=Ce})(Ut||(e.TestMessage=Ut={}));var Lt;(function(Fe){Fe.namespace=c.$MJ,Fe.denamespace=c.$NJ})(Lt||(e.TestTag=Lt={}));var et;(function(Fe){function Te(se){const Ne=(0,s.$QM)(se).controllerId;return{extId:o.$IJ.fromExtHostTestItem(se,Ne).toString(),label:se.label,uri:v.URI.revive(se.uri),busy:se.busy,tags:se.tags.map(qe=>Lt.namespace(Ne,qe.id)),range:k.$Is.lift(a.from(se.range)),description:se.description||null,sortText:se.sortText||null,error:se.error&&j.fromStrict(se.error)||null}}Fe.from=Te;function Ce(se){return{parent:void 0,error:void 0,id:o.$IJ.fromString(se.extId).localId,label:se.label,uri:v.URI.revive(se.uri),tags:(se.tags||[]).map(Ne=>{const{tagId:qe}=Lt.denamespace(Ne);return new r.$rM(qe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:a.to(se.range||void 0),canResolveChildren:!1,busy:se.busy,description:se.description||void 0,sortText:se.sortText||void 0}}Fe.toPlain=Ce})(et||(e.TestItem=et={})),function(Fe){function Te(se){return{id:se.id}}Fe.from=Te;function Ce(se){return new r.$rM(se.id)}Fe.to=Ce}(Lt||(e.TestTag=Lt={}));var Gt;(function(Fe){const Te=(se,Ne)=>{const qe=[];for(const[Ke,st]of Ne)o.$IJ.compare(st.item.extId,Ke)===2&&(Ne.delete(Ke),qe.push(st));const xe={...et.toPlain(se.item),parent:void 0,taskStates:se.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(st=>st.type===0).map(Ut.to)})),children:qe.map(Ke=>Te(Ke,Ne))};for(const Ke of xe.children)Ke.parent=xe;return xe};function Ce(se){const Ne=[],qe=new Map;for(const xe of se.items){qe.set(xe.item.extId,xe);const Ke=o.$IJ.root(xe.item.extId);se.request.targets.some(st=>st.controllerId===Ke&&st.testIds.includes(xe.item.extId))&&Ne.push(xe)}return{completedAt:se.completedAt,results:Ne.map(xe=>Te(xe,qe))}}Fe.to=Ce})(Gt||(e.TestResults=Gt={}));var Jt;(function(Fe){function Te(qe){return{covered:qe.covered,total:qe.total}}function Ce(qe){return"line"in qe?S.from(qe):a.from(qe)}function se(qe){return"branches"in qe?{count:qe.executionCount,location:Ce(qe.location),type:1,branches:qe.branches.length?qe.branches.map(xe=>({count:xe.executionCount,location:xe.location&&Ce(xe.location)})):void 0}:{type:0,name:qe.name,count:qe.executionCount,location:Ce(qe.location)}}Fe.fromDetailed=se;function Ne(qe){return{uri:qe.uri,statement:Te(qe.statementCoverage),branch:qe.branchCoverage&&Te(qe.branchCoverage),function:qe.functionCoverage&&Te(qe.functionCoverage),details:qe.detailedCoverage?.map(se)}}Fe.fromFile=Ne})(Jt||(e.TestCoverage=Jt={}));var ht;(function(Fe){function Te(Ce){switch(Ce){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Fe.to=Te})(ht||(e.CodeActionTriggerKind=ht={}));var bt;(function(Fe){function Te(se){const Ne=new r.$xM(he.to(se.kind),se.name,se.detail||"",v.URI.revive(se.uri),a.to(se.range),a.to(se.selectionRange));return Ne._sessionId=se._sessionId,Ne._itemId=se._itemId,Ne}Fe.to=Te;function Ce(se,Ne,qe){if(Ne=Ne??se._sessionId,qe=qe??se._itemId,Ne===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:qe,kind:he.from(se.kind),name:se.name,detail:se.detail??"",uri:se.uri,range:a.from(se.range),selectionRange:a.from(se.selectionRange),tags:se.tags?.map(Z.from)}}Fe.from=Ce})(bt||(e.TypeHierarchyItem=bt={}));var zt;(function(Fe){function Te(Ce){if(Ce)return{value:Ce.value,tooltip:Ce.tooltip}}Fe.from=Te})(zt||(e.ViewBadge=zt={}));var qt;(function(Fe){function Te(qe,xe,Ke){const st=xe.fileData;return st?new r.$IL(new r.$JL(st.name,v.URI.revive(st.uri),st.id,(0,I.$db)(()=>Ke(st.id)))):qe===A.$5r.uriList&&xe.uriListData?new r.$HL(Ne(xe.uriListData)):new r.$HL(xe.asString)}Fe.to=Te;async function Ce(qe,xe){const Ke=await xe.asString();if(qe===A.$5r.uriList)return{asString:Ke,fileData:void 0,uriListData:se(Ke)};const st=xe.asFile();return{asString:Ke,fileData:st?{name:st.name,uri:st.uri,id:st._itemId??st.id}:void 0}}Fe.from=Ce;function se(qe){return g.$ft.split(qe).map(xe=>{if(xe.startsWith("#"))return xe;try{return v.URI.parse(xe)}catch{}return xe})}function Ne(qe){return g.$ft.create(qe.map(xe=>typeof xe=="string"?xe:v.URI.revive(xe)))}})(qt||(e.DataTransferItem=qt={}));var Dt;(function(Fe){function Te(se,Ne){const qe=se.items.map(([xe,Ke])=>[xe,qt.to(xe,Ke,Ne)]);return new r.$KL(qe)}Fe.toDataTransfer=Te;async function Ce(se){const Ne={items:[]},qe=[];for(const[xe,Ke]of se)qe.push((async()=>{Ne.items.push([xe,await qt.from(xe,Ke)])})());return await Promise.all(qe),Ne}Fe.from=Ce})(Dt||(e.DataTransfer=Dt={}));var ft;(function(Fe){function Te(Ce){return{kind:"reply",message:Ce.message,title:Ce.title,tooltip:Ce.tooltip}}Fe.from=Te})(ft||(e.ChatReplyFollowup=ft={}));var At;(function(Fe){function Te(Ce){return typeof Ce=="string"?{title:Ce,message:Ce,kind:"reply"}:"commandId"in Ce?{kind:"command",title:Ce.title??"",commandId:Ce.commandId??"",when:Ce.when??"",args:Ce.args}:ft.from(Ce)}Fe.from=Te})(At||(e.ChatFollowup=At={}));var xt;(function(Fe){function Te(se){const Ne=new r.$JM(Ct.to(se.role),se.content);return Ne.name=se.name,Ne}Fe.to=Te;function Ce(se){return{role:Ct.from(se.role),content:se.content,name:se.name}}Fe.from=Ce})(xt||(e.ChatMessage=xt={}));var Ct;(function(Fe){function Te(se){switch(se){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Fe.to=Te;function Ce(se){switch(se){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Fe.from=Ce})(Ct||(e.ChatMessageRole=Ct={}));var Qe;(function(Fe){function Te(Ne){const qe={};for(const xe of Object.keys(Ne))qe[xe]=Ne[xe].map(Fe.to);return qe}Fe.objectTo=Te;function Ce(Ne){return{level:Mt.to(Ne.level),kind:Ne.kind,value:(0,y.$zh)(Ne.value),description:Ne.description}}Fe.to=Ce;function se(Ne){return{level:Mt.from(Ne.level),kind:Ne.kind,value:Ne.value,description:Ne.description}}Fe.from=se})(Qe||(e.ChatVariable=Qe={}));var Mt;(function(Fe){function Te(se){switch(se){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Fe.to=Te;function Ce(se){switch(se){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Fe.from=Ce})(Mt||(e.ChatVariableLevel=Mt={}));var Vt;(function(Fe){function Te(Ce){switch(Ce){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return r.InteractiveEditorResponseFeedbackKind.Bug}}Fe.to=Te})(Vt||(e.InteractiveEditorResponseFeedbackKind=Vt={}));var Qt;(function(Fe){function Te(Ce,se){return"placeholder"in se&&"resolvedContent"in se?{content:se.placeholder,kind:"asyncContent"}:"markdownContent"in se?((0,d.$pF)(Ce,"chatAgents2Additions"),{content:j.from(se.markdownContent),kind:"markdownContent"}):"content"in se?"vulnerabilities"in se&&se.vulnerabilities?((0,d.$pF)(Ce,"chatAgents2Additions"),{content:se.content,vulnerabilities:se.vulnerabilities,kind:"vulnerability"}):typeof se.content=="string"?{content:se.content,kind:"content"}:((0,d.$pF)(Ce,"chatAgents2Additions"),{content:j.from(se.content),kind:"markdownContent"}):"documents"in se?{documents:se.documents.map(Ne=>({uri:Ne.uri,version:Ne.version,ranges:Ne.ranges.map(qe=>a.from(qe))})),kind:"usedContext"}:"reference"in se?{reference:"uri"in se.reference?{uri:se.reference.uri,range:a.from(se.reference.range)}:se.reference,kind:"reference"}:"inlineReference"in se?{inlineReference:"uri"in se.inlineReference?{uri:se.inlineReference.uri,range:a.from(se.inlineReference.range)}:se.inlineReference,name:se.title,kind:"inlineReference"}:"agentName"in se?((0,d.$pF)(Ce,"chatAgents2Additions"),{agentName:se.agentName,command:se.command,kind:"agentDetection"}):"treeData"in se?{treeData:se.treeData,kind:"treeData"}:"message"in se?{content:se.message,kind:"progressMessage"}:void 0}Fe.from=Te})(Qt||(e.ChatResponseProgress=Qt={}));var gt;(function(Fe){function Te(Ce){return{label:Ce.label,values:Ce.values.map(Qe.from),insertText:Ce.insertText,detail:Ce.detail,documentation:Ce.documentation}}Fe.from=Te})(gt||(e.ChatAgentCompletionItem=gt={}));var Nt;(function(Fe){function Te(Ce,se,Ne){return"terminalCommand"in Ce?{terminalCommand:Ce.terminalCommand,shouldExecute:Ce.shouldExecute}:"uri"in Ce?{uri:Ce.uri}:se.toInternal(Ce,Ne)}Fe.from=Te})(Nt||(e.TerminalQuickFix=Nt={}))}),define(Se[294],ke([1,0,2,14,7,15,75]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0;class b{constructor(y,A,C,m={timeout:1500,errors:3}){this.c=y,this.d=A,this.f=C,this.g=m,this.a=new R.$3c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(y){return(A,C,m)=>{const k={dispose:this.a.push([A,C,y])};return Array.isArray(m)&&m.push(k),k}}async $participateInSave(y,A){const C=D.URI.revive(y);let m=!1;const v=setTimeout(()=>m=!0,this.g.timeout),k=[];try{for(const l of[...this.a]){if(m)break;const f=this.d.getDocument(C),s=await this.h(l,{document:f,reason:I.TextDocumentSaveReason.to(A)});k.push(s)}}finally{clearTimeout(v)}return k}h([y,A,C],m){const v=this.b.get(y);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(C,y,A,m).then(()=>!0,k=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this.c.error(k),!(k instanceof Error)||k.message!=="concurrent_edits"){const l=this.b.get(y);this.b.set(y,l?l+1:1),typeof l=="number"&&l>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(y,A,C,m){const v=[],k=Date.now(),{document:l,reason:f}=m,{version:s}=l,i=Object.freeze({document:l,reason:f,waitUntil(n){if(Object.isFrozen(v))throw(0,N.$8)("waitUntil can not be called async");v.push(Promise.resolve(n))}});try{A.apply(C,[i])}catch(n){return Promise.reject(n)}return Object.freeze(v),new Promise((n,o)=>{const c=setTimeout(()=>o(new Error("timeout")),this.g.timeout);return Promise.all(v).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' finished after ${Date.now()-k}ms`),clearTimeout(c),n(t)}).catch(t=>{clearTimeout(c),o(t)})}).then(n=>{const o={edits:[]};for(const c of n)if(Array.isArray(c)&&c.every(t=>t instanceof g.$ZK))for(const{newText:t,newEol:r,range:d}of c)o.edits.push({resource:l.uri,versionId:void 0,textEdit:{range:d&&I.Range.from(d),text:t,eol:r&&I.EndOfLine.from(r)}});if(o.edits.length!==0)return s===l.version?this.f.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.$sgc=b}),define(Se[295],ke([1,0,17,2,15,7,111]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ygc=e.$xgc=void 0;class b{constructor(C,m,v,k){this.start=C,this.deletedCount=m,this.deletedItems=v,this.items=k}asApiEvent(){return{range:new I.$eM(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(C,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:C}}constructor(C,m,v){this.notebook=C,this.h=m,this.j=v,this.handle=v.handle,this.uri=N.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(g.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(g.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const C=this,m=this.h.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:g.NotebookCellKind.to(this.j.cellKind),document:m.document,get mime(){return C.g},set mime(k){C.g=k},get outputs(){return C.a.slice(0)},get metadata(){return C.b},get executionSummary(){return C.d}};this.f=Object.freeze(v)}return this.f}setOutputs(C){this.a=C.map(g.NotebookCellOutput.to)}setOutputItems(C,m,v){const k=v.map(g.NotebookCellOutputItem.to),l=this.a.find(f=>f.id===C);if(l&&(m||(l.items.length=0),l.items.push(...k),l.items.length>1&&l.items.every(f=>R.$UI(f.mime)))){const f=new Map,s=[];l.items.forEach(i=>{let n;f.has(i.mime)?n=f.get(i.mime):(n=[],f.set(i.mime,n),s.push(i.mime)),n.push(i.data)}),l.items.length=0,s.forEach(i=>{const n=R.$VI(f.get(i));l.items.push({mime:i,data:n.data.buffer})})}}setMetadata(C){this.b=Object.freeze(C)}setInternalMetadata(C){this.e=C,this.d=Object.freeze(g.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.$xgc=$;class y{static{this.a=0}constructor(C,m,v,k,l){this.k=C,this.l=m,this.m=v,this.uri=k,this.handle=y.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=l.viewType,this.f=Object.freeze(l.metadata??Object.create(null)),this.r([[0,0,l.cells]],!0,void 0),this.g=l.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const C=this,m={get uri(){return C.uri},get version(){return C.g},get notebookType(){return C.d},get isDirty(){return C.h},get isUntitled(){return C.uri.scheme===D.Schemas.untitled},get isClosed(){return C.j},get metadata(){return C.f},get cellCount(){return C.b.length},cellAt(v){return v=C.n(v),C.b[v].apiCell},getCells(v){return(v?C.p(v):C.b).map(l=>l.apiCell)},save(){return C.q()}};this.e=Object.freeze(m)}return this.e}acceptDocumentPropertiesChanged(C){C.metadata&&(this.f=Object.freeze({...this.f,...C.metadata}))}acceptDirty(C){this.h=C}acceptModelChanged(C,m,v){this.g=C.versionId,this.h=m,this.acceptDocumentPropertiesChanged({metadata:v});const k={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},l=[];for(const s of C.rawEvents)s.kind===R.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,k.contentChanges):s.kind===R.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,k.contentChanges):s.kind===R.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),l.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),l.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),l.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===R.NotebookCellsChangeType.ChangeCellContent?l.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),l.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),l.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const f=new Map;for(let s=0;s<l.length;s++){const i=l[s],n=f.get(i.cell);if(n===void 0){const o=k.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});f.set(i.cell,o-1)}else k.cellChanges[n]={...k.cellChanges[n],...i}}return Object.freeze(k),Object.freeze(k.cellChanges),Object.freeze(k.contentChanges),k}n(C){return C=C|0,C<0?0:C>=this.b.length?this.b.length-1:C}o(C){let m=C.start|0,v=C.end|0;return m<0&&(m=0),v>this.b.length&&(v=this.b.length),C.with({start:m,end:v})}p(C){C=this.o(C);const m=[];for(let v=C.start;v<C.end;v++)m.push(this.b[v]);return m}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(C,m,v){if(this.j)return;const k=[],l=[],f=[];if(C.reverse().forEach(s=>{const n=s[2].map(t=>{const r=new $(this,this.l,t);return m||l.push($.asModelAddData(this.apiNotebook,t)),r}),o=new b(s[0],s[1],[],n),c=this.b.splice(s[0],s[1],...n);for(const t of c)f.push(t.uri),o.deletedItems.push(t.apiCell);k.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:f}),v)for(const s of k)v.push(s.asApiEvent())}s(C,m,v,k){const l=this.b.splice(C,m);this.b.splice(v,0,...l);const f=[new b(C,m,l.map(s=>s.apiCell),[]),new b(v,0,[],l)];for(const s of f)k.push(s.asApiEvent())}t(C,m){this.b[C].setOutputs(m)}u(C,m,v,k){this.b[C].setOutputItems(m,v,k)}v(C,m){const v=this.b[C];v.apiCell.document.languageId!==m&&this.m.$acceptModelLanguageChanged(v.uri,m)}w(C,m){const v=this.b[C];v.apiCell.mime=m}x(C,m){this.b[C].setMetadata(m)}y(C,m){this.b[C].setInternalMetadata(m)}getCellFromApiCell(C){return this.b.find(m=>m.apiCell===C)}getCellFromIndex(C){return this.b[C]}getCell(C){return this.b.find(m=>m.handle===C)}getCellIndex(C){return this.b.indexOf(C)}}e.$ygc=y}),define(Se[296],ke([1,0,4,2,15,7]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=void 0;class R{constructor($,y,A,C={timeout:1500,errors:3}){this.b=$,this.c=y,this.d=A,this.f=C,this.a=new D.$Ud}dispose(){}getOnWillSaveNotebookDocumentEvent($){return(y,A,C)=>{const m=function(k){y.call(A,k)};return m.extension=$,this.a.event(m,void 0,C)}}async $participateInSave($,y,A){const C=N.URI.revive($),m=this.c.getNotebookDocument(C);if(!m)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:m.apiNotebook,reason:g.TextDocumentSaveReason.to(y)},A,async(l,f)=>{const s=Date.now(),i=await await Promise.resolve(l);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier),!A.isCancellationRequested&&i&&(i instanceof I.$3K?v.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(v.length===0)return!0;const k={edits:[]};for(const l of v){const{edits:f}=g.WorkspaceEdit.from(l);k.edits=k.edits.concat(f)}return this.d.$tryApplyWorkspaceEdit(k)}}e.$Ogc=R}),define(Se[146],ke([1,0,14,15,7]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=void 0;class I{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,$,y,A,C,m){this.id=b,this.f=$,this.notebookData=y,this.a=[],this.b=[],this.d=!1,this.a=C,this.b=A,this.c=m}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection($){this.selections=[$]},get selections(){return b.a},set selections($){if(!Array.isArray($)||!$.every(g.$eM.isNotebookRange))throw(0,D.$7)("selections");b.a=$,b.g($)},get visibleRanges(){return b.b},revealRange($,y){b.f.$tryRevealRange(b.id,N.NotebookRange.from($),y??g.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},I.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(N.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$zgc=I}),define(Se[297],ke([1,0,4,13,15]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=void 0;let I=class{constructor(b,$){this.c=b,this.d=$,this.a=new D.$Sd,this.b=new D.$Sd,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(b,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,$);const y=this.d.getEditorById(b);$.visibleRanges&&y._acceptVisibleRanges($.visibleRanges.ranges.map(g.NotebookRange.to)),$.selections&&y._acceptSelections($.selections.selections.map(g.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:y.apiEditor,visibleRanges:y.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:y.apiEditor,selections:y.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const $ in b)this.d.getEditorById($)._acceptViewColumn(g.ViewColumn.to(b[$]))}};e.$Qgc=I,e.$Qgc=I=Ge([We(0,N.$kj)],I)}),define(Se[298],ke([1,0,15,85,216,21,52,14]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=void 0;class ${constructor(m){this.b=0,this.c=new Map,this.a=m}async withProgress(m,v,k){const l=this.b++,{title:f,location:s,cancellable:i}=v,n={label:(0,g.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this.a.$startProgress(l,{location:D.ProgressLocation.from(s),title:f,source:n,cancellable:i},m.isUnderDevelopment?void 0:m.identifier.value).catch(b.$2),this.d(l,k,!!i)}d(m,v,k){let l;k&&(l=new I.$3d,this.c.set(m,l));const f=i=>{this.a.$progressEnd(i),this.c.delete(i),l?.dispose()};let s;try{s=v(new A(this.a,m),k&&l?l.token:I.CancellationToken.None)}catch(i){throw f(m),i}return s.then(i=>f(m),i=>f(m)),s}$acceptProgressCanceled(m){const v=this.c.get(m);v&&(v.cancel(),this.c.delete(m))}}e.$Xgc=$;function y(C,m){return C.message=m.message,typeof m.increment=="number"&&(typeof C.increment=="number"?C.increment+=m.increment:C.increment=m.increment),C}class A extends N.$iv{constructor(m,v){super(k=>this.throttledReport(k)),this.c=m,this.d=v}throttledReport(m){this.c.$progressReport(this.d,m)}}Ge([(0,R.$wh)(100,(C,m)=>y(C,m),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(Se[147],ke([1,0,29,142,67,112,89,15,2]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0M=e.$9M=e.$8M=e.$7M=void 0;const y=(n,o,c,t)=>{let r=o;return{enumerable:!0,configurable:!1,get(){return r},set(d){if(!c(r,d)){const u=r;r=d,n.listener?.(t(d,u))}}}},A=(n,o)=>n===o,C={range:(n,o)=>n===o?!0:!n||!o?!1:n.isEqual(o),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(n,o)=>!(n.length!==o.length||n.some(c=>!o.find(t=>c.id===t.id)))},m=n=>o=>({op:4,update:n(o)}),v=(n,o)=>({range:(()=>{let c;const t=m(r=>({range:D.$Is.lift(b.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return c},set(r){n.listener?.({op:6}),C.range(c,r)||(c=r,n.listener?.(t(r)))}}})(),label:y(n,o,C.label,m(c=>({label:c}))),description:y(n,void 0,C.description,m(c=>({description:c}))),sortText:y(n,void 0,C.sortText,m(c=>({sortText:c}))),canResolveChildren:y(n,!1,C.canResolveChildren,c=>({op:2,state:c})),busy:y(n,!1,C.busy,m(c=>({busy:c}))),error:y(n,void 0,C.error,m(c=>({error:b.MarkdownString.fromStrict(c)||null}))),tags:y(n,[],C.tags,(c,t)=>({op:1,new:c.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),k=n=>{const o=g.$IJ.fromString(n.extId),c=new f(o.controllerId,o.localId,n.label,$.URI.revive(n.uri)||void 0);return c.range=b.Range.to(n.range||void 0),c.description=n.description||void 0,c.sortText=n.sortText||void 0,c.tags=n.tags.map(t=>b.TestTag.to({id:(0,R.$NJ)(t).tagId})),c},l=n=>{let o;for(const c of n.tests){const t=k(c.item);(0,N.$QM)(t).parent=o,o=t}return o};e.$7M=l;class f{constructor(o,c,t,r){if(c.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(c)} symbol`);const d=(0,N.$PM)(this,o);Object.defineProperties(this,{id:{value:c,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof s?void 0:d.parent}},children:{value:(0,I.$OM)(d,N.$QM,f),enumerable:!0,writable:!1},...v(d,t)})}}e.$8M=f;class s extends f{constructor(o,c){super(o,o,c,void 0),this._isRoot=!0}}e.$9M=s;class i extends I.$KM{constructor(o,c,t){super({controllerId:o,getDocumentVersion:r=>r&&t.getDocument(r)?.version,getApiFor:N.$QM,getChildren:r=>r.children,root:new s(o,c),toITestItem:b.TestItem.from})}}e.$0M=i}),define(Se[148],ke([1,0,60,14,121,15,7]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=e.$3M=e.$2M=void 0;class b{static{this.c=new g.$ZM("TextEditorDecorationType")}constructor(m,v,k){const l=b.c.nextId();m.$registerTextEditorDecorationType(v.identifier,l,I.DecorationRenderOptions.from(k)),this.value=Object.freeze({key:l,dispose(){m.$removeTextEditorDecorationType(l)}})}}e.$2M=b;class ${constructor(m,v){this.g=[],this.h=void 0,this.j=!1,this.c=m,this.d=m.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(m,v){this.k();let k=null;if(m instanceof R.$TK)k=new R.$UK(m,m);else if(m instanceof R.$UK)k=m;else throw new Error("Unrecognized location");this.l(k,v,!1)}insert(m,v){this.k(),this.l(new R.$UK(m,m),v,!0)}delete(m){this.k();let v=null;if(m instanceof R.$UK)v=m;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(m,v,k){const l=this.c.validateRange(m);this.g.push({range:l,text:v,forceMoveMarkers:k})}setEndOfLine(m){if(this.k(),m!==R.EndOfLine.LF&&m!==R.EndOfLine.CRLF)throw(0,N.$7)("endOfLine");this.h=m}}class y{constructor(m,v,k,l){this.c=m,this.d=v,this._accept(k),this.e=l;const f=this;this.value={get tabSize(){return f.f},set tabSize(s){f.n(s)},get indentSize(){return f.g},set indentSize(s){f.p(s)},get insertSpaces(){return f.j},set insertSpaces(s){f.s(s)},get cursorStyle(){return f.k},set cursorStyle(s){f.t(s)},get lineNumbers(){return f.l},set lineNumbers(s){f.u(s)}}}_accept(m){this.f=m.tabSize,this.g=m.indentSize,this.h=m.originalIndentSize,this.j=m.insertSpaces,this.k=m.cursorStyle,this.l=I.TextEditorLineNumbersStyle.to(m.lineNumbers)}m(m){if(m==="auto")return"auto";if(typeof m=="number"){const v=Math.floor(m);return v>0?v:null}if(typeof m=="string"){const v=parseInt(m,10);return isNaN(v)?null:v>0?v:null}return null}n(m){const v=this.m(m);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}o(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const v=Math.floor(m);return v>0?v:null}if(typeof m=="string"){const v=parseInt(m,10);return isNaN(v)?null:v>0?v:null}return null}p(m){const v=this.o(m);if(v!==null){if(typeof v=="number"){if(this.h===v)return;this.g=v,this.h=v}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}q(m){return m==="auto"?"auto":m==="false"?!1:!!m}s(m){const v=this.q(m);if(typeof v=="boolean"){if(this.j===v)return;this.j=v}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}t(m){this.k!==m&&(this.k=m,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:m})))}u(m){this.l!==m&&(this.l=m,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:I.TextEditorLineNumbersStyle.from(m)})))}assign(m){const v={};let k=!1;if(typeof m.tabSize<"u"){const l=this.m(m.tabSize);l==="auto"?(k=!0,v.tabSize=l):typeof l=="number"&&this.f!==l&&(this.f=l,k=!0,v.tabSize=l)}if(typeof m.indentSize<"u"){const l=this.o(m.indentSize);l==="tabSize"?(k=!0,v.indentSize=l):typeof l=="number"&&this.h!==l&&(this.g=l,this.h=l,k=!0,v.indentSize=l)}if(typeof m.insertSpaces<"u"){const l=this.q(m.insertSpaces);l==="auto"?(k=!0,v.insertSpaces=l):this.j!==l&&(this.j=l,k=!0,v.insertSpaces=l)}typeof m.cursorStyle<"u"&&this.k!==m.cursorStyle&&(this.k=m.cursorStyle,k=!0,v.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this.l!==m.lineNumbers&&(this.l=m.lineNumbers,k=!0,v.lineNumbers=I.TextEditorLineNumbersStyle.from(m.lineNumbers)),k&&this.v("setOptions",this.c.$trySetOptions(this.d,v))}v(m,v){v.catch(k=>{this.e.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this.e.warn(k)})}}e.$3M=y;class A{constructor(m,v,k,l,f,s,i,n){this.id=m,this.j=v,this.k=k,this.g=!1,this.h=new Set,this.c=f,this.d=new y(this.j,this.id,s,k),this.e=i,this.f=n;const o=this;this.value=Object.freeze({get document(){return l.value},set document(c){throw new N.$9("document")},get selection(){return o.c&&o.c[0]},set selection(c){if(!(c instanceof R.$VK))throw(0,N.$7)("selection");o.c=[c],o.l()},get selections(){return o.c},set selections(c){if(!Array.isArray(c)||c.some(t=>!(t instanceof R.$VK)))throw(0,N.$7)("selections");o.c=c,o.l()},get visibleRanges(){return o.e},set visibleRanges(c){throw new N.$9("visibleRanges")},get options(){return o.d.value},set options(c){o.g||o.d.assign(c)},get viewColumn(){return o.f},set viewColumn(c){throw new N.$9("viewColumn")},edit(c,t={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new $(l.value,t);return c(r),o.m(r)},insertSnippet(c,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!t||Array.isArray(t)&&t.length===0)d=o.c.map(u=>I.Range.from(u));else if(t instanceof R.$TK){const{lineNumber:u,column:a}=I.Position.from(t);d=[{startLineNumber:u,startColumn:a,endLineNumber:u,endColumn:a}]}else if(t instanceof R.$UK)d=[I.Range.from(t)];else{d=[];for(const u of t)if(u instanceof R.$UK)d.push(I.Range.from(u));else{const{lineNumber:a,column:h}=I.Position.from(u);d.push({startLineNumber:a,startColumn:h,endLineNumber:a,endColumn:h})}}return v.$tryInsertSnippet(m,l.value.version,c.value,d,r)},setDecorations(c,t){const r=t.length===0;r&&!o.h.has(c.key)||(r?o.h.delete(c.key):o.h.add(c.key),o.n(()=>{if(I.$RM(t))return v.$trySetDecorations(m,c.key,I.$SM(t));{const d=new Array(4*t.length);for(let u=0,a=t.length;u<a;u++){const h=t[u];d[4*u]=h.start.line+1,d[4*u+1]=h.start.character+1,d[4*u+2]=h.end.line+1,d[4*u+3]=h.end.character+1}return v.$trySetDecorationsFast(m,c.key,d)}}))},revealRange(c,t){o.n(()=>v.$tryRevealRange(m,I.Range.from(c),t||R.TextEditorRevealType.Default))},show(c){v.$tryShowEditor(m,I.ViewColumn.from(c))},hide(){v.$tryHideEditor(m)}})}dispose(){(0,D.ok)(!this.g),this.g=!0}_acceptOptions(m){(0,D.ok)(!this.g),this.d._accept(m)}_acceptVisibleRanges(m){(0,D.ok)(!this.g),this.e=m}_acceptViewColumn(m){(0,D.ok)(!this.g),this.f=m}_acceptSelections(m){(0,D.ok)(!this.g),this.c=m}async l(){const m=this.c.map(I.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,m)),this.value}m(m){const v=m.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const k=v.edits.map(f=>f.range);k.sort((f,s)=>f.end.line===s.end.line?f.end.character===s.end.character?f.start.line===s.start.line?f.start.character-s.start.character:f.start.line-s.start.line:f.end.character-s.end.character:f.end.line-s.end.line);for(let f=0,s=k.length-1;f<s;f++){const i=k[f].end;if(k[f+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=v.edits.map(f=>({range:I.Range.from(f.range),text:f.text,forceMoveMarkers:f.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,l,{setEndOfLine:typeof v.setEndOfLine=="number"?I.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(m){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.$4M=A}),define(Se[299],ke([1,0,220,23,2,4,3,279,11,7,18,19,15,80,21,177,25]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=void 0;function s(o,c){if((0,A.$Ff)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let t;return Array.isArray(o.highlights)&&(t=o.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),t=t.length?t:void 0),{label:o.label,highlights:t}}}class i extends R.$Sc{constructor(c,t,r){super(),this.f=c,this.g=t,this.h=r,this.a=new Map,this.b=new l.$a8;function d(u){return u&&u.$treeViewId&&(u.$treeItemHandle||u.$selectedTreeItems||u.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:u=>d(u)?this.r(u):Array.isArray(u)&&u.length>0?u.map(a=>d(a)?this.r(a):a):u})}registerTreeDataProvider(c,t,r){const d=this.createTreeView(c,{treeDataProvider:t},r);return{dispose:()=>d.dispose()}}createTreeView(c,t,r){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=t.dragAndDropController?.dropMimeTypes??[],u=t.dragAndDropController?.dragMimeTypes??[],a=!!t.dragAndDropController?.handleDrag,h=!!t.dragAndDropController?.handleDrop,S=this.m(c,t,r),P={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:d,dragMimeTypes:u,hasHandleDrag:a,hasHandleDrop:h,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},w=this.f.$registerTreeViewDataProvider(c,P),p={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,f.$pF)(r,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,f.$pF)(r,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(E){(0,v.$gk)(E)&&(0,f.$pF)(r,"treeViewMarkdownMessage"),S.message=E},get title(){return S.title},set title(E){S.title=E},get description(){return S.description},set description(E){S.description=E},get badge(){return S.badge},set badge(E){E!==void 0&&y.ViewBadge.isViewBadge(E)?S.badge={value:Math.floor(Math.abs(E.value)),tooltip:E.tooltip}:E===void 0&&(S.badge=void 0)},reveal:(E,L)=>S.reveal(E,L),dispose:async()=>{await w,this.a.delete(c),S.dispose()}};return this.B(p),p}$getChildren(c,t){const r=this.a.get(c);return r?r.getChildren(t):Promise.reject(new b.$ZE(c))}async $handleDrop(c,t,r,d,u,a,h,S){const P=this.a.get(c);if(!P)return Promise.reject(new b.$ZE(c));const w=m.DataTransfer.toDataTransfer(r,async p=>(await this.f.$resolveDropFileData(c,t,p)).buffer);return h===c&&S&&await this.j(w,P,S,u,a),P.onDrop(w,d,u)}async j(c,t,r,d,u){const a=this.b.removeDragOperationTransfer(u);if(a)(await a)?.forEach((h,S)=>{h&&c.set(S,h)});else if(u&&t.handleDrag){const h=t.handleDrag(r,c,d);this.b.addDragOperationTransfer(u,h),await h}return c}async $handleDrag(c,t,r,d){const u=this.a.get(c);if(!u)return Promise.reject(new b.$ZE(c));const a=await this.j(new y.$KL,u,t,d,r);if(!(!a||d.isCancellationRequested))return m.DataTransfer.from(a)}async $hasResolve(c){const t=this.a.get(c);if(!t)throw new b.$ZE(c);return t.hasResolve}$resolve(c,t,r){const d=this.a.get(c);if(!d)throw new b.$ZE(c);return d.resolveTreeItem(t,r)}$setExpanded(c,t,r){const d=this.a.get(c);if(!d)throw new b.$ZE(c);d.setExpanded(t,r)}$setSelectionAndFocus(c,t,r){const d=this.a.get(c);if(!d)throw new b.$ZE(c);d.setSelectionAndFocus(t,r)}$setVisible(c,t){const r=this.a.get(c);if(!r){if(!t)return;throw new b.$ZE(c)}r.setVisible(t)}$changeCheckboxState(c,t){const r=this.a.get(c);if(!r)throw new b.$ZE(c);r.setCheckboxState(t)}m(c,t,r){const d=this.B(new n(c,t,this.f,this.g.converter,this.h,r));return this.a.set(c,d),d}r(c){const t=this.a.get(c.$treeViewId);return t&&"$treeItemHandle"in c?t.getExtensionElement(c.$treeItemHandle):t&&"$focusedTreeItem"in c&&c.$focusedTreeItem?t.focusedElement:null}}e.$ehc=i;class n extends R.$Sc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(c=>this.getExtensionElement(c)).filter(c=>!(0,A.$Of)(c))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(c,t,r,d,u,a){if(super(),this.I=c,this.J=r,this.L=d,this.M=u,this.N=a,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new I.$Sd),this.onDidExpandElement=this.u.event,this.w=this.B(new I.$Sd),this.onDidCollapseElement=this.w.event,this.y=this.B(new I.$Sd),this.onDidChangeSelection=this.y.event,this.z=this.B(new I.$Sd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new I.$Sd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new I.$Sd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new I.$Sd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new k.$3d,a.contributes&&a.contributes.views)for(const w in a.contributes.views)for(const p of a.contributes.views[w])p.id===c&&(this.P=p.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(w=>this.F.fire({message:!1,element:w})));let h,S;const P=I.Event.debounce(this.F.event,(w,p)=>(w||(w={message:!1,elements:[]}),p.element!==!1&&(h||(h=new Promise(E=>S=E),this.G=this.G.then(()=>h)),Array.isArray(p.element)?w.elements.push(...p.element):w.elements.push(p.element)),p.message&&(w.message=!0),w),200,!0);this.B(P(({message:w,elements:p})=>{p.length&&(this.H=this.H.then(()=>{const E=S;return h=null,this.$(p).then(()=>E())})),w&&this.J.$setMessage(this.I,m.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(c){const t=c?this.getExtensionElement(c):void 0;if(c&&!t)return this.M.error(`No tree item with id '${c}' found.`),Promise.resolve([]);let r=this.X(c);return r||(r=await this.Y(t)),r?r.map(d=>d.item):void 0}getExtensionElement(c){return this.j.get(c)}reveal(c,t){t=t||{select:!0,focus:!1};const r=(0,A.$Of)(t.select)?!0:t.select,d=(0,A.$Of)(t.focus)?!1:t.focus,u=(0,A.$Of)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.G.then(()=>this.S(c)).then(a=>this.W(c,a[a.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:a.map(S=>S.item)},{select:r,focus:d,expand:u})),a=>this.M.error(a)):this.J.$reveal(this.I,void 0,{select:r,focus:d,expand:u})}get message(){return this.O}set message(c){this.O=c,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(c){this.P=c,this.J.$setTitle(this.I,c,this.Q)}get description(){return this.Q}set description(c){this.Q=c,this.J.$setTitle(this.I,this.P,c)}get badge(){return this.R}set badge(c){this.R?.value===c?.value&&this.R?.tooltip===c?.tooltip||(this.R=m.ViewBadge.from(c),this.J.$setBadge(this.I,c))}setExpanded(c,t){const r=this.getExtensionElement(c);r&&(t?this.u.fire(Object.freeze({element:r})):this.w.fire(Object.freeze({element:r})))}setSelectionAndFocus(c,t){const r=!(0,C.$ub)(this.s,c);this.s=c;const d=this.t!==t;this.t=t,r&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(c){c!==this.r&&(this.r=c,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(c){const t=(await Promise.all(c.map(async r=>{const d=this.getExtensionElement(r.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:r.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);t.forEach(r=>{r.treeItem.checkboxState=r.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(r=>[r.extensionItem,r.newState])})}async handleDrag(c,t,r){const d=[];for(const u of c){const a=this.getExtensionElement(u);a&&d.push(a)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,t,r),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(c,t,r){const d=t?this.getExtensionElement(t):void 0;if(!(!d&&t||!this.g?.handleDrop))return(0,$.$Vg)(()=>this.g?.handleDrop?this.g.handleDrop(d,c,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(c,t){if(!this.f.resolveTreeItem)return;const r=this.j.get(c);if(r){const d=this.m.get(r);if(d){const u=await this.f.resolveTreeItem(d.extensionItem,r,t)??d.extensionItem;return this.hb(u),d.item.tooltip=this.eb(u.tooltip),d.item.command=this.fb(d.disposableStore,u.command),d.item}}}S(c){return this.U(c).then(t=>t?this.S(t).then(r=>this.W(t,r[r.length-1]).then(d=>(r.push(d),r))):Promise.resolve([]))}U(c){const t=this.m.get(c);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$Vg)(()=>this.f.getParent(c))}W(c,t){const r=this.m.get(c);return r?Promise.resolve(r):(0,$.$Vg)(()=>this.f.getTreeItem(c)).then(d=>this.kb(c,d,t,!0)).then(d=>this.getChildren(t?t.item.handle:void 0).then(()=>{const u=this.getExtensionElement(d);if(u){const a=this.m.get(u);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(c){if(c){let t;if(typeof c=="string"){const r=this.getExtensionElement(c);t=r?this.m.get(r):void 0}else t=c;return t&&t.children||void 0}return this.h}async Y(c){this.rb(c);const t=new k.$3d(this.Z.token);try{const r=c?this.m.get(c):void 0,d=await this.f.getChildren(c);if(t.token.isCancellationRequested)return;const u=(0,C.$Hb)(d||[]),a=await Promise.all((0,C.$Hb)(u).map(S=>this.f.getTreeItem(S)));if(t.token.isCancellationRequested)return;const h=a.map((S,P)=>S?this.db(u[P],S,r):null);return(0,C.$Hb)(h)}finally{t.dispose()}}$(c){if(c.some(r=>!r))return this.Z.dispose(!0),this.Z=new k.$3d,this.tb(),this.J.$refresh(this.I);{const r=this.ab(c);if(r.length)return this.bb(r)}return Promise.resolve(void 0)}ab(c){const t=new Set,r=c.map(u=>this.m.get(u));for(const u of r)if(u&&!t.has(u.item.handle)){let a=u;for(;a&&a.parent&&r.findIndex(h=>a&&a.parent&&h&&h.item.handle===a.parent.item.handle)===-1;){const h=this.j.get(a.parent.item.handle);a=h?this.m.get(h):void 0}a&&!a.parent&&t.add(u.item.handle)}const d=[];return t.forEach(u=>{const a=this.j.get(u);if(a){const h=this.m.get(a);h&&(!h.parent||!t.has(h.parent.item.handle))&&d.push(u)}}),d}bb(c){const t={};return Promise.all(c.map(r=>this.cb(r).then(d=>{d&&(t[r]=d.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(c){const t=this.getExtensionElement(c);if(t){const r=this.m.get(t);if(r)return this.rb(t),(0,$.$Vg)(()=>this.f.getTreeItem(t)).then(d=>{if(d){const u=this.ib(t,d,r.parent);return this.pb(t,u,r,r.parent),r.dispose(),u}return null})}return Promise.resolve(null)}db(c,t,r){const d=this.ib(c,t,r);if(t.id&&this.j.has(d.item.handle))throw new Error((0,D.localize)(0,null,t.id));return this.ob(c,d),this.qb(d,r),d}eb(c){return y.$hL.isMarkdownString(c)?m.MarkdownString.from(c):c}fb(c,t){return t?{...this.L.toInternal(t,c),originalId:t.command}:void 0}gb(c){if(c.checkboxState===void 0)return;let t,r,d;return typeof c.checkboxState=="number"?t=c.checkboxState:(t=c.checkboxState.state,r=c.checkboxState.tooltip,d=c.checkboxState.accessibilityInformation),{isChecked:t===y.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:d}}hb(c){if(!y.$FL.isTreeItem(c,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(c,t,r){this.hb(t);const d=this.B(new R.$Rc),u=this.kb(c,t,r),a=this.lb(t);return{item:{handle:u,parentHandle:r?r.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(d,t.command),contextValue:t.contextValue,icon:a,iconDark:this.mb(t)||a,themeIcon:this.jb(t),collapsibleState:(0,A.$Of)(t.collapsibleState)?y.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:r,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(c){return c.iconPath instanceof y.$NL?c.iconPath:void 0}kb(c,{id:t,label:r,resourceUri:d},u,a){if(t)return`${n.b}/${t}`;const h=s(r,this.N),S=u?u.item.handle:n.a;let P=h?h.label:d?(0,N.$Bg)(d):"";P=P.indexOf("/")!==-1?P.replace("/","//"):P;const w=this.m.has(c)?this.m.get(c).item.handle:void 0,p=this.X(u)||[];let E,L=0;do{if(E=`${S}/${L}:${P}`,a||!this.j.has(E)||w===E)break;L++}while(L<=p.length);return E}lb(c){if(c.iconPath&&!(c.iconPath instanceof y.$NL))return typeof c.iconPath=="string"||g.URI.isUri(c.iconPath)?this.nb(c.iconPath):this.nb(c.iconPath.light)}mb(c){if(c.iconPath&&!(c.iconPath instanceof y.$NL)&&c.iconPath.dark)return this.nb(c.iconPath.dark)}nb(c){return g.URI.isUri(c)?c:g.URI.file(c)}ob(c,t){this.j.set(t.item.handle,c),this.m.set(c,t)}pb(c,t,r,d){this.j.delete(t.item.handle),this.m.delete(c),t.item.handle!==r.item.handle&&this.j.delete(r.item.handle),this.ob(c,t);const u=this.X(d)||[],a=u.filter(h=>h.item.handle===r.item.handle)[0];a&&u.splice(u.indexOf(a),1,t)}qb(c,t){t?(t.children||(t.children=[]),t.children.push(c)):(this.h||(this.h=[]),this.h.push(c))}rb(c){if(c){const t=this.m.get(c);if(t){if(t.children)for(const r of t.children){const d=this.j.get(r.item.handle);d&&this.sb(d)}t.children=void 0}}else this.tb()}sb(c){const t=this.m.get(c);if(t){if(t.children)for(const r of t.children){const d=this.j.get(r.item.handle);d&&this.sb(d)}this.m.delete(c),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(c=>c.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Se[300],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[301],ke([1,0,234,14,39,134,108,37,26,300,136,137]),function(me,e,D,N,g,I,R,b,$,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iF=e.$hF=e.$gF=e.$fF=e.$eF=e.$dF=void 0;const m=b.$vn.as(R.$wn.JSONContribution);class v{constructor(c,t,r){this.a=c,this.b=t,this.c=r}d(c,t){this.a({type:c,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(c){this.d(g.default.Error,c)}warn(c){this.d(g.default.Warning,c)}info(c){this.d(g.default.Info,c)}}e.$dF=v;class k{static a(c){const t=new $.$jm;for(let r=0,d=c.length;r<d;r++)t.add(c[r].description.identifier);return t}static compute(c,t){if(!c||!c.length)return new k(t,[]);if(!t||!t.length)return new k([],c);const r=this.a(c),d=this.a(t),u=t.filter(h=>!r.has(h.description.identifier)),a=c.filter(h=>!d.has(h.description.identifier));return new k(u,a)}constructor(c,t){this.added=c,this.removed=t}}e.$eF=k;class l{constructor(c,t){this.name=c,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(c){if(this.a!==null)throw new Error("Handler already set!");this.a=c,this.d()}acceptUsers(c){this.c=k.compute(this.b,c),this.b=c,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(c){(0,N.$1)(c)}}}e.$fF=l;const f={type:"string",enum:["ui","workspace"],enumDescriptions:[D.localize(0,null),D.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$gF={properties:{engines:{type:"object",description:D.localize(2,null),properties:{vscode:{type:"string",description:D.localize(3,null),default:"^1.22.0"}}},publisher:{description:D.localize(4,null),type:"string"},displayName:{description:D.localize(5,null),type:"string"},categories:{description:D.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$hm},{type:"string",const:"Languages",deprecationMessage:D.localize(7,null)}]}},galleryBanner:{type:"object",description:D.localize(8,null),properties:{color:{description:D.localize(9,null),type:"string"},theme:{description:D.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:D.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:D.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:D.localize(13,null)},enabledApiProposals:{markdownDescription:D.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}},api:{markdownDescription:D.localize(15,null),type:"string",enum:["none"],enumDescriptions:[D.localize(16,null)]},activationEvents:{description:D.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:D.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:D.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:D.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:D.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:D.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:D.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:D.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:D.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:D.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:D.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:D.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:D.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:D.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:D.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:D.localize(32,null)},{label:"onUri",body:"onUri",description:D.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:D.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:D.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:D.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:D.localize(37,null)},{label:"onRenderer",description:D.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:D.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:D.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:D.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:D.localize(42,null)},{label:"*",description:D.localize(43,null),body:"*"}]}},badges:{type:"array",description:D.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:D.localize(45,null)},href:{type:"string",description:D.localize(46,null)},description:{type:"string",description:D.localize(47,null)}}}},markdown:{type:"string",description:D.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:D.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:D.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:I.$ao}},extensionPack:{description:D.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:I.$ao}},extensionKind:{description:D.localize(52,null),type:"array",items:f,default:["workspace"],defaultSnippets:[{body:["ui"],description:D.localize(53,null)},{body:["workspace"],description:D.localize(54,null)},{body:["ui","workspace"],description:D.localize(55,null)},{body:["workspace","ui"],description:D.localize(56,null)},{body:[],description:D.localize(57,null)}]},capabilities:{description:D.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:D.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:D.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(61,null),D.localize(62,null),D.localize(63,null)]},description:{type:"string",markdownDescription:D.localize(64,null)}}},untrustedWorkspaces:{description:D.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:D.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(67,null),D.localize(68,null),D.localize(69,null)]},restrictedConfigurations:{description:D.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:D.localize(71,null)}}}}},sponsor:{description:D.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:D.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:D.localize(74,null),type:"string"},"vscode:uninstall":{description:D.localize(75,null),type:"string"}}},icon:{type:"string",description:D.localize(76,null)},l10n:{type:"string",description:D.localize(77,null)},pricing:{type:"string",markdownDescription:D.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(c){if(this.a.has(c.extensionPoint))throw new Error("Duplicate extension point: "+c.extensionPoint);const t=new l(c.extensionPoint,c.defaultExtensionKind);return this.a.set(c.extensionPoint,t),c.activationEventsGenerator&&C.$7E.register(c.extensionPoint,c.activationEventsGenerator),e.$gF.properties.contributes.properties[c.extensionPoint]=c.jsonSchema,m.registerSchema(s,e.$gF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$hF=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};b.$vn.add(n.ExtensionsRegistry,new i),e.$iF=b.$vn.as(n.ExtensionsRegistry),m.registerSchema(s,e.$gF),m.registerSchema(A.$Dj,{properties:{extensionEnabledApiProposals:{description:D.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}}]}}}})}),define(Se[302],ke([1,0,230,18,24,301,46,4]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kG=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:D.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:D.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:D.localize(2,null),default:""}}};var y;(function(m){function v(k,l,f){if(!k)return;const s=N.$Ff(k.type)?k.type:void 0;if(!s||s.length===0){f.error(D.localize(3,null));return}const i=[];if(Array.isArray(k.required))for(const n of k.required)N.$Ff(n)&&i.push(n);return{extensionId:l.value,taskType:s,required:i,properties:k.properties?g.$jn(k.properties):{},when:k.when?R.$1i.deserialize(k.when):void 0}}m.from=v})(y||(y={}));const A=I.$iF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(m,v)=>{for(const k of m)k.type&&v.push(`onTaskType:${k.type}`)},jsonSchema:{description:D.localize(4,null),type:"array",items:$}});class C{constructor(){this.d=new b.$Sd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,k)=>{A.setHandler((l,f)=>{this.c=void 0;try{for(const s of f.removed){const i=s.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const s of f.added){const i=s.value;for(const n of i){const o=y.from(n,s.description.identifier,s.collector);o&&(this.a[o.taskType]=o)}}(f.removed.length>0||f.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const k of this.all()){const l={type:"object",additionalProperties:!1};k.required.length>0&&(l.required=k.required.slice(0)),k.properties!==void 0?l.properties=g.$jn(k.properties):l.properties=Object.create(null),l.properties.type={type:"string",enum:[k.taskType]},v.push(l)}this.c={oneOf:v}}return this.c}}e.$kG=new C}),define(Se[303],ke([1,0,231,18,23,24,46,302]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$uG=e.JsonSchemaVersion=e.ExecutionEngine=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$oG=e.ShellQuoting=e.$nG=e.$mG=e.$lG=void 0,e.$lG="settings",e.$mG=new R.$hj("taskRunning",!1,D.localize(0,null)),e.$nG={value:D.localize(1,null),original:"Tasks"};var $;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$oG="$customized",function(O){function M(W){if(!W)return O.Strong;switch(W.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=M}($||(e.ShellQuoting=$={}));var y;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(y||(e.CommandOptions=y={}));var A;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(A||(e.RevealKind=A={})),function(O){function M(W){switch(W.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=M}(A||(e.RevealKind=A={}));var C;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(O){function M(W){switch(W.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=M}(C||(e.RevealProblemKind=C={}));var m;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(m||(e.PanelKind=m={})),function(O){function M(W){switch(W.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=M}(m||(e.PanelKind=m={}));var v;(function(O){O.defaults={echo:!0,reveal:A.Always,revealProblems:C.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var k;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(k||(e.RuntimeType=k={})),function(O){function M(Y){switch(Y.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=M;function W(Y){switch(Y){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=W}(k||(e.RuntimeType=k={}));var l;(function(O){function M(W){return N.$Ff(W)?W:W.value}O.value=M})(l||(e.CommandString=l={}));var f;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function M(Y){return Y===O.Clean._id||Y===O.Build._id||Y===O.Rebuild._id||Y===O.Test._id}O.is=M;function W(Y){if(Y!==void 0)return N.$Ff(Y)?M(Y)?{_id:Y,isDefault:!1}:void 0:Y}O.from=W})(f||(e.TaskGroup=f={}));var s;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var i;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function M(W){switch(W){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=M})(i||(e.TaskSourceKind=i={}));var n;(function(O){O.parallel="parallel",O.sequence="sequence"})(n||(e.DependsOrder=n={}));var o;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(o||(e.RunOnOptions=o={}));var c;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:o.default,instanceLimit:1}})(c||(e.RunOptions=c={}));class t{constructor(M,W,Y,ue,X,J){this._label="",this._id=M,W&&(this._label=W),Y&&(this.type=Y),this.runOptions=ue,this.configurationProperties=X,this._source=J}getDefinition(M){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const M={folder:this.d(),id:this._id};return JSON.stringify(M)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(M,W=!1){if(M===void 0)return!1;if(N.$Ff(M))return M===this._label||M===this.configurationProperties.identifier||W&&M===this._id;const Y=this.getDefinition(!0);return Y!==void 0&&Y._key===M._key}getQualifiedLabel(){const M=this.getWorkspaceFolder();return M?`${this._label} (${M.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(M){this.c===void 0&&(this.c=[]),M&&(this.c=this.c.concat(M))}get taskLoadMessages(){return this.c}}e.$pG=t;class r extends t{constructor(M,W,Y,ue,X,J,x,he){super(M,Y,void 0,x,he,W),this.command={},this._source=W,this.hasDefinedMatchers=J,X&&(this.command=X)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(M=!1){if(M&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case k.Shell:W="shell";break;case k.Process:W="process";break;case k.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(M){return M instanceof r}getMapKey(){const M=this._source.config.workspaceFolder;return M?`${M.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$lG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const M=this.d();if(!M)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const Y={type:e.$oG,folder:M,id:W};return JSON.stringify(Y)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$Bg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(M){return new r(M._id,M._source,M._label,M.type,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.$qG=r;class d extends t{constructor(M,W,Y,ue,X,J,x){super(M,Y,ue,J,x,W),this._source=W,this.configures=X}static is(M){return M instanceof d}f(M){return M}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$Bg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$lG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const M=this.d();if(!M)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const Y={type:e.$oG,folder:M,id:W};return JSON.stringify(Y)}}e.$rG=d;class u extends t{constructor(M,W,Y,ue,X,J,x,he,Z){super(M,Y,ue,he,Z,W),this.defines=X,this.hasDefinedMatchers=x,this.command=J,this.icon=Z.icon,this.hide=Z.hide}clone(){return new u(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(M){return M instanceof u}getMapKey(){const M=this._source.workspaceFolder;return M?`${this._source.scope.toString()}|${M.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const M={type:"contributed",scope:this._source.scope,id:this._id};return M.folder=this.d(),JSON.stringify(M)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(M){return new u(M._id,M._source,M._label,M.type,M.defines,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.$sG=u;class a extends t{constructor(M,W,Y,ue,X,J){super(M,Y,ue,X,J,W),this._source=W}clone(){return new a(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(M){return M instanceof a}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(M){return new a(M._id,M._source,M._label,M.type,M.runOptions,M.configurationProperties)}}e.$tG=a;var h;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(O){O._default=O.Terminal}(h||(e.ExecutionEngine=h={}));var S;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(S||(e.JsonSchemaVersion=S={}));class P{constructor(M){this.c=new Map;for(let W=0;W<M.length;W++)this.c.set(M[W].uri.toString(),W)}compare(M,W){const Y=M.getWorkspaceFolder(),ue=W.getWorkspaceFolder();if(Y&&ue){let X=this.c.get(Y.uri.toString());X=X===void 0?0:X+1;let J=this.c.get(ue.uri.toString());return J=J===void 0?0:J+1,X===J?M._label.localeCompare(W._label):X-J}else return!Y&&ue?-1:Y&&!ue?1:0}}e.$uG=P;var w;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(w||(e.TaskEventKind=w={}));var p;(function(O){O.SingleRun="singleRun",O.Background="background"})(p||(e.TaskRunType=p={}));var E;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(E||(e.TaskRunSource=E={}));var L;(function(O){function M(he){return{taskId:he._id,taskName:he.configurationProperties.name,runType:he.configurationProperties.isBackground?"background":"singleRun",group:he.configurationProperties.group,__task:he}}function W(he,Z,we){return{...M(he),kind:"start",terminalId:Z,resolvedVariables:we}}O.start=W;function Y(he,Z,we){return{...M(he),kind:"processStarted",terminalId:Z,processId:we}}O.processStarted=Y;function ue(he,Z,we){return{...M(he),kind:"processEnded",terminalId:Z,exitCode:we}}O.processEnded=ue;function X(he,Z,we){return{...M(he),kind:"terminated",exitReason:we,terminalId:Z}}O.terminated=X;function J(he,Z,we){return{...M(Z),kind:he,terminalId:we}}O.general=J;function x(){return{kind:"changed"}}O.changed=x})(L||(e.TaskEvent=L={}));var T;(function(O){function M(Y){const ue=Object.keys(Y).sort();let X="";for(const J of ue){let x=Y[J];x instanceof Object?x=M(x):typeof x=="string"&&(x=x.replace(/,/g,",,")),X+=J+","+x+","}return X}function W(Y){const X={_key:M(Y),type:Y.taskType};return Object.assign(X,Y),X}O.create=W})(T||(e.KeyedTaskIdentifier=T={}));var U;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection",O.VerboseLogging="task.verboseLogging"})(U||(e.TaskSettingId=U={}));var F;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(F||(e.TasksSchemaProperties=F={}));var j;(function(O){function M(W,Y){const ue=b.$kG.get(W.type);if(ue===void 0){const he=I.$jn(W);return delete he._key,T.create(he)}const X=Object.create(null);X.type=ue.taskType;const J=new Set;ue.required.forEach(he=>J.add(he));const x=ue.properties;for(const he of Object.keys(x)){const Z=W[he];if(Z!=null)X[he]=Z;else if(J.has(he)){const we=x[he];if(we.default!==void 0)X[he]=I.$jn(we.default);else switch(we.type){case"boolean":X[he]=!1;break;case"number":case"integer":X[he]=0;break;case"string":X[he]="";break;default:Y.error(D.localize(2,null,JSON.stringify(W,void 0,0),he));return}}}return T.create(X)}O.createTaskIdentifier=M})(j||(e.TaskDefinition=j={}))}),define(Se[304],ke([1,0,14]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u7b=e.$t7b=void 0;class N{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,b)=>{this.b=R,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,D.$1)(R))}then(R,b){return this.j().then(R,b)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$t7b=N;class g extends N{constructor(){super(),this.h=!0,this.i=new D.$5}}e.$u7b=g}),define(Se[68],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gv=e.$Fv=e.$Ev=e.$Dv=void 0;class D{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++D.count}}e.$Dv=D;const N=[];function g(b){const $=new D(b);return N[$.nid]=$,$}e.$Ev=g;function I(b){return N[b].sid}e.$Fv=I;class R{constructor($){this.value=$}}e.$Gv=R}),define(Se[6],ke([1,0,68]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RK=e.$QK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$PK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(N||(e.TextEditorRevealType=N={}));var g;(function(l){l[l.UnknownInput=0]="UnknownInput",l[l.TextInput=1]="TextInput",l[l.TextDiffInput=2]="TextDiffInput",l[l.TextMergeInput=3]="TextMergeInput",l[l.NotebookInput=4]="NotebookInput",l[l.NotebookDiffInput=5]="NotebookDiffInput",l[l.CustomEditorInput=6]="CustomEditorInput",l[l.WebviewEditorInput=7]="WebviewEditorInput",l[l.TerminalEditorInput=8]="TerminalEditorInput",l[l.InteractiveEditorInput=9]="InteractiveEditorInput",l[l.ChatEditorInput=10]="ChatEditorInput"})(g||(e.TabInputKind=g={}));var I;(function(l){l[l.TAB_OPEN=0]="TAB_OPEN",l[l.TAB_CLOSE=1]="TAB_CLOSE",l[l.TAB_UPDATE=2]="TAB_UPDATE",l[l.TAB_MOVE=3]="TAB_MOVE"})(I||(e.TabModelOperationKind=I={}));var R;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var b;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var $;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var y;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(y||(e.NotebookEditorRevealType=y={}));var A;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class C{static{this.a=0}static mixin(f){return f._id=C.a++,f}}e.$PK=C;var m;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.kindModifier="m",l.commandIdent="n",l.commandId="o",l.commandArguments="p"})(m||(e.ISuggestDataDtoField=m={}));var v;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var k;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(k||(e.ExtHostTestingResource=k={})),e.$QK={MainThreadAuthentication:(0,D.$Ev)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.$Ev)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.$Ev)("MainThreadChatProvider"),MainThreadChatAgents2:(0,D.$Ev)("MainThreadChatAgents2"),MainThreadChatVariables:(0,D.$Ev)("MainThreadChatVariables"),MainThreadClipboard:(0,D.$Ev)("MainThreadClipboard"),MainThreadCommands:(0,D.$Ev)("MainThreadCommands"),MainThreadComments:(0,D.$Ev)("MainThreadComments"),MainThreadConfiguration:(0,D.$Ev)("MainThreadConfiguration"),MainThreadConsole:(0,D.$Ev)("MainThreadConsole"),MainThreadDebugService:(0,D.$Ev)("MainThreadDebugService"),MainThreadDecorations:(0,D.$Ev)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.$Ev)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.$Ev)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.$Ev)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.$Ev)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.$Ev)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.$Ev)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.$Ev)("MainThreadEditorTabs"),MainThreadErrors:(0,D.$Ev)("MainThreadErrors"),MainThreadTreeViews:(0,D.$Ev)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.$Ev)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.$Ev)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.$Ev)("MainThreadLanguages"),MainThreadLogger:(0,D.$Ev)("MainThreadLogger"),MainThreadMessageService:(0,D.$Ev)("MainThreadMessageService"),MainThreadOutputService:(0,D.$Ev)("MainThreadOutputService"),MainThreadProgress:(0,D.$Ev)("MainThreadProgress"),MainThreadQuickDiff:(0,D.$Ev)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.$Ev)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.$Ev)("MainThreadStatusBar"),MainThreadSecretState:(0,D.$Ev)("MainThreadSecretState"),MainThreadStorage:(0,D.$Ev)("MainThreadStorage"),MainThreadSpeech:(0,D.$Ev)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,D.$Ev)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.$Ev)("MainThreadTerminalService"),MainThreadWebviews:(0,D.$Ev)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.$Ev)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.$Ev)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.$Ev)("MainThreadCustomEditors"),MainThreadUrls:(0,D.$Ev)("MainThreadUrls"),MainThreadUriOpeners:(0,D.$Ev)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.$Ev)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.$Ev)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.$Ev)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,D.$Ev)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,D.$Ev)("MainThreadExtensionService"),MainThreadSCM:(0,D.$Ev)("MainThreadSCM"),MainThreadSearch:(0,D.$Ev)("MainThreadSearch"),MainThreadShare:(0,D.$Ev)("MainThreadShare"),MainThreadTask:(0,D.$Ev)("MainThreadTask"),MainThreadWindow:(0,D.$Ev)("MainThreadWindow"),MainThreadLabelService:(0,D.$Ev)("MainThreadLabelService"),MainThreadNotebook:(0,D.$Ev)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.$Ev)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.$Ev)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.$Ev)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.$Ev)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.$Ev)("MainThreadInteractive"),MainThreadChat:(0,D.$Ev)("MainThreadChat"),MainThreadInlineChat:(0,D.$Ev)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.$Ev)("MainThreadTheming"),MainThreadTunnelService:(0,D.$Ev)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.$Ev)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.$Ev)("MainThreadTimeline"),MainThreadTesting:(0,D.$Ev)("MainThreadTesting"),MainThreadLocalization:(0,D.$Ev)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.$Ev)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.$Ev)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.$Ev)("MainThreadIssueReporter")},e.$RK={ExtHostCommands:(0,D.$Ev)("ExtHostCommands"),ExtHostConfiguration:(0,D.$Ev)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.$Ev)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.$Ev)("ExtHostDebugService"),ExtHostDecorations:(0,D.$Ev)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.$Ev)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.$Ev)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.$Ev)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.$Ev)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.$Ev)("ExtHostEditors"),ExtHostTreeViews:(0,D.$Ev)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.$Ev)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.$Ev)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.$Ev)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.$Ev)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.$Ev)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.$Ev)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.$Ev)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.$Ev)("ExtHostStatusBar"),ExtHostShare:(0,D.$Ev)("ExtHostShare"),ExtHostExtensionService:(0,D.$Ev)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.$Ev)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.$Ev)("ExtHostTerminalService"),ExtHostSCM:(0,D.$Ev)("ExtHostSCM"),ExtHostSearch:(0,D.$Ev)("ExtHostSearch"),ExtHostTask:(0,D.$Ev)("ExtHostTask"),ExtHostWorkspace:(0,D.$Ev)("ExtHostWorkspace"),ExtHostWindow:(0,D.$Ev)("ExtHostWindow"),ExtHostWebviews:(0,D.$Ev)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.$Ev)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.$Ev)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.$Ev)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.$Ev)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.$Ev)("ExtHostEditorTabs"),ExtHostProgress:(0,D.$Ev)("ExtHostProgress"),ExtHostComments:(0,D.$Ev)("ExtHostComments"),ExtHostSecretState:(0,D.$Ev)("ExtHostSecretState"),ExtHostStorage:(0,D.$Ev)("ExtHostStorage"),ExtHostUrls:(0,D.$Ev)("ExtHostUrls"),ExtHostUriOpeners:(0,D.$Ev)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.$Ev)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.$Ev)("ExtHostOutputService"),ExtHostLabelService:(0,D.$Ev)("ExtHostLabelService"),ExtHostNotebook:(0,D.$Ev)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.$Ev)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.$Ev)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.$Ev)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.$Ev)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.$Ev)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.$Ev)("ExtHostInteractive"),ExtHostInlineChat:(0,D.$Ev)("ExtHostInlineChatShape"),ExtHostChat:(0,D.$Ev)("ExtHostChat"),ExtHostChatAgents2:(0,D.$Ev)("ExtHostChatAgents"),ExtHostChatVariables:(0,D.$Ev)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.$Ev)("ExtHostChatProvider"),ExtHostSpeech:(0,D.$Ev)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,D.$Ev)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.$Ev)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.$Ev)("ExtHostTheming"),ExtHostTunnelService:(0,D.$Ev)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.$Ev)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.$Ev)("ExtHostAuthentication"),ExtHostTimeline:(0,D.$Ev)("ExtHostTimeline"),ExtHostTesting:(0,D.$Ev)("ExtHostTesting"),ExtHostTelemetry:(0,D.$Ev)("ExtHostTelemetry"),ExtHostLocalization:(0,D.$Ev)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.$Ev)("ExtHostIssueReporter")}}),define(Se[305],ke([1,0,6,7]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=void 0;class g{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(D.$QK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,b,$){if(this.a.size===0)throw new Error("No related information providers registered");const y=this.a.get(R);if(!y)throw new Error("related information provider not found");return await y.provideRelatedInformation(b,$)??[]}getRelatedInformation(R,b,$){return this.c.$getAiRelatedInformation(b,$)}registerRelatedInformationProvider(R,b,$){const y=this.b;return this.b++,this.a.set(y,$),this.c.$registerAiRelatedInformationProvider(y,b),new N.$SK(()=>{this.c.$unregisterAiRelatedInformationProvider(y),this.a.delete(y)})}}e.$efc=g}),define(Se[91],ke([1,0,5,13,6,20]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=e.$lfc=e.$kfc=void 0,e.$kfc=(0,D.$3h)("IExtHostApiDeprecationService");let R=class{constructor($,y){this.c=y,this.a=new Set,this.b=$.getProxy(g.$QK.MainThreadTelemetry)}report($,y,A){const C=this.d($,y);this.a.has(C)||(this.a.add(C),y.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:$}))}d($,y){return`${$}-${y.identifier.value}`}};e.$lfc=R,e.$lfc=R=Ge([We(0,I.$UM),We(1,N.$kj)],R),e.$mfc=Object.freeze(new class{report(b,$,y){}})}),define(Se[306],ke([1,0,4,6,7,26]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=void 0;class R{constructor(y){this.b=new Map,this.c=[],this.d=new D.$Sd,this.onDidChangeSessions=this.d.event,this.f=new b,this.g=new b,this.a=y.getProxy(N.$QK.MainThreadAuthentication)}$setProviders(y){return this.c=y,Promise.resolve()}async getSession(y,A,C,m={}){const v=I.$im.toKey(y.identifier),k=[...C].sort().join(" ");return await this.f.getOrCreate(`${v} ${A} ${k}`,async()=>{await this.a.$ensureProvider(A);const l=y.displayName||y.name;return this.a.$getSession(A,C,v,l,m)})}async getSessions(y,A,C){const m=I.$im.toKey(y.identifier),v=[...C].sort().join(" ");return await this.g.getOrCreate(`${m} ${v}`,async()=>{await this.a.$ensureProvider(A);const k=y.displayName||y.name;return this.a.$getSessions(A,C,m,k)})}async removeSession(y,A){const C=this.b.get(y);return C?C.provider.removeSession(A):this.a.$removeSession(y,A)}registerAuthenticationProvider(y,A,C,m){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:A,provider:C,options:m??{supportsMultipleAccounts:!1}}),this.c.find(k=>k.id===y)||this.c.push({id:y,label:A});const v=C.onDidChangeSessions(k=>{this.a.$sendDidChangeSessions(y,{added:k.added??[],changed:k.changed??[],removed:k.removed??[]})});return this.a.$registerAuthenticationProvider(y,A,m?.supportsMultipleAccounts??!1),new g.$SK(()=>{v.dispose(),this.b.delete(y);const k=this.c.findIndex(l=>l.id===y);k>-1&&this.c.splice(k),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,A,C){const m=this.b.get(y);if(m)return Promise.resolve(m.provider.createSession(A,C));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,A){const C=this.b.get(y);if(C)return Promise.resolve(C.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,A){const C=this.b.get(y);if(C)return Promise.resolve(C.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,A){return this.d.fire({provider:{id:y,label:A}}),Promise.resolve()}}e.$pfc=R;class b{constructor(){this.a=new Map}getOrCreate(y,A){const C=this.a.get(y);if(C)return C;const m=A().finally(()=>this.a.delete(y));return this.a.set(y,m),m}}}),define(Se[307],ke([1,0,6,20,15]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=void 0;let I=class{constructor(b,$){this.a=b.getProxy(D.$QK.MainThreadBulkEdits),this.b={getTextDocumentVersion:y=>$.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,$,y){const A=g.WorkspaceEdit.from(b,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,y?.isRefactoring??!1)}};e.$qfc=I,e.$qfc=I=Ge([We(0,N.$UM)],I)}),define(Se[308],ke([1,0,53,3,6,15]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=void 0;class R{static{this.a=0}constructor(y,A){this.extension=y,this.provider=A,this.handle=R.a++}}class b{static{this.a=0}constructor(y){this.b=new Map,this.c=new Map,this.d=y.getProxy(g.$QK.MainThreadChat)}registerChatProvider(y,A,C){const m=new R(y,C);return this.b.set(m.handle,m),this.d.$registerChatProvider(m.handle,A),(0,N.$Qc)(()=>{this.d.$unregisterChatProvider(m.handle),this.b.delete(m.handle)})}transferChatSession(y,A){const C=D.Iterable.find(this.c.keys(),m=>this.c.get(m)===y)??0;typeof C=="number"&&this.d.$transferChatSession(C,A)}sendInteractiveRequestToProvider(y,A){this.d.$sendRequestToProvider(y,A)}async $prepareChat(y,A){const C=this.b.get(y);if(!C)return;const m=await C.provider.prepareSession(A);if(!m)return;const v=b.a++;return this.c.set(v,m),{id:v,requesterUsername:m.requester?.name,requesterAvatarIconUri:m.requester?.icon,responderUsername:m.responder?.name,responderAvatarIconUri:m.responder?.icon,inputPlaceholder:m.inputPlaceholder}}async $provideWelcomeMessage(y,A){const C=this.b.get(y);if(!C||!C.provider.provideWelcomeMessage)return;const m=await C.provider.provideWelcomeMessage(A);if(m)return m.map(v=>typeof v=="string"?v:Array.isArray(v)?v.map(k=>I.ChatReplyFollowup.from(k)):I.MarkdownString.from(v))}async $provideSampleQuestions(y,A){const C=this.b.get(y);if(!C||!C.provider.provideSampleQuestions)return;const m=await C.provider.provideSampleQuestions(A);if(m)return m?.map(v=>I.ChatReplyFollowup.from(v))}$releaseSession(y){this.c.delete(y)}}e.$rfc=b}),define(Se[309],ke([1,0,11,21,44,4,38,18,2,210,85,6,15,7,280,25]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=void 0;class f{static{this.a=0}constructor(n,o,c){this.i=o,this.j=c,this.b=new Map,this.g=new Map,this.h=new Map,this.d=n.getProxy(C.$QK.MainThreadChatAgents2)}createChatAgent(n,o,c){const t=f.a++,r=new s(n,o,this.d,t,c);return this.b.set(t,r),this.d.$registerAgent(t,o,{}),r.apiAgent}async $invokeAgent(n,o,c,t,r,d){this.g.delete(o);const u=this.b.get(n);if(!u)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let a=!1;function h(){if(a)throw new Error("Only valid while executing the command")}const S=new D.$nh;d.onCancellationRequested(()=>S.complete()),this.i.allowListExtensionWhile(u.extension.identifier,S.p);const P=t.command?await u.validateSlashCommand(t.command):void 0,w=R.$Od.create(!1);let p;try{const E=u.invoke({prompt:t.message,variables:m.ChatVariable.objectTo(t.variables),slashCommand:P},{history:r.history.map(m.ChatMessage.to)},new A.$iv(L=>{h(),typeof p>"u"&&"content"in L&&(p=w.elapsed());const T=m.ChatResponseProgress.from(u.extension,L);if(!T){this.j.error("Unknown progress type: "+JSON.stringify(L));return}if("placeholder"in L&&"resolvedContent"in L){const U=Promise.all([this.d.$handleProgressChunk(c,T),L.resolvedContent]);(0,D.$Rg)(U,d).then(F=>{if(!F)return;const[j,O]=F,M=m.ChatResponseProgress.from(u.extension,O);if(!M){this.j.error("Unknown progress type: "+JSON.stringify(O));return}this.d.$handleProgressChunk(c,M,j??void 0)})}else this.d.$handleProgressChunk(c,T)}),d);return await(0,D.$Rg)(Promise.resolve(E).then(L=>{if(L){this.g.set(o,L);let T=this.h.get(o);T||(T=new Map,this.h.set(o,T)),T.set(c,L);const U={firstProgress:p,totalElapsed:w.elapsed()};return{errorDetails:L.errorDetails,timings:U}}else this.g.delete(o)}),d)}catch(E){return this.j.error(E,u.extension),{errorDetails:{message:(0,y.localize)(0,null,(0,g.$Ni)(E)),responseIsIncomplete:!0}}}finally{a=!0,S.complete()}}$releaseSession(n){this.g.delete(n),this.h.delete(n)}async $provideSlashCommands(n,o){const c=this.b.get(n);return c?c.provideSlashCommand(o):[]}$provideFollowups(n,o,c){const t=this.b.get(n);if(!t)return Promise.resolve([]);const r=this.g.get(o);return r?t.provideFollowups(r,c):Promise.resolve([])}$acceptFeedback(n,o,c,t,r){const d=this.b.get(n);if(!d)return;const u=this.h.get(o)?.get(c);if(!u)return;let a;switch(t){case k.InteractiveSessionVoteDirection.Down:a=v.ChatAgentResultFeedbackKind.Unhelpful;break;case k.InteractiveSessionVoteDirection.Up:a=v.ChatAgentResultFeedbackKind.Helpful;break}d.acceptFeedback(Object.freeze(r?{result:u,kind:a,reportIssue:r}:{result:u,kind:a}))}$acceptAction(n,o,c,t){const r=this.b.get(n);if(!r)return;const d=this.h.get(o)?.get(c);d&&t.action.kind!=="vote"&&r.acceptAction(Object.freeze({action:t.action,result:d}))}async $invokeCompletionProvider(n,o,c){const t=this.b.get(n);return t?(await t.invokeCompletionProvider(o,c)).map(m.ChatAgentCompletionItem.from):[]}}e.$tfc=f;class s{constructor(n,o,c,t,r){this.extension=n,this.t=o,this.u=c,this.w=t,this.x=r,this.o=new I.$Sd,this.q=new I.$Sd}acceptFeedback(n){this.o.fire(n)}acceptAction(n){this.q.fire(n)}async invokeCompletionProvider(n,o){return this.s?await this.s.provider.provideCompletionItems(n,o)??[]:[]}async validateSlashCommand(n){this.b||(await this.provideSlashCommand(N.CancellationToken.None),(0,b.$Pf)(this.b));const o=this.b.find(c=>c.name===n);if(!o)throw new Error(`Unknown slashCommand: ${n}`);return o}async provideSlashCommand(n){if(!this.a)return[];const o=await this.a.provideSlashCommands(n);return o?(this.b=o,o.map(c=>({name:c.name,description:c.description,followupPlaceholder:c.followupPlaceholder,shouldRepopulate:c.shouldRepopulate,sampleRequest:c.sampleRequest}))):[]}async provideFollowups(n,o){if(!this.d)return[];const c=await this.d.provideFollowups(n,o);return c?c.map(t=>m.ChatFollowup.from(t)):[]}get apiAgent(){let n=!1,o=!1;const c=()=>{n||o||(o=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof $.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof v.$NL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:m.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:m.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),o=!1}))},t=this;return{get name(){return t.t},get description(){return t.g??""},set description(r){t.g=r,c()},get fullName(){return t.h??t.extension.displayName??t.extension.name},set fullName(r){t.h=r,c()},get iconPath(){return t.i},set iconPath(r){t.i=r,c()},get slashCommandProvider(){return t.a},set slashCommandProvider(r){t.a=r,c()},get followupProvider(){return t.d},set followupProvider(r){t.d=r,c()},get isDefault(){return(0,l.$pF)(t.extension,"defaultChatAgent"),t.j},set isDefault(r){(0,l.$pF)(t.extension,"defaultChatAgent"),t.j=r,c()},get helpTextPrefix(){return(0,l.$pF)(t.extension,"defaultChatAgent"),t.k},set helpTextPrefix(r){if((0,l.$pF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPrefix is only available on the default chat agent");t.k=r,c()},get helpTextPostfix(){return(0,l.$pF)(t.extension,"defaultChatAgent"),t.l},set helpTextPostfix(r){if((0,l.$pF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPostfix is only available on the default chat agent");t.l=r,c()},get isSecondary(){return(0,l.$pF)(t.extension,"defaultChatAgent"),t.n},set isSecondary(r){(0,l.$pF)(t.extension,"defaultChatAgent"),t.n=r,c()},get sampleRequest(){return t.m},set sampleRequest(r){t.m=r,c()},get supportIssueReporting(){return(0,l.$pF)(t.extension,"chatAgents2Additions"),t.r},set supportIssueReporting(r){(0,l.$pF)(t.extension,"chatAgents2Additions"),t.r=r,c()},get onDidReceiveFeedback(){return t.o.event},set agentVariableProvider(r){if(t.s=r,r){if(!r.triggerCharacters.length)throw new Error("triggerCharacters are required");t.u.$registerAgentCompletionsProvider(t.w,r.triggerCharacters)}else t.u.$unregisterAgentCompletionsProvider(t.w)},get agentVariableProvider(){return t.s},onDidPerformAction:(0,l.$oF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){n=!0,t.a=void 0,t.d=void 0,t.o.dispose(),t.u.$unregisterAgent(t.w)}}}invoke(n,o,c,t){return this.x(n,o,c,t)}}}),define(Se[310],ke([1,0,21,3,6,15,85,26,11,4]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sfc=void 0;class A{constructor(k,l){this.stream=new $.$th,this.stream=l??new $.$th;const f=this;this.apiObj={option:k,response:f.stream.asyncIterable}}}class C{constructor(k,l){this.a=new y.$Sd,this.b=new Map,this.c=new $.$th,this.d=!1;const f=this;this.apiObject={result:k,response:f.c.asyncIterable,onDidStartResponseStream:f.a.event,cancel(){l.cancel()}},k.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,s]of this.b)s.stream.resolve();else this.c.resolve()})}handleFragment(k){if(this.d)return;let l=this.b.get(k.index);l||(this.b.size===0?l=new A(k.index,this.c):l=new A(k.index),this.b.set(k.index,l),this.a.fire(l.apiObj)),l.stream.emitOne(k.part)}}class m{static{this.a=1}constructor(k,l){this.d=l,this.c=new Map,this.e=new Map,this.f=new b.$km,this.b=k.getProxy(g.$QK.MainThreadChatProvider)}registerProvider(k,l,f,s){const i=m.a++;return this.c.set(i,{extension:k,provider:f}),this.b.$registerProvider(i,l,{extension:k,model:s.name??""}),(0,N.$Qc)(()=>{this.b.$unregisterProvider(i),this.c.delete(i)})}async $provideChatResponse(k,l,f,s,i){const n=this.c.get(k);if(!n)return;const o=new R.$iv(async c=>{if(i.isCancellationRequested){this.d.warn(`[CHAT](${n.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(l,{index:c.index,part:c.part})});return n.provider.provideChatResponse(f.map(I.ChatMessage.to),s,o,i)}allowListExtensionWhile(k,l){this.f.set(k,l),l.finally(()=>this.f.delete(k))}async requestChatResponseProvider(k,l){if(!this.f.has(k))throw new Error("Extension is NOT allowed to make chat requests");const f=await this.b.$prepareChatAccess(l);if(!f)throw new Error(`ChatAccess '${l}' NOT found`);const s=this;return{get model(){return f.model},get isRevoked(){return!s.f.has(k)},makeRequest(i,n,o){if(!s.f.has(k))throw new Error("Access to chat has been revoked");const c=new D.$3d(o),t=Math.random()*1e6|0,r=s.b.$fetchResponse(k,l,t,i.map(I.ChatMessage.from),n??{},c.token),d=new C(r,c);return s.e.set(t,{res:d}),r.finally(()=>{s.e.delete(t)}),d.apiObject}}}async $handleResponseFragment(k,l){const f=this.e.get(k);f&&f.res.handleFragment(l)}}e.$sfc=m}),define(Se[311],ke([1,0,3,6,14,15]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ufc=void 0;class R{static{this.a=0}constructor($){this.b=new Map,this.c=$.getProxy(N.$QK.MainThreadChatVariables)}async $resolveVariable($,y,A){const C=this.b.get($);if(C)try{const m=await C.resolver.resolve(C.data.name,{message:y},A);if(m)return m.map(I.ChatVariable.from)}catch(m){(0,g.$2)(m)}}registerVariableResolver($,y,A,C){const m=R.a++;return this.b.set(m,{extension:$.identifier,data:{name:y,description:A},resolver:C}),this.c.$registerVariable(m,{name:y,description:A}),(0,D.$Qc)(()=>{this.b.delete(m),this.c.$unregisterVariable(m)})}}e.$ufc=R}),define(Se[312],ke([1,0,6]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vfc=void 0;class N{constructor(I){const R=I.getProxy(D.$QK.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(b){return R.$writeText(b)}})}}e.$vfc=N}),define(Se[35],ke([1,0,18,7,15,24,6,19,13,55,29,49,2,3,5,20,147,22,68,44,38,87,90,30]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l,f,s,i,n,o,c,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iN=e.$hN=e.$gN=e.$fN=e.$eN=e.$dN=void 0;let d=class{#e;#t;#i;constructor(w,p,E){this.b=new Map,this.c=new Map,this.#e=w.getProxy(R.$QK.MainThreadCommands),this.d=p,this.#i=E,this.#t=w.getProxy(R.$QK.MainThreadTelemetry),this.converter=new u(this,L=>{const T=this.c.get(L);return T?.result===h.Void?T:void 0},p),this.f=[{processArgument(L){return(0,y.$zh)(L)}},{processArgument(L){return(0,I.$ln)(L,function(T){if(A.$Is.isIRange(T))return g.Range.to(T);if(C.$Hs.isIPosition(T))return g.Position.to(T);if(A.$Is.isIRange(T.range)&&m.URI.isUri(T.uri))return g.location.to(T);if(T instanceof s.$ge)return T.buffer.buffer;if(!Array.isArray(T))return T})}}]}registerArgumentProcessor(w){this.f.push(w)}registerApiCommand(w){const p=this.registerCommand(!1,w.id,async(...E)=>{const L=w.args.map((U,F)=>{if(!U.validate(E[F]))throw new Error(`Invalid argument '${U.name}' when running '${w.id}', received: ${typeof E[F]=="object"?JSON.stringify(E[F],null,"	"):E[F]} `);return U.convert(E[F])}),T=await this.executeCommand(w.internalId,...L);return w.result.convert(T,E,this.converter)},void 0,{description:w.description,args:w.args,returns:w.result.description});return this.c.set(w.id,w),new N.$SK(()=>{p.dispose(),this.c.delete(w.id)})}registerCommand(w,p,E,L,T,U){if(this.d.trace("ExtHostCommands#registerCommand",p),!p.trim().length)throw new Error("invalid id");if(this.b.has(p))throw new Error(`command '${p}' already exists`);return this.b.set(p,{callback:E,thisArg:L,metadata:T,extension:U}),w&&this.#e.$registerCommand(p),new N.$SK(()=>{this.b.delete(p)&&w&&this.#e.$unregisterCommand(p)})}executeCommand(w,...p){return this.d.trace("ExtHostCommands#executeCommand",w),this.g(w,p,!0)}async g(w,p,E){if(this.b.has(w))return this.#e.$fireCommandActivationEvent(w),this.h(w,p,!1);{let L=!1;const T=(0,I.$ln)(p,function(U){if(U instanceof N.$TK)return g.Position.from(U);if(U instanceof N.$UK)return g.Range.from(U);if(U instanceof N.$5K)return g.location.from(U);if(N.$eM.isNotebookRange(U))return g.NotebookRange.from(U);if(U instanceof ArrayBuffer)return L=!0,s.$ge.wrap(new Uint8Array(U));if(U instanceof Uint8Array)return L=!0,s.$ge.wrap(U);if(U instanceof s.$ge)return L=!0,U;if(!Array.isArray(U))return U});try{const U=await this.#e.$executeCommand(w,L?new i.$Gv(T):T,E);return(0,y.$zh)(U)}catch(U){if(U instanceof Error&&U.message==="$executeCommand:retry")return this.g(w,p,!1);throw U}}}async h(w,p,E){const L=this.b.get(w);if(!L)throw new Error("Unknown command");const{callback:T,thisArg:U,metadata:F}=L;if(F?.args)for(let O=0;O<F.args.length;O++)try{(0,D.$Wf)(p[O],F.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${w}' failed. Illegal argument '${F.args[O].name}' - ${F.args[O].description}`)}const j=o.$Od.create();try{return await T.apply(U,p)}catch(O){if(w===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(...p);M&&(w=M.command)}if(this.d.error(O,w,L.extension?.identifier),!E)throw O;if(L.extension?.identifier){const M=this.#i.onExtensionError(L.extension.identifier,O);this.d.trace("forwarded error to extension?",M,L.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$Ni)(O)),this.id=w,this.source=L.extension?.displayName??L.extension?.name}}}finally{this.j(L,w,j.elapsed())}}j(w,p,E){w.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:w.extension.identifier.value,id:new c.$yo(p),duration:E})}$executeContributedCommand(w,...p){this.d.trace("ExtHostCommands#$executeContributedCommand",w);const E=this.b.get(w);return E?(p=p.map(L=>this.f.reduce((T,U)=>U.processArgument(T,E.extension?.identifier),L)),this.h(w,p,!0)):Promise.reject(new Error(`Contributed command '${w}' does not exist.`))}getCommands(w=!1){return this.d.trace("ExtHostCommands#getCommands",w),this.#e.$getCommands().then(p=>(w&&(p=p.filter(E=>E[0]!=="_")),p))}$getContributedCommandMetadata(){const w=Object.create(null);for(const[p,E]of this.b){const{metadata:L}=E;L&&(w[p]=L)}return Promise.resolve(w)}};e.$dN=d,e.$dN=d=Ge([We(0,l.$UM),We(1,$.$kj),We(2,t.$cN)],d),e.$eN=(0,k.$3h)("IExtHostCommands");class u{constructor(w,p,E){this.d=w,this.f=p,this.g=E,this.delegatingCommandId=`__vsc${(0,r.$ng)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(w,p){if(!w)return;const E={$ident:void 0,id:w.command,title:w.title,tooltip:w.tooltip};if(!w.command)return E;const L=this.f(w.command);if(L)E.id=L.internalId,E.arguments=L.args.map((T,U)=>T.convert(w.arguments&&w.arguments[U]));else if((0,b.$Lb)(w.arguments)){const T=`${w.command} /${++this.c}`;this.b.set(T,w),p.add((0,v.$Qc)(()=>{this.b.delete(T),this.g.trace("CommandsConverter#DISPOSE",T)})),E.$ident=T,E.id=this.delegatingCommandId,E.arguments=[T],this.g.trace("CommandsConverter#CREATE",w.command,T)}return E}fromInternal(w){return typeof w.$ident=="string"?this.b.get(w.$ident):{command:w.id,title:w.title,arguments:w.arguments}}getActualCommand(...w){return this.b.get(w[0])}h(...w){const p=this.getActualCommand(...w);return this.g.trace("CommandsConverter#EXECUTE",w[0],p?p.command:"MISSING"),p?this.d.executeCommand(p.command,...p.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${w[0]}`)}}e.$fN=u;class a{static{this.Uri=new a("uri","Uri of a text document",w=>m.URI.isUri(w),w=>w)}static{this.Position=new a("position","A position in a text document",w=>N.$TK.isPosition(w),g.Position.from)}static{this.Range=new a("range","A range in a text document",w=>N.$UK.isRange(w),g.Range.from)}static{this.Selection=new a("selection","A selection in a text document",w=>N.$VK.isSelection(w),g.Selection.from)}static{this.Number=new a("number","",w=>typeof w=="number",w=>w)}static{this.String=new a("string","",w=>typeof w=="string",w=>w)}static{this.StringArray=a.Arr(a.String)}static Arr(w){return new a(`${w.name}_array`,`Array of ${w.name}, ${w.description}`,p=>Array.isArray(p)&&p.every(E=>w.validate(E)),p=>p.map(E=>w.convert(E)))}static{this.CallHierarchyItem=new a("item","A call hierarchy item",w=>w instanceof N.$dL,g.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new a("item","A type hierarchy item",w=>w instanceof N.$xM,g.TypeHierarchyItem.from)}static{this.TestItem=new a("testItem","A VS Code TestItem",w=>w instanceof f.$8M,g.TestItem.from)}constructor(w,p,E,L){this.name=w,this.description=p,this.validate=E,this.convert=L}optional(){return new a(this.name,`(optional) ${this.description}`,w=>w==null||this.validate(w),w=>w===void 0?void 0:w===null?null:this.convert(w))}with(w,p){return new a(w??this.name,p??this.description,this.validate,this.convert)}}e.$gN=a;class h{static{this.Void=new h("no result",w=>w)}constructor(w,p){this.description=w,this.convert=p}}e.$hN=h;class S{constructor(w,p,E,L,T){this.id=w,this.internalId=p,this.description=E,this.args=L,this.result=T}}e.$iN=S}),define(Se[313],ke([1,0,19,17,2,83,131,46,35,15,7]),function(me,e,D,N,g,I,R,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=void 0;const C=[new $.$iN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$gN.Uri,$.$gN.Position],new $.$hN("A promise that resolves to an array of DocumentHighlight-instances.",v(y.DocumentHighlight.to))),new $.$iN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$gN.Uri],new $.$hN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,f)=>{if((0,D.$Kb)(l))return;class s extends A.$$K{static to(n){const o=new s(n.name,y.SymbolKind.to(n.kind),n.containerName||"",new A.$5K(f[0],y.Range.to(n.range)));return o.detail=n.detail,o.range=o.location.range,o.selectionRange=y.Range.to(n.selectionRange),o.children=n.children?n.children.map(s.to):[],o}}return l.map(s.to)})),new $.$iN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$gN.Uri,new $.$gN("options","Formatting options",l=>!0,l=>l)],new $.$hN("A promise that resolves to an array of TextEdits.",v(y.TextEdit.to))),new $.$iN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$gN.Uri,$.$gN.Range,new $.$gN("options","Formatting options",l=>!0,l=>l)],new $.$hN("A promise that resolves to an array of TextEdits.",v(y.TextEdit.to))),new $.$iN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$gN.Uri,$.$gN.Position,new $.$gN("ch","Trigger character",l=>typeof l=="string",l=>l),new $.$gN("options","Formatting options",l=>!0,l=>l)],new $.$hN("A promise that resolves to an array of TextEdits.",v(y.TextEdit.to))),new $.$iN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$gN.Uri,$.$gN.Position],new $.$hN("A promise that resolves to an array of Location or LocationLink instances.",k)),new $.$iN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$gN.Uri,$.$gN.Position],new $.$hN("A promise that resolves to an array of Location or LocationLink instances.",k)),new $.$iN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$gN.Uri,$.$gN.Position],new $.$hN("A promise that resolves to an array of Location or LocationLink instances.",k)),new $.$iN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$gN.Uri,$.$gN.Position],new $.$hN("A promise that resolves to an array of Location or LocationLink instances.",k)),new $.$iN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$gN.Uri,$.$gN.Position],new $.$hN("A promise that resolves to an array of Location-instances.",v(y.location.to))),new $.$iN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$gN.Uri,$.$gN.Position],new $.$hN("A promise that resolves to an array of Hover-instances.",v(y.Hover.to))),new $.$iN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$gN.Uri,new $.$gN("position","A position in a text document",l=>Array.isArray(l)&&l.every(f=>A.$TK.isPosition(f)),l=>l.map(y.Position.from))],new $.$hN("A promise that resolves to an array of ranges.",l=>l.map(f=>{let s;for(const i of f.reverse())s=new A.$cL(y.Range.to(i),s);return s}))),new $.$iN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$gN.String.with("query","Search string")],new $.$hN("A promise that resolves to an array of SymbolInformation-instances.",l=>l.map(y.WorkspaceSymbol.to))),new $.$iN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$gN.Uri,$.$gN.Position],new $.$hN("A promise that resolves to an array of CallHierarchyItem-instances",l=>l.map(y.CallHierarchyItem.to))),new $.$iN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$gN.CallHierarchyItem],new $.$hN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",l=>l.map(y.CallHierarchyIncomingCall.to))),new $.$iN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$gN.CallHierarchyItem],new $.$hN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",l=>l.map(y.CallHierarchyOutgoingCall.to))),new $.$iN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$gN.Uri,$.$gN.Position],new $.$hN("A promise that resolves to a range and placeholder text.",l=>{if(l)return{range:y.Range.to(l.range),placeholder:l.text}})),new $.$iN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$gN.Uri,$.$gN.Position,$.$gN.String.with("newName","The new symbol name")],new $.$hN("A promise that resolves to a WorkspaceEdit.",l=>{if(l){if(l.rejectReason)throw new Error(l.rejectReason);return y.WorkspaceEdit.to(l)}})),new $.$iN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$gN.Uri,$.$gN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$hN("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(y.DocumentLink.to))),new $.$iN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$gN.Uri],new $.$hN("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new A.$9L(l.tokenTypes,l.tokenModifiers)})),new $.$iN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$gN.Uri],new $.$hN("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const f=(0,R.$k$)(l);if(f.type==="full")return new A.$$L(f.data,void 0)})),new $.$iN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$gN.Uri,$.$gN.Range.optional()],new $.$hN("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new A.$9L(l.tokenTypes,l.tokenModifiers)})),new $.$iN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$gN.Uri,$.$gN.Range],new $.$hN("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const f=(0,R.$k$)(l);if(f.type==="full")return new A.$$L(f.data,void 0)})),new $.$iN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$gN.Uri,$.$gN.Position,$.$gN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$gN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$hN("A promise that resolves to a CompletionList-instance.",(l,f,s)=>{if(!l)return new A.$oL([]);const i=l.suggestions.map(n=>y.CompletionItem.to(n,s));return new A.$oL(i,l.incomplete)})),new $.$iN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$gN.Uri,$.$gN.Position,$.$gN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$hN("A promise that resolves to SignatureHelp.",l=>{if(l)return y.SignatureHelp.to(l)})),new $.$iN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$gN.Uri,$.$gN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$hN("A promise that resolves to an array of CodeLens-instances.",(l,f,s)=>v(i=>new A.$gL(y.Range.to(i.range),i.command&&s.fromInternal(i.command)))(l))),new $.$iN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$gN.Uri,new $.$gN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>A.$UK.isRange(l),l=>A.$VK.isSelection(l)?y.Selection.from(l):y.Range.from(l)),$.$gN.String.with("kind","Code action kind to return code actions for").optional(),$.$gN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$hN("A promise that resolves to an array of Command-instances.",(l,f,s)=>v(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(i.command)}else{const n=new A.$aL(i.title,i.kind?new A.$bL(i.kind):void 0);return i.edit&&(n.edit=y.WorkspaceEdit.to(i.edit)),i.command&&(n.command=s.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(l))),new $.$iN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$gN.Uri],new $.$hN("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(f=>new A.$uL(y.Range.to(f.range),y.Color.to(f.color))):[])),new $.$iN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$gN("color","The color to show and insert",l=>l instanceof A.$tL,y.Color.from),new $.$gN("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:y.Range.from(l.range)}))],new $.$hN("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(y.ColorPresentation.to):[])),new $.$iN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$gN.Uri,$.$gN.Range],new $.$hN("A promise that resolves to an array of Inlay objects",(l,f,s)=>l.map(y.InlayHint.to.bind(void 0,s)))),new $.$iN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$gN.Uri],new $.$hN("A promise that resolves to an array of FoldingRange objects",(l,f)=>{if(l)return l.map(y.FoldingRange.to)})),new $.$iN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$hN("A promise that resolves to an array of NotebookContentProvider static info objects.",v(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(f=>y.NotebookExclusiveDocumentPattern.to(f))})))),new $.$iN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$gN.Uri,$.$gN.Range,new $.$gN("context","An InlineValueContext",l=>l&&typeof l.frameId=="number"&&l.stoppedLocation instanceof A.$UK,l=>y.InlineValueContext.from(l))],new $.$hN("A promise that resolves to an array of InlineValue objects",l=>l.map(y.InlineValue.to))),new $.$iN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$gN("uriOrString","Uri-instance or string (only http/https)",l=>g.URI.isUri(l)||typeof l=="string"&&(0,N.$cg)(l,N.Schemas.http,N.Schemas.https),l=>l),new $.$gN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[y.ViewColumn.from(l),void 0]:[y.ViewColumn.from(l.viewColumn),y.TextEditorOpenOptions.from(l)])).optional(),$.$gN.String.with("label","").optional()],$.$hN.Void),new $.$iN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$gN.Uri.with("resource","Resource to open"),$.$gN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$gN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[y.ViewColumn.from(l),void 0]:[y.ViewColumn.from(l.viewColumn),y.TextEditorOpenOptions.from(l)])).optional()],$.$hN.Void),new $.$iN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$gN.Uri.with("left","Left-hand side resource of the diff editor"),$.$gN.Uri.with("right","Right-hand side resource of the diff editor"),$.$gN.String.with("title","Human readable title for the diff editor").optional(),new $.$gN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[y.ViewColumn.from(l.viewColumn),y.TextEditorOpenOptions.from(l)]).optional()],$.$hN.Void),new $.$iN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$gN.String.with("title","Human readable title for the changes editor"),new $.$gN("resourceList","List of resources to compare",l=>{for(const f of l){if(f.length!==3)return!1;const[s,i,n]=f;if(!g.URI.isUri(s)||!g.URI.isUri(i)&&i!==void 0&&i!==null||!g.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},l=>l)],$.$hN.Void),new $.$iN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$gN.Uri,$.$gN.Position],new $.$hN("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(y.TypeHierarchyItem.to))),new $.$iN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$gN.TypeHierarchyItem],new $.$hN("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(y.TypeHierarchyItem.to))),new $.$iN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$gN.TypeHierarchyItem],new $.$hN("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(y.TypeHierarchyItem.to))),new $.$iN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$gN.TestItem],$.$hN.Void),new $.$iN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$gN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$hN.Void),new $.$iN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$gN.String.with("name","The context key name"),new $.$gN("value","The context key value",()=>!0,l=>l)],$.$hN.Void),new $.$iN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$gN.Uri,$.$gN.StringArray,new $.$gN("MappedEditsContext","Mapped Edits Context",l=>y.MappedEditsContext.is(l),l=>y.MappedEditsContext.from(l))],new $.$hN("A promise that resolves to a workspace edit or null",l=>l?y.WorkspaceEdit.to(l):null))];class m{static register(f){C.forEach(f.registerApiCommand,f),this.a(f)}static a(f){f.registerCommand(!1,"_validateWhenClauses",b.$2i)}}e.$ofc=m;function v(l){return f=>{if(Array.isArray(f))return f.map(l)}}function k(l){if(!Array.isArray(l))return;const f=[];for(const s of l)I.$ut(s)?f.push(y.DefinitionLink.to(s)):f.push(y.location.to(s));return f}}),define(Se[314],ke([1,0,11,52,4,3,2,83,26,15,7,6,25]),function(me,e,D,N,g,I,R,b,$,y,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yfc=void 0;function v(k,l,f){const s=k.getProxy(C.$QK.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$km,l.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const S=this.b.get(h.handle);return S?S.value:h}else if(h&&h.$mid===7){const S=this.b.get(h.commentControlHandle);if(!S)return h;const P=S.getCommentThread(h.commentThreadHandle);return P?P.value:h}else if(h&&(h.$mid===9||h.$mid===8)){const S=this.b.get(h.thread.commentControlHandle);if(!S)return h;const P=S.getCommentThread(h.thread.commentThreadHandle);return P?h.$mid===8?P.value:{thread:P.value,text:h.text}:h}else if(h&&h.$mid===10){const S=this.b.get(h.thread.commentControlHandle);if(!S)return h;const P=S.getCommentThread(h.thread.commentThreadHandle);if(!P)return h;const w=h.commentUniqueId,p=P.getCommentByUniqueId(w);return p||h}else if(h&&h.$mid===11){const S=this.b.get(h.thread.commentControlHandle);if(!S)return h;const P=S.getCommentThread(h.thread.commentThreadHandle);if(!P)return h;const w=h.text,p=h.commentUniqueId,E=P.getCommentByUniqueId(p);return E?(typeof E.body=="string"?E.body=w:E.body=new A.$hL(w),E):h}return h}})}createCommentController(h,S,P){const w=i.a++,p=new o(h,w,S,P);this.b.set(p.handle,p);const E=this.c.get(h.identifier)||[];return E.push(p),this.c.set(h.identifier,E),p.value}async $createCommentThreadTemplate(h,S,P){const w=this.b.get(h);w&&w.$createCommentThreadTemplate(S,P)}async $updateCommentThreadTemplate(h,S,P){const w=this.b.get(h);w&&w.$updateCommentThreadTemplate(S,P)}$deleteCommentThread(h,S){this.b.get(h)?.$deleteCommentThread(S)}$provideCommentingRanges(h,S,P){const w=this.b.get(h);if(!w||!w.commentingRangeProvider)return Promise.resolve(void 0);const p=f.getDocument(R.URI.revive(S));return(0,D.$Vg)(async()=>{const E=await w.commentingRangeProvider.provideCommentingRanges(p,P);let L;return Array.isArray(E)?L={ranges:E,fileComments:!1}:E?L={ranges:E.ranges||[],fileComments:E.fileComments||!1}:L=E??void 0,L}).then(E=>{let L;return E&&(L={ranges:E.ranges.map(T=>y.Range.from(T)),fileComments:E.fileComments}),L})}$toggleReaction(h,S,P,w,p){const E=this.b.get(h);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,D.$Vg)(()=>{const L=E.getCommentThread(S);if(L){const T=L.getCommentByUniqueId(w.uniqueIdInThread);if(E!==void 0&&T&&E.reactionHandler)return E.reactionHandler(T,r(p))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(h){this.n=h}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(h){(h===void 0!=(this.p===void 0)||!h||!this.p||!h.isEqual(this.p))&&(this.p=h,this.b.range=h,this.c.fire())}get range(){return this.p}set canReply(h){this.d!==h&&(this.d=h,this.b.canReply=h,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(h){this.e=h,this.b.label=h,this.c.fire()}get contextValue(){return this.f}set contextValue(h){this.f=h,this.b.contextValue=h,this.c.fire()}get comments(){return this.q}set comments(h){this.q=h,this.b.comments=h,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(h){this.g=h,this.b.collapsibleState=h,this.c.fire()}get state(){return this.h}set state(h){this.h=h,this.b.state=h,this.c.fire()}get isDisposed(){return this.j}constructor(h,S,P,w,p,E,L,T){this.m=S,this.n=P,this.o=w,this.p=p,this.q=E,this.extensionDescription=L,this.r=T,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new g.$Sd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new I.$Tc,this.l.value=new I.$Rc,this.n===void 0&&(this.n=`${h}.${this.handle}`),s.$createCommentThread(S,this.handle,this.n,this.o,y.Range.from(this.p),L.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this.i.push({dispose:()=>{s.$deleteCommentThread(S,this.handle)}});const U=this;this.value={get uri(){return U.uri},get range(){return U.range},set range(F){U.range=F},get comments(){return U.comments},set comments(F){U.comments=F},get collapsibleState(){return U.collapsibleState},set collapsibleState(F){U.collapsibleState=F},get canReply(){return U.canReply},set canReply(F){U.canReply=F},get contextValue(){return U.contextValue},set contextValue(F){U.contextValue=F},get label(){return U.label},set label(F){U.label=F},get state(){return U.state},set state(F){U.state=F},dispose:()=>{U.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new I.$Rc);const h=P=>Object.prototype.hasOwnProperty.call(this.b,P),S={};h("range")&&(S.range=y.Range.from(this.p)),h("label")&&(S.label=this.label),h("contextValue")&&(S.contextValue=this.contextValue??null),h("comments")&&(S.comments=this.q.map(P=>c(this,P,this.k,this.extensionDescription))),h("collapsibleState")&&(S.collapseState=d(this.g)),h("canReply")&&(S.canReply=this.canReply),h("state")&&(S.state=u(this.h)),h("isTemplate")&&(S.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(h){for(const S of this.k){const P=S[0],w=S[1];if(h===w)return P}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(h=>h.dispose())}}Ge([(0,N.$vh)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class o{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(h){this.b=h,s.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(h){this.c=h,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this.d}set options(h){this.d=h,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(h,S,P,w){this.f=h,this.g=S,this.h=P,this.i=w,this.a=new Map,s.$registerCommentController(this.handle,P,w,this.f.identifier.value);const p=this;this.value=Object.freeze({id:p.id,label:p.label,get options(){return p.options},set options(E){p.options=E},get commentingRangeProvider(){return p.commentingRangeProvider},set commentingRangeProvider(E){p.commentingRangeProvider=E},get reactionHandler(){return p.reactionHandler},set reactionHandler(E){p.reactionHandler=E},createCommentThread(E,L,T){return p.createCommentThread(E,L,T).value},dispose:()=>{p.dispose()}}),this.e=[],this.e.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(h,S,P){S===void 0&&(0,m.$pF)(this.f,"fileComments");const w=new n(this.id,this.handle,void 0,h,S,P,this.f,!1);return this.a.set(w.handle,w),w}$createCommentThreadTemplate(h,S){const P=new n(this.id,this.handle,void 0,R.URI.revive(h),y.Range.to(S),[],this.f,!0);return P.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(P.handle,P),P}$updateCommentThreadTemplate(h,S){const P=this.a.get(h);P&&(P.range=y.Range.to(S))}$deleteCommentThread(h){this.a.get(h)?.dispose(),this.a.delete(h)}getCommentThread(h){return this.a.get(h)}dispose(){this.a.forEach(h=>{h.dispose()}),this.e.forEach(h=>h.dispose())}}function c(a,h,S,P){let w=S.get(h);return w||(w=++a.commentHandle,S.set(h,w)),h.state!==void 0&&(0,m.$pF)(P,"commentsDraftState"),h.reactions?.some(p=>p.reactors!==void 0)&&(0,m.$pF)(P,"commentReactor"),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:w,body:typeof h.body=="string"?h.body:y.MarkdownString.from(h.body),userName:h.author.name,userIconPath:h.author.iconPath,label:h.label,commentReactions:h.reactions?h.reactions.map(p=>t(p)):void 0,state:h.state,timestamp:h.timestamp?.toJSON()}}function t(a){return{label:a.label,iconPath:a.iconPath?y.$TM(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted,reactors:a.reactors}}function r(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?R.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1,reactors:a.reactors}}function d(a){if(a!==void 0)switch(a){case A.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function u(a){if(a!==void 0)switch(a){case A.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}return new i}e.$yfc=v}),define(Se[315],ke([1,0,24,6,27,20]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=void 0;let R=class{constructor(A,C){this.a=A.getProxy(N.$QK.MainThreadConsole),this.b=C.consoleForward.includeStack,this.c=C.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,C){const m=this,v=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){m.e(A,C,v,arguments)}})}e(A,C,m,v){this.a.$logExtensionHostMessage({type:"__$console",severity:C,arguments:$(v,this.b)}),this.c&&this.f(A,m,v)}};e.$mhc=R,e.$mhc=R=Ge([We(0,I.$UM),We(1,g.$$M)],R);const b=1e5;function $(y,A){const C=[];if(y.length)for(let m=0;m<y.length;m++){let v=y[m];if(typeof v>"u")v="undefined";else if(v instanceof Error){const k=v;k.stack?v=k.stack:v=k.toString()}C.push(v)}if(A){const m=new Error().stack;m&&C.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,D.$on)(C);return m.length>b?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(Se[149],ke([1,0,2,6,7,5,20,13,19,12,16,25]),function(me,e,D,N,g,I,R,b,$,y,A,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=e.$ogc=void 0;let v=class{static{m=this}static{this.c=0}static{this.d=250}constructor(l,f){this.h=f,this.f=new Map,this.g=l.getProxy(N.$QK.MainThreadDecorations)}registerFileDecorationProvider(l,f){const s=m.c++;this.f.set(s,{provider:l,extensionDescription:f}),this.g.$registerDecorationProvider(s,f.identifier.value);const i=l.onDidChangeFileDecorations&&l.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(s,null);return}const o=(0,$.$3b)(n);if(o.length<=m.d){this.g.$onDidChange(s,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",f.identifier.value,o.length);const c=o.map(d=>({uri:d,rank:(0,y.$Me)(d.path,"/")})),t=(0,$.$zb)(c,(d,u)=>d.rank-u.rank||(0,y.$2e)(d.uri.path,u.uri.path)),r=[];e:for(const d of t){let u;for(const a of d){const h=(0,A.$mc)(a.uri.path);if(u!==h&&(u=h,r.push(a.uri)>=m.d))break e}}this.g.$onDidChange(s,r)});return new g.$SK(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(l,f,s){if(!this.f.has(l))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:o}=this.f.get(l);return await Promise.all(f.map(async c=>{try{const{uri:t,id:r}=c,d=await Promise.resolve(n.provideFileDecoration(D.URI.revive(t),s));if(!d)return;try{g.$cM.validate(d),d.badge&&typeof d.badge!="string"&&(0,C.$pF)(o,"codiconDecoration"),i[r]=[d.propagate,d.tooltip,d.badge,d.color]}catch(u){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${u}`)}}catch(t){this.h.error(t)}})),i}};e.$ogc=v,e.$ogc=v=m=Ge([We(0,R.$UM),We(1,b.$kj)],v),e.$pgc=(0,I.$3h)("IExtHostDecorations")}),define(Se[316],ke([1,0,211,135,2,6,7,15,4,13,28,58]),function(me,e,D,N,g,I,R,b,$,y,A,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=e.$ifc=void 0;class v{#e;#t;#i;constructor(f,s,i,n,o,c,t,r){this.d=f,this.e=s,this.f=i,this.g=n,this.h=o,this.c=!1,this.f=Math.max(n,i),this.#i=new A.$Ac(d=>c.getComparisonKey(d)),this.#e=t,this.#t=r}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(f,s){if(!f){this.clear();return}this.j();let i=[];if(g.URI.isUri(f)){if(!s){this.delete(f);return}this.#i.set(f,s.slice()),i=[f]}else if(Array.isArray(f)){i=[];let c;f=[...f].sort(v.k);for(const t of f){const[r,d]=t;if((!c||r.toString()!==c.toString())&&(c&&this.#i.get(c).length===0&&this.#i.delete(c),c=r,i.push(r),this.#i.set(r,[])),d)this.#i.get(r)?.push(...d);else{const u=this.#i.get(r);u&&(u.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let o=0;for(const c of i){let t=[];const r=this.#i.get(c);if(r)if(r.length>this.g){t=[];const d=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let u=0;u<4;u++)for(const a of r)if(a.severity===d[u]&&t.push({...b.Diagnostic.from(a),modelVersionId:this.h(c)})===this.g)break e;t.push({severity:N.MarkerSeverity.Info,message:(0,D.localize)(0,null,r.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=r.map(d=>({...b.Diagnostic.from(d),modelVersionId:this.h(c)}));if(n.push([c,t]),o+=t.length,o>this.f)break}this.#e.$changeMany(this.e,n)}delete(f){this.j(),this.#t.fire([f]),this.#i.delete(f),this.#e?.$changeMany(this.e,[[f,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(f,s){this.j();for(const[i,n]of this)f.call(s,i,n,this)}*[Symbol.iterator](){this.j();for(const f of this.#i.keys())yield[f,this.get(f)]}get(f){this.j();const s=this.#i.get(f);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(f){return this.j(),Array.isArray(this.#i.get(f))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(f,s){return f[0].toString()<s[0].toString()?-1:f[0].toString()>s[0].toString()?1:0}}e.$ifc=v;let k=class{static{m=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*m.d}static _mapper(f){const s=new A.$Ac;for(const i of f)s.set(i,i);return{uris:Object.freeze(Array.from(s.values()))}}constructor(f,s,i,n){this.j=s,this.k=i,this.l=n,this.g=new Map,this.h=new $.$Wd({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,m._mapper),this.f=f.getProxy(I.$QK.MainThreadDiagnostics)}createDiagnosticCollection(f,s){const{g:i,f:n,h:o,j:c,k:t,l:r}=this,d=new class{$changeMany(h,S){n.$changeMany(h,S),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",f.value,h,S.length===0?"CLEARING":S)}$clear(h){n.$clear(h),c.trace("[DiagnosticCollection] remove all (extension, owner)",f.value,h)}dispose(){n.dispose()}};let u;if(!s)s="_generated_diagnostic_collection_name_#"+m.c++,u=s;else if(!i.has(s))u=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do u=s+m.c++;while(i.has(u))}return new class extends v{constructor(){super(s,u,m.e,m.d,h=>r.getDocument(h)?.version,t.extUri,d,o),i.set(u,this)}dispose(){super.dispose(),i.delete(u)}}}getDiagnostics(f){if(f)return this.m(f);{const s=new Map,i=[];for(const n of this.g.values())n.forEach((o,c)=>{let t=s.get(o.toString());typeof t>"u"&&(t=i.length,s.set(o.toString(),t),i.push([o,[]])),i[t][1]=i[t][1].concat(...c)});return i}}m(f){let s=[];for(const i of this.g.values())i.has(f)&&(s=s.concat(i.get(f)));return s}$acceptMarkersChange(f){if(!this.n){const s="_generated_mirror",i=new v(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(s,i),this.n=i}for(const[s,i]of f)this.n.set(g.URI.revive(s),i.map(b.Diagnostic.to))}};e.$jfc=k,e.$jfc=k=m=Ge([We(1,y.$kj),We(2,C.$hfc)],k)}),define(Se[317],ke([1,0,2,6,25]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=void 0;class I{constructor(b){this.a=b.getProxy(N.$QK.MainThreadDialogs)}showOpenDialog(b,$){return $?.allowUIResources&&(0,g.$pF)(b,"showLocal"),this.a.$showOpenDialog($).then(y=>y?y.map(A=>D.URI.revive(A)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then($=>$?D.URI.revive($):void 0)}}e.$qgc=I}),define(Se[318],ke([1,0,14,2,7,6,17,21,12]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0;class y{static{this.a=0}constructor(C,m,v){this.d=m,this.e=v,this.b=new Map,this.c=C.getProxy(I.$QK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,m){if(Object.keys(R.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const v=y.a++;this.b.set(v,m),this.c.$registerTextContentProvider(v,C);let k;if(typeof m.onDidChange=="function"){let l;k=m.onDidChange(async f=>{if(f.scheme!==C){this.e.warn(`Provider for scheme '${C}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(f))return;l&&await l;const s=this.$provideTextDocumentContent(v,f).then(async i=>{if(!i&&typeof i!="string")return;const n=this.d.getDocument(f);if(!n)return;const o=(0,$.$We)(i);if(!n.equalLines(o))return this.c.$onVirtualDocumentChange(f,i)}).catch(D.$1).finally(()=>{l===s&&(l=void 0)});l=s})}return new g.$SK(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),k&&(k.dispose(),k=void 0)})}$provideTextDocumentContent(C,m){const v=this.b.get(C);return v?Promise.resolve(v.provideTextDocumentContent(N.URI.revive(m),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.$rgc=y}),define(Se[319],ke([1,0,4,3,2,6,141,15,18,24,7]),function(me,e,D,N,g,I,R,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=void 0;class C{constructor(v,k){this.a=new D.$Sd,this.b=new D.$Sd,this.c=new D.$Sd,this.d=new D.$Sd,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new N.$Rc,this.h=new Map,this.f=v.getProxy(I.$QK.MainThreadDocuments),this.g=k,this.g.onDidRemoveDocuments(l=>{for(const f of l)this.b.fire(f.document)},void 0,this.e),this.g.onDidAddDocuments(l=>{for(const f of l)this.a.fire(f.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const k=this.g.getDocument(v);if(k)return k}getDocument(v){const k=this.getDocumentData(v);if(!k?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return k.document}ensureDocumentData(v){const k=this.g.getDocument(v);if(k)return Promise.resolve(k);let l=this.h.get(v.toString());return l||(l=this.f.$tryOpenDocument(v).then(f=>{this.h.delete(v.toString());const s=g.URI.revive(f);return(0,$.$Qf)(this.g.getDocument(s))},f=>(this.h.delete(v.toString()),Promise.reject(f))),this.h.set(v.toString(),l)),l}createDocumentData(v){return this.f.$tryCreateDocument(v).then(k=>g.URI.revive(k))}$acceptModelLanguageChanged(v,k){const l=g.URI.revive(v),f=this.g.getDocument(l);if(!f)throw new Error("unknown document");this.b.fire(f.document),f._acceptLanguageId(k),this.a.fire(f.document)}$acceptModelSaved(v){const k=g.URI.revive(v),l=this.g.getDocument(k);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(l.document)}$acceptDirtyStateChanged(v,k){const l=g.URI.revive(v),f=this.g.getDocument(l);if(!f)throw new Error("unknown document");f._acceptIsDirty(k),this.c.fire({document:f.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,k,l){const f=g.URI.revive(v),s=this.g.getDocument(f);if(!s)throw new Error("unknown document");s._acceptIsDirty(l),s.onEvents(k);let i;k.isUndoing?i=A.TextDocumentChangeReason.Undo:k.isRedoing&&(i=A.TextDocumentChangeReason.Redo),this.c.fire((0,y.$kn)({document:s.document,contentChanges:k.changes.map(n=>({range:b.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:i}))}setWordDefinitionFor(v,k){(0,R.$WM)(v,k)}}e.$ffc=C}),define(Se[69],ke([1,0,60,4,3,2,5,6,141,20,148,15,13,28,17,53,43]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6M=e.$5M=void 0;class s{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(o,c){this.h=o,this.i=c,this.a=null,this.b=new Map,this.c=new v.$Ac,this.d=new N.$Sd,this.e=new N.$Sd,this.f=new N.$Sd,this.g=new N.$Sd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const c=[],t=[],r=[];if(o.removedDocuments)for(const d of o.removedDocuments){const u=I.URI.revive(d),a=this.c.get(u);a?.unref()&&(this.c.delete(u),c.push(a.value))}if(o.addedDocuments)for(const d of o.addedDocuments){const u=I.URI.revive(d.uri);let a=this.c.get(u);if(a&&u.scheme!==k.Schemas.vscodeNotebookCell&&u.scheme!==k.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);a||(a=new s(new $.$XM(this.h.getProxy(b.$QK.MainThreadDocuments),u,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty,d.notebook)),this.c.set(u,a),t.push(a.value)),a.ref()}if(o.removedEditors)for(const d of o.removedEditors){const u=this.b.get(d);this.b.delete(d),u&&r.push(u)}if(o.addedEditors)for(const d of o.addedEditors){const u=I.URI.revive(d.documentUri);D.ok(this.c.has(u),`document '${u}' does not exist`),D.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const a=this.c.get(u).value,h=new A.$4M(d.id,this.h.getProxy(b.$QK.MainThreadTextEditors),this.i,new f.$V(()=>a.document),d.selections.map(C.Selection.to),d.options,d.visibleRanges.map(S=>C.Range.to(S)),typeof d.editorPosition=="number"?C.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,h)}o.newActiveEditor!==void 0&&(D.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,g.$Nc)(c),(0,g.$Nc)(r),o.removedDocuments&&this.e.fire(c),o.addedDocuments&&this.d.fire(t),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return l.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const c=this.b.get(this.a);return o?c:c?.value}allEditors(){return[...this.b.values()]}};e.$5M=i,e.$5M=i=Ge([We(0,y.$UM),We(1,m.$kj)],i),e.$6M=(0,R.$3h)("IExtHostDocumentsAndEditors")}),define(Se[70],ke([1,0,73,4,18,2,5,6,20,15,7]),function(me,e,D,N,g,I,R,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfc=e.$Rfc=void 0,e.$Rfc=(0,R.$3h)("IExtHostEditorTabs");class C{constructor(f,s,i){this.e=i,this.d=s,this.acceptDtoUpdate(f)}get apiObject(){if(!this.a){const f=this,s={get isActive(){return f.b.id===f.e()},get label(){return f.b.label},get input(){return f.c},get isDirty(){return f.b.isDirty},get isPinned(){return f.b.isPinned},get isPreview(){return f.b.isPreview},get group(){return f.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(f){this.b=f,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$yM(I.URI.revive(this.b.input.uri));case 2:return new A.$zM(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified));case 3:return new A.$AM(I.URI.revive(this.b.input.base),I.URI.revive(this.b.input.input1),I.URI.revive(this.b.input.input2),I.URI.revive(this.b.input.result));case 6:return new A.$BM(I.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$CM(this.b.input.viewType);case 4:return new A.$DM(I.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$EM(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$FM;case 9:return new A.$GM(I.URI.revive(this.b.input.uri),I.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$HM(this.b.input.providerId);default:return}}}class m{constructor(f,s){this.c=[],this.d="",this.b=f,this.e=s;for(const i of f.tabs)i.isActive&&(this.d=i.id),this.c.push(new C(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const f=this,s={get isActive(){return f.b.groupId===f.e()},get viewColumn(){return y.ViewColumn.to(f.b.viewColumn)},get activeTab(){return f.c.find(i=>i.tabId===f.d)?.apiObject},get tabs(){return Object.freeze(f.c.map(i=>i.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(f){this.b=f}acceptTabOperation(f){if(f.kind===0){const i=new C(f.tabDto,this,()=>this.activeTabId());return this.c.splice(f.index,0,i),f.tabDto.isActive&&(this.d=i.tabId),i}else if(f.kind===1){const i=this.c.splice(f.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${f.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(f.kind===3){if(f.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(f.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${f.oldIndex} which does not exist`);return this.c.splice(f.index,0,i),i}const s=this.c.find(i=>i.tabId===f.tabDto.id);if(!s)throw new Error("INVALID tab");return f.tabDto.isActive?this.d=f.tabDto.id:this.d===f.tabDto.id&&!f.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(f.tabDto),s}activeTabId(){return this.d}}let v=class{constructor(f){this.b=new N.$Sd,this.c=new N.$Sd,this.e=[],this.a=f.getProxy(b.$QK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const f=this,s={onDidChangeTabGroups:f.c.event,onDidChangeTabs:f.b.event,get all(){return Object.freeze(f.e.map(i=>i.apiObject))},get activeTabGroup(){const i=f.d;return(0,g.$Qf)(f.e.find(o=>o.groupId===i)?.apiObject)},close:async(i,n)=>{const o=Array.isArray(i)?i:[i];return o.length?k(o[0])?this.j(o,n):this.i(o,n):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(f){const s=new Set(this.e.map(d=>d.groupId)),i=new Set(f.map(d=>d.groupId)),n=(0,D.$L)(s,i),o=this.e.filter(d=>n.removed.includes(d.groupId)).map(d=>d.apiObject),c=[],t=[];this.e=f.map(d=>{const u=new m(d,()=>this.d);return n.added.includes(u.groupId)?c.push(u.apiObject):t.push(u.apiObject),u});const r=(0,g.$Qf)(f.find(d=>d.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:c,closed:o,changed:t}))}$acceptTabGroupUpdate(f){const s=this.e.find(i=>i.groupId===f.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(f),f.isActive&&(this.d=f.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(f){const s=this.e.find(n=>n.groupId===f.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const i=s.acceptTabOperation(f);switch(f.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(f){for(const s of this.e)for(const i of s.tabs)if(i.apiObject===f)return i}h(f){return this.e.find(s=>s.apiObject===f)}async i(f,s){const i=[];for(const n of f){const o=this.g(n);if(!o)throw new Error("Tab close: Invalid tab not found!");i.push(o.tabId)}return this.a.$closeTab(i,s)}async j(f,s){const i=[];for(const n of f){const o=this.h(n);if(!o)throw new Error("Group close: Invalid group not found!");i.push(o.groupId)}return this.a.$closeGroup(i,s)}};e.$Sfc=v,e.$Sfc=v=Ge([We(0,$.$UM)],v);function k(l){return l.tabs!==void 0}}),define(Se[320],ke([1,0,6,7]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=void 0;class g{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(D.$QK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,b,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const y=this.a.get(R);if(!y)throw new Error("Embedding vector provider not found");const A=await y.provideEmbeddingVector(b,$);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,b,$){const y=this.b;return this.b++,this.a.set(y,$),this.c.$registerAiEmbeddingVectorProvider(b,y),new N.$SK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(y),this.a.delete(y)})}}e.$tgc=g}),define(Se[321],ke([1,0,2,6,3,7,15,173,12,22,25,80]),function(me,e,D,N,g,I,R,b,$,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=void 0;class m{constructor(){this.a=[]}add(l){this.b=void 0,this.a.push(l)}delete(l){const f=this.a.indexOf(l);f>=0&&(this.a.splice(f,1),this.b=void 0)}c(){if(!this.b){const l=this.a.sort(),f=[];let s,i,n=14,o=14;for(const c of l){let t=s?(0,$.$$e)(s,c):0;for(t===0?i=1:i=o;t<c.length;t++)t+1===c.length?(n=o,o=9):o+=1,f.push([i,c.toUpperCase().charCodeAt(t),o]),f.push([i,c.toLowerCase().charCodeAt(t),o]),i=o;s=c,o=n}f.push([9,58,10]),f.push([10,47,12]),this.b=new b.$oZ(f)}}provideDocumentLinks(l){this.c();const f=[],s=b.$pZ.computeLinks({getLineContent(i){return l.lineAt(i-1).text},getLineCount(){return l.lineCount}},this.b);for(const i of s){const n=R.DocumentLink.to(i);n.target&&f.push(n)}return f}}class v{constructor(l,f){this.i=f,this.b=new m,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=l.getProxy(N.$QK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(l,f,s,i={}){if(v.j(s),this.d.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(l,"*",this.b));const n=this.h++;this.b.add(f),this.d.add(f),this.c.set(n,s);let o=2;i.isCaseSensitive&&(o+=1024),i.isReadonly&&(o+=2048),typeof s.copy=="function"&&(o+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,A.$pF)(l,"fsChunks"),o+=4);let c;i.isReadonly&&(0,C.$gk)(i.isReadonly)&&((0,A.$pF)(l,"readonlyMessage"),c={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,f,o,c).catch(r=>{console.error(`FAILED to register filesystem provider of ${l.identifier.value}-extension for the scheme ${f}`),console.error(r)});const t=s.onDidChangeFile(r=>{const d=[];for(const u of r){const{uri:a,type:h}=u;if(a.scheme!==f)continue;let S;switch(h){case I.FileChangeType.Changed:S=0;break;case I.FileChangeType.Created:S=1;break;case I.FileChangeType.Deleted:S=2;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:a,type:S})}this.a.$onFileSystemChange(n,d)});return(0,g.$Qc)(()=>{t.dispose(),this.b.delete(f),this.d.delete(f),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(l){if(!l)throw new Error("MISSING provider");if(typeof l.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof l.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof l.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof l.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof l.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof l.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof l.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof l.rename!="function")throw new Error("Provider does NOT implement rename")}static k(l){const{type:f,ctime:s,mtime:i,size:n,permissions:o}=l;return{type:f,ctime:s,mtime:i,size:n,permissions:o}}$stat(l,f){return Promise.resolve(this.l(l).stat(D.URI.revive(f))).then(s=>v.k(s))}$readdir(l,f){return Promise.resolve(this.l(l).readDirectory(D.URI.revive(f)))}$readFile(l,f){return Promise.resolve(this.l(l).readFile(D.URI.revive(f))).then(s=>y.$ge.wrap(s))}$writeFile(l,f,s,i){return Promise.resolve(this.l(l).writeFile(D.URI.revive(f),s.buffer,i))}$delete(l,f,s){return Promise.resolve(this.l(l).delete(D.URI.revive(f),s))}$rename(l,f,s,i){return Promise.resolve(this.l(l).rename(D.URI.revive(f),D.URI.revive(s),i))}$copy(l,f,s,i){const n=this.l(l);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(D.URI.revive(f),D.URI.revive(s),i))}$mkdir(l,f){return Promise.resolve(this.l(l).createDirectory(D.URI.revive(f)))}$watch(l,f,s,i){const n=this.l(l).watch(D.URI.revive(s),i);this.f.set(f,n)}$unwatch(l,f){const s=this.f.get(f);s&&(s.dispose(),this.f.delete(f))}$open(l,f,s){const i=this.l(l);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(D.URI.revive(f),s))}$close(l,f){const s=this.l(l);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(f))}$read(l,f,s,i){const n=this.l(l);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const o=y.$ge.alloc(i);return Promise.resolve(n.read(f,s,o.buffer,0,i)).then(c=>o.slice(0,c))}$write(l,f,s,i){const n=this.l(l);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(f,s,i.buffer,0,i.byteLength))}l(l){const f=this.c.get(l);if(!f){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return f}}e.$ugc=v}),define(Se[71],ke([1,0,6,32,7,22,5,20,58,3,11,23,17]),function(me,e,D,N,g,I,R,b,$,y,A,C,m){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=e.$Gfc=void 0;let k=v=class{constructor(f,s){this.b=new Map,this.c=new A.$_g,this.a=f.getProxy(D.$QK.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let o;const c=i.b.get(n.scheme);return c?(await i.a.$ensureActivation(n.scheme),o=await c.impl.stat(n)):o=await i.a.$stat(n),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===N.FilePermission.Readonly?1:void 0}}catch(o){v.e(o)}},async readDirectory(n){try{const o=i.b.get(n.scheme);return o?(await i.a.$ensureActivation(n.scheme),(await o.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(o){return v.e(o)}},async createDirectory(n){try{const o=i.b.get(n.scheme);return o&&!o.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(o.impl,o.extUri,n)):await i.a.$mkdir(n)}catch(o){return v.e(o)}},async readFile(n){try{const o=i.b.get(n.scheme);return o?(await i.a.$ensureActivation(n.scheme),(await o.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(o){return v.e(o)}},async writeFile(n,o){try{const c=i.b.get(n.scheme);return c&&!c.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(c.impl,c.extUri,c.extUri.dirname(n)),await i.c.queueFor(n).queue(()=>Promise.resolve(c.impl.writeFile(n,o,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,I.$ge.wrap(o))}catch(c){return v.e(c)}},async delete(n,o){try{const c=i.b.get(n.scheme);return c&&!c.isReadonly?(await i.a.$ensureActivation(n.scheme),await c.impl.delete(n,{recursive:!1,...o})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(c){return v.e(c)}},async rename(n,o,c){try{return await i.a.$rename(n,o,{overwrite:!1,...c})}catch(t){return v.e(t)}},async copy(n,o,c){try{return await i.a.$copy(n,o,{overwrite:!1,...c})}catch(t){return v.e(t)}},isWritableFileSystem(n){const o=s.getCapabilities(n);if(typeof o=="number")return!(o&2048)}})}async d(f,s,i){const n=[];for(;!s.isEqual(i,s.dirname(i));)try{if(!((await f.stat(i)).type&N.FileType.Directory))throw g.$7L.FileExists(`Unable to create folder '${i.scheme===m.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(N.$Dk(o)!==N.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(s.basename(i)),i=s.dirname(i)}for(let o=n.length-1;o>=0;o--){i=s.joinPath(i,n[o]);try{await f.createDirectory(i)}catch(c){if(N.$Dk(c)!==N.FileSystemProviderErrorCode.FileExists)throw c}}}static e(f){if(f instanceof g.$7L)throw f;if(f instanceof N.$zk)switch(f.code){case N.FileSystemProviderErrorCode.FileExists:throw g.$7L.FileExists(f.message);case N.FileSystemProviderErrorCode.FileNotFound:throw g.$7L.FileNotFound(f.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw g.$7L.FileNotADirectory(f.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw g.$7L.FileIsADirectory(f.message);case N.FileSystemProviderErrorCode.NoPermissions:throw g.$7L.NoPermissions(f.message);case N.FileSystemProviderErrorCode.Unavailable:throw g.$7L.Unavailable(f.message);default:throw new g.$7L(f.message,f.name)}if(!(f instanceof Error))throw new g.$7L(String(f));if(f.name==="ENOPRO"||f.message.includes("ENOPRO"))throw g.$7L.Unavailable(f.message);switch(f.name){case N.FileSystemProviderErrorCode.FileExists:throw g.$7L.FileExists(f.message);case N.FileSystemProviderErrorCode.FileNotFound:throw g.$7L.FileNotFound(f.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw g.$7L.FileNotADirectory(f.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw g.$7L.FileIsADirectory(f.message);case N.FileSystemProviderErrorCode.NoPermissions:throw g.$7L.NoPermissions(f.message);case N.FileSystemProviderErrorCode.Unavailable:throw g.$7L.Unavailable(f.message);default:throw new g.$7L(f.message,f.name)}}addFileSystemProvider(f,s,i){return this.b.set(f,{impl:s,extUri:i?.isCaseSensitive?C.$ug:C.$wg,isReadonly:!!i?.isReadonly}),(0,y.$Qc)(()=>this.b.delete(f))}getFileSystemProviderExtUri(f){return this.b.get(f)?.extUri??C.$ug}};e.$Gfc=k,e.$Gfc=k=v=Ge([We(0,b.$UM),We(1,$.$hfc)],k),e.$Hfc=(0,R.$3h)("IExtHostConsumerFileSystem")}),define(Se[322],ke([1,0,4,34,2,6,15,7,43]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=void 0;class y{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(v,k,l,f,s,i){this.a=Math.random(),this.b=new D.$Sd,this.c=new D.$Sd,this.d=new D.$Sd,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,N.$Jj)(s),o=typeof s=="string",c=i?.correlate,t=f(r=>{if(!(typeof r.session=="number"&&r.session!==this.a)&&!(c&&typeof r.session>"u")){if(!i?.ignoreCreateEvents)for(const d of r.created){const u=g.URI.revive(d);n(u.fsPath)&&(!o||k.getWorkspaceFolder(u))&&this.b.fire(u)}if(!i?.ignoreChangeEvents)for(const d of r.changed){const u=g.URI.revive(d);n(u.fsPath)&&(!o||k.getWorkspaceFolder(u))&&this.c.fire(u)}if(!i?.ignoreDeleteEvents)for(const d of r.deleted){const u=g.URI.revive(d);n(u.fsPath)&&(!o||k.getWorkspaceFolder(u))&&this.d.fire(u)}}});this.g=b.$SK.from(this.i(v,l,s,i,i?.correlate),this.b,this.c,this.d,t)}i(v,k,l,f,s){const i=b.$SK.from();if(typeof l=="string")return i;const n=v.getProxy(I.$QK.MainThreadFileSystemEventService);let o=!1;return(l.pattern.includes(N.$Fj)||l.pattern.includes(N.$Gj))&&(o=!0),n.$watch(k.identifier.value,this.a,l.baseUri,{recursive:o,excludes:f?.excludes??[]},!!s),b.$SK.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(v){this.a=v,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(g.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(g.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(g.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class C{constructor(v,k,l){this.j=v,this.k=k,this.l=l,this.a=new D.$Sd,this.b=new D.$Sd,this.c=new D.$Sd,this.d=new D.$Sd,this.g=new D.$Ud,this.h=new D.$Ud,this.i=new D.$Ud,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(v,k,l,f){return new y(this.j,v,k,this.a.event,R.GlobPattern.from(l),f)}$onFileEvent(v){this.a.fire(new A(v))}$onDidRunFileOperation(v,k){switch(v){case 2:this.b.fire(Object.freeze({files:k.map(l=>({oldUri:g.URI.revive(l.source),newUri:g.URI.revive(l.target)}))}));break;case 1:this.d.fire(Object.freeze({files:k.map(l=>g.URI.revive(l.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:k.map(l=>g.URI.revive(l.target))}));break;default:}}getOnWillRenameFileEvent(v){return this.m(v,this.g)}getOnWillCreateFileEvent(v){return this.m(v,this.h)}getOnWillDeleteFileEvent(v){return this.m(v,this.i)}m(v,k){return(l,f,s)=>{const i=function(o){l.call(f,o)};return i.extension=v,k.event(i,void 0,s)}}async $onWillRunFileOperation(v,k,l,f){switch(v){case 2:return await this.n(this.g,{files:k.map(s=>({oldUri:g.URI.revive(s.source),newUri:g.URI.revive(s.target)}))},l,f);case 1:return await this.n(this.i,{files:k.map(s=>g.URI.revive(s.target))},l,f);case 0:case 3:return await this.n(this.h,{files:k.map(s=>g.URI.revive(s.target))},l,f)}}async n(v,k,l,f){const s=new Set,i=[];if(await v.fireAsync(k,f,async(o,c)=>{const t=Date.now(),r=await Promise.resolve(o);r instanceof b.$3K&&(i.push([c.extension,r]),s.add(c.extension.displayName??c.extension.identifier.value)),Date.now()-t>l&&this.k.warn("SLOW file-participant",c.extension.identifier)}),f.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,o]of i){const{edits:c}=R.WorkspaceEdit.from(o,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(c)}return{edit:n,extensionNames:Array.from(s)}}}e.$vgc=C}),define(Se[323],ke([1,0,3,2,6,15,7,35,11]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=void 0;class y{static{this.a=0}constructor(v,k){this.extension=v,this.provider=k,this.handle=y.a++}}class A{constructor(v){this.session=v,this.responses=[]}}class C{static{this.a=0}constructor(v,k,l,f){this.f=l,this.g=f,this.b=new Map,this.d=new Map,this.e=v.getProxy(g.$QK.MainThreadInlineChat),k.registerApiCommand(new b.$iN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new b.$gN("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?I.Range.from(s.initialRange):void 0,initialSelection:s.initialSelection?I.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?I.Position.from(s.position):void 0}})],b.$hN.Void))}registerProvider(v,k,l){const f=new y(v,k);return this.b.set(f.handle,f),this.e.$registerInteractiveEditorProvider(f.handle,l?.label??v.displayName??v.name,v.identifier.value,typeof k.handleInteractiveEditorResponseFeedback=="function",typeof k.provideFollowups=="function",l?.supportReportIssue??!1),(0,D.$Qc)(()=>{this.e.$unregisterInteractiveEditorProvider(f.handle),this.b.delete(f.handle)})}async $prepareSession(v,k,l,f){const s=this.b.get(v);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(N.URI.revive(k)),n=I.Selection.to(l),o=await s.provider.prepareInteractiveEditorSession({document:i,selection:n},f);if(!o)return;if(o.wholeRange&&!o.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const c=C.a++;return this.d.set(c,new A(o)),{id:c,placeholder:o.placeholder,input:o.input,slashCommands:o.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:I.Range.from(o.wholeRange),message:o.message}}async $provideResponse(v,k,l,f){const s=this.b.get(v);if(!s)return;const i=this.d.get(k.id);if(!i)return;const n={prompt:l.prompt,selection:I.Selection.to(l.selection),wholeRange:I.Range.to(l.wholeRange),attempt:l.attempt,live:l.live};let o=!1;const c={report:async P=>{if(!l.live&&P.edits?.length)throw new Error("Progress reporting is only supported for live sessions");o||f.isCancellationRequested||await this.e.$handleProgressChunk(l.requestId,{message:P.message,edits:P.edits?.map(I.TextEdit.from),editsShouldBeInstant:P.editsShouldBeInstant,slashCommand:P.slashCommand?.command,markdownFragment:R.$hL.isMarkdownString(P.content)?P.content.value:P.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(i.session,n,c,f));let r;try{r=await(0,$.$Rg)(t,f)}finally{o=!0}if(!r)return;const d=i.responses.push(r)-1,u={wholeRange:I.Range.from(r.wholeRange),placeholder:r.placeholder};if(!C.h(r))return{...u,id:d,type:"editorEdit",message:I.MarkdownString.from(r.contents),edits:[]};const{edits:a,contents:h}=r,S=h!==void 0?I.MarkdownString.from(h):void 0;return a instanceof R.$3K?{...u,id:d,type:"bulkEdit",edits:I.WorkspaceEdit.from(a),message:S}:{...u,id:d,type:"editorEdit",edits:a.map(I.TextEdit.from),message:S}}async $provideFollowups(v,k,l,f){const s=this.b.get(v),i=this.d.get(k),n=i?.responses[l];if(s&&n&&s.provider.provideFollowups){const o=Promise.resolve(s.provider.provideFollowups(i.session,n,f));return(await(0,$.$Rg)(o,f))?.map(I.ChatReplyFollowup.from)}}$handleFeedback(v,k,l,f){const s=this.b.get(v),i=this.d.get(k),n=i?.responses[l];if(s&&n){const o=I.InteractiveEditorResponseFeedbackKind.to(f);s.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,o)}}$releaseSession(v,k){}static h(v){return typeof v=="object"&&typeof v.edits=="object"}}e.$wgc=C}),define(Se[324],ke([1,0,2,35]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jgc=void 0;class g{constructor(R,b,$,y,A){this.a=b,this.b=$,this.c=y;const C=new N.$iN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new N.$gN("showOptions","Show Options",m=>!0,m=>m),new N.$gN("resource","Interactive resource Uri",m=>!0,m=>m),new N.$gN("controllerId","Notebook controller Id",m=>!0,m=>m),new N.$gN("title","Interactive editor title",m=>!0,m=>m)],new N.$hN("Notebook and input URI",m=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const v=this.a.getEditorById(m.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:D.URI.revive(m.notebookUri),inputUri:D.URI.revive(m.inputUri),notebookEditor:v.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:D.URI.revive(m.notebookUri),inputUri:D.URI.revive(m.inputUri)}}));this.c.registerApiCommand(C)}$willAddInteractiveDocument(R,b,$,y){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:$,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(D.URI.revive(y))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$Jgc=g}),define(Se[325],ke([1,0,6,7]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=void 0;class g{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(D.$QK.MainThreadIssueReporter)}async $getIssueReporterUri(R,b){if(this.a.size===0)throw new Error("No issue request handlers registered");const $=this.a.get(R);if(!$)throw new Error("Issue request handler not found");const y=await $.handleIssueUrlRequest();if(!y)throw new Error("Issue request handler returned no result");return y}async $getIssueReporterData(R,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(R);if(!$)throw new Error("Issue data provider not found");const y=await $.provideIssueData(b);if(!y)throw new Error("Issue data provider returned no result");return y}async $getIssueReporterTemplate(R,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(R);if(!$)throw new Error("Issue data provider not found");const y=await $.provideIssueTemplate(b);if(!y)throw new Error("Issue template provider returned no result");return y}registerIssueUriRequestHandler(R,b){const $=R.identifier.value;return this.a.set($,b),this.c.$registerIssueUriRequestHandler($),new N.$SK(()=>{this.c.$unregisterIssueUriRequestHandler($),this.a.delete($)})}registerIssueDataProvider(R,b){const $=R.identifier.value;return this.b.set($,b),this.c.$registerIssueDataProvider($),new N.$SK(()=>{this.c.$unregisterIssueDataProvider($),this.b.delete($)})}}e.$Kgc=g}),define(Se[326],ke([1,0,3,6]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=void 0;class g{constructor(R){this.b=0,this.a=R.getProxy(N.$QK.MainThreadLabelService)}$registerResourceLabelFormatter(R){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,R),(0,D.$Qc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$Lgc=g}),define(Se[327],ke([1,0,2,24,15,7,83,6,12,29,19,18,169,21,26,3,131,121,110,38,14,11,25,213]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l,f,s,i,n,o,c,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=void 0;class d{constructor(z,Q){this.d=z,this.e=Q}async provideDocumentSymbols(z,Q){const ee=this.d.getDocument(z),V=await this.e.provideDocumentSymbols(ee,Q);if(!(0,A.$Kb)(V))return V[0]instanceof I.$_K?V.map(g.DocumentSymbol.from):d.f(V)}static f(z){z=z.slice(0).sort((V,oe)=>{let le=V.location.range.start.compareTo(oe.location.range.start);return le===0&&(le=oe.location.range.end.compareTo(V.location.range.end)),le});const Q=[],ee=[];for(const V of z){const oe={name:V.name||"!!MISSING: name!!",kind:g.SymbolKind.from(V.kind),tags:V.tags?.map(g.SymbolTag.from)||[],detail:"",containerName:V.containerName,range:g.Range.from(V.location.range),selectionRange:g.Range.from(V.location.range),children:[]};for(;;){if(ee.length===0){ee.push(oe),Q.push(oe);break}const le=ee[ee.length-1];if(y.$Is.containsRange(le.range,oe.range)&&!y.$Is.equalsRange(le.range,oe.range)){le.children?.push(oe),ee.push(oe);break}ee.pop()}}return Q}}class u{constructor(z,Q,ee,V,oe,le){this.f=z,this.g=Q,this.h=ee,this.j=V,this.k=oe,this.l=le,this.d=new i.$dfc("CodeLens"),this.e=new Map}async provideCodeLenses(z,Q){const ee=this.f.getDocument(z),V=await this.h.provideCodeLenses(ee,Q);if(!V||Q.isCancellationRequested)return;const oe=this.d.add(V),le=new l.$Rc;this.e.set(oe,le);const Re={cacheId:oe,lenses:[]};for(let je=0;je<V.length;je++)Re.lenses.push({cacheId:[oe,je],range:g.Range.from(V[je].range),command:this.g.toInternal(V[je].command,le)});return Re}async resolveCodeLens(z,Q){const ee=z.cacheId&&this.d.get(...z.cacheId);if(!ee)return;let V;if(typeof this.h.resolveCodeLens!="function"||ee.isResolved?V=ee:V=await this.h.resolveCodeLens(ee,Q),V||(V=ee),Q.isCancellationRequested)return;const oe=z.cacheId&&this.e.get(z.cacheId[0]);if(oe){if(!V.command){const le=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,le),this.l.error(le);return}return z.command=this.g.toInternal(V.command,oe),z}}releaseCodeLenses(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}}function a(De){return Array.isArray(De)?De.map(g.DefinitionLink.from):De?[g.DefinitionLink.from(De)]:[]}class h{constructor(z,Q){this.d=z,this.e=Q}async provideDefinition(z,Q,ee){const V=this.d.getDocument(z),oe=g.Position.to(Q),le=await this.e.provideDefinition(V,oe,ee);return a(le)}}class S{constructor(z,Q){this.d=z,this.e=Q}async provideDeclaration(z,Q,ee){const V=this.d.getDocument(z),oe=g.Position.to(Q),le=await this.e.provideDeclaration(V,oe,ee);return a(le)}}class P{constructor(z,Q){this.d=z,this.e=Q}async provideImplementation(z,Q,ee){const V=this.d.getDocument(z),oe=g.Position.to(Q),le=await this.e.provideImplementation(V,oe,ee);return a(le)}}class w{constructor(z,Q){this.d=z,this.e=Q}async provideTypeDefinition(z,Q,ee){const V=this.d.getDocument(z),oe=g.Position.to(Q),le=await this.e.provideTypeDefinition(V,oe,ee);return a(le)}}class p{constructor(z,Q){this.d=z,this.e=Q}async provideHover(z,Q,ee){const V=this.d.getDocument(z),oe=g.Position.to(Q),le=await this.e.provideHover(V,oe,ee);if(!(!le||(0,A.$Kb)(le.contents)))return le.range||(le.range=V.getWordRangeAtPosition(oe)),le.range||(le.range=new I.$UK(oe,oe)),g.Hover.from(le)}}class E{constructor(z,Q){this.d=z,this.e=Q}async provideEvaluatableExpression(z,Q,ee){const V=this.d.getDocument(z),oe=g.Position.to(Q),le=await this.e.provideEvaluatableExpression(V,oe,ee);if(le)return g.EvaluatableExpression.from(le)}}class L{constructor(z,Q){this.d=z,this.e=Q}async provideInlineValues(z,Q,ee,V){const oe=this.d.getDocument(z),le=await this.e.provideInlineValues(oe,g.Range.to(Q),g.InlineValueContext.to(ee),V);if(Array.isArray(le))return le.map(Re=>g.InlineValue.from(Re))}}class T{constructor(z,Q){this.d=z,this.e=Q}async provideDocumentHighlights(z,Q,ee){const V=this.d.getDocument(z),oe=g.Position.to(Q),le=await this.e.provideDocumentHighlights(V,oe,ee);if(Array.isArray(le))return le.map(g.DocumentHighlight.from)}}class U{constructor(z,Q){this.d=z,this.e=Q}async provideMultiDocumentHighlights(z,Q,ee,V){const oe=this.d.getDocument(z),le=ee.map(He=>this.d.getDocument(He)),Re=g.Position.to(Q),je=await this.e.provideMultiDocumentHighlights(oe,Re,le,V);if(Array.isArray(je))return je.map(g.MultiDocumentHighlight.from)}}class F{constructor(z,Q){this.d=z,this.e=Q}async provideLinkedEditingRanges(z,Q,ee){const V=this.d.getDocument(z),oe=g.Position.to(Q),le=await this.e.provideLinkedEditingRanges(V,oe,ee);if(le&&Array.isArray(le.ranges))return{ranges:(0,A.$Hb)(le.ranges.map(g.Range.from)),wordPattern:le.wordPattern}}}class j{constructor(z,Q){this.d=z,this.e=Q}async provideReferences(z,Q,ee,V){const oe=this.d.getDocument(z),le=g.Position.to(Q),Re=await this.e.provideReferences(oe,le,ee,V);if(Array.isArray(Re))return Re.map(g.location.from)}}class O{static{this.d=1e3}constructor(z,Q,ee,V,oe,le,Re){this.g=z,this.h=Q,this.j=ee,this.k=V,this.l=oe,this.m=le,this.n=Re,this.e=new i.$dfc("CodeAction"),this.f=new Map}async provideCodeActions(z,Q,ee,V){const oe=this.g.getDocument(z),le=m.$Ks.isISelection(Q)?g.Selection.to(Q):g.Range.to(Q),Re=[];for(const ot of this.j.getDiagnostics(z))if(le.intersection(ot.range)&&Re.push(ot)>O.d)break;const je={diagnostics:Re,only:ee.only?new I.$bL(ee.only):void 0,triggerKind:g.CodeActionTriggerKind.to(ee.trigger)},He=await this.k.provideCodeActions(oe,le,je,V);if(!(0,A.$Lb)(He)||V.isCancellationRequested)return;const Je=this.e.add(He),_e=new l.$Rc;this.f.set(Je,_e);const ct=[];for(let ot=0;ot<He.length;ot++){const rt=He[ot];rt&&(O.o(rt)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ct.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,_e)})):(je.only&&(rt.kind?je.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ct.push({cacheId:[Je,ot],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,_e),diagnostics:rt.diagnostics&&rt.diagnostics.map(g.Diagnostic.from),edit:rt.edit&&g.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,t.$oF)(this.m,"codeActionAI")?rt.isAI:!1,disabled:rt.disabled?.reason})))}return{cacheId:Je,actions:ct}}async resolveCodeAction(z,Q){const[ee,V]=z,oe=this.e.get(ee,V);if(!oe||O.o(oe))return{};if(!this.k.resolveCodeAction)return{};const le=await this.k.resolveCodeAction(oe,Q)??oe;let Re;le.edit&&(Re=g.WorkspaceEdit.from(le.edit,void 0));let je;if(le.command){const He=this.f.get(ee);He&&(je=this.h.toInternal(le.command,He))}return{edit:Re,command:je}}releaseCodeActions(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}static o(z){return typeof z.command=="string"&&typeof z.title=="string"}}class M{static toInternalProviderId(z,Q){return z+"."+Q}constructor(z,Q,ee,V,oe){this.d=z,this.e=Q,this.f=ee,this.g=V,this.h=oe}async prepareDocumentPaste(z,Q,ee,V){if(!this.f.prepareDocumentPaste)return;const oe=this.e.getDocument(z),le=Q.map(He=>g.Range.to(He)),Re=g.DataTransfer.toDataTransfer(ee,()=>{throw new o.$$});if(await this.f.prepareDocumentPaste(oe,le,Re,V),V.isCancellationRequested)return;const je=Array.from(Re).filter(([,He])=>!(He instanceof I.$HL));return g.DataTransfer.from(je)}async providePasteEdits(z,Q,ee,V,oe){if(!this.f.provideDocumentPasteEdits)return;const le=this.e.getDocument(Q),Re=ee.map(Je=>g.Range.to(Je)),je=g.DataTransfer.toDataTransfer(V,async Je=>(await this.d.$resolvePasteFileData(this.g,z,Je)).buffer),He=await this.f.provideDocumentPasteEdits(le,Re,je,oe);if(He)return{label:He.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:He.yieldTo?.map(Je=>"mimeType"in Je?Je:{providerId:M.toInternalProviderId(Je.extensionId,Je.providerId)}),insertText:typeof He.insertText=="string"?He.insertText:{snippet:He.insertText.value},additionalEdit:He.additionalEdit?g.WorkspaceEdit.from(He.additionalEdit,void 0):void 0}}}class W{constructor(z,Q){this.d=z,this.e=Q}async provideDocumentFormattingEdits(z,Q,ee){const V=this.d.getDocument(z),oe=await this.e.provideDocumentFormattingEdits(V,Q,ee);if(Array.isArray(oe))return oe.map(g.TextEdit.from)}}class Y{constructor(z,Q){this.d=z,this.e=Q}async provideDocumentRangeFormattingEdits(z,Q,ee,V){const oe=this.d.getDocument(z),le=g.Range.to(Q),Re=await this.e.provideDocumentRangeFormattingEdits(oe,le,ee,V);if(Array.isArray(Re))return Re.map(g.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,Q,ee,V){(0,C.$Pf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const oe=this.d.getDocument(z),le=Q.map(g.Range.to),Re=await this.e.provideDocumentRangesFormattingEdits(oe,le,ee,V);if(Array.isArray(Re))return Re.map(g.TextEdit.from)}}class ue{constructor(z,Q){this.d=z,this.e=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,Q,ee,V,oe){const le=this.d.getDocument(z),Re=g.Position.to(Q),je=await this.e.provideOnTypeFormattingEdits(le,Re,ee,V,oe);if(Array.isArray(je))return je.map(g.TextEdit.from)}}class X{constructor(z,Q){this.e=z,this.f=Q,this.d=new i.$dfc("WorkspaceSymbols")}async provideWorkspaceSymbols(z,Q){const ee=await this.e.provideWorkspaceSymbols(z,Q);if(!(0,A.$Lb)(ee))return{symbols:[]};const V=this.d.add(ee),oe={cacheId:V,symbols:[]};for(let le=0;le<ee.length;le++){const Re=ee[le];if(!Re||!Re.name){this.f.warn("INVALID SymbolInformation",Re);continue}oe.symbols.push({...g.WorkspaceSymbol.from(Re),cacheId:[V,le]})}return oe}async resolveWorkspaceSymbol(z,Q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const ee=this.d.get(...z.cacheId);if(ee){const V=await this.e.resolveWorkspaceSymbol(ee,Q);return V&&(0,N.$mn)(z,g.WorkspaceSymbol.from(V),!0)}}releaseWorkspaceSymbols(z){this.d.delete(z)}}class J{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,Q,ee){this.d=z,this.e=Q,this.f=ee}async provideRenameEdits(z,Q,ee,V){const oe=this.d.getDocument(z),le=g.Position.to(Q);try{const Re=await this.e.provideRenameEdits(oe,le,ee,V);return Re?g.WorkspaceEdit.from(Re):void 0}catch(Re){const je=J.g(Re);return je?{rejectReason:je,edits:void 0}:Promise.reject(Re)}}async resolveRenameLocation(z,Q,ee){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const V=this.d.getDocument(z),oe=g.Position.to(Q);try{const le=await this.e.prepareRename(V,oe,ee);let Re,je;if(I.$UK.isRange(le)?(Re=le,je=V.getText(le)):(0,C.$Hf)(le)&&(Re=le.range,je=le.placeholder),!Re||!je)return;if(Re.start.line>oe.line||Re.end.line<oe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:g.Range.from(Re),text:je}}catch(le){const Re=J.g(le);return Re?{rejectReason:Re,range:void 0,text:void 0}:Promise.reject(le)}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class x{constructor(z,Q){this.resultId=z,this.tokens=Q}}class he{constructor(z,Q){this.f=z,this.g=Q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(z,Q,ee){const V=this.f.getDocument(z),oe=Q!==0?this.d.get(Q):null;let le=typeof oe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(V,oe.resultId,ee):await this.g.provideDocumentSemanticTokens(V,ee);return oe&&this.d.delete(Q),le?(le=he.h(le),this.o(he.n(oe,le),le)):null}async releaseDocumentSemanticColoring(z){this.d.delete(z)}static h(z){return he.j(z)?he.k(z)?z:new I.$$L(new Uint32Array(z.data),z.resultId):he.l(z)?he.m(z)?z:new I.$aM(z.edits.map(Q=>new I.$_L(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),z.resultId):z}static j(z){return z&&!!z.data}static k(z){return z.data instanceof Uint32Array}static l(z){return z&&Array.isArray(z.edits)}static m(z){for(const Q of z.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static n(z,Q){if(!he.j(Q)||!z||!z.tokens)return Q;const ee=z.tokens,V=ee.length,oe=Q.data,le=oe.length;let Re=0;const je=Math.min(V,le);for(;Re<je&&ee[Re]===oe[Re];)Re++;if(Re===V&&Re===le)return new I.$aM([],Q.resultId);let He=0;const Je=je-Re;for(;He<Je&&ee[V-He-1]===oe[le-He-1];)He++;return new I.$aM([{start:Re,deleteCount:V-Re-He,data:oe.subarray(Re,le-He)}],Q.resultId)}o(z,Q){if(he.j(z)){const ee=this.e++;return this.d.set(ee,new x(z.resultId,z.data)),(0,f.$j$)({id:ee,type:"full",data:z.data})}if(he.l(z)){const ee=this.e++;return he.j(Q)?this.d.set(ee,new x(Q.resultId,Q.data)):this.d.set(ee,new x(z.resultId)),(0,f.$j$)({id:ee,type:"delta",deltas:(z.edits||[]).map(V=>({start:V.start,deleteCount:V.deleteCount,data:V.data}))})}return null}}class Z{constructor(z,Q){this.d=z,this.e=Q}async provideDocumentRangeSemanticTokens(z,Q,ee){const V=this.d.getDocument(z),oe=await this.e.provideDocumentRangeSemanticTokens(V,g.Range.to(Q),ee);return oe?this.f(oe):null}f(z){return(0,f.$j$)({id:0,type:"full",data:z.data})}}class we{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,Q,ee,V,oe){this.f=z,this.g=Q,this.h=ee,this.j=V,this.k=oe,this.d=new i.$dfc("CompletionItem"),this.e=new Map}async provideCompletionItems(z,Q,ee,V){const oe=this.f.getDocument(z),le=g.Position.to(Q),Re=oe.getWordRangeAtPosition(le)||new I.$UK(le,le),je=Re.with({end:le}),He=new n.$Od,Je=await this.h.provideCompletionItems(oe,le,V,g.CompletionContext.to(ee));if(!Je||V.isCancellationRequested)return;const _e=Array.isArray(Je)?new I.$oL(Je):Je,ct=we.supportsResolving(this.h)?this.d.add(_e.items):this.d.add([]),ot=new l.$Rc;this.e.set(ct,ot);const rt=[],Ae={x:ct,b:rt,a:{replace:g.Range.from(Re),insert:g.Range.from(je)},c:_e.isIncomplete||void 0,d:He.elapsed()};for(let Ue=0;Ue<_e.items.length;Ue++){const Le=_e.items[Ue],Xe=this.l(Le,[ct,Ue],je,Re);rt.push(Xe)}return Ae}async resolveCompletionItem(z,Q){if(typeof this.h.resolveCompletionItem!="function")return;const ee=this.d.get(...z);if(!ee)return;const V=this.l(ee,z),oe=await this.h.resolveCompletionItem(ee,Q);if(!oe)return;const le=this.l(oe,z);return(V.h!==le.h||V.i!==le.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(V.n!==le.n||V.o!==le.o||!(0,N.$nn)(V.p,le.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...V,d:le.d,c:le.c,l:le.l,h:le.h,i:le.i,n:le.n,o:le.o,p:le.p}}releaseCompletionItems(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,Q,ee,V){const oe=this.e.get(Q[0]);if(!oe)throw Error("DisposableStore is missing...");const le=this.g.toInternal(z.command,oe),Re={x:Q,a:z.label,b:z.kind!==void 0?g.CompletionItemKind.from(z.kind):void 0,m:z.tags&&z.tags.map(g.CompletionItemTag.from),c:z.detail,d:typeof z.documentation>"u"?void 0:g.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters?.join(""),l:z.additionalTextEdits&&z.additionalTextEdits.map(g.TextEdit.from),n:le?.$ident,o:le?.id,p:le?.$ident?void 0:le?.arguments};z.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Re.h=z.textEdit.newText):typeof z.insertText=="string"?Re.h=z.insertText:z.insertText instanceof I.$4K&&(Re.h=z.insertText.value,Re.i|=4);let je;return z.textEdit?je=z.textEdit.range:z.range&&(je=z.range),I.$UK.isRange(je)?Re.j=g.Range.from(je):je&&(!ee?.isEqual(je.inserting)||!V?.isEqual(je.replacing))&&(Re.j={insert:g.Range.from(je.inserting),replace:g.Range.from(je.replacing)}),Re}}class ce{async provideInlineCompletions(z,Q,ee,V){}disposeCompletions(z){}handleDidShowCompletionItem(z,Q,ee){}handlePartialAccept(z,Q,ee){}}class K extends ce{constructor(z,Q,ee,V){super(),this.f=z,this.g=Q,this.h=ee,this.j=V,this.d=new B,this.e=(0,t.$oF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:I.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:I.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$oF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,Q,ee,V){const oe=this.g.getDocument(z),le=g.Position.to(Q),Re=await this.h.provideInlineCompletionItems(oe,le,{selectedCompletionInfo:ee.selectedSuggestionInfo?{range:g.Range.to(ee.selectedSuggestionInfo.range),text:ee.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[ee.triggerKind]},V);if(!Re||V.isCancellationRequested)return;const je=Array.isArray(Re)?Re:Re.items,He=this.e?Array.isArray(Re)?[]:Re.commands||[]:[],Je=this.e&&!Array.isArray(Re)?Re.enableForwardStability:void 0;let _e;return{pid:this.d.createReferenceId({dispose(){_e?.dispose()},items:je}),items:je.map((ot,rt)=>{let Ae;ot.command&&(_e||(_e=new l.$Rc),Ae=this.j.toInternal(ot.command,_e));const Ue=ot.insertText;return{insertText:typeof Ue=="string"?Ue:{snippet:Ue.value},filterText:ot.filterText,range:ot.range?g.Range.from(ot.range):void 0,command:Ae,idx:rt,completeBracketPairs:this.e?ot.completeBracketPairs:!1}}),commands:He.map(ot=>(_e||(_e=new l.$Rc),this.j.toInternal(ot,_e))),suppressSuggestions:!1,enableForwardStability:Je}}disposeCompletions(z){this.d.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,Q,ee){const V=this.d.get(z)?.items[Q];V&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(V,ee)}handlePartialAccept(z,Q,ee){const V=this.d.get(z)?.items[Q];V&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(V,ee)}}class B{constructor(){this.d=new Map,this.e=1}createReferenceId(z){const Q=this.e++;return this.d.set(Q,z),Q}disposeReferenceId(z){const Q=this.d.get(z);return this.d.delete(z),Q}get(z){return this.d.get(z)}}class re{constructor(z,Q){this.e=z,this.f=Q,this.d=new i.$dfc("SignatureHelp")}async provideSignatureHelp(z,Q,ee,V){const oe=this.e.getDocument(z),le=g.Position.to(Q),Re=this.g(ee),je=await this.f.provideSignatureHelp(oe,le,V,Re);if(je){const He=this.d.add([je]);return{...g.SignatureHelp.from(je),id:He}}}g(z){let Q;if(z.activeSignatureHelp){const ee=g.SignatureHelp.to(z.activeSignatureHelp),V=this.d.get(z.activeSignatureHelp.id,0);V?(Q=V,Q.activeSignature=ee.activeSignature,Q.activeParameter=ee.activeParameter):Q=ee}return{...z,activeSignatureHelp:Q}}releaseSignatureHelp(z){this.d.delete(z)}}class ye{constructor(z,Q,ee,V,oe){this.f=z,this.g=Q,this.h=ee,this.j=V,this.k=oe,this.d=new i.$dfc("InlayHints"),this.e=new Map}async provideInlayHints(z,Q,ee){const V=this.f.getDocument(z),oe=g.Range.to(Q),le=await this.h.provideInlayHints(V,oe,ee);if(!Array.isArray(le)||le.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(Q)}`);return}if(ee.isCancellationRequested)return;const Re=this.d.add(le);this.e.set(Re,new l.$Rc);const je={hints:[],cacheId:Re};for(let He=0;He<le.length;He++)this.l(le[He],oe)&&je.hints.push(this.m(le[He],[Re,He]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(Q)}`),je}async resolveInlayHint(z,Q){if(typeof this.h.resolveInlayHint!="function")return;const ee=this.d.get(...z);if(!ee)return;const V=await this.h.resolveInlayHint(ee,Q);if(V&&this.l(V))return this.m(V,z)}releaseHints(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,Q){return z.label.length===0||Array.isArray(z.label)&&z.label.every(ee=>ee.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(Q&&!Q.contains(z.position))}m(z,Q){const ee=this.e.get(Q[0]);if(!ee)throw Error("DisposableStore is missing...");const V={label:"",cacheId:Q,tooltip:g.MarkdownString.fromStrict(z.tooltip),position:g.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(g.TextEdit.from),kind:z.kind&&g.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};if(typeof z.label=="string")V.label=z.label;else{const oe=[];V.label=oe;for(const le of z.label){if(!le.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Re={label:le.value,tooltip:g.MarkdownString.fromStrict(le.tooltip)};I.$5K.isLocation(le.location)&&(Re.location=g.location.from(le.location)),le.command&&(Re.command=this.g.toInternal(le.command,ee)),oe.push(Re)}}return V}}class de{constructor(z,Q){this.e=z,this.f=Q,this.d=new i.$dfc("DocumentLink")}async provideLinks(z,Q){const ee=this.e.getDocument(z),V=await this.f.provideDocumentLinks(ee,Q);if(!(!Array.isArray(V)||V.length===0)&&!Q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:V.filter(de.g).map(g.DocumentLink.from)};{const oe=this.d.add(V),le={links:[],cacheId:oe};for(let Re=0;Re<V.length;Re++){if(!de.g(V[Re]))continue;const je=g.DocumentLink.from(V[Re]);je.cacheId=[oe,Re],le.links.push(je)}return le}}}static g(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,Q){if(typeof this.f.resolveDocumentLink!="function")return;const ee=this.d.get(...z);if(!ee)return;const V=await this.f.resolveDocumentLink(ee,Q);if(!(!V||!de.g(V)))return g.DocumentLink.from(V)}releaseLinks(z){this.d.delete(z)}}class ge{constructor(z,Q){this.d=z,this.e=Q}async provideColors(z,Q){const ee=this.d.getDocument(z),V=await this.e.provideDocumentColors(ee,Q);return Array.isArray(V)?V.map(le=>({color:g.Color.from(le.color),range:g.Range.from(le.range)})):[]}async provideColorPresentations(z,Q,ee){const V=this.d.getDocument(z),oe=g.Range.to(Q.range),le=g.Color.to(Q.color),Re=await this.e.provideColorPresentations(le,{document:V,range:oe},ee);if(Array.isArray(Re))return Re.map(g.ColorPresentation.from)}}class _{constructor(z,Q){this.d=z,this.e=Q}async provideFoldingRanges(z,Q,ee){const V=this.d.getDocument(z),oe=await this.e.provideFoldingRanges(V,Q,ee);if(Array.isArray(oe))return oe.map(g.FoldingRange.from)}}class ie{constructor(z,Q,ee){this.d=z,this.e=Q,this.f=ee}async provideSelectionRanges(z,Q,ee){const V=this.d.getDocument(z),oe=Q.map(g.Position.to),le=await this.e.provideSelectionRanges(V,oe,ee);if(!(0,A.$Lb)(le))return[];if(le.length!==oe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Re=[];for(let je=0;je<oe.length;je++){const He=[];Re.push(He);let Je=oe[je],_e=le[je];for(;;){if(!_e.range.contains(Je))throw new Error("INVALID selection range, must contain the previous range");if(He.push(g.SelectionRange.from(_e)),!_e.parent)break;Je=_e.range,_e=_e.parent}}return Re}}class G{constructor(z,Q){this.f=z,this.g=Q,this.d=new s.$ZM(""),this.e=new Map}async prepareSession(z,Q,ee){const V=this.f.getDocument(z),oe=g.Position.to(Q),le=await this.g.prepareCallHierarchy(V,oe,ee);if(!le)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(le)?le.map(je=>this.h(Re,je)):[this.h(Re,le)]}async provideCallsTo(z,Q,ee){const V=this.j(z,Q);if(!V)throw new Error("missing call hierarchy item");const oe=await this.g.provideCallHierarchyIncomingCalls(V,ee);if(oe)return oe.map(le=>({from:this.h(z,le.from),fromRanges:le.fromRanges.map(Re=>g.Range.from(Re))}))}async provideCallsFrom(z,Q,ee){const V=this.j(z,Q);if(!V)throw new Error("missing call hierarchy item");const oe=await this.g.provideCallHierarchyOutgoingCalls(V,ee);if(oe)return oe.map(le=>({to:this.h(z,le.to),fromRanges:le.fromRanges.map(Re=>g.Range.from(Re))}))}releaseSession(z){this.e.delete(z)}h(z,Q){const ee=this.e.get(z),V=g.CallHierarchyItem.from(Q,z,ee.size.toString(36));return ee.set(V._itemId,Q),V}j(z,Q){return this.e.get(z)?.get(Q)}}class te{constructor(z,Q){this.f=z,this.g=Q,this.d=new s.$ZM(""),this.e=new Map}async prepareSession(z,Q,ee){const V=this.f.getDocument(z),oe=g.Position.to(Q),le=await this.g.prepareTypeHierarchy(V,oe,ee);if(!le)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(le)?le.map(je=>this.h(Re,je)):[this.h(Re,le)]}async provideSupertypes(z,Q,ee){const V=this.j(z,Q);if(!V)throw new Error("missing type hierarchy item");const oe=await this.g.provideTypeHierarchySupertypes(V,ee);if(oe)return oe.map(le=>this.h(z,le))}async provideSubtypes(z,Q,ee){const V=this.j(z,Q);if(!V)throw new Error("missing type hierarchy item");const oe=await this.g.provideTypeHierarchySubtypes(V,ee);if(oe)return oe.map(le=>this.h(z,le))}releaseSession(z){this.e.delete(z)}h(z,Q){const ee=this.e.get(z),V=g.TypeHierarchyItem.from(Q,z,ee.size.toString(36));return ee.set(V._itemId,Q),V}j(z,Q){return this.e.get(z)?.get(Q)}}class fe{static toInternalProviderId(z,Q){return z+"."+Q}constructor(z,Q,ee,V,oe){this.d=z,this.e=Q,this.f=ee,this.g=V,this.h=oe}async provideDocumentOnDropEdits(z,Q,ee,V,oe){const le=this.e.getDocument(Q),Re=g.Position.to(ee),je=g.DataTransfer.toDataTransfer(V,async Je=>(await this.d.$resolveDocumentOnDropFileData(this.g,z,Je)).buffer),He=await this.f.provideDocumentDropEdits(le,Re,je,oe);if(He)return{label:He.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:He.yieldTo?.map(Je=>"mimeType"in Je?Je:{providerId:fe.toInternalProviderId(Je.extensionId,Je.providerId)}),insertText:typeof He.insertText=="string"?He.insertText:{snippet:He.insertText.value},additionalEdit:He.additionalEdit?g.WorkspaceEdit.from(He.additionalEdit,void 0):void 0}}}class ve{constructor(z,Q){this.d=z,this.e=Q}async provideMappedEdits(z,Q,ee,V){const oe=D.URI.revive(z),le=this.d.getDocument(oe),Re=ee.documents.map(Je=>Je.map(_e=>({uri:D.URI.revive(_e.uri),version:_e.version,ranges:_e.ranges.map(ct=>g.Range.to(ct))}))),je={documents:Re,selections:Re[0]?.[0]?.ranges??[]},He=await this.e.provideMappedEdits(le,Q,je,V);return He?g.WorkspaceEdit.from(He):null}}class Pe{constructor(z,Q){this.adapter=z,this.extension=Q}}class be{static{this.d=0}constructor(z,Q,ee,V,oe,le,Re,je){this.g=Q,this.h=ee,this.j=V,this.k=oe,this.l=le,this.m=Re,this.n=je,this.f=new Map,this.e=z.getProxy(b.$QK.MainThreadLanguageFeatures)}o(z,Q){return g.DocumentSelector.from(z,this.g,Q)}p(z){return new I.$SK(()=>{this.f.delete(z),this.e.$unregister(z)})}q(){return be.d++}async s(z,Q,ee,V,oe,le=!1){const Re=this.f.get(z);if(!Re||!(Re.adapter instanceof Q))return V;const je=Date.now();le||this.l.trace(`[${Re.extension.identifier.value}] INVOKE provider '${ee.toString().replace(/[\r\n]/g,"")}'`);const He=ee(Re.adapter,Re.extension);return Promise.resolve(He).catch(Je=>{(0,o.$4)(Je)||(this.l.error(`[${Re.extension.identifier.value}] provider FAILED`),this.l.error(Je),this.n.onExtensionError(Re.extension.identifier,Je))}).finally(()=>{le||this.l.trace(`[${Re.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),v.CancellationToken.isCancellationToken(oe)?(0,c.$Sg)(He,oe):He}t(z,Q){const ee=this.q();return this.f.set(ee,new Pe(z,Q)),ee}static u(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,Q,ee,V){const oe=this.t(new d(this.h,ee),z),le=V&&V.label||be.u(z);return this.e.$registerDocumentSymbolProvider(oe,this.o(Q,z),le),this.p(oe)}$provideDocumentSymbols(z,Q,ee){return this.s(z,d,V=>V.provideDocumentSymbols(D.URI.revive(Q),ee),void 0,ee)}registerCodeLensProvider(z,Q,ee){const V=this.q(),oe=typeof ee.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(V,new Pe(new u(this.h,this.j.converter,ee,z,this.n,this.l),z)),this.e.$registerCodeLensSupport(V,this.o(Q,z),oe);let le=this.p(V);if(oe!==void 0){const Re=ee.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(oe));le=I.$SK.from(le,Re)}return le}$provideCodeLenses(z,Q,ee){return this.s(z,u,V=>V.provideCodeLenses(D.URI.revive(Q),ee),void 0,ee)}$resolveCodeLens(z,Q,ee){return this.s(z,u,V=>V.resolveCodeLens(Q,ee),void 0,void 0)}$releaseCodeLenses(z,Q){this.s(z,u,ee=>Promise.resolve(ee.releaseCodeLenses(Q)),void 0,void 0)}registerDefinitionProvider(z,Q,ee){const V=this.t(new h(this.h,ee),z);return this.e.$registerDefinitionSupport(V,this.o(Q,z)),this.p(V)}$provideDefinition(z,Q,ee,V){return this.s(z,h,oe=>oe.provideDefinition(D.URI.revive(Q),ee,V),[],V)}registerDeclarationProvider(z,Q,ee){const V=this.t(new S(this.h,ee),z);return this.e.$registerDeclarationSupport(V,this.o(Q,z)),this.p(V)}$provideDeclaration(z,Q,ee,V){return this.s(z,S,oe=>oe.provideDeclaration(D.URI.revive(Q),ee,V),[],V)}registerImplementationProvider(z,Q,ee){const V=this.t(new P(this.h,ee),z);return this.e.$registerImplementationSupport(V,this.o(Q,z)),this.p(V)}$provideImplementation(z,Q,ee,V){return this.s(z,P,oe=>oe.provideImplementation(D.URI.revive(Q),ee,V),[],V)}registerTypeDefinitionProvider(z,Q,ee){const V=this.t(new w(this.h,ee),z);return this.e.$registerTypeDefinitionSupport(V,this.o(Q,z)),this.p(V)}$provideTypeDefinition(z,Q,ee,V){return this.s(z,w,oe=>oe.provideTypeDefinition(D.URI.revive(Q),ee,V),[],V)}registerHoverProvider(z,Q,ee,V){const oe=this.t(new p(this.h,ee),z);return this.e.$registerHoverProvider(oe,this.o(Q,z)),this.p(oe)}$provideHover(z,Q,ee,V){return this.s(z,p,oe=>oe.provideHover(D.URI.revive(Q),ee,V),void 0,V)}registerEvaluatableExpressionProvider(z,Q,ee,V){const oe=this.t(new E(this.h,ee),z);return this.e.$registerEvaluatableExpressionProvider(oe,this.o(Q,z)),this.p(oe)}$provideEvaluatableExpression(z,Q,ee,V){return this.s(z,E,oe=>oe.provideEvaluatableExpression(D.URI.revive(Q),ee,V),void 0,V)}registerInlineValuesProvider(z,Q,ee,V){const oe=typeof ee.onDidChangeInlineValues=="function"?this.q():void 0,le=this.t(new L(this.h,ee),z);this.e.$registerInlineValuesProvider(le,this.o(Q,z),oe);let Re=this.p(le);if(oe!==void 0){const je=ee.onDidChangeInlineValues(He=>this.e.$emitInlineValuesEvent(oe));Re=I.$SK.from(Re,je)}return Re}$provideInlineValues(z,Q,ee,V,oe){return this.s(z,L,le=>le.provideInlineValues(D.URI.revive(Q),ee,V,oe),void 0,oe)}registerDocumentHighlightProvider(z,Q,ee){const V=this.t(new T(this.h,ee),z);return this.e.$registerDocumentHighlightProvider(V,this.o(Q,z)),this.p(V)}registerMultiDocumentHighlightProvider(z,Q,ee){const V=this.t(new U(this.h,ee),z);return this.e.$registerMultiDocumentHighlightProvider(V,this.o(Q,z)),this.p(V)}$provideDocumentHighlights(z,Q,ee,V){return this.s(z,T,oe=>oe.provideDocumentHighlights(D.URI.revive(Q),ee,V),void 0,V)}$provideMultiDocumentHighlights(z,Q,ee,V,oe){return this.s(z,U,le=>le.provideMultiDocumentHighlights(D.URI.revive(Q),ee,V.map(Re=>D.URI.revive(Re)),oe),void 0,oe)}registerLinkedEditingRangeProvider(z,Q,ee){const V=this.t(new F(this.h,ee),z);return this.e.$registerLinkedEditingRangeProvider(V,this.o(Q,z)),this.p(V)}$provideLinkedEditingRanges(z,Q,ee,V){return this.s(z,F,async oe=>{const le=await oe.provideLinkedEditingRanges(D.URI.revive(Q),ee,V);if(le)return{ranges:le.ranges,wordPattern:le.wordPattern?be.w(le.wordPattern):void 0}},void 0,V)}registerReferenceProvider(z,Q,ee){const V=this.t(new j(this.h,ee),z);return this.e.$registerReferenceSupport(V,this.o(Q,z)),this.p(V)}$provideReferences(z,Q,ee,V,oe){return this.s(z,j,le=>le.provideReferences(D.URI.revive(Q),ee,V,oe),void 0,oe)}registerCodeActionProvider(z,Q,ee,V){const oe=new l.$Rc,le=this.t(new O(this.h,this.j.converter,this.k,ee,this.l,z,this.m),z);return this.e.$registerQuickFixSupport(le,this.o(Q,z),{providedKinds:V?.providedCodeActionKinds?.map(Re=>Re.value),documentation:V?.documentation?.map(Re=>({kind:Re.kind.value,command:this.j.converter.toInternal(Re.command,oe)}))},be.u(z),!!ee.resolveCodeAction),oe.add(this.p(le)),oe}$provideCodeActions(z,Q,ee,V,oe){return this.s(z,O,le=>le.provideCodeActions(D.URI.revive(Q),ee,V,oe),void 0,oe)}$resolveCodeAction(z,Q,ee){return this.s(z,O,V=>V.resolveCodeAction(Q,ee),{},void 0)}$releaseCodeActions(z,Q){this.s(z,O,ee=>Promise.resolve(ee.releaseCodeActions(Q)),void 0,void 0)}registerDocumentFormattingEditProvider(z,Q,ee){const V=this.t(new W(this.h,ee),z);return this.e.$registerDocumentFormattingSupport(V,this.o(Q,z),z.identifier,z.displayName||z.name),this.p(V)}$provideDocumentFormattingEdits(z,Q,ee,V){return this.s(z,W,oe=>oe.provideDocumentFormattingEdits(D.URI.revive(Q),ee,V),void 0,V)}registerDocumentRangeFormattingEditProvider(z,Q,ee){const V=typeof ee.provideDocumentRangesFormattingEdits=="function",oe=this.t(new Y(this.h,ee),z);return this.e.$registerRangeFormattingSupport(oe,this.o(Q,z),z.identifier,z.displayName||z.name,V),this.p(oe)}$provideDocumentRangeFormattingEdits(z,Q,ee,V,oe){return this.s(z,Y,le=>le.provideDocumentRangeFormattingEdits(D.URI.revive(Q),ee,V,oe),void 0,oe)}$provideDocumentRangesFormattingEdits(z,Q,ee,V,oe){return this.s(z,Y,le=>le.provideDocumentRangesFormattingEdits(D.URI.revive(Q),ee,V,oe),void 0,oe)}registerOnTypeFormattingEditProvider(z,Q,ee,V){const oe=this.t(new ue(this.h,ee),z);return this.e.$registerOnTypeFormattingSupport(oe,this.o(Q,z),V,z.identifier),this.p(oe)}$provideOnTypeFormattingEdits(z,Q,ee,V,oe,le){return this.s(z,ue,Re=>Re.provideOnTypeFormattingEdits(D.URI.revive(Q),ee,V,oe,le),void 0,le)}registerWorkspaceSymbolProvider(z,Q){const ee=this.t(new X(Q,this.l),z);return this.e.$registerNavigateTypeSupport(ee,typeof Q.resolveWorkspaceSymbol=="function"),this.p(ee)}$provideWorkspaceSymbols(z,Q,ee){return this.s(z,X,V=>V.provideWorkspaceSymbols(Q,ee),{symbols:[]},ee)}$resolveWorkspaceSymbol(z,Q,ee){return this.s(z,X,V=>V.resolveWorkspaceSymbol(Q,ee),void 0,void 0)}$releaseWorkspaceSymbols(z,Q){this.s(z,X,ee=>ee.releaseWorkspaceSymbols(Q),void 0,void 0)}registerRenameProvider(z,Q,ee){const V=this.t(new J(this.h,ee,this.l),z);return this.e.$registerRenameSupport(V,this.o(Q,z),J.supportsResolving(ee)),this.p(V)}$provideRenameEdits(z,Q,ee,V,oe){return this.s(z,J,le=>le.provideRenameEdits(D.URI.revive(Q),ee,V,oe),void 0,oe)}$resolveRenameLocation(z,Q,ee,V){return this.s(z,J,oe=>oe.resolveRenameLocation(D.URI.revive(Q),ee,V),void 0,V)}registerDocumentSemanticTokensProvider(z,Q,ee,V){const oe=this.t(new he(this.h,ee),z),le=typeof ee.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(oe,this.o(Q,z),V,le);let Re=this.p(oe);if(le){const je=ee.onDidChangeSemanticTokens(He=>this.e.$emitDocumentSemanticTokensEvent(le));Re=I.$SK.from(Re,je)}return Re}$provideDocumentSemanticTokens(z,Q,ee,V){return this.s(z,he,oe=>oe.provideDocumentSemanticTokens(D.URI.revive(Q),ee,V),null,V)}$releaseDocumentSemanticTokens(z,Q){this.s(z,he,ee=>ee.releaseDocumentSemanticColoring(Q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,Q,ee,V){const oe=this.t(new Z(this.h,ee),z);return this.e.$registerDocumentRangeSemanticTokensProvider(oe,this.o(Q,z),V),this.p(oe)}$provideDocumentRangeSemanticTokens(z,Q,ee,V){return this.s(z,Z,oe=>oe.provideDocumentRangeSemanticTokens(D.URI.revive(Q),ee,V),null,V)}registerCompletionItemProvider(z,Q,ee,V){const oe=this.t(new we(this.h,this.j.converter,ee,this.m,z),z);return this.e.$registerCompletionsProvider(oe,this.o(Q,z),V,we.supportsResolving(ee),z.identifier),this.p(oe)}$provideCompletionItems(z,Q,ee,V,oe){return this.s(z,we,le=>le.provideCompletionItems(D.URI.revive(Q),ee,V,oe),void 0,oe)}$resolveCompletionItem(z,Q,ee){return this.s(z,we,V=>V.resolveCompletionItem(Q,ee),void 0,ee)}$releaseCompletionItems(z,Q){this.s(z,we,ee=>ee.releaseCompletionItems(Q),void 0,void 0)}registerInlineCompletionsProvider(z,Q,ee,V){const oe=new K(z,this.h,ee,this.j.converter),le=this.t(oe,z);return this.e.$registerInlineCompletionsSupport(le,this.o(Q,z),oe.supportsHandleEvents,k.$im.toKey(z.identifier.value),V?.yieldTo?.map(Re=>k.$im.toKey(Re))||[]),this.p(le)}$provideInlineCompletions(z,Q,ee,V,oe){return this.s(z,ce,le=>le.provideInlineCompletions(D.URI.revive(Q),ee,V,oe),void 0,oe)}$handleInlineCompletionDidShow(z,Q,ee,V){this.s(z,ce,async oe=>{oe.handleDidShowCompletionItem(Q,ee,V)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,Q,ee,V){this.s(z,ce,async oe=>{oe.handlePartialAccept(Q,ee,V)},void 0,void 0)}$freeInlineCompletionsList(z,Q){this.s(z,ce,async ee=>{ee.disposeCompletions(Q)},void 0,void 0)}registerSignatureHelpProvider(z,Q,ee,V){const oe=Array.isArray(V)?{triggerCharacters:V,retriggerCharacters:[]}:V,le=this.t(new re(this.h,ee),z);return this.e.$registerSignatureHelpProvider(le,this.o(Q,z),oe),this.p(le)}$provideSignatureHelp(z,Q,ee,V,oe){return this.s(z,re,le=>le.provideSignatureHelp(D.URI.revive(Q),ee,V,oe),void 0,oe)}$releaseSignatureHelp(z,Q){this.s(z,re,ee=>ee.releaseSignatureHelp(Q),void 0,void 0)}registerInlayHintsProvider(z,Q,ee){const V=typeof ee.onDidChangeInlayHints=="function"?this.q():void 0,oe=this.t(new ye(this.h,this.j.converter,ee,this.l,z),z);this.e.$registerInlayHintsProvider(oe,this.o(Q,z),typeof ee.resolveInlayHint=="function",V,be.u(z));let le=this.p(oe);if(V!==void 0){const Re=ee.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(V));le=I.$SK.from(le,Re)}return le}$provideInlayHints(z,Q,ee,V){return this.s(z,ye,oe=>oe.provideInlayHints(D.URI.revive(Q),ee,V),void 0,V)}$resolveInlayHint(z,Q,ee){return this.s(z,ye,V=>V.resolveInlayHint(Q,ee),void 0,ee)}$releaseInlayHints(z,Q){this.s(z,ye,ee=>ee.releaseHints(Q),void 0,void 0)}registerDocumentLinkProvider(z,Q,ee){const V=this.t(new de(this.h,ee),z);return this.e.$registerDocumentLinkProvider(V,this.o(Q,z),typeof ee.resolveDocumentLink=="function"),this.p(V)}$provideDocumentLinks(z,Q,ee){return this.s(z,de,V=>V.provideLinks(D.URI.revive(Q),ee),void 0,ee,Q.scheme==="output")}$resolveDocumentLink(z,Q,ee){return this.s(z,de,V=>V.resolveLink(Q,ee),void 0,void 0,!0)}$releaseDocumentLinks(z,Q){this.s(z,de,ee=>ee.releaseLinks(Q),void 0,void 0,!0)}registerColorProvider(z,Q,ee){const V=this.t(new ge(this.h,ee),z);return this.e.$registerDocumentColorProvider(V,this.o(Q,z)),this.p(V)}$provideDocumentColors(z,Q,ee){return this.s(z,ge,V=>V.provideColors(D.URI.revive(Q),ee),[],ee)}$provideColorPresentations(z,Q,ee,V){return this.s(z,ge,oe=>oe.provideColorPresentations(D.URI.revive(Q),ee,V),void 0,V)}registerFoldingRangeProvider(z,Q,ee){const V=this.q(),oe=typeof ee.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(V,new Pe(new _(this.h,ee),z)),this.e.$registerFoldingRangeProvider(V,this.o(Q,z),z.identifier,oe);let le=this.p(V);if(oe!==void 0){const Re=ee.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(oe));le=I.$SK.from(le,Re)}return le}$provideFoldingRanges(z,Q,ee,V){return this.s(z,_,oe=>oe.provideFoldingRanges(D.URI.revive(Q),ee,V),void 0,V)}registerSelectionRangeProvider(z,Q,ee){const V=this.t(new ie(this.h,ee,this.l),z);return this.e.$registerSelectionRangeProvider(V,this.o(Q,z)),this.p(V)}$provideSelectionRanges(z,Q,ee,V){return this.s(z,ie,oe=>oe.provideSelectionRanges(D.URI.revive(Q),ee,V),[],V)}registerCallHierarchyProvider(z,Q,ee){const V=this.t(new G(this.h,ee),z);return this.e.$registerCallHierarchyProvider(V,this.o(Q,z)),this.p(V)}$prepareCallHierarchy(z,Q,ee,V){return this.s(z,G,oe=>Promise.resolve(oe.prepareSession(D.URI.revive(Q),ee,V)),void 0,V)}$provideCallHierarchyIncomingCalls(z,Q,ee,V){return this.s(z,G,oe=>oe.provideCallsTo(Q,ee,V),void 0,V)}$provideCallHierarchyOutgoingCalls(z,Q,ee,V){return this.s(z,G,oe=>oe.provideCallsFrom(Q,ee,V),void 0,V)}$releaseCallHierarchy(z,Q){this.s(z,G,ee=>Promise.resolve(ee.releaseSession(Q)),void 0,void 0)}registerTypeHierarchyProvider(z,Q,ee){const V=this.t(new te(this.h,ee),z);return this.e.$registerTypeHierarchyProvider(V,this.o(Q,z)),this.p(V)}$prepareTypeHierarchy(z,Q,ee,V){return this.s(z,te,oe=>Promise.resolve(oe.prepareSession(D.URI.revive(Q),ee,V)),void 0,V)}$provideTypeHierarchySupertypes(z,Q,ee,V){return this.s(z,te,oe=>oe.provideSupertypes(Q,ee,V),void 0,V)}$provideTypeHierarchySubtypes(z,Q,ee,V){return this.s(z,te,oe=>oe.provideSubtypes(Q,ee,V),void 0,V)}$releaseTypeHierarchy(z,Q){this.s(z,te,ee=>Promise.resolve(ee.releaseSession(Q)),void 0,void 0)}registerDocumentOnDropEditProvider(z,Q,ee,V){const oe=this.q();this.f.set(oe,new Pe(new fe(this.e,this.h,ee,oe,z),z));const le=(0,t.$oF)(z,"dropMetadata")&&V?fe.toInternalProviderId(z.identifier.value,V.id):void 0;return this.e.$registerDocumentOnDropEditProvider(oe,this.o(Q,z),le,(0,t.$oF)(z,"dropMetadata")?V:void 0),this.p(oe)}$provideDocumentOnDropEdits(z,Q,ee,V,oe,le){return this.s(z,fe,Re=>Promise.resolve(Re.provideDocumentOnDropEdits(Q,D.URI.revive(ee),V,oe,le)),void 0,void 0)}registerMappedEditsProvider(z,Q,ee){const V=this.t(new ve(this.h,ee),z);return this.e.$registerMappedEditsProvider(V,this.o(Q,z)),this.p(V)}$provideMappedEdits(z,Q,ee,V,oe){return this.s(z,ve,le=>Promise.resolve(le.provideMappedEdits(Q,ee,V,oe)),null,oe)}registerDocumentPasteEditProvider(z,Q,ee,V){const oe=this.q();this.f.set(oe,new Pe(new M(this.e,this.h,ee,oe,z),z));const le=M.toInternalProviderId(z.identifier.value,V.id);return this.e.$registerPasteEditProvider(oe,this.o(Q,z),le,{supportsCopy:!!ee.prepareDocumentPaste,supportsPaste:!!ee.provideDocumentPasteEdits,copyMimeTypes:V.copyMimeTypes,pasteMimeTypes:V.pasteMimeTypes}),this.p(oe)}$prepareDocumentPaste(z,Q,ee,V,oe){return this.s(z,M,le=>le.prepareDocumentPaste(D.URI.revive(Q),ee,V,oe),void 0,oe)}$providePasteEdits(z,Q,ee,V,oe,le){return this.s(z,M,Re=>Re.providePasteEdits(Q,D.URI.revive(ee),V,oe,le),void 0,le)}static w(z){return{pattern:z.source,flags:z.flags}}static y(z){return{decreaseIndentPattern:be.w(z.decreaseIndentPattern),increaseIndentPattern:be.w(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?be.w(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?be.w(z.unIndentedLinePattern):void 0}}static z(z){return{beforeText:be.w(z.beforeText),afterText:z.afterText?be.w(z.afterText):void 0,previousLineText:z.previousLineText?be.w(z.previousLineText):void 0,action:z.action}}static B(z){return z.map(be.z)}static C(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(Q=>I.SyntaxTokenType.toString(Q)):void 0}}static D(z){return z.map(be.C)}setLanguageConfiguration(z,Q,ee){const{wordPattern:V}=ee;if(V&&(0,$.$Ve)(V))throw new Error(`Invalid language configuration: wordPattern '${V}' is not allowed to match the empty string.`);V?this.h.setWordDefinitionFor(Q,V):this.h.setWordDefinitionFor(Q,void 0),ee.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),ee.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const oe=this.q(),le={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?be.w(ee.wordPattern):void 0,indentationRules:ee.indentationRules?be.y(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?be.B(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport,autoClosingPairs:ee.autoClosingPairs?be.D(ee.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(oe,Q,le),this.p(oe)}$setWordDefinitions(z){for(const Q of z)this.h.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.$nfc=be}),define(Se[328],ke([1,0,6,15,7,39,11,3,25]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=void 0;class y{constructor(C,m,v,k){this.c=m,this.d=v,this.e=k,this.b=[],this.f=0,this.g=new Set,this.a=C.getProxy(D.$QK.MainThreadLanguages)}$acceptLanguageIds(C){this.b=C}async getLanguages(){return this.b.slice(0)}async changeLanguage(C,m){await this.a.$changeLanguage(C,m);const v=this.c.getDocumentData(C);if(!v)throw new Error(`document '${C.toString()}' NOT found`);return v.document}async tokenAtPosition(C,m){const v=C.version,k=N.Position.from(m),l=await this.a.$tokensAtPosition(C.uri,k),f={type:g.StandardTokenType.Other,range:C.getWordRangeAtPosition(m)??new g.$UK(m.line,m.character,m.line,m.character)};if(!l)return f;const s={range:N.Range.to(l.range),type:N.TokenType.to(l.type)};return!s.range.contains(m)||v!==C.version?f:s}createLanguageStatusItem(C,m,v){const k=this.f++,l=this.a,f=this.g,s=`${C.identifier.value}/${m}`;if(f.has(s))throw new Error(`LanguageStatusItem with id '${m}' ALREADY exists`);f.add(s);const i={selector:v,id:m,name:C.displayName??C.name,severity:g.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const o=new b.$Rc,c=()=>{if(n?.dispose(),!f.has(s)){console.warn(`LanguageStatusItem (${m}) from ${C.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,R.$5g)(()=>{o.clear(),this.a.$setLanguageStatus(k,{id:s,name:i.name??C.displayName??C.name,source:C.displayName??C.name,selector:N.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===g.LanguageStatusSeverity.Error?I.default.Error:i.severity===g.LanguageStatusSeverity.Warning?I.default.Warning:I.default.Info,command:i.command&&this.d.toInternal(i.command,o),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){o.dispose(),n?.dispose(),l.$removeLanguageStatus(k),f.delete(s)},get id(){return i.id},get name(){return i.name},set name(r){i.name=r,c()},get selector(){return i.selector},set selector(r){i.selector=r,c()},get text(){return i.text},set text(r){i.text=r,c()},set text2(r){(0,$.$pF)(C,"languageStatusText"),i.text=r,c()},get text2(){return(0,$.$pF)(C,"languageStatusText"),i.text},get detail(){return i.detail},set detail(r){i.detail=r,c()},get severity(){return i.severity},set severity(r){i.severity=r,c()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(r){i.accessibilityInformation=r,c()},get command(){return i.command},set command(r){i.command=r,c()},get busy(){return i.busy},set busy(r){i.busy=r,c()}};return c(),t}}e.$Mgc=y}),define(Se[115],ke([1,0,10,12,2,5,13,6,27,20]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=e.$$fc=void 0;let A=class{constructor(m,v,k){this.f=k,this.d=new Map,this.a=v.getProxy(b.$QK.MainThreadLocalization),this.b=m.environment.appLanguage,this.c=this.b===D.$g}getMessage(m,v){const{message:k,args:l,comment:f}=v;if(this.c)return(0,N.$Ie)(k,l??{});let s=k;f&&f.length>0&&(s+=`/${Array.isArray(f)?f.join(""):f}`);const i=this.d.get(m)?.contents[s];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,N.$Ie)(i??k,l??{})}getBundle(m){return this.d.get(m)?.contents}getBundleUri(m){return this.d.get(m)?.uri}async initializeLocalizedMessages(m){if(this.c||!m.l10n&&!m.isBuiltin||this.d.has(m.identifier.value))return;let v;const k=await this.g(m);if(!k){this.f.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const l=await this.a.$fetchBundleContents(k),f=JSON.parse(l);v=m.isBuiltin?f.contents?.bundle:f}catch(l){this.f.error(`Failed to load translations for ${m.identifier.value} from ${k}: ${l.message}`);return}v&&this.d.set(m.identifier.value,{contents:v,uri:k})}async g(m){if(m.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(m.identifier.value,this.b);return g.URI.revive(v)}return m.l10n?g.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$$fc=A,e.$$fc=A=Ge([We(0,$.$$M),We(1,y.$UM),We(2,R.$kj)],A),e.$_fc=(0,I.$3h)("IExtHostLocalizationService")}),define(Se[150],ke([1,0,13,6,27,20,2,55]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lhc=void 0;let $=class extends D.$vj{constructor(C,m){super(m.logLevel,m.logsLocation,m.loggers.map(v=>(0,b.$zh)(v))),this.r=C.getProxy(N.$QK.MainThreadLogger)}$setLogLevel(C,m){m?this.setLogLevel(R.URI.revive(m),C):this.setLogLevel(C)}setVisibility(C,m){super.setVisibility(C,m),this.r.$setVisibility(C,m)}s(C,m,v){return new y(this.r,C,m,v)}};e.$lhc=$,e.$lhc=$=Ge([We(0,I.$UM),We(1,g.$$M)],$);class y extends D.$qj{constructor(C,m,v,k){super(k?.logLevel==="always"),this.r=C,this.s=m,this.m=!1,this.n=[],this.setLevel(v),this.r.$createLogger(m,k).then(()=>{this.u(this.n),this.m=!0})}g(C,m){const v=[[C,m]];this.m?this.u(v):this.n.push(...v)}u(C){this.r.$log(this.s,C)}flush(){this.r.$flush(this.s)}}}),define(Se[116],ke([1,0,6,5,3,20,22]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=e.$agc=void 0,e.$agc=(0,N.$3h)("IExtHostManagedSockets");let b=class{constructor(C){this.b=0,this.c=null,this.d=new Map,this.a=C.getProxy(D.$QK.MainThreadManagedSockets)}setFactory(C,m){for(const v of this.d.values())v.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(C,m),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(C){if(!this.c||this.c.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const m=++this.b,v=await this.c.makeConnection(),k=new g.$Rc;return this.d.set(m,new y(m,v,k)),k.add((0,g.$Qc)(()=>this.d.delete(m))),k.add(v.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(m),k.dispose()})),k.add(v.onDidClose(l=>{this.a.$onDidManagedSocketClose(m,l?.stack??l?.message),k.dispose()})),k.add(v.onDidReceiveMessage(l=>this.a.$onDidManagedSocketHaveData(m,R.$ge.wrap(l)))),m}$remoteSocketWrite(C,m){this.d.get(C)?.actual.send(m.buffer)}$remoteSocketEnd(C){const m=this.d.get(C);m&&(m.actual.end(),m.dispose())}async $remoteSocketDrain(C){await this.d.get(C)?.actual.drain?.()}};e.$bgc=b,e.$bgc=b=Ge([We(0,I.$UM)],b);class ${constructor(C,m){this.socketFactoryId=C,this.makeConnection=m}}class y extends g.$Sc{constructor(C,m,v){super(),this.socketId=C,this.actual=m,this.B(v)}}}),define(Se[329],ke([1,0,6,13,25]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=void 0;function I(b){return b&&b.title}let R=class{constructor($,y){this.b=y,this.a=$.getProxy(D.$QK.MainThreadMessageService)}showMessage($,y,A,C,m){const v={source:{identifier:$.identifier,label:$.displayName||$.name}};let k;typeof C=="string"||I(C)?k=[C,...m]:(v.modal=C?.modal,v.useCustom=C?.useCustom,v.detail=C?.detail,k=m),v.useCustom&&(0,g.$pF)($,"resolvers");const l=[];let f=!1;for(let s=0;s<k.length;s++){const i=k[s];if(typeof i=="string")l.push({title:i,handle:s,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:o}=i;l.push({title:n,isCloseAffordance:!!o,handle:s}),o&&(f?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,i):f=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,i)}return this.a.$showMessage(y,A,v,l).then(s=>{if(typeof s=="number")return k[s]})}};e.$Ngc=R,e.$Ngc=R=Ge([We(1,N.$kj)],R)}),define(Se[330],ke([1,0,19,11,21,4,3,28,2,26,13,6,35,15,7,113,286,25,68]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l,f,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=e.$Rgc=void 0;let n=class{constructor(h,S,P,w,p){this.m=S,this.n=P,this.o=w,this.q=p,this.b=new b.$Ac,this.c=new b.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new I.$Sd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=h.getProxy(C.$QK.MainThreadNotebookKernels);const E=new m.$iN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.$gN("options","Select kernel options",L=>!0,L=>{if(L&&"notebookEditor"in L&&"id"in L){const T=this.n.getIdByEditor(L.notebookEditor);return{id:L.id,extension:L.extension,notebookEditorId:T}}else if(L&&"notebookEditor"in L){const T=this.n.getIdByEditor(L.notebookEditor);if(T===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${L.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:T}}return L})],m.$hN.Void);this.o.registerApiCommand(E)}createNotebookController(h,S,P,w,p,E){for(const Z of this.j.values())if(Z.controller.id===S&&y.$im.equals(h.identifier,Z.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const L=this.k++,T=this;this.q.trace(`NotebookController[${L}], CREATED by ${h.identifier.value}, ${S}`);const U=()=>console.warn(`NO execute handler from notebook controller '${M.id}' of extension: '${h.identifier}'`);let F=!1;const j=new I.$Sd,O=new I.$Sd,M={id:u(h.identifier,S),notebookType:P,extensionId:h.identifier,extensionLocation:h.extensionLocation,label:w||h.identifier.value,preloads:E?E.map(v.NotebookRendererScript.from):[]};let W=p??U,Y,ue;this.a.$addKernel(L,M).catch(Z=>{console.log(Z),F=!0});let X=0;const J=()=>{if(F)return;const Z=++X;Promise.resolve().then(()=>{Z===X&&this.a.$updateKernel(L,M)})},x=new b.$Ac,he={get id(){return S},get notebookType(){return M.notebookType},onDidChangeSelectedNotebooks:j.event,get label(){return M.label},set label(Z){M.label=Z??h.displayName??h.name,J()},get detail(){return M.detail??""},set detail(Z){M.detail=Z,J()},get description(){return M.description??""},set description(Z){M.description=Z,J()},get supportedLanguages(){return M.supportedLanguages},set supportedLanguages(Z){M.supportedLanguages=Z,J()},get supportsExecutionOrder(){return M.supportsExecutionOrder??!1},set supportsExecutionOrder(Z){M.supportsExecutionOrder=Z,J()},get rendererScripts(){return M.preloads?M.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(Z){W=Z??U},get interruptHandler(){return Y},set interruptHandler(Z){Y=Z,M.supportsInterrupt=!!Z,J()},set variableProvider(Z){(0,s.$pF)(h,"notebookVariableProvider"),ue=Z,M.hasVariableProvider=!!Z,Z?.onDidChangeVariables(we=>T.a.$variablesUpdated(we.uri)),J()},get variableProvider(){return ue},createNotebookCellExecution(Z){if(F)throw new Error("notebook controller is DISPOSED");if(!x.has(Z.notebook.uri))throw T.q.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(we=>we.toString())),new Error(`notebook controller is NOT associated to notebook: ${Z.notebook.uri.toString()}`);return T._createNotebookCellExecution(Z,u(h.identifier,this.id))},createNotebookExecution(Z){if((0,s.$pF)(h,"notebookExecution"),F)throw new Error("notebook controller is DISPOSED");if(!x.has(Z.uri))throw T.q.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(we=>we.toString())),new Error(`notebook controller is NOT associated to notebook: ${Z.uri.toString()}`);return T._createNotebookExecution(Z,u(h.identifier,this.id))},dispose:()=>{F||(this.q.trace(`NotebookController[${L}], DISPOSED`),F=!0,this.j.delete(L),j.dispose(),O.dispose(),this.a.$removeKernel(L))},updateNotebookAffinity(Z,we){we===k.NotebookControllerAffinity2.Hidden&&(0,s.$pF)(h,"notebookControllerAffinityHidden"),T.a.$updateNotebookPriority(L,Z.uri,we)},onDidReceiveMessage:O.event,postMessage(Z,we){return(0,s.$pF)(h,"notebookMessaging"),T.a.$postMessage(L,we&&T.n.getIdByEditor(we),Z)},asWebviewUri(Z){return(0,s.$pF)(h,"notebookMessaging"),(0,l.$lvb)(Z,T.m.remote)}};return this.j.set(L,{extensionId:h.identifier,controller:he,onDidReceiveMessage:O,onDidChangeSelection:j,associatedNotebooks:x}),he}getIdByController(h){for(const[S,P]of this.j)if(P.controller===h)return u(P.extensionId,h.id);return null}createNotebookControllerDetectionTask(h,S){const P=this.g++,w=this;this.q.trace(`NotebookControllerDetectionTask[${P}], CREATED by ${h.identifier.value}`),this.a.$addKernelDetectionTask(P,S);const p={dispose:()=>{this.f.delete(P),w.a.$removeKernelDetectionTask(P)}};return this.f.set(P,p),p}registerKernelSourceActionProvider(h,S,P){const w=this.i++,p=typeof P.onDidChangeNotebookKernelSourceActions=="function"?w:void 0,E=this;this.h.set(w,P),this.q.trace(`NotebookKernelSourceActionProvider[${w}], CREATED by ${h.identifier.value}`),this.a.$addKernelSourceActionProvider(w,w,S);let L;return p!==void 0&&(L=P.onDidChangeNotebookKernelSourceActions(T=>this.a.$emitNotebookKernelSourceActionsChangeEvent(p))),{dispose:()=>{this.h.delete(w),E.a.$removeKernelSourceActionProvider(w,w),L?.dispose()}}}async $provideKernelSourceActions(h,S){const P=this.h.get(h);if(P){const w=new R.$Rc;return(await P.provideNotebookKernelSourceActions(S)??[]).map(E=>v.NotebookKernelSourceAction.from(E,this.o.converter,w))}return[]}$acceptNotebookAssociation(h,S,P){const w=this.j.get(h);if(w){const p=this.n.getNotebookDocument($.URI.revive(S));P?w.associatedNotebooks.set(p.uri,!0):w.associatedNotebooks.delete(p.uri),this.q.trace(`NotebookController[${h}] ASSOCIATE notebook`,p.uri.toString(),P),w.onDidChangeSelection.fire({selected:P,notebook:p.apiNotebook})}}async $executeCells(h,S,P){const w=this.j.get(h);if(!w)return;const p=this.n.getNotebookDocument($.URI.revive(S)),E=[];for(const L of P){const T=p.getCell(L);T&&E.push(T.apiCell)}try{this.q.trace(`NotebookController[${h}] EXECUTE cells`,p.uri.toString(),E.length),await w.controller.executeHandler.call(w.controller,E,p.apiNotebook,w.controller)}catch(L){this.q.error(`NotebookController[${h}] execute cells FAILED`,L),console.error(L)}}async $cancelCells(h,S,P){const w=this.j.get(h);if(!w)return;const p=this.n.getNotebookDocument($.URI.revive(S));if(w.controller.interruptHandler)await w.controller.interruptHandler.call(w.controller,p.apiNotebook);else for(const E of P){const L=p.getCell(E);L&&this.b.get(L.uri)?.cancel()}if(w.controller.interruptHandler){const E=this.c.get(p.uri);P.length&&Array.isArray(E)&&E.length&&E.forEach(L=>L.dispose())}}async $provideVariables(h,S,P,w,p,E,L){const T=this.j.get(h);if(!T)return;const U=this.n.getNotebookDocument($.URI.revive(P)),F=T.controller.variableProvider;if(!F)return;const j=w?{name:w,value:""}:void 0,O=p==="named"?k.NotebookVariablesRequestKind.Named:k.NotebookVariablesRequestKind.Indexed,M=F.provideVariables(U.apiNotebook,j,O,E,L);for await(const W of M){if(L.isCancellationRequested)return;this.a.$receiveVariable(S,W)}}$acceptKernelMessageFromRenderer(h,S,P){const w=this.j.get(h);if(!w)return;const p=this.n.getEditorById(S);w.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:P}))}$cellExecutionChanged(h,S,P){const p=this.n.getNotebookDocument($.URI.revive(h)).getCell(S);if(p){const E=P?v.NotebookCellExecutionState.to(P):k.NotebookCellExecutionState.Idle;E!==void 0&&this.l.fire({cell:p.apiCell,state:E})}}_createNotebookCellExecution(h,S){if(h.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const w=this.n.getNotebookDocument(h.notebook.uri).getCellFromApiCell(h);if(!w)throw new Error("invalid cell");if(this.b.has(w.uri))throw new Error(`duplicate execution for ${w.uri}`);const p=new c(S,w,this.a);this.b.set(w.uri,p);const E=p.onDidChangeState(()=>{p.state===o.Resolved&&(p.dispose(),E.dispose(),this.b.delete(w.uri))});return p.asApiObject()}_createNotebookExecution(h,S){const P=this.n.getNotebookDocument(h.uri),w=h.getCells().find(L=>{const T=P.getCellFromApiCell(L);return T&&this.b.has(T.uri)});if(w)throw new Error(`duplicate cell execution for ${w.document.uri}`);if(this.c.has(P.uri))throw new Error(`duplicate notebook execution for ${P.uri}`);const p=new r(S,P,this.a),E=p.onDidChangeState(()=>{p.state===t.Resolved&&(p.dispose(),E.dispose(),this.c.delete(P.uri))});return this.c.set(P.uri,[p,E]),p.asApiObject()}};e.$Rgc=n,e.$Rgc=n=Ge([We(4,A.$kj)],n);var o;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(o||(o={}));class c extends R.$Sc{static{this.a=0}get state(){return this.f}constructor(h,S,P){super(),this.m=S,this.n=P,this.b=c.a++,this.c=new I.$Sd,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new g.$3d),this.h=new d(10,w=>this.s(w)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,h,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(h){await this.h.addItem(h)}async s(h){const S=Array.isArray(h)?h:[h];return this.n.$updateExecution(this.b,new i.$Gv(S))}t(){if(this.f===o.Init)throw new Error("Must call start before modifying cell output");if(this.f===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(h){let S=this.m;if(h&&(S=this.m.notebook.getCellFromApiCell(h)),!S)throw new Error("INVALID cell");return S.handle}y(h){return h.map(S=>{const P=k.$iM.ensureUniqueMimeTypes(S.items,!0);return P===S.items?v.NotebookCellOutput.from(S):v.NotebookCellOutput.from({items:P,id:S.id,metadata:S.metadata})})}async z(h,S,P){const w=this.w(S),p=this.y((0,D.$3b)(h));return this.r({editType:f.CellExecutionUpdateType.Output,cellHandle:w,append:P,outputs:p})}async C(h,S,P){return h=k.$iM.ensureUniqueMimeTypes((0,D.$3b)(h),!0),this.r({editType:f.CellExecutionUpdateType.OutputItems,items:h.map(v.NotebookCellOutputItem.from),outputId:S.id,append:P})}asApiObject(){const h=this;return Object.freeze({get token(){return h.g.token},get cell(){return h.m.apiCell},get executionOrder(){return h.j},set executionOrder(P){h.j=P,h.s([{editType:f.CellExecutionUpdateType.ExecutionState,executionOrder:h.j}])},start(P){if(h.f===o.Resolved||h.f===o.Started)throw new Error("Cannot call start again");h.f=o.Started,h.c.fire(),h.s({editType:f.CellExecutionUpdateType.ExecutionState,runStartTime:P})},end(P,w){if(h.f===o.Resolved)throw new Error("Cannot call resolve twice");h.f=o.Resolved,h.c.fire(),h.h.flush(),h.n.$completeExecution(h.b,new i.$Gv({runEndTime:w,lastRunSuccess:P}))},clearOutput(P){return h.t(),h.z([],P,!1)},appendOutput(P,w){return h.t(),h.z(P,w,!0)},replaceOutput(P,w){return h.t(),h.z(P,w,!1)},appendOutputItems(P,w){return h.t(),h.C(P,w,!0)},replaceOutputItems(P,w){return h.t(),h.C(P,w,!1)}})}}var t;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(t||(t={}));class r extends R.$Sc{static{this.a=0}get state(){return this.f}constructor(h,S,P){super(),this.h=S,this.j=P,this.b=r.a++,this.c=new I.$Sd,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new g.$3d),this.j.$createNotebookExecution(this.b,h,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class d{constructor(h,S){this.f=h,this.g=S,this.a=[],this.b=Date.now()}addItem(h){return this.a.push(h),this.c||(this.c=new N.$nh,this.b=Date.now(),(0,N.$4g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const h=this.c;this.c=void 0;const S=this.a;return this.a=[],this.g(S).finally(()=>h.complete())}}function u(a,h){return`${a.value}/${h}`}e.$Sgc=u}),define(Se[331],ke([1,0,4,6,146]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tgc=void 0;class I{constructor(b,$){this.c=$,this.a=new Map,this.b=b.getProxy(N.$QK.MainThreadNotebookRenderers)}$postRendererMessage(b,$,y){const A=this.c.getEditorById(b);this.a.get($)?.fire({editor:A.apiEditor,message:y})}createRendererMessaging(b,$){if(!b.contributes?.notebookRenderer?.some(A=>A.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(A,C,m)=>this.d($).event(A,C,m),postMessage:(A,C)=>{g.$zgc.apiEditorsToExtHost.has(A)&&([A,C]=[C,A]);const m=C&&g.$zgc.apiEditorsToExtHost.get(C);return this.b.$postMessage(m?.id,$,A)}}}d(b){let $=this.a.get(b);return $||($=new D.$Sd({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(b)}}),this.a.set(b,$),$)}}e.$Tgc=I}),define(Se[332],ke([1,0,3,18,2,25,6]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=void 0;class b{constructor(y){this.b=new Map,this.a=y.getProxy(R.$QK.MainThreadProfileContentHandlers)}registrProfileContentHandler(y,A,C){if((0,I.$pF)(y,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,C),this.a.$registerProfileContentHandler(A,C.name,C.description,y.identifier.value),(0,D.$Qc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(y,A,C,m){const v=this.b.get(y);if(!v)throw new Error(`Unknown handler with id: ${y}`);return v.saveProfile(A,C,m)}async $readProfile(y,A,C){const m=this.b.get(y);if(!m)throw new Error(`Unknown handler with id: ${y}`);return m.readProfile((0,N.$Ff)(A)?A:g.URI.revive(A),C)}}e.$Wgc=b}),define(Se[333],ke([1,0,2,6,11,15]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=void 0;class R{static{this.a=0}constructor($,y){this.d=y,this.c=new Map,this.b=$.getProxy(N.$QK.MainThreadQuickDiff)}$provideOriginalResource($,y,A){const C=D.URI.revive(y),m=this.c.get($);return m?(0,g.$Vg)(()=>m.provideOriginalResource(C,A)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider($,y,A,C){const m=R.a++;return this.c.set(m,y),this.b.$registerQuickDiffProvider(m,I.DocumentSelector.from($,this.d),A,C),{dispose:()=>{this.b.$unregisterQuickDiffProvider(m),this.c.delete(m)}}}}e.$Ygc=R}),define(Se[334],ke([1,0,21,4,3,6,2,7,14,19,39,61,25,15]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=void 0;function k(l,f,s){const i=l.getProxy(I.$QK.MainThreadQuickOpen);class n{constructor(S,P){this.e=new Map,this.f=0,this.a=S,this.b=P}showQuickPick(S,P,w,p=D.CancellationToken.None){this.c=void 0;const E=Promise.resolve(P),L=++this.f,T=i.$show(L,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},p),U={},F=T.then(()=>U);return Promise.race([F,E]).then(j=>{if(j===U)return;const O=(0,m.$oF)(S,"quickPickItemTooltip");return E.then(M=>{const W=[];for(let Y=0;Y<M.length;Y++){const ue=M[Y];if(typeof ue=="string")W.push({label:ue,handle:Y});else if(ue.kind===b.QuickPickItemKind.Separator)W.push({type:"separator",label:ue.label});else{ue.tooltip&&!O&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const X=ue.iconPath?d(ue.iconPath):void 0;W.push({label:ue.label,iconPath:X?.iconPath,iconClass:X?.iconClass,description:ue.description,detail:ue.detail,picked:ue.picked,alwaysShow:ue.alwaysShow,tooltip:O?v.MarkdownString.fromStrict(ue.tooltip):void 0,handle:Y})}}return w&&typeof w.onDidSelectItem=="function"&&(this.c=Y=>{w.onDidSelectItem(M[Y])}),i.$setItems(L,W),T.then(Y=>{if(typeof Y=="number")return M[Y];if(Array.isArray(Y))return Y.map(ue=>M[ue])})})}).then(void 0,j=>{if(!(0,$.$4)(j))return i.$setError(L,j),Promise.reject(j)})}$onItemSelected(S){this.c?.(S)}showInput(S,P=D.CancellationToken.None){return this.d=S?.validateInput,i.$input(S,typeof this.d=="function",P).then(void 0,w=>{if(!(0,$.$4)(w))return Promise.reject(w)})}async $validateInput(S){if(!this.d)return;const P=await this.d(S);if(!P||typeof P=="string")return P;let w;switch(P.severity){case b.InputBoxValidationSeverity.Info:w=A.default.Info;break;case b.InputBoxValidationSeverity.Warning:w=A.default.Warning;break;case b.InputBoxValidationSeverity.Error:w=A.default.Error;break;default:w=P.message?A.default.Error:A.default.Ignore;break}return{content:P.message,severity:w}}async showWorkspaceFolderPick(S,P=D.CancellationToken.None){const w=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!w)return;const p=await this.a.getWorkspaceFolders2();if(p)return p.find(E=>E.uri.toString()===w.uri.toString())}createQuickPick(S){const P=new u(S,()=>this.e.delete(P._id));return this.e.set(P._id,P),P}createInputBox(S){const P=new a(S,()=>this.e.delete(P._id));return this.e.set(P._id,P),P}$onDidChangeValue(S,P){this.e.get(S)?._fireDidChangeValue(P)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,P){const w=this.e.get(S);w instanceof u&&w._fireDidChangeActive(P)}$onDidChangeSelection(S,P){const w=this.e.get(S);w instanceof u&&w._fireDidChangeSelection(P)}$onDidTriggerButton(S,P){this.e.get(S)?._fireDidTriggerButton(P)}$onDidTriggerItemButton(S,P,w){const p=this.e.get(S);p instanceof u&&p._fireDidTriggerItemButton(P,w)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class o{static{this.a=1}constructor(S,P){this.x=S,this.y=P,this._id=u.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new N.$Sd,this.q=new N.$Sd,this.r=new N.$Sd,this.s=new N.$Sd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((P,w)=>{const p=P===b.$bM.Back?-1:w;this.o.set(p,P)}),this.z({buttons:S.map((P,w)=>({...d(P.iconPath),tooltip:P.tooltip,handle:P===b.$bM.Back?-1:w}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const P=this.o.get(S);P&&this.r.fire(P)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,g.$Nc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(S){if(!this.v){for(const P of Object.keys(S)){const w=S[P];this.u[P]=w===void 0?null:w}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function c(h){if(h instanceof b.$NL)return{id:h.id};const S=r(h),P=t(h);return{dark:typeof S=="string"?R.URI.file(S):S,light:typeof P=="string"?R.URI.file(P):P}}function t(h){return typeof h=="object"&&"light"in h?h.light:h}function r(h){return typeof h=="object"&&"dark"in h?h.dark:h}function d(h){const S=c(h);let P,w;return"id"in S?w=C.ThemeIcon.asClassName(S):P=S,{iconPath:P,iconClass:w}}class u extends o{constructor(S,P){super(S.identifier,P),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new N.$Sd,this.L=[],this.M=new N.$Sd,this.N=new N.$Sd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((p,E)=>{this.C.set(E,p),this.D.set(p,E)});const P=(0,m.$oF)(this.O,"quickPickItemTooltip"),w=[];for(let p=0;p<S.length;p++){const E=S[p];if(E.kind===b.QuickPickItemKind.Separator)w.push({type:"separator",label:E.label});else{E.tooltip&&!P&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const L=E.iconPath?d(E.iconPath):void 0;w.push({handle:p,label:E.label,iconPath:L?.iconPath,iconClass:L?.iconClass,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,tooltip:P?v.MarkdownString.fromStrict(E.tooltip):void 0,buttons:E.buttons?.map((T,U)=>({...d(T.iconPath),tooltip:T.tooltip,handle:U}))})}}this.z({items:w})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(P=>this.D.has(P)),this.z({activeItems:this.J.map(P=>this.D.get(P))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(P=>this.D.has(P)),this.z({selectedItems:this.L.map(P=>this.D.get(P))})}_fireDidChangeActive(S){const P=(0,y.$Hb)(S.map(w=>this.C.get(w)));this.J=P,this.K.fire(P)}_fireDidChangeSelection(S){const P=(0,y.$Hb)(S.map(w=>this.C.get(w)));this.L=P,this.M.fire(P)}_fireDidTriggerItemButton(S,P){const w=this.C.get(S);if(!w||!w.buttons||!w.buttons.length)return;const p=w.buttons[P];p&&this.N.fire({button:p,item:w})}}class a extends o{constructor(S,P){super(S.identifier,P),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:A.default.Error}):this.z({validationMessage:S.message,severity:S.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new n(f,s)}e.$Zgc=k}),define(Se[335],ke([1,0,2,4,52,3,11,6,19,128,13,26,61,15,25,17,10]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l,f){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$2gc=e.$1gc=void 0;function i(L){return L instanceof D.URI}function n(L,T){return L.scheme===l.Schemas.file&&T.scheme===l.Schemas.file&&f.$k?L.toString()===T.toString():L.toString().toLowerCase()===T.toString().toLowerCase()}function o(L){if(L)return typeof L.iconPath=="string"?D.URI.file(L.iconPath):D.URI.isUri(L.iconPath)||m.ThemeIcon.isThemeIcon(L.iconPath)?L.iconPath:void 0}function c(L){if(L.icon){if(D.URI.isUri(L.icon))return L.icon;if(m.ThemeIcon.isThemeIcon(L.icon))return L.icon;{const T=L.icon;return{light:T.light,dark:T.dark}}}else return}function t(L,T){if(!L.iconPath&&!T.iconPath)return 0;if(L.iconPath){if(!T.iconPath)return 1}else return-1;const U=typeof L.iconPath=="string"?L.iconPath:D.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id,F=typeof T.iconPath=="string"?T.iconPath:D.URI.isUri(T.iconPath)?T.iconPath.fsPath:T.iconPath.id;return(0,y.$Gq)(U,F)}function r(L,T){let U=0;if(L.strikeThrough!==T.strikeThrough)return L.strikeThrough?1:-1;if(L.faded!==T.faded)return L.faded?1:-1;if(L.tooltip!==T.tooltip)return(L.tooltip||"").localeCompare(T.tooltip||"");if(U=t(L,T),U!==0)return U;if(L.light&&T.light)U=t(L.light,T.light);else{if(L.light)return 1;if(T.light)return-1}if(U!==0)return U;if(L.dark&&T.dark)U=t(L.dark,T.dark);else{if(L.dark)return 1;if(T.dark)return-1}return U}function d(L,T){if(L.command!==T.command)return L.command<T.command?-1:1;if(L.title!==T.title)return L.title<T.title?-1:1;if(L.tooltip!==T.tooltip){if(L.tooltip!==void 0&&T.tooltip!==void 0)return L.tooltip<T.tooltip?-1:1;if(L.tooltip!==void 0)return 1;if(T.tooltip!==void 0)return-1}if(L.arguments===T.arguments)return 0;if(L.arguments)if(T.arguments){if(L.arguments.length!==T.arguments.length)return L.arguments.length-T.arguments.length}else return 1;else return-1;for(let U=0;U<L.arguments.length;U++){const F=L.arguments[U],j=T.arguments[U];if(F!==j&&!(i(F)&&i(j)&&n(F,j)))return F<j?-1:1}return 0}function u(L,T){let U=(0,y.$Gq)(L.resourceUri.fsPath,T.resourceUri.fsPath,!0);if(U!==0)return U;if(L.command&&T.command)U=d(L.command,T.command);else{if(L.command)return 1;if(T.command)return-1}if(U!==0)return U;if(L.decorations&&T.decorations)U=r(L.decorations,T.decorations);else{if(L.decorations)return 1;if(T.decorations)return-1}return U}function a(L,T){for(let U=0;U<L.length;U++)if(L[U]!==T[U])return!1;return!0}function h(L,T){return L.command===T.command&&L.title===T.title&&L.tooltip===T.tooltip&&(L.arguments&&T.arguments?a(L.arguments,T.arguments):L.arguments===T.arguments)}function S(L,T){return(0,$.$ub)(L,T,h)}class P{#e;#t;get value(){return this.d}set value(T){T=T??"",this.#e.$setInputBoxValue(this.l,T),this.n(T)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(T){this.#e.$setInputBoxPlaceholder(this.l,T),this.f=T}get validateInput(){return(0,k.$pF)(this.k,"scmValidation"),this.g}set validateInput(T){if((0,k.$pF)(this.k,"scmValidation"),T&&typeof T!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=T,this.#e.$setValidationProviderIsEnabled(this.l,!!T)}get enabled(){return this.h}set enabled(T){T=!!T,this.h!==T&&(this.h=T,this.#e.$setInputBoxEnablement(this.l,T))}get visible(){return this.j}set visible(T){T=!!T,this.j!==T&&(this.j=T,this.#e.$setInputBoxVisibility(this.l,T))}get document(){return(0,k.$pF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(T,U,F,j,O){this.k=T,this.l=j,this.m=O,this.d="",this.e=new N.$Sd,this.f="",this.h=!0,this.j=!0,this.#t=U,this.#e=F}showValidationMessage(T,U){(0,k.$pF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,T,U)}$onInputBoxValueChange(T){this.n(T)}n(T){this.d=T,this.e.fire(T)}}e.$1gc=P;class w{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(T){this.v=T,this.q.$updateGroupLabel(this.t,this.handle,T)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(T){this.p=T,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(T){this.f=[...T],this.k.fire()}constructor(T,U,F,j,O){this.q=T,this.s=U,this.t=F,this.u=j,this.v=O,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new N.$Sd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new N.$Sd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=w.d++}getResourceState(T){return this.g.get(T)}$executeResourceCommand(T,U){const F=this.h.get(T);return F?(0,R.$Vg)(()=>this.s.executeCommand(F.command,...F.arguments||[],U)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const T=[...this.f].sort(u),F=(0,$.$Db)(this.o,T,u).map(M=>{const W=M.toInsert.map(Y=>{const ue=this.e++;this.g.set(ue,Y);const X=Y.resourceUri;let J;if(Y.command)if(Y.command.command==="vscode.open"||Y.command.command==="vscode.diff"||Y.command.command==="vscode.changes"){const de=new I.$Rc;J=this.s.converter.toInternal(Y.command,de),this.j.set(ue,de)}else this.h.set(ue,Y.command);const x=o(Y.decorations),he=Y.decorations&&o(Y.decorations.light)||x,Z=Y.decorations&&o(Y.decorations.dark)||x,we=[he,Z],ce=Y.decorations&&Y.decorations.tooltip||"",K=Y.decorations&&!!Y.decorations.strikeThrough,B=Y.decorations&&!!Y.decorations.faded,re=Y.contextValue||"";return{rawResource:[ue,X,we,ce,K,B,re,J],handle:ue}});return{start:M.start,deleteCount:M.deleteCount,toInsert:W}}),j=F.map(({start:M,deleteCount:W,toInsert:Y})=>[M,W,Y.map(ue=>ue.rawResource)]),O=F.reverse();for(const{start:M,deleteCount:W,toInsert:Y}of O){const ue=Y.map(J=>J.handle),X=this.n.splice(M,W,...ue);for(const J of X)this.g.delete(J),this.h.delete(J),this.j.get(J)?.dispose(),this.j.delete(J)}return this.o=T,j}dispose(){this.l=!0,this.m.fire()}}class p{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(T){this.g!==T&&(this.g=T,this.#e.$updateSourceControl(this.w,{count:T}))}get quickDiffProvider(){return this.h}set quickDiffProvider(T){this.h=T;let U;(0,k.$oF)(this.x,"quickDiffProvider")&&(U=T?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!T,quickDiffLabel:U})}get historyProvider(){return(0,k.$pF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(T){(0,k.$pF)(this.x,"scmHistoryProvider"),this.j=T,this.k.value=new I.$Rc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!T}),T&&this.k.value.add(T.onDidChangeCurrentHistoryItemGroup(()=>{this.l=T?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(T){T!==this.m&&(this.m=T,this.#e.$updateSourceControl(this.w,{commitTemplate:T}))}get acceptInputCommand(){return this.o}set acceptInputCommand(T){this.n.value=new I.$Rc,this.o=T;const U=this.y.converter.toInternal(T,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:U})}get actionButton(){return(0,k.$pF)(this.x,"scmActionButton"),this.q}set actionButton(T){(0,k.$pF)(this.x,"scmActionButton"),this.p.value=new I.$Rc,this.q=T;const U=T!==void 0?{command:this.y.converter.toInternal(T.command,this.p.value),secondaryCommands:T.secondaryCommands?.map(F=>F.map(j=>this.y.converter.toInternal(j,this.p.value))),description:T.description,enabled:T.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:U??null})}get statusBarCommands(){return this.t}set statusBarCommands(T){if(this.t&&T&&S(this.t,T))return;this.s.value=new I.$Rc,this.t=T;const U=(T||[]).map(F=>this.y.converter.toInternal(F,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:U})}get selected(){return this.u}constructor(T,U,F,j,O,M,W){this.x=T,this.y=j,this.z=O,this.A=M,this.B=W,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new I.$Tc,this.m=void 0,this.n=new I.$Tc,this.o=void 0,this.p=new I.$Tc,this.s=new I.$Tc,this.t=void 0,this.u=!1,this.v=new N.$Sd,this.onDidChangeSelection=this.v.event,this.w=p.d++,this.C=new Map,this.D=new Set,this.#e=F;const Y=D.URI.from({scheme:l.Schemas.vscodeSourceControl,path:`${O}/scm${this.w}/input`,query:W?`rootUri=${encodeURIComponent(W.toString())}`:void 0});this.f=new P(T,U,this.#e,this.w,Y),this.#e.$registerSourceControl(this.w,O,M,W,Y)}createResourceGroup(T,U){const F=new w(this.#e,this.y,this.w,T,U),j=N.Event.once(F.onDidDispose)(()=>this.C.delete(F));return this.C.set(F,j),this.eventuallyAddResourceGroups(),F}eventuallyAddResourceGroups(){const T=[],U=[];for(const[F,j]of this.C){j.dispose();const O=F.onDidUpdateResourceStates(()=>{this.D.add(F),this.eventuallyUpdateResourceStates()});N.Event.once(F.onDidDispose)(()=>{this.D.delete(F),O.dispose(),this.e.delete(F.handle),this.#e.$unregisterGroup(this.w,F.handle)}),T.push([F.handle,F.id,F.label,F.features]);const M=F._takeResourceStateSnapshot();M.length>0&&U.push([F.handle,M]),this.e.set(F.handle,F)}this.#e.$registerGroups(this.w,T,U),this.C.clear()}eventuallyUpdateResourceStates(){const T=[];this.D.forEach(U=>{const F=U._takeResourceStateSnapshot();F.length!==0&&T.push([U.handle,F])}),T.length>0&&this.#e.$spliceResourceStates(this.w,T),this.D.clear()}getResourceGroup(T){return this.e.get(T)}setSelectionState(T){this.u=T,this.v.fire(T)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(T=>T.dispose()),this.#e.$unregisterSourceControl(this.w)}}Ge([(0,g.$vh)(100)],p.prototype,"eventuallyAddResourceGroups",null),Ge([(0,g.$vh)(100)],p.prototype,"eventuallyUpdateResourceStates",null);let E=class{static{s=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(T,U,F,j){this.l=U,this.m=F,this.n=j,this.g=new Map,this.h=new C.$km,this.j=new N.$Sd,this.e=T.getProxy(b.$QK.MainThreadSCM),this.f=T.getProxy(b.$QK.MainThreadTelemetry),U.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===3){const M=this.g.get(O.sourceControlHandle);if(!M)return O;const W=M.getResourceGroup(O.groupHandle);return W?W.getResourceState(O.handle):O}else if(O&&O.$mid===4){const M=this.g.get(O.sourceControlHandle);return M?M.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===5){const M=this.g.get(O.handle);return M||O}return O}})}createSourceControl(T,U,F,j){this.n.trace("ExtHostSCM#createSourceControl",T.identifier.value,U,F,j),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:T.identifier.value});const O=s.d++,M=new p(T,this.m,this.e,this.l,U,F,j);this.g.set(O,M);const W=this.h.get(T.identifier)||[];return W.push(M),this.h.set(T.identifier,W),M}getLastInputBox(T){this.n.trace("ExtHostSCM#getLastInputBox",T.identifier.value);const U=this.h.get(T.identifier),F=U&&U[U.length-1];return F&&F.inputBox}$provideOriginalResource(T,U,F){const j=D.URI.revive(U);this.n.trace("ExtHostSCM#$provideOriginalResource",T,j.toString());const O=this.g.get(T);return!O||!O.quickDiffProvider||!O.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Vg)(()=>O.quickDiffProvider.provideOriginalResource(j,F)).then(M=>M||null)}$onInputBoxValueChange(T,U){this.n.trace("ExtHostSCM#$onInputBoxValueChange",T);const F=this.g.get(T);return F&&F.inputBox.$onInputBoxValueChange(U),Promise.resolve(void 0)}$executeResourceCommand(T,U,F,j){this.n.trace("ExtHostSCM#$executeResourceCommand",T,U,F);const O=this.g.get(T);if(!O)return Promise.resolve(void 0);const M=O.getResourceGroup(U);return M?M.$executeResourceCommand(F,j):Promise.resolve(void 0)}$validateInput(T,U,F){this.n.trace("ExtHostSCM#$validateInput",T);const j=this.g.get(T);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Vg)(()=>j.inputBox.validateInput(U,F)).then(O=>{if(!O)return Promise.resolve(void 0);const M=v.MarkdownString.fromStrict(O.message);return M?Promise.resolve([M,O.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(T){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",T),T!==void 0&&this.g.get(T)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=T,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(T,U,F){return await this.g.get(T)?.historyProvider?.resolveHistoryItemGroupBase(U,F)??void 0}async $resolveHistoryItemGroupCommonAncestor(T,U,F,j){return await this.g.get(T)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(U,F,j)??void 0}async $provideHistoryItems(T,U,F,j){return(await this.g.get(T)?.historyProvider?.provideHistoryItems(U,F,j))?.map(W=>({...W,icon:c(W)}))??void 0}async $provideHistoryItemChanges(T,U,F){return await this.g.get(T)?.historyProvider?.provideHistoryItemChanges(U,F)??void 0}};e.$2gc=E,e.$2gc=E=s=Ge([We(3,A.$kj)],E)}),define(Se[117],ke([1,0,6,4,5]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=e.$8fc=void 0;class I{constructor(b){this.b=new N.$Sd,this.onDidChangePassword=this.b.event,this.a=b.getProxy(D.$QK.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,$){return this.a.$getPassword(b,$)}store(b,$,y){return this.a.$setPassword(b,$,y)}delete(b,$){return this.a.$deletePassword(b,$)}}e.$8fc=I,e.$9fc=(0,g.$3h)("IExtHostSecretState")}),define(Se[336],ke([1,0,6,15,2]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3gc=void 0;class I{static{this.a=0}constructor(b,$){this.d=$,this.c=new Map,this.b=b.getProxy(D.$QK.MainThreadShare)}async $provideShare(b,$,y){return await this.c.get(b)?.provideShare({selection:N.Range.to($.selection),resourceUri:g.URI.revive($.resourceUri)},y)??void 0}registerShareProvider(b,$){const y=I.a++;return this.c.set(y,$),this.b.$registerShareProvider(y,N.DocumentSelector.from(b,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(y),this.c.delete(y)}}}}e.$3gc=I}),define(Se[337],ke([1,0,21,3,6]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=void 0;class I{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.b=b.getProxy(g.$QK.MainThreadSpeech)}async $createSpeechToTextSession(b,$){const y=this.c.get(b);if(!y)return;const A=new N.$Rc,C=new D.$3d;this.d.set($,C);const m=A.add(y.provideSpeechToTextSession(C.token));A.add(m.onDidChange(v=>{C.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,v)})),A.add(C.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,$,y){const A=I.a++;return this.c.set(A,y),this.b.$registerProvider(A,$,{extension:b,displayName:b.value}),(0,N.$Qc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$4gc=I}),define(Se[338],ke([1,0,7,6,217,3,15,18]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=e.$5gc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new D.$OL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new D.$OL("statusBarItem.warningForeground")]])}#e;#t;constructor(m,v,k,l,f,s=D.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new I.$Rc,this.#e=m,this.#t=v,f&&l){this.c=(0,D.$rL)(l.identifier,f);const n=k.get(this.c);n&&(s=n.alignLeft?D.StatusBarAlignment.Left:D.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String($.a++);this.e=l,this.f=f,this.g=s,this.h=this.u(i)}u(m){if((0,b.$Jf)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(m){this.k=m,this.v()}set name(m){this.m=m,this.v()}set tooltip(m){this.l=m,this.v()}set color(m){this.n=m,this.v()}set backgroundColor(m){m&&!$.b.has(m.id)&&(m=void 0),this.o=m,this.v()}set command(m){this.r?.fromApi!==m&&(this.p&&this.q.add(this.p),this.p=new I.$Rc,typeof m=="string"?this.r={fromApi:m,internal:this.#t.toInternal({title:"",command:m},this.p)}:m?this.r={fromApi:m,internal:this.#t.toInternal(m,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(m){this.t=m,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let m;this.e?this.f?m=`${this.e.identifier.value}.${this.f}`:m=this.e.identifier.value:m=this.f;let v;this.m?v=this.m:v=(0,g.localize)(0,null,this.e.displayName||this.e.name);let k=this.n;this.o&&(k=$.b.get(this.o.id));const l=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,m,this.e?.identifier.value,v,this.k,l,this.r?.internal,k,this.o,this.g===D.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$5gc=$;class y{constructor(m){this.b=[],this.a=m.createStatusBarEntry(void 0,"status.extensionMessage",D.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,g.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(m){const v={message:m};return this.b.unshift(v),this.c(),new D.$SK(()=>{const k=this.b.indexOf(v);k>=0&&(this.b.splice(k,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(m,v){this.e=new Map,this.a=m.getProxy(N.$QK.MainThreadStatusBar),this.b=v,this.c=new y(this)}$acceptStaticEntries(m){for(const v of m)this.e.set(v.entryId,v)}createStatusBarEntry(m,v,k,l){return new $(this.a,this.b,this.e,m,v,k,l)}setStatusBarMessage(m,v){const k=this.c.setMessage(m);let l;return typeof v=="number"?l=setTimeout(()=>k.dispose(),v):typeof v<"u"&&v.then(()=>k.dispose(),()=>k.dispose()),new D.$SK(()=>{k.dispose(),clearTimeout(l)})}}e.$6gc=A}),define(Se[118],ke([1,0,6,4,5]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=e.$Zfc=void 0;class I{constructor(b,$){this.c=$,this.b=new N.$Sd,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(D.$QK.MainThreadStorage)}registerExtensionStorageKeysToSync(b,$){this.a.$registerExtensionStorageKeysToSync(b,$)}async initializeExtensionStorage(b,$,y){const A=await this.a.$initializeExtensionStorage(b,$);let C;return A&&(C=this.d(b,$,A)),C||y}setValue(b,$,y){return this.a.$setValue(b,$,y)}$acceptValue(b,$,y){const A=this.d(b,$,y);A&&this.b.fire({shared:b,key:$,value:A})}d(b,$,y){try{return JSON.parse(y)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${b}): ${A}`)}}}e.$Zfc=I,e.$1fc=(0,g.$3h)("IExtHostStorage")}),define(Se[92],ke([1,0,5,27,13,71,2]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=e.$Ifc=void 0,e.$Ifc=(0,D.$3h)("IExtensionStoragePaths");let b=class{constructor(y,A,C){this.d=A,this.f=C,this.a=y.workspace??void 0,this.b=y.environment,this.whenReady=this.h().then(m=>this.c=m)}async g(y){return R.URI.joinPath(this.b.workspaceStorageHome,y)}async h(){if(!this.a)return Promise.resolve(void 0);const y=this.a.id,A=await this.g(y);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(C){this.d.error("[ExtHostStorage]",C);return}}workspaceValue(y){if(this.c)return R.URI.joinPath(this.c,y.identifier.value)}globalValue(y){return R.URI.joinPath(this.b.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Jfc=b,e.$Jfc=b=Ge([We(0,N.$$M),We(1,g.$kj),We(2,I.$Hfc)],b)}),define(Se[47],ke([1,0,4,6,5,2,20,3,7,219,14,263,21,30,264,61,11,15,35]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l,f,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=e.$6fc=e.$5fc=e.$4fc=void 0,e.$4fc=(0,g.$3h)("IExtHostTerminalService");class n{constructor(w,p,E,L){this.l=w,this._id=p,this.m=E,this.n=L,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(U=>this.f=U);const T=this;this.value={get name(){return T.n||""},get processId(){return T.b},get creationOptions(){return T.m},get exitStatus(){return T.h},get state(){return T.j},get selection(){return T.k},sendText(U,F=!0){T.q(),T.l.$sendText(T._id,U,F)},show(U){T.q(),T.l.$show(T._id,U)},hide(){T.q(),T.l.$hide(T._id)},dispose(){T.a||(T.a=!0,T.l.$dispose(T._id))},get dimensions(){if(!(T.d===void 0||T.g===void 0))return{columns:T.d,rows:T.g}}}}async create(w,p){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:w.name,shellPath:w.shellPath??void 0,shellArgs:w.shellArgs??void 0,cwd:w.cwd??p?.cwd??void 0,env:w.env??void 0,icon:a(w.iconPath)??void 0,color:l.ThemeColor.isThemeColor(w.color)?w.color.id:void 0,initialText:w.message??void 0,strictEnv:w.strictEnv??void 0,hideFromUser:w.hideFromUser??void 0,isFeatureTerminal:p?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:p?.useShellEnvironment??void 0,location:p?.location||this.o(w.location,p?.resolvedExtHostIdentifier),isTransient:w.isTransient??void 0})}async createExtensionTerminal(w,p,E,L,T){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:L,color:l.ThemeColor.isThemeColor(T)?T.id:void 0,location:p?.location||this.o(w,E),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(w,p){return typeof w=="object"?"parentTerminal"in w&&w.parentTerminal&&p?{parentTerminal:p}:"viewColumn"in w?{viewColumn:s.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus}:void 0:w}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(w){this.n=w}setExitStatus(w,p){this.h=Object.freeze({code:w,reason:p})}setDimensions(w,p){return w===this.d&&p===this.g||w===0||p===0?!1:(this.d=w,this.g=p,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(w){this.k=w}_setProcessId(w){this.f?(this.f(w),this.f=void 0):this.b.then(p=>{p!==w&&(this.b=Promise.resolve(w))})}}e.$5fc=n;class o{get onProcessReady(){return this.b.event}constructor(w){this.g=w,this.id=0,this.shouldPersist=!1,this.a=new D.$Sd,this.onProcessData=this.a.event,this.b=new D.$Sd,this.d=new D.$Sd,this.onDidChangeProperty=this.d.event,this.f=new D.$Sd,this.onProcessExit=this.f.event}refreshProperty(w){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${w}`)}updateProperty(w,p){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${w}, value: ${p}`)}async start(){}shutdown(){this.g.close()}input(w){this.g.handleInput?.(w)}resize(w,p){this.g.setDimensions?.({columns:w,rows:p})}clearBuffer(){}async processBinary(w){}acknowledgeDataEvent(w){}async setUnicodeVersion(w){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(w){this.g.onDidWrite(p=>this.a.fire(p)),this.g.onDidClose?.((p=void 0)=>{this.f.fire(p===void 0?void 0:p)}),this.g.onDidOverrideDimensions?.(p=>{p&&this.d.fire({type:"overrideDimensions",value:{cols:p.columns,rows:p.rows}})}),this.g.onDidChangeName?.(p=>{this.d.fire({type:"title",value:p})}),this.g.open(w||void 0),w&&this.g.setDimensions?.(w),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let c=1,t=class extends b.$Sc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(w=>w.value)}constructor(w,p,E){super(),this.Q=p,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Tc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new D.$Sd,this.onDidCloseTerminal=this.H.event,this.I=new D.$Sd,this.onDidOpenTerminal=this.I.event,this.J=new D.$Sd,this.onDidChangeActiveTerminal=this.J.event,this.L=new D.$Sd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new D.$Sd,this.onDidChangeTerminalState=this.M.event,this.N=new D.$Sd,this.onDidChangeShell=this.N.event,this.O=new D.$Sd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new D.$Sd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=E.getProxy(N.$QK.MainThreadTerminalService),this.y=new k.$zrb(this.a.$sendProcessData),this.a.$registerProcessSupport(w),this.Q.registerArgumentProcessor({processArgument:L=>{const T=U=>{const F=U;return this.W(F.instanceId)?.value};switch(L?.$mid){case 15:return T(L);default:{if(Array.isArray(L))for(let U=0;U<L.length&&L[U].$mid===15;U++)L[U]=T(L[U]);return L}}}}),this.B({dispose:()=>{for(const[L,T]of this.g)T.shutdown(!0)}})}getDefaultShell(w){return(w?this.u:this.s)?.path||""}getDefaultShellArgs(w){return(w?this.u:this.s)?.args||[]}createExtensionTerminal(w,p){const E=new n(this.a,(0,v.$ng)(),w,w.name),L=new o(w.pty);return E.createExtensionTerminal(w.location,p,this.R(w,p).resolvedExtHostIdentifier,a(w.iconPath),h(w.color)).then(T=>{const U=this.S(T,L);this.h[T]=U}),this.f.push(E),E.value}R(w,p){if(p=p||{},w.location&&typeof w.location=="object"&&"parentTerminal"in w.location){const E=w.location.parentTerminal;if(E){const L=this.f.find(T=>T.value===E);L&&(p.resolvedExtHostIdentifier=L._id)}}else w.location&&typeof w.location!="object"?p.location=w.location:p.location&&typeof p.location=="object"&&"splitActiveTerminal"in p.location&&(p.location={splitActiveTerminal:!0});return p}attachPtyToTerminal(w,p){if(!this.W(w))throw new Error(`Cannot resolve terminal with id ${w} for virtual process`);const L=new o(p),T=this.S(w,L);this.h[w]=T}async $acceptActiveTerminalChanged(w){const p=this.b;if(w===null){this.b=void 0,p!==this.b&&this.J.fire(this.b);return}const E=this.W(w);E&&(this.b=E,p!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(w,p){const E=this.W(w);E&&this.O.fire({terminal:E.value,data:p})}async $acceptTerminalDimensions(w,p,E){const L=this.W(w);L&&L.setDimensions(p,E)&&this.L.fire({terminal:L.value,dimensions:L.value.dimensions})}async $acceptDidExecuteCommand(w,p){const E=this.W(w);E&&this.P.fire({terminal:E.value,...p})}async $acceptTerminalMaximumDimensions(w,p,E){this.g.get(w)?.resize(p,E)}async $acceptTerminalTitleChange(w,p){const E=this.W(w);E&&(E.name=p)}async $acceptTerminalClosed(w,p,E){const L=this.Y(this.f,w);if(L!==null){const T=this.f.splice(L,1)[0];T.setExitStatus(p,E),this.H.fire(T.value)}}$acceptTerminalOpened(w,p,E,L){if(p){const F=this.Y(this.f,p);if(F!==null){this.f[F]._id=w,this.I.fire(this.terminals[F]),this.f[F].isOpen=!0;return}}const T={name:L.name,shellPath:L.executable,shellArgs:L.args,cwd:typeof L.cwd=="string"?L.cwd:I.URI.revive(L.cwd),env:L.env,hideFromUser:L.hideFromUser},U=new n(this.a,w,T,E);this.f.push(U),this.I.fire(U.value),U.isOpen=!0}async $acceptTerminalProcessId(w,p){this.W(w)?._setProcessId(p)}async $startExtensionTerminal(w,p){const E=this.W(w);if(!E)return{message:(0,y.localize)(0,null,w)};E.isOpen||await new Promise(T=>{const U=this.onDidOpenTerminal(async F=>{F===E.value&&(U.dispose(),T())})});const L=this.g.get(w);L?L.startSendingEvents(p):this.j[w]={initialDimensions:p}}S(w,p){const E=new b.$Rc;E.add(p.onProcessReady(T=>this.a.$sendProcessReady(w,T.pid,T.cwd,T.windowsPty))),E.add(p.onDidChangeProperty(T=>this.a.$sendProcessProperty(w,T))),this.y.startBuffering(w,p.onProcessData),E.add(p.onProcessExit(T=>this.U(w,T))),this.g.set(w,p);const L=this.j[w];return L&&p instanceof o&&(p.startSendingEvents(L.initialDimensions),delete this.j[w]),E}$acceptProcessAckDataEvent(w,p){this.g.get(w)?.acknowledgeDataEvent(p)}$acceptProcessInput(w,p){this.g.get(w)?.input(p)}$acceptTerminalInteraction(w){const p=this.W(w);p?.setInteractedWith()&&this.M.fire(p.value)}$acceptTerminalSelection(w,p){this.W(w)?.setSelection(p)}$acceptProcessResize(w,p,E){try{this.g.get(w)?.resize(p,E)}catch(L){if(L.code!=="EPIPE"&&L.code!=="ERR_IPC_CHANNEL_CLOSED")throw L}}$acceptProcessShutdown(w,p){this.g.get(w)?.shutdown(p)}$acceptProcessRequestInitialCwd(w){this.g.get(w)?.getInitialCwd().then(p=>this.a.$sendProcessProperty(w,{type:"initialCwd",value:p}))}$acceptProcessRequestCwd(w){this.g.get(w)?.getCwd().then(p=>this.a.$sendProcessProperty(w,{type:"cwd",value:p}))}$acceptProcessRequestLatency(w){return Promise.resolve(w)}registerLinkProvider(w){return this.z.add(w),this.z.size===1&&this.a.$startLinkProvider(),new $.$SK(()=>{this.z.delete(w),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(w,p,E){if(this.C.has(p))throw new Error(`Terminal profile provider "${p}" already registered`);return this.C.set(p,E),this.a.$registerProfileProvider(p,w.identifier.value),new $.$SK(()=>{this.C.delete(p),this.a.$unregisterProfileProvider(p)})}registerTerminalQuickFixProvider(w,p,E){if(this.D.has(w))throw new Error(`Terminal quick fix provider "${w}" is already registered`);return this.D.set(w,E),this.a.$registerQuickFixProvider(w,p),new $.$SK(()=>{this.D.delete(w),this.a.$unregisterQuickFixProvider(w)})}async $provideTerminalQuickFixes(w,p){const E=new m.$3d().token;if(E.isCancellationRequested)return;const L=this.D.get(w);if(!L)return;const T=await L.provideTerminalQuickFixes(p,E);if(T===null||Array.isArray(T)&&T.length===0)return;const U=new b.$Rc;if(this.w.value=U,!Array.isArray(T))return T?s.TerminalQuickFix.from(T,this.Q.converter,U):void 0;const F=[];for(const j of T){const O=s.TerminalQuickFix.from(j,this.Q.converter,U);O&&F.push(O)}return F}async $createContributedProfileTerminal(w,p){const E=new m.$3d().token;let L=await this.C.get(w)?.provideTerminalProfile(E);if(!E.isCancellationRequested){if(L&&!("options"in L)&&(L={options:L}),!L||!("options"in L))throw new Error(`No terminal profile options provided for id "${w}"`);if("pty"in L.options){this.createExtensionTerminal(L.options,p);return}this.createTerminalFromOptions(L.options,p)}}async $provideLinks(w,p){const E=this.W(w);if(!E)return[];this.F.delete(w),this.G.get(w)?.dispose(!0);const T=new m.$3d;this.G.set(w,T);const U=[],F={terminal:E.value,line:p},j=[];for(const W of this.z)j.push(f.Promises.withAsyncBody(async Y=>{T.token.onCancellationRequested(()=>Y({provider:W,links:[]}));const ue=await W.provideTerminalLinks(F,T.token)||[];T.token.isCancellationRequested||Y({provider:W,links:ue})}));const O=await Promise.all(j);if(T.token.isCancellationRequested)return[];const M=new Map;for(const W of O)W&&W.links.length>0&&U.push(...W.links.map(Y=>{const ue={id:c++,startIndex:Y.startIndex,length:Y.length,label:Y.tooltip};return M.set(ue.id,{provider:W.provider,link:Y}),ue}));return this.F.set(w,M),U}$activateLink(w,p){const E=this.F.get(w)?.get(p);E&&E.provider.handleTerminalLink(E.link)}U(w,p){this.y.stopBuffering(w),this.g.delete(w),delete this.j[w];const E=this.h[w];E&&(E.dispose(),delete this.h[w]),this.a.$sendProcessExit(w,p)}W(w){return this.X(this.f,w)}X(w,p){const E=this.Y(w,p);return E!==null?w[E]:null}Y(w,p){const E=w.findIndex(L=>L._id===p);return E===-1?null:E}getEnvironmentVariableCollection(w){let p=this.n.get(w.identifier.value);return p||(p=new r,this.$(w.identifier.value,p)),p.getScopedEnvironmentVariableCollection(void 0)}Z(w,p){const E=(0,C.$zr)(p.map),L=(0,C.$Ar)(p.descriptionMap);this.a.$setEnvironmentVariableCollection(w,p.persistent,E.length===0?void 0:E,L)}$initEnvironmentVariableCollections(w){w.forEach(p=>{const E=p[0],L=new r(p[1]);this.$(E,L)})}$acceptDefaultProfile(w,p){const E=this.s;this.s=w,this.u=p,E?.path!==w.path&&this.N.fire(w.path)}$(w,p){this.n.set(w,p),p.onDidChangeCollection(()=>{this.Z(w,p)})}};e.$6fc=t,e.$6fc=t=Ge([We(1,i.$eN),We(2,R.$UM)],t);class r{get persistent(){return this.b}set persistent(w){this.b=w,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(w){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new D.$Sd,this.map=new Map(w)}getScopedEnvironmentVariableCollection(w){const p=this.h(w);let E=this.a.get(p);return E||(E=new d(this,w),this.a.set(p,E),E.onDidChangeCollection(()=>this.d.fire())),E}replace(w,p,E,L){this.f(w,{value:p,type:$.EnvironmentVariableMutatorType.Replace,options:E??{applyAtProcessCreation:!0},scope:L})}append(w,p,E,L){this.f(w,{value:p,type:$.EnvironmentVariableMutatorType.Append,options:E??{applyAtProcessCreation:!0},scope:L})}prepend(w,p,E,L){this.f(w,{value:p,type:$.EnvironmentVariableMutatorType.Prepend,options:E??{applyAtProcessCreation:!0},scope:L})}f(w,p){if(p.options&&p.options.applyAtProcessCreation===!1&&!p.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const E=this.g(w,p.scope),L=this.map.get(E),T=p.options?{applyAtProcessCreation:p.options.applyAtProcessCreation??!1,applyAtShellIntegration:p.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!L||L.value!==p.value||L.type!==p.type||L.options?.applyAtProcessCreation!==T.applyAtProcessCreation||L.options?.applyAtShellIntegration!==T.applyAtShellIntegration||L.scope?.workspaceFolder?.index!==p.scope?.workspaceFolder?.index){const U=this.g(w,p.scope),F={variable:w,...p,options:T};this.map.set(U,F),this.d.fire()}}get(w,p){const E=this.g(w,p),L=this.map.get(E);return L?S(L):void 0}g(w,p){const E=this.h(p);return E.length?`${w}:::${E}`:w}h(w){return this.j(w?.workspaceFolder)??""}j(w){return w?w.uri.toString():void 0}getVariableMap(w){const p=new Map;for(const[E,L]of this.map)this.h(L.scope)===this.h(w)&&p.set(L.variable,S(L));return p}delete(w,p){const E=this.g(w,p);this.map.delete(E),this.d.fire()}clear(w){if(w?.workspaceFolder){for(const[p,E]of this.map)E.scope?.workspaceFolder?.index===w.workspaceFolder.index&&this.map.delete(p);this.k(w)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(w,p){const E=this.h(p),L=this.descriptionMap.get(E);if(!L||L.description!==w){let T;typeof w=="string"?T=w:T=w?.value.split(`

`)[0];const U={description:T,scope:p};this.descriptionMap.set(E,U),this.d.fire()}}getDescription(w){const p=this.h(w);return this.descriptionMap.get(p)?.description}k(w){const p=this.h(w);this.descriptionMap.delete(p)}}class d{get persistent(){return this.b.persistent}set persistent(w){this.b.persistent=w}get onDidChangeCollection(){return this.a&&this.a.event}constructor(w,p){this.b=w,this.d=p,this.a=new D.$Sd}getScoped(w){return this.b.getScopedEnvironmentVariableCollection(w)}replace(w,p,E){this.b.replace(w,p,E,this.d)}append(w,p,E){this.b.append(w,p,E,this.d)}prepend(w,p,E){this.b.prepend(w,p,E,this.d)}get(w){return this.b.get(w,this.d)}forEach(w,p){this.b.getVariableMap(this.d).forEach((E,L)=>w.call(p,L,E,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(w){this.b.delete(w,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(w){this.b.setDescription(w,this.d)}get description(){return this.b.getDescription(this.d)}}let u=class extends t{constructor(w,p){super(!1,w,p)}createTerminal(w,p,E){throw new A.$_}createTerminalFromOptions(w,p){throw new A.$_}};e.$7fc=u,e.$7fc=u=Ge([We(0,i.$eN),We(1,R.$UM)],u);function a(P){if(!(!P||typeof P=="string"))return"id"in P?{id:P.id,color:P.color}:P}function h(P){return l.ThemeColor.isThemeColor(P)?P:void 0}function S(P){const w={...P};return delete w.scope,w.options=w.options??void 0,delete w.variable,w}}),define(Se[339],ke([1,0,11,22,21,4,74,54,3,24,18,30,13,6,20,147,15,7,67,112,89,25]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l,f,s,i,n,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=e.$_gc=e.$$gc=e.$0gc=void 0;let t=class extends $.$Sc{constructor(F,j,O,M){super(),this.w=M,this.f=this.B(new I.$Sd),this.g=new Map,this.s=this.B(new I.$Sd),this.onResultsChanged=this.f.event,this.results=[],this.h=F.getProxy(v.$QK.MainThreadTesting),this.m=new E(this.h),this.j=new a(this.h,j),O.registerArgumentProcessor({processArgument:W=>{switch(W?.$mid){case 16:{const Y=W,ue=Y.tests[Y.tests.length-1].item.extId;return this.g.get(i.$IJ.root(ue))?.collection.tree.get(ue)?.actual??(0,l.$7M)(W)}case 18:{const{extId:Y,message:ue}=W;return{test:this.g.get(i.$IJ.root(Y))?.collection.tree.get(Y)?.actual,message:f.TestMessage.to(ue)}}default:return W}}}),O.registerCommand(!1,"testing.getExplorerSelection",async()=>{const W=await O.executeCommand("_testing.getExplorerSelection"),Y=ue=>{const X=this.g.get(i.$IJ.root(ue));if(X)return i.$IJ.isRoot(ue)?X.controller:X.collection.tree.get(ue)?.actual};return{include:W?.include.map(Y).filter(A.$Nf)||[],exclude:W?.exclude.map(Y).filter(A.$Nf)||[]}})}createTestController(F,j,O,M){if(this.g.has(j))throw new Error(`Attempt to insert a duplicate controller with ID "${j}"`);const W=new $.$Rc,Y=W.add(new l.$0M(j,O,this.w));Y.root.label=O;const ue=new Map,X=new Set,J=this.h,x={items:Y.root.children,get label(){return O},set label(Z){O=Z,Y.root.label=Z,J.$updateController(j,{label:O})},get refreshHandler(){return M},set refreshHandler(Z){M=Z,J.$updateController(j,{canRefresh:!!Z})},get id(){return j},createRunProfile:(Z,we,ce,K,B,re)=>{let ye=(0,b.$Qi)(Z);for(;ue.has(ye);)ye++;return new L(this.h,ue,F,X,this.s.event,j,ye,Z,we,ce,K,B,re)},createTestItem(Z,we,ce){return new l.$8M(j,Z,we,ce)},createTestRun:(Z,we,ce=!0)=>this.j.createTestRun(F,j,Y,Z,we,ce),invalidateTestResults:Z=>{if(Z===void 0)this.h.$markTestRetired(void 0);else{const we=Z instanceof Array?Z:[Z];this.h.$markTestRetired(we.map(ce=>i.$IJ.fromExtHostTestItem(ce,j).toString()))}},set resolveHandler(Z){Y.resolveHandler=Z},get resolveHandler(){return Y.resolveHandler},dispose:()=>{W.dispose()}};J.$registerTestController(j,O,!!M),W.add((0,$.$Qc)(()=>J.$unregisterTestController(j)));const he={controller:x,collection:Y,profiles:ue,extension:F,activeProfiles:X};return this.g.set(j,he),W.add((0,$.$Qc)(()=>this.g.delete(j))),W.add(Y.onDidGenerateDiff(Z=>J.$publishDiff(j,Z.map(o.TestsDiffOp.serialize)))),x}createTestObserver(){return this.m.checkout()}async runTests(F,j=g.CancellationToken.None){const O=h(F);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const M=this.g.get(O.controllerId);if(!M)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:F.include?.map(W=>i.$IJ.fromExtHostTestItem(W,M.collection.root.id).toString())??[M.collection.root.id],profileGroup:T[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:F.exclude?.map(W=>W.id)},j)}$syncTests(){for(const{collection:F}of this.g.values())F.flushDiff();return Promise.resolve()}async $provideFileCoverage(F,j,O){return await this.j.getCoverageReport(F,j)?.provideFileCoverage(O)??[]}async $resolveFileCoverage(F,j,O,M){return await this.j.getCoverageReport(F,j)?.resolveFileCoverage(O,M)??[]}$configureRunProfile(F,j){this.g.get(F)?.profiles.get(j)?.configureHandler?.()}$setActiveRunProfiles(F){const j=new Map;for(const[O,M]of Object.entries(F)){const W=this.g.get(O);if(!W)continue;const Y=new Map,ue=M.filter(J=>!W.activeProfiles.has(J)),X=[...W.activeProfiles].filter(J=>!M.includes(J));for(const J of ue)Y.set(J,!0),W.activeProfiles.add(J);for(const J of X)Y.set(J,!1),W.activeProfiles.delete(J);Y.size&&j.set(O,Y)}this.s.fire(j)}async $refreshTests(F,j){await this.g.get(F)?.controller.refreshHandler?.(j)}$publishTestResults(F){this.results=Object.freeze(F.map(j=>(0,y.$kn)(f.TestResults.to(j))).concat(this.results).sort((j,O)=>O.completedAt-j.completedAt).slice(0,32)),this.f.fire()}async $expandTest(F,j){const O=this.g.get(i.$IJ.fromString(F).controllerId)?.collection;O&&(await O.expand(F,j<0?1/0:j),O.flushDiff())}$acceptDiff(F){this.m.applyDiff(F.map(j=>o.TestsDiffOp.deserialize({asCanonicalUri:O=>O},j)))}async $runControllerTests(F,j){return Promise.all(F.map(O=>this.y(O,!1,j)))}async $startContinuousRun(F,j){const O=new g.$3d(j),M=await Promise.all(F.map(W=>this.y(W,!0,O.token)));return!j.isCancellationRequested&&!M.some(W=>W.error)&&await new Promise(W=>j.onCancellationRequested(W)),O.dispose(!0),M}async y(F,j,O){const M=this.g.get(F.controllerId);if(!M)return{};const{collection:W,profiles:Y,extension:ue}=M,X=Y.get(F.profileId);if(!X)return{};const J=F.testIds.map(we=>W.tree.get(we)).filter(A.$Nf),x=F.excludeExtIds.map(we=>M.collection.tree.get(we)).filter(A.$Nf).filter(we=>J.some(ce=>ce.fullId.compare(we.fullId)===2));if(!J.length)return{};const he=new s.$pM(J.some(we=>we.actual instanceof l.$9M)?void 0:J.map(we=>we.actual),x.map(we=>we.actual),X,j),Z=(0,o.$KJ)(F)&&this.j.prepareForMainThreadTestRun(he,S.fromInternal(F,M.collection),ue,O);try{return await X.runHandler(he,O),{}}catch(we){return{error:String(we)}}finally{Z&&(Z.hasRunningTasks&&!O.isCancellationRequested&&await I.Event.toPromise(Z.onEnd),Z.dispose())}}$cancelExtensionTestRun(F){F===void 0?this.j.cancelAllRuns():this.j.cancelRunById(F)}};e.$0gc=t,e.$0gc=t=Ge([We(0,k.$UM),We(1,m.$kj)],t);const r=1e4;var d;(function(U){U[U.Running=0]="Running",U[U.Cancelling=1]="Cancelling",U[U.Ended=2]="Ended"})(d||(d={}));class u extends $.$Sc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(F,j,O,M,W){super(),this.s=F,this.w=j,this.y=O,this.z=M,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new I.$Sd),this.m=this.B(new I.$Sd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new g.$3d(W));const Y=this.B(new D.$ch(()=>this.C(),r));this.B(this.h.token.onCancellationRequested(()=>Y.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(F){const j=this.s.id,O=this.s.controllerId,M=(0,C.$ng)(),W=this.y,Y=this.m;let ue;const X=Z=>(we,...ce)=>{if(x){this.z.warn(`Setting the state of test "${we.id}" is a no-op after the run ends.`);return}this.s.isIncluded(we)&&(this.F(we),Z(we,...ce))},J=(Z,we)=>{const ce=we instanceof Array?we.map(f.TestMessage.from):[f.TestMessage.from(we)];if(Z.uri&&Z.range){const K={range:f.Range.from(Z.range),uri:Z.uri};for(const B of ce)B.location=B.location||K}this.w.$appendTestMessagesInRun(j,M,i.$IJ.fromExtHostTestItem(Z,O).toString(),ce)};let x=!1;const he={isPersisted:this.s.isPersisted,token:this.h.token,name:F,get coverageProvider(){return ue?.provider},set coverageProvider(Z){(0,c.$pF)(W,"testCoverage"),ue=Z&&new P(Z),Y.fire({taskId:M,runId:j,coverage:ue})},enqueued:X(Z=>{this.w.$updateTestStateInRun(j,M,i.$IJ.fromExtHostTestItem(Z,O).toString(),1)}),skipped:X(Z=>{this.w.$updateTestStateInRun(j,M,i.$IJ.fromExtHostTestItem(Z,O).toString(),5)}),started:X(Z=>{this.w.$updateTestStateInRun(j,M,i.$IJ.fromExtHostTestItem(Z,O).toString(),2)}),errored:X((Z,we,ce)=>{J(Z,we),this.w.$updateTestStateInRun(j,M,i.$IJ.fromExtHostTestItem(Z,O).toString(),6,ce)}),failed:X((Z,we,ce)=>{J(Z,we),this.w.$updateTestStateInRun(j,M,i.$IJ.fromExtHostTestItem(Z,O).toString(),4,ce)}),passed:X((Z,we)=>{this.w.$updateTestStateInRun(j,M,i.$IJ.fromExtHostTestItem(Z,this.s.controllerId).toString(),3,we)}),appendOutput:(Z,we,ce)=>{x||(ce&&(this.s.isIncluded(ce)?this.F(ce):ce=void 0),this.w.$appendOutputToRun(j,M,N.$ge.fromString(Z),we&&f.location.from(we),ce&&i.$IJ.fromExtHostTestItem(ce,O).toString()))},end:()=>{x||(x=!0,this.w.$finishedTestRunTask(j,M),this.f.delete(M),this.f.size||this.D())}};return this.f.set(M,{run:he}),this.w.$startedTestRunTask(j,{id:M,name:F,running:!0}),he}C(){for(const{run:F}of this.f.values())F.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(F){if(!(F instanceof l.$8M))throw new n.$MM(F.id);if(this.g.has(i.$IJ.fromExtHostTestItem(F,this.s.controllerId).toString()))return;const j=[],O=this.s.colllection.root;for(;;){const M=f.TestItem.from(F);if(j.unshift(M),this.g.has(M.extId)||(this.g.add(M.extId),F===O))break;F=F.parent||O}this.w.$addTestsToRun(this.s.controllerId,this.s.id,j)}dispose(){this.D(),super.dispose()}}class a{get trackers(){return this.c.values()}constructor(F,j){this.g=F,this.h=j,this.c=new Map,this.f=[]}getCoverageReport(F,j){return this.f.find(O=>O.runId===F)?.coverage.get(j)}prepareForMainThreadTestRun(F,j,O,M){return this.j(F,j,O,M)}cancelRunById(F){for(const j of this.c.values())if(j.id===F){j.cancel();return}}cancelAllRuns(){for(const F of this.c.values())F.cancel()}createTestRun(F,j,O,M,W,Y){const ue=this.c.get(M);if(ue)return ue.createRun(W);const X=S.fromPublic(j,O,M,Y),J=h(M);this.g.$startedExtensionTestRun({controllerId:j,continuous:!!M.continuous,profile:J&&{group:T[J.kind],id:J.profileId},exclude:M.exclude?.map(he=>i.$IJ.fromExtHostTestItem(he,O.root.id).toString())??[],id:X.id,include:M.include?.map(he=>i.$IJ.fromExtHostTestItem(he,O.root.id).toString())??[O.root.id],persist:Y});const x=this.j(M,X,F);return I.Event.once(x.onEnd)(()=>{this.g.$finishedExtensionTestRun(X.id),x.dispose()}),x.createRun(W)}j(F,j,O,M){const W=new u(j,this.g,O,this.h,M);this.c.set(F,W);let Y;const ue=W.onDidCoverage(({runId:X,taskId:J,coverage:x})=>{Y||(Y={runId:X,coverage:new Map},this.f.unshift(Y),this.f.length>o.$PJ&&this.f.pop()),Y.coverage.set(J,x),this.g.$signalCoverageAvailable(X,J,!!x)});return I.Event.once(W.onEnd)(()=>{this.c.delete(F),ue.dispose()}),W}}e.$$gc=a;const h=U=>{if(U.profile){if(!(U.profile instanceof L))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return U.profile}};class S{static fromPublic(F,j,O,M){return new S(F,(0,C.$ng)(),O.include?.map(W=>i.$IJ.fromExtHostTestItem(W,F).toString())??[F],O.exclude?.map(W=>i.$IJ.fromExtHostTestItem(W,F).toString())??[],M,j)}static fromInternal(F,j){return new S(F.controllerId,F.runId,F.testIds,F.excludeExtIds,!0,j)}constructor(F,j,O,M,W,Y){this.controllerId=F,this.id=j,this.isPersisted=W,this.colllection=Y,this.c=O.map(ue=>ue+"\0"),this.f=M.map(ue=>ue+"\0")}isIncluded(F){const j=i.$IJ.fromExtHostTestItem(F,this.controllerId).toString()+"\0";for(const O of this.f)if(j===O||j.startsWith(O))return!1;for(const O of this.c)if(j===O||j.startsWith(O))return!0;return!1}}e.$_gc=S;class P{constructor(F){this.provider=F}async provideFileCoverage(F){this.c||(this.c=(async()=>this.provider.provideFileCoverage(F))());try{return(await this.c)?.map(f.TestCoverage.fromFile)??[]}catch(j){throw this.c=void 0,j}}async resolveFileCoverage(F,j){const O=await this.c;let M=O?.[F];return!this.provider||!O||!M?[]:(M.detailedCoverage||(M=O[F]=await this.provider.resolveFileCoverage?.(M,j)??M),M.detailedCoverage?.map(f.TestCoverage.fromDetailed)??[])}}class w{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(F){this.j=F,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(F){this.c.add(F)}update(F){Object.assign(F.revived,f.TestItem.toPlain(F.item)),this.c.has(F)||this.f.add(F)}remove(F){if(this.c.has(F)){this.c.delete(F);return}this.f.delete(F);const j=i.$IJ.parentId(F.item.extId);if(j&&this.h.has(j.toString())){this.h.add(F.item.extId);return}this.g.add(F)}getChangeEvent(){const{c:F,f:j,g:O}=this;return{get added(){return[...F].map(M=>M.revived)},get updated(){return[...j].map(M=>M.revived)},get removed(){return[...O].map(M=>M.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class p extends o.$QJ{constructor(){super(...arguments),this.s=new I.$Sd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(F){return this.f.get(F)}getMirroredTestDataByReference(F){return this.f.get(F.id)}w(F,j){return{...F,revived:f.TestItem.toPlain(F.item),depth:j?j.depth+1:0,children:new Set}}v(){return new w(this.s)}}class E{constructor(F){this.f=F}checkout(){this.c||(this.c=this.g());const F=this.c;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(j=>j.revived)},dispose:(0,R.$db)(()=>{--F.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(F){return this.c?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.c?.tests.apply(F)}g(){const F=new p({asCanonicalUri:j=>j});return this.f.$subscribeToDiffs(),{observers:0,tests:F}}}class L{#e;#t;#i;#o;#r;get label(){return this.f}set label(F){F!==this.f&&(this.f=F,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:F}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(F){F!==this.h&&(this.h=F,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:F}))}get isDefault(){return this.g}set isDefault(F){F!==this.g&&(this.g=F,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:F}))}get tag(){return this._tag}set tag(F){F?.id!==this._tag?.id&&(this._tag=F,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:F?f.TestTag.namespace(this.controllerId,F.id):null}))}get configureHandler(){return this.c}set configureHandler(F){F!==this.c&&(this.c=F,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!F}))}get isSelected(){return(0,c.$pF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,c.$pF)(this.#t,"testingActiveProfile"),I.Event.chain(this.#o,F=>F.map(j=>j.get(this.controllerId)?.get(this.profileId)).filter(A.$Nf))}constructor(F,j,O,M,W,Y,ue,X,J,x,he=!1,Z=void 0,we=!1){this.controllerId=Y,this.profileId=ue,this.f=X,this.kind=J,this.runHandler=x,this.g=he,this._tag=Z,this.h=we,this.#e=F,this.#r=j,this.#t=O,this.#i=M,this.#o=W,j.set(ue,this);const ce=T[J];if(typeof ce!="number")throw new Error(`Unknown TestRunProfile.group ${J}`);this.#e.$publishTestRunProfile({profileId:ue,controllerId:Y,tag:Z?f.TestTag.namespace(this.controllerId,Z.id):null,label:X,group:ce,isDefault:he,hasConfigurationHandler:!1,supportsContinuousRun:we})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$ahc=L;const T={[s.TestRunProfileKind.Coverage]:8,[s.TestRunProfileKind.Debug]:4,[s.TestRunProfileKind.Run]:2}}),define(Se[340],ke([1,0,19,4,6,148,15,7]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wfc=void 0;class ${constructor(A,C){this.i=C,this.a=new N.$Sd,this.b=new N.$Sd,this.c=new N.$Sd,this.d=new N.$Sd,this.f=new N.$Sd,this.g=new N.$Sd,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(g.$QK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(m=>this.g.fire(m)),this.i.onDidChangeActiveTextEditor(m=>this.f.fire(m))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const C=this.i.allEditors();return A?C:C.map(m=>m.value)}async showTextDocument(A,C,m){let v;typeof C=="number"?v={position:R.ViewColumn.from(C),preserveFocus:m}:typeof C=="object"?v={position:R.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?R.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:v={preserveFocus:!1};const k=await this.h.$tryShowTextDocument(A.uri,v),l=k&&this.i.getEditor(k);if(l)return l.value;throw k?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,C){return new I.$2M(this.h,A,C).value}$acceptEditorPropertiesChanged(A,C){const m=this.i.getEditor(A);if(!m)throw new Error("unknown text editor");if(C.options&&m._acceptOptions(C.options),C.selections){const v=C.selections.selections.map(R.Selection.to);m._acceptSelections(v)}if(C.visibleRanges){const v=D.$Hb(C.visibleRanges.map(R.Range.to));m._acceptVisibleRanges(v)}if(C.options&&this.b.fire({textEditor:m.value,options:{...C.options,lineNumbers:R.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const v=b.TextEditorSelectionChangeKind.fromValue(C.selections.source),k=C.selections.selections.map(R.Selection.to);this.a.fire({textEditor:m.value,selections:k,kind:v})}if(C.visibleRanges){const v=D.$Hb(C.visibleRanges.map(R.Range.to));this.c.fire({textEditor:m.value,visibleRanges:v})}}$acceptEditorPositionData(A){for(const C in A){const m=this.i.getEditor(C);if(!m)throw new Error("Unknown text editor");const v=R.ViewColumn.to(A[C]);m.value.viewColumn!==v&&(m._acceptViewColumn(v),this.d.fire({textEditor:m.value,viewColumn:v}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$wfc=$}),define(Se[341],ke([1,0,2,5,6,3,7,15,26,18]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=e.$chc=void 0,e.$chc=(0,N.$3h)("IExtHostTimeline");class A{constructor(v,k){this.b=new Map,this.c=new Map,this.a=v.getProxy(g.$QK.MainThreadTimeline),k.registerArgumentProcessor({processArgument:(l,f)=>{if(l&&l.$mid===12)if(this.b.get(l.source)&&$.$im.equals(f,this.b.get(l.source)?.extension)){const s=l.uri===void 0?void 0:D.URI.revive(l.uri);return this.c.get(l.source)?.get(C(s))?.get(l.handle)}else return;return l}})}async $getTimeline(v,k,l,f){return this.b.get(v)?.provider.provideTimeline(D.URI.revive(k),l,f)}registerTimelineProvider(v,k,l,f){const s=new I.$Rc,i=this.d(k.id,f,s).bind(this);let n;k.onDidChange&&(n=k.onDidChange(c=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...c,id:k.id}),this));const o=this.c;return this.f({...k,scheme:v,onDidChange:void 0,async provideTimeline(c,t,r){t?.resetCache&&(s.clear(),o.get(k.id)?.clear());const d=await k.provideTimeline(c,t,r);if(d==null)return;const u=i(c,t);return{...d,source:k.id,items:d.items.map(u)}},dispose(){for(const c of o.values())c.get(k.id)?.clear();n?.dispose(),s.dispose()}},l)}d(v,k,l){return(f,s)=>{let i;if(s?.cacheResults){let n=this.c.get(v);n===void 0&&(n=new Map,this.c.set(v,n));const o=C(f);i=n.get(o),i===void 0&&(i=new Map,n.set(o,i))}return n=>{const{iconPath:o,...c}=n,t=`${v}|${n.id??n.timestamp}`;i?.set(t,n);let r,d,u;n.iconPath&&(o instanceof R.$NL?u={id:o.id,color:o.color}:D.URI.isUri(o)?(r=o,d=o):{light:r,dark:d}=o);let a;return R.$hL.isMarkdownString(c.tooltip)?a=b.MarkdownString.from(c.tooltip):(0,y.$Ff)(c.tooltip)?a=c.tooltip:R.$hL.isMarkdownString(c.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=b.MarkdownString.from(c.detail)):(0,y.$Ff)(c.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=c.detail),{...c,id:c.id??void 0,handle:t,source:v,command:n.command?k.toInternal(n.command,l):void 0,icon:r,iconDark:d,themeIcon:u,tooltip:a,accessibilityInformation:n.accessibilityInformation}}}}f(v,k){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:k}),(0,I.$Qc)(()=>{for(const f of this.c.values())f.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$dhc=A;function C(m){return m?.toString()}}),define(Se[72],ke([1,0,21,4,3,221,5,13,88,6,27,20,7]),function(me,e,D,N,g,I,R,b,$,y,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dyb=e.$cyb=e.TunnelDtoConverter=void 0;class v extends $.$wv{}var k;(function(f){function s(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:n.protocol}}f.fromApiTunnel=s;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==$.TunnelPrivacyId.ConstantPrivate&&n.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}f.fromServiceTunnel=i})(k||(e.TunnelDtoConverter=k={})),e.$cyb=(0,R.$3h)("IExtHostTunnelService");let l=class extends g.$Sc{constructor(s,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new N.$Sd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(y.$QK.MainThreadTunnelService)}async openTunnel(s,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,s.displayName);if(n){const o=new v(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,i){const n=this.u();return this.r.set(n,{selector:s,provider:i}),this.a.$registerPortsAttributesProvider(s,n),new m.$SK(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(s,i,n,o,c){const t=[];for(const d of s){const u=this.r.get(d);if(!u)return[];t.push(...await Promise.all(i.map(async a=>{let h;try{h=await u.provider.providePortAttributes({port:a,pid:n,commandLine:o},c)}catch{h=await u.provider.providePortAttributes(a,n,o,c)}return{providedAttributes:h,port:a}})))}const r=t.filter(d=>!!d.providedAttributes);return r.length>0?r.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,c)=>await s.provideTunnel(o,c,new D.$3d().token)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,g.$Qc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,i){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const n=s.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let o=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:I.localize(0,null),themeIcon:"lock"},{id:"public",label:I.localize(1,null),themeIcon:"eye"}]);const c=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:o}:void 0;this.a.$setTunnelProvider(c)}}else this.b=void 0;return(0,g.$Qc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,i){if(this.g.has(s.host)){const n=this.g.get(s.host);n.has(s.port)&&(i&&n.get(s.port).disposeListener.dispose(),await n.get(s.port).tunnel.dispose(),n.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(s,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const o=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const c=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:o,disposeListener:c}),k.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(s){const i=await Promise.all(s.map(o=>this.f(o.host,o.port,o.detail??""))),n=s.filter((o,c)=>i[c]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(o=>o.port).join(", ")} to ${n.map(o=>o.port).join(", ")}`),n}};e.$dyb=l,e.$dyb=l=Ge([We(0,C.$UM),We(1,A.$$M),We(2,b.$kj)],l)}),define(Se[342],ke([1,0,3,17,2,6]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=void 0;class R{static{this.a=new Set([N.Schemas.http,N.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(I.$QK.MainThreadUriOpeners)}registerExternalUriOpener($,y,A,C){if(this.c.has(y))throw new Error(`Opener with id '${y}' already registered`);const m=C.schemes.find(v=>!R.a.has(v));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this.c.set(y,A),this.b.$registerUriOpener(y,C.schemes,$,C.label),(0,D.$Qc)(()=>{this.c.delete(y),this.b.$unregisterUriOpener(y)})}async $canOpenUri($,y,A){const C=this.c.get($);if(!C)throw new Error(`Unknown opener with id: ${$}`);const m=g.URI.revive(y);return C.canOpenExternalUri(m,A)}async $openUri($,y,A){const C=this.c.get($);if(!C)throw new Error(`Unknown opener id: '${$}'`);return C.openExternalUri(g.URI.revive(y.resolvedUri),{sourceUri:g.URI.revive(y.sourceUri)},A)}}e.$fhc=R}),define(Se[343],ke([1,0,6,2,3,14,26]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=void 0;class b{static{this.a=0}constructor(y){this.c=new R.$jm,this.d=new Map,this.b=y.getProxy(D.$QK.MainThreadUrls)}registerUriHandler(y,A){const C=y.identifier;if(this.c.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const m=b.a++;return this.c.add(C),this.d.set(m,A),this.b.$registerUriHandler(m,C,y.displayName||y.name),(0,g.$Qc)(()=>{this.c.delete(C),this.d.delete(m),this.b.$unregisterUriHandler(m)})}$handleExternalUri(y,A){const C=this.d.get(y);if(!C)return Promise.resolve(void 0);try{C.handleUri(N.URI.revive(A))}catch(m){(0,I.$1)(m)}return Promise.resolve(void 0)}async createAppUri(y){return N.URI.revive(await this.b.$createAppUri(y))}}e.$ghc=b}),define(Se[93],ke([1,0,4,3,17,24,2,238,275,113,6]),function(me,e,D,N,g,I,R,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ofc=e.$Nfc=e.$Mfc=e.$Lfc=e.$Kfc=void 0;class C{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(o,c,t,r,d,u,a){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new D.$Sd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new D.$Sd,this._onDidDispose=this.#h.event,this.#e=o,this.#t=c,this.#s=t,this.#o=r,this.#r=d,this.#n=u,this.#l=m(u),this.#d=v(u),this.#i=a}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#u=!0,(0,y.$lvb)(o,this.#o)}get cspSource(){const o=this.#n.extensionLocation;if(o.scheme===g.Schemas.https||o.scheme===g.Schemas.http){let c=o.toString();return c.endsWith("/")||(c+="/"),c+" "+y.$kvb}return y.$kvb}get html(){return this.a(),this.#a}set html(o){this.a(),this.#a!==o&&(this.#a=o,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(o)))}get options(){return this.a(),this.#s}set options(o){this.a(),I.$nn(this.#s,o)||this.#t.$setOptions(this.#e,f(this.#n,this.#r,o)),this.#s=o}async postMessage(o){if(this.#c)return!1;const c=(0,$.$4kb)(o,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,c.message,...c.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(o){if(!this.#d)return o;const c=this.#n.extensionLocation?.scheme===g.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===g.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,d,u,a,h,S)=>{const P=R.URI.from({scheme:a||"file",path:decodeURIComponent(h)}),w=(0,y.$lvb)(P,{isRemote:c,authority:t}).toString();return`${d}${w}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,d,u,a,h,S)=>{const P=R.URI.from({scheme:a||"file",path:decodeURIComponent(h)}),w=(0,y.$lvb)(P,{isRemote:c,authority:t}).toString();return`${d}${w}${S}`})}}e.$Kfc=C;function m(n){try{const o=(0,b.$3o)((0,b.$2o)(n.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}e.$Lfc=m;function v(n){try{const o=(0,b.$3o)((0,b.$2o)(n.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class k extends N.$Sc{constructor(o,c,t,r,d){super(),this.c=c,this.f=t,this.g=r,this.h=d,this.b=new Map,this.a=o.getProxy(A.$QK.MainThreadWebviews)}dispose(){super.dispose();for(const o of this.b.values())o.dispose();this.b.clear()}$onMessage(o,c,t){const r=this.j(o);if(r){const{message:d}=(0,$.$5kb)(c,t.value);r._onMessageEmitter.fire(d)}}$onMissingCsp(o,c){this.g.warn(`${c} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,c,t){const r=new C(o,this.a,s(c),this.c,this.f,t,this.h);this.b.set(o,r);const d=r._onDidDispose(()=>{d.dispose(),this.deleteWebview(o)});return r}deleteWebview(o){this.b.delete(o)}j(o){return this.b.get(o)}}e.$Mfc=k;function l(n){return{id:n.identifier,location:n.extensionLocation}}e.$Nfc=l;function f(n,o,c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots||i(n,o)}}e.$Ofc=f;function s(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(o=>R.URI.from(o))}}function i(n,o){return[...(o?.getWorkspaceFolders()||[]).map(c=>c.uri),n.extensionLocation]}}),define(Se[344],ke([1,0,21,54,3,17,23,2,15,93,110,6,7]),function(me,e,D,N,g,I,R,b,$,y,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qfc=void 0;class v{constructor(r,d){this.document=r,this.b=d,this.a=1,this.c=new A.$dfc("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,d){await this.f(r).undo(),d||this.disposeBackup()}async redo(r,d){await this.f(r).redo(),d||this.disposeBackup()}disposeEdits(r){for(const d of r)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=c(this.document.uri)+this.a++;return(0,R.$Eg)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const d=this.c.get(r,0);if(!d)throw new Error("No edit found");return d}}class k{constructor(){this.a=new Map}get(r,d){return this.a.get(this.b(r,d))}add(r,d,u){const a=this.b(r,d.uri);if(this.a.has(a))throw new Error(`Document already exists for viewType:${r} resource:${d.uri}`);const h=new v(d,u);return this.a.set(a,h),h}delete(r,d){const u=this.b(r,d.uri);this.a.delete(u)}b(r,d){return`${r}@@@${d}`}}var l;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(l||(l={}));class f{constructor(){this.a=new Map}addTextProvider(r,d,u){return this.b(0,r,d,u)}addCustomProvider(r,d,u){return this.b(1,r,d,u)}get(r){return this.a.get(r)}b(r,d,u,a){if(this.a.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this.a.set(d,{type:r,extension:u,provider:a}),new m.$SK(()=>this.a.delete(d))}}class s{constructor(r,d,u,a,h){this.d=d,this.f=u,this.g=a,this.h=h,this.b=new f,this.c=new k,this.a=r.getProxy(C.$QK.MainThreadCustomEditors)}registerCustomEditorProvider(r,d,u,a){const h=new g.$Rc;return n(u)?(h.add(this.b.addTextProvider(d,r,u)),this.a.$registerTextEditorProvider((0,y.$Nfc)(r),d,a.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,y.$Lfc)(r))):(h.add(this.b.addCustomProvider(d,r,u)),i(u)&&h.add(u.onDidChangeCustomDocument(S=>{const P=this.i(d,S.document.uri);if(o(S)){const w=P.addEdit(S);this.a.$onDidEdit(S.document.uri,d,w,S.label)}else this.a.$onContentChange(S.document.uri,d)})),this.a.$registerCustomEditorProvider((0,y.$Nfc)(r),d,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,y.$Lfc)(r))),m.$SK.from(h,new m.$SK(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(r,d,u,a,h){const S=this.b.get(d);if(!S)throw new Error(`No provider found for '${d}'`);if(S.type!==1)throw new Error(`Invalid provide type for '${d}'`);const P=b.URI.revive(r),w=await S.provider.openCustomDocument(P,{backupId:u,untitledDocumentData:a?.buffer},h);let p;return i(S.provider)&&this.f&&(p=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(d,w,p),{editable:i(S.provider)}}async $disposeCustomDocument(r,d){const u=this.b.get(d);if(!u)throw new Error(`No provider found for '${d}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${d}'`);const a=b.URI.revive(r),{document:h}=this.i(d,a);this.c.delete(d,h),h.dispose()}async $resolveCustomEditor(r,d,u,a,h,S){const P=this.b.get(u);if(!P)throw new Error(`No provider found for '${u}'`);const w=$.ViewColumn.to(h),p=this.g.createNewWebview(d,a.contentOptions,P.extension),E=this.h.createNewWebviewPanel(d,u,a.title,w,a.options,p,a.active),L=b.URI.revive(r);switch(P.type){case 1:{const{document:T}=this.i(u,L);return P.provider.resolveCustomEditor(T,E,S)}case 0:{const T=this.d.getDocument(L);return P.provider.resolveCustomTextEditor(T,E,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,d,u){this.i(d,r).disposeEdits(u)}async $onMoveCustomEditor(r,d,u){const a=this.b.get(u);if(!a)throw new Error(`No provider found for '${u}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const h=this.h.getWebviewPanel(r);if(!h)throw new Error("No webview found");const S=b.URI.revive(d),P=this.d.getDocument(S);await a.provider.moveCustomTextEditor(P,h,D.CancellationToken.None)}async $undo(r,d,u,a){return this.i(d,r).undo(u,a)}async $redo(r,d,u,a){return this.i(d,r).redo(u,a)}async $revert(r,d,u){const a=this.i(d,r);await this.j(d).revertCustomDocument(a.document,u),a.disposeBackup()}async $onSave(r,d,u){const a=this.i(d,r);await this.j(d).saveCustomDocument(a.document,u),a.disposeBackup()}async $onSaveAs(r,d,u,a){const h=this.i(d,r);return this.j(d).saveCustomDocumentAs(h.document,b.URI.revive(u),a)}async $backup(r,d,u){const a=this.i(d,r),S=await this.j(d).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},u);return a.updateBackup(S),S.id}i(r,d){const u=this.c.get(r,b.URI.revive(d));if(!u)throw new Error("No custom document found");return u}j(r){const u=this.b.get(r)?.provider;if(!u||!i(u))throw new Error("Custom document is not editable");return u}}e.$Qfc=s;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function o(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function c(t){const r=t.scheme===I.Schemas.file||t.scheme===I.Schemas.untitled?t.fsPath:t.toString();return(0,N.$Qi)(r)+""}}),define(Se[345],ke([1,0,4,3,2,30,15,93,6,7]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pfc=void 0;class A extends N.$Sc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(k,l,f,s){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new D.$Sd),this.onDidDispose=this.#d.event,this.#h=this.B(new D.$Sd),this.onDidChangeViewState=this.#h.event,this.#e=k,this.#t=l,this.#o=f,this.#i=s.viewType,this.#r=s.panelOptions,this.#s=s.viewColumn,this.#n=s.title,this.#u=s.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(k){this.c(),this.#n!==k&&(this.#n=k,this.#t.$setTitle(this.#e,k))}get iconPath(){return this.c(),this.#a}set iconPath(k){this.c(),this.#a!==k&&(this.#a=k,this.#t.$setIconPath(this.#e,g.URI.isUri(k)?{light:k,dark:k}:k))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(k){this.#l||(this.active!==k.active||this.visible!==k.visible||this.viewColumn!==k.viewColumn)&&(this.#u=k.active,this.#c=k.visible,this.#s=k.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(k,l){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof k>"u"?void 0:R.ViewColumn.from(k),preserveFocus:!!l})}c(){if(this.#l)throw new Error("Webview is disposed")}}class C extends N.$Sc{static c(){return(0,I.$ng)()}constructor(k,l,f){super(),this.j=l,this.m=f,this.g=new Map,this.h=new Map,this.f=k.getProxy($.$QK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(k=>k.dispose()),this.g.clear()}createWebviewPanel(k,l,f,s,i={}){const n=typeof s=="object"?s.viewColumn:s,o={viewColumn:R.ViewColumn.from(n),preserveFocus:typeof s=="object"&&!!s.preserveFocus},c=(0,b.$Lfc)(k),t=C.c();this.f.$createWebviewPanel((0,b.$Nfc)(k),t,l,{title:f,panelOptions:m(i),webviewOptions:(0,b.$Ofc)(k,this.m,i),serializeBuffersForPostMessage:c},o);const r=this.j.createNewWebview(t,i,k);return this.createNewWebviewPanel(t,l,f,n,i,r,!0)}$onDidChangeWebviewPanelViewStates(k){const l=Object.keys(k);l.sort((f,s)=>{const i=k[f],n=k[s];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const f of l){const s=this.getWebviewPanel(f);if(!s)continue;const i=k[f];s._updateViewState({active:i.active,visible:i.visible,viewColumn:R.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(k){this.getWebviewPanel(k)?.dispose(),this.g.delete(k),this.j.deleteWebview(k)}registerWebviewPanelSerializer(k,l,f){if(this.h.has(l))throw new Error(`Serializer for '${l}' already registered`);return this.h.set(l,{serializer:f,extension:k}),this.f.$registerSerializer(l,{serializeBuffersForPostMessage:(0,b.$Lfc)(k)}),new y.$SK(()=>{this.h.delete(l),this.f.$unregisterSerializer(l)})}async $deserializeWebviewPanel(k,l,f,s){const i=this.h.get(l);if(!i)throw new Error(`No serializer found for '${l}'`);const{serializer:n,extension:o}=i,c=this.j.createNewWebview(k,f.webviewOptions,o),t=this.createNewWebviewPanel(k,l,f.title,s,f.panelOptions,c,f.active);await n.deserializeWebviewPanel(t,f.state)}createNewWebviewPanel(k,l,f,s,i,n,o){const c=new A(k,this.f,n,{viewType:l,title:f,viewColumn:s,panelOptions:i,active:o});return this.g.set(k,c),c}getWebviewPanel(k){return this.g.get(k)}}e.$Pfc=C;function m(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(Se[346],ke([1,0,4,3,93,15,6,7]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=void 0;class $ extends N.$Sc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(C,m,v,k,l,f){super(),this.#r=!1,this.#u=this.B(new D.$Sd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new D.$Sd),this.onDidDispose=this.#l.event,this.#i=v,this.#a=k,this.#e=C,this.#t=m,this.#o=l,this.#n=f}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(C){this.a(),this.#a!==C&&(this.#a=C,this.#t.$setWebviewViewTitle(this.#e,C))}get description(){return this.a(),this.#s}set description(C){this.a(),this.#s!==C&&(this.#s=C,this.#t.$setWebviewViewDescription(this.#e,C))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(C){C===this.#n||this.#r||(this.#n=C,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(C){this.a(),!(C?.value===this.#c?.value&&C?.tooltip===this.#c?.tooltip)&&(this.#c=I.ViewBadge.from(C),this.#t.$setWebviewViewBadge(this.#e,C))}show(C){this.a(),this.#t.$show(this.#e,!!C)}a(){if(this.#r)throw new Error("Webview is disposed")}}class y{constructor(C,m){this.d=m,this.b=new Map,this.c=new Map,this.a=C.getProxy(R.$QK.MainThreadWebviewViews)}registerWebviewViewProvider(C,m,v,k){if(this.b.has(m))throw new Error(`View provider for '${m}' already registered`);return this.b.set(m,{provider:v,extension:C}),this.a.$registerWebviewViewProvider((0,g.$Nfc)(C),m,{retainContextWhenHidden:k?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,g.$Lfc)(C)}),new b.$SK(()=>{this.b.delete(m),this.a.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(C,m,v,k,l){const f=this.b.get(m);if(!f)throw new Error(`No view provider found for '${m}'`);const{provider:s,extension:i}=f,n=this.d.createNewWebview(C,{},i),o=new $(C,this.a,m,v,n,!0);this.c.set(C,o),await s.resolveWebviewView(o,{state:k},l)}async $onDidChangeWebviewViewVisibility(C,m){this.e(C)._setVisible(m)}async $disposeWebviewView(C){const m=this.e(C);this.c.delete(C),m.dispose(),this.d.deleteWebview(C)}e(C){const m=this.c.get(C);if(!m)throw new Error("No webview found");return m}}e.$hhc=y}),define(Se[151],ke([1,0,4,6,2,17,12,5,20,25]),function(me,e,D,N,g,I,R,b,$,y){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$jhc=e.$ihc=void 0;let C=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(v){const k=this.d;return{get focused(){return k.focused},get active(){return(0,y.$pF)(v,"windowActivity"),k.active}}}constructor(v){this.c=new D.$Sd,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=v.getProxy(N.$QK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:k,isActive:l})=>{this.onDidChangeWindowProperty("focused",k),this.onDidChangeWindowProperty("active",l)})}$onDidChangeWindowFocus(v){this.onDidChangeWindowProperty("focused",v)}$onDidChangeWindowActive(v){this.onDidChangeWindowProperty("active",v)}onDidChangeWindowProperty(v,k){k!==this.d[v]&&(this.d={...this.d,[v]:k},this.c.fire(this.d))}openUri(v,k){let l;if(typeof v=="string"){l=v;try{v=g.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,R.$Ge)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===I.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this.b.$openUri(v,l,k)}async asExternalUri(v,k){if((0,R.$Ge)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const l=await this.b.$asExternalUri(v,k);return g.URI.from(l)}};e.$ihc=C,e.$ihc=C=A=Ge([We(0,$.$UM)],C),e.$jhc=(0,b.$3h)("IExtHostWindow")}),define(Se[347],ke([1,0,315,27,20]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhc=void 0;const I=1024*1024;let R=class extends D.$mhc{constructor($,y){super($,y),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,y,A){const C=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,C.write(`
START_NATIVE_LOG
`),y.apply(console,A),C.write(`
END_NATIVE_LOG
`),this.g=!1}j($,y){const A=process[$],C=A.write;let m="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(v,k,l)=>{if(!this.g){m+=v.toString(k);const f=m.length>I?m.length:m.lastIndexOf(`
`);f!==-1&&(console[y](m.slice(0,f)),m=m.slice(f+1))}C.call(A,v,k,l)}})}};e.$Xhc=R,e.$Xhc=R=Ge([We(0,g.$UM),We(1,N.$$M)],R)}),define(Se[348],ke([1,0,71,17,13,250,32,10]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhc=void 0;let $=class{constructor(C,m){C.addFileSystemProvider(N.Schemas.file,new y(m),{isCaseSensitive:b.$k})}};e.$Yhc=$,e.$Yhc=$=Ge([We(0,D.$Hfc),We(1,g.$kj)],$);class y{constructor(C){this.b=C,this.a=new I.$pq(this.b)}async stat(C){const m=await this.a.stat(C);return{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(C){return this.a.readdir(C)}createDirectory(C){return this.a.mkdir(C)}readFile(C){return this.a.readFile(C)}writeFile(C,m,v){return this.a.writeFile(C,m,{...v,unlock:!1,atomic:!1})}delete(C,m){return this.a.delete(C,{...m,useTrash:!1,atomic:!1})}rename(C,m,v){return this.a.rename(C,m,v)}copy(C,m,v){return this.a.copy(C,m,v)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(C,m){throw new Error("Method not implemented.")}}}),define(Se[349],ke([1,0,16,63,30,35,3,6,2,20]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=void 0;let A=class extends R.$Sc{constructor(m,v){super();const k=m.getProxy(b.$QK.MainThreadDownloadService);v.registerCommand(!1,"_workbench.downloadResource",async l=>{const f=$.URI.file((0,D.$jc)((0,N.tmpdir)(),(0,g.$ng)()));return await k.$download(l,f),f})}};e.$Whc=A,e.$Whc=A=Ge([We(0,y.$UM),We(1,I.$eN)],A)}),define(Se[350],ke([1,0,150,17,252,30]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=void 0;class R extends D.$lhc{s($,y,A){return $.scheme===N.Schemas.file?new g.$7N(A?.name||(0,I.$ng)(),$.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,y):super.s($,y,A)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$0hc=R}),define(Se[351],ke([1,0,56,16,2,92,3,17,11,31]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=void 0;class A extends I.$Jfc{constructor(){super(...arguments),this.i=null}async g(t){const r=await super.g(t);if(r.scheme!==b.Schemas.file)return r;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${r.fsPath}.`),r;const d=r.fsPath;let u=0;do{let a;u===0?a=d:a=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${u}`:`${d}-${u}`,await C(a);const h=N.$jc(a,"vscode.lock"),S=await l(this.d,h,!1);if(S)return this.i=S,process.on("exit",()=>{S.dispose()}),g.URI.file(a);u++}while(u<10);return r}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$9hc=A;async function C(c){try{await y.Promises.stat(c);return}catch{}try{await y.Promises.mkdir(c,{recursive:!0})}catch{}}const m=1e3,v=10*60*1e3;class k extends R.$Sc{constructor(t,r){super(),this.b=t,this.c=r,this.a=this.B(new $.$bh),this.a.cancelAndSet(async()=>{const d=await f(t,r);(!d||d.pid!==process.pid)&&(t.info(`Lock '${r}': The lock was lost unexpectedly.`),this.a.cancel());try{await y.Promises.utimes(r,new Date,new Date)}catch(u){t.error(u),t.info(`Lock '${r}': Could not update mtime.`)}},m)}dispose(){super.dispose();try{D.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const r={pid:process.pid,willReleaseAt:Date.now()+t};await y.Promises.writeFile(this.c,JSON.stringify(r),{flag:"w"})}catch(r){this.b.error(r)}}}async function l(c,t,r){try{const u={pid:process.pid,willReleaseAt:0};await y.Promises.writeFile(t,JSON.stringify(u),{flag:"wx"})}catch(u){c.error(u)}const d=await f(c,t);return!d||d.pid!==process.pid?r?(c.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(c.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(c,t)):(c.info(`Lock '${t}': Lock acquired.`),new k(c,t))}async function f(c,t){let r;try{r=await y.Promises.readFile(t)}catch(d){return c.error(d),null}try{return JSON.parse(String(r))}catch(d){return c.error(d),null}}async function s(c,t){let r;try{r=await y.Promises.stat(t)}catch(d){return c.error(d),0}return r.mtime.getTime()}function i(c){try{return process.kill(c,0),!0}catch{return!1}}async function n(c,t){const r=await f(c,t);if(!r)return c.info(`Lock '${t}': Could not read pid of lock holder.`),o(c,t);if(r.willReleaseAt){let S=r.willReleaseAt-Date.now();if(S<5e3){for(S>0?c.info(`Lock '${t}': The lockfile is scheduled to be released in ${S} ms.`):c.info(`Lock '${t}': The lockfile is scheduled to have been released.`);S>0;){if(await(0,$.$4g)(Math.min(100,S)),await s(c,t)===0)return o(c,t);S=r.willReleaseAt-Date.now()}return o(c,t)}}if(!i(r.pid))return c.info(`Lock '${t}': The pid ${r.pid} appears to be gone.`),o(c,t);const d=await s(c,t),u=Date.now()-d;if(u<=v)return c.info(`Lock '${t}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null;c.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$4g)(2e3);const a=await s(c,t),h=Date.now()-a;return h<=v?(c.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(c.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),o(c,t))}async function o(c,t){c.info(`Lock '${t}': Deleting a stale lock.`);try{await y.Promises.unlink(t)}catch{}return l(c,t,!0)}}),define(Se[352],ke([1,0,30,20,47,35]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhc=void 0;let R=class extends g.$6fc{constructor($,y){super(!0,$,y)}createTerminal($,y,A){return this.createTerminalFromOptions({name:$,shellPath:y,shellArgs:A})}createTerminalFromOptions($,y){const A=new g.$5fc(this.a,(0,D.$ng)(),$,$.name);return this.f.push(A),A.create($,this.R($,y)),A.value}};e.$rhc=R,e.$rhc=R=Ge([We(0,I.$eN),We(1,N.$UM)],R)}),define(Se[353],ke([1,0,11,22,21,14,4,3,130,304,68]),function(me,e,D,N,g,I,R,b,$,y,A){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$x7b=e.ResponsiveState=e.RequestInitiator=e.$w7b=e.$v7b=void 0;function m(E,L){try{return JSON.stringify(E,L)}catch{return"null"}}const v="$$ref$$",k={[v]:-1};class l{constructor(L,T){this.jsonString=L,this.referencedBuffers=T}}function f(E,L=null,T=!1){const U=[];return{jsonString:(T?m:JSON.stringify)(E,(j,O)=>{if(typeof O>"u")return k;if(typeof O=="object"){if(O instanceof N.$ge){const M=U.push(O)-1;return{[v]:M}}if(L)return L(j,O)}return O}),referencedBuffers:U}}e.$v7b=f;function s(E,L,T){return JSON.parse(E,(U,F)=>{if(F){const j=F[v];if(typeof j=="number")return L[j];if(T&&F.$mid===1)return T.transformIncoming(F)}return F})}e.$w7b=s;function i(E,L){return JSON.stringify(E,L)}function n(E){return E?(L,T)=>T&&T.$mid===1?E.transformOutgoing(T):T:null}var o;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var c;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(c||(e.ResponsiveState=c={}));const t=()=>{},r=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class u extends b.$Sc{static{C=r}static{this.a=3*1e3}constructor(L,T=null,U=null){super(),this[C]=!0,this.b=this.B(new R.$Sd),this.onDidChangeResponsiveState=this.b.event,this.c=L,this.f=T,this.g=U,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let F=0,j=A.$Dv.count;F<j;F++)this.m[F]=null,this.s[F]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new D.$ch(()=>this.H(),1e3)),this.c.onMessage(F=>this.L(F))}dispose(){this.j=!0,Object.keys(this.w).forEach(L=>{const T=this.w[L];delete this.w[L],T.resolveErr(I.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(L){this.z===0&&(this.C=Date.now()+u.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(L){this.C=Date.now()+u.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(L){this.y!==L&&(this.y=L,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(L){return this.g?(0,$.$4m)(L,this.g):L}getProxy(L){const{nid:T,sid:U}=L;return this.s[T]||(this.s[T]=this.J(T,U)),this.s[T]}J(L,T){const U={get:(F,j)=>(typeof j=="string"&&!F[j]&&j.charCodeAt(0)===36&&(F[j]=(...O)=>this.U(L,j,O)),j===d?T:F[j])};return new Proxy(Object.create(null),U)}set(L,T){return this.m[L.nid]=T,T}assertRegistered(L){for(let T=0,U=L.length;T<U;T++){const F=L[T];if(!this.m[F.nid])throw new Error(`Missing proxy instance ${F.sid}`)}}L(L){if(this.j)return;const T=L.byteLength,U=h.read(L,0),F=U.readUInt8(),j=U.readUInt32();switch(F){case 1:case 2:{let{rpcId:O,method:M,args:W}=P.deserializeRequestJSONArgs(U);this.g&&(W=(0,$.$4m)(W,this.g)),this.M(T,j,O,M,W,F===2);break}case 3:case 4:{let{rpcId:O,method:M,args:W}=P.deserializeRequestMixedArgs(U);this.g&&(W=(0,$.$4m)(W,this.g)),this.M(T,j,O,M,W,F===4);break}case 5:{this.f?.logIncoming(T,j,0,"ack"),this.G(j);break}case 6:{this.N(T,j);break}case 7:{this.O(T,j,void 0);break}case 9:{let O=P.deserializeReplyOKJSON(U);this.g&&(O=(0,$.$4m)(O,this.g)),this.O(T,j,O);break}case 10:{const O=P.deserializeReplyOKJSONWithBuffers(U,this.g);this.O(T,j,O);break}case 8:{const O=P.deserializeReplyOKVSBuffer(U);this.O(T,j,O);break}case 11:{let O=P.deserializeReplyErrError(U);this.g&&(O=(0,$.$4m)(O,this.g)),this.P(T,j,O);break}case 12:{this.P(T,j,void 0);break}default:console.error("received unexpected message"),console.error(L)}}M(L,T,U,F,j,O){this.f?.logIncoming(L,T,1,`receiveRequest ${(0,A.$Fv)(U)}.${F}(`,j);const M=String(T);let W,Y;if(O){const X=new g.$3d;j.push(X.token),W=this.Q(U,F,j),Y=()=>X.cancel()}else W=this.Q(U,F,j),Y=t;this.u[M]=Y;const ue=P.serializeAcknowledged(T);this.f?.logOutgoing(ue.byteLength,T,1,"ack"),this.c.send(ue),W.then(X=>{delete this.u[M];const J=P.serializeReplyOK(T,X,this.h);this.f?.logOutgoing(J.byteLength,T,1,"reply:",X),this.c.send(J)},X=>{delete this.u[M];const J=P.serializeReplyErr(T,X);this.f?.logOutgoing(J.byteLength,T,1,"replyErr:",X),this.c.send(J)})}N(L,T){this.f?.logIncoming(L,T,1,"receiveCancel");const U=String(T);this.u[U]?.()}O(L,T,U){this.f?.logIncoming(L,T,0,"receiveReply:",U);const F=String(T);if(!this.w.hasOwnProperty(F))return;const j=this.w[F];delete this.w[F],j.resolveOk(U)}P(L,T,U){this.f?.logIncoming(L,T,0,"receiveReplyErr:",U);const F=String(T);if(!this.w.hasOwnProperty(F))return;const j=this.w[F];delete this.w[F];let O;U&&(U.$isError?(O=new Error,O.name=U.name,O.message=U.message,O.stack=U.stack):O=U),j.resolveErr(O)}Q(L,T,U){try{return Promise.resolve(this.S(L,T,U))}catch(F){return Promise.reject(F)}}S(L,T,U){const F=this.m[L];if(!F)throw new Error("Unknown actor "+(0,A.$Fv)(L));const j=F[T];if(typeof j!="function")throw new Error("Unknown method "+T+" on actor "+(0,A.$Fv)(L));return j.apply(F,U)}U(L,T,U){if(this.j)return new y.$u7b;let F=null;if(U.length>0&&g.CancellationToken.isCancellationToken(U[U.length-1])&&(F=U.pop()),F&&F.isCancellationRequested)return Promise.reject(I.$6());const j=P.serializeRequestArguments(U,this.h),O=++this.t,M=String(O),W=new y.$t7b,Y=new b.$Rc;F&&Y.add(F.onCancellationRequested(()=>{const X=P.serializeCancel(O);this.f?.logOutgoing(X.byteLength,O,0,"cancel"),this.c.send(P.serializeCancel(O))})),this.w[M]=new a(W,Y),this.F(O);const ue=P.serializeRequest(O,L,T,j,!!F);return this.f?.logOutgoing(ue.byteLength,O,0,`request: ${(0,A.$Fv)(L)}.${T}(`,U),this.c.send(ue),W}}e.$x7b=u;class a{constructor(L,T){this.a=L,this.b=T}resolveOk(L){this.a.resolveOk(L),this.b.dispose()}resolveErr(L){this.a.resolveErr(L),this.b.dispose()}}class h{static alloc(L,T,U){const F=new h(N.$ge.alloc(U+1+4),0);return F.writeUInt8(L),F.writeUInt32(T),F}static read(L,T){return new h(L,T)}get buffer(){return this.a}constructor(L,T){this.a=L,this.b=T}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(L){this.a.writeUInt8(L,this.b),this.b+=1}readUInt8(){const L=this.a.readUInt8(this.b);return this.b+=1,L}writeUInt32(L){this.a.writeUInt32BE(L,this.b),this.b+=4}readUInt32(){const L=this.a.readUInt32BE(this.b);return this.b+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this.a.writeUInt8(L.byteLength,this.b),this.b+=1,this.a.set(L,this.b),this.b+=L.byteLength}readShortString(){const L=this.a.readUInt8(this.b);this.b+=1;const U=this.a.slice(this.b,this.b+L).toString();return this.b+=L,U}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readLongString(){const L=this.a.readUInt32BE(this.b);this.b+=4;const U=this.a.slice(this.b,this.b+L).toString();return this.b+=L,U}writeBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readVSBuffer(){const L=this.a.readUInt32BE(this.b);this.b+=4;const T=this.a.slice(this.b,this.b+L);return this.b+=L,T}static sizeMixedArray(L){let T=0;T+=1;for(let U=0,F=L.length;U<F;U++){const j=L[U];switch(T+=1,j.type){case 1:T+=this.sizeLongString(j.value);break;case 2:T+=this.sizeVSBuffer(j.value);break;case 3:T+=this.sizeUInt32,T+=this.sizeLongString(j.value);for(let O=0;O<j.buffers.length;++O)T+=this.sizeVSBuffer(j.buffers[O]);break;case 4:break}}return T}writeMixedArray(L){this.a.writeUInt8(L.length,this.b),this.b+=1;for(let T=0,U=L.length;T<U;T++){const F=L[T];switch(F.type){case 1:this.writeUInt8(1),this.writeLongString(F.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(F.value);break;case 3:this.writeUInt8(3),this.writeUInt32(F.buffers.length),this.writeLongString(F.value);for(let j=0;j<F.buffers.length;++j)this.writeBuffer(F.buffers[j]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this.a.readUInt8(this.b);this.b+=1;const T=new Array(L);for(let U=0;U<L;U++)switch(this.readUInt8()){case 1:T[U]=this.readLongString();break;case 2:T[U]=this.readVSBuffer();break;case 3:{const j=this.readUInt32(),O=this.readLongString(),M=[];for(let W=0;W<j;++W)M.push(this.readVSBuffer());T[U]=new A.$Gv(s(O,M,null));break}case 4:T[U]=void 0;break}return T}}var S;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(S||(S={}));class P{static a(L){for(let T=0,U=L.length;T<U;T++)if(L[T]instanceof N.$ge||L[T]instanceof A.$Gv||typeof L[T]>"u")return!0;return!1}static serializeRequestArguments(L,T){if(this.a(L)){const U=[];for(let F=0,j=L.length;F<j;F++){const O=L[F];if(O instanceof N.$ge)U[F]={type:2,value:O};else if(typeof O>"u")U[F]={type:4};else if(O instanceof A.$Gv){const{jsonString:M,referencedBuffers:W}=f(O.value,T);U[F]={type:3,value:N.$ge.fromString(M),buffers:W}}else U[F]={type:1,value:N.$ge.fromString(i(O,T))}}return{type:1,args:U}}return{type:0,args:i(L,T)}}static serializeRequest(L,T,U,F,j){switch(F.type){case 0:return this.b(L,T,U,F.args,j);case 1:return this.c(L,T,U,F.args,j)}}static b(L,T,U,F,j){const O=N.$ge.fromString(U),M=N.$ge.fromString(F);let W=0;W+=h.sizeUInt8(),W+=h.sizeShortString(O),W+=h.sizeLongString(M);const Y=h.alloc(j?2:1,L,W);return Y.writeUInt8(T),Y.writeShortString(O),Y.writeLongString(M),Y.buffer}static deserializeRequestJSONArgs(L){const T=L.readUInt8(),U=L.readShortString(),F=L.readLongString();return{rpcId:T,method:U,args:JSON.parse(F)}}static c(L,T,U,F,j){const O=N.$ge.fromString(U);let M=0;M+=h.sizeUInt8(),M+=h.sizeShortString(O),M+=h.sizeMixedArray(F);const W=h.alloc(j?4:3,L,M);return W.writeUInt8(T),W.writeShortString(O),W.writeMixedArray(F),W.buffer}static deserializeRequestMixedArgs(L){const T=L.readUInt8(),U=L.readShortString(),F=L.readMixedArray(),j=new Array(F.length);for(let O=0,M=F.length;O<M;O++){const W=F[O];typeof W=="string"?j[O]=JSON.parse(W):j[O]=W}return{rpcId:T,method:U,args:j}}static serializeAcknowledged(L){return h.alloc(5,L,0).buffer}static serializeCancel(L){return h.alloc(6,L,0).buffer}static serializeReplyOK(L,T,U){if(typeof T>"u")return this.d(L);if(T instanceof N.$ge)return this.e(L,T);if(T instanceof A.$Gv){const{jsonString:F,referencedBuffers:j}=f(T.value,U,!0);return this.g(L,F,j)}else return this.f(L,m(T,U))}static d(L){return h.alloc(7,L,0).buffer}static e(L,T){let U=0;U+=h.sizeVSBuffer(T);const F=h.alloc(8,L,U);return F.writeVSBuffer(T),F.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static f(L,T){const U=N.$ge.fromString(T);let F=0;F+=h.sizeLongString(U);const j=h.alloc(9,L,F);return j.writeLongString(U),j.buffer}static g(L,T,U){const F=N.$ge.fromString(T);let j=0;j+=h.sizeUInt32,j+=h.sizeLongString(F);for(const M of U)j+=h.sizeVSBuffer(M);const O=h.alloc(10,L,j);O.writeUInt32(U.length),O.writeLongString(F);for(const M of U)O.writeBuffer(M);return O.buffer}static deserializeReplyOKJSON(L){const T=L.readLongString();return JSON.parse(T)}static deserializeReplyOKJSONWithBuffers(L,T){const U=L.readUInt32(),F=L.readLongString(),j=[];for(let O=0;O<U;++O)j.push(L.readVSBuffer());return new A.$Gv(s(F,j,T))}static serializeReplyErr(L,T){const U=T?m(I.$3(T),null):void 0;if(typeof U!="string")return this.h(L);const F=N.$ge.fromString(U);let j=0;j+=h.sizeLongString(F);const O=h.alloc(11,L,j);return O.writeLongString(F),O.buffer}static deserializeReplyErrError(L){const T=L.readLongString();return JSON.parse(T)}static h(L){return h.alloc(12,L,0).buffer}}var w;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var p;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(p||(p={}))}),define(Se[354],ke([1,0,4,37,46,5]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aK=e.$_J=e.OutputChannelUpdateMode=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=void 0,e.$2J="text/x-code-output",e.$3J="output",e.$4J="Log",e.$5J="text/x-code-log-output",e.$6J="log",e.$7J="workbench.panel.output",e.$8J=new g.$hj("inOutput",!1),e.$9J=new g.$hj("activeLogOutput",!1),e.$0J=new g.$hj("outputView.scrollLock",!1),e.$$J=(0,I.$3h)("outputService");var R;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$_J={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new D.$Sd,this.onDidRegisterChannel=this.b.event,this.c=new D.$Sd,this.onDidRemoveChannel=this.c.event}registerChannel(y){this.a.has(y.id)||(this.a.set(y.id,y),this.b.fire(y.id))}getChannels(){const y=[];return this.a.forEach(A=>y.push(A)),y}getChannel(y){return this.a.get(y)}removeChannel(y){this.a.delete(y),this.c.fire(y)}}N.$vn.add(e.$_J.OutputChannels,new b),e.$aK=new g.$hj("activeOutputChannel","")}),define(Se[152],ke([1,0,6,5,20,26,13,354,71,27,58,182,22,18,32,4,3]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=e.$Ugc=void 0;class s extends R.$qj{get disposed(){return this.n}constructor(c,t,r,d,u){super(),this.id=c,this.name=t,this.r=r,this.s=d,this.extension=u,this.m=0,this.n=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(a=>this.setLevel(a)))}get logLevel(){return this.getLevel()}appendLine(c){this.append(c+`
`)}append(c){this.info(c)}clear(){const c=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,c)}replace(c){const t=this.m;this.info(c),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(c,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof c=="boolean"?c:t))}hide(){this.s.$close(this.id)}g(c,t){this.m+=m.$ge.fromString(t).byteLength,(0,R.log)(this.r,c,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends s{appendLine(c){this.append(c)}}let n=class{constructor(c,t,r,d,u,a){this.i=t,this.j=r,this.k=d,this.l=u,this.m=a,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=c.getProxy(D.$QK.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,C.$tm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(c){this.h=c;for(const[t,r]of this.g)r.visible=t===this.h}createOutputChannel(c,t,r){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");const d=typeof t=="object"&&t.log,u=(0,v.$Ff)(t)?t:void 0;if((0,v.$Ff)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let a;const h=this.i.environment.extensionLogLevel?.find(([P])=>I.$im.equals(r.identifier,P))?.[1];h&&(a=(0,R.$Aj)(h));const S=d?this.o(c,a,r):this.n(c,u,r);return S.then(P=>{this.g.set(P.id,P),P.visible=P.id===this.h}),d?this.r(c,a??this.m.getLevel(),S):this.q(c,S)}async n(c,t,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,u=this.k.extUri.joinPath(d,`${this.f++}-${c.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.l.createLogger(u,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(c,u,t,r.identifier.value);return new s(h,c,a,this.a,r)}async o(c,t,r){const d=await this.p(r),u=c.replace(/[\\/:\*\?"<>\|]/g,""),a=this.k.extUri.joinPath(d,`${u}.log`),h=`${r.identifier.value}.${u}`,S=this.l.createLogger(a,{id:h,name:c,logLevel:t,extensionId:r.identifier.value});return new i(h,c,S,this.a,r)}p(c){let t=this.d.get(c.identifier.value);if(!t){const r=this.k.extUri.joinPath(this.i.logsLocation,c.identifier.value);this.d.set(c.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(r)}catch(d){if((0,k.$Dk)(d)!==k.FileSystemProviderErrorCode.FileExists)throw d}return r})())}return t}q(c,t){let r=!1;const d=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return c},append(u){d(),t.then(a=>a.append(u))},appendLine(u){d(),t.then(a=>a.appendLine(u))},clear(){d(),t.then(u=>u.clear())},replace(u){d(),t.then(a=>a.replace(u))},show(u,a){d(),t.then(h=>h.show(u,a))},hide(){d(),t.then(u=>u.hide())},dispose(){r=!0,t.then(u=>u.dispose())}}}r(c,t,r){const d=new f.$Rc,u=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},a=d.add(new l.$Sd);function h(S){t=S,a.fire(S)}return r.then(S=>{d.add(S),S.logLevel!==t&&h(S.logLevel),d.add(S.onDidChangeLogLevel(P=>h(P)))}),{...this.q(c,r),get logLevel(){return t},onDidChangeLogLevel:a.event,trace(S,...P){u(),r.then(w=>w.trace(S,...P))},debug(S,...P){u(),r.then(w=>w.debug(S,...P))},info(S,...P){u(),r.then(w=>w.info(S,...P))},warn(S,...P){u(),r.then(w=>w.warn(S,...P))},error(S,...P){u(),r.then(w=>w.error(S,...P))},dispose(){d.dispose()}}}};e.$Ugc=n,e.$Ugc=n=Ge([We(0,g.$UM),We(1,y.$$M),We(2,$.$Hfc),We(3,A.$hfc),We(4,R.$lj),We(5,R.$kj)],n),e.$Vgc=(0,N.$3h)("IExtHostOutputService")}),define(Se[153],ke([1,0,5,11]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=e.$Im=void 0,e.$Im=(0,D.$3h)("remoteAgentService"),e.$Jm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(g){let I=1/0;for(let b=0;b<this.maxSampleCount;b++){const $=await g.getRoundTripTime();if($===void 0)return;I=Math.min(I,$/2),await(0,N.$4g)(this.sampleDelay)}this.average.push(I),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(I):R=this.initial.reduce((b,$)=>b+$,0)/this.initial.length,this.lastMeasurement={initial:R,current:I,average:this.average.reduce((b,$)=>b+$,0)/this.average.length,high:(()=>typeof R>"u"?!1:I>this.highLatencyMaxThreshold||I>this.highLatencyMinThreshold&&I>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Se[355],ke([1,0,224,86,37,40,45,3,4,153,10,24]),function(me,e,D,N,g,I,R,b,$,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=void 0,e.$EH=Object.freeze({id:"application",order:100,title:(0,D.localize)(0,null),type:"object"}),e.$FH=Object.freeze({id:"workbench",order:7,title:(0,D.localize)(1,null),type:"object"}),e.$GH=Object.freeze({id:"security",scope:1,title:(0,D.localize)(2,null),type:"object",order:7}),e.$HH={ConfigurationMigration:"base.contributions.configuration.migration"};class m{constructor(){this.migrations=[],this.a=new $.$Sd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(s){this.migrations.push(...s)}}const v=new m;g.$vn.add(e.$HH.ConfigurationMigration,v);let k=class extends b.$Sc{constructor(s,i){super(),this.a=s,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async n=>{for(const o of n.added)await this.f(o,v.migrations)})),this.c(v.migrations),this.B(v.onDidRegisterConfigurationMigration(n=>this.c(n)))}async c(s){await this.f(void 0,s);for(const i of this.b.getWorkspace().folders)await this.f(i,s)}async f(s,i){await Promise.all([i.map(n=>this.g(n,s?.uri))])}async g(s,i){const n=this.a.inspect(s.key,{resource:i}),o=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[c,t]of o){const r=[];for(const u of n.overrideIdentifiers??[]){const a=await this.h(s,{resource:i,overrideIdentifier:u},c);for(const h of a??[]){let S=r.find(([[P,w]])=>P===h[0]&&(0,C.$nn)(w.value,h[1].value));S||r.push(S=[h,[]]),S[1].push(u)}}const d=await this.h(s,{resource:i},c,n);for(const u of d??[])r.push([u,[]]);r.length&&await Promise.allSettled(r.map(async([[u,a],h])=>this.a.updateValue(u,a.value,{resource:i,overrideIdentifiers:h},t)))}}async h(s,i,n,o){const c=u=>t(this.a.inspect(u,i)),t=u=>{const a=u[n];return i.overrideIdentifier?a?.override:a?.value},r=o?t(o):c(s.key);if(r===void 0)return;const d=await s.migrateFn(r,c);return Array.isArray(d)?d:[[s.key,d]]}};e.$IH=k,e.$IH=k=Ge([We(0,R.$wi),We(1,I.$_h)],k);let l=class extends b.$Sc{constructor(s){super(),(async()=>{if(!A.$i&&(await s.getEnvironment())?.os!==1)return;g.$vn.as(N.$An.Configuration).registerConfiguration({...e.$GH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,D.localize)(3,null)},default:[],markdownDescription:(0,D.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,D.localize)(5,null),scope:2}}})})()}};e.$JH=l,e.$JH=l=Ge([We(0,y.$Im)],l)}),define(Se[356],ke([1,0,34,17,16,23,233,355,86,5,37]),function(me,e,D,N,g,I,R,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8cb=e.$7cb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$6cb=e.$5cb=void 0,e.$5cb=(0,y.$3h)("editorResolverService"),e.$6cb="workbench.editorAssociations";const C=A.$vn.as($.$An.Configuration),m={...b.$FH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};C.registerConfiguration(m);var v;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(v||(e.RegisteredEditorPriority=v={}));var k;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(k||(e.ResolvedStatus=k={}));function l(s){switch(s){case v.exclusive:return 5;case v.default:return 4;case v.builtin:return 3;case v.option:default:return 1}}e.$7cb=l;function f(s,i){if(new Set([N.Schemas.extension,N.Schemas.webviewPanel,N.Schemas.vscodeWorkspaceTrust,N.Schemas.vscodeSettings]).has(i.scheme))return!1;const c=typeof s=="string"&&s.indexOf(g.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,I.$Bg)(i);return D.$Ij(typeof s=="string"?s.toLowerCase():s,c.toLowerCase())}e.$8cb=f}),define(Se[357],ke([1,0,33,17,16,10,23,2,5,268,40,144,153]),function(me,e,D,N,g,I,R,b,$,y,A,C,m){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$tK=e.$sK=void 0,e.$sK=(0,$.$3h)("pathService");let k=v=class{constructor(f,s,i,n){this.d=f,this.e=s,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||I.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??f})()}hasValidBasename(f,s,i){return typeof s=="string"||typeof s>"u"?this.a.then(n=>this.h(f,n,s)):this.h(f,s,i)}h(f,s,i){return f.scheme===N.Schemas.file||f.scheme===N.Schemas.vscodeRemote?(0,D.$3f)(i??(0,R.$Bg)(f),s===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(f,s){if(f.remoteAuthority)return N.Schemas.vscodeRemote;const i=(0,y.$pK)(s.getWorkspace());if(i)return i;const n=s.getWorkspace().folders[0];if(n)return n.uri.scheme;const o=s.getWorkspace().configuration;return o?o.scheme:N.Schemas.file}userHome(f){return f?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(f=>f===1?g.$fc:g.$gc)}async fileURI(f){let s="";if(await this.a===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const n=f.indexOf("/",2);n===-1?(s=f.substring(2),f="/"):(s=f.substring(2,n),f=f.substring(n)||"/")}return b.URI.from({scheme:N.Schemas.file,authority:s,path:f,query:"",fragment:""})}};e.$tK=k,e.$tK=k=v=Ge([We(1,m.$Im),We(2,C.$bK),We(3,A.$_h)],k)}),define(Se[358],ke([1,0,235,19,52,4,54,3,2,45,240,13,64,270,88,40,144,25,21,18,24,46]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l,f,s,i,n,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mK=e.$lK=e.$kK=e.OnPortForward=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.TunnelSource=e.TunnelCloseReason=e.$eK=e.$dK=e.$cK=void 0;const t=10*1e3,r="remote.tunnels.toRestore";e.$cK="onTunnel",e.$dK=new c.$hj("forwardedPortsViewEnabled",!1,D.localize(0,null));function d(T){const U=T.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(U)return{host:U[1]?.substring(0,U[1].length-1)||"localhost",port:Number(U[2])}}e.$eK=d;var u;(function(T){T.Other="Other",T.User="User",T.AutoForwardEnd="AutoForwardEnd"})(u||(e.TunnelCloseReason=u={}));var a;(function(T){T[T.User=0]="User",T[T.Auto=1]="Auto",T[T.Extension=2]="Extension"})(a||(e.TunnelSource=a={})),e.$fK={source:a.User,description:D.localize(1,null)},e.$gK={source:a.Auto,description:D.localize(2,null)};function h(T,U,F){const j=T.get(P(U,F));if(j)return j;if((0,k.$sv)(U))for(const O of k.$rv){const M=P(O,F);if(T.has(M))return T.get(M)}else if((0,k.$uv)(U))for(const O of k.$tv){const M=P(O,F);if(T.has(M))return T.get(M)}}e.$hK=h;function S(T,U,F){const j=h(T,U,F);if(j)return j;const O=(0,k.$uv)(U)?"localhost":(0,k.$sv)(U)?"0.0.0.0":void 0;if(O)return h(T,O,F)}e.$iK=S;function P(T,U){return T+":"+U}e.$jK=P;var w;(function(T){T.Notify="notify",T.OpenBrowser="openBrowser",T.OpenBrowserOnce="openBrowserOnce",T.OpenPreview="openPreview",T.Silent="silent",T.Ignore="ignore"})(w||(e.OnPortForward=w={}));function p(T){return T&&"host"in T&&typeof T.host=="string"&&"port"in T&&typeof T.port=="number"&&(!("detail"in T)||typeof T.detail=="string")&&(!("pid"in T)||typeof T.pid=="string")}e.$kK=p;class E extends b.$Sc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(U){super(),this.r=U,this.j=[],this.n=new I.$Sd,this.onDidChangeAttributes=this.n.event,this.B(U.onDidChangeConfiguration(F=>{(F.affectsConfiguration(E.c)||F.affectsConfiguration(E.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(U,F,j){let O=this.w(U,F,j,this.j,0);const M={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;O>=0;){const W=this.j[O];W.key===U?(M.onAutoForward=W.onAutoForward??M.onAutoForward,M.elevateIfNeeded=W.elevateIfNeeded!==void 0?W.elevateIfNeeded:M.elevateIfNeeded,M.label=W.label??M.label,M.requireLocalPort=W.requireLocalPort,M.protocol=W.protocol):(M.onAutoForward=M.onAutoForward??W.onAutoForward,M.elevateIfNeeded=M.elevateIfNeeded!==void 0?M.elevateIfNeeded:W.elevateIfNeeded,M.label=M.label??W.label,M.requireLocalPort=M.requireLocalPort!==void 0?M.requireLocalPort:void 0,M.protocol=M.protocol??W.protocol),O=this.w(U,F,j,this.j,O+1)}return M.onAutoForward!==void 0||M.elevateIfNeeded!==void 0||M.label!==void 0||M.requireLocalPort!==void 0||M.protocol!==void 0?M:this.C()}t(U){return U.start!==void 0&&U.end!==void 0}u(U){return U.host!==void 0&&U.port!==void 0&&(0,n.$Ff)(U.host)&&(0,n.$Jf)(U.port)}w(U,F,j,O,M){if(M>=O.length)return-1;const W=!(0,k.$sv)(F)&&!(0,k.$uv)(F),ue=O.slice(M).findIndex(X=>(0,n.$Jf)(X.key)?W?!1:X.key===U:this.t(X.key)?W?!1:U>=X.key.start&&U<=X.key.end:this.u(X.key)?U===X.key.port&&F===X.key.host:j?X.key.test(j):!1);return ue>=0?ue+M:-1}y(){const U=this.r.getValue(E.c);if(!U||!(0,n.$Hf)(U))return[];const F=[];for(const O in U){if(O===void 0)continue;const M=U[O];let W;if(Number(O))W=Number(O);else if((0,n.$Ff)(O))if(E.g.test(O)){const Y=O.match(E.g);W={start:Number(Y[1]),end:Number(Y[2])}}else if(E.h.test(O)){const Y=O.match(E.h);W={host:Y[1],port:Number(Y[2])}}else{let Y;try{Y=RegExp(O)}catch{}Y&&(W=Y)}W&&F.push({key:W,elevateIfNeeded:M.elevateIfNeeded,onAutoForward:M.onAutoForward,label:M.label,requireLocalPort:M.requireLocalPort,protocol:M.protocol})}const j=this.r.getValue(E.f);return j&&(this.m={elevateIfNeeded:j.elevateIfNeeded,label:j.label,onAutoForward:j.onAutoForward,requireLocalPort:j.requireLocalPort,protocol:j.protocol}),this.z(F)}z(U){function F(j,O){return(0,n.$Jf)(j.key)?j.key:O.t(j.key)?j.key.start:O.u(j.key)?j.key.port:Number.MAX_VALUE}return U.sort((j,O)=>F(j,this)-F(O,this))}C(){return this.m}static providedActionToAction(U){switch(U){case k.ProvidedOnAutoForward.Notify:return w.Notify;case k.ProvidedOnAutoForward.OpenBrowser:return w.OpenBrowser;case k.ProvidedOnAutoForward.OpenBrowserOnce:return w.OpenBrowserOnce;case k.ProvidedOnAutoForward.OpenPreview:return w.OpenPreview;case k.ProvidedOnAutoForward.Silent:return w.Silent;case k.ProvidedOnAutoForward.Ignore:return w.Ignore;default:return}}async addAttributes(U,F,j){const M=this.r.inspect(E.c).userRemoteValue;let W;!M||!(0,n.$Hf)(M)?W={}:W=(0,o.$jn)(M),W[`${U}`]||(W[`${U}`]={});for(const Y in F)W[`${U}`][Y]=F[Y];return this.r.updateValue(E.c,W,j)}}e.$lK=E;let L=class extends b.$Sc{constructor(U,F,j,O,M,W,Y,ue,X,J){super(),this.H=U,this.I=F,this.J=j,this.L=O,this.M=M,this.N=W,this.O=Y,this.P=ue,this.Q=X,this.R=J,this.c=new Map,this.g=new I.$Sd,this.onForwardPort=this.g.event,this.h=new I.$Sd,this.onClosePort=this.h.event,this.j=new I.$Sd,this.onPortName=this.j.event,this.n=new I.$Sd,this.onCandidatesChanged=this.n.event,this.t=new I.$Sd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new I.$Sd,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new E(j),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async x=>{const he=await this.getAttributes(x.map(Z=>({port:Z.tunnelRemotePort,host:Z.tunnelRemoteHost})));for(const Z of x)if(Z.localAddress){const we=P(Z.tunnelRemoteHost,Z.tunnelRemotePort),ce=S(this.m??new Map,Z.tunnelRemoteHost,Z.tunnelRemotePort);this.forwarded.set(we,{remotePort:Z.tunnelRemotePort,remoteHost:Z.tunnelRemoteHost,localAddress:Z.localAddress,protocol:he?.get(Z.tunnelRemotePort)?.protocol??k.TunnelProtocol.Http,localUri:await this.X(Z.localAddress,he?.get(Z.tunnelRemotePort)),localPort:Z.tunnelLocalPort,runningProcess:ce?.detail,hasRunningProcess:!!ce,pid:ce?.pid,privacy:Z.privacy,source:e.$fK}),this.f.set(we,Z)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async x=>{const he=P(x.tunnelRemoteHost,x.tunnelRemotePort);if(!S(this.forwarded,x.tunnelRemoteHost,x.tunnelRemotePort)&&!S(this.detected,x.tunnelRemoteHost,x.tunnelRemotePort)&&!S(this.c,x.tunnelRemoteHost,x.tunnelRemotePort)&&x.localAddress){const Z=S(this.m??new Map,x.tunnelRemoteHost,x.tunnelRemotePort),we=(await this.getAttributes([{port:x.tunnelRemotePort,host:x.tunnelRemoteHost}]))?.get(x.tunnelRemotePort);this.forwarded.set(he,{remoteHost:x.tunnelRemoteHost,remotePort:x.tunnelRemotePort,localAddress:x.localAddress,protocol:we?.protocol??k.TunnelProtocol.Http,localUri:await this.X(x.localAddress,we),localPort:x.tunnelLocalPort,closeable:!0,runningProcess:Z?.detail,hasRunningProcess:!!Z,pid:Z?.pid,privacy:x.privacy,source:e.$fK})}await this.$(),this.f.set(he,x),this.g.fire(this.forwarded.get(he))})),this.B(this.H.onTunnelClosed(x=>this.W(x,u.Other))),this.U()}S(){return this.Q.extensions.find(U=>U.activationEvents?.includes(e.$cK))?(this.R.createKey(e.$dK.key,!0),!0):!1}U(){if(this.S())return;const U=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&U.dispose()}))}async W(U,F){const j=P(U.host,U.port);this.forwarded.has(j)&&(this.forwarded.delete(j),await this.$(),this.h.fire(U))}X(U,F){if(U.startsWith("http"))return $.URI.parse(U);const j=F?.protocol??"http";return $.URI.parse(`${j}://${U}`)}async Y(){const U=this.N.getWorkspace(),F=U.configuration?(0,R.$Qi)(U.configuration.path):U.folders.length>0?(0,R.$Qi)(U.folders[0].uri.path):void 0;if(F===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${r}.${this.L.remoteAuthority}.${F}`}async Z(){const U=this.I.get(r,1);if(U)return this.I.remove(r,1),await this.$(),U;const F=await this.Y();if(F)return this.I.get(F,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const U=await this.s;if(U&&U!==this.y){const F=JSON.parse(U)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${F.map(j=>j.remotePort).join(", ")}`);for(const j of F){const O=S(this.detected,j.remoteHost,j.remotePort);j.source.source!==a.Extension&&!O||j.source.source===a.Extension&&O?await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,privacy:j.privacy,elevateIfNeeded:!0,source:j.source}):j.source.source===a.Extension&&!O&&this.D.set(P(j.remoteHost,j.remotePort),j)}}}if(this.z=!0,this.C.fire(),!this.w){const U=await this.Y();this.w=this.B(new b.$Rc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async F=>{F.key===U&&(this.s=Promise.resolve(this.I.get(U,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const U=JSON.stringify(Array.from(this.forwarded.values()));if(U!==this.y){this.y=U;const F=await this.Y();F&&this.I.store(F,this.y,0,0)}}}async bb(U,F,j){if(!U.tunnelLocalPort||!j?.requireLocalPort||U.tunnelLocalPort===F)return;const O=new Date;if(this.ab.getTime()+t>O.getTime())return;this.ab=O;const M=D.localize(3,null,F,U.tunnelRemotePort,U.tunnelLocalPort);return this.P.info(M)}async forward(U,F){return!this.z&&this.L.remoteAuthority&&await I.Event.toPromise(this.C.event),this.cb(U,F)}async cb(U,F){await this.Q.activateByEvent(e.$cK);const j=S(this.forwarded,U.remote.host,U.remote.port);F=F??(F!==null?(await this.getAttributes([U.remote]))?.get(U.remote.port):void 0);const O=U.local!==void 0?U.local:U.remote.port;let M;if(j)return this.eb(j,U,F);{const W=this.L.remoteAuthority,Y=W?{getAddress:async()=>(await this.M.resolveAuthority(W)).authority}:void 0,ue=P(U.remote.host,U.remote.port);this.c.set(ue,!0),U=this.db(ue,U);const X=await this.H.openTunnel(Y,U.remote.host,U.remote.port,void 0,O,U.elevateIfNeeded?U.elevateIfNeeded:F?.elevateIfNeeded,U.privacy,F?.protocol);if(typeof X=="string")M=X;else if(X&&X.localAddress){const J=S(this.m??new Map,U.remote.host,U.remote.port),x=X.protocol?X.protocol===k.TunnelProtocol.Https?k.TunnelProtocol.Https:k.TunnelProtocol.Http:F?.protocol??k.TunnelProtocol.Http,he={remoteHost:X.tunnelRemoteHost,remotePort:X.tunnelRemotePort,localPort:X.tunnelLocalPort,name:F?.label??U.name,closeable:!0,localAddress:X.localAddress,protocol:x,localUri:await this.X(X.localAddress,F),runningProcess:J?.detail,hasRunningProcess:!!J,pid:J?.pid,source:U.source??e.$fK,privacy:X.privacy};return this.forwarded.set(ue,he),this.f.set(ue,X),this.c.delete(ue),await this.$(),await this.bb(X,O,F),this.g.fire(he),X}this.c.delete(ue)}return M}db(U,F){const j=this.D.has(U)?this.D:this.F.has(U)?this.F:void 0;if(j){const O=j.get(U);j.delete(U),O&&(F.name=O.name??F.name,F.local=("local"in O?O.local:"localPort"in O?O.localPort:void 0)??F.local,F.privacy=O.privacy??F.privacy)}return F}async eb(U,F,j){const O=j?.label??F.name;let M;(function(Y){Y[Y.None=0]="None",Y[Y.Fire=1]="Fire",Y[Y.Reopen=2]="Reopen"})(M||(M={}));let W=M.None;switch(O!==U.name&&(U.name=O,W=M.Fire),(j?.protocol||U.protocol!==k.TunnelProtocol.Http)&&j?.protocol!==U.protocol&&(F.source=U.source,W=M.Reopen),F.privacy&&U.privacy!==F.privacy&&(W=M.Reopen),W){case M.Fire:{this.g.fire();break}case M.Reopen:await this.close(U.remoteHost,U.remotePort,u.User),await this.cb(F,j)}return S(this.f,F.remote.host,F.remote.port)}async name(U,F,j){const O=S(this.forwarded,U,F),M=P(U,F);if(O){O.name=j,await this.$(),this.j.fire({host:U,port:F});return}else this.detected.has(M)&&(this.detected.get(M).name=j,this.j.fire({host:U,port:F}))}async close(U,F,j){const O=P(U,F),M=this.forwarded.get(O);return j===u.AutoForwardEnd&&M&&M.source.source===a.Auto&&this.F.set(O,{local:M.localPort,name:M.name,privacy:M.privacy}),await this.H.closeTunnel(U,F),this.W({host:U,port:F},j)}address(U,F){const j=P(U,F);return(this.forwarded.get(j)||this.detected.get(j))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(U){if(U)for(const F of U){const j=S(this.m??new Map,F.remoteAddress.host,F.remoteAddress.port),O=typeof F.localAddress=="string"?F.localAddress:P(F.localAddress.host,F.localAddress.port);this.detected.set(P(F.remoteAddress.host,F.remoteAddress.port),{remoteHost:F.remoteAddress.host,remotePort:F.remoteAddress.port,localAddress:O,protocol:k.TunnelProtocol.Http,localUri:this.X(O),closeable:!1,runningProcess:j?.detail,hasRunningProcess:!!j,pid:j?.pid,privacy:k.TunnelPrivacyId.ConstantPrivate,source:{source:a.Extension,description:D.localize(4,null)}}),this.H.setEnvironmentTunnel(F.remoteAddress.host,F.remoteAddress.port,O,k.TunnelPrivacyId.ConstantPrivate,k.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(U){this.r=U}async setCandidates(U){let F=U;this.r&&(F=await this.r(U));const j=this.fb(F);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(j.values()).map(O=>O.port).join(", ")}`),this.n.fire(j)}fb(U){const F=this.m??new Map,j=new Map;return this.m=j,U.forEach(O=>{const M=P(O.host,O.port);j.set(M,{host:O.host,port:O.port,detail:O.detail,pid:O.pid}),F.has(M)&&F.delete(M);const W=S(this.forwarded,O.host,O.port);W&&(W.runningProcess=O.detail,W.hasRunningProcess=!0,W.pid=O.pid)}),F.forEach((O,M)=>{const W=d(M);if(!W)return;const Y=S(this.forwarded,W.host,W.port);Y&&(Y.runningProcess=void 0,Y.hasRunningProcess=!1,Y.pid=void 0);const ue=S(this.detected,W.host,W.port);ue&&(ue.runningProcess=void 0,ue.hasRunningProcess=!1,ue.pid=void 0)}),F}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const U=Array.from(this.forwarded.values()),F=await this.getAttributes(U.map(j=>({port:j.remotePort,host:j.remoteHost})),!1);if(F)for(const j of U){const O=F.get(j.remotePort);(O?.protocol||j.protocol!==k.TunnelProtocol.Http)&&O?.protocol!==j.protocol&&await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,source:j.source},O),O&&O.label&&O.label!==j.name&&await this.name(j.remoteHost,j.remotePort,O.label)}}async getAttributes(U,F=!0){const j=new Map,O=new Map;U.forEach(X=>{const J=S(this.m??new Map,k.$rv[0],X.port)??X;if(J){j.set(X.port,J);const x=p(J)?J.pid:void 0;O.has(x)||O.set(x,[]),O.get(x)?.push(X.port)}});const M=new Map;if(U.forEach(X=>{const J=this.configPortsAttributes.getAttributes(X.port,X.host,j.get(X.port)?.detail);J&&M.set(X.port,J)}),this.G.length===0||!F)return M.size>0?M:void 0;const W=await Promise.all((0,N.$Rb)(this.G.map(X=>Array.from(O.entries()).map(J=>{const x=J[1],he=j.get(x[0]);return X.providePortAttributes(x,he?.pid,he?.detail,new i.$3d().token)})))),Y=new Map;if(W.forEach(X=>X.forEach(J=>{J&&Y.set(J.port,J)})),!M&&!Y)return;const ue=new Map;return U.forEach(X=>{const J=M.get(X.port),x=Y.get(X.port);ue.set(X.port,{elevateIfNeeded:J?.elevateIfNeeded,label:J?.label,onAutoForward:J?.onAutoForward??E.providedActionToAction(x?.autoForwardAction),requireLocalPort:J?.requireLocalPort,protocol:J?.protocol})}),ue}addAttributesProvider(U){this.G.push(U)}};e.$mK=L,Ge([(0,g.$vh)(1e3)],L.prototype,"$",null),e.$mK=L=Ge([We(0,k.$nv),We(1,v.$ip),We(2,y.$wi),We(3,f.$bK),We(4,m.$5k),We(5,l.$_h),We(6,C.$kj),We(7,A.$Sv),We(8,s.$lF),We(9,c.$ij)],L)}),define(Se[94],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$8I=e.$7I=void 0;class D{constructor(R,b){this.line=R,this.character=b}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,b){return new D(0,0)}with(R){return new D(0,0)}}e.$7I=D;class N{constructor(R,b,$,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new D(R,b),this.end=new D($,y)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new N(0,0,0,0)}with(R){return new N(0,0,0,0)}}e.$8I=N;var g;(function(I){I[I.Information=1]="Information",I[I.Warning=2]="Warning"})(g||(e.TextSearchCompleteMessageType=g={}))}),define(Se[36],ke([1,0,19,34,24,33,12,5,16,14,94,11]),function(me,e,D,N,g,I,R,b,$,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.SearchErrorCode=e.$kJ=e.$jJ=e.SearchSortOrder=e.ViewMode=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.SearchCompletionExitCode=e.$eJ=e.$dJ=e.$cJ=e.QueryType=e.SearchProviderType=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$9I="workbench.view.search",e.$0I="workbench.panel.search",e.$$I="workbench.view.search",e.$_I="search-result",e.$aJ="search.exclude";const m="\u27EA ",v=" characters skipped \u27EB",k=(m.length+v.length+5)*2;e.$bJ=(0,b.$3h)("searchService");var l;(function(x){x[x.file=0]="file",x[x.text=1]="text"})(l||(e.SearchProviderType=l={}));var f;(function(x){x[x.File=1]="File",x[x.Text=2]="Text"})(f||(e.QueryType=f={}));function s(x){return!!x.preview}e.$cJ=s;function i(x){return!!x.resource}e.$dJ=i;function n(x){return!!x.message}e.$eJ=n;var o;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class c{constructor(he){this.resource=he,this.results=[]}}e.$fJ=c;class t{constructor(he,Z,we,ce){this.ranges=Z,this.webviewIndex=ce;const K=Array.isArray(Z)?Z:[Z];if(we&&we.matchLines===1&&r(K)){he=(0,R.$yf)(he,we.matchLines);let B="",re=0,ye=0;const de=Math.floor(we.charsPerLine/5),ge=[];for(const _ of K){const ie=Math.max(_.startColumn-de,0),G=_.startColumn+we.charsPerLine;if(ie>ye+de+k){const te=m+(ie-ye)+v;B+=te+he.slice(ie,G),re+=ie-(ye+te.length)}else B+=he.slice(ye,G);ge.push(new u(0,_.startColumn-re,_.endColumn-re)),ye=G}this.preview={text:B,matches:Array.isArray(this.ranges)?ge:ge[0]}}else{const B=Array.isArray(Z)?Z[0].startLineNumber:Z.startLineNumber;this.preview={text:he,matches:(0,D.$2b)(Z,re=>new d(re.startLineNumber-B,re.startColumn,re.endLineNumber-B,re.endColumn))}}}}e.$gJ=t;function r(x){const he=x[0].startLineNumber;for(const Z of x)if(Z.startLineNumber!==he||Z.endLineNumber!==he)return!1;return!0}class d{constructor(he,Z,we,ce){this.startLineNumber=he,this.startColumn=Z,this.endLineNumber=we,this.endColumn=ce}}e.$hJ=d;class u extends d{constructor(he,Z,we){super(he,Z,he,we)}}e.$iJ=u;var a;(function(x){x.List="list",x.Tree="tree"})(a||(e.ViewMode=a={}));var h;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function S(x,he=!0){const Z=x&&x.files&&x.files.exclude,we=he&&x&&x.search&&x.search.exclude;if(!Z&&!we)return;if(!Z||!we)return Z||we;let ce=Object.create(null);return ce=g.$mn(ce,g.$jn(Z)),ce=g.$mn(ce,g.$jn(we),!0),ce}e.$jJ=S;function P(x,he){return x.excludePattern&&N.$Ij(x.excludePattern,he)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&N.$Ij(x.includePattern,he)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(Z=>{const we=Z.folder.fsPath;if(I.$5f(he,we)){const ce=$.$lc(we,he);return!Z.includePattern||!!N.$Ij(Z.includePattern,ce)}else return!1}):!1:!0}e.$kJ=P;var w;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(w||(e.SearchErrorCode=w={}));class p extends Error{constructor(he,Z){super(he),this.code=Z}}e.$lJ=p;function E(x){const he=x.message;if((0,y.$4)(x))return new p(he,w.canceled);try{const Z=JSON.parse(he);return new p(Z.message,Z.code)}catch{return new p(he,w.other)}}e.$mJ=E;function L(x){const he={message:x.message,code:x.code};return new Error(JSON.stringify(he))}e.$nJ=L;function T(x){return x.type==="error"?!0:x.type==="success"}e.$oJ=T;function U(x){return x.type==="success"}e.$pJ=U;function F(x){return!!x.path}e.$qJ=F;function j(x,he){const Z=x.searchPath?x.searchPath:x.relativePath;return(0,R.$vf)(Z,he)}e.$rJ=j;class O{constructor(he){this.path=he,this.results=[]}addMatch(he){this.results.push(he)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$sJ=O;function M(x,he){const Z={...x||{},...he||{}};return Object.keys(Z).filter(we=>{const ce=Z[we];return typeof ce=="boolean"&&ce})}e.$tJ=M;class W{constructor(he,Z){this.c=null,this.a={...he.excludePattern||{},...Z.excludePattern||{}},this.b=N.$Jj(this.a);let we=he.includePattern;Z.includePattern&&(we?we={...we,...Z.includePattern}:we=Z.includePattern),we&&(this.c=N.$Jj(we))}matchesExcludesSync(he,Z,we){return!!(this.b&&this.b(he,Z,we))}includedInQuerySync(he,Z,we){return!(this.b&&this.b(he,Z,we)||this.c&&!this.c(he,Z,we))}includedInQuery(he,Z,we){const ce=this.b(he,Z,we),K=()=>this.c?!!this.c(he,Z,we):!0;return(0,C.$Pg)(ce)?ce.then(B=>B?!1:K()):K()}hasSiblingExcludeClauses(){return Y(this.a)}}e.$uJ=W;function Y(x){for(const he in x)if(typeof x[he]!="boolean")return!0;return!1}function ue(x){if(!x)return;let he;return Z=>(he||(he=(x()||Promise.resolve([])).then(we=>we?J(we):{})),he.then(we=>!!we[Z]))}e.$vJ=ue;function X(x){if(!x)return;let he;return Z=>{if(!he){const we=x();he=we?J(we):{}}return!!he[Z]}}e.$wJ=X;function J(x){const he={};for(const Z of x)he[Z]=!0;return he}}),define(Se[41],ke([1,0,19,11,21,4,3,77,17,122,23,12,2,222,5,13,253,40,58,27,20,15,7,66,36,6,55]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l,f,s,i,n,o,c,t,r,d,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cfc=e.$Bfc=void 0;function h(U,F,j){return new A.$tg(O=>p(O,j)).isEqual(U,F)}function S(U,F,j){return h(U.uri,F.uri,j)?0:(0,C.$2e)(U.uri.toString(),F.uri.toString())}function P(U,F,j){return U.index!==F.index?U.index<F.index?-1:1:h(U.uri,F.uri,j)?(0,C.$2e)(U.name,F.name):(0,C.$2e)(U.uri.toString(),F.uri.toString())}function w(U,F,j,O){const M=U.slice(0).sort((Y,ue)=>j(Y,ue,O)),W=F.slice(0).sort((Y,ue)=>j(Y,ue,O));return(0,D.$Eb)(M,W,(Y,ue)=>j(Y,ue,O))}function p(U,F){const j=F.getCapabilities(U.scheme);return!(j&&j&1024)}class E extends s.$ji{static toExtHostWorkspace(F,j,O,M){if(!F)return{workspace:null,added:[],removed:[]};const{id:W,name:Y,folders:ue,configuration:X,transient:J,isUntitled:x}=F,he=[],Z=j;j?ue.forEach((B,re)=>{const ye=m.URI.revive(B.uri),de=E.o(O||j,ye,M);de?(de.name=B.name,de.index=B.index,he.push(de)):he.push({uri:ye,name:B.name,index:re})}):he.push(...ue.map(({uri:B,name:re,index:ye})=>({uri:m.URI.revive(B),name:re,index:ye}))),he.sort((B,re)=>B.index<re.index?-1:1);const we=new E(W,Y,he,!!J,X?m.URI.revive(X):null,!!x,B=>p(B,M)),{added:ce,removed:K}=w(Z?Z.workspaceFolders:[],we.workspaceFolders,S,M);return{workspace:we,added:ce,removed:K}}static o(F,j,O){for(let M=0;M<F.folders.length;M++){const W=F.workspaceFolders[M];if(h(W.uri,j,O))return W}}constructor(F,j,O,M,W,Y,ue){super(F,O.map(X=>new s.$ki(X)),M,W,ue),this.t=j,this.u=Y,this.q=[],this.s=b.$9h.forUris(ue),O.forEach(X=>{this.q.push(X),this.s.set(X.uri,X)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(F,j){return j&&this.s.get(F)&&(F=(0,A.$Dg)(F)),this.s.findSubstr(F)}resolveWorkspaceFolder(F){return this.s.get(F)}}let L=class{constructor(F,j,O,M,W){this.c=new I.$Sd,this.onDidChangeWorkspace=this.c.event,this.g=new I.$Sd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new I.$Ud,this.B=new Map,this.h=M,this.s=O,this.t=W,this.j=new y.$6l,this.k=new N.$2g,this.o=F.getProxy(u.$QK.MainThreadWorkspace),this.q=F.getProxy(u.$QK.MainThreadMessageService);const Y=j.workspace;this.l=Y?new E(Y.id,Y.name,[],!!Y.transient,Y.configuration?m.URI.revive(Y.configuration):null,!!Y.isUntitled,ue=>p(ue,O)):void 0}$initializeWorkspace(F,j){this.v=j,this.$acceptWorkspaceData(F),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?m.URI.from({scheme:$.Schemas.untitled,path:(0,A.$Bg)((0,A.$Dg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(F,j,O,...M){const W=[];if(Array.isArray(M)&&M.forEach(x=>{m.URI.isUri(x.uri)&&!W.some(he=>h(he.uri,x.uri,this.s))&&W.push({uri:x.uri,name:x.name||(0,A.$Ag)(x.uri)})}),this.n||[j,O].some(x=>typeof x!="number"||x<0)||O===0&&W.length===0)return!1;const Y=this.x?this.x.workspaceFolders:[];if(j+O>Y.length)return!1;const ue=Y.slice(0);ue.splice(j,O,...W.map(x=>({uri:x.uri,name:x.name||(0,A.$Ag)(x.uri),index:void 0})));for(let x=0;x<ue.length;x++){const he=ue[x];if(ue.some((Z,we)=>we!==x&&h(he.uri,Z.uri,this.s)))return!1}ue.forEach((x,he)=>x.index=he);const{added:X,removed:J}=w(Y,ue,P,this.s);if(X.length===0&&J.length===0)return!1;if(this.o){const x=F.displayName||F.name;this.o.$updateWorkspaceFolders(x,j,O,W).then(void 0,he=>{this.n=void 0;const Z={source:{identifier:F.identifier,label:F.displayName||F.name}};this.q.$showMessage(f.Severity.Error,(0,v.localize)(0,null,x,he.toString()),Z,[])})}return this.y(ue),!0}getWorkspaceFolder(F,j){if(this.x)return this.x.getWorkspaceFolder(F,j)}async getWorkspaceFolder2(F,j){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(F,j)}async resolveWorkspaceFolder(F){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(F)}getPath(){if(!this.x)return;const{folders:F}=this.x;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,j){let O,M="";if(typeof F=="string"?(O=m.URI.file(F),M=F):typeof F<"u"&&(O=F,M=F.fsPath),!O)return M;const W=this.getWorkspaceFolder(O,!0);if(!W)return M;typeof j>"u"&&this.x&&(j=this.x.folders.length>1);let Y=(0,A.$Gg)(W.uri,O);return j&&W.name&&(Y=`${W.name}/${Y}`),Y}y(F){this.x&&(this.n=E.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:F,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:j,added:O,removed:M}=E.toExtHostWorkspace(F,this.l,this.n,this.s);this.l=j||void 0,this.n=void 0,this.c.fire(Object.freeze({added:O,removed:M}))}findFiles(F,j,O,M,W=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${M.value}, entryPoint: findFiles`);let Y;if(j===null?Y=!1:j&&(typeof j=="string"?Y=j:Y=j.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:ue,folder:X}=T(c.GlobPattern.from(F));return this.o.$startFileSearch(ue??null,X??null,Y??null,O??null,W).then(J=>Array.isArray(J)?J.map(x=>m.URI.revive(x)):[])}async findTextInFiles(F,j,O,M,W=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${M.value}, entryPoint: findTextInFiles`);const Y=this.j.getNext(),ue=typeof j.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:j.previewOptions,{includePattern:X,folder:J}=T(c.GlobPattern.from(j.include)),x=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,he={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!0,fileEncoding:j.encoding,maxResults:j.maxResults,previewOptions:ue,afterContext:j.afterContext,beforeContext:j.beforeContext,includePattern:X,excludePattern:x},Z=!1;if(this.u[Y]=we=>{if(Z)return;const ce=m.URI.revive(we.resource);we.results.forEach(K=>{const B=(0,a.$zh)(K);(0,d.$cJ)(B)?O({uri:ce,preview:{text:B.preview.text,matches:(0,D.$2b)(B.preview.matches,re=>new t.$UK(re.startLineNumber,re.startColumn,re.endLineNumber,re.endColumn))},ranges:(0,D.$2b)(B.ranges,re=>new t.$UK(re.startLineNumber,re.startColumn,re.endLineNumber,re.endColumn))}):O({uri:ce,text:B.text,lineNumber:B.lineNumber})})},W.isCancellationRequested)return{};try{const we=await this.o.$startTextSearch(F,J??null,he,Y,W);return delete this.u[Y],we||{}}catch(we){throw delete this.u[Y],we}}$handleTextSearchResult(F,j){this.u[j]?.(F)}async save(F){const j=await this.o.$save(F,{saveAs:!1});return m.URI.revive(j)}async saveAs(F){const j=await this.o.$save(F,{saveAs:!0});return m.URI.revive(j)}saveAll(F){return this.o.$saveAll(F)}resolveProxy(F){return this.o.$resolveProxy(F)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(F){return this.o.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(F,j){if(this.w.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.w.set(F,j);const O=this.t.transformOutgoingScheme(F),M=this.z++;return this.o.$registerEditSessionIdentityProvider(M,O),(0,R.$Qc)(()=>{this.w.delete(F),this.o.$unregisterEditSessionIdentityProvider(M)})}async $getEditSessionIdentifier(F,j){this.h.info("Getting edit session identifier for workspaceFolder",F);const O=await this.resolveWorkspaceFolder(m.URI.revive(F));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const M=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!M),!M)return;const W=await M.provideEditSessionIdentity(O,j);if(this.h.info("Provider returned edit session identifier: ",W),!!W)return W}async $provideEditSessionIdentityMatch(F,j,O,M){this.h.info("Getting edit session identifier for workspaceFolder",F);const W=await this.resolveWorkspaceFolder(m.URI.revive(F));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const Y=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!Y),!Y)return;const ue=await Y.provideEditSessionIdentityMatch?.(j,O,M);if(this.h.info("Provider returned edit session identifier match result: ",ue),!!ue)return ue}getOnWillCreateEditSessionIdentityEvent(F){return(j,O,M)=>{const W=function(ue){j.call(O,ue)};return W.extension=F,this.A.event(W,void 0,M)}}async $onWillCreateEditSessionIdentity(F,j,O){const M=await this.resolveWorkspaceFolder(m.URI.revive(F));if(M===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:M},j,async(W,Y)=>{const ue=Date.now();await Promise.resolve(W),Date.now()-ue>O&&this.h.warn("SLOW edit session create-participant",Y.extension.identifier)}),j.isCancellationRequested}registerCanonicalUriProvider(F,j){if(this.B.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.B.set(F,j);const O=this.t.transformOutgoingScheme(F),M=this.z++;return this.o.$registerCanonicalUriProvider(M,O),(0,R.$Qc)(()=>{this.B.delete(F),this.o.$unregisterCanonicalUriProvider(M)})}async provideCanonicalUri(F,j,O){const M=this.B.get(F.scheme);if(!M)return;const W=await M.provideCanonicalUri?.(m.URI.revive(F),j,O);if(W)return W}async $provideCanonicalUri(F,j,O){return this.provideCanonicalUri(m.URI.revive(F),{targetScheme:j},O)}};e.$Bfc=L,e.$Bfc=L=Ge([We(0,o.$UM),We(1,n.$$M),We(2,i.$hfc),We(3,l.$kj),We(4,r.$zfc)],L),e.$Cfc=(0,k.$3h)("IExtHostWorkspace");function T(U){let F,j;return U&&(typeof U=="string"?F=U:(F=U.pattern,j=m.URI.revive(U.baseUri))),{includePattern:F,folder:j}}}),define(Se[42],ke([1,0,24,4,41,6,7,255,86,18,11,5,20,13,2]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=e.$Efc=e.$Dfc=void 0;function l(r,d){if(d){const u=d.split(".");let a=r;for(let h=0;a&&h<u.length;h++)a=a[u[h]];return a}}function f(r){return r instanceof k.URI}function s(r){return r&&r.uri instanceof k.URI&&r.languageId&&typeof r.languageId=="string"}function i(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function n(r){return r&&r.uri instanceof k.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function o(r){if(f(r))return{resource:r};if(s(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(i(r))return{overrideIdentifier:r.languageId};if(n(r))return{resource:r.uri};if(r===null)return{resource:null}}let c=class{constructor(d,u,a){this.a=d.getProxy(I.$QK.MainThreadConfiguration),this.c=u,this.b=a,this.d=new A.$2g,this.e=null}getConfigProvider(){return this.d.wait().then(d=>this.e)}$initializeConfiguration(d){this.e=new t(this.a,this.c,d,this.b),this.d.open()}$acceptConfigurationChanged(d,u){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(d,u))}};e.$Dfc=c,e.$Dfc=c=Ge([We(0,m.$UM),We(1,g.$Cfc),We(2,v.$kj)],c);class t{constructor(d,u,a,h){this.a=new N.$Sd,this.b=d,this.f=h,this.c=u,this.e=b.$Tn.parse(a),this.d=this.k(a.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(d,u){const a={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$Tn.parse(d),this.d=this.k(d.configurationScopes),this.a.fire(this.j(u,a))}getConfiguration(d,u,a){const h=o(u)||{},S=this.g(d?l(this.e.getValue(void 0,h,this.c.workspace),d):this.e.getValue(void 0,h,this.c.workspace));d&&this.h(d,h,a?.identifier);function P(p){if(p==null)return null;if(typeof p=="boolean")return p?2:5;switch(p){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const w={has(p){return typeof l(S,p)<"u"},get:(p,E)=>{this.h(d?`${d}.${p}`:p,h,a?.identifier);let L=l(S,p);if(typeof L>"u")L=E;else{let T;const U=(F,j)=>{if((0,y.$Hf)(F)){let O;const M=()=>{T=T||(0,D.$jn)(S),O=O||l(T,j)};return new Proxy(F,{get:(W,Y)=>{if(typeof Y=="string"&&Y.toLowerCase()==="tojson")return M(),()=>O;if(T)return O=O||l(T,j),O[Y];const ue=W[Y];return typeof Y=="string"?U(ue,`${j}.${Y}`):ue},set:(W,Y,ue)=>(M(),O&&(O[Y]=ue),!0),deleteProperty:(W,Y)=>(M(),O&&delete O[Y],!0),defineProperty:(W,Y,ue)=>(M(),O&&Object.defineProperty(O,Y,ue),!0)})}return Array.isArray(F)?(0,D.$jn)(F):F};L=U(L,p)}return L},update:(p,E,L,T)=>{p=d?`${d}.${p}`:p;const U=P(L);return E!==void 0?this.b.$updateConfigurationOption(U,p,E,h,T):this.b.$removeConfigurationOption(U,p,h,T)},inspect:p=>{p=d?`${d}.${p}`:p;const E=this.e.inspect(p,h,this.c.workspace);if(E)return{key:p,defaultValue:(0,D.$jn)(E.policy?.value??E.default?.value),globalValue:(0,D.$jn)(E.user?.value??E.application?.value),workspaceValue:(0,D.$jn)(E.workspace?.value),workspaceFolderValue:(0,D.$jn)(E.workspaceFolder?.value),defaultLanguageValue:(0,D.$jn)(E.default?.override),globalLanguageValue:(0,D.$jn)(E.user?.override??E.application?.override),workspaceLanguageValue:(0,D.$jn)(E.workspace?.override),workspaceFolderLanguageValue:(0,D.$jn)(E.workspaceFolder?.override),languageIds:(0,D.$jn)(E.overrideIdentifiers)}}};return typeof S=="object"&&(0,D.$mn)(w,S,!1),Object.freeze(w)}g(d){const u=a=>(0,y.$Hf)(a)?new Proxy(a,{get:(h,S)=>u(h[S]),set:(h,S,P)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(S)}' of object`)},deleteProperty:(h,S)=>{throw new Error(`TypeError: Cannot delete read only property '${String(S)}' of object`)},defineProperty:(h,S)=>{throw new Error(`TypeError: Cannot define property '${String(S)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return u(d)}h(d,u,a){const h=$.$Kn.test(d)?4:this.d.get(d),S=a?`[${a.value}] `:"";if(h===4){typeof u?.resource>"u"&&this.f.warn(`${S}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${d}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){u?.resource&&this.f.warn(`${S}Accessing a window scoped configuration for a resource is not expected. To associate '${d}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(d,u){const a=new b.$Vn(d,u,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,S)=>a.affectsConfiguration(h,o(S))})}k(d){return d.reduce((u,a)=>(u.set(a[0],a[1]),u),new Map)}}e.$Efc=t,e.$Ffc=(0,C.$3h)("IExtHostConfiguration")}),define(Se[95],ke([1,0,2,11,4,6,7,41,69,42,21,47,20,27,5,17,10,13,91,303,14]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l,f,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=e.$8gc=e.$7gc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var c;(function(U){function F(O){if(O!=null)return O}U.from=F;function j(O){if(O!=null)return O}U.to=j})(c||(c={}));var t;(function(U){function F(O){if(O!=null)return O}U.from=F;function j(O){if(O!=null)return O}U.to=j})(t||(t={}));var r;(function(U){function F(O){if(O!=null)return O}U.from=F;function j(O){if(O!=null)return O}U.to=j})(r||(r={}));var d;(function(U){function F(M){if(M){const W=M;return W&&!!W.process}else return!1}U.is=F;function j(M){if(M==null)return;const W={process:M.process,args:M.args};return M.options&&(W.options=r.from(M.options)),W}U.from=j;function O(M){if(M!=null)return new R.$BL(M.process,M.args,M.options)}U.to=O})(d||(d={}));var u;(function(U){function F(O){if(O!=null)return O}U.from=F;function j(O){if(O!=null)return O}U.to=j})(u||(u={}));var a;(function(U){function F(M){if(M){const W=M;return W&&(!!W.commandLine||!!W.command)}else return!1}U.is=F;function j(M){if(M==null)return;const W={};return M.commandLine!==void 0?W.commandLine=M.commandLine:(W.command=M.command,W.args=M.args),M.options&&(W.options=u.from(M.options)),W}U.from=j;function O(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new R.$CL(M.commandLine,M.options):new R.$CL(M.command,M.args?M.args:[],M.options)}U.to=O})(a||(a={}));var h;(function(U){function F(M){if(M){const W=M;return W&&W.customExecution==="customExecution"}else return!1}U.is=F;function j(M){return{customExecution:"customExecution"}}U.from=j;function O(M,W){return W.get(M)}U.to=O})(h||(e.CustomExecutionDTO=h={}));var S;(function(U){function F(j,O){let M;return j.scope!==void 0&&typeof j.scope!="number"?M=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===R.TaskScope.Workspace&&O&&O.workspaceFile?M=O.workspaceFile:M=n.$lG),{id:j._id,workspaceFolder:M}}U.from=F})(S||(e.TaskHandleDTO=S={}));var P;(function(U){function F(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}U.from=F})(P||(P={}));var w;(function(U){function F(M,W){if(M==null)return[];const Y=[];for(const ue of M){const X=j(ue,W);X&&Y.push(X)}return Y}U.fromMany=F;function j(M,W){if(M==null)return;let Y;M.execution instanceof R.$BL?Y=d.from(M.execution):M.execution instanceof R.$CL?Y=a.from(M.execution):M.execution&&M.execution instanceof R.$DL&&(Y=h.from(M.execution));const ue=c.from(M.definition);let X;return M.scope?typeof M.scope=="number"?X=M.scope:X=M.scope.uri:X=R.TaskScope.Workspace,!ue||!X?void 0:{_id:M._id,definition:ue,name:M.name,source:{extensionId:W.identifier.value,label:M.source,scope:X},execution:Y,isBackground:M.isBackground,group:P.from(M.group),presentationOptions:t.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}U.from=j;async function O(M,W,Y){if(M==null)return;let ue;d.is(M.execution)?ue=d.to(M.execution):a.is(M.execution)?ue=a.to(M.execution):h.is(M.execution)&&(ue=h.to(M._id,Y));const X=c.to(M.definition);let J;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?J=M.source.scope:J=await W.resolveWorkspaceFolder(D.URI.revive(M.source.scope)):J=R.TaskScope.Workspace),!X||!J)return;const x=new R.$EL(X,J,M.name,M.source.label,ue,M.problemMatchers);return M.isBackground!==void 0&&(x.isBackground=M.isBackground),M.group!==void 0&&(x.group=R.$AL.from(M.group._id),x.group&&M.group.isDefault&&(x.group=new R.$AL(x.group.id,x.group.label),M.group.isDefault===!0&&(x.group.isDefault=M.group.isDefault))),M.presentationOptions&&(x.presentationOptions=t.to(M.presentationOptions)),M._id&&(x._id=M._id),M.detail&&(x.detail=M.detail),x}U.to=O})(w||(e.TaskDTO=w={}));var p;(function(U){function F(O){return O}U.from=F;function j(O){if(O)return Object.assign(Object.create(null),O)}U.to=j})(p||(p={}));class E{#e;constructor(F,j,O){this._id=j,this.a=O,this.#e=F}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(F){}fireDidEndProcess(F){}}let L=class{constructor(F,j,O,M,W,Y,ue,X){this.q=new g.$Sd,this.r=new g.$Sd,this.s=new g.$Sd,this.u=new g.$Sd,this.a=F.getProxy(I.$QK.MainThreadTask),this.b=O,this.c=M,this.d=W,this.e=Y,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ue,this.g=X,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(F,j,O){if(!O)return new R.$SK(()=>{});const M=this.x();return this.j.set(M,{type:j,provider:O,extension:F}),this.a.$registerTaskProvider(M,j),new R.$SK(()=>{this.j.delete(M),this.a.$unregisterTaskProvider(M)})}registerTaskSystem(F,j){this.a.$registerTaskSystem(F,j)}fetchTasks(F){return this.a.$fetchTasks(p.from(F)).then(async j=>{const O=[];for(const M of j){const W=await w.to(M,this.b,this.m);W&&O.push(W)}return O})}get taskExecutions(){const F=[];return this.k.forEach(j=>F.push(j)),F}terminateTask(F){if(!(F instanceof E))throw new Error("No valid task execution provided");return this.a.$terminateTask(F._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(F,j,O){const M=this.m.get(F.id);M&&(this.o.set(F.id,M),this.e.attachPtyToTerminal(j,await M.callback(O))),this.p=F.id,this.q.fire({execution:await this.z(F)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(F){if(!this.l.has(F.id))return;const j=await this.z(F);this.l.delete(F.id),this.k.delete(F.id),this.B(F),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(F){const j=await this.z(F.id);this.s.fire({execution:j,processId:F.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(F){const j=await this.z(F.id);this.u.fire({execution:j,exitCode:F.exitCode})}$provideTasks(F,j){const O=this.j.get(F);if(!O)return Promise.reject(new Error("no handler found"));const M=[],W=(0,N.$Vg)(()=>O.provider.provideTasks(A.CancellationToken.None)).then(Y=>this.v(j,M,O,Y));return new Promise(Y=>{W.then(ue=>{Promise.all(M).then(()=>{Y(ue)})})})}async $resolveTask(F,j){const O=this.j.get(F);if(!O)return Promise.reject(new Error("no handler found"));if(j.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${O.type}].`);const M=await w.to(j,this.b,this.m);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const W=await O.provider.resolveTask(M,A.CancellationToken.None);if(!W)return;this.A(W,O);const Y=w.from(W,O.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(Y.execution)&&await this.y(Y,W,!0),await this.w(Y)}x(){return this.h++}async y(F,j,O){const M=await this.a.$createTaskId(F);!O&&!this.m.has(M)&&(this.n.add(M),this.o.set(M,j.execution)),this.m.set(M,j.execution)}async z(F,j){if(typeof F=="string"){const W=this.l.get(F);if(!W)throw new o.$bb("Unexpected: The specified task is missing an execution");return W}const O=this.l.get(F.id);if(O)return O;let M;return j?M=Promise.resolve(new E(this,F.id,j)):M=w.to(F.task,this.b,this.m).then(W=>{if(!W)throw new o.$bb("Unexpected: Task does not exist.");return new E(this,F.id,W)}),this.l.set(F.id,M),M.then(W=>(this.k.set(F.id,W),W))}A(F,j){F._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}B(F){this.o.get(F.id)&&this.o.delete(F.id),this.n.has(F.id)&&this.p!==F.id&&(this.m.delete(F.id),this.n.delete(F.id));const O=this.n.values();let M=O.next();for(;!M.done;)!this.o.has(M.value)&&this.p!==M.value&&(this.m.delete(M.value),this.n.delete(M.value)),M=O.next()}};e.$7gc=L,e.$7gc=L=Ge([We(0,m.$UM),We(1,v.$$M),We(2,b.$Cfc),We(3,$.$6M),We(4,y.$Ffc),We(5,C.$4fc),We(6,s.$kj),We(7,i.$kfc)],L);let T=class extends L{constructor(F,j,O,M,W,Y,ue,X){super(F,j,O,M,W,Y,ue,X),this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:"",platform:f.$h(0)})}async executeTask(F,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const O=w.from(j,F);if(O===void 0)throw new Error("Task is not valid");if(h.is(O.execution))await this.y(O,j,!1);else throw new o.$_;const M=await this.z(await this.a.$getTaskExecution(O),j);return this.a.$executeTask(O).catch(W=>{throw new Error(W)}),M}v(F,j,O,M){const W=[];if(M)for(const Y of M){if(this.A(Y,O),!Y.definition||!F[Y.definition.type]){const X=Y.source?Y.source:"No task source";this.f.warn(`The task [${X}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`)}const ue=w.from(Y,O.extension);ue&&h.is(ue.execution)?(W.push(ue),j.push(this.y(ue,Y,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:O.extension}}async w(F){if(h.is(F.execution))return F;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(F,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(F,j,O){}};e.$8gc=T,e.$8gc=T=Ge([We(0,m.$UM),We(1,v.$$M),We(2,b.$Cfc),We(3,$.$6M),We(4,y.$Ffc),We(5,C.$4fc),We(6,s.$kj),We(7,i.$kfc)],T),e.$9gc=(0,k.$3h)("IExtHostTask")}),define(Se[359],ke([1,0,36,29]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EJ=e.$DJ=e.$CJ=void 0;function g(R){return"cellResults"in R}e.$CJ=g,e.$DJ="rawCell#";function I(R,b){let $=-1;const y=[];let A=[];return R.forEach(m=>{m.range.startLineNumber!==$&&A.length>0&&(y.push([...A]),A=[]),A.push(m),$=m.range.endLineNumber}),A.length>0&&y.push([...A]),y.map(m=>{const v=[],k=m[0].range.startLineNumber,l=m[m.length-1].range.endLineNumber;for(let f=k;f<=l;f++)v.push(b.getLineContent(f));return new D.$gJ(v.join(`
`)+`
`,m.map(f=>new N.$Is(f.range.startLineNumber-1,f.range.startColumn-1,f.range.endLineNumber-1,f.range.endColumn-1)))})}e.$EJ=I}),define(Se[360],ke([1,0,215,22,4,3,28,12,18,2,32,110,6,35,15,7,68,295,146,24,17,287,359,356]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l,f,s,i,n,o,c,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Igc=void 0;class d{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(a=>a.apiEditor)}constructor(a,h,S,P,w,p){this.q=S,this.r=P,this.s=w,this.t=p,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new g.$Sd,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new g.$Sd,this.onDidOpenNotebookDocument=this.m.event,this.n=new g.$Sd,this.onDidCloseNotebookDocument=this.n.event,this.o=new g.$Sd,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.$dfc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=a.getProxy(m.$QK.MainThreadNotebook),this.c=a.getProxy(m.$QK.MainThreadNotebookDocuments),this.d=a.getProxy(m.$QK.MainThreadNotebookEditors),this.i=h.converter,h.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===13){const L=E.notebookEditor?.notebookUri,T=E.cell.handle,F=this.g.get(L)?.getCell(T);if(F)return F.apiCell}if(E&&E.$mid===14){const L=E.uri,T=this.g.get(L);if(T)return T.apiNotebook}return E}}),d.B(h)}getEditorById(a){const h=this.h.get(a);if(!h)throw new Error(`unknown text editor: ${a}. known editors: ${[...this.h.keys()]} `);return h}getIdByEditor(a){for(const[h,S]of this.h)if(S.apiEditor===a)return h}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(a,h){const S=this.g.get(a);if(!S&&!h)throw new Error(`NO notebook document for '${a}'`);return S}static u(a,h){if(!h)return;const S=h.filenamePattern.map(P=>k.NotebookExclusiveDocumentPattern.from(P)).filter(P=>P!==void 0);if(h.filenamePattern&&!S){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:h.displayName,filenamePattern:S,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,h,S){const P=d.a++,w=typeof S.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(P,S),this.b.$registerNotebookCellStatusBarItemProvider(P,w,h);let p;return w!==void 0&&(p=S.onDidChangeCellStatusBarItems(E=>this.b.$emitCellStatusBarEvent(w))),new l.$SK(()=>{this.f.delete(P),this.b.$unregisterNotebookCellStatusBarItemProvider(P,w),p?.dispose()})}async createNotebookDocument(a){const h=await this.c.$tryCreateNotebook({viewType:a.viewType,content:a.content&&k.NotebookData.from(a.content)});return y.URI.revive(h)}async openNotebookDocument(a){const h=this.g.get(a);if(h)return h.apiNotebook;const S=await this.c.$tryOpenNotebook(a),P=this.g.get(y.URI.revive(S));return(0,$.$Qf)(P?.apiNotebook)}async showNotebookDocument(a,h){y.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let S;typeof h=="object"?S={position:k.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(k.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:S={preserveFocus:!1};const P=await this.d.$tryShowNotebookDocument(a.uri,a.notebookType,S),w=P&&this.h.get(P)?.apiEditor;if(w)return w;throw P?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,h,S,P){const w=this.f.get(a),p=y.URI.revive(h),E=this.g.get(p);if(!E||!w)return;const L=E.getCellFromIndex(S);if(!L)return;const T=await w.provideCellStatusBarItems(L.apiCell,P);if(!T)return;const U=new I.$Rc,F=this.p.add([U]),O=(Array.isArray(T)?T:[T]).map(M=>k.NotebookStatusBarItem.from(M,this.i,U));return{cacheId:F,items:O}}$releaseNotebookCellStatusBarItems(a){this.p.delete(a)}registerNotebookSerializer(a,h,S,P,w){if((0,b.$Ge)(h))throw new Error("viewType cannot be empty or just whitespace");const p=this.w++;return this.x.set(p,{viewType:h,serializer:S,options:P}),this.b.$registerNotebookSerializer(p,{id:a.identifier,location:a.extensionLocation},h,k.NotebookDocumentContentOptions.from(P),d.u(a,w)),(0,I.$Qc)(()=>{this.b.$unregisterNotebookSerializer(p)})}async $dataToNotebook(a,h,S){const P=this.x.get(a);if(!P)throw new Error("NO serializer found");const w=await P.serializer.deserializeNotebook(h.buffer,S);return new f.$Gv(k.NotebookData.from(w))}async $notebookToData(a,h,S){const P=this.x.get(a);if(!P)throw new Error("NO serializer found");const w=await P.serializer.serializeNotebook(k.NotebookData.to(h.value),S);return N.$ge.wrap(w)}async $saveNotebook(a,h,S,P,w){const p=y.URI.revive(h),E=this.x.get(a);if(!E)throw new Error("NO serializer found");const L=this.g.get(p);if(!L)throw new Error("Document NOT found");if(L.versionId!==S)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(p.scheme))throw new A.$Ik((0,D.localize)(0,null,this.z(p)),6);await this.y(p,P);const T={metadata:(0,n.$rn)(L.apiNotebook.metadata,M=>!(E.options?.transientDocumentMetadata??{})[M]),cells:[]};for(const M of L.apiNotebook.getCells()){const W=new l.$fM(M.kind,M.document.getText(),M.document.languageId,M.mime,E.options?.transientOutputs?[]:[...M.outputs],M.metadata,M.executionSummary);W.metadata=(0,n.$rn)(M.metadata,Y=>!(E.options?.transientCellMetadata??{})[Y]),T.cells.push(W)}const U=await E.serializer.serializeNotebook(T,w);await this.s.value.writeFile(p,U);const F=this.s.getFileSystemProviderExtUri(p.scheme),j=await this.s.value.stat(p);return{name:F.basename(p),isFile:(j.type&A.FileType.File)!==0,isDirectory:(j.type&A.FileType.Directory)!==0,isSymbolicLink:(j.type&A.FileType.SymbolicLink)!==0,mtime:j.mtime,ctime:j.ctime,size:j.size,readonly:!!((j.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(p.scheme),locked:!!((j.permissions??0)&A.FilePermission.Locked),etag:A.$Tk({mtime:j.mtime,size:j.size}),children:void 0}}async $searchInNotebooks(a,h,S,P,w){const p=this.x.get(a)?.serializer;if(!p)return{limitHit:!1,results:[]};const E=new R.$Bc;await(async(j,O,M)=>{await Promise.all(j.map(async W=>await Promise.all(W.filenamePatterns.map(Y=>{const ue={_reason:M._reason,folderQueries:M.folderQueries,includePattern:M.includePattern,excludePattern:M.excludePattern,maxResults:M.maxResults,type:1,filePattern:Y};return this.t.doInternalFileSearchWithCustomCallback(ue,O,X=>{X.forEach(J=>{E.has(J)||P.some(he=>W.isFromSettings&&!he.isFromSettings?!1:he.filenamePatterns.some(Z=>(0,r.$8cb)(Z,J)))||E.add(J)})})}))))})(S,w,h);const T=new R.$Ac;let U=!1;const F=Array.from(E).map(async j=>{const O=[];try{if(w.isCancellationRequested)return;if(h.maxResults&&[...T.values()].reduce((ue,X)=>ue+X.cellResults.length,0)>h.maxResults){U=!0;return}const M=[],W=this.g.get(j);if(W)W.apiNotebook.getCells().forEach(X=>M.push({input:X.document.getText(),outputs:X.outputs.flatMap(J=>J.items.map(x=>x.data.toString()))}));else{const ue=await this.s.value.readFile(j),X=N.$ge.fromString(ue.toString()),J=await p.deserializeNotebook(X.buffer,w);if(w.isCancellationRequested)return;k.NotebookData.from(J).cells.forEach(he=>M.push({input:he.source,outputs:he.outputs.flatMap(Z=>Z.items.map(we=>we.valueBytes.toString()))}))}if(w.isCancellationRequested)return;M.forEach((ue,X)=>{const J=h.contentPattern.pattern,x=new c.$$Pb(ue.input,void 0,ue.outputs),he=x.findInInputs(J),Z=x.findInOutputs(J),we=Z.flatMap(ce=>(0,t.$EJ)(ce.matches,ce.textBuffer)).map((ce,K)=>(ce.webviewIndex=K,ce));if(he.length>0||Z.length>0){const ce={index:X,contentResults:(0,t.$EJ)(he,x.inputTextBuffer),webviewResults:we};O.push(ce)}});const Y={resource:j,cellResults:O};T.set(j,Y);return}catch{return}});return await Promise.all(F),{limitHit:U,results:[...T.values()]}}async y(a,h){const S=await this.s.value.stat(a);if(typeof h?.mtime=="number"&&typeof h.etag=="string"&&h.etag!==A.$Sk&&typeof S.mtime=="number"&&typeof S.size=="number"&&h.mtime<S.mtime&&h.etag!==A.$Tk({mtime:h.mtime,size:S.size}))throw new A.$Ik((0,D.localize)(1,null),3,h)}z(a){return a.scheme===o.Schemas.file?a.fsPath:a.toString()}A(a,h,S){if(this.h.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const P=new i.$zgc(h,this.d,a,S.visibleRanges.map(k.NotebookRange.to),S.selections.map(k.NotebookRange.to),typeof S.viewColumn=="number"?k.ViewColumn.to(S.viewColumn):void 0);this.h.set(h,P)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const S of a.value.removedDocuments){const P=y.URI.revive(S),w=this.g.get(P);w&&(w.dispose(),this.g.delete(P),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:w.apiNotebook.getCells().map(p=>p.document.uri)}),this.n.fire(w.apiNotebook));for(const p of this.h.values())p.notebookData.uri.toString()===P.toString()&&this.h.delete(p.id)}if(a.value.addedDocuments){const S=[];for(const P of a.value.addedDocuments){const w=y.URI.revive(P.uri);if(this.g.has(w))throw new Error(`adding EXISTING notebook ${w} `);const p=new s.$ygc(this.c,this.q,this.r,w,P);S.push(...P.cells.map(E=>s.$xgc.asModelAddData(p.apiNotebook,E))),this.g.get(w)?.dispose(),this.g.set(w,p),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:S}),this.m.fire(p.apiNotebook)}}if(a.value.addedEditors)for(const S of a.value.addedEditors){if(this.h.has(S.id))return;const P=y.URI.revive(S.documentUri),w=this.g.get(P);w&&this.A(w,S.id,S)}const h=[];if(a.value.removedEditors)for(const S of a.value.removedEditors){const P=this.h.get(S);P&&(this.h.delete(S),this.k?.id===P.id&&(this.k=void 0),h.push(P))}if(a.value.visibleEditors){this.l=a.value.visibleEditors.map(P=>this.h.get(P)).filter(P=>!!P);const S=new Set;this.l.forEach(P=>S.add(P.id));for(const P of this.h.values()){const w=S.has(P.id);P._acceptVisibility(w)}this.l=[...this.h.values()].map(P=>P).filter(P=>P.visible),this.o.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this.k=void 0:a.value.newActiveEditor&&(this.h.get(a.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${a.value.newActiveEditor}`),this.k=this.h.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(a){const h=v.$gN.String.with("notebookType","A notebook type"),S=new v.$iN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[h,new v.$gN("data","Bytes to convert to data",w=>w instanceof Uint8Array,w=>N.$ge.wrap(w))],new v.$hN("Notebook Data",w=>k.NotebookData.to(w.value))),P=new v.$iN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[h,new v.$gN("NotebookData","Notebook data to convert to bytes",w=>!0,w=>new f.$Gv(k.NotebookData.from(w)))],new v.$hN("Bytes",w=>w.buffer));a.registerApiCommand(S),a.registerApiCommand(P)}}e.$Igc=d}),define(Se[361],ke([1,0,16,21,44,34,23,38,36]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Agc=void 0;class y{constructor(m,v,k){this.k=m,this.l=v,this.o=k,this.e=!1,this.f=0,this.g=!1,this.a=m.filePattern,this.b=m.includePattern&&I.$Jj(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.h=new Set,this.j=m.excludePattern&&I.$Jj(m.excludePattern)}cancel(){this.g=!0,this.h.forEach(m=>m.cancel()),this.h=new Set}search(m){const v=this.k.folderQueries||[];return new Promise((k,l)=>{const f=s=>{this.f++,m(s)};if(this.g)return k({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const i=s.toString(),n=D.$nc(i);this.j&&this.j(i,n)||this.v(f,{base:s,basename:n})}),Promise.all(v.map(s=>this.p(s,f))).then(s=>{k({limitHit:this.e,stats:s[0]||void 0})},s=>{l(new Error((0,g.$Ni)(s)))})})}async p(m,v){const k=new N.$3d,l=this.q(m),f=this.r(),s=new $.$uJ(this.k,m),i=!s.hasSiblingExcludeClauses();let n;try{this.h.add(k),n=b.$Od.create();const o=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},l,k.token),c=n.elapsed(),t=b.$Od.create();return this.g&&!this.e||(o&&o.forEach(r=>{const d=D.$gc.relative(m.folder.path,r.path);if(i){const u=D.$nc(r.path);this.v(v,{base:m.folder,relativePath:d,basename:u});return}this.s(f,m.folder,d,v)}),this.g&&!this.e)?null:(this.u(f,s,v),{providerTime:c,postProcessTime:t.elapsed()})}finally{k.dispose(),this.h.delete(k)}}q(m){const v=(0,$.$tJ)(this.k.includePattern,m.includePattern),k=(0,$.$tJ)(this.k.excludePattern,m.excludePattern);return{folder:m.folder,excludes:k,includes:v,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}s({pathToEntries:m},v,k,l){if(k===this.a){const s=D.$nc(this.a);this.v(l,{base:v,relativePath:this.a,basename:s})}function f(s){const i=D.$nc(s),n=D.$mc(s);let o=m[n];o||(o=m[n]=[],f(n)),o.push({base:v,relativePath:s,basename:i})}f(k)}u({rootEntries:m,pathToEntries:v},k,l){const f=this,s=this.a;function i(n){const o=(0,$.$wJ)(()=>n.map(c=>c.basename));for(let c=0,t=n.length;c<t;c++){const r=n[c],{relativePath:d,basename:u}=r;if(k.matchesExcludesSync(d,u,s!==u?o:void 0))continue;const a=v[d];if(a)i(a);else{if(d===s)continue;f.v(l,r)}if(f.e)break}}i(m)}v(m,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||m(v))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(m,v,k,l){const f=this.c(m.cacheKey),s=new y(m,v,f&&f.token);let i=0;const n=o=>{i+=o.length,k(o.map(c=>this.d(c)))};return this.e(s,A.a,n,l).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:o.stats}}))}clearCache(m){this.c(m)?.cancel()}c(m){if(m)return this.b.has(m)||this.b.set(m,new N.$3d),this.b.get(m)}d(m){return m.relativePath?{resource:R.$Eg(m.base,m.relativePath)}:{resource:m.base}}e(m,v,k,l){const f=l.onCancellationRequested(()=>{m.cancel()}),s=n=>{n&&(i.push(n),v>0&&i.length>=v&&(k(i),i=[]))};let i=[];return m.search(s).then(n=>(i.length&&k(i),f.dispose(),n),n=>(i.length&&k(i),f.dispose(),Promise.reject(n)))}}e.$Agc=A}),define(Se[362],ke([1,0,19,73,34,102,28,17,16,23,12,18,2,99,236,45,13,40,143,357,36]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l,f,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vK=e.$uK=void 0;let c=class{constructor(p,E,L,T,U){this.a=p,this.b=E,this.c=L,this.d=T,this.e=U}text(p,E,L={}){p=this.f(p,L);const T=this.a.getValue(),U=E&&E.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(E?.map(s.$li),L),type:2,contentPattern:p,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:T.search.usePCRE2||U||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}f(p,E){const L=this.a.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const T={...p,wordSeparators:L.editor.wordSeparators};return this.j(p,E)&&(T.isCaseSensitive=!0),this.k(p)&&(T.isMultiline=!0),E.notebookSearchConfig?.includeMarkupInput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookMarkdownInput=E.notebookSearchConfig.includeMarkupInput),E.notebookSearchConfig?.includeMarkupPreview&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookMarkdownPreview=E.notebookSearchConfig.includeMarkupPreview),E.notebookSearchConfig?.includeCodeInput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookCellInput=E.notebookSearchConfig.includeCodeInput),E.notebookSearchConfig?.includeOutput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookCellOutput=E.notebookSearchConfig.includeOutput),T}file(p,E={}){return{...this.h(p,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}g(p,E){return p?(p=Array.isArray(p)?p.map(a):a(p),E?this.parseSearchPaths(p):{pattern:r(...Array.isArray(p)?p:[p])}):{}}h(p=[],E={}){const L=this.g(E.includePattern,E.expandPatterns),T=this.g(E.excludePattern,E.expandPatterns),U=p.length>1,F=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(M=>this.q(M,E,T)):p.map(M=>this.r(M,E,T,U))).filter(M=>!!M),j={_reason:E._reason,folderQueries:F,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:T.pattern,includePattern:L.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const M=D.$Hb(D.$Rb(this.c.groups.map(ue=>ue.editors.map(X=>X.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(M));const W=M.filter(ue=>(0,o.$kJ)(j,ue.fsPath)),Y=this.i(W);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Y)),{...j,...Y}}const O=E.extraFileResources&&E.extraFileResources.filter(M=>(0,o.$kJ)(j,M.fsPath));return j.extraFileResources=O&&O.length?O:void 0,j}i(p){const E=[],L=new R.$Ac,T={};let U=!1;return p.forEach(F=>{if(F.scheme===b.Schemas.walkThrough)return;if((0,y.$Ig)(F)){const O=this.b.getWorkspaceFolder(F)?.uri??F.with({path:$.$mc(F.fsPath)});let M=L.get(O);M||(U=!0,M={folder:O,includePattern:{}},E.push(M),L.set(O,M));const W=$.$lc(O.fsPath,F.fsPath);(0,C.$Qf)(M.includePattern)[W.replace(/\\/g,"/")]=!0}else F.fsPath&&(U=!0,T[F.fsPath]=!0)}),{folderQueries:E,includePattern:T,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}j(p,E){if(E.isSmartCase){if(p.isRegExp){if(A.$wf(p.pattern,!0))return!0}else if(A.$wf(p.pattern))return!0}return!!p.isCaseSensitive}k(p){return p.isMultiline||p.isRegExp&&(0,v.$PB)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const E=Y=>$.$ic(Y)||/^\.\.?([\/\\]|$)/.test(Y),T=(Array.isArray(p)?p:d(p)).map(Y=>{const ue=this.e.resolvedUserHome;return ue?(0,I.$Lv)(Y,ue.scheme===b.Schemas.file?ue.fsPath:ue.path):Y}),U=N.$K(T,Y=>E(Y)?"searchPaths":"exprSegments"),F=(U.exprSegments||[]).map(Y=>A.$Re(Y,"/")).map(Y=>A.$Re(Y,"\\")).map(Y=>(Y[0]==="."&&(Y="*"+Y),u(Y))),j={},O=this.m(U.searchPaths||[]);O&&O.length&&(j.searchPaths=O);const M=D.$Rb(F),W=r(...M);return W&&(j.pattern=W),j}l(p,E){return E.disregardExcludeSettings?void 0:(0,o.$jJ)(p,!E.disregardSearchExcludeSettings)}m(p){if(!p||!p.length)return[];const E=p.flatMap(T=>{let{pathPortion:U,globPortion:F}=t(T);return F&&(F=h(F)),this.n(U).flatMap(O=>this.o(O,F))}),L=new Map;return E.forEach(T=>{const U=T.searchPath.toString(),F=L.get(U);F?T.pattern&&(F.pattern=F.pattern||{},F.pattern[T.pattern]=!0):L.set(U,{searchPath:T.searchPath,pattern:T.pattern?r(T.pattern):void 0})}),Array.from(L.values())}n(p){if($.$ic(p)){const E=this.b.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==b.Schemas.file?[{searchPath:E[0].uri.with({path:p})}]:[{searchPath:m.URI.file($.$hc(p))}]}if(this.b.getWorkbenchState()===2){const E=this.b.getWorkspace().folders[0].uri;if(p=a(p),p.startsWith("../")||p===".."){const T=$.$gc.resolve(E.path,p);return[{searchPath:E.with({path:T})}]}const L=h(p);return[{searchPath:E,pattern:L}]}else{if(p==="./"||p===".\\")return[];{const E=p.replace(/^\.[\/\\]/,""),T=this.b.getWorkspace().folders.map(U=>{const F=E.match(new RegExp(`^${A.$Le(U.name)}(?:/(.*)|$)`));return F?{match:F,folder:U}:null}).filter(C.$Nf);if(T.length)return T.map(U=>{const F=U.match[1];return{searchPath:U.folder.uri,pattern:F&&h(F)}});{const U=p.match(/\.[\/\\](.+)[\/\\]?/),F=U?U[1]:p,j=k.localize(0,null,F);throw new Error(j)}}}}o(p,E){const L=p.pattern&&E?`${p.pattern}/${E}`:p.pattern||E,T=[{searchPath:p.searchPath,pattern:L}];return L&&!L.endsWith("**")&&T.push({searchPath:p.searchPath,pattern:L+"/**"}),T}q(p,E,L){const T=this.r((0,s.$li)(p.searchPath),E,L,!1);return T?{...T,includePattern:p.pattern}:null}r(p,E,L,T){let U;const F=m.URI.isUri(p)?p:p.uri;if(L.searchPaths){const Y=L.searchPaths.filter(ue=>(0,y.$xg)(ue.searchPath,F))[0];if(Y&&!Y.pattern)return null;Y&&(U=Y.pattern)}const j=this.a.getValue({resource:F}),M={...this.l(j,E)||{},...U||{}},W=m.URI.isUri(p)?(0,y.$Bg)(p):p.name;return{folder:F,folderName:T?W:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof E.disregardParentIgnoreFiles=="boolean"?E.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!j.search.followSymlinks}}};e.$uK=c,e.$uK=c=Ge([We(0,l.$wi),We(1,s.$_h),We(2,i.$UC),We(3,f.$kj),We(4,n.$sK)],c);function t(w){const p=w.match(/[\*\{\}\(\)\[\]\?]/);if(p){const E=p.index,L=w.substr(0,E).match(/[/|\\][^/\\]*$/);if(L){let T=w.substr(0,L.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:w.substr((L.index||0)+1)}}}return{pathPortion:w}}function r(...w){return w.length?w.reduce((p,E)=>(p[E]=!0,p),Object.create(null)):void 0}function d(w){return g.$Hj(w,",").map(p=>p.trim()).filter(p=>!!p.length)}function u(w){return[`**/${w}/**`,`**/${w}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function a(w){return w.replace(/\\/g,"/")}function h(w){return a(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(w){return w.replace(/([?*[\]])/g,"[$1]")}function P(w,p){w=D.$Mb(w,T=>T.toString());const E=[],L=p.getWorkspace();return w&&w.forEach(T=>{let U;if(p.getWorkbenchState()===2)U=(0,y.$Gg)(L.folders[0].uri,T),U&&U!=="."&&(U="./"+U);else{const F=p.getWorkspaceFolder(T);if(F){const j=F.name;if(L.folders.filter(M=>M.name===j).length===1){const M=(0,y.$Gg)(F.uri,T);M===""?U=`./${F.name}`:U=`./${F.name}/${M}`}else U=T.fsPath}}U&&E.push(S(U))}),E}e.$vK=P}),define(Se[363],ke([1,0,23,2,21,14,5,362,36,40]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gsb=e.$fsb=void 0;const A=7e3;function C(l,f){const s=f.activationEvents;if(!s)return Promise.resolve(void 0);const i=[],n=[];for(const u of s)if(/^workspaceContains:/.test(u)){const a=u.substr(18);a.indexOf("*")>=0||a.indexOf("?")>=0||l.forceUsingSearch?n.push(a):i.push(a)}if(i.length===0&&n.length===0)return Promise.resolve(void 0);let o;const c=new Promise((u,a)=>{o=u}),t=u=>o({activationEvent:u}),r=Promise.all(i.map(u=>m(l,u,t))).then(()=>{}),d=v(l,f.identifier,n,t);return Promise.all([r,d]).then(()=>{o(void 0)}),c}e.$fsb=C;async function m(l,f,s){for(const i of l.folders)if(await l.exists(D.$Eg(N.URI.revive(i),f))){s(`workspaceContains:${f}`);return}}async function v(l,f,s,i){if(s.length===0)return Promise.resolve(void 0);const n=new g.$3d,o=l.checkExists(l.folders,s,n.token),c=setTimeout(async()=>{n.cancel(),l.logService.info(`Not activating extension '${f.value}': Timed out while searching for 'workspaceContains' pattern ${s.join(",")}`)},A);let t=!1;try{t=await o}catch(r){I.$4(r)||I.$1(r)}n.dispose(),clearTimeout(c),t&&i(`workspaceContains:${s.join(",")}`)}function k(l,f,s,i){const n=l.get(R.$2h),o=l.get($.$bJ),t=n.createInstance(b.$uK).file(f.map(r=>(0,y.$li)(N.URI.revive(r))),{_reason:"checkExists",includePattern:s,exists:!0});return o.fileSearch(t,i).then(r=>!!r.limitHit,r=>I.$4(r)?!1:Promise.reject(r))}e.$gsb=k}),define(Se[48],ke([1,0,212,16,57,23,11,3,77,2,13,6,42,293,118,41,25,145,14,26,22,272,7,64,5,27,92,20,107,72,47,4,363,117,274,17,115,38,10,116]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l,f,s,i,n,o,c,t,r,d,u,a,h,S,P,w,p,E,L,T,U,F,j,O,M){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=e.$fgc=e.$egc=e.$dgc=e.$cgc=void 0,e.$cgc=(0,d.$3h)("IHostUtils");let Y=W=class extends b.$Sc{constructor(K,B,re,ye,de,ge,_,ie,G,te,fe,ve){super(),this.X=ve,this.a=this.B(new p.$Sd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=B,this.g=re,this.f=_,this.j=ye,this.m=de,this.s=ge,this.t=G,this.u=te,this.w=fe,this.y=this.g.getProxy(C.$QK.MainThreadWorkspace),this.z=this.g.getProxy(C.$QK.MainThreadTelemetry),this.C=this.g.getProxy(C.$QK.MainThreadExtensionService),this.D=new R.$2g,this.F=new R.$2g,this.G=new R.$2g,this.H=new R.$2g,this.I=new we(this.f.extensions.activationEvents),this.L=new s.$p7b(this.I,this.f.extensions.allExtensions);const Pe=new n.$jm(this.f.extensions.myExtensions);this.J=new s.$p7b(this.I,he(this.L,Pe)),O.$t&&(this.s.info(`Creating extension host with the following global extensions: ${J(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${J(this.J)}`)),this.M=new k.$Zfc(this.g,this.s),this.N=new L.$8fc(this.g),this.O=ie,this.h=K.createChild(new S.$1h([k.$1fc,this.M],[L.$9fc,this.N])),this.P=this.B(new v.$Yfc(this.J,this.L,{onExtensionActivationError:(be,De,z)=>{this.C.$onExtensionActivationError(be,i.$3(De),z)},actualActivateExtension:async(be,De)=>{if(s.$p7b.isHostExtension(be,this.J,this.L))return await this.C.$activateExtension(be,De),new v.$Xfc;const z=this.J.getExtensionDescription(be);return this.db(z,De)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),g.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(K){i.$1(K)}}async Y(){this.O.onWillDeactivateAll();let K=[];try{K=this.J.getAllExtensionDescriptions().map(de=>de.identifier).filter(de=>this.isActivated(de)).map(de=>this.cb(de))}catch{}await Promise.all(K)}terminate(K,B=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${K}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(ye=>{this.s.error(ye)}),this.g.dispose();const re=this.Y();Promise.race([(0,R.$4g)(5e3),re]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${B}`):this.s.info(`Extension host exiting with code ${B}`),this.s.flush(),this.s.dispose(),this.c.exit(B)})}isActivated(K){return this.G.isOpen()?this.P.isActivated(K):!1}async getExtension(K){const B=await this.C.$getExtension(K);return B&&{...B,identifier:new n.$im(B.identifier.value),extensionLocation:y.URI.revive(B.extensionLocation)}}Z(K,B){return this.P.activateByEvent(K,B)}$(K,B){return this.P.activateById(K,B)}activateByIdWithErrors(K,B){return this.$(K,B).then(()=>{const re=this.P.getActivatedExtension(K);if(re.activationFailed)return Promise.reject(re.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(K=>this.J)}getExtensionExports(K){if(this.G.isOpen())return this.P.getActivatedExtension(K).exports;try{return this.P.getActivatedExtension(K).exports}catch{return null}}async ab(K){if(K.scheme===U.Schemas.file&&this.c.fsRealpath){const B=await this.c.fsRealpath(K.fsPath);return y.URI.file(B)}return K}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(K=>new Z(K))),this.Q}async bb(K){const B=$.$9h.forUris(re=>I.$vg.ignorePathCasing(re));return await Promise.all(K.map(async re=>{if(this.ub(re)){const ye=await this.ab(re.extensionLocation);B.set(ye,re)}})),B}cb(K){let B=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(K))return B;const re=this.P.getActivatedExtension(K);if(!re)return B;try{typeof re.module.deactivate=="function"&&(B=Promise.resolve(re.module.deactivate()).then(void 0,ye=>(this.s.error(ye),Promise.resolve(void 0))))}catch(ye){this.s.error(`An error occurred when deactivating the extension '${K.value}':`),this.s.error(ye)}try{(0,b.$Nc)(re.subscriptions)}catch(ye){this.s.error(`An error occurred when deactivating the subscriptions for extension '${K.value}':`),this.s.error(ye)}return B}async db(K,B){return this.f.remote.isRemote?this.C.$onWillActivateExtension(K.identifier):await this.C.$onWillActivateExtension(K.identifier),this.fb(K,B).then(re=>{const ye=re.activationTimes;return this.C.$onDidActivateExtension(K.identifier,ye.codeLoadingTime,ye.activateCallTime,ye.activateResolvedTime,B),this.eb(K,B,"success",ye),re},re=>{throw this.eb(K,B,"failure"),re})}eb(K,B,re,ye){const de=X(K,B);this.z.$publicLog2("extensionActivationTimes",{...de,...ye||{},outcome:re})}fb(K,B){const re=X(K,B);this.z.$publicLog2("activatePlugin",re);const ye=this.ub(K);if(!ye)return Promise.resolve(new v.$Wfc(v.$Tfc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${K.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${K.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this.s.flush();const de=new v.$Ufc(B.startup);return Promise.all([this.vb(K,(0,I.$Eg)(K.extensionLocation,ye),de),this.gb(K)]).then(ge=>(g.mark(`code/extHost/willActivateExtension/${K.identifier.value}`),W.hb(this.s,K.identifier,ge[0],ge[1],de))).then(ge=>(g.mark(`code/extHost/didActivateExtension/${K.identifier.value}`),ge))}gb(K){const B=new c.$3fc(K,this.M),re=new c.$2fc(K.identifier.value,!1,this.M),ye=new T.$0fc(K,this.N),de=K.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ge=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${K.identifier.value}`),Promise.all([B.whenReady,re.whenReady,this.O.whenReady]).then(()=>{const _=this;let ie,G;const te=(0,f.$oF)(K,"ipc")?this.f.messagePorts?.get(n.$im.toKey(K.identifier)):void 0;return Object.freeze({globalState:B,workspaceState:re,secrets:ye,subscriptions:[],get extensionUri(){return K.extensionLocation},get extensionPath(){return K.extensionLocation.fsPath},asAbsolutePath(fe){return N.$jc(K.extensionLocation.fsPath,fe)},get storagePath(){return _.O.workspaceValue(K)?.fsPath},get globalStoragePath(){return _.O.globalValue(K).fsPath},get logPath(){return N.$jc(_.f.logsLocation.fsPath,K.identifier.value)},get logUri(){return y.URI.joinPath(_.f.logsLocation,K.identifier.value)},get storageUri(){return _.O.workspaceValue(K)},get globalStorageUri(){return _.O.globalValue(K)},get extensionMode(){return de},get extension(){return ie===void 0&&(ie=new x(_,K.identifier,K,ge,!1)),ie},get extensionRuntime(){return(0,f.$pF)(K,"extensionRuntime"),_.extensionRuntime},get environmentVariableCollection(){return _.u.getEnvironmentVariableCollection(K)},get messagePassingProtocol(){if(!G){if(!te)return;const fe=p.Event.buffer(p.Event.fromDOMEventEmitter(te,"message",ve=>ve.data));te.start(),G={onDidReceiveMessage:fe,postMessage:te.postMessage.bind(te)}}return G}})})}static hb(K,B,re,ye,de){return re=re||{activate:void 0,deactivate:void 0},this.ib(K,B,re,ye,de).then(ge=>new v.$Vfc(!1,null,de.build(),re,ge,ye.subscriptions))}static ib(K,B,re,ye,de){if(typeof re.activate=="function")try{de.activateCallStart(),K.trace(`ExtensionService#_callActivateOptional ${B.value}`);const ge=typeof global=="object"?global:self,_=re.activate.apply(ge,[ye]);return de.activateCallStop(),de.activateResolveStart(),Promise.resolve(_).then(ie=>(de.activateResolveStop(),ie))}catch(ge){return Promise.reject(ge)}else return Promise.resolve(re)}jb(K,B){this.$(K.identifier,{startup:!1,extensionId:K.identifier,activationEvent:B}).then(void 0,re=>{this.s.error(re)})}kb(K,B=0){const ye=Date.now();(0,O.$B)(()=>{for(let de=B;de<K.length;de+=1){const ge=K[de];for(const _ of ge.activationEvents??[])if(_==="onStartupFinished")if(Date.now()-ye>50){this.kb(K,de);break}else this.jb(ge,_)}})}lb(){this.C.$setPerformanceMarks(g.getMarks()),this.m.getConfigProvider().then(K=>{const B=K.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),re=this.J.getAllExtensionDescriptions();if(B)this.kb(re);else for(const ye of re)if(ye.activationEvents)for(const de of ye.activationEvents)de==="onStartupFinished"&&this.jb(ye,de)})}mb(){const K=this.Z("*",!0).then(void 0,ge=>{this.s.error(ge)});this.B(this.j.onDidChangeWorkspace(ge=>this.nb(ge.added)));const B=this.j.workspace?this.j.workspace.folders:[],re=this.nb(B),ye=this.pb(),de=Promise.all([ye,K,re]).then(()=>{});return Promise.race([de,(0,R.$4g)(1e4)]).then(()=>{this.lb()}),de}nb(K){return K.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(B=>this.ob(K,B))).then(()=>{})}async ob(K,B){if(this.isActivated(B.identifier))return;const re=!this.f.remote.isRemote&&!!this.f.remote.authority,ye={logService:this.s,folders:K.map(ge=>ge.uri),forceUsingSearch:re||!this.c.fsExists,exists:ge=>this.c.fsExists(ge.fsPath),checkExists:(ge,_,ie)=>this.y.$checkExists(ge,_,ie)},de=await(0,E.$fsb)(ye,B);if(de)return this.$(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:de.activationEvent}).then(void 0,ge=>this.s.error(ge))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(K){throw console.error(K),K}}async qb(){const{extensionDevelopmentLocationURI:K,extensionTestsLocationURI:B}=this.f.environment;if(!K||!B)throw new Error(D.localize(0,null));const re=await this.vb(null,B,new v.$Ufc(!1));if(!re||typeof re.run!="function")throw new Error(D.localize(1,null,B.toString()));return new Promise((ye,de)=>{const ge=(G,te)=>{G?(O.$t&&this.s.error("Test runner called back with error",G),de(G)):(O.$t&&(te?this.s.info(`Test runner called back with ${te} failures.`):this.s.info("Test runner called back with successful outcome.")),ye(typeof te=="number"&&te>0?1:0))},_=(0,I.$sg)(B),ie=re.run(_,ge);ie&&ie.then&&ie.then(()=>{O.$t&&this.s.info("Test runner finished successfully."),ye(0)}).catch(G=>{O.$t&&this.s.error("Test runner finished with error",G),de(G instanceof Error&&G.stack?G.stack:String(G))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$4g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(K,B){return this.R[K]=B,(0,b.$Qc)(()=>{delete this.R[K]})}async getRemoteExecServer(K){const{resolver:B}=await this.sb(K);return B?.resolveExecServer?.(K,{resolveAttempt:0})}async sb(K){const B=K.indexOf("+");if(B===-1)throw new t.$YK("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const re=K.substr(0,B);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${re}`,!1),{authorityPrefix:re,resolver:this.R[re]}}async $resolveAuthority(K,B){const re=j.$Od.create(!1),ye=()=>`[resolveAuthority(${(0,r.$9k)(K)},${B})][${re.elapsed()}ms] `,de=ee=>this.s.info(`${ye()}${ee}`),ge=ee=>this.s.warn(`${ye()}${ee}`),_=(ee,V=void 0)=>this.s.error(`${ye()}${ee}`,V),ie=ee=>{if(ee instanceof t.$YK)return{type:"error",error:{code:ee._code,message:ee._message,detail:ee._detail}};throw ee},G=async ee=>{de(`activating resolver for ${ee}...`);const{resolver:V,authorityPrefix:oe}=await this.sb(ee);if(!V)throw _(`no resolver for ${oe}`),new t.$YK(`No remote extension installed to resolve ${oe}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:V,authorityPrefix:oe,remoteAuthority:ee}},te=K.split(/@|%40/g).reverse();de(`activating remote resolvers ${te.join(" -> ")}`);let fe;try{fe=await Promise.all(te.map(G)).catch(async ee=>{if(!(ee instanceof t.$YK)||ee._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw ee;return ge(`resolving nested authorities failed: ${ee.message}`),[await G(K)]})}catch(ee){return ie(ee)}const ve=new R.$bh;ve.cancelAndSet(()=>de("waiting..."),1e3);let Pe,be;for(const[ee,{authorityPrefix:V,resolver:oe,remoteAuthority:le}]of fe.entries())try{if(ee===fe.length-1)de("invoking final resolve()..."),g.mark(`code/extHost/willResolveAuthority/${V}`),Pe=await oe.resolve(le,{resolveAttempt:B,execServer:be}),g.mark(`code/extHost/didResolveAuthorityOK/${V}`),de("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(oe,t.$XK.isManagedResolvedAuthority(Pe)?Pe:void 0));else{if(de(`invoking resolveExecServer() for ${le}`),g.mark(`code/extHost/willResolveExecServer/${V}`),be=await oe.resolveExecServer?.(le,{resolveAttempt:B,execServer:be}),!be)throw new t.$YK(`Exec server was not available for ${le}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);g.mark(`code/extHost/didResolveExecServerOK/${V}`)}}catch(Re){return g.mark(`code/extHost/didResolveAuthorityError/${V}`),_("returned an error",Re),ve.dispose(),ie(Re)}ve.dispose();const De={environmentTunnels:Pe.environmentTunnels,features:Pe.tunnelFeatures},z={extensionHostEnv:Pe.extensionHostEnv,isTrusted:Pe.isTrusted,authenticationSession:Pe.authenticationSessionForInitializingExtensions?{id:Pe.authenticationSessionForInitializingExtensions.id,providerId:Pe.authenticationSessionForInitializingExtensions.providerId}:void 0};de(`returned ${t.$XK.isManagedResolvedAuthority(Pe)?"managed authority":`${Pe.host}:${Pe.port}`}`);let Q;if(t.$XK.isManagedResolvedAuthority(Pe)){const ee=B;this.X.setFactory(ee,Pe.makeConnection),Q={authority:K,connectTo:new r.$6k(ee),connectionToken:Pe.connectionToken}}else Q={authority:K,connectTo:new r.$7k(Pe.host,Pe.port),connectionToken:Pe.connectionToken};return{type:"ok",value:{authority:Q,options:z,tunnelInformation:De}}}async $getCanonicalURI(K,B){this.s.info(`$getCanonicalURI invoked for authority (${(0,r.$9k)(K)})`);const{resolver:re}=await this.sb(K);if(!re)return null;const ye=y.URI.revive(B);if(typeof re.getCanonicalURI>"u")return ye;const de=await(0,R.$Vg)(()=>re.getCanonicalURI(ye));return de||ye}$startExtensionHost(K){K.toAdd.forEach(ye=>ye.extensionLocation=y.URI.revive(ye.extensionLocation));const{globalRegistry:B,myExtensions:re}=ue(this.I,this.L,this.J,K);return this.L.set(B.getAllExtensionDescriptions()),this.J.set(re),O.$t&&(this.s.info(`$startExtensionHost: global extensions: ${J(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${J(this.J)}`)),this.rb()}$activateByEvent(K,B){return B===1?this.D.wait().then(re=>this.Z(K,!1)):this.G.wait().then(re=>this.Z(K,!1))}async $activate(K,B){return await this.G.wait(),this.J.getExtensionDescription(K)?(await this.$(K,B),!0):!1}async $deltaExtensions(K){K.toAdd.forEach(ge=>ge.extensionLocation=y.URI.revive(ge.extensionLocation));const{globalRegistry:B,myExtensions:re}=ue(this.I,this.L,this.J,K),ye=await this.bb(re);return(await this.getExtensionPathIndex()).setSearchTree(ye),this.L.set(B.getAllExtensionDescriptions()),this.J.set(re),O.$t&&(this.s.info(`$deltaExtensions: global extensions: ${J(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${J(this.J)}`)),Promise.resolve(void 0)}async $test_latency(K){return K}async $test_up(K){return K.byteLength}async $test_down(K){const B=o.$ge.alloc(K),re=Math.random()%256;for(let ye=0;ye<K;ye++)B.writeUInt8(re,ye);return B}async $updateRemoteConnectionData(K){this.W=K,this.a.fire()}};e.$dgc=Y,e.$dgc=Y=W=Ge([We(0,d.$2h),We(1,e.$cgc),We(2,h.$UM),We(3,l.$Cfc),We(4,m.$Ffc),We(5,A.$kj),We(6,u.$$M),We(7,a.$Ifc),We(8,P.$cyb),We(9,w.$4fc),We(10,F.$_fc),We(11,M.$agc)],Y);function ue(ce,K,B,re){ce.addActivationEvents(re.addActivationEvents);const ye=new s.$p7b(ce,K.getAllExtensionDescriptions());ye.deltaExtensions(re.toAdd,re.toRemove);const de=new n.$jm(B.getAllExtensionDescriptions().map(_=>_.identifier));for(const _ of re.myToRemove)de.delete(_);for(const _ of re.myToAdd)de.add(_);const ge=he(ye,de);return{globalRegistry:ye,myExtensions:ge}}function X(ce,K){return{id:ce.identifier.value,name:ce.name,extensionVersion:ce.version,publisherDisplayName:ce.publisher,activationEvents:ce.activationEvents?ce.activationEvents.join(","):null,isBuiltin:ce.isBuiltin,reason:K.activationEvent,reasonId:K.extensionId.value}}function J(ce){return ce.getAllExtensionDescriptions().map(K=>K.identifier.value).join(",")}e.$egc=(0,d.$3h)("IExtHostExtensionService");class x{#e;#t;#i;constructor(K,B,re,ye,de){this.#e=K,this.#t=B,this.#i=re.identifier,this.id=re.identifier.value,this.extensionUri=re.extensionLocation,this.extensionPath=N.$hc((0,I.$sg)(re.extensionLocation)),this.packageJSON=re,this.extensionKind=ye,this.isFromDifferentExtensionHost=de}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$fgc=x;function he(ce,K){return ce.getAllExtensionDescriptions().filter(B=>K.has(B.identifier))}class Z{constructor(K){this.a=K}setSearchTree(K){this.a=K}findSubstr(K){return this.a.findSubstr(K)}forEach(K){return this.a.forEach(K)}}e.$ggc=Z;class we{constructor(K){this.a=new n.$km,this.addActivationEvents(K)}readActivationEvents(K){return this.a.get(K.identifier)??[]}addActivationEvents(K){for(const B of Object.keys(K))this.a.set(B,K[B])}}}),define(Se[364],ke([1,0,57,2,6,42,25,26,20,27,5,48,13,12]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$ohc=void 0;let l=class{constructor(o,c,t,r,d,u,a){this.c=o,this.d=c,this.e=t,this.f=r,this.g=d,this.h=u,this.i=a,this.a=new Map,this.b=[]}async install(){this.j(),D.mark("code/extHost/willWaitForConfig");const o=await this.f.getConfigProvider();D.mark("code/extHost/didWaitForConfig");const c=await this.g.getExtensionPathIndex();this.register(new s(this.c,c,this.d,o,this.i)),this.register(this.e.createInstance(f)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,c,this.h.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const c of o.nodeModuleName)this.a.set(c,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(c=>o.alternativeModuleName(c))}};e.$ohc=l,e.$ohc=l=Ge([We(2,A.$2h),We(3,I.$Ffc),We(4,C.$egc),We(5,y.$$M),We(6,m.$kj)],l);let f=class{static{k=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&k.a.size){const c=(0,v.$Le)(this.c(o.environment.appRoot.fsPath)),t="[a-z0-9_.-]",r=`@${t}+\\/${t}+|${t}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${c}/${d}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const c=this.b.exec(this.c(o));if(!c)return;const[,t,r,d]=c,u=k.a.get(r);if(u!==void 0)return console.warn(`${r} as been renamed to ${u}, please update your imports`),t+u+d}c(o){return o.replace(/\\/g,"/")}};f=k=Ge([We(0,y.$$M)],f);class s{constructor(o,c,t,r,d){this.c=o,this.d=c,this.e=t,this.f=r,this.g=d,this.nodeModuleName="vscode",this.a=new b.$km}load(o,c){const t=this.d.findSubstr(c);if(t){let r=this.a.get(t.identifier);return r||(r=this.c(t,this.e,this.f),this.a.set(t.identifier,r)),r}if(!this.b){let r="";this.d.forEach((d,u)=>r+=`	${u} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${c}. These are the extension path mappings: 
${r}`),this.b=this.c(R.$jF,this.e,this.f)}return this.b}}let i=class{constructor(o,c,t){this.e=o,this.f=c,this.nodeModuleName=["open","opn"],this.d=t.getProxy(g.$QK.MainThreadTelemetry);const r=t.getProxy(g.$QK.MainThreadWindow);this.c=(d,u)=>{const a=N.URI.parse(d);return u?this.g(d,u):a.scheme==="http"||a.scheme==="https"?r.$openUri(a,d,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this.f?r.$openUri(a,d,{}):this.g(d,u)}}load(o,c,t){const r=this.e.findSubstr(c);return r&&(this.a=r.identifier.value,this.h()),this.b=t(o),this.c}g(o,c){return this.i(),this.b(o,c)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Ge([We(2,$.$UM)],i)}),define(Se[59],ke([1,0,43,3,16,50,5,69,70,48,7,41,290,42]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=e.$hgc=void 0,e.$hgc=(0,R.$3h)("IExtHostVariableResolverProvider");class k extends m.$VN{constructor(s,i,n,o,c,t,r){function d(){if(n){const u=n.activeEditor();if(u)return u.document.uri;const a=o.tabGroups.all.find(h=>h.isActive)?.activeTab;if(a!==void 0){if(a.input instanceof A.$zM||a.input instanceof A.$EM)return a.input.modified;if(a.input instanceof A.$yM||a.input instanceof A.$DM||a.input instanceof A.$BM)return a.input.uri}}}super({getFolderUri:u=>{const a=t.folders.filter(h=>h.name===u);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(u,a)=>c.getConfiguration(void 0,u).get(a),getAppRoot:()=>I.cwd(),getExecPath:()=>I.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=d();if(u)return g.$hc(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const u=d();if(u){const a=i.getWorkspaceFolder(u);if(a)return g.$hc(a.uri.fsPath)}}},getSelectedText:()=>{if(n){const u=n.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(n){const u=n.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>s.getExtension(u)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(I.env))}}let l=class extends N.$Sc{constructor(s,i,n,o,c){super(),this.b=s,this.c=i,this.g=n,this.h=o,this.j=c,this.a=new D.$V(async()=>{const t=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new k(this.b,this.c,this.g,this.j,t,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$igc=l,e.$igc=l=Ge([We(0,y.$egc),We(1,C.$Cfc),We(2,b.$6M),We(3,v.$Ffc),We(4,$.$Rfc)],l)}),define(Se[96],ke([1,0,11,4,2,5,6,70,48,20,7,41,140,282,42,59]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=e.$mgc=e.$lgc=e.$kgc=e.$jgc=void 0,e.$jgc=(0,I.$3h)("IExtHostDebugService");let f=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,d,u,a,h,S){this.E=d,this.F=u,this.G=a,this.H=h,this.I=S,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new N.$Sd,this.n=new N.$Sd,this.o=new N.$Sd,this.u=new N.$Sd,this.k=r.getProxy(R.$QK.MainThreadDebugService),this.y=new N.$Sd,this.A=new N.$Sd,this.v=new i(this.k),this.w=new Map,this.F.getExtensionRegistry().then(P=>{P.onDidChange(w=>{this.J(P)}),this.J(P)})}asDebugSourceUri(r,d){const u=r;if(typeof u.sourceReference=="number"&&u.sourceReference>0){let a=`debug:${encodeURIComponent(u.path||"")}`,h="?";return d&&(a+=`${h}session=${encodeURIComponent(d.id)}`,h="&"),a+=`${h}ref=${u.sourceReference}`,g.URI.parse(a)}else{if(u.path)return g.URI.file(u.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(r){const d=[];for(const u of r.getAllExtensionDescriptions())if(u.contributes){const a=u.contributes.debuggers;if(a&&a.length>0)for(const h of a)(0,v.$1F)(h)&&d.push(h.type)}this.k.$registerDebugTypes(d)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const r=[];return this.w.forEach(d=>r.push(d)),r}addBreakpoints(r){const d=r.filter(h=>{const S=h.id;return this.w.has(S)?!1:(this.w.set(S,h),!0)});this.U(d,[],[]);const u=[],a=new Map;for(const h of d)if(h instanceof A.$SL){let S=a.get(h.location.uri.toString());S||(S={type:"sourceMulti",uri:h.location.uri,lines:[]},a.set(h.location.uri.toString(),S),u.push(S)),S.lines.push({id:h.id,enabled:h.enabled,condition:h.condition,hitCondition:h.hitCondition,logMessage:h.logMessage,line:h.location.range.start.line,character:h.location.range.start.character})}else h instanceof A.$TL&&u.push({type:"function",id:h.id,enabled:h.enabled,hitCondition:h.hitCondition,logMessage:h.logMessage,condition:h.condition,functionName:h.functionName});return this.k.$registerBreakpoints(u)}removeBreakpoints(r){const d=r.filter(S=>this.w.delete(S.id));this.U([],d,[]);const u=d.filter(S=>S instanceof A.$SL).map(S=>S.id),a=d.filter(S=>S instanceof A.$TL).map(S=>S.id),h=d.filter(S=>S instanceof A.$UL).map(S=>S.id);return this.k.$unregisterBreakpoints(u,a,h)}startDebugging(r,d,u){return this.k.$startDebugging(r?r.uri:void 0,d,{parentSessionID:u.parentSession?u.parentSession.id:void 0,lifecycleManagedByParent:u.lifecycleManagedByParent,repl:u.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:u.noDebug,compact:u.compact,suppressSaveBeforeStart:u.suppressSaveBeforeStart,suppressDebugStatusbar:u.suppressDebugStatusbar??u.debugUI?.simple,suppressDebugToolbar:u.suppressDebugToolbar??u.debugUI?.simple,suppressDebugView:u.suppressDebugView??u.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,d,u){if(!d)return new A.$SK(()=>{});const a=this.d++;return this.f.push({type:r,handle:a,provider:d}),this.k.$registerDebugConfigurationProvider(r,u,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,a),new A.$SK(()=>{this.f=this.f.filter(h=>h.provider!==d),this.k.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(r,d,u){if(!u)return new A.$SK(()=>{});if(!this.Q(r,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.N(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this.g++;return this.h.push({type:d,handle:a,factory:u}),this.k.$registerDebugAdapterDescriptorFactory(d,a),new A.$SK(()=>{this.h=this.h.filter(h=>h.factory!==u),this.k.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(r,d){if(!d)return new A.$SK(()=>{});const u=this.i++;return this.j.push({type:r,handle:u,factory:d}),new A.$SK(()=>{this.j=this.j.filter(a=>a.factory!==d)})}async $runInTerminal(r,d){return Promise.resolve(void 0)}async $substituteVariables(r,d){let u;const a=await this.W(r);return a&&(u={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(u,d)}K(r,d){if(r.type==="implementation")return new o(r.implementation)}L(){}async $startDASession(r,d){const u=this,a=await this.V(d);return this.S(this.N(a.type),a).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const S=this.M(h),P=this.K(S,a);if(!P)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const w=P;return this.B.set(r,w),this.R(a).then(p=>(p&&this.C.set(r,p),w.onMessage(async E=>{if(E.type==="request"&&E.command==="handshake"){const L=E,T={type:"response",seq:0,command:L.command,request_seq:L.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const U=await this.D.sign(L.arguments.value);T.body={signature:U},w.sendResponse(T)}else throw new Error("no signer")}catch(U){T.success=!1,T.message=U.message,w.sendResponse(T)}}else p&&p.onDidSendMessage&&p.onDidSendMessage(E),E=(0,v.$6F)(E,!0),u.k.$acceptDAMessage(r,E)}),w.onError(E=>{p&&p.onError&&p.onError(E),this.k.$acceptDAError(r,E.name,E.message,E.stack)}),w.onExit(E=>{p&&p.onExit&&p.onExit(E??void 0,void 0),this.k.$acceptDAExit(r,E??void 0,void 0)}),p&&p.onWillStartSession&&p.onWillStartSession(),w.startSession()))})}$sendDAMessage(r,d){d=(0,v.$5F)(d,!1);const u=this.C.get(r);u&&u.onWillReceiveMessage&&u.onWillReceiveMessage(d),this.B.get(r)?.sendMessage(d)}$stopDASession(r){const d=this.C.get(r);this.C.delete(r),d&&d.onWillStopSession&&d.onWillStopSession();const u=this.B.get(r);return this.B.delete(r),u?u.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const d=[],u=[],a=[];if(r.added)for(const h of r.added){const S=h.id;if(S&&!this.w.has(S)){let P;if(h.type==="function")P=new A.$TL(h.functionName,h.enabled,h.condition,h.hitCondition,h.logMessage);else if(h.type==="data")P=new A.$UL(h.label,h.dataId,h.canPersist,h.enabled,h.hitCondition,h.condition,h.logMessage);else{const w=g.URI.revive(h.uri);P=new A.$SL(new A.$5K(w,new A.$TK(h.line,h.character)),h.enabled,h.condition,h.hitCondition,h.logMessage)}(0,A.$QL)(P,S),this.w.set(S,P),d.push(P)}}if(r.removed)for(const h of r.removed){const S=this.w.get(h);S&&(this.w.delete(h),u.push(S))}if(r.changed){for(const h of r.changed)if(h.id){const S=this.w.get(h.id);if(S){if(S instanceof A.$TL&&h.type==="function"){const P=S;P.enabled=h.enabled,P.condition=h.condition,P.hitCondition=h.hitCondition,P.logMessage=h.logMessage,P.functionName=h.functionName}else if(S instanceof A.$SL&&h.type==="source"){const P=S;P.enabled=h.enabled,P.condition=h.condition,P.hitCondition=h.hitCondition,P.logMessage=h.logMessage,P.location=new A.$5K(g.URI.revive(h.uri),new A.$TK(h.line,h.character))}a.push(S)}}}this.U(d,u,a)}async $acceptStackFrameFocus(r){let d;const u=r.sessionId?await this.V(r.sessionId):void 0;if(!u)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?d=new A.$1L(u,r.threadId):d=new A.$ZL(u,r.threadId,r.frameId),this.z=d,this.A.fire(this.z)}$provideDebugConfigurations(r,d,u){return(0,D.$Vg)(async()=>{const a=this.P(r);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const h=await this.W(d);return a.provideDebugConfigurations(h,u)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(r,d,u,a){return(0,D.$Vg)(async()=>{const h=this.P(r);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const S=await this.W(d);return h.resolveDebugConfiguration(S,u,a)})}$resolveDebugConfigurationWithSubstitutedVariables(r,d,u,a){return(0,D.$Vg)(async()=>{const h=this.P(r);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const S=await this.W(d);return h.resolveDebugConfigurationWithSubstitutedVariables(S,u,a)})}async $provideDebugAdapter(r,d){const u=this.O(r);if(!u)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.V(d);return this.S(u,a).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.M(h)})}async $acceptDebugSessionStarted(r){const d=await this.V(r);this.m.fire(d)}async $acceptDebugSessionTerminated(r){const d=await this.V(r);d&&(this.n.fire(d),this.l.delete(d.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,d){(await this.V(r))?._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(r,d){const a={session:await this.V(r),event:d.event,body:d.body};this.u.fire(a)}M(r){if(r instanceof A.$VL)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof A.$WL)return{type:"server",port:r.port,host:r.host};if(r instanceof A.$XL)return{type:"pipeServer",path:r.path};if(r instanceof A.$YL)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}N(r){const d=this.h.filter(u=>u.type===r);if(d.length>0)return d[0].factory}O(r){const d=this.h.filter(u=>u.handle===r);if(d.length>0)return d[0].factory}P(r){const d=this.f.filter(u=>u.handle===r);if(d.length>0)return d[0].provider}Q(r,d){if(r.contributes){const u=r.contributes.debuggers;if(u&&u.length>0){for(const a of u)if(a.label&&a.type&&a.type===d)return!0}}return!1}R(r){const u=r.configuration.type,a=this.j.filter(h=>h.type===u||h.type==="*").map(h=>(0,D.$Vg)(()=>h.factory.createDebugAdapterTracker(r)).then(S=>S,S=>null));return Promise.race([Promise.all(a).then(h=>{const S=h.filter(P=>!!P);if(S.length>0)return new n(S)}),new Promise(h=>setTimeout(()=>h(void 0),1e3))]).catch(h=>{})}async S(r,d){const u=d.configuration.debugServer;if(typeof u=="number")return Promise.resolve(new A.$WL(u));if(r){const h=await this.F.getExtensionRegistry();return(0,D.$Vg)(()=>r.createDebugAdapterDescriptor(d,this.T(d,h))).then(S=>{if(S)return S})}const a=await this.F.getExtensionRegistry();return Promise.resolve(this.T(d,a))}T(r,d){}U(r,d,u){(r.length>0||d.length>0||u.length>0)&&this.y.fire(Object.freeze({added:r,removed:d,changed:u}))}async V(r){if(r)if(typeof r=="string"){const d=this.l.get(r);if(d)return d}else{let d=this.l.get(r.id);if(!d){const u=await this.W(r.folderUri),a=r.parent?this.l.get(r.parent):void 0;d=new s(this.k,r.id,r.type,r.name,u,r.configuration,a),this.l.set(d.id,d),this.k.$sessionCached(d.id)}return d}throw new Error("cannot find session")}W(r){if(r){const d=g.URI.revive(r);return this.E.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};e.$kgc=f,e.$kgc=f=Ge([We(0,y.$UM),We(1,C.$Cfc),We(2,$.$egc),We(3,k.$Ffc),We(4,b.$Rfc),We(5,l.$hgc)],f);class s{constructor(r,d,u,a,h,S,P){this.d=r,this.f=d,this.g=u,this.h=a,this.i=h,this.j=S,this.k=P}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,d){return this.d.$customDebugAdapterRequest(this.f,r,d)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.$lgc=s;class i{constructor(r){this.value=Object.freeze({append(d){r.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.$mgc=i;class n{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(d=>d.onError?d.onError(r):void 0)}onExit(r,d){this.d.forEach(u=>u.onExit?u.onExit(r,d):void 0)}}class o extends m.$xlb{constructor(r){super(),this.h=r,r.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let c=class extends f{constructor(r,d,u,a,h,S){super(r,d,u,a,h,S)}};e.$ngc=c,e.$ngc=c=Ge([We(0,y.$UM),We(1,C.$Cfc),We(2,$.$egc),We(3,k.$Ffc),We(4,b.$Rfc),We(5,l.$hgc)],c)}),define(Se[365],ke([1,0,14,57,2,6,353,13,106,107,27,248,20,66,48,90]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qhc=e.$phc=void 0;class f{static async installEarlyHandler(n){Error.stackTraceLimit=100;const o=n.get(b.$kj),t=n.get(m.$UM).getProxy(I.$QK.MainThreadErrors);D.setUnexpectedErrorHandler(r=>{o.error(r);const d=D.$3(r);t.$onUnexpectedError(d)})}static async installFullHandler(n){const o=n.get(b.$kj),c=n.get(m.$UM),t=n.get(k.$egc),r=n.get(l.$cN),d=c.getProxy(I.$QK.MainThreadExtensionService),u=c.getProxy(I.$QK.MainThreadErrors),a=await t.getExtensionPathIndex(),h=new WeakMap;function S(p,E){if(h.has(p))return h.get(p).stack;let L="",T,U;for(const j of E)L+=`
	at ${j.toString()}`,U=j.getFileName(),!T&&U&&(T=a.findSubstr(g.URI.file(U)));const F=`${p.name||"Error"}: ${p.message||""}${L}`;return h.set(p,{extensionIdentifier:T?.identifier,stack:F}),F}const P=Symbol("prepareStackTrace wrapped");let w=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return w},set(p){if(p===S||!p||p[P]){w=p||S;return}w=function(E,L){return S(E,L),p.call(Error,E,L)},Object.assign(w,{[P]:!0})}}),D.setUnexpectedErrorHandler(p=>{o.error(p);const E=D.$3(p),L=h.get(p);if(!L?.extensionIdentifier){u.$onUnexpectedError(E);return}d.$onExtensionRuntimeError(L.extensionIdentifier,E);const T=r.onExtensionError(L.extensionIdentifier,p);o.trace("forwarded error to extension?",T,L)})}}e.$phc=f;class s{constructor(n,o,c,t,r){this.a=c,this.b=new R.$x7b(n,null,t),o=s.e(o,this.b);const d=new y.$1h(...(0,$.$Mr)());d.set(A.$$M,{_serviceBrand:void 0,...o,messagePorts:r}),d.set(m.$UM,new m.$VM(this.b)),d.set(v.$zfc,new v.$Afc(t)),d.set(k.$cgc,c);const u=new C.$sq(d,!0);u.invokeFunction(f.installEarlyHandler),this.d=u.invokeFunction(a=>a.get(b.$kj)),N.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=u.invokeFunction(a=>a.get(k.$egc)),this.c.initialize(),u.invokeFunction(f.installFullHandler)}async asBrowserUri(n){const o=this.b.getProxy(I.$QK.MainThreadExtensionService);return g.URI.revive(await o.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,o){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=g.URI.revive(o.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=g.URI.revive(o.transformIncomingURIs(n.environment.appRoot));const c=n.environment.extensionDevelopmentLocationURI;return c&&(n.environment.extensionDevelopmentLocationURI=c.map(t=>g.URI.revive(o.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=g.URI.revive(o.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=g.URI.revive(o.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=g.URI.revive(o.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=g.URI.revive(o.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=g.URI.revive(o.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=g.URI.revive(o.transformIncomingURIs(n.logsLocation)),n.workspace=o.transformIncomingURIs(n.workspace),n}}e.$qhc=s}),define(Se[366],ke([1,0,11,10,223,242,138,96,70,48,20,47,7,59,41,283,284,42]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ahc=void 0;let i=class extends b.$kgc{constructor(r,d,u,a,h,S,P){super(r,d,u,a,S,P),this.Z=h,this.X=new c}K(r,d){switch(r.type){case"server":return new l.$vhc(r);case"pipeServer":return new l.$whc(r);case"executable":return new l.$xhc(r,d.type)}return super.K(r,d)}T(r,d){const u=l.$xhc.platformAdapterExecutable(d.getAllExtensionDescriptions(),r.type);if(u)return new m.$VL(u.command,u.args,u.options)}L(){return new R.$k$b}async $runInTerminal(r,d){if(r.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(F=>{this.X.onTerminalClosed(F)}));const u=await this.G.getConfigProvider(),a=this.Z.getDefaultShell(!0),h=this.Z.getDefaultShellArgs(!0),S=r.title||g.localize(0,null),P=JSON.stringify({shell:a,shellArgs:h});let w=await this.X.checkout(P,S),p,E=!1;if(w)p=r.cwd;else{const F={shellPath:a,shellArgs:h,cwd:r.cwd,name:S,iconPath:new m.$NL("debug")};E=!0,w=this.Z.createTerminalFromOptions(F,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(w,P)}w.show(!0);const L=await w.processId;E?await new Promise(F=>setTimeout(F,1e3)):u.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0||a.indexOf("cmd.exe")>=0?w.sendText("cls"):a.indexOf("bash")>=0?w.sendText("clear"):N.$i?w.sendText("cls"):w.sendText("clear"));const T=(0,f.$zhc)(a,r.args,!!r.argsCanBeInterpretedByShell,p,r.env);w.sendText(T);const U=this.onDidTerminateDebugSession(F=>{F.id===d&&(this.X.free(w),U.dispose())});return L}else if(r.kind==="external")return o(r,await this.G.getConfigProvider());return super.$runInTerminal(r,d)}};e.$Ahc=i,e.$Ahc=i=Ge([We(0,A.$UM),We(1,k.$Cfc),We(2,y.$egc),We(3,s.$Ffc),We(4,C.$4fc),We(5,$.$Rfc),We(6,v.$hgc)],i);let n;function o(t,r){if(!n)if(N.$i)n=new I.$99b;else if(N.$j)n=new I.$09b;else if(N.$k)n=new I.$$9b;else throw new Error("external terminals not supported on this platform");const d=r.getConfiguration("terminal");return n.runInTerminal(t.title,t.cwd,t.args,t.env||{},d.external||{})}class c{constructor(){this.b=new Map}static{this.a=1e3}async checkout(r,d){const a=[...this.b.entries()].map(([h,S])=>(0,D.$Qg)(async P=>{if(h.name!==d||S.lastUsedAt!==-1&&await(0,f.$yhc)(await h.processId))return null;const w=Date.now();return S.lastUsedAt+c.a>w||P.isCancellationRequested||S.config!==r?null:(S.lastUsedAt=w,h)}));return await(0,D.$8g)(a,h=>!!h)}insert(r,d){this.b.set(r,{lastUsedAt:Date.now(),config:d})}free(r){const d=this.b.get(r);d&&(d.lastUsedAt=-1)}onTerminalClosed(r){this.b.delete(r)}}}),define(Se[367],ke([1,0,16,2,104,41,69,42,40,47,20,27,95,17,13,91,23,63,59]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l,f,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$shc=void 0;let n=class extends m.$7gc{constructor(c,t,r,d,u,a,h,S,P){super(c,t,r,d,u,a,h,S),this.C=r,this.D=P,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(v.Schemas.file,{scheme:v.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(c,t){const r=t;if(!t.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const d=m.TaskHandleDTO.from(r,this.C),u=await this.a.$getTaskExecution(d);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const a=await this.z(u,t);return this.a.$executeTask(d).catch(()=>{}),a}else{const d=m.TaskDTO.from(t,c);if(d===void 0)return Promise.reject(new Error("Task is not valid"));m.CustomExecutionDTO.is(d.execution)&&await this.y(d,t,!1);const u=await this.z(await this.a.$getTaskExecution(d),t);return this.a.$executeTask(d).catch(()=>{}),u}}v(c,t,r,d){const u=[];if(d)for(const a of d){this.A(a,r),(!a.definition||!c[a.definition.type])&&this.f.warn(`The task [${a.source}, ${a.name}] uses an undefined task type. The task will be ignored in the future.`);const h=m.TaskDTO.from(a,r.extension);h&&(u.push(h),m.CustomExecutionDTO.is(h.execution)&&t.push(this.y(h,a,!0)))}return{tasks:u,extension:r.extension}}async w(c){return c}async G(c){let t=c&&c.length>0?c[0]:void 0;if(!t){const r=N.URI.file((0,s.homedir)());t=new $.$ki({uri:r,name:f.$Bg(r),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(c,t){const r=N.URI.revive(c),d={process:void 0,variables:Object.create(null)},u=await this.b.resolveWorkspaceFolder(r),a=await this.b.getWorkspaceFolders2()??[],h=await this.D.getResolver(),S=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(a);for(const P of t.variables)d.variables[P]=await h.resolveAsync(S,P);if(t.process!==void 0){let P;if(t.process.path!==void 0){P=t.process.path.split(D.$tc);for(let w=0;w<P.length;w++)P[w]=await h.resolveAsync(S,P[w])}d.process=await g.win32.findExecutable(await h.resolveAsync(S,t.process.name),t.process.cwd!==void 0?await h.resolveAsync(S,t.process.cwd):void 0,P)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(c,t,r){return g.win32.findExecutable(c,t,r)}};e.$shc=n,e.$shc=n=Ge([We(0,A.$UM),We(1,C.$$M),We(2,I.$Cfc),We(3,R.$6M),We(4,b.$Ffc),We(5,y.$4fc),We(6,k.$kj),We(7,l.$kfc),We(8,i.$hgc)],n)}),define(Se[368],ke([1,0,63,59]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=void 0;class g extends N.$igc{m(){return(0,D.homedir)()}}e.$$hc=g}),define(Se[154],ke([1,0,19,11,21,44,17,16,23,2,36]),function(me,e,D,N,g,I,R,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=e.$Dgc=e.$Cgc=e.$Bgc=void 0;class C{constructor(i,n,o,c){this.d=i,this.e=n,this.f=o,this.g=c,this.a=null,this.b=!1,this.c=0}search(i,n){const o=this.d.folderQueries||[],c=new g.$3d(n);return new Promise((t,r)=>{this.a=new v(i);let d=!1;const u=(a,h)=>{if(!d&&!this.b){const S=this.h(a);l(a)&&typeof this.d.maxResults=="number"&&this.c+S>this.d.maxResults&&(this.b=!0,d=!0,c.cancel(),a=this.j(a,this.d.maxResults-this.c));const P=this.h(a);this.c+=P,(P>0||!l(a))&&this.a.add(a,h)}};Promise.all(o.map((a,h)=>this.k(a,S=>u(S,h),c.token))).then(a=>{c.dispose(),this.a.flush();const h=a.some(S=>!!S&&!!S.limitHit);t({limitHit:this.b||h,messages:(0,D.$Rb)(a.map(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[])),stats:{type:this.g}})},a=>{c.dispose();const h=(0,I.$Ni)(a);r(new Error(h))})})}h(i){return l(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const o=Array.isArray(i.ranges)?i.ranges:[i.ranges],c=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:o.slice(0,n),preview:{matches:c.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,o){const c=new A.$uJ(this.d,i),t=[],r={report:a=>{if(!this.l(a))return;const h=i.folder.scheme===R.Schemas.file?(0,A.$vJ)(()=>this.f.readdir($.$Dg(a.uri))):void 0,S=$.$Gg(i.folder,a.uri);if(S){const P=c.includedInQuery(S,b.$nc(S),h);(0,N.$Pg)(P)?t.push(P.then(w=>{w&&n(a)})):P&&n(a)}}},d=this.n(i),u=await this.e.provideTextSearchResults(m(this.d.contentPattern),d,r,o);return t.length&&await Promise.all(t),u}l(i){if(l(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,A.$tJ)(this.d.includePattern,i.includePattern),o=(0,A.$tJ)(this.d.excludePattern,i.excludePattern),c={folder:y.URI.from(i.folder),excludes:o,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return c.usePCRE2=this.d.usePCRE2,c}}e.$Bgc=C;function m(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class v{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new f(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!$.$xg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(k(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$Cgc=v;function k(s){return l(s)?{preview:{matches:(0,D.$2b)(s.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:s.preview.text},ranges:(0,D.$2b)(s.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function l(s){return!!s.preview}e.$Dgc=l;class f{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<f.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},f.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Egc=f}),define(Se[97],ke([1,0,3,6,5,361,20,66,13,2,154]),function(me,e,D,N,g,I,R,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hgc=e.$Ggc=e.$Fgc=void 0,e.$Fgc=(0,g.$3h)("IExtHostSearch");let C=class{constructor(l,f,s){this.k=l,this.l=f,this.n=s,this.c=this.k.getProxy(N.$QK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new I.$Agc}o(l){return this.l.transformOutgoingScheme(l)}registerTextSearchProvider(l,f){if(this.g.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this.g.add(l);const s=this.d++;return this.e.set(s,f),this.c.$registerTextSearchProvider(s,this.o(l)),(0,D.$Qc)(()=>{this.g.delete(l),this.e.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(l,f){if(this.i.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this.i.add(l);const s=this.d++;return this.h.set(s,f),this.c.$registerFileSearchProvider(s,this.o(l)),(0,D.$Qc)(()=>{this.i.delete(l),this.h.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(l,f,s,i){const n=m(s),o=this.h.get(l);if(o)return this.j.fileSearch(n,o,c=>{this.c.$handleFileMatch(l,f,c.map(t=>t.resource))},i);throw new Error("unknown provider: "+l)}async doInternalFileSearchWithCustomCallback(l,f,s){return{messages:[]}}$clearCache(l){return this.j.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,f,s,i){const n=this.e.get(l);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown provider ${l}`);const o=m(s);return this.q(o,n).search(t=>this.c.$handleTextMatch(l,f,t),i)}$enableExtensionHostSearch(){}q(l,f){return new A.$Bgc(l,f,{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}};e.$Ggc=C,e.$Ggc=C=Ge([We(0,R.$UM),We(1,b.$zfc),We(2,$.$kj)],C);function m(k){return{...k,folderQueries:k.folderQueries&&k.folderQueries.map(v),extraFileResources:k.extraFileResources&&k.extraFileResources.map(l=>y.URI.revive(l))}}e.$Hgc=m;function v(k){return{...k,folder:y.URI.revive(k.folder)}}}),define(Se[369],ke([1,0,21,14,4,3,17,39,2,132,191,172,79,26,32,13,65,87,267,6,305,313,91,306,307,308,309,310,311,312,288,35,314,42,344,96,149,316,317,318,294,319,69,70,320,48,321,71,322,58,27,323,324,325,326,327,328,115,116,329,360,296,273,297,330,331,152,332,298,333,334,20,335,97,117,336,337,338,118,92,95,90,47,339,340,285,341,299,72,15,7,342,66,343,93,345,346,151,41,281,114,25,94]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l,f,s,i,n,o,c,t,r,d,u,a,h,S,P,w,p,E,L,T,U,F,j,O,M,W,Y,ue,X,J,x,he,Z,we,ce,K,B,re,ye,de,ge,_,ie,G,te,fe,ve,Pe,be,De,z,Q,ee,V,oe,le,Re,je,He,Je,_e,ct,ot,rt,Ae,Ue,Le,Xe,ne,ae,Ie,Ve,Ze,nt,it,Oe,wt,kt,Tt,Wt,Et,Kt,Ot,Zt,Ut,Lt,et,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=void 0;function Jt(ht){const bt=ht.get(K.$$M),zt=ht.get(ce.$hfc),qt=ht.get(Z.$Hfc),Dt=ht.get(x.$egc),ft=ht.get(Zt.$Cfc),At=ht.get(Le.$cN),xt=ht.get(L.$Ffc),Ct=ht.get(kt.$zfc),Qe=ht.get(Re.$UM),Mt=ht.get(rt.$1fc),Vt=ht.get(Ae.$Ifc),Qt=ht.get(l.$lj),gt=ht.get(l.$kj),Nt=ht.get(nt.$cyb),Fe=ht.get(t.$kfc),Te=ht.get(Ot.$jhc),Ce=ht.get(Je.$9fc),se=ht.get(X.$Rfc),Ne=ht.get(G.$agc);Qe.set(n.$RK.ExtHostFileSystemInfo,zt),Qe.set(n.$RK.ExtHostLogLevelServiceShape,Qt),Qe.set(n.$RK.ExtHostWorkspace,ft),Qe.set(n.$RK.ExtHostConfiguration,xt),Qe.set(n.$RK.ExtHostExtensionService,Dt),Qe.set(n.$RK.ExtHostStorage,Mt),Qe.set(n.$RK.ExtHostTunnelService,Nt),Qe.set(n.$RK.ExtHostWindow,Te),Qe.set(n.$RK.ExtHostSecretState,Ce),Qe.set(n.$RK.ExtHostTelemetry,At),Qe.set(n.$RK.ExtHostEditorTabs,se),Qe.set(n.$RK.ExtHostManagedSockets,Ne);const qe=Qe.set(n.$RK.ExtHostDecorations,ht.get(F.$pgc)),xe=Qe.set(n.$RK.ExtHostDocumentsAndEditors,ht.get(ue.$6M)),Ke=Qe.set(n.$RK.ExtHostCommands,ht.get(p.$eN)),st=Qe.set(n.$RK.ExtHostTerminalService,ht.get(Xe.$4fc)),$t=Qe.set(n.$RK.ExtHostDebugService,ht.get(U.$jgc)),Bt=Qe.set(n.$RK.ExtHostSearch,ht.get(He.$Fgc)),St=Qe.set(n.$RK.ExtHostTask,ht.get(Ue.$9gc)),It=Qe.set(n.$RK.ExtHostOutputService,ht.get(Q.$Vgc)),yt=Qe.set(n.$RK.ExtHostLocalization,ht.get(ie.$_fc)),gi=Qe.set(n.$RK.ExtHostUrls,new Tt.$ghc(Qe)),Rt=Qe.set(n.$RK.ExtHostDocuments,new Y.$ffc(Qe,xe)),Di=Qe.set(n.$RK.ExtHostDocumentContentProviders,new M.$rgc(Qe,xe,gt)),Ki=Qe.set(n.$RK.ExtHostDocumentSaveParticipant,new W.$sgc(gt,Rt,Qe.getProxy(n.$QK.MainThreadBulkEdits))),Pt=Qe.set(n.$RK.ExtHostNotebook,new fe.$Igc(Qe,Ke,xe,Rt,qt,Bt)),ri=Qe.set(n.$RK.ExtHostNotebookDocuments,new Pe.$Pgc(Pt)),mi=Qe.set(n.$RK.ExtHostNotebookEditors,new be.$Qgc(gt,Pt)),ci=Qe.set(n.$RK.ExtHostNotebookKernels,new De.$Rgc(Qe,bt,Pt,Ke,gt)),Ci=Qe.set(n.$RK.ExtHostNotebookRenderers,new z.$Tgc(Qe,Pt)),Ii=Qe.set(n.$RK.ExtHostNotebookDocumentSaveParticipant,new ve.$Ogc(gt,Pt,Qe.getProxy(n.$QK.MainThreadBulkEdits))),jt=Qe.set(n.$RK.ExtHostEditors,new ae.$wfc(Qe,xe)),$i=Qe.set(n.$RK.ExtHostTreeViews,new Ze.$ehc(Qe.getProxy(n.$QK.MainThreadTreeViews),Ke,gt)),Pi=Qe.set(n.$RK.ExtHostEditorInsets,new w.$xfc(Qe.getProxy(n.$QK.MainThreadEditorInsets),jt,bt.remote)),ui=Qe.set(n.$RK.ExtHostDiagnostics,new j.$jfc(Qe,gt,zt,xe)),li=Qe.set(n.$RK.ExtHostLanguages,new _.$Mgc(Qe,Rt,Ke.converter,Ct)),dt=Qe.set(n.$RK.ExtHostLanguageFeatures,new ge.$nfc(Qe,Ct,Rt,Ke,ui,gt,Fe,At)),Gi=Qe.set(n.$RK.ExtHostFileSystem,new he.$ugc(Qe,dt)),_t=Qe.set(n.$RK.ExtHostFileSystemEventService,new we.$vgc(Qe,gt,xe)),si=Qe.set(n.$RK.ExtHostQuickOpen,(0,le.$Zgc)(Qe,ft,Ke)),bi=Qe.set(n.$RK.ExtHostSCM,new je.$2gc(Qe,Ke,Rt,gt)),Ai=Qe.set(n.$RK.ExtHostQuickDiff,new oe.$Ygc(Qe,Ct)),Ji=Qe.set(n.$RK.ExtHostShare,new _e.$3gc(Qe,Ct)),Li=Qe.set(n.$RK.ExtHostComments,(0,E.$yfc)(Qe,Ke,Rt)),pi=Qe.set(n.$RK.ExtHostProgress,new V.$Xgc(Qe.getProxy(n.$QK.MainThreadProgress))),Qi=Qe.set(n.$RK.ExtHostLabelService,new de.$Lgc(Qe)),Ri=Qe.set(n.$RK.ExtHostTheming,new Ie.$bhc(Qe)),hi=Qe.set(n.$RK.ExtHostAuthentication,new r.$pfc(Qe)),Zi=Qe.set(n.$RK.ExtHostTimeline,new Ve.$dhc(Qe,Ke)),wi=Qe.set(n.$RK.ExtHostWebviews,new Wt.$Mfc(Qe,bt.remote,ft,gt,Fe)),Fi=Qe.set(n.$RK.ExtHostWebviewPanels,new Et.$Pfc(Qe,wi,ft)),cn=Qe.set(n.$RK.ExtHostCustomEditors,new T.$Qfc(Qe,Rt,Vt,wi,Fi)),Mi=Qe.set(n.$RK.ExtHostWebviewViews,new Kt.$hhc(Qe,wi)),oi=Qe.set(n.$RK.ExtHostTesting,new ne.$0gc(Qe,gt,Ke,xe)),un=Qe.set(n.$RK.ExtHostUriOpeners,new wt.$fhc(Qe)),ln=Qe.set(n.$RK.ExtHostProfileContentHandlers,new ee.$Wgc(Qe));Qe.set(n.$RK.ExtHostInteractive,new re.$Jgc(Qe,Pt,xe,Ke,gt));const Xi=Qe.set(n.$RK.ExtHostInlineChat,new B.$wgc(Qe,Ke,Rt,gt)),di=Qe.set(n.$RK.ExtHostChatProvider,new h.$sfc(Qe,gt)),Yi=Qe.set(n.$RK.ExtHostChatAgents2,new a.$tfc(Qe,di,gt)),xi=Qe.set(n.$RK.ExtHostChatVariables,new S.$ufc(Qe)),vi=Qe.set(n.$RK.ExtHostChat,new u.$rfc(Qe)),_i=Qe.set(n.$RK.ExtHostAiRelatedInformation,new o.$efc(Qe)),Ni=Qe.set(n.$RK.ExtHostAiEmbeddingVector,new J.$tgc(Qe)),Ti=Qe.set(n.$RK.ExtHostIssueReporter,new ye.$Kgc(Qe)),ei=Qe.set(n.$RK.ExtHostStatusBar,new ot.$6gc(Qe,Ke.converter)),yi=Qe.set(n.$RK.ExtHostSpeech,new ct.$4gc(Qe)),hn=Object.values(n.$RK);Qe.assertRegistered(hn);const Xt=new d.$qfc(Qe,xe),Ei=new P.$vfc(Qe),Si=new te.$Ngc(Qe,gt),Oi=new O.$qgc(Qe);return c.$ofc.register(Ke),function(Be,ti,en){function at($e){return(Ee,ze,ut)=>{const vt=$e(Ft=>{try{Ee.call(ze,Ft)}catch(an){N.$2(new Error(`[ExtensionListenerError] Extension '${Be.identifier.value}' FAILED to handle event`,{cause:an})),At.onExtensionError(Be.identifier,an)}});return ut?.push(vt),vt}}const pt=function(){let $e=!Be.isUnderDevelopment;function Ee(){$e||(gt.info(`Extension '${Be.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),$e=!0)}return function ze(ut){if(Array.isArray(ut))ut.forEach(ze);else if(typeof ut=="string")Ee();else{const vt=ut;typeof vt.scheme>"u"&&Ee(),typeof vt.exclusive=="boolean"&&(0,et.$pF)(Be,"documentFiltersExclusive")}return ut}}(),dn={getSession($e,Ee,ze){return hi.getSession(Be,$e,Ee,ze)},getSessions($e,Ee){return(0,et.$pF)(Be,"authGetSessions"),hi.getSessions(Be,$e,Ee)},async hasSession($e,Ee){return(0,et.$pF)(Be,"authSession"),!!await hi.getSession(Be,$e,Ee,{silent:!0})},get onDidChangeSessions(){return at(hi.onDidChangeSessions)},registerAuthenticationProvider($e,Ee,ze,ut){return hi.registerAuthenticationProvider($e,Ee,ze,ut)}},fn={registerCommand($e,Ee,ze){return Ke.registerCommand(!0,$e,Ee,ze,void 0,Be)},registerTextEditorCommand($e,Ee,ze){return Ke.registerCommand(!0,$e,(...ut)=>{const vt=jt.getActiveTextEditor();if(!vt){gt.warn("Cannot execute "+$e+" because there is no active text editor.");return}return vt.edit(Ft=>{Ee.apply(ze,[vt,Ft,...ut])}).then(Ft=>{Ft||gt.warn("Edits from command "+$e+" were not applied.")},Ft=>{gt.warn("An error occurred while running command "+$e,Ft)})},void 0,void 0,Be)},registerDiffInformationCommand:($e,Ee,ze)=>((0,et.$pF)(Be,"diffCommand"),Ke.registerCommand(!0,$e,async(...ut)=>{const vt=xe.activeEditor(!0);if(!vt){gt.warn("Cannot execute "+$e+" because there is no active text editor.");return}const Ft=await jt.getDiffInformation(vt.id);Ee.apply(ze,[Ft,...ut])},void 0,void 0,Be)),executeCommand($e,...Ee){return Ke.executeCommand($e,...Ee)},getCommands($e=!1){return Ke.getCommands($e)}},ji={get machineId(){return bt.telemetryInfo.machineId},get sessionId(){return bt.telemetryInfo.sessionId},get language(){return bt.environment.appLanguage},get appName(){return bt.environment.appName},get appRoot(){return bt.environment.appRoot?.fsPath??""},get appHost(){return bt.environment.appHost},get uriScheme(){return bt.environment.appUriScheme},get clipboard(){return Ei.value},get shell(){return st.getDefaultShell(!1)},get onDidChangeShell(){return at(st.onDidChangeShell)},get isTelemetryEnabled(){return At.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return at(At.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.$pF)(Be,"telemetry"),At.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$pF)(Be,"telemetry"),at(At.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Le.$bN)(bt.telemetryInfo.firstSessionDate)},createTelemetryLogger($e,Ee){return Le.$aN.validateSender($e),At.instantiateLogger(Be,$e,Ee)},openExternal($e,Ee){return Te.openUri($e,{allowTunneling:!!bt.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri($e){if($e.scheme===bt.environment.appUriScheme)return gi.createAppUri($e);try{return await Te.asExternalUri($e,{allowTunneling:!!bt.remote.authority})}catch(Ee){if((0,R.$bg)($e,R.Schemas.http)||(0,R.$bg)($e,R.Schemas.https))return $e;throw Ee}},get remoteName(){return(0,f.$$k)(bt.remote.authority)},get remoteAuthority(){return(0,et.$pF)(Be,"resolvers"),bt.remote.authority},get uiKind(){return bt.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return at(gt.onDidChangeLogLevel)},registerIssueUriRequestHandler($e){return(0,et.$pF)(Be,"handleIssueUri"),Ti.registerIssueUriRequestHandler(Be,$e)},registerIssueDataProvider($e){return(0,et.$pF)(Be,"handleIssueUri"),Ti.registerIssueDataProvider(Be,$e)},get appQuality(){return(0,et.$pF)(Be,"resolvers"),bt.quality},get appCommit(){return(0,et.$pF)(Be,"resolvers"),bt.commit}};bt.environment.extensionTestsLocationURI||Object.freeze(ji);const Ui={createTestController($e,Ee,ze){return oi.createTestController(Be,$e,Ee,ze)},createTestObserver(){return(0,et.$pF)(Be,"testObserver"),oi.createTestObserver()},runTests($e){return(0,et.$pF)(Be,"testObserver"),oi.runTests($e)},get onDidChangeTestResults(){return(0,et.$pF)(Be,"testObserver"),at(oi.onResultsChanged)},get testResults(){return(0,et.$pF)(Be,"testObserver"),oi.results}},fi=bt.remote.isRemote?Oe.ExtensionKind.Workspace:Oe.ExtensionKind.UI,tn={getExtension($e,Ee){(0,et.$oF)(Be,"extensionsAny")||(Ee=!1);const ze=ti.mine.getExtensionDescription($e);if(ze)return new x.$fgc(Dt,Be.identifier,ze,fi,!1);if(Ee){const ut=ti.all.getExtensionDescription($e);if(ut)return new x.$fgc(Dt,Be.identifier,ut,fi,!0)}},get all(){const $e=[];for(const Ee of ti.mine.getAllExtensionDescriptions())$e.push(new x.$fgc(Dt,Be.identifier,Ee,fi,!1));return $e},get allAcrossExtensionHosts(){(0,et.$pF)(Be,"extensionsAny");const $e=new v.$jm(ti.mine.getAllExtensionDescriptions().map(ze=>ze.identifier)),Ee=[];for(const ze of ti.all.getAllExtensionDescriptions()){const ut=!$e.has(ze.identifier);Ee.push(new x.$fgc(Dt,Be.identifier,ze,fi,ut))}return Ee},get onDidChange(){return(0,et.$oF)(Be,"extensionsAny")?at(g.Event.any(ti.mine.onDidChange,ti.all.onDidChange)):at(ti.mine.onDidChange)}},nn={createDiagnosticCollection($e){return ui.createDiagnosticCollection(Be.identifier,$e)},get onDidChangeDiagnostics(){return at(ui.onDidChangeDiagnostics)},getDiagnostics:$e=>ui.getDiagnostics($e),getLanguages(){return li.getLanguages()},setTextDocumentLanguage($e,Ee){return li.changeLanguage($e.uri,Ee)},match($e,Ee){const ze=Rt.getDocumentData(Ee.uri)?.notebook;return(0,A.$pt)(it.LanguageSelector.from($e),Ee.uri,Ee.languageId,!0,ze?.uri,ze?.notebookType)},registerCodeActionsProvider($e,Ee,ze){return dt.registerCodeActionProvider(Be,pt($e),Ee,ze)},registerDocumentPasteEditProvider($e,Ee,ze){return(0,et.$pF)(Be,"documentPaste"),dt.registerDocumentPasteEditProvider(Be,pt($e),Ee,ze)},registerCodeLensProvider($e,Ee){return dt.registerCodeLensProvider(Be,pt($e),Ee)},registerDefinitionProvider($e,Ee){return dt.registerDefinitionProvider(Be,pt($e),Ee)},registerDeclarationProvider($e,Ee){return dt.registerDeclarationProvider(Be,pt($e),Ee)},registerImplementationProvider($e,Ee){return dt.registerImplementationProvider(Be,pt($e),Ee)},registerTypeDefinitionProvider($e,Ee){return dt.registerTypeDefinitionProvider(Be,pt($e),Ee)},registerHoverProvider($e,Ee){return dt.registerHoverProvider(Be,pt($e),Ee,Be.identifier)},registerEvaluatableExpressionProvider($e,Ee){return dt.registerEvaluatableExpressionProvider(Be,pt($e),Ee,Be.identifier)},registerInlineValuesProvider($e,Ee){return dt.registerInlineValuesProvider(Be,pt($e),Ee,Be.identifier)},registerDocumentHighlightProvider($e,Ee){return dt.registerDocumentHighlightProvider(Be,pt($e),Ee)},registerMultiDocumentHighlightProvider($e,Ee){return dt.registerMultiDocumentHighlightProvider(Be,pt($e),Ee)},registerLinkedEditingRangeProvider($e,Ee){return dt.registerLinkedEditingRangeProvider(Be,pt($e),Ee)},registerReferenceProvider($e,Ee){return dt.registerReferenceProvider(Be,pt($e),Ee)},registerRenameProvider($e,Ee){return dt.registerRenameProvider(Be,pt($e),Ee)},registerDocumentSymbolProvider($e,Ee,ze){return dt.registerDocumentSymbolProvider(Be,pt($e),Ee,ze)},registerWorkspaceSymbolProvider($e){return dt.registerWorkspaceSymbolProvider(Be,$e)},registerDocumentFormattingEditProvider($e,Ee){return dt.registerDocumentFormattingEditProvider(Be,pt($e),Ee)},registerDocumentRangeFormattingEditProvider($e,Ee){return dt.registerDocumentRangeFormattingEditProvider(Be,pt($e),Ee)},registerOnTypeFormattingEditProvider($e,Ee,ze,...ut){return dt.registerOnTypeFormattingEditProvider(Be,pt($e),Ee,[ze].concat(ut))},registerDocumentSemanticTokensProvider($e,Ee,ze){return dt.registerDocumentSemanticTokensProvider(Be,pt($e),Ee,ze)},registerDocumentRangeSemanticTokensProvider($e,Ee,ze){return dt.registerDocumentRangeSemanticTokensProvider(Be,pt($e),Ee,ze)},registerSignatureHelpProvider($e,Ee,ze,...ut){return typeof ze=="object"?dt.registerSignatureHelpProvider(Be,pt($e),Ee,ze):dt.registerSignatureHelpProvider(Be,pt($e),Ee,typeof ze>"u"?[]:[ze,...ut])},registerCompletionItemProvider($e,Ee,...ze){return dt.registerCompletionItemProvider(Be,pt($e),Ee,ze)},registerInlineCompletionItemProvider($e,Ee,ze){return Ee.handleDidShowCompletionItem&&(0,et.$pF)(Be,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,et.$pF)(Be,"inlineCompletionsAdditions"),ze&&(0,et.$pF)(Be,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(Be,pt($e),Ee,ze)},registerDocumentLinkProvider($e,Ee){return dt.registerDocumentLinkProvider(Be,pt($e),Ee)},registerColorProvider($e,Ee){return dt.registerColorProvider(Be,pt($e),Ee)},registerFoldingRangeProvider($e,Ee){return dt.registerFoldingRangeProvider(Be,pt($e),Ee)},registerSelectionRangeProvider($e,Ee){return dt.registerSelectionRangeProvider(Be,$e,Ee)},registerCallHierarchyProvider($e,Ee){return dt.registerCallHierarchyProvider(Be,$e,Ee)},registerTypeHierarchyProvider($e,Ee){return dt.registerTypeHierarchyProvider(Be,$e,Ee)},setLanguageConfiguration:($e,Ee)=>dt.setLanguageConfiguration(Be,$e,Ee),getTokenInformationAtPosition($e,Ee){return(0,et.$pF)(Be,"tokenInformation"),li.tokenAtPosition($e,Ee)},registerInlayHintsProvider($e,Ee){return dt.registerInlayHintsProvider(Be,$e,Ee)},createLanguageStatusItem($e,Ee){return li.createLanguageStatusItem(Be,$e,Ee)},registerDocumentDropEditProvider($e,Ee,ze){return dt.registerDocumentOnDropEditProvider(Be,$e,Ee,(0,et.$oF)(Be,"dropMetadata")?ze:void 0)}},gn={get activeTextEditor(){return jt.getActiveTextEditor()},get visibleTextEditors(){return jt.getVisibleTextEditors()},get activeTerminal(){return st.activeTerminal},get terminals(){return st.terminals},async showTextDocument($e,Ee,ze){const ut=await($.URI.isUri($e)?Promise.resolve(rn.openTextDocument($e)):Promise.resolve($e));return jt.showTextDocument(ut,Ee,ze)},createTextEditorDecorationType($e){return jt.createTextEditorDecorationType(Be,$e)},onDidChangeActiveTextEditor($e,Ee,ze){return at(jt.onDidChangeActiveTextEditor)($e,Ee,ze)},onDidChangeVisibleTextEditors($e,Ee,ze){return at(jt.onDidChangeVisibleTextEditors)($e,Ee,ze)},onDidChangeTextEditorSelection($e,Ee,ze){return at(jt.onDidChangeTextEditorSelection)($e,Ee,ze)},onDidChangeTextEditorOptions($e,Ee,ze){return at(jt.onDidChangeTextEditorOptions)($e,Ee,ze)},onDidChangeTextEditorVisibleRanges($e,Ee,ze){return at(jt.onDidChangeTextEditorVisibleRanges)($e,Ee,ze)},onDidChangeTextEditorViewColumn($e,Ee,ze){return at(jt.onDidChangeTextEditorViewColumn)($e,Ee,ze)},onDidCloseTerminal($e,Ee,ze){return at(st.onDidCloseTerminal)($e,Ee,ze)},onDidOpenTerminal($e,Ee,ze){return at(st.onDidOpenTerminal)($e,Ee,ze)},onDidChangeActiveTerminal($e,Ee,ze){return at(st.onDidChangeActiveTerminal)($e,Ee,ze)},onDidChangeTerminalDimensions($e,Ee,ze){return(0,et.$pF)(Be,"terminalDimensions"),at(st.onDidChangeTerminalDimensions)($e,Ee,ze)},onDidChangeTerminalState($e,Ee,ze){return at(st.onDidChangeTerminalState)($e,Ee,ze)},onDidWriteTerminalData($e,Ee,ze){return(0,et.$pF)(Be,"terminalDataWriteEvent"),at(st.onDidWriteTerminalData)($e,Ee,ze)},onDidExecuteTerminalCommand($e,Ee,ze){return(0,et.$pF)(Be,"terminalExecuteCommandEvent"),at(st.onDidExecuteTerminalCommand)($e,Ee,ze)},get state(){return Te.getState(Be)},onDidChangeWindowState($e,Ee,ze){return at(Te.onDidChangeWindowState)($e,Ee,ze)},showInformationMessage($e,...Ee){return Si.showMessage(Be,b.default.Info,$e,Ee[0],Ee.slice(1))},showWarningMessage($e,...Ee){return Si.showMessage(Be,b.default.Warning,$e,Ee[0],Ee.slice(1))},showErrorMessage($e,...Ee){return Si.showMessage(Be,b.default.Error,$e,Ee[0],Ee.slice(1))},showQuickPick($e,Ee,ze){return si.showQuickPick(Be,$e,Ee,ze)},showWorkspaceFolderPick($e){return si.showWorkspaceFolderPick($e)},showInputBox($e,Ee){return si.showInput($e,Ee)},showOpenDialog($e){return Oi.showOpenDialog(Be,$e)},showSaveDialog($e){return Oi.showSaveDialog($e)},createStatusBarItem($e,Ee,ze){let ut,vt,Ft;return typeof $e=="string"?(ut=$e,vt=Ee,Ft=ze):(vt=$e,Ft=Ee),ei.createStatusBarEntry(Be,ut,vt,Ft)},setStatusBarMessage($e,Ee){return ei.setStatusBarMessage($e,Ee)},withScmProgress($e){return Fe.report("window.withScmProgress",Be,"Use 'withProgress' instead."),pi.withProgress(Be,{location:Oe.ProgressLocation.SourceControl},(Ee,ze)=>$e({report(ut){}}))},withProgress($e,Ee){return pi.withProgress(Be,$e,Ee)},createOutputChannel($e,Ee){return It.createOutputChannel($e,Ee,Be)},createWebviewPanel($e,Ee,ze,ut){return Fi.createWebviewPanel(Be,$e,Ee,ze,ut)},createWebviewTextEditorInset($e,Ee,ze,ut){return(0,et.$pF)(Be,"editorInsets"),Pi.createWebviewEditorInset($e,Ee,ze,ut,Be)},createTerminal($e,Ee,ze){return typeof $e=="object"?"pty"in $e?st.createExtensionTerminal($e):st.createTerminalFromOptions($e):st.createTerminal($e,Ee,ze)},registerTerminalLinkProvider($e){return st.registerLinkProvider($e)},registerTerminalProfileProvider($e,Ee){return st.registerProfileProvider(Be,$e,Ee)},registerTerminalQuickFixProvider($e,Ee){return(0,et.$pF)(Be,"terminalQuickFixProvider"),st.registerTerminalQuickFixProvider($e,Be.identifier.value,Ee)},registerTreeDataProvider($e,Ee){return $i.registerTreeDataProvider($e,Ee,Be)},createTreeView($e,Ee){return $i.createTreeView($e,Ee,Be)},registerWebviewPanelSerializer:($e,Ee)=>Fi.registerWebviewPanelSerializer(Be,$e,Ee),registerCustomEditorProvider:($e,Ee,ze={})=>cn.registerCustomEditorProvider(Be,$e,Ee,ze),registerFileDecorationProvider($e){return qe.registerFileDecorationProvider($e,Be)},registerUriHandler($e){return gi.registerUriHandler(Be,$e)},createQuickPick(){return si.createQuickPick(Be)},createInputBox(){return si.createInputBox(Be)},get activeColorTheme(){return Ri.activeColorTheme},onDidChangeActiveColorTheme($e,Ee,ze){return at(Ri.onDidChangeActiveColorTheme)($e,Ee,ze)},registerWebviewViewProvider($e,Ee,ze){return Mi.registerWebviewViewProvider(Be,$e,Ee,ze?.webviewOptions)},get activeNotebookEditor(){return Pt.activeNotebookEditor},onDidChangeActiveNotebookEditor($e,Ee,ze){return at(Pt.onDidChangeActiveNotebookEditor)($e,Ee,ze)},get visibleNotebookEditors(){return Pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return at(Pt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection($e,Ee,ze){return at(mi.onDidChangeNotebookEditorSelection)($e,Ee,ze)},onDidChangeNotebookEditorVisibleRanges($e,Ee,ze){return at(mi.onDidChangeNotebookEditorVisibleRanges)($e,Ee,ze)},showNotebookDocument($e,Ee){return Pt.showNotebookDocument($e,Ee)},registerExternalUriOpener($e,Ee,ze){return(0,et.$pF)(Be,"externalUriOpener"),un.registerExternalUriOpener(Be.identifier,$e,Ee,ze)},registerProfileContentHandler($e,Ee){return(0,et.$pF)(Be,"profileContentHandlers"),ln.registrProfileContentHandler(Be,$e,Ee)},registerQuickDiffProvider($e,Ee,ze,ut){return(0,et.$pF)(Be,"quickDiffProvider"),Ai.registerQuickDiffProvider(pt($e),Ee,ze,ut)},get tabGroups(){return se.tabGroups},registerShareProvider($e,Ee){return(0,et.$pF)(Be,"shareProvider"),Ji.registerShareProvider(pt($e),Ee)}},rn={get rootPath(){return Fe.report("workspace.rootPath",Be,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath($e){throw new N.$9("rootPath")},getWorkspaceFolder($e){return ft.getWorkspaceFolder($e)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name($e){throw new N.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile($e){throw new N.$9("workspaceFile")},updateWorkspaceFolders:($e,Ee,...ze)=>ft.updateWorkspaceFolders(Be,$e,Ee||0,...ze),onDidChangeWorkspaceFolders:function($e,Ee,ze){return at(ft.onDidChangeWorkspace)($e,Ee,ze)},asRelativePath:($e,Ee)=>ft.getRelativePath($e,Ee),findFiles:($e,Ee,ze,ut)=>ft.findFiles($e,Ee,ze,Be.identifier,ut),findTextInFiles:($e,Ee,ze,ut)=>{(0,et.$pF)(Be,"findTextInFiles");let vt,Ft;return typeof Ee=="object"?(vt=Ee,Ft=ze):(vt={},Ft=Ee,ut=ze),ft.findTextInFiles($e,vt||{},Ft,Be.identifier,ut)},save:$e=>ft.save($e),saveAs:$e=>ft.saveAs($e),saveAll:$e=>ft.saveAll($e),applyEdit($e,Ee){return Xt.applyWorkspaceEdit($e,Be,Ee)},createFileSystemWatcher:($e,Ee,ze,ut)=>{let vt;return typeof Ee=="boolean"?vt={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!ze,ignoreDeleteEvents:!!ut,correlate:!1}:Ee&&((0,et.$pF)(Be,"createFileSystemWatcher"),vt={...Ee,correlate:!0}),_t.createFileSystemWatcher(ft,Be,$e,vt)},get textDocuments(){return Rt.getAllDocumentData().map($e=>$e.document)},set textDocuments($e){throw new N.$9("textDocuments")},openTextDocument($e){let Ee;const ze=$e;if(typeof $e=="string")Ee=Promise.resolve($.URI.file($e));else if($.URI.isUri($e))Ee=Promise.resolve($e);else if(!ze||typeof ze=="object")Ee=Rt.createDocumentData(ze);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(ut=>Rt.ensureDocumentData(ut).then(vt=>vt.document))},onDidOpenTextDocument:($e,Ee,ze)=>at(Rt.onDidAddDocument)($e,Ee,ze),onDidCloseTextDocument:($e,Ee,ze)=>at(Rt.onDidRemoveDocument)($e,Ee,ze),onDidChangeTextDocument:($e,Ee,ze)=>at(Rt.onDidChangeDocument)($e,Ee,ze),onDidSaveTextDocument:($e,Ee,ze)=>at(Rt.onDidSaveDocument)($e,Ee,ze),onWillSaveTextDocument:($e,Ee,ze)=>at(Ki.getOnWillSaveTextDocumentEvent(Be))($e,Ee,ze),get notebookDocuments(){return Pt.notebookDocuments.map($e=>$e.apiNotebook)},async openNotebookDocument($e,Ee){let ze;if($.URI.isUri($e))ze=$e,await Pt.openNotebookDocument($e);else if(typeof $e=="string")ze=$.URI.revive(await Pt.createNotebookDocument({viewType:$e,content:Ee}));else throw new Error("Invalid arguments");return Pt.getNotebookDocument(ze).apiNotebook},onDidSaveNotebookDocument($e,Ee,ze){return at(ri.onDidSaveNotebookDocument)($e,Ee,ze)},onDidChangeNotebookDocument($e,Ee,ze){return at(ri.onDidChangeNotebookDocument)($e,Ee,ze)},onWillSaveNotebookDocument($e,Ee,ze){return at(Ii.getOnWillSaveNotebookDocumentEvent(Be))($e,Ee,ze)},get onDidOpenNotebookDocument(){return at(Pt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return at(Pt.onDidCloseNotebookDocument)},registerNotebookSerializer($e,Ee,ze,ut){return Pt.registerNotebookSerializer(Be,$e,Ee,ze,(0,et.$oF)(Be,"notebookLiveShare")?ut:void 0)},onDidChangeConfiguration:($e,Ee,ze)=>at(en.onDidChangeConfiguration)($e,Ee,ze),getConfiguration($e,Ee){return Ee=arguments.length===1?void 0:Ee,en.getConfiguration($e,Ee,Be)},registerTextDocumentContentProvider($e,Ee){return Di.registerTextDocumentContentProvider($e,Ee)},registerTaskProvider:($e,Ee)=>(Fe.report("window.registerTaskProvider",Be,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider(Be,$e,Ee)),registerFileSystemProvider($e,Ee,ze){return(0,I.$Pc)(Gi.registerFileSystemProvider(Be,$e,Ee,ze),qt.addFileSystemProvider($e,Ee,ze))},get fs(){return qt.value},registerFileSearchProvider:($e,Ee)=>((0,et.$pF)(Be,"fileSearchProvider"),Bt.registerFileSearchProvider($e,Ee)),registerTextSearchProvider:($e,Ee)=>((0,et.$pF)(Be,"textSearchProvider"),Bt.registerTextSearchProvider($e,Ee)),registerRemoteAuthorityResolver:($e,Ee)=>((0,et.$pF)(Be,"resolvers"),Dt.registerRemoteAuthorityResolver($e,Ee)),registerResourceLabelFormatter:$e=>((0,et.$pF)(Be,"resolvers"),Qi.$registerResourceLabelFormatter($e)),getRemoteExecServer:$e=>((0,et.$pF)(Be,"resolvers"),Dt.getRemoteExecServer($e)),onDidCreateFiles:($e,Ee,ze)=>at(_t.onDidCreateFile)($e,Ee,ze),onDidDeleteFiles:($e,Ee,ze)=>at(_t.onDidDeleteFile)($e,Ee,ze),onDidRenameFiles:($e,Ee,ze)=>at(_t.onDidRenameFile)($e,Ee,ze),onWillCreateFiles:($e,Ee,ze)=>at(_t.getOnWillCreateFileEvent(Be))($e,Ee,ze),onWillDeleteFiles:($e,Ee,ze)=>at(_t.getOnWillDeleteFileEvent(Be))($e,Ee,ze),onWillRenameFiles:($e,Ee,ze)=>at(_t.getOnWillRenameFileEvent(Be))($e,Ee,ze),openTunnel:$e=>((0,et.$pF)(Be,"tunnels"),Nt.openTunnel(Be,$e).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,et.$pF)(Be,"tunnels"),Nt.getTunnels()},onDidChangeTunnels:($e,Ee,ze)=>((0,et.$pF)(Be,"tunnels"),at(Nt.onDidChangeTunnels)($e,Ee,ze)),registerPortAttributesProvider:($e,Ee)=>((0,et.$pF)(Be,"portsAttributes"),Nt.registerPortsAttributesProvider($e,Ee)),registerTunnelProvider:($e,Ee)=>((0,et.$pF)(Be,"tunnelFactory"),Nt.registerTunnelProvider($e,Ee)),registerTimelineProvider:($e,Ee)=>((0,et.$pF)(Be,"timeline"),Zi.registerTimelineProvider($e,Ee,Be.identifier,Ke.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:$e=>((0,et.$pF)(Be,"workspaceTrust"),ft.requestWorkspaceTrust($e)),onDidGrantWorkspaceTrust:($e,Ee,ze)=>at(ft.onDidGrantWorkspaceTrust)($e,Ee,ze),registerEditSessionIdentityProvider:($e,Ee)=>((0,et.$pF)(Be,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider($e,Ee)),onWillCreateEditSessionIdentity:($e,Ee,ze)=>((0,et.$pF)(Be,"editSessionIdentityProvider"),at(ft.getOnWillCreateEditSessionIdentityEvent(Be))($e,Ee,ze)),registerCanonicalUriProvider:($e,Ee)=>((0,et.$pF)(Be,"canonicalUriProvider"),ft.registerCanonicalUriProvider($e,Ee)),getCanonicalUri:($e,Ee,ze)=>((0,et.$pF)(Be,"canonicalUriProvider"),ft.provideCanonicalUri($e,Ee,ze))},sn={get inputBox(){return Fe.report("scm.inputBox",Be,"Use 'SourceControl.inputBox' instead"),bi.getLastInputBox(Be)},createSourceControl($e,Ee,ze){return bi.createSourceControl(Be,$e,Ee,ze)}},on={createCommentController($e,Ee){return Li.createCommentController(Be,$e,Ee)}},zi={get activeDebugSession(){return $t.activeDebugSession},get activeDebugConsole(){return $t.activeDebugConsole},get breakpoints(){return $t.breakpoints},get stackFrameFocus(){return $t.stackFrameFocus},onDidStartDebugSession($e,Ee,ze){return at($t.onDidStartDebugSession)($e,Ee,ze)},onDidTerminateDebugSession($e,Ee,ze){return at($t.onDidTerminateDebugSession)($e,Ee,ze)},onDidChangeActiveDebugSession($e,Ee,ze){return at($t.onDidChangeActiveDebugSession)($e,Ee,ze)},onDidReceiveDebugSessionCustomEvent($e,Ee,ze){return at($t.onDidReceiveDebugSessionCustomEvent)($e,Ee,ze)},onDidChangeBreakpoints($e,Ee,ze){return at($t.onDidChangeBreakpoints)($e,Ee,ze)},onDidChangeStackFrameFocus($e,Ee,ze){return(0,et.$pF)(Be,"debugFocus"),at($t.onDidChangeStackFrameFocus)($e,Ee,ze)},registerDebugConfigurationProvider($e,Ee,ze){return $t.registerDebugConfigurationProvider($e,Ee,ze||Ut.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory($e,Ee){return $t.registerDebugAdapterDescriptorFactory(Be,$e,Ee)},registerDebugAdapterTrackerFactory($e,Ee){return $t.registerDebugAdapterTrackerFactory($e,Ee)},startDebugging($e,Ee,ze){return!ze||typeof ze=="object"&&"configuration"in ze?$t.startDebugging($e,Ee,{parentSession:ze}):$t.startDebugging($e,Ee,ze||{})},stopDebugging($e){return $t.stopDebugging($e)},addBreakpoints($e){return $t.addBreakpoints($e)},removeBreakpoints($e){return $t.removeBreakpoints($e)},asDebugSourceUri($e,Ee){return $t.asDebugSourceUri($e,Ee)}},Bi={registerTaskProvider:($e,Ee)=>St.registerTaskProvider(Be,$e,Ee),fetchTasks:$e=>St.fetchTasks($e),executeTask:$e=>St.executeTask(Be,$e),get taskExecutions(){return St.taskExecutions},onDidStartTask:($e,Ee,ze)=>at(St.onDidStartTask)($e,Ee,ze),onDidEndTask:($e,Ee,ze)=>at(St.onDidEndTask)($e,Ee,ze),onDidStartTaskProcess:($e,Ee,ze)=>at(St.onDidStartTaskProcess)($e,Ee,ze),onDidEndTaskProcess:($e,Ee,ze)=>at(St.onDidEndTaskProcess)($e,Ee,ze)},Wi={createNotebookController($e,Ee,ze,ut,vt){return ci.createNotebookController(Be,$e,Ee,ze,ut,(0,et.$oF)(Be,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:($e,Ee)=>Pt.registerNotebookCellStatusBarItemProvider(Be,$e,Ee),createRendererMessaging($e){return Ci.createRendererMessaging(Be,$e)},createNotebookControllerDetectionTask($e){return(0,et.$pF)(Be,"notebookKernelSource"),ci.createNotebookControllerDetectionTask(Be,$e)},registerKernelSourceActionProvider($e,Ee){return(0,et.$pF)(Be,"notebookKernelSource"),ci.registerKernelSourceActionProvider(Be,$e,Ee)},onDidChangeNotebookCellExecutionState($e,Ee,ze){return(0,et.$pF)(Be,"notebookCellExecutionState"),at(ci.onDidChangeNotebookCellExecutionState)($e,Ee,ze)}},ki={t(...$e){if(typeof $e[0]=="string"){const Ee=$e.shift(),ze=!$e||typeof $e[0]!="object"?$e:$e[0];return yt.getMessage(Be.identifier.value,{message:Ee,args:ze})}return yt.getMessage(Be.identifier.value,$e[0])},get bundle(){return yt.getBundle(Be.identifier.value)},get uri(){return yt.getBundleUri(Be.identifier.value)}},qi={_version:1,registerInteractiveEditorSessionProvider($e,Ee){return(0,et.$pF)(Be,"interactive"),Xi.registerProvider(Be,$e,Ee)},registerInteractiveSessionProvider($e,Ee){return(0,et.$pF)(Be,"interactive"),vi.registerChatProvider(Be,$e,Ee)},sendInteractiveRequestToProvider($e,Ee){return(0,et.$pF)(Be,"interactive"),vi.sendInteractiveRequestToProvider($e,Ee)},transferChatSession($e,Ee){return(0,et.$pF)(Be,"interactive"),vi.transferChatSession($e,Ee)}},mn={getRelatedInformation($e,Ee){return(0,et.$pF)(Be,"aiRelatedInformation"),_i.getRelatedInformation(Be,$e,Ee)},registerRelatedInformationProvider($e,Ee){return(0,et.$pF)(Be,"aiRelatedInformation"),_i.registerRelatedInformationProvider(Be,$e,Ee)},registerEmbeddingVectorProvider($e,Ee){return(0,et.$pF)(Be,"aiRelatedInformation"),Ni.registerEmbeddingVectorProvider(Be,$e,Ee)}},$n={registerChatResponseProvider($e,Ee,ze){return(0,et.$pF)(Be,"chatProvider"),di.registerProvider(Be.identifier,$e,Ee,ze)},requestChatAccess($e){return(0,et.$pF)(Be,"chatRequestAccess"),di.requestChatResponseProvider(Be.identifier,$e)},registerVariable($e,Ee,ze){return(0,et.$pF)(Be,"chatVariables"),xi.registerVariableResolver(Be,$e,Ee,ze)},registerMappedEditsProvider($e,Ee){return(0,et.$pF)(Be,"mappedEditsProvider"),dt.registerMappedEditsProvider(Be,$e,Ee)},createChatAgent($e,Ee){return(0,et.$pF)(Be,"chatAgents2"),Yi.createChatAgent(Be,$e,Ee)}},bn={registerSpeechProvider($e,Ee){return(0,et.$pF)(Be,"speech"),yi.registerProvider(Be.identifier,$e,Ee)}};return{version:bt.version,ai:mn,authentication:dn,commands:fn,comments:on,chat:$n,debug:zi,env:ji,extensions:tn,interactive:qi,l10n:ki,languages:nn,notebooks:Wi,scm:sn,speech:bn,tasks:Bi,tests:Ui,window:gn,workspace:rn,Breakpoint:Oe.$RL,TerminalOutputAnchor:Oe.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Oe.ChatAgentResultFeedbackKind,ChatMessage:Oe.$JM,ChatMessageRole:Oe.ChatMessageRole,ChatVariableLevel:Oe.ChatVariableLevel,ChatAgentCompletionItem:Oe.$IM,CallHierarchyIncomingCall:Oe.$eL,CallHierarchyItem:Oe.$dL,CallHierarchyOutgoingCall:Oe.$fL,CancellationError:N.$5,CancellationTokenSource:D.$3d,CandidatePortSource:n.CandidatePortSource,CodeAction:Oe.$aL,CodeActionKind:Oe.$bL,CodeActionTriggerKind:Oe.CodeActionTriggerKind,CodeLens:Oe.$gL,Color:Oe.$tL,ColorInformation:Oe.$uL,ColorPresentation:Oe.$vL,ColorThemeKind:Oe.ColorThemeKind,CommentMode:Oe.CommentMode,CommentState:Oe.CommentState,CommentThreadCollapsibleState:Oe.CommentThreadCollapsibleState,CommentThreadState:Oe.CommentThreadState,CompletionItem:Oe.$nL,CompletionItemKind:Oe.CompletionItemKind,CompletionItemTag:Oe.CompletionItemTag,CompletionList:Oe.$oL,CompletionTriggerKind:Oe.CompletionTriggerKind,ConfigurationTarget:Oe.ConfigurationTarget,CustomExecution:Oe.$DL,DebugAdapterExecutable:Oe.$VL,DebugAdapterInlineImplementation:Oe.$YL,DebugAdapterNamedPipeServer:Oe.$XL,DebugAdapterServer:Oe.$WL,DebugConfigurationProviderTriggerKind:Ut.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Oe.DebugConsoleMode,DecorationRangeBehavior:Oe.DecorationRangeBehavior,Diagnostic:Oe.$7K,DiagnosticRelatedInformation:Oe.$6K,DiagnosticSeverity:Oe.DiagnosticSeverity,DiagnosticTag:Oe.DiagnosticTag,Disposable:Oe.$SK,DocumentHighlight:Oe.$9K,DocumentHighlightKind:Oe.DocumentHighlightKind,MultiDocumentHighlight:Oe.$0K,DocumentLink:Oe.$sL,DocumentSymbol:Oe.$_K,EndOfLine:Oe.EndOfLine,EnvironmentVariableMutatorType:Oe.EnvironmentVariableMutatorType,EvaluatableExpression:Oe.$2L,InlineValueText:Oe.$3L,InlineValueVariableLookup:Oe.$4L,InlineValueEvaluatableExpression:Oe.$5L,InlineCompletionTriggerKind:Oe.InlineCompletionTriggerKind,EventEmitter:g.$Sd,ExtensionKind:Oe.ExtensionKind,ExtensionMode:Oe.ExtensionMode,ExternalUriOpenerPriority:Oe.ExternalUriOpenerPriority,FileChangeType:Oe.FileChangeType,FileDecoration:Oe.$cM,FileDecoration2:Oe.$cM,FileSystemError:Oe.$7L,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:Oe.$8L,FoldingRangeKind:Oe.FoldingRangeKind,FunctionBreakpoint:Oe.$TL,InlineCompletionItem:Oe.$pL,InlineCompletionList:Oe.$qL,Hover:Oe.$8K,IndentAction:C.IndentAction,Location:Oe.$5K,MarkdownString:Oe.$hL,OverviewRulerLane:m.OverviewRulerLane,ParameterInformation:Oe.$iL,PortAutoForwardAction:Oe.PortAutoForwardAction,Position:Oe.$TK,ProcessExecution:Oe.$BL,ProgressLocation:Oe.ProgressLocation,QuickInputButtons:Oe.$bM,Range:Oe.$UK,RelativePattern:Oe.$PL,Selection:Oe.$VK,SelectionRange:Oe.$cL,SemanticTokens:Oe.$$L,SemanticTokensBuilder:Oe.$0L,SemanticTokensEdit:Oe.$_L,SemanticTokensEdits:Oe.$aM,SemanticTokensLegend:Oe.$9L,ShellExecution:Oe.$CL,ShellQuoting:Oe.ShellQuoting,SignatureHelp:Oe.$kL,SignatureHelpTriggerKind:Oe.SignatureHelpTriggerKind,SignatureInformation:Oe.$jL,SnippetString:Oe.$4K,SourceBreakpoint:Oe.$SL,StandardTokenType:Oe.StandardTokenType,StatusBarAlignment:Oe.StatusBarAlignment,SymbolInformation:Oe.$$K,SymbolKind:Oe.SymbolKind,SymbolTag:Oe.SymbolTag,Task:Oe.$EL,TaskGroup:Oe.$AL,TaskPanelKind:Oe.TaskPanelKind,TaskRevealKind:Oe.TaskRevealKind,TaskScope:Oe.TaskScope,TerminalLink:Oe.$wL,TerminalQuickFixTerminalCommand:Oe.$yL,TerminalQuickFixOpener:Oe.$xL,TerminalLocation:Oe.TerminalLocation,TerminalProfile:Oe.$zL,TerminalExitReason:Oe.TerminalExitReason,TextDocumentSaveReason:Oe.TextDocumentSaveReason,TextEdit:Oe.$ZK,SnippetTextEdit:Oe.$2K,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:Oe.TextEditorLineNumbersStyle,TextEditorRevealType:Oe.TextEditorRevealType,TextEditorSelectionChangeKind:Oe.TextEditorSelectionChangeKind,SyntaxTokenType:Oe.SyntaxTokenType,TextDocumentChangeReason:Oe.TextDocumentChangeReason,ThemeColor:Oe.$OL,ThemeIcon:Oe.$NL,TreeItem:Oe.$FL,TreeItemCheckboxState:Oe.TreeItemCheckboxState,TreeItemCollapsibleState:Oe.TreeItemCollapsibleState,TypeHierarchyItem:Oe.$xM,UIKind:Lt.UIKind,Uri:$.URI,ViewColumn:Oe.ViewColumn,WorkspaceEdit:Oe.$3K,DocumentDropEdit:Oe.$LL,DocumentPasteEdit:Oe.$ML,InlayHint:Oe.$mL,InlayHintLabelPart:Oe.$lL,InlayHintKind:Oe.InlayHintKind,RemoteAuthorityResolverError:Oe.$YK,ResolvedAuthority:Oe.$WK,ManagedResolvedAuthority:Oe.$XK,SourceControlInputBoxValidationType:Oe.SourceControlInputBoxValidationType,ExtensionRuntime:Oe.ExtensionRuntime,TimelineItem:Oe.$mM,NotebookRange:Oe.$eM,NotebookCellKind:Oe.NotebookCellKind,NotebookCellExecutionState:Oe.NotebookCellExecutionState,NotebookCellData:Oe.$fM,NotebookData:Oe.$gM,NotebookRendererScript:Oe.$kM,NotebookCellStatusBarAlignment:Oe.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Oe.NotebookEditorRevealType,NotebookCellOutput:Oe.$iM,NotebookCellOutputItem:Oe.$hM,NotebookCellStatusBarItem:Oe.$jM,NotebookControllerAffinity:Oe.NotebookControllerAffinity,NotebookControllerAffinity2:Oe.NotebookControllerAffinity2,NotebookEdit:Oe.$1K,NotebookKernelSourceAction:Oe.$lM,NotebookVariablesRequestKind:Oe.NotebookVariablesRequestKind,PortAttributes:Oe.$oM,LinkedEditingRanges:Oe.$nM,TestResultState:Oe.TestResultState,TestRunRequest:Oe.$pM,TestMessage:Oe.$qM,TestMessage2:Oe.$qM,TestTag:Oe.$rM,TestRunProfileKind:Oe.TestRunProfileKind,TextSearchCompleteMessageType:Gt.TextSearchCompleteMessageType,DataTransfer:Oe.$KL,DataTransferItem:Oe.$GL,CoveredCount:Oe.$sM,FileCoverage:Oe.$tM,StatementCoverage:Oe.$uM,BranchCoverage:Oe.$vM,FunctionCoverage:Oe.$wM,WorkspaceTrustState:Oe.WorkspaceTrustState,LanguageStatusSeverity:Oe.LanguageStatusSeverity,QuickPickItemKind:Oe.QuickPickItemKind,InputBoxValidationSeverity:Oe.InputBoxValidationSeverity,TabInputText:Oe.$yM,TabInputTextDiff:Oe.$zM,TabInputTextMerge:Oe.$AM,TabInputCustom:Oe.$BM,TabInputNotebook:Oe.$DM,TabInputNotebookDiff:Oe.$EM,TabInputWebview:Oe.$CM,TabInputTerminal:Oe.$FM,TabInputInteractiveWindow:Oe.$GM,TabInputChat:Oe.$HM,TelemetryTrustedValue:s.$yo,LogLevel:l.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Oe.InteractiveSessionVoteDirection,ChatAgentCopyKind:Oe.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Oe.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Oe.$ZL,ThreadFocus:Oe.$1L,RelatedInformationType:Oe.RelatedInformationType,SpeechToTextStatus:Oe.SpeechToTextStatus}}}e.$khc=Jt}),define(Se[370],ke([1,0,106,152,41,149,42,35,69,47,95,96,97,118,72,91,151,71,58,117,90,70,150,13,59,115,116]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l,f,s,i,n,o,c,t,r,d,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Lr)(u.$_fc,u.$$fc,1),(0,D.$Lr)(r.$lj,t.$lhc,1),(0,D.$Lr)(l.$kfc,l.$lfc,1),(0,D.$Lr)(b.$eN,b.$dN,0),(0,D.$Lr)(R.$Ffc,R.$Dfc,0),(0,D.$Lr)(s.$Hfc,s.$Gfc,0),(0,D.$Lr)(C.$jgc,C.$ngc,0),(0,D.$Lr)(I.$pgc,I.$ogc,0),(0,D.$Lr)($.$6M,$.$5M,0),(0,D.$Lr)(a.$agc,a.$bgc,0),(0,D.$Lr)(i.$hfc,i.$gfc,0),(0,D.$Lr)(N.$Vgc,N.$Ugc,1),(0,D.$Lr)(m.$Fgc,m.$Ggc,0),(0,D.$Lr)(v.$1fc,v.$Zfc,0),(0,D.$Lr)(A.$9gc,A.$8gc,0),(0,D.$Lr)(y.$4fc,y.$7fc,0),(0,D.$Lr)(k.$cyb,k.$dyb,0),(0,D.$Lr)(f.$jhc,f.$ihc,0),(0,D.$Lr)(g.$Cfc,g.$Bfc,0),(0,D.$Lr)(n.$9fc,n.$8fc,0),(0,D.$Lr)(o.$cN,o.$_M,0),(0,D.$Lr)(c.$Rfc,c.$Sfc,0),(0,D.$Lr)(d.$hgc,d.$igc,0)}),define(Se[119],ke([1,0,19,13,36,94]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=e.$Chc=e.$Bhc=void 0;function R(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.$Bhc=R;function b(C,m,v,k){const l=(0,D.$2b)(v,$),f=new g.$gJ(m,l,k),s=f.preview.matches;return{ranges:(0,D.$2b)(l,y),uri:C,preview:{text:f.preview.text,matches:(0,D.$2b)(s,y)}}}e.$Chc=b;function $(C){return new g.$hJ(C.start.line,C.start.character,C.end.line,C.end.character)}function y(C){return new I.$8I(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let A=class{constructor(m,v){this.a=m,this.b=v}appendLine(m){this.b.debug(`${this.a}#search`,m)}};e.$Dhc=A,e.$Dhc=A=Ge([We(1,N.$kj)],A)}),define(Se[371],ke([1,0,51,16,76,33,10,12,119,372]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=e.$Fhc=e.$Ehc=void 0;const A=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(n,o,c,t){const r=m(n,o,c,t),d=o.folder.fsPath;return{cmd:D.spawn(A,r.args,{cwd:d}),rgDiskPath:A,siblingClauses:r.siblingClauses,rgArgs:r,cwd:d}}e.$Ehc=C;function m(n,o,c,t){const r=["--files","--hidden","--case-sensitive","--no-require-git"];k([o],c,!1).forEach(u=>{const a=(0,$.$Bhc)(u);if(r.push("-g",a),R.$j){const h=(0,g.$El)(a);h!==a&&r.push("-g",h)}});const d=v([o],t,void 0,!1);return d.globArgs.forEach(u=>{const a=`!${(0,$.$Bhc)(u)}`;if(r.push("-g",a),R.$j){const h=(0,g.$El)(a);h!==a&&r.push("-g",h)}}),o.disregardIgnoreFiles!==!1?r.push("--no-ignore"):o.disregardParentIgnoreFiles!==!1&&r.push("--no-ignore-parent"),o.ignoreSymlinks||r.push("--follow"),n.exists&&r.push("--quiet"),r.push("--no-config"),o.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:d.siblingClauses}}function v(n,o,c,t=!0){const r=[];let d={};return n.forEach(u=>{const a=Object.assign({},u.excludePattern||{},o||{}),h=l(a,t?u.folder.fsPath:void 0,c);r.push(...h.globArgs),h.siblingClauses&&(d=Object.assign(d,h.siblingClauses))}),{globArgs:r,siblingClauses:d}}function k(n,o,c=!0){const t=[];return n.forEach(r=>{const d=Object.assign({},o||{},r.includePattern||{}),u=l(d,c?r.folder.fsPath:void 0);t.push(...u.globArgs)}),t}function l(n,o,c){const t=[],r={};return Object.keys(n).forEach(d=>{if(c&&c.has(d)||!d)return;const u=n[d];d=s(o?f(o,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof u=="boolean"&&u?(d.startsWith("\\\\")&&(d+="**"),t.push(i(d))):u&&u.when&&(r[d]=u)}),{globArgs:t,siblingClauses:r}}function f(n,o){return N.$ic(o)?o:N.$jc(n,o)}e.$Fhc=f;function s(n){return n=b.$Re(n,"\\"),b.$Re(n,"/")}function i(n){return I.$1f(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}e.$Ghc=i}),define(Se[373],ke([1,0,51,56,16,374,19,44,34,76,33,10,38,12,18,31,36,371,129]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l,f,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ihc=e.$Hhc=void 0;const n=new Set;process.on("exit",()=>{n.forEach(d=>d())});class o{constructor(u){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=u,this.b=u.filePattern||"",this.d=u.includePattern&&$.$Jj(u.includePattern),this.f=u.maxResults||null,this.g=!!u.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,i.$Nq)(this.b).normalizedLowercase),this.u=u.excludePattern&&$.$Jj(u.excludePattern),this.t=new Map,u.folderQueries.forEach(a=>{const h=Object.assign({},a.excludePattern||{},this.a.excludePattern||{}),S=a.folder.fsPath;u.folderQueries.map(P=>P.folder.fsPath).filter(P=>P!==S).forEach(P=>{(0,A.$5f)(P,S)&&(h[g.$lc(S,P)]=!0)}),this.t.set(S,new t(h,S))})}cancel(){this.l=!0,n.forEach(u=>u())}walk(u,a,h,S,P){if(this.m=m.$Od.create(!1),this.l)return P(null,this.j);a.forEach(w=>{const p=g.$nc(w.fsPath);this.u&&this.u(w.fsPath,p)||this.J(h,{relativePath:w.fsPath,searchPath:void 0})}),this.r=m.$Od.create(!1),this.w(u,(w,p)=>{this.x(this.y,this,w,h,S,E=>{if(E){const L=(0,b.$Ni)(E);console.error(L),this.q.push(L),p(E,void 0)}else p(null,void 0)})},(w,p)=>{this.m.stop();const E=w?R.$Hb(w)[0]:null;P(E,this.j)})}w(u,a,h){const S=new Array(u.length),P=new Array(u.length);let w=!1,p=0;if(u.length===0)return h(null,[]);u.forEach((E,L)=>{a(E,(T,U)=>{if(T?(w=!0,S[L]=null,P[L]=T):(S[L]=U,P[L]=null),++p===u.length)return h(w?P:null,S)})})}x(u,a,...h){try{u.apply(a,h)}catch(S){h[h.length-1](S)}}y(u,a,h,S){const P=u.folder.fsPath,w=C.$j,p=()=>F&&F.kill();n.add(p);let E=W=>{n.delete(p),E=()=>{},S(W)},L="";const T=this.D(),U=(0,s.$Ehc)(this.a,u,this.a.includePattern,this.t.get(u.folder.fsPath).expression),F=U.cmd,j=!Object.keys(U.siblingClauses).length,O=U.rgArgs.args.map(W=>W.match(/^-/)?W:`'${W}'`).join(" ");let M=`${U.rgDiskPath} ${O}
 - cwd: ${U.cwd}`;U.rgArgs.siblingClauses&&(M+=`
 - Sibling clauses: ${JSON.stringify(U.rgArgs.siblingClauses)}`),h({message:M}),this.s=0,this.z(F,"utf8",h,(W,Y,ue)=>{if(W){E(W);return}if(this.j){E();return}const J=(L+(w?y.$Dl(Y||""):Y)).split(`
`);if(ue){const x=J.length;J[x-1]=J[x-1].trim(),J[x-1]||J.pop()}else L=J.pop()||"";if(J.length&&J[0].indexOf(`
`)!==-1){E(new Error("Splitting up files failed"));return}if(this.s+=J.length,j){for(const x of J)if(this.J(a,{base:P,relativePath:x,searchPath:this.N(u,x)}),this.j){p();break}(ue||this.j)&&E();return}this.G(u,T,P,J,a),ue&&(this.H(T,P,a),E())})}spawnFindCmd(u){const a=this.t.get(u.folder.fsPath),h=a.getBasenameTerms(),S=a.getPathTerms(),P=["-L","."];if(h.length||S.length){P.push("-not","(","(");for(const w of h)P.push("-name",w),P.push("-o");for(const w of S)P.push("-path",w),P.push("-o");P.pop(),P.push(")","-prune",")")}return P.push("-type","f"),D.spawn("find",P,{cwd:u.folder.fsPath})}readStdout(u,a,h){let S="";this.z(u,a,()=>{},(P,w,p)=>{if(P){h(P);return}S+=w,p&&h(null,S)})}z(u,a,h,S){let P=(E,L,T)=>{(E||T)&&(P=()=>{},this.r?.stop()),S(E,L,T)},w=!1;u.stdout?(this.A(u.stdout,a,P),u.stdout.once("data",()=>w=!0)):h({message:"stdout is null"});let p;u.stderr?p=this.B(u.stderr):h({message:"stderr is null"}),u.on("error",E=>{P(E)}),u.on("close",E=>{let L;!w&&(L=this.C(p,a))&&r(L)?P(new Error(`command failed with error code ${E}: ${this.C(p,a)}`)):(this.g&&E===0&&(this.j=!0),P(null,"",!0))})}A(u,a,h){const S=new I.StringDecoder(a);return u.on("data",P=>{h(null,S.write(P))}),S}B(u){const a=[];return u.on("data",h=>{a.push(h)}),a}C(u,a){const h=new I.StringDecoder(a);return u.map(S=>h.write(S)).join("")}D(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}G(u,{pathToEntries:a},h,S,P){S.indexOf(this.b)!==-1&&this.J(P,{base:h,relativePath:this.b,searchPath:this.N(u,this.b)});const w=p=>{const E=g.$nc(p),L=g.$mc(p);let T=a[L];T||(T=a[L]=[],w(L)),T.push({base:h,relativePath:p,basename:E,searchPath:this.N(u,p)})};S.forEach(w)}H({rootEntries:u,pathToEntries:a},h,S){const P=this,w=this.t.get(h),p=this.b;function E(L){P.o++;const T=(0,f.$wJ)(()=>L.map(U=>U.basename));for(let U=0,F=L.length;U<F;U++){const j=L[U],{relativePath:O,basename:M}=j;if(w.test(O,M,p!==M?T:void 0))continue;const W=a[O];if(W)E(W);else{if(P.p++,O===p)continue;P.J(S,j)}if(P.j)break}}E(u)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(u,a,h,S,P){const w=u.folder,p=(0,f.$wJ)(()=>h);this.w(h,(E,L)=>{if(this.l||this.j)return L(null);const T=a?[a,E].join(g.sep):E;if(this.t.get(u.folder.fsPath).test(T,E,this.a.filePattern!==E?p:void 0))return L(null);const U=[w.fsPath,T].join(g.sep);N.lstat(U,(F,j)=>{if(F||this.l||this.j)return L(null);this.L(U,j,(O,M)=>O||this.l||this.j?L(null):M.isDirectory()?(this.o++,this.M(U,j,(W,Y)=>W||this.l||this.j||(Y=Y||"",this.v[Y])?L(null):(this.v[Y]=!0,l.Promises.readdir(U).then(ue=>{if(this.l||this.j)return L(null);this.I(u,T,ue,S,X=>L(X||null))},ue=>{L(null)})))):(this.p++,T===this.b||this.h&&k.$Jf(M.size)&&M.size>this.h||this.J(S,{base:w.fsPath,relativePath:T,searchPath:this.N(u,T)}),L(null,void 0)))})},E=>{const L=E&&R.$Hb(E);return P(L&&L.length>0?L[0]:void 0)})}J(u,a){this.K(a)&&(!this.d||this.d(a.relativePath,g.$nc(a.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||u(a))}K(u){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,f.$rJ)(u,this.c)}return!0}L(u,a,h){return a.isSymbolicLink()?N.stat(u,h):h(null,a)}M(u,a,h){return a.isSymbolicLink()?N.realpath(u,(S,P)=>S?h(S):h(null,P)):h(null,u)}N(u,a){return u.folderName?g.$jc(u.folderName,a):a}}e.$Hhc=o;class c{constructor(u){this.a=u.folderQueries,this.b=u.extraFileResources||[],this.c=new o(u)}search(u,a,h){this.c.walk(this.a,this.b,u,a,(S,P)=>{h(S,{limitHit:P,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Ihc=c;class t{constructor(u,a){this.expression=u,this.c=a,this.d(u)}d(u){let a,h;Object.keys(u).filter(S=>u[S]).forEach(S=>{g.$ic(S)?(a=a||$.$Ej(),a[S]=u[S]):(h=h||$.$Ej(),h[S]=u[S])}),this.a=a&&$.$Jj(a,{trimForExclusions:!0}),this.b=h&&$.$Jj(h,{trimForExclusions:!0})}test(u,a,h){return this.b&&this.b(u,a,h)||this.a&&this.a(g.$jc(this.c,u),a,h)}getBasenameTerms(){const u=[];return this.a&&u.push(...$.$Lj(this.a)),this.b&&u.push(...$.$Lj(this.b)),u}getPathTerms(){const u=[];return this.a&&u.push(...$.$Mj(this.a)),this.b&&u.push(...$.$Mj(this.b)),u}}function r(d){const u=d.trim().split(`
`),a=u[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return v.$xf(u[u.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}}),define(Se[375],ke([1,0,98,22,186,21]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iD=e.$hD=e.$gD=e.$fD=e.$eD=e.$dD=e.$cD=e.$bD=e.$aD=e.DecodeStreamErrorKind=e.$_C=e.$$C=e.$0C=e.$9C=e.$8C=e.$7C=e.$6C=e.$5C=void 0,e.$5C="utf8",e.$6C="utf8bom",e.$7C="utf16be",e.$8C="utf16le";function R(a){return[e.$5C,e.$6C,e.$7C,e.$8C].some(h=>h===a)}e.$9C=R,e.$0C=[254,255],e.$$C=[255,254],e.$_C=[239,187,191];const b=512,$=512,y=512*8,A=512*128;var C;(function(a){a[a.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C||(e.DecodeStreamErrorKind=C={}));class m extends Error{constructor(h,S){super(h),this.decodeStreamErrorKind=S}}e.$aD=m;class v{static async create(h){let S;if(h!==e.$5C)S=(await(0,g.$4C)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(s(h));else{const P=new TextDecoder;S={write(w){return P.decode(w,{stream:!0})},end(){return P.decode()}}}return new v(S)}constructor(h){this.a=h}write(h){return this.a.write(h)}end(){return this.a.end()}}function k(a,h){const S=h.minBytesRequiredForDetection??h.guessEncoding?y:$;return new Promise((P,w)=>{const p=(0,D.$7d)(j=>j.join("")),E=[];let L=0,T;const U=new I.$3d,F=async()=>{try{const j=await u({buffer:N.$ge.concat(E),bytesRead:L},h.guessEncoding);if(j.seemsBinary&&h.acceptTextOnly)throw new m("Stream is binary but only text is accepted for decoding",1);j.encoding=await h.overwriteEncoding(j.encoding),T=await v.create(j.encoding);const O=T.write(N.$ge.concat(E).buffer);p.write(O),E.length=0,L=0,P({stream:p,detected:j})}catch(j){U.cancel(),p.destroy(),w(j)}};(0,D.$$d)(a,{onData:async j=>{T?p.write(T.write(j.buffer)):(E.push(j),L+=j.byteLength,L>=S&&(a.pause(),await F(),setTimeout(()=>a.resume())))},onError:j=>p.error(j),onEnd:async()=>{T||await F(),p.end(T?.end())}},U.token)})}e.$bD=k;async function l(a,h,S){const w=(await(0,g.$4C)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(s(h),S);let p=!1,E=!1;return{read(){if(E)return null;const L=a.read();if(typeof L!="string"){if(E=!0,!p&&S?.addBOM)switch(h){case e.$5C:case e.$6C:return N.$ge.wrap(Uint8Array.from(e.$_C));case e.$7C:return N.$ge.wrap(Uint8Array.from(e.$0C));case e.$8C:return N.$ge.wrap(Uint8Array.from(e.$$C))}const T=w.end();return T&&T.length>0?(p=!0,N.$ge.wrap(T)):null}return p=!0,N.$ge.wrap(w.write(L))}}}e.$cD=l;async function f(a){return(await(0,g.$4C)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(s(a))}e.$dD=f;function s(a){return a===e.$6C||a===null?e.$5C:a}e.$eD=s;function i(a,h){if(!a||h<e.$0C.length)return null;const S=a.readUInt8(0),P=a.readUInt8(1);if(S===e.$0C[0]&&P===e.$0C[1])return e.$7C;if(S===e.$$C[0]&&P===e.$$C[1])return e.$8C;if(h<e.$_C.length)return null;const w=a.readUInt8(2);return S===e.$_C[0]&&P===e.$_C[1]&&w===e.$_C[2]?e.$6C:null}e.$fD=i;const n=["ascii","utf-16","utf-32"];async function o(a){const h=await(0,g.$4C)("jschardet","dist/jschardet.min.js"),S=a.slice(0,A),P=r(S.buffer),w=h.detect(P);if(!w||!w.encoding)return null;const p=w.encoding.toLowerCase();return 0<=n.indexOf(p)?null:t(w.encoding)}const c={ibm866:"cp866",big5:"cp950"};function t(a){const h=a.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return c[h]||h}function r(a){let h="";for(let S=0;S<a.length;S++)h+=String.fromCharCode(a[S]);return h}function d(a){switch(a){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const h=a.match(/windows(\d+)/);return h?"windows-"+h[1]:a}}}e.$gD=d;function u({buffer:a,bytesRead:h},S){let P=i(a,h),w=!1;if(P!==e.$7C&&P!==e.$8C&&a){let p=!0,E=!0,L=!1;for(let T=0;T<h&&T<b;T++){const U=T%2===1,F=a.readUInt8(T)===0;if(F&&(L=!0),p&&(U&&!F||!U&&F)&&(p=!1),E&&(U&&F||!U&&!F)&&(E=!1),F&&!p&&!E)break}L&&(p?P=e.$8C:E?P=e.$7C:w=!0)}return S&&!w&&!P&&a?o(a.slice(0,h)).then(p=>({seemsBinary:!1,encoding:p})):{seemsBinary:w,encoding:P}}e.$hD=u,e.$iD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Se[155],ke([1,0,375,31,154]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=void 0;class I extends g.$Bgc{constructor(b,$,y=N,A="searchProcess"){super(b,$,{readdir:C=>y.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,D.$gD)(C)},A)}}e.$Qhc=I}),define(Se[156],ke([1,0,51,391,374,19,73,34,12,2,36,94,392,372,119]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Phc=e.$Ohc=e.$Nhc=e.$Mhc=e.$Lhc=e.$Khc=e.$Jhc=void 0;const l=v.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class f{constructor(p){this.a=p}provideTextSearchResults(p,E,L,T){return this.a.appendLine(`provideTextSearchResults ${p.pattern}, ${JSON.stringify({...E,folder:E.folder.toString()})}`),new Promise((U,F)=>{T.onCancellationRequested(()=>J());const j=t(p,E),O=E.folder.fsPath,M=j.map(ce=>ce.match(/^-/)?ce:`'${ce}'`).join(" ");this.a.appendLine(`${l} ${M}
 - cwd: ${O}`);let W=D.spawn(l,j,{cwd:O});W.on("error",ce=>{console.error(ce),this.a.appendLine("Error: "+(ce&&ce.message)),F((0,A.$nJ)(new A.$lJ(ce&&ce.message,A.SearchErrorCode.rgProcessError)))});let Y=!1;const ue=new n(E.maxResults,E.folder,E.previewOptions);ue.on("result",ce=>{Y=!0,he="",L.report(ce)});let X=!1;const J=()=>{X=!0,W?.kill(),ue?.cancel()};let x=!1;ue.on("hitLimit",()=>{x=!0,J()});let he="";W.stdout.on("data",ce=>{ue.handleData(ce),Y||(he+=ce)});let Z=!1;W.stdout.once("data",()=>Z=!0);let we="";W.stderr.on("data",ce=>{const K=ce.toString();this.a.appendLine(K),we.length+K.length<1e6&&(we+=K)}),W.on("close",()=>{if(this.a.appendLine(Z?"Got data from stdout":"No data from stdout"),this.a.appendLine(Y?"Got result from parser":"No result from parser"),he&&this.a.appendLine(`Got data without result: ${he}`),this.a.appendLine(""),X)U({limitHit:x});else{ue.flush(),W=null;let ce;we&&!Z&&(ce=s(we))?F((0,A.$nJ)(new A.$lJ(ce.message,ce.code))):U({limitHit:x})}})})}}e.$Jhc=f;function s(w){const p=w.split(`
`),E=p[0].trim();if(p.some(T=>T.startsWith("regex parse error")))return new A.$lJ(i(p),A.SearchErrorCode.regexParseError);const L=E.match(/grep config error: unknown encoding: (.*)/);if(L)return new A.$lJ(`Unknown encoding: ${L[1]}`,A.SearchErrorCode.unknownEncoding);if(E.startsWith("error parsing glob"))return new A.$lJ(E.charAt(0).toUpperCase()+E.substr(1),A.SearchErrorCode.globParseError);if(E.startsWith("the literal"))return new A.$lJ(E.charAt(0).toUpperCase()+E.substr(1),A.SearchErrorCode.invalidLiteral);if(E.startsWith("PCRE2: error compiling pattern"))return new A.$lJ(E,A.SearchErrorCode.regexParseError)}function i(w){const p=["Regex parse error"],E=w.filter(L=>L.startsWith("PCRE2:"));if(E.length>=1){const L=E[0].replace("PCRE2:","");if(L.indexOf(":")!==-1&&L.split(":").length>=2){const T=L.split(":")[1];p.push(":"+T)}}return p.join("")}class n extends N.EventEmitter{constructor(p,E,L){super(),this.g=p,this.h=E,this.j=L,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new g.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(p,E){return super.on(p,E),this}handleData(p){if(this.b)return;const E=typeof p=="string"?p:this.d.write(p);this.k(E)}k(p){let E=p.indexOf(`
`);const L=this.a+p;if(E>=0)E+=this.a.length;else{this.a=L;return}let T=0;for(;E>=0;)this.m(L.substring(T,E).trim()),T=E+1,E=L.indexOf(`
`,T);this.a=L.substring(T)}m(p){if(this.b||!p)return;let E;try{E=JSON.parse(p)}catch{throw new Error(`malformed line from rg: ${p}`)}if(E.type==="match"){const L=o(E.data.path),T=y.URI.joinPath(this.h,L),U=this.n(E.data,T);this.p(U),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(E.type==="context"){const L=o(E.data.path),T=y.URI.joinPath(this.h,L);this.o(E.data,T).forEach(F=>this.p(F))}}n(p,E){const L=p.line_number-1,T=o(p.lines),U=Buffer.from(T);let F=0,j=0,O=L;p.submatches.length===0&&p.submatches.push(T.length?{start:0,end:1,match:{text:T[0]}}:{start:0,end:0,match:{text:""}});const M=(0,I.$Hb)(p.submatches.map((W,Y)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ue=o(W.match),X=U.slice(F,W.start).toString(),J=c(X),x=J.numLines>0?J.lastLineLength:J.lastLineLength+j,he=c(ue),Z=J.numLines+O,we=he.numLines+Z,ce=he.numLines>0?he.lastLineLength:he.lastLineLength+x;return F=W.end,j=ce,O=we,new C.$8I(Z,x,we,ce)}));return(0,k.$Chc)(E,T,M,this.j)}o(p,E){const L=o(p.lines),T=p.line_number;return L.replace(/\r?\n$/,"").split(`
`).map((U,F)=>({text:U,uri:E,lineNumber:T+F}))}p(p){this.emit("result",p)}}e.$Khc=n;function o(w){return w.bytes?Buffer.from(w.bytes,"base64").toString():w.text}function c(w){const p=/\n/g;let E=0,L=-1,T;for(;T=p.exec(w);)E++,L=T.index;const U=L>=0?w.length-L-1:w.length;return{numLines:E,lastLineLength:U}}function t(w,p){const E=["--hidden","--no-require-git"];E.push(w.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:L,otherIncludes:T}=(0,R.$K)(p.includes,F=>F.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(T&&T.length){const F=new Set;T.forEach(j=>{F.add(j)}),E.push("-g","!*"),F.forEach(j=>{r(j).map(k.$Bhc).forEach(O=>{E.push("-g",O)})})}L&&L.length&&L.forEach(F=>{E.push("-g",F)}),p.excludes.map(k.$Bhc).forEach(F=>E.push("-g",`!${F}`)),p.maxFileSize&&E.push("--max-filesize",p.maxFileSize+""),p.useIgnoreFiles?p.useParentIgnoreFiles||E.push("--no-ignore-parent"):E.push("--no-ignore"),p.followSymlinks&&E.push("--follow"),p.encoding&&p.encoding!=="utf8"&&E.push("--encoding",p.encoding),w.pattern==="--"&&(w.isRegExp=!0,w.pattern="\\-\\-"),w.isMultiline&&!w.isRegExp&&(w.pattern=(0,$.$Le)(w.pattern),w.isRegExp=!0),p.usePCRE2&&E.push("--pcre2"),E.push("--crlf"),w.isRegExp&&(w.pattern=d(w.pattern),E.push("--engine","auto"));let U;if(w.isWordMatch){const j=(0,$.$Ue)(w.pattern,!!w.isRegExp,{wholeWord:w.isWordMatch}).source.replace(/\\\//g,"/");E.push("--regexp",j)}else if(w.isRegExp){let F=a(w.pattern);F=h(F),E.push("--regexp",F)}else U=w.pattern,E.push("--fixed-strings");return E.push("--no-config"),p.useGlobalIgnoreFiles||E.push("--no-ignore-global"),E.push("--json"),w.isMultiline&&E.push("--multiline"),p.beforeContext&&E.push("--before-context",p.beforeContext+""),p.afterContext&&E.push("--after-context",p.afterContext+""),E.push("--"),U&&E.push(U),E.push("."),E}e.$Lhc=t;function r(w){return P(w).flatMap(E=>{const L=(0,b.$Hj)(E,"/");return L.map((T,U)=>L.slice(0,U+1).join("/"))})}function d(w){const p=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;w.match(p);)w=w.replace(p,"$1\\x{$2}");const E=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;w.match(E);)w=w.replace(E,"$1\\x{$2}");return w}e.$Mhc=d;const u=w=>w.type==="Assertion"&&w.kind==="lookbehind";function a(w){let p;try{p=new m.RegExpParser().parsePattern(w)}catch{return w}let E="",L=0;const T=(j,O,M)=>{E+=w.slice(L,j)+M,L=O},U=[];return new m.RegExpVisitor({onCharacterEnter(j){if(j.raw!=="\\n")return;const O=U[0];if(!O)T(j.start,j.end,"\\r?\\n");else if(!U.some(u))if(O.type==="CharacterClass")if(O.negate){const M=w.slice(O.start+2,j.start)+w.slice(j.end,O.end-1);O.parent?.type==="Quantifier"?T(O.start,O.end,M?`[^${M}]`:"."):T(O.start,O.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=w.slice(O.start+1,j.start)+w.slice(j.end,O.end-1);T(O.start,O.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else O.type==="Quantifier"&&T(j.start,j.end,"(?:\\r?\\n)")},onQuantifierEnter(j){U.unshift(j)},onQuantifierLeave(){U.shift()},onCharacterClassRangeEnter(j){U.unshift(j)},onCharacterClassRangeLeave(){U.shift()},onCharacterClassEnter(j){U.unshift(j)},onCharacterClassLeave(){U.shift()},onAssertionEnter(j){u(j)&&U.push(j)},onAssertionLeave(j){U[0]===j&&U.shift()}}).visit(p),E+=w.slice(L),E}e.$Nhc=a;function h(w){return w.replace(/\n/g,"\\r?\\n")}e.$Ohc=h;function S(w){let p=!1,E=!1,L="",T="";for(let U=0;U<w.length;U++){const F=w[U];switch(F){case"\\":E?(p?T+="\\"+F:L+="\\"+F,E=!1):E=!0;break;case"{":if(E)p?T+=F:L+=F,E=!1;else{if(p)return{strInBraces:L+"{"+T+"{"+w.substring(U+1)};p=!0}break;case"}":if(E)p?T+=F:L+=F,E=!1;else{if(p)return{fixedStart:L,strInBraces:T,fixedEnd:w.substring(U+1)};L+=F}break;default:p?T+=(E?"\\":"")+F:L+=(E?"\\":"")+F,E=!1;break}}return{strInBraces:L+(p?"{"+T:"")}}function P(w){const{fixedStart:p,strInBraces:E,fixedEnd:L}=S(w);if(p===void 0||L===void 0)return[E];let T=(0,b.$Hj)(E,",");T.length||(T=[""]);const U=P(L);return T.flatMap(F=>{const j=p+F;return U.map(O=>j+O)})}e.$Phc=P}),define(Se[376],ke([1,0,21,156,85,17]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=void 0;class R{constructor(y){this.b=y,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(y,A,C,m){const v=new N.$Jhc(this.b);if(A.folder.scheme===I.Schemas.vscodeUserData){const k={...A,folder:A.folder.with({scheme:I.Schemas.file})},l=new g.$iv(f=>C.report({...f,uri:f.uri.with({scheme:A.folder.scheme})}));return this.c(m,f=>v.provideTextSearchResults(y,k,l,f))}else return this.c(m,k=>v.provideTextSearchResults(y,A,C,k))}async c(y,A){const C=b(y);this.a.add(C);const m=await A(C.token);return this.a.delete(C),m}d(){this.a.forEach(y=>y.cancel())}}e.$Thc=R;function b($){const y=new D.$3d;return $.onCancellationRequested(()=>y.cancel()),y}}),define(Se[377],ke([1,0,31,156,155]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rhc=void 0;class I{constructor($){this.a=$}search($,y,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(v){A({message:v})}},m=new g.$Qhc(this.a,new N.$Jhc(C),D);return new Promise((v,k)=>m.search(l=>{y(l.map(R))},$).then(l=>v({limitHit:l.limitHit,type:"success",stats:l.stats}),k))}}e.$Rhc=I;function R(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce(($,y)=>{if(y.ranges){const A=y;return $+(Array.isArray(A.ranges)?A.ranges.length:1)}else return $+1},0)}}}),define(Se[378],ke([1,0,19,11,14,4,129,16,38,2,32,36,373,377]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Shc=void 0;class k{static{this.a=512}constructor(o="searchProcess"){this.d=o,this.b=Object.create(null)}fileSearch(o){let c;const t=s(o),r=new I.$Sd({onDidAddFirstListener:()=>{c=(0,N.$Qg)(d=>this.doFileSearchWithEngine(m.$Ihc,t,u=>r.fire(u),d)),c.then(d=>r.fire(d),d=>r.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{c.cancel()}});return r.event}textSearch(o){let c;const t=s(o),r=new I.$Sd({onDidAddFirstListener:()=>{c=(0,N.$Qg)(d=>this.f(t,u=>r.fire(u),d)),c.then(d=>r.fire(d),d=>r.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{c.cancel()}});return r.event}f(o,c,t){return o.maxFileSize=this.g().maxFileSize,new v.$Rhc(o).search(t,c,c)}g(){return{maxFileSize:16*A.$Vk.GB}}doFileSearch(o,c,t){return this.doFileSearchWithEngine(m.$Ihc,o,c,t)}doFileSearchWithEngine(o,c,t,r,d=k.a){let u=0;const a=S=>{Array.isArray(S)?(u+=S.length,t(S.map(P=>this.h(P)))):S.relativePath?(u++,t(this.h(S))):t(S)};if(c.sortByScore){let S=this.l(c,a,r);if(!S){const P=c.maxResults?Object.assign({},c,{maxResults:null}):c,w=new o(P);S=this.j(w,c,t,a,r)}return new Promise((P,w)=>{S.then(([p,E])=>{const L=E.map(T=>this.h(T));this.o(L,t,d),P(p)},w)})}const h=new o(c);return this.r(h,a,d,r).then(S=>({limitHit:S.limitHit,type:"success",stats:{detailStats:S.stats,type:this.d,fromCache:!1,resultCount:u,sortingTime:void 0}}))}h(o){return{path:o.base?(0,b.$jc)(o.base,o.relativePath):o.relativePath}}j(o,c,t,r,d){const u=new I.$Sd;let a=(0,N.$Qg)(S=>{let P=[];const w=p=>{Array.isArray(p)?P=p:(r(p),u.fire(p))};return this.r(o,w,-1,S).then(p=>[p,P])}),h;if(c.cacheKey){h=this.k(c.cacheKey);const S={promise:a,event:u.event,resolved:!1};h.resultsToSearchCache[c.filePattern||""]=S,a.then(()=>{S.resolved=!0},P=>{delete h.resultsToSearchCache[c.filePattern||""]}),a=this.s(a)}return a.then(([S,P])=>{const w=h?h.scorerCache:Object.create(null),p=(typeof c.maxResults!="number"||c.maxResults>0)&&$.$Od.create(!1);return this.n(c,P,w,d).then(E=>{const L=p?p.elapsed():-1;return[{type:"success",stats:{detailStats:S.stats,sortingTime:L,fromCache:!1,type:this.d,workspaceFolderCount:c.folderQueries.length,resultCount:E.length},messages:S.messages,limitHit:S.limitHit||typeof c.maxResults=="number"&&P.length>c.maxResults},E]})})}k(o){const c=this.b[o];return c||(this.b[o]=new l)}l(o,c,t){const r=o.cacheKey&&this.b[o.cacheKey];if(!r)return;const d=this.q(r,o.filePattern||"",c,t);if(d)return d.then(([u,a,h])=>{const S=$.$Od.create(!1);return this.n(o,a,r.scorerCache,t).then(P=>{const w=S.elapsed(),p={fromCache:!0,detailStats:h,type:this.d,resultCount:a.length,sortingTime:w};return[{type:"success",limitHit:u.limitHit||typeof o.maxResults=="number"&&a.length>o.maxResults,stats:p},P]})})}n(o,c,t,r){const d=(0,R.$Nq)(o.filePattern||""),u=(h,S)=>(0,R.$Mq)(h,S,d,!0,f,t),a=typeof o.maxResults=="number"?o.maxResults:Number.MAX_VALUE;return D.$Gb(c,u,a,1e4,r)}o(o,c,t){if(t&&t>0)for(let r=0;r<o.length;r+=t)c(o.slice(r,r+t));else c(o)}q(o,c,t,r){const d=$.$Od.create(!1),u=c.indexOf(b.sep)>=0;let a;for(const w in o.resultsToSearchCache)if(c.startsWith(w)){if(u&&w.indexOf(b.sep)<0&&w!=="")continue;const p=o.resultsToSearchCache[w];a={promise:this.s(p.promise),event:p.event,resolved:p.resolved};break}if(!a)return null;const h=d.elapsed(),S=$.$Od.create(!1),P=a.event(t);return r&&r.onCancellationRequested(()=>{P.dispose()}),a.promise.then(([w,p])=>{if(r&&r.isCancellationRequested)throw(0,g.$6)();const E=[],L=(0,R.$Nq)(c).normalizedLowercase;for(const T of p)(0,C.$rJ)(T,L)&&E.push(T);return[w,E,{cacheWasResolved:a.resolved,cacheLookupTime:h,cacheFilterTime:S.elapsed(),cacheEntryCount:p.length}]})}r(o,c,t,r){return new Promise((d,u)=>{let a=[];r?.onCancellationRequested(()=>o.cancel()),o.search(h=>{h&&(t?(a.push(h),t>0&&a.length>=t&&(c(a),a=[])):c(h))},h=>{c(h)},(h,S)=>{a.length&&c(a),h?(c({message:"Search finished. Error: "+h.message}),u(h)):(c({message:"Search finished. Stats: "+JSON.stringify(S.stats)}),d(S))})})}clearCache(o){return delete this.b[o],Promise.resolve(void 0)}s(o){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(c,t){return o.then(c,t)}catch(c){return this.then(void 0,c)}finally(c){return o.finally(c)}}}}e.$Shc=k;class l{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const f=new class{getItemLabel(n){return(0,b.$nc)(n.relativePath)}getItemDescription(n){return(0,b.$mc)(n.relativePath)}getItemPath(n){return n.relativePath}};function s(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(i),extraFileResources:n.extraFileResources&&n.extraFileResources.map(o=>y.URI.revive(o))}}function i(n){return{...n,folder:y.URI.revive(n.folder)}}}),define(Se[379],ke([1,0,3,17,2,31,13,27,20,97,66,36,378,376,119,155]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=void 0;let f=class extends y.$Ggc{constructor(i,n,o,c){super(i,o,c),this.s=I,this.t=-1,this.v=null,this.w=!1,this.x=new D.$Rc;const t=new k.$Dhc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(N.Schemas.vscodeUserData,new v.$Thc(t))),n.remote.isRemote&&n.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new k.$Dhc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(N.Schemas.file,new v.$Thc(i))),this.x.add(this.z(N.Schemas.file,new m.$Shc("fileSearchProvider")))}z(i,n){const o=this.d++;return this.v=n,this.t=o,this.c.$registerFileSearchProvider(o,this.o(i)),(0,D.$Qc)(()=>{this.v=null,this.c.$unregisterProvider(o)})}$provideFileSearchResults(i,n,o,c){const t=(0,y.$Hgc)(o);if(i===this.t){const r=Date.now();return this.A(i,n,t,c).then(d=>{const u=Date.now()-r;return this.n.debug(`Ext host file search time: ${u}ms`),d})}return super.$provideFileSearchResults(i,n,o,c)}doInternalFileSearchWithCustomCallback(i,n,o){const c=t=>{if((0,C.$qJ)(t)&&(t=[t]),Array.isArray(t)){o(t.map(r=>g.URI.file(r.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,c,n)}async A(i,n,o,c){return this.doInternalFileSearchWithCustomCallback(o,c,t=>{this.c.$handleFileMatch(i,n,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,n){return new l.$Qhc(i,n,void 0,"textSearchProvider")}};e.$Uhc=f,e.$Uhc=f=Ge([We(0,$.$UM),We(1,b.$$M),We(2,A.$zfc),We(3,R.$kj)],f)}),define(Se[120],ke([1,0,393,62,63,394,22,14,4,3,16,10,30,81,82]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=void 0;class l{traceSocketEvent(p,E){k.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,p,E)}constructor(p,E=""){this.f=!0,this.debugLabel=E,this.socket=p,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,b.$1)(L)}},this.socket.on("error",this.a),this.b=L=>{this.traceSocketEvent("close",{hadError:L}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(p){const E=L=>{this.traceSocketEvent("read",L),p(R.$ge.wrap(L))};return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(p){const E=L=>{p({type:0,hadError:L,error:void 0})};return this.socket.on("close",E),{dispose:()=>this.socket.off("close",E)}}onEnd(p){const E=()=>{p()};return this.socket.on("end",E),{dispose:()=>this.socket.off("end",E)}}write(p){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",p),this.socket.write(p.buffer,E=>{if(E){if(E.code==="EPIPE")return;(0,b.$1)(E)}})}catch(E){if(E.code==="EPIPE")return;(0,b.$1)(E)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((p,E)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),p();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),p()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.$Rh=l;var f;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize",w[w.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var s;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(s||(s={}));class i extends y.$Sc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(p,E){this.socket.traceSocketEvent(p,E)}constructor(p,E,L,T){super(),this.f=this.B(new $.$Sd),this.g=this.B(new $.$Sd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=p,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:E,inflateBytesLength:L?.byteLength||0,recordInflateBytes:T}),this.a=this.B(new n(this,E,L,T,this.f,(U,F)=>this.m(U,F))),this.B(this.a.onError(U=>{console.error(U),(0,b.$1)(U),this.g.fire({type:0,hadError:!0,error:U})})),this.b=new k.$Mh,this.B(this.socket.onData(U=>this.n(U))),this.B(this.socket.onClose(async U=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(U)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this.f.event(p)}onClose(p){return this.g.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){let E=0;for(;E<p.byteLength;)this.a.writeMessage(p.slice(E,Math.min(E+262144,p.byteLength)),{compressed:!0,opcode:2}),E+=262144}m(p,{compressed:E,opcode:L}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",p);let T=2;p.byteLength<126?T+=0:p.byteLength<2**16?T+=2:T+=8;const U=R.$ge.alloc(T),F=E?64:0,j=L&15;if(U.writeUInt8(128|F|j,0),p.byteLength<126)U.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){U.writeUInt8(126,1);let O=1;U.writeUInt8(p.byteLength>>>8&255,++O),U.writeUInt8(p.byteLength>>>0&255,++O)}else{U.writeUInt8(127,1);let O=1;U.writeUInt8(0,++O),U.writeUInt8(0,++O),U.writeUInt8(0,++O),U.writeUInt8(0,++O),U.writeUInt8(p.byteLength>>>24&255,++O),U.writeUInt8(p.byteLength>>>16&255,++O),U.writeUInt8(p.byteLength>>>8&255,++O),U.writeUInt8(p.byteLength>>>0&255,++O)}this.socket.write(R.$ge.concat([U,p]))}end(){this.h=!0,this.socket.end()}n(p){if(p.byteLength!==0){for(this.b.acceptChunk(p);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const E=this.b.peek(this.j.readLen),L=E.readUInt8(0),T=(L&128)>>>7,U=(L&64)>>>6,F=L&15,j=E.readUInt8(1),O=(j&128)>>>7,M=j&127;this.j.state=2,this.j.readLen=2+(O?4:0)+(M===126?2:0)+(M===127?8:0),this.j.fin=T,this.j.firstFrameOfMessage&&(this.j.compressed=!!U),this.j.firstFrameOfMessage=!!T,this.j.mask=0,this.j.opcode=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const E=this.b.read(this.j.readLen),L=E.readUInt8(1),T=(L&128)>>>7;let U=L&127,F=1;U===126?U=E.readUInt8(++F)*2**8+E.readUInt8(++F):U===127&&(U=E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*2**24+E.readUInt8(++F)*2**16+E.readUInt8(++F)*2**8+E.readUInt8(++F));let j=0;T&&(j=E.readUInt8(++F)*2**24+E.readUInt8(++F)*2**16+E.readUInt8(++F)*2**8+E.readUInt8(++F)),this.j.state=3,this.j.readLen=U,this.j.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const E=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",E),t(E,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",E),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(E,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(E,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Sh=i;class n extends y.$Sc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$ge.alloc(0)}constructor(p,E,L,T,U,F){super(),this.n=p,this.r=U,this.s=F,this.a=this.B(new $.$Sd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$Sd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$Sd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,E?(this.b=this.B(new o(this.n,T,L,{windowBits:15})),this.f=this.B(new c(this.n,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(p,E){this.g.push({data:p,options:E}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:p,options:E}=this.g.shift();if(this.f&&E.compressed){const L=await this.w(this.f,p);this.s(L,E)}else this.s(p,{...E,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(p,E){return new Promise((L,T)=>{p.write(E),p.flush(U=>L(U))})}acceptFrame(p,E,L){this.h.push({data:p,isCompressed:E,isLastFrameOfMessage:L}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const p=this.h.shift();if(this.b&&p.isCompressed){const E=await this.C(this.b,p.data,p.isLastFrameOfMessage);this.r.fire(E)}else this.r.fire(p.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(p,E,L){return new Promise((T,U)=>{p.write(E),L&&p.write(R.$ge.fromByteArray([0,0,255,255])),p.flush(F=>T(F))})}}class o extends y.$Sc{get recordedInflateBytes(){return this.j?R.$ge.concat(this.f):R.$ge.alloc(0)}constructor(p,E,L,T){super(),this.h=p,this.j=E,this.a=this.B(new $.$Sd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,I.createInflateRaw)(T),this.b.on("error",U=>{this.h.traceSocketEvent("zlibInflateError",{message:U?.message,code:U?.code}),this.a.fire(U)}),this.b.on("data",U=>{this.h.traceSocketEvent("zlibInflateData",U),this.g.push(R.$ge.wrap(U))}),L&&(this.h.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this.b.write(L.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(p){this.j&&this.f.push(p.clone()),this.h.traceSocketEvent("zlibInflateWrite",p),this.b.write(p.buffer)}flush(p){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const E=R.$ge.concat(this.g);this.g.length=0,p(E)})}}class c extends y.$Sc{constructor(p,E){super(),this.g=p,this.a=this.B(new $.$Sd),this.onError=this.a.event,this.f=[],this.b=(0,I.createDeflateRaw)({windowBits:15}),this.b.on("error",L=>{this.g.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.g.traceSocketEvent("zlibDeflateData",L),this.f.push(R.$ge.wrap(L))})}write(p){this.g.traceSocketEvent("zlibDeflateWrite",p.buffer),this.b.write(p.buffer)}flush(p){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let E=R.$ge.concat(this.f);this.f.length=0,E=E.slice(0,E.byteLength-4),p(E)})}}function t(w,p){if(p===0)return;const E=w.byteLength>>>2;for(let O=0;O<E;O++){const M=w.readUInt32BE(O*4);w.writeUInt32BE(M^p,O*4)}const L=E*4,T=w.byteLength-L,U=p>>>24&255,F=p>>>16&255,j=p>>>8&255;T>=1&&w.writeUInt8(w.readUInt8(L)^U,L),T>=2&&w.writeUInt8(w.readUInt8(L+1)^F,L+1),T>=3&&w.writeUInt8(w.readUInt8(L+2)^j,L+2)}e.$Th=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function d(){const w=(0,m.$ng)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;const p=process.platform!=="darwin"&&e.$Th?e.$Th:(0,g.tmpdir)(),E=(0,A.$jc)(p,`vscode-ipc-${w}.sock`);return a(E),E}e.$Uh=d;function u(w,p,E){const L=(0,D.createHash)("md5").update(w).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${E}-${p}-sock`;const T=E.substr(0,4),U=p.substr(0,6),F=L.substr(0,8);let j;return process.platform!=="darwin"&&e.$Th&&!process.env.VSCODE_PORTABLE?j=(0,A.$jc)(e.$Th,`vscode-${F}-${T}-${U}.sock`):j=(0,A.$jc)(w,`${T}-${U}.sock`),a(j),j}e.$Vh=u;function a(w){const p=r[C.$u];typeof p=="number"&&w.length>=p&&console.warn(`WARNING: IPC handle "${w}" is longer than ${p} chars, try a shorter --user-data-dir`)}class h extends v.$Gh{static b(p){const E=$.Event.fromNodeEventEmitter(p,"connection");return $.Event.map(E,L=>({protocol:new k.$Nh(new l(L,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(L,"close"))}))}constructor(p){super(h.b(p)),this.d=p}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Wh=h;function S(w){return new Promise((p,E)=>{const L=(0,N.createServer)();L.on("error",E),L.listen(w,()=>{L.removeListener("error",E),p(new h(L))})})}e.$Xh=S;function P(w,p){return new Promise((E,L)=>{const T=(0,N.createConnection)(w,()=>{T.removeListener("error",L),E(k.$Oh.fromSocket(new l(T,`ipc-client${p}`),p))});T.once("error",L)})}e.$Yh=P}),define(Se[380],ke([1,0,62,63,166,120,11,3,10,45,13,136,257,258,109,88,22]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i$b=e.$h$b=e.$g$b=e.$f$b=void 0;async function s(t,r,d,u,a){let h;for(let S=3;S&&(h?.dispose(),h=await new i(t,r,d,u,a).waitForReady(),!(a&&g.$qg[a]||!g.$qg[h.tunnelLocalPort]));S--);return h}class i extends b.$Sc{constructor(r,d,u,a,h){super(),this.m=d,this.n=h,this.privacy=l.TunnelPrivacyId.Private,this.j=new Map,this.a=r,this.b=D.createServer(),this.c=new R.$2g,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=S=>this.r(S),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=a,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const r=this.n??this.tunnelRemotePort,d=(0,l.$uv)(this.m)?"0.0.0.0":"127.0.0.1";let u=await(0,g.$rg)(r,2,1e3,d),a=null;return this.b.listen(u,this.m),await this.c.wait(),a=this.b.address(),a||(u=0,this.b.listen(u,this.m),await this.c.wait(),a=this.b.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async r(r){r.pause();const d=(0,l.$sv)(this.tunnelRemoteHost)||(0,l.$uv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,m.$il)(this.a,d,this.tunnelRemotePort),a=u.getSocket(),h=u.readEntireBuffer();u.dispose(),h.byteLength>0&&r.write(h.buffer),r.on("end",()=>{r.localAddress&&this.j.delete(r.localAddress),a.end()}),r.on("close",()=>a.end()),r.on("error",()=>{r.localAddress&&this.j.delete(r.localAddress),a instanceof I.$Rh?a.socket.destroy():a.end()}),a instanceof I.$Rh?this.t(r,a):this.s(r,a),r.localAddress&&this.j.set(r.localAddress,()=>{r.end(),a.end()})}s(r,d){d.onClose(()=>r.destroy()),d.onEnd(()=>r.end()),d.onData(u=>r.write(u.buffer)),r.on("data",u=>d.write(f.$ge.wrap(u))),r.resume()}t(r,d){const u=d.socket;u.on("end",()=>r.end()),u.on("close",()=>r.end()),u.on("error",()=>{r.destroy()}),u.pipe(r),r.pipe(u)}}e.$f$b=i;let n=class extends l.$xv{constructor(r,d,u,a,h){super(d,h),this.u=r,this.v=u,this.w=a}isPortPrivileged(r){return(0,l.$vv)(r,this.l,$.OS,N.release())}s(r,d,u,a,h,S,P,w){const p=this.r(d,u);if(p)return++p.refcount,p.value;if((0,l.$pv)(r))return this.t(r,d,u,h,S,P,w);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${u} on local port ${h}.`);const E={commit:this.w.commit,quality:this.w.quality,addressProvider:r,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},L=s(E,a,d,u,h);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(d,u,L),L}}};e.$g$b=n,e.$g$b=n=Ge([We(0,v.$cl),We(1,A.$kj),We(2,k.$fl),We(3,C.$Cj),We(4,y.$wi)],n);let o=class extends n{constructor(r,d,u,a,h){super(r,d,u,a,h)}};e.$h$b=o,e.$h$b=o=Ge([We(0,v.$cl),We(1,A.$kj),We(2,k.$fl),We(3,C.$Cj),We(4,y.$wi)],o);let c=class extends b.$Sc{constructor(r,d,u,a,h){super(),this.b=r,this.c=d,this.f=u,this.g=a,this.h=h,this.a=new Map}async openTunnel(r,d,u,a,h,S,P,w,p){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${a} on local port ${S}.`),!this.a.has(r)){const E=new o(this.b,this.c,this.g,this.f,this.h);this.B(E),this.a.set(r,E),E.onTunnelClosed(async()=>{(await E.tunnels).length===0&&(E.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(d,u,a,h,S,P,w,p)}};e.$i$b=c,e.$i$b=c=Ge([We(0,v.$cl),We(1,A.$kj),We(2,C.$Cj),We(3,k.$fl),We(4,y.$wi)],c)}),define(Se[381],ke([1,0,120,277,56,35,2,13,40]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kN=e.$jN=void 0;class y{constructor(m,v,k){this.b=m,this.c=v,this.f=k,this.a=N.createServer((l,f)=>this.h(l,f)),this.g().catch(l=>(v.error(l),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",m=>this.c.error(m))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(m,v){const k=(f,s)=>{v.writeHead(f,{"content-type":"application/json"}),v.end(JSON.stringify(s||null),i=>i&&this.c.error(i))},l=[];m.setEncoding("utf8"),m.on("data",f=>l.push(f)),m.on("end",async()=>{try{const f=JSON.parse(l.join(""));let s;switch(f.type){case"open":s=await this.i(f);break;case"openExternal":s=await this.j(f);break;case"status":s=await this.l(f);break;case"extensionManagement":s=await this.k(f);break;default:k(404,`Unknown message type: ${f.type}`);break}k(200,s)}catch(f){const s=f instanceof Error?f.message:JSON.stringify(f);k(500,s),this.c.error("Error while processing pipe request",f)}})}async i(m){const{fileURIs:v,folderURIs:k,forceNewWindow:l,diffMode:f,mergeMode:s,addMode:i,forceReuseWindow:n,gotoLineMode:o,waitMarkerFilePath:c,remoteAuthority:t}=m,r=[];if(Array.isArray(k))for(const h of k)try{r.push({folderUri:R.URI.parse(h)})}catch{}if(Array.isArray(v))for(const h of v)try{(0,$.$vi)(h)?r.push({workspaceUri:R.URI.parse(h)}):r.push({fileUri:R.URI.parse(h)})}catch{}const d=c?R.URI.file(c):void 0,a={forceNewWindow:l,diffMode:f,mergeMode:s,addMode:i,gotoLineMode:o,forceReuseWindow:n,preferNewWindow:!n&&!d&&!i,waitMarkerFileURI:d,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",r,a)}async j(m){for(const v of m.uris){const k=R.URI.parse(v),l=k.scheme==="file"?k:v;await this.b.executeCommand("_remoteCLI.openExternal",l)}}async k(m){const v=l=>l?.map(f=>/\.vsix$/i.test(f)?R.URI.parse(f):f),k={list:m.list,install:v(m.install),uninstall:v(m.uninstall),force:m.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",k)}async l(m){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&g.existsSync(this.f)&&g.unlinkSync(this.f)}}e.$jN=y;let A=class extends y{constructor(m,v){super(m,v,(0,D.$Uh)())}};e.$kN=A,e.$kN=A=Ge([We(0,I.$eN),We(1,b.$kj)],A)}),define(Se[382],ke([1,0,57,369,364,276,48,349,2,17,7,381,103,347,348]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=void 0;class l extends g.$ohc{j(){const i=this,n=globalThis._VSCODE_NODE_MODULES.module,o=n._load;n._load=function(d,u,a){return d=t(d),i.a.has(d)?i.a.get(d).load(d,$.URI.file((0,m.$kq)(u.filename)),h=>o.apply(this,[h,u,a])):o.apply(this,arguments)};const c=n._resolveLookupPaths;n._resolveLookupPaths=(r,d)=>c.call(this,t(r),d);const t=r=>{for(const d of i.b){const u=d(r);if(u){r=u;break}}return r}}}class f extends R.$dgc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async tb(){this.h.createInstance(v.$Xhc);const i=this.h.invokeFunction(N.$khc);if(this.h.createInstance(b.$Whc),this.f.remote.isRemote&&this.f.remote.authority){const c=this.h.createInstance(C.$kN);process.env.VSCODE_IPC_HOOK_CLI=c.ipcHandlePath}this.h.createInstance(k.$Yhc),await this.h.createInstance(l,i,{mine:this.J,all:this.L}).install(),D.mark("code/extHost/didInitAPI");const o=await this.m.getConfigProvider();await(0,I.$Vhc)(this.j,o,this,this.s,this.z,this.f),D.mark("code/extHost/didInitProxyResolver")}ub(i){return i.main}async vb(i,n,o){if(n.scheme!==y.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let c=null;o.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&D.mark(`code/extHost/willLoadExtensionCode/${t}`),c=me.__$__nodeRequire(n.fsPath)}finally{t&&D.mark(`code/extHost/didLoadExtensionCode/${t}`),o.codeLoadingStop()}return c}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const n in i){const o=i[n];o===null?delete process.env[n]:process.env[n]=o}}}e.$Zhc=f}),define(Se[383],ke([1,0,51,22,4,3,122,10,23,2,31,13,256,64,109,88,380,27,20,72,358]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l,f,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8hc=e.$7hc=e.$6hc=e.$5hc=e.$4hc=e.$3hc=e.$2hc=e.$1hc=void 0;function c(p){const E=p.trim().split(`
`),L=[];return E.forEach(U=>{const F=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(U);F&&F.length>=3&&L.push({pid:parseInt(F[1],10),socket:parseInt(F[2],10)})}),L.reduce((U,F)=>(U[F.socket]=F,U),{})}e.$1hc=c;function t(...p){const E=[].concat(...p.map(d));return[...new Map(E.filter(L=>L.st==="0A").map(L=>{const T=L.local_address.split(":");return{socket:parseInt(L.inode,10),ip:r(T[0]),port:parseInt(T[1],16)}}).map(L=>[L.ip+":"+L.port,L])).values()]}e.$2hc=t;function r(p){let E="";if(p.length===8)for(let L=p.length-2;L>=0;L-=2)E+=parseInt(p.substr(L,2),16),L!==0&&(E+=".");else for(let L=0;L<p.length;L+=8){const T=p.substring(L,L+8);let U="";for(let F=8;F>=2;F-=2)U+=T.substring(F-2,F),(F===6||F===2)&&(U=parseInt(U,16).toString(16),E+=`${U}`,U="",L+F!==p.length-6&&(E+=":"))}return E}e.$3hc=r;function d(p){const E=p.trim().split(`
`),L=E.shift().trim().split(/\s+/).filter(U=>U!=="rx_queue"&&U!=="tm->when");return E.map(U=>U.trim().split(/\s+/).reduce((F,j,O)=>(F[L[O]||O]=j,F),{}))}e.$4hc=d;function u(p){return!!p.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||p.indexOf("out/server-main.js")!==-1||p.indexOf("_productName=VSCode")!==-1}function a(p){const E=p.trim().split(`
`),L=[];return E.forEach(T=>{const U=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(T);U&&U.length>=4&&L.push({pid:parseInt(U[1],10),ppid:parseInt(U[2]),cmd:U[3]})}),L}e.$5hc=a;async function h(p,E,L){const T=L.reduce((F,j)=>(F[j.pid]=j,F),{}),U=[];return p.forEach(({socket:F,ip:j,port:O})=>{const M=E[F]?E[F].pid:void 0,W=M?T[M]?.cmd:void 0;M&&W&&!u(W)&&U.push({host:j,port:O,detail:W,pid:M})}),U}e.$6hc=h;function S(p,E,L){const T=new Map,U=a(E);for(const F of p){const j=L.get(F.port);if(j){T.set(F.port,j);continue}const O=U.find(M=>M.cmd.includes(`${F.port}`));if(O){let M=O,W;do W=U.find(Y=>Y.ppid===M.pid),W&&(M=W);while(W);T.set(F.port,{host:F.ip,port:F.port,pid:M.pid,detail:M.cmd,ppid:M.ppid})}else T.set(F.port,{host:F.ip,port:F.port,ppid:Number.MAX_VALUE})}return T}e.$7hc=S;let P=class extends n.$dyb{constructor(E,L,T,U){super(E,L,T),this.D=L,this.F=U,this.y=void 0,this.z=new Map,this.C=!1,b.$k&&L.remote.isRemote&&L.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(E){if(E&&this.C)return;this.C=E;let L;this.y&&(L=this.y,await this.a.$onFoundNewCandidates(this.y));const T=new R.$7l;let U=0;for(;this.C;){const F=new Date().getTime(),j=(await this.I()).filter(W=>(0,l.$sv)(W.host)||(0,l.$uv)(W.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${j.map(W=>W.port).join(", ")}`);const O=new Date().getTime()-F;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${O} ms.`),U++>3&&T.update(O),(!L||JSON.stringify(L)!==JSON.stringify(j))&&(L=j,await this.a.$onFoundNewCandidates(L));const M=this.G(T.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${M} ms.`),await new Promise(W=>setTimeout(()=>W(),M))}}G(E){return Math.max(E*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(E=>E.port).join(", ")}`)}async I(){let E="",L="";try{E=await A.Promises.readFile("/proc/net/tcp","utf8"),L=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const T=t(E,L),U=await new Promise(X=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(J,x,he)=>{X(x)})}),F=c(U),j=await A.Promises.readdir("/proc"),O=[];for(const X of j)try{const J=Number(X),x=$.$Eg(y.URI.file("/proc"),X);if((await A.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(J)){const Z=await A.Promises.readlink($.$Eg(x,"cwd").fsPath),we=await A.Promises.readFile($.$Eg(x,"cmdline").fsPath,"utf8");O.push({pid:J,cwd:Z,cmd:we})}}catch{}const M=[],W=T.filter(X=>{const J=F[X.socket];return J||M.push(X),J}),Y=h(W,F,O);let ue;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${M.length}`),M.length>0){const X=await new Promise(J=>{(0,D.exec)("ps -F -A -l | grep root",(x,he,Z)=>{J(he)})});this.z=S(M,X,this.z),ue=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ue.map(J=>J.port).join(", ")}`)}return Y.then(X=>ue?X.concat(ue):X)}w(E){return async L=>{const T=new f.$f$b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(F,j,O,M){const W=await E.makeConnection();return w.connect(W,j,O,M)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new v.$6k(0),connectionToken:E.connectionToken})}},signService:this.F},"localhost",L.remoteAddress.host||"localhost",L.remoteAddress.port,L.localAddressPort);await T.waitForReady();const U=new g.$Sd;return{localAddress:(0,o.$eK)(T.localAddress)??T.localAddress,remoteAddress:{port:T.tunnelRemotePort,host:T.tunnelRemoteHost},onDidDispose:U.event,dispose:()=>{T.dispose(),U.fire(),U.dispose()}}}}};e.$8hc=P,e.$8hc=P=Ge([We(0,i.$UM),We(1,s.$$M),We(2,C.$kj),We(3,k.$fl)],P);class w extends m.$irb{static connect(E,L,T,U){const F=new I.$Rc,j={onClose:F.add(new g.$Sd),onData:F.add(new g.$Sd),onEnd:F.add(new g.$Sd)};F.add(E.onDidReceiveMessage(M=>j.onData.fire(N.$ge.wrap(M)))),F.add(E.onDidEnd(()=>j.onEnd.fire())),F.add(E.onDidClose(M=>j.onClose.fire({type:0,error:M,hadError:!!M})));const O=new w(E,U,j);return O.B(F),(0,m.$hrb)(O,L,T,U,j)}constructor(E,L,T){super(L,T),this.n=E}write(E){this.n.send(E.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Se[384],ke([1,0,106,352,367,366,379,382,383,96,48,97,95,47,72,92,351,350,13,368,59,271,105,109,138]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l,f,s,i,n,o,c,t,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Lr)(A.$egc,b.$Zhc,0),(0,D.$Lr)(i.$lj,s.$0hc,1),(0,D.$Lr)(i.$kj,new t.$Zh(c.$nhc,[!1],!0)),(0,D.$Lr)(r.$fl,d.$k$b,1),(0,D.$Lr)(l.$Ifc,f.$9hc,0),(0,D.$Lr)(y.$jgc,I.$Ahc,0),(0,D.$Lr)(C.$Fgc,R.$Uhc,0),(0,D.$Lr)(m.$9gc,g.$shc,0),(0,D.$Lr)(v.$4fc,N.$rhc,0),(0,D.$Lr)(k.$cyb,$.$8hc,0),(0,D.$Lr)(o.$hgc,n.$$hc,0)}),define(Se[395],ke([1,0,62,396,57,14,82,120,254,114,365,22,31,103,11,132,278,292,370,384]),function(me,e,D,N,g,I,R,b,$,y,A,C,m,v,k,l,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let S=0;S<process.execArgv.length;S++)process.execArgv[S]==="--inspect-port=0"&&(process.execArgv.splice(S,1),S--)}();const i=N(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const h=globalThis._VSCODE_NODE_MODULES.module,S=h._load;h._load=function(P){if(P==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return S.apply(this,arguments)}})();const n=process.exit.bind(process),o=process.on.bind(process);function c(h){process.exit=function(S){if(h)n(S);else{const P=new Error("An extension called process.exit() and this was prevented.");console.warn(P.stack)}},process.crash=function(){const S=new Error("An extension called process.crash() and this was prevented.");console.warn(S.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(S,P){S==="uncaughtException"&&(P=function(){try{return P.call(void 0,arguments)}catch{}}),o(S,P)}}let t=function(h){n()};function r(){const h=(0,s.$Qm)(process.env);if(h.type===3)return new Promise((S,P)=>{const w=p=>{const E=p[0],L=new R.$Ph;E.on("message",T=>L.fire(C.$ge.wrap(T.data))),E.on("close",()=>{t("renderer closed the MessagePort")}),E.start(),S({onMessage:L.event,send:T=>E.postMessage(T.buffer)})};process.parentPort.on("message",p=>w(p.ports))});if(h.type===2)return new Promise((S,P)=>{let w=null;const p=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),E=108e5,L=3e5,T=new k.$dh(()=>t("renderer disconnected for too long (1)"),E),U=new k.$dh(()=>t("renderer disconnected for too long (2)"),L);process.on("message",(j,O)=>{if(j&&j.type==="VSCODE_EXTHOST_IPC_SOCKET"){O.setNoDelay(!0);const M=C.$ge.wrap(Buffer.from(j.initialDataChunk,"base64"));let W;if(j.skipWebSocketFrames)W=new b.$Rh(O,"extHost-socket");else{const Y=C.$ge.wrap(Buffer.from(j.inflateBytes,"base64"));W=new b.$Sh(new b.$Rh(O,"extHost-socket"),j.permessageDeflate,Y,!1)}w?(T.cancel(),U.cancel(),w.beginAcceptReconnection(W,M),w.endAcceptReconnection(),w.sendResume()):(clearTimeout(p),w=new R.$Qh({socket:W,initialChunk:M}),w.sendResume(),w.onDidDispose(()=>t("renderer disconnected")),S(w),w.onSocketClose(()=>{T.schedule()}))}if(j&&j.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(U.isScheduled())return;T.isScheduled()&&U.schedule()}});const F={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(F)});{const S=h.pipeName;return new Promise((P,w)=>{const p=D.createConnection(S,()=>{p.removeListener("error",w);const E=new R.$Qh({socket:new b.$Rh(p,"extHost-renderer")});E.sendResume(),P(E)});p.once("error",w),p.on("close",()=>{t("renderer closed the socket")})})}}async function d(){const h=await r();return new class{constructor(){this.a=new R.$Ph,this.onMessage=this.a.event,this.b=!1,h.onMessage(S=>{(0,y.$rm)(S,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(S)})}send(S){this.b||h.send(S)}async drain(){if(h.drain)return h.drain()}}}function u(h){return new Promise(S=>{const P=h.onMessage(w=>{P.dispose();const p=JSON.parse(w.toString()),E=p.commit,L=$.default.commit;if(E&&L&&E!==L&&n(55),p.parentPid){let T=0;setInterval(function(){try{process.kill(p.parentPid,0),T=0}catch(F){F&&F.code==="EPERM"?(T++,T>=3&&t(`parent process ${p.parentPid} does not exist anymore (3 x EPERM): ${F.message} (code: ${F.code}) (errno: ${F.errno})`)):t(`parent process ${p.parentPid} does not exist anymore: ${F.message} (code: ${F.code}) (errno: ${F.errno})`)}},1e3);let U;try{U=globalThis._VSCODE_NODE_MODULES["native-watchdog"],U.start(p.parentPid)}catch(F){(0,I.$1)(F)}}h.send((0,y.$qm)(0)),S({protocol:h,initData:p})});h.send((0,y.$qm)(1))})}async function a(){const h=[];process.on("unhandledRejection",(T,U)=>{h.push(U),setTimeout(()=>{const F=h.indexOf(U);F>=0&&U.catch(j=>{h.splice(F,1),(0,I.$4)(j)||(console.warn(`rejected promise not handled within 1 second: ${j}`),j&&j.stack&&console.warn(`stack trace: ${j.stack}`),T&&(0,I.$1)(T))})},1e3)}),process.on("rejectionHandled",T=>{const U=h.indexOf(T);U>=0&&h.splice(U,1)}),process.on("uncaughtException",function(T){(0,I.$Z)(T)||(0,I.$1)(T)}),g.mark("code/extHost/willConnectToRenderer");const S=await d();g.mark("code/extHost/didConnectToRenderer");const P=await u(S);g.mark("code/extHost/didWaitForInitData");const{initData:w}=P;c(!!w.environment.extensionTestsLocationURI),w.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,w.environment.skipWorkspaceStorageLock=(0,l.boolean)(i.skipWorkspaceStorageLock,!1);const p=new class{constructor(){this.pid=process.pid}exit(U){n(U)}fsExists(U){return m.Promises.exists(U)}fsRealpath(U){return(0,v.$jq)(U)}};let E=null;w.remote.authority&&i.transformURIs&&(E=(0,f.$Pr)(w.remote.authority));const L=new A.$qhc(P.protocol,w,p,E);t=T=>L.terminate(T)}a().catch(h=>console.log(h))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a017b12b9caa3475675cfe6fda014fcf5af388c9/core/vs/workbench/api/node/extensionHostProcess.js.map
