/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/strings","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostCommands","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/themables","vs/base/common/extpath","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Re=function(ge){for(var e=[],E=0,T=ge.length;E<T;E++)e[E]=Ce[ge[E]];return e};define(Ce[66],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.$vh=e.$uh=void 0;function E(R){return($,g,w)=>{let A=null,D=null;if(typeof w.value=="function"?(A="value",D=w.value):typeof w.get=="function"&&(A="get",D=w.get),!D)throw new Error("not supported");w[A]=R(D,g)}}function T(R,$,g){let w=null,A=null;if(typeof g.value=="function"?(w="value",A=g.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(w="get",A=g.get),!A)throw new Error("not supported");const D=`$memoize$${$}`;g[w]=function(...l){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,l)}),this[D]}}e.$uh=T;function I(R,$,g){return E((w,A)=>{const D=`$debounce$${A}`,l=`$debounce$result$${A}`;return function(...p){this[l]||(this[l]=g?g():void 0),clearTimeout(this[D]),$&&(this[l]=$(this[l],...p),p=[this[l]]),this[D]=setTimeout(()=>{w.apply(this,p),this[l]=g?g():void 0},R)}})}e.$vh=I;function F(R,$,g){return E((w,A)=>{const D=`$throttle$timer$${A}`,l=`$throttle$result$${A}`,p=`$throttle$lastRun$${A}`,b=`$throttle$pending$${A}`;return function(...r){if(this[l]||(this[l]=g?g():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),$&&(this[l]=$(this[l],...r)),this[b])return;const o=this[p]+R;o<=Date.now()?(this[p]=Date.now(),w.apply(this,[this[l]]),this[l]=g?g():void 0):(this[b]=!0,this[D]=setTimeout(()=>{this[b]=!1,this[p]=Date.now(),w.apply(this,[this[l]]),this[l]=g?g():void 0},o-Date.now()))}})}e.$wh=F}),define(Ce[89],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1M=e.$ZM=void 0;class E{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.$ZM=E,e.$1M=new E("id#")}),define(Ce[119],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var T;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var I;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var F;(function(i){i.DEFAULT={allowTrailingComma:!0}})(F||(e.ParseOptions=F={}));function R(i,s=!1){let u=0;const d=i.length;let m="",f=0,S=16,L=0;function v(W){let P=0,C=0;for(;P<W;){const J=i.charCodeAt(u);if(J>=48&&J<=57)C=C*16+J-48;else if(J>=65&&J<=70)C=C*16+J-65+10;else if(J>=97&&J<=102)C=C*16+J-97+10;else break;u++,P++}return P<W&&(C=-1),C}function y(W){u=W,m="",f=0,S=16,L=0}function k(){const W=u;if(i.charCodeAt(u)===48)u++;else for(u++;u<i.length&&w(i.charCodeAt(u));)u++;if(u<i.length&&i.charCodeAt(u)===46)if(u++,u<i.length&&w(i.charCodeAt(u)))for(u++;u<i.length&&w(i.charCodeAt(u));)u++;else return L=3,i.substring(W,u);let P=u;if(u<i.length&&(i.charCodeAt(u)===69||i.charCodeAt(u)===101))if(u++,(u<i.length&&i.charCodeAt(u)===43||i.charCodeAt(u)===45)&&u++,u<i.length&&w(i.charCodeAt(u))){for(u++;u<i.length&&w(i.charCodeAt(u));)u++;P=u}else L=3;return i.substring(W,P)}function N(){let W="",P=u;for(;;){if(u>=d){W+=i.substring(P,u),L=2;break}const C=i.charCodeAt(u);if(C===34){W+=i.substring(P,u),u++;break}if(C===92){if(W+=i.substring(P,u),u++,u>=d){L=2;break}switch(i.charCodeAt(u++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:{const ae=v(4);ae>=0?W+=String.fromCharCode(ae):L=4;break}default:L=5}P=u;continue}if(C>=0&&C<=31)if(g(C)){W+=i.substring(P,u),L=2;break}else L=6;u++}return W}function O(){if(m="",L=0,f=u,u>=d)return f=d,S=17;let W=i.charCodeAt(u);if($(W)){do u++,m+=String.fromCharCode(W),W=i.charCodeAt(u);while($(W));return S=15}if(g(W))return u++,m+=String.fromCharCode(W),W===13&&i.charCodeAt(u)===10&&(u++,m+=`
`),S=14;switch(W){case 123:return u++,S=1;case 125:return u++,S=2;case 91:return u++,S=3;case 93:return u++,S=4;case 58:return u++,S=6;case 44:return u++,S=5;case 34:return u++,m=N(),S=10;case 47:{const P=u-1;if(i.charCodeAt(u+1)===47){for(u+=2;u<d&&!g(i.charCodeAt(u));)u++;return m=i.substring(P,u),S=12}if(i.charCodeAt(u+1)===42){u+=2;const C=d-1;let J=!1;for(;u<C;){if(i.charCodeAt(u)===42&&i.charCodeAt(u+1)===47){u+=2,J=!0;break}u++}return J||(u++,L=1),m=i.substring(P,u),S=13}return m+=String.fromCharCode(W),u++,S=16}case 45:if(m+=String.fromCharCode(W),u++,u===d||!w(i.charCodeAt(u)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return m+=k(),S=11;default:for(;u<d&&K(W);)u++,W=i.charCodeAt(u);if(f!==u){switch(m=i.substring(f,u),m){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return m+=String.fromCharCode(W),u++,S=16}}function K(W){if($(W)||g(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let W;do W=O();while(W>=12&&W<=15);return W}return{setPosition:y,getPosition:()=>u,scan:s?j:O,getToken:()=>S,getTokenValue:()=>m,getTokenOffset:()=>f,getTokenLength:()=>u-f,getTokenError:()=>L}}e.$0m=R;function $(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function g(i){return i===10||i===13||i===8232||i===8233}function w(i){return i>=48&&i<=57}var A;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(A||(A={}));function D(i,s){const u=[],d=new Object;let m;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function L(v,y,k,N){f.value=v,f.offset=y,f.length=k,f.type=N,f.colonOffset=void 0,m=f}try{a(i,{onObjectBegin:(v,y)=>{if(s<=v)throw d;m=void 0,S=s>v,u.push("")},onObjectProperty:(v,y,k)=>{if(s<y||(L(v,y,k,"property"),u[u.length-1]=v,s<=y+k))throw d},onObjectEnd:(v,y)=>{if(s<=v)throw d;m=void 0,u.pop()},onArrayBegin:(v,y)=>{if(s<=v)throw d;m=void 0,u.push(0)},onArrayEnd:(v,y)=>{if(s<=v)throw d;m=void 0,u.pop()},onLiteralValue:(v,y,k)=>{if(s<y||(L(v,y,k,h(v)),s<=y+k))throw d},onSeparator:(v,y,k)=>{if(s<=y)throw d;if(v===":"&&m&&m.type==="property")m.colonOffset=y,S=!1,m=void 0;else if(v===","){const N=u[u.length-1];typeof N=="number"?u[u.length-1]=N+1:(S=!0,u[u.length-1]=""),m=void 0}}})}catch(v){if(v!==d)throw v}return{path:u,previousNode:m,isAtPropertyKey:S,matches:v=>{let y=0;for(let k=0;y<v.length&&k<u.length;k++)if(v[y]===u[k]||v[y]==="*")y++;else if(v[y]!=="**")return!1;return y===v.length}}}e.$$m=D;function l(i,s=[],u=F.DEFAULT){let d=null,m=[];const f=[];function S(v){Array.isArray(m)?m.push(v):d!==null&&(m[d]=v)}return a(i,{onObjectBegin:()=>{const v={};S(v),f.push(m),m=v,d=null},onObjectProperty:v=>{d=v},onObjectEnd:()=>{m=f.pop()},onArrayBegin:()=>{const v=[];S(v),f.push(m),m=v,d=null},onArrayEnd:()=>{m=f.pop()},onLiteralValue:S,onError:(v,y,k)=>{s.push({error:v,offset:y,length:k})}},u),m[0]}e.$_m=l;function p(i,s=[],u=F.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function m(v){d.type==="property"&&(d.length=v-d.offset,d=d.parent)}function f(v){return d.children.push(v),v}a(i,{onObjectBegin:v=>{d=f({type:"object",offset:v,length:-1,parent:d,children:[]})},onObjectProperty:(v,y,k)=>{d=f({type:"property",offset:y,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:v,offset:y,length:k,parent:d})},onObjectEnd:(v,y)=>{d.length=v+y-d.offset,d=d.parent,m(v+y)},onArrayBegin:(v,y)=>{d=f({type:"array",offset:v,length:-1,parent:d,children:[]})},onArrayEnd:(v,y)=>{d.length=v+y-d.offset,d=d.parent,m(v+y)},onLiteralValue:(v,y,k)=>{f({type:h(v),offset:y,length:k,parent:d,value:v}),m(y+k)},onSeparator:(v,y,k)=>{d.type==="property"&&(v===":"?d.colonOffset=y:v===","&&m(y))},onError:(v,y,k)=>{s.push({error:v,offset:y,length:k})}},u);const L=d.children[0];return L&&delete L.parent,L}e.$an=p;function b(i,s){if(!i)return;let u=i;for(const d of s)if(typeof d=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let m=!1;for(const f of u.children)if(Array.isArray(f.children)&&f.children[0].value===d){u=f.children[1],m=!0;break}if(!m)return}else{const m=d;if(u.type!=="array"||m<0||!Array.isArray(u.children)||m>=u.children.length)return;u=u.children[m]}return u}e.$bn=b;function r(i){if(!i.parent||!i.parent.children)return[];const s=r(i.parent);if(i.parent.type==="property"){const u=i.parent.children[0].value;s.push(u)}else if(i.parent.type==="array"){const u=i.parent.children.indexOf(i);u!==-1&&s.push(u)}return s}e.$cn=r;function o(i){switch(i.type){case"array":return i.children.map(o);case"object":{const s=Object.create(null);for(const u of i.children){const d=u.children[1];d&&(s[u.children[0].value]=o(d))}return s}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$dn=o;function t(i,s,u=!1){return s>=i.offset&&s<i.offset+i.length||u&&s===i.offset+i.length}e.$en=t;function n(i,s,u=!1){if(t(i,s,u)){const d=i.children;if(Array.isArray(d))for(let m=0;m<d.length&&d[m].offset<=s;m++){const f=n(d[m],s,u);if(f)return f}return i}}e.$fn=n;function a(i,s,u=F.DEFAULT){const d=R(i,!1);function m(ee){return ee?()=>ee(d.getTokenOffset(),d.getTokenLength()):()=>!0}function f(ee){return ee?ke=>ee(ke,d.getTokenOffset(),d.getTokenLength()):()=>!0}const S=m(s.onObjectBegin),L=f(s.onObjectProperty),v=m(s.onObjectEnd),y=m(s.onArrayBegin),k=m(s.onArrayEnd),N=f(s.onLiteralValue),O=f(s.onSeparator),K=m(s.onComment),j=f(s.onError),W=u&&u.disallowComments,P=u&&u.allowTrailingComma;function C(){for(;;){const ee=d.scan();switch(d.getTokenError()){case 4:J(14);break;case 5:J(15);break;case 3:J(13);break;case 1:W||J(11);break;case 2:J(12);break;case 6:J(16);break}switch(ee){case 12:case 13:W?J(10):K();break;case 16:J(1);break;case 15:case 14:break;default:return ee}}}function J(ee,ke=[],se=[]){if(j(ee),ke.length+se.length>0){let _=d.getToken();for(;_!==17;){if(ke.indexOf(_)!==-1){C();break}else if(se.indexOf(_)!==-1)break;_=C()}}}function ae(ee){const ke=d.getTokenValue();return ee?N(ke):L(ke),C(),!0}function fe(){switch(d.getToken()){case 11:{let ee=0;try{ee=JSON.parse(d.getTokenValue()),typeof ee!="number"&&(J(2),ee=0)}catch{J(2)}N(ee);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return C(),!0}function be(){return d.getToken()!==10?(J(3,[],[2,5]),!1):(ae(!1),d.getToken()===6?(O(":"),C(),ve()||J(4,[],[2,5])):J(5,[],[2,5]),!0)}function ye(){S(),C();let ee=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(ee||J(4,[],[]),O(","),C(),d.getToken()===2&&P)break}else ee&&J(6,[],[]);be()||J(4,[],[2,5]),ee=!0}return v(),d.getToken()!==2?J(7,[2],[]):C(),!0}function he(){y(),C();let ee=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(ee||J(4,[],[]),O(","),C(),d.getToken()===4&&P)break}else ee&&J(6,[],[]);ve()||J(4,[],[4,5]),ee=!0}return k(),d.getToken()!==4?J(8,[4],[]):C(),!0}function ve(){switch(d.getToken()){case 3:return he();case 1:return ye();case 10:return ae(!0);default:return fe()}}return C(),d.getToken()===17?u.allowEmptyContent?!0:(J(4,[],[]),!1):ve()?(d.getToken()!==17&&J(9,[],[]),!0):(J(4,[],[]),!1)}e.$gn=a;function c(i,s){const u=R(i),d=[];let m,f=0,S;do switch(S=u.getPosition(),m=u.scan(),m){case 12:case 13:case 17:f!==S&&d.push(i.substring(f,S)),s!==void 0&&d.push(u.getTokenValue().replace(/[^\r\n]/g,s)),f=u.getPosition();break}while(m!==17);return d.join("")}e.$hn=c;function h(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$in=h}),function(ge,e){typeof define=="function"&&define.amd?define(Ce[120],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(Pe,ce){for(var ie=0;ie<ce.length;ie++){var Q=ce[ie];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(Pe,Q.key,Q)}}function E(Pe,ce,ie){return ce&&e(Pe.prototype,ce),ie&&e(Pe,ie),Object.defineProperty(Pe,"prototype",{writable:!1}),Pe}function T(Pe,ce){if(Pe){if(typeof Pe=="string")return I(Pe,ce);var ie=Object.prototype.toString.call(Pe).slice(8,-1);if(ie==="Object"&&Pe.constructor&&(ie=Pe.constructor.name),ie==="Map"||ie==="Set")return Array.from(Pe);if(ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ie))return I(Pe,ce)}}function I(Pe,ce){(ce==null||ce>Pe.length)&&(ce=Pe.length);for(var ie=0,Q=new Array(ce);ie<ce;ie++)Q[ie]=Pe[ie];return Q}function F(Pe,ce){var ie=typeof Symbol<"u"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(ie)return(ie=ie.call(Pe)).next.bind(ie);if(Array.isArray(Pe)||(ie=T(Pe))||ce&&Pe&&typeof Pe.length=="number"){ie&&(Pe=ie);var Q=0;return function(){return Q>=Pe.length?{done:!0}:{done:!1,value:Pe[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ge.defaults=R();function $(Pe){ge.defaults=Pe}var g=/[&<>"']/,w=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(ce){return l[ce]};function b(Pe,ce){if(ce){if(g.test(Pe))return Pe.replace(w,p)}else if(A.test(Pe))return Pe.replace(D,p);return Pe}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Pe){return Pe.replace(r,function(ce,ie){return ie=ie.toLowerCase(),ie==="colon"?":":ie.charAt(0)==="#"?ie.charAt(1)==="x"?String.fromCharCode(parseInt(ie.substring(2),16)):String.fromCharCode(+ie.substring(1)):""})}var t=/(^|[^\[])\^/g;function n(Pe,ce){Pe=typeof Pe=="string"?Pe:Pe.source,ce=ce||"";var ie={replace:function(te,me){return me=me.source||me,me=me.replace(t,"$1"),Pe=Pe.replace(te,me),ie},getRegex:function(){return new RegExp(Pe,ce)}};return ie}var a=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Pe,ce,ie){if(Pe){var Q;try{Q=decodeURIComponent(o(ie)).replace(a,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}ce&&!c.test(ie)&&(ie=m(ce,ie));try{ie=encodeURI(ie).replace(/%25/g,"%")}catch{return null}return ie}var i={},s=/^[^:]+:\/*[^/]*$/,u=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function m(Pe,ce){i[" "+Pe]||(s.test(Pe)?i[" "+Pe]=Pe+"/":i[" "+Pe]=v(Pe,"/",!0)),Pe=i[" "+Pe];var ie=Pe.indexOf(":")===-1;return ce.substring(0,2)==="//"?ie?ce:Pe.replace(u,"$1")+ce:ce.charAt(0)==="/"?ie?ce:Pe.replace(d,"$1")+ce:Pe+ce}var f={exec:function(){}};function S(Pe){for(var ce=1,ie,Q;ce<arguments.length;ce++){ie=arguments[ce];for(Q in ie)Object.prototype.hasOwnProperty.call(ie,Q)&&(Pe[Q]=ie[Q])}return Pe}function L(Pe,ce){var ie=Pe.replace(/\|/g,function(me,pe,Fe){for(var le=!1,we=pe;--we>=0&&Fe[we]==="\\";)le=!le;return le?"|":" |"}),Q=ie.split(/ \|/),te=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>ce)Q.splice(ce);else for(;Q.length<ce;)Q.push("");for(;te<Q.length;te++)Q[te]=Q[te].trim().replace(/\\\|/g,"|");return Q}function v(Pe,ce,ie){var Q=Pe.length;if(Q===0)return"";for(var te=0;te<Q;){var me=Pe.charAt(Q-te-1);if(me===ce&&!ie)te++;else if(me!==ce&&ie)te++;else break}return Pe.slice(0,Q-te)}function y(Pe,ce){if(Pe.indexOf(ce[1])===-1)return-1;for(var ie=Pe.length,Q=0,te=0;te<ie;te++)if(Pe[te]==="\\")te++;else if(Pe[te]===ce[0])Q++;else if(Pe[te]===ce[1]&&(Q--,Q<0))return te;return-1}function k(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function N(Pe,ce){if(ce<1)return"";for(var ie="";ce>1;)ce&1&&(ie+=Pe),ce>>=1,Pe+=Pe;return ie+Pe}function O(Pe,ce,ie,Q){var te=ce.href,me=ce.title?b(ce.title):null,pe=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){Q.state.inLink=!0;var Fe={type:"link",raw:ie,href:te,title:me,text:pe,tokens:Q.inlineTokens(pe)};return Q.state.inLink=!1,Fe}return{type:"image",raw:ie,href:te,title:me,text:b(pe)}}function K(Pe,ce){var ie=Pe.match(/^(\s+)(?:```)/);if(ie===null)return ce;var Q=ie[1];return ce.split(`
`).map(function(te){var me=te.match(/^\s+/);if(me===null)return te;var pe=me[0];return pe.length>=Q.length?te.slice(Q.length):te}).join(`
`)}var j=function(){function Pe(ie){this.options=ie||ge.defaults}var ce=Pe.prototype;return ce.space=function(Q){var te=this.rules.block.newline.exec(Q);if(te&&te[0].length>0)return{type:"space",raw:te[0]}},ce.code=function(Q){var te=this.rules.block.code.exec(Q);if(te){var me=te[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:te[0],codeBlockStyle:"indented",text:this.options.pedantic?me:v(me,`
`)}}},ce.fences=function(Q){var te=this.rules.block.fences.exec(Q);if(te){var me=te[0],pe=K(me,te[3]||"");return{type:"code",raw:me,lang:te[2]?te[2].trim():te[2],text:pe}}},ce.heading=function(Q){var te=this.rules.block.heading.exec(Q);if(te){var me=te[2].trim();if(/#$/.test(me)){var pe=v(me,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(me=pe.trim())}return{type:"heading",raw:te[0],depth:te[1].length,text:me,tokens:this.lexer.inline(me)}}},ce.hr=function(Q){var te=this.rules.block.hr.exec(Q);if(te)return{type:"hr",raw:te[0]}},ce.blockquote=function(Q){var te=this.rules.block.blockquote.exec(Q);if(te){var me=te[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:te[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},ce.list=function(Q){var te=this.rules.block.list.exec(Q);if(te){var me,pe,Fe,le,we,M,q,H,U,Z,Y,Ee,Te=te[1].trim(),We=Te.length>1,He={type:"list",raw:"",ordered:We,start:We?+Te.slice(0,-1):"",loose:!1,items:[]};Te=We?"\\d{1,9}\\"+Te.slice(-1):"\\"+Te,this.options.pedantic&&(Te=We?Te:"[*+-]");for(var Xe=new RegExp("^( {0,3}"+Te+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(Ee=!1,!(!(te=Xe.exec(Q))||this.rules.block.hr.test(Q)));){if(me=te[0],Q=Q.substring(me.length),H=te[2].split(`
`,1)[0],U=Q.split(`
`,1)[0],this.options.pedantic?(le=2,Y=H.trimLeft()):(le=te[2].search(/[^ ]/),le=le>4?1:le,Y=H.slice(le),le+=te[1].length),M=!1,!H&&/^ *$/.test(U)&&(me+=U+`
`,Q=Q.substring(U.length+1),Ee=!0),!Ee)for(var st=new RegExp("^ {0,"+Math.min(3,le-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,le-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),tt=new RegExp("^ {0,"+Math.min(3,le-1)+"}(?:```|~~~)"),at=new RegExp("^ {0,"+Math.min(3,le-1)+"}#");Q&&(Z=Q.split(`
`,1)[0],H=Z,this.options.pedantic&&(H=H.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(tt.test(H)||at.test(H)||st.test(H)||nt.test(Q)));){if(H.search(/[^ ]/)>=le||!H.trim())Y+=`
`+H.slice(le);else if(!M)Y+=`
`+H;else break;!M&&!H.trim()&&(M=!0),me+=Z+`
`,Q=Q.substring(Z.length+1)}He.loose||(q?He.loose=!0:/\n *\n *$/.test(me)&&(q=!0)),this.options.gfm&&(pe=/^\[[ xX]\] /.exec(Y),pe&&(Fe=pe[0]!=="[ ] ",Y=Y.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:me,task:!!pe,checked:Fe,loose:!1,text:Y}),He.raw+=me}He.items[He.items.length-1].raw=me.trimRight(),He.items[He.items.length-1].text=Y.trimRight(),He.raw=He.raw.trimRight();var ct=He.items.length;for(we=0;we<ct;we++){this.lexer.state.top=!1,He.items[we].tokens=this.lexer.blockTokens(He.items[we].text,[]);var ze=He.items[we].tokens.filter(function(X){return X.type==="space"}),vt=ze.every(function(X){for(var x=X.raw.split(""),$e=0,Be=F(x),Qe;!(Qe=Be()).done;){var it=Qe.value;if(it===`
`&&($e+=1),$e>1)return!0}return!1});!He.loose&&ze.length&&vt&&(He.loose=!0,He.items[we].loose=!0)}return He}},ce.html=function(Q){var te=this.rules.block.html.exec(Q);if(te){var me={type:"html",raw:te[0],pre:!this.options.sanitizer&&(te[1]==="pre"||te[1]==="script"||te[1]==="style"),text:te[0]};if(this.options.sanitize){var pe=this.options.sanitizer?this.options.sanitizer(te[0]):b(te[0]);me.type="paragraph",me.text=pe,me.tokens=this.lexer.inline(pe)}return me}},ce.def=function(Q){var te=this.rules.block.def.exec(Q);if(te){te[3]&&(te[3]=te[3].substring(1,te[3].length-1));var me=te[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:te[0],href:te[2],title:te[3]}}},ce.table=function(Q){var te=this.rules.block.table.exec(Q);if(te){var me={type:"table",header:L(te[1]).map(function(q){return{text:q}}),align:te[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:te[3]&&te[3].trim()?te[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=te[0];var pe=me.align.length,Fe,le,we,M;for(Fe=0;Fe<pe;Fe++)/^ *-+: *$/.test(me.align[Fe])?me.align[Fe]="right":/^ *:-+: *$/.test(me.align[Fe])?me.align[Fe]="center":/^ *:-+ *$/.test(me.align[Fe])?me.align[Fe]="left":me.align[Fe]=null;for(pe=me.rows.length,Fe=0;Fe<pe;Fe++)me.rows[Fe]=L(me.rows[Fe],me.header.length).map(function(q){return{text:q}});for(pe=me.header.length,le=0;le<pe;le++)me.header[le].tokens=this.lexer.inline(me.header[le].text);for(pe=me.rows.length,le=0;le<pe;le++)for(M=me.rows[le],we=0;we<M.length;we++)M[we].tokens=this.lexer.inline(M[we].text);return me}}},ce.lheading=function(Q){var te=this.rules.block.lheading.exec(Q);if(te)return{type:"heading",raw:te[0],depth:te[2].charAt(0)==="="?1:2,text:te[1],tokens:this.lexer.inline(te[1])}},ce.paragraph=function(Q){var te=this.rules.block.paragraph.exec(Q);if(te){var me=te[1].charAt(te[1].length-1)===`
`?te[1].slice(0,-1):te[1];return{type:"paragraph",raw:te[0],text:me,tokens:this.lexer.inline(me)}}},ce.text=function(Q){var te=this.rules.block.text.exec(Q);if(te)return{type:"text",raw:te[0],text:te[0],tokens:this.lexer.inline(te[0])}},ce.escape=function(Q){var te=this.rules.inline.escape.exec(Q);if(te)return{type:"escape",raw:te[0],text:b(te[1])}},ce.tag=function(Q){var te=this.rules.inline.tag.exec(Q);if(te)return!this.lexer.state.inLink&&/^<a /i.test(te[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(te[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(te[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(te[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:te[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):b(te[0]):te[0]}},ce.link=function(Q){var te=this.rules.inline.link.exec(Q);if(te){var me=te[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var pe=v(me.slice(0,-1),"\\");if((me.length-pe.length)%2===0)return}else{var Fe=y(te[2],"()");if(Fe>-1){var le=te[0].indexOf("!")===0?5:4,we=le+te[1].length+Fe;te[2]=te[2].substring(0,Fe),te[0]=te[0].substring(0,we).trim(),te[3]=""}}var M=te[2],q="";if(this.options.pedantic){var H=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(M);H&&(M=H[1],q=H[3])}else q=te[3]?te[3].slice(1,-1):"";return M=M.trim(),/^</.test(M)&&(this.options.pedantic&&!/>$/.test(me)?M=M.slice(1):M=M.slice(1,-1)),O(te,{href:M&&M.replace(this.rules.inline._escapes,"$1"),title:q&&q.replace(this.rules.inline._escapes,"$1")},te[0],this.lexer)}},ce.reflink=function(Q,te){var me;if((me=this.rules.inline.reflink.exec(Q))||(me=this.rules.inline.nolink.exec(Q))){var pe=(me[2]||me[1]).replace(/\s+/g," ");if(pe=te[pe.toLowerCase()],!pe||!pe.href){var Fe=me[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return O(me,pe,me[0],this.lexer)}},ce.emStrong=function(Q,te,me){me===void 0&&(me="");var pe=this.rules.inline.emStrong.lDelim.exec(Q);if(pe&&!(pe[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=pe[1]||pe[2]||"";if(!Fe||Fe&&(me===""||this.rules.inline.punctuation.exec(me))){var le=pe[0].length-1,we,M,q=le,H=0,U=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(U.lastIndex=0,te=te.slice(-1*Q.length+le);(pe=U.exec(te))!=null;)if(we=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!we){if(M=we.length,pe[3]||pe[4]){q+=M;continue}else if((pe[5]||pe[6])&&le%3&&!((le+M)%3)){H+=M;continue}if(q-=M,!(q>0)){if(M=Math.min(M,M+q+H),Math.min(le,M)%2){var Z=Q.slice(1,le+pe.index+M);return{type:"em",raw:Q.slice(0,le+pe.index+M+1),text:Z,tokens:this.lexer.inlineTokens(Z)}}var Y=Q.slice(2,le+pe.index+M-1);return{type:"strong",raw:Q.slice(0,le+pe.index+M+1),text:Y,tokens:this.lexer.inlineTokens(Y)}}}}}},ce.codespan=function(Q){var te=this.rules.inline.code.exec(Q);if(te){var me=te[2].replace(/\n/g," "),pe=/[^ ]/.test(me),Fe=/^ /.test(me)&&/ $/.test(me);return pe&&Fe&&(me=me.substring(1,me.length-1)),me=b(me,!0),{type:"codespan",raw:te[0],text:me}}},ce.br=function(Q){var te=this.rules.inline.br.exec(Q);if(te)return{type:"br",raw:te[0]}},ce.del=function(Q){var te=this.rules.inline.del.exec(Q);if(te)return{type:"del",raw:te[0],text:te[2],tokens:this.lexer.inlineTokens(te[2])}},ce.autolink=function(Q,te){var me=this.rules.inline.autolink.exec(Q);if(me){var pe,Fe;return me[2]==="@"?(pe=b(this.options.mangle?te(me[1]):me[1]),Fe="mailto:"+pe):(pe=b(me[1]),Fe=pe),{type:"link",raw:me[0],text:pe,href:Fe,tokens:[{type:"text",raw:pe,text:pe}]}}},ce.url=function(Q,te){var me;if(me=this.rules.inline.url.exec(Q)){var pe,Fe;if(me[2]==="@")pe=b(this.options.mangle?te(me[0]):me[0]),Fe="mailto:"+pe;else{var le;do le=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(le!==me[0]);pe=b(me[0]),me[1]==="www."?Fe="http://"+pe:Fe=pe}return{type:"link",raw:me[0],text:pe,href:Fe,tokens:[{type:"text",raw:pe,text:pe}]}}},ce.inlineText=function(Q,te){var me=this.rules.inline.text.exec(Q);if(me){var pe;return this.lexer.state.inRawBlock?pe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):b(me[0]):me[0]:pe=b(this.options.smartypants?te(me[0]):me[0]),{type:"text",raw:me[0],text:pe}}},Pe}(),W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:f,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=n(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.listItemStart=n(/^( *)(bull) */).replace("bull",W.bullet).getRegex(),W.list=n(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=n(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=n(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.blockquote=n(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=S({},W),W.gfm=S({},W.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.table=n(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.gfm.paragraph=n(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",W.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.pedantic=S({},W.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:f,paragraph:n(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var P={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:f,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:f,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};P._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",P.punctuation=n(P.punctuation).replace(/punctuation/g,P._punctuation).getRegex(),P.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,P.escapedEmSt=/\\\*|\\_/g,P._comment=n(W._comment).replace("(?:-->|$)","-->").getRegex(),P.emStrong.lDelim=n(P.emStrong.lDelim).replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimAst=n(P.emStrong.rDelimAst,"g").replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimUnd=n(P.emStrong.rDelimUnd,"g").replace(/punct/g,P._punctuation).getRegex(),P._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,P._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,P._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,P.autolink=n(P.autolink).replace("scheme",P._scheme).replace("email",P._email).getRegex(),P._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,P.tag=n(P.tag).replace("comment",P._comment).replace("attribute",P._attribute).getRegex(),P._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,P._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,P._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,P.link=n(P.link).replace("label",P._label).replace("href",P._href).replace("title",P._title).getRegex(),P.reflink=n(P.reflink).replace("label",P._label).replace("ref",W._label).getRegex(),P.nolink=n(P.nolink).replace("ref",W._label).getRegex(),P.reflinkSearch=n(P.reflinkSearch,"g").replace("reflink",P.reflink).replace("nolink",P.nolink).getRegex(),P.normal=S({},P),P.pedantic=S({},P.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",P._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",P._label).getRegex()}),P.gfm=S({},P.normal,{escape:n(P.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),P.gfm.url=n(P.gfm.url,"i").replace("email",P.gfm._extended_email).getRegex(),P.breaks=S({},P.gfm,{br:n(P.br).replace("{2,}","*").getRegex(),text:n(P.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function C(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function J(Pe){var ce="",ie,Q,te=Pe.length;for(ie=0;ie<te;ie++)Q=Pe.charCodeAt(ie),Math.random()>.5&&(Q="x"+Q.toString(16)),ce+="&#"+Q+";";return ce}var ae=function(){function Pe(ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=ie||ge.defaults,this.options.tokenizer=this.options.tokenizer||new j,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:W.normal,inline:P.normal};this.options.pedantic?(Q.block=W.pedantic,Q.inline=P.pedantic):this.options.gfm&&(Q.block=W.gfm,this.options.breaks?Q.inline=P.breaks:Q.inline=P.gfm),this.tokenizer.rules=Q}Pe.lex=function(Q,te){var me=new Pe(te);return me.lex(Q)},Pe.lexInline=function(Q,te){var me=new Pe(te);return me.inlineTokens(Q)};var ce=Pe.prototype;return ce.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var te;te=this.inlineQueue.shift();)this.inlineTokens(te.src,te.tokens);return this.tokens},ce.blockTokens=function(Q,te){var me=this;te===void 0&&(te=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(q,H,U){return H+"    ".repeat(U.length)});for(var pe,Fe,le,we;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(q){return(pe=q.call({lexer:me},Q,te))?(Q=Q.substring(pe.raw.length),te.push(pe),!0):!1}))){if(pe=this.tokenizer.space(Q)){Q=Q.substring(pe.raw.length),pe.raw.length===1&&te.length>0?te[te.length-1].raw+=`
`:te.push(pe);continue}if(pe=this.tokenizer.code(Q)){Q=Q.substring(pe.raw.length),Fe=te[te.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+pe.raw,Fe.text+=`
`+pe.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):te.push(pe);continue}if(pe=this.tokenizer.fences(Q)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(pe=this.tokenizer.heading(Q)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(pe=this.tokenizer.hr(Q)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(pe=this.tokenizer.blockquote(Q)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(pe=this.tokenizer.list(Q)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(pe=this.tokenizer.html(Q)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(pe=this.tokenizer.def(Q)){Q=Q.substring(pe.raw.length),Fe=te[te.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+pe.raw,Fe.text+=`
`+pe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(Q)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(pe=this.tokenizer.lheading(Q)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(le=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var q=1/0,H=Q.slice(1),U=void 0;me.options.extensions.startBlock.forEach(function(Z){U=Z.call({lexer:this},H),typeof U=="number"&&U>=0&&(q=Math.min(q,U))}),q<1/0&&q>=0&&(le=Q.substring(0,q+1))}(),this.state.top&&(pe=this.tokenizer.paragraph(le))){Fe=te[te.length-1],we&&Fe.type==="paragraph"?(Fe.raw+=`
`+pe.raw,Fe.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):te.push(pe),we=le.length!==Q.length,Q=Q.substring(pe.raw.length);continue}if(pe=this.tokenizer.text(Q)){Q=Q.substring(pe.raw.length),Fe=te[te.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+pe.raw,Fe.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):te.push(pe);continue}if(Q){var M="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(M);break}else throw new Error(M)}}return this.state.top=!0,te},ce.inline=function(Q,te){return te===void 0&&(te=[]),this.inlineQueue.push({src:Q,tokens:te}),te},ce.inlineTokens=function(Q,te){var me=this;te===void 0&&(te=[]);var pe,Fe,le,we=Q,M,q,H;if(this.tokens.links){var U=Object.keys(this.tokens.links);if(U.length>0)for(;(M=this.tokenizer.rules.inline.reflinkSearch.exec(we))!=null;)U.includes(M[0].slice(M[0].lastIndexOf("[")+1,-1))&&(we=we.slice(0,M.index)+"["+N("a",M[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(M=this.tokenizer.rules.inline.blockSkip.exec(we))!=null;)we=we.slice(0,M.index)+"["+N("a",M[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(M=this.tokenizer.rules.inline.escapedEmSt.exec(we))!=null;)we=we.slice(0,M.index)+"++"+we.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(q||(H=""),q=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Y){return(pe=Y.call({lexer:me},Q,te))?(Q=Q.substring(pe.raw.length),te.push(pe),!0):!1}))){if(pe=this.tokenizer.escape(Q)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(pe=this.tokenizer.tag(Q)){Q=Q.substring(pe.raw.length),Fe=te[te.length-1],Fe&&pe.type==="text"&&Fe.type==="text"?(Fe.raw+=pe.raw,Fe.text+=pe.text):te.push(pe);continue}if(pe=this.tokenizer.link(Q)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(pe=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(pe.raw.length),Fe=te[te.length-1],Fe&&pe.type==="text"&&Fe.type==="text"?(Fe.raw+=pe.raw,Fe.text+=pe.text):te.push(pe);continue}if(pe=this.tokenizer.emStrong(Q,we,H)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(pe=this.tokenizer.codespan(Q)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(pe=this.tokenizer.br(Q)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(pe=this.tokenizer.del(Q)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(pe=this.tokenizer.autolink(Q,J)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(!this.state.inLink&&(pe=this.tokenizer.url(Q,J))){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(le=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var Y=1/0,Ee=Q.slice(1),Te=void 0;me.options.extensions.startInline.forEach(function(We){Te=We.call({lexer:this},Ee),typeof Te=="number"&&Te>=0&&(Y=Math.min(Y,Te))}),Y<1/0&&Y>=0&&(le=Q.substring(0,Y+1))}(),pe=this.tokenizer.inlineText(le,C)){Q=Q.substring(pe.raw.length),pe.raw.slice(-1)!=="_"&&(H=pe.raw.slice(-1)),q=!0,Fe=te[te.length-1],Fe&&Fe.type==="text"?(Fe.raw+=pe.raw,Fe.text+=pe.text):te.push(pe);continue}if(Q){var Z="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(Z);break}else throw new Error(Z)}}return te},E(Pe,null,[{key:"rules",get:function(){return{block:W,inline:P}}}]),Pe}(),fe=function(){function Pe(ie){this.options=ie||ge.defaults}var ce=Pe.prototype;return ce.code=function(Q,te,me){var pe=(te||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(Q,pe);Fe!=null&&Fe!==Q&&(me=!0,Q=Fe)}return Q=Q.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+b(pe,!0)+'">'+(me?Q:b(Q,!0))+`</code></pre>
`:"<pre><code>"+(me?Q:b(Q,!0))+`</code></pre>
`},ce.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},ce.html=function(Q){return Q},ce.heading=function(Q,te,me,pe){if(this.options.headerIds){var Fe=this.options.headerPrefix+pe.slug(me);return"<h"+te+' id="'+Fe+'">'+Q+"</h"+te+`>
`}return"<h"+te+">"+Q+"</h"+te+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(Q,te,me){var pe=te?"ol":"ul",Fe=te&&me!==1?' start="'+me+'"':"";return"<"+pe+Fe+`>
`+Q+"</"+pe+`>
`},ce.listitem=function(Q){return"<li>"+Q+`</li>
`},ce.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(Q){return"<p>"+Q+`</p>
`},ce.table=function(Q,te){return te&&(te="<tbody>"+te+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+te+`</table>
`},ce.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},ce.tablecell=function(Q,te){var me=te.header?"th":"td",pe=te.align?"<"+me+' align="'+te.align+'">':"<"+me+">";return pe+Q+("</"+me+`>
`)},ce.strong=function(Q){return"<strong>"+Q+"</strong>"},ce.em=function(Q){return"<em>"+Q+"</em>"},ce.codespan=function(Q){return"<code>"+Q+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(Q){return"<del>"+Q+"</del>"},ce.link=function(Q,te,me){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return me;var pe='<a href="'+b(Q)+'"';return te&&(pe+=' title="'+te+'"'),pe+=">"+me+"</a>",pe},ce.image=function(Q,te,me){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return me;var pe='<img src="'+Q+'" alt="'+me+'"';return te&&(pe+=' title="'+te+'"'),pe+=this.options.xhtml?"/>":">",pe},ce.text=function(Q){return Q},Pe}(),be=function(){function Pe(){}var ce=Pe.prototype;return ce.strong=function(Q){return Q},ce.em=function(Q){return Q},ce.codespan=function(Q){return Q},ce.del=function(Q){return Q},ce.html=function(Q){return Q},ce.text=function(Q){return Q},ce.link=function(Q,te,me){return""+me},ce.image=function(Q,te,me){return""+me},ce.br=function(){return""},Pe}(),ye=function(){function Pe(){this.seen={}}var ce=Pe.prototype;return ce.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(Q,te){var me=Q,pe=0;if(this.seen.hasOwnProperty(me)){pe=this.seen[Q];do pe++,me=Q+"-"+pe;while(this.seen.hasOwnProperty(me))}return te||(this.seen[Q]=pe,this.seen[me]=0),me},ce.slug=function(Q,te){te===void 0&&(te={});var me=this.serialize(Q);return this.getNextSafeSlug(me,te.dryrun)},Pe}(),he=function(){function Pe(ie){this.options=ie||ge.defaults,this.options.renderer=this.options.renderer||new fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new be,this.slugger=new ye}Pe.parse=function(Q,te){var me=new Pe(te);return me.parse(Q)},Pe.parseInline=function(Q,te){var me=new Pe(te);return me.parseInline(Q)};var ce=Pe.prototype;return ce.parse=function(Q,te){te===void 0&&(te=!0);var me="",pe,Fe,le,we,M,q,H,U,Z,Y,Ee,Te,We,He,Xe,st,nt,tt,at,ct=Q.length;for(pe=0;pe<ct;pe++){if(Y=Q[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Y.type]&&(at=this.options.extensions.renderers[Y.type].call({parser:this},Y),at!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Y.type))){me+=at||"";continue}switch(Y.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(Y.tokens),Y.depth,o(this.parseInline(Y.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(Y.text,Y.lang,Y.escaped);continue}case"table":{for(U="",H="",we=Y.header.length,Fe=0;Fe<we;Fe++)H+=this.renderer.tablecell(this.parseInline(Y.header[Fe].tokens),{header:!0,align:Y.align[Fe]});for(U+=this.renderer.tablerow(H),Z="",we=Y.rows.length,Fe=0;Fe<we;Fe++){for(q=Y.rows[Fe],H="",M=q.length,le=0;le<M;le++)H+=this.renderer.tablecell(this.parseInline(q[le].tokens),{header:!1,align:Y.align[le]});Z+=this.renderer.tablerow(H)}me+=this.renderer.table(U,Z);continue}case"blockquote":{Z=this.parse(Y.tokens),me+=this.renderer.blockquote(Z);continue}case"list":{for(Ee=Y.ordered,Te=Y.start,We=Y.loose,we=Y.items.length,Z="",Fe=0;Fe<we;Fe++)Xe=Y.items[Fe],st=Xe.checked,nt=Xe.task,He="",Xe.task&&(tt=this.renderer.checkbox(st),We?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=tt+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=tt+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:tt}):He+=tt),He+=this.parse(Xe.tokens,We),Z+=this.renderer.listitem(He,nt,st);me+=this.renderer.list(Z,Ee,Te);continue}case"html":{me+=this.renderer.html(Y.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(Y.tokens));continue}case"text":{for(Z=Y.tokens?this.parseInline(Y.tokens):Y.text;pe+1<ct&&Q[pe+1].type==="text";)Y=Q[++pe],Z+=`
`+(Y.tokens?this.parseInline(Y.tokens):Y.text);me+=te?this.renderer.paragraph(Z):Z;continue}default:{var ze='Token with "'+Y.type+'" type was not found.';if(this.options.silent){console.error(ze);return}else throw new Error(ze)}}}return me},ce.parseInline=function(Q,te){te=te||this.renderer;var me="",pe,Fe,le,we=Q.length;for(pe=0;pe<we;pe++){if(Fe=Q[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(le=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),le!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){me+=le||"";continue}switch(Fe.type){case"escape":{me+=te.text(Fe.text);break}case"html":{me+=te.html(Fe.text);break}case"link":{me+=te.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,te));break}case"image":{me+=te.image(Fe.href,Fe.title,Fe.text);break}case"strong":{me+=te.strong(this.parseInline(Fe.tokens,te));break}case"em":{me+=te.em(this.parseInline(Fe.tokens,te));break}case"codespan":{me+=te.codespan(Fe.text);break}case"br":{me+=te.br();break}case"del":{me+=te.del(this.parseInline(Fe.tokens,te));break}case"text":{me+=te.text(Fe.text);break}default:{var M='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(M);return}else throw new Error(M)}}}return me},Pe}();function ve(Pe,ce,ie){if(typeof Pe>"u"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof ce=="function"&&(ie=ce,ce=null),ce=S({},ve.defaults,ce||{}),k(ce),ie){var Q=ce.highlight,te;try{te=ae.lex(Pe,ce)}catch(we){return ie(we)}var me=function(M){var q;if(!M)try{ce.walkTokens&&ve.walkTokens(te,ce.walkTokens),q=he.parse(te,ce)}catch(H){M=H}return ce.highlight=Q,M?ie(M):ie(null,q)};if(!Q||Q.length<3||(delete ce.highlight,!te.length))return me();var pe=0;ve.walkTokens(te,function(we){we.type==="code"&&(pe++,setTimeout(function(){Q(we.text,we.lang,function(M,q){if(M)return me(M);q!=null&&q!==we.text&&(we.text=q,we.escaped=!0),pe--,pe===0&&me()})},0))}),pe===0&&me();return}function Fe(we){if(we.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+b(we.message+"",!0)+"</pre>";throw we}try{var le=ae.lex(Pe,ce);if(ce.walkTokens){if(ce.async)return Promise.all(ve.walkTokens(le,ce.walkTokens)).then(function(){return he.parse(le,ce)}).catch(Fe);ve.walkTokens(le,ce.walkTokens)}return he.parse(le,ce)}catch(we){Fe(we)}}ve.options=ve.setOptions=function(Pe){return S(ve.defaults,Pe),$(ve.defaults),ve},ve.getDefaults=R,ve.defaults=ge.defaults,ve.use=function(){for(var Pe=arguments.length,ce=new Array(Pe),ie=0;ie<Pe;ie++)ce[ie]=arguments[ie];var Q=S.apply(void 0,[{}].concat(ce)),te=ve.defaults.extensions||{renderers:{},childTokens:{}},me;ce.forEach(function(pe){if(pe.extensions&&(me=!0,pe.extensions.forEach(function(le){if(!le.name)throw new Error("extension name required");if(le.renderer){var we=te.renderers?te.renderers[le.name]:null;we?te.renderers[le.name]=function(){for(var M=arguments.length,q=new Array(M),H=0;H<M;H++)q[H]=arguments[H];var U=le.renderer.apply(this,q);return U===!1&&(U=we.apply(this,q)),U}:te.renderers[le.name]=le.renderer}if(le.tokenizer){if(!le.level||le.level!=="block"&&le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");te[le.level]?te[le.level].unshift(le.tokenizer):te[le.level]=[le.tokenizer],le.start&&(le.level==="block"?te.startBlock?te.startBlock.push(le.start):te.startBlock=[le.start]:le.level==="inline"&&(te.startInline?te.startInline.push(le.start):te.startInline=[le.start]))}le.childTokens&&(te.childTokens[le.name]=le.childTokens)})),pe.renderer&&function(){var le=ve.defaults.renderer||new fe,we=function(H){var U=le[H];le[H]=function(){for(var Z=arguments.length,Y=new Array(Z),Ee=0;Ee<Z;Ee++)Y[Ee]=arguments[Ee];var Te=pe.renderer[H].apply(le,Y);return Te===!1&&(Te=U.apply(le,Y)),Te}};for(var M in pe.renderer)we(M);Q.renderer=le}(),pe.tokenizer&&function(){var le=ve.defaults.tokenizer||new j,we=function(H){var U=le[H];le[H]=function(){for(var Z=arguments.length,Y=new Array(Z),Ee=0;Ee<Z;Ee++)Y[Ee]=arguments[Ee];var Te=pe.tokenizer[H].apply(le,Y);return Te===!1&&(Te=U.apply(le,Y)),Te}};for(var M in pe.tokenizer)we(M);Q.tokenizer=le}(),pe.walkTokens){var Fe=ve.defaults.walkTokens;Q.walkTokens=function(le){var we=[];return we.push(pe.walkTokens.call(this,le)),Fe&&(we=we.concat(Fe.call(this,le))),we}}me&&(Q.extensions=te),ve.setOptions(Q)})},ve.walkTokens=function(Pe,ce){for(var ie=[],Q=function(){var Fe=me.value;switch(ie=ie.concat(ce.call(ve,Fe)),Fe.type){case"table":{for(var le=F(Fe.header),we;!(we=le()).done;){var M=we.value;ie=ie.concat(ve.walkTokens(M.tokens,ce))}for(var q=F(Fe.rows),H;!(H=q()).done;)for(var U=H.value,Z=F(U),Y;!(Y=Z()).done;){var Ee=Y.value;ie=ie.concat(ve.walkTokens(Ee.tokens,ce))}break}case"list":{ie=ie.concat(ve.walkTokens(Fe.items,ce));break}default:ve.defaults.extensions&&ve.defaults.extensions.childTokens&&ve.defaults.extensions.childTokens[Fe.type]?ve.defaults.extensions.childTokens[Fe.type].forEach(function(Te){ie=ie.concat(ve.walkTokens(Fe[Te],ce))}):Fe.tokens&&(ie=ie.concat(ve.walkTokens(Fe.tokens,ce)))}},te=F(Pe),me;!(me=te()).done;)Q();return ie},ve.parseInline=function(Pe,ce){if(typeof Pe>"u"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");ce=S({},ve.defaults,ce||{}),k(ce);try{var ie=ae.lexInline(Pe,ce);return ce.walkTokens&&ve.walkTokens(ie,ce.walkTokens),he.parseInline(ie,ce)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+b(Q.message+"",!0)+"</pre>";throw Q}},ve.Parser=he,ve.parser=he.parse,ve.Renderer=fe,ve.TextRenderer=be,ve.Lexer=ae,ve.lexer=ae.lex,ve.Tokenizer=j,ve.Slugger=ye,ve.parse=ve;var ee=ve.options,ke=ve.setOptions,se=ve.use,_=ve.walkTokens,V=ve.parseInline,ne=ve,Ie=he.parse,Ae=ae.lex;ge.Lexer=ae,ge.Parser=he,ge.Renderer=fe,ge.Slugger=ye,ge.TextRenderer=be,ge.Tokenizer=j,ge.getDefaults=R,ge.lexer=Ae,ge.marked=ve,ge.options=ee,ge.parse=ne,ge.parseInline=V,ge.parser=Ie,ge.setOptions=ke,ge.use=se,ge.walkTokens=_,Object.defineProperty(ge,"__esModule",{value:!0})}),define(Ce[121],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oj=void 0;function E(r){const o=F(r);if(o&&o.length>0)return new Uint32Array(o)}e.$Oj=E;let T=0;const I=new Uint32Array(10);function F(r){if(T=0,R(r,D,4352),T>0||(R(r,l,4449),T>0)||(R(r,p,4520),T>0)||(R(r,b,12593),T))return I.subarray(0,T);if(r>=44032&&r<=55203){const o=r-44032,t=o%588,n=Math.floor(o/588),a=Math.floor(t/28),c=t%28-1;if(n<D.length?R(n,D,0):4352+n-12593<b.length&&R(4352+n,b,12593),a<l.length?R(a,l,0):4449+a-12593<b.length&&R(4449+a-12593,b,12593),c>=0&&(c<p.length?R(c,p,0):4520+c-12593<b.length&&R(4520+c-12593,b,12593)),T>0)return I.subarray(0,T)}}function R(r,o,t){r>=t&&r<t+o.length&&$(o[r-t])}function $(r){r!==0&&(I[T++]=r&255,r>>8&&(I[T++]=r>>8&255),r>>16&&(I[T++]=r>>16&255))}var g;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(g||(g={}));var w;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(w||(w={}));var A;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(A||(A={}));const D=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),p=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),b=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Ce[122],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8l=e.$7l=e.$6l=e.rot=e.$4l=void 0;function E($,g,w){return Math.min(Math.max($,g),w)}e.$4l=E;function T($,g){return(g+$%g)%g}e.rot=T;class I{constructor(){this.a=0}getNext(){return this.a++}}e.$6l=I;class F{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$7l=F;class R{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const w=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$8l=R}),function(){function ge(I){const F=[];typeof I=="number"&&F.push("code/timeOrigin",I);function R(g){F.push(g,Date.now())}function $(){const g=[];for(let w=0;w<F.length;w+=2)g.push({name:F[w],startTime:F[w+1]});return g}return{mark:R,getMarks:$}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const F=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const R of performance.getEntriesByType("mark"))F.push({name:R.name,startTime:Math.round(I+R.startTime)});return F}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ge(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function E(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=E(T))}(),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var T in E)(typeof exports=="object"?exports:ge)[T]=E[T]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function E(T){if(e[T])return e[T].exports;var I=e[T]={i:T,l:!1,exports:{}};return ge[T].call(I.exports,I,I.exports,E),I.l=!0,I.exports}return E.m=ge,E.c=e,E.d=function(T,I,F){E.o(T,I)||Object.defineProperty(T,I,{enumerable:!0,get:F})},E.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},E.t=function(T,I){if(1&I&&(T=E(T)),8&I||4&I&&typeof T=="object"&&T&&T.__esModule)return T;var F=Object.create(null);if(E.r(F),Object.defineProperty(F,"default",{enumerable:!0,value:T}),2&I&&typeof T!="string")for(var R in T)E.d(F,R,function($){return T[$]}.bind(null,R));return F},E.n=function(T){var I=T&&T.__esModule?function(){return T.default}:function(){return T};return E.d(I,"a",I),I},E.o=function(T,I){return Object.prototype.hasOwnProperty.call(T,I)},E.p="",E(E.s=0)}([function(ge,e,E){(function(T){var I;e=ge.exports=se,I=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var U=Array.prototype.slice.call(arguments,0);U.unshift("SEMVER"),console.log.apply(console,U)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var F=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,$=e.re=[],g=e.src=[],w=0,A=w++;g[A]="0|[1-9]\\d*";var D=w++;g[D]="[0-9]+";var l=w++;g[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=w++;g[p]="("+g[A]+")\\.("+g[A]+")\\.("+g[A]+")";var b=w++;g[b]="("+g[D]+")\\.("+g[D]+")\\.("+g[D]+")";var r=w++;g[r]="(?:"+g[A]+"|"+g[l]+")";var o=w++;g[o]="(?:"+g[D]+"|"+g[l]+")";var t=w++;g[t]="(?:-("+g[r]+"(?:\\."+g[r]+")*))";var n=w++;g[n]="(?:-?("+g[o]+"(?:\\."+g[o]+")*))";var a=w++;g[a]="[0-9A-Za-z-]+";var c=w++;g[c]="(?:\\+("+g[a]+"(?:\\."+g[a]+")*))";var h=w++,i="v?"+g[p]+g[t]+"?"+g[c]+"?";g[h]="^"+i+"$";var s="[v=\\s]*"+g[b]+g[n]+"?"+g[c]+"?",u=w++;g[u]="^"+s+"$";var d=w++;g[d]="((?:<|>)?=?)";var m=w++;g[m]=g[D]+"|x|X|\\*";var f=w++;g[f]=g[A]+"|x|X|\\*";var S=w++;g[S]="[v=\\s]*("+g[f]+")(?:\\.("+g[f]+")(?:\\.("+g[f]+")(?:"+g[t]+")?"+g[c]+"?)?)?";var L=w++;g[L]="[v=\\s]*("+g[m]+")(?:\\.("+g[m]+")(?:\\.("+g[m]+")(?:"+g[n]+")?"+g[c]+"?)?)?";var v=w++;g[v]="^"+g[d]+"\\s*"+g[S]+"$";var y=w++;g[y]="^"+g[d]+"\\s*"+g[L]+"$";var k=w++;g[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=w++;g[N]="(?:~>?)";var O=w++;g[O]="(\\s*)"+g[N]+"\\s+",$[O]=new RegExp(g[O],"g");var K=w++;g[K]="^"+g[N]+g[S]+"$";var j=w++;g[j]="^"+g[N]+g[L]+"$";var W=w++;g[W]="(?:\\^)";var P=w++;g[P]="(\\s*)"+g[W]+"\\s+",$[P]=new RegExp(g[P],"g");var C=w++;g[C]="^"+g[W]+g[S]+"$";var J=w++;g[J]="^"+g[W]+g[L]+"$";var ae=w++;g[ae]="^"+g[d]+"\\s*("+s+")$|^$";var fe=w++;g[fe]="^"+g[d]+"\\s*("+i+")$|^$";var be=w++;g[be]="(\\s*)"+g[d]+"\\s*("+s+"|"+g[S]+")",$[be]=new RegExp(g[be],"g");var ye=w++;g[ye]="^\\s*("+g[S]+")\\s+-\\s+("+g[S]+")\\s*$";var he=w++;g[he]="^\\s*("+g[L]+")\\s+-\\s+("+g[L]+")\\s*$";var ve=w++;g[ve]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)I(ee,g[ee]),$[ee]||($[ee]=new RegExp(g[ee]));function ke(U,Z){if(U instanceof se)return U;if(typeof U!="string"||U.length>F||!(Z?$[u]:$[h]).test(U))return null;try{return new se(U,Z)}catch{return null}}function se(U,Z){if(U instanceof se){if(U.loose===Z)return U;U=U.version}else if(typeof U!="string")throw new TypeError("Invalid Version: "+U);if(U.length>F)throw new TypeError("version is longer than "+F+" characters");if(!(this instanceof se))return new se(U,Z);I("SemVer",U,Z),this.loose=Z;var Y=U.trim().match(Z?$[u]:$[h]);if(!Y)throw new TypeError("Invalid Version: "+U);if(this.raw=U,this.major=+Y[1],this.minor=+Y[2],this.patch=+Y[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");Y[4]?this.prerelease=Y[4].split(".").map(function(Ee){if(/^[0-9]+$/.test(Ee)){var Te=+Ee;if(Te>=0&&Te<R)return Te}return Ee}):this.prerelease=[],this.build=Y[5]?Y[5].split("."):[],this.format()}e.parse=ke,e.valid=function(U,Z){var Y=ke(U,Z);return Y?Y.version:null},e.clean=function(U,Z){var Y=ke(U.trim().replace(/^[=v]+/,""),Z);return Y?Y.version:null},e.SemVer=se,se.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},se.prototype.toString=function(){return this.version},se.prototype.compare=function(U){return I("SemVer.compare",this.version,this.loose,U),U instanceof se||(U=new se(U,this.loose)),this.compareMain(U)||this.comparePre(U)},se.prototype.compareMain=function(U){return U instanceof se||(U=new se(U,this.loose)),V(this.major,U.major)||V(this.minor,U.minor)||V(this.patch,U.patch)},se.prototype.comparePre=function(U){if(U instanceof se||(U=new se(U,this.loose)),this.prerelease.length&&!U.prerelease.length)return-1;if(!this.prerelease.length&&U.prerelease.length)return 1;if(!this.prerelease.length&&!U.prerelease.length)return 0;var Z=0;do{var Y=this.prerelease[Z],Ee=U.prerelease[Z];if(I("prerelease compare",Z,Y,Ee),Y===void 0&&Ee===void 0)return 0;if(Ee===void 0)return 1;if(Y===void 0)return-1;if(Y!==Ee)return V(Y,Ee)}while(++Z)},se.prototype.inc=function(U,Z){switch(U){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Z);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Z);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Z),this.inc("pre",Z);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Z),this.inc("pre",Z);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Y=this.prerelease.length;--Y>=0;)typeof this.prerelease[Y]=="number"&&(this.prerelease[Y]++,Y=-2);Y===-1&&this.prerelease.push(0)}Z&&(this.prerelease[0]===Z?isNaN(this.prerelease[1])&&(this.prerelease=[Z,0]):this.prerelease=[Z,0]);break;default:throw new Error("invalid increment argument: "+U)}return this.format(),this.raw=this.version,this},e.inc=function(U,Z,Y,Ee){typeof Y=="string"&&(Ee=Y,Y=void 0);try{return new se(U,Y).inc(Z,Ee).version}catch{return null}},e.diff=function(U,Z){if(Pe(U,Z))return null;var Y=ke(U),Ee=ke(Z);if(Y.prerelease.length||Ee.prerelease.length){for(var Te in Y)if((Te==="major"||Te==="minor"||Te==="patch")&&Y[Te]!==Ee[Te])return"pre"+Te;return"prerelease"}for(var Te in Y)if((Te==="major"||Te==="minor"||Te==="patch")&&Y[Te]!==Ee[Te])return Te},e.compareIdentifiers=V;var _=/^[0-9]+$/;function V(U,Z){var Y=_.test(U),Ee=_.test(Z);return Y&&Ee&&(U=+U,Z=+Z),Y&&!Ee?-1:Ee&&!Y?1:U<Z?-1:U>Z?1:0}function ne(U,Z,Y){return new se(U,Y).compare(new se(Z,Y))}function Ie(U,Z,Y){return ne(U,Z,Y)>0}function Ae(U,Z,Y){return ne(U,Z,Y)<0}function Pe(U,Z,Y){return ne(U,Z,Y)===0}function ce(U,Z,Y){return ne(U,Z,Y)!==0}function ie(U,Z,Y){return ne(U,Z,Y)>=0}function Q(U,Z,Y){return ne(U,Z,Y)<=0}function te(U,Z,Y,Ee){var Te;switch(Z){case"===":typeof U=="object"&&(U=U.version),typeof Y=="object"&&(Y=Y.version),Te=U===Y;break;case"!==":typeof U=="object"&&(U=U.version),typeof Y=="object"&&(Y=Y.version),Te=U!==Y;break;case"":case"=":case"==":Te=Pe(U,Y,Ee);break;case"!=":Te=ce(U,Y,Ee);break;case">":Te=Ie(U,Y,Ee);break;case">=":Te=ie(U,Y,Ee);break;case"<":Te=Ae(U,Y,Ee);break;case"<=":Te=Q(U,Y,Ee);break;default:throw new TypeError("Invalid operator: "+Z)}return Te}function me(U,Z){if(U instanceof me){if(U.loose===Z)return U;U=U.value}if(!(this instanceof me))return new me(U,Z);I("comparator",U,Z),this.loose=Z,this.parse(U),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(U,Z){return V(Z,U)},e.major=function(U,Z){return new se(U,Z).major},e.minor=function(U,Z){return new se(U,Z).minor},e.patch=function(U,Z){return new se(U,Z).patch},e.compare=ne,e.compareLoose=function(U,Z){return ne(U,Z,!0)},e.rcompare=function(U,Z,Y){return ne(Z,U,Y)},e.sort=function(U,Z){return U.sort(function(Y,Ee){return e.compare(Y,Ee,Z)})},e.rsort=function(U,Z){return U.sort(function(Y,Ee){return e.rcompare(Y,Ee,Z)})},e.gt=Ie,e.lt=Ae,e.eq=Pe,e.neq=ce,e.gte=ie,e.lte=Q,e.cmp=te,e.Comparator=me;var pe={};function Fe(U,Z){if(U instanceof Fe)return U.loose===Z?U:new Fe(U.raw,Z);if(U instanceof me)return new Fe(U.value,Z);if(!(this instanceof Fe))return new Fe(U,Z);if(this.loose=Z,this.raw=U,this.set=U.split(/\s*\|\|\s*/).map(function(Y){return this.parseRange(Y.trim())},this).filter(function(Y){return Y.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+U);this.format()}function le(U){return!U||U.toLowerCase()==="x"||U==="*"}function we(U,Z,Y,Ee,Te,We,He,Xe,st,nt,tt,at,ct){return((Z=le(Y)?"":le(Ee)?">="+Y+".0.0":le(Te)?">="+Y+"."+Ee+".0":">="+Z)+" "+(Xe=le(st)?"":le(nt)?"<"+(+st+1)+".0.0":le(tt)?"<"+st+"."+(+nt+1)+".0":at?"<="+st+"."+nt+"."+tt+"-"+at:"<="+Xe)).trim()}function M(U,Z){for(var Y=0;Y<U.length;Y++)if(!U[Y].test(Z))return!1;if(Z.prerelease.length){for(Y=0;Y<U.length;Y++)if(I(U[Y].semver),U[Y].semver!==pe&&U[Y].semver.prerelease.length>0){var Ee=U[Y].semver;if(Ee.major===Z.major&&Ee.minor===Z.minor&&Ee.patch===Z.patch)return!0}return!1}return!0}function q(U,Z,Y){try{Z=new Fe(Z,Y)}catch{return!1}return Z.test(U)}function H(U,Z,Y,Ee){var Te,We,He,Xe,st;switch(U=new se(U,Ee),Z=new Fe(Z,Ee),Y){case">":Te=Ie,We=Q,He=Ae,Xe=">",st=">=";break;case"<":Te=Ae,We=ie,He=Ie,Xe="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(q(U,Z,Ee))return!1;for(var nt=0;nt<Z.set.length;++nt){var tt=Z.set[nt],at=null,ct=null;if(tt.forEach(function(ze){ze.semver===pe&&(ze=new me(">=0.0.0")),at=at||ze,ct=ct||ze,Te(ze.semver,at.semver,Ee)?at=ze:He(ze.semver,ct.semver,Ee)&&(ct=ze)}),at.operator===Xe||at.operator===st||(!ct.operator||ct.operator===Xe)&&We(U,ct.semver)||ct.operator===st&&He(U,ct.semver))return!1}return!0}me.prototype.parse=function(U){var Z=this.loose?$[ae]:$[fe],Y=U.match(Z);if(!Y)throw new TypeError("Invalid comparator: "+U);this.operator=Y[1],this.operator==="="&&(this.operator=""),Y[2]?this.semver=new se(Y[2],this.loose):this.semver=pe},me.prototype.toString=function(){return this.value},me.prototype.test=function(U){return I("Comparator.test",U,this.loose),this.semver===pe||(typeof U=="string"&&(U=new se(U,this.loose)),te(U,this.operator,this.semver,this.loose))},me.prototype.intersects=function(U,Z){if(!(U instanceof me))throw new TypeError("a Comparator is required");var Y;if(this.operator==="")return Y=new Fe(U.value,Z),q(this.value,Y,Z);if(U.operator==="")return Y=new Fe(this.value,Z),q(U.semver,Y,Z);var Ee=!(this.operator!==">="&&this.operator!==">"||U.operator!==">="&&U.operator!==">"),Te=!(this.operator!=="<="&&this.operator!=="<"||U.operator!=="<="&&U.operator!=="<"),We=this.semver.version===U.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||U.operator!==">="&&U.operator!=="<="),Xe=te(this.semver,"<",U.semver,Z)&&(this.operator===">="||this.operator===">")&&(U.operator==="<="||U.operator==="<"),st=te(this.semver,">",U.semver,Z)&&(this.operator==="<="||this.operator==="<")&&(U.operator===">="||U.operator===">");return Ee||Te||We&&He||Xe||st},e.Range=Fe,Fe.prototype.format=function(){return this.range=this.set.map(function(U){return U.join(" ").trim()}).join("||").trim(),this.range},Fe.prototype.toString=function(){return this.range},Fe.prototype.parseRange=function(U){var Z=this.loose;U=U.trim(),I("range",U,Z);var Y=Z?$[he]:$[ye];U=U.replace(Y,we),I("hyphen replace",U),U=U.replace($[be],"$1$2$3"),I("comparator trim",U,$[be]),U=(U=(U=U.replace($[O],"$1~")).replace($[P],"$1^")).split(/\s+/).join(" ");var Ee=Z?$[ae]:$[fe],Te=U.split(" ").map(function(We){return function(He,Xe){return I("comp",He),He=function(st,nt){return st.trim().split(/\s+/).map(function(tt){return function(at,ct){I("caret",at,ct);var ze=ct?$[J]:$[C];return at.replace(ze,function(vt,X,x,$e,Be){var Qe;return I("caret",at,vt,X,x,$e,Be),le(X)?Qe="":le(x)?Qe=">="+X+".0.0 <"+(+X+1)+".0.0":le($e)?Qe=X==="0"?">="+X+"."+x+".0 <"+X+"."+(+x+1)+".0":">="+X+"."+x+".0 <"+(+X+1)+".0.0":Be?(I("replaceCaret pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Qe=X==="0"?x==="0"?">="+X+"."+x+"."+$e+Be+" <"+X+"."+x+"."+(+$e+1):">="+X+"."+x+"."+$e+Be+" <"+X+"."+(+x+1)+".0":">="+X+"."+x+"."+$e+Be+" <"+(+X+1)+".0.0"):(I("no pr"),Qe=X==="0"?x==="0"?">="+X+"."+x+"."+$e+" <"+X+"."+x+"."+(+$e+1):">="+X+"."+x+"."+$e+" <"+X+"."+(+x+1)+".0":">="+X+"."+x+"."+$e+" <"+(+X+1)+".0.0"),I("caret return",Qe),Qe})}(tt,nt)}).join(" ")}(He,Xe),I("caret",He),He=function(st,nt){return st.trim().split(/\s+/).map(function(tt){return function(at,ct){var ze=ct?$[j]:$[K];return at.replace(ze,function(vt,X,x,$e,Be){var Qe;return I("tilde",at,vt,X,x,$e,Be),le(X)?Qe="":le(x)?Qe=">="+X+".0.0 <"+(+X+1)+".0.0":le($e)?Qe=">="+X+"."+x+".0 <"+X+"."+(+x+1)+".0":Be?(I("replaceTilde pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Qe=">="+X+"."+x+"."+$e+Be+" <"+X+"."+(+x+1)+".0"):Qe=">="+X+"."+x+"."+$e+" <"+X+"."+(+x+1)+".0",I("tilde return",Qe),Qe})}(tt,nt)}).join(" ")}(He,Xe),I("tildes",He),He=function(st,nt){return I("replaceXRanges",st,nt),st.split(/\s+/).map(function(tt){return function(at,ct){at=at.trim();var ze=ct?$[y]:$[v];return at.replace(ze,function(vt,X,x,$e,Be,Qe){I("xRange",at,vt,X,x,$e,Be,Qe);var it=le(x),rt=it||le($e),Ne=rt||le(Be);return X==="="&&Ne&&(X=""),it?vt=X===">"||X==="<"?"<0.0.0":"*":X&&Ne?(rt&&($e=0),Ne&&(Be=0),X===">"?(X=">=",rt?(x=+x+1,$e=0,Be=0):Ne&&($e=+$e+1,Be=0)):X==="<="&&(X="<",rt?x=+x+1:$e=+$e+1),vt=X+x+"."+$e+"."+Be):rt?vt=">="+x+".0.0 <"+(+x+1)+".0.0":Ne&&(vt=">="+x+"."+$e+".0 <"+x+"."+(+$e+1)+".0"),I("xRange return",vt),vt})}(tt,nt)}).join(" ")}(He,Xe),I("xrange",He),He=function(st,nt){return I("replaceStars",st,nt),st.trim().replace($[ve],"")}(He,Xe),I("stars",He),He}(We,Z)}).join(" ").split(/\s+/);return this.loose&&(Te=Te.filter(function(We){return!!We.match(Ee)})),Te=Te.map(function(We){return new me(We,Z)})},Fe.prototype.intersects=function(U,Z){if(!(U instanceof Fe))throw new TypeError("a Range is required");return this.set.some(function(Y){return Y.every(function(Ee){return U.set.some(function(Te){return Te.every(function(We){return Ee.intersects(We,Z)})})})})},e.toComparators=function(U,Z){return new Fe(U,Z).set.map(function(Y){return Y.map(function(Ee){return Ee.value}).join(" ").trim().split(" ")})},Fe.prototype.test=function(U){if(!U)return!1;typeof U=="string"&&(U=new se(U,this.loose));for(var Z=0;Z<this.set.length;Z++)if(M(this.set[Z],U))return!0;return!1},e.satisfies=q,e.maxSatisfying=function(U,Z,Y){var Ee=null,Te=null;try{var We=new Fe(Z,Y)}catch{return null}return U.forEach(function(He){We.test(He)&&(Ee&&Te.compare(He)!==-1||(Te=new se(Ee=He,Y)))}),Ee},e.minSatisfying=function(U,Z,Y){var Ee=null,Te=null;try{var We=new Fe(Z,Y)}catch{return null}return U.forEach(function(He){We.test(He)&&(Ee&&Te.compare(He)!==1||(Te=new se(Ee=He,Y)))}),Ee},e.validRange=function(U,Z){try{return new Fe(U,Z).range||"*"}catch{return null}},e.ltr=function(U,Z,Y){return H(U,Z,"<",Y)},e.gtr=function(U,Z,Y){return H(U,Z,">",Y)},e.outside=H,e.prerelease=function(U,Z){var Y=ke(U,Z);return Y&&Y.prerelease.length?Y.prerelease:null},e.intersects=function(U,Z,Y){return U=new Fe(U,Y),Z=new Fe(Z,Y),U.intersects(Z)},e.coerce=function(U){if(U instanceof se)return U;if(typeof U!="string")return null;var Z=U.match($[k]);return Z==null?null:ke((Z[1]||"0")+"."+(Z[2]||"0")+"."+(Z[3]||"0"))}}).call(this,E(1))},function(ge,e){var E,T,I=ge.exports={};function F(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function $(o){if(E===setTimeout)return setTimeout(o,0);if((E===F||!E)&&setTimeout)return E=setTimeout,setTimeout(o,0);try{return E(o,0)}catch{try{return E.call(null,o,0)}catch{return E.call(this,o,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:F}catch{E=F}try{T=typeof clearTimeout=="function"?clearTimeout:R}catch{T=R}})();var g,w=[],A=!1,D=-1;function l(){A&&g&&(A=!1,g.length?w=g.concat(w):D=-1,w.length&&p())}function p(){if(!A){var o=$(l);A=!0;for(var t=w.length;t;){for(g=w,w=[];++D<t;)g&&g[D].run();D=-1,t=w.length}g=null,A=!1,function(n){if(T===clearTimeout)return clearTimeout(n);if((T===R||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(n);try{T(n)}catch{try{return T.call(null,n)}catch{return T.call(this,n)}}}(o)}}function b(o,t){this.fun=o,this.array=t}function r(){}I.nextTick=function(o){var t=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)t[n-1]=arguments[n];w.push(new b(o,t)),w.length!==1||A||$(p)},b.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=r,I.addListener=r,I.once=r,I.off=r,I.removeListener=r,I.removeAllListeners=r,I.emit=r,I.prependListener=r,I.prependOnceListener=r,I.listeners=function(o){return[]},I.binding=function(o){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(o){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Ce[123],Re([1,0,15,6]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;function I(c){const h=c;return h?typeof h.read=="function":!1}e.$4d=I;function F(c){const h=c;return h?[h.on,h.pause,h.resume,h.destroy].every(i=>typeof i=="function"):!1}e.$5d=F;function R(c){const h=c;return h?F(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$6d=R;function $(c,h){return new g(c,h)}e.$7d=$;class g{constructor(h,i){this.e=h,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(i=>i(h))}h(h){this.c.error.length===0?(0,E.$1)(h):this.c.error.slice(0).forEach(i=>i(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,i){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(h,i){if(this.a.destroyed)return;let s;switch(h){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const u=s.indexOf(i);u>=0&&s.splice(u,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(c,h){const i=[];let s;for(;(s=c.read())!==null;)i.push(s);return h(i)}e.$8d=w;function A(c,h,i){const s=[];let u;for(;(u=c.read())!==null&&s.length<i;)s.push(u);return u===null&&s.length>0?h(s):{read:()=>{if(s.length>0)return s.shift();if(typeof u<"u"){const d=u;return u=void 0,d}return c.read()}}}e.$9d=A;function D(c,h){return new Promise((i,s)=>{const u=[];l(c,{onData:d=>{h&&u.push(d)},onError:d=>{h?s(d):i(void 0)},onEnd:()=>{i(h?h(u):void 0)}})})}e.$0d=D;function l(c,h,i){c.on("error",s=>{i?.isCancellationRequested||h.onError(s)}),c.on("end",()=>{i?.isCancellationRequested||h.onEnd()}),c.on("data",s=>{i?.isCancellationRequested||h.onData(s)})}e.$$d=l;function p(c,h){return new Promise((i,s)=>{const u=new T.$Rc,d=[],m=L=>{if(d.push(L),d.length>h)return u.dispose(),c.pause(),i({stream:c,buffer:d,ended:!1})},f=L=>(u.dispose(),s(L)),S=()=>(u.dispose(),i({stream:c,buffer:d,ended:!0}));u.add((0,T.$Qc)(()=>c.removeListener("error",f))),c.on("error",f),u.add((0,T.$Qc)(()=>c.removeListener("end",S))),c.on("end",S),u.add((0,T.$Qc)(()=>c.removeListener("data",m))),c.on("data",m)})}e.$_d=p;function b(c,h){const i=$(h);return i.end(c),i}e.$ae=b;function r(){const c=$(()=>{throw new Error("not supported")});return c.end(),c}e.$be=r;function o(c){let h=!1;return{read:()=>h?null:(h=!0,c)}}e.$ce=o;function t(c,h,i){const s=$(i);return l(c,{onData:u=>s.write(h.data(u)),onError:u=>s.error(h.error?h.error(u):u),onEnd:()=>s.end()}),s}e.$de=t;function n(c,h,i){let s=!1;return{read:()=>{const u=h.read();return s?u:(s=!0,u!==null?i([c,u]):c)}}}e.$ee=n;function a(c,h,i){let s=!1;const u=$(i);return l(h,{onData:d=>s?u.write(d):(s=!0,u.write(i([c,d]))),onError:d=>u.error(d),onEnd:()=>{s||(s=!0,u.write(c)),u.end()}}),u}e.$fe=a}),define(Ce[24],Re([1,0,39,123]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=void 0;const I=typeof Buffer<"u",F=new E.$V(()=>new Uint8Array(256));let R,$;class g{static alloc(k){return I?new g(Buffer.allocUnsafe(k)):new g(new Uint8Array(k))}static wrap(k){return I&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new g(k)}static fromString(k,N){return!(N?.dontUseNodeBuffer||!1)&&I?new g(Buffer.from(k)):(R||(R=new TextEncoder),new g(R.encode(k)))}static fromByteArray(k){const N=g.alloc(k.length);for(let O=0,K=k.length;O<K;O++)N.buffer[O]=k[O];return N}static concat(k,N){if(typeof N>"u"){N=0;for(let j=0,W=k.length;j<W;j++)N+=k[j].byteLength}const O=g.alloc(N);let K=0;for(let j=0,W=k.length;j<W;j++){const P=k[j];O.set(P,K),K+=P.byteLength}return O}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=g.alloc(this.byteLength);return k.set(this),k}toString(){return I?this.buffer.toString():($||($=new TextDecoder),$.decode(this.buffer))}slice(k,N){return new g(this.buffer.subarray(k,N))}set(k,N){if(k instanceof g)this.buffer.set(k.buffer,N);else if(k instanceof Uint8Array)this.buffer.set(k,N);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),N);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),N);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return l(this.buffer,k)}writeUInt32BE(k,N){p(this.buffer,k,N)}readUInt32LE(k){return b(this.buffer,k)}writeUInt32LE(k,N){r(this.buffer,k,N)}readUInt8(k){return o(this.buffer,k)}writeUInt8(k,N){t(this.buffer,k,N)}indexOf(k,N=0){return w(this.buffer,k instanceof g?k.buffer:k,N)}}e.$ge=g;function w(y,k,N=0){const O=k.byteLength,K=y.byteLength;if(O===0)return 0;if(O===1)return y.indexOf(k[0]);if(O>K-N)return-1;const j=F.value;j.fill(k.length);for(let J=0;J<k.length;J++)j[k[J]]=k.length-J-1;let W=N+k.length-1,P=W,C=-1;for(;W<K;)if(y[W]===k[P]){if(P===0){C=W;break}W--,P--}else W+=Math.max(k.length-P,j[y[W]]),P=k.length-1;return C}e.$he=w;function A(y,k){return y[k+0]<<0>>>0|y[k+1]<<8>>>0}e.$ie=A;function D(y,k,N){y[N+0]=k&255,k=k>>>8,y[N+1]=k&255}e.$je=D;function l(y,k){return y[k]*2**24+y[k+1]*2**16+y[k+2]*2**8+y[k+3]}e.$ke=l;function p(y,k,N){y[N+3]=k,k=k>>>8,y[N+2]=k,k=k>>>8,y[N+1]=k,k=k>>>8,y[N]=k}e.$le=p;function b(y,k){return y[k+0]<<0>>>0|y[k+1]<<8>>>0|y[k+2]<<16>>>0|y[k+3]<<24>>>0}e.$me=b;function r(y,k,N){y[N+0]=k&255,k=k>>>8,y[N+1]=k&255,k=k>>>8,y[N+2]=k&255,k=k>>>8,y[N+3]=k&255}e.$ne=r;function o(y,k){return y[k]}e.$oe=o;function t(y,k,N){y[N]=k}e.$pe=t;function n(y){return T.$8d(y,k=>g.concat(k))}e.$qe=n;function a(y){return T.$ce(y)}e.$re=a;function c(y){return T.$0d(y,k=>g.concat(k))}e.$se=c;async function h(y){return y.ended?g.concat(y.buffer):g.concat([...y.buffer,await c(y.stream)])}e.$te=h;function i(y){return T.$ae(y,k=>g.concat(k))}e.$ue=i;function s(y){return T.$de(y,{data:k=>typeof k=="string"?g.fromString(k):g.wrap(k)},k=>g.concat(k))}e.$ve=s;function u(y){return T.$7d(k=>g.concat(k),y)}e.$we=u;function d(y,k){return T.$ee(y,k,N=>g.concat(N))}e.$xe=d;function m(y,k){return T.$fe(y,k,N=>g.concat(N))}e.$ye=m;function f(y){let k=0,N=0,O=0;const K=new Uint8Array(Math.floor(y.length/4*3)),j=P=>{switch(N){case 3:K[O++]=k|P,N=0;break;case 2:K[O++]=k|P>>>2,k=P<<6,N=3;break;case 1:K[O++]=k|P>>>4,k=P<<4,N=2;break;default:k=P<<2,N=1}};for(let P=0;P<y.length;P++){const C=y.charCodeAt(P);if(C>=65&&C<=90)j(C-65);else if(C>=97&&C<=122)j(C-97+26);else if(C>=48&&C<=57)j(C-48+52);else if(C===43||C===45)j(62);else if(C===47||C===95)j(63);else{if(C===61)break;throw new SyntaxError(`Unexpected base64 character ${y[P]}`)}}const W=O;for(;N>0;)j(0);return g.wrap(K).slice(0,W)}e.$ze=f;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:y},k=!0,N=!1){const O=N?L:S;let K="";const j=y.byteLength%3;let W=0;for(;W<y.byteLength-j;W+=3){const P=y[W+0],C=y[W+1],J=y[W+2];K+=O[P>>>2],K+=O[(P<<4|C>>>4)&63],K+=O[(C<<2|J>>>6)&63],K+=O[J&63]}if(j===1){const P=y[W+0];K+=O[P>>>2],K+=O[P<<4&63],k&&(K+="==")}else if(j===2){const P=y[W+0],C=y[W+1];K+=O[P>>>2],K+=O[(P<<4|C>>>4)&63],K+=O[C<<2&63],k&&(K+="=")}return K}e.$Ae=v}),define(Ce[124],Re([1,0,28,121,11]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$5j=e.$4j=e.$3j=e.FuzzyScore=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.or=void 0;function F(...le){return function(we,M){for(let q=0,H=le.length;q<H;q++){const U=le[q](we,M);if(U)return U}return null}}e.or=F,e.$Qj=R.bind(void 0,!1),e.$Rj=R.bind(void 0,!0);function R(le,we,M){if(!M||M.length<we.length)return null;let q;return le?q=I.$0e(M,we):q=M.indexOf(we)===0,q?we.length>0?[{start:0,end:we.length}]:[]:null}function $(le,we){const M=we.toLowerCase().indexOf(le.toLowerCase());return M===-1?null:[{start:M,end:M+le.length}]}e.$Sj=$;function g(le,we){return w(le.toLowerCase(),we.toLowerCase(),0,0)}e.$Tj=g;function w(le,we,M,q){if(M===le.length)return[];if(q===we.length)return null;if(le[M]===we[q]){let H=null;return(H=w(le,we,M+1,q+1))?c({start:q,end:q+1},H):null}return w(le,we,M,q+1)}function A(le){return 97<=le&&le<=122}function D(le){return 65<=le&&le<=90}e.$Uj=D;function l(le){return 48<=le&&le<=57}function p(le){return le===32||le===9||le===10||le===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(le=>b.add(le.charCodeAt(0)));function r(le){return p(le)||b.has(le)}function o(le,we){return le===we||r(le)&&r(we)}const t=new Map;function n(le){if(t.has(le))return t.get(le);let we;const M=(0,T.$Oj)(le);return M&&(we=M),t.set(le,we),we}function a(le){return A(le)||D(le)||l(le)}function c(le,we){return we.length===0?we=[le]:le.end===we[0].start?we[0].start=le.start:we.unshift(le),we}function h(le,we){for(let M=we;M<le.length;M++){const q=le.charCodeAt(M);if(D(q)||l(q)||M>0&&!a(le.charCodeAt(M-1)))return M}return le.length}function i(le,we,M,q){if(M===le.length)return[];if(q===we.length)return null;if(le[M]!==we[q].toLowerCase())return null;{let H=null,U=q+1;for(H=i(le,we,M+1,q+1);!H&&(U=h(we,U))<we.length;)H=i(le,we,M+1,U),U++;return H===null?null:c({start:q,end:q+1},H)}}function s(le){let we=0,M=0,q=0,H=0,U=0;for(let We=0;We<le.length;We++)U=le.charCodeAt(We),D(U)&&we++,A(U)&&M++,a(U)&&q++,l(U)&&H++;const Z=we/le.length,Y=M/le.length,Ee=q/le.length,Te=H/le.length;return{upperPercent:Z,lowerPercent:Y,alphaPercent:Ee,numericPercent:Te}}function u(le){const{upperPercent:we,lowerPercent:M}=le;return M===0&&we>.6}function d(le){const{upperPercent:we,lowerPercent:M,alphaPercent:q,numericPercent:H}=le;return M>.2&&we<.8&&q>.6&&H<.2}function m(le){let we=0,M=0,q=0,H=0;for(let U=0;U<le.length;U++)q=le.charCodeAt(U),D(q)&&we++,A(q)&&M++,p(q)&&H++;return(we===0||M===0)&&H===0?le.length<=30:we<=5}function f(le,we){if(!we||(we=we.trim(),we.length===0)||!m(le)||we.length>60)return null;const M=s(we);if(!d(M)){if(!u(M))return null;we=we.toLowerCase()}let q=null,H=0;for(le=le.toLowerCase();H<we.length&&(q=i(le,we,0,H))===null;)H=h(we,H+1);return q}e.$Vj=f;function S(le,we,M=!1){if(!we||we.length===0)return null;let q=null,H=0;for(le=le.toLowerCase(),we=we.toLowerCase();H<we.length&&(q=L(le,we,0,H,M),q===null);)H=v(we,H+1);return q}e.$Wj=S;function L(le,we,M,q,H){let U=0;if(M===le.length)return[];if(q===we.length)return null;if(!o(le.charCodeAt(M),we.charCodeAt(q))){const Ee=n(le.charCodeAt(M));if(!Ee)return null;for(let Te=0;Te<Ee.length;Te++)if(!o(Ee[Te],we.charCodeAt(q+Te)))return null;U+=Ee.length-1}let Z=null,Y=q+U+1;if(Z=L(le,we,M+1,Y,H),!H)for(;!Z&&(Y=v(we,Y))<we.length;)Z=L(le,we,M+1,Y,H),Y++;if(!Z)return null;if(le.charCodeAt(M)!==we.charCodeAt(q)){const Ee=n(le.charCodeAt(M));if(!Ee)return Z;for(let Te=0;Te<Ee.length;Te++)if(Ee[Te]!==we.charCodeAt(q+Te))return Z}return c({start:q,end:q+U+1},Z)}function v(le,we){for(let M=we;M<le.length;M++)if(r(le.charCodeAt(M))||M>0&&r(le.charCodeAt(M-1)))return M;return le.length}const y=F(e.$Rj,f,$),k=F(e.$Rj,f,g),N=new E.$Dc(1e4);function O(le,we,M=!1){if(typeof le!="string"||typeof we!="string")return null;let q=N.get(le);q||(q=new RegExp(I.$Se(le),"i"),N.set(le,q));const H=q.exec(we);return H?[{start:H.index,end:H.index+H[0].length}]:M?k(le,we):y(le,we)}e.$Xj=O;function K(le,we){const M=ce(le,le.toLowerCase(),0,we,we.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return M?W(M):null}e.$Yj=K;function j(le,we,M,q,H,U){const Z=Math.min(13,le.length);for(;M<Z;M++){const Y=ce(le,we,M,q,H,U,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Y)return Y}return[0,U]}e.$Zj=j;function W(le){if(typeof le>"u")return[];const we=[],M=le[1];for(let q=le.length-1;q>1;q--){const H=le[q]+M,U=we[we.length-1];U&&U.end===H?U.end=H+1:we.push({start:H,end:H+1})}return we}e.$1j=W;const P=128;function C(){const le=[],we=[];for(let M=0;M<=P;M++)we[M]=0;for(let M=0;M<=P;M++)le.push(we.slice(0));return le}function J(le){const we=[];for(let M=0;M<=le;M++)we[M]=0;return we}const ae=J(2*P),fe=J(2*P),be=C(),ye=C(),he=C(),ve=!1;function ee(le,we,M,q,H){function U(Y,Ee,Te=" "){for(;Y.length<Ee;)Y=Te+Y;return Y}let Z=` |   |${q.split("").map(Y=>U(Y,3)).join("|")}
`;for(let Y=0;Y<=M;Y++)Y===0?Z+=" |":Z+=`${we[Y-1]}|`,Z+=le[Y].slice(0,H+1).map(Ee=>U(Ee.toString(),3)).join("|")+`
`;return Z}function ke(le,we,M,q){le=le.substr(we),M=M.substr(q),console.log(ee(ye,le,le.length,M,M.length)),console.log(ee(he,le,le.length,M,M.length)),console.log(ee(be,le,le.length,M,M.length))}function se(le,we){if(we<0||we>=le.length)return!1;const M=le.codePointAt(we);switch(M){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!I.$pf(M)}}function _(le,we){if(we<0||we>=le.length)return!1;switch(le.charCodeAt(we)){case 32:case 9:return!0;default:return!1}}function V(le,we,M){return we[le]!==M[le]}function ne(le,we,M,q,H,U,Z=!1){for(;we<M&&H<U;)le[we]===q[H]&&(Z&&(ae[we]=H),we+=1),H+=1;return we===M}e.$2j=ne;var Ie;(function(le){le[le.Diag=1]="Diag",le[le.Left=2]="Left",le[le.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Ae;(function(le){le.Default=[-100,0];function we(M){return!M||M.length===2&&M[0]===-100&&M[1]===0}le.isDefault=we})(Ae||(e.FuzzyScore=Ae={}));class Pe{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(we,M){this.firstMatchCanBeWeak=we,this.boostFullMatch=M}}e.$3j=Pe;function ce(le,we,M,q,H,U,Z=Pe.default){const Y=le.length>P?P:le.length,Ee=q.length>P?P:q.length;if(M>=Y||U>=Ee||Y-M>Ee-U||!ne(we,M,Y,H,U,Ee,!0))return;ie(Y,Ee,M,U,we,H);let Te=1,We=1,He=M,Xe=U;const st=[!1];for(Te=1,He=M;He<Y;Te++,He++){const ze=ae[He],vt=fe[He],X=He+1<Y?fe[He+1]:Ee;for(We=ze-U+1,Xe=ze;Xe<X;We++,Xe++){let x=Number.MIN_SAFE_INTEGER,$e=!1;Xe<=vt&&(x=Q(le,we,He,M,q,H,Xe,Ee,U,be[Te-1][We-1]===0,st));let Be=0;x!==Number.MAX_SAFE_INTEGER&&($e=!0,Be=x+ye[Te-1][We-1]);const Qe=Xe>ze,it=Qe?ye[Te][We-1]+(be[Te][We-1]>0?-5:0):0,rt=Xe>ze+1&&be[Te][We-1]>0,Ne=rt?ye[Te][We-2]+(be[Te][We-2]>0?-5:0):0;if(rt&&(!Qe||Ne>=it)&&(!$e||Ne>=Be))ye[Te][We]=Ne,he[Te][We]=3,be[Te][We]=0;else if(Qe&&(!$e||it>=Be))ye[Te][We]=it,he[Te][We]=2,be[Te][We]=0;else if($e)ye[Te][We]=Be,he[Te][We]=1,be[Te][We]=be[Te-1][We-1]+1;else throw new Error("not possible")}}if(ve&&ke(le,M,q,U),!st[0]&&!Z.firstMatchCanBeWeak)return;Te--,We--;const nt=[ye[Te][We],U];let tt=0,at=0;for(;Te>=1;){let ze=We;do{const vt=he[Te][ze];if(vt===3)ze=ze-2;else if(vt===2)ze=ze-1;else break}while(ze>=1);tt>1&&we[M+Te-1]===H[U+We-1]&&!V(ze+U-1,q,H)&&tt+1>be[Te][ze]&&(ze=We),ze===We?tt++:tt=1,at||(at=ze),Te--,We=ze-1,nt.push(We)}Ee===Y&&Z.boostFullMatch&&(nt[0]+=2);const ct=at-Y;return nt[0]-=ct,nt}e.$4j=ce;function ie(le,we,M,q,H,U){let Z=le-1,Y=we-1;for(;Z>=M&&Y>=q;)H[Z]===U[Y]&&(fe[Z]=Y,Z--),Y--}function Q(le,we,M,q,H,U,Z,Y,Ee,Te,We){if(we[M]!==U[Z])return Number.MIN_SAFE_INTEGER;let He=1,Xe=!1;return Z===M-q?He=le[M]===H[Z]?7:5:V(Z,H,U)&&(Z===0||!V(Z-1,H,U))?(He=le[M]===H[Z]?7:5,Xe=!0):se(U,Z)&&(Z===0||!se(U,Z-1))?He=5:(se(U,Z-1)||_(U,Z-1))&&(He=5,Xe=!0),He>1&&M===q&&(We[0]=!0),Xe||(Xe=V(Z,H,U)||se(U,Z-1)||_(U,Z-1)),M===q?Z>Ee&&(He-=Xe?3:5):Te?He+=Xe?2:0:He+=Xe?0:1,Z+1===Y&&(He-=Xe?3:5),He}function te(le,we,M,q,H,U,Z){return pe(le,we,M,q,H,U,!0,Z)}e.$5j=te;function me(le,we,M,q,H,U,Z){return pe(le,we,M,q,H,U,!1,Z)}e.$6j=me;function pe(le,we,M,q,H,U,Z,Y){let Ee=ce(le,we,M,q,H,U,Y);if(Ee&&!Z)return Ee;if(le.length>=3){const Te=Math.min(7,le.length-1);for(let We=M+1;We<Te;We++){const He=Fe(le,We);if(He){const Xe=ce(He,He.toLowerCase(),M,q,H,U,Y);Xe&&(Xe[0]-=3,(!Ee||Xe[0]>Ee[0])&&(Ee=Xe))}}}return Ee}function Fe(le,we){if(we+1>=le.length)return;const M=le[we],q=le[we+1];if(M!==q)return le.slice(0,we)+q+M+le.slice(we+2)}}),define(Ce[31],Re([1,0,11]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(T||(T={})),function(I){const F="error",R="warning",$="warn",g="info",w="ignore";function A(l){return l?E.$9e(F,l)?I.Error:E.$9e(R,l)||E.$9e($,l)?I.Warning:E.$9e(g,l)?I.Info:I.Ignore:I.Ignore}I.fromValue=A;function D(l){switch(l){case I.Error:return F;case I.Warning:return R;case I.Info:return g;default:return w}}I.toString=D}(T||(T={})),e.default=T}),define(Ce[125],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pd=void 0,e.$Pd=Symbol("MicrotaskDelay")}),define(Ce[50],Re([1,0,18,11]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=void 0;class I{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const b=p.charCodeAt(0),r=this.b.charCodeAt(this.c);return b-r}value(){return this.b[this.c]}}e.$5h=I;class F{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,T.$3e)(p,this.b,0,p.length,this.c,this.d):(0,T.$5e)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$6h=F;class R{constructor(p=!0,b=!0){this.f=p,this.g=b}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let b=p.length-1;b>=0;b--,this.c--){const r=this.b.charCodeAt(b);if(!(r===47||this.f&&r===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const b=this.b.charCodeAt(this.e);if(b===47||this.f&&b===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,T.$3e)(p,this.b,0,p.length,this.d,this.e):(0,T.$5e)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$7h=R;var $;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})($||($={}));class g{constructor(p,b){this.f=p,this.g=b,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,T.$4e)(p,this.c.scheme);if(this.d[this.e]===2)return(0,T.$4e)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,T.$2e)(p,this.c.query);if(this.d[this.e]===5)return(0,T.$2e)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$8h=g;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(A||(A={}));class D{static forUris(p=()=>!1,b=()=>!1){return new D(new g(p,b))}static forPaths(p=!1){return new D(new R(void 0,!p))}static forStrings(){return new D(new I)}static forConfigKeys(){return new D(new F)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,b){if(b){const r=b.slice(0);(0,E.$Xb)(r);for(const o of r)this.set(o,p)}else{const r=p.slice(0);(0,E.$Xb)(r);for(const o of r)this.set(o[0],o[1])}}set(p,b){const r=this.b.reset(p);let o;this.c||(this.c=new w,this.c.segment=r.value());const t=[];for(o=this.c;;){const a=r.cmp(o.segment);if(a>0)o.left||(o.left=new w,o.left.segment=r.value()),t.push([-1,o]),o=o.left;else if(a<0)o.right||(o.right=new w,o.right.segment=r.value()),t.push([1,o]),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new w,o.mid.segment=r.value()),t.push([0,o]),o=o.mid;else break}const n=o.value;o.value=b,o.key=p;for(let a=t.length-1;a>=0;a--){const c=t[a][1];c.updateHeight();const h=c.balanceFactor();if(h<-1||h>1){const i=t[a][0],s=t[a+1][0];if(i===1&&s===1)t[a][1]=c.rotateLeft();else if(i===-1&&s===-1)t[a][1]=c.rotateRight();else if(i===1&&s===-1)c.right=t[a+1][1]=t[a+1][1].rotateRight(),t[a][1]=c.rotateLeft();else if(i===-1&&s===1)c.left=t[a+1][1]=t[a+1][1].rotateLeft(),t[a][1]=c.rotateRight();else throw new Error;if(a>0)switch(t[a-1][0]){case-1:t[a-1][1].left=t[a][1];break;case 1:t[a-1][1].right=t[a][1];break;case 0:t[a-1][1].mid=t[a][1];break}else this.c=t[0][1]}}return n}get(p){return this.d(p)?.value}d(p){const b=this.b.reset(p);let r=this.c;for(;r;){const o=b.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(b.hasNext())b.next(),r=r.mid;else break}return r}has(p){const b=this.d(p);return!(b?.value===void 0&&b?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,b){const r=this.b.reset(p),o=[];let t=this.c;for(;t;){const n=r.cmp(t.segment);if(n>0)o.push([-1,t]),t=t.left;else if(n<0)o.push([1,t]),t=t.right;else if(r.hasNext())r.next(),o.push([0,t]),t=t.mid;else break}if(t){if(b?(t.left=void 0,t.mid=void 0,t.right=void 0,t.height=1):(t.key=void 0,t.value=void 0),!t.mid&&!t.value)if(t.left&&t.right){const n=this.f(t.right);if(n.key){const{key:a,value:c,segment:h}=n;this.e(n.key,!1),t.key=a,t.value=c,t.segment=h}}else{const n=t.left??t.right;if(o.length>0){const[a,c]=o[o.length-1];switch(a){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this.c=n}for(let n=o.length-1;n>=0;n--){const a=o[n][1];a.updateHeight();const c=a.balanceFactor();if(c>1?(a.right.balanceFactor()>=0||(a.right=a.right.rotateRight()),o[n][1]=a.rotateLeft()):c<-1&&(a.left.balanceFactor()<=0||(a.left=a.left.rotateLeft()),o[n][1]=a.rotateRight()),n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const b=this.b.reset(p);let r=this.c,o;for(;r;){const t=b.cmp(r.segment);if(t>0)r=r.left;else if(t<0)r=r.right;else if(b.hasNext())b.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(p){return this.g(p,!1)}g(p,b){const r=this.b.reset(p);let o=this.c;for(;o;){const t=r.cmp(o.segment);if(t>0)o=o.left;else if(t<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else return o.mid?this.h(o.mid):b?o.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[b,r]of this)p(r,b)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const b=[];return this.j(p,b),b[Symbol.iterator]()}j(p,b){p&&(p.left&&this.j(p.left,b),p.value&&b.push([p.key,p.value]),p.mid&&this.j(p.mid,b),p.right&&this.j(p.right,b))}_isBalanced(){const p=b=>{if(!b)return!0;const r=b.balanceFactor();return r<-1||r>1?!1:p(b.left)&&p(b.right)};return p(this.c)}}e.$9h=D}),define(Ce[45],Re([1,0,90]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$0j=e.ThemeColor=void 0;var T;(function(R){function $(g){return g&&typeof g=="object"&&typeof g.id=="string"}R.isThemeColor=$})(T||(e.ThemeColor=T={}));function I(R){return{id:R}}e.$0j=I;var F;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const $=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function g(n){const a=$.exec(n.id);if(!a)return g(E.$9j.error);const[,c,h]=a,i=["codicon","codicon-"+c];return h&&i.push("codicon-modifier-"+h.substring(1)),i}R.asClassNameArray=g;function w(n){return g(n).join(" ")}R.asClassName=w;function A(n){return"."+g(n).join(".")}R.asCSSSelector=A;function D(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||T.isThemeColor(n.color))}R.isThemeIcon=D;const l=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function p(n){const a=l.exec(n);if(!a)return;const[,c]=a;return{id:c}}R.fromString=p;function b(n){return{id:n}}R.fromId=b;function r(n,a){let c=n.id;const h=c.lastIndexOf("~");return h!==-1&&(c=c.substring(0,h)),a&&(c=`${c}~${a}`),{id:c}}R.modify=r;function o(n){const a=n.id.lastIndexOf("~");if(a!==-1)return n.id.substring(a+1)}R.getModifier=o;function t(n,a){return n.id===a.id&&n.color?.id===a.color?.id}R.isEqual=t})(F||(e.ThemeIcon=F={}))}),define(Ce[126],Re([1,0,124,11,45]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=void 0;const F="$(",R=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),$=new RegExp(`(\\\\)?${R.source}`,"g");function g(t){return t.replace($,(n,a)=>a?n:`\\${n}`)}e.$$j=g;const w=new RegExp(`\\\\${R.source}`,"g");function A(t){return t.replace(w,n=>`\\${n}`)}e.$_j=A;const D=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function l(t){return t.indexOf(F)===-1?t:t.replace(D,(n,a,c,h)=>c?n:a||h||"")}e.$ak=l;function p(t){return t?t.replace(/\$\((.*?)\)/g,(n,a)=>` ${a} `).trim():""}e.$bk=p;const b=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(t){b.lastIndex=0;let n="";const a=[];let c=0;for(;;){const h=b.lastIndex,i=b.exec(t),s=t.substring(h,i?.index);if(s.length>0){n+=s;for(let u=0;u<s.length;u++)a.push(c)}if(!i)break;c+=i[0].length}return{text:n,iconOffsets:a}}e.$ck=r;function o(t,n,a=!1){const{text:c,iconOffsets:h}=n;if(!h||h.length===0)return(0,E.$Xj)(t,c,a);const i=(0,T.$Qe)(c," "),s=c.length-i.length,u=(0,E.$Xj)(t,i,a);if(u)for(const d of u){const m=h[d.start+s]+s;d.start+=m,d.end+=m}return u}e.$dk=o}),define(Ce[33],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ng=e.$mg=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(I){return E.test(I)}e.$mg=T,e.$ng=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function($){for(let g=0;g<$.length;g++)$[g]=Math.floor(Math.random()*256);return $};const F=new Uint8Array(16),R=[];for(let $=0;$<256;$++)R.push($.toString(16).padStart(2,"0"));return function(){I(F),F[6]=F[6]&15|64,F[8]=F[8]&63|128;let g=0,w="";return w+=R[F[g++]],w+=R[F[g++]],w+=R[F[g++]],w+=R[F[g++]],w+="-",w+=R[F[g++]],w+=R[F[g++]],w+="-",w+=R[F[g++]],w+=R[F[g++]],w+="-",w+=R[F[g++]],w+=R[F[g++]],w+="-",w+=R[F[g++]],w+=R[F[g++]],w+=R[F[g++]],w+=R[F[g++]],w+=R[F[g++]],w+=R[F[g++]],w}}()}),define(Ce[127],Re([1,0,18,67,33]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.$et=e.$dt=e.$ct=e.$bt=void 0;function F(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.$bt=F;function R(D,l,p){const b={id:(0,I.$ng)(),name:D,uri:l,data:p};return{asString:async()=>"",asFile:()=>b,value:void 0}}e.$ct=R;class ${constructor(){this.a=new Map}get size(){let l=0;for(const p of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const p=[...this.a.keys()];return T.Iterable.some(this,([b,r])=>r.asFile())&&p.push("files"),A(g(l),p)}get(l){return this.a.get(this.b(l))?.[0]}append(l,p){const b=this.a.get(l);b?b.push(p):this.a.set(this.b(l),[p])}replace(l,p){this.a.set(this.b(l),[p])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,p]of this.a)for(const b of p)yield[l,b]}b(l){return g(l)}}e.$dt=$;function g(D){return D.toLowerCase()}function w(D,l){return A(g(D),l.map(g))}e.$et=w;function A(D,l){if(D==="*/*")return l.length>0;if(l.includes(D))return!0;const p=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[b,r,o]=p;return o==="*"?l.some(t=>t.startsWith(r+"/")):!1}e.$ft=Object.freeze({create:D=>(0,E.$Mb)(D.map(l=>l.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$ft.split(D).filter(l=>!l.startsWith("#"))})}),define(Ce[128],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$it=e.StringEOL=void 0;var E;(function(I){I[I.Unknown=0]="Unknown",I[I.Invalid=3]="Invalid",I[I.LF=1]="LF",I[I.CRLF=2]="CRLF"})(E||(e.StringEOL=E={}));function T(I){let F=0,R=0,$=0,g=0;for(let w=0,A=I.length;w<A;w++){const D=I.charCodeAt(w);D===13?(F===0&&(R=w),F++,w+1<A&&I.charCodeAt(w+1)===10?(g|=2,w++):g|=3,$=w+1):D===10&&(g|=1,F===0&&(R=w),F++,$=w+1)}return F===0&&(R=I.length),[F,R,I.length-$,g]}e.$it=T}),define(Ce[129],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=void 0,e.$fs={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[130],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gt=e.$Ft=e.IndentAction=void 0;var E;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(E||(e.IndentAction=E={}));class T{constructor($){if(this.e=null,this.f=!1,this.open=$.open,this.close=$.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray($.notIn))for(let g=0,w=$.notIn.length;g<w;g++)switch($.notIn[g]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK($){switch($){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose($,g){if($.getTokenCount()===0)return!0;const w=$.findTokenIndexAtOffset(g-2),A=$.getStandardTokenType(w);return this.isOK(A)}g($,g){for(let w=$;w<=g;w++){const A=String.fromCharCode(w);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Ft=T;class I{constructor($){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const g of $)F(this.autoClosingPairsOpenByStart,g.open.charAt(0),g),F(this.autoClosingPairsOpenByEnd,g.open.charAt(g.open.length-1),g),F(this.autoClosingPairsCloseByStart,g.close.charAt(0),g),F(this.autoClosingPairsCloseByEnd,g.close.charAt(g.close.length-1),g),g.close.length===1&&g.open.length===1&&F(this.autoClosingPairsCloseSingleChar,g.close,g)}}e.$Gt=I;function F(R,$,g){R.has($)?R.get($).push(g):R.set($,[g])}}),define(Ce[131],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NB=e.$MB=e.$LB=e.$KB=e.$JB=e.$IB=e.$HB=e.$GB=e.$FB=e.NodeColor=e.$EB=void 0;class E{constructor(o,t){this.piece=o,this.color=t,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$FB)return I(this.right);let o=this;for(;o.parent!==e.$FB&&o.parent.left!==o;)o=o.parent;return o.parent===e.$FB?e.$FB:o.parent}prev(){if(this.left!==e.$FB)return F(this.left);let o=this;for(;o.parent!==e.$FB&&o.parent.right!==o;)o=o.parent;return o.parent===e.$FB?e.$FB:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$EB=E;var T;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(T||(e.NodeColor=T={})),e.$FB=new E(null,0),e.$FB.parent=e.$FB,e.$FB.left=e.$FB,e.$FB.right=e.$FB,e.$FB.color=0;function I(r){for(;r.left!==e.$FB;)r=r.left;return r}e.$GB=I;function F(r){for(;r.right!==e.$FB;)r=r.right;return r}e.$HB=F;function R(r){return r===e.$FB?0:r.size_left+r.piece.length+R(r.right)}function $(r){return r===e.$FB?0:r.lf_left+r.piece.lineFeedCnt+$(r.right)}function g(){e.$FB.parent=e.$FB}function w(r,o){const t=o.right;t.size_left+=o.size_left+(o.piece?o.piece.length:0),t.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=t.left,t.left!==e.$FB&&(t.left.parent=o),t.parent=o.parent,o.parent===e.$FB?r.root=t:o.parent.left===o?o.parent.left=t:o.parent.right=t,t.left=o,o.parent=t}e.$IB=w;function A(r,o){const t=o.left;o.left=t.right,t.right!==e.$FB&&(t.right.parent=o),t.parent=o.parent,o.size_left-=t.size_left+(t.piece?t.piece.length:0),o.lf_left-=t.lf_left+(t.piece?t.piece.lineFeedCnt:0),o.parent===e.$FB?r.root=t:o===o.parent.right?o.parent.right=t:o.parent.left=t,t.right=o,o.parent=t}e.$JB=A;function D(r,o){let t,n;if(o.left===e.$FB?(n=o,t=n.right):o.right===e.$FB?(n=o,t=n.left):(n=I(o.right),t=n.right),n===r.root){r.root=t,t.color=0,o.detach(),g(),r.root.parent=e.$FB;return}const a=n.color===1;if(n===n.parent.left?n.parent.left=t:n.parent.right=t,n===o?(t.parent=n.parent,b(r,t)):(n.parent===o?t.parent=n:t.parent=n.parent,b(r,t),n.left=o.left,n.right=o.right,n.parent=o.parent,n.color=o.color,o===r.root?r.root=n:o===o.parent.left?o.parent.left=n:o.parent.right=n,n.left!==e.$FB&&(n.left.parent=n),n.right!==e.$FB&&(n.right.parent=n),n.size_left=o.size_left,n.lf_left=o.lf_left,b(r,n)),o.detach(),t.parent.left===t){const h=R(t),i=$(t);if(h!==t.parent.size_left||i!==t.parent.lf_left){const s=h-t.parent.size_left,u=i-t.parent.lf_left;t.parent.size_left=h,t.parent.lf_left=i,p(r,t.parent,s,u)}}if(b(r,t.parent),a){g();return}let c;for(;t!==r.root&&t.color===0;)t===t.parent.left?(c=t.parent.right,c.color===1&&(c.color=0,t.parent.color=1,w(r,t.parent),c=t.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,t=t.parent):(c.right.color===0&&(c.left.color=0,c.color=1,A(r,c),c=t.parent.right),c.color=t.parent.color,t.parent.color=0,c.right.color=0,w(r,t.parent),t=r.root)):(c=t.parent.left,c.color===1&&(c.color=0,t.parent.color=1,A(r,t.parent),c=t.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,t=t.parent):(c.left.color===0&&(c.right.color=0,c.color=1,w(r,c),c=t.parent.left),c.color=t.parent.color,t.parent.color=0,c.left.color=0,A(r,t.parent),t=r.root));t.color=0,g()}e.$KB=D;function l(r,o){for(b(r,o);o!==r.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const t=o.parent.parent.right;t.color===1?(o.parent.color=0,t.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,w(r,o)),o.parent.color=0,o.parent.parent.color=1,A(r,o.parent.parent))}else{const t=o.parent.parent.left;t.color===1?(o.parent.color=0,t.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,A(r,o)),o.parent.color=0,o.parent.parent.color=1,w(r,o.parent.parent))}r.root.color=0}e.$LB=l;function p(r,o,t,n){for(;o!==r.root&&o!==e.$FB;)o.parent.left===o&&(o.parent.size_left+=t,o.parent.lf_left+=n),o=o.parent}e.$MB=p;function b(r,o){let t=0,n=0;if(o!==r.root){for(;o!==r.root&&o===o.parent.right;)o=o.parent;if(o!==r.root)for(o=o.parent,t=R(o.left)-o.size_left,n=$(o.left)-o.lf_left,o.size_left+=t,o.lf_left+=n;o!==r.root&&(t!==0||n!==0);)o.parent.left===o&&(o.parent.size_left+=t,o.parent.lf_left+=n),o=o.parent}}e.$NB=b}),define(Ce[91],Re([1,0,92,29,93,131,94]),function(ge,e,E,T,I,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YB=e.$XB=e.$WB=e.$VB=e.$UB=void 0;const $=65535;function g(t){let n;return t[t.length-1]<65536?n=new Uint16Array(t.length):n=new Uint32Array(t.length),n.set(t,0),n}class w{constructor(n,a,c,h,i){this.lineStarts=n,this.cr=a,this.lf=c,this.crlf=h,this.isBasicASCII=i}}function A(t,n=!0){const a=[0];let c=1;for(let h=0,i=t.length;h<i;h++){const s=t.charCodeAt(h);s===13?h+1<i&&t.charCodeAt(h+1)===10?(a[c++]=h+2,h++):a[c++]=h+1:s===10&&(a[c++]=h+1)}return n?g(a):a}e.$UB=A;function D(t,n){t.length=0,t[0]=0;let a=1,c=0,h=0,i=0,s=!0;for(let d=0,m=n.length;d<m;d++){const f=n.charCodeAt(d);f===13?d+1<m&&n.charCodeAt(d+1)===10?(i++,t[a++]=d+2,d++):(c++,t[a++]=d+1):f===10?(h++,t[a++]=d+1):s&&f!==9&&(f<32||f>126)&&(s=!1)}const u=new w(g(t),c,h,i,s);return t.length=0,u}e.$VB=D;class l{constructor(n,a,c,h,i){this.bufferIndex=n,this.start=a,this.end=c,this.lineFeedCnt=h,this.length=i}}e.$WB=l;class p{constructor(n,a){this.buffer=n,this.lineStarts=a}}e.$XB=p;class b{constructor(n,a){this.a=[],this.c=n,this.d=a,this.b=0,n.root!==F.$FB&&n.iterate(n.root,c=>(c!==F.$FB&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class r{constructor(n){this.a=n,this.b=[]}get(n){for(let a=this.b.length-1;a>=0;a--){const c=this.b[a];if(c.nodeStartOffset<=n&&c.nodeStartOffset+c.node.piece.length>=n)return c}return null}get2(n){for(let a=this.b.length-1;a>=0;a--){const c=this.b[a];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<n&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=n)return c}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let a=!1;const c=this.b;for(let h=0;h<c.length;h++){const i=c[h];if(i.node.parent===null||i.nodeStartOffset>=n){c[h]=null,a=!0;continue}}if(a){const h=[];for(const i of c)i!==null&&h.push(i);this.b=h}}}class o{constructor(n,a,c){this.create(n,a,c)}create(n,a,c){this.a=[new p("",[0])],this.g={line:0,column:0},this.root=F.$FB,this.b=1,this.c=0,this.d=a,this.e=a.length,this.f=c;let h=null;for(let i=0,s=n.length;i<s;i++)if(n[i].buffer.length>0){n[i].lineStarts||(n[i].lineStarts=A(n[i].buffer));const u=new l(i+1,{line:0,column:0},{line:n[i].lineStarts.length-1,column:n[i].buffer.length-n[i].lineStarts[n[i].lineStarts.length-1]},n[i].lineStarts.length-1,n[i].buffer.length);this.a.push(n[i]),h=this.S(h,u)}this.h=new r(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const a=$,c=a-Math.floor(a/3),h=c*2;let i="",s=0;const u=[];if(this.iterate(this.root,d=>{const m=this.R(d),f=m.length;if(s<=c||s+f<h)return i+=m,s+=f,!0;const S=i.replace(/\r\n|\r|\n/g,n);return u.push(new p(S,A(S))),i=m,s=f,!0}),s>0){const d=i.replace(/\r\n|\r|\n/g,n);u.push(new p(d,A(d)))}this.create(u,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new b(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let a=0;return this.iterate(this.root,h=>{if(h===F.$FB)return!0;const i=this.R(h),s=i.length,u=n.G(a),d=n.G(a+s),m=n.getValueInRange2(u,d);return a+=s,i===m})}getOffsetAt(n,a){let c=0,h=this.root;for(;h!==F.$FB;)if(h.left!==F.$FB&&h.lf_left+1>=n)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=n){c+=h.size_left;const i=this.B(h,n-h.lf_left-2);return c+=i+a-1}else n-=h.lf_left+h.piece.lineFeedCnt,c+=h.size_left+h.piece.length,h=h.right;return c}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let a=this.root,c=0;const h=n;for(;a!==F.$FB;)if(a.size_left!==0&&a.size_left>=n)a=a.left;else if(a.size_left+a.piece.length>=n){const i=this.A(a,n-a.size_left);if(c+=a.lf_left+i.index,i.index===0){const s=this.getOffsetAt(c+1,1),u=h-s;return new E.$Hs(c+1,u+1)}return new E.$Hs(c+1,i.remainder+1)}else if(n-=a.size_left+a.piece.length,c+=a.lf_left+a.piece.lineFeedCnt,a.right===F.$FB){const i=this.getOffsetAt(c+1,1),s=h-n-i;return new E.$Hs(c+1,s+1)}else a=a.right;return new E.$Hs(1,1)}getValueInRange(n,a){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const c=this.H(n.startLineNumber,n.startColumn),h=this.H(n.endLineNumber,n.endColumn),i=this.getValueInRange2(c,h);return a?a!==this.d||!this.f?i.replace(/\r\n|\r|\n/g,a):a===this.getEOL()&&this.f?i:i.replace(/\r\n|\r|\n/g,a):i}getValueInRange2(n,a){if(n.node===a.node){const u=n.node,d=this.a[u.piece.bufferIndex].buffer,m=this.u(u.piece.bufferIndex,u.piece.start);return d.substring(m+n.remainder,m+a.remainder)}let c=n.node;const h=this.a[c.piece.bufferIndex].buffer,i=this.u(c.piece.bufferIndex,c.piece.start);let s=h.substring(i+n.remainder,i+c.piece.length);for(c=c.next();c!==F.$FB;){const u=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(c===a.node){s+=u.substring(d,d+a.remainder);break}else s+=u.substr(d,c.piece.length);c=c.next()}return s}getLinesContent(){const n=[];let a=0,c="",h=!1;return this.iterate(this.root,i=>{if(i===F.$FB)return!0;const s=i.piece;let u=s.length;if(u===0)return!0;const d=this.a[s.bufferIndex].buffer,m=this.a[s.bufferIndex].lineStarts,f=s.start.line,S=s.end.line;let L=m[f]+s.start.column;if(h&&(d.charCodeAt(L)===10&&(L++,u--),n[a++]=c,c="",h=!1,u===0))return!0;if(f===S)return!this.f&&d.charCodeAt(L+u-1)===13?(h=!0,c+=d.substr(L,u-1)):c+=d.substr(L,u),!0;c+=this.f?d.substring(L,Math.max(L,m[f+1]-this.e)):d.substring(L,m[f+1]).replace(/(\r\n|\r|\n)$/,""),n[a++]=c;for(let v=f+1;v<S;v++)c=this.f?d.substring(m[v],m[v+1]-this.e):d.substring(m[v],m[v+1]).replace(/(\r\n|\r|\n)$/,""),n[a++]=c;return!this.f&&d.charCodeAt(m[S]+s.end.column-1)===13?(h=!0,s.end.column===0?a--:c=d.substr(m[S],s.end.column-1)):c=d.substr(m[S],s.end.column),!0}),h&&(n[a++]=c,c=""),n[a++]=c,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const a=n.node.next();if(!a)return 0;const c=this.a[a.piece.bufferIndex],h=this.u(a.piece.bufferIndex,a.piece.start);return c.buffer.charCodeAt(h)}else{const a=this.a[n.node.piece.bufferIndex],h=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return a.buffer.charCodeAt(h)}}getLineCharCode(n,a){const c=this.H(n,a+1);return this.l(c)}getLineLength(n){if(n===this.getLineCount()){const a=this.getOffsetAt(n,1);return this.getLength()-a}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const a=this.G(n);return this.l(a)}findMatchesInNode(n,a,c,h,i,s,u,d,m,f,S){const L=this.a[n.piece.bufferIndex],v=this.u(n.piece.bufferIndex,n.piece.start),y=this.u(n.piece.bufferIndex,i),k=this.u(n.piece.bufferIndex,s);let N;const O={line:0,column:0};let K,j;a._wordSeparators?(K=L.buffer.substring(y,k),j=W=>W+y,a.reset(0)):(K=L.buffer,j=W=>W,a.reset(y));do if(N=a.next(K),N){if(j(N.index)>=k)return f;this.s(n,j(N.index)-v,O);const W=this.t(n.piece.bufferIndex,i,O),P=O.line===i.line?O.column-i.column+h:O.column+1,C=P+N[0].length;if(S[f++]=(0,R.$QB)(new T.$Is(c+W,P,c+W,C),N,d),j(N.index)+N[0].length>=k||f>=m)return f}while(N);return f}findMatchesLineByLine(n,a,c,h){const i=[];let s=0;const u=new R.$TB(a.wordSeparators,a.regex);let d=this.H(n.startLineNumber,n.startColumn);if(d===null)return[];const m=this.H(n.endLineNumber,n.endColumn);if(m===null)return[];let f=this.s(d.node,d.remainder);const S=this.s(m.node,m.remainder);if(d.node===m.node)return this.findMatchesInNode(d.node,u,n.startLineNumber,n.startColumn,f,S,a,c,h,s,i),i;let L=n.startLineNumber,v=d.node;for(;v!==m.node;){const k=this.t(v.piece.bufferIndex,f,v.piece.end);if(k>=1){const O=this.a[v.piece.bufferIndex].lineStarts,K=this.u(v.piece.bufferIndex,v.piece.start),j=O[f.line+k],W=L===n.startLineNumber?n.startColumn:1;if(s=this.findMatchesInNode(v,u,L,W,f,this.s(v,j-K),a,c,h,s,i),s>=h)return i;L+=k}const N=L===n.startLineNumber?n.startColumn-1:0;if(L===n.endLineNumber){const O=this.getLineContent(L).substring(N,n.endColumn-1);return s=this.n(a,u,O,n.endLineNumber,N,s,i,c,h),i}if(s=this.n(a,u,this.getLineContent(L).substr(N),L,N,s,i,c,h),s>=h)return i;L++,d=this.H(L,1),v=d.node,f=this.s(d.node,d.remainder)}if(L===n.endLineNumber){const k=L===n.startLineNumber?n.startColumn-1:0,N=this.getLineContent(L).substring(k,n.endColumn-1);return s=this.n(a,u,N,n.endLineNumber,k,s,i,c,h),i}const y=L===n.startLineNumber?n.startColumn:1;return s=this.findMatchesInNode(m.node,u,L,y,f,S,a,c,h,s,i),i}n(n,a,c,h,i,s,u,d,m){const f=n.wordSeparators;if(!d&&n.simpleSearch){const L=n.simpleSearch,v=L.length,y=c.length;let k=-v;for(;(k=c.indexOf(L,k+v))!==-1;)if((!f||(0,R.$SB)(f,c,y,k,v))&&(u[s++]=new I.$1u(new T.$Is(h,k+1+i,h,k+1+v+i),null),s>=m))return s;return s}let S;a.reset(0);do if(S=a.next(c),S&&(u[s++]=(0,R.$QB)(new T.$Is(h,S.index+1+i,h,S.index+1+S[0].length+i),S,d),s>=m))return s;while(S);return s}insert(n,a,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==F.$FB){const{node:h,remainder:i,nodeStartOffset:s}=this.G(n),u=h.piece,d=u.bufferIndex,m=this.s(h,i);if(h.piece.bufferIndex===0&&u.end.line===this.g.line&&u.end.column===this.g.column&&s+u.length===n&&a.length<$){this.F(h,a),this.y();return}if(s===n)this.o(a,h),this.h.validate(n);else if(s+h.piece.length>n){const f=[];let S=new l(u.bufferIndex,m,u.end,this.t(u.bufferIndex,m,u.end),this.u(d,u.end)-this.u(d,m));if(this.K()&&this.M(a)&&this.I(h,i)===10){const k={line:S.start.line+1,column:0};S=new l(S.bufferIndex,k,S.end,this.t(S.bufferIndex,k,S.end),S.length-1),a+=`
`}if(this.K()&&this.L(a))if(this.I(h,i-1)===13){const k=this.s(h,i-1);this.C(h,k),a="\r"+a,h.piece.length===0&&f.push(h)}else this.C(h,m);else this.C(h,m);const L=this.w(a);S.length>0&&this.S(h,S);let v=h;for(let y=0;y<L.length;y++)v=this.S(v,L[y]);this.v(f)}else this.q(a,h)}else{const h=this.w(a);let i=this.T(null,h[0]);for(let s=1;s<h.length;s++)i=this.S(i,h[s])}this.y()}delete(n,a){if(this.j.lineNumber=0,this.j.value="",a<=0||this.root===F.$FB)return;const c=this.G(n),h=this.G(n+a),i=c.node,s=h.node;if(i===s){const L=this.s(i,c.remainder),v=this.s(i,h.remainder);if(c.nodeStartOffset===n){if(a===i.piece.length){const y=i.next();(0,F.$KB)(this,i),this.N(y),this.y();return}this.D(i,v),this.h.validate(n),this.N(i),this.y();return}if(c.nodeStartOffset+i.piece.length===n+a){this.C(i,L),this.O(i),this.y();return}this.E(i,L,v),this.y();return}const u=[],d=this.s(i,c.remainder);this.C(i,d),this.h.validate(n),i.piece.length===0&&u.push(i);const m=this.s(s,h.remainder);this.D(s,m),s.piece.length===0&&u.push(s);const f=i.next();for(let L=f;L!==F.$FB&&L!==s;L=L.next())u.push(L);const S=i.piece.length===0?i.prev():i;this.v(u),this.O(S),this.y()}o(n,a){const c=[];if(this.K()&&this.M(n)&&this.L(a)){const s=a.piece,u={line:s.start.line+1,column:0},d=new l(s.bufferIndex,u,s.end,this.t(s.bufferIndex,u,s.end),s.length-1);a.piece=d,n+=`
`,(0,F.$MB)(this,a,-1,-1),a.piece.length===0&&c.push(a)}const h=this.w(n);let i=this.T(a,h[h.length-1]);for(let s=h.length-2;s>=0;s--)i=this.T(i,h[s]);this.N(i),this.v(c)}q(n,a){this.Q(n,a)&&(n+=`
`);const c=this.w(n),h=this.S(a,c[0]);let i=h;for(let s=1;s<c.length;s++)i=this.S(i,c[s]);this.N(h)}s(n,a,c){const h=n.piece,i=n.piece.bufferIndex,s=this.a[i].lineStarts,d=s[h.start.line]+h.start.column+a;let m=h.start.line,f=h.end.line,S=0,L=0,v=0;for(;m<=f&&(S=m+(f-m)/2|0,v=s[S],S!==f);)if(L=s[S+1],d<v)f=S-1;else if(d>=L)m=S+1;else break;return c?(c.line=S,c.column=d-v,null):{line:S,column:d-v}}t(n,a,c){if(c.column===0)return c.line-a.line;const h=this.a[n].lineStarts;if(c.line===h.length-1)return c.line-a.line;const i=h[c.line+1],s=h[c.line]+c.column;if(i>s+1)return c.line-a.line;const u=s-1;return this.a[n].buffer.charCodeAt(u)===13?c.line-a.line+1:c.line-a.line}u(n,a){return this.a[n].lineStarts[a.line]+a.column}v(n){for(let a=0;a<n.length;a++)(0,F.$KB)(this,n[a])}w(n){if(n.length>$){const f=[];for(;n.length>$;){const L=n.charCodeAt($-1);let v;L===13||L>=55296&&L<=56319?(v=n.substring(0,$-1),n=n.substring($-1)):(v=n.substring(0,$),n=n.substring($));const y=A(v);f.push(new l(this.a.length,{line:0,column:0},{line:y.length-1,column:v.length-y[y.length-1]},y.length-1,v.length)),this.a.push(new p(v,y))}const S=A(n);return f.push(new l(this.a.length,{line:0,column:0},{line:S.length-1,column:n.length-S[S.length-1]},S.length-1,n.length)),this.a.push(new p(n,S)),f}let a=this.a[0].buffer.length;const c=A(n,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===a&&a!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let f=0;f<c.length;f++)c[f]+=a+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+n,a+=1}else{if(a!==0)for(let f=0;f<c.length;f++)c[f]+=a;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=n}const i=this.a[0].buffer.length,s=this.a[0].lineStarts.length-1,u=i-this.a[0].lineStarts[s],d={line:s,column:u},m=new l(0,h,d,this.t(0,h,d),i-a);return this.g=d,[m]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,a=0){let c=this.root,h="";const i=this.h.get2(n);if(i){c=i.node;const s=this.B(c,n-i.nodeStartLineNumber-1),u=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(i.nodeStartLineNumber+c.piece.lineFeedCnt===n)h=u.substring(d+s,d+c.piece.length);else{const m=this.B(c,n-i.nodeStartLineNumber);return u.substring(d+s,d+m-a)}}else{let s=0;const u=n;for(;c!==F.$FB;)if(c.left!==F.$FB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const d=this.B(c,n-c.lf_left-2),m=this.B(c,n-c.lf_left-1),f=this.a[c.piece.bufferIndex].buffer,S=this.u(c.piece.bufferIndex,c.piece.start);return s+=c.size_left,this.h.set({node:c,nodeStartOffset:s,nodeStartLineNumber:u-(n-1-c.lf_left)}),f.substring(S+d,S+m-a)}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const d=this.B(c,n-c.lf_left-2),m=this.a[c.piece.bufferIndex].buffer,f=this.u(c.piece.bufferIndex,c.piece.start);h=m.substring(f+d,f+c.piece.length);break}else n-=c.lf_left+c.piece.lineFeedCnt,s+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==F.$FB;){const s=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const u=this.B(c,0),d=this.u(c.piece.bufferIndex,c.piece.start);return h+=s.substring(d,d+u-a),h}else{const u=this.u(c.piece.bufferIndex,c.piece.start);h+=s.substr(u,c.piece.length)}c=c.next()}return h}y(){let n=this.root,a=1,c=0;for(;n!==F.$FB;)a+=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;this.b=a,this.c=c,this.h.validate(this.c)}A(n,a){const c=n.piece,h=this.s(n,a),i=h.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===a){const s=this.t(n.piece.bufferIndex,c.start,h);if(s!==i)return{index:s,remainder:0}}return{index:i,remainder:h.column}}B(n,a){if(a<0)return 0;const c=n.piece,h=this.a[c.bufferIndex].lineStarts,i=c.start.line+a+1;return i>c.end.line?h[c.end.line]+c.end.column-h[c.start.line]-c.start.column:h[i]-h[c.start.line]-c.start.column}C(n,a){const c=n.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.end),s=a,u=this.u(c.bufferIndex,s),d=this.t(c.bufferIndex,c.start,s),m=d-h,f=u-i,S=c.length+f;n.piece=new l(c.bufferIndex,c.start,s,d,S),(0,F.$MB)(this,n,f,m)}D(n,a){const c=n.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.start),s=a,u=this.t(c.bufferIndex,s,c.end),d=this.u(c.bufferIndex,s),m=u-h,f=i-d,S=c.length+f;n.piece=new l(c.bufferIndex,s,c.end,u,S),(0,F.$MB)(this,n,f,m)}E(n,a,c){const h=n.piece,i=h.start,s=h.end,u=h.length,d=h.lineFeedCnt,m=a,f=this.t(h.bufferIndex,h.start,m),S=this.u(h.bufferIndex,a)-this.u(h.bufferIndex,i);n.piece=new l(h.bufferIndex,h.start,m,f,S),(0,F.$MB)(this,n,S-u,f-d);const L=new l(h.bufferIndex,c,s,this.t(h.bufferIndex,c,s),this.u(h.bufferIndex,s)-this.u(h.bufferIndex,c)),v=this.S(n,L);this.N(v)}F(n,a){this.Q(a,n)&&(a+=`
`);const c=this.K()&&this.L(a)&&this.M(n),h=this.a[0].buffer.length;this.a[0].buffer+=a;const i=A(a,!1);for(let v=0;v<i.length;v++)i[v]+=h;if(c){const v=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-v}}this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1));const s=this.a[0].lineStarts.length-1,u=this.a[0].buffer.length-this.a[0].lineStarts[s],d={line:s,column:u},m=n.piece.length+a.length,f=n.piece.lineFeedCnt,S=this.t(0,n.piece.start,d),L=S-f;n.piece=new l(n.piece.bufferIndex,n.piece.start,d,S,m),this.g=d,(0,F.$MB)(this,n,a.length,L)}G(n){let a=this.root;const c=this.h.get(n);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:n-c.nodeStartOffset};let h=0;for(;a!==F.$FB;)if(a.size_left>n)a=a.left;else if(a.size_left+a.piece.length>=n){h+=a.size_left;const i={node:a,remainder:n-a.size_left,nodeStartOffset:h};return this.h.set(i),i}else n-=a.size_left+a.piece.length,h+=a.size_left+a.piece.length,a=a.right;return null}H(n,a){let c=this.root,h=0;for(;c!==F.$FB;)if(c.left!==F.$FB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const i=this.B(c,n-c.lf_left-2),s=this.B(c,n-c.lf_left-1);return h+=c.size_left,{node:c,remainder:Math.min(i+a-1,s),nodeStartOffset:h}}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const i=this.B(c,n-c.lf_left-2);if(i+a-1<=c.piece.length)return{node:c,remainder:i+a-1,nodeStartOffset:h};a-=c.piece.length-i;break}else n-=c.lf_left+c.piece.lineFeedCnt,h+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==F.$FB;){if(c.piece.lineFeedCnt>0){const i=this.B(c,0),s=this.J(c);return{node:c,remainder:Math.min(a-1,i),nodeStartOffset:s}}else if(c.piece.length>=a-1){const i=this.J(c);return{node:c,remainder:a-1,nodeStartOffset:i}}else a-=c.piece.length;c=c.next()}return null}I(n,a){if(n.piece.lineFeedCnt<1)return-1;const c=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start)+a;return c.buffer.charCodeAt(h)}J(n){if(!n)return 0;let a=n.size_left;for(;n!==this.root;)n.parent.right===n&&(a+=n.parent.size_left+n.parent.piece.length),n=n.parent;return a}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===F.$FB||n.piece.lineFeedCnt===0)return!1;const a=n.piece,c=this.a[a.bufferIndex].lineStarts,h=a.start.line,i=c[h]+a.start.column;return h===c.length-1||c[h+1]>i+1?!1:this.a[a.bufferIndex].buffer.charCodeAt(i)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===F.$FB||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const a=n.prev();this.M(a)&&this.P(a,n)}}O(n){if(this.K()&&this.M(n)){const a=n.next();this.L(a)&&this.P(n,a)}}P(n,a){const c=[],h=this.a[n.piece.bufferIndex].lineStarts;let i;n.piece.end.column===0?i={line:n.piece.end.line-1,column:h[n.piece.end.line]-h[n.piece.end.line-1]-1}:i={line:n.piece.end.line,column:n.piece.end.column-1};const s=n.piece.length-1,u=n.piece.lineFeedCnt-1;n.piece=new l(n.piece.bufferIndex,n.piece.start,i,u,s),(0,F.$MB)(this,n,-1,-1),n.piece.length===0&&c.push(n);const d={line:a.piece.start.line+1,column:0},m=a.piece.length-1,f=this.t(a.piece.bufferIndex,d,a.piece.end);a.piece=new l(a.piece.bufferIndex,d,a.piece.end,f,m),(0,F.$MB)(this,a,-1,-1),a.piece.length===0&&c.push(a);const S=this.w(`\r
`);this.S(n,S[0]);for(let L=0;L<c.length;L++)(0,F.$KB)(this,c[L])}Q(n,a){if(this.K()&&this.M(n)){const c=a.next();if(this.L(c)){if(n+=`
`,c.piece.length===1)(0,F.$KB)(this,c);else{const h=c.piece,i={line:h.start.line+1,column:0},s=h.length-1,u=this.t(h.bufferIndex,i,h.end);c.piece=new l(h.bufferIndex,i,h.end,u,s),(0,F.$MB)(this,c,-1,-1)}return!0}}return!1}iterate(n,a){if(n===F.$FB)return a(F.$FB);const c=this.iterate(n.left,a);return c&&a(n)&&this.iterate(n.right,a)}R(n){if(n===F.$FB)return"";const a=this.a[n.piece.bufferIndex],c=n.piece,h=this.u(c.bufferIndex,c.start),i=this.u(c.bufferIndex,c.end);return a.buffer.substring(h,i)}getPieceContent(n){const a=this.a[n.bufferIndex],c=this.u(n.bufferIndex,n.start),h=this.u(n.bufferIndex,n.end);return a.buffer.substring(c,h)}S(n,a){const c=new F.$EB(a,1);if(c.left=F.$FB,c.right=F.$FB,c.parent=F.$FB,c.size_left=0,c.lf_left=0,this.root===F.$FB)this.root=c,c.color=0;else if(n.right===F.$FB)n.right=c,c.parent=n;else{const i=(0,F.$GB)(n.right);i.left=c,c.parent=i}return(0,F.$LB)(this,c),c}T(n,a){const c=new F.$EB(a,1);if(c.left=F.$FB,c.right=F.$FB,c.parent=F.$FB,c.size_left=0,c.lf_left=0,this.root===F.$FB)this.root=c,c.color=0;else if(n.left===F.$FB)n.left=c,c.parent=n;else{const h=(0,F.$HB)(n.left);h.right=c,c.parent=h}return(0,F.$LB)(this,c),c}U(n){let a="";return this.iterate(n,c=>(a+=this.R(c),!0)),a}}e.$YB=o}),define(Ce[132],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b8=e.$a8=void 0;class E{constructor(){this.a=new Map}removeDragOperationTransfer(F){if(F&&this.a.has(F)){const R=this.a.get(F);return this.a.delete(F),R}}addDragOperationTransfer(F,R){this.a.set(F,R)}}e.$a8=E;class T{constructor(F){this.identifier=F}}e.$b8=T}),define(Ce[133],Re([9,10]),function(ge,e){return ge.create("vs/base/common/actions",e)}),define(Ce[134],Re([1,0,5,6,133]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=void 0;class F extends T.$Sc{constructor(l,p="",b="",r=!0,o){super(),this.h=this.B(new E.$Sd),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=p,this.u=b,this.w=r,this.C=o}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,p){this.C&&await this.C(l)}}e.$Hi=F;class R extends T.$Sc{constructor(){super(...arguments),this.f=this.B(new E.$Sd),this.onWillRun=this.f.event,this.m=this.B(new E.$Sd),this.onDidRun=this.m.event}async run(l,p){if(!l.enabled)return;this.f.fire({action:l});let b;try{await this.u(l,p)}catch(r){b=r}this.m.fire({action:l,error:b})}async u(l,p){await l.run(p)}}e.$Ii=R;class ${constructor(){this.id=$.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let p=[];for(const b of l)b.length&&(p.length?p=[...p,new $,...b]:p=b);return p}static{this.ID="vs.actions.separator"}async run(){}}e.$Ji=$;class g{get actions(){return this.a}constructor(l,p,b,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=p,this.class=r,this.a=b}async run(){}}e.$Ki=g;class w extends F{static{this.ID="vs.actions.empty"}constructor(){super(w.ID,I.localize(0,null),void 0,!1)}}e.$Li=w;function A(D){return{id:D.id,label:D.label,class:D.class,enabled:D.enabled??!0,checked:D.checked??!1,run:async(...l)=>D.run(...l),tooltip:D.label}}e.$Mi=A}),define(Ce[135],Re([9,10]),function(ge,e){return ge.create("vs/base/common/date",e)}),define(Ce[136],Re([1,0,135]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=e.$sm=void 0;const T=60,I=T*60,F=I*24,R=F*7,$=F*30,g=F*365;function w(D,l,p,b){typeof D!="number"&&(D=D.getTime());const r=Math.round((new Date().getTime()-D)/1e3);if(r<-30)return(0,E.localize)(0,null,w(new Date().getTime()+r*1e3,!1));if(!b&&r<30)return(0,E.localize)(1,null);let o;return r<T?(o=r,l?o===1?p?(0,E.localize)(2,null,o):(0,E.localize)(3,null,o):p?(0,E.localize)(4,null,o):(0,E.localize)(5,null,o):o===1?p?(0,E.localize)(6,null,o):(0,E.localize)(7,null,o):p?(0,E.localize)(8,null,o):(0,E.localize)(9,null,o)):r<I?(o=Math.floor(r/T),l?o===1?p?(0,E.localize)(10,null,o):(0,E.localize)(11,null,o):p?(0,E.localize)(12,null,o):(0,E.localize)(13,null,o):o===1?p?(0,E.localize)(14,null,o):(0,E.localize)(15,null,o):p?(0,E.localize)(16,null,o):(0,E.localize)(17,null,o)):r<F?(o=Math.floor(r/I),l?o===1?p?(0,E.localize)(18,null,o):(0,E.localize)(19,null,o):p?(0,E.localize)(20,null,o):(0,E.localize)(21,null,o):o===1?p?(0,E.localize)(22,null,o):(0,E.localize)(23,null,o):p?(0,E.localize)(24,null,o):(0,E.localize)(25,null,o)):r<R?(o=Math.floor(r/F),l?o===1?(0,E.localize)(26,null,o):(0,E.localize)(27,null,o):o===1?(0,E.localize)(28,null,o):(0,E.localize)(29,null,o)):r<$?(o=Math.floor(r/R),l?o===1?p?(0,E.localize)(30,null,o):(0,E.localize)(31,null,o):p?(0,E.localize)(32,null,o):(0,E.localize)(33,null,o):o===1?p?(0,E.localize)(34,null,o):(0,E.localize)(35,null,o):p?(0,E.localize)(36,null,o):(0,E.localize)(37,null,o)):r<g?(o=Math.floor(r/$),l?o===1?p?(0,E.localize)(38,null,o):(0,E.localize)(39,null,o):p?(0,E.localize)(40,null,o):(0,E.localize)(41,null,o):o===1?p?(0,E.localize)(42,null,o):(0,E.localize)(43,null,o):p?(0,E.localize)(44,null,o):(0,E.localize)(45,null,o)):(o=Math.floor(r/g),l?o===1?p?(0,E.localize)(46,null,o):(0,E.localize)(47,null,o):p?(0,E.localize)(48,null,o):(0,E.localize)(49,null,o):o===1?p?(0,E.localize)(50,null,o):(0,E.localize)(51,null,o):p?(0,E.localize)(52,null,o):(0,E.localize)(53,null,o))}e.$sm=w;function A(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$tm=A}),define(Ce[137],Re([9,10]),function(ge,e){return ge.create("vs/base/common/errorMessage",e)}),define(Ce[40],Re([1,0,18,16,137]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.$Oi=e.$Ni=void 0;function F(D,l){return l&&(D.stack||D.stacktrace)?I.localize(0,null,$(D),R(D.stack)||R(D.stacktrace)):$(D)}function R(D){return Array.isArray(D)?D.join(`
`):D}function $(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?I.localize(1,null,D.message):D.message||I.localize(2,null)}function g(D=null,l=!1){if(!D)return I.localize(3,null);if(Array.isArray(D)){const p=E.$Hb(D),b=g(p[0],l);return p.length>1?I.localize(4,null,b,p.length):b}if(T.$Ff(D))return D;if(D.detail){const p=D.detail;if(p.error)return F(p.error,l);if(p.exception)return F(p.exception,l)}return D.stack?F(D,l):D.message?D.message:I.localize(5,null)}e.$Ni=g;function w(D){const l=D;return l instanceof Error&&Array.isArray(l.actions)}e.$Oi=w;function A(D,l){let p;return typeof D=="string"?p=new Error(D):p=D,p.actions=l,p}e.$Pi=A}),define(Ce[138],Re([1,0,39,19]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=e.$Hq=e.$Gq=e.$Fq=e.$Eq=e.$Dq=e.$Cq=e.$Bq=e.$Aq=e.$zq=e.$yq=e.$xq=e.$wq=void 0;const I=new E.$V(()=>{const L=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:L,collatorIsNumeric:L.resolvedOptions().numeric}}),F=new E.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new E.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function $(L,v,y=!1){const k=L||"",N=v||"",O=I.value.collator.compare(k,N);return I.value.collatorIsNumeric&&O===0&&k!==N?k<N?-1:1:O}e.$wq=$;function g(L,v){const y=F.value.collator;return L=L||"",v=v||"",c(y,L,v)}e.$xq=g;function w(L,v){const y=F.value.collator;return L=L||"",v=v||"",u(L,v)||c(y,L,v)}e.$yq=w;function A(L,v){const y=F.value.collator;return L=L||"",v=v||"",s(L,v)||c(y,L,v)}e.$zq=A;function D(L,v){return L=L||"",v=v||"",L===v?0:L<v?-1:1}e.$Aq=D;function l(L,v){const[y,k]=n(L),[N,O]=n(v);let K=I.value.collator.compare(k,O);if(K===0){if(I.value.collatorIsNumeric&&k!==O)return k<O?-1:1;if(K=I.value.collator.compare(y,N),I.value.collatorIsNumeric&&K===0&&y!==N)return y<N?-1:1}return K}e.$Bq=l;function p(L,v){L=L||"",v=v||"";const y=a(L),k=a(v),N=F.value.collator,O=R.value.collator;return c(O,y,k)||c(N,L,v)}e.$Cq=p;function b(L,v){L=L||"",v=v||"";const y=a(L),k=a(v),N=F.value.collator,O=R.value.collator;return c(O,y,k)||u(L,v)||c(N,L,v)}e.$Dq=b;function r(L,v){L=L||"",v=v||"";const y=a(L),k=a(v),N=F.value.collator,O=R.value.collator;return c(O,y,k)||s(L,v)||c(N,L,v)}e.$Eq=r;function o(L,v){L=L||"",v=v||"";const y=a(L).toLowerCase(),k=a(v).toLowerCase();return y!==k?y<k?-1:1:L!==v?L<v?-1:1:0}e.$Fq=o;const t=/^(.*?)(\.([^.]*))?$/;function n(L,v=!1){const y=L?t.exec(L):[];let k=[y&&y[1]||"",y&&y[3]||""];return v&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function a(L){const v=L?t.exec(L):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function c(L,v,y){const k=L.compare(v,y);return k!==0?k:v.length!==y.length?v.length<y.length?-1:1:0}function h(L){const v=L.charAt(0);return v.toLocaleUpperCase()!==v}function i(L){const v=L.charAt(0);return v.toLocaleLowerCase()!==v}function s(L,v){return h(L)&&i(v)?-1:i(L)&&h(v)?1:0}function u(L,v){return i(L)&&h(v)?-1:h(L)&&i(v)?1:0}function d(L,v,y=!1){return y||(L=L&&L.toLowerCase(),v=v&&v.toLowerCase()),L===v?0:L<v?-1:1}function m(L,v,y=!1){const k=L.split(T.sep),N=v.split(T.sep),O=k.length-1,K=N.length-1;let j,W;for(let P=0;;P++){if(j=O===P,W=K===P,j&&W)return $(k[P],N[P],y);if(j)return-1;if(W)return 1;const C=d(k[P],N[P],y);if(C!==0)return C}}e.$Gq=m;function f(L,v,y){const k=L.toLowerCase(),N=v.toLowerCase(),O=S(L,v,y);if(O)return O;const K=k.endsWith(y),j=N.endsWith(y);if(K!==j)return K?-1:1;const W=$(k,N);return W!==0?W:k.localeCompare(N)}e.$Hq=f;function S(L,v,y){const k=L.toLowerCase(),N=v.toLowerCase(),O=k.startsWith(y),K=N.startsWith(y);if(O!==K)return O?-1:1;if(O&&K){if(k.length<N.length)return-1;if(k.length>N.length)return 1}return 0}e.$Iq=S}),define(Ce[46],Re([1,0,19,21,11,16]),function(ge,e,E,T,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=void 0;function R(f){return f===47||f===92}e.$Xf=R;function $(f){return f.replace(/[\\/]/g,E.$gc.sep)}e.$Yf=$;function g(f){return f.indexOf("/")===-1&&(f=$(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}e.$Zf=g;function w(f,S=E.$gc.sep){if(!f)return"";const L=f.length,v=f.charCodeAt(0);if(R(v)){if(R(f.charCodeAt(1))&&!R(f.charCodeAt(2))){let k=3;const N=k;for(;k<L&&!R(f.charCodeAt(k));k++);if(N!==k&&!R(f.charCodeAt(k+1))){for(k+=1;k<L;k++)if(R(f.charCodeAt(k)))return f.slice(0,k+1).replace(/[\\/]/g,S)}}return S}else if(t(v)&&f.charCodeAt(1)===58)return R(f.charCodeAt(2))?f.slice(0,2)+S:f.slice(0,2);let y=f.indexOf("://");if(y!==-1){for(y+=3;y<L;y++)if(R(f.charCodeAt(y)))return f.slice(0,y+1)}return""}e.$1f=w;function A(f){if(!T.$i||!f||f.length<5)return!1;let S=f.charCodeAt(0);if(S!==92||(S=f.charCodeAt(1),S!==92))return!1;let L=2;const v=L;for(;L<f.length&&(S=f.charCodeAt(L),S!==92);L++);return!(v===L||(S=f.charCodeAt(L+1),isNaN(S)||S===92))}e.$2f=A;const D=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function b(f,S=T.$i){const L=S?D:l;return!(!f||f.length===0||/^\s+$/.test(f)||(L.lastIndex=0,L.test(f))||S&&p.test(f)||f==="."||f===".."||S&&f[f.length-1]==="."||S&&f.length!==f.trim().length||f.length>255)}e.$3f=b;function r(f,S,L){const v=f===S;return!L||v?v:!f||!S?!1:(0,I.$9e)(f,S)}e.$4f=r;function o(f,S,L,v=E.sep){if(f===S)return!0;if(!f||!S||S.length>f.length)return!1;if(L){if(!(0,I.$0e)(f,S))return!1;if(S.length===f.length)return!0;let k=S.length;return S.charAt(S.length-1)===v&&k--,f.charAt(k)===v}return S.charAt(S.length-1)!==v&&(S+=v),f.indexOf(S)===0}e.$5f=o;function t(f){return f>=65&&f<=90||f>=97&&f<=122}e.$6f=t;function n(f,S){return T.$i&&f.endsWith(":")&&(f+=E.sep),(0,E.$ic)(f)||(f=(0,E.$jc)(S,f)),f=(0,E.$hc)(f),T.$i?(f=(0,I.$Re)(f,E.sep),f.endsWith(":")&&(f+=E.sep)):(f=(0,I.$Re)(f,E.sep),f||(f=E.sep)),f}e.$7f=n;function a(f){const S=(0,E.$hc)(f);return T.$i?f.length>3?!1:c(S)&&(f.length===2||S.charCodeAt(2)===92):S===E.$gc.sep}e.$8f=a;function c(f,S=T.$i){return S?t(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}e.$9f=c;function h(f,S=T.$i){return c(f,S)?f[0]:void 0}e.$0f=h;function i(f,S,L){return S.length>f.length?-1:f===S?0:(L&&(f=f.toLowerCase(),S=S.toLowerCase()),f.indexOf(S))}e.$$f=i;function s(f){const S=f.split(":");let L,v,y;for(const k of S){const N=Number(k);(0,F.$Jf)(N)?v===void 0?v=N:y===void 0&&(y=N):L=L?[L,k].join(":"):k}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:v!==void 0?v:void 0,column:y!==void 0?y:v!==void 0?1:void 0}}e.$_f=s;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",d="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function m(f,S,L=8){let v="";for(let k=0;k<L;k++){let N;k===0&&T.$i&&!S&&(L===3||L===4)?N=d:N=u,v+=N.charAt(Math.floor(Math.random()*N.length))}let y;return S?y=`${S}-${v}`:y=v,f?(0,E.$jc)(f,y):y}e.$ag=m}),define(Ce[68],Re([1,0,19]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=e.$8r=e.$7r=e.$6r=e.$5r=void 0,e.$5r=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function F(A){const D=(0,E.$oc)(A),l=T[D.toLowerCase()];return l!==void 0?l:R(A)}e.$6r=F;function R(A){const D=(0,E.$oc)(A);return I[D.toLowerCase()]}e.$7r=R;function $(A){for(const D in I)if(I[D]===A)return D}e.$8r=$;const g=/^(.+)\/(.+?)(;.+)?$/;function w(A,D){const l=g.exec(A);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:D?void 0:A}e.$9r=w}),define(Ce[51],Re([1,0,24,2]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.$yh=e.$xh=void 0;function I(g){return JSON.stringify(g,R)}e.$xh=I;function F(g){let w=JSON.parse(g);return w=$(w),w}e.$yh=F;function R(g,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:w.flags}:w}function $(g,w=0){if(!g||w>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return T.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 17:return new Date(g.source)}if(g instanceof E.$ge||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let A=0;A<g.length;++A)g[A]=$(g[A],w+1);else for(const A in g)Object.hasOwnProperty.call(g,A)&&(g[A]=$(g[A],w+1))}return g}e.$zh=$}),define(Ce[12],Re([1,0,15,21,11,2]),function(ge,e,E,T,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.Schemas=void 0;var R;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={}));function $(l,p){return F.URI.isUri(l)?(0,I.$9e)(l.scheme,p):(0,I.$0e)(l,p+":")}e.$bg=$;function g(l,...p){return p.some(b=>$(l,b))}e.$cg=g,e.$dg="vscode-tkn",e.$eg="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p){this.f=`${p}/${R.vscodeRemoteResource}`}set(p,b,r){this.a[p]=b,this.b[p]=r}setConnectionToken(p,b){this.c[p]=b}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch(a){return E.$1(a),p}const b=p.authority;let r=this.a[b];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const o=this.b[b],t=this.c[b];let n=`path=${encodeURIComponent(p.path)}`;return typeof t=="string"&&(n+=`&${e.$eg}=${encodeURIComponent(t)}`),F.URI.from({scheme:T.$o?this.d:R.vscodeRemoteResource,authority:`${r}:${o}`,path:this.f,query:n})}}e.$fg=new w,e.$gg="vs/../../extensions",e.$hg="vs/../../node_modules",e.$ig="vs/../../node_modules.asar",e.$jg="vs/../../node_modules.asar.unpacked",e.$kg="vscode-app";class A{static{this.a=e.$kg}asBrowserUri(p){const b=this.b(p,ge);return this.uriToBrowserUri(b)}uriToBrowserUri(p){return p.scheme===R.vscodeRemote?e.$fg.rewrite(p):p.scheme===R.file&&(T.$m||T.$q===`${R.vscodeFileResource}://${A.a}`)?p.with({scheme:R.vscodeFileResource,authority:p.authority||A.a,query:null,fragment:null}):p}asFileUri(p){const b=this.b(p,ge);return this.uriToFileUri(b)}uriToFileUri(p){return p.scheme===R.vscodeFileResource?p.with({scheme:R.file,authority:p.authority!==A.a?p.authority:null,query:null,fragment:null}):p}b(p,b){return F.URI.isUri(p)?p:F.URI.parse(b.toUrl(p))}}e.$lg=new A;var D;(function(l){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(p.get("3"));const b="vscode-coi";function r(t){let n;typeof t=="string"?n=new URL(t).searchParams:t instanceof URL?n=t.searchParams:F.URI.isUri(t)&&(n=new URL(t.toString(!0)).searchParams);const a=n?.get(b);if(a)return p.get(a)}l.getHeadersFromQuery=r;function o(t,n,a){if(!globalThis.crossOriginIsolated)return;const c=n&&a?"3":a?"2":"1";t instanceof URLSearchParams?t.set(b,c):t[b]=c}l.addSearchParam=o})(D||(e.COI=D={}))}),define(Ce[25],Re([1,0,46,12,19,21,11,2]),function(ge,e,E,T,I,F,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Og=e.DataUri=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=void 0;function g(p){return(0,$.$wc)(p,!0)}e.$sg=g;class w{constructor(b){this.a=b}compare(b,r,o=!1){return b===r?0:(0,R.$2e)(this.getComparisonKey(b,o),this.getComparisonKey(r,o))}isEqual(b,r,o=!1){return b===r?!0:!b||!r?!1:this.getComparisonKey(b,o)===this.getComparisonKey(r,o)}getComparisonKey(b,r=!1){return b.with({path:this.a(b)?b.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(b){return this.a(b)}isEqualOrParent(b,r,o=!1){if(b.scheme===r.scheme){if(b.scheme===T.Schemas.file)return E.$5f(g(b),g(r),this.a(b))&&b.query===r.query&&(o||b.fragment===r.fragment);if((0,e.$Jg)(b.authority,r.authority))return E.$5f(b.path,r.path,this.a(b),"/")&&b.query===r.query&&(o||b.fragment===r.fragment)}return!1}joinPath(b,...r){return $.URI.joinPath(b,...r)}basenameOrAuthority(b){return(0,e.$Bg)(b)||b.authority}basename(b){return I.$gc.basename(b.path)}extname(b){return I.$gc.extname(b.path)}dirname(b){if(b.path.length===0)return b;let r;return b.scheme===T.Schemas.file?r=$.URI.file(I.$mc(g(b))).path:(r=I.$gc.dirname(b.path),b.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${b.toString})) resulted in a relative path`),r="/")),b.with({path:r})}normalizePath(b){if(!b.path.length)return b;let r;return b.scheme===T.Schemas.file?r=$.URI.file(I.$hc(g(b))).path:r=I.$gc.normalize(b.path),b.with({path:r})}relativePath(b,r){if(b.scheme!==r.scheme||!(0,e.$Jg)(b.authority,r.authority))return;if(b.scheme===T.Schemas.file){const n=I.$lc(g(b),g(r));return F.$i?E.$Yf(n):n}let o=b.path||"/";const t=r.path||"/";if(this.a(b)){let n=0;for(const a=Math.min(o.length,t.length);n<a&&!(o.charCodeAt(n)!==t.charCodeAt(n)&&o.charAt(n).toLowerCase()!==t.charAt(n).toLowerCase());n++);o=t.substr(0,n)+o.substr(n)}return I.$gc.relative(o,t)}resolvePath(b,r){if(b.scheme===T.Schemas.file){const o=$.URI.file(I.$kc(g(b),r));return b.with({authority:o.authority,path:o.path})}return r=E.$Zf(r),b.with({path:I.$gc.resolve(b.path,r)})}isAbsolutePath(b){return!!b.path&&b.path[0]==="/"}isEqualAuthority(b,r){return b===r||b!==void 0&&r!==void 0&&(0,R.$9e)(b,r)}hasTrailingPathSeparator(b,r=I.sep){if(b.scheme===T.Schemas.file){const o=g(b);return o.length>E.$1f(o).length&&o[o.length-1]===r}else{const o=b.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(b.fsPath)}}removeTrailingPathSeparator(b,r=I.sep){return(0,e.$Kg)(b,r)?b.with({path:b.path.substr(0,b.path.length-1)}):b}addTrailingPathSeparator(b,r=I.sep){let o=!1;if(b.scheme===T.Schemas.file){const t=g(b);o=t!==void 0&&t.length===E.$1f(t).length&&t[t.length-1]===r}else{r="/";const t=b.path;o=t.length===1&&t.charCodeAt(t.length-1)===47}return!o&&!(0,e.$Kg)(b,r)?b.with({path:b.path+"/"}):b}}e.$tg=w,e.$ug=new w(()=>!1),e.$vg=new w(p=>p.scheme===T.Schemas.file?!F.$k:!0),e.$wg=new w(p=>!0),e.$xg=e.$ug.isEqual.bind(e.$ug),e.$yg=e.$ug.isEqualOrParent.bind(e.$ug),e.$zg=e.$ug.getComparisonKey.bind(e.$ug),e.$Ag=e.$ug.basenameOrAuthority.bind(e.$ug),e.$Bg=e.$ug.basename.bind(e.$ug),e.$Cg=e.$ug.extname.bind(e.$ug),e.$Dg=e.$ug.dirname.bind(e.$ug),e.$Eg=e.$ug.joinPath.bind(e.$ug),e.$Fg=e.$ug.normalizePath.bind(e.$ug),e.$Gg=e.$ug.relativePath.bind(e.$ug),e.$Hg=e.$ug.resolvePath.bind(e.$ug),e.$Ig=e.$ug.isAbsolutePath.bind(e.$ug),e.$Jg=e.$ug.isEqualAuthority.bind(e.$ug),e.$Kg=e.$ug.hasTrailingPathSeparator.bind(e.$ug),e.$Lg=e.$ug.removeTrailingPathSeparator.bind(e.$ug),e.$Mg=e.$ug.addTrailingPathSeparator.bind(e.$ug);function A(p,b){const r=[];for(let o=0;o<p.length;o++){const t=b(p[o]);p.some((n,a)=>a===o?!1:(0,e.$yg)(t,b(n)))||r.push(p[o])}return r}e.$Ng=A;var D;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function b(r){const o=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(a=>{const[c,h]=a.split(":");c&&h&&o.set(c,h)});const n=r.path.substring(0,r.path.indexOf(";"));return n&&o.set(p.META_DATA_MIME,n),o}p.parseMetaData=b})(D||(e.DataUri=D={}));function l(p,b,r){if(b){let o=p.path;return o&&o[0]!==I.$gc.sep&&(o=I.$gc.sep+o),p.with({scheme:r,authority:b,path:o})}return p.with({scheme:r})}e.$Og=l}),define(Ce[13],Re([1,0,20,15,5,6,25,21,125,39]),function(ge,e,E,T,I,F,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.Promises=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=void 0;function A(ce){return!!ce&&typeof ce.then=="function"}e.$Pg=A;function D(ce){const ie=new E.$3d,Q=ce(ie.token),te=new Promise((me,pe)=>{const Fe=ie.token.onCancellationRequested(()=>{Fe.dispose(),ie.dispose(),pe(new T.$5)});Promise.resolve(Q).then(le=>{Fe.dispose(),ie.dispose(),me(le)},le=>{Fe.dispose(),ie.dispose(),pe(le)})});return new class{cancel(){ie.cancel()}then(me,pe){return te.then(me,pe)}catch(me){return this.then(void 0,me)}finally(me){return te.finally(me)}}}e.$Qg=D;function l(ce,ie,Q){return new Promise((te,me)=>{const pe=ie.onCancellationRequested(()=>{pe.dispose(),te(Q)});ce.then(te,me).finally(()=>pe.dispose())})}e.$Rg=l;function p(ce,ie){return new Promise((Q,te)=>{const me=ie.onCancellationRequested(()=>{me.dispose(),te(new T.$5)});ce.then(Q,te).finally(()=>me.dispose())})}e.$Sg=p;async function b(ce){let ie=-1;const Q=ce.map((te,me)=>te.then(pe=>(ie=me,pe)));try{return await Promise.race(Q)}finally{ce.forEach((te,me)=>{me!==ie&&te.cancel()})}}e.$Tg=b;function r(ce,ie,Q){let te;const me=setTimeout(()=>{te?.(void 0),Q?.()},ie);return Promise.race([ce.finally(()=>clearTimeout(me)),new Promise(pe=>te=pe)])}e.$Ug=r;function o(ce){return new Promise((ie,Q)=>{const te=ce();A(te)?te.then(ie,Q):ie(te)})}e.$Vg=o;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(ie){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=ie,!this.b){const Q=()=>{if(this.b=null,this.f)return;const te=this.queue(this.d);return this.d=null,te};this.b=new Promise(te=>{this.a.then(Q,Q).then(te)})}return new Promise((Q,te)=>{this.b.then(Q,te)})}return this.a=ie(),new Promise((Q,te)=>{this.a.then(me=>{this.a=null,Q(me)},me=>{this.a=null,te(me)})})}dispose(){this.f=!0}}e.$Wg=t;class n{constructor(){this.a=Promise.resolve(null)}queue(ie){return this.a=this.a.then(()=>ie(),()=>ie())}}e.$Xg=n;class a{constructor(){this.a=new Map}queue(ie,Q){const me=(this.a.get(ie)??Promise.resolve()).catch(()=>{}).then(Q).finally(()=>{this.a.get(ie)===me&&this.a.delete(ie)});return this.a.set(ie,me),me}}e.$Yg=a;const c=(ce,ie)=>{let Q=!0;const te=setTimeout(()=>{Q=!1,ie()},ce);return{isTriggered:()=>Q,dispose:()=>{clearTimeout(te),Q=!1}}},h=ce=>{let ie=!0;return queueMicrotask(()=>{ie&&(ie=!1,ce())}),{isTriggered:()=>ie,dispose:()=>{ie=!1}}};class i{constructor(ie){this.defaultDelay=ie,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ie,Q=this.defaultDelay){this.g=ie,this.h(),this.b||(this.b=new Promise((me,pe)=>{this.d=me,this.f=pe}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const te=()=>{this.a=null,this.d?.(null)};return this.a=Q===g.$Pd?h(te):c(Q,te),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Zg=i;class s{constructor(ie){this.a=new i(ie),this.b=new t}trigger(ie,Q){return this.a.trigger(()=>this.b.queue(ie),Q)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$1g=s;class u{constructor(){this.a=!1,this.b=new Promise((ie,Q)=>{this.d=ie})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$2g=u;class d extends u{constructor(ie){super(),this.f=setTimeout(()=>this.open(),ie)}open(){clearTimeout(this.f),super.open()}}e.$3g=d;function m(ce,ie){return ie?new Promise((Q,te)=>{const me=setTimeout(()=>{pe.dispose(),Q()},ce),pe=ie.onCancellationRequested(()=>{clearTimeout(me),pe.dispose(),te(new T.$5)})}):D(Q=>m(ce,Q))}e.$4g=m;function f(ce,ie=0,Q){const te=setTimeout(()=>{ce(),Q&&me.dispose()},ie),me=(0,F.$Qc)(()=>{clearTimeout(te),Q?.deleteAndLeak(me)});return Q?.add(me),me}e.$5g=f;function S(ce){const ie=[];let Q=0;const te=ce.length;function me(){return Q<te?ce[Q++]():null}function pe(Fe){Fe!=null&&ie.push(Fe);const le=me();return le?le.then(pe):Promise.resolve(ie)}return Promise.resolve(null).then(pe)}e.$6g=S;function L(ce,ie=te=>!!te,Q=null){let te=0;const me=ce.length,pe=()=>{if(te>=me)return Promise.resolve(Q);const Fe=ce[te++];return Promise.resolve(Fe()).then(we=>ie(we)?Promise.resolve(we):pe())};return pe()}e.$7g=L;function v(ce,ie=te=>!!te,Q=null){if(ce.length===0)return Promise.resolve(Q);let te=ce.length;const me=()=>{te=-1;for(const pe of ce)pe.cancel?.()};return new Promise((pe,Fe)=>{for(const le of ce)le.then(we=>{--te>=0&&ie(we)?(me(),pe(we)):te===0&&pe(Q)}).catch(we=>{--te>=0&&(me(),Fe(we))})})}e.$8g=v;class y{constructor(ie){this.a=0,this.d=ie,this.f=[],this.b=0,this.g=new I.$Sd}get onDrained(){return this.g.event}get size(){return this.a}queue(ie){return this.a++,new Promise((Q,te)=>{this.f.push({factory:ie,c:Q,e:te}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const ie=this.f.shift();this.b++;const Q=ie.factory();Q.then(ie.c,ie.e),Q.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$9g=y;class k extends y{constructor(){super(1)}}e.$0g=k;class N{constructor(){this.a=new ye,this.b=0}queue(ie){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,ie())):this.a.run(this.b++,ie())}}e.$$g=N;class O{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const ie=new ee;return this.b.add(ie),ie.p}g(){for(const[,ie]of this.a)if(ie.size>0)return!1;return!0}queueFor(ie,Q=R.$ug){const te=Q.getComparisonKey(ie);let me=this.a.get(te);if(!me){me=new k;const pe=this.f++,Fe=I.Event.once(me.onDrained)(()=>{me?.dispose(),this.a.delete(te),this.h(),this.d?.deleteAndDispose(pe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new F.$2c),this.d.set(pe,Fe),this.a.set(te,me)}return me}h(){this.g()&&this.j()}j(){for(const ie of this.b)ie.complete();this.b.clear()}dispose(){for(const[,ie]of this.a)ie.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$_g=O;class K{constructor(ie,Q){this.a=-1,typeof ie=="function"&&typeof Q=="number"&&this.setIfNotSet(ie,Q)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ie,Q){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ie()},Q)}setIfNotSet(ie,Q){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ie()},Q))}}e.$ah=K;class j{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(ie,Q,te=globalThis){this.cancel();const me=te.setInterval(()=>{ie()},Q);this.d=(0,F.$Qc)(()=>{te.clearInterval(me),this.d=void 0})}dispose(){this.cancel()}}e.$bh=j;class W{constructor(ie,Q){this.b=-1,this.a=ie,this.d=Q,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ie=this.d){this.cancel(),this.b=setTimeout(this.f,ie)}get delay(){return this.d}set delay(ie){this.d=ie}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$ch=W;class P{constructor(ie,Q){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.a=ie,this.b=Q,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ie=this.b){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ie/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$dh=P;class C extends W{constructor(ie,Q){super(ie,Q),this.j=[]}work(ie){this.j.push(ie),this.isScheduled()||this.schedule()}h(){const ie=this.j;this.j=[],this.a?.(ie)}dispose(){this.j=[],super.dispose()}}e.$eh=C;class J extends F.$Sc{constructor(ie,Q){super(),this.g=ie,this.h=Q,this.a=[],this.b=this.B(new F.$Tc),this.f=!1}get pending(){return this.a.length}work(ie){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ie.length>this.g.maxBufferedWork)return!1}else if(this.pending+ie.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Q of ie)this.a.push(Q);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new W(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$fh=J,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$hh=(ce,ie)=>{(0,$.$B)(()=>{if(Q)return;const te=Date.now()+15;ie(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,te-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.$hh=(ce,ie,Q)=>{const te=ce.requestIdleCallback(ie,typeof Q=="number"?{timeout:Q}:void 0);let me=!1;return{dispose(){me||(me=!0,ce.cancelIdleCallback(te))}}},e.$gh=ce=>(0,e.$hh)(globalThis,ce)}();class ae{constructor(ie,Q){this.g=!1,this.d=()=>{try{this.j=Q()}catch(te){this.l=te}finally{this.g=!0}},this.f=(0,e.$hh)(ie,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$ih=ae;class fe extends ae{constructor(ie){super(globalThis,ie)}}e.$jh=fe;async function be(ce,ie,Q){let te;for(let me=0;me<Q;me++)try{return await ce()}catch(pe){te=pe,await m(ie)}throw te}e.$kh=be;class ye{isRunning(ie){return typeof ie=="number"?this.a?.taskId===ie:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(ie,Q,te){return this.a={taskId:ie,cancel:()=>te?.(),promise:Q},Q.then(()=>this.d(ie),()=>this.d(ie)),Q}d(ie){this.a&&ie===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ie=this.b;this.b=void 0,ie.run().then(ie.promiseResolve,ie.promiseReject)}}queue(ie){if(this.b)this.b.run=ie;else{let Q,te;const me=new Promise((pe,Fe)=>{Q=pe,te=Fe});this.b={run:ie,promise:me,promiseResolve:Q,promiseReject:te}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$lh=ye;class he{constructor(ie,Q=()=>Date.now()){this.d=ie,this.f=Q,this.a=0,this.b=0}increment(){const ie=this.f();return ie-this.a>this.d&&(this.a=ie,this.b=0),this.b++,this.b}}e.$mh=he;var ve;(function(ce){ce[ce.Resolved=0]="Resolved",ce[ce.Rejected=1]="Rejected"})(ve||(ve={}));class ee{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((ie,Q)=>{this.a=ie,this.b=Q})}complete(ie){return new Promise(Q=>{this.a(ie),this.d={outcome:0,value:ie},Q()})}error(ie){return new Promise(Q=>{this.b(ie),this.d={outcome:1,value:ie},Q()})}cancel(){return this.error(new T.$5)}}e.$nh=ee;var ke;(function(ce){async function ie(te){let me;const pe=await Promise.all(te.map(Fe=>Fe.then(le=>le,le=>{me||(me=le)})));if(typeof me<"u")throw me;return pe}ce.settled=ie;function Q(te){return new Promise(async(me,pe)=>{try{await te(me,pe)}catch(Fe){pe(Fe)}})}ce.withAsyncBody=Q})(ke||(e.Promises=ke={}));class se{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(ie){this.a=void 0,this.b=void 0,this.d=!1,this.promise=ie.then(Q=>(this.a=Q,this.d=!0,Q),Q=>{throw this.b=Q,this.d=!0,Q})}requireValue(){if(!this.d)throw new T.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$oh=se;class _{constructor(ie){this.b=ie,this.a=new w.$V(()=>new se(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$ph=_;var V;(function(ce){ce[ce.Initial=0]="Initial",ce[ce.DoneOK=1]="DoneOK",ce[ce.DoneError=2]="DoneError"})(V||(V={}));class ne{static fromArray(ie){return new ne(Q=>{Q.emitMany(ie)})}static fromPromise(ie){return new ne(async Q=>{Q.emitMany(await ie)})}static fromPromises(ie){return new ne(async Q=>{await Promise.all(ie.map(async te=>Q.emitOne(await te)))})}static merge(ie){return new ne(async Q=>{await Promise.all(ie.map(async te=>{for await(const me of te)Q.emitOne(me)}))})}static{this.EMPTY=ne.fromArray([])}constructor(ie){this.a=0,this.b=[],this.d=null,this.f=new I.$Sd,queueMicrotask(async()=>{const Q={emitOne:te=>this.g(te),emitMany:te=>this.h(te),reject:te=>this.k(te)};try{await Promise.resolve(ie(Q)),this.j()}catch(te){this.k(te)}finally{Q.emitOne=void 0,Q.emitMany=void 0,Q.reject=void 0}})}[Symbol.asyncIterator](){let ie=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ie<this.b.length)return{done:!1,value:this.b[ie++]};if(this.a===1)return{done:!0,value:void 0};await I.Event.toPromise(this.f.event)}while(!0)}}}static map(ie,Q){return new ne(async te=>{for await(const me of ie)te.emitOne(Q(me))})}map(ie){return ne.map(this,ie)}static filter(ie,Q){return new ne(async te=>{for await(const me of ie)Q(me)&&te.emitOne(me)})}filter(ie){return ne.filter(this,ie)}static coalesce(ie){return ne.filter(ie,Q=>!!Q)}coalesce(){return ne.coalesce(this)}static async toPromise(ie){const Q=[];for await(const te of ie)Q.push(te);return Q}toPromise(){return ne.toPromise(this)}g(ie){this.a===0&&(this.b.push(ie),this.f.fire())}h(ie){this.a===0&&(this.b=this.b.concat(ie),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ie){this.a===0&&(this.a=2,this.d=ie,this.f.fire())}}e.$qh=ne;class Ie extends ne{constructor(ie,Q){super(Q),this.l=ie}cancel(){this.l.cancel()}}e.$rh=Ie;function Ae(ce){const ie=new E.$3d,Q=ce(ie.token);return new Ie(ie,async te=>{const me=ie.token.onCancellationRequested(()=>{me.dispose(),ie.dispose(),te.reject(new T.$5)});try{for await(const pe of Q){if(ie.token.isCancellationRequested)return;te.emitOne(pe)}me.dispose(),ie.dispose()}catch(pe){me.dispose(),ie.dispose(),te.reject(pe)}})}e.$sh=Ae;class Pe{constructor(){this.a=new ee,this.b=new ne(te=>{if(ie){te.reject(ie);return}return Q&&te.emitMany(Q),this.d=me=>te.reject(me),this.f=me=>te.emitOne(me),this.a.p});let ie,Q;this.f=te=>{Q||(Q=[]),Q.push(te)},this.d=te=>{ie||(ie=te)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(ie){this.d(ie),this.a.complete()}emitOne(ie){this.f(ie)}}e.$th=Pe}),define(Ce[34],Re([1,0,18,13,46,28,19,21,11]),function(ge,e,E,T,I,F,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=void 0;function w(){return Object.create(null)}e.$Ej=w,e.$Fj="**",e.$Gj="/";const A="[/\\\\]",D="[^/\\\\]",l=/\//g;function p(fe,be){switch(fe){case 0:return"";case 1:return`${D}*?`;default:return`(?:${A}|${D}+${A}${be?`|${A}${D}+`:""})*?`}}function b(fe,be){if(!fe)return[];const ye=[];let he=!1,ve=!1,ee="";for(const ke of fe){switch(ke){case be:if(!he&&!ve){ye.push(ee),ee="";continue}break;case"{":he=!0;break;case"}":he=!1;break;case"[":ve=!0;break;case"]":ve=!1;break}ee+=ke}return ee&&ye.push(ee),ye}e.$Hj=b;function r(fe){if(!fe)return"";let be="";const ye=b(fe,e.$Gj);if(ye.every(he=>he===e.$Fj))be=".*";else{let he=!1;ye.forEach((ve,ee)=>{if(ve===e.$Fj){if(he)return;be+=p(2,ee===ye.length-1)}else{let ke=!1,se="",_=!1,V="";for(const ne of ve){if(ne!=="}"&&ke){se+=ne;continue}if(_&&(ne!=="]"||!V)){let Ie;ne==="-"?Ie=ne:(ne==="^"||ne==="!")&&!V?Ie="^":ne===e.$Gj?Ie="":Ie=(0,g.$Le)(ne),V+=Ie;continue}switch(ne){case"{":ke=!0;continue;case"[":_=!0;continue;case"}":{const Ae=`(?:${b(se,",").map(Pe=>r(Pe)).join("|")})`;be+=Ae,ke=!1,se="";break}case"]":{be+="["+V+"]",_=!1,V="";break}case"?":be+=D;continue;case"*":be+=p(1);continue;default:be+=(0,g.$Le)(ne)}}ee<ye.length-1&&(ye[ee+1]!==e.$Fj||ee+2<ye.length)&&(be+=A)}he=ve===e.$Fj})}return be}const o=/^\*\*\/\*\.[\w\.-]+$/,t=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,a=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new F.$Dc(1e4),s=function(){return!1},u=function(){return null};function d(fe,be){if(!fe)return u;let ye;typeof fe!="string"?ye=fe.pattern:ye=fe,ye=ye.trim();const he=`${ye}_${!!be.trimForExclusions}`;let ve=i.get(he);if(ve)return m(ve,fe);let ee;return o.test(ye)?ve=S(ye.substr(4),ye):(ee=t.exec(f(ye,be)))?ve=L(ee[1],ye):(be.trimForExclusions?a:n).test(ye)?ve=v(ye,be):(ee=c.exec(f(ye,be)))?ve=y(ee[1].substr(1),ye,!0):(ee=h.exec(f(ye,be)))?ve=y(ee[1],ye,!1):ve=k(ye),i.set(he,ve),m(ve,fe)}function m(fe,be){if(typeof be=="string")return fe;const ye=function(he,ve){return(0,I.$5f)(he,be.base,!$.$k)?fe((0,g.$Qe)(he.substr(be.base.length),R.sep),ve):null};return ye.allBasenames=fe.allBasenames,ye.allPaths=fe.allPaths,ye.basenames=fe.basenames,ye.patterns=fe.patterns,ye}function f(fe,be){return be.trimForExclusions&&fe.endsWith("/**")?fe.substr(0,fe.length-2):fe}function S(fe,be){return function(ye,he){return typeof ye=="string"&&ye.endsWith(fe)?be:null}}function L(fe,be){const ye=`/${fe}`,he=`\\${fe}`,ve=function(ke,se){return typeof ke!="string"?null:se?se===fe?be:null:ke===fe||ke.endsWith(ye)||ke.endsWith(he)?be:null},ee=[fe];return ve.basenames=ee,ve.patterns=[be],ve.allBasenames=ee,ve}function v(fe,be){const ye=J(fe.slice(1,-1).split(",").map(se=>d(se,be)).filter(se=>se!==u),fe),he=ye.length;if(!he)return u;if(he===1)return ye[0];const ve=function(se,_){for(let V=0,ne=ye.length;V<ne;V++)if(ye[V](se,_))return fe;return null},ee=ye.find(se=>!!se.allBasenames);ee&&(ve.allBasenames=ee.allBasenames);const ke=ye.reduce((se,_)=>_.allPaths?se.concat(_.allPaths):se,[]);return ke.length&&(ve.allPaths=ke),ve}function y(fe,be,ye){const he=R.sep===R.$gc.sep,ve=he?fe:fe.replace(l,R.sep),ee=R.sep+ve,ke=R.$gc.sep+fe;let se;return ye?se=function(_,V){return typeof _=="string"&&(_===ve||_.endsWith(ee)||!he&&(_===fe||_.endsWith(ke)))?be:null}:se=function(_,V){return typeof _=="string"&&(_===ve||!he&&_===fe)?be:null},se.allPaths=[(ye?"*/":"./")+fe],se}function k(fe){try{const be=new RegExp(`^${r(fe)}$`);return function(ye){return be.lastIndex=0,typeof ye=="string"&&be.test(ye)?fe:null}}catch{return u}}function N(fe,be,ye){return!fe||typeof be!="string"?!1:O(fe)(be,void 0,ye)}e.$Ij=N;function O(fe,be={}){if(!fe)return s;if(typeof fe=="string"||K(fe)){const ye=d(fe,be);if(ye===u)return s;const he=function(ve,ee){return!!ye(ve,ee)};return ye.allBasenames&&(he.allBasenames=ye.allBasenames),ye.allPaths&&(he.allPaths=ye.allPaths),he}return P(fe,be)}e.$Jj=O;function K(fe){const be=fe;return be?typeof be.base=="string"&&typeof be.pattern=="string":!1}e.$Kj=K;function j(fe){return fe.allBasenames||[]}e.$Lj=j;function W(fe){return fe.allPaths||[]}e.$Mj=W;function P(fe,be){const ye=J(Object.getOwnPropertyNames(fe).map(se=>C(se,fe[se],be)).filter(se=>se!==u)),he=ye.length;if(!he)return u;if(!ye.some(se=>!!se.requiresSiblings)){if(he===1)return ye[0];const se=function(ne,Ie){let Ae;for(let Pe=0,ce=ye.length;Pe<ce;Pe++){const ie=ye[Pe](ne,Ie);if(typeof ie=="string")return ie;(0,T.$Pg)(ie)&&(Ae||(Ae=[]),Ae.push(ie))}return Ae?(async()=>{for(const Pe of Ae){const ce=await Pe;if(typeof ce=="string")return ce}return null})():null},_=ye.find(ne=>!!ne.allBasenames);_&&(se.allBasenames=_.allBasenames);const V=ye.reduce((ne,Ie)=>Ie.allPaths?ne.concat(Ie.allPaths):ne,[]);return V.length&&(se.allPaths=V),se}const ve=function(se,_,V){let ne,Ie;for(let Ae=0,Pe=ye.length;Ae<Pe;Ae++){const ce=ye[Ae];ce.requiresSiblings&&V&&(_||(_=(0,R.$nc)(se)),ne||(ne=_.substr(0,_.length-(0,R.$oc)(se).length)));const ie=ce(se,_,ne,V);if(typeof ie=="string")return ie;(0,T.$Pg)(ie)&&(Ie||(Ie=[]),Ie.push(ie))}return Ie?(async()=>{for(const Ae of Ie){const Pe=await Ae;if(typeof Pe=="string")return Pe}return null})():null},ee=ye.find(se=>!!se.allBasenames);ee&&(ve.allBasenames=ee.allBasenames);const ke=ye.reduce((se,_)=>_.allPaths?se.concat(_.allPaths):se,[]);return ke.length&&(ve.allPaths=ke),ve}function C(fe,be,ye){if(be===!1)return u;const he=d(fe,ye);if(he===u)return u;if(typeof be=="boolean")return he;if(be){const ve=be.when;if(typeof ve=="string"){const ee=(ke,se,_,V)=>{if(!V||!he(ke,se))return null;const ne=ve.replace("$(basename)",()=>_),Ie=V(ne);return(0,T.$Pg)(Ie)?Ie.then(Ae=>Ae?fe:null):Ie?fe:null};return ee.requiresSiblings=!0,ee}}return he}function J(fe,be){const ye=fe.filter(se=>!!se.basenames);if(ye.length<2)return fe;const he=ye.reduce((se,_)=>{const V=_.basenames;return V?se.concat(V):se},[]);let ve;if(be){ve=[];for(let se=0,_=he.length;se<_;se++)ve.push(be)}else ve=ye.reduce((se,_)=>{const V=_.patterns;return V?se.concat(V):se},[]);const ee=function(se,_){if(typeof se!="string")return null;if(!_){let ne;for(ne=se.length;ne>0;ne--){const Ie=se.charCodeAt(ne-1);if(Ie===47||Ie===92)break}_=se.substr(ne)}const V=he.indexOf(_);return V!==-1?ve[V]:null};ee.basenames=he,ee.patterns=ve,ee.allBasenames=he;const ke=fe.filter(se=>!se.basenames);return ke.push(ee),ke}function ae(fe,be){return(0,E.$ub)(fe,be,(ye,he)=>typeof ye=="string"&&typeof he=="string"?ye===he:typeof ye!="string"&&typeof he!="string"?ye.base===he.base&&ye.pattern===he.pattern:!1)}e.$Nj=ae}),define(Ce[52],Re([1,0,15,126,25,11,2]),function(ge,e,E,T,I,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.MarkdownStringTextNewlineStyle=void 0;var $;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})($||(e.MarkdownStringTextNewlineStyle=$={}));class g{constructor(n="",a=!1){if(this.value=n,typeof this.value!="string")throw(0,E.$7)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1,this.supportHtml=a.supportHtml??!1)}appendText(n,a=0){return this.value+=l(this.supportThemeIcons?(0,T.$$j)(n):n).replace(/([ \t]+)/g,(c,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,a){return this.value+=`
${p(a,n)}
`,this}appendLink(n,a,c){return this.value+="[",this.value+=this.c(a,"]"),this.value+="](",this.value+=this.c(String(n),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(n,a){const c=new RegExp((0,F.$Le)(a),"g");return n.replace(c,(h,i)=>n.charAt(i-1)!=="\\"?`\\${h}`:h)}}e.$ek=g;function w(t){return A(t)?!t.value:Array.isArray(t)?t.every(w):!0}e.$fk=w;function A(t){return t instanceof g?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$gk=A;function D(t,n){return t===n?!0:!t||!n?!1:t.value===n.value&&t.isTrusted===n.isTrusted&&t.supportThemeIcons===n.supportThemeIcons&&t.supportHtml===n.supportHtml&&(t.baseUri===n.baseUri||!!t.baseUri&&!!n.baseUri&&(0,I.$xg)(R.URI.from(t.baseUri),R.URI.from(n.baseUri)))}e.$hk=D;function l(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$ik=l;function p(t,n){const a=t.match(/^`+/gm)?.reduce((h,i)=>h.length>i.length?h:i).length??0,c=a>=3?a+1:3;return[`${"`".repeat(c)}${n}`,t,`${"`".repeat(c)}`].join(`
`)}e.$jk=p;function b(t){return t.replace(/"/g,"&quot;")}e.$kk=b;function r(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$lk=r;function o(t){const n=[],a=t.split("|").map(h=>h.trim());t=a[0];const c=a[1];if(c){const h=/height=(\d+)/.exec(c),i=/width=(\d+)/.exec(c),s=h?h[1]:"",u=i?i[1]:"",d=isFinite(parseInt(u)),m=isFinite(parseInt(s));d&&n.push(`width="${u}"`),m&&n.push(`height="${s}"`)}return{href:t,dimensions:n}}e.$mk=o}),define(Ce[95],Re([1,0,18,46,19,21,25,11]),function(ge,e,E,T,I,F,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rv=e.$Qv=e.$Pv=e.$Ov=e.$Nv=e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=void 0;function g(d,m){const{os:f,tildify:S,relative:L}=m;if(L){const k=w(d,L,f);if(typeof k=="string")return k}let v=d.fsPath;if(f===1&&!F.$i?v=v.replace(/\//g,"\\"):f!==1&&F.$i&&(v=v.replace(/\\/g,"/")),f!==1&&S?.userHome){const k=S.userHome.fsPath;let N;d.scheme!==S.userHome.scheme&&d.path[0]===I.$gc.sep&&d.path[1]!==I.$gc.sep?N=S.userHome.with({path:d.path}).fsPath:N=v,v=l(N,k,f)}return(f===1?I.$fc:I.$gc).normalize(A(v,f===1))}e.$Iv=g;function w(d,m,f){const S=f===1?I.$fc:I.$gc,L=f===3?R.$ug:R.$wg,v=m.getWorkspace(),y=(0,E.$Ob)(v.folders);if(!y)return;d.scheme!==y.uri.scheme&&d.path[0]===I.$gc.sep&&d.path[1]!==I.$gc.sep&&(d=y.uri.with({path:d.path}));const k=m.getWorkspaceFolder(d);if(!k)return;let N;if(L.isEqual(k.uri,d)?N="":N=L.relativePath(k.uri,d)??"",N&&(N=S.normalize(N)),v.folders.length>1&&!m.noPrefix){const O=k.name?k.name:L.basenameOrAuthority(k.uri);N=N?`${O} \u2022 ${N}`:O}return N}function A(d,m=F.$i){return(0,T.$9f)(d,m)?d.charAt(0).toUpperCase()+d.slice(1):d}e.$Jv=A;let D=Object.create(null);function l(d,m,f=F.OS){if(f===1||!d||!m)return d;let S=D.original===m?D.normalized:void 0;S||(S=m,F.$i&&(S=(0,T.$Yf)(S)),S=`${(0,$.$Re)(S,I.$gc.sep)}${I.$gc.sep}`,D={original:m,normalized:S});let L=d;return F.$i&&(L=(0,T.$Yf)(L)),(f===3?L.startsWith(S):(0,$.$0e)(L,S))?`~/${L.substr(S.length)}`:d}e.$Kv=l;function p(d,m){return d.replace(/^~($|\/|\\)/,`${m}$1`)}e.$Lv=p;const b="\u2026",r="\\\\",o="~";function t(d,m=I.sep){const f=new Array(d.length);let S=!1;for(let L=0;L<d.length;L++){const v=d[L];if(v===""){f[L]=`.${m}`;continue}if(!v){f[L]=v;continue}S=!0;let y="",k=v;k.indexOf(r)===0?(y=k.substr(0,k.indexOf(r)+r.length),k=k.substr(k.indexOf(r)+r.length)):k.indexOf(m)===0?(y=k.substr(0,k.indexOf(m)+m.length),k=k.substr(k.indexOf(m)+m.length)):k.indexOf(o)===0&&(y=k.substr(0,k.indexOf(o)+o.length),k=k.substr(k.indexOf(o)+o.length));const N=k.split(m);for(let O=1;S&&O<=N.length;O++)for(let K=N.length-O;S&&K>=0;K--){S=!1;let j=N.slice(K,K+O).join(m);for(let W=0;!S&&W<d.length;W++)if(W!==L&&d[W]&&d[W].indexOf(j)>-1){const P=K+O===N.length,C=K>0&&d[W].indexOf(m)>-1?m+j:j,J=d[W].endsWith(C);S=!P||J}if(!S){let W="";(N[0].endsWith(":")||y!=="")&&(K===1&&(K=0,O++,j=N[0]+m+j),K>0&&(W=N[0]+m),W=y+W),K>0&&(W=W+b+m),W=W+j,K+O<N.length&&(W=W+m+b),f[L]=W}}S&&(f[L]=v)}return f}e.$Mv=t;var n;(function(d){d[d.TEXT=0]="TEXT",d[d.VARIABLE=1]="VARIABLE",d[d.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function a(d,m=Object.create(null)){const f=[];let S=!1,L="";for(const v of d)if(v==="$"||S&&v==="{")L&&f.push({value:L,type:n.TEXT}),L="",S=!0;else if(v==="}"&&S){const y=m[L];if(typeof y=="string")y.length&&f.push({value:y,type:n.VARIABLE});else if(y){const k=f[f.length-1];(!k||k.type!==n.SEPARATOR)&&f.push({value:y.label,type:n.SEPARATOR})}L="",S=!1}else L+=v;return L&&!S&&f.push({value:L,type:n.TEXT}),f.filter((v,y)=>{if(v.type===n.SEPARATOR){const k=f[y-1],N=f[y+1];return[k,N].every(O=>O&&(O.type===n.VARIABLE||O.type===n.TEXT)&&O.value.length>0)}return!0}).map(v=>v.value).join("")}e.$Nv=a;function c(d,m){return F.$j||m?d.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.$j?"&":"&&"):d.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.$Ov=c;function h(d,m){return F.$j||m?d.replace(/\(&&\w\)|&&/g,""):F.$i?d.replace(/&&|&/g,f=>f==="&"?"&&":"&"):d.replace(/&&/g,"_")}e.$Pv=h;function i(d){return d.replace(/&/g,"&&")}e.$Qv=i;function s(d){if(d.endsWith("]")){const m=d.lastIndexOf(" [",d.length-2);if(m!==-1){const f=u(d.substring(0,m)),S=d.substring(m);return{name:f.name+S,parentPath:f.parentPath}}}return u(d)}e.$Rv=s;function u(d){const m=d.indexOf("/")!==-1?I.$gc:I.$fc,f=m.basename(d),S=m.dirname(d);return f.length?{name:f,parentPath:S}:{name:S,parentPath:""}}}),define(Ce[139],Re([1,0,24,2]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=void 0;function I(D){return D.toJSON()}class F{constructor(l){this.a=l}transformIncoming(l){const p=this.a.transformIncoming(l);return p===l?l:I(T.URI.from(p))}transformOutgoing(l){const p=this.a.transformOutgoing(l);return p===l?l:I(T.URI.from(p))}transformOutgoingURI(l){const p=this.a.transformOutgoing(l);return p===l?l:T.URI.from(p)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$1m=F,e.$2m=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function R(D,l,p){if(!D||p>200)return null;if(typeof D=="object"){if(D instanceof T.URI)return l.transformOutgoing(D);for(const b in D)if(Object.hasOwnProperty.call(D,b)){const r=R(D[b],l,p+1);r!==null&&(D[b]=r)}}return null}function $(D,l){const p=R(D,l,0);return p===null?D:p}e.$3m=$;function g(D,l,p,b){if(!D||b>200)return null;if(typeof D=="object"){if(D.$mid===1)return p?T.URI.revive(l.transformIncoming(D)):l.transformIncoming(D);if(D instanceof E.$ge)return null;for(const r in D)if(Object.hasOwnProperty.call(D,r)){const o=g(D[r],l,p,b+1);o!==null&&(D[r]=o)}}return null}function w(D,l){const p=g(D,l,!1,0);return p===null?D:p}e.$4m=w;function A(D,l){const p=g(D,l,!0,0);return p===null?D:p}e.$5m=A}),define(Ce[140],Re([1,0,11,21,24]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=e.$2s=e.$1s=void 0;let F;function R(){return F||(F=new TextDecoder("UTF-16LE")),F}let $;function g(){return $||($=new TextDecoder("UTF-16BE")),$}let w;function A(){return w||(w=T.$D()?R():g()),w}e.$1s=A;function D(b,r,o){const t=new Uint16Array(b.buffer,r,o);return o>0&&(t[0]===65279||t[0]===65534)?l(b,r,o):R().decode(t)}e.$2s=D;function l(b,r,o){const t=[];let n=0;for(let a=0;a<o;a++){const c=I.$ie(b,r);r+=2,t[n++]=String.fromCharCode(c)}return t.join("")}class p{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return A().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const o=this.a-this.d;o<=1&&(o===0||E.$af(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const o=r.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=r;return}for(let t=0;t<o;t++)this.b[this.d++]=r.charCodeAt(t)}}e.$3s=p}),define(Ce[141],Re([1,0,24,140]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5s=e.$4s=void 0;function I(g){return g.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class F{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(w,A,D,l){this.oldPosition=w,this.oldText=A,this.newPosition=D,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${I(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${I(this.oldText)}")`:`(replace@${this.oldPosition} "${I(this.oldText)}" with "${I(this.newText)}")`}static a(w){return 4+2*w.length}static c(w,A,D){const l=A.length;E.$le(w,l,D),D+=4;for(let p=0;p<l;p++)E.$je(w,A.charCodeAt(p),D),D+=2;return D}static d(w,A){const D=E.$ke(w,A);return A+=4,(0,T.$2s)(w,A,D)}writeSize(){return 4+4+F.a(this.oldText)+F.a(this.newText)}write(w,A){return E.$le(w,this.oldPosition,A),A+=4,E.$le(w,this.newPosition,A),A+=4,A=F.c(w,this.oldText,A),A=F.c(w,this.newText,A),A}static read(w,A,D){const l=E.$ke(w,A);A+=4;const p=E.$ke(w,A);A+=4;const b=F.d(w,A);A+=F.a(b);const r=F.d(w,A);return A+=F.a(r),D.push(new F(l,b,p,r)),A}}e.$4s=F;function R(g,w){return g===null||g.length===0?w:new $(g,w).compress()}e.$5s=R;class ${constructor(w,A){this.a=w,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let w=0,A=0,D=this.n(w),l=this.l(A);for(;w<this.f||A<this.h;){if(D===null){this.k(l),l=this.l(++A);continue}if(l===null){this.m(D),D=this.n(++w);continue}if(l.oldEnd<=D.newPosition){this.k(l),l=this.l(++A);continue}if(D.newEnd<=l.oldPosition){this.m(D),D=this.n(++w);continue}if(l.oldPosition<D.newPosition){const[t,n]=$.r(l,D.newPosition-l.oldPosition);this.k(t),l=n;continue}if(D.newPosition<l.oldPosition){const[t,n]=$.q(D,l.oldPosition-D.newPosition);this.m(t),D=n;continue}let r,o;if(l.oldEnd===D.newEnd)r=D,o=l,D=this.n(++w),l=this.l(++A);else if(l.oldEnd<D.newEnd){const[t,n]=$.q(D,l.oldLength);r=t,o=l,D=n,l=this.l(++A)}else{const[t,n]=$.r(l,D.newLength);r=D,o=t,D=this.n(++w),l=n}this.d[this.e++]=new F(r.oldPosition,r.oldText,o.newPosition,o.newText),this.g+=r.newLength-r.oldLength,this.j+=o.newLength-o.oldLength}const p=$.s(this.d);return $.t(p)}k(w){this.d[this.e++]=$.o(this.g,w),this.j+=w.newLength-w.oldLength}l(w){return w<this.h?this.c[w]:null}m(w){this.d[this.e++]=$.p(this.j,w),this.g+=w.newLength-w.oldLength}n(w){return w<this.f?this.a[w]:null}static o(w,A){return new F(A.oldPosition-w,A.oldText,A.newPosition,A.newText)}static p(w,A){return new F(A.oldPosition,A.oldText,A.newPosition+w,A.newText)}static q(w,A){const D=w.newText.substr(0,A),l=w.newText.substr(A);return[new F(w.oldPosition,w.oldText,w.newPosition,D),new F(w.oldEnd,"",w.newPosition+A,l)]}static r(w,A){const D=w.oldText.substr(0,A),l=w.oldText.substr(A);return[new F(w.oldPosition,D,w.newPosition,w.newText),new F(w.oldPosition+A,l,w.newEnd,"")]}static s(w){if(w.length===0)return w;const A=[];let D=0,l=w[0];for(let p=1;p<w.length;p++){const b=w[p];l.oldEnd===b.oldPosition?l=new F(l.oldPosition,l.oldText+b.oldText,l.newPosition,l.newText+b.newText):(A[D++]=l,l=b)}return A[D++]=l,A}static t(w){if(w.length===0)return w;const A=[];let D=0;for(let l=0;l<w.length;l++){const p=w[l];p.oldText!==p.newText&&(A[D++]=p)}return A}}}),define(Ce[142],Re([1,0,34,19]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pt=void 0;function I(F,R,$,g,w,A){if(Array.isArray(F)){let D=0;for(const l of F){const p=I(l,R,$,g,w,A);if(p===10)return p;p>D&&(D=p)}return D}else{if(typeof F=="string")return g?F==="*"?5:F===$?10:0:0;if(F){const{language:D,pattern:l,scheme:p,hasAccessToAllModels:b,notebookType:r}=F;if(!g&&!b)return 0;r&&w&&(R=w);let o=0;if(p)if(p===R.scheme)o=10;else if(p==="*")o=5;else return 0;if(D)if(D===$)o=10;else if(D==="*")o=Math.max(o,5);else return 0;if(r)if(r===A)o=10;else if(r==="*"&&A!==void 0)o=Math.max(o,5);else return 0;if(l){let t;if(typeof l=="string"?t=l:t={...l,base:(0,T.$hc)(l.base)},t===R.fsPath||(0,E.$Ij)(t,R.fsPath))o=10;else return 0}return o}else return 0}}e.$pt=I}),define(Ce[143],Re([1,0,5,11,29,93,91,128,141,6]),function(ge,e,E,T,I,F,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZB=void 0;class A extends w.$Sc{constructor(l,p,b,r,o,t,n){super(),this.m=this.B(new E.$Sd),this.onDidChangeContent=this.m.event,this.f=p,this.j=!t,this.g=r,this.h=o,this.c=new R.$YB(l,b,n)}equals(l){return!(l instanceof A)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,p){return this.c.getOffsetAt(l,p)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,p){const b=l+p,r=this.getPositionAt(l),o=this.getPositionAt(b);return new I.$Is(r.lineNumber,r.column,o.lineNumber,o.column)}getValueInRange(l,p=0){if(l.isEmpty())return"";const b=this.n(p);return this.c.getValueInRange(l,b)}getValueLengthInRange(l,p=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const b=this.getOffsetAt(l.startLineNumber,l.startColumn),r=this.getOffsetAt(l.endLineNumber,l.endColumn);let o=0;const t=this.n(p),n=this.getEOL();if(t.length!==n.length){const a=t.length-n.length,c=l.endLineNumber-l.startLineNumber;o=a*c}return r-b+o}getCharacterCountInRange(l,p=0){if(this.j){let b=0;const r=l.startLineNumber,o=l.endLineNumber;for(let t=r;t<=o;t++){const n=this.getLineContent(t),a=t===r?l.startColumn-1:0,c=t===o?l.endColumn-1:n.length;for(let h=a;h<c;h++)T.$af(n.charCodeAt(h))?(b=b+1,h=h+1):b=b+1}return b+=this.n(p).length*(o-r),b}return this.getValueLengthInRange(l,p)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,p){return this.c.getLineCharCode(l,p)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const p=T.$Xe(this.getLineContent(l));return p===-1?0:p+1}getLineLastNonWhitespaceColumn(l){const p=T.$Ze(this.getLineContent(l));return p===-1?0:p+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,p,b){let r=this.g,o=this.h,t=this.j,n=!0,a=[];for(let m=0;m<l.length;m++){const f=l[m];n&&f._isTracked&&(n=!1);const S=f.range;if(f.text){let N=!0;t||(N=!T.$lf(f.text),t=N),!r&&N&&(r=T.$kf(f.text)),!o&&N&&(o=T.$nf(f.text))}let L="",v=0,y=0,k=0;if(f.text){let N;[v,y,k,N]=(0,$.$it)(f.text);const O=this.getEOL();N===0||N===(O===`\r
`?2:1)?L=f.text:L=f.text.replace(/\r\n|\r|\n/g,O)}a[m]={sortIndex:m,identifier:f.identifier||null,range:S,rangeOffset:this.getOffsetAt(S.startLineNumber,S.startColumn),rangeLength:this.getValueLengthInRange(S),text:L,eolCount:v,firstLineLength:y,lastLineLength:k,forceMoveMarkers:!!f.forceMoveMarkers,isAutoWhitespaceEdit:f.isAutoWhitespaceEdit||!1}}a.sort(A.u);let c=!1;for(let m=0,f=a.length-1;m<f;m++){const S=a[m].range.getEndPosition(),L=a[m+1].range.getStartPosition();if(L.isBeforeOrEqual(S)){if(L.isBefore(S))throw new Error("Overlapping ranges are not allowed!");c=!0}}n&&(a=this.s(a));const h=b||p?A._getInverseEditRanges(a):[],i=[];if(p)for(let m=0;m<a.length;m++){const f=a[m],S=h[m];if(f.isAutoWhitespaceEdit&&f.range.isEmpty())for(let L=S.startLineNumber;L<=S.endLineNumber;L++){let v="";L===S.startLineNumber&&(v=this.getLineContent(f.range.startLineNumber),T.$Xe(v)!==-1)||i.push({lineNumber:L,oldContent:v})}}let s=null;if(b){let m=0;s=[];for(let f=0;f<a.length;f++){const S=a[f],L=h[f],v=this.getValueInRange(S.range),y=S.rangeOffset+m;m+=S.text.length-v.length,s[f]={sortIndex:S.sortIndex,identifier:S.identifier,range:L,text:v,textChange:new g.$4s(S.rangeOffset,v,y,S.text)}}c||s.sort((f,S)=>f.sortIndex-S.sortIndex)}this.g=r,this.h=o,this.j=t;const u=this.t(a);let d=null;if(p&&i.length>0){i.sort((m,f)=>f.lineNumber-m.lineNumber),d=[];for(let m=0,f=i.length;m<f;m++){const S=i[m].lineNumber;if(m>0&&i[m-1].lineNumber===S)continue;const L=i[m].oldContent,v=this.getLineContent(S);v.length===0||v===L||T.$Xe(v)!==-1||d.push(S)}}return this.m.fire(),new F.$5u(s,u,d)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let p=!1;const b=l[0].range,r=l[l.length-1].range,o=new I.$Is(b.startLineNumber,b.startColumn,r.endLineNumber,r.endColumn);let t=b.startLineNumber,n=b.startColumn;const a=[];for(let u=0,d=l.length;u<d;u++){const m=l[u],f=m.range;p=p||m.forceMoveMarkers,a.push(this.getValueInRange(new I.$Is(t,n,f.startLineNumber,f.startColumn))),m.text.length>0&&a.push(m.text),t=f.endLineNumber,n=f.endColumn}const c=a.join(""),[h,i,s]=(0,$.$it)(c);return{sortIndex:0,identifier:l[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:c,eolCount:h,firstLineLength:i,lastLineLength:s,forceMoveMarkers:p,isAutoWhitespaceEdit:!1}}t(l){l.sort(A.w);const p=[];for(let b=0;b<l.length;b++){const r=l[b],o=r.range.startLineNumber,t=r.range.startColumn,n=r.range.endLineNumber,a=r.range.endColumn;if(o===n&&t===a&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const c=new I.$Is(o,t,n,a);p.push({range:c,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return p}findMatchesLineByLine(l,p,b,r){return this.c.findMatchesLineByLine(l,p,b,r)}getPieceTree(){return this.c}static _getInverseEditRange(l,p){const b=l.startLineNumber,r=l.startColumn,[o,t,n]=(0,$.$it)(p);let a;if(p.length>0){const c=o+1;c===1?a=new I.$Is(b,r,b,r+t):a=new I.$Is(b,r,b+c-1,n+1)}else a=new I.$Is(b,r,b,r);return a}static _getInverseEditRanges(l){const p=[];let b=0,r=0,o=null;for(let t=0,n=l.length;t<n;t++){const a=l[t];let c,h;o?o.range.endLineNumber===a.range.startLineNumber?(c=b,h=r+(a.range.startColumn-o.range.endColumn)):(c=b+(a.range.startLineNumber-o.range.endLineNumber),h=a.range.startColumn):(c=a.range.startLineNumber,h=a.range.startColumn);let i;if(a.text.length>0){const s=a.eolCount+1;s===1?i=new I.$Is(c,h,c,h+a.firstLineLength):i=new I.$Is(c,h,c+s-1,a.lastLineLength+1)}else i=new I.$Is(c,h,c,h);b=i.endLineNumber,r=i.endColumn,p.push(i),o=a}return p}static u(l,p){const b=I.$Is.compareRangesUsingEnds(l.range,p.range);return b===0?l.sortIndex-p.sortIndex:b}static w(l,p){const b=I.$Is.compareRangesUsingEnds(l.range,p.range);return b===0?p.sortIndex-l.sortIndex:-b}}e.$ZB=A}),define(Ce[144],Re([1,0,11,91,143]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1B=void 0;class F{constructor(g,w,A,D,l,p,b,r,o){this.a=g,this.b=w,this.c=A,this.d=D,this.e=l,this.f=p,this.g=b,this.h=r,this.j=o}k(g){const w=this.c+this.d+this.e,A=this.c+this.e;return w===0?g===1?`
`:`\r
`:A>w/2?`\r
`:`
`}create(g){const w=this.k(g),A=this.a;if(this.j&&(w===`\r
`&&(this.c>0||this.d>0)||w===`
`&&(this.c>0||this.e>0)))for(let l=0,p=A.length;l<p;l++){const b=A[l].buffer.replace(/\r\n|\r|\n/g,w),r=(0,T.$UB)(b);A[l]=new T.$XB(b,r)}const D=new I.$ZB(A,this.b,w,this.f,this.g,this.h,this.j);return{textBuffer:D,disposable:D}}getFirstLineText(g){return this.a[0].buffer.substr(0,g).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(g){if(g.length===0)return;this.a.length===0&&E.$tf(g)&&(this.b=E.$sf,g=g.substr(1));const w=g.charCodeAt(g.length-1);w===13||w>=55296&&w<=56319?(this.m(g.substr(0,g.length-1),!1),this.c=!0,this.d=w):(this.m(g,!1),this.c=!1,this.d=w)}m(g,w){!w&&g.length===0||(this.c?this.n(String.fromCharCode(this.d)+g):this.n(g))}n(g){const w=(0,T.$VB)(this.e,g);this.a.push(new T.$XB(g,w.lineStarts)),this.f+=w.cr,this.g+=w.lf,this.h+=w.crlf,w.isBasicASCII||(this.l=!1,this.j||(this.j=E.$kf(g)),this.k||(this.k=E.$nf(g)))}finish(g=!0){return this.o(),new F(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,g)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const g=this.a[this.a.length-1];g.buffer+=String.fromCharCode(this.d);const w=(0,T.$UB)(g.buffer);g.lineStarts=w,this.d===13&&this.f++}}}e.$1B=R}),define(Ce[96],Re([1,0,24,21]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k$=e.$j$=void 0;var I;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(I||(I={}));function F(D){for(let l=0,p=D.length;l<p;l+=4){const b=D[l+0],r=D[l+1],o=D[l+2],t=D[l+3];D[l+0]=t,D[l+1]=o,D[l+2]=r,D[l+3]=b}}function R(D){const l=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return T.$D()||F(l),E.$ge.wrap(l)}function $(D){const l=D.buffer;if(T.$D()||F(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const p=new Uint8Array(l.byteLength);return p.set(l),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function g(D){const l=new Uint32Array(w(D));let p=0;if(l[p++]=D.id,D.type==="full")l[p++]=1,l[p++]=D.data.length,l.set(D.data,p),p+=D.data.length;else{l[p++]=2,l[p++]=D.deltas.length;for(const b of D.deltas)l[p++]=b.start,l[p++]=b.deleteCount,b.data?(l[p++]=b.data.length,l.set(b.data,p),p+=b.data.length):l[p++]=0}return R(l)}e.$j$=g;function w(D){let l=0;if(l+=1+1,D.type==="full")l+=1+D.data.length;else{l+=1,l+=(1+1+1)*D.deltas.length;for(const p of D.deltas)p.data&&(l+=p.data.length)}return l}function A(D){const l=$(D);let p=0;const b=l[p++];if(l[p++]===1){const n=l[p++],a=l.subarray(p,p+n);return p+=n,{id:b,type:"full",data:a}}const o=l[p++],t=[];for(let n=0;n<o;n++){const a=l[p++],c=l[p++],h=l[p++];let i;h>0&&(i=l.subarray(p,p+h),p+=h),t[n]={start:a,deleteCount:c,data:i}}return{id:b,type:"delta",deltas:t}}e.$k$=A}),define(Ce[145],Re([9,10]),function(ge,e){return ge.create("vs/editor/common/config/editorOptions",e)}),define(Ce[146],Re([1,0,18,26,21,129,147,145]),function(ge,e,E,T,I,F,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var g;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(g||(e.EditorAutoIndentStrategy=g={})),e.MINIMAP_GUTTER_WIDTH=8;class w{constructor(x){this.c=x}hasChanged(x){return this.c[x]}}e.ConfigurationChangedEvent=w;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class D{constructor(x,$e,Be,Qe){this.id=x,this.name=$e,this.defaultValue=Be,this.schema=Qe}applyUpdate(x,$e){return p(x,$e)}compute(x,$e,Be){return Be}}class l{constructor(x,$e){this.newValue=x,this.didChange=$e}}e.ApplyUpdateResult=l;function p(X,x){if(typeof X!="object"||typeof x!="object"||!X||!x)return new l(x,X!==x);if(Array.isArray(X)||Array.isArray(x)){const Be=Array.isArray(X)&&Array.isArray(x)&&E.$ub(X,x);return new l(x,!Be)}let $e=!1;for(const Be in x)if(x.hasOwnProperty(Be)){const Qe=p(X[Be],x[Be]);Qe.didChange&&(X[Be]=Qe.newValue,$e=!0)}return new l(X,$e)}class b{constructor(x){this.schema=void 0,this.id=x,this.name="_never_",this.defaultValue=void 0}applyUpdate(x,$e){return p(x,$e)}validate(x){return this.defaultValue}}class r{constructor(x,$e,Be,Qe){this.id=x,this.name=$e,this.defaultValue=Be,this.schema=Qe}applyUpdate(x,$e){return p(x,$e)}validate(x){return typeof x>"u"?this.defaultValue:x}compute(x,$e,Be){return Be}}function o(X,x){return typeof X>"u"?x:X==="false"?!1:!!X}e.boolean=o;class t extends r{constructor(x,$e,Be,Qe=void 0){typeof Qe<"u"&&(Qe.type="boolean",Qe.default=Be),super(x,$e,Be,Qe)}validate(x){return o(x,this.defaultValue)}}function n(X,x,$e,Be){if(typeof X>"u")return x;let Qe=parseInt(X,10);return isNaN(Qe)?x:(Qe=Math.max($e,Qe),Qe=Math.min(Be,Qe),Qe|0)}e.clampedInt=n;class a extends r{static clampedInt(x,$e,Be,Qe){return n(x,$e,Be,Qe)}constructor(x,$e,Be,Qe,it,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=Be,rt.minimum=Qe,rt.maximum=it),super(x,$e,Be,rt),this.minimum=Qe,this.maximum=it}validate(x){return a.clampedInt(x,this.defaultValue,this.minimum,this.maximum)}}function c(X,x,$e,Be){if(typeof X>"u")return x;const Qe=h.float(X,x);return h.clamp(Qe,$e,Be)}e.clampedFloat=c;class h extends r{static clamp(x,$e,Be){return x<$e?$e:x>Be?Be:x}static float(x,$e){if(typeof x=="number")return x;if(typeof x>"u")return $e;const Be=parseFloat(x);return isNaN(Be)?$e:Be}constructor(x,$e,Be,Qe,it){typeof it<"u"&&(it.type="number",it.default=Be),super(x,$e,Be,it),this.validationFn=Qe}validate(x){return this.validationFn(h.float(x,this.defaultValue))}}class i extends r{static string(x,$e){return typeof x!="string"?$e:x}constructor(x,$e,Be,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.default=Be),super(x,$e,Be,Qe)}validate(x){return i.string(x,this.defaultValue)}}function s(X,x,$e,Be){return typeof X!="string"?x:Be&&X in Be?Be[X]:$e.indexOf(X)===-1?x:X}e.stringSet=s;class u extends r{constructor(x,$e,Be,Qe,it=void 0){typeof it<"u"&&(it.type="string",it.enum=Qe,it.default=Be),super(x,$e,Be,it),this.c=Qe}validate(x){return s(x,this.defaultValue,this.c)}}class d extends D{constructor(x,$e,Be,Qe,it,rt,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.enum=it,Ne.default=Qe),super(x,$e,Be,Ne),this.c=it,this.d=rt}validate(x){return typeof x!="string"?this.defaultValue:this.c.indexOf(x)===-1?this.defaultValue:this.d(x)}}function m(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[$.localize(0,null),$.localize(1,null),$.localize(2,null)],default:"auto",tags:["accessibility"],description:$.localize(3,null)})}validate(x){switch(x){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(x,$e,Be){return Be===0?x.accessibilitySupport:Be}}class S extends D{constructor(){const x={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",x,{"editor.comments.insertSpace":{type:"boolean",default:x.insertSpace,description:$.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:x.ignoreEmptyLines,description:$.localize(5,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{insertSpace:o($e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o($e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var L;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(L||(e.TextEditorCursorBlinkingStyle=L={}));function v(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var y;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(y||(e.TextEditorCursorStyle=y={}));function k(X){switch(X){case y.Line:return"line";case y.Block:return"block";case y.Underline:return"underline";case y.LineThin:return"line-thin";case y.BlockOutline:return"block-outline";case y.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=k;function N(X){switch(X){case"line":return y.Line;case"block":return y.Block;case"underline":return y.Underline;case"line-thin":return y.LineThin;case"block-outline":return y.BlockOutline;case"underline-thin":return y.UnderlineThin}}class O extends b{constructor(){super(140)}compute(x,$e,Be){const Qe=["monaco-editor"];return $e.get(39)&&Qe.push($e.get(39)),x.extraEditorClassName&&Qe.push(x.extraEditorClassName),$e.get(73)==="default"?Qe.push("mouse-default"):$e.get(73)==="copy"&&Qe.push("mouse-copy"),$e.get(110)&&Qe.push("showUnused"),$e.get(138)&&Qe.push("showDeprecated"),Qe.join(" ")}}class K extends t{constructor(){super(37,"emptySelectionClipboard",!0,{description:$.localize(6,null)})}compute(x,$e,Be){return Be&&x.emptySelectionClipboard}}class j extends D{constructor(){const x={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",x,{"editor.find.cursorMoveOnType":{type:"boolean",default:x.cursorMoveOnType,description:$.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:x.seedSearchStringFromSelection,enumDescriptions:[$.localize(8,null),$.localize(9,null),$.localize(10,null)],description:$.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:x.autoFindInSelection,enumDescriptions:[$.localize(12,null),$.localize(13,null),$.localize(14,null)],description:$.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:x.globalFindClipboard,description:$.localize(16,null),included:I.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:x.addExtraSpaceOnTop,description:$.localize(17,null)},"editor.find.loop":{type:"boolean",default:x.loop,description:$.localize(18,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{cursorMoveOnType:o($e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof x.seedSearchStringFromSelection=="boolean"?x.seedSearchStringFromSelection?"always":"never":s($e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof x.autoFindInSelection=="boolean"?x.autoFindInSelection?"always":"never":s($e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o($e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o($e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o($e.loop,this.defaultValue.loop)}}}class W extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",W.OFF,{anyOf:[{type:"boolean",description:$.localize(19,null)},{type:"string",description:$.localize(20,null)}],description:$.localize(21,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"||x.length===0?W.OFF:x==="true"?W.ON:x:x?W.ON:W.OFF}}e.EditorFontLigatures=W;class P extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",P.OFF,{anyOf:[{type:"boolean",description:$.localize(22,null)},{type:"string",description:$.localize(23,null)}],description:$.localize(24,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"?P.OFF:x==="true"?P.TRANSLATE:x:x?P.TRANSLATE:P.OFF}compute(x,$e,Be){return x.fontInfo.fontVariationSettings}}e.EditorFontVariations=P;class C extends b{constructor(){super(50)}compute(x,$e,Be){return x.fontInfo}}class J extends r{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:$.localize(25,null)})}validate(x){const $e=h.float(x,this.defaultValue);return $e===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp($e,6,100)}compute(x,$e,Be){return x.fontInfo.fontSize}}class ae extends D{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ae.d,maximum:ae.e,errorMessage:$.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ae.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:$.localize(27,null)})}validate(x){return x==="normal"||x==="bold"?x:String(a.clampedInt(x,e.EDITOR_FONT_DEFAULTS.fontWeight,ae.d,ae.e))}}class fe extends D{constructor(){const x={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},$e={type:"string",enum:["peek","gotoAndPeek","goto"],default:x.multiple,enumDescriptions:[$.localize(28,null),$.localize(29,null),$.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",x,{"editor.gotoLocation.multiple":{deprecationMessage:$.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:$.localize(32,null),...$e},"editor.gotoLocation.multipleTypeDefinitions":{description:$.localize(33,null),...$e},"editor.gotoLocation.multipleDeclarations":{description:$.localize(34,null),...$e},"editor.gotoLocation.multipleImplementations":{description:$.localize(35,null),...$e},"editor.gotoLocation.multipleReferences":{description:$.localize(36,null),...$e},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:x.alternativeDefinitionCommand,enum:Be,description:$.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:x.alternativeTypeDefinitionCommand,enum:Be,description:$.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:x.alternativeDeclarationCommand,enum:Be,description:$.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:x.alternativeImplementationCommand,enum:Be,description:$.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:x.alternativeReferenceCommand,enum:Be,description:$.localize(41,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{multiple:s($e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:$e.multipleDefinitions??s($e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:$e.multipleTypeDefinitions??s($e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:$e.multipleDeclarations??s($e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:$e.multipleImplementations??s($e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:$e.multipleReferences??s($e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string($e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string($e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string($e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string($e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string($e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class be extends D{constructor(){const x={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",x,{"editor.hover.enabled":{type:"boolean",default:x.enabled,description:$.localize(42,null)},"editor.hover.delay":{type:"number",default:x.delay,minimum:0,maximum:1e4,description:$.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:x.sticky,description:$.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:x.hidingDelay,description:$.localize(45,null)},"editor.hover.above":{type:"boolean",default:x.above,description:$.localize(46,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{enabled:o($e.enabled,this.defaultValue.enabled),delay:a.clampedInt($e.delay,this.defaultValue.delay,0,1e4),sticky:o($e.sticky,this.defaultValue.sticky),hidingDelay:a.clampedInt($e.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o($e.above,this.defaultValue.above)}}}var ye;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(ye||(e.RenderMinimap=ye={}));class he extends b{constructor(){super(143)}compute(x,$e,Be){return he.computeLayout($e,{memory:x.memory,outerWidth:x.outerWidth,outerHeight:x.outerHeight,isDominatedByLongLines:x.isDominatedByLongLines,lineHeight:x.fontInfo.lineHeight,viewLineCount:x.viewLineCount,lineNumbersDigitCount:x.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:x.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:x.fontInfo.maxDigitWidth,pixelRatio:x.pixelRatio,glyphMarginDecorationLaneCount:x.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(x){const $e=x.height/x.lineHeight,Be=Math.floor(x.paddingTop/x.lineHeight);let Qe=Math.floor(x.paddingBottom/x.lineHeight);x.scrollBeyondLastLine&&(Qe=Math.max(Qe,$e-1));const it=(Be+x.viewLineCount+Qe)/(x.pixelRatio*x.height),rt=Math.floor(x.viewLineCount/it);return{typicalViewportLineCount:$e,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Qe,desiredRatio:it,minimapLineCount:rt}}static c(x,$e){const Be=x.outerWidth,Qe=x.outerHeight,it=x.pixelRatio;if(!x.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(it*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const rt=$e.stableMinimapLayoutInput,Ne=rt&&x.outerHeight===rt.outerHeight&&x.lineHeight===rt.lineHeight&&x.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&x.pixelRatio===rt.pixelRatio&&x.scrollBeyondLastLine===rt.scrollBeyondLastLine&&x.paddingTop===rt.paddingTop&&x.paddingBottom===rt.paddingBottom&&x.minimap.enabled===rt.minimap.enabled&&x.minimap.side===rt.minimap.side&&x.minimap.size===rt.minimap.size&&x.minimap.showSlider===rt.minimap.showSlider&&x.minimap.renderCharacters===rt.minimap.renderCharacters&&x.minimap.maxColumn===rt.minimap.maxColumn&&x.minimap.scale===rt.minimap.scale&&x.verticalScrollbarWidth===rt.verticalScrollbarWidth&&x.isViewportWrapping===rt.isViewportWrapping,Pt=x.lineHeight,Tt=x.typicalHalfwidthCharacterWidth,Ht=x.scrollBeyondLastLine,Bt=x.minimap.renderCharacters;let yt=it>=2?Math.round(x.minimap.scale*2):x.minimap.scale;const Kt=x.minimap.maxColumn,Nt=x.minimap.size,Zt=x.minimap.side,jt=x.verticalScrollbarWidth,Rt=x.viewLineCount,Ye=x.remainingWidth,Gt=x.isViewportWrapping,Jt=Bt?2:3;let lt=Math.floor(it*Qe);const $t=lt/it;let zt=!1,Wt=!1,kt=Jt*yt,dt=yt/it,Ct=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:ft,extraLinesBeforeFirstLine:Mt,extraLinesBeyondLastLine:Se,desiredRatio:Me,minimapLineCount:de}=he.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Ht,paddingTop:x.paddingTop,paddingBottom:x.paddingBottom,height:Qe,lineHeight:Pt,pixelRatio:it});if(Rt/de>1)zt=!0,Wt=!0,yt=1,kt=1,dt=yt/it;else{let Le=!1,Ue=yt+1;if(Nt==="fit"){const Ze=Math.ceil((Mt+Rt+Se)*kt);Gt&&Ne&&Ye<=$e.stableFitRemainingWidth?(Le=!0,Ue=$e.stableFitMaxMinimapScale):Le=Ze>lt}if(Nt==="fill"||Le){zt=!0;const Ze=yt;kt=Math.min(Pt*it,Math.max(1,Math.floor(1/Me))),Gt&&Ne&&Ye<=$e.stableFitRemainingWidth&&(Ue=$e.stableFitMaxMinimapScale),yt=Math.min(Ue,Math.max(1,Math.floor(kt/Jt))),yt>Ze&&(Ct=Math.min(2,yt/Ze)),dt=yt/it/Ct,lt=Math.ceil(Math.max(ft,Mt+Rt+Se)*kt),Gt?($e.stableMinimapLayoutInput=x,$e.stableFitRemainingWidth=Ye,$e.stableFitMaxMinimapScale=yt):($e.stableMinimapLayoutInput=null,$e.stableFitRemainingWidth=0)}}}const xt=Math.floor(Kt*dt),St=Math.min(xt,Math.max(0,Math.floor((Ye-jt-2)*dt/(Tt+dt)))+e.MINIMAP_GUTTER_WIDTH);let qe=Math.floor(it*St);const Ft=qe/it;qe=Math.floor(qe*Ct);const Vt=Bt?1:2,Qt=Zt==="left"?0:Be-St-jt;return{renderMinimap:Vt,minimapLeft:Qt,minimapWidth:St,minimapHeightIsEditorHeight:zt,minimapIsSampling:Wt,minimapScale:yt,minimapLineHeight:kt,minimapCanvasInnerWidth:qe,minimapCanvasInnerHeight:lt,minimapCanvasOuterWidth:Ft,minimapCanvasOuterHeight:$t}}static computeLayout(x,$e){const Be=$e.outerWidth|0,Qe=$e.outerHeight|0,it=$e.lineHeight|0,rt=$e.lineNumbersDigitCount|0,Ne=$e.typicalHalfwidthCharacterWidth,Pt=$e.maxDigitWidth,Tt=$e.pixelRatio,Ht=$e.viewLineCount,Bt=x.get(135),yt=Bt==="inherit"?x.get(134):Bt,Kt=yt==="inherit"?x.get(130):yt,Nt=x.get(133),Zt=$e.isDominatedByLongLines,jt=x.get(57),Rt=x.get(67).renderType!==0,Ye=x.get(68),Gt=x.get(104),Jt=x.get(83),lt=x.get(72),$t=x.get(102),zt=$t.verticalScrollbarSize,Wt=$t.verticalHasArrows,kt=$t.arrowSize,dt=$t.horizontalScrollbarSize,Ct=x.get(43),xt=x.get(109)!=="never";let St=x.get(65);Ct&&xt&&(St+=16);let qe=0;if(Rt){const _e=Math.max(rt,Ye);qe=Math.round(_e*Pt)}let Ft=0;jt&&(Ft=it*$e.glyphMarginDecorationLaneCount);let Vt=0,Qt=Vt+Ft,ft=Qt+qe,Mt=ft+St;const Se=Be-Ft-qe-St;let Me=!1,de=!1,G=-1;yt==="inherit"&&Zt?(Me=!0,de=!0):Kt==="on"||Kt==="bounded"?de=!0:Kt==="wordWrapColumn"&&(G=Nt);const Le=he.c({outerWidth:Be,outerHeight:Qe,lineHeight:it,typicalHalfwidthCharacterWidth:Ne,pixelRatio:Tt,scrollBeyondLastLine:Gt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:lt,verticalScrollbarWidth:zt,viewLineCount:Ht,remainingWidth:Se,isViewportWrapping:de},$e.memory||new A);Le.renderMinimap!==0&&Le.minimapLeft===0&&(Vt+=Le.minimapWidth,Qt+=Le.minimapWidth,ft+=Le.minimapWidth,Mt+=Le.minimapWidth);const Ue=Se-Le.minimapWidth,Ze=Math.max(1,Math.floor((Ue-zt-2)/Ne)),Ve=Wt?kt:0;return de&&(G=Math.max(1,Ze),Kt==="bounded"&&(G=Math.min(G,Nt))),{width:Be,height:Qe,glyphMarginLeft:Vt,glyphMarginWidth:Ft,glyphMarginDecorationLaneCount:$e.glyphMarginDecorationLaneCount,lineNumbersLeft:Qt,lineNumbersWidth:qe,decorationsLeft:ft,decorationsWidth:St,contentLeft:Mt,contentWidth:Ue,minimap:Le,viewportColumn:Ze,isWordWrapMinified:Me,isViewportWrapping:de,wrappingColumn:G,verticalScrollbarWidth:zt,horizontalScrollbarHeight:dt,overviewRuler:{top:Ve,width:zt,height:Qe-2*Ve,right:0}}}}e.EditorLayoutInfoComputer=he;class ve extends D{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[$.localize(47,null),$.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:$.localize(49,null)}})}validate(x){return s(x,"simple",["simple","advanced"])}compute(x,$e,Be){return $e.get(2)===2?"advanced":Be}}var ee;(function(X){X.Off="off",X.OnCode="onCode",X.On="on"})(ee||(e.ShowLightbulbIconMode=ee={}));class ke extends D{constructor(){const x={enabled:ee.OnCode};super(64,"lightbulb",x,{"editor.lightbulb.enabled":{type:"string",enum:[ee.Off,ee.OnCode,ee.On],default:x.enabled,enumDescriptions:[$.localize(50,null),$.localize(51,null),$.localize(52,null)],description:$.localize(53,null)}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{enabled:s(x.enabled,this.defaultValue.enabled,[ee.Off,ee.OnCode,ee.On])}}}class se extends D{constructor(){const x={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",x,{"editor.stickyScroll.enabled":{type:"boolean",default:x.enabled,description:$.localize(54,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:x.maxLineCount,minimum:1,maximum:10,description:$.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:x.defaultModel,description:$.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:x.scrollWithEditor,description:$.localize(57,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{enabled:o($e.enabled,this.defaultValue.enabled),maxLineCount:a.clampedInt($e.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s($e.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o($e.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class _ extends D{constructor(){const x={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",x,{"editor.inlayHints.enabled":{type:"string",default:x.enabled,description:$.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[$.localize(59,null),$.localize(60,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(61,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:x.fontSize,markdownDescription:$.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:x.fontFamily,markdownDescription:$.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:x.padding,description:$.localize(65,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return typeof $e.enabled=="boolean"&&($e.enabled=$e.enabled?"on":"off"),{enabled:s($e.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:a.clampedInt($e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string($e.fontFamily,this.defaultValue.fontFamily),padding:o($e.padding,this.defaultValue.padding)}}}class V extends D{constructor(){super(65,"lineDecorationsWidth",10)}validate(x){return typeof x=="string"&&/^\d+(\.\d+)?ch$/.test(x)?-parseFloat(x.substring(0,x.length-2)):a.clampedInt(x,this.defaultValue,0,1e3)}compute(x,$e,Be){return Be<0?a.clampedInt(-Be*x.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class ne extends h{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,x=>h.clamp(x,0,150),{markdownDescription:$.localize(66,null)})}compute(x,$e,Be){return x.fontInfo.lineHeight}}class Ie extends D{constructor(){const x={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",x,{"editor.minimap.enabled":{type:"boolean",default:x.enabled,description:$.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:x.autohide,description:$.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[$.localize(69,null),$.localize(70,null),$.localize(71,null)],default:x.size,description:$.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:x.side,description:$.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:x.showSlider,description:$.localize(74,null)},"editor.minimap.scale":{type:"number",default:x.scale,minimum:1,maximum:3,enum:[1,2,3],description:$.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:x.renderCharacters,description:$.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:x.maxColumn,description:$.localize(77,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{enabled:o($e.enabled,this.defaultValue.enabled),autohide:o($e.autohide,this.defaultValue.autohide),size:s($e.size,this.defaultValue.size,["proportional","fill","fit"]),side:s($e.side,this.defaultValue.side,["right","left"]),showSlider:s($e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o($e.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt($e.scale,1,1,3),maxColumn:a.clampedInt($e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ae(X){return X==="ctrlCmd"?I.$j?"metaKey":"ctrlKey":"altKey"}class Pe extends D{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(79,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{top:a.clampedInt($e.top,0,0,1e3),bottom:a.clampedInt($e.bottom,0,0,1e3)}}}class ce extends D{constructor(){const x={enabled:!0,cycle:!0};super(85,"parameterHints",x,{"editor.parameterHints.enabled":{type:"boolean",default:x.enabled,description:$.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:x.cycle,description:$.localize(81,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{enabled:o($e.enabled,this.defaultValue.enabled),cycle:o($e.cycle,this.defaultValue.cycle)}}}class ie extends b{constructor(){super(141)}compute(x,$e,Be){return x.pixelRatio}}class Q extends D{constructor(){const x={other:"on",comments:"off",strings:"off"},$e=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[$.localize(82,null),$.localize(83,null),$.localize(84,null)]}];super(88,"quickSuggestions",x,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:$e,default:x.strings,description:$.localize(85,null)},comments:{anyOf:$e,default:x.comments,description:$.localize(86,null)},other:{anyOf:$e,default:x.other,description:$.localize(87,null)}},default:x,markdownDescription:$.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=x}validate(x){if(typeof x=="boolean"){const Tt=x?"on":"off";return{comments:Tt,strings:Tt,other:Tt}}if(!x||typeof x!="object")return this.defaultValue;const{other:$e,comments:Be,strings:Qe}=x,it=["on","inline","off"];let rt,Ne,Pt;return typeof $e=="boolean"?rt=$e?"on":"off":rt=s($e,this.defaultValue.other,it),typeof Be=="boolean"?Ne=Be?"on":"off":Ne=s(Be,this.defaultValue.comments,it),typeof Qe=="boolean"?Pt=Qe?"on":"off":Pt=s(Qe,this.defaultValue.strings,it),{other:rt,comments:Ne,strings:Pt}}}var te;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(te||(e.RenderLineNumbersType=te={}));class me extends D{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[$.localize(89,null),$.localize(90,null),$.localize(91,null),$.localize(92,null)],default:"on",description:$.localize(93,null)})}validate(x){let $e=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof x<"u"&&(typeof x=="function"?($e=4,Be=x):x==="interval"?$e=3:x==="relative"?$e=2:x==="on"?$e=1:$e=0),{renderType:$e,renderFn:Be}}}function pe(X){const x=X.get(97);return x==="editable"?X.get(90):x!=="on"}e.filterValidationDecorations=pe;class Fe extends D{constructor(){const x=[],$e={type:"number",description:$.localize(94,null)};super(101,"rulers",x,{type:"array",items:{anyOf:[$e,{type:["object"],properties:{column:$e,color:{type:"string",description:$.localize(95,null),format:"color-hex"}}}]},default:x,description:$.localize(96,null)})}validate(x){if(Array.isArray(x)){const $e=[];for(const Be of x)if(typeof Be=="number")$e.push({column:a.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Qe=Be;$e.push({column:a.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return $e.sort((Be,Qe)=>Be.column-Qe.column),$e}return this.defaultValue}}class le extends D{constructor(){super(91,"readOnlyMessage",void 0)}validate(x){return!x||typeof x!="object"?this.defaultValue:x}}function we(X,x){if(typeof X!="string")return x;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class M extends D{constructor(){const x={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",x,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(97,null),$.localize(98,null),$.localize(99,null)],default:"auto",description:$.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(101,null),$.localize(102,null),$.localize(103,null)],default:"auto",description:$.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:x.verticalScrollbarSize,description:$.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:x.horizontalScrollbarSize,description:$.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:x.scrollByPage,description:$.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:x.ignoreHorizontalScrollbarInContentHeight,description:$.localize(108,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x,Be=a.clampedInt($e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=a.clampedInt($e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt($e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:we($e.vertical,this.defaultValue.vertical),horizontal:we($e.horizontal,this.defaultValue.horizontal),useShadows:o($e.useShadows,this.defaultValue.useShadows),verticalHasArrows:o($e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o($e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o($e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o($e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:a.clampedInt($e.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:a.clampedInt($e.verticalSliderSize,Qe,0,1e3),scrollByPage:o($e.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o($e.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class q extends D{constructor(){const x={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",x,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.nonBasicASCII,description:$.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:x.invisibleCharacters,description:$.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:x.ambiguousCharacters,description:$.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeComments,description:$.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeStrings,description:$.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:x.allowedCharacters,description:$.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:x.allowedLocales,description:$.localize(115,null)}})}applyUpdate(x,$e){let Be=!1;$e.allowedCharacters&&x&&(T.$nn(x.allowedCharacters,$e.allowedCharacters)||(x={...x,allowedCharacters:$e.allowedCharacters},Be=!0)),$e.allowedLocales&&x&&(T.$nn(x.allowedLocales,$e.allowedLocales)||(x={...x,allowedLocales:$e.allowedLocales},Be=!0));const Qe=super.applyUpdate(x,$e);return Be?new l(Qe.newValue,!0):Qe}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{nonBasicASCII:Y($e.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o($e.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o($e.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Y($e.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Y($e.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(x.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(x.allowedLocales,this.defaultValue.allowedLocales)}}c(x,$e){if(typeof x!="object"||!x)return $e;const Be={};for(const[Qe,it]of Object.entries(x))it===!0&&(Be[Qe]=!0);return Be}}class H extends D{constructor(){const x={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",x,{"editor.inlineSuggest.enabled":{type:"boolean",default:x.enabled,description:$.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:x.showToolbar,enum:["always","onHover","never"],enumDescriptions:[$.localize(117,null),$.localize(118,null),$.localize(119,null)],description:$.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:x.suppressSuggestions,description:$.localize(121,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{enabled:o($e.enabled,this.defaultValue.enabled),mode:s($e.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o($e.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o($e.keepOnBlur,this.defaultValue.keepOnBlur)}}}class U extends D{constructor(){const x={enabled:F.$fs.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:F.$fs.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",x,{"editor.bracketPairColorization.enabled":{type:"boolean",default:x.enabled,markdownDescription:$.localize(122,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:x.independentColorPoolPerBracketType,description:$.localize(123,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{enabled:o($e.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o($e.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Z extends D{constructor(){const x={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",x,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(124,null),$.localize(125,null),$.localize(126,null)],default:x.bracketPairs,description:$.localize(127,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(128,null),$.localize(129,null),$.localize(130,null)],default:x.bracketPairsHorizontal,description:$.localize(131,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:x.highlightActiveBracketPair,description:$.localize(132,null)},"editor.guides.indentation":{type:"boolean",default:x.indentation,description:$.localize(133,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[$.localize(134,null),$.localize(135,null),$.localize(136,null)],default:x.highlightActiveIndentation,description:$.localize(137,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{bracketPairs:Y($e.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Y($e.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o($e.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o($e.indentation,this.defaultValue.indentation),highlightActiveIndentation:Y($e.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Y(X,x,$e){const Be=$e.indexOf(X);return Be===-1?x:$e[Be]}class Ee extends D{constructor(){const x={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",x,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[$.localize(138,null),$.localize(139,null)],default:x.insertMode,description:$.localize(140,null)},"editor.suggest.filterGraceful":{type:"boolean",default:x.filterGraceful,description:$.localize(141,null)},"editor.suggest.localityBonus":{type:"boolean",default:x.localityBonus,description:$.localize(142,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:x.shareSuggestSelections,markdownDescription:$.localize(143,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[$.localize(144,null),$.localize(145,null),$.localize(146,null),$.localize(147,null)],default:x.selectionMode,markdownDescription:$.localize(148,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:x.snippetsPreventQuickSuggestions,description:$.localize(149,null)},"editor.suggest.showIcons":{type:"boolean",default:x.showIcons,description:$.localize(150,null)},"editor.suggest.showStatusBar":{type:"boolean",default:x.showStatusBar,description:$.localize(151,null)},"editor.suggest.preview":{type:"boolean",default:x.preview,description:$.localize(152,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:x.showInlineDetails,description:$.localize(153,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:$.localize(154,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:$.localize(155,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:$.localize(156,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:$.localize(157,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:$.localize(158,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:$.localize(159,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:$.localize(160,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:$.localize(161,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:$.localize(162,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:$.localize(163,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:$.localize(164,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:$.localize(165,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:$.localize(166,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:$.localize(167,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:$.localize(168,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:$.localize(169,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:$.localize(170,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:$.localize(171,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:$.localize(172,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:$.localize(173,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:$.localize(174,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:$.localize(175,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:$.localize(176,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:$.localize(177,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:$.localize(178,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:$.localize(179,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:$.localize(180,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:$.localize(181,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:$.localize(182,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:$.localize(183,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:$.localize(184,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:$.localize(185,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{insertMode:s($e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o($e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o($e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o($e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o($e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s($e.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o($e.showIcons,this.defaultValue.showIcons),showStatusBar:o($e.showStatusBar,this.defaultValue.showStatusBar),preview:o($e.preview,this.defaultValue.preview),previewMode:s($e.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o($e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o($e.showMethods,this.defaultValue.showMethods),showFunctions:o($e.showFunctions,this.defaultValue.showFunctions),showConstructors:o($e.showConstructors,this.defaultValue.showConstructors),showDeprecated:o($e.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o($e.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o($e.showFields,this.defaultValue.showFields),showVariables:o($e.showVariables,this.defaultValue.showVariables),showClasses:o($e.showClasses,this.defaultValue.showClasses),showStructs:o($e.showStructs,this.defaultValue.showStructs),showInterfaces:o($e.showInterfaces,this.defaultValue.showInterfaces),showModules:o($e.showModules,this.defaultValue.showModules),showProperties:o($e.showProperties,this.defaultValue.showProperties),showEvents:o($e.showEvents,this.defaultValue.showEvents),showOperators:o($e.showOperators,this.defaultValue.showOperators),showUnits:o($e.showUnits,this.defaultValue.showUnits),showValues:o($e.showValues,this.defaultValue.showValues),showConstants:o($e.showConstants,this.defaultValue.showConstants),showEnums:o($e.showEnums,this.defaultValue.showEnums),showEnumMembers:o($e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o($e.showKeywords,this.defaultValue.showKeywords),showWords:o($e.showWords,this.defaultValue.showWords),showColors:o($e.showColors,this.defaultValue.showColors),showFiles:o($e.showFiles,this.defaultValue.showFiles),showReferences:o($e.showReferences,this.defaultValue.showReferences),showFolders:o($e.showFolders,this.defaultValue.showFolders),showTypeParameters:o($e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o($e.showSnippets,this.defaultValue.showSnippets),showUsers:o($e.showUsers,this.defaultValue.showUsers),showIssues:o($e.showIssues,this.defaultValue.showIssues)}}}class Te extends D{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:$.localize(186,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:$.localize(187,null),default:!0,type:"boolean"}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(x.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(x.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class He extends D{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[$.localize(188,null),$.localize(189,null),$.localize(190,null),$.localize(191,null)],description:$.localize(192,null),default:"same"}})}validate(x){switch(x){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(x,$e,Be){return $e.get(2)===2?0:Be}}class Xe extends b{constructor(){super(144)}compute(x,$e,Be){const Qe=$e.get(143);return{isDominatedByLongLines:x.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}class st extends D{constructor(){const x={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",x,{"editor.dropIntoEditor.enabled":{type:"boolean",default:x.enabled,markdownDescription:$.localize(193,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:$.localize(194,null),enum:["afterDrop","never"],enumDescriptions:[$.localize(195,null),$.localize(196,null)],default:"afterDrop"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{enabled:o($e.enabled,this.defaultValue.enabled),showDropSelector:s($e.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class nt extends D{constructor(){const x={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",x,{"editor.pasteAs.enabled":{type:"boolean",default:x.enabled,markdownDescription:$.localize(197,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:$.localize(198,null),enum:["afterPaste","never"],enumDescriptions:[$.localize(199,null),$.localize(200,null)],default:"afterPaste"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{enabled:o($e.enabled,this.defaultValue.enabled),showPasteSelector:s($e.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const tt="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",ct="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.$j?at:I.$k?ct:tt,fontWeight:"normal",fontSize:I.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(X){return e.editorOptionsRegistry[X.id]=X,X}var vt;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.ariaRequired=5]="ariaRequired",X[X.autoClosingBrackets=6]="autoClosingBrackets",X[X.autoClosingComments=7]="autoClosingComments",X[X.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",X[X.autoClosingDelete=9]="autoClosingDelete",X[X.autoClosingOvertype=10]="autoClosingOvertype",X[X.autoClosingQuotes=11]="autoClosingQuotes",X[X.autoIndent=12]="autoIndent",X[X.automaticLayout=13]="automaticLayout",X[X.autoSurround=14]="autoSurround",X[X.bracketPairColorization=15]="bracketPairColorization",X[X.guides=16]="guides",X[X.codeLens=17]="codeLens",X[X.codeLensFontFamily=18]="codeLensFontFamily",X[X.codeLensFontSize=19]="codeLensFontSize",X[X.colorDecorators=20]="colorDecorators",X[X.colorDecoratorsLimit=21]="colorDecoratorsLimit",X[X.columnSelection=22]="columnSelection",X[X.comments=23]="comments",X[X.contextmenu=24]="contextmenu",X[X.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",X[X.cursorBlinking=26]="cursorBlinking",X[X.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",X[X.cursorStyle=28]="cursorStyle",X[X.cursorSurroundingLines=29]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",X[X.cursorWidth=31]="cursorWidth",X[X.disableLayerHinting=32]="disableLayerHinting",X[X.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",X[X.domReadOnly=34]="domReadOnly",X[X.dragAndDrop=35]="dragAndDrop",X[X.dropIntoEditor=36]="dropIntoEditor",X[X.emptySelectionClipboard=37]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",X[X.extraEditorClassName=39]="extraEditorClassName",X[X.fastScrollSensitivity=40]="fastScrollSensitivity",X[X.find=41]="find",X[X.fixedOverflowWidgets=42]="fixedOverflowWidgets",X[X.folding=43]="folding",X[X.foldingStrategy=44]="foldingStrategy",X[X.foldingHighlight=45]="foldingHighlight",X[X.foldingImportsByDefault=46]="foldingImportsByDefault",X[X.foldingMaximumRegions=47]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=49]="fontFamily",X[X.fontInfo=50]="fontInfo",X[X.fontLigatures=51]="fontLigatures",X[X.fontSize=52]="fontSize",X[X.fontWeight=53]="fontWeight",X[X.fontVariations=54]="fontVariations",X[X.formatOnPaste=55]="formatOnPaste",X[X.formatOnType=56]="formatOnType",X[X.glyphMargin=57]="glyphMargin",X[X.gotoLocation=58]="gotoLocation",X[X.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",X[X.hover=60]="hover",X[X.inDiffEditor=61]="inDiffEditor",X[X.inlineSuggest=62]="inlineSuggest",X[X.letterSpacing=63]="letterSpacing",X[X.lightbulb=64]="lightbulb",X[X.lineDecorationsWidth=65]="lineDecorationsWidth",X[X.lineHeight=66]="lineHeight",X[X.lineNumbers=67]="lineNumbers",X[X.lineNumbersMinChars=68]="lineNumbersMinChars",X[X.linkedEditing=69]="linkedEditing",X[X.links=70]="links",X[X.matchBrackets=71]="matchBrackets",X[X.minimap=72]="minimap",X[X.mouseStyle=73]="mouseStyle",X[X.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=75]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",X[X.multiCursorModifier=77]="multiCursorModifier",X[X.multiCursorPaste=78]="multiCursorPaste",X[X.multiCursorLimit=79]="multiCursorLimit",X[X.occurrencesHighlight=80]="occurrencesHighlight",X[X.overviewRulerBorder=81]="overviewRulerBorder",X[X.overviewRulerLanes=82]="overviewRulerLanes",X[X.padding=83]="padding",X[X.pasteAs=84]="pasteAs",X[X.parameterHints=85]="parameterHints",X[X.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",X[X.quickSuggestions=88]="quickSuggestions",X[X.quickSuggestionsDelay=89]="quickSuggestionsDelay",X[X.readOnly=90]="readOnly",X[X.readOnlyMessage=91]="readOnlyMessage",X[X.renameOnType=92]="renameOnType",X[X.renderControlCharacters=93]="renderControlCharacters",X[X.renderFinalNewline=94]="renderFinalNewline",X[X.renderLineHighlight=95]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=97]="renderValidationDecorations",X[X.renderWhitespace=98]="renderWhitespace",X[X.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",X[X.roundedSelection=100]="roundedSelection",X[X.rulers=101]="rulers",X[X.scrollbar=102]="scrollbar",X[X.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=104]="scrollBeyondLastLine",X[X.scrollPredominantAxis=105]="scrollPredominantAxis",X[X.selectionClipboard=106]="selectionClipboard",X[X.selectionHighlight=107]="selectionHighlight",X[X.selectOnLineNumbers=108]="selectOnLineNumbers",X[X.showFoldingControls=109]="showFoldingControls",X[X.showUnused=110]="showUnused",X[X.snippetSuggestions=111]="snippetSuggestions",X[X.smartSelect=112]="smartSelect",X[X.smoothScrolling=113]="smoothScrolling",X[X.stickyScroll=114]="stickyScroll",X[X.stickyTabStops=115]="stickyTabStops",X[X.stopRenderingLineAfter=116]="stopRenderingLineAfter",X[X.suggest=117]="suggest",X[X.suggestFontSize=118]="suggestFontSize",X[X.suggestLineHeight=119]="suggestLineHeight",X[X.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",X[X.suggestSelection=121]="suggestSelection",X[X.tabCompletion=122]="tabCompletion",X[X.tabIndex=123]="tabIndex",X[X.unicodeHighlighting=124]="unicodeHighlighting",X[X.unusualLineTerminators=125]="unusualLineTerminators",X[X.useShadowDOM=126]="useShadowDOM",X[X.useTabStops=127]="useTabStops",X[X.wordBreak=128]="wordBreak",X[X.wordSeparators=129]="wordSeparators",X[X.wordWrap=130]="wordWrap",X[X.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=133]="wordWrapColumn",X[X.wordWrapOverride1=134]="wordWrapOverride1",X[X.wordWrapOverride2=135]="wordWrapOverride2",X[X.wrappingIndent=136]="wrappingIndent",X[X.wrappingStrategy=137]="wrappingStrategy",X[X.showDeprecated=138]="showDeprecated",X[X.inlayHints=139]="inlayHints",X[X.editorClassName=140]="editorClassName",X[X.pixelRatio=141]="pixelRatio",X[X.tabFocusMode=142]="tabFocusMode",X[X.layoutInfo=143]="layoutInfo",X[X.wrappingInfo=144]="wrappingInfo",X[X.defaultColorDecorators=145]="defaultColorDecorators",X[X.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",X[X.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(vt||(e.EditorOption=vt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new t(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:$.localize(201,null)})),acceptSuggestionOnEnter:ze(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",$.localize(202,null),""],markdownDescription:$.localize(203,null)})),accessibilitySupport:ze(new f),accessibilityPageSize:ze(new a(3,"accessibilityPageSize",10,1,1073741824,{description:$.localize(204,null),tags:["accessibility"]})),ariaLabel:ze(new i(4,"ariaLabel",$.localize(205,null))),ariaRequired:ze(new t(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new t(8,"screenReaderAnnounceInlineSuggestion",!0,{description:$.localize(206,null),tags:["accessibility"]})),autoClosingBrackets:ze(new u(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(207,null),$.localize(208,null),""],description:$.localize(209,null)})),autoClosingComments:ze(new u(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(210,null),$.localize(211,null),""],description:$.localize(212,null)})),autoClosingDelete:ze(new u(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",$.localize(213,null),""],description:$.localize(214,null)})),autoClosingOvertype:ze(new u(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",$.localize(215,null),""],description:$.localize(216,null)})),autoClosingQuotes:ze(new u(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(217,null),$.localize(218,null),""],description:$.localize(219,null)})),autoIndent:ze(new d(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],m,{enumDescriptions:[$.localize(220,null),$.localize(221,null),$.localize(222,null),$.localize(223,null),$.localize(224,null)],description:$.localize(225,null)})),automaticLayout:ze(new t(13,"automaticLayout",!1)),autoSurround:ze(new u(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[$.localize(226,null),$.localize(227,null),$.localize(228,null),""],description:$.localize(229,null)})),bracketPairColorization:ze(new U),bracketPairGuides:ze(new Z),stickyTabStops:ze(new t(115,"stickyTabStops",!1,{description:$.localize(230,null)})),codeLens:ze(new t(17,"codeLens",!0,{description:$.localize(231,null)})),codeLensFontFamily:ze(new i(18,"codeLensFontFamily","",{description:$.localize(232,null)})),codeLensFontSize:ze(new a(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:$.localize(233,null)})),colorDecorators:ze(new t(20,"colorDecorators",!0,{description:$.localize(234,null)})),colorDecoratorActivatedOn:ze(new u(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[$.localize(235,null),$.localize(236,null),$.localize(237,null)],description:$.localize(238,null)})),colorDecoratorsLimit:ze(new a(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:$.localize(239,null)})),columnSelection:ze(new t(22,"columnSelection",!1,{description:$.localize(240,null)})),comments:ze(new S),contextmenu:ze(new t(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new t(25,"copyWithSyntaxHighlighting",!0,{description:$.localize(241,null)})),cursorBlinking:ze(new d(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],v,{description:$.localize(242,null)})),cursorSmoothCaretAnimation:ze(new u(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[$.localize(243,null),$.localize(244,null),$.localize(245,null)],description:$.localize(246,null)})),cursorStyle:ze(new d(28,"cursorStyle",y.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],N,{description:$.localize(247,null)})),cursorSurroundingLines:ze(new a(29,"cursorSurroundingLines",0,0,1073741824,{description:$.localize(248,null)})),cursorSurroundingLinesStyle:ze(new u(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[$.localize(249,null),$.localize(250,null)],markdownDescription:$.localize(251,null)})),cursorWidth:ze(new a(31,"cursorWidth",0,0,1073741824,{markdownDescription:$.localize(252,null)})),disableLayerHinting:ze(new t(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new t(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new t(34,"domReadOnly",!1)),dragAndDrop:ze(new t(35,"dragAndDrop",!0,{description:$.localize(253,null)})),emptySelectionClipboard:ze(new K),dropIntoEditor:ze(new st),stickyScroll:ze(new se),experimentalWhitespaceRendering:ze(new u(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[$.localize(254,null),$.localize(255,null),$.localize(256,null)],description:$.localize(257,null)})),extraEditorClassName:ze(new i(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new h(40,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:$.localize(258,null)})),find:ze(new j),fixedOverflowWidgets:ze(new t(42,"fixedOverflowWidgets",!1)),folding:ze(new t(43,"folding",!0,{description:$.localize(259,null)})),foldingStrategy:ze(new u(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[$.localize(260,null),$.localize(261,null)],description:$.localize(262,null)})),foldingHighlight:ze(new t(45,"foldingHighlight",!0,{description:$.localize(263,null)})),foldingImportsByDefault:ze(new t(46,"foldingImportsByDefault",!1,{description:$.localize(264,null)})),foldingMaximumRegions:ze(new a(47,"foldingMaximumRegions",5e3,10,65e3,{description:$.localize(265,null)})),unfoldOnClickAfterEndOfLine:ze(new t(48,"unfoldOnClickAfterEndOfLine",!1,{description:$.localize(266,null)})),fontFamily:ze(new i(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:$.localize(267,null)})),fontInfo:ze(new C),fontLigatures2:ze(new W),fontSize:ze(new J),fontWeight:ze(new ae),fontVariations:ze(new P),formatOnPaste:ze(new t(55,"formatOnPaste",!1,{description:$.localize(268,null)})),formatOnType:ze(new t(56,"formatOnType",!1,{description:$.localize(269,null)})),glyphMargin:ze(new t(57,"glyphMargin",!0,{description:$.localize(270,null)})),gotoLocation:ze(new fe),hideCursorInOverviewRuler:ze(new t(59,"hideCursorInOverviewRuler",!1,{description:$.localize(271,null)})),hover:ze(new be),inDiffEditor:ze(new t(61,"inDiffEditor",!1)),letterSpacing:ze(new h(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>h.clamp(X,-5,20),{description:$.localize(272,null)})),lightbulb:ze(new ke),lineDecorationsWidth:ze(new V),lineHeight:ze(new ne),lineNumbers:ze(new me),lineNumbersMinChars:ze(new a(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new t(69,"linkedEditing",!1,{description:$.localize(273,null)})),links:ze(new t(70,"links",!0,{description:$.localize(274,null)})),matchBrackets:ze(new u(71,"matchBrackets","always",["always","near","never"],{description:$.localize(275,null)})),minimap:ze(new Ie),mouseStyle:ze(new u(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new h(74,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:$.localize(276,null)})),mouseWheelZoom:ze(new t(75,"mouseWheelZoom",!1,{markdownDescription:I.$j?$.localize(277,null):$.localize(278,null)})),multiCursorMergeOverlapping:ze(new t(76,"multiCursorMergeOverlapping",!0,{description:$.localize(279,null)})),multiCursorModifier:ze(new d(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ae,{markdownEnumDescriptions:[$.localize(280,null),$.localize(281,null)],markdownDescription:$.localize(282,null)})),multiCursorPaste:ze(new u(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[$.localize(283,null),$.localize(284,null)],markdownDescription:$.localize(285,null)})),multiCursorLimit:ze(new a(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:$.localize(286,null)})),occurrencesHighlight:ze(new u(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[$.localize(287,null),$.localize(288,null),$.localize(289,null)],markdownDescription:$.localize(290,null)})),overviewRulerBorder:ze(new t(81,"overviewRulerBorder",!0,{description:$.localize(291,null)})),overviewRulerLanes:ze(new a(82,"overviewRulerLanes",3,0,3)),padding:ze(new Pe),pasteAs:ze(new nt),parameterHints:ze(new ce),peekWidgetDefaultFocus:ze(new u(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[$.localize(292,null),$.localize(293,null)],description:$.localize(294,null)})),definitionLinkOpensInPeek:ze(new t(87,"definitionLinkOpensInPeek",!1,{description:$.localize(295,null)})),quickSuggestions:ze(new Q),quickSuggestionsDelay:ze(new a(89,"quickSuggestionsDelay",10,0,1073741824,{description:$.localize(296,null)})),readOnly:ze(new t(90,"readOnly",!1)),readOnlyMessage:ze(new le),renameOnType:ze(new t(92,"renameOnType",!1,{description:$.localize(297,null),markdownDeprecationMessage:$.localize(298,null)})),renderControlCharacters:ze(new t(93,"renderControlCharacters",!0,{description:$.localize(299,null),restricted:!0})),renderFinalNewline:ze(new u(94,"renderFinalNewline",I.$k?"dimmed":"on",["off","on","dimmed"],{description:$.localize(300,null)})),renderLineHighlight:ze(new u(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",$.localize(301,null)],description:$.localize(302,null)})),renderLineHighlightOnlyWhenFocus:ze(new t(96,"renderLineHighlightOnlyWhenFocus",!1,{description:$.localize(303,null)})),renderValidationDecorations:ze(new u(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new u(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",$.localize(304,null),$.localize(305,null),$.localize(306,null),""],description:$.localize(307,null)})),revealHorizontalRightPadding:ze(new a(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new t(100,"roundedSelection",!0,{description:$.localize(308,null)})),rulers:ze(new Fe),scrollbar:ze(new M),scrollBeyondLastColumn:ze(new a(103,"scrollBeyondLastColumn",4,0,1073741824,{description:$.localize(309,null)})),scrollBeyondLastLine:ze(new t(104,"scrollBeyondLastLine",!0,{description:$.localize(310,null)})),scrollPredominantAxis:ze(new t(105,"scrollPredominantAxis",!0,{description:$.localize(311,null)})),selectionClipboard:ze(new t(106,"selectionClipboard",!0,{description:$.localize(312,null),included:I.$k})),selectionHighlight:ze(new t(107,"selectionHighlight",!0,{description:$.localize(313,null)})),selectOnLineNumbers:ze(new t(108,"selectOnLineNumbers",!0)),showFoldingControls:ze(new u(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[$.localize(314,null),$.localize(315,null),$.localize(316,null)],description:$.localize(317,null)})),showUnused:ze(new t(110,"showUnused",!0,{description:$.localize(318,null)})),showDeprecated:ze(new t(138,"showDeprecated",!0,{description:$.localize(319,null)})),inlayHints:ze(new _),snippetSuggestions:ze(new u(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[$.localize(320,null),$.localize(321,null),$.localize(322,null),$.localize(323,null)],description:$.localize(324,null)})),smartSelect:ze(new Te),smoothScrolling:ze(new t(113,"smoothScrolling",!1,{description:$.localize(325,null)})),stopRenderingLineAfter:ze(new a(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new Ee),inlineSuggest:ze(new H),inlineCompletionsAccessibilityVerbose:ze(new t(147,"inlineCompletionsAccessibilityVerbose",!1,{description:$.localize(326,null)})),suggestFontSize:ze(new a(118,"suggestFontSize",0,0,1e3,{markdownDescription:$.localize(327,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new a(119,"suggestLineHeight",0,0,1e3,{markdownDescription:$.localize(328,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new t(120,"suggestOnTriggerCharacters",!0,{description:$.localize(329,null)})),suggestSelection:ze(new u(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[$.localize(330,null),$.localize(331,null),$.localize(332,null)],description:$.localize(333,null)})),tabCompletion:ze(new u(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[$.localize(334,null),$.localize(335,null),$.localize(336,null)],description:$.localize(337,null)})),tabIndex:ze(new a(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new q),unusualLineTerminators:ze(new u(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[$.localize(338,null),$.localize(339,null),$.localize(340,null)],description:$.localize(341,null)})),useShadowDOM:ze(new t(126,"useShadowDOM",!0)),useTabStops:ze(new t(127,"useTabStops",!0,{description:$.localize(342,null)})),wordBreak:ze(new u(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[$.localize(343,null),$.localize(344,null)],description:$.localize(345,null)})),wordSeparators:ze(new i(129,"wordSeparators",R.$gs,{description:$.localize(346,null)})),wordWrap:ze(new u(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[$.localize(347,null),$.localize(348,null),$.localize(349,null),$.localize(350,null)],description:$.localize(351,null)})),wordWrapBreakAfterCharacters:ze(new i(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new i(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new a(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:$.localize(352,null)})),wordWrapOverride1:ze(new u(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new u(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new O),defaultColorDecorators:ze(new t(145,"defaultColorDecorators",!1,{markdownDescription:$.localize(353,null)})),pixelRatio:ze(new ie),tabFocusMode:ze(new t(142,"tabFocusMode",!1,{markdownDescription:$.localize(354,null)})),layoutInfo:ze(new he),wrappingInfo:ze(new Xe),wrappingIndent:ze(new He),wrappingStrategy:ze(new ve)}}),define(Ce[148],Re([9,10]),function(ge,e){return ge.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[149],Re([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/contextkey",e)}),define(Ce[150],Re([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/scanner",e)}),define(Ce[151],Re([9,10]),function(ge,e){return ge.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[152],Re([9,10]),function(ge,e){return ge.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[153],Re([9,10]),function(ge,e){return ge.create("vs/platform/files/common/files",e)}),define(Ce[154],Re([9,10]),function(ge,e){return ge.create("vs/platform/markers/common/markers",e)}),define(Ce[155],Re([9,10]),function(ge,e){return ge.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[156],Re([9,10]),function(ge,e){return ge.create("vs/platform/workspace/common/workspace",e)}),define(Ce[157],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Ce[158],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[159],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[160],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ce[161],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLogService",e)}),define(Ce[162],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ce[163],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostProgress",e)}),define(Ce[164],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[165],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[166],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[167],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[168],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ce[169],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[170],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/configuration",e)}),define(Ce[171],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/editor",e)}),define(Ce[172],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/views",e)}),define(Ce[173],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[174],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[175],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[176],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[177],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[178],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ce[179],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[180],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[181],Re([1,0,15,150]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xi=e.TokenType=void 0;var I;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(I||(e.TokenType=I={}));function F(...w){switch(w.length){case 1:return(0,T.localize)(0,null,w[0]);case 2:return(0,T.localize)(1,null,w[0],w[1]);case 3:return(0,T.localize)(2,null,w[0],w[1],w[2]);default:return}}const R=(0,T.localize)(3,null),$=(0,T.localize)(4,null);class g{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,E.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(F("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(F("&&"));break;case 124:this.h(124)?this.k(16):this.l(F("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const D=this.d,l=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:l};this.g.push({offset:D,lexeme:l,additionalInfo:A}),this.f.push(p)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const D=this.c.substring(this.d,this.e),l=g.b.get(D);l?this.k(l):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,D=!1,l=!1;for(;;){if(A>=this.c.length){this.e=A,this.l($);return}const b=this.c.charCodeAt(A);if(D)D=!1;else if(b===47&&!l){A++;break}else b===91?l=!0:b===92?D=!0:b===93&&(l=!1);A++}for(;A<this.c.length&&g.a.has(this.c.charCodeAt(A));)A++;this.e=A;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$Xi=g}),define(Ce[182],Re([1,0,25,31,152,294]),function(ge,e,E,T,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,$=/^-(\d{4})(\d{2})(\d{2})$/;function g(t){return t=t.trim(),t==="*"||R.test(t)}e.$1o=g;function w(t){if(!g(t))return null;if(t=t.trim(),t==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=t.match(R);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}e.$2o=w;function A(t){if(!t)return null;const n=t.majorBase,a=t.majorMustEqual,c=t.minorBase;let h=t.minorMustEqual;const i=t.patchBase;let s=t.patchMustEqual;t.hasCaret&&(n===0||(h=!1),s=!1);let u=0;if(t.preRelease){const d=$.exec(t.preRelease);if(d){const[,m,f,S]=d;u=Date.UTC(Number(m),Number(f)-1,Number(S))}}return{majorBase:n,majorMustEqual:a,minorBase:c,minorMustEqual:h,patchBase:i,patchMustEqual:s,isMinimum:t.hasGreaterEquals,notBefore:u}}e.$3o=A;function D(t,n,a){let c;typeof t=="string"?c=A(w(t)):c=t;let h;n instanceof Date?h=n.getTime():typeof n=="string"&&(h=new Date(n).getTime());let i;if(typeof a=="string"?i=A(w(a)):i=a,!c||!i)return!1;const s=c.majorBase,u=c.minorBase,d=c.patchBase;let m=i.majorBase,f=i.minorBase,S=i.patchBase;const L=i.notBefore;let v=i.majorMustEqual,y=i.minorMustEqual,k=i.patchMustEqual;return i.isMinimum?s>m?!0:s<m?!1:u>f?!0:u<f||h&&h<L?!1:d>=S:(s===1&&m===0&&(!v||!y||!k)&&(m=1,f=0,S=0,v=!0,y=!1,k=!1),s<m?!1:s>m?!v:u<f?!1:u>f?!y:d<S?!1:d>S?!k:!(h&&h<L))}e.$4o=D;function l(t,n,a,c,h){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([T.default.Error,I.localize(0,null)]),i;if(typeof c.name!="string")return i.push([T.default.Error,I.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([T.default.Error,I.localize(2,null,"version")]),i;if(!c.engines)return i.push([T.default.Error,I.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([T.default.Error,I.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!o(c.extensionDependencies))return i.push([T.default.Error,I.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!o(c.activationEvents))return i.push([T.default.Error,I.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([T.default.Error,I.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([T.default.Warning,I.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([T.default.Error,I.localize(9,null,"main")]),i;{const d=(0,E.$Eg)(a,c.main);(0,E.$yg)(d,a)||i.push([T.default.Warning,I.localize(10,null,d.path,a.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([T.default.Error,I.localize(11,null,"browser")]),i;{const d=(0,E.$Eg)(a,c.browser);(0,E.$yg)(d,a)||i.push([T.default.Warning,I.localize(12,null,d.path,a.path)])}}if(!F.valid(c.version))return i.push([T.default.Error,I.localize(13,null)]),i;const s=[];if(!p(t,n,c,h,s))for(const d of s)i.push([T.default.Error,d]);return i}e.$5o=l;function p(t,n,a,c,h){return c||typeof a.main>"u"&&typeof a.browser>"u"?!0:r(t,n,a.engines.vscode,h)}e.$6o=p;function b(t,n,a){return t==="*"||r(n,a,t)}e.$7o=b;function r(t,n,a,c=[]){const h=A(w(a));if(!h)return c.push(I.localize(14,null,a)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return c.push(I.localize(15,null,a)),!1}else if(!h.majorMustEqual)return c.push(I.localize(16,null,a)),!1;return D(t,n,h)?!0:(c.push(I.localize(17,null,t,a)),!1)}function o(t){if(!Array.isArray(t))return!1;for(let n=0,a=t.length;n<a;n++)if(typeof t[n]!="string")return!1;return!0}}),define(Ce[69],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=void 0;class E{constructor(I,F=[],R=!1){this.ctor=I,this.staticArguments=F,this.supportsDelayedInstantiation=R}}e.$Zh=E}),define(Ce[70],Re([1,0,69]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mr=e.$Lr=e.InstantiationType=void 0;const T=[];var I;(function($){$[$.Eager=0]="Eager",$[$.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function F($,g,w){g instanceof E.$Zh||(g=new E.$Zh(g,[],!!w)),T.push([$,g])}e.$Lr=F;function R(){return T}e.$Mr=R}),define(Ce[183],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=void 0;class E{constructor(F,R){this.key=F,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$qq=E;class T{constructor(F){this.b=F,this.a=new Map}roots(){const F=[];for(const R of this.a.values())R.outgoing.size===0&&F.push(R);return F}insertEdge(F,R){const $=this.lookupOrInsertNode(F),g=this.lookupOrInsertNode(R);$.outgoing.set(g.key,g),g.incoming.set($.key,$)}removeNode(F){const R=this.b(F);this.a.delete(R);for(const $ of this.a.values())$.outgoing.delete(R),$.incoming.delete(R)}lookupOrInsertNode(F){const R=this.b(F);let $=this.a.get(R);return $||($=new E(R,F),this.a.set(R,$)),$}lookup(F){return this.a.get(this.b(F))}isEmpty(){return this.a.size===0}toString(){const F=[];for(const[R,$]of this.a)F.push(`${R}
	(-> incoming)[${[...$.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...$.outgoing.keys()].join(",")}]
`);return F.join(`
`)}findCycleSlow(){for(const[F,R]of this.a){const $=new Set([F]),g=this.c(R,$);if(g)return g}}c(F,R){for(const[$,g]of F.outgoing){if(R.has($))return[...R,$].join(" -> ");R.add($);const w=this.c(g,R);if(w)return w;R.delete($)}}}e.$rq=T}),define(Ce[4],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=e.$2h=e._util=void 0;var E;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function $(g){return g[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=$})(E||(e._util=E={})),e.$2h=I("instantiationService");function T(R,$,g){$[E.DI_TARGET]===$?$[E.DI_DEPENDENCIES].push({id:R,index:g}):($[E.DI_DEPENDENCIES]=[{id:R,index:g}],$[E.DI_TARGET]=$)}function I(R){if(E.serviceIds.has(R))return E.serviceIds.get(R);const $=function(g,w,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T($,g,A)};return $.toString=()=>R,E.serviceIds.set(R,$),$}e.$3h=I;function F(R){return R}e.$4h=F}),define(Ce[41],Re([1,0,16,2,4]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.ConfigurationTarget=e.$yi=e.$xi=e.$wi=void 0,e.$wi=(0,I.$3h)("configurationService");function F(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof T.URI)}e.$xi=F;function R(t){return t&&typeof t=="object"&&(!t.overrideIdentifiers||Array.isArray(t.overrideIdentifiers))&&!t.overrideIdentifier&&(!t.resource||t.resource instanceof T.URI)}e.$yi=R;var $;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.USER=2]="USER",t[t.USER_LOCAL=3]="USER_LOCAL",t[t.USER_REMOTE=4]="USER_REMOTE",t[t.WORKSPACE=5]="WORKSPACE",t[t.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",t[t.DEFAULT=7]="DEFAULT",t[t.MEMORY=8]="MEMORY"})($||(e.ConfigurationTarget=$={}));function g(t){switch(t){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$zi=g;function w(t){return t.applicationValue!==void 0||t.userValue!==void 0||t.userLocalValue!==void 0||t.userRemoteValue!==void 0||t.workspaceValue!==void 0||t.workspaceFolderValue!==void 0}e.$Ai=w;function A(t,n){const a=Object.create(null);for(const c in t)D(a,c,t[c],n);return a}e.$Bi=A;function D(t,n,a,c){const h=n.split("."),i=h.pop();let s=t;for(let u=0;u<h.length;u++){const d=h[u];let m=s[d];switch(typeof m){case"undefined":m=s[d]=Object.create(null);break;case"object":break;default:c(`Ignoring ${n} as ${h.slice(0,u+1).join(".")} is ${JSON.stringify(m)}`);return}s=m}if(typeof s=="object"&&s!==null)try{s[i]=a}catch{c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(s)}`)}else c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(s)}`)}e.$Ci=D;function l(t,n){const a=n.split(".");p(t,a)}e.$Di=l;function p(t,n){const a=n.shift();if(n.length===0){delete t[a];return}if(Object.keys(t).indexOf(a)!==-1){const c=t[a];typeof c=="object"&&!Array.isArray(c)&&(p(c,n),Object.keys(c).length===0&&delete t[a])}}function b(t,n,a){function c(s,u){let d=s;for(const m of u){if(typeof d!="object"||d===null)return;d=d[m]}return d}const h=n.split("."),i=c(t,h);return typeof i>"u"?a:i}e.$Ei=b;function r(t,n,a){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in t?E.$Hf(t[c])&&E.$Hf(n[c])?r(t[c],n[c],a):a&&(t[c]=n[c]):t[c]=n[c])})}e.$Fi=r;function o(t){return t.replace(/[\[\]]/g,"")}e.$Gi=o}),define(Ce[35],Re([1,0,21,11,181,4,149,15]),function(ge,e,E,T,I,F,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.ContextKeyExprType=e.$Yi=void 0;const g=new Map;g.set("false",!1),g.set("true",!0),g.set("isMac",E.$j),g.set("isLinux",E.$k),g.set("isWindows",E.$i),g.set("isWeb",E.$o),g.set("isMacNative",E.$j&&!E.$o),g.set("isEdge",E.$H),g.set("isFirefox",E.$F),g.set("isChrome",E.$E),g.set("isSafari",E.$G);function w(_,V){if(g.get(_)!==void 0)throw(0,$.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");g.set(_,V)}e.$Yi=w;const A=Object.prototype.hasOwnProperty;var D;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const l={regexParsingWithErrorRecovery:!0},p=(0,R.localize)(0,null),b=(0,R.localize)(1,null),r=(0,R.localize)(2,null),o=(0,R.localize)(3,null),t=(0,R.localize)(4,null),n=(0,R.localize)(5,null),a=(0,R.localize)(6,null),c=(0,R.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=l){this.k=V,this.d=new I.$Xi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:b});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const Ie=this.D(),Ae=Ie.type===17?n:void 0;throw this.h.push({message:t,offset:Ie.offset,lexeme:I.$Xi.getLexeme(Ie),additionalInfo:Ae}),h.c}return ne}catch(ne){if(ne!==h.c)throw ne;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(16);){const ne=this.o();V.push(ne)}return V.length===1?V[0]:i.or(...V)}o(){const V=[this.s()];for(;this.y(15);){const ne=this.s();V.push(ne)}return V.length===1?V[0]:i.and(...V)}s(){if(this.y(2)){const V=this.D();switch(V.type){case 11:return this.z(),m.INSTANCE;case 12:return this.z(),f.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,o),ne?.negate()}case 17:return this.z(),N.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const ne=this.l();return this.A(1,o),ne}case 17:{const ne=V.lexeme;if(this.z(),this.y(9)){const Ae=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Ae.type!==10)throw this.B("REGEX",Ae);const Pe=Ae.lexeme,ce=Pe.lastIndexOf("/"),ie=ce===Pe.length-1?void 0:this.w(Pe.substring(ce+1));let Q;try{Q=new RegExp(Pe.substring(1,ce),ie)}catch{throw this.B("REGEX",Ae)}return C.create(ne,Q)}switch(Ae.type){case 10:case 19:{const Pe=[Ae.lexeme];this.z();let ce=this.D(),ie=0;for(let Fe=0;Fe<Ae.lexeme.length;Fe++)Ae.lexeme.charCodeAt(Fe)===40?ie++:Ae.lexeme.charCodeAt(Fe)===41&&ie--;for(;!this.E()&&ce.type!==15&&ce.type!==16;){switch(ce.type){case 0:ie++;break;case 1:ie--;break;case 10:case 18:for(let Fe=0;Fe<ce.lexeme.length;Fe++)ce.lexeme.charCodeAt(Fe)===40?ie++:Ae.lexeme.charCodeAt(Fe)===41&&ie--}if(ie<0)break;Pe.push(I.$Xi.getLexeme(ce)),this.z(),ce=this.D()}const Q=Pe.join(""),te=Q.lastIndexOf("/"),me=te===Q.length-1?void 0:this.w(Q.substring(te+1));let pe;try{pe=new RegExp(Q.substring(1,te),me)}catch{throw this.B("REGEX",Ae)}return i.regex(ne,pe)}case 18:{const Pe=Ae.lexeme;this.z();let ce=null;if(!(0,T.$Ge)(Pe)){const ie=Pe.indexOf("/"),Q=Pe.lastIndexOf("/");if(ie!==Q&&ie>=0){const te=Pe.slice(ie+1,Q),me=Pe[Q+1]==="i"?"i":"";try{ce=new RegExp(te,me)}catch{throw this.B("REGEX",Ae)}}}if(ce===null)throw this.B("REGEX",Ae);return C.create(ne,ce)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,r);const Ae=this.u();return i.notIn(ne,Ae)}switch(this.D().type){case 3:{this.z();const Ae=this.u();if(this.x().type===18)return i.equals(ne,Ae);switch(Ae){case"true":return i.has(ne);case"false":return i.not(ne);default:return i.equals(ne,Ae)}}case 4:{this.z();const Ae=this.u();if(this.x().type===18)return i.notEquals(ne,Ae);switch(Ae){case"true":return i.not(ne);case"false":return i.has(ne);default:return i.notEquals(ne,Ae)}}case 5:return this.z(),W.create(ne,this.u());case 6:return this.z(),P.create(ne,this.u());case 7:return this.z(),K.create(ne,this.u());case 8:return this.z(),j.create(ne,this.u());case 13:return this.z(),i.in(ne,this.u());default:return i.has(ne)}}case 20:throw this.h.push({message:a,offset:V.offset,lexeme:"",additionalInfo:c}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case 17:case 18:return this.z(),V.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,ne){if(this.C(V))return this.z();throw this.B(ne,this.D())}B(V,ne,Ie){const Ae=(0,R.localize)(8,null,V,I.$Xi.getLexeme(ne)),Pe=ne.offset,ce=I.$Xi.getLexeme(ne);return this.h.push({message:Ae,offset:Pe,lexeme:ce,additionalInfo:Ie}),h.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Zi=h;class i{static false(){return m.INSTANCE}static true(){return f.INSTANCE}static has(V){return S.create(V)}static equals(V,ne){return L.create(V,ne)}static notEquals(V,ne){return k.create(V,ne)}static regex(V,ne){return C.create(V,ne)}static in(V,ne){return v.create(V,ne)}static notIn(V,ne){return y.create(V,ne)}static not(V){return N.create(V)}static and(...V){return fe.create(V,null,!0)}static or(...V){return be.create(V,null,!0)}static greater(V,ne){return K.create(V,ne)}static greaterEquals(V,ne){return j.create(V,ne)}static smaller(V,ne){return W.create(V,ne)}static smallerEquals(V,ne){return P.create(V,ne)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$1i=i;function s(_){const V=new h({regexParsingWithErrorRecovery:!1});return _.map(ne=>(V.parse(ne),V.lexingErrors.length>0?V.lexingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?(0,R.localize)(9,null,Ie.additionalInfo):(0,R.localize)(10,null),offset:Ie.offset,length:Ie.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?`${Ie.message}. ${Ie.additionalInfo}`:Ie.message,offset:Ie.offset,length:Ie.lexeme.length})):[]))}e.$2i=s;function u(_,V){const ne=_?_.substituteConstants():void 0,Ie=V?V.substituteConstants():void 0;return!ne&&!Ie?!0:!ne||!Ie?!1:ne.equals(Ie)}e.$3i=u;function d(_,V){return _.cmp(V)}class m{static{this.INSTANCE=new m}constructor(){this.type=0}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return f.INSTANCE}}e.$4i=m;class f{static{this.INSTANCE=new f}constructor(){this.type=1}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return m.INSTANCE}}e.$5i=f;class S{static create(V,ne=null){const Ie=g.get(V);return typeof Ie=="boolean"?Ie?f.INSTANCE:m.INSTANCE:new S(V,ne)}constructor(V,ne){this.key=V,this.c=ne,this.type=2}cmp(V){return V.type!==this.type?this.type-V.type:he(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=g.get(this.key);return typeof V=="boolean"?V?f.INSTANCE:m.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=N.create(this.key,this)),this.c}}e.$6i=S;class L{static create(V,ne,Ie=null){if(typeof ne=="boolean")return ne?S.create(V,Ie):N.create(V,Ie);const Ae=g.get(V);return typeof Ae=="boolean"?ne===(Ae?"true":"false")?f.INSTANCE:m.INSTANCE:new L(V,ne,Ie)}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=4}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=g.get(this.c);if(typeof V=="boolean"){const ne=V?"true":"false";return this.d===ne?f.INSTANCE:m.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$7i=L;class v{static create(V,ne){return new v(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=10,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const ne=V.getValue(this.f),Ie=V.getValue(this.d);return Array.isArray(ne)?ne.includes(Ie):typeof Ie=="string"&&typeof ne=="object"&&ne!==null?A.call(ne,Ie):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=y.create(this.d,this.f)),this.c}}e.$8i=v;class y{static create(V,ne){return new y(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=11,this.c=v.create(V,ne)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$9i=y;class k{static create(V,ne,Ie=null){if(typeof ne=="boolean")return ne?N.create(V,Ie):S.create(V,Ie);const Ae=g.get(V);return typeof Ae=="boolean"?ne===(Ae?"true":"false")?m.INSTANCE:f.INSTANCE:new k(V,ne,Ie)}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=5}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=g.get(this.c);if(typeof V=="boolean"){const ne=V?"true":"false";return this.d===ne?m.INSTANCE:f.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$0i=k;class N{static create(V,ne=null){const Ie=g.get(V);return typeof Ie=="boolean"?Ie?m.INSTANCE:f.INSTANCE:new N(V,ne)}constructor(V,ne){this.c=V,this.d=ne,this.type=3}cmp(V){return V.type!==this.type?this.type-V.type:he(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=g.get(this.c);return typeof V=="boolean"?V?m.INSTANCE:f.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=S.create(this.c,this)),this.d}}e.$$i=N;function O(_,V){if(typeof _=="string"){const ne=parseFloat(_);isNaN(ne)||(_=ne)}return typeof _=="string"||typeof _=="number"?V(_):m.INSTANCE}class K{static create(V,ne,Ie=null){return O(ne,Ae=>new K(V,Ae,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=12}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$_i=K;class j{static create(V,ne,Ie=null){return O(ne,Ae=>new j(V,Ae,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=13}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$aj=j;class W{static create(V,ne,Ie=null){return O(ne,Ae=>new W(V,Ae,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=14}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$bj=W;class P{static create(V,ne,Ie=null){return O(ne,Ae=>new P(V,Ae,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=15}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$cj=P;class C{static create(V,ne){return new C(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=7,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const ne=this.f?this.f.source:"",Ie=V.f?V.f.source:"";return ne<Ie?-1:ne>Ie?1:0}equals(V){if(V.type===this.type){const ne=this.f?this.f.source:"",Ie=V.f?V.f.source:"";return this.d===V.d&&ne===Ie}return!1}substituteConstants(){return this}evaluate(V){const ne=V.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=J.create(this)),this.c}}e.$dj=C;class J{static create(V){return new J(V)}constructor(V){this.c=V,this.type=8}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new J(this.c.map(V))}negate(){return this.c}}e.$ej=J;function ae(_){let V=null;for(let ne=0,Ie=_.length;ne<Ie;ne++){const Ae=_[ne].substituteConstants();if(_[ne]!==Ae&&V===null){V=[];for(let Pe=0;Pe<ne;Pe++)V[Pe]=_[Pe]}V!==null&&(V[ne]=Ae)}return V===null?_:V}class fe{static create(V,ne,Ie){return fe.d(V,ne,Ie)}constructor(V,ne){this.expr=V,this.c=ne,this.type=6}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++){const Ae=d(this.expr[ne],V.expr[ne]);if(Ae!==0)return Ae}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].equals(V.expr[ne]))return!1;return!0}return!1}substituteConstants(){const V=ae(this.expr);return V===this.expr?this:fe.create(V,this.c,!1)}evaluate(V){for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].evaluate(V))return!1;return!0}static d(V,ne,Ie){const Ae=[];let Pe=!1;for(const ce of V)if(ce){if(ce.type===1){Pe=!0;continue}if(ce.type===0)return m.INSTANCE;if(ce.type===6){Ae.push(...ce.expr);continue}Ae.push(ce)}if(Ae.length===0&&Pe)return f.INSTANCE;if(Ae.length!==0){if(Ae.length===1)return Ae[0];Ae.sort(d);for(let ce=1;ce<Ae.length;ce++)Ae[ce-1].equals(Ae[ce])&&(Ae.splice(ce,1),ce--);if(Ae.length===1)return Ae[0];for(;Ae.length>1;){const ce=Ae[Ae.length-1];if(ce.type!==9)break;Ae.pop();const ie=Ae.pop(),Q=Ae.length===0,te=be.create(ce.expr.map(me=>fe.create([me,ie],null,Ie)),null,Q);te&&(Ae.push(te),Ae.sort(d))}if(Ae.length===1)return Ae[0];if(Ie){for(let ce=0;ce<Ae.length;ce++)for(let ie=ce+1;ie<Ae.length;ie++)if(Ae[ce].negate().equals(Ae[ie]))return m.INSTANCE;if(Ae.length===1)return Ae[0]}return new fe(Ae,ne)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const ne of this.expr)V.push(...ne.keys());return V}map(V){return new fe(this.expr.map(ne=>ne.map(V)),null)}negate(){if(!this.c){const V=[];for(const ne of this.expr)V.push(ne.negate());this.c=be.create(V,this,!0)}return this.c}}e.$fj=fe;class be{static create(V,ne,Ie){return be.d(V,ne,Ie)}constructor(V,ne){this.expr=V,this.c=ne,this.type=9}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++){const Ae=d(this.expr[ne],V.expr[ne]);if(Ae!==0)return Ae}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].equals(V.expr[ne]))return!1;return!0}return!1}substituteConstants(){const V=ae(this.expr);return V===this.expr?this:be.create(V,this.c,!1)}evaluate(V){for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(this.expr[ne].evaluate(V))return!0;return!1}static d(V,ne,Ie){let Ae=[],Pe=!1;if(V){for(let ce=0,ie=V.length;ce<ie;ce++){const Q=V[ce];if(Q){if(Q.type===0){Pe=!0;continue}if(Q.type===1)return f.INSTANCE;if(Q.type===9){Ae=Ae.concat(Q.expr);continue}Ae.push(Q)}}if(Ae.length===0&&Pe)return m.INSTANCE;Ae.sort(d)}if(Ae.length!==0){if(Ae.length===1)return Ae[0];for(let ce=1;ce<Ae.length;ce++)Ae[ce-1].equals(Ae[ce])&&(Ae.splice(ce,1),ce--);if(Ae.length===1)return Ae[0];if(Ie){for(let ce=0;ce<Ae.length;ce++)for(let ie=ce+1;ie<Ae.length;ie++)if(Ae[ce].negate().equals(Ae[ie]))return f.INSTANCE;if(Ae.length===1)return Ae[0]}return new be(Ae,ne)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const ne of this.expr)V.push(...ne.keys());return V}map(V){return new be(this.expr.map(ne=>ne.map(V)),null)}negate(){if(!this.c){const V=[];for(const ne of this.expr)V.push(ne.negate());for(;V.length>1;){const ne=V.shift(),Ie=V.shift(),Ae=[];for(const Pe of se(ne))for(const ce of se(Ie))Ae.push(fe.create([Pe,ce],null,!1));V.unshift(be.create(Ae,null,!1))}this.c=be.create(V,this,!0)}return this.c}}e.$gj=be;class ye extends S{static{this.d=[]}static all(){return ye.d.values()}constructor(V,ne,Ie){super(V,null),this.f=ne,typeof Ie=="object"?ye.d.push({...Ie,key:V}):Ie!==!0&&ye.d.push({key:V,description:Ie,type:ne!=null?typeof ne:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return L.create(this.key,V)}notEqualsTo(V){return k.create(this.key,V)}}e.$hj=ye,e.$ij=(0,F.$3h)("contextKeyService");function he(_,V){return _<V?-1:_>V?1:0}function ve(_,V,ne,Ie){return _<ne?-1:_>ne?1:V<Ie?-1:V>Ie?1:0}function ee(_,V){if(_.type===0||V.type===1)return!0;if(_.type===9)return V.type===9?ke(_.expr,V.expr):!1;if(V.type===9){for(const ne of V.expr)if(ee(_,ne))return!0;return!1}if(_.type===6){if(V.type===6)return ke(V.expr,_.expr);for(const ne of _.expr)if(ee(ne,V))return!0;return!1}return _.equals(V)}e.$jj=ee;function ke(_,V){let ne=0,Ie=0;for(;ne<_.length&&Ie<V.length;){const Ae=_[ne].cmp(V[Ie]);if(Ae<0)return!1;Ae===0&&ne++,Ie++}return ne===_.length}function se(_){return _.type===9?_.expr:[_]}}),define(Ce[184],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=e.$0h=void 0,e.$0h=(0,E.$3h)("environmentService"),e.$$h=(0,E.$4h)(e.$0h)}),define(Ce[97],Re([1,0,151,4]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$mo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=void 0,e.$ao="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$bo=new RegExp(e.$ao),e.$co="__web_extension",e.$do="skipWalkthrough",e.$eo="extensionsSync",e.$fo="dependecyOrPackExtensionInstall";function I(t){switch(t){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$go=I;function F(t){switch(t){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$ho=F;function R(t,n){switch(t){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$io=R;function $(t,n){return n==="web"&&!t.includes("web")}e.$jo=$;function g(t,n,a){return $(n,a)?!1:t==="undefined"||t==="universal"?!0:t==="unknown"?!1:t===a}e.$ko=g;function w(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.$lo=w;var A;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var D;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(D||(e.SortOrder=D={}));var l;(function(t){t.Install="install",t.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var p;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.$mo=(0,T.$3h)("extensionGalleryService");var b;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.Extract="Extract",t.Delete="Delete",t.Rename="Rename",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));var r;(function(t){t.UnknownError="UnknownError",t.PackageIsInvalidZip="PackageIsInvalidZip",t.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(r||(e.ExtensionSignaturetErrorCode=r={}));class o extends Error{constructor(n,a){super(n),this.code=a,this.name=a}}e.$no=o,e.$oo=(0,T.$3h)("extensionManagementService"),e.$po="extensionsIdentifiers/disabled",e.$qo="extensionsIdentifiers/enabled",e.$ro=(0,T.$3h)("IGlobalExtensionEnablementService"),e.$so=(0,T.$3h)("IExtensionTipsService"),e.$to=(0,E.localize)(0,null),e.$uo={value:e.$to,original:"Extensions"},e.$vo={value:(0,E.localize)(1,null),original:"Preferences"}}),define(Ce[42],Re([1,0,50,19,11,16,2,153,4,21,12,39]),function(ge,e,E,T,I,F,R,$,g,w,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.FileKind=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.FileOperationResult=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.FileChangeType=e.$Fk=e.FileOperation=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.FileSystemProviderErrorCode=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.FileSystemProviderCapabilities=e.$pk=e.FilePermission=e.FileType=e.$ok=e.$nk=void 0,e.$nk=(0,g.$3h)("fileService");function l(ee){return ee.create===!0}e.$ok=l;var p;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var b;(function(ee){ee[ee.Readonly=1]="Readonly",ee[ee.Locked=2]="Locked"})(b||(e.FilePermission=b={}));function r(ee){const ke=ee;return!!ke&&typeof ke.onDidChange=="function"}e.$pk=r;var o;(function(ee){ee[ee.None=0]="None",ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileAtomicWrite=32768]="FileAtomicWrite",ee[ee.FileAtomicDelete=65536]="FileAtomicDelete",ee[ee.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function t(ee){return!!(ee.capabilities&2)}e.$qk=t;function n(ee){return!!(ee.capabilities&8)}e.$rk=n;function a(ee){return!!(ee.capabilities&131072)}e.$sk=a;function c(ee){return!!(ee.capabilities&4)}e.$tk=c;function h(ee){return!!(ee.capabilities&16)}e.$uk=h;function i(ee){return t(ee)?!!(ee.capabilities&16384):!1}e.$vk=i;function s(ee){return t(ee)?!!(ee.capabilities&32768):!1}e.$wk=s;function u(ee){return!!(ee.capabilities&65536)}e.$xk=u;function d(ee){return!!(ee.capabilities&2048)}e.$yk=d;var m;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsStorageQuota="EntryExceedsStorageQuota",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(m||(e.FileSystemProviderErrorCode=m={}));class f extends Error{static create(ke,se){const _=new f(ke.toString(),se);return v(_,se),_}constructor(ke,se){super(ke),this.code=se}}e.$zk=f;function S(ee,ke){return f.create(ee,ke)}e.$Ak=S;function L(ee){return ee||S((0,$.localize)(0,null),m.Unknown)}e.$Bk=L;function v(ee,ke){return ee.name=ke?`${ke} (FileSystemError)`:"FileSystemError",ee}e.$Ck=v;function y(ee){if(!ee)return m.Unknown;if(ee instanceof f)return ee.code;const ke=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!ke)return m.Unknown;switch(ke[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.$Dk=y;function k(ee){if(ee instanceof P)return ee.fileOperationResult;switch(y(ee)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 9;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileTooLarge:return 7;default:return 10}}e.$Ek=k;var N;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(N||(e.FileOperation=N={}));class O{constructor(ke,se,_){this.resource=ke,this.operation=se,this.target=_}isOperation(ke){return this.operation===ke}}e.$Fk=O;var K;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(K||(e.FileChangeType=K={}));class j{static{this.a=null}constructor(ke,se){this.c=se,this.b=void 0,this.d=new D.$V(()=>{const _=E.$9h.forUris(()=>this.c);return _.fill(this.rawAdded.map(V=>[V,!0])),_}),this.f=new D.$V(()=>{const _=E.$9h.forUris(()=>this.c);return _.fill(this.rawUpdated.map(V=>[V,!0])),_}),this.g=new D.$V(()=>{const _=E.$9h.forUris(()=>this.c);return _.fill(this.rawDeleted.map(V=>[V,!0])),_}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const _ of ke){switch(_.type){case 1:this.rawAdded.push(_.resource);break;case 0:this.rawUpdated.push(_.resource);break;case 2:this.rawDeleted.push(_.resource);break}this.b!==j.a&&(typeof _.cId=="number"?this.b===void 0?this.b=_.cId:this.b!==_.cId&&(this.b=j.a):this.b!==void 0&&(this.b=j.a))}}contains(ke,...se){return this.h(ke,{includeChildren:!1},...se)}affects(ke,...se){return this.h(ke,{includeChildren:!0},...se)}h(ke,se,..._){if(!ke)return!1;const V=_.length>0;return!!((!V||_.includes(1))&&(this.d.value.get(ke)||se.includeChildren&&this.d.value.findSuperstr(ke))||(!V||_.includes(0))&&(this.f.value.get(ke)||se.includeChildren&&this.f.value.findSuperstr(ke))||(!V||_.includes(2))&&(this.g.value.findSubstr(ke)||se.includeChildren&&this.g.value.findSuperstr(ke)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ke){return this.b===ke}hasCorrelation(){return typeof this.b=="number"}}e.$Gk=j;function W(ee,ke,se){return!ee||!ke||ee===ke||ke.length>ee.length?!1:(ke.charAt(ke.length-1)!==T.sep&&(ke+=T.sep),se?(0,I.$0e)(ee,ke):ee.indexOf(ke)===0)}e.$Hk=W;class P extends Error{constructor(ke,se,_){super(ke),this.fileOperationResult=se,this.options=_}}e.$Ik=P;class C extends P{constructor(ke,se,_,V){super(ke,se,V),this.fileOperationResult=se,this.size=_}}e.$Jk=C;class J extends P{constructor(ke,se,_){super(ke,2,_),this.stat=se}}e.$Kk=J;var ae;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.$Lk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Mk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Nk="files.associations",e.$Ok="files.exclude",e.$Pk="files.readonlyInclude",e.$Qk="files.readonlyExclude",e.$Rk="files.readonlyFromPermissions";var fe;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})(fe||(e.FileKind=fe={})),e.$Sk="";function be(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}e.$Tk=be;async function ye(ee,ke){if(!ke.hasProvider(R.URI.from({scheme:ee.scheme})))return new Promise(se=>{const _=ke.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===ee.scheme&&V.added&&(_.dispose(),se())})})}e.$Uk=ye;class he{static{this.KB=1024}static{this.MB=he.KB*he.KB}static{this.GB=he.MB*he.KB}static{this.TB=he.GB*he.KB}static formatSize(ke){return(0,F.$Jf)(ke)||(ke=0),ke<he.KB?(0,$.localize)(1,null,ke.toFixed(0)):ke<he.MB?(0,$.localize)(2,null,(ke/he.KB).toFixed(2)):ke<he.GB?(0,$.localize)(3,null,(ke/he.MB).toFixed(2)):ke<he.TB?(0,$.localize)(4,null,(ke/he.GB).toFixed(2)):(0,$.localize)(5,null,(ke/he.TB).toFixed(2))}}e.$Vk=he;function ve(ee){const ke=typeof ee=="string"||ee?.scheme===A.Schemas.vscodeRemote;return typeof ee!="string"&&ee?.scheme===A.Schemas.file?1024*he.MB:ke?10*he.MB:w.$o?50*he.MB:1024*he.MB}e.$Wk=ve}),define(Ce[71],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=void 0;class E{constructor(...I){this.a=new Map;for(const[F,R]of I)this.set(F,R)}set(I,F){const R=this.a.get(I);return this.a.set(I,F),R}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$1h=E}),define(Ce[185],Re([1,0,13,15,6,69,183,4,71,186]),function(ge,e,E,T,I,F,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=void 0;const A=!1;class D extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class l{constructor(o=new g.$1h,t=!1,n,a=A){this.f=o,this.g=t,this.h=n,this.i=a,this.o=new Set,this.f.set($.$2h,this),this._globalGraph=a?n?._globalGraph??new R.$rq(c=>c):void 0}createChild(o){return new l(o,this.g,this,this.i)}invokeFunction(o,...t){const n=b.traceInvocation(this.i,o);let a=!1;try{return o({get:h=>{if(a)throw(0,T.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(h,n);if(!i)throw new Error(`[invokeFunction] unknown service '${h}'`);return i}},...t)}finally{a=!0,n.stop()}}createInstance(o,...t){let n,a;return o instanceof F.$Zh?(n=b.traceCreation(this.i,o.ctor),a=this.j(o.ctor,o.staticArguments.concat(t),n)):(n=b.traceCreation(this.i,o),a=this.j(o,t,n)),n.stop(),a}j(o,t=[],n){const a=$._util.getServiceDependencies(o).sort((i,s)=>i.index-s.index),c=[];for(const i of a){const s=this.m(i.id,n);s||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(s)}const h=a.length>0?a[0].index:t.length;if(t.length!==h){console.trace(`[createInstance] First service dependency of ${o.name} at position ${h+1} conflicts with ${t.length} static arguments`);const i=h-t.length;i>0?t=t.concat(new Array(i)):t=t.slice(0,h)}return Reflect.construct(o,t.concat(c))}k(o,t){if(this.f.get(o)instanceof F.$Zh)this.f.set(o,t);else if(this.h)this.h.k(o,t);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const t=this.f.get(o);return!t&&this.h?this.h.l(o):t}m(o,t){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const n=this.l(o);return n instanceof F.$Zh?this.q(o,n,t.branch(o,!0)):(t.branch(o,!1),n)}q(o,t,n){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,t,n)}finally{this.o.delete(o)}}r(o,t,n){const a=new R.$rq(i=>i.id.toString());let c=0;const h=[{id:o,desc:t,_trace:n}];for(;h.length;){const i=h.pop();if(a.lookupOrInsertNode(i),c++>1e3)throw new D(a);for(const s of $._util.getServiceDependencies(i.desc.ctor)){const u=this.l(s.id);if(u||this.u(`[createInstance] ${o} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(s.id)),u instanceof F.$Zh){const d={id:s.id,desc:u,_trace:i._trace.branch(s.id,!0)};a.insertEdge(i,d),h.push(d)}}}for(;;){const i=a.roots();if(i.length===0){if(!a.isEmpty())throw new D(a);break}for(const{data:s}of i){if(this.l(s.id)instanceof F.$Zh){const d=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,d)}a.removeNode(s)}}return this.l(o)}s(o,t,n=[],a,c){if(this.f.get(o)instanceof F.$Zh)return this.t(o,t,n,a,c);if(this.h)return this.h.s(o,t,n,a,c);throw new Error(`illegalState - creating UNKNOWN service instance ${t.name}`)}t(o,t,n=[],a,c){if(a){const h=new l(void 0,this.g,this,this.i);h.c=String(o);const i=new Map,s=new E.$jh(()=>{const u=h.j(t,n,c);for(const[d,m]of i){const f=u[d];if(typeof f=="function")for(const S of m)f.apply(u,S)}return i.clear(),u});return new Proxy(Object.create(null),{get(u,d){if(!s.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let S=i.get(d);return S||(S=new w.$3c,i.set(d,S)),(v,y,k)=>{const N=S.push([v,y,k]);return(0,I.$Qc)(N)}}if(d in u)return u[d];const m=s.value;let f=m[d];return typeof f!="function"||(f=f.bind(m),u[d]=f),f},set(u,d,m){return s.value[d]=m,!0},getPrototypeOf(u){return t.prototype}})}else return this.j(t,n,c)}u(o,t){if(t&&console.warn(o),this.g)throw new Error(o)}}e.$sq=l;var p;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(p||(p={}));class b{static{this.all=new Set}static{this.c=new class extends b{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,t){return o?new b(2,t.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):b.c}static traceCreation(o,t){return o?new b(1,t.name):b.c}static{this.f=0}constructor(o,t){this.type=o,this.name=t,this.g=Date.now(),this.h=[]}branch(o,t){const n=new b(3,o.toString());return this.h.push([o,t,n]),n}stop(){const o=Date.now()-this.g;b.f+=o;let t=!1;function n(c,h){const i=[],s=new Array(c+1).join("	");for(const[u,d,m]of h.h)if(d&&m){t=!0,i.push(`${s}CREATES -> ${u}`);const f=n(c+1,m);f&&i.push(f)}else i.push(`${s}uses -> ${u}`);return i.join(`
`)}const a=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${b.f.toFixed(2)}ms)`];(o>2||t)&&b.all.add(a.join(`
`))}}e.$tq=b}),define(Ce[14],Re([1,0,40,5,98,6,28,21,25,16,2,35,4]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.log=e.$nj=e.LogLevel=e.$mj=e.$lj=e.$kj=void 0,e.$kj=(0,l.$3h)("logService"),e.$lj=(0,l.$3h)("loggerService");function p(){return new Date().toISOString()}function b(v){return(0,w.$Jf)(v)}e.$mj=b;var r;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(r||(e.LogLevel=r={})),e.$nj=r.Info;function o(v,y,k){switch(y){case r.Trace:v.trace(k);break;case r.Debug:v.debug(k);break;case r.Info:v.info(k);break;case r.Warning:v.warn(k);break;case r.Error:v.error(k);break;case r.Off:break;default:throw new Error(`Invalid log level ${y}`)}}e.log=o;function t(v,y=!1){let k="";for(let N=0;N<v.length;N++){let O=v[N];if(O instanceof Error&&(O=(0,E.$Ni)(O,y)),typeof O=="object")try{O=JSON.stringify(O)}catch{}k+=(N>0?" ":"")+O}return k}class n extends F.$Sc{constructor(){super(...arguments),this.b=e.$nj,this.c=this.B(new T.$Sd),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==r.Off&&this.b<=y}}e.$pj=n;class a extends n{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...k){this.f(r.Trace)&&this.g(r.Trace,t([y,...k],!0))}debug(y,...k){this.f(r.Debug)&&this.g(r.Debug,t([y,...k]))}info(y,...k){this.f(r.Info)&&this.g(r.Info,t([y,...k]))}warn(y,...k){this.f(r.Warning)&&this.g(r.Warning,t([y,...k]))}error(y,...k){if(this.f(r.Error))if(y instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=y.stack,this.g(r.Error,t(N))}else this.g(r.Error,t([y,...k]))}flush(){}}e.$qj=a;class c extends n{constructor(y=e.$nj){super(),this.setLevel(y),this.g=!$.$i}trace(y,...k){this.f(r.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,y,...k):console.log(`[main ${p()}]`,y,...k))}debug(y,...k){this.f(r.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,y,...k):console.log(`[main ${p()}]`,y,...k))}info(y,...k){this.f(r.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,y,...k):console.log(`[main ${p()}]`,y,...k))}warn(y,...k){this.f(r.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,y,...k):console.warn(`[main ${p()}]`,y,...k))}error(y,...k){this.f(r.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,y,...k):console.error(`[main ${p()}]`,y,...k))}flush(){}}e.$rj=c;class h extends n{constructor(y=e.$nj,k=!0){super(),this.g=k,this.setLevel(y)}trace(y,...k){this.f(r.Trace)&&(this.g?console.log("%cTRACE","color: #888",y,...k):console.log(y,...k))}debug(y,...k){this.f(r.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",y,...k):console.log(y,...k))}info(y,...k){this.f(r.Info)&&(this.g?console.log("%c INFO","color: #33f",y,...k):console.log(y,...k))}warn(y,...k){this.f(r.Warning)&&(this.g?console.log("%c WARN","color: #993",y,...k):console.log(y,...k))}error(y,...k){this.f(r.Error)&&(this.g?console.log("%c  ERR","color: #f33",y,...k):console.error(y,...k))}flush(){}}e.$sj=h;class i extends n{constructor(y,k=e.$nj){super(),this.g=y,this.setLevel(k)}trace(y,...k){this.f(r.Trace)&&this.g.log(r.Trace,[this.h(y),...k])}debug(y,...k){this.f(r.Debug)&&this.g.log(r.Debug,[this.h(y),...k])}info(y,...k){this.f(r.Info)&&this.g.log(r.Info,[this.h(y),...k])}warn(y,...k){this.f(r.Warning)&&this.g.log(r.Warning,[this.h(y),...k])}error(y,...k){this.f(r.Error)&&this.g.log(r.Error,[this.h(y),...k])}h(y){return typeof y=="string"?y:(0,E.$Ni)(y,this.f(r.Trace))}flush(){}}e.$tj=i;class s extends n{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const k of this.g)k.setLevel(y);super.setLevel(y)}trace(y,...k){for(const N of this.g)N.trace(y,...k)}debug(y,...k){for(const N of this.g)N.debug(y,...k)}info(y,...k){for(const N of this.g)N.info(y,...k)}warn(y,...k){for(const N of this.g)N.warn(y,...k)}error(y,...k){for(const N of this.g)N.error(y,...k)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose();super.dispose()}}e.$uj=s;class u extends F.$Sc{constructor(y,k,N){if(super(),this.h=y,this.j=k,this.b=new R.$Ac,this.c=this.B(new T.$Sd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$Sd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$Sd),this.onDidChangeVisibility=this.g.event,N)for(const O of N)this.b.set(O.resource,{logger:void 0,info:O})}m(y){return(0,w.$Ff)(y)?[...this.b.values()].find(k=>k.info.id===y):this.b.get(y)}getLogger(y){return this.m(y)?.logger}createLogger(y,k){const N=this.n(y),O=(0,w.$Ff)(y)?y:k?.id??(0,I.$Qi)(N.toString()).toString(16);let K=this.b.get(N)?.logger;const j=k?.logLevel==="always"?r.Trace:k?.logLevel;K||(K=this.s(N,j??this.getLogLevel(N)??this.h,{...k,id:O}));const W={logger:K,info:{resource:N,id:O,logLevel:j,name:k?.name,hidden:k?.hidden,extensionId:k?.extensionId,when:k?.when}};return this.registerLogger(W.info),this.b.set(N,W),K}n(y){return(0,w.$Ff)(y)?(0,g.$Eg)(this.j,`${y}.log`):y}setLogLevel(y,k){if(A.URI.isUri(y)){const N=y,O=k,K=this.b.get(N);K&&O!==K.info.logLevel&&(K.info.logLevel=O===this.h?void 0:O,K.logger?.setLevel(O),this.b.set(K.info.resource,K),this.f.fire([N,O]))}else{this.h=y;for(const[N,O]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&O.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,k){const N=this.m(y);N&&k!==!N.info.hidden&&(N.info.hidden=!k,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,k]))}getLogLevel(y){let k;return y&&(k=this.b.get(y)?.info.logLevel),k??this.h}registerLogger(y){const k=this.b.get(y.resource);k?k.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const k=this.b.get(y);k&&(k.logger&&k.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[k.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.$vj=u;class d{constructor(){this.onDidChangeLogLevel=new T.$Sd().event}setLevel(y){}getLevel(){return r.Info}trace(y,...k){}debug(y,...k){}info(y,...k){}warn(y,...k){}error(y,...k){}critical(y,...k){}dispose(){}flush(){}}e.$wj=d;class m extends d{}e.$xj=m;function f(v){if(v.verbose)return r.Trace;if(typeof v.logLevel=="string"){const y=L(v.logLevel.toLowerCase());if(y!==void 0)return y}return e.$nj}e.$yj=f;function S(v){switch(v){case r.Trace:return"trace";case r.Debug:return"debug";case r.Info:return"info";case r.Warning:return"warn";case r.Error:return"error";case r.Off:return"off"}}e.$zj=S;function L(v){switch(v){case"trace":return r.Trace;case"debug":return r.Debug;case"info":return r.Info;case"warn":return r.Warning;case"error":return r.Error;case"critical":return r.Error;case"off":return r.Off}}e.$Aj=L,e.$Bj=new D.$hj("logLevel",S(r.Info))}),define(Ce[187],Re([1,0,6,14]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fO=void 0;class I extends E.$Sc{constructor(R,$=[]){super(),this.a=new T.$uj([R,...$]),this.B(R.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...$){this.a.trace(R,...$)}debug(R,...$){this.a.debug(R,...$)}info(R,...$){this.a.info(R,...$)}warn(R,...$){this.a.warn(R,...$)}error(R,...$){this.a.error(R,...$)}flush(){this.a.flush()}}e.$fO=I}),define(Ce[99],Re([1,0,31,154,4]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ot=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var F;(function(g){g[g.Unnecessary=1]="Unnecessary",g[g.Deprecated=2]="Deprecated"})(F||(e.MarkerTag=F={}));var R;(function(g){g[g.Hint=1]="Hint",g[g.Info=2]="Info",g[g.Warning=4]="Warning",g[g.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(g){function w(b,r){return r-b}g.compare=w;const A=Object.create(null);A[g.Error]=(0,T.localize)(0,null),A[g.Warning]=(0,T.localize)(1,null),A[g.Info]=(0,T.localize)(2,null);function D(b){return A[b]||""}g.toString=D;function l(b){switch(b){case E.default.Error:return g.Error;case E.default.Warning:return g.Warning;case E.default.Info:return g.Info;case E.default.Ignore:return g.Hint}}g.fromSeverity=l;function p(b){switch(b){case g.Error:return E.default.Error;case g.Warning:return E.default.Warning;case g.Info:return E.default.Info;case g.Hint:return E.default.Ignore}}g.toSeverity=p}(R||(e.MarkerSeverity=R={}));var $;(function(g){const w="";function A(l){return D(l,!0)}g.makeKey=A;function D(l,p){const b=[w];return l.source?b.push(l.source.replace("\xA6","\\\xA6")):b.push(w),l.code?typeof l.code=="string"?b.push(l.code.replace("\xA6","\\\xA6")):b.push(l.code.value.replace("\xA6","\\\xA6")):b.push(w),l.severity!==void 0&&l.severity!==null?b.push(R.toString(l.severity)):b.push(w),l.message&&p?b.push(l.message.replace("\xA6","\\\xA6")):b.push(w),l.startLineNumber!==void 0&&l.startLineNumber!==null?b.push(l.startLineNumber.toString()):b.push(w),l.startColumn!==void 0&&l.startColumn!==null?b.push(l.startColumn.toString()):b.push(w),l.endLineNumber!==void 0&&l.endLineNumber!==null?b.push(l.endLineNumber.toString()):b.push(w),l.endColumn!==void 0&&l.endColumn!==null?b.push(l.endColumn.toString()):b.push(w),b.push(w),b.join("\xA6")}g.makeKeyOptionalMessage=D})($||(e.IMarkerData=$={})),e.$ot=(0,I.$3h)("markerService")}),define(Ce[188],Re([1,0,5,31,4]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fv=e.$ev=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$dv=e.Severity=void 0,e.Severity=T.default,e.$dv=(0,I.$3h)("notificationService");var F;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(F||(e.NotificationPriority=F={}));var R;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var $;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})($||(e.NotificationsFilter=$={}));class g{constructor(){this.progress=new w,this.onDidClose=E.Event.None,this.onDidChangeVisibility=E.Event.None}updateSeverity(D){}updateMessage(D){}updateActions(D){}close(){}}e.$ev=g;class w{infinite(){}done(){}total(D){}worked(D){}}e.$fv=w}),define(Ce[189],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dj=e.$Cj=void 0,e.$Cj=(0,E.$3h)("productService"),e.$Dj="vscode://schemas/vscode-product"});var Ge=this&&this.__decorate||function(ge,e,E,T){var I=arguments.length,F=I<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,E):T,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(ge,e,E,T);else for(var $=ge.length-1;$>=0;$--)(R=ge[$])&&(F=(I<3?R(F):I>3?R(e,E,F):R(e,E))||F);return I>3&&F&&Object.defineProperty(e,E,F),F},Ke=this&&this.__param||function(ge,e){return function(E,T){e(E,T,ge)}};define(Ce[72],Re([1,0,13,20,6,4]),function(ge,e,E,T,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.ProgressLocation=e.$gv=void 0,e.$gv=(0,F.$3h)("progressService");var R;(function(D){D[D.Explorer=1]="Explorer",D[D.Scm=3]="Scm",D[D.Extensions=5]="Extensions",D[D.Window=10]="Window",D[D.Notification=15]="Notification",D[D.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$hv=Object.freeze({total(){},worked(){},done(){}});class ${static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$iv=$;class g{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const p=this.d;this.d=()=>{p?.(),l()}}):Promise.resolve()}}e.$jv=g;let w=class extends I.$Sc{constructor(l,p){super(),this.a=new E.$nh,p.withProgress(l,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,I.$Qc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$kv=w,e.$kv=w=Ge([Ke(1,e.$gv)],w);class A extends I.$Sc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new I.$Rc)}start(l){this.stop();const p=++this.a,b=new T.$3d;return this.f=setTimeout(()=>{p===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,I.$Qc)(()=>clearTimeout(this.f))),this.b.add((0,I.$Qc)(()=>b.cancel())),this.b.add((0,I.$Qc)(()=>this.c?this.c.done():void 0)),{id:p,token:b.token,stop:()=>this.h(p),isCurrent:()=>this.a===p}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$lv=A,e.$mv=(0,F.$3h)("editorProgressService")}),define(Ce[30],Re([1,0,53,16]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=void 0;class I{constructor(){this.a=new Map}add(R,$){E.ok(T.$Ff(R)),E.ok(T.$Hf($)),E.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,$)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$vn=new I}),define(Ce[73],Re([1,0,5,30]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=void 0,e.$wn={JSONContribution:"base.contributions.json"};function I($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class F{constructor(){this.b=new E.$Sd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,w){this.a[I(g)]=w,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const R=new F;T.$vn.add(e.$wn.JSONContribution,R)}),define(Ce[54],Re([1,0,18,5,16,148,41,73,30]),function(ge,e,E,T,I,F,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.ConfigurationScope=e.$An=e.EditPresentationTypes=void 0;var w;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(w||(e.EditPresentationTypes=w={})),e.$An={Configuration:"base.contributions.configuration"};var A;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$Bn={properties:{},patternProperties:{}},e.$Cn={properties:{},patternProperties:{}},e.$Dn={properties:{},patternProperties:{}},e.$En={properties:{},patternProperties:{}},e.$Fn={properties:{},patternProperties:{}},e.$Gn={properties:{},patternProperties:{}},e.$Hn="vscode://schemas/settings/resourceLanguage",e.$In="vscode://schemas/settings/configurationDefaults";const D=g.$vn.as($.$wn.JSONContribution);class l{constructor(){this.h=new Set,this.i=new T.$Sd,this.onDidSchemaChange=this.i.event,this.j=new T.$Sd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:F.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$Hn,this.g),this.v()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const u=new Set;this.n(i,s,u),D.registerSchema(e.$Hn,this.g),this.i.fire(),this.j.fire({properties:u})}deregisterConfigurations(i){const s=new Set;this.o(i,s),D.registerSchema(e.$Hn,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:i,remove:s}){const u=new Set;this.o(s,u),this.n(i,!1,u),D.registerSchema(e.$Hn,this.g),this.i.fire(),this.j.fire({properties:u})}registerDefaultConfigurations(i){const s=new Set;this.k(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(i,s){const u=[];for(const{overrides:d,source:m}of i)for(const f in d)if(s.add(f),e.$Kn.test(f)){const S=this.a.get(f),L=S?.valuesSources??new Map;if(m)for(const N of Object.keys(d[f]))L.set(N,m);const v={...S?.value||{},...d[f]};this.a.set(f,{source:m,value:v,valuesSources:L});const y=(0,R.$Gi)(f),k={type:"object",default:v,description:F.localize(1,null,y),$ref:e.$Hn,defaultDefaultValue:v,source:I.$Ff(m)?void 0:m,defaultValueSource:m};u.push(...r(f)),this.d[f]=k,this.b.properties[f]=k}else{this.a.set(f,{value:d[f],source:m});const S=this.d[f];S&&(this.w(f,S),this.r(f,S))}this.m(u)}deregisterDefaultConfigurations(i){const s=new Set;this.l(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(i,s){for(const{overrides:u,source:d}of i)for(const m in u){const f=this.a.get(m),S=I.$Ff(d)?d:d?.id,L=I.$Ff(f?.source)?f?.source:f?.source?.id;if(S===L)if(s.add(m),this.a.delete(m),e.$Kn.test(m))delete this.d[m],delete this.b.properties[m];else{const v=this.d[m];v&&(this.w(m,v),this.r(m,v))}}this.u()}deltaConfiguration(i){let s=!1;const u=new Set;i.removedDefaults&&(this.l(i.removedDefaults,u),s=!0),i.addedDefaults&&(this.k(i.addedDefaults,u),s=!0),i.removedConfigurations&&this.o(i.removedConfigurations,u),i.addedConfigurations&&this.n(i.addedConfigurations,!1,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const s of i)this.h.add(s);this.u()}n(i,s,u){i.forEach(d=>{this.p(d,s,d.extensionInfo,d.restrictedProperties,void 0,u),this.c.push(d),this.q(d)})}o(i,s){const u=d=>{if(d.properties)for(const m in d.properties){s.add(m);const f=this.d[m];f?.policy?.name&&this.e.delete(f.policy.name),delete this.d[m],this.s(m,d.properties[m])}d.allOf?.forEach(m=>u(m))};for(const d of i){u(d);const m=this.c.indexOf(d);m!==-1&&this.c.splice(m,1)}}p(i,s=!0,u,d,m=3,f){m=I.$Of(i.scope)?m:i.scope;const S=i.properties;if(S)for(const v in S){const y=S[v];if(s&&a(v,y)){delete S[v];continue}if(y.source=u,y.defaultDefaultValue=S[v].default,this.w(v,y),e.$Kn.test(v)?y.scope=void 0:(y.scope=I.$Of(y.scope)?m:y.scope,y.restricted=I.$Of(y.restricted)?!!d?.includes(v):y.restricted),S[v].hasOwnProperty("included")&&!S[v].included){this.f[v]=S[v],delete S[v];continue}else this.d[v]=S[v],S[v].policy?.name&&this.e.set(S[v].policy.name,v);!S[v].deprecationMessage&&S[v].markdownDeprecationMessage&&(S[v].deprecationMessage=S[v].markdownDeprecationMessage),f.add(v)}const L=i.allOf;if(L)for(const v of L)this.p(v,s,u,d,m,f)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const s=u=>{const d=u.properties;if(d)for(const f in d)this.r(f,d[f]);u.allOf?.forEach(s)};s(i)}r(i,s){switch(e.$Bn.properties[i]=s,s.scope){case 1:e.$Cn.properties[i]=s;break;case 2:e.$Dn.properties[i]=s;break;case 6:e.$En.properties[i]=s;break;case 3:e.$Fn.properties[i]=s;break;case 4:e.$Gn.properties[i]=s;break;case 5:e.$Gn.properties[i]=s,this.g.properties[i]=s;break}}s(i,s){switch(delete e.$Bn.properties[i],s.scope){case 1:delete e.$Cn.properties[i];break;case 2:delete e.$Dn.properties[i];break;case 6:delete e.$En.properties[i];break;case 3:delete e.$Fn.properties[i];break;case 4:case 5:delete e.$Gn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const s=`[${i}]`,u={type:"object",description:F.localize(2,null),errorMessage:F.localize(3,null),$ref:e.$Hn};this.w(s,u),e.$Bn.properties[s]=u,e.$Cn.properties[s]=u,e.$Dn.properties[s]=u,e.$En.properties[s]=u,e.$Fn.properties[s]=u,e.$Gn.properties[s]=u}}v(){const i={type:"object",description:F.localize(4,null),errorMessage:F.localize(5,null),$ref:e.$Hn};e.$Bn.patternProperties[e.$Jn]=i,e.$Cn.patternProperties[e.$Jn]=i,e.$Dn.patternProperties[e.$Jn]=i,e.$En.patternProperties[e.$Jn]=i,e.$Fn.patternProperties[e.$Jn]=i,e.$Gn.patternProperties[e.$Jn]=i,this.i.fire()}w(i,s){const u=this.a.get(i);let d=u?.value,m=u?.source;I.$Mf(d)&&(d=s.defaultDefaultValue,m=void 0),I.$Mf(d)&&(d=t(s.type)),s.default=d,s.defaultValueSource=m}}const p="\\[([^\\]]+)\\]",b=new RegExp(p,"g");e.$Jn=`^(${p})+$`,e.$Kn=new RegExp(e.$Jn);function r(h){const i=[];if(e.$Kn.test(h)){let s=b.exec(h);for(;s?.length;){const u=s[1].trim();u&&i.push(u),s=b.exec(h)}}return(0,E.$Mb)(i)}e.$Ln=r;function o(h){return h.reduce((i,s)=>`${i}[${s}]`,"")}e.$Mn=o;function t(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Nn=t;const n=new l;g.$vn.add(e.$An.Configuration,n);function a(h,i){return h.trim()?e.$Kn.test(h)?F.localize(7,null,h):n.getConfigurationProperties()[h]!==void 0?F.localize(8,null,h):i.policy?.name&&n.getPolicyConfigurations().get(i.policy?.name)!==void 0?F.localize(9,null,h,i.policy?.name,n.getPolicyConfigurations().get(i.policy?.name)):null:F.localize(6,null)}e.$On=a;function c(){const h=[],i=n.getConfigurationProperties();for(const s of Object.keys(i))h.push([s,i[s].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$Pn=c}),define(Ce[190],Re([1,0,18,5,119,6,28,26,16,2,41,54,30]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=void 0;function p(s){return Object.isFrozen(s)?s:$.$kn(s)}class b{constructor(u={},d=[],m=[],f){this.b=u,this.c=d,this.d=m,this.raw=f,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const u=this.raw.map(d=>{if(d instanceof b)return d;const m=new r("");return m.parseRaw(d),m.configurationModel});this.f=u.reduce((d,m)=>m===d?m:d.merge(m),u[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(u){return u?(0,A.$Ei)(this.contents,u):this.contents}inspect(u,d){const m=this.rawConfiguration.getValue(u),f=d?this.rawConfiguration.getOverrideValue(u,d):void 0,S=d?this.rawConfiguration.override(d).getValue(u):m;return{value:m,override:f,merged:S}}getOverrideValue(u,d){const m=this.i(d);return m?u?(0,A.$Ei)(m,u):m:void 0}getKeysForOverrideIdentifier(u){const d=[];for(const m of this.overrides)m.identifiers.includes(u)&&d.push(...m.keys);return E.$Mb(d)}getAllOverrideIdentifiers(){const u=[];for(const d of this.overrides)u.push(...d.identifiers);return E.$Mb(u)}override(u){let d=this.a.get(u);return d||(d=this.g(u),this.a.set(u,d)),d}merge(...u){const d=$.$jn(this.contents),m=$.$jn(this.overrides),f=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const L of u)if(S.push(...L.raw?.length?L.raw:[L]),!L.isEmpty()){this.h(d,L.contents);for(const v of L.overrides){const[y]=m.filter(k=>E.$ub(k.identifiers,v.identifiers));y?(this.h(y.contents,v.contents),y.keys.push(...v.keys),y.keys=E.$Mb(y.keys)):m.push($.$jn(v))}for(const v of L.keys)f.indexOf(v)===-1&&f.push(v)}return new b(d,f,m,S.every(L=>L instanceof b)?void 0:S)}g(u){const d=this.i(u);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const m={};for(const f of E.$Mb([...Object.keys(this.contents),...Object.keys(d)])){let S=this.contents[f];const L=d[f];L&&(typeof S=="object"&&typeof L=="object"?(S=$.$jn(S),this.h(S,L)):S=L),m[f]=S}return new b(m,this.keys,this.overrides)}h(u,d){for(const m of Object.keys(d)){if(m in u&&g.$Hf(u[m])&&g.$Hf(d[m])){this.h(u[m],d[m]);continue}u[m]=$.$jn(d[m])}}i(u){let d=null,m=null;const f=S=>{S&&(m?this.h(m,S):m=$.$jn(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===u?d=S.contents:S.identifiers.includes(u)&&f(S.contents);return f(d),m}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(u,d){this.j(u,d,!0)}setValue(u,d){this.j(u,d,!1)}removeValue(u){const d=this.keys.indexOf(u);d!==-1&&(this.keys.splice(d,1),(0,A.$Di)(this.contents,u),D.$Kn.test(u)&&this.overrides.splice(this.overrides.findIndex(m=>E.$ub(m.identifiers,(0,D.$Ln)(u))),1))}j(u,d,m){(0,A.$Ci)(this.contents,u,d,f=>console.error(f)),m=m||this.keys.indexOf(u)===-1,m&&this.keys.push(u),D.$Kn.test(u)&&this.overrides.push({identifiers:(0,D.$Ln)(u),keys:Object.keys(this.contents[u]),contents:(0,A.$Bi)(this.contents[u],f=>console.error(f))})}}e.$Qn=b;class r{constructor(u){this.f=u,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new b}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(u,d){if(!g.$Of(u)){const m=this.g(u);this.parseRaw(m,d)}}reparse(u){this.a&&this.parseRaw(this.a,u)}parseRaw(u,d){this.a=u;const{contents:m,keys:f,overrides:S,restricted:L,hasExcludedProperties:v}=this.h(u,d);this.b=new b(m,f,S,v?[u]:void 0),this.c=L||[]}g(u){let d={},m=null,f=[];const S=[],L=[];function v(k){Array.isArray(f)?f.push(k):m!==null&&(f[m]=k)}const y={onObjectBegin:()=>{const k={};v(k),S.push(f),f=k,m=null},onObjectProperty:k=>{m=k},onObjectEnd:()=>{f=S.pop()},onArrayBegin:()=>{const k=[];v(k),S.push(f),f=k,m=null},onArrayEnd:()=>{f=S.pop()},onLiteralValue:v,onError:(k,N,O)=>{L.push({error:k,offset:N,length:O})}};if(u)try{I.$gn(u,y),d=f[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return d}h(u,d){const m=l.$vn.as(D.$An.Configuration).getConfigurationProperties(),f=this.i(u,m,!0,d);u=f.raw;const S=(0,A.$Bi)(u,y=>console.error(`Conflict in settings file ${this.f}: ${y}`)),L=Object.keys(u),v=this.j(u,y=>console.error(`Conflict in settings file ${this.f}: ${y}`));return{contents:S,keys:L,overrides:v,restricted:f.restricted,hasExcludedProperties:f.hasExcludedProperties}}i(u,d,m,f){let S=!1;if(!f?.scopes&&!f?.skipRestricted&&!f?.exclude?.length)return{raw:u,restricted:[],hasExcludedProperties:S};const L={},v=[];for(const y in u)if(D.$Kn.test(y)&&m){const k=this.i(u[y],d,!1,f);L[y]=k.raw,S=S||k.hasExcludedProperties,v.push(...k.restricted)}else{const k=d[y],N=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&v.push(y),!f.exclude?.includes(y)&&(f.include?.includes(y)||(N===void 0||f.scopes===void 0||f.scopes.includes(N))&&!(f.skipRestricted&&k?.restricted))?L[y]=u[y]:S=!0}return{raw:L,restricted:v,hasExcludedProperties:S}}j(u,d){const m=[];for(const f of Object.keys(u))if(D.$Kn.test(f)){const S={};for(const L in u[f])S[L]=u[f][L];m.push({identifiers:(0,D.$Ln)(f),keys:Object.keys(S),contents:(0,A.$Bi)(S,d)})}return m}}e.$Rn=r;class o extends F.$Sc{constructor(u,d,m,f){super(),this.c=u,this.f=d,this.g=f,this.b=this.B(new T.$Sd),this.onDidChange=this.b.event,this.a=new r(this.c.toString()),this.B(this.g.watch(m.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&m.isEqual(S.resource,u)))(()=>this.b.fire()))}async loadConfiguration(){try{const u=await this.g.readFile(this.c);return this.a.parse(u.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new b}}reparse(u){return u&&(this.f=u),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Sn=o;class t{constructor(u,d,m,f,S,L,v,y,k,N,O,K,j){this.a=u,this.b=d,this.c=m,this.overrideIdentifiers=f,this.d=S,this.f=L,this.g=v,this.h=y,this.i=k,this.j=N,this.k=O,this.l=K,this.m=j}get value(){return p(this.c)}n(u,d,m){const f=u.inspect(d,m);return{get value(){return p(f.value)},get override(){return p(f.override)},get merged(){return p(f.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class n{constructor(u,d,m,f,S=new b,L=new b,v=new R.$Ac,y=new b,k=new R.$Ac){this.c=u,this.d=d,this.f=m,this.g=f,this.h=S,this.i=L,this.j=v,this.l=y,this.m=k,this.a=null,this.b=new R.$Ac,this.n=null}getValue(u,d,m){return this.p(u,d,m).getValue(u)}updateValue(u,d,m={}){let f;m.resource?(f=this.m.get(m.resource),f||(f=new b,this.m.set(m.resource,f))):f=this.l,d===void 0?f.removeValue(u):f.setValue(u,d),m.resource||(this.a=null)}inspect(u,d,m){const f=this.p(u,d,m),S=this.t(d.resource,m),L=d.resource?this.m.get(d.resource)||this.l:this.l,v=new Set;for(const y of f.overrides)for(const k of y.identifiers)f.getOverrideValue(u,k)!==void 0&&v.add(k);return new t(u,d,f.getValue(u),v.size?[...v]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,m?this.i:void 0,S||void 0,L)}keys(u){const d=this.t(void 0,u);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(u){this.c=u,this.a=null,this.b.clear()}updatePolicyConfiguration(u){this.d=u}updateApplicationConfiguration(u){this.f=u,this.a=null,this.b.clear()}updateLocalUserConfiguration(u){this.g=u,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(u){this.h=u,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(u){this.i=u,this.a=null,this.b.clear()}updateFolderConfiguration(u,d){this.j.set(u,d),this.b.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this.b.delete(u)}compareAndUpdateDefaultConfiguration(u,d){const m=[];if(!d){const{added:f,updated:S,removed:L}=h(this.c,u);d=[...f,...S,...L]}for(const f of d)for(const S of(0,D.$Ln)(f)){const L=this.c.getKeysForOverrideIdentifier(S),v=u.getKeysForOverrideIdentifier(S),y=[...v.filter(k=>L.indexOf(k)===-1),...L.filter(k=>v.indexOf(k)===-1),...L.filter(k=>!$.$nn(this.c.override(S).getValue(k),u.override(S).getValue(k)))];m.push([S,y])}return this.updateDefaultConfiguration(u),{keys:d,overrides:m}}compareAndUpdatePolicyConfiguration(u){const{added:d,updated:m,removed:f}=h(this.d,u),S=[...d,...m,...f];return S.length&&this.updatePolicyConfiguration(u),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:d,updated:m,removed:f,overrides:S}=h(this.applicationConfiguration,u),L=[...d,...m,...f];return L.length&&this.updateApplicationConfiguration(u),{keys:L,overrides:S}}compareAndUpdateLocalUserConfiguration(u){const{added:d,updated:m,removed:f,overrides:S}=h(this.localUserConfiguration,u),L=[...d,...m,...f];return L.length&&this.updateLocalUserConfiguration(u),{keys:L,overrides:S}}compareAndUpdateRemoteUserConfiguration(u){const{added:d,updated:m,removed:f,overrides:S}=h(this.remoteUserConfiguration,u),L=[...d,...m,...f];return L.length&&this.updateRemoteUserConfiguration(u),{keys:L,overrides:S}}compareAndUpdateWorkspaceConfiguration(u){const{added:d,updated:m,removed:f,overrides:S}=h(this.workspaceConfiguration,u),L=[...d,...m,...f];return L.length&&this.updateWorkspaceConfiguration(u),{keys:L,overrides:S}}compareAndUpdateFolderConfiguration(u,d){const m=this.folderConfigurations.get(u),{added:f,updated:S,removed:L,overrides:v}=h(m,d),y=[...f,...S,...L];return(y.length||!m)&&this.updateFolderConfiguration(u,d),{keys:y,overrides:v}}compareAndDeleteFolderConfiguration(u){const d=this.folderConfigurations.get(u);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:m,updated:f,removed:S,overrides:L}=h(d,void 0);return{keys:[...m,...f,...S],overrides:L}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(u,d,m){let f=this.q(d,m);return d.overrideIdentifier&&(f=f.override(d.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(u)!==void 0&&(f=f.merge(this.d)),f}q({resource:u},d){let m=this.r();if(d&&u){const f=d.getFolder(u);f&&(m=this.s(f.uri)||m);const S=this.m.get(u);S&&(m=m.merge(S))}return m}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(u){let d=this.b.get(u);if(!d){const m=this.r(),f=this.j.get(u);f?(d=m.merge(f),this.b.set(u,d)):d=m}return d}t(u,d){if(d&&u){const m=d.getFolder(u);if(m)return this.j.get(m.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((u,d)=>{const{contents:m,overrides:f,keys:S}=this.j.get(d);return u.push([d,{contents:m,overrides:f,keys:S}]),u},[])}}allKeys(){const u=new Set;return this.c.keys.forEach(d=>u.add(d)),this.userConfiguration.keys.forEach(d=>u.add(d)),this.i.keys.forEach(d=>u.add(d)),this.j.forEach(d=>d.keys.forEach(m=>u.add(m))),[...u.values()]}u(){const u=new Set;return this.c.getAllOverrideIdentifiers().forEach(d=>u.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>u.add(d)),this.i.getAllOverrideIdentifiers().forEach(d=>u.add(d)),this.j.forEach(d=>d.getAllOverrideIdentifiers().forEach(m=>u.add(m))),[...u.values()]}v(u){const d=new Set;return this.c.getKeysForOverrideIdentifier(u).forEach(m=>d.add(m)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(m=>d.add(m)),this.i.getKeysForOverrideIdentifier(u).forEach(m=>d.add(m)),this.j.forEach(m=>m.getKeysForOverrideIdentifier(u).forEach(f=>d.add(f))),[...d.values()]}static parse(u){const d=this.w(u.defaults),m=this.w(u.policy),f=this.w(u.application),S=this.w(u.user),L=this.w(u.workspace),v=u.folders.reduce((y,k)=>(y.set(w.URI.revive(k[0]),this.w(k[1])),y),new R.$Ac);return new n(d,m,f,S,new b,L,v,new b,new R.$Ac)}static w(u){return new b(u.contents,u.keys,u.overrides)}}e.$Tn=n;function a(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const u=new Set,d=new Map;for(const f of s)f.keys.forEach(S=>u.add(S)),f.overrides.forEach(([S,L])=>{const v=(0,R.$xc)(d,S,new Set);L.forEach(y=>v.add(y))});const m=[];return d.forEach((f,S)=>m.push([S,[...f.values()]])),{keys:[...u.values()],overrides:m}}e.$Un=a;class c{constructor(u,d,m,f){this.change=u,this.f=d,this.g=m,this.h=f,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const S of u.keys)this.affectedKeys.add(S);for(const[,S]of u.overrides)for(const L of S)this.affectedKeys.add(L);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(u,d){const m=this.a+u,f=this.d.indexOf(m);if(f<0)return!1;const S=f+m.length;if(S>=this.d.length)return!1;const L=this.d.charCodeAt(S);if(L!==this.b&&L!==this.c)return!1;if(d){const v=this.previousConfiguration?this.previousConfiguration.getValue(u,d,this.f?.workspace):void 0,y=this.g.getValue(u,d,this.h);return!$.$nn(v,y)}return!0}}e.$Vn=c;function h(s,u){const{added:d,removed:m,updated:f}=i(u?.rawConfiguration,s?.rawConfiguration),S=[],L=s?.getAllOverrideIdentifiers()||[],v=u?.getAllOverrideIdentifiers()||[];if(u){const y=v.filter(k=>!L.includes(k));for(const k of y)S.push([k,u.getKeysForOverrideIdentifier(k)])}if(s){const y=L.filter(k=>!v.includes(k));for(const k of y)S.push([k,s.getKeysForOverrideIdentifier(k)])}if(u&&s){for(const y of L)if(v.includes(y)){const k=i({contents:s.getOverrideValue(void 0,y)||{},keys:s.getKeysForOverrideIdentifier(y)},{contents:u.getOverrideValue(void 0,y)||{},keys:u.getKeysForOverrideIdentifier(y)});S.push([y,[...k.added,...k.removed,...k.updated]])}}return{added:d,removed:m,updated:f,overrides:S}}function i(s,u){const d=s?u?s.keys.filter(S=>u.keys.indexOf(S)===-1):[...s.keys]:[],m=u?s?u.keys.filter(S=>s.keys.indexOf(S)===-1):[...u.keys]:[],f=[];if(s&&u){for(const S of u.keys)if(s.keys.indexOf(S)!==-1){const L=(0,A.$Ei)(u.contents,S),v=(0,A.$Ei)(s.contents,S);$.$nn(L,v)||f.push(S)}}return{added:d,removed:m,updated:f}}}),define(Ce[100],Re([1,0,15,4]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.RemoteAuthorityResolverErrorCode=e.$7k=e.$6k=e.RemoteConnectionType=e.$5k=void 0,e.$5k=(0,T.$3h)("remoteAuthorityResolverService");var I;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class F{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$6k=F;class R{constructor(D,l){this.host=D,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$7k=R;var $;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})($||(e.RemoteAuthorityResolverErrorCode=$={}));class g extends E.$bb{static isNotAvailable(D){return D instanceof g&&D._code===$.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof g&&D._code===$.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof g&&D._code===$.NoResolverFound}static isInvalidAuthority(D){return D instanceof g&&D._code===$.InvalidAuthority}static isHandled(D){return D instanceof g&&D.isHandled}constructor(D,l=$.Unknown,p){super(D),this._message=D,this._code=l,this._detail=p,this.isHandled=l===$.NotAvailable&&p===!0,Object.setPrototypeOf(this,g.prototype)}}e.$8k=g;function w(A){const D=A.indexOf("+");return D===-1?A:A.substring(0,D)}e.$9k=w}),define(Ce[55],Re([1,0,12]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=e.$_k=e.$$k=e.$0k=void 0;function T(w){return w.scheme===E.Schemas.vscodeRemote?w.authority:void 0}e.$0k=T;function I(w){if(!w)return;const A=w.indexOf("+");return A<0?w:w.substr(0,A)}e.$$k=I;function F(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.$_k=F;function R(w){const{host:A,port:D}=g(w);if(typeof D>"u")throw new Error(`Invalid remote authority: ${w}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:A,port:D}}e.$al=R;function $(w,A){let{host:D,port:l}=g(w);return typeof l>"u"&&(l=A),{host:D,port:l}}e.$bl=$;function g(w){const A=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const D=w.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const l=w.match(/(.*):(\d+)$/);return l?{host:l[1],port:parseInt(l[2],10)}:{host:w,port:void 0}}}),define(Ce[22],Re([1,0,11,4,55]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.TargetPlatform=e.ExtensionType=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=void 0,e.$cm="extensions.user.cache",e.$dm="extensions.builtin.cache",e.$em="undefined_publisher",e.$fm=["ui","workspace","web"];function F(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$gm=F,e.$hm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(R||(e.ExtensionType=R={}));var $;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})($||(e.TargetPlatform=$={}));class g{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,t){if(typeof o>"u"||o===null)return typeof t>"u"||t===null;if(typeof t>"u"||t===null)return!1;if(typeof o=="string"||typeof t=="string"){const n=typeof o=="string"?o:o.value,a=typeof t=="string"?t:t.value;return E.$9e(n,a)}return o._lower===t._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$im=g;class w{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const t of o)this.add(t)}add(o){this.c.add(g.toKey(o))}delete(o){return this.c.delete(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}}e.$jm=w;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(g.toKey(o))}get(o){return this.c.get(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}set(o,t){this.c.set(g.toKey(o),t)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$km=A;function D(r){return l(r)}e.$lm=D;function l(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}e.$mm=l;function p(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}e.$nm=p;function b(r,o){if(o){const t=`onResolveRemoteAuthority:${(0,I.$$k)(o)}`;return!!r.activationEvents?.includes(t)}return!1}e.$om=b,e.$pm=(0,T.$3h)("IBuiltinExtensionsScannerService")}),define(Ce[101],Re([1,0,15,22]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7E=e.$6E=void 0;class I{constructor(){this.a=new Map,this.b=new WeakMap}register(R,$){this.a.set(R,$)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const $=Object.create(null);for(const g of R){const w=this.readActivationEvents(g);w.length>0&&($[T.$im.toKey(g.identifier)]=w)}return $}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const $=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let g=0;g<$.length;g++)$[g]==="onUri"&&($[g]=`onUri:${T.$im.toKey(R.identifier)}`);if(!R.contributes)return $;for(const g in R.contributes){const w=this.a.get(g);if(!w)continue;const A=R.contributes[g],D=Array.isArray(A)?A:[A];try{w(D,$)}catch(l){(0,E.$1)(l)}}return $}}e.$6E=I,e.$7E=new I}),define(Ce[191],Re([1,0,21,74,33]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xo=e.$wo=void 0;function F(g){if(E.$u===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}function R(g,w,A,D,l,p,b,r,o){const t=Object.create(null);t["common.machineId"]=p,t["common.sqmId"]=b,t.sessionID=(0,I.$ng)()+Date.now(),t.commitHash=D,t.version=l,t["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,E.$h)(E.$u),t["common.nodePlatform"]=T.$dc,t["common.nodeArch"]=A,t["common.product"]=o||"desktop",r&&(t["common.msftInternal"]=r);let n=0;const a=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),E.$l&&(t["common.snap"]="true");const c=F(w);return c&&(t["common.platformDetail"]=c),t}e.$wo=R;function $(g){const w=T.env.USERDNSDOMAIN;if(!w)return!1;const A=w.toLowerCase();return g.some(D=>A===D)}e.$xo=$}),define(Ce[192],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=void 0,e.$rl=(0,E.$3h)("telemetryService"),e.$sl=(0,E.$3h)("customEndpointTelemetryService"),e.$tl="telemetry.currentSessionDate",e.$ul="telemetry.firstSessionDate",e.$vl="telemetry.lastSessionDate",e.$wl="telemetry.machineId",e.$xl="telemetry.sqmId",e.$yl="telemetry",e.$zl="telemetry.telemetryLevel",e.$Al="telemetry.enableCrashReporter",e.$Bl="telemetry.enableTelemetry";var T;(function(F){F[F.NONE=0]="NONE",F[F.CRASH=1]="CRASH",F[F.ERROR=2]="ERROR",F[F.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var I;(function(F){F.OFF="off",F.CRASH="crash",F.ERROR="error",F.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(Ce[56],Re([1,0,26,16,5,41,55,191,192]),function(ge,e,E,T,I,F,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=void 0;class w{constructor(m){this.value=m,this.isTrustedTelemetryValue=!0}}e.$yo=w;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$zo=A,e.$Ao=new A;class D{async publicLog(m,f,S){}async publicLogError(m,f,S){}}e.$Bo=D,e.$Co="telemetry",e.$Do="extensionTelemetryLog",e.$Eo={log:()=>null,flush:()=>Promise.resolve(null)};function l(d,m){return I.Event.debounce(m.onDidChangeConfiguration,(S,L)=>{const v=S?new Set([...S.affectedKeys,...L.affectedKeys]):L.affectedKeys;return{...L,affectedKeys:v}},1e3,!0)(S=>{S.source!==7&&d.publicLog2("updateConfiguration",{configurationSource:(0,F.$zi)(S.source),configurationKeys:Array.from(S.affectedKeys)})})}e.$Fo=l;function p(d,m){return!m.isBuilt&&!m.disableTelemetry?!0:!(m.disableTelemetry||!d.enableTelemetry)}e.$Go=p;function b(d,m){return m.extensionTestsLocationURI?!0:!(m.isBuilt||m.disableTelemetry||d.enableTelemetry&&d.aiConfig?.ariaKey)}e.$Ho=b;function r(d){const m=d.getValue(g.$zl),f=d.getValue(g.$Al);if(d.getValue(g.$Bl)===!1||f===!1)return 0;switch(m??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Io=r;function o(d){const m={},f={},S={};a(d,S);for(let L in S){L=L.length>150?L.substr(L.length-149):L;const v=S[L];typeof v=="number"?f[L]=v:typeof v=="boolean"?f[L]=v?1:0:typeof v=="string"?(v.length>8192&&console.warn(`Telemetry property: ${L} has been trimmed to 8192, the original length is ${v.length}`),m[L]=v.substring(0,8191)):typeof v<"u"&&v!==null&&(m[L]=v)}return{properties:m,measurements:f}}e.$Jo=o;const t=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(d){if(!d)return"none";const m=(0,R.$$k)(d);return t.has(m)?m:"other"}e.$Ko=n;function a(d,m,f=0,S){if(d)for(const L of Object.getOwnPropertyNames(d)){const v=d[L],y=S?S+L:L;Array.isArray(v)?m[y]=(0,E.$on)(v):v instanceof Date?m[y]=v.toISOString():(0,T.$Hf)(v)?f<2?a(v,m,f+1,y+"."):m[y]=(0,E.$on)(v):m[y]=v}}function c(d,m){const f=d.msftInternalDomains||[],S=m.getValue("telemetry.internalTesting");return(0,$.$xo)(f)||S}e.$Lo=c;function h(d){return[d.appRoot,d.extensionsPath,d.userHome.fsPath,d.tmpDir.fsPath,d.userDataPath]}e.$Mo=h;function i(d,m){if(!d||!d.includes("/")&&!d.includes("\\"))return d;let f=d;const S=[];for(const k of m)for(;;){const N=k.exec(d);if(!N)break;S.push([N.index,k.lastIndex])}const L=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let y=0;for(f="";;){const k=v.exec(d);if(!k)break;const N=S.some(([O,K])=>k.index<K&&O<v.lastIndex);!L.test(k[0])&&!N&&(f+=d.substring(y,k.index)+"<REDACTED: user-file-path>",y=v.lastIndex)}return y<d.length&&(f+=d.substr(y)),f}function s(d){if(!d)return d;const m=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of m)if(f.regex.test(d))return`<REDACTED: ${f.label}>`;return d}function u(d,m){return(0,E.$ln)(d,f=>{if(f instanceof w||Object.hasOwnProperty.call(f,"isTrustedTelemetryValue"))return f.value;if(typeof f=="string"){let S=f.replaceAll("%20"," ");S=i(S,m);for(const L of m)S=S.replace(L,"");return S=s(S),S}})}e.$No=u}),define(Ce[193],Re([1,0,11,97,22,21,2,15,74,56]),function(ge,e,E,T,I,F,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=void 0;function A(u,d){return u.uuid&&d.uuid?u.uuid===d.uuid:u.id===d.id?!0:(0,E.$4e)(u.id,d.id)===0}e.$Oo=A;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(d){const m=d.manifest?d.manifest.version:d.version,f=d.manifest?d.targetPlatform:d.properties.targetPlatform;return new l(d.identifier,m,f)}static parse(d){const m=D.exec(d);return m&&m[1]&&m[2]?new l({id:m[1]},m[2],m[4]||void 0):null}constructor(d,m,f="undefined"){this.version=m,this.targetPlatform=f,this.id=d.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(d){return d instanceof l?A(this,d)&&this.version===d.version&&this.targetPlatform===d.targetPlatform:!1}}e.$Po=l;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(u){const d=p.exec(u);return d&&d[1]?[o(d[1]),d[2]]:[o(u),void 0]}e.$Qo=b;function r(u,d){return`${u}.${d}`}e.$Ro=r;function o(u){return u.toLowerCase()}e.$So=o;function t(u,d){return o(r(u??I.$em,d))}e.$To=t;function n(u,d){const m=[],f=S=>{for(const L of m)if(L.some(v=>A(d(v),d(S))))return L;return null};for(const S of u){const L=f(S);L?L.push(S):m.push([S])}return m}e.$Uo=n;function a(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.$Vo=a;function c(u){return{id:new w.$yo(u.identifier.id),name:new w.$yo(u.name),galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),isSigned:u.isSigned,...u.telemetryData}}e.$Wo=c,e.$Xo=new I.$im("pprice.better-merge");function h(u,d){const m=[],f=d.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const S=f.shift();if(S&&m.every(L=>!A(L.identifier,{id:S}))){const L=u.filter(v=>A(v.identifier,{id:S}));L.length===1&&(m.push(L[0]),f.push(...L[0].manifest.extensionDependencies?.slice(0)??[]))}}return m}e.$Yo=h;async function i(u,d){if(!F.$k)return!1;let m;try{m=(await u.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{m=(await u.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){d.debug("Error while getting the os-release file.",(0,$.$0)(S))}}return!!m&&(m.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(u,d){const m=await i(u,d),f=(0,T.$io)(m?"alpine":F.$u,g.$ec);return d.debug("ComputeTargetPlatform:",f),f}e.$Zo=s}),define(Ce[194],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=e.$Dr=e.$Cr=e.$Br=e.$Ar=e.$zr=void 0;function E(g){return[...g.entries()]}e.$zr=E;function T(g){return g?[...g.entries()]:[]}e.$Ar=T;function I(g){return new Map(g)}e.$Br=I;function F(g){return new Map(g??[])}e.$Cr=F;function R(g){return Array.from(g.entries()).map(w=>[w[0],E(w[1].map),T(w[1].descriptionMap)])}e.$Dr=R;function $(g){return new Map(g.map(w=>[w[0],{map:I(w[1]),descriptionMap:F(w[2])}]))}e.$Er=$}),define(Ce[195],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zrb=void 0;class E{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,F,R=5){const $=F(g=>{const w=typeof g=="string"?g:g.data;let A=this.a.get(I);if(A){A.data.push(w);return}const D=setTimeout(()=>this.flushBuffer(I),R);A={data:[w],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(I),$.dispose()}},this.a.set(I,A)});return $}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const F=this.a.get(I);F&&(this.a.delete(I),this.b(I,F.data.join("")))}}e.$zrb=E}),define(Ce[196],Re([1,0,13,90,45,5,16,2,155,73,30]),function(ge,e,E,T,I,F,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rw=e.$qw=e.$pw=e.$ow=e.$nw=e.$mw=e.$lw=e.$kw=e.IconFontDefinition=e.IconContribution=e.$jw=void 0,e.$jw={IconContribution:"base.contributions.icons"};var D;(function(c){function h(i,s){let u=i.defaults;for(;I.ThemeIcon.isThemeIcon(u);){const d=b.getIcon(u.id);if(!d)return;u=d.defaults}return u}c.getDefinition=h})(D||(e.IconContribution=D={}));var l;(function(c){function h(s){return{weight:s.weight,style:s.style,src:s.src.map(u=>({format:u.format,location:u.location.toString()}))}}c.toJSONObject=h;function i(s){const u=d=>(0,R.$Ff)(d)?d:void 0;if(s&&Array.isArray(s.src)&&s.src.every(d=>(0,R.$Ff)(d.format)&&(0,R.$Ff)(d.location)))return{weight:u(s.weight),style:u(s.style),src:s.src.map(d=>({format:d.format,location:$.URI.parse(d.location)}))}}c.fromJSONObject=i})(l||(e.IconFontDefinition=l={}));class p{constructor(){this.a=new F.$Sd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,g.localize)(0,null)},fontCharacter:{type:"string",description:(0,g.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${I.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(h,i,s,u){const d=this.b[h];if(d){if(s&&!d.description){d.description=s,this.d.properties[h].markdownDescription=`${s} $(${h})`;const S=this.e.enum.indexOf(h);S!==-1&&(this.e.enumDescriptions[S]=s),this.a.fire()}return d}const m={id:h,description:s,defaults:i,deprecationMessage:u};this.b[h]=m;const f={$ref:"#/definitions/icons"};return u&&(f.deprecationMessage=u),s&&(f.markdownDescription=`${s}: $(${h})`),this.d.properties[h]=f,this.e.enum.push(h),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:h}}deregisterIcon(h){delete this.b[h],delete this.d.properties[h];const i=this.e.enum.indexOf(h);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(h=>this.b[h])}getIcon(h){return this.b[h]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(h,i){const s=this.f[h];return s||(this.f[h]=i,this.a.fire(),i)}deregisterIconFont(h){delete this.f[h]}getIconFont(h){return this.f[h]}toString(){const h=(d,m)=>d.id.localeCompare(m.id),i=d=>{for(;I.ThemeIcon.isThemeIcon(d.defaults);)d=this.b[d.defaults.id];return`codicon codicon-${d?d.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.b).map(d=>this.b[d]);for(const d of u.filter(m=>!!m.description).sort(h))s.push(`|<i class="${i(d)}"></i>|${d.id}|${I.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const d of u.filter(m=>!I.ThemeIcon.isThemeIcon(m.defaults)).sort(h))s.push(`|<i class="${i(d)}"></i>|${d.id}|`);return s.join(`
`)}}const b=new p;A.$vn.add(e.$jw.IconContribution,b);function r(c,h,i,s){return b.registerIcon(c,h,i,s)}e.$kw=r;function o(){return b}e.$lw=o;function t(){const c=(0,T.$7j)();for(const h in c){const i="\\"+c[h].toString(16);b.registerIcon(h,{fontCharacter:i})}}t(),e.$mw="vscode://schemas/icons";const n=A.$vn.as(w.$wn.JSONContribution);n.registerSchema(e.$mw,b.getIconSchema());const a=new E.$ch(()=>n.notifySchemaChanged(e.$mw),200);b.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.$nw=r("widget-close",T.$9j.close,(0,g.localize)(2,null)),e.$ow=r("goto-previous-location",T.$9j.arrowUp,(0,g.localize)(3,null)),e.$pw=r("goto-next-location",T.$9j.arrowDown,(0,g.localize)(4,null)),e.$qw=I.ThemeIcon.modify(T.$9j.sync,"spin"),e.$rw=I.ThemeIcon.modify(T.$9j.loading,"spin")}),define(Ce[197],Re([1,0,5,41,4,14]),function(ge,e,E,T,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xv=e.$wv=e.$vv=e.$uv=e.$tv=e.$sv=e.$rv=e.$qv=e.ProvidedOnAutoForward=e.$pv=e.TunnelPrivacyId=e.TunnelProtocol=e.$ov=e.$nv=void 0,e.$nv=(0,I.$3h)("tunnelService"),e.$ov=(0,I.$3h)("sharedTunnelsService");var R;(function(o){o.Http="http",o.Https="https"})(R||(e.TunnelProtocol=R={}));var $;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})($||(e.TunnelPrivacyId=$={}));function g(o){return!!o.forwardPort}e.$pv=g;var w;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(w||(e.ProvidedOnAutoForward=w={}));function A(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(t)return{address:t[1],port:+t[2]}}e.$qv=A,e.$rv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(o){return e.$rv.indexOf(o)>=0}e.$sv=D,e.$tv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function l(o){return e.$tv.indexOf(o)>=0}e.$uv=l;function p(o,t,n,a){if(n===1)return!1;if(n===2&&l(t)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(c?.length===4&&parseInt(c[1])>=18)return!1}return o<1024}e.$vv=p;class b{constructor(t,n,a){this.remoteAddress=t,this.localAddress=n,this.b=a,this.a=new E.$Sd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$wv=b;let r=class{constructor(t,n){this.j=t,this.k=n,this.a=new E.$Sd,this.onTunnelOpened=this.a.event,this.b=new E.$Sd,this.onTunnelClosed=this.b.event,this.c=new E.$Sd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const t=this.k.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.f=t,t?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.g=t.elevation,this.h=t.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const t=[],n=Array.from(this.e.values());for(const a of n){const c=Array.from(a.values());for(const h of c){const i=await h.value;i&&typeof i!="string"&&t.push(i)}}return t}async dispose(){for(const t of this.e.values()){for(const{value:n}of t.values())await n.then(a=>typeof a!="string"?a?.dispose():void 0);t.clear()}this.e.clear()}setEnvironmentTunnel(t,n,a,c,h){this.p(t,n,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:n,localAddress:a,privacy:c,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,n){(l(t)||D(t))&&(t=e.$rv[0]);const a=this.r(t,n);if(a)return++a.refcount,a.value}openTunnel(t,n,a,c,h,i=!1,s,u){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${a} on local port ${h}.`);const d=this.f??t;if(!d)return;if(n||(n="localhost"),c||(c=this.l),this.f&&this.i.has(a)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const m=this.s(d,n,a,c,h,i,s,u);return m?m.then(f=>{if(f){if(typeof f=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(n,a),f}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(n,a);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.n(f);return(f.tunnelRemoteHost!==n||f.tunnelRemotePort!==a)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&f.privacy!==s&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),m)}n(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const n=this.e.get(t.tunnelRemoteHost);if(n){const a=n.get(t.tunnelRemotePort);a&&(a.refcount--,await this.o(t.tunnelRemoteHost,t.tunnelRemotePort,a))}}}}async o(t,n,a){if(a.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${n}.`);const c=a.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has(t)&&this.e.get(t).delete(n),c}}async closeTunnel(t,n){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${n} `);const a=this.e.get(t);if(a&&a.has(n)){const c=a.get(n);c.refcount=0,await this.o(t,n,c)}}p(t,n,a){this.e.has(t)||this.e.set(t,new Map),this.e.get(t).set(n,{refcount:1,value:a})}async q(t,n){const a=this.e.get(t);if(a){const c=a.get(n),h=c?await c.value:void 0;(!h||typeof h=="string")&&a.delete(n),a.size===0&&this.e.delete(t)}}r(t,n){const a=[t];D(t)?(a.push(...e.$rv),a.push(...e.$tv)):l(t)&&a.push(...e.$tv);const c=a.map(h=>this.e.get(h));for(const h of c){const i=h?.get(n);if(i)return i}}canTunnel(t){return!!A(t)}t(t,n,a,c,h,i,s){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${a} on local port ${c}.`);const u=a;this.i.add(u);const d=c===void 0?a:c,m={elevationRequired:h?this.isPortPrivileged(d):!1},f={remoteAddress:{host:n,port:a},localAddressPort:c,privacy:i,public:i?i!==$.Private:void 0,protocol:s},S=t.forwardPort(f,m);return S?(this.p(n,a,S),S.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(u)})):this.i.delete(u),S}};e.$xv=r,e.$xv=r=Ge([Ke(0,F.$kj),Ke(1,T.$wi)],r)}),define(Ce[198],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$yv=void 0,e.$yv=(0,E.$3h)("editSessionIdentityService");var T;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(Ce[199],Re([1,0,12]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=void 0;function T(g){return g.scheme!==E.Schemas.file&&g.scheme!==E.Schemas.vscodeRemote}e.$nK=T;function I(g){if(g.folders.length)return g.folders.every(w=>T(w.uri))?g.folders[0].uri:void 0;if(g.configuration&&T(g.configuration))return g.configuration}e.$oK=I;function F(g){return I(g)?.scheme}e.$pK=F;function R(g){return I(g)?.authority}e.$qK=R;function $(g){return I(g)!==void 0}e.$rK=$}),define(Ce[47],Re([1,0,156,19,50,25,2,4,12]),function(ge,e,E,T,I,F,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.WorkbenchState=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=void 0,e.$_h=(0,$.$3h)("contextService");function w(d){const m=d;return typeof m?.id=="string"&&R.URI.isUri(m.uri)}e.$ai=w;function A(d){return typeof d?.id=="string"&&!w(d)&&!l(d)}e.$bi=A,e.$ci={id:"ext-dev"},e.$di={id:"empty-window"};function D(d,m){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,T.$nc)(d)}:m?e.$ci:e.$di;const f=d;return f.configuration?{id:f.id,configPath:f.configuration}:f.folders.length===1?{id:f.id,uri:f.folders[0].uri}:{id:f.id}}e.$ei=D;function l(d){const m=d;return typeof m?.id=="string"&&R.URI.isUri(m.configPath)}e.$fi=l;function p(d){const m=d;if(m?.uri)return{id:m.id,uri:R.URI.revive(m.uri)};const f=d;if(f?.configPath)return{id:f.id,configPath:R.URI.revive(f.configPath)};if(d?.id)return{id:d.id}}e.$gi=p;var b;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(b||(e.WorkbenchState=b={}));function r(d){const m=d;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.$hi=r;function o(d){const m=d;return!!(m&&typeof m=="object"&&R.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.$ii=o;class t{constructor(m,f,S,L,v){this.h=m,this.j=S,this.k=L,this.l=v,this.c=I.$9h.forUris(this.l,()=>!0),this.folders=f}update(m){this.h=m.id,this.k=m.configuration,this.j=m.transient,this.l=m.l,this.folders=m.folders}get folders(){return this.g}set folders(m){this.g=m,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(m){this.k=m}getFolder(m){return m&&this.c.findSubstr(m)||null}n(){this.c=I.$9h.forUris(this.l,()=>!0);for(const m of this.folders)this.c.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ji=t;class n{constructor(m,f){this.raw=f,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,F.$Eg)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ki=n;function a(d){return new n({uri:d,index:0,name:(0,F.$Ag)(d)},{uri:d.toString()})}e.$li=a,e.$mi="code-workspace",e.$ni=`.${e.$mi}`,e.$oi=[{name:(0,E.localize)(0,null),extensions:[e.$mi]}],e.$pi="workspace.json";function c(d,m){return F.$vg.isEqualOrParent(d,m.untitledWorkspacesHome)}e.$qi=c;function h(d){let m;return R.URI.isUri(d)?m=d:m=d.configuration,m?.scheme===g.Schemas.tmp}e.$ri=h,e.$si="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(d){return d.id===e.$si}e.$ti=i;function s(d,m){return!c(d,m)&&!h(d)}e.$ui=s;function u(d){return(typeof d=="string"?(0,T.$oc)(d):(0,F.$Cg)(d))===e.$ni}e.$vi=u}),define(Ce[75],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0;class E{static{this.a=!1}constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const F=this.c++;return this.b.set(F,I),this.e(),F}get(I,F){return this.b.has(I)?this.b.get(I)[F]:void 0}delete(I){this.b.delete(I),this.e()}e(){E.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$dfc=E}),define(Ce[43],Re([1,0,12,25,4]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=e.$gfc=void 0;class F{constructor(){this.a=new Set(Object.keys(E.Schemas)),this.b=new Map,this.extUri=new T.$tg($=>{const g=this.b.get($.scheme);return!(g===void 0||g&1024)})}$acceptProviderInfos($,g){g===null?this.b.delete($.scheme):this.b.set($.scheme,g)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$gfc=F,e.$hfc=(0,I.$3h)("IExtHostFileSystemInfo")}),define(Ce[27],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=void 0,e.$$M=(0,E.$3h)("IExtHostInitDataService")}),define(Ce[200],Re([1,0,161,14,187,27]),function(ge,e,E,T,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=void 0;let R=class extends I.$fO{constructor(g,w,A){const D=A.remote.isRemote?"remoteexthost":g?"workerexthost":"exthost",l=A.remote.isRemote?(0,E.localize)(0,null):g?(0,E.localize)(1,null):(0,E.localize)(2,null);super(w.createLogger(D,{name:l}))}};e.$nhc=R,e.$nhc=R=Ge([Ke(1,T.$lj),Ke(2,F.$$M)],R)}),define(Ce[201],Re([1,0,13]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=e.$2fc=void 0;class T{constructor(R,$,g){this.h=new Map,this.a=R,this.b=$,this.c=g,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(w=>(this.f=w,this)),this.g=this.c.onDidChangeStorage(w=>{w.shared===this.b&&w.key===this.a&&(this.f=w.value)}),this.i=new E.$ch(()=>{const w=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of w.values())A.complete()}catch(A){for(const D of w.values())D.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,$){let g=this.f[R];return typeof g>"u"&&(g=$),g}update(R,$){this.f[R]=$;const g=this.h.get(R);if(g!==void 0)return g.p;const w=new E.$nh;return this.h.set(R,w),this.i.isScheduled()||this.i.schedule(),w.p}dispose(){this.g.dispose()}}e.$2fc=T;class I extends T{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,$){super(R.identifier.value,!0,$),this.j=R}}e.$3fc=I}),define(Ce[202],Re([1,0,5,2]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pgc=void 0;class I{constructor(R){this.c=R,this.a=new E.$Sd,this.onDidSaveNotebookDocument=this.a.event,this.b=new E.$Sd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,$,g,w){const D=this.c.getNotebookDocument(T.URI.revive(R)).acceptModelChanged($.value,g,w);this.b.fire(D)}$acceptDirtyStateChanged(R,$){this.c.getNotebookDocument(T.URI.revive(R)).acceptDirty($)}$acceptModelSaved(R){const $=this.c.getNotebookDocument(T.URI.revive(R));this.a.fire($.apiNotebook)}}e.$Pgc=I}),define(Ce[17],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VM=e.$UM=void 0,e.$UM=(0,E.$3h)("IExtHostRpcService");class T{constructor(F){this.getProxy=F.getProxy.bind(F),this.set=F.set.bind(F),this.dispose=F.dispose.bind(F),this.assertRegistered=F.assertRegistered.bind(F),this.drain=F.drain.bind(F)}}e.$VM=T}),define(Ce[203],Re([1,0,22,5]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=void 0;class I{#e;constructor(R,$){this.b=new T.$Sd,this.onDidChange=this.b.event,this.a=E.$im.toKey(R.identifier),this.#e=$,this.#e.onDidChangePassword(g=>{g.extensionId===this.a&&this.b.fire({key:g.key})})}get(R){return this.#e.get(this.a,R)}store(R,$){return this.#e.store(this.a,R,$)}delete(R){return this.#e.delete(this.a,R)}}e.$0fc=I}),define(Ce[57],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=e.$zfc=void 0,e.$zfc=(0,E.$3h)("IURITransformerService");class T{constructor(F){F?(this.transformIncoming=F.transformIncoming.bind(F),this.transformOutgoing=F.transformOutgoing.bind(F),this.transformOutgoingURI=F.transformOutgoingURI.bind(F),this.transformOutgoingScheme=F.transformOutgoingScheme.bind(F)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$Afc=T}),define(Ce[204],Re([1,0,24]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5kb=e.$4kb=void 0;class T{constructor(){this.buffers=[]}add(g){let w=this.buffers.indexOf(g);return w<0&&(w=this.buffers.length,this.buffers.push(g)),w}}function I($,g){if(g.serializeBuffersForPostMessage){const w=new T,D=JSON.stringify($,(p,b)=>{if(b instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:w.add(b)};if(ArrayBuffer.isView(b)){const r=F(b);if(r)return{$$vscode_array_buffer_reference$$:!0,index:w.add(b.buffer),view:{type:r,byteLength:b.byteLength,byteOffset:b.byteOffset}}}return b}),l=w.buffers.map(p=>{const b=new Uint8Array(p);return E.$ge.wrap(b)});return{message:D,buffers:l}}else return{message:JSON.stringify($),buffers:[]}}e.$4kb=I;function F($){switch($.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R($,g){const w=g.map(l=>{const p=new ArrayBuffer(l.byteLength);return new Uint8Array(p).set(l.buffer),p}),A=g.length?(l,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const b=p,{index:r}=b,o=w[r];if(b.view)switch(b.view.type){case 1:return new Int8Array(o,b.view.byteOffset,b.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,b.view.byteOffset,b.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,b.view.byteOffset,b.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,b.view.byteOffset,b.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,b.view.byteOffset,b.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,b.view.byteOffset,b.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,b.view.byteOffset,b.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,b.view.byteOffset,b.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,b.view.byteOffset,b.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,b.view.byteOffset,b.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,b.view.byteOffset,b.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return p}:void 0;return{message:JSON.parse($,A),arrayBuffers:w}}e.$5kb=R}),define(Ce[102],Re([1,0,171,16,2,6,4,30,42,12,40,134,31]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QE=e.$PE=e.$OE=e.EditorsOrder=e.$NE=e.CloseDirection=e.$ME=e.$LE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$KE=e.$JE=e.$IE=e.$HE=e.$GE=e.$FE=e.$EE=e.$DE=e.EditorInputCapabilities=e.$CE=e.SaveReason=e.Verbosity=e.$BE=e.$AE=e.$zE=e.$yE=e.$xE=e.$wE=e.$vE=e.$uE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$tE=e.$sE=e.$rE=e.$qE=e.$pE=void 0,e.$pE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$qE={id:"default",displayName:(0,E.localize)(0,null),providerDisplayName:(0,E.localize)(1,null)},e.$rE="workbench.editor.sidebysideEditor",e.$sE="workbench.editors.textDiffEditor",e.$tE="workbench.editors.binaryResourceDiffEditor";var p;(function(se){se[se.PROGRAMMATIC=1]="PROGRAMMATIC",se[se.USER=2]="USER",se[se.EDIT=3]="EDIT",se[se.NAVIGATION=4]="NAVIGATION",se[se.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var b;(function(se){se[se.IDENTICAL=1]="IDENTICAL",se[se.SIMILAR=2]="SIMILAR",se[se.DIFFERENT=3]="DIFFERENT"})(b||(e.EditorPaneSelectionCompareResult=b={}));function r(se){const _=se;return!!_&&typeof _.getSelection=="function"&&!!_.onDidChangeSelection}e.$uE=r;function o(se,_,V){for(const ne of V.visibleEditorPanes)if(ne.group.id===_&&se.matches(ne.input))return ne.getViewState()}e.$vE=o;function t(se){if(S(se))return!1;const _=se;return I.URI.isUri(_?.resource)}e.$wE=t;function n(se){if(S(se))return!1;const _=se;return _?.original!==void 0&&_.modified!==void 0}e.$xE=n;function a(se){if(S(se))return!1;const _=se;return Array.isArray(_?.resources)}e.$yE=a;function c(se){if(S(se)||n(se))return!1;const _=se;return _?.primary!==void 0&&_.secondary!==void 0}e.$zE=c;function h(se){if(S(se))return!1;const _=se;return _?_.resource===void 0||_.resource.scheme===w.Schemas.untitled||_.forceUntitled===!0:!1}e.$AE=h;function i(se){if(S(se))return!1;const _=se;return I.URI.isUri(_?.base?.resource)&&I.URI.isUri(_?.input1?.resource)&&I.URI.isUri(_?.input2?.resource)&&I.URI.isUri(_?.result?.resource)}e.$BE=i;var s;(function(se){se[se.SHORT=0]="SHORT",se[se.MEDIUM=1]="MEDIUM",se[se.LONG=2]="LONG"})(s||(e.Verbosity=s={}));var u;(function(se){se[se.EXPLICIT=1]="EXPLICIT",se[se.AUTO=2]="AUTO",se[se.FOCUS_CHANGE=3]="FOCUS_CHANGE",se[se.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u||(e.SaveReason=u={}));class d{constructor(){this.a=new Map}registerSource(_,V){let ne=this.a.get(_);return ne||(ne={source:_,label:V},this.a.set(_,ne)),ne.source}getSourceLabel(_){return this.a.get(_)?.label??_}}e.$CE=new d;var m;(function(se){se[se.None=0]="None",se[se.Readonly=2]="Readonly",se[se.Untitled=4]="Untitled",se[se.Singleton=8]="Singleton",se[se.RequiresTrust=16]="RequiresTrust",se[se.CanSplitInGroup=32]="CanSplitInGroup",se[se.ForceDescription=64]="ForceDescription",se[se.CanDropIntoEditor=128]="CanDropIntoEditor",se[se.MultipleEditors=256]="MultipleEditors",se[se.Scratchpad=512]="Scratchpad",se[se.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(m||(e.EditorInputCapabilities=m={}));class f extends F.$Sc{}e.$DE=f;function S(se){return se instanceof f}e.$EE=S;function L(se){const _=se;return I.URI.isUri(_?.preferredResource)}function v(se){const _=se;return S(_?.primary)&&S(_?.secondary)}e.$FE=v;function y(se){const _=se;return S(_?.modified)&&S(_?.original)}e.$GE=y;function k(se,_,V,ne,Ie){return ke(ne,[(0,D.$Mi)({id:"workbench.action.openLargeFile",label:(0,E.localize)(2,null),run:()=>{const Ae={...V,limits:{size:Number.MAX_VALUE}};se.openEditor(_,Ae)}}),(0,D.$Mi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,E.localize)(3,null),run:()=>Ie.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}e.$HE=k;function N(se){return S(se?.editor)}e.$IE=N;function O(se){const _=se;return N(se)&&_?.group!==void 0}e.$JE=O;function K(se){const _=se;return typeof _?.groupId=="number"&&S(_.editor)}e.$KE=K;var j;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.REPLACE=1]="REPLACE",se[se.MOVE=2]="MOVE",se[se.UNPIN=3]="UNPIN"})(j||(e.EditorCloseContext=j={}));var W;(function(se){se[se.GROUP_ACTIVE=0]="GROUP_ACTIVE",se[se.GROUP_INDEX=1]="GROUP_INDEX",se[se.GROUP_LABEL=2]="GROUP_LABEL",se[se.GROUP_LOCKED=3]="GROUP_LOCKED",se[se.EDITOR_OPEN=4]="EDITOR_OPEN",se[se.EDITOR_CLOSE=5]="EDITOR_CLOSE",se[se.EDITOR_MOVE=6]="EDITOR_MOVE",se[se.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",se[se.EDITOR_LABEL=8]="EDITOR_LABEL",se[se.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",se[se.EDITOR_PIN=10]="EDITOR_PIN",se[se.EDITOR_STICKY=11]="EDITOR_STICKY",se[se.EDITOR_DIRTY=12]="EDITOR_DIRTY",se[se.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(W||(e.GroupModelChangeKind=W={}));var P;(function(se){se[se.PRIMARY=1]="PRIMARY",se[se.SECONDARY=2]="SECONDARY",se[se.BOTH=3]="BOTH",se[se.ANY=4]="ANY"})(P||(e.SideBySideEditor=P={}));class C{getOriginalUri(_,V){if(!_)return;if(i(_))return e.$ME.getOriginalUri(_.result,V);if(V?.supportSideBySide){const{primary:Ie,secondary:Ae}=this.a(_);if(Ie&&Ae){if(V?.supportSideBySide===P.BOTH)return{primary:this.getOriginalUri(Ie,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(Ae,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===P.ANY)return this.getOriginalUri(Ie,{filterByScheme:V.filterByScheme})??this.getOriginalUri(Ae,{filterByScheme:V.filterByScheme});_=V.supportSideBySide===P.PRIMARY?Ie:Ae}}if(n(_)||a(_)||c(_)||i(_))return;const ne=L(_)?_.preferredResource:_.resource;return!ne||!V||!V.filterByScheme?ne:this.b(ne,V.filterByScheme)}a(_){return v(_)||c(_)?{primary:_.primary,secondary:_.secondary}:y(_)||n(_)?{primary:_.modified,secondary:_.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(_,V){if(!_)return;if(i(_))return e.$ME.getCanonicalUri(_.result,V);if(V?.supportSideBySide){const{primary:Ie,secondary:Ae}=this.a(_);if(Ie&&Ae){if(V?.supportSideBySide===P.BOTH)return{primary:this.getCanonicalUri(Ie,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(Ae,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===P.ANY)return this.getCanonicalUri(Ie,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(Ae,{filterByScheme:V.filterByScheme});_=V.supportSideBySide===P.PRIMARY?Ie:Ae}}if(n(_)||a(_)||c(_)||i(_))return;const ne=_.resource;return!ne||!V||!V.filterByScheme?ne:this.b(ne,V.filterByScheme)}b(_,V){if(Array.isArray(V)){if(V.some(ne=>_.scheme===ne))return _}else if(V===_.scheme)return _}}var J;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.KEYBOARD=1]="KEYBOARD",se[se.MOUSE=2]="MOUSE"})(J||(e.EditorCloseMethod=J={}));function ae(se,_,V,ne){if(!se.isSticky(_))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return V===J.MOUSE||V===J.KEYBOARD;case"mouse":return V===J.MOUSE;case"keyboard":return V===J.KEYBOARD}return!1}e.$LE=ae,e.$ME=new C;var fe;(function(se){se[se.LEFT=0]="LEFT",se[se.RIGHT=1]="RIGHT"})(fe||(e.CloseDirection=fe={}));class be{constructor(){this.c=new Map,this.d=new Map}start(_){const V=this.a=_.get(R.$2h);for(const[ne,Ie]of this.c)this.e(ne,Ie,V);this.c.clear()}e(_,V,ne){const Ie=ne.createInstance(V);this.d.set(_,Ie)}registerFileEditorFactory(_){if(this.b)throw new Error("Can only register one file editor factory.");this.b=_}getFileEditorFactory(){return(0,T.$Qf)(this.b)}registerEditorSerializer(_,V){if(this.c.has(_)||this.d.has(_))throw new Error(`A editor serializer with type ID '${_}' was already registered.`);return this.a?this.e(_,V,this.a):this.c.set(_,V),(0,F.$Qc)(()=>{this.c.delete(_),this.d.delete(_)})}getEditorSerializer(_){return this.d.get(typeof _=="string"?_:_.typeId)}}$.$vn.add(e.$pE.EditorFactory,new be);async function ye(se,_,V){return!se||!se.length?[]:await Promise.all(se.map(async ne=>{const Ie=I.URI.revive(ne.fileUri);if(!Ie){V.info("Cannot resolve the path because it is not valid.",ne);return}if(!await _.canHandleResource(Ie)){V.info("Cannot resolve the path because it cannot be handled",ne);return}let Pe=ne.exists,ce=ne.type;if(typeof Pe!="boolean"||typeof ce!="number")try{ce=(await _.stat(Ie)).isDirectory?g.FileType.Directory:g.FileType.Unknown,Pe=!0}catch(Q){V.error(Q),Pe=!1}if(!Pe&&ne.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",ne);return}if(ce===g.FileType.Directory){V.info("Cannot resolve the path because it is a directory",ne);return}const ie={...ne.options,pinned:!0};return Pe?{resource:Ie,options:ie}:{resource:Ie,options:ie,forceUntitled:!0}}))}e.$NE=ye;var he;(function(se){se[se.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",se[se.SEQUENTIAL=1]="SEQUENTIAL"})(he||(e.EditorsOrder=he={}));function ve(se){const _=se;if(!_)return!1;const V=_;if(V.modified)return ve(V.modified);const ne=_;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.$OE=ve;function ee(se){return(0,A.$Oi)(se)}e.$PE=ee;function ke(se,_,V){const ne=(0,A.$Pi)(se,_);return ne.forceMessage=V?.forceMessage,ne.forceSeverity=V?.forceSeverity,ne.allowDialog=V?.allowDialog,ne}e.$QE=ke}),define(Ce[205],Re([1,0,5,172,4,6,28,30,18,26,90,196]),function(ge,e,E,T,I,F,R,$,g,w,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZE=e.$YE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$XE=e.$WE=e.ViewContentGroups=e.$VE=e.$UE=e.ViewContainerLocation=e.Extensions=e.$TE=e.$SE=e.$RE=void 0,e.$RE="views",e.$SE=(0,T.localize)(0,null),e.$TE=(0,D.$kw)("default-view-icon",A.$9j.window,(0,T.localize)(1,null));var l;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var p;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$UE=[0,1,2];function b(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$VE=b;class r extends F.$Sc{constructor(){super(...arguments),this.c=this.B(new E.$Sd),this.onDidRegister=this.c.event,this.f=this.B(new E.$Sd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,g.$Rb)([...this.g.values()])}registerViewContainer(u,d,m){const f=this.get(u.id);if(f)return f;const S=u;return S.openCommandActionDescriptor=m?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,R.$xc)(this.g,d,[]).push(S),m?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:d}),S}deregisterViewContainer(u){for(const d of this.g.keys()){const m=this.g.get(d),f=m?.indexOf(u);if(f!==-1){m?.splice(f,1),m.length===0&&this.g.delete(d),this.f.fire({viewContainer:u,viewContainerLocation:d});return}}}get(u){return this.all.filter(d=>d.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(m=>m?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(d=>this.getViewContainerLocation(d)===u)}}$.$vn.add(l.ViewContainersRegistry,new r);var o;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(o||(e.ViewContentGroups=o={}));function t(s,u){const d=s.group??o.More,m=u.group??o.More;return d!==m?d.localeCompare(m):(s.order??5)-(u.order??5)}class n extends F.$Sc{constructor(){super(...arguments),this.c=this.B(new E.$Sd),this.onViewsRegistered=this.c.event,this.f=this.B(new E.$Sd),this.onViewsDeregistered=this.f.event,this.g=this.B(new E.$Sd),this.onDidChangeContainer=this.g.event,this.h=this.B(new E.$Sd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Gc}registerViews(u,d){this.registerViews2([{views:u,viewContainer:d}])}registerViews2(u){u.forEach(({views:d,viewContainer:m})=>this.r(d,m)),this.c.fire(u)}deregisterViews(u,d){const m=this.s(u,d);m.length&&this.f.fire({views:m,viewContainer:d})}moveViews(u,d){for(const m of this.m.keys())if(m!==d){const f=this.s(u,m);f.length&&(this.r(f,d),this.g.fire({views:f,from:m,to:d}))}}getViews(u){return this.m.get(u)||[]}getView(u){for(const d of this.j){const m=(this.m.get(d)||[]).filter(f=>f.id===u)[0];if(m)return m}return null}getViewContainer(u){for(const d of this.j)if((this.m.get(d)||[]).filter(f=>f.id===u)[0])return d;return null}registerViewWelcomeContent(u,d){return this.n.add(u,d),this.h.fire(u),(0,F.$Qc)(()=>{this.n.delete(u,d),this.h.fire(u)})}registerViewWelcomeContent2(u,d){const m=new Map;for(const[f,S]of d)this.n.add(u,S),m.set(f,(0,F.$Qc)(()=>{this.n.delete(u,S),this.h.fire(u)}));return this.h.fire(u),m}getViewWelcomeContent(u){const d=[];return this.n.forEach(u,m=>d.push(m)),d.sort(t)}r(u,d){let m=this.m.get(d);m||(m=[],this.m.set(d,m),this.j.push(d));for(const f of u){if(this.getView(f.id)!==null)throw new Error((0,T.localize)(2,null,f.id));m.push(f)}}s(u,d){const m=this.m.get(d);if(!m)return[];const f=[],S=[];for(const L of m)u.includes(L)?f.push(L):S.push(L);return f.length&&(S.length?this.m.set(d,S):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),f}}$.$vn.add(l.ViewsRegistry,new n),e.$WE=(0,I.$3h)("viewsService"),e.$XE=(0,I.$3h)("viewDescriptorService");var a;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(a||(e.ViewVisibilityState=a={}));var c;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class h{constructor(u,d){this.c=!1,this.d=!1,(0,w.$mn)(this,u),this.d=!!d,this.resolve=async m=>{if(d&&!this.c){const f=await d(m);f&&(this.tooltip=this.tooltip??f.tooltip,this.command=this.command??f.command)}m.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$YE=h;class i extends Error{constructor(u){super((0,T.localize)(3,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.$ZE=i}),define(Ce[206],Re([1,0,2,29,4]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RF=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$QF=e.$PF=void 0;function F(w){return!!w&&typeof w=="object"&&"uri"in w&&w.uri instanceof E.URI&&"version"in w&&typeof w.version=="number"&&"ranges"in w&&Array.isArray(w.ranges)&&w.ranges.every(T.$Is.isIRange)}e.$PF=F;function R(w){return!!w&&typeof w=="object"&&"documents"in w&&Array.isArray(w.documents)&&w.documents.every(F)}e.$QF=R;var $;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})($||(e.InteractiveSessionVoteDirection=$={}));var g;(function(w){w[w.Action=1]="Action",w[w.Toolbar=2]="Toolbar"})(g||(e.ChatAgentCopyKind=g={})),e.$RF=(0,I.$3h)("IChatService")}),define(Ce[207],Re([1,0,5,13,173]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xlb=void 0;class F{constructor(){this.f=new Map,this.k=[],this.m=new E.$Sd,this.n=new E.$Sd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage($){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=$}onEvent($){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=$}onRequest($){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=$}sendResponse($){$.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${$.command}`)):this.s("response",$)}sendRequest($,g,w,A){const D={command:$};if(g&&Object.keys(g).length>0&&(D.arguments=g),this.s("request",D),typeof A=="number"){const l=setTimeout(()=>{clearTimeout(l);const p=this.f.get(D.seq);if(p){this.f.delete(D.seq);const b={type:"response",seq:0,request_seq:D.seq,success:!1,command:$,message:(0,I.localize)(0,null,A,$)};p(b)}},A)}return w&&this.f.set(D.seq,w),D.seq}acceptMessage($){this.j?this.j($):(this.k.push($),this.k.length===1&&this.q())}o($,g){return $.type!=="event"||g.type!=="event"}async q(){let $;for(;this.k.length;){if((!$||this.o(this.k[0],$))&&await(0,T.$4g)(0),$=this.k.shift(),!$)return;switch($.type){case"event":this.i?.($);break;case"request":this.g?.($);break;case"response":{const g=$,w=this.f.get(g.request_seq);w&&(this.f.delete(g.request_seq),w(g));break}}}}s($,g){g.type=$,g.seq=this.d++,this.sendMessage(g)}async u(){if(this.f.size===0)return Promise.resolve();const $=new Map;this.f.forEach((g,w)=>$.set(w,g)),await(0,T.$4g)(500),$.forEach((g,w)=>{g({type:"response",seq:0,request_seq:w,success:!1,command:"canceled",message:"canceled"}),this.f.delete(w)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$xlb=F}),define(Ce[208],Re([1,0,174,35,4]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$AH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$zH=e.MemoryRangeType=e.$yH=e.State=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=void 0,e.$vG="workbench.view.debug",e.$wG="workbench.debug.variablesView",e.$xG="workbench.debug.watchExpressionsView",e.$yG="workbench.debug.callStackView",e.$zG="workbench.debug.loadedScriptsView",e.$AG="workbench.debug.breakPointsView",e.$BG="workbench.debug.disassemblyView",e.$CG="workbench.panel.repl",e.$DG="workbench.panel.repl.view",e.$EG=new T.$hj("debugType",void 0,{type:"string",description:E.localize(0,null)}),e.$FG=new T.$hj("debugConfigurationType",void 0,{type:"string",description:E.localize(1,null)}),e.$GG=new T.$hj("debugState","inactive",{type:"string",description:E.localize(2,null)}),e.$HG="debugUx",e.$IG=new T.$hj(e.$HG,"default",{type:"string",description:E.localize(3,null)}),e.$JG=new T.$hj("hasDebugged",!1,{type:"boolean",description:E.localize(4,null)}),e.$KG=new T.$hj("inDebugMode",!1,{type:"boolean",description:E.localize(5,null)}),e.$LG=new T.$hj("inDebugRepl",!1,{type:"boolean",description:E.localize(6,null)}),e.$MG=new T.$hj("breakpointWidgetVisible",!1,{type:"boolean",description:E.localize(7,null)}),e.$NG=new T.$hj("inBreakpointWidget",!1,{type:"boolean",description:E.localize(8,null)}),e.$OG=new T.$hj("breakpointsFocused",!0,{type:"boolean",description:E.localize(9,null)}),e.$PG=new T.$hj("watchExpressionsFocused",!0,{type:"boolean",description:E.localize(10,null)}),e.$QG=new T.$hj("watchExpressionsExist",!1,{type:"boolean",description:E.localize(11,null)}),e.$RG=new T.$hj("variablesFocused",!0,{type:"boolean",description:E.localize(12,null)}),e.$SG=new T.$hj("expressionSelected",!1,{type:"boolean",description:E.localize(13,null)}),e.$TG=new T.$hj("breakpointInputFocused",!1,{type:"boolean",description:E.localize(14,null)}),e.$UG=new T.$hj("callStackItemType",void 0,{type:"string",description:E.localize(15,null)}),e.$VG=new T.$hj("callStackSessionIsAttach",!1,{type:"boolean",description:E.localize(16,null)}),e.$WG=new T.$hj("callStackItemStopped",!1,{type:"boolean",description:E.localize(17,null)}),e.$XG=new T.$hj("callStackSessionHasOneThread",!1,{type:"boolean",description:E.localize(18,null)}),e.$YG=new T.$hj("watchItemType",void 0,{type:"string",description:E.localize(19,null)}),e.$ZG=new T.$hj("canViewMemory",void 0,{type:"boolean",description:E.localize(20,null)}),e.$1G=new T.$hj("breakpointItemType",void 0,{type:"string",description:E.localize(21,null)}),e.$2G=new T.$hj("breakpointSupportsCondition",!1,{type:"boolean",description:E.localize(22,null)}),e.$3G=new T.$hj("loadedScriptsSupported",!1,{type:"boolean",description:E.localize(23,null)}),e.$4G=new T.$hj("loadedScriptsItemType",void 0,{type:"string",description:E.localize(24,null)}),e.$5G=new T.$hj("focusedSessionIsAttach",!1,{type:"boolean",description:E.localize(25,null)}),e.$6G=new T.$hj("focusedSessionIsNoDebug",!1,{type:"boolean",description:E.localize(26,null)}),e.$7G=new T.$hj("stepBackSupported",!1,{type:"boolean",description:E.localize(27,null)}),e.$8G=new T.$hj("restartFrameSupported",!1,{type:"boolean",description:E.localize(28,null)}),e.$9G=new T.$hj("stackFrameSupportsRestart",!1,{type:"boolean",description:E.localize(29,null)}),e.$0G=new T.$hj("jumpToCursorSupported",!1,{type:"boolean",description:E.localize(30,null)}),e.$$G=new T.$hj("stepIntoTargetsSupported",!1,{type:"boolean",description:E.localize(31,null)}),e.$_G=new T.$hj("breakpointsExist",!1,{type:"boolean",description:E.localize(32,null)}),e.$aH=new T.$hj("debuggersAvailable",!1,{type:"boolean",description:E.localize(33,null)}),e.$bH=new T.$hj("debugExtensionAvailable",!0,{type:"boolean",description:E.localize(34,null)}),e.$cH=new T.$hj("debugProtocolVariableMenuContext",void 0,{type:"string",description:E.localize(35,null)}),e.$dH=new T.$hj("debugSetVariableSupported",!1,{type:"boolean",description:E.localize(36,null)}),e.$eH=new T.$hj("debugSetExpressionSupported",!1,{type:"boolean",description:E.localize(37,null)}),e.$fH=new T.$hj("breakWhenValueChangesSupported",!1,{type:"boolean",description:E.localize(38,null)}),e.$gH=new T.$hj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:E.localize(39,null)}),e.$hH=new T.$hj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:E.localize(40,null)}),e.$iH=new T.$hj("terminateDebuggeeSupported",!1,{type:"boolean",description:E.localize(41,null)}),e.$jH=new T.$hj("suspendDebuggeeSupported",!1,{type:"boolean",description:E.localize(42,null)}),e.$kH=new T.$hj("variableEvaluateNamePresent",!1,{type:"boolean",description:E.localize(43,null)}),e.$lH=new T.$hj("variableIsReadonly",!1,{type:"boolean",description:E.localize(44,null)}),e.$mH=new T.$hj("exceptionWidgetVisible",!1,{type:"boolean",description:E.localize(45,null)}),e.$nH=new T.$hj("multiSessionRepl",!1,{type:"boolean",description:E.localize(46,null)}),e.$oH=new T.$hj("multiSessionDebug",!1,{type:"boolean",description:E.localize(47,null)}),e.$pH=new T.$hj("disassembleRequestSupported",!1,{type:"boolean",description:E.localize(48,null)}),e.$qH=new T.$hj("disassemblyViewFocus",!1,{type:"boolean",description:E.localize(49,null)}),e.$rH=new T.$hj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:E.localize(50,null)}),e.$sH=new T.$hj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:E.localize(51,null)});const F=l=>E.localize(52,null,l);e.$tH=F,e.$uH="editor.contrib.debug",e.$vH="editor.contrib.breakpoint",e.$wH="debug",e.$xH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:E.localize(53,null)};var R;(function(l){l[l.Inactive=0]="Inactive",l[l.Initializing=1]="Initializing",l[l.Stopped=2]="Stopped",l[l.Running=3]="Running"})(R||(e.State=R={}));function $(l){switch(l){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$yH=$;var g;(function(l){l[l.Valid=0]="Valid",l[l.Unreadable=1]="Unreadable",l[l.Error=2]="Error"})(g||(e.MemoryRangeType=g={})),e.$zH="vscode-debug-memory";var w;(function(l){l[l.Initial=1]="Initial",l[l.Dynamic=2]="Dynamic"})(w||(e.DebugConfigurationProviderTriggerKind=w={}));var A;(function(l){l.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$AH=(0,I.$3h)("debugService");var D;(function(l){l[l.CONDITION=0]="CONDITION",l[l.HIT_COUNT=1]="HIT_COUNT",l[l.LOG_MESSAGE=2]="LOG_MESSAGE"})(D||(e.BreakpointWidgetContext=D={}))}),define(Ce[209],Re([1,0,11,2,19,26,12,29,20,18]),function(ge,e,E,T,I,F,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=void 0;const A=/{([^}]+)}/g;function D(L,v,y){return L.replace(A,function(k,N){return v&&N.length>0&&N[0]!=="_"?k:y&&y.hasOwnProperty(N)?y[N]:k})}e.$WF=D;function l(L){const v={};for(const y of Object.keys(L))y.startsWith("!")||(v[y]=L[y]);return v}e.$XF=l;function p(L){return L.configuration.request==="attach"&&!b(L)&&(!L.parentSession||p(L.parentSession))}e.$YF=p;function b(L){let v=L.configuration.type;if(v)return v==="vslsShare"&&(v=L.configuration.adapterProxy.configuration.type),(0,E.$9e)(v,"extensionhost")||(0,E.$9e)(v,"pwa-extensionhost")?L:L.parentSession?b(L.parentSession):void 0}e.$ZF=b;function r(L){return L.type&&(L.label||L.program||L.runtime)}e.$1F=r;function o(L,v,y){let k,N=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let K=null;for(;K=O.exec(L);){const j=K.index+1,W=j+K[0].length;if(j<=v&&W>=y){k=K[0],N=j;break}}if(k){const j=/\w+/g;let W=null;for(;(W=j.exec(k))&&!(W.index+1+N+W[0].length>=y););W&&(k=k.substring(0,j.lastIndex))}return k?{start:N,end:N+k.length-1}:{start:0,end:0}}e.$2F=o;async function t(L,v,y,k){if(L.evaluatableExpressionProvider.has(v)){const N=L.evaluatableExpressionProvider.ordered(v),O=(0,w.$Hb)(await Promise.all(N.map(async K=>{try{return await K.provideEvaluatableExpression(v,y,k??g.CancellationToken.None)}catch{return}})));if(O.length>0){let K=O[0].expression;const j=O[0].range;return K||(K=v.getLineContent(y.lineNumber).substring(j.startColumn-1,j.endColumn-1)),{range:j,matchingExpression:K}}}else{const N=v.getLineContent(y.lineNumber),{start:O,end:K}=o(N,y.column,y.column),j=N.substring(O-1,K);return{matchingExpression:j,range:new $.$Is(y.lineNumber,O,y.lineNumber,O+j.length)}}return null}e.$3F=t;const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function a(L){return!!(L&&L.match(n))}e.$4F=a;function c(L){if(typeof L.path=="string"&&!(typeof L.sourceReference=="number"&&L.sourceReference>0)){if(a(L.path))return T.URI.parse(L.path);if((0,I.$ic)(L.path))return T.URI.file(L.path)}return L.path}function h(L){if(typeof L.path=="object"){const v=T.URI.revive(L.path);if(v)return v.scheme===R.Schemas.file?v.fsPath:v.toString()}return L.path}function i(L,v){const y=v?c:h,k=(0,F.$jn)(L);return u(k,(N,O)=>{N&&O&&(O.path=y(O))}),k}e.$5F=i;function s(L,v){const y=v?c:h,k=(0,F.$jn)(L);return u(k,(N,O)=>{!N&&O&&(O.path=y(O))}),k}e.$6F=s;function u(L,v){switch(L.type){case"event":{const y=L;switch(y.event){case"output":v(!1,y.body.source);break;case"loadedSource":v(!1,y.body.source);break;case"breakpoint":v(!1,y.body.breakpoint.source);break;default:break}break}case"request":{const y=L;switch(y.command){case"setBreakpoints":v(!0,y.arguments.source);break;case"breakpointLocations":v(!0,y.arguments.source);break;case"source":v(!0,y.arguments.source);break;case"gotoTargets":v(!0,y.arguments.source);break;case"launchVSCode":y.arguments.args.forEach(k=>v(!1,k));break;default:break}break}case"response":{const y=L;if(y.success&&y.body)switch(y.command){case"stackTrace":y.body.stackFrames.forEach(k=>v(!1,k.source));break;case"loadedSources":y.body.sources.forEach(k=>v(!1,k));break;case"scopes":y.body.scopes.forEach(k=>v(!1,k.source));break;case"setFunctionBreakpoints":y.body.breakpoints.forEach(k=>v(!1,k.source));break;case"setBreakpoints":y.body.breakpoints.forEach(k=>v(!1,k.source));break;case"disassemble":y.body?.instructions.forEach(N=>v(!1,N.location));break;default:break}break}}}function d(L){return L.filter(v=>!v.presentation?.hidden).sort((v,y)=>v.presentation?y.presentation?v.presentation.group?y.presentation.group?v.presentation.group!==y.presentation.group?v.presentation.group.localeCompare(y.presentation.group):m(v.presentation.order,y.presentation.order):-1:y.presentation.group?1:m(v.presentation.order,y.presentation.order):-1:y.presentation?1:0)}e.$7F=d;function m(L,v){return typeof L!="number"?typeof v!="number"?0:1:typeof v!="number"?-1:L-v}async function f(L,v){const y=L.getValue("debug.saveBeforeStart",{overrideIdentifier:v.activeTextEditorLanguageId});if(y!=="none"&&(await v.saveAll(),y==="allEditorsInActiveGroup")){const k=v.activeEditorPane;k&&k.input.resource?.scheme===R.Schemas.untitled&&await v.save({editor:k.input,groupId:k.group.id})}await L.reloadConfiguration()}e.$8F=f;const S=(L,v)=>!L||!v?L===v:L.name===v.name&&L.path===v.path&&L.sourceReference===v.sourceReference;e.$9F=S}),define(Ce[76],Re([1,0,24,34,67,68,12,19,21,35]),function(ge,e,E,T,I,F,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WI=e.$VI=e.$UI=e.$TI=e.CellStatusbarAlignment=e.$SI=e.$RI=e.$QI=e.NotebookEditorPriority=e.$PI=e.$OI=e.$NI=e.$MI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$LI=e.$KI=e.$JI=e.$II=e.CellKind=e.$HI=e.$GI=e.$FI=void 0,e.$FI="workbench.editor.notebook",e.$GI="workbench.editor.notebookTextDiffEditor",e.$HI="workbench.editor.interactive";var A;(function(C){C[C.Markup=1]="Markup",C[C.Code=2]="Code"})(A||(e.CellKind=A={})),e.$II=["application/json","application/javascript","text/html","image/svg+xml",F.$5r.latex,F.$5r.markdown,"image/png","image/jpeg",F.$5r.text],e.$JI=[F.$5r.latex,F.$5r.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",F.$5r.text],e.$KI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$LI="_notAvailable";var D;(function(C){C[C.Running=1]="Running",C[C.Idle=2]="Idle"})(D||(e.NotebookRunState=D={}));var l;(function(C){C[C.Unconfirmed=1]="Unconfirmed",C[C.Pending=2]="Pending",C[C.Executing=3]="Executing"})(l||(e.NotebookCellExecutionState=l={}));var p;(function(C){C[C.Unconfirmed=1]="Unconfirmed",C[C.Pending=2]="Pending",C[C.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var b;(function(C){C[C.WithHardKernelDependency=0]="WithHardKernelDependency",C[C.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",C[C.Pure=2]="Pure",C[C.Never=3]="Never"})(b||(e.NotebookRendererMatch=b={}));var r;(function(C){C.Always="always",C.Never="never",C.Optional="optional"})(r||(e.RendererMessagingSpec=r={}));var o;(function(C){C[C.ModelChange=1]="ModelChange",C[C.Move=2]="Move",C[C.ChangeCellLanguage=5]="ChangeCellLanguage",C[C.Initialize=6]="Initialize",C[C.ChangeCellMetadata=7]="ChangeCellMetadata",C[C.Output=8]="Output",C[C.OutputItem=9]="OutputItem",C[C.ChangeCellContent=10]="ChangeCellContent",C[C.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",C[C.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",C[C.ChangeCellMime=13]="ChangeCellMime",C[C.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var t;(function(C){C[C.Handle=0]="Handle",C[C.Index=1]="Index"})(t||(e.SelectionStateType=t={}));var n;(function(C){C[C.Replace=1]="Replace",C[C.Output=2]="Output",C[C.Metadata=3]="Metadata",C[C.CellLanguage=4]="CellLanguage",C[C.DocumentMetadata=5]="DocumentMetadata",C[C.Move=6]="Move",C[C.OutputItems=7]="OutputItems",C[C.PartialMetadata=8]="PartialMetadata",C[C.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var a;(function(C){C.scheme=R.Schemas.vscodeNotebookCell;const J=["W","X","Y","Z","a","b","c","d","e","f"],ae=new RegExp(`^[${J.join("")}]+`),fe=7;function be(se,_){const V=_.toString(fe),Ie=`${V.length<J.length?J[V.length-1]:"z"}${V}s${(0,E.$Ae)(E.$ge.fromString(se.scheme),!0,!0)}`;return se.with({scheme:C.scheme,fragment:Ie})}C.generate=be;function ye(se){if(se.scheme!==C.scheme)return;const _=se.fragment.indexOf("s");if(_<0)return;const V=parseInt(se.fragment.substring(0,_).replace(ae,""),fe),ne=(0,E.$ze)(se.fragment.substring(_+1)).toString();if(!isNaN(V))return{handle:V,notebook:se.with({scheme:ne,fragment:null})}}C.parse=ye;function he(se,_){return se.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${_??""},${se.scheme!==R.Schemas.file?se.scheme:""}`})}C.generateCellOutputUri=he;function ve(se){if(se.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const _=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(se.fragment);if(!_)return;const V=_[1]&&_[1]!==""?_[1]:void 0,ne=_[2];return{outputId:V,notebook:se.with({scheme:ne||R.Schemas.file,fragment:null})}}C.parseCellOutputUri=ve;function ee(se,_,V){return C.generate(se,_).with({scheme:V})}C.generateCellPropertyUri=ee;function ke(se,_){if(se.scheme===_)return C.parse(se.with({scheme:C.scheme}))}C.parseCellPropertyUri=ke})(a||(e.CellUri=a={}));const c=C=>g.$i?C.replace(/\//g,"\\"):C;class h{constructor(J=[],ae=e.$II){this.e=ae,this.d=[...new Set(J)].map(fe=>({pattern:fe,matches:T.$Jj(c(fe))}))}sort(J){const ae=new Map(I.Iterable.map(J,be=>[be,c(be)]));let fe=[];for(const{matches:be}of this.d)for(const[ye,he]of ae)if(be(he)){fe.push(ye),ae.delete(ye);break}return ae.size&&(fe=fe.concat([...ae.keys()].sort((be,ye)=>this.e.indexOf(be)-this.e.indexOf(ye)))),fe}prioritize(J,ae){const fe=this.f(J);if(fe===-1){this.d.unshift({pattern:J,matches:T.$Jj(c(J))});return}const be=new Set(ae.map(he=>this.f(he,fe)));be.delete(-1);const ye=Array.from(be).sort();this.d.splice(fe+1,0,...ye.map(he=>this.d[he]));for(let he=ye.length-1;he>=0;he--)this.d.splice(ye[he],1)}toArray(){return this.d.map(J=>J.pattern)}f(J,ae=this.d.length){const fe=c(J);for(let be=0;be<ae;be++)if(this.d[be].matches(fe))return be;return-1}}e.$MI=h;function i(C,J,ae,fe=(be,ye)=>be===ye){const be=[];function ye(ee,ke,se){if(ke===0&&se.length===0)return;const _=be[be.length-1];_&&_.start+_.deleteCount===ee?(_.deleteCount+=ke,_.toInsert.push(...se)):be.push({start:ee,deleteCount:ke,toInsert:se})}let he=0,ve=0;for(;;){if(he===C.length){ye(he,0,J.slice(ve));break}if(ve===J.length){ye(he,C.length-he,[]);break}const ee=C[he],ke=J[ve];if(fe(ee,ke)){he+=1,ve+=1;continue}ae(ke)?(ye(he,1,[]),he+=1):(ye(he,0,[ke]),ve+=1)}return be}e.$NI=i,e.$OI=new w.$hj("notebookEditorCursorAtBoundary","none"),e.$PI=new w.$hj("notebookEditorCursorAtLineBoundary","none");var s;(function(C){C.default="default",C.option="option"})(s||(e.NotebookEditorPriority=s={}));function u(C){const J=C;return!!((typeof J.include=="string"||T.$Kj(J.include))&&(typeof J.exclude=="string"||T.$Kj(J.exclude)))}e.$QI=u;function d(C,J,ae){if(Array.isArray(C.viewType)&&C.viewType.indexOf(J)>=0||C.viewType===J)return!0;if(C.filenamePattern){const fe=u(C.filenamePattern)?C.filenamePattern.include:C.filenamePattern,be=u(C.filenamePattern)?C.filenamePattern.exclude:void 0;if(T.$Ij(fe,(0,$.$nc)(ae.fsPath).toLowerCase()))return!(be&&T.$Ij(be,(0,$.$nc)(ae.fsPath).toLowerCase()))}return!1}e.$RI=d,e.$SI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var m;(function(C){C[C.Left=1]="Left",C[C.Right=2]="Right"})(m||(e.CellStatusbarAlignment=m={}));class f{static{this.d="notebook/"}static create(J){return`${f.d}${J}`}static parse(J){if(J.startsWith(f.d))return J.substring(f.d.length)}}e.$TI=f;function S(C){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(C)}e.$UI=S;const L=new TextDecoder;function v(C){const J=[];let ae=!1;for(const he of C)(J.length===0||ae)&&(J.push(he),ae=!0);let fe=N(J);const be=E.$ge.concat(J.map(he=>E.$ge.wrap(he))),ye=P(be);return fe=fe||ye.byteLength!==be.byteLength,{data:ye,didCompression:fe}}e.$VI=v,e.$WI=`${String.fromCharCode(27)}[A`;const y=e.$WI.split("").map(C=>C.charCodeAt(0)),k=10;function N(C){let J=!1;return C.forEach((ae,fe)=>{if(fe===0||ae.length<e.$WI.length)return;const be=C[fe-1],ye=ae.subarray(0,e.$WI.length);if(ye[0]===y[0]&&ye[1]===y[1]&&ye[2]===y[2]){const he=be.lastIndexOf(k);if(he===-1)return;J=!0,C[fe-1]=be.subarray(0,he),C[fe]=ae.subarray(e.$WI.length)}}),J}function O(C){let J=C;do C=J,J=C.replace(/[^\n]\x08/gm,"");while(J.length<C.length);return C}function K(C){for(C=C.replace(/\r+\n/gm,`
`);C.search(/\r[^$]/g)>-1;){const J=C.match(/^(.*)\r+/m)[1];let ae=C.match(/\r+(.*)$/m)[1];ae=ae+J.slice(ae.length,J.length),C=C.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ae)}return C}const j="\b".charCodeAt(0),W="\r".charCodeAt(0);function P(C){return!C.buffer.includes(j)&&!C.buffer.includes(W)?C:E.$ge.fromString(K(O(L.decode(C.buffer))))}}),define(Ce[7],Re([1,0,18,15,52,28,68,11,16,2,33,22,42,100,76]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l,p,b){"use strict";var r,o,t,n,a,c,h,i,s,u,d,m,f,S,L,v,y;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$JM=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$IM=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=e.$CM=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$wM=e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.TestRunProfileKind=e.TestResultState=e.$oM=e.$nM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$mM=e.NotebookVariablesRequestKind=e.$lM=e.$kM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$jM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.ColorThemeKind=e.$dM=e.$cM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$bM=e.DebugConsoleMode=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$8L=e.$7L=e.FileChangeType=e.$6L=e.$5L=e.$4L=e.$3L=e.InlineCompletionTriggerKind=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.ConfigurationTarget=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$FL=e.ViewBadge=e.ProgressLocation=e.$EL=e.$DL=e.TaskScope=e.ShellQuoting=e.$CL=e.$BL=e.$AL=e.TaskPanelKind=e.TaskRevealKind=e.$zL=e.TerminalLocation=e.$yL=e.$xL=e.$wL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$vL=e.$uL=e.$tL=e.$sL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$rL=e.StatusBarAlignment=e.ViewColumn=e.$qL=e.$pL=e.$oL=e.$nL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$mL=e.$lL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.LanguageStatusSeverity=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.CodeActionTriggerKind=e.$_K=e.$$K=e.SymbolTag=e.SymbolKind=e.$0K=e.$9K=e.DocumentHighlightKind=e.$8K=e.$7K=e.$6K=e.$5K=e.DiagnosticSeverity=e.DiagnosticTag=e.$4K=e.$3K=e.FileEditType=e.$2K=e.$1K=e.$ZK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function k(B){return Object.assign(B,{apply:function(...oe){if(oe.length===0)return Reflect.construct(B,[]);{const De=oe.length===1?[]:oe[1];return Reflect.construct(B,De,oe[0].constructor)}},call:function(...oe){if(oe.length===0)return Reflect.construct(B,[]);{const[De,...Je]=oe;return Reflect.construct(B,Je,De.constructor)}}})}var N;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(N||(e.TerminalOutputAnchor=N={}));var O;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(O||(e.TerminalQuickFixType=O={}));let K=r=class{static from(...z){let oe=z;return new r(function(){if(oe){for(const De of oe)De&&typeof De.dispose=="function"&&De.dispose();oe=void 0}})}#e;constructor(z){this.#e=z}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$SK=K,e.$SK=K=r=Ge([k],K);let j=o=class{static Min(...z){if(z.length===0)throw new TypeError;let oe=z[0];for(let De=1;De<z.length;De++){const Je=z[De];Je.isBefore(oe)&&(oe=Je)}return oe}static Max(...z){if(z.length===0)throw new TypeError;let oe=z[0];for(let De=1;De<z.length;De++){const Je=z[De];Je.isAfter(oe)&&(oe=Je)}return oe}static isPosition(z){if(!z)return!1;if(z instanceof o)return!0;const{line:oe,character:De}=z;return typeof oe=="number"&&typeof De=="number"}static of(z){if(z instanceof o)return z;if(this.isPosition(z))return new o(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(z,oe){if(z<0)throw(0,T.$7)("line must be non-negative");if(oe<0)throw(0,T.$7)("character must be non-negative");this.c=z,this.e=oe}isBefore(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<z.e}isBeforeOrEqual(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<=z.e}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this.c===z.c&&this.e===z.e}compareTo(z){return this.c<z.c?-1:this.c>z.line?1:this.e<z.e?-1:this.e>z.e?1:0}translate(z,oe=0){if(z===null||oe===null)throw(0,T.$7)();let De;return typeof z>"u"?De=0:typeof z=="number"?De=z:(De=typeof z.lineDelta=="number"?z.lineDelta:0,oe=typeof z.characterDelta=="number"?z.characterDelta:0),De===0&&oe===0?this:new o(this.line+De,this.character+oe)}with(z,oe=this.character){if(z===null||oe===null)throw(0,T.$7)();let De;return typeof z>"u"?De=this.line:typeof z=="number"?De=z:(De=typeof z.line=="number"?z.line:this.line,oe=typeof z.character=="number"?z.character:this.character),De===this.line&&oe===this.character?this:new o(De,oe)}toJSON(){return{line:this.line,character:this.character}}};e.$TK=j,e.$TK=j=o=Ge([k],j);let W=t=class{static isRange(z){return z instanceof t?!0:z?j.isPosition(z.start)&&j.isPosition(z.end):!1}static of(z){if(z instanceof t)return z;if(this.isRange(z))return new t(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(z,oe,De,Je){let xe,ut;if(typeof z=="number"&&typeof oe=="number"&&typeof De=="number"&&typeof Je=="number"?(xe=new j(z,oe),ut=new j(De,Je)):j.isPosition(z)&&j.isPosition(oe)&&(xe=j.of(z),ut=j.of(oe)),!xe||!ut)throw new Error("Invalid arguments");xe.isBefore(ut)?(this.c=xe,this.e=ut):(this.c=ut,this.e=xe)}contains(z){return t.isRange(z)?this.contains(z.start)&&this.contains(z.end):j.isPosition(z)?!(j.of(z).isBefore(this.c)||this.e.isBefore(z)):!1}isEqual(z){return this.c.isEqual(z.c)&&this.e.isEqual(z.e)}intersection(z){const oe=j.Max(z.start,this.c),De=j.Min(z.end,this.e);if(!oe.isAfter(De))return new t(oe,De)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const oe=j.Min(z.start,this.c),De=j.Max(z.end,this.end);return new t(oe,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(z,oe=this.end){if(z===null||oe===null)throw(0,T.$7)();let De;return z?j.isPosition(z)?De=z:(De=z.start||this.start,oe=z.end||this.end):De=this.start,De.isEqual(this.c)&&oe.isEqual(this.end)?this:new t(De,oe)}toJSON(){return[this.start,this.end]}};e.$UK=W,e.$UK=W=t=Ge([k],W);let P=n=class extends W{static isSelection(z){return z instanceof n?!0:z?W.isRange(z)&&j.isPosition(z.anchor)&&j.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(z,oe,De,Je){let xe,ut;if(typeof z=="number"&&typeof oe=="number"&&typeof De=="number"&&typeof Je=="number"?(xe=new j(z,oe),ut=new j(De,Je)):j.isPosition(z)&&j.isPosition(oe)&&(xe=j.of(z),ut=j.of(oe)),!xe||!ut)throw new Error("Invalid arguments");super(xe,ut),this.f=xe,this.g=ut}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$VK=P,e.$VK=P=n=Ge([k],P);const C=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,T.$7)("connectionToken")};class J{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,oe,De){if(typeof z!="string"||z.length===0)throw(0,T.$7)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,T.$7)("port");typeof De<"u"&&C(De),this.host=z,this.port=Math.round(oe),this.connectionToken=De}}e.$WK=J;class ae{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,oe){this.makeConnection=z,this.connectionToken=oe,typeof oe<"u"&&C(oe)}}e.$XK=ae;class fe extends Error{static NotAvailable(z,oe){return new fe(z,p.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(z){return new fe(z,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,oe=p.RemoteAuthorityResolverErrorCode.Unknown,De){super(z),this._message=z,this._code=oe,this._detail=De,Object.setPrototypeOf(this,fe.prototype)}}e.$YK=fe;var be;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(be||(e.EndOfLine=be={}));var ye;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(ye||(e.EnvironmentVariableMutatorType=ye={}));let he=a=class{static isTextEdit(z){return z instanceof a?!0:z?W.isRange(z)&&typeof z.newText=="string":!1}static replace(z,oe){return new a(z,oe)}static insert(z,oe){return a.replace(new W(z,z),oe)}static delete(z){return a.replace(z,"")}static setEndOfLine(z){const oe=new a(new W(new j(0,0),new j(0,0)),"");return oe.newEol=z,oe}get range(){return this.c}set range(z){if(z&&!W.isRange(z))throw(0,T.$7)("range");this.c=z}get newText(){return this.e||""}set newText(z){if(z&&typeof z!="string")throw(0,T.$7)("newText");this.e=z}get newEol(){return this.f}set newEol(z){if(z&&typeof z!="number")throw(0,T.$7)("newEol");this.f=z}constructor(z,oe){this.c=z,this.e=oe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$ZK=he,e.$ZK=he=a=Ge([k],he);let ve=c=class{static isNotebookCellEdit(z){return z instanceof c?!0:z?ei.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,oe){return new c(z,oe)}static insertCells(z,oe){return new c(new ei(z,z),oe)}static deleteCells(z){return new c(z,[])}static updateCellMetadata(z,oe){const De=new c(new ei(z,z),[]);return De.newCellMetadata=oe,De}static updateNotebookMetadata(z){const oe=new c(new ei(0,0),[]);return oe.newNotebookMetadata=z,oe}constructor(z,oe){this.range=z,this.newCells=oe}};e.$1K=ve,e.$1K=ve=c=Ge([k],ve);class ee{static isSnippetTextEdit(z){return z instanceof ee?!0:z?W.isRange(z.range)&&_.isSnippetString(z.snippet):!1}static replace(z,oe){return new ee(z,oe)}static insert(z,oe){return ee.replace(new W(z,z),oe)}constructor(z,oe){this.range=z,this.snippet=oe}}e.$2K=ee;var ke;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(ke||(e.FileEditType=ke={}));let se=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(z,oe,De,Je){this.c.push({_type:1,from:z,to:oe,options:De,metadata:Je})}createFile(z,oe,De){this.c.push({_type:1,from:void 0,to:z,options:oe,metadata:De})}deleteFile(z,oe,De){this.c.push({_type:1,from:z,to:void 0,options:oe,metadata:De})}e(z,oe,De){this.c.push({_type:3,metadata:De,uri:z,edit:{editType:5,metadata:oe},notebookMetadata:oe})}f(z,oe,De,Je){const xe=oe.start,ut=oe.end;(xe!==ut||De.length>0)&&this.c.push({_type:5,uri:z,index:xe,count:ut-xe,cells:De,metadata:Je})}g(z,oe,De,Je){this.c.push({_type:3,metadata:Je,uri:z,edit:{editType:3,index:oe,metadata:De}})}replace(z,oe,De,Je){this.c.push({_type:2,uri:z,edit:new he(oe,De),metadata:Je})}insert(z,oe,De,Je){this.replace(z,new W(oe,oe),De,Je)}delete(z,oe,De){this.replace(z,oe,"",De)}has(z){return this.c.some(oe=>oe._type===2&&oe.uri.toString()===z.toString())}set(z,oe){if(oe)for(const De of oe){if(!De)continue;let Je,xe;Array.isArray(De)?(Je=De[0],xe=De[1]):Je=De,ve.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(z,Je.range.start,Je.newCellMetadata,xe):Je.newNotebookMetadata?this.e(z,Je.newNotebookMetadata,xe):this.f(z,Je.range,Je.newCells,xe):ee.isSnippetTextEdit(Je)?this.c.push({_type:6,uri:z,range:Je.range,edit:Je.snippet,metadata:xe}):this.c.push({_type:2,uri:z,edit:Je,metadata:xe})}else{for(let De=0;De<this.c.length;De++){const Je=this.c[De];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===z.toString()&&(this.c[De]=void 0);break}}(0,E.$Ib)(this.c)}}get(z){const oe=[];for(const De of this.c)De._type===2&&De.uri.toString()===z.toString()&&oe.push(De.edit);return oe}entries(){const z=new F.$Ac;for(const oe of this.c)if(oe._type===2){let De=z.get(oe.uri);De||(De=[oe.uri,[]],z.set(oe.uri,De)),De[1].push(oe.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$3K=se,e.$3K=se=Ge([k],se);let _=h=class{static isSnippetString(z){return z instanceof h?!0:z?typeof z.value=="string":!1}static c(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this.e=1,this.value=z||""}appendText(z){return this.value+=h.c(z),this}appendTabstop(z=this.e++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,oe=this.e++){if(typeof z=="function"){const De=new h;De.e=this.e,z(De),this.e=De.e,z=De.value}else z=h.c(z);return this.value+="${",this.value+=oe,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,oe=this.e++){const De=z.map(Je=>Je.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(z,oe){if(typeof oe=="function"){const De=new h;De.e=this.e,oe(De),this.e=De.e,oe=De.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};e.$4K=_,e.$4K=_=h=Ge([k],_);var V;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var ne;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let Ie=i=class{static isLocation(z){return z instanceof i?!0:z?W.isRange(z.range)&&w.URI.isUri(z.uri):!1}constructor(z,oe){if(this.uri=z,oe)if(W.isRange(oe))this.range=W.of(oe);else if(j.isPosition(oe))this.range=new W(oe,oe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$5K=Ie,e.$5K=Ie=i=Ge([k],Ie);let Ae=class{static is(z){return z?typeof z.message=="string"&&z.location&&W.isRange(z.location.range)&&w.URI.isUri(z.location.uri):!1}constructor(z,oe){this.location=z,this.message=oe}static isEqual(z,oe){return z===oe?!0:!z||!oe?!1:z.message===oe.message&&z.location.range.isEqual(oe.location.range)&&z.location.uri.toString()===oe.location.uri.toString()}};e.$6K=Ae,e.$6K=Ae=Ge([k],Ae);let Pe=class{constructor(z,oe,De=ne.Error){if(!W.isRange(z))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=z,this.message=oe,this.severity=De}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,oe){return z===oe?!0:!z||!oe?!1:z.message===oe.message&&z.severity===oe.severity&&z.code===oe.code&&z.severity===oe.severity&&z.source===oe.source&&z.range.isEqual(oe.range)&&(0,E.$ub)(z.tags,oe.tags)&&(0,E.$ub)(z.relatedInformation,oe.relatedInformation,Ae.isEqual)}};e.$7K=Pe,e.$7K=Pe=Ge([k],Pe);let ce=class{constructor(z,oe){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=oe}};e.$8K=ce,e.$8K=ce=Ge([k],ce);var ie;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(ie||(e.DocumentHighlightKind=ie={}));let Q=class{constructor(z,oe=ie.Text){this.range=z,this.kind=oe}toJSON(){return{range:this.range,kind:ie[this.kind]}}};e.$9K=Q,e.$9K=Q=Ge([k],Q);let te=class{constructor(z,oe){this.uri=z,this.highlights=oe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(z=>z.toJSON())}}};e.$0K=te,e.$0K=te=Ge([k],te);var me;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(me||(e.SymbolKind=me={}));var pe;(function(B){B[B.Deprecated=1]="Deprecated"})(pe||(e.SymbolTag=pe={}));let Fe=s=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,oe,De,Je,xe){this.name=z,this.kind=oe,this.containerName=xe,typeof De=="string"&&(this.containerName=De),Je instanceof Ie?this.location=Je:De instanceof W&&(this.location=new Ie(Je,De)),s.validate(this)}toJSON(){return{name:this.name,kind:me[this.kind],location:this.location,containerName:this.containerName}}};e.$$K=Fe,e.$$K=Fe=s=Ge([k],Fe);let le=u=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(u.validate)}constructor(z,oe,De,Je,xe){this.name=z,this.detail=oe,this.kind=De,this.range=Je,this.selectionRange=xe,this.children=[],u.validate(this)}};e.$_K=le,e.$_K=le=u=Ge([k],le);var we;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(we||(e.CodeActionTriggerKind=we={}));let M=class{constructor(z,oe){this.title=z,this.kind=oe}};e.$aL=M,e.$aL=M=Ge([k],M);let q=class{static{d=this}static{this.c="."}constructor(z){this.value=z}append(z){return new d(this.value?this.value+d.c+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+d.c)}};e.$bL=q,e.$bL=q=d=Ge([k],q),q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorMove=q.Refactor.append("move"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll"),q.Notebook=q.Empty.append("notebook");let H=class{constructor(z,oe){if(this.range=z,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$cL=H,e.$cL=H=Ge([k],H);class U{constructor(z,oe,De,Je,xe,ut){this.kind=z,this.name=oe,this.detail=De,this.uri=Je,this.range=xe,this.selectionRange=ut}}e.$dL=U;class Z{constructor(z,oe){this.fromRanges=oe,this.from=z}}e.$eL=Z;class Y{constructor(z,oe){this.fromRanges=oe,this.to=z}}e.$fL=Y;var Ee;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(Ee||(e.LanguageStatusSeverity=Ee={}));let Te=class{constructor(z,oe){this.range=z,this.command=oe}get isResolved(){return!!this.command}};e.$gL=Te,e.$gL=Te=Ge([k],Te);let We=m=class{#e;static isMarkdownString(z){return z instanceof m?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,oe=!1){this.#e=new I.$ek(z,{supportThemeIcons:oe})}get value(){return this.#e.value}set value(z){this.#e.value=z}get isTrusted(){return this.#e.isTrusted}set isTrusted(z){this.#e.isTrusted=z}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(z){this.#e.supportThemeIcons=z}get supportHtml(){return this.#e.supportHtml}set supportHtml(z){this.#e.supportHtml=z}get baseUri(){return this.#e.baseUri}set baseUri(z){this.#e.baseUri=z}appendText(z){return this.#e.appendText(z),this}appendMarkdown(z){return this.#e.appendMarkdown(z),this}appendCodeblock(z,oe){return this.#e.appendCodeblock(oe??"",z),this}};e.$hL=We,e.$hL=We=m=Ge([k],We);let He=class{constructor(z,oe){this.label=z,this.documentation=oe}};e.$iL=He,e.$iL=He=Ge([k],He);let Xe=class{constructor(z,oe){this.label=z,this.documentation=oe,this.parameters=[]}};e.$jL=Xe,e.$jL=Xe=Ge([k],Xe);let st=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$kL=st,e.$kL=st=Ge([k],st);var nt;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(nt||(e.SignatureHelpTriggerKind=nt={}));var tt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let at=class{constructor(z){this.value=z}};e.$lL=at,e.$lL=at=Ge([k],at);let ct=class{constructor(z,oe,De){this.position=z,this.label=oe,this.kind=De}};e.$mL=ct,e.$mL=ct=Ge([k],ct);var ze;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ze||(e.CompletionTriggerKind=ze={}));var vt;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(vt||(e.CompletionItemKind=vt={}));var X;(function(B){B[B.Deprecated=1]="Deprecated"})(X||(e.CompletionItemTag=X={}));let x=class{constructor(z,oe){this.label=z,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&vt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$nL=x,e.$nL=x=Ge([k],x);let $e=class{constructor(z=[],oe=!1){this.items=z,this.isIncomplete=oe}};e.$oL=$e,e.$oL=$e=Ge([k],$e);let Be=class{constructor(z,oe,De){this.insertText=z,this.range=oe,this.command=De}};e.$pL=Be,e.$pL=Be=Ge([k],Be);let Qe=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.$qL=Qe,e.$qL=Qe=Ge([k],Qe);var it;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(it||(e.ViewColumn=it={}));var rt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(rt||(e.StatusBarAlignment=rt={}));function Ne(B,z){return`${D.$im.toKey(B)}.${z}`}e.$rL=Ne;var Pt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Tt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Tt||(e.TextDocumentSaveReason=Tt={}));var Ht;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var Bt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var yt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(yt||(e.TextDocumentChangeReason=yt={}));var Kt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Kt||(e.DecorationRangeBehavior=Kt={})),function(B){function z(oe){switch(oe){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=z}(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var Nt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Nt||(e.SyntaxTokenType=Nt={})),function(B){function z(oe){switch(oe){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=z}(Nt||(e.SyntaxTokenType=Nt={}));let Zt=class{constructor(z,oe){if(oe&&!w.URI.isUri(oe))throw(0,T.$7)("target");if(!W.isRange(z)||z.isEmpty)throw(0,T.$7)("range");this.range=z,this.target=oe}};e.$sL=Zt,e.$sL=Zt=Ge([k],Zt);let jt=class{constructor(z,oe,De,Je){this.red=z,this.green=oe,this.blue=De,this.alpha=Je}};e.$tL=jt,e.$tL=jt=Ge([k],jt);let Rt=class{constructor(z,oe){if(oe&&!(oe instanceof jt))throw(0,T.$7)("color");if(!W.isRange(z)||z.isEmpty)throw(0,T.$7)("range");this.range=z,this.color=oe}};e.$uL=Rt,e.$uL=Rt=Ge([k],Rt);let Ye=class{constructor(z){if(!z||typeof z!="string")throw(0,T.$7)("label");this.label=z}};e.$vL=Ye,e.$vL=Ye=Ge([k],Ye);var Gt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(Gt||(e.ColorFormat=Gt={}));var Jt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(Jt||(e.SourceControlInputBoxValidationType=Jt={}));var lt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(lt||(e.TerminalExitReason=lt={}));class $t{constructor(z,oe,De){if(this.startIndex=z,this.length=oe,this.tooltip=De,typeof z!="number"||z<0)throw(0,T.$7)("startIndex");if(typeof oe!="number"||oe<1)throw(0,T.$7)("length");if(De!==void 0&&typeof De!="string")throw(0,T.$7)("tooltip")}}e.$wL=$t;class zt{constructor(z){this.uri=z}}e.$xL=zt;class Wt{constructor(z){this.terminalCommand=z}}e.$yL=Wt;var kt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(kt||(e.TerminalLocation=kt={}));class dt{constructor(z){if(this.options=z,typeof z!="object")throw(0,T.$7)("options")}}e.$zL=dt;var Ct;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Ct||(e.TaskRevealKind=Ct={}));var xt;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(xt||(e.TaskPanelKind=xt={}));let St=class{static{f=this}static{this.Clean=new f("clean","Clean")}static{this.Build=new f("build","Build")}static{this.Rebuild=new f("rebuild","Rebuild")}static{this.Test=new f("test","Test")}static from(z){switch(z){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}constructor(z,oe){if(this.label=oe,typeof z!="string"||typeof oe!="string")throw(0,T.$7)("name");this.c=z}get id(){return this.c}};e.$AL=St,e.$AL=St=f=Ge([k],St);function qe(B){let z="";for(let oe=0;oe<B.length;oe++)z+=B[oe].replace(/,/g,",,")+",";return z}let Ft=class{constructor(z,oe,De){if(typeof z!="string")throw(0,T.$7)("process");this.e=[],this.c=z,oe!==void 0&&(Array.isArray(oe)?(this.e=oe,this.f=De):this.f=oe)}get process(){return this.c}set process(z){if(typeof z!="string")throw(0,T.$7)("process");this.c=z}get args(){return this.e}set args(z){Array.isArray(z)||(z=[]),this.e=z}get options(){return this.f}set options(z){this.f=z}computeId(){const z=[];if(z.push("process"),this.c!==void 0&&z.push(this.c),this.e&&this.e.length>0)for(const oe of this.e)z.push(oe);return qe(z)}};e.$BL=Ft,e.$BL=Ft=Ge([k],Ft);let Vt=class{constructor(z,oe,De){if(this.f=[],Array.isArray(oe)){if(!z)throw(0,T.$7)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,T.$7)("command");this.e=z,this.f=oe,this.g=De}else{if(typeof z!="string")throw(0,T.$7)("commandLine");this.c=z,this.g=oe}}get commandLine(){return this.c}set commandLine(z){if(typeof z!="string")throw(0,T.$7)("commandLine");this.c=z}get command(){return this.e?this.e:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,T.$7)("command");this.e=z}get args(){return this.f}set args(z){this.f=z||[]}get options(){return this.g}set options(z){this.g=z}computeId(){const z=[];if(z.push("shell"),this.c!==void 0&&z.push(this.c),this.e!==void 0&&z.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const oe of this.f)z.push(typeof oe=="string"?oe:oe.value);return qe(z)}};e.$CL=Vt,e.$CL=Vt=Ge([k],Vt);var Qt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(Qt||(e.ShellQuoting=Qt={}));var ft;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(ft||(e.TaskScope=ft={}));class Mt{constructor(z){this.c=z}computeId(){return"customExecution"+(0,A.$ng)()}set callback(z){this.c=z}get callback(){return this.c}}e.$DL=Mt;let Se=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(z,oe,De,Je,xe,ut){this.k=!1,this.l=this.definition=z;let gt;typeof oe=="string"?(this.n=this.name=oe,this.u=this.source=De,this.execution=Je,gt=xe,this.k=!0):oe===ft.Global||oe===ft.Workspace?(this.target=oe,this.n=this.name=De,this.u=this.source=Je,this.execution=xe,gt=ut):(this.target=oe,this.n=this.name=De,this.u=this.source=Je,this.execution=xe,gt=ut),typeof gt=="string"?(this.q=[gt],this.r=!0):Array.isArray(gt)?(this.q=gt,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(z){this.j=z}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Ft?this.l={type:S.e,id:this.o.computeId()}:this.o instanceof Vt?this.l={type:S.f,id:this.o.computeId()}:this.o instanceof Mt?this.l={type:S.c,id:this.o.computeId()}:this.l={type:S.g,id:(0,A.$ng)()}}get definition(){return this.l}set definition(z){if(z==null)throw(0,T.$7)("Kind can't be undefined or null");this.A(),this.l=z}get scope(){return this.m}set target(z){this.A(),this.m=z}get name(){return this.n}set name(z){if(typeof z!="string")throw(0,T.$7)("name");this.A(),this.n=z}get execution(){return this.o}set execution(z){z===null&&(z=void 0),this.A(),this.o=z;const oe=this.l.type;(S.g===oe||S.e===oe||S.f===oe||S.c===oe)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(z){if(Array.isArray(z))this.A(),this.q=z,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.A(),this.t=z}get source(){return this.u}set source(z){if(typeof z!="string"||z.length===0)throw(0,T.$7)("source must be a string of length > 0");this.A(),this.u=z}get group(){return this.w}set group(z){z===null&&(z=void 0),this.A(),this.w=z}get detail(){return this.z}set detail(z){z===null&&(z=void 0),this.z=z}get presentationOptions(){return this.x}set presentationOptions(z){z==null&&(z=Object.create(null)),this.A(),this.x=z}get runOptions(){return this.y}set runOptions(z){z==null&&(z=Object.create(null)),this.A(),this.y=z}};e.$EL=Se,e.$EL=Se=S=Ge([k],Se);var Me;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Me||(e.ProgressLocation=Me={}));var de;(function(B){function z(oe){const De=oe;return(0,g.$Jf)(De.value)?De.tooltip&&!(0,g.$Ff)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}B.isViewBadge=z})(de||(e.ViewBadge=de={}));let G=L=class{static isTreeItem(z,oe){const De=z;if(De.checkboxState!==void 0){const Je=(0,g.$Jf)(De.checkboxState)?De.checkboxState:(0,g.$Hf)(De.checkboxState)&&(0,g.$Jf)(De.checkboxState.state)?De.checkboxState.state:void 0,xe=!(0,g.$Jf)(De.checkboxState)&&(0,g.$Hf)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Je===void 0||Je!==Ue.Checked&&Je!==Ue.Unchecked||xe!==void 0&&!(0,g.$Ff)(xe))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(z instanceof L)return!0;if(De.label!==void 0&&!(0,g.$Ff)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,g.$Ff)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,g.$Ff)(De.iconPath)&&!w.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,g.$Ff)(De.iconPath.id))){const Je=De.iconPath;if(!Je||!(0,g.$Ff)(Je.light)&&!w.URI.isUri(Je.light)&&!(0,g.$Ff)(Je.dark)&&!w.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,g.$Ff)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!w.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,g.$Ff)(De.tooltip)&&!(De.tooltip instanceof We)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<Le.None&&De.collapsibleState>Le.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,g.$Ff)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(z,oe=Le.None){this.collapsibleState=oe,w.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.$FL=G,e.$FL=G=L=Ge([k],G);var Le;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Le||(e.TreeItemCollapsibleState=Le={}));var Ue;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Ue||(e.TreeItemCheckboxState=Ue={}));let Ze=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.$GL=Ze,e.$GL=Ze=Ge([k],Ze);class Ve extends Ze{}e.$HL=Ve;class _e extends Ve{#e;constructor(z){super(""),this.#e=z}asFile(){return this.#e}}e.$IL=_e;class mt{constructor(z,oe,De,Je){this.name=z,this.uri=oe,this._itemId=De,this.c=Je}data(){return this.c()}}e.$JL=mt;let Ut=class{#e=new Map;constructor(z){for(const[oe,De]of z??[]){const Je=this.#e.get(this.#t(oe));Je?Je.push(De):this.#e.set(this.#t(oe),[De])}}get(z){return this.#e.get(this.#t(z))?.[0]}set(z,oe){this.#e.set(this.#t(z),[oe])}forEach(z,oe){for(const[De,Je]of this.#e)for(const xe of Je)z.call(oe,xe,De,this)}*[Symbol.iterator](){for(const[z,oe]of this.#e)for(const De of oe)yield[z,De]}#t(z){return z.toLowerCase()}};e.$KL=Ut,e.$KL=Ut=Ge([k],Ut);let Et=class{constructor(z){this.insertText=z}};e.$LL=Et,e.$LL=Et=Ge([k],Et);let Dt=class{constructor(z,oe){this.label=oe,this.insertText=z}};e.$ML=Dt,e.$ML=Dt=Ge([k],Dt);let wt=class{constructor(z,oe){this.id=z,this.color=oe}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.$NL=wt,e.$NL=wt=Ge([k],wt),wt.File=new wt("file"),wt.Folder=new wt("folder");let gi=class{constructor(z){this.id=z}};e.$OL=gi,e.$OL=gi=Ge([k],gi);var At;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(At||(e.ConfigurationTarget=At={}));let Di=class{get base(){return this.c}set base(z){this.c=z,this.e=w.URI.file(z)}get baseUri(){return this.e}set baseUri(z){this.e=z,this.c=z.fsPath}constructor(z,oe){if(typeof z!="string"&&(!z||!w.URI.isUri(z)&&!w.URI.isUri(z.uri)))throw(0,T.$7)("base");if(typeof oe!="string")throw(0,T.$7)("pattern");typeof z=="string"?this.baseUri=w.URI.file(z):w.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=oe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$PL=Di,e.$PL=Di=Ge([k],Di);const Hi=new WeakMap;function It(B,z){Hi.set(B,z)}e.$QL=It;let ri=class{constructor(z,oe,De,Je){this.enabled=typeof z=="boolean"?z:!0,typeof oe=="string"&&(this.condition=oe),typeof De=="string"&&(this.hitCondition=De),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this.c||(this.c=Hi.get(this)??(0,A.$ng)()),this.c}};e.$RL=ri,e.$RL=ri=Ge([k],ri);let mi=class extends ri{constructor(z,oe,De,Je,xe){if(super(oe,De,Je,xe),z===null)throw(0,T.$7)("location");this.location=z}};e.$SL=mi,e.$SL=mi=Ge([k],mi);let ci=class extends ri{constructor(z,oe,De,Je,xe){super(oe,De,Je,xe),this.functionName=z}};e.$TL=ci,e.$TL=ci=Ge([k],ci);let Ii=class extends ri{constructor(z,oe,De,Je,xe,ut,gt){if(super(Je,xe,ut,gt),!oe)throw(0,T.$7)("dataId");this.label=z,this.dataId=oe,this.canPersist=De}};e.$UL=Ii,e.$UL=Ii=Ge([k],Ii);let Ci=class{constructor(z,oe,De){this.command=z,this.args=oe||[],this.options=De}};e.$VL=Ci,e.$VL=Ci=Ge([k],Ci);let Ot=class{constructor(z,oe){this.port=z,this.host=oe}};e.$WL=Ot,e.$WL=Ot=Ge([k],Ot);let $i=class{constructor(z){this.path=z}};e.$XL=$i,e.$XL=$i=Ge([k],$i);let Pi=class{constructor(z){this.implementation=z}};e.$YL=Pi,e.$YL=Pi=Ge([k],Pi);let ui=class{constructor(z,oe,De){this.session=z,this.threadId=oe,this.frameId=De}};e.$ZL=ui,e.$ZL=ui=Ge([k],ui);let li=class{constructor(z,oe){this.session=z,this.threadId=oe}};e.$1L=li,e.$1L=li=Ge([k],li);let ht=class{constructor(z,oe){this.range=z,this.expression=oe}};e.$2L=ht,e.$2L=ht=Ge([k],ht);var Gi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Gi||(e.InlineCompletionTriggerKind=Gi={}));let _t=class{constructor(z,oe){this.range=z,this.text=oe}};e.$3L=_t,e.$3L=_t=Ge([k],_t);let si=class{constructor(z,oe,De=!0){this.range=z,this.variableName=oe,this.caseSensitiveLookup=De}};e.$4L=si,e.$4L=si=Ge([k],si);let pi=class{constructor(z,oe){this.range=z,this.expression=oe}};e.$5L=pi,e.$5L=pi=Ge([k],pi);let Ri=class{constructor(z,oe){this.frameId=z,this.stoppedLocation=oe}};e.$6L=Ri,e.$6L=Ri=Ge([k],Ri);var Ji;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Ji||(e.FileChangeType=Ji={}));let Ai=v=class extends Error{static FileExists(z){return new v(z,l.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(z){return new v(z,l.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(z){return new v(z,l.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(z){return new v(z,l.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(z){return new v(z,l.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(z){return new v(z,l.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}constructor(z,oe=l.FileSystemProviderErrorCode.Unknown,De){super(w.URI.isUri(z)?z.toString(!0):z),this.code=De?.name??"Unknown",(0,l.$Ck)(this,oe),Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$7L=Ai,e.$7L=Ai=v=Ge([k],Ai);let vi=class{constructor(z,oe,De){this.start=z,this.end=oe,this.kind=De}};e.$8L=vi,e.$8L=vi=Ge([k],vi);var Qi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Qi||(e.FoldingRangeKind=Qi={}));var Li;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Li||(e.CommentThreadCollapsibleState=Li={}));var hi;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(hi||(e.CommentMode=hi={}));var Zi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Zi||(e.CommentState=Zi={}));var bi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(bi||(e.CommentThreadState=bi={}));class Fi{constructor(z,oe=[]){this.tokenTypes=z,this.tokenModifiers=oe}}e.$9L=Fi;function cn(B){return typeof B>"u"||(0,g.$Gf)(B)}class Mi{constructor(z){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,z){this.m=!0;for(let oe=0,De=z.tokenTypes.length;oe<De;oe++)this.k.set(z.tokenTypes[oe],oe);for(let oe=0,De=z.tokenModifiers.length;oe<De;oe++)this.l.set(z.tokenModifiers[oe],oe)}}push(z,oe,De,Je,xe){if(typeof z=="number"&&typeof oe=="number"&&typeof De=="number"&&typeof Je=="number"&&(typeof xe=="number"||typeof xe>"u"))return typeof xe>"u"&&(xe=0),this.o(z,oe,De,Je,xe);if(W.isRange(z)&&typeof oe=="string"&&cn(De))return this.n(z,oe,De);throw(0,T.$7)()}n(z,oe,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(oe))throw new Error("`tokenType` is not in the provided legend");const Je=z.start.line,xe=z.start.character,ut=z.end.character-z.start.character,gt=this.k.get(oe);let qt=0;if(De)for(const Yt of De){if(!this.l.has(Yt))throw new Error("`tokenModifier` is not in the provided legend");const ii=this.l.get(Yt);qt|=1<<ii>>>0}this.o(Je,xe,ut,gt,qt)}o(z,oe,De,Je,xe){if(this.f&&(z<this.c||z===this.c&&oe<this.e)){this.f=!1;const qt=this.g.length/5|0;let Yt=0,ii=0;for(let ni=0;ni<qt;ni++){let ai=this.g[5*ni],qi=this.g[5*ni+1];ai===0?(ai=Yt,qi+=ii):ai+=Yt,this.g[5*ni]=ai,this.g[5*ni+1]=qi,Yt=ai,ii=qi}}let ut=z,gt=oe;this.f&&this.j>0&&(ut-=this.c,ut===0&&(gt-=this.e)),this.g[this.j++]=ut,this.g[this.j++]=gt,this.g[this.j++]=De,this.g[this.j++]=Je,this.g[this.j++]=xe,this.c=z,this.e=oe}static q(z){const oe=[],De=z.length/5|0;for(let gt=0;gt<De;gt++)oe[gt]=gt;oe.sort((gt,qt)=>{const Yt=z[5*gt],ii=z[5*qt];if(Yt===ii){const ni=z[5*gt+1],ai=z[5*qt+1];return ni-ai}return Yt-ii});const Je=new Uint32Array(z.length);let xe=0,ut=0;for(let gt=0;gt<De;gt++){const qt=5*oe[gt],Yt=z[qt+0],ii=z[qt+1],ni=z[qt+2],ai=z[qt+3],qi=z[qt+4],In=Yt-xe,On=In===0?ii-ut:ii,Ki=5*gt;Je[Ki+0]=In,Je[Ki+1]=On,Je[Ki+2]=ni,Je[Ki+3]=ai,Je[Ki+4]=qi,xe=Yt,ut=ii}return Je}build(z){return this.f?new oi(new Uint32Array(this.g),z):new oi(Mi.q(this.g),z)}}e.$0L=Mi;class oi{constructor(z,oe){this.resultId=oe,this.data=z}}e.$$L=oi;class un{constructor(z,oe,De){this.start=z,this.deleteCount=oe,this.data=De}}e.$_L=un;class ln{constructor(z,oe){this.resultId=oe,this.edits=z}}e.$aM=ln;var Xi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Xi||(e.DebugConsoleMode=Xi={}));let di=class{static{this.Back={iconPath:new wt("arrow-left")}}constructor(){}};e.$bM=di,e.$bM=di=Ge([k],di);var Yi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Yi||(e.QuickPickItemKind=Yi={}));var xi;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(xi||(e.InputBoxValidationSeverity=xi={}));var wi;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(wi||(e.ExtensionKind=wi={}));class _i{static validate(z){if(typeof z.badge=="string"){let oe=(0,$.$gf)(z.badge,0);if(oe<z.badge.length&&(oe+=(0,$.$gf)(z.badge,oe)),z.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!wt.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,oe,De){this.badge=z,this.tooltip=oe,this.color=De}}e.$cM=_i;let Ti=class{constructor(z){this.kind=z}};e.$dM=Ti,e.$dM=Ti=Ge([k],Ti);var Ni;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Ni||(e.ColorThemeKind=Ni={}));class ei{static isNotebookRange(z){return z instanceof ei?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(z,oe){if(z<0)throw(0,T.$7)("start must be positive");if(oe<0)throw(0,T.$7)("end must be positive");z<=oe?(this.c=z,this.e=oe):(this.c=oe,this.e=z)}with(z){let oe=this.c,De=this.e;return z.start!==void 0&&(oe=z.start),z.end!==void 0&&(De=z.end),oe===this.c&&De===this.e?this:new ei(oe,De)}}e.$eM=ei;class yi{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(oe=>yi.isNotebookCellData(oe))}static isNotebookCellData(z){return!0}constructor(z,oe,De,Je,xe,ut,gt){this.kind=z,this.value=oe,this.languageId=De,this.mime=Je,this.outputs=xe??[],this.metadata=ut,this.executionSummary=gt,yi.validate(this)}}e.$fM=yi;class hn{constructor(z){this.cells=z}}e.$gM=hn;class Xt{static isNotebookCellOutputItem(z){return z instanceof Xt?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const oe={name:z.name,message:z.message,stack:z.stack};return Xt.json(oe,"application/vnd.code.notebook.error")}static stdout(z){return Xt.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return Xt.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,oe="application/octet-stream"){return new Xt(z,oe)}static#e=new TextEncoder;static text(z,oe=R.$5r.text){const De=Xt.#e.encode(String(z));return new Xt(De,oe)}static json(z,oe="text/x-json"){const De=JSON.stringify(z,void 0,"	");return Xt.text(De,oe)}constructor(z,oe){this.data=z,this.mime=oe;const De=(0,R.$9r)(oe,!0);if(!De)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$hM=Xt;class Ei{static isNotebookCellOutput(z){return z instanceof Ei?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,oe=!1){const De=new Set,Je=new Set;for(let xe=0;xe<z.length;xe++){const ut=z[xe],gt=(0,R.$9r)(ut.mime);if(!De.has(gt)||(0,b.$UI)(gt)){De.add(gt);continue}Je.add(xe),oe&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Je.size===0?z:z.filter((xe,ut)=>!Je.has(ut))}constructor(z,oe,De){this.items=Ei.ensureUniqueMimeTypes(z,!0),typeof oe=="string"?(this.id=oe,this.metadata=De):(this.id=(0,A.$ng)(),this.metadata=oe??De)}}e.$iM=Ei;var ki;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(ki||(e.NotebookCellKind=ki={}));var Oi;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Oi||(e.NotebookCellExecutionState=Oi={}));var je;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(je||(e.NotebookCellStatusBarAlignment=je={}));var ti;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(ti||(e.NotebookEditorRevealType=ti={}));class en{constructor(z,oe){this.text=z,this.alignment=oe}}e.$jM=en;var et;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(et||(e.NotebookControllerAffinity=et={}));var pt;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(pt||(e.NotebookControllerAffinity2=pt={}));class dn{constructor(z,oe=[]){this.uri=z,this.provides=(0,E.$3b)(oe)}}e.$kM=dn;class fn{constructor(z){this.label=z}}e.$lM=fn;var ji;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(ji||(e.NotebookVariablesRequestKind=ji={}));let zi=class{constructor(z,oe){this.label=z,this.timestamp=oe}};e.$mM=zi,e.$mM=zi=Ge([k],zi);var fi;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(fi||(e.ExtensionMode=fi={}));var tn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(tn||(e.ExtensionRuntime=tn={}));var nn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(nn||(e.StandardTokenType=nn={}));class gn{constructor(z,oe){this.ranges=z,this.wordPattern=oe}}e.$nM=gn;class rn{constructor(z){this.c=z}get autoForwardAction(){return this.c}}e.$oM=rn;var sn;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(sn||(e.TestResultState=sn={}));var on;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(on||(e.TestRunProfileKind=on={}));let Ui=class{constructor(z=void 0,oe=void 0,De=void 0,Je=!1){this.include=z,this.exclude=oe,this.profile=De,this.continuous=Je}};e.$pM=Ui,e.$pM=Ui=Ge([k],Ui);let Bi=y=class{static diff(z,oe,De){const Je=new y(z);return Je.expectedOutput=oe,Je.actualOutput=De,Je}constructor(z){this.message=z}};e.$qM=Bi,e.$qM=Bi=y=Ge([k],Bi);let Wi=class{constructor(z){this.id=z}};e.$rM=Wi,e.$rM=Wi=Ge([k],Wi);class Si{constructor(z,oe){this.covered=z,this.total=oe}}e.$sM=Si;class Vi{static fromDetails(z,oe){const De=new Si(0,0),Je=new Si(0,0),xe=new Si(0,0);for(const gt of oe)if("branches"in gt){De.total+=1,De.covered+=gt.executionCount>0?1:0;for(const qt of gt.branches)Je.total+=1,Je.covered+=qt.executionCount>0?1:0}else xe.total+=1,xe.covered+=gt.executionCount>0?1:0;const ut=new Vi(z,De,Je.total>0?Je:void 0,xe.total>0?xe:void 0);return ut.detailedCoverage=oe,ut}constructor(z,oe,De,Je){this.uri=z,this.statementCoverage=oe,this.branchCoverage=De,this.functionCoverage=Je}}e.$tM=Vi;class mn{constructor(z,oe,De=[]){this.executionCount=z,this.location=oe,this.branches=De}}e.$uM=mn;class $n{constructor(z,oe){this.executionCount=z,this.location=oe}}e.$vM=$n;class pn{constructor(z,oe,De){this.name=z,this.executionCount=oe,this.location=De}}e.$wM=pn;var re;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(re||(e.ExternalUriOpenerPriority=re={}));var ue;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(ue||(e.WorkspaceTrustState=ue={}));var Oe;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(Oe||(e.PortAutoForwardAction=Oe={}));class ot{constructor(z,oe,De,Je,xe,ut){this.kind=z,this.name=oe,this.detail=De,this.uri=Je,this.range=xe,this.selectionRange=ut}}e.$xM=ot;class bt{constructor(z){this.uri=z}}e.$yM=bt;class Lt{constructor(z,oe){this.original=z,this.modified=oe}}e.$zM=Lt;class an{constructor(z,oe,De,Je){this.base=z,this.input1=oe,this.input2=De,this.result=Je}}e.$AM=an;class Cn{constructor(z,oe){this.uri=z,this.viewType=oe}}e.$BM=Cn;class Pn{constructor(z){this.viewType=z}}e.$CM=Pn;class Rn{constructor(z,oe){this.uri=z,this.notebookType=oe}}e.$DM=Rn;class An{constructor(z,oe,De){this.original=z,this.modified=oe,this.notebookType=De}}e.$EM=An;class Ln{constructor(){}}e.$FM=Ln;class Fn{constructor(z,oe){this.uri=z,this.inputBoxUri=oe}}e.$GM=Fn;class Mn{constructor(z){this.providerId=z}}e.$HM=Mn;var vn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(vn||(e.InteractiveSessionVoteDirection=vn={}));var bn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(bn||(e.ChatAgentCopyKind=bn={}));var wn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(wn||(e.ChatVariableLevel=wn={}));class Tn{constructor(z,oe){this.label=z,this.values=oe}}e.$IM=Tn;var yn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(B){B[B.System=0]="System",B[B.User=1]="User",B[B.Assistant=2]="Assistant",B[B.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));class Nn{constructor(z,oe){this.role=z,this.content=oe}}e.$JM=Nn;var kn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(kn||(e.ChatAgentResultFeedbackKind=kn={}));var Sn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Sn||(e.RelatedInformationType=Sn={}));var Dn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped"})(Dn||(e.SpeechToTextStatus=Dn={}))}),define(Ce[103],Re([1,0,53,12,11,295,147,7,18]),function(ge,e,E,T,I,F,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YM=e.$XM=e.$WM=void 0;const w=new Map;function A(b,r){r?w.set(b,r):w.delete(b)}e.$WM=A;function D(b){return w.get(b)}class l extends F.$_u{constructor(r,o,t,n,a,c,h,i){super(o,t,n,a),this.c=r,this.m=c,this.q=h,this.notebook=i,this.b=!1}dispose(){(0,E.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,g.$ub)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===T.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(o){return o?r.s(o):r.getText()},get eol(){return r.g===`
`?$.EndOfLine.LF:$.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(o){return r.t(o)},offsetAt(o){return r.u(o)},positionAt(o){return r.v(o)},validateRange(o){return r.w(o)},validatePosition(o){return r.x(o)},getWordRangeAtPosition(o,t){return r.y(o,t)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,E.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,E.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const o=this.w(r);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const t=this.g,n=o.start.line,a=o.end.line,c=[];c.push(this.f[n].substring(o.start.character));for(let h=n+1;h<a;h++)c.push(this.f[h]);return c.push(this.f[a].substring(0,o.end.character)),c.join(t)}t(r){let o;if(r instanceof $.$TK?o=r.line:typeof r=="number"&&(o=r),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new p(o,this.f[o],o===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const o=this.j.getIndexOf(r),t=this.f[o.index].length;return new $.$TK(o.index,Math.min(o.remainder,t))}w(r){if(!(r instanceof $.$UK))throw new Error("Invalid argument");const o=this.x(r.start),t=this.x(r.end);return o===r.start&&t===r.end?r:new $.$UK(o.line,o.character,t.line,t.character)}x(r){if(!(r instanceof $.$TK))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:o,character:t}=r,n=!1;if(o<0)o=0,t=0,n=!0;else if(o>=this.f.length)o=this.f.length-1,t=this.f[o].length,n=!0;else{const a=this.f[o].length;t<0?(t=0,n=!0):t>a&&(t=a,n=!0)}return n?new $.$TK(o,t):r}y(r,o){const t=this.x(r);if(!o)o=D(this.m);else if((0,I.$Ve)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const n=(0,R.$ks)(t.character+1,(0,R.$is)(o),this.f[t.line],0);if(n)return new $.$UK(t.line,n.startColumn-1,t.line,n.endColumn-1)}}e.$XM=l;class p{constructor(r,o,t){this.a=r,this.b=o,this.c=t}get lineNumber(){return this.a}get text(){return this.b}get range(){return new $.$UK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new $.$UK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$YM=p}),define(Ce[210],Re([1,0,7,17,5]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=void 0;let F=class{constructor($){this.a=new E.$dM(E.ColorThemeKind.Dark),this.b=new I.$Sd}get activeColorTheme(){return this.a}$onColorThemeChange($){let g;switch($){case"light":g=E.ColorThemeKind.Light;break;case"hcDark":g=E.ColorThemeKind.HighContrast;break;case"hcLight":g=E.ColorThemeKind.HighContrastLight;break;default:g=E.ColorThemeKind.Dark}this.a=new E.$dM(g),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$bhc=F,e.$bhc=F=Ge([Ke(0,T.$UM)],F)}),define(Ce[211],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YI=e.CellExecutionUpdateType=void 0;var T;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$YI=(0,E.$3h)("INotebookExecutionService")}),define(Ce[212],Re([1,0,6,29,144,94]),function(ge,e,E,T,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Pb=void 0;class R extends E.$Sc{constructor(g,w,A){super(),this._source=g,this.b=w,this.c=A,this.a=void 0}f(g){const w=g.getLineCount();return new T.$Is(1,1,w,this.g(g,w))}g(g,w){if(w<1||w>g.getLineCount())throw new Error("Illegal value for lineNumber");return g.getLineLength(w)+1}get inputTextBuffer(){if(!this.b){const g=new I.$1B;g.acceptChunk(this._source);const w=g.finish(!0),{textBuffer:A,disposable:D}=w.create(1);this.b=A,this.B(D)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(g=>{const w=new I.$1B;w.acceptChunk(g);const A=w.finish(!0),{textBuffer:D,disposable:l}=A.create(1);return this.B(l),D})),this.a}findInInputs(g){const A=new F.$OB(g,!1,!1,null).parseSearchRequest();if(!A)return[];const D=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(D,A,!0,5e3)}findInOutputs(g){const A=new F.$OB(g,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(D=>{const l=D.findMatchesLineByLine(this.f(D),A,!0,5e3);if(l.length!==0)return{textBuffer:D,matches:l}}).filter(D=>!!D):[]}}e.$$Pb=R}),define(Ce[48],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IJ=e.TestPosition=e.TestIdPathParts=void 0;var E;(function(F){F.Delimiter="\0"})(E||(e.TestIdPathParts=E={}));var T;(function(F){F[F.IsSame=0]="IsSame",F[F.Disconnected=1]="Disconnected",F[F.IsChild=2]="IsChild",F[F.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class I{static fromExtHostTestItem(R,$,g=R.parent){if(R._isRoot)return new I([$]);const w=[R.id];for(let A=g;A&&A.id!==$;A=A.parent)w.push(A.id);return w.push($),new I(w.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const $=R.indexOf("\0");return $===-1?R:R.slice(0,$)}static fromString(R){return new I(R.split("\0"))}static join(R,$){return new I([...R.path,$])}static joinToString(R,$){return R.toString()+"\0"+$}static parentId(R){const $=R.lastIndexOf("\0");return $===-1?void 0:R.slice(0,$)}static localId(R){const $=R.lastIndexOf("\0");return $===-1?R:R.slice($+1)}static isChild(R,$){return $.startsWith(R)&&$[R.length]==="\0"}static compare(R,$){return R===$?0:I.isChild(R,$)?2:I.isChild($,R)?3:1}constructor(R,$=R.length){if(this.path=R,this.d=$,R.length===0||$<1)throw new Error("cannot create test with empty path")}get rootId(){return new I(this.path,1)}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new I(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new I(this.path,R)}compare(R){if(typeof R=="string")return I.compare(this.toString(),R);for(let $=0;$<R.d&&$<this.d;$++)if(R.path[$]!==this.path[$])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$IJ=I}),define(Ce[58],Re([1,0,2,92,29,48]),function(ge,e,E,T,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$PJ=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$OJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$NJ=e.$MJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$LJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$KJ=e.$JJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(P){P[P.Unset=0]="Unset",P[P.Queued=1]="Queued",P[P.Running=2]="Running",P[P.Passed=3]="Passed",P[P.Failed=4]="Failed",P[P.Skipped=5]="Skipped",P[P.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var $;(function(P){P[P.Run=1]="Run",P[P.Debug=2]="Debug",P[P.Coverage=3]="Coverage"})($||(e.ExtTestRunProfileKind=$={}));var g;(function(P){P[P.Run=2]="Run",P[P.Debug=4]="Debug",P[P.Coverage=8]="Coverage",P[P.HasNonDefaultProfile=16]="HasNonDefaultProfile",P[P.HasConfigurable=32]="HasConfigurable",P[P.SupportsContinuousRun=64]="SupportsContinuousRun"})(g||(e.TestRunProfileBitset=g={})),e.$JJ=[2,4,8,16,32,64];const w=P=>"runId"in P;e.$KJ=w;var A;(function(P){P.serialize=C=>({range:C.range.toJSON(),uri:C.uri.toJSON()}),P.deserialize=(C,J)=>({range:I.$Is.lift(J.range),uri:C.asCanonicalUri(E.URI.revive(J.uri))})})(A||(e.IRichLocation=A={}));var D;(function(P){P[P.Error=0]="Error",P[P.Output=1]="Output"})(D||(e.TestMessageType=D={}));var l;(function(P){P.serialize=C=>({message:C.message,type:0,expected:C.expected,actual:C.actual,contextValue:C.contextValue,location:C.location&&A.serialize(C.location)}),P.deserialize=(C,J)=>({message:J.message,type:0,expected:J.expected,actual:J.actual,contextValue:J.contextValue,location:J.location&&A.deserialize(C,J.location)})})(l||(e.ITestErrorMessage=l={}));const p=(P,C)=>`${C?"s":"e"}${P}`;e.$LJ=p;var b;(function(P){P.serialize=C=>({message:C.message,type:1,offset:C.offset,length:C.length,location:C.location&&A.serialize(C.location)}),P.deserialize=(C,J)=>({message:J.message,type:1,offset:J.offset,length:J.length,location:J.location&&A.deserialize(C,J.location)})})(b||(e.ITestOutputMessage=b={}));var r;(function(P){P.serialize=C=>C.type===0?l.serialize(C):b.serialize(C),P.deserialize=(C,J)=>J.type===0?l.deserialize(C,J):b.deserialize(C,J)})(r||(e.ITestMessage=r={}));var o;(function(P){P.serializeWithoutMessages=C=>({state:C.state,duration:C.duration,messages:[]}),P.serialize=C=>({state:C.state,duration:C.duration,messages:C.messages.map(r.serialize)}),P.deserialize=(C,J)=>({state:J.state,duration:J.duration,messages:J.messages.map(ae=>r.deserialize(C,ae))})})(o||(e.ITestTaskState=o={}));const t="\0",n=(P,C)=>P+t+C;e.$MJ=n;const a=P=>{const C=P.indexOf(t);return{ctrlId:P.slice(0,C),tagId:P.slice(C+1)}};e.$NJ=a;var c;(function(P){P.serialize=C=>({extId:C.extId,label:C.label,tags:C.tags,busy:C.busy,children:void 0,uri:C.uri?.toJSON(),range:C.range?.toJSON()||null,description:C.description,error:C.error,sortText:C.sortText}),P.deserialize=(C,J)=>({extId:J.extId,label:J.label,tags:J.tags,busy:J.busy,children:void 0,uri:J.uri?C.asCanonicalUri(E.URI.revive(J.uri)):void 0,range:J.range?I.$Is.lift(J.range):null,description:J.description,error:J.error,sortText:J.sortText})})(c||(e.ITestItem=c={}));var h;(function(P){P[P.NotExpandable=0]="NotExpandable",P[P.Expandable=1]="Expandable",P[P.BusyExpanding=2]="BusyExpanding",P[P.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var i;(function(P){P.serialize=C=>({expand:C.expand,item:c.serialize(C.item)}),P.deserialize=(C,J)=>({controllerId:F.$IJ.root(J.item.extId),expand:J.expand,item:c.deserialize(C,J.item)})})(i||(e.InternalTestItem=i={}));var s;(function(P){P.serialize=C=>{let J;return C.item&&(J={},C.item.label!==void 0&&(J.label=C.item.label),C.item.tags!==void 0&&(J.tags=C.item.tags),C.item.busy!==void 0&&(J.busy=C.item.busy),C.item.uri!==void 0&&(J.uri=C.item.uri?.toJSON()),C.item.range!==void 0&&(J.range=C.item.range?.toJSON()),C.item.description!==void 0&&(J.description=C.item.description),C.item.error!==void 0&&(J.error=C.item.error),C.item.sortText!==void 0&&(J.sortText=C.item.sortText)),{extId:C.extId,expand:C.expand,item:J}},P.deserialize=C=>{let J;return C.item&&(J={},C.item.label!==void 0&&(J.label=C.item.label),C.item.tags!==void 0&&(J.tags=C.item.tags),C.item.busy!==void 0&&(J.busy=C.item.busy),C.item.range!==void 0&&(J.range=C.item.range?I.$Is.lift(C.item.range):null),C.item.description!==void 0&&(J.description=C.item.description),C.item.error!==void 0&&(J.error=C.item.error),C.item.sortText!==void 0&&(J.sortText=C.item.sortText)),{extId:C.extId,expand:C.expand,item:J}}})(s||(e.ITestItemUpdate=s={}));const u=(P,C)=>{C.expand!==void 0&&(P.expand=C.expand),C.item!==void 0&&(P.item=P.item?Object.assign(P.item,C.item):C.item)};e.$OJ=u;var d;(function(P){P.serializeWithoutMessages=C=>({...i.serialize(C),ownComputedState:C.ownComputedState,computedState:C.computedState,tasks:C.tasks.map(o.serializeWithoutMessages)}),P.serialize=C=>({...i.serialize(C),ownComputedState:C.ownComputedState,computedState:C.computedState,tasks:C.tasks.map(o.serialize)}),P.deserialize=(C,J)=>({...i.deserialize(C,J),ownComputedState:J.ownComputedState,computedState:J.computedState,tasks:J.tasks.map(ae=>o.deserialize(C,ae)),retired:!0})})(d||(e.TestResultItem=d={}));var m;(function(P){P.empty=()=>({covered:0,total:0}),P.sum=(C,J)=>{C.covered+=J.covered,C.total+=J.total}})(m||(e.ICoveredCount=m={}));var f;(function(P){P.serialize=C=>({statement:C.statement,branch:C.branch,function:C.function,details:C.details?.map(y.serialize),uri:C.uri.toJSON()}),P.deserialize=(C,J)=>({statement:J.statement,branch:J.branch,function:J.function,details:J.details?.map(y.deserialize),uri:C.asCanonicalUri(E.URI.revive(J.uri))})})(f||(e.IFileCoverage=f={}));function S(P){return{...P,location:P.location?.toJSON()}}function L(P){return P.location=P.location?T.$Hs.isIPosition(P.location)?T.$Hs.lift(P.location):I.$Is.lift(P.location):void 0,P}e.$PJ=3;var v;(function(P){P[P.Function=0]="Function",P[P.Statement=1]="Statement"})(v||(e.DetailType=v={}));var y;(function(P){P.serialize=C=>C.type===0?N.serialize(C):O.serialize(C),P.deserialize=C=>C.type===0?N.deserialize(C):O.deserialize(C)})(y||(e.CoverageDetails=y={}));var k;(function(P){P.serialize=S,P.deserialize=L})(k||(e.IBranchCoverage=k={}));var N;(function(P){P.serialize=S,P.deserialize=L})(N||(e.IFunctionCoverage=N={}));var O;(function(P){P.serialize=C=>({...S(C),branches:C.branches?.map(k.serialize)}),P.deserialize=C=>({...L(C),branches:C.branches?.map(k.deserialize)})})(O||(e.IStatementCoverage=O={}));var K;(function(P){P[P.Add=0]="Add",P[P.Update=1]="Update",P[P.DocumentSynced=2]="DocumentSynced",P[P.Remove=3]="Remove",P[P.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",P[P.Retire=5]="Retire",P[P.AddTag=6]="AddTag",P[P.RemoveTag=7]="RemoveTag"})(K||(e.TestDiffOpType=K={}));var j;(function(P){P.deserialize=(C,J)=>J.op===0?{op:J.op,item:i.deserialize(C,J.item)}:J.op===1?{op:J.op,item:s.deserialize(J.item)}:J.op===2?{op:J.op,uri:C.asCanonicalUri(E.URI.revive(J.uri)),docv:J.docv}:J,P.serialize=C=>C.op===0?{op:C.op,item:i.serialize(C.item)}:C.op===1?{op:C.op,item:s.serialize(C.item)}:C})(j||(e.TestsDiffOp=j={}));class W{constructor(C){this.k=C,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(C){const J=this.v();for(const ae of C)switch(ae.op){case 0:this.l(i.deserialize(this.k,ae.item),J);break;case 1:this.o(s.deserialize(ae.item),J);break;case 3:this.p(ae.itemId,J);break;case 5:this.q(ae.itemId);break;case 4:this.updatePendingRoots(ae.amount);break;case 6:this.c.set(ae.tag.id,ae.tag);break;case 7:this.c.delete(ae.id);break}J.complete?.()}l(C,J){const ae=F.$IJ.parentId(C.item.extId)?.toString();let fe;if(!ae)fe=this.w(C),this.g.add(fe),this.f.set(C.item.extId,fe);else if(this.f.has(ae)){const be=this.f.get(ae);be.children.add(C.item.extId),fe=this.w(C,be),this.f.set(C.item.extId,fe)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(C)}`);return}return J.add?.(fe),C.expand===2&&this.h++,fe}o(C,J){const ae=this.f.get(C.extId);if(ae)return C.expand!==void 0&&(ae.expand===2&&this.h--,C.expand===2&&this.h++),(0,e.$OJ)(ae,C),J.update?.(ae),ae}p(C,J){const ae=this.f.get(C);if(!ae)return;const fe=F.$IJ.parentId(ae.item.extId)?.toString();fe?this.f.get(fe).children.delete(ae.item.extId):this.g.delete(ae);const be=[[C]];for(;be.length;)for(const ye of be.pop()){const he=this.f.get(ye);he&&(be.push(he.children),this.f.delete(ye),J.remove?.(he,he!==ae),he.expand===2&&this.h--)}}q(C){}updatePendingRoots(C){this.j+=C}v(){return{}}}e.$QJ=W}),define(Ce[77],Re([1,0,13,5,6,53,58,48]),function(ge,e,E,T,I,F,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=e.$NM=e.$MM=e.$LM=e.$KM=e.TestItemEventOp=void 0;var g;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(g||(e.TestItemEventOp=g={}));const w=(n,a)=>n===a,D=Object.entries({range:(n,a)=>n===a?!0:!n||!a?!1:n.equalsRange(a),busy:w,label:w,description:w,error:w,sortText:w,tags:(n,a)=>!(n.length!==a.length||n.some(c=>!a.includes(c)))}),l=(n,a)=>{let c;for(const[h,i]of D)i(n[h],a[h])||(c?c[h]=a[h]:c={[h]:a[h]});return c};class p extends I.$Sc{get root(){return this.s.root}constructor(a){super(),this.s=a,this.f=this.B(new E.$ch(()=>this.flushDiff(),200)),this.g=this.B(new T.$Sd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(a){this.h=a;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const a=this.m;return this.m=[],a}pushDiff(a){switch(a.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===a.uri){c.docv=a.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===a.item.extId){(0,R.$OJ)(c.item,a.item);return}if(c.op===0&&c.item.item.extId===a.item.extId){(0,R.$OJ)(c.item,a.item);return}}break}}this.m.push(a),this.f.isScheduled()||this.f.schedule()}expand(a,c){const h=this.tree.get(a);if(h){if((h.expandLevels===void 0||c>h.expandLevels)&&(h.expandLevels=c),h.expand===1){const i=this.M(h);return i.isOpen()?this.L(h,c-1):i.wait().then(()=>this.L(h,c-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,c-1)):this.L(h,c-1)}}dispose(){for(const a of this.tree.values())this.s.getApiFor(a.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(a,c){switch(c.op){case 3:this.O($.$IJ.joinToString(a.fullId,c.id));break;case 0:this.z(c.item,a);break;case 5:for(const h of c.ops)this.w(a,h);break;case 1:this.C(c.new,c.old,a.fullId.toString());break;case 2:this.J(a);break;case 4:this.pushDiff({op:1,item:{extId:a.fullId.toString(),item:c.update}});break;case 6:this.y(a.actual.uri);break;default:(0,F.$5c)(c)}}y(a){a&&this.pushDiff({op:2,uri:a,docv:this.s.getDocumentVersion(a)})}z(a,c){const h=$.$IJ.fromExtHostTestItem(a,this.root.id,c?.actual),i=this.s.getApiFor(a);i.parent&&i.parent!==c?.actual&&this.s.getChildren(i.parent).delete(a.id);let s=this.tree.get(h.toString());if(!s){s={fullId:h,actual:a,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},a.tags.forEach(this.D,this),this.tree.set(s.fullId.toString(),s),this.G(a,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(a)}}),this.I(a,s,c);return}if(s.actual===a){this.H(a,s,c);return}if(s.actual.uri?.toString()!==a.uri?.toString())return this.O(h.toString()),this.z(a,c);const u=this.s.getChildren(s.actual),d=s.actual,m=l(this.s.toITestItem(d),this.s.toITestItem(a));this.s.getApiFor(d).listener=void 0,s.actual=a,s.expand=0,m&&(m.hasOwnProperty("tags")&&(this.C(a.tags,d.tags,h.toString()),delete m.tags),this.w(s,{op:4,update:m})),this.I(a,s,c);for(const[f,S]of u)this.s.getChildren(a).get(S.id)||this.O($.$IJ.joinToString(h,S.id));this.y(s.actual.uri)}C(a,c,h){const i=new Set(c.map(s=>s.id));for(const s of a)i.delete(s.id)||this.D(s);this.pushDiff({op:1,item:{extId:h,item:{tags:a.map(s=>(0,R.$MJ)(this.s.controllerId,s.id))}}}),i.forEach(this.F,this)}D(a){const c=this.j.get(a.id);c?c.refCount++:(this.j.set(a.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$MJ)(this.s.controllerId,a.id)}}))}F(a){const c=this.j.get(a);c&&!--c.refCount&&(this.j.delete(a),this.pushDiff({op:7,id:(0,R.$MJ)(this.s.controllerId,a)}))}G(a,c){this.s.getApiFor(a).parent=c&&c.actual!==this.root?c.actual:void 0}H(a,c,h){this.G(a,h);const i=this.s.getApiFor(a);i.parent=h?.actual,i.listener=s=>this.w(c,s),this.J(c)}I(a,c,h){this.H(a,c,h);for(const[i,s]of this.s.getChildren(a))this.z(s,c)}J(a){let c;this.h?a.resolveBarrier?c=a.resolveBarrier.isOpen()?3:2:c=a.actual.canResolveChildren?1:0:c=0,c!==a.expand&&(a.expand=c,this.pushDiff({op:1,item:{extId:a.fullId.toString(),expand:c}}),c===1&&a.expandLevels!==void 0&&this.M(a))}L(a,c){if(c<0)return;const h=[];for(const[i,s]of this.s.getChildren(a.actual)){const u=this.expand($.$IJ.joinToString(a.fullId,s.id),c);(0,E.$Pg)(u)&&h.push(u)}if(h.length)return Promise.all(h).then(()=>{})}M(a){if(a.resolveBarrier)return a.resolveBarrier;if(!this.h){const s=new E.$2g;return s.open(),s}a.expand=2,this.N(a);const c=a.resolveBarrier=new E.$2g,h=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let i;try{i=this.h(a.actual===this.root?void 0:a.actual)}catch(s){h(s)}return(0,E.$Pg)(i)?i.catch(h).then(()=>{c.open(),this.J(a)}):(c.open(),this.J(a)),a.resolveBarrier}N(a){this.pushDiff({op:1,item:{extId:a.fullId.toString(),expand:a.expand}})}O(a){const c=this.tree.get(a);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:a});const h=[c];for(;h.length;){const i=h.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const s of i.actual.tags)this.F(s.id);this.tree.delete(i.fullId.toString());for(const[s,u]of this.s.getChildren(i.actual))h.push(this.tree.get($.$IJ.joinToString(i.fullId,u.id)))}}}flushDiff(){const a=this.collectDiff();a.length&&this.g.fire(a)}}e.$KM=p;class b extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.$LM=b;class r extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$MM=r;class o extends Error{constructor(a,c,h){super(`TestItem with ID "${a}" is from controller "${c}" and cannot be added as a child of an item from controller "${h}".`)}}e.$NM=o;const t=(n,a,c)=>{let h=new Map;return{get size(){return h.size},forEach(i,s){for(const u of h.values())i.call(s,u,this)},[Symbol.iterator](){return h.entries()},replace(i){const s=new Map,u=new Set(h.keys()),d={op:5,ops:[]};for(const m of i){if(!(m instanceof c))throw new r(m.id);const f=a(m).controllerId;if(f!==n.controllerId)throw new o(m.id,f,n.controllerId);if(s.has(m.id))throw new b(m.id);s.set(m.id,m),u.delete(m.id),d.ops.push({op:0,item:m})}for(const m of u.keys())d.ops.push({op:3,id:m});n.listener?.(d),h=s},add(i){if(!(i instanceof c))throw new r(i.id);h.set(i.id,i),n.listener?.({op:0,item:i})},delete(i){h.delete(i)&&n.listener?.({op:3,id:i})},get(i){return h.get(i)},toJSON(){return Array.from(h.values())}}};e.$OM=t}),define(Ce[104],Re([1,0,77]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$PM=void 0;const T=new WeakMap,I=(R,$)=>{const g={controllerId:$};return T.set(R,g),g};e.$PM=I;const F=R=>{const $=T.get(R);if(!$)throw new E.$MM(R?.id||"<unknown>");return $};e.$QM=F}),define(Ce[78],Re([1,0,12,2]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mvb=e.$lvb=e.$kvb=e.$jvb=e.$ivb=void 0,e.$ivb="vscode-cdn.net",e.$jvb=`vscode-resource.${e.$ivb}`,e.$kvb=`'self' https://*.${e.$ivb}`;function I($,g){return $.scheme===E.Schemas.http||$.scheme===E.Schemas.https?$:(g&&g.authority&&g.isRemote&&$.scheme===E.Schemas.file&&($=T.URI.from({scheme:E.Schemas.vscodeRemote,authority:g.authority,path:$.path})),T.URI.from({scheme:E.Schemas.https,authority:`${$.scheme}+${F($.authority)}.${e.$jvb}`,path:$.path,fragment:$.fragment,query:$.query}))}e.$lvb=I;function F($){return $.replace(/./g,g=>{const w=g.charCodeAt(0);return w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57?g:"-"+w.toString(16).padStart(4,"0")})}function R($){return $.replace(/-([0-9a-f]{4})/g,(g,w)=>String.fromCharCode(parseInt(w,16)))}e.$mvb=R}),define(Ce[213],Re([1,0,5,6,78]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=void 0;class F{constructor($,g,w){this.d=$,this.e=g,this.f=w,this.a=0,this.b=new T.$Rc,this.c=new Map,this.b.add(g.onDidChangeVisibleTextEditors(()=>{const A=g.getVisibleTextEditors();for(const D of this.c.values())A.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach($=>$.inset.dispose()),this.b.dispose()}createWebviewEditorInset($,g,w,A,D){let l;for(const a of this.e.getVisibleTextEditors(!0))if(a.value===$){l=a;break}if(!l)throw new Error("not a visible editor");const p=this,b=this.a++,r=new E.$Sd,o=new E.$Sd,t=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(a){return(0,I.$lvb)(a,p.f)}get cspSource(){return I.$kvb}set options(a){this.b=a,p.d.$setOptions(b,a)}get options(){return this.b}set html(a){this.a=a,p.d.$setHtml(b,a)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(a){return p.d.$postMessage(b,a)}},n=new class{constructor(){this.editor=$,this.line=g,this.height=w,this.webview=t,this.onDidDispose=o.event}dispose(){p.c.has(b)&&(p.c.delete(b),p.d.$disposeEditorInset(b),o.fire(),o.dispose(),r.dispose())}};return this.d.$createEditorInset(b,l.id,l.value.document.uri,g+1,w,A||{},D.identifier,D.extensionLocation),this.c.set(b,{editor:$,inset:n,onDidReceiveMessage:r}),n}$onDidDispose($){const g=this.c.get($);g&&g.inset.dispose()}$onDidReceiveMessage($,g){this.c.get($)?.onDidReceiveMessage.fire(g)}}e.$xfc=F}),define(Ce[214],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HN=e.VariableKind=e.$GN=void 0,e.$GN=(0,E.$3h)("configurationResolverService");var T;(function(F){F.Unknown="unknown",F.Env="env",F.Config="config",F.Command="command",F.Input="input",F.ExtensionInstallFolder="extensionInstallFolder",F.WorkspaceFolder="workspaceFolder",F.Cwd="cwd",F.WorkspaceFolderBasename="workspaceFolderBasename",F.UserHome="userHome",F.LineNumber="lineNumber",F.SelectedText="selectedText",F.File="file",F.FileWorkspaceFolder="fileWorkspaceFolder",F.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",F.RelativeFile="relativeFile",F.RelativeFileDirname="relativeFileDirname",F.FileDirname="fileDirname",F.FileExtname="fileExtname",F.FileBasename="fileBasename",F.FileBasenameNoExtension="fileBasenameNoExtension",F.FileDirnameBasename="fileDirnameBasename",F.ExecPath="execPath",F.ExecInstallFolder="execInstallFolder",F.PathSeparator="pathSeparator",F.PathSeparatorAlias="/"})(T||(e.VariableKind=T={}));class I extends Error{constructor(R,$){super($),this.variable=R}}e.$HN=I}),define(Ce[215],Re([1,0,19,74,16,26,21,95,177,214,11]),function(ge,e,E,T,I,F,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VN=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(p,b,r,o){this.h=new Map,this.a=p,this.b=b,this.g=r,o&&(this.c=o.then(t=>this.i(t)))}i(p){if(R.$i){const b=Object.create(null);return Object.keys(p).forEach(r=>{b[r.toLowerCase()]=p[r]}),b}return p}resolveWithEnvironment(p,b,r){return this.l({env:this.i(p),userHome:void 0},b?b.uri:void 0,r)}async resolveAsync(p,b){const r={env:await this.c,userHome:await this.g};return this.l(r,p?p.uri:void 0,b)}async j(p,b,r,o){const t=F.$jn(b);R.$i&&t.windows?Object.keys(t.windows).forEach(a=>t[a]=t.windows[a]):R.$j&&t.osx?Object.keys(t.osx).forEach(a=>t[a]=t.osx[a]):R.$k&&t.linux&&Object.keys(t.linux).forEach(a=>t[a]=t.linux[a]),delete t.windows,delete t.osx,delete t.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,p?p.uri:void 0,t,r,o)}async resolveAnyAsync(p,b,r){return this.j(p,b,r)}async resolveAnyMap(p,b,r){const o=new Map;return{newConfig:await this.j(p,b,r,o),resolvedVariables:o}}resolveWithInteractionReplace(p,b,r,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,b,r,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,b){if(this.h.has(p))throw new Error("Variable "+p+" is contributed twice.");this.h.set(p,b)}async l(p,b,r,o,t){if(I.$Ff(r))return this.m(p,b,r,o,t);if(Array.isArray(r))return Promise.all(r.map(n=>this.l(p,b,n,o,t)));if(I.$Hf(r)){const n=Object.create(null),a=await Promise.all(Object.keys(r).map(async c=>[await this.m(p,b,c,o,t),await this.l(p,b,r[c],o,t)]));for(const[c,h]of a)n[c]=h;return n}return r}m(p,b,r,o,t){return(0,A.$1e)(r,D.VARIABLE_REGEXP,async(n,a)=>{if(a.includes(D.VARIABLE_LHS))return n;let c=await this.o(p,n,a,b,o);return t?.set(a,c),c!==n&&I.$Ff(c)&&c.match(D.VARIABLE_REGEXP)&&(c=await this.m(p,b,c,o,t)),c})}n(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async o(p,b,r,o,t){let n;const a=r.split(":");a.length>1&&(r=a[0],n=a[1]);const c=s=>{const u=this.a.getFilePath();if(u)return(0,$.$Jv)(u);throw new w.$HN(s,(0,g.localize)(0,null,b))},h=s=>{const u=c(s);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,$.$Jv)(d)}throw new w.$HN(s,(0,g.localize)(1,null,b,E.$nc(u)))},i=s=>{if(n){const u=this.a.getFolderUri(n);if(u)return u;throw new w.$HN(s,(0,g.localize)(2,null,b,n))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new w.$HN(s,(0,g.localize)(3,null,b)):new w.$HN(s,(0,g.localize)(4,null,b))};switch(r){case"env":if(n){if(p.env){const s=p.env[R.$i?n.toLowerCase():n];if(I.$Ff(s))return s}return""}throw new w.$HN(w.VariableKind.Env,(0,g.localize)(5,null,b));case"config":if(n){const s=this.a.getConfigurationValue(o,n);if(I.$Of(s))throw new w.$HN(w.VariableKind.Config,(0,g.localize)(6,null,b,n));if(I.$Hf(s))throw new w.$HN(w.VariableKind.Config,(0,g.localize)(7,null,b,n));return s}throw new w.$HN(w.VariableKind.Config,(0,g.localize)(8,null,b));case"command":return this.p(w.VariableKind.Command,b,n,t,"command");case"input":return this.p(w.VariableKind.Input,b,n,t,"input");case"extensionInstallFolder":if(n){const s=await this.a.getExtension(n);if(!s)throw new w.$HN(w.VariableKind.ExtensionInstallFolder,(0,g.localize)(9,null,b,n));return this.n(s.extensionLocation)}throw new w.$HN(w.VariableKind.ExtensionInstallFolder,(0,g.localize)(10,null,b));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,$.$Jv)(this.n(i(w.VariableKind.WorkspaceFolder)));case"cwd":return o||n?(0,$.$Jv)(this.n(i(w.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,$.$Jv)(E.$nc(this.n(i(w.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new w.$HN(w.VariableKind.UserHome,(0,g.localize)(11,null,b))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new w.$HN(w.VariableKind.LineNumber,(0,g.localize)(12,null,b))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new w.$HN(w.VariableKind.SelectedText,(0,g.localize)(13,null,b))}case"file":return c(w.VariableKind.File);case"fileWorkspaceFolder":return h(w.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return E.$nc(h(w.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||n?E.$lc(this.n(i(w.VariableKind.RelativeFile)),c(w.VariableKind.RelativeFile)):c(w.VariableKind.RelativeFile);case"relativeFileDirname":{const s=E.$mc(c(w.VariableKind.RelativeFileDirname));if(o||n){const u=E.$lc(this.n(i(w.VariableKind.RelativeFileDirname)),s);return u.length===0?".":u}return s}case"fileDirname":return E.$mc(c(w.VariableKind.FileDirname));case"fileExtname":return E.$oc(c(w.VariableKind.FileExtname));case"fileBasename":return E.$nc(c(w.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=E.$nc(c(w.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-E.$oc(s).length)}case"fileDirnameBasename":return E.$nc(E.$mc(c(w.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||b}case"execInstallFolder":{const s=this.a.getAppRoot();return s||b}case"pathSeparator":case"/":return E.sep;default:try{const s=n?`${r}:${n}`:r;return this.p(w.VariableKind.Unknown,b,s,t,void 0)}catch{return b}}}}p(p,b,r,o,t){if(r&&o){const n=t===void 0?o[r]:o[t+":"+r];if(typeof n=="string")return n;throw new w.$HN(p,(0,g.localize)(14,null,b))}return b}}e.$VN=D}),define(Ce[105],Re([1,0,4,102]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XC=e.$WC=e.OpenEditorContext=e.GroupsOrder=e.$VC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$UC=void 0,e.$UC=(0,E.$3h)("editorGroupsService");var I;(function(b){b[b.UP=0]="UP",b[b.DOWN=1]="DOWN",b[b.LEFT=2]="LEFT",b[b.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var F;(function(b){b[b.HORIZONTAL=0]="HORIZONTAL",b[b.VERTICAL=1]="VERTICAL"})(F||(e.GroupOrientation=F={}));var R;(function(b){b[b.FIRST=0]="FIRST",b[b.LAST=1]="LAST",b[b.NEXT=2]="NEXT",b[b.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var $;(function(b){b[b.MAXIMIZE=0]="MAXIMIZE",b[b.EXPAND=1]="EXPAND",b[b.EVEN=2]="EVEN"})($||(e.GroupsArrangement=$={}));var g;(function(b){b[b.COPY_EDITORS=0]="COPY_EDITORS",b[b.MOVE_EDITORS=1]="MOVE_EDITORS"})(g||(e.MergeGroupMode=g={}));function w(b){const r=b;return(0,T.$EE)(r?.editor)&&(0,T.$EE)(r?.replacement)}e.$VC=w;var A;(function(b){b[b.CREATION_TIME=0]="CREATION_TIME",b[b.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",b[b.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var D;(function(b){b[b.NEW_EDITOR=1]="NEW_EDITOR",b[b.MOVE_EDITOR=2]="MOVE_EDITOR",b[b.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function l(b){const r=b;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}e.$WC=l;function p(b){return b.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$XC=p}),define(Ce[216],Re([1,0,4,105]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3C=e.$2C=e.$1C=e.$ZC=e.$YC=void 0,e.$YC=(0,E.$3h)("editorService"),e.$ZC=-1,e.$1C=-2,e.$2C=-3;function I(F){const R=F;return typeof F=="number"||(0,T.$WC)(R)}e.$3C=I}),define(Ce[217],Re([1,0,4,184]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bK=void 0,e.$bK=(0,E.$4h)(T.$0h)}),define(Ce[106],Re([1,0,22,5,19,6]),function(ge,e,E,T,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s7b=e.$r7b=e.$q7b=e.$p7b=e.$o7b=void 0;class R{constructor(t,n){this.versionId=t,this.removedDueToLooping=n}}e.$o7b=R;class ${static isHostExtension(t,n,a){if(n.getExtensionDescription(t))return!1;const c=a.getExtensionDescription(t);return c?!!((c.main||c.browser)&&c.api==="none"):!1}constructor(t,n){this.j=t,this.c=new T.$Sd,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(b),this.f=new E.$km,this.g=[],this.h=new Map;for(const t of this.e){if(this.f.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.f.set(t.identifier,t),this.g.push(t);const n=this.j.readActivationEvents(t);for(const a of n)this.h.has(a)||this.h.set(a,[]),this.h.get(a).push(t)}}set(t){return this.e=t,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(t,n){this.e=r(this.e,n),this.e=this.e.concat(t);const a=$.l(this.e);return this.e=r(this.e,a.map(c=>c.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,a)}static l(t){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,u){this.addNode(s),this.addNode(u),this.c.has(s)?this.c.get(s).push(u):this.c.set(s,[u])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,u){const d=n.getArcs(s);for(let m=0;m<d.length;m++)if(!u.has(d[m]))return!1;return!0}getNodes(){return this.e}},a=new E.$km;for(const s of t)if(a.set(s.identifier,s),s.extensionDependencies)for(const u of s.extensionDependencies)n.addArc(E.$im.toKey(s.identifier),E.$im.toKey(u));const c=new Set;n.getNodes().filter(s=>n.getArcs(s).length===0).forEach(s=>c.add(s));const h=n.getNodes().filter(s=>!c.has(s));let i;do{i=!1;for(let s=0;s<h.length;s++){const u=h[s];n.hasOnlyGoodArcs(u,c)&&(h.splice(s,1),s--,c.add(u),i=!0)}}while(i);return h.map(s=>a.get(s))}containsActivationEvent(t){return this.h.has(t)}containsExtension(t){return this.f.has(t)}getExtensionDescriptionsForActivationEvent(t){const n=this.h.get(t);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new g(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(t){const n=this.f.get(t);return n||void 0}getExtensionDescriptionByUUID(t){for(const n of this.g)if(n.uuid===t)return n}getExtensionDescriptionByIdOrUUID(t,n){return this.getExtensionDescription(t)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$p7b=$;class g{constructor(t,n){this.versionId=t,this.extensions=n}}e.$q7b=g;class w{constructor(t){this.d=new l,this.c=new $(t,[])}async acquireLock(t){const n=await this.d.acquire(t);return new A(this,n)}deltaExtensions(t,n,a){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,a)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,n){return this.c.getExtensionDescriptionByIdOrUUID(t,n)}}e.$r7b=w;class A extends F.$Sc{constructor(t,n){super(),this.f=t,this.c=!1,this.B(n)}isAcquiredFor(t){return!this.c&&this.f===t}}e.$s7b=A;class D{constructor(t){this.name=t,this.promise=new Promise((n,a)=>{this.c=n})}resolve(t){this.c(t)}}class l{constructor(){this.c=[],this.d=!1}async acquire(t){const n=new D(t);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let n=!0;const a=setTimeout(()=>{n&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),c=()=>{n&&(clearTimeout(a),n=!1,this.d=!1,this.e())};t.resolve((0,F.$Qc)(c))}}var p;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(p||(p={}));function b(o,t){const n=o.isBuiltin?0:o.isUnderDevelopment?2:1,a=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(n!==a)return n-a;const c=I.$gc.basename(o.extensionLocation.path),h=I.$gc.basename(t.extensionLocation.path);return c<h?-1:c>h?1:0}function r(o,t){const n=new E.$jm(t);return o.filter(a=>!n.has(a.identifier))}}),define(Ce[79],Re([1,0,24]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$rm=e.$qm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(w){w[w.Desktop=1]="Desktop",w[w.Web=2]="Web"})(T||(e.UIKind=T={}));var I;(function(w){w[w.VersionMismatch=55]="VersionMismatch",w[w.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var F;(function(w){w[w.Initialized=0]="Initialized",w[w.Ready=1]="Ready",w[w.Terminate=2]="Terminate"})(F||(e.MessageType=F={}));function R(w){const A=E.$ge.alloc(1);switch(w){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$qm=R;function $(w,A){if(w.byteLength!==1)return!1;switch(w.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$rm=$;var g;(function(w){w.Start="START_NATIVE_LOG",w.End="END_NATIVE_LOG"})(g||(e.NativeLogMarkers=g={}))}),define(Ce[59],Re([1,0,4,5,14,27,79,55,56,26,2,6,165]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cN=e.$bN=e.$aN=e.$_M=void 0;let p=class extends D.$Sc{constructor(t,n){super(),this.s=t,this.t=n,this.a=this.B(new T.$Sd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$Sd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:g.$Do,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(a=>{(0,I.$mj)(a)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===I.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(t,n,a){const c=this.getTelemetryDetails(),h=new b(n,a,t,this.n,this.j,this.getBuiltInCommonProperties(t),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),i=this.r.get(t.identifier.value)??[];return this.r.set(t.identifier.value,[...i,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(t,n,a){this.f=t,this.g=n,this.c=a??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(t){const n=Object.create(null);switch(n["common.extname"]=`${t.publisher}.${t.name}`,n["common.extversion"]=t.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=r(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,$.$$k)((0,g.$Ko)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(t){this.h=this.getTelemetryConfiguration(),this.f=t;const n=this.getTelemetryDetails();this.r.forEach((a,c)=>{const h=a.filter(i=>!i.isDisposed);h.length===0?this.r.delete(c):this.r.set(c,h)}),this.r.forEach(a=>{for(const c of a)c.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(t,n){const c=this.r.get(t.value)?.filter(i=>!i.isDisposed);if(!c)return this.r.delete(t.value),!1;let h=!1;for(const i of c)i.ignoreUnhandledExtHostErrors||(i.logError(n),h=!0);return h}};e.$_M=p,e.$_M=p=Ge([Ke(0,F.$$M),Ke(1,I.$lj)],p);class b{static validateSender(t){if(typeof t!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof t.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof t.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof t.flush<"u"&&typeof t.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(t,n,a,c,h,i,s){this.g=a,this.h=c,this.i=h,this.j=i,this.a=new T.$Sd,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=t,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(t,n){this.e&&(this.d={isUsageEnabled:t,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(t){let n="properties"in t?t.properties??{}:t;return n=(0,g.$No)(n,[]),this.c&&(n=(0,w.$mn)(n,this.c)),this.b||(n=(0,w.$mn)(n,this.j)),"properties"in t?t.properties=n:t=n,t}k(t,n){this.f&&(this.g.publisher==="vscode"?t=this.g.name+"/"+t:t=this.g.identifier.value+"/"+t,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(t,n),this.h.trace(t,n))}logUsage(t,n){this.d.isUsageEnabled&&this.k(t,n)}logError(t,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof t=="string")this.k(t,n);else{const a={name:t.name,message:t.message,stack:t.stack,cause:t.cause},c=(0,g.$No)(a,[]),h=new Error(c.message,{cause:c.cause});h.stack=c.stack,h.name=c.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(h,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const t=this,n={logUsage:t.logUsage.bind(t),get isUsageEnabled(){return t.d.isUsageEnabled},get isErrorsEnabled(){return t.d.isErrorsEnabled},logError:t.logError.bind(t),dispose:t.dispose.bind(t),onDidChangeEnableStates:t.a.event.bind(t)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let t=this.f;this.f=void 0,Promise.resolve(t.flush()).then(t=void 0),this.e=void 0}else this.f=void 0}}e.$aN=b;function r(o){const t=Date.now()-new Date(o).getTime();return isNaN(t)?!1:t<1e3*60*60*24}e.$bN=r,e.$cN=(0,E.$3h)("IExtHostTelemetry")}),define(Ce[23],Re([1,0,5,2,193,101,22,4]),function(ge,e,E,T,I,F,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uF=e.$tF=e.$sF=e.ActivationKind=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.ExtensionHostStartup=e.$mF=e.$lF=e.$kF=e.$jF=void 0,e.$jF=Object.freeze({identifier:new R.$im("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$kF="extensions.webWorker",e.$lF=(0,$.$3h)("extensionService");class g{constructor(h){this.dependency=h}}e.$mF=g;var w;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(w||(e.ExtensionHostStartup=w={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,i,s){this.c=h,this.d=i.slice(0),this.e=s.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:F.$7E.createActivationEventsMap(this.d)}}set(h,i,s){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const u=[],d=[],m=[],f=[],S=D(this.d),L=D(i),v=(K,j)=>K.extensionLocation.toString()===j.extensionLocation.toString()||K.isBuiltin===j.isBuiltin||K.isUserBuiltin===j.isUserBuiltin||K.isUnderDevelopment===j.isUnderDevelopment;for(const K of this.d){const j=L.get(K.identifier);if(!j){u.push(K.identifier),S.delete(K.identifier);continue}if(!v(K,j)){u.push(K.identifier),S.delete(K.identifier);continue}}for(const K of i){const j=S.get(K.identifier);if(!j){d.push(K);continue}if(!v(j,K)){u.push(j.identifier),S.delete(j.identifier);continue}}const y=new R.$jm(this.e),k=new R.$jm(s);for(const K of this.e)k.has(K)||m.push(K);for(const K of s)y.has(K)||f.push(K);const N=F.$7E.createActivationEventsMap(d),O={versionId:h,toRemove:u,toAdd:d,addActivationEvents:N,myToRemove:m,myToAdd:f};return this.delta(O),O}delta(h){if(this.c>=h.versionId)return null;const{toRemove:i,toAdd:s,myToRemove:u,myToAdd:d}=h,m=new R.$jm(i),f=new R.$jm(u);for(let S=0;S<this.d.length;S++)m.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)f.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of s)this.d.push(S);for(const S of d)this.e.push(S);return this.f=null,h}containsExtension(h){for(const i of this.e)if(R.$im.equals(i,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const s=F.$7E.readActivationEvents(i);for(const u of s)h.add(u)}return h}}e.$nF=A;function D(c){const h=new R.$km;for(const i of c)h.set(i.identifier,i);return h}function l(c,h){return c.enabledApiProposals?c.enabledApiProposals.includes(h):!1}e.$oF=l;function p(c,h){if(!l(c,h))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.$pF=p;class b{constructor(h,i,s,u){this.codeLoadingTime=h,this.activateCallTime=i,this.activateResolvedTime=s,this.activationReason=u}}e.$qF=b;class r{constructor(h,i){this.description=h,this.value=i}}e.$rF=r;var o;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function t(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,I.$To)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.$sF=t;function n(c,h){return{identifier:new R.$im((0,I.$Ro)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!h,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform}}e.$tF=n;class a{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None,this.onWillStop=E.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,i){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$uF=a}),define(Ce[218],Re([1,0,15,106,22,23,14,13]),function(ge,e,E,T,I,F,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yfc=e.$Xfc=e.$Wfc=e.$Vfc=e.$Ufc=e.$Tfc=void 0;class g{static{this.NONE=new g(!1,-1,-1,-1)}constructor(t,n,a,c){this.startup=t,this.codeLoadingTime=n,this.activateCallTime=a,this.activateResolvedTime=c}}e.$Tfc=g;class w{constructor(t){this.a=t,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(t,n){return t===-1||n===-1?-1:n-t}build(){return new g(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Ufc=w;class A{constructor(t,n,a,c,h,i){this.activationFailed=t,this.activationFailedError=n,this.activationTimes=a,this.module=c,this.exports=h,this.subscriptions=i}}e.$Vfc=A;class D extends A{constructor(t){super(!1,null,t,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Wfc=D;class l extends A{constructor(){super(!1,null,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Xfc=l;class p extends A{constructor(t){super(!0,t,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let b=class{constructor(t,n,a,c){this.g=c,this.a=t,this.b=n,this.c=a,this.d=new I.$km,this.f=Object.create(null)}dispose(){for(const[t,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const t=[];for(const[n,a]of this.d)t.push(a.wait());await Promise.all(t)}isActivated(t){const n=this.d.get(t);return!!(n&&n.value)}getActivatedExtension(t){const n=this.d.get(t);if(!n||!n.value)throw new Error(`Extension '${t.value}' is not known or not activated`);return n.value}async activateByEvent(t,n){if(this.f[t])return;const a=this.a.getExtensionDescriptionsForActivationEvent(t);await this.h(a.map(c=>({id:c.identifier,reason:{startup:n,extensionId:c.identifier,activationEvent:t}}))),this.f[t]=!0}activateById(t,n){const a=this.a.getExtensionDescription(t);if(!a)throw new Error(`Extension '${t}' is not known`);return this.h([{id:a.identifier,reason:n}])}async h(t){const n=t.filter(a=>!this.isActivated(a.id)).map(a=>this.j(a));await Promise.all(n.map(a=>a.wait()))}j(t){if(this.d.has(t.id))return this.d.get(t.id);if(this.l(t.id))return this.k(t,null,[],null);const n=this.a.getExtensionDescription(t.id);if(!n){const h=new Error(`Cannot activate unknown extension '${t.id.value}'`),i=this.k(t,null,[],new p(h));return this.c.onExtensionActivationError(t.id,h,new F.$mF(t.id.value)),i}const a=[],c=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const h of c){if(this.m(h))continue;const i=this.d.get(h);if(i){a.push(i);continue}if(this.l(h)){a.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:t.reason}));continue}const s=this.a.getExtensionDescription(h);if(s){if(!s.main&&!s.browser)continue;a.push(this.j({id:s.identifier,reason:t.reason}));continue}const u=n.displayName||n.identifier.value,d=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${h}'`),m=this.k(t,n.displayName,[],new p(d));return this.c.onExtensionActivationError(n.identifier,d,new F.$mF(h)),m}return this.k(t,n.displayName,a,null)}k(t,n,a,c){const h=new r(t.id,n,t.reason,a,c,this.c,this.g);return this.d.set(t.id,h),h}l(t){return T.$p7b.isHostExtension(t,this.a,this.b)}m(t){const n=this.b.getExtensionDescription(t);return n?!n.main&&!n.browser:!1}};e.$Yfc=b,e.$Yfc=b=Ge([Ke(3,R.$kj)],b);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(t,n,a,c,h,i,s){this.c=t,this.d=n,this.f=a,this.g=c,this.h=h,this.j=i,this.k=s,this.a=new $.$2g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let t=0;t<this.g.length;t++){const n=this.g[t];if(n.value&&!n.value.activationFailed){this.g.splice(t,1),t--;continue}if(n.value&&n.value.activationFailed){const a=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);a.detail=n.value.activationFailedError,this.h=new p(a),this.j.onExtensionActivationError(this.c,a,null);return}}this.g.length>0&&await Promise.race(this.g.map(t=>t.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(t){const n=new Error;if(t&&t.name&&(n.name=t.name),t&&t.message?n.message=`Activating extension '${this.c.value}' failed: ${t.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${t}.`,t&&t.stack&&(n.stack=t.stack),this.h=new p(n),this.b&&E.$4(t))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(t)}}};r=Ge([Ke(6,R.$kj)],r)}),define(Ce[8],Re([1,0,18,24,127,219,52,28,120,51,68,26,16,2,29,80,99,104,102,76,48,58,216,7,23]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l,p,b,r,o,t,n,a,c,h,i,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$TM=e.$SM=e.MarkdownString=e.$RM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var d;(function(Se){function Me(G){const{selectionStartLineNumber:Le,selectionStartColumn:Ue,positionLineNumber:Ze,positionColumn:Ve}=G,_e=new s.$TK(Le-1,Ue-1),mt=new s.$TK(Ze-1,Ve-1);return new s.$VK(_e,mt)}Se.to=Me;function de(G){const{anchor:Le,active:Ue}=G;return{selectionStartLineNumber:Le.line+1,selectionStartColumn:Le.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}Se.from=de})(d||(e.Selection=d={}));var m;(function(Se){function Me(G){if(!G)return;const{start:Le,end:Ue}=G;return{startLineNumber:Le.line+1,startColumn:Le.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}Se.from=Me;function de(G){if(!G)return;const{startLineNumber:Le,startColumn:Ue,endLineNumber:Ze,endColumn:Ve}=G;return new s.$UK(Le-1,Ue-1,Ze-1,Ve-1)}Se.to=de})(m||(e.Range=m={}));var f;(function(Se){function Me(de){switch(de){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Se.to=Me})(f||(e.TokenType=f={}));var S;(function(Se){function Me(G){return new s.$TK(G.lineNumber-1,G.column-1)}Se.to=Me;function de(G){return{lineNumber:G.line+1,column:G.character+1}}Se.from=de})(S||(e.Position=S={}));var L;(function(Se){function Me(Le,Ue,Ze){return(0,E.$Hb)((0,E.$3b)(Le).map(Ve=>de(Ve,Ue,Ze)))}Se.from=Me;function de(Le,Ue,Ze){if(typeof Le=="string")return{$serialized:!0,language:Le,isBuiltin:Ze?.isBuiltin};if(Le)return{$serialized:!0,language:Le.language,scheme:G(Le.scheme,Ue),pattern:X.from(Le.pattern)??void 0,exclusive:Le.exclusive,notebookType:Le.notebookType,isBuiltin:Ze?.isBuiltin}}function G(Le,Ue){return Ue&&typeof Le=="string"?Ue.transformOutgoingScheme(Le):Le}})(L||(e.DocumentSelector=L={}));var v;(function(Se){function Me(G){switch(G){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Se.from=Me;function de(G){switch(G){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Se.to=de})(v||(e.DiagnosticTag=v={}));var y;(function(Se){function Me(G){let Le;return G.code&&((0,l.$Ff)(G.code)||(0,l.$Jf)(G.code)?Le=String(G.code):Le={value:String(G.code.value),target:G.code.target}),{...m.from(G.range),message:G.message,source:G.source,code:Le,severity:N.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(k.from),tags:Array.isArray(G.tags)?(0,E.$Hb)(G.tags.map(v.from)):void 0}}Se.from=Me;function de(G){const Le=new s.$7K(m.to(G),G.message,N.to(G.severity));return Le.source=G.source,Le.code=(0,l.$Ff)(G.code)?G.code:G.code?.value,Le.relatedInformation=G.relatedInformation&&G.relatedInformation.map(k.to),Le.tags=G.tags&&(0,E.$Hb)(G.tags.map(v.to)),Le}Se.to=de})(y||(e.Diagnostic=y={}));var k;(function(Se){function Me(G){return{...m.from(G.location.range),message:G.message,resource:G.location.uri}}Se.from=Me;function de(G){return new s.$6K(new s.$5K(G.resource,m.to(G)),G.message)}Se.to=de})(k||(e.DiagnosticRelatedInformation=k={}));var N;(function(Se){function Me(G){switch(G){case s.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}Se.from=Me;function de(G){switch(G){case o.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Se.to=de})(N||(e.DiagnosticSeverity=N={}));var O;(function(Se){function Me(G){return typeof G=="number"&&G>=s.ViewColumn.One?G-1:G===s.ViewColumn.Beside?i.$1C:i.$ZC}Se.from=Me;function de(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=de})(O||(e.ViewColumn=O={}));function K(Se){return typeof Se.range<"u"}function j(Se){return Se.length===0?!0:!!K(Se[0])}e.$RM=j;var W;(function(Se){function Me(Ve){return Ve.map(Se.from)}Se.fromMany=Me;function de(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function G(Ve){let _e;if(de(Ve)){const{language:Dt,value:wt}=Ve;_e={value:"```"+Dt+`
`+wt+"\n```\n"}}else s.$hL.isMarkdownString(Ve)?_e={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?_e={value:Ve}:_e={value:""};const mt=Object.create(null);_e.uris=mt;const Ut=Dt=>{try{let wt=p.URI.parse(Dt,!0);wt=wt.with({query:Le(wt.query,mt)}),mt[Dt]=wt}catch{}return""},Et=new g.marked.Renderer;return Et.link=Ut,Et.image=Dt=>typeof Dt=="string"?Ut(R.$mk(Dt).href):"",(0,g.marked)(_e.value,{renderer:Et}),_e}Se.from=G;function Le(Ve,_e){if(!Ve)return Ve;let mt;try{mt=(0,w.$yh)(Ve)}catch{}if(!mt)return Ve;let Ut=!1;return mt=(0,D.$ln)(mt,Et=>{if(p.URI.isUri(Et)){const Dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return _e[Dt]=Et,Ut=!0,Dt}else return}),Ut?JSON.stringify(mt):Ve}function Ue(Ve){const _e=new s.$hL(Ve.value,Ve.supportThemeIcons);return _e.isTrusted=Ve.isTrusted,_e.supportHtml=Ve.supportHtml,_e.baseUri=Ve.baseUri?p.URI.from(Ve.baseUri):void 0,_e}Se.to=Ue;function Ze(Ve){if(Ve)return typeof Ve=="string"?Ve:Se.from(Ve)}Se.fromStrict=Ze})(W||(e.MarkdownString=W={}));function P(Se){return j(Se)?Se.map(Me=>({range:m.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?W.fromMany(Me.hoverMessage):Me.hoverMessage?W.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Se.map(Me=>({range:m.from(Me)}))}e.$SM=P;function C(Se){return typeof Se>"u"?Se:typeof Se=="string"?p.URI.file(Se):Se}e.$TM=C;var J;(function(Se){function Me(de){return typeof de>"u"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?C(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}Se.from=Me})(J||(e.ThemableDecorationAttachmentRenderOptions=J={}));var ae;(function(Se){function Me(de){return typeof de>"u"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?C(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?J.from(de.before):void 0,after:de.after?J.from(de.after):void 0}}Se.from=Me})(ae||(e.ThemableDecorationRenderOptions=ae={}));var fe;(function(Se){function Me(de){if(typeof de>"u")return de;switch(de){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Me})(fe||(e.DecorationRangeBehavior=fe={}));var be;(function(Se){function Me(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?fe.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?ae.from(de.light):void 0,dark:de.dark?ae.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?C(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?J.from(de.before):void 0,after:de.after?J.from(de.after):void 0}}Se.from=Me})(be||(e.DecorationRenderOptions=be={}));var ye;(function(Se){function Me(G){return{text:G.newText,eol:G.newEol&&tt.from(G.newEol),range:m.from(G.range)}}Se.from=Me;function de(G){const Le=new s.$ZK(m.to(G.range),G.text);return Le.newEol=typeof G.eol>"u"?void 0:tt.to(G.eol),Le}Se.to=de})(ye||(e.TextEdit=ye={}));var he;(function(Se){function Me(G,Le){const Ue={edits:[]};if(G instanceof s.$3K){const Ze=new $.$Bc;for(const Ve of G._allEntries())Ve._type===1&&p.URI.isUri(Ve.to)&&Ve.from===void 0&&Ze.add(Ve.to);for(const Ve of G._allEntries())if(Ve._type===1){let _e;Ve.options?.contents&&(ArrayBuffer.isView(Ve.options.contents)?_e={type:"base64",value:(0,T.$Ae)(T.$ge.wrap(Ve.options.contents))}:_e={type:"dataTransferItem",id:Ve.options.contents._itemId}),Ue.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contents:_e},metadata:Ve.metadata})}else Ve._type===2?Ue.edits.push({resource:Ve.uri,textEdit:ye.from(Ve.edit),versionId:Ze.has(Ve.uri)?void 0:Le?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?Ue.edits.push({resource:Ve.uri,textEdit:{range:m.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Ze.has(Ve.uri)?void 0:Le?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?Ue.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Le?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&Ue.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Le?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(Pt.from)}})}return Ue}Se.from=Me;function de(G){const Le=new s.$3K,Ue=new $.$Ac;for(const Ze of G.edits)if(Ze.textEdit){const Ve=Ze,_e=p.URI.revive(Ve.resource),mt=m.to(Ve.textEdit.range),Ut=Ve.textEdit.text,Et=Ve.textEdit.insertAsSnippet;let Dt;Et?Dt=s.$2K.replace(mt,new s.$4K(Ut)):Dt=s.$ZK.replace(mt,Ut);const wt=Ue.get(_e);wt?wt.push(Dt):Ue.set(_e,[Dt])}else Le.renameFile(p.URI.revive(Ze.oldResource),p.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Ve]of Ue)Le.set(Ze,Ve);return Le}Se.to=de})(he||(e.WorkspaceEdit=he={}));var ve;(function(Se){const Me=Object.create(null);Me[s.SymbolKind.File]=0,Me[s.SymbolKind.Module]=1,Me[s.SymbolKind.Namespace]=2,Me[s.SymbolKind.Package]=3,Me[s.SymbolKind.Class]=4,Me[s.SymbolKind.Method]=5,Me[s.SymbolKind.Property]=6,Me[s.SymbolKind.Field]=7,Me[s.SymbolKind.Constructor]=8,Me[s.SymbolKind.Enum]=9,Me[s.SymbolKind.Interface]=10,Me[s.SymbolKind.Function]=11,Me[s.SymbolKind.Variable]=12,Me[s.SymbolKind.Constant]=13,Me[s.SymbolKind.String]=14,Me[s.SymbolKind.Number]=15,Me[s.SymbolKind.Boolean]=16,Me[s.SymbolKind.Array]=17,Me[s.SymbolKind.Object]=18,Me[s.SymbolKind.Key]=19,Me[s.SymbolKind.Null]=20,Me[s.SymbolKind.EnumMember]=21,Me[s.SymbolKind.Struct]=22,Me[s.SymbolKind.Event]=23,Me[s.SymbolKind.Operator]=24,Me[s.SymbolKind.TypeParameter]=25;function de(Le){return typeof Me[Le]=="number"?Me[Le]:6}Se.from=de;function G(Le){for(const Ue in Me)if(Me[Ue]===Le)return Number(Ue);return s.SymbolKind.Property}Se.to=G})(ve||(e.SymbolKind=ve={}));var ee;(function(Se){function Me(G){switch(G){case s.SymbolTag.Deprecated:return 1}}Se.from=Me;function de(G){switch(G){case 1:return s.SymbolTag.Deprecated}}Se.to=de})(ee||(e.SymbolTag=ee={}));var ke;(function(Se){function Me(G){return{name:G.name,kind:ve.from(G.kind),tags:G.tags&&G.tags.map(ee.from),containerName:G.containerName,location:Ie.from(G.location)}}Se.from=Me;function de(G){const Le=new s.$$K(G.name,ve.to(G.kind),G.containerName,Ie.to(G.location));return Le.tags=G.tags&&G.tags.map(ee.to),Le}Se.to=de})(ke||(e.WorkspaceSymbol=ke={}));var se;(function(Se){function Me(G){const Le={name:G.name||"!!MISSING: name!!",detail:G.detail,range:m.from(G.range),selectionRange:m.from(G.selectionRange),kind:ve.from(G.kind),tags:G.tags?.map(ee.from)??[]};return G.children&&(Le.children=G.children.map(Me)),Le}Se.from=Me;function de(G){const Le=new s.$_K(G.name,G.detail,ve.to(G.kind),m.to(G.range),m.to(G.selectionRange));return(0,E.$Lb)(G.tags)&&(Le.tags=G.tags.map(ee.to)),G.children&&(Le.children=G.children.map(de)),Le}Se.to=de})(se||(e.DocumentSymbol=se={}));var _;(function(Se){function Me(G){const Le=new s.$dL(ve.to(G.kind),G.name,G.detail||"",p.URI.revive(G.uri),m.to(G.range),m.to(G.selectionRange));return Le._sessionId=G._sessionId,Le._itemId=G._itemId,Le}Se.to=Me;function de(G,Le,Ue){if(Le=Le??G._sessionId,Ue=Ue??G._itemId,Le===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Ue,name:G.name,detail:G.detail,kind:ve.from(G.kind),uri:G.uri,range:m.from(G.range),selectionRange:m.from(G.selectionRange),tags:G.tags?.map(ee.from)}}Se.from=de})(_||(e.CallHierarchyItem=_={}));var V;(function(Se){function Me(de){return new s.$eL(_.to(de.from),de.fromRanges.map(G=>m.to(G)))}Se.to=Me})(V||(e.CallHierarchyIncomingCall=V={}));var ne;(function(Se){function Me(de){return new s.$fL(_.to(de.to),de.fromRanges.map(G=>m.to(G)))}Se.to=Me})(ne||(e.CallHierarchyOutgoingCall=ne={}));var Ie;(function(Se){function Me(G){return{range:G.range&&m.from(G.range),uri:G.uri}}Se.from=Me;function de(G){return new s.$5K(p.URI.revive(G.uri),m.to(G.range))}Se.to=de})(Ie||(e.location=Ie={}));var Ae;(function(Se){function Me(G){const Le=G,Ue=G;return{originSelectionRange:Le.originSelectionRange?m.from(Le.originSelectionRange):void 0,uri:Le.targetUri?Le.targetUri:Ue.uri,range:m.from(Le.targetRange?Le.targetRange:Ue.range),targetSelectionRange:Le.targetSelectionRange?m.from(Le.targetSelectionRange):void 0}}Se.from=Me;function de(G){return{targetUri:p.URI.revive(G.uri),targetRange:m.to(G.range),targetSelectionRange:G.targetSelectionRange?m.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?m.to(G.originSelectionRange):void 0}}Se.to=de})(Ae||(e.DefinitionLink=Ae={}));var Pe;(function(Se){function Me(G){return{range:m.from(G.range),contents:W.fromMany(G.contents)}}Se.from=Me;function de(G){return new s.$8K(G.contents.map(W.to),m.to(G.range))}Se.to=de})(Pe||(e.Hover=Pe={}));var ce;(function(Se){function Me(G){return{range:m.from(G.range),expression:G.expression}}Se.from=Me;function de(G){return new s.$2L(m.to(G.range),G.expression)}Se.to=de})(ce||(e.EvaluatableExpression=ce={}));var ie;(function(Se){function Me(G){if(G instanceof s.$3L)return{type:"text",range:m.from(G.range),text:G.text};if(G instanceof s.$4L)return{type:"variable",range:m.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof s.$5L)return{type:"expression",range:m.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Me;function de(G){switch(G.type){case"text":return{range:m.to(G.range),text:G.text};case"variable":return{range:m.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:m.to(G.range),expression:G.expression}}}Se.to=de})(ie||(e.InlineValue=ie={}));var Q;(function(Se){function Me(G){return{frameId:G.frameId,stoppedLocation:m.from(G.stoppedLocation)}}Se.from=Me;function de(G){return new s.$6L(G.frameId,m.to(G.stoppedLocation))}Se.to=de})(Q||(e.InlineValueContext=Q={}));var te;(function(Se){function Me(G){return{range:m.from(G.range),kind:G.kind}}Se.from=Me;function de(G){return new s.$9K(m.to(G.range),G.kind)}Se.to=de})(te||(e.DocumentHighlight=te={}));var me;(function(Se){function Me(G){return{uri:G.uri,highlights:G.highlights.map(te.from)}}Se.from=Me;function de(G){return new s.$0K(p.URI.revive(G.uri),G.highlights.map(te.to))}Se.to=de})(me||(e.MultiDocumentHighlight=me={}));var pe;(function(Se){function Me(de){switch(de){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Se.to=Me})(pe||(e.CompletionTriggerKind=pe={}));var Fe;(function(Se){function Me(de){return{triggerKind:pe.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}Se.to=Me})(Fe||(e.CompletionContext=Fe={}));var le;(function(Se){function Me(G){switch(G){case s.CompletionItemTag.Deprecated:return 1}}Se.from=Me;function de(G){switch(G){case 1:return s.CompletionItemTag.Deprecated}}Se.to=de})(le||(e.CompletionItemTag=le={}));var we;(function(Se){const Me=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function de(Ue){return Me.get(Ue)??9}Se.from=de;const G=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Le(Ue){return G.get(Ue)??s.CompletionItemKind.Property}Se.to=Le})(we||(e.CompletionItemKind=we={}));var M;(function(Se){function Me(de,G){const Le=new s.$nL(de.label);return Le.insertText=de.insertText,Le.kind=we.to(de.kind),Le.tags=de.tags?.map(le.to),Le.detail=de.detail,Le.documentation=R.$gk(de.documentation)?W.to(de.documentation):de.documentation,Le.sortText=de.sortText,Le.filterText=de.filterText,Le.preselect=de.preselect,Le.commitCharacters=de.commitCharacters,b.$Is.isIRange(de.range)?Le.range=m.to(de.range):typeof de.range=="object"&&(Le.range={inserting:m.to(de.range.insert),replacing:m.to(de.range.replace)}),Le.keepWhitespace=typeof de.insertTextRules>"u"?!1:!!(de.insertTextRules&1),typeof de.insertTextRules<"u"&&de.insertTextRules&4?Le.insertText=new s.$4K(de.insertText):(Le.insertText=de.insertText,Le.textEdit=Le.range instanceof s.$UK?new s.$ZK(Le.range,Le.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Le.additionalTextEdits=de.additionalTextEdits.map(Ue=>ye.to(Ue))),Le.command=G&&de.command?G.fromInternal(de.command):void 0,Le}Se.to=Me})(M||(e.CompletionItem=M={}));var q;(function(Se){function Me(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:W.fromStrict(G.documentation)}}Se.from=Me;function de(G){return{label:G.label,documentation:R.$gk(G.documentation)?W.to(G.documentation):G.documentation}}Se.to=de})(q||(e.ParameterInformation=q={}));var H;(function(Se){function Me(G){return{label:G.label,documentation:W.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(q.from):[],activeParameter:G.activeParameter}}Se.from=Me;function de(G){return{label:G.label,documentation:R.$gk(G.documentation)?W.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(q.to):[],activeParameter:G.activeParameter}}Se.to=de})(H||(e.SignatureInformation=H={}));var U;(function(Se){function Me(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(H.from):[]}}Se.from=Me;function de(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(H.to):[]}}Se.to=de})(U||(e.SignatureHelp=U={}));var Z;(function(Se){function Me(de,G){const Le=new s.$mL(S.to(G.position),typeof G.label=="string"?G.label:G.label.map(Y.to.bind(void 0,de)),G.kind&&Ee.to(G.kind));return Le.textEdits=G.textEdits&&G.textEdits.map(ye.to),Le.tooltip=R.$gk(G.tooltip)?W.to(G.tooltip):G.tooltip,Le.paddingLeft=G.paddingLeft,Le.paddingRight=G.paddingRight,Le}Se.to=Me})(Z||(e.InlayHint=Z={}));var Y;(function(Se){function Me(de,G){const Le=new s.$lL(G.label);return Le.tooltip=R.$gk(G.tooltip)?W.to(G.tooltip):G.tooltip,r.Command.is(G.command)&&(Le.command=de.fromInternal(G.command)),G.location&&(Le.location=Ie.to(G.location)),Le}Se.to=Me})(Y||(e.InlayHintLabelPart=Y={}));var Ee;(function(Se){function Me(G){return G}Se.from=Me;function de(G){return G}Se.to=de})(Ee||(e.InlayHintKind=Ee={}));var Te;(function(Se){function Me(G){return{range:m.from(G.range),url:G.target,tooltip:G.tooltip}}Se.from=Me;function de(G){let Le;if(G.url)try{Le=typeof G.url=="string"?p.URI.parse(G.url,!0):p.URI.revive(G.url)}catch{}return new s.$sL(m.to(G.range),Le)}Se.to=de})(Te||(e.DocumentLink=Te={}));var We;(function(Se){function Me(G){const Le=new s.$vL(G.label);return G.textEdit&&(Le.textEdit=ye.to(G.textEdit)),G.additionalTextEdits&&(Le.additionalTextEdits=G.additionalTextEdits.map(Ue=>ye.to(Ue))),Le}Se.to=Me;function de(G){return{label:G.label,textEdit:G.textEdit?ye.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Le=>ye.from(Le)):void 0}}Se.from=de})(We||(e.ColorPresentation=We={}));var He;(function(Se){function Me(G){return new s.$tL(G[0],G[1],G[2],G[3])}Se.to=Me;function de(G){return[G.red,G.green,G.blue,G.alpha]}Se.from=de})(He||(e.Color=He={}));var Xe;(function(Se){function Me(G){return{range:m.from(G.range)}}Se.from=Me;function de(G){return new s.$cL(m.to(G.range))}Se.to=de})(Xe||(e.SelectionRange=Xe={}));var st;(function(Se){function Me(de){switch(de){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Se.to=Me})(st||(e.TextDocumentSaveReason=st={}));var nt;(function(Se){function Me(G){switch(G){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Me;function de(G){switch(G){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Se.to=de})(nt||(e.TextEditorLineNumbersStyle=nt={}));var tt;(function(Se){function Me(G){if(G===s.EndOfLine.CRLF)return 1;if(G===s.EndOfLine.LF)return 0}Se.from=Me;function de(G){if(G===1)return s.EndOfLine.CRLF;if(G===0)return s.EndOfLine.LF}Se.to=de})(tt||(e.EndOfLine=tt={}));var at;(function(Se){function Me(de){if(typeof de=="object")return de.viewId;switch(de){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Me})(at||(e.ProgressLocation=at={}));var ct;(function(Se){function Me(G){const Le={start:G.start+1,end:G.end+1};return G.kind&&(Le.kind=ze.from(G.kind)),Le}Se.from=Me;function de(G){const Le={start:G.start-1,end:G.end-1};return G.kind&&(Le.kind=ze.to(G.kind)),Le}Se.to=de})(ct||(e.FoldingRange=ct={}));var ze;(function(Se){function Me(G){if(G)switch(G){case s.FoldingRangeKind.Comment:return r.$yt.Comment;case s.FoldingRangeKind.Imports:return r.$yt.Imports;case s.FoldingRangeKind.Region:return r.$yt.Region}}Se.from=Me;function de(G){if(G)switch(G.value){case r.$yt.Comment.value:return s.FoldingRangeKind.Comment;case r.$yt.Imports.value:return s.FoldingRangeKind.Imports;case r.$yt.Region.value:return s.FoldingRangeKind.Region}}Se.to=de})(ze||(e.FoldingRangeKind=ze={}));var vt;(function(Se){function Me(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?m.from(de.selection):void 0,override:typeof de.override=="boolean"?n.$qE.id:void 0}}Se.from=Me})(vt||(e.TextEditorOpenOptions=vt={}));var X;(function(Se){function Me(Ue){return Ue instanceof s.$PL?Ue.toJSON():typeof Ue=="string"?Ue:de(Ue)||G(Ue)?new s.$PL(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}Se.from=Me;function de(Ue){const Ze=Ue;return Ze?p.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function G(Ue){const Ze=Ue;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Le(Ue){return typeof Ue=="string"?Ue:new s.$PL(p.URI.revive(Ue.baseUri),Ue.pattern)}Se.to=Le})(X||(e.GlobPattern=X={}));var x;(function(Se){function Me(de){if(de){if(Array.isArray(de))return de.map(Me);if(typeof de=="string")return de;{const G=de;return{language:G.language,scheme:G.scheme,pattern:X.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}Se.from=Me})(x||(e.LanguageSelector=x={}));var $e;(function(Se){function Me(G){return!!G&&typeof G=="object"&&"documents"in G&&Array.isArray(G.documents)&&G.documents.every(Le=>Array.isArray(Le)&&Le.every(Ue=>Ue&&typeof Ue=="object"&&"uri"in Ue&&p.URI.isUri(Ue.uri)&&"version"in Ue&&typeof Ue.version=="number"&&"ranges"in Ue&&Array.isArray(Ue.ranges)&&Ue.ranges.every(Ze=>Ze instanceof s.$UK)))}Se.is=Me;function de(G){return{documents:G.documents.map(Le=>Le.map(Ue=>({uri:p.URI.from(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Ze=>m.from(Ze))})))}}Se.from=de})($e||(e.MappedEditsContext=$e={}));var Be;(function(Se){function Me(G){return{start:G.start,end:G.end}}Se.from=Me;function de(G){return new s.$eM(G.start,G.end)}Se.to=de})(Be||(e.NotebookRange=Be={}));var Qe;(function(Se){function Me(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}Se.to=Me;function de(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}Se.from=de})(Qe||(e.NotebookCellExecutionSummary=Qe={}));var it;(function(Se){function Me(de){if(de===a.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(de===a.NotebookCellExecutionState.Pending)return;if(de===a.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${de}`)}Se.to=Me})(it||(e.NotebookCellExecutionState=it={}));var rt;(function(Se){function Me(G){switch(G){case s.NotebookCellKind.Markup:return a.CellKind.Markup;case s.NotebookCellKind.Code:default:return a.CellKind.Code}}Se.from=Me;function de(G){switch(G){case a.CellKind.Markup:return s.NotebookCellKind.Markup;case a.CellKind.Code:default:return s.NotebookCellKind.Code}}Se.to=de})(rt||(e.NotebookCellKind=rt={}));var Ne;(function(Se){function Me(G){const Le={metadata:G.metadata??Object.create(null),cells:[]};for(const Ue of G.cells)s.$fM.validate(Ue),Le.cells.push(Pt.from(Ue));return Le}Se.from=Me;function de(G){const Le=new s.$gM(G.cells.map(Pt.to));return(0,l.$Sf)(G.metadata)||(Le.metadata=G.metadata),Le}Se.to=de})(Ne||(e.NotebookData=Ne={}));var Pt;(function(Se){function Me(G){return{cellKind:rt.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:Qe.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Ht.from):[]}}Se.from=Me;function de(G){return new s.$fM(rt.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Ht.to):void 0,G.metadata,G.internalMetadata?Qe.to(G.internalMetadata):void 0)}Se.to=de})(Pt||(e.NotebookCellData=Pt={}));var Tt;(function(Se){function Me(G){return{mime:G.mime,valueBytes:T.$ge.wrap(G.data)}}Se.from=Me;function de(G){return new s.$hM(G.valueBytes.buffer,G.mime)}Se.to=de})(Tt||(e.NotebookCellOutputItem=Tt={}));var Ht;(function(Se){function Me(G){return{outputId:G.id,items:G.items.map(Tt.from),metadata:G.metadata}}Se.from=Me;function de(G){const Le=G.items.map(Tt.to);return new s.$iM(Le,G.outputId,G.metadata)}Se.to=de})(Ht||(e.NotebookCellOutput=Ht={}));var Bt;(function(Se){function Me(Le){return G(Le)?{include:X.from(Le.include)??void 0,exclude:X.from(Le.exclude)??void 0}:X.from(Le)??void 0}Se.from=Me;function de(Le){return G(Le)?{include:X.to(Le.include),exclude:X.to(Le.exclude)}:X.to(Le)}Se.to=de;function G(Le){const Ue=Le;return Ue?!(0,l.$Of)(Ue.include)&&!(0,l.$Of)(Ue.exclude):!1}})(Bt||(e.NotebookExclusiveDocumentPattern=Bt={}));var yt;(function(Se){function Me(de,G,Le){const Ue=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Ue,Le),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}Se.from=Me})(yt||(e.NotebookStatusBarItem=yt={}));var Kt;(function(Se){function Me(de,G,Le){const Ue=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{command:G.toInternal(Ue,Le),label:de.label,description:de.description,detail:de.detail,documentation:de.documentation}}Se.from=Me})(Kt||(e.NotebookKernelSourceAction=Kt={}));var Nt;(function(Se){function Me(de){return{transientOutputs:de?.transientOutputs??!1,transientCellMetadata:de?.transientCellMetadata??{},transientDocumentMetadata:de?.transientDocumentMetadata??{},cellContentMetadata:de?.cellContentMetadata??{}}}Se.from=Me})(Nt||(e.NotebookDocumentContentOptions=Nt={}));var Zt;(function(Se){function Me(G){return{uri:G.uri,provides:G.provides}}Se.from=Me;function de(G){return new s.$kM(p.URI.revive(G.uri),G.provides)}Se.to=de})(Zt||(e.NotebookRendererScript=Zt={}));var jt;(function(Se){function Me(G){return{message:W.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,contextValue:G.contextValue,location:G.location&&{range:m.from(G.location.range),uri:G.location.uri}}}Se.from=Me;function de(G){const Le=new s.$qM(typeof G.message=="string"?G.message:W.to(G.message));return Le.actualOutput=G.actual,Le.expectedOutput=G.expected,Le.contextValue=G.contextValue,Le.location=G.location?Ie.to(G.location):void 0,Le}Se.to=de})(jt||(e.TestMessage=jt={}));var Rt;(function(Se){Se.namespace=h.$MJ,Se.denamespace=h.$NJ})(Rt||(e.TestTag=Rt={}));var Ye;(function(Se){function Me(G){const Le=(0,t.$QM)(G).controllerId;return{extId:c.$IJ.fromExtHostTestItem(G,Le).toString(),label:G.label,uri:p.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(Ue=>Rt.namespace(Le,Ue.id)),range:b.$Is.lift(m.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&W.fromStrict(G.error)||null}}Se.from=Me;function de(G){return{parent:void 0,error:void 0,id:c.$IJ.fromString(G.extId).localId,label:G.label,uri:p.URI.revive(G.uri),tags:(G.tags||[]).map(Le=>{const{tagId:Ue}=Rt.denamespace(Le);return new s.$rM(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:m.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}Se.toPlain=de})(Ye||(e.TestItem=Ye={})),function(Se){function Me(G){return{id:G.id}}Se.from=Me;function de(G){return new s.$rM(G.id)}Se.to=de}(Rt||(e.TestTag=Rt={}));var Gt;(function(Se){const Me=(G,Le)=>{const Ue=[];for(const[Ve,_e]of Le)c.$IJ.compare(_e.item.extId,Ve)===2&&(Le.delete(Ve),Ue.push(_e));const Ze={...Ye.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(_e=>_e.type===0).map(jt.to)})),children:Ue.map(Ve=>Me(Ve,Le))};for(const Ve of Ze.children)Ve.parent=Ze;return Ze};function de(G){const Le=[],Ue=new Map;for(const Ze of G.items){Ue.set(Ze.item.extId,Ze);const Ve=c.$IJ.root(Ze.item.extId);G.request.targets.some(_e=>_e.controllerId===Ve&&_e.testIds.includes(Ze.item.extId))&&Le.push(Ze)}return{completedAt:G.completedAt,results:Le.map(Ze=>Me(Ze,Ue))}}Se.to=de})(Gt||(e.TestResults=Gt={}));var Jt;(function(Se){function Me(Ue){return{covered:Ue.covered,total:Ue.total}}function de(Ue){return"line"in Ue?S.from(Ue):m.from(Ue)}function G(Ue){return"branches"in Ue?{count:Ue.executionCount,location:de(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&de(Ze.location)})):void 0}:{type:0,name:Ue.name,count:Ue.executionCount,location:de(Ue.location)}}Se.fromDetailed=G;function Le(Ue){return{uri:Ue.uri,statement:Me(Ue.statementCoverage),branch:Ue.branchCoverage&&Me(Ue.branchCoverage),function:Ue.functionCoverage&&Me(Ue.functionCoverage),details:Ue.detailedCoverage?.map(G)}}Se.fromFile=Le})(Jt||(e.TestCoverage=Jt={}));var lt;(function(Se){function Me(de){switch(de){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Se.to=Me})(lt||(e.CodeActionTriggerKind=lt={}));var $t;(function(Se){function Me(G){const Le=new s.$xM(ve.to(G.kind),G.name,G.detail||"",p.URI.revive(G.uri),m.to(G.range),m.to(G.selectionRange));return Le._sessionId=G._sessionId,Le._itemId=G._itemId,Le}Se.to=Me;function de(G,Le,Ue){if(Le=Le??G._sessionId,Ue=Ue??G._itemId,Le===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Ue,kind:ve.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:m.from(G.range),selectionRange:m.from(G.selectionRange),tags:G.tags?.map(ee.from)}}Se.from=de})($t||(e.TypeHierarchyItem=$t={}));var zt;(function(Se){function Me(de){if(de)return{value:de.value,tooltip:de.tooltip}}Se.from=Me})(zt||(e.ViewBadge=zt={}));var Wt;(function(Se){function Me(Ue,Ze,Ve){const _e=Ze.fileData;return _e?new s.$IL(new s.$JL(_e.name,p.URI.revive(_e.uri),_e.id,(0,F.$db)(()=>Ve(_e.id)))):Ue===A.$5r.uriList&&Ze.uriListData?new s.$HL(Le(Ze.uriListData)):new s.$HL(Ze.asString)}Se.to=Me;async function de(Ue,Ze){const Ve=await Ze.asString();if(Ue===A.$5r.uriList)return{asString:Ve,fileData:void 0,uriListData:G(Ve)};const _e=Ze.asFile();return{asString:Ve,fileData:_e?{name:_e.name,uri:_e.uri,id:_e._itemId??_e.id}:void 0}}Se.from=de;function G(Ue){return I.$ft.split(Ue).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return p.URI.parse(Ze)}catch{}return Ze})}function Le(Ue){return I.$ft.create(Ue.map(Ze=>typeof Ze=="string"?Ze:p.URI.revive(Ze)))}})(Wt||(e.DataTransferItem=Wt={}));var kt;(function(Se){function Me(G,Le){const Ue=G.items.map(([Ze,Ve])=>[Ze,Wt.to(Ze,Ve,Le)]);return new s.$KL(Ue)}Se.toDataTransfer=Me;async function de(G){const Le={items:[]},Ue=[];for(const[Ze,Ve]of G)Ue.push((async()=>{Le.items.push([Ze,await Wt.from(Ze,Ve)])})());return await Promise.all(Ue),Le}Se.from=de})(kt||(e.DataTransfer=kt={}));var dt;(function(Se){function Me(de){return{kind:"reply",message:de.message,title:de.title,tooltip:de.tooltip}}Se.from=Me})(dt||(e.ChatReplyFollowup=dt={}));var Ct;(function(Se){function Me(de){return typeof de=="string"?{title:de,message:de,kind:"reply"}:"commandId"in de?{kind:"command",title:de.title??"",commandId:de.commandId??"",when:de.when??"",args:de.args}:dt.from(de)}Se.from=Me})(Ct||(e.ChatFollowup=Ct={}));var xt;(function(Se){function Me(G){const Le=new s.$JM(St.to(G.role),G.content);return Le.name=G.name,Le}Se.to=Me;function de(G){return{role:St.from(G.role),content:G.content,name:G.name}}Se.from=de})(xt||(e.ChatMessage=xt={}));var St;(function(Se){function Me(G){switch(G){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Se.to=Me;function de(G){switch(G){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Se.from=de})(St||(e.ChatMessageRole=St={}));var qe;(function(Se){function Me(Le){const Ue={};for(const Ze of Object.keys(Le))Ue[Ze]=Le[Ze].map(Se.to);return Ue}Se.objectTo=Me;function de(Le){return{level:Ft.to(Le.level),kind:Le.kind,value:(0,w.$zh)(Le.value),description:Le.description}}Se.to=de;function G(Le){return{level:Ft.from(Le.level),kind:Le.kind,value:Le.value,description:Le.description}}Se.from=G})(qe||(e.ChatVariable=qe={}));var Ft;(function(Se){function Me(G){switch(G){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Se.to=Me;function de(G){switch(G){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Se.from=de})(Ft||(e.ChatVariableLevel=Ft={}));var Vt;(function(Se){function Me(de){switch(de){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Se.to=Me})(Vt||(e.InteractiveEditorResponseFeedbackKind=Vt={}));var Qt;(function(Se){function Me(de,G){return"placeholder"in G&&"resolvedContent"in G?{content:G.placeholder,kind:"asyncContent"}:"markdownContent"in G?((0,u.$pF)(de,"chatAgents2Additions"),{content:W.from(G.markdownContent),kind:"markdownContent"}):"content"in G?"vulnerabilities"in G&&G.vulnerabilities?((0,u.$pF)(de,"chatAgents2Additions"),{content:G.content,vulnerabilities:G.vulnerabilities,kind:"vulnerability"}):typeof G.content=="string"?{content:G.content,kind:"content"}:((0,u.$pF)(de,"chatAgents2Additions"),{content:W.from(G.content),kind:"markdownContent"}):"documents"in G?{documents:G.documents.map(Le=>({uri:Le.uri,version:Le.version,ranges:Le.ranges.map(Ue=>m.from(Ue))})),kind:"usedContext"}:"reference"in G?{reference:"uri"in G.reference?{uri:G.reference.uri,range:m.from(G.reference.range)}:G.reference,kind:"reference"}:"inlineReference"in G?{inlineReference:"uri"in G.inlineReference?{uri:G.inlineReference.uri,range:m.from(G.inlineReference.range)}:G.inlineReference,name:G.title,kind:"inlineReference"}:"agentName"in G?((0,u.$pF)(de,"chatAgents2Additions"),{agentName:G.agentName,command:G.command,kind:"agentDetection"}):"treeData"in G?{treeData:G.treeData,kind:"treeData"}:"message"in G?{content:G.message,kind:"progressMessage"}:void 0}Se.from=Me})(Qt||(e.ChatResponseProgress=Qt={}));var ft;(function(Se){function Me(de){return{label:de.label,values:de.values.map(qe.from),insertText:de.insertText,detail:de.detail,documentation:de.documentation}}Se.from=Me})(ft||(e.ChatAgentCompletionItem=ft={}));var Mt;(function(Se){function Me(de,G,Le){return"terminalCommand"in de?{terminalCommand:de.terminalCommand,shouldExecute:de.shouldExecute}:"uri"in de?{uri:de.uri}:G.toInternal(de,Le)}Se.from=Me})(Mt||(e.TerminalQuickFix=Mt={}))}),define(Ce[220],Re([1,0,2,15,7,8,186]),function(ge,e,E,T,I,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0;class ${constructor(w,A,D,l={timeout:1500,errors:3}){this.c=w,this.d=A,this.f=D,this.g=l,this.a=new R.$3c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(w){return(A,D,l)=>{const b={dispose:this.a.push([A,D,w])};return Array.isArray(l)&&l.push(b),b}}async $participateInSave(w,A){const D=E.URI.revive(w);let l=!1;const p=setTimeout(()=>l=!0,this.g.timeout),b=[];try{for(const r of[...this.a]){if(l)break;const o=this.d.getDocument(D),t=await this.h(r,{document:o,reason:F.TextDocumentSaveReason.to(A)});b.push(t)}}finally{clearTimeout(p)}return b}h([w,A,D],l){const p=this.b.get(w);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(D,w,A,l).then(()=>!0,b=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error(b),!(b instanceof Error)||b.message!=="concurrent_edits"){const r=this.b.get(w);this.b.set(w,r?r+1:1),typeof r=="number"&&r>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(w,A,D,l){const p=[],b=Date.now(),{document:r,reason:o}=l,{version:t}=r,n=Object.freeze({document:r,reason:o,waitUntil(a){if(Object.isFrozen(p))throw(0,T.$8)("waitUntil can not be called async");p.push(Promise.resolve(a))}});try{A.apply(D,[n])}catch(a){return Promise.reject(a)}return Object.freeze(p),new Promise((a,c)=>{const h=setTimeout(()=>c(new Error("timeout")),this.g.timeout);return Promise.all(p).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' finished after ${Date.now()-b}ms`),clearTimeout(h),a(i)}).catch(i=>{clearTimeout(h),c(i)})}).then(a=>{const c={edits:[]};for(const h of a)if(Array.isArray(h)&&h.every(i=>i instanceof I.$ZK))for(const{newText:i,newEol:s,range:u}of h)c.edits.push({resource:r.uri,versionId:void 0,textEdit:{range:u&&F.Range.from(u),text:i,eol:s&&F.EndOfLine.from(s)}});if(c.edits.length!==0)return t===r.version?this.f.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.$sgc=$}),define(Ce[221],Re([1,0,12,2,8,7,76]),function(ge,e,E,T,I,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ygc=e.$xgc=void 0;class ${constructor(D,l,p,b){this.start=D,this.deletedCount=l,this.deletedItems=p,this.items=b}asApiEvent(){return{range:new F.$eM(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class g{static asModelAddData(D,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,l,p){this.notebook=D,this.h=l,this.j=p,this.handle=p.handle,this.uri=T.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(I.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return D.g},set mime(b){D.g=b},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(p)}return this.f}setOutputs(D){this.a=D.map(I.NotebookCellOutput.to)}setOutputItems(D,l,p){const b=p.map(I.NotebookCellOutputItem.to),r=this.a.find(o=>o.id===D);if(r&&(l||(r.items.length=0),r.items.push(...b),r.items.length>1&&r.items.every(o=>R.$UI(o.mime)))){const o=new Map,t=[];r.items.forEach(n=>{let a;o.has(n.mime)?a=o.get(n.mime):(a=[],o.set(n.mime,a),t.push(n.mime)),a.push(n.data)}),r.items.length=0,t.forEach(n=>{const a=R.$VI(o.get(n));r.items.push({mime:n,data:a.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$xgc=g;class w{static{this.a=0}constructor(D,l,p,b,r){this.k=D,this.l=l,this.m=p,this.uri=b,this.handle=w.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,l={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===E.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(p){return p=D.n(p),D.b[p].apiCell},getCells(p){return(p?D.p(p):D.b).map(r=>r.apiCell)},save(){return D.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,l,p){this.g=D.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:p});const b={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},r=[];for(const t of D.rawEvents)t.kind===R.NotebookCellsChangeType.ModelChange?this.r(t.changes,!1,b.contentChanges):t.kind===R.NotebookCellsChangeType.Move?this.s(t.index,t.length,t.newIdx,b.contentChanges):t.kind===R.NotebookCellsChangeType.Output?(this.t(t.index,t.outputs),r.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===R.NotebookCellsChangeType.OutputItem?(this.u(t.index,t.outputId,t.append,t.outputItems),r.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(t.index,t.language),r.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document})):t.kind===R.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document}):t.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(t.index,t.mime):t.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(t.index,t.metadata),r.push({cell:this.b[t.index].apiCell,metadata:this.b[t.index].apiCell.metadata})):t.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(t.index,t.internalMetadata),r.push({cell:this.b[t.index].apiCell,executionSummary:this.b[t.index].apiCell.executionSummary}));const o=new Map;for(let t=0;t<r.length;t++){const n=r[t],a=o.get(n.cell);if(a===void 0){const c=b.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});o.set(n.cell,c-1)}else b.cellChanges[a]={...b.cellChanges[a],...n}}return Object.freeze(b),Object.freeze(b.cellChanges),Object.freeze(b.contentChanges),b}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let l=D.start|0,p=D.end|0;return l<0&&(l=0),p>this.b.length&&(p=this.b.length),D.with({start:l,end:p})}p(D){D=this.o(D);const l=[];for(let p=D.start;p<D.end;p++)l.push(this.b[p]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,l,p){if(this.j)return;const b=[],r=[],o=[];if(D.reverse().forEach(t=>{const a=t[2].map(i=>{const s=new g(this,this.l,i);return l||r.push(g.asModelAddData(this.apiNotebook,i)),s}),c=new $(t[0],t[1],[],a),h=this.b.splice(t[0],t[1],...a);for(const i of h)o.push(i.uri),c.deletedItems.push(i.apiCell);b.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:o}),p)for(const t of b)p.push(t.asApiEvent())}s(D,l,p,b){const r=this.b.splice(D,l);this.b.splice(p,0,...r);const o=[new $(D,l,r.map(t=>t.apiCell),[]),new $(p,0,[],r)];for(const t of o)b.push(t.asApiEvent())}t(D,l){this.b[D].setOutputs(l)}u(D,l,p,b){this.b[D].setOutputItems(l,p,b)}v(D,l){const p=this.b[D];p.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(p.uri,l)}w(D,l){const p=this.b[D];p.apiCell.mime=l}x(D,l){this.b[D].setMetadata(l)}y(D,l){this.b[D].setInternalMetadata(l)}getCellFromApiCell(D){return this.b.find(l=>l.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(l=>l.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$ygc=w}),define(Ce[222],Re([1,0,5,2,8,7]),function(ge,e,E,T,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=void 0;class R{constructor(g,w,A,D={timeout:1500,errors:3}){this.b=g,this.c=w,this.d=A,this.f=D,this.a=new E.$Ud}dispose(){}getOnWillSaveNotebookDocumentEvent(g){return(w,A,D)=>{const l=function(b){w.call(A,b)};return l.extension=g,this.a.event(l,void 0,D)}}async $participateInSave(g,w,A){const D=T.URI.revive(g),l=this.c.getNotebookDocument(D);if(!l)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:I.TextDocumentSaveReason.to(w)},A,async(r,o)=>{const t=Date.now(),n=await await Promise.resolve(r);Date.now()-t>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!A.isCancellationRequested&&n&&(n instanceof F.$3K?p.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(p.length===0)return!0;const b={edits:[]};for(const r of p){const{edits:o}=I.WorkspaceEdit.from(r);b.edits=b.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(b)}}e.$Ogc=R}),define(Ce[107],Re([1,0,15,8,7]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=void 0;class F{static{this.apiEditorsToExtHost=new WeakMap}constructor($,g,w,A,D,l){this.id=$,this.f=g,this.notebookData=w,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=A,this.c=l}get apiEditor(){if(!this.e){const $=this;this.e={get notebook(){return $.notebookData.apiNotebook},get selection(){return $.a[0]},set selection(g){this.selections=[g]},get selections(){return $.a},set selections(g){if(!Array.isArray(g)||!g.every(I.$eM.isNotebookRange))throw(0,E.$7)("selections");$.a=g,$.g(g)},get visibleRanges(){return $.b},revealRange(g,w){$.f.$tryRevealRange($.id,T.NotebookRange.from(g),w??I.NotebookEditorRevealType.Default)},get viewColumn(){return $.c}},F.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility($){this.d=$}_acceptVisibleRanges($){this.b=$}_acceptSelections($){this.a=$}g($){this.f.$trySetSelections(this.id,$.map(T.NotebookRange.from))}_acceptViewColumn($){this.c=$}}e.$zgc=F}),define(Ce[223],Re([1,0,5,14,8]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=void 0;let F=class{constructor($,g){this.c=$,this.d=g,this.a=new E.$Sd,this.b=new E.$Sd,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged($,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",$,g);const w=this.d.getEditorById($);g.visibleRanges&&w._acceptVisibleRanges(g.visibleRanges.ranges.map(I.NotebookRange.to)),g.selections&&w._acceptSelections(g.selections.selections.map(I.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:w.apiEditor,visibleRanges:w.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:w.apiEditor,selections:w.apiEditor.selections}))}$acceptEditorViewColumns($){for(const g in $)this.d.getEditorById(g)._acceptViewColumn(I.ViewColumn.to($[g]))}};e.$Qgc=F,e.$Qgc=F=Ge([Ke(0,T.$kj)],F)}),define(Ce[224],Re([1,0,8,72,163,20,66,15]),function(ge,e,E,T,I,F,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=void 0;class g{constructor(l){this.b=0,this.c=new Map,this.a=l}async withProgress(l,p,b){const r=this.b++,{title:o,location:t,cancellable:n}=p,a={label:(0,I.localize)(0,null,l.displayName||l.name),id:l.identifier.value};return this.a.$startProgress(r,{location:E.ProgressLocation.from(t),title:o,source:a,cancellable:n},l.isUnderDevelopment?void 0:l.identifier.value).catch($.$2),this.d(r,b,!!n)}d(l,p,b){let r;b&&(r=new F.$3d,this.c.set(l,r));const o=n=>{this.a.$progressEnd(n),this.c.delete(n),r?.dispose()};let t;try{t=p(new A(this.a,l),b&&r?r.token:F.CancellationToken.None)}catch(n){throw o(l),n}return t.then(n=>o(l),n=>o(l)),t}$acceptProgressCanceled(l){const p=this.c.get(l);p&&(p.cancel(),this.c.delete(l))}}e.$Xgc=g;function w(D,l){return D.message=l.message,typeof l.increment=="number"&&(typeof D.increment=="number"?D.increment+=l.increment:D.increment=l.increment),D}class A extends T.$iv{constructor(l,p){super(b=>this.throttledReport(b)),this.c=l,this.d=p}throttledReport(l){this.c.$progressReport(this.d,l)}}Ge([(0,R.$wh)(100,(D,l)=>w(D,l),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(Ce[108],Re([1,0,29,104,48,77,58,8,2]),function(ge,e,E,T,I,F,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0M=e.$9M=e.$8M=e.$7M=void 0;const w=(a,c,h,i)=>{let s=c;return{enumerable:!0,configurable:!1,get(){return s},set(u){if(!h(s,u)){const d=s;s=u,a.listener?.(i(u,d))}}}},A=(a,c)=>a===c,D={range:(a,c)=>a===c?!0:!a||!c?!1:a.isEqual(c),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(a,c)=>!(a.length!==c.length||a.some(h=>!c.find(i=>h.id===i.id)))},l=a=>c=>({op:4,update:a(c)}),p=(a,c)=>({range:(()=>{let h;const i=l(s=>({range:E.$Is.lift($.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return h},set(s){a.listener?.({op:6}),D.range(h,s)||(h=s,a.listener?.(i(s)))}}})(),label:w(a,c,D.label,l(h=>({label:h}))),description:w(a,void 0,D.description,l(h=>({description:h}))),sortText:w(a,void 0,D.sortText,l(h=>({sortText:h}))),canResolveChildren:w(a,!1,D.canResolveChildren,h=>({op:2,state:h})),busy:w(a,!1,D.busy,l(h=>({busy:h}))),error:w(a,void 0,D.error,l(h=>({error:$.MarkdownString.fromStrict(h)||null}))),tags:w(a,[],D.tags,(h,i)=>({op:1,new:h.map($.TestTag.from),old:i.map($.TestTag.from)}))}),b=a=>{const c=I.$IJ.fromString(a.extId),h=new o(c.controllerId,c.localId,a.label,g.URI.revive(a.uri)||void 0);return h.range=$.Range.to(a.range||void 0),h.description=a.description||void 0,h.sortText=a.sortText||void 0,h.tags=a.tags.map(i=>$.TestTag.to({id:(0,R.$NJ)(i).tagId})),h},r=a=>{let c;for(const h of a.tests){const i=b(h.item);(0,T.$QM)(i).parent=c,c=i}return c};e.$7M=r;class o{constructor(c,h,i,s){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const u=(0,T.$PM)(this,c);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return u.parent instanceof t?void 0:u.parent}},children:{value:(0,F.$OM)(u,T.$QM,o),enumerable:!0,writable:!1},...p(u,i)})}}e.$8M=o;class t extends o{constructor(c,h){super(c,c,h,void 0),this._isRoot=!0}}e.$9M=t;class n extends F.$KM{constructor(c,h,i){super({controllerId:c,getDocumentVersion:s=>s&&i.getDocument(s)?.version,getApiFor:T.$QM,getChildren:s=>s.children,root:new t(c,h),toITestItem:$.TestItem.from})}}e.$0M=n}),define(Ce[109],Re([1,0,53,15,89,8,7]),function(ge,e,E,T,I,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=e.$3M=e.$2M=void 0;class ${static{this.c=new I.$ZM("TextEditorDecorationType")}constructor(l,p,b){const r=$.c.nextId();l.$registerTextEditorDecorationType(p.identifier,r,F.DecorationRenderOptions.from(b)),this.value=Object.freeze({key:r,dispose(){l.$removeTextEditorDecorationType(r)}})}}e.$2M=$;class g{constructor(l,p){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,p){this.k();let b=null;if(l instanceof R.$TK)b=new R.$UK(l,l);else if(l instanceof R.$UK)b=l;else throw new Error("Unrecognized location");this.l(b,p,!1)}insert(l,p){this.k(),this.l(new R.$UK(l,l),p,!0)}delete(l){this.k();let p=null;if(l instanceof R.$UK)p=l;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(l,p,b){const r=this.c.validateRange(l);this.g.push({range:r,text:p,forceMoveMarkers:b})}setEndOfLine(l){if(this.k(),l!==R.EndOfLine.LF&&l!==R.EndOfLine.CRLF)throw(0,T.$7)("endOfLine");this.h=l}}class w{constructor(l,p,b,r){this.c=l,this.d=p,this._accept(b),this.e=r;const o=this;this.value={get tabSize(){return o.f},set tabSize(t){o.n(t)},get indentSize(){return o.g},set indentSize(t){o.p(t)},get insertSpaces(){return o.j},set insertSpaces(t){o.s(t)},get cursorStyle(){return o.k},set cursorStyle(t){o.t(t)},get lineNumbers(){return o.l},set lineNumbers(t){o.u(t)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=F.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const p=Math.floor(l);return p>0?p:null}if(typeof l=="string"){const p=parseInt(l,10);return isNaN(p)?null:p>0?p:null}return null}n(l){const p=this.m(l);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const p=Math.floor(l);return p>0?p:null}if(typeof l=="string"){const p=parseInt(l,10);return isNaN(p)?null:p>0?p:null}return null}p(l){const p=this.o(l);if(p!==null){if(typeof p=="number"){if(this.h===p)return;this.g=p,this.h=p}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const p=this.q(l);if(typeof p=="boolean"){if(this.j===p)return;this.j=p}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:F.TextEditorLineNumbersStyle.from(l)})))}assign(l){const p={};let b=!1;if(typeof l.tabSize<"u"){const r=this.m(l.tabSize);r==="auto"?(b=!0,p.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,b=!0,p.tabSize=r)}if(typeof l.indentSize<"u"){const r=this.o(l.indentSize);r==="tabSize"?(b=!0,p.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,b=!0,p.indentSize=r)}if(typeof l.insertSpaces<"u"){const r=this.q(l.insertSpaces);r==="auto"?(b=!0,p.insertSpaces=r):this.j!==r&&(this.j=r,b=!0,p.insertSpaces=r)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,b=!0,p.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,b=!0,p.lineNumbers=F.TextEditorLineNumbersStyle.from(l.lineNumbers)),b&&this.v("setOptions",this.c.$trySetOptions(this.d,p))}v(l,p){p.catch(b=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(b)})}}e.$3M=w;class A{constructor(l,p,b,r,o,t,n,a){this.id=l,this.j=p,this.k=b,this.g=!1,this.h=new Set,this.c=o,this.d=new w(this.j,this.id,t,b),this.e=n,this.f=a;const c=this;this.value=Object.freeze({get document(){return r.value},set document(h){throw new T.$9("document")},get selection(){return c.c&&c.c[0]},set selection(h){if(!(h instanceof R.$VK))throw(0,T.$7)("selection");c.c=[h],c.l()},get selections(){return c.c},set selections(h){if(!Array.isArray(h)||h.some(i=>!(i instanceof R.$VK)))throw(0,T.$7)("selections");c.c=h,c.l()},get visibleRanges(){return c.e},set visibleRanges(h){throw new T.$9("visibleRanges")},get options(){return c.d.value},set options(h){c.g||c.d.assign(h)},get viewColumn(){return c.f},set viewColumn(h){throw new T.$9("viewColumn")},edit(h,i={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new g(r.value,i);return h(s),c.m(s)},insertSnippet(h,i,s={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!i||Array.isArray(i)&&i.length===0)u=c.c.map(d=>F.Range.from(d));else if(i instanceof R.$TK){const{lineNumber:d,column:m}=F.Position.from(i);u=[{startLineNumber:d,startColumn:m,endLineNumber:d,endColumn:m}]}else if(i instanceof R.$UK)u=[F.Range.from(i)];else{u=[];for(const d of i)if(d instanceof R.$UK)u.push(F.Range.from(d));else{const{lineNumber:m,column:f}=F.Position.from(d);u.push({startLineNumber:m,startColumn:f,endLineNumber:m,endColumn:f})}}return p.$tryInsertSnippet(l,r.value.version,h.value,u,s)},setDecorations(h,i){const s=i.length===0;s&&!c.h.has(h.key)||(s?c.h.delete(h.key):c.h.add(h.key),c.n(()=>{if(F.$RM(i))return p.$trySetDecorations(l,h.key,F.$SM(i));{const u=new Array(4*i.length);for(let d=0,m=i.length;d<m;d++){const f=i[d];u[4*d]=f.start.line+1,u[4*d+1]=f.start.character+1,u[4*d+2]=f.end.line+1,u[4*d+3]=f.end.character+1}return p.$trySetDecorationsFast(l,h.key,u)}}))},revealRange(h,i){c.n(()=>p.$tryRevealRange(l,F.Range.from(h),i||R.TextEditorRevealType.Default))},show(h){p.$tryShowEditor(l,F.ViewColumn.from(h))},hide(){p.$tryHideEditor(l)}})}dispose(){(0,E.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,E.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,E.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,E.ok)(!this.g),this.f=l}_acceptSelections(l){(0,E.ok)(!this.g),this.c=l}async l(){const l=this.c.map(F.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const p=l.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const b=p.edits.map(o=>o.range);b.sort((o,t)=>o.end.line===t.end.line?o.end.character===t.end.character?o.start.line===t.start.line?o.start.character-t.start.character:o.start.line-t.start.line:o.end.character-t.end.character:o.end.line-t.end.line);for(let o=0,t=b.length-1;o<t;o++){const n=b[o].end;if(b[o+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=p.edits.map(o=>({range:F.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,r,{setEndOfLine:typeof p.setEndOfLine=="number"?F.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.$4M=A}),define(Ce[225],Re([1,0,167,25,2,5,6,205,13,7,16,18,8,52,20,132,23]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l,p,b,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=void 0;function t(c,h){if((0,A.$Ff)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let i;return Array.isArray(c.highlights)&&(i=c.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),i=i.length?i:void 0),{label:c.label,highlights:i}}}class n extends R.$Sc{constructor(h,i,s){super(),this.f=h,this.g=i,this.h=s,this.a=new Map,this.b=new r.$a8;function u(d){return d&&d.$treeViewId&&(d.$treeItemHandle||d.$selectedTreeItems||d.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:d=>u(d)?this.r(d):Array.isArray(d)&&d.length>0?d.map(m=>u(m)?this.r(m):m):d})}registerTreeDataProvider(h,i,s){const u=this.createTreeView(h,{treeDataProvider:i},s);return{dispose:()=>u.dispose()}}createTreeView(h,i,s){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=i.dragAndDropController?.dropMimeTypes??[],d=i.dragAndDropController?.dragMimeTypes??[],m=!!i.dragAndDropController?.handleDrag,f=!!i.dragAndDropController?.handleDrop,S=this.m(h,i,s),L={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:u,dragMimeTypes:d,hasHandleDrag:m,hasHandleDrop:f,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},v=this.f.$registerTreeViewDataProvider(h,L),y={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,o.$pF)(s,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,o.$pF)(s,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(k){(0,p.$gk)(k)&&(0,o.$pF)(s,"treeViewMarkdownMessage"),S.message=k},get title(){return S.title},set title(k){S.title=k},get description(){return S.description},set description(k){S.description=k},get badge(){return S.badge},set badge(k){k!==void 0&&w.ViewBadge.isViewBadge(k)?S.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(S.badge=void 0)},reveal:(k,N)=>S.reveal(k,N),dispose:async()=>{await v,this.a.delete(h),S.dispose()}};return this.B(y),y}$getChildren(h,i){const s=this.a.get(h);return s?s.getChildren(i):Promise.reject(new $.$ZE(h))}async $handleDrop(h,i,s,u,d,m,f,S){const L=this.a.get(h);if(!L)return Promise.reject(new $.$ZE(h));const v=l.DataTransfer.toDataTransfer(s,async y=>(await this.f.$resolveDropFileData(h,i,y)).buffer);return f===h&&S&&await this.j(v,L,S,d,m),L.onDrop(v,u,d)}async j(h,i,s,u,d){const m=this.b.removeDragOperationTransfer(d);if(m)(await m)?.forEach((f,S)=>{f&&h.set(S,f)});else if(d&&i.handleDrag){const f=i.handleDrag(s,h,u);this.b.addDragOperationTransfer(d,f),await f}return h}async $handleDrag(h,i,s,u){const d=this.a.get(h);if(!d)return Promise.reject(new $.$ZE(h));const m=await this.j(new w.$KL,d,i,u,s);if(!(!m||u.isCancellationRequested))return l.DataTransfer.from(m)}async $hasResolve(h){const i=this.a.get(h);if(!i)throw new $.$ZE(h);return i.hasResolve}$resolve(h,i,s){const u=this.a.get(h);if(!u)throw new $.$ZE(h);return u.resolveTreeItem(i,s)}$setExpanded(h,i,s){const u=this.a.get(h);if(!u)throw new $.$ZE(h);u.setExpanded(i,s)}$setSelectionAndFocus(h,i,s){const u=this.a.get(h);if(!u)throw new $.$ZE(h);u.setSelectionAndFocus(i,s)}$setVisible(h,i){const s=this.a.get(h);if(!s){if(!i)return;throw new $.$ZE(h)}s.setVisible(i)}$changeCheckboxState(h,i){const s=this.a.get(h);if(!s)throw new $.$ZE(h);s.setCheckboxState(i)}m(h,i,s){const u=this.B(new a(h,i,this.f,this.g.converter,this.h,s));return this.a.set(h,u),u}r(h){const i=this.a.get(h.$treeViewId);return i&&"$treeItemHandle"in h?i.getExtensionElement(h.$treeItemHandle):i&&"$focusedTreeItem"in h&&h.$focusedTreeItem?i.focusedElement:null}}e.$ehc=n;class a extends R.$Sc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,A.$Of)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,i,s,u,d,m){if(super(),this.I=h,this.J=s,this.L=u,this.M=d,this.N=m,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new F.$Sd),this.onDidExpandElement=this.u.event,this.w=this.B(new F.$Sd),this.onDidCollapseElement=this.w.event,this.y=this.B(new F.$Sd),this.onDidChangeSelection=this.y.event,this.z=this.B(new F.$Sd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new F.$Sd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new F.$Sd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new F.$Sd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new b.$3d,m.contributes&&m.contributes.views)for(const v in m.contributes.views)for(const y of m.contributes.views[v])y.id===h&&(this.P=y.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(v=>this.F.fire({message:!1,element:v})));let f,S;const L=F.Event.debounce(this.F.event,(v,y)=>(v||(v={message:!1,elements:[]}),y.element!==!1&&(f||(f=new Promise(k=>S=k),this.G=this.G.then(()=>f)),Array.isArray(y.element)?v.elements.push(...y.element):v.elements.push(y.element)),y.message&&(v.message=!0),v),200,!0);this.B(L(({message:v,elements:y})=>{y.length&&(this.H=this.H.then(()=>{const k=S;return f=null,this.$(y).then(()=>k())})),v&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const i=h?this.getExtensionElement(h):void 0;if(h&&!i)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let s=this.X(h);return s||(s=await this.Y(i)),s?s.map(u=>u.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,i){i=i||{select:!0,focus:!1};const s=(0,A.$Of)(i.select)?!0:i.select,u=(0,A.$Of)(i.focus)?!1:i.focus,d=(0,A.$Of)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(m=>this.W(h,m[m.length-1]).then(f=>this.J.$reveal(this.I,{item:f.item,parentChain:m.map(S=>S.item)},{select:s,focus:u,expand:d})),m=>this.M.error(m)):this.J.$reveal(this.I,void 0,{select:s,focus:u,expand:d})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=l.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,i){const s=this.getExtensionElement(h);s&&(i?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(h,i){const s=!(0,D.$ub)(this.s,h);this.s=h;const u=this.t!==i;this.t=i,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),u&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const i=(await Promise.all(h.map(async s=>{const u=this.getExtensionElement(s.treeItemHandle);return u?{extensionItem:u,treeItem:await this.f.getTreeItem(u),newState:s.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);i.forEach(s=>{s.treeItem.checkboxState=s.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map(s=>[s.extensionItem,s.newState])})}async handleDrag(h,i,s){const u=[];for(const d of h){const m=this.getExtensionElement(d);m&&u.push(m)}if(!(!this.g?.handleDrag||u.length===0))return await this.g.handleDrag(u,i,s),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,i,s){const u=i?this.getExtensionElement(i):void 0;if(!(!u&&i||!this.g?.handleDrop))return(0,g.$Vg)(()=>this.g?.handleDrop?this.g.handleDrop(u,h,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,i){if(!this.f.resolveTreeItem)return;const s=this.j.get(h);if(s){const u=this.m.get(s);if(u){const d=await this.f.resolveTreeItem(u.extensionItem,s,i)??u.extensionItem;return this.hb(d),u.item.tooltip=this.eb(d.tooltip),u.item.command=this.fb(u.disposableStore,d.command),u.item}}}S(h){return this.U(h).then(i=>i?this.S(i).then(s=>this.W(i,s[s.length-1]).then(u=>(s.push(u),s))):Promise.resolve([]))}U(h){const i=this.m.get(h);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,g.$Vg)(()=>this.f.getParent(h))}W(h,i){const s=this.m.get(h);return s?Promise.resolve(s):(0,g.$Vg)(()=>this.f.getTreeItem(h)).then(u=>this.kb(h,u,i,!0)).then(u=>this.getChildren(i?i.item.handle:void 0).then(()=>{const d=this.getExtensionElement(u);if(d){const m=this.m.get(d);if(m)return Promise.resolve(m)}throw new Error(`Cannot resolve tree item for element ${u} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let i;if(typeof h=="string"){const s=this.getExtensionElement(h);i=s?this.m.get(s):void 0}else i=h;return i&&i.children||void 0}return this.h}async Y(h){this.rb(h);const i=new b.$3d(this.Z.token);try{const s=h?this.m.get(h):void 0,u=await this.f.getChildren(h);if(i.token.isCancellationRequested)return;const d=(0,D.$Hb)(u||[]),m=await Promise.all((0,D.$Hb)(d).map(S=>this.f.getTreeItem(S)));if(i.token.isCancellationRequested)return;const f=m.map((S,L)=>S?this.db(d[L],S,s):null);return(0,D.$Hb)(f)}finally{i.dispose()}}$(h){if(h.some(s=>!s))return this.Z.dispose(!0),this.Z=new b.$3d,this.tb(),this.J.$refresh(this.I);{const s=this.ab(h);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(h){const i=new Set,s=h.map(d=>this.m.get(d));for(const d of s)if(d&&!i.has(d.item.handle)){let m=d;for(;m&&m.parent&&s.findIndex(f=>m&&m.parent&&f&&f.item.handle===m.parent.item.handle)===-1;){const f=this.j.get(m.parent.item.handle);m=f?this.m.get(f):void 0}m&&!m.parent&&i.add(d.item.handle)}const u=[];return i.forEach(d=>{const m=this.j.get(d);if(m){const f=this.m.get(m);f&&(!f.parent||!i.has(f.parent.item.handle))&&u.push(d)}}),u}bb(h){const i={};return Promise.all(h.map(s=>this.cb(s).then(u=>{u&&(i[s]=u.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(h){const i=this.getExtensionElement(h);if(i){const s=this.m.get(i);if(s)return this.rb(i),(0,g.$Vg)(()=>this.f.getTreeItem(i)).then(u=>{if(u){const d=this.ib(i,u,s.parent);return this.pb(i,d,s,s.parent),s.dispose(),d}return null})}return Promise.resolve(null)}db(h,i,s){const u=this.ib(h,i,s);if(i.id&&this.j.has(u.item.handle))throw new Error((0,E.localize)(0,null,i.id));return this.ob(h,u),this.qb(u,s),u}eb(h){return w.$hL.isMarkdownString(h)?l.MarkdownString.from(h):h}fb(h,i){return i?{...this.L.toInternal(i,h),originalId:i.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let i,s,u;return typeof h.checkboxState=="number"?i=h.checkboxState:(i=h.checkboxState.state,s=h.checkboxState.tooltip,u=h.checkboxState.accessibilityInformation),{isChecked:i===w.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:u}}hb(h){if(!w.$FL.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,i,s){this.hb(i);const u=this.B(new R.$Rc),d=this.kb(h,i,s),m=this.lb(i);return{item:{handle:d,parentHandle:s?s.item.handle:void 0,label:t(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(u,i.command),contextValue:i.contextValue,icon:m,iconDark:this.mb(i)||m,themeIcon:this.jb(i),collapsibleState:(0,A.$Of)(i.collapsibleState)?w.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:s,children:void 0,disposableStore:u,dispose(){u.dispose()}}}jb(h){return h.iconPath instanceof w.$NL?h.iconPath:void 0}kb(h,{id:i,label:s,resourceUri:u},d,m){if(i)return`${a.b}/${i}`;const f=t(s,this.N),S=d?d.item.handle:a.a;let L=f?f.label:u?(0,T.$Bg)(u):"";L=L.indexOf("/")!==-1?L.replace("/","//"):L;const v=this.m.has(h)?this.m.get(h).item.handle:void 0,y=this.X(d)||[];let k,N=0;do{if(k=`${S}/${N}:${L}`,m||!this.j.has(k)||v===k)break;N++}while(N<=y.length);return k}lb(h){if(h.iconPath&&!(h.iconPath instanceof w.$NL))return typeof h.iconPath=="string"||I.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof w.$NL)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return I.URI.isUri(h)?h:I.URI.file(h)}ob(h,i){this.j.set(i.item.handle,h),this.m.set(h,i)}pb(h,i,s,u){this.j.delete(i.item.handle),this.m.delete(h),i.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(h,i);const d=this.X(u)||[],m=d.filter(f=>f.item.handle===s.item.handle)[0];m&&d.splice(d.indexOf(m),1,i)}qb(h,i){i?(i.children||(i.children=[]),i.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const i=this.m.get(h);if(i){if(i.children)for(const s of i.children){const u=this.j.get(s.item.handle);u&&this.sb(u)}i.children=void 0}}else this.tb()}sb(h){const i=this.m.get(h);if(i){if(i.children)for(const s of i.children){const u=this.j.get(s.item.handle);u&&this.sb(u)}this.m.delete(h),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ce[226],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[227],Re([1,0,179,15,31,97,73,30,22,226,189,101]),function(ge,e,E,T,I,F,R,$,g,w,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iF=e.$hF=e.$gF=e.$fF=e.$eF=e.$dF=void 0;const l=$.$vn.as(R.$wn.JSONContribution);class p{constructor(h,i,s){this.a=h,this.b=i,this.c=s}d(h,i){this.a({type:h,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(I.default.Error,h)}warn(h){this.d(I.default.Warning,h)}info(h){this.d(I.default.Info,h)}}e.$dF=p;class b{static a(h){const i=new g.$jm;for(let s=0,u=h.length;s<u;s++)i.add(h[s].description.identifier);return i}static compute(h,i){if(!h||!h.length)return new b(i,[]);if(!i||!i.length)return new b([],h);const s=this.a(h),u=this.a(i),d=i.filter(f=>!s.has(f.description.identifier)),m=h.filter(f=>!u.has(f.description.identifier));return new b(d,m)}constructor(h,i){this.added=h,this.removed=i}}e.$eF=b;class r{constructor(h,i){this.name=h,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=b.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,T.$1)(h)}}}e.$fF=r;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[E.localize(0,null),E.localize(1,null)]},t="vscode://schemas/vscode-extensions";e.$gF={properties:{engines:{type:"object",description:E.localize(2,null),properties:{vscode:{type:"string",description:E.localize(3,null),default:"^1.22.0"}}},publisher:{description:E.localize(4,null),type:"string"},displayName:{description:E.localize(5,null),type:"string"},categories:{description:E.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:g.$hm},{type:"string",const:"Languages",deprecationMessage:E.localize(7,null)}]}},galleryBanner:{type:"object",description:E.localize(8,null),properties:{color:{description:E.localize(9,null),type:"string"},theme:{description:E.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:E.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:E.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:E.localize(13,null)},enabledApiProposals:{markdownDescription:E.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}},api:{markdownDescription:E.localize(15,null),type:"string",enum:["none"],enumDescriptions:[E.localize(16,null)]},activationEvents:{description:E.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:E.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:E.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:E.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:E.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:E.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:E.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:E.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:E.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:E.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:E.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:E.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:E.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:E.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:E.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:E.localize(32,null)},{label:"onUri",body:"onUri",description:E.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:E.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:E.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:E.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:E.localize(37,null)},{label:"onRenderer",description:E.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:E.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:E.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:E.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:E.localize(42,null)},{label:"*",description:E.localize(43,null),body:"*"}]}},badges:{type:"array",description:E.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:E.localize(45,null)},href:{type:"string",description:E.localize(46,null)},description:{type:"string",description:E.localize(47,null)}}}},markdown:{type:"string",description:E.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:E.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:E.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$ao}},extensionPack:{description:E.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$ao}},extensionKind:{description:E.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:E.localize(53,null)},{body:["workspace"],description:E.localize(54,null)},{body:["ui","workspace"],description:E.localize(55,null)},{body:["workspace","ui"],description:E.localize(56,null)},{body:[],description:E.localize(57,null)}]},capabilities:{description:E.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:E.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:E.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(61,null),E.localize(62,null),E.localize(63,null)]},description:{type:"string",markdownDescription:E.localize(64,null)}}},untrustedWorkspaces:{description:E.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:E.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(67,null),E.localize(68,null),E.localize(69,null)]},restrictedConfigurations:{description:E.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:E.localize(71,null)}}}}},sponsor:{description:E.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:E.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:E.localize(74,null),type:"string"},"vscode:uninstall":{description:E.localize(75,null),type:"string"}}},icon:{type:"string",description:E.localize(76,null)},l10n:{type:"string",description:E.localize(77,null)},pricing:{type:"string",markdownDescription:E.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const i=new r(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,i),h.activationEventsGenerator&&D.$7E.register(h.extensionPoint,h.activationEventsGenerator),e.$gF.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,l.registerSchema(t,e.$gF),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$hF=n;const a={ExtensionsRegistry:"ExtensionsRegistry"};$.$vn.add(a.ExtensionsRegistry,new n),e.$iF=$.$vn.as(a.ExtensionsRegistry),l.registerSchema(t,e.$gF),l.registerSchema(A.$Dj,{properties:{extensionEnabledApiProposals:{description:E.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}}]}}}})}),define(Ce[228],Re([1,0,175,16,26,227,35,5]),function(ge,e,E,T,I,F,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kG=void 0;const g={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:E.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:E.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:E.localize(2,null),default:""}}};var w;(function(l){function p(b,r,o){if(!b)return;const t=T.$Ff(b.type)?b.type:void 0;if(!t||t.length===0){o.error(E.localize(3,null));return}const n=[];if(Array.isArray(b.required))for(const a of b.required)T.$Ff(a)&&n.push(a);return{extensionId:r.value,taskType:t,required:n,properties:b.properties?I.$jn(b.properties):{},when:b.when?R.$1i.deserialize(b.when):void 0}}l.from=p})(w||(w={}));const A=F.$iF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,p)=>{for(const b of l)b.type&&p.push(`onTaskType:${b.type}`)},jsonSchema:{description:E.localize(4,null),type:"array",items:g}});class D{constructor(){this.d=new $.$Sd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,b)=>{A.setHandler((r,o)=>{this.c=void 0;try{for(const t of o.removed){const n=t.value;for(const a of n)this.a&&a.type&&this.a[a.type]&&delete this.a[a.type]}for(const t of o.added){const n=t.value;for(const a of n){const c=w.from(a,t.description.identifier,t.collector);c&&(this.a[c.taskType]=c)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const b of this.all()){const r={type:"object",additionalProperties:!1};b.required.length>0&&(r.required=b.required.slice(0)),b.properties!==void 0?r.properties=I.$jn(b.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[b.taskType]},p.push(r)}this.c={oneOf:p}}return this.c}}e.$kG=new D}),define(Ce[229],Re([1,0,176,16,25,26,35,228]),function(ge,e,E,T,I,F,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$uG=e.JsonSchemaVersion=e.ExecutionEngine=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$oG=e.ShellQuoting=e.$nG=e.$mG=e.$lG=void 0,e.$lG="settings",e.$mG=new R.$hj("taskRunning",!1,E.localize(0,null)),e.$nG={value:E.localize(1,null),original:"Tasks"};var g;(function(P){P[P.Escape=1]="Escape",P[P.Strong=2]="Strong",P[P.Weak=3]="Weak"})(g||(e.ShellQuoting=g={})),e.$oG="$customized",function(P){function C(J){if(!J)return P.Strong;switch(J.toLowerCase()){case"escape":return P.Escape;case"strong":return P.Strong;case"weak":return P.Weak;default:return P.Strong}}P.from=C}(g||(e.ShellQuoting=g={}));var w;(function(P){P.defaults={cwd:"${workspaceFolder}"}})(w||(e.CommandOptions=w={}));var A;(function(P){P[P.Always=1]="Always",P[P.Silent=2]="Silent",P[P.Never=3]="Never"})(A||(e.RevealKind=A={})),function(P){function C(J){switch(J.toLowerCase()){case"always":return P.Always;case"silent":return P.Silent;case"never":return P.Never;default:return P.Always}}P.fromString=C}(A||(e.RevealKind=A={}));var D;(function(P){P[P.Never=1]="Never",P[P.OnProblem=2]="OnProblem",P[P.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(P){function C(J){switch(J.toLowerCase()){case"always":return P.Always;case"never":return P.Never;case"onproblem":return P.OnProblem;default:return P.OnProblem}}P.fromString=C}(D||(e.RevealProblemKind=D={}));var l;(function(P){P[P.Shared=1]="Shared",P[P.Dedicated=2]="Dedicated",P[P.New=3]="New"})(l||(e.PanelKind=l={})),function(P){function C(J){switch(J.toLowerCase()){case"shared":return P.Shared;case"dedicated":return P.Dedicated;case"new":return P.New;default:return P.Shared}}P.fromString=C}(l||(e.PanelKind=l={}));var p;(function(P){P.defaults={echo:!0,reveal:A.Always,revealProblems:D.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var b;(function(P){P[P.Shell=1]="Shell",P[P.Process=2]="Process",P[P.CustomExecution=3]="CustomExecution"})(b||(e.RuntimeType=b={})),function(P){function C(ae){switch(ae.toLowerCase()){case"shell":return P.Shell;case"process":return P.Process;case"customExecution":return P.CustomExecution;default:return P.Process}}P.fromString=C;function J(ae){switch(ae){case P.Shell:return"shell";case P.Process:return"process";case P.CustomExecution:return"customExecution";default:return"process"}}P.toString=J}(b||(e.RuntimeType=b={}));var r;(function(P){function C(J){return T.$Ff(J)?J:J.value}P.value=C})(r||(e.CommandString=r={}));var o;(function(P){P.Clean={_id:"clean",isDefault:!1},P.Build={_id:"build",isDefault:!1},P.Rebuild={_id:"rebuild",isDefault:!1},P.Test={_id:"test",isDefault:!1};function C(ae){return ae===P.Clean._id||ae===P.Build._id||ae===P.Rebuild._id||ae===P.Test._id}P.is=C;function J(ae){if(ae!==void 0)return T.$Ff(ae)?C(ae)?{_id:ae,isDefault:!1}:void 0:ae}P.from=J})(o||(e.TaskGroup=o={}));var t;(function(P){P[P.Global=1]="Global",P[P.Workspace=2]="Workspace",P[P.Folder=3]="Folder"})(t||(e.TaskScope=t={}));var n;(function(P){P.Workspace="workspace",P.Extension="extension",P.InMemory="inMemory",P.WorkspaceFile="workspaceFile",P.User="user";function C(J){switch(J){case P.User:return 2;case P.WorkspaceFile:return 5;default:return 6}}P.toConfigurationTarget=C})(n||(e.TaskSourceKind=n={}));var a;(function(P){P.parallel="parallel",P.sequence="sequence"})(a||(e.DependsOrder=a={}));var c;(function(P){P[P.default=1]="default",P[P.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var h;(function(P){P.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class i{constructor(C,J,ae,fe,be,ye){this._label="",this._id=C,J&&(this._label=J),ae&&(this.type=ae),this.runOptions=fe,this.configurationProperties=be,this._source=ye}getDefinition(C){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const C={folder:this.d(),id:this._id};return JSON.stringify(C)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(C,J=!1){if(C===void 0)return!1;if(T.$Ff(C))return C===this._label||C===this.configurationProperties.identifier||J&&C===this._id;const ae=this.getDefinition(!0);return ae!==void 0&&ae._key===C._key}getQualifiedLabel(){const C=this.getWorkspaceFolder();return C?`${this._label} (${C.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(C){this.c===void 0&&(this.c=[]),C&&(this.c=this.c.concat(C))}get taskLoadMessages(){return this.c}}e.$pG=i;class s extends i{constructor(C,J,ae,fe,be,ye,he,ve){super(C,ae,void 0,he,ve,J),this.command={},this._source=J,this.hasDefinedMatchers=ye,be&&(this.command=be)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(C=!1){if(C&&this._source.customizes!==void 0)return this._source.customizes;{let J;switch(this.command?this.command.runtime:void 0){case b.Shell:J="shell";break;case b.Process:J="process";break;case b.CustomExecution:J="customExecution";break;case void 0:J="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:J,_key:this._id,id:this._id}}}static is(C){return C instanceof s}getMapKey(){const C=this._source.config.workspaceFolder;return C?`${C.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$lG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const C=this.d();if(!C)return;let J=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(J+=this._source.kind);const ae={type:e.$oG,folder:C,id:J};return JSON.stringify(ae)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$Bg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(C){return new s(C._id,C._source,C._label,C.type,C.command,C.hasDefinedMatchers,C.runOptions,C.configurationProperties)}}e.$qG=s;class u extends i{constructor(C,J,ae,fe,be,ye,he){super(C,ae,fe,ye,he,J),this._source=J,this.configures=be}static is(C){return C instanceof u}f(C){return C}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$Bg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$lG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const C=this.d();if(!C)return;let J=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(J+=this._source.kind);const ae={type:e.$oG,folder:C,id:J};return JSON.stringify(ae)}}e.$rG=u;class d extends i{constructor(C,J,ae,fe,be,ye,he,ve,ee){super(C,ae,fe,ve,ee,J),this.defines=be,this.hasDefinedMatchers=he,this.command=ye,this.icon=ee.icon,this.hide=ee.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(C){return C instanceof d}getMapKey(){const C=this._source.workspaceFolder;return C?`${this._source.scope.toString()}|${C.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const C={type:"contributed",scope:this._source.scope,id:this._id};return C.folder=this.d(),JSON.stringify(C)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(C){return new d(C._id,C._source,C._label,C.type,C.defines,C.command,C.hasDefinedMatchers,C.runOptions,C.configurationProperties)}}e.$sG=d;class m extends i{constructor(C,J,ae,fe,be,ye){super(C,ae,fe,be,ye,J),this._source=J}clone(){return new m(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(C){return C instanceof m}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(C){return new m(C._id,C._source,C._label,C.type,C.runOptions,C.configurationProperties)}}e.$tG=m;var f;(function(P){P[P.Process=1]="Process",P[P.Terminal=2]="Terminal"})(f||(e.ExecutionEngine=f={})),function(P){P._default=P.Terminal}(f||(e.ExecutionEngine=f={}));var S;(function(P){P[P.V0_1_0=1]="V0_1_0",P[P.V2_0_0=2]="V2_0_0"})(S||(e.JsonSchemaVersion=S={}));class L{constructor(C){this.c=new Map;for(let J=0;J<C.length;J++)this.c.set(C[J].uri.toString(),J)}compare(C,J){const ae=C.getWorkspaceFolder(),fe=J.getWorkspaceFolder();if(ae&&fe){let be=this.c.get(ae.uri.toString());be=be===void 0?0:be+1;let ye=this.c.get(fe.uri.toString());return ye=ye===void 0?0:ye+1,be===ye?C._label.localeCompare(J._label):be-ye}else return!ae&&fe?-1:ae&&!fe?1:0}}e.$uG=L;var v;(function(P){P.DependsOnStarted="dependsOnStarted",P.AcquiredInput="acquiredInput",P.Start="start",P.ProcessStarted="processStarted",P.Active="active",P.Inactive="inactive",P.Changed="changed",P.Terminated="terminated",P.ProcessEnded="processEnded",P.End="end"})(v||(e.TaskEventKind=v={}));var y;(function(P){P.SingleRun="singleRun",P.Background="background"})(y||(e.TaskRunType=y={}));var k;(function(P){P[P.System=0]="System",P[P.User=1]="User",P[P.FolderOpen=2]="FolderOpen",P[P.ConfigurationChange=3]="ConfigurationChange",P[P.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var N;(function(P){function C(ve){return{taskId:ve._id,taskName:ve.configurationProperties.name,runType:ve.configurationProperties.isBackground?"background":"singleRun",group:ve.configurationProperties.group,__task:ve}}function J(ve,ee,ke){return{...C(ve),kind:"start",terminalId:ee,resolvedVariables:ke}}P.start=J;function ae(ve,ee,ke){return{...C(ve),kind:"processStarted",terminalId:ee,processId:ke}}P.processStarted=ae;function fe(ve,ee,ke){return{...C(ve),kind:"processEnded",terminalId:ee,exitCode:ke}}P.processEnded=fe;function be(ve,ee,ke){return{...C(ve),kind:"terminated",exitReason:ke,terminalId:ee}}P.terminated=be;function ye(ve,ee,ke){return{...C(ee),kind:ve,terminalId:ke}}P.general=ye;function he(){return{kind:"changed"}}P.changed=he})(N||(e.TaskEvent=N={}));var O;(function(P){function C(ae){const fe=Object.keys(ae).sort();let be="";for(const ye of fe){let he=ae[ye];he instanceof Object?he=C(he):typeof he=="string"&&(he=he.replace(/,/g,",,")),be+=ye+","+he+","}return be}function J(ae){const be={_key:C(ae),type:ae.taskType};return Object.assign(be,ae),be}P.create=J})(O||(e.KeyedTaskIdentifier=O={}));var K;(function(P){P.AutoDetect="task.autoDetect",P.SaveBeforeRun="task.saveBeforeRun",P.ShowDecorations="task.showDecorations",P.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",P.SlowProviderWarning="task.slowProviderWarning",P.QuickOpenHistory="task.quickOpen.history",P.QuickOpenDetail="task.quickOpen.detail",P.QuickOpenSkip="task.quickOpen.skip",P.QuickOpenShowAll="task.quickOpen.showAll",P.AllowAutomaticTasks="task.allowAutomaticTasks",P.Reconnection="task.reconnection",P.VerboseLogging="task.verboseLogging"})(K||(e.TaskSettingId=K={}));var j;(function(P){P.Tasks="tasks",P.SuppressTaskName="tasks.suppressTaskName",P.Windows="tasks.windows",P.Osx="tasks.osx",P.Linux="tasks.linux",P.ShowOutput="tasks.showOutput",P.IsShellCommand="tasks.isShellCommand",P.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var W;(function(P){function C(J,ae){const fe=$.$kG.get(J.type);if(fe===void 0){const ve=F.$jn(J);return delete ve._key,O.create(ve)}const be=Object.create(null);be.type=fe.taskType;const ye=new Set;fe.required.forEach(ve=>ye.add(ve));const he=fe.properties;for(const ve of Object.keys(he)){const ee=J[ve];if(ee!=null)be[ve]=ee;else if(ye.has(ve)){const ke=he[ve];if(ke.default!==void 0)be[ve]=F.$jn(ke.default);else switch(ke.type){case"boolean":be[ve]=!1;break;case"number":case"integer":be[ve]=0;break;case"string":be[ve]="";break;default:ae.error(E.localize(2,null,JSON.stringify(J,void 0,0),ve));return}}}return O.create(be)}P.createTaskIdentifier=C})(W||(e.TaskDefinition=W={}))}),define(Ce[230],Re([1,0,15]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u7b=e.$t7b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,$)=>{this.b=R,this.d=$,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,E.$1)(R))}then(R,$){return this.j().then(R,$)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$t7b=T;class I extends T{constructor(){super(),this.h=!0,this.i=new E.$5}}e.$u7b=I}),define(Ce[49],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gv=e.$Fv=e.$Ev=e.$Dv=void 0;class E{static{this.count=0}constructor(g){this._proxyIdentifierBrand=void 0,this.sid=g,this.nid=++E.count}}e.$Dv=E;const T=[];function I($){const g=new E($);return T[g.nid]=g,g}e.$Ev=I;function F($){return T[$].sid}e.$Fv=F;class R{constructor(g){this.value=g}}e.$Gv=R}),define(Ce[3],Re([1,0,49]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RK=e.$QK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$PK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var I;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput"})(I||(e.TabInputKind=I={}));var F;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(F||(e.TabModelOperationKind=F={}));var R;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var $;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})($||(e.WebviewMessageArrayBufferViewType=$={}));var g;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(g||(e.CellOutputKind=g={}));var w;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(w||(e.NotebookEditorRevealType=w={}));var A;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class D{static{this.a=0}static mixin(o){return o._id=D.a++,o}}e.$PK=D;var l;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var p;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var b;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(b||(e.ExtHostTestingResource=b={})),e.$QK={MainThreadAuthentication:(0,E.$Ev)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.$Ev)("MainThreadBulkEdits"),MainThreadChatProvider:(0,E.$Ev)("MainThreadChatProvider"),MainThreadChatAgents2:(0,E.$Ev)("MainThreadChatAgents2"),MainThreadChatVariables:(0,E.$Ev)("MainThreadChatVariables"),MainThreadClipboard:(0,E.$Ev)("MainThreadClipboard"),MainThreadCommands:(0,E.$Ev)("MainThreadCommands"),MainThreadComments:(0,E.$Ev)("MainThreadComments"),MainThreadConfiguration:(0,E.$Ev)("MainThreadConfiguration"),MainThreadConsole:(0,E.$Ev)("MainThreadConsole"),MainThreadDebugService:(0,E.$Ev)("MainThreadDebugService"),MainThreadDecorations:(0,E.$Ev)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.$Ev)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.$Ev)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.$Ev)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.$Ev)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.$Ev)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.$Ev)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.$Ev)("MainThreadEditorTabs"),MainThreadErrors:(0,E.$Ev)("MainThreadErrors"),MainThreadTreeViews:(0,E.$Ev)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.$Ev)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,E.$Ev)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.$Ev)("MainThreadLanguages"),MainThreadLogger:(0,E.$Ev)("MainThreadLogger"),MainThreadMessageService:(0,E.$Ev)("MainThreadMessageService"),MainThreadOutputService:(0,E.$Ev)("MainThreadOutputService"),MainThreadProgress:(0,E.$Ev)("MainThreadProgress"),MainThreadQuickDiff:(0,E.$Ev)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,E.$Ev)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.$Ev)("MainThreadStatusBar"),MainThreadSecretState:(0,E.$Ev)("MainThreadSecretState"),MainThreadStorage:(0,E.$Ev)("MainThreadStorage"),MainThreadSpeech:(0,E.$Ev)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,E.$Ev)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.$Ev)("MainThreadTerminalService"),MainThreadWebviews:(0,E.$Ev)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.$Ev)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.$Ev)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.$Ev)("MainThreadCustomEditors"),MainThreadUrls:(0,E.$Ev)("MainThreadUrls"),MainThreadUriOpeners:(0,E.$Ev)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,E.$Ev)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,E.$Ev)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.$Ev)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,E.$Ev)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,E.$Ev)("MainThreadExtensionService"),MainThreadSCM:(0,E.$Ev)("MainThreadSCM"),MainThreadSearch:(0,E.$Ev)("MainThreadSearch"),MainThreadShare:(0,E.$Ev)("MainThreadShare"),MainThreadTask:(0,E.$Ev)("MainThreadTask"),MainThreadWindow:(0,E.$Ev)("MainThreadWindow"),MainThreadLabelService:(0,E.$Ev)("MainThreadLabelService"),MainThreadNotebook:(0,E.$Ev)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.$Ev)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.$Ev)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.$Ev)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.$Ev)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.$Ev)("MainThreadInteractive"),MainThreadChat:(0,E.$Ev)("MainThreadChat"),MainThreadInlineChat:(0,E.$Ev)("MainThreadInlineChatShape"),MainThreadTheming:(0,E.$Ev)("MainThreadTheming"),MainThreadTunnelService:(0,E.$Ev)("MainThreadTunnelService"),MainThreadManagedSockets:(0,E.$Ev)("MainThreadManagedSockets"),MainThreadTimeline:(0,E.$Ev)("MainThreadTimeline"),MainThreadTesting:(0,E.$Ev)("MainThreadTesting"),MainThreadLocalization:(0,E.$Ev)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,E.$Ev)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,E.$Ev)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,E.$Ev)("MainThreadIssueReporter")},e.$RK={ExtHostCommands:(0,E.$Ev)("ExtHostCommands"),ExtHostConfiguration:(0,E.$Ev)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.$Ev)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.$Ev)("ExtHostDebugService"),ExtHostDecorations:(0,E.$Ev)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.$Ev)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.$Ev)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.$Ev)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.$Ev)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.$Ev)("ExtHostEditors"),ExtHostTreeViews:(0,E.$Ev)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.$Ev)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.$Ev)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.$Ev)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.$Ev)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.$Ev)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.$Ev)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,E.$Ev)("ExtHostQuickDiff"),ExtHostStatusBar:(0,E.$Ev)("ExtHostStatusBar"),ExtHostShare:(0,E.$Ev)("ExtHostShare"),ExtHostExtensionService:(0,E.$Ev)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.$Ev)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.$Ev)("ExtHostTerminalService"),ExtHostSCM:(0,E.$Ev)("ExtHostSCM"),ExtHostSearch:(0,E.$Ev)("ExtHostSearch"),ExtHostTask:(0,E.$Ev)("ExtHostTask"),ExtHostWorkspace:(0,E.$Ev)("ExtHostWorkspace"),ExtHostWindow:(0,E.$Ev)("ExtHostWindow"),ExtHostWebviews:(0,E.$Ev)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.$Ev)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.$Ev)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.$Ev)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.$Ev)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.$Ev)("ExtHostEditorTabs"),ExtHostProgress:(0,E.$Ev)("ExtHostProgress"),ExtHostComments:(0,E.$Ev)("ExtHostComments"),ExtHostSecretState:(0,E.$Ev)("ExtHostSecretState"),ExtHostStorage:(0,E.$Ev)("ExtHostStorage"),ExtHostUrls:(0,E.$Ev)("ExtHostUrls"),ExtHostUriOpeners:(0,E.$Ev)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,E.$Ev)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,E.$Ev)("ExtHostOutputService"),ExtHostLabelService:(0,E.$Ev)("ExtHostLabelService"),ExtHostNotebook:(0,E.$Ev)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.$Ev)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.$Ev)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.$Ev)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.$Ev)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,E.$Ev)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,E.$Ev)("ExtHostInteractive"),ExtHostInlineChat:(0,E.$Ev)("ExtHostInlineChatShape"),ExtHostChat:(0,E.$Ev)("ExtHostChat"),ExtHostChatAgents2:(0,E.$Ev)("ExtHostChatAgents"),ExtHostChatVariables:(0,E.$Ev)("ExtHostChatVariables"),ExtHostChatProvider:(0,E.$Ev)("ExtHostChatProvider"),ExtHostSpeech:(0,E.$Ev)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,E.$Ev)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,E.$Ev)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,E.$Ev)("ExtHostTheming"),ExtHostTunnelService:(0,E.$Ev)("ExtHostTunnelService"),ExtHostManagedSockets:(0,E.$Ev)("ExtHostManagedSockets"),ExtHostAuthentication:(0,E.$Ev)("ExtHostAuthentication"),ExtHostTimeline:(0,E.$Ev)("ExtHostTimeline"),ExtHostTesting:(0,E.$Ev)("ExtHostTesting"),ExtHostTelemetry:(0,E.$Ev)("ExtHostTelemetry"),ExtHostLocalization:(0,E.$Ev)("ExtHostLocalization"),ExtHostIssueReporter:(0,E.$Ev)("ExtHostIssueReporter")}}),define(Ce[231],Re([1,0,3,7]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=void 0;class I{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(E.$QK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,$,g){if(this.a.size===0)throw new Error("No related information providers registered");const w=this.a.get(R);if(!w)throw new Error("related information provider not found");return await w.provideRelatedInformation($,g)??[]}getRelatedInformation(R,$,g){return this.c.$getAiRelatedInformation($,g)}registerRelatedInformationProvider(R,$,g){const w=this.b;return this.b++,this.a.set(w,g),this.c.$registerAiRelatedInformationProvider(w,$),new T.$SK(()=>{this.c.$unregisterAiRelatedInformationProvider(w),this.a.delete(w)})}}e.$efc=I}),define(Ce[81],Re([1,0,4,14,3,17]),function(ge,e,E,T,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=e.$lfc=e.$kfc=void 0,e.$kfc=(0,E.$3h)("IExtHostApiDeprecationService");let R=class{constructor(g,w){this.c=w,this.a=new Set,this.b=g.getProxy(I.$QK.MainThreadTelemetry)}report(g,w,A){const D=this.d(g,w);this.a.has(D)||(this.a.add(D),w.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${g}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:w.identifier.value,apiId:g}))}d(g,w){return`${g}-${w.identifier.value}`}};e.$lfc=R,e.$lfc=R=Ge([Ke(0,F.$UM),Ke(1,T.$kj)],R),e.$mfc=Object.freeze(new class{report($,g,w){}})}),define(Ce[232],Re([1,0,5,3,7,22]),function(ge,e,E,T,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=void 0;class R{constructor(w){this.b=new Map,this.c=[],this.d=new E.$Sd,this.onDidChangeSessions=this.d.event,this.f=new $,this.g=new $,this.a=w.getProxy(T.$QK.MainThreadAuthentication)}$setProviders(w){return this.c=w,Promise.resolve()}async getSession(w,A,D,l={}){const p=F.$im.toKey(w.identifier),b=[...D].sort().join(" ");return await this.f.getOrCreate(`${p} ${A} ${b}`,async()=>{await this.a.$ensureProvider(A);const r=w.displayName||w.name;return this.a.$getSession(A,D,p,r,l)})}async getSessions(w,A,D){const l=F.$im.toKey(w.identifier),p=[...D].sort().join(" ");return await this.g.getOrCreate(`${l} ${p}`,async()=>{await this.a.$ensureProvider(A);const b=w.displayName||w.name;return this.a.$getSessions(A,D,l,b)})}async removeSession(w,A){const D=this.b.get(w);return D?D.provider.removeSession(A):this.a.$removeSession(w,A)}registerAuthenticationProvider(w,A,D,l){if(this.b.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this.b.set(w,{label:A,provider:D,options:l??{supportsMultipleAccounts:!1}}),this.c.find(b=>b.id===w)||this.c.push({id:w,label:A});const p=D.onDidChangeSessions(b=>{this.a.$sendDidChangeSessions(w,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this.a.$registerAuthenticationProvider(w,A,l?.supportsMultipleAccounts??!1),new I.$SK(()=>{p.dispose(),this.b.delete(w);const b=this.c.findIndex(r=>r.id===w);b>-1&&this.c.splice(b),this.a.$unregisterAuthenticationProvider(w)})}$createSession(w,A,D){const l=this.b.get(w);if(l)return Promise.resolve(l.provider.createSession(A,D));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,A){const D=this.b.get(w);if(D)return Promise.resolve(D.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,A){const D=this.b.get(w);if(D)return Promise.resolve(D.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,A){return this.d.fire({provider:{id:w,label:A}}),Promise.resolve()}}e.$pfc=R;class ${constructor(){this.a=new Map}getOrCreate(w,A){const D=this.a.get(w);if(D)return D;const l=A().finally(()=>this.a.delete(w));return this.a.set(w,l),l}}}),define(Ce[233],Re([1,0,3,17,8]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=void 0;let F=class{constructor($,g){this.a=$.getProxy(E.$QK.MainThreadBulkEdits),this.b={getTextDocumentVersion:w=>g.getDocument(w)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,g,w){const A=I.WorkspaceEdit.from($,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,w?.isRefactoring??!1)}};e.$qfc=F,e.$qfc=F=Ge([Ke(0,T.$UM)],F)}),define(Ce[234],Re([1,0,67,6,3,8]),function(ge,e,E,T,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=void 0;class R{static{this.a=0}constructor(w,A){this.extension=w,this.provider=A,this.handle=R.a++}}class ${static{this.a=0}constructor(w){this.b=new Map,this.c=new Map,this.d=w.getProxy(I.$QK.MainThreadChat)}registerChatProvider(w,A,D){const l=new R(w,D);return this.b.set(l.handle,l),this.d.$registerChatProvider(l.handle,A),(0,T.$Qc)(()=>{this.d.$unregisterChatProvider(l.handle),this.b.delete(l.handle)})}transferChatSession(w,A){const D=E.Iterable.find(this.c.keys(),l=>this.c.get(l)===w)??0;typeof D=="number"&&this.d.$transferChatSession(D,A)}sendInteractiveRequestToProvider(w,A){this.d.$sendRequestToProvider(w,A)}async $prepareChat(w,A){const D=this.b.get(w);if(!D)return;const l=await D.provider.prepareSession(A);if(!l)return;const p=$.a++;return this.c.set(p,l),{id:p,requesterUsername:l.requester?.name,requesterAvatarIconUri:l.requester?.icon,responderUsername:l.responder?.name,responderAvatarIconUri:l.responder?.icon,inputPlaceholder:l.inputPlaceholder}}async $provideWelcomeMessage(w,A){const D=this.b.get(w);if(!D||!D.provider.provideWelcomeMessage)return;const l=await D.provider.provideWelcomeMessage(A);if(l)return l.map(p=>typeof p=="string"?p:Array.isArray(p)?p.map(b=>F.ChatReplyFollowup.from(b)):F.MarkdownString.from(p))}async $provideSampleQuestions(w,A){const D=this.b.get(w);if(!D||!D.provider.provideSampleQuestions)return;const l=await D.provider.provideSampleQuestions(A);if(l)return l?.map(p=>F.ChatReplyFollowup.from(p))}$releaseSession(w){this.c.delete(w)}}e.$rfc=$}),define(Ce[235],Re([1,0,13,20,40,5,60,16,2,157,72,3,8,7,206,23]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l,p,b,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=void 0;class o{static{this.a=0}constructor(a,c,h){this.i=c,this.j=h,this.b=new Map,this.g=new Map,this.h=new Map,this.d=a.getProxy(D.$QK.MainThreadChatAgents2)}createChatAgent(a,c,h){const i=o.a++,s=new t(a,c,this.d,i,h);return this.b.set(i,s),this.d.$registerAgent(i,c,{}),s.apiAgent}async $invokeAgent(a,c,h,i,s,u){this.g.delete(c);const d=this.b.get(a);if(!d)throw new Error(`[CHAT](${a}) CANNOT invoke agent because the agent is not registered`);let m=!1;function f(){if(m)throw new Error("Only valid while executing the command")}const S=new E.$nh;u.onCancellationRequested(()=>S.complete()),this.i.allowListExtensionWhile(d.extension.identifier,S.p);const L=i.command?await d.validateSlashCommand(i.command):void 0,v=R.$Od.create(!1);let y;try{const k=d.invoke({prompt:i.message,variables:l.ChatVariable.objectTo(i.variables),slashCommand:L},{history:s.history.map(l.ChatMessage.to)},new A.$iv(N=>{f(),typeof y>"u"&&"content"in N&&(y=v.elapsed());const O=l.ChatResponseProgress.from(d.extension,N);if(!O){this.j.error("Unknown progress type: "+JSON.stringify(N));return}if("placeholder"in N&&"resolvedContent"in N){const K=Promise.all([this.d.$handleProgressChunk(h,O),N.resolvedContent]);(0,E.$Rg)(K,u).then(j=>{if(!j)return;const[W,P]=j,C=l.ChatResponseProgress.from(d.extension,P);if(!C){this.j.error("Unknown progress type: "+JSON.stringify(P));return}this.d.$handleProgressChunk(h,C,W??void 0)})}else this.d.$handleProgressChunk(h,O)}),u);return await(0,E.$Rg)(Promise.resolve(k).then(N=>{if(N){this.g.set(c,N);let O=this.h.get(c);O||(O=new Map,this.h.set(c,O)),O.set(h,N);const K={firstProgress:y,totalElapsed:v.elapsed()};return{errorDetails:N.errorDetails,timings:K}}else this.g.delete(c)}),u)}catch(k){return this.j.error(k,d.extension),{errorDetails:{message:(0,w.localize)(0,null,(0,I.$Ni)(k)),responseIsIncomplete:!0}}}finally{m=!0,S.complete()}}$releaseSession(a){this.g.delete(a),this.h.delete(a)}async $provideSlashCommands(a,c){const h=this.b.get(a);return h?h.provideSlashCommand(c):[]}$provideFollowups(a,c,h){const i=this.b.get(a);if(!i)return Promise.resolve([]);const s=this.g.get(c);return s?i.provideFollowups(s,h):Promise.resolve([])}$acceptFeedback(a,c,h,i,s){const u=this.b.get(a);if(!u)return;const d=this.h.get(c)?.get(h);if(!d)return;let m;switch(i){case b.InteractiveSessionVoteDirection.Down:m=p.ChatAgentResultFeedbackKind.Unhelpful;break;case b.InteractiveSessionVoteDirection.Up:m=p.ChatAgentResultFeedbackKind.Helpful;break}u.acceptFeedback(Object.freeze(s?{result:d,kind:m,reportIssue:s}:{result:d,kind:m}))}$acceptAction(a,c,h,i){const s=this.b.get(a);if(!s)return;const u=this.h.get(c)?.get(h);u&&i.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:i.action,result:u}))}async $invokeCompletionProvider(a,c,h){const i=this.b.get(a);return i?(await i.invokeCompletionProvider(c,h)).map(l.ChatAgentCompletionItem.from):[]}}e.$tfc=o;class t{constructor(a,c,h,i,s){this.extension=a,this.t=c,this.u=h,this.w=i,this.x=s,this.o=new F.$Sd,this.q=new F.$Sd}acceptFeedback(a){this.o.fire(a)}acceptAction(a){this.q.fire(a)}async invokeCompletionProvider(a,c){return this.s?await this.s.provider.provideCompletionItems(a,c)??[]:[]}async validateSlashCommand(a){this.b||(await this.provideSlashCommand(T.CancellationToken.None),(0,$.$Pf)(this.b));const c=this.b.find(h=>h.name===a);if(!c)throw new Error(`Unknown slashCommand: ${a}`);return c}async provideSlashCommand(a){if(!this.a)return[];const c=await this.a.provideSlashCommands(a);return c?(this.b=c,c.map(h=>({name:h.name,description:h.description,followupPlaceholder:h.followupPlaceholder,shouldRepopulate:h.shouldRepopulate,sampleRequest:h.sampleRequest}))):[]}async provideFollowups(a,c){if(!this.d)return[];const h=await this.d.provideFollowups(a,c);return h?h.map(i=>l.ChatFollowup.from(i)):[]}get apiAgent(){let a=!1,c=!1;const h=()=>{a||c||(c=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof g.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof p.$NL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:l.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:l.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),c=!1}))},i=this;return{get name(){return i.t},get description(){return i.g??""},set description(s){i.g=s,h()},get fullName(){return i.h??i.extension.displayName??i.extension.name},set fullName(s){i.h=s,h()},get iconPath(){return i.i},set iconPath(s){i.i=s,h()},get slashCommandProvider(){return i.a},set slashCommandProvider(s){i.a=s,h()},get followupProvider(){return i.d},set followupProvider(s){i.d=s,h()},get isDefault(){return(0,r.$pF)(i.extension,"defaultChatAgent"),i.j},set isDefault(s){(0,r.$pF)(i.extension,"defaultChatAgent"),i.j=s,h()},get helpTextPrefix(){return(0,r.$pF)(i.extension,"defaultChatAgent"),i.k},set helpTextPrefix(s){if((0,r.$pF)(i.extension,"defaultChatAgent"),!i.j)throw new Error("helpTextPrefix is only available on the default chat agent");i.k=s,h()},get helpTextPostfix(){return(0,r.$pF)(i.extension,"defaultChatAgent"),i.l},set helpTextPostfix(s){if((0,r.$pF)(i.extension,"defaultChatAgent"),!i.j)throw new Error("helpTextPostfix is only available on the default chat agent");i.l=s,h()},get isSecondary(){return(0,r.$pF)(i.extension,"defaultChatAgent"),i.n},set isSecondary(s){(0,r.$pF)(i.extension,"defaultChatAgent"),i.n=s,h()},get sampleRequest(){return i.m},set sampleRequest(s){i.m=s,h()},get supportIssueReporting(){return(0,r.$pF)(i.extension,"chatAgents2Additions"),i.r},set supportIssueReporting(s){(0,r.$pF)(i.extension,"chatAgents2Additions"),i.r=s,h()},get onDidReceiveFeedback(){return i.o.event},set agentVariableProvider(s){if(i.s=s,s){if(!s.triggerCharacters.length)throw new Error("triggerCharacters are required");i.u.$registerAgentCompletionsProvider(i.w,s.triggerCharacters)}else i.u.$unregisterAgentCompletionsProvider(i.w)},get agentVariableProvider(){return i.s},onDidPerformAction:(0,r.$oF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){a=!0,i.a=void 0,i.d=void 0,i.o.dispose(),i.u.$unregisterAgent(i.w)}}}invoke(a,c,h,i){return this.x(a,c,h,i)}}}),define(Ce[236],Re([1,0,20,6,3,8,72,22,13,5]),function(ge,e,E,T,I,F,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sfc=void 0;class A{constructor(b,r){this.stream=new g.$th,this.stream=r??new g.$th;const o=this;this.apiObj={option:b,response:o.stream.asyncIterable}}}class D{constructor(b,r){this.a=new w.$Sd,this.b=new Map,this.c=new g.$th,this.d=!1;const o=this;this.apiObject={result:b,response:o.c.asyncIterable,onDidStartResponseStream:o.a.event,cancel(){r.cancel()}},b.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,t]of this.b)t.stream.resolve();else this.c.resolve()})}handleFragment(b){if(this.d)return;let r=this.b.get(b.index);r||(this.b.size===0?r=new A(b.index,this.c):r=new A(b.index),this.b.set(b.index,r),this.a.fire(r.apiObj)),r.stream.emitOne(b.part)}}class l{static{this.a=1}constructor(b,r){this.d=r,this.c=new Map,this.e=new Map,this.f=new $.$km,this.b=b.getProxy(I.$QK.MainThreadChatProvider)}registerProvider(b,r,o,t){const n=l.a++;return this.c.set(n,{extension:b,provider:o}),this.b.$registerProvider(n,r,{extension:b,model:t.name??""}),(0,T.$Qc)(()=>{this.b.$unregisterProvider(n),this.c.delete(n)})}async $provideChatResponse(b,r,o,t,n){const a=this.c.get(b);if(!a)return;const c=new R.$iv(async h=>{if(n.isCancellationRequested){this.d.warn(`[CHAT](${a.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(r,{index:h.index,part:h.part})});return a.provider.provideChatResponse(o.map(F.ChatMessage.to),t,c,n)}allowListExtensionWhile(b,r){this.f.set(b,r),r.finally(()=>this.f.delete(b))}async requestChatResponseProvider(b,r){if(!this.f.has(b))throw new Error("Extension is NOT allowed to make chat requests");const o=await this.b.$prepareChatAccess(r);if(!o)throw new Error(`ChatAccess '${r}' NOT found`);const t=this;return{get model(){return o.model},get isRevoked(){return!t.f.has(b)},makeRequest(n,a,c){if(!t.f.has(b))throw new Error("Access to chat has been revoked");const h=new E.$3d(c),i=Math.random()*1e6|0,s=t.b.$fetchResponse(b,r,i,n.map(F.ChatMessage.from),a??{},h.token),u=new D(s,h);return t.e.set(i,{res:u}),s.finally(()=>{t.e.delete(i)}),u.apiObject}}}async $handleResponseFragment(b,r){const o=this.e.get(b);o&&o.res.handleFragment(r)}}e.$sfc=l}),define(Ce[237],Re([1,0,6,3,15,8]),function(ge,e,E,T,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ufc=void 0;class R{static{this.a=0}constructor(g){this.b=new Map,this.c=g.getProxy(T.$QK.MainThreadChatVariables)}async $resolveVariable(g,w,A){const D=this.b.get(g);if(D)try{const l=await D.resolver.resolve(D.data.name,{message:w},A);if(l)return l.map(F.ChatVariable.from)}catch(l){(0,I.$2)(l)}}registerVariableResolver(g,w,A,D){const l=R.a++;return this.b.set(l,{extension:g.identifier,data:{name:w,description:A},resolver:D}),this.c.$registerVariable(l,{name:w,description:A}),(0,E.$Qc)(()=>{this.b.delete(l),this.c.$unregisterVariable(l)})}}e.$ufc=R}),define(Ce[238],Re([1,0,3]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vfc=void 0;class T{constructor(F){const R=F.getProxy(E.$QK.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText($){return R.$writeText($)}})}}e.$vfc=T}),define(Ce[32],Re([1,0,16,7,8,26,3,18,14,51,29,92,2,6,4,17,108,24,49,40,60,56,59,33]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l,p,b,r,o,t,n,a,c,h,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iN=e.$hN=e.$gN=e.$fN=e.$eN=e.$dN=void 0;let u=class{#e;#t;#i;constructor(v,y,k){this.b=new Map,this.c=new Map,this.#e=v.getProxy(R.$QK.MainThreadCommands),this.d=y,this.#i=k,this.#t=v.getProxy(R.$QK.MainThreadTelemetry),this.converter=new d(this,N=>{const O=this.c.get(N);return O?.result===f.Void?O:void 0},y),this.f=[{processArgument(N){return(0,w.$zh)(N)}},{processArgument(N){return(0,F.$ln)(N,function(O){if(A.$Is.isIRange(O))return I.Range.to(O);if(D.$Hs.isIPosition(O))return I.Position.to(O);if(A.$Is.isIRange(O.range)&&l.URI.isUri(O.uri))return I.location.to(O);if(O instanceof t.$ge)return O.buffer.buffer;if(!Array.isArray(O))return O})}}]}registerArgumentProcessor(v){this.f.push(v)}registerApiCommand(v){const y=this.registerCommand(!1,v.id,async(...k)=>{const N=v.args.map((K,j)=>{if(!K.validate(k[j]))throw new Error(`Invalid argument '${K.name}' when running '${v.id}', received: ${typeof k[j]=="object"?JSON.stringify(k[j],null,"	"):k[j]} `);return K.convert(k[j])}),O=await this.executeCommand(v.internalId,...N);return v.result.convert(O,k,this.converter)},void 0,{description:v.description,args:v.args,returns:v.result.description});return this.c.set(v.id,v),new T.$SK(()=>{y.dispose(),this.c.delete(v.id)})}registerCommand(v,y,k,N,O,K){if(this.d.trace("ExtHostCommands#registerCommand",y),!y.trim().length)throw new Error("invalid id");if(this.b.has(y))throw new Error(`command '${y}' already exists`);return this.b.set(y,{callback:k,thisArg:N,metadata:O,extension:K}),v&&this.#e.$registerCommand(y),new T.$SK(()=>{this.b.delete(y)&&v&&this.#e.$unregisterCommand(y)})}executeCommand(v,...y){return this.d.trace("ExtHostCommands#executeCommand",v),this.g(v,y,!0)}async g(v,y,k){if(this.b.has(v))return this.#e.$fireCommandActivationEvent(v),this.h(v,y,!1);{let N=!1;const O=(0,F.$ln)(y,function(K){if(K instanceof T.$TK)return I.Position.from(K);if(K instanceof T.$UK)return I.Range.from(K);if(K instanceof T.$5K)return I.location.from(K);if(T.$eM.isNotebookRange(K))return I.NotebookRange.from(K);if(K instanceof ArrayBuffer)return N=!0,t.$ge.wrap(new Uint8Array(K));if(K instanceof Uint8Array)return N=!0,t.$ge.wrap(K);if(K instanceof t.$ge)return N=!0,K;if(!Array.isArray(K))return K});try{const K=await this.#e.$executeCommand(v,N?new n.$Gv(O):O,k);return(0,w.$zh)(K)}catch(K){if(K instanceof Error&&K.message==="$executeCommand:retry")return this.g(v,y,!1);throw K}}}async h(v,y,k){const N=this.b.get(v);if(!N)throw new Error("Unknown command");const{callback:O,thisArg:K,metadata:j}=N;if(j?.args)for(let P=0;P<j.args.length;P++)try{(0,E.$Wf)(y[P],j.args[P].constraint)}catch{throw new Error(`Running the contributed command: '${v}' failed. Illegal argument '${j.args[P].name}' - ${j.args[P].description}`)}const W=c.$Od.create();try{return await O.apply(K,y)}catch(P){if(v===this.converter.delegatingCommandId){const C=this.converter.getActualCommand(...y);C&&(v=C.command)}if(this.d.error(P,v,N.extension?.identifier),!k)throw P;if(N.extension?.identifier){const C=this.#i.onExtensionError(N.extension.identifier,P);this.d.trace("forwarded error to extension?",C,N.extension?.identifier)}throw new class extends Error{constructor(){super((0,a.$Ni)(P)),this.id=v,this.source=N.extension?.displayName??N.extension?.name}}}finally{this.j(N,v,W.elapsed())}}j(v,y,k){v.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:v.extension.identifier.value,id:new h.$yo(y),duration:k})}$executeContributedCommand(v,...y){this.d.trace("ExtHostCommands#$executeContributedCommand",v);const k=this.b.get(v);return k?(y=y.map(N=>this.f.reduce((O,K)=>K.processArgument(O,k.extension?.identifier),N)),this.h(v,y,!0)):Promise.reject(new Error(`Contributed command '${v}' does not exist.`))}getCommands(v=!1){return this.d.trace("ExtHostCommands#getCommands",v),this.#e.$getCommands().then(y=>(v&&(y=y.filter(k=>k[0]!=="_")),y))}$getContributedCommandMetadata(){const v=Object.create(null);for(const[y,k]of this.b){const{metadata:N}=k;N&&(v[y]=N)}return Promise.resolve(v)}};e.$dN=u,e.$dN=u=Ge([Ke(0,r.$UM),Ke(1,g.$kj),Ke(2,i.$cN)],u),e.$eN=(0,b.$3h)("IExtHostCommands");class d{constructor(v,y,k){this.d=v,this.f=y,this.g=k,this.delegatingCommandId=`__vsc${(0,s.$ng)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(v,y){if(!v)return;const k={$ident:void 0,id:v.command,title:v.title,tooltip:v.tooltip};if(!v.command)return k;const N=this.f(v.command);if(N)k.id=N.internalId,k.arguments=N.args.map((O,K)=>O.convert(v.arguments&&v.arguments[K]));else if((0,$.$Lb)(v.arguments)){const O=`${v.command} /${++this.c}`;this.b.set(O,v),y.add((0,p.$Qc)(()=>{this.b.delete(O),this.g.trace("CommandsConverter#DISPOSE",O)})),k.$ident=O,k.id=this.delegatingCommandId,k.arguments=[O],this.g.trace("CommandsConverter#CREATE",v.command,O)}return k}fromInternal(v){return typeof v.$ident=="string"?this.b.get(v.$ident):{command:v.id,title:v.title,arguments:v.arguments}}getActualCommand(...v){return this.b.get(v[0])}h(...v){const y=this.getActualCommand(...v);return this.g.trace("CommandsConverter#EXECUTE",v[0],y?y.command:"MISSING"),y?this.d.executeCommand(y.command,...y.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${v[0]}`)}}e.$fN=d;class m{static{this.Uri=new m("uri","Uri of a text document",v=>l.URI.isUri(v),v=>v)}static{this.Position=new m("position","A position in a text document",v=>T.$TK.isPosition(v),I.Position.from)}static{this.Range=new m("range","A range in a text document",v=>T.$UK.isRange(v),I.Range.from)}static{this.Selection=new m("selection","A selection in a text document",v=>T.$VK.isSelection(v),I.Selection.from)}static{this.Number=new m("number","",v=>typeof v=="number",v=>v)}static{this.String=new m("string","",v=>typeof v=="string",v=>v)}static{this.StringArray=m.Arr(m.String)}static Arr(v){return new m(`${v.name}_array`,`Array of ${v.name}, ${v.description}`,y=>Array.isArray(y)&&y.every(k=>v.validate(k)),y=>y.map(k=>v.convert(k)))}static{this.CallHierarchyItem=new m("item","A call hierarchy item",v=>v instanceof T.$dL,I.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new m("item","A type hierarchy item",v=>v instanceof T.$xM,I.TypeHierarchyItem.from)}static{this.TestItem=new m("testItem","A VS Code TestItem",v=>v instanceof o.$8M,I.TestItem.from)}constructor(v,y,k,N){this.name=v,this.description=y,this.validate=k,this.convert=N}optional(){return new m(this.name,`(optional) ${this.description}`,v=>v==null||this.validate(v),v=>v===void 0?void 0:v===null?null:this.convert(v))}with(v,y){return new m(v??this.name,y??this.description,this.validate,this.convert)}}e.$gN=m;class f{static{this.Void=new f("no result",v=>v)}constructor(v,y){this.description=v,this.convert=y}}e.$hN=f;class S{constructor(v,y,k,N,O){this.id=v,this.internalId=y,this.description=k,this.args=N,this.result=O}}e.$iN=S}),define(Ce[239],Re([1,0,18,12,2,80,96,35,32,8,7]),function(ge,e,E,T,I,F,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=void 0;const D=[new g.$iN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$gN.Uri,g.$gN.Position],new g.$hN("A promise that resolves to an array of DocumentHighlight-instances.",p(w.DocumentHighlight.to))),new g.$iN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$gN.Uri],new g.$hN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if((0,E.$Kb)(r))return;class t extends A.$$K{static to(a){const c=new t(a.name,w.SymbolKind.to(a.kind),a.containerName||"",new A.$5K(o[0],w.Range.to(a.range)));return c.detail=a.detail,c.range=c.location.range,c.selectionRange=w.Range.to(a.selectionRange),c.children=a.children?a.children.map(t.to):[],c}}return r.map(t.to)})),new g.$iN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$gN.Uri,new g.$gN("options","Formatting options",r=>!0,r=>r)],new g.$hN("A promise that resolves to an array of TextEdits.",p(w.TextEdit.to))),new g.$iN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$gN.Uri,g.$gN.Range,new g.$gN("options","Formatting options",r=>!0,r=>r)],new g.$hN("A promise that resolves to an array of TextEdits.",p(w.TextEdit.to))),new g.$iN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$gN.Uri,g.$gN.Position,new g.$gN("ch","Trigger character",r=>typeof r=="string",r=>r),new g.$gN("options","Formatting options",r=>!0,r=>r)],new g.$hN("A promise that resolves to an array of TextEdits.",p(w.TextEdit.to))),new g.$iN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$gN.Uri,g.$gN.Position],new g.$hN("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.$iN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$gN.Uri,g.$gN.Position],new g.$hN("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.$iN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$gN.Uri,g.$gN.Position],new g.$hN("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.$iN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$gN.Uri,g.$gN.Position],new g.$hN("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.$iN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$gN.Uri,g.$gN.Position],new g.$hN("A promise that resolves to an array of Location-instances.",p(w.location.to))),new g.$iN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$gN.Uri,g.$gN.Position],new g.$hN("A promise that resolves to an array of Hover-instances.",p(w.Hover.to))),new g.$iN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$gN.Uri,new g.$gN("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>A.$TK.isPosition(o)),r=>r.map(w.Position.from))],new g.$hN("A promise that resolves to an array of ranges.",r=>r.map(o=>{let t;for(const n of o.reverse())t=new A.$cL(w.Range.to(n),t);return t}))),new g.$iN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$gN.String.with("query","Search string")],new g.$hN("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(w.WorkspaceSymbol.to))),new g.$iN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$gN.Uri,g.$gN.Position],new g.$hN("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(w.CallHierarchyItem.to))),new g.$iN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$gN.CallHierarchyItem],new g.$hN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(w.CallHierarchyIncomingCall.to))),new g.$iN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$gN.CallHierarchyItem],new g.$hN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(w.CallHierarchyOutgoingCall.to))),new g.$iN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$gN.Uri,g.$gN.Position],new g.$hN("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:w.Range.to(r.range),placeholder:r.text}})),new g.$iN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$gN.Uri,g.$gN.Position,g.$gN.String.with("newName","The new symbol name")],new g.$hN("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return w.WorkspaceEdit.to(r)}})),new g.$iN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$gN.Uri,g.$gN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$hN("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(w.DocumentLink.to))),new g.$iN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$gN.Uri],new g.$hN("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new A.$9L(r.tokenTypes,r.tokenModifiers)})),new g.$iN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$gN.Uri],new g.$hN("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,R.$k$)(r);if(o.type==="full")return new A.$$L(o.data,void 0)})),new g.$iN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$gN.Uri,g.$gN.Range.optional()],new g.$hN("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new A.$9L(r.tokenTypes,r.tokenModifiers)})),new g.$iN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$gN.Uri,g.$gN.Range],new g.$hN("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,R.$k$)(r);if(o.type==="full")return new A.$$L(o.data,void 0)})),new g.$iN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$gN.Uri,g.$gN.Position,g.$gN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$gN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$hN("A promise that resolves to a CompletionList-instance.",(r,o,t)=>{if(!r)return new A.$oL([]);const n=r.suggestions.map(a=>w.CompletionItem.to(a,t));return new A.$oL(n,r.incomplete)})),new g.$iN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$gN.Uri,g.$gN.Position,g.$gN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$hN("A promise that resolves to SignatureHelp.",r=>{if(r)return w.SignatureHelp.to(r)})),new g.$iN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$gN.Uri,g.$gN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$hN("A promise that resolves to an array of CodeLens-instances.",(r,o,t)=>p(n=>new A.$gL(w.Range.to(n.range),n.command&&t.fromInternal(n.command)))(r))),new g.$iN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$gN.Uri,new g.$gN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>A.$UK.isRange(r),r=>A.$VK.isSelection(r)?w.Selection.from(r):w.Range.from(r)),g.$gN.String.with("kind","Code action kind to return code actions for").optional(),g.$gN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$hN("A promise that resolves to an array of Command-instances.",(r,o,t)=>p(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return t.fromInternal(n.command)}else{const a=new A.$aL(n.title,n.kind?new A.$bL(n.kind):void 0);return n.edit&&(a.edit=w.WorkspaceEdit.to(n.edit)),n.command&&(a.command=t.fromInternal(n.command)),a.isPreferred=n.isPreferred,a}})(r))),new g.$iN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$gN.Uri],new g.$hN("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new A.$uL(w.Range.to(o.range),w.Color.to(o.color))):[])),new g.$iN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$gN("color","The color to show and insert",r=>r instanceof A.$tL,w.Color.from),new g.$gN("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:w.Range.from(r.range)}))],new g.$hN("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(w.ColorPresentation.to):[])),new g.$iN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$gN.Uri,g.$gN.Range],new g.$hN("A promise that resolves to an array of Inlay objects",(r,o,t)=>r.map(w.InlayHint.to.bind(void 0,t)))),new g.$iN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$gN.Uri],new g.$hN("A promise that resolves to an array of FoldingRange objects",(r,o)=>{if(r)return r.map(w.FoldingRange.to)})),new g.$iN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$hN("A promise that resolves to an array of NotebookContentProvider static info objects.",p(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>w.NotebookExclusiveDocumentPattern.to(o))})))),new g.$iN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$gN.Uri,g.$gN.Range,new g.$gN("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof A.$UK,r=>w.InlineValueContext.from(r))],new g.$hN("A promise that resolves to an array of InlineValue objects",r=>r.map(w.InlineValue.to))),new g.$iN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$gN("uriOrString","Uri-instance or string (only http/https)",r=>I.URI.isUri(r)||typeof r=="string"&&(0,T.$cg)(r,T.Schemas.http,T.Schemas.https),r=>r),new g.$gN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[w.ViewColumn.from(r),void 0]:[w.ViewColumn.from(r.viewColumn),w.TextEditorOpenOptions.from(r)])).optional(),g.$gN.String.with("label","").optional()],g.$hN.Void),new g.$iN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$gN.Uri.with("resource","Resource to open"),g.$gN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$gN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[w.ViewColumn.from(r),void 0]:[w.ViewColumn.from(r.viewColumn),w.TextEditorOpenOptions.from(r)])).optional()],g.$hN.Void),new g.$iN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$gN.Uri.with("left","Left-hand side resource of the diff editor"),g.$gN.Uri.with("right","Right-hand side resource of the diff editor"),g.$gN.String.with("title","Human readable title for the diff editor").optional(),new g.$gN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[w.ViewColumn.from(r.viewColumn),w.TextEditorOpenOptions.from(r)]).optional()],g.$hN.Void),new g.$iN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[g.$gN.String.with("title","Human readable title for the changes editor"),new g.$gN("resourceList","List of resources to compare",r=>{for(const o of r){if(o.length!==3)return!1;const[t,n,a]=o;if(!I.URI.isUri(t)||!I.URI.isUri(n)&&n!==void 0&&n!==null||!I.URI.isUri(a)&&a!==void 0&&a!==null)return!1}return!0},r=>r)],g.$hN.Void),new g.$iN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$gN.Uri,g.$gN.Position],new g.$hN("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(w.TypeHierarchyItem.to))),new g.$iN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$gN.TypeHierarchyItem],new g.$hN("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(w.TypeHierarchyItem.to))),new g.$iN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$gN.TypeHierarchyItem],new g.$hN("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(w.TypeHierarchyItem.to))),new g.$iN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$gN.TestItem],g.$hN.Void),new g.$iN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$gN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$hN.Void),new g.$iN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$gN.String.with("name","The context key name"),new g.$gN("value","The context key value",()=>!0,r=>r)],g.$hN.Void),new g.$iN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$gN.Uri,g.$gN.StringArray,new g.$gN("MappedEditsContext","Mapped Edits Context",r=>w.MappedEditsContext.is(r),r=>w.MappedEditsContext.from(r))],new g.$hN("A promise that resolves to a workspace edit or null",r=>r?w.WorkspaceEdit.to(r):null))];class l{static register(o){D.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",$.$2i)}}e.$ofc=l;function p(r){return o=>{if(Array.isArray(o))return o.map(r)}}function b(r){if(!Array.isArray(r))return;const o=[];for(const t of r)F.$ut(t)?o.push(w.DefinitionLink.to(t)):o.push(w.location.to(t));return o}}),define(Ce[240],Re([1,0,13,66,5,6,2,80,22,8,7,3,23]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yfc=void 0;function p(b,r,o){const t=b.getProxy(D.$QK.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new g.$km,r.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const S=this.b.get(f.handle);return S?S.value:f}else if(f&&f.$mid===7){const S=this.b.get(f.commentControlHandle);if(!S)return f;const L=S.getCommentThread(f.commentThreadHandle);return L?L.value:f}else if(f&&(f.$mid===9||f.$mid===8)){const S=this.b.get(f.thread.commentControlHandle);if(!S)return f;const L=S.getCommentThread(f.thread.commentThreadHandle);return L?f.$mid===8?L.value:{thread:L.value,text:f.text}:f}else if(f&&f.$mid===10){const S=this.b.get(f.thread.commentControlHandle);if(!S)return f;const L=S.getCommentThread(f.thread.commentThreadHandle);if(!L)return f;const v=f.commentUniqueId,y=L.getCommentByUniqueId(v);return y||f}else if(f&&f.$mid===11){const S=this.b.get(f.thread.commentControlHandle);if(!S)return f;const L=S.getCommentThread(f.thread.commentThreadHandle);if(!L)return f;const v=f.text,y=f.commentUniqueId,k=L.getCommentByUniqueId(y);return k?(typeof k.body=="string"?k.body=v:k.body=new A.$hL(v),k):f}return f}})}createCommentController(f,S,L){const v=n.a++,y=new c(f,v,S,L);this.b.set(y.handle,y);const k=this.c.get(f.identifier)||[];return k.push(y),this.c.set(f.identifier,k),y.value}async $createCommentThreadTemplate(f,S,L){const v=this.b.get(f);v&&v.$createCommentThreadTemplate(S,L)}async $updateCommentThreadTemplate(f,S,L){const v=this.b.get(f);v&&v.$updateCommentThreadTemplate(S,L)}$deleteCommentThread(f,S){this.b.get(f)?.$deleteCommentThread(S)}$provideCommentingRanges(f,S,L){const v=this.b.get(f);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const y=o.getDocument(R.URI.revive(S));return(0,E.$Vg)(async()=>{const k=await v.commentingRangeProvider.provideCommentingRanges(y,L);let N;return Array.isArray(k)?N={ranges:k,fileComments:!1}:k?N={ranges:k.ranges||[],fileComments:k.fileComments||!1}:N=k??void 0,N}).then(k=>{let N;return k&&(N={ranges:k.ranges.map(O=>w.Range.from(O)),fileComments:k.fileComments}),N})}$toggleReaction(f,S,L,v,y){const k=this.b.get(f);return!k||!k.reactionHandler?Promise.resolve(void 0):(0,E.$Vg)(()=>{const N=k.getCommentThread(S);if(N){const O=N.getCommentByUniqueId(v.uniqueIdInThread);if(k!==void 0&&O&&k.reactionHandler)return k.reactionHandler(O,s(y))}return Promise.resolve(void 0)})}}class a{static{this.a=0}set threadId(f){this.n=f}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(f){(f===void 0!=(this.p===void 0)||!f||!this.p||!f.isEqual(this.p))&&(this.p=f,this.b.range=f,this.c.fire())}get range(){return this.p}set canReply(f){this.d!==f&&(this.d=f,this.b.canReply=f,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(f){this.e=f,this.b.label=f,this.c.fire()}get contextValue(){return this.f}set contextValue(f){this.f=f,this.b.contextValue=f,this.c.fire()}get comments(){return this.q}set comments(f){this.q=f,this.b.comments=f,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(f){this.g=f,this.b.collapsibleState=f,this.c.fire()}get state(){return this.h}set state(f){this.h=f,this.b.state=f,this.c.fire()}get isDisposed(){return this.j}constructor(f,S,L,v,y,k,N,O){this.m=S,this.n=L,this.o=v,this.p=y,this.q=k,this.extensionDescription=N,this.r=O,this.handle=a.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.$Sd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new F.$Tc,this.l.value=new F.$Rc,this.n===void 0&&(this.n=`${f}.${this.handle}`),t.$createCommentThread(S,this.handle,this.n,this.o,w.Range.from(this.p),N.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=k,this.i.push({dispose:()=>{t.$deleteCommentThread(S,this.handle)}});const K=this;this.value={get uri(){return K.uri},get range(){return K.range},set range(j){K.range=j},get comments(){return K.comments},set comments(j){K.comments=j},get collapsibleState(){return K.collapsibleState},set collapsibleState(j){K.collapsibleState=j},get canReply(){return K.canReply},set canReply(j){K.canReply=j},get contextValue(){return K.contextValue},set contextValue(j){K.contextValue=j},get label(){return K.label},set label(j){K.label=j},get state(){return K.state},set state(j){K.state=j},dispose:()=>{K.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new F.$Rc);const f=L=>Object.prototype.hasOwnProperty.call(this.b,L),S={};f("range")&&(S.range=w.Range.from(this.p)),f("label")&&(S.label=this.label),f("contextValue")&&(S.contextValue=this.contextValue??null),f("comments")&&(S.comments=this.q.map(L=>h(this,L,this.k,this.extensionDescription))),f("collapsibleState")&&(S.collapseState=u(this.g)),f("canReply")&&(S.canReply=this.canReply),f("state")&&(S.state=d(this.h)),f("isTemplate")&&(S.isTemplate=this.r),this.b={},t.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(f){for(const S of this.k){const L=S[0],v=S[1];if(f===v)return L}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(f=>f.dispose())}}Ge([(0,T.$vh)(100)],a.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(f){this.b=f,t.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(f){this.c=f,t.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this.d}set options(f){this.d=f,t.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(f,S,L,v){this.f=f,this.g=S,this.h=L,this.i=v,this.a=new Map,t.$registerCommentController(this.handle,L,v,this.f.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(k){y.options=k},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(k){y.commentingRangeProvider=k},get reactionHandler(){return y.reactionHandler},set reactionHandler(k){y.reactionHandler=k},createCommentThread(k,N,O){return y.createCommentThread(k,N,O).value},dispose:()=>{y.dispose()}}),this.e=[],this.e.push({dispose:()=>{t.$unregisterCommentController(this.handle)}})}createCommentThread(f,S,L){S===void 0&&(0,l.$pF)(this.f,"fileComments");const v=new a(this.id,this.handle,void 0,f,S,L,this.f,!1);return this.a.set(v.handle,v),v}$createCommentThreadTemplate(f,S){const L=new a(this.id,this.handle,void 0,R.URI.revive(f),w.Range.to(S),[],this.f,!0);return L.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(L.handle,L),L}$updateCommentThreadTemplate(f,S){const L=this.a.get(f);L&&(L.range=w.Range.to(S))}$deleteCommentThread(f){this.a.get(f)?.dispose(),this.a.delete(f)}getCommentThread(f){return this.a.get(f)}dispose(){this.a.forEach(f=>{f.dispose()}),this.e.forEach(f=>f.dispose())}}function h(m,f,S,L){let v=S.get(f);return v||(v=++m.commentHandle,S.set(f,v)),f.state!==void 0&&(0,l.$pF)(L,"commentsDraftState"),f.reactions?.some(y=>y.reactors!==void 0)&&(0,l.$pF)(L,"commentReactor"),{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:v,body:typeof f.body=="string"?f.body:w.MarkdownString.from(f.body),userName:f.author.name,userIconPath:f.author.iconPath,label:f.label,commentReactions:f.reactions?f.reactions.map(y=>i(y)):void 0,state:f.state,timestamp:f.timestamp?.toJSON()}}function i(m){return{label:m.label,iconPath:m.iconPath?w.$TM(m.iconPath):void 0,count:m.count,hasReacted:m.authorHasReacted,reactors:m.reactors}}function s(m){return{label:m.label||"",count:m.count||0,iconPath:m.iconPath?R.URI.revive(m.iconPath):"",authorHasReacted:m.hasReacted||!1,reactors:m.reactors}}function u(m){if(m!==void 0)switch(m){case A.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function d(m){if(m!==void 0)switch(m){case A.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}return new n}e.$yfc=p}),define(Ce[241],Re([1,0,26,3,27,17]),function(ge,e,E,T,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=void 0;let R=class{constructor(A,D){this.a=A.getProxy(T.$QK.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,D){const l=this,p=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){l.e(A,D,p,arguments)}})}e(A,D,l,p){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:g(p,this.b)}),this.c&&this.f(A,l,p)}};e.$mhc=R,e.$mhc=R=Ge([Ke(0,F.$UM),Ke(1,I.$$M)],R);const $=1e5;function g(w,A){const D=[];if(w.length)for(let l=0;l<w.length;l++){let p=w[l];if(typeof p>"u")p="undefined";else if(p instanceof Error){const b=p;b.stack?p=b.stack:p=b.toString()}D.push(p)}if(A){const l=new Error().stack;l&&D.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,E.$on)(D);return l.length>$?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Ce[110],Re([1,0,2,3,7,4,17,14,18,11,19,23]),function(ge,e,E,T,I,F,R,$,g,w,A,D){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=e.$ogc=void 0;let p=class{static{l=this}static{this.c=0}static{this.d=250}constructor(r,o){this.h=o,this.f=new Map,this.g=r.getProxy(T.$QK.MainThreadDecorations)}registerFileDecorationProvider(r,o){const t=l.c++;this.f.set(t,{provider:r,extensionDescription:o}),this.g.$registerDecorationProvider(t,o.identifier.value);const n=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(a=>{if(!a){this.g.$onDidChange(t,null);return}const c=(0,g.$3b)(a);if(c.length<=l.d){this.g.$onDidChange(t,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,c.length);const h=c.map(u=>({uri:u,rank:(0,w.$Me)(u.path,"/")})),i=(0,g.$zb)(h,(u,d)=>u.rank-d.rank||(0,w.$2e)(u.uri.path,d.uri.path)),s=[];e:for(const u of i){let d;for(const m of u){const f=(0,A.$mc)(m.uri.path);if(d!==f&&(d=f,s.push(m.uri)>=l.d))break e}}this.g.$onDidChange(t,s)});return new I.$SK(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(t),this.f.delete(t)})}async $provideDecorations(r,o,t){if(!this.f.has(r))return Object.create(null);const n=Object.create(null),{provider:a,extensionDescription:c}=this.f.get(r);return await Promise.all(o.map(async h=>{try{const{uri:i,id:s}=h,u=await Promise.resolve(a.provideFileDecoration(E.URI.revive(i),t));if(!u)return;try{I.$cM.validate(u),u.badge&&typeof u.badge!="string"&&(0,D.$pF)(c,"codiconDecoration"),n[s]=[u.propagate,u.tooltip,u.badge,u.color]}catch(d){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${d}`)}}catch(i){this.h.error(i)}})),n}};e.$ogc=p,e.$ogc=p=l=Ge([Ke(0,R.$UM),Ke(1,$.$kj)],p),e.$pgc=(0,F.$3h)("IExtHostDecorations")}),define(Ce[242],Re([1,0,158,99,2,3,7,8,5,14,28,43]),function(ge,e,E,T,I,F,R,$,g,w,A,D){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=e.$ifc=void 0;class p{#e;#t;#i;constructor(o,t,n,a,c,h,i,s){this.d=o,this.e=t,this.f=n,this.g=a,this.h=c,this.c=!1,this.f=Math.max(a,n),this.#i=new A.$Ac(u=>h.getComparisonKey(u)),this.#e=i,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,t){if(!o){this.clear();return}this.j();let n=[];if(I.URI.isUri(o)){if(!t){this.delete(o);return}this.#i.set(o,t.slice()),n=[o]}else if(Array.isArray(o)){n=[];let h;o=[...o].sort(p.k);for(const i of o){const[s,u]=i;if((!h||s.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=s,n.push(s),this.#i.set(s,[])),u)this.#i.get(s)?.push(...u);else{const d=this.#i.get(s);d&&(d.length=0)}}}if(this.#t.fire(n),!this.#e)return;const a=[];let c=0;for(const h of n){let i=[];const s=this.#i.get(h);if(s)if(s.length>this.g){i=[];const u=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(const m of s)if(m.severity===u[d]&&i.push({...$.Diagnostic.from(m),modelVersionId:this.h(h)})===this.g)break e;i.push({severity:T.MarkerSeverity.Info,message:(0,E.localize)(0,null,s.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=s.map(u=>({...$.Diagnostic.from(u),modelVersionId:this.h(h)}));if(a.push([h,i]),c+=i.length,c>this.f)break}this.#e.$changeMany(this.e,a)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,t){this.j();for(const[n,a]of this)o.call(t,n,a,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const t=this.#i.get(o);return Array.isArray(t)?Object.freeze(t.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,t){return o[0].toString()<t[0].toString()?-1:o[0].toString()>t[0].toString()?1:0}}e.$ifc=p;let b=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(o){const t=new A.$Ac;for(const n of o)t.set(n,n);return{uris:Object.freeze(Array.from(t.values()))}}constructor(o,t,n,a){this.j=t,this.k=n,this.l=a,this.g=new Map,this.h=new g.$Wd({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=g.Event.map(this.h.event,l._mapper),this.f=o.getProxy(F.$QK.MainThreadDiagnostics)}createDiagnosticCollection(o,t){const{g:n,f:a,h:c,j:h,k:i,l:s}=this,u=new class{$changeMany(f,S){a.$changeMany(f,S),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,f,S.length===0?"CLEARING":S)}$clear(f){a.$clear(f),h.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,f)}dispose(){a.dispose()}};let d;if(!t)t="_generated_diagnostic_collection_name_#"+l.c++,d=t;else if(!n.has(t))d=t;else{this.j.warn(`DiagnosticCollection with name '${t}' does already exist.`);do d=t+l.c++;while(n.has(d))}return new class extends p{constructor(){super(t,d,l.e,l.d,f=>s.getDocument(f)?.version,i.extUri,u,c),n.set(d,this)}dispose(){super.dispose(),n.delete(d)}}}getDiagnostics(o){if(o)return this.m(o);{const t=new Map,n=[];for(const a of this.g.values())a.forEach((c,h)=>{let i=t.get(c.toString());typeof i>"u"&&(i=n.length,t.set(c.toString(),i),n.push([c,[]])),n[i][1]=n[i][1].concat(...h)});return n}}m(o){let t=[];for(const n of this.g.values())n.has(o)&&(t=t.concat(n.get(o)));return t}$acceptMarkersChange(o){if(!this.n){const t="_generated_mirror",n=new p(t,t,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,a=>{},this.k.extUri,void 0,this.h);this.g.set(t,n),this.n=n}for(const[t,n]of o)this.n.set(I.URI.revive(t),n.map($.Diagnostic.to))}};e.$jfc=b,e.$jfc=b=l=Ge([Ke(1,w.$kj),Ke(2,D.$hfc)],b)}),define(Ce[243],Re([1,0,2,3,23]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=void 0;class F{constructor($){this.a=$.getProxy(T.$QK.MainThreadDialogs)}showOpenDialog($,g){return g?.allowUIResources&&(0,I.$pF)($,"showLocal"),this.a.$showOpenDialog(g).then(w=>w?w.map(A=>E.URI.revive(A)):void 0)}showSaveDialog($){return this.a.$showSaveDialog($).then(g=>g?E.URI.revive(g):void 0)}}e.$qgc=F}),define(Ce[244],Re([1,0,15,2,7,3,12,20,11]),function(ge,e,E,T,I,F,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0;class w{static{this.a=0}constructor(D,l,p){this.d=l,this.e=p,this.b=new Map,this.c=D.getProxy(F.$QK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,l){if(Object.keys(R.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const p=w.a++;this.b.set(p,l),this.c.$registerTextContentProvider(p,D);let b;if(typeof l.onDidChange=="function"){let r;b=l.onDidChange(async o=>{if(o.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;r&&await r;const t=this.$provideTextDocumentContent(p,o).then(async n=>{if(!n&&typeof n!="string")return;const a=this.d.getDocument(o);if(!a)return;const c=(0,g.$We)(n);if(!a.equalLines(c))return this.c.$onVirtualDocumentChange(o,n)}).catch(E.$1).finally(()=>{r===t&&(r=void 0)});r=t})}return new I.$SK(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),b&&(b.dispose(),b=void 0)})}$provideTextDocumentContent(D,l){const p=this.b.get(D);return p?Promise.resolve(p.provideTextDocumentContent(T.URI.revive(l),$.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$rgc=w}),define(Ce[245],Re([1,0,5,6,2,3,103,8,16,26,7]),function(ge,e,E,T,I,F,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=void 0;class D{constructor(p,b){this.a=new E.$Sd,this.b=new E.$Sd,this.c=new E.$Sd,this.d=new E.$Sd,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Rc,this.h=new Map,this.f=p.getProxy(F.$QK.MainThreadDocuments),this.g=b,this.g.onDidRemoveDocuments(r=>{for(const o of r)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const o of r)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(p){if(!p)return;const b=this.g.getDocument(p);if(b)return b}getDocument(p){const b=this.getDocumentData(p);if(!b?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return b.document}ensureDocumentData(p){const b=this.g.getDocument(p);if(b)return Promise.resolve(b);let r=this.h.get(p.toString());return r||(r=this.f.$tryOpenDocument(p).then(o=>{this.h.delete(p.toString());const t=I.URI.revive(o);return(0,g.$Qf)(this.g.getDocument(t))},o=>(this.h.delete(p.toString()),Promise.reject(o))),this.h.set(p.toString(),r)),r}createDocumentData(p){return this.f.$tryCreateDocument(p).then(b=>I.URI.revive(b))}$acceptModelLanguageChanged(p,b){const r=I.URI.revive(p),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(b),this.a.fire(o.document)}$acceptModelSaved(p){const b=I.URI.revive(p),r=this.g.getDocument(b);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(p,b){const r=I.URI.revive(p),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(b),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,b,r){const o=I.URI.revive(p),t=this.g.getDocument(o);if(!t)throw new Error("unknown document");t._acceptIsDirty(r),t.onEvents(b);let n;b.isUndoing?n=A.TextDocumentChangeReason.Undo:b.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,w.$kn)({document:t.document,contentChanges:b.changes.map(a=>({range:$.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:n}))}setWordDefinitionFor(p,b){(0,R.$WM)(p,b)}}e.$ffc=D}),define(Ce[61],Re([1,0,53,5,6,2,4,3,103,17,109,8,14,28,12,67,39]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l,p,b,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6M=e.$5M=void 0;class t{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(c,h){this.h=c,this.i=h,this.a=null,this.b=new Map,this.c=new p.$Ac,this.d=new T.$Sd,this.e=new T.$Sd,this.f=new T.$Sd,this.g=new T.$Sd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const h=[],i=[],s=[];if(c.removedDocuments)for(const u of c.removedDocuments){const d=F.URI.revive(u),m=this.c.get(d);m?.unref()&&(this.c.delete(d),h.push(m.value))}if(c.addedDocuments)for(const u of c.addedDocuments){const d=F.URI.revive(u.uri);let m=this.c.get(d);if(m&&d.scheme!==b.Schemas.vscodeNotebookCell&&d.scheme!==b.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);m||(m=new t(new g.$XM(this.h.getProxy($.$QK.MainThreadDocuments),d,u.lines,u.EOL,u.versionId,u.languageId,u.isDirty,u.notebook)),this.c.set(d,m),i.push(m.value)),m.ref()}if(c.removedEditors)for(const u of c.removedEditors){const d=this.b.get(u);this.b.delete(u),d&&s.push(d)}if(c.addedEditors)for(const u of c.addedEditors){const d=F.URI.revive(u.documentUri);E.ok(this.c.has(d),`document '${d}' does not exist`),E.ok(!this.b.has(u.id),`editor '${u.id}' already exists!`);const m=this.c.get(d).value,f=new A.$4M(u.id,this.h.getProxy($.$QK.MainThreadTextEditors),this.i,new o.$V(()=>m.document),u.selections.map(D.Selection.to),u.options,u.visibleRanges.map(S=>D.Range.to(S)),typeof u.editorPosition=="number"?D.ViewColumn.to(u.editorPosition):void 0);this.b.set(u.id,f)}c.newActiveEditor!==void 0&&(E.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,I.$Nc)(h),(0,I.$Nc)(s),c.removedDocuments&&this.e.fire(h),c.addedDocuments&&this.d.fire(i),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(u=>u.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return r.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const h=this.b.get(this.a);return c?h:h?.value}allEditors(){return[...this.b.values()]}};e.$5M=n,e.$5M=n=Ge([Ke(0,w.$UM),Ke(1,l.$kj)],n),e.$6M=(0,R.$3h)("IExtHostDocumentsAndEditors")}),define(Ce[62],Re([1,0,246,5,16,2,4,3,17,8,7]),function(ge,e,E,T,I,F,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfc=e.$Rfc=void 0,e.$Rfc=(0,R.$3h)("IExtHostEditorTabs");class D{constructor(o,t,n){this.e=n,this.d=t,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,t={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(t)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$yM(F.URI.revive(this.b.input.uri));case 2:return new A.$zM(F.URI.revive(this.b.input.original),F.URI.revive(this.b.input.modified));case 3:return new A.$AM(F.URI.revive(this.b.input.base),F.URI.revive(this.b.input.input1),F.URI.revive(this.b.input.input2),F.URI.revive(this.b.input.result));case 6:return new A.$BM(F.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$CM(this.b.input.viewType);case 4:return new A.$DM(F.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$EM(F.URI.revive(this.b.input.original),F.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$FM;case 9:return new A.$GM(F.URI.revive(this.b.input.uri),F.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$HM(this.b.input.providerId);default:return}}}class l{constructor(o,t){this.c=[],this.d="",this.b=o,this.e=t;for(const n of o.tabs)n.isActive&&(this.d=n.id),this.c.push(new D(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,t={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return w.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(n=>n.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(n=>n.apiObject))}};this.a=Object.freeze(t)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const n=new D(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,n),o.tabDto.isActive&&(this.d=n.tabId),n}else if(o.kind===1){const n=this.c.splice(o.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(o.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,n),n}const t=this.c.find(n=>n.tabId===o.tabDto.id);if(!t)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),t.acceptDtoUpdate(o.tabDto),t}activeTabId(){return this.d}}let p=class{constructor(o){this.b=new T.$Sd,this.c=new T.$Sd,this.e=[],this.a=o.getProxy($.$QK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,t={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(n=>n.apiObject))},get activeTabGroup(){const n=o.d;return(0,I.$Qf)(o.e.find(c=>c.groupId===n)?.apiObject)},close:async(n,a)=>{const c=Array.isArray(n)?n:[n];return c.length?b(c[0])?this.j(c,a):this.i(c,a):!0}};this.f=Object.freeze(t)}return this.f}$acceptEditorTabModel(o){const t=new Set(this.e.map(u=>u.groupId)),n=new Set(o.map(u=>u.groupId)),a=(0,E.$L)(t,n),c=this.e.filter(u=>a.removed.includes(u.groupId)).map(u=>u.apiObject),h=[],i=[];this.e=o.map(u=>{const d=new l(u,()=>this.d);return a.added.includes(d.groupId)?h.push(d.apiObject):i.push(d.apiObject),d});const s=(0,I.$Qf)(o.find(u=>u.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:h,closed:c,changed:i}))}$acceptTabGroupUpdate(o){const t=this.e.find(n=>n.groupId===o.groupId);if(!t)throw new Error("Update Group IPC call received before group creation.");t.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[t.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const t=this.e.find(a=>a.groupId===o.groupId);if(!t)throw new Error("Update Tabs IPC call received before group creation.");const n=t.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(o){for(const t of this.e)for(const n of t.tabs)if(n.apiObject===o)return n}h(o){return this.e.find(t=>t.apiObject===o)}async i(o,t){const n=[];for(const a of o){const c=this.g(a);if(!c)throw new Error("Tab close: Invalid tab not found!");n.push(c.tabId)}return this.a.$closeTab(n,t)}async j(o,t){const n=[];for(const a of o){const c=this.h(a);if(!c)throw new Error("Group close: Invalid group not found!");n.push(c.groupId)}return this.a.$closeGroup(n,t)}};e.$Sfc=p,e.$Sfc=p=Ge([Ke(0,g.$UM)],p);function b(r){return r.tabs!==void 0}}),define(Ce[247],Re([1,0,3,7]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=void 0;class I{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(E.$QK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,$,g){if(this.a.size===0)throw new Error("No embedding vector providers registered");const w=this.a.get(R);if(!w)throw new Error("Embedding vector provider not found");const A=await w.provideEmbeddingVector($,g);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,$,g){const w=this.b;return this.b++,this.a.set(w,g),this.c.$registerAiEmbeddingVectorProvider($,w),new T.$SK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(w),this.a.delete(w)})}}e.$tgc=I}),define(Ce[248],Re([1,0,2,3,6,7,8,296,11,24,23,52]),function(ge,e,E,T,I,F,R,$,g,w,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=void 0;class l{constructor(){this.a=[]}add(r){this.b=void 0,this.a.push(r)}delete(r){const o=this.a.indexOf(r);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const r=this.a.sort(),o=[];let t,n,a=14,c=14;for(const h of r){let i=t?(0,g.$$e)(t,h):0;for(i===0?n=1:n=c;i<h.length;i++)i+1===h.length?(a=c,c=9):c+=1,o.push([n,h.toUpperCase().charCodeAt(i),c]),o.push([n,h.toLowerCase().charCodeAt(i),c]),n=c;t=h,c=a}o.push([9,58,10]),o.push([10,47,12]),this.b=new $.$oZ(o)}}provideDocumentLinks(r){this.c();const o=[],t=$.$pZ.computeLinks({getLineContent(n){return r.lineAt(n-1).text},getLineCount(){return r.lineCount}},this.b);for(const n of t){const a=R.DocumentLink.to(n);a.target&&o.push(a)}return o}}class p{constructor(r,o){this.i=o,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=r.getProxy(T.$QK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(r,o,t,n={}){if(p.j(t),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(r,"*",this.b));const a=this.h++;this.b.add(o),this.d.add(o),this.c.set(a,t);let c=2;n.isCaseSensitive&&(c+=1024),n.isReadonly&&(c+=2048),typeof t.copy=="function"&&(c+=8),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,A.$pF)(r,"fsChunks"),c+=4);let h;n.isReadonly&&(0,D.$gk)(n.isReadonly)&&((0,A.$pF)(r,"readonlyMessage"),h={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(a,o,c,h).catch(s=>{console.error(`FAILED to register filesystem provider of ${r.identifier.value}-extension for the scheme ${o}`),console.error(s)});const i=t.onDidChangeFile(s=>{const u=[];for(const d of s){const{uri:m,type:f}=d;if(m.scheme!==o)continue;let S;switch(f){case F.FileChangeType.Changed:S=0;break;case F.FileChangeType.Created:S=1;break;case F.FileChangeType.Deleted:S=2;break;default:throw new Error("Unknown FileChangeType")}u.push({resource:m,type:S})}this.a.$onFileSystemChange(a,u)});return(0,I.$Qc)(()=>{i.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(a),this.a.$unregisterProvider(a)})}static j(r){if(!r)throw new Error("MISSING provider");if(typeof r.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof r.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof r.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof r.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof r.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof r.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof r.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof r.rename!="function")throw new Error("Provider does NOT implement rename")}static k(r){const{type:o,ctime:t,mtime:n,size:a,permissions:c}=r;return{type:o,ctime:t,mtime:n,size:a,permissions:c}}$stat(r,o){return Promise.resolve(this.l(r).stat(E.URI.revive(o))).then(t=>p.k(t))}$readdir(r,o){return Promise.resolve(this.l(r).readDirectory(E.URI.revive(o)))}$readFile(r,o){return Promise.resolve(this.l(r).readFile(E.URI.revive(o))).then(t=>w.$ge.wrap(t))}$writeFile(r,o,t,n){return Promise.resolve(this.l(r).writeFile(E.URI.revive(o),t.buffer,n))}$delete(r,o,t){return Promise.resolve(this.l(r).delete(E.URI.revive(o),t))}$rename(r,o,t,n){return Promise.resolve(this.l(r).rename(E.URI.revive(o),E.URI.revive(t),n))}$copy(r,o,t,n){const a=this.l(r);if(!a.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(a.copy(E.URI.revive(o),E.URI.revive(t),n))}$mkdir(r,o){return Promise.resolve(this.l(r).createDirectory(E.URI.revive(o)))}$watch(r,o,t,n){const a=this.l(r).watch(E.URI.revive(t),n);this.f.set(o,a)}$unwatch(r,o){const t=this.f.get(o);t&&(t.dispose(),this.f.delete(o))}$open(r,o,t){const n=this.l(r);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(E.URI.revive(o),t))}$close(r,o){const t=this.l(r);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(o))}$read(r,o,t,n){const a=this.l(r);if(!a.read)throw new Error('FileSystemProvider does not implement "read"');const c=w.$ge.alloc(n);return Promise.resolve(a.read(o,t,c.buffer,0,n)).then(h=>c.slice(0,h))}$write(r,o,t,n){const a=this.l(r);if(!a.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(a.write(o,t,n.buffer,0,n.byteLength))}l(r){const o=this.c.get(r);if(!o){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return o}}e.$ugc=p}),define(Ce[63],Re([1,0,3,42,7,24,4,17,43,6,13,25,12]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=e.$Gfc=void 0;let b=p=class{constructor(o,t){this.b=new Map,this.c=new A.$_g,this.a=o.getProxy(E.$QK.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(a){try{let c;const h=n.b.get(a.scheme);return h?(await n.a.$ensureActivation(a.scheme),c=await h.impl.stat(a)):c=await n.a.$stat(a),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===T.FilePermission.Readonly?1:void 0}}catch(c){p.e(c)}},async readDirectory(a){try{const c=n.b.get(a.scheme);return c?(await n.a.$ensureActivation(a.scheme),(await c.impl.readDirectory(a)).slice()):await n.a.$readdir(a)}catch(c){return p.e(c)}},async createDirectory(a){try{const c=n.b.get(a.scheme);return c&&!c.isReadonly?(await n.a.$ensureActivation(a.scheme),await n.d(c.impl,c.extUri,a)):await n.a.$mkdir(a)}catch(c){return p.e(c)}},async readFile(a){try{const c=n.b.get(a.scheme);return c?(await n.a.$ensureActivation(a.scheme),(await c.impl.readFile(a)).slice()):(await n.a.$readFile(a)).buffer}catch(c){return p.e(c)}},async writeFile(a,c){try{const h=n.b.get(a.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(a.scheme),await n.d(h.impl,h.extUri,h.extUri.dirname(a)),await n.c.queueFor(a).queue(()=>Promise.resolve(h.impl.writeFile(a,c,{create:!0,overwrite:!0})))):await n.a.$writeFile(a,F.$ge.wrap(c))}catch(h){return p.e(h)}},async delete(a,c){try{const h=n.b.get(a.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(a.scheme),await h.impl.delete(a,{recursive:!1,...c})):await n.a.$delete(a,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(h){return p.e(h)}},async rename(a,c,h){try{return await n.a.$rename(a,c,{overwrite:!1,...h})}catch(i){return p.e(i)}},async copy(a,c,h){try{return await n.a.$copy(a,c,{overwrite:!1,...h})}catch(i){return p.e(i)}},isWritableFileSystem(a){const c=t.getCapabilities(a);if(typeof c=="number")return!(c&2048)}})}async d(o,t,n){const a=[];for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&T.FileType.Directory))throw I.$7L.FileExists(`Unable to create folder '${n.scheme===l.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(T.$Dk(c)!==T.FileSystemProviderErrorCode.FileNotFound)throw c;a.push(t.basename(n)),n=t.dirname(n)}for(let c=a.length-1;c>=0;c--){n=t.joinPath(n,a[c]);try{await o.createDirectory(n)}catch(h){if(T.$Dk(h)!==T.FileSystemProviderErrorCode.FileExists)throw h}}}static e(o){if(o instanceof I.$7L)throw o;if(o instanceof T.$zk)switch(o.code){case T.FileSystemProviderErrorCode.FileExists:throw I.$7L.FileExists(o.message);case T.FileSystemProviderErrorCode.FileNotFound:throw I.$7L.FileNotFound(o.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw I.$7L.FileNotADirectory(o.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw I.$7L.FileIsADirectory(o.message);case T.FileSystemProviderErrorCode.NoPermissions:throw I.$7L.NoPermissions(o.message);case T.FileSystemProviderErrorCode.Unavailable:throw I.$7L.Unavailable(o.message);default:throw new I.$7L(o.message,o.name)}if(!(o instanceof Error))throw new I.$7L(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw I.$7L.Unavailable(o.message);switch(o.name){case T.FileSystemProviderErrorCode.FileExists:throw I.$7L.FileExists(o.message);case T.FileSystemProviderErrorCode.FileNotFound:throw I.$7L.FileNotFound(o.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw I.$7L.FileNotADirectory(o.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw I.$7L.FileIsADirectory(o.message);case T.FileSystemProviderErrorCode.NoPermissions:throw I.$7L.NoPermissions(o.message);case T.FileSystemProviderErrorCode.Unavailable:throw I.$7L.Unavailable(o.message);default:throw new I.$7L(o.message,o.name)}}addFileSystemProvider(o,t,n){return this.b.set(o,{impl:t,extUri:n?.isCaseSensitive?D.$ug:D.$wg,isReadonly:!!n?.isReadonly}),(0,w.$Qc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??D.$ug}};e.$Gfc=b,e.$Gfc=b=p=Ge([Ke(0,$.$UM),Ke(1,g.$hfc)],b),e.$Hfc=(0,R.$3h)("IExtHostConsumerFileSystem")}),define(Ce[249],Re([1,0,5,34,2,3,8,7,39]),function(ge,e,E,T,I,F,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=void 0;class w{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(p,b,r,o,t,n){this.a=Math.random(),this.b=new E.$Sd,this.c=new E.$Sd,this.d=new E.$Sd,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const a=(0,T.$Jj)(t),c=typeof t=="string",h=n?.correlate,i=o(s=>{if(!(typeof s.session=="number"&&s.session!==this.a)&&!(h&&typeof s.session>"u")){if(!n?.ignoreCreateEvents)for(const u of s.created){const d=I.URI.revive(u);a(d.fsPath)&&(!c||b.getWorkspaceFolder(d))&&this.b.fire(d)}if(!n?.ignoreChangeEvents)for(const u of s.changed){const d=I.URI.revive(u);a(d.fsPath)&&(!c||b.getWorkspaceFolder(d))&&this.c.fire(d)}if(!n?.ignoreDeleteEvents)for(const u of s.deleted){const d=I.URI.revive(u);a(d.fsPath)&&(!c||b.getWorkspaceFolder(d))&&this.d.fire(d)}}});this.g=$.$SK.from(this.i(p,r,t,n,n?.correlate),this.b,this.c,this.d,i)}i(p,b,r,o,t){const n=$.$SK.from();if(typeof r=="string")return n;const a=p.getProxy(F.$QK.MainThreadFileSystemEventService);let c=!1;return(r.pattern.includes(T.$Fj)||r.pattern.includes(T.$Gj))&&(c=!0),a.$watch(b.identifier.value,this.a,r.baseUri,{recursive:c,excludes:o?.excludes??[]},!!t),$.$SK.from({dispose:()=>a.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(p){this.a=p,this.session=this.a.session,this.b=new g.$V(()=>this.a.created.map(I.URI.revive)),this.c=new g.$V(()=>this.a.changed.map(I.URI.revive)),this.d=new g.$V(()=>this.a.deleted.map(I.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class D{constructor(p,b,r){this.j=p,this.k=b,this.l=r,this.a=new E.$Sd,this.b=new E.$Sd,this.c=new E.$Sd,this.d=new E.$Sd,this.g=new E.$Ud,this.h=new E.$Ud,this.i=new E.$Ud,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(p,b,r,o){return new w(this.j,p,b,this.a.event,R.GlobPattern.from(r),o)}$onFileEvent(p){this.a.fire(new A(p))}$onDidRunFileOperation(p,b){switch(p){case 2:this.b.fire(Object.freeze({files:b.map(r=>({oldUri:I.URI.revive(r.source),newUri:I.URI.revive(r.target)}))}));break;case 1:this.d.fire(Object.freeze({files:b.map(r=>I.URI.revive(r.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:b.map(r=>I.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent(p){return this.m(p,this.g)}getOnWillCreateFileEvent(p){return this.m(p,this.h)}getOnWillDeleteFileEvent(p){return this.m(p,this.i)}m(p,b){return(r,o,t)=>{const n=function(c){r.call(o,c)};return n.extension=p,b.event(n,void 0,t)}}async $onWillRunFileOperation(p,b,r,o){switch(p){case 2:return await this.n(this.g,{files:b.map(t=>({oldUri:I.URI.revive(t.source),newUri:I.URI.revive(t.target)}))},r,o);case 1:return await this.n(this.i,{files:b.map(t=>I.URI.revive(t.target))},r,o);case 0:case 3:return await this.n(this.h,{files:b.map(t=>I.URI.revive(t.target))},r,o)}}async n(p,b,r,o){const t=new Set,n=[];if(await p.fireAsync(b,o,async(c,h)=>{const i=Date.now(),s=await Promise.resolve(c);s instanceof $.$3K&&(n.push([h.extension,s]),t.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-i>r&&this.k.warn("SLOW file-participant",h.extension.identifier)}),o.isCancellationRequested||n.length===0)return;const a={edits:[]};for(const[,c]of n){const{edits:h}=R.WorkspaceEdit.from(c,{getTextDocumentVersion:i=>this.l.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}});a.edits=a.edits.concat(h)}return{edit:a,extensionNames:Array.from(t)}}}e.$vgc=D}),define(Ce[250],Re([1,0,6,2,3,8,7,32,13]),function(ge,e,E,T,I,F,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=void 0;class w{static{this.a=0}constructor(p,b){this.extension=p,this.provider=b,this.handle=w.a++}}class A{constructor(p){this.session=p,this.responses=[]}}class D{static{this.a=0}constructor(p,b,r,o){this.f=r,this.g=o,this.b=new Map,this.d=new Map,this.e=p.getProxy(I.$QK.MainThreadInlineChat),b.registerApiCommand(new $.$iN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$gN("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?F.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?F.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?F.Position.from(t.position):void 0}})],$.$hN.Void))}registerProvider(p,b,r){const o=new w(p,b);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,r?.label??p.displayName??p.name,p.identifier.value,typeof b.handleInteractiveEditorResponseFeedback=="function",typeof b.provideFollowups=="function",r?.supportReportIssue??!1),(0,E.$Qc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession(p,b,r,o){const t=this.b.get(p);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(T.URI.revive(b)),a=F.Selection.to(r),c=await t.provider.prepareInteractiveEditorSession({document:n,selection:a},o);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(a))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=D.a++;return this.d.set(h,new A(c)),{id:h,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(i=>({command:i.command,detail:i.detail,refer:i.refer,executeImmediately:i.executeImmediately})),wholeRange:F.Range.from(c.wholeRange),message:c.message}}async $provideResponse(p,b,r,o){const t=this.b.get(p);if(!t)return;const n=this.d.get(b.id);if(!n)return;const a={prompt:r.prompt,selection:F.Selection.to(r.selection),wholeRange:F.Range.to(r.wholeRange),attempt:r.attempt,live:r.live};let c=!1;const h={report:async L=>{if(!r.live&&L.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||o.isCancellationRequested||await this.e.$handleProgressChunk(r.requestId,{message:L.message,edits:L.edits?.map(F.TextEdit.from),editsShouldBeInstant:L.editsShouldBeInstant,slashCommand:L.slashCommand?.command,markdownFragment:R.$hL.isMarkdownString(L.content)?L.content.value:L.content})}},i=Promise.resolve(t.provider.provideInteractiveEditorResponse(n.session,a,h,o));let s;try{s=await(0,g.$Rg)(i,o)}finally{c=!0}if(!s)return;const u=n.responses.push(s)-1,d={wholeRange:F.Range.from(s.wholeRange),placeholder:s.placeholder};if(!D.h(s))return{...d,id:u,type:"editorEdit",message:F.MarkdownString.from(s.contents),edits:[]};const{edits:m,contents:f}=s,S=f!==void 0?F.MarkdownString.from(f):void 0;return m instanceof R.$3K?{...d,id:u,type:"bulkEdit",edits:F.WorkspaceEdit.from(m),message:S}:{...d,id:u,type:"editorEdit",edits:m.map(F.TextEdit.from),message:S}}async $provideFollowups(p,b,r,o){const t=this.b.get(p),n=this.d.get(b),a=n?.responses[r];if(t&&a&&t.provider.provideFollowups){const c=Promise.resolve(t.provider.provideFollowups(n.session,a,o));return(await(0,g.$Rg)(c,o))?.map(F.ChatReplyFollowup.from)}}$handleFeedback(p,b,r,o){const t=this.b.get(p),n=this.d.get(b),a=n?.responses[r];if(t&&a){const c=F.InteractiveEditorResponseFeedbackKind.to(o);t.provider.handleInteractiveEditorResponseFeedback?.(n.session,a,c)}}$releaseSession(p,b){}static h(p){return typeof p=="object"&&typeof p.edits=="object"}}e.$wgc=D}),define(Ce[251],Re([1,0,2,32]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jgc=void 0;class I{constructor(R,$,g,w,A){this.a=$,this.b=g,this.c=w;const D=new T.$iN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$gN("showOptions","Show Options",l=>!0,l=>l),new T.$gN("resource","Interactive resource Uri",l=>!0,l=>l),new T.$gN("controllerId","Notebook controller Id",l=>!0,l=>l),new T.$gN("title","Interactive editor title",l=>!0,l=>l)],new T.$hN("Notebook and input URI",l=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const p=this.a.getEditorById(l.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:E.URI.revive(l.notebookUri),inputUri:E.URI.revive(l.inputUri),notebookEditor:p.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:E.URI.revive(l.notebookUri),inputUri:E.URI.revive(l.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(R,$,g,w){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:$,lines:[""],languageId:g,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(E.URI.revive(w))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,$){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$Jgc=I}),define(Ce[252],Re([1,0,3,7]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=void 0;class I{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(E.$QK.MainThreadIssueReporter)}async $getIssueReporterUri(R,$){if(this.a.size===0)throw new Error("No issue request handlers registered");const g=this.a.get(R);if(!g)throw new Error("Issue request handler not found");const w=await g.handleIssueUrlRequest();if(!w)throw new Error("Issue request handler returned no result");return w}async $getIssueReporterData(R,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const g=this.b.get(R);if(!g)throw new Error("Issue data provider not found");const w=await g.provideIssueData($);if(!w)throw new Error("Issue data provider returned no result");return w}async $getIssueReporterTemplate(R,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const g=this.b.get(R);if(!g)throw new Error("Issue data provider not found");const w=await g.provideIssueTemplate($);if(!w)throw new Error("Issue template provider returned no result");return w}registerIssueUriRequestHandler(R,$){const g=R.identifier.value;return this.a.set(g,$),this.c.$registerIssueUriRequestHandler(g),new T.$SK(()=>{this.c.$unregisterIssueUriRequestHandler(g),this.a.delete(g)})}registerIssueDataProvider(R,$){const g=R.identifier.value;return this.b.set(g,$),this.c.$registerIssueDataProvider(g),new T.$SK(()=>{this.c.$unregisterIssueDataProvider(g),this.b.delete(g)})}}e.$Kgc=I}),define(Ce[253],Re([1,0,6,3]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=void 0;class I{constructor(R){this.b=0,this.a=R.getProxy(T.$QK.MainThreadLabelService)}$registerResourceLabelFormatter(R){const $=this.b++;return this.a.$registerResourceLabelFormatter($,R),(0,E.$Qc)(()=>{this.a.$unregisterResourceLabelFormatter($)})}}e.$Lgc=I}),define(Ce[254],Re([1,0,2,26,8,7,80,3,11,29,18,16,297,20,22,6,96,89,75,60,15,13,23,160]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l,p,b,r,o,t,n,a,c,h,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=void 0;class u{constructor(M,q){this.d=M,this.e=q}async provideDocumentSymbols(M,q){const H=this.d.getDocument(M),U=await this.e.provideDocumentSymbols(H,q);if(!(0,A.$Kb)(U))return U[0]instanceof F.$_K?U.map(I.DocumentSymbol.from):u.f(U)}static f(M){M=M.slice(0).sort((U,Z)=>{let Y=U.location.range.start.compareTo(Z.location.range.start);return Y===0&&(Y=Z.location.range.end.compareTo(U.location.range.end)),Y});const q=[],H=[];for(const U of M){const Z={name:U.name||"!!MISSING: name!!",kind:I.SymbolKind.from(U.kind),tags:U.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:U.containerName,range:I.Range.from(U.location.range),selectionRange:I.Range.from(U.location.range),children:[]};for(;;){if(H.length===0){H.push(Z),q.push(Z);break}const Y=H[H.length-1];if(w.$Is.containsRange(Y.range,Z.range)&&!w.$Is.equalsRange(Y.range,Z.range)){Y.children?.push(Z),H.push(Z);break}H.pop()}}return q}}class d{constructor(M,q,H,U,Z,Y){this.f=M,this.g=q,this.h=H,this.j=U,this.k=Z,this.l=Y,this.d=new n.$dfc("CodeLens"),this.e=new Map}async provideCodeLenses(M,q){const H=this.f.getDocument(M),U=await this.h.provideCodeLenses(H,q);if(!U||q.isCancellationRequested)return;const Z=this.d.add(U),Y=new r.$Rc;this.e.set(Z,Y);const Ee={cacheId:Z,lenses:[]};for(let Te=0;Te<U.length;Te++)Ee.lenses.push({cacheId:[Z,Te],range:I.Range.from(U[Te].range),command:this.g.toInternal(U[Te].command,Y)});return Ee}async resolveCodeLens(M,q){const H=M.cacheId&&this.d.get(...M.cacheId);if(!H)return;let U;if(typeof this.h.resolveCodeLens!="function"||H.isResolved?U=H:U=await this.h.resolveCodeLens(H,q),U||(U=H),q.isCancellationRequested)return;const Z=M.cacheId&&this.e.get(M.cacheId[0]);if(Z){if(!U.command){const Y=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,Y),this.l.error(Y);return}return M.command=this.g.toInternal(U.command,Z),M}}releaseCodeLenses(M){this.e.get(M)?.dispose(),this.e.delete(M),this.d.delete(M)}}function m(we){return Array.isArray(we)?we.map(I.DefinitionLink.from):we?[I.DefinitionLink.from(we)]:[]}class f{constructor(M,q){this.d=M,this.e=q}async provideDefinition(M,q,H){const U=this.d.getDocument(M),Z=I.Position.to(q),Y=await this.e.provideDefinition(U,Z,H);return m(Y)}}class S{constructor(M,q){this.d=M,this.e=q}async provideDeclaration(M,q,H){const U=this.d.getDocument(M),Z=I.Position.to(q),Y=await this.e.provideDeclaration(U,Z,H);return m(Y)}}class L{constructor(M,q){this.d=M,this.e=q}async provideImplementation(M,q,H){const U=this.d.getDocument(M),Z=I.Position.to(q),Y=await this.e.provideImplementation(U,Z,H);return m(Y)}}class v{constructor(M,q){this.d=M,this.e=q}async provideTypeDefinition(M,q,H){const U=this.d.getDocument(M),Z=I.Position.to(q),Y=await this.e.provideTypeDefinition(U,Z,H);return m(Y)}}class y{constructor(M,q){this.d=M,this.e=q}async provideHover(M,q,H){const U=this.d.getDocument(M),Z=I.Position.to(q),Y=await this.e.provideHover(U,Z,H);if(!(!Y||(0,A.$Kb)(Y.contents)))return Y.range||(Y.range=U.getWordRangeAtPosition(Z)),Y.range||(Y.range=new F.$UK(Z,Z)),I.Hover.from(Y)}}class k{constructor(M,q){this.d=M,this.e=q}async provideEvaluatableExpression(M,q,H){const U=this.d.getDocument(M),Z=I.Position.to(q),Y=await this.e.provideEvaluatableExpression(U,Z,H);if(Y)return I.EvaluatableExpression.from(Y)}}class N{constructor(M,q){this.d=M,this.e=q}async provideInlineValues(M,q,H,U){const Z=this.d.getDocument(M),Y=await this.e.provideInlineValues(Z,I.Range.to(q),I.InlineValueContext.to(H),U);if(Array.isArray(Y))return Y.map(Ee=>I.InlineValue.from(Ee))}}class O{constructor(M,q){this.d=M,this.e=q}async provideDocumentHighlights(M,q,H){const U=this.d.getDocument(M),Z=I.Position.to(q),Y=await this.e.provideDocumentHighlights(U,Z,H);if(Array.isArray(Y))return Y.map(I.DocumentHighlight.from)}}class K{constructor(M,q){this.d=M,this.e=q}async provideMultiDocumentHighlights(M,q,H,U){const Z=this.d.getDocument(M),Y=H.map(We=>this.d.getDocument(We)),Ee=I.Position.to(q),Te=await this.e.provideMultiDocumentHighlights(Z,Ee,Y,U);if(Array.isArray(Te))return Te.map(I.MultiDocumentHighlight.from)}}class j{constructor(M,q){this.d=M,this.e=q}async provideLinkedEditingRanges(M,q,H){const U=this.d.getDocument(M),Z=I.Position.to(q),Y=await this.e.provideLinkedEditingRanges(U,Z,H);if(Y&&Array.isArray(Y.ranges))return{ranges:(0,A.$Hb)(Y.ranges.map(I.Range.from)),wordPattern:Y.wordPattern}}}class W{constructor(M,q){this.d=M,this.e=q}async provideReferences(M,q,H,U){const Z=this.d.getDocument(M),Y=I.Position.to(q),Ee=await this.e.provideReferences(Z,Y,H,U);if(Array.isArray(Ee))return Ee.map(I.location.from)}}class P{static{this.d=1e3}constructor(M,q,H,U,Z,Y,Ee){this.g=M,this.h=q,this.j=H,this.k=U,this.l=Z,this.m=Y,this.n=Ee,this.e=new n.$dfc("CodeAction"),this.f=new Map}async provideCodeActions(M,q,H,U){const Z=this.g.getDocument(M),Y=l.$Ks.isISelection(q)?I.Selection.to(q):I.Range.to(q),Ee=[];for(const nt of this.j.getDiagnostics(M))if(Y.intersection(nt.range)&&Ee.push(nt)>P.d)break;const Te={diagnostics:Ee,only:H.only?new F.$bL(H.only):void 0,triggerKind:I.CodeActionTriggerKind.to(H.trigger)},We=await this.k.provideCodeActions(Z,Y,Te,U);if(!(0,A.$Lb)(We)||U.isCancellationRequested)return;const He=this.e.add(We),Xe=new r.$Rc;this.f.set(He,Xe);const st=[];for(let nt=0;nt<We.length;nt++){const tt=We[nt];tt&&(P.o(tt)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),st.push({_isSynthetic:!0,title:tt.title,command:this.h.toInternal(tt,Xe)})):(Te.only&&(tt.kind?Te.only.contains(tt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${tt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),st.push({cacheId:[He,nt],title:tt.title,command:tt.command&&this.h.toInternal(tt.command,Xe),diagnostics:tt.diagnostics&&tt.diagnostics.map(I.Diagnostic.from),edit:tt.edit&&I.WorkspaceEdit.from(tt.edit,void 0),kind:tt.kind&&tt.kind.value,isPreferred:tt.isPreferred,isAI:(0,i.$oF)(this.m,"codeActionAI")?tt.isAI:!1,disabled:tt.disabled?.reason})))}return{cacheId:He,actions:st}}async resolveCodeAction(M,q){const[H,U]=M,Z=this.e.get(H,U);if(!Z||P.o(Z))return{};if(!this.k.resolveCodeAction)return{};const Y=await this.k.resolveCodeAction(Z,q)??Z;let Ee;Y.edit&&(Ee=I.WorkspaceEdit.from(Y.edit,void 0));let Te;if(Y.command){const We=this.f.get(H);We&&(Te=this.h.toInternal(Y.command,We))}return{edit:Ee,command:Te}}releaseCodeActions(M){this.f.get(M)?.dispose(),this.f.delete(M),this.e.delete(M)}static o(M){return typeof M.command=="string"&&typeof M.title=="string"}}class C{static toInternalProviderId(M,q){return M+"."+q}constructor(M,q,H,U,Z){this.d=M,this.e=q,this.f=H,this.g=U,this.h=Z}async prepareDocumentPaste(M,q,H,U){if(!this.f.prepareDocumentPaste)return;const Z=this.e.getDocument(M),Y=q.map(We=>I.Range.to(We)),Ee=I.DataTransfer.toDataTransfer(H,()=>{throw new c.$$});if(await this.f.prepareDocumentPaste(Z,Y,Ee,U),U.isCancellationRequested)return;const Te=Array.from(Ee).filter(([,We])=>!(We instanceof F.$HL));return I.DataTransfer.from(Te)}async providePasteEdits(M,q,H,U,Z){if(!this.f.provideDocumentPasteEdits)return;const Y=this.e.getDocument(q),Ee=H.map(He=>I.Range.to(He)),Te=I.DataTransfer.toDataTransfer(U,async He=>(await this.d.$resolvePasteFileData(this.g,M,He)).buffer),We=await this.f.provideDocumentPasteEdits(Y,Ee,Te,Z);if(We)return{label:We.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(He=>"mimeType"in He?He:{providerId:C.toInternalProviderId(He.extensionId,He.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?I.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class J{constructor(M,q){this.d=M,this.e=q}async provideDocumentFormattingEdits(M,q,H){const U=this.d.getDocument(M),Z=await this.e.provideDocumentFormattingEdits(U,q,H);if(Array.isArray(Z))return Z.map(I.TextEdit.from)}}class ae{constructor(M,q){this.d=M,this.e=q}async provideDocumentRangeFormattingEdits(M,q,H,U){const Z=this.d.getDocument(M),Y=I.Range.to(q),Ee=await this.e.provideDocumentRangeFormattingEdits(Z,Y,H,U);if(Array.isArray(Ee))return Ee.map(I.TextEdit.from)}async provideDocumentRangesFormattingEdits(M,q,H,U){(0,D.$Pf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Z=this.d.getDocument(M),Y=q.map(I.Range.to),Ee=await this.e.provideDocumentRangesFormattingEdits(Z,Y,H,U);if(Array.isArray(Ee))return Ee.map(I.TextEdit.from)}}class fe{constructor(M,q){this.d=M,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(M,q,H,U,Z){const Y=this.d.getDocument(M),Ee=I.Position.to(q),Te=await this.e.provideOnTypeFormattingEdits(Y,Ee,H,U,Z);if(Array.isArray(Te))return Te.map(I.TextEdit.from)}}class be{constructor(M,q){this.e=M,this.f=q,this.d=new n.$dfc("WorkspaceSymbols")}async provideWorkspaceSymbols(M,q){const H=await this.e.provideWorkspaceSymbols(M,q);if(!(0,A.$Lb)(H))return{symbols:[]};const U=this.d.add(H),Z={cacheId:U,symbols:[]};for(let Y=0;Y<H.length;Y++){const Ee=H[Y];if(!Ee||!Ee.name){this.f.warn("INVALID SymbolInformation",Ee);continue}Z.symbols.push({...I.WorkspaceSymbol.from(Ee),cacheId:[U,Y]})}return Z}async resolveWorkspaceSymbol(M,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!M.cacheId)return M;const H=this.d.get(...M.cacheId);if(H){const U=await this.e.resolveWorkspaceSymbol(H,q);return U&&(0,T.$mn)(M,I.WorkspaceSymbol.from(U),!0)}}releaseWorkspaceSymbols(M){this.d.delete(M)}}class ye{static supportsResolving(M){return typeof M.prepareRename=="function"}constructor(M,q,H){this.d=M,this.e=q,this.f=H}async provideRenameEdits(M,q,H,U){const Z=this.d.getDocument(M),Y=I.Position.to(q);try{const Ee=await this.e.provideRenameEdits(Z,Y,H,U);return Ee?I.WorkspaceEdit.from(Ee):void 0}catch(Ee){const Te=ye.g(Ee);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(Ee)}}async resolveRenameLocation(M,q,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const U=this.d.getDocument(M),Z=I.Position.to(q);try{const Y=await this.e.prepareRename(U,Z,H);let Ee,Te;if(F.$UK.isRange(Y)?(Ee=Y,Te=U.getText(Y)):(0,D.$Hf)(Y)&&(Ee=Y.range,Te=Y.placeholder),!Ee||!Te)return;if(Ee.start.line>Z.line||Ee.end.line<Z.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(Ee),text:Te}}catch(Y){const Ee=ye.g(Y);return Ee?{rejectReason:Ee,range:void 0,text:void 0}:Promise.reject(Y)}}static g(M){return typeof M=="string"?M:M instanceof Error&&typeof M.message=="string"?M.message:void 0}}class he{constructor(M,q){this.resultId=M,this.tokens=q}}class ve{constructor(M,q){this.f=M,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(M,q,H){const U=this.f.getDocument(M),Z=q!==0?this.d.get(q):null;let Y=typeof Z?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(U,Z.resultId,H):await this.g.provideDocumentSemanticTokens(U,H);return Z&&this.d.delete(q),Y?(Y=ve.h(Y),this.o(ve.n(Z,Y),Y)):null}async releaseDocumentSemanticColoring(M){this.d.delete(M)}static h(M){return ve.j(M)?ve.k(M)?M:new F.$$L(new Uint32Array(M.data),M.resultId):ve.l(M)?ve.m(M)?M:new F.$aM(M.edits.map(q=>new F.$_L(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),M.resultId):M}static j(M){return M&&!!M.data}static k(M){return M.data instanceof Uint32Array}static l(M){return M&&Array.isArray(M.edits)}static m(M){for(const q of M.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(M,q){if(!ve.j(q)||!M||!M.tokens)return q;const H=M.tokens,U=H.length,Z=q.data,Y=Z.length;let Ee=0;const Te=Math.min(U,Y);for(;Ee<Te&&H[Ee]===Z[Ee];)Ee++;if(Ee===U&&Ee===Y)return new F.$aM([],q.resultId);let We=0;const He=Te-Ee;for(;We<He&&H[U-We-1]===Z[Y-We-1];)We++;return new F.$aM([{start:Ee,deleteCount:U-Ee-We,data:Z.subarray(Ee,Y-We)}],q.resultId)}o(M,q){if(ve.j(M)){const H=this.e++;return this.d.set(H,new he(M.resultId,M.data)),(0,o.$j$)({id:H,type:"full",data:M.data})}if(ve.l(M)){const H=this.e++;return ve.j(q)?this.d.set(H,new he(q.resultId,q.data)):this.d.set(H,new he(M.resultId)),(0,o.$j$)({id:H,type:"delta",deltas:(M.edits||[]).map(U=>({start:U.start,deleteCount:U.deleteCount,data:U.data}))})}return null}}class ee{constructor(M,q){this.d=M,this.e=q}async provideDocumentRangeSemanticTokens(M,q,H){const U=this.d.getDocument(M),Z=await this.e.provideDocumentRangeSemanticTokens(U,I.Range.to(q),H);return Z?this.f(Z):null}f(M){return(0,o.$j$)({id:0,type:"full",data:M.data})}}class ke{static supportsResolving(M){return typeof M.resolveCompletionItem=="function"}constructor(M,q,H,U,Z){this.f=M,this.g=q,this.h=H,this.j=U,this.k=Z,this.d=new n.$dfc("CompletionItem"),this.e=new Map}async provideCompletionItems(M,q,H,U){const Z=this.f.getDocument(M),Y=I.Position.to(q),Ee=Z.getWordRangeAtPosition(Y)||new F.$UK(Y,Y),Te=Ee.with({end:Y}),We=new a.$Od,He=await this.h.provideCompletionItems(Z,Y,U,I.CompletionContext.to(H));if(!He||U.isCancellationRequested)return;const Xe=Array.isArray(He)?new F.$oL(He):He,st=ke.supportsResolving(this.h)?this.d.add(Xe.items):this.d.add([]),nt=new r.$Rc;this.e.set(st,nt);const tt=[],at={x:st,b:tt,a:{replace:I.Range.from(Ee),insert:I.Range.from(Te)},c:Xe.isIncomplete||void 0,d:We.elapsed()};for(let ct=0;ct<Xe.items.length;ct++){const ze=Xe.items[ct],vt=this.l(ze,[st,ct],Te,Ee);tt.push(vt)}return at}async resolveCompletionItem(M,q){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...M);if(!H)return;const U=this.l(H,M),Z=await this.h.resolveCompletionItem(H,q);if(!Z)return;const Y=this.l(Z,M);return(U.h!==Y.h||U.i!==Y.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(U.n!==Y.n||U.o!==Y.o||!(0,T.$nn)(U.p,Y.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...U,d:Y.d,c:Y.c,l:Y.l,h:Y.h,i:Y.i,n:Y.n,o:Y.o,p:Y.p}}releaseCompletionItems(M){this.e.get(M)?.dispose(),this.e.delete(M),this.d.delete(M)}l(M,q,H,U){const Z=this.e.get(q[0]);if(!Z)throw Error("DisposableStore is missing...");const Y=this.g.toInternal(M.command,Z),Ee={x:q,a:M.label,b:M.kind!==void 0?I.CompletionItemKind.from(M.kind):void 0,m:M.tags&&M.tags.map(I.CompletionItemTag.from),c:M.detail,d:typeof M.documentation>"u"?void 0:I.MarkdownString.fromStrict(M.documentation),e:M.sortText!==M.label?M.sortText:void 0,f:M.filterText!==M.label?M.filterText:void 0,g:M.preselect||void 0,i:M.keepWhitespace?1:0,k:M.commitCharacters?.join(""),l:M.additionalTextEdits&&M.additionalTextEdits.map(I.TextEdit.from),n:Y?.$ident,o:Y?.id,p:Y?.$ident?void 0:Y?.arguments};M.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ee.h=M.textEdit.newText):typeof M.insertText=="string"?Ee.h=M.insertText:M.insertText instanceof F.$4K&&(Ee.h=M.insertText.value,Ee.i|=4);let Te;return M.textEdit?Te=M.textEdit.range:M.range&&(Te=M.range),F.$UK.isRange(Te)?Ee.j=I.Range.from(Te):Te&&(!H?.isEqual(Te.inserting)||!U?.isEqual(Te.replacing))&&(Ee.j={insert:I.Range.from(Te.inserting),replace:I.Range.from(Te.replacing)}),Ee}}class se{async provideInlineCompletions(M,q,H,U){}disposeCompletions(M){}handleDidShowCompletionItem(M,q,H){}handlePartialAccept(M,q,H){}}class _ extends se{constructor(M,q,H,U){super(),this.f=M,this.g=q,this.h=H,this.j=U,this.d=new V,this.e=(0,i.$oF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:F.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:F.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.$oF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(M,q,H,U){const Z=this.g.getDocument(M),Y=I.Position.to(q),Ee=await this.h.provideInlineCompletionItems(Z,Y,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:I.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},U);if(!Ee||U.isCancellationRequested)return;const Te=Array.isArray(Ee)?Ee:Ee.items,We=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],He=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let Xe;return{pid:this.d.createReferenceId({dispose(){Xe?.dispose()},items:Te}),items:Te.map((nt,tt)=>{let at;nt.command&&(Xe||(Xe=new r.$Rc),at=this.j.toInternal(nt.command,Xe));const ct=nt.insertText;return{insertText:typeof ct=="string"?ct:{snippet:ct.value},filterText:nt.filterText,range:nt.range?I.Range.from(nt.range):void 0,command:at,idx:tt,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:We.map(nt=>(Xe||(Xe=new r.$Rc),this.j.toInternal(nt,Xe))),suppressSuggestions:!1,enableForwardStability:He}}disposeCompletions(M){this.d.disposeReferenceId(M)?.dispose()}handleDidShowCompletionItem(M,q,H){const U=this.d.get(M)?.items[q];U&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(U,H)}handlePartialAccept(M,q,H){const U=this.d.get(M)?.items[q];U&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(U,H)}}class V{constructor(){this.d=new Map,this.e=1}createReferenceId(M){const q=this.e++;return this.d.set(q,M),q}disposeReferenceId(M){const q=this.d.get(M);return this.d.delete(M),q}get(M){return this.d.get(M)}}class ne{constructor(M,q){this.e=M,this.f=q,this.d=new n.$dfc("SignatureHelp")}async provideSignatureHelp(M,q,H,U){const Z=this.e.getDocument(M),Y=I.Position.to(q),Ee=this.g(H),Te=await this.f.provideSignatureHelp(Z,Y,U,Ee);if(Te){const We=this.d.add([Te]);return{...I.SignatureHelp.from(Te),id:We}}}g(M){let q;if(M.activeSignatureHelp){const H=I.SignatureHelp.to(M.activeSignatureHelp),U=this.d.get(M.activeSignatureHelp.id,0);U?(q=U,q.activeSignature=H.activeSignature,q.activeParameter=H.activeParameter):q=H}return{...M,activeSignatureHelp:q}}releaseSignatureHelp(M){this.d.delete(M)}}class Ie{constructor(M,q,H,U,Z){this.f=M,this.g=q,this.h=H,this.j=U,this.k=Z,this.d=new n.$dfc("InlayHints"),this.e=new Map}async provideInlayHints(M,q,H){const U=this.f.getDocument(M),Z=I.Range.to(q),Y=await this.h.provideInlayHints(U,Z,H);if(!Array.isArray(Y)||Y.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`);return}if(H.isCancellationRequested)return;const Ee=this.d.add(Y);this.e.set(Ee,new r.$Rc);const Te={hints:[],cacheId:Ee};for(let We=0;We<Y.length;We++)this.l(Y[We],Z)&&Te.hints.push(this.m(Y[We],[Ee,We]));return this.j.trace(`[InlayHints] ${Te.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`),Te}async resolveInlayHint(M,q){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...M);if(!H)return;const U=await this.h.resolveInlayHint(H,q);if(U&&this.l(U))return this.m(U,M)}releaseHints(M){this.e.get(M)?.dispose(),this.e.delete(M),this.d.delete(M)}l(M,q){return M.label.length===0||Array.isArray(M.label)&&M.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",M),!1):!(q&&!q.contains(M.position))}m(M,q){const H=this.e.get(q[0]);if(!H)throw Error("DisposableStore is missing...");const U={label:"",cacheId:q,tooltip:I.MarkdownString.fromStrict(M.tooltip),position:I.Position.from(M.position),textEdits:M.textEdits&&M.textEdits.map(I.TextEdit.from),kind:M.kind&&I.InlayHintKind.from(M.kind),paddingLeft:M.paddingLeft,paddingRight:M.paddingRight};if(typeof M.label=="string")U.label=M.label;else{const Z=[];U.label=Z;for(const Y of M.label){if(!Y.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ee={label:Y.value,tooltip:I.MarkdownString.fromStrict(Y.tooltip)};F.$5K.isLocation(Y.location)&&(Ee.location=I.location.from(Y.location)),Y.command&&(Ee.command=this.g.toInternal(Y.command,H)),Z.push(Ee)}}return U}}class Ae{constructor(M,q){this.e=M,this.f=q,this.d=new n.$dfc("DocumentLink")}async provideLinks(M,q){const H=this.e.getDocument(M),U=await this.f.provideDocumentLinks(H,q);if(!(!Array.isArray(U)||U.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:U.filter(Ae.g).map(I.DocumentLink.from)};{const Z=this.d.add(U),Y={links:[],cacheId:Z};for(let Ee=0;Ee<U.length;Ee++){if(!Ae.g(U[Ee]))continue;const Te=I.DocumentLink.from(U[Ee]);Te.cacheId=[Z,Ee],Y.links.push(Te)}return Y}}}static g(M){return M.target&&M.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(M,q){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...M);if(!H)return;const U=await this.f.resolveDocumentLink(H,q);if(!(!U||!Ae.g(U)))return I.DocumentLink.from(U)}releaseLinks(M){this.d.delete(M)}}class Pe{constructor(M,q){this.d=M,this.e=q}async provideColors(M,q){const H=this.d.getDocument(M),U=await this.e.provideDocumentColors(H,q);return Array.isArray(U)?U.map(Y=>({color:I.Color.from(Y.color),range:I.Range.from(Y.range)})):[]}async provideColorPresentations(M,q,H){const U=this.d.getDocument(M),Z=I.Range.to(q.range),Y=I.Color.to(q.color),Ee=await this.e.provideColorPresentations(Y,{document:U,range:Z},H);if(Array.isArray(Ee))return Ee.map(I.ColorPresentation.from)}}class ce{constructor(M,q){this.d=M,this.e=q}async provideFoldingRanges(M,q,H){const U=this.d.getDocument(M),Z=await this.e.provideFoldingRanges(U,q,H);if(Array.isArray(Z))return Z.map(I.FoldingRange.from)}}class ie{constructor(M,q,H){this.d=M,this.e=q,this.f=H}async provideSelectionRanges(M,q,H){const U=this.d.getDocument(M),Z=q.map(I.Position.to),Y=await this.e.provideSelectionRanges(U,Z,H);if(!(0,A.$Lb)(Y))return[];if(Y.length!==Z.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ee=[];for(let Te=0;Te<Z.length;Te++){const We=[];Ee.push(We);let He=Z[Te],Xe=Y[Te];for(;;){if(!Xe.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(We.push(I.SelectionRange.from(Xe)),!Xe.parent)break;He=Xe.range,Xe=Xe.parent}}return Ee}}class Q{constructor(M,q){this.f=M,this.g=q,this.d=new t.$ZM(""),this.e=new Map}async prepareSession(M,q,H){const U=this.f.getDocument(M),Z=I.Position.to(q),Y=await this.g.prepareCallHierarchy(U,Z,H);if(!Y)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(Y)?Y.map(Te=>this.h(Ee,Te)):[this.h(Ee,Y)]}async provideCallsTo(M,q,H){const U=this.j(M,q);if(!U)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyIncomingCalls(U,H);if(Z)return Z.map(Y=>({from:this.h(M,Y.from),fromRanges:Y.fromRanges.map(Ee=>I.Range.from(Ee))}))}async provideCallsFrom(M,q,H){const U=this.j(M,q);if(!U)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyOutgoingCalls(U,H);if(Z)return Z.map(Y=>({to:this.h(M,Y.to),fromRanges:Y.fromRanges.map(Ee=>I.Range.from(Ee))}))}releaseSession(M){this.e.delete(M)}h(M,q){const H=this.e.get(M),U=I.CallHierarchyItem.from(q,M,H.size.toString(36));return H.set(U._itemId,q),U}j(M,q){return this.e.get(M)?.get(q)}}class te{constructor(M,q){this.f=M,this.g=q,this.d=new t.$ZM(""),this.e=new Map}async prepareSession(M,q,H){const U=this.f.getDocument(M),Z=I.Position.to(q),Y=await this.g.prepareTypeHierarchy(U,Z,H);if(!Y)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(Y)?Y.map(Te=>this.h(Ee,Te)):[this.h(Ee,Y)]}async provideSupertypes(M,q,H){const U=this.j(M,q);if(!U)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySupertypes(U,H);if(Z)return Z.map(Y=>this.h(M,Y))}async provideSubtypes(M,q,H){const U=this.j(M,q);if(!U)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySubtypes(U,H);if(Z)return Z.map(Y=>this.h(M,Y))}releaseSession(M){this.e.delete(M)}h(M,q){const H=this.e.get(M),U=I.TypeHierarchyItem.from(q,M,H.size.toString(36));return H.set(U._itemId,q),U}j(M,q){return this.e.get(M)?.get(q)}}class me{static toInternalProviderId(M,q){return M+"."+q}constructor(M,q,H,U,Z){this.d=M,this.e=q,this.f=H,this.g=U,this.h=Z}async provideDocumentOnDropEdits(M,q,H,U,Z){const Y=this.e.getDocument(q),Ee=I.Position.to(H),Te=I.DataTransfer.toDataTransfer(U,async He=>(await this.d.$resolveDocumentOnDropFileData(this.g,M,He)).buffer),We=await this.f.provideDocumentDropEdits(Y,Ee,Te,Z);if(We)return{label:We.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(He=>"mimeType"in He?He:{providerId:me.toInternalProviderId(He.extensionId,He.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?I.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class pe{constructor(M,q){this.d=M,this.e=q}async provideMappedEdits(M,q,H,U){const Z=E.URI.revive(M),Y=this.d.getDocument(Z),Ee=H.documents.map(He=>He.map(Xe=>({uri:E.URI.revive(Xe.uri),version:Xe.version,ranges:Xe.ranges.map(st=>I.Range.to(st))}))),Te={documents:Ee,selections:Ee[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(Y,q,Te,U);return We?I.WorkspaceEdit.from(We):null}}class Fe{constructor(M,q){this.adapter=M,this.extension=q}}class le{static{this.d=0}constructor(M,q,H,U,Z,Y,Ee,Te){this.g=q,this.h=H,this.j=U,this.k=Z,this.l=Y,this.m=Ee,this.n=Te,this.f=new Map,this.e=M.getProxy($.$QK.MainThreadLanguageFeatures)}o(M,q){return I.DocumentSelector.from(M,this.g,q)}p(M){return new F.$SK(()=>{this.f.delete(M),this.e.$unregister(M)})}q(){return le.d++}async s(M,q,H,U,Z,Y=!1){const Ee=this.f.get(M);if(!Ee||!(Ee.adapter instanceof q))return U;const Te=Date.now();Y||this.l.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const We=H(Ee.adapter,Ee.extension);return Promise.resolve(We).catch(He=>{(0,c.$4)(He)||(this.l.error(`[${Ee.extension.identifier.value}] provider FAILED`),this.l.error(He),this.n.onExtensionError(Ee.extension.identifier,He))}).finally(()=>{Y||this.l.trace(`[${Ee.extension.identifier.value}] provider DONE after ${Date.now()-Te}ms`)}),p.CancellationToken.isCancellationToken(Z)?(0,h.$Sg)(We,Z):We}t(M,q){const H=this.q();return this.f.set(H,new Fe(M,q)),H}static u(M){return M.displayName||M.name}registerDocumentSymbolProvider(M,q,H,U){const Z=this.t(new u(this.h,H),M),Y=U&&U.label||le.u(M);return this.e.$registerDocumentSymbolProvider(Z,this.o(q,M),Y),this.p(Z)}$provideDocumentSymbols(M,q,H){return this.s(M,u,U=>U.provideDocumentSymbols(E.URI.revive(q),H),void 0,H)}registerCodeLensProvider(M,q,H){const U=this.q(),Z=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(U,new Fe(new d(this.h,this.j.converter,H,M,this.n,this.l),M)),this.e.$registerCodeLensSupport(U,this.o(q,M),Z);let Y=this.p(U);if(Z!==void 0){const Ee=H.onDidChangeCodeLenses(Te=>this.e.$emitCodeLensEvent(Z));Y=F.$SK.from(Y,Ee)}return Y}$provideCodeLenses(M,q,H){return this.s(M,d,U=>U.provideCodeLenses(E.URI.revive(q),H),void 0,H)}$resolveCodeLens(M,q,H){return this.s(M,d,U=>U.resolveCodeLens(q,H),void 0,void 0)}$releaseCodeLenses(M,q){this.s(M,d,H=>Promise.resolve(H.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(M,q,H){const U=this.t(new f(this.h,H),M);return this.e.$registerDefinitionSupport(U,this.o(q,M)),this.p(U)}$provideDefinition(M,q,H,U){return this.s(M,f,Z=>Z.provideDefinition(E.URI.revive(q),H,U),[],U)}registerDeclarationProvider(M,q,H){const U=this.t(new S(this.h,H),M);return this.e.$registerDeclarationSupport(U,this.o(q,M)),this.p(U)}$provideDeclaration(M,q,H,U){return this.s(M,S,Z=>Z.provideDeclaration(E.URI.revive(q),H,U),[],U)}registerImplementationProvider(M,q,H){const U=this.t(new L(this.h,H),M);return this.e.$registerImplementationSupport(U,this.o(q,M)),this.p(U)}$provideImplementation(M,q,H,U){return this.s(M,L,Z=>Z.provideImplementation(E.URI.revive(q),H,U),[],U)}registerTypeDefinitionProvider(M,q,H){const U=this.t(new v(this.h,H),M);return this.e.$registerTypeDefinitionSupport(U,this.o(q,M)),this.p(U)}$provideTypeDefinition(M,q,H,U){return this.s(M,v,Z=>Z.provideTypeDefinition(E.URI.revive(q),H,U),[],U)}registerHoverProvider(M,q,H,U){const Z=this.t(new y(this.h,H),M);return this.e.$registerHoverProvider(Z,this.o(q,M)),this.p(Z)}$provideHover(M,q,H,U){return this.s(M,y,Z=>Z.provideHover(E.URI.revive(q),H,U),void 0,U)}registerEvaluatableExpressionProvider(M,q,H,U){const Z=this.t(new k(this.h,H),M);return this.e.$registerEvaluatableExpressionProvider(Z,this.o(q,M)),this.p(Z)}$provideEvaluatableExpression(M,q,H,U){return this.s(M,k,Z=>Z.provideEvaluatableExpression(E.URI.revive(q),H,U),void 0,U)}registerInlineValuesProvider(M,q,H,U){const Z=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,Y=this.t(new N(this.h,H),M);this.e.$registerInlineValuesProvider(Y,this.o(q,M),Z);let Ee=this.p(Y);if(Z!==void 0){const Te=H.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(Z));Ee=F.$SK.from(Ee,Te)}return Ee}$provideInlineValues(M,q,H,U,Z){return this.s(M,N,Y=>Y.provideInlineValues(E.URI.revive(q),H,U,Z),void 0,Z)}registerDocumentHighlightProvider(M,q,H){const U=this.t(new O(this.h,H),M);return this.e.$registerDocumentHighlightProvider(U,this.o(q,M)),this.p(U)}registerMultiDocumentHighlightProvider(M,q,H){const U=this.t(new K(this.h,H),M);return this.e.$registerMultiDocumentHighlightProvider(U,this.o(q,M)),this.p(U)}$provideDocumentHighlights(M,q,H,U){return this.s(M,O,Z=>Z.provideDocumentHighlights(E.URI.revive(q),H,U),void 0,U)}$provideMultiDocumentHighlights(M,q,H,U,Z){return this.s(M,K,Y=>Y.provideMultiDocumentHighlights(E.URI.revive(q),H,U.map(Ee=>E.URI.revive(Ee)),Z),void 0,Z)}registerLinkedEditingRangeProvider(M,q,H){const U=this.t(new j(this.h,H),M);return this.e.$registerLinkedEditingRangeProvider(U,this.o(q,M)),this.p(U)}$provideLinkedEditingRanges(M,q,H,U){return this.s(M,j,async Z=>{const Y=await Z.provideLinkedEditingRanges(E.URI.revive(q),H,U);if(Y)return{ranges:Y.ranges,wordPattern:Y.wordPattern?le.w(Y.wordPattern):void 0}},void 0,U)}registerReferenceProvider(M,q,H){const U=this.t(new W(this.h,H),M);return this.e.$registerReferenceSupport(U,this.o(q,M)),this.p(U)}$provideReferences(M,q,H,U,Z){return this.s(M,W,Y=>Y.provideReferences(E.URI.revive(q),H,U,Z),void 0,Z)}registerCodeActionProvider(M,q,H,U){const Z=new r.$Rc,Y=this.t(new P(this.h,this.j.converter,this.k,H,this.l,M,this.m),M);return this.e.$registerQuickFixSupport(Y,this.o(q,M),{providedKinds:U?.providedCodeActionKinds?.map(Ee=>Ee.value),documentation:U?.documentation?.map(Ee=>({kind:Ee.kind.value,command:this.j.converter.toInternal(Ee.command,Z)}))},le.u(M),!!H.resolveCodeAction),Z.add(this.p(Y)),Z}$provideCodeActions(M,q,H,U,Z){return this.s(M,P,Y=>Y.provideCodeActions(E.URI.revive(q),H,U,Z),void 0,Z)}$resolveCodeAction(M,q,H){return this.s(M,P,U=>U.resolveCodeAction(q,H),{},void 0)}$releaseCodeActions(M,q){this.s(M,P,H=>Promise.resolve(H.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(M,q,H){const U=this.t(new J(this.h,H),M);return this.e.$registerDocumentFormattingSupport(U,this.o(q,M),M.identifier,M.displayName||M.name),this.p(U)}$provideDocumentFormattingEdits(M,q,H,U){return this.s(M,J,Z=>Z.provideDocumentFormattingEdits(E.URI.revive(q),H,U),void 0,U)}registerDocumentRangeFormattingEditProvider(M,q,H){const U=typeof H.provideDocumentRangesFormattingEdits=="function",Z=this.t(new ae(this.h,H),M);return this.e.$registerRangeFormattingSupport(Z,this.o(q,M),M.identifier,M.displayName||M.name,U),this.p(Z)}$provideDocumentRangeFormattingEdits(M,q,H,U,Z){return this.s(M,ae,Y=>Y.provideDocumentRangeFormattingEdits(E.URI.revive(q),H,U,Z),void 0,Z)}$provideDocumentRangesFormattingEdits(M,q,H,U,Z){return this.s(M,ae,Y=>Y.provideDocumentRangesFormattingEdits(E.URI.revive(q),H,U,Z),void 0,Z)}registerOnTypeFormattingEditProvider(M,q,H,U){const Z=this.t(new fe(this.h,H),M);return this.e.$registerOnTypeFormattingSupport(Z,this.o(q,M),U,M.identifier),this.p(Z)}$provideOnTypeFormattingEdits(M,q,H,U,Z,Y){return this.s(M,fe,Ee=>Ee.provideOnTypeFormattingEdits(E.URI.revive(q),H,U,Z,Y),void 0,Y)}registerWorkspaceSymbolProvider(M,q){const H=this.t(new be(q,this.l),M);return this.e.$registerNavigateTypeSupport(H,typeof q.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(M,q,H){return this.s(M,be,U=>U.provideWorkspaceSymbols(q,H),{symbols:[]},H)}$resolveWorkspaceSymbol(M,q,H){return this.s(M,be,U=>U.resolveWorkspaceSymbol(q,H),void 0,void 0)}$releaseWorkspaceSymbols(M,q){this.s(M,be,H=>H.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(M,q,H){const U=this.t(new ye(this.h,H,this.l),M);return this.e.$registerRenameSupport(U,this.o(q,M),ye.supportsResolving(H)),this.p(U)}$provideRenameEdits(M,q,H,U,Z){return this.s(M,ye,Y=>Y.provideRenameEdits(E.URI.revive(q),H,U,Z),void 0,Z)}$resolveRenameLocation(M,q,H,U){return this.s(M,ye,Z=>Z.resolveRenameLocation(E.URI.revive(q),H,U),void 0,U)}registerDocumentSemanticTokensProvider(M,q,H,U){const Z=this.t(new ve(this.h,H),M),Y=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Z,this.o(q,M),U,Y);let Ee=this.p(Z);if(Y){const Te=H.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(Y));Ee=F.$SK.from(Ee,Te)}return Ee}$provideDocumentSemanticTokens(M,q,H,U){return this.s(M,ve,Z=>Z.provideDocumentSemanticTokens(E.URI.revive(q),H,U),null,U)}$releaseDocumentSemanticTokens(M,q){this.s(M,ve,H=>H.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(M,q,H,U){const Z=this.t(new ee(this.h,H),M);return this.e.$registerDocumentRangeSemanticTokensProvider(Z,this.o(q,M),U),this.p(Z)}$provideDocumentRangeSemanticTokens(M,q,H,U){return this.s(M,ee,Z=>Z.provideDocumentRangeSemanticTokens(E.URI.revive(q),H,U),null,U)}registerCompletionItemProvider(M,q,H,U){const Z=this.t(new ke(this.h,this.j.converter,H,this.m,M),M);return this.e.$registerCompletionsProvider(Z,this.o(q,M),U,ke.supportsResolving(H),M.identifier),this.p(Z)}$provideCompletionItems(M,q,H,U,Z){return this.s(M,ke,Y=>Y.provideCompletionItems(E.URI.revive(q),H,U,Z),void 0,Z)}$resolveCompletionItem(M,q,H){return this.s(M,ke,U=>U.resolveCompletionItem(q,H),void 0,H)}$releaseCompletionItems(M,q){this.s(M,ke,H=>H.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(M,q,H,U){const Z=new _(M,this.h,H,this.j.converter),Y=this.t(Z,M);return this.e.$registerInlineCompletionsSupport(Y,this.o(q,M),Z.supportsHandleEvents,b.$im.toKey(M.identifier.value),U?.yieldTo?.map(Ee=>b.$im.toKey(Ee))||[]),this.p(Y)}$provideInlineCompletions(M,q,H,U,Z){return this.s(M,se,Y=>Y.provideInlineCompletions(E.URI.revive(q),H,U,Z),void 0,Z)}$handleInlineCompletionDidShow(M,q,H,U){this.s(M,se,async Z=>{Z.handleDidShowCompletionItem(q,H,U)},void 0,void 0)}$handleInlineCompletionPartialAccept(M,q,H,U){this.s(M,se,async Z=>{Z.handlePartialAccept(q,H,U)},void 0,void 0)}$freeInlineCompletionsList(M,q){this.s(M,se,async H=>{H.disposeCompletions(q)},void 0,void 0)}registerSignatureHelpProvider(M,q,H,U){const Z=Array.isArray(U)?{triggerCharacters:U,retriggerCharacters:[]}:U,Y=this.t(new ne(this.h,H),M);return this.e.$registerSignatureHelpProvider(Y,this.o(q,M),Z),this.p(Y)}$provideSignatureHelp(M,q,H,U,Z){return this.s(M,ne,Y=>Y.provideSignatureHelp(E.URI.revive(q),H,U,Z),void 0,Z)}$releaseSignatureHelp(M,q){this.s(M,ne,H=>H.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(M,q,H){const U=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,Z=this.t(new Ie(this.h,this.j.converter,H,this.l,M),M);this.e.$registerInlayHintsProvider(Z,this.o(q,M),typeof H.resolveInlayHint=="function",U,le.u(M));let Y=this.p(Z);if(U!==void 0){const Ee=H.onDidChangeInlayHints(Te=>this.e.$emitInlayHintsEvent(U));Y=F.$SK.from(Y,Ee)}return Y}$provideInlayHints(M,q,H,U){return this.s(M,Ie,Z=>Z.provideInlayHints(E.URI.revive(q),H,U),void 0,U)}$resolveInlayHint(M,q,H){return this.s(M,Ie,U=>U.resolveInlayHint(q,H),void 0,H)}$releaseInlayHints(M,q){this.s(M,Ie,H=>H.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(M,q,H){const U=this.t(new Ae(this.h,H),M);return this.e.$registerDocumentLinkProvider(U,this.o(q,M),typeof H.resolveDocumentLink=="function"),this.p(U)}$provideDocumentLinks(M,q,H){return this.s(M,Ae,U=>U.provideLinks(E.URI.revive(q),H),void 0,H,q.scheme==="output")}$resolveDocumentLink(M,q,H){return this.s(M,Ae,U=>U.resolveLink(q,H),void 0,void 0,!0)}$releaseDocumentLinks(M,q){this.s(M,Ae,H=>H.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(M,q,H){const U=this.t(new Pe(this.h,H),M);return this.e.$registerDocumentColorProvider(U,this.o(q,M)),this.p(U)}$provideDocumentColors(M,q,H){return this.s(M,Pe,U=>U.provideColors(E.URI.revive(q),H),[],H)}$provideColorPresentations(M,q,H,U){return this.s(M,Pe,Z=>Z.provideColorPresentations(E.URI.revive(q),H,U),void 0,U)}registerFoldingRangeProvider(M,q,H){const U=this.q(),Z=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(U,new Fe(new ce(this.h,H),M)),this.e.$registerFoldingRangeProvider(U,this.o(q,M),M.identifier,Z);let Y=this.p(U);if(Z!==void 0){const Ee=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Z));Y=F.$SK.from(Y,Ee)}return Y}$provideFoldingRanges(M,q,H,U){return this.s(M,ce,Z=>Z.provideFoldingRanges(E.URI.revive(q),H,U),void 0,U)}registerSelectionRangeProvider(M,q,H){const U=this.t(new ie(this.h,H,this.l),M);return this.e.$registerSelectionRangeProvider(U,this.o(q,M)),this.p(U)}$provideSelectionRanges(M,q,H,U){return this.s(M,ie,Z=>Z.provideSelectionRanges(E.URI.revive(q),H,U),[],U)}registerCallHierarchyProvider(M,q,H){const U=this.t(new Q(this.h,H),M);return this.e.$registerCallHierarchyProvider(U,this.o(q,M)),this.p(U)}$prepareCallHierarchy(M,q,H,U){return this.s(M,Q,Z=>Promise.resolve(Z.prepareSession(E.URI.revive(q),H,U)),void 0,U)}$provideCallHierarchyIncomingCalls(M,q,H,U){return this.s(M,Q,Z=>Z.provideCallsTo(q,H,U),void 0,U)}$provideCallHierarchyOutgoingCalls(M,q,H,U){return this.s(M,Q,Z=>Z.provideCallsFrom(q,H,U),void 0,U)}$releaseCallHierarchy(M,q){this.s(M,Q,H=>Promise.resolve(H.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(M,q,H){const U=this.t(new te(this.h,H),M);return this.e.$registerTypeHierarchyProvider(U,this.o(q,M)),this.p(U)}$prepareTypeHierarchy(M,q,H,U){return this.s(M,te,Z=>Promise.resolve(Z.prepareSession(E.URI.revive(q),H,U)),void 0,U)}$provideTypeHierarchySupertypes(M,q,H,U){return this.s(M,te,Z=>Z.provideSupertypes(q,H,U),void 0,U)}$provideTypeHierarchySubtypes(M,q,H,U){return this.s(M,te,Z=>Z.provideSubtypes(q,H,U),void 0,U)}$releaseTypeHierarchy(M,q){this.s(M,te,H=>Promise.resolve(H.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(M,q,H,U){const Z=this.q();this.f.set(Z,new Fe(new me(this.e,this.h,H,Z,M),M));const Y=(0,i.$oF)(M,"dropMetadata")&&U?me.toInternalProviderId(M.identifier.value,U.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Z,this.o(q,M),Y,(0,i.$oF)(M,"dropMetadata")?U:void 0),this.p(Z)}$provideDocumentOnDropEdits(M,q,H,U,Z,Y){return this.s(M,me,Ee=>Promise.resolve(Ee.provideDocumentOnDropEdits(q,E.URI.revive(H),U,Z,Y)),void 0,void 0)}registerMappedEditsProvider(M,q,H){const U=this.t(new pe(this.h,H),M);return this.e.$registerMappedEditsProvider(U,this.o(q,M)),this.p(U)}$provideMappedEdits(M,q,H,U,Z){return this.s(M,pe,Y=>Promise.resolve(Y.provideMappedEdits(q,H,U,Z)),null,Z)}registerDocumentPasteEditProvider(M,q,H,U){const Z=this.q();this.f.set(Z,new Fe(new C(this.e,this.h,H,Z,M),M));const Y=C.toInternalProviderId(M.identifier.value,U.id);return this.e.$registerPasteEditProvider(Z,this.o(q,M),Y,{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,copyMimeTypes:U.copyMimeTypes,pasteMimeTypes:U.pasteMimeTypes}),this.p(Z)}$prepareDocumentPaste(M,q,H,U,Z){return this.s(M,C,Y=>Y.prepareDocumentPaste(E.URI.revive(q),H,U,Z),void 0,Z)}$providePasteEdits(M,q,H,U,Z,Y){return this.s(M,C,Ee=>Ee.providePasteEdits(q,E.URI.revive(H),U,Z,Y),void 0,Y)}static w(M){return{pattern:M.source,flags:M.flags}}static y(M){return{decreaseIndentPattern:le.w(M.decreaseIndentPattern),increaseIndentPattern:le.w(M.increaseIndentPattern),indentNextLinePattern:M.indentNextLinePattern?le.w(M.indentNextLinePattern):void 0,unIndentedLinePattern:M.unIndentedLinePattern?le.w(M.unIndentedLinePattern):void 0}}static z(M){return{beforeText:le.w(M.beforeText),afterText:M.afterText?le.w(M.afterText):void 0,previousLineText:M.previousLineText?le.w(M.previousLineText):void 0,action:M.action}}static B(M){return M.map(le.z)}static C(M){return{open:M.open,close:M.close,notIn:M.notIn?M.notIn.map(q=>F.SyntaxTokenType.toString(q)):void 0}}static D(M){return M.map(le.C)}setLanguageConfiguration(M,q,H){const{wordPattern:U}=H;if(U&&(0,g.$Ve)(U))throw new Error(`Invalid language configuration: wordPattern '${U}' is not allowed to match the empty string.`);U?this.h.setWordDefinitionFor(q,U):this.h.setWordDefinitionFor(q,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",M,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",M,"Do not use.");const Z=this.q(),Y={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?le.w(H.wordPattern):void 0,indentationRules:H.indentationRules?le.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?le.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?le.D(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(Z,q,Y),this.p(Z)}$setWordDefinitions(M){for(const q of M)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$nfc=le}),define(Ce[255],Re([1,0,3,8,7,31,13,6,23]),function(ge,e,E,T,I,F,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=void 0;class w{constructor(D,l,p,b){this.c=l,this.d=p,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=D.getProxy(E.$QK.MainThreadLanguages)}$acceptLanguageIds(D){this.b=D}async getLanguages(){return this.b.slice(0)}async changeLanguage(D,l){await this.a.$changeLanguage(D,l);const p=this.c.getDocumentData(D);if(!p)throw new Error(`document '${D.toString()}' NOT found`);return p.document}async tokenAtPosition(D,l){const p=D.version,b=T.Position.from(l),r=await this.a.$tokensAtPosition(D.uri,b),o={type:I.StandardTokenType.Other,range:D.getWordRangeAtPosition(l)??new I.$UK(l.line,l.character,l.line,l.character)};if(!r)return o;const t={range:T.Range.to(r.range),type:T.TokenType.to(r.type)};return!t.range.contains(l)||p!==D.version?o:t}createLanguageStatusItem(D,l,p){const b=this.f++,r=this.a,o=this.g,t=`${D.identifier.value}/${l}`;if(o.has(t))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);o.add(t);const n={selector:p,id:l,name:D.displayName??D.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let a;const c=new $.$Rc,h=()=>{if(a?.dispose(),!o.has(t)){console.warn(`LanguageStatusItem (${l}) from ${D.identifier.value} has been disposed and CANNOT be updated anymore`);return}a=(0,R.$5g)(()=>{c.clear(),this.a.$setLanguageStatus(b,{id:t,name:n.name??D.displayName??D.name,source:D.displayName??D.name,selector:T.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===I.LanguageStatusSeverity.Error?F.default.Error:n.severity===I.LanguageStatusSeverity.Warning?F.default.Warning:F.default.Info,command:n.command&&this.d.toInternal(n.command,c),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},i={dispose(){c.dispose(),a?.dispose(),r.$removeLanguageStatus(b),o.delete(t)},get id(){return n.id},get name(){return n.name},set name(s){n.name=s,h()},get selector(){return n.selector},set selector(s){n.selector=s,h()},get text(){return n.text},set text(s){n.text=s,h()},set text2(s){(0,g.$pF)(D,"languageStatusText"),n.text=s,h()},get text2(){return(0,g.$pF)(D,"languageStatusText"),n.text},get detail(){return n.detail},set detail(s){n.detail=s,h()},get severity(){return n.severity},set severity(s){n.severity=s,h()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(s){n.accessibilityInformation=s,h()},get command(){return n.command},set command(s){n.command=s,h()},get busy(){return n.busy},set busy(s){n.busy=s,h()}};return h(),i}}e.$Mgc=w}),define(Ce[82],Re([1,0,21,11,2,4,14,3,27,17]),function(ge,e,E,T,I,F,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=e.$$fc=void 0;let A=class{constructor(l,p,b){this.f=b,this.d=new Map,this.a=p.getProxy($.$QK.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===E.$g}getMessage(l,p){const{message:b,args:r,comment:o}=p;if(this.c)return(0,T.$Ie)(b,r??{});let t=b;o&&o.length>0&&(t+=`/${Array.isArray(o)?o.join(""):o}`);const n=this.d.get(l)?.contents[t];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${t}`),(0,T.$Ie)(n??b,r??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let p;const b=await this.g(l);if(!b){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(b),o=JSON.parse(r);p=l.isBuiltin?o.contents?.bundle:o}catch(r){this.f.error(`Failed to load translations for ${l.identifier.value} from ${b}: ${r.message}`);return}p&&this.d.set(l.identifier.value,{contents:p,uri:b})}async g(l){if(l.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return I.URI.revive(p)}return l.l10n?I.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$$fc=A,e.$$fc=A=Ge([Ke(0,g.$$M),Ke(1,w.$UM),Ke(2,R.$kj)],A),e.$_fc=(0,F.$3h)("IExtHostLocalizationService")}),define(Ce[256],Re([1,0,14,3,27,17,2,51]),function(ge,e,E,T,I,F,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lhc=void 0;let g=class extends E.$vj{constructor(D,l){super(l.logLevel,l.logsLocation,l.loggers.map(p=>(0,$.$zh)(p))),this.r=D.getProxy(T.$QK.MainThreadLogger)}$setLogLevel(D,l){l?this.setLogLevel(R.URI.revive(l),D):this.setLogLevel(D)}setVisibility(D,l){super.setVisibility(D,l),this.r.$setVisibility(D,l)}s(D,l,p){return new w(this.r,D,l,p)}};e.$lhc=g,e.$lhc=g=Ge([Ke(0,F.$UM),Ke(1,I.$$M)],g);class w extends E.$qj{constructor(D,l,p,b){super(b?.logLevel==="always"),this.r=D,this.s=l,this.m=!1,this.n=[],this.setLevel(p),this.r.$createLogger(l,b).then(()=>{this.u(this.n),this.m=!0})}g(D,l){const p=[[D,l]];this.m?this.u(p):this.n.push(...p)}u(D){this.r.$log(this.s,D)}flush(){this.r.$flush(this.s)}}}),define(Ce[83],Re([1,0,3,4,6,17,24]),function(ge,e,E,T,I,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=e.$agc=void 0,e.$agc=(0,T.$3h)("IExtHostManagedSockets");let $=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(E.$QK.MainThreadManagedSockets)}setFactory(D,l){for(const p of this.d.values())p.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new g(D,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const l=++this.b,p=await this.c.makeConnection(),b=new I.$Rc;return this.d.set(l,new w(l,p,b)),b.add((0,I.$Qc)(()=>this.d.delete(l))),b.add(p.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),b.dispose()})),b.add(p.onDidClose(r=>{this.a.$onDidManagedSocketClose(l,r?.stack??r?.message),b.dispose()})),b.add(p.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(l,R.$ge.wrap(r)))),l}$remoteSocketWrite(D,l){this.d.get(D)?.actual.send(l.buffer)}$remoteSocketEnd(D){const l=this.d.get(D);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$bgc=$,e.$bgc=$=Ge([Ke(0,F.$UM)],$);class g{constructor(D,l){this.socketFactoryId=D,this.makeConnection=l}}class w extends I.$Sc{constructor(D,l,p){super(),this.socketId=D,this.actual=l,this.B(p)}}}),define(Ce[257],Re([1,0,3,14,23]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=void 0;function F($){return $&&$.title}let R=class{constructor(g,w){this.b=w,this.a=g.getProxy(E.$QK.MainThreadMessageService)}showMessage(g,w,A,D,l){const p={source:{identifier:g.identifier,label:g.displayName||g.name}};let b;typeof D=="string"||F(D)?b=[D,...l]:(p.modal=D?.modal,p.useCustom=D?.useCustom,p.detail=D?.detail,b=l),p.useCustom&&(0,I.$pF)(g,"resolvers");const r=[];let o=!1;for(let t=0;t<b.length;t++){const n=b[t];if(typeof n=="string")r.push({title:n,handle:t,isCloseAffordance:!1});else if(typeof n=="object"){const{title:a,isCloseAffordance:c}=n;r.push({title:a,isCloseAffordance:!!c,handle:t}),c&&(o?this.b.warn(`[${g.identifier}] Only one message item can have 'isCloseAffordance':`,n):o=!0)}else this.b.warn(`[${g.identifier}] Invalid message item:`,n)}return this.a.$showMessage(w,A,p,r).then(t=>{if(typeof t=="number")return b[t]})}};e.$Ngc=R,e.$Ngc=R=Ge([Ke(1,T.$kj)],R)}),define(Ce[258],Re([1,0,18,13,20,5,6,28,2,22,14,3,32,8,7,78,211,23,49]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l,p,b,r,o,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=e.$Rgc=void 0;let a=class{constructor(f,S,L,v,y){this.m=S,this.n=L,this.o=v,this.q=y,this.b=new $.$Ac,this.c=new $.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new F.$Sd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=f.getProxy(D.$QK.MainThreadNotebookKernels);const k=new l.$iN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$gN("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const O=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:O}}else if(N&&"notebookEditor"in N){const O=this.n.getIdByEditor(N.notebookEditor);if(O===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:O}}return N})],l.$hN.Void);this.o.registerApiCommand(k)}createNotebookController(f,S,L,v,y,k){for(const ee of this.j.values())if(ee.controller.id===S&&w.$im.equals(f.identifier,ee.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const N=this.k++,O=this;this.q.trace(`NotebookController[${N}], CREATED by ${f.identifier.value}, ${S}`);const K=()=>console.warn(`NO execute handler from notebook controller '${C.id}' of extension: '${f.identifier}'`);let j=!1;const W=new F.$Sd,P=new F.$Sd,C={id:d(f.identifier,S),notebookType:L,extensionId:f.identifier,extensionLocation:f.extensionLocation,label:v||f.identifier.value,preloads:k?k.map(p.NotebookRendererScript.from):[]};let J=y??K,ae,fe;this.a.$addKernel(N,C).catch(ee=>{console.log(ee),j=!0});let be=0;const ye=()=>{if(j)return;const ee=++be;Promise.resolve().then(()=>{ee===be&&this.a.$updateKernel(N,C)})},he=new $.$Ac,ve={get id(){return S},get notebookType(){return C.notebookType},onDidChangeSelectedNotebooks:W.event,get label(){return C.label},set label(ee){C.label=ee??f.displayName??f.name,ye()},get detail(){return C.detail??""},set detail(ee){C.detail=ee,ye()},get description(){return C.description??""},set description(ee){C.description=ee,ye()},get supportedLanguages(){return C.supportedLanguages},set supportedLanguages(ee){C.supportedLanguages=ee,ye()},get supportsExecutionOrder(){return C.supportsExecutionOrder??!1},set supportsExecutionOrder(ee){C.supportsExecutionOrder=ee,ye()},get rendererScripts(){return C.preloads?C.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return J},set executeHandler(ee){J=ee??K},get interruptHandler(){return ae},set interruptHandler(ee){ae=ee,C.supportsInterrupt=!!ee,ye()},set variableProvider(ee){(0,t.$pF)(f,"notebookVariableProvider"),fe=ee,C.hasVariableProvider=!!ee,ee?.onDidChangeVariables(ke=>O.a.$variablesUpdated(ke.uri)),ye()},get variableProvider(){return fe},createNotebookCellExecution(ee){if(j)throw new Error("notebook controller is DISPOSED");if(!he.has(ee.notebook.uri))throw O.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(he.keys()).map(ke=>ke.toString())),new Error(`notebook controller is NOT associated to notebook: ${ee.notebook.uri.toString()}`);return O._createNotebookCellExecution(ee,d(f.identifier,this.id))},createNotebookExecution(ee){if((0,t.$pF)(f,"notebookExecution"),j)throw new Error("notebook controller is DISPOSED");if(!he.has(ee.uri))throw O.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(he.keys()).map(ke=>ke.toString())),new Error(`notebook controller is NOT associated to notebook: ${ee.uri.toString()}`);return O._createNotebookExecution(ee,d(f.identifier,this.id))},dispose:()=>{j||(this.q.trace(`NotebookController[${N}], DISPOSED`),j=!0,this.j.delete(N),W.dispose(),P.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity(ee,ke){ke===b.NotebookControllerAffinity2.Hidden&&(0,t.$pF)(f,"notebookControllerAffinityHidden"),O.a.$updateNotebookPriority(N,ee.uri,ke)},onDidReceiveMessage:P.event,postMessage(ee,ke){return(0,t.$pF)(f,"notebookMessaging"),O.a.$postMessage(N,ke&&O.n.getIdByEditor(ke),ee)},asWebviewUri(ee){return(0,t.$pF)(f,"notebookMessaging"),(0,r.$lvb)(ee,O.m.remote)}};return this.j.set(N,{extensionId:f.identifier,controller:ve,onDidReceiveMessage:P,onDidChangeSelection:W,associatedNotebooks:he}),ve}getIdByController(f){for(const[S,L]of this.j)if(L.controller===f)return d(L.extensionId,f.id);return null}createNotebookControllerDetectionTask(f,S){const L=this.g++,v=this;this.q.trace(`NotebookControllerDetectionTask[${L}], CREATED by ${f.identifier.value}`),this.a.$addKernelDetectionTask(L,S);const y={dispose:()=>{this.f.delete(L),v.a.$removeKernelDetectionTask(L)}};return this.f.set(L,y),y}registerKernelSourceActionProvider(f,S,L){const v=this.i++,y=typeof L.onDidChangeNotebookKernelSourceActions=="function"?v:void 0,k=this;this.h.set(v,L),this.q.trace(`NotebookKernelSourceActionProvider[${v}], CREATED by ${f.identifier.value}`),this.a.$addKernelSourceActionProvider(v,v,S);let N;return y!==void 0&&(N=L.onDidChangeNotebookKernelSourceActions(O=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(v),k.a.$removeKernelSourceActionProvider(v,v),N?.dispose()}}}async $provideKernelSourceActions(f,S){const L=this.h.get(f);if(L){const v=new R.$Rc;return(await L.provideNotebookKernelSourceActions(S)??[]).map(k=>p.NotebookKernelSourceAction.from(k,this.o.converter,v))}return[]}$acceptNotebookAssociation(f,S,L){const v=this.j.get(f);if(v){const y=this.n.getNotebookDocument(g.URI.revive(S));L?v.associatedNotebooks.set(y.uri,!0):v.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${f}] ASSOCIATE notebook`,y.uri.toString(),L),v.onDidChangeSelection.fire({selected:L,notebook:y.apiNotebook})}}async $executeCells(f,S,L){const v=this.j.get(f);if(!v)return;const y=this.n.getNotebookDocument(g.URI.revive(S)),k=[];for(const N of L){const O=y.getCell(N);O&&k.push(O.apiCell)}try{this.q.trace(`NotebookController[${f}] EXECUTE cells`,y.uri.toString(),k.length),await v.controller.executeHandler.call(v.controller,k,y.apiNotebook,v.controller)}catch(N){this.q.error(`NotebookController[${f}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(f,S,L){const v=this.j.get(f);if(!v)return;const y=this.n.getNotebookDocument(g.URI.revive(S));if(v.controller.interruptHandler)await v.controller.interruptHandler.call(v.controller,y.apiNotebook);else for(const k of L){const N=y.getCell(k);N&&this.b.get(N.uri)?.cancel()}if(v.controller.interruptHandler){const k=this.c.get(y.uri);L.length&&Array.isArray(k)&&k.length&&k.forEach(N=>N.dispose())}}async $provideVariables(f,S,L,v,y,k,N){const O=this.j.get(f);if(!O)return;const K=this.n.getNotebookDocument(g.URI.revive(L)),j=O.controller.variableProvider;if(!j)return;const W=v?{name:v,value:""}:void 0,P=y==="named"?b.NotebookVariablesRequestKind.Named:b.NotebookVariablesRequestKind.Indexed,C=j.provideVariables(K.apiNotebook,W,P,k,N);for await(const J of C){if(N.isCancellationRequested)return;this.a.$receiveVariable(S,J)}}$acceptKernelMessageFromRenderer(f,S,L){const v=this.j.get(f);if(!v)return;const y=this.n.getEditorById(S);v.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:L}))}$cellExecutionChanged(f,S,L){const y=this.n.getNotebookDocument(g.URI.revive(f)).getCell(S);if(y){const k=L?p.NotebookCellExecutionState.to(L):b.NotebookCellExecutionState.Idle;k!==void 0&&this.l.fire({cell:y.apiCell,state:k})}}_createNotebookCellExecution(f,S){if(f.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const v=this.n.getNotebookDocument(f.notebook.uri).getCellFromApiCell(f);if(!v)throw new Error("invalid cell");if(this.b.has(v.uri))throw new Error(`duplicate execution for ${v.uri}`);const y=new h(S,v,this.a);this.b.set(v.uri,y);const k=y.onDidChangeState(()=>{y.state===c.Resolved&&(y.dispose(),k.dispose(),this.b.delete(v.uri))});return y.asApiObject()}_createNotebookExecution(f,S){const L=this.n.getNotebookDocument(f.uri),v=f.getCells().find(N=>{const O=L.getCellFromApiCell(N);return O&&this.b.has(O.uri)});if(v)throw new Error(`duplicate cell execution for ${v.document.uri}`);if(this.c.has(L.uri))throw new Error(`duplicate notebook execution for ${L.uri}`);const y=new s(S,L,this.a),k=y.onDidChangeState(()=>{y.state===i.Resolved&&(y.dispose(),k.dispose(),this.c.delete(L.uri))});return this.c.set(L.uri,[y,k]),y.asApiObject()}};e.$Rgc=a,e.$Rgc=a=Ge([Ke(4,A.$kj)],a);var c;(function(m){m[m.Init=0]="Init",m[m.Started=1]="Started",m[m.Resolved=2]="Resolved"})(c||(c={}));class h extends R.$Sc{static{this.a=0}get state(){return this.f}constructor(f,S,L){super(),this.m=S,this.n=L,this.b=h.a++,this.c=new F.$Sd,this.onDidChangeState=this.c.event,this.f=c.Init,this.g=this.B(new I.$3d),this.h=new u(10,v=>this.s(v)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,f,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(f){await this.h.addItem(f)}async s(f){const S=Array.isArray(f)?f:[f];return this.n.$updateExecution(this.b,new n.$Gv(S))}t(){if(this.f===c.Init)throw new Error("Must call start before modifying cell output");if(this.f===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(f){let S=this.m;if(f&&(S=this.m.notebook.getCellFromApiCell(f)),!S)throw new Error("INVALID cell");return S.handle}y(f){return f.map(S=>{const L=b.$iM.ensureUniqueMimeTypes(S.items,!0);return L===S.items?p.NotebookCellOutput.from(S):p.NotebookCellOutput.from({items:L,id:S.id,metadata:S.metadata})})}async z(f,S,L){const v=this.w(S),y=this.y((0,E.$3b)(f));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:v,append:L,outputs:y})}async C(f,S,L){return f=b.$iM.ensureUniqueMimeTypes((0,E.$3b)(f),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:f.map(p.NotebookCellOutputItem.from),outputId:S.id,append:L})}asApiObject(){const f=this;return Object.freeze({get token(){return f.g.token},get cell(){return f.m.apiCell},get executionOrder(){return f.j},set executionOrder(L){f.j=L,f.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:f.j}])},start(L){if(f.f===c.Resolved||f.f===c.Started)throw new Error("Cannot call start again");f.f=c.Started,f.c.fire(),f.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:L})},end(L,v){if(f.f===c.Resolved)throw new Error("Cannot call resolve twice");f.f=c.Resolved,f.c.fire(),f.h.flush(),f.n.$completeExecution(f.b,new n.$Gv({runEndTime:v,lastRunSuccess:L}))},clearOutput(L){return f.t(),f.z([],L,!1)},appendOutput(L,v){return f.t(),f.z(L,v,!0)},replaceOutput(L,v){return f.t(),f.z(L,v,!1)},appendOutputItems(L,v){return f.t(),f.C(L,v,!0)},replaceOutputItems(L,v){return f.t(),f.C(L,v,!1)}})}}var i;(function(m){m[m.Init=0]="Init",m[m.Started=1]="Started",m[m.Resolved=2]="Resolved"})(i||(i={}));class s extends R.$Sc{static{this.a=0}get state(){return this.f}constructor(f,S,L){super(),this.h=S,this.j=L,this.b=s.a++,this.c=new F.$Sd,this.onDidChangeState=this.c.event,this.f=i.Init,this.g=this.B(new I.$3d),this.j.$createNotebookExecution(this.b,f,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===i.Resolved||this.f===i.Started)throw new Error("Cannot call start again");this.f=i.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===i.Resolved)throw new Error("Cannot call resolve twice");this.f=i.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class u{constructor(f,S){this.f=f,this.g=S,this.a=[],this.b=Date.now()}addItem(f){return this.a.push(f),this.c||(this.c=new T.$nh,this.b=Date.now(),(0,T.$4g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const f=this.c;this.c=void 0;const S=this.a;return this.a=[],this.g(S).finally(()=>f.complete())}}function d(m,f){return`${m.value}/${f}`}e.$Sgc=d}),define(Ce[259],Re([1,0,5,3,107]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tgc=void 0;class F{constructor($,g){this.c=g,this.a=new Map,this.b=$.getProxy(T.$QK.MainThreadNotebookRenderers)}$postRendererMessage($,g,w){const A=this.c.getEditorById($);this.a.get(g)?.fire({editor:A.apiEditor,message:w})}createRendererMessaging($,g){if(!$.contributes?.notebookRenderer?.some(A=>A.id===g))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${g})`);return{onDidReceiveMessage:(A,D,l)=>this.d(g).event(A,D,l),postMessage:(A,D)=>{I.$zgc.apiEditorsToExtHost.has(A)&&([A,D]=[D,A]);const l=D&&I.$zgc.apiEditorsToExtHost.get(D);return this.b.$postMessage(l?.id,g,A)}}}d($){let g=this.a.get($);return g||(g=new E.$Sd({onDidRemoveLastListener:()=>{g?.dispose(),this.a.delete($)}}),this.a.set($,g),g)}}e.$Tgc=F}),define(Ce[260],Re([1,0,6,16,2,23,3]),function(ge,e,E,T,I,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=void 0;class ${constructor(w){this.b=new Map,this.a=w.getProxy(R.$QK.MainThreadProfileContentHandlers)}registrProfileContentHandler(w,A,D){if((0,F.$pF)(w,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,D),this.a.$registerProfileContentHandler(A,D.name,D.description,w.identifier.value),(0,E.$Qc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(w,A,D,l){const p=this.b.get(w);if(!p)throw new Error(`Unknown handler with id: ${w}`);return p.saveProfile(A,D,l)}async $readProfile(w,A,D){const l=this.b.get(w);if(!l)throw new Error(`Unknown handler with id: ${w}`);return l.readProfile((0,T.$Ff)(A)?A:I.URI.revive(A),D)}}e.$Wgc=$}),define(Ce[261],Re([1,0,2,3,13,8]),function(ge,e,E,T,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=void 0;class R{static{this.a=0}constructor(g,w){this.d=w,this.c=new Map,this.b=g.getProxy(T.$QK.MainThreadQuickDiff)}$provideOriginalResource(g,w,A){const D=E.URI.revive(w),l=this.c.get(g);return l?(0,I.$Vg)(()=>l.provideOriginalResource(D,A)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider(g,w,A,D){const l=R.a++;return this.c.set(l,w),this.b.$registerQuickDiffProvider(l,F.DocumentSelector.from(g,this.d),A,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$Ygc=R}),define(Ce[262],Re([1,0,20,5,6,3,2,7,15,18,31,45,23,8]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=void 0;function b(r,o,t){const n=r.getProxy(F.$QK.MainThreadQuickOpen);class a{constructor(S,L){this.e=new Map,this.f=0,this.a=S,this.b=L}showQuickPick(S,L,v,y=E.CancellationToken.None){this.c=void 0;const k=Promise.resolve(L),N=++this.f,O=n.$show(N,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},y),K={},j=O.then(()=>K);return Promise.race([j,k]).then(W=>{if(W===K)return;const P=(0,l.$oF)(S,"quickPickItemTooltip");return k.then(C=>{const J=[];for(let ae=0;ae<C.length;ae++){const fe=C[ae];if(typeof fe=="string")J.push({label:fe,handle:ae});else if(fe.kind===$.QuickPickItemKind.Separator)J.push({type:"separator",label:fe.label});else{fe.tooltip&&!P&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const be=fe.iconPath?u(fe.iconPath):void 0;J.push({label:fe.label,iconPath:be?.iconPath,iconClass:be?.iconClass,description:fe.description,detail:fe.detail,picked:fe.picked,alwaysShow:fe.alwaysShow,tooltip:P?p.MarkdownString.fromStrict(fe.tooltip):void 0,handle:ae})}}return v&&typeof v.onDidSelectItem=="function"&&(this.c=ae=>{v.onDidSelectItem(C[ae])}),n.$setItems(N,J),O.then(ae=>{if(typeof ae=="number")return C[ae];if(Array.isArray(ae))return ae.map(fe=>C[fe])})})}).then(void 0,W=>{if(!(0,g.$4)(W))return n.$setError(N,W),Promise.reject(W)})}$onItemSelected(S){this.c?.(S)}showInput(S,L=E.CancellationToken.None){return this.d=S?.validateInput,n.$input(S,typeof this.d=="function",L).then(void 0,v=>{if(!(0,g.$4)(v))return Promise.reject(v)})}async $validateInput(S){if(!this.d)return;const L=await this.d(S);if(!L||typeof L=="string")return L;let v;switch(L.severity){case $.InputBoxValidationSeverity.Info:v=A.default.Info;break;case $.InputBoxValidationSeverity.Warning:v=A.default.Warning;break;case $.InputBoxValidationSeverity.Error:v=A.default.Error;break;default:v=L.message?A.default.Error:A.default.Ignore;break}return{content:L.message,severity:v}}async showWorkspaceFolderPick(S,L=E.CancellationToken.None){const v=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!v)return;const y=await this.a.getWorkspaceFolders2();if(y)return y.find(k=>k.uri.toString()===v.uri.toString())}createQuickPick(S){const L=new d(S,()=>this.e.delete(L._id));return this.e.set(L._id,L),L}createInputBox(S){const L=new m(S,()=>this.e.delete(L._id));return this.e.set(L._id,L),L}$onDidChangeValue(S,L){this.e.get(S)?._fireDidChangeValue(L)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,L){const v=this.e.get(S);v instanceof d&&v._fireDidChangeActive(L)}$onDidChangeSelection(S,L){const v=this.e.get(S);v instanceof d&&v._fireDidChangeSelection(L)}$onDidTriggerButton(S,L){this.e.get(S)?._fireDidTriggerButton(L)}$onDidTriggerItemButton(S,L,v){const y=this.e.get(S);y instanceof d&&y._fireDidTriggerItemButton(L,v)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class c{static{this.a=1}constructor(S,L){this.x=S,this.y=L,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$Sd,this.q=new T.$Sd,this.r=new T.$Sd,this.s=new T.$Sd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((L,v)=>{const y=L===$.$bM.Back?-1:v;this.o.set(y,L)}),this.z({buttons:S.map((L,v)=>({...u(L.iconPath),tooltip:L.tooltip,handle:L===$.$bM.Back?-1:v}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const L=this.o.get(S);L&&this.r.fire(L)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.$Nc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(S){if(!this.v){for(const L of Object.keys(S)){const v=S[L];this.u[L]=v===void 0?null:v}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function h(f){if(f instanceof $.$NL)return{id:f.id};const S=s(f),L=i(f);return{dark:typeof S=="string"?R.URI.file(S):S,light:typeof L=="string"?R.URI.file(L):L}}function i(f){return typeof f=="object"&&"light"in f?f.light:f}function s(f){return typeof f=="object"&&"dark"in f?f.dark:f}function u(f){const S=h(f);let L,v;return"id"in S?v=D.ThemeIcon.asClassName(S):L=S,{iconPath:L,iconClass:v}}class d extends c{constructor(S,L){super(S.identifier,L),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$Sd,this.L=[],this.M=new T.$Sd,this.N=new T.$Sd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((y,k)=>{this.C.set(k,y),this.D.set(y,k)});const L=(0,l.$oF)(this.O,"quickPickItemTooltip"),v=[];for(let y=0;y<S.length;y++){const k=S[y];if(k.kind===$.QuickPickItemKind.Separator)v.push({type:"separator",label:k.label});else{k.tooltip&&!L&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const N=k.iconPath?u(k.iconPath):void 0;v.push({handle:y,label:k.label,iconPath:N?.iconPath,iconClass:N?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:L?p.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((O,K)=>({...u(O.iconPath),tooltip:O.tooltip,handle:K}))})}}this.z({items:v})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(L=>this.D.has(L)),this.z({activeItems:this.J.map(L=>this.D.get(L))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(L=>this.D.has(L)),this.z({selectedItems:this.L.map(L=>this.D.get(L))})}_fireDidChangeActive(S){const L=(0,w.$Hb)(S.map(v=>this.C.get(v)));this.J=L,this.K.fire(L)}_fireDidChangeSelection(S){const L=(0,w.$Hb)(S.map(v=>this.C.get(v)));this.L=L,this.M.fire(L)}_fireDidTriggerItemButton(S,L){const v=this.C.get(S);if(!v||!v.buttons||!v.buttons.length)return;const y=v.buttons[L];y&&this.N.fire({button:y,item:v})}}class m extends c{constructor(S,L){super(S.identifier,L),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:A.default.Error}):this.z({validationMessage:S.message,severity:S.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new a(o,t)}e.$Zgc=b}),define(Ce[263],Re([1,0,2,5,66,6,13,3,18,138,14,22,45,8,23,12,21]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l,p,b,r,o){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$2gc=e.$1gc=void 0;function n(N){return N instanceof E.URI}function a(N,O){return N.scheme===r.Schemas.file&&O.scheme===r.Schemas.file&&o.$k?N.toString()===O.toString():N.toString().toLowerCase()===O.toString().toLowerCase()}function c(N){if(N)return typeof N.iconPath=="string"?E.URI.file(N.iconPath):E.URI.isUri(N.iconPath)||l.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function h(N){if(N.icon){if(E.URI.isUri(N.icon))return N.icon;if(l.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const O=N.icon;return{light:O.light,dark:O.dark}}}else return}function i(N,O){if(!N.iconPath&&!O.iconPath)return 0;if(N.iconPath){if(!O.iconPath)return 1}else return-1;const K=typeof N.iconPath=="string"?N.iconPath:E.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,j=typeof O.iconPath=="string"?O.iconPath:E.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,w.$Gq)(K,j)}function s(N,O){let K=0;if(N.strikeThrough!==O.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==O.faded)return N.faded?1:-1;if(N.tooltip!==O.tooltip)return(N.tooltip||"").localeCompare(O.tooltip||"");if(K=i(N,O),K!==0)return K;if(N.light&&O.light)K=i(N.light,O.light);else{if(N.light)return 1;if(O.light)return-1}if(K!==0)return K;if(N.dark&&O.dark)K=i(N.dark,O.dark);else{if(N.dark)return 1;if(O.dark)return-1}return K}function u(N,O){if(N.command!==O.command)return N.command<O.command?-1:1;if(N.title!==O.title)return N.title<O.title?-1:1;if(N.tooltip!==O.tooltip){if(N.tooltip!==void 0&&O.tooltip!==void 0)return N.tooltip<O.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(N.arguments===O.arguments)return 0;if(N.arguments)if(O.arguments){if(N.arguments.length!==O.arguments.length)return N.arguments.length-O.arguments.length}else return 1;else return-1;for(let K=0;K<N.arguments.length;K++){const j=N.arguments[K],W=O.arguments[K];if(j!==W&&!(n(j)&&n(W)&&a(j,W)))return j<W?-1:1}return 0}function d(N,O){let K=(0,w.$Gq)(N.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(K!==0)return K;if(N.command&&O.command)K=u(N.command,O.command);else{if(N.command)return 1;if(O.command)return-1}if(K!==0)return K;if(N.decorations&&O.decorations)K=s(N.decorations,O.decorations);else{if(N.decorations)return 1;if(O.decorations)return-1}return K}function m(N,O){for(let K=0;K<N.length;K++)if(N[K]!==O[K])return!1;return!0}function f(N,O){return N.command===O.command&&N.title===O.title&&N.tooltip===O.tooltip&&(N.arguments&&O.arguments?m(N.arguments,O.arguments):N.arguments===O.arguments)}function S(N,O){return(0,g.$ub)(N,O,f)}class L{#e;#t;get value(){return this.d}set value(O){O=O??"",this.#e.$setInputBoxValue(this.l,O),this.n(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){this.#e.$setInputBoxPlaceholder(this.l,O),this.f=O}get validateInput(){return(0,b.$pF)(this.k,"scmValidation"),this.g}set validateInput(O){if((0,b.$pF)(this.k,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=O,this.#e.$setValidationProviderIsEnabled(this.l,!!O)}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,this.#e.$setInputBoxEnablement(this.l,O))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,this.#e.$setInputBoxVisibility(this.l,O))}get document(){return(0,b.$pF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(O,K,j,W,P){this.k=O,this.l=W,this.m=P,this.d="",this.e=new T.$Sd,this.f="",this.h=!0,this.j=!0,this.#t=K,this.#e=j}showValidationMessage(O,K){(0,b.$pF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,O,K)}$onInputBoxValueChange(O){this.n(O)}n(O){this.d=O,this.e.fire(O)}}e.$1gc=L;class v{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(O){this.v=O,this.q.$updateGroupLabel(this.t,this.handle,O)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(O){this.p=O,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,K,j,W,P){this.q=O,this.s=K,this.t=j,this.u=W,this.v=P,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$Sd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$Sd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=v.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,K){const j=this.h.get(O);return j?(0,R.$Vg)(()=>this.s.executeCommand(j.command,...j.arguments||[],K)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort(d),j=(0,g.$Db)(this.o,O,d).map(C=>{const J=C.toInsert.map(ae=>{const fe=this.e++;this.g.set(fe,ae);const be=ae.resourceUri;let ye;if(ae.command)if(ae.command.command==="vscode.open"||ae.command.command==="vscode.diff"||ae.command.command==="vscode.changes"){const Ae=new F.$Rc;ye=this.s.converter.toInternal(ae.command,Ae),this.j.set(fe,Ae)}else this.h.set(fe,ae.command);const he=c(ae.decorations),ve=ae.decorations&&c(ae.decorations.light)||he,ee=ae.decorations&&c(ae.decorations.dark)||he,ke=[ve,ee],se=ae.decorations&&ae.decorations.tooltip||"",_=ae.decorations&&!!ae.decorations.strikeThrough,V=ae.decorations&&!!ae.decorations.faded,ne=ae.contextValue||"";return{rawResource:[fe,be,ke,se,_,V,ne,ye],handle:fe}});return{start:C.start,deleteCount:C.deleteCount,toInsert:J}}),W=j.map(({start:C,deleteCount:J,toInsert:ae})=>[C,J,ae.map(fe=>fe.rawResource)]),P=j.reverse();for(const{start:C,deleteCount:J,toInsert:ae}of P){const fe=ae.map(ye=>ye.handle),be=this.n.splice(C,J,...fe);for(const ye of be)this.g.delete(ye),this.h.delete(ye),this.j.get(ye)?.dispose(),this.j.delete(ye)}return this.o=O,W}dispose(){this.l=!0,this.m.fire()}}class y{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(O){this.g!==O&&(this.g=O,this.#e.$updateSourceControl(this.w,{count:O}))}get quickDiffProvider(){return this.h}set quickDiffProvider(O){this.h=O;let K;(0,b.$oF)(this.x,"quickDiffProvider")&&(K=O?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!O,quickDiffLabel:K})}get historyProvider(){return(0,b.$pF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(O){(0,b.$pF)(this.x,"scmHistoryProvider"),this.j=O,this.k.value=new F.$Rc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!O}),O&&this.k.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.l=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(O){O!==this.m&&(this.m=O,this.#e.$updateSourceControl(this.w,{commitTemplate:O}))}get acceptInputCommand(){return this.o}set acceptInputCommand(O){this.n.value=new F.$Rc,this.o=O;const K=this.y.converter.toInternal(O,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:K})}get actionButton(){return(0,b.$pF)(this.x,"scmActionButton"),this.q}set actionButton(O){(0,b.$pF)(this.x,"scmActionButton"),this.p.value=new F.$Rc,this.q=O;const K=O!==void 0?{command:this.y.converter.toInternal(O.command,this.p.value),secondaryCommands:O.secondaryCommands?.map(j=>j.map(W=>this.y.converter.toInternal(W,this.p.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:K??null})}get statusBarCommands(){return this.t}set statusBarCommands(O){if(this.t&&O&&S(this.t,O))return;this.s.value=new F.$Rc,this.t=O;const K=(O||[]).map(j=>this.y.converter.toInternal(j,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:K})}get selected(){return this.u}constructor(O,K,j,W,P,C,J){this.x=O,this.y=W,this.z=P,this.A=C,this.B=J,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new F.$Tc,this.m=void 0,this.n=new F.$Tc,this.o=void 0,this.p=new F.$Tc,this.s=new F.$Tc,this.t=void 0,this.u=!1,this.v=new T.$Sd,this.onDidChangeSelection=this.v.event,this.w=y.d++,this.C=new Map,this.D=new Set,this.#e=j;const ae=E.URI.from({scheme:r.Schemas.vscodeSourceControl,path:`${P}/scm${this.w}/input`,query:J?`rootUri=${encodeURIComponent(J.toString())}`:void 0});this.f=new L(O,K,this.#e,this.w,ae),this.#e.$registerSourceControl(this.w,P,C,J,ae)}createResourceGroup(O,K){const j=new v(this.#e,this.y,this.w,O,K),W=T.Event.once(j.onDidDispose)(()=>this.C.delete(j));return this.C.set(j,W),this.eventuallyAddResourceGroups(),j}eventuallyAddResourceGroups(){const O=[],K=[];for(const[j,W]of this.C){W.dispose();const P=j.onDidUpdateResourceStates(()=>{this.D.add(j),this.eventuallyUpdateResourceStates()});T.Event.once(j.onDidDispose)(()=>{this.D.delete(j),P.dispose(),this.e.delete(j.handle),this.#e.$unregisterGroup(this.w,j.handle)}),O.push([j.handle,j.id,j.label,j.features]);const C=j._takeResourceStateSnapshot();C.length>0&&K.push([j.handle,C]),this.e.set(j.handle,j)}this.#e.$registerGroups(this.w,O,K),this.C.clear()}eventuallyUpdateResourceStates(){const O=[];this.D.forEach(K=>{const j=K._takeResourceStateSnapshot();j.length!==0&&O.push([K.handle,j])}),O.length>0&&this.#e.$spliceResourceStates(this.w,O),this.D.clear()}getResourceGroup(O){return this.e.get(O)}setSelectionState(O){this.u=O,this.v.fire(O)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.w)}}Ge([(0,I.$vh)(100)],y.prototype,"eventuallyAddResourceGroups",null),Ge([(0,I.$vh)(100)],y.prototype,"eventuallyUpdateResourceStates",null);let k=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(O,K,j,W){this.l=K,this.m=j,this.n=W,this.g=new Map,this.h=new D.$km,this.j=new T.$Sd,this.e=O.getProxy($.$QK.MainThreadSCM),this.f=O.getProxy($.$QK.MainThreadTelemetry),K.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===3){const C=this.g.get(P.sourceControlHandle);if(!C)return P;const J=C.getResourceGroup(P.groupHandle);return J?J.getResourceState(P.handle):P}else if(P&&P.$mid===4){const C=this.g.get(P.sourceControlHandle);return C?C.getResourceGroup(P.groupHandle):P}else if(P&&P.$mid===5){const C=this.g.get(P.handle);return C||P}return P}})}createSourceControl(O,K,j,W){this.n.trace("ExtHostSCM#createSourceControl",O.identifier.value,K,j,W),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const P=t.d++,C=new y(O,this.m,this.e,this.l,K,j,W);this.g.set(P,C);const J=this.h.get(O.identifier)||[];return J.push(C),this.h.set(O.identifier,J),C}getLastInputBox(O){this.n.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const K=this.h.get(O.identifier),j=K&&K[K.length-1];return j&&j.inputBox}$provideOriginalResource(O,K,j){const W=E.URI.revive(K);this.n.trace("ExtHostSCM#$provideOriginalResource",O,W.toString());const P=this.g.get(O);return!P||!P.quickDiffProvider||!P.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Vg)(()=>P.quickDiffProvider.provideOriginalResource(W,j)).then(C=>C||null)}$onInputBoxValueChange(O,K){this.n.trace("ExtHostSCM#$onInputBoxValueChange",O);const j=this.g.get(O);return j&&j.inputBox.$onInputBoxValueChange(K),Promise.resolve(void 0)}$executeResourceCommand(O,K,j,W){this.n.trace("ExtHostSCM#$executeResourceCommand",O,K,j);const P=this.g.get(O);if(!P)return Promise.resolve(void 0);const C=P.getResourceGroup(K);return C?C.$executeResourceCommand(j,W):Promise.resolve(void 0)}$validateInput(O,K,j){this.n.trace("ExtHostSCM#$validateInput",O);const W=this.g.get(O);return!W||!W.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Vg)(()=>W.inputBox.validateInput(K,j)).then(P=>{if(!P)return Promise.resolve(void 0);const C=p.MarkdownString.fromStrict(P.message);return C?Promise.resolve([C,P.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.g.get(O)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(O,K,j){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupBase(K,j)??void 0}async $resolveHistoryItemGroupCommonAncestor(O,K,j,W){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(K,j,W)??void 0}async $provideHistoryItems(O,K,j,W){return(await this.g.get(O)?.historyProvider?.provideHistoryItems(K,j,W))?.map(J=>({...J,icon:h(J)}))??void 0}async $provideHistoryItemChanges(O,K,j){return await this.g.get(O)?.historyProvider?.provideHistoryItemChanges(K,j)??void 0}};e.$2gc=k,e.$2gc=k=t=Ge([Ke(3,A.$kj)],k)}),define(Ce[84],Re([1,0,3,5,4]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=e.$8fc=void 0;class F{constructor($){this.b=new T.$Sd,this.onDidChangePassword=this.b.event,this.a=$.getProxy(E.$QK.MainThreadSecretState)}async $onDidChangePassword($){this.b.fire($)}get($,g){return this.a.$getPassword($,g)}store($,g,w){return this.a.$setPassword($,g,w)}delete($,g){return this.a.$deletePassword($,g)}}e.$8fc=F,e.$9fc=(0,I.$3h)("IExtHostSecretState")}),define(Ce[264],Re([1,0,3,8,2]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3gc=void 0;class F{static{this.a=0}constructor($,g){this.d=g,this.c=new Map,this.b=$.getProxy(E.$QK.MainThreadShare)}async $provideShare($,g,w){return await this.c.get($)?.provideShare({selection:T.Range.to(g.selection),resourceUri:I.URI.revive(g.resourceUri)},w)??void 0}registerShareProvider($,g){const w=F.a++;return this.c.set(w,g),this.b.$registerShareProvider(w,T.DocumentSelector.from($,this.d),g.id,g.label,g.priority),{dispose:()=>{this.b.$unregisterShareProvider(w),this.c.delete(w)}}}}e.$3gc=F}),define(Ce[265],Re([1,0,20,6,3]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=void 0;class F{static{this.a=1}constructor($){this.c=new Map,this.d=new Map,this.b=$.getProxy(I.$QK.MainThreadSpeech)}async $createSpeechToTextSession($,g){const w=this.c.get($);if(!w)return;const A=new T.$Rc,D=new E.$3d;this.d.set(g,D);const l=A.add(w.provideSpeechToTextSession(D.token));A.add(l.onDidChange(p=>{D.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(g,p)})),A.add(D.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession($){this.d.get($)?.dispose(!0),this.d.delete($)}registerProvider($,g,w){const A=F.a++;return this.c.set(A,w),this.b.$registerProvider(A,g,{extension:$,displayName:$.value}),(0,T.$Qc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$4gc=F}),define(Ce[266],Re([1,0,7,3,164,6,8,16]),function(ge,e,E,T,I,F,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=e.$5gc=void 0;class g{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new E.$OL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new E.$OL("statusBarItem.warningForeground")]])}#e;#t;constructor(l,p,b,r,o,t=E.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new F.$Rc,this.#e=l,this.#t=p,o&&r){this.c=(0,E.$rL)(r.identifier,o);const a=b.get(this.c);a&&(t=a.alignLeft?E.StatusBarAlignment.Left:E.StatusBarAlignment.Right,n=a.priority,this.j=!0,this.name=a.name,this.text=a.text,this.tooltip=a.tooltip,this.command=a.command,this.accessibilityInformation=a.accessibilityInformation)}else this.c=String(g.a++);this.e=r,this.f=o,this.g=t,this.h=this.u(n)}u(l){if((0,$.$Jf)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!g.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new F.$Rc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let p;this.m?p=this.m:p=(0,I.localize)(0,null,this.e.displayName||this.e.name);let b=this.n;this.o&&(b=g.b.get(this.o.id));const r=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,p,this.k,r,this.r?.internal,b,this.o,this.g===E.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$5gc=g;class w{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",E.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const p={message:l};return this.b.unshift(p),this.c(),new E.$SK(()=>{const b=this.b.indexOf(p);b>=0&&(this.b.splice(b,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(l,p){this.e=new Map,this.a=l.getProxy(T.$QK.MainThreadStatusBar),this.b=p,this.c=new w(this)}$acceptStaticEntries(l){for(const p of l)this.e.set(p.entryId,p)}createStatusBarEntry(l,p,b,r){return new g(this.a,this.b,this.e,l,p,b,r)}setStatusBarMessage(l,p){const b=this.c.setMessage(l);let r;return typeof p=="number"?r=setTimeout(()=>b.dispose(),p):typeof p<"u"&&p.then(()=>b.dispose(),()=>b.dispose()),new E.$SK(()=>{b.dispose(),clearTimeout(r)})}}e.$6gc=A}),define(Ce[85],Re([1,0,3,5,4]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=e.$Zfc=void 0;class F{constructor($,g){this.c=g,this.b=new T.$Sd,this.onDidChangeStorage=this.b.event,this.a=$.getProxy(E.$QK.MainThreadStorage)}registerExtensionStorageKeysToSync($,g){this.a.$registerExtensionStorageKeysToSync($,g)}async initializeExtensionStorage($,g,w){const A=await this.a.$initializeExtensionStorage($,g);let D;return A&&(D=this.d($,g,A)),D||w}setValue($,g,w){return this.a.$setValue($,g,w)}$acceptValue($,g,w){const A=this.d($,g,w);A&&this.b.fire({shared:$,key:g,value:A})}d($,g,w){try{return JSON.parse(w)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${g}, global: ${$}): ${A}`)}}}e.$Zfc=F,e.$1fc=(0,I.$3h)("IExtHostStorage")}),define(Ce[86],Re([1,0,4,27,14,63,2]),function(ge,e,E,T,I,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=e.$Ifc=void 0,e.$Ifc=(0,E.$3h)("IExtensionStoragePaths");let $=class{constructor(w,A,D){this.d=A,this.f=D,this.a=w.workspace??void 0,this.b=w.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(w){return R.URI.joinPath(this.b.workspaceStorageHome,w)}async h(){if(!this.a)return Promise.resolve(void 0);const w=this.a.id,A=await this.g(w);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(w){if(this.c)return R.URI.joinPath(this.c,w.identifier.value)}globalValue(w){return R.URI.joinPath(this.b.globalStorageHome,w.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Jfc=$,e.$Jfc=$=Ge([Ke(0,T.$$M),Ke(1,I.$kj),Ke(2,F.$Hfc)],$)}),define(Ce[64],Re([1,0,5,3,4,2,17,6,7,166,15,194,20,33,195,45,13,8,32]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l,p,b,r,o,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=e.$6fc=e.$5fc=e.$4fc=void 0,e.$4fc=(0,I.$3h)("IExtHostTerminalService");class a{constructor(v,y,k,N){this.l=v,this._id=y,this.m=k,this.n=N,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(K=>this.f=K);const O=this;this.value={get name(){return O.n||""},get processId(){return O.b},get creationOptions(){return O.m},get exitStatus(){return O.h},get state(){return O.j},get selection(){return O.k},sendText(K,j=!0){O.q(),O.l.$sendText(O._id,K,j)},show(K){O.q(),O.l.$show(O._id,K)},hide(){O.q(),O.l.$hide(O._id)},dispose(){O.a||(O.a=!0,O.l.$dispose(O._id))},get dimensions(){if(!(O.d===void 0||O.g===void 0))return{columns:O.d,rows:O.g}}}}async create(v,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:v.name,shellPath:v.shellPath??void 0,shellArgs:v.shellArgs??void 0,cwd:v.cwd??y?.cwd??void 0,env:v.env??void 0,icon:m(v.iconPath)??void 0,color:r.ThemeColor.isThemeColor(v.color)?v.color.id:void 0,initialText:v.message??void 0,strictEnv:v.strictEnv??void 0,hideFromUser:v.hideFromUser??void 0,isFeatureTerminal:y?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:y?.useShellEnvironment??void 0,location:y?.location||this.o(v.location,y?.resolvedExtHostIdentifier),isTransient:v.isTransient??void 0})}async createExtensionTerminal(v,y,k,N,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:N,color:r.ThemeColor.isThemeColor(O)?O.id:void 0,location:y?.location||this.o(v,k),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(v,y){return typeof v=="object"?"parentTerminal"in v&&v.parentTerminal&&y?{parentTerminal:y}:"viewColumn"in v?{viewColumn:t.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus}:void 0:v}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(v){this.n=v}setExitStatus(v,y){this.h=Object.freeze({code:v,reason:y})}setDimensions(v,y){return v===this.d&&y===this.g||v===0||y===0?!1:(this.d=v,this.g=y,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(v){this.k=v}_setProcessId(v){this.f?(this.f(v),this.f=void 0):this.b.then(y=>{y!==v&&(this.b=Promise.resolve(v))})}}e.$5fc=a;class c{get onProcessReady(){return this.b.event}constructor(v){this.g=v,this.id=0,this.shouldPersist=!1,this.a=new E.$Sd,this.onProcessData=this.a.event,this.b=new E.$Sd,this.d=new E.$Sd,this.onDidChangeProperty=this.d.event,this.f=new E.$Sd,this.onProcessExit=this.f.event}refreshProperty(v){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${v}`)}updateProperty(v,y){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${v}, value: ${y}`)}async start(){}shutdown(){this.g.close()}input(v){this.g.handleInput?.(v)}resize(v,y){this.g.setDimensions?.({columns:v,rows:y})}clearBuffer(){}async processBinary(v){}acknowledgeDataEvent(v){}async setUnicodeVersion(v){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(v){this.g.onDidWrite(y=>this.a.fire(y)),this.g.onDidClose?.((y=void 0)=>{this.f.fire(y===void 0?void 0:y)}),this.g.onDidOverrideDimensions?.(y=>{y&&this.d.fire({type:"overrideDimensions",value:{cols:y.columns,rows:y.rows}})}),this.g.onDidChangeName?.(y=>{this.d.fire({type:"title",value:y})}),this.g.open(v||void 0),v&&this.g.setDimensions?.(v),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,i=class extends $.$Sc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(v=>v.value)}constructor(v,y,k){super(),this.Q=y,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new $.$Tc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new E.$Sd,this.onDidCloseTerminal=this.H.event,this.I=new E.$Sd,this.onDidOpenTerminal=this.I.event,this.J=new E.$Sd,this.onDidChangeActiveTerminal=this.J.event,this.L=new E.$Sd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new E.$Sd,this.onDidChangeTerminalState=this.M.event,this.N=new E.$Sd,this.onDidChangeShell=this.N.event,this.O=new E.$Sd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new E.$Sd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(T.$QK.MainThreadTerminalService),this.y=new b.$zrb(this.a.$sendProcessData),this.a.$registerProcessSupport(v),this.Q.registerArgumentProcessor({processArgument:N=>{const O=K=>{const j=K;return this.W(j.instanceId)?.value};switch(N?.$mid){case 15:return O(N);default:{if(Array.isArray(N))for(let K=0;K<N.length&&N[K].$mid===15;K++)N[K]=O(N[K]);return N}}}}),this.B({dispose:()=>{for(const[N,O]of this.g)O.shutdown(!0)}})}getDefaultShell(v){return(v?this.u:this.s)?.path||""}getDefaultShellArgs(v){return(v?this.u:this.s)?.args||[]}createExtensionTerminal(v,y){const k=new a(this.a,(0,p.$ng)(),v,v.name),N=new c(v.pty);return k.createExtensionTerminal(v.location,y,this.R(v,y).resolvedExtHostIdentifier,m(v.iconPath),f(v.color)).then(O=>{const K=this.S(O,N);this.h[O]=K}),this.f.push(k),k.value}R(v,y){if(y=y||{},v.location&&typeof v.location=="object"&&"parentTerminal"in v.location){const k=v.location.parentTerminal;if(k){const N=this.f.find(O=>O.value===k);N&&(y.resolvedExtHostIdentifier=N._id)}}else v.location&&typeof v.location!="object"?y.location=v.location:y.location&&typeof y.location=="object"&&"splitActiveTerminal"in y.location&&(y.location={splitActiveTerminal:!0});return y}attachPtyToTerminal(v,y){if(!this.W(v))throw new Error(`Cannot resolve terminal with id ${v} for virtual process`);const N=new c(y),O=this.S(v,N);this.h[v]=O}async $acceptActiveTerminalChanged(v){const y=this.b;if(v===null){this.b=void 0,y!==this.b&&this.J.fire(this.b);return}const k=this.W(v);k&&(this.b=k,y!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(v,y){const k=this.W(v);k&&this.O.fire({terminal:k.value,data:y})}async $acceptTerminalDimensions(v,y,k){const N=this.W(v);N&&N.setDimensions(y,k)&&this.L.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(v,y){const k=this.W(v);k&&this.P.fire({terminal:k.value,...y})}async $acceptTerminalMaximumDimensions(v,y,k){this.g.get(v)?.resize(y,k)}async $acceptTerminalTitleChange(v,y){const k=this.W(v);k&&(k.name=y)}async $acceptTerminalClosed(v,y,k){const N=this.Y(this.f,v);if(N!==null){const O=this.f.splice(N,1)[0];O.setExitStatus(y,k),this.H.fire(O.value)}}$acceptTerminalOpened(v,y,k,N){if(y){const j=this.Y(this.f,y);if(j!==null){this.f[j]._id=v,this.I.fire(this.terminals[j]),this.f[j].isOpen=!0;return}}const O={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:F.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},K=new a(this.a,v,O,k);this.f.push(K),this.I.fire(K.value),K.isOpen=!0}async $acceptTerminalProcessId(v,y){this.W(v)?._setProcessId(y)}async $startExtensionTerminal(v,y){const k=this.W(v);if(!k)return{message:(0,w.localize)(0,null,v)};k.isOpen||await new Promise(O=>{const K=this.onDidOpenTerminal(async j=>{j===k.value&&(K.dispose(),O())})});const N=this.g.get(v);N?N.startSendingEvents(y):this.j[v]={initialDimensions:y}}S(v,y){const k=new $.$Rc;k.add(y.onProcessReady(O=>this.a.$sendProcessReady(v,O.pid,O.cwd,O.windowsPty))),k.add(y.onDidChangeProperty(O=>this.a.$sendProcessProperty(v,O))),this.y.startBuffering(v,y.onProcessData),k.add(y.onProcessExit(O=>this.U(v,O))),this.g.set(v,y);const N=this.j[v];return N&&y instanceof c&&(y.startSendingEvents(N.initialDimensions),delete this.j[v]),k}$acceptProcessAckDataEvent(v,y){this.g.get(v)?.acknowledgeDataEvent(y)}$acceptProcessInput(v,y){this.g.get(v)?.input(y)}$acceptTerminalInteraction(v){const y=this.W(v);y?.setInteractedWith()&&this.M.fire(y.value)}$acceptTerminalSelection(v,y){this.W(v)?.setSelection(y)}$acceptProcessResize(v,y,k){try{this.g.get(v)?.resize(y,k)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(v,y){this.g.get(v)?.shutdown(y)}$acceptProcessRequestInitialCwd(v){this.g.get(v)?.getInitialCwd().then(y=>this.a.$sendProcessProperty(v,{type:"initialCwd",value:y}))}$acceptProcessRequestCwd(v){this.g.get(v)?.getCwd().then(y=>this.a.$sendProcessProperty(v,{type:"cwd",value:y}))}$acceptProcessRequestLatency(v){return Promise.resolve(v)}registerLinkProvider(v){return this.z.add(v),this.z.size===1&&this.a.$startLinkProvider(),new g.$SK(()=>{this.z.delete(v),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(v,y,k){if(this.C.has(y))throw new Error(`Terminal profile provider "${y}" already registered`);return this.C.set(y,k),this.a.$registerProfileProvider(y,v.identifier.value),new g.$SK(()=>{this.C.delete(y),this.a.$unregisterProfileProvider(y)})}registerTerminalQuickFixProvider(v,y,k){if(this.D.has(v))throw new Error(`Terminal quick fix provider "${v}" is already registered`);return this.D.set(v,k),this.a.$registerQuickFixProvider(v,y),new g.$SK(()=>{this.D.delete(v),this.a.$unregisterQuickFixProvider(v)})}async $provideTerminalQuickFixes(v,y){const k=new l.$3d().token;if(k.isCancellationRequested)return;const N=this.D.get(v);if(!N)return;const O=await N.provideTerminalQuickFixes(y,k);if(O===null||Array.isArray(O)&&O.length===0)return;const K=new $.$Rc;if(this.w.value=K,!Array.isArray(O))return O?t.TerminalQuickFix.from(O,this.Q.converter,K):void 0;const j=[];for(const W of O){const P=t.TerminalQuickFix.from(W,this.Q.converter,K);P&&j.push(P)}return j}async $createContributedProfileTerminal(v,y){const k=new l.$3d().token;let N=await this.C.get(v)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${v}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,y);return}this.createTerminalFromOptions(N.options,y)}}async $provideLinks(v,y){const k=this.W(v);if(!k)return[];this.F.delete(v),this.G.get(v)?.dispose(!0);const O=new l.$3d;this.G.set(v,O);const K=[],j={terminal:k.value,line:y},W=[];for(const J of this.z)W.push(o.Promises.withAsyncBody(async ae=>{O.token.onCancellationRequested(()=>ae({provider:J,links:[]}));const fe=await J.provideTerminalLinks(j,O.token)||[];O.token.isCancellationRequested||ae({provider:J,links:fe})}));const P=await Promise.all(W);if(O.token.isCancellationRequested)return[];const C=new Map;for(const J of P)J&&J.links.length>0&&K.push(...J.links.map(ae=>{const fe={id:h++,startIndex:ae.startIndex,length:ae.length,label:ae.tooltip};return C.set(fe.id,{provider:J.provider,link:ae}),fe}));return this.F.set(v,C),K}$activateLink(v,y){const k=this.F.get(v)?.get(y);k&&k.provider.handleTerminalLink(k.link)}U(v,y){this.y.stopBuffering(v),this.g.delete(v),delete this.j[v];const k=this.h[v];k&&(k.dispose(),delete this.h[v]),this.a.$sendProcessExit(v,y)}W(v){return this.X(this.f,v)}X(v,y){const k=this.Y(v,y);return k!==null?v[k]:null}Y(v,y){const k=v.findIndex(N=>N._id===y);return k===-1?null:k}getEnvironmentVariableCollection(v){let y=this.n.get(v.identifier.value);return y||(y=new s,this.$(v.identifier.value,y)),y.getScopedEnvironmentVariableCollection(void 0)}Z(v,y){const k=(0,D.$zr)(y.map),N=(0,D.$Ar)(y.descriptionMap);this.a.$setEnvironmentVariableCollection(v,y.persistent,k.length===0?void 0:k,N)}$initEnvironmentVariableCollections(v){v.forEach(y=>{const k=y[0],N=new s(y[1]);this.$(k,N)})}$acceptDefaultProfile(v,y){const k=this.s;this.s=v,this.u=y,k?.path!==v.path&&this.N.fire(v.path)}$(v,y){this.n.set(v,y),y.onDidChangeCollection(()=>{this.Z(v,y)})}};e.$6fc=i,e.$6fc=i=Ge([Ke(1,n.$eN),Ke(2,R.$UM)],i);class s{get persistent(){return this.b}set persistent(v){this.b=v,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(v){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new E.$Sd,this.map=new Map(v)}getScopedEnvironmentVariableCollection(v){const y=this.h(v);let k=this.a.get(y);return k||(k=new u(this,v),this.a.set(y,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(v,y,k,N){this.f(v,{value:y,type:g.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:N})}append(v,y,k,N){this.f(v,{value:y,type:g.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:N})}prepend(v,y,k,N){this.f(v,{value:y,type:g.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:N})}f(v,y){if(y.options&&y.options.applyAtProcessCreation===!1&&!y.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(v,y.scope),N=this.map.get(k),O=y.options?{applyAtProcessCreation:y.options.applyAtProcessCreation??!1,applyAtShellIntegration:y.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==y.value||N.type!==y.type||N.options?.applyAtProcessCreation!==O.applyAtProcessCreation||N.options?.applyAtShellIntegration!==O.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index){const K=this.g(v,y.scope),j={variable:v,...y,options:O};this.map.set(K,j),this.d.fire()}}get(v,y){const k=this.g(v,y),N=this.map.get(k);return N?S(N):void 0}g(v,y){const k=this.h(y);return k.length?`${v}:::${k}`:v}h(v){return this.j(v?.workspaceFolder)??""}j(v){return v?v.uri.toString():void 0}getVariableMap(v){const y=new Map;for(const[k,N]of this.map)this.h(N.scope)===this.h(v)&&y.set(N.variable,S(N));return y}delete(v,y){const k=this.g(v,y);this.map.delete(k),this.d.fire()}clear(v){if(v?.workspaceFolder){for(const[y,k]of this.map)k.scope?.workspaceFolder?.index===v.workspaceFolder.index&&this.map.delete(y);this.k(v)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(v,y){const k=this.h(y),N=this.descriptionMap.get(k);if(!N||N.description!==v){let O;typeof v=="string"?O=v:O=v?.value.split(`

`)[0];const K={description:O,scope:y};this.descriptionMap.set(k,K),this.d.fire()}}getDescription(v){const y=this.h(v);return this.descriptionMap.get(y)?.description}k(v){const y=this.h(v);this.descriptionMap.delete(y)}}class u{get persistent(){return this.b.persistent}set persistent(v){this.b.persistent=v}get onDidChangeCollection(){return this.a&&this.a.event}constructor(v,y){this.b=v,this.d=y,this.a=new E.$Sd}getScoped(v){return this.b.getScopedEnvironmentVariableCollection(v)}replace(v,y,k){this.b.replace(v,y,k,this.d)}append(v,y,k){this.b.append(v,y,k,this.d)}prepend(v,y,k){this.b.prepend(v,y,k,this.d)}get(v){return this.b.get(v,this.d)}forEach(v,y){this.b.getVariableMap(this.d).forEach((k,N)=>v.call(y,N,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(v){this.b.delete(v,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(v){this.b.setDescription(v,this.d)}get description(){return this.b.getDescription(this.d)}}let d=class extends i{constructor(v,y){super(!1,v,y)}createTerminal(v,y,k){throw new A.$_}createTerminalFromOptions(v,y){throw new A.$_}};e.$7fc=d,e.$7fc=d=Ge([Ke(0,n.$eN),Ke(1,R.$UM)],d);function m(L){if(!(!L||typeof L=="string"))return"id"in L?{id:L.id,color:L.color}:L}function f(L){return r.ThemeColor.isThemeColor(L)?L:void 0}function S(L){const v={...L};return delete v.scope,v.options=v.options??void 0,delete v.variable,v}}),define(Ce[267],Re([1,0,13,24,20,5,219,98,6,26,16,33,14,3,17,108,8,7,48,77,58,23]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l,p,b,r,o,t,n,a,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=e.$_gc=e.$$gc=e.$0gc=void 0;let i=class extends g.$Sc{constructor(j,W,P,C){super(),this.w=C,this.f=this.B(new F.$Sd),this.g=new Map,this.s=this.B(new F.$Sd),this.onResultsChanged=this.f.event,this.results=[],this.h=j.getProxy(p.$QK.MainThreadTesting),this.m=new k(this.h),this.j=new m(this.h,W),P.registerArgumentProcessor({processArgument:J=>{switch(J?.$mid){case 16:{const ae=J,fe=ae.tests[ae.tests.length-1].item.extId;return this.g.get(n.$IJ.root(fe))?.collection.tree.get(fe)?.actual??(0,r.$7M)(J)}case 18:{const{extId:ae,message:fe}=J;return{test:this.g.get(n.$IJ.root(ae))?.collection.tree.get(ae)?.actual,message:o.TestMessage.to(fe)}}default:return J}}}),P.registerCommand(!1,"testing.getExplorerSelection",async()=>{const J=await P.executeCommand("_testing.getExplorerSelection"),ae=fe=>{const be=this.g.get(n.$IJ.root(fe));if(be)return n.$IJ.isRoot(fe)?be.controller:be.collection.tree.get(fe)?.actual};return{include:J?.include.map(ae).filter(A.$Nf)||[],exclude:J?.exclude.map(ae).filter(A.$Nf)||[]}})}createTestController(j,W,P,C){if(this.g.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const J=new g.$Rc,ae=J.add(new r.$0M(W,P,this.w));ae.root.label=P;const fe=new Map,be=new Set,ye=this.h,he={items:ae.root.children,get label(){return P},set label(ee){P=ee,ae.root.label=ee,ye.$updateController(W,{label:P})},get refreshHandler(){return C},set refreshHandler(ee){C=ee,ye.$updateController(W,{canRefresh:!!ee})},get id(){return W},createRunProfile:(ee,ke,se,_,V,ne)=>{let Ie=(0,$.$Qi)(ee);for(;fe.has(Ie);)Ie++;return new N(this.h,fe,j,be,this.s.event,W,Ie,ee,ke,se,_,V,ne)},createTestItem(ee,ke,se){return new r.$8M(W,ee,ke,se)},createTestRun:(ee,ke,se=!0)=>this.j.createTestRun(j,W,ae,ee,ke,se),invalidateTestResults:ee=>{if(ee===void 0)this.h.$markTestRetired(void 0);else{const ke=ee instanceof Array?ee:[ee];this.h.$markTestRetired(ke.map(se=>n.$IJ.fromExtHostTestItem(se,W).toString()))}},set resolveHandler(ee){ae.resolveHandler=ee},get resolveHandler(){return ae.resolveHandler},dispose:()=>{J.dispose()}};ye.$registerTestController(W,P,!!C),J.add((0,g.$Qc)(()=>ye.$unregisterTestController(W)));const ve={controller:he,collection:ae,profiles:fe,extension:j,activeProfiles:be};return this.g.set(W,ve),J.add((0,g.$Qc)(()=>this.g.delete(W))),J.add(ae.onDidGenerateDiff(ee=>ye.$publishDiff(W,ee.map(c.TestsDiffOp.serialize)))),he}createTestObserver(){return this.m.checkout()}async runTests(j,W=I.CancellationToken.None){const P=f(j);if(!P)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const C=this.g.get(P.controllerId);if(!C)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:j.include?.map(J=>n.$IJ.fromExtHostTestItem(J,C.collection.root.id).toString())??[C.collection.root.id],profileGroup:O[P.kind],profileId:P.profileId,controllerId:P.controllerId}],exclude:j.exclude?.map(J=>J.id)},W)}$syncTests(){for(const{collection:j}of this.g.values())j.flushDiff();return Promise.resolve()}async $provideFileCoverage(j,W,P){return await this.j.getCoverageReport(j,W)?.provideFileCoverage(P)??[]}async $resolveFileCoverage(j,W,P,C){return await this.j.getCoverageReport(j,W)?.resolveFileCoverage(P,C)??[]}$configureRunProfile(j,W){this.g.get(j)?.profiles.get(W)?.configureHandler?.()}$setActiveRunProfiles(j){const W=new Map;for(const[P,C]of Object.entries(j)){const J=this.g.get(P);if(!J)continue;const ae=new Map,fe=C.filter(ye=>!J.activeProfiles.has(ye)),be=[...J.activeProfiles].filter(ye=>!C.includes(ye));for(const ye of fe)ae.set(ye,!0),J.activeProfiles.add(ye);for(const ye of be)ae.set(ye,!1),J.activeProfiles.delete(ye);ae.size&&W.set(P,ae)}this.s.fire(W)}async $refreshTests(j,W){await this.g.get(j)?.controller.refreshHandler?.(W)}$publishTestResults(j){this.results=Object.freeze(j.map(W=>(0,w.$kn)(o.TestResults.to(W))).concat(this.results).sort((W,P)=>P.completedAt-W.completedAt).slice(0,32)),this.f.fire()}async $expandTest(j,W){const P=this.g.get(n.$IJ.fromString(j).controllerId)?.collection;P&&(await P.expand(j,W<0?1/0:W),P.flushDiff())}$acceptDiff(j){this.m.applyDiff(j.map(W=>c.TestsDiffOp.deserialize({asCanonicalUri:P=>P},W)))}async $runControllerTests(j,W){return Promise.all(j.map(P=>this.y(P,!1,W)))}async $startContinuousRun(j,W){const P=new I.$3d(W),C=await Promise.all(j.map(J=>this.y(J,!0,P.token)));return!W.isCancellationRequested&&!C.some(J=>J.error)&&await new Promise(J=>W.onCancellationRequested(J)),P.dispose(!0),C}async y(j,W,P){const C=this.g.get(j.controllerId);if(!C)return{};const{collection:J,profiles:ae,extension:fe}=C,be=ae.get(j.profileId);if(!be)return{};const ye=j.testIds.map(ke=>J.tree.get(ke)).filter(A.$Nf),he=j.excludeExtIds.map(ke=>C.collection.tree.get(ke)).filter(A.$Nf).filter(ke=>ye.some(se=>se.fullId.compare(ke.fullId)===2));if(!ye.length)return{};const ve=new t.$pM(ye.some(ke=>ke.actual instanceof r.$9M)?void 0:ye.map(ke=>ke.actual),he.map(ke=>ke.actual),be,W),ee=(0,c.$KJ)(j)&&this.j.prepareForMainThreadTestRun(ve,S.fromInternal(j,C.collection),fe,P);try{return await be.runHandler(ve,P),{}}catch(ke){return{error:String(ke)}}finally{ee&&(ee.hasRunningTasks&&!P.isCancellationRequested&&await F.Event.toPromise(ee.onEnd),ee.dispose())}}$cancelExtensionTestRun(j){j===void 0?this.j.cancelAllRuns():this.j.cancelRunById(j)}};e.$0gc=i,e.$0gc=i=Ge([Ke(0,b.$UM),Ke(1,l.$kj)],i);const s=1e4;var u;(function(K){K[K.Running=0]="Running",K[K.Cancelling=1]="Cancelling",K[K.Ended=2]="Ended"})(u||(u={}));class d extends g.$Sc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(j,W,P,C,J){super(),this.s=j,this.w=W,this.y=P,this.z=C,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new F.$Sd),this.m=this.B(new F.$Sd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new I.$3d(J));const ae=this.B(new E.$ch(()=>this.C(),s));this.B(this.h.token.onCancellationRequested(()=>ae.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(j){const W=this.s.id,P=this.s.controllerId,C=(0,D.$ng)(),J=this.y,ae=this.m;let fe;const be=ee=>(ke,...se)=>{if(he){this.z.warn(`Setting the state of test "${ke.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ke)&&(this.F(ke),ee(ke,...se))},ye=(ee,ke)=>{const se=ke instanceof Array?ke.map(o.TestMessage.from):[o.TestMessage.from(ke)];if(ee.uri&&ee.range){const _={range:o.Range.from(ee.range),uri:ee.uri};for(const V of se)V.location=V.location||_}this.w.$appendTestMessagesInRun(W,C,n.$IJ.fromExtHostTestItem(ee,P).toString(),se)};let he=!1;const ve={isPersisted:this.s.isPersisted,token:this.h.token,name:j,get coverageProvider(){return fe?.provider},set coverageProvider(ee){(0,h.$pF)(J,"testCoverage"),fe=ee&&new L(ee),ae.fire({taskId:C,runId:W,coverage:fe})},enqueued:be(ee=>{this.w.$updateTestStateInRun(W,C,n.$IJ.fromExtHostTestItem(ee,P).toString(),1)}),skipped:be(ee=>{this.w.$updateTestStateInRun(W,C,n.$IJ.fromExtHostTestItem(ee,P).toString(),5)}),started:be(ee=>{this.w.$updateTestStateInRun(W,C,n.$IJ.fromExtHostTestItem(ee,P).toString(),2)}),errored:be((ee,ke,se)=>{ye(ee,ke),this.w.$updateTestStateInRun(W,C,n.$IJ.fromExtHostTestItem(ee,P).toString(),6,se)}),failed:be((ee,ke,se)=>{ye(ee,ke),this.w.$updateTestStateInRun(W,C,n.$IJ.fromExtHostTestItem(ee,P).toString(),4,se)}),passed:be((ee,ke)=>{this.w.$updateTestStateInRun(W,C,n.$IJ.fromExtHostTestItem(ee,this.s.controllerId).toString(),3,ke)}),appendOutput:(ee,ke,se)=>{he||(se&&(this.s.isIncluded(se)?this.F(se):se=void 0),this.w.$appendOutputToRun(W,C,T.$ge.fromString(ee),ke&&o.location.from(ke),se&&n.$IJ.fromExtHostTestItem(se,P).toString()))},end:()=>{he||(he=!0,this.w.$finishedTestRunTask(W,C),this.f.delete(C),this.f.size||this.D())}};return this.f.set(C,{run:ve}),this.w.$startedTestRunTask(W,{id:C,name:j,running:!0}),ve}C(){for(const{run:j}of this.f.values())j.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(j){if(!(j instanceof r.$8M))throw new a.$MM(j.id);if(this.g.has(n.$IJ.fromExtHostTestItem(j,this.s.controllerId).toString()))return;const W=[],P=this.s.colllection.root;for(;;){const C=o.TestItem.from(j);if(W.unshift(C),this.g.has(C.extId)||(this.g.add(C.extId),j===P))break;j=j.parent||P}this.w.$addTestsToRun(this.s.controllerId,this.s.id,W)}dispose(){this.D(),super.dispose()}}class m{get trackers(){return this.c.values()}constructor(j,W){this.g=j,this.h=W,this.c=new Map,this.f=[]}getCoverageReport(j,W){return this.f.find(P=>P.runId===j)?.coverage.get(W)}prepareForMainThreadTestRun(j,W,P,C){return this.j(j,W,P,C)}cancelRunById(j){for(const W of this.c.values())if(W.id===j){W.cancel();return}}cancelAllRuns(){for(const j of this.c.values())j.cancel()}createTestRun(j,W,P,C,J,ae){const fe=this.c.get(C);if(fe)return fe.createRun(J);const be=S.fromPublic(W,P,C,ae),ye=f(C);this.g.$startedExtensionTestRun({controllerId:W,continuous:!!C.continuous,profile:ye&&{group:O[ye.kind],id:ye.profileId},exclude:C.exclude?.map(ve=>n.$IJ.fromExtHostTestItem(ve,P.root.id).toString())??[],id:be.id,include:C.include?.map(ve=>n.$IJ.fromExtHostTestItem(ve,P.root.id).toString())??[P.root.id],persist:ae});const he=this.j(C,be,j);return F.Event.once(he.onEnd)(()=>{this.g.$finishedExtensionTestRun(be.id),he.dispose()}),he.createRun(J)}j(j,W,P,C){const J=new d(W,this.g,P,this.h,C);this.c.set(j,J);let ae;const fe=J.onDidCoverage(({runId:be,taskId:ye,coverage:he})=>{ae||(ae={runId:be,coverage:new Map},this.f.unshift(ae),this.f.length>c.$PJ&&this.f.pop()),ae.coverage.set(ye,he),this.g.$signalCoverageAvailable(be,ye,!!he)});return F.Event.once(J.onEnd)(()=>{this.c.delete(j),fe.dispose()}),J}}e.$$gc=m;const f=K=>{if(K.profile){if(!(K.profile instanceof N))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return K.profile}};class S{static fromPublic(j,W,P,C){return new S(j,(0,D.$ng)(),P.include?.map(J=>n.$IJ.fromExtHostTestItem(J,j).toString())??[j],P.exclude?.map(J=>n.$IJ.fromExtHostTestItem(J,j).toString())??[],C,W)}static fromInternal(j,W){return new S(j.controllerId,j.runId,j.testIds,j.excludeExtIds,!0,W)}constructor(j,W,P,C,J,ae){this.controllerId=j,this.id=W,this.isPersisted=J,this.colllection=ae,this.c=P.map(fe=>fe+"\0"),this.f=C.map(fe=>fe+"\0")}isIncluded(j){const W=n.$IJ.fromExtHostTestItem(j,this.controllerId).toString()+"\0";for(const P of this.f)if(W===P||W.startsWith(P))return!1;for(const P of this.c)if(W===P||W.startsWith(P))return!0;return!1}}e.$_gc=S;class L{constructor(j){this.provider=j}async provideFileCoverage(j){this.c||(this.c=(async()=>this.provider.provideFileCoverage(j))());try{return(await this.c)?.map(o.TestCoverage.fromFile)??[]}catch(W){throw this.c=void 0,W}}async resolveFileCoverage(j,W){const P=await this.c;let C=P?.[j];return!this.provider||!P||!C?[]:(C.detailedCoverage||(C=P[j]=await this.provider.resolveFileCoverage?.(C,W)??C),C.detailedCoverage?.map(o.TestCoverage.fromDetailed)??[])}}class v{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(j){this.j=j,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(j){this.c.add(j)}update(j){Object.assign(j.revived,o.TestItem.toPlain(j.item)),this.c.has(j)||this.f.add(j)}remove(j){if(this.c.has(j)){this.c.delete(j);return}this.f.delete(j);const W=n.$IJ.parentId(j.item.extId);if(W&&this.h.has(W.toString())){this.h.add(j.item.extId);return}this.g.add(j)}getChangeEvent(){const{c:j,f:W,g:P}=this;return{get added(){return[...j].map(C=>C.revived)},get updated(){return[...W].map(C=>C.revived)},get removed(){return[...P].map(C=>C.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class y extends c.$QJ{constructor(){super(...arguments),this.s=new F.$Sd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(j){return this.f.get(j)}getMirroredTestDataByReference(j){return this.f.get(j.id)}w(j,W){return{...j,revived:o.TestItem.toPlain(j.item),depth:W?W.depth+1:0,children:new Set}}v(){return new v(this.s)}}class k{constructor(j){this.f=j}checkout(){this.c||(this.c=this.g());const j=this.c;return j.observers++,{onDidChangeTest:j.tests.onDidChangeTests,get tests(){return[...j.tests.rootTests].map(W=>W.revived)},dispose:(0,R.$db)(()=>{--j.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(j){return this.c?.tests.getMirroredTestDataByReference(j)}applyDiff(j){this.c?.tests.apply(j)}g(){const j=new y({asCanonicalUri:W=>W});return this.f.$subscribeToDiffs(),{observers:0,tests:j}}}class N{#e;#t;#i;#o;#r;get label(){return this.f}set label(j){j!==this.f&&(this.f=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:j}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(j){j!==this.h&&(this.h=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:j}))}get isDefault(){return this.g}set isDefault(j){j!==this.g&&(this.g=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:j}))}get tag(){return this._tag}set tag(j){j?.id!==this._tag?.id&&(this._tag=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:j?o.TestTag.namespace(this.controllerId,j.id):null}))}get configureHandler(){return this.c}set configureHandler(j){j!==this.c&&(this.c=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!j}))}get isSelected(){return(0,h.$pF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,h.$pF)(this.#t,"testingActiveProfile"),F.Event.chain(this.#o,j=>j.map(W=>W.get(this.controllerId)?.get(this.profileId)).filter(A.$Nf))}constructor(j,W,P,C,J,ae,fe,be,ye,he,ve=!1,ee=void 0,ke=!1){this.controllerId=ae,this.profileId=fe,this.f=be,this.kind=ye,this.runHandler=he,this.g=ve,this._tag=ee,this.h=ke,this.#e=j,this.#r=W,this.#t=P,this.#i=C,this.#o=J,W.set(fe,this);const se=O[ye];if(typeof se!="number")throw new Error(`Unknown TestRunProfile.group ${ye}`);this.#e.$publishTestRunProfile({profileId:fe,controllerId:ae,tag:ee?o.TestTag.namespace(this.controllerId,ee.id):null,label:be,group:se,isDefault:ve,hasConfigurationHandler:!1,supportsContinuousRun:ke})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$ahc=N;const O={[t.TestRunProfileKind.Coverage]:8,[t.TestRunProfileKind.Debug]:4,[t.TestRunProfileKind.Run]:2}}),define(Ce[268],Re([1,0,18,5,3,109,8,7]),function(ge,e,E,T,I,F,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wfc=void 0;class g{constructor(A,D){this.i=D,this.a=new T.$Sd,this.b=new T.$Sd,this.c=new T.$Sd,this.d=new T.$Sd,this.f=new T.$Sd,this.g=new T.$Sd,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(I.$QK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const D=this.i.allEditors();return A?D:D.map(l=>l.value)}async showTextDocument(A,D,l){let p;typeof D=="number"?p={position:R.ViewColumn.from(D),preserveFocus:l}:typeof D=="object"?p={position:R.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?R.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:p={preserveFocus:!1};const b=await this.h.$tryShowTextDocument(A.uri,p),r=b&&this.i.getEditor(b);if(r)return r.value;throw b?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,D){return new F.$2M(this.h,A,D).value}$acceptEditorPropertiesChanged(A,D){const l=this.i.getEditor(A);if(!l)throw new Error("unknown text editor");if(D.options&&l._acceptOptions(D.options),D.selections){const p=D.selections.selections.map(R.Selection.to);l._acceptSelections(p)}if(D.visibleRanges){const p=E.$Hb(D.visibleRanges.map(R.Range.to));l._acceptVisibleRanges(p)}if(D.options&&this.b.fire({textEditor:l.value,options:{...D.options,lineNumbers:R.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const p=$.TextEditorSelectionChangeKind.fromValue(D.selections.source),b=D.selections.selections.map(R.Selection.to);this.a.fire({textEditor:l.value,selections:b,kind:p})}if(D.visibleRanges){const p=E.$Hb(D.visibleRanges.map(R.Range.to));this.c.fire({textEditor:l.value,visibleRanges:p})}}$acceptEditorPositionData(A){for(const D in A){const l=this.i.getEditor(D);if(!l)throw new Error("Unknown text editor");const p=R.ViewColumn.to(A[D]);l.value.viewColumn!==p&&(l._acceptViewColumn(p),this.d.fire({textEditor:l.value,viewColumn:p}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$wfc=g}),define(Ce[269],Re([1,0,2,4,3,6,7,8,22,16]),function(ge,e,E,T,I,F,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=e.$chc=void 0,e.$chc=(0,T.$3h)("IExtHostTimeline");class A{constructor(p,b){this.b=new Map,this.c=new Map,this.a=p.getProxy(I.$QK.MainThreadTimeline),b.registerArgumentProcessor({processArgument:(r,o)=>{if(r&&r.$mid===12)if(this.b.get(r.source)&&g.$im.equals(o,this.b.get(r.source)?.extension)){const t=r.uri===void 0?void 0:E.URI.revive(r.uri);return this.c.get(r.source)?.get(D(t))?.get(r.handle)}else return;return r}})}async $getTimeline(p,b,r,o){return this.b.get(p)?.provider.provideTimeline(E.URI.revive(b),r,o)}registerTimelineProvider(p,b,r,o){const t=new F.$Rc,n=this.d(b.id,o,t).bind(this);let a;b.onDidChange&&(a=b.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:b.id}),this));const c=this.c;return this.f({...b,scheme:p,onDidChange:void 0,async provideTimeline(h,i,s){i?.resetCache&&(t.clear(),c.get(b.id)?.clear());const u=await b.provideTimeline(h,i,s);if(u==null)return;const d=n(h,i);return{...u,source:b.id,items:u.items.map(d)}},dispose(){for(const h of c.values())h.get(b.id)?.clear();a?.dispose(),t.dispose()}},r)}d(p,b,r){return(o,t)=>{let n;if(t?.cacheResults){let a=this.c.get(p);a===void 0&&(a=new Map,this.c.set(p,a));const c=D(o);n=a.get(c),n===void 0&&(n=new Map,a.set(c,n))}return a=>{const{iconPath:c,...h}=a,i=`${p}|${a.id??a.timestamp}`;n?.set(i,a);let s,u,d;a.iconPath&&(c instanceof R.$NL?d={id:c.id,color:c.color}:E.URI.isUri(c)?(s=c,u=c):{light:s,dark:u}=c);let m;return R.$hL.isMarkdownString(h.tooltip)?m=$.MarkdownString.from(h.tooltip):(0,w.$Ff)(h.tooltip)?m=h.tooltip:R.$hL.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),m=$.MarkdownString.from(h.detail)):(0,w.$Ff)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),m=h.detail),{...h,id:h.id??void 0,handle:i,source:p,command:a.command?b.toInternal(a.command,r):void 0,icon:s,iconDark:u,themeIcon:d,tooltip:m,accessibilityInformation:a.accessibilityInformation}}}}f(p,b){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:b}),(0,F.$Qc)(()=>{for(const o of this.c.values())o.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$dhc=A;function D(l){return l?.toString()}}),define(Ce[87],Re([1,0,20,5,6,168,4,14,197,3,27,17,7]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dyb=e.$cyb=e.TunnelDtoConverter=void 0;class p extends g.$wv{}var b;(function(o){function t(a){return{remoteAddress:a.remoteAddress,localAddress:a.localAddress,public:!!a.public,privacy:a.privacy??(a.public?g.TunnelPrivacyId.Public:g.TunnelPrivacyId.Private),protocol:a.protocol}}o.fromApiTunnel=t;function n(a){return{remoteAddress:{host:a.tunnelRemoteHost,port:a.tunnelRemotePort},localAddress:a.localAddress,public:a.privacy!==g.TunnelPrivacyId.ConstantPrivate&&a.privacy!==g.TunnelPrivacyId.ConstantPrivate,privacy:a.privacy,protocol:a.protocol}}o.fromServiceTunnel=n})(b||(e.TunnelDtoConverter=b={})),e.$cyb=(0,R.$3h)("IExtHostTunnelService");let r=class extends I.$Sc{constructor(t,n,a){super(),this.s=a,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$Sd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=t.getProxy(w.$QK.MainThreadTunnelService)}async openTunnel(t,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${t.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const a=await this.a.$openTunnel(n,t.displayName);if(a){const c=new p(a.remoteAddress,a.localAddress,()=>this.a.$closeTunnel(a.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(t,n){const a=this.u();return this.r.set(a,{selector:t,provider:n}),this.a.$registerPortsAttributesProvider(t,a),new l.$SK(()=>{this.r.delete(a),this.a.$unregisterPortsAttributesProvider(a)})}async $providePortAttributes(t,n,a,c,h){const i=[];for(const u of t){const d=this.r.get(u);if(!d)return[];i.push(...await Promise.all(n.map(async m=>{let f;try{f=await d.provider.providePortAttributes({port:m,pid:a,commandLine:c},h)}catch{f=await d.provider.providePortAttributes(m,a,c,h)}return{providedAttributes:f,port:m}})))}const s=i.filter(u=>!!u.providedAttributes);return s.length>0?s.map(u=>({autoForwardAction:u.providedAttributes.autoForwardAction,port:u.port})):[]}async $registerCandidateFinder(t){}registerTunnelProvider(t,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,h)=>await t.provideTunnel(c,h,new E.$3d().token)??void 0;const a=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(a),Promise.resolve((0,I.$Qc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(t,n){if(t){t.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(t.candidatePortSource),t.showCandidatePort&&(this.f=t.showCandidatePort,this.a.$setCandidateFilter());const a=t.tunnelFactory??(n?this.w(n):void 0);if(a){this.b=a;let c=t.tunnelFeatures?.privacyOptions??[];t.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:F.localize(0,null),themeIcon:"lock"},{id:"public",label:F.localize(1,null),themeIcon:"eye"}]);const h=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,public:!!t.tunnelFeatures?.public,privacyOptions:c}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,I.$Qc)(()=>{this.b=void 0})}w(t){}async $closeTunnel(t,n){if(this.g.has(t.host)){const a=this.g.get(t.host);a.has(t.port)&&(n&&a.get(t.port).disposeListener.dispose(),await a.get(t.port).tunnel.dispose(),a.delete(t.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(t,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const a=this.b(t,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),a!==void 0){const c=await a;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(t.remoteAddress.host)||this.g.set(t.remoteAddress.host,new Map);const h=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(t.remoteAddress.host).set(t.remoteAddress.port,{tunnel:c,disposeListener:h}),b.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(a){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),a instanceof Error)return a.message}}async $applyCandidateFilter(t){const n=await Promise.all(t.map(c=>this.f(c.host,c.port,c.detail??""))),a=t.filter((c,h)=>n[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${t.map(c=>c.port).join(", ")} to ${a.map(c=>c.port).join(", ")}`),a}};e.$dyb=r,e.$dyb=r=Ge([Ke(0,D.$UM),Ke(1,A.$$M),Ke(2,$.$kj)],r)}),define(Ce[270],Re([1,0,6,12,2,3]),function(ge,e,E,T,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=void 0;class R{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(g){this.c=new Map,this.b=g.getProxy(F.$QK.MainThreadUriOpeners)}registerExternalUriOpener(g,w,A,D){if(this.c.has(w))throw new Error(`Opener with id '${w}' already registered`);const l=D.schemes.find(p=>!R.a.has(p));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(w,A),this.b.$registerUriOpener(w,D.schemes,g,D.label),(0,E.$Qc)(()=>{this.c.delete(w),this.b.$unregisterUriOpener(w)})}async $canOpenUri(g,w,A){const D=this.c.get(g);if(!D)throw new Error(`Unknown opener with id: ${g}`);const l=I.URI.revive(w);return D.canOpenExternalUri(l,A)}async $openUri(g,w,A){const D=this.c.get(g);if(!D)throw new Error(`Unknown opener id: '${g}'`);return D.openExternalUri(I.URI.revive(w.resolvedUri),{sourceUri:I.URI.revive(w.sourceUri)},A)}}e.$fhc=R}),define(Ce[271],Re([1,0,3,2,6,15,22]),function(ge,e,E,T,I,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=void 0;class ${static{this.a=0}constructor(w){this.c=new R.$jm,this.d=new Map,this.b=w.getProxy(E.$QK.MainThreadUrls)}registerUriHandler(w,A){const D=w.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const l=$.a++;return this.c.add(D),this.d.set(l,A),this.b.$registerUriHandler(l,D,w.displayName||w.name),(0,I.$Qc)(()=>{this.c.delete(D),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(w,A){const D=this.d.get(w);if(!D)return Promise.resolve(void 0);try{D.handleUri(T.URI.revive(A))}catch(l){(0,F.$1)(l)}return Promise.resolve(void 0)}async createAppUri(w){return T.URI.revive(await this.b.$createAppUri(w))}}e.$ghc=$}),define(Ce[65],Re([1,0,5,6,12,26,2,182,204,78,3]),function(ge,e,E,T,I,F,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ofc=e.$Nfc=e.$Mfc=e.$Lfc=e.$Kfc=void 0;class D{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(c,h,i,s,u,d,m){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new E.$Sd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new E.$Sd,this._onDidDispose=this.#h.event,this.#e=c,this.#t=h,this.#s=i,this.#o=s,this.#r=u,this.#n=d,this.#l=l(d),this.#d=p(d),this.#i=m}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,w.$lvb)(c,this.#o)}get cspSource(){const c=this.#n.extensionLocation;if(c.scheme===I.Schemas.https||c.scheme===I.Schemas.http){let h=c.toString();return h.endsWith("/")||(h+="/"),h+" "+w.$kvb}return w.$kvb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#s}set options(c){this.a(),F.$nn(this.#s,c)||this.#t.$setOptions(this.#e,o(this.#n,this.#r,c)),this.#s=c}async postMessage(c){if(this.#c)return!1;const h=(0,g.$4kb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const h=this.#n.extensionLocation?.scheme===I.Schemas.vscodeRemote,i=this.#n.extensionLocation.scheme===I.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,u,d,m,f,S)=>{const L=R.URI.from({scheme:m||"file",path:decodeURIComponent(f)}),v=(0,w.$lvb)(L,{isRemote:h,authority:i}).toString();return`${u}${v}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,u,d,m,f,S)=>{const L=R.URI.from({scheme:m||"file",path:decodeURIComponent(f)}),v=(0,w.$lvb)(L,{isRemote:h,authority:i}).toString();return`${u}${v}${S}`})}}e.$Kfc=D;function l(a){try{const c=(0,$.$3o)((0,$.$2o)(a.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}e.$Lfc=l;function p(a){try{const c=(0,$.$3o)((0,$.$2o)(a.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class b extends T.$Sc{constructor(c,h,i,s,u){super(),this.c=h,this.f=i,this.g=s,this.h=u,this.b=new Map,this.a=c.getProxy(A.$QK.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,h,i){const s=this.j(c);if(s){const{message:u}=(0,g.$5kb)(h,i.value);s._onMessageEmitter.fire(u)}}$onMissingCsp(c,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,h,i){const s=new D(c,this.a,t(h),this.c,this.f,i,this.h);this.b.set(c,s);const u=s._onDidDispose(()=>{u.dispose(),this.deleteWebview(c)});return s}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$Mfc=b;function r(a){return{id:a.identifier,location:a.extensionLocation}}e.$Nfc=r;function o(a,c,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||n(a,c)}}e.$Ofc=o;function t(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(c=>R.URI.from(c))}}function n(a,c){return[...(c?.getWorkspaceFolders()||[]).map(h=>h.uri),a.extensionLocation]}}),define(Ce[272],Re([1,0,20,98,6,12,25,2,8,65,75,3,7]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qfc=void 0;class p{constructor(s,u){this.document=s,this.b=u,this.a=1,this.c=new A.$dfc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,u){await this.f(s).undo(),u||this.disposeBackup()}async redo(s,u){await this.f(s).redo(),u||this.disposeBackup()}disposeEdits(s){for(const u of s)this.c.delete(u)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=h(this.document.uri)+this.a++;return(0,R.$Eg)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const u=this.c.get(s,0);if(!u)throw new Error("No edit found");return u}}class b{constructor(){this.a=new Map}get(s,u){return this.a.get(this.b(s,u))}add(s,u,d){const m=this.b(s,u.uri);if(this.a.has(m))throw new Error(`Document already exists for viewType:${s} resource:${u.uri}`);const f=new p(u,d);return this.a.set(m,f),f}delete(s,u){const d=this.b(s,u.uri);this.a.delete(d)}b(s,u){return`${s}@@@${u}`}}var r;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(r||(r={}));class o{constructor(){this.a=new Map}addTextProvider(s,u,d){return this.b(0,s,u,d)}addCustomProvider(s,u,d){return this.b(1,s,u,d)}get(s){return this.a.get(s)}b(s,u,d,m){if(this.a.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this.a.set(u,{type:s,extension:d,provider:m}),new l.$SK(()=>this.a.delete(u))}}class t{constructor(s,u,d,m,f){this.d=u,this.f=d,this.g=m,this.h=f,this.b=new o,this.c=new b,this.a=s.getProxy(D.$QK.MainThreadCustomEditors)}registerCustomEditorProvider(s,u,d,m){const f=new I.$Rc;return a(d)?(f.add(this.b.addTextProvider(u,s,d)),this.a.$registerTextEditorProvider((0,w.$Nfc)(s),u,m.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,w.$Lfc)(s))):(f.add(this.b.addCustomProvider(u,s,d)),n(d)&&f.add(d.onDidChangeCustomDocument(S=>{const L=this.i(u,S.document.uri);if(c(S)){const v=L.addEdit(S);this.a.$onDidEdit(S.document.uri,u,v,S.label)}else this.a.$onContentChange(S.document.uri,u)})),this.a.$registerCustomEditorProvider((0,w.$Nfc)(s),u,m.webviewOptions||{},!!m.supportsMultipleEditorsPerDocument,(0,w.$Lfc)(s))),l.$SK.from(f,new l.$SK(()=>{this.a.$unregisterEditorProvider(u)}))}async $createCustomDocument(s,u,d,m,f){const S=this.b.get(u);if(!S)throw new Error(`No provider found for '${u}'`);if(S.type!==1)throw new Error(`Invalid provide type for '${u}'`);const L=$.URI.revive(s),v=await S.provider.openCustomDocument(L,{backupId:d,untitledDocumentData:m?.buffer},f);let y;return n(S.provider)&&this.f&&(y=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(u,v,y),{editable:n(S.provider)}}async $disposeCustomDocument(s,u){const d=this.b.get(u);if(!d)throw new Error(`No provider found for '${u}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${u}'`);const m=$.URI.revive(s),{document:f}=this.i(u,m);this.c.delete(u,f),f.dispose()}async $resolveCustomEditor(s,u,d,m,f,S){const L=this.b.get(d);if(!L)throw new Error(`No provider found for '${d}'`);const v=g.ViewColumn.to(f),y=this.g.createNewWebview(u,m.contentOptions,L.extension),k=this.h.createNewWebviewPanel(u,d,m.title,v,m.options,y,m.active),N=$.URI.revive(s);switch(L.type){case 1:{const{document:O}=this.i(d,N);return L.provider.resolveCustomEditor(O,k,S)}case 0:{const O=this.d.getDocument(N);return L.provider.resolveCustomTextEditor(O,k,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,u,d){this.i(u,s).disposeEdits(d)}async $onMoveCustomEditor(s,u,d){const m=this.b.get(d);if(!m)throw new Error(`No provider found for '${d}'`);if(!m.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const f=this.h.getWebviewPanel(s);if(!f)throw new Error("No webview found");const S=$.URI.revive(u),L=this.d.getDocument(S);await m.provider.moveCustomTextEditor(L,f,E.CancellationToken.None)}async $undo(s,u,d,m){return this.i(u,s).undo(d,m)}async $redo(s,u,d,m){return this.i(u,s).redo(d,m)}async $revert(s,u,d){const m=this.i(u,s);await this.j(u).revertCustomDocument(m.document,d),m.disposeBackup()}async $onSave(s,u,d){const m=this.i(u,s);await this.j(u).saveCustomDocument(m.document,d),m.disposeBackup()}async $onSaveAs(s,u,d,m){const f=this.i(u,s);return this.j(u).saveCustomDocumentAs(f.document,$.URI.revive(d),m)}async $backup(s,u,d){const m=this.i(u,s),S=await this.j(u).backupCustomDocument(m.document,{destination:m.getNewBackupUri()},d);return m.updateBackup(S),S.id}i(s,u){const d=this.c.get(s,$.URI.revive(u));if(!d)throw new Error("No custom document found");return d}j(s){const d=this.b.get(s)?.provider;if(!d||!n(d))throw new Error("Custom document is not editable");return d}}e.$Qfc=t;function n(i){return!!i.onDidChangeCustomDocument}function a(i){return typeof i.resolveCustomTextEditor=="function"}function c(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function h(i){const s=i.scheme===F.Schemas.file||i.scheme===F.Schemas.untitled?i.fsPath:i.toString();return(0,T.$Qi)(s)+""}}),define(Ce[273],Re([1,0,5,6,2,33,8,65,3,7]),function(ge,e,E,T,I,F,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pfc=void 0;class A extends T.$Sc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(b,r,o,t){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new E.$Sd),this.onDidDispose=this.#d.event,this.#h=this.B(new E.$Sd),this.onDidChangeViewState=this.#h.event,this.#e=b,this.#t=r,this.#o=o,this.#i=t.viewType,this.#r=t.panelOptions,this.#s=t.viewColumn,this.#n=t.title,this.#u=t.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(b){this.c(),this.#n!==b&&(this.#n=b,this.#t.$setTitle(this.#e,b))}get iconPath(){return this.c(),this.#a}set iconPath(b){this.c(),this.#a!==b&&(this.#a=b,this.#t.$setIconPath(this.#e,I.URI.isUri(b)?{light:b,dark:b}:b))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(b){this.#l||(this.active!==b.active||this.visible!==b.visible||this.viewColumn!==b.viewColumn)&&(this.#u=b.active,this.#c=b.visible,this.#s=b.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(b,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof b>"u"?void 0:R.ViewColumn.from(b),preserveFocus:!!r})}c(){if(this.#l)throw new Error("Webview is disposed")}}class D extends T.$Sc{static c(){return(0,F.$ng)()}constructor(b,r,o){super(),this.j=r,this.m=o,this.g=new Map,this.h=new Map,this.f=b.getProxy(g.$QK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(b=>b.dispose()),this.g.clear()}createWebviewPanel(b,r,o,t,n={}){const a=typeof t=="object"?t.viewColumn:t,c={viewColumn:R.ViewColumn.from(a),preserveFocus:typeof t=="object"&&!!t.preserveFocus},h=(0,$.$Lfc)(b),i=D.c();this.f.$createWebviewPanel((0,$.$Nfc)(b),i,r,{title:o,panelOptions:l(n),webviewOptions:(0,$.$Ofc)(b,this.m,n),serializeBuffersForPostMessage:h},c);const s=this.j.createNewWebview(i,n,b);return this.createNewWebviewPanel(i,r,o,a,n,s,!0)}$onDidChangeWebviewPanelViewStates(b){const r=Object.keys(b);r.sort((o,t)=>{const n=b[o],a=b[t];return n.active?1:a.active?-1:+n.visible-+a.visible});for(const o of r){const t=this.getWebviewPanel(o);if(!t)continue;const n=b[o];t._updateViewState({active:n.active,visible:n.visible,viewColumn:R.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(b){this.getWebviewPanel(b)?.dispose(),this.g.delete(b),this.j.deleteWebview(b)}registerWebviewPanelSerializer(b,r,o){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:o,extension:b}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,$.$Lfc)(b)}),new w.$SK(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(b,r,o,t){const n=this.h.get(r);if(!n)throw new Error(`No serializer found for '${r}'`);const{serializer:a,extension:c}=n,h=this.j.createNewWebview(b,o.webviewOptions,c),i=this.createNewWebviewPanel(b,r,o.title,t,o.panelOptions,h,o.active);await a.deserializeWebviewPanel(i,o.state)}createNewWebviewPanel(b,r,o,t,n,a,c){const h=new A(b,this.f,a,{viewType:r,title:o,viewColumn:t,panelOptions:n,active:c});return this.g.set(b,h),h}getWebviewPanel(b){return this.g.get(b)}}e.$Pfc=D;function l(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}}),define(Ce[274],Re([1,0,5,6,65,8,3,7]),function(ge,e,E,T,I,F,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=void 0;class g extends T.$Sc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(D,l,p,b,r,o){super(),this.#r=!1,this.#u=this.B(new E.$Sd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new E.$Sd),this.onDidDispose=this.#l.event,this.#i=p,this.#a=b,this.#e=D,this.#t=l,this.#o=r,this.#n=o}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(D){this.a(),this.#a!==D&&(this.#a=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.a(),this.#s}set description(D){this.a(),this.#s!==D&&(this.#s=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(D){D===this.#n||this.#r||(this.#n=D,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(D){this.a(),!(D?.value===this.#c?.value&&D?.tooltip===this.#c?.tooltip)&&(this.#c=F.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.a(),this.#t.$show(this.#e,!!D)}a(){if(this.#r)throw new Error("Webview is disposed")}}class w{constructor(D,l){this.d=l,this.b=new Map,this.c=new Map,this.a=D.getProxy(R.$QK.MainThreadWebviewViews)}registerWebviewViewProvider(D,l,p,b){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:p,extension:D}),this.a.$registerWebviewViewProvider((0,I.$Nfc)(D),l,{retainContextWhenHidden:b?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.$Lfc)(D)}),new $.$SK(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(D,l,p,b,r){const o=this.b.get(l);if(!o)throw new Error(`No view provider found for '${l}'`);const{provider:t,extension:n}=o,a=this.d.createNewWebview(D,{},n),c=new g(D,this.a,l,p,a,!0);this.c.set(D,c),await t.resolveWebviewView(c,{state:b},r)}async $onDidChangeWebviewViewVisibility(D,l){this.e(D)._setVisible(l)}async $disposeWebviewView(D){const l=this.e(D);this.c.delete(D),l.dispose(),this.d.deleteWebview(D)}e(D){const l=this.c.get(D);if(!l)throw new Error("No webview found");return l}}e.$hhc=w}),define(Ce[111],Re([1,0,5,3,2,12,11,4,17,23]),function(ge,e,E,T,I,F,R,$,g,w){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$jhc=e.$ihc=void 0;let D=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(p){const b=this.d;return{get focused(){return b.focused},get active(){return(0,w.$pF)(p,"windowActivity"),b.active}}}constructor(p){this.c=new E.$Sd,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=p.getProxy(T.$QK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:b,isActive:r})=>{this.onDidChangeWindowProperty("focused",b),this.onDidChangeWindowProperty("active",r)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,b){b!==this.d[p]&&(this.d={...this.d,[p]:b},this.c.fire(this.d))}openUri(p,b){let r;if(typeof p=="string"){r=p;try{p=I.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,R.$Ge)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===F.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,r,b)}async asExternalUri(p,b){if((0,R.$Ge)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const r=await this.b.$asExternalUri(p,b);return I.URI.from(r)}};e.$ihc=D,e.$ihc=D=A=Ge([Ke(0,g.$UM)],D),e.$jhc=(0,$.$3h)("IExtHostWindow")}),define(Ce[275],Re([1,0,241,27,17]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vjc=void 0;let F=class extends E.$mhc{constructor($,g){super($,g)}f($,g,w){g.apply(console,w)}};e.$vjc=F,e.$vjc=F=Ge([Ke(0,I.$UM),Ke(1,T.$$M)],F)}),define(Ce[276],Re([1,0,13,24,20,15,5,6,139,230,49]),function(ge,e,E,T,I,F,R,$,g,w,A){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$x7b=e.ResponsiveState=e.RequestInitiator=e.$w7b=e.$v7b=void 0;function l(k,N){try{return JSON.stringify(k,N)}catch{return"null"}}const p="$$ref$$",b={[p]:-1};class r{constructor(N,O){this.jsonString=N,this.referencedBuffers=O}}function o(k,N=null,O=!1){const K=[];return{jsonString:(O?l:JSON.stringify)(k,(W,P)=>{if(typeof P>"u")return b;if(typeof P=="object"){if(P instanceof T.$ge){const C=K.push(P)-1;return{[p]:C}}if(N)return N(W,P)}return P}),referencedBuffers:K}}e.$v7b=o;function t(k,N,O){return JSON.parse(k,(K,j)=>{if(j){const W=j[p];if(typeof W=="number")return N[W];if(O&&j.$mid===1)return O.transformIncoming(j)}return j})}e.$w7b=t;function n(k,N){return JSON.stringify(k,N)}function a(k){return k?(N,O)=>O&&O.$mid===1?k.transformOutgoing(O):O:null}var c;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var h;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const i=()=>{},s=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class d extends $.$Sc{static{D=s}static{this.a=3*1e3}constructor(N,O=null,K=null){super(),this[D]=!0,this.b=this.B(new R.$Sd),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=O,this.g=K,this.h=a(this.g),this.j=!1,this.m=[],this.s=[];for(let j=0,W=A.$Dv.count;j<W;j++)this.m[j]=null,this.s[j]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new E.$ch(()=>this.H(),1e3)),this.c.onMessage(j=>this.L(j))}dispose(){this.j=!0,Object.keys(this.w).forEach(N=>{const O=this.w[N];delete this.w[N],O.resolveErr(F.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(N){this.z===0&&(this.C=Date.now()+d.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(N){this.C=Date.now()+d.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(N){this.y!==N&&(this.y=N,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(N){return this.g?(0,g.$4m)(N,this.g):N}getProxy(N){const{nid:O,sid:K}=N;return this.s[O]||(this.s[O]=this.J(O,K)),this.s[O]}J(N,O){const K={get:(j,W)=>(typeof W=="string"&&!j[W]&&W.charCodeAt(0)===36&&(j[W]=(...P)=>this.U(N,W,P)),W===u?O:j[W])};return new Proxy(Object.create(null),K)}set(N,O){return this.m[N.nid]=O,O}assertRegistered(N){for(let O=0,K=N.length;O<K;O++){const j=N[O];if(!this.m[j.nid])throw new Error(`Missing proxy instance ${j.sid}`)}}L(N){if(this.j)return;const O=N.byteLength,K=f.read(N,0),j=K.readUInt8(),W=K.readUInt32();switch(j){case 1:case 2:{let{rpcId:P,method:C,args:J}=L.deserializeRequestJSONArgs(K);this.g&&(J=(0,g.$4m)(J,this.g)),this.M(O,W,P,C,J,j===2);break}case 3:case 4:{let{rpcId:P,method:C,args:J}=L.deserializeRequestMixedArgs(K);this.g&&(J=(0,g.$4m)(J,this.g)),this.M(O,W,P,C,J,j===4);break}case 5:{this.f?.logIncoming(O,W,0,"ack"),this.G(W);break}case 6:{this.N(O,W);break}case 7:{this.O(O,W,void 0);break}case 9:{let P=L.deserializeReplyOKJSON(K);this.g&&(P=(0,g.$4m)(P,this.g)),this.O(O,W,P);break}case 10:{const P=L.deserializeReplyOKJSONWithBuffers(K,this.g);this.O(O,W,P);break}case 8:{const P=L.deserializeReplyOKVSBuffer(K);this.O(O,W,P);break}case 11:{let P=L.deserializeReplyErrError(K);this.g&&(P=(0,g.$4m)(P,this.g)),this.P(O,W,P);break}case 12:{this.P(O,W,void 0);break}default:console.error("received unexpected message"),console.error(N)}}M(N,O,K,j,W,P){this.f?.logIncoming(N,O,1,`receiveRequest ${(0,A.$Fv)(K)}.${j}(`,W);const C=String(O);let J,ae;if(P){const be=new I.$3d;W.push(be.token),J=this.Q(K,j,W),ae=()=>be.cancel()}else J=this.Q(K,j,W),ae=i;this.u[C]=ae;const fe=L.serializeAcknowledged(O);this.f?.logOutgoing(fe.byteLength,O,1,"ack"),this.c.send(fe),J.then(be=>{delete this.u[C];const ye=L.serializeReplyOK(O,be,this.h);this.f?.logOutgoing(ye.byteLength,O,1,"reply:",be),this.c.send(ye)},be=>{delete this.u[C];const ye=L.serializeReplyErr(O,be);this.f?.logOutgoing(ye.byteLength,O,1,"replyErr:",be),this.c.send(ye)})}N(N,O){this.f?.logIncoming(N,O,1,"receiveCancel");const K=String(O);this.u[K]?.()}O(N,O,K){this.f?.logIncoming(N,O,0,"receiveReply:",K);const j=String(O);if(!this.w.hasOwnProperty(j))return;const W=this.w[j];delete this.w[j],W.resolveOk(K)}P(N,O,K){this.f?.logIncoming(N,O,0,"receiveReplyErr:",K);const j=String(O);if(!this.w.hasOwnProperty(j))return;const W=this.w[j];delete this.w[j];let P;K&&(K.$isError?(P=new Error,P.name=K.name,P.message=K.message,P.stack=K.stack):P=K),W.resolveErr(P)}Q(N,O,K){try{return Promise.resolve(this.S(N,O,K))}catch(j){return Promise.reject(j)}}S(N,O,K){const j=this.m[N];if(!j)throw new Error("Unknown actor "+(0,A.$Fv)(N));const W=j[O];if(typeof W!="function")throw new Error("Unknown method "+O+" on actor "+(0,A.$Fv)(N));return W.apply(j,K)}U(N,O,K){if(this.j)return new w.$u7b;let j=null;if(K.length>0&&I.CancellationToken.isCancellationToken(K[K.length-1])&&(j=K.pop()),j&&j.isCancellationRequested)return Promise.reject(F.$6());const W=L.serializeRequestArguments(K,this.h),P=++this.t,C=String(P),J=new w.$t7b,ae=new $.$Rc;j&&ae.add(j.onCancellationRequested(()=>{const be=L.serializeCancel(P);this.f?.logOutgoing(be.byteLength,P,0,"cancel"),this.c.send(L.serializeCancel(P))})),this.w[C]=new m(J,ae),this.F(P);const fe=L.serializeRequest(P,N,O,W,!!j);return this.f?.logOutgoing(fe.byteLength,P,0,`request: ${(0,A.$Fv)(N)}.${O}(`,K),this.c.send(fe),J}}e.$x7b=d;class m{constructor(N,O){this.a=N,this.b=O}resolveOk(N){this.a.resolveOk(N),this.b.dispose()}resolveErr(N){this.a.resolveErr(N),this.b.dispose()}}class f{static alloc(N,O,K){const j=new f(T.$ge.alloc(K+1+4),0);return j.writeUInt8(N),j.writeUInt32(O),j}static read(N,O){return new f(N,O)}get buffer(){return this.a}constructor(N,O){this.a=N,this.b=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const K=this.a.slice(this.b,this.b+N).toString();return this.b+=N,K}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const K=this.a.slice(this.b,this.b+N).toString();return this.b+=N,K}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+N);return this.b+=N,O}static sizeMixedArray(N){let O=0;O+=1;for(let K=0,j=N.length;K<j;K++){const W=N[K];switch(O+=1,W.type){case 1:O+=this.sizeLongString(W.value);break;case 2:O+=this.sizeVSBuffer(W.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(W.value);for(let P=0;P<W.buffers.length;++P)O+=this.sizeVSBuffer(W.buffers[P]);break;case 4:break}}return O}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let O=0,K=N.length;O<K;O++){const j=N[O];switch(j.type){case 1:this.writeUInt8(1),this.writeLongString(j.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(j.value);break;case 3:this.writeUInt8(3),this.writeUInt32(j.buffers.length),this.writeLongString(j.value);for(let W=0;W<j.buffers.length;++W)this.writeBuffer(j.buffers[W]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const O=new Array(N);for(let K=0;K<N;K++)switch(this.readUInt8()){case 1:O[K]=this.readLongString();break;case 2:O[K]=this.readVSBuffer();break;case 3:{const W=this.readUInt32(),P=this.readLongString(),C=[];for(let J=0;J<W;++J)C.push(this.readVSBuffer());O[K]=new A.$Gv(t(P,C,null));break}case 4:O[K]=void 0;break}return O}}var S;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(S||(S={}));class L{static a(N){for(let O=0,K=N.length;O<K;O++)if(N[O]instanceof T.$ge||N[O]instanceof A.$Gv||typeof N[O]>"u")return!0;return!1}static serializeRequestArguments(N,O){if(this.a(N)){const K=[];for(let j=0,W=N.length;j<W;j++){const P=N[j];if(P instanceof T.$ge)K[j]={type:2,value:P};else if(typeof P>"u")K[j]={type:4};else if(P instanceof A.$Gv){const{jsonString:C,referencedBuffers:J}=o(P.value,O);K[j]={type:3,value:T.$ge.fromString(C),buffers:J}}else K[j]={type:1,value:T.$ge.fromString(n(P,O))}}return{type:1,args:K}}return{type:0,args:n(N,O)}}static serializeRequest(N,O,K,j,W){switch(j.type){case 0:return this.b(N,O,K,j.args,W);case 1:return this.c(N,O,K,j.args,W)}}static b(N,O,K,j,W){const P=T.$ge.fromString(K),C=T.$ge.fromString(j);let J=0;J+=f.sizeUInt8(),J+=f.sizeShortString(P),J+=f.sizeLongString(C);const ae=f.alloc(W?2:1,N,J);return ae.writeUInt8(O),ae.writeShortString(P),ae.writeLongString(C),ae.buffer}static deserializeRequestJSONArgs(N){const O=N.readUInt8(),K=N.readShortString(),j=N.readLongString();return{rpcId:O,method:K,args:JSON.parse(j)}}static c(N,O,K,j,W){const P=T.$ge.fromString(K);let C=0;C+=f.sizeUInt8(),C+=f.sizeShortString(P),C+=f.sizeMixedArray(j);const J=f.alloc(W?4:3,N,C);return J.writeUInt8(O),J.writeShortString(P),J.writeMixedArray(j),J.buffer}static deserializeRequestMixedArgs(N){const O=N.readUInt8(),K=N.readShortString(),j=N.readMixedArray(),W=new Array(j.length);for(let P=0,C=j.length;P<C;P++){const J=j[P];typeof J=="string"?W[P]=JSON.parse(J):W[P]=J}return{rpcId:O,method:K,args:W}}static serializeAcknowledged(N){return f.alloc(5,N,0).buffer}static serializeCancel(N){return f.alloc(6,N,0).buffer}static serializeReplyOK(N,O,K){if(typeof O>"u")return this.d(N);if(O instanceof T.$ge)return this.e(N,O);if(O instanceof A.$Gv){const{jsonString:j,referencedBuffers:W}=o(O.value,K,!0);return this.g(N,j,W)}else return this.f(N,l(O,K))}static d(N){return f.alloc(7,N,0).buffer}static e(N,O){let K=0;K+=f.sizeVSBuffer(O);const j=f.alloc(8,N,K);return j.writeVSBuffer(O),j.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,O){const K=T.$ge.fromString(O);let j=0;j+=f.sizeLongString(K);const W=f.alloc(9,N,j);return W.writeLongString(K),W.buffer}static g(N,O,K){const j=T.$ge.fromString(O);let W=0;W+=f.sizeUInt32,W+=f.sizeLongString(j);for(const C of K)W+=f.sizeVSBuffer(C);const P=f.alloc(10,N,W);P.writeUInt32(K.length),P.writeLongString(j);for(const C of K)P.writeBuffer(C);return P.buffer}static deserializeReplyOKJSON(N){const O=N.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(N,O){const K=N.readUInt32(),j=N.readLongString(),W=[];for(let P=0;P<K;++P)W.push(N.readVSBuffer());return new A.$Gv(t(j,W,O))}static serializeReplyErr(N,O){const K=O?l(F.$3(O),null):void 0;if(typeof K!="string")return this.h(N);const j=T.$ge.fromString(K);let W=0;W+=f.sizeLongString(j);const P=f.alloc(11,N,W);return P.writeLongString(j),P.buffer}static deserializeReplyErrError(N){const O=N.readLongString();return JSON.parse(O)}static h(N){return f.alloc(12,N,0).buffer}}var v;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var y;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(y||(y={}))}),define(Ce[277],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xjc=void 0;const E=function(F){const R=$=>{globalThis.removeEventListener("message",R);const g=$.data;Object.defineProperties(globalThis,{postMessage:{value(w,A){g.postMessage(w,A)}},onmessage:{get(){return g.onmessage},set(w){g.onmessage=w}}}),g.addEventListener("message",w=>{globalThis.dispatchEvent(new MessageEvent("message",{data:w.data,ports:w.ports?[...w.ports]:void 0}))}),g.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(F)};globalThis.addEventListener("message",R)}.toString();class T extends EventTarget{constructor(F,R,$){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const g=`((${E})('${R}'))`,w=new Blob([g],{type:"application/javascript"}),A=URL.createObjectURL(w),D=new MessageChannel,l=A,p={type:"_newWorker",id:l,port:D.port2,url:A,options:$};F(p,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{F({type:"_terminateWorker",id:l}),URL.revokeObjectURL(A),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(b){D.port1.onmessage=b}},onmessageerror:{get(){return D.port1.onmessageerror},set(b){D.port1.onmessageerror=b}}}),D.port1.addEventListener("messageerror",b=>{const r=new MessageEvent("messageerror",{data:b.data});this.dispatchEvent(r)}),D.port1.addEventListener("message",b=>{const r=new MessageEvent("message",{data:b.data});this.dispatchEvent(r)}),D.port1.start()}}e.$xjc=T}),define(Ce[278],Re([1,0,5,30,35,4]),function(ge,e,E,T,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aK=e.$_J=e.OutputChannelUpdateMode=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=void 0,e.$2J="text/x-code-output",e.$3J="output",e.$4J="Log",e.$5J="text/x-code-log-output",e.$6J="log",e.$7J="workbench.panel.output",e.$8J=new I.$hj("inOutput",!1),e.$9J=new I.$hj("activeLogOutput",!1),e.$0J=new I.$hj("outputView.scrollLock",!1),e.$$J=(0,F.$3h)("outputService");var R;(function(g){g[g.Append=1]="Append",g[g.Replace=2]="Replace",g[g.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$_J={OutputChannels:"workbench.contributions.outputChannels"};class ${constructor(){this.a=new Map,this.b=new E.$Sd,this.onDidRegisterChannel=this.b.event,this.c=new E.$Sd,this.onDidRemoveChannel=this.c.event}registerChannel(w){this.a.has(w.id)||(this.a.set(w.id,w),this.b.fire(w.id))}getChannels(){const w=[];return this.a.forEach(A=>w.push(A)),w}getChannel(w){return this.a.get(w)}removeChannel(w){this.a.delete(w),this.c.fire(w)}}T.$vn.add(e.$_J.OutputChannels,new $),e.$aK=new I.$hj("activeOutputChannel","")}),define(Ce[112],Re([1,0,3,4,17,22,14,278,63,27,43,136,24,16,42,5,6]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l,p,b,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=e.$Ugc=void 0;class t extends R.$qj{get disposed(){return this.n}constructor(h,i,s,u,d){super(),this.id=h,this.name=i,this.r=s,this.s=u,this.extension=d,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(m=>this.setLevel(m)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Clear,h)}replace(h){const i=this.m;this.info(h),this.s.$update(this.id,$.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(h,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:i))}hide(){this.s.$close(this.id)}g(h,i){this.m+=l.$ge.fromString(i).byteLength,(0,R.log)(this.r,h,i),this.visible&&(this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends t{appendLine(h){this.append(h)}}let a=class{constructor(h,i,s,u,d,m){this.i=i,this.j=s,this.k=u,this.l=d,this.m=m,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(E.$QK.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,D.$tm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[i,s]of this.g)s.visible=i===this.h}createOutputChannel(h,i,s){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const u=typeof i=="object"&&i.log,d=(0,p.$Ff)(i)?i:void 0;if((0,p.$Ff)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let m;const f=this.i.environment.extensionLogLevel?.find(([L])=>F.$im.equals(s.identifier,L))?.[1];f&&(m=(0,R.$Aj)(f));const S=u?this.o(h,m,s):this.n(h,d,s);return S.then(L=>{this.g.set(L.id,L),L.visible=L.id===this.h}),u?this.r(h,m??this.m.getLevel(),S):this.q(h,S)}async n(h,i,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const u=await this.c,d=this.k.extUri.joinPath(u,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),m=this.l.createLogger(d,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),f=await this.a.$register(h,d,i,s.identifier.value);return new t(f,h,m,this.a,s)}async o(h,i,s){const u=await this.p(s),d=h.replace(/[\\/:\*\?"<>\|]/g,""),m=this.k.extUri.joinPath(u,`${d}.log`),f=`${s.identifier.value}.${d}`,S=this.l.createLogger(m,{id:f,name:h,logLevel:i,extensionId:s.identifier.value});return new n(f,h,S,this.a,s)}p(h){let i=this.d.get(h.identifier.value);if(!i){const s=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(s)}catch(u){if((0,b.$Dk)(u)!==b.FileSystemProviderErrorCode.FileExists)throw u}return s})())}return i}q(h,i){let s=!1;const u=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return h},append(d){u(),i.then(m=>m.append(d))},appendLine(d){u(),i.then(m=>m.appendLine(d))},clear(){u(),i.then(d=>d.clear())},replace(d){u(),i.then(m=>m.replace(d))},show(d,m){u(),i.then(f=>f.show(d,m))},hide(){u(),i.then(d=>d.hide())},dispose(){s=!0,i.then(d=>d.dispose())}}}r(h,i,s){const u=new o.$Rc,d=()=>{if(u.isDisposed)throw new Error("Channel has been closed")},m=u.add(new r.$Sd);function f(S){i=S,m.fire(S)}return s.then(S=>{u.add(S),S.logLevel!==i&&f(S.logLevel),u.add(S.onDidChangeLogLevel(L=>f(L)))}),{...this.q(h,s),get logLevel(){return i},onDidChangeLogLevel:m.event,trace(S,...L){d(),s.then(v=>v.trace(S,...L))},debug(S,...L){d(),s.then(v=>v.debug(S,...L))},info(S,...L){d(),s.then(v=>v.info(S,...L))},warn(S,...L){d(),s.then(v=>v.warn(S,...L))},error(S,...L){d(),s.then(v=>v.error(S,...L))},dispose(){u.dispose()}}}};e.$Ugc=a,e.$Ugc=a=Ge([Ke(0,I.$UM),Ke(1,w.$$M),Ke(2,g.$Hfc),Ke(3,A.$hfc),Ke(4,R.$lj),Ke(5,R.$kj)],a),e.$Vgc=(0,T.$3h)("IExtHostOutputService")}),define(Ce[113],Re([1,0,4,13]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=e.$Im=void 0,e.$Im=(0,E.$3h)("remoteAgentService"),e.$Jm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(I){let F=1/0;for(let $=0;$<this.maxSampleCount;$++){const g=await I.getRoundTripTime();if(g===void 0)return;F=Math.min(F,g/2),await(0,T.$4g)(this.sampleDelay)}this.average.push(F),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(F):R=this.initial.reduce(($,g)=>$+g,0)/this.initial.length,this.lastMeasurement={initial:R,current:F,average:this.average.reduce(($,g)=>$+g,0)/this.average.length,high:(()=>typeof R>"u"?!1:F>this.highLatencyMaxThreshold||F>this.highLatencyMinThreshold&&F>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ce[279],Re([1,0,170,54,30,47,41,6,5,113,21,26]),function(ge,e,E,T,I,F,R,$,g,w,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=void 0,e.$EH=Object.freeze({id:"application",order:100,title:(0,E.localize)(0,null),type:"object"}),e.$FH=Object.freeze({id:"workbench",order:7,title:(0,E.localize)(1,null),type:"object"}),e.$GH=Object.freeze({id:"security",scope:1,title:(0,E.localize)(2,null),type:"object",order:7}),e.$HH={ConfigurationMigration:"base.contributions.configuration.migration"};class l{constructor(){this.migrations=[],this.a=new g.$Sd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(t){this.migrations.push(...t)}}const p=new l;I.$vn.add(e.$HH.ConfigurationMigration,p);let b=class extends $.$Sc{constructor(t,n){super(),this.a=t,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async a=>{for(const c of a.added)await this.f(c,p.migrations)})),this.c(p.migrations),this.B(p.onDidRegisterConfigurationMigration(a=>this.c(a)))}async c(t){await this.f(void 0,t);for(const n of this.b.getWorkspace().folders)await this.f(n,t)}async f(t,n){await Promise.all([n.map(a=>this.g(a,t?.uri))])}async g(t,n){const a=this.a.inspect(t.key,{resource:n}),c=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[h,i]of c){const s=[];for(const d of a.overrideIdentifiers??[]){const m=await this.h(t,{resource:n,overrideIdentifier:d},h);for(const f of m??[]){let S=s.find(([[L,v]])=>L===f[0]&&(0,D.$nn)(v.value,f[1].value));S||s.push(S=[f,[]]),S[1].push(d)}}const u=await this.h(t,{resource:n},h,a);for(const d of u??[])s.push([d,[]]);s.length&&await Promise.allSettled(s.map(async([[d,m],f])=>this.a.updateValue(d,m.value,{resource:n,overrideIdentifiers:f},i)))}}async h(t,n,a,c){const h=d=>i(this.a.inspect(d,n)),i=d=>{const m=d[a];return n.overrideIdentifier?m?.override:m?.value},s=c?i(c):h(t.key);if(s===void 0)return;const u=await t.migrateFn(s,h);return Array.isArray(u)?u:[[t.key,u]]}};e.$IH=b,e.$IH=b=Ge([Ke(0,R.$wi),Ke(1,F.$_h)],b);let r=class extends $.$Sc{constructor(t){super(),(async()=>{if(!A.$i&&(await t.getEnvironment())?.os!==1)return;I.$vn.as(T.$An.Configuration).registerConfiguration({...e.$GH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,E.localize)(3,null)},default:[],markdownDescription:(0,E.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,E.localize)(5,null),scope:2}}})})()}};e.$JH=r,e.$JH=r=Ge([Ke(0,w.$Im)],r)}),define(Ce[280],Re([1,0,34,12,19,25,178,279,54,4,30]),function(ge,e,E,T,I,F,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8cb=e.$7cb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$6cb=e.$5cb=void 0,e.$5cb=(0,w.$3h)("editorResolverService"),e.$6cb="workbench.editorAssociations";const D=A.$vn.as(g.$An.Configuration),l={...$.$FH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};D.registerConfiguration(l);var p;(function(t){t.builtin="builtin",t.option="option",t.exclusive="exclusive",t.default="default"})(p||(e.RegisteredEditorPriority=p={}));var b;(function(t){t[t.ABORT=1]="ABORT",t[t.NONE=2]="NONE"})(b||(e.ResolvedStatus=b={}));function r(t){switch(t){case p.exclusive:return 5;case p.default:return 4;case p.builtin:return 3;case p.option:default:return 1}}e.$7cb=r;function o(t,n){if(new Set([T.Schemas.extension,T.Schemas.webviewPanel,T.Schemas.vscodeWorkspaceTrust,T.Schemas.vscodeSettings]).has(n.scheme))return!1;const h=typeof t=="string"&&t.indexOf(I.$gc.sep)>=0?`${n.scheme}:${n.path}`:(0,F.$Bg)(n);return E.$Ij(typeof t=="string"?t.toLowerCase():t,h.toLowerCase())}e.$8cb=o}),define(Ce[281],Re([1,0,46,12,19,21,25,2,4,199,47,217,113]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$tK=e.$sK=void 0,e.$sK=(0,g.$3h)("pathService");let b=p=class{constructor(o,t,n,a){this.d=o,this.e=t,this.f=n,this.g=a,this.a=(async()=>(await this.e.getEnvironment())?.os||F.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??o})()}hasValidBasename(o,t,n){return typeof t=="string"||typeof t>"u"?this.a.then(a=>this.h(o,a,t)):this.h(o,t,n)}h(o,t,n){return o.scheme===T.Schemas.file||o.scheme===T.Schemas.vscodeRemote?(0,E.$3f)(n??(0,R.$Bg)(o),t===1):!0}get defaultUriScheme(){return p.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,t){if(o.remoteAuthority)return T.Schemas.vscodeRemote;const n=(0,w.$pK)(t.getWorkspace());if(n)return n;const a=t.getWorkspace().folders[0];if(a)return a.uri.scheme;const c=t.getWorkspace().configuration;return c?c.scheme:T.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?I.$fc:I.$gc)}async fileURI(o){let t="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const a=o.indexOf("/",2);a===-1?(t=o.substring(2),o="/"):(t=o.substring(2,a),o=o.substring(a)||"/")}return $.URI.from({scheme:T.Schemas.file,authority:t,path:o,query:"",fragment:""})}};e.$tK=b,e.$tK=b=p=Ge([Ke(1,l.$Im),Ke(2,D.$bK),Ke(3,A.$_h)],b)}),define(Ce[114],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$8I=e.$7I=void 0;class E{constructor(R,$){this.line=R,this.character=$}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,$){return new E(0,0)}with(R){return new E(0,0)}}e.$7I=E;class T{constructor(R,$,g,w){this.isEmpty=!1,this.isSingleLine=!1,this.start=new E(R,$),this.end=new E(g,w)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new T(0,0,0,0)}with(R){return new T(0,0,0,0)}}e.$8I=T;var I;(function(F){F[F.Information=1]="Information",F[F.Warning=2]="Warning"})(I||(e.TextSearchCompleteMessageType=I={}))}),define(Ce[44],Re([1,0,18,34,26,46,11,4,19,15,114,13]),function(ge,e,E,T,I,F,R,$,g,w,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.SearchErrorCode=e.$kJ=e.$jJ=e.SearchSortOrder=e.ViewMode=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.SearchCompletionExitCode=e.$eJ=e.$dJ=e.$cJ=e.QueryType=e.SearchProviderType=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$9I="workbench.view.search",e.$0I="workbench.panel.search",e.$$I="workbench.view.search",e.$_I="search-result",e.$aJ="search.exclude";const l="\u27EA ",p=" characters skipped \u27EB",b=(l.length+p.length+5)*2;e.$bJ=(0,$.$3h)("searchService");var r;(function(he){he[he.file=0]="file",he[he.text=1]="text"})(r||(e.SearchProviderType=r={}));var o;(function(he){he[he.File=1]="File",he[he.Text=2]="Text"})(o||(e.QueryType=o={}));function t(he){return!!he.preview}e.$cJ=t;function n(he){return!!he.resource}e.$dJ=n;function a(he){return!!he.message}e.$eJ=a;var c;(function(he){he[he.Normal=0]="Normal",he[he.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class h{constructor(ve){this.resource=ve,this.results=[]}}e.$fJ=h;class i{constructor(ve,ee,ke,se){this.ranges=ee,this.webviewIndex=se;const _=Array.isArray(ee)?ee:[ee];if(ke&&ke.matchLines===1&&s(_)){ve=(0,R.$yf)(ve,ke.matchLines);let V="",ne=0,Ie=0;const Ae=Math.floor(ke.charsPerLine/5),Pe=[];for(const ce of _){const ie=Math.max(ce.startColumn-Ae,0),Q=ce.startColumn+ke.charsPerLine;if(ie>Ie+Ae+b){const te=l+(ie-Ie)+p;V+=te+ve.slice(ie,Q),ne+=ie-(Ie+te.length)}else V+=ve.slice(Ie,Q);Pe.push(new d(0,ce.startColumn-ne,ce.endColumn-ne)),Ie=Q}this.preview={text:V,matches:Array.isArray(this.ranges)?Pe:Pe[0]}}else{const V=Array.isArray(ee)?ee[0].startLineNumber:ee.startLineNumber;this.preview={text:ve,matches:(0,E.$2b)(ee,ne=>new u(ne.startLineNumber-V,ne.startColumn,ne.endLineNumber-V,ne.endColumn))}}}}e.$gJ=i;function s(he){const ve=he[0].startLineNumber;for(const ee of he)if(ee.startLineNumber!==ve||ee.endLineNumber!==ve)return!1;return!0}class u{constructor(ve,ee,ke,se){this.startLineNumber=ve,this.startColumn=ee,this.endLineNumber=ke,this.endColumn=se}}e.$hJ=u;class d extends u{constructor(ve,ee,ke){super(ve,ee,ve,ke)}}e.$iJ=d;var m;(function(he){he.List="list",he.Tree="tree"})(m||(e.ViewMode=m={}));var f;(function(he){he.Default="default",he.FileNames="fileNames",he.Type="type",he.Modified="modified",he.CountDescending="countDescending",he.CountAscending="countAscending"})(f||(e.SearchSortOrder=f={}));function S(he,ve=!0){const ee=he&&he.files&&he.files.exclude,ke=ve&&he&&he.search&&he.search.exclude;if(!ee&&!ke)return;if(!ee||!ke)return ee||ke;let se=Object.create(null);return se=I.$mn(se,I.$jn(ee)),se=I.$mn(se,I.$jn(ke),!0),se}e.$jJ=S;function L(he,ve){return he.excludePattern&&T.$Ij(he.excludePattern,ve)?!1:he.includePattern||he.usingSearchPaths?he.includePattern&&T.$Ij(he.includePattern,ve)?!0:he.usingSearchPaths?!!he.folderQueries&&he.folderQueries.some(ee=>{const ke=ee.folder.fsPath;if(F.$5f(ve,ke)){const se=g.$lc(ke,ve);return!ee.includePattern||!!T.$Ij(ee.includePattern,se)}else return!1}):!1:!0}e.$kJ=L;var v;(function(he){he[he.unknownEncoding=1]="unknownEncoding",he[he.regexParseError=2]="regexParseError",he[he.globParseError=3]="globParseError",he[he.invalidLiteral=4]="invalidLiteral",he[he.rgProcessError=5]="rgProcessError",he[he.other=6]="other",he[he.canceled=7]="canceled"})(v||(e.SearchErrorCode=v={}));class y extends Error{constructor(ve,ee){super(ve),this.code=ee}}e.$lJ=y;function k(he){const ve=he.message;if((0,w.$4)(he))return new y(ve,v.canceled);try{const ee=JSON.parse(ve);return new y(ee.message,ee.code)}catch{return new y(ve,v.other)}}e.$mJ=k;function N(he){const ve={message:he.message,code:he.code};return new Error(JSON.stringify(ve))}e.$nJ=N;function O(he){return he.type==="error"?!0:he.type==="success"}e.$oJ=O;function K(he){return he.type==="success"}e.$pJ=K;function j(he){return!!he.path}e.$qJ=j;function W(he,ve){const ee=he.searchPath?he.searchPath:he.relativePath;return(0,R.$vf)(ee,ve)}e.$rJ=W;class P{constructor(ve){this.path=ve,this.results=[]}addMatch(ve){this.results.push(ve)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$sJ=P;function C(he,ve){const ee={...he||{},...ve||{}};return Object.keys(ee).filter(ke=>{const se=ee[ke];return typeof se=="boolean"&&se})}e.$tJ=C;class J{constructor(ve,ee){this.c=null,this.a={...ve.excludePattern||{},...ee.excludePattern||{}},this.b=T.$Jj(this.a);let ke=ve.includePattern;ee.includePattern&&(ke?ke={...ke,...ee.includePattern}:ke=ee.includePattern),ke&&(this.c=T.$Jj(ke))}matchesExcludesSync(ve,ee,ke){return!!(this.b&&this.b(ve,ee,ke))}includedInQuerySync(ve,ee,ke){return!(this.b&&this.b(ve,ee,ke)||this.c&&!this.c(ve,ee,ke))}includedInQuery(ve,ee,ke){const se=this.b(ve,ee,ke),_=()=>this.c?!!this.c(ve,ee,ke):!0;return(0,D.$Pg)(se)?se.then(V=>V?!1:_()):_()}hasSiblingExcludeClauses(){return ae(this.a)}}e.$uJ=J;function ae(he){for(const ve in he)if(typeof he[ve]!="boolean")return!0;return!1}function fe(he){if(!he)return;let ve;return ee=>(ve||(ve=(he()||Promise.resolve([])).then(ke=>ke?ye(ke):{})),ve.then(ke=>!!ke[ee]))}e.$vJ=fe;function be(he){if(!he)return;let ve;return ee=>{if(!ve){const ke=he();ve=ke?ye(ke):{}}return!!ve[ee]}}e.$wJ=be;function ye(he){const ve={};for(const ee of he)ve[ee]=!0;return ve}}),define(Ce[36],Re([1,0,18,13,20,5,6,50,12,122,25,11,2,169,4,14,188,47,43,27,17,8,7,57,44,3,51]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l,p,b,r,o,t,n,a,c,h,i,s,u,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cfc=e.$Bfc=void 0;function f(K,j,W){return new A.$tg(P=>y(P,W)).isEqual(K,j)}function S(K,j,W){return f(K.uri,j.uri,W)?0:(0,D.$2e)(K.uri.toString(),j.uri.toString())}function L(K,j,W){return K.index!==j.index?K.index<j.index?-1:1:f(K.uri,j.uri,W)?(0,D.$2e)(K.name,j.name):(0,D.$2e)(K.uri.toString(),j.uri.toString())}function v(K,j,W,P){const C=K.slice(0).sort((ae,fe)=>W(ae,fe,P)),J=j.slice(0).sort((ae,fe)=>W(ae,fe,P));return(0,E.$Eb)(C,J,(ae,fe)=>W(ae,fe,P))}function y(K,j){const W=j.getCapabilities(K.scheme);return!(W&&W&1024)}class k extends t.$ji{static toExtHostWorkspace(j,W,P,C){if(!j)return{workspace:null,added:[],removed:[]};const{id:J,name:ae,folders:fe,configuration:be,transient:ye,isUntitled:he}=j,ve=[],ee=W;W?fe.forEach((V,ne)=>{const Ie=l.URI.revive(V.uri),Ae=k.o(P||W,Ie,C);Ae?(Ae.name=V.name,Ae.index=V.index,ve.push(Ae)):ve.push({uri:Ie,name:V.name,index:ne})}):ve.push(...fe.map(({uri:V,name:ne,index:Ie})=>({uri:l.URI.revive(V),name:ne,index:Ie}))),ve.sort((V,ne)=>V.index<ne.index?-1:1);const ke=new k(J,ae,ve,!!ye,be?l.URI.revive(be):null,!!he,V=>y(V,C)),{added:se,removed:_}=v(ee?ee.workspaceFolders:[],ke.workspaceFolders,S,C);return{workspace:ke,added:se,removed:_}}static o(j,W,P){for(let C=0;C<j.folders.length;C++){const J=j.workspaceFolders[C];if(f(J.uri,W,P))return J}}constructor(j,W,P,C,J,ae,fe){super(j,P.map(be=>new t.$ki(be)),C,J,fe),this.t=W,this.u=ae,this.q=[],this.s=$.$9h.forUris(fe),P.forEach(be=>{this.q.push(be),this.s.set(be.uri,be)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,W){return W&&this.s.get(j)&&(j=(0,A.$Dg)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let N=class{constructor(j,W,P,C,J){this.c=new F.$Sd,this.onDidChangeWorkspace=this.c.event,this.g=new F.$Sd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new F.$Ud,this.B=new Map,this.h=C,this.s=P,this.t=J,this.j=new w.$6l,this.k=new T.$2g,this.o=j.getProxy(d.$QK.MainThreadWorkspace),this.q=j.getProxy(d.$QK.MainThreadMessageService);const ae=W.workspace;this.l=ae?new k(ae.id,ae.name,[],!!ae.transient,ae.configuration?l.URI.revive(ae.configuration):null,!!ae.isUntitled,fe=>y(fe,P)):void 0}$initializeWorkspace(j,W){this.v=W,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:g.Schemas.untitled,path:(0,A.$Bg)((0,A.$Dg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,W,P,...C){const J=[];if(Array.isArray(C)&&C.forEach(he=>{l.URI.isUri(he.uri)&&!J.some(ve=>f(ve.uri,he.uri,this.s))&&J.push({uri:he.uri,name:he.name||(0,A.$Ag)(he.uri)})}),this.n||[W,P].some(he=>typeof he!="number"||he<0)||P===0&&J.length===0)return!1;const ae=this.x?this.x.workspaceFolders:[];if(W+P>ae.length)return!1;const fe=ae.slice(0);fe.splice(W,P,...J.map(he=>({uri:he.uri,name:he.name||(0,A.$Ag)(he.uri),index:void 0})));for(let he=0;he<fe.length;he++){const ve=fe[he];if(fe.some((ee,ke)=>ke!==he&&f(ve.uri,ee.uri,this.s)))return!1}fe.forEach((he,ve)=>he.index=ve);const{added:be,removed:ye}=v(ae,fe,L,this.s);if(be.length===0&&ye.length===0)return!1;if(this.o){const he=j.displayName||j.name;this.o.$updateWorkspaceFolders(he,W,P,J).then(void 0,ve=>{this.n=void 0;const ee={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(o.Severity.Error,(0,p.localize)(0,null,he,ve.toString()),ee,[])})}return this.y(fe),!0}getWorkspaceFolder(j,W){if(this.x)return this.x.getWorkspaceFolder(j,W)}async getWorkspaceFolder2(j,W){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,W)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,W){let P,C="";if(typeof j=="string"?(P=l.URI.file(j),C=j):typeof j<"u"&&(P=j,C=j.fsPath),!P)return C;const J=this.getWorkspaceFolder(P,!0);if(!J)return C;typeof W>"u"&&this.x&&(W=this.x.folders.length>1);let ae=(0,A.$Gg)(J.uri,P);return W&&J.name&&(ae=`${J.name}/${ae}`),ae}y(j){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:W,added:P,removed:C}=k.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=W||void 0,this.n=void 0,this.c.fire(Object.freeze({added:P,removed:C}))}findFiles(j,W,P,C,J=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${C.value}, entryPoint: findFiles`);let ae;if(W===null?ae=!1:W&&(typeof W=="string"?ae=W:ae=W.pattern),J&&J.isCancellationRequested)return Promise.resolve([]);const{includePattern:fe,folder:be}=O(h.GlobPattern.from(j));return this.o.$startFileSearch(fe??null,be??null,ae??null,P??null,J).then(ye=>Array.isArray(ye)?ye.map(he=>l.URI.revive(he)):[])}async findTextInFiles(j,W,P,C,J=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${C.value}, entryPoint: findTextInFiles`);const ae=this.j.getNext(),fe=typeof W.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:W.previewOptions,{includePattern:be,folder:ye}=O(h.GlobPattern.from(W.include)),he=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,ve={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof W.useParentIgnoreFiles=="boolean"?!W.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!0,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:fe,afterContext:W.afterContext,beforeContext:W.beforeContext,includePattern:be,excludePattern:he},ee=!1;if(this.u[ae]=ke=>{if(ee)return;const se=l.URI.revive(ke.resource);ke.results.forEach(_=>{const V=(0,m.$zh)(_);(0,u.$cJ)(V)?P({uri:se,preview:{text:V.preview.text,matches:(0,E.$2b)(V.preview.matches,ne=>new i.$UK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,E.$2b)(V.ranges,ne=>new i.$UK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):P({uri:se,text:V.text,lineNumber:V.lineNumber})})},J.isCancellationRequested)return{};try{const ke=await this.o.$startTextSearch(j,ye??null,ve,ae,J);return delete this.u[ae],ke||{}}catch(ke){throw delete this.u[ae],ke}}$handleTextSearchResult(j,W){this.u[W]?.(j)}async save(j){const W=await this.o.$save(j,{saveAs:!1});return l.URI.revive(W)}async saveAs(j){const W=await this.o.$save(j,{saveAs:!0});return l.URI.revive(W)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,W){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,W);const P=this.t.transformOutgoingScheme(j),C=this.z++;return this.o.$registerEditSessionIdentityProvider(C,P),(0,R.$Qc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(C)})}async $getEditSessionIdentifier(j,W){this.h.info("Getting edit session identifier for workspaceFolder",j);const P=await this.resolveWorkspaceFolder(l.URI.revive(j));if(!P){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",P);const C=this.w.get(P.uri.scheme);if(this.h.info(`Provider for scheme ${P.uri.scheme} is defined: `,!!C),!C)return;const J=await C.provideEditSessionIdentity(P,W);if(this.h.info("Provider returned edit session identifier: ",J),!!J)return J}async $provideEditSessionIdentityMatch(j,W,P,C){this.h.info("Getting edit session identifier for workspaceFolder",j);const J=await this.resolveWorkspaceFolder(l.URI.revive(j));if(!J){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",J);const ae=this.w.get(J.uri.scheme);if(this.h.info(`Provider for scheme ${J.uri.scheme} is defined: `,!!ae),!ae)return;const fe=await ae.provideEditSessionIdentityMatch?.(W,P,C);if(this.h.info("Provider returned edit session identifier match result: ",fe),!!fe)return fe}getOnWillCreateEditSessionIdentityEvent(j){return(W,P,C)=>{const J=function(fe){W.call(P,fe)};return J.extension=j,this.A.event(J,void 0,C)}}async $onWillCreateEditSessionIdentity(j,W,P){const C=await this.resolveWorkspaceFolder(l.URI.revive(j));if(C===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:C},W,async(J,ae)=>{const fe=Date.now();await Promise.resolve(J),Date.now()-fe>P&&this.h.warn("SLOW edit session create-participant",ae.extension.identifier)}),W.isCancellationRequested}registerCanonicalUriProvider(j,W){if(this.B.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.B.set(j,W);const P=this.t.transformOutgoingScheme(j),C=this.z++;return this.o.$registerCanonicalUriProvider(C,P),(0,R.$Qc)(()=>{this.B.delete(j),this.o.$unregisterCanonicalUriProvider(C)})}async provideCanonicalUri(j,W,P){const C=this.B.get(j.scheme);if(!C)return;const J=await C.provideCanonicalUri?.(l.URI.revive(j),W,P);if(J)return J}async $provideCanonicalUri(j,W,P){return this.provideCanonicalUri(l.URI.revive(j),{targetScheme:W},P)}};e.$Bfc=N,e.$Bfc=N=Ge([Ke(0,c.$UM),Ke(1,a.$$M),Ke(2,n.$hfc),Ke(3,r.$kj),Ke(4,s.$zfc)],N),e.$Cfc=(0,b.$3h)("IExtHostWorkspace");function O(K){let j,W;return K&&(typeof K=="string"?j=K:(j=K.pattern,W=l.URI.revive(K.baseUri))),{includePattern:j,folder:W}}}),define(Ce[37],Re([1,0,26,5,36,3,7,190,54,16,13,4,17,14,2]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=e.$Efc=e.$Dfc=void 0;function r(s,u){if(u){const d=u.split(".");let m=s;for(let f=0;m&&f<d.length;f++)m=m[d[f]];return m}}function o(s){return s instanceof b.URI}function t(s){return s&&s.uri instanceof b.URI&&s.languageId&&typeof s.languageId=="string"}function n(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function a(s){return s&&s.uri instanceof b.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function c(s){if(o(s))return{resource:s};if(t(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(n(s))return{overrideIdentifier:s.languageId};if(a(s))return{resource:s.uri};if(s===null)return{resource:null}}let h=class{constructor(u,d,m){this.a=u.getProxy(F.$QK.MainThreadConfiguration),this.c=d,this.b=m,this.d=new A.$2g,this.e=null}getConfigProvider(){return this.d.wait().then(u=>this.e)}$initializeConfiguration(u){this.e=new i(this.a,this.c,u,this.b),this.d.open()}$acceptConfigurationChanged(u,d){this.getConfigProvider().then(m=>m.$acceptConfigurationChanged(u,d))}};e.$Dfc=h,e.$Dfc=h=Ge([Ke(0,l.$UM),Ke(1,I.$Cfc),Ke(2,p.$kj)],h);class i{constructor(u,d,m,f){this.a=new T.$Sd,this.b=u,this.f=f,this.c=d,this.e=$.$Tn.parse(m),this.d=this.k(m.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(u,d){const m={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Tn.parse(u),this.d=this.k(u.configurationScopes),this.a.fire(this.j(d,m))}getConfiguration(u,d,m){const f=c(d)||{},S=this.g(u?r(this.e.getValue(void 0,f,this.c.workspace),u):this.e.getValue(void 0,f,this.c.workspace));u&&this.h(u,f,m?.identifier);function L(y){if(y==null)return null;if(typeof y=="boolean")return y?2:5;switch(y){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(y){return typeof r(S,y)<"u"},get:(y,k)=>{this.h(u?`${u}.${y}`:y,f,m?.identifier);let N=r(S,y);if(typeof N>"u")N=k;else{let O;const K=(j,W)=>{if((0,w.$Hf)(j)){let P;const C=()=>{O=O||(0,E.$jn)(S),P=P||r(O,W)};return new Proxy(j,{get:(J,ae)=>{if(typeof ae=="string"&&ae.toLowerCase()==="tojson")return C(),()=>P;if(O)return P=P||r(O,W),P[ae];const fe=J[ae];return typeof ae=="string"?K(fe,`${W}.${ae}`):fe},set:(J,ae,fe)=>(C(),P&&(P[ae]=fe),!0),deleteProperty:(J,ae)=>(C(),P&&delete P[ae],!0),defineProperty:(J,ae,fe)=>(C(),P&&Object.defineProperty(P,ae,fe),!0)})}return Array.isArray(j)?(0,E.$jn)(j):j};N=K(N,y)}return N},update:(y,k,N,O)=>{y=u?`${u}.${y}`:y;const K=L(N);return k!==void 0?this.b.$updateConfigurationOption(K,y,k,f,O):this.b.$removeConfigurationOption(K,y,f,O)},inspect:y=>{y=u?`${u}.${y}`:y;const k=this.e.inspect(y,f,this.c.workspace);if(k)return{key:y,defaultValue:(0,E.$jn)(k.policy?.value??k.default?.value),globalValue:(0,E.$jn)(k.user?.value??k.application?.value),workspaceValue:(0,E.$jn)(k.workspace?.value),workspaceFolderValue:(0,E.$jn)(k.workspaceFolder?.value),defaultLanguageValue:(0,E.$jn)(k.default?.override),globalLanguageValue:(0,E.$jn)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,E.$jn)(k.workspace?.override),workspaceFolderLanguageValue:(0,E.$jn)(k.workspaceFolder?.override),languageIds:(0,E.$jn)(k.overrideIdentifiers)}}};return typeof S=="object"&&(0,E.$mn)(v,S,!1),Object.freeze(v)}g(u){const d=m=>(0,w.$Hf)(m)?new Proxy(m,{get:(f,S)=>d(f[S]),set:(f,S,L)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(S)}' of object`)},deleteProperty:(f,S)=>{throw new Error(`TypeError: Cannot delete read only property '${String(S)}' of object`)},defineProperty:(f,S)=>{throw new Error(`TypeError: Cannot define property '${String(S)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):m;return d(u)}h(u,d,m){const f=g.$Kn.test(u)?4:this.d.get(u),S=m?`[${m.value}] `:"";if(f===4){typeof d?.resource>"u"&&this.f.warn(`${S}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){d?.resource&&this.f.warn(`${S}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(u,d){const m=new $.$Vn(u,d,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(f,S)=>m.affectsConfiguration(f,c(S))})}k(u){return u.reduce((d,m)=>(d.set(m[0],m[1]),d),new Map)}}e.$Efc=i,e.$Ffc=(0,D.$3h)("IExtHostConfiguration")}),define(Ce[115],Re([1,0,2,13,5,3,7,36,61,37,20,64,17,27,4,12,21,14,81,229,15]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l,p,b,r,o,t,n,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=e.$8gc=e.$7gc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(K){function j(P){if(P!=null)return P}K.from=j;function W(P){if(P!=null)return P}K.to=W})(h||(h={}));var i;(function(K){function j(P){if(P!=null)return P}K.from=j;function W(P){if(P!=null)return P}K.to=W})(i||(i={}));var s;(function(K){function j(P){if(P!=null)return P}K.from=j;function W(P){if(P!=null)return P}K.to=W})(s||(s={}));var u;(function(K){function j(C){if(C){const J=C;return J&&!!J.process}else return!1}K.is=j;function W(C){if(C==null)return;const J={process:C.process,args:C.args};return C.options&&(J.options=s.from(C.options)),J}K.from=W;function P(C){if(C!=null)return new R.$BL(C.process,C.args,C.options)}K.to=P})(u||(u={}));var d;(function(K){function j(P){if(P!=null)return P}K.from=j;function W(P){if(P!=null)return P}K.to=W})(d||(d={}));var m;(function(K){function j(C){if(C){const J=C;return J&&(!!J.commandLine||!!J.command)}else return!1}K.is=j;function W(C){if(C==null)return;const J={};return C.commandLine!==void 0?J.commandLine=C.commandLine:(J.command=C.command,J.args=C.args),C.options&&(J.options=d.from(C.options)),J}K.from=W;function P(C){if(!(C==null||C.command===void 0&&C.commandLine===void 0))return C.commandLine?new R.$CL(C.commandLine,C.options):new R.$CL(C.command,C.args?C.args:[],C.options)}K.to=P})(m||(m={}));var f;(function(K){function j(C){if(C){const J=C;return J&&J.customExecution==="customExecution"}else return!1}K.is=j;function W(C){return{customExecution:"customExecution"}}K.from=W;function P(C,J){return J.get(C)}K.to=P})(f||(e.CustomExecutionDTO=f={}));var S;(function(K){function j(W,P){let C;return W.scope!==void 0&&typeof W.scope!="number"?C=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===R.TaskScope.Workspace&&P&&P.workspaceFile?C=P.workspaceFile:C=a.$lG),{id:W._id,workspaceFolder:C}}K.from=j})(S||(e.TaskHandleDTO=S={}));var L;(function(K){function j(W){if(W!=null)return{_id:W.id,isDefault:W.isDefault}}K.from=j})(L||(L={}));var v;(function(K){function j(C,J){if(C==null)return[];const ae=[];for(const fe of C){const be=W(fe,J);be&&ae.push(be)}return ae}K.fromMany=j;function W(C,J){if(C==null)return;let ae;C.execution instanceof R.$BL?ae=u.from(C.execution):C.execution instanceof R.$CL?ae=m.from(C.execution):C.execution&&C.execution instanceof R.$DL&&(ae=f.from(C.execution));const fe=h.from(C.definition);let be;return C.scope?typeof C.scope=="number"?be=C.scope:be=C.scope.uri:be=R.TaskScope.Workspace,!fe||!be?void 0:{_id:C._id,definition:fe,name:C.name,source:{extensionId:J.identifier.value,label:C.source,scope:be},execution:ae,isBackground:C.isBackground,group:L.from(C.group),presentationOptions:i.from(C.presentationOptions),problemMatchers:C.problemMatchers,hasDefinedMatchers:C.hasDefinedMatchers,runOptions:C.runOptions?C.runOptions:{reevaluateOnRerun:!0},detail:C.detail}}K.from=W;async function P(C,J,ae){if(C==null)return;let fe;u.is(C.execution)?fe=u.to(C.execution):m.is(C.execution)?fe=m.to(C.execution):f.is(C.execution)&&(fe=f.to(C._id,ae));const be=h.to(C.definition);let ye;if(C.source&&(C.source.scope!==void 0?typeof C.source.scope=="number"?ye=C.source.scope:ye=await J.resolveWorkspaceFolder(E.URI.revive(C.source.scope)):ye=R.TaskScope.Workspace),!be||!ye)return;const he=new R.$EL(be,ye,C.name,C.source.label,fe,C.problemMatchers);return C.isBackground!==void 0&&(he.isBackground=C.isBackground),C.group!==void 0&&(he.group=R.$AL.from(C.group._id),he.group&&C.group.isDefault&&(he.group=new R.$AL(he.group.id,he.group.label),C.group.isDefault===!0&&(he.group.isDefault=C.group.isDefault))),C.presentationOptions&&(he.presentationOptions=i.to(C.presentationOptions)),C._id&&(he._id=C._id),C.detail&&(he.detail=C.detail),he}K.to=P})(v||(e.TaskDTO=v={}));var y;(function(K){function j(P){return P}K.from=j;function W(P){if(P)return Object.assign(Object.create(null),P)}K.to=W})(y||(y={}));class k{#e;constructor(j,W,P){this._id=W,this.a=P,this.#e=j}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}let N=class{constructor(j,W,P,C,J,ae,fe,be){this.q=new I.$Sd,this.r=new I.$Sd,this.s=new I.$Sd,this.u=new I.$Sd,this.a=j.getProxy(F.$QK.MainThreadTask),this.b=P,this.c=C,this.d=J,this.e=ae,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=fe,this.g=be,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(j,W,P){if(!P)return new R.$SK(()=>{});const C=this.x();return this.j.set(C,{type:W,provider:P,extension:j}),this.a.$registerTaskProvider(C,W),new R.$SK(()=>{this.j.delete(C),this.a.$unregisterTaskProvider(C)})}registerTaskSystem(j,W){this.a.$registerTaskSystem(j,W)}fetchTasks(j){return this.a.$fetchTasks(y.from(j)).then(async W=>{const P=[];for(const C of W){const J=await v.to(C,this.b,this.m);J&&P.push(J)}return P})}get taskExecutions(){const j=[];return this.k.forEach(W=>j.push(W)),j}terminateTask(j){if(!(j instanceof k))throw new Error("No valid task execution provided");return this.a.$terminateTask(j._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(j,W,P){const C=this.m.get(j.id);C&&(this.o.set(j.id,C),this.e.attachPtyToTerminal(W,await C.callback(P))),this.p=j.id,this.q.fire({execution:await this.z(j)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(j){if(!this.l.has(j.id))return;const W=await this.z(j);this.l.delete(j.id),this.k.delete(j.id),this.B(j),this.r.fire({execution:W})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(j){const W=await this.z(j.id);this.s.fire({execution:W,processId:j.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(j){const W=await this.z(j.id);this.u.fire({execution:W,exitCode:j.exitCode})}$provideTasks(j,W){const P=this.j.get(j);if(!P)return Promise.reject(new Error("no handler found"));const C=[],J=(0,T.$Vg)(()=>P.provider.provideTasks(A.CancellationToken.None)).then(ae=>this.v(W,C,P,ae));return new Promise(ae=>{J.then(fe=>{Promise.all(C).then(()=>{ae(fe)})})})}async $resolveTask(j,W){const P=this.j.get(j);if(!P)return Promise.reject(new Error("no handler found"));if(W.definition.type!==P.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${P.type}].`);const C=await v.to(W,this.b,this.m);if(!C)throw new Error("Unexpected: Task cannot be resolved.");const J=await P.provider.resolveTask(C,A.CancellationToken.None);if(!J)return;this.A(J,P);const ae=v.from(J,P.extension);if(!ae)throw new Error("Unexpected: Task cannot be resolved.");if(J.definition!==C.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return f.is(ae.execution)&&await this.y(ae,J,!0),await this.w(ae)}x(){return this.h++}async y(j,W,P){const C=await this.a.$createTaskId(j);!P&&!this.m.has(C)&&(this.n.add(C),this.o.set(C,W.execution)),this.m.set(C,W.execution)}async z(j,W){if(typeof j=="string"){const J=this.l.get(j);if(!J)throw new c.$bb("Unexpected: The specified task is missing an execution");return J}const P=this.l.get(j.id);if(P)return P;let C;return W?C=Promise.resolve(new k(this,j.id,W)):C=v.to(j.task,this.b,this.m).then(J=>{if(!J)throw new c.$bb("Unexpected: Task does not exist.");return new k(this,j.id,J)}),this.l.set(j.id,C),C.then(J=>(this.k.set(j.id,J),J))}A(j,W){j._deprecated&&this.g.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}B(j){this.o.get(j.id)&&this.o.delete(j.id),this.n.has(j.id)&&this.p!==j.id&&(this.m.delete(j.id),this.n.delete(j.id));const P=this.n.values();let C=P.next();for(;!C.done;)!this.o.has(C.value)&&this.p!==C.value&&(this.m.delete(C.value),this.n.delete(C.value)),C=P.next()}};e.$7gc=N,e.$7gc=N=Ge([Ke(0,l.$UM),Ke(1,p.$$M),Ke(2,$.$Cfc),Ke(3,g.$6M),Ke(4,w.$Ffc),Ke(5,D.$4fc),Ke(6,t.$kj),Ke(7,n.$kfc)],N);let O=class extends N{constructor(j,W,P,C,J,ae,fe,be){super(j,W,P,C,J,ae,fe,be),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(j,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const P=v.from(W,j);if(P===void 0)throw new Error("Task is not valid");if(f.is(P.execution))await this.y(P,W,!1);else throw new c.$_;const C=await this.z(await this.a.$getTaskExecution(P),W);return this.a.$executeTask(P).catch(J=>{throw new Error(J)}),C}v(j,W,P,C){const J=[];if(C)for(const ae of C){if(this.A(ae,P),!ae.definition||!j[ae.definition.type]){const be=ae.source?ae.source:"No task source";this.f.warn(`The task [${be}, ${ae.name}] uses an undefined task type. The task will be ignored in the future.`)}const fe=v.from(ae,P.extension);fe&&f.is(fe.execution)?(J.push(fe),W.push(this.y(fe,ae,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:J,extension:P.extension}}async w(j){if(f.is(j.execution))return j;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(j,W){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,W,P){}};e.$8gc=O,e.$8gc=O=Ge([Ke(0,l.$UM),Ke(1,p.$$M),Ke(2,$.$Cfc),Ke(3,g.$6M),Ke(4,w.$Ffc),Ke(5,D.$4fc),Ke(6,t.$kj),Ke(7,n.$kfc)],O),e.$9gc=(0,b.$3h)("IExtHostTask")}),define(Ce[282],Re([1,0,44,29]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EJ=e.$DJ=e.$CJ=void 0;function I(R){return"cellResults"in R}e.$CJ=I,e.$DJ="rawCell#";function F(R,$){let g=-1;const w=[];let A=[];return R.forEach(l=>{l.range.startLineNumber!==g&&A.length>0&&(w.push([...A]),A=[]),A.push(l),g=l.range.endLineNumber}),A.length>0&&w.push([...A]),w.map(l=>{const p=[],b=l[0].range.startLineNumber,r=l[l.length-1].range.endLineNumber;for(let o=b;o<=r;o++)p.push($.getLineContent(o));return new E.$gJ(p.join(`
`)+`
`,l.map(o=>new T.$Is(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}e.$EJ=F}),define(Ce[283],Re([1,0,162,24,5,6,28,11,16,2,42,75,3,32,8,7,49,221,107,26,12,212,282,280]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l,p,b,r,o,t,n,a,c,h,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Igc=void 0;class u{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(m=>m.apiEditor)}constructor(m,f,S,L,v,y){this.q=S,this.r=L,this.s=v,this.t=y,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new I.$Sd,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new I.$Sd,this.onDidOpenNotebookDocument=this.m.event,this.n=new I.$Sd,this.onDidCloseNotebookDocument=this.n.event,this.o=new I.$Sd,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.$dfc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=m.getProxy(l.$QK.MainThreadNotebook),this.c=m.getProxy(l.$QK.MainThreadNotebookDocuments),this.d=m.getProxy(l.$QK.MainThreadNotebookEditors),this.i=f.converter,f.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const N=k.notebookEditor?.notebookUri,O=k.cell.handle,j=this.g.get(N)?.getCell(O);if(j)return j.apiCell}if(k&&k.$mid===14){const N=k.uri,O=this.g.get(N);if(O)return O.apiNotebook}return k}}),u.B(f)}getEditorById(m){const f=this.h.get(m);if(!f)throw new Error(`unknown text editor: ${m}. known editors: ${[...this.h.keys()]} `);return f}getIdByEditor(m){for(const[f,S]of this.h)if(S.apiEditor===m)return f}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(m,f){const S=this.g.get(m);if(!S&&!f)throw new Error(`NO notebook document for '${m}'`);return S}static u(m,f){if(!f)return;const S=f.filenamePattern.map(L=>b.NotebookExclusiveDocumentPattern.from(L)).filter(L=>L!==void 0);if(f.filenamePattern&&!S){console.warn(`Notebook content provider view options file name pattern is invalid ${f.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:f.displayName,filenamePattern:S,exclusive:f.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,f,S){const L=u.a++,v=typeof S.onDidChangeCellStatusBarItems=="function"?u.a++:void 0;this.f.set(L,S),this.b.$registerNotebookCellStatusBarItemProvider(L,v,f);let y;return v!==void 0&&(y=S.onDidChangeCellStatusBarItems(k=>this.b.$emitCellStatusBarEvent(v))),new r.$SK(()=>{this.f.delete(L),this.b.$unregisterNotebookCellStatusBarItemProvider(L,v),y?.dispose()})}async createNotebookDocument(m){const f=await this.c.$tryCreateNotebook({viewType:m.viewType,content:m.content&&b.NotebookData.from(m.content)});return w.URI.revive(f)}async openNotebookDocument(m){const f=this.g.get(m);if(f)return f.apiNotebook;const S=await this.c.$tryOpenNotebook(m),L=this.g.get(w.URI.revive(S));return(0,g.$Qf)(L?.apiNotebook)}async showNotebookDocument(m,f){w.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let S;typeof f=="object"?S={position:b.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus,selections:f.selections&&f.selections.map(b.NotebookRange.from),pinned:typeof f.preview=="boolean"?!f.preview:void 0}:S={preserveFocus:!1};const L=await this.d.$tryShowNotebookDocument(m.uri,m.notebookType,S),v=L&&this.h.get(L)?.apiEditor;if(v)return v;throw L?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,f,S,L){const v=this.f.get(m),y=w.URI.revive(f),k=this.g.get(y);if(!k||!v)return;const N=k.getCellFromIndex(S);if(!N)return;const O=await v.provideCellStatusBarItems(N.apiCell,L);if(!O)return;const K=new F.$Rc,j=this.p.add([K]),P=(Array.isArray(O)?O:[O]).map(C=>b.NotebookStatusBarItem.from(C,this.i,K));return{cacheId:j,items:P}}$releaseNotebookCellStatusBarItems(m){this.p.delete(m)}registerNotebookSerializer(m,f,S,L,v){if((0,$.$Ge)(f))throw new Error("viewType cannot be empty or just whitespace");const y=this.w++;return this.x.set(y,{viewType:f,serializer:S,options:L}),this.b.$registerNotebookSerializer(y,{id:m.identifier,location:m.extensionLocation},f,b.NotebookDocumentContentOptions.from(L),u.u(m,v)),(0,F.$Qc)(()=>{this.b.$unregisterNotebookSerializer(y)})}async $dataToNotebook(m,f,S){const L=this.x.get(m);if(!L)throw new Error("NO serializer found");const v=await L.serializer.deserializeNotebook(f.buffer,S);return new o.$Gv(b.NotebookData.from(v))}async $notebookToData(m,f,S){const L=this.x.get(m);if(!L)throw new Error("NO serializer found");const v=await L.serializer.serializeNotebook(b.NotebookData.to(f.value),S);return T.$ge.wrap(v)}async $saveNotebook(m,f,S,L,v){const y=w.URI.revive(f),k=this.x.get(m);if(!k)throw new Error("NO serializer found");const N=this.g.get(y);if(!N)throw new Error("Document NOT found");if(N.versionId!==S)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(y.scheme))throw new A.$Ik((0,E.localize)(0,null,this.z(y)),6);await this.y(y,L);const O={metadata:(0,a.$rn)(N.apiNotebook.metadata,C=>!(k.options?.transientDocumentMetadata??{})[C]),cells:[]};for(const C of N.apiNotebook.getCells()){const J=new r.$fM(C.kind,C.document.getText(),C.document.languageId,C.mime,k.options?.transientOutputs?[]:[...C.outputs],C.metadata,C.executionSummary);J.metadata=(0,a.$rn)(C.metadata,ae=>!(k.options?.transientCellMetadata??{})[ae]),O.cells.push(J)}const K=await k.serializer.serializeNotebook(O,v);await this.s.value.writeFile(y,K);const j=this.s.getFileSystemProviderExtUri(y.scheme),W=await this.s.value.stat(y);return{name:j.basename(y),isFile:(W.type&A.FileType.File)!==0,isDirectory:(W.type&A.FileType.Directory)!==0,isSymbolicLink:(W.type&A.FileType.SymbolicLink)!==0,mtime:W.mtime,ctime:W.ctime,size:W.size,readonly:!!((W.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(y.scheme),locked:!!((W.permissions??0)&A.FilePermission.Locked),etag:A.$Tk({mtime:W.mtime,size:W.size}),children:void 0}}async $searchInNotebooks(m,f,S,L,v){const y=this.x.get(m)?.serializer;if(!y)return{limitHit:!1,results:[]};const k=new R.$Bc;await(async(W,P,C)=>{await Promise.all(W.map(async J=>await Promise.all(J.filenamePatterns.map(ae=>{const fe={_reason:C._reason,folderQueries:C.folderQueries,includePattern:C.includePattern,excludePattern:C.excludePattern,maxResults:C.maxResults,type:1,filePattern:ae};return this.t.doInternalFileSearchWithCustomCallback(fe,P,be=>{be.forEach(ye=>{k.has(ye)||L.some(ve=>J.isFromSettings&&!ve.isFromSettings?!1:ve.filenamePatterns.some(ee=>(0,s.$8cb)(ee,ye)))||k.add(ye)})})}))))})(S,v,f);const O=new R.$Ac;let K=!1;const j=Array.from(k).map(async W=>{const P=[];try{if(v.isCancellationRequested)return;if(f.maxResults&&[...O.values()].reduce((fe,be)=>fe+be.cellResults.length,0)>f.maxResults){K=!0;return}const C=[],J=this.g.get(W);if(J)J.apiNotebook.getCells().forEach(be=>C.push({input:be.document.getText(),outputs:be.outputs.flatMap(ye=>ye.items.map(he=>he.data.toString()))}));else{const fe=await this.s.value.readFile(W),be=T.$ge.fromString(fe.toString()),ye=await y.deserializeNotebook(be.buffer,v);if(v.isCancellationRequested)return;b.NotebookData.from(ye).cells.forEach(ve=>C.push({input:ve.source,outputs:ve.outputs.flatMap(ee=>ee.items.map(ke=>ke.valueBytes.toString()))}))}if(v.isCancellationRequested)return;C.forEach((fe,be)=>{const ye=f.contentPattern.pattern,he=new h.$$Pb(fe.input,void 0,fe.outputs),ve=he.findInInputs(ye),ee=he.findInOutputs(ye),ke=ee.flatMap(se=>(0,i.$EJ)(se.matches,se.textBuffer)).map((se,_)=>(se.webviewIndex=_,se));if(ve.length>0||ee.length>0){const se={index:be,contentResults:(0,i.$EJ)(ve,he.inputTextBuffer),webviewResults:ke};P.push(se)}});const ae={resource:W,cellResults:P};O.set(W,ae);return}catch{return}});return await Promise.all(j),{limitHit:K,results:[...O.values()]}}async y(m,f){const S=await this.s.value.stat(m);if(typeof f?.mtime=="number"&&typeof f.etag=="string"&&f.etag!==A.$Sk&&typeof S.mtime=="number"&&typeof S.size=="number"&&f.mtime<S.mtime&&f.etag!==A.$Tk({mtime:f.mtime,size:S.size}))throw new A.$Ik((0,E.localize)(1,null),3,f)}z(m){return m.scheme===c.Schemas.file?m.fsPath:m.toString()}A(m,f,S){if(this.h.has(f))throw new Error(`editor with id ALREADY EXSIST: ${f}`);const L=new n.$zgc(f,this.d,m,S.visibleRanges.map(b.NotebookRange.to),S.selections.map(b.NotebookRange.to),typeof S.viewColumn=="number"?b.ViewColumn.to(S.viewColumn):void 0);this.h.set(f,L)}$acceptDocumentAndEditorsDelta(m){if(m.value.removedDocuments)for(const S of m.value.removedDocuments){const L=w.URI.revive(S),v=this.g.get(L);v&&(v.dispose(),this.g.delete(L),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(y=>y.document.uri)}),this.n.fire(v.apiNotebook));for(const y of this.h.values())y.notebookData.uri.toString()===L.toString()&&this.h.delete(y.id)}if(m.value.addedDocuments){const S=[];for(const L of m.value.addedDocuments){const v=w.URI.revive(L.uri);if(this.g.has(v))throw new Error(`adding EXISTING notebook ${v} `);const y=new t.$ygc(this.c,this.q,this.r,v,L);S.push(...L.cells.map(k=>t.$xgc.asModelAddData(y.apiNotebook,k))),this.g.get(v)?.dispose(),this.g.set(v,y),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:S}),this.m.fire(y.apiNotebook)}}if(m.value.addedEditors)for(const S of m.value.addedEditors){if(this.h.has(S.id))return;const L=w.URI.revive(S.documentUri),v=this.g.get(L);v&&this.A(v,S.id,S)}const f=[];if(m.value.removedEditors)for(const S of m.value.removedEditors){const L=this.h.get(S);L&&(this.h.delete(S),this.k?.id===L.id&&(this.k=void 0),f.push(L))}if(m.value.visibleEditors){this.l=m.value.visibleEditors.map(L=>this.h.get(L)).filter(L=>!!L);const S=new Set;this.l.forEach(L=>S.add(L.id));for(const L of this.h.values()){const v=S.has(L.id);L._acceptVisibility(v)}this.l=[...this.h.values()].map(L=>L).filter(L=>L.visible),this.o.fire(this.visibleNotebookEditors)}m.value.newActiveEditor===null?this.k=void 0:m.value.newActiveEditor&&(this.h.get(m.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${m.value.newActiveEditor}`),this.k=this.h.get(m.value.newActiveEditor)),m.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(m){const f=p.$gN.String.with("notebookType","A notebook type"),S=new p.$iN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[f,new p.$gN("data","Bytes to convert to data",v=>v instanceof Uint8Array,v=>T.$ge.wrap(v))],new p.$hN("Notebook Data",v=>b.NotebookData.to(v.value))),L=new p.$iN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[f,new p.$gN("NotebookData","Notebook data to convert to bytes",v=>!0,v=>new o.$Gv(b.NotebookData.from(v)))],new p.$hN("Bytes",v=>v.buffer));m.registerApiCommand(S),m.registerApiCommand(L)}}e.$Igc=u}),define(Ce[284],Re([1,0,19,20,40,34,25,60,44]),function(ge,e,E,T,I,F,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Agc=void 0;class w{constructor(l,p,b){this.k=l,this.l=p,this.o=b,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&F.$Jj(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&F.$Jj(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const p=this.k.folderQueries||[];return new Promise((b,r)=>{const o=t=>{this.f++,l(t)};if(this.g)return b({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(t=>{const n=t.toString(),a=E.$nc(n);this.j&&this.j(n,a)||this.v(o,{base:t,basename:a})}),Promise.all(p.map(t=>this.p(t,o))).then(t=>{b({limitHit:this.e,stats:t[0]||void 0})},t=>{r(new Error((0,I.$Ni)(t)))})})}async p(l,p){const b=new T.$3d,r=this.q(l),o=this.r(),t=new g.$uJ(this.k,l),n=!t.hasSiblingExcludeClauses();let a;try{this.h.add(b),a=$.$Od.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,b.token),h=a.elapsed(),i=$.$Od.create();return this.g&&!this.e||(c&&c.forEach(s=>{const u=E.$gc.relative(l.folder.path,s.path);if(n){const d=E.$nc(s.path);this.v(p,{base:l.folder,relativePath:u,basename:d});return}this.s(o,l.folder,u,p)}),this.g&&!this.e)?null:(this.u(o,t,p),{providerTime:h,postProcessTime:i.elapsed()})}finally{b.dispose(),this.h.delete(b)}}q(l){const p=(0,g.$tJ)(this.k.includePattern,l.includePattern),b=(0,g.$tJ)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:b,includes:p,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},p,b,r){if(b===this.a){const t=E.$nc(this.a);this.v(r,{base:p,relativePath:this.a,basename:t})}function o(t){const n=E.$nc(t),a=E.$mc(t);let c=l[a];c||(c=l[a]=[],o(a)),c.push({base:p,relativePath:t,basename:n})}o(b)}u({rootEntries:l,pathToEntries:p},b,r){const o=this,t=this.a;function n(a){const c=(0,g.$wJ)(()=>a.map(h=>h.basename));for(let h=0,i=a.length;h<i;h++){const s=a[h],{relativePath:u,basename:d}=s;if(b.matchesExcludesSync(u,d,t!==d?c:void 0))continue;const m=p[u];if(m)n(m);else{if(u===t)continue;o.v(r,s)}if(o.e)break}}n(l)}v(l,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(p))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,p,b,r){const o=this.c(l.cacheKey),t=new w(l,p,o&&o.token);let n=0;const a=c=>{n+=c.length,b(c.map(h=>this.d(h)))};return this.e(t,A.a,a,r).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:c.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new T.$3d),this.b.get(l)}d(l){return l.relativePath?{resource:R.$Eg(l.base,l.relativePath)}:{resource:l.base}}e(l,p,b,r){const o=r.onCancellationRequested(()=>{l.cancel()}),t=a=>{a&&(n.push(a),p>0&&n.length>=p&&(b(n),n=[]))};let n=[];return l.search(t).then(a=>(n.length&&b(n),o.dispose(),a),a=>(n.length&&b(n),o.dispose(),Promise.reject(a)))}}e.$Agc=A}),define(Ce[285],Re([1,0,18,246,34,95,28,12,19,25,11,16,2,94,180,41,14,47,105,281,44]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l,p,b,r,o,t,n,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vK=e.$uK=void 0;let h=class{constructor(y,k,N,O,K){this.a=y,this.b=k,this.c=N,this.d=O,this.e=K}text(y,k,N={}){y=this.f(y,N);const O=this.a.getValue(),K=k&&k.some(W=>!this.a.getValue({resource:W}).search.useRipgrep);return{...this.h(k?.map(t.$li),N),type:2,contentPattern:y,previewOptions:N.previewOptions,maxFileSize:N.maxFileSize,usePCRE2:O.search.usePCRE2||K||!1,beforeContext:N.beforeContext,afterContext:N.afterContext,userDisabledExcludesAndIgnoreFiles:N.disregardExcludeSettings&&N.disregardIgnoreFiles}}f(y,k){const N=this.a.getValue();y.isRegExp&&(y.pattern=y.pattern.replace(/\r?\n/g,"\\n"));const O={...y,wordSeparators:N.editor.wordSeparators};return this.j(y,k)&&(O.isCaseSensitive=!0),this.k(y)&&(O.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),O}file(y,k={}){return{...this.h(y,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey}}g(y,k){return y?(y=Array.isArray(y)?y.map(m):m(y),k?this.parseSearchPaths(y):{pattern:s(...Array.isArray(y)?y:[y])}):{}}h(y=[],k={}){const N=this.g(k.includePattern,k.expandPatterns),O=this.g(k.excludePattern,k.expandPatterns),K=y.length>1,j=(N.searchPaths&&N.searchPaths.length?N.searchPaths.map(C=>this.q(C,k,O)):y.map(C=>this.r(C,k,O,K))).filter(C=>!!C),W={_reason:k._reason,folderQueries:j,usingSearchPaths:!!(N.searchPaths&&N.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:O.pattern,includePattern:N.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const C=E.$Hb(E.$Rb(this.c.groups.map(fe=>fe.editors.map(be=>be.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(C));const J=C.filter(fe=>(0,c.$kJ)(W,fe.fsPath)),ae=this.i(J);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ae)),{...W,...ae}}const P=k.extraFileResources&&k.extraFileResources.filter(C=>(0,c.$kJ)(W,C.fsPath));return W.extraFileResources=P&&P.length?P:void 0,W}i(y){const k=[],N=new R.$Ac,O={};let K=!1;return y.forEach(j=>{if(j.scheme===$.Schemas.walkThrough)return;if((0,w.$Ig)(j)){const P=this.b.getWorkspaceFolder(j)?.uri??j.with({path:g.$mc(j.fsPath)});let C=N.get(P);C||(K=!0,C={folder:P,includePattern:{}},k.push(C),N.set(P,C));const J=g.$lc(P.fsPath,j.fsPath);(0,D.$Qf)(C.includePattern)[J.replace(/\\/g,"/")]=!0}else j.fsPath&&(K=!0,O[j.fsPath]=!0)}),{folderQueries:k,includePattern:O,usingSearchPaths:!0,excludePattern:K?void 0:{"**/*":!0}}}j(y,k){if(k.isSmartCase){if(y.isRegExp){if(A.$wf(y.pattern,!0))return!0}else if(A.$wf(y.pattern))return!0}return!!y.isCaseSensitive}k(y){return y.isMultiline||y.isRegExp&&(0,p.$PB)(y.pattern)||y.pattern.indexOf(`
`)>=0?!0:!!y.isMultiline}parseSearchPaths(y){const k=ae=>g.$ic(ae)||/^\.\.?([\/\\]|$)/.test(ae),O=(Array.isArray(y)?y:u(y)).map(ae=>{const fe=this.e.resolvedUserHome;return fe?(0,F.$Lv)(ae,fe.scheme===$.Schemas.file?fe.fsPath:fe.path):ae}),K=T.$K(O,ae=>k(ae)?"searchPaths":"exprSegments"),j=(K.exprSegments||[]).map(ae=>A.$Re(ae,"/")).map(ae=>A.$Re(ae,"\\")).map(ae=>(ae[0]==="."&&(ae="*"+ae),d(ae))),W={},P=this.m(K.searchPaths||[]);P&&P.length&&(W.searchPaths=P);const C=E.$Rb(j),J=s(...C);return J&&(W.pattern=J),W}l(y,k){return k.disregardExcludeSettings?void 0:(0,c.$jJ)(y,!k.disregardSearchExcludeSettings)}m(y){if(!y||!y.length)return[];const k=y.flatMap(O=>{let{pathPortion:K,globPortion:j}=i(O);return j&&(j=f(j)),this.n(K).flatMap(P=>this.o(P,j))}),N=new Map;return k.forEach(O=>{const K=O.searchPath.toString(),j=N.get(K);j?O.pattern&&(j.pattern=j.pattern||{},j.pattern[O.pattern]=!0):N.set(K,{searchPath:O.searchPath,pattern:O.pattern?s(O.pattern):void 0})}),Array.from(N.values())}n(y){if(g.$ic(y)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==$.Schemas.file?[{searchPath:k[0].uri.with({path:y})}]:[{searchPath:l.URI.file(g.$hc(y))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(y=m(y),y.startsWith("../")||y===".."){const O=g.$gc.resolve(k.path,y);return[{searchPath:k.with({path:O})}]}const N=f(y);return[{searchPath:k,pattern:N}]}else{if(y==="./"||y===".\\")return[];{const k=y.replace(/^\.[\/\\]/,""),O=this.b.getWorkspace().folders.map(K=>{const j=k.match(new RegExp(`^${A.$Le(K.name)}(?:/(.*)|$)`));return j?{match:j,folder:K}:null}).filter(D.$Nf);if(O.length)return O.map(K=>{const j=K.match[1];return{searchPath:K.folder.uri,pattern:j&&f(j)}});{const K=y.match(/\.[\/\\](.+)[\/\\]?/),j=K?K[1]:y,W=b.localize(0,null,j);throw new Error(W)}}}}o(y,k){const N=y.pattern&&k?`${y.pattern}/${k}`:y.pattern||k,O=[{searchPath:y.searchPath,pattern:N}];return N&&!N.endsWith("**")&&O.push({searchPath:y.searchPath,pattern:N+"/**"}),O}q(y,k,N){const O=this.r((0,t.$li)(y.searchPath),k,N,!1);return O?{...O,includePattern:y.pattern}:null}r(y,k,N,O){let K;const j=l.URI.isUri(y)?y:y.uri;if(N.searchPaths){const ae=N.searchPaths.filter(fe=>(0,w.$xg)(fe.searchPath,j))[0];if(ae&&!ae.pattern)return null;ae&&(K=ae.pattern)}const W=this.a.getValue({resource:j}),C={...this.l(W,k)||{},...K||{}},J=l.URI.isUri(y)?(0,w.$Bg)(y):y.name;return{folder:j,folderName:O?J:void 0,excludePattern:Object.keys(C).length>0?C:void 0,fileEncoding:W.files&&W.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!W.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!W.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!W.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!W.search.followSymlinks}}};e.$uK=h,e.$uK=h=Ge([Ke(0,r.$wi),Ke(1,t.$_h),Ke(2,n.$UC),Ke(3,o.$kj),Ke(4,a.$sK)],h);function i(v){const y=v.match(/[\*\{\}\(\)\[\]\?]/);if(y){const k=y.index,N=v.substr(0,k).match(/[/|\\][^/\\]*$/);if(N){let O=v.substr(0,N.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:v.substr((N.index||0)+1)}}}return{pathPortion:v}}function s(...v){return v.length?v.reduce((y,k)=>(y[k]=!0,y),Object.create(null)):void 0}function u(v){return I.$Hj(v,",").map(y=>y.trim()).filter(y=>!!y.length)}function d(v){return[`**/${v}/**`,`**/${v}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function m(v){return v.replace(/\\/g,"/")}function f(v){return m(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(v){return v.replace(/([?*[\]])/g,"[$1]")}function L(v,y){v=E.$Mb(v,O=>O.toString());const k=[],N=y.getWorkspace();return v&&v.forEach(O=>{let K;if(y.getWorkbenchState()===2)K=(0,w.$Gg)(N.folders[0].uri,O),K&&K!=="."&&(K="./"+K);else{const j=y.getWorkspaceFolder(O);if(j){const W=j.name;if(N.folders.filter(C=>C.name===W).length===1){const C=(0,w.$Gg)(j.uri,O);C===""?K=`./${j.name}`:K=`./${j.name}/${C}`}else K=O.fsPath}}K&&k.push(S(K))}),k}e.$vK=L}),define(Ce[286],Re([1,0,25,2,20,15,4,285,44,47]),function(ge,e,E,T,I,F,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gsb=e.$fsb=void 0;const A=7e3;function D(r,o){const t=o.activationEvents;if(!t)return Promise.resolve(void 0);const n=[],a=[];for(const d of t)if(/^workspaceContains:/.test(d)){const m=d.substr(18);m.indexOf("*")>=0||m.indexOf("?")>=0||r.forceUsingSearch?a.push(m):n.push(m)}if(n.length===0&&a.length===0)return Promise.resolve(void 0);let c;const h=new Promise((d,m)=>{c=d}),i=d=>c({activationEvent:d}),s=Promise.all(n.map(d=>l(r,d,i))).then(()=>{}),u=p(r,o.identifier,a,i);return Promise.all([s,u]).then(()=>{c(void 0)}),h}e.$fsb=D;async function l(r,o,t){for(const n of r.folders)if(await r.exists(E.$Eg(T.URI.revive(n),o))){t(`workspaceContains:${o}`);return}}async function p(r,o,t,n){if(t.length===0)return Promise.resolve(void 0);const a=new I.$3d,c=r.checkExists(r.folders,t,a.token),h=setTimeout(async()=>{a.cancel(),r.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${t.join(",")}`)},A);let i=!1;try{i=await c}catch(s){F.$4(s)||F.$1(s)}a.dispose(),clearTimeout(h),i&&n(`workspaceContains:${t.join(",")}`)}function b(r,o,t,n){const a=r.get(R.$2h),c=r.get(g.$bJ),i=a.createInstance($.$uK).file(o.map(s=>(0,w.$li)(T.URI.revive(s))),{_reason:"checkExists",includePattern:t,exists:!0});return c.fileSearch(i,n).then(s=>!!s.limitHit,s=>F.$4(s)?!1:Promise.reject(s))}e.$gsb=b}),define(Ce[38],Re([1,0,159,19,88,25,13,6,50,2,14,3,37,218,85,36,23,106,15,22,24,201,7,100,4,27,86,17,71,87,64,5,286,84,203,12,82,60,21,83]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l,p,b,r,o,t,n,a,c,h,i,s,u,d,m,f,S,L,v,y,k,N,O,K,j,W,P,C){"use strict";var J;Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=e.$fgc=e.$egc=e.$dgc=e.$cgc=void 0,e.$cgc=(0,u.$3h)("IHostUtils");let ae=J=class extends $.$Sc{constructor(_,V,ne,Ie,Ae,Pe,ce,ie,Q,te,me,pe){super(),this.X=pe,this.a=this.B(new y.$Sd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=V,this.g=ne,this.f=ce,this.j=Ie,this.m=Ae,this.s=Pe,this.t=Q,this.u=te,this.w=me,this.y=this.g.getProxy(D.$QK.MainThreadWorkspace),this.z=this.g.getProxy(D.$QK.MainThreadTelemetry),this.C=this.g.getProxy(D.$QK.MainThreadExtensionService),this.D=new R.$2g,this.F=new R.$2g,this.G=new R.$2g,this.H=new R.$2g,this.I=new ke(this.f.extensions.activationEvents),this.L=new t.$p7b(this.I,this.f.extensions.allExtensions);const Fe=new a.$jm(this.f.extensions.myExtensions);this.J=new t.$p7b(this.I,ve(this.L,Fe)),P.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ye(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ye(this.J)}`)),this.M=new b.$Zfc(this.g,this.s),this.N=new N.$8fc(this.g),this.O=ie,this.h=_.createChild(new S.$1h([b.$1fc,this.M],[N.$9fc,this.N])),this.P=this.B(new p.$Yfc(this.J,this.L,{onExtensionActivationError:(le,we,M)=>{this.C.$onExtensionActivationError(le,n.$3(we),M)},actualActivateExtension:async(le,we)=>{if(t.$p7b.isHostExtension(le,this.J,this.L))return await this.C.$activateExtension(le,we),new p.$Xfc;const M=this.J.getExtensionDescription(le);return this.db(M,we)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(_){n.$1(_)}}async Y(){this.O.onWillDeactivateAll();let _=[];try{_=this.J.getAllExtensionDescriptions().map(Ae=>Ae.identifier).filter(Ae=>this.isActivated(Ae)).map(Ae=>this.cb(Ae))}catch{}await Promise.all(_)}terminate(_,V=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${_}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Ie=>{this.s.error(Ie)}),this.g.dispose();const ne=this.Y();Promise.race([(0,R.$4g)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${V}`):this.s.info(`Extension host exiting with code ${V}`),this.s.flush(),this.s.dispose(),this.c.exit(V)})}isActivated(_){return this.G.isOpen()?this.P.isActivated(_):!1}async getExtension(_){const V=await this.C.$getExtension(_);return V&&{...V,identifier:new a.$im(V.identifier.value),extensionLocation:w.URI.revive(V.extensionLocation)}}Z(_,V){return this.P.activateByEvent(_,V)}$(_,V){return this.P.activateById(_,V)}activateByIdWithErrors(_,V){return this.$(_,V).then(()=>{const ne=this.P.getActivatedExtension(_);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(_=>this.J)}getExtensionExports(_){if(this.G.isOpen())return this.P.getActivatedExtension(_).exports;try{return this.P.getActivatedExtension(_).exports}catch{return null}}async ab(_){if(_.scheme===K.Schemas.file&&this.c.fsRealpath){const V=await this.c.fsRealpath(_.fsPath);return w.URI.file(V)}return _}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(_=>new ee(_))),this.Q}async bb(_){const V=g.$9h.forUris(ne=>F.$vg.ignorePathCasing(ne));return await Promise.all(_.map(async ne=>{if(this.ub(ne)){const Ie=await this.ab(ne.extensionLocation);V.set(Ie,ne)}})),V}cb(_){let V=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(_))return V;const ne=this.P.getActivatedExtension(_);if(!ne)return V;try{typeof ne.module.deactivate=="function"&&(V=Promise.resolve(ne.module.deactivate()).then(void 0,Ie=>(this.s.error(Ie),Promise.resolve(void 0))))}catch(Ie){this.s.error(`An error occurred when deactivating the extension '${_.value}':`),this.s.error(Ie)}try{(0,$.$Nc)(ne.subscriptions)}catch(Ie){this.s.error(`An error occurred when deactivating the subscriptions for extension '${_.value}':`),this.s.error(Ie)}return V}async db(_,V){return this.f.remote.isRemote?this.C.$onWillActivateExtension(_.identifier):await this.C.$onWillActivateExtension(_.identifier),this.fb(_,V).then(ne=>{const Ie=ne.activationTimes;return this.C.$onDidActivateExtension(_.identifier,Ie.codeLoadingTime,Ie.activateCallTime,Ie.activateResolvedTime,V),this.eb(_,V,"success",Ie),ne},ne=>{throw this.eb(_,V,"failure"),ne})}eb(_,V,ne,Ie){const Ae=be(_,V);this.z.$publicLog2("extensionActivationTimes",{...Ae,...Ie||{},outcome:ne})}fb(_,V){const ne=be(_,V);this.z.$publicLog2("activatePlugin",ne);const Ie=this.ub(_);if(!Ie)return Promise.resolve(new p.$Wfc(p.$Tfc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${_.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${_.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this.s.flush();const Ae=new p.$Ufc(V.startup);return Promise.all([this.vb(_,(0,F.$Eg)(_.extensionLocation,Ie),Ae),this.gb(_)]).then(Pe=>(I.mark(`code/extHost/willActivateExtension/${_.identifier.value}`),J.hb(this.s,_.identifier,Pe[0],Pe[1],Ae))).then(Pe=>(I.mark(`code/extHost/didActivateExtension/${_.identifier.value}`),Pe))}gb(_){const V=new h.$3fc(_,this.M),ne=new h.$2fc(_.identifier.value,!1,this.M),Ie=new O.$0fc(_,this.N),Ae=_.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Pe=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${_.identifier.value}`),Promise.all([V.whenReady,ne.whenReady,this.O.whenReady]).then(()=>{const ce=this;let ie,Q;const te=(0,o.$oF)(_,"ipc")?this.f.messagePorts?.get(a.$im.toKey(_.identifier)):void 0;return Object.freeze({globalState:V,workspaceState:ne,secrets:Ie,subscriptions:[],get extensionUri(){return _.extensionLocation},get extensionPath(){return _.extensionLocation.fsPath},asAbsolutePath(me){return T.$jc(_.extensionLocation.fsPath,me)},get storagePath(){return ce.O.workspaceValue(_)?.fsPath},get globalStoragePath(){return ce.O.globalValue(_).fsPath},get logPath(){return T.$jc(ce.f.logsLocation.fsPath,_.identifier.value)},get logUri(){return w.URI.joinPath(ce.f.logsLocation,_.identifier.value)},get storageUri(){return ce.O.workspaceValue(_)},get globalStorageUri(){return ce.O.globalValue(_)},get extensionMode(){return Ae},get extension(){return ie===void 0&&(ie=new he(ce,_.identifier,_,Pe,!1)),ie},get extensionRuntime(){return(0,o.$pF)(_,"extensionRuntime"),ce.extensionRuntime},get environmentVariableCollection(){return ce.u.getEnvironmentVariableCollection(_)},get messagePassingProtocol(){if(!Q){if(!te)return;const me=y.Event.buffer(y.Event.fromDOMEventEmitter(te,"message",pe=>pe.data));te.start(),Q={onDidReceiveMessage:me,postMessage:te.postMessage.bind(te)}}return Q}})})}static hb(_,V,ne,Ie,Ae){return ne=ne||{activate:void 0,deactivate:void 0},this.ib(_,V,ne,Ie,Ae).then(Pe=>new p.$Vfc(!1,null,Ae.build(),ne,Pe,Ie.subscriptions))}static ib(_,V,ne,Ie,Ae){if(typeof ne.activate=="function")try{Ae.activateCallStart(),_.trace(`ExtensionService#_callActivateOptional ${V.value}`);const Pe=typeof global=="object"?global:self,ce=ne.activate.apply(Pe,[Ie]);return Ae.activateCallStop(),Ae.activateResolveStart(),Promise.resolve(ce).then(ie=>(Ae.activateResolveStop(),ie))}catch(Pe){return Promise.reject(Pe)}else return Promise.resolve(ne)}jb(_,V){this.$(_.identifier,{startup:!1,extensionId:_.identifier,activationEvent:V}).then(void 0,ne=>{this.s.error(ne)})}kb(_,V=0){const Ie=Date.now();(0,P.$B)(()=>{for(let Ae=V;Ae<_.length;Ae+=1){const Pe=_[Ae];for(const ce of Pe.activationEvents??[])if(ce==="onStartupFinished")if(Date.now()-Ie>50){this.kb(_,Ae);break}else this.jb(Pe,ce)}})}lb(){this.C.$setPerformanceMarks(I.getMarks()),this.m.getConfigProvider().then(_=>{const V=_.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(V)this.kb(ne);else for(const Ie of ne)if(Ie.activationEvents)for(const Ae of Ie.activationEvents)Ae==="onStartupFinished"&&this.jb(Ie,Ae)})}mb(){const _=this.Z("*",!0).then(void 0,Pe=>{this.s.error(Pe)});this.B(this.j.onDidChangeWorkspace(Pe=>this.nb(Pe.added)));const V=this.j.workspace?this.j.workspace.folders:[],ne=this.nb(V),Ie=this.pb(),Ae=Promise.all([Ie,_,ne]).then(()=>{});return Promise.race([Ae,(0,R.$4g)(1e4)]).then(()=>{this.lb()}),Ae}nb(_){return _.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(V=>this.ob(_,V))).then(()=>{})}async ob(_,V){if(this.isActivated(V.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,Ie={logService:this.s,folders:_.map(Pe=>Pe.uri),forceUsingSearch:ne||!this.c.fsExists,exists:Pe=>this.c.fsExists(Pe.fsPath),checkExists:(Pe,ce,ie)=>this.y.$checkExists(Pe,ce,ie)},Ae=await(0,k.$fsb)(Ie,V);if(Ae)return this.$(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:Ae.activationEvent}).then(void 0,Pe=>this.s.error(Pe))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(_){throw console.error(_),_}}async qb(){const{extensionDevelopmentLocationURI:_,extensionTestsLocationURI:V}=this.f.environment;if(!_||!V)throw new Error(E.localize(0,null));const ne=await this.vb(null,V,new p.$Ufc(!1));if(!ne||typeof ne.run!="function")throw new Error(E.localize(1,null,V.toString()));return new Promise((Ie,Ae)=>{const Pe=(Q,te)=>{Q?(P.$t&&this.s.error("Test runner called back with error",Q),Ae(Q)):(P.$t&&(te?this.s.info(`Test runner called back with ${te} failures.`):this.s.info("Test runner called back with successful outcome.")),Ie(typeof te=="number"&&te>0?1:0))},ce=(0,F.$sg)(V),ie=ne.run(ce,Pe);ie&&ie.then&&ie.then(()=>{P.$t&&this.s.info("Test runner finished successfully."),Ie(0)}).catch(Q=>{P.$t&&this.s.error("Test runner finished with error",Q),Ae(Q instanceof Error&&Q.stack?Q.stack:String(Q))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$4g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(_,V){return this.R[_]=V,(0,$.$Qc)(()=>{delete this.R[_]})}async getRemoteExecServer(_){const{resolver:V}=await this.sb(_);return V?.resolveExecServer?.(_,{resolveAttempt:0})}async sb(_){const V=_.indexOf("+");if(V===-1)throw new i.$YK("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=_.substr(0,V);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.R[ne]}}async $resolveAuthority(_,V){const ne=W.$Od.create(!1),Ie=()=>`[resolveAuthority(${(0,s.$9k)(_)},${V})][${ne.elapsed()}ms] `,Ae=H=>this.s.info(`${Ie()}${H}`),Pe=H=>this.s.warn(`${Ie()}${H}`),ce=(H,U=void 0)=>this.s.error(`${Ie()}${H}`,U),ie=H=>{if(H instanceof i.$YK)return{type:"error",error:{code:H._code,message:H._message,detail:H._detail}};throw H},Q=async H=>{Ae(`activating resolver for ${H}...`);const{resolver:U,authorityPrefix:Z}=await this.sb(H);if(!U)throw ce(`no resolver for ${Z}`),new i.$YK(`No remote extension installed to resolve ${Z}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:U,authorityPrefix:Z,remoteAuthority:H}},te=_.split(/@|%40/g).reverse();Ae(`activating remote resolvers ${te.join(" -> ")}`);let me;try{me=await Promise.all(te.map(Q)).catch(async H=>{if(!(H instanceof i.$YK)||H._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw H;return Pe(`resolving nested authorities failed: ${H.message}`),[await Q(_)]})}catch(H){return ie(H)}const pe=new R.$bh;pe.cancelAndSet(()=>Ae("waiting..."),1e3);let Fe,le;for(const[H,{authorityPrefix:U,resolver:Z,remoteAuthority:Y}]of me.entries())try{if(H===me.length-1)Ae("invoking final resolve()..."),I.mark(`code/extHost/willResolveAuthority/${U}`),Fe=await Z.resolve(Y,{resolveAttempt:V,execServer:le}),I.mark(`code/extHost/didResolveAuthorityOK/${U}`),Ae("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Z,i.$XK.isManagedResolvedAuthority(Fe)?Fe:void 0));else{if(Ae(`invoking resolveExecServer() for ${Y}`),I.mark(`code/extHost/willResolveExecServer/${U}`),le=await Z.resolveExecServer?.(Y,{resolveAttempt:V,execServer:le}),!le)throw new i.$YK(`Exec server was not available for ${Y}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);I.mark(`code/extHost/didResolveExecServerOK/${U}`)}}catch(Ee){return I.mark(`code/extHost/didResolveAuthorityError/${U}`),ce("returned an error",Ee),pe.dispose(),ie(Ee)}pe.dispose();const we={environmentTunnels:Fe.environmentTunnels,features:Fe.tunnelFeatures},M={extensionHostEnv:Fe.extensionHostEnv,isTrusted:Fe.isTrusted,authenticationSession:Fe.authenticationSessionForInitializingExtensions?{id:Fe.authenticationSessionForInitializingExtensions.id,providerId:Fe.authenticationSessionForInitializingExtensions.providerId}:void 0};Ae(`returned ${i.$XK.isManagedResolvedAuthority(Fe)?"managed authority":`${Fe.host}:${Fe.port}`}`);let q;if(i.$XK.isManagedResolvedAuthority(Fe)){const H=V;this.X.setFactory(H,Fe.makeConnection),q={authority:_,connectTo:new s.$6k(H),connectionToken:Fe.connectionToken}}else q={authority:_,connectTo:new s.$7k(Fe.host,Fe.port),connectionToken:Fe.connectionToken};return{type:"ok",value:{authority:q,options:M,tunnelInformation:we}}}async $getCanonicalURI(_,V){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$9k)(_)})`);const{resolver:ne}=await this.sb(_);if(!ne)return null;const Ie=w.URI.revive(V);if(typeof ne.getCanonicalURI>"u")return Ie;const Ae=await(0,R.$Vg)(()=>ne.getCanonicalURI(Ie));return Ae||Ie}$startExtensionHost(_){_.toAdd.forEach(Ie=>Ie.extensionLocation=w.URI.revive(Ie.extensionLocation));const{globalRegistry:V,myExtensions:ne}=fe(this.I,this.L,this.J,_);return this.L.set(V.getAllExtensionDescriptions()),this.J.set(ne),P.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ye(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ye(this.J)}`)),this.rb()}$activateByEvent(_,V){return V===1?this.D.wait().then(ne=>this.Z(_,!1)):this.G.wait().then(ne=>this.Z(_,!1))}async $activate(_,V){return await this.G.wait(),this.J.getExtensionDescription(_)?(await this.$(_,V),!0):!1}async $deltaExtensions(_){_.toAdd.forEach(Pe=>Pe.extensionLocation=w.URI.revive(Pe.extensionLocation));const{globalRegistry:V,myExtensions:ne}=fe(this.I,this.L,this.J,_),Ie=await this.bb(ne);return(await this.getExtensionPathIndex()).setSearchTree(Ie),this.L.set(V.getAllExtensionDescriptions()),this.J.set(ne),P.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ye(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ye(this.J)}`)),Promise.resolve(void 0)}async $test_latency(_){return _}async $test_up(_){return _.byteLength}async $test_down(_){const V=c.$ge.alloc(_),ne=Math.random()%256;for(let Ie=0;Ie<_;Ie++)V.writeUInt8(ne,Ie);return V}async $updateRemoteConnectionData(_){this.W=_,this.a.fire()}};e.$dgc=ae,e.$dgc=ae=J=Ge([Ke(0,u.$2h),Ke(1,e.$cgc),Ke(2,f.$UM),Ke(3,r.$Cfc),Ke(4,l.$Ffc),Ke(5,A.$kj),Ke(6,d.$$M),Ke(7,m.$Ifc),Ke(8,L.$cyb),Ke(9,v.$4fc),Ke(10,j.$_fc),Ke(11,C.$agc)],ae);function fe(se,_,V,ne){se.addActivationEvents(ne.addActivationEvents);const Ie=new t.$p7b(se,_.getAllExtensionDescriptions());Ie.deltaExtensions(ne.toAdd,ne.toRemove);const Ae=new a.$jm(V.getAllExtensionDescriptions().map(ce=>ce.identifier));for(const ce of ne.myToRemove)Ae.delete(ce);for(const ce of ne.myToAdd)Ae.add(ce);const Pe=ve(Ie,Ae);return{globalRegistry:Ie,myExtensions:Pe}}function be(se,_){return{id:se.identifier.value,name:se.name,extensionVersion:se.version,publisherDisplayName:se.publisher,activationEvents:se.activationEvents?se.activationEvents.join(","):null,isBuiltin:se.isBuiltin,reason:_.activationEvent,reasonId:_.extensionId.value}}function ye(se){return se.getAllExtensionDescriptions().map(_=>_.identifier.value).join(",")}e.$egc=(0,u.$3h)("IExtHostExtensionService");class he{#e;#t;#i;constructor(_,V,ne,Ie,Ae){this.#e=_,this.#t=V,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=T.$hc((0,F.$sg)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=Ie,this.isFromDifferentExtensionHost=Ae}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$fgc=he;function ve(se,_){return se.getAllExtensionDescriptions().filter(V=>_.has(V.identifier))}class ee{constructor(_){this.a=_}setSearchTree(_){this.a=_}findSubstr(_){return this.a.findSubstr(_)}forEach(_){return this.a.forEach(_)}}e.$ggc=ee;class ke{constructor(_){this.a=new a.$km,this.addActivationEvents(_)}readActivationEvents(_){return this.a.get(_.identifier)??[]}addActivationEvents(_){for(const V of Object.keys(_))this.a.set(V,_[V])}}}),define(Ce[287],Re([1,0,88,2,3,37,23,22,17,27,4,38,14,11]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l,p){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$ohc=void 0;let r=class{constructor(c,h,i,s,u,d,m){this.c=c,this.d=h,this.e=i,this.f=s,this.g=u,this.h=d,this.i=m,this.a=new Map,this.b=[]}async install(){this.j(),E.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new t(this.c,h,this.d,c,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,h,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const h of c.nodeModuleName)this.a.set(h,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(h=>c.alternativeModuleName(h))}};e.$ohc=r,e.$ohc=r=Ge([Ke(2,A.$2h),Ke(3,F.$Ffc),Ke(4,D.$egc),Ke(5,w.$$M),Ke(6,l.$kj)],r);let o=class{static{b=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&b.a.size){const h=(0,p.$Le)(this.c(c.environment.appRoot.fsPath)),i="[a-z0-9_.-]",s=`@${i}+\\/${i}+|${i}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${u}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const h=this.b.exec(this.c(c));if(!h)return;const[,i,s,u]=h,d=b.a.get(s);if(d!==void 0)return console.warn(`${s} as been renamed to ${d}, please update your imports`),i+d+u}c(c){return c.replace(/\\/g,"/")}};o=b=Ge([Ke(0,w.$$M)],o);class t{constructor(c,h,i,s,u){this.c=c,this.d=h,this.e=i,this.f=s,this.g=u,this.nodeModuleName="vscode",this.a=new $.$km}load(c,h){const i=this.d.findSubstr(h);if(i){let s=this.a.get(i.identifier);return s||(s=this.c(i,this.e,this.f),this.a.set(i.identifier,s)),s}if(!this.b){let s="";this.d.forEach((u,d)=>s+=`	${d} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${s}`),this.b=this.c(R.$jF,this.e,this.f)}return this.b}}let n=class{constructor(c,h,i){this.e=c,this.f=h,this.nodeModuleName=["open","opn"],this.d=i.getProxy(I.$QK.MainThreadTelemetry);const s=i.getProxy(I.$QK.MainThreadWindow);this.c=(u,d)=>{const m=T.URI.parse(u);return d?this.g(u,d):m.scheme==="http"||m.scheme==="https"?s.$openUri(m,u,{allowTunneling:!0}):m.scheme==="mailto"||m.scheme===this.f?s.$openUri(m,u,{}):this.g(u,d)}}load(c,h,i){const s=this.e.findSubstr(h);return s&&(this.a=s.identifier.value,this.h()),this.b=i(c),this.c}g(c,h){return this.i(),this.b(c,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Ge([Ke(2,g.$UM)],n)}),define(Ce[116],Re([1,0,39,6,19,74,4,61,62,38,7,36,215,37]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=e.$hgc=void 0,e.$hgc=(0,R.$3h)("IExtHostVariableResolverProvider");class b extends l.$VN{constructor(t,n,a,c,h,i,s){function u(){if(a){const d=a.activeEditor();if(d)return d.document.uri;const m=c.tabGroups.all.find(f=>f.isActive)?.activeTab;if(m!==void 0){if(m.input instanceof A.$zM||m.input instanceof A.$EM)return m.input.modified;if(m.input instanceof A.$yM||m.input instanceof A.$DM||m.input instanceof A.$BM)return m.input.uri}}}super({getFolderUri:d=>{const m=i.folders.filter(f=>f.name===d);if(m&&m.length>0)return m[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(d,m)=>h.getConfiguration(void 0,d).get(m),getAppRoot:()=>F.cwd(),getExecPath:()=>F.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=u();if(d)return I.$hc(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const d=u();if(d){const m=n.getWorkspaceFolder(d);if(m)return I.$hc(m.uri.fsPath)}}},getSelectedText:()=>{if(a){const d=a.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(a){const d=a.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>t.getExtension(d)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(F.env))}}let r=class extends T.$Sc{constructor(t,n,a,c,h){super(),this.b=t,this.c=n,this.g=a,this.h=c,this.j=h,this.a=new E.$V(async()=>{const i=await this.h.getConfigProvider(),u={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{u.folders=await this.c.getWorkspaceFolders2()||[]})),new b(this.b,this.c,this.g,this.j,i,u,this.m())})}getResolver(){return this.a.value}m(){}};e.$igc=r,e.$igc=r=Ge([Ke(0,w.$egc),Ke(1,D.$Cfc),Ke(2,$.$6M),Ke(3,p.$Ffc),Ke(4,g.$Rfc)],r)}),define(Ce[117],Re([1,0,13,5,2,4,3,62,38,17,7,36,207,209,37,116]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l,p,b,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=e.$mgc=e.$lgc=e.$kgc=e.$jgc=void 0,e.$jgc=(0,F.$3h)("IExtHostDebugService");let o=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,u,d,m,f,S){this.E=u,this.F=d,this.G=m,this.H=f,this.I=S,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$Sd,this.n=new T.$Sd,this.o=new T.$Sd,this.u=new T.$Sd,this.k=s.getProxy(R.$QK.MainThreadDebugService),this.y=new T.$Sd,this.A=new T.$Sd,this.v=new n(this.k),this.w=new Map,this.F.getExtensionRegistry().then(L=>{L.onDidChange(v=>{this.J(L)}),this.J(L)})}asDebugSourceUri(s,u){const d=s;if(typeof d.sourceReference=="number"&&d.sourceReference>0){let m=`debug:${encodeURIComponent(d.path||"")}`,f="?";return u&&(m+=`${f}session=${encodeURIComponent(u.id)}`,f="&"),m+=`${f}ref=${d.sourceReference}`,I.URI.parse(m)}else{if(d.path)return I.URI.file(d.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const u=[];for(const d of s.getAllExtensionDescriptions())if(d.contributes){const m=d.contributes.debuggers;if(m&&m.length>0)for(const f of m)(0,p.$1F)(f)&&u.push(f.type)}this.k.$registerDebugTypes(u)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(u=>s.push(u)),s}addBreakpoints(s){const u=s.filter(f=>{const S=f.id;return this.w.has(S)?!1:(this.w.set(S,f),!0)});this.U(u,[],[]);const d=[],m=new Map;for(const f of u)if(f instanceof A.$SL){let S=m.get(f.location.uri.toString());S||(S={type:"sourceMulti",uri:f.location.uri,lines:[]},m.set(f.location.uri.toString(),S),d.push(S)),S.lines.push({id:f.id,enabled:f.enabled,condition:f.condition,hitCondition:f.hitCondition,logMessage:f.logMessage,line:f.location.range.start.line,character:f.location.range.start.character})}else f instanceof A.$TL&&d.push({type:"function",id:f.id,enabled:f.enabled,hitCondition:f.hitCondition,logMessage:f.logMessage,condition:f.condition,functionName:f.functionName});return this.k.$registerBreakpoints(d)}removeBreakpoints(s){const u=s.filter(S=>this.w.delete(S.id));this.U([],u,[]);const d=u.filter(S=>S instanceof A.$SL).map(S=>S.id),m=u.filter(S=>S instanceof A.$TL).map(S=>S.id),f=u.filter(S=>S instanceof A.$UL).map(S=>S.id);return this.k.$unregisterBreakpoints(d,m,f)}startDebugging(s,u,d){return this.k.$startDebugging(s?s.uri:void 0,u,{parentSessionID:d.parentSession?d.parentSession.id:void 0,lifecycleManagedByParent:d.lifecycleManagedByParent,repl:d.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:d.noDebug,compact:d.compact,suppressSaveBeforeStart:d.suppressSaveBeforeStart,suppressDebugStatusbar:d.suppressDebugStatusbar??d.debugUI?.simple,suppressDebugToolbar:d.suppressDebugToolbar??d.debugUI?.simple,suppressDebugView:d.suppressDebugView??d.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,u,d){if(!u)return new A.$SK(()=>{});const m=this.d++;return this.f.push({type:s,handle:m,provider:u}),this.k.$registerDebugConfigurationProvider(s,d,!!u.provideDebugConfigurations,!!u.resolveDebugConfiguration,!!u.resolveDebugConfigurationWithSubstitutedVariables,m),new A.$SK(()=>{this.f=this.f.filter(f=>f.provider!==u),this.k.$unregisterDebugConfigurationProvider(m)})}registerDebugAdapterDescriptorFactory(s,u,d){if(!d)return new A.$SK(()=>{});if(!this.Q(s,u))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${u}' debugger.`);if(this.N(u))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const m=this.g++;return this.h.push({type:u,handle:m,factory:d}),this.k.$registerDebugAdapterDescriptorFactory(u,m),new A.$SK(()=>{this.h=this.h.filter(f=>f.factory!==d),this.k.$unregisterDebugAdapterDescriptorFactory(m)})}registerDebugAdapterTrackerFactory(s,u){if(!u)return new A.$SK(()=>{});const d=this.i++;return this.j.push({type:s,handle:d,factory:u}),new A.$SK(()=>{this.j=this.j.filter(m=>m.factory!==u)})}async $runInTerminal(s,u){return Promise.resolve(void 0)}async $substituteVariables(s,u){let d;const m=await this.W(s);return m&&(d={uri:m.uri,name:m.name,index:m.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(d,u)}K(s,u){if(s.type==="implementation")return new c(s.implementation)}L(){}async $startDASession(s,u){const d=this,m=await this.V(u);return this.S(this.N(m.type),m).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}' (extension might have failed to activate)`);const S=this.M(f),L=this.K(S,m);if(!L)throw new Error(`Couldn't create a debug adapter for type '${m.type}'.`);const v=L;return this.B.set(s,v),this.R(m).then(y=>(y&&this.C.set(s,y),v.onMessage(async k=>{if(k.type==="request"&&k.command==="handshake"){const N=k,O={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const K=await this.D.sign(N.arguments.value);O.body={signature:K},v.sendResponse(O)}else throw new Error("no signer")}catch(K){O.success=!1,O.message=K.message,v.sendResponse(O)}}else y&&y.onDidSendMessage&&y.onDidSendMessage(k),k=(0,p.$6F)(k,!0),d.k.$acceptDAMessage(s,k)}),v.onError(k=>{y&&y.onError&&y.onError(k),this.k.$acceptDAError(s,k.name,k.message,k.stack)}),v.onExit(k=>{y&&y.onExit&&y.onExit(k??void 0,void 0),this.k.$acceptDAExit(s,k??void 0,void 0)}),y&&y.onWillStartSession&&y.onWillStartSession(),v.startSession()))})}$sendDAMessage(s,u){u=(0,p.$5F)(u,!1);const d=this.C.get(s);d&&d.onWillReceiveMessage&&d.onWillReceiveMessage(u),this.B.get(s)?.sendMessage(u)}$stopDASession(s){const u=this.C.get(s);this.C.delete(s),u&&u.onWillStopSession&&u.onWillStopSession();const d=this.B.get(s);return this.B.delete(s),d?d.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const u=[],d=[],m=[];if(s.added)for(const f of s.added){const S=f.id;if(S&&!this.w.has(S)){let L;if(f.type==="function")L=new A.$TL(f.functionName,f.enabled,f.condition,f.hitCondition,f.logMessage);else if(f.type==="data")L=new A.$UL(f.label,f.dataId,f.canPersist,f.enabled,f.hitCondition,f.condition,f.logMessage);else{const v=I.URI.revive(f.uri);L=new A.$SL(new A.$5K(v,new A.$TK(f.line,f.character)),f.enabled,f.condition,f.hitCondition,f.logMessage)}(0,A.$QL)(L,S),this.w.set(S,L),u.push(L)}}if(s.removed)for(const f of s.removed){const S=this.w.get(f);S&&(this.w.delete(f),d.push(S))}if(s.changed){for(const f of s.changed)if(f.id){const S=this.w.get(f.id);if(S){if(S instanceof A.$TL&&f.type==="function"){const L=S;L.enabled=f.enabled,L.condition=f.condition,L.hitCondition=f.hitCondition,L.logMessage=f.logMessage,L.functionName=f.functionName}else if(S instanceof A.$SL&&f.type==="source"){const L=S;L.enabled=f.enabled,L.condition=f.condition,L.hitCondition=f.hitCondition,L.logMessage=f.logMessage,L.location=new A.$5K(I.URI.revive(f.uri),new A.$TK(f.line,f.character))}m.push(S)}}}this.U(u,d,m)}async $acceptStackFrameFocus(s){let u;const d=s.sessionId?await this.V(s.sessionId):void 0;if(!d)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?u=new A.$1L(d,s.threadId):u=new A.$ZL(d,s.threadId,s.frameId),this.z=u,this.A.fire(this.z)}$provideDebugConfigurations(s,u,d){return(0,E.$Vg)(async()=>{const m=this.P(s);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const f=await this.W(u);return m.provideDebugConfigurations(f,d)}).then(m=>{if(!m)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return m})}$resolveDebugConfiguration(s,u,d,m){return(0,E.$Vg)(async()=>{const f=this.P(s);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const S=await this.W(u);return f.resolveDebugConfiguration(S,d,m)})}$resolveDebugConfigurationWithSubstitutedVariables(s,u,d,m){return(0,E.$Vg)(async()=>{const f=this.P(s);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const S=await this.W(u);return f.resolveDebugConfigurationWithSubstitutedVariables(S,d,m)})}async $provideDebugAdapter(s,u){const d=this.O(s);if(!d)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const m=await this.V(u);return this.S(d,m).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}'`);return this.M(f)})}async $acceptDebugSessionStarted(s){const u=await this.V(s);this.m.fire(u)}async $acceptDebugSessionTerminated(s){const u=await this.V(s);u&&(this.n.fire(u),this.l.delete(u.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,u){(await this.V(s))?._acceptNameChanged(u)}async $acceptDebugSessionCustomEvent(s,u){const m={session:await this.V(s),event:u.event,body:u.body};this.u.fire(m)}M(s){if(s instanceof A.$VL)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof A.$WL)return{type:"server",port:s.port,host:s.host};if(s instanceof A.$XL)return{type:"pipeServer",path:s.path};if(s instanceof A.$YL)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const u=this.h.filter(d=>d.type===s);if(u.length>0)return u[0].factory}O(s){const u=this.h.filter(d=>d.handle===s);if(u.length>0)return u[0].factory}P(s){const u=this.f.filter(d=>d.handle===s);if(u.length>0)return u[0].provider}Q(s,u){if(s.contributes){const d=s.contributes.debuggers;if(d&&d.length>0){for(const m of d)if(m.label&&m.type&&m.type===u)return!0}}return!1}R(s){const d=s.configuration.type,m=this.j.filter(f=>f.type===d||f.type==="*").map(f=>(0,E.$Vg)(()=>f.factory.createDebugAdapterTracker(s)).then(S=>S,S=>null));return Promise.race([Promise.all(m).then(f=>{const S=f.filter(L=>!!L);if(S.length>0)return new a(S)}),new Promise(f=>setTimeout(()=>f(void 0),1e3))]).catch(f=>{})}async S(s,u){const d=u.configuration.debugServer;if(typeof d=="number")return Promise.resolve(new A.$WL(d));if(s){const f=await this.F.getExtensionRegistry();return(0,E.$Vg)(()=>s.createDebugAdapterDescriptor(u,this.T(u,f))).then(S=>{if(S)return S})}const m=await this.F.getExtensionRegistry();return Promise.resolve(this.T(u,m))}T(s,u){}U(s,u,d){(s.length>0||u.length>0||d.length>0)&&this.y.fire(Object.freeze({added:s,removed:u,changed:d}))}async V(s){if(s)if(typeof s=="string"){const u=this.l.get(s);if(u)return u}else{let u=this.l.get(s.id);if(!u){const d=await this.W(s.folderUri),m=s.parent?this.l.get(s.parent):void 0;u=new t(this.k,s.id,s.type,s.name,d,s.configuration,m),this.l.set(u.id,u),this.k.$sessionCached(u.id)}return u}throw new Error("cannot find session")}W(s){if(s){const u=I.URI.revive(s);return this.E.resolveWorkspaceFolder(u)}return Promise.resolve(void 0)}};e.$kgc=o,e.$kgc=o=Ge([Ke(0,w.$UM),Ke(1,D.$Cfc),Ke(2,g.$egc),Ke(3,b.$Ffc),Ke(4,$.$Rfc),Ke(5,r.$hgc)],o);class t{constructor(s,u,d,m,f,S,L){this.d=s,this.f=u,this.g=d,this.h=m,this.i=f,this.j=S,this.k=L}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,u){return this.d.$customDebugAdapterRequest(this.f,s,u)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$lgc=t;class n{constructor(s){this.value=Object.freeze({append(u){s.$appendDebugConsole(u)},appendLine(u){this.append(u+`
`)}})}}e.$mgc=n;class a{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(u=>u.onWillReceiveMessage?u.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(u=>u.onDidSendMessage?u.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(u=>u.onError?u.onError(s):void 0)}onExit(s,u){this.d.forEach(d=>d.onExit?d.onExit(s,u):void 0)}}class c extends l.$xlb{constructor(s){super(),this.h=s,s.onDidSendMessage(u=>{this.acceptMessage(u)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let h=class extends o{constructor(s,u,d,m,f,S){super(s,u,d,m,f,S)}};e.$ngc=h,e.$ngc=h=Ge([Ke(0,w.$UM),Ke(1,D.$Cfc),Ke(2,g.$egc),Ke(3,b.$Ffc),Ke(4,$.$Rfc),Ke(5,r.$hgc)],h)}),define(Ce[288],Re([1,0,15,88,2,3,276,14,70,71,27,185,17,57,38,59]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l,p,b,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qhc=e.$phc=void 0;class o{static async installEarlyHandler(a){Error.stackTraceLimit=100;const c=a.get($.$kj),i=a.get(l.$UM).getProxy(F.$QK.MainThreadErrors);E.setUnexpectedErrorHandler(s=>{c.error(s);const u=E.$3(s);i.$onUnexpectedError(u)})}static async installFullHandler(a){const c=a.get($.$kj),h=a.get(l.$UM),i=a.get(b.$egc),s=a.get(r.$cN),u=h.getProxy(F.$QK.MainThreadExtensionService),d=h.getProxy(F.$QK.MainThreadErrors),m=await i.getExtensionPathIndex(),f=new WeakMap;function S(y,k){if(f.has(y))return f.get(y).stack;let N="",O,K;for(const W of k)N+=`
	at ${W.toString()}`,K=W.getFileName(),!O&&K&&(O=m.findSubstr(I.URI.file(K)));const j=`${y.name||"Error"}: ${y.message||""}${N}`;return f.set(y,{extensionIdentifier:O?.identifier,stack:j}),j}const L=Symbol("prepareStackTrace wrapped");let v=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return v},set(y){if(y===S||!y||y[L]){v=y||S;return}v=function(k,N){return S(k,N),y.call(Error,k,N)},Object.assign(v,{[L]:!0})}}),E.setUnexpectedErrorHandler(y=>{c.error(y);const k=E.$3(y),N=f.get(y);if(!N?.extensionIdentifier){d.$onUnexpectedError(k);return}u.$onExtensionRuntimeError(N.extensionIdentifier,k);const O=s.onExtensionError(N.extensionIdentifier,y);c.trace("forwarded error to extension?",O,N)})}}e.$phc=o;class t{constructor(a,c,h,i,s){this.a=h,this.b=new R.$x7b(a,null,i),c=t.e(c,this.b);const u=new w.$1h(...(0,g.$Mr)());u.set(A.$$M,{_serviceBrand:void 0,...c,messagePorts:s}),u.set(l.$UM,new l.$VM(this.b)),u.set(p.$zfc,new p.$Afc(i)),u.set(b.$cgc,h);const d=new D.$sq(u,!0);d.invokeFunction(o.installEarlyHandler),this.d=d.invokeFunction(m=>m.get($.$kj)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=d.invokeFunction(m=>m.get(b.$egc)),this.c.initialize(),d.invokeFunction(o.installFullHandler)}async asBrowserUri(a){const c=this.b.getProxy(F.$QK.MainThreadExtensionService);return I.URI.revive(await c.$asBrowserUri(a))}terminate(a){this.c.terminate(a)}static e(a,c){a.extensions.allExtensions.forEach(i=>{i.extensionLocation=I.URI.revive(c.transformIncomingURIs(i.extensionLocation))}),a.environment.appRoot=I.URI.revive(c.transformIncomingURIs(a.environment.appRoot));const h=a.environment.extensionDevelopmentLocationURI;return h&&(a.environment.extensionDevelopmentLocationURI=h.map(i=>I.URI.revive(c.transformIncomingURIs(i)))),a.environment.extensionTestsLocationURI=I.URI.revive(c.transformIncomingURIs(a.environment.extensionTestsLocationURI)),a.environment.globalStorageHome=I.URI.revive(c.transformIncomingURIs(a.environment.globalStorageHome)),a.environment.workspaceStorageHome=I.URI.revive(c.transformIncomingURIs(a.environment.workspaceStorageHome)),a.environment.extensionTelemetryLogResource=I.URI.revive(c.transformIncomingURIs(a.environment.extensionTelemetryLogResource)),a.nlsBaseUrl=I.URI.revive(c.transformIncomingURIs(a.nlsBaseUrl)),a.logsLocation=I.URI.revive(c.transformIncomingURIs(a.logsLocation)),a.workspace=c.transformIncomingURIs(a.workspace),a}}e.$qhc=t}),define(Ce[289],Re([1,0,18,13,20,40,12,19,25,2,44]),function(ge,e,E,T,I,F,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=e.$Dgc=e.$Cgc=e.$Bgc=void 0;class D{constructor(n,a,c,h){this.d=n,this.e=a,this.f=c,this.g=h,this.a=null,this.b=!1,this.c=0}search(n,a){const c=this.d.folderQueries||[],h=new I.$3d(a);return new Promise((i,s)=>{this.a=new p(n);let u=!1;const d=(m,f)=>{if(!u&&!this.b){const S=this.h(m);r(m)&&typeof this.d.maxResults=="number"&&this.c+S>this.d.maxResults&&(this.b=!0,u=!0,h.cancel(),m=this.j(m,this.d.maxResults-this.c));const L=this.h(m);this.c+=L,(L>0||!r(m))&&this.a.add(m,f)}};Promise.all(c.map((m,f)=>this.k(m,S=>d(S,f),h.token))).then(m=>{h.dispose(),this.a.flush();const f=m.some(S=>!!S&&!!S.limitHit);i({limitHit:this.b||f,messages:(0,E.$Rb)(m.map(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[])),stats:{type:this.g}})},m=>{h.dispose();const f=(0,F.$Ni)(m);s(new Error(f))})})}h(n){return r(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,a){const c=Array.isArray(n.ranges)?n.ranges:[n.ranges],h=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:c.slice(0,a),preview:{matches:h.slice(0,a),text:n.preview.text},uri:n.uri}}async k(n,a,c){const h=new A.$uJ(this.d,n),i=[],s={report:m=>{if(!this.l(m))return;const f=n.folder.scheme===R.Schemas.file?(0,A.$vJ)(()=>this.f.readdir(g.$Dg(m.uri))):void 0,S=g.$Gg(n.folder,m.uri);if(S){const L=h.includedInQuery(S,$.$nc(S),f);(0,T.$Pg)(L)?i.push(L.then(v=>{v&&a(m)})):L&&a(m)}}},u=this.n(n),d=await this.e.provideTextSearchResults(l(this.d.contentPattern),u,s,c);return i.length&&await Promise.all(i),d}l(n){if(r(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const a=(0,A.$tJ)(this.d.includePattern,n.includePattern),c=(0,A.$tJ)(this.d.excludePattern,n.excludePattern),h={folder:w.URI.from(n.folder),excludes:c,includes:a,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.f.toCanonicalName(n.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return h.usePCRE2=this.d.usePCRE2,h}}e.$Bgc=D;function l(t){return{isCaseSensitive:t.isCaseSensitive||!1,isRegExp:t.isRegExp||!1,isWordMatch:t.isWordMatch||!1,isMultiline:t.isMultiline||!1,pattern:t.pattern}}class p{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new o(512,a=>this.g(a))}add(n,a){this.d&&(this.b!==a||!g.$xg(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=a,this.d={resource:n.uri,results:[]}),this.d.results.push(b(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$Cgc=p;function b(t){return r(t)?{preview:{matches:(0,E.$2b)(t.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:t.preview.text},ranges:(0,E.$2b)(t.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:t.text,lineNumber:t.lineNumber}}function r(t){return!!t.preview}e.$Dgc=r;class o{static{this.a=4e3}static{this.b=50}constructor(n,a){this.g=n,this.h=a,this.c=0,this.d=[],this.e=0}addItem(n,a){n&&this.j(n,a)}addItems(n,a){n&&this.k(n,a)}j(n,a){this.d.push(n),this.e+=a,this.l()}k(n,a){this.d=this.d.concat(n),this.e+=a,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Egc=o}),define(Ce[118],Re([1,0,6,3,4,284,17,57,14,2,289]),function(ge,e,E,T,I,F,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hgc=e.$Ggc=e.$Fgc=void 0,e.$Fgc=(0,I.$3h)("IExtHostSearch");let D=class{constructor(r,o,t){this.k=r,this.l=o,this.n=t,this.c=this.k.getProxy(T.$QK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new F.$Agc}o(r){return this.l.transformOutgoingScheme(r)}registerTextSearchProvider(r,o){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const t=this.d++;return this.e.set(t,o),this.c.$registerTextSearchProvider(t,this.o(r)),(0,E.$Qc)(()=>{this.g.delete(r),this.e.delete(t),this.c.$unregisterProvider(t)})}registerFileSearchProvider(r,o){if(this.i.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.i.add(r);const t=this.d++;return this.h.set(t,o),this.c.$registerFileSearchProvider(t,this.o(r)),(0,E.$Qc)(()=>{this.i.delete(r),this.h.delete(t),this.c.$unregisterProvider(t)})}$provideFileSearchResults(r,o,t,n){const a=l(t),c=this.h.get(r);if(c)return this.j.fileSearch(a,c,h=>{this.c.$handleFileMatch(r,o,h.map(i=>i.resource))},n);throw new Error("unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,o,t){return{messages:[]}}$clearCache(r){return this.j.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,o,t,n){const a=this.e.get(r);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${r}`);const c=l(t);return this.q(c,a).search(i=>this.c.$handleTextMatch(r,o,i),n)}$enableExtensionHostSearch(){}q(r,o){return new A.$Bgc(r,o,{readdir:t=>Promise.resolve([]),toCanonicalName:t=>t},"textSearchProvider")}};e.$Ggc=D,e.$Ggc=D=Ge([Ke(0,R.$UM),Ke(1,$.$zfc),Ke(2,g.$kj)],D);function l(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map(p),extraFileResources:b.extraFileResources&&b.extraFileResources.map(r=>w.URI.revive(r))}}e.$Hgc=l;function p(b){return{...b,folder:w.URI.revive(b.folder)}}}),define(Ce[290],Re([1,0,20,15,5,6,12,31,2,146,142,130,93,22,42,14,55,56,198,3,231,239,81,232,233,234,235,236,237,238,213,32,240,37,272,117,110,242,243,244,220,245,61,62,247,38,248,63,249,43,27,250,251,252,253,254,255,82,83,257,283,222,202,223,258,259,112,260,224,261,262,17,263,118,84,264,265,266,85,86,115,59,64,267,268,210,269,225,87,8,7,270,57,271,65,273,274,111,36,208,79,23,114]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l,p,b,r,o,t,n,a,c,h,i,s,u,d,m,f,S,L,v,y,k,N,O,K,j,W,P,C,J,ae,fe,be,ye,he,ve,ee,ke,se,_,V,ne,Ie,Ae,Pe,ce,ie,Q,te,me,pe,Fe,le,we,M,q,H,U,Z,Y,Ee,Te,We,He,Xe,st,nt,tt,at,ct,ze,vt,X,x,$e,Be,Qe,it,rt,Ne,Pt,Tt,Ht,Bt,yt,Kt,Nt,Zt,jt,Rt,Ye,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=void 0;function Jt(lt){const $t=lt.get(_.$$M),zt=lt.get(se.$hfc),Wt=lt.get(ee.$Hfc),kt=lt.get(he.$egc),dt=lt.get(Zt.$Cfc),Ct=lt.get(ze.$cN),xt=lt.get(N.$Ffc),St=lt.get(Tt.$zfc),qe=lt.get(Ee.$UM),Ft=lt.get(tt.$1fc),Vt=lt.get(at.$Ifc),Qt=lt.get(r.$lj),ft=lt.get(r.$kj),Mt=lt.get(it.$cyb),Se=lt.get(i.$kfc),Me=lt.get(Nt.$jhc),de=lt.get(He.$9fc),G=lt.get(be.$Rfc),Le=lt.get(Q.$agc);qe.set(a.$RK.ExtHostFileSystemInfo,zt),qe.set(a.$RK.ExtHostLogLevelServiceShape,Qt),qe.set(a.$RK.ExtHostWorkspace,dt),qe.set(a.$RK.ExtHostConfiguration,xt),qe.set(a.$RK.ExtHostExtensionService,kt),qe.set(a.$RK.ExtHostStorage,Ft),qe.set(a.$RK.ExtHostTunnelService,Mt),qe.set(a.$RK.ExtHostWindow,Me),qe.set(a.$RK.ExtHostSecretState,de),qe.set(a.$RK.ExtHostTelemetry,Ct),qe.set(a.$RK.ExtHostEditorTabs,G),qe.set(a.$RK.ExtHostManagedSockets,Le);const Ue=qe.set(a.$RK.ExtHostDecorations,lt.get(j.$pgc)),Ze=qe.set(a.$RK.ExtHostDocumentsAndEditors,lt.get(fe.$6M)),Ve=qe.set(a.$RK.ExtHostCommands,lt.get(y.$eN)),_e=qe.set(a.$RK.ExtHostTerminalService,lt.get(vt.$4fc)),mt=qe.set(a.$RK.ExtHostDebugService,lt.get(K.$jgc)),Ut=qe.set(a.$RK.ExtHostSearch,lt.get(We.$Fgc)),Et=qe.set(a.$RK.ExtHostTask,lt.get(ct.$9gc)),Dt=qe.set(a.$RK.ExtHostOutputService,lt.get(q.$Vgc)),wt=qe.set(a.$RK.ExtHostLocalization,lt.get(ie.$_fc)),gi=qe.set(a.$RK.ExtHostUrls,new Ht.$ghc(qe)),At=qe.set(a.$RK.ExtHostDocuments,new ae.$ffc(qe,Ze)),Di=qe.set(a.$RK.ExtHostDocumentContentProviders,new C.$rgc(qe,Ze,ft)),Hi=qe.set(a.$RK.ExtHostDocumentSaveParticipant,new J.$sgc(ft,At,qe.getProxy(a.$QK.MainThreadBulkEdits))),It=qe.set(a.$RK.ExtHostNotebook,new me.$Igc(qe,Ve,Ze,At,Wt,Ut)),ri=qe.set(a.$RK.ExtHostNotebookDocuments,new Fe.$Pgc(It)),mi=qe.set(a.$RK.ExtHostNotebookEditors,new le.$Qgc(ft,It)),ci=qe.set(a.$RK.ExtHostNotebookKernels,new we.$Rgc(qe,$t,It,Ve,ft)),Ii=qe.set(a.$RK.ExtHostNotebookRenderers,new M.$Tgc(qe,It)),Ci=qe.set(a.$RK.ExtHostNotebookDocumentSaveParticipant,new pe.$Ogc(ft,It,qe.getProxy(a.$QK.MainThreadBulkEdits))),Ot=qe.set(a.$RK.ExtHostEditors,new x.$wfc(qe,Ze)),$i=qe.set(a.$RK.ExtHostTreeViews,new Qe.$ehc(qe.getProxy(a.$QK.MainThreadTreeViews),Ve,ft)),Pi=qe.set(a.$RK.ExtHostEditorInsets,new v.$xfc(qe.getProxy(a.$QK.MainThreadEditorInsets),Ot,$t.remote)),ui=qe.set(a.$RK.ExtHostDiagnostics,new W.$jfc(qe,ft,zt,Ze)),li=qe.set(a.$RK.ExtHostLanguages,new ce.$Mgc(qe,At,Ve.converter,St)),ht=qe.set(a.$RK.ExtHostLanguageFeatures,new Pe.$nfc(qe,St,At,Ve,ui,ft,Se,Ct)),Gi=qe.set(a.$RK.ExtHostFileSystem,new ve.$ugc(qe,ht)),_t=qe.set(a.$RK.ExtHostFileSystemEventService,new ke.$vgc(qe,ft,Ze)),si=qe.set(a.$RK.ExtHostQuickOpen,(0,Y.$Zgc)(qe,dt,Ve)),pi=qe.set(a.$RK.ExtHostSCM,new Te.$2gc(qe,Ve,At,ft)),Ri=qe.set(a.$RK.ExtHostQuickDiff,new Z.$Ygc(qe,St)),Ji=qe.set(a.$RK.ExtHostShare,new Xe.$3gc(qe,St)),Ai=qe.set(a.$RK.ExtHostComments,(0,k.$yfc)(qe,Ve,At)),vi=qe.set(a.$RK.ExtHostProgress,new U.$Xgc(qe.getProxy(a.$QK.MainThreadProgress))),Qi=qe.set(a.$RK.ExtHostLabelService,new Ae.$Lgc(qe)),Li=qe.set(a.$RK.ExtHostTheming,new $e.$bhc(qe)),hi=qe.set(a.$RK.ExtHostAuthentication,new s.$pfc(qe)),Zi=qe.set(a.$RK.ExtHostTimeline,new Be.$dhc(qe,Ve)),bi=qe.set(a.$RK.ExtHostWebviews,new Bt.$Mfc(qe,$t.remote,dt,ft,Se)),Fi=qe.set(a.$RK.ExtHostWebviewPanels,new yt.$Pfc(qe,bi,dt)),cn=qe.set(a.$RK.ExtHostCustomEditors,new O.$Qfc(qe,At,Vt,bi,Fi)),Mi=qe.set(a.$RK.ExtHostWebviewViews,new Kt.$hhc(qe,bi)),oi=qe.set(a.$RK.ExtHostTesting,new X.$0gc(qe,ft,Ve,Ze)),un=qe.set(a.$RK.ExtHostUriOpeners,new Pt.$fhc(qe)),ln=qe.set(a.$RK.ExtHostProfileContentHandlers,new H.$Wgc(qe));qe.set(a.$RK.ExtHostInteractive,new ne.$Jgc(qe,It,Ze,Ve,ft));const Xi=qe.set(a.$RK.ExtHostInlineChat,new V.$wgc(qe,Ve,At,ft)),di=qe.set(a.$RK.ExtHostChatProvider,new f.$sfc(qe,ft)),Yi=qe.set(a.$RK.ExtHostChatAgents2,new m.$tfc(qe,di,ft)),xi=qe.set(a.$RK.ExtHostChatVariables,new S.$ufc(qe)),wi=qe.set(a.$RK.ExtHostChat,new d.$rfc(qe)),_i=qe.set(a.$RK.ExtHostAiRelatedInformation,new c.$efc(qe)),Ti=qe.set(a.$RK.ExtHostAiEmbeddingVector,new ye.$tgc(qe)),Ni=qe.set(a.$RK.ExtHostIssueReporter,new Ie.$Kgc(qe)),ei=qe.set(a.$RK.ExtHostStatusBar,new nt.$6gc(qe,Ve.converter)),yi=qe.set(a.$RK.ExtHostSpeech,new st.$4gc(qe)),hn=Object.values(a.$RK);qe.assertRegistered(hn);const Xt=new u.$qfc(qe,Ze),Ei=new L.$vfc(qe),ki=new te.$Ngc(qe,ft),Oi=new P.$qgc(qe);return h.$ofc.register(Ve),function(je,ti,en){function et(re){return(ue,Oe,ot)=>{const bt=re(Lt=>{try{ue.call(Oe,Lt)}catch(an){T.$2(new Error(`[ExtensionListenerError] Extension '${je.identifier.value}' FAILED to handle event`,{cause:an})),Ct.onExtensionError(je.identifier,an)}});return ot?.push(bt),bt}}const pt=function(){let re=!je.isUnderDevelopment;function ue(){re||(ft.info(`Extension '${je.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Oe(ot){if(Array.isArray(ot))ot.forEach(Oe);else if(typeof ot=="string")ue();else{const bt=ot;typeof bt.scheme>"u"&&ue(),typeof bt.exclusive=="boolean"&&(0,Ye.$pF)(je,"documentFiltersExclusive")}return ot}}(),dn={getSession(re,ue,Oe){return hi.getSession(je,re,ue,Oe)},getSessions(re,ue){return(0,Ye.$pF)(je,"authGetSessions"),hi.getSessions(je,re,ue)},async hasSession(re,ue){return(0,Ye.$pF)(je,"authSession"),!!await hi.getSession(je,re,ue,{silent:!0})},get onDidChangeSessions(){return et(hi.onDidChangeSessions)},registerAuthenticationProvider(re,ue,Oe,ot){return hi.registerAuthenticationProvider(re,ue,Oe,ot)}},fn={registerCommand(re,ue,Oe){return Ve.registerCommand(!0,re,ue,Oe,void 0,je)},registerTextEditorCommand(re,ue,Oe){return Ve.registerCommand(!0,re,(...ot)=>{const bt=Ot.getActiveTextEditor();if(!bt){ft.warn("Cannot execute "+re+" because there is no active text editor.");return}return bt.edit(Lt=>{ue.apply(Oe,[bt,Lt,...ot])}).then(Lt=>{Lt||ft.warn("Edits from command "+re+" were not applied.")},Lt=>{ft.warn("An error occurred while running command "+re,Lt)})},void 0,void 0,je)},registerDiffInformationCommand:(re,ue,Oe)=>((0,Ye.$pF)(je,"diffCommand"),Ve.registerCommand(!0,re,async(...ot)=>{const bt=Ze.activeEditor(!0);if(!bt){ft.warn("Cannot execute "+re+" because there is no active text editor.");return}const Lt=await Ot.getDiffInformation(bt.id);ue.apply(Oe,[Lt,...ot])},void 0,void 0,je)),executeCommand(re,...ue){return Ve.executeCommand(re,...ue)},getCommands(re=!1){return Ve.getCommands(re)}},ji={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return Ei.value},get shell(){return _e.getDefaultShell(!1)},get onDidChangeShell(){return et(_e.onDidChangeShell)},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return et(Ct.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ye.$pF)(je,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$pF)(je,"telemetry"),et(Ct.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ze.$bN)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(re,ue){return ze.$aN.validateSender(re),Ct.instantiateLogger(je,re,ue)},openExternal(re,ue){return Me.openUri(re,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===$t.environment.appUriScheme)return gi.createAppUri(re);try{return await Me.asExternalUri(re,{allowTunneling:!!$t.remote.authority})}catch(ue){if((0,R.$bg)(re,R.Schemas.http)||(0,R.$bg)(re,R.Schemas.https))return re;throw ue}},get remoteName(){return(0,o.$$k)($t.remote.authority)},get remoteAuthority(){return(0,Ye.$pF)(je,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return et(ft.onDidChangeLogLevel)},registerIssueUriRequestHandler(re){return(0,Ye.$pF)(je,"handleIssueUri"),Ni.registerIssueUriRequestHandler(je,re)},registerIssueDataProvider(re){return(0,Ye.$pF)(je,"handleIssueUri"),Ni.registerIssueDataProvider(je,re)},get appQuality(){return(0,Ye.$pF)(je,"resolvers"),$t.quality},get appCommit(){return(0,Ye.$pF)(je,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(ji);const zi={createTestController(re,ue,Oe){return oi.createTestController(je,re,ue,Oe)},createTestObserver(){return(0,Ye.$pF)(je,"testObserver"),oi.createTestObserver()},runTests(re){return(0,Ye.$pF)(je,"testObserver"),oi.runTests(re)},get onDidChangeTestResults(){return(0,Ye.$pF)(je,"testObserver"),et(oi.onResultsChanged)},get testResults(){return(0,Ye.$pF)(je,"testObserver"),oi.results}},fi=$t.remote.isRemote?Ne.ExtensionKind.Workspace:Ne.ExtensionKind.UI,tn={getExtension(re,ue){(0,Ye.$oF)(je,"extensionsAny")||(ue=!1);const Oe=ti.mine.getExtensionDescription(re);if(Oe)return new he.$fgc(kt,je.identifier,Oe,fi,!1);if(ue){const ot=ti.all.getExtensionDescription(re);if(ot)return new he.$fgc(kt,je.identifier,ot,fi,!0)}},get all(){const re=[];for(const ue of ti.mine.getAllExtensionDescriptions())re.push(new he.$fgc(kt,je.identifier,ue,fi,!1));return re},get allAcrossExtensionHosts(){(0,Ye.$pF)(je,"extensionsAny");const re=new p.$jm(ti.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),ue=[];for(const Oe of ti.all.getAllExtensionDescriptions()){const ot=!re.has(Oe.identifier);ue.push(new he.$fgc(kt,je.identifier,Oe,fi,ot))}return ue},get onDidChange(){return(0,Ye.$oF)(je,"extensionsAny")?et(I.Event.any(ti.mine.onDidChange,ti.all.onDidChange)):et(ti.mine.onDidChange)}},nn={createDiagnosticCollection(re){return ui.createDiagnosticCollection(je.identifier,re)},get onDidChangeDiagnostics(){return et(ui.onDidChangeDiagnostics)},getDiagnostics:re=>ui.getDiagnostics(re),getLanguages(){return li.getLanguages()},setTextDocumentLanguage(re,ue){return li.changeLanguage(re.uri,ue)},match(re,ue){const Oe=At.getDocumentData(ue.uri)?.notebook;return(0,A.$pt)(rt.LanguageSelector.from(re),ue.uri,ue.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(re,ue,Oe){return ht.registerCodeActionProvider(je,pt(re),ue,Oe)},registerDocumentPasteEditProvider(re,ue,Oe){return(0,Ye.$pF)(je,"documentPaste"),ht.registerDocumentPasteEditProvider(je,pt(re),ue,Oe)},registerCodeLensProvider(re,ue){return ht.registerCodeLensProvider(je,pt(re),ue)},registerDefinitionProvider(re,ue){return ht.registerDefinitionProvider(je,pt(re),ue)},registerDeclarationProvider(re,ue){return ht.registerDeclarationProvider(je,pt(re),ue)},registerImplementationProvider(re,ue){return ht.registerImplementationProvider(je,pt(re),ue)},registerTypeDefinitionProvider(re,ue){return ht.registerTypeDefinitionProvider(je,pt(re),ue)},registerHoverProvider(re,ue){return ht.registerHoverProvider(je,pt(re),ue,je.identifier)},registerEvaluatableExpressionProvider(re,ue){return ht.registerEvaluatableExpressionProvider(je,pt(re),ue,je.identifier)},registerInlineValuesProvider(re,ue){return ht.registerInlineValuesProvider(je,pt(re),ue,je.identifier)},registerDocumentHighlightProvider(re,ue){return ht.registerDocumentHighlightProvider(je,pt(re),ue)},registerMultiDocumentHighlightProvider(re,ue){return ht.registerMultiDocumentHighlightProvider(je,pt(re),ue)},registerLinkedEditingRangeProvider(re,ue){return ht.registerLinkedEditingRangeProvider(je,pt(re),ue)},registerReferenceProvider(re,ue){return ht.registerReferenceProvider(je,pt(re),ue)},registerRenameProvider(re,ue){return ht.registerRenameProvider(je,pt(re),ue)},registerDocumentSymbolProvider(re,ue,Oe){return ht.registerDocumentSymbolProvider(je,pt(re),ue,Oe)},registerWorkspaceSymbolProvider(re){return ht.registerWorkspaceSymbolProvider(je,re)},registerDocumentFormattingEditProvider(re,ue){return ht.registerDocumentFormattingEditProvider(je,pt(re),ue)},registerDocumentRangeFormattingEditProvider(re,ue){return ht.registerDocumentRangeFormattingEditProvider(je,pt(re),ue)},registerOnTypeFormattingEditProvider(re,ue,Oe,...ot){return ht.registerOnTypeFormattingEditProvider(je,pt(re),ue,[Oe].concat(ot))},registerDocumentSemanticTokensProvider(re,ue,Oe){return ht.registerDocumentSemanticTokensProvider(je,pt(re),ue,Oe)},registerDocumentRangeSemanticTokensProvider(re,ue,Oe){return ht.registerDocumentRangeSemanticTokensProvider(je,pt(re),ue,Oe)},registerSignatureHelpProvider(re,ue,Oe,...ot){return typeof Oe=="object"?ht.registerSignatureHelpProvider(je,pt(re),ue,Oe):ht.registerSignatureHelpProvider(je,pt(re),ue,typeof Oe>"u"?[]:[Oe,...ot])},registerCompletionItemProvider(re,ue,...Oe){return ht.registerCompletionItemProvider(je,pt(re),ue,Oe)},registerInlineCompletionItemProvider(re,ue,Oe){return ue.handleDidShowCompletionItem&&(0,Ye.$pF)(je,"inlineCompletionsAdditions"),ue.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$pF)(je,"inlineCompletionsAdditions"),Oe&&(0,Ye.$pF)(je,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(je,pt(re),ue,Oe)},registerDocumentLinkProvider(re,ue){return ht.registerDocumentLinkProvider(je,pt(re),ue)},registerColorProvider(re,ue){return ht.registerColorProvider(je,pt(re),ue)},registerFoldingRangeProvider(re,ue){return ht.registerFoldingRangeProvider(je,pt(re),ue)},registerSelectionRangeProvider(re,ue){return ht.registerSelectionRangeProvider(je,re,ue)},registerCallHierarchyProvider(re,ue){return ht.registerCallHierarchyProvider(je,re,ue)},registerTypeHierarchyProvider(re,ue){return ht.registerTypeHierarchyProvider(je,re,ue)},setLanguageConfiguration:(re,ue)=>ht.setLanguageConfiguration(je,re,ue),getTokenInformationAtPosition(re,ue){return(0,Ye.$pF)(je,"tokenInformation"),li.tokenAtPosition(re,ue)},registerInlayHintsProvider(re,ue){return ht.registerInlayHintsProvider(je,re,ue)},createLanguageStatusItem(re,ue){return li.createLanguageStatusItem(je,re,ue)},registerDocumentDropEditProvider(re,ue,Oe){return ht.registerDocumentOnDropEditProvider(je,re,ue,(0,Ye.$oF)(je,"dropMetadata")?Oe:void 0)}},gn={get activeTextEditor(){return Ot.getActiveTextEditor()},get visibleTextEditors(){return Ot.getVisibleTextEditors()},get activeTerminal(){return _e.activeTerminal},get terminals(){return _e.terminals},async showTextDocument(re,ue,Oe){const ot=await(g.URI.isUri(re)?Promise.resolve(rn.openTextDocument(re)):Promise.resolve(re));return Ot.showTextDocument(ot,ue,Oe)},createTextEditorDecorationType(re){return Ot.createTextEditorDecorationType(je,re)},onDidChangeActiveTextEditor(re,ue,Oe){return et(Ot.onDidChangeActiveTextEditor)(re,ue,Oe)},onDidChangeVisibleTextEditors(re,ue,Oe){return et(Ot.onDidChangeVisibleTextEditors)(re,ue,Oe)},onDidChangeTextEditorSelection(re,ue,Oe){return et(Ot.onDidChangeTextEditorSelection)(re,ue,Oe)},onDidChangeTextEditorOptions(re,ue,Oe){return et(Ot.onDidChangeTextEditorOptions)(re,ue,Oe)},onDidChangeTextEditorVisibleRanges(re,ue,Oe){return et(Ot.onDidChangeTextEditorVisibleRanges)(re,ue,Oe)},onDidChangeTextEditorViewColumn(re,ue,Oe){return et(Ot.onDidChangeTextEditorViewColumn)(re,ue,Oe)},onDidCloseTerminal(re,ue,Oe){return et(_e.onDidCloseTerminal)(re,ue,Oe)},onDidOpenTerminal(re,ue,Oe){return et(_e.onDidOpenTerminal)(re,ue,Oe)},onDidChangeActiveTerminal(re,ue,Oe){return et(_e.onDidChangeActiveTerminal)(re,ue,Oe)},onDidChangeTerminalDimensions(re,ue,Oe){return(0,Ye.$pF)(je,"terminalDimensions"),et(_e.onDidChangeTerminalDimensions)(re,ue,Oe)},onDidChangeTerminalState(re,ue,Oe){return et(_e.onDidChangeTerminalState)(re,ue,Oe)},onDidWriteTerminalData(re,ue,Oe){return(0,Ye.$pF)(je,"terminalDataWriteEvent"),et(_e.onDidWriteTerminalData)(re,ue,Oe)},onDidExecuteTerminalCommand(re,ue,Oe){return(0,Ye.$pF)(je,"terminalExecuteCommandEvent"),et(_e.onDidExecuteTerminalCommand)(re,ue,Oe)},get state(){return Me.getState(je)},onDidChangeWindowState(re,ue,Oe){return et(Me.onDidChangeWindowState)(re,ue,Oe)},showInformationMessage(re,...ue){return ki.showMessage(je,$.default.Info,re,ue[0],ue.slice(1))},showWarningMessage(re,...ue){return ki.showMessage(je,$.default.Warning,re,ue[0],ue.slice(1))},showErrorMessage(re,...ue){return ki.showMessage(je,$.default.Error,re,ue[0],ue.slice(1))},showQuickPick(re,ue,Oe){return si.showQuickPick(je,re,ue,Oe)},showWorkspaceFolderPick(re){return si.showWorkspaceFolderPick(re)},showInputBox(re,ue){return si.showInput(re,ue)},showOpenDialog(re){return Oi.showOpenDialog(je,re)},showSaveDialog(re){return Oi.showSaveDialog(re)},createStatusBarItem(re,ue,Oe){let ot,bt,Lt;return typeof re=="string"?(ot=re,bt=ue,Lt=Oe):(bt=re,Lt=ue),ei.createStatusBarEntry(je,ot,bt,Lt)},setStatusBarMessage(re,ue){return ei.setStatusBarMessage(re,ue)},withScmProgress(re){return Se.report("window.withScmProgress",je,"Use 'withProgress' instead."),vi.withProgress(je,{location:Ne.ProgressLocation.SourceControl},(ue,Oe)=>re({report(ot){}}))},withProgress(re,ue){return vi.withProgress(je,re,ue)},createOutputChannel(re,ue){return Dt.createOutputChannel(re,ue,je)},createWebviewPanel(re,ue,Oe,ot){return Fi.createWebviewPanel(je,re,ue,Oe,ot)},createWebviewTextEditorInset(re,ue,Oe,ot){return(0,Ye.$pF)(je,"editorInsets"),Pi.createWebviewEditorInset(re,ue,Oe,ot,je)},createTerminal(re,ue,Oe){return typeof re=="object"?"pty"in re?_e.createExtensionTerminal(re):_e.createTerminalFromOptions(re):_e.createTerminal(re,ue,Oe)},registerTerminalLinkProvider(re){return _e.registerLinkProvider(re)},registerTerminalProfileProvider(re,ue){return _e.registerProfileProvider(je,re,ue)},registerTerminalQuickFixProvider(re,ue){return(0,Ye.$pF)(je,"terminalQuickFixProvider"),_e.registerTerminalQuickFixProvider(re,je.identifier.value,ue)},registerTreeDataProvider(re,ue){return $i.registerTreeDataProvider(re,ue,je)},createTreeView(re,ue){return $i.createTreeView(re,ue,je)},registerWebviewPanelSerializer:(re,ue)=>Fi.registerWebviewPanelSerializer(je,re,ue),registerCustomEditorProvider:(re,ue,Oe={})=>cn.registerCustomEditorProvider(je,re,ue,Oe),registerFileDecorationProvider(re){return Ue.registerFileDecorationProvider(re,je)},registerUriHandler(re){return gi.registerUriHandler(je,re)},createQuickPick(){return si.createQuickPick(je)},createInputBox(){return si.createInputBox(je)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(re,ue,Oe){return et(Li.onDidChangeActiveColorTheme)(re,ue,Oe)},registerWebviewViewProvider(re,ue,Oe){return Mi.registerWebviewViewProvider(je,re,ue,Oe?.webviewOptions)},get activeNotebookEditor(){return It.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,ue,Oe){return et(It.onDidChangeActiveNotebookEditor)(re,ue,Oe)},get visibleNotebookEditors(){return It.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return et(It.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(re,ue,Oe){return et(mi.onDidChangeNotebookEditorSelection)(re,ue,Oe)},onDidChangeNotebookEditorVisibleRanges(re,ue,Oe){return et(mi.onDidChangeNotebookEditorVisibleRanges)(re,ue,Oe)},showNotebookDocument(re,ue){return It.showNotebookDocument(re,ue)},registerExternalUriOpener(re,ue,Oe){return(0,Ye.$pF)(je,"externalUriOpener"),un.registerExternalUriOpener(je.identifier,re,ue,Oe)},registerProfileContentHandler(re,ue){return(0,Ye.$pF)(je,"profileContentHandlers"),ln.registrProfileContentHandler(je,re,ue)},registerQuickDiffProvider(re,ue,Oe,ot){return(0,Ye.$pF)(je,"quickDiffProvider"),Ri.registerQuickDiffProvider(pt(re),ue,Oe,ot)},get tabGroups(){return G.tabGroups},registerShareProvider(re,ue){return(0,Ye.$pF)(je,"shareProvider"),Ji.registerShareProvider(pt(re),ue)}},rn={get rootPath(){return Se.report("workspace.rootPath",je,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(re){throw new T.$9("rootPath")},getWorkspaceFolder(re){return dt.getWorkspaceFolder(re)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(re){throw new T.$9("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(re){throw new T.$9("workspaceFile")},updateWorkspaceFolders:(re,ue,...Oe)=>dt.updateWorkspaceFolders(je,re,ue||0,...Oe),onDidChangeWorkspaceFolders:function(re,ue,Oe){return et(dt.onDidChangeWorkspace)(re,ue,Oe)},asRelativePath:(re,ue)=>dt.getRelativePath(re,ue),findFiles:(re,ue,Oe,ot)=>dt.findFiles(re,ue,Oe,je.identifier,ot),findTextInFiles:(re,ue,Oe,ot)=>{(0,Ye.$pF)(je,"findTextInFiles");let bt,Lt;return typeof ue=="object"?(bt=ue,Lt=Oe):(bt={},Lt=ue,ot=Oe),dt.findTextInFiles(re,bt||{},Lt,je.identifier,ot)},save:re=>dt.save(re),saveAs:re=>dt.saveAs(re),saveAll:re=>dt.saveAll(re),applyEdit(re,ue){return Xt.applyWorkspaceEdit(re,je,ue)},createFileSystemWatcher:(re,ue,Oe,ot)=>{let bt;return typeof ue=="boolean"?bt={ignoreCreateEvents:!!ue,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!ot,correlate:!1}:ue&&((0,Ye.$pF)(je,"createFileSystemWatcher"),bt={...ue,correlate:!0}),_t.createFileSystemWatcher(dt,je,re,bt)},get textDocuments(){return At.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw new T.$9("textDocuments")},openTextDocument(re){let ue;const Oe=re;if(typeof re=="string")ue=Promise.resolve(g.URI.file(re));else if(g.URI.isUri(re))ue=Promise.resolve(re);else if(!Oe||typeof Oe=="object")ue=At.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(ot=>At.ensureDocumentData(ot).then(bt=>bt.document))},onDidOpenTextDocument:(re,ue,Oe)=>et(At.onDidAddDocument)(re,ue,Oe),onDidCloseTextDocument:(re,ue,Oe)=>et(At.onDidRemoveDocument)(re,ue,Oe),onDidChangeTextDocument:(re,ue,Oe)=>et(At.onDidChangeDocument)(re,ue,Oe),onDidSaveTextDocument:(re,ue,Oe)=>et(At.onDidSaveDocument)(re,ue,Oe),onWillSaveTextDocument:(re,ue,Oe)=>et(Hi.getOnWillSaveTextDocumentEvent(je))(re,ue,Oe),get notebookDocuments(){return It.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,ue){let Oe;if(g.URI.isUri(re))Oe=re,await It.openNotebookDocument(re);else if(typeof re=="string")Oe=g.URI.revive(await It.createNotebookDocument({viewType:re,content:ue}));else throw new Error("Invalid arguments");return It.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(re,ue,Oe){return et(ri.onDidSaveNotebookDocument)(re,ue,Oe)},onDidChangeNotebookDocument(re,ue,Oe){return et(ri.onDidChangeNotebookDocument)(re,ue,Oe)},onWillSaveNotebookDocument(re,ue,Oe){return et(Ci.getOnWillSaveNotebookDocumentEvent(je))(re,ue,Oe)},get onDidOpenNotebookDocument(){return et(It.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return et(It.onDidCloseNotebookDocument)},registerNotebookSerializer(re,ue,Oe,ot){return It.registerNotebookSerializer(je,re,ue,Oe,(0,Ye.$oF)(je,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(re,ue,Oe)=>et(en.onDidChangeConfiguration)(re,ue,Oe),getConfiguration(re,ue){return ue=arguments.length===1?void 0:ue,en.getConfiguration(re,ue,je)},registerTextDocumentContentProvider(re,ue){return Di.registerTextDocumentContentProvider(re,ue)},registerTaskProvider:(re,ue)=>(Se.report("window.registerTaskProvider",je,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(je,re,ue)),registerFileSystemProvider(re,ue,Oe){return(0,F.$Pc)(Gi.registerFileSystemProvider(je,re,ue,Oe),Wt.addFileSystemProvider(re,ue,Oe))},get fs(){return Wt.value},registerFileSearchProvider:(re,ue)=>((0,Ye.$pF)(je,"fileSearchProvider"),Ut.registerFileSearchProvider(re,ue)),registerTextSearchProvider:(re,ue)=>((0,Ye.$pF)(je,"textSearchProvider"),Ut.registerTextSearchProvider(re,ue)),registerRemoteAuthorityResolver:(re,ue)=>((0,Ye.$pF)(je,"resolvers"),kt.registerRemoteAuthorityResolver(re,ue)),registerResourceLabelFormatter:re=>((0,Ye.$pF)(je,"resolvers"),Qi.$registerResourceLabelFormatter(re)),getRemoteExecServer:re=>((0,Ye.$pF)(je,"resolvers"),kt.getRemoteExecServer(re)),onDidCreateFiles:(re,ue,Oe)=>et(_t.onDidCreateFile)(re,ue,Oe),onDidDeleteFiles:(re,ue,Oe)=>et(_t.onDidDeleteFile)(re,ue,Oe),onDidRenameFiles:(re,ue,Oe)=>et(_t.onDidRenameFile)(re,ue,Oe),onWillCreateFiles:(re,ue,Oe)=>et(_t.getOnWillCreateFileEvent(je))(re,ue,Oe),onWillDeleteFiles:(re,ue,Oe)=>et(_t.getOnWillDeleteFileEvent(je))(re,ue,Oe),onWillRenameFiles:(re,ue,Oe)=>et(_t.getOnWillRenameFileEvent(je))(re,ue,Oe),openTunnel:re=>((0,Ye.$pF)(je,"tunnels"),Mt.openTunnel(je,re).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,Ye.$pF)(je,"tunnels"),Mt.getTunnels()},onDidChangeTunnels:(re,ue,Oe)=>((0,Ye.$pF)(je,"tunnels"),et(Mt.onDidChangeTunnels)(re,ue,Oe)),registerPortAttributesProvider:(re,ue)=>((0,Ye.$pF)(je,"portsAttributes"),Mt.registerPortsAttributesProvider(re,ue)),registerTunnelProvider:(re,ue)=>((0,Ye.$pF)(je,"tunnelFactory"),Mt.registerTunnelProvider(re,ue)),registerTimelineProvider:(re,ue)=>((0,Ye.$pF)(je,"timeline"),Zi.registerTimelineProvider(re,ue,je.identifier,Ve.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:re=>((0,Ye.$pF)(je,"workspaceTrust"),dt.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,ue,Oe)=>et(dt.onDidGrantWorkspaceTrust)(re,ue,Oe),registerEditSessionIdentityProvider:(re,ue)=>((0,Ye.$pF)(je,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(re,ue)),onWillCreateEditSessionIdentity:(re,ue,Oe)=>((0,Ye.$pF)(je,"editSessionIdentityProvider"),et(dt.getOnWillCreateEditSessionIdentityEvent(je))(re,ue,Oe)),registerCanonicalUriProvider:(re,ue)=>((0,Ye.$pF)(je,"canonicalUriProvider"),dt.registerCanonicalUriProvider(re,ue)),getCanonicalUri:(re,ue,Oe)=>((0,Ye.$pF)(je,"canonicalUriProvider"),dt.provideCanonicalUri(re,ue,Oe))},sn={get inputBox(){return Se.report("scm.inputBox",je,"Use 'SourceControl.inputBox' instead"),pi.getLastInputBox(je)},createSourceControl(re,ue,Oe){return pi.createSourceControl(je,re,ue,Oe)}},on={createCommentController(re,ue){return Ai.createCommentController(je,re,ue)}},Ui={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},get stackFrameFocus(){return mt.stackFrameFocus},onDidStartDebugSession(re,ue,Oe){return et(mt.onDidStartDebugSession)(re,ue,Oe)},onDidTerminateDebugSession(re,ue,Oe){return et(mt.onDidTerminateDebugSession)(re,ue,Oe)},onDidChangeActiveDebugSession(re,ue,Oe){return et(mt.onDidChangeActiveDebugSession)(re,ue,Oe)},onDidReceiveDebugSessionCustomEvent(re,ue,Oe){return et(mt.onDidReceiveDebugSessionCustomEvent)(re,ue,Oe)},onDidChangeBreakpoints(re,ue,Oe){return et(mt.onDidChangeBreakpoints)(re,ue,Oe)},onDidChangeStackFrameFocus(re,ue,Oe){return(0,Ye.$pF)(je,"debugFocus"),et(mt.onDidChangeStackFrameFocus)(re,ue,Oe)},registerDebugConfigurationProvider(re,ue,Oe){return mt.registerDebugConfigurationProvider(re,ue,Oe||jt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,ue){return mt.registerDebugAdapterDescriptorFactory(je,re,ue)},registerDebugAdapterTrackerFactory(re,ue){return mt.registerDebugAdapterTrackerFactory(re,ue)},startDebugging(re,ue,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?mt.startDebugging(re,ue,{parentSession:Oe}):mt.startDebugging(re,ue,Oe||{})},stopDebugging(re){return mt.stopDebugging(re)},addBreakpoints(re){return mt.addBreakpoints(re)},removeBreakpoints(re){return mt.removeBreakpoints(re)},asDebugSourceUri(re,ue){return mt.asDebugSourceUri(re,ue)}},Bi={registerTaskProvider:(re,ue)=>Et.registerTaskProvider(je,re,ue),fetchTasks:re=>Et.fetchTasks(re),executeTask:re=>Et.executeTask(je,re),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(re,ue,Oe)=>et(Et.onDidStartTask)(re,ue,Oe),onDidEndTask:(re,ue,Oe)=>et(Et.onDidEndTask)(re,ue,Oe),onDidStartTaskProcess:(re,ue,Oe)=>et(Et.onDidStartTaskProcess)(re,ue,Oe),onDidEndTaskProcess:(re,ue,Oe)=>et(Et.onDidEndTaskProcess)(re,ue,Oe)},Wi={createNotebookController(re,ue,Oe,ot,bt){return ci.createNotebookController(je,re,ue,Oe,ot,(0,Ye.$oF)(je,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(re,ue)=>It.registerNotebookCellStatusBarItemProvider(je,re,ue),createRendererMessaging(re){return Ii.createRendererMessaging(je,re)},createNotebookControllerDetectionTask(re){return(0,Ye.$pF)(je,"notebookKernelSource"),ci.createNotebookControllerDetectionTask(je,re)},registerKernelSourceActionProvider(re,ue){return(0,Ye.$pF)(je,"notebookKernelSource"),ci.registerKernelSourceActionProvider(je,re,ue)},onDidChangeNotebookCellExecutionState(re,ue,Oe){return(0,Ye.$pF)(je,"notebookCellExecutionState"),et(ci.onDidChangeNotebookCellExecutionState)(re,ue,Oe)}},Si={t(...re){if(typeof re[0]=="string"){const ue=re.shift(),Oe=!re||typeof re[0]!="object"?re:re[0];return wt.getMessage(je.identifier.value,{message:ue,args:Oe})}return wt.getMessage(je.identifier.value,re[0])},get bundle(){return wt.getBundle(je.identifier.value)},get uri(){return wt.getBundleUri(je.identifier.value)}},Vi={_version:1,registerInteractiveEditorSessionProvider(re,ue){return(0,Ye.$pF)(je,"interactive"),Xi.registerProvider(je,re,ue)},registerInteractiveSessionProvider(re,ue){return(0,Ye.$pF)(je,"interactive"),wi.registerChatProvider(je,re,ue)},sendInteractiveRequestToProvider(re,ue){return(0,Ye.$pF)(je,"interactive"),wi.sendInteractiveRequestToProvider(re,ue)},transferChatSession(re,ue){return(0,Ye.$pF)(je,"interactive"),wi.transferChatSession(re,ue)}},mn={getRelatedInformation(re,ue){return(0,Ye.$pF)(je,"aiRelatedInformation"),_i.getRelatedInformation(je,re,ue)},registerRelatedInformationProvider(re,ue){return(0,Ye.$pF)(je,"aiRelatedInformation"),_i.registerRelatedInformationProvider(je,re,ue)},registerEmbeddingVectorProvider(re,ue){return(0,Ye.$pF)(je,"aiRelatedInformation"),Ti.registerEmbeddingVectorProvider(je,re,ue)}},$n={registerChatResponseProvider(re,ue,Oe){return(0,Ye.$pF)(je,"chatProvider"),di.registerProvider(je.identifier,re,ue,Oe)},requestChatAccess(re){return(0,Ye.$pF)(je,"chatRequestAccess"),di.requestChatResponseProvider(je.identifier,re)},registerVariable(re,ue,Oe){return(0,Ye.$pF)(je,"chatVariables"),xi.registerVariableResolver(je,re,ue,Oe)},registerMappedEditsProvider(re,ue){return(0,Ye.$pF)(je,"mappedEditsProvider"),ht.registerMappedEditsProvider(je,re,ue)},createChatAgent(re,ue){return(0,Ye.$pF)(je,"chatAgents2"),Yi.createChatAgent(je,re,ue)}},pn={registerSpeechProvider(re,ue){return(0,Ye.$pF)(je,"speech"),yi.registerProvider(je.identifier,re,ue)}};return{version:$t.version,ai:mn,authentication:dn,commands:fn,comments:on,chat:$n,debug:Ui,env:ji,extensions:tn,interactive:Vi,l10n:Si,languages:nn,notebooks:Wi,scm:sn,speech:pn,tasks:Bi,tests:zi,window:gn,workspace:rn,Breakpoint:Ne.$RL,TerminalOutputAnchor:Ne.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Ne.ChatAgentResultFeedbackKind,ChatMessage:Ne.$JM,ChatMessageRole:Ne.ChatMessageRole,ChatVariableLevel:Ne.ChatVariableLevel,ChatAgentCompletionItem:Ne.$IM,CallHierarchyIncomingCall:Ne.$eL,CallHierarchyItem:Ne.$dL,CallHierarchyOutgoingCall:Ne.$fL,CancellationError:T.$5,CancellationTokenSource:E.$3d,CandidatePortSource:a.CandidatePortSource,CodeAction:Ne.$aL,CodeActionKind:Ne.$bL,CodeActionTriggerKind:Ne.CodeActionTriggerKind,CodeLens:Ne.$gL,Color:Ne.$tL,ColorInformation:Ne.$uL,ColorPresentation:Ne.$vL,ColorThemeKind:Ne.ColorThemeKind,CommentMode:Ne.CommentMode,CommentState:Ne.CommentState,CommentThreadCollapsibleState:Ne.CommentThreadCollapsibleState,CommentThreadState:Ne.CommentThreadState,CompletionItem:Ne.$nL,CompletionItemKind:Ne.CompletionItemKind,CompletionItemTag:Ne.CompletionItemTag,CompletionList:Ne.$oL,CompletionTriggerKind:Ne.CompletionTriggerKind,ConfigurationTarget:Ne.ConfigurationTarget,CustomExecution:Ne.$DL,DebugAdapterExecutable:Ne.$VL,DebugAdapterInlineImplementation:Ne.$YL,DebugAdapterNamedPipeServer:Ne.$XL,DebugAdapterServer:Ne.$WL,DebugConfigurationProviderTriggerKind:jt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ne.DebugConsoleMode,DecorationRangeBehavior:Ne.DecorationRangeBehavior,Diagnostic:Ne.$7K,DiagnosticRelatedInformation:Ne.$6K,DiagnosticSeverity:Ne.DiagnosticSeverity,DiagnosticTag:Ne.DiagnosticTag,Disposable:Ne.$SK,DocumentHighlight:Ne.$9K,DocumentHighlightKind:Ne.DocumentHighlightKind,MultiDocumentHighlight:Ne.$0K,DocumentLink:Ne.$sL,DocumentSymbol:Ne.$_K,EndOfLine:Ne.EndOfLine,EnvironmentVariableMutatorType:Ne.EnvironmentVariableMutatorType,EvaluatableExpression:Ne.$2L,InlineValueText:Ne.$3L,InlineValueVariableLookup:Ne.$4L,InlineValueEvaluatableExpression:Ne.$5L,InlineCompletionTriggerKind:Ne.InlineCompletionTriggerKind,EventEmitter:I.$Sd,ExtensionKind:Ne.ExtensionKind,ExtensionMode:Ne.ExtensionMode,ExternalUriOpenerPriority:Ne.ExternalUriOpenerPriority,FileChangeType:Ne.FileChangeType,FileDecoration:Ne.$cM,FileDecoration2:Ne.$cM,FileSystemError:Ne.$7L,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:Ne.$8L,FoldingRangeKind:Ne.FoldingRangeKind,FunctionBreakpoint:Ne.$TL,InlineCompletionItem:Ne.$pL,InlineCompletionList:Ne.$qL,Hover:Ne.$8K,IndentAction:D.IndentAction,Location:Ne.$5K,MarkdownString:Ne.$hL,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Ne.$iL,PortAutoForwardAction:Ne.PortAutoForwardAction,Position:Ne.$TK,ProcessExecution:Ne.$BL,ProgressLocation:Ne.ProgressLocation,QuickInputButtons:Ne.$bM,Range:Ne.$UK,RelativePattern:Ne.$PL,Selection:Ne.$VK,SelectionRange:Ne.$cL,SemanticTokens:Ne.$$L,SemanticTokensBuilder:Ne.$0L,SemanticTokensEdit:Ne.$_L,SemanticTokensEdits:Ne.$aM,SemanticTokensLegend:Ne.$9L,ShellExecution:Ne.$CL,ShellQuoting:Ne.ShellQuoting,SignatureHelp:Ne.$kL,SignatureHelpTriggerKind:Ne.SignatureHelpTriggerKind,SignatureInformation:Ne.$jL,SnippetString:Ne.$4K,SourceBreakpoint:Ne.$SL,StandardTokenType:Ne.StandardTokenType,StatusBarAlignment:Ne.StatusBarAlignment,SymbolInformation:Ne.$$K,SymbolKind:Ne.SymbolKind,SymbolTag:Ne.SymbolTag,Task:Ne.$EL,TaskGroup:Ne.$AL,TaskPanelKind:Ne.TaskPanelKind,TaskRevealKind:Ne.TaskRevealKind,TaskScope:Ne.TaskScope,TerminalLink:Ne.$wL,TerminalQuickFixTerminalCommand:Ne.$yL,TerminalQuickFixOpener:Ne.$xL,TerminalLocation:Ne.TerminalLocation,TerminalProfile:Ne.$zL,TerminalExitReason:Ne.TerminalExitReason,TextDocumentSaveReason:Ne.TextDocumentSaveReason,TextEdit:Ne.$ZK,SnippetTextEdit:Ne.$2K,TextEditorCursorStyle:w.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ne.TextEditorLineNumbersStyle,TextEditorRevealType:Ne.TextEditorRevealType,TextEditorSelectionChangeKind:Ne.TextEditorSelectionChangeKind,SyntaxTokenType:Ne.SyntaxTokenType,TextDocumentChangeReason:Ne.TextDocumentChangeReason,ThemeColor:Ne.$OL,ThemeIcon:Ne.$NL,TreeItem:Ne.$FL,TreeItemCheckboxState:Ne.TreeItemCheckboxState,TreeItemCollapsibleState:Ne.TreeItemCollapsibleState,TypeHierarchyItem:Ne.$xM,UIKind:Rt.UIKind,Uri:g.URI,ViewColumn:Ne.ViewColumn,WorkspaceEdit:Ne.$3K,DocumentDropEdit:Ne.$LL,DocumentPasteEdit:Ne.$ML,InlayHint:Ne.$mL,InlayHintLabelPart:Ne.$lL,InlayHintKind:Ne.InlayHintKind,RemoteAuthorityResolverError:Ne.$YK,ResolvedAuthority:Ne.$WK,ManagedResolvedAuthority:Ne.$XK,SourceControlInputBoxValidationType:Ne.SourceControlInputBoxValidationType,ExtensionRuntime:Ne.ExtensionRuntime,TimelineItem:Ne.$mM,NotebookRange:Ne.$eM,NotebookCellKind:Ne.NotebookCellKind,NotebookCellExecutionState:Ne.NotebookCellExecutionState,NotebookCellData:Ne.$fM,NotebookData:Ne.$gM,NotebookRendererScript:Ne.$kM,NotebookCellStatusBarAlignment:Ne.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ne.NotebookEditorRevealType,NotebookCellOutput:Ne.$iM,NotebookCellOutputItem:Ne.$hM,NotebookCellStatusBarItem:Ne.$jM,NotebookControllerAffinity:Ne.NotebookControllerAffinity,NotebookControllerAffinity2:Ne.NotebookControllerAffinity2,NotebookEdit:Ne.$1K,NotebookKernelSourceAction:Ne.$lM,NotebookVariablesRequestKind:Ne.NotebookVariablesRequestKind,PortAttributes:Ne.$oM,LinkedEditingRanges:Ne.$nM,TestResultState:Ne.TestResultState,TestRunRequest:Ne.$pM,TestMessage:Ne.$qM,TestMessage2:Ne.$qM,TestTag:Ne.$rM,TestRunProfileKind:Ne.TestRunProfileKind,TextSearchCompleteMessageType:Gt.TextSearchCompleteMessageType,DataTransfer:Ne.$KL,DataTransferItem:Ne.$GL,CoveredCount:Ne.$sM,FileCoverage:Ne.$tM,StatementCoverage:Ne.$uM,BranchCoverage:Ne.$vM,FunctionCoverage:Ne.$wM,WorkspaceTrustState:Ne.WorkspaceTrustState,LanguageStatusSeverity:Ne.LanguageStatusSeverity,QuickPickItemKind:Ne.QuickPickItemKind,InputBoxValidationSeverity:Ne.InputBoxValidationSeverity,TabInputText:Ne.$yM,TabInputTextDiff:Ne.$zM,TabInputTextMerge:Ne.$AM,TabInputCustom:Ne.$BM,TabInputNotebook:Ne.$DM,TabInputNotebookDiff:Ne.$EM,TabInputWebview:Ne.$CM,TabInputTerminal:Ne.$FM,TabInputInteractiveWindow:Ne.$GM,TabInputChat:Ne.$HM,TelemetryTrustedValue:t.$yo,LogLevel:r.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ne.InteractiveSessionVoteDirection,ChatAgentCopyKind:Ne.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Ne.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Ne.$ZL,ThreadFocus:Ne.$1L,RelatedInformationType:Ne.RelatedInformationType,SpeechToTextStatus:Ne.SpeechToTextStatus}}}e.$khc=Jt}),define(Ce[291],Re([1,0,70,112,36,110,37,32,61,64,115,117,118,85,87,81,111,63,43,84,59,62,256,14,116,82,83]),function(ge,e,E,T,I,F,R,$,g,w,A,D,l,p,b,r,o,t,n,a,c,h,i,s,u,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.$Lr)(d.$_fc,d.$$fc,1),(0,E.$Lr)(s.$lj,i.$lhc,1),(0,E.$Lr)(r.$kfc,r.$lfc,1),(0,E.$Lr)($.$eN,$.$dN,0),(0,E.$Lr)(R.$Ffc,R.$Dfc,0),(0,E.$Lr)(t.$Hfc,t.$Gfc,0),(0,E.$Lr)(D.$jgc,D.$ngc,0),(0,E.$Lr)(F.$pgc,F.$ogc,0),(0,E.$Lr)(g.$6M,g.$5M,0),(0,E.$Lr)(m.$agc,m.$bgc,0),(0,E.$Lr)(n.$hfc,n.$gfc,0),(0,E.$Lr)(T.$Vgc,T.$Ugc,1),(0,E.$Lr)(l.$Fgc,l.$Ggc,0),(0,E.$Lr)(p.$1fc,p.$Zfc,0),(0,E.$Lr)(A.$9gc,A.$8gc,0),(0,E.$Lr)(w.$4fc,w.$7fc,0),(0,E.$Lr)(b.$cyb,b.$dyb,0),(0,E.$Lr)(o.$jhc,o.$ihc,0),(0,E.$Lr)(I.$Cfc,I.$Bfc,0),(0,E.$Lr)(a.$9fc,a.$8fc,0),(0,E.$Lr)(c.$cN,c.$_M,0),(0,E.$Lr)(h.$Rfc,h.$Sfc,0),(0,E.$Lr)(u.$hgc,u.$igc,0)}),define(Ce[292],Re([1,0,290,38,2,287,7,13,275]),function(ge,e,E,T,I,F,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wjc=void 0;class w extends F.$ohc{j(){}getModule(p,b){for(const r of this.b){const o=r(p);if(o){p=o;break}}if(this.a.has(p))return this.a.get(p).load(p,b,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends T.$dgc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(g.$vjc);const p=this.h.invokeFunction(E.$khc);this.r=this.h.createInstance(w,p,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(p){return p.browser}async vb(p,b,r){b=b.with({path:D(b.path,".js")});const o=p?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const t=I.URI.revive(await this.C.$asBrowserUri(b)),n=await fetch(t.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),n.status!==200)throw new Error(n.statusText);const a=await n.text(),c=`${b.toString(!0)}#vscode-extension`,h=`${a}
//# sourceURL=${c}`;let i;try{i=new Function("module","exports","require",h)}catch(m){throw console.error(o?`Loading code for extension ${o} failed: ${m.message}`:`Loading code failed: ${m.message}`),console.error(`${b.toString(!0)}${typeof m.line=="number"?` line ${m.line}`:""}${typeof m.column=="number"?` column ${m.column}`:""}`),console.error(m),m}p&&await this.w.initializeLocalizedMessages(p);const s={},u={exports:s},d=m=>{const f=this.r.getModule(m,b);if(f===void 0)throw new Error(`Cannot load module '${m}'`);return f};try{return r.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),i(u,s,d),u.exports!==s?u.exports:s}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),r.codeLoadingStop()}}async $setRemoteEnvironment(p){}async zb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const b=Date.now()+p;for(;Date.now()<b&&!("__jsDebugIsReady"in globalThis);)await(0,$.$4g)(10)}}e.$wjc=A;function D(l,p){return l.endsWith(p)?l:l+p}}),define(Ce[293],Re([1,0,69,70,14,38,200,86,292]),function(ge,e,E,T,I,F,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,T.$Lr)(I.$kj,new E.$Zh(R.$nhc,[!0],!0)),(0,T.$Lr)(F.$egc,g.$wjc,0),(0,T.$Lr)($.$Ifc,$.$Jfc,0)}),define(Ce[298],Re([1,0,24,5,79,288,277,19,88,12,2,291,293]),function(ge,e,E,T,I,F,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(i){return/^(file|vscode-remote):/i.test(i)}const b=fetch.bind(self);function r(i){self.fetch=async function(s,u){return s instanceof Request||p(String(s))&&(s=(await i(A.URI.parse(String(s)))).toString(!0)),b(s,u)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,u,d,m,f){(async()=>(p(u.toString())&&(u=(await i(A.URI.parse(u.toString()))).toString(!0)),super.open(s,u,d??!0,m,f)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(s,u){if(/^file:/i.test(s.toString()))s=w.$lg.uriToBrowserUri(A.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const m=`(${function(v){function y(O){return typeof O=="string"||O instanceof URL?String(O).replace(/^file:\/\//i,"vscode-file://vscode-app"):O}const k=fetch.bind(self);self.fetch=function(O,K){return O instanceof Request?k(O,K):k(y(O),K)},self.XMLHttpRequest=class extends XMLHttpRequest{open(O,K,j,W,P){return super.open(O,y(K),j??!0,W,P)}};const N=importScripts.bind(self);self.importScripts=(...O)=>{N(...O.map(y))},N(v)}.toString()}('${s}'))`;u=u||{},u.name=u.name||$.$nc(s.toString());const f=new Blob([m],{type:"application/javascript"}),S=URL.createObjectURL(f);return new i(S,u)}}else self.Worker=class extends R.$xjc{constructor(i,s){super(l,i,{name:$.$nc(i.toString()),...s})}};const o=new class{constructor(){this.pid=void 0}exit(i){D()}};class t{constructor(){const s=new MessageChannel,u=new T.$Sd;let d=!1;l(s.port2,[s.port2]),s.port1.onmessage=m=>{const{data:f}=m;if(!(f instanceof ArrayBuffer)){console.warn("UNKNOWN data received",f);return}const S=E.$ge.wrap(new Uint8Array(f,0,f.byteLength));if((0,I.$rm)(S,2)){d=!0,a("received terminate message from renderer");return}u.fire(S)},this.protocol={onMessage:u.event,send:m=>{if(!d){const f=m.buffer.buffer.slice(m.buffer.byteOffset,m.buffer.byteOffset+m.buffer.byteLength);s.port1.postMessage(f,[f])}}}}}function n(i){return new Promise(s=>{const u=i.onMessage(d=>{u.dispose();const m=JSON.parse(d.toString());i.send((0,I.$qm)(0)),s({protocol:i,initData:m})});i.send((0,I.$qm)(1))})}let a=i=>D();function c(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function h(){g.mark("code/extHost/willConnectToRenderer");const i=new t;return{onmessage(s){c(s)&&n(i.protocol).then(u=>{g.mark("code/extHost/didWaitForInitData");const d=new F.$qhc(u.protocol,u.initData,o,null,s.data);r(m=>d.asBrowserUri(m)),a=m=>d.terminate(m)})}}}e.create=h})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a017b12b9caa3475675cfe6fda014fcf5af388c9/core/vs/workbench/api/worker/extensionHostWorker.js.map
